-- MySQL dump 10.13  Distrib 8.2.0, for Linux (x86_64)
--
-- Host: localhost    Database: metabase_bi
-- ------------------------------------------------------
-- Server version	8.2.0

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `action`
--

DROP TABLE IF EXISTS `action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `action` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the action was created',
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the action was updated',
  `type` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Type of action',
  `model_id` int NOT NULL,
  `name` varchar(254) COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The description of the action',
  `parameters` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The saved parameters for this action',
  `parameter_mappings` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The saved parameter mappings for this action',
  `visualization_settings` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The UI visualization_settings for this action',
  `public_uuid` char(36) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Unique UUID used to in publically-accessible links to this Action.',
  `made_public_by_id` int DEFAULT NULL COMMENT 'The ID of the User who first publically shared this Action.',
  `creator_id` int DEFAULT NULL COMMENT 'The user who created the action',
  `archived` bit(1) NOT NULL DEFAULT b'0',
  `entity_id` char(21) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `public_uuid` (`public_uuid`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_action_public_uuid` (`public_uuid`),
  KEY `fk_action_made_public_by_id` (`made_public_by_id`),
  KEY `idx_action_creator_id` (`creator_id`),
  KEY `fk_action_model_id` (`model_id`),
  CONSTRAINT `fk_action_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`),
  CONSTRAINT `fk_action_made_public_by_id` FOREIGN KEY (`made_public_by_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_action_model_id` FOREIGN KEY (`model_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='An action is something you can do, such as run a readwrite query';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `action`
--

LOCK TABLES `action` WRITE;
/*!40000 ALTER TABLE `action` DISABLE KEYS */;
/*!40000 ALTER TABLE `action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `api_key`
--

DROP TABLE IF EXISTS `api_key`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `api_key` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'The ID of the API Key itself',
  `user_id` int DEFAULT NULL,
  `key` varchar(254) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The hashed API key',
  `key_prefix` varchar(7) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The first 7 characters of the unhashed key',
  `creator_id` int DEFAULT NULL,
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp when the key was created',
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp when the key was last updated',
  `name` varchar(254) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The user-defined name of the API key.',
  `updated_by_id` int NOT NULL COMMENT 'The ID of the user that last updated this API key',
  `scope` varchar(64) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'The scope of the API key, if applicable',
  PRIMARY KEY (`id`),
  UNIQUE KEY `key_prefix` (`key_prefix`),
  UNIQUE KEY `name` (`name`),
  KEY `idx_api_key_created_by` (`creator_id`),
  KEY `idx_api_key_user_id` (`user_id`),
  KEY `idx_api_key_updated_by_id` (`updated_by_id`),
  CONSTRAINT `fk_api_key_created_by_user_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`),
  CONSTRAINT `fk_api_key_updated_by_id_user_id` FOREIGN KEY (`updated_by_id`) REFERENCES `core_user` (`id`),
  CONSTRAINT `fk_api_key_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='An API Key';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `api_key`
--

LOCK TABLES `api_key` WRITE;
/*!40000 ALTER TABLE `api_key` DISABLE KEYS */;
/*!40000 ALTER TABLE `api_key` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `application_permissions_revision`
--

DROP TABLE IF EXISTS `application_permissions_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `application_permissions_revision` (
  `id` int NOT NULL AUTO_INCREMENT,
  `before` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Serialized JSON of the permission graph before the changes.',
  `after` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Serialized JSON of the changes in permission graph.',
  `user_id` int NOT NULL COMMENT 'The ID of the admin who made this set of changes.',
  `created_at` timestamp(6) NOT NULL,
  `remark` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'Optional remarks explaining why these changes were made.',
  PRIMARY KEY (`id`),
  KEY `fk_general_permissions_revision_user_id` (`user_id`),
  CONSTRAINT `fk_general_permissions_revision_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to keep track of changes made to general permissions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `application_permissions_revision`
--

LOCK TABLES `application_permissions_revision` WRITE;
/*!40000 ALTER TABLE `application_permissions_revision` DISABLE KEYS */;
/*!40000 ALTER TABLE `application_permissions_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `audit_log`
--

DROP TABLE IF EXISTS `audit_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `audit_log` (
  `id` int NOT NULL AUTO_INCREMENT,
  `topic` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The topic of a given audit event',
  `timestamp` timestamp(6) NOT NULL COMMENT 'The time an event was recorded',
  `end_timestamp` timestamp(6) NULL DEFAULT NULL COMMENT 'The time an event ended, if applicable',
  `user_id` int DEFAULT NULL COMMENT 'The user who performed an action or triggered an event',
  `model` varchar(32) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'The name of the model this event applies to (e.g. Card, Dashboard), if applicable',
  `model_id` int DEFAULT NULL COMMENT 'The ID of the model this event applies to, if applicable',
  `details` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'A JSON map with metadata about the event',
  PRIMARY KEY (`id`),
  KEY `idx_audit_log_entity_qualified_id` (((case when (`model` = _utf8mb4'Dataset') then concat(_utf8mb4'card_',`model_id`) when (`model_id` is null) then NULL else concat(lower(`model`),_utf8mb4'_',`model_id`) end)))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to store application events for auditing use cases';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `audit_log`
--

LOCK TABLES `audit_log` WRITE;
/*!40000 ALTER TABLE `audit_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `audit_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bookmark_ordering`
--

DROP TABLE IF EXISTS `bookmark_ordering`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `bookmark_ordering` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'ID of the User who ordered bookmarks',
  `type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'type of the Bookmark',
  `item_id` int NOT NULL COMMENT 'id of the item being bookmarked (Card, Collection, Dashboard, ...) no FK, so may no longer exist',
  `ordering` int NOT NULL COMMENT 'order of bookmark for user',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_bookmark_user_id_type_item_id` (`user_id`,`type`,`item_id`),
  UNIQUE KEY `unique_bookmark_user_id_ordering` (`user_id`,`ordering`),
  KEY `idx_bookmark_ordering_user_id` (`user_id`),
  CONSTRAINT `fk_bookmark_ordering_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table holding ordering information for various bookmark tables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bookmark_ordering`
--

LOCK TABLES `bookmark_ordering` WRITE;
/*!40000 ALTER TABLE `bookmark_ordering` DISABLE KEYS */;
/*!40000 ALTER TABLE `bookmark_ordering` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_config`
--

DROP TABLE IF EXISTS `cache_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cache_config` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'Unique ID',
  `model` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Name of an entity model',
  `model_id` int NOT NULL COMMENT 'ID of the said entity',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'Timestamp when the config was inserted',
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'Timestamp when the config was updated',
  `strategy` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'caching strategy name',
  `config` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'caching strategy configuration',
  `state` longtext COLLATE utf8mb4_unicode_ci COMMENT 'state for strategies needing to keep some data between runs',
  `invalidated_at` timestamp(6) NULL DEFAULT NULL COMMENT 'indicates when a cache was invalidated last time for schedule-based strategies',
  `next_run_at` timestamp(6) NULL DEFAULT NULL COMMENT 'keeps next time to run for schedule-based strategies',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_cache_config_unique_model` (`model`,`model_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Cache Configuration';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_config`
--

LOCK TABLES `cache_config` WRITE;
/*!40000 ALTER TABLE `cache_config` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `card_bookmark`
--

DROP TABLE IF EXISTS `card_bookmark`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `card_bookmark` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'ID of the User who bookmarked the Card',
  `card_id` int NOT NULL COMMENT 'ID of the Card bookmarked by the user',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the bookmark was created',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_card_bookmark_user_id_card_id` (`user_id`,`card_id`),
  KEY `idx_card_bookmark_user_id` (`user_id`),
  KEY `idx_card_bookmark_card_id` (`card_id`),
  CONSTRAINT `fk_card_bookmark_dashboard_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_card_bookmark_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table holding bookmarks on cards';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `card_bookmark`
--

LOCK TABLES `card_bookmark` WRITE;
/*!40000 ALTER TABLE `card_bookmark` DISABLE KEYS */;
/*!40000 ALTER TABLE `card_bookmark` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `card_label`
--

DROP TABLE IF EXISTS `card_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `card_label` (
  `id` int NOT NULL AUTO_INCREMENT,
  `card_id` int NOT NULL,
  `label_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_card_label_card_id_label_id` (`card_id`,`label_id`),
  KEY `idx_card_label_card_id` (`card_id`),
  KEY `idx_card_label_label_id` (`label_id`),
  CONSTRAINT `fk_card_label_ref_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_card_label_ref_label_id` FOREIGN KEY (`label_id`) REFERENCES `label` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `card_label`
--

LOCK TABLES `card_label` WRITE;
/*!40000 ALTER TABLE `card_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `card_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cloud_migration`
--

DROP TABLE IF EXISTS `cloud_migration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cloud_migration` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'Unique ID',
  `external_id` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Matching ID in Cloud for this migration',
  `upload_url` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'URL where the backup will be uploaded to',
  `state` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'init' COMMENT 'Current state of the migration: init, setup, dump, upload, done, error, cancelled',
  `progress` int NOT NULL DEFAULT '0' COMMENT 'Number between 0 to 100 representing progress as a percentage',
  `created_at` timestamp(6) NOT NULL COMMENT 'Timestamp when the config was inserted',
  `updated_at` timestamp(6) NOT NULL COMMENT 'Timestamp when the config was updated',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Migrate to cloud directly from Metabase';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cloud_migration`
--

LOCK TABLES `cloud_migration` WRITE;
/*!40000 ALTER TABLE `cloud_migration` DISABLE KEYS */;
/*!40000 ALTER TABLE `cloud_migration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `collection`
--

DROP TABLE IF EXISTS `collection`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `collection` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `archived` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Whether this Collection has been archived and should be hidden from users.',
  `location` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '/' COMMENT 'Directory-structure path of ancestor Collections. e.g. "/1/2/" means our Parent is Collection 2, and their parent is Collection 1.',
  `personal_owner_id` int DEFAULT NULL COMMENT 'If set, this Collection is a personal Collection, for exclusive use of the User with this ID.',
  `slug` varchar(510) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `namespace` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'The namespace (hierachy) this Collection belongs to. NULL means the Collection is in the default namespace.',
  `authority_level` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Nullable column to incidate collection''s authority level. Initially values are "official" and nil.',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'Timestamp of when this Collection was created.',
  `type` varchar(256) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'This is used to differentiate instance-analytics collections from all other collections.',
  `is_sample` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Is the collection part of the sample content?',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_collection_personal_owner_id` (`personal_owner_id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_collection_location` (`location`),
  KEY `idx_collection_personal_owner_id` (`personal_owner_id`),
  CONSTRAINT `fk_collection_personal_owner_id` FOREIGN KEY (`personal_owner_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Collections are an optional way to organize Cards and handle permissions for them.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `collection`
--

LOCK TABLES `collection` WRITE;
/*!40000 ALTER TABLE `collection` DISABLE KEYS */;
INSERT INTO `collection` VALUES (1,'Examples',NULL,_binary '\0','/',NULL,'examples',NULL,NULL,'53YGAg4EE6MC76nxx-f5f','2024-06-19 14:13:29.000000',NULL,_binary ''),(2,'erwinlee的个人收藏集',NULL,_binary '\0','/',13371339,'erwinlee%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F%E9%9B%86',NULL,NULL,'AgXYyKLpWkgK9H4ac-XRS','2024-06-19 14:18:21.604528',NULL,_binary '\0'),(3,'铁粉空间',NULL,_binary '\0','/',NULL,'%E9%93%81%E7%B2%89%E7%A9%BA%E9%97%B4',NULL,NULL,'Ryxr-6cxGNa9tYmTGTxfq','2024-06-19 14:21:34.078117',NULL,_binary '\0'),(4,'dingkai的个人收藏',NULL,_binary '\0','/',13371340,'dingkai%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F',NULL,NULL,'AaUldk6qL9BnAbpPccXTn','2024-06-19 14:24:55.339208',NULL,_binary '\0'),(5,'yezian的个人收藏',NULL,_binary '\0','/',13371341,'yezian%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F',NULL,NULL,'16GwZcFFFeLnmTbmU-BXS','2024-06-19 14:35:14.235919',NULL,_binary '\0'),(6,'robin的个人收藏',NULL,_binary '\0','/',13371342,'robin%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F',NULL,NULL,'wKLE7lZnZ4PgHU5NwOVEX','2024-06-19 14:36:03.644200',NULL,_binary '\0'),(7,'yubingchang的个人收藏',NULL,_binary '\0','/',13371343,'yubingchang%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F',NULL,NULL,'KCznSMRQwfhO036KYy96r','2024-06-19 14:36:25.908737',NULL,_binary '\0'),(8,'zhangzihao的个人收藏',NULL,_binary '\0','/',13371344,'zhangzihao%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F',NULL,NULL,'H8NxROQxeZilSvYGHuKQ7','2024-06-19 14:36:47.383215',NULL,_binary '\0'),(9,'zihao的个人收藏',NULL,_binary '\0','/',13371345,'zihao%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F',NULL,NULL,'gbFjHs6U0FxBwabC0qbf3','2024-06-19 14:37:07.846056',NULL,_binary '\0');
/*!40000 ALTER TABLE `collection` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `collection_bookmark`
--

DROP TABLE IF EXISTS `collection_bookmark`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `collection_bookmark` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'ID of the User who bookmarked the Collection',
  `collection_id` int NOT NULL COMMENT 'ID of the Card bookmarked by the user',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the bookmark was created',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_collection_bookmark_user_id_collection_id` (`user_id`,`collection_id`),
  KEY `idx_collection_bookmark_user_id` (`user_id`),
  KEY `idx_collection_bookmark_collection_id` (`collection_id`),
  CONSTRAINT `fk_collection_bookmark_collection_id` FOREIGN KEY (`collection_id`) REFERENCES `collection` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_collection_bookmark_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table holding bookmarks on collections';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `collection_bookmark`
--

LOCK TABLES `collection_bookmark` WRITE;
/*!40000 ALTER TABLE `collection_bookmark` DISABLE KEYS */;
/*!40000 ALTER TABLE `collection_bookmark` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `collection_permission_graph_revision`
--

DROP TABLE IF EXISTS `collection_permission_graph_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `collection_permission_graph_revision` (
  `id` int NOT NULL AUTO_INCREMENT,
  `before` longtext COLLATE utf8mb4_unicode_ci,
  `after` longtext COLLATE utf8mb4_unicode_ci,
  `user_id` int NOT NULL COMMENT 'The ID of the admin who made this set of changes.',
  `created_at` timestamp(6) NOT NULL,
  `remark` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_collection_revision_user_id` (`user_id`),
  CONSTRAINT `fk_collection_revision_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to keep track of changes made to collections.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `collection_permission_graph_revision`
--

LOCK TABLES `collection_permission_graph_revision` WRITE;
/*!40000 ALTER TABLE `collection_permission_graph_revision` DISABLE KEYS */;
/*!40000 ALTER TABLE `collection_permission_graph_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `connection_impersonations`
--

DROP TABLE IF EXISTS `connection_impersonations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `connection_impersonations` (
  `id` int NOT NULL AUTO_INCREMENT,
  `db_id` int NOT NULL COMMENT 'ID of the database this connection impersonation policy affects',
  `group_id` int NOT NULL COMMENT 'ID of the permissions group this connection impersonation policy affects',
  `attribute` longtext COLLATE utf8mb4_unicode_ci COMMENT 'User attribute associated with the database role to use for this connection impersonation policy',
  PRIMARY KEY (`id`),
  UNIQUE KEY `conn_impersonation_unique_group_id_db_id` (`group_id`,`db_id`),
  KEY `idx_conn_impersonations_db_id` (`db_id`),
  KEY `idx_conn_impersonations_group_id` (`group_id`),
  CONSTRAINT `fk_conn_impersonation_db_id` FOREIGN KEY (`db_id`) REFERENCES `metabase_database` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_conn_impersonation_group_id` FOREIGN KEY (`group_id`) REFERENCES `permissions_group` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table for holding connection impersonation policies';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `connection_impersonations`
--

LOCK TABLES `connection_impersonations` WRITE;
/*!40000 ALTER TABLE `connection_impersonations` DISABLE KEYS */;
/*!40000 ALTER TABLE `connection_impersonations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `core_session`
--

DROP TABLE IF EXISTS `core_session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `core_session` (
  `id` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `user_id` int NOT NULL,
  `created_at` timestamp(6) NOT NULL,
  `anti_csrf_token` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_session_ref_user_id` (`user_id`),
  CONSTRAINT `fk_session_ref_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `core_session`
--

LOCK TABLES `core_session` WRITE;
/*!40000 ALTER TABLE `core_session` DISABLE KEYS */;
INSERT INTO `core_session` VALUES ('00ede3ee-1dff-4ada-80dd-544f305b6744',13371345,'2024-07-18 07:03:07.259166',NULL),('0af4688c-6bdb-4ae2-8081-332e14788053',13371340,'2024-07-18 12:31:22.713052',NULL),('0c0e543a-4f09-4a90-82b8-326b87db1a21',13371341,'2024-06-26 11:20:42.055910',NULL),('0e4d3f2c-5b93-47d3-8006-5084733580a5',13371339,'2024-07-18 10:40:35.833532',NULL),('0ecb3c1b-6ad9-4040-9263-b0c03b3e147a',13371341,'2024-07-04 13:25:46.752658',NULL),('140fea25-5132-4915-ae60-f20fb6aaf95d',13371341,'2024-07-04 13:31:54.321898',NULL),('2448dfd6-75ee-4316-a6e3-7c938a3ee0aa',13371345,'2024-07-03 16:16:18.511223',NULL),('265f9ba4-ba19-4096-99f6-8f66fc62add7',13371341,'2024-07-06 02:02:30.663720',NULL),('2e1e9ff1-bd10-405f-93ce-ff3bb1d1e9b3',13371339,'2024-07-03 16:04:31.248986',NULL),('30bb99d5-3e65-4a24-8a10-a308178b8cc3',13371341,'2024-06-21 08:48:30.135111',NULL),('316e0c82-6db4-4171-a7ae-07687cb8c539',13371339,'2024-07-21 14:45:13.199726',NULL),('475bdd75-1719-471b-9d73-803ebf419d62',13371341,'2024-07-01 16:14:57.924260',NULL),('488b19d3-e00b-4a5b-ac40-51bfb51bba8b',13371339,'2024-06-19 14:34:26.918230',NULL),('4c08b321-559c-4c98-8ecb-57fec02a3851',13371341,'2024-07-20 05:47:40.292965',NULL),('4c6ce095-03a6-444e-855e-2e86851d661e',13371341,'2024-06-20 16:08:05.940091',NULL),('52efa5fc-b128-4b47-b69b-54da96c20fac',13371339,'2024-06-19 14:27:56.609994',NULL),('55d6f65b-d1a9-461f-afb5-d0856b737c99',13371341,'2024-07-05 11:10:10.492170',NULL),('70725e84-b642-47bc-8e23-8e33049a916d',13371340,'2024-07-04 10:41:59.073833',NULL),('75578e38-f1be-4ac3-88a9-39b57d910160',13371340,'2024-07-20 14:39:04.873758',NULL),('77190d62-10f9-4cae-8978-2de3481a7539',13371340,'2024-06-19 14:41:18.645233',NULL),('810c0a61-09e1-47ca-bed3-3b323dab9835',13371341,'2024-07-19 15:58:53.790427',NULL),('82ab7a60-5631-4261-92e4-3b44b8846ff6',13371339,'2024-07-04 01:55:18.312074',NULL),('a446500a-960a-4367-bbf1-c7c28272c168',13371341,'2024-07-15 17:31:32.120611',NULL),('a50e62e2-c5a5-4b14-b6a3-69a60b52adc2',13371345,'2024-06-19 16:04:16.358439',NULL),('a7396bb8-fa22-4ba8-8271-46eb631b0b7a',13371345,'2024-07-03 17:29:17.583157',NULL),('b4b120f8-0be2-425f-8066-fe32027668ed',13371341,'2024-07-21 12:37:10.924897',NULL),('bb547754-7de4-4179-beb3-38393a15ccd4',13371345,'2024-06-19 14:49:07.714189',NULL),('c3c227ab-a2bf-479d-8d9d-28a9a16b5c58',13371341,'2024-06-24 04:46:21.923947',NULL),('c95e5628-1978-4a0b-93f9-1b195a8730cf',13371340,'2024-06-20 16:35:53.594158',NULL),('c9f26520-30ea-425e-97ad-82255cc07d55',13371341,'2024-06-24 01:55:57.607072',NULL),('dcd44d03-b44e-4d73-9b34-5173fdd6b5f9',13371341,'2024-06-20 16:07:32.021293',NULL),('e1246f2b-f130-4526-b355-b9a8ac939c23',13371339,'2024-07-17 16:04:34.958053',NULL),('e6fbf343-bf3d-40bb-95d5-00e021af92be',13371340,'2024-07-04 07:32:12.552250',NULL),('ecc882e1-8840-46c6-af30-5fd2bb79672a',13371340,'2024-06-19 16:01:43.458980',NULL),('ef6a1ab6-ed44-46bd-9997-9ba33f137dac',13371345,'2024-07-17 16:45:16.811355',NULL),('f0439738-430c-466d-ac8f-87b4feae4a5b',13371341,'2024-06-24 13:29:32.050179',NULL),('f0b493dd-0a07-4f0c-be0a-f075e85e5cc1',13371340,'2024-07-20 14:44:53.737638',NULL),('fe6afc65-0861-4e77-bea1-072aeff5c050',13371340,'2024-06-19 16:02:06.765358',NULL);
/*!40000 ALTER TABLE `core_session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `core_user`
--

DROP TABLE IF EXISTS `core_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `core_user` (
  `id` int NOT NULL AUTO_INCREMENT,
  `email` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `first_name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `last_name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `password` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `password_salt` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `date_joined` timestamp(6) NOT NULL,
  `last_login` timestamp(6) NULL DEFAULT NULL,
  `is_superuser` bit(1) NOT NULL DEFAULT b'0',
  `is_active` bit(1) NOT NULL DEFAULT b'1',
  `reset_token` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `reset_triggered` bigint DEFAULT NULL,
  `is_qbnewb` bit(1) NOT NULL DEFAULT b'1',
  `login_attributes` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `updated_at` timestamp(6) NULL DEFAULT NULL,
  `sso_source` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'String to indicate the SSO backend the user is from',
  `locale` varchar(5) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Preferred ISO locale (language/country) code, e.g "en" or "en-US", for this User. Overrides site default.',
  `is_datasetnewb` bit(1) NOT NULL DEFAULT b'1',
  `settings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'Serialized JSON containing User-local Settings for this User',
  `type` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'personal' COMMENT 'The type of user',
  `entity_id` char(21) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'NanoID tag for each user',
  PRIMARY KEY (`id`),
  UNIQUE KEY `email` (`email`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_user_full_name` ((concat(`first_name`,_utf8mb4' ',`last_name`)))
) ENGINE=InnoDB AUTO_INCREMENT=13371346 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `core_user`
--

LOCK TABLES `core_user` WRITE;
/*!40000 ALTER TABLE `core_user` DISABLE KEYS */;
INSERT INTO `core_user` VALUES (13371338,'internal@metabase.com','Metabase','Internal','$2a$10$UKVSkyy/1dVHNsi2LHlnxuCGff3unwZjEL./ahVRtwgB/6a3wUUTS','8ae8875c-d15c-4e9d-acfb-ea4fd3500121','2024-06-19 14:13:27.000000',NULL,_binary '\0',_binary '\0',NULL,NULL,_binary '',NULL,NULL,NULL,NULL,_binary '',NULL,'internal',NULL),(13371339,'lwl0608@foxmail.com','erwin','lee','$2a$10$mTrFfR2bg/ug.UgPwVYY7.hDGspac0Qx2OIH5EQFFzl3/lnLW3NUW','d273c735-ea81-4615-aa87-6c6c9f9cdd45','2024-06-19 14:17:10.000000','2024-07-18 10:40:35.000000',_binary '',_binary '',NULL,NULL,_binary '\0',NULL,'2024-07-18 10:40:35.844846',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\",\"last-used-native-database-id\":\"2\",\"dismissed-custom-dashboard-toast\":\"true\",\"expand-browse-in-nav\":\"true\"}','personal','nBs7d-OUyGP0SjieSedJr'),(13371340,'dingkai@wishpal.cn','dingkai',NULL,'$2a$10$65FhY2L6hockGdbxh8.kbOFrfSoJDfXT2FCYqzTjn1xmZ35eAjgny','3e97641c-1c80-453f-a8d9-7c0d6b7b252f','2024-06-19 14:24:55.000000','2024-07-20 14:44:53.000000',_binary '\0',_binary '',NULL,NULL,_binary '',NULL,'2024-07-21 06:53:08.483696',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\",\"dismissed-custom-dashboard-toast\":\"true\",\"expand-browse-in-nav\":\"false\"}','personal','omZt7SYzRnCqKpeKT_7A9'),(13371341,'yezian@wishpal.cn','yezian',NULL,'$2a$10$nqSgrsqB1g3mnllbCwBvjetifknEOeUN9JgG0B1GZkgntMf1HMLeG','f3bdc024-8285-4dfe-b8bb-2055367e5f4c','2024-06-19 14:35:14.000000','2024-07-21 12:37:10.000000',_binary '\0',_binary '',NULL,NULL,_binary '\0',NULL,'2024-07-21 12:37:10.936772',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\",\"dismissed-custom-dashboard-toast\":\"true\"}','personal','nXCuYI_YhRUeIe8dRnD4O'),(13371342,'robin@wishpal.cn','robin',NULL,'$2a$10$JNB9pQ8nFAC0Z.3uoyP7p.8GOQwFDlw64tysk5L956psa5e03VcaS','c2f2b1d6-bf3a-48a2-ae59-5130d0dfe22a','2024-06-19 14:36:03.000000',NULL,_binary '\0',_binary '','$2a$10$gbp1TPKHDbn1LveCODST8ej4G1AnBU20vxSjS4xx86ZRBWEUvX5Gy',1718807763440,_binary '',NULL,'2024-06-19 14:36:03.525291',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\"}','personal','kzG6xtKlVuW_ZHACpb8Dd'),(13371343,'yubingchang@wishpal.cn','yubingchang',NULL,'$2a$10$Eaa/q/TYbGLf1hGF4wkx3ObHfXfctlK9BAOTQKWA6PIzqMwrvZWDu','cb030eac-dcd5-4697-ab7a-b50dc3a49c05','2024-06-19 14:36:25.000000',NULL,_binary '\0',_binary '','$2a$10$5hHOr44MrBliegh5zGnCtOHE3uyUiGaB7WIJ1ap6LyHRUuwmFTAC.',1718807785652,_binary '',NULL,'2024-06-19 14:36:25.736454',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\"}','personal','mSpViq315NLwh0BTCRq9k'),(13371344,'zhangzihao@wishpal.cn','zhangzihao',NULL,'$2a$10$8smoi8uNak3QUSc9bagoQOhUvxiCBQk9eygw9OOH0orImrBav//l.','db8dec0a-265b-433c-8ff1-1f27059b7788','2024-06-19 14:36:47.000000',NULL,_binary '\0',_binary '','$2a$10$G1jF8utAjOAszBHwPbiU0eXckd57uMnbhLiG0RNKOTDfErBVx9/7C',1718807807194,_binary '',NULL,'2024-06-19 14:36:47.280930',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\"}','personal','2P0hxK41HnE_pUgooDCkQ'),(13371345,'zihao@wishpal.cn','zihao',NULL,'$2a$10$5sraZAfMOYt4GRZ6anIwdu5ULe.wboDYcs/FgtNtVhQzPCTzB/njC','d86aa969-4bb7-407a-b449-cf07d3fe30b1','2024-06-19 14:37:07.000000','2024-07-18 07:03:07.000000',_binary '\0',_binary '','$2a$10$80z0R0.eaLKQdiP52u/cGO/.xoX0He8b.W5OtfjLuJ6.sEkE0x9J.',1718807827677,_binary '\0',NULL,'2024-07-18 14:12:20.902517',NULL,NULL,_binary '','{\"last-acknowledged-version\":\"v0.50.5\",\"dismissed-custom-dashboard-toast\":\"true\",\"expand-browse-in-nav\":\"true\"}','personal','-97efSgl32d3f8vdi4eBR');
/*!40000 ALTER TABLE `core_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dashboard_bookmark`
--

DROP TABLE IF EXISTS `dashboard_bookmark`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `dashboard_bookmark` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'ID of the User who bookmarked the Dashboard',
  `dashboard_id` int NOT NULL COMMENT 'ID of the Dashboard bookmarked by the user',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the bookmark was created',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_dashboard_bookmark_user_id_dashboard_id` (`user_id`,`dashboard_id`),
  KEY `idx_dashboard_bookmark_user_id` (`user_id`),
  KEY `idx_dashboard_bookmark_dashboard_id` (`dashboard_id`),
  CONSTRAINT `fk_dashboard_bookmark_dashboard_id` FOREIGN KEY (`dashboard_id`) REFERENCES `report_dashboard` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dashboard_bookmark_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table holding bookmarks on dashboards';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dashboard_bookmark`
--

LOCK TABLES `dashboard_bookmark` WRITE;
/*!40000 ALTER TABLE `dashboard_bookmark` DISABLE KEYS */;
/*!40000 ALTER TABLE `dashboard_bookmark` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dashboard_favorite`
--

DROP TABLE IF EXISTS `dashboard_favorite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `dashboard_favorite` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'ID of the User who favorited the Dashboard.',
  `dashboard_id` int NOT NULL COMMENT 'ID of the Dashboard favorited by the User.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_dashboard_favorite_user_id_dashboard_id` (`user_id`,`dashboard_id`),
  KEY `idx_dashboard_favorite_user_id` (`user_id`),
  KEY `idx_dashboard_favorite_dashboard_id` (`dashboard_id`),
  CONSTRAINT `fk_dashboard_favorite_dashboard_id` FOREIGN KEY (`dashboard_id`) REFERENCES `report_dashboard` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dashboard_favorite_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Presence of a row here indicates a given User has favorited a given Dashboard.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dashboard_favorite`
--

LOCK TABLES `dashboard_favorite` WRITE;
/*!40000 ALTER TABLE `dashboard_favorite` DISABLE KEYS */;
/*!40000 ALTER TABLE `dashboard_favorite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dashboard_tab`
--

DROP TABLE IF EXISTS `dashboard_tab`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `dashboard_tab` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dashboard_id` int NOT NULL COMMENT 'The dashboard that a tab is on',
  `name` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Displayed name of the tab',
  `position` int NOT NULL COMMENT 'Position of the tab with respect to others tabs in dashboard',
  `entity_id` char(21) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp at which the tab was created',
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp at which the tab was last updated',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `fk_dashboard_tab_ref_dashboard_id` (`dashboard_id`),
  CONSTRAINT `fk_dashboard_tab_ref_dashboard_id` FOREIGN KEY (`dashboard_id`) REFERENCES `report_dashboard` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Join table connecting dashboard to dashboardcards';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dashboard_tab`
--

LOCK TABLES `dashboard_tab` WRITE;
/*!40000 ALTER TABLE `dashboard_tab` DISABLE KEYS */;
INSERT INTO `dashboard_tab` VALUES (1,1,'Overview',0,'PS7GW5IfD3ov0haogAPLu','2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000'),(2,1,'Portfolio performance',1,'z5IymDhXzRY2kF79LxQIN','2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000'),(3,1,'Demographics',2,'TKyJ0onLUPOuZgVfwZfU1','2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000');
/*!40000 ALTER TABLE `dashboard_tab` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dashboardcard_series`
--

DROP TABLE IF EXISTS `dashboardcard_series`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `dashboardcard_series` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dashboardcard_id` int NOT NULL,
  `card_id` int NOT NULL,
  `position` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_dashboardcard_series_dashboardcard_id` (`dashboardcard_id`),
  KEY `idx_dashboardcard_series_card_id` (`card_id`),
  CONSTRAINT `fk_dashboardcard_series_ref_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dashboardcard_series_ref_dashboardcard_id` FOREIGN KEY (`dashboardcard_id`) REFERENCES `report_dashboardcard` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dashboardcard_series`
--

LOCK TABLES `dashboardcard_series` WRITE;
/*!40000 ALTER TABLE `dashboardcard_series` DISABLE KEYS */;
/*!40000 ALTER TABLE `dashboardcard_series` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_permissions`
--

DROP TABLE IF EXISTS `data_permissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `data_permissions` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'The ID of the permission',
  `group_id` int NOT NULL COMMENT 'The ID of the associated permission group',
  `perm_type` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The type of the permission (e.g. "data", "collection", "download"...)',
  `db_id` int NOT NULL COMMENT 'A database ID, for DB and table-level permissions',
  `schema_name` varchar(254) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'A schema name, for table-level permissions',
  `table_id` int DEFAULT NULL COMMENT 'A table ID',
  `perm_value` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The value this permission is set to.',
  PRIMARY KEY (`id`),
  KEY `idx_data_permissions_table_id` (`table_id`),
  KEY `idx_data_permissions_db_id` (`db_id`),
  KEY `idx_data_permissions_group_id` (`group_id`),
  CONSTRAINT `fk_data_permissions_ref_db_id` FOREIGN KEY (`db_id`) REFERENCES `metabase_database` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_data_permissions_ref_permissions_group` FOREIGN KEY (`group_id`) REFERENCES `permissions_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_data_permissions_ref_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='A table to store database and table permissions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `data_permissions`
--

LOCK TABLES `data_permissions` WRITE;
/*!40000 ALTER TABLE `data_permissions` DISABLE KEYS */;
INSERT INTO `data_permissions` VALUES (1,1,'perms/view-data',1,NULL,NULL,'unrestricted'),(2,1,'perms/create-queries',1,NULL,NULL,'query-builder-and-native'),(3,1,'perms/download-results',1,NULL,NULL,'one-million-rows'),(4,1,'perms/manage-table-metadata',1,NULL,NULL,'no'),(5,1,'perms/manage-database',1,NULL,NULL,'no'),(7,1,'perms/create-queries',2,NULL,NULL,'query-builder-and-native'),(8,1,'perms/view-data',2,NULL,NULL,'unrestricted'),(9,1,'perms/download-results',2,NULL,NULL,'one-million-rows'),(10,1,'perms/manage-table-metadata',2,NULL,NULL,'no'),(11,1,'perms/manage-database',2,NULL,NULL,'no');
/*!40000 ALTER TABLE `data_permissions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `databasechangelog`
--

DROP TABLE IF EXISTS `databasechangelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `databasechangelog` (
  `ID` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `AUTHOR` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `FILENAME` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `DATEEXECUTED` datetime NOT NULL,
  `ORDEREXECUTED` int NOT NULL,
  `EXECTYPE` varchar(10) COLLATE utf8mb4_unicode_ci NOT NULL,
  `MD5SUM` varchar(35) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `DESCRIPTION` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `COMMENTS` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `TAG` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `LIQUIBASE` varchar(20) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `CONTEXTS` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `LABELS` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `DEPLOYMENT_ID` varchar(10) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  UNIQUE KEY `idx_databasechangelog_id_author_filename` (`ID`,`AUTHOR`,`FILENAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `databasechangelog`
--

LOCK TABLES `databasechangelog` WRITE;
/*!40000 ALTER TABLE `databasechangelog` DISABLE KEYS */;
INSERT INTO `databasechangelog` VALUES ('v00.00-000','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:01',1,'EXECUTED','9:cecb4c73745e92033c738dbf3d6e747e','sqlFile path=initialization/metabase_postgres.sql; sqlFile path=initialization/metabase_mysql.sql; sqlFile path=initialization/metabase_h2.sql','Initialze metabase',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-001','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',2,'EXECUTED','9:24324f06a65a9bb339c735f02cbfb47f','createTable tableName=action','Added 0.44.0 - writeback',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-002','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',3,'EXECUTED','9:d2c9f50f5a29947a07e4808957d63ab6','createTable tableName=query_action','Added 0.44.0 - writeback',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-003','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',4,'EXECUTED','9:dafaaf7c9f0efbf92670ea93c001f7a1','addPrimaryKey constraintName=pk_query_action, tableName=query_action','Added 0.44.0 - writeback',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-011','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',5,'EXECUTED','9:c539f152aa1c2287c5b602c7a395f9e8','addColumn tableName=report_card','Added 0.44.0 - writeback',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-012','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',6,'EXECUTED','9:4b66ab5561933821db3a68d21ce43b6b','createTable tableName=http_action','Added 0.44.0 - writeback',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-013','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',7,'EXECUTED','9:54c5d6a9659b7ae62e8c42f60f9620d2','addPrimaryKey constraintName=pk_http_action, tableName=http_action','Added 0.44.0 - writeback',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-022','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',8,'EXECUTED','9:4f00f51af294ccdd99b6029b7a023643','createTable tableName=app','Added 0.45.0 - add app container',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-023','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',9,'EXECUTED','9:082d296233ee6dbbf2871b9d93c3a6a4','addForeignKeyConstraint baseTableName=app, constraintName=fk_app_ref_dashboard_id, referencedTableName=report_dashboard','Added 0.45.0 - add app container',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-025','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:02',10,'EXECUTED','9:2214b0d71acc8a8cf90781a2aca98664','addColumn tableName=report_dashboard','Added 0.45.0 - mark app pages',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-026','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',11,'EXECUTED','9:9f2ce2d2d79d0dce365ddf3464d1f648','addColumn tableName=report_dashboardcard','Added 0.45.0 - apps add action_id to report_dashboardcard',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-027','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',12,'EXECUTED','9:73718f7b7c3fb4ef30f71dc6e6170528','addForeignKeyConstraint baseTableName=report_dashboardcard, constraintName=fk_report_dashboardcard_ref_action_id, referencedTableName=action','Added 0.45.0 - apps add fk for action_id to report_dashboardcard',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-028','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',13,'EXECUTED','9:883315d70f3fc10b07858aa0e48ed9da','renameColumn newColumnName=size_x, oldColumnName=sizeX, tableName=report_dashboardcard','Added 0.45.0 -- rename DashboardCard sizeX to size_x. See https://github.com/metabase/metabase/issues/16344',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-029','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',14,'EXECUTED','9:fe3b8aca811ef5b541f922a83c7ded8c','renameColumn newColumnName=size_y, oldColumnName=sizeY, tableName=report_dashboardcard','Added 0.45.0 -- rename DashboardCard size_y to size_y. See https://github.com/metabase/metabase/issues/16344',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-030','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',15,'EXECUTED','9:63da8f2f82baf396ad30f3fd451c501d','addDefaultValue columnName=size_x, tableName=report_dashboardcard','Added 0.45.0 -- add default value to DashboardCard size_x -- this was previously done by Toucan',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-031','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',16,'EXECUTED','9:3628c1c692bec0f7258ea983b18340b5','addDefaultValue columnName=size_y, tableName=report_dashboardcard','Added 0.45.0 -- add default value to DashboardCard size_y -- this was previously done by Toucan',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-033','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',17,'EXECUTED','9:b93dab321e4a1fcaeb74d12b52867fd4','sql','Added 0.45.0 -- add default value for DashboardCard created_at (MySQL/MariaDB)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-035','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',18,'EXECUTED','9:207984e21c44681a6135592cab3d0f3f','sql','Added 0.45.0 -- add default value for DashboardCard updated_at (MySQL/MariaDB)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-036','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',19,'EXECUTED','9:1c5db47da78b69f2540542243b529e65','createTable tableName=model_action','Added 0.45.0 - add model action table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-037','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',20,'EXECUTED','9:6600702fb0cc9dcd8628fca8df9c0b39','addUniqueConstraint constraintName=unique_model_action_card_id_slug, tableName=model_action','Added 0.45.0 - model action',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-039','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:03',21,'EXECUTED','9:7b331f47a0260218275c58fa21fdcc60','sql','Added 0.45.0 -- add default value for Database created_at (MySQL/MariaDB)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-041','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',22,'EXECUTED','9:84d479472b81809b8067f72b28934954','sql','Added 0.45.0 -- add default value for Database updated_at (MySQL/MariaDB)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-042','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',23,'EXECUTED','9:f600f2e052bf44938d081165c8d87364','sql','Added 0.45.0 -- add default value for Database with NULL details',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-043','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',24,'EXECUTED','9:daa8b1249027fa4c9ea07f1acb8ee889','addNotNullConstraint columnName=details, tableName=metabase_database','Added 0.45.0 -- make Database details NOT NULL',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-044','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',25,'EXECUTED','9:39c664afe6e6c6598576c7575931b106','createTable tableName=app_permission_graph_revision','Added 0.45.0 -- create app permission graph revision table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-048','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',26,'EXECUTED','9:122ebd5e3f3b30b61b66bfad0e9ab1b0','addColumn tableName=collection','Added 0.45.0 -- add created_at to Collection',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-049','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',27,'EXECUTED','9:50ef9cbb0f9958bd4e8a1e6364fd6038','sql; sql; sql','Added 0.45.0 -- set Collection.created_at to User.date_joined for Personal Collections',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-050','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',28,'EXECUTED','9:e5af01b22e40f1ce3dc0cbbddf131f58','sql; sql; sql','Added 0.45.0 -- seed Collection.created_at with value of oldest item for non-Personal Collections',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-051','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',29,'EXECUTED','9:caa34704f55850f5f8f15ef5eb7a758e','modifyDataType columnName=after, tableName=collection_permission_graph_revision','Added 0.45.0 - modify type of collection_permission_graph_revision.after from text to longtext on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-052','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',30,'EXECUTED','9:c397d1eaf5e2cbfb90319014b9ebdfad','modifyDataType columnName=before, tableName=collection_permission_graph_revision','Added 0.45.0 - modify type of collection_permission_graph_revision.before from text to longtext on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-053','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',31,'EXECUTED','9:44242218dd4f217ef03dde5ac8b1ea7e','modifyDataType columnName=remark, tableName=collection_permission_graph_revision','Added 0.45.0 - modify type of collection_permission_graph_revision.remark from text to longtext on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-054','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',32,'EXECUTED','9:3356706563854978e668538752e58242','modifyDataType columnName=after, tableName=permissions_revision','Added 0.45.0 - modify type of permissions_revision.after from text to longtext on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-055','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',33,'EXECUTED','9:1b764e3ac4c6a41f1a83ea19a2464782','modifyDataType columnName=before, tableName=permissions_revision','Added 0.45.0 - modify type of permissions_revision.before from text to longtext on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-056','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',34,'EXECUTED','9:db0f77fe782f392241d0fe911b8890a2','modifyDataType columnName=remark, tableName=permissions_revision','Added 0.45.0 - modify type of permissions_revision.remark from text to longtext on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v45.00-057','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',35,'EXECUTED','9:d1125daee3e40f7a316c59c6b7a0fb1b','modifyDataType columnName=value, tableName=secret','Added 0.45.0 - modify type of secret.value from blob to longblob on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-000','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:04',36,'EXECUTED','9:1fac9d1658592106303e67a591966565','createTable tableName=implicit_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-001','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',37,'EXECUTED','9:9a3a543cd836c34d8131b6c929061425','addColumn tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-002','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',38,'EXECUTED','9:a352e46d75236605148308fc7e95cfe6','addColumn tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-003','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',39,'EXECUTED','9:5fcf2126624707dc3b84c4673ca8064e','addColumn tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-004','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',40,'EXECUTED','9:2845510b38cd14b0fb864be9996216a0','addColumn tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-005','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',41,'EXECUTED','9:7bfb368ddb611bb4e34a9e91b6273a57','addColumn tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-006','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',42,'EXECUTED','9:343162b0798092bdd0c4b3a896bfae0c','addColumn tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-007','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',43,'EXECUTED','9:604733020cb8d94b0b21728393b9227a','addForeignKeyConstraint baseTableName=action, constraintName=fk_action_model_id, referencedTableName=report_card','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-008','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',44,'EXECUTED','9:24adc5d36405f95e479157afa6ac7090','addColumn tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-009','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',45,'EXECUTED','9:fb691dd38898c7e55813a6fb1ba2883f','addColumn tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-010','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',46,'EXECUTED','9:17661d9a15cea0e046aa22bbe05f8ca9','addForeignKeyConstraint baseTableName=query_action, constraintName=fk_query_action_database_id, referencedTableName=metabase_database','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-011','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',47,'EXECUTED','9:305af61cd201d6c9366c9e9d7d0a3551','sql; sql; sql','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-012','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',48,'EXECUTED','9:f5e43052660cb6fd61dca7385a41690f','dropNotNullConstraint columnName=card_id, tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-013','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',49,'EXECUTED','9:12bf37b0e6732f2f09122f76cb8b59b5','sql','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-014','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',50,'EXECUTED','9:f5856fab23b69dbc669c354d5cb14d36','dropForeignKeyConstraint baseTableName=query_action, constraintName=fk_query_action_ref_card_id','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-015','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',51,'EXECUTED','9:1ef231990b57b1f8496070f5f63f4579','dropColumn columnName=card_id, tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-016','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',52,'EXECUTED','9:cf5ae825070bb05fd046b0a22f299403','sql','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-017','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',53,'EXECUTED','9:7428779ccdce61097d0fe5e761e05b18','dropColumn columnName=name, tableName=http_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-018','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:05',54,'EXECUTED','9:1ae9ab13080fc2dd4df6ccdeb28baf72','dropColumn columnName=description, tableName=http_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-019','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',55,'EXECUTED','9:ffa18e1fb9a06d0a673a1d6aab1edfbc','dropColumn columnName=is_write, tableName=report_card','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-020','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',56,'EXECUTED','9:f96413cb1260923de7be41fd0a665543','addNotNullConstraint columnName=database_id, tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-021','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',57,'EXECUTED','9:4096f22cba83bce61efb299867d96d85','addNotNullConstraint columnName=dataset_query, tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-022','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',58,'EXECUTED','9:4096f22cba83bce61efb299867d96d85','addNotNullConstraint columnName=dataset_query, tableName=query_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-023','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',59,'EXECUTED','9:072dea52b8b04cbb2829741c8523d768','addNotNullConstraint columnName=model_id, tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-024','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',60,'EXECUTED','9:92798789cb9756596896f74e7055988d','addNotNullConstraint columnName=name, tableName=action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-025','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',61,'EXECUTED','9:cedeeebf30271f749b77f79609b197ba','dropTable tableName=model_action','Added 0.46.0 - Unify action representation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-026','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',62,'EXECUTED','9:0b495131821e8ac0a2bc562f688ccca7','addColumn tableName=metabase_database','Added 0.46.0 -- add field for tracking DBMS versions',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-027','snoe','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',63,'EXECUTED','9:74894629391fee2263064bfca9e3afa9','addColumn tableName=metabase_fieldvalues','Added 0.46.0 -- add last_used_at to FieldValues',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-028','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',64,'EXECUTED','9:b512cb7ec893db1f41c5f05ca6801b56','createTable tableName=parameter_card','Added 0.46.0 -- Join table connecting cards to dashboards/cards\'s parameters that need custom filter values from the card',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-029','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',65,'EXECUTED','9:c95d07d656ec9c2d06e9d83ab14e5170','dropUniqueConstraint constraintName=unique_dimension_field_id_name, tableName=dimension','Make Dimension <=> Field a 1t1 relationship. Drop unique constraint on field_id + name. (1/3)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-030','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',66,'EXECUTED','9:3342b8ad5e8160325705f4df619c1416','sql','Make Dimension <=> Field a 1t1 relationship. Delete duplicate entries. (2/3)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-031','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',67,'EXECUTED','9:5822fde920ae9c048d75e951674c6570','addUniqueConstraint constraintName=unique_dimension_field_id, tableName=dimension','Make Dimension <=> Field a 1t1 relationship. Add unique constraint on field_id. (3/3)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-032','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',68,'EXECUTED','9:2e882eb92ce78edf23d417dcbc7c4f03','addUniqueConstraint constraintName=unique_parameterized_object_card_parameter, tableName=parameter_card','Added 0.46.0 -- Unique parameter_card',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-033','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',69,'EXECUTED','9:2ca24580b18e8a0736cc1c0b463d43a6','createIndex indexName=idx_parameter_card_parameterized_object_id, tableName=parameter_card','Added 0.46.0 -- parameter_card index on connected object',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-034','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',70,'EXECUTED','9:654f10ff8db9163f27f87fc7da686912','createIndex indexName=idx_parameter_card_card_id, tableName=parameter_card','Added 0.46.0 -- parameter_card index on connected card',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-035','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',71,'EXECUTED','9:54d48bc5d1b60faa10ba000c3409c973','addForeignKeyConstraint baseTableName=parameter_card, constraintName=fk_parameter_card_ref_card_id, referencedTableName=report_card','Added 0.46.0 - parameter_card.card_id foreign key',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-036','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',72,'EXECUTED','9:5e155b0c1edc895bddf0e5de96def85e','dropTable tableName=app_permission_graph_revision','App containers are removed in 0.46.0',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-037','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',73,'EXECUTED','9:ba61742e04377180572fb011d5ad3263','dropColumn columnName=is_app_page, tableName=report_dashboard','App pages are removed in 0.46.0',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-038','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:06',74,'EXECUTED','9:a45d7cfa18714cd1d536bd17b927e3ac','dropTable tableName=app','App containers are removed in 0.46.0',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-039','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',75,'EXECUTED','9:a850f5255ad1f2abb52d4a7c93fa68a0','addColumn tableName=parameter_card','Added 0.46.0 - add entity_id to parameter_card',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-040','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',76,'EXECUTED','9:400fe00b6e522509e4949a71cc12e196','addDefaultValue columnName=size_x, tableName=report_dashboardcard','Added 0.46.0 -- Bump default dashcard size to 4x4',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-041','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',77,'EXECUTED','9:0f7635baf2acb131464865f2a94a17ed','addDefaultValue columnName=size_y, tableName=report_dashboardcard','Added 0.46.0 -- Bump default dashcard size to 4x4',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-042','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',78,'EXECUTED','9:6b99f953adbc8c3f536c7d729ef780a2','createIndex indexName=idx_query_execution_executor_id, tableName=query_execution','Added 0.46.0 -- index query_execution.executor_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-043','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',79,'EXECUTED','9:6fd04070a9c19ac34c15a5cbe27def47','createIndex indexName=idx_query_execution_context, tableName=query_execution','Added 0.46.0 -- index query_execution.context',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-045','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',80,'EXECUTED','9:1f61e64d7ce15c315ff530ef8a2dc7f3','addColumn tableName=action','Added 0.46.0 -- add public_uuid to action.',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-051','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',81,'EXECUTED','9:7f54a26b4edf1aa4bc86b95f9c316dea','dropDefaultValue columnName=row, tableName=report_dashboardcard','Added 0.46.0 -- drop defaults for dashcard\'s position and size',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-052','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',82,'EXECUTED','9:4fc7e45d19ab28e91bd27325d23afd83','dropDefaultValue columnName=col, tableName=report_dashboardcard','Added 0.46.0 -- drop defaults for dashcard\'s position and size',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-053','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',83,'EXECUTED','9:2d2836a1c76d1c5db400219364aa070e','dropDefaultValue columnName=size_x, tableName=report_dashboardcard','Added 0.46.0 -- drop defaults for dashcard\'s position and size',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-054','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',84,'EXECUTED','9:60b7a066e6ca1826efcb8b562b33f331','dropDefaultValue columnName=size_y, tableName=report_dashboardcard','Added 0.46.0 -- drop defaults for dashcard\'s position and size',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-055','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',85,'EXECUTED','9:5b583b1b5eac915914f40a27163263b3','addColumn tableName=action','Added 0.46.0 -- add made_public_by_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-056','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',86,'EXECUTED','9:9e37acc40f5685ec3992dff91bbfa618','createIndex indexName=idx_action_public_uuid, tableName=action','Added 0.46.0 -- add public_uuid and made_public_by_id to action. public_uuid is indexed',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-057','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',87,'EXECUTED','9:86b2d39951f748b94abd2e1c7b68144a','modifyDataType columnName=parameter_id, tableName=parameter_card','Added 0.46.0 -- parameter_card.parameter_id long enough to hold a uuid',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-058','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',88,'EXECUTED','9:7458ddbf194a385219df05900d78185d','addForeignKeyConstraint baseTableName=action, constraintName=fk_action_made_public_by_id, referencedTableName=core_user','Added 0.46.0 -- add FK constraint for action.made_public_by_id with core_user.id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-059','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',89,'EXECUTED','9:55a077fb646639308046b80c3f64267e','addColumn tableName=action','Added 0.46.0 -- add actions.creator_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-060','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',90,'EXECUTED','9:a0726ea2ef7c354af8b60a8ab37d24bd','createIndex indexName=idx_action_creator_id, tableName=action','Added 0.46.0 -- action.creator_id index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-061','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',91,'EXECUTED','9:7497cc10ea1fdad211179b36d53bde6a','addForeignKeyConstraint baseTableName=action, constraintName=fk_action_creator_id, referencedTableName=core_user','Added 0.46.0 -- action.creator_id index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-062','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:07',92,'EXECUTED','9:35cc67731bc19abd498bcdbb0aeb688e','addColumn tableName=action','Added 0.46.0 -- add actions.archived',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-064','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',93,'EXECUTED','9:a73357bb088af23043336f048172a1f3','renameTable newTableName=sandboxes, oldTableName=group_table_access_policy','Added 0.46.0 -- rename `group_table_access_policy` to `sandboxes`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-065','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',94,'EXECUTED','9:b5b5d61c3e6f7daa528acce1a52b6f75','addColumn tableName=sandboxes','Added 0.46.0 -- add `permission_id` to `sandboxes`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-070','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',95,'EXECUTED','9:e52174e49aa14e61eb922ba200cfc002','addColumn tableName=action','Added 0.46.0 - add entity_id column to action',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-074','metamben','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',96,'EXECUTED','9:29c6090a889f466de44d68a70207e10d','modifyDataType columnName=updated_at, tableName=report_card','Added 0.46.0 -- increase precision of updated_at of report_card',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-079','john-metabase','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',97,'EXECUTED','9:e5ce98dd7ac26fb102db98625e10dfab','sql','Added 0.46.0 -- migrates Databases using deprecated and removed presto driver to presto-jdbc',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-080','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',98,'EXECUTED','9:742aaa27012538f89770095551808dbc','customChange','Migrate data permission paths from v1 to v2 (splitting them into separate data and query permissions)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-084','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',99,'EXECUTED','9:ec26e53892d1293ef822005b0e2d5d0d','dropForeignKeyConstraint baseTableName=action, constraintName=fk_action_model_id','Added 0.46.0 - CASCADE delete for action.model_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-085','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',100,'EXECUTED','9:013d55806a3c819a2e94ff2d5cb71df2','addForeignKeyConstraint baseTableName=action, constraintName=fk_action_model_id, referencedTableName=report_card','Added 0.46.0 - CASCADE delete for action.model_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-086','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',101,'EXECUTED','9:3029f7b7b204834ce65fc573378b3425','customChange','Added 0.46.0 - Delete the abandonment email task',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-088','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',102,'EXECUTED','9:c38b799746664b436dc8c63f2c6214c6','sql','Added 0.46.5 -- backfill `permission_id` values in `sandboxes`. This is a fixed verison of v46.00-066 which has been removed, since it had a bug that blocked a customer from upgrading.',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-089','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:08',103,'EXECUTED','9:7a7761ef80cae24914abb65143fb0503','sql','Added 0.46.5 -- remove orphaned entries in `sandboxes`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v46.00-090','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',104,'EXECUTED','9:d17eaed2e43c5589332682c53e4a6458','addForeignKeyConstraint baseTableName=sandboxes, constraintName=fk_sandboxes_ref_permissions, referencedTableName=permissions','Add foreign key constraint on sandboxes.permission_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-001','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',105,'EXECUTED','9:b655eb44da8863f3021bd71dc14e69b3','sql','Added 0.47.0 -- set base-type to type/JSON for JSON database-types for postgres and mysql',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-002','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',106,'EXECUTED','9:1983e3e2e005932513c2146770aa7f37','addColumn tableName=metabase_field','Added 0.47.0 - Add json_unfolding column to metabase_field',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-003','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',107,'EXECUTED','9:a3cdc062588a6c5c4459d48dc1b76519','sql','Added 0.47.0 - Populate metabase_field.json_unfolding based on base_type',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-004','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',108,'EXECUTED','9:9457f62a9c6533da79c4881ca21d727f','addColumn tableName=metabase_field','Added 0.47.0 - Add auto_incremented to metabase_field',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-005','winlost','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',109,'EXECUTED','9:afc9309217305117e3b9e88018c5437e','addColumn tableName=report_dashboard','Added 0.47.0 - Add auto_apply_filters to dashboard',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-006','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',110,'EXECUTED','9:268558b59e388f5d130befc2cc48a506','createTable tableName=dashboard_tab','Added 0.47.0 - Add dashboard_tab table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-007','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',111,'EXECUTED','9:7e6c0250df2957d89875cd0d14d271ee','addColumn tableName=report_dashboardcard','Added 0.47.0 -- add report_dashboardcard.dashboard_tab_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-008','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',112,'EXECUTED','9:606ece18373d1e534db0714add1c41e8','addForeignKeyConstraint baseTableName=report_dashboardcard, constraintName=fk_report_dashboardcard_ref_dashboard_tab_id, referencedTableName=dashboard_tab','Added 0.47.0 -- add report_dashboardcard.dashboard_tab_id fk constraint',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-009','qwef','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',113,'EXECUTED','9:738a13b99f62269ff366f57c09652ebc','sql','Added 0.47.0 - Replace user google_auth and ldap_auth columns with sso_source values',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-010','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',114,'EXECUTED','9:5d9a509a79dedadff743042b6f82ddbe','modifyDataType columnName=name, tableName=metabase_table','Added 0.47.0 - Make metabase_table.name long enough for H2 names',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-011','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',115,'EXECUTED','9:7a6a06886b1428bf54d5105d1d4fcf0a','modifyDataType columnName=display_name, tableName=metabase_table','Added 0.47.0 - Make metabase_table.display_name long enough for H2 names',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-012','qwef','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',116,'EXECUTED','9:42ca291fec3fb0a7bdd74dd17d03339a','dropColumn columnName=google_auth, tableName=core_user','Added 0.47.0 - Replace user google_auth and ldap_auth columns with sso_source values',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-013','qwef','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',117,'EXECUTED','9:fcc22e7f3fd2f6e52739a8b9778f8e50','sql','Added 0.47.0 - Replace user google_auth and ldap_auth columns with sso_source values',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-014','qwef','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',118,'EXECUTED','9:e8309c65ac1f122f944e64d702409377','dropColumn columnName=ldap_auth, tableName=core_user','Added 0.47.0 - Replace user google_auth and ldap_auth columns with sso_source values',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-015','escherize','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',119,'EXECUTED','9:a05fe66edd2512f17a9fc7f9ff122669','addColumn tableName=metabase_database','added 0.47.0 - Add is_audit to metabase_database',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-016','calherres','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',120,'EXECUTED','9:dbd88ce575f7976114e5b8c7e0382a5a','customChange','Added 0.47.0 - Migrate the report_card.visualization_settings.column_settings field refs from legacy format',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-018','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:09',121,'EXECUTED','9:3019a2f90c2a6d8c060afc7b3e5d35a5','createTable tableName=model_index','Indexed Entities information table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-019','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',122,'EXECUTED','9:c94ce89ec2a7f334bc2357a31427c561','createTable tableName=model_index_value','Indexed Entities values table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-020','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',123,'EXECUTED','9:96991ffa2c754f2f70d61928c7574e31','addUniqueConstraint constraintName=unique_model_index_value_model_index_id_model_pk, tableName=model_index_value','Add unique constraint on index_id and pk',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-023','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',124,'EXECUTED','9:ab9a7a030405fc844b36f10d77fef039','createIndex indexName=idx_model_index_model_id, tableName=model_index','Added 0.47.0 -- model_index index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-024','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',125,'EXECUTED','9:ab4cd02348503fcaa7cedd49d11d217d','addForeignKeyConstraint baseTableName=model_index, constraintName=fk_model_index_model_id, referencedTableName=report_card','Added 0.47.0 -- model_index foriegn key to report_card',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-025','dpsutton','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',126,'EXECUTED','9:e002aab419bb327f68a09b604eb24fa5','addForeignKeyConstraint baseTableName=model_index_value, constraintName=fk_model_index_value_model_id, referencedTableName=model_index','Added 0.47.0 -- model_index_value foriegn key to model_index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-026','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',127,'EXECUTED','9:81eed341cad343495635a2071229e322','createTable tableName=connection_impersonations','Added 0.47.0 - New table for connection impersonation policies',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-027','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',128,'EXECUTED','9:a40730a20a1f9ae345d15f9c2bfa443e','customChange','Added 0.47.0 - Migrate field_ref in report_card.result_metadata from legacy format',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-028','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',129,'EXECUTED','9:66ec973062109ac00d89c8bb1a867d1e','customChange','Added 0.47.0 - Add join-alias to the report_card.visualization_settings.column_settings field refs',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-029','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',130,'EXECUTED','9:4e63a84adeeacdbe8ecf771e3f6cf65e','customChange','Added 0.47.0 - Stack cards vertically for dashboard with tabs on downgrade',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-030','escherize','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',131,'EXECUTED','9:e6d3c56859e8c41a5c5f6b7ebcc489d7','addColumn tableName=collection','Added 0.47.0 - Type column for collections for instance-analytics',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-031','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',132,'EXECUTED','9:6c0047955d2fc52cd25e4e4aabdc7143','sql; sql','Added 0.47.0 - migrate dashboard grid size from 18 to 24',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-032','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',133,'EXECUTED','9:e9621439a79c5255a2cfe540c1e8df73','customChange','Added 0.47.0 - migrate dashboard grid size from 18 to 24 for revisions',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-033','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',134,'EXECUTED','9:ef48cabec16353dc09a6297d06e27a9f','customChange','Added 0.47.0 - Migrate field refs in visualization_settings.column_settings keys from legacy format',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-034','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',135,'EXECUTED','9:9032d7052ab38a476e7f83d9486e8609','customChange','Added 0.47.0 - Add join-alias to the visualization_settings.column_settings field refs in card revisions',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-035','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',136,'EXECUTED','9:57f53ab4caba81bea788f23487b6888a','dropForeignKeyConstraint baseTableName=implicit_action, constraintName=fk_implicit_action_action_id','Added 0.47.0 - Drop foreign key constraint on implicit_action.action_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-036','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',137,'EXECUTED','9:c45b0246a2068f7bed037662a25e52c0','addPrimaryKey constraintName=pk_implicit_action, tableName=implicit_action','Added 0.47.0 - Set primary key to action_id for implicit_action table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-037','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',138,'EXECUTED','9:8a7a6c51a3f52acb8b69bf10782e3a6e','addForeignKeyConstraint baseTableName=implicit_action, constraintName=fk_implicit_action_action_id, referencedTableName=action','Added 0.47.0 - Add foreign key constraint on implicit_action.action_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-043','calherres','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',139,'EXECUTED','9:d7a6e633d99b064539cbc7563c7f1905','customChange','Added 0.47.0 - Migrate report_dashboardcard.visualization_settings.column_settings field refs from legacy format',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-044','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',140,'EXECUTED','9:905e1385202b3626c9e67e4645b44375','customChange','Added 0.47.0 - Add join-alias to the report_dashboardcard.visualization_settings.column_settings field refs',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-045','calherres','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',141,'EXECUTED','9:ad1660852fc3eacd2c35e164d3c97609','customChange','Added 0.47.0 - Migrate dashboard revision dashboard cards\' visualization_settings.column_settings field refs from legacy format',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-046','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',142,'EXECUTED','9:e0cd8b50dc855ce3362b562dc80afbb0','customChange','Added 0.47.0 - Add join-alias to dashboard revision dashboard cards\' visualization_settings.column_settings field refs',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-050','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',143,'EXECUTED','9:8e9aad6950c3b6f4799f51f0a7277457','addColumn tableName=metabase_table','Added 0.47.0 - table.is_upload',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-051','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',144,'EXECUTED','9:ec914ed2458e64fdd021bc6ca19e85c1','dropForeignKeyConstraint baseTableName=connection_impersonations, constraintName=fk_conn_impersonation_db_id','Added 0.47.0 - Drop foreign key constraint on connection_impersonations.db_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-052','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',145,'EXECUTED','9:9dc7bed69c542749be182f5d76233488','dropForeignKeyConstraint baseTableName=connection_impersonations, constraintName=fk_conn_impersonation_group_id','Added 0.47.0 - Drop foreign key constraint on connection_impersonations.group_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-053','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',146,'EXECUTED','9:91a175d49e28b1653ac8a7bad2a8204f','createIndex indexName=idx_conn_impersonations_db_id, tableName=connection_impersonations','Added 0.47.0 -- connection_impersonations index for db_id column',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-054','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:10',147,'EXECUTED','9:5245b1f06e5d1ae3a4c929f6cfcde9d4','createIndex indexName=idx_conn_impersonations_group_id, tableName=connection_impersonations','Added 0.47.0 -- connection_impersonations index for group_id column',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-055','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',148,'EXECUTED','9:aef0d48122a09e653a9683d3b7074165','addUniqueConstraint constraintName=conn_impersonation_unique_group_id_db_id, tableName=connection_impersonations','Added 0.47.0 - unique constraint for connection impersonations',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-056','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',149,'EXECUTED','9:bac4590e83ce8522e9fad8703aa88295','addForeignKeyConstraint baseTableName=connection_impersonations, constraintName=fk_conn_impersonation_db_id, referencedTableName=metabase_database','Added 0.47.0 - re-add foreign key constraint on connection_impersonations.db_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-057','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',150,'EXECUTED','9:21e3b2ee3c1ae91f35c7c1fbd0f82dac','addForeignKeyConstraint baseTableName=connection_impersonations, constraintName=fk_conn_impersonation_group_id, referencedTableName=permissions_group','Added 0.47.0 - re-add foreign key constraint on connection_impersonations.group_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-058','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',151,'EXECUTED','9:d268796eef28773e767c286904f50cee','dropColumn columnName=entity_id, tableName=parameter_card','Drop parameter_card.entity_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v47.00-059','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',152,'EXECUTED','9:087e632c348027aeb01bc49bb428f67a','dropNotNullConstraint columnName=entity_id, tableName=dashboard_tab','Drops not null from dashboard_tab.entity_id since it breaks drop-entity-ids command',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-001','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',153,'EXECUTED','9:2dd9aa417cd83b00a59b5eb1deb9ae55','customChange','Added 0.47.0 - Migrate database.options to database.settings',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-002','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',154,'EXECUTED','9:7a9312346a8d041d62726cd99d27e02b','dropColumn columnName=options, tableName=metabase_database','Added 0.47.0 - drop metabase_database.options',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-003','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',155,'EXECUTED','9:b623ee408e368c53ef1865af15a5edac','dropTable tableName=computation_job_result','Added 0.48.0 - drop computation_job_result table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-004','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',156,'EXECUTED','9:e9bdc7a7ca09fe29d5b3479d9925bbd7','dropTable tableName=computation_job','Added 0.48.0 - drop computation_job table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-005','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',157,'EXECUTED','9:46dbd09ead2298f0e37d28f011b8986e','addColumn tableName=query_execution','Added 0.48.0 - Add query_execution.action_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-006','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',158,'EXECUTED','9:87cb5019893ddcb08ce06856825f1e6a','createIndex indexName=idx_query_execution_action_id, tableName=query_execution','Added 0.48.0 - Index query_execution.action_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-007','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',159,'EXECUTED','9:efa5dcca04d3887bca0eafc95754b9ee','addColumn tableName=revision','Added 0.48.0 - Add revision.most_recent',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-008','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',160,'EXECUTED','9:427285b2ac59a9b5a4c7c51f0f7140a6','sql; sql','Set revision.most_recent = true for latest revisions',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-009','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',161,'EXECUTED','9:4243d81311d2dc265d687e4b665215dc','createTable tableName=table_privileges','Added 0.48.0 - Create table_privileges table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-010','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',162,'EXECUTED','9:79908afdc739c3e9dbdddd1e29a20e5d','sql','Remove ON UPDATE for revision.timestamp on mysql, mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-011','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',163,'EXECUTED','9:2da4950057f3a912cd044bd95a189087','createIndex indexName=idx_revision_most_recent, tableName=revision','Index revision.most_recent',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-013','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',164,'MARK_RAN','9:9478b5f507bc34df51aaa4d719fc1c37','sql','Index unindexed FKs for postgres',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-014','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',165,'MARK_RAN','9:f22e8ba6b47eaa27344835a6f5069c7f','createIndex indexName=idx_table_privileges_table_id, tableName=table_privileges','Added 0.48.0 - Create table_privileges.table_id index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-015','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',166,'EXECUTED','9:7ce7965ef94006d568d2298c4e5e007c','createIndex indexName=idx_table_privileges_role, tableName=table_privileges','Added 0.48.0 - Create table_privileges.role index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-016','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',167,'EXECUTED','9:99bac12bbd1ff64b35f0c48f5f9bf824','modifyDataType columnName=slug, tableName=collection','Added 0.48.0 - Change the type of collection.slug to varchar(510)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-018','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:11',168,'EXECUTED','9:7e190e044ea31c175d382aa6eb2b80c4','createTable tableName=recent_views','Add new recent_views table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-019','nemanjaglumac','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',169,'EXECUTED','9:3af8327e2dab1b5344292966c4e1d8e0','dropColumn columnName=color, tableName=collection','Collection color is removed in 0.48.0',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-020','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',170,'EXECUTED','9:53aa607fc4b962053bffbca4e4283391','createIndex indexName=idx_recent_views_user_id, tableName=recent_views','Added 0.48.0 - Create recent_views.user_id index',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-021','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',171,'EXECUTED','9:8fd8b97bfbae458ea7eb91e117cabc33','addColumn tableName=report_card','Cards store Metabase version used to create them',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-022','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',172,'EXECUTED','9:0f826a4d0f9f512ca63fb667409ad999','customChange','Migrate migrate-click-through to a custom migration',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-023','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',173,'EXECUTED','9:6ee76f86f68f7a2120cf8160cb34fd99','customChange','Data migration migrate-remove-admin-from-group-mapping-if-needed',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-024','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',174,'EXECUTED','9:87ed320552869766323c1d12f7969b17','dropTable tableName=data_migrations','All data migrations were transferred to custom_migrations!',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-025','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',175,'EXECUTED','9:0e54628ce18964128e827ad05ab2a448','addColumn tableName=revision','Revisions store Metabase version used to create them',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-026','lbrdnk','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',176,'EXECUTED','9:d1ce706fe25d39767a77089171859856','update tableName=metabase_field','Set semantic_type with value type/Number to null (#18754)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-027','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',177,'EXECUTED','9:0a7ed49c904abc7110aa09324b49f106','sql','No op migration',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-028','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',178,'EXECUTED','9:545c671b45a6bdf0f8dc7aa8ddfaaf29','createTable tableName=audit_log','Add new audit_log table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-029','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',179,'EXECUTED','9:bd1054ea8483f51d43701ba42d29768a','sqlFile path=instance_analytics_views/audit_log/v1/postgres-audit_log.sql; sqlFile path=instance_analytics_views/audit_log/v1/mysql-audit_log.sql; sqlFile path=instance_analytics_views/audit_log/v1/h2-audit_log.sql','Added 0.48.0 - new view v_audit_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-030','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',180,'EXECUTED','9:9dece66e24100146348152445f3ba47c','sqlFile path=instance_analytics_views/content/v1/postgres-content.sql; sqlFile path=instance_analytics_views/content/v1/mysql-content.sql; sqlFile path=instance_analytics_views/content/v1/h2-content.sql','Added 0.48.0 - new view v_content',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-031','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',181,'EXECUTED','9:4493c1a05ff71a8cf629c2e469e63b29','sqlFile path=instance_analytics_views/dashboardcard/v1/dashboardcard.sql','Added 0.48.0 - new view v_dashboardcard',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-032','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',182,'EXECUTED','9:c73d37997ac7c32b730b761bd1a7ecc0','sqlFile path=instance_analytics_views/group_members/v1/group_members.sql','Added 0.48.0 - new view v_group_members',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-033','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',183,'EXECUTED','9:793875adb62366f96ba5e97c3d86f6ad','sqlFile path=instance_analytics_views/subscriptions/v1/postgres-subscriptions.sql; sqlFile path=instance_analytics_views/subscriptions/v1/mysql-subscriptions.sql; sqlFile path=instance_analytics_views/subscriptions/v1/h2-subscriptions.sql','Added 0.48.0 - new view v_subscriptions for postgres',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-034','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',184,'EXECUTED','9:b3d39890db507464674fffaa4be3111c','sqlFile path=instance_analytics_views/users/v1/postgres-users.sql; sqlFile path=instance_analytics_views/users/v1/mysql-users.sql; sqlFile path=instance_analytics_views/users/v1/h2-users.sql','Added 0.48.0 - new view v_users',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-035','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',185,'EXECUTED','9:1600b802494a0077a24dbb4e4f6de5b2','sqlFile path=instance_analytics_views/alerts/v1/postgres-alerts.sql; sqlFile path=instance_analytics_views/alerts/v1/mysql-alerts.sql; sqlFile path=instance_analytics_views/alerts/v1/h2-alerts.sql','Added 0.48.0 - new view v_alerts',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-036','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',186,'EXECUTED','9:4a4b8b9d1d537618546664e041121858','sqlFile path=instance_analytics_views/databases/v1/databases.sql','Added 0.48.0 - new view v_databases',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-037','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',187,'EXECUTED','9:950273e8f27d0143e1ba26ff298da5c7','sqlFile path=instance_analytics_views/fields/v1/postgres-fields.sql; sqlFile path=instance_analytics_views/fields/v1/mysql-fields.sql; sqlFile path=instance_analytics_views/fields/v1/h2-fields.sql','Added 0.48.0 - new view v_fields',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-038','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',188,'EXECUTED','9:c7824fdfc6386073f53d490c9e25b3f4','sqlFile path=instance_analytics_views/query_log/v1/postgres-query_log.sql; sqlFile path=instance_analytics_views/query_log/v1/mysql-query_log.sql; sqlFile path=instance_analytics_views/query_log/v1/h2-query_log.sql','Added 0.48.0 - new view v_query_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-039','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',189,'EXECUTED','9:3d4eb8c983f42c45f9b55d401648ea73','sqlFile path=instance_analytics_views/tables/v1/postgres-tables.sql; sqlFile path=instance_analytics_views/tables/v1/mysql-tables.sql; sqlFile path=instance_analytics_views/tables/v1/h2-tables.sql','Added 0.48.0 - new view v_tables',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-040','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',190,'EXECUTED','9:b81e37d0a48f4fb40bf4a594b0ad5178','sqlFile path=instance_analytics_views/view_log/v1/postgres-view_log.sql; sqlFile path=instance_analytics_views/view_log/v1/mysql-view_log.sql; sqlFile path=instance_analytics_views/view_log/v1/h2-view_log.sql','Added 0.48.0 - new view v_view_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-045','qwef','migrations/001_update_migrations.yaml','2024-06-19 22:13:12',191,'EXECUTED','9:3a8a23ac9c57ddb43351c8a0d57edbb7','addColumn tableName=query_execution','Added 0.48.0 - add is_sandboxed to query_execution',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-046','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',192,'EXECUTED','9:de62f52504f802c5bd4164395d88b340','sqlFile path=instance_analytics_views/indexes/v1/postgres-indexes.sql; sqlFile path=instance_analytics_views/indexes/v1/mysql-indexes.sql; sqlFile path=instance_analytics_views/indexes/v1/mariadb-indexes.sql; sqlFile path=instance_analytics_views/...','Added 0.48.0 - new indexes to optimize audit v2 queries',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-047','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',193,'EXECUTED','9:83099e323661cb585639e5ee8d48d7bf','dropForeignKeyConstraint baseTableName=recent_views, constraintName=fk_recent_views_ref_user_id','Drop foreign key on recent_views so that it can be recreated with onDelete policy',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-048','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',194,'EXECUTED','9:1ccb1544d732d0c6944ee1c4ac998801','addForeignKeyConstraint baseTableName=recent_views, constraintName=fk_recent_views_ref_user_id, referencedTableName=core_user','Add foreign key on recent_views with onDelete CASCADE',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-049','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',195,'EXECUTED','9:05df92e2ee338322a94403ba1ca24659','sql; sql; sql','Migrate data from activity to audit_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-050','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',196,'EXECUTED','9:d41d8cd98f00b204e9800998ecf8427e','empty','Added 0.48.0 - no-op migration to remove audit DB and collection on downgrade',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-051','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',197,'EXECUTED','9:cf285be2d9566f078ecabe8c01b1a896','sql; sql','Migrate metabase_field when the fk target field is inactive',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-053','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',198,'EXECUTED','9:7997563ebc2f57b53a1f19679d89b3b7','modifyDataType columnName=model, tableName=activity','Increase length of `activity.model` to fit longer model names',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-054','escherize','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',199,'EXECUTED','9:d41d8cd98f00b204e9800998ecf8427e','empty','Added 0.48.0 - no-op migration to remove Internal Metabase User on downgrade',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-055','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',200,'EXECUTED','9:753e49c8ca5d240edaea75a82af76e16','sqlFile path=instance_analytics_views/tasks/v1/postgres-tasks.sql; sqlFile path=instance_analytics_views/tasks/v1/mysql-tasks.sql; sqlFile path=instance_analytics_views/tasks/v1/h2-tasks.sql','Added 0.48.0 - new view v_tasks',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-056','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',201,'EXECUTED','9:cd66e7282ad1d92ae91d2694906f8762','addColumn tableName=view_log','Adjust view_log schema for Audit Log v2',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-057','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',202,'EXECUTED','9:24967224f6153a884f8f588772dfaf7d','addColumn tableName=view_log','Adjust view_log schema for Audit Log v2',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-059','qwef','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',203,'EXECUTED','9:aac112e35358d50dd099737f32e491bc','sql','Update the namespace of any audit collections that are already loaded',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-060','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',204,'EXECUTED','9:97dc864df6ae5bca6e14ff4b1a455030','createIndex indexName=idx_task_history_started_at, tableName=task_history','Added 0.48.0 - task_history.started_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-061','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',205,'EXECUTED','9:87e8b08479ad84f843df319cc837b450','addColumn tableName=query_execution','Adds query_execution.cache_hash -> query_cache.query_hash',NULL,'4.26.0',NULL,NULL,'8806377583'),('v48.00-067','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',206,'EXECUTED','9:d898510812a4024d10b9f731242ce883','addUniqueConstraint constraintName=idx_databasechangelog_id_author_filename, tableName=DATABASECHANGELOG','Add unique constraint idx_databasechangelog_id_author_filename',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-000','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',207,'EXECUTED','9:a6eaedb204bd70b999a7b7ed7524b904','sql','Remove leagcy pulses',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-003','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',208,'EXECUTED','9:6c49190e041265b22255a447302236b8','addColumn tableName=core_user','Add a `type` to users',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-004','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',209,'EXECUTED','9:910cb52c64c9c2432dbe19d487710723','createTable tableName=api_key','Add a table for API keys',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-005','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',210,'EXECUTED','9:790e75675265f53ca11f32994b9d1d12','createIndex indexName=idx_api_key_created_by, tableName=api_key','Add an index on `api_key.created_by`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-006','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',211,'EXECUTED','9:46cfb5a9bab696272d0211d7f34870ef','createIndex indexName=idx_api_key_user_id, tableName=api_key','Add an index on `api_key.user_id`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-007','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',212,'EXECUTED','9:638a7394870315abd52742b739ee49ff','sql','Set the `type` of the internal user',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-008','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',213,'EXECUTED','9:381669dee234455e2d6e975afb9e95b0','addColumn tableName=metabase_field','Add metabase_field.database_indexed',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-009','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:13',214,'EXECUTED','9:9cc276d895ef96a7d9e4b9c9b033a91f','sql; sql','Migrate pulse_card.include_csv to \'true\' when the joined card.display is \'table\'',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-010','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',215,'EXECUTED','9:c618fafea8561e66c97ac5d9a56106f3','addColumn tableName=api_key','Add a name to API Keys',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-011','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',216,'EXECUTED','9:9dae0a3606d63cc6c47ec94f181d203c','addColumn tableName=metabase_table','Add metabase_table.database_require_filter',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-012','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',217,'EXECUTED','9:129b215b73fec358adbd3cf9ba478515','addColumn tableName=metabase_field','Add metabase_field.database_partitioned',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-013','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',218,'EXECUTED','9:fd99fac43bba1d45dfa8f17cd635e55b','addColumn tableName=api_key','Add `api_key.updated_by_id`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-014','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',219,'EXECUTED','9:ab6ff0fa8e1088222e01466c38295012','createIndex indexName=idx_api_key_updated_by_id, tableName=api_key','Add an index on `api_key.updated_by_id`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-015','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',220,'EXECUTED','9:85e3063c4b008044fe6729789af4d2d0','renameColumn newColumnName=creator_id, oldColumnName=created_by, tableName=api_key','Rename `created_by` to `creator_id`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-016','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',221,'EXECUTED','9:3af524e7d0a5451fa0b3664c73909654','modifyDataType columnName=archived, tableName=action','Added 0.49.0 - modify type of action.archived from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-017','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',222,'EXECUTED','9:d6f038eb9f5cd269af61920e84b7843b','addNotNullConstraint columnName=archived, tableName=action','Add NOT NULL constraint to action.archived',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-018','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',223,'EXECUTED','9:dfa7799dd05f439f01c646f35810d37a','addDefaultValue columnName=archived, tableName=action','Add default value to action.archived',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-019','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:14',224,'EXECUTED','9:6670e06ad4f9cae59d8030a0bd188e8d','modifyDataType columnName=json_unfolding, tableName=metabase_field','Added 0.49.0 - modify type of metabase_field.json_unfolding from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-020','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',225,'EXECUTED','9:471354d5a2a892d7fff8dda434167e42','addNotNullConstraint columnName=json_unfolding, tableName=metabase_field','Add NOT NULL constraint to metabase_field.json_unfolding',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-021','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',226,'EXECUTED','9:eda3e041b4def2f0c9188b131330a743','addDefaultValue columnName=json_unfolding, tableName=metabase_field','Add default value to metabase_field.json_unfolding',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-022','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',227,'EXECUTED','9:f55c82c9150267f7af4105cfd040ea92','modifyDataType columnName=database_is_auto_increment, tableName=metabase_field','Added 0.49.0 - modify type of metabase_field.database_is_auto_increment from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-023','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',228,'EXECUTED','9:1c23e1a62c2c8b909285bd74f7babeb6','addNotNullConstraint columnName=database_is_auto_increment, tableName=metabase_field','Add NOT NULL constraint to metabase_field.database_is_auto_increment',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-024','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',229,'EXECUTED','9:438a77b956692c7e3703d96b913e5566','addDefaultValue columnName=database_is_auto_increment, tableName=metabase_field','Add default value to metabase_field.database_is_auto_increment',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-025','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',230,'EXECUTED','9:e71efa66f18a81d725397af1430e17cc','modifyDataType columnName=auto_apply_filters, tableName=report_dashboard','Added 0.49.0 - modify type of report_dashboard.auto_apply_filters from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-026','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',231,'EXECUTED','9:f48932fb7dbb00b5dd6eed779538d57f','addNotNullConstraint columnName=auto_apply_filters, tableName=report_dashboard','Add NOT NULL constraint to report_dashboard.auto_apply_filters',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-027','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',232,'EXECUTED','9:e8e27cec1e1cb5801ddfca828e3404a2','addDefaultValue columnName=auto_apply_filters, tableName=report_dashboard','Add default value to report_dashboard.auto_apply_filters',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-028','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',233,'EXECUTED','9:cc433fbe4fc7c63120f47c21f8dd4876','modifyDataType columnName=is_audit, tableName=metabase_database','Added 0.49.0 - modify type of metabase_database.is_audit from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-029','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',234,'EXECUTED','9:508f95400f30625332612492fc0d390f','addNotNullConstraint columnName=is_audit, tableName=metabase_database','Add NOT NULL constraint to metabase_database.is_audit',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-030','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:15',235,'EXECUTED','9:93140751149cec3fdf7a186e6bac564a','addDefaultValue columnName=is_audit, tableName=metabase_database','Add default value to metabase_database.is_audit',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-031','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',236,'EXECUTED','9:ee9d6badebbaad529947c18acab19f33','modifyDataType columnName=is_upload, tableName=metabase_table','Added 0.49.0 - modify type of metabase_table.is_upload from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-032','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',237,'EXECUTED','9:5db2a4a8512493aaeea8317c3bb97a0a','addNotNullConstraint columnName=is_upload, tableName=metabase_table','Add NOT NULL constraint to metabase_table.is_upload',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-033','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',238,'EXECUTED','9:75f535cee2ac99c5eabfd8d23007cec5','addDefaultValue columnName=is_upload, tableName=metabase_table','Add default value to metabase_table.is_upload',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-034','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',239,'EXECUTED','9:e0a9e7d1363fa5ab69571a9613d06c7f','modifyDataType columnName=most_recent, tableName=revision','Added 0.49.0 - modify type of revision.most_recent from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-035','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',240,'EXECUTED','9:e0a9e7d1363fa5ab69571a9613d06c7f','modifyDataType columnName=most_recent, tableName=revision','Added 0.49.0 - modify type of revision.most_recent from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-036','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',241,'EXECUTED','9:d4d5506cb138538496bfcc597dea0ed7','addNotNullConstraint columnName=most_recent, tableName=revision','Add NOT NULL constraint to revision.most_recent',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-037','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',242,'EXECUTED','9:ddaf7704e565f42c3599823018f7f0cd','addDefaultValue columnName=most_recent, tableName=revision','Add default value to revision.most_recent',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-038','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',243,'EXECUTED','9:764da803a4253e28e188705a0a54db7d','modifyDataType columnName=select, tableName=table_privileges','Added 0.49.0 - modify type of table_privileges.select from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-039','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',244,'EXECUTED','9:3ad298c9d5b09735eca58fa0e36145e6','addNotNullConstraint columnName=select, tableName=table_privileges','Add NOT NULL constraint to table_privileges.select',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-040','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',245,'EXECUTED','9:a429c76f53ca1f6e40cb97e10f5bbb13','addDefaultValue columnName=select, tableName=table_privileges','Add default value to table_privileges.select',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-041','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',246,'EXECUTED','9:b805a294a82be70036c9691bb6f8add6','modifyDataType columnName=update, tableName=table_privileges','Added 0.49.0 - modify type of table_privileges.update from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-042','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',247,'EXECUTED','9:a058ac5e70061fac23d649c51de38b4a','addNotNullConstraint columnName=update, tableName=table_privileges','Add NOT NULL constraint to table_privileges.update',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-043','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:16',248,'EXECUTED','9:1a18955a2d01bb8fb1b7edfc74f5d976','addDefaultValue columnName=update, tableName=table_privileges','Add default value to table_privileges.update',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-044','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',249,'EXECUTED','9:624c6ca0e36c7772bb253e5b145a0be6','modifyDataType columnName=insert, tableName=table_privileges','Added 0.49.0 - modify type of table_privileges.insert from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-045','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',250,'EXECUTED','9:a4e9d3e1b3ac0544d36da7fcf6e296a3','addNotNullConstraint columnName=insert, tableName=table_privileges','Add NOT NULL constraint to table_privileges.insert',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-046','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',251,'EXECUTED','9:32c3a206904e45e4d6b3d639a2477d4e','addDefaultValue columnName=insert, tableName=table_privileges','Add default value to table_privileges.insert',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-047','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',252,'EXECUTED','9:a49c32d40d1a70fa2388760363ed5626','modifyDataType columnName=delete, tableName=table_privileges','Added 0.49.0 - modify type of table_privileges.delete from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-048','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',253,'EXECUTED','9:ea9d63a09f6fbf06841c9e23d885d065','addNotNullConstraint columnName=delete, tableName=table_privileges','Add NOT NULL constraint to table_privileges.delete',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-049','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',254,'EXECUTED','9:fa6e7cafdbbf7880ddd8eef9b1cd33c9','addDefaultValue columnName=delete, tableName=table_privileges','Add default value to table_privileges.delete',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-050','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',255,'EXECUTED','9:5b2c42dcb037b8f34161182f1252f5a7','modifyDataType columnName=is_sandboxed, tableName=query_execution','Added 0.49.0 - modify type of query_execution.is_sandboxed from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-051','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',256,'EXECUTED','9:932ff410b31a5312bd59bb4af1051b91','modifyDataType columnName=has_access, tableName=view_log','Added 0.49.0 - modify type of view_log.has_access from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-052','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',257,'EXECUTED','9:ee005c2e466f51fdb7e6609e6604fbc7','modifyDataType columnName=database_indexed, tableName=metabase_field','Added 0.49.0 - modify type of metabase_field.database_indexed from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-053','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:17',258,'EXECUTED','9:63c99fa4f61b45384d24d65dd2b785dd','modifyDataType columnName=database_require_filter, tableName=metabase_table','Added 0.49.0 - modify type of metabase_table.database_require_filter from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-059','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',259,'EXECUTED','9:4046506923db48fd7a7c11021b58a4b5','customChange','Added 0.49.0 - unify type of time columns',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.00-060','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',260,'EXECUTED','9:bfa847d943e2a99d363bf56ac5f31b88','modifyDataType columnName=database_partitioned, tableName=metabase_field','Added 0.49.0 - modify type of metabase_field.database_partitioned from boolean to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-22T11:50:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',261,'EXECUTED','9:643a028e650ad7fcd6789a702249a179','addColumn tableName=report_card','Add `report_card.type`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-22T11:51:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',262,'EXECUTED','9:6e53593c40c63e38d6c1ffd0331753c5','sql','Backfill `report_card.type`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-22T11:52:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',263,'EXECUTED','9:7d260ed302016469ea5950bba09cb471','customChange','Backfill `report_card.type`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-29T19:26:40','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',264,'EXECUTED','9:04671d8b09ff919ab5154604377ba247','addColumn tableName=report_dashboard','Add width setting to Dashboards',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-29T19:30:00','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',265,'EXECUTED','9:856b864c837cd25b3de595691f2b5712','update tableName=report_dashboard','Update existing report_dashboard width values to full',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-29T19:56:40','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',266,'EXECUTED','9:c092ab859ee6994fcd3b4719872abb97','addNotNullConstraint columnName=width, tableName=report_dashboard','Dashboard width setting must have a value',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-01-29T19:59:12','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',267,'EXECUTED','9:663770b688f1ec9aee90d067d789ddbe','addDefaultValue columnName=width, tableName=report_dashboard','Add default value to report_dashboard.width for mysql and mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-02T11:27:49','oisincoveney','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',268,'EXECUTED','9:c67f2804eeabd9937bb4d10d93160a9e','addColumn tableName=report_card','Add report_card.initially_published_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-02T11:28:36','oisincoveney','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',269,'EXECUTED','9:a789a7122bdeb83603486f84a2024a62','addColumn tableName=report_dashboard','Add report_dashboard.initially_published_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-07T21:52:01','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',270,'EXECUTED','9:da7a00eb2ed39a840975e50c93a5805a','sqlFile path=instance_analytics_views/view_log/v2/postgres-view_log.sql; sqlFile path=instance_analytics_views/view_log/v2/mysql-view_log.sql; sqlFile path=instance_analytics_views/view_log/v2/h2-view_log.sql','Added 0.49.0 - updated view v_view_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-07T21:52:02','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',271,'EXECUTED','9:bfad7cbbaf23a408a427ad13fe6ca61a','sqlFile path=instance_analytics_views/audit_log/v2/postgres-audit_log.sql; sqlFile path=instance_analytics_views/audit_log/v2/mysql-audit_log.sql; sqlFile path=instance_analytics_views/audit_log/v2/h2-audit_log.sql','Added 0.49.0 - updated view v_audit_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-07T21:52:03','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',272,'EXECUTED','9:9072a2d1352e44778ba6ecda18ba2177','sqlFile path=instance_analytics_views/group_members/v2/group_members.sql','Added 0.49.0 - updated view v_group_members',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-07T21:52:04','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',273,'EXECUTED','9:8a38c37ebaa7737254f1cbcca2ee9a05','sqlFile path=instance_analytics_views/query_log/v2/postgres-query_log.sql; sqlFile path=instance_analytics_views/query_log/v2/mysql-query_log.sql; sqlFile path=instance_analytics_views/query_log/v2/h2-query_log.sql','Added 0.49.0 - updated view v_query_log',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-07T21:52:05','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',274,'EXECUTED','9:5c6dc68180512127abcbefb3c1905b6e','sqlFile path=instance_analytics_views/users/v2/postgres-users.sql; sqlFile path=instance_analytics_views/users/v2/mysql-users.sql; sqlFile path=instance_analytics_views/users/v2/h2-users.sql','Added 0.49.0 - updated view v_users',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-02-09T13:55:26','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',275,'MARK_RAN','9:c5913529bf32922a42106be35fa5cb0f','sql; sql; sql','Set default value for enable-public-sharing to `false` for existing instances with users, if not already set',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-03-26T10:23:12','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:22',276,'EXECUTED','9:2e7a0bc202e12b0ece4365d253b46bff','addColumn tableName=pulse_card','Add pulse_card.format_rows',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-03-26T20:27:58','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',277,'EXECUTED','9:469ae1b8af4545f2f48d9505fd34059d','customChange','Added 0.46.0 - Delete the truncate audit log task (renamed to truncate audit tables)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-04-09T10:00:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',278,'EXECUTED','9:0584ae323d98a60f80b433bedab2a0a2','dropNotNullConstraint columnName=cache_field_values_schedule, tableName=metabase_database','Drop not null constraint on metabase_database.cache_field_values_schedule',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-04-09T10:00:01','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',279,'EXECUTED','9:68341c448ecdca425eae019974b64c09','dropDefaultValue columnName=cache_field_values_schedule, tableName=metabase_database','Drop default value on metabase_database.cache_field_values_schedule',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-04-09T10:00:02','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',280,'EXECUTED','9:adb15f2d80ea2b037b44d1eb2dbcb3c5','addDefaultValue columnName=cache_field_values_schedule, tableName=metabase_database','Add null as default value for metabase_database.cache_field_values_schedule',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-04-09T10:00:03','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',281,'EXECUTED','9:fb84fa8ea82ea520edae45164aa167d9','customChange','This clears the schedule for caching field values for databases with period scanning disabled.',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-07T10:00:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',282,'EXECUTED','9:60df23f2bae0b7c52fcb29845cb911e5','sql','Set revision.most_recent = true to latest revision and false to others. A redo of v48.00-008 for mysql',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-20T19:10:34','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',283,'EXECUTED','9:37e8337a7760488c44efb9eb336827a8','modifyDataType columnName=collection_preview, tableName=report_card','Modify type of report_card.collection_preview to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-20T20:37:55','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',284,'EXECUTED','9:cd3c79ed1edfc118dabbdb1f0aa63df7','addNotNullConstraint columnName=collection_preview, tableName=report_card','Add NOT NULL constraint to report_card.collection_preview',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-20T20:38:34','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',285,'EXECUTED','9:4915c63aed5f55151a7fe470a040862f','addDefaultValue columnName=collection_preview, tableName=report_card','Add default value to report_card.collection_preview',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-29T09:26:20','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',286,'EXECUTED','9:801a8f1afe7dd59ef03f68036830e85d','modifyDataType columnName=dataset, tableName=report_card','Modify type of report_card.dataset to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-29T09:27:15','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:23',287,'EXECUTED','9:cc966e564c858127530e7f7716b02e36','addNotNullConstraint columnName=dataset, tableName=report_card','Add NOT NULL constraint to report_card.dataset',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-05-29T09:28:25','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:24',288,'EXECUTED','9:38c354239c1ccad066b233ebe80b2dcf','addDefaultValue columnName=dataset, tableName=report_card','Add default value to report_card.dataset',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:01:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:24',289,'EXECUTED','9:1d1c91b9c7cead23b159896420c79af4','modifyDataType columnName=is_datasetnewb, tableName=core_user','Modify type of core_user.is_datasetnewb to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:01:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',290,'EXECUTED','9:82b9f72cf8b697d5e91c287e8a758b08','addNotNullConstraint columnName=is_datasetnewb, tableName=core_user','Add NOT NULL constraint to core_user.is_datasetnewb on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:01:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',291,'EXECUTED','9:041a7090bfadac7f338a20fd67c83b58','addDefaultValue columnName=is_datasetnewb, tableName=core_user','Add default value to core_user.is_datasetnewb on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:02:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',292,'EXECUTED','9:f5326345adab0353084b60af1b073636','modifyDataType columnName=database_required, tableName=metabase_field','Modify type of metabase_field.database_required to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:02:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',293,'EXECUTED','9:21bc6332032c73f4639fec4bd030dcd6','addNotNullConstraint columnName=database_required, tableName=metabase_field','Add NOT NULL constraint to metabase_field.database_required on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:02:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',294,'EXECUTED','9:7befa4ce0f5c42bd64b28fa452dc8170','addDefaultValue columnName=database_required, tableName=metabase_field','Add default value to metabase_field.database_required on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:03:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',295,'EXECUTED','9:09f828eca1dfb7853a2725ae596d66c6','modifyDataType columnName=has_more_values, tableName=metabase_fieldvalues','Modify type of metabase_fieldvalues.has_more_values to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:03:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',296,'EXECUTED','9:16349a8c50f6af8e85890d42794e1bbc','addDefaultValue columnName=has_more_values, tableName=metabase_fieldvalues','Add default value to metabase_fieldvalues.has_more_values on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:04:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',297,'EXECUTED','9:8e9d653bb983f8383bf71ff8596faf7d','modifyDataType columnName=is_group_manager, tableName=permissions_group_membership','Modify type of permissions_group_membership.is_group_manager to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:04:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',298,'EXECUTED','9:4cec16bfde7501060d4aa50c45a5a921','addNotNullConstraint columnName=is_group_manager, tableName=permissions_group_membership','Add NOT NULL constraint to permissions_group_membership.is_group_manager on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:04:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',299,'EXECUTED','9:9b5ba285cc8b148637929bbe77fe9c42','addDefaultValue columnName=is_group_manager, tableName=permissions_group_membership','Add default value to permissions_group_membership.is_group_manager on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:05:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',300,'EXECUTED','9:018e98f8ad3ad67589c2f3c40e7d19d3','modifyDataType columnName=active, tableName=persisted_info','Modify type of persisted_info.active to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:05:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',301,'EXECUTED','9:96f6bebaad7cb9b01b2984881e65334b','addNotNullConstraint columnName=active, tableName=persisted_info','Add NOT NULL constraint to persisted_info.active on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:05:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:25',302,'EXECUTED','9:f48d7fe3f66e550d41337c8d1d30dac3','addDefaultValue columnName=active, tableName=persisted_info','Add default value to persisted_info.active on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:06:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',303,'EXECUTED','9:801a8f1afe7dd59ef03f68036830e85d','modifyDataType columnName=dataset, tableName=report_card','Modify type of report_card.dataset to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:06:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',304,'EXECUTED','9:cc966e564c858127530e7f7716b02e36','addNotNullConstraint columnName=dataset, tableName=report_card','Add NOT NULL constraint to report_card.dataset on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:06:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',305,'EXECUTED','9:38c354239c1ccad066b233ebe80b2dcf','addDefaultValue columnName=dataset, tableName=report_card','Add default value to report_card.dataset on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:07:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',306,'EXECUTED','9:d3b401736be71c429234be8cd4a0674a','modifyDataType columnName=archived, tableName=timeline','Modify type of timeline.archived to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:07:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',307,'EXECUTED','9:3670bc7ab905d2b0ef5e43fa32b61549','addNotNullConstraint columnName=archived, tableName=timeline','Add NOT NULL constraint to timeline.archived on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:07:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',308,'EXECUTED','9:5c719513bc741dbbf32c775ba01d9ad5','addDefaultValue columnName=archived, tableName=timeline','Add default value to timeline.archived on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:08:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',309,'EXECUTED','9:3359f45e3702535ed528e77a16c468de','modifyDataType columnName=default, tableName=timeline','Modify type of timeline.default to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:08:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',310,'EXECUTED','9:6f5e4229d5daebda415a2e3222252ff1','addNotNullConstraint columnName=default, tableName=timeline','Add NOT NULL constraint to timeline.default on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:08:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',311,'EXECUTED','9:b8c9b0a2ea7421499dea66e1f5b5aaec','addDefaultValue columnName=default, tableName=timeline','Add default value to timeline.default on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:09:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',312,'EXECUTED','9:0f66de0e773ce3a17da9d4d32d54fe8e','modifyDataType columnName=archived, tableName=timeline_event','Modify type of timeline_event.archived to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:09:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',313,'EXECUTED','9:c3f3668fb388e7cfafd1491e0a18a63f','addNotNullConstraint columnName=archived, tableName=timeline_event','Add NOT NULL constraint to timeline_event.archived on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:09:03','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:26',314,'EXECUTED','9:273829584cdadb47cdb01659369930d0','addDefaultValue columnName=archived, tableName=timeline_event','Add default value to timeline_event.archived on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:10:01','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',315,'EXECUTED','9:3a56364d180c24ad5a5d9c5f3f5df962','modifyDataType columnName=time_matters, tableName=timeline_event','Modify type of timeline_event.time_matters to bit(1) on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v49.2024-06-05T09:10:02','johnswanson','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',316,'EXECUTED','9:2f04eba0f574e8c7808acbbc1e3b1f45','addNotNullConstraint columnName=time_matters, tableName=timeline_event','Add NOT NULL constraint to timeline_event.time_matters on mysql,mariadb',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-04T13:52:51','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',317,'EXECUTED','9:19f8b6614c4fe95ff71b42830785df04','createTable tableName=data_permissions','Data permissions table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-09T13:52:21','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',318,'EXECUTED','9:3c438c9a400361ed3dedc2818c7ed4b8','createIndex indexName=idx_data_permissions_table_id, tableName=data_permissions','Index on data_permissions.table_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-09T13:53:50','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',319,'EXECUTED','9:21ad67aa43df73593d4e86492afdfb4e','createIndex indexName=idx_data_permissions_db_id, tableName=data_permissions','Index on data_permissions.db_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-09T13:53:54','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',320,'EXECUTED','9:34a2e61c8298c84b18f7a7c7bf5d2119','createIndex indexName=idx_data_permissions_group_id, tableName=data_permissions','Index on data_permissions.group_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-10T03:27:29','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',321,'EXECUTED','9:a8c8b1c823344ea148826e9772c2b9b7','dropForeignKeyConstraint baseTableName=sandboxes, constraintName=fk_sandboxes_ref_permissions','Drop foreign key constraint on sandboxes.permissions_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-10T03:27:30','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',322,'EXECUTED','9:43d9c28c892a376c4884b0e1e9a46abb','sqlFile path=permissions/data_access.sql; sqlFile path=permissions/mysql_data_access.sql','Migrate data-access permissions from `permissions` to `data_permissions`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-10T03:27:31','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',323,'EXECUTED','9:4ea632c5ef082ebf005d923bd5527be3','sqlFile path=permissions/native_query_editing.sql','Migrate native-query-editing permissions from `permissions` to `data_permissions`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-10T03:27:32','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',324,'EXECUTED','9:ee60f5758c7e3686ab91338aca682960','sqlFile path=permissions/download_results.sql; sqlFile path=permissions/mysql_download_results.sql','Migrate download-results permissions from `permissions` to `data_permissions`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-10T03:27:33','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',325,'EXECUTED','9:c90adccb7a20372a38f5379a096a1ad0','sqlFile path=permissions/manage_table_metadata.sql; sqlFile path=permissions/mysql_manage_table_metadata.sql','Migrate manage-data-metadata permissions from `permissions` to `data_permissions`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-01-10T03:27:34','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',326,'EXECUTED','9:9c37edf4ba12133ce298fb806af1a9cb','sqlFile path=permissions/manage_database.sql','Migrate manage-database permissions from `permissions` to `data_permissions`',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-19T21:32:04','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',327,'EXECUTED','9:2a02ffb8f60532c88e645d2cd9053d95','sql','Clear data permission paths',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-20T19:21:04','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',328,'EXECUTED','9:32e06eedee74b10b4f03aa0c64e5f19c','sql','Drop v1 version of v_content view since it references report_card.dataset which we are dropping in next migration',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-20T19:25:40','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',329,'EXECUTED','9:1a0d14160b0a4e346ffe38d0e1009b7e','dropColumn columnName=dataset, tableName=report_card','Remove report_card.dataset (indicated whether Card was a Model; migrated to report_card.type in 49)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-20T19:26:38','camsaul','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',330,'EXECUTED','9:e3a9aeb9609c7d2709fed4dcafff645d','sqlFile path=instance_analytics_views/content/v2/postgres-content.sql; sqlFile path=instance_analytics_views/content/v2/mysql-content.sql; sqlFile path=instance_analytics_views/content/v2/h2-content.sql','Add new v2 version of v_content view which uses report_card.type instead of report_card.dataset (removed in previous migration)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-26T22:15:54','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',331,'EXECUTED','9:838ed8f582c11e79f574db21b2dcb999','sqlFile path=permissions/view_data.sql; sqlFile path=permissions/mysql_view_data.sql','New `view-data` permission',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-26T22:15:55','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',332,'EXECUTED','9:7c2bc517b6def4e3278394b0399c3d4b','sqlFile path=permissions/create_queries.sql','New `create_queries` permission',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-29T15:06:43','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',333,'EXECUTED','9:bf61f630cb8d21a16ef6566d842a8b46','createTable tableName=query_field','Add the query_field join table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-29T15:07:43','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',334,'EXECUTED','9:0abc329e07ca6746b3e3da79a1bb4fdb','createIndex indexName=idx_query_field_card_id, tableName=query_field','Index query_field.card_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-02-29T15:08:43','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',335,'EXECUTED','9:27ce36c055a2b252a6c6e52d5f5f1d76','createIndex indexName=idx_query_field_field_id, tableName=query_field','Index query_field.field_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-12T17:16:38','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',336,'EXECUTED','9:ee42f814c124ba84636b9b5fd1c34bdf','dropTable tableName=activity','Drops the `activity` table which is now unused',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-18T16:00:00','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',337,'EXECUTED','9:b659196c654af3fcd883659a23050456','createTable tableName=cache_config','Effective caching #36847',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-18T16:00:01','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',338,'EXECUTED','9:5007337d4de322587ce6056e0b9eac9b','addUniqueConstraint constraintName=idx_cache_config_unique_model, tableName=cache_config','Effective caching #36847',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-21T17:41:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:27',339,'EXECUTED','9:ecace972ee38bae5dd02e23ff91e2794','addColumn tableName=metabase_table','Add metabase_table.estimated_row_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-22T00:38:28','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',340,'EXECUTED','9:35b509c5f84505752ce3bce23ac9fe7e','createTable tableName=field_usage','Add field_usage table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-22T00:39:28','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',341,'EXECUTED','9:c94534b092f89579385156f18faee569','createIndex indexName=idx_field_usage_field_id, tableName=field_usage','Index field_usage.field_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-24T19:34:11','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',342,'EXECUTED','9:ceac2712d4c61fbbafa21b905ee7cf35','sql','Clean up deprecated view-data and native-query-editing permissions',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-25T14:53:00','tsmacdonald','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',343,'EXECUTED','9:af3b97471147a095314b82f495a76355','addColumn tableName=query_field','Add query_field.direct_reference',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-28T16:30:35','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',344,'EXECUTED','9:db68375fac0a9fe40f0caf475dd1fd92','customChange','Create internal user',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-03-29T10:00:00','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',345,'EXECUTED','9:abd6ed632eb666eef7c7af2fd4516e4b','addColumn tableName=report_card','Granular cache invalidation',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-09T15:55:19','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',346,'EXECUTED','9:73939d8738beb345395b00486e8be036','addColumn tableName=collection','Add collection.is_sample column',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-15T16:30:35','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',347,'EXECUTED','9:ca6732d415696c00b248da78cd63f581','addColumn tableName=report_card','Add report_card.last_used_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-19T17:04:04','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',348,'EXECUTED','9:ceac2712d4c61fbbafa21b905ee7cf35','sql','Clean up deprecated view-data and native-query-editing permissions (again)',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T01:04:05','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',349,'EXECUTED','9:61c4fc54c2c8ab0ea6b072ec1409fa48','customChange','Delete the old SendPulses job and trigger',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T01:04:06','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',350,'EXECUTED','9:ca85ee4382798cec047044ab394061c0','customChange','Delete SendPulse Job on downgrade',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T01:04:07','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',351,'EXECUTED','9:8380c81746dd65909faceeef3461133e','customChange','Delete InitSendPulseTriggers Job on downgrade',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T03:15:01','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',352,'EXECUTED','9:669daa77b4a7c048fbb8bfb4fee54df0','addColumn tableName=core_user','Add entity_id to core_user',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T03:15:02','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',353,'EXECUTED','9:477fd6e94e5b5bcd818b811928af19ff','addColumn tableName=permissions_group','Add entity_id to permissions_group',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T16:29:31','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:28',354,'EXECUTED','9:8241c6c3caca2f4eeccfdd157063da58','addColumn tableName=report_card','Add report_card.view_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T16:29:32','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',355,'EXECUTED','9:2df1fd211edddb6c4fdf3a8ba460096d','sql; sql','Populate report_card.view_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T16:29:33','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',356,'EXECUTED','9:c443c22fa32cc1e0dbee3669ef0398ee','addColumn tableName=report_dashboard','Add report_dashboard.view_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T16:29:34','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',357,'EXECUTED','9:0ef640abf0344e1e8a7dd65cf12b2c36','sql; sql','Populate report_dashboard.view_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T16:29:35','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',358,'EXECUTED','9:5873cdd28eb07ce7ea60ab44e9646338','addColumn tableName=metabase_table','Add metabase_table.view_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-25T16:29:36','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',359,'EXECUTED','9:0d5b1e573bfe8924deba0d9bd3fbd8b2','sql; sql','Populate metabase_table.view_count',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-26T09:19:00','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',360,'EXECUTED','9:66c6d4c7d07af47f035b9f5ec8bd4ef8','createTable tableName=user_parameter_value','Added 0.50.0 - Per-user Dashboard Parameter values table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-26T09:25:00','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',361,'EXECUTED','9:2af6f33e022984b2abd41fb0a6820b92','createIndex indexName=idx_user_parameter_value_user_id, tableName=user_parameter_value','Index user_parameter_value.user_id',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-30T23:57:23','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',362,'EXECUTED','9:19d659847dc567d1abd78734b8672ea9','addColumn tableName=api_key','Add `scope` column to api_key to support SCIM authentication',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-04-30T23:58:24','noahmoss','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',363,'EXECUTED','9:a6914c25365739b16b573067fae3a383','dropNotNullConstraint columnName=user_id, tableName=api_key','Drop NOT NULL constraint on api_key.user_id to support SCIM-scoped API keys',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:00','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',364,'EXECUTED','9:e28d26db534e046b411c8fe176c1c0e0','addColumn tableName=task_history','Add task_history.status',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:01','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',365,'EXECUTED','9:c8df0ec666d8c736f83bdb85e446fed1','dropDefaultValue columnName=status, tableName=task_history','Drop default value task_history.status',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:02','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',366,'EXECUTED','9:c9cd34125a3c9445f4d7076527b95589','addDefaultValue columnName=status, tableName=task_history','Add \"started\" as default value for task_history.status, now that backfill is done.',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:03','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',367,'EXECUTED','9:ae3f0bf31f031acc16b351bbaec0a1bf','dropNotNullConstraint columnName=ended_at, tableName=task_history','Drop not null constraint for task_history.ended_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:04','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',368,'EXECUTED','9:20c322e8ee6d62c43ae49d8891f81f89','dropNotNullConstraint columnName=duration, tableName=task_history','Drop not null constraint for task_history.duration',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:05','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',369,'EXECUTED','9:b02406ab39b905df65acccf4bdc82ee1','dropDefaultValue columnName=ended_at, tableName=task_history','Drop default value task_history.ended_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-08T09:00:06','qnkhuat','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',370,'EXECUTED','9:7ab667ce198a98ccb03ec77b2f1b3655','addDefaultValue columnName=ended_at, tableName=task_history','Add null as default value for task_history.ended_at',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-13T16:00:00','filipesilva','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',371,'EXECUTED','9:0a8fee67ae6fe965f6f6824c8e9cb627','createTable tableName=cloud_migration','Create cloud migration',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-15T13:13:13','adam-james','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',372,'EXECUTED','9:a7f15cd934779ad0d52c634c3fdca04f','customChange','Fix visualization settings for stacked area/bar/combo displays',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-17T19:54:23','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',373,'EXECUTED','9:35cb1f14fe0c01a1eaaa660251c4478c','addColumn tableName=metabase_database','Add metabase_database.uploads_enabled column',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-17T19:54:24','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',374,'EXECUTED','9:207fad1b6ed06979a9ca087c8407b881','addColumn tableName=metabase_database','Add metabase_database.uploads_schema_name column',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-17T19:54:25','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',375,'EXECUTED','9:5a02e26118488635ae682325df5d74af','addColumn tableName=metabase_database','Add metabase_database.uploads_table_prefix column',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-17T19:54:26','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:29',376,'EXECUTED','9:2ba2a860ad40c70381cddf179a766d08','customChange','Update metabase_database.uploads_enabled value',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-05-27T15:55:22','calherries','migrations/001_update_migrations.yaml','2024-06-19 22:13:30',377,'EXECUTED','9:47cab1070db15a6d225dcf467747120a','customChange','Create sample content',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-06-12T12:33:07','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:30',378,'EXECUTED','9:6d76b0bddae5c21628ed0e2c3600e5ce','customChange','Decrypt some settings so the next migration runs well',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-06-12T12:33:08','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:30',379,'EXECUTED','9:f2d495df8f3835264f557bff64a5f11f','sqlFile path=custom_sql/fill_cache_config.pg.sql; sqlFile path=custom_sql/fill_cache_config.my.sql; sqlFile path=custom_sql/fill_cache_config.h2.sql','Copy old cache configurations to cache_config table',NULL,'4.26.0',NULL,NULL,'8806377583'),('v50.2024-06-12T12:33:09','piranha','migrations/001_update_migrations.yaml','2024-06-19 22:13:30',380,'EXECUTED','9:7a5ec7ab747490d43865dbc13d72cd2c','sqlFile path=custom_sql/fill_cache_config_root_fix.my.sql','Fix root cache config for mysql if it is wrong',NULL,'4.26.0',NULL,NULL,'8806377583');
/*!40000 ALTER TABLE `databasechangelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `databasechangeloglock`
--

DROP TABLE IF EXISTS `databasechangeloglock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `databasechangeloglock` (
  `ID` int NOT NULL,
  `LOCKED` tinyint NOT NULL,
  `LOCKGRANTED` datetime DEFAULT NULL,
  `LOCKEDBY` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `databasechangeloglock`
--

LOCK TABLES `databasechangeloglock` WRITE;
/*!40000 ALTER TABLE `databasechangeloglock` DISABLE KEYS */;
INSERT INTO `databasechangeloglock` VALUES (1,0,NULL,NULL);
/*!40000 ALTER TABLE `databasechangeloglock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dependency`
--

DROP TABLE IF EXISTS `dependency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `dependency` (
  `id` int NOT NULL AUTO_INCREMENT,
  `model` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `model_id` int NOT NULL,
  `dependent_on_model` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `dependent_on_id` int NOT NULL,
  `created_at` timestamp(6) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_dependency_model` (`model`),
  KEY `idx_dependency_model_id` (`model_id`),
  KEY `idx_dependency_dependent_on_model` (`dependent_on_model`),
  KEY `idx_dependency_dependent_on_id` (`dependent_on_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dependency`
--

LOCK TABLES `dependency` WRITE;
/*!40000 ALTER TABLE `dependency` DISABLE KEYS */;
/*!40000 ALTER TABLE `dependency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dimension`
--

DROP TABLE IF EXISTS `dimension`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `dimension` (
  `id` int NOT NULL AUTO_INCREMENT,
  `field_id` int NOT NULL COMMENT 'ID of the field this dimension row applies to',
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Short description used as the display name of this new column',
  `type` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Either internal for a user defined remapping or external for a foreign key based remapping',
  `human_readable_field_id` int DEFAULT NULL COMMENT 'Only used with external type remappings. Indicates which field on the FK related table to use for display',
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_dimension_field_id` (`field_id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `fk_dimension_displayfk_ref_field_id` (`human_readable_field_id`),
  KEY `idx_dimension_field_id` (`field_id`),
  CONSTRAINT `fk_dimension_displayfk_ref_field_id` FOREIGN KEY (`human_readable_field_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dimension_ref_field_id` FOREIGN KEY (`field_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Stores references to alternate views of existing fields, such as remapping an integer to a description, like an enum';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dimension`
--

LOCK TABLES `dimension` WRITE;
/*!40000 ALTER TABLE `dimension` DISABLE KEYS */;
/*!40000 ALTER TABLE `dimension` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_usage`
--

DROP TABLE IF EXISTS `field_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `field_usage` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'Unique ID',
  `field_id` int NOT NULL COMMENT 'ID of the field',
  `query_execution_id` int NOT NULL COMMENT 'referenced query execution',
  `used_in` varchar(25) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'which part of the query the field was used in',
  `filter_op` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'filter''s operator that applied to the field',
  `aggregation_function` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'the aggregation function that field applied to',
  `breakout_temporal_unit` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'temporal unit options of the breakout',
  `breakout_binning_strategy` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'the strategy of breakout',
  `breakout_binning_num_bins` int DEFAULT NULL COMMENT 'The numbin option of breakout',
  `breakout_binning_bin_width` int DEFAULT NULL COMMENT 'The numbin option of breakout',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The time a field usage was recorded',
  PRIMARY KEY (`id`),
  KEY `fk_field_usage_query_execution_id` (`query_execution_id`),
  KEY `idx_field_usage_field_id` (`field_id`),
  CONSTRAINT `fk_field_usage_field_id_metabase_field_id` FOREIGN KEY (`field_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_field_usage_query_execution_id` FOREIGN KEY (`query_execution_id`) REFERENCES `query_execution` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to store field usage during query execution';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_usage`
--

LOCK TABLES `field_usage` WRITE;
/*!40000 ALTER TABLE `field_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `http_action`
--

DROP TABLE IF EXISTS `http_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `http_action` (
  `action_id` int NOT NULL COMMENT 'The related action',
  `template` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'A template that defines method,url,body,headers required to make an api call',
  `response_handle` longtext COLLATE utf8mb4_unicode_ci COMMENT 'A program to take an api response and transform to an appropriate response for emitters',
  `error_handle` longtext COLLATE utf8mb4_unicode_ci COMMENT 'A program to take an api response to determine if an error occurred',
  PRIMARY KEY (`action_id`),
  CONSTRAINT `fk_http_action_ref_action_id` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='An http api call type of action';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `http_action`
--

LOCK TABLES `http_action` WRITE;
/*!40000 ALTER TABLE `http_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `http_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `implicit_action`
--

DROP TABLE IF EXISTS `implicit_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `implicit_action` (
  `action_id` int NOT NULL COMMENT 'The associated action',
  `kind` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The kind of implicit action create/update/delete',
  PRIMARY KEY (`action_id`),
  CONSTRAINT `fk_implicit_action_action_id` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='An action with dynamic parameters based on the underlying model';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `implicit_action`
--

LOCK TABLES `implicit_action` WRITE;
/*!40000 ALTER TABLE `implicit_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `implicit_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `label`
--

DROP TABLE IF EXISTS `label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `label` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `slug` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `icon` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `idx_label_slug` (`slug`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `label`
--

LOCK TABLES `label` WRITE;
/*!40000 ALTER TABLE `label` DISABLE KEYS */;
/*!40000 ALTER TABLE `label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `login_history`
--

DROP TABLE IF EXISTS `login_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `login_history` (
  `id` int NOT NULL AUTO_INCREMENT,
  `timestamp` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'When this login occurred.',
  `user_id` int NOT NULL COMMENT 'ID of the User that logged in.',
  `session_id` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'ID of the Session created by this login if one is currently active. NULL if Session is no longer active.',
  `device_id` char(36) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Cookie-based unique identifier for the device/browser the user logged in from.',
  `device_description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `ip_address` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_session_id` (`session_id`),
  KEY `idx_timestamp` (`timestamp`),
  KEY `idx_user_id_device_id` (`session_id`,`device_id`),
  KEY `idx_user_id_timestamp` (`user_id`,`timestamp`),
  CONSTRAINT `fk_login_history_session_id` FOREIGN KEY (`session_id`) REFERENCES `core_session` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_login_history_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=46 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Keeps track of various logins for different users and additional info such as location and device';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `login_history`
--

LOCK TABLES `login_history` WRITE;
/*!40000 ALTER TABLE `login_history` DISABLE KEYS */;
INSERT INTO `login_history` VALUES (1,'2024-06-19 14:26:46.860777',13371339,NULL,'ae529c00-191b-4696-a238-9c8997aa5157','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/125.0.0.0 Safari/537.36','222.130.159.174'),(2,'2024-06-19 14:27:39.531936',13371340,NULL,'ae529c00-191b-4696-a238-9c8997aa5157','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/125.0.0.0 Safari/537.36','222.130.159.174'),(3,'2024-06-19 14:27:56.627643',13371339,'52efa5fc-b128-4b47-b69b-54da96c20fac','ae529c00-191b-4696-a238-9c8997aa5157','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/125.0.0.0 Safari/537.36','222.130.159.174'),(4,'2024-06-19 14:34:26.939020',13371339,'488b19d3-e00b-4a5b-ac40-51bfb51bba8b','64881057-6929-4650-acf2-c2f32fabbd12','Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/125.0.0.0 Mobile Safari/537.36','222.130.159.174'),(5,'2024-06-19 14:41:18.667784',13371340,'77190d62-10f9-4cae-8978-2de3481a7539','1014f61c-ca50-4fd8-82dd-77929b4906ed','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','223.104.41.225'),(6,'2024-06-19 14:44:40.996106',13371341,NULL,'eb28b4f7-dd9c-4b7e-b0cf-34896df6b062','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','118.113.120.245'),(7,'2024-06-19 14:49:07.737165',13371345,'bb547754-7de4-4179-beb3-38393a15ccd4','26e077f2-9742-4cbe-9908-a35aec5c06d1','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','223.104.122.52'),(8,'2024-06-19 16:01:43.478373',13371340,'ecc882e1-8840-46c6-af30-5fd2bb79672a','ae301ed1-4920-4e8d-ab13-757557eca791','Mozilla/5.0 (iPhone; CPU iPhone OS 17_4_1 like Mac OS X; zh-CN) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/21E236 UCBrowser/16.5.5.2341 Mobile  AliApp(TUnionSDK/0.1.20.4)','124.127.70.185'),(9,'2024-06-19 16:02:06.786519',13371340,'fe6afc65-0861-4e77-bea1-072aeff5c050','ae301ed1-4920-4e8d-ab13-757557eca791','Mozilla/5.0 (iPhone; CPU iPhone OS 17_4_1 like Mac OS X; zh-CN) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/21E236 UCBrowser/16.5.5.2341 Mobile  AliApp(TUnionSDK/0.1.20.4)','124.127.70.185'),(10,'2024-06-19 16:04:16.378803',13371345,'a50e62e2-c5a5-4b14-b6a3-69a60b52adc2','e1bedb61-f25d-456a-9966-115007fc0b0a','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','27.17.70.102'),(11,'2024-06-20 04:31:11.319203',13371341,NULL,'ea38a004-e661-4df5-aebb-f38a45e22c68','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','116.169.10.158'),(12,'2024-06-20 06:03:12.525756',13371341,NULL,'556b0ab9-fb51-437a-8b3c-a4325156c97f','Mozilla/5.0 (iPad; CPU OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','116.169.10.158'),(13,'2024-06-20 09:22:44.599912',13371341,NULL,'d7f7342a-d4cc-4019-a1a6-339e98b3da8c','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','116.169.10.158'),(14,'2024-06-20 16:06:49.776719',13371341,NULL,'b8cd46c4-43a3-441d-9304-34adbd408dba','Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36 Edg/126.0.0.0','119.4.179.152'),(15,'2024-06-20 16:07:14.866770',13371341,NULL,'b8cd46c4-43a3-441d-9304-34adbd408dba','Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36 Edg/126.0.0.0','119.4.179.152'),(16,'2024-06-20 16:07:32.045016',13371341,'dcd44d03-b44e-4d73-9b34-5173fdd6b5f9','b8cd46c4-43a3-441d-9304-34adbd408dba','Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36 Edg/126.0.0.0','119.4.179.152'),(17,'2024-06-20 16:08:05.958214',13371341,'4c6ce095-03a6-444e-855e-2e86851d661e','70739096-7d4a-484b-ba4e-afc343b4cdd6','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','119.4.179.152'),(18,'2024-06-20 16:35:53.613746',13371340,'c95e5628-1978-4a0b-93f9-1b195a8730cf','6cba3edf-a77f-41d2-a1a2-89ba58ad22fa','Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/122.0.6261.95 Safari/537.36','114.250.139.60'),(19,'2024-06-21 08:48:30.155249',13371341,'30bb99d5-3e65-4a24-8a10-a308178b8cc3','eb37810d-0d97-4c6d-aab3-aca5d5649d9b','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36 Edg/114.0.1823.67','211.137.80.13'),(20,'2024-06-24 01:55:57.626841',13371341,'c9f26520-30ea-425e-97ad-82255cc07d55','c063efb6-2a2b-48c2-8941-77a656391a79','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','101.204.219.101'),(21,'2024-06-24 04:46:21.942485',13371341,'c3c227ab-a2bf-479d-8d9d-28a9a16b5c58','f16d848b-47ce-40c7-bd2e-ea02989e24ca','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','116.169.80.229'),(22,'2024-06-24 13:29:32.071113',13371341,'f0439738-430c-466d-ac8f-87b4feae4a5b','556b0ab9-fb51-437a-8b3c-a4325156c97f','Mozilla/5.0 (iPad; CPU OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','101.204.219.101'),(23,'2024-06-26 11:20:42.074401',13371341,'0c0e543a-4f09-4a90-82b8-326b87db1a21','350d08dd-1161-4b10-b27b-3dcb84e213d2','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1','116.169.6.123'),(24,'2024-07-01 16:14:57.944558',13371341,'475bdd75-1719-471b-9d73-803ebf419d62','262dc2fb-0309-4dc9-a373-c14708a49125','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/126.0.2592.78 Version/18.0 Mobile/15E148 Safari/604.1','119.4.68.236'),(25,'2024-07-03 16:04:31.270956',13371339,'2e1e9ff1-bd10-405f-93ce-ff3bb1d1e9b3','64881057-6929-4650-acf2-c2f32fabbd12','Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Mobile Safari/537.36','223.104.41.249'),(26,'2024-07-03 16:16:18.528692',13371345,'2448dfd6-75ee-4316-a6e3-7c938a3ee0aa','e1bedb61-f25d-456a-9966-115007fc0b0a','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','27.19.184.81'),(27,'2024-07-03 17:29:17.603466',13371345,'a7396bb8-fa22-4ba8-8271-46eb631b0b7a','26e077f2-9742-4cbe-9908-a35aec5c06d1','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','183.94.48.151'),(28,'2024-07-04 01:55:18.330553',13371339,'82ab7a60-5631-4261-92e4-3b44b8846ff6','ae529c00-191b-4696-a238-9c8997aa5157','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36','36.112.33.42'),(29,'2024-07-04 07:32:12.575521',13371340,'e6fbf343-bf3d-40bb-95d5-00e021af92be','241dbb92-8c1f-4c99-bac6-9ec666a09dbe','Mozilla/5.0 (iPhone; CPU iPhone OS 17_4_1 like Mac OS X; zh-CN) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/21E236 UCBrowser/16.5.9.2353 Mobile  AliApp(TUnionSDK/0.1.20.4)','114.250.139.60'),(30,'2024-07-04 10:41:59.092830',13371340,'70725e84-b642-47bc-8e23-8e33049a916d','1014f61c-ca50-4fd8-82dd-77929b4906ed','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','223.104.41.177'),(31,'2024-07-04 13:25:46.772665',13371341,'0ecb3c1b-6ad9-4040-9263-b0c03b3e147a','319c0515-9a32-434c-8dbd-d85aebb0d0f1','Mozilla/5.0 (iPad; CPU OS 17_5 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/126.0.2592.86 Version/17.0 Mobile/15E148 Safari/604.1','101.207.187.160'),(32,'2024-07-04 13:31:54.342078',13371341,'140fea25-5132-4915-ae60-f20fb6aaf95d','fab328e3-2f80-45b7-b7a4-04a9a245e51d','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/17.5 Safari/605.1.15','101.207.187.160'),(33,'2024-07-05 11:10:10.512757',13371341,'55d6f65b-d1a9-461f-afb5-d0856b737c99','eb37810d-0d97-4c6d-aab3-aca5d5649d9b','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36 Edg/114.0.1823.67','111.9.5.123'),(34,'2024-07-06 02:02:30.682640',13371341,'265f9ba4-ba19-4096-99f6-8f66fc62add7','b8cd46c4-43a3-441d-9304-34adbd408dba','Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36 Edg/126.0.0.0','101.207.187.160'),(35,'2024-07-15 17:31:32.138192',13371341,'a446500a-960a-4367-bbf1-c7c28272c168','21f23d3e-1e69-488c-aced-822a48462d99','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/126.0.2592.86 Version/18.0 Mobile/15E148 Safari/604.1','119.4.176.197'),(36,'2024-07-17 16:04:34.975266',13371339,'e1246f2b-f130-4526-b355-b9a8ac939c23','64881057-6929-4650-acf2-c2f32fabbd12','Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Mobile Safari/537.36','222.130.159.174'),(37,'2024-07-17 16:45:16.832906',13371345,'ef6a1ab6-ed44-46bd-9997-9ba33f137dac','e1bedb61-f25d-456a-9966-115007fc0b0a','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','27.16.147.239'),(38,'2024-07-18 07:03:07.277693',13371345,'00ede3ee-1dff-4ada-80dd-544f305b6744','26e077f2-9742-4cbe-9908-a35aec5c06d1','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','183.94.49.8'),(39,'2024-07-18 10:40:35.852839',13371339,'0e4d3f2c-5b93-47d3-8006-5084733580a5','ae529c00-191b-4696-a238-9c8997aa5157','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36','36.112.33.42'),(40,'2024-07-18 12:31:22.737291',13371340,'0af4688c-6bdb-4ae2-8081-332e14788053','1014f61c-ca50-4fd8-82dd-77929b4906ed','Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36','39.144.85.123'),(41,'2024-07-19 15:58:53.810165',13371341,'810c0a61-09e1-47ca-bed3-3b323dab9835','fab328e3-2f80-45b7-b7a4-04a9a245e51d','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/18.0 Safari/605.1.15','175.152.46.205'),(42,'2024-07-20 05:47:40.316026',13371341,'4c08b321-559c-4c98-8ecb-57fec02a3851','c487c601-e4a6-4e56-a10e-a8df034524e4','Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/126.0.2592.100 Version/18.0 Mobile/15E148 Safari/604.1','175.152.46.205'),(43,'2024-07-20 14:39:04.894012',13371340,'75578e38-f1be-4ac3-88a9-39b57d910160','f9674346-9523-4666-a631-4d2e655d849d','Mozilla/5.0 (iPhone; CPU iPhone OS 17_4_1 like Mac OS X; zh-CN) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/21E236 UCBrowser/16.6.4.2367 Mobile  AliApp(TUnionSDK/0.1.20.4)','114.253.22.101'),(44,'2024-07-20 14:44:53.756241',13371340,'f0b493dd-0a07-4f0c-be0a-f075e85e5cc1','f9674346-9523-4666-a631-4d2e655d849d','Mozilla/5.0 (iPhone; CPU iPhone OS 17_4_1 like Mac OS X; zh-CN) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/21E236 UCBrowser/16.6.4.2367 Mobile  AliApp(TUnionSDK/0.1.20.4)','114.253.22.101'),(45,'2024-07-21 12:37:10.943891',13371341,'b4b120f8-0be2-425f-8066-fe32027668ed','eb37810d-0d97-4c6d-aab3-aca5d5649d9b','Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36 Edg/114.0.1823.67','112.193.145.102');
/*!40000 ALTER TABLE `login_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `metabase_database`
--

DROP TABLE IF EXISTS `metabase_database`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `metabase_database` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `details` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `engine` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `is_sample` bit(1) NOT NULL DEFAULT b'0',
  `is_full_sync` bit(1) NOT NULL DEFAULT b'1',
  `points_of_interest` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `caveats` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `metadata_sync_schedule` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0 50 * * * ? *' COMMENT 'The cron schedule string for when this database should undergo the metadata sync process (and analysis for new fields).',
  `cache_field_values_schedule` varchar(254) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `timezone` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Timezone identifier for the database, set by the sync process',
  `is_on_demand` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Whether we should do On-Demand caching of FieldValues for this DB. This means FieldValues are updated when their Field is used in a Dashboard or Card param.',
  `auto_run_queries` bit(1) NOT NULL DEFAULT b'1' COMMENT 'Whether to automatically run queries when doing simple filtering and summarizing in the Query Builder.',
  `refingerprint` bit(1) DEFAULT NULL COMMENT 'Whether or not to enable periodic refingerprinting for this Database.',
  `cache_ttl` int DEFAULT NULL COMMENT 'Granular cache TTL for specific database.',
  `initial_sync_status` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'complete' COMMENT 'String indicating whether a database has completed its initial sync and is ready to use',
  `creator_id` int DEFAULT NULL COMMENT 'ID of the admin who added the database',
  `settings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'Serialized JSON containing Database-local Settings for this Database',
  `dbms_version` longtext COLLATE utf8mb4_unicode_ci COMMENT 'A JSON object describing the flavor and version of the DBMS.',
  `is_audit` bit(1) NOT NULL DEFAULT b'0',
  `uploads_enabled` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Whether uploads are enabled for this database',
  `uploads_schema_name` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The schema name for uploads',
  `uploads_table_prefix` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The prefix for upload table names',
  PRIMARY KEY (`id`),
  KEY `fk_database_creator_id` (`creator_id`),
  CONSTRAINT `fk_database_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `metabase_database`
--

LOCK TABLES `metabase_database` WRITE;
/*!40000 ALTER TABLE `metabase_database` DISABLE KEYS */;
INSERT INTO `metabase_database` VALUES (1,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.229352','Sample Database','Some example data for you to play around with.','{\"db\":\"file:/plugins/sample-database.db;USER=GUEST;PASSWORD=guest\"}','h2',_binary '',_binary '','You can find all sorts of different joinable tables ranging from products to people to reviews here.','You probably don\'t want to use this for your business-critical analyses, but hey, it\'s your world, we\'re just living in it.','0 26 * * * ? *','0 0 17 * * ? *','GMT',_binary '\0',_binary '',NULL,NULL,'complete',NULL,NULL,'{\"flavor\":\"H2\",\"version\":\"2.1.214 (2022-06-13)\",\"semantic-version\":[2,1]}',_binary '\0',_binary '\0',NULL,NULL),(2,'2024-06-19 14:18:15.158438','2024-06-19 14:18:30.374485','metabase_bi',NULL,'{\"host\":\"1Panel-mysql-TUA1\",\"port\":3306,\"dbname\":\"metabase_bi\",\"user\":\"root\",\"password\":\"Wishpal_2024\",\"ssl\":false,\"tunnel-enabled\":false,\"advanced-options\":false}','mysql',_binary '\0',_binary '',NULL,NULL,'0 45 * * * ? *','0 0 21 * * ? *','+08:00',_binary '\0',_binary '',NULL,NULL,'complete',13371339,NULL,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}',_binary '\0',_binary '\0',NULL,NULL);
/*!40000 ALTER TABLE `metabase_database` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `metabase_field`
--

DROP TABLE IF EXISTS `metabase_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `metabase_field` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `base_type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `semantic_type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `active` bit(1) NOT NULL DEFAULT b'1',
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `preview_display` bit(1) NOT NULL DEFAULT b'1',
  `position` int NOT NULL DEFAULT '0',
  `table_id` int NOT NULL,
  `parent_id` int DEFAULT NULL,
  `display_name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `visibility_type` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'normal',
  `fk_target_field_id` int DEFAULT NULL,
  `last_analyzed` timestamp(6) NULL DEFAULT NULL,
  `points_of_interest` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `caveats` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `fingerprint` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `fingerprint_version` int NOT NULL DEFAULT '0' COMMENT 'The version of the fingerprint for this Field. Used so we can keep track of which Fields need to be analyzed again when new things are added to fingerprints.',
  `database_type` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `has_field_values` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `settings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `database_position` int NOT NULL DEFAULT '0',
  `custom_position` int NOT NULL DEFAULT '0',
  `effective_type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'The effective type of the field after any coercions.',
  `coercion_strategy` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'A strategy to coerce the base_type into the effective_type.',
  `nfc_path` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Nested field column paths, flattened',
  `database_required` bit(1) NOT NULL DEFAULT b'0',
  `json_unfolding` bit(1) NOT NULL DEFAULT b'0',
  `database_is_auto_increment` bit(1) NOT NULL DEFAULT b'0',
  `database_indexed` bit(1) DEFAULT NULL,
  `database_partitioned` bit(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_uniq_field_table_id_parent_id_name` (`table_id`,`parent_id`,`name`),
  KEY `idx_field_table_id` (`table_id`),
  KEY `idx_field_parent_id` (`parent_id`),
  CONSTRAINT `fk_field_parent_ref_field_id` FOREIGN KEY (`parent_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_field_ref_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=908 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `metabase_field`
--

LOCK TABLES `metabase_field` WRITE;
/*!40000 ALTER TABLE `metabase_field` DISABLE KEYS */;
INSERT INTO `metabase_field` VALUES (1,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','SEATS','type/Integer',NULL,_binary '',NULL,_binary '',6,6,NULL,'Seats','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":102,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":2.4309856865966593,\"q3\":10.553778422458695,\"max\":1325.0,\"sd\":51.198301031505444,\"avg\":16.21763527054108}}}',5,'INTEGER','auto-list',NULL,6,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(2,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','TRIAL_ENDS_AT','type/DateTime',NULL,_binary '',NULL,_binary '',8,6,NULL,'Trial Ends At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1712,\"nil%\":0.001202404809619238},\"type\":{\"type/DateTime\":{\"earliest\":\"2020-09-30T12:00:00Z\",\"latest\":\"2031-10-25T12:00:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,8,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(3,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','CANCELED_AT','type/DateTime','type/CancelationTimestamp',_binary '',NULL,_binary '',9,6,NULL,'Canceled At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2021,\"nil%\":0.1859719438877756},\"type\":{\"type/DateTime\":{\"earliest\":\"2020-10-01T15:43:40Z\",\"latest\":\"2032-06-03T14:01:15Z\"}}}',5,'TIMESTAMP',NULL,NULL,9,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(4,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','PLAN','type/Text','type/Category',_binary '',NULL,_binary '',4,6,NULL,'Plan','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.1062124248497}}}',5,'CHARACTER VARYING','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(5,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ACTIVE_SUBSCRIPTION','type/Boolean','type/Category',_binary '',NULL,_binary '',11,6,NULL,'Active Subscription','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BOOLEAN','auto-list',NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(6,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','LATITUDE','type/Float','type/Latitude',_binary '',NULL,_binary '',13,6,NULL,'Latitude','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2472,\"nil%\":4.008016032064128E-4},\"type\":{\"type/Number\":{\"min\":-48.75,\"q1\":19.430679334308675,\"q3\":47.24585743676113,\"max\":69.23111,\"sd\":23.492041679980137,\"avg\":31.35760681046913}}}',5,'DOUBLE PRECISION',NULL,NULL,13,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(7,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ID','type/BigInteger','type/PK',_binary '',NULL,_binary '',0,6,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(8,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','LEGACY_PLAN','type/Boolean','type/Category',_binary '',NULL,_binary '',12,6,NULL,'Legacy Plan','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BOOLEAN','auto-list',NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(9,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','FIRST_NAME','type/Text','type/Name',_binary '',NULL,_binary '',2,6,NULL,'First Name','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1687,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.001603206412825651,\"average-length\":5.997595190380761}}}',5,'CHARACTER VARYING',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(10,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','LAST_NAME','type/Text','type/Name',_binary '',NULL,_binary '',3,6,NULL,'Last Name','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":473,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.536673346693386}}}',5,'CHARACTER VARYING','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(11,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','SOURCE','type/Text','type/Source',_binary '',NULL,_binary '',5,6,NULL,'Source','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.3346693386773547},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.4705410821643286}}}',5,'CHARACTER VARYING','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(12,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','EMAIL','type/Text','type/Email',_binary '',NULL,_binary '',1,6,NULL,'Email','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2494,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":1.0,\"percent-state\":0.0,\"average-length\":28.185971943887775}}}',5,'CHARACTER VARYING',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(13,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','CREATED_AT','type/DateTime','type/CreationTimestamp',_binary '',NULL,_binary '',7,6,NULL,'Created At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2495,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2020-09-15T16:11:50Z\",\"latest\":\"2031-10-10T19:14:48Z\"}}}',5,'TIMESTAMP',NULL,NULL,7,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(14,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','TRIAL_CONVERTED','type/Boolean','type/Category',_binary '',NULL,_binary '',10,6,NULL,'Trial Converted','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BOOLEAN','auto-list',NULL,10,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(15,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','COUNTRY','type/Text','type/Country',_binary '',NULL,_binary '',15,6,NULL,'Country','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":134,\"nil%\":8.016032064128256E-4},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.1130260521042084,\"average-length\":1.9983967935871743}}}',5,'CHARACTER','auto-list',NULL,15,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(16,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','LONGITUDE','type/Float','type/Longitude',_binary '',NULL,_binary '',14,6,NULL,'Longitude','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2484,\"nil%\":4.008016032064128E-4},\"type\":{\"type/Number\":{\"min\":-175.06667,\"q1\":-55.495929410727236,\"q3\":28.627359769389155,\"max\":176.21667,\"sd\":68.51011002740533,\"avg\":2.6042336031796345}}}',5,'DOUBLE PRECISION',NULL,NULL,14,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(17,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','EVENT','type/Text','type/Category',_binary '',NULL,_binary '',2,1,NULL,'Event','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":11.3906}}}',5,'CHARACTER VARYING','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(18,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','PAGE_URL','type/Text','type/URL',_binary '',NULL,_binary '',4,1,NULL,'Page URL','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":6,\"nil%\":0.1302},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":22.2674}}}',5,'CHARACTER VARYING','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(19,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','BUTTON_LABEL','type/Text','type/Category',_binary '',NULL,_binary '',5,1,NULL,'Button Label','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":6,\"nil%\":0.8698},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":1.0552}}}',5,'CHARACTER VARYING','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(20,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ID','type/BigInteger','type/PK',_binary '',NULL,_binary '',0,1,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(21,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ACCOUNT_ID','type/BigInteger','type/FK',_binary '',NULL,_binary '',1,1,NULL,'Account ID','normal',7,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":589,\"nil%\":0.0}}',5,'BIGINT',NULL,NULL,1,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(22,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','TIMESTAMP','type/DateTime',NULL,_binary '',NULL,_binary '',3,1,NULL,'Timestamp','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":8576,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-03-15T00:18:25Z\",\"latest\":\"2022-04-11T20:24:02Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(23,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','RATING','type/Integer','type/Score',_binary '',NULL,_binary '',4,2,NULL,'Rating','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":2.7545289729206877,\"q3\":4.004191340512663,\"max\":5.0,\"sd\":0.8137255616667736,\"avg\":3.3629283489096573}}}',5,'SMALLINT','auto-list',NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(24,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ID','type/BigInteger','type/PK',_binary '',NULL,_binary '',0,2,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(25,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ACCOUNT_ID','type/BigInteger','type/FK',_binary '',NULL,_binary '',1,2,NULL,'Account ID','normal',7,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":642,\"nil%\":0.0}}',5,'BIGINT',NULL,NULL,1,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(26,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','EMAIL','type/Text','type/Email',_binary '',NULL,_binary '',2,2,NULL,'Email','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":642,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":1.0,\"percent-state\":0.0,\"average-length\":28.327102803738317}}}',5,'CHARACTER VARYING','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(27,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','BODY','type/Text',NULL,_binary '',NULL,_binary '\0',6,2,NULL,'Body','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":642,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":438.15264797507785}}}',5,'CHARACTER LARGE OBJECT',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(28,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','RATING_MAPPED','type/Text','type/Category',_binary '',NULL,_binary '',5,2,NULL,'Rating Mapped','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.453271028037383}}}',5,'CHARACTER VARYING','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(29,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','DATE_RECEIVED','type/DateTime',NULL,_binary '',NULL,_binary '',3,2,NULL,'Date Received','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":576,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2020-11-20T00:00:00Z\",\"latest\":\"2031-12-01T00:00:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(30,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','PLAN','type/Text','type/Category',_binary '',NULL,_binary '',4,7,NULL,'Plan','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.2931}}}',5,'CHARACTER VARYING','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(31,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ID','type/BigInteger','type/PK',_binary '',NULL,_binary '',0,7,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(32,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','ACCOUNT_ID','type/BigInteger','type/FK',_binary '',NULL,_binary '',1,7,NULL,'Account ID','normal',7,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1449,\"nil%\":0.0}}',5,'BIGINT',NULL,NULL,1,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(33,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','DATE_RECEIVED','type/DateTime',NULL,_binary '',NULL,_binary '',5,7,NULL,'Date Received','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":714,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2020-09-30T00:00:00Z\",\"latest\":\"2027-05-02T00:00:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,5,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(34,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','PAYMENT','type/Float',NULL,_binary '',NULL,_binary '',2,7,NULL,'Payment','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":707,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":13.7,\"q1\":233.1870107122195,\"q3\":400.5965814842149,\"max\":33714.6,\"sd\":763.7961603932441,\"avg\":519.4153400000004}}}',5,'DOUBLE PRECISION',NULL,NULL,2,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(35,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','EXPECTED_INVOICE','type/Boolean','type/Category',_binary '',NULL,_binary '',3,7,NULL,'Expected Invoice','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BOOLEAN','auto-list',NULL,3,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(36,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.421341','DISCOUNT','type/Float','type/Discount',_binary '','Discount amount.',_binary '',6,5,NULL,'Discount','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":701,\"nil%\":0.898},\"type\":{\"type/Number\":{\"min\":0.17088996672584322,\"q1\":2.9786226681458743,\"q3\":7.338187788658235,\"max\":61.69684269960571,\"sd\":3.053663125001991,\"avg\":5.161255547580326}}}',5,'DOUBLE PRECISION',NULL,NULL,6,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(37,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.329057','ID','type/BigInteger','type/PK',_binary '','This is a unique ID for the product. It is also called the “Invoice number” or “Confirmation number” in customer facing emails and screens.',_binary '',0,5,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(38,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.287512','TAX','type/Float',NULL,_binary '','This is the amount of local and federal taxes that are collected on the purchase. Note that other governmental fees on some products are not included here, but instead are accounted for in the subtotal.',_binary '',4,5,NULL,'Tax','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":797,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":2.273340386603857,\"q3\":5.337275338216307,\"max\":11.12,\"sd\":2.3206651358900316,\"avg\":3.8722100000000004}}}',5,'DOUBLE PRECISION',NULL,NULL,4,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(39,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.398115','QUANTITY','type/Integer','type/Quantity',_binary '','Number of products bought.',_binary '',8,5,NULL,'Quantity','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":62,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":1.755882607764982,\"q3\":4.882654507928044,\"max\":100.0,\"sd\":4.214258386403798,\"avg\":3.7015}}}',5,'INTEGER','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(40,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.238445','PRODUCT_ID','type/Integer','type/FK',_binary '','The product ID. This is an internal identifier for the product, NOT the SKU.',_binary '',2,5,NULL,'Product ID','normal',62,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":200,\"nil%\":0.0}}',5,'INTEGER',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(41,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.446889','CREATED_AT','type/DateTime','type/CreationTimestamp',_binary '','The date and time an order was submitted.',_binary '',7,5,NULL,'Created At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}}',5,'TIMESTAMP',NULL,NULL,7,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(42,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.309650','TOTAL','type/Float',NULL,_binary '','The total billed amount.',_binary '',5,5,NULL,'Total','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4426,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":8.93914247937167,\"q1\":51.34535490743823,\"q3\":110.29428389265787,\"max\":159.34900526552292,\"sd\":34.26469575709948,\"avg\":80.35871658771228}}}',5,'DOUBLE PRECISION',NULL,NULL,5,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(43,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.349539','USER_ID','type/Integer','type/FK',_binary '','The id of the user who made this order. Note that in some cases where an order was created on behalf of a customer who phoned the order in, this might be the employee who handled the request.',_binary '',1,5,NULL,'User ID','normal',46,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":929,\"nil%\":0.0}}',5,'INTEGER',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(44,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.266047','SUBTOTAL','type/Float',NULL,_binary '','The raw, pre-tax cost of the order. Note that this might be different in the future from the product price due to promotions, credits, etc.',_binary '',3,5,NULL,'Subtotal','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":340,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":15.691943673970439,\"q1\":49.74894519060184,\"q3\":105.42965746993103,\"max\":148.22900526552291,\"sd\":32.53705013056317,\"avg\":77.01295465356547}}}',5,'DOUBLE PRECISION',NULL,NULL,3,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(45,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.642663','SOURCE','type/Text','type/Source',_binary '','The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter',_binary '',8,3,NULL,'Source','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.4084}}}',5,'CHARACTER VARYING','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(46,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.706911','ID','type/BigInteger','type/PK',_binary '','A unique identifier given to each user.',_binary '',0,3,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(47,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.548936','NAME','type/Text','type/Name',_binary '','The name of the user who owns an account',_binary '',4,3,NULL,'Name','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2499,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.532}}}',5,'CHARACTER VARYING',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(48,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.618885','STATE','type/Text','type/State',_binary '','The state or province of the account’s billing address',_binary '',7,3,NULL,'State','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":49,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":1.0,\"average-length\":2.0}}}',5,'CHARACTER','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(49,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.669117','BIRTH_DATE','type/Date',NULL,_binary '','The date of birth of the user',_binary '',9,3,NULL,'Birth Date','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2308,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"1958-04-26\",\"latest\":\"2000-04-03\"}}}',5,'DATE',NULL,NULL,9,0,'type/Date',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(50,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.595976','LONGITUDE','type/Float','type/Longitude',_binary '','This is the longitude of the user on sign-up. It might be updated in the future to the last seen location.',_binary '',6,3,NULL,'Longitude','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2491,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-166.5425726,\"q1\":-101.58350792373135,\"q3\":-84.65289348288829,\"max\":-67.96735199999999,\"sd\":15.399698968175663,\"avg\":-95.18741780363999}}}',5,'DOUBLE PRECISION',NULL,NULL,6,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(51,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.507401','EMAIL','type/Text','type/Email',_binary '','The contact email for the account.',_binary '',2,3,NULL,'Email','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":1.0,\"percent-state\":0.0,\"average-length\":24.1824}}}',5,'CHARACTER VARYING',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(52,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.488653','ADDRESS','type/Text',NULL,_binary '','The street address of the account’s billing address',_binary '',1,3,NULL,'Address','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2490,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":20.85}}}',5,'CHARACTER VARYING',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(53,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.528121','PASSWORD','type/Text',NULL,_binary '','This is the salted password of the user. It should not be visible',_binary '',3,3,NULL,'Password','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":36.0}}}',5,'CHARACTER VARYING',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(54,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.122878','ZIP','type/Text','type/ZipCode',_binary '','The postal code of the account’s billing address',_binary '',10,3,NULL,'Zip','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2234,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.0}}}',5,'CHARACTER',NULL,NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(55,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.569057','CITY','type/Text','type/City',_binary '','The city of the account’s billing address',_binary '',5,3,NULL,'City','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1966,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.002,\"average-length\":8.284}}}',5,'CHARACTER VARYING',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(56,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.746288','CREATED_AT','type/DateTime','type/CreationTimestamp',_binary '','The date the user record was created. Also referred to as the user’s \"join date\"',_binary '',12,3,NULL,'Created At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-19T21:35:18.752Z\",\"latest\":\"2025-04-19T14:06:27.3Z\"}}}',5,'TIMESTAMP',NULL,NULL,12,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(57,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.726900','LATITUDE','type/Float','type/Latitude',_binary '','This is the latitude of the user on sign-up. It might be updated in the future to the last seen location.',_binary '',11,3,NULL,'Latitude','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2491,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":25.775827,\"q1\":35.302705923023126,\"q3\":43.773802584662,\"max\":70.6355001,\"sd\":6.390832341883712,\"avg\":39.87934670484002}}}',5,'DOUBLE PRECISION',NULL,NULL,11,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(58,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.784306','CATEGORY','type/Text','type/Category',_binary '','The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget',_binary '',3,8,NULL,'Category','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}}',5,'CHARACTER VARYING','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(59,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.867715','PRICE','type/Float',NULL,_binary '','The list price of the product. Note that this is not always the price the product sold for due to discounts, promotions, etc.',_binary '',5,8,NULL,'Price','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":170,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":15.691943673970439,\"q1\":37.25154462926434,\"q3\":75.45898071609447,\"max\":98.81933684368194,\"sd\":21.711481557852057,\"avg\":55.74639966792074}}}',5,'DOUBLE PRECISION',NULL,NULL,5,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(60,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.922944','VENDOR','type/Text','type/Company',_binary '','The source of the product.',_binary '',4,8,NULL,'Vendor','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":200,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":20.6}}}',5,'CHARACTER VARYING','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(61,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.892614','RATING','type/Float','type/Score',_binary '','The average rating users have given the product. This ranges from 1 - 5',_binary '',6,8,NULL,'Rating','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":23,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":3.5120465053408525,\"q3\":4.216124969497314,\"max\":5.0,\"sd\":1.3605488657451452,\"avg\":3.4715}}}',5,'DOUBLE PRECISION',NULL,NULL,6,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(62,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.849673','ID','type/BigInteger','type/PK',_binary '','The numerical product number. Only used internally. All external communication should use the title or EAN.',_binary '',0,8,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(63,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.824136','EAN','type/Text',NULL,_binary '','The international article number. A 13 digit number uniquely identifying the product.',_binary '',1,8,NULL,'Ean','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":200,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.0}}}',5,'CHARACTER','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(64,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.803208','CREATED_AT','type/DateTime','type/CreationTimestamp',_binary '','The date the product was added to our catalog.',_binary '',7,8,NULL,'Created At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":200,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-26T19:29:55.147Z\",\"latest\":\"2025-04-15T13:34:19.931Z\"}}}',5,'TIMESTAMP',NULL,NULL,7,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(65,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.907927','TITLE','type/Text','type/Title',_binary '','The name of the product as it should be displayed to customers.',_binary '',2,8,NULL,'Title','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":199,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.495}}}',5,'CHARACTER VARYING','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(66,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.045471','RATING','type/Integer','type/Score',_binary '','The rating (on a scale of 1-5) the user left.',_binary '',3,4,NULL,'Rating','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":3.54744353181696,\"q3\":4.764807071650455,\"max\":5.0,\"sd\":1.0443899855660577,\"avg\":3.987410071942446}}}',5,'SMALLINT','auto-list',NULL,3,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(67,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.142325','BODY','type/Text','type/Description',_binary '','The review the user left. Limited to 2000 characters.',_binary '',4,4,NULL,'Body','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1112,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":177.41996402877697}}}',5,'CHARACTER VARYING',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(68,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.003394','ID','type/BigInteger','type/PK',_binary '','A unique internal identifier for the review. Should not be used externally.',_binary '',0,4,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,0,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(69,'2024-06-19 14:13:29.000000','2024-06-19 14:13:32.986120','CREATED_AT','type/DateTime','type/CreationTimestamp',_binary '','The day and time a review was written by a user.',_binary '',5,4,NULL,'Created At','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1112,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-06-03T00:37:05.818Z\",\"latest\":\"2026-04-19T14:15:25.677Z\"}}}',5,'TIMESTAMP',NULL,NULL,5,0,'type/DateTime',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(70,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.083653','REVIEWER','type/Text',NULL,_binary '','The user who left the review',_binary '',2,4,NULL,'Reviewer','normal',NULL,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1076,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.001798561151079137,\"average-length\":9.972122302158274}}}',5,'CHARACTER VARYING',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(71,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.025534','PRODUCT_ID','type/Integer','type/FK',_binary '','The product the review was for',_binary '',1,4,NULL,'Product ID','normal',62,'2024-06-19 14:13:29.000000',NULL,NULL,'{\"global\":{\"distinct-count\":176,\"nil%\":0.0}}',5,'INTEGER',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(72,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','model_id','type/Integer','type/FK',_binary '',NULL,_binary '',4,30,NULL,'Model ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(73,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the action was created',_binary '',1,30,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(74,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','type','type/Text',NULL,_binary '','Type of action',_binary '',3,30,NULL,'Type','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(75,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','public_uuid','type/Text',NULL,_binary '','Unique UUID used to in publically-accessible links to this Action.',_binary '',10,30,NULL,'Public UUID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(76,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',14,30,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(77,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','name','type/Text',NULL,_binary '',NULL,_binary '',5,30,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(78,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,30,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(79,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','creator_id','type/Integer','type/FK',_binary '','The user who created the action',_binary '',12,30,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,12,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(80,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','archived','type/Boolean',NULL,_binary '',NULL,_binary '',13,30,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,13,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(81,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','parameter_mappings','type/Text',NULL,_binary '','The saved parameter mappings for this action',_binary '',8,30,NULL,'Parameter Mappings','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(82,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','made_public_by_id','type/Integer','type/FK',_binary '','The ID of the User who first publically shared this Action.',_binary '',11,30,NULL,'Made Public By ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,11,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(83,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','description','type/Text',NULL,_binary '','The description of the action',_binary '',6,30,NULL,'Description','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(84,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','visualization_settings','type/Text',NULL,_binary '','The UI visualization_settings for this action',_binary '',9,30,NULL,'Visualization Settings','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(85,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','parameters','type/Text',NULL,_binary '','The saved parameters for this action',_binary '',7,30,NULL,'Parameters','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(86,'2024-06-19 14:18:19.251925','2024-06-19 14:18:27.427077','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the action was updated',_binary '',2,30,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(87,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp when the key was created',_binary '',5,107,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,5,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(88,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','name','type/Text',NULL,_binary '','The user-defined name of the API key.',_binary '',7,107,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(89,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','updated_by_id','type/Integer','type/FK',_binary '','The ID of the user that last updated this API key',_binary '',8,107,NULL,'Updated By ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,8,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(90,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp when the key was last updated',_binary '',6,107,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(91,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','user_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,107,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(92,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','scope','type/Text',NULL,_binary '','The scope of the API key, if applicable',_binary '',9,107,NULL,'Scope','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(93,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','key_prefix','type/Text',NULL,_binary '','The first 7 characters of the unhashed key',_binary '',3,107,NULL,'Key Prefix','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(94,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',4,107,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(95,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','key','type/Text',NULL,_binary '','The hashed API key',_binary '',2,107,NULL,'Key','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(96,'2024-06-19 14:18:19.332432','2024-06-19 14:18:30.280358','id','type/Integer','type/PK',_binary '','The ID of the API Key itself',_binary '',0,107,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(97,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','details','type/Text',NULL,_binary '','A JSON map with metadata about the event',_binary '',7,19,NULL,'Details','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(98,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','topic','type/Text',NULL,_binary '','The topic of a given audit event',_binary '',1,19,NULL,'Topic','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(99,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,19,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(100,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','model','type/Text',NULL,_binary '','The name of the model this event applies to (e.g. Card, Dashboard), if applicable',_binary '',5,19,NULL,'Model','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(101,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','model_id','type/Integer',NULL,_binary '','The ID of the model this event applies to, if applicable',_binary '',6,19,NULL,'Model ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,6,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(102,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','user_id','type/Integer',NULL,_binary '','The user who performed an action or triggered an event',_binary '',4,19,NULL,'User ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(103,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','end_timestamp','type/DateTimeWithLocalTZ',NULL,_binary '','The time an event ended, if applicable',_binary '',3,19,NULL,'End Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(104,'2024-06-19 14:18:19.411456','2024-06-19 14:18:27.114388','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '','The time an event was recorded',_binary '',2,19,NULL,'Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(105,'2024-06-19 14:18:19.489339','2024-06-19 14:18:29.293670','user_id','type/Integer','type/FK',_binary '','ID of the User who ordered bookmarks',_binary '',1,80,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(106,'2024-06-19 14:18:19.489339','2024-06-19 14:18:29.293670','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,80,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(107,'2024-06-19 14:18:19.489339','2024-06-19 14:18:29.293670','type','type/Text',NULL,_binary '','type of the Bookmark',_binary '',2,80,NULL,'Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(108,'2024-06-19 14:18:19.489339','2024-06-19 14:18:29.293670','item_id','type/Integer',NULL,_binary '','id of the item being bookmarked (Card, Collection, Dashboard, ...) no FK, so may no longer exist',_binary '',3,80,NULL,'Item ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(109,'2024-06-19 14:18:19.489339','2024-06-19 14:18:29.293670','ordering','type/Integer',NULL,_binary '','order of bookmark for user',_binary '',4,80,NULL,'Ordering','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(110,'2024-06-19 14:18:19.548923','2024-06-19 14:18:26.976131','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,15,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(111,'2024-06-19 14:18:19.548923','2024-06-19 14:18:26.976131','user_id','type/Integer','type/FK',_binary '','ID of the User who bookmarked the Card',_binary '',1,15,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(112,'2024-06-19 14:18:19.548923','2024-06-19 14:18:26.976131','card_id','type/Integer','type/FK',_binary '','ID of the Card bookmarked by the user',_binary '',2,15,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(113,'2024-06-19 14:18:19.548923','2024-06-19 14:18:26.976131','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the bookmark was created',_binary '',3,15,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(114,'2024-06-19 14:18:19.600642','2024-06-19 14:18:30.239094','label_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,106,NULL,'Label ID','normal',226,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(115,'2024-06-19 14:18:19.600642','2024-06-19 14:18:30.239094','card_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,106,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(116,'2024-06-19 14:18:19.600642','2024-06-19 14:18:30.239094','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,106,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(117,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','progress','type/Integer',NULL,_binary '','Number between 0 to 100 representing progress as a percentage',_binary '',4,97,NULL,'Progress','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(118,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','external_id','type/Text',NULL,_binary '','Matching ID in Cloud for this migration',_binary '',1,97,NULL,'External ID','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(119,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','Timestamp when the config was updated',_binary '',6,97,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(120,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','Timestamp when the config was inserted',_binary '',5,97,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,5,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(121,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','id','type/Integer','type/PK',_binary '','Unique ID',_binary '',0,97,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(122,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','state','type/Text',NULL,_binary '','Current state of the migration: init, setup, dump, upload, done, error, cancelled',_binary '',3,97,NULL,'State','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(123,'2024-06-19 14:18:19.660668','2024-06-19 14:18:29.973094','upload_url','type/Text',NULL,_binary '','URL where the backup will be uploaded to',_binary '',2,97,NULL,'Upload URL','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(124,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '','Timestamp of when this Collection was created.',_binary '',10,91,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:21.604528Z\"}}}',5,'TIMESTAMP',NULL,NULL,10,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(125,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','slug','type/Text','type/Category',_binary '',NULL,_binary '',6,91,NULL,'Slug','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":35.0}}}',5,'VARCHAR','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(126,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','authority_level','type/Text','type/Author',_binary '','Nullable column to incidate collection\'s authority level. Initially values are \"official\" and nil.',_binary '',8,91,NULL,'Authority Level','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(127,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','personal_owner_id','type/Integer','type/FK',_binary '','If set, this Collection is a personal Collection, for exclusive use of the User with this ID.',_binary '',5,91,NULL,'Personal Owner ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5}}',5,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(128,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','entity_id','type/Text','type/Category',_binary '','Random NanoID tag for unique identity.',_binary '',9,91,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.0}}}',5,'CHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(129,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','archived','type/Boolean','type/Category',_binary '','Whether this Collection has been archived and should be hidden from users.',_binary '',3,91,NULL,'Archived','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,3,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(130,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','location','type/Text','type/Category',_binary '','Directory-structure path of ancestor Collections. e.g. \"/1/2/\" means our Parent is Collection 2, and their parent is Collection 1.',_binary '',4,91,NULL,'Location','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":1.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(131,'2024-06-19 14:18:19.712968','2024-06-19 14:18:29.775440','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,91,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(132,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',1,91,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":11.0}}}',5,'LONGTEXT','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(133,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','is_sample','type/Boolean','type/Category',_binary '','Is the collection part of the sample content?',_binary '',12,91,NULL,'Is Sample','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(134,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',2,91,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(135,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','namespace','type/Text',NULL,_binary '','The namespace (hierachy) this Collection belongs to. NULL means the Collection is in the default namespace.',_binary '',7,91,NULL,'Namespace','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(136,'2024-06-19 14:18:19.712968','2024-06-19 14:18:48.863736','type','type/Text','type/Category',_binary '','This is used to differentiate instance-analytics collections from all other collections.',_binary '',11,91,NULL,'Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(137,'2024-06-19 14:18:19.775636','2024-06-19 14:18:28.149189','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,54,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(138,'2024-06-19 14:18:19.775636','2024-06-19 14:18:28.149189','collection_id','type/Integer','type/FK',_binary '','ID of the Card bookmarked by the user',_binary '',2,54,NULL,'Collection ID','normal',131,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(139,'2024-06-19 14:18:19.775636','2024-06-19 14:18:28.149189','user_id','type/Integer','type/FK',_binary '','ID of the User who bookmarked the Collection',_binary '',1,54,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(140,'2024-06-19 14:18:19.775636','2024-06-19 14:18:28.149189','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the bookmark was created',_binary '',3,54,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(141,'2024-06-19 14:18:19.842676','2024-06-19 14:18:29.918898','db_id','type/Integer','type/FK',_binary '','ID of the database this connection impersonation policy affects',_binary '',1,95,NULL,'Db ID','normal',250,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(142,'2024-06-19 14:18:19.842676','2024-06-19 14:18:29.918898','group_id','type/Integer','type/FK',_binary '','ID of the permissions group this connection impersonation policy affects',_binary '',2,95,NULL,'Group ID','normal',386,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(143,'2024-06-19 14:18:19.842676','2024-06-19 14:18:29.918898','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,95,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(144,'2024-06-19 14:18:19.842676','2024-06-19 14:18:29.918898','attribute','type/Text',NULL,_binary '','User attribute associated with the database role to use for this connection impersonation policy',_binary '',3,95,NULL,'Attribute','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(145,'2024-06-19 14:18:19.900290','2024-06-19 14:18:28.104860','id','type/Text','type/PK',_binary '',NULL,_binary '',0,51,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(146,'2024-06-19 14:18:19.900290','2024-06-19 14:18:48.863736','anti_csrf_token','type/Text',NULL,_binary '',NULL,_binary '',3,51,NULL,'Anti Csrf Token','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(147,'2024-06-19 14:18:19.900290','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',2,51,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:17:10.776124Z\",\"latest\":\"2024-06-19T14:17:10.776124Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(148,'2024-06-19 14:18:19.900290','2024-06-19 14:18:48.863736','user_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,51,NULL,'User ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(149,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','reset_token','type/Text',NULL,_binary '',NULL,_binary '',10,23,NULL,'Reset Token','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(150,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','locale','type/Text',NULL,_binary '','Preferred ISO locale (language/country) code, e.g \"en\" or \"en-US\", for this User. Overrides site default.',_binary '',16,23,NULL,'Locale','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,16,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(151,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','password_salt','type/Text','type/Category',_binary '',NULL,_binary '',5,23,NULL,'Password Salt','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":36.0}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(152,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',14,23,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:17:10.848325Z\",\"latest\":\"2024-06-19T14:17:10.848325Z\"}}}',5,'TIMESTAMP',NULL,NULL,14,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(153,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','type','type/Text','type/Category',_binary '','The type of user',_binary '',19,23,NULL,'Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.0}}}',5,'VARCHAR','auto-list',NULL,19,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(154,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','email','type/Text','type/Email',_binary '',NULL,_binary '',1,23,NULL,'Email','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":1.0,\"percent-state\":0.0,\"average-length\":20.0}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(155,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','settings','type/Text','type/Category',_binary '','Serialized JSON containing User-local Settings for this User',_binary '',18,23,NULL,'Settings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Text\":{\"percent-json\":0.5,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":19.5}}}',5,'LONGTEXT','auto-list',NULL,18,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(156,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','first_name','type/Text','type/Name',_binary '',NULL,_binary '',2,23,NULL,'First Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.5}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(157,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','sso_source','type/Text','type/Source',_binary '','String to indicate the SSO backend the user is from',_binary '',15,23,NULL,'Sso Source','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,15,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(158,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','password','type/Text','type/Category',_binary '',NULL,_binary '',4,23,NULL,'Password','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":60.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(159,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','reset_triggered','type/BigInteger',NULL,_binary '',NULL,_binary '',11,23,NULL,'Reset Triggered','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'BIGINT','auto-list',NULL,11,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(160,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','date_joined','type/DateTimeWithLocalTZ','type/JoinTimestamp',_binary '',NULL,_binary '',6,23,NULL,'Date Joined','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:27Z\",\"latest\":\"2024-06-19T14:17:10Z\"}}}',5,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(161,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','is_qbnewb','type/Boolean','type/Category',_binary '',NULL,_binary '',12,23,NULL,'Is Qbnewb','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(162,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','last_name','type/Text','type/Name',_binary '',NULL,_binary '',3,23,NULL,'Last Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.5}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(163,'2024-06-19 14:18:19.973897','2024-06-19 14:18:27.218616','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,23,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(164,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','last_login','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',7,23,NULL,'Last Login','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:17:10Z\",\"latest\":\"2024-06-19T14:17:10Z\"}}}',5,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(165,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','is_superuser','type/Boolean','type/Category',_binary '',NULL,_binary '',8,23,NULL,'Is Superuser','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,8,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(166,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','login_attributes','type/Text',NULL,_binary '',NULL,_binary '',13,23,NULL,'Login Attributes','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(167,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','entity_id','type/Text','type/Category',_binary '','NanoID tag for each user',_binary '',20,23,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":10.5}}}',5,'CHAR','auto-list',NULL,20,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(168,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','is_datasetnewb','type/Boolean','type/Category',_binary '',NULL,_binary '',17,23,NULL,'Is Datasetnewb','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,17,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(169,'2024-06-19 14:18:19.973897','2024-06-19 14:18:48.863736','is_active','type/Boolean','type/Category',_binary '',NULL,_binary '',9,23,NULL,'Is Active','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,9,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(170,'2024-06-19 14:18:20.046451','2024-06-19 14:18:27.043858','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,17,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(171,'2024-06-19 14:18:20.046451','2024-06-19 14:18:27.043858','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the bookmark was created',_binary '',3,17,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(172,'2024-06-19 14:18:20.046451','2024-06-19 14:18:27.043858','user_id','type/Integer','type/FK',_binary '','ID of the User who bookmarked the Dashboard',_binary '',1,17,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(173,'2024-06-19 14:18:20.046451','2024-06-19 14:18:27.043858','dashboard_id','type/Integer','type/FK',_binary '','ID of the Dashboard bookmarked by the user',_binary '',2,17,NULL,'Dashboard ID','normal',614,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(174,'2024-06-19 14:18:20.102154','2024-06-19 14:18:30.075078','user_id','type/Integer','type/FK',_binary '','ID of the User who favorited the Dashboard.',_binary '',1,101,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(175,'2024-06-19 14:18:20.102154','2024-06-19 14:18:30.075078','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,101,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(176,'2024-06-19 14:18:20.102154','2024-06-19 14:18:30.075078','dashboard_id','type/Integer','type/FK',_binary '','ID of the Dashboard favorited by the User.',_binary '',2,101,NULL,'Dashboard ID','normal',614,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(177,'2024-06-19 14:18:20.158289','2024-06-19 14:18:29.548637','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,83,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(178,'2024-06-19 14:18:20.158289','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '','Displayed name of the tab',_binary '',2,83,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.666666666666666}}}',5,'LONGTEXT','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(179,'2024-06-19 14:18:20.158289','2024-06-19 14:18:48.863736','entity_id','type/Text','type/Category',_binary '',NULL,_binary '',4,83,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.0}}}',5,'CHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(180,'2024-06-19 14:18:20.158289','2024-06-19 14:18:48.863736','position','type/Integer','type/Category',_binary '','Position of the tab with respect to others tabs in dashboard',_binary '',3,83,NULL,'Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.25,\"q3\":1.75,\"max\":2.0,\"sd\":1.0,\"avg\":1.0}}}',5,'INT','auto-list',NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(181,'2024-06-19 14:18:20.158289','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '','The timestamp at which the tab was created',_binary '',5,83,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,5,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(182,'2024-06-19 14:18:20.158289','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '','The timestamp at which the tab was last updated',_binary '',6,83,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(183,'2024-06-19 14:18:20.158289','2024-06-19 14:18:48.863736','dashboard_id','type/Integer','type/FK',_binary '','The dashboard that a tab is on',_binary '',1,83,NULL,'Dashboard ID','normal',614,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(184,'2024-06-19 14:18:20.229201','2024-06-19 14:18:28.226110','dashboardcard_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,57,NULL,'Dashboardcard ID','normal',625,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(185,'2024-06-19 14:18:20.229201','2024-06-19 14:18:28.226110','position','type/Integer',NULL,_binary '',NULL,_binary '',3,57,NULL,'Position','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(186,'2024-06-19 14:18:20.229201','2024-06-19 14:18:28.226110','card_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,57,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(187,'2024-06-19 14:18:20.229201','2024-06-19 14:18:28.226110','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,57,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(188,'2024-06-19 14:18:20.271932','2024-06-19 14:18:29.948512','id','type/Integer','type/PK',_binary '','The ID of the permission',_binary '',0,96,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(189,'2024-06-19 14:18:20.271932','2024-06-19 14:18:48.863736','db_id','type/Integer','type/FK',_binary '','A database ID, for DB and table-level permissions',_binary '',3,96,NULL,'Db ID','normal',250,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(190,'2024-06-19 14:18:20.271932','2024-06-19 14:18:48.863736','table_id','type/Integer','type/FK',_binary '','A table ID',_binary '',5,96,NULL,'Table ID','normal',314,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(191,'2024-06-19 14:18:20.271932','2024-06-19 14:18:48.863736','perm_type','type/Text','type/Category',_binary '','The type of the permission (e.g. \"data\", \"collection\", \"download\"...)',_binary '',2,96,NULL,'Perm Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.0}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(192,'2024-06-19 14:18:20.271932','2024-06-19 14:18:48.863736','group_id','type/Integer','type/FK',_binary '','The ID of the associated permission group',_binary '',1,96,NULL,'Group ID','normal',386,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(193,'2024-06-19 14:18:20.271932','2024-06-19 14:18:48.863736','perm_value','type/Text','type/Category',_binary '','The value this permission is set to.',_binary '',6,96,NULL,'Perm Value','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":11.2}}}',5,'VARCHAR','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(194,'2024-06-19 14:18:20.271932','2024-06-19 14:18:48.863736','schema_name','type/Text',NULL,_binary '','A schema name, for table-level permissions',_binary '',4,96,NULL,'Schema Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(195,'2024-06-19 14:18:20.320236','2024-06-19 14:18:27.536327','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',5,34,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,5,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(196,'2024-06-19 14:18:20.320236','2024-06-19 14:18:27.536327','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,34,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(197,'2024-06-19 14:18:20.320236','2024-06-19 14:18:27.536327','dependent_on_id','type/Integer',NULL,_binary '',NULL,_binary '',4,34,NULL,'Dependent On ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(198,'2024-06-19 14:18:20.320236','2024-06-19 14:18:27.536327','model','type/Text',NULL,_binary '',NULL,_binary '',1,34,NULL,'Model','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(199,'2024-06-19 14:18:20.320236','2024-06-19 14:18:27.536327','model_id','type/Integer',NULL,_binary '',NULL,_binary '',2,34,NULL,'Model ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(200,'2024-06-19 14:18:20.320236','2024-06-19 14:18:27.536327','dependent_on_model','type/Text',NULL,_binary '',NULL,_binary '',3,34,NULL,'Dependent On Model','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(201,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','type','type/Text',NULL,_binary '','Either internal for a user defined remapping or external for a foreign key based remapping',_binary '',3,74,NULL,'Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(202,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','human_readable_field_id','type/Integer','type/FK',_binary '','Only used with external type remappings. Indicates which field on the FK related table to use for display',_binary '',4,74,NULL,'Human Readable Field ID','normal',290,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(203,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',6,74,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(204,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',5,74,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,5,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(205,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,74,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(206,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',7,74,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(207,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','name','type/Text',NULL,_binary '','Short description used as the display name of this new column',_binary '',2,74,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(208,'2024-06-19 14:18:20.396915','2024-06-19 14:18:28.957921','field_id','type/Integer','type/FK',_binary '','ID of the field this dimension row applies to',_binary '',1,74,NULL,'Field ID','normal',290,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(209,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','id','type/Integer','type/PK',_binary '','Unique ID',_binary '',0,22,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(210,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','breakout_binning_num_bins','type/Integer',NULL,_binary '','The numbin option of breakout',_binary '',8,22,NULL,'Breakout Binning Num Bins','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(211,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','used_in','type/Text',NULL,_binary '','which part of the query the field was used in',_binary '',3,22,NULL,'Used In','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(212,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','aggregation_function','type/Text',NULL,_binary '','the aggregation function that field applied to',_binary '',5,22,NULL,'Aggregation Function','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(213,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','breakout_binning_bin_width','type/Integer',NULL,_binary '','The numbin option of breakout',_binary '',9,22,NULL,'Breakout Binning Bin Width','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(214,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','query_execution_id','type/Integer','type/FK',_binary '','referenced query execution',_binary '',2,22,NULL,'Query Execution ID','normal',534,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(215,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','breakout_temporal_unit','type/Text',NULL,_binary '','temporal unit options of the breakout',_binary '',6,22,NULL,'Breakout Temporal Unit','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(216,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','filter_op','type/Text',NULL,_binary '','filter\'s operator that applied to the field',_binary '',4,22,NULL,'Filter Op','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(217,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','field_id','type/Integer','type/FK',_binary '','ID of the field',_binary '',1,22,NULL,'Field ID','normal',290,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(218,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The time a field usage was recorded',_binary '',10,22,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,10,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(219,'2024-06-19 14:18:20.455644','2024-06-19 14:18:27.173944','breakout_binning_strategy','type/Text',NULL,_binary '','the strategy of breakout',_binary '',7,22,NULL,'Breakout Binning Strategy','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(220,'2024-06-19 14:18:20.541547','2024-06-19 14:18:27.874744','template','type/Text',NULL,_binary '','A template that defines method,url,body,headers required to make an api call',_binary '',1,44,NULL,'Template','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(221,'2024-06-19 14:18:20.541547','2024-06-19 14:18:27.874744','error_handle','type/Text',NULL,_binary '','A program to take an api response to determine if an error occurred',_binary '',3,44,NULL,'Error Handle','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(222,'2024-06-19 14:18:20.541547','2024-06-19 14:18:27.874744','action_id','type/Integer','type/FK',_binary '','The related action',_binary '',0,44,NULL,'Action ID','normal',78,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(223,'2024-06-19 14:18:20.541547','2024-06-19 14:18:27.874744','response_handle','type/Text',NULL,_binary '','A program to take an api response and transform to an appropriate response for emitters',_binary '',2,44,NULL,'Response Handle','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(224,'2024-06-19 14:18:20.587322','2024-06-19 14:18:27.269317','kind','type/Text',NULL,_binary '','The kind of implicit action create/update/delete',_binary '',1,26,NULL,'Kind','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(225,'2024-06-19 14:18:20.587322','2024-06-19 14:18:27.269317','action_id','type/Integer','type/FK',_binary '','The associated action',_binary '',0,26,NULL,'Action ID','normal',78,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(226,'2024-06-19 14:18:20.689726','2024-06-19 14:18:28.614486','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,66,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(227,'2024-06-19 14:18:20.689726','2024-06-19 14:18:28.614486','slug','type/Text',NULL,_binary '',NULL,_binary '',2,66,NULL,'Slug','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(228,'2024-06-19 14:18:20.689726','2024-06-19 14:18:28.614486','name','type/Text',NULL,_binary '',NULL,_binary '',1,66,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(229,'2024-06-19 14:18:20.689726','2024-06-19 14:18:28.614486','icon','type/Text',NULL,_binary '',NULL,_binary '',3,66,NULL,'Icon','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(230,'2024-06-19 14:18:20.821797','2024-06-19 14:45:09.256760','device_description','type/Text','type/Description',_binary '',NULL,_binary '',5,18,NULL,'Device Description','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":123.16666666666667}}}',5,'LONGTEXT','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(231,'2024-06-19 14:18:20.821797','2024-06-19 14:45:09.256760','session_id','type/Text','type/FK',_binary '','ID of the Session created by this login if one is currently active. NULL if Session is no longer active.',_binary '',3,18,NULL,'Session ID','normal',145,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.3333333333333333}}',5,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(232,'2024-06-19 14:18:20.821797','2024-06-19 14:45:09.256760','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '','When this login occurred.',_binary '',1,18,NULL,'Timestamp','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":6,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:26:46.860777Z\",\"latest\":\"2024-06-19T14:44:40.996106Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(233,'2024-06-19 14:18:20.821797','2024-06-19 14:45:09.256760','user_id','type/Integer','type/FK',_binary '','ID of the User that logged in.',_binary '',2,18,NULL,'User ID','normal',163,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0}}',5,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(234,'2024-06-19 14:18:20.821797','2024-06-19 14:45:09.256760','ip_address','type/Text','type/Category',_binary '',NULL,_binary '',6,18,NULL,'IP Address','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.833333333333334}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(235,'2024-06-19 14:18:20.821797','2024-06-19 14:18:27.088748','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,18,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(236,'2024-06-19 14:18:20.821797','2024-06-19 14:45:09.256760','device_id','type/Text','type/Category',_binary '','Cookie-based unique identifier for the device/browser the user logged in from.',_binary '',4,18,NULL,'Device ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":36.0}}}',5,'CHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(237,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','refingerprint','type/Boolean','type/Category',_binary '','Whether or not to enable periodic refingerprinting for this Database.',_binary '',16,82,NULL,'Refingerprint','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'BIT','auto-list',NULL,16,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(238,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','metadata_sync_schedule','type/Text','type/Category',_binary '','The cron schedule string for when this database should undergo the metadata sync process (and analysis for new fields).',_binary '',11,82,NULL,'Metadata Sync Schedule','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.0}}}',5,'VARCHAR','auto-list',NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(239,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','cache_field_values_schedule','type/Text','type/Category',_binary '',NULL,_binary '',12,82,NULL,'Cache Field Values Schedule','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.0}}}',5,'VARCHAR','auto-list',NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(240,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',4,82,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":23.0}}}',5,'LONGTEXT','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(241,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','settings','type/Text',NULL,_binary '','Serialized JSON containing Database-local Settings for this Database',_binary '',20,82,NULL,'Settings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,20,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(242,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','details','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',5,82,NULL,'Details','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":115.0}}}',5,'LONGTEXT','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(243,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','timezone','type/Text','type/Category',_binary '','Timezone identifier for the database, set by the sync process',_binary '',13,82,NULL,'Timezone','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.5}}}',5,'VARCHAR','auto-list',NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(244,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','is_on_demand','type/Boolean','type/Category',_binary '','Whether we should do On-Demand caching of FieldValues for this DB. This means FieldValues are updated when their Field is used in a Dashboard or Card param.',_binary '',14,82,NULL,'Is On Demand','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,14,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(245,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','points_of_interest','type/Text','type/Category',_binary '',NULL,_binary '',9,82,NULL,'Points Of Interest','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":50.0}}}',5,'LONGTEXT','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(246,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','initial_sync_status','type/Text','type/Category',_binary '','String indicating whether a database has completed its initial sync and is ready to use',_binary '',18,82,NULL,'Initial Sync Status','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.0}}}',5,'VARCHAR','auto-list',NULL,18,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(247,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','creator_id','type/Integer','type/FK',_binary '','ID of the admin who added the database',_binary '',19,82,NULL,'Creator ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5}}',5,'INT',NULL,NULL,19,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(248,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,82,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:15.158438Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(249,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','uploads_enabled','type/Boolean','type/Category',_binary '','Whether uploads are enabled for this database',_binary '',23,82,NULL,'Uploads Enabled','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,23,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(250,'2024-06-19 14:18:20.887685','2024-06-19 14:18:29.515395','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,82,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(251,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','uploads_table_prefix','type/Text',NULL,_binary '','The prefix for upload table names',_binary '',25,82,NULL,'Uploads Table Prefix','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,25,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(252,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','is_audit','type/Boolean','type/Category',_binary '',NULL,_binary '',22,82,NULL,'Is Audit','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,22,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(253,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',3,82,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.0}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(254,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','is_full_sync','type/Boolean','type/Category',_binary '',NULL,_binary '',8,82,NULL,'Is Full Sync','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,8,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(255,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','caveats','type/Text','type/Category',_binary '',NULL,_binary '',10,82,NULL,'Caveats','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":61.5}}}',5,'LONGTEXT','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(256,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,82,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:33.229352Z\",\"latest\":\"2024-06-19T14:18:30.374485Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(257,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','auto_run_queries','type/Boolean','type/Category',_binary '','Whether to automatically run queries when doing simple filtering and summarizing in the Query Builder.',_binary '',15,82,NULL,'Auto Run Queries','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,15,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(258,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','dbms_version','type/Text','type/SerializedJSON',_binary '','A JSON object describing the flavor and version of the DBMS.',_binary '',21,82,NULL,'Dbms Version','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":67.0}}}',5,'LONGTEXT','auto-list',NULL,21,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(259,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','is_sample','type/Boolean','type/Category',_binary '',NULL,_binary '',7,82,NULL,'Is Sample','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,7,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(260,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','cache_ttl','type/Integer',NULL,_binary '','Granular cache TTL for specific database.',_binary '',17,82,NULL,'Cache Ttl','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,17,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(261,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','engine','type/Text','type/Category',_binary '',NULL,_binary '',6,82,NULL,'Engine','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":3.5}}}',5,'VARCHAR','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(262,'2024-06-19 14:18:20.887685','2024-06-19 14:18:48.863736','uploads_schema_name','type/Text',NULL,_binary '','The schema name for uploads',_binary '',24,82,NULL,'Uploads Schema Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,24,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(263,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','database_type','type/Text','type/Category',_binary '',NULL,_binary '',20,28,NULL,'Database Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":23,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.187431091510474}}}',5,'LONGTEXT','auto-list',NULL,20,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(264,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','database_partitioned','type/Boolean','type/Category',_binary '',NULL,_binary '',32,28,NULL,'Database Partitioned','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'BIT','auto-list',NULL,32,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(265,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','fingerprint','type/Text',NULL,_binary '',NULL,_binary '',18,28,NULL,'Fingerprint','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":88,\"nil%\":0.8930540242557883},\"type\":{\"type/Text\":{\"percent-json\":0.1069459757442117,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":16.17640573318633}}}',5,'LONGTEXT','auto-list',NULL,18,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(266,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','database_required','type/Boolean','type/Category',_binary '',NULL,_binary '',28,28,NULL,'Database Required','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,28,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(267,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','has_field_values','type/Text','type/Category',_binary '',NULL,_binary '',21,28,NULL,'Has Field Values','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9735391400220507},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.23814773980154355}}}',5,'LONGTEXT','auto-list',NULL,21,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(268,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','database_is_auto_increment','type/Boolean','type/Category',_binary '',NULL,_binary '',30,28,NULL,'Database Is Auto Increment','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,30,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(269,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','fingerprint_version','type/Integer','type/Category',_binary '','The version of the fingerprint for this Field. Used so we can keep track of which Fields need to be analyzed again when new things are added to fingerprints.',_binary '',19,28,NULL,'Fingerprint Version','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":2.0798486957963283,\"max\":5.0,\"sd\":1.5460752878198982,\"avg\":0.5347298787210585}}}',5,'INT','auto-list',NULL,19,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(270,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',7,28,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":279,\"nil%\":0.6372657111356119},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":19.676957001102537}}}',5,'LONGTEXT','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(271,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','fk_target_field_id','type/Integer','type/Category',_binary '',NULL,_binary '',14,28,NULL,'Fk Target Field ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":29,\"nil%\":0.8687982359426681},\"type\":{\"type/Number\":{\"min\":7.0,\"q1\":160.59391777328744,\"q3\":511.5625,\"max\":696.0,\"sd\":185.21707624453452,\"avg\":311.30252100840335}}}',5,'INT','auto-list',NULL,14,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(272,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','database_position','type/Integer',NULL,_binary '',NULL,_binary '',23,28,NULL,'Database Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":33,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":1.7860355569013984,\"q3\":9.122760912932305,\"max\":32.0,\"sd\":5.903769101909442,\"avg\":6.2546857772877615}}}',5,'INT','auto-list',NULL,23,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(273,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,28,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":93,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:25.286932Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(274,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','coercion_strategy','type/Text',NULL,_binary '','A strategy to coerce the base_type into the effective_type.',_binary '',26,28,NULL,'Coercion Strategy','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,26,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(275,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','visibility_type','type/Text','type/Category',_binary '',NULL,_binary '',13,28,NULL,'Visibility Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.0}}}',5,'VARCHAR','auto-list',NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(276,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','json_unfolding','type/Boolean','type/Category',_binary '',NULL,_binary '',29,28,NULL,'Json Unfolding','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,29,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(277,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','points_of_interest','type/Text',NULL,_binary '',NULL,_binary '',16,28,NULL,'Points Of Interest','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,16,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(278,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','last_analyzed','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',15,28,NULL,'Last Analyzed','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9305402425578831},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,15,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(279,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','semantic_type','type/Text','type/Category',_binary '',NULL,_binary '',5,28,NULL,'Semantic Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":22,\"nil%\":0.7331863285556781},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":2.1499448732083795}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(280,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','database_indexed','type/Boolean','type/Category',_binary '',NULL,_binary '',31,28,NULL,'Database Indexed','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.1730981256890849}}',5,'BIT','auto-list',NULL,31,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(281,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,28,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":161,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:31.772349Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(282,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','table_id','type/Integer','type/FK',_binary '',NULL,_binary '',10,28,NULL,'Table ID','normal',314,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":100,\"nil%\":0.0}}',5,'INT',NULL,NULL,10,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(283,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','settings','type/Text',NULL,_binary '',NULL,_binary '',22,28,NULL,'Settings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,22,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(284,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','display_name','type/Text',NULL,_binary '',NULL,_binary '',12,28,NULL,'Display Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":374,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.07386990077177508,\"average-length\":9.94928335170893}}}',5,'VARCHAR','auto-list',NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(285,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',3,28,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":386,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.07386990077177508,\"average-length\":9.94928335170893}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(286,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','base_type','type/Text','type/Category',_binary '',NULL,_binary '',4,28,NULL,'Base Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":10,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":12.253583241455347}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(287,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','parent_id','type/Integer','type/FK',_binary '',NULL,_binary '',11,28,NULL,'Parent ID','normal',290,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'INT',NULL,NULL,11,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(288,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','preview_display','type/Boolean','type/Category',_binary '',NULL,_binary '',8,28,NULL,'Preview Display','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,8,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(289,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','caveats','type/Text',NULL,_binary '',NULL,_binary '',17,28,NULL,'Caveats','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,17,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(290,'2024-06-19 14:18:20.974028','2024-06-19 14:18:27.351244','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,28,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(291,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','nfc_path','type/Text',NULL,_binary '','Nested field column paths, flattened',_binary '',27,28,NULL,'Nfc Path','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,27,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(292,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','custom_position','type/Integer','type/Category',_binary '',NULL,_binary '',24,28,NULL,'Custom Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":0.0,\"avg\":0.0}}}',5,'INT','auto-list',NULL,24,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(293,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','position','type/Integer',NULL,_binary '',NULL,_binary '',9,28,NULL,'Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":33,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":1.7860355569013984,\"q3\":9.122760912932305,\"max\":32.0,\"sd\":5.903769101909442,\"avg\":6.2546857772877615}}}',5,'INT','auto-list',NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(294,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','effective_type','type/Text','type/Category',_binary '','The effective type of the field after any coercions.',_binary '',25,28,NULL,'Effective Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":10,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":12.253583241455347}}}',5,'VARCHAR','auto-list',NULL,25,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(295,'2024-06-19 14:18:20.974028','2024-06-19 14:18:48.863736','active','type/Boolean','type/Category',_binary '',NULL,_binary '',6,28,NULL,'Active','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,6,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(296,'2024-06-19 14:18:21.070410','2024-06-19 14:18:30.132965','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,103,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(297,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,103,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:35.044327Z\",\"latest\":\"2024-06-19T14:13:36.665093Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(298,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','hash_key','type/Text',NULL,_binary '','Hash key for a cached fieldvalues',_binary '',8,103,NULL,'Hash Key','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(299,'2024-06-19 14:18:21.070410','2024-06-19 14:19:05.976997','values','type/Text','type/Category',_binary '',NULL,_binary '',3,103,NULL,'Values','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":19,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.8333333333333333,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":342.875}}}',5,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(300,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,103,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:35.044327Z\",\"latest\":\"2024-06-19T14:13:36.665093Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(301,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','field_id','type/Integer','type/FK',_binary '',NULL,_binary '',5,103,NULL,'Field ID','normal',290,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.0}}',5,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(302,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','human_readable_values','type/Text',NULL,_binary '',NULL,_binary '',4,103,NULL,'Human Readable Values','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(303,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','has_more_values','type/Boolean','type/Category',_binary '',NULL,_binary '',6,103,NULL,'Has More Values','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,6,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(304,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','last_used_at','type/DateTimeWithLocalTZ',NULL,_binary '','Timestamp of when these FieldValues were last used.',_binary '',9,103,NULL,'Last Used At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:35.044327Z\",\"latest\":\"2024-06-19T14:13:36.665093Z\"}}}',5,'TIMESTAMP',NULL,NULL,9,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(305,'2024-06-19 14:18:21.070410','2024-06-19 14:18:48.863736','type','type/Text','type/Category',_binary '','Type of FieldValues',_binary '',7,103,NULL,'Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.0}}}',5,'VARCHAR','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(306,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','visibility_type','type/Text','type/Category',_binary '',NULL,_binary '',9,79,NULL,'Visibility Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9345794392523364},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.32710280373831774}}}',5,'VARCHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(307,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','caveats','type/Text','type/Category',_binary '',NULL,_binary '',12,79,NULL,'Caveats','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":9,\"nil%\":0.9252336448598131},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.16822429906542}}}',5,'LONGTEXT','auto-list',NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(308,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','field_order','type/Text','type/Category',_binary '',NULL,_binary '',14,79,NULL,'Field Order','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.0}}}',5,'VARCHAR','auto-list',NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(309,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',3,79,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.570093457943925}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(310,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','initial_sync_status','type/Text','type/Category',_binary '','String indicating whether a table has completed its initial sync and is ready to use',_binary '',15,79,NULL,'Initial Sync Status','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.0}}}',5,'VARCHAR','auto-list',NULL,15,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(311,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','display_name','type/Text',NULL,_binary '',NULL,_binary '',8,79,NULL,'Display Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.570093457943925}}}',5,'VARCHAR','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(312,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','estimated_row_count','type/BigInteger','type/Quantity',_binary '','The estimated row count',_binary '',18,79,NULL,'Estimated Row Count','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'BIGINT','auto-list',NULL,18,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(313,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','show_in_getting_started','type/Boolean','type/Category',_binary '',NULL,_binary '',13,79,NULL,'Show In Getting Started','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,13,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(314,'2024-06-19 14:18:21.121593','2024-06-19 14:18:29.201671','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,79,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(315,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','entity_type','type/Text','type/Category',_binary '',NULL,_binary '',5,79,NULL,'Entity Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":6,\"nil%\":0.9252336448598131},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":1.3831775700934579}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(316,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','active','type/Boolean','type/Category',_binary '',NULL,_binary '',6,79,NULL,'Active','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,6,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(317,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',4,79,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":52,\"nil%\":0.3177570093457944},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":32.654205607476634}}}',5,'LONGTEXT','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(318,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','database_require_filter','type/Boolean','type/Category',_binary '',NULL,_binary '',17,79,NULL,'Database Require Filter','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'BIT','auto-list',NULL,17,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(319,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,79,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":16,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:33.339338Z\",\"latest\":\"2024-06-19T14:18:26.857109Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(320,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','points_of_interest','type/Text','type/Category',_binary '',NULL,_binary '',11,79,NULL,'Points Of Interest','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.9252336448598131},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":2.2803738317757007}}}',5,'LONGTEXT','auto-list',NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(321,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,79,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":100,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:19.094014Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(322,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','schema','type/Text','type/Category',_binary '',NULL,_binary '',10,79,NULL,'Schema','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9252336448598131},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.4485981308411215}}}',5,'VARCHAR','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(323,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','view_count','type/Integer','type/Quantity',_binary '','Keeps a running count of card views',_binary '',19,79,NULL,'View Count','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":0.0,\"avg\":0.0}}}',5,'INT','auto-list',NULL,19,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(324,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','is_upload','type/Boolean','type/Category',_binary '',NULL,_binary '',16,79,NULL,'Is Upload','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,16,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(325,'2024-06-19 14:18:21.121593','2024-06-19 14:18:48.863736','db_id','type/Integer','type/FK',_binary '',NULL,_binary '',7,79,NULL,'Db ID','normal',250,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'INT',NULL,NULL,7,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(326,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','name','type/Text',NULL,_binary '',NULL,_binary '',3,27,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(327,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','description','type/Text',NULL,_binary '',NULL,_binary '',4,27,NULL,'Description','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(328,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','caveats','type/Text',NULL,_binary '',NULL,_binary '',10,27,NULL,'Caveats','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(329,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',8,27,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,8,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(330,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','definition','type/Text',NULL,_binary '',NULL,_binary '',6,27,NULL,'Definition','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(331,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,27,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(332,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','show_in_getting_started','type/Boolean',NULL,_binary '',NULL,_binary '',12,27,NULL,'Show In Getting Started','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(333,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,27,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(334,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',7,27,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(335,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','table_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,27,NULL,'Table ID','normal',314,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(336,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','how_is_this_calculated','type/Text',NULL,_binary '',NULL,_binary '',11,27,NULL,'How Is This Calculated','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(337,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','points_of_interest','type/Text',NULL,_binary '',NULL,_binary '',9,27,NULL,'Points Of Interest','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(338,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','archived','type/Boolean',NULL,_binary '',NULL,_binary '',5,27,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(339,'2024-06-19 14:18:21.197708','2024-06-19 14:18:27.306056','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',13,27,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(340,'2024-06-19 14:18:21.268715','2024-06-19 14:18:27.722985','field_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,39,NULL,'Field ID','normal',290,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(341,'2024-06-19 14:18:21.268715','2024-06-19 14:18:27.722985','metric_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,39,NULL,'Metric ID','normal',331,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(342,'2024-06-19 14:18:21.268715','2024-06-19 14:18:27.722985','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,39,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(343,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','pk_ref','type/Text',NULL,_binary '','Serialized JSON of the primary key field ref.',_binary '',2,16,NULL,'Pk Ref','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(344,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','indexed_at','type/DateTimeWithLocalTZ',NULL,_binary '','When the status changed',_binary '',6,16,NULL,'Indexed At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(345,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','schedule','type/Text',NULL,_binary '','The cron schedule for when value syncing should happen.',_binary '',4,16,NULL,'Schedule','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(346,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when these changes were made.',_binary '',8,16,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,8,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(347,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','error','type/Text',NULL,_binary '','The error message if the status is error.',_binary '',7,16,NULL,'Error','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(348,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','value_ref','type/Text',NULL,_binary '','Serialized JSON of the label field ref.',_binary '',3,16,NULL,'Value Ref','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(349,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','state','type/Text',NULL,_binary '','The status of the index: initializing, indexed, error, overflow.',_binary '',5,16,NULL,'State','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(350,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','creator_id','type/Integer','type/FK',_binary '','ID of the user who created the event',_binary '',9,16,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,9,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(351,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,16,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(352,'2024-06-19 14:18:21.324073','2024-06-19 14:18:27.008429','model_id','type/Integer','type/FK',_binary '','The ID of the indexed model.',_binary '',1,16,NULL,'Model ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(353,'2024-06-19 14:18:21.380370','2024-06-19 14:18:27.140428','name','type/Text',NULL,_binary '','The label to display identifying the indexed value.',_binary '',2,20,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(354,'2024-06-19 14:18:21.380370','2024-06-19 14:18:27.140428','model_index_id','type/Integer','type/FK',_binary '','The ID of the indexed model.',_binary '',0,20,NULL,'Model Index ID','normal',351,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(355,'2024-06-19 14:18:21.380370','2024-06-19 14:18:27.140428','model_pk','type/Integer',NULL,_binary '','The primary key of the indexed value',_binary '',1,20,NULL,'Model Pk','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(356,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','text','type/Text',NULL,_binary '',NULL,_binary '',4,31,NULL,'Text','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(357,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','moderator_id','type/Integer',NULL,_binary '','ID of the user who did the review',_binary '',7,31,NULL,'Moderator ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,7,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(358,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','most_recent','type/Boolean',NULL,_binary '','tag for most recent review',_binary '',8,31,NULL,'Most Recent','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,8,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(359,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','status','type/Text',NULL,_binary '','verified, misleading, confusing, not_misleading, pending',_binary '',3,31,NULL,'Status','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(360,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','moderated_item_type','type/Text',NULL,_binary '','whether it\'s a question or dashboard',_binary '',6,31,NULL,'Moderated Item Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(361,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','moderated_item_id','type/Integer',NULL,_binary '','either a document or question ID; the item that needs review',_binary '',5,31,NULL,'Moderated Item ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(362,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','most recent modification time',_binary '',1,31,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(363,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','creation time',_binary '',2,31,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(364,'2024-06-19 14:18:21.428937','2024-06-19 14:18:27.461134','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,31,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(365,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',7,50,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(366,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','description','type/Text',NULL,_binary '',NULL,_binary '',2,50,NULL,'Description','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(367,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','archived','type/Boolean',NULL,_binary '',NULL,_binary '',5,50,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(368,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',6,50,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(369,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','name','type/Text',NULL,_binary '','Name of the query snippet',_binary '',1,50,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(370,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',4,50,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(371,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','collection_id','type/Integer','type/FK',_binary '','ID of the Snippet Folder (Collection) this Snippet is in, if any',_binary '',8,50,NULL,'Collection ID','normal',131,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(372,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',9,50,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(373,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','content','type/Text',NULL,_binary '',NULL,_binary '',3,50,NULL,'Content','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(374,'2024-06-19 14:18:21.483988','2024-06-19 14:18:28.078676','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,50,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(375,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','parameter_id','type/Text',NULL,_binary '',NULL,_binary '',6,87,NULL,'Parameter ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(376,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','card_id','type/Integer','type/FK',_binary '','ID of the card generating the values',_binary '',3,87,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(377,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','parameterized_object_type','type/Text',NULL,_binary '','Type of the entity consuming the values (dashboard, card, etc.)',_binary '',4,87,NULL,'Parameterized Object Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(378,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','most recent modification time',_binary '',1,87,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(379,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,87,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(380,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','creation time',_binary '',2,87,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(381,'2024-06-19 14:18:21.561852','2024-06-19 14:18:29.632981','parameterized_object_id','type/Integer',NULL,_binary '','ID of the entity consuming the values',_binary '',5,87,NULL,'Parameterized Object ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(382,'2024-06-19 14:18:21.661409','2024-06-19 14:18:48.863736','group_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,29,NULL,'Group ID','normal',386,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(383,'2024-06-19 14:18:21.661409','2024-06-19 14:18:48.863736','object','type/Text','type/Category',_binary '',NULL,_binary '',1,29,NULL,'Object','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":18.8}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(384,'2024-06-19 14:18:21.661409','2024-06-19 14:18:27.385318','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,29,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(385,'2024-06-19 14:18:21.734126','2024-06-19 14:18:48.863736','entity_id','type/Text',NULL,_binary '','NanoID tag for each user',_binary '',2,102,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'CHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(386,'2024-06-19 14:18:21.734126','2024-06-19 14:18:30.106361','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,102,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(387,'2024-06-19 14:18:21.734126','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',1,102,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":11.5}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(388,'2024-06-19 14:18:21.798053','2024-06-19 14:18:29.743143','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,90,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(389,'2024-06-19 14:18:21.798053','2024-06-19 14:18:48.863736','group_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,90,NULL,'Group ID','normal',386,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(390,'2024-06-19 14:18:21.798053','2024-06-19 14:18:48.863736','user_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,90,NULL,'User ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(391,'2024-06-19 14:18:21.798053','2024-06-19 14:18:48.863736','is_group_manager','type/Boolean','type/Category',_binary '',NULL,_binary '',3,90,NULL,'Is Group Manager','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,3,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(392,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','table_name','type/Text',NULL,_binary '','Name of the table persisted',_binary '',4,63,NULL,'Table Name','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(393,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','definition','type/Text',NULL,_binary '','JSON object that captures the state of the table when we persisted',_binary '',5,63,NULL,'Definition','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(394,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','state_change_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the most recent state changed',_binary '',11,63,NULL,'State Change At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,11,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(395,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','database_id','type/Integer','type/FK',_binary '','ID of the database associated to the persisted card',_binary '',1,63,NULL,'Database ID','normal',250,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(396,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','query_hash','type/Text',NULL,_binary '','Hash of the query persisted',_binary '',6,63,NULL,'Query Hash','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(397,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','question_slug','type/Text',NULL,_binary '','Slug of the card which will form the persisted table name',_binary '',3,63,NULL,'Question Slug','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(398,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,63,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(399,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','refresh_begin','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the most recent refresh was started',_binary '',9,63,NULL,'Refresh Begin','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,9,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(400,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the model was first persisted',_binary '',13,63,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,13,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(401,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','state','type/Text',NULL,_binary '','Persisted table state (creating, persisted, refreshing, deleted)',_binary '',8,63,NULL,'State','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,8,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(402,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','card_id','type/Integer','type/FK',_binary '','ID of the Card model persisted',_binary '',2,63,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(403,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','refresh_end','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the most recent refresh ended',_binary '',10,63,NULL,'Refresh End','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,10,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(404,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','error','type/Text',NULL,_binary '','Error message from persisting if applicable',_binary '',12,63,NULL,'Error','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(405,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','active','type/Boolean',NULL,_binary '',NULL,_binary '',7,63,NULL,'Active','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,7,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(406,'2024-06-19 14:18:21.982676','2024-06-19 14:18:28.459052','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',14,63,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,14,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(407,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','name','type/Text',NULL,_binary '',NULL,_binary '',2,45,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(408,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','skip_if_empty','type/Boolean',NULL,_binary '','Skip a scheduled Pulse if none of its questions have any results',_binary '',5,45,NULL,'Skip If Empty','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(409,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',14,45,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(410,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',3,45,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(411,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',4,45,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(412,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','dashboard_id','type/Integer','type/FK',_binary '','ID of the Dashboard if this Pulse is a Dashboard Subscription.',_binary '',12,45,NULL,'Dashboard ID','normal',614,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,12,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(413,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','collection_position','type/Integer',NULL,_binary '','Optional pinned position for this item in its Collection. NULL means item is not pinned.',_binary '',10,45,NULL,'Collection Position','normal',NULL,NULL,NULL,NULL,NULL,0,'SMALLINT',NULL,NULL,10,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(414,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,45,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(415,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','parameters','type/Text',NULL,_binary '',NULL,_binary '',13,45,NULL,'Parameters','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(416,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','alert_first_only','type/Boolean',NULL,_binary '','True if the alert should be disabled after the first notification',_binary '',7,45,NULL,'Alert First Only','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,7,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(417,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','archived','type/Boolean',NULL,_binary '','Has this pulse been archived?',_binary '',11,45,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(418,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','alert_above_goal','type/Boolean',NULL,_binary '','For a goal condition, alert when above the goal',_binary '',8,45,NULL,'Alert Above Goal','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,8,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(419,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','collection_id','type/Integer','type/FK',_binary '','Options ID of Collection this Pulse belongs to.',_binary '',9,45,NULL,'Collection ID','normal',131,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(420,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','alert_condition','type/Text',NULL,_binary '','Condition (i.e. \"rows\" or \"goal\") used as a guard for alerts',_binary '',6,45,NULL,'Alert Condition','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(421,'2024-06-19 14:18:22.127690','2024-06-19 14:18:27.920174','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,45,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(422,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','position','type/Integer',NULL,_binary '',NULL,_binary '',3,37,NULL,'Position','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(423,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','include_csv','type/Boolean',NULL,_binary '','True if a CSV of the data should be included for this pulse card',_binary '',4,37,NULL,'Include Csv','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,4,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(424,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','pulse_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,37,NULL,'Pulse ID','normal',414,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(425,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','format_rows','type/Boolean',NULL,_binary '','Whether or not to apply formatting to the rows of the export',_binary '',8,37,NULL,'Format Rows','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,8,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(426,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',7,37,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(427,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','include_xls','type/Boolean',NULL,_binary '','True if a XLS of the data should be included for this pulse card',_binary '',5,37,NULL,'Include Xls','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(428,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','card_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,37,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(429,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','dashboard_card_id','type/Integer','type/FK',_binary '','If this Pulse is a Dashboard subscription, the ID of the DashboardCard that corresponds to this PulseCard.',_binary '',6,37,NULL,'Dashboard Card ID','normal',625,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,6,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(430,'2024-06-19 14:18:22.275707','2024-06-19 14:18:27.642069','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,37,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(431,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','channel_type','type/Text',NULL,_binary '',NULL,_binary '',2,49,NULL,'Channel Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(432,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','pulse_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,49,NULL,'Pulse ID','normal',414,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(433,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,49,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(434,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',11,49,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(435,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','details','type/Text',NULL,_binary '',NULL,_binary '',3,49,NULL,'Details','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(436,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','schedule_type','type/Text',NULL,_binary '',NULL,_binary '',4,49,NULL,'Schedule Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(437,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',7,49,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(438,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','schedule_frame','type/Text',NULL,_binary '',NULL,_binary '',9,49,NULL,'Schedule Frame','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(439,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','schedule_day','type/Text',NULL,_binary '',NULL,_binary '',6,49,NULL,'Schedule Day','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(440,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','schedule_hour','type/Integer',NULL,_binary '',NULL,_binary '',5,49,NULL,'Schedule Hour','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(441,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','enabled','type/Boolean',NULL,_binary '',NULL,_binary '',10,49,NULL,'Enabled','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,10,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(442,'2024-06-19 14:18:22.354307','2024-06-19 14:18:28.035146','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',8,49,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,8,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(443,'2024-06-19 14:18:22.462681','2024-06-19 14:18:28.732204','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,72,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(444,'2024-06-19 14:18:22.462681','2024-06-19 14:18:28.732204','user_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,72,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(445,'2024-06-19 14:18:22.462681','2024-06-19 14:18:28.732204','pulse_channel_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,72,NULL,'Pulse Channel ID','normal',433,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(446,'2024-06-19 14:18:22.570684','2024-06-19 14:18:28.368325','TRIGGER_GROUP','type/Text','type/FK',_binary '',NULL,_binary '',2,60,NULL,'Trigger Group','normal',515,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(447,'2024-06-19 14:18:22.570684','2024-06-19 14:18:28.368325','BLOB_DATA','type/*',NULL,_binary '',NULL,_binary '',3,60,NULL,'Blob Data','normal',NULL,NULL,NULL,NULL,NULL,0,'BLOB',NULL,NULL,3,0,'type/*',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(448,'2024-06-19 14:18:22.570684','2024-06-19 14:18:28.368325','SCHED_NAME','type/Text','type/FK',_binary '',NULL,_binary '',0,60,NULL,'Sched Name','normal',510,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(449,'2024-06-19 14:18:22.570684','2024-06-19 14:18:28.368325','TRIGGER_NAME','type/Text','type/FK',_binary '',NULL,_binary '',1,60,NULL,'Trigger Name','normal',518,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(450,'2024-06-19 14:18:22.646142','2024-06-19 14:18:26.943960','CALENDAR_NAME','type/Text','type/PK',_binary '',NULL,_binary '',1,13,NULL,'Calendar Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(451,'2024-06-19 14:18:22.646142','2024-06-19 14:18:26.943960','CALENDAR','type/*',NULL,_binary '',NULL,_binary '',2,13,NULL,'Calendar','normal',NULL,NULL,NULL,NULL,NULL,0,'BLOB',NULL,NULL,2,0,'type/*',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(452,'2024-06-19 14:18:22.646142','2024-06-19 14:18:26.943960','SCHED_NAME','type/Text','type/PK',_binary '',NULL,_binary '',0,13,NULL,'Sched Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(453,'2024-06-19 14:18:22.722625','2024-06-19 14:18:48.863736','TRIGGER_NAME','type/Text','type/FK',_binary '',NULL,_binary '',1,47,NULL,'Trigger Name','normal',518,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":9,\"nil%\":0.0}}',5,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(454,'2024-06-19 14:18:22.722625','2024-06-19 14:18:48.863736','SCHED_NAME','type/Text','type/FK',_binary '',NULL,_binary '',0,47,NULL,'Sched Name','normal',510,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(455,'2024-06-19 14:18:22.722625','2024-06-19 14:18:48.863736','CRON_EXPRESSION','type/Text','type/Category',_binary '',NULL,_binary '',3,47,NULL,'Cron Expression','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":9,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.555555555555555}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(456,'2024-06-19 14:18:22.722625','2024-06-19 14:18:48.863736','TRIGGER_GROUP','type/Text','type/FK',_binary '',NULL,_binary '',2,47,NULL,'Trigger Group','normal',515,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(457,'2024-06-19 14:18:22.722625','2024-06-19 14:18:48.863736','TIME_ZONE_ID','type/Text','type/Category',_binary '',NULL,_binary '',4,47,NULL,'Time Zone ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":3.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(458,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','SCHED_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',6,93,NULL,'Sched Time','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.7188083E12,\"q1\":1.7188083E12,\"q3\":1.7188083E12,\"max\":1.7188083E12,\"sd\":null,\"avg\":1.7188083E12}}}',5,'BIGINT','auto-list',NULL,6,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(459,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','TRIGGER_GROUP','type/Text','type/Category',_binary '',NULL,_binary '',3,93,NULL,'Trigger Group','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.0}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(460,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','STATE','type/Text','type/Category',_binary '',NULL,_binary '',8,93,NULL,'State','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":9.0}}}',5,'VARCHAR','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(461,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','TRIGGER_NAME','type/Text','type/Category',_binary '',NULL,_binary '',2,93,NULL,'Trigger Name','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":40.0}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(462,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','INSTANCE_NAME','type/Text','type/Category',_binary '',NULL,_binary '',4,93,NULL,'Instance Name','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":25.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(463,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','JOB_GROUP','type/Text','type/Category',_binary '',NULL,_binary '',10,93,NULL,'Job Group','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.0}}}',5,'VARCHAR','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(464,'2024-06-19 14:18:22.792223','2024-06-19 14:18:29.850603','ENTRY_ID','type/Text','type/PK',_binary '',NULL,_binary '',1,93,NULL,'Entry ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(465,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','REQUESTS_RECOVERY','type/Boolean','type/Category',_binary '',NULL,_binary '',12,93,NULL,'Requests Recovery','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(466,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','PRIORITY','type/Integer','type/Category',_binary '',NULL,_binary '',7,93,NULL,'Priority','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":5.0,\"q1\":5.0,\"q3\":5.0,\"max\":5.0,\"sd\":null,\"avg\":5.0}}}',5,'INT','auto-list',NULL,7,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(467,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','FIRED_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',5,93,NULL,'Fired Time','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.718808300002E12,\"q1\":1.718808300002E12,\"q3\":1.718808300002E12,\"max\":1.718808300002E12,\"sd\":null,\"avg\":1.718808300002E12}}}',5,'BIGINT','auto-list',NULL,5,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(468,'2024-06-19 14:18:22.792223','2024-06-19 14:18:29.850603','SCHED_NAME','type/Text','type/PK',_binary '',NULL,_binary '',0,93,NULL,'Sched Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(469,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','IS_NONCONCURRENT','type/Boolean','type/Category',_binary '',NULL,_binary '',11,93,NULL,'Is Nonconcurrent','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(470,'2024-06-19 14:18:22.792223','2024-06-19 14:45:09.256760','JOB_NAME','type/Text','type/Category',_binary '',NULL,_binary '',9,93,NULL,'Job Name','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":34.0}}}',5,'VARCHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(471,'2024-06-19 14:18:22.853663','2024-06-19 14:18:48.863736','REQUESTS_RECOVERY','type/Boolean','type/Category',_binary '',NULL,_binary '',8,68,NULL,'Requests Recovery','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,8,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(472,'2024-06-19 14:18:22.853663','2024-06-19 14:18:48.863736','JOB_CLASS_NAME','type/Text','type/Category',_binary '',NULL,_binary '',4,68,NULL,'Job Class Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":17,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":51.64705882352941}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(473,'2024-06-19 14:18:22.853663','2024-06-19 14:18:48.863736','DESCRIPTION','type/Text','type/Description',_binary '',NULL,_binary '',3,68,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":7,\"nil%\":0.6470588235294118},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":9.470588235294118}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(474,'2024-06-19 14:18:22.853663','2024-06-19 14:18:28.652877','JOB_NAME','type/Text','type/PK',_binary '',NULL,_binary '',1,68,NULL,'Job Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(475,'2024-06-19 14:18:22.853663','2024-06-19 14:18:28.652877','JOB_DATA','type/*',NULL,_binary '',NULL,_binary '',9,68,NULL,'Job Data','normal',NULL,NULL,NULL,NULL,NULL,0,'BLOB',NULL,NULL,9,0,'type/*',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(476,'2024-06-19 14:18:22.853663','2024-06-19 14:18:48.863736','IS_UPDATE_DATA','type/Boolean','type/Category',_binary '',NULL,_binary '',7,68,NULL,'Is Update Data','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,7,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(477,'2024-06-19 14:18:22.853663','2024-06-19 14:18:48.863736','IS_NONCONCURRENT','type/Boolean','type/Category',_binary '',NULL,_binary '',6,68,NULL,'Is Nonconcurrent','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,6,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(478,'2024-06-19 14:18:22.853663','2024-06-19 14:18:28.652877','SCHED_NAME','type/Text','type/PK',_binary '',NULL,_binary '',0,68,NULL,'Sched Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(479,'2024-06-19 14:18:22.853663','2024-06-19 14:18:28.652877','JOB_GROUP','type/Text','type/PK',_binary '',NULL,_binary '',2,68,NULL,'Job Group','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(480,'2024-06-19 14:18:22.853663','2024-06-19 14:18:48.863736','IS_DURABLE','type/Boolean','type/Category',_binary '',NULL,_binary '',5,68,NULL,'Is Durable','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,5,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(481,'2024-06-19 14:18:22.909729','2024-06-19 14:18:28.173302','LOCK_NAME','type/Text','type/PK',_binary '',NULL,_binary '',1,55,NULL,'Lock Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(482,'2024-06-19 14:18:22.909729','2024-06-19 14:18:28.173302','SCHED_NAME','type/Text','type/PK',_binary '',NULL,_binary '',0,55,NULL,'Sched Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(483,'2024-06-19 14:18:22.954848','2024-06-19 14:18:28.390388','SCHED_NAME','type/Text','type/PK',_binary '',NULL,_binary '',0,61,NULL,'Sched Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(484,'2024-06-19 14:18:22.954848','2024-06-19 14:18:28.390388','TRIGGER_GROUP','type/Text','type/PK',_binary '',NULL,_binary '',1,61,NULL,'Trigger Group','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(485,'2024-06-19 14:18:23.005661','2024-06-19 14:18:28.678720','SCHED_NAME','type/Text','type/PK',_binary '',NULL,_binary '',0,70,NULL,'Sched Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(486,'2024-06-19 14:18:23.005661','2024-06-19 14:18:48.863736','CHECKIN_INTERVAL','type/BigInteger','type/Category',_binary '',NULL,_binary '',3,70,NULL,'Checkin Interval','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":7500.0,\"q1\":7500.0,\"q3\":7500.0,\"max\":7500.0,\"sd\":null,\"avg\":7500.0}}}',5,'BIGINT','auto-list',NULL,3,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(487,'2024-06-19 14:18:23.005661','2024-06-19 14:18:48.863736','LAST_CHECKIN_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',2,70,NULL,'Last Checkin Time','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.718806717186E12,\"q1\":1.718806717186E12,\"q3\":1.718806717186E12,\"max\":1.718806717186E12,\"sd\":null,\"avg\":1.718806717186E12}}}',5,'BIGINT','auto-list',NULL,2,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(488,'2024-06-19 14:18:23.005661','2024-06-19 14:18:28.678720','INSTANCE_NAME','type/Text','type/PK',_binary '',NULL,_binary '',1,70,NULL,'Instance Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(489,'2024-06-19 14:18:23.064485','2024-06-19 14:18:27.572112','SCHED_NAME','type/Text','type/FK',_binary '',NULL,_binary '',0,35,NULL,'Sched Name','normal',510,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(490,'2024-06-19 14:18:23.064485','2024-06-19 14:18:27.572112','REPEAT_INTERVAL','type/BigInteger',NULL,_binary '',NULL,_binary '',4,35,NULL,'Repeat Interval','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,4,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(491,'2024-06-19 14:18:23.064485','2024-06-19 14:18:27.572112','REPEAT_COUNT','type/BigInteger',NULL,_binary '',NULL,_binary '',3,35,NULL,'Repeat Count','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,3,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(492,'2024-06-19 14:18:23.064485','2024-06-19 14:18:27.572112','TRIGGER_GROUP','type/Text','type/FK',_binary '',NULL,_binary '',2,35,NULL,'Trigger Group','normal',515,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(493,'2024-06-19 14:18:23.064485','2024-06-19 14:18:27.572112','TRIGGER_NAME','type/Text','type/FK',_binary '',NULL,_binary '',1,35,NULL,'Trigger Name','normal',518,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(494,'2024-06-19 14:18:23.064485','2024-06-19 14:18:27.572112','TIMES_TRIGGERED','type/BigInteger',NULL,_binary '',NULL,_binary '',5,35,NULL,'Times Triggered','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,5,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(495,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','STR_PROP_3','type/Text',NULL,_binary '',NULL,_binary '',5,36,NULL,'Str Prop 3','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(496,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','LONG_PROP_2','type/BigInteger',NULL,_binary '',NULL,_binary '',9,36,NULL,'Long Prop 2','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,9,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(497,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','DEC_PROP_1','type/Decimal',NULL,_binary '',NULL,_binary '',10,36,NULL,'Dec Prop 1','normal',NULL,NULL,NULL,NULL,NULL,0,'DECIMAL',NULL,NULL,10,0,'type/Decimal',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(498,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','TRIGGER_GROUP','type/Text','type/FK',_binary '',NULL,_binary '',2,36,NULL,'Trigger Group','normal',515,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(499,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','BOOL_PROP_2','type/Boolean',NULL,_binary '',NULL,_binary '',13,36,NULL,'Bool Prop 2','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,13,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(500,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','STR_PROP_1','type/Text',NULL,_binary '',NULL,_binary '',3,36,NULL,'Str Prop 1','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(501,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','STR_PROP_2','type/Text',NULL,_binary '',NULL,_binary '',4,36,NULL,'Str Prop 2','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(502,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','INT_PROP_2','type/Integer',NULL,_binary '',NULL,_binary '',7,36,NULL,'Int Prop 2','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,7,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(503,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','LONG_PROP_1','type/BigInteger',NULL,_binary '',NULL,_binary '',8,36,NULL,'Long Prop 1','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,8,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(504,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','SCHED_NAME','type/Text','type/FK',_binary '',NULL,_binary '',0,36,NULL,'Sched Name','normal',510,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(505,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','DEC_PROP_2','type/Decimal',NULL,_binary '',NULL,_binary '',11,36,NULL,'Dec Prop 2','normal',NULL,NULL,NULL,NULL,NULL,0,'DECIMAL',NULL,NULL,11,0,'type/Decimal',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(506,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','INT_PROP_1','type/Integer',NULL,_binary '',NULL,_binary '',6,36,NULL,'Int Prop 1','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,6,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(507,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','BOOL_PROP_1','type/Boolean',NULL,_binary '',NULL,_binary '',12,36,NULL,'Bool Prop 1','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(508,'2024-06-19 14:18:23.118953','2024-06-19 14:18:27.600212','TRIGGER_NAME','type/Text','type/FK',_binary '',NULL,_binary '',1,36,NULL,'Trigger Name','normal',518,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(509,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','END_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',12,64,NULL,'End Time','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":0.0,\"avg\":0.0}}}',5,'BIGINT','auto-list',NULL,12,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(510,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','SCHED_NAME','type/Text','type/FK',_binary '',NULL,_binary '',0,64,NULL,'Sched Name','normal',478,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(511,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','PREV_FIRE_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',7,64,NULL,'Prev Fire Time','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-1.0,\"q1\":-1.0,\"q3\":-1.0,\"max\":-1.0,\"sd\":0.0,\"avg\":-1.0}}}',5,'BIGINT','auto-list',NULL,7,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(512,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','JOB_GROUP','type/Text','type/FK',_binary '',NULL,_binary '',4,64,NULL,'Job Group','normal',479,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'VARCHAR',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(513,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','TRIGGER_TYPE','type/Text','type/Category',_binary '',NULL,_binary '',10,64,NULL,'Trigger Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.0}}}',5,'VARCHAR','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(514,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','PRIORITY','type/Integer','type/Category',_binary '',NULL,_binary '',8,64,NULL,'Priority','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":5.0,\"q1\":5.0,\"q3\":5.0,\"max\":5.0,\"sd\":0.0,\"avg\":5.0}}}',5,'INT','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(515,'2024-06-19 14:18:23.211477','2024-06-19 14:18:28.580535','TRIGGER_GROUP','type/Text','type/PK',_binary '',NULL,_binary '',2,64,NULL,'Trigger Group','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(516,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','JOB_NAME','type/Text','type/FK',_binary '',NULL,_binary '',3,64,NULL,'Job Name','normal',474,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":9,\"nil%\":0.0}}',5,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(517,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','CALENDAR_NAME','type/Text',NULL,_binary '',NULL,_binary '',13,64,NULL,'Calendar Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(518,'2024-06-19 14:18:23.211477','2024-06-19 14:18:28.580535','TRIGGER_NAME','type/Text','type/PK',_binary '',NULL,_binary '',1,64,NULL,'Trigger Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(519,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','MISFIRE_INSTR','type/Integer','type/Category',_binary '',NULL,_binary '',14,64,NULL,'Misfire Instr','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":1.8759615953640392,\"max\":2.0,\"sd\":1.0540925533894598,\"avg\":0.8888888888888888}}}',5,'SMALLINT','auto-list',NULL,14,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(520,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','NEXT_FIRE_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',6,64,NULL,'Next Fire Time','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":8,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.7188083E12,\"q1\":1.718819505E12,\"q3\":1.718867745E12,\"max\":1.7190216E12,\"sd\":6.5615137735129386E7,\"avg\":1.7188585533333333E12}}}',5,'BIGINT','auto-list',NULL,6,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(521,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','TRIGGER_STATE','type/Text','type/Category',_binary '',NULL,_binary '',9,64,NULL,'Trigger State','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.0}}}',5,'VARCHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(522,'2024-06-19 14:18:23.211477','2024-06-19 14:18:28.580535','JOB_DATA','type/*',NULL,_binary '',NULL,_binary '',15,64,NULL,'Job Data','normal',NULL,NULL,NULL,NULL,NULL,0,'BLOB',NULL,NULL,15,0,'type/*',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(523,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','START_TIME','type/BigInteger','type/Category',_binary '',NULL,_binary '',11,64,NULL,'Start Time','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.718806416E12,\"q1\":1.7188064162403704E12,\"q3\":1.718806556E12,\"max\":1.718806695E12,\"sd\":122776.33231929425,\"avg\":1.7188064784444443E12}}}',5,'BIGINT','auto-list',NULL,11,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(524,'2024-06-19 14:18:23.211477','2024-06-19 14:18:48.863736','DESCRIPTION','type/Text','type/Description',_binary '',NULL,_binary '',5,64,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.7777777777777778},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.333333333333333}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(525,'2024-06-19 14:18:23.265854','2024-06-19 14:45:09.256760','query','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',2,24,NULL,'Query','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":259.0}}}',5,'LONGTEXT','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(526,'2024-06-19 14:18:23.265854','2024-06-19 14:18:27.239448','query_hash','type/*','type/PK',_binary '','The hash of the query dictionary. (This is a 256-bit SHA3 hash of the query dict.)',_binary '',0,24,NULL,'Query Hash','normal',NULL,NULL,NULL,NULL,NULL,0,'BINARY',NULL,NULL,0,0,'type/*',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(527,'2024-06-19 14:18:23.265854','2024-06-19 14:45:09.256760','average_execution_time','type/Integer','type/Category',_binary '','Average execution time for the query, round to nearest number of milliseconds. This is updated as a rolling average.',_binary '',1,24,NULL,'Average Execution Time','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":11.0,\"q1\":13.0,\"q3\":68.0,\"max\":79.0,\"sd\":33.04037933599835,\"avg\":40.5}}}',5,'INT','auto-list',NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(528,'2024-06-19 14:18:23.309090','2024-06-19 14:18:29.413681','database_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,81,NULL,'Database ID','normal',250,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(529,'2024-06-19 14:18:23.309090','2024-06-19 14:18:29.413681','dataset_query','type/Text',NULL,_binary '',NULL,_binary '',2,81,NULL,'Dataset Query','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(530,'2024-06-19 14:18:23.309090','2024-06-19 14:18:29.413681','action_id','type/Integer','type/FK',_binary '','The related action',_binary '',0,81,NULL,'Action ID','normal',78,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(531,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','error','type/Text',NULL,_binary '',NULL,_binary '',7,58,NULL,'Error','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(532,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','result_rows','type/Integer','type/Category',_binary '','Number of rows in the query results.',_binary '',4,58,NULL,'Result Rows','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.0,\"q3\":14.113628693451263,\"max\":43.0,\"sd\":5.769143685844939,\"avg\":1.7924528301886793}}}',5,'INT','auto-list',NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(533,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','started_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',2,58,NULL,'Started At','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":53,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:19:06.454153Z\",\"latest\":\"2024-06-19T06:44:53.92964Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(534,'2024-06-19 14:18:23.358230','2024-06-19 14:18:28.295433','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,58,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(535,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','is_sandboxed','type/Boolean','type/Category',_binary '',NULL,_binary '',15,58,NULL,'Is Sandboxed','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,15,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(536,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','database_id','type/Integer','type/Category',_binary '','ID of the database this query was ran against.',_binary '',12,58,NULL,'Database ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":2.0,\"max\":2.0,\"sd\":0.0,\"avg\":2.0}}}',5,'INT','auto-list',NULL,12,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(537,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','action_id','type/Integer',NULL,_binary '','The ID of the action associated with this query execution, if any.',_binary '',14,58,NULL,'Action ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,14,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(538,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','native','type/Boolean','type/Category',_binary '','Whether the query was a native query, as opposed to an MBQL one (e.g., created with the GUI).',_binary '',5,58,NULL,'Native','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,5,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(539,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','cache_hit','type/Boolean','type/Category',_binary '','Cache hit on query execution',_binary '',13,58,NULL,'Cache Hit','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,13,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(540,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','card_id','type/Integer','type/Category',_binary '','The ID of the Card (Question) associated with this query execution, if any.',_binary '',9,58,NULL,'Card ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.05660377358490566},\"type\":{\"type/Number\":{\"min\":27.0,\"q1\":27.0,\"q3\":27.0,\"max\":27.0,\"sd\":0.0,\"avg\":27.0}}}',5,'INT','auto-list',NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(541,'2024-06-19 14:18:23.358230','2024-06-19 14:18:28.295433','hash','type/*',NULL,_binary '','The hash of the query dictionary. This is a 256-bit SHA3 hash of the query.',_binary '',1,58,NULL,'Hash','normal',NULL,NULL,NULL,NULL,NULL,0,'BINARY',NULL,NULL,1,0,'type/*',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(542,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','executor_id','type/Integer','type/Category',_binary '','The ID of the User who triggered this query execution, if any.',_binary '',8,58,NULL,'Executor ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.3371339E7,\"q1\":1.3371339E7,\"q3\":1.3371339378453521E7,\"max\":1.3371341E7,\"sd\":0.35432226440586684,\"avg\":1.3371339094339622E7}}}',5,'INT','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(543,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','running_time','type/Integer',NULL,_binary '','The time, in milliseconds, this query took to complete.',_binary '',3,58,NULL,'Running Time','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":34,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":11.0,\"q1\":49.75,\"q3\":66.375,\"max\":101.0,\"sd\":16.402701643026084,\"avg\":58.094339622641506}}}',5,'INT','auto-list',NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(544,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','dashboard_id','type/Integer','type/Category',_binary '','The ID of the Dashboard associated with this query execution, if any.',_binary '',10,58,NULL,'Dashboard ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.1132075471698113},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":2.0,\"max\":2.0,\"sd\":0.0,\"avg\":2.0}}}',5,'INT','auto-list',NULL,10,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(545,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','pulse_id','type/Integer',NULL,_binary '','The ID of the Pulse associated with this query execution, if any.',_binary '',11,58,NULL,'Pulse ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,11,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(546,'2024-06-19 14:18:23.358230','2024-06-19 14:18:28.295433','cache_hash','type/*',NULL,_binary '','Hash of normalized query, calculated in middleware.cache',_binary '',16,58,NULL,'Cache Hash','normal',NULL,NULL,NULL,NULL,NULL,0,'BLOB',NULL,NULL,16,0,'type/*',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(547,'2024-06-19 14:18:23.358230','2024-06-19 14:45:09.256760','context','type/Text','type/Category',_binary '','Short string specifying how this query was executed, e.g. in a Dashboard or Pulse.',_binary '',6,58,NULL,'Context','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.773584905660377}}}',5,'VARCHAR','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(548,'2024-06-19 14:18:23.415577','2024-06-19 14:18:48.863736','direct_reference','type/Boolean','type/Category',_binary '','Is the Field referenced directly or via a wildcard',_binary '',3,99,NULL,'Direct Reference','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,3,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(549,'2024-06-19 14:18:23.415577','2024-06-19 14:18:48.863736','field_id','type/Integer','type/FK',_binary '','referenced field',_binary '',2,99,NULL,'Field ID','normal',290,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":17,\"nil%\":0.0}}',5,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(550,'2024-06-19 14:18:23.415577','2024-06-19 14:18:48.863736','card_id','type/Integer','type/FK',_binary '','referenced card',_binary '',1,99,NULL,'Card ID','normal',576,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.0}}',5,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(551,'2024-06-19 14:18:23.415577','2024-06-19 14:18:30.004009','id','type/Integer','type/PK',_binary '','PK',_binary '',0,99,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(552,'2024-06-19 14:18:23.465263','2024-06-19 14:45:09.256760','user_id','type/Integer','type/FK',_binary '','The user associated with this view',_binary '',1,56,NULL,'User ID','normal',163,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0}}',5,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(553,'2024-06-19 14:18:23.465263','2024-06-19 14:45:09.256760','model_id','type/Integer','type/Category',_binary '','The ID of the model that was viewed',_binary '',3,56,NULL,'Model ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":3.0,\"max\":27.0,\"sd\":10.132456102380443,\"avg\":6.333333333333333}}}',5,'INT','auto-list',NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(554,'2024-06-19 14:18:23.465263','2024-06-19 14:45:09.256760','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',4,56,NULL,'Timestamp','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":6,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:21:34.101784Z\",\"latest\":\"2024-06-19T06:44:53.781676Z\"}}}',5,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(555,'2024-06-19 14:18:23.465263','2024-06-19 14:45:09.256760','model','type/Text','type/Category',_binary '','The name of the model that was viewed',_binary '',2,56,NULL,'Model','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.5}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(556,'2024-06-19 14:18:23.465263','2024-06-19 14:18:28.198539','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,56,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(557,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','visualization_settings','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',7,73,NULL,'Visualization Settings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":20,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":183.65384615384616}}}',5,'LONGTEXT','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(558,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','dataset_query','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',6,73,NULL,'Dataset Query','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":332.0769230769231}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(559,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','collection_position','type/Integer','type/Category',_binary '','Optional pinned position for this item in its Collection. NULL means item is not pinned.',_binary '',20,73,NULL,'Collection Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9615384615384615},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.0,\"q3\":1.0,\"max\":1.0,\"sd\":null,\"avg\":1.0}}}',5,'SMALLINT','auto-list',NULL,20,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(560,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','archived','type/Boolean','type/Category',_binary '',NULL,_binary '',12,73,NULL,'Archived','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(561,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','type','type/Text','type/Category',_binary '','The type of card, could be \'question\', \'model\', \'metric\'',_binary '',26,73,NULL,'Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.884615384615385}}}',5,'VARCHAR','auto-list',NULL,26,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(562,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','metabase_version','type/Text',NULL,_binary '','Metabase version used to create the card.',_binary '',25,73,NULL,'Metabase Version','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,25,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(563,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','cache_invalidated_at','type/DateTimeWithLocalTZ',NULL,_binary '','An invalidation time that can supersede cache_config.invalidated_at',_binary '',28,73,NULL,'Cache Invalidated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/DateTime\":{\"earliest\":null,\"latest\":null}}}',5,'TIMESTAMP',NULL,NULL,28,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(564,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',8,73,NULL,'Creator ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,8,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(565,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','view_count','type/Integer','type/Quantity',_binary '','Keeps a running count of card views',_binary '',30,73,NULL,'View Count','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":0.0,\"avg\":0.0}}}',5,'INT','auto-list',NULL,30,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(566,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','table_id','type/Integer','type/FK',_binary '',NULL,_binary '',10,73,NULL,'Table ID','normal',314,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0}}',5,'INT',NULL,NULL,10,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(567,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','cache_ttl','type/Integer',NULL,_binary '','The maximum time, in seconds, to return cached results for this Card rather than running a new query.',_binary '',18,73,NULL,'Cache Ttl','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,18,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(568,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','initially_published_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp when the card was first published in a static embed',_binary '',27,73,NULL,'Initially Published At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/DateTime\":{\"earliest\":null,\"latest\":null}}}',5,'TIMESTAMP',NULL,NULL,27,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(569,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','last_used_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the card is last used',_binary '',29,73,NULL,'Last Used At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,29,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(570,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','enable_embedding','type/Boolean','type/Category',_binary '','Is this Card allowed to be embedded in different websites (using a signed JWT)?',_binary '',16,73,NULL,'Enable Embedding','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,16,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(571,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','display','type/Text','type/Category',_binary '',NULL,_binary '',5,73,NULL,'Display','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":11,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.769230769230769}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(572,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','entity_id','type/Text','type/Category',_binary '','Random NanoID tag for unique identity.',_binary '',21,73,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.0}}}',5,'CHAR','auto-list',NULL,21,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(573,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','query_type','type/Text','type/Category',_binary '',NULL,_binary '',11,73,NULL,'Query Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.0}}}',5,'VARCHAR','auto-list',NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(574,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',4,73,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":21,\"nil%\":0.1538461538461538},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":65.07692307692308}}}',5,'LONGTEXT','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(575,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',3,73,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":27.76923076923077}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(576,'2024-06-19 14:18:23.528199','2024-06-19 14:18:28.814633','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,73,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(577,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','result_metadata','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',19,73,NULL,'Result Metadata','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":1003.1538461538462}}}',5,'LONGTEXT','auto-list',NULL,19,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(578,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,73,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(579,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','collection_id','type/Integer','type/FK',_binary '','Optional ID of Collection this Card belongs to.',_binary '',13,73,NULL,'Collection ID','normal',131,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,13,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(580,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','collection_preview','type/Boolean','type/Category',_binary '',NULL,_binary '',24,73,NULL,'Collection Preview','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,24,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(581,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','parameter_mappings','type/Text','type/SerializedJSON',_binary '','List of parameter associated to a card',_binary '',23,73,NULL,'Parameter Mappings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":2.0}}}',5,'LONGTEXT','auto-list',NULL,23,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(582,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,73,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(583,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','parameters','type/Text','type/SerializedJSON',_binary '','List of parameter associated to a card',_binary '',22,73,NULL,'Parameters','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":2.0}}}',5,'LONGTEXT','auto-list',NULL,22,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(584,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','made_public_by_id','type/Integer','type/FK',_binary '','The ID of the User who first publically shared this Card.',_binary '',15,73,NULL,'Made Public By ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'INT',NULL,NULL,15,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(585,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','embedding_params','type/Text',NULL,_binary '',NULL,_binary '',17,73,NULL,'Embedding Params','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,17,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(586,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','database_id','type/Integer','type/FK',_binary '',NULL,_binary '',9,73,NULL,'Database ID','normal',250,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,9,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(587,'2024-06-19 14:18:23.528199','2024-06-19 14:18:48.863736','public_uuid','type/Text',NULL,_binary '','Unique UUID used to in publically-accessible links to this Card.',_binary '',14,73,NULL,'Public UUID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'CHAR','auto-list',NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(588,'2024-06-19 14:18:23.601767','2024-06-19 14:18:28.426922','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',2,62,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(589,'2024-06-19 14:18:23.601767','2024-06-19 14:18:28.426922','owner_id','type/Integer','type/FK',_binary '',NULL,_binary '',4,62,NULL,'Owner ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(590,'2024-06-19 14:18:23.601767','2024-06-19 14:18:28.426922','card_id','type/Integer','type/FK',_binary '',NULL,_binary '',3,62,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(591,'2024-06-19 14:18:23.601767','2024-06-19 14:18:28.426922','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,62,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(592,'2024-06-19 14:18:23.601767','2024-06-19 14:18:28.426922','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',1,62,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(593,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',3,59,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":19.0}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(594,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','caveats','type/Text',NULL,_binary '',NULL,_binary '',8,59,NULL,'Caveats','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(595,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',5,59,NULL,'Creator ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(596,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','entity_id','type/Text','type/Category',_binary '','Random NanoID tag for unique identity.',_binary '',19,59,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.0}}}',5,'CHAR','auto-list',NULL,19,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(597,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','initially_published_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp when the dashboard was first published in a static embed',_binary '',22,59,NULL,'Initially Published At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/DateTime\":{\"earliest\":null,\"latest\":null}}}',5,'TIMESTAMP',NULL,NULL,22,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(598,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','show_in_getting_started','type/Boolean','type/Category',_binary '',NULL,_binary '',9,59,NULL,'Show In Getting Started','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,9,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(599,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','position','type/Integer',NULL,_binary '','The position this Dashboard should appear in the Dashboards list, lower-numbered positions appearing before higher numbered ones.',_binary '',15,59,NULL,'Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,15,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(600,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','width','type/Text','type/Category',_binary '',NULL,_binary '',21,59,NULL,'Width','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.0}}}',5,'VARCHAR','auto-list',NULL,21,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(601,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','view_count','type/Integer','type/Quantity',_binary '','Keeps a running count of dashboard views',_binary '',23,59,NULL,'View Count','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":null,\"avg\":0.0}}}',5,'INT','auto-list',NULL,23,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(602,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','parameters','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',6,59,NULL,'Parameters','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":453.0}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(603,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','auto_apply_filters','type/Boolean','type/Category',_binary '',NULL,_binary '',20,59,NULL,'Auto Apply Filters','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,20,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(604,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','cache_ttl','type/Integer',NULL,_binary '','Granular cache TTL for specific dashboard.',_binary '',18,59,NULL,'Cache Ttl','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,18,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(605,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,59,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(606,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,59,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(607,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','points_of_interest','type/Text',NULL,_binary '',NULL,_binary '',7,59,NULL,'Points Of Interest','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(608,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','collection_id','type/Integer','type/FK',_binary '','Optional ID of Collection this Dashboard belongs to.',_binary '',16,59,NULL,'Collection ID','normal',131,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,16,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(609,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','enable_embedding','type/Boolean','type/Category',_binary '','Is this Dashboard allowed to be embedded in different websites (using a signed JWT)?',_binary '',12,59,NULL,'Enable Embedding','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,12,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(610,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','embedding_params','type/Text',NULL,_binary '',NULL,_binary '',13,59,NULL,'Embedding Params','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(611,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',4,59,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":237.0}}}',5,'LONGTEXT','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(612,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','public_uuid','type/Text',NULL,_binary '','Unique UUID used to in publically-accessible links to this Dashboard.',_binary '',10,59,NULL,'Public UUID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'CHAR','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(613,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','archived','type/Boolean','type/Category',_binary '','Is this Dashboard archived (effectively treated as deleted?)',_binary '',14,59,NULL,'Archived','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,14,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(614,'2024-06-19 14:18:23.657356','2024-06-19 14:18:28.341987','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,59,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(615,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','collection_position','type/Integer','type/Category',_binary '','Optional pinned position for this item in its Collection. NULL means item is not pinned.',_binary '',17,59,NULL,'Collection Position','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":2.0,\"max\":2.0,\"sd\":null,\"avg\":2.0}}}',5,'SMALLINT','auto-list',NULL,17,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(616,'2024-06-19 14:18:23.657356','2024-06-19 14:18:48.863736','made_public_by_id','type/Integer','type/FK',_binary '','The ID of the User who first publically shared this Dashboard.',_binary '',11,59,NULL,'Made Public By ID','normal',163,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'INT',NULL,NULL,11,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(617,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',11,76,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":31,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.0}}}',5,'CHAR','auto-list',NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(618,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','card_id','type/Integer','type/FK',_binary '',NULL,_binary '',7,76,NULL,'Card ID','normal',576,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":25,\"nil%\":0.2258064516129032}}',5,'INT',NULL,NULL,7,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(619,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','visualization_settings','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',10,76,NULL,'Visualization Settings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":29,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":317.93548387096774}}}',5,'LONGTEXT','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(620,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,76,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(621,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','size_x','type/Integer','type/Category',_binary '',NULL,_binary '',3,76,NULL,'Size X','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":7,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":6.0,\"q1\":6.958187643906492,\"q3\":20.04956999276797,\"max\":24.0,\"sd\":7.211549875921487,\"avg\":13.838709677419354}}}',5,'INT','auto-list',NULL,3,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(622,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','dashboard_tab_id','type/Integer','type/FK',_binary '','The referenced tab id that dashcard is on, it\'s nullable for dashboard with no tab',_binary '',13,76,NULL,'Dashboard Tab ID','normal',177,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0}}',5,'INT',NULL,NULL,13,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(623,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','row','type/Integer','type/Category',_binary '',NULL,_binary '',5,76,NULL,'Row','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":15,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":1.1958944516674581,\"q3\":13.625,\"max\":20.0,\"sd\":6.9861614362182625,\"avg\":7.838709677419355}}}',5,'INT','auto-list',NULL,5,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(624,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','col','type/Integer','type/Category',_binary '',NULL,_binary '',6,76,NULL,'Col','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":6,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":11.418861169915811,\"max\":18.0,\"sd\":7.194531973838232,\"avg\":5.806451612903226}}}',5,'INT','auto-list',NULL,6,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(625,'2024-06-19 14:18:23.717743','2024-06-19 14:18:29.071664','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,76,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(626,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','parameter_mappings','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',9,76,NULL,'Parameter Mappings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":25,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":323.61290322580646}}}',5,'LONGTEXT','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(627,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','size_y','type/Integer','type/Category',_binary '',NULL,_binary '',4,76,NULL,'Size Y','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":7,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":2.5,\"q3\":5.9771059563342,\"max\":11.0,\"sd\":2.369156648642392,\"avg\":4.290322580645161}}}',5,'INT','auto-list',NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(628,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','dashboard_id','type/Integer','type/FK',_binary '',NULL,_binary '',8,76,NULL,'Dashboard ID','normal',614,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,8,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(629,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','action_id','type/Integer','type/FK',_binary '','The related action',_binary '',12,76,NULL,'Action ID','normal',78,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0}}',5,'INT',NULL,NULL,12,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(630,'2024-06-19 14:18:23.717743','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',2,76,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(631,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','model_id','type/Integer','type/Category',_binary '',NULL,_binary '',2,38,NULL,'Model ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":15.789934334069043,\"max\":27.0,\"sd\":10.540925533894598,\"avg\":7.0}}}',5,'INT','auto-list',NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(632,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','model','type/Text','type/Category',_binary '',NULL,_binary '',1,38,NULL,'Model','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.0}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(633,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','user_id','type/Integer','type/FK',_binary '',NULL,_binary '',3,38,NULL,'User ID','normal',163,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(634,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','is_reversion','type/Boolean','type/Category',_binary '',NULL,_binary '',6,38,NULL,'Is Reversion','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,6,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(635,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','metabase_version','type/Text','type/Category',_binary '','Metabase version used to create the revision.',_binary '',10,38,NULL,'Metabase Version','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":17.0}}}',5,'VARCHAR','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(636,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',4,38,NULL,'Timestamp','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":10,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:20:52Z\",\"latest\":\"2024-06-19T14:34:07Z\"}}}',5,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(637,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','message','type/Text',NULL,_binary '',NULL,_binary '',8,38,NULL,'Message','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(638,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','most_recent','type/Boolean','type/Category',_binary '',NULL,_binary '',9,38,NULL,'Most Recent','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,9,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(639,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','is_creation','type/Boolean','type/Category',_binary '',NULL,_binary '',7,38,NULL,'Is Creation','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,7,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(640,'2024-06-19 14:18:23.764178','2024-06-19 14:45:09.256760','object','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',5,38,NULL,'Object','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":9,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":439.7}}}',5,'LONGTEXT','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(641,'2024-06-19 14:18:23.764178','2024-06-19 14:18:27.677229','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,38,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(642,'2024-06-19 14:18:23.811329','2024-06-19 14:18:27.964092','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,46,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(643,'2024-06-19 14:18:23.811329','2024-06-19 14:18:27.964092','attribute_remappings','type/Text',NULL,_binary '',NULL,_binary '',4,46,NULL,'Attribute Remappings','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(644,'2024-06-19 14:18:23.811329','2024-06-19 14:18:27.964092','group_id','type/Integer','type/FK',_binary '','ID of the Permissions Group this policy affects.',_binary '',1,46,NULL,'Group ID','normal',386,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(645,'2024-06-19 14:18:23.811329','2024-06-19 14:18:27.964092','card_id','type/Integer','type/FK',_binary '',NULL,_binary '',3,46,NULL,'Card ID','normal',576,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(646,'2024-06-19 14:18:23.811329','2024-06-19 14:18:27.964092','permission_id','type/Integer',NULL,_binary '','The ID of the corresponding permissions path for this sandbox',_binary '',5,46,NULL,'Permission ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(647,'2024-06-19 14:18:23.811329','2024-06-19 14:18:27.964092','table_id','type/Integer','type/FK',_binary '','ID of the Table that should get automatically replaced as query source for the Permissions Group.',_binary '',2,46,NULL,'Table ID','normal',314,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(648,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','name','type/Text',NULL,_binary '','The name of this secret record.',_binary '',5,75,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(649,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','value','type/*',NULL,_binary '',NULL,_binary '',8,75,NULL,'Value','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGBLOB',NULL,NULL,8,0,'type/*',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(650,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','creator_id','type/Integer','type/FK',_binary '','User ID who created this secret instance',_binary '',2,75,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(651,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','kind','type/Text',NULL,_binary '','The kind of secret this record represents; the value is interpreted as a Clojure keyword with a hierarchy. Ex: \'bytes\' means generic binary data, \'jks-keystore\' extends \'bytes\' but has a specific meaning.',_binary '',6,75,NULL,'Kind','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(652,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','id','type/Integer','type/PK',_binary '','Part of composite primary key for secret; this is the uniquely generted ID column',_binary '',0,75,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(653,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','Timestamp for when this secret record was updated. Only relevant when non-value field changes since a value change will result in a new version being inserted.',_binary '',4,75,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(654,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','version','type/Integer','type/PK',_binary '','Part of composite primary key for secret; this is the version column',_binary '',1,75,NULL,'Version','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(655,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','Timestamp for when this secret instance was created',_binary '',3,75,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(656,'2024-06-19 14:18:23.870071','2024-06-19 14:18:28.987970','source','type/Text',NULL,_binary '','The source of secret record, which controls how Metabase interprets the value (ex: \'file-path\' means the \'simple_value\' is not the real value, but a pointer to a file that contains the value).',_binary '',7,75,NULL,'Source','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(657,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','points_of_interest','type/Text',NULL,_binary '',NULL,_binary '',9,32,NULL,'Points Of Interest','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(658,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','show_in_getting_started','type/Boolean',NULL,_binary '',NULL,_binary '',11,32,NULL,'Show In Getting Started','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(659,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','caveats','type/Text',NULL,_binary '',NULL,_binary '',10,32,NULL,'Caveats','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(660,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','archived','type/Boolean',NULL,_binary '',NULL,_binary '',5,32,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(661,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','name','type/Text',NULL,_binary '',NULL,_binary '',3,32,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(662,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',8,32,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,8,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(663,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','definition','type/Text',NULL,_binary '',NULL,_binary '',6,32,NULL,'Definition','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(664,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',12,32,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(665,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','description','type/Text',NULL,_binary '',NULL,_binary '',4,32,NULL,'Description','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(666,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',7,32,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(667,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,32,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(668,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','creator_id','type/Integer','type/FK',_binary '',NULL,_binary '',2,32,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,2,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(669,'2024-06-19 14:18:23.914469','2024-06-19 14:18:27.500876','table_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,32,NULL,'Table ID','normal',314,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(670,'2024-06-19 14:18:23.956300','2024-06-19 21:00:09.113785','value','type/Text','type/Category',_binary '',NULL,_binary '',1,71,NULL,'Value','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":13,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.07142857142857142,\"percent-email\":0.07142857142857142,\"percent-state\":0.0,\"average-length\":15.571428571428571}}}',5,'LONGTEXT',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(671,'2024-06-19 14:18:23.956300','2024-06-19 14:18:28.704948','key','type/Text','type/PK',_binary '',NULL,_binary '',0,71,NULL,'Key','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,0,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(672,'2024-06-19 14:18:24.007671','2024-06-19 14:18:48.863736','user_id','type/BigInteger',NULL,_binary '',NULL,_binary '',1,42,NULL,'User ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":393,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":101850.0,\"q1\":319107.52299782896,\"q3\":746180.6224582847,\"max\":993953.0,\"sd\":251196.11526894735,\"avg\":526777.4452926209}}}',5,'BIGINT','auto-list',NULL,1,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(673,'2024-06-19 14:18:24.007671','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',2,42,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":378,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.374045801526718}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(674,'2024-06-19 14:18:24.007671','2024-06-19 14:18:48.863736','mid','type/BigInteger',NULL,_binary '',NULL,_binary '',0,42,NULL,'Mid','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":393,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":3.0,\"q1\":997.0745647699475,\"q3\":161965.67987006973,\"max\":312807.0,\"sd\":98087.25760272479,\"avg\":77561.11450381679}}}',5,'BIGINT','auto-list',NULL,0,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(675,'2024-06-19 14:18:24.074448','2024-06-19 14:18:27.828698','role','type/Text',NULL,_binary '','Role name. NULL indicates the privileges are the current user\'s',_binary '',1,43,NULL,'Role','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(676,'2024-06-19 14:18:24.074448','2024-06-19 14:18:27.828698','table_id','type/Integer','type/FK',_binary '','Table ID',_binary '',0,43,NULL,'Table ID','normal',314,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(677,'2024-06-19 14:18:24.074448','2024-06-19 14:18:27.828698','select','type/Boolean',NULL,_binary '',NULL,_binary '',2,43,NULL,'Select','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,2,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(678,'2024-06-19 14:18:24.074448','2024-06-19 14:18:27.828698','insert','type/Boolean',NULL,_binary '',NULL,_binary '',4,43,NULL,'Insert','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,4,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(679,'2024-06-19 14:18:24.074448','2024-06-19 14:18:27.828698','update','type/Boolean',NULL,_binary '',NULL,_binary '',3,43,NULL,'Update','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,3,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(680,'2024-06-19 14:18:24.074448','2024-06-19 14:18:27.828698','delete','type/Boolean',NULL,_binary '',NULL,_binary '',5,43,NULL,'Delete','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(681,'2024-06-19 14:18:24.122516','2024-06-19 14:18:48.863736','task','type/Text','type/Category',_binary '','Name of the task',_binary '',1,105,NULL,'Task','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":16,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.592592592592593}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(682,'2024-06-19 14:18:24.122516','2024-06-19 14:18:30.203421','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,105,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(683,'2024-06-19 14:18:24.122516','2024-06-19 14:18:48.863736','started_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',3,105,NULL,'Started At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":27,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:13:30.792604Z\",\"latest\":\"2024-06-19T06:18:30.430338Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(684,'2024-06-19 14:18:24.122516','2024-06-19 14:18:48.863736','db_id','type/Integer','type/Category',_binary '',NULL,_binary '',2,105,NULL,'Db ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.0,\"q3\":1.8891559983417312,\"max\":2.0,\"sd\":0.5007117441325405,\"avg\":1.4074074074074074}}}',5,'INT','auto-list',NULL,2,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(685,'2024-06-19 14:18:24.122516','2024-06-28 21:00:11.023547','duration','type/Integer','type/Duration',_binary '',NULL,_binary '',5,105,NULL,'Duration','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.07407407407407407},\"type\":{\"type/Number\":{\"min\":10.0,\"q1\":54.5,\"q3\":2245.25,\"max\":14839.0,\"sd\":3166.212844498403,\"avg\":1634.12}}}',5,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(686,'2024-06-19 14:18:24.122516','2024-06-19 14:18:48.863736','task_details','type/Text','type/Category',_binary '',NULL,_binary '',6,105,NULL,'Task Details','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":19,\"nil%\":0.2962962962962963},\"type\":{\"type/Text\":{\"percent-json\":0.7037037037037037,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":29.62962962962963}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(687,'2024-06-19 14:18:24.122516','2024-06-19 14:18:48.863736','status','type/Text','type/Category',_binary '','the status of task history, could be started, failed, success, unknown',_binary '',7,105,NULL,'Status','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.0}}}',5,'VARCHAR','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(688,'2024-06-19 14:18:24.122516','2024-06-19 14:18:48.863736','ended_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',4,105,NULL,'Ended At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.07407407407407407},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:13:30.852284Z\",\"latest\":\"2024-06-19T06:18:30.350768Z\"}}}',5,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(689,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','entity_id','type/Text',NULL,_binary '','Random NanoID tag for unique identity.',_binary '',10,104,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'CHAR',NULL,NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(690,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','default','type/Boolean',NULL,_binary '',NULL,_binary '',9,104,NULL,'Default','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,9,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(691,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','name','type/Text',NULL,_binary '','Name of the timeline',_binary '',1,104,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(692,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','creator_id','type/Integer','type/FK',_binary '','ID of the user who created the timeline',_binary '',6,104,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,6,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(693,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the timeline was created',_binary '',7,104,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(694,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','icon','type/Text',NULL,_binary '',NULL,_binary '',3,104,NULL,'Icon','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(695,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','archived','type/Boolean',NULL,_binary '',NULL,_binary '',5,104,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(696,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,104,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(697,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','description','type/Text',NULL,_binary '','Optional description of the timeline',_binary '',2,104,NULL,'Description','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(698,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','collection_id','type/Integer','type/FK',_binary '','ID of the collection containing the timeline',_binary '',4,104,NULL,'Collection ID','normal',131,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(699,'2024-06-19 14:18:24.174041','2024-06-19 14:18:30.170796','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the timeline was updated',_binary '',8,104,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,8,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(700,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','description','type/Text',NULL,_binary '','Optional markdown description of the event',_binary '',3,94,NULL,'Description','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(701,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','name','type/Text',NULL,_binary '','Name of the event',_binary '',2,94,NULL,'Name','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(702,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','archived','type/Boolean',NULL,_binary '',NULL,_binary '',8,94,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,8,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(703,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','icon','type/Text',NULL,_binary '',NULL,_binary '',7,94,NULL,'Icon','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(704,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,94,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(705,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','time_matters','type/Boolean',NULL,_binary '',NULL,_binary '',5,94,NULL,'Time Matters','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(706,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','created_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the event was created',_binary '',10,94,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,10,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(707,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','timeline_id','type/Integer','type/FK',_binary '','ID of the timeline containing the event',_binary '',1,94,NULL,'Timeline ID','normal',696,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(708,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '','When the event happened',_binary '',4,94,NULL,'Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(709,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '','The timestamp of when the event was modified',_binary '',11,94,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,11,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(710,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','timezone','type/Text',NULL,_binary '','Timezone to display the underlying UTC timestamp in for the client',_binary '',6,94,NULL,'Timezone','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(711,'2024-06-19 14:18:24.227132','2024-06-19 14:18:29.884634','creator_id','type/Integer','type/FK',_binary '','ID of the user who created the event',_binary '',9,94,NULL,'Creator ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,9,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(712,'2024-06-19 14:18:24.278365','2024-06-19 14:18:29.575877','parameter_id','type/Text',NULL,_binary '','The parameter ID',_binary '',2,84,NULL,'Parameter ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(713,'2024-06-19 14:18:24.278365','2024-06-19 14:18:29.575877','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,84,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(714,'2024-06-19 14:18:24.278365','2024-06-19 14:18:29.575877','value','type/Text',NULL,_binary '','Value of the parameter',_binary '',3,84,NULL,'Value','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(715,'2024-06-19 14:18:24.278365','2024-06-19 14:18:29.575877','user_id','type/Integer','type/FK',_binary '','ID of the User who has set the parameter value',_binary '',1,84,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(716,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','recipients','type/Text',NULL,_binary '',NULL,_binary '',13,98,NULL,'Recipients','normal',NULL,NULL,NULL,NULL,NULL,0,'MEDIUMTEXT',NULL,NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(717,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','alert_condition','type/Text',NULL,_binary '','Condition (i.e. \"rows\" or \"goal\") used as a guard for alerts',_binary '',7,98,NULL,'Alert Condition','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(718,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','card_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',6,98,NULL,'Card Qualified ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(719,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',3,98,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(720,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','archived','type/Boolean',NULL,_binary '','Has this pulse been archived?',_binary '',11,98,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(721,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',0,98,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(722,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','recipient_type','type/Text',NULL,_binary '',NULL,_binary '',12,98,NULL,'Recipient Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(723,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','recipient_external','type/Text',NULL,_binary '',NULL,_binary '',14,98,NULL,'Recipient External','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(724,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','schedule_type','type/Text',NULL,_binary '',NULL,_binary '',8,98,NULL,'Schedule Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(725,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','creator_id','type/Integer',NULL,_binary '',NULL,_binary '',4,98,NULL,'Creator ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(726,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',1,98,NULL,'Entity Qualified ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(727,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','card_id','type/Integer',NULL,_binary '',NULL,_binary '',5,98,NULL,'Card ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(728,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','schedule_day','type/Text',NULL,_binary '',NULL,_binary '',9,98,NULL,'Schedule Day','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(729,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','schedule_hour','type/Integer',NULL,_binary '',NULL,_binary '',10,98,NULL,'Schedule Hour','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,10,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(730,'2024-06-19 14:18:24.330736','2024-06-19 14:18:24.330736','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',2,98,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(731,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','entity_id','type/Integer',NULL,_binary '','The ID of the model this event applies to, if applicable',_binary '',6,33,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,6,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(732,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','details','type/Text',NULL,_binary '','A JSON map with metadata about the event',_binary '',8,33,NULL,'Details','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,8,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(733,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','user_id','type/BigInteger',NULL,_binary '',NULL,_binary '',4,33,NULL,'User ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,4,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(734,'2024-06-19 14:18:24.392967','2024-06-19 14:18:48.863736','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,33,NULL,'ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,NULL,5,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(735,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','topic','type/Text',NULL,_binary '',NULL,_binary '',1,33,NULL,'Topic','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(736,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','end_timestamp','type/*',NULL,_binary '',NULL,_binary '',3,33,NULL,'End Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'BINARY',NULL,NULL,3,0,'type/*',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(737,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','entity_type','type/Text',NULL,_binary '',NULL,_binary '',5,33,NULL,'Entity Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(738,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',7,33,NULL,'Entity Qualified ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(739,'2024-06-19 14:18:24.392967','2024-06-19 14:18:24.392967','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '','The time an event was recorded',_binary '',2,33,NULL,'Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(740,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','collection_is_personal','type/BigInteger','type/Category',_binary '',NULL,_binary '',15,77,NULL,'Collection Is Personal','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.9310344827586207},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":1.0,\"max\":1.0,\"sd\":0.7071067811865476,\"avg\":0.5}}}',5,'BIGINT','auto-list',NULL,15,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(741,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','collection_is_official','type/BigInteger','type/Category',_binary '',NULL,_binary '',14,77,NULL,'Collection Is Official','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9310344827586207},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":0.0,\"avg\":0.0}}}',5,'BIGINT','auto-list',NULL,14,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(742,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','question_viz_type','type/Text','type/Category',_binary '',NULL,_binary '',16,77,NULL,'Question Viz Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":12,\"nil%\":0.103448275862069},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.172413793103448}}}',5,'VARCHAR','auto-list',NULL,16,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(743,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','archived','type/Boolean','type/Category',_binary '',NULL,_binary '',11,77,NULL,'Archived','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(744,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',3,77,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:21.604528Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(745,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','creator_id','type/Integer','type/Author',_binary '',NULL,_binary '',5,77,NULL,'Creator ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.06896551724137931},\"type\":{\"type/Number\":{\"min\":1.3371338E7,\"q1\":1.3371338E7,\"q3\":1.3371338E7,\"max\":1.3371338E7,\"sd\":0.0,\"avg\":1.3371338E7}}}',5,'INT','auto-list',NULL,5,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(746,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',6,77,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":29,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":26.310344827586206}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(747,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','question_is_native','type/BigInteger','type/Category',_binary '',NULL,_binary '',18,77,NULL,'Question Is Native','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.103448275862069},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.0,\"max\":0.0,\"sd\":0.0,\"avg\":0.0}}}',5,'BIGINT','auto-list',NULL,18,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(748,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',4,77,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.06896551724137931},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(749,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','is_embedding_enabled','type/Boolean','type/Category',_binary '',NULL,_binary '',10,77,NULL,'Is Embedding Enabled','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.06896551724137931}}',5,'BIT','auto-list',NULL,10,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(750,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','entity_id','type/Integer','type/Category',_binary '',NULL,_binary '',0,77,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":4.75,\"q3\":19.25,\"max\":26.0,\"sd\":8.153242879868603,\"avg\":12.241379310344827}}}',5,'INT','auto-list',NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(751,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','question_database_id','type/Text','type/Category',_binary '',NULL,_binary '',17,77,NULL,'Question Database ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.103448275862069},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.96551724137931}}}',5,'VARCHAR','auto-list',NULL,17,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(752,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','entity_type','type/Text','type/Category',_binary '',NULL,_binary '',2,77,NULL,'Entity Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.068965517241379}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(753,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','collection_id','type/Integer','type/Category',_binary '',NULL,_binary '',8,77,NULL,'Collection ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.06896551724137931},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.0,\"q3\":1.0,\"max\":1.0,\"sd\":0.0,\"avg\":1.0}}}',5,'INT','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(754,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',7,77,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":22,\"nil%\":0.2068965517241379},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":66.51724137931035}}}',5,'LONGTEXT','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(755,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','action_model_id','type/Integer',NULL,_binary '',NULL,_binary '',13,77,NULL,'Action Model ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,13,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(756,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','made_public_by_user','type/Integer',NULL,_binary '',NULL,_binary '',9,77,NULL,'Made Public By User','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(757,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','entity_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',1,77,NULL,'Entity Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":29,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.172413793103448}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(758,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','action_type','type/Text','type/Category',_binary '',NULL,_binary '',12,77,NULL,'Action Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(759,'2024-06-19 14:18:24.442180','2024-06-19 14:18:48.863736','event_timestamp','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',19,77,NULL,'Event Timestamp','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/DateTime\":{\"earliest\":null,\"latest\":null}}}',5,'TIMESTAMP',NULL,NULL,19,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(760,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',0,11,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":31,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":8.25,\"q3\":23.75,\"max\":31.0,\"sd\":9.092121131323903,\"avg\":16.0}}}',5,'INT','auto-list',NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(761,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','visualization_settings','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',9,11,NULL,'Visualization Settings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":29,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":317.93548387096774}}}',5,'LONGTEXT','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(762,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','dashboardtab_id','type/Text','type/Category',_binary '',NULL,_binary '',3,11,NULL,'Dashboardtab ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.0}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(763,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','size_y','type/Integer','type/Category',_binary '',NULL,_binary '',8,11,NULL,'Size Y','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":7,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":2.5,\"q3\":5.9771059563342,\"max\":11.0,\"sd\":2.369156648642392,\"avg\":4.290322580645161}}}',5,'INT','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(764,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',1,11,NULL,'Entity Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":31,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":15.709677419354838}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(765,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','parameter_mappings','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',10,11,NULL,'Parameter Mappings','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":25,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":323.61290322580646}}}',5,'LONGTEXT','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(766,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',5,11,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,5,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(767,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','size_x','type/Integer','type/Category',_binary '',NULL,_binary '',7,11,NULL,'Size X','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":7,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":6.0,\"q1\":6.958187643906492,\"q3\":20.04956999276797,\"max\":24.0,\"sd\":7.211549875921487,\"avg\":13.838709677419354}}}',5,'INT','auto-list',NULL,7,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(768,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','dashboard_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',2,11,NULL,'Dashboard Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":11.0}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(769,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',6,11,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:13:29Z\"}}}',5,'TIMESTAMP',NULL,NULL,6,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(770,'2024-06-19 14:18:24.501726','2024-06-19 14:18:48.863736','card_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',4,11,NULL,'Card Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":25,\"nil%\":0.2258064516129032},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.161290322580645}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(771,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','creator_id','type/Integer','type/Author',_binary '','ID of the admin who added the database',_binary '',13,53,NULL,'Creator ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Number\":{\"min\":1.3371339E7,\"q1\":1.3371339E7,\"q3\":1.3371339E7,\"max\":1.3371339E7,\"sd\":null,\"avg\":1.3371339E7}}}',5,'INT','auto-list',NULL,13,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(772,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','cache_ttl','type/Integer',NULL,_binary '','Granular cache TTL for specific database.',_binary '',12,53,NULL,'Cache Ttl','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,12,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(773,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','auto_run_queries','type/Boolean','type/Category',_binary '','Whether to automatically run queries when doing simple filtering and summarizing in the Query Builder.',_binary '',11,53,NULL,'Auto Run Queries','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(774,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','metadata_sync_schedule','type/Text','type/Category',_binary '','The cron schedule string for when this database should undergo the metadata sync process (and analysis for new fields).',_binary '',7,53,NULL,'Metadata Sync Schedule','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.0}}}',5,'VARCHAR','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(775,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','cache_field_values_schedule','type/Text','type/Category',_binary '',NULL,_binary '',8,53,NULL,'Cache Field Values Schedule','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.0}}}',5,'VARCHAR','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(776,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',5,53,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.5},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":23.0}}}',5,'LONGTEXT','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(777,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',3,53,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:33.229352Z\",\"latest\":\"2024-06-19T14:18:30.374485Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(778,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','entity_id','type/Integer','type/Category',_binary '',NULL,_binary '',0,53,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.0,\"q3\":2.0,\"max\":2.0,\"sd\":0.7071067811865476,\"avg\":1.5}}}',5,'INT','auto-list',NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(779,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','timezone','type/Text','type/Category',_binary '','Timezone identifier for the database, set by the sync process',_binary '',9,53,NULL,'Timezone','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.5}}}',5,'VARCHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(780,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',2,53,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:15.158438Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(781,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','entity_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',1,53,NULL,'Entity Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":10.0}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(782,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','is_on_demand','type/Boolean','type/Category',_binary '','Whether we should do On-Demand caching of FieldValues for this DB. This means FieldValues are updated when their Field is used in a Dashboard or Card param.',_binary '',10,53,NULL,'Is On Demand','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,10,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(783,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','db_version','type/Text','type/SerializedJSON',_binary '','A JSON object describing the flavor and version of the DBMS.',_binary '',14,53,NULL,'Db Version','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":67.0}}}',5,'LONGTEXT','auto-list',NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(784,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',4,53,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(785,'2024-06-19 14:18:24.552683','2024-06-19 14:18:48.863736','database_type','type/Text','type/Category',_binary '',NULL,_binary '',6,53,NULL,'Database Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":3.5}}}',5,'VARCHAR','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(786,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','has_field_values','type/Text','type/Category',_binary '',NULL,_binary '',10,65,NULL,'Has Field Values','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.9735391400220507},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.23814773980154355}}}',5,'LONGTEXT','auto-list',NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(787,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',2,65,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":93,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:25.286932Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(788,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','visibility_type','type/Text','type/Category',_binary '',NULL,_binary '',8,65,NULL,'Visibility Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.0}}}',5,'VARCHAR','auto-list',NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(789,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','display_name','type/Text',NULL,_binary '',NULL,_binary '',5,65,NULL,'Display Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":374,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.07386990077177508,\"average-length\":9.94928335170893}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(790,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','active','type/Boolean','type/Category',_binary '',NULL,_binary '',11,65,NULL,'Active','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(791,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',4,65,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":386,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.07386990077177508,\"average-length\":9.94928335170893}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(792,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',0,65,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":907,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":227.8453873523461,\"q3\":680.8643684802138,\"max\":907.0,\"sd\":261.93707116299544,\"avg\":454.0}}}',5,'INT','auto-list',NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(793,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',1,65,NULL,'Entity Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":907,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.880926130099228}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(794,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','fk_target_field_id','type/Integer','type/Category',_binary '',NULL,_binary '',9,65,NULL,'Fk Target Field ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":29,\"nil%\":0.8687982359426681},\"type\":{\"type/Number\":{\"min\":7.0,\"q1\":160.59391777328744,\"q3\":511.5625,\"max\":696.0,\"sd\":185.21707624453452,\"avg\":311.30252100840335}}}',5,'INT','auto-list',NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(795,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',6,65,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":279,\"nil%\":0.6372657111356119},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":19.676957001102537}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(796,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','table_id','type/Integer',NULL,_binary '',NULL,_binary '',12,65,NULL,'Table ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":100,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":28.131243324690477,\"q3\":80.32215870950205,\"max\":107.0,\"sd\":30.62887567195088,\"avg\":54.722160970231535}}}',5,'INT','auto-list',NULL,12,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(797,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','base_type','type/Text','type/Category',_binary '',NULL,_binary '',7,65,NULL,'Base Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":10,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":12.253583241455347}}}',5,'VARCHAR','auto-list',NULL,7,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(798,'2024-06-19 14:18:24.617527','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',3,65,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":268,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:36.890163Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(799,'2024-06-19 14:18:24.666062','2024-06-19 14:18:48.863736','group_id','type/BigInteger','type/Category',_binary '',NULL,_binary '',1,12,NULL,'Group ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.41421356237309515,\"q3\":1.5857864376269049,\"max\":2.0,\"sd\":0.816496580927726,\"avg\":1.0}}}',5,'BIGINT','auto-list',NULL,1,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(800,'2024-06-19 14:18:24.666062','2024-06-19 14:18:48.863736','group_name','type/Text','type/Category',_binary '',NULL,_binary '',2,12,NULL,'Group Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":11.75}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(801,'2024-06-19 14:18:24.666062','2024-06-19 14:18:48.863736','user_id','type/BigInteger','type/Category',_binary '',NULL,_binary '',0,12,NULL,'User ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":6685669.0,\"q3\":1.3371339E7,\"max\":1.3371339E7,\"sd\":6685669.33333335,\"avg\":1.0028504E7}}}',5,'BIGINT','auto-list',NULL,0,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(802,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','card_id','type/Integer','type/Category',_binary '','The ID of the Card (Question) associated with this query execution, if any.',_binary '',8,9,NULL,'Card ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.05660377358490566},\"type\":{\"type/Number\":{\"min\":27.0,\"q1\":27.0,\"q3\":27.0,\"max\":27.0,\"sd\":0.0,\"avg\":27.0}}}',5,'INT','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(803,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','pulse_id','type/Integer',NULL,_binary '','The ID of the Pulse associated with this query execution, if any.',_binary '',12,9,NULL,'Pulse ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,12,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(804,'2024-06-19 14:18:24.714660','2024-06-22 21:00:03.218829','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',0,9,NULL,'Entity ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":53,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":13.75,\"q3\":40.25,\"max\":53.0,\"sd\":15.443445211480501,\"avg\":27.0}}}',5,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(805,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','result_rows','type/Integer','type/Category',_binary '','Number of rows in the query results.',_binary '',3,9,NULL,'Result Rows','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.0,\"q3\":14.113628693451263,\"max\":43.0,\"sd\":5.769143685844939,\"avg\":1.7924528301886793}}}',5,'INT','auto-list',NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(806,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','user_id','type/BigInteger','type/Category',_binary '',NULL,_binary '',7,9,NULL,'User ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.3371339E7,\"q1\":1.3371339E7,\"q3\":1.3371339378453521E7,\"max\":1.3371341E7,\"sd\":0.35432226440586684,\"avg\":1.3371339094339622E7}}}',5,'BIGINT','auto-list',NULL,7,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(807,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','running_time_seconds','type/Float',NULL,_binary '',NULL,_binary '',2,9,NULL,'Running Time Seconds','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":34,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.011,\"q1\":0.04975,\"q3\":0.066375,\"max\":0.101,\"sd\":0.016402701643026086,\"avg\":0.0580943396226415}}}',5,'DOUBLE',NULL,NULL,2,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(808,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','started_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',1,9,NULL,'Started At','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":53,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:19:06.454153Z\",\"latest\":\"2024-06-19T06:44:53.92964Z\"}}}',5,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(809,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','dashboard_id','type/Integer','type/Category',_binary '','The ID of the Dashboard associated with this query execution, if any.',_binary '',10,9,NULL,'Dashboard ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.1132075471698113},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":2.0,\"max\":2.0,\"sd\":0.0,\"avg\":2.0}}}',5,'INT','auto-list',NULL,10,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(810,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','dashboard_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',11,9,NULL,'Dashboard Qualified ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.1132075471698113},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":9.754716981132075}}}',5,'VARCHAR','auto-list',NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(811,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','database_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',14,9,NULL,'Database Qualified ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":10.0}}}',5,'VARCHAR','auto-list',NULL,14,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(812,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','error','type/Text',NULL,_binary '',NULL,_binary '',6,9,NULL,'Error','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(813,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','cache_hit','type/Boolean','type/Category',_binary '','Cache hit on query execution',_binary '',15,9,NULL,'Cache Hit','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,15,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(814,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','is_native','type/Boolean','type/Category',_binary '','Whether the query was a native query, as opposed to an MBQL one (e.g., created with the GUI).',_binary '',4,9,NULL,'Is Native','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,4,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(815,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','card_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',9,9,NULL,'Card Qualified ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.05660377358490566},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.60377358490566}}}',5,'VARCHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(816,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','query','type/Text','type/SerializedJSON',_binary '',NULL,_binary '',18,9,NULL,'Query','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":1.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":356.07547169811323}}}',5,'LONGTEXT','auto-list',NULL,18,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(817,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','query_source','type/Text','type/Source',_binary '','Short string specifying how this query was executed, e.g. in a Dashboard or Pulse.',_binary '',5,9,NULL,'Query Source','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.773584905660377}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(818,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','action_id','type/Integer',NULL,_binary '','The ID of the action associated with this query execution, if any.',_binary '',16,9,NULL,'Action ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Number\":{\"min\":null,\"q1\":null,\"q3\":null,\"max\":null,\"sd\":null,\"avg\":null}}}',5,'INT','auto-list',NULL,16,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(819,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','database_id','type/Integer','type/Category',_binary '','ID of the database this query was ran against.',_binary '',13,9,NULL,'Database ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":2.0,\"q1\":2.0,\"q3\":2.0,\"max\":2.0,\"sd\":0.0,\"avg\":2.0}}}',5,'INT','auto-list',NULL,13,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(820,'2024-06-19 14:18:24.714660','2024-06-19 14:45:09.256760','action_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',17,9,NULL,'Action Qualified ID','normal',NULL,'2024-06-19 14:45:09.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,17,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(821,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','dashboard_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',6,25,NULL,'Dashboard Qualified ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(822,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','recipient_type','type/Text',NULL,_binary '',NULL,_binary '',10,25,NULL,'Recipient Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,10,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(823,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',0,25,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(824,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','creator_id','type/Integer',NULL,_binary '',NULL,_binary '',4,25,NULL,'Creator ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(825,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','updated_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',3,25,NULL,'Updated At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(826,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','recipient_external','type/Text',NULL,_binary '',NULL,_binary '',12,25,NULL,'Recipient External','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(827,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','schedule_day','type/Text',NULL,_binary '',NULL,_binary '',8,25,NULL,'Schedule Day','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,8,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(828,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','archived','type/Boolean',NULL,_binary '','Has this pulse been archived?',_binary '',5,25,NULL,'Archived','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,5,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(829,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',1,25,NULL,'Entity Qualified ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(830,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','schedule_type','type/Text',NULL,_binary '',NULL,_binary '',7,25,NULL,'Schedule Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(831,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','schedule_hour','type/Integer',NULL,_binary '',NULL,_binary '',9,25,NULL,'Schedule Hour','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,9,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(832,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','parameters','type/Text',NULL,_binary '',NULL,_binary '',13,25,NULL,'Parameters','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(833,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','recipients','type/Text',NULL,_binary '',NULL,_binary '',11,25,NULL,'Recipients','normal',NULL,NULL,NULL,NULL,NULL,0,'MEDIUMTEXT',NULL,NULL,11,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(834,'2024-06-19 14:18:24.771688','2024-06-19 14:18:24.771688','created_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',2,25,NULL,'Created At','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(835,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',3,52,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":16,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:33.339338Z\",\"latest\":\"2024-06-19T14:18:26.857109Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(836,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','name','type/Text','type/Name',_binary '',NULL,_binary '',4,52,NULL,'Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.570093457943925}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(837,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','database_id','type/Integer','type/Category',_binary '',NULL,_binary '',8,52,NULL,'Database ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":1.624638636739191,\"q3\":2.0,\"max\":2.0,\"sd\":0.2642516874667833,\"avg\":1.925233644859813}}}',5,'INT','auto-list',NULL,8,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(838,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',1,52,NULL,'Entity Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.990654205607477}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(839,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','created_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',2,52,NULL,'Created At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":100,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:29Z\",\"latest\":\"2024-06-19T14:18:19.094014Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(840,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','description','type/Text','type/Description',_binary '',NULL,_binary '',6,52,NULL,'Description','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":52,\"nil%\":0.3177570093457944},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":32.654205607476634}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(841,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','is_upload','type/Boolean','type/Category',_binary '',NULL,_binary '',10,52,NULL,'Is Upload','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,10,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(842,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','active','type/Boolean','type/Category',_binary '',NULL,_binary '',7,52,NULL,'Active','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0}}',5,'BIT','auto-list',NULL,7,0,'type/Boolean',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(843,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','schema','type/Text','type/Category',_binary '',NULL,_binary '',9,52,NULL,'Schema','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.0}}}',5,'VARCHAR','auto-list',NULL,9,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(844,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',0,52,NULL,'Entity ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":27.25,\"q3\":80.75,\"max\":107.0,\"sd\":31.028973070524277,\"avg\":54.0}}}',5,'INT','auto-list',NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(845,'2024-06-19 14:18:24.825899','2024-06-19 14:18:48.863736','display_name','type/Text',NULL,_binary '',NULL,_binary '',5,52,NULL,'Display Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.570093457943925}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(846,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,92,NULL,'ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,NULL,5,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(847,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','database_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',2,92,NULL,'Database Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":10.0}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(848,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','details','type/Text','type/Category',_binary '',NULL,_binary '',6,92,NULL,'Details','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":19,\"nil%\":0.2962962962962963},\"type\":{\"type/Text\":{\"percent-json\":0.7037037037037037,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":29.62962962962963}}}',5,'LONGTEXT','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(849,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','ended_at','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',4,92,NULL,'Ended At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":26,\"nil%\":0.07407407407407407},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:13:30.852284Z\",\"latest\":\"2024-06-19T06:18:30.350768Z\"}}}',5,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(850,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','task','type/Text','type/Category',_binary '','Name of the task',_binary '',1,92,NULL,'Task','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":16,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":14.592592592592593}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(851,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','started_at','type/DateTimeWithLocalTZ','type/CreationTimestamp',_binary '',NULL,_binary '',3,92,NULL,'Started At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":27,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T06:13:30.792604Z\",\"latest\":\"2024-06-19T06:18:30.430338Z\"}}}',5,'TIMESTAMP',NULL,NULL,3,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(852,'2024-06-19 14:18:24.886248','2024-06-19 14:18:48.863736','duration_seconds','type/Float','type/Duration',_binary '',NULL,_binary '',5,92,NULL,'Duration Seconds','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":24,\"nil%\":0.07407407407407407},\"type\":{\"type/Number\":{\"min\":0.01,\"q1\":0.0545,\"q3\":2.24525,\"max\":14.839,\"sd\":3.166212844498403,\"avg\":1.63412}}}',5,'DOUBLE',NULL,NULL,5,0,'type/Float',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(853,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','is_active','type/Boolean','type/Category',_binary '',NULL,_binary '',11,85,NULL,'Is Active','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.3333333333333333}}',5,'BIT','auto-list',NULL,11,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(854,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','last_login','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',8,85,NULL,'Last Login','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.6666666666666667},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:17:10Z\",\"latest\":\"2024-06-19T14:17:10Z\"}}}',5,'TIMESTAMP',NULL,NULL,8,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(855,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','locale','type/Text',NULL,_binary '',NULL,_binary '',13,85,NULL,'Locale','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,13,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(856,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','last_name','type/Text','type/Name',_binary '',NULL,_binary '',5,85,NULL,'Last Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.0}}}',5,'VARCHAR','auto-list',NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(857,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','user_id','type/BigInteger','type/Category',_binary '',NULL,_binary '',0,85,NULL,'User ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":3342834.5,\"q3\":1.337133875E7,\"max\":1.3371339E7,\"sd\":7719945.882400623,\"avg\":8914225.666666666}}}',5,'BIGINT','auto-list',NULL,0,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(858,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','first_name','type/Text','type/Name',_binary '',NULL,_binary '',4,85,NULL,'First Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.0}}}',5,'VARCHAR','auto-list',NULL,4,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(859,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','updated_at','type/DateTimeWithLocalTZ','type/UpdatedTimestamp',_binary '',NULL,_binary '',9,85,NULL,'Updated At','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.6666666666666667},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:17:10.848325Z\",\"latest\":\"2024-06-19T14:17:10.848325Z\"}}}',5,'TIMESTAMP',NULL,NULL,9,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(860,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','full_name','type/Text','type/Name',_binary '',NULL,_binary '',6,85,NULL,'Full Name','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.0}}}',5,'VARCHAR','auto-list',NULL,6,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(861,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','type','type/Text','type/Category',_binary '',NULL,_binary '',2,85,NULL,'Type','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":8.333333333333334}}}',5,'VARCHAR','auto-list',NULL,2,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(862,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','is_admin','type/Decimal',NULL,_binary '',NULL,_binary '',10,85,NULL,'Is Admin','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":0.7752551286084111,\"max\":1.0,\"sd\":0.5773502691896258,\"avg\":0.3333333333333333}}}',5,'DECIMAL',NULL,NULL,10,0,'type/Decimal',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(863,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','entity_qualified_id','type/Text','type/Category',_binary '',NULL,_binary '',1,85,NULL,'Entity Qualified ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":10.666666666666666}}}',5,'VARCHAR','auto-list',NULL,1,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(864,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','email','type/Text','type/Category',_binary '',NULL,_binary '',3,85,NULL,'Email','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.3333333333333333},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.6666666666666667,\"percent-state\":0.0,\"average-length\":13.333333333333334}}}',5,'VARCHAR','auto-list',NULL,3,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(865,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','date_joined','type/DateTimeWithLocalTZ','type/JoinTimestamp',_binary '',NULL,_binary '',7,85,NULL,'Date Joined','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.3333333333333333},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-19T14:13:27Z\",\"latest\":\"2024-06-19T14:17:10Z\"}}}',5,'TIMESTAMP',NULL,NULL,7,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(866,'2024-06-19 14:18:24.942645','2024-06-19 14:18:48.863736','sso_source','type/Text','type/Source',_binary '',NULL,_binary '',12,85,NULL,'Sso Source','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":1,\"nil%\":1.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":0.0}}}',5,'VARCHAR','auto-list',NULL,12,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(867,'2024-06-19 14:18:25.003358','2024-06-19 14:18:25.003358','entity_id','type/Integer',NULL,_binary '',NULL,_binary '',4,48,NULL,'Entity ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,4,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(868,'2024-06-19 14:18:25.003358','2024-06-19 14:18:48.863736','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,48,NULL,'ID','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,NULL,5,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(869,'2024-06-19 14:18:25.003358','2024-06-19 14:18:25.003358','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',1,48,NULL,'Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,1,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(870,'2024-06-19 14:18:25.003358','2024-06-19 14:18:25.003358','entity_qualified_id','type/Text',NULL,_binary '',NULL,_binary '',5,48,NULL,'Entity Qualified ID','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(871,'2024-06-19 14:18:25.003358','2024-06-19 14:18:25.003358','user_id','type/BigInteger',NULL,_binary '',NULL,_binary '',2,48,NULL,'User ID','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT',NULL,NULL,2,0,'type/BigInteger',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',NULL,NULL),(872,'2024-06-19 14:18:25.003358','2024-06-19 14:18:25.003358','entity_type','type/Text',NULL,_binary '',NULL,_binary '',3,48,NULL,'Entity Type','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,3,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',NULL,NULL),(873,'2024-06-19 14:18:25.053414','2024-06-19 14:18:48.863736','mid','type/BigInteger',NULL,_binary '',NULL,_binary '',0,40,NULL,'Mid','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":169,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":4.0,\"q1\":609.3544890966989,\"q3\":205579.27754909397,\"max\":308873.0,\"sd\":104756.78611130486,\"avg\":106199.57978723405}}}',5,'BIGINT','auto-list',NULL,0,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(874,'2024-06-19 14:18:25.053414','2024-06-30 21:00:05.573782','income','type/BigInteger','type/Income',_binary '',NULL,_binary '',1,40,NULL,'Income','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":283,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-392.0,\"q1\":346.34318116430006,\"q3\":2798.691641498395,\"max\":175308.0,\"sd\":14600.008045102608,\"avg\":4325.614361702128}}}',5,'BIGINT',NULL,NULL,1,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(875,'2024-06-19 14:18:25.053414','2024-06-19 14:18:48.863736','pdate','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',2,40,NULL,'Pdate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":3,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-06-16T16:00:00Z\",\"latest\":\"2024-06-18T16:00:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,2,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(876,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','membership_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',2,100,NULL,'Membership Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":37,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":196.0,\"q1\":444.03894091358103,\"q3\":1923.25,\"max\":15043.0,\"sd\":2693.0444303512995,\"avg\":1968.2923076923078}}}',5,'BIGINT','auto-list',NULL,2,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(877,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_moment_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',8,100,NULL,'Zone Moment Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":52,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":492.75,\"q3\":10419.5,\"max\":26617.0,\"sd\":6082.896724905445,\"avg\":7646.476923076923}}}',5,'BIGINT','auto-list',NULL,8,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(878,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','other_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',10,100,NULL,'Other Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":60,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":599.5,\"q3\":3618.5,\"max\":8371.0,\"sd\":1996.6209134724058,\"avg\":2350.076923076923}}}',5,'BIGINT','auto-list',NULL,10,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(879,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_admission_rate','type/Float','type/Share',_binary '',NULL,_binary '',16,100,NULL,'Zone Admission Rate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":56,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.3575119897723198,\"q3\":0.527744248509407,\"max\":0.6382589936256409,\"sd\":0.20076487598082626,\"avg\":0.39512443693641286}}}',5,'FLOAT',NULL,NULL,16,0,'type/Float',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(880,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_superfan_rate','type/Float','type/Share',_binary '',NULL,_binary '',17,100,NULL,'Zone Superfan Rate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":44,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0026592219847113197,\"q3\":0.09723432548344135,\"max\":0.19809000194072723,\"sd\":0.05544033621079531,\"avg\":0.05520068291001595}}}',5,'FLOAT',NULL,NULL,17,0,'type/Float',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(881,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_moment_cnt','type/BigInteger',NULL,_binary '',NULL,_binary '',7,100,NULL,'Zone Moment Cnt','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":50,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":3.5,\"q3\":400.0,\"max\":1802.0,\"sd\":294.92914892328866,\"avg\":243.2153846153846}}}',5,'BIGINT','auto-list',NULL,7,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(882,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','ptime','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',0,100,NULL,'Ptime','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":65,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-04-14T16:00:00Z\",\"latest\":\"2024-06-17T16:00:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,0,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(883,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_admission_cnt','type/BigInteger',NULL,_binary '',NULL,_binary '',3,100,NULL,'Zone Admission Cnt','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":53,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":23.5,\"q3\":590.0,\"max\":2711.0,\"sd\":627.0663618113992,\"avg\":480.4769230769231}}}',5,'BIGINT','auto-list',NULL,3,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(884,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_superfan_cnt','type/BigInteger','type/Category',_binary '',NULL,_binary '',5,100,NULL,'Zone Superfan Cnt','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":14,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.2723527321376576,\"q3\":7.050510257216822,\"max\":13.0,\"sd\":4.0922652181138774,\"avg\":4.184615384615385}}}',5,'BIGINT','auto-list',NULL,5,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(885,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','other_rate','type/Float','type/Share',_binary '',NULL,_binary '',19,100,NULL,'Other Rate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":62,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0419684499502182,\"q3\":0.11789575032889843,\"max\":0.9366649985313416,\"sd\":0.1611181018068115,\"avg\":0.12115839780666507}}}',5,'FLOAT',NULL,NULL,19,0,'type/Float',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(886,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_superfan_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',6,100,NULL,'Zone Superfan Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":81.56633928656505,\"q3\":3771.25,\"max\":13260.0,\"sd\":2959.013374826793,\"avg\":2416.9384615384615}}}',5,'BIGINT','auto-list',NULL,6,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(887,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','membership_rate','type/Float','type/Share',_binary '',NULL,_binary '',15,100,NULL,'Membership Rate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":62,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.007211179938167334,\"q1\":0.01574990013614297,\"q3\":0.2910572588443756,\"max\":1.0,\"sd\":0.3020607864796694,\"avg\":0.22548349442390295}}}',5,'FLOAT',NULL,NULL,15,0,'type/Float',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(888,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','other_cnt','type/BigInteger',NULL,_binary '',NULL,_binary '',9,100,NULL,'Other Cnt','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":31,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":7.125,\"q3\":20.870828693386972,\"max\":53.0,\"sd\":11.357859020892164,\"avg\":15.446153846153846}}}',5,'BIGINT','auto-list',NULL,9,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(889,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_admission_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',4,100,NULL,'Zone Admission Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":56,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":2197.0,\"q3\":19357.25,\"max\":50177.0,\"sd\":11883.161722883837,\"avg\":14450.553846153845}}}',5,'BIGINT','auto-list',NULL,4,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(890,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','membership_cnt','type/BigInteger',NULL,_binary '',NULL,_binary '',1,100,NULL,'Membership Cnt','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":37,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":4.0,\"q1\":9.06201920231798,\"q3\":39.25,\"max\":307.0,\"sd\":54.96009041533264,\"avg\":40.16923076923077}}}',5,'BIGINT','auto-list',NULL,1,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(891,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','zone_moment_rate','type/Float','type/Share',_binary '',NULL,_binary '',18,100,NULL,'Zone Moment Rate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":52,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.10595924779772758,\"q3\":0.29502174258232117,\"max\":0.3675389885902405,\"sd\":0.12431709936570924,\"avg\":0.20303298767942649}}}',5,'FLOAT',NULL,NULL,18,0,'type/Float',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(892,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','official_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',13,100,NULL,'Official Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":65,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-241.0,\"q1\":2644.5,\"q3\":10907.75,\"max\":25701.0,\"sd\":5446.351841606647,\"avg\":7542.015384615384}}}',5,'BIGINT','auto-list',NULL,13,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(893,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','total_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',11,100,NULL,'Total Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":65,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":196.0,\"q1\":6020.75,\"q3\":37597.0,\"max\":85854.0,\"sd\":21879.886967706014,\"avg\":28832.33846153846}}}',5,'BIGINT','auto-list',NULL,11,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(894,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','profit_rate','type/Float','type/Share',_binary '',NULL,_binary '',14,100,NULL,'Profit Rate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":65,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-1.2295900583267212,\"q1\":0.21873850002884865,\"q3\":0.40105874836444855,\"max\":0.8319839835166931,\"sd\":0.2486005214779685,\"avg\":0.3083435393296755}}}',5,'FLOAT',NULL,NULL,14,0,'type/Float',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(895,'2024-06-19 14:18:25.114737','2024-06-19 14:18:48.863736','streamer_flow','type/BigInteger',NULL,_binary '',NULL,_binary '',12,100,NULL,'Streamer Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":63,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":83.0,\"q1\":4233.0,\"q3\":29105.25,\"max\":67028.0,\"sd\":17050.690670677108,\"avg\":21290.323076923076}}}',5,'BIGINT','auto-list',NULL,12,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(896,'2024-06-19 14:18:25.218536','2024-06-19 14:18:48.863736','pdate','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',0,86,NULL,'Pdate','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-05-07T16:00:00Z\",\"latest\":\"2024-06-18T16:00:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,0,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(897,'2024-06-19 14:18:25.218536','2024-06-19 14:18:48.863736','flow','type/BigInteger',NULL,_binary '',NULL,_binary '',1,86,NULL,'Flow','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1673597.0,\"q1\":2808104.5,\"q3\":5250836.25,\"max\":8581933.0,\"sd\":1731684.621442138,\"avg\":4107630.88372093}}}',5,'BIGINT','auto-list',NULL,1,0,'type/BigInteger',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(898,'2024-06-19 14:18:25.266679','2024-06-19 14:18:48.863736','ptime','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',0,78,NULL,'Ptime','normal',NULL,'2024-06-19 14:18:48.000000',NULL,NULL,'{\"global\":{\"distinct-count\":9998,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-05-06T16:05:00Z\",\"latest\":\"2024-06-10T09:20:00Z\"}}}',5,'TIMESTAMP',NULL,NULL,0,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL),(899,'2024-06-19 14:18:25.266679','2024-06-19 14:18:29.122989','flow','type/*',NULL,_binary '',NULL,_binary '',1,78,NULL,'Flow','normal',NULL,NULL,NULL,NULL,NULL,0,'BIGINT UNSIGNED ZEROFILL',NULL,NULL,1,0,'type/*',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(900,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','timestamp','type/DateTimeWithLocalTZ',NULL,_binary '',NULL,_binary '',4,89,NULL,'Timestamp','normal',NULL,NULL,NULL,NULL,NULL,0,'TIMESTAMP',NULL,NULL,4,0,'type/DateTimeWithLocalTZ',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(901,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','id','type/Integer','type/PK',_binary '',NULL,_binary '',0,89,NULL,'ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,0,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '',_binary '',NULL),(902,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','context','type/Text',NULL,_binary '','The context of the view, can be collection, question, or dashboard. Only for cards.',_binary '',7,89,NULL,'Context','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,7,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(903,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','user_id','type/Integer','type/FK',_binary '',NULL,_binary '',1,89,NULL,'User ID','normal',163,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,1,0,'type/Integer',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '',NULL),(904,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','model','type/Text',NULL,_binary '',NULL,_binary '',2,89,NULL,'Model','normal',NULL,NULL,NULL,NULL,NULL,0,'VARCHAR',NULL,NULL,2,0,'type/Text',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '\0',NULL),(905,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','has_access','type/Boolean',NULL,_binary '',NULL,_binary '',6,89,NULL,'Has Access','normal',NULL,NULL,NULL,NULL,NULL,0,'BIT',NULL,NULL,6,0,'type/Boolean',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(906,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','metadata','type/Text',NULL,_binary '',NULL,_binary '',5,89,NULL,'Metadata','normal',NULL,NULL,NULL,NULL,NULL,0,'LONGTEXT',NULL,NULL,5,0,'type/Text',NULL,NULL,_binary '\0',_binary '\0',_binary '\0',_binary '\0',NULL),(907,'2024-06-19 14:18:25.286932','2024-06-19 14:18:29.686610','model_id','type/Integer',NULL,_binary '',NULL,_binary '',3,89,NULL,'Model ID','normal',NULL,NULL,NULL,NULL,NULL,0,'INT',NULL,NULL,3,0,'type/Integer',NULL,NULL,_binary '',_binary '\0',_binary '\0',_binary '',NULL);
/*!40000 ALTER TABLE `metabase_field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `metabase_fieldvalues`
--

DROP TABLE IF EXISTS `metabase_fieldvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `metabase_fieldvalues` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NULL DEFAULT NULL,
  `values` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `human_readable_values` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `field_id` int NOT NULL,
  `has_more_values` bit(1) DEFAULT b'0',
  `type` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'full' COMMENT 'Type of FieldValues',
  `hash_key` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'Hash key for a cached fieldvalues',
  `last_used_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'Timestamp of when these FieldValues were last used.',
  PRIMARY KEY (`id`),
  KEY `idx_fieldvalues_field_id` (`field_id`),
  CONSTRAINT `fk_fieldvalues_ref_field_id` FOREIGN KEY (`field_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=353 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `metabase_fieldvalues`
--

LOCK TABLES `metabase_fieldvalues` WRITE;
/*!40000 ALTER TABLE `metabase_fieldvalues` DISABLE KEYS */;
INSERT INTO `metabase_fieldvalues` VALUES (1,'2024-06-19 14:13:35.044327','2024-06-19 14:13:35.044327','[false,true]',NULL,5,_binary '\0','full',NULL,'2024-06-19 14:13:35.044327'),(2,'2024-06-19 14:13:35.139692','2024-06-19 14:13:35.139692','[null,\"AE\",\"AF\",\"AG\",\"AL\",\"AM\",\"AR\",\"AT\",\"AU\",\"BA\",\"BD\",\"BE\",\"BF\",\"BG\",\"BN\",\"BO\",\"BR\",\"BT\",\"BW\",\"BY\",\"CA\",\"CD\",\"CH\",\"CI\",\"CL\",\"CM\",\"CN\",\"CO\",\"CR\",\"CU\",\"CV\",\"CY\",\"CZ\",\"DE\",\"DK\",\"DO\",\"DZ\",\"EE\",\"EG\",\"ES\",\"ET\",\"FI\",\"FR\",\"GB\",\"GE\",\"GM\",\"GN\",\"GR\",\"GT\",\"HN\",\"HR\",\"HT\",\"HU\",\"ID\",\"IE\",\"IL\",\"IN\",\"IQ\",\"IR\",\"IT\",\"JM\",\"JO\",\"JP\",\"KE\",\"KH\",\"KI\",\"KM\",\"KR\",\"KZ\",\"LA\",\"LC\",\"LK\",\"LR\",\"LS\",\"LT\",\"LU\",\"LV\",\"LY\",\"MA\",\"MD\",\"MG\",\"MK\",\"ML\",\"MM\",\"MT\",\"MU\",\"MW\",\"MX\",\"MY\",\"NE\",\"NG\",\"NI\",\"NL\",\"NO\",\"NZ\",\"PA\",\"PE\",\"PH\",\"PK\",\"PL\",\"PT\",\"PW\",\"PY\",\"RO\",\"RS\",\"RU\",\"RW\",\"SA\",\"SE\",\"SI\",\"SK\",\"SL\",\"SM\",\"SN\",\"SO\",\"SV\",\"SY\",\"SZ\",\"TH\",\"TJ\",\"TN\",\"TO\",\"TR\",\"TZ\",\"UA\",\"UG\",\"US\",\"UZ\",\"VE\",\"VN\",\"YE\",\"ZA\",\"ZM\",\"ZW\"]',NULL,15,_binary '\0','full',NULL,'2024-06-19 14:13:35.139692'),(3,'2024-06-19 14:13:35.234135','2024-06-19 14:13:35.234135','[\"Abbott\",\"Abernathy\",\"Abshire\",\"Adams\",\"Altenwerth\",\"Anderson\",\"Ankunding\",\"Armstrong\",\"Auer\",\"Aufderhar\",\"Bahringer\",\"Bailey\",\"Balistreri\",\"Barrows\",\"Bartell\",\"Bartoletti\",\"Barton\",\"Batz\",\"Bauch\",\"Baumbach\",\"Bayer\",\"Beahan\",\"Beatty\",\"Bechtelar\",\"Becker\",\"Bednar\",\"Beer\",\"Beier\",\"Berge\",\"Bergnaum\",\"Bergstrom\",\"Bernhard\",\"Bernier\",\"Bins\",\"Blanda\",\"Blick\",\"Block\",\"Bode\",\"Boehm\",\"Bogan\",\"Bogisich\",\"Borer\",\"Bosco\",\"Botsford\",\"Boyer\",\"Boyle\",\"Bradtke\",\"Brakus\",\"Braun\",\"Breitenberg\",\"Brekke\",\"Brown\",\"Bruen\",\"Buckridge\",\"Carroll\",\"Carter\",\"Cartwright\",\"Casper\",\"Cassin\",\"Champlin\",\"Christiansen\",\"Cole\",\"Collier\",\"Collins\",\"Conn\",\"Connelly\",\"Conroy\",\"Considine\",\"Corkery\",\"Cormier\",\"Corwin\",\"Cremin\",\"Crist\",\"Crona\",\"Cronin\",\"Crooks\",\"Cruickshank\",\"Cummerata\",\"Cummings\",\"D\'Amore\",\"Dach\",\"Daniel\",\"Dare\",\"Daugherty\",\"Davis\",\"Deckow\",\"Denesik\",\"Dibbert\",\"Dickens\",\"Dicki\",\"Dickinson\",\"Dietrich\",\"Donnelly\",\"Dooley\",\"Douglas\",\"Doyle\",\"DuBuque\",\"Durgan\",\"Ebert\",\"Effertz\",\"Eichmann\",\"Emard\",\"Emmerich\",\"Erdman\",\"Ernser\",\"Fadel\",\"Fahey\",\"Farrell\",\"Fay\",\"Feeney\",\"Feest\",\"Feil\",\"Ferry\",\"Fisher\",\"Flatley\",\"Frami\",\"Franecki\",\"Friesen\",\"Fritsch\",\"Funk\",\"Gaylord\",\"Gerhold\",\"Gerlach\",\"Gibson\",\"Gislason\",\"Gleason\",\"Gleichner\",\"Glover\",\"Goldner\",\"Goodwin\",\"Gorczany\",\"Gottlieb\",\"Goyette\",\"Grady\",\"Graham\",\"Grant\",\"Green\",\"Greenfelder\",\"Greenholt\",\"Grimes\",\"Gulgowski\",\"Gusikowski\",\"Gutkowski\",\"Gutmann\",\"Haag\",\"Hackett\",\"Hagenes\",\"Hahn\",\"Haley\",\"Halvorson\",\"Hamill\",\"Hammes\",\"Hand\",\"Hane\",\"Hansen\",\"Harber\",\"Harris\",\"Hartmann\",\"Harvey\",\"Hauck\",\"Hayes\",\"Heaney\",\"Heathcote\",\"Hegmann\",\"Heidenreich\",\"Heller\",\"Herman\",\"Hermann\",\"Hermiston\",\"Herzog\",\"Hessel\",\"Hettinger\",\"Hickle\",\"Hilll\",\"Hills\",\"Hilpert\",\"Hintz\",\"Hirthe\",\"Hodkiewicz\",\"Hoeger\",\"Homenick\",\"Hoppe\",\"Howe\",\"Howell\",\"Hudson\",\"Huel\",\"Huels\",\"Hyatt\",\"Jacobi\",\"Jacobs\",\"Jacobson\",\"Jakubowski\",\"Jaskolski\",\"Jast\",\"Jenkins\",\"Jerde\",\"Jewess\",\"Johns\",\"Johnson\",\"Johnston\",\"Jones\",\"Kassulke\",\"Kautzer\",\"Keebler\",\"Keeling\",\"Kemmer\",\"Kerluke\",\"Kertzmann\",\"Kessler\",\"Kiehn\",\"Kihn\",\"Kilback\",\"King\",\"Kirlin\",\"Klein\",\"Kling\",\"Klocko\",\"Koch\",\"Koelpin\",\"Koepp\",\"Kohler\",\"Konopelski\",\"Koss\",\"Kovacek\",\"Kozey\",\"Krajcik\",\"Kreiger\",\"Kris\",\"Kshlerin\",\"Kub\",\"Kuhic\",\"Kuhlman\",\"Kuhn\",\"Kulas\",\"Kunde\",\"Kunze\",\"Kuphal\",\"Kutch\",\"Kuvalis\",\"Labadie\",\"Lakin\",\"Lang\",\"Langosh\",\"Langworth\",\"Larkin\",\"Larson\",\"Leannon\",\"Lebsack\",\"Ledner\",\"Leffler\",\"Legros\",\"Lehner\",\"Lemke\",\"Lesch\",\"Leuschke\",\"Lind\",\"Lindgren\",\"Littel\",\"Little\",\"Lockman\",\"Lowe\",\"Lubowitz\",\"Lueilwitz\",\"Luettgen\",\"Lynch\",\"Macejkovic\",\"Maggio\",\"Mann\",\"Mante\",\"Marks\",\"Marquardt\",\"Marvin\",\"Mayer\",\"Mayert\",\"McClure\",\"McCullough\",\"McDermott\",\"McGlynn\",\"McKenzie\",\"McLaughlin\",\"Medhurst\",\"Mertz\",\"Metz\",\"Miller\",\"Mills\",\"Mitchell\",\"Moen\",\"Mohr\",\"Monahan\",\"Moore\",\"Morar\",\"Morissette\",\"Mosciski\",\"Mraz\",\"Mueller\",\"Muller\",\"Murazik\",\"Murphy\",\"Murray\",\"Nader\",\"Nicolas\",\"Nienow\",\"Nikolaus\",\"Nitzsche\",\"Nolan\",\"O\'Connell\",\"O\'Conner\",\"O\'Hara\",\"O\'Keefe\",\"O\'Kon\",\"O\'Reilly\",\"Oberbrunner\",\"Okuneva\",\"Olson\",\"Ondricka\",\"Orn\",\"Ortiz\",\"Osinski\",\"Pacocha\",\"Padberg\",\"Pagac\",\"Parisian\",\"Parker\",\"Paucek\",\"Pfannerstill\",\"Pfeffer\",\"Pollich\",\"Pouros\",\"Powlowski\",\"Predovic\",\"Price\",\"Prohaska\",\"Prosacco\",\"Purdy\",\"Quigley\",\"Quitzon\",\"Rath\",\"Ratke\",\"Rau\",\"Raynor\",\"Reichel\",\"Reichert\",\"Reilly\",\"Reinger\",\"Rempel\",\"Renner\",\"Reynolds\",\"Rice\",\"Rippin\",\"Ritchie\",\"Robel\",\"Roberts\",\"Rodriguez\",\"Rogahn\",\"Rohan\",\"Rolfson\",\"Romaguera\",\"Roob\",\"Rosenbaum\",\"Rowe\",\"Ruecker\",\"Runolfsdottir\",\"Runolfsson\",\"Runte\",\"Russel\",\"Rutherford\",\"Ryan\",\"Sanford\",\"Satterfield\",\"Sauer\",\"Sawayn\",\"Schaden\",\"Schaefer\",\"Schamberger\",\"Schiller\",\"Schimmel\",\"Schinner\",\"Schmeler\",\"Schmidt\",\"Schmitt\",\"Schneider\",\"Schoen\",\"Schowalter\",\"Schroeder\",\"Schulist\",\"Schultz\",\"Schumm\",\"Schuppe\",\"Schuster\",\"Senger\",\"Shanahan\",\"Shields\",\"Simonis\",\"Sipes\",\"Skiles\",\"Smith\",\"Smitham\",\"Spencer\",\"Spinka\",\"Sporer\",\"Stamm\",\"Stanton\",\"Stark\",\"Stehr\",\"Steuber\",\"Stiedemann\",\"Stokes\",\"Stoltenberg\",\"Stracke\",\"Streich\",\"Stroman\",\"Strosin\",\"Swaniawski\",\"Swift\",\"Terry\",\"Thiel\",\"Thompson\",\"Tillman\",\"Torp\",\"Torphy\",\"Towne\",\"Toy\",\"Trantow\",\"Tremblay\",\"Treutel\",\"Tromp\",\"Turcotte\",\"Turner\",\"Ullrich\",\"Upton\",\"Vandervort\",\"Veum\",\"Volkman\",\"Von\",\"VonRueden\",\"Waelchi\",\"Walker\",\"Walsh\",\"Walter\",\"Ward\",\"Waters\",\"Watsica\",\"Weber\",\"Wehner\",\"Weimann\",\"Weissnat\",\"Welch\",\"West\",\"White\",\"Wiegand\",\"Wilderman\",\"Wilkinson\",\"Will\",\"Williamson\",\"Willms\",\"Windler\",\"Wintheiser\",\"Wisoky\",\"Wisozk\",\"Witting\",\"Wiza\",\"Wolf\",\"Wolff\",\"Wuckert\",\"Wunsch\",\"Wyman\",\"Yost\",\"Yundt\",\"Zboncak\",\"Zemlak\",\"Ziemann\",\"Zieme\",\"Zulauf\"]',NULL,10,_binary '\0','full',NULL,'2024-06-19 14:13:35.234135'),(4,'2024-06-19 14:13:35.323807','2024-06-19 14:13:35.323807','[false,true]',NULL,8,_binary '\0','full',NULL,'2024-06-19 14:13:35.323807'),(5,'2024-06-19 14:13:35.382216','2024-06-19 14:13:35.382216','[\"Basic\",\"Business\",\"Premium\"]',NULL,4,_binary '\0','full',NULL,'2024-06-19 14:13:35.382216'),(6,'2024-06-19 14:13:35.445627','2024-06-19 14:13:35.445627','[1,3,5,8,10,12,14,16,19,21,23,25,27,30,32,34,36,38,41,43,45,47,49,52,54,56,58,60,63,65,67,69,71,74,76,78,80,82,85,87,89,91,93,96,98,102,104,107,109,111,113,115,120,122,124,129,131,133,135,137,140,142,148,155,162,168,173,175,177,179,186,188,190,197,201,203,208,210,219,223,236,252,254,261,267,269,274,289,331,335,351,390,393,401,423,426,450,503,522,639,668,1325]',NULL,1,_binary '\0','full',NULL,'2024-06-19 14:13:35.445627'),(7,'2024-06-19 14:13:35.502517','2024-06-19 14:13:35.502517','[null,\"Facebook\",\"Google\",\"Invite\",\"Twitter\"]',NULL,11,_binary '\0','full',NULL,'2024-06-19 14:13:35.502517'),(8,'2024-06-19 14:13:35.570021','2024-06-19 14:13:35.570021','[false,true]',NULL,14,_binary '\0','full',NULL,'2024-06-19 14:13:35.570021'),(9,'2024-06-19 14:13:35.647764','2024-06-19 14:13:35.647764','[null,\"Checkout\",\"Create Item\",\"Invite\",\"Signup\",\"Subscribe\"]',NULL,19,_binary '\0','full',NULL,'2024-06-19 14:13:35.647764'),(10,'2024-06-19 14:13:35.715535','2024-06-19 14:13:35.715535','[\"Button Clicked\",\"Page Viewed\"]',NULL,17,_binary '\0','full',NULL,'2024-06-19 14:13:35.715535'),(11,'2024-06-19 14:13:35.794686','2024-06-19 14:13:35.794686','[null,\"www.piespace.example/help\",\"www.piespace.example/home\",\"www.piespace.example/invite\",\"www.piespace.example/login\",\"www.piespace.example/pies\"]',NULL,18,_binary '\0','full',NULL,'2024-06-19 14:13:35.794686'),(12,'2024-06-19 14:13:35.860119','2024-06-19 14:13:35.860119','[\"abbott-berneice@hotmail.example\",\"abdullah-kerluke@gmail.example\",\"adan-weissnat@yahoo.example\",\"aida.schneider@gmail.example\",\"aidan-hagenes@hotmail.example\",\"aidan.rodriguez@gmail.example\",\"alaina-howell@gmail.example\",\"alayna.halvorson@hotmail.example\",\"alberto.gulgowski@gmail.example\",\"alicia.schimmel@gmail.example\",\"alisa-morissette@hotmail.example\",\"alisa-schmitt@hotmail.example\",\"altenwerth.onie@yahoo.example\",\"alva.conroy@hotmail.example\",\"alvena-legros@hotmail.example\",\"alverta-rogahn@hotmail.example\",\"alvina.mertz@gmail.example\",\"alvis.emmerich@yahoo.example\",\"alycia.collins@yahoo.example\",\"alysson-cartwright@yahoo.example\",\"anastacio.jaskolski@hotmail.example\",\"anderson-eliza@hotmail.example\",\"anderson.schinner@yahoo.example\",\"andy-skiles@yahoo.example\",\"angela-botsford@hotmail.example\",\"anjali-parker@hotmail.example\",\"ankunding-rudolph@hotmail.example\",\"aracely.jenkins@gmail.example\",\"arch-ryan@hotmail.example\",\"archibald-lowe@hotmail.example\",\"archibald-turner@hotmail.example\",\"arne-o-hara@gmail.example\",\"art-graham@yahoo.example\",\"arvel-lakin@gmail.example\",\"ashton-herman@hotmail.example\",\"aubree-dibbert@hotmail.example\",\"aubree-walter@hotmail.example\",\"aufderhar-mya@hotmail.example\",\"aufderhar.john@yahoo.example\",\"aurore-yundt@yahoo.example\",\"bahringer-laura@yahoo.example\",\"bailey.kenna@yahoo.example\",\"balistreri-oral@yahoo.example\",\"balistreri-unique@gmail.example\",\"bauch-wilford@gmail.example\",\"bayer-mattie@hotmail.example\",\"bayer.mark@hotmail.example\",\"beatty-emmie@gmail.example\",\"beatty.julio@gmail.example\",\"beatty.mohammed@gmail.example\",\"bechtelar.antone@gmail.example\",\"beer.humberto@hotmail.example\",\"berge-halie@hotmail.example\",\"bergstrom-chelsie@yahoo.example\",\"bernhard.kathleen@yahoo.example\",\"bins-evans@hotmail.example\",\"blair.heaney@gmail.example\",\"blake-leffler@hotmail.example\",\"blaze-daugherty@hotmail.example\",\"blick-candelario@yahoo.example\",\"block.emiliano@hotmail.example\",\"bode-sydnie@gmail.example\",\"bode.richmond@gmail.example\",\"boehm-amanda@hotmail.example\",\"bogan.rodger@gmail.example\",\"bosco-zachariah@gmail.example\",\"bosco.haylie@hotmail.example\",\"botsford.okey@hotmail.example\",\"boyer-bernhard@yahoo.example\",\"boyle-christiana@gmail.example\",\"brakus-kimberly@gmail.example\",\"brakus.marlene@hotmail.example\",\"brant.klein@yahoo.example\",\"braun.madisyn@gmail.example\",\"breanna.strosin@yahoo.example\",\"breitenberg-louie@gmail.example\",\"brekke.kirsten@yahoo.example\",\"brennon-gerlach@hotmail.example\",\"bret-quigley@gmail.example\",\"brianne-jacobson@yahoo.example\",\"brown-deontae@gmail.example\",\"buddy-hills@gmail.example\",\"caleigh-hodkiewicz@yahoo.example\",\"camron-homenick@gmail.example\",\"camryn-schmeler@hotmail.example\",\"candida-turcotte@yahoo.example\",\"carolanne-upton@gmail.example\",\"carroll.chanel@yahoo.example\",\"carroll.kohler@hotmail.example\",\"carter-fern@hotmail.example\",\"casey.robel@yahoo.example\",\"casper-alfonzo@yahoo.example\",\"cassin-cleta@hotmail.example\",\"cassin.mario@hotmail.example\",\"cayla.vonrueden@hotmail.example\",\"cecilia.stark@hotmail.example\",\"cedrick-kessler@gmail.example\",\"champlin.jensen@yahoo.example\",\"chanel.rippin@yahoo.example\",\"charlene-bayer@hotmail.example\",\"chet-blick@yahoo.example\",\"christophe.wilderman@hotmail.example\",\"ciara-larson@hotmail.example\",\"ciara.green@yahoo.example\",\"clark-luettgen@gmail.example\",\"claudie-dare@yahoo.example\",\"claudine.mccullough@yahoo.example\",\"clay-pfannerstill@gmail.example\",\"clemens.hansen@gmail.example\",\"cole.christophe@yahoo.example\",\"conn-gideon@yahoo.example\",\"connell-o-henriette@yahoo.example\",\"connell.lisette.o@yahoo.example\",\"connelly-alice@gmail.example\",\"connelly.bessie@hotmail.example\",\"conner.windler@gmail.example\",\"conroy-orlando@yahoo.example\",\"conroy-yadira@gmail.example\",\"corbin.mertz@hotmail.example\",\"corbin.wiegand@yahoo.example\",\"corkery.theresa@yahoo.example\",\"cornelius-bogisich@hotmail.example\",\"crawford.rath@gmail.example\",\"cremin-jerome@hotmail.example\",\"cremin.tyler@gmail.example\",\"cronin-marley@yahoo.example\",\"curtis.morar@hotmail.example\",\"d-amore-geoffrey@yahoo.example\",\"dagmar-sawayn@gmail.example\",\"dana-orn@hotmail.example\",\"dana.kozey@yahoo.example\",\"darwin-abshire@yahoo.example\",\"dawson-kuvalis@gmail.example\",\"dax-bartell@hotmail.example\",\"dayne.strosin@hotmail.example\",\"deckow.alisha@hotmail.example\",\"dell-schimmel@hotmail.example\",\"demario-hand@yahoo.example\",\"demetris.hauck@hotmail.example\",\"dena-schiller@yahoo.example\",\"denesik-delphia@hotmail.example\",\"deron-cremin@gmail.example\",\"destiny-murazik@hotmail.example\",\"deven.brekke@gmail.example\",\"domenico.bailey@yahoo.example\",\"dominic.jacobi@yahoo.example\",\"donavon.lowe@gmail.example\",\"dooley-karen@gmail.example\",\"douglas-prosacco@hotmail.example\",\"douglas.anais@hotmail.example\",\"durgan-emiliano@hotmail.example\",\"earnestine-lockman@hotmail.example\",\"easton-koch@gmail.example\",\"effertz-elnora@yahoo.example\",\"eileen-mayert@gmail.example\",\"eldon.herman@yahoo.example\",\"elisa-grady@yahoo.example\",\"ellie-oberbrunner@yahoo.example\",\"ellsworth.west@hotmail.example\",\"elmo.schimmel@yahoo.example\",\"elsa.klocko@gmail.example\",\"elvera.lowe@yahoo.example\",\"elwin.okuneva@gmail.example\",\"emanuel-corwin@gmail.example\",\"emard-janiya@gmail.example\",\"emerson-o-keefe@gmail.example\",\"emery.gerlach@hotmail.example\",\"emmie-mertz@yahoo.example\",\"enola.bayer@yahoo.example\",\"erich.kris@gmail.example\",\"ernestina-gerhold@gmail.example\",\"ernser-ardella@gmail.example\",\"esther-douglas@yahoo.example\",\"estrella.goyette@hotmail.example\",\"ethan.rutherford@gmail.example\",\"eudora-renner@gmail.example\",\"eugenia-stroman@yahoo.example\",\"eula-connell-o@hotmail.example\",\"eve.mante@yahoo.example\",\"fadel-philip@hotmail.example\",\"feest-angus@gmail.example\",\"feil.sterling@gmail.example\",\"felicity-greenfelder@hotmail.example\",\"felipe-johnston@yahoo.example\",\"ferry.enrico@hotmail.example\",\"fisher-antwan@hotmail.example\",\"florence.donnelly@gmail.example\",\"foster-gusikowski@yahoo.example\",\"foster-marks@yahoo.example\",\"francisco-robel@hotmail.example\",\"freddie.wisoky@gmail.example\",\"fredrick-gulgowski@yahoo.example\",\"fritz.dickens@hotmail.example\",\"funk.nichole@yahoo.example\",\"gabrielle-considine@yahoo.example\",\"gabrielle-frami@gmail.example\",\"gaetano-rogahn@hotmail.example\",\"gaylord-granville@yahoo.example\",\"gene-lueilwitz@gmail.example\",\"gerhold.lempi@yahoo.example\",\"germaine-brakus@yahoo.example\",\"gibson.eveline@hotmail.example\",\"gilberto-mueller@gmail.example\",\"gino.johnston@yahoo.example\",\"giovani-thompson@hotmail.example\",\"giovani.lesch@hotmail.example\",\"gislason-kaelyn@hotmail.example\",\"giuseppe.morar@hotmail.example\",\"gleichner-joshuah@gmail.example\",\"glover-eryn@gmail.example\",\"glover.kelsie@yahoo.example\",\"goldner.ruthe@hotmail.example\",\"gorczany-eulah@yahoo.example\",\"gottlieb-ola@gmail.example\",\"gottlieb-ruthe@yahoo.example\",\"grady.raynor@hotmail.example\",\"graham-liam@yahoo.example\",\"greenfelder-hulda@gmail.example\",\"greenfelder.wilbert@gmail.example\",\"greg-purdy@gmail.example\",\"gretchen.muller@hotmail.example\",\"greyson.boyle@gmail.example\",\"grimes-terrence@gmail.example\",\"grimes.melisa@gmail.example\",\"guido-mckenzie@yahoo.example\",\"gulgowski.ubaldo@gmail.example\",\"gutkowski-pattie@hotmail.example\",\"gutmann-lura@hotmail.example\",\"hagenes-rosie@hotmail.example\",\"hahn.hugh@hotmail.example\",\"halvorson.dale@gmail.example\",\"hane.audie@gmail.example\",\"hane.carter@gmail.example\",\"hansen-karl@hotmail.example\",\"hansen.alta@yahoo.example\",\"hansen.anibal@yahoo.example\",\"hansen.magnolia@gmail.example\",\"harris-myrtice@gmail.example\",\"harris.constantin@hotmail.example\",\"harris.richard@yahoo.example\",\"heath-dare@gmail.example\",\"heathcote.jamar@gmail.example\",\"heidenreich-patience@hotmail.example\",\"heidenreich.pearlie@hotmail.example\",\"heidi-glover@gmail.example\",\"henry-rowe@yahoo.example\",\"hermann-madelyn@hotmail.example\",\"hermiston.gerald@yahoo.example\",\"hertha.price@gmail.example\",\"herzog-ophelia@hotmail.example\",\"hessel.arnoldo@yahoo.example\",\"hettinger-brendon@yahoo.example\",\"hettinger.david@yahoo.example\",\"hettinger.orval@hotmail.example\",\"hettinger.shyanne@yahoo.example\",\"hills-violet@hotmail.example\",\"hilpert.gunnar@yahoo.example\",\"hollis-hettinger@gmail.example\",\"homenick-omari@hotmail.example\",\"hoppe.kathryne@gmail.example\",\"hoppe.lewis@gmail.example\",\"howell-reba@gmail.example\",\"howell.jacinthe@yahoo.example\",\"hudson-audra@hotmail.example\",\"hudson.larkin@hotmail.example\",\"huels-earnest@hotmail.example\",\"huels-gunnar@yahoo.example\",\"hyatt.rowan@hotmail.example\",\"jace-kihn@yahoo.example\",\"jacey.schoen@hotmail.example\",\"jacobs-oliver@yahoo.example\",\"jacobs-ronny@hotmail.example\",\"jacobson.stan@gmail.example\",\"jairo-simonis@yahoo.example\",\"jakob.hansen@gmail.example\",\"jakubowski.nyasia@yahoo.example\",\"jaleel.collins@gmail.example\",\"jamel.stanton@yahoo.example\",\"jannie-balistreri@yahoo.example\",\"jasen.stanton@yahoo.example\",\"jast.leann@yahoo.example\",\"jayden.kris@hotmail.example\",\"jazmin.brekke@gmail.example\",\"jedediah-huels@hotmail.example\",\"jeffry-schowalter@hotmail.example\",\"jenkins-sandy@yahoo.example\",\"jennifer-klocko@hotmail.example\",\"jerrod-king@yahoo.example\",\"jessika.funk@yahoo.example\",\"jo-gusikowski@hotmail.example\",\"joe.becker@yahoo.example\",\"joelle-ullrich@gmail.example\",\"johns-myrtle@yahoo.example\",\"johnston.benny@gmail.example\",\"jorge.bins@gmail.example\",\"josh-schimmel@gmail.example\",\"judd-hickle@gmail.example\",\"kade-kub@hotmail.example\",\"kaela-kunze@gmail.example\",\"kariane.hintz@gmail.example\",\"karine.mante@gmail.example\",\"katharina-heathcote@yahoo.example\",\"kavon-dach@gmail.example\",\"kaya.schoen@yahoo.example\",\"kayley.powlowski@hotmail.example\",\"keefe-o-jonas@yahoo.example\",\"keenan.ferry@hotmail.example\",\"kellie.price@hotmail.example\",\"kelsi.douglas@gmail.example\",\"kemmer-gene@yahoo.example\",\"kemmer-matt@yahoo.example\",\"kemmer.bonnie@hotmail.example\",\"kennedy-kunde@gmail.example\",\"kerluke.jakob@gmail.example\",\"kertzmann-coty@hotmail.example\",\"keshaun-carroll@hotmail.example\",\"khalid-pouros@yahoo.example\",\"khalid.blanda@yahoo.example\",\"kihn.alfred@yahoo.example\",\"kilback-alisha@hotmail.example\",\"kilback-carmelo@yahoo.example\",\"kitty.hilll@gmail.example\",\"koelpin-karelle@gmail.example\",\"koepp-melyna@gmail.example\",\"kohler.jermain@hotmail.example\",\"konopelski.beaulah@hotmail.example\",\"koss-ella@hotmail.example\",\"koss.letha@hotmail.example\",\"kovacek-dawson@hotmail.example\",\"kristoffer.blanda@yahoo.example\",\"krystel.boyle@yahoo.example\",\"kshlerin-bernardo@gmail.example\",\"kshlerin-stella@yahoo.example\",\"kulas-armani@yahoo.example\",\"kunze.eleanora@hotmail.example\",\"kuphal.colton@gmail.example\",\"kurtis.parker@gmail.example\",\"kuvalis-cierra@yahoo.example\",\"kuvalis-willis@yahoo.example\",\"kyler-altenwerth@yahoo.example\",\"kyler.abshire@yahoo.example\",\"kyra-lynch@hotmail.example\",\"lacey.dickinson@hotmail.example\",\"langosh.cathrine@gmail.example\",\"langworth-savion@gmail.example\",\"larkin-lilliana@hotmail.example\",\"larkin.cedrick@gmail.example\",\"larson-adrianna@gmail.example\",\"laurel.pfannerstill@gmail.example\",\"laurie-sanford@hotmail.example\",\"lavern.botsford@hotmail.example\",\"lavern.boyle@hotmail.example\",\"leannon-clay@gmail.example\",\"lebsack-tristin@yahoo.example\",\"ledner-nichole@yahoo.example\",\"leila-considine@gmail.example\",\"leta-heidenreich@yahoo.example\",\"leuschke-estefania@yahoo.example\",\"liam-schoen@hotmail.example\",\"lillie.wilderman@hotmail.example\",\"lind.annamae@gmail.example\",\"linnea.dickens@gmail.example\",\"littel.otto@hotmail.example\",\"little-anika@hotmail.example\",\"little.john@yahoo.example\",\"lockman-janiya@hotmail.example\",\"logan-weber@yahoo.example\",\"lon-friesen@yahoo.example\",\"lorna.greenholt@yahoo.example\",\"lou.runte@gmail.example\",\"lowell-daniel@gmail.example\",\"loyal.wintheiser@yahoo.example\",\"loyce-lemke@yahoo.example\",\"lucas-beer@gmail.example\",\"lucile-bednar@gmail.example\",\"lueilwitz.osbaldo@yahoo.example\",\"luna-nienow@gmail.example\",\"lynch.tyson@gmail.example\",\"lysanne-brekke@yahoo.example\",\"mabel-grimes@hotmail.example\",\"macejkovic-cyrus@gmail.example\",\"macejkovic.andrew@hotmail.example\",\"mackenzie-ullrich@yahoo.example\",\"madge-friesen@gmail.example\",\"madie.bayer@hotmail.example\",\"maeve.hilpert@hotmail.example\",\"maiya-beier@hotmail.example\",\"malika-kuphal@hotmail.example\",\"mante-dakota@yahoo.example\",\"marcelle-rippin@gmail.example\",\"marcelo-ferry@gmail.example\",\"margarete.tillman@gmail.example\",\"marley.gorczany@hotmail.example\",\"marvin.kris@gmail.example\",\"mathilde.quigley@gmail.example\",\"maurine-considine@hotmail.example\",\"maximillia.ebert@hotmail.example\",\"maximillian-zboncak@hotmail.example\",\"mayer.arne@hotmail.example\",\"mayert.jessyca@gmail.example\",\"mckenzie.eduardo@yahoo.example\",\"mclaughlin.ezekiel@yahoo.example\",\"meagan.cremin@yahoo.example\",\"melba-witting@hotmail.example\",\"melisa.hilpert@hotmail.example\",\"melissa.cormier@hotmail.example\",\"merle.blick@yahoo.example\",\"merle.moen@yahoo.example\",\"mertz.antoinette@hotmail.example\",\"mertz.melissa@gmail.example\",\"micaela.kerluke@gmail.example\",\"milan-ritchie@gmail.example\",\"miller-geovanni@hotmail.example\",\"miller.morgan@gmail.example\",\"mills-andy@hotmail.example\",\"milton.schiller@hotmail.example\",\"mina.reynolds@yahoo.example\",\"miracle.erdman@gmail.example\",\"misty-botsford@hotmail.example\",\"mitchell-lacey@gmail.example\",\"moen-evalyn@gmail.example\",\"mohr.johnson@gmail.example\",\"mollie.bogan@hotmail.example\",\"monahan.loma@yahoo.example\",\"monserrate-doyle@hotmail.example\",\"morar-maddison@hotmail.example\",\"morissette.jailyn@gmail.example\",\"mraz-tomas@gmail.example\",\"mraz.caitlyn@yahoo.example\",\"muller-russell@yahoo.example\",\"murazik-donny@hotmail.example\",\"murray-idell@gmail.example\",\"murray-zemlak@hotmail.example\",\"murray.gleason@gmail.example\",\"mya-gleason@yahoo.example\",\"myles.deckow@gmail.example\",\"myrtle.bahringer@hotmail.example\",\"nader-arnaldo@hotmail.example\",\"nader-ryley@hotmail.example\",\"nayeli.becker@yahoo.example\",\"nicolas.dameon@yahoo.example\",\"nicolas.karen@hotmail.example\",\"nikko.bartoletti@gmail.example\",\"nikolas-hilpert@gmail.example\",\"nikolaus-willie@yahoo.example\",\"nils.gaylord@hotmail.example\",\"nolan-amy@hotmail.example\",\"nolan.samantha@hotmail.example\",\"o-issac-kon@hotmail.example\",\"o.janelle.hara@gmail.example\",\"oceane.runte@yahoo.example\",\"odell.stehr@hotmail.example\",\"olaf.sipes@gmail.example\",\"ollie.corkery@gmail.example\",\"ondricka-lamont@hotmail.example\",\"ondricka-madge@yahoo.example\",\"ondricka.rollin@gmail.example\",\"orie-sipes@yahoo.example\",\"ortiz.harrison@gmail.example\",\"orville-effertz@hotmail.example\",\"oscar-olson@hotmail.example\",\"osinski-joanne@gmail.example\",\"pacocha-khalil@hotmail.example\",\"padberg-albert@gmail.example\",\"pagac-yessenia@yahoo.example\",\"parker-lilliana@yahoo.example\",\"pattie.senger@yahoo.example\",\"paucek-larry@hotmail.example\",\"petra.durgan@hotmail.example\",\"peyton-barton@gmail.example\",\"powlowski-mohammed@yahoo.example\",\"price-rosalyn@yahoo.example\",\"rau.arnaldo@hotmail.example\",\"raynor.chasity@gmail.example\",\"rebekah-dickinson@hotmail.example\",\"rebekah.ledner@gmail.example\",\"reichel-antwon@hotmail.example\",\"reichel.gracie@gmail.example\",\"reichert-evangeline@yahoo.example\",\"reid-reilly@hotmail.example\",\"reilly.o.franco@yahoo.example\",\"rempel.brooke@gmail.example\",\"rene.muller@gmail.example\",\"reuben-koelpin@yahoo.example\",\"rey-schumm@hotmail.example\",\"reyna-greenholt@yahoo.example\",\"reynolds-melisa@hotmail.example\",\"richmond-adams@gmail.example\",\"roberts-lilian@yahoo.example\",\"rogahn-meta@hotmail.example\",\"rolfson-ford@yahoo.example\",\"rolfson.natalie@yahoo.example\",\"romaguera-angeline@yahoo.example\",\"roob-lila@gmail.example\",\"rosalinda-stamm@gmail.example\",\"rosella-bergstrom@gmail.example\",\"rowe-celestine@gmail.example\",\"ruecker-kathlyn@yahoo.example\",\"ruecker-tad@yahoo.example\",\"runolfsdottir-tyreek@gmail.example\",\"runolfsdottir.augustine@gmail.example\",\"runolfsson.davonte@gmail.example\",\"rutherford-beau@yahoo.example\",\"rylee-upton@yahoo.example\",\"ryleigh-padberg@hotmail.example\",\"sabrina-schmidt@hotmail.example\",\"sabryna-schumm@gmail.example\",\"sallie.wehner@yahoo.example\",\"samir.hayes@yahoo.example\",\"sanford.leilani@yahoo.example\",\"satterfield-abbey@hotmail.example\",\"satterfield.chris@hotmail.example\",\"satterfield.creola@hotmail.example\",\"sauer-franco@yahoo.example\",\"schaden.johathan@hotmail.example\",\"schamberger-zora@gmail.example\",\"schiller.loyal@gmail.example\",\"schinner.verna@yahoo.example\",\"schmeler-lucinda@hotmail.example\",\"schmeler-rita@yahoo.example\",\"schmeler.annabelle@gmail.example\",\"schoen.viola@hotmail.example\",\"schuster.geovanny@yahoo.example\",\"scottie.schmidt@hotmail.example\",\"senger-kamron@hotmail.example\",\"shanie.spinka@gmail.example\",\"shanny-kuvalis@gmail.example\",\"shirley-okuneva@yahoo.example\",\"sidney-kling@gmail.example\",\"skiles-devan@gmail.example\",\"skye.heidenreich@gmail.example\",\"smith-meaghan@yahoo.example\",\"smith-price@yahoo.example\",\"spencer.efrain@gmail.example\",\"spinka-donato@yahoo.example\",\"spinka-jessy@gmail.example\",\"sporer-nyasia@hotmail.example\",\"sporer.toby@yahoo.example\",\"stamm.davin@yahoo.example\",\"stanley.kuphal@gmail.example\",\"stark.yasmin@gmail.example\",\"stehr-freeman@hotmail.example\",\"stehr.tyson@gmail.example\",\"steuber-vernice@yahoo.example\",\"steuber.dedrick@gmail.example\",\"stewart.sawayn@gmail.example\",\"stiedemann-gage@gmail.example\",\"stiedemann.coby@gmail.example\",\"stokes.cordelia@yahoo.example\",\"stoltenberg-miguel@gmail.example\",\"swaniawski-kaleb@gmail.example\",\"swaniawski-luisa@hotmail.example\",\"swift.pietro@hotmail.example\",\"tavares.metz@yahoo.example\",\"terry-gregorio@gmail.example\",\"terry-william@yahoo.example\",\"terry.darlene@gmail.example\",\"terry.joe@gmail.example\",\"theodore.mcglynn@hotmail.example\",\"theresa.grant@yahoo.example\",\"theresia-russel@gmail.example\",\"thompson-fay@yahoo.example\",\"thompson-hosea@hotmail.example\",\"thurman-pouros@hotmail.example\",\"toby.yundt@gmail.example\",\"torp.magdalen@yahoo.example\",\"trantow-daphnee@hotmail.example\",\"tressie-smitham@yahoo.example\",\"treutel-jessika@yahoo.example\",\"treutel.jaquan@hotmail.example\",\"tromp-demario@yahoo.example\",\"tromp.emelia@hotmail.example\",\"trudie-muller@gmail.example\",\"trudie.koch@yahoo.example\",\"turner.dahlia@yahoo.example\",\"turner.kelley@hotmail.example\",\"tyrel-beatty@yahoo.example\",\"ullrich-ladarius@gmail.example\",\"unique.jerde@yahoo.example\",\"vanessa-jaskolski@gmail.example\",\"vergie.borer@hotmail.example\",\"veronica.weissnat@gmail.example\",\"virginia-prohaska@yahoo.example\",\"vonrueden-sheridan@hotmail.example\",\"waelchi-filomena@yahoo.example\",\"waelchi-jaqueline@hotmail.example\",\"waelchi.iva@yahoo.example\",\"walker-derrick@yahoo.example\",\"walker-nicole@yahoo.example\",\"walker-trace@gmail.example\",\"walker.carter@yahoo.example\",\"walter-melisa@gmail.example\",\"walter.chris@yahoo.example\",\"ward.anais@gmail.example\",\"ward.mabel@gmail.example\",\"warren.gulgowski@hotmail.example\",\"watsica-olen@gmail.example\",\"watsica.stanley@hotmail.example\",\"weber-breana@hotmail.example\",\"weber-gino@yahoo.example\",\"weber-mohammad@yahoo.example\",\"weimann.keyshawn@hotmail.example\",\"weimann.maryam@gmail.example\",\"weissnat-victoria@gmail.example\",\"weissnat.elmore@gmail.example\",\"weissnat.mathilde@hotmail.example\",\"welch-lucinda@yahoo.example\",\"wendell-becker@yahoo.example\",\"west.laisha@yahoo.example\",\"white.berneice@gmail.example\",\"wiegand.guy@gmail.example\",\"wilderman-nellie@hotmail.example\",\"wilhelmine.erdman@gmail.example\",\"wilkinson-penelope@gmail.example\",\"wilkinson.edmund@hotmail.example\",\"will.garrison@yahoo.example\",\"willms-ardella@yahoo.example\",\"willms-tressie@hotmail.example\",\"willms.seth@gmail.example\",\"willms.wilhelm@gmail.example\",\"wilton-senger@yahoo.example\",\"winfield.donnelly@hotmail.example\",\"winona.cassin@yahoo.example\",\"wintheiser-broderick@yahoo.example\",\"wintheiser-celestino@gmail.example\",\"wintheiser-murray@yahoo.example\",\"wisoky-rebeka@hotmail.example\",\"witting-cindy@yahoo.example\",\"witting-maud@gmail.example\",\"witting-raegan@gmail.example\",\"wiza-andreanne@gmail.example\",\"wiza.lisette@yahoo.example\",\"wolf-jewell@yahoo.example\",\"wuckert.iva@hotmail.example\",\"wyman.hilma@gmail.example\",\"yundt-haven@hotmail.example\",\"yundt.merl@yahoo.example\",\"zackery.bailey@gmail.example\",\"zane.paucek@yahoo.example\",\"zetta.nitzsche@gmail.example\",\"ziemann-serena@gmail.example\",\"zula.boehm@hotmail.example\"]',NULL,26,_binary '\0','full',NULL,'2024-06-19 14:13:35.860119'),(13,'2024-06-19 14:13:35.927816','2024-06-19 14:13:35.927816','[1,2,3,4,5]',NULL,23,_binary '\0','full',NULL,'2024-06-19 14:13:35.927816'),(14,'2024-06-19 14:13:35.973599','2024-06-19 14:13:35.973599','[\"Average\",\"Below Average\",\"Good\",\"Great\",\"Poor\"]',NULL,28,_binary '\0','full',NULL,'2024-06-19 14:13:35.973599'),(15,'2024-06-19 14:13:36.036647','2024-06-19 14:13:36.036647','[false,true]',NULL,35,_binary '\0','full',NULL,'2024-06-19 14:13:36.036647'),(16,'2024-06-19 14:13:36.102633','2024-06-19 14:13:36.102633','[\"Basic\",\"Business\",\"Premium\"]',NULL,30,_binary '\0','full',NULL,'2024-06-19 14:13:36.102633'),(17,'2024-06-19 14:13:36.191205','2024-06-19 14:13:36.191205','[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,63,65,67,68,69,70,71,72,73,75,78,82,83,88,100]',NULL,39,_binary '\0','full',NULL,'2024-06-19 14:13:36.191205'),(18,'2024-06-19 14:13:36.298124','2024-06-19 14:13:36.298124','[\"Affiliate\",\"Facebook\",\"Google\",\"Organic\",\"Twitter\"]',NULL,45,_binary '\0','full',NULL,'2024-06-19 14:13:36.298124'),(19,'2024-06-19 14:13:36.349486','2024-06-19 14:13:36.349486','[\"AK\",\"AL\",\"AR\",\"AZ\",\"CA\",\"CO\",\"CT\",\"DE\",\"FL\",\"GA\",\"IA\",\"ID\",\"IL\",\"IN\",\"KS\",\"KY\",\"LA\",\"MA\",\"MD\",\"ME\",\"MI\",\"MN\",\"MO\",\"MS\",\"MT\",\"NC\",\"ND\",\"NE\",\"NH\",\"NJ\",\"NM\",\"NV\",\"NY\",\"OH\",\"OK\",\"OR\",\"PA\",\"RI\",\"SC\",\"SD\",\"TN\",\"TX\",\"UT\",\"VA\",\"VT\",\"WA\",\"WI\",\"WV\",\"WY\"]',NULL,48,_binary '\0','full',NULL,'2024-06-19 14:13:36.349486'),(20,'2024-06-19 14:13:36.405499','2024-06-19 14:13:36.405499','[\"Doohickey\",\"Gadget\",\"Gizmo\",\"Widget\"]',NULL,58,_binary '\0','full',NULL,'2024-06-19 14:13:36.405499'),(21,'2024-06-19 14:13:36.473081','2024-06-19 14:13:36.473081','[\"0001664425970\",\"0006590063715\",\"0010465925138\",\"0038948983000\",\"0095774502751\",\"0096051986448\",\"0157967025871\",\"0212722801067\",\"0225815844582\",\"0236197465609\",\"0255973714120\",\"0272643267465\",\"0335243754848\",\"0399569209871\",\"0498395047364\",\"0698616313838\",\"0743731223606\",\"0832349515187\",\"0848056924761\",\"0899183128263\",\"1018947080336\",\"1078766578568\",\"1087115303928\",\"1144906750559\",\"1157194463322\",\"1272575087123\",\"1404411876176\",\"1408483808240\",\"1464781960745\",\"1468999794635\",\"1484994799123\",\"1538211018396\",\"1559730016366\",\"1576499102253\",\"1613730311804\",\"1613963249998\",\"1726123595351\",\"1770178011663\",\"1790740189682\",\"1807963902339\",\"1838229841499\",\"1878073010375\",\"1909194306167\",\"1943523619306\",\"1960588072419\",\"2084705637233\",\"2091630691049\",\"2117622168280\",\"2125923238175\",\"2293343551454\",\"2315609605258\",\"2339358820724\",\"2434890445616\",\"2448500145612\",\"2484897511500\",\"2516506541834\",\"2529776156387\",\"2543248750439\",\"2562717359713\",\"2646001599860\",\"2703547723491\",\"2820850288674\",\"2890379323668\",\"2952766751666\",\"3084140869281\",\"3301617687934\",\"3307124431763\",\"3576267834421\",\"3621077291879\",\"3642408008706\",\"3661250556340\",\"3685697688891\",\"3691313722887\",\"3769015137275\",\"3772022926992\",\"3806751355669\",\"3828680930458\",\"3987140172453\",\"3988126680641\",\"4009053735033\",\"4093428378987\",\"4134502155718\",\"4168050315812\",\"4198118078267\",\"4201407654834\",\"4284914664558\",\"4307721071729\",\"4312472827051\",\"4347934129886\",\"4406572671024\",\"4504719641739\",\"4516685534489\",\"4561421124790\",\"4665903801947\",\"4686859196154\",\"4709231420798\",\"4733532233696\",\"4734618834332\",\"4760375596107\",\"4785470010730\",\"4819782507258\",\"4863291591550\",\"4886504321812\",\"4893655420066\",\"4945934419923\",\"4963935336179\",\"4966277046676\",\"5010710584900\",\"5050273180195\",\"5065846711133\",\"5099742600901\",\"5176352942567\",\"5272733645116\",\"5291392809646\",\"5408760500061\",\"5433448189252\",\"5499736705597\",\"5522456328132\",\"5528517133622\",\"5592486096660\",\"5626486088179\",\"5738533322232\",\"5778452195678\",\"5856636800041\",\"5881647583898\",\"5935916054838\",\"5955704607626\",\"6009279470754\",\"6154584840805\",\"6190070243323\",\"6201199361567\",\"6248889948356\",\"6316992933962\",\"6372029072158\",\"6403813628678\",\"6409491343148\",\"6424174443243\",\"6575325360237\",\"6588791601926\",\"6704641545275\",\"6858015278648\",\"6875096496570\",\"6906120611895\",\"6966709160725\",\"7059492880556\",\"7067375149041\",\"7080123588503\",\"7153630876392\",\"7167715379463\",\"7177157744491\",\"7217466997444\",\"7317365230007\",\"7345418848909\",\"7384311074268\",\"7485639601133\",\"7494558044822\",\"7532074237028\",\"7570673549500\",\"7595223735110\",\"7663515285824\",\"7667946672475\",\"7668932199532\",\"7760442733661\",\"7813908779724\",\"7854842811538\",\"8002754191821\",\"8163753213485\",\"8207931408888\",\"8222420544052\",\"8245402607613\",\"8271165200181\",\"8296484749050\",\"8368305700967\",\"8469939413398\",\"8590367775021\",\"8687358946192\",\"8703661046340\",\"8725228831589\",\"8769809778856\",\"8825217022124\",\"8833419218504\",\"8844419430964\",\"8909358907493\",\"8933669659420\",\"9031323475252\",\"9095019841233\",\"9131148018211\",\"9182640035008\",\"9216642429807\",\"9347854191845\",\"9458076657016\",\"9482467478850\",\"9522454376759\",\"9633135585459\",\"9644009305424\",\"9687547218818\",\"9753065345920\",\"9786855487647\",\"9802920493181\",\"9978391194435\"]',NULL,63,_binary '\0','full',NULL,'2024-06-19 14:13:36.473081'),(22,'2024-06-19 14:13:36.538209','2024-06-19 14:13:36.538209','[\"Aerodynamic Bronze Hat\",\"Aerodynamic Concrete Bench\",\"Aerodynamic Concrete Lamp\",\"Aerodynamic Copper Knife\",\"Aerodynamic Cotton Bottle\",\"Aerodynamic Cotton Lamp\",\"Aerodynamic Granite Bench\",\"Aerodynamic Granite Bottle\",\"Aerodynamic Leather Computer\",\"Aerodynamic Leather Toucan\",\"Aerodynamic Linen Coat\",\"Aerodynamic Paper Coat\",\"Aerodynamic Paper Computer\",\"Aerodynamic Rubber Bench\",\"Awesome Aluminum Keyboard\",\"Awesome Aluminum Table\",\"Awesome Bronze Plate\",\"Awesome Concrete Shoes\",\"Awesome Cotton Shoes\",\"Awesome Granite Car\",\"Awesome Iron Hat\",\"Awesome Plastic Watch\",\"Awesome Rubber Wallet\",\"Awesome Silk Car\",\"Awesome Steel Toucan\",\"Awesome Wool Bench\",\"Durable Aluminum Bag\",\"Durable Copper Clock\",\"Durable Cotton Bench\",\"Durable Cotton Shirt\",\"Durable Iron Knife\",\"Durable Leather Wallet\",\"Durable Marble Watch\",\"Durable Rubber Computer\",\"Durable Steel Toucan\",\"Durable Wool Toucan\",\"Enormous Aluminum Clock\",\"Enormous Aluminum Shirt\",\"Enormous Copper Shirt\",\"Enormous Cotton Pants\",\"Enormous Granite Bottle\",\"Enormous Granite Wallet\",\"Enormous Leather Wallet\",\"Enormous Marble Gloves\",\"Enormous Marble Shoes\",\"Enormous Marble Wallet\",\"Enormous Plastic Coat\",\"Enormous Steel Watch\",\"Enormous Wool Car\",\"Ergonomic Aluminum Plate\",\"Ergonomic Concrete Lamp\",\"Ergonomic Cotton Bag\",\"Ergonomic Granite Bottle\",\"Ergonomic Iron Watch\",\"Ergonomic Leather Pants\",\"Ergonomic Linen Toucan\",\"Ergonomic Marble Computer\",\"Ergonomic Marble Hat\",\"Ergonomic Paper Wallet\",\"Ergonomic Plastic Bench\",\"Ergonomic Rubber Bench\",\"Ergonomic Silk Coat\",\"Ergonomic Silk Keyboard\",\"Ergonomic Silk Table\",\"Ergonomic Wool Bag\",\"Fantastic Aluminum Bottle\",\"Fantastic Copper Hat\",\"Fantastic Leather Watch\",\"Fantastic Rubber Knife\",\"Fantastic Silk Bottle\",\"Fantastic Steel Knife\",\"Fantastic Wool Shirt\",\"Gorgeous Aluminum Plate\",\"Gorgeous Bronze Hat\",\"Gorgeous Concrete Chair\",\"Gorgeous Concrete Shoes\",\"Gorgeous Copper Knife\",\"Gorgeous Linen Bottle\",\"Gorgeous Linen Keyboard\",\"Gorgeous Marble Computer\",\"Gorgeous Marble Plate\",\"Gorgeous Paper Bag\",\"Gorgeous Wooden Car\",\"Heavy-Duty Copper Gloves\",\"Heavy-Duty Copper Toucan\",\"Heavy-Duty Copper Watch\",\"Heavy-Duty Cotton Bottle\",\"Heavy-Duty Linen Gloves\",\"Heavy-Duty Linen Toucan\",\"Heavy-Duty Rubber Bottle\",\"Heavy-Duty Rubber Gloves\",\"Heavy-Duty Silk Car\",\"Heavy-Duty Silk Chair\",\"Heavy-Duty Steel Watch\",\"Heavy-Duty Wooden Clock\",\"Incredible Aluminum Knife\",\"Incredible Bronze Pants\",\"Incredible Bronze Wallet\",\"Incredible Concrete Keyboard\",\"Incredible Concrete Watch\",\"Incredible Granite Toucan\",\"Incredible Linen Knife\",\"Incredible Plastic Chair\",\"Incredible Plastic Watch\",\"Incredible Silk Shoes\",\"Intelligent Bronze Knife\",\"Intelligent Granite Hat\",\"Intelligent Iron Shirt\",\"Intelligent Paper Car\",\"Intelligent Paper Hat\",\"Intelligent Steel Car\",\"Intelligent Wooden Gloves\",\"Lightweight Bronze Table\",\"Lightweight Copper Wallet\",\"Lightweight Granite Hat\",\"Lightweight Leather Bench\",\"Lightweight Leather Gloves\",\"Lightweight Linen Bottle\",\"Lightweight Linen Coat\",\"Lightweight Linen Hat\",\"Lightweight Marble Bag\",\"Lightweight Paper Bottle\",\"Lightweight Steel Knife\",\"Lightweight Steel Watch\",\"Lightweight Wool Bag\",\"Lightweight Wool Computer\",\"Lightweight Wool Plate\",\"Mediocre Aluminum Lamp\",\"Mediocre Aluminum Shirt\",\"Mediocre Cotton Coat\",\"Mediocre Cotton Toucan\",\"Mediocre Leather Coat\",\"Mediocre Leather Computer\",\"Mediocre Marble Lamp\",\"Mediocre Paper Car\",\"Mediocre Plastic Clock\",\"Mediocre Rubber Shoes\",\"Mediocre Silk Bottle\",\"Mediocre Wooden Bench\",\"Mediocre Wooden Table\",\"Mediocre Wool Toucan\",\"Practical Aluminum Coat\",\"Practical Aluminum Table\",\"Practical Bronze Computer\",\"Practical Bronze Watch\",\"Practical Copper Car\",\"Practical Granite Plate\",\"Practical Paper Bag\",\"Practical Plastic Keyboard\",\"Practical Silk Bottle\",\"Practical Silk Computer\",\"Practical Steel Table\",\"Practical Wool Hat\",\"Rustic Concrete Bottle\",\"Rustic Copper Hat\",\"Rustic Copper Knife\",\"Rustic Iron Bench\",\"Rustic Iron Keyboard\",\"Rustic Linen Keyboard\",\"Rustic Marble Bottle\",\"Rustic Paper Bench\",\"Rustic Paper Car\",\"Rustic Paper Wallet\",\"Rustic Rubber Clock\",\"Rustic Rubber Knife\",\"Rustic Silk Knife\",\"Rustic Silk Pants\",\"Sleek Aluminum Clock\",\"Sleek Aluminum Watch\",\"Sleek Bronze Lamp\",\"Sleek Copper Watch\",\"Sleek Granite Pants\",\"Sleek Leather Table\",\"Sleek Leather Toucan\",\"Sleek Marble Clock\",\"Sleek Marble Table\",\"Sleek Paper Toucan\",\"Sleek Plastic Shoes\",\"Sleek Steel Table\",\"Sleek Wool Wallet\",\"Sleek Wool Watch\",\"Small Concrete Knife\",\"Small Copper Clock\",\"Small Copper Plate\",\"Small Cotton Chair\",\"Small Granite Gloves\",\"Small Marble Hat\",\"Small Marble Knife\",\"Small Marble Shoes\",\"Small Plastic Computer\",\"Small Rubber Clock\",\"Small Wool Wallet\",\"Synergistic Copper Computer\",\"Synergistic Granite Chair\",\"Synergistic Leather Coat\",\"Synergistic Marble Keyboard\",\"Synergistic Rubber Shoes\",\"Synergistic Steel Chair\",\"Synergistic Wool Coat\"]',NULL,65,_binary '\0','full',NULL,'2024-06-19 14:13:36.538209'),(23,'2024-06-19 14:13:36.603156','2024-06-19 14:13:36.603156','[\"Alfreda Konopelski II Group\",\"Alfredo Kuhlman Group\",\"Americo Sipes and Sons\",\"Annetta Wyman and Sons\",\"Aufderhar-Boehm\",\"Balistreri-Ankunding\",\"Balistreri-Muller\",\"Barrows-Johns\",\"Batz-Schroeder\",\"Baumbach-Hilpert\",\"Bednar, Berge and Boyle\",\"Berge, Mraz and Sawayn\",\"Bernhard-Grady\",\"Blake Greenfelder Group\",\"Bosco-Breitenberg\",\"Bradtke, Wilkinson and Reilly\",\"Braeden Gislason and Sons\",\"Brittany Mueller Inc\",\"Cale Thompson V and Sons\",\"Carmela Douglas Inc\",\"Carol Marvin LLC\",\"Casper-Schimmel\",\"Cassin-Collins\",\"Claude Thompson Group\",\"Connelly-Mitchell\",\"Connelly-Ritchie\",\"Considine, Bogisich and Bauch\",\"Considine, Lehner and Maggio\",\"Considine, Schamberger and Schiller\",\"Cremin-Williamson\",\"Crona, Block and Homenick\",\"Cruickshank-Abernathy\",\"Daugherty-Dach\",\"Delphia Bauch Inc\",\"Demarcus Brakus Inc\",\"Denesik-Ortiz\",\"Devonte Gleichner Inc\",\"Dominic Mann Group\",\"Donnelly, Renner and Barton\",\"Dooley-Cummings\",\"Dora Fay and Sons\",\"Dorothea Balistreri Inc\",\"Emmerich-Nienow\",\"Erika Volkman Group\",\"Eugenia Kunze LLC\",\"Fisher-Kemmer\",\"Fisher-Purdy\",\"Flatley-Kunde\",\"Ford Runolfsson Group\",\"Francis Wolff Group\",\"Friesen-Anderson\",\"Friesen-Langworth\",\"Gail Bergstrom Inc\",\"Gaylord-Lesch\",\"Gibson, Turner and Douglas\",\"Goyette-Smitham\",\"Grady, Greenfelder and Welch\",\"Gulgowski, Grimes and Mayer\",\"Gutmann-Breitenberg\",\"Hackett-Reynolds\",\"Halle Kulas I LLC\",\"Halvorson, Lockman and Ruecker\",\"Hane, Hamill and Jerde\",\"Hartmann, Mohr and Stiedemann\",\"Hauck, Ernser and Barton\",\"Heaney-Windler\",\"Heathcote-Kirlin\",\"Herman Flatley Group\",\"Herman, Gleason and Renner\",\"Hermiston, O\'Hara and Wunsch\",\"Herta Skiles and Sons\",\"Hills, Fahey and Jones\",\"Hilpert, Jacobs and Hauck\",\"Hodkiewicz-Brekke\",\"Howe, Kiehn and Price\",\"Israel Spinka and Sons\",\"Izabella Dach I and Sons\",\"Jacobson-Daniel\",\"Janick Harvey LLC\",\"Jefferey Volkman LLC\",\"Jerrell Gulgowski Inc\",\"Jerrod McLaughlin LLC\",\"Jones, Hayes and Kshlerin\",\"Jordi Effertz LLC\",\"Keely Stehr Group\",\"Keshaun Mueller Group\",\"Kiehn-Pacocha\",\"Kiel Kassulke Group\",\"Kirlin, Hermann and Stokes\",\"Koch-Ruecker\",\"Koepp, Ondricka and Larkin\",\"Kuhlman-Kuphal\",\"Kuhlman-McKenzie\",\"Kuhn-O\'Reilly\",\"Kuphal, Brown and Koss\",\"Kuphal, Friesen and Rowe\",\"Kuphal, Schowalter and Bogan\",\"Lakin-Stroman\",\"Larson, Pfeffer and Klocko\",\"Ledner-Satterfield\",\"Ledner-Watsica\",\"Legros, Lynch and Howell\",\"Little-Pagac\",\"Lon Wiegand DVM and Sons\",\"Lorenza Mayer Inc\",\"Maegan Casper Group\",\"Marge Effertz Jr. Inc\",\"Marquardt, Crooks and Abshire\",\"Marvin, Turcotte and Wisozk\",\"Mason Bashirian and Sons\",\"Maxime Haley and Sons\",\"Mayer, Kiehn and Turcotte\",\"McClure-Lockman\",\"McClure-Murphy\",\"McDermott, Kiehn and Becker\",\"McGlynn, Fay and Kertzmann\",\"Medhurst-Reichert\",\"Miles Ryan Group\",\"Miss Annamae Kutch Group\",\"Morar-Schamberger\",\"Morissette, Bartoletti and Cummings\",\"Morissette, Dare and Schimmel\",\"Mr. Colton Mayer Group\",\"Mr. Johanna Koepp and Sons\",\"Mr. Tanya Stracke and Sons\",\"Mrs. Eugenia Koelpin and Sons\",\"Mueller, Mayert and Johnston\",\"Mueller-Dare\",\"Murray, Watsica and Wunsch\",\"Myriam Macejkovic Inc\",\"Nikolaus-Hudson\",\"Noah Anderson and Sons\",\"Nolan-Heller\",\"Nolan-Wolff\",\"Odessa Emmerich Inc\",\"Okuneva, Kutch and Monahan\",\"Ora Monahan and Sons\",\"Oran D\'Amore Inc\",\"Orn, Hilpert and Pfannerstill\",\"Pacocha-Volkman\",\"Padberg, Senger and Williamson\",\"Parker, O\'Connell and Beahan\",\"Pouros, Nitzsche and Mayer\",\"Powlowski, Keebler and Quigley\",\"Price Kuhic Inc\",\"Price, Schultz and Daniel\",\"Prohaska-Quigley\",\"Quigley, Von and Will\",\"Regan Bradtke and Sons\",\"Reichert, Johnson and Roob\",\"Reid Pfannerstill and Sons\",\"Reynolds, Gleason and Brekke\",\"Ritchie, Haley and Pacocha\",\"Robyn Padberg Inc\",\"Rodriguez-Kuhlman\",\"Rosanna Murazik Inc\",\"Roscoe Oberbrunner Group\",\"Rowan Kautzer LLC\",\"Ruecker, Carter and Ortiz\",\"Ruecker-Jakubowski\",\"Schamberger-Maggio\",\"Schamberger-Wehner\",\"Schiller, Bogisich and Lockman\",\"Schinner, Schmitt and Crona\",\"Schumm, Brown and Wehner\",\"Schuster-Wyman\",\"Senger, Mertz and Murray\",\"Senger-Doyle\",\"Senger-Stamm\",\"Smitham, Dach and Bode\",\"Spinka-Stokes\",\"Stamm, Crist and Labadie\",\"Stanton-Fritsch\",\"Stark-Bayer\",\"Stroman-Carroll\",\"Swaniawski, Casper and Hilll\",\"Theodora Terry and Sons\",\"Theodore Hansen Inc\",\"Thompson-Wolf\",\"Tia Goyette Group\",\"Toy, Deckow and Nitzsche\",\"Trantow-Bartell\",\"Turner, Kiehn and Schmitt\",\"Una Fadel Group\",\"Upton, Kovacek and Halvorson\",\"Upton, Schoen and Streich\",\"Ursula Collins LLC\",\"Volkman, Greenfelder and Kiehn\",\"Von-Gulgowski\",\"Weimann-Cummings\",\"West, Prohaska and Wunsch\",\"Wilkinson, Donnelly and Gulgowski\",\"Wilkinson-Gottlieb\",\"Wisoky, Pagac and Heaney\",\"Wiza, Abbott and Deckow\",\"Wolf, Beahan and Thiel\",\"Wolff, Ebert and Hansen\",\"Wuckert, Murazik and Ernser\",\"Zemlak, Botsford and Corkery\",\"Zemlak-Wiegand\"]',NULL,60,_binary '\0','full',NULL,'2024-06-19 14:13:36.603156'),(24,'2024-06-19 14:13:36.665093','2024-06-19 14:13:36.665093','[1,2,3,4,5]',NULL,66,_binary '\0','full',NULL,'2024-06-19 14:13:36.665093'),(25,'2024-06-19 14:18:52.901219','2024-06-30 21:00:03.872422','[null,\"card_1\",\"card_10\",\"card_11\",\"card_12\",\"card_13\",\"card_14\",\"card_15\",\"card_16\",\"card_17\",\"card_18\",\"card_19\",\"card_20\",\"card_21\",\"card_22\",\"card_23\",\"card_24\",\"card_25\",\"card_27\",\"card_29\",\"card_3\",\"card_30\",\"card_31\",\"card_4\",\"card_5\",\"card_6\",\"card_7\",\"card_8\",\"card_9\"]',NULL,770,_binary '\0','full',NULL,'2024-06-19 14:18:52.901219'),(26,'2024-06-19 14:18:52.946281','2024-06-19 21:00:03.789951','[\"dashboard_1\",\"dashboard_2\"]',NULL,768,_binary '\0','full',NULL,'2024-06-19 14:18:52.946281'),(27,'2024-06-19 14:18:52.992285','2024-06-19 21:00:03.821295','[null,\"dashboardtab_1\",\"dashboardtab_2\",\"dashboardtab_3\"]',NULL,762,_binary '\0','full',NULL,'2024-06-19 14:18:52.992285'),(28,'2024-06-19 14:18:53.032158','2024-06-30 21:00:03.938643','[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,34,35,36]',NULL,760,_binary '\0','full',NULL,'2024-06-19 14:18:53.032158'),(29,'2024-06-19 14:18:53.072523','2024-06-30 21:00:03.965857','[\"dashboardcard_1\",\"dashboardcard_10\",\"dashboardcard_11\",\"dashboardcard_12\",\"dashboardcard_13\",\"dashboardcard_14\",\"dashboardcard_15\",\"dashboardcard_16\",\"dashboardcard_17\",\"dashboardcard_18\",\"dashboardcard_19\",\"dashboardcard_2\",\"dashboardcard_20\",\"dashboardcard_21\",\"dashboardcard_22\",\"dashboardcard_23\",\"dashboardcard_24\",\"dashboardcard_25\",\"dashboardcard_26\",\"dashboardcard_27\",\"dashboardcard_28\",\"dashboardcard_29\",\"dashboardcard_3\",\"dashboardcard_30\",\"dashboardcard_31\",\"dashboardcard_32\",\"dashboardcard_34\",\"dashboardcard_35\",\"dashboardcard_36\",\"dashboardcard_4\",\"dashboardcard_5\",\"dashboardcard_6\",\"dashboardcard_7\",\"dashboardcard_8\",\"dashboardcard_9\"]',NULL,764,_binary '\0','full',NULL,'2024-06-19 14:18:53.072523'),(30,'2024-06-19 14:18:53.124768','2024-06-19 14:18:53.124768','[\"[]\",\"[{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"afa56954\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"512c560a\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]},{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]}]\",\"[{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":24,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":4,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":23,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",\\\"PRODUCTS__via__PRODUCT_ID__TITLE\\\",{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",\\\"CREATED_AT\\\",{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"Products\\\"}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",\\\"CREATED_AT\\\",{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"Products\\\"}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":22,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":22,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\"]',NULL,765,_binary '\0','full',NULL,'2024-06-19 14:18:53.124768'),(31,'2024-06-19 14:18:53.182211','2024-06-19 14:18:53.182211','[6,7,9,15,17,18,24]',NULL,767,_binary '\0','full',NULL,'2024-06-19 14:18:53.182211'),(32,'2024-06-19 14:18:53.230449','2024-06-20 21:00:03.733557','[1,2,3,5,6,7,8,11]',NULL,763,_binary '\0','full',NULL,'2024-06-19 14:18:53.230449'),(33,'2024-06-19 14:18:53.308438','2024-06-19 21:00:03.989631','[\"{\\\"card.description\\\":\\\"An ordered list of our most successful products\\\",\\\"card.title\\\":\\\"Best selling products\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"TITLE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Products\\\",\\\"graph.y_axis.title_text\\\":\\\"number of orders\\\",\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"table.pivot\\\":false}\",\"{\\\"card.description\\\":\\\"Breaks down the overall performance of each of the product categories \\\",\\\"card.title\\\":\\\"Total orders by category\\\",\\\"column_settings\\\":null,\\\"pie.colors\\\":{\\\"Doohickey\\\":\\\"#7172AD\\\",\\\"Gadget\\\":\\\"#A989C5\\\",\\\"Gizmo\\\":\\\"#C7EAEA\\\",\\\"Widget\\\":\\\"#227FD2\\\"}}\",\"{\\\"card.description\\\":\\\"Compares the current total in revenue with the set goal for the quarter\\\",\\\"progress.goal\\\":250000,\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"sum\\\\\\\"]\\\":{\\\"number_style\\\":\\\"currency\\\"}}}\",\"{\\\"card.description\\\":\\\"Compares the number of unique customers placing orders this month with the previous period\\\",\\\"card.title\\\":\\\"Unique customers per month\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the orders of each category quarter over quarter\\\",\\\"card.title\\\":\\\"Numbers of orders by category per quarter\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Created At\\\",\\\"graph.y_axis.title_text\\\":\\\"Number of orders\\\",\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}}}\",\"{\\\"card.description\\\":\\\"Compares the total discount given this quarter with the previous period\\\",\\\"card.title\\\":\\\"Discount given per quarter\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the total number of orders placed for this product this month with the previous period\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the total number of orders placed this month with the previous period\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the total revenue this quarter with the previous period\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Indicates the average customer review of our products\\\",\\\"card.title\\\":\\\"Average product rating overall\\\",\\\"column_settings\\\":null,\\\"gauge.segments\\\":[{\\\"color\\\":\\\"#EF8C8C\\\",\\\"label\\\":\\\"awful\\\",\\\"max\\\":1,\\\"min\\\":0},{\\\"color\\\":\\\"#F2A86F\\\",\\\"label\\\":\\\"bad\\\",\\\"max\\\":2,\\\"min\\\":1},{\\\"color\\\":\\\"#F9D45C\\\",\\\"label\\\":\\\"alright\\\",\\\"max\\\":3,\\\"min\\\":2},{\\\"color\\\":\\\"#A7D07C\\\",\\\"label\\\":\\\"good\\\",\\\"max\\\":4,\\\"min\\\":3},{\\\"color\\\":\\\"#689636\\\",\\\"label\\\":\\\"great\\\",\\\"max\\\":5,\\\"min\\\":4}],\\\"table.cell_column\\\":\\\"avg\\\"}\",\"{\\\"card.description\\\":\\\"Matches the cumulative revenue  month over month with the number of orders placed each month\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\"],\\\"graph.metrics\\\":[\\\"sum\\\",\\\"sum_2\\\"],\\\"graph.show_trendline\\\":false,\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Orders date\\\",\\\"graph.y_axis.labels_enabled\\\":false,\\\"graph.y_axis.title_text\\\":\\\"Revenue\\\",\\\"series_settings\\\":{\\\"sum\\\":{\\\"display\\\":\\\"line\\\",\\\"line.interpolate\\\":\\\"linear\\\",\\\"line.marker_enabled\\\":false,\\\"show_series_values\\\":true,\\\"title\\\":\\\"Revenue\\\"},\\\"sum_2\\\":{\\\"color\\\":\\\"#51528D\\\",\\\"title\\\":\\\"Number of orders\\\"}}}\",\"{\\\"card.description\\\":\\\"Orders placed per quarter broken down by source and formatted to highlight best and worst quarters\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"SOURCE\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_labels\\\":[null],\\\"pivot.show_row_totals\\\":true,\\\"pivot_table.column_split\\\":{\\\"columns\\\":[[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]],\\\"rows\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"values\\\":[[\\\"aggregation\\\",0]]},\\\"pivot_table.column_widths\\\":{\\\"leftHeaderWidths\\\":[141],\\\"totalLeftHeaderWidths\\\":141,\\\"valueHeaderWidths\\\":{\\\"0\\\":234,\\\"1\\\":263,\\\"2\\\":254,\\\"3\\\":236.3636474609375,\\\"4\\\":227,\\\"5\\\":170}},\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.column_formatting\\\":[{\\\"color\\\":\\\"#FBE499\\\",\\\"colors\\\":[\\\"#ED6E6E\\\",\\\"#FFFFFF\\\",\\\"#84BB4C\\\"],\\\"columns\\\":[\\\"sum\\\"],\\\"highlight_row\\\":false,\\\"max_type\\\":null,\\\"max_value\\\":100,\\\"min_type\\\":null,\\\"min_value\\\":0,\\\"operator\\\":\\\"<\\\",\\\"type\\\":\\\"range\\\",\\\"value\\\":1000}]}\",\"{\\\"card.description\\\":\\\"Shows a distribution of orders broken down by product category across our customers\' age groups\\\",\\\"card.title\\\":\\\"Product category orders per individual age\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.title_text\\\":\\\"Orders by category\\\",\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}},\\\"stackable.stack_type\\\":\\\"normalized\\\"}\",\"{\\\"card.description\\\":\\\"Shows a distribution of orders broken down by source across our customers\' age groups\\\",\\\"card.title\\\":\\\"Orders by source per individual age\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"SOURCE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.title_text\\\":\\\"Orders by Sources\\\",\\\"stackable.stack_type\\\":\\\"normalized\\\"}\",\"{\\\"card.description\\\":\\\"Shows a distribution of revenue in age groups\\\",\\\"card.title\\\":\\\"Revenue per individual age\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"graph.label_value_formatting\\\":\\\"compact\\\",\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.title_text\\\":\\\"Total revenue\\\",\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"card.description\\\":\\\"Shows the distribution of the product categories along the scale of customer ratings\\\",\\\"card.title\\\":\\\"Customer Satisfaction per category\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"RATING\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.title_text\\\":\\\"Customer Ratings\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"graph.y_axis.title_text\\\":\\\"Orders by category\\\",\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"},\\\"count\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.pivot\\\":false}\",\"{\\\"card.title\\\":\\\"Value of orders over time (before taxes)\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.labels_enabled\\\":false,\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}},\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Age insights breakdowns\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Customer satisfaction insights\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Overall business health\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Product category insights\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Top performing products\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Who  and where are our customers\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"SOURCE\\\"],\\\"graph.label_value_formatting\\\":\\\"compact\\\",\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.x_axis.labels_enabled\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"graph.y_axis.labels_enabled\\\":false,\\\"graph.y_axis.title_text\\\":\\\"Orders\\\",\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null}\",\"{\\\"graph.show_values\\\":true,\\\"graph.x_axis.labels_enabled\\\":true,\\\"table.cell_column\\\":\\\"SUBTOTAL\\\",\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.y_axis.labels_enabled\\\":false,\\\"card.title\\\":\\\"Product category orders per age group\\\",\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}},\\\"graph.y_axis.auto_range\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"CATEGORY\\\"],\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"graph.y_axis.title_text\\\":\\\"Buyers\\\",\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.title_text\\\":\\\"Age\\\",\\\"card.title\\\":\\\"Buyers by age group\\\",\\\"graph.metrics\\\":[\\\"count_2\\\"],\\\"graph.series_order\\\":null,\\\"card.description\\\":\\\"Shows a distribution of our customers in age groups\\\",\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"count_2\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"count\\\"]}\",\"{\\\"text\\\":\\\"### Top three all-time products \\\\nMoM performance\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"text\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{}\"]',NULL,761,_binary '\0','full',NULL,'2024-06-19 14:18:53.308438'),(34,'2024-06-19 14:18:53.363827','2024-06-19 14:18:53.363827','[0,1,2]',NULL,799,_binary '\0','full',NULL,'2024-06-19 14:18:53.363827'),(35,'2024-06-19 14:18:53.442883','2024-06-19 14:18:53.442883','[\"Administrators\",\"All Users\",\"Anonymous users\"]',NULL,800,_binary '\0','full',NULL,'2024-06-19 14:18:53.442883'),(36,'2024-06-19 14:18:53.487485','2024-06-19 21:00:04.086384','[0,13371338,13371339,13371340,13371341,13371342,13371343,13371344,13371345]',NULL,801,_binary '\0','full',NULL,'2024-06-19 14:18:53.487485'),(37,'2024-06-19 14:18:53.644385','2024-06-19 21:00:04.314317','[\"dingkai@wishpal.cn\",\"internal@metabase.com\",\"lwl0608@foxmail.com\",\"robin@wishpal.cn\",\"yezian@wishpal.cn\",\"yubingchang@wishpal.cn\",\"zhangzihao@wishpal.cn\",\"zihao@wishpal.cn\"]',NULL,154,_binary '\0','full',NULL,'2024-06-19 14:18:53.644385'),(38,'2024-06-19 14:18:53.690069','2024-06-19 21:00:04.348918','[null,\"-97efSgl32d3f8vdi4eBR\",\"2P0hxK41HnE_pUgooDCkQ\",\"kzG6xtKlVuW_ZHACpb8Dd\",\"mSpViq315NLwh0BTCRq9k\",\"nBs7d-OUyGP0SjieSedJr\",\"nXCuYI_YhRUeIe8dRnD4O\",\"omZt7SYzRnCqKpeKT_7A9\"]',NULL,167,_binary '\0','full',NULL,'2024-06-19 14:18:53.690069'),(39,'2024-06-19 14:18:53.733825','2024-06-19 21:00:04.382423','[\"dingkai\",\"erwin\",\"Metabase\",\"robin\",\"yezian\",\"yubingchang\",\"zhangzihao\",\"zihao\"]',NULL,156,_binary '\0','full',NULL,'2024-06-19 14:18:53.733825'),(40,'2024-06-19 14:18:53.773785','2024-06-19 14:18:53.773785','[false,true]',NULL,169,_binary '\0','full',NULL,'2024-06-19 14:18:53.773785'),(41,'2024-06-19 14:18:53.812387','2024-06-19 14:18:53.812387','[true]',NULL,168,_binary '\0','full',NULL,'2024-06-19 14:18:53.812387'),(42,'2024-06-19 14:18:53.853931','2024-06-19 21:00:04.501667','[false,true]',NULL,161,_binary '\0','full',NULL,'2024-06-19 14:18:53.853931'),(43,'2024-06-19 14:18:53.904768','2024-06-19 14:18:53.904768','[false,true]',NULL,165,_binary '\0','full',NULL,'2024-06-19 14:18:53.904768'),(44,'2024-06-19 14:18:53.957995','2024-06-19 21:00:04.556555','[null,\"Internal\",\"lee\"]',NULL,162,_binary '\0','full',NULL,'2024-06-19 14:18:53.957995'),(45,'2024-06-19 14:18:54.001493','2024-06-19 14:18:54.001493','[null]',NULL,150,_binary '\0','full',NULL,'2024-06-19 14:18:54.001493'),(46,'2024-06-19 14:18:54.042385','2024-06-19 14:18:54.042385','[null]',NULL,166,_binary '\0','full',NULL,'2024-06-19 14:18:54.042385'),(47,'2024-06-19 14:18:54.091399','2024-06-20 21:00:04.292192','[\"$2a$10$5sraZAfMOYt4GRZ6anIwdu5ULe.wboDYcs/FgtNtVhQzPCTzB/njC\",\"$2a$10$65FhY2L6hockGdbxh8.kbOFrfSoJDfXT2FCYqzTjn1xmZ35eAjgny\",\"$2a$10$8smoi8uNak3QUSc9bagoQOhUvxiCBQk9eygw9OOH0orImrBav//l.\",\"$2a$10$Eaa/q/TYbGLf1hGF4wkx3ObHfXfctlK9BAOTQKWA6PIzqMwrvZWDu\",\"$2a$10$JNB9pQ8nFAC0Z.3uoyP7p.8GOQwFDlw64tysk5L956psa5e03VcaS\",\"$2a$10$mTrFfR2bg/ug.UgPwVYY7.hDGspac0Qx2OIH5EQFFzl3/lnLW3NUW\",\"$2a$10$nqSgrsqB1g3mnllbCwBvjetifknEOeUN9JgG0B1GZkgntMf1HMLeG\",\"$2a$10$UKVSkyy/1dVHNsi2LHlnxuCGff3unwZjEL./ahVRtwgB/6a3wUUTS\"]',NULL,158,_binary '\0','full',NULL,'2024-06-19 14:18:54.091399'),(48,'2024-06-19 14:18:54.137740','2024-06-20 21:00:04.322326','[\"3e97641c-1c80-453f-a8d9-7c0d6b7b252f\",\"8ae8875c-d15c-4e9d-acfb-ea4fd3500121\",\"c2f2b1d6-bf3a-48a2-ae59-5130d0dfe22a\",\"cb030eac-dcd5-4697-ab7a-b50dc3a49c05\",\"d273c735-ea81-4615-aa87-6c6c9f9cdd45\",\"d86aa969-4bb7-407a-b449-cf07d3fe30b1\",\"db8dec0a-265b-433c-8ff1-1f27059b7788\",\"f3bdc024-8285-4dfe-b8bb-2055367e5f4c\"]',NULL,151,_binary '\0','full',NULL,'2024-06-19 14:18:54.137740'),(49,'2024-06-19 14:18:54.182622','2024-06-20 21:00:04.350990','[null,\"$2a$10$5hHOr44MrBliegh5zGnCtOHE3uyUiGaB7WIJ1ap6LyHRUuwmFTAC.\",\"$2a$10$80z0R0.eaLKQdiP52u/cGO/.xoX0He8b.W5OtfjLuJ6.sEkE0x9J.\",\"$2a$10$G1jF8utAjOAszBHwPbiU0eXckd57uMnbhLiG0RNKOTDfErBVx9/7C\",\"$2a$10$gbp1TPKHDbn1LveCODST8ej4G1AnBU20vxSjS4xx86ZRBWEUvX5Gy\"]',NULL,149,_binary '\0','full',NULL,'2024-06-19 14:18:54.182622'),(50,'2024-06-19 14:18:54.221933','2024-06-20 21:00:04.379426','[null,1718807763440,1718807785652,1718807807194,1718807827677]',NULL,159,_binary '\0','full',NULL,'2024-06-19 14:18:54.221933'),(51,'2024-06-19 14:18:54.262484','2024-06-19 21:00:04.787727','[null,\"{\\\"last-acknowledged-version\\\":\\\"v0.50.5\\\",\\\"dismissed-custom-dashboard-toast\\\":\\\"true\\\"}\",\"{\\\"last-acknowledged-version\\\":\\\"v0.50.5\\\",\\\"last-used-native-database-id\\\":\\\"2\\\",\\\"dismissed-custom-dashboard-toast\\\":\\\"true\\\",\\\"expand-browse-in-nav\\\":\\\"true\\\"}\",\"{\\\"last-acknowledged-version\\\":\\\"v0.50.5\\\"}\"]',NULL,155,_binary '\0','full',NULL,'2024-06-19 14:18:54.262484'),(52,'2024-06-19 14:18:54.304312','2024-06-19 14:18:54.304312','[null]',NULL,157,_binary '\0','full',NULL,'2024-06-19 14:18:54.304312'),(53,'2024-06-19 14:18:54.352776','2024-06-19 14:18:54.352776','[\"internal\",\"personal\"]',NULL,153,_binary '\0','full',NULL,'2024-06-19 14:18:54.352776'),(54,'2024-06-19 14:18:54.481994','2024-06-19 14:18:54.481994','[true]',NULL,295,_binary '\0','full',NULL,'2024-06-19 14:18:54.481994'),(55,'2024-06-19 14:18:54.540242','2024-06-19 14:18:54.540242','[\"type/*\",\"type/BigInteger\",\"type/Boolean\",\"type/Date\",\"type/DateTime\",\"type/DateTimeWithLocalTZ\",\"type/Decimal\",\"type/Float\",\"type/Integer\",\"type/Text\"]',NULL,286,_binary '\0','full',NULL,'2024-06-19 14:18:54.540242'),(56,'2024-06-19 14:18:54.590454','2024-06-19 14:18:54.590454','[null]',NULL,289,_binary '\0','full',NULL,'2024-06-19 14:18:54.590454'),(57,'2024-06-19 14:18:54.639410','2024-06-19 14:18:54.639410','[null]',NULL,274,_binary '\0','full',NULL,'2024-06-19 14:18:54.639410'),(58,'2024-06-19 14:18:54.684597','2024-06-19 14:18:54.684597','[0]',NULL,292,_binary '\0','full',NULL,'2024-06-19 14:18:54.684597'),(59,'2024-06-19 14:18:54.739698','2024-06-19 14:18:54.739698','[null,false,true]',NULL,280,_binary '\0','full',NULL,'2024-06-19 14:18:54.739698'),(60,'2024-06-19 14:18:54.803829','2024-06-19 14:18:54.803829','[false,true]',NULL,268,_binary '\0','full',NULL,'2024-06-19 14:18:54.803829'),(61,'2024-06-19 14:18:54.846632','2024-06-19 14:18:54.846632','[null]',NULL,264,_binary '\0','full',NULL,'2024-06-19 14:18:54.846632'),(62,'2024-06-19 14:18:54.891707','2024-06-19 14:18:54.891707','[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32]',NULL,272,_binary '\0','full',NULL,'2024-06-19 14:18:54.891707'),(63,'2024-06-19 14:18:54.930959','2024-06-19 14:18:54.930959','[false,true]',NULL,266,_binary '\0','full',NULL,'2024-06-19 14:18:54.930959'),(64,'2024-06-19 14:18:54.971631','2024-06-19 14:18:54.971631','[\"BIGINT\",\"BIGINT UNSIGNED ZEROFILL\",\"BINARY\",\"BIT\",\"BLOB\",\"BOOLEAN\",\"CHAR\",\"CHARACTER\",\"CHARACTER LARGE OBJECT\",\"CHARACTER VARYING\",\"DATE\",\"DECIMAL\",\"DOUBLE\",\"DOUBLE PRECISION\",\"FLOAT\",\"INT\",\"INTEGER\",\"LONGBLOB\",\"LONGTEXT\",\"MEDIUMTEXT\",\"SMALLINT\",\"TIMESTAMP\",\"VARCHAR\"]',NULL,263,_binary '\0','full',NULL,'2024-06-19 14:18:54.971631'),(65,'2024-06-19 14:18:55.020193','2024-06-19 14:18:55.020193','[null,\"A database ID, for DB and table-level permissions\",\"A JSON map with metadata about the event\",\"A JSON object describing the flavor and version of the DBMS.\",\"A program to take an api response and transform to an appropriate response for emitters\",\"A program to take an api response to determine if an error occurred\",\"A schema name, for table-level permissions\",\"A strategy to coerce the base_type into the effective_type.\",\"A table ID\",\"A template that defines method,url,body,headers required to make an api call\",\"A unique identifier given to each user.\",\"A unique internal identifier for the review. Should not be used externally.\",\"An invalidation time that can supersede cache_config.invalidated_at\",\"Average execution time for the query, round to nearest number of milliseconds. This is updated as a rolling average.\",\"Cache hit on query execution\",\"Condition (i.e. \\\"rows\\\" or \\\"goal\\\") used as a guard for alerts\",\"Cookie-based unique identifier for the device/browser the user logged in from.\",\"creation time\",\"Current state of the migration: init, setup, dump, upload, done, error, cancelled\",\"Directory-structure path of ancestor Collections. e.g. \\\"/1/2/\\\" means our Parent is Collection 2, and their parent is Collection 1.\",\"Discount amount.\",\"Displayed name of the tab\",\"either a document or question ID; the item that needs review\",\"Either internal for a user defined remapping or external for a foreign key based remapping\",\"Error message from persisting if applicable\",\"filter\'s operator that applied to the field\",\"For a goal condition, alert when above the goal\",\"Granular cache TTL for specific dashboard.\",\"Granular cache TTL for specific database.\",\"Has this pulse been archived?\",\"Hash key for a cached fieldvalues\",\"Hash of normalized query, calculated in middleware.cache\",\"Hash of the query persisted\",\"ID of the admin who added the database\",\"ID of the Card bookmarked by the user\",\"ID of the card generating the values\",\"ID of the Card model persisted\",\"ID of the collection containing the timeline\",\"ID of the Dashboard bookmarked by the user\",\"ID of the Dashboard favorited by the User.\",\"ID of the Dashboard if this Pulse is a Dashboard Subscription.\",\"ID of the database associated to the persisted card\",\"ID of the database this connection impersonation policy affects\",\"ID of the database this query was ran against.\",\"ID of the entity consuming the values\",\"ID of the field\",\"ID of the field this dimension row applies to\",\"id of the item being bookmarked (Card, Collection, Dashboard, ...) no FK, so may no longer exist\",\"ID of the permissions group this connection impersonation policy affects\",\"ID of the Permissions Group this policy affects.\",\"ID of the Session created by this login if one is currently active. NULL if Session is no longer active.\",\"ID of the Snippet Folder (Collection) this Snippet is in, if any\",\"ID of the Table that should get automatically replaced as query source for the Permissions Group.\",\"ID of the timeline containing the event\",\"ID of the User that logged in.\",\"ID of the User who bookmarked the Card\",\"ID of the User who bookmarked the Collection\",\"ID of the User who bookmarked the Dashboard\",\"ID of the user who created the event\",\"ID of the user who created the timeline\",\"ID of the user who did the review\",\"ID of the User who favorited the Dashboard.\",\"ID of the User who has set the parameter value\",\"ID of the User who ordered bookmarks\",\"If set, this Collection is a personal Collection, for exclusive use of the User with this ID.\",\"If this Pulse is a Dashboard subscription, the ID of the DashboardCard that corresponds to this PulseCard.\",\"Is the collection part of the sample content?\",\"Is the Field referenced directly or via a wildcard\",\"Is this Card allowed to be embedded in different websites (using a signed JWT)?\",\"Is this Dashboard allowed to be embedded in different websites (using a signed JWT)?\",\"Is this Dashboard archived (effectively treated as deleted?)\",\"JSON object that captures the state of the table when we persisted\",\"Keeps a running count of card views\",\"Keeps a running count of dashboard views\",\"List of parameter associated to a card\",\"Matching ID in Cloud for this migration\",\"Metabase version used to create the card.\",\"Metabase version used to create the revision.\",\"most recent modification time\",\"Name of the event\",\"Name of the query snippet\",\"Name of the table persisted\",\"Name of the task\",\"Name of the timeline\",\"NanoID tag for each user\",\"Nested field column paths, flattened\",\"Nullable column to incidate collection\'s authority level. Initially values are \\\"official\\\" and nil.\",\"Number between 0 to 100 representing progress as a percentage\",\"Number of products bought.\",\"Number of rows in the query results.\",\"Only used with external type remappings. Indicates which field on the FK related table to use for display\",\"Optional description of the timeline\",\"Optional ID of Collection this Card belongs to.\",\"Optional ID of Collection this Dashboard belongs to.\",\"Optional markdown description of the event\",\"Optional pinned position for this item in its Collection. NULL means item is not pinned.\",\"Options ID of Collection this Pulse belongs to.\",\"order of bookmark for user\",\"Part of composite primary key for secret; this is the uniquely generted ID column\",\"Part of composite primary key for secret; this is the version column\",\"Persisted table state (creating, persisted, refreshing, deleted)\",\"PK\",\"Position of the tab with respect to others tabs in dashboard\",\"Preferred ISO locale (language/country) code, e.g \\\"en\\\" or \\\"en-US\\\", for this User. Overrides site default.\",\"Random NanoID tag for unique identity.\",\"referenced card\",\"referenced field\",\"referenced query execution\",\"Role name. NULL indicates the privileges are the current user\'s\",\"Serialized JSON containing Database-local Settings for this Database\",\"Serialized JSON containing User-local Settings for this User\",\"Serialized JSON of the label field ref.\",\"Serialized JSON of the primary key field ref.\",\"Short description used as the display name of this new column\",\"Short string specifying how this query was executed, e.g. in a Dashboard or Pulse.\",\"Skip a scheduled Pulse if none of its questions have any results\",\"Slug of the card which will form the persisted table name\",\"String indicating whether a database has completed its initial sync and is ready to use\",\"String indicating whether a table has completed its initial sync and is ready to use\",\"String to indicate the SSO backend the user is from\",\"Table ID\",\"tag for most recent review\",\"temporal unit options of the breakout\",\"the aggregation function that field applied to\",\"The associated action\",\"The average rating users have given the product. This ranges from 1 - 5\",\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\",\"The city of the account’s billing address\",\"The contact email for the account.\",\"The context of the view, can be collection, question, or dashboard. Only for cards.\",\"The cron schedule for when value syncing should happen.\",\"The cron schedule string for when this database should undergo the metadata sync process (and analysis for new fields).\",\"The dashboard that a tab is on\",\"The date and time an order was submitted.\",\"The date of birth of the user\",\"The date the product was added to our catalog.\",\"The date the user record was created. Also referred to as the user’s \\\"join date\\\"\",\"The day and time a review was written by a user.\",\"The description of the action\",\"The effective type of the field after any coercions.\",\"The error message if the status is error.\",\"The estimated row count\",\"The first 7 characters of the unhashed key\",\"The hash of the query dictionary. (This is a 256-bit SHA3 hash of the query dict.)\",\"The hash of the query dictionary. This is a 256-bit SHA3 hash of the query.\",\"The hashed API key\",\"The ID of the action associated with this query execution, if any.\",\"The ID of the API Key itself\",\"The ID of the associated permission group\",\"The ID of the Card (Question) associated with this query execution, if any.\",\"The ID of the corresponding permissions path for this sandbox\",\"The ID of the Dashboard associated with this query execution, if any.\",\"The ID of the indexed model.\",\"The ID of the model that was viewed\",\"The ID of the model this event applies to, if applicable\",\"The ID of the permission\",\"The ID of the Pulse associated with this query execution, if any.\",\"The ID of the user that last updated this API key\",\"The ID of the User who first publically shared this Action.\",\"The ID of the User who first publically shared this Card.\",\"The ID of the User who first publically shared this Dashboard.\",\"The id of the user who made this order. Note that in some cases where an order was created on behalf of a customer who phoned the order in, this might be the employee who handled the request.\",\"The ID of the User who triggered this query execution, if any.\",\"The international article number. A 13 digit number uniquely identifying the product.\",\"The kind of implicit action create/update/delete\",\"The kind of secret this record represents; the value is interpreted as a Clojure keyword with a hierarchy. Ex: \'bytes\' means generic binary data, \'jks-keystore\' extends \'bytes\' but has a specific meaning.\",\"The label to display identifying the indexed value.\",\"The list price of the product. Note that this is not always the price the product sold for due to discounts, promotions, etc.\",\"The maximum time, in seconds, to return cached results for this Card rather than running a new query.\",\"The name of the model that was viewed\",\"The name of the model this event applies to (e.g. Card, Dashboard), if applicable\",\"The name of the product as it should be displayed to customers.\",\"The name of the user who owns an account\",\"The name of this secret record.\",\"The namespace (hierachy) this Collection belongs to. NULL means the Collection is in the default namespace.\",\"The numbin option of breakout\",\"The numerical product number. Only used internally. All external communication should use the title or EAN.\",\"The parameter ID\",\"The position this Dashboard should appear in the Dashboards list, lower-numbered positions appearing before higher numbered ones.\",\"The postal code of the account’s billing address\",\"The prefix for upload table names\",\"The primary key of the indexed value\",\"The product ID. This is an internal identifier for the product, NOT the SKU.\",\"The product the review was for\",\"The rating (on a scale of 1-5) the user left.\",\"The raw, pre-tax cost of the order. Note that this might be different in the future from the product price due to promotions, credits, etc.\",\"The referenced tab id that dashcard is on, it\'s nullable for dashboard with no tab\",\"The related action\",\"The review the user left. Limited to 2000 characters.\",\"The saved parameter mappings for this action\",\"The saved parameters for this action\",\"The schema name for uploads\",\"The scope of the API key, if applicable\",\"The source of secret record, which controls how Metabase interprets the value (ex: \'file-path\' means the \'simple_value\' is not the real value, but a pointer to a file that contains the value).\",\"The source of the product.\",\"The state or province of the account’s billing address\",\"the status of task history, could be started, failed, success, unknown\",\"The status of the index: initializing, indexed, error, overflow.\",\"the strategy of breakout\",\"The street address of the account’s billing address\",\"The time a field usage was recorded\",\"The time an event ended, if applicable\",\"The time an event was recorded\",\"The time, in milliseconds, this query took to complete.\",\"The timestamp at which the tab was created\",\"The timestamp at which the tab was last updated\",\"The timestamp of when the action was created\",\"The timestamp of when the action was updated\",\"The timestamp of when the bookmark was created\",\"The timestamp of when the card is last used\",\"The timestamp of when the event was created\",\"The timestamp of when the event was modified\",\"The timestamp of when the model was first persisted\",\"The timestamp of when the most recent refresh ended\",\"The timestamp of when the most recent refresh was started\",\"The timestamp of when the most recent state changed\",\"The timestamp of when the timeline was created\",\"The timestamp of when the timeline was updated\",\"The timestamp of when these changes were made.\",\"The timestamp when the card was first published in a static embed\",\"The timestamp when the dashboard was first published in a static embed\",\"The timestamp when the key was created\",\"The timestamp when the key was last updated\",\"The topic of a given audit event\",\"The total billed amount.\",\"The type of card, could be \'question\', \'model\', \'metric\'\",\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"The type of the permission (e.g. \\\"data\\\", \\\"collection\\\", \\\"download\\\"...)\",\"The type of user\",\"The UI visualization_settings for this action\",\"The user associated with this view\",\"The user who created the action\",\"The user who left the review\",\"The user who performed an action or triggered an event\",\"The user-defined name of the API key.\",\"The value this permission is set to.\",\"The version of the fingerprint for this Field. Used so we can keep track of which Fields need to be analyzed again when new things are added to fingerprints.\",\"This is a unique ID for the product. It is also called the “Invoice number” or “Confirmation number” in customer facing emails and screens.\",\"This is the amount of local and federal taxes that are collected on the purchase. Note that other governmental fees on some products are not included here, but instead are accounted for in the subtotal.\",\"This is the latitude of the user on sign-up. It might be updated in the future to the last seen location.\",\"This is the longitude of the user on sign-up. It might be updated in the future to the last seen location.\",\"This is the salted password of the user. It should not be visible\",\"This is used to differentiate instance-analytics collections from all other collections.\",\"Timestamp for when this secret instance was created\",\"Timestamp for when this secret record was updated. Only relevant when non-value field changes since a value change will result in a new version being inserted.\",\"Timestamp of when these FieldValues were last used.\",\"Timestamp of when this Collection was created.\",\"Timestamp when the config was inserted\",\"Timestamp when the config was updated\",\"Timezone identifier for the database, set by the sync process\",\"Timezone to display the underlying UTC timestamp in for the client\",\"True if a CSV of the data should be included for this pulse card\",\"True if a XLS of the data should be included for this pulse card\",\"True if the alert should be disabled after the first notification\",\"Type of action\",\"Type of FieldValues\",\"type of the Bookmark\",\"Type of the entity consuming the values (dashboard, card, etc.)\",\"Unique ID\",\"Unique UUID used to in publically-accessible links to this Action.\",\"Unique UUID used to in publically-accessible links to this Card.\",\"Unique UUID used to in publically-accessible links to this Dashboard.\",\"URL where the backup will be uploaded to\",\"User attribute associated with the database role to use for this connection impersonation policy\",\"User ID who created this secret instance\",\"Value of the parameter\",\"verified, misleading, confusing, not_misleading, pending\",\"When the event happened\",\"When the status changed\",\"When this login occurred.\",\"whether it\'s a question or dashboard\",\"Whether or not to apply formatting to the rows of the export\",\"Whether or not to enable periodic refingerprinting for this Database.\",\"Whether the query was a native query, as opposed to an MBQL one (e.g., created with the GUI).\",\"Whether this Collection has been archived and should be hidden from users.\",\"Whether to automatically run queries when doing simple filtering and summarizing in the Query Builder.\",\"Whether uploads are enabled for this database\",\"Whether we should do On-Demand caching of FieldValues for this DB. This means FieldValues are updated when their Field is used in a Dashboard or Card param.\",\"which part of the query the field was used in\"]',NULL,270,_binary '\0','full',NULL,'2024-06-19 14:18:55.020193'),(66,'2024-06-19 14:18:55.080998','2024-06-19 14:18:55.080998','[\"Account ID\",\"Action ID\",\"Action Model ID\",\"Action Qualified ID\",\"Action Type\",\"Active\",\"Active Subscription\",\"Address\",\"Aggregation Function\",\"Alert Above Goal\",\"Alert Condition\",\"Alert First Only\",\"Anti Csrf Token\",\"Archived\",\"Attribute\",\"Attribute Remappings\",\"Authority Level\",\"Auto Apply Filters\",\"Auto Run Queries\",\"Average Execution Time\",\"Base Type\",\"Birth Date\",\"Blob Data\",\"Body\",\"Bool Prop 1\",\"Bool Prop 2\",\"Breakout Binning Bin Width\",\"Breakout Binning Num Bins\",\"Breakout Binning Strategy\",\"Breakout Temporal Unit\",\"Button Label\",\"Cache Field Values Schedule\",\"Cache Hash\",\"Cache Hit\",\"Cache Invalidated At\",\"Cache Ttl\",\"Calendar\",\"Calendar Name\",\"Canceled At\",\"Card ID\",\"Card Qualified ID\",\"Category\",\"Caveats\",\"Channel Type\",\"Checkin Interval\",\"City\",\"Coercion Strategy\",\"Col\",\"Collection ID\",\"Collection Is Official\",\"Collection Is Personal\",\"Collection Position\",\"Collection Preview\",\"Content\",\"Context\",\"Country\",\"Created At\",\"Creator ID\",\"Cron Expression\",\"Custom Position\",\"Dashboard Card ID\",\"Dashboard ID\",\"Dashboard Qualified ID\",\"Dashboard Tab ID\",\"Dashboardcard ID\",\"Dashboardtab ID\",\"Database ID\",\"Database Indexed\",\"Database Is Auto Increment\",\"Database Partitioned\",\"Database Position\",\"Database Qualified ID\",\"Database Require Filter\",\"Database Required\",\"Database Type\",\"Dataset Query\",\"Date Joined\",\"Date Received\",\"Db ID\",\"Db Version\",\"Dbms Version\",\"Dec Prop 1\",\"Dec Prop 2\",\"Default\",\"Definition\",\"Delete\",\"Dependent On ID\",\"Dependent On Model\",\"Description\",\"Details\",\"Device Description\",\"Device ID\",\"Direct Reference\",\"Discount\",\"Display\",\"Display Name\",\"Duration\",\"Duration Seconds\",\"Ean\",\"Effective Type\",\"Email\",\"Embedding Params\",\"Enable Embedding\",\"Enabled\",\"End Time\",\"End Timestamp\",\"Ended At\",\"Engine\",\"Entity ID\",\"Entity Qualified ID\",\"Entity Type\",\"Entry ID\",\"Error\",\"Error Handle\",\"Estimated Row Count\",\"Event\",\"Event Timestamp\",\"Executor ID\",\"Expected Invoice\",\"External ID\",\"Field ID\",\"Field Order\",\"Filter Op\",\"Fingerprint\",\"Fingerprint Version\",\"Fired Time\",\"First Name\",\"Fk Target Field ID\",\"Flow\",\"Format Rows\",\"Full Name\",\"Group ID\",\"Group Name\",\"Has Access\",\"Has Field Values\",\"Has More Values\",\"Hash\",\"Hash Key\",\"How Is This Calculated\",\"Human Readable Field ID\",\"Human Readable Values\",\"Icon\",\"ID\",\"Include Csv\",\"Include Xls\",\"Income\",\"Indexed At\",\"Initial Sync Status\",\"Initially Published At\",\"Insert\",\"Instance Name\",\"Int Prop 1\",\"Int Prop 2\",\"IP Address\",\"Is Active\",\"Is Admin\",\"Is Audit\",\"Is Creation\",\"Is Datasetnewb\",\"Is Durable\",\"Is Embedding Enabled\",\"Is Full Sync\",\"Is Group Manager\",\"Is Native\",\"Is Nonconcurrent\",\"Is On Demand\",\"Is Qbnewb\",\"Is Reversion\",\"Is Sample\",\"Is Sandboxed\",\"Is Superuser\",\"Is Update Data\",\"Is Upload\",\"Item ID\",\"Job Class Name\",\"Job Data\",\"Job Group\",\"Job Name\",\"Json Unfolding\",\"Key\",\"Key Prefix\",\"Kind\",\"Label ID\",\"Last Analyzed\",\"Last Checkin Time\",\"Last Login\",\"Last Name\",\"Last Used At\",\"Latitude\",\"Legacy Plan\",\"Locale\",\"Location\",\"Lock Name\",\"Login Attributes\",\"Long Prop 1\",\"Long Prop 2\",\"Longitude\",\"Made Public By ID\",\"Made Public By User\",\"Membership Cnt\",\"Membership Flow\",\"Membership Rate\",\"Message\",\"Metabase Version\",\"Metadata\",\"Metadata Sync Schedule\",\"Metric ID\",\"Mid\",\"Misfire Instr\",\"Model\",\"Model ID\",\"Model Index ID\",\"Model Pk\",\"Moderated Item ID\",\"Moderated Item Type\",\"Moderator ID\",\"Most Recent\",\"Name\",\"Namespace\",\"Native\",\"Next Fire Time\",\"Nfc Path\",\"Object\",\"Official Flow\",\"Ordering\",\"Other Cnt\",\"Other Flow\",\"Other Rate\",\"Owner ID\",\"Page URL\",\"Parameter ID\",\"Parameter Mappings\",\"Parameterized Object ID\",\"Parameterized Object Type\",\"Parameters\",\"Parent ID\",\"Password\",\"Password Salt\",\"Payment\",\"Pdate\",\"Perm Type\",\"Perm Value\",\"Permission ID\",\"Personal Owner ID\",\"Pk Ref\",\"Plan\",\"Points Of Interest\",\"Position\",\"Prev Fire Time\",\"Preview Display\",\"Price\",\"Priority\",\"Product ID\",\"Profit Rate\",\"Progress\",\"Ptime\",\"Public UUID\",\"Pulse Channel ID\",\"Pulse ID\",\"Quantity\",\"Query\",\"Query Execution ID\",\"Query Hash\",\"Query Source\",\"Query Type\",\"Question Database ID\",\"Question Is Native\",\"Question Slug\",\"Question Viz Type\",\"Rating\",\"Rating Mapped\",\"Recipient External\",\"Recipient Type\",\"Recipients\",\"Refingerprint\",\"Refresh Begin\",\"Refresh End\",\"Repeat Count\",\"Repeat Interval\",\"Requests Recovery\",\"Reset Token\",\"Reset Triggered\",\"Response Handle\",\"Result Metadata\",\"Result Rows\",\"Reviewer\",\"Role\",\"Row\",\"Running Time\",\"Running Time Seconds\",\"Sched Name\",\"Sched Time\",\"Schedule\",\"Schedule Day\",\"Schedule Frame\",\"Schedule Hour\",\"Schedule Type\",\"Schema\",\"Schema Name\",\"Scope\",\"Seats\",\"Select\",\"Semantic Type\",\"Session ID\",\"Settings\",\"Show In Getting Started\",\"Size X\",\"Size Y\",\"Skip If Empty\",\"Slug\",\"Source\",\"Sso Source\",\"Start Time\",\"Started At\",\"State\",\"State Change At\",\"Status\",\"Str Prop 1\",\"Str Prop 2\",\"Str Prop 3\",\"Streamer Flow\",\"Subtotal\",\"Table ID\",\"Table Name\",\"Task\",\"Task Details\",\"Tax\",\"Template\",\"Text\",\"Time Matters\",\"Time Zone ID\",\"Timeline ID\",\"Times Triggered\",\"Timestamp\",\"Timezone\",\"Title\",\"Topic\",\"Total\",\"Total Flow\",\"Trial Converted\",\"Trial Ends At\",\"Trigger Group\",\"Trigger Name\",\"Trigger State\",\"Trigger Type\",\"Type\",\"Update\",\"Updated At\",\"Updated By ID\",\"Upload URL\",\"Uploads Enabled\",\"Uploads Schema Name\",\"Uploads Table Prefix\",\"Used In\",\"User ID\",\"Value\",\"Value Ref\",\"Values\",\"Vendor\",\"Version\",\"View Count\",\"Visibility Type\",\"Visualization Settings\",\"Width\",\"Zip\",\"Zone Admission Cnt\",\"Zone Admission Flow\",\"Zone Admission Rate\",\"Zone Moment Cnt\",\"Zone Moment Flow\",\"Zone Moment Rate\",\"Zone Superfan Cnt\",\"Zone Superfan Flow\",\"Zone Superfan Rate\"]',NULL,284,_binary '\0','full',NULL,'2024-06-19 14:18:55.080998'),(67,'2024-06-19 14:18:55.140118','2024-06-19 14:18:55.140118','[\"type/*\",\"type/BigInteger\",\"type/Boolean\",\"type/Date\",\"type/DateTime\",\"type/DateTimeWithLocalTZ\",\"type/Decimal\",\"type/Float\",\"type/Integer\",\"type/Text\"]',NULL,294,_binary '\0','full',NULL,'2024-06-19 14:18:55.140118'),(68,'2024-06-19 14:18:55.184618','2024-06-19 21:00:05.422723','[null,\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:13:29Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:17:10.776124Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10.776124Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-1.0,\\\"q1\\\":-1.0,\\\"q3\\\":-1.0,\\\"max\\\":-1.0,\\\"sd\\\":0.0,\\\"avg\\\":-1.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":0.0,\\\"max\\\":0.0,\\\"sd\\\":0.0,\\\"avg\\\":0.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":0.0,\\\"max\\\":0.0,\\\"sd\\\":null,\\\"avg\\\":0.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.718806717186E12,\\\"q1\\\":1.718806717186E12,\\\"q3\\\":1.718806717186E12,\\\"max\\\":1.718806717186E12,\\\"sd\\\":null,\\\"avg\\\":1.718806717186E12}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.718808300002E12,\\\"q1\\\":1.718808300002E12,\\\"q3\\\":1.718808300002E12,\\\"max\\\":1.718808300002E12,\\\"sd\\\":null,\\\"avg\\\":1.718808300002E12}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.7188083E12,\\\"q1\\\":1.7188083E12,\\\"q3\\\":1.7188083E12,\\\"max\\\":1.7188083E12,\\\"sd\\\":null,\\\"avg\\\":1.7188083E12}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":2.0,\\\"q1\\\":2.0,\\\"q3\\\":2.0,\\\"max\\\":2.0,\\\"sd\\\":0.0,\\\"avg\\\":2.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":2.0,\\\"q1\\\":2.0,\\\"q3\\\":2.0,\\\"max\\\":2.0,\\\"sd\\\":null,\\\"avg\\\":2.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":5.0,\\\"q1\\\":5.0,\\\"q3\\\":5.0,\\\"max\\\":5.0,\\\"sd\\\":0.0,\\\"avg\\\":5.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":5.0,\\\"q1\\\":5.0,\\\"q3\\\":5.0,\\\"max\\\":5.0,\\\"sd\\\":null,\\\"avg\\\":5.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":7500.0,\\\"q1\\\":7500.0,\\\"q3\\\":7500.0,\\\"max\\\":7500.0,\\\"sd\\\":null,\\\"avg\\\":7500.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":1.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":10.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":11.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":17.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":19.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":237.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":25.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":3.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":34.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":4.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":40.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":9.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":2.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":453.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":1.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":null,\\\"latest\\\":null}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":1.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":null,\\\"q1\\\":null,\\\"q3\\\":null,\\\"max\\\":null,\\\"sd\\\":null,\\\"avg\\\":null}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":1.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":0.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":1.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":10,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:20:52Z\\\",\\\"latest\\\":\\\"2024-06-19T14:34:07Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":10,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":12.253583241455347}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":100,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:19.094014Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":100,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":28.131243324690477,\\\"q3\\\":80.32215870950205,\\\"max\\\":107.0,\\\"sd\\\":30.62887567195088,\\\"avg\\\":54.722160970231535}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":100,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":102,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":2.4309856865966593,\\\"q3\\\":10.553778422458695,\\\"max\\\":1325.0,\\\"sd\\\":51.198301031505444,\\\"avg\\\":16.21763527054108}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":107,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":27.25,\\\"q3\\\":80.75,\\\"max\\\":107.0,\\\"sd\\\":31.028973070524277,\\\"avg\\\":54.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":107,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.570093457943925}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":107,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.990654205607477}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1076,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.001798561151079137,\\\"average-length\\\":9.972122302158274}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":11,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.769230769230769}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1112,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-06-03T00:37:05.818Z\\\",\\\"latest\\\":\\\"2026-04-19T14:15:25.677Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1112,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":177.41996402877697}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":12,\\\"nil%\\\":0.103448275862069},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.172413793103448}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":13,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.07142857142857142,\\\"percent-email\\\":0.07142857142857142,\\\"percent-state\\\":0.0,\\\"average-length\\\":15.571428571428571}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":134,\\\"nil%\\\":8.016032064128256E-4},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.1130260521042084,\\\"average-length\\\":1.9983967935871743}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":14,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.2723527321376576,\\\"q3\\\":7.050510257216822,\\\"max\\\":13.0,\\\"sd\\\":4.0922652181138774,\\\"avg\\\":4.184615384615385}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1449,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":15,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":1.1958944516674581,\\\"q3\\\":13.625,\\\"max\\\":20.0,\\\"sd\\\":6.9861614362182625,\\\"avg\\\":7.838709677419355}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":16,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:33.339338Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:26.857109Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":16,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":14.592592592592593}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":161,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:31.772349Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1687,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.001603206412825651,\\\"average-length\\\":5.997595190380761}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":169,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":4.0,\\\"q1\\\":609.3544890966989,\\\"q3\\\":205579.27754909397,\\\"max\\\":308873.0,\\\"sd\\\":104756.78611130486,\\\"avg\\\":106199.57978723405}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":17,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":51.64705882352941}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":17,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":170,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":15.691943673970439,\\\"q1\\\":37.25154462926434,\\\"q3\\\":75.45898071609447,\\\"max\\\":98.81933684368194,\\\"sd\\\":21.711481557852057,\\\"avg\\\":55.74639966792074}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1712,\\\"nil%\\\":0.001202404809619238},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2020-09-30T12:00:00Z\\\",\\\"latest\\\":\\\"2031-10-25T12:00:00Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":176,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":19,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.8333333333333333,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":342.875}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":19,\\\"nil%\\\":0.2962962962962963},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.7037037037037037,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":29.62962962962963}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":1966,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.002,\\\"average-length\\\":8.284}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":199,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.495}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:27Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:15.158438Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:21.604528Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:33.229352Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:30.374485Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":0.7752551286084111,\\\"max\\\":1.0,\\\"sd\\\":0.5773502691896258,\\\"avg\\\":0.3333333333333333}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":1.8759615953640392,\\\"max\\\":2.0,\\\"sd\\\":1.0540925533894598,\\\"avg\\\":0.8888888888888888}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":2.0798486957963283,\\\"max\\\":5.0,\\\"sd\\\":1.5460752878198982,\\\"avg\\\":0.5347298787210585}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":1.0,\\\"q3\\\":1.8891559983417312,\\\"max\\\":2.0,\\\"sd\\\":0.5007117441325405,\\\"avg\\\":1.4074074074074074}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":1.0,\\\"q3\\\":14.113628693451263,\\\"max\\\":43.0,\\\"sd\\\":5.769143685844939,\\\"avg\\\":1.7924528301886793}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":1.0,\\\"q3\\\":2.0,\\\"max\\\":2.0,\\\"sd\\\":0.7071067811865476,\\\"avg\\\":1.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":1.624638636739191,\\\"q3\\\":2.0,\\\"max\\\":2.0,\\\"sd\\\":0.2642516874667833,\\\"avg\\\":1.925233644859813}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":2.0,\\\"q1\\\":2.0,\\\"q3\\\":15.789934334069043,\\\"max\\\":27.0,\\\"sd\\\":10.540925533894598,\\\"avg\\\":7.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":10.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":11.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":11.3906}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":11.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":14.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":3.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":35.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":36.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":4.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":60.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.884615384615385}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":1.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":20.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":115.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":67.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.05660377358490566},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":27.0,\\\"q1\\\":27.0,\\\"q3\\\":27.0,\\\"max\\\":27.0,\\\"sd\\\":0.0,\\\"avg\\\":27.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.05660377358490566},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.60377358490566}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.06896551724137931},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:13:29Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.06896551724137931},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":1.0,\\\"q3\\\":1.0,\\\"max\\\":1.0,\\\"sd\\\":0.0,\\\"avg\\\":1.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.06896551724137931},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.3371338E7,\\\"q1\\\":1.3371338E7,\\\"q3\\\":1.3371338E7,\\\"max\\\":1.3371338E7,\\\"sd\\\":0.0,\\\"avg\\\":1.3371338E7}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.06896551724137931}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.103448275862069},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":0.0,\\\"max\\\":0.0,\\\"sd\\\":0.0,\\\"avg\\\":0.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.103448275862069},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.96551724137931}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.1132075471698113},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":2.0,\\\"q1\\\":2.0,\\\"q3\\\":2.0,\\\"max\\\":2.0,\\\"sd\\\":0.0,\\\"avg\\\":2.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.1132075471698113},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":9.754716981132075}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:17:10.848325Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10.848325Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:17:10Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.3371339E7,\\\"q1\\\":1.3371339E7,\\\"q3\\\":1.3371339E7,\\\"max\\\":1.3371339E7,\\\"sd\\\":null,\\\"avg\\\":1.3371339E7}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":10.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":23.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":50.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":61.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.5,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":19.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.5}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.6666666666666667},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:17:10.848325Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10.848325Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.6666666666666667},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:17:10Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.9252336448598131},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":0.4485981308411215}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.9305402425578831},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:13:29Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.9310344827586207},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":0.0,\\\"max\\\":0.0,\\\"sd\\\":0.0,\\\"avg\\\":0.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.9345794392523364},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":0.32710280373831774}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.9615384615384615},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":1.0,\\\"q3\\\":1.0,\\\"max\\\":1.0,\\\"sd\\\":null,\\\"avg\\\":1.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.9735391400220507},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":0.23814773980154355}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":20,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":183.65384615384616}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":200,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-26T19:29:55.147Z\\\",\\\"latest\\\":\\\"2025-04-15T13:34:19.931Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":200,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":200,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":20.6}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":200,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2021,\\\"nil%\\\":0.1859719438877756},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2020-10-01T15:43:40Z\\\",\\\"latest\\\":\\\"2032-06-03T14:01:15Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":21,\\\"nil%\\\":0.1538461538461538},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":65.07692307692308}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":22,\\\"nil%\\\":0.2068965517241379},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":66.51724137931035}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":22,\\\"nil%\\\":0.7331863285556781},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":2.1499448732083795}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2234,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":23,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":3.5120465053408525,\\\"q3\\\":4.216124969497314,\\\"max\\\":5.0,\\\"sd\\\":1.3605488657451452,\\\"avg\\\":3.4715}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":23,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.187431091510474}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2308,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"1958-04-26\\\",\\\"latest\\\":\\\"2000-04-03\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":24,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:35.044327Z\\\",\\\"latest\\\":\\\"2024-06-19T14:13:36.665093Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":24,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":24,\\\"nil%\\\":0.07407407407407407},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.01,\\\"q1\\\":0.0545,\\\"q3\\\":2.24525,\\\"max\\\":14.839,\\\"sd\\\":3.166212844498403,\\\"avg\\\":1.63412}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":24,\\\"nil%\\\":0.07407407407407407},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":10.0,\\\"q1\\\":54.5,\\\"q3\\\":2245.25,\\\"max\\\":14839.0,\\\"sd\\\":3166.212844498403,\\\"avg\\\":1634.12}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2472,\\\"nil%\\\":4.008016032064128E-4},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-48.75,\\\"q1\\\":19.430679334308675,\\\"q3\\\":47.24585743676113,\\\"max\\\":69.23111,\\\"sd\\\":23.492041679980137,\\\"avg\\\":31.35760681046913}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2484,\\\"nil%\\\":4.008016032064128E-4},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-175.06667,\\\"q1\\\":-55.495929410727236,\\\"q3\\\":28.627359769389155,\\\"max\\\":176.21667,\\\"sd\\\":68.51011002740533,\\\"avg\\\":2.6042336031796345}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2490,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":20.85}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2491,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-166.5425726,\\\"q1\\\":-101.58350792373135,\\\"q3\\\":-84.65289348288829,\\\"max\\\":-67.96735199999999,\\\"sd\\\":15.399698968175663,\\\"avg\\\":-95.18741780363999}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2491,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":25.775827,\\\"q1\\\":35.302705923023126,\\\"q3\\\":43.773802584662,\\\"max\\\":70.6355001,\\\"sd\\\":6.390832341883712,\\\"avg\\\":39.87934670484002}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2494,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":1.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":28.185971943887775}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2495,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2020-09-15T16:11:50Z\\\",\\\"latest\\\":\\\"2031-10-10T19:14:48Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2499,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.532}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":25,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":323.61290322580646}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":25,\\\"nil%\\\":0.2258064516129032},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.161290322580645}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":25,\\\"nil%\\\":0.2258064516129032}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-19T21:35:18.752Z\\\",\\\"latest\\\":\\\"2025-04-19T14:06:27.3Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":36.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":1.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":24.1824}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":26,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":4.75,\\\"q3\\\":19.25,\\\"max\\\":26.0,\\\"sd\\\":8.153242879868603,\\\"avg\\\":12.241379310344827}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":26,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":26,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":27.76923076923077}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":26,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":1003.1538461538462}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":26,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":332.0769230769231}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":26,\\\"nil%\\\":0.07407407407407407},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T06:13:30.852284Z\\\",\\\"latest\\\":\\\"2024-06-19T06:18:30.350768Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":268,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:36.890163Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":27,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T06:13:30.792604Z\\\",\\\"latest\\\":\\\"2024-06-19T06:18:30.430338Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":279,\\\"nil%\\\":0.6372657111356119},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":19.676957001102537}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":283,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-392.0,\\\"q1\\\":346.34318116430006,\\\"q3\\\":2798.691641498395,\\\"max\\\":175308.0,\\\"sd\\\":14600.008045102608,\\\"avg\\\":4325.614361702128}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":29,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":26.310344827586206}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":29,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.172413793103448}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":29,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":317.93548387096774}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":29,\\\"nil%\\\":0.8687982359426681},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":7.0,\\\"q1\\\":160.59391777328744,\\\"q3\\\":511.5625,\\\"max\\\":696.0,\\\"sd\\\":185.21707624453452,\\\"avg\\\":311.30252100840335}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-16T16:00:00Z\\\",\\\"latest\\\":\\\"2024-06-18T16:00:00Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.25,\\\"q3\\\":1.75,\\\"max\\\":2.0,\\\"sd\\\":1.0,\\\"avg\\\":1.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.41421356237309515,\\\"q3\\\":1.5857864376269049,\\\"max\\\":2.0,\\\"sd\\\":0.816496580927726,\\\"avg\\\":1.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":3342834.5,\\\"q3\\\":1.337133875E7,\\\"max\\\":1.3371339E7,\\\"sd\\\":7719945.882400623,\\\"avg\\\":8914225.666666666}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":6685669.0,\\\"q3\\\":1.3371339E7,\\\"max\\\":1.3371339E7,\\\"sd\\\":6685669.33333335,\\\"avg\\\":1.0028504E7}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.3371339E7,\\\"q1\\\":1.3371339E7,\\\"q3\\\":1.3371339378453521E7,\\\"max\\\":1.3371341E7,\\\"sd\\\":0.35432226440586684,\\\"avg\\\":1.3371339094339622E7}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.718806416E12,\\\"q1\\\":1.7188064162403704E12,\\\"q3\\\":1.718806556E12,\\\"max\\\":1.718806695E12,\\\"sd\\\":122776.33231929425,\\\"avg\\\":1.7188064784444443E12}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":2.0,\\\"q1\\\":2.0,\\\"q3\\\":3.0,\\\"max\\\":27.0,\\\"sd\\\":10.132456102380443,\\\"avg\\\":6.333333333333333}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":10.666666666666666}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":11.75}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.666666666666666}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":14.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":14.833333333333334}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.1062124248497}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.2931}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.333333333333334}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.773584905660377}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.1730981256890849}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.3333333333333333},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:27Z\\\",\\\"latest\\\":\\\"2024-06-19T14:17:10Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.3333333333333333},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.6666666666666667,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.333333333333334}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.3333333333333333}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.7777777777777778},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.333333333333333}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.9252336448598131},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":2.2803738317757007}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":3,\\\"nil%\\\":0.9310344827586207},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":1.0,\\\"max\\\":1.0,\\\"sd\\\":0.7071067811865476,\\\"avg\\\":0.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":31,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":7.125,\\\"q3\\\":20.870828693386972,\\\"max\\\":53.0,\\\"sd\\\":11.357859020892164,\\\"avg\\\":15.446153846153846}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":31,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":8.25,\\\"q3\\\":23.75,\\\"max\\\":31.0,\\\"sd\\\":9.092121131323903,\\\"avg\\\":16.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":31,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":15.709677419354838}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":31,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":33,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":1.7860355569013984,\\\"q3\\\":9.122760912932305,\\\"max\\\":32.0,\\\"sd\\\":5.903769101909442,\\\"avg\\\":6.2546857772877615}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":34,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.011,\\\"q1\\\":0.04975,\\\"q3\\\":0.066375,\\\"max\\\":0.101,\\\"sd\\\":0.016402701643026086,\\\"avg\\\":0.0580943396226415}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":34,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":11.0,\\\"q1\\\":49.75,\\\"q3\\\":66.375,\\\"max\\\":101.0,\\\"sd\\\":16.402701643026084,\\\"avg\\\":58.094339622641506}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":340,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":15.691943673970439,\\\"q1\\\":49.74894519060184,\\\"q3\\\":105.42965746993103,\\\"max\\\":148.22900526552291,\\\"sd\\\":32.53705013056317,\\\"avg\\\":77.01295465356547}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":37,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":196.0,\\\"q1\\\":444.03894091358103,\\\"q3\\\":1923.25,\\\"max\\\":15043.0,\\\"sd\\\":2693.0444303512995,\\\"avg\\\":1968.2923076923078}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":37,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":4.0,\\\"q1\\\":9.06201920231798,\\\"q3\\\":39.25,\\\"max\\\":307.0,\\\"sd\\\":54.96009041533264,\\\"avg\\\":40.16923076923077}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":374,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.07386990077177508,\\\"average-length\\\":9.94928335170893}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":378,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":4.374045801526718}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":386,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.07386990077177508,\\\"average-length\\\":9.94928335170893}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":393,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":101850.0,\\\"q1\\\":319107.52299782896,\\\"q3\\\":746180.6224582847,\\\"max\\\":993953.0,\\\"sd\\\":251196.11526894735,\\\"avg\\\":526777.4452926209}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":393,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":3.0,\\\"q1\\\":997.0745647699475,\\\"q3\\\":161965.67987006973,\\\"max\\\":312807.0,\\\"sd\\\":98087.25760272479,\\\"avg\\\":77561.11450381679}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":11.0,\\\"q1\\\":13.0,\\\"q3\\\":68.0,\\\"max\\\":79.0,\\\"sd\\\":33.04037933599835,\\\"avg\\\":40.5}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":11.2}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":123.16666666666667}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":36.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.068965517241379}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":259.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":356.07547169811323}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-05-07T16:00:00Z\\\",\\\"latest\\\":\\\"2024-06-18T16:00:00Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":81.56633928656505,\\\"q3\\\":3771.25,\\\"max\\\":13260.0,\\\"sd\\\":2959.013374826793,\\\"avg\\\":2416.9384615384615}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1673597.0,\\\"q1\\\":2808104.5,\\\"q3\\\":5250836.25,\\\"max\\\":8581933.0,\\\"sd\\\":1731684.621442138,\\\"avg\\\":4107630.88372093}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":44,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0026592219847113197,\\\"q3\\\":0.09723432548344135,\\\"max\\\":0.19809000194072723,\\\"sd\\\":0.05544033621079531,\\\"avg\\\":0.05520068291001595}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":4426,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":8.93914247937167,\\\"q1\\\":51.34535490743823,\\\"q3\\\":110.29428389265787,\\\"max\\\":159.34900526552292,\\\"sd\\\":34.26469575709948,\\\"avg\\\":80.35871658771228}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":473,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.536673346693386}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":49,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":1.0,\\\"average-length\\\":2.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":2.7545289729206877,\\\"q3\\\":4.004191340512663,\\\"max\\\":5.0,\\\"sd\\\":0.8137255616667736,\\\"avg\\\":3.3629283489096573}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":3.54744353181696,\\\"q3\\\":4.764807071650455,\\\"max\\\":5.0,\\\"sd\\\":1.0443899855660577,\\\"avg\\\":3.987410071942446}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":18.8}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.453271028037383}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.4084}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.3333333333333333}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.3346693386773547},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":4.4705410821643286}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":50,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":3.5,\\\"q3\\\":400.0,\\\"max\\\":1802.0,\\\"sd\\\":294.92914892328866,\\\"avg\\\":243.2153846153846}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":52,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.10595924779772758,\\\"q3\\\":0.29502174258232117,\\\"max\\\":0.3675389885902405,\\\"sd\\\":0.12431709936570924,\\\"avg\\\":0.20303298767942649}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":52,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":492.75,\\\"q3\\\":10419.5,\\\"max\\\":26617.0,\\\"sd\\\":6082.896724905445,\\\"avg\\\":7646.476923076923}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":52,\\\"nil%\\\":0.3177570093457944},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":32.654205607476634}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":53,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T06:19:06.454153Z\\\",\\\"latest\\\":\\\"2024-06-19T06:44:53.92964Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":53,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":23.5,\\\"q3\\\":590.0,\\\"max\\\":2711.0,\\\"sd\\\":627.0663618113992,\\\"avg\\\":480.4769230769231}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":53,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":13.75,\\\"q3\\\":40.25,\\\"max\\\":53.0,\\\"sd\\\":15.443445211480501,\\\"avg\\\":27.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":56,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.3575119897723198,\\\"q3\\\":0.527744248509407,\\\"max\\\":0.6382589936256409,\\\"sd\\\":0.20076487598082626,\\\"avg\\\":0.39512443693641286}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":56,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":2197.0,\\\"q3\\\":19357.25,\\\"max\\\":50177.0,\\\"sd\\\":11883.161722883837,\\\"avg\\\":14450.553846153845}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":576,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2020-11-20T00:00:00Z\\\",\\\"latest\\\":\\\"2031-12-01T00:00:00Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":589,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":6,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T06:21:34.101784Z\\\",\\\"latest\\\":\\\"2024-06-19T06:44:53.781676Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":6,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:26:46.860777Z\\\",\\\"latest\\\":\\\"2024-06-19T14:44:40.996106Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":6,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":11.418861169915811,\\\"max\\\":18.0,\\\"sd\\\":7.194531973838232,\\\"avg\\\":5.806451612903226}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":6,\\\"nil%\\\":0.1302},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":22.2674}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":6,\\\"nil%\\\":0.8698},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":1.0552}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":6,\\\"nil%\\\":0.9252336448598131},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":1.3831775700934579}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":60,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":599.5,\\\"q3\\\":3618.5,\\\"max\\\":8371.0,\\\"sd\\\":1996.6209134724058,\\\"avg\\\":2350.076923076923}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":62,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0419684499502182,\\\"q3\\\":0.11789575032889843,\\\"max\\\":0.9366649985313416,\\\"sd\\\":0.1611181018068115,\\\"avg\\\":0.12115839780666507}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":62,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":1.755882607764982,\\\"q3\\\":4.882654507928044,\\\"max\\\":100.0,\\\"sd\\\":4.214258386403798,\\\"avg\\\":3.7015}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":62,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.007211179938167334,\\\"q1\\\":0.01574990013614297,\\\"q3\\\":0.2910572588443756,\\\"max\\\":1.0,\\\"sd\\\":0.3020607864796694,\\\"avg\\\":0.22548349442390295}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":63,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":83.0,\\\"q1\\\":4233.0,\\\"q3\\\":29105.25,\\\"max\\\":67028.0,\\\"sd\\\":17050.690670677108,\\\"avg\\\":21290.323076923076}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":642,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":438.15264797507785}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":642,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":1.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":28.327102803738317}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":642,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":65,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-04-14T16:00:00Z\\\",\\\"latest\\\":\\\"2024-06-17T16:00:00Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":65,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-1.2295900583267212,\\\"q1\\\":0.21873850002884865,\\\"q3\\\":0.40105874836444855,\\\"max\\\":0.8319839835166931,\\\"sd\\\":0.2486005214779685,\\\"avg\\\":0.3083435393296755}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":65,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-241.0,\\\"q1\\\":2644.5,\\\"q3\\\":10907.75,\\\"max\\\":25701.0,\\\"sd\\\":5446.351841606647,\\\"avg\\\":7542.015384615384}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":65,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":196.0,\\\"q1\\\":6020.75,\\\"q3\\\":37597.0,\\\"max\\\":85854.0,\\\"sd\\\":21879.886967706014,\\\"avg\\\":28832.33846153846}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":7,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":2.5,\\\"q3\\\":5.9771059563342,\\\"max\\\":11.0,\\\"sd\\\":2.369156648642392,\\\"avg\\\":4.290322580645161}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":7,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":6.0,\\\"q1\\\":6.958187643906492,\\\"q3\\\":20.04956999276797,\\\"max\\\":24.0,\\\"sd\\\":7.211549875921487,\\\"avg\\\":13.838709677419354}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":7,\\\"nil%\\\":0.6470588235294118},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":9.470588235294118}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":701,\\\"nil%\\\":0.898},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.17088996672584322,\\\"q1\\\":2.9786226681458743,\\\"q3\\\":7.338187788658235,\\\"max\\\":61.69684269960571,\\\"sd\\\":3.053663125001991,\\\"avg\\\":5.161255547580326}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":707,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":13.7,\\\"q1\\\":233.1870107122195,\\\"q3\\\":400.5965814842149,\\\"max\\\":33714.6,\\\"sd\\\":763.7961603932441,\\\"avg\\\":519.4153400000004}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":714,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2020-09-30T00:00:00Z\\\",\\\"latest\\\":\\\"2027-05-02T00:00:00Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":797,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":2.273340386603857,\\\"q3\\\":5.337275338216307,\\\"max\\\":11.12,\\\"sd\\\":2.3206651358900316,\\\"avg\\\":3.8722100000000004}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":8,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.7188083E12,\\\"q1\\\":1.718819505E12,\\\"q3\\\":1.718867745E12,\\\"max\\\":1.7190216E12,\\\"sd\\\":6.5615137735129386E7,\\\"avg\\\":1.7188585533333333E12}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":8576,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-03-15T00:18:25Z\\\",\\\"latest\\\":\\\"2022-04-11T20:24:02Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":88,\\\"nil%\\\":0.8930540242557883},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.1069459757442117,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":16.17640573318633}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":9,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":14.555555555555555}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":9,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":1.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":439.7}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":9,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":9,\\\"nil%\\\":0.9252336448598131},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.16822429906542}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":907,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":227.8453873523461,\\\"q3\\\":680.8643684802138,\\\"max\\\":907.0,\\\"sd\\\":261.93707116299544,\\\"avg\\\":454.0}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":907,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":8.880926130099228}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":929,\\\"nil%\\\":0.0}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":93,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-06-19T14:13:29Z\\\",\\\"latest\\\":\\\"2024-06-19T14:18:25.286932Z\\\"}}}\",\"{\\\"global\\\":{\\\"distinct-count\\\":9998,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-05-06T16:05:00Z\\\",\\\"latest\\\":\\\"2024-06-10T09:20:00Z\\\"}}}\"]',NULL,265,_binary '\0','full',NULL,'2024-06-19 14:18:55.184618'),(69,'2024-06-19 14:18:55.237577','2024-06-19 14:18:55.237577','[0,5]',NULL,269,_binary '\0','full',NULL,'2024-06-19 14:18:55.237577'),(70,'2024-06-19 14:18:55.275462','2024-06-19 14:18:55.275462','[null,7,46,62,78,131,145,163,177,226,250,290,314,331,351,386,414,433,474,478,479,510,515,518,534,576,614,625,696]',NULL,271,_binary '\0','full',NULL,'2024-06-19 14:18:55.275462'),(71,'2024-06-19 14:18:55.322049','2024-06-19 14:18:55.322049','[null,\"auto-list\"]',NULL,267,_binary '\0','full',NULL,'2024-06-19 14:18:55.322049'),(72,'2024-06-19 14:18:55.363472','2024-06-19 14:18:55.363472','[false]',NULL,276,_binary '\0','full',NULL,'2024-06-19 14:18:55.363472'),(73,'2024-06-19 14:18:55.428651','2024-06-19 14:18:55.428651','[\"ACCOUNT_ID\",\"action_id\",\"action_model_id\",\"action_qualified_id\",\"action_type\",\"active\",\"ACTIVE_SUBSCRIPTION\",\"ADDRESS\",\"aggregation_function\",\"alert_above_goal\",\"alert_condition\",\"alert_first_only\",\"anti_csrf_token\",\"archived\",\"attribute\",\"attribute_remappings\",\"authority_level\",\"auto_apply_filters\",\"auto_run_queries\",\"average_execution_time\",\"base_type\",\"BIRTH_DATE\",\"BLOB_DATA\",\"BODY\",\"BOOL_PROP_1\",\"BOOL_PROP_2\",\"breakout_binning_bin_width\",\"breakout_binning_num_bins\",\"breakout_binning_strategy\",\"breakout_temporal_unit\",\"BUTTON_LABEL\",\"cache_field_values_schedule\",\"cache_hash\",\"cache_hit\",\"cache_invalidated_at\",\"cache_ttl\",\"CALENDAR\",\"CALENDAR_NAME\",\"CANCELED_AT\",\"card_id\",\"card_qualified_id\",\"CATEGORY\",\"caveats\",\"channel_type\",\"CHECKIN_INTERVAL\",\"CITY\",\"coercion_strategy\",\"col\",\"collection_id\",\"collection_is_official\",\"collection_is_personal\",\"collection_position\",\"collection_preview\",\"content\",\"context\",\"COUNTRY\",\"CREATED_AT\",\"creator_id\",\"CRON_EXPRESSION\",\"custom_position\",\"dashboard_card_id\",\"dashboard_id\",\"dashboard_qualified_id\",\"dashboard_tab_id\",\"dashboardcard_id\",\"dashboardtab_id\",\"database_id\",\"database_indexed\",\"database_is_auto_increment\",\"database_partitioned\",\"database_position\",\"database_qualified_id\",\"database_require_filter\",\"database_required\",\"database_type\",\"dataset_query\",\"date_joined\",\"DATE_RECEIVED\",\"db_id\",\"db_version\",\"dbms_version\",\"DEC_PROP_1\",\"DEC_PROP_2\",\"default\",\"definition\",\"delete\",\"dependent_on_id\",\"dependent_on_model\",\"description\",\"details\",\"device_description\",\"device_id\",\"direct_reference\",\"DISCOUNT\",\"display\",\"display_name\",\"duration\",\"duration_seconds\",\"EAN\",\"effective_type\",\"EMAIL\",\"embedding_params\",\"enable_embedding\",\"enabled\",\"END_TIME\",\"end_timestamp\",\"ended_at\",\"engine\",\"entity_id\",\"entity_qualified_id\",\"entity_type\",\"ENTRY_ID\",\"error\",\"error_handle\",\"estimated_row_count\",\"EVENT\",\"event_timestamp\",\"executor_id\",\"EXPECTED_INVOICE\",\"external_id\",\"field_id\",\"field_order\",\"filter_op\",\"fingerprint\",\"fingerprint_version\",\"FIRED_TIME\",\"FIRST_NAME\",\"fk_target_field_id\",\"flow\",\"format_rows\",\"full_name\",\"group_id\",\"group_name\",\"has_access\",\"has_field_values\",\"has_more_values\",\"hash\",\"hash_key\",\"how_is_this_calculated\",\"human_readable_field_id\",\"human_readable_values\",\"icon\",\"ID\",\"include_csv\",\"include_xls\",\"income\",\"indexed_at\",\"initial_sync_status\",\"initially_published_at\",\"insert\",\"INSTANCE_NAME\",\"INT_PROP_1\",\"INT_PROP_2\",\"ip_address\",\"is_active\",\"is_admin\",\"is_audit\",\"is_creation\",\"is_datasetnewb\",\"IS_DURABLE\",\"is_embedding_enabled\",\"is_full_sync\",\"is_group_manager\",\"is_native\",\"IS_NONCONCURRENT\",\"is_on_demand\",\"is_qbnewb\",\"is_reversion\",\"is_sample\",\"is_sandboxed\",\"is_superuser\",\"IS_UPDATE_DATA\",\"is_upload\",\"item_id\",\"JOB_CLASS_NAME\",\"JOB_DATA\",\"JOB_GROUP\",\"JOB_NAME\",\"json_unfolding\",\"key\",\"key_prefix\",\"kind\",\"label_id\",\"last_analyzed\",\"LAST_CHECKIN_TIME\",\"last_login\",\"LAST_NAME\",\"last_used_at\",\"LATITUDE\",\"LEGACY_PLAN\",\"locale\",\"location\",\"LOCK_NAME\",\"login_attributes\",\"LONG_PROP_1\",\"LONG_PROP_2\",\"LONGITUDE\",\"made_public_by_id\",\"made_public_by_user\",\"membership_cnt\",\"membership_flow\",\"membership_rate\",\"message\",\"metabase_version\",\"metadata\",\"metadata_sync_schedule\",\"metric_id\",\"mid\",\"MISFIRE_INSTR\",\"model\",\"model_id\",\"model_index_id\",\"model_pk\",\"moderated_item_id\",\"moderated_item_type\",\"moderator_id\",\"most_recent\",\"NAME\",\"namespace\",\"native\",\"NEXT_FIRE_TIME\",\"nfc_path\",\"object\",\"official_flow\",\"ordering\",\"other_cnt\",\"other_flow\",\"other_rate\",\"owner_id\",\"PAGE_URL\",\"parameter_id\",\"parameter_mappings\",\"parameterized_object_id\",\"parameterized_object_type\",\"parameters\",\"parent_id\",\"PASSWORD\",\"password_salt\",\"PAYMENT\",\"pdate\",\"perm_type\",\"perm_value\",\"permission_id\",\"personal_owner_id\",\"pk_ref\",\"PLAN\",\"points_of_interest\",\"position\",\"PREV_FIRE_TIME\",\"preview_display\",\"PRICE\",\"PRIORITY\",\"PRODUCT_ID\",\"profit_rate\",\"progress\",\"ptime\",\"public_uuid\",\"pulse_channel_id\",\"pulse_id\",\"QUANTITY\",\"query\",\"query_execution_id\",\"query_hash\",\"query_source\",\"query_type\",\"question_database_id\",\"question_is_native\",\"question_slug\",\"question_viz_type\",\"RATING\",\"RATING_MAPPED\",\"recipient_external\",\"recipient_type\",\"recipients\",\"refingerprint\",\"refresh_begin\",\"refresh_end\",\"REPEAT_COUNT\",\"REPEAT_INTERVAL\",\"REQUESTS_RECOVERY\",\"reset_token\",\"reset_triggered\",\"response_handle\",\"result_metadata\",\"result_rows\",\"REVIEWER\",\"role\",\"row\",\"running_time\",\"running_time_seconds\",\"SCHED_NAME\",\"SCHED_TIME\",\"schedule\",\"schedule_day\",\"schedule_frame\",\"schedule_hour\",\"schedule_type\",\"schema\",\"schema_name\",\"scope\",\"SEATS\",\"select\",\"semantic_type\",\"session_id\",\"settings\",\"show_in_getting_started\",\"size_x\",\"size_y\",\"skip_if_empty\",\"slug\",\"SOURCE\",\"sso_source\",\"START_TIME\",\"started_at\",\"STATE\",\"state_change_at\",\"status\",\"STR_PROP_1\",\"STR_PROP_2\",\"STR_PROP_3\",\"streamer_flow\",\"SUBTOTAL\",\"table_id\",\"table_name\",\"task\",\"task_details\",\"TAX\",\"template\",\"text\",\"time_matters\",\"TIME_ZONE_ID\",\"timeline_id\",\"TIMES_TRIGGERED\",\"TIMESTAMP\",\"timezone\",\"TITLE\",\"topic\",\"TOTAL\",\"total_flow\",\"TRIAL_CONVERTED\",\"TRIAL_ENDS_AT\",\"TRIGGER_GROUP\",\"TRIGGER_NAME\",\"TRIGGER_STATE\",\"TRIGGER_TYPE\",\"type\",\"update\",\"updated_at\",\"updated_by_id\",\"upload_url\",\"uploads_enabled\",\"uploads_schema_name\",\"uploads_table_prefix\",\"used_in\",\"USER_ID\",\"value\",\"value_ref\",\"values\",\"VENDOR\",\"version\",\"view_count\",\"visibility_type\",\"visualization_settings\",\"width\",\"ZIP\",\"zone_admission_cnt\",\"zone_admission_flow\",\"zone_admission_rate\",\"zone_moment_cnt\",\"zone_moment_flow\",\"zone_moment_rate\",\"zone_superfan_cnt\",\"zone_superfan_flow\",\"zone_superfan_rate\"]',NULL,285,_binary '\0','full',NULL,'2024-06-19 14:18:55.428651'),(74,'2024-06-19 14:18:55.481819','2024-06-19 14:18:55.481819','[null]',NULL,291,_binary '\0','full',NULL,'2024-06-19 14:18:55.481819'),(75,'2024-06-19 14:18:55.530882','2024-06-19 14:18:55.530882','[null]',NULL,277,_binary '\0','full',NULL,'2024-06-19 14:18:55.530882'),(76,'2024-06-19 14:18:55.576163','2024-06-19 14:18:55.576163','[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32]',NULL,293,_binary '\0','full',NULL,'2024-06-19 14:18:55.576163'),(77,'2024-06-19 14:18:55.621597','2024-06-19 14:18:55.621597','[false,true]',NULL,288,_binary '\0','full',NULL,'2024-06-19 14:18:55.621597'),(78,'2024-06-19 14:18:55.663962','2024-06-19 14:18:55.663962','[null,\"type/Author\",\"type/CancelationTimestamp\",\"type/Category\",\"type/City\",\"type/Company\",\"type/Country\",\"type/CreationTimestamp\",\"type/Description\",\"type/Discount\",\"type/Duration\",\"type/Email\",\"type/FK\",\"type/Income\",\"type/JoinTimestamp\",\"type/Latitude\",\"type/Longitude\",\"type/Name\",\"type/PK\",\"type/Quantity\",\"type/Score\",\"type/SerializedJSON\",\"type/Share\",\"type/Source\",\"type/State\",\"type/Title\",\"type/UpdatedTimestamp\",\"type/URL\",\"type/ZipCode\"]',NULL,279,_binary '\0','full',NULL,'2024-06-19 14:18:55.663962'),(79,'2024-06-19 14:18:55.705302','2024-06-19 14:18:55.705302','[null]',NULL,283,_binary '\0','full',NULL,'2024-06-19 14:18:55.705302'),(80,'2024-06-19 14:18:55.748994','2024-06-19 14:18:55.748994','[\"normal\"]',NULL,275,_binary '\0','full',NULL,'2024-06-19 14:18:55.748994'),(81,'2024-06-19 14:18:55.797240','2024-06-19 21:00:05.820578','[\"/\",\"/application/subscription/\",\"/collection/1/\",\"/collection/3/\",\"/collection/namespace/snippets/root/\",\"/collection/root/\"]',NULL,383,_binary '\0','full',NULL,'2024-06-19 14:18:55.797240'),(83,'2024-06-19 14:18:56.028935','2024-07-03 21:00:05.739686','[4,7,8,9,10,11,20,22,25,26,34,44,48,58,61,63,64,65,66,67,68,69,73,74,75,77,78,79,81,82,85,89,92,93,94,95,96,97,99,101,102,104,106,107,109,110,111,113,115,117,118,119,120,121,122,123,132,136,137,138,139,140,141,142,148,151,159,164,283,750,779,898,996,1071,1188,1258,1471,1649,1958,1982,2593,2953,3364,3940,5349,5545,5620,5681,6069,13324,13820,14573,16311,19316,24582,25114,26283,37634,40441,48900,51444,51609,52499,54525,66771,67019,67379,67383,69379,73857,77377,78740,79843,85910,86090,87404,87907,90281,91236,93579,97359,97857,103920,106148,143961,144384,145309,145740,145806,146166,146340,146460,146545,148509,153632,158395,159566,160616,161609,163374,163608,164630,166037,167340,169095,170194,172477,172731,173051,174440,175834,178210,179782,182308,185893,186083,190618,192434,195763,197811,202826,206580,209473,210852,212561,213014,213554,214911,215008,215135,215240,217606,217860,218851,226924,227196,228359,240225,242263,243393,243875,249042,252780,254325,258846,259111,263758,263921,264877,267713,267884,268954,269339,269583,269632,270017,270232,270602,270888,273575,274697,275013,276039,279590,280318,280544,293390,293753,296564,300771,302200,302231,308732,308873,310356,317333,320517,320610,323517,326483,327391,328717,329947,330205,335318,335577,336947,336963,337626,337829,338334,338605,340532,341103,341834,342076,342468,344844,345300,345521,345859,346331,347900,348187,348500,348991,351513,352007,352787,352921,352924,353051,353921,354058,354125,354236,358886]',NULL,873,_binary '\0','full',NULL,'2024-06-19 14:18:56.028935'),(84,'2024-06-19 14:18:56.076966','2024-07-03 21:00:05.772401','[3,4,5,6,7,8,9,10,11,12,14,15,16,17,19,20,21,22,23,24,25,26,27,28,29,30,31,34,35,36,37,38,41,44,48,50,58,59,61,62,63,64,65,66,67,68,69,71,72,73,74,75,76,77,78,79,81,82,83,84,85,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,109,110,111,112,113,115,116,117,118,119,120,121,122,123,124,125,127,131,132,133,134,135,136,137,138,139,140,141,142,144,145,146,147,148,149,150,151,159,245,283,493,501,507,530,750,779,876,897,898,996,1071,1188,1258,1259,1336,1471,1624,1649,1740,1832,1850,1958,1982,2391,2432,2508,2608,2634,2686,2895,2953,2997,3169,3343,3364,3367,3489,3536,3925,3940,4474,4497,4865,5051,5161,5545,5620,5681,6069,6145,6520,6856,7520,7875,8184,9017,9429,10351,11146,11583,12104,12771,12955,13208,13324,13820,13862,15851,15949,15966,16311,16477,18370,18488,19230,19316,20475,21951,22358,23132,23152,24457,24582,25058,25114,25315,25329,26283,31520,31551,31552,33306,34365,35042,35373,36032,37567,37634,37939,38263,38971,39190,40441,42720,46055,48900,49436,51444,51609,51697,52499,52772,54525,55108,57245,57272,60553,61060,66771,66930,66961,67378,67379,67383,68283,68441,68559,69379,70822,71287,76278,76723,77377,79390,79843,80077,82003,82391,82414,84663,85910,87404,87907,89818,90281,90356,91236,91856,92413,93963,97359,97857,99796,100601,103920,105604,106148,143961,144384,145309,145740,145806,146007,146166,146340,146460,146545,147322,148509,153632,158395,159566,161609,162710,162816,163374,163608,163660,164533,164630,166037,167340,169095,172477,172731,173051,173304,174440,175834,176342,178210,179782,180889,182308,184293,185893,190618,192434,192549,193781,194448,195763,197811,199188,202826,204372,205940,206164,206580,208778,209473,210852,212561,213014,213554,214911,215008,215135,215240,217606,217860,218851,220411,226924,227196,228265,228359,229743,230965,239368,240225,242263,243225,243875,249042,252780,254325,254587,258846,259111,259476,263758,263921,264877,267713,267884,268954,269339,269583,269632,270017,270232,270602,270888,273575,274697,275013,275732,276039,276071,276120,276466,279590,280318,280544,293390,293753,296564,300771,301759,302200,308732,308873,310356,312807,317098,317333,320610,322645,323517,326483,327391,328717,329947,330205,330649,335318,335373,335577,335736,337587,337626,337829,338334,338605,341103,341834,342076,342468,342969,344012,344664,344844,345300,345521,345859,346732,347900,348187,348500,348991,349805,351513,352007,352787,352921,352924,353051,353654,353681,353921,354058,354125,354236,355229,356071,356641,356737,357096,357146,357181,357669,358886,360080,360412]',NULL,674,_binary '\0','full',NULL,'2024-06-19 14:18:56.076966'),(85,'2024-06-19 14:18:56.130206','2024-07-03 21:00:05.805119','[\"123\",\"56岁后妈\",\"Ai二桃\",\"bobby\",\"Carol周妍希\",\"Dull-迷人\",\"En1x1\",\"F姐姐呀\",\"Grace\",\"kiko🏹温软净高184\",\"Linda琳儿\",\"luna长腿仙女\",\"Lynn 小静宛\",\"MiKu\",\"MIYA\",\"moon酱\",\"PUPIHAN\",\"Sia不吃鱼\",\"soda野\",\"ss小点点\",\"TATTOO-纹身师桃子\",\"UI\",\"Uu酱\",\"XY\",\"Yogurt\",\"yuki\",\"yu酱睡不醒\",\" 小小西瓜妹～\",\" 比安卡1995\",\"一位很正的阿姨\",\"一口两支冰淇淋\",\"一口奶酱\",\"一只发财的兔头\",\"一只小胡狸\",\"一只辣宝\",\"一妍爱运动\",\"一念星辰\",\"一颗小金桔\",\"七七仙女\",\"不好玩\",\"不安分的媚娘\",\"不爱笑的赛琳\",\"丫丫\",\"丰满秘书日常\",\"么凹猫\",\"乖乖琦\",\"乙醇子\",\"于丰霖\",\"于熙妍wink\",\"于芷晴MINI\",\"人间水蜜桃\",\"什锦金\",\"仙儿\",\"任智桃\",\"伽罗\",\"你的 00\",\"你的蜜桃姨\",\"侯阳靖雯\",\"俏妞qiaoniutT\",\"保守的妻子\",\"健身猫女\",\"健身的桃桃\",\"兔兔很Sss\",\"兔宝妮\",\"兔心心心\",\"八尺夫人\",\"六六小阿姨\",\"兰兰小可爱\",\"兰花仙子\",\"关于原的诗\",\"冰.—\",\"冰冰\",\"冲田花老师\",\"凌凌七DL\",\"凌大小姐\",\"凡妮莎\",\"刘有劲\",\"千日酱\",\"午夜俱乐部\",\"午夜小野马\",\"单打鱼丸\",\"卡戴星\",\"可可西\",\"可心呀\",\"可爱的肉巴\",\"可馨\",\"叶子姐姐\",\"吉宝宝宝\",\"呆呆娜\",\"呆萌橘子酱\",\"周可儿y y y\",\"周姨姨\",\"咩咩男装穿搭\",\"咩咩阿银\",\"哈哈哈哈哈\",\"嘎嘎乱杀\",\"嘟媛\",\"团酱\",\"困鼠\",\"圆溜溜啊圆\",\"壮壮姐姐\",\"壹奈多香\",\"夏天的小雪\",\"夏蓝\",\"多肉大白兔Miko\",\"大R老师\",\"大佬甜Giova\",\"大冰冰超甜\",\"大嫩粉\",\"大宝ootd\",\"大宝贝\",\"大晴暴脾气\",\"大甜甜Bigba\",\"大萱Amy\",\"大静静是个小朋友\",\"大鹅\",\"夹心饼干包\",\"奈奥米Naomi\",\"女刺客\",\"女王的后花园\",\"奶涵大白兔\",\"奶瑶妹妹\",\"奶白鹿神\",\"奶糖\",\"奶雾喵\",\"妤丸\",\"妮好甜🐰\",\"妹妹\",\"姐姐LaLion\",\"姐姐阿竹\",\"姑苏酥酥\",\"娜依灵儿\",\"娜娜zzz\",\"婷妹儿\",\"婷宝小姨\",\"媛媛酱SAYUKI\",\"孟晓艺\",\"学中医的土狗\",\"安妮_yo\",\"安琪啦baby\",\"宋昱欣Hitomi\",\"宝儿茹\",\"宝宝子\",\"宫本湖泊\",\"小依\",\"小厨娘美食记\",\"小喵咪ck\",\"小墨迹\",\"小奈奈yuna\",\"小妖呀\",\"小小兔🐰\",\"小小奶瓶儿\",\"小师妹\",\"小希🍮\",\"小悦悦阿\",\"小文同学\",\"小熊五花肉\",\"小猪佩奇\",\"小玉吃果冻\",\"小王同学\",\"小甜酒子\",\"小羊u\",\"小艾根本吃不饱\",\"小茹茹\",\"小莹喜欢狗\",\"小蒋姐姐\",\"小蕉\",\"小虎\",\"小贝不吃鱼啊\",\"小辣椒sweet\",\"小逗逗\",\"小逗逗蜜桃园\",\"小野\",\"小阮\",\"小雪家\",\"小馋猫\",\"小鹿奶啤\",\"尤妮丝\",\"尽情利世\",\"尾巴酱\",\"山雀Queen\",\"崽崽\",\"左公子666\",\"巴菲音\",\"庆欣有点胖\",\"张有财（必发财版\",\"彤の\",\"徐子蜜\",\"徐樱菡\",\"徐珺大哥\",\"徐莉芝booty\",\"御母\",\"微密秀直播\",\"心动女孩欣欣\",\"快手琳琳小公主\",\"思景MM\",\"性感羊秘\",\"恩沈一点\",\"恩雅\",\"恩馨很甜\",\"悦悦babe\",\"情酱\",\"想想会魔法\",\"慵懒小新\",\"我会炸\",\"我才是岚岚\",\"我是ou\",\"我是你可爱的小猫\",\"抓小乖\",\"拉露恩\",\"搞笑女\",\"撕后刑ss\",\"文茜\",\"文静儿\",\"无情后妈不减脂\",\"无情近视眼\",\"早睡羊崽\",\"易阳\",\"星怡\",\"是姨也是姐\",\"是田不是甜\",\"是秀秀呀\",\"是胖虎啊\",\"晴子兔\",\"智惠姐姐\",\"暴虐兔_\",\"朵茜\",\"杉杉超辣\",\"李嘉欣97\",\"李妙子\",\"李李好甜\",\"李漂亮\",\"李漂亮🦊\",\"李美兮\",\"李音\",\"杨姓奇女子\",\"杨晨晨\",\"杨桃长大了\",\"林汐\",\"林汐韵-yyo\",\"林沐瑶\",\"林瑞贤在这儿\",\"果儿Victoria\",\"枳侑十二\",\"柚柚琪宝\",\"柯宝碎碎念\",\"柳老板_\",\"桃子嘟嘟\",\"桃桃🍑\",\"桃沢樱\",\"桥本环梦\",\"梓琳\",\"梦瑶雪儿\",\"梨涡狼姐\",\"橙月儿\",\"欠揍\",\"欣杨\",\"欣老板\",\"款嫂\",\"毅宝宝\",\"水梨夫人🍐\",\"水蜜桃米米\",\"汐娜\",\"沁羽\",\"沈汝凡\",\"沈真理\",\"泡芙\",\"波雅大大\",\"洋洋不是洋妞\",\"济南摄影遥远\",\"温舒蕾\",\"溪月艺潼\",\"满好互娱\",\"炸弹椅\",\"炸蛋boom\",\"爆炒肉肉啦\",\"爆炸小熊kuku\",\"爱吃蚝仔烙的酱酱\",\"爱吃辣\",\"爱疯13妹\",\"猪儿虫\",\"猪猪君伊\",\"猪猪女侠\",\"猫七baby\",\"玉子烧\",\"玉帛Sama\",\"王兔兔啊\",\"王婉悠\",\"王心心\",\"王璐瑶的猫\",\"王秋宝\",\"王蕊儿\",\"王雨纯\",\"玩酱呀\",\"玫桃泡芙\",\"玫玫\",\"玲儿\",\"琪琪甜圈\",\"琳崽\",\"琳琳\",\"瑶大美呀\",\"甜幼清\",\"甜心宝贝\",\"甜甜央\",\"甜粥\",\"用户127346\",\"用户331338\",\"用户358212\",\"用户376678\",\"用户461378\",\"用户495532\",\"用户591186\",\"用户620457\",\"用户642077\",\"用户754608\",\"用户830707\",\"用户831504\",\"用户850230\",\"用户948665\",\"用户999286\",\"男王\",\"畅畅\",\"病娇咩咩酱\",\"瘦宝\",\"白嫚lsa\",\"白日做梦\",\"皮神\",\"相扑猫\",\"矫矫\",\"禾子\",\"秀人XIUREN\",\"秋不吃鱼\",\"秦梦姐姐\",\"章鱼小童谣\",\"筱洁y\",\"米晨\",\"粉色霸王龙\",\"纪念小小V\",\"纯欲伊\",\"绝佳佳\",\"绝美可砸\",\"绮里嘉ula\",\"羊羊崽\",\"羊老师-\",\"美一人虞\",\"美晓\",\"美羊羊\",\"美邵女Baby\",\"美酱Nami\",\"羽儿\",\"老婆饼\",\"聂傲娇\",\"肉丝很烦恼\",\"肉肉\",\"肉肉菲猪\",\"肖甜\",\"肥蛇饱饱\",\"胖宁\",\"胭脂粉粉\",\"脸红mm\",\"舔舔\",\"艾拉·isla\",\"艾曦_lcey\",\"芥妹帅\",\"芳姨\",\"芷仪G宝\",\"苏古拉\",\"苏妲己\",\"苏老师超棒s\",\"苦茶子\",\"茜怡\",\"草莓不可爱\",\"草莓酱yys\",\"菀菀\",\"菜小葵\",\"菠萝包\",\"菲兮\",\"萌妮妮\",\"董一涵_\",\"蒙蒙子\",\"蔡文姬\",\"薄荷大人\",\"虞美人\",\"蛋炒饭好吃\",\"袍袍\",\"西好运\",\"話話超棒\",\"许雯Amy\",\"豆腐西施\",\"贝小七\",\"贝蒂蔓蔓\",\"账号已注销\",\"赵伊彤\",\"路边的野花\",\"辣肉肉Gina\",\"这里是小树苗苗儿\",\"迷人的五姨太\",\"迷妹啊\",\"酷奇儿\",\"野生小鹿\",\"金喜妹妹\",\"金金金live\",\"钟垚垚\",\"铁粉空间官方\",\"铁锤姐姐\",\"铠爷\",\"银蛇大人\",\"阿尔卑香小狗子\",\"阿拉蕾\",\"阿爽\",\"阿玉🍒\",\"阿色\",\"陈佩奇\",\"陈妮妮\",\"陈迪娅\",\"陈露露\",\"陶77\",\"雅丘小圆\",\"雅茹\",\"雨如\",\"雪墩墩\",\"雪怡\",\"雯宝儿\",\"静静大人\",\"香香de香香\",\"馨子baby\",\"馨馨酱\",\"高级白鹿\",\"高高\",\"鱼神\",\"鱼紫酱\",\"鹅鹅🦢\",\"麻利亚辣\",\"麻辣奶兔\",\"黎允熙baby\",\"黑杜宾\",\"🍒樱桃小狗🍒\"]',NULL,673,_binary '\0','full',NULL,'2024-06-19 14:18:56.130206'),(86,'2024-06-19 14:18:56.176943','2024-07-03 21:00:05.838200','[101850,104731,105786,106516,107004,107874,107917,110208,110493,110875,112932,113360,114410,117198,120854,121348,126513,127346,127781,128503,130527,138798,140913,141985,143257,145137,145557,148857,151560,152349,155254,155550,156665,158127,158790,163876,167171,167525,169057,171759,172005,172653,173698,178975,180549,181837,184057,184127,189826,190254,190912,191935,198633,199501,200557,203069,205316,206323,209558,209894,214416,219189,219643,221455,222677,222935,224846,228323,232585,232882,233583,242331,243020,243721,244133,246577,247733,250082,252850,253020,253564,254089,257328,257859,261190,262466,262712,267348,269587,270152,270176,270601,271650,272856,274902,275172,275362,278478,278535,280869,286126,287546,293350,300581,300895,302467,306344,309225,309344,310077,310196,312090,313416,315751,317448,318127,319272,320658,321084,323167,324138,324934,325087,325431,326449,329143,330079,331338,332667,333372,333666,334959,336623,336894,338372,339518,344527,345738,346812,347192,348715,350389,351165,351936,353184,353794,354499,354674,355252,358212,360350,363364,365443,366486,371511,376678,377132,381955,383335,384037,388045,390191,390792,391262,391826,392375,397256,397673,398180,400262,400642,401588,401732,404534,406354,407598,408505,408888,414387,414839,418213,420043,420216,424856,425756,428611,433160,433999,439858,442209,442668,443213,443606,444367,446085,450855,451014,458408,458901,461378,461943,462261,463700,465820,468226,469267,470004,472759,473434,473995,476219,481823,484398,486245,490060,492175,492987,495532,499300,500691,502570,506578,513210,515701,518964,520094,523813,527240,527300,532352,534766,537718,538214,540639,543571,543955,546653,549166,550071,554518,556326,556936,556939,562693,562768,565089,566149,567851,571068,574059,579626,580435,581343,581784,587943,588239,588258,588727,590846,591186,594639,596500,601309,602375,603792,607576,610397,612442,615705,616288,617336,618827,620457,621957,622587,623144,625337,626036,630261,631165,632804,635501,636078,636086,641394,642077,644864,646340,647561,648836,649412,650778,651851,652745,656916,658274,659544,659588,660452,660516,668819,673951,674687,675205,676774,677337,678107,680442,680541,688576,688704,688860,689989,690991,694226,694867,695244,701601,703267,704992,710566,714087,717354,720445,721139,724471,724793,725246,726144,727220,727286,728206,728667,730047,730921,736360,737657,743139,744706,746079,746123,746277,748245,750695,752956,754587,754608,755511,758780,760752,761133,762345,763546,763552,763926,765913,767871,768620,771817,773576,774789,776712,779846,781018,781789,781984,784124,792296,793009,798116,800110,800436,800547,801086,802354,803677,811053,815196,817341,817403,819074,822523,826968,829329,829549,830399,830707,831504,832269,834923,835426,840053,841976,842498,847901,849493,850230,850633,851231,856151,860871,861283,861732,862194,863698,867784,869711,873354,875112,877216,881121,890131,892166,893450,894664,897649,898644,902778,902883,904656,906134,909724,918811,919263,923715,924346,926263,928000,928612,931544,932543,934640,936467,938978,940934,945338,945839,947097,948665,948961,951830,953814,954933,955728,956095,958821,959236,963187,964464,968453,973218,973788,983565,987370,993443,993953,999286]',NULL,672,_binary '\0','full',NULL,'2024-06-19 14:18:56.176943'),(87,'2024-06-19 14:18:56.263592','2024-06-19 14:18:56.263592','[\"0 0 */12 * * ? *\",\"0 0 0 * * ? *\",\"0 0 12 * * ? *\",\"0 0 2 ? * 7\",\"0 0 21 * * ? *\",\"0 15 6,18 * * ? *\",\"0 41 5 * * ? *\",\"0 42 0/4 1/1 * ? *\",\"0 45 * * * ? *\"]',NULL,455,_binary '\0','full',NULL,'2024-06-19 14:18:56.263592'),(88,'2024-06-19 14:18:56.298931','2024-06-19 14:18:56.298931','[\"GMT\"]',NULL,457,_binary '\0','full',NULL,'2024-06-19 14:18:56.298931'),(89,'2024-06-19 14:18:56.387998','2024-06-19 14:18:56.387998','[null]',NULL,146,_binary '\0','full',NULL,'2024-06-19 14:18:56.387998'),(90,'2024-06-19 14:18:56.432982','2024-06-19 14:18:56.432982','[1]',NULL,842,_binary '\0','full',NULL,'2024-06-19 14:18:56.432982'),(91,'2024-06-19 14:18:56.469408','2024-06-19 14:18:56.469408','[1,2]',NULL,837,_binary '\0','full',NULL,'2024-06-19 14:18:56.469408'),(92,'2024-06-19 14:18:56.509682','2024-06-19 14:18:56.509682','[null,\"A log of executed queries, used for calculating historic execution times, auditing, and other purposes.\",\"A readwrite query type of action\",\"A table to store database and table permissions\",\"An action is something you can do, such as run a readwrite query\",\"An action with dynamic parameters based on the underlying model\",\"An API Key\",\"An http api call type of action\",\"Cache Configuration\",\"Cached results of queries are stored here when using the DB-based query cache.\",\"Collections are an optional way to organize Cards and handle permissions for them.\",\"Confirmed payments from Piespace’s customers. Most accounts pay for their pie subscription on a monthly basis.\",\"Confirmed Sample Company orders for a product, from a user.\",\"Events table\",\"Fields used by a card\'s query\",\"Includes a catalog of all the products ever sold by the famed Sample Company.\",\"Information (such as average execution time) for different queries that have been previously ran.\",\"Information on customer accounts registered with Piespace. Each account represents a new organization signing up for on-demand pies.\",\"Information on the user accounts registered with Sample Company.\",\"Join table connecting cards to entities (dashboards, other cards, etc.) that use the values generated by the card for filter values\",\"Join table connecting dashboard to dashboardcards\",\"Keeps track of various logins for different users and additional info such as location and device\",\"Migrate to cloud directly from Metabase\",\"Piespace does some anonymous analytics tracking on how users interact with their platform. They’ve only had time to implement a few events, but you know how it is. Pies come first.\",\"Presence of a row here indicates a given User has favorited a given Dashboard.\",\"Query snippets (raw text) to be substituted in native queries\",\"Records that a given Card (Question) should automatically replace a given Table as query source for a given a Perms Group.\",\"Reviews (from moderators) for a given question/dashboard (BUCM)\",\"Reviews that Sample Company customers have left on our products.\",\"Storage for managed secrets (passwords, binary data, etc.)\",\"Stores references to alternate views of existing fields, such as remapping an integer to a description, like an enum\",\"Table for holding connection impersonation policies\",\"Table for user and role privileges by table\",\"Table holding bookmarks on cards\",\"Table holding bookmarks on collections\",\"Table holding bookmarks on dashboards\",\"Table holding information about persisted models\",\"Table holding last set value of a parameter per user\",\"Table holding ordering information for various bookmark tables\",\"Timeline table to organize events\",\"Timing and metadata info about background/quartz processes\",\"Used for Quartz scheduler.\",\"Used to keep track of changes made to collections.\",\"Used to keep track of changes made to general permissions.\",\"Used to keep track of changes made to permissions.\",\"Used to keep track of the values indexed in a model\",\"Used to keep track of which models have indexed columns.\",\"Used to store application events for auditing use cases\",\"Used to store field usage during query execution\",\"Used to store recently viewed objects for each user\",\"VIEW\",\"With each order of pies sent out, Piespace includes a place for customers to submit feedback and review their order.\"]',NULL,840,_binary '\0','full',NULL,'2024-06-19 14:18:56.509682'),(93,'2024-06-19 14:18:56.562903','2024-06-19 14:18:56.562903','[\"Accounts\",\"Action\",\"Analytic Events\",\"Api Key\",\"Application Permissions Revision\",\"Audit Log\",\"Bookmark Ordering\",\"Cache Config\",\"Card Bookmark\",\"Card Label\",\"Cloud Migration\",\"Collection\",\"Collection Bookmark\",\"Collection Permission Graph Revision\",\"Connection Impersonations\",\"Core Session\",\"Core User\",\"Dashboard Bookmark\",\"Dashboard Favorite\",\"Dashboard Tab\",\"Dashboardcard Series\",\"Data Permissions\",\"Databasechangelog\",\"Databasechangeloglock\",\"Dependency\",\"Dimension\",\"Feedback\",\"Field Usage\",\"Http Action\",\"Implicit Action\",\"Invoices\",\"Label\",\"Login History\",\"Metabase Database\",\"Metabase Field\",\"Metabase Fieldvalues\",\"Metabase Table\",\"Metric\",\"Metric Important Field\",\"Model Index\",\"Model Index Value\",\"Moderation Review\",\"Native Query Snippet\",\"Orders\",\"Parameter Card\",\"People\",\"Permissions\",\"Permissions Group\",\"Permissions Group Membership\",\"Permissions Revision\",\"Persisted Info\",\"Products\",\"Pulse\",\"Pulse Card\",\"Pulse Channel\",\"Pulse Channel Recipient\",\"Qrtz Blob Triggers\",\"Qrtz Calendars\",\"Qrtz Cron Triggers\",\"Qrtz Fired Triggers\",\"Qrtz Job Details\",\"Qrtz Locks\",\"Qrtz Paused Trigger Grps\",\"Qrtz Scheduler State\",\"Qrtz Simple Triggers\",\"Qrtz Simprop Triggers\",\"Qrtz Triggers\",\"Query\",\"Query Action\",\"Query Cache\",\"Query Execution\",\"Query Field\",\"Recent Views\",\"Report Card\",\"Report Cardfavorite\",\"Report Dashboard\",\"Report Dashboardcard\",\"Reviews\",\"Revision\",\"Sandboxes\",\"Secret\",\"Segment\",\"Setting\",\"Streamer\",\"Table Privileges\",\"Task History\",\"Timeline\",\"Timeline Event\",\"User Parameter Value\",\"V Alerts\",\"V Audit Log\",\"V Content\",\"V Dashboardcard\",\"V Databases\",\"V Fields\",\"V Group Members\",\"V Query Log\",\"V Subscriptions\",\"V Tables\",\"V Tasks\",\"V Users\",\"V View Log\",\"Vas Cur Streamer Income\",\"Vas Day Detail\",\"Vas Day Flow\",\"Vas Yoy Flow\",\"View Log\"]',NULL,845,_binary '\0','full',NULL,'2024-06-19 14:18:56.562903'),(94,'2024-06-19 14:18:56.601840','2024-06-19 14:18:56.601840','[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107]',NULL,844,_binary '\0','full',NULL,'2024-06-19 14:18:56.601840'),(95,'2024-06-19 14:18:56.640544','2024-06-19 14:18:56.640544','[\"table_1\",\"table_10\",\"table_100\",\"table_101\",\"table_102\",\"table_103\",\"table_104\",\"table_105\",\"table_106\",\"table_107\",\"table_11\",\"table_12\",\"table_13\",\"table_14\",\"table_15\",\"table_16\",\"table_17\",\"table_18\",\"table_19\",\"table_2\",\"table_20\",\"table_21\",\"table_22\",\"table_23\",\"table_24\",\"table_25\",\"table_26\",\"table_27\",\"table_28\",\"table_29\",\"table_3\",\"table_30\",\"table_31\",\"table_32\",\"table_33\",\"table_34\",\"table_35\",\"table_36\",\"table_37\",\"table_38\",\"table_39\",\"table_4\",\"table_40\",\"table_41\",\"table_42\",\"table_43\",\"table_44\",\"table_45\",\"table_46\",\"table_47\",\"table_48\",\"table_49\",\"table_5\",\"table_50\",\"table_51\",\"table_52\",\"table_53\",\"table_54\",\"table_55\",\"table_56\",\"table_57\",\"table_58\",\"table_59\",\"table_6\",\"table_60\",\"table_61\",\"table_62\",\"table_63\",\"table_64\",\"table_65\",\"table_66\",\"table_67\",\"table_68\",\"table_69\",\"table_7\",\"table_70\",\"table_71\",\"table_72\",\"table_73\",\"table_74\",\"table_75\",\"table_76\",\"table_77\",\"table_78\",\"table_79\",\"table_8\",\"table_80\",\"table_81\",\"table_82\",\"table_83\",\"table_84\",\"table_85\",\"table_86\",\"table_87\",\"table_88\",\"table_89\",\"table_9\",\"table_90\",\"table_91\",\"table_92\",\"table_93\",\"table_94\",\"table_95\",\"table_96\",\"table_97\",\"table_98\",\"table_99\"]',NULL,838,_binary '\0','full',NULL,'2024-06-19 14:18:56.640544'),(96,'2024-06-19 14:18:56.701115','2024-06-19 14:18:56.701115','[0]',NULL,841,_binary '\0','full',NULL,'2024-06-19 14:18:56.701115'),(97,'2024-06-19 14:18:56.740289','2024-06-19 14:18:56.740289','[\"ACCOUNTS\",\"action\",\"ANALYTIC_EVENTS\",\"api_key\",\"application_permissions_revision\",\"audit_log\",\"bookmark_ordering\",\"cache_config\",\"card_bookmark\",\"card_label\",\"cloud_migration\",\"collection\",\"collection_bookmark\",\"collection_permission_graph_revision\",\"connection_impersonations\",\"core_session\",\"core_user\",\"dashboard_bookmark\",\"dashboard_favorite\",\"dashboard_tab\",\"dashboardcard_series\",\"data_permissions\",\"databasechangelog\",\"databasechangeloglock\",\"dependency\",\"dimension\",\"FEEDBACK\",\"field_usage\",\"http_action\",\"implicit_action\",\"INVOICES\",\"label\",\"login_history\",\"metabase_database\",\"metabase_field\",\"metabase_fieldvalues\",\"metabase_table\",\"metric\",\"metric_important_field\",\"model_index\",\"model_index_value\",\"moderation_review\",\"native_query_snippet\",\"ORDERS\",\"parameter_card\",\"PEOPLE\",\"permissions\",\"permissions_group\",\"permissions_group_membership\",\"permissions_revision\",\"persisted_info\",\"PRODUCTS\",\"pulse\",\"pulse_card\",\"pulse_channel\",\"pulse_channel_recipient\",\"qrtz_blob_triggers\",\"qrtz_calendars\",\"qrtz_cron_triggers\",\"qrtz_fired_triggers\",\"qrtz_job_details\",\"qrtz_locks\",\"qrtz_paused_trigger_grps\",\"qrtz_scheduler_state\",\"qrtz_simple_triggers\",\"qrtz_simprop_triggers\",\"qrtz_triggers\",\"query\",\"query_action\",\"query_cache\",\"query_execution\",\"query_field\",\"recent_views\",\"report_card\",\"report_cardfavorite\",\"report_dashboard\",\"report_dashboardcard\",\"REVIEWS\",\"revision\",\"sandboxes\",\"secret\",\"segment\",\"setting\",\"streamer\",\"table_privileges\",\"task_history\",\"timeline\",\"timeline_event\",\"user_parameter_value\",\"v_alerts\",\"v_audit_log\",\"v_content\",\"v_dashboardcard\",\"v_databases\",\"v_fields\",\"v_group_members\",\"v_query_log\",\"v_subscriptions\",\"v_tables\",\"v_tasks\",\"v_users\",\"v_view_log\",\"vas_cur_streamer_income\",\"vas_day_detail\",\"vas_day_flow\",\"vas_yoy_flow\",\"view_log\"]',NULL,836,_binary '\0','full',NULL,'2024-06-19 14:18:56.740289'),(98,'2024-06-19 14:18:56.783754','2024-06-19 14:18:56.783754','[\"schema\"]',NULL,843,_binary '\0','full',NULL,'2024-06-19 14:18:56.783754'),(99,'2024-06-19 14:18:56.831277','2024-06-19 14:18:56.831277','[1]',NULL,773,_binary '\0','full',NULL,'2024-06-19 14:18:56.831277'),(100,'2024-06-19 14:18:56.870664','2024-06-19 14:18:56.870664','[\"0 0 17 * * ? *\",\"0 0 21 * * ? *\"]',NULL,775,_binary '\0','full',NULL,'2024-06-19 14:18:56.870664'),(101,'2024-06-19 14:18:56.927650','2024-06-19 14:18:56.927650','[null]',NULL,772,_binary '\0','full',NULL,'2024-06-19 14:18:56.927650'),(102,'2024-06-19 14:18:56.978746','2024-06-19 14:18:56.978746','[null,13371339]',NULL,771,_binary '\0','full',NULL,'2024-06-19 14:18:56.978746'),(103,'2024-06-19 14:18:57.023062','2024-06-19 14:18:57.023062','[\"h2\",\"mysql\"]',NULL,785,_binary '\0','full',NULL,'2024-06-19 14:18:57.023062'),(104,'2024-06-19 14:18:57.062208','2024-06-19 14:18:57.062208','[\"{\\\"flavor\\\":\\\"H2\\\",\\\"version\\\":\\\"2.1.214 (2022-06-13)\\\",\\\"semantic-version\\\":[2,1]}\",\"{\\\"flavor\\\":\\\"MySQL\\\",\\\"version\\\":\\\"8.2.0\\\",\\\"semantic-version\\\":[8,2]}\"]',NULL,783,_binary '\0','full',NULL,'2024-06-19 14:18:57.062208'),(105,'2024-06-19 14:18:57.100128','2024-06-19 14:18:57.100128','[null,\"Some example data for you to play around with.\"]',NULL,776,_binary '\0','full',NULL,'2024-06-19 14:18:57.100128'),(106,'2024-06-19 14:18:57.141487','2024-06-19 14:18:57.141487','[1,2]',NULL,778,_binary '\0','full',NULL,'2024-06-19 14:18:57.141487'),(107,'2024-06-19 14:18:57.179273','2024-06-19 14:18:57.179273','[\"database_1\",\"database_2\"]',NULL,781,_binary '\0','full',NULL,'2024-06-19 14:18:57.179273'),(108,'2024-06-19 14:18:57.217626','2024-06-19 14:18:57.217626','[0]',NULL,782,_binary '\0','full',NULL,'2024-06-19 14:18:57.217626'),(109,'2024-06-19 14:18:57.254801','2024-06-19 14:18:57.254801','[\"0 26 * * * ? *\",\"0 45 * * * ? *\"]',NULL,774,_binary '\0','full',NULL,'2024-06-19 14:18:57.254801'),(110,'2024-06-19 14:18:57.293507','2024-06-19 14:18:57.293507','[\"metabase_bi\",\"Sample Database\"]',NULL,784,_binary '\0','full',NULL,'2024-06-19 14:18:57.293507'),(111,'2024-06-19 14:18:57.334367','2024-06-19 14:18:57.334367','[\"+08:00\",\"GMT\"]',NULL,779,_binary '\0','full',NULL,'2024-06-19 14:18:57.334367'),(112,'2024-06-19 14:18:57.446551','2024-06-19 14:18:57.446551','[false]',NULL,613,_binary '\0','full',NULL,'2024-06-19 14:18:57.446551'),(113,'2024-06-19 14:18:57.481062','2024-06-19 14:18:57.481062','[true]',NULL,603,_binary '\0','full',NULL,'2024-06-19 14:18:57.481062'),(114,'2024-06-19 14:18:57.516191','2024-06-19 14:18:57.516191','[null]',NULL,604,_binary '\0','full',NULL,'2024-06-19 14:18:57.516191'),(115,'2024-06-19 14:18:57.562755','2024-06-19 14:18:57.562755','[null]',NULL,594,_binary '\0','full',NULL,'2024-06-19 14:18:57.562755'),(116,'2024-06-19 14:18:57.600064','2024-06-19 21:00:07.882719','[null,2]',NULL,615,_binary '\0','full',NULL,'2024-06-19 14:18:57.600064'),(117,'2024-06-19 14:18:57.643613','2024-06-19 21:00:07.919806','[null,\"Quickly take an overview of an e-commerce reseller business and dive into separate tabs that focus on top selling products and demographic insights. Each vendor can log in as a tenant and see their own data sandboxed from all the others.\"]',NULL,611,_binary '\0','full',NULL,'2024-06-19 14:18:57.643613'),(118,'2024-06-19 14:18:57.684643','2024-06-19 14:18:57.684643','[null]',NULL,610,_binary '\0','full',NULL,'2024-06-19 14:18:57.684643'),(119,'2024-06-19 14:18:57.731754','2024-06-19 14:18:57.731754','[false]',NULL,609,_binary '\0','full',NULL,'2024-06-19 14:18:57.731754'),(120,'2024-06-19 14:18:57.776445','2024-06-19 21:00:08.007833','[\"DlK2jXoIHPXyVkEuo6Uy6\",\"sMsdTxTSKoA1lP8ifp3iw\"]',NULL,596,_binary '\0','full',NULL,'2024-06-19 14:18:57.776445'),(121,'2024-06-19 14:18:57.857086','2024-06-19 21:00:08.042629','[\"E-commerce insights\",\"ironfan-增值\"]',NULL,593,_binary '\0','full',NULL,'2024-06-19 14:18:57.857086'),(122,'2024-06-19 14:18:57.902608','2024-06-19 21:00:08.074046','[\"[]\",\"[{\\\"id\\\":\\\"fc2cd1be\\\",\\\"isMultiSelect\\\":false,\\\"name\\\":\\\"Vendor\\\",\\\"sectionId\\\":\\\"string\\\",\\\"slug\\\":\\\"vendor\\\",\\\"type\\\":\\\"string/=\\\"},{\\\"id\\\":\\\"afa56954\\\",\\\"name\\\":\\\"Date Range\\\",\\\"sectionId\\\":\\\"date\\\",\\\"slug\\\":\\\"date_range\\\",\\\"type\\\":\\\"date/range\\\"},{\\\"id\\\":\\\"5eeec658\\\",\\\"name\\\":\\\"Category\\\",\\\"sectionId\\\":\\\"string\\\",\\\"slug\\\":\\\"category\\\",\\\"type\\\":\\\"string/=\\\",\\\"values_query_type\\\":\\\"list\\\"},{\\\"id\\\":\\\"512c560a\\\",\\\"name\\\":\\\"Location\\\",\\\"sectionId\\\":\\\"location\\\",\\\"slug\\\":\\\"location\\\",\\\"type\\\":\\\"string/=\\\",\\\"values_query_type\\\":\\\"search\\\"}]\"]',NULL,602,_binary '\0','full',NULL,'2024-06-19 14:18:57.902608'),(123,'2024-06-19 14:18:57.945417','2024-06-19 14:18:57.945417','[null]',NULL,607,_binary '\0','full',NULL,'2024-06-19 14:18:57.945417'),(124,'2024-06-19 14:18:57.991995','2024-06-19 14:18:57.991995','[null]',NULL,599,_binary '\0','full',NULL,'2024-06-19 14:18:57.991995'),(125,'2024-06-19 14:18:58.029653','2024-06-19 14:18:58.029653','[null]',NULL,612,_binary '\0','full',NULL,'2024-06-19 14:18:58.029653'),(126,'2024-06-19 14:18:58.071864','2024-06-19 14:18:58.071864','[false]',NULL,598,_binary '\0','full',NULL,'2024-06-19 14:18:58.071864'),(127,'2024-06-19 14:18:58.126307','2024-07-03 21:00:07.265942','[0,2443]',NULL,601,_binary '\0','full',NULL,'2024-06-19 14:18:58.126307'),(128,'2024-06-19 14:18:58.172774','2024-06-19 14:18:58.172774','[\"full\"]',NULL,600,_binary '\0','full',NULL,'2024-06-19 14:18:58.172774'),(129,'2024-06-19 14:18:58.278648','2024-06-19 14:18:58.278648','[null]',NULL,517,_binary '\0','full',NULL,'2024-06-19 14:18:58.278648'),(130,'2024-06-19 14:18:58.322001','2024-06-19 14:18:58.322001','[null,\"sync-and-analyze Database 2\",\"update-field-values Database 2\"]',NULL,524,_binary '\0','full',NULL,'2024-06-19 14:18:58.322001'),(131,'2024-06-19 14:18:58.370591','2024-06-19 14:18:58.370591','[0]',NULL,509,_binary '\0','full',NULL,'2024-06-19 14:18:58.370591'),(132,'2024-06-19 14:18:58.430977','2024-06-19 14:18:58.430977','[0,2]',NULL,519,_binary '\0','full',NULL,'2024-06-19 14:18:58.430977'),(133,'2024-06-19 14:18:58.487260','2024-07-03 21:00:07.436901','[1720043100000,1720051200000,1720053720000,1720071660000,1720073700000,1720094400000,1720126800000,1720231200000]',NULL,520,_binary '\0','full',NULL,'2024-06-19 14:18:58.487260'),(134,'2024-06-19 14:18:58.531157','2024-07-03 21:00:07.465935','[1719626400000,1719964800000,1719985260000,1720008000000,1720030500000,1720039320000,1720039500000,1720040400000]',NULL,511,_binary '\0','full',NULL,'2024-06-19 14:18:58.531157'),(135,'2024-06-19 14:18:58.583683','2024-06-19 14:18:58.583683','[5]',NULL,514,_binary '\0','full',NULL,'2024-06-19 14:18:58.583683'),(136,'2024-06-19 14:18:58.624099','2024-06-19 14:18:58.624099','[1718806416000,1718806417000,1718806695000]',NULL,523,_binary '\0','full',NULL,'2024-06-19 14:18:58.624099'),(137,'2024-06-19 14:18:58.663883','2024-06-19 21:00:08.550383','[\"BLOCKED\",\"WAITING\"]',NULL,521,_binary '\0','full',NULL,'2024-06-19 14:18:58.663883'),(138,'2024-06-19 14:18:58.702799','2024-06-19 14:18:58.702799','[\"CRON\"]',NULL,513,_binary '\0','full',NULL,'2024-06-19 14:18:58.702799'),(139,'2024-06-19 14:18:58.760131','2024-06-19 14:18:58.760131','[1]',NULL,790,_binary '\0','full',NULL,'2024-06-19 14:18:58.760131'),(140,'2024-06-19 14:18:58.802829','2024-06-19 14:18:58.802829','[\"type/*\",\"type/BigInteger\",\"type/Boolean\",\"type/Date\",\"type/DateTime\",\"type/DateTimeWithLocalTZ\",\"type/Decimal\",\"type/Float\",\"type/Integer\",\"type/Text\"]',NULL,797,_binary '\0','full',NULL,'2024-06-19 14:18:58.802829'),(141,'2024-06-19 14:18:58.856398','2024-06-19 14:18:58.856398','[null,\"A database ID, for DB and table-level permissions\",\"A JSON map with metadata about the event\",\"A JSON object describing the flavor and version of the DBMS.\",\"A program to take an api response and transform to an appropriate response for emitters\",\"A program to take an api response to determine if an error occurred\",\"A schema name, for table-level permissions\",\"A strategy to coerce the base_type into the effective_type.\",\"A table ID\",\"A template that defines method,url,body,headers required to make an api call\",\"A unique identifier given to each user.\",\"A unique internal identifier for the review. Should not be used externally.\",\"An invalidation time that can supersede cache_config.invalidated_at\",\"Average execution time for the query, round to nearest number of milliseconds. This is updated as a rolling average.\",\"Cache hit on query execution\",\"Condition (i.e. \\\"rows\\\" or \\\"goal\\\") used as a guard for alerts\",\"Cookie-based unique identifier for the device/browser the user logged in from.\",\"creation time\",\"Current state of the migration: init, setup, dump, upload, done, error, cancelled\",\"Directory-structure path of ancestor Collections. e.g. \\\"/1/2/\\\" means our Parent is Collection 2, and their parent is Collection 1.\",\"Discount amount.\",\"Displayed name of the tab\",\"either a document or question ID; the item that needs review\",\"Either internal for a user defined remapping or external for a foreign key based remapping\",\"Error message from persisting if applicable\",\"filter\'s operator that applied to the field\",\"For a goal condition, alert when above the goal\",\"Granular cache TTL for specific dashboard.\",\"Granular cache TTL for specific database.\",\"Has this pulse been archived?\",\"Hash key for a cached fieldvalues\",\"Hash of normalized query, calculated in middleware.cache\",\"Hash of the query persisted\",\"ID of the admin who added the database\",\"ID of the Card bookmarked by the user\",\"ID of the card generating the values\",\"ID of the Card model persisted\",\"ID of the collection containing the timeline\",\"ID of the Dashboard bookmarked by the user\",\"ID of the Dashboard favorited by the User.\",\"ID of the Dashboard if this Pulse is a Dashboard Subscription.\",\"ID of the database associated to the persisted card\",\"ID of the database this connection impersonation policy affects\",\"ID of the database this query was ran against.\",\"ID of the entity consuming the values\",\"ID of the field\",\"ID of the field this dimension row applies to\",\"id of the item being bookmarked (Card, Collection, Dashboard, ...) no FK, so may no longer exist\",\"ID of the permissions group this connection impersonation policy affects\",\"ID of the Permissions Group this policy affects.\",\"ID of the Session created by this login if one is currently active. NULL if Session is no longer active.\",\"ID of the Snippet Folder (Collection) this Snippet is in, if any\",\"ID of the Table that should get automatically replaced as query source for the Permissions Group.\",\"ID of the timeline containing the event\",\"ID of the User that logged in.\",\"ID of the User who bookmarked the Card\",\"ID of the User who bookmarked the Collection\",\"ID of the User who bookmarked the Dashboard\",\"ID of the user who created the event\",\"ID of the user who created the timeline\",\"ID of the user who did the review\",\"ID of the User who favorited the Dashboard.\",\"ID of the User who has set the parameter value\",\"ID of the User who ordered bookmarks\",\"If set, this Collection is a personal Collection, for exclusive use of the User with this ID.\",\"If this Pulse is a Dashboard subscription, the ID of the DashboardCard that corresponds to this PulseCard.\",\"Is the collection part of the sample content?\",\"Is the Field referenced directly or via a wildcard\",\"Is this Card allowed to be embedded in different websites (using a signed JWT)?\",\"Is this Dashboard allowed to be embedded in different websites (using a signed JWT)?\",\"Is this Dashboard archived (effectively treated as deleted?)\",\"JSON object that captures the state of the table when we persisted\",\"Keeps a running count of card views\",\"Keeps a running count of dashboard views\",\"List of parameter associated to a card\",\"Matching ID in Cloud for this migration\",\"Metabase version used to create the card.\",\"Metabase version used to create the revision.\",\"most recent modification time\",\"Name of the event\",\"Name of the query snippet\",\"Name of the table persisted\",\"Name of the task\",\"Name of the timeline\",\"NanoID tag for each user\",\"Nested field column paths, flattened\",\"Nullable column to incidate collection\'s authority level. Initially values are \\\"official\\\" and nil.\",\"Number between 0 to 100 representing progress as a percentage\",\"Number of products bought.\",\"Number of rows in the query results.\",\"Only used with external type remappings. Indicates which field on the FK related table to use for display\",\"Optional description of the timeline\",\"Optional ID of Collection this Card belongs to.\",\"Optional ID of Collection this Dashboard belongs to.\",\"Optional markdown description of the event\",\"Optional pinned position for this item in its Collection. NULL means item is not pinned.\",\"Options ID of Collection this Pulse belongs to.\",\"order of bookmark for user\",\"Part of composite primary key for secret; this is the uniquely generted ID column\",\"Part of composite primary key for secret; this is the version column\",\"Persisted table state (creating, persisted, refreshing, deleted)\",\"PK\",\"Position of the tab with respect to others tabs in dashboard\",\"Preferred ISO locale (language/country) code, e.g \\\"en\\\" or \\\"en-US\\\", for this User. Overrides site default.\",\"Random NanoID tag for unique identity.\",\"referenced card\",\"referenced field\",\"referenced query execution\",\"Role name. NULL indicates the privileges are the current user\'s\",\"Serialized JSON containing Database-local Settings for this Database\",\"Serialized JSON containing User-local Settings for this User\",\"Serialized JSON of the label field ref.\",\"Serialized JSON of the primary key field ref.\",\"Short description used as the display name of this new column\",\"Short string specifying how this query was executed, e.g. in a Dashboard or Pulse.\",\"Skip a scheduled Pulse if none of its questions have any results\",\"Slug of the card which will form the persisted table name\",\"String indicating whether a database has completed its initial sync and is ready to use\",\"String indicating whether a table has completed its initial sync and is ready to use\",\"String to indicate the SSO backend the user is from\",\"Table ID\",\"tag for most recent review\",\"temporal unit options of the breakout\",\"the aggregation function that field applied to\",\"The associated action\",\"The average rating users have given the product. This ranges from 1 - 5\",\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\",\"The city of the account’s billing address\",\"The contact email for the account.\",\"The context of the view, can be collection, question, or dashboard. Only for cards.\",\"The cron schedule for when value syncing should happen.\",\"The cron schedule string for when this database should undergo the metadata sync process (and analysis for new fields).\",\"The dashboard that a tab is on\",\"The date and time an order was submitted.\",\"The date of birth of the user\",\"The date the product was added to our catalog.\",\"The date the user record was created. Also referred to as the user’s \\\"join date\\\"\",\"The day and time a review was written by a user.\",\"The description of the action\",\"The effective type of the field after any coercions.\",\"The error message if the status is error.\",\"The estimated row count\",\"The first 7 characters of the unhashed key\",\"The hash of the query dictionary. (This is a 256-bit SHA3 hash of the query dict.)\",\"The hash of the query dictionary. This is a 256-bit SHA3 hash of the query.\",\"The hashed API key\",\"The ID of the action associated with this query execution, if any.\",\"The ID of the API Key itself\",\"The ID of the associated permission group\",\"The ID of the Card (Question) associated with this query execution, if any.\",\"The ID of the corresponding permissions path for this sandbox\",\"The ID of the Dashboard associated with this query execution, if any.\",\"The ID of the indexed model.\",\"The ID of the model that was viewed\",\"The ID of the model this event applies to, if applicable\",\"The ID of the permission\",\"The ID of the Pulse associated with this query execution, if any.\",\"The ID of the user that last updated this API key\",\"The ID of the User who first publically shared this Action.\",\"The ID of the User who first publically shared this Card.\",\"The ID of the User who first publically shared this Dashboard.\",\"The id of the user who made this order. Note that in some cases where an order was created on behalf of a customer who phoned the order in, this might be the employee who handled the request.\",\"The ID of the User who triggered this query execution, if any.\",\"The international article number. A 13 digit number uniquely identifying the product.\",\"The kind of implicit action create/update/delete\",\"The kind of secret this record represents; the value is interpreted as a Clojure keyword with a hierarchy. Ex: \'bytes\' means generic binary data, \'jks-keystore\' extends \'bytes\' but has a specific meaning.\",\"The label to display identifying the indexed value.\",\"The list price of the product. Note that this is not always the price the product sold for due to discounts, promotions, etc.\",\"The maximum time, in seconds, to return cached results for this Card rather than running a new query.\",\"The name of the model that was viewed\",\"The name of the model this event applies to (e.g. Card, Dashboard), if applicable\",\"The name of the product as it should be displayed to customers.\",\"The name of the user who owns an account\",\"The name of this secret record.\",\"The namespace (hierachy) this Collection belongs to. NULL means the Collection is in the default namespace.\",\"The numbin option of breakout\",\"The numerical product number. Only used internally. All external communication should use the title or EAN.\",\"The parameter ID\",\"The position this Dashboard should appear in the Dashboards list, lower-numbered positions appearing before higher numbered ones.\",\"The postal code of the account’s billing address\",\"The prefix for upload table names\",\"The primary key of the indexed value\",\"The product ID. This is an internal identifier for the product, NOT the SKU.\",\"The product the review was for\",\"The rating (on a scale of 1-5) the user left.\",\"The raw, pre-tax cost of the order. Note that this might be different in the future from the product price due to promotions, credits, etc.\",\"The referenced tab id that dashcard is on, it\'s nullable for dashboard with no tab\",\"The related action\",\"The review the user left. Limited to 2000 characters.\",\"The saved parameter mappings for this action\",\"The saved parameters for this action\",\"The schema name for uploads\",\"The scope of the API key, if applicable\",\"The source of secret record, which controls how Metabase interprets the value (ex: \'file-path\' means the \'simple_value\' is not the real value, but a pointer to a file that contains the value).\",\"The source of the product.\",\"The state or province of the account’s billing address\",\"the status of task history, could be started, failed, success, unknown\",\"The status of the index: initializing, indexed, error, overflow.\",\"the strategy of breakout\",\"The street address of the account’s billing address\",\"The time a field usage was recorded\",\"The time an event ended, if applicable\",\"The time an event was recorded\",\"The time, in milliseconds, this query took to complete.\",\"The timestamp at which the tab was created\",\"The timestamp at which the tab was last updated\",\"The timestamp of when the action was created\",\"The timestamp of when the action was updated\",\"The timestamp of when the bookmark was created\",\"The timestamp of when the card is last used\",\"The timestamp of when the event was created\",\"The timestamp of when the event was modified\",\"The timestamp of when the model was first persisted\",\"The timestamp of when the most recent refresh ended\",\"The timestamp of when the most recent refresh was started\",\"The timestamp of when the most recent state changed\",\"The timestamp of when the timeline was created\",\"The timestamp of when the timeline was updated\",\"The timestamp of when these changes were made.\",\"The timestamp when the card was first published in a static embed\",\"The timestamp when the dashboard was first published in a static embed\",\"The timestamp when the key was created\",\"The timestamp when the key was last updated\",\"The topic of a given audit event\",\"The total billed amount.\",\"The type of card, could be \'question\', \'model\', \'metric\'\",\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"The type of the permission (e.g. \\\"data\\\", \\\"collection\\\", \\\"download\\\"...)\",\"The type of user\",\"The UI visualization_settings for this action\",\"The user associated with this view\",\"The user who created the action\",\"The user who left the review\",\"The user who performed an action or triggered an event\",\"The user-defined name of the API key.\",\"The value this permission is set to.\",\"The version of the fingerprint for this Field. Used so we can keep track of which Fields need to be analyzed again when new things are added to fingerprints.\",\"This is a unique ID for the product. It is also called the “Invoice number” or “Confirmation number” in customer facing emails and screens.\",\"This is the amount of local and federal taxes that are collected on the purchase. Note that other governmental fees on some products are not included here, but instead are accounted for in the subtotal.\",\"This is the latitude of the user on sign-up. It might be updated in the future to the last seen location.\",\"This is the longitude of the user on sign-up. It might be updated in the future to the last seen location.\",\"This is the salted password of the user. It should not be visible\",\"This is used to differentiate instance-analytics collections from all other collections.\",\"Timestamp for when this secret instance was created\",\"Timestamp for when this secret record was updated. Only relevant when non-value field changes since a value change will result in a new version being inserted.\",\"Timestamp of when these FieldValues were last used.\",\"Timestamp of when this Collection was created.\",\"Timestamp when the config was inserted\",\"Timestamp when the config was updated\",\"Timezone identifier for the database, set by the sync process\",\"Timezone to display the underlying UTC timestamp in for the client\",\"True if a CSV of the data should be included for this pulse card\",\"True if a XLS of the data should be included for this pulse card\",\"True if the alert should be disabled after the first notification\",\"Type of action\",\"Type of FieldValues\",\"type of the Bookmark\",\"Type of the entity consuming the values (dashboard, card, etc.)\",\"Unique ID\",\"Unique UUID used to in publically-accessible links to this Action.\",\"Unique UUID used to in publically-accessible links to this Card.\",\"Unique UUID used to in publically-accessible links to this Dashboard.\",\"URL where the backup will be uploaded to\",\"User attribute associated with the database role to use for this connection impersonation policy\",\"User ID who created this secret instance\",\"Value of the parameter\",\"verified, misleading, confusing, not_misleading, pending\",\"When the event happened\",\"When the status changed\",\"When this login occurred.\",\"whether it\'s a question or dashboard\",\"Whether or not to apply formatting to the rows of the export\",\"Whether or not to enable periodic refingerprinting for this Database.\",\"Whether the query was a native query, as opposed to an MBQL one (e.g., created with the GUI).\",\"Whether this Collection has been archived and should be hidden from users.\",\"Whether to automatically run queries when doing simple filtering and summarizing in the Query Builder.\",\"Whether uploads are enabled for this database\",\"Whether we should do On-Demand caching of FieldValues for this DB. This means FieldValues are updated when their Field is used in a Dashboard or Card param.\",\"which part of the query the field was used in\"]',NULL,795,_binary '\0','full',NULL,'2024-06-19 14:18:58.856398'),(142,'2024-06-19 14:18:58.918593','2024-06-19 14:18:58.918593','[\"Account ID\",\"Action ID\",\"Action Model ID\",\"Action Qualified ID\",\"Action Type\",\"Active\",\"Active Subscription\",\"Address\",\"Aggregation Function\",\"Alert Above Goal\",\"Alert Condition\",\"Alert First Only\",\"Anti Csrf Token\",\"Archived\",\"Attribute\",\"Attribute Remappings\",\"Authority Level\",\"Auto Apply Filters\",\"Auto Run Queries\",\"Average Execution Time\",\"Base Type\",\"Birth Date\",\"Blob Data\",\"Body\",\"Bool Prop 1\",\"Bool Prop 2\",\"Breakout Binning Bin Width\",\"Breakout Binning Num Bins\",\"Breakout Binning Strategy\",\"Breakout Temporal Unit\",\"Button Label\",\"Cache Field Values Schedule\",\"Cache Hash\",\"Cache Hit\",\"Cache Invalidated At\",\"Cache Ttl\",\"Calendar\",\"Calendar Name\",\"Canceled At\",\"Card ID\",\"Card Qualified ID\",\"Category\",\"Caveats\",\"Channel Type\",\"Checkin Interval\",\"City\",\"Coercion Strategy\",\"Col\",\"Collection ID\",\"Collection Is Official\",\"Collection Is Personal\",\"Collection Position\",\"Collection Preview\",\"Content\",\"Context\",\"Country\",\"Created At\",\"Creator ID\",\"Cron Expression\",\"Custom Position\",\"Dashboard Card ID\",\"Dashboard ID\",\"Dashboard Qualified ID\",\"Dashboard Tab ID\",\"Dashboardcard ID\",\"Dashboardtab ID\",\"Database ID\",\"Database Indexed\",\"Database Is Auto Increment\",\"Database Partitioned\",\"Database Position\",\"Database Qualified ID\",\"Database Require Filter\",\"Database Required\",\"Database Type\",\"Dataset Query\",\"Date Joined\",\"Date Received\",\"Db ID\",\"Db Version\",\"Dbms Version\",\"Dec Prop 1\",\"Dec Prop 2\",\"Default\",\"Definition\",\"Delete\",\"Dependent On ID\",\"Dependent On Model\",\"Description\",\"Details\",\"Device Description\",\"Device ID\",\"Direct Reference\",\"Discount\",\"Display\",\"Display Name\",\"Duration\",\"Duration Seconds\",\"Ean\",\"Effective Type\",\"Email\",\"Embedding Params\",\"Enable Embedding\",\"Enabled\",\"End Time\",\"End Timestamp\",\"Ended At\",\"Engine\",\"Entity ID\",\"Entity Qualified ID\",\"Entity Type\",\"Entry ID\",\"Error\",\"Error Handle\",\"Estimated Row Count\",\"Event\",\"Event Timestamp\",\"Executor ID\",\"Expected Invoice\",\"External ID\",\"Field ID\",\"Field Order\",\"Filter Op\",\"Fingerprint\",\"Fingerprint Version\",\"Fired Time\",\"First Name\",\"Fk Target Field ID\",\"Flow\",\"Format Rows\",\"Full Name\",\"Group ID\",\"Group Name\",\"Has Access\",\"Has Field Values\",\"Has More Values\",\"Hash\",\"Hash Key\",\"How Is This Calculated\",\"Human Readable Field ID\",\"Human Readable Values\",\"Icon\",\"ID\",\"Include Csv\",\"Include Xls\",\"Income\",\"Indexed At\",\"Initial Sync Status\",\"Initially Published At\",\"Insert\",\"Instance Name\",\"Int Prop 1\",\"Int Prop 2\",\"IP Address\",\"Is Active\",\"Is Admin\",\"Is Audit\",\"Is Creation\",\"Is Datasetnewb\",\"Is Durable\",\"Is Embedding Enabled\",\"Is Full Sync\",\"Is Group Manager\",\"Is Native\",\"Is Nonconcurrent\",\"Is On Demand\",\"Is Qbnewb\",\"Is Reversion\",\"Is Sample\",\"Is Sandboxed\",\"Is Superuser\",\"Is Update Data\",\"Is Upload\",\"Item ID\",\"Job Class Name\",\"Job Data\",\"Job Group\",\"Job Name\",\"Json Unfolding\",\"Key\",\"Key Prefix\",\"Kind\",\"Label ID\",\"Last Analyzed\",\"Last Checkin Time\",\"Last Login\",\"Last Name\",\"Last Used At\",\"Latitude\",\"Legacy Plan\",\"Locale\",\"Location\",\"Lock Name\",\"Login Attributes\",\"Long Prop 1\",\"Long Prop 2\",\"Longitude\",\"Made Public By ID\",\"Made Public By User\",\"Membership Cnt\",\"Membership Flow\",\"Membership Rate\",\"Message\",\"Metabase Version\",\"Metadata\",\"Metadata Sync Schedule\",\"Metric ID\",\"Mid\",\"Misfire Instr\",\"Model\",\"Model ID\",\"Model Index ID\",\"Model Pk\",\"Moderated Item ID\",\"Moderated Item Type\",\"Moderator ID\",\"Most Recent\",\"Name\",\"Namespace\",\"Native\",\"Next Fire Time\",\"Nfc Path\",\"Object\",\"Official Flow\",\"Ordering\",\"Other Cnt\",\"Other Flow\",\"Other Rate\",\"Owner ID\",\"Page URL\",\"Parameter ID\",\"Parameter Mappings\",\"Parameterized Object ID\",\"Parameterized Object Type\",\"Parameters\",\"Parent ID\",\"Password\",\"Password Salt\",\"Payment\",\"Pdate\",\"Perm Type\",\"Perm Value\",\"Permission ID\",\"Personal Owner ID\",\"Pk Ref\",\"Plan\",\"Points Of Interest\",\"Position\",\"Prev Fire Time\",\"Preview Display\",\"Price\",\"Priority\",\"Product ID\",\"Profit Rate\",\"Progress\",\"Ptime\",\"Public UUID\",\"Pulse Channel ID\",\"Pulse ID\",\"Quantity\",\"Query\",\"Query Execution ID\",\"Query Hash\",\"Query Source\",\"Query Type\",\"Question Database ID\",\"Question Is Native\",\"Question Slug\",\"Question Viz Type\",\"Rating\",\"Rating Mapped\",\"Recipient External\",\"Recipient Type\",\"Recipients\",\"Refingerprint\",\"Refresh Begin\",\"Refresh End\",\"Repeat Count\",\"Repeat Interval\",\"Requests Recovery\",\"Reset Token\",\"Reset Triggered\",\"Response Handle\",\"Result Metadata\",\"Result Rows\",\"Reviewer\",\"Role\",\"Row\",\"Running Time\",\"Running Time Seconds\",\"Sched Name\",\"Sched Time\",\"Schedule\",\"Schedule Day\",\"Schedule Frame\",\"Schedule Hour\",\"Schedule Type\",\"Schema\",\"Schema Name\",\"Scope\",\"Seats\",\"Select\",\"Semantic Type\",\"Session ID\",\"Settings\",\"Show In Getting Started\",\"Size X\",\"Size Y\",\"Skip If Empty\",\"Slug\",\"Source\",\"Sso Source\",\"Start Time\",\"Started At\",\"State\",\"State Change At\",\"Status\",\"Str Prop 1\",\"Str Prop 2\",\"Str Prop 3\",\"Streamer Flow\",\"Subtotal\",\"Table ID\",\"Table Name\",\"Task\",\"Task Details\",\"Tax\",\"Template\",\"Text\",\"Time Matters\",\"Time Zone ID\",\"Timeline ID\",\"Times Triggered\",\"Timestamp\",\"Timezone\",\"Title\",\"Topic\",\"Total\",\"Total Flow\",\"Trial Converted\",\"Trial Ends At\",\"Trigger Group\",\"Trigger Name\",\"Trigger State\",\"Trigger Type\",\"Type\",\"Update\",\"Updated At\",\"Updated By ID\",\"Upload URL\",\"Uploads Enabled\",\"Uploads Schema Name\",\"Uploads Table Prefix\",\"Used In\",\"User ID\",\"Value\",\"Value Ref\",\"Values\",\"Vendor\",\"Version\",\"View Count\",\"Visibility Type\",\"Visualization Settings\",\"Width\",\"Zip\",\"Zone Admission Cnt\",\"Zone Admission Flow\",\"Zone Admission Rate\",\"Zone Moment Cnt\",\"Zone Moment Flow\",\"Zone Moment Rate\",\"Zone Superfan Cnt\",\"Zone Superfan Flow\",\"Zone Superfan Rate\"]',NULL,789,_binary '\0','full',NULL,'2024-06-19 14:18:58.918593'),(143,'2024-06-19 14:18:58.976609','2024-06-19 14:18:58.976609','[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,419,420,421,422,423,424,425,426,427,428,429,430,431,432,433,434,435,436,437,438,439,440,441,442,443,444,445,446,447,448,449,450,451,452,453,454,455,456,457,458,459,460,461,462,463,464,465,466,467,468,469,470,471,472,473,474,475,476,477,478,479,480,481,482,483,484,485,486,487,488,489,490,491,492,493,494,495,496,497,498,499,500,501,502,503,504,505,506,507,508,509,510,511,512,513,514,515,516,517,518,519,520,521,522,523,524,525,526,527,528,529,530,531,532,533,534,535,536,537,538,539,540,541,542,543,544,545,546,547,548,549,550,551,552,553,554,555,556,557,558,559,560,561,562,563,564,565,566,567,568,569,570,571,572,573,574,575,576,577,578,579,580,581,582,583,584,585,586,587,588,589,590,591,592,593,594,595,596,597,598,599,600,601,602,603,604,605,606,607,608,609,610,611,612,613,614,615,616,617,618,619,620,621,622,623,624,625,626,627,628,629,630,631,632,633,634,635,636,637,638,639,640,641,642,643,644,645,646,647,648,649,650,651,652,653,654,655,656,657,658,659,660,661,662,663,664,665,666,667,668,669,670,671,672,673,674,675,676,677,678,679,680,681,682,683,684,685,686,687,688,689,690,691,692,693,694,695,696,697,698,699,700,701,702,703,704,705,706,707,708,709,710,711,712,713,714,715,716,717,718,719,720,721,722,723,724,725,726,727,728,729,730,731,732,733,734,735,736,737,738,739,740,741,742,743,744,745,746,747,748,749,750,751,752,753,754,755,756,757,758,759,760,761,762,763,764,765,766,767,768,769,770,771,772,773,774,775,776,777,778,779,780,781,782,783,784,785,786,787,788,789,790,791,792,793,794,795,796,797,798,799,800,801,802,803,804,805,806,807,808,809,810,811,812,813,814,815,816,817,818,819,820,821,822,823,824,825,826,827,828,829,830,831,832,833,834,835,836,837,838,839,840,841,842,843,844,845,846,847,848,849,850,851,852,853,854,855,856,857,858,859,860,861,862,863,864,865,866,867,868,869,870,871,872,873,874,875,876,877,878,879,880,881,882,883,884,885,886,887,888,889,890,891,892,893,894,895,896,897,898,899,900,901,902,903,904,905,906,907]',NULL,792,_binary '\0','full',NULL,'2024-06-19 14:18:58.976609'),(144,'2024-06-19 14:18:59.048030','2024-06-19 14:18:59.048030','[\"field_1\",\"field_10\",\"field_100\",\"field_101\",\"field_102\",\"field_103\",\"field_104\",\"field_105\",\"field_106\",\"field_107\",\"field_108\",\"field_109\",\"field_11\",\"field_110\",\"field_111\",\"field_112\",\"field_113\",\"field_114\",\"field_115\",\"field_116\",\"field_117\",\"field_118\",\"field_119\",\"field_12\",\"field_120\",\"field_121\",\"field_122\",\"field_123\",\"field_124\",\"field_125\",\"field_126\",\"field_127\",\"field_128\",\"field_129\",\"field_13\",\"field_130\",\"field_131\",\"field_132\",\"field_133\",\"field_134\",\"field_135\",\"field_136\",\"field_137\",\"field_138\",\"field_139\",\"field_14\",\"field_140\",\"field_141\",\"field_142\",\"field_143\",\"field_144\",\"field_145\",\"field_146\",\"field_147\",\"field_148\",\"field_149\",\"field_15\",\"field_150\",\"field_151\",\"field_152\",\"field_153\",\"field_154\",\"field_155\",\"field_156\",\"field_157\",\"field_158\",\"field_159\",\"field_16\",\"field_160\",\"field_161\",\"field_162\",\"field_163\",\"field_164\",\"field_165\",\"field_166\",\"field_167\",\"field_168\",\"field_169\",\"field_17\",\"field_170\",\"field_171\",\"field_172\",\"field_173\",\"field_174\",\"field_175\",\"field_176\",\"field_177\",\"field_178\",\"field_179\",\"field_18\",\"field_180\",\"field_181\",\"field_182\",\"field_183\",\"field_184\",\"field_185\",\"field_186\",\"field_187\",\"field_188\",\"field_189\",\"field_19\",\"field_190\",\"field_191\",\"field_192\",\"field_193\",\"field_194\",\"field_195\",\"field_196\",\"field_197\",\"field_198\",\"field_199\",\"field_2\",\"field_20\",\"field_200\",\"field_201\",\"field_202\",\"field_203\",\"field_204\",\"field_205\",\"field_206\",\"field_207\",\"field_208\",\"field_209\",\"field_21\",\"field_210\",\"field_211\",\"field_212\",\"field_213\",\"field_214\",\"field_215\",\"field_216\",\"field_217\",\"field_218\",\"field_219\",\"field_22\",\"field_220\",\"field_221\",\"field_222\",\"field_223\",\"field_224\",\"field_225\",\"field_226\",\"field_227\",\"field_228\",\"field_229\",\"field_23\",\"field_230\",\"field_231\",\"field_232\",\"field_233\",\"field_234\",\"field_235\",\"field_236\",\"field_237\",\"field_238\",\"field_239\",\"field_24\",\"field_240\",\"field_241\",\"field_242\",\"field_243\",\"field_244\",\"field_245\",\"field_246\",\"field_247\",\"field_248\",\"field_249\",\"field_25\",\"field_250\",\"field_251\",\"field_252\",\"field_253\",\"field_254\",\"field_255\",\"field_256\",\"field_257\",\"field_258\",\"field_259\",\"field_26\",\"field_260\",\"field_261\",\"field_262\",\"field_263\",\"field_264\",\"field_265\",\"field_266\",\"field_267\",\"field_268\",\"field_269\",\"field_27\",\"field_270\",\"field_271\",\"field_272\",\"field_273\",\"field_274\",\"field_275\",\"field_276\",\"field_277\",\"field_278\",\"field_279\",\"field_28\",\"field_280\",\"field_281\",\"field_282\",\"field_283\",\"field_284\",\"field_285\",\"field_286\",\"field_287\",\"field_288\",\"field_289\",\"field_29\",\"field_290\",\"field_291\",\"field_292\",\"field_293\",\"field_294\",\"field_295\",\"field_296\",\"field_297\",\"field_298\",\"field_299\",\"field_3\",\"field_30\",\"field_300\",\"field_301\",\"field_302\",\"field_303\",\"field_304\",\"field_305\",\"field_306\",\"field_307\",\"field_308\",\"field_309\",\"field_31\",\"field_310\",\"field_311\",\"field_312\",\"field_313\",\"field_314\",\"field_315\",\"field_316\",\"field_317\",\"field_318\",\"field_319\",\"field_32\",\"field_320\",\"field_321\",\"field_322\",\"field_323\",\"field_324\",\"field_325\",\"field_326\",\"field_327\",\"field_328\",\"field_329\",\"field_33\",\"field_330\",\"field_331\",\"field_332\",\"field_333\",\"field_334\",\"field_335\",\"field_336\",\"field_337\",\"field_338\",\"field_339\",\"field_34\",\"field_340\",\"field_341\",\"field_342\",\"field_343\",\"field_344\",\"field_345\",\"field_346\",\"field_347\",\"field_348\",\"field_349\",\"field_35\",\"field_350\",\"field_351\",\"field_352\",\"field_353\",\"field_354\",\"field_355\",\"field_356\",\"field_357\",\"field_358\",\"field_359\",\"field_36\",\"field_360\",\"field_361\",\"field_362\",\"field_363\",\"field_364\",\"field_365\",\"field_366\",\"field_367\",\"field_368\",\"field_369\",\"field_37\",\"field_370\",\"field_371\",\"field_372\",\"field_373\",\"field_374\",\"field_375\",\"field_376\",\"field_377\",\"field_378\",\"field_379\",\"field_38\",\"field_380\",\"field_381\",\"field_382\",\"field_383\",\"field_384\",\"field_385\",\"field_386\",\"field_387\",\"field_388\",\"field_389\",\"field_39\",\"field_390\",\"field_391\",\"field_392\",\"field_393\",\"field_394\",\"field_395\",\"field_396\",\"field_397\",\"field_398\",\"field_399\",\"field_4\",\"field_40\",\"field_400\",\"field_401\",\"field_402\",\"field_403\",\"field_404\",\"field_405\",\"field_406\",\"field_407\",\"field_408\",\"field_409\",\"field_41\",\"field_410\",\"field_411\",\"field_412\",\"field_413\",\"field_414\",\"field_415\",\"field_416\",\"field_417\",\"field_418\",\"field_419\",\"field_42\",\"field_420\",\"field_421\",\"field_422\",\"field_423\",\"field_424\",\"field_425\",\"field_426\",\"field_427\",\"field_428\",\"field_429\",\"field_43\",\"field_430\",\"field_431\",\"field_432\",\"field_433\",\"field_434\",\"field_435\",\"field_436\",\"field_437\",\"field_438\",\"field_439\",\"field_44\",\"field_440\",\"field_441\",\"field_442\",\"field_443\",\"field_444\",\"field_445\",\"field_446\",\"field_447\",\"field_448\",\"field_449\",\"field_45\",\"field_450\",\"field_451\",\"field_452\",\"field_453\",\"field_454\",\"field_455\",\"field_456\",\"field_457\",\"field_458\",\"field_459\",\"field_46\",\"field_460\",\"field_461\",\"field_462\",\"field_463\",\"field_464\",\"field_465\",\"field_466\",\"field_467\",\"field_468\",\"field_469\",\"field_47\",\"field_470\",\"field_471\",\"field_472\",\"field_473\",\"field_474\",\"field_475\",\"field_476\",\"field_477\",\"field_478\",\"field_479\",\"field_48\",\"field_480\",\"field_481\",\"field_482\",\"field_483\",\"field_484\",\"field_485\",\"field_486\",\"field_487\",\"field_488\",\"field_489\",\"field_49\",\"field_490\",\"field_491\",\"field_492\",\"field_493\",\"field_494\",\"field_495\",\"field_496\",\"field_497\",\"field_498\",\"field_499\",\"field_5\",\"field_50\",\"field_500\",\"field_501\",\"field_502\",\"field_503\",\"field_504\",\"field_505\",\"field_506\",\"field_507\",\"field_508\",\"field_509\",\"field_51\",\"field_510\",\"field_511\",\"field_512\",\"field_513\",\"field_514\",\"field_515\",\"field_516\",\"field_517\",\"field_518\",\"field_519\",\"field_52\",\"field_520\",\"field_521\",\"field_522\",\"field_523\",\"field_524\",\"field_525\",\"field_526\",\"field_527\",\"field_528\",\"field_529\",\"field_53\",\"field_530\",\"field_531\",\"field_532\",\"field_533\",\"field_534\",\"field_535\",\"field_536\",\"field_537\",\"field_538\",\"field_539\",\"field_54\",\"field_540\",\"field_541\",\"field_542\",\"field_543\",\"field_544\",\"field_545\",\"field_546\",\"field_547\",\"field_548\",\"field_549\",\"field_55\",\"field_550\",\"field_551\",\"field_552\",\"field_553\",\"field_554\",\"field_555\",\"field_556\",\"field_557\",\"field_558\",\"field_559\",\"field_56\",\"field_560\",\"field_561\",\"field_562\",\"field_563\",\"field_564\",\"field_565\",\"field_566\",\"field_567\",\"field_568\",\"field_569\",\"field_57\",\"field_570\",\"field_571\",\"field_572\",\"field_573\",\"field_574\",\"field_575\",\"field_576\",\"field_577\",\"field_578\",\"field_579\",\"field_58\",\"field_580\",\"field_581\",\"field_582\",\"field_583\",\"field_584\",\"field_585\",\"field_586\",\"field_587\",\"field_588\",\"field_589\",\"field_59\",\"field_590\",\"field_591\",\"field_592\",\"field_593\",\"field_594\",\"field_595\",\"field_596\",\"field_597\",\"field_598\",\"field_599\",\"field_6\",\"field_60\",\"field_600\",\"field_601\",\"field_602\",\"field_603\",\"field_604\",\"field_605\",\"field_606\",\"field_607\",\"field_608\",\"field_609\",\"field_61\",\"field_610\",\"field_611\",\"field_612\",\"field_613\",\"field_614\",\"field_615\",\"field_616\",\"field_617\",\"field_618\",\"field_619\",\"field_62\",\"field_620\",\"field_621\",\"field_622\",\"field_623\",\"field_624\",\"field_625\",\"field_626\",\"field_627\",\"field_628\",\"field_629\",\"field_63\",\"field_630\",\"field_631\",\"field_632\",\"field_633\",\"field_634\",\"field_635\",\"field_636\",\"field_637\",\"field_638\",\"field_639\",\"field_64\",\"field_640\",\"field_641\",\"field_642\",\"field_643\",\"field_644\",\"field_645\",\"field_646\",\"field_647\",\"field_648\",\"field_649\",\"field_65\",\"field_650\",\"field_651\",\"field_652\",\"field_653\",\"field_654\",\"field_655\",\"field_656\",\"field_657\",\"field_658\",\"field_659\",\"field_66\",\"field_660\",\"field_661\",\"field_662\",\"field_663\",\"field_664\",\"field_665\",\"field_666\",\"field_667\",\"field_668\",\"field_669\",\"field_67\",\"field_670\",\"field_671\",\"field_672\",\"field_673\",\"field_674\",\"field_675\",\"field_676\",\"field_677\",\"field_678\",\"field_679\",\"field_68\",\"field_680\",\"field_681\",\"field_682\",\"field_683\",\"field_684\",\"field_685\",\"field_686\",\"field_687\",\"field_688\",\"field_689\",\"field_69\",\"field_690\",\"field_691\",\"field_692\",\"field_693\",\"field_694\",\"field_695\",\"field_696\",\"field_697\",\"field_698\",\"field_699\",\"field_7\",\"field_70\",\"field_700\",\"field_701\",\"field_702\",\"field_703\",\"field_704\",\"field_705\",\"field_706\",\"field_707\",\"field_708\",\"field_709\",\"field_71\",\"field_710\",\"field_711\",\"field_712\",\"field_713\",\"field_714\",\"field_715\",\"field_716\",\"field_717\",\"field_718\",\"field_719\",\"field_72\",\"field_720\",\"field_721\",\"field_722\",\"field_723\",\"field_724\",\"field_725\",\"field_726\",\"field_727\",\"field_728\",\"field_729\",\"field_73\",\"field_730\",\"field_731\",\"field_732\",\"field_733\",\"field_734\",\"field_735\",\"field_736\",\"field_737\",\"field_738\",\"field_739\",\"field_74\",\"field_740\",\"field_741\",\"field_742\",\"field_743\",\"field_744\",\"field_745\",\"field_746\",\"field_747\",\"field_748\",\"field_749\",\"field_75\",\"field_750\",\"field_751\",\"field_752\",\"field_753\",\"field_754\",\"field_755\",\"field_756\",\"field_757\",\"field_758\",\"field_759\",\"field_76\",\"field_760\",\"field_761\",\"field_762\",\"field_763\",\"field_764\",\"field_765\",\"field_766\",\"field_767\",\"field_768\",\"field_769\",\"field_77\",\"field_770\",\"field_771\",\"field_772\",\"field_773\",\"field_774\",\"field_775\",\"field_776\",\"field_777\",\"field_778\",\"field_779\",\"field_78\",\"field_780\",\"field_781\",\"field_782\",\"field_783\",\"field_784\",\"field_785\",\"field_786\",\"field_787\",\"field_788\",\"field_789\",\"field_79\",\"field_790\",\"field_791\",\"field_792\",\"field_793\",\"field_794\",\"field_795\",\"field_796\",\"field_797\",\"field_798\",\"field_799\",\"field_8\",\"field_80\",\"field_800\",\"field_801\",\"field_802\",\"field_803\",\"field_804\",\"field_805\",\"field_806\",\"field_807\",\"field_808\",\"field_809\",\"field_81\",\"field_810\",\"field_811\",\"field_812\",\"field_813\",\"field_814\",\"field_815\",\"field_816\",\"field_817\",\"field_818\",\"field_819\",\"field_82\",\"field_820\",\"field_821\",\"field_822\",\"field_823\",\"field_824\",\"field_825\",\"field_826\",\"field_827\",\"field_828\",\"field_829\",\"field_83\",\"field_830\",\"field_831\",\"field_832\",\"field_833\",\"field_834\",\"field_835\",\"field_836\",\"field_837\",\"field_838\",\"field_839\",\"field_84\",\"field_840\",\"field_841\",\"field_842\",\"field_843\",\"field_844\",\"field_845\",\"field_846\",\"field_847\",\"field_848\",\"field_849\",\"field_85\",\"field_850\",\"field_851\",\"field_852\",\"field_853\",\"field_854\",\"field_855\",\"field_856\",\"field_857\",\"field_858\",\"field_859\",\"field_86\",\"field_860\",\"field_861\",\"field_862\",\"field_863\",\"field_864\",\"field_865\",\"field_866\",\"field_867\",\"field_868\",\"field_869\",\"field_87\",\"field_870\",\"field_871\",\"field_872\",\"field_873\",\"field_874\",\"field_875\",\"field_876\",\"field_877\",\"field_878\",\"field_879\",\"field_88\",\"field_880\",\"field_881\",\"field_882\",\"field_883\",\"field_884\",\"field_885\",\"field_886\",\"field_887\",\"field_888\",\"field_889\",\"field_89\",\"field_890\",\"field_891\",\"field_892\",\"field_893\",\"field_894\",\"field_895\",\"field_896\",\"field_897\",\"field_898\",\"field_899\",\"field_9\",\"field_90\",\"field_900\",\"field_901\",\"field_902\",\"field_903\",\"field_904\",\"field_905\",\"field_906\",\"field_907\",\"field_91\",\"field_92\",\"field_93\",\"field_94\",\"field_95\",\"field_96\",\"field_97\",\"field_98\",\"field_99\"]',NULL,793,_binary '\0','full',NULL,'2024-06-19 14:18:59.048030'),(145,'2024-06-19 14:18:59.092291','2024-06-19 14:18:59.092291','[null,7,46,62,78,131,145,163,177,226,250,290,314,331,351,386,414,433,474,478,479,510,515,518,534,576,614,625,696]',NULL,794,_binary '\0','full',NULL,'2024-06-19 14:18:59.092291'),(146,'2024-06-19 14:18:59.141655','2024-06-19 14:18:59.141655','[null,\"auto-list\"]',NULL,786,_binary '\0','full',NULL,'2024-06-19 14:18:59.141655'),(147,'2024-06-19 14:18:59.188161','2024-06-19 14:18:59.188161','[\"ACCOUNT_ID\",\"action_id\",\"action_model_id\",\"action_qualified_id\",\"action_type\",\"active\",\"ACTIVE_SUBSCRIPTION\",\"ADDRESS\",\"aggregation_function\",\"alert_above_goal\",\"alert_condition\",\"alert_first_only\",\"anti_csrf_token\",\"archived\",\"attribute\",\"attribute_remappings\",\"authority_level\",\"auto_apply_filters\",\"auto_run_queries\",\"average_execution_time\",\"base_type\",\"BIRTH_DATE\",\"BLOB_DATA\",\"BODY\",\"BOOL_PROP_1\",\"BOOL_PROP_2\",\"breakout_binning_bin_width\",\"breakout_binning_num_bins\",\"breakout_binning_strategy\",\"breakout_temporal_unit\",\"BUTTON_LABEL\",\"cache_field_values_schedule\",\"cache_hash\",\"cache_hit\",\"cache_invalidated_at\",\"cache_ttl\",\"CALENDAR\",\"CALENDAR_NAME\",\"CANCELED_AT\",\"card_id\",\"card_qualified_id\",\"CATEGORY\",\"caveats\",\"channel_type\",\"CHECKIN_INTERVAL\",\"CITY\",\"coercion_strategy\",\"col\",\"collection_id\",\"collection_is_official\",\"collection_is_personal\",\"collection_position\",\"collection_preview\",\"content\",\"context\",\"COUNTRY\",\"CREATED_AT\",\"creator_id\",\"CRON_EXPRESSION\",\"custom_position\",\"dashboard_card_id\",\"dashboard_id\",\"dashboard_qualified_id\",\"dashboard_tab_id\",\"dashboardcard_id\",\"dashboardtab_id\",\"database_id\",\"database_indexed\",\"database_is_auto_increment\",\"database_partitioned\",\"database_position\",\"database_qualified_id\",\"database_require_filter\",\"database_required\",\"database_type\",\"dataset_query\",\"date_joined\",\"DATE_RECEIVED\",\"db_id\",\"db_version\",\"dbms_version\",\"DEC_PROP_1\",\"DEC_PROP_2\",\"default\",\"definition\",\"delete\",\"dependent_on_id\",\"dependent_on_model\",\"description\",\"details\",\"device_description\",\"device_id\",\"direct_reference\",\"DISCOUNT\",\"display\",\"display_name\",\"duration\",\"duration_seconds\",\"EAN\",\"effective_type\",\"EMAIL\",\"embedding_params\",\"enable_embedding\",\"enabled\",\"END_TIME\",\"end_timestamp\",\"ended_at\",\"engine\",\"entity_id\",\"entity_qualified_id\",\"entity_type\",\"ENTRY_ID\",\"error\",\"error_handle\",\"estimated_row_count\",\"EVENT\",\"event_timestamp\",\"executor_id\",\"EXPECTED_INVOICE\",\"external_id\",\"field_id\",\"field_order\",\"filter_op\",\"fingerprint\",\"fingerprint_version\",\"FIRED_TIME\",\"FIRST_NAME\",\"fk_target_field_id\",\"flow\",\"format_rows\",\"full_name\",\"group_id\",\"group_name\",\"has_access\",\"has_field_values\",\"has_more_values\",\"hash\",\"hash_key\",\"how_is_this_calculated\",\"human_readable_field_id\",\"human_readable_values\",\"icon\",\"ID\",\"include_csv\",\"include_xls\",\"income\",\"indexed_at\",\"initial_sync_status\",\"initially_published_at\",\"insert\",\"INSTANCE_NAME\",\"INT_PROP_1\",\"INT_PROP_2\",\"ip_address\",\"is_active\",\"is_admin\",\"is_audit\",\"is_creation\",\"is_datasetnewb\",\"IS_DURABLE\",\"is_embedding_enabled\",\"is_full_sync\",\"is_group_manager\",\"is_native\",\"IS_NONCONCURRENT\",\"is_on_demand\",\"is_qbnewb\",\"is_reversion\",\"is_sample\",\"is_sandboxed\",\"is_superuser\",\"IS_UPDATE_DATA\",\"is_upload\",\"item_id\",\"JOB_CLASS_NAME\",\"JOB_DATA\",\"JOB_GROUP\",\"JOB_NAME\",\"json_unfolding\",\"key\",\"key_prefix\",\"kind\",\"label_id\",\"last_analyzed\",\"LAST_CHECKIN_TIME\",\"last_login\",\"LAST_NAME\",\"last_used_at\",\"LATITUDE\",\"LEGACY_PLAN\",\"locale\",\"location\",\"LOCK_NAME\",\"login_attributes\",\"LONG_PROP_1\",\"LONG_PROP_2\",\"LONGITUDE\",\"made_public_by_id\",\"made_public_by_user\",\"membership_cnt\",\"membership_flow\",\"membership_rate\",\"message\",\"metabase_version\",\"metadata\",\"metadata_sync_schedule\",\"metric_id\",\"mid\",\"MISFIRE_INSTR\",\"model\",\"model_id\",\"model_index_id\",\"model_pk\",\"moderated_item_id\",\"moderated_item_type\",\"moderator_id\",\"most_recent\",\"NAME\",\"namespace\",\"native\",\"NEXT_FIRE_TIME\",\"nfc_path\",\"object\",\"official_flow\",\"ordering\",\"other_cnt\",\"other_flow\",\"other_rate\",\"owner_id\",\"PAGE_URL\",\"parameter_id\",\"parameter_mappings\",\"parameterized_object_id\",\"parameterized_object_type\",\"parameters\",\"parent_id\",\"PASSWORD\",\"password_salt\",\"PAYMENT\",\"pdate\",\"perm_type\",\"perm_value\",\"permission_id\",\"personal_owner_id\",\"pk_ref\",\"PLAN\",\"points_of_interest\",\"position\",\"PREV_FIRE_TIME\",\"preview_display\",\"PRICE\",\"PRIORITY\",\"PRODUCT_ID\",\"profit_rate\",\"progress\",\"ptime\",\"public_uuid\",\"pulse_channel_id\",\"pulse_id\",\"QUANTITY\",\"query\",\"query_execution_id\",\"query_hash\",\"query_source\",\"query_type\",\"question_database_id\",\"question_is_native\",\"question_slug\",\"question_viz_type\",\"RATING\",\"RATING_MAPPED\",\"recipient_external\",\"recipient_type\",\"recipients\",\"refingerprint\",\"refresh_begin\",\"refresh_end\",\"REPEAT_COUNT\",\"REPEAT_INTERVAL\",\"REQUESTS_RECOVERY\",\"reset_token\",\"reset_triggered\",\"response_handle\",\"result_metadata\",\"result_rows\",\"REVIEWER\",\"role\",\"row\",\"running_time\",\"running_time_seconds\",\"SCHED_NAME\",\"SCHED_TIME\",\"schedule\",\"schedule_day\",\"schedule_frame\",\"schedule_hour\",\"schedule_type\",\"schema\",\"schema_name\",\"scope\",\"SEATS\",\"select\",\"semantic_type\",\"session_id\",\"settings\",\"show_in_getting_started\",\"size_x\",\"size_y\",\"skip_if_empty\",\"slug\",\"SOURCE\",\"sso_source\",\"START_TIME\",\"started_at\",\"STATE\",\"state_change_at\",\"status\",\"STR_PROP_1\",\"STR_PROP_2\",\"STR_PROP_3\",\"streamer_flow\",\"SUBTOTAL\",\"table_id\",\"table_name\",\"task\",\"task_details\",\"TAX\",\"template\",\"text\",\"time_matters\",\"TIME_ZONE_ID\",\"timeline_id\",\"TIMES_TRIGGERED\",\"TIMESTAMP\",\"timezone\",\"TITLE\",\"topic\",\"TOTAL\",\"total_flow\",\"TRIAL_CONVERTED\",\"TRIAL_ENDS_AT\",\"TRIGGER_GROUP\",\"TRIGGER_NAME\",\"TRIGGER_STATE\",\"TRIGGER_TYPE\",\"type\",\"update\",\"updated_at\",\"updated_by_id\",\"upload_url\",\"uploads_enabled\",\"uploads_schema_name\",\"uploads_table_prefix\",\"used_in\",\"USER_ID\",\"value\",\"value_ref\",\"values\",\"VENDOR\",\"version\",\"view_count\",\"visibility_type\",\"visualization_settings\",\"width\",\"ZIP\",\"zone_admission_cnt\",\"zone_admission_flow\",\"zone_admission_rate\",\"zone_moment_cnt\",\"zone_moment_flow\",\"zone_moment_rate\",\"zone_superfan_cnt\",\"zone_superfan_flow\",\"zone_superfan_rate\"]',NULL,791,_binary '\0','full',NULL,'2024-06-19 14:18:59.188161'),(148,'2024-06-19 14:18:59.265660','2024-06-19 14:18:59.265660','[1,2,3,4,5,6,7,8,9,11,12,13,15,16,17,18,19,20,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,68,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107]',NULL,796,_binary '\0','full',NULL,'2024-06-19 14:18:59.265660'),(149,'2024-06-19 14:18:59.306525','2024-06-19 14:18:59.306525','[\"normal\"]',NULL,788,_binary '\0','full',NULL,'2024-06-19 14:18:59.306525'),(150,'2024-06-19 14:18:59.360138','2024-06-19 14:18:59.360138','[null,\"Indexed Value Refresh task\",\"Persisted Model prune task\",\"Persisted Model refresh task\",\"Send Pulse\",\"sync-and-analyze for all databases\",\"update-field-values for all databases\"]',NULL,473,_binary '\0','full',NULL,'2024-06-19 14:18:59.360138'),(151,'2024-06-19 14:18:59.404746','2024-06-19 14:18:59.404746','[false,true]',NULL,480,_binary '\0','full',NULL,'2024-06-19 14:18:59.404746'),(152,'2024-06-19 14:18:59.449736','2024-06-19 14:18:59.449736','[false,true]',NULL,477,_binary '\0','full',NULL,'2024-06-19 14:18:59.449736'),(153,'2024-06-19 14:18:59.490876','2024-06-19 14:18:59.490876','[false]',NULL,476,_binary '\0','full',NULL,'2024-06-19 14:18:59.490876'),(154,'2024-06-19 14:18:59.529423','2024-06-19 14:18:59.529423','[\"metabase.task.backfill_query_fields.BackfillQueryField\",\"metabase.task.creator_sentiment_emails.CreatorSentimentEmail\",\"metabase.task.email_remove_legacy_pulse.EmailRemoveLegacyPulse\",\"metabase.task.follow_up_emails.FollowUpEmail\",\"metabase.task.index_values.ModelIndexRefresh\",\"metabase.task.legacy_no_self_service_emails.LegacyNoSelfServiceEmail\",\"metabase.task.persist_refresh.PersistencePrune\",\"metabase.task.persist_refresh.PersistenceRefresh\",\"metabase.task.refresh_slack_channel_user_cache.RefreshCache\",\"metabase.task.send_anonymous_stats.SendAnonymousUsageStats\",\"metabase.task.send_pulses.InitSendPulseTriggers\",\"metabase.task.send_pulses.SendPulse\",\"metabase.task.sync_databases.SyncAndAnalyzeDatabase\",\"metabase.task.sync_databases.UpdateFieldValues\",\"metabase.task.task_history_cleanup.TaskHistoryCleanup\",\"metabase.task.truncate_audit_tables.TruncateAuditTables\",\"metabase.task.upgrade_checks.CheckForNewVersions\"]',NULL,472,_binary '\0','full',NULL,'2024-06-19 14:18:59.529423'),(155,'2024-06-19 14:18:59.578007','2024-06-19 14:18:59.578007','[false]',NULL,471,_binary '\0','full',NULL,'2024-06-19 14:18:59.578007'),(156,'2024-06-19 14:18:59.622315','2024-06-19 14:18:59.622315','[7500]',NULL,486,_binary '\0','full',NULL,'2024-06-19 14:18:59.622315'),(157,'2024-06-19 14:18:59.674217','2024-07-03 21:00:07.990175','[1720040405037]',NULL,487,_binary '\0','full',NULL,'2024-06-19 14:18:59.674217'),(159,'2024-06-19 14:18:59.797930','2024-06-20 21:00:08.577499','[false,true]',NULL,560,_binary '\0','full',NULL,'2024-06-19 14:18:59.797930'),(160,'2024-06-19 14:18:59.851225','2024-06-19 14:18:59.851225','[null]',NULL,567,_binary '\0','full',NULL,'2024-06-19 14:18:59.851225'),(161,'2024-06-19 14:18:59.899909','2024-06-19 14:18:59.899909','[null,1]',NULL,559,_binary '\0','full',NULL,'2024-06-19 14:18:59.899909'),(162,'2024-06-19 14:18:59.942754','2024-06-19 14:18:59.942754','[true]',NULL,580,_binary '\0','full',NULL,'2024-06-19 14:18:59.942754'),(163,'2024-06-19 14:18:59.998985','2024-06-30 21:00:07.896696','[\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"avg\\\",[\\\"field\\\",61,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"source-table\\\":8}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"expression\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"expressions\\\":{\\\"Age\\\":[\\\"datetime-diff\\\",[\\\"field\\\",49,{\\\"base-type\\\":\\\"type/Date\\\",\\\"join-alias\\\":\\\"People - User\\\"}],[\\\"now\\\"],\\\"year\\\"]},\\\"joins\\\":[{\\\"alias\\\":\\\"People - User\\\",\\\"strategy\\\":\\\"left-join\\\",\\\"condition\\\":[\\\"=\\\",[\\\"field\\\",43,{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",46,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"source-table\\\":3}],\\\"source-table\\\":5}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"expression\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]],\\\"expressions\\\":{\\\"Age\\\":[\\\"datetime-diff\\\",[\\\"field\\\",49,{\\\"base-type\\\":\\\"type/Date\\\",\\\"join-alias\\\":\\\"People - User\\\"}],[\\\"now\\\"],\\\"year\\\"]},\\\"joins\\\":[{\\\"alias\\\":\\\"People - User\\\",\\\"strategy\\\":\\\"left-join\\\",\\\"condition\\\":[\\\"=\\\",[\\\"field\\\",43,{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",46,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"source-table\\\":3}],\\\"source-table\\\":5}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10}}],[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"joins\\\":[{\\\"alias\\\":\\\"People - User\\\",\\\"fields\\\":\\\"all\\\",\\\"strategy\\\":\\\"left-join\\\",\\\"condition\\\":[\\\"=\\\",[\\\"field\\\",\\\"USER_ID\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",46,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"source-table\\\":3}],\\\"source-table\\\":\\\"card__2\\\"}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10}}],[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"Products\\\"}]],\\\"joins\\\":[{\\\"alias\\\":\\\"Products\\\",\\\"fields\\\":\\\"all\\\",\\\"strategy\\\":\\\"left-join\\\",\\\"condition\\\":[\\\"=\\\",[\\\"field\\\",\\\"PRODUCT_ID\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",62,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"join-alias\\\":\\\"Products\\\"}]],\\\"source-table\\\":8}],\\\"source-table\\\":\\\"card__2\\\"}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10}}]],\\\"source-table\\\":\\\"card__26\\\"}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-24,\\\"month\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]],\\\"source-table\\\":5}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",61,{\\\"base-type\\\":\\\"type/Float\\\",\\\"source-field\\\":40}],[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]],\\\"order-by\\\":[[\\\"desc\\\",[\\\"field\\\",61,{\\\"base-type\\\":\\\"type/Float\\\",\\\"source-field\\\":40}]]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"!=\\\",[\\\"field\\\",65,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"Incredible Aluminum Knife\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"cum-sum\\\",[\\\"field\\\",42,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],\\\"current\\\",\\\"quarter\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"distinct\\\",[\\\"field\\\",47,{\\\"base-type\\\":\\\"type/Text\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",56,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}]],\\\"source-table\\\":3,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",56,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-2,\\\"month\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",\\\"TOTAL\\\",{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10}}]],\\\"source-table\\\":\\\"card__2\\\"}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",36,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-2,\\\"quarter\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",39,{\\\"base-type\\\":\\\"type/Integer\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"and\\\",[\\\"between\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],\\\"2021-01-01\\\",\\\"2024-01-23\\\"],[\\\"=\\\",[\\\"field\\\",62,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"source-field\\\":40}],165]]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",39,{\\\"base-type\\\":\\\"type/Integer\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"and\\\",[\\\"between\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],\\\"2021-01-01\\\",\\\"2024-01-23\\\"],[\\\"=\\\",[\\\"field\\\",62,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"source-field\\\":40}],17]]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",39,{\\\"base-type\\\":\\\"type/Integer\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"and\\\",[\\\"between\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],\\\"2021-01-01\\\",\\\"2024-01-23\\\"],[\\\"=\\\",[\\\"field\\\",62,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"source-field\\\":40}],86]]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",39,{\\\"base-type\\\":\\\"type/Integer\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-2,\\\"month\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",42,{\\\"base-type\\\":\\\"type/Float\\\"}]],[\\\"sum\\\",[\\\"field\\\",39,{\\\"base-type\\\":\\\"type/Integer\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-24,\\\"month\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",42,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"expression\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}]],\\\"expressions\\\":{\\\"Age\\\":[\\\"datetime-diff\\\",[\\\"field\\\",49,{\\\"base-type\\\":\\\"type/Date\\\",\\\"join-alias\\\":\\\"People - User\\\"}],[\\\"now\\\"],\\\"year\\\"]},\\\"joins\\\":[{\\\"alias\\\":\\\"People - User\\\",\\\"strategy\\\":\\\"left-join\\\",\\\"condition\\\":[\\\"=\\\",[\\\"field\\\",43,{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",46,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"source-table\\\":3}],\\\"source-table\\\":5}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",42,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-2,\\\"quarter\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",42,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]],\\\"source-table\\\":5}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",44,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-24,\\\"month\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"aggregation\\\":[[\\\"sum\\\",[\\\"field\\\",44,{\\\"base-type\\\":\\\"type/Float\\\"}]]],\\\"breakout\\\":[[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}],[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"time-interval\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}],-24,\\\"month\\\"]}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"expressions\\\":{\\\"Age\\\":[\\\"datetime-diff\\\",[\\\"field\\\",49,{\\\"base-type\\\":\\\"type/Date\\\",\\\"join-alias\\\":\\\"People - User\\\"}],[\\\"now\\\"],\\\"year\\\"]},\\\"joins\\\":[{\\\"alias\\\":\\\"People - User\\\",\\\"strategy\\\":\\\"left-join\\\",\\\"condition\\\":[\\\"=\\\",[\\\"field\\\",43,{\\\"base-type\\\":\\\"type/Integer\\\"}],[\\\"field\\\",46,{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"join-alias\\\":\\\"People - User\\\"}]],\\\"source-table\\\":3}],\\\"source-table\\\":5}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"filter\\\":[\\\">\\\",[\\\"field\\\",\\\"count\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}],108],\\\"source-query\\\":{\\\"aggregation\\\":[[\\\"count\\\"]],\\\"breakout\\\":[[\\\"field\\\",65,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]],\\\"order-by\\\":[[\\\"desc\\\",[\\\"aggregation\\\",0]]],\\\"source-table\\\":5,\\\"filter\\\":[\\\"!=\\\",[\\\"field\\\",65,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"Incredible Aluminum Knife\\\"]}}}\",\"{\\\"database\\\":1,\\\"type\\\":\\\"query\\\",\\\"query\\\":{\\\"source-table\\\":3,\\\"expressions\\\":{\\\"Age\\\":[\\\"datetime-diff\\\",[\\\"field\\\",49,{\\\"base-type\\\":\\\"type/Date\\\"}],[\\\"now\\\"],\\\"year\\\"]}}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'主播昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\"}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail\\\\nORDER BY ptime DESC\\\\n;\\\"}}\"]',NULL,558,_binary '\0','full',NULL,'2024-06-19 14:18:59.998985'),(164,'2024-06-19 14:19:00.061179','2024-06-19 14:19:00.061179','[null,\"An ordered list of our most successful products\",\"Breaks down the overall performance of each of the product categories\",\"Compares the current total in revenue with the set goal for the quarter\",\"Compares the number of unique customers placing orders this month with the previous period\",\"Compares the orders of each category quarter over quarter\",\"Compares the total discount given this quarter with the previous period\",\"Compares the total number of orders placed for this product this month with the previous period\",\"Compares the total number of orders placed this month with the previous period\",\"Compares the total revenue this quarter with the previous period\",\"Indicates the average customer review of our products\",\"Matches the cumulative revenue month over month with the number of orders placed each month\",\"Orders placed per quarter broken down by source and formatted to highlight best and worst quarters\",\"Shows a distribution of orders broken down by product categories across our customers\' age groups\",\"Shows a distribution of orders broken down by product category across our customers\' individual age values\",\"Shows a distribution of orders broken down by source across our customers\' age groups\",\"Shows a distribution of orders broken down by source across our customers\' individual age values\",\"Shows a distribution of our customers in age groups\",\"Shows a distribution of revenue per individual age values\",\"Shows the distribution of the product categories along the scale of customer ratings\",\"Shows the revenue distributed by age group\"]',NULL,574,_binary '\0','full',NULL,'2024-06-19 14:19:00.061179'),(165,'2024-06-19 14:19:00.115541','2024-06-19 21:00:09.322831','[\"bar\",\"combo\",\"gauge\",\"line\",\"map\",\"pie\",\"pivot\",\"progress\",\"row\",\"scalar\",\"smartscalar\",\"table\"]',NULL,571,_binary '\0','full',NULL,'2024-06-19 14:19:00.115541'),(166,'2024-06-19 14:19:00.160699','2024-06-19 14:19:00.160699','[null]',NULL,585,_binary '\0','full',NULL,'2024-06-19 14:19:00.160699'),(167,'2024-06-19 14:19:00.211822','2024-06-19 14:19:00.211822','[false]',NULL,570,_binary '\0','full',NULL,'2024-06-19 14:19:00.211822'),(168,'2024-06-19 14:19:00.252659','2024-06-30 21:00:08.004057','[\"-BcEE22ptXyDOgUNRqyct\",\"-mfPjg0QOoIKbqJS0SYne\",\"-O1j6tHCB5JqcjTboahf-\",\"1aVGgD6-onGIPUeWCLiMA\",\"83H8D9yh7bM54eQ89C03w\",\"avC199ZiYvp1aIWdejfFf\",\"Bkb4GEr5dH2_LbDOKhObR\",\"BP4o72CSvPOTLe5Nk6twf\",\"cO53DQ6k0DueW5Aglwp7Y\",\"d3KPtMfbe0IIK0MDrHTNn\",\"DDT6zuq6O7bsnw1UEWtQQ\",\"dsZMohGmK4P7eQRBdLFmb\",\"evd6f3MoDUtTNsoXHwu0T\",\"f9RqS8HspKvcsGEH24_Af\",\"fPYpb3KcV2TJZLRw-L841\",\"hBnes5i3LGSYZeoGIYwvm\",\"hjNoawcRfsDrC32g7LSOE\",\"KMq74J_Gh78vIimczx0LH\",\"lY4hbjNofxepxQGRhJa0s\",\"NdqehUq98ebQ4H_-1d9v3\",\"nhFZBIIZA_KnK6RuLp36z\",\"OouzOUPGIjf6zXJsSDe0f\",\"oShRjudlgUvJRezvGTQTD\",\"P-shWkp5lozD2nuo5xusW\",\"qj0jT7SXwEUezz1wSjtaZ\",\"rqxxsDv8zhSBXgJmVjyWa\",\"t1rQijQdCIZoQI6bhwBEG\",\"wd1PEi_Z217Gr-ceeZSNj\",\"WkUMW3ptA5dVGIw8dZiYT\",\"YaPijzoih3eXfFIsGcA2d\",\"yvOSMNTUeqWKfubXw6Rj9\"]',NULL,572,_binary '\0','full',NULL,'2024-06-19 14:19:00.252659'),(169,'2024-06-19 14:19:00.299821','2024-06-19 21:00:09.454104','[null,\"v0.50.5 (48f6978)\"]',NULL,562,_binary '\0','full',NULL,'2024-06-19 14:19:00.299821'),(170,'2024-06-19 14:19:00.344255','2024-06-30 21:00:08.054240','[\"Aerodynamic Copper Knife trend\",\"Average product rating overall\",\"Best selling products\",\"Buyers by age group\",\"Customer satisfaction per category\",\"Discount given per quarter\",\"Enormous Wool Car trend\",\"Heavy-Duty Silk Chair trend\",\"Number of orders per month\",\"Numbers of orders by category per quarter\",\"Orders according to sources per quarter\",\"Orders by source per age group\",\"Orders by source per individual age\",\"Orders with People\",\"People with age\",\"Product category orders per age group\",\"Product category orders per individual age\",\"Revenue and orders over time\",\"Revenue by state\",\"Revenue goal for this quarter\",\"Revenue per age group\",\"Revenue per individual age\",\"Revenue per quarter\",\"Total orders by category\",\"Unique customers per month\",\"Value of orders over time (before taxes)\",\"三日时分同比\",\"三日流水时分同比\",\"主播当日收入榜\",\"当日流水\",\"每日收入明细\"]',NULL,575,_binary '\0','full',NULL,'2024-06-19 14:19:00.344255'),(171,'2024-06-19 14:19:00.393001','2024-06-19 14:19:00.393001','[\"[]\"]',NULL,581,_binary '\0','full',NULL,'2024-06-19 14:19:00.393001'),(172,'2024-06-19 14:19:00.431592','2024-06-19 14:19:00.431592','[\"[]\"]',NULL,583,_binary '\0','full',NULL,'2024-06-19 14:19:00.431592'),(173,'2024-06-19 14:19:00.474676','2024-06-19 14:19:00.474676','[null]',NULL,587,_binary '\0','full',NULL,'2024-06-19 14:19:00.474676'),(174,'2024-06-19 14:19:00.528773','2024-06-19 21:00:09.592057','[\"native\",\"query\"]',NULL,573,_binary '\0','full',NULL,'2024-06-19 14:19:00.528773'),(175,'2024-06-19 14:19:00.589968','2024-07-03 21:00:08.370282','[\"[{\\\"description\\\":\\\"A unique identifier given to each user.\\\",\\\"semantic_type\\\":\\\"type/PK\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"ID\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",46,null],\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"id\\\":46,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"ID\\\",\\\"fingerprint\\\":null,\\\"base_type\\\":\\\"type/BigInteger\\\"},{\\\"description\\\":\\\"The street address of the account’s billing address\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"ADDRESS\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",52,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":52,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Address\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2490,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":20.85}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The contact email for the account.\\\",\\\"semantic_type\\\":\\\"type/Email\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"EMAIL\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",51,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":51,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Email\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":1.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":24.1824}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"This is the salted password of the user. It should not be visible\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"PASSWORD\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",53,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":53,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Password\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":36.0}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The name of the user who owns an account\\\",\\\"semantic_type\\\":\\\"type/Name\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"NAME\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",47,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":47,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Name\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2499,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":13.532}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The city of the account’s billing address\\\",\\\"semantic_type\\\":\\\"type/City\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CITY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",55,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":55,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"City\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":1966,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.002,\\\"average-length\\\":8.284}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"This is the longitude of the user on sign-up. It might be updated in the future to the last seen location.\\\",\\\"semantic_type\\\":\\\"type/Longitude\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"LONGITUDE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",50,null],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":50,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Longitude\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2491,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-166.5425726,\\\"q1\\\":-101.58350792373135,\\\"q3\\\":-84.65289348288829,\\\"max\\\":-67.96735199999999,\\\"sd\\\":15.399698968175663,\\\"avg\\\":-95.18741780363999}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"The state or province of the account’s billing address\\\",\\\"semantic_type\\\":\\\"type/State\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"STATE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",48,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":48,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"State\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":49,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":1.0,\\\"average-length\\\":2.0}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\\\",\\\"semantic_type\\\":\\\"type/Source\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"SOURCE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",45,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":45,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Source\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.4084}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The date of birth of the user\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"default\\\",\\\"name\\\":\\\"BIRTH_DATE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",49,{\\\"temporal-unit\\\":\\\"default\\\"}],\\\"effective_type\\\":\\\"type/Date\\\",\\\"id\\\":49,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Birth Date\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2308,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"1958-04-26\\\",\\\"latest\\\":\\\"2000-04-03\\\"}}},\\\"base_type\\\":\\\"type/Date\\\"},{\\\"description\\\":\\\"The postal code of the account’s billing address\\\",\\\"semantic_type\\\":\\\"type/ZipCode\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"ZIP\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",54,null],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":54,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Zip\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2234,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.0}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"This is the latitude of the user on sign-up. It might be updated in the future to the last seen location.\\\",\\\"semantic_type\\\":\\\"type/Latitude\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"LATITUDE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",57,null],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":57,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Latitude\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2491,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":25.775827,\\\"q1\\\":35.302705923023126,\\\"q3\\\":43.773802584662,\\\"max\\\":70.6355001,\\\"sd\\\":6.390832341883712,\\\"avg\\\":39.87934670484002}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"The date the user record was created. Also referred to as the user’s \\\\\\\"join date\\\\\\\"\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"default\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",56,{\\\"temporal-unit\\\":\\\"default\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":56,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-19T21:35:18.752Z\\\",\\\"latest\\\":\\\"2025-04-19T14:06:27.3Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Age\\\",\\\"field_ref\\\":[\\\"expression\\\",\\\"Age\\\"],\\\"name\\\":\\\"Age\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":42,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24.0,\\\"q1\\\":33.340572873934306,\\\"q3\\\":55.17166516756599,\\\"max\\\":65.0,\\\"sd\\\":12.263883782175668,\\\"avg\\\":44.434}}}}]\",\"[{\\\"description\\\":\\\"The average rating users have given the product. This ranges from 1 - 5\\\",\\\"semantic_type\\\":\\\"type/Score\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"RATING\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",61,{\\\"base-type\\\":\\\"type/Float\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":61,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Rating\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":23,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":3.5120465053408525,\\\"q3\\\":4.216124969497314,\\\"max\\\":5.0,\\\"sd\\\":1.3605488657451452,\\\"avg\\\":3.4715}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":58,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":57,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":70.0,\\\"q1\\\":105.0,\\\"q3\\\":370.0,\\\"max\\\":1093.0,\\\"sd\\\":229.88812521865958,\\\"avg\\\":281.6060606060606}}}}]\",\"[{\\\"description\\\":\\\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"pivot-grouping\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"expression\\\",\\\"pivot-grouping\\\"],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":45,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"pivot-grouping\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":3.0,\\\"q1\\\":3.0,\\\"q3\\\":3.0,\\\"max\\\":3.0,\\\"sd\\\":null,\\\"avg\\\":3.0}}},\\\"base_type\\\":\\\"type/Integer\\\"},{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"sum\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Sum of Subtotal\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":379867.38872485986,\\\"q1\\\":379867.38872485986,\\\"q3\\\":379867.38872485986,\\\"max\\\":379867.38872485986,\\\"sd\\\":null,\\\"avg\\\":379867.38872485986}}},\\\"base_type\\\":\\\"type/Float\\\"}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Quantity\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":7,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":3.25,\\\"q3\\\":6.0,\\\"max\\\":74.0,\\\"sd\\\":22.086949389477336,\\\"avg\\\":11.5}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Quantity\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":7,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1.0,\\\"q1\\\":2.5,\\\"q3\\\":9.414213562373096,\\\"max\\\":10.0,\\\"sd\\\":3.693623849670827,\\\"avg\\\":5.75}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":58,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Sum of Subtotal\\\",\\\"semantic_type\\\":null,\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":96,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":194.15721878715678,\\\"q1\\\":1682.037094502916,\\\"q3\\\":5250.149916853326,\\\"max\\\":10113.40941589646,\\\"sd\\\":2757.8851826916916,\\\"avg\\\":3956.9519658839577}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Quantity\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":11,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":3.0,\\\"q1\\\":4.76393202250021,\\\"q3\\\":17.0,\\\"max\\\":21.0,\\\"sd\\\":6.199964551476116,\\\"avg\\\":10.142857142857142}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Total\\\",\\\"semantic_type\\\":null,\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":24,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1265.7162964063327,\\\"q1\\\":7814.799491244121,\\\"q3\\\":21566.481581896165,\\\"max\\\":38569.69761756364,\\\"sd\\\":11384.837065416124,\\\"avg\\\":16481.762292966578}}}},{\\\"display_name\\\":\\\"Sum of Quantity\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",1],\\\"name\\\":\\\"sum_2\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":24,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":75.0,\\\"q1\\\":369.0,\\\"q3\\\":1286.0,\\\"max\\\":2260.0,\\\"sd\\\":630.7594628699596,\\\"avg\\\":877.25}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Quantity\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":487.0,\\\"q1\\\":487.0,\\\"q3\\\":1330.0,\\\"max\\\":1330.0,\\\"sd\\\":596.0910165402596,\\\"avg\\\":908.5}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"quarter\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Discount\\\",\\\"semantic_type\\\":\\\"type/Discount\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":738.5575011690233,\\\"q1\\\":738.5575011690233,\\\"q3\\\":795.9833992557524,\\\"max\\\":795.9833992557524,\\\"sd\\\":40.606241952853686,\\\"avg\\\":767.2704502123879}}}}]\",\"[{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"quarter\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Sum of Total\\\",\\\"semantic_type\\\":null,\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":67863.39650548704,\\\"q1\\\":67863.39650548704,\\\"q3\\\":111121.25780141751,\\\"max\\\":111121.25780141751,\\\"sd\\\":30587.92706197953,\\\"avg\\\":89492.32715345226}}}}]\",\"[{\\\"description\\\":\\\"The date the user record was created. Also referred to as the user’s \\\\\\\"join date\\\\\\\"\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"month\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",56,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"month\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":56,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2500,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-19T21:35:18.752Z\\\",\\\"latest\\\":\\\"2025-04-19T14:06:27.3Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Distinct values of Name\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":2,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":70.0,\\\"q1\\\":70.0,\\\"q3\\\":76.0,\\\"max\\\":76.0,\\\"sd\\\":4.242640687119285,\\\"avg\\\":73.0}}}}]\",\"[{\\\"description\\\":\\\"The name of the product as it should be displayed to customers.\\\",\\\"semantic_type\\\":\\\"type/Title\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"TITLE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",65,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":65,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Title\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":199,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":21.495}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":58,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"count\\\",{\\\"base-type\\\":\\\"type/Integer\\\"}],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":8,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":109.0,\\\"q1\\\":109.36150801752578,\\\"q3\\\":117.41886116991581,\\\"max\\\":120.0,\\\"sd\\\":4.254710813035841,\\\"avg\\\":113.53846153846153}}}}]\",\"[{\\\"description\\\":\\\"The state or province of the account’s billing address\\\",\\\"semantic_type\\\":\\\"type/State\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"STATE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":48,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"User → State\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":49,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":1.0,\\\"average-length\\\":2.0}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Sum of Total\\\",\\\"semantic_type\\\":null,\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":48,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":1358.6880585850759,\\\"q1\\\":14606.102496036605,\\\"q3\\\":45423.71594332504,\\\"max\\\":108466.5974651383,\\\"sd\\\":21267.69039176716,\\\"avg\\\":31471.285063554824}}}}]\",\"[{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":58,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"quarter\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":34,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":13.0,\\\"q1\\\":81.0,\\\"q3\\\":259.5,\\\"max\\\":338.0,\\\"sd\\\":102.85448188797824,\\\"avg\\\":169.38888888888889}}}}]\",\"[{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":58,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":3976.0,\\\"q1\\\":4380.0,\\\"q3\\\":5000.0,\\\"max\\\":5061.0,\\\"sd\\\":489.3103990992493,\\\"avg\\\":4690.0}}}}]\",\"[{\\\"description\\\":\\\"This is a unique ID for the product. It is also called the “Invoice number” or “Confirmation number” in customer facing emails and screens.\\\",\\\"semantic_type\\\":\\\"type/PK\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"ID\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",37,null],\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"id\\\":37,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"ID\\\",\\\"fingerprint\\\":null,\\\"base_type\\\":\\\"type/BigInteger\\\"},{\\\"description\\\":\\\"The id of the user who made this order. Note that in some cases where an order was created on behalf of a customer who phoned the order in, this might be the employee who handled the request.\\\",\\\"semantic_type\\\":\\\"type/FK\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"USER_ID\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":46,\\\"field_ref\\\":[\\\"field\\\",43,null],\\\"effective_type\\\":\\\"type/Integer\\\",\\\"id\\\":43,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"User ID\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":929,\\\"nil%\\\":0}},\\\"base_type\\\":\\\"type/Integer\\\"},{\\\"description\\\":\\\"The product ID. This is an internal identifier for the product, NOT the SKU.\\\",\\\"semantic_type\\\":\\\"type/FK\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"PRODUCT_ID\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":62,\\\"field_ref\\\":[\\\"field\\\",40,null],\\\"effective_type\\\":\\\"type/Integer\\\",\\\"id\\\":40,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product ID\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":200,\\\"nil%\\\":0}},\\\"base_type\\\":\\\"type/Integer\\\"},{\\\"description\\\":\\\"The raw, pre-tax cost of the order. Note that this might be different in the future from the product price due to promotions, credits, etc.\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"SUBTOTAL\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",44,null],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":44,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Subtotal\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":340,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":15.691943673970439,\\\"q1\\\":49.74894519060184,\\\"q3\\\":105.42965746993103,\\\"max\\\":148.22900526552291,\\\"sd\\\":32.53705013056317,\\\"avg\\\":77.01295465356547}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"This is the amount of local and federal taxes that are collected on the purchase. Note that other governmental fees on some products are not included here, but instead are accounted for in the subtotal.\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"TAX\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",38,null],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":38,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Tax\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":797,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0,\\\"q1\\\":2.273340386603857,\\\"q3\\\":5.337275338216307,\\\"max\\\":11.12,\\\"sd\\\":2.3206651358900316,\\\"avg\\\":3.8722100000000004}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"The total billed amount.\\\",\\\"semantic_type\\\":null,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"TOTAL\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",42,null],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":42,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Total\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4426,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":8.93914247937167,\\\"q1\\\":51.34535490743823,\\\"q3\\\":110.29428389265787,\\\"max\\\":159.34900526552292,\\\"sd\\\":34.26469575709948,\\\"avg\\\":80.35871658771228}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"Discount amount.\\\",\\\"semantic_type\\\":\\\"type/Discount\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"DISCOUNT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",36,null],\\\"effective_type\\\":\\\"type/Float\\\",\\\"id\\\":36,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Discount\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":701,\\\"nil%\\\":0.898},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.17088996672584322,\\\"q1\\\":2.9786226681458743,\\\"q3\\\":7.338187788658235,\\\"max\\\":61.69684269960571,\\\"sd\\\":3.053663125001991,\\\"avg\\\":5.161255547580326}}},\\\"base_type\\\":\\\"type/Float\\\"},{\\\"description\\\":\\\"The date and time an order was submitted.\\\",\\\"semantic_type\\\":\\\"type/CreationTimestamp\\\",\\\"coercion_strategy\\\":null,\\\"unit\\\":\\\"default\\\",\\\"name\\\":\\\"CREATED_AT\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",41,{\\\"temporal-unit\\\":\\\"default\\\"}],\\\"effective_type\\\":\\\"type/DateTime\\\",\\\"id\\\":41,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Created At\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":10001,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2022-04-30T18:56:13.352Z\\\",\\\"latest\\\":\\\"2026-04-19T14:07:15.657Z\\\"}}},\\\"base_type\\\":\\\"type/DateTime\\\"},{\\\"description\\\":\\\"Number of products bought.\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"QUANTITY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",39,null],\\\"effective_type\\\":\\\"type/Integer\\\",\\\"id\\\":39,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Quantity\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":62,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0,\\\"q1\\\":1.755882607764982,\\\"q3\\\":4.882654507928044,\\\"max\\\":100,\\\"sd\\\":4.214258386403798,\\\"avg\\\":3.7015}}},\\\"base_type\\\":\\\"type/Integer\\\"},{\\\"display_name\\\":\\\"Age\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"Age\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":42,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24,\\\"q1\\\":33.36752836803635,\\\"q3\\\":55.20362176071121,\\\"max\\\":65,\\\"sd\\\":12.063315373018085,\\\"avg\\\":44.572}}},\\\"semantic_type\\\":null}]\",\"[{\\\"display_name\\\":\\\"Age\\\",\\\"field_ref\\\":[\\\"expression\\\",\\\"Age\\\"],\\\"name\\\":\\\"Age\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24.0,\\\"q1\\\":34.15,\\\"q3\\\":55.45,\\\"max\\\":66.0,\\\"sd\\\":12.328008896346248,\\\"avg\\\":44.80281690140845}}}},{\\\"description\\\":\\\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\\\",\\\"semantic_type\\\":\\\"type/Source\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"SOURCE\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":45,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"People - User → Source\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.4084}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":111,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":14.0,\\\"q1\\\":61.30452018978108,\\\"q3\\\":110.7900825561565,\\\"max\\\":214.0,\\\"sd\\\":36.95993697001328,\\\"avg\\\":88.07511737089202}}}}]\",\"[{\\\"display_name\\\":\\\"Age\\\",\\\"field_ref\\\":[\\\"expression\\\",\\\"Age\\\"],\\\"name\\\":\\\"Age\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24.0,\\\"q1\\\":34.25,\\\"q3\\\":55.75,\\\"max\\\":66.0,\\\"sd\\\":12.445906346880554,\\\"avg\\\":45.0}}}},{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"id\\\":58,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Product → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\"},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":84,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":11.0,\\\"q1\\\":95.5,\\\"q3\\\":124.48331477354789,\\\"max\\\":204.0,\\\"sd\\\":28.015985634286857,\\\"avg\\\":109.06976744186046}}}}]\",\"[{\\\"display_name\\\":\\\"Age\\\",\\\"field_ref\\\":[\\\"expression\\\",\\\"Age\\\"],\\\"name\\\":\\\"Age\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24.0,\\\"q1\\\":34.25,\\\"q3\\\":55.75,\\\"max\\\":66.0,\\\"sd\\\":12.556538801224908,\\\"avg\\\":45.0}}}},{\\\"display_name\\\":\\\"Sum of Total\\\",\\\"semantic_type\\\":null,\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":43,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":4158.786206744129,\\\"q1\\\":31397.769615345165,\\\"q3\\\":38764.15212640109,\\\"max\\\":58676.42899556268,\\\"sd\\\":8106.619825736762,\\\"avg\\\":35130.73681513096}}}}]\",\"[{\\\"display_name\\\":\\\"Age\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10,\\\"min-value\\\":20,\\\"max-value\\\":65,\\\"bin-width\\\":5}}],\\\"name\\\":\\\"Age\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":42,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24,\\\"q1\\\":33.340572873934306,\\\"q3\\\":55.17166516756599,\\\"max\\\":65,\\\"sd\\\":12.263883782175668,\\\"avg\\\":44.434}}},\\\"semantic_type\\\":null},{\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"count\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":9,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":61,\\\"q1\\\":270,\\\"q3\\\":304,\\\"max\\\":334,\\\"sd\\\":99.91663191547909,\\\"avg\\\":250}}}}]\",\"[{\\\"display_name\\\":\\\"Average of Rating\\\",\\\"semantic_type\\\":\\\"type/Score\\\",\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"avg\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":3.4715,\\\"q1\\\":3.4715,\\\"q3\\\":3.4715,\\\"max\\\":3.4715,\\\"sd\\\":null,\\\"avg\\\":3.4715}}}}]\",\"[{\\\"display_name\\\":\\\"Cumulative sum of Total\\\",\\\"semantic_type\\\":null,\\\"settings\\\":null,\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"name\\\":\\\"sum\\\",\\\"base_type\\\":\\\"type/Float\\\",\\\"effective_type\\\":\\\"type/Float\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":123889.60365320997,\\\"q1\\\":123889.60365320997,\\\"q3\\\":123889.60365320997,\\\"max\\\":123889.60365320997,\\\"sd\\\":null,\\\"avg\\\":123889.60365320997}}}}]\",\"[{\\\"display_name\\\":\\\"flow/100\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"flow/100\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"flow/100\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":1,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":22716.04,\\\"q1\\\":22716.04,\\\"q3\\\":22716.04,\\\"max\\\":22716.04,\\\"sd\\\":null,\\\"avg\\\":22716.04}}}}]\",\"[{\\\"display_name\\\":\\\"主播mid\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"主播mid\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"主播mid\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":76,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":11.0,\\\"q1\\\":119.21494573814783,\\\"q3\\\":270235.5,\\\"max\\\":358886.0,\\\"sd\\\":135248.34163189933,\\\"avg\\\":147879.56578947368}}}},{\\\"display_name\\\":\\\"主播user_id\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"主播user_id\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"主播user_id\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":76,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":110208.0,\\\"q1\\\":335144.5,\\\"q3\\\":774264.5,\\\"max\\\":983565.0,\\\"sd\\\":257255.55730095622,\\\"avg\\\":570996.75}}}},{\\\"display_name\\\":\\\"主播昵称\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"主播昵称\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"主播昵称\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":76,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":4.421052631578948}}}},{\\\"display_name\\\":\\\"主播收入(钻石)\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"主播收入(钻石)\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"主播收入(钻石)\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":60,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":155.0,\\\"q3\\\":729.0,\\\"max\\\":36180.0,\\\"sd\\\":6324.339636174215,\\\"avg\\\":2183.0789473684213}}}}]\",\"[{\\\"display_name\\\":\\\"时间\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"时间\\\",{\\\"base-type\\\":\\\"type/DateTimeWithLocalTZ\\\"}],\\\"name\\\":\\\"时间\\\",\\\"base_type\\\":\\\"type/DateTimeWithLocalTZ\\\",\\\"effective_type\\\":\\\"type/DateTimeWithLocalTZ\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":80,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"2024-04-15T00:00:00+08:00\\\",\\\"latest\\\":\\\"2024-07-03T00:00:00+08:00\\\"}}}},{\\\"display_name\\\":\\\"会员数\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"会员数\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"会员数\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":39,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":4.0,\\\"q1\\\":9.23013858660781,\\\"q3\\\":29.5,\\\"max\\\":307.0,\\\"sd\\\":50.63239944361438,\\\"avg\\\":35.075}}}},{\\\"display_name\\\":\\\"会员流水\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"会员流水\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"会员流水\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":39,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":196.0,\\\"q1\\\":452.27679074378267,\\\"q3\\\":1445.5,\\\"max\\\":15043.0,\\\"sd\\\":2480.9875727371045,\\\"avg\\\":1718.675}}}},{\\\"display_name\\\":\\\"空间解锁数\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间解锁数\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"空间解锁数\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":68,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":121.5,\\\"q3\\\":745.5,\\\"max\\\":2711.0,\\\"sd\\\":605.4061592075556,\\\"avg\\\":557.4}}}},{\\\"display_name\\\":\\\"空间解锁流水\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间解锁流水\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"空间解锁流水\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":71,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":8882.5,\\\"q3\\\":24252.350796039722,\\\"max\\\":50177.0,\\\"sd\\\":11685.612267017832,\\\"avg\\\":16512.2625}}}},{\\\"display_name\\\":\\\"空间超粉数\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间超粉数\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"空间超粉数\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":18,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.5432235637169979,\\\"q3\\\":9.279240779943873,\\\"max\\\":22.0,\\\"sd\\\":5.3567507391153315,\\\"avg\\\":5.8375}}}},{\\\"display_name\\\":\\\"空间超粉流水\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间超粉流水\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"空间超粉流水\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":58,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":165.53323086318386,\\\"q3\\\":6052.5,\\\"max\\\":13260.0,\\\"sd\\\":3626.384291253218,\\\"avg\\\":3479.9}}}},{\\\"display_name\\\":\\\"空间动态数\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间动态数\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"空间动态数\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":65,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":52.0,\\\"q3\\\":496.0,\\\"max\\\":1802.0,\\\"sd\\\":303.0292590766444,\\\"avg\\\":308.125}}}},{\\\"display_name\\\":\\\"空间动态流水\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间动态流水\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"空间动态流水\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":67,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":5357.071247280614,\\\"q3\\\":13479.5,\\\"max\\\":26617.0,\\\"sd\\\":6251.27090162017,\\\"avg\\\":8974.475}}}},{\\\"display_name\\\":\\\"其他数(微信+金币)\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"其他数(微信+金币)\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"其他数(微信+金币)\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":41,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":8.82842712474619,\\\"q3\\\":29.0,\\\"max\\\":53.0,\\\"sd\\\":12.884860117718183,\\\"avg\\\":18.925}}}},{\\\"display_name\\\":\\\"其他流水(微信+金币)\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"其他流水(微信+金币)\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"其他流水(微信+金币)\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":75,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":1032.6590249791168,\\\"q3\\\":4516.0,\\\"max\\\":13801.0,\\\"sd\\\":2839.3824462747325,\\\"avg\\\":3155.8375}}}},{\\\"display_name\\\":\\\"总流水\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"总流水\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"总流水\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":80,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":196.0,\\\"q1\\\":22211.01189595526,\\\"q3\\\":52371.5,\\\"max\\\":85854.0,\\\"sd\\\":22564.819345914184,\\\"avg\\\":33841.15}}}},{\\\"display_name\\\":\\\"主播分成\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"主播分成\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"主播分成\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":78,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":83.0,\\\"q1\\\":13688.926122272083,\\\"q3\\\":39726.02020253553,\\\"max\\\":67028.0,\\\"sd\\\":17758.300888006026,\\\"avg\\\":25366.0875}}}},{\\\"display_name\\\":\\\"净收入\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"净收入\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\"}],\\\"name\\\":\\\"净收入\\\",\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":80,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":-241.0,\\\"q1\\\":6153.5,\\\"q3\\\":11794.5,\\\"max\\\":25701.0,\\\"sd\\\":5356.920404061795,\\\"avg\\\":8475.0625}}}},{\\\"display_name\\\":\\\"利润率\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"利润率\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"利润率\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":79,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.9375}}}},{\\\"display_name\\\":\\\"会员流水占比\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"会员流水占比\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"会员流水占比\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":71,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.1625}}}},{\\\"display_name\\\":\\\"空间解锁占比\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间解锁占比\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"空间解锁占比\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":71,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.3875}}}},{\\\"display_name\\\":\\\"空间超粉占比\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间超粉占比\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"空间超粉占比\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":58,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":4.5}}}},{\\\"display_name\\\":\\\"空间动态占比\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"空间动态占比\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"空间动态占比\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":66,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.25}}}},{\\\"display_name\\\":\\\"其他占比\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"其他占比\\\",{\\\"base-type\\\":\\\"type/Text\\\"}],\\\"name\\\":\\\"其他占比\\\",\\\"base_type\\\":\\\"type/Text\\\",\\\"effective_type\\\":\\\"type/Text\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":77,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":5.175}}}}]\",\"[{\\\"display_name\\\":\\\"时间\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"时间\\\",{\\\"base-type\\\":\\\"type/Time\\\"}],\\\"name\\\":\\\"时间\\\",\\\"base_type\\\":\\\"type/Time\\\",\\\"effective_type\\\":\\\"type/Time\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":288,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"00:00:00+08:00\\\",\\\"latest\\\":\\\"23:55:00+08:00\\\"}}}},{\\\"display_name\\\":\\\"前天\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"前天\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"前天\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":286,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":19621.866686248843,\\\"q3\\\":56075.32250000001,\\\"max\\\":70776.82,\\\"sd\\\":19799.369850403622,\\\"avg\\\":37145.63506944445}}}},{\\\"display_name\\\":\\\"昨天\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"昨天\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"昨天\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":287,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":15323.414082724074,\\\"q3\\\":57720.24766030573,\\\"max\\\":72219.92,\\\"sd\\\":22498.958037008044,\\\"avg\\\":35904.26038194444}}}},{\\\"display_name\\\":\\\"今天\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"今天\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"今天\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":107,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":11087.168333333333,\\\"max\\\":17222.2,\\\"sd\\\":6081.903195444214,\\\"avg\\\":4361.703784722222}}}}]\",\"[{\\\"display_name\\\":\\\"时间\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"时间\\\",{\\\"base-type\\\":\\\"type/Time\\\"}],\\\"name\\\":\\\"时间\\\",\\\"base_type\\\":\\\"type/Time\\\",\\\"effective_type\\\":\\\"type/Time\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":288,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/DateTime\\\":{\\\"earliest\\\":\\\"00:00:00+08:00\\\",\\\"latest\\\":\\\"23:55:00+08:00\\\"}}}},{\\\"display_name\\\":\\\"前天\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"前天\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"前天\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":270,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":12398.445748047536,\\\"q3\\\":34251.14292898093,\\\"max\\\":55173.3,\\\"sd\\\":13337.228720674084,\\\"avg\\\":23816.550659722227}}}},{\\\"display_name\\\":\\\"昨天\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"昨天\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"昨天\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":277,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":16093.808321146662,\\\"q3\\\":48737.18947351832,\\\"max\\\":67916.82,\\\"sd\\\":17625.056385085732,\\\"avg\\\":33038.760972222226}}}},{\\\"display_name\\\":\\\"今天\\\",\\\"field_ref\\\":[\\\"field\\\",\\\"今天\\\",{\\\"base-type\\\":\\\"type/Decimal\\\"}],\\\"name\\\":\\\"今天\\\",\\\"base_type\\\":\\\"type/Decimal\\\",\\\"effective_type\\\":\\\"type/Decimal\\\",\\\"semantic_type\\\":null,\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":50,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":0.0,\\\"q1\\\":0.0,\\\"q3\\\":1642.8829212631874,\\\"max\\\":22473.04,\\\"sd\\\":6186.611414069903,\\\"avg\\\":2559.8475694444446}}}}]\",\"[{\\\"field_ref\\\":[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10,\\\"min-value\\\":20.0,\\\"max-value\\\":65.0,\\\"bin-width\\\":5.0}}],\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"name\\\":\\\"Age\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"display_name\\\":\\\"Age\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":42,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24,\\\"q1\\\":33.36752836803635,\\\"q3\\\":55.20362176071121,\\\"max\\\":65,\\\"sd\\\":12.063315373018085,\\\"avg\\\":44.572}}},\\\"binning_info\\\":{\\\"num_bins\\\":10,\\\"min_value\\\":20.0,\\\"max_value\\\":65.0,\\\"bin_width\\\":5.0,\\\"binning_strategy\\\":\\\"num-bins\\\"},\\\"source\\\":\\\"breakout\\\"},{\\\"description\\\":\\\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\\\",\\\"semantic_type\\\":\\\"type/Category\\\",\\\"table_id\\\":8,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"CATEGORY\\\",\\\"settings\\\":null,\\\"source\\\":\\\"breakout\\\",\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"Products\\\"}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"nfc_path\\\":null,\\\"parent_id\\\":null,\\\"id\\\":58,\\\"position\\\":3,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"Products → Category\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":4,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":6.375}}},\\\"base_type\\\":\\\"type/Text\\\",\\\"source_alias\\\":\\\"Products\\\"},{\\\"base_type\\\":\\\"type/Integer\\\",\\\"name\\\":\\\"count\\\",\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"source\\\":\\\"aggregation\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"aggregation_index\\\":0}]\",\"[{\\\"field_ref\\\":[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10,\\\"min-value\\\":20.0,\\\"max-value\\\":65.0,\\\"bin-width\\\":5.0}}],\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"name\\\":\\\"Age\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"display_name\\\":\\\"Age\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":42,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24,\\\"q1\\\":33.36752836803635,\\\"q3\\\":55.20362176071121,\\\"max\\\":65,\\\"sd\\\":12.063315373018085,\\\"avg\\\":44.572}}},\\\"binning_info\\\":{\\\"num_bins\\\":10,\\\"min_value\\\":20.0,\\\"max_value\\\":65.0,\\\"bin_width\\\":5.0,\\\"binning_strategy\\\":\\\"num-bins\\\"},\\\"source\\\":\\\"breakout\\\"},{\\\"description\\\":\\\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\\\",\\\"semantic_type\\\":\\\"type/Source\\\",\\\"table_id\\\":3,\\\"coercion_strategy\\\":null,\\\"name\\\":\\\"SOURCE\\\",\\\"settings\\\":null,\\\"source\\\":\\\"breakout\\\",\\\"fk_target_field_id\\\":null,\\\"field_ref\\\":[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}],\\\"effective_type\\\":\\\"type/Text\\\",\\\"nfc_path\\\":null,\\\"parent_id\\\":null,\\\"id\\\":45,\\\"position\\\":8,\\\"visibility_type\\\":\\\"normal\\\",\\\"display_name\\\":\\\"People - User → Source\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":5,\\\"nil%\\\":0.0},\\\"type\\\":{\\\"type/Text\\\":{\\\"percent-json\\\":0.0,\\\"percent-url\\\":0.0,\\\"percent-email\\\":0.0,\\\"percent-state\\\":0.0,\\\"average-length\\\":7.4084}}},\\\"base_type\\\":\\\"type/Text\\\",\\\"source_alias\\\":\\\"People - User\\\"},{\\\"base_type\\\":\\\"type/Integer\\\",\\\"name\\\":\\\"count\\\",\\\"display_name\\\":\\\"Count\\\",\\\"semantic_type\\\":\\\"type/Quantity\\\",\\\"source\\\":\\\"aggregation\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"aggregation_index\\\":0}]\",\"[{\\\"field_ref\\\":[\\\"field\\\",\\\"Age\\\",{\\\"base-type\\\":\\\"type/BigInteger\\\",\\\"binning\\\":{\\\"strategy\\\":\\\"num-bins\\\",\\\"num-bins\\\":10,\\\"min-value\\\":20.0,\\\"max-value\\\":65.0,\\\"bin-width\\\":5.0}}],\\\"base_type\\\":\\\"type/BigInteger\\\",\\\"name\\\":\\\"Age\\\",\\\"effective_type\\\":\\\"type/BigInteger\\\",\\\"display_name\\\":\\\"Age\\\",\\\"fingerprint\\\":{\\\"global\\\":{\\\"distinct-count\\\":42,\\\"nil%\\\":0},\\\"type\\\":{\\\"type/Number\\\":{\\\"min\\\":24,\\\"q1\\\":33.36752836803635,\\\"q3\\\":55.20362176071121,\\\"max\\\":65,\\\"sd\\\":12.063315373018085,\\\"avg\\\":44.572}}},\\\"binning_info\\\":{\\\"num_bins\\\":10,\\\"min_value\\\":20.0,\\\"max_value\\\":65.0,\\\"bin_width\\\":5.0,\\\"binning_strategy\\\":\\\"num-bins\\\"},\\\"source\\\":\\\"breakout\\\"},{\\\"base_type\\\":\\\"type/Float\\\",\\\"name\\\":\\\"sum\\\",\\\"display_name\\\":\\\"Sum of Total\\\",\\\"source\\\":\\\"aggregation\\\",\\\"field_ref\\\":[\\\"aggregation\\\",0],\\\"aggregation_index\\\":0}]\"]',NULL,577,_binary '\0','full',NULL,'2024-06-19 14:19:00.589968'),(176,'2024-06-19 14:19:00.642625','2024-06-19 14:19:00.642625','[\"model\",\"question\"]',NULL,561,_binary '\0','full',NULL,'2024-06-19 14:19:00.642625'),(177,'2024-06-19 14:19:00.680065','2024-07-03 21:00:08.419634','[0,3,340,1415,1427,1548]',NULL,565,_binary '\0','full',NULL,'2024-06-19 14:19:00.680065'),(178,'2024-06-19 14:19:00.728218','2024-06-30 21:00:08.241068','[\"{\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"flow/100\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}}\",\"{\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"时间\\\\\\\"]\\\":{\\\"time_style\\\":\\\"HH:mm\\\",\\\"date_style\\\":\\\"YYYY/M/D\\\"}},\\\"table.cell_column\\\":\\\"会员数\\\"}\",\"{\\\"column_settings\\\":null,\\\"gauge.segments\\\":[{\\\"color\\\":\\\"#EF8C8C\\\",\\\"label\\\":\\\"awful\\\",\\\"max\\\":1,\\\"min\\\":0},{\\\"color\\\":\\\"#F2A86F\\\",\\\"label\\\":\\\"bad\\\",\\\"max\\\":2,\\\"min\\\":1},{\\\"color\\\":\\\"#F9D45C\\\",\\\"label\\\":\\\"alright\\\",\\\"max\\\":3,\\\"min\\\":2},{\\\"color\\\":\\\"#A7D07C\\\",\\\"label\\\":\\\"good\\\",\\\"max\\\":4,\\\"min\\\":3},{\\\"color\\\":\\\"#689636\\\",\\\"label\\\":\\\"great\\\",\\\"max\\\":5,\\\"min\\\":4}],\\\"table.cell_column\\\":\\\"avg\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.x_axis.labels_enabled\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"SOURCE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.x_axis.labels_enabled\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"SOURCE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\"],\\\"graph.metrics\\\":[\\\"sum\\\",\\\"sum_2\\\"],\\\"graph.show_trendline\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Orders date\\\",\\\"graph.y_axis.title_text\\\":\\\"Revenue\\\",\\\"series_settings\\\":{\\\"sum\\\":{\\\"display\\\":\\\"line\\\",\\\"line.interpolate\\\":\\\"linear\\\",\\\"line.marker_enabled\\\":false,\\\"show_series_values\\\":true,\\\"title\\\":\\\"Revenue\\\"},\\\"sum_2\\\":{\\\"color\\\":\\\"#51528D\\\",\\\"title\\\":\\\"Number of orders\\\"}}}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"RATING\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.title_text\\\":\\\"Products\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"graph.y_axis.title_text\\\":\\\"total orders\\\",\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.pivot\\\":false}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"TITLE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.x_axis.title_text\\\":\\\"Products\\\",\\\"graph.y_axis.title_text\\\":\\\"total orders\\\",\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"table.pivot\\\":false}\",\"{\\\"column_settings\\\":null,\\\"map.colors\\\":[\\\"#e5e5f1\\\",\\\"#c0c0da\\\",\\\"#9b9cc3\\\",\\\"#7677ab\\\",\\\"hsl(239, 29.5%, 39.3%)\\\"]}\",\"{\\\"column_settings\\\":null,\\\"pie.colors\\\":{\\\"Doohickey\\\":\\\"#7172AD\\\",\\\"Gadget\\\":\\\"#A989C5\\\",\\\"Gizmo\\\":\\\"#C7EAEA\\\",\\\"Widget\\\":\\\"#227FD2\\\"}}\",\"{\\\"column_settings\\\":null,\\\"progress.goal\\\":120000}\",\"{\\\"column_settings\\\":null}\",\"{\\\"graph.dimensions\\\":[\\\"age\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"table.pivot_column\\\":\\\"SOURCE\\\",\\\"table.cell_column\\\":\\\"LONGITUDE\\\"}\",\"{\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#A989C5\\\"}},\\\"graph.series_order_dimension\\\":null,\\\"graph.series_order\\\":null,\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.y_axis.title_text\\\":\\\"Buyers\\\"}\",\"{\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"table.pivot_column\\\":\\\"CATEGORY\\\",\\\"table.cell_column\\\":\\\"count\\\"}\",\"{\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"SOURCE\\\"],\\\"graph.series_labels\\\":[null],\\\"pivot_table.column_split\\\":{\\\"columns\\\":[[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]],\\\"rows\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"values\\\":[[\\\"aggregation\\\",0]]},\\\"pivot_table.column_widths\\\":{\\\"leftHeaderWidths\\\":[141],\\\"totalLeftHeaderWidths\\\":141,\\\"valueHeaderWidths\\\":{}},\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.column_formatting\\\":[{\\\"color\\\":\\\"#A7D07C\\\",\\\"columns\\\":[\\\"sum\\\"],\\\"highlight_row\\\":false,\\\"operator\\\":\\\">\\\",\\\"type\\\":\\\"single\\\",\\\"value\\\":20000}],\\\"graph.metrics\\\":[\\\"sum\\\"]}\",\"{\\\"graph.show_goal\\\":false,\\\"graph.show_trendline\\\":false,\\\"graph.show_values\\\":true,\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":\\\"rotate-90\\\",\\\"graph.y_axis.scale\\\":\\\"linear\\\",\\\"graph.label_value_frequency\\\":\\\"fit\\\",\\\"graph.metrics\\\":[\\\"前天\\\",\\\"昨天\\\",\\\"今天\\\"],\\\"graph.y_axis.axis_enabled\\\":true,\\\"graph.label_value_formatting\\\":\\\"auto\\\",\\\"graph.series_order\\\":null,\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"t\\\\\\\"]\\\":{\\\"time_enabled\\\":\\\"seconds\\\",\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}},\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"时间\\\"]}\",\"{\\\"table.cell_column\\\":\\\"前天\\\",\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.x_axis.axis_enabled\\\":\\\"rotate-45\\\",\\\"graph.show_values\\\":true,\\\"graph.label_value_formatting\\\":\\\"auto\\\",\\\"graph.dimensions\\\":[\\\"时间\\\"],\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"时间\\\\\\\"]\\\":{\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}},\\\"graph.metrics\\\":[\\\"前天\\\",\\\"昨天\\\",\\\"今天\\\"]}\",\"{\\\"table.column_widths\\\":[null,null,null,null,null,null,null,null,null,164],\\\"graph.show_values\\\":true,\\\"table.cell_column\\\":\\\"SUBTOTAL\\\",\\\"graph.series_order_dimension\\\":null,\\\"graph.metrics\\\":[],\\\"graph.series_order\\\":null,\\\"table.pivot_column\\\":\\\"Age\\\",\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"table.pivot_column\\\":\\\"昵称\\\",\\\"table.cell_column\\\":\\\"主播mid\\\",\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播mid\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播user_id\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播收入(钻石)\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}}\"]',NULL,557,_binary '\0','full',NULL,'2024-06-19 14:19:00.728218'),(179,'2024-06-19 14:19:00.814129','2024-06-19 14:19:00.814129','[0,6,9,12,17,18]',NULL,624,_binary '\0','full',NULL,'2024-06-19 14:19:00.814129'),(180,'2024-06-19 14:19:00.864227','2024-06-30 21:00:08.320551','[\"1mSLJrWPvehXkcIzoK1Yq\",\"3d1iG7J48euO467UN-hCL\",\"3f4Uo5mlklic7PBxY32DZ\",\"C3ByFOdgRYsNwwXVTGfY-\",\"Cb92ioon7vWaER-4OcdDS\",\"Cc0jFy1OZZbmC1CEA4eu2\",\"dMJWPl0xxJkfsUFnPmd3Q\",\"dX_lc-n9uNhVcRmbhZfdQ\",\"e-8h-dZx-B9RYybRoZzci\",\"f-hh5qVJwpgrj3_JWDtpX\",\"g6Z9N7QjvtdQbEHaAgxhY\",\"gXkQgKfsYghl-XjDpSefW\",\"h_f6hPOFg0FN3m6VA5B03\",\"iSUCvbFniuVFlN5NDV3Y7\",\"JDDgMLIDoRDC24ufF2yeI\",\"Jtd-7AGoT0MNS4CxhVjei\",\"l8ojUGfQRhM62r3dfrUP9\",\"M0wMgB4luEU3tLw2ihcCr\",\"M89Lh2AQnAunejYWXNUeT\",\"mAWb2jLm8VflkT7s1_lBf\",\"ndNZEBY96LMGGWefgnG3o\",\"NGar3mVnCROw5p7djSBa3\",\"OMCqqRP9CQTT3pSp6sfo5\",\"P37ixkaPafIr47ep0oypD\",\"Q4sD1F6XrD8dVPD2JHV1Z\",\"s_DDqee44Wp_gHh16bAuR\",\"s2ZdKLKOql1B0gCbOh3XO\",\"T3G6Is3XniVtrqzKbZ2vx\",\"tNvUvy6ezg0rUhV9baI0O\",\"VjAahFlVkOA0hp1LVBrH5\",\"vJZR2mN2xRrXiqqwAc0eb\",\"wRqWXKjFJ_d3t34HXl7Vg\",\"xmP43pM4LHbrbRP-rjT-j\",\"xZFChb3ro-2jzg7I767yY\",\"zfSwuSU-8e6O3eqyt9r16\"]',NULL,617,_binary '\0','full',NULL,'2024-06-19 14:19:00.864227'),(181,'2024-06-19 14:19:00.910547','2024-06-19 14:19:00.910547','[\"[]\",\"[{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"afa56954\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"512c560a\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]},{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"card_id\\\":3,\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]}]\",\"[{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":24,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":4,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":23,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",\\\"PRODUCTS__via__PRODUCT_ID__TITLE\\\",{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":1,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",\\\"CREATED_AT\\\",{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":10,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"Products\\\"}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",\\\"CREATED_AT\\\",{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"Products\\\"}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":11,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":12,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":13,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":14,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":15,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":16,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":17,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":18,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":19,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":20,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":21,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":22,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":22,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":25,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"join-alias\\\":\\\"People - User\\\"}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":5,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":6,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":7,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":8,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\",\"[{\\\"parameter_id\\\":\\\"fc2cd1be\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",60,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"afa56954\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\"}]]},{\\\"parameter_id\\\":\\\"5eeec658\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",58,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":40}]]},{\\\"parameter_id\\\":\\\"512c560a\\\",\\\"card_id\\\":9,\\\"target\\\":[\\\"dimension\\\",[\\\"field\\\",48,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]]}]\"]',NULL,626,_binary '\0','full',NULL,'2024-06-19 14:19:00.910547'),(182,'2024-06-19 14:19:00.972921','2024-06-20 21:00:09.319853','[0,1,2,3,4,6,7,8,9,10,12,13,14,15,18,19,20]',NULL,623,_binary '\0','full',NULL,'2024-06-19 14:19:00.972921'),(183,'2024-06-19 14:19:01.022312','2024-06-19 14:19:01.022312','[6,7,9,15,17,18,24]',NULL,621,_binary '\0','full',NULL,'2024-06-19 14:19:01.022312'),(184,'2024-06-19 14:19:01.065629','2024-06-20 21:00:09.374081','[1,2,3,5,6,7,8,11]',NULL,627,_binary '\0','full',NULL,'2024-06-19 14:19:01.065629'),(185,'2024-06-19 14:19:01.120961','2024-06-19 21:00:09.933090','[\"{\\\"card.description\\\":\\\"An ordered list of our most successful products\\\",\\\"card.title\\\":\\\"Best selling products\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"TITLE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Products\\\",\\\"graph.y_axis.title_text\\\":\\\"number of orders\\\",\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"table.pivot\\\":false}\",\"{\\\"card.description\\\":\\\"Breaks down the overall performance of each of the product categories \\\",\\\"card.title\\\":\\\"Total orders by category\\\",\\\"column_settings\\\":null,\\\"pie.colors\\\":{\\\"Doohickey\\\":\\\"#7172AD\\\",\\\"Gadget\\\":\\\"#A989C5\\\",\\\"Gizmo\\\":\\\"#C7EAEA\\\",\\\"Widget\\\":\\\"#227FD2\\\"}}\",\"{\\\"card.description\\\":\\\"Compares the current total in revenue with the set goal for the quarter\\\",\\\"progress.goal\\\":250000,\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"sum\\\\\\\"]\\\":{\\\"number_style\\\":\\\"currency\\\"}}}\",\"{\\\"card.description\\\":\\\"Compares the number of unique customers placing orders this month with the previous period\\\",\\\"card.title\\\":\\\"Unique customers per month\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the orders of each category quarter over quarter\\\",\\\"card.title\\\":\\\"Numbers of orders by category per quarter\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Created At\\\",\\\"graph.y_axis.title_text\\\":\\\"Number of orders\\\",\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}}}\",\"{\\\"card.description\\\":\\\"Compares the total discount given this quarter with the previous period\\\",\\\"card.title\\\":\\\"Discount given per quarter\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the total number of orders placed for this product this month with the previous period\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the total number of orders placed this month with the previous period\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Compares the total revenue this quarter with the previous period\\\",\\\"column_settings\\\":null}\",\"{\\\"card.description\\\":\\\"Indicates the average customer review of our products\\\",\\\"card.title\\\":\\\"Average product rating overall\\\",\\\"column_settings\\\":null,\\\"gauge.segments\\\":[{\\\"color\\\":\\\"#EF8C8C\\\",\\\"label\\\":\\\"awful\\\",\\\"max\\\":1,\\\"min\\\":0},{\\\"color\\\":\\\"#F2A86F\\\",\\\"label\\\":\\\"bad\\\",\\\"max\\\":2,\\\"min\\\":1},{\\\"color\\\":\\\"#F9D45C\\\",\\\"label\\\":\\\"alright\\\",\\\"max\\\":3,\\\"min\\\":2},{\\\"color\\\":\\\"#A7D07C\\\",\\\"label\\\":\\\"good\\\",\\\"max\\\":4,\\\"min\\\":3},{\\\"color\\\":\\\"#689636\\\",\\\"label\\\":\\\"great\\\",\\\"max\\\":5,\\\"min\\\":4}],\\\"table.cell_column\\\":\\\"avg\\\"}\",\"{\\\"card.description\\\":\\\"Matches the cumulative revenue  month over month with the number of orders placed each month\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\"],\\\"graph.metrics\\\":[\\\"sum\\\",\\\"sum_2\\\"],\\\"graph.show_trendline\\\":false,\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.x_axis.title_text\\\":\\\"Orders date\\\",\\\"graph.y_axis.labels_enabled\\\":false,\\\"graph.y_axis.title_text\\\":\\\"Revenue\\\",\\\"series_settings\\\":{\\\"sum\\\":{\\\"display\\\":\\\"line\\\",\\\"line.interpolate\\\":\\\"linear\\\",\\\"line.marker_enabled\\\":false,\\\"show_series_values\\\":true,\\\"title\\\":\\\"Revenue\\\"},\\\"sum_2\\\":{\\\"color\\\":\\\"#51528D\\\",\\\"title\\\":\\\"Number of orders\\\"}}}\",\"{\\\"card.description\\\":\\\"Orders placed per quarter broken down by source and formatted to highlight best and worst quarters\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"SOURCE\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_labels\\\":[null],\\\"pivot.show_row_totals\\\":true,\\\"pivot_table.column_split\\\":{\\\"columns\\\":[[\\\"field\\\",45,{\\\"base-type\\\":\\\"type/Text\\\",\\\"source-field\\\":43}]],\\\"rows\\\":[[\\\"field\\\",41,{\\\"base-type\\\":\\\"type/DateTime\\\",\\\"temporal-unit\\\":\\\"quarter\\\"}]],\\\"values\\\":[[\\\"aggregation\\\",0]]},\\\"pivot_table.column_widths\\\":{\\\"leftHeaderWidths\\\":[141],\\\"totalLeftHeaderWidths\\\":141,\\\"valueHeaderWidths\\\":{\\\"0\\\":234,\\\"1\\\":263,\\\"2\\\":254,\\\"3\\\":236.3636474609375,\\\"4\\\":227,\\\"5\\\":170}},\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.column_formatting\\\":[{\\\"color\\\":\\\"#FBE499\\\",\\\"colors\\\":[\\\"#ED6E6E\\\",\\\"#FFFFFF\\\",\\\"#84BB4C\\\"],\\\"columns\\\":[\\\"sum\\\"],\\\"highlight_row\\\":false,\\\"max_type\\\":null,\\\"max_value\\\":100,\\\"min_type\\\":null,\\\"min_value\\\":0,\\\"operator\\\":\\\"<\\\",\\\"type\\\":\\\"range\\\",\\\"value\\\":1000}]}\",\"{\\\"card.description\\\":\\\"Shows a distribution of orders broken down by product category across our customers\' age groups\\\",\\\"card.title\\\":\\\"Product category orders per individual age\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.title_text\\\":\\\"Orders by category\\\",\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}},\\\"stackable.stack_type\\\":\\\"normalized\\\"}\",\"{\\\"card.description\\\":\\\"Shows a distribution of orders broken down by source across our customers\' age groups\\\",\\\"card.title\\\":\\\"Orders by source per individual age\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"SOURCE\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.title_text\\\":\\\"Orders by Sources\\\",\\\"stackable.stack_type\\\":\\\"normalized\\\"}\",\"{\\\"card.description\\\":\\\"Shows a distribution of revenue in age groups\\\",\\\"card.title\\\":\\\"Revenue per individual age\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"graph.label_value_formatting\\\":\\\"compact\\\",\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.title_text\\\":\\\"Total revenue\\\",\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"card.description\\\":\\\"Shows the distribution of the product categories along the scale of customer ratings\\\",\\\"card.title\\\":\\\"Customer Satisfaction per category\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"RATING\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.title_text\\\":\\\"Customer Ratings\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"graph.y_axis.title_text\\\":\\\"Orders by category\\\",\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"},\\\"count\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.pivot\\\":false}\",\"{\\\"card.title\\\":\\\"Value of orders over time (before taxes)\\\",\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"CREATED_AT\\\",\\\"CATEGORY\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.labels_enabled\\\":false,\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}},\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Age insights breakdowns\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Customer satisfaction insights\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Overall business health\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Product category insights\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Top performing products\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"dashcard.background\\\":false,\\\"text\\\":\\\"Who  and where are our customers\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"heading\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"SOURCE\\\"],\\\"graph.label_value_formatting\\\":\\\"compact\\\",\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.x_axis.labels_enabled\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.y_axis.auto_range\\\":true,\\\"graph.y_axis.labels_enabled\\\":false,\\\"graph.y_axis.title_text\\\":\\\"Orders\\\",\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null,\\\"graph.dimensions\\\":[\\\"Age\\\"],\\\"graph.metrics\\\":[\\\"sum\\\"],\\\"graph.series_order\\\":null,\\\"graph.series_order_dimension\\\":null,\\\"graph.show_values\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"stackable.stack_type\\\":\\\"stacked\\\",\\\"table.cell_column\\\":\\\"SUBTOTAL\\\"}\",\"{\\\"column_settings\\\":null}\",\"{\\\"graph.show_values\\\":true,\\\"graph.x_axis.labels_enabled\\\":true,\\\"table.cell_column\\\":\\\"SUBTOTAL\\\",\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":true,\\\"graph.y_axis.labels_enabled\\\":false,\\\"card.title\\\":\\\"Product category orders per age group\\\",\\\"graph.metrics\\\":[\\\"count\\\"],\\\"graph.series_order\\\":null,\\\"series_settings\\\":{\\\"Doohickey\\\":{\\\"color\\\":\\\"#7172AD\\\"},\\\"Gadget\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"Gizmo\\\":{\\\"color\\\":\\\"#C7EAEA\\\"},\\\"Widget\\\":{\\\"color\\\":\\\"#227FD2\\\"}},\\\"graph.y_axis.auto_range\\\":true,\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"Age\\\",\\\"CATEGORY\\\"],\\\"stackable.stack_type\\\":\\\"stacked\\\"}\",\"{\\\"graph.y_axis.title_text\\\":\\\"Buyers\\\",\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.title_text\\\":\\\"Age\\\",\\\"card.title\\\":\\\"Buyers by age group\\\",\\\"graph.metrics\\\":[\\\"count_2\\\"],\\\"graph.series_order\\\":null,\\\"card.description\\\":\\\"Shows a distribution of our customers in age groups\\\",\\\"series_settings\\\":{\\\"count\\\":{\\\"color\\\":\\\"#A989C5\\\"},\\\"count_2\\\":{\\\"color\\\":\\\"#999AC4\\\"}},\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"count\\\"]}\",\"{\\\"text\\\":\\\"### Top three all-time products \\\\nMoM performance\\\",\\\"virtual_card\\\":{\\\"archived\\\":false,\\\"dataset_query\\\":{},\\\"display\\\":\\\"text\\\",\\\"name\\\":null,\\\"visualization_settings\\\":{}}}\",\"{}\"]',NULL,619,_binary '\0','full',NULL,'2024-06-19 14:19:01.120961'),(186,'2024-06-19 14:19:01.171173','2024-06-19 14:19:01.171173','[null]',NULL,755,_binary '\0','full',NULL,'2024-06-19 14:19:01.171173'),(187,'2024-06-19 14:19:01.211714','2024-06-19 14:19:01.211714','[null]',NULL,758,_binary '\0','full',NULL,'2024-06-19 14:19:01.211714'),(188,'2024-06-19 14:19:01.255416','2024-06-20 21:00:09.477192','[false,true]',NULL,743,_binary '\0','full',NULL,'2024-06-19 14:19:01.255416'),(189,'2024-06-19 14:19:01.293597','2024-06-19 21:00:10.101448','[null,1,3]',NULL,753,_binary '\0','full',NULL,'2024-06-19 14:19:01.293597'),(190,'2024-06-19 14:19:01.329901','2024-06-19 14:19:01.329901','[null,0]',NULL,741,_binary '\0','full',NULL,'2024-06-19 14:19:01.329901'),(191,'2024-06-19 14:19:01.386259','2024-06-19 14:19:01.386259','[null,0,1]',NULL,740,_binary '\0','full',NULL,'2024-06-19 14:19:01.386259'),(192,'2024-06-19 14:19:01.438397','2024-06-19 21:00:10.190593','[null,13371338,13371339]',NULL,745,_binary '\0','full',NULL,'2024-06-19 14:19:01.438397'),(193,'2024-06-19 14:19:01.482949','2024-06-19 14:19:01.482949','[null,\"An ordered list of our most successful products\",\"Breaks down the overall performance of each of the product categories\",\"Compares the current total in revenue with the set goal for the quarter\",\"Compares the number of unique customers placing orders this month with the previous period\",\"Compares the orders of each category quarter over quarter\",\"Compares the total discount given this quarter with the previous period\",\"Compares the total number of orders placed for this product this month with the previous period\",\"Compares the total number of orders placed this month with the previous period\",\"Compares the total revenue this quarter with the previous period\",\"Indicates the average customer review of our products\",\"Matches the cumulative revenue month over month with the number of orders placed each month\",\"Orders placed per quarter broken down by source and formatted to highlight best and worst quarters\",\"Quickly take an overview of an e-commerce reseller business and dive into separate tabs that focus on top selling products and demographic insights. Each vendor can log in as a tenant and see their own data sandboxed from all the others.\",\"Shows a distribution of orders broken down by product categories across our customers\' age groups\",\"Shows a distribution of orders broken down by product category across our customers\' individual age values\",\"Shows a distribution of orders broken down by source across our customers\' age groups\",\"Shows a distribution of orders broken down by source across our customers\' individual age values\",\"Shows a distribution of our customers in age groups\",\"Shows a distribution of revenue per individual age values\",\"Shows the distribution of the product categories along the scale of customer ratings\",\"Shows the revenue distributed by age group\"]',NULL,754,_binary '\0','full',NULL,'2024-06-19 14:19:01.482949'),(194,'2024-06-19 14:19:01.525631','2024-06-30 21:00:08.640450','[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31]',NULL,750,_binary '\0','full',NULL,'2024-06-19 14:19:01.525631'),(195,'2024-06-19 14:19:01.562520','2024-06-30 21:00:08.673460','[\"card_1\",\"card_10\",\"card_11\",\"card_12\",\"card_13\",\"card_14\",\"card_15\",\"card_16\",\"card_17\",\"card_18\",\"card_19\",\"card_2\",\"card_20\",\"card_21\",\"card_22\",\"card_23\",\"card_24\",\"card_25\",\"card_26\",\"card_27\",\"card_28\",\"card_29\",\"card_3\",\"card_30\",\"card_31\",\"card_4\",\"card_5\",\"card_6\",\"card_7\",\"card_8\",\"card_9\",\"collection_1\",\"collection_2\",\"collection_3\",\"collection_4\",\"collection_5\",\"collection_6\",\"collection_7\",\"collection_8\",\"collection_9\",\"dashboard_1\",\"dashboard_2\"]',NULL,757,_binary '\0','full',NULL,'2024-06-19 14:19:01.562520'),(196,'2024-06-19 14:19:01.606450','2024-06-19 14:19:01.606450','[\"collection\",\"dashboard\",\"model\",\"question\"]',NULL,752,_binary '\0','full',NULL,'2024-06-19 14:19:01.606450'),(197,'2024-06-19 14:19:01.653386','2024-06-19 14:19:01.653386','[null,false]',NULL,749,_binary '\0','full',NULL,'2024-06-19 14:19:01.653386'),(198,'2024-06-19 14:19:01.694720','2024-06-19 14:19:01.694720','[null]',NULL,756,_binary '\0','full',NULL,'2024-06-19 14:19:01.694720'),(199,'2024-06-19 14:19:01.731592','2024-06-30 21:00:08.768163','[\"Aerodynamic Copper Knife trend\",\"Average product rating overall\",\"Best selling products\",\"Buyers by age group\",\"Customer satisfaction per category\",\"dingkai的个人收藏\",\"Discount given per quarter\",\"E-commerce insights\",\"Enormous Wool Car trend\",\"erwinlee的个人收藏集\",\"Examples\",\"Heavy-Duty Silk Chair trend\",\"ironfan-增值\",\"Number of orders per month\",\"Numbers of orders by category per quarter\",\"Orders according to sources per quarter\",\"Orders by source per age group\",\"Orders by source per individual age\",\"Orders with People\",\"People with age\",\"Product category orders per age group\",\"Product category orders per individual age\",\"Revenue and orders over time\",\"Revenue by state\",\"Revenue goal for this quarter\",\"Revenue per age group\",\"Revenue per individual age\",\"Revenue per quarter\",\"robin的个人收藏\",\"Total orders by category\",\"Unique customers per month\",\"Value of orders over time (before taxes)\",\"yezian的个人收藏\",\"yubingchang的个人收藏\",\"zhangzihao的个人收藏\",\"zihao的个人收藏\",\"三日时分同比\",\"三日流水时分同比\",\"主播当日收入榜\",\"当日流水\",\"每日收入明细\",\"铁粉空间\"]',NULL,746,_binary '\0','full',NULL,'2024-06-19 14:19:01.731592'),(200,'2024-06-19 14:19:01.767969','2024-06-19 21:00:10.414862','[null,\"database_1\",\"database_2\"]',NULL,751,_binary '\0','full',NULL,'2024-06-19 14:19:01.767969'),(201,'2024-06-19 14:19:01.805469','2024-06-19 21:00:10.452108','[null,0,1]',NULL,747,_binary '\0','full',NULL,'2024-06-19 14:19:01.805469'),(202,'2024-06-19 14:19:01.843551','2024-06-19 21:00:10.483712','[null,\"bar\",\"combo\",\"gauge\",\"line\",\"map\",\"pie\",\"pivot\",\"progress\",\"row\",\"scalar\",\"smartscalar\",\"table\"]',NULL,742,_binary '\0','full',NULL,'2024-06-19 14:19:01.843551'),(203,'2024-06-19 14:19:01.891028','2024-06-19 14:19:01.891028','[true]',NULL,316,_binary '\0','full',NULL,'2024-06-19 14:19:01.891028'),(204,'2024-06-19 14:19:01.928082','2024-06-19 14:19:01.928082','[null,\"Not every account feels inclined to submit feedback. That’s cool. There’s still quite a few responses here.\",\"Note that employees and customer support staff will have accounts.\",\"Piespace has cracked time travel, so keep in mind that some events may have already happened in the future.\",\"Piespace’s business operates with a two week trial period. If you see that “Canceled At” is null then that account is still happily paying for their pies.\",\"The rating column is an integer from 1-5 where 1 is dreadful and 5 is the best thing ever.\",\"These reviews aren\'t tied to orders so it is possible people have reviewed products they did not purchase from us.\",\"You can group by “Account ID” to see all the payments from an account and unveil information like total amount paid to date.\",\"You can join this on the Products and Orders table using the ID fields. Discount is left null if not applicable.\"]',NULL,307,_binary '\0','full',NULL,'2024-06-19 14:19:01.928082'),(205,'2024-06-19 14:19:01.966355','2024-06-19 14:19:01.966355','[null]',NULL,318,_binary '\0','full',NULL,'2024-06-19 14:19:01.966355'),(206,'2024-06-19 14:19:02.005999','2024-06-19 14:19:02.005999','[null,\"A log of executed queries, used for calculating historic execution times, auditing, and other purposes.\",\"A readwrite query type of action\",\"A table to store database and table permissions\",\"An action is something you can do, such as run a readwrite query\",\"An action with dynamic parameters based on the underlying model\",\"An API Key\",\"An http api call type of action\",\"Cache Configuration\",\"Cached results of queries are stored here when using the DB-based query cache.\",\"Collections are an optional way to organize Cards and handle permissions for them.\",\"Confirmed payments from Piespace’s customers. Most accounts pay for their pie subscription on a monthly basis.\",\"Confirmed Sample Company orders for a product, from a user.\",\"Events table\",\"Fields used by a card\'s query\",\"Includes a catalog of all the products ever sold by the famed Sample Company.\",\"Information (such as average execution time) for different queries that have been previously ran.\",\"Information on customer accounts registered with Piespace. Each account represents a new organization signing up for on-demand pies.\",\"Information on the user accounts registered with Sample Company.\",\"Join table connecting cards to entities (dashboards, other cards, etc.) that use the values generated by the card for filter values\",\"Join table connecting dashboard to dashboardcards\",\"Keeps track of various logins for different users and additional info such as location and device\",\"Migrate to cloud directly from Metabase\",\"Piespace does some anonymous analytics tracking on how users interact with their platform. They’ve only had time to implement a few events, but you know how it is. Pies come first.\",\"Presence of a row here indicates a given User has favorited a given Dashboard.\",\"Query snippets (raw text) to be substituted in native queries\",\"Records that a given Card (Question) should automatically replace a given Table as query source for a given a Perms Group.\",\"Reviews (from moderators) for a given question/dashboard (BUCM)\",\"Reviews that Sample Company customers have left on our products.\",\"Storage for managed secrets (passwords, binary data, etc.)\",\"Stores references to alternate views of existing fields, such as remapping an integer to a description, like an enum\",\"Table for holding connection impersonation policies\",\"Table for user and role privileges by table\",\"Table holding bookmarks on cards\",\"Table holding bookmarks on collections\",\"Table holding bookmarks on dashboards\",\"Table holding information about persisted models\",\"Table holding last set value of a parameter per user\",\"Table holding ordering information for various bookmark tables\",\"Timeline table to organize events\",\"Timing and metadata info about background/quartz processes\",\"Used for Quartz scheduler.\",\"Used to keep track of changes made to collections.\",\"Used to keep track of changes made to general permissions.\",\"Used to keep track of changes made to permissions.\",\"Used to keep track of the values indexed in a model\",\"Used to keep track of which models have indexed columns.\",\"Used to store application events for auditing use cases\",\"Used to store field usage during query execution\",\"Used to store recently viewed objects for each user\",\"VIEW\",\"With each order of pies sent out, Piespace includes a place for customers to submit feedback and review their order.\"]',NULL,317,_binary '\0','full',NULL,'2024-06-19 14:19:02.005999'),(207,'2024-06-19 14:19:02.051664','2024-06-19 14:19:02.051664','[\"Accounts\",\"Action\",\"Analytic Events\",\"Api Key\",\"Application Permissions Revision\",\"Audit Log\",\"Bookmark Ordering\",\"Cache Config\",\"Card Bookmark\",\"Card Label\",\"Cloud Migration\",\"Collection\",\"Collection Bookmark\",\"Collection Permission Graph Revision\",\"Connection Impersonations\",\"Core Session\",\"Core User\",\"Dashboard Bookmark\",\"Dashboard Favorite\",\"Dashboard Tab\",\"Dashboardcard Series\",\"Data Permissions\",\"Databasechangelog\",\"Databasechangeloglock\",\"Dependency\",\"Dimension\",\"Feedback\",\"Field Usage\",\"Http Action\",\"Implicit Action\",\"Invoices\",\"Label\",\"Login History\",\"Metabase Database\",\"Metabase Field\",\"Metabase Fieldvalues\",\"Metabase Table\",\"Metric\",\"Metric Important Field\",\"Model Index\",\"Model Index Value\",\"Moderation Review\",\"Native Query Snippet\",\"Orders\",\"Parameter Card\",\"People\",\"Permissions\",\"Permissions Group\",\"Permissions Group Membership\",\"Permissions Revision\",\"Persisted Info\",\"Products\",\"Pulse\",\"Pulse Card\",\"Pulse Channel\",\"Pulse Channel Recipient\",\"Qrtz Blob Triggers\",\"Qrtz Calendars\",\"Qrtz Cron Triggers\",\"Qrtz Fired Triggers\",\"Qrtz Job Details\",\"Qrtz Locks\",\"Qrtz Paused Trigger Grps\",\"Qrtz Scheduler State\",\"Qrtz Simple Triggers\",\"Qrtz Simprop Triggers\",\"Qrtz Triggers\",\"Query\",\"Query Action\",\"Query Cache\",\"Query Execution\",\"Query Field\",\"Recent Views\",\"Report Card\",\"Report Cardfavorite\",\"Report Dashboard\",\"Report Dashboardcard\",\"Reviews\",\"Revision\",\"Sandboxes\",\"Secret\",\"Segment\",\"Setting\",\"Streamer\",\"Table Privileges\",\"Task History\",\"Timeline\",\"Timeline Event\",\"User Parameter Value\",\"V Alerts\",\"V Audit Log\",\"V Content\",\"V Dashboardcard\",\"V Databases\",\"V Fields\",\"V Group Members\",\"V Query Log\",\"V Subscriptions\",\"V Tables\",\"V Tasks\",\"V Users\",\"V View Log\",\"Vas Cur Streamer Income\",\"Vas Day Detail\",\"Vas Day Flow\",\"Vas Yoy Flow\",\"View Log\"]',NULL,311,_binary '\0','full',NULL,'2024-06-19 14:19:02.051664'),(208,'2024-06-19 14:19:02.088913','2024-06-19 14:19:02.088913','[null,\"entity/EventTable\",\"entity/GenericTable\",\"entity/ProductTable\",\"entity/SubscriptionTable\",\"entity/TransactionTable\",\"entity/UserTable\"]',NULL,315,_binary '\0','full',NULL,'2024-06-19 14:19:02.088913'),(209,'2024-06-19 14:19:02.129622','2024-06-19 14:19:02.129622','[null]',NULL,312,_binary '\0','full',NULL,'2024-06-19 14:19:02.129622'),(210,'2024-06-19 14:19:02.217267','2024-06-19 14:19:02.217267','[\"database\"]',NULL,308,_binary '\0','full',NULL,'2024-06-19 14:19:02.217267'),(211,'2024-06-19 14:19:02.264938','2024-06-19 14:19:02.264938','[\"complete\"]',NULL,310,_binary '\0','full',NULL,'2024-06-19 14:19:02.264938'),(212,'2024-06-19 14:19:02.300768','2024-06-19 14:19:02.300768','[false]',NULL,324,_binary '\0','full',NULL,'2024-06-19 14:19:02.300768'),(213,'2024-06-19 14:19:02.340904','2024-06-19 14:19:02.340904','[\"ACCOUNTS\",\"action\",\"ANALYTIC_EVENTS\",\"api_key\",\"application_permissions_revision\",\"audit_log\",\"bookmark_ordering\",\"cache_config\",\"card_bookmark\",\"card_label\",\"cloud_migration\",\"collection\",\"collection_bookmark\",\"collection_permission_graph_revision\",\"connection_impersonations\",\"core_session\",\"core_user\",\"dashboard_bookmark\",\"dashboard_favorite\",\"dashboard_tab\",\"dashboardcard_series\",\"data_permissions\",\"databasechangelog\",\"databasechangeloglock\",\"dependency\",\"dimension\",\"FEEDBACK\",\"field_usage\",\"http_action\",\"implicit_action\",\"INVOICES\",\"label\",\"login_history\",\"metabase_database\",\"metabase_field\",\"metabase_fieldvalues\",\"metabase_table\",\"metric\",\"metric_important_field\",\"model_index\",\"model_index_value\",\"moderation_review\",\"native_query_snippet\",\"ORDERS\",\"parameter_card\",\"PEOPLE\",\"permissions\",\"permissions_group\",\"permissions_group_membership\",\"permissions_revision\",\"persisted_info\",\"PRODUCTS\",\"pulse\",\"pulse_card\",\"pulse_channel\",\"pulse_channel_recipient\",\"qrtz_blob_triggers\",\"qrtz_calendars\",\"qrtz_cron_triggers\",\"qrtz_fired_triggers\",\"qrtz_job_details\",\"qrtz_locks\",\"qrtz_paused_trigger_grps\",\"qrtz_scheduler_state\",\"qrtz_simple_triggers\",\"qrtz_simprop_triggers\",\"qrtz_triggers\",\"query\",\"query_action\",\"query_cache\",\"query_execution\",\"query_field\",\"recent_views\",\"report_card\",\"report_cardfavorite\",\"report_dashboard\",\"report_dashboardcard\",\"REVIEWS\",\"revision\",\"sandboxes\",\"secret\",\"segment\",\"setting\",\"streamer\",\"table_privileges\",\"task_history\",\"timeline\",\"timeline_event\",\"user_parameter_value\",\"v_alerts\",\"v_audit_log\",\"v_content\",\"v_dashboardcard\",\"v_databases\",\"v_fields\",\"v_group_members\",\"v_query_log\",\"v_subscriptions\",\"v_tables\",\"v_tasks\",\"v_users\",\"v_view_log\",\"vas_cur_streamer_income\",\"vas_day_detail\",\"vas_day_flow\",\"vas_yoy_flow\",\"view_log\"]',NULL,309,_binary '\0','full',NULL,'2024-06-19 14:19:02.340904'),(214,'2024-06-19 14:19:02.381420','2024-06-19 14:19:02.381420','[null,\"Is it? We’ll let you be the judge of that.\",\"Is it? You tell us!\"]',NULL,320,_binary '\0','full',NULL,'2024-06-19 14:19:02.381420'),(215,'2024-06-19 14:19:02.428048','2024-06-19 14:19:02.428048','[null,\"PUBLIC\"]',NULL,322,_binary '\0','full',NULL,'2024-06-19 14:19:02.428048'),(216,'2024-06-19 14:19:02.472168','2024-06-19 14:19:02.472168','[false]',NULL,313,_binary '\0','full',NULL,'2024-06-19 14:19:02.472168'),(217,'2024-06-19 14:19:02.512932','2024-06-19 14:19:02.512932','[0]',NULL,323,_binary '\0','full',NULL,'2024-06-19 14:19:02.512932'),(218,'2024-06-19 14:19:02.551979','2024-06-19 14:19:02.551979','[null,\"cruft\"]',NULL,306,_binary '\0','full',NULL,'2024-06-19 14:19:02.551979'),(219,'2024-06-19 14:19:02.640276','2024-06-19 14:19:02.640276','[true]',NULL,257,_binary '\0','full',NULL,'2024-06-19 14:19:02.640276'),(220,'2024-06-19 14:19:02.683735','2024-06-19 14:19:02.683735','[\"0 0 17 * * ? *\",\"0 0 21 * * ? *\"]',NULL,239,_binary '\0','full',NULL,'2024-06-19 14:19:02.683735'),(221,'2024-06-19 14:19:02.719758','2024-06-19 14:19:02.719758','[null]',NULL,260,_binary '\0','full',NULL,'2024-06-19 14:19:02.719758'),(222,'2024-06-19 14:19:02.759569','2024-06-19 14:19:02.759569','[null,\"You probably don\'t want to use this for your business-critical analyses, but hey, it\'s your world, we\'re just living in it.\"]',NULL,255,_binary '\0','full',NULL,'2024-06-19 14:19:02.759569'),(223,'2024-06-19 14:19:02.801089','2024-06-19 14:19:02.801089','[\"{\\\"flavor\\\":\\\"H2\\\",\\\"version\\\":\\\"2.1.214 (2022-06-13)\\\",\\\"semantic-version\\\":[2,1]}\",\"{\\\"flavor\\\":\\\"MySQL\\\",\\\"version\\\":\\\"8.2.0\\\",\\\"semantic-version\\\":[8,2]}\"]',NULL,258,_binary '\0','full',NULL,'2024-06-19 14:19:02.801089'),(224,'2024-06-19 14:19:02.838605','2024-06-19 14:19:02.838605','[null,\"Some example data for you to play around with.\"]',NULL,240,_binary '\0','full',NULL,'2024-06-19 14:19:02.838605'),(225,'2024-06-19 14:19:02.878299','2024-06-19 14:19:02.878299','[\"{\\\"db\\\":\\\"file:/plugins/sample-database.db;USER=GUEST;PASSWORD=guest\\\"}\",\"{\\\"host\\\":\\\"1Panel-mysql-TUA1\\\",\\\"port\\\":3306,\\\"dbname\\\":\\\"metabase_bi\\\",\\\"user\\\":\\\"root\\\",\\\"password\\\":\\\"Wishpal_2024\\\",\\\"ssl\\\":false,\\\"tunnel-enabled\\\":false,\\\"advanced-options\\\":false}\"]',NULL,242,_binary '\0','full',NULL,'2024-06-19 14:19:02.878299'),(226,'2024-06-19 14:19:02.929011','2024-06-19 14:19:02.929011','[\"h2\",\"mysql\"]',NULL,261,_binary '\0','full',NULL,'2024-06-19 14:19:02.929011'),(227,'2024-06-19 14:19:02.984281','2024-06-19 14:19:02.984281','[\"complete\"]',NULL,246,_binary '\0','full',NULL,'2024-06-19 14:19:02.984281'),(228,'2024-06-19 14:19:03.030647','2024-06-19 14:19:03.030647','[false]',NULL,252,_binary '\0','full',NULL,'2024-06-19 14:19:03.030647'),(229,'2024-06-19 14:19:03.086021','2024-06-19 14:19:03.086021','[true]',NULL,254,_binary '\0','full',NULL,'2024-06-19 14:19:03.086021'),(230,'2024-06-19 14:19:03.144599','2024-06-19 14:19:03.144599','[false]',NULL,244,_binary '\0','full',NULL,'2024-06-19 14:19:03.144599'),(231,'2024-06-19 14:19:03.210441','2024-06-19 14:19:03.210441','[false,true]',NULL,259,_binary '\0','full',NULL,'2024-06-19 14:19:03.210441'),(232,'2024-06-19 14:19:03.249797','2024-06-19 14:19:03.249797','[\"0 26 * * * ? *\",\"0 45 * * * ? *\"]',NULL,238,_binary '\0','full',NULL,'2024-06-19 14:19:03.249797'),(233,'2024-06-19 14:19:03.285054','2024-06-19 14:19:03.285054','[\"metabase_bi\",\"Sample Database\"]',NULL,253,_binary '\0','full',NULL,'2024-06-19 14:19:03.285054'),(234,'2024-06-19 14:19:03.327346','2024-06-19 14:19:03.327346','[null,\"You can find all sorts of different joinable tables ranging from products to people to reviews here.\"]',NULL,245,_binary '\0','full',NULL,'2024-06-19 14:19:03.327346'),(235,'2024-06-19 14:19:03.366828','2024-06-19 14:19:03.366828','[null]',NULL,237,_binary '\0','full',NULL,'2024-06-19 14:19:03.366828'),(236,'2024-06-19 14:19:03.407817','2024-06-19 14:19:03.407817','[null]',NULL,241,_binary '\0','full',NULL,'2024-06-19 14:19:03.407817'),(237,'2024-06-19 14:19:03.452304','2024-06-19 14:19:03.452304','[\"+08:00\",\"GMT\"]',NULL,243,_binary '\0','full',NULL,'2024-06-19 14:19:03.452304'),(238,'2024-06-19 14:19:03.497859','2024-06-19 14:19:03.497859','[false]',NULL,249,_binary '\0','full',NULL,'2024-06-19 14:19:03.497859'),(239,'2024-06-19 14:19:03.537545','2024-06-19 14:19:03.537545','[null]',NULL,262,_binary '\0','full',NULL,'2024-06-19 14:19:03.537545'),(240,'2024-06-19 14:19:03.577306','2024-06-19 14:19:03.577306','[null]',NULL,251,_binary '\0','full',NULL,'2024-06-19 14:19:03.577306'),(241,'2024-06-19 14:19:03.623209','2024-06-19 14:19:03.623209','[\"PS7GW5IfD3ov0haogAPLu\",\"TKyJ0onLUPOuZgVfwZfU1\",\"z5IymDhXzRY2kF79LxQIN\"]',NULL,179,_binary '\0','full',NULL,'2024-06-19 14:19:03.623209'),(242,'2024-06-19 14:19:03.672930','2024-06-19 14:19:03.672930','[\"Demographics\",\"Overview\",\"Portfolio performance\"]',NULL,178,_binary '\0','full',NULL,'2024-06-19 14:19:03.672930'),(243,'2024-06-19 14:19:03.721983','2024-06-19 14:19:03.721983','[0,1,2]',NULL,180,_binary '\0','full',NULL,'2024-06-19 14:19:03.721983'),(244,'2024-06-19 14:19:03.794602','2024-06-19 21:00:11.479002','[null,\"dingkai@wishpal.cn\",\"internal@metabase.com\",\"lwl0608@foxmail.com\",\"robin@wishpal.cn\",\"yezian@wishpal.cn\",\"yubingchang@wishpal.cn\",\"zhangzihao@wishpal.cn\",\"zihao@wishpal.cn\"]',NULL,864,_binary '\0','full',NULL,'2024-06-19 14:19:03.794602'),(245,'2024-06-19 14:19:03.832900','2024-06-19 21:00:11.518315','[\"user_0\",\"user_13371338\",\"user_13371339\",\"user_13371340\",\"user_13371341\",\"user_13371342\",\"user_13371343\",\"user_13371344\",\"user_13371345\"]',NULL,863,_binary '\0','full',NULL,'2024-06-19 14:19:03.832900'),(246,'2024-06-19 14:19:03.874323','2024-06-19 21:00:11.550930','[\"dingkai\",\"erwin\",\"External\",\"Metabase\",\"robin\",\"yezian\",\"yubingchang\",\"zhangzihao\",\"zihao\"]',NULL,858,_binary '\0','full',NULL,'2024-06-19 14:19:03.874323'),(247,'2024-06-19 14:19:03.912976','2024-06-19 21:00:11.591090','[null,\"erwin lee\",\"External User\",\"Metabase Internal\"]',NULL,860,_binary '\0','full',NULL,'2024-06-19 14:19:03.912976'),(248,'2024-06-19 14:19:03.952442','2024-06-19 14:19:03.952442','[null,false,true]',NULL,853,_binary '\0','full',NULL,'2024-06-19 14:19:03.952442'),(249,'2024-06-19 14:19:03.990095','2024-06-19 21:00:11.648686','[null,\"Internal\",\"lee\",\"User\"]',NULL,856,_binary '\0','full',NULL,'2024-06-19 14:19:03.990095'),(250,'2024-06-19 14:19:04.031479','2024-06-19 14:19:04.031479','[null]',NULL,855,_binary '\0','full',NULL,'2024-06-19 14:19:04.031479'),(251,'2024-06-19 14:19:04.071254','2024-06-19 14:19:04.071254','[null]',NULL,866,_binary '\0','full',NULL,'2024-06-19 14:19:04.071254'),(252,'2024-06-19 14:19:04.113319','2024-06-19 14:19:04.113319','[\"anonymous\",\"internal\",\"personal\"]',NULL,861,_binary '\0','full',NULL,'2024-06-19 14:19:04.113319'),(253,'2024-06-19 14:19:04.150083','2024-06-19 21:00:11.747035','[0,13371338,13371339,13371340,13371341,13371342,13371343,13371344,13371345]',NULL,857,_binary '\0','full',NULL,'2024-06-19 14:19:04.150083'),(254,'2024-06-19 14:19:04.206718','2024-07-03 21:00:10.097201','[1673597,2354657,2494700,2508146,2566878,2651298,2663141,2698486,2704313,2740997,2787937,2803631,2821525,2879932,2895955,2913659,2948598,3046893,3093182,3094824,3162264,3190436,3397724,3430661,3552523,3708328,3726421,3873202,3935755,4220970,4246707,4430961,4486957,4708757,5083618,5112025,5146586,5208633,5264904,5291797,5456171,5491963,5498751,5594909,5725803,5827787,5851176,6156024,6274460,6387201,6612137,6829741,6847091,6965390,7115176,7224992,7576554,8581933]',NULL,897,_binary '\0','full',NULL,'2024-06-19 14:19:04.206718'),(255,'2024-06-19 14:19:04.270261','2024-06-19 14:19:04.270261','[false]',NULL,391,_binary '\0','full',NULL,'2024-06-19 14:19:04.270261'),(256,'2024-06-19 14:19:04.315506','2024-06-19 14:19:04.315506','[false]',NULL,129,_binary '\0','full',NULL,'2024-06-19 14:19:04.315506'),(257,'2024-06-19 14:19:04.354971','2024-06-19 14:19:04.354971','[null]',NULL,126,_binary '\0','full',NULL,'2024-06-19 14:19:04.354971'),(258,'2024-06-19 14:19:04.397563','2024-06-19 14:19:04.397563','[null]',NULL,134,_binary '\0','full',NULL,'2024-06-19 14:19:04.397563'),(259,'2024-06-19 14:19:04.438877','2024-06-19 21:00:11.971144','[\"16GwZcFFFeLnmTbmU-BXS\",\"53YGAg4EE6MC76nxx-f5f\",\"AaUldk6qL9BnAbpPccXTn\",\"AgXYyKLpWkgK9H4ac-XRS\",\"gbFjHs6U0FxBwabC0qbf3\",\"H8NxROQxeZilSvYGHuKQ7\",\"KCznSMRQwfhO036KYy96r\",\"Ryxr-6cxGNa9tYmTGTxfq\",\"wKLE7lZnZ4PgHU5NwOVEX\"]',NULL,128,_binary '\0','full',NULL,'2024-06-19 14:19:04.438877'),(260,'2024-06-19 14:19:04.480209','2024-06-19 14:19:04.480209','[false,true]',NULL,133,_binary '\0','full',NULL,'2024-06-19 14:19:04.480209'),(261,'2024-06-19 14:19:04.517766','2024-06-19 14:19:04.517766','[\"/\"]',NULL,130,_binary '\0','full',NULL,'2024-06-19 14:19:04.517766'),(262,'2024-06-19 14:19:04.565922','2024-06-19 21:00:12.059407','[\"dingkai的个人收藏\",\"erwinlee的个人收藏集\",\"Examples\",\"robin的个人收藏\",\"yezian的个人收藏\",\"yubingchang的个人收藏\",\"zhangzihao的个人收藏\",\"zihao的个人收藏\",\"铁粉空间\"]',NULL,132,_binary '\0','full',NULL,'2024-06-19 14:19:04.565922'),(263,'2024-06-19 14:19:04.605036','2024-06-19 14:19:04.605036','[null]',NULL,135,_binary '\0','full',NULL,'2024-06-19 14:19:04.605036'),(264,'2024-06-19 14:19:04.643485','2024-06-19 21:00:12.111381','[\"%E9%93%81%E7%B2%89%E7%A9%BA%E9%97%B4\",\"dingkai%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F\",\"erwinlee%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F%E9%9B%86\",\"examples\",\"robin%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F\",\"yezian%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F\",\"yubingchang%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F\",\"zhangzihao%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F\",\"zihao%E7%9A%84%E4%B8%AA%E4%BA%BA%E6%94%B6%E8%97%8F\"]',NULL,125,_binary '\0','full',NULL,'2024-06-19 14:19:04.643485'),(265,'2024-06-19 14:19:04.685102','2024-06-19 14:19:04.685102','[null]',NULL,136,_binary '\0','full',NULL,'2024-06-19 14:19:04.685102'),(266,'2024-06-19 14:19:04.730834','2024-06-20 21:00:11.453456','[null,\"database_1\",\"database_2\"]',NULL,847,_binary '\0','full',NULL,'2024-06-19 14:19:04.730834'),(267,'2024-06-19 14:19:04.766709','2024-07-03 21:00:10.453494','[null,\"{\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":26,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":27,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":30,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":31,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":32,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":33,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":34,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":46,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":72,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":24,\\\"updated\\\":0,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":272,\\\"updated\\\":0,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":56,\\\"updated\\\":74,\\\"deleted\\\":1}\",\"{\\\"fields-classified\\\":0,\\\"fields-failed\\\":0}\",\"{\\\"fields-classified\\\":367,\\\"fields-failed\\\":0}\",\"{\\\"fields-classified\\\":66,\\\"fields-failed\\\":0}\",\"{\\\"flavor\\\":\\\"H2\\\",\\\"version\\\":\\\"2.1.214 (2022-06-13)\\\",\\\"semantic-version\\\":[2,1]}\",\"{\\\"flavor\\\":\\\"MySQL\\\",\\\"version\\\":\\\"8.2.0\\\",\\\"semantic-version\\\":[8,2]}\",\"{\\\"no-data-fingerprints\\\":0,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":0,\\\"fingerprints-attempted\\\":0}\",\"{\\\"no-data-fingerprints\\\":320,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":0,\\\"fingerprints-attempted\\\":320}\",\"{\\\"no-data-fingerprints\\\":320,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":66,\\\"fingerprints-attempted\\\":386}\",\"{\\\"no-data-fingerprints\\\":386,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":367,\\\"fingerprints-attempted\\\":753}\",\"{\\\"timezone-id\\\":\\\"+08:00\\\"}\",\"{\\\"timezone-id\\\":\\\"GMT\\\"}\",\"{\\\"total-fields\\\":71,\\\"updated-fields\\\":0}\",\"{\\\"total-fields\\\":836,\\\"updated-fields\\\":0}\",\"{\\\"total-fields\\\":836,\\\"updated-fields\\\":836}\",\"{\\\"total-fks\\\":113,\\\"updated-fks\\\":0,\\\"total-failed\\\":0}\",\"{\\\"total-fks\\\":113,\\\"updated-fks\\\":113,\\\"total-failed\\\":0}\",\"{\\\"total-fks\\\":6,\\\"updated-fks\\\":0,\\\"total-failed\\\":0}\",\"{\\\"total-indexes\\\":0,\\\"added-indexes\\\":0,\\\"removed-indexes\\\":0}\",\"{\\\"total-indexes\\\":226,\\\"added-indexes\\\":226,\\\"removed-indexes\\\":0}\",\"{\\\"total-tables\\\":8,\\\"tables-classified\\\":0}\",\"{\\\"total-tables\\\":92,\\\"tables-classified\\\":0}\",\"{\\\"total-tables\\\":92,\\\"tables-classified\\\":92}\",\"{\\\"updated-tables\\\":0,\\\"total-tables\\\":8}\",\"{\\\"updated-tables\\\":0,\\\"total-tables\\\":99}\",\"{\\\"updated-tables\\\":99,\\\"total-tables\\\":0}\",\"{}\"]',NULL,848,_binary '\0','full',NULL,'2024-06-19 14:19:04.766709'),(268,'2024-06-19 14:19:04.807053','2024-06-20 21:00:11.522571','[\"analyze\",\"classify-fields\",\"classify-tables\",\"delete-expired-advanced-field-values\",\"field values scanning\",\"fingerprint-fields\",\"sync\",\"sync-dbms-version\",\"sync-fields\",\"sync-fks\",\"sync-indexes\",\"sync-metabase-metadata\",\"sync-table-privileges\",\"sync-tables\",\"sync-timezone\",\"task-history-cleanup\",\"update-field-values\"]',NULL,850,_binary '\0','full',NULL,'2024-06-19 14:19:04.807053'),(269,'2024-06-19 14:19:04.887722','2024-06-19 14:19:04.887722','[\"perms/create-queries\",\"perms/download-results\",\"perms/manage-database\",\"perms/manage-table-metadata\",\"perms/view-data\"]',NULL,191,_binary '\0','full',NULL,'2024-06-19 14:19:04.887722'),(270,'2024-06-19 14:19:04.924389','2024-06-19 14:19:04.924389','[\"no\",\"one-million-rows\",\"query-builder-and-native\",\"unrestricted\"]',NULL,193,_binary '\0','full',NULL,'2024-06-19 14:19:04.924389'),(271,'2024-06-19 14:19:04.963917','2024-06-19 14:19:04.963917','[null]',NULL,194,_binary '\0','full',NULL,'2024-06-19 14:19:04.963917'),(272,'2024-06-19 14:19:05.040230','2024-06-19 14:19:05.040230','[true]',NULL,548,_binary '\0','full',NULL,'2024-06-19 14:19:05.040230'),(273,'2024-06-19 14:19:05.087737','2024-06-29 21:00:11.193948','[4,6,7,8,9,10,11,12,13,14,15,16,17,19,21,22,25,26,28,31,33,36,38,43,59,73,78,87,96,102,105,109,130,132,139,141,144,171,307]',NULL,890,_binary '\0','full',NULL,'2024-06-19 14:19:05.087737'),(274,'2024-06-19 14:19:05.125049','2024-06-29 21:00:11.229222','[196,294,343,392,441,490,539,588,637,686,735,784,833,931,1029,1078,1225,1274,1372,1519,1617,1764,1862,2107,2891,3577,3822,4263,4704,4998,5145,5341,6370,6468,6811,6909,7056,8379,15043]',NULL,876,_binary '\0','full',NULL,'2024-06-19 14:19:05.125049'),(275,'2024-06-19 14:19:05.163729','2024-07-03 21:00:10.989353','[-241,84,189,237,285,286,346,363,367,411,443,451,569,1129,1271,1587,2997,4282,5834,6137,6170,6263,6297,6373,6567,6597,6675,6689,6957,7051,7123,7129,7507,7816,7854,7870,7975,8079,8120,8164,8345,8415,8471,9293,9402,9534,9785,10003,10260,10518,10544,10891,10958,11027,11152,11269,11406,11616,11622,11791,11798,12184,12803,12847,12958,12979,13142,13681,14175,14847,15197,15218,15277,15348,15449,15480,16447,17043,18826,25701]',NULL,892,_binary '\0','full',NULL,'2024-06-19 14:19:05.163729'),(276,'2024-06-19 14:19:05.216248','2024-07-03 21:00:11.019760','[0,1,3,4,5,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,30,31,32,33,34,36,37,38,39,40,41,42,51,53]',NULL,888,_binary '\0','full',NULL,'2024-06-19 14:19:05.216248'),(277,'2024-06-19 14:19:05.266246','2024-07-03 21:00:11.051578','[0,1,50,100,110,179,200,269,325,446,499,633,817,949,1035,1058,1059,1095,1154,1192,1247,1348,1378,1456,1550,1653,1655,1682,2133,2330,2365,2425,2477,2764,2886,2961,2974,3107,3241,3262,3295,3363,3411,3414,3486,3593,3695,3922,3948,3978,3989,4018,4049,4119,4348,4684,4713,4813,4916,4937,5259,5469,5598,6161,6292,6332,6481,6828,7144,7457,7847,8371,9494,12977,13801]',NULL,878,_binary '\0','full',NULL,'2024-06-19 14:19:05.266246'),(278,'2024-06-19 14:19:05.309956','2024-07-03 21:00:11.088376','[83,117,156,157,274,330,354,437,475,542,584,1200,3116,3513,4473,6428,12413,12453,14577,15653,16961,17476,18216,18380,19380,19397,19461,19505,19782,19861,20847,20907,21063,21277,21346,21658,21692,21708,22280,23222,24094,24256,25864,26395,26873,27648,29003,29412,30378,31011,33173,34775,34866,36703,37043,39274,39557,39567,39842,40093,40679,41700,43120,43428,44226,44297,45449,46327,48800,49794,51255,51372,53293,54445,55851,56982,59347,67028]',NULL,895,_binary '\0','full',NULL,'2024-06-19 14:19:05.309956'),(279,'2024-06-19 14:19:05.349841','2024-07-03 21:00:11.121554','[196,394,414,441,442,494,503,543,637,686,842,985,1035,2787,4642,5744,6113,13025,16735,20229,24947,25081,25438,25677,26193,26512,26631,26984,27180,27359,27878,28036,28234,28799,28969,29165,29485,30279,30467,30673,30931,31581,31952,33003,33996,34335,35623,37082,37282,38542,39356,41875,42466,44309,44869,47247,50836,51120,51464,52085,52658,52955,54580,54918,55006,56017,57276,58296,58511,61758,62744,63969,66219,68298,68490,69663,71199,72259,75794,85854]',NULL,893,_binary '\0','full',NULL,'2024-06-19 14:19:05.349841'),(280,'2024-06-19 14:19:05.391372','2024-07-03 21:00:11.151128','[0,1,2,4,12,13,27,63,108,121,122,135,143,144,149,150,155,156,161,188,199,211,249,265,314,386,411,452,481,489,509,521,535,541,545,553,560,566,579,605,623,645,654,701,718,719,735,739,752,757,780,804,892,965,969,1098,1120,1153,1172,1271,1378,1538,1547,1766,1943,2324,2640,2711]',NULL,883,_binary '\0','full',NULL,'2024-06-19 14:19:05.391372'),(281,'2024-06-19 14:19:05.427338','2024-07-03 21:00:11.179460','[0,2,70,99,396,1188,1189,2533,4666,8417,8798,8967,10467,10808,11354,11394,11942,12267,12402,12652,12689,12992,13539,14221,14520,14732,15510,15746,15841,15976,16212,16519,16538,16794,16853,17049,18249,18502,18605,19229,19742,20105,20697,20801,21277,21377,22031,22570,22861,23483,23501,24790,24890,24908,25595,26651,26800,27294,27685,28628,28652,30569,30917,32619,32659,33756,37104,37381,39989,41545,50177]',NULL,889,_binary '\0','full',NULL,'2024-06-19 14:19:05.427338'),(282,'2024-06-19 14:19:05.466565','2024-07-03 21:00:11.212922','[0,1,2,4,6,25,46,58,70,72,83,87,88,96,97,102,104,105,118,132,137,140,226,267,271,273,298,317,328,343,345,359,365,366,399,403,412,416,429,446,464,480,488,492,495,496,523,531,542,550,575,606,608,612,643,644,649,651,655,659,661,702,723,970,1802]',NULL,881,_binary '\0','full',NULL,'2024-06-19 14:19:05.466565'),(283,'2024-06-19 14:19:05.510959','2024-07-03 21:00:11.242638','[0,87,399,524,1468,3307,5151,5644,5653,6324,6393,6578,6793,6833,6878,7224,7252,7626,7938,8011,8182,8298,8329,8412,8665,8754,8964,9094,9169,9267,9378,9560,9831,9898,10230,10291,10805,10820,11279,11938,12080,12094,12540,12584,13118,13354,13433,13526,13852,13991,14350,14948,15008,15118,15237,15441,15834,16067,16153,16490,17689,18377,18704,19017,19115,21974,26617]',NULL,877,_binary '\0','full',NULL,'2024-06-19 14:19:05.510959'),(284,'2024-06-19 14:19:05.557919','2024-06-29 21:00:11.560636','[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,18,19,22]',NULL,884,_binary '\0','full',NULL,'2024-06-19 14:19:05.557919'),(285,'2024-06-19 14:19:05.635191','2024-07-03 21:00:11.296699','[0,297,298,337,414,674,863,914,917,995,1182,1312,1494,1590,1602,1849,1873,1913,2365,2684,2888,2891,3087,3214,3584,3639,3741,3759,3862,4160,4679,4800,4987,5159,5483,5691,5776,5988,6117,6177,6251,6811,7355,7389,7473,7479,7692,7818,8356,8442,9297,9363,9792,10214,10431,12183,12643,13260]',NULL,886,_binary '\0','full',NULL,'2024-06-19 14:19:05.635191'),(286,'2024-06-19 14:19:05.692743','2024-06-19 14:19:05.692743','[null]',NULL,385,_binary '\0','full',NULL,'2024-06-19 14:19:05.692743'),(287,'2024-06-19 14:19:05.733312','2024-06-19 14:19:05.733312','[\"Administrators\",\"All Users\"]',NULL,387,_binary '\0','full',NULL,'2024-06-19 14:19:05.733312'),(288,'2024-06-19 14:19:05.783030','2024-06-19 14:19:05.783030','[false]',NULL,303,_binary '\0','full',NULL,'2024-06-19 14:19:05.783030'),(289,'2024-06-19 14:19:05.824442','2024-06-19 14:19:05.824442','[null]',NULL,298,_binary '\0','full',NULL,'2024-06-19 14:19:05.824442'),(290,'2024-06-19 14:19:05.873311','2024-06-19 14:19:05.873311','[null]',NULL,302,_binary '\0','full',NULL,'2024-06-19 14:19:05.873311'),(291,'2024-06-19 14:19:05.923741','2024-06-19 14:19:05.923741','[\"full\"]',NULL,305,_binary '\0','full',NULL,'2024-06-19 14:19:05.923741'),(292,'2024-06-19 14:19:06.039864','2024-06-20 21:00:12.615739','[null,1,2]',NULL,684,_binary '\0','full',NULL,'2024-06-19 14:19:06.039864'),(294,'2024-06-19 14:19:06.129043','2024-06-19 14:19:06.129043','[\"started\",\"success\"]',NULL,687,_binary '\0','full',NULL,'2024-06-19 14:19:06.129043'),(295,'2024-06-19 14:19:06.169932','2024-06-20 21:00:12.715032','[\"analyze\",\"classify-fields\",\"classify-tables\",\"delete-expired-advanced-field-values\",\"field values scanning\",\"fingerprint-fields\",\"sync\",\"sync-dbms-version\",\"sync-fields\",\"sync-fks\",\"sync-indexes\",\"sync-metabase-metadata\",\"sync-table-privileges\",\"sync-tables\",\"sync-timezone\",\"task-history-cleanup\",\"update-field-values\"]',NULL,681,_binary '\0','full',NULL,'2024-06-19 14:19:06.169932'),(296,'2024-06-19 14:19:06.211436','2024-07-03 21:00:11.581895','[null,\"{\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":26,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":27,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":30,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":31,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":32,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":33,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":34,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":46,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":0,\\\"updated\\\":72,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":24,\\\"updated\\\":0,\\\"deleted\\\":0}\",\"{\\\"errors\\\":0,\\\"created\\\":272,\\\"updated\\\":0,\\\"deleted\\\":1}\",\"{\\\"errors\\\":0,\\\"created\\\":56,\\\"updated\\\":74,\\\"deleted\\\":1}\",\"{\\\"fields-classified\\\":0,\\\"fields-failed\\\":0}\",\"{\\\"fields-classified\\\":367,\\\"fields-failed\\\":0}\",\"{\\\"fields-classified\\\":66,\\\"fields-failed\\\":0}\",\"{\\\"flavor\\\":\\\"H2\\\",\\\"version\\\":\\\"2.1.214 (2022-06-13)\\\",\\\"semantic-version\\\":[2,1]}\",\"{\\\"flavor\\\":\\\"MySQL\\\",\\\"version\\\":\\\"8.2.0\\\",\\\"semantic-version\\\":[8,2]}\",\"{\\\"no-data-fingerprints\\\":0,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":0,\\\"fingerprints-attempted\\\":0}\",\"{\\\"no-data-fingerprints\\\":320,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":0,\\\"fingerprints-attempted\\\":320}\",\"{\\\"no-data-fingerprints\\\":320,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":66,\\\"fingerprints-attempted\\\":386}\",\"{\\\"no-data-fingerprints\\\":386,\\\"failed-fingerprints\\\":0,\\\"updated-fingerprints\\\":367,\\\"fingerprints-attempted\\\":753}\",\"{\\\"timezone-id\\\":\\\"+08:00\\\"}\",\"{\\\"timezone-id\\\":\\\"GMT\\\"}\",\"{\\\"total-fields\\\":71,\\\"updated-fields\\\":0}\",\"{\\\"total-fields\\\":836,\\\"updated-fields\\\":0}\",\"{\\\"total-fields\\\":836,\\\"updated-fields\\\":836}\",\"{\\\"total-fks\\\":113,\\\"updated-fks\\\":0,\\\"total-failed\\\":0}\",\"{\\\"total-fks\\\":113,\\\"updated-fks\\\":113,\\\"total-failed\\\":0}\",\"{\\\"total-fks\\\":6,\\\"updated-fks\\\":0,\\\"total-failed\\\":0}\",\"{\\\"total-indexes\\\":0,\\\"added-indexes\\\":0,\\\"removed-indexes\\\":0}\",\"{\\\"total-indexes\\\":226,\\\"added-indexes\\\":226,\\\"removed-indexes\\\":0}\",\"{\\\"total-tables\\\":8,\\\"tables-classified\\\":0}\",\"{\\\"total-tables\\\":92,\\\"tables-classified\\\":0}\",\"{\\\"total-tables\\\":92,\\\"tables-classified\\\":92}\",\"{\\\"updated-tables\\\":0,\\\"total-tables\\\":8}\",\"{\\\"updated-tables\\\":0,\\\"total-tables\\\":99}\",\"{\\\"updated-tables\\\":99,\\\"total-tables\\\":0}\",\"{}\"]',NULL,686,_binary '\0','full',NULL,'2024-06-19 14:19:06.211436'),(297,'2024-06-19 21:00:03.229903','2024-06-19 21:00:03.229903','[null]',NULL,818,_binary '\0','full',NULL,'2024-06-19 21:00:03.229903'),(298,'2024-06-19 21:00:03.259521','2024-06-19 21:00:03.259521','[null]',NULL,820,_binary '\0','full',NULL,'2024-06-19 21:00:03.259521'),(299,'2024-06-19 21:00:03.288928','2024-06-20 21:00:03.061464','[null,0]',NULL,813,_binary '\0','full',NULL,'2024-06-19 21:00:03.288928'),(300,'2024-06-19 21:00:03.319385','2024-06-30 21:00:03.426538','[null,27,28,29,30,31]',NULL,802,_binary '\0','full',NULL,'2024-06-19 21:00:03.319385'),(301,'2024-06-19 21:00:03.347920','2024-06-30 21:00:03.462760','[null,\"card_27\",\"card_28\",\"card_29\",\"card_30\",\"card_31\"]',NULL,815,_binary '\0','full',NULL,'2024-06-19 21:00:03.347920'),(302,'2024-06-19 21:00:03.376551','2024-06-19 21:00:03.376551','[null,2]',NULL,809,_binary '\0','full',NULL,'2024-06-19 21:00:03.376551'),(303,'2024-06-19 21:00:03.405111','2024-06-19 21:00:03.405111','[null,\"dashboard_2\"]',NULL,810,_binary '\0','full',NULL,'2024-06-19 21:00:03.405111'),(304,'2024-06-19 21:00:03.434060','2024-06-19 21:00:03.434060','[2]',NULL,819,_binary '\0','full',NULL,'2024-06-19 21:00:03.434060'),(305,'2024-06-19 21:00:03.464192','2024-06-19 21:00:03.464192','[\"database_2\"]',NULL,811,_binary '\0','full',NULL,'2024-06-19 21:00:03.464192'),(307,'2024-06-19 21:00:03.534717','2024-06-22 21:00:03.259028','[null,\"(conn=1096) Unknown column \'pdate\' in \'where clause\'\",\"(conn=1096) Unknown column \'t2.t\' in \'field list\'\",\"减少结果行数的错误。null\"]',NULL,812,_binary '\0','full',NULL,'2024-06-19 21:00:03.534717'),(308,'2024-06-19 21:00:03.563550','2024-06-19 21:00:03.563550','[1]',NULL,814,_binary '\0','full',NULL,'2024-06-19 21:00:03.563550'),(309,'2024-06-19 21:00:03.592578','2024-06-19 21:00:03.592578','[null]',NULL,803,_binary '\0','full',NULL,'2024-06-19 21:00:03.592578'),(310,'2024-06-19 21:00:03.621395','2024-06-30 21:00:03.724721','[\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail\\\\nORDER BY ptime DESC\\\\n;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'主播昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"},\\\"viz-settings\\\":{},\\\"database\\\":2}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name \'昵称\',\\\\n        t1.income \'主播收入\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name != \'\'\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.t,\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t1.t\\\\n;\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t2.t,\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t1.t\\\\n;\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t2.t,\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM streamer;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_cur_streamer_income;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(ptime, \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_flow WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_yoy_flow WHERE pdate>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT NOW()\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT ptime, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT ptime, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT t2.t, t2.flow, t1.flow, t0.flow\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail\\\\nORDER BY ptime DESC\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT * FROM vas_day_flow WHERE pdate>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_flow;\\\",\\\"template-tags\\\":{}},\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT flow FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\",\\\"template-tags\\\":{}},\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\",\\\"template-tags\\\":{}},\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\"]',NULL,816,_binary '\0','full',NULL,'2024-06-19 21:00:03.621395'),(311,'2024-06-19 21:00:03.651425','2024-06-19 21:00:03.651425','[\"ad-hoc\",\"dashboard\",\"question\"]',NULL,817,_binary '\0','full',NULL,'2024-06-19 21:00:03.651425'),(312,'2024-06-19 21:00:03.682408','2024-07-03 21:00:03.748202','[0,1,3,5,6,7,8,10,11,12,14,15,16,17,18,21,22,23,24,25,26,27,28,29,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,141,142,143,288,394,488]',NULL,805,_binary '\0','full',NULL,'2024-06-19 21:00:03.682408'),(313,'2024-06-19 21:00:03.713776','2024-06-19 21:00:03.713776','[13371339,13371340,13371341,13371345]',NULL,806,_binary '\0','full',NULL,'2024-06-19 21:00:03.713776'),(314,'2024-06-19 21:00:04.164296','2024-07-03 21:00:04.132096','[\"Mozilla/5.0 (iPad; CPU OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1\",\"Mozilla/5.0 (iPhone; CPU iPhone OS 17_4_1 like Mac OS X; zh-CN) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/21E236 UCBrowser/16.5.5.2341 Mobile  AliApp(TUnionSDK/0.1.20.4)\",\"Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/125.0.2535.96 Version/18.0 Mobile/15E148 Safari/604.1\",\"Mozilla/5.0 (iPhone; CPU iPhone OS 18_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) EdgiOS/126.0.2592.78 Version/18.0 Mobile/15E148 Safari/604.1\",\"Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/125.0.0.0 Mobile Safari/537.36\",\"Mozilla/5.0 (Linux; Android 10; K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Mobile Safari/537.36\",\"Mozilla/5.0 (Linux; Android 10; SM-A750F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.50 Mobile Safari/537.36\",\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36 Edg/114.0.1823.67\",\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/125.0.0.0 Safari/537.36\",\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36 Edg/126.0.0.0\",\"Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/122.0.6261.95 Safari/537.36\"]',NULL,230,_binary '\0','full',NULL,'2024-06-19 21:00:04.164296'),(315,'2024-06-19 21:00:04.197726','2024-07-01 21:00:03.801176','[\"1014f61c-ca50-4fd8-82dd-77929b4906ed\",\"262dc2fb-0309-4dc9-a373-c14708a49125\",\"26e077f2-9742-4cbe-9908-a35aec5c06d1\",\"350d08dd-1161-4b10-b27b-3dcb84e213d2\",\"556b0ab9-fb51-437a-8b3c-a4325156c97f\",\"64881057-6929-4650-acf2-c2f32fabbd12\",\"6cba3edf-a77f-41d2-a1a2-89ba58ad22fa\",\"70739096-7d4a-484b-ba4e-afc343b4cdd6\",\"ae301ed1-4920-4e8d-ab13-757557eca791\",\"ae529c00-191b-4696-a238-9c8997aa5157\",\"b8cd46c4-43a3-441d-9304-34adbd408dba\",\"c063efb6-2a2b-48c2-8941-77a656391a79\",\"d7f7342a-d4cc-4019-a1a6-339e98b3da8c\",\"e1bedb61-f25d-456a-9966-115007fc0b0a\",\"ea38a004-e661-4df5-aebb-f38a45e22c68\",\"eb28b4f7-dd9c-4b7e-b0cf-34896df6b062\",\"eb37810d-0d97-4c6d-aab3-aca5d5649d9b\",\"f16d848b-47ce-40c7-bd2e-ea02989e24ca\"]',NULL,236,_binary '\0','full',NULL,'2024-06-19 21:00:04.197726'),(316,'2024-06-19 21:00:04.231557','2024-07-03 21:00:04.190333','[\"101.204.219.101\",\"114.250.139.60\",\"116.169.10.158\",\"116.169.6.123\",\"116.169.80.229\",\"118.113.120.245\",\"119.4.179.152\",\"119.4.68.236\",\"124.127.70.185\",\"183.94.48.151\",\"211.137.80.13\",\"222.130.159.174\",\"223.104.122.52\",\"223.104.41.225\",\"223.104.41.249\",\"27.17.70.102\",\"27.19.184.81\"]',NULL,234,_binary '\0','full',NULL,'2024-06-19 21:00:04.231557'),(317,'2024-06-19 21:00:04.876917','2024-07-03 21:00:04.657887','[9,10,11,14,15,16,18,19,24,28,36,42,47,56,66,79,116,120,137,140,149,160,175,183,184,197,220,228,241,255,307,491]',NULL,527,_binary '\0','full',NULL,'2024-06-19 21:00:04.876917'),(318,'2024-06-19 21:00:04.912560','2024-06-30 21:00:04.611839','[\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"process-viz-settings?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail\\\\nORDER BY ptime DESC\\\\n;\\\"},\\\"viz-settings\\\":null,\\\"database\\\":2}\",\"{\\\"constraints\\\":{\\\"max-results\\\":10000,\\\"max-results-bare-rows\\\":2000},\\\"type\\\":\\\"native\\\",\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"ignore-cached-results?\\\":false,\\\"userland-query?\\\":true},\\\"cache-strategy\\\":null,\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'主播昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"},\\\"viz-settings\\\":{},\\\"database\\\":2}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name \'昵称\',\\\\n        t1.income \'主播收入\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name != \'\'\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t1.t,\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t1.t\\\\n;\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t2.t,\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t1.t\\\\n;\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT  t2.t,\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM streamer;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_cur_streamer_income;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(ptime, \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_flow WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_yoy_flow WHERE pdate>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\\n\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT NOW()\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT ptime, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT ptime, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT t2.t, t2.flow, t1.flow, t0.flow\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail\\\\nORDER BY ptime DESC\\\\n;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail;\\\",\\\"template-tags\\\":{}},\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT * FROM vas_day_flow WHERE pdate>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\"},\\\"type\\\":\\\"native\\\",\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT * FROM vas_day_flow;\\\",\\\"template-tags\\\":{}},\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT flow FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\",\\\"template-tags\\\":{}},\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\",\"{\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\",\\\"template-tags\\\":{}},\\\"database\\\":2,\\\"middleware\\\":{\\\"js-int-to-string?\\\":true,\\\"userland-query?\\\":true,\\\"add-default-userland-constraints?\\\":true}}\"]',NULL,525,_binary '\0','full',NULL,'2024-06-19 21:00:04.912560'),(319,'2024-06-19 21:00:06.009733','2024-06-19 21:00:06.009733','[false,true]',NULL,639,_binary '\0','full',NULL,'2024-06-19 21:00:06.009733'),(320,'2024-06-19 21:00:06.049813','2024-06-19 21:00:06.049813','[false]',NULL,634,_binary '\0','full',NULL,'2024-06-19 21:00:06.049813'),(321,'2024-06-19 21:00:06.100187','2024-06-19 21:00:06.100187','[null]',NULL,637,_binary '\0','full',NULL,'2024-06-19 21:00:06.100187'),(322,'2024-06-19 21:00:06.138085','2024-06-19 21:00:06.138085','[\"v0.50.5 (48f6978)\"]',NULL,635,_binary '\0','full',NULL,'2024-06-19 21:00:06.138085'),(323,'2024-06-19 21:00:06.174746','2024-06-19 21:00:06.174746','[\"Card\",\"Dashboard\"]',NULL,632,_binary '\0','full',NULL,'2024-06-19 21:00:06.174746'),(324,'2024-06-19 21:00:06.210807','2024-06-30 21:00:05.464643','[2,27,28,29,30,31]',NULL,631,_binary '\0','full',NULL,'2024-06-19 21:00:06.210807'),(325,'2024-06-19 21:00:06.240935','2024-06-19 21:00:06.240935','[false,true]',NULL,638,_binary '\0','full',NULL,'2024-06-19 21:00:06.240935'),(326,'2024-06-19 21:00:06.272258','2024-06-30 21:00:05.520756','[\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":1,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"三日时分同比\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"line\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"table.cell_column\\\":\\\"前天\\\",\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.x_axis.axis_enabled\\\":\\\"rotate-45\\\",\\\"graph.show_values\\\":true,\\\"graph.label_value_formatting\\\":\\\"auto\\\",\\\"graph.dimensions\\\":[\\\"时间\\\"],\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"时间\\\\\\\"]\\\":{\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}},\\\"graph.metrics\\\":[\\\"前天\\\",\\\"昨天\\\",\\\"今天\\\"]},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"三日时分同比new\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"table\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"table.cell_column\\\":\\\"前天\\\",\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"时间\\\\\\\"]\\\":{\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"三日时分同比new\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"line\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"table.cell_column\\\":\\\"前天\\\",\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.x_axis.axis_enabled\\\":\\\"rotate-45\\\",\\\"graph.show_values\\\":true,\\\"graph.label_value_formatting\\\":\\\"auto\\\",\\\"graph.dimensions\\\":[\\\"时间\\\"],\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"时间\\\\\\\"]\\\":{\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}},\\\"graph.metrics\\\":[\\\"前天\\\",\\\"昨天\\\",\\\"今天\\\"]},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"三日流水时分同比\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"line\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"graph.show_goal\\\":false,\\\"graph.show_trendline\\\":false,\\\"graph.show_values\\\":true,\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":\\\"rotate-90\\\",\\\"graph.y_axis.scale\\\":\\\"linear\\\",\\\"graph.label_value_frequency\\\":\\\"fit\\\",\\\"graph.metrics\\\":[\\\"前天\\\",\\\"昨天\\\",\\\"今天\\\"],\\\"graph.y_axis.axis_enabled\\\":true,\\\"graph.label_value_formatting\\\":\\\"auto\\\",\\\"graph.series_order\\\":null,\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"t\\\\\\\"]\\\":{\\\"time_enabled\\\":\\\"seconds\\\",\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}},\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"时间\\\"]},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"主播当日收入榜\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'主播昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"table\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"table.pivot_column\\\":\\\"昵称\\\",\\\"table.cell_column\\\":\\\"主播mid\\\",\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播mid\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播user_id\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播收入(钻石)\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"主播当日收入榜\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t1.mid AS \'主播mid\',\\\\n        t2.user_id AS \'主播user_id\',\\\\n        t2.name AS \'昵称\',\\\\n        t1.income AS \'主播收入(钻石)\'\\\\nFROM\\\\n(\\\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nLEFT JOIN\\\\n(\\\\n        SELECT mid,user_id,name FROM streamer\\\\n) t2\\\\nON t1.mid=t2.mid\\\\nWHERE t2.name!=\'\'\\\\nORDER BY t1.income DESC\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"table\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"table.pivot_column\\\":\\\"昵称\\\",\\\"table.cell_column\\\":\\\"主播mid\\\",\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播mid\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播user_id\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"主播收入(钻石)\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"当日流水\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"scalar\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"flow/100\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"每日收入明细\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT\\\\n\\\\tptime   \'时间\',\\\\n\\\\tmembership_cnt   \'会员数\',\\\\n\\\\tmembership_flow   \'会员流水\',\\\\n\\\\tzone_admission_cnt   \'空间解锁数\',\\\\n\\\\tzone_admission_flow   \'空间解锁流水\',\\\\n\\\\tzone_superfan_cnt   \'空间超粉数\',\\\\n\\\\tzone_superfan_flow   \'空间超粉流水\',\\\\n\\\\tzone_moment_cnt   \'空间动态数\',\\\\n\\\\tzone_moment_flow   \'空间动态流水\',\\\\n\\\\tother_cnt   \'其他数(微信+金币)\',\\\\n\\\\tother_flow   \'其他流水(微信+金币)\',\\\\n\\\\ttotal_flow   \'总流水\',\\\\n\\\\tstreamer_flow   \'主播分成\',\\\\n\\\\tofficial_flow   \'净收入\',\\\\n\\\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\\\n\\\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\\\n\\\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\\\n\\\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\\\n\\\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\\\n\\\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\\\nFROM vas_day_detail\\\\nORDER BY ptime DESC\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"table\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"table.cell_column\\\":\\\"会员数\\\",\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"时间\\\\\\\"]\\\":{\\\"time_style\\\":\\\"HH:mm\\\",\\\"date_style\\\":\\\"YYYY/M/D\\\"}}},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":null,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"当日流水\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"scalar\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"flow/100\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}}},\\\"parameters\\\":[]}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"fixed\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":3,\\\"dashboard_id\\\":2,\\\"row\\\":0}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":33,\\\"parameter_mappings\\\":[],\\\"card_id\\\":28,\\\"visualization_settings\\\":{},\\\"size_y\\\":7,\\\"dashboard_id\\\":2,\\\"row\\\":2}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":34,\\\"parameter_mappings\\\":[],\\\"card_id\\\":29,\\\"visualization_settings\\\":{},\\\"size_y\\\":8,\\\"dashboard_id\\\":2,\\\"row\\\":2},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":35,\\\"parameter_mappings\\\":[],\\\"card_id\\\":30,\\\"visualization_settings\\\":{},\\\"size_y\\\":5,\\\"dashboard_id\\\":2,\\\"row\\\":10},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":36,\\\"parameter_mappings\\\":[],\\\"card_id\\\":31,\\\"visualization_settings\\\":{},\\\"size_y\\\":8,\\\"dashboard_id\\\":2,\\\"row\\\":15}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":34,\\\"parameter_mappings\\\":[],\\\"card_id\\\":29,\\\"visualization_settings\\\":{},\\\"size_y\\\":8,\\\"dashboard_id\\\":2,\\\"row\\\":2},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":35,\\\"parameter_mappings\\\":[],\\\"card_id\\\":30,\\\"visualization_settings\\\":{},\\\"size_y\\\":5,\\\"dashboard_id\\\":2,\\\"row\\\":10}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0},{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":34,\\\"parameter_mappings\\\":[],\\\"card_id\\\":29,\\\"visualization_settings\\\":{},\\\"size_y\\\":8,\\\"dashboard_id\\\":2,\\\"row\\\":2}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":3,\\\"dashboard_id\\\":2,\\\"row\\\":0}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":null,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"fixed\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":null,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"fixed\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":3,\\\"dashboard_id\\\":2,\\\"row\\\":0}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":false,\\\"collection_position\\\":null,\\\"tabs\\\":[],\\\"enable_embedding\\\":false,\\\"collection_id\\\":null,\\\"name\\\":\\\"ironfan-增值\\\",\\\"width\\\":\\\"full\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"cards\\\":[{\\\"size_x\\\":24,\\\"dashboard_tab_id\\\":null,\\\"series\\\":[],\\\"action_id\\\":null,\\\"col\\\":0,\\\"id\\\":32,\\\"parameter_mappings\\\":[],\\\"card_id\\\":27,\\\"visualization_settings\\\":{},\\\"size_y\\\":2,\\\"dashboard_id\\\":2,\\\"row\\\":0}],\\\"parameters\\\":[],\\\"auto_apply_filters\\\":true}\",\"{\\\"description\\\":null,\\\"archived\\\":true,\\\"collection_position\\\":null,\\\"table_id\\\":null,\\\"database_id\\\":2,\\\"enable_embedding\\\":false,\\\"collection_id\\\":3,\\\"query_type\\\":\\\"native\\\",\\\"name\\\":\\\"三日流水时分同比\\\",\\\"type\\\":\\\"question\\\",\\\"embedding_params\\\":null,\\\"cache_ttl\\\":null,\\\"dataset_query\\\":{\\\"database\\\":2,\\\"type\\\":\\\"native\\\",\\\"native\\\":{\\\"template-tags\\\":{},\\\"query\\\":\\\"SELECT  t2.t AS \'时间\',\\\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\\\nFROM\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\\\n) t2\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t1\\\\nON t1.t=t2.t\\\\nLEFT JOIN\\\\n(\\\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\\\n) t0\\\\nON t0.t=t2.t\\\\n;\\\"}},\\\"parameter_mappings\\\":[],\\\"display\\\":\\\"line\\\",\\\"collection_preview\\\":true,\\\"visualization_settings\\\":{\\\"graph.show_goal\\\":false,\\\"graph.show_trendline\\\":false,\\\"graph.show_values\\\":true,\\\"graph.x_axis.labels_enabled\\\":false,\\\"graph.series_order_dimension\\\":null,\\\"graph.x_axis.axis_enabled\\\":\\\"rotate-90\\\",\\\"graph.y_axis.scale\\\":\\\"linear\\\",\\\"graph.label_value_frequency\\\":\\\"fit\\\",\\\"graph.metrics\\\":[\\\"前天\\\",\\\"昨天\\\",\\\"今天\\\"],\\\"graph.y_axis.axis_enabled\\\":true,\\\"graph.label_value_formatting\\\":\\\"auto\\\",\\\"graph.series_order\\\":null,\\\"column_settings\\\":{\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"t\\\\\\\"]\\\":{\\\"time_enabled\\\":\\\"seconds\\\",\\\"time_style\\\":\\\"HH:mm\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"前天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"昨天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"},\\\"[\\\\\\\"name\\\\\\\",\\\\\\\"今天\\\\\\\"]\\\":{\\\"number_separators\\\":\\\".\\\"}},\\\"graph.x_axis.scale\\\":\\\"ordinal\\\",\\\"graph.dimensions\\\":[\\\"时间\\\"]},\\\"parameters\\\":[]}\"]',NULL,640,_binary '\0','full',NULL,'2024-06-19 21:00:06.272258'),(327,'2024-06-19 21:00:07.256191','2024-06-19 21:00:07.256191','[\"card\",\"collection\",\"dashboard\"]',NULL,555,_binary '\0','full',NULL,'2024-06-19 21:00:07.256191'),(328,'2024-06-19 21:00:07.290836','2024-06-30 21:00:06.435562','[2,3,27,28,29,30,31]',NULL,553,_binary '\0','full',NULL,'2024-06-19 21:00:07.290836'),(329,'2024-06-19 21:00:07.340863','2024-06-19 21:00:07.340863','[null]',NULL,537,_binary '\0','full',NULL,'2024-06-19 21:00:07.340863'),(330,'2024-06-19 21:00:07.372923','2024-06-20 21:00:06.818962','[null,false]',NULL,539,_binary '\0','full',NULL,'2024-06-19 21:00:07.372923'),(331,'2024-06-19 21:00:07.409723','2024-06-30 21:00:06.522035','[null,27,28,29,30,31]',NULL,540,_binary '\0','full',NULL,'2024-06-19 21:00:07.409723'),(332,'2024-06-19 21:00:07.442354','2024-06-19 21:00:07.442354','[\"ad-hoc\",\"dashboard\",\"question\"]',NULL,547,_binary '\0','full',NULL,'2024-06-19 21:00:07.442354'),(333,'2024-06-19 21:00:07.475009','2024-06-19 21:00:07.475009','[null,2]',NULL,544,_binary '\0','full',NULL,'2024-06-19 21:00:07.475009'),(334,'2024-06-19 21:00:07.508104','2024-06-19 21:00:07.508104','[2]',NULL,536,_binary '\0','full',NULL,'2024-06-19 21:00:07.508104'),(335,'2024-06-19 21:00:07.540120','2024-06-22 21:00:06.319179','[null,\"(conn=1096) Unknown column \'pdate\' in \'where clause\'\",\"(conn=1096) Unknown column \'t2.t\' in \'field list\'\",\"减少结果行数的错误。null\"]',NULL,531,_binary '\0','full',NULL,'2024-06-19 21:00:07.540120'),(336,'2024-06-19 21:00:07.571407','2024-06-19 21:00:07.571407','[13371339,13371340,13371341,13371345]',NULL,542,_binary '\0','full',NULL,'2024-06-19 21:00:07.571407'),(337,'2024-06-19 21:00:07.613643','2024-06-20 21:00:07.035873','[null,false]',NULL,535,_binary '\0','full',NULL,'2024-06-19 21:00:07.613643'),(338,'2024-06-19 21:00:07.645738','2024-06-19 21:00:07.645738','[true]',NULL,538,_binary '\0','full',NULL,'2024-06-19 21:00:07.645738'),(339,'2024-06-19 21:00:07.675926','2024-06-19 21:00:07.675926','[null]',NULL,545,_binary '\0','full',NULL,'2024-06-19 21:00:07.675926'),(340,'2024-06-19 21:00:07.707185','2024-07-03 21:00:06.869498','[0,1,3,5,6,7,8,10,11,12,14,15,16,17,18,21,22,23,24,25,26,27,28,29,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,141,142,143,288,394,488]',NULL,532,_binary '\0','full',NULL,'2024-06-19 21:00:07.707185'),(341,'2024-06-19 21:00:07.740798','2024-07-03 21:00:06.908994','[9,10,11,14,15,16,18,19,24,28,35,36,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,355,356,357,359,360,361,362,363,364,365,366,367,369,370,371,372,373,374,375,376,377,378,380,381,382,383,384,385,386,387,388,390,392,393,394,395,397,398,400,403,415,417,423,425,426,434,435,438,439,440,449,461,462,463,466,491,517,520,590,622,671]',NULL,543,_binary '\0','full',NULL,'2024-06-19 21:00:07.740798'),(342,'2024-06-19 21:00:12.252096','2024-07-03 21:00:10.519437','[1720040400002]',NULL,467,_binary '\0','full',NULL,'2024-06-19 21:00:12.252096'),(343,'2024-06-19 21:00:12.281732','2024-06-19 21:00:12.281732','[\"39bc26db45631718806416712\"]',NULL,462,_binary '\0','full',NULL,'2024-06-19 21:00:12.281732'),(344,'2024-06-19 21:00:12.310524','2024-06-19 21:00:12.310524','[true]',NULL,469,_binary '\0','full',NULL,'2024-06-19 21:00:12.310524'),(345,'2024-06-19 21:00:12.338877','2024-06-19 21:00:12.338877','[\"DEFAULT\"]',NULL,463,_binary '\0','full',NULL,'2024-06-19 21:00:12.338877'),(346,'2024-06-19 21:00:12.367216','2024-06-19 21:00:12.367216','[\"metabase.task.update-field-values.job\"]',NULL,470,_binary '\0','full',NULL,'2024-06-19 21:00:12.367216'),(347,'2024-06-19 21:00:12.395803','2024-06-19 21:00:12.395803','[5]',NULL,466,_binary '\0','full',NULL,'2024-06-19 21:00:12.395803'),(348,'2024-06-19 21:00:12.424901','2024-06-19 21:00:12.424901','[false]',NULL,465,_binary '\0','full',NULL,'2024-06-19 21:00:12.424901'),(349,'2024-06-19 21:00:12.455419','2024-07-03 21:00:10.679091','[1720040400000]',NULL,458,_binary '\0','full',NULL,'2024-06-19 21:00:12.455419'),(350,'2024-06-19 21:00:12.485792','2024-06-19 21:00:12.485792','[\"EXECUTING\"]',NULL,460,_binary '\0','full',NULL,'2024-06-19 21:00:12.485792'),(351,'2024-06-19 21:00:12.516010','2024-06-19 21:00:12.516010','[\"DEFAULT\"]',NULL,459,_binary '\0','full',NULL,'2024-06-19 21:00:12.516010'),(352,'2024-06-19 21:00:12.545994','2024-06-19 21:00:12.545994','[\"metabase.task.update-field-values.trigger.2\"]',NULL,461,_binary '\0','full',NULL,'2024-06-19 21:00:12.545994');
/*!40000 ALTER TABLE `metabase_fieldvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `metabase_table`
--

DROP TABLE IF EXISTS `metabase_table`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `metabase_table` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `name` varchar(256) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `entity_type` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `active` bit(1) NOT NULL,
  `db_id` int NOT NULL,
  `display_name` varchar(256) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `visibility_type` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `schema` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `points_of_interest` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `caveats` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `show_in_getting_started` bit(1) NOT NULL DEFAULT b'0',
  `field_order` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'database',
  `initial_sync_status` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'complete' COMMENT 'String indicating whether a table has completed its initial sync and is ready to use',
  `is_upload` bit(1) NOT NULL DEFAULT b'0',
  `database_require_filter` bit(1) DEFAULT NULL,
  `estimated_row_count` bigint DEFAULT NULL COMMENT 'The estimated row count',
  `view_count` int NOT NULL DEFAULT '0' COMMENT 'Keeps a running count of card views',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_uniq_table_db_id_schema_name` (`db_id`,`schema`,`name`),
  KEY `idx_table_db_id` (`db_id`),
  KEY `idx_metabase_table_show_in_getting_started` (`show_in_getting_started`),
  KEY `idx_metabase_table_db_id_schema` (`db_id`,`schema`),
  CONSTRAINT `fk_table_ref_database_id` FOREIGN KEY (`db_id`) REFERENCES `metabase_database` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=108 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `metabase_table`
--

LOCK TABLES `metabase_table` WRITE;
/*!40000 ALTER TABLE `metabase_table` DISABLE KEYS */;
INSERT INTO `metabase_table` VALUES (1,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.582681','ANALYTIC_EVENTS','Piespace does some anonymous analytics tracking on how users interact with their platform. They’ve only had time to implement a few events, but you know how it is. Pies come first.','entity/EventTable',_binary '',1,'Analytic Events',NULL,'PUBLIC','Is it? We’ll let you be the judge of that.','Piespace has cracked time travel, so keep in mind that some events may have already happened in the future.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(2,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.664897','FEEDBACK','With each order of pies sent out, Piespace includes a place for customers to submit feedback and review their order.','entity/GenericTable',_binary '',1,'Feedback',NULL,'PUBLIC','Is it? We’ll let you be the judge of that.','Not every account feels inclined to submit feedback. That’s cool. There’s still quite a few responses here.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(3,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.372199','PEOPLE','Information on the user accounts registered with Sample Company.','entity/UserTable',_binary '',1,'People',NULL,'PUBLIC','Is it? You tell us!','Note that employees and customer support staff will have accounts.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(4,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.386421','REVIEWS','Reviews that Sample Company customers have left on our products.','entity/GenericTable',_binary '',1,'Reviews',NULL,'PUBLIC','Is it? You tell us!','These reviews aren\'t tied to orders so it is possible people have reviewed products they did not purchase from us.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(5,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.354805','ORDERS','Confirmed Sample Company orders for a product, from a user.','entity/TransactionTable',_binary '',1,'Orders',NULL,'PUBLIC','Is it? You tell us!','You can join this on the Products and Orders table using the ID fields. Discount is left null if not applicable.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(6,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.502289','ACCOUNTS','Information on customer accounts registered with Piespace. Each account represents a new organization signing up for on-demand pies.','entity/UserTable',_binary '',1,'Accounts',NULL,'PUBLIC','Is it? We’ll let you be the judge of that.','Piespace’s business operates with a two week trial period. If you see that “Canceled At” is null then that account is still happily paying for their pies.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(7,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.484891','INVOICES','Confirmed payments from Piespace’s customers. Most accounts pay for their pie subscription on a monthly basis.','entity/GenericTable',_binary '',1,'Invoices',NULL,'PUBLIC','Is it? We’ll let you be the judge of that.','You can group by “Account ID” to see all the payments from an account and unveil information like total amount paid to date.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(8,'2024-06-19 14:13:29.000000','2024-06-19 14:13:33.339338','PRODUCTS','Includes a catalog of all the products ever sold by the famed Sample Company.','entity/ProductTable',_binary '',1,'Products',NULL,'PUBLIC','Is it? You tell us!','The rating column is an integer from 1-5 where 1 is dreadful and 5 is the best thing ever.',_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(9,'2024-06-19 14:18:15.740128','2024-07-21 13:45:04.015931','v_query_log','VIEW','entity/EventTable',_binary '',2,'V Query Log',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(10,'2024-06-19 14:18:15.781469','2024-06-19 14:18:15.781469','permissions_revision','Used to keep track of changes made to permissions.',NULL,_binary '',2,'Permissions Revision','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(11,'2024-06-19 14:18:15.826639','2024-07-21 13:45:04.015931','v_dashboardcard','VIEW','entity/GenericTable',_binary '',2,'V Dashboardcard',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(12,'2024-06-19 14:18:15.859827','2024-07-21 13:45:04.015931','v_group_members','VIEW','entity/GenericTable',_binary '',2,'V Group Members',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(13,'2024-06-19 14:18:15.900206','2024-07-21 13:45:04.015931','qrtz_calendars','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Calendars',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(14,'2024-06-19 14:18:15.940087','2024-06-19 14:18:15.940087','collection_permission_graph_revision','Used to keep track of changes made to collections.',NULL,_binary '',2,'Collection Permission Graph Revision','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(15,'2024-06-19 14:18:15.998169','2024-07-21 13:45:04.015931','card_bookmark','Table holding bookmarks on cards','entity/GenericTable',_binary '',2,'Card Bookmark',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(16,'2024-06-19 14:18:16.032936','2024-07-21 13:45:04.015931','model_index','Used to keep track of which models have indexed columns.','entity/GenericTable',_binary '',2,'Model Index',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(17,'2024-06-19 14:18:16.068485','2024-07-21 13:45:04.015931','dashboard_bookmark','Table holding bookmarks on dashboards','entity/GenericTable',_binary '',2,'Dashboard Bookmark',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(18,'2024-06-19 14:18:16.098057','2024-07-21 13:45:04.015931','login_history','Keeps track of various logins for different users and additional info such as location and device','entity/EventTable',_binary '',2,'Login History',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(19,'2024-06-19 14:18:16.128396','2024-07-21 13:45:04.015931','audit_log','Used to store application events for auditing use cases','entity/EventTable',_binary '',2,'Audit Log',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(20,'2024-06-19 14:18:16.161961','2024-07-21 13:45:04.015931','model_index_value','Used to keep track of the values indexed in a model','entity/GenericTable',_binary '',2,'Model Index Value',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(21,'2024-06-19 14:18:16.198691','2024-06-19 14:18:16.198691','application_permissions_revision','Used to keep track of changes made to general permissions.',NULL,_binary '',2,'Application Permissions Revision','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(22,'2024-06-19 14:18:16.238697','2024-07-21 13:45:04.015931','field_usage','Used to store field usage during query execution','entity/GenericTable',_binary '',2,'Field Usage',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(23,'2024-06-19 14:18:16.276648','2024-07-21 13:45:04.015931','core_user',NULL,'entity/UserTable',_binary '',2,'Core User',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(24,'2024-06-19 14:18:16.303912','2024-07-21 13:45:04.015931','query','Information (such as average execution time) for different queries that have been previously ran.','entity/GenericTable',_binary '',2,'Query',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(25,'2024-06-19 14:18:16.334754','2024-07-21 13:45:04.015931','v_subscriptions','VIEW','entity/SubscriptionTable',_binary '',2,'V Subscriptions',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(26,'2024-06-19 14:18:16.372315','2024-07-21 13:45:04.015931','implicit_action','An action with dynamic parameters based on the underlying model','entity/GenericTable',_binary '',2,'Implicit Action',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(27,'2024-06-19 14:18:16.408076','2024-07-21 13:45:04.015931','metric',NULL,'entity/GenericTable',_binary '',2,'Metric',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(28,'2024-06-19 14:18:16.445323','2024-07-21 13:45:04.015931','metabase_field',NULL,'entity/GenericTable',_binary '',2,'Metabase Field',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(29,'2024-06-19 14:18:16.477555','2024-07-21 13:45:04.015931','permissions',NULL,'entity/GenericTable',_binary '',2,'Permissions',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(30,'2024-06-19 14:18:16.510143','2024-07-21 13:45:04.015931','action','An action is something you can do, such as run a readwrite query','entity/GenericTable',_binary '',2,'Action',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(31,'2024-06-19 14:18:16.539935','2024-07-21 13:45:04.015931','moderation_review','Reviews (from moderators) for a given question/dashboard (BUCM)','entity/GenericTable',_binary '',2,'Moderation Review',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(32,'2024-06-19 14:18:16.574707','2024-07-21 13:45:04.015931','segment',NULL,'entity/GenericTable',_binary '',2,'Segment',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(33,'2024-06-19 14:18:16.607705','2024-07-21 13:45:04.015931','v_audit_log','VIEW','entity/EventTable',_binary '',2,'V Audit Log',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(34,'2024-06-19 14:18:16.637429','2024-07-21 13:45:04.015931','dependency',NULL,'entity/GenericTable',_binary '',2,'Dependency',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(35,'2024-06-19 14:18:16.667694','2024-07-21 13:45:04.015931','qrtz_simple_triggers','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Simple Triggers',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(36,'2024-06-19 14:18:16.697916','2024-07-21 13:45:04.015931','qrtz_simprop_triggers','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Simprop Triggers',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(37,'2024-06-19 14:18:16.728308','2024-07-21 13:45:04.015931','pulse_card',NULL,'entity/GenericTable',_binary '',2,'Pulse Card',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(38,'2024-06-19 14:18:16.757921','2024-07-21 13:45:04.015931','revision',NULL,'entity/GenericTable',_binary '',2,'Revision',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(39,'2024-06-19 14:18:16.790281','2024-07-21 13:45:04.015931','metric_important_field',NULL,'entity/GenericTable',_binary '',2,'Metric Important Field',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(40,'2024-06-19 14:18:16.818044','2024-07-21 13:45:04.015931','vas_cur_streamer_income',NULL,'entity/GenericTable',_binary '',2,'Vas Cur Streamer Income',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(41,'2024-06-19 14:18:16.848080','2024-06-19 14:18:16.848080','databasechangelog',NULL,NULL,_binary '',2,'Databasechangelog','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(42,'2024-06-19 14:18:16.888318','2024-07-21 13:45:04.015931','streamer',NULL,'entity/GenericTable',_binary '',2,'Streamer',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(43,'2024-06-19 14:18:16.915931','2024-07-21 13:45:04.015931','table_privileges','Table for user and role privileges by table','entity/GenericTable',_binary '',2,'Table Privileges',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(44,'2024-06-19 14:18:16.945651','2024-07-21 13:45:04.015931','http_action','An http api call type of action','entity/GenericTable',_binary '',2,'Http Action',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(45,'2024-06-19 14:18:16.972218','2024-07-21 13:45:04.015931','pulse',NULL,'entity/GenericTable',_binary '',2,'Pulse',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(46,'2024-06-19 14:18:16.998311','2024-07-21 13:45:04.015931','sandboxes','Records that a given Card (Question) should automatically replace a given Table as query source for a given a Perms Group.','entity/GenericTable',_binary '',2,'Sandboxes',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(47,'2024-06-19 14:18:17.041594','2024-07-21 13:45:04.015931','qrtz_cron_triggers','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Cron Triggers',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(48,'2024-06-19 14:18:17.078689','2024-07-21 13:45:04.015931','v_view_log','VIEW','entity/EventTable',_binary '',2,'V View Log',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(49,'2024-06-19 14:18:17.114681','2024-07-21 13:45:04.015931','pulse_channel',NULL,'entity/GenericTable',_binary '',2,'Pulse Channel',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(50,'2024-06-19 14:18:17.143453','2024-07-21 13:45:04.015931','native_query_snippet','Query snippets (raw text) to be substituted in native queries','entity/GenericTable',_binary '',2,'Native Query Snippet',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(51,'2024-06-19 14:18:17.174994','2024-07-21 13:45:04.015931','core_session',NULL,'entity/GenericTable',_binary '',2,'Core Session',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(52,'2024-06-19 14:18:17.206500','2024-07-21 13:45:04.015931','v_tables','VIEW','entity/GenericTable',_binary '',2,'V Tables',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(53,'2024-06-19 14:18:17.236567','2024-07-21 13:45:04.015931','v_databases','VIEW','entity/GenericTable',_binary '',2,'V Databases',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(54,'2024-06-19 14:18:17.267222','2024-07-21 13:45:04.015931','collection_bookmark','Table holding bookmarks on collections','entity/GenericTable',_binary '',2,'Collection Bookmark',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(55,'2024-06-19 14:18:17.297880','2024-07-21 13:45:04.015931','qrtz_locks','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Locks',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(56,'2024-06-19 14:18:17.347642','2024-07-21 13:45:04.015931','recent_views','Used to store recently viewed objects for each user','entity/GenericTable',_binary '',2,'Recent Views',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(57,'2024-06-19 14:18:17.385638','2024-07-21 13:45:04.015931','dashboardcard_series',NULL,'entity/GenericTable',_binary '',2,'Dashboardcard Series',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(58,'2024-06-19 14:18:17.412920','2024-07-21 13:45:04.015931','query_execution','A log of executed queries, used for calculating historic execution times, auditing, and other purposes.','entity/GenericTable',_binary '',2,'Query Execution',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(59,'2024-06-19 14:18:17.438672','2024-07-21 13:45:04.015931','report_dashboard',NULL,'entity/GenericTable',_binary '',2,'Report Dashboard',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(60,'2024-06-19 14:18:17.467643','2024-07-21 13:45:04.015931','qrtz_blob_triggers','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Blob Triggers',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(61,'2024-06-19 14:18:17.501342','2024-07-21 13:45:04.015931','qrtz_paused_trigger_grps','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Paused Trigger Grps',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(62,'2024-06-19 14:18:17.531791','2024-07-21 13:45:04.015931','report_cardfavorite',NULL,'entity/GenericTable',_binary '',2,'Report Cardfavorite',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(63,'2024-06-19 14:18:17.562655','2024-07-21 13:45:04.015931','persisted_info','Table holding information about persisted models','entity/GenericTable',_binary '',2,'Persisted Info',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(64,'2024-06-19 14:18:17.599288','2024-07-21 13:45:04.015931','qrtz_triggers','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Triggers',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(65,'2024-06-19 14:18:17.630451','2024-07-21 13:45:04.015931','v_fields','VIEW','entity/GenericTable',_binary '',2,'V Fields',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(66,'2024-06-19 14:18:17.661278','2024-07-21 13:45:04.015931','label',NULL,'entity/GenericTable',_binary '',2,'Label',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(67,'2024-06-19 14:18:17.691038','2024-06-19 14:18:17.691038','query_cache','Cached results of queries are stored here when using the DB-based query cache.',NULL,_binary '',2,'Query Cache','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(68,'2024-06-19 14:18:17.722944','2024-07-21 13:45:04.015931','qrtz_job_details','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Job Details',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(69,'2024-06-19 14:18:17.750693','2024-06-19 14:18:17.750693','databasechangeloglock',NULL,NULL,_binary '',2,'Databasechangeloglock','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(70,'2024-06-19 14:18:17.790224','2024-07-21 13:45:04.015931','qrtz_scheduler_state','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Scheduler State',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(71,'2024-06-19 14:18:17.823189','2024-07-21 13:45:04.015931','setting',NULL,'entity/GenericTable',_binary '',2,'Setting',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(72,'2024-06-19 14:18:17.852881','2024-07-21 13:45:04.015931','pulse_channel_recipient',NULL,'entity/GenericTable',_binary '',2,'Pulse Channel Recipient',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(73,'2024-06-19 14:18:17.883601','2024-07-21 13:45:04.015931','report_card',NULL,'entity/GenericTable',_binary '',2,'Report Card',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(74,'2024-06-19 14:18:17.921375','2024-07-21 13:45:04.015931','dimension','Stores references to alternate views of existing fields, such as remapping an integer to a description, like an enum','entity/GenericTable',_binary '',2,'Dimension',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(75,'2024-06-19 14:18:17.957764','2024-07-21 13:45:04.015931','secret','Storage for managed secrets (passwords, binary data, etc.)','entity/GenericTable',_binary '',2,'Secret',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(76,'2024-06-19 14:18:17.989166','2024-07-21 13:45:04.015931','report_dashboardcard',NULL,'entity/GenericTable',_binary '',2,'Report Dashboardcard',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(77,'2024-06-19 14:18:18.020697','2024-07-21 13:45:04.015931','v_content','VIEW','entity/GenericTable',_binary '',2,'V Content',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(78,'2024-06-19 14:18:18.050880','2024-07-21 13:45:04.015931','vas_yoy_flow',NULL,'entity/GenericTable',_binary '',2,'Vas Yoy Flow',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(79,'2024-06-19 14:18:18.086010','2024-07-21 13:45:04.015931','metabase_table',NULL,'entity/GenericTable',_binary '',2,'Metabase Table',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(80,'2024-06-19 14:18:18.120173','2024-07-21 13:45:04.015931','bookmark_ordering','Table holding ordering information for various bookmark tables','entity/GenericTable',_binary '',2,'Bookmark Ordering',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(81,'2024-06-19 14:18:18.162000','2024-07-21 13:45:04.015931','query_action','A readwrite query type of action','entity/GenericTable',_binary '',2,'Query Action',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(82,'2024-06-19 14:18:18.187024','2024-07-21 13:45:04.015931','metabase_database',NULL,'entity/GenericTable',_binary '',2,'Metabase Database',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(83,'2024-06-19 14:18:18.243679','2024-07-21 13:45:04.015931','dashboard_tab','Join table connecting dashboard to dashboardcards','entity/GenericTable',_binary '',2,'Dashboard Tab',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(84,'2024-06-19 14:18:18.318355','2024-07-21 13:45:04.015931','user_parameter_value','Table holding last set value of a parameter per user','entity/UserTable',_binary '',2,'User Parameter Value',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(85,'2024-06-19 14:18:18.351500','2024-07-21 13:45:04.015931','v_users','VIEW','entity/UserTable',_binary '',2,'V Users',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(86,'2024-06-19 14:18:18.378551','2024-07-21 13:45:04.015931','vas_day_flow',NULL,'entity/GenericTable',_binary '',2,'Vas Day Flow',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(87,'2024-06-19 14:18:18.408426','2024-07-21 13:45:04.015931','parameter_card','Join table connecting cards to entities (dashboards, other cards, etc.) that use the values generated by the card for filter values','entity/GenericTable',_binary '',2,'Parameter Card',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(88,'2024-06-19 14:18:18.438178','2024-06-19 14:18:18.438178','cache_config','Cache Configuration',NULL,_binary '',2,'Cache Config','cruft',NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(89,'2024-06-19 14:18:18.470613','2024-07-21 13:45:04.015931','view_log',NULL,'entity/EventTable',_binary '',2,'View Log',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(90,'2024-06-19 14:18:18.508522','2024-07-21 13:45:04.015931','permissions_group_membership',NULL,'entity/GenericTable',_binary '',2,'Permissions Group Membership',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(91,'2024-06-19 14:18:18.537035','2024-07-21 13:45:04.015931','collection','Collections are an optional way to organize Cards and handle permissions for them.','entity/GenericTable',_binary '',2,'Collection',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(92,'2024-06-19 14:18:18.565698','2024-07-21 13:45:04.015931','v_tasks','VIEW','entity/GenericTable',_binary '',2,'V Tasks',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(93,'2024-06-19 14:18:18.594539','2024-07-21 13:45:04.015931','qrtz_fired_triggers','Used for Quartz scheduler.','entity/GenericTable',_binary '',2,'Qrtz Fired Triggers',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(94,'2024-06-19 14:18:18.621509','2024-07-21 13:45:04.015931','timeline_event','Events table','entity/EventTable',_binary '',2,'Timeline Event',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(95,'2024-06-19 14:18:18.648692','2024-07-21 13:45:04.015931','connection_impersonations','Table for holding connection impersonation policies','entity/GenericTable',_binary '',2,'Connection Impersonations',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(96,'2024-06-19 14:18:18.677303','2024-07-21 13:45:04.015931','data_permissions','A table to store database and table permissions','entity/GenericTable',_binary '',2,'Data Permissions',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(97,'2024-06-19 14:18:18.708698','2024-07-21 13:45:04.015931','cloud_migration','Migrate to cloud directly from Metabase','entity/GenericTable',_binary '',2,'Cloud Migration',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(98,'2024-06-19 14:18:18.783635','2024-07-21 13:45:04.015931','v_alerts','VIEW','entity/GenericTable',_binary '',2,'V Alerts',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(99,'2024-06-19 14:18:18.819767','2024-07-21 13:45:04.015931','query_field','Fields used by a card\'s query','entity/GenericTable',_binary '',2,'Query Field',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(100,'2024-06-19 14:18:18.849145','2024-07-21 13:45:04.015931','vas_day_detail',NULL,'entity/GenericTable',_binary '',2,'Vas Day Detail',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(101,'2024-06-19 14:18:18.899090','2024-07-21 13:45:04.015931','dashboard_favorite','Presence of a row here indicates a given User has favorited a given Dashboard.','entity/GenericTable',_binary '',2,'Dashboard Favorite',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(102,'2024-06-19 14:18:18.931263','2024-07-21 13:45:04.015931','permissions_group',NULL,'entity/GenericTable',_binary '',2,'Permissions Group',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(103,'2024-06-19 14:18:18.962954','2024-07-21 13:45:04.015931','metabase_fieldvalues',NULL,'entity/GenericTable',_binary '',2,'Metabase Fieldvalues',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(104,'2024-06-19 14:18:18.991361','2024-07-21 13:45:04.015931','timeline','Timeline table to organize events','entity/GenericTable',_binary '',2,'Timeline',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(105,'2024-06-19 14:18:19.030085','2024-07-21 13:45:04.015931','task_history','Timing and metadata info about background/quartz processes','entity/GenericTable',_binary '',2,'Task History',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(106,'2024-06-19 14:18:19.065445','2024-07-21 13:45:04.015931','card_label',NULL,'entity/GenericTable',_binary '',2,'Card Label',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0),(107,'2024-06-19 14:18:19.094014','2024-07-21 13:45:04.015931','api_key','An API Key','entity/GenericTable',_binary '',2,'Api Key',NULL,NULL,NULL,NULL,_binary '\0','database','complete',_binary '\0',NULL,NULL,0);
/*!40000 ALTER TABLE `metabase_table` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `metric`
--

DROP TABLE IF EXISTS `metric`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `metric` (
  `id` int NOT NULL AUTO_INCREMENT,
  `table_id` int NOT NULL,
  `creator_id` int NOT NULL,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `archived` bit(1) DEFAULT b'0',
  `definition` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `points_of_interest` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `caveats` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `how_is_this_calculated` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `show_in_getting_started` bit(1) NOT NULL DEFAULT b'0',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_metric_creator_id` (`creator_id`),
  KEY `idx_metric_table_id` (`table_id`),
  KEY `idx_metric_show_in_getting_started` (`show_in_getting_started`),
  CONSTRAINT `fk_metric_ref_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_metric_ref_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `metric`
--

LOCK TABLES `metric` WRITE;
/*!40000 ALTER TABLE `metric` DISABLE KEYS */;
/*!40000 ALTER TABLE `metric` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `metric_important_field`
--

DROP TABLE IF EXISTS `metric_important_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `metric_important_field` (
  `id` int NOT NULL AUTO_INCREMENT,
  `metric_id` int NOT NULL,
  `field_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_metric_important_field_metric_id_field_id` (`metric_id`,`field_id`),
  KEY `idx_metric_important_field_metric_id` (`metric_id`),
  KEY `idx_metric_important_field_field_id` (`field_id`),
  CONSTRAINT `fk_metric_important_field_metabase_field_id` FOREIGN KEY (`field_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_metric_important_field_metric_id` FOREIGN KEY (`metric_id`) REFERENCES `metric` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `metric_important_field`
--

LOCK TABLES `metric_important_field` WRITE;
/*!40000 ALTER TABLE `metric_important_field` DISABLE KEYS */;
/*!40000 ALTER TABLE `metric_important_field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `model_index`
--

DROP TABLE IF EXISTS `model_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `model_index` (
  `id` int NOT NULL AUTO_INCREMENT,
  `model_id` int DEFAULT NULL COMMENT 'The ID of the indexed model.',
  `pk_ref` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Serialized JSON of the primary key field ref.',
  `value_ref` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Serialized JSON of the label field ref.',
  `schedule` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The cron schedule for when value syncing should happen.',
  `state` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The status of the index: initializing, indexed, error, overflow.',
  `indexed_at` timestamp(6) NULL DEFAULT NULL COMMENT 'When the status changed',
  `error` longtext COLLATE utf8mb4_unicode_ci COMMENT 'The error message if the status is error.',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when these changes were made.',
  `creator_id` int NOT NULL COMMENT 'ID of the user who created the event',
  PRIMARY KEY (`id`),
  KEY `fk_model_index_creator_id` (`creator_id`),
  KEY `idx_model_index_model_id` (`model_id`),
  CONSTRAINT `fk_model_index_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_model_index_model_id` FOREIGN KEY (`model_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to keep track of which models have indexed columns.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `model_index`
--

LOCK TABLES `model_index` WRITE;
/*!40000 ALTER TABLE `model_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `model_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `model_index_value`
--

DROP TABLE IF EXISTS `model_index_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `model_index_value` (
  `model_index_id` int DEFAULT NULL COMMENT 'The ID of the indexed model.',
  `model_pk` int NOT NULL COMMENT 'The primary key of the indexed value',
  `name` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The label to display identifying the indexed value.',
  UNIQUE KEY `unique_model_index_value_model_index_id_model_pk` (`model_index_id`,`model_pk`),
  CONSTRAINT `fk_model_index_value_model_id` FOREIGN KEY (`model_index_id`) REFERENCES `model_index` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to keep track of the values indexed in a model';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `model_index_value`
--

LOCK TABLES `model_index_value` WRITE;
/*!40000 ALTER TABLE `model_index_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `model_index_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `moderation_review`
--

DROP TABLE IF EXISTS `moderation_review`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `moderation_review` (
  `id` int NOT NULL AUTO_INCREMENT,
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'most recent modification time',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'creation time',
  `status` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'verified, misleading, confusing, not_misleading, pending',
  `text` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `moderated_item_id` int NOT NULL COMMENT 'either a document or question ID; the item that needs review',
  `moderated_item_type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'whether it''s a question or dashboard',
  `moderator_id` int NOT NULL COMMENT 'ID of the user who did the review',
  `most_recent` bit(1) NOT NULL COMMENT 'tag for most recent review',
  PRIMARY KEY (`id`),
  KEY `idx_moderation_review_item_type_item_id` (`moderated_item_type`,`moderated_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Reviews (from moderators) for a given question/dashboard (BUCM)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `moderation_review`
--

LOCK TABLES `moderation_review` WRITE;
/*!40000 ALTER TABLE `moderation_review` DISABLE KEYS */;
/*!40000 ALTER TABLE `moderation_review` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `native_query_snippet`
--

DROP TABLE IF EXISTS `native_query_snippet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `native_query_snippet` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Name of the query snippet',
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `content` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `creator_id` int NOT NULL,
  `archived` bit(1) NOT NULL DEFAULT b'0',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `collection_id` int DEFAULT NULL COMMENT 'ID of the Snippet Folder (Collection) this Snippet is in, if any',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `fk_snippet_creator_id` (`creator_id`),
  KEY `idx_snippet_name` (`name`),
  KEY `idx_snippet_collection_id` (`collection_id`),
  CONSTRAINT `fk_snippet_collection_id` FOREIGN KEY (`collection_id`) REFERENCES `collection` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_snippet_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Query snippets (raw text) to be substituted in native queries';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `native_query_snippet`
--

LOCK TABLES `native_query_snippet` WRITE;
/*!40000 ALTER TABLE `native_query_snippet` DISABLE KEYS */;
/*!40000 ALTER TABLE `native_query_snippet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `parameter_card`
--

DROP TABLE IF EXISTS `parameter_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `parameter_card` (
  `id` int NOT NULL AUTO_INCREMENT,
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'most recent modification time',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'creation time',
  `card_id` int NOT NULL COMMENT 'ID of the card generating the values',
  `parameterized_object_type` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Type of the entity consuming the values (dashboard, card, etc.)',
  `parameterized_object_id` int NOT NULL COMMENT 'ID of the entity consuming the values',
  `parameter_id` varchar(36) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_parameterized_object_card_parameter` (`parameterized_object_id`,`parameterized_object_type`,`parameter_id`),
  KEY `idx_parameter_card_parameterized_object_id` (`parameterized_object_id`),
  KEY `idx_parameter_card_card_id` (`card_id`),
  CONSTRAINT `fk_parameter_card_ref_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Join table connecting cards to entities (dashboards, other cards, etc.) that use the values generated by the card for filter values';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `parameter_card`
--

LOCK TABLES `parameter_card` WRITE;
/*!40000 ALTER TABLE `parameter_card` DISABLE KEYS */;
/*!40000 ALTER TABLE `parameter_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `permissions`
--

DROP TABLE IF EXISTS `permissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `permissions` (
  `id` int NOT NULL AUTO_INCREMENT,
  `object` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `group_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `group_id` (`group_id`,`object`),
  KEY `idx_permissions_group_id` (`group_id`),
  KEY `idx_permissions_object` (`object`),
  KEY `idx_permissions_group_id_object` (`group_id`,`object`),
  CONSTRAINT `fk_permissions_group_id` FOREIGN KEY (`group_id`) REFERENCES `permissions_group` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `permissions`
--

LOCK TABLES `permissions` WRITE;
/*!40000 ALTER TABLE `permissions` DISABLE KEYS */;
INSERT INTO `permissions` VALUES (3,'/application/subscription/',1),(5,'/collection/1/',1),(6,'/collection/3/',1),(4,'/collection/namespace/snippets/root/',1),(2,'/collection/root/',1),(1,'/',2);
/*!40000 ALTER TABLE `permissions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `permissions_group`
--

DROP TABLE IF EXISTS `permissions_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `permissions_group` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `entity_id` char(21) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'NanoID tag for each user',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_permissions_group_name` (`name`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_permissions_group_name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `permissions_group`
--

LOCK TABLES `permissions_group` WRITE;
/*!40000 ALTER TABLE `permissions_group` DISABLE KEYS */;
INSERT INTO `permissions_group` VALUES (1,'All Users',NULL),(2,'Administrators',NULL);
/*!40000 ALTER TABLE `permissions_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `permissions_group_membership`
--

DROP TABLE IF EXISTS `permissions_group_membership`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `permissions_group_membership` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL,
  `group_id` int NOT NULL,
  `is_group_manager` bit(1) NOT NULL DEFAULT b'0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_permissions_group_membership_user_id_group_id` (`user_id`,`group_id`),
  KEY `idx_permissions_group_membership_group_id` (`group_id`),
  KEY `idx_permissions_group_membership_user_id` (`user_id`),
  KEY `idx_permissions_group_membership_group_id_user_id` (`group_id`,`user_id`),
  CONSTRAINT `fk_permissions_group_group_id` FOREIGN KEY (`group_id`) REFERENCES `permissions_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_permissions_group_membership_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `permissions_group_membership`
--

LOCK TABLES `permissions_group_membership` WRITE;
/*!40000 ALTER TABLE `permissions_group_membership` DISABLE KEYS */;
INSERT INTO `permissions_group_membership` VALUES (1,13371338,1,_binary '\0'),(2,13371339,1,_binary '\0'),(3,13371339,2,_binary '\0'),(4,13371340,1,_binary '\0'),(5,13371341,1,_binary '\0'),(6,13371342,1,_binary '\0'),(7,13371343,1,_binary '\0'),(8,13371344,1,_binary '\0'),(9,13371345,1,_binary '\0');
/*!40000 ALTER TABLE `permissions_group_membership` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `permissions_revision`
--

DROP TABLE IF EXISTS `permissions_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `permissions_revision` (
  `id` int NOT NULL AUTO_INCREMENT,
  `before` longtext COLLATE utf8mb4_unicode_ci,
  `after` longtext COLLATE utf8mb4_unicode_ci,
  `user_id` int NOT NULL COMMENT 'The ID of the admin who made this set of changes.',
  `created_at` timestamp(6) NOT NULL,
  `remark` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_permissions_revision_user_id` (`user_id`),
  CONSTRAINT `fk_permissions_revision_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to keep track of changes made to permissions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `permissions_revision`
--

LOCK TABLES `permissions_revision` WRITE;
/*!40000 ALTER TABLE `permissions_revision` DISABLE KEYS */;
/*!40000 ALTER TABLE `permissions_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `persisted_info`
--

DROP TABLE IF EXISTS `persisted_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `persisted_info` (
  `id` int NOT NULL AUTO_INCREMENT,
  `database_id` int NOT NULL COMMENT 'ID of the database associated to the persisted card',
  `card_id` int NOT NULL COMMENT 'ID of the Card model persisted',
  `question_slug` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Slug of the card which will form the persisted table name',
  `table_name` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Name of the table persisted',
  `definition` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'JSON object that captures the state of the table when we persisted',
  `query_hash` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'Hash of the query persisted',
  `active` bit(1) NOT NULL DEFAULT b'0',
  `state` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Persisted table state (creating, persisted, refreshing, deleted)',
  `refresh_begin` timestamp(6) NOT NULL COMMENT 'The timestamp of when the most recent refresh was started',
  `refresh_end` timestamp(6) NULL DEFAULT NULL COMMENT 'The timestamp of when the most recent refresh ended',
  `state_change_at` timestamp(6) NULL DEFAULT NULL COMMENT 'The timestamp of when the most recent state changed',
  `error` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'Error message from persisting if applicable',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the model was first persisted',
  `creator_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `card_id` (`card_id`),
  KEY `fk_persisted_info_database_id` (`database_id`),
  KEY `fk_persisted_info_ref_creator_id` (`creator_id`),
  CONSTRAINT `fk_persisted_info_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_persisted_info_database_id` FOREIGN KEY (`database_id`) REFERENCES `metabase_database` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_persisted_info_ref_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table holding information about persisted models';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `persisted_info`
--

LOCK TABLES `persisted_info` WRITE;
/*!40000 ALTER TABLE `persisted_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `persisted_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pulse`
--

DROP TABLE IF EXISTS `pulse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `pulse` (
  `id` int NOT NULL AUTO_INCREMENT,
  `creator_id` int NOT NULL,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `skip_if_empty` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Skip a scheduled Pulse if none of its questions have any results',
  `alert_condition` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Condition (i.e. "rows" or "goal") used as a guard for alerts',
  `alert_first_only` bit(1) DEFAULT NULL COMMENT 'True if the alert should be disabled after the first notification',
  `alert_above_goal` bit(1) DEFAULT NULL COMMENT 'For a goal condition, alert when above the goal',
  `collection_id` int DEFAULT NULL COMMENT 'Options ID of Collection this Pulse belongs to.',
  `collection_position` smallint DEFAULT NULL COMMENT 'Optional pinned position for this item in its Collection. NULL means item is not pinned.',
  `archived` bit(1) DEFAULT b'0' COMMENT 'Has this pulse been archived?',
  `dashboard_id` int DEFAULT NULL COMMENT 'ID of the Dashboard if this Pulse is a Dashboard Subscription.',
  `parameters` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_pulse_creator_id` (`creator_id`),
  KEY `idx_pulse_collection_id` (`collection_id`),
  KEY `fk_pulse_ref_dashboard_id` (`dashboard_id`),
  CONSTRAINT `fk_pulse_collection_id` FOREIGN KEY (`collection_id`) REFERENCES `collection` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_pulse_ref_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_pulse_ref_dashboard_id` FOREIGN KEY (`dashboard_id`) REFERENCES `report_dashboard` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pulse`
--

LOCK TABLES `pulse` WRITE;
/*!40000 ALTER TABLE `pulse` DISABLE KEYS */;
/*!40000 ALTER TABLE `pulse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pulse_card`
--

DROP TABLE IF EXISTS `pulse_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `pulse_card` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pulse_id` int NOT NULL,
  `card_id` int NOT NULL,
  `position` int NOT NULL,
  `include_csv` bit(1) NOT NULL DEFAULT b'0' COMMENT 'True if a CSV of the data should be included for this pulse card',
  `include_xls` bit(1) NOT NULL DEFAULT b'0' COMMENT 'True if a XLS of the data should be included for this pulse card',
  `dashboard_card_id` int DEFAULT NULL COMMENT 'If this Pulse is a Dashboard subscription, the ID of the DashboardCard that corresponds to this PulseCard.',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  `format_rows` bit(1) DEFAULT b'1' COMMENT 'Whether or not to apply formatting to the rows of the export',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_pulse_card_pulse_id` (`pulse_id`),
  KEY `idx_pulse_card_card_id` (`card_id`),
  KEY `fk_pulse_card_ref_pulse_card_id` (`dashboard_card_id`),
  CONSTRAINT `fk_pulse_card_ref_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_pulse_card_ref_pulse_card_id` FOREIGN KEY (`dashboard_card_id`) REFERENCES `report_dashboardcard` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_pulse_card_ref_pulse_id` FOREIGN KEY (`pulse_id`) REFERENCES `pulse` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pulse_card`
--

LOCK TABLES `pulse_card` WRITE;
/*!40000 ALTER TABLE `pulse_card` DISABLE KEYS */;
/*!40000 ALTER TABLE `pulse_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pulse_channel`
--

DROP TABLE IF EXISTS `pulse_channel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `pulse_channel` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pulse_id` int NOT NULL,
  `channel_type` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `details` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `schedule_type` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `schedule_hour` int DEFAULT NULL,
  `schedule_day` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `schedule_frame` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `enabled` bit(1) NOT NULL DEFAULT b'1',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_pulse_channel_pulse_id` (`pulse_id`),
  KEY `idx_pulse_channel_schedule_type` (`schedule_type`),
  CONSTRAINT `fk_pulse_channel_ref_pulse_id` FOREIGN KEY (`pulse_id`) REFERENCES `pulse` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pulse_channel`
--

LOCK TABLES `pulse_channel` WRITE;
/*!40000 ALTER TABLE `pulse_channel` DISABLE KEYS */;
/*!40000 ALTER TABLE `pulse_channel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pulse_channel_recipient`
--

DROP TABLE IF EXISTS `pulse_channel_recipient`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `pulse_channel_recipient` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pulse_channel_id` int NOT NULL,
  `user_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_pulse_channel_recipient_ref_pulse_channel_id` (`pulse_channel_id`),
  KEY `fk_pulse_channel_recipient_ref_user_id` (`user_id`),
  CONSTRAINT `fk_pulse_channel_recipient_ref_pulse_channel_id` FOREIGN KEY (`pulse_channel_id`) REFERENCES `pulse_channel` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_pulse_channel_recipient_ref_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pulse_channel_recipient`
--

LOCK TABLES `pulse_channel_recipient` WRITE;
/*!40000 ALTER TABLE `pulse_channel_recipient` DISABLE KEYS */;
/*!40000 ALTER TABLE `pulse_channel_recipient` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_blob_triggers`
--

DROP TABLE IF EXISTS `qrtz_blob_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_blob_triggers` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `BLOB_DATA` blob,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `FK_QRTZ_BLOB_TRIGGERS_TRIGGERS` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `qrtz_triggers` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_blob_triggers`
--

LOCK TABLES `qrtz_blob_triggers` WRITE;
/*!40000 ALTER TABLE `qrtz_blob_triggers` DISABLE KEYS */;
/*!40000 ALTER TABLE `qrtz_blob_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_calendars`
--

DROP TABLE IF EXISTS `qrtz_calendars`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_calendars` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `CALENDAR_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `CALENDAR` blob NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`CALENDAR_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_calendars`
--

LOCK TABLES `qrtz_calendars` WRITE;
/*!40000 ALTER TABLE `qrtz_calendars` DISABLE KEYS */;
/*!40000 ALTER TABLE `qrtz_calendars` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_cron_triggers`
--

DROP TABLE IF EXISTS `qrtz_cron_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_cron_triggers` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `CRON_EXPRESSION` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TIME_ZONE_ID` varchar(80) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `FK_QRTZ_CRON_TRIGGERS_TRIGGERS` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `qrtz_triggers` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_cron_triggers`
--

LOCK TABLES `qrtz_cron_triggers` WRITE;
/*!40000 ALTER TABLE `qrtz_cron_triggers` DISABLE KEYS */;
INSERT INTO `qrtz_cron_triggers` VALUES ('MetabaseScheduler','metabase.task.anonymous-stats.trigger','DEFAULT','0 3 5 * * ? *','GMT'),('MetabaseScheduler','metabase.task.creator-sentiment-emails.trigger','DEFAULT','0 0 2 ? * 7','GMT'),('MetabaseScheduler','metabase.task.follow-up-emails.trigger','DEFAULT','0 0 12 * * ? *','GMT'),('MetabaseScheduler','metabase.task.refresh-channel-cache.trigger','DEFAULT','0 53 0/4 1/1 * ? *','GMT'),('MetabaseScheduler','metabase.task.sync-and-analyze.trigger.2','DEFAULT','0 45 * * * ? *','GMT'),('MetabaseScheduler','metabase.task.task-history-cleanup.trigger','DEFAULT','0 0 0 * * ? *','GMT'),('MetabaseScheduler','metabase.task.truncate-audit-tables.trigger','DEFAULT','0 0 */12 * * ? *','GMT'),('MetabaseScheduler','metabase.task.update-field-values.trigger.2','DEFAULT','0 0 21 * * ? *','GMT'),('MetabaseScheduler','metabase.task.upgrade-checks.trigger','DEFAULT','0 15 6,18 * * ? *','GMT');
/*!40000 ALTER TABLE `qrtz_cron_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_fired_triggers`
--

DROP TABLE IF EXISTS `qrtz_fired_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_fired_triggers` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `ENTRY_ID` varchar(95) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `INSTANCE_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `FIRED_TIME` bigint NOT NULL,
  `SCHED_TIME` bigint DEFAULT NULL,
  `PRIORITY` int NOT NULL,
  `STATE` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `JOB_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `JOB_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `IS_NONCONCURRENT` bit(1) DEFAULT NULL,
  `REQUESTS_RECOVERY` bit(1) DEFAULT NULL,
  PRIMARY KEY (`SCHED_NAME`,`ENTRY_ID`),
  KEY `IDX_QRTZ_FT_TRIG_INST_NAME` (`SCHED_NAME`,`INSTANCE_NAME`),
  KEY `IDX_QRTZ_FT_INST_JOB_REQ_RCVRY` (`SCHED_NAME`,`INSTANCE_NAME`,`REQUESTS_RECOVERY`),
  KEY `IDX_QRTZ_FT_J_G` (`SCHED_NAME`,`JOB_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_FT_JG` (`SCHED_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_FT_T_G` (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  KEY `IDX_QRTZ_FT_TG` (`SCHED_NAME`,`TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_fired_triggers`
--

LOCK TABLES `qrtz_fired_triggers` WRITE;
/*!40000 ALTER TABLE `qrtz_fired_triggers` DISABLE KEYS */;
INSERT INTO `qrtz_fired_triggers` VALUES ('MetabaseScheduler','39bc26db456317215729313161721572931293','metabase.task.sync-and-analyze.trigger.2','DEFAULT','39bc26db45631721572931316',1721573113295,1721573100000,5,'EXECUTING','metabase.task.sync-and-analyze.job','DEFAULT',_binary '',_binary '\0');
/*!40000 ALTER TABLE `qrtz_fired_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_job_details`
--

DROP TABLE IF EXISTS `qrtz_job_details`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_job_details` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `JOB_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `JOB_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `DESCRIPTION` varchar(250) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `JOB_CLASS_NAME` varchar(250) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `IS_DURABLE` bit(1) NOT NULL,
  `IS_NONCONCURRENT` bit(1) NOT NULL,
  `IS_UPDATE_DATA` bit(1) NOT NULL,
  `REQUESTS_RECOVERY` bit(1) NOT NULL,
  `JOB_DATA` blob,
  PRIMARY KEY (`SCHED_NAME`,`JOB_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_J_REQ_RECOVERY` (`SCHED_NAME`,`REQUESTS_RECOVERY`),
  KEY `IDX_QRTZ_J_GRP` (`SCHED_NAME`,`JOB_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_job_details`
--

LOCK TABLES `qrtz_job_details` WRITE;
/*!40000 ALTER TABLE `qrtz_job_details` DISABLE KEYS */;
INSERT INTO `qrtz_job_details` VALUES ('MetabaseScheduler','metabase.task.anonymous-stats.job','DEFAULT',NULL,'metabase.task.send_anonymous_stats.SendAnonymousUsageStats',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.backfill-query-fields.job','DEFAULT',NULL,'metabase.task.backfill_query_fields.BackfillQueryField',_binary '',_binary '',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.creator-sentiment-emails.job','DEFAULT',NULL,'metabase.task.creator_sentiment_emails.CreatorSentimentEmail',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.email-remove-legacy-pulse.job','DEFAULT',NULL,'metabase.task.email_remove_legacy_pulse.EmailRemoveLegacyPulse',_binary '',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.follow-up-emails.job','DEFAULT',NULL,'metabase.task.follow_up_emails.FollowUpEmail',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.IndexValues.job','DEFAULT','Indexed Value Refresh task','metabase.task.index_values.ModelIndexRefresh',_binary '',_binary '',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.legacy-no-self-service-emails.job','DEFAULT',NULL,'metabase.task.legacy_no_self_service_emails.LegacyNoSelfServiceEmail',_binary '',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.PersistencePrune.job','DEFAULT','Persisted Model prune task','metabase.task.persist_refresh.PersistencePrune',_binary '',_binary '',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.PersistenceRefresh.job','DEFAULT','Persisted Model refresh task','metabase.task.persist_refresh.PersistenceRefresh',_binary '',_binary '',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.refresh-channel-cache.job','DEFAULT',NULL,'metabase.task.refresh_slack_channel_user_cache.RefreshCache',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.send-pulses.init-send-pulse-triggers.job','DEFAULT',NULL,'metabase.task.send_pulses.InitSendPulseTriggers',_binary '',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.send-pulses.send-pulse.job','DEFAULT','Send Pulse','metabase.task.send_pulses.SendPulse',_binary '',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.sync-and-analyze.job','DEFAULT','sync-and-analyze for all databases','metabase.task.sync_databases.SyncAndAnalyzeDatabase',_binary '',_binary '',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.task-history-cleanup.job','DEFAULT',NULL,'metabase.task.task_history_cleanup.TaskHistoryCleanup',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.truncate-audit-tables.job','DEFAULT',NULL,'metabase.task.truncate_audit_tables.TruncateAuditTables',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.update-field-values.job','DEFAULT','update-field-values for all databases','metabase.task.sync_databases.UpdateFieldValues',_binary '',_binary '',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0'),('MetabaseScheduler','metabase.task.upgrade-checks.job','DEFAULT',NULL,'metabase.task.upgrade_checks.CheckForNewVersions',_binary '\0',_binary '\0',_binary '\0',_binary '\0',_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0x\0');
/*!40000 ALTER TABLE `qrtz_job_details` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_locks`
--

DROP TABLE IF EXISTS `qrtz_locks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_locks` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `LOCK_NAME` varchar(40) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`LOCK_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_locks`
--

LOCK TABLES `qrtz_locks` WRITE;
/*!40000 ALTER TABLE `qrtz_locks` DISABLE KEYS */;
INSERT INTO `qrtz_locks` VALUES ('MetabaseScheduler','STATE_ACCESS'),('MetabaseScheduler','TRIGGER_ACCESS');
/*!40000 ALTER TABLE `qrtz_locks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_paused_trigger_grps`
--

DROP TABLE IF EXISTS `qrtz_paused_trigger_grps`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_paused_trigger_grps` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_paused_trigger_grps`
--

LOCK TABLES `qrtz_paused_trigger_grps` WRITE;
/*!40000 ALTER TABLE `qrtz_paused_trigger_grps` DISABLE KEYS */;
/*!40000 ALTER TABLE `qrtz_paused_trigger_grps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_scheduler_state`
--

DROP TABLE IF EXISTS `qrtz_scheduler_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_scheduler_state` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `INSTANCE_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `LAST_CHECKIN_TIME` bigint NOT NULL,
  `CHECKIN_INTERVAL` bigint NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`INSTANCE_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_scheduler_state`
--

LOCK TABLES `qrtz_scheduler_state` WRITE;
/*!40000 ALTER TABLE `qrtz_scheduler_state` DISABLE KEYS */;
INSERT INTO `qrtz_scheduler_state` VALUES ('MetabaseScheduler','39bc26db45631721572931316',1721573111987,7500);
/*!40000 ALTER TABLE `qrtz_scheduler_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_simple_triggers`
--

DROP TABLE IF EXISTS `qrtz_simple_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_simple_triggers` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `REPEAT_COUNT` bigint NOT NULL,
  `REPEAT_INTERVAL` bigint NOT NULL,
  `TIMES_TRIGGERED` bigint NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `FK_QRTZ_SIMPLE_TRIGGERS_TRIGGERS` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `qrtz_triggers` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_simple_triggers`
--

LOCK TABLES `qrtz_simple_triggers` WRITE;
/*!40000 ALTER TABLE `qrtz_simple_triggers` DISABLE KEYS */;
/*!40000 ALTER TABLE `qrtz_simple_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_simprop_triggers`
--

DROP TABLE IF EXISTS `qrtz_simprop_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_simprop_triggers` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `STR_PROP_1` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `STR_PROP_2` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `STR_PROP_3` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `INT_PROP_1` int DEFAULT NULL,
  `INT_PROP_2` int DEFAULT NULL,
  `LONG_PROP_1` bigint DEFAULT NULL,
  `LONG_PROP_2` bigint DEFAULT NULL,
  `DEC_PROP_1` decimal(13,4) DEFAULT NULL,
  `DEC_PROP_2` decimal(13,4) DEFAULT NULL,
  `BOOL_PROP_1` bit(1) DEFAULT NULL,
  `BOOL_PROP_2` bit(1) DEFAULT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `FK_QRTZ_SIMPROP_TRIGGERS_TRIGGERS` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `qrtz_triggers` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_simprop_triggers`
--

LOCK TABLES `qrtz_simprop_triggers` WRITE;
/*!40000 ALTER TABLE `qrtz_simprop_triggers` DISABLE KEYS */;
/*!40000 ALTER TABLE `qrtz_simprop_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_triggers`
--

DROP TABLE IF EXISTS `qrtz_triggers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_triggers` (
  `SCHED_NAME` varchar(120) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `JOB_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `JOB_GROUP` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `DESCRIPTION` varchar(250) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `NEXT_FIRE_TIME` bigint DEFAULT NULL,
  `PREV_FIRE_TIME` bigint DEFAULT NULL,
  `PRIORITY` int DEFAULT NULL,
  `TRIGGER_STATE` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `TRIGGER_TYPE` varchar(8) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `START_TIME` bigint NOT NULL,
  `END_TIME` bigint DEFAULT NULL,
  `CALENDAR_NAME` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `MISFIRE_INSTR` smallint DEFAULT NULL,
  `JOB_DATA` blob,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  KEY `IDX_QRTZ_T_J` (`SCHED_NAME`,`JOB_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_T_JG` (`SCHED_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_T_C` (`SCHED_NAME`,`CALENDAR_NAME`),
  KEY `IDX_QRTZ_T_G` (`SCHED_NAME`,`TRIGGER_GROUP`),
  KEY `IDX_QRTZ_T_STATE` (`SCHED_NAME`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_N_STATE` (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_N_G_STATE` (`SCHED_NAME`,`TRIGGER_GROUP`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_NEXT_FIRE_TIME` (`SCHED_NAME`,`NEXT_FIRE_TIME`),
  KEY `IDX_QRTZ_T_NFT_ST` (`SCHED_NAME`,`TRIGGER_STATE`,`NEXT_FIRE_TIME`),
  KEY `IDX_QRTZ_T_NFT_MISFIRE` (`SCHED_NAME`,`MISFIRE_INSTR`,`NEXT_FIRE_TIME`),
  KEY `IDX_QRTZ_T_NFT_ST_MISFIRE` (`SCHED_NAME`,`MISFIRE_INSTR`,`NEXT_FIRE_TIME`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_NFT_ST_MISFIRE_GRP` (`SCHED_NAME`,`MISFIRE_INSTR`,`NEXT_FIRE_TIME`,`TRIGGER_GROUP`,`TRIGGER_STATE`),
  CONSTRAINT `FK_QRTZ_TRIGGERS_JOB_DETAILS` FOREIGN KEY (`SCHED_NAME`, `JOB_NAME`, `JOB_GROUP`) REFERENCES `qrtz_job_details` (`SCHED_NAME`, `JOB_NAME`, `JOB_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used for Quartz scheduler.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_triggers`
--

LOCK TABLES `qrtz_triggers` WRITE;
/*!40000 ALTER TABLE `qrtz_triggers` DISABLE KEYS */;
INSERT INTO `qrtz_triggers` VALUES ('MetabaseScheduler','metabase.task.anonymous-stats.trigger','DEFAULT','metabase.task.anonymous-stats.job','DEFAULT',NULL,1721624580000,-1,5,'WAITING','CRON',1721572932000,0,NULL,0,''),('MetabaseScheduler','metabase.task.creator-sentiment-emails.trigger','DEFAULT','metabase.task.creator-sentiment-emails.job','DEFAULT',NULL,1722045600000,-1,5,'WAITING','CRON',1721572932000,0,NULL,0,''),('MetabaseScheduler','metabase.task.follow-up-emails.trigger','DEFAULT','metabase.task.follow-up-emails.job','DEFAULT',NULL,1721649600000,-1,5,'WAITING','CRON',1721572932000,0,NULL,0,''),('MetabaseScheduler','metabase.task.refresh-channel-cache.trigger','DEFAULT','metabase.task.refresh-channel-cache.job','DEFAULT',NULL,1721580780000,-1,5,'WAITING','CRON',1721572932000,0,NULL,2,''),('MetabaseScheduler','metabase.task.sync-and-analyze.trigger.2','DEFAULT','metabase.task.sync-and-analyze.job','DEFAULT','sync-and-analyze Database 2',1721576700000,1721573100000,5,'BLOCKED','CRON',1718806695000,0,NULL,2,_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0t\0db-idsr\0java.lang.Integer⠤\???8\0I\0valuexr\0java.lang.Number????\?\0\0xp\0\0\0x\0'),('MetabaseScheduler','metabase.task.task-history-cleanup.trigger','DEFAULT','metabase.task.task-history-cleanup.job','DEFAULT',NULL,1721606400000,-1,5,'WAITING','CRON',1721572932000,0,NULL,0,''),('MetabaseScheduler','metabase.task.truncate-audit-tables.trigger','DEFAULT','metabase.task.truncate-audit-tables.job','DEFAULT',NULL,1721606400000,-1,5,'WAITING','CRON',1721572932000,0,NULL,2,''),('MetabaseScheduler','metabase.task.update-field-values.trigger.2','DEFAULT','metabase.task.update-field-values.job','DEFAULT','update-field-values Database 2',1721595600000,1721509200000,5,'WAITING','CRON',1718806695000,0,NULL,2,_binary '?\?0sr\0org.quartz.JobDataMap???迩?\?\0\0xr\0&org.quartz.utils.StringKeyDirtyFlagMap?\??\?(\0Z\0allowsTransientDataxr\0org.quartz.utils.DirtyFlagMap\?.?(v\n\?\0Z\0dirtyL\0mapt\0Ljava/util/Map;xp\0sr\0java.util.HashMap\?\?`\?\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0t\0db-idsr\0java.lang.Integer⠤\???8\0I\0valuexr\0java.lang.Number????\?\0\0xp\0\0\0x\0'),('MetabaseScheduler','metabase.task.upgrade-checks.trigger','DEFAULT','metabase.task.upgrade-checks.job','DEFAULT',NULL,1721585700000,-1,5,'WAITING','CRON',1721572932000,0,NULL,0,'');
/*!40000 ALTER TABLE `qrtz_triggers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `query`
--

DROP TABLE IF EXISTS `query`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `query` (
  `query_hash` binary(32) NOT NULL COMMENT 'The hash of the query dictionary. (This is a 256-bit SHA3 hash of the query dict.)',
  `average_execution_time` int NOT NULL COMMENT 'Average execution time for the query, round to nearest number of milliseconds. This is updated as a rolling average.',
  `query` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`query_hash`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Information (such as average execution time) for different queries that have been previously ran.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `query`
--

LOCK TABLES `query` WRITE;
/*!40000 ALTER TABLE `query` DISABLE KEYS */;
INSERT INTO `query` VALUES (_binary 'fU?\?S\??ΰ,l\?? {?~\?P\???+7c#',66,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n\\n\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T',1035,'{\"constraints\":{\"max-results\":10000,\"max-results-bare-rows\":2000},\"type\":\"native\",\"middleware\":{\"js-int-to-string?\":true,\"ignore-cached-results?\":false,\"process-viz-settings?\":false,\"userland-query?\":true},\"cache-strategy\":null,\"native\":{\"template-tags\":{},\"query\":\"SELECT\\n\\tptime   \'时间\',\\n\\tmembership_cnt   \'会员数\',\\n\\tmembership_flow   \'会员流水\',\\n\\tzone_admission_cnt   \'空间解锁数\',\\n\\tzone_admission_flow   \'空间解锁流水\',\\n\\tzone_superfan_cnt   \'空间超粉数\',\\n\\tzone_superfan_flow   \'空间超粉流水\',\\n\\tzone_moment_cnt   \'空间动态数\',\\n\\tzone_moment_flow   \'空间动态流水\',\\n\\tother_cnt   \'其他数(微信+金币)\',\\n\\tother_flow   \'其他流水(微信+金币)\',\\n\\ttotal_flow   \'总流水\',\\n\\tstreamer_flow   \'主播分成\',\\n\\tofficial_flow   \'净收入\',\\n\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\n\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\n\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\n\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\n\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\n\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\nFROM vas_day_detail\\nORDER BY ptime DESC\\n;\"},\"viz-settings\":null,\"database\":2}'),(_binary '#?]?\?\?,S?\?,?o	?檣?w<\?8k/\\?\?',24,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_day_flow WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '??ox?*?H?\????\ZWM???zna?B\?f',14,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t2.t,\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t1.t\\n;\\n\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '??đrK\?g|?\??1?\?CGO\???\?',56,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT\\n\\tptime   \'时间\',\\n\\tmembership_cnt   \'会员数\',\\n\\tmembership_flow   \'会员流水\',\\n\\tzone_admission_cnt   \'空间解锁数\',\\n\\tzone_admission_flow   \'空间解锁流水\',\\n\\tzone_superfan_cnt   \'空间超粉数\',\\n\\tzone_superfan_flow   \'空间超粉流水\',\\n\\tzone_moment_cnt   \'空间动态数\',\\n\\tzone_moment_flow   \'空间动态流水\',\\n\\tother_cnt   \'其他数(微信+金币)\',\\n\\tother_flow   \'其他流水(微信+金币)\',\\n\\ttotal_flow   \'总流水\',\\n\\tstreamer_flow   \'主播分成\',\\n\\tofficial_flow   \'净收入\',\\n\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\n\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\n\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\n\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\n\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\n\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\nFROM vas_day_detail;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?',255,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t2.t,\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '>?1S???	_??傹-T\"3|E)?y??g\???',36,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM streamer;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?lm.iP?A9?\????K`\\\?C	????Z\?',322,'{\"constraints\":{\"max-results\":10000,\"max-results-bare-rows\":2000},\"type\":\"native\",\"middleware\":{\"js-int-to-string?\":true,\"ignore-cached-results?\":false,\"process-viz-settings?\":false,\"userland-query?\":true},\"cache-strategy\":null,\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"},\"viz-settings\":null,\"database\":2}'),(_binary 'Cv???t???!\?!???X?\?\?\?\n{??l',18,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\nORDER BY t1.income DESC\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'CY??o?UKs?)0??`?Sy?\?nz??1ʘQ',16,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'IoPu7?\?w)ll?)`???{\???. N?Q]3e',491,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'L\?.?\??\??=b??]\?\??k?J?8??',116,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT ptime, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'M?d?\???$\\ˡ3r?[M\?\??\?`hv?!??',10,'{\"native\":{\"template-tags\":{},\"query\":\"SELECT * FROM vas_day_flow WHERE pdate>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n\"},\"type\":\"native\",\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'P\?\?/ț?;?\???\??N?\????k?#+',183,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'Yh\??V\??\?Zh????&X$?p\??Qʟ?\??\?',14,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_day_detail WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'b;\???q\?\???\??\??\?I3\??a?s\?',149,'{\"constraints\":{\"max-results\":10000,\"max-results-bare-rows\":2000},\"type\":\"native\",\"middleware\":{\"js-int-to-string?\":true,\"ignore-cached-results?\":false,\"process-viz-settings?\":false,\"userland-query?\":true},\"cache-strategy\":null,\"native\":{\"template-tags\":{},\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\nORDER BY t1.income DESC\\n;\"},\"viz-settings\":null,\"database\":2}'),(_binary 'i\???Ck??k?F\????}?nIU\??^X\?',11,'{\"native\":{\"template-tags\":{},\"query\":\"SELECT DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\"},\"type\":\"native\",\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary 'v/m\?<\??n\\\?,M?X\??dڹH+?ǡ??#?',79,'{\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_day_flow;\",\"template-tags\":{}},\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?1?u\?Ω\\\??\?%\????ӷ?#SFK?\?',241,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_cur_streamer_income;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '???\?\\?!.-\?y?x \?-Ye@]\????',59,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT\\n\\tptime   \'时间\',\\n\\tmembership_cnt   \'会员数\',\\n\\tmembership_flow   \'会员流水\',\\n\\tzone_admission_cnt   \'空间解锁数\',\\n\\tzone_admission_flow   \'空间解锁流水\',\\n\\tzone_superfan_cnt   \'空间超粉数\',\\n\\tzone_superfan_flow   \'空间超粉流水\',\\n\\tzone_moment_cnt   \'空间动态数\',\\n\\tzone_moment_flow   \'空间动态流水\',\\n\\tother_cnt   \'其他数(微信+金币)\',\\n\\tother_flow   \'其他流水(微信+金币)\',\\n\\ttotal_flow   \'总流水\',\\n\\tstreamer_flow   \'主播分成\',\\n\\tofficial_flow   \'净收入\',\\n\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\n\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\n\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\n\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\n\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\n\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\nFROM vas_day_detail\\nORDER BY ptime DESC\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n',178,'{\"constraints\":{\"max-results\":10000,\"max-results-bare-rows\":2000},\"type\":\"native\",\"middleware\":{\"js-int-to-string?\":true,\"ignore-cached-results?\":false,\"userland-query?\":true},\"cache-strategy\":null,\"native\":{\"template-tags\":{},\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'主播昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\nORDER BY t1.income DESC\\n;\"},\"viz-settings\":{},\"database\":2}'),(_binary '?7??A*w?/00\?Z\'??\?Ht??0?\?(?',120,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT ptime, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '??3CL,??[WA8?f?U?Mz??2ӘV\?8',140,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t1.t,\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t1.t\\n;\\n\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?){???9\r?u\?=21ǉ?\?)???\?yK?99?',228,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT t2.t, t2.flow, t1.flow, t0.flow\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?I??\??\????????t?\??\??6F?5^n',9,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT NOW()\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?~????\?t\????.?\?\?\?*??$7tP7',15,'{\"type\":\"native\",\"native\":{\"query\":\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\",\"template-tags\":{}},\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '\?0\??[ƊAV1\?7~???\??9]?/\?0tGe',42,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_yoy_flow WHERE pdate>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '\?:?\??\?l?\?K\0?|?KK?OB~*??\"?',220,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(ptime, \'%Y-%m-%d 00:00:00\')\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '\??/+??æ\?????\?M?\?*?xm\np\?41',11,'{\"type\":\"native\",\"native\":{\"query\":\"SELECT flow FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\",\"template-tags\":{}},\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '㇧\'~???v;\'??\'\??u8?S\???Tl',199,'{\"constraints\":{\"max-results\":10000,\"max-results-bare-rows\":2000},\"type\":\"native\",\"middleware\":{\"js-int-to-string?\":true,\"ignore-cached-results?\":false,\"process-viz-settings?\":false,\"userland-query?\":true},\"cache-strategy\":null,\"native\":{\"template-tags\":{},\"query\":\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\"},\"viz-settings\":null,\"database\":2}'),(_binary '\?\?O?\?)?iϵ\?\?4?ZT??bhJ?+\?',175,'{\"native\":{\"template-tags\":{},\"query\":\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n\"},\"type\":\"native\",\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?????äcͣ\???D??c]?N\??2?ˏ??',197,'{\"native\":{\"template-tags\":{},\"query\":\"SELECT * FROM vas_day_detail WHERE DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\"},\"type\":\"native\",\"database\":2,\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?\?D\?\?-?i*ƀ\?O콞??!?\?2|_?X?',28,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'昵称\',\\n        t1.income AS \'主播收入\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name != \'\'\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}'),(_binary '?\?42	\?7?r3?\?v\??\?+l-\?t\0ܹ',19,'{\"database\":2,\"type\":\"native\",\"native\":{\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name \'昵称\',\\n        t1.income \'主播收入\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\n;\",\"template-tags\":{}},\"middleware\":{\"js-int-to-string?\":true,\"userland-query?\":true,\"add-default-userland-constraints?\":true}}');
/*!40000 ALTER TABLE `query` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `query_action`
--

DROP TABLE IF EXISTS `query_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `query_action` (
  `action_id` int NOT NULL COMMENT 'The related action',
  `database_id` int NOT NULL,
  `dataset_query` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`action_id`),
  KEY `fk_query_action_database_id` (`database_id`),
  CONSTRAINT `fk_query_action_database_id` FOREIGN KEY (`database_id`) REFERENCES `metabase_database` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_query_action_ref_action_id` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='A readwrite query type of action';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `query_action`
--

LOCK TABLES `query_action` WRITE;
/*!40000 ALTER TABLE `query_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `query_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `query_cache`
--

DROP TABLE IF EXISTS `query_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `query_cache` (
  `query_hash` binary(32) NOT NULL COMMENT 'The hash of the query dictionary. (This is a 256-bit SHA3 hash of the query dict).',
  `updated_at` timestamp(6) NULL DEFAULT NULL,
  `results` longblob,
  PRIMARY KEY (`query_hash`),
  KEY `idx_query_cache_updated_at` (`updated_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Cached results of queries are stored here when using the DB-based query cache.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `query_cache`
--

LOCK TABLES `query_cache` WRITE;
/*!40000 ALTER TABLE `query_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `query_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `query_execution`
--

DROP TABLE IF EXISTS `query_execution`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `query_execution` (
  `id` int NOT NULL AUTO_INCREMENT,
  `hash` binary(32) NOT NULL COMMENT 'The hash of the query dictionary. This is a 256-bit SHA3 hash of the query.',
  `started_at` timestamp(6) NULL DEFAULT NULL,
  `running_time` int NOT NULL COMMENT 'The time, in milliseconds, this query took to complete.',
  `result_rows` int NOT NULL COMMENT 'Number of rows in the query results.',
  `native` bit(1) NOT NULL COMMENT 'Whether the query was a native query, as opposed to an MBQL one (e.g., created with the GUI).',
  `context` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Short string specifying how this query was executed, e.g. in a Dashboard or Pulse.',
  `error` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `executor_id` int DEFAULT NULL COMMENT 'The ID of the User who triggered this query execution, if any.',
  `card_id` int DEFAULT NULL COMMENT 'The ID of the Card (Question) associated with this query execution, if any.',
  `dashboard_id` int DEFAULT NULL COMMENT 'The ID of the Dashboard associated with this query execution, if any.',
  `pulse_id` int DEFAULT NULL COMMENT 'The ID of the Pulse associated with this query execution, if any.',
  `database_id` int DEFAULT NULL COMMENT 'ID of the database this query was ran against.',
  `cache_hit` bit(1) DEFAULT NULL COMMENT 'Cache hit on query execution',
  `action_id` int DEFAULT NULL COMMENT 'The ID of the action associated with this query execution, if any.',
  `is_sandboxed` bit(1) DEFAULT NULL,
  `cache_hash` blob COMMENT 'Hash of normalized query, calculated in middleware.cache',
  PRIMARY KEY (`id`),
  KEY `idx_query_execution_started_at` (`started_at`),
  KEY `idx_query_execution_query_hash_started_at` (`hash`,`started_at`),
  KEY `idx_query_execution_card_id` (`card_id`),
  KEY `idx_query_execution_card_id_started_at` (`card_id`,`started_at`),
  KEY `idx_query_execution_executor_id` (`executor_id`),
  KEY `idx_query_execution_context` (`context`),
  KEY `idx_query_execution_action_id` (`action_id`),
  KEY `idx_query_execution_card_qualified_id` ((concat(_utf8mb4'card_',`card_id`)))
) ENGINE=InnoDB AUTO_INCREMENT=12478 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='A log of executed queries, used for calculating historic execution times, auditing, and other purposes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `query_execution`
--

LOCK TABLES `query_execution` WRITE;
/*!40000 ALTER TABLE `query_execution` DISABLE KEYS */;
INSERT INTO `query_execution` VALUES (1,_binary 'v/m\?<\??n\\\?,M?X\??dڹH+?ǡ??#?','2024-06-19 06:19:06.454153',79,43,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2,_binary '\??/+??æ\?????\?M?\?*?xm\np\?41','2024-06-19 06:19:39.633199',11,1,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3,_binary '?~????\?t\????.?\?\?\?*??$7tP7','2024-06-19 06:19:48.623458',15,1,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:21:08.238381',101,1,_binary '','question',NULL,13371339,27,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:21:37.140825',83,1,_binary '','question',NULL,13371339,27,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:21:50.909851',63,1,_binary '','question',NULL,13371339,27,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:21:58.378706',59,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:22:14.447723',39,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:22:24.574657',44,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:26:19.378222',67,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:03.028999',68,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:15.800640',76,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(13,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:22.343759',53,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(14,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:23.903027',49,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(15,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:26.256633',74,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(16,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:27.564045',64,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(17,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:39.286955',58,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(18,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:46.640892',76,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(19,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:48.274649',39,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(20,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:28:49.540230',44,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(21,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:29:05.332247',61,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(22,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:29:09.286891',39,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(23,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:29:09.952671',53,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(24,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:29:41.632835',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(25,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:29:46.379804',47,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(26,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:30:01.879876',75,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(27,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:30:14.638363',61,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(28,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:30:16.786445',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(29,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:31:10.613935',67,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(30,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:32:01.434054',62,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(31,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:32:13.853552',59,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(32,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:32:18.703687',57,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(33,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:32:34.180662',66,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(34,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:33:41.605092',63,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(35,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:33:42.554153',53,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(36,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:33:45.079690',90,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(37,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:33:46.628717',55,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(38,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:34:28.039272',52,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(39,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:34:33.441225',62,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(40,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:34:43.352182',73,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(41,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:38:56.766190',58,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(42,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:39:15.071353',57,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(43,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:39:24.867724',48,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(44,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:39:28.527731',89,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(45,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:39:36.570799',39,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(46,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:39:56.171918',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(47,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:40:26.195569',66,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(48,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:41:19.869237',59,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(49,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:41:27.107857',59,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(50,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:41:34.195197',43,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(51,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:41:55.433058',36,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(52,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:44:41.900389',50,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(53,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:44:53.929640',56,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(54,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:48:33.120993',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(55,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:49:08.798186',61,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(56,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:42.739577',39,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(57,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:44.758626',50,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(58,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:48.198619',57,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(59,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:52.838382',49,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(60,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:55.804200',55,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(61,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:57.942531',36,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(62,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:50:59.557451',70,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(63,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 06:57:01.836391',55,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(64,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:03:00.234299',62,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(65,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:04:35.959448',52,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(66,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:20:24.813867',63,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(67,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:23:56.330694',57,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(68,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:36:08.476834',56,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(69,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:40:50.655010',69,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(70,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:43:43.777215',75,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(71,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 07:57:24.641417',85,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(72,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:01:08.761511',58,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(73,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:01:11.042959',57,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(74,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:01:44.299619',50,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(75,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:02:07.541537',61,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(76,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:02:13.579840',71,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(77,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:03:03.278722',60,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(78,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:03:47.177402',58,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(79,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:04:17.334145',63,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(80,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:04:20.034389',54,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(81,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:04:24.034387',70,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(82,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:10:26.817053',66,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(83,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:25:58.361095',51,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(84,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:26:00.625718',56,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(85,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:30:17.195344',51,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(86,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:32:06.593922',56,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(87,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:32:10.368708',54,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(88,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:32:18.775688',59,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(89,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:36:14.294100',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(90,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 08:41:13.317084',43,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(91,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:03:22.545941',46,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(92,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:15:02.293640',50,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(93,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:29:56.696278',53,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(94,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:35:07.792213',53,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(95,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:35:11.999700',66,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(96,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:38:08.009568',52,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(97,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:39:29.154194',54,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(98,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:54:27.863722',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(99,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:56:17.850297',54,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(100,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 09:59:12.495809',62,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(101,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:06:55.489901',58,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(102,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:16:40.102656',48,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(103,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:18:48.158441',47,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(104,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:25:25.036716',63,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:31:02.485861',53,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(106,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:31:49.691797',57,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(107,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:35:31.106603',52,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(108,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 10:54:52.514125',44,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(109,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 11:46:57.406481',54,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(110,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 11:52:46.830250',49,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(111,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 12:08:22.853067',46,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(112,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 12:27:13.368991',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 12:27:16.282981',53,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(114,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 12:58:40.362953',54,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(115,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 12:58:42.654612',51,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(116,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 14:42:59.161864',51,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(117,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:05:10.639437',47,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:05:12.203769',74,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(119,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:25:30.851411',46,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(120,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:34:14.717793',47,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(121,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:34:19.276665',50,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(122,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:34:22.752330',51,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(123,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 15:51:49.961808',47,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(124,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 16:28:42.688169',55,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 16:29:34.006838',50,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(126,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 16:32:03.833928',64,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(127,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 16:46:43.711293',52,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(128,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 16:48:32.347294',45,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(129,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:15:17.986386',70,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(130,_binary 'i\???Ck??k?F\????}?nIU\??^X\?','2024-06-19 17:18:20.034008',11,1,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(131,_binary '\?:?\??\?l?\?K\0?|?KK?OB~*??\"?','2024-06-19 17:18:55.055264',220,66,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(132,_binary 'Yh\??V\??\?Zh????&X$?p\??Qʟ?\??\?','2024-06-19 17:19:37.256414',14,0,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(133,_binary '?????äcͣ\???D??c]?N\??2?ˏ??','2024-06-19 17:20:00.865279',197,66,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(134,_binary '?I??\??\????????t?\??\??6F?5^n','2024-06-19 17:20:28.442160',9,1,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(135,_binary '\?\?O?\?)?iϵ\?\?4?ZT??bhJ?+\?','2024-06-19 17:20:35.263920',175,66,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(136,_binary '#?]?\?\?,S?\?,?o	?檣?w<\?8k/\\?\?','2024-06-19 17:20:45.565700',24,44,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(137,_binary 'M?d?\???$\\ˡ3r?[M\?\??\?`hv?!??','2024-06-19 17:23:43.476877',10,1,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(138,_binary '\?0\??[ƊAV1\?7~???\??9]?/\?0tGe','2024-06-19 17:24:12.001130',42,0,_binary '','ad-hoc','(conn=1096) Unknown column \'pdate\' in \'where clause\'',13371339,NULL,NULL,NULL,2,NULL,NULL,NULL,NULL),(139,_binary 'fU?\?S\??ΰ,l\?? {?~\?P\???+7c#','2024-06-19 17:24:20.264374',66,112,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(140,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:25:36.894287',55,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(141,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:25:43.977852',42,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(142,_binary '?7??A*w?/00\?Z\'??\?Ht??0?\?(?','2024-06-19 17:26:01.736406',120,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(143,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:26:13.253487',64,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(144,_binary 'L\?.?\??\??=b??]\?\??k?J?8??','2024-06-19 17:26:25.294244',116,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(145,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:28:31.534866',59,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(146,_binary 'IoPu7?\?w)ll?)`???{\???. N?Q]3e','2024-06-19 17:31:07.447215',491,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(147,_binary '?){???9\r?u\?=21ǉ?\?)???\?yK?99?','2024-06-19 17:31:48.246233',228,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(148,_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?','2024-06-19 17:32:56.323482',293,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(149,_binary '??ox?*?H?\????\ZWM???zna?B\?f','2024-06-19 17:35:10.800103',14,0,_binary '','ad-hoc','(conn=1096) Unknown column \'t2.t\' in \'field list\'',13371339,NULL,NULL,NULL,2,NULL,NULL,NULL,NULL),(150,_binary '??3CL,??[WA8?f?U?Mz??2ӘV\?8','2024-06-19 17:35:21.908457',140,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(151,_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?','2024-06-19 17:36:14.688689',222,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(152,_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?','2024-06-19 17:36:19.742425',208,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(153,_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?','2024-06-19 17:36:31.789712',178,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(154,_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?','2024-06-19 17:36:45.557220',198,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(155,_binary '9[\??kr?\?{?8\?\?N\?fa?)?]\?','2024-06-19 17:36:46.743257',203,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(156,_binary 'P\?\?/ț?;?\???\??N?\????k?#+','2024-06-19 17:37:09.844612',174,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(157,_binary 'P\?\?/ț?;?\???\??N?\????k?#+','2024-06-19 17:38:08.261636',255,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(158,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:39:47.103129',129,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(159,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:39:47.121007',282,288,_binary '','question',NULL,13371339,28,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(160,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:40:47.131915',309,288,_binary '','question',NULL,13371339,28,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(161,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:41:01.129711',265,288,_binary '','question',NULL,13371339,28,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(162,_binary 'P\?\?/ț?;?\???\??N?\????k?#+','2024-06-19 17:41:24.368356',195,288,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(163,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:43:22.727572',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:43:22.730647',285,288,_binary '','dashboard',NULL,13371341,28,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(165,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:43:37.595402',57,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(166,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:43:37.600634',279,288,_binary '','dashboard',NULL,13371339,28,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(167,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:44:12.836693',50,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(168,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:44:21.708298',249,288,_binary '','question',NULL,13371339,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(169,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:44:31.594190',315,288,_binary '','question',NULL,13371339,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(170,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:44:46.171409',90,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(171,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:44:46.174224',257,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(172,_binary '?1?u\?Ω\\\??\?%\????ӷ?#SFK?\?','2024-06-19 17:46:31.933308',241,488,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(173,_binary '>?1S???	_??傹-T\"3|E)?y??g\???','2024-06-19 17:48:28.162542',36,394,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(174,_binary '?\?42	\?7?r3?\?v\??\?+l-\?t\0ܹ','2024-06-19 17:50:46.987054',19,101,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(175,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:51:05.373746',90,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:51:05.374261',243,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(177,_binary '?\?D\?\?-?i*ƀ\?O콞??!?\?2|_?X?','2024-06-19 17:51:21.468292',28,91,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(178,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:51:21.329839',288,288,_binary '','question',NULL,13371341,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(179,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:51:27.362176',251,288,_binary '','question',NULL,13371341,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(180,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:51:40.146020',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(181,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:51:40.144357',326,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(182,_binary 'CY??o?UKs?)0??`?Sy?\?nz??1ʘQ','2024-06-19 17:51:40.830917',16,91,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(183,_binary 'Cv???t???!\?!???X?\?\?\?\n{??l','2024-06-19 17:51:59.760043',18,91,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(184,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:52:29.425716',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(185,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:52:29.429302',349,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(186,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:53:09.177520',129,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(187,_binary 'b;\???q\?\???\??\??\?I3\??a?s\?','2024-06-19 17:53:09.200381',156,92,_binary '','question',NULL,13371339,30,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(188,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:53:09.179179',362,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(189,_binary 'b;\???q\?\???\??\??\?I3\??a?s\?','2024-06-19 17:53:36.014336',85,92,_binary '','question',NULL,13371339,30,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(190,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:53:52.933340',112,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(191,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 17:53:52.932215',156,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(192,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:53:52.926219',341,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(193,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:54:55.493772',179,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(194,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 17:54:55.488725',262,92,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(195,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:54:55.496019',360,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(196,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:55:08.972310',198,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(197,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 17:55:08.994722',176,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(198,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:55:08.978922',466,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(199,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:55:11.247341',113,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(200,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 17:55:11.258668',137,92,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(201,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:55:11.279612',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(202,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:55:15.049759',72,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(203,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 17:55:15.072474',119,92,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(204,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:55:15.054341',382,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(205,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 17:55:47.287264',134,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(206,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 17:55:47.295856',141,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(207,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 17:55:47.291530',280,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(208,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:00:05.912955',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(209,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:00:05.916564',172,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(210,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:00:05.934474',272,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(211,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:02:10.330457',150,92,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(212,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:02:10.330285',164,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(213,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:02:10.328076',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(214,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:14:03.720393',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(215,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:14:03.713201',120,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(216,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:14:03.726012',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(217,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:14:14.847082',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(218,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:14:14.863248',149,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(219,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:14:14.837044',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(220,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:14:17.646108',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(221,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:14:17.659467',144,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(222,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:14:17.675874',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(223,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:36:14.084695',157,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(224,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:36:14.077764',220,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(225,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:36:14.074916',394,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(226,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:41:51.447983',171,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(227,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:41:51.450521',202,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(228,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:41:51.458511',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(229,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:46:34.764612',131,94,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(230,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:46:34.762862',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(231,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:46:34.774373',308,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(232,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 18:58:50.552269',338,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(233,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 18:58:50.585142',370,95,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(234,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 18:58:50.570820',520,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(235,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 19:02:13.859248',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(236,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 19:02:13.845742',133,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(237,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 19:02:13.858210',273,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(238,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 19:04:20.139326',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(239,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 19:04:20.142155',140,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(240,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 19:04:20.133954',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(241,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 19:22:01.967786',191,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(242,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 19:22:01.986377',194,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(243,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 19:22:01.974928',341,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(244,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 19:34:41.241418',138,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(245,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 19:34:41.227743',164,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(246,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 19:34:41.225038',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(247,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 19:46:31.795437',168,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(248,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 19:46:31.822792',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(249,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 19:46:31.813608',325,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(250,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:09:25.927909',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(251,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:09:25.929330',198,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(252,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:09:25.870505',364,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(253,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:13:37.583312',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(254,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:13:37.592916',149,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(255,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:13:37.608139',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(256,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:31:12.226879',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(257,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:31:12.220557',152,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(258,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:31:12.211790',366,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(259,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:45:02.435187',123,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(260,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:45:02.461059',182,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(261,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:45:02.448627',357,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:56:00.861123',111,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(263,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:56:00.876870',206,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(264,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:56:00.871882',340,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(265,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:56:05.216414',201,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(266,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:56:05.212732',234,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(267,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:56:05.223746',435,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(268,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:57:11.792756',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(269,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:57:11.799317',150,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(270,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:57:11.786303',328,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(271,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 20:57:14.661913',133,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(272,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 20:57:14.668811',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(273,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 20:57:14.636249',319,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(274,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:03:13.740788',77,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(275,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:03:13.759853',121,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(276,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:03:13.756337',306,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(277,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:25:46.538368',129,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(278,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:25:46.544280',133,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(279,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:25:46.537658',278,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(280,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:27:05.041051',142,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(281,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:27:05.034048',165,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(282,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:27:05.036509',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(283,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:27:16.831014',67,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(284,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:27:16.823130',133,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(285,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:27:16.819815',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(286,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:27:20.333770',88,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(287,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:27:20.332715',117,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(288,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:27:20.332523',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:42:20.446270',134,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(290,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:42:20.435140',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(291,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:42:20.448646',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(292,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:42:31.883328',136,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(293,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:42:31.885288',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(294,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:42:31.884527',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 22:42:41.231183',95,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(296,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 22:42:41.224865',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(297,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 22:42:41.252988',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(298,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 23:38:40.496489',105,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(299,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 23:38:40.511631',104,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(300,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 23:38:40.499429',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(301,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-19 23:40:43.563728',153,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(302,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-19 23:40:43.559700',163,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(303,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-19 23:40:43.572994',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(304,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 01:09:37.894782',175,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(305,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 01:09:37.901816',195,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(306,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 01:09:37.892754',347,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(307,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 01:10:12.626826',133,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(308,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 01:10:12.635034',170,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(309,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 01:10:12.625333',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 01:22:45.491363',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(311,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 01:22:45.508636',192,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(312,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 01:22:45.496753',378,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(313,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 02:24:08.111041',131,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 02:24:08.160842',123,109,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(315,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 02:24:08.120248',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(316,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 02:48:01.363607',76,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(317,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 02:48:01.361462',141,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(318,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 02:48:01.362151',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(319,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 02:57:49.577506',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(320,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 02:57:49.574134',127,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(321,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 02:57:49.579933',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(322,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 02:59:27.455817',201,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(323,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 02:59:27.468145',204,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(324,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 02:59:27.454258',339,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(325,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:00:07.876790',142,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(326,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:00:07.879152',131,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(327,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:00:07.877355',267,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(328,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:04:46.499457',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(329,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:04:46.517302',197,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(330,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:04:46.494494',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(331,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:28:28.716529',135,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(332,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:28:28.724159',148,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(333,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:28:28.733321',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(334,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:31:53.962032',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(335,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:31:53.961942',136,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(336,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:31:53.967504',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(337,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:31:56.313142',107,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(338,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:31:56.302536',122,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(339,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:31:56.309143',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(340,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:32:04.861941',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(341,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:32:04.858221',126,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(342,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:32:04.863785',269,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(343,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:32:07.602076',98,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(344,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:32:07.615241',117,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(345,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:32:07.607978',331,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(346,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:32:10.715240',85,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(347,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:32:10.714844',150,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(348,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:32:10.712313',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(349,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:33:42.373656',123,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(350,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:33:42.378884',148,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(351,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:33:42.369672',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(352,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:33:46.393341',126,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(353,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:33:46.383408',133,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(354,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:33:46.392200',264,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(355,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:34:42.264030',129,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(356,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:34:42.257410',131,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(357,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:34:42.261110',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(358,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:39:32.296296',157,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(359,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:39:32.288105',196,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(360,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:39:32.288110',374,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(361,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 03:55:16.508169',192,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(362,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 03:55:16.498457',208,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(363,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 03:55:16.520713',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(364,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 04:02:15.216007',138,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(365,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 04:02:15.207140',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(366,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 04:02:15.184350',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(367,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 04:09:29.684435',126,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(368,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 04:09:29.682692',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(369,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 04:09:29.679992',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(370,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 04:13:58.049177',121,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(371,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 04:13:58.053891',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(372,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 04:13:58.061218',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(373,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 04:41:39.660141',121,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(374,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 04:41:39.653989',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(375,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 04:41:39.662222',345,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(376,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 04:45:31.456718',92,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(377,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 04:45:31.469262',109,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(378,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 04:45:31.456983',270,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 04:59:44.268399',142,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(380,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 04:59:44.271414',210,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(381,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 04:59:44.277443',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(382,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:00:30.450028',165,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(383,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:00:30.471186',157,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(384,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:00:30.447431',339,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(385,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:07:28.036061',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(386,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:07:28.021073',160,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(387,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:07:28.027514',386,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(388,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:07:47.755559',127,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(389,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:07:47.761163',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(390,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:07:47.758940',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(391,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:07:50.373979',53,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(392,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:07:50.415552',169,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(393,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:07:50.479275',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(394,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:26:19.565700',121,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(395,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:26:19.566759',121,112,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(396,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:26:19.565701',289,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:33:20.787466',167,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(398,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:33:20.771668',196,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(399,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:33:20.789664',339,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(400,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:42:05.418183',150,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(401,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:42:05.410721',144,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(402,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:42:05.437657',285,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(403,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:42:21.021784',128,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(404,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:42:21.027537',141,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(405,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:42:21.028331',267,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(406,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:43:31.043543',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(407,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:43:31.044752',180,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(408,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:43:31.053318',309,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(409,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:43:59.266894',73,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(410,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:43:59.258101',141,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(411,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:43:59.249412',279,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(412,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:45:13.745897',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(413,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:45:13.748167',127,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(414,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:45:13.739016',250,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(415,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:45:43.051524',139,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(416,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:45:43.041984',154,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(417,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:45:43.038443',304,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(418,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:46:00.919577',117,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(419,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:46:00.919700',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(420,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:46:00.926710',296,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(421,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:46:35.892711',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(422,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:46:35.907540',120,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(423,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:46:35.903315',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(424,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:46:37.521974',88,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(425,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:46:37.530941',135,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(426,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:46:37.522483',267,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(427,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:51:38.231438',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(428,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:51:38.262409',151,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(429,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:51:38.238627',372,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(430,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:56:03.138084',140,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(431,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:56:03.128693',160,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(432,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:56:03.131577',360,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(433,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 05:58:42.958571',132,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(434,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 05:58:42.975110',114,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(435,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 05:58:42.969128',290,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(436,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:02:49.682047',124,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(437,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:02:49.674317',141,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(438,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:02:49.679782',284,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(439,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:10:28.574254',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(440,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:10:28.578190',152,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(441,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:10:28.600024',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(442,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:11:28.036526',124,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(443,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:11:28.039424',137,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(444,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:11:28.041620',281,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(445,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:17:13.394833',139,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(446,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:17:13.395868',155,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(447,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:17:13.391053',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(448,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:35:45.882134',125,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(449,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:35:45.893198',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(450,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:35:45.886165',277,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(451,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:41:28.039399',91,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(452,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:41:28.041774',125,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(453,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:41:28.039260',351,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(454,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:51:39.467044',86,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:51:39.468736',139,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(456,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:51:39.462726',284,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(457,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 06:52:40.917436',113,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(458,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 06:52:40.918995',119,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(459,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 06:52:40.921225',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(460,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:20:04.592114',194,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(461,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:20:04.636355',180,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(462,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:20:04.590350',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(463,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:26:44.960149',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(464,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:26:44.965012',125,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(465,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:26:44.978915',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(466,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:27:28.478142',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(467,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:27:28.482633',157,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(468,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:27:28.496841',304,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(469,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:38:49.358126',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(470,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:38:49.355239',123,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(471,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:38:49.366064',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(472,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:39:21.406853',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(473,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:39:21.407551',125,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(474,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:39:21.406495',269,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(475,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:40:45.785430',79,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(476,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:40:45.846875',114,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(477,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:40:45.795539',315,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(478,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:43:07.498738',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(479,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:43:07.487230',186,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(480,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:43:07.489420',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(481,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:46:04.630443',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(482,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:46:04.621661',133,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(483,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:46:04.634107',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(484,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:46:08.239683',129,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(485,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:46:08.244241',110,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(486,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:46:08.260200',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(487,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:46:26.372014',70,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(488,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:46:26.384682',145,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(489,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:46:26.382519',332,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(490,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:49:06.793712',122,114,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(491,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:49:06.798725',161,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(492,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:49:06.788554',258,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(493,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:50:05.676707',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(494,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:50:05.681777',133,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(495,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:50:05.680949',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(496,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:50:18.301858',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(497,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:50:18.287515',141,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(498,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:50:18.284128',319,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(499,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 07:59:04.833513',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(500,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 07:59:04.836251',129,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(501,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 07:59:04.830607',267,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(502,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:06:50.911024',124,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(503,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:06:50.905906',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(504,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:06:50.912658',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(505,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:07:20.806430',65,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(506,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:07:20.824932',207,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(507,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:07:20.818094',361,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(508,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:07:21.761093',110,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(509,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:07:21.764031',107,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(510,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:07:21.758842',283,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(511,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:07:32.797103',139,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(512,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:07:32.807119',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(513,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:07:32.794169',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(514,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:08:06.677919',137,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(515,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:08:06.676475',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(516,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:08:06.675868',278,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(517,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:08:38.472363',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(518,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:08:38.469298',180,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(519,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:08:38.479536',294,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(520,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:09:08.862874',56,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(521,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:09:08.863721',115,1,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(522,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:09:08.859490',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(523,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:09:23.930727',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(524,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:09:23.944572',150,1,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(525,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:09:23.925597',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(526,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:09:41.100875',118,1,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(527,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:09:41.113878',129,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(528,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:09:41.112377',261,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(529,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:09:44.332771',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(530,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:09:44.343954',138,1,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(531,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:09:44.345213',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(532,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:13:51.450341',118,8,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(533,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:13:51.450647',147,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(534,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:13:51.453430',270,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(535,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:24:13.538128',109,16,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(536,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:24:13.531127',160,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(537,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:24:13.533155',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(538,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:33:07.481254',81,22,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(539,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:33:07.483571',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(540,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:33:07.494723',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(541,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:35:54.320916',170,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(542,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:35:54.315360',203,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(543,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:35:54.323574',671,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(544,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:36:55.702335',181,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(545,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:36:55.703419',202,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(546,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:36:55.699473',335,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(547,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:45:55.736964',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(548,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:45:55.755727',120,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(549,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:45:55.744846',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(550,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:50:35.663134',112,25,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(551,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:50:35.662426',110,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(552,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:50:35.664946',335,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(553,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:51:07.217951',99,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(554,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:51:07.220423',122,25,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(555,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:51:07.212373',266,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(556,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:51:18.563227',184,25,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(557,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:51:18.576860',184,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(558,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:51:18.565530',317,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(559,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:51:22.055514',76,25,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(560,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:51:22.053632',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(561,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:51:29.866027',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(562,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:51:29.887424',124,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(563,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:51:29.894708',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(564,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 08:59:56.915043',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(565,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 08:59:56.922198',119,26,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(566,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 08:59:56.925815',293,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(567,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 09:16:00.420034',85,34,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(568,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 09:16:00.429443',118,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(569,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 09:16:00.423416',261,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(570,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 09:35:45.556521',96,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(571,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 09:35:45.568385',169,37,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(572,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 09:35:45.558623',350,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(573,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 10:17:39.180520',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(574,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 10:17:39.171008',161,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(575,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 10:17:39.173395',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(576,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 10:17:58.632598',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(577,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 10:17:58.713638',100,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(578,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 10:17:58.670990',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(579,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 10:18:01.354136',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(580,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 10:18:01.362927',111,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(581,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 10:18:01.360421',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(582,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 10:22:41.506883',106,44,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(583,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 10:22:41.504364',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(584,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 10:22:41.511238',274,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 10:25:15.301387',125,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(586,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 10:25:15.308295',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(587,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 10:25:15.307259',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(588,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:01:09.012956',111,46,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(589,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:01:09.004659',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(590,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:01:09.011451',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(591,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:06:41.330030',159,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(592,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:06:41.306150',172,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(593,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:06:41.343759',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(594,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:11:12.201153',126,47,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(595,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:11:12.220278',106,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(596,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:11:12.230753',288,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(597,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:14:18.188605',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(598,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:14:18.197110',125,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(599,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:14:18.191326',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(600,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:14:30.090069',71,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(601,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:14:30.089670',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(602,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:14:30.088308',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(603,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:14:32.640374',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(604,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:14:32.641479',156,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(605,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:14:32.649787',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(606,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 11:28:13.993926',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(607,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 11:28:14.008207',112,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(608,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 11:28:14.013752',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(609,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 12:38:51.092522',126,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(610,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 12:38:51.101219',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(611,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 12:38:51.095449',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(612,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 13:08:44.106452',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(613,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 13:08:44.108168',112,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(614,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 13:08:44.105784',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(615,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 16:48:44.824769',81,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(616,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 16:48:44.812369',125,66,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(617,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 16:48:44.816505',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 17:24:12.626497',109,67,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(619,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 17:24:12.631379',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(620,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 17:24:12.626651',253,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(621,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 20:01:04.097730',125,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(622,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 20:01:04.121562',133,76,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(623,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 20:01:04.096367',314,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(624,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 21:49:40.867391',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(625,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 21:49:40.865718',142,88,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(626,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 21:49:40.868211',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(627,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:00:19.072899',115,88,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(628,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:00:19.075885',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(629,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:00:19.084310',309,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(630,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:06:07.519483',77,89,_binary '','question',NULL,13371341,30,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(631,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:06:08.540217',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(632,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:06:08.554950',124,89,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(633,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:06:08.542773',319,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(634,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:06:20.014877',246,288,_binary '','question',NULL,13371341,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(635,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:06:21.387722',133,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(636,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:06:21.377487',151,89,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(637,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:06:21.376510',322,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(638,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:08:23.326979',134,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(639,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:08:23.337654',131,89,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(640,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:08:23.330030',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(641,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:08:38.337874',121,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(642,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:08:38.335577',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(643,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:08:38.347111',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(644,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:10:21.992943',69,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:10:21.992459',129,89,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(646,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:10:22.003765',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(647,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:26:25.300190',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(648,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:26:25.308282',131,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(649,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:26:25.296871',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(650,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:26:36.968670',62,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(651,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:26:36.971310',129,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(652,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:26:36.970635',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(653,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:26:40.655776',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(654,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:26:40.643104',154,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(655,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:26:40.644597',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(656,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:35:11.021397',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(657,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:35:11.024471',141,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(658,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:35:11.047219',315,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(659,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 22:43:49.075127',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(660,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 22:43:49.071384',144,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(661,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 22:43:49.064136',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(662,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 23:21:54.333363',83,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(663,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 23:21:54.335556',147,90,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(664,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 23:21:54.336347',359,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(665,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 23:56:40.353980',144,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(666,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 23:56:40.356063',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(667,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 23:56:40.352931',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(668,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 23:56:52.229239',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(669,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 23:56:52.231211',110,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(670,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 23:56:52.230576',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(671,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-20 23:56:54.138692',129,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(672,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-20 23:56:54.143812',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(673,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-20 23:56:54.148505',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(674,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:04:21.150618',50,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(675,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:04:21.447568',128,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(676,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:04:21.441078',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(677,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:05:12.740696',110,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(678,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:05:12.745578',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:05:12.755397',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(680,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:35:18.321033',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:35:18.321533',112,94,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(682,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:35:18.329850',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(683,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:36:51.065554',67,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(684,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:36:51.072518',117,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(685,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:36:51.068592',269,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(686,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:36:56.537635',149,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(687,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:36:56.628097',95,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(688,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:36:56.537902',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(689,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:37:01.709016',122,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(690,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:37:01.715195',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:37:01.717492',316,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(692,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:37:05.496557',106,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:37:05.515962',84,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(694,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:37:05.493876',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(695,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:44:40.270379',117,94,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(696,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:44:40.276975',123,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(697,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:44:40.293275',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(698,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:48:31.318451',87,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(699,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:48:31.322206',118,94,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(700,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:48:31.320933',285,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(701,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:51:36.841781',148,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(702,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:51:36.847265',150,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:51:36.861314',268,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(704,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 00:57:27.746331',78,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(705,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 00:57:27.745146',123,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(706,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 00:57:27.740907',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(707,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 01:00:35.889376',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(708,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 01:00:35.903376',94,94,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(709,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 01:00:35.894634',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(710,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 01:01:17.634937',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(711,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 01:01:17.669370',138,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(712,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 01:01:17.641007',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(713,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 01:22:17.162550',147,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(714,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 01:22:17.172367',166,95,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 01:22:17.195399',340,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(716,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 01:27:26.100538',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(717,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 01:27:26.110248',102,95,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(718,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 01:27:26.103334',262,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(719,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 01:41:44.149742',73,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(720,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 01:41:44.147348',132,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(721,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 01:41:44.147348',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(722,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 01:52:06.004163',136,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(723,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 01:52:06.009457',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(724,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 01:52:06.012253',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(725,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:03:08.599123',124,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(726,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:03:08.614110',123,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:03:08.595738',261,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(728,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:03:12.685653',114,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(729,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:03:12.680968',130,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(730,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:03:12.680969',265,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(731,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:03:30.350160',98,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(732,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:03:30.343804',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(733,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:03:30.360526',232,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(734,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:07:34.595996',126,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(735,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:07:34.594774',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(736,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:07:34.587821',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(737,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:11:09.506545',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(738,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:11:09.499872',134,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(739,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:11:09.507646',309,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(740,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:21:05.855165',116,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(741,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:21:05.860061',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(742,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:21:05.853222',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(743,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:21:28.239495',74,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(744,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:21:28.226816',110,98,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(745,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:21:28.248744',243,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(746,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:29:10.029810',67,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(747,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:29:10.031054',119,98,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(748,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:29:10.042363',271,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(749,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 02:29:43.330417',124,98,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(750,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 02:29:43.339238',109,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(751,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 02:29:43.343532',270,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(752,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:10:08.161314',111,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(753,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:10:08.155065',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(754,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:10:08.151977',240,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(755,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:16:52.722268',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(756,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:16:52.731249',129,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(757,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:16:52.731741',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(758,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:23:00.072852',136,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(759,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:23:00.073009',147,98,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(760,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:23:00.061567',306,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(761,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:23:36.443460',81,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(762,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:23:36.448796',132,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(763,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:23:36.440133',317,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(764,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:44:28.093398',139,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(765,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:44:28.107652',138,99,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(766,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:44:28.098260',255,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(767,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:49:05.162359',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(768,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:49:05.172521',113,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(769,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:49:05.173459',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(770,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:52:20.454554',102,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(771,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:52:20.458366',112,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(772,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:52:20.453637',275,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(773,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:52:55.408457',121,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(774,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:52:55.403736',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(775,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:52:55.406007',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(776,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:54:30.720309',139,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(777,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:54:30.717361',160,99,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(778,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:54:30.715680',291,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(779,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 03:56:33.844866',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(780,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 03:56:33.848172',81,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(781,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 03:56:33.856393',334,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(782,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 04:05:13.511207',96,99,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(783,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 04:05:13.510982',115,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(784,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 04:05:13.511729',261,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(785,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 04:28:22.308910',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(786,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 04:28:22.303312',128,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(787,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 04:28:22.310050',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(788,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 04:32:21.555875',117,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(789,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 04:32:21.551129',144,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(790,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 04:32:21.568899',285,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(791,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 04:41:11.206103',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(792,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 04:41:11.212405',128,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(793,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 04:41:11.215249',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(794,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 04:41:13.969878',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(795,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 04:41:13.988822',115,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(796,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 04:41:13.981402',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(797,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 05:04:10.781377',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(798,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 05:04:10.784482',142,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(799,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 05:04:10.794263',268,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(800,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 05:25:03.042205',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(801,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 05:25:03.046595',150,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(802,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 05:25:03.049769',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(803,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 05:46:44.818256',147,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(804,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 05:46:44.820307',174,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(805,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 05:46:44.812801',333,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(806,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 05:52:14.027756',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 05:52:14.026535',112,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(808,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 05:52:14.020540',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(809,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 06:37:01.268446',97,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(810,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 06:37:01.257612',104,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(811,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 06:37:01.271248',242,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(812,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 06:45:28.577315',113,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(813,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 06:45:28.592624',107,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(814,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 06:45:28.580693',259,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(815,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 06:59:09.924663',106,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(816,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 06:59:09.944125',147,108,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(817,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 06:59:09.921007',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 07:07:31.844655',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(819,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 07:07:31.850513',130,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(820,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 07:07:31.841943',270,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(821,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 07:12:47.361280',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(822,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 07:12:47.357295',127,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(823,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 07:12:47.365556',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(824,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 07:54:25.001642',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(825,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 07:54:25.005402',120,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(826,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 07:54:25.011116',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(827,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 07:54:40.795510',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(828,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 07:54:40.836841',81,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(829,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 07:54:40.817600',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(830,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 07:56:48.039219',62,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(831,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 07:56:48.048476',154,112,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(832,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 07:56:48.034307',323,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 07:57:00.254616',85,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 07:57:00.242315',131,112,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(835,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 07:57:00.236292',234,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(836,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 08:16:10.089099',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(837,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 08:16:10.090298',145,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(838,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 08:16:10.087064',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(839,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 08:17:56.137867',85,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(840,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 08:17:56.136399',106,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(841,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 08:17:56.139504',246,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(842,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 08:29:07.578559',127,17,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(843,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 08:29:07.591490',125,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(844,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 08:29:07.587381',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(845,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 08:29:51.686918',60,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(846,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 08:29:51.684199',106,17,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(847,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 08:29:51.685665',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(848,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 08:49:43.835358',116,21,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(849,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 08:49:43.833922',114,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(850,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 08:49:43.832945',249,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(851,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:08:54.876969',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(852,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:08:54.893428',109,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(853,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:08:54.880018',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(854,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:09:00.063899',118,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(855,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:09:00.049474',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(856,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:09:00.051521',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(857,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:09:07.099971',68,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(858,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:09:07.101830',99,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(859,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:09:07.100341',238,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(860,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:09:09.722548',81,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(861,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:09:09.732490',97,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(862,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:09:09.724083',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(863,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:23:32.625695',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(864,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:23:32.620048',107,32,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(865,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:23:32.626734',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:46:04.208323',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(867,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:46:04.209217',123,34,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:46:04.201716',287,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(869,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:46:09.052169',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(870,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:46:09.059618',144,34,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(871,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:46:09.046421',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(872,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:46:20.583553',85,34,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:46:20.557775',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(874,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:46:20.560761',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(875,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 09:46:23.142222',105,34,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(876,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 09:46:23.140342',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(877,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 09:46:23.138080',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(878,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 10:11:53.818173',121,38,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(879,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 10:11:53.826431',112,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 10:11:53.820957',283,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(881,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 10:26:38.951905',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(882,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 10:26:38.971171',121,40,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(883,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 10:26:38.978831',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(884,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 10:30:37.118839',72,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(885,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 10:30:37.116945',106,40,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(886,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 10:30:37.117328',233,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(887,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 10:31:01.378003',92,40,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(888,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 10:31:01.373193',143,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(889,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 10:31:01.377019',269,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(890,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 11:00:34.869389',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(891,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 11:00:34.872482',116,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 11:00:34.871483',264,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(893,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 11:08:33.015721',122,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(894,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 11:08:33.029891',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(895,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 11:08:33.025952',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(896,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 12:20:24.894280',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(897,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 12:20:24.893392',130,45,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(898,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 12:20:24.901248',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(899,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 12:41:32.159142',120,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(900,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 12:41:32.162346',127,45,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(901,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 12:41:32.152511',240,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(902,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 13:30:02.519373',97,48,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(903,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 13:30:02.543190',99,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 13:30:02.525572',267,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 15:00:54.583602',48,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(906,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 15:00:54.595036',122,48,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(907,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 15:00:54.612902',244,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(908,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 15:18:43.983917',112,49,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(909,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 15:18:43.983917',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(910,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 15:18:43.985494',240,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(911,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 15:24:11.736883',98,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(912,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 15:24:11.742480',78,49,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(913,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 15:24:11.744254',261,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(914,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 15:35:36.750546',111,49,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(915,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 15:35:36.767654',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 15:35:36.755035',247,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 15:57:32.752814',80,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(918,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 15:57:32.750061',164,51,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(919,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 15:57:32.756928',281,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(920,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 16:26:44.143223',140,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(921,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 16:26:44.144115',170,52,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(922,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 16:26:44.140901',336,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(923,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 17:12:44.899077',122,58,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(924,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 17:12:44.901954',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(925,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 17:12:44.903948',236,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(926,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 17:33:16.175843',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(927,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 17:33:16.178635',113,60,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(928,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 17:33:16.177166',253,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(929,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 17:39:47.526759',123,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(930,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 17:39:47.521272',135,60,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(931,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 17:39:47.523645',259,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(932,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 18:42:57.538202',113,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(933,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 18:42:57.517845',129,67,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(934,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 18:42:57.514109',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(935,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 18:47:15.012299',128,67,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(936,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 18:47:15.024613',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(937,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 18:47:15.011575',241,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(938,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 18:47:23.300353',84,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(939,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 18:47:23.312260',106,67,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(940,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 18:47:23.307763',259,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 19:11:15.996096',59,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(942,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 19:11:15.999438',121,67,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(943,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 19:11:15.994704',297,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(944,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 19:38:07.961551',77,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(945,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 19:38:07.952268',105,71,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(946,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 19:38:07.950700',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(947,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 20:00:48.690334',109,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(948,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 20:00:48.672568',127,72,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(949,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 20:00:48.679816',260,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(950,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 20:03:50.541333',85,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(951,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 20:03:50.615952',234,72,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(952,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 20:03:50.531139',315,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(953,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 20:06:41.743805',86,72,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(954,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 20:06:41.746032',115,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(955,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 20:06:41.736308',239,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(956,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 20:06:52.537783',136,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(957,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 20:06:52.539504',132,72,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(958,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 20:06:52.533552',311,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(959,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 21:01:52.281370',73,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(960,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 21:01:52.280672',124,73,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(961,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 21:01:52.275309',281,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(962,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 21:32:22.454597',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(963,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 21:32:22.457867',116,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(964,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 21:32:22.456828',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(965,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 21:32:34.002380',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(966,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 21:32:34.007454',86,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(967,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 21:32:34.005392',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(968,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 21:32:36.026112',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(969,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 21:32:36.027704',132,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(970,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 21:32:36.022071',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(971,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 21:42:03.981005',96,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(972,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 21:42:03.986090',112,74,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(973,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 21:42:03.984158',301,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(974,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:06:41.137177',104,78,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(975,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:06:41.129439',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(976,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:06:41.118431',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(977,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:06:43.737305',79,78,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(978,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:06:43.730449',242,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(979,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:10:24.094507',112,78,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(980,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:10:24.086988',112,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(981,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:10:24.093447',237,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(982,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:21:04.779988',123,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(983,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:21:04.799455',130,79,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:21:04.783490',283,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(985,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:21:58.951411',81,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(986,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:21:58.942957',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(987,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:21:58.945156',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(988,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:23:56.323346',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(989,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:23:56.341318',156,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(990,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:23:56.338206',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(991,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:23:59.055679',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(992,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:23:59.039380',235,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(993,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:23:59.035701',363,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:38:09.150110',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(995,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:38:09.177361',77,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:38:09.155307',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 22:38:38.671232',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 22:38:38.682167',108,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(999,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 22:38:38.674105',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1000,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 23:30:19.985202',111,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1001,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 23:30:19.979400',124,86,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1002,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 23:30:19.986811',278,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1003,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-21 23:54:24.962522',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1004,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-21 23:54:24.988475',133,86,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1005,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-21 23:54:24.959461',285,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1006,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:03:04.967545',123,86,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1007,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:03:04.956890',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1008,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:03:04.972332',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1009,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:04:28.955561',83,86,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1010,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:04:28.953169',90,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1011,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:04:28.964859',229,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1012,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:05:29.328264',77,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1013,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:05:29.325667',97,86,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1014,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:05:29.346078',232,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1015,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:13:12.950552',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1016,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:13:12.948297',132,87,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1017,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:13:12.941214',254,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:13:51.060252',136,87,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1019,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:13:51.072798',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:13:51.057460',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:13:53.675293',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1022,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:13:53.676680',104,87,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1023,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:13:53.671045',254,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1024,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:24:06.377371',98,0,_binary '','dashboard','减少结果行数的错误。null',13371339,30,2,NULL,2,NULL,NULL,NULL,NULL),(1025,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:24:06.389983',88,0,_binary '','dashboard','减少结果行数的错误。null',13371339,29,2,NULL,2,NULL,NULL,NULL,NULL),(1026,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:24:06.345199',192,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1027,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:24:07.535646',88,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1028,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:24:07.558918',141,88,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1029,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:24:07.566324',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1030,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 00:47:59.494984',72,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1031,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 00:47:59.489877',146,88,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 00:47:59.498397',248,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1033,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 01:22:41.762358',88,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1034,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 01:22:41.785769',104,90,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1035,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 01:22:41.767675',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1036,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 01:23:23.477604',81,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1037,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 01:23:23.475576',124,90,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1038,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 01:23:23.467729',281,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1039,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 01:37:44.692553',130,91,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1040,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 01:37:44.694080',126,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1041,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 01:37:44.686244',258,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1042,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:07:36.955360',89,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1043,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:07:36.946775',106,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1044,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:07:36.957023',253,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1045,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:07:51.242285',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:07:51.247611',107,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1047,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:07:51.249235',276,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1048,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:11:25.246873',101,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1049,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:11:25.252755',134,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1050,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:11:25.247174',257,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1051,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:11:30.209231',148,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1052,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:11:30.214362',176,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1053,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:11:30.222566',269,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1054,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:31:43.840893',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1055,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:31:43.872179',102,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1056,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:31:43.862752',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1057,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:33:36.222043',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1058,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:33:36.228930',200,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1059,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:33:36.232413',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1060,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 02:50:48.806431',108,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1061,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 02:50:48.800150',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1062,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 02:50:48.813154',245,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 03:28:35.384393',155,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1064,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 03:28:35.400750',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1065,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 03:28:35.402735',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1066,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 03:28:46.962303',62,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1067,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 03:28:46.953766',120,95,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1068,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 03:28:46.952259',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1069,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 03:34:01.452673',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1070,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 03:34:01.453119',119,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1071,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 03:34:01.483310',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1072,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 03:34:13.094552',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1073,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 03:34:13.096363',129,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1074,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 03:34:13.090651',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1075,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 03:34:15.117916',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1076,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 03:34:15.135011',108,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1077,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 03:34:15.123443',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1078,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 03:40:55.168119',56,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1079,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 03:40:55.180361',118,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1080,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 03:40:55.176656',263,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1081,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 04:11:49.893348',124,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1082,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 04:11:49.895562',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1083,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 04:11:49.889686',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1084,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 04:26:44.735171',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1085,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 04:26:44.723404',171,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1086,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 04:26:44.721174',331,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1087,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 05:30:01.526847',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1088,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 05:30:01.531057',139,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1089,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 05:30:01.539694',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1090,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 05:30:13.673734',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1091,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 05:30:13.668772',151,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1092,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 05:30:13.674753',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1093,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 05:30:15.802730',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1094,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 05:30:15.816230',98,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1095,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 05:30:15.806280',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1096,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 05:49:03.859982',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1097,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 05:49:03.865724',107,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1098,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 05:49:03.854002',248,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1099,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 05:50:08.181283',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1100,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 05:50:08.184519',109,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1101,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 05:50:08.175005',245,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1102,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:15:17.701964',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1103,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:15:17.708509',112,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:15:17.710848',241,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:23:33.454954',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1106,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:23:33.453093',138,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1107,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:23:33.460230',264,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1108,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:33:16.122632',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1109,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:33:16.120678',111,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1110,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:33:16.130426',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1111,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:36:24.804796',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1112,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:36:24.815867',105,106,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1113,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:36:24.813858',242,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1114,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:39:02.473612',91,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1115,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:39:02.464993',102,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1116,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:39:02.471335',241,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:46:51.911106',78,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:46:51.910458',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1119,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:46:51.917453',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1120,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:50:09.792343',147,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1121,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:50:09.792391',122,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1122,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:50:09.804439',244,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1123,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 06:58:11.070972',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1124,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 06:58:11.074148',133,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1125,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 06:58:11.080165',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1126,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:00:07.488380',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1127,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:00:07.483832',101,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1128,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:00:07.490328',239,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1129,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:05:04.833226',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1130,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:05:04.833370',96,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1131,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:05:04.831833',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1132,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:05:09.370403',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1133,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:05:09.375362',107,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1134,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:05:09.369863',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1135,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:05:16.344771',129,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1136,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:05:16.355441',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1137,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:05:16.337593',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1138,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:05:18.943737',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1139,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:05:18.938992',207,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1140,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:05:18.942756',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1141,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:33:43.649869',68,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1142,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:33:43.678529',181,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1143,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:33:43.657380',304,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1144,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:57:29.382844',81,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1145,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:57:29.386260',101,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1146,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:57:29.380231',249,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1147,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 07:58:09.659793',84,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1148,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 07:58:09.669323',83,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1149,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 07:58:09.681812',211,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1150,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:02:03.832221',123,0,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1151,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:02:03.821514',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1152,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:02:03.837174',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1153,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:02:16.074990',110,1,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1154,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:02:16.076163',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1155,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:02:16.075015',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1156,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:02:20.795062',119,1,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1157,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:02:20.795297',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1158,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:02:20.796972',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1159,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:17:35.331624',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1160,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:17:35.342074',111,3,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1161,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:17:35.331849',249,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1162,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:17:43.432168',93,3,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1163,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:17:43.415266',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:17:43.420020',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1165,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:21:12.326531',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1166,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:21:12.323942',97,3,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1167,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:21:12.318067',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1168,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:27:03.659103',112,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1169,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:27:03.665268',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1170,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:27:03.664481',247,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1171,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 08:38:25.831756',87,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1172,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 08:38:25.845824',96,14,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1173,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 08:38:25.836565',230,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1174,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:09:28.527535',103,27,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1175,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:09:28.523736',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:09:28.536363',221,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1177,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:21:45.792306',107,32,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1178,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:21:45.785147',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1179,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:21:45.789970',306,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1180,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:21:52.398790',114,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1181,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:21:52.400789',121,32,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1182,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:21:52.399701',293,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1183,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:26:53.742632',129,33,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1184,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:26:53.738264',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1185,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:26:53.748120',244,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1186,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:37:37.096329',97,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1187,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:37:37.094388',101,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1188,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:37:37.094403',240,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1189,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:37:43.032003',44,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1190,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:37:43.090852',90,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1191,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:37:43.089666',260,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1192,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:37:50.291628',59,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1193,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:37:50.369047',135,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1194,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:37:50.413387',276,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1195,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:37:53.345094',55,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1196,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:37:53.341849',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1197,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:37:53.358647',238,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1198,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 09:52:28.069029',74,36,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1199,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 09:52:28.063418',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1200,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 09:52:28.067848',250,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1201,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 10:01:27.346312',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1202,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 10:01:27.409376',83,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1203,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 10:01:27.413107',219,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1204,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 10:01:31.279290',85,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1205,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 10:01:31.293323',80,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1206,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 10:01:31.275311',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1207,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 10:01:39.995372',116,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1208,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 10:01:40.004442',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1209,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 10:01:39.999380',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1210,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 10:01:42.635476',112,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1211,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 10:01:42.641143',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1212,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 10:01:42.643177',228,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1213,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 11:13:45.126175',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1214,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 11:13:45.113414',137,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1215,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 11:13:45.108839',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1216,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 12:51:32.818363',108,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1217,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 12:51:32.824901',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1218,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 12:51:32.817202',233,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1219,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 16:28:10.306019',91,60,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1220,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 16:28:10.304510',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1221,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 16:28:10.316153',252,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1222,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 17:52:01.534206',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1223,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 17:52:01.536032',125,67,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1224,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 17:52:01.533433',258,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1225,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 17:56:40.610927',46,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1226,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 17:56:40.630828',114,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1227,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 17:56:40.638235',228,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1228,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 17:56:51.921769',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1229,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 17:56:51.913710',116,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1230,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 17:56:51.918189',240,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1231,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 17:56:54.456412',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1232,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 17:56:54.464617',99,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1233,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 17:56:54.453265',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1234,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 19:04:01.892024',88,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1235,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 19:04:01.882158',113,75,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1236,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 19:04:01.889790',300,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1237,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 19:56:00.520560',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1238,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 19:56:00.529760',135,81,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1239,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 19:56:00.518210',267,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1240,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 20:17:23.793475',76,0,_binary '','dashboard','减少结果行数的错误。null',13371340,29,2,NULL,2,NULL,NULL,NULL,NULL),(1241,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 20:17:23.795954',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1242,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 20:17:23.794715',151,82,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1243,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 20:17:24.832357',85,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1244,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 20:17:24.827728',106,82,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1245,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 20:17:24.834006',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1246,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 20:23:57.834950',135,83,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1247,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 20:23:57.834913',141,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1248,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 20:23:57.836336',258,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1249,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 20:43:18.768228',114,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1250,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 20:43:18.764534',160,84,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1251,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 20:43:18.750888',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1252,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 20:47:55.862832',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1253,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 20:47:55.869904',102,84,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1254,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 20:47:55.858516',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1255,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 20:48:23.833921',119,84,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1256,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 20:48:23.836227',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1257,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 20:48:23.833939',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1258,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 22:11:25.415555',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1259,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 22:11:25.432779',119,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1260,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 22:11:25.415750',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1261,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 22:12:54.599960',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 22:12:54.613958',115,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1263,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 22:12:54.602274',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1264,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 22:12:57.259308',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1265,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 22:12:57.262108',119,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1266,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 22:12:57.257849',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1267,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 22:50:26.689757',118,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1268,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 22:50:26.690123',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1269,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 22:50:26.691928',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1270,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 22:54:28.063317',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1271,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 22:54:28.067474',121,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1272,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 22:54:28.081280',220,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1273,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 23:15:25.545971',98,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1274,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 23:15:25.554326',122,88,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1275,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 23:15:25.544122',247,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1276,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 23:15:28.837902',117,88,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1277,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 23:15:28.855070',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1278,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 23:15:28.844005',250,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1279,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 23:49:21.589668',108,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1280,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 23:49:21.591381',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1281,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 23:49:21.591389',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1282,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-22 23:59:31.737459',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1283,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-22 23:59:31.739177',121,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1284,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-22 23:59:31.742137',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1285,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 00:28:17.882089',137,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1286,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 00:28:17.877124',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1287,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 00:28:17.874251',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1288,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 00:28:30.058790',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 00:28:30.047162',119,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1290,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 00:28:30.046818',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1291,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 00:28:31.835535',72,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1292,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 00:28:31.845614',122,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1293,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 00:28:31.840461',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1294,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 01:09:09.577522',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 01:09:09.598188',107,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1296,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 01:09:09.582391',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1297,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 01:19:26.170308',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1298,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 01:19:26.166309',143,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1299,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 01:19:26.175700',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1300,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 01:36:01.264072',124,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1301,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 01:36:01.269881',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1302,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 01:36:01.267881',264,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1303,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 01:50:56.817381',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1304,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 01:50:56.822512',137,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1305,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 01:50:56.829012',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1306,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 01:52:29.983681',118,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1307,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 01:52:29.977079',134,94,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1308,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 01:52:30.010108',265,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1309,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:02:27.475544',122,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:02:27.472435',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1311,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:02:27.483324',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1312,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:22:04.608995',138,95,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1313,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:22:04.626510',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1314,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:22:04.606077',317,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1315,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:25:21.346043',94,95,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1316,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:25:21.339559',107,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1317,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:25:21.336569',246,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1318,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:25:24.779478',121,95,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1319,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:25:24.729805',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1320,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:25:24.740468',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1321,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:36:47.554623',117,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1322,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:36:47.548046',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1323,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:36:47.548054',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1324,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:39:12.108327',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1325,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:39:12.143376',107,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1326,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:39:12.118490',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1327,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:42:54.688211',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1328,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:42:54.701803',111,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1329,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:42:54.686994',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1330,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:50:21.494062',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1331,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:50:21.501903',167,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1332,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:50:21.493899',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1333,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:50:28.531792',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1334,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:50:28.529070',152,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1335,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:50:28.524373',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1336,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 02:58:49.302289',113,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1337,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 02:58:49.314042',130,97,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1338,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 02:58:49.316888',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1339,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 03:11:53.785536',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1340,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 03:11:53.797436',162,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1341,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 03:11:53.795244',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1342,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 03:12:01.492799',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1343,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 03:12:01.495770',113,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1344,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 03:12:01.488091',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1345,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 03:22:43.346885',112,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 03:22:43.350128',126,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1347,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 03:22:43.359848',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1348,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 03:22:47.089952',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1349,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 03:22:47.087625',190,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1350,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 03:22:47.096465',327,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1351,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 03:38:19.845371',92,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1352,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 03:38:19.841000',110,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1353,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 03:38:19.837934',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1354,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 03:51:11.813836',157,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1355,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 03:51:11.814602',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1356,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 03:51:11.807159',276,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1357,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 04:13:38.150240',114,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1358,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 04:13:38.144769',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1359,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 04:13:38.172606',239,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1360,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 04:23:14.413629',120,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1361,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 04:23:14.407273',140,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1362,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 04:23:14.410620',282,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1363,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 04:39:10.875761',121,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1364,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 04:39:10.881801',147,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1365,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 04:39:10.869992',304,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 04:40:41.595095',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1367,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 04:40:41.596088',131,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1368,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 04:40:41.604070',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1369,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 05:07:31.908305',131,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1370,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 05:07:31.907537',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1371,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 05:07:31.907674',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1372,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 05:39:21.324869',133,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1373,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 05:39:21.330344',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1374,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 05:39:21.319252',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1375,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 05:42:44.805621',77,103,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1376,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 05:42:44.807273',107,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1377,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 05:42:44.808813',318,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1378,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 05:53:40.209718',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 05:53:40.218907',140,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1380,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 05:53:40.216922',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1381,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 05:58:40.087403',126,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1382,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 05:58:40.088324',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1383,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 05:58:40.077420',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1384,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 05:59:43.946458',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1385,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 05:59:43.961826',105,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1386,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 05:59:43.942798',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1387,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 06:22:43.905688',46,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1388,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 06:22:43.927777',116,104,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1389,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 06:22:43.916842',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1390,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 06:37:34.448245',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1391,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 06:37:34.452990',134,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1392,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 06:37:34.444433',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1393,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 06:47:45.125864',123,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1394,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 06:47:45.127950',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1395,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 06:47:45.125864',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1396,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 06:50:03.910518',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1397,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 06:50:03.914309',140,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1398,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 06:50:03.906183',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1399,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 06:50:05.725817',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1400,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 06:50:05.730885',121,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1401,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 06:50:05.739524',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1402,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:09:01.149425',125,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1403,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:09:01.140032',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1404,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:09:01.138036',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1405,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:09:12.514896',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1406,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:09:12.517935',106,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1407,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:09:12.534493',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1408,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:09:15.326153',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1409,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:09:15.319360',132,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1410,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:09:15.335967',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1411,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:14:41.383732',107,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1412,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:14:41.408199',112,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1413,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:14:41.386511',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1414,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:14:58.246510',105,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1415,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:14:58.263534',115,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1416,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:14:58.258303',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1417,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:15:05.711411',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1418,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:15:05.740097',148,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1419,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:15:05.727980',283,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1420,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:15:32.209821',80,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:15:32.209904',197,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1422,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:15:32.214714',352,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1423,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:16:32.534466',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1424,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:16:32.544804',162,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1425,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:16:32.538676',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1426,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:18:06.758396',124,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1427,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:18:06.767397',123,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1428,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:18:06.758017',249,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:18:15.078519',44,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:18:15.108897',91,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1431,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:18:15.117978',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1432,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:18:48.862442',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1433,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:18:48.860267',110,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1434,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:18:48.859714',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1435,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:25:10.126903',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1436,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:25:10.106102',122,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1437,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:25:10.115423',240,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1438,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:40:04.298106',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1439,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:40:04.298116',135,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1440,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:40:04.303766',332,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1441,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:40:07.845528',126,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1442,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:40:07.841223',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1443,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:40:07.857445',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1444,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:42:07.445773',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1445,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:42:07.450152',130,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1446,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:42:07.451503',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1447,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:44:10.928561',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1448,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:44:10.930322',116,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1449,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:44:10.939883',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1450,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:44:49.031624',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1451,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:44:49.043618',113,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1452,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:44:49.041970',251,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1453,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:48:47.076311',95,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1454,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:48:47.082310',97,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1455,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:48:47.071376',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1456,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 07:55:45.659211',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1457,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 07:55:45.689290',165,110,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1458,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 07:55:45.670033',279,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1459,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:27:58.339063',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1460,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:27:58.358249',107,17,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1461,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:27:58.341286',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1462,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:28:33.877610',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1463,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:28:33.867911',122,17,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1464,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:28:33.876347',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1465,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:29:18.903915',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1466,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:29:18.911047',119,17,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1467,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:29:18.920822',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1468,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:29:21.452065',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1469,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:29:21.453733',139,17,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1470,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:29:21.455680',251,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1471,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:32:32.751399',91,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1472,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:32:32.744231',104,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1473,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:32:32.754826',236,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1474,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:32:44.026326',110,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1475,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:32:44.027356',121,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1476,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:32:44.026982',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1477,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:32:47.433893',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1478,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:32:47.483635',93,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1479,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:32:47.443166',251,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1480,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:33:23.205205',105,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1481,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:33:23.207157',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1482,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:33:23.208143',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1483,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:33:34.675809',85,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1484,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:33:34.680133',94,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1485,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:33:34.689708',234,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1486,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:33:37.969160',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1487,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:33:37.958385',142,22,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1488,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:33:37.960361',246,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1489,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:42:14.629557',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1490,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:42:14.626864',143,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1491,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:42:14.624088',248,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1492,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:42:26.706888',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1493,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:42:26.708959',115,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1494,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:42:26.714029',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1495,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:42:29.370724',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1496,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:42:29.388296',77,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1497,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:42:29.375036',239,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1498,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 08:46:34.023700',55,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1499,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 08:46:34.056538',92,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1500,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 08:46:34.048728',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1501,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 09:33:40.071143',97,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1502,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 09:33:40.071962',129,31,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1503,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 09:33:40.077199',265,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1504,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 09:49:46.311836',90,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1505,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 09:49:46.306244',108,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1506,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 09:49:46.311851',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1507,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 09:49:50.635608',255,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1508,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 09:49:50.622456',282,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1509,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 09:49:50.634329',434,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1510,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:04:14.216169',112,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1511,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:04:14.221306',121,38,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1512,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:04:14.216874',269,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1513,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:04:50.664404',170,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1514,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:04:50.654226',211,38,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1515,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:04:50.630262',355,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1516,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:04:54.378206',101,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1517,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:04:54.385300',102,38,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1518,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:04:54.395006',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1519,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:19:04.603960',106,41,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1520,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:19:04.608992',99,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1521,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:19:04.606555',244,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1522,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:46:14.849449',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1523,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:46:14.860315',114,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1524,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:46:14.858853',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1525,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:46:17.492406',59,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1526,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:46:17.500004',148,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1527,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:46:17.489796',264,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1528,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:48:04.709206',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1529,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:48:04.719336',102,50,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1530,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:48:04.709794',248,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1531,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 10:48:43.605721',81,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1532,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 10:48:43.600372',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1533,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 10:48:43.608295',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1534,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 12:53:14.261707',109,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1535,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 12:53:14.248293',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1536,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 12:53:14.241389',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1537,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 13:14:22.085251',72,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1538,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 13:14:22.089219',123,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1539,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 13:14:22.101205',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1540,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 16:46:02.134854',81,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1541,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 16:46:02.115756',126,72,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1542,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 16:46:02.120256',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1543,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 16:46:13.666576',91,72,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1544,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 16:46:13.673849',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1545,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 16:46:13.665062',250,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1546,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 16:46:16.817288',112,72,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1547,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 16:46:16.815824',112,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1548,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 16:46:16.808338',298,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1549,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 16:56:51.788131',105,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1550,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 16:56:51.794429',107,74,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1551,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 16:56:51.791510',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1552,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 17:38:04.342866',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1553,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 17:38:04.358836',99,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1554,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 17:38:04.359424',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1555,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 17:38:15.578643',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1556,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 17:38:15.576619',104,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1557,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 17:38:15.576421',243,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1558,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 17:38:18.174029',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1559,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 17:38:18.171598',115,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1560,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 17:38:18.162799',231,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1561,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 17:55:58.251633',94,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1562,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 17:55:58.266336',125,81,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1563,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 17:55:58.253335',293,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1564,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 18:53:30.009429',66,0,_binary '','dashboard','减少结果行数的错误。null',13371339,29,2,NULL,2,NULL,NULL,NULL,NULL),(1565,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 18:53:30.009901',122,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1566,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 18:53:30.004816',153,0,_binary '','dashboard','减少结果行数的错误。null',13371339,30,2,NULL,2,NULL,NULL,NULL,NULL),(1567,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 18:53:30.921739',69,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1568,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 18:53:30.929197',89,83,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1569,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 18:53:30.930322',255,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1570,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 18:56:19.545855',88,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1571,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 18:56:19.548370',101,83,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1572,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 18:56:19.557371',258,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1573,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 19:09:31.045545',63,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1574,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 19:09:31.032556',118,83,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1575,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 19:09:31.031163',261,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1576,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 19:44:16.466864',117,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1577,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 19:44:16.468785',109,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1578,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 19:44:16.473557',296,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1579,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 20:46:22.534228',88,86,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1580,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 20:46:22.523802',114,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1581,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 20:46:22.529226',316,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1582,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 21:04:30.074332',121,86,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1583,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 21:04:30.075467',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1584,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 21:04:30.072154',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 21:34:53.894119',132,88,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1586,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 21:34:53.879387',150,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1587,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 21:34:53.879846',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1588,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 21:53:35.233902',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1589,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 21:53:35.243804',162,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1590,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 21:53:35.233899',357,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1591,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 21:59:58.669652',143,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1592,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 21:59:58.688610',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1593,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 21:59:58.682432',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1594,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:00:01.371068',147,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1595,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:00:01.368985',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1596,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:00:01.371049',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1597,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:07:52.145884',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1598,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:07:52.116606',162,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1599,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:07:52.119288',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1600,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:11:58.487228',92,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1601,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:11:58.474262',115,89,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1602,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:11:58.482657',265,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1603,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:16:20.795580',66,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1604,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:16:20.791908',133,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1605,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:16:20.794422',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1606,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:16:31.765000',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1607,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:16:31.771361',116,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1608,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:16:31.766775',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1609,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:16:34.602326',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1610,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:16:34.654210',113,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1611,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:16:34.599816',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1612,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:20:54.548282',108,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1613,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:20:54.552245',125,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1614,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:20:54.551352',250,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1615,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:50:26.732655',114,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1616,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:50:26.732919',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1617,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:50:26.734850',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1618,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 22:57:55.945199',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1619,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 22:57:55.948564',149,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1620,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 22:57:55.947414',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1621,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 23:02:20.939938',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1622,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 23:02:20.945827',119,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1623,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 23:02:20.939938',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1624,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 23:05:21.734917',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1625,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 23:05:21.749461',97,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1626,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 23:05:21.738353',234,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1627,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 23:18:36.380046',122,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1628,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 23:18:36.382284',115,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1629,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 23:18:36.374640',278,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1630,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 23:24:39.645663',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1631,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 23:24:39.641690',132,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1632,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 23:24:39.659094',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1633,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 23:39:54.511299',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1634,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 23:39:54.511305',138,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1635,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 23:39:54.517753',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1636,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-23 23:45:58.492718',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1637,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-23 23:45:58.496294',108,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1638,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-23 23:45:58.506303',260,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1639,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 01:47:55.331730',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1640,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 01:47:55.334968',128,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1641,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 01:47:55.342041',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1642,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 01:58:49.170799',43,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1643,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 01:58:49.191915',102,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1644,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 01:58:49.184265',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 01:58:51.918200',120,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1646,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 01:58:51.930980',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1647,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 01:58:51.930117',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1648,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 02:53:36.033646',129,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1649,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 02:53:36.046274',124,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1650,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 02:53:36.027793',329,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1651,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:05:37.596801',61,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1652,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:05:37.599256',114,102,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1653,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:05:37.597189',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1654,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:12:57.607958',120,102,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1655,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:12:57.605167',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1656,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:12:57.601616',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1657,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:13:08.275799',116,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1658,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:13:08.266721',189,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1659,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:13:08.271914',363,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1660,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:13:08.806166',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1661,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:13:08.812983',113,102,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1662,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:13:08.809832',308,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1663,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:14:26.005106',92,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1664,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:14:26.026378',89,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1665,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:14:26.017406',279,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1666,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:19:46.403423',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1667,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:19:46.420392',115,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1668,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:19:46.412739',248,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1669,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:25:24.770957',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1670,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:25:24.779809',100,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1671,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:25:24.791009',273,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1672,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:44:46.310332',119,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1673,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:44:46.314007',113,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1674,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:44:46.313408',281,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1675,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 03:53:24.224855',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1676,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 03:53:24.214359',132,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1677,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 03:53:24.220666',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1678,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:01:14.558636',129,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1679,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:01:14.577233',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1680,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:01:14.561453',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1681,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:08:49.330966',48,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1682,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:08:49.449763',61,103,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1683,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:08:49.393806',255,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1684,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:11:06.241767',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1685,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:11:06.253445',138,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1686,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:11:06.239289',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1687,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:23:21.183427',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1688,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:23:21.185055',125,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1689,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:23:21.189778',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1690,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:23:57.215522',61,1,_binary '','question',NULL,13371345,27,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1691,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:24:00.615670',104,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1692,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:24:00.630326',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1693,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:24:00.649312',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1694,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:25:59.079381',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1695,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:25:59.076489',133,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1696,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:25:59.086059',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1697,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:28:18.515244',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1698,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:28:18.499112',136,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1699,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:28:18.519306',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1700,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:38:06.727840',77,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1701,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:38:06.750455',137,105,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1702,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:38:06.722121',311,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1703,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:47:04.672841',93,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1704,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:47:04.665147',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1705,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:47:04.671692',247,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1706,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 04:51:53.337198',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1707,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 04:51:53.334879',130,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1708,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 04:51:53.334463',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1709,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:03:52.899427',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1710,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:03:52.896769',143,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1711,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:03:52.891271',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1712,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:11:45.338688',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:11:45.355326',109,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1714,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:11:45.345341',248,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1715,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:17:33.300644',131,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1716,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:17:33.302832',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1717,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:17:33.300343',242,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1718,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:17:45.251317',69,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1719,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:17:45.258246',146,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1720,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:17:45.258900',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1721,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:17:47.184238',88,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1722,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:17:47.165093',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1723,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:17:47.167338',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1724,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:22:12.798266',65,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1725,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:22:12.800797',95,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1726,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:22:12.794823',254,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1727,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:26:26.594646',67,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1728,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:26:26.595659',99,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1729,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:26:26.592817',260,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1730,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:26:38.428191',99,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1731,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:26:38.451969',90,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1732,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:26:38.432490',243,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1733,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:26:41.617477',89,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1734,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:26:41.639452',108,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1735,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:26:41.625548',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1736,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:29:07.462259',124,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1737,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:29:07.480257',113,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1738,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:29:07.468760',237,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1739,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:29:32.733803',93,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1740,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:29:32.731709',148,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1741,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:29:32.731669',288,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1742,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 05:57:03.069611',90,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1743,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 05:57:03.095290',91,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1744,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 05:57:03.074088',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1745,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:03:29.568239',114,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1746,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:03:29.573365',120,109,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1747,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:03:29.571596',239,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1748,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:10:39.352805',116,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1749,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:10:39.353554',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1750,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:10:39.349389',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1751,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:14:15.836731',74,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1752,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:14:15.845110',132,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1753,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:14:15.830879',249,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1754,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:14:28.057069',83,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1755,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:14:28.130320',97,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1756,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:14:28.124805',243,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1757,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:14:39.999670',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1758,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:14:40.051115',111,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1759,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:14:40.055021',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1760,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:16:15.558325',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1761,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:16:15.562306',131,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1762,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:16:15.565861',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1763,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:16:27.060117',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1764,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:16:27.051287',159,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1765,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:16:27.050293',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1766,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:16:29.947544',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1767,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:16:29.949884',127,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1768,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:16:29.948530',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1769,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:21:55.589119',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1770,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:21:55.594134',128,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1771,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:21:55.607078',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1772,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:22:07.399700',103,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1773,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:22:07.404490',111,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1774,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:22:07.397434',282,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1775,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:26:13.398743',84,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1776,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:26:13.391612',115,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1777,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:26:13.397263',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1778,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:32:55.548624',103,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1779,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:32:55.533457',129,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1780,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:32:55.539761',266,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:38:06.081094',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1782,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:38:06.087441',117,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1783,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:38:06.086108',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1784,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 06:57:20.010644',121,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1785,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 06:57:20.037515',123,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1786,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 06:57:20.030345',239,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1787,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:10:39.636198',107,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1788,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:10:39.640729',117,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1789,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:10:39.644951',290,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1790,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:10:52.555881',98,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1791,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:10:52.557320',132,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1792,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:10:52.558333',278,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1793,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:10:55.568155',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1794,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:10:55.570637',114,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1795,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:10:55.569103',269,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1796,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:17:48.934466',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1797,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:17:48.937308',127,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1798,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:17:48.930378',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1799,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:21:00.200293',128,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1800,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:21:00.195928',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1801,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:21:00.192965',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1802,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:25:07.019486',79,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1803,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:25:07.015289',103,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1804,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:25:07.052638',239,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1805,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:36:07.518666',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1806,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:36:07.523073',115,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1807,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:36:07.521515',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1808,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:36:20.347754',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1809,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:36:20.349264',144,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1810,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:36:20.348353',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1811,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:45:02.481916',150,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1812,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:45:02.481392',164,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1813,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:45:02.477321',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1814,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:46:03.047340',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1815,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:46:03.075751',114,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1816,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:46:03.074876',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1817,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:46:21.898441',85,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:46:21.894300',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1819,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:46:21.912923',264,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1820,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 07:59:52.354120',93,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1821,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 07:59:52.355611',144,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1822,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 07:59:52.356764',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1823,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:00:00.074800',112,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1824,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:00:00.117929',198,0,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1825,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:00:00.111855',286,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1826,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:00:11.757902',90,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1827,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:00:11.760461',104,0,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1828,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:00:11.768960',249,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1829,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:00:52.752697',114,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1830,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:00:52.766453',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1831,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:00:52.749210',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1832,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:01:06.139955',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1833,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:01:06.148597',140,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1834,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:01:06.145213',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1835,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:02:30.960702',125,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1836,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:02:31.017801',78,5,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1837,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:02:31.008578',258,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1838,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:02:42.642221',119,5,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1839,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:02:42.653010',79,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1840,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:02:42.638093',234,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1841,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:02:45.951195',80,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1842,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:02:45.951830',94,5,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1843,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:02:45.945042',254,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1844,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:11:47.435168',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1845,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:11:47.440836',179,5,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1846,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:11:47.432148',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1847,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:29:10.539434',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1848,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:29:10.580250',120,22,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1849,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:29:10.559907',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1850,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:34:30.897013',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1851,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:34:30.898841',106,26,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1852,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:34:30.896498',282,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1853,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:45:27.909703',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1854,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:45:27.906403',107,29,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1855,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:45:27.905595',264,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1856,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:45:30.589605',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1857,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:45:30.597106',123,29,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1858,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:45:30.609128',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1859,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 08:53:44.742092',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1860,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 08:53:44.746970',169,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1861,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 08:53:44.740986',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1862,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 09:02:07.990482',173,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1863,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 09:02:07.988506',217,33,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1864,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 09:02:08.001205',463,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1865,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 09:02:20.798122',64,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1866,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 09:02:20.800965',99,36,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1867,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 09:02:20.806166',233,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1868,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 09:13:56.558157',114,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1869,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 09:13:56.567662',109,36,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1870,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 09:13:56.553548',295,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1871,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 09:31:44.434805',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1872,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 09:31:44.433744',128,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1873,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 09:31:44.437205',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1874,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 09:41:25.841575',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1875,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 09:41:25.831895',148,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1876,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 09:41:25.839244',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1877,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 09:58:18.023524',87,49,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1878,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 09:58:18.019790',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1879,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 09:58:18.021559',259,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1880,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 10:18:12.920178',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 10:18:12.916765',114,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1882,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 10:18:12.922527',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1883,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 11:03:36.830821',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1884,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 11:03:36.831654',92,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1885,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 11:03:36.844360',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1886,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 11:26:07.958927',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1887,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 11:26:07.960437',101,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1888,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 11:26:07.957590',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1889,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 11:40:12.219856',99,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1890,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 11:40:12.220286',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1891,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 11:40:12.225190',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1892,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 11:51:54.118082',97,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1893,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 11:51:54.136503',136,64,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1894,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 11:51:54.120644',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1895,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 12:51:49.507005',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1896,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 12:51:49.501214',111,65,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1897,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 12:51:49.508770',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1898,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 12:53:02.867354',99,65,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1899,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 12:53:02.878996',93,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1900,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 12:53:02.865449',241,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1901,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 16:44:03.703108',109,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1902,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 16:44:03.710774',117,75,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1903,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 16:44:03.703021',267,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1904,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:03:25.101677',118,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:03:25.109837',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1906,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:03:25.102777',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1907,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:03:38.238138',183,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1908,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:03:38.261632',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1909,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:03:38.280231',366,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1910,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:03:41.044309',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1911,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:03:41.045354',135,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1912,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:03:41.056464',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1913,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:09:30.748084',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1914,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:09:30.738188',136,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1915,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:09:30.740568',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1916,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:09:42.335990',120,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:09:42.340360',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1918,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:09:42.333091',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1919,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:09:45.028825',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1920,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:09:45.029402',116,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1921,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:09:45.030975',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:17:04.633495',124,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1923,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:17:04.625563',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1924,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:17:04.618628',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1925,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:32:31.254106',111,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1926,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:32:31.259178',110,100,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1927,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:32:31.262961',311,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1928,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-24 22:32:35.789828',121,100,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1929,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-24 22:32:35.791196',129,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1930,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-24 22:32:35.799347',267,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1931,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 00:01:31.517104',115,103,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1932,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 00:01:31.518308',122,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1933,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 00:01:31.510593',241,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1934,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 00:37:03.709266',133,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1935,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 00:37:03.715131',134,103,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1936,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 00:37:03.711908',264,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1937,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 00:37:14.854130',107,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1938,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 00:37:14.857505',101,103,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1939,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 00:37:14.866839',248,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1940,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 00:37:18.704635',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1941,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 00:37:18.732493',102,103,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1942,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 00:37:18.725722',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1943,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:19:19.021218',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1944,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:19:19.017261',121,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1945,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:19:19.037997',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1946,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:26:54.063333',68,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1947,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:26:54.049998',147,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1948,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:26:54.058794',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1949,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:36:08.405927',121,104,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1950,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:36:08.404414',125,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1951,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:36:08.395922',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1952,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:42:15.650002',109,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1953,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:42:15.657792',129,105,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1954,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:42:15.650711',263,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1955,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:48:48.424636',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1956,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:48:48.423624',119,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1957,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:48:48.443190',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1958,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:48:51.448376',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1959,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:48:51.445964',120,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1960,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:48:51.447945',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:51:16.774331',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1962,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:51:16.780083',113,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1963,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:51:16.770012',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1964,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:51:19.480866',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1965,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:51:19.514225',104,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1966,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:51:19.501870',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1967,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 01:51:45.093065',101,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1968,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 01:51:45.100793',118,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1969,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 01:51:45.102689',247,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1970,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 02:29:41.570613',127,106,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1971,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 02:29:41.593019',125,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1972,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 02:29:41.573855',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1973,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 02:31:20.585514',110,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1974,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 02:31:20.581911',106,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1975,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 02:31:20.592383',268,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1976,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 02:33:38.109066',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1977,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 02:33:38.097436',145,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1978,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 02:33:38.096938',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1979,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 02:50:51.285596',110,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1980,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 02:50:51.289429',131,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1981,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 02:50:51.295404',251,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1982,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 02:57:18.342813',77,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1983,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 02:57:18.351002',152,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 02:57:18.349318',298,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1985,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 03:04:33.517451',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1986,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 03:04:33.531747',137,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1987,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 03:04:33.514910',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1988,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 03:04:56.682298',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1989,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 03:04:56.674035',140,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1990,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 03:04:56.693351',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1991,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 03:05:01.732973',110,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1992,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 03:05:01.750399',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1993,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 03:05:01.738100',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 03:50:36.050068',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1995,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 03:50:36.068397',130,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 03:50:36.058333',250,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 04:15:00.921768',61,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 04:15:00.966420',102,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(1999,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 04:15:00.968813',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2000,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 04:15:12.831020',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2001,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 04:15:12.831067',137,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2002,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 04:15:12.843466',247,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2003,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 04:15:15.997696',145,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2004,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 04:15:15.995012',142,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2005,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 04:15:15.988331',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2006,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 04:24:23.013718',130,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2007,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 04:24:23.020050',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2008,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 04:24:23.018348',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2009,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:04:49.736406',80,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2010,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:04:49.733431',145,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2011,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:04:49.743526',308,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2012,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:09:48.960896',64,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2013,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:09:48.962767',112,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2014,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:09:48.960719',286,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2015,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:17:48.262202',99,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2016,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:17:48.262202',126,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2017,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:17:48.265569',303,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2018,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:24:34.140122',194,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2019,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:24:34.164105',211,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:24:34.145009',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:24:36.923725',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2022,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:24:36.925070',110,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2023,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:24:36.927299',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2024,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:27:03.279144',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2025,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:27:03.281883',105,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2026,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:27:03.278156',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2027,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:27:14.651189',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2028,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:27:14.654022',113,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2029,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:27:14.641873',243,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2030,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 05:27:16.627759',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2031,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 05:27:16.663664',70,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 05:27:16.641526',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2033,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 06:10:06.464161',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2034,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 06:10:06.471840',149,114,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2035,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 06:10:06.473385',273,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2036,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 06:39:58.961351',119,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2037,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 06:39:58.958536',130,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2038,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 06:39:58.962534',275,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2039,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 06:51:19.882543',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2040,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 06:51:19.891395',135,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2041,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 06:51:19.895462',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2042,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 06:53:56.866997',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2043,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 06:53:56.884406',112,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2044,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 06:53:56.870481',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2045,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:04:57.287026',96,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:04:57.288417',103,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2047,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:04:57.280373',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2048,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:09:02.676727',120,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2049,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:09:02.667552',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2050,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:09:02.678867',242,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2051,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:22:52.185800',101,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2052,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:22:52.195686',120,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2053,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:22:52.193469',257,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2054,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:26:19.382982',93,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2055,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:26:19.374388',109,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2056,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:26:19.380536',256,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2057,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:26:23.744501',108,117,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2058,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:26:23.748421',124,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2059,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:26:23.753660',293,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2060,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:27:26.692229',84,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2061,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:27:26.688806',83,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2062,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:27:26.702127',244,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2063,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:28:38.701180',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2064,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:28:38.699494',123,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2065,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:28:38.699448',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2066,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:43:09.957891',121,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2067,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:43:09.959279',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2068,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:43:09.966396',278,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2069,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:54:40.157801',105,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2070,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:54:40.169482',140,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2071,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:54:40.166511',339,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2072,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:54:44.437254',79,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2073,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:54:44.447389',112,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2074,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:54:44.437886',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2075,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:55:21.149400',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2076,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:55:21.165247',107,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2077,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:55:21.152379',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2078,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:55:23.861058',78,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2079,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:55:23.855837',119,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2080,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:55:23.858836',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2081,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:55:29.294627',122,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2082,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:55:29.303814',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2083,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:55:29.307794',242,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2084,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:55:32.097861',101,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2085,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:55:32.083111',111,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2086,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:55:32.087259',223,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2087,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:58:13.294228',120,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2088,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:58:13.294768',131,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2089,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:58:13.302279',240,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2090,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:58:21.649540',128,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2091,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:58:21.651448',137,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2092,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:58:21.638860',265,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2093,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 07:59:40.169091',45,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2094,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 07:59:40.228432',81,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2095,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 07:59:40.224323',251,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2096,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:00:04.818731',82,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2097,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:00:04.830328',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2098,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:00:04.813498',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2099,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:00:07.273660',79,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2100,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:00:07.273661',107,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2101,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:00:07.274941',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2102,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:15:33.226060',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2103,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:15:33.231065',152,15,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:15:33.233053',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:19:45.000191',97,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2106,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:19:45.002833',110,15,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2107,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:19:45.010769',249,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2108,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:34:55.414735',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2109,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:34:55.417171',141,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2110,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:34:55.428366',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2111,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:36:29.726686',67,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2112,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:36:29.720861',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2113,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:36:29.718149',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2114,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:36:42.054391',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2115,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:36:42.061780',150,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2116,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:36:42.054220',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:36:43.849368',114,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:36:43.844426',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2119,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:36:43.851269',235,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2120,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:37:13.647492',106,31,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2121,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:37:13.656328',91,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2122,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:37:13.652952',275,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2123,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:41:35.558299',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2124,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:41:35.574818',115,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2125,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:41:35.563205',243,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2126,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 08:47:48.012358',76,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2127,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 08:47:48.029893',108,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2128,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 08:47:48.010479',259,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2129,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 09:09:16.295489',94,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2130,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 09:09:16.288167',135,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2131,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 09:09:16.287555',276,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2132,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 09:28:13.891098',79,45,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2133,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 09:28:13.888014',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2134,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 09:28:13.892185',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2135,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 09:48:37.160969',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2136,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 09:48:37.161574',95,48,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2137,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 09:48:37.176565',233,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2138,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 09:49:50.930871',202,48,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2139,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 09:49:50.939448',222,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2140,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 09:49:50.921565',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2141,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 09:59:03.975464',66,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2142,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 09:59:03.967077',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2143,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 09:59:03.967945',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2144,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 09:59:06.502213',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2145,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 09:59:06.508484',92,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2146,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 09:59:06.509288',234,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2147,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 10:06:09.918941',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2148,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 10:06:09.914961',89,51,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2149,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 10:06:09.918258',241,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2150,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 10:11:04.382161',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2151,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 10:11:04.383233',108,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2152,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 10:11:04.378343',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2153,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 10:22:53.062753',107,51,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2154,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 10:22:53.068782',89,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2155,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 10:22:53.067868',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2156,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 11:53:14.829879',89,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2157,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 11:53:14.813677',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2158,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 11:53:14.819772',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2159,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 12:13:20.332055',98,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2160,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 12:13:20.341671',108,65,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2161,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 12:13:20.336922',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2162,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 12:13:21.072472',112,65,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2163,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 12:13:21.067593',86,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 12:13:21.075265',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2165,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 12:20:10.668639',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2166,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 12:20:10.671538',124,65,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2167,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 12:20:10.690887',249,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2168,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 12:46:44.261916',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2169,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 12:46:44.262544',103,65,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2170,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 12:46:44.261923',236,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2171,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 12:52:57.750534',105,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2172,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 12:52:57.734184',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2173,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 12:52:57.736864',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2174,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 13:09:52.180598',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2175,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 13:09:52.175038',82,67,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 13:09:52.169455',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2177,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 13:23:41.795526',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2178,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 13:23:41.798539',98,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2179,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 13:23:41.815361',226,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2180,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 13:23:44.393395',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2181,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 13:23:44.422372',77,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2182,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 13:23:44.397464',221,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2183,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 13:52:52.421682',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2184,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 13:52:52.424938',121,72,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2185,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 13:52:52.437758',239,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2186,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 15:14:17.061303',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2187,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 15:14:17.061738',123,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2188,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 15:14:17.062951',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2189,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 15:43:49.059062',76,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2190,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 15:43:49.040714',102,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2191,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 15:43:49.045662',252,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2192,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 16:33:33.383664',59,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2193,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 16:33:33.383334',104,79,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2194,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 16:33:33.385680',250,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2195,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 16:39:37.010605',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2196,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 16:39:37.008683',124,79,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2197,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 16:39:37.001464',306,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2198,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 17:01:52.780161',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2199,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 17:01:52.782775',115,80,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2200,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 17:01:52.789216',276,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2201,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 19:18:01.449020',133,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2202,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 19:18:01.448727',163,88,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2203,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 19:18:01.454555',280,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2204,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 19:56:48.402894',80,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2205,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 19:56:48.537642',61,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2206,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 19:56:48.402850',295,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2207,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 20:06:33.094858',124,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2208,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 20:06:33.092881',141,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2209,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 20:06:33.085241',267,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2210,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 20:29:18.656550',57,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2211,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 20:29:18.703116',116,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2212,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 20:29:18.694656',288,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2213,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 21:15:40.686360',89,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2214,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 21:15:40.674291',131,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2215,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 21:15:40.677117',254,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2216,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 21:15:43.377036',112,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2217,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 21:15:43.374238',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2218,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 21:15:43.379155',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2219,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 21:38:16.630954',97,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2220,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 21:38:16.634280',105,98,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2221,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 21:38:16.641217',293,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 22:22:55.856162',125,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2223,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 22:22:55.865668',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2224,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 22:22:55.863915',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2225,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 23:22:42.563549',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2226,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 23:22:42.567303',129,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2227,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 23:22:42.569946',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2228,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-25 23:28:20.223190',85,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2229,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-25 23:28:20.210882',123,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2230,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-25 23:28:20.207194',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2231,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 00:35:57.815966',65,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2232,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 00:35:57.841848',106,102,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2233,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 00:35:57.834000',252,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2234,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 00:47:10.973725',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2235,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 00:47:10.957337',134,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2236,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 00:47:10.960289',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2237,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:04:04.788203',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2238,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:04:04.796748',129,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2239,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:04:04.782692',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2240,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:10:34.227635',91,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2241,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:10:34.228519',141,103,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2242,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:10:34.226468',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2243,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:10:52.379488',83,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2244,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:10:52.410367',104,103,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2245,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:10:52.369438',257,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2246,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:10:55.830716',76,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2247,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:10:55.839412',132,103,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2248,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:10:55.825771',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2249,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:25:33.622105',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2250,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:25:33.622024',125,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2251,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:25:33.624302',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2252,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:32:43.139038',80,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2253,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:32:43.177518',109,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2254,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:32:43.177121',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2255,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:43:53.867375',63,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2256,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:43:53.870332',121,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2257,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:43:53.873256',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2258,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:44:05.518539',88,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2259,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:44:05.510573',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2260,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:44:05.519735',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2261,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:44:07.541129',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:44:07.545743',100,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2263,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:44:07.537573',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2264,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 01:48:36.346382',81,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2265,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 01:48:36.350873',109,106,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2266,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 01:48:36.359335',249,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2267,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:11:19.374097',82,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2268,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:11:19.421693',137,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2269,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:11:19.397791',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2270,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:16:04.473038',58,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2271,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:16:04.484335',147,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2272,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:16:04.469888',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2273,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:23:18.317414',71,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2274,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:23:18.366990',112,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2275,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:23:18.368795',288,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2276,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:23:29.720729',119,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2277,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:23:29.717534',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2278,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:23:29.713783',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2279,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:23:32.717780',120,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2280,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:23:32.719348',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2281,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:23:32.732339',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2282,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:30:03.440318',138,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2283,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:30:03.444908',131,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2284,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:30:03.447601',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2285,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 02:30:41.188224',99,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2286,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 02:30:41.203830',86,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2287,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 02:30:41.207893',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2288,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:02:13.843976',92,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:02:13.853710',134,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2290,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:02:13.841739',289,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2291,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:03:24.300025',75,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2292,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:03:24.295150',106,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2293,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:03:24.308160',236,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2294,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:03:27.578258',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:03:27.577627',171,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2296,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:03:27.580471',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2297,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:20:42.874864',99,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2298,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:20:42.867045',160,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2299,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:20:42.869737',300,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2300,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:22:38.283008',101,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2301,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:22:38.288275',112,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2302,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:22:38.301093',312,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2303,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:46:45.791982',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2304,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:46:45.784247',211,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2305,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:46:45.793010',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:46:57.693758',105,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2307,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:46:57.710861',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2308,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:46:57.696299',250,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2309,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:46:59.688394',105,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:46:59.692194',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2311,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:46:59.690604',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2312,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 03:53:29.513232',89,114,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2313,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 03:53:29.525570',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2314,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 03:53:29.510856',312,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2315,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 04:00:23.630597',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2316,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 04:00:23.645504',213,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2317,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 04:00:23.642700',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2318,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 04:03:40.489807',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2319,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 04:03:40.487365',130,115,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2320,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 04:03:40.495107',298,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2321,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 04:24:50.813397',224,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2322,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 04:24:50.805908',247,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2323,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 04:24:50.825450',374,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2324,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 04:32:13.922508',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2325,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 04:32:13.939386',124,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2326,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 04:32:13.929530',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2327,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 05:04:52.580210',101,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2328,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 05:04:52.578175',127,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2329,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 05:04:52.570895',251,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2330,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 05:24:30.672091',92,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2331,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 05:24:30.664459',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2332,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 05:24:30.658532',273,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2333,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 05:26:24.856104',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2334,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 05:26:24.856061',119,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2335,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 05:26:24.849876',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2336,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:00:57.492519',78,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2337,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:00:57.553805',102,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2338,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:00:57.556521',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2339,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:04:04.291475',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2340,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:04:04.283281',110,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2341,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:04:04.289409',236,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2342,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:31:35.336495',118,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2343,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:31:35.346870',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2344,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:31:35.345362',252,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2345,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:45:46.004733',98,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:45:45.989726',110,120,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2347,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:45:45.993383',256,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2348,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:49:12.748246',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2349,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:49:12.760099',91,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2350,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:49:12.762712',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2351,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:52:44.807337',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2352,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:52:44.811346',132,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2353,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:52:44.824716',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2354,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:52:55.675044',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2355,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:52:55.683884',113,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2356,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:52:55.669771',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2357,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:52:57.787599',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2358,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:52:57.806375',94,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2359,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:52:57.808672',227,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2360,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 06:54:16.733661',110,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2361,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 06:54:16.736361',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2362,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 06:54:16.733561',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2363,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:00:46.266153',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2364,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:00:46.289448',122,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2365,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:00:46.275022',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:13:16.605305',100,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2367,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:13:16.601566',123,120,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2368,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:13:16.634280',255,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2369,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:14:40.752235',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2370,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:14:40.754900',123,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2371,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:14:40.766478',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2372,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:14:43.589333',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2373,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:14:43.586193',148,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2374,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:14:43.600962',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2375,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:22:29.641126',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2376,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:22:29.642380',139,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2377,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:22:29.638855',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2378,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:33:28.129162',88,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:33:28.136343',113,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2380,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:33:28.131501',288,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2381,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:40:04.371988',90,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2382,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:40:04.367473',99,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2383,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:40:04.361876',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2384,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:53:13.747985',80,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2385,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:53:13.772356',100,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2386,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:53:13.751005',239,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2387,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 07:56:49.286902',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2388,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 07:56:49.280244',144,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2389,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 07:56:49.280360',271,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2390,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:01:59.826021',80,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2391,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:01:59.819955',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2392,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:01:59.815763',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2393,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:22:31.156672',89,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2394,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:22:31.156455',119,24,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2395,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:22:31.153148',247,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2396,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:40:39.675313',119,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:40:39.659825',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2398,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:40:39.665651',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2399,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:46:18.136602',78,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2400,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:46:18.181319',77,36,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2401,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:46:18.135026',249,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2402,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:46:30.673947',106,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2403,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:46:30.677701',111,36,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2404,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:46:30.678206',283,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2405,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:46:41.540361',117,36,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2406,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:46:41.533858',133,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2407,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:46:41.542509',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2408,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 08:55:00.976372',105,42,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2409,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 08:55:00.974522',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2410,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 08:55:00.969007',274,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2411,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 09:08:57.590768',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2412,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 09:08:57.605425',135,45,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2413,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 09:08:57.591739',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2414,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 09:41:18.392604',85,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2415,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 09:41:18.390793',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2416,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 09:41:18.383789',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2417,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:01:30.738188',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2418,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:01:30.731138',97,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2419,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:01:30.729672',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2420,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:08:45.353493',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:08:45.349370',119,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2422,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:08:45.350456',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2423,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:15:57.369141',83,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2424,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:15:57.367598',117,54,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2425,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:15:57.365126',251,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2426,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:21:20.928851',105,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2427,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:21:20.947494',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2428,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:21:20.936005',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:45:53.475361',77,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:45:53.478232',112,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2431,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:45:53.494362',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2432,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:45:56.207989',72,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2433,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:45:56.204915',223,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2434,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:46:19.973327',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2435,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:46:19.995390',124,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2436,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:46:19.977571',232,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2437,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 10:46:22.656564',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2438,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 10:46:22.701967',99,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2439,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 10:46:22.704828',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2440,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 11:08:17.102962',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2441,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 11:08:17.108032',137,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2442,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 11:08:17.099787',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2443,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 11:10:17.696006',88,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2444,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 11:10:17.677900',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2445,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 11:10:17.683520',228,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2446,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 11:13:27.117208',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2447,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 11:13:27.111592',110,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2448,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 11:13:27.153273',217,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2449,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 11:58:01.663985',133,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2450,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 11:58:01.674318',124,60,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2451,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 11:58:01.671326',322,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2452,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 12:34:55.249164',61,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2453,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 12:34:55.258023',122,61,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2454,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 12:34:55.256000',262,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 12:35:36.816415',81,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2456,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 12:35:36.810260',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2457,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 12:35:36.807662',257,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2458,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 12:44:35.356764',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2459,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 12:44:35.360077',145,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2460,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 12:44:35.362417',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2461,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 12:44:39.525335',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2462,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 12:44:39.551980',98,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2463,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 12:44:39.540528',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2464,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 13:21:37.502200',111,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2465,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 13:21:37.491245',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2466,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 13:21:37.495203',240,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2467,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 13:49:57.483677',77,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2468,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 13:49:57.500092',114,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2469,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 13:49:57.489897',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2470,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 14:00:23.589638',103,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2471,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 14:00:23.589546',105,65,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2472,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 14:00:23.592555',246,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2473,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 15:34:55.776072',111,66,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2474,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 15:34:55.779466',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2475,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 15:34:55.781567',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2476,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 16:01:43.550903',109,70,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2477,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 16:01:43.548416',106,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2478,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 16:01:43.547983',262,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2479,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 16:48:04.852217',44,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2480,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 16:48:04.886819',100,71,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2481,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 16:48:04.860837',244,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2482,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 18:53:46.864668',102,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2483,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 18:53:46.883709',112,85,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2484,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 18:53:46.872488',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2485,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 19:01:11.029115',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2486,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 19:01:11.029122',160,85,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2487,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 19:01:11.030478',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2488,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 19:42:32.817516',94,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2489,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 19:42:32.817080',124,88,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2490,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 19:42:32.825221',269,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2491,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 19:50:44.067704',104,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2492,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 19:50:44.070172',118,88,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2493,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 19:50:44.081087',242,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2494,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 19:52:42.875808',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2495,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 19:52:42.882022',114,89,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2496,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 19:52:42.870779',241,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2497,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 21:02:26.538912',116,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2498,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 21:02:26.529187',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2499,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 21:02:26.523830',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2500,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 21:13:47.536832',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2501,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 21:13:47.544453',126,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2502,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 21:13:47.547443',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2503,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 22:53:35.832818',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2504,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 22:53:35.842233',130,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2505,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 22:53:35.838630',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2506,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 22:53:46.886101',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2507,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 22:53:46.889553',137,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2508,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 22:53:46.882722',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2509,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 22:53:48.957171',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2510,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 22:53:48.964964',130,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2511,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 22:53:48.975252',242,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2512,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 22:56:48.377104',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2513,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 22:56:48.376512',142,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2514,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 22:56:48.378085',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2515,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-26 22:56:51.013329',78,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2516,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-26 22:56:51.011195',136,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2517,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-26 22:56:51.016634',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2518,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 00:30:22.498414',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2519,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 00:30:22.507055',100,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2520,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 00:30:22.496111',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2521,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 00:41:31.881382',119,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2522,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 00:41:31.895293',112,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2523,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 00:41:31.884013',267,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2524,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:01:46.693157',121,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2525,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:01:46.700340',124,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2526,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:01:46.700119',369,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2527,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:01:47.547790',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2528,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:01:47.553141',134,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2529,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:01:47.543992',289,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2530,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:06:23.087682',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2531,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:06:23.090199',132,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2532,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:06:23.087552',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2533,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:06:34.515465',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2534,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:06:34.510287',134,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2535,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:06:34.525969',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2536,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:06:37.280764',75,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2537,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:06:37.292664',103,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2538,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:06:37.282426',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2539,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:30:41.447238',136,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2540,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:30:41.461314',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2541,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:30:41.462342',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2542,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 01:41:48.561916',122,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2543,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 01:41:48.554994',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2544,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 01:41:48.549311',352,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2545,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 02:44:25.456940',132,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2546,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 02:44:25.460909',137,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2547,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 02:44:25.461210',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2548,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 03:25:31.599649',111,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2549,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 03:25:31.611511',135,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2550,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 03:25:31.606052',270,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2551,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 03:35:45.717700',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2552,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 03:35:45.721469',114,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2553,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 03:35:45.714876',246,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2554,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 03:40:53.704142',95,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2555,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 03:40:53.712187',128,115,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2556,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 03:40:53.707046',268,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2557,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 04:29:52.378702',109,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2558,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 04:29:52.393968',142,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2559,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 04:29:52.378702',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2560,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 04:43:09.744201',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2561,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 04:43:09.756082',118,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2562,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 04:43:09.744773',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2563,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:08:50.235945',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2564,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:08:50.235006',328,120,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2565,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:08:50.222087',387,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2566,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:09:55.953608',115,120,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2567,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:09:55.956053',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2568,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:09:55.961137',240,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2569,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:13:49.313044',89,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2570,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:13:49.331030',124,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2571,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:13:49.315679',241,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2572,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:22:04.182089',97,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2573,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:22:04.184855',124,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2574,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:22:04.193696',313,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2575,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:27:55.404025',119,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2576,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:27:55.433834',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2577,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:27:55.425016',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2578,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:30:31.846713',102,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2579,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:30:31.860039',112,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2580,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:30:31.857888',314,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2581,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:47:59.718931',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2582,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:47:59.726812',123,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2583,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:47:59.723508',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2584,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 05:50:56.467208',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 05:50:56.460921',130,122,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2586,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 05:50:56.465091',285,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2587,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:00:38.007499',111,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2588,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:00:38.004380',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2589,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:00:38.012465',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2590,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:00:48.903264',125,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2591,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:00:48.950728',89,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2592,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:00:48.913675',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2593,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:00:51.024352',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2594,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:00:51.026448',118,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2595,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:00:51.026026',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2596,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:19:51.180895',114,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2597,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:19:51.197462',194,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2598,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:19:51.191572',359,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2599,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:22:30.447000',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2600,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:22:30.453361',134,123,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2601,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:22:30.455816',257,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2602,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:27:22.262973',79,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2603,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:27:22.271462',103,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2604,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:27:22.268470',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2605,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:30:11.172148',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2606,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:30:11.182347',117,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2607,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:30:11.173566',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2608,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:44:44.861288',126,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2609,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:44:44.885646',115,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2610,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:44:44.865968',236,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2611,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:47:26.528261',88,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2612,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:47:26.551933',131,124,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2613,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:47:26.539151',295,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2614,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 06:48:24.129332',77,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2615,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 06:48:24.150871',63,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2616,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 06:48:24.125757',242,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2617,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:10:02.603194',136,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:10:02.606914',162,124,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2619,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:10:02.591884',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2620,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:12:05.950813',100,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2621,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:12:05.971075',103,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2622,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:12:05.939443',243,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2623,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:22:35.152245',69,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2624,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:22:35.158280',186,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2625,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:22:35.156383',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2626,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:37:55.028961',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2627,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:37:55.030906',117,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2628,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:37:55.029488',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2629,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:44:50.651062',226,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2630,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:44:50.658524',278,127,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2631,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:44:50.666990',426,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2632,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:52:46.725181',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2633,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:52:46.729983',125,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2634,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:52:46.721393',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2635,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:52:54.635826',41,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2636,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:52:54.638205',96,127,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2637,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:52:54.636323',278,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2638,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:54:14.967567',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2639,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:54:14.963244',126,127,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2640,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:54:14.968327',249,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2641,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 07:54:16.911986',109,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2642,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 07:54:16.903256',110,127,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2643,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 07:54:16.900159',242,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2644,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 08:08:48.689382',109,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 08:08:48.693115',110,3,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2646,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 08:08:48.687285',260,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2647,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 08:22:38.152066',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2648,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 08:22:38.158296',96,18,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2649,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 08:22:38.160375',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2650,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 08:27:31.913363',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2651,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 08:27:31.924653',112,18,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2652,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 08:27:31.915345',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2653,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 08:39:13.638084',116,27,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2654,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 08:39:13.632368',118,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2655,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 08:39:13.645502',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2656,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 08:54:34.675237',150,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2657,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 08:54:34.689890',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2658,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 08:54:34.673063',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2659,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 08:54:48.153834',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2660,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 08:54:48.163536',153,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2661,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 08:54:48.160836',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2662,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 09:06:16.341163',83,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2663,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 09:06:16.349982',93,40,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2664,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 09:06:16.347952',257,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2665,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 09:24:11.163977',97,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2666,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 09:24:11.168745',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2667,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 09:24:11.171337',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2668,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 09:25:46.664623',66,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2669,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 09:25:46.666313',108,44,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2670,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 09:25:46.656887',271,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2671,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 09:43:40.762546',128,46,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2672,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 09:43:40.764265',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2673,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 09:43:40.766464',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2674,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 09:57:49.976247',189,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2675,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 09:57:49.975253',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2676,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 09:57:49.965291',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2677,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 10:05:45.573270',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2678,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 10:05:45.576052',124,48,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 10:05:45.577550',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2680,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 10:34:23.509480',77,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 10:34:23.494475',122,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2682,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 10:34:23.498739',250,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2683,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 10:44:47.372384',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2684,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 10:44:47.363643',119,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2685,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 10:44:47.371104',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2686,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 12:15:38.364288',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2687,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 12:15:38.355464',105,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2688,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 12:15:38.362931',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2689,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 12:24:22.365572',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2690,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 12:24:22.377238',276,59,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 12:24:22.386746',350,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2692,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 12:53:37.001902',134,59,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 12:53:36.914006',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2694,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 12:53:37.051266',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2695,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 14:02:06.941330',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2696,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 14:02:06.933724',134,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2697,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 14:02:06.944850',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2698,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 15:07:39.403105',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2699,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 15:07:39.398032',129,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2700,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 15:07:39.407294',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2701,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 15:07:41.971674',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2702,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 15:07:41.968450',100,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 15:07:41.980629',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2704,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 15:47:30.163574',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2705,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 15:47:30.167422',126,66,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2706,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 15:47:30.180385',277,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2707,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 16:22:45.579642',109,70,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2708,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 16:22:45.584184',117,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2709,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 16:22:45.590065',258,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2710,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 16:47:09.104082',129,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2711,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 16:47:09.119979',140,70,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2712,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 16:47:09.111673',298,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 18:04:14.258888',145,75,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2714,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 18:04:14.280233',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 18:04:14.242982',293,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2716,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 18:54:03.447797',109,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2717,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 18:54:03.446845',124,80,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2718,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 18:54:03.457254',239,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2719,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 19:29:28.879221',142,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2720,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 19:29:28.894905',156,83,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2721,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 19:29:28.878447',319,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2722,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 19:35:31.101201',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2723,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 19:35:31.099262',111,83,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2724,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 19:35:31.102015',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2725,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 19:41:47.369147',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2726,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 19:41:47.372715',136,83,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 19:41:47.384230',262,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2728,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 19:58:13.044386',97,86,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2729,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 19:58:13.031240',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2730,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 19:58:13.038156',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2731,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 20:16:14.695195',149,86,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2732,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 20:16:14.701066',162,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2733,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 20:16:14.699327',340,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2734,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 20:56:44.749273',95,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2735,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 20:56:44.818396',84,88,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2736,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 20:56:44.756323',257,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2737,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 21:12:10.156324',100,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2738,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 21:12:10.159106',115,89,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2739,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 21:12:10.163540',256,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2740,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 22:01:30.290062',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2741,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 22:01:30.307098',125,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2742,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 22:01:30.320139',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2743,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 22:01:33.160226',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2744,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 22:01:33.165235',121,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2745,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 22:01:33.138882',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2746,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 23:25:14.332418',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2747,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 23:25:14.348041',146,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2748,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 23:25:14.323980',305,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2749,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 23:31:30.719789',113,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2750,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 23:31:30.733874',121,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2751,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 23:31:30.725320',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2752,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-27 23:57:49.109351',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2753,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-27 23:57:49.107457',152,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2754,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-27 23:57:49.099848',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2755,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 00:02:42.704621',91,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2756,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 00:02:42.697057',101,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2757,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 00:02:42.694315',259,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2758,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 00:03:49.914277',99,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2759,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 00:03:49.909832',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2760,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 00:03:49.919367',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2761,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 00:53:09.158691',110,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2762,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 00:53:09.168704',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2763,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 00:53:09.156557',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2764,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 00:53:12.293024',122,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2765,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 00:53:12.286418',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2766,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 00:53:12.295204',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2767,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 00:56:07.792884',94,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2768,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 00:56:07.784138',109,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2769,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 00:56:07.790063',227,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2770,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:00:37.436417',123,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2771,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:00:37.435760',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2772,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:00:37.443327',234,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2773,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:04:56.935193',79,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2774,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:04:56.937311',105,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2775,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:04:56.938787',269,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2776,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:12:21.060141',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2777,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:12:21.076338',135,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2778,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:12:21.064745',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2779,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:53:35.691773',123,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2780,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:53:35.696352',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2781,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:53:35.693388',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2782,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:55:14.517076',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2783,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:55:14.502472',142,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2784,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:55:14.494445',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2785,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:55:17.380014',122,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2786,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:55:17.375264',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2787,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:55:17.378138',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2788,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:55:33.685898',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2789,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:55:33.684418',120,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2790,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:55:33.672685',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2791,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:55:45.185277',121,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2792,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:55:45.177201',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2793,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:55:45.172709',246,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2794,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 01:55:46.989379',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2795,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 01:55:46.998629',121,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2796,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 01:55:46.987626',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2797,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 03:14:08.777800',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2798,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 03:14:08.787572',133,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2799,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 03:14:08.788989',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2800,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 03:16:09.514436',112,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2801,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 03:16:09.510729',123,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2802,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 03:16:09.522353',240,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2803,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 03:29:14.867346',117,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2804,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 03:29:14.865233',129,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2805,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 03:29:14.861407',253,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2806,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 03:53:52.465679',103,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 03:53:52.456341',150,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2808,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 03:53:52.456848',267,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2809,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 04:56:06.059179',102,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2810,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 04:56:06.066247',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2811,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 04:56:06.067027',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2812,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 04:59:29.581765',35,0,_binary '','dashboard','减少结果行数的错误。null',13371339,30,2,NULL,2,NULL,NULL,NULL,NULL),(2813,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 04:59:29.600383',82,0,_binary '','dashboard','减少结果行数的错误。null',13371339,29,2,NULL,2,NULL,NULL,NULL,NULL),(2814,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 04:59:29.603562',137,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2815,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 04:59:30.498743',103,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2816,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 04:59:30.496216',108,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2817,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 04:59:30.497971',274,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:22:10.212507',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2819,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:22:10.215453',129,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2820,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:22:10.224377',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2821,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:22:17.712121',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2822,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:22:17.714457',125,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2823,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:22:17.711062',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2824,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:22:21.824296',56,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2825,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:22:21.818012',130,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2826,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:22:21.828292',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2827,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:22:24.694489',111,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2828,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:22:24.693552',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2829,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:22:24.686341',253,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2830,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:31:28.546083',109,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2831,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:31:28.554745',126,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2832,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:31:28.542091',230,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:33:19.430662',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:33:19.435176',121,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2835,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:33:19.445884',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2836,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:56:42.082462',143,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2837,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:56:42.086055',149,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2838,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:56:42.087777',317,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2839,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:56:59.048332',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2840,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:56:59.044829',148,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2841,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:56:59.041440',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2842,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:57:02.695146',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2843,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:57:02.732061',111,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2844,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:57:02.699841',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2845,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:57:49.796359',91,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2846,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:57:49.793204',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2847,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:57:49.807653',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2848,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 05:58:16.033063',202,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2849,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 05:58:16.037309',216,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2850,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 05:58:16.050825',417,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2851,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:00:28.538885',85,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2852,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:00:28.553236',105,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2853,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:00:28.570708',234,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2854,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:01:44.694787',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2855,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:01:44.703843',109,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2856,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:01:44.699552',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2857,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:24:55.110210',117,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2858,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:24:55.109604',138,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2859,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:24:55.109596',241,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2860,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:29:12.753955',144,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2861,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:29:12.761288',142,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2862,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:29:12.755357',333,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2863,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:38:57.778352',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2864,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:38:57.784569',170,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2865,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:38:57.779700',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:39:20.815423',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2867,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:39:20.812000',120,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:39:20.811519',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2869,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:40:56.753352',71,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2870,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:40:56.750246',112,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2871,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:40:56.772098',259,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2872,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:50:07.466165',88,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:50:07.452688',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2874,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:50:07.458488',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2875,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 06:56:32.455314',103,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2876,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 06:56:32.463335',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2877,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 06:56:32.454654',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2878,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:01:23.029482',90,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2879,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:01:23.041546',125,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:01:23.069888',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:08:01.922108',89,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2882,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:08:01.926686',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2883,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:08:01.917209',264,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2884,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:09:47.587292',77,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2885,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:09:47.578046',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2886,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:09:47.587557',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2887,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:21:57.250717',121,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2888,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:21:57.246349',121,122,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2889,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:21:57.256350',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2890,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:41:54.831174',117,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2891,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:41:54.902007',81,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:41:54.834796',259,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2893,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:42:19.382075',100,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2894,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:42:19.389651',98,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2895,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:42:19.376635',245,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2896,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:44:01.578632',63,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2897,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:44:01.587543',102,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2898,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:44:01.594456',255,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2899,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:44:17.983541',108,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2900,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:44:17.999799',82,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2901,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:44:18.001561',229,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2902,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:45:32.546610',76,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2903,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:45:32.556197',108,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:45:32.563517',243,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2905,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:46:21.337218',109,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2906,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:46:21.325604',112,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2907,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:46:21.334219',267,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2908,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:48:01.847292',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2909,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:48:01.846235',155,123,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2910,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:48:01.843111',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2911,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:54:04.932278',127,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2912,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:54:04.934231',145,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2913,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:54:04.927696',249,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2914,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:55:12.369167',106,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2915,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:55:12.377973',113,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:55:12.387560',252,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 07:59:14.589549',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2918,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 07:59:14.593297',115,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2919,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 07:59:14.582884',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2920,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:00:40.688884',70,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2921,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:00:40.691762',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2922,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:00:40.696208',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2923,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:16:45.418981',75,12,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2924,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:16:45.409468',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2925,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:16:45.425853',251,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2926,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:45:08.831559',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2927,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:45:08.828825',140,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2928,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:45:08.823735',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2929,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:45:11.759504',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2930,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:45:11.760858',140,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2931,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:45:11.751204',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2932,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:45:38.143867',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2933,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:45:38.165367',103,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2934,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:45:38.154319',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2935,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:45:40.883031',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2936,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:45:40.915466',99,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2937,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:45:40.887237',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2938,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:46:48.630814',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2939,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:46:48.638135',100,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2940,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:46:48.647908',218,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:49:16.968629',89,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2942,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:49:16.964907',104,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2943,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:49:16.959619',252,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2944,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:49:29.380828',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2945,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:49:29.384751',98,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2946,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:49:29.387302',236,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2947,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 08:49:31.111609',101,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2948,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 08:49:31.100714',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2949,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:49:31.106953',237,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2950,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 08:49:40.793046',248,288,_binary '','question',NULL,13371345,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2951,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:04:19.395643',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2952,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:04:19.392143',113,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2953,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:04:19.394558',248,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:04:31.964153',107,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2955,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:04:31.966412',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:04:31.975041',240,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2957,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:04:34.208833',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2958,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:04:34.198875',100,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2959,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:04:34.207291',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2960,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:04:52.810140',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2961,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:04:52.807864',109,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2962,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:04:52.814054',264,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2963,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:04:54.452280',59,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2964,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:04:54.444003',140,35,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2965,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:04:54.440999',260,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2966,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:09:04.180533',133,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2967,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:09:04.179533',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2968,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:09:04.184821',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2969,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:12:35.334853',89,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2970,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:12:35.333517',93,43,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2971,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:12:35.331941',227,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2972,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:14:37.494985',86,43,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2973,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:14:37.498838',129,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2974,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:14:37.504335',342,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2975,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:15:34.523877',111,43,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2976,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:15:34.515440',111,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2977,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:15:34.519775',267,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2978,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:21:23.091193',77,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2979,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:21:23.082231',116,43,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2980,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:21:23.091489',274,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2981,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:30:02.105127',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2982,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:30:02.113545',114,45,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2983,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:30:02.100488',274,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2984,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:37:02.177276',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2985,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:37:02.183834',95,45,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2986,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:37:02.180125',247,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2987,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 09:39:53.921673',80,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2988,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 09:39:53.932245',99,45,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2989,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 09:39:53.924417',263,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2990,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 10:00:32.237951',113,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2991,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 10:00:32.233800',137,46,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2992,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 10:00:32.239174',221,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2993,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 10:11:13.408045',73,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2994,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 10:11:13.417712',138,49,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2995,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 10:11:13.419312',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2996,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 10:14:49.846766',145,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 10:14:49.856414',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2998,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 10:14:49.858972',398,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(2999,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 10:37:46.123703',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3000,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 10:37:46.123864',105,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3001,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 10:37:46.121870',230,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3002,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 11:01:58.913291',95,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3003,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 11:01:58.907096',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3004,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 11:01:58.915730',254,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3005,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 11:38:09.073278',132,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3006,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 11:38:09.068770',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3007,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 11:38:09.069071',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3008,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 11:54:41.085212',60,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3009,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 11:54:41.155912',79,63,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3010,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 11:54:41.092255',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3011,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 11:54:53.883036',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3012,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 11:54:53.952827',82,63,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3013,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 11:54:53.883041',239,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3014,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 12:01:46.710627',106,63,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3015,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 12:01:46.710238',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3016,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 12:01:46.723347',236,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3017,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 12:03:55.514178',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 12:03:55.506947',109,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3019,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 12:03:55.516162',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3020,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 12:57:02.959642',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3021,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 12:57:02.951317',111,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3022,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 12:57:02.949217',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3023,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 13:47:41.808355',128,68,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3024,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 13:47:41.817268',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3025,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 13:47:41.803123',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3026,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 13:55:11.306809',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3027,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 13:55:11.305331',128,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3028,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 13:55:11.305059',238,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3029,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 13:56:31.874728',103,69,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3030,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 13:56:31.884526',88,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3031,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 13:56:31.882846',269,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3032,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 14:01:01.671626',103,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3033,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 14:01:01.670780',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3034,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 14:01:01.670880',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3035,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 17:30:26.667228',110,81,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3036,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 17:30:26.662907',130,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3037,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 17:30:26.661430',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3038,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 18:17:01.261573',80,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3039,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 18:17:01.262492',131,84,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3040,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 18:17:01.266521',250,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3041,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 19:32:46.330438',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3042,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 19:32:46.320184',160,91,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3043,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 19:32:46.311299',321,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3044,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 19:58:32.343074',121,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3045,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 19:58:32.340940',131,94,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3046,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 19:58:32.336034',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3047,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 20:11:19.588883',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3048,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 20:11:19.591217',134,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3049,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 20:11:19.581999',251,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3050,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 20:51:53.454968',103,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3051,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 20:51:53.445077',130,96,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3052,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 20:51:53.441191',262,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3053,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 21:03:06.089416',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3054,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 21:03:06.097179',152,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3055,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 21:03:06.083797',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3056,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 21:03:08.830261',128,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3057,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 21:03:08.831157',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3058,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 21:03:08.821426',248,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3059,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 21:27:34.655790',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3060,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 21:27:34.669669',124,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3061,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 21:27:34.662404',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3062,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 22:04:17.017915',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 22:04:17.022861',128,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3064,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 22:04:17.021235',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3065,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 22:24:00.884198',109,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3066,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 22:24:00.884182',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3067,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 22:24:00.881675',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3068,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 22:25:57.161957',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3069,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 22:25:57.169421',130,101,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3070,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 22:25:57.167762',243,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3071,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 22:27:53.064851',111,101,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3072,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 22:27:53.056413',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3073,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 22:27:53.052656',277,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3074,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 22:27:56.644312',95,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3075,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 22:27:56.637879',126,101,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3076,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 22:27:56.642088',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3077,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 23:46:01.896193',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3078,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 23:46:01.912227',118,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3079,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 23:46:01.892649',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3080,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 23:46:06.371526',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3081,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 23:46:06.364900',127,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3082,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 23:46:06.369487',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3083,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-28 23:52:58.132747',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3084,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-28 23:52:58.136419',97,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3085,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-28 23:52:58.153394',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3086,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 00:25:44.231704',97,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3087,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 00:25:44.237784',105,104,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3088,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 00:25:44.234205',259,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3089,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 00:52:50.774631',70,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3090,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 00:52:50.771193',195,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3091,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 00:52:50.764046',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3092,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 00:53:03.811314',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3093,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 00:53:03.810200',111,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3094,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 00:53:03.806557',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3095,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 00:53:05.802296',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3096,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 00:53:05.817261',158,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3097,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 00:53:05.806952',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3098,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 00:53:44.453407',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3099,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 00:53:44.460146',151,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3100,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 00:53:44.456798',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3101,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 01:22:44.373264',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3102,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 01:22:44.367471',112,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3103,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 01:22:44.378879',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3104,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 01:23:07.385801',91,105,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 01:23:07.379045',114,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3106,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 01:23:07.373469',246,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3107,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 01:38:20.743245',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3108,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 01:38:20.762004',146,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3109,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 01:38:20.758678',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3110,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 02:11:16.674122',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3111,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 02:11:16.669309',137,105,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3112,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 02:11:16.665519',275,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 02:51:47.029329',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3114,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 02:51:47.018359',156,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3115,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 02:51:47.024351',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3116,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 03:13:28.676711',76,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 03:13:28.672127',131,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3118,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 03:13:28.674818',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3119,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 03:22:11.130570',76,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3120,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 03:22:11.210474',71,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3121,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 03:22:11.128342',265,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3122,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 03:33:43.561517',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3123,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 03:33:43.576787',123,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3124,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 03:33:43.564744',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 04:04:44.399491',63,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3126,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 04:04:44.406258',107,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3127,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 04:04:44.399596',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3128,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 04:04:56.466352',66,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3129,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 04:04:56.470417',107,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3130,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 04:04:56.483774',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3131,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 04:04:58.348522',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3132,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 04:04:58.360884',139,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3133,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 04:04:58.348232',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3134,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 04:40:13.686051',88,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3135,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 04:40:13.675387',134,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3136,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 04:40:13.689818',257,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3137,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 04:41:31.770547',60,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3138,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 04:41:31.820630',103,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3139,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 04:41:31.779657',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3140,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 04:47:51.118568',104,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3141,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 04:47:51.128438',102,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3142,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 04:47:51.116006',252,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3143,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 05:25:05.910424',89,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3144,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 05:25:05.895823',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3145,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 05:25:05.900180',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3146,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 05:35:51.459867',139,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3147,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 05:35:51.459208',138,112,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3148,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 05:35:51.458231',320,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3149,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 05:40:22.080931',102,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3150,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 05:40:22.075363',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3151,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 05:40:22.070195',298,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3152,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 05:42:46.597566',116,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3153,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 05:42:46.607558',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3154,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 05:42:46.612101',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3155,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 05:48:12.975968',88,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3156,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 05:48:12.977694',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3157,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 05:48:12.963903',261,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3158,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 05:48:17.828702',112,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3159,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 05:48:17.850676',99,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3160,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 05:48:17.832563',297,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3161,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:00:23.799472',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3162,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:00:23.803125',105,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3163,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:00:23.811998',247,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3164,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:01:02.626374',129,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3165,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:01:02.632397',136,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3166,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:01:02.628695',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3167,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:01:22.463880',106,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3168,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:01:22.460363',106,114,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3169,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:01:22.464052',262,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3170,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:12:07.792369',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3171,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:12:07.796455',119,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3172,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:12:07.796949',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3173,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:30:32.501321',100,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3174,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:30:32.499919',117,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3175,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:30:32.510155',265,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3176,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:39:01.562102',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3177,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:39:01.566105',131,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3178,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:39:01.562485',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3179,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:39:49.043335',92,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3180,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:39:49.055104',113,115,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3181,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:39:49.058207',248,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3182,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:50:03.333071',106,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3183,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:50:03.331857',123,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3184,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:50:03.336803',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3185,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 06:55:20.642269',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3186,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 06:55:20.636465',122,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3187,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 06:55:20.639720',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3188,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 07:17:26.409314',134,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3189,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 07:17:26.412534',144,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3190,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 07:17:26.426319',274,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3191,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 07:35:56.626610',99,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3192,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 07:35:56.626588',121,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3193,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 07:35:56.639152',238,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3194,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 07:41:47.923321',69,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3195,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 07:41:47.925545',144,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3196,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 07:41:47.934105',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3197,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:01:30.891271',101,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3198,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:01:30.902012',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3199,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:01:30.896406',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3200,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:01:35.044094',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3201,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:01:35.042255',115,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3202,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:01:35.041288',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3203,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:01:42.839273',129,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3204,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:01:42.832390',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3205,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:01:42.849099',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3206,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:02:18.046958',85,6,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3207,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:02:18.040980',123,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3208,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:02:18.056096',256,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3209,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:03:14.639876',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3210,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:03:14.669125',102,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3211,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:03:14.643208',229,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3212,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:03:27.383761',57,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3213,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:03:27.426695',150,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3214,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:03:27.427931',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3215,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:03:30.805060',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3216,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:03:30.840967',90,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3217,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:03:30.843221',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3218,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:24:53.832246',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3219,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:24:53.845838',118,15,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3220,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:24:53.842823',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3221,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:27:21.819319',101,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:27:21.828924',87,15,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3223,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:27:21.826330',273,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3224,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:34:55.510823',78,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3225,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:34:55.513154',133,21,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3226,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:34:55.523507',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3227,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 08:55:51.749230',114,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3228,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 08:55:51.759153',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3229,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 08:55:51.756922',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3230,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 09:03:54.779360',95,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3231,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 09:03:54.778533',117,41,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3232,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 09:03:54.775734',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3233,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 09:42:50.658220',165,54,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3234,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 09:42:50.681906',165,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3235,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 09:42:50.691489',341,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3236,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 09:49:00.780191',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3237,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 09:49:00.777181',159,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3238,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 09:49:00.774542',258,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3239,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 10:08:55.347497',89,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3240,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 10:08:55.349967',129,58,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3241,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 10:08:55.352744',251,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3242,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 10:11:16.438062',58,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3243,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 10:11:16.431928',101,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3244,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 10:11:16.441230',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3245,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 10:17:38.463022',103,59,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3246,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 10:17:38.480454',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3247,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 10:17:38.473420',241,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3248,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 10:35:27.362859',109,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3249,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 10:35:27.360294',127,60,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3250,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 10:35:27.357002',255,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3251,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 10:46:11.453717',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3252,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 10:46:11.466135',108,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3253,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 10:46:11.458192',250,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3254,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 11:10:12.756845',105,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3255,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 11:10:12.758071',112,63,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3256,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 11:10:12.768140',257,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3257,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 11:27:53.575988',73,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3258,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 11:27:53.577554',131,64,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3259,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 11:27:53.583530',243,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3260,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 12:46:04.222776',78,71,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3261,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 12:46:04.234164',75,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3262,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 12:46:04.225322',249,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3263,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 13:28:29.714925',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3264,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 13:28:29.699256',116,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3265,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 13:28:29.707288',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3266,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 14:11:51.526592',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3267,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 14:11:51.502159',135,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3268,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 14:11:51.497811',239,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3269,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 15:22:44.752849',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3270,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 15:22:44.750929',107,75,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3271,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 15:22:44.753496',247,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3272,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 15:24:24.241296',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3273,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 15:24:24.260461',129,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3274,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 15:24:24.246065',232,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3275,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 15:24:27.074751',82,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3276,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 15:24:27.072759',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3277,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 15:24:27.076894',245,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3278,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 16:57:04.178228',111,82,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3279,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 16:57:04.174313',108,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3280,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 16:57:04.163196',281,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3281,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 17:32:04.118676',103,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3282,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 17:32:04.122286',126,85,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3283,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 17:32:04.133476',222,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3284,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 21:13:59.682610',92,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3285,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 21:13:59.684469',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3286,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 21:13:59.683247',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3287,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-29 22:15:55.819142',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3288,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-29 22:15:55.822001',140,105,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3289,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-29 22:15:55.836538',258,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3290,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:01:19.910524',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3291,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:01:19.914660',127,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3292,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:01:19.915489',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3293,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:01:32.287619',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3294,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:01:32.273033',133,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3295,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:01:32.293000',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3296,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:01:35.048071',135,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3297,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:01:35.041431',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3298,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:01:35.036314',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3299,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:46:34.888341',227,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3300,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:46:34.885176',246,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3301,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:46:34.865822',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3302,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:46:36.439084',110,110,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3303,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:46:36.439608',102,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3304,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:46:36.433685',255,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3305,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:48:16.601708',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:48:16.616451',121,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3307,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:48:16.611712',250,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3308,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 00:52:05.129956',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3309,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 00:52:05.126359',129,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3310,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 00:52:05.134131',327,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3311,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 01:05:31.589091',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3312,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 01:05:31.590119',164,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3313,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 01:05:31.591284',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 01:05:43.120321',119,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3315,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 01:05:43.112959',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3316,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 01:05:43.111285',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3317,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 01:05:45.109084',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3318,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 01:05:45.112216',127,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3319,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 01:05:45.105990',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3320,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 01:20:19.568081',121,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3321,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 01:20:19.580322',130,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3322,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 01:20:19.567364',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3323,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 01:20:42.578729',96,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3324,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 01:20:42.577319',122,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3325,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 01:20:42.572703',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3326,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 01:20:45.809654',104,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3327,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 01:20:45.806758',117,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3328,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 01:20:45.828484',268,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3329,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 02:19:55.448276',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3330,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 02:19:55.449003',116,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3331,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 02:19:55.450494',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3332,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 02:19:59.198893',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3333,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 02:19:59.199782',119,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3334,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 02:19:59.199124',263,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3335,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 02:35:26.599635',117,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3336,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 02:35:26.610485',114,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3337,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 02:35:26.602274',295,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3338,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 02:51:42.036164',101,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3339,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 02:51:42.042440',133,117,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3340,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 02:51:42.050048',271,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3341,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 03:13:53.830173',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3342,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 03:13:53.836825',178,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3343,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 03:13:53.826863',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3344,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 03:28:01.750088',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3345,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 03:28:01.764211',115,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3346,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 03:28:01.753015',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3347,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 03:28:04.505514',93,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3348,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 03:28:04.518895',108,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3349,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 03:28:04.525675',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3350,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 03:42:56.071212',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3351,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 03:42:56.065852',118,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3352,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 03:42:56.072489',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3353,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 04:17:25.957516',78,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3354,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 04:17:25.951286',118,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3355,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 04:17:25.964097',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3356,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 04:28:26.490671',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3357,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 04:28:26.492306',135,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3358,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 04:28:26.499275',238,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3359,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 04:28:30.793735',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3360,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 04:28:30.798443',105,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3361,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 04:28:30.810655',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3362,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:00:03.349128',119,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3363,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:00:03.349977',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3364,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:00:03.360122',263,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3365,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:14:20.098805',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3366,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:14:20.102327',132,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3367,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:14:20.104379',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3368,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:14:31.315309',104,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3369,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:14:31.324004',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3370,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:14:31.325965',247,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3371,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:14:33.516916',59,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3372,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:14:33.518400',109,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3373,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:14:33.531133',234,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3374,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:19:02.671103',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3375,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:19:02.673262',141,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3376,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:19:02.680608',239,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3377,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:32:46.841747',93,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3378,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:32:46.830869',111,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3379,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:32:46.844051',270,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3380,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:42:19.277495',63,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3381,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:42:19.294528',119,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3382,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:42:19.278485',254,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3383,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:46:21.959296',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3384,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:46:21.968709',131,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3385,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:46:21.954968',264,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3386,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:46:43.028941',78,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3387,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:46:43.036427',109,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3388,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:46:43.034416',250,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3389,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:55:05.290123',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3390,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:55:05.297954',133,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3391,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:55:05.297747',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3392,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 05:55:08.084073',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3393,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 05:55:08.096992',125,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3394,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 05:55:08.087016',236,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3395,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:13:23.854132',78,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3396,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:13:23.865866',94,122,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3397,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:13:23.850658',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3398,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:14:28.605772',86,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3399,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:14:28.602468',129,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3400,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:14:28.607843',279,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3401,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:27:37.594057',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3402,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:27:37.616449',140,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3403,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:27:37.595920',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3404,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:29:30.429085',124,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3405,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:29:30.431803',129,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3406,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:29:30.428057',259,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3407,_binary '??đrK\?g|?\??1?\?CGO\???\?','2024-06-30 06:29:35.467010',56,76,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3408,_binary '???\?\\?!.-\?y?x \?-Ye@]\????','2024-06-30 06:30:03.117348',47,76,_binary '','ad-hoc',NULL,13371339,NULL,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3409,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:31:23.649772',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3410,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:31:23.645824',177,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3411,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 06:31:23.660260',187,76,_binary '','question',NULL,13371339,31,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3412,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:31:23.650245',303,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3413,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:31:32.339300',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3414,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:31:32.358012',122,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3415,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:31:32.339182',256,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3416,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 06:39:38.812088',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3417,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 06:39:38.829700',142,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3418,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 06:39:38.802326',213,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3419,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 06:39:38.814443',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3420,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:04:18.475987',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:04:18.471200',170,123,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3422,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:04:18.474453',218,76,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3423,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:04:18.441047',360,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3424,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:04:26.139458',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3425,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:04:26.149599',223,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3426,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:04:26.138747',288,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3427,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:04:26.138628',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3428,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:04:37.363413',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3429,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:04:37.353715',195,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:04:37.348407',169,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3431,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:04:37.393929',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3432,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:04:39.503706',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3433,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:04:39.508910',165,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3434,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:04:39.513052',190,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3435,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:04:39.507915',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3436,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:04:42.216237',133,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3437,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:04:42.261379',145,123,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3438,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:04:42.229897',194,76,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3439,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:04:42.239110',369,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3440,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:04:53.590804',81,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3441,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:04:53.632419',210,123,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3442,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:04:53.631128',219,76,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3443,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:04:53.618505',361,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3444,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:08:13.860265',186,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3445,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:08:13.877719',219,123,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3446,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:08:13.873138',287,76,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3447,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:08:13.843143',384,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3448,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:14:33.334230',208,76,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3449,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:14:33.344950',179,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3450,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:14:33.331266',193,125,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3451,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:14:33.342487',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3452,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:25:59.177951',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3453,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:25:59.270095',70,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3454,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:25:59.356326',126,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3455,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:25:59.212847',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3456,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:27:56.225425',220,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3457,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:27:56.228520',241,125,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3458,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:27:56.219897',273,76,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3459,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:27:56.233201',395,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3460,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:34:16.499267',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3461,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:34:16.514134',171,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3462,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:34:16.493862',215,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3463,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:34:16.497753',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3464,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:34:36.676153',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3465,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:34:36.683028',184,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3466,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:34:36.684844',184,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3467,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:34:36.669863',403,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3468,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:41:30.898148',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3469,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:41:30.889249',223,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3470,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:41:30.896308',224,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3471,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:41:30.899225',415,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3472,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:41:39.312855',66,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3473,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:41:39.345463',191,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3474,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:41:39.335062',274,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3475,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:41:39.348478',378,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3476,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:41:50.217304',320,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3477,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:41:50.237440',353,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3478,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:41:50.238975',517,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3479,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:41:50.238746',590,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3480,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:41:53.375909',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3481,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:41:53.405540',175,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3482,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:41:53.412043',248,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3483,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:41:53.398672',393,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3484,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 07:52:21.864144',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3485,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 07:52:21.871073',173,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3486,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 07:52:21.884016',192,76,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3487,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 07:52:21.872497',380,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3488,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 08:30:27.288647',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3489,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 08:30:27.286475',205,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3490,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 08:30:27.280503',219,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3491,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 08:30:27.290337',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3492,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 08:30:37.411351',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3493,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 08:30:37.425403',128,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3494,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 08:30:37.439968',163,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3495,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 08:30:37.453423',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3496,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 08:40:10.655200',152,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3497,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 08:40:10.663480',145,29,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3498,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 08:40:10.673754',220,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3499,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 08:40:10.681526',335,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3500,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 08:45:11.244907',191,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3501,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 08:45:11.249152',192,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3502,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 08:45:11.237279',236,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3503,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 08:45:11.240330',331,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3504,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 08:50:17.754146',154,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3505,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 08:50:17.747921',136,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3506,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 08:50:17.746874',187,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3507,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 08:50:17.763151',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3508,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 09:02:06.108406',159,39,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3509,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 09:02:06.103895',171,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3510,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 09:02:06.112079',192,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3511,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 09:02:06.105244',325,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3512,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 09:06:13.470472',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3513,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 09:06:13.454127',152,44,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3514,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 09:06:13.456732',189,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3515,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 09:06:13.444311',295,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3516,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 09:11:40.030171',170,44,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3517,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 09:11:40.042277',169,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3518,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 09:11:40.020474',222,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3519,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 09:11:40.028350',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3520,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 09:11:51.434464',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3521,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 09:11:51.421010',141,44,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3522,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 09:11:51.464174',142,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3523,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 09:11:51.456307',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3524,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 09:11:54.883306',129,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3525,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 09:11:54.876570',270,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3526,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 09:36:30.549251',155,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3527,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 09:36:30.561666',166,51,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3528,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 09:36:30.563461',184,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3529,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 09:36:30.547286',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3530,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 10:29:07.078201',170,61,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3531,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 10:29:07.095069',133,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3532,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 10:29:07.084992',216,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3533,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 10:29:07.105277',306,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3534,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 10:44:28.368566',143,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3535,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 10:44:28.399269',185,65,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3536,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 10:44:28.381990',214,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3537,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 10:44:28.412071',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3538,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 11:00:16.845833',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3539,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 11:00:16.872692',189,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3540,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 11:00:16.868317',223,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3541,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 11:00:16.858003',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3542,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 11:11:13.380761',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3543,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 11:11:13.372911',164,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3544,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 11:11:13.388824',178,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3545,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 11:11:13.378242',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3546,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 11:11:24.372224',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3547,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 11:11:24.393472',155,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3548,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 11:11:24.392228',187,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3549,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 11:11:24.370364',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3550,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 11:11:27.279050',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3551,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 11:11:27.301100',126,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3552,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 11:11:27.292978',166,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3553,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 11:11:27.289429',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3554,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 11:21:08.382068',154,69,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3555,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 11:21:08.389807',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3556,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 11:21:08.415513',165,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3557,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 11:21:08.393012',301,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3558,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 11:25:24.812701',171,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3559,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 11:25:24.822646',196,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3560,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 11:25:24.805601',211,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3561,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 11:25:24.803830',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3562,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 12:17:13.470503',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3563,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 12:17:13.472024',160,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3564,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 12:17:13.473053',176,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3565,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 12:17:13.462320',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3566,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 12:59:07.674657',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3567,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 12:59:07.694665',175,70,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3568,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 12:59:07.699484',183,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3569,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 12:59:07.680497',317,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3570,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:06:45.916781',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3571,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:06:45.940688',166,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3572,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:06:45.930287',272,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3573,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:06:45.920964',400,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3574,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:08:30.818130',151,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3575,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:08:30.842208',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3576,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:08:30.827917',165,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3577,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:08:30.820298',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3578,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:16:31.593883',154,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3579,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:16:31.589176',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3580,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:16:31.603469',169,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3581,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:16:31.594671',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3582,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:27:16.258605',133,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3583,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:27:16.275556',197,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3584,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:27:16.277337',188,71,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3585,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:27:16.258607',326,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3586,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:27:51.084846',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3587,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:27:51.078102',195,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3588,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:27:51.088361',174,71,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3589,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:27:51.075447',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3590,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:28:35.762260',149,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3591,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:28:35.761060',167,71,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3592,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:28:35.755277',191,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3593,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:28:35.751378',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3594,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 13:57:34.271297',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3595,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 13:57:34.273817',196,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3596,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 13:57:34.272051',208,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3597,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 13:57:34.275419',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3598,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:06:53.121862',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3599,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:06:53.132817',162,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3600,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:06:53.148419',182,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3601,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:06:53.142896',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3602,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:20:02.225665',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3603,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:20:02.238589',176,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3604,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:20:02.206293',234,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3605,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:20:02.223772',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3606,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:20:10.587003',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3607,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:20:10.590030',171,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3608,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:20:10.601261',212,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3609,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:20:10.580359',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3610,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:20:20.234355',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3611,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:20:20.252616',155,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3612,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:20:20.255525',171,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3613,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:20:20.246432',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3614,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:22:16.407536',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3615,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:22:16.404873',192,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3616,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:22:16.403237',178,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3617,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:22:16.406297',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3618,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:26:50.689534',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3619,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:26:50.713021',226,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3620,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:26:50.690545',276,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3621,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:26:50.684923',439,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3622,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:32:57.728006',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3623,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:32:57.744148',174,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3624,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:32:57.728008',181,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3625,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:32:57.730953',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3626,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:33:28.487064',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3627,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:33:28.506963',164,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3628,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:33:28.489343',204,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3629,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:33:28.490312',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3630,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:33:31.463147',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3631,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:33:31.488540',168,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3632,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:33:31.504190',183,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3633,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:33:31.459881',400,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3634,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:35:08.400500',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3635,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:35:08.409087',181,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3636,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:35:08.411288',198,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3637,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:35:08.406173',384,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3638,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:35:49.827477',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3639,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:35:49.841457',137,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3640,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:35:49.845974',163,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3641,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:35:49.831133',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3642,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:36:21.222726',120,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3643,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:36:21.209507',191,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3644,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:36:21.220388',229,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3645,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:36:21.218175',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3646,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:36:58.177721',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3647,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:36:58.183259',151,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3648,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:36:58.168916',181,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3649,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:36:58.176454',365,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3650,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:37:56.699010',169,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3651,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:37:56.702417',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3652,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:37:56.703911',187,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3653,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:37:56.708933',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3654,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:40:29.429166',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3655,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:40:29.431695',147,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3656,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:40:29.428634',236,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3657,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:40:29.430600',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3658,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:43:56.882385',149,76,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3659,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:43:56.903417',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3660,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:43:56.910445',152,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3661,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:43:56.869210',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3662,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:47:28.923479',173,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3663,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:47:28.915036',182,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3664,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:47:28.929356',206,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3665,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:47:28.917098',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3666,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:47:30.295319',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3667,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:47:30.284147',157,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3668,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:47:30.294532',170,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3669,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:47:30.279759',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3670,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 15:51:29.275498',169,76,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3671,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 15:51:29.256853',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3672,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 15:51:29.277461',189,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3673,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 15:51:29.261676',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3674,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 16:00:49.612699',170,77,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3675,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 16:00:49.630398',189,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3676,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 16:00:49.631913',198,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3677,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 16:00:49.617004',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3678,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 19:21:51.435690',127,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3679,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 19:21:51.440833',189,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3680,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 19:21:51.458080',187,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3681,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 19:21:51.475827',271,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3682,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 19:31:42.464825',177,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3683,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 19:31:42.454820',202,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3684,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 19:31:42.450101',241,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3685,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 19:31:42.452809',325,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3686,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 20:02:28.272972',184,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3687,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 20:02:28.275029',190,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3688,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 20:02:28.277704',259,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3689,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 20:02:28.265708',353,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3690,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 20:05:10.921830',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3691,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 20:05:10.924815',195,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3692,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 20:05:10.933969',208,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3693,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 20:05:10.923300',377,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3694,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 20:14:08.918128',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3695,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 20:14:08.917302',208,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3696,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 20:14:08.921322',243,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3697,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 20:14:08.908866',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3698,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 20:24:37.804259',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3699,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 20:24:37.806435',210,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3700,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 20:24:37.807430',200,94,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3701,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 20:24:37.805345',352,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3702,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 20:33:17.709145',156,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3703,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 20:33:17.700943',164,95,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3704,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 20:33:17.693668',182,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3705,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 20:33:17.702898',279,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3706,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 20:38:58.506249',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3707,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 20:38:58.512344',198,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3708,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 20:38:58.531357',190,95,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3709,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 20:38:58.534711',316,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3710,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:12:01.761186',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3711,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:12:01.760288',191,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3712,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:12:01.771347',189,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3713,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:12:01.763076',333,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3714,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:35:17.023327',166,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3715,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:35:17.027772',170,105,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3716,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:35:17.019100',228,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3717,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:35:17.030144',335,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3718,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:43:39.854706',156,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3719,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:43:39.868408',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3720,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:43:39.865292',213,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3721,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:43:39.867381',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3722,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:47:06.572339',108,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3723,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:47:06.605065',138,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3724,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:47:06.599256',168,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3725,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:47:06.575183',283,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3726,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:47:48.623393',179,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3727,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:47:48.619210',218,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3728,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:47:48.637797',210,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3729,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:47:48.635693',339,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3730,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:47:53.813247',173,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3731,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:47:53.806550',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3732,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:47:53.823628',161,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3733,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:47:53.814847',329,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3734,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 22:53:05.823038',194,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3735,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 22:53:05.816182',213,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3736,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 22:53:05.804265',226,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3737,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 22:53:05.818852',365,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3738,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 23:18:02.731267',53,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3739,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 23:18:02.759482',161,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3740,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 23:18:02.770345',172,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3741,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 23:18:02.750967',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3742,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-06-30 23:21:26.355092',227,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3743,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-06-30 23:21:26.357036',220,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3744,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-06-30 23:21:26.359175',242,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3745,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-06-30 23:21:26.361350',353,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3746,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 00:01:20.872740',77,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3747,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 00:01:20.891679',440,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3748,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 00:01:21.233330',109,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3749,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 00:01:21.265015',110,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3750,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 00:01:21.773513',182,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3751,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 00:01:21.778099',187,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3752,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 00:01:21.735234',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3753,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 00:25:13.239352',156,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3754,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 00:25:13.244784',217,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3755,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 00:25:13.261593',237,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3756,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 00:25:13.237138',333,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3757,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 00:25:28.475729',161,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3758,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 00:25:28.486165',164,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3759,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 00:25:28.489140',191,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3760,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 00:25:28.482552',289,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3761,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 00:36:51.526126',180,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3762,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 00:36:51.545254',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3763,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 00:36:51.544969',181,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3764,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 00:36:51.562317',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3765,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:03:50.678357',182,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3766,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:03:50.658395',267,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3767,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:03:50.671533',262,114,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3768,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:03:50.674916',423,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3769,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:21:27.012329',134,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3770,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:21:27.025506',181,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3771,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:21:27.028874',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3772,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:21:27.016767',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3773,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:21:38.395014',152,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3774,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:21:38.425999',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3775,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:21:38.429996',194,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3776,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:21:38.400439',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3777,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:21:40.593703',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3778,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:21:40.595216',168,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3779,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:21:40.586095',180,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3780,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:21:40.585534',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:27:20.960276',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3782,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:27:20.966442',245,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3783,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:27:20.963001',259,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3784,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:27:20.943715',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3785,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:33:29.424847',213,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3786,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:33:29.423342',233,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3787,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:33:29.417455',287,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3788,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:33:29.416493',367,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3789,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:33:32.318161',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3790,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:33:32.388425',152,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3791,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:33:32.482417',122,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3792,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:33:32.323021',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3793,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:36:42.330310',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3794,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:36:42.358824',148,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3795,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:36:42.339079',183,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3796,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:36:42.357689',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3797,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:36:53.394233',48,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3798,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:36:53.465475',157,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3799,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:36:53.468350',160,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3800,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:36:53.473361',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3801,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:36:56.427568',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3802,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:36:56.438976',158,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3803,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:36:56.424945',209,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3804,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:36:56.430405',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3805,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 01:50:07.581399',152,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3806,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 01:50:07.573797',228,115,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3807,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 01:50:07.574011',235,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3808,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 01:50:07.576527',351,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3809,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 02:43:22.512752',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3810,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 02:43:22.512161',160,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3811,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 02:43:22.515196',196,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3812,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 02:43:22.519006',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3813,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 02:44:07.793295',158,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3814,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 02:44:07.791708',156,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3815,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 02:44:07.783840',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3816,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 02:44:07.780650',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3817,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 02:44:18.669059',161,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 02:44:18.669294',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3819,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 02:44:18.658246',207,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3820,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 02:44:18.664412',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3821,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 03:07:54.677271',423,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3822,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 03:07:54.666792',461,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3823,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 03:07:54.664043',462,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3824,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 03:07:54.690395',449,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3825,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 04:08:55.298567',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3826,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 04:08:55.303370',185,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3827,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 04:08:55.301024',199,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3828,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 04:08:55.302046',378,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3829,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 04:16:01.173732',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3830,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 04:16:01.169661',170,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3831,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 04:16:01.179921',168,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3832,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 04:16:01.162375',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 04:53:09.037655',159,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3834,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 04:53:09.039681',162,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3835,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 04:53:09.037429',165,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3836,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 04:53:09.035393',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3837,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 04:53:11.938525',157,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3838,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 04:53:11.916160',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3839,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 04:53:11.939998',164,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3840,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 04:53:11.900876',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3841,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 05:10:25.663501',109,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3842,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 05:10:25.641845',151,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3843,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 05:10:25.647724',184,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3844,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 05:10:25.661374',318,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3845,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 05:50:34.646449',155,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3846,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 05:50:34.643611',186,128,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3847,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 05:50:34.655365',202,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3848,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 05:50:34.647259',343,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3849,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 06:03:09.433461',158,128,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3850,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 06:03:09.433020',169,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3851,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 06:03:09.440437',182,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3852,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 06:03:09.427480',328,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3853,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 06:06:15.965436',190,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3854,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 06:06:15.948159',192,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3855,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 06:06:15.956354',237,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3856,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 06:06:15.951344',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3857,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 06:06:28.618222',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3858,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 06:06:28.620655',189,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3859,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 06:06:28.616163',196,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3860,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 06:06:28.622488',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3861,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 06:06:30.582869',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3862,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 06:06:30.614431',159,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3863,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 06:06:30.581088',225,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3864,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 06:06:30.590309',356,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3865,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 06:11:24.218545',187,128,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 06:11:24.241542',148,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3867,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 06:11:24.227527',194,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 06:11:24.213828',321,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3869,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:00:56.791408',170,129,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3870,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:00:56.787014',204,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3871,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:00:56.803937',197,77,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3872,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:00:56.790229',299,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3873,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:18:19.759247',124,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3874,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:18:19.765509',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3875,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:18:19.768411',261,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3876,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:18:19.785866',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3877,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:18:33.056760',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3878,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:18:33.071243',168,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3879,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:18:33.071331',195,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:18:33.069841',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3881,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:18:36.214099',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3882,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:18:36.264476',153,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3883,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:18:36.251089',186,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3884,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:18:36.233333',359,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3885,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:22:45.536864',180,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:22:45.538822',196,130,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3887,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:22:45.527987',213,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3888,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:22:45.533301',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3889,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:22:57.136373',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3890,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:22:57.120936',185,130,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3891,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:22:57.133885',202,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:22:57.131003',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3893,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:23:00.742189',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3894,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:23:00.759747',167,130,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3895,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:23:00.749460',194,77,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3896,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:23:00.740471',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3897,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:29:06.750309',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3898,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:29:06.763127',170,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3899,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:29:06.767322',203,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3900,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:29:06.720810',350,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3901,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:37:42.444245',179,131,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3902,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:37:42.432800',212,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3903,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:37:42.436256',217,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:37:42.426815',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3905,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:38:26.273865',154,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3906,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:38:26.278173',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3907,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:38:26.287526',198,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3908,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:38:26.285963',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3909,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:38:47.516153',166,131,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3910,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:38:47.511134',176,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3911,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:38:47.526083',194,77,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3912,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:38:47.532935',273,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3913,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:41:13.794441',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3914,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:41:13.852241',184,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3915,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:41:13.853408',213,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:41:13.878650',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3917,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 07:56:13.503209',152,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3918,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 07:56:13.486478',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3919,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 07:56:13.493013',240,77,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3920,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 07:56:13.495231',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3921,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:11:04.952570',106,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:11:04.953455',147,7,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3923,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:11:04.950228',198,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3924,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:11:04.944132',300,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3925,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:14:58.485885',120,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3926,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:14:58.487914',148,14,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:14:58.477396',196,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3928,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:14:58.485357',290,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3929,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:23:29.757084',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3930,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:23:29.771323',157,22,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3931,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:23:29.762869',204,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3932,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:23:29.756462',300,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3933,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:35:29.138880',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3934,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:35:29.141453',171,26,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3935,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:35:29.142891',212,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3936,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:35:29.133980',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3937,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:35:40.223749',164,26,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3938,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:35:40.224593',165,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3939,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:35:40.221956',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3940,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:35:40.216518',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:35:43.330699',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3942,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:35:43.342207',138,26,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3943,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:35:43.339073',160,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3944,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:35:43.340394',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3945,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 08:59:50.532838',261,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3946,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 08:59:50.572415',361,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3947,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 08:59:50.563092',371,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3948,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 08:59:50.514232',622,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3949,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:00:02.006305',120,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3950,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:00:01.990475',160,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3951,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:00:01.998866',180,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3952,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:00:02.006739',285,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3953,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:00:05.234486',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:00:05.246261',167,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3955,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:00:05.265286',160,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:00:05.232008',308,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3957,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:13:43.273115',198,40,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3958,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:13:43.268428',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3959,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:13:43.277322',291,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3960,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:13:43.284936',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:13:54.135105',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3962,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:13:54.146881',140,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3963,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:13:54.157743',126,40,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3964,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:13:54.149595',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3965,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:13:57.070512',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3966,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:13:57.073520',150,40,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3967,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:13:57.074979',167,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3968,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:13:57.048370',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3969,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:19:52.608955',59,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3970,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:19:52.684823',140,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3971,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:19:52.682918',135,40,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3972,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:19:52.682104',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3973,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:27:12.498061',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3974,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:27:12.525423',160,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3975,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:27:12.505577',190,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3976,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:27:12.537042',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3977,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:27:28.025150',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3978,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:27:28.034093',138,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3979,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:27:28.042623',194,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3980,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:27:28.022490',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3981,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:27:36.361324',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3982,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:27:36.365434',196,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3983,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:27:36.362515',172,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:27:36.366790',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3985,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:30:30.916815',147,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3986,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:30:30.920711',166,43,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3987,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:30:30.919560',177,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3988,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:30:30.918268',322,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3989,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:41:10.051216',184,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3990,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:41:10.050249',197,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3991,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:41:10.066384',136,48,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3992,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:41:10.050253',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3993,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 09:54:06.211944',134,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 09:54:06.220161',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3995,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 09:54:06.219506',191,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 09:54:06.214029',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 10:16:14.793643',123,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 10:16:14.799187',149,57,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(3999,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 10:16:14.798177',163,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4000,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 10:16:14.795477',334,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4001,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 10:32:56.655461',160,57,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4002,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 10:32:56.646593',161,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4003,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 10:32:56.656028',190,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4004,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 10:32:56.644249',259,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4005,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 11:06:22.796846',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4006,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 11:06:22.819767',120,62,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4007,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 11:06:22.817552',178,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4008,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 11:06:22.789312',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4009,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 11:15:35.962468',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4010,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 11:15:35.950678',205,62,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4011,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 11:15:35.959916',202,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4012,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 11:15:35.953166',375,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4013,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 13:12:40.160465',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4014,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 13:12:40.237741',125,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4015,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 13:12:40.247555',144,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4016,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 13:12:40.237426',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4017,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 13:12:50.474278',231,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 13:12:50.472337',272,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4019,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 13:12:50.480536',292,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 13:12:50.430160',393,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 13:12:53.372398',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4022,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 13:12:53.371817',188,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4023,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 13:12:53.373506',209,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4024,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 13:12:53.368249',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4025,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 13:50:59.645378',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4026,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 13:50:59.643186',185,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4027,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 13:50:59.661283',179,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4028,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 13:50:59.649745',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4029,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 13:54:21.713165',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4030,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 13:54:21.722141',124,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4031,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 13:54:21.714090',161,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 13:54:21.706976',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4033,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 13:54:24.550000',133,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4034,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 13:54:24.538997',239,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4035,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 14:07:10.726023',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4036,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 14:07:10.728367',174,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4037,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 14:07:10.732946',201,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4038,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 14:07:10.725956',373,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4039,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 14:07:15.083439',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4040,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 14:07:15.092415',205,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4041,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 14:07:15.094935',210,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4042,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 14:07:15.080334',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4043,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 14:43:56.656521',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4044,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 14:43:56.657574',154,77,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4045,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 14:43:56.665515',181,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4046,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 14:43:56.655920',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4047,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 16:07:13.761070',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4048,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 16:07:13.756453',170,86,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4049,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 16:07:13.763959',188,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4050,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 16:07:13.771934',336,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4051,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 16:13:54.795884',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4052,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 16:13:54.801346',173,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4053,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 16:13:54.817546',158,87,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4054,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 16:13:54.802641',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4055,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 16:40:53.895930',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4056,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 16:40:53.900770',142,89,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4057,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 16:40:53.902241',174,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4058,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 16:40:53.897727',338,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4059,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 17:09:41.828163',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4060,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 17:09:41.840079',177,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4061,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 17:09:41.850283',212,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4062,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 17:09:41.837021',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4063,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 17:09:52.876296',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4064,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 17:09:52.855043',164,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4065,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 17:09:52.861472',193,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4066,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 17:09:52.871191',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4067,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 17:09:55.873951',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4068,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 17:09:55.864024',181,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4069,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 17:09:55.861420',203,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4070,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 17:09:55.856506',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4071,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 17:17:19.535257',157,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4072,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 17:17:19.540230',165,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4073,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 17:17:19.554206',163,89,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4074,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 17:17:19.549738',271,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4075,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 17:30:43.077361',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4076,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 17:30:43.082764',197,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4077,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 17:30:43.098477',199,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4078,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 17:30:43.081613',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4079,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 17:50:12.920987',67,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4080,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 17:50:12.921988',208,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4081,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 17:50:12.929279',248,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4082,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 17:50:12.941825',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4083,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 18:07:22.309365',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4084,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 18:07:22.302373',225,92,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4085,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 18:07:22.318368',225,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4086,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:07:22.312565',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4087,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 18:10:15.550881',178,92,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4088,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 18:10:15.576173',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4089,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 18:10:15.564273',228,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4090,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:10:15.555766',295,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4091,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:10:25.384616',276,288,_binary '','question',NULL,13371341,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4092,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 18:45:18.505425',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4093,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 18:45:18.482286',193,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4094,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 18:45:18.511453',174,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4095,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:45:18.485308',352,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4096,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 18:48:41.744605',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4097,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 18:48:41.741389',201,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4098,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 18:48:41.732447',192,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4099,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:48:41.726859',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4100,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 18:48:59.390700',179,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4101,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 18:48:59.386206',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4102,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 18:48:59.394431',187,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4103,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:48:59.405361',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4104,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 18:49:02.993193',150,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 18:49:02.998480',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4106,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 18:49:03.017576',175,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4107,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 18:49:02.996273',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4108,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 19:04:47.344300',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4109,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 19:04:47.346203',192,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4110,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 19:04:47.353624',204,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4111,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 19:04:47.362426',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4112,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 21:13:40.613751',181,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 21:13:40.632496',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4114,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 21:13:40.615538',183,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4115,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 21:13:40.622375',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4116,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 21:13:52.760910',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 21:13:52.755973',190,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4118,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 21:13:52.774605',220,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4119,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 21:13:52.771889',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4120,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 21:13:54.795914',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4121,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 21:13:54.831244',194,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4122,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 21:13:54.812426',222,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4123,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 21:13:54.820904',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4124,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 21:40:51.675103',136,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 21:40:51.678662',118,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4126,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 21:40:51.684790',179,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4127,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 21:40:51.668985',400,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4128,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 22:00:32.659425',200,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4129,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 22:00:32.662080',191,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4130,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 22:00:32.646557',248,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4131,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 22:00:32.641174',338,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4132,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 22:01:31.956006',158,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4133,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 22:01:31.963775',169,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4134,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 22:01:31.973853',167,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4135,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 22:01:31.957380',336,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4136,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 22:02:07.305653',170,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4137,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 22:02:07.261625',206,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4138,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 22:02:07.286701',200,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4139,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 22:02:07.282820',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4140,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 22:02:18.069188',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4141,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 22:02:18.078243',188,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4142,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 22:02:18.082049',211,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4143,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 22:02:18.077476',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4144,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-01 22:02:20.988285',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4145,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-01 22:02:21.001899',208,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4146,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-01 22:02:20.998651',201,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4147,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-01 22:02:21.000045',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4148,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:03:19.793107',125,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4149,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:03:19.818951',125,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4150,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:03:19.846110',199,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4151,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:03:19.807338',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4152,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:13:15.212509',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4153,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:13:15.242285',203,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4154,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:13:15.250184',212,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4155,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:13:15.234751',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4156,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:13:18.302872',195,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4157,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:13:18.300576',190,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4158,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:13:18.312431',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4159,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:13:18.304073',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4160,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:16:16.120234',177,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4161,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:16:16.156717',161,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4162,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:16:16.135260',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4163,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:16:16.131921',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4164,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:18:30.016362',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4165,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:18:30.008658',195,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4166,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:18:30.019035',199,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4167,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:18:30.029720',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4168,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:30:33.694356',184,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4169,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:30:33.685402',192,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4170,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:30:33.691002',204,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4171,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:30:33.688018',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4172,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 00:30:38.425455',99,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4173,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 00:30:38.433082',177,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4174,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 00:30:38.497200',147,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4175,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 00:30:38.438389',323,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4176,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 01:20:48.492394',156,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4177,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 01:20:48.501657',181,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4178,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 01:20:48.503608',201,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4179,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 01:20:48.499128',305,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4180,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 01:57:53.816777',151,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4181,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 01:57:53.814664',161,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4182,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 01:57:53.814285',168,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4183,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 01:57:53.819053',275,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4184,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 02:16:44.902955',126,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4185,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 02:16:44.893898',223,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4186,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 02:16:44.891100',223,121,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4187,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 02:16:44.886736',338,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4188,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 02:44:38.484451',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4189,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 02:44:38.513761',176,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4190,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 02:44:38.512977',187,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4191,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 02:44:38.479181',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4192,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 03:22:29.820445',189,122,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4193,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 03:22:29.817365',213,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4194,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 03:22:29.826530',262,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4195,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 03:22:29.835938',392,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4196,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 03:22:38.071557',168,122,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4197,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 03:22:38.076119',174,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4198,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 03:22:38.095234',200,78,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4199,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 03:22:38.082462',342,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4200,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:06:43.933394',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4201,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:06:43.931148',193,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4202,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:06:43.935477',207,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4203,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:06:43.943291',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4204,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:25:48.184874',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4205,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:25:48.194769',188,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4206,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:25:48.196973',210,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4207,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:25:48.192508',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4208,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:25:52.439416',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4209,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:25:52.444641',189,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4210,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:25:52.480417',173,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4211,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:25:52.434911',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4212,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:44:22.153289',60,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4213,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:44:22.183016',150,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4214,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:44:22.161513',193,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4215,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:44:22.159483',342,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4216,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:45:32.631541',194,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4217,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:45:32.644712',217,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4218,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:45:32.632975',257,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4219,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:45:32.653962',322,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4220,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:46:42.771388',125,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4221,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:46:42.791096',178,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4222,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:46:42.775573',215,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4223,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:46:42.777899',385,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4224,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:48:02.065145',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4225,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:48:02.065145',190,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4226,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:48:02.076644',213,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4227,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:48:02.073418',314,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4228,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:50:34.537172',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4229,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:50:34.548209',199,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4230,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:50:34.527874',273,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4231,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:50:34.546508',365,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4232,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:50:39.138359',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4233,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:50:39.133705',160,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4234,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:50:39.128784',174,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4235,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:50:39.134918',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4236,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:57:48.931072',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4237,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:57:48.919071',157,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4238,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:57:48.923882',196,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4239,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:57:48.929318',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4240,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:58:00.309483',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4241,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:58:00.317332',154,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4242,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:58:00.297192',184,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4243,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:58:00.307036',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4244,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 04:58:02.468081',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4245,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 04:58:02.512010',189,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4246,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 04:58:02.497669',213,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4247,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 04:58:02.472078',365,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4248,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 05:08:13.249550',108,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4249,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 05:08:13.262140',196,129,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4250,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 05:08:13.250424',232,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4251,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 05:08:13.242249',346,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4252,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 05:11:54.397634',148,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4253,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 05:11:54.431345',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4254,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 05:11:54.402130',182,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4255,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 05:11:54.430560',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4256,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 05:12:05.911265',134,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4257,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 05:12:05.902374',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4258,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 05:12:05.908426',172,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4259,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 05:12:05.919787',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4260,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 05:12:08.097605',218,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4261,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 05:12:08.082484',351,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4262,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 05:12:08.096295',397,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4263,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 05:12:08.072326',423,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4264,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 05:26:32.197565',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4265,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 05:26:32.209698',182,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4266,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 05:26:32.208176',204,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4267,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 05:26:32.205204',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4268,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 05:57:37.164660',170,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4269,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 05:57:37.170906',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4270,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 05:57:37.176767',181,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4271,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 05:57:37.174516',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4272,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:00:48.394145',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4273,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:00:48.415811',154,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4274,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:00:48.396347',178,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4275,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:00:48.416004',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4276,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:13:04.935947',136,130,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4277,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:13:04.948488',192,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4278,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:13:04.951112',250,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4279,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:13:04.950453',359,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4280,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:31:26.465113',181,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4281,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:31:26.472370',193,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4282,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:31:26.478550',224,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4283,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:31:26.467421',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4284,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:31:53.001008',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4285,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:31:52.993973',215,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4286,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:31:53.010498',191,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4287,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:31:53.008027',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4288,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:32:17.757847',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:32:17.753972',163,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4290,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:32:17.772810',157,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4291,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:32:17.756931',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4292,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:34:30.416068',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4293,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:34:30.419222',207,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4294,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:34:30.411564',202,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4295,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:34:30.417017',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4296,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:34:33.433180',223,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4297,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:34:33.444431',226,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4298,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:34:33.437576',235,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4299,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:34:33.441433',390,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4300,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:44:20.922034',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4301,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:44:20.926357',207,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4302,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:44:20.941172',228,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4303,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:44:20.923882',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4304,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:49:15.470888',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4305,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:49:15.494561',176,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4306,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:49:15.504254',182,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4307,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:49:15.484469',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4308,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:49:27.695457',109,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4309,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:49:27.713940',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4310,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:49:27.703099',179,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4311,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:49:27.700325',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4312,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:49:32.374266',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4313,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:49:32.375847',158,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4314,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:49:32.373381',177,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4315,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:49:32.386930',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4316,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:54:59.097357',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4317,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:54:59.094720',178,133,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4318,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:54:59.092175',185,78,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4319,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:54:59.092756',293,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4320,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:59:32.127084',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4321,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:59:32.129627',205,133,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4322,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:59:32.142061',207,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4323,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:59:32.131669',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4324,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:59:46.022488',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4325,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:59:46.050506',167,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4326,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:59:46.058306',174,133,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4327,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:59:46.031192',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4328,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 06:59:48.919565',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4329,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 06:59:48.923549',170,133,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4330,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 06:59:48.934640',175,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4331,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 06:59:48.954277',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4332,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 07:04:11.577184',119,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4333,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 07:04:11.585655',168,134,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4334,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 07:04:11.581423',205,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4335,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 07:04:11.597986',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4336,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 07:23:58.930383',200,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4337,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 07:23:58.932000',184,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4338,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 07:23:58.927389',195,136,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4339,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 07:23:58.926152',299,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4340,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 07:32:19.672929',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4341,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 07:32:19.683434',174,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4342,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 07:32:19.680643',185,78,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4343,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 07:32:19.684954',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4344,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 07:57:46.496917',152,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4345,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 07:57:46.483798',182,78,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 07:57:46.500204',186,138,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4347,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 07:57:46.488626',376,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4348,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:16:38.020188',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4349,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:16:38.016527',204,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4350,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:16:38.022402',204,11,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4351,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:16:38.008120',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4352,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:25:04.190245',85,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4353,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:25:04.254006',142,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4354,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:25:04.250366',153,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4355,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:25:04.246364',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4356,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:35:47.995608',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4357,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:35:47.999031',190,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4358,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:35:47.982534',198,32,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4359,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:35:47.995987',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4360,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:35:48.679527',79,32,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4361,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:35:48.641321',125,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4362,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:35:48.687812',154,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4363,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:35:48.662844',331,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4364,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:35:59.630388',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4365,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:35:59.650643',142,32,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4366,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:35:59.662698',169,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4367,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:35:59.640751',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4368,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:36:04.543280',142,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4369,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:36:04.553928',174,32,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4370,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:36:04.551972',175,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4371,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:36:04.540347',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4372,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:44:30.878779',60,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4373,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:44:30.887199',156,37,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4374,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:44:30.887530',159,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4375,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:44:30.899262',282,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4376,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:46:34.764443',182,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4377,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:46:34.763908',195,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4378,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:46:34.756175',209,37,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4379,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:46:34.765443',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4380,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:55:04.589831',58,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4381,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:55:04.608721',169,41,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4382,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:55:04.617185',216,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4383,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:55:04.596822',383,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4384,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:55:09.727152',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4385,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:55:09.749477',200,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4386,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:55:09.762804',193,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4387,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:55:09.739125',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4388,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:55:21.133620',152,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4389,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:55:21.123282',154,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4390,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:55:21.119463',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4391,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:55:21.127165',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4392,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:55:23.165285',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4393,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:55:23.179956',166,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4394,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:55:23.209138',152,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4395,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:55:23.173224',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4396,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 08:58:36.903239',146,41,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4397,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 08:58:36.906097',176,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4398,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 08:58:36.899024',171,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4399,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 08:58:36.902065',340,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4400,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 09:03:52.686263',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4401,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 09:03:52.687335',176,45,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4402,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 09:03:52.686384',189,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4403,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 09:03:52.688147',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4404,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 09:33:19.426853',151,59,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4405,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 09:33:19.449865',123,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4406,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 09:33:19.434687',150,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4407,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 09:33:19.436095',272,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4408,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 09:35:16.542070',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4409,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 09:35:16.552955',144,59,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4410,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 09:35:16.556288',164,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4411,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 09:35:16.504792',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4412,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 10:08:41.186936',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4413,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 10:08:41.193945',199,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4414,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 10:08:41.192332',208,65,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4415,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 10:08:41.190667',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4416,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 10:10:56.388296',140,65,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4417,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 10:10:56.408310',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4418,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 10:10:56.395522',163,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4419,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 10:10:56.399414',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4420,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 10:30:59.678393',173,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 10:30:59.668868',154,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4422,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 10:30:59.670330',217,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4423,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 10:30:59.673343',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4424,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:19:45.086131',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4425,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:19:45.097478',190,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4426,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:19:45.102666',195,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4427,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:19:45.089610',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4428,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:19:49.113546',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4429,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:19:49.128448',140,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4430,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:19:49.135762',157,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4431,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:19:49.116225',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4432,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:19:56.212381',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4433,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:19:56.237213',134,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4434,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:19:56.210018',144,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4435,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:19:56.238384',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4436,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:19:59.167120',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4437,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:19:59.177235',170,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4438,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:19:59.191378',196,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4439,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:19:59.167827',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4440,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:21:32.051661',78,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4441,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:21:32.191072',72,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4442,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:21:32.092815',233,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4443,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:21:32.574127',87,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4444,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:22:46.143857',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4445,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:22:46.170694',151,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4446,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:22:46.160948',162,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4447,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:22:46.161836',298,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4448,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 11:22:53.354598',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4449,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 11:22:53.358509',157,76,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4450,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 11:22:53.342402',190,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4451,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 11:22:53.337034',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4452,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 12:25:00.904849',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4453,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 12:25:00.917168',172,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4454,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 12:25:00.929568',182,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4455,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 12:25:00.941418',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4456,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 13:43:35.390167',203,80,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4457,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 13:43:35.370464',213,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4458,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 13:43:35.386089',223,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4459,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 13:43:35.384139',326,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4460,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 15:51:04.544179',63,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4461,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 15:51:04.569443',188,87,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4462,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 15:51:04.546489',227,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4463,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 15:51:04.558343',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4464,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 15:55:16.210546',134,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4465,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 15:55:16.228486',169,87,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4466,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 15:55:16.217543',210,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4467,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 15:55:16.215366',306,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4468,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 17:13:21.742153',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4469,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 17:13:21.736923',161,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4470,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 17:13:21.735211',164,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4471,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 17:13:21.736508',333,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4472,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 17:30:02.936141',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4473,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 17:30:02.907165',148,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4474,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 17:30:02.930421',152,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4475,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 17:30:02.908758',290,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4476,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 17:51:22.827231',176,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4477,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 17:51:22.844089',203,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4478,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 17:51:22.842632',225,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4479,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 17:51:22.831401',297,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4480,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 18:40:14.062772',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4481,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 18:40:14.070424',182,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4482,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 18:40:14.066538',238,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4483,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 18:40:14.068418',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4484,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 18:40:16.763402',63,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4485,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 18:40:16.755510',116,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4486,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 18:40:16.761803',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4487,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 18:51:13.532968',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4488,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 18:51:13.543182',191,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4489,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 18:51:13.537644',209,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4490,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 18:51:13.545796',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4491,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 19:00:30.407414',64,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4492,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 19:00:30.427278',192,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4493,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 19:00:30.436535',193,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4494,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 19:00:30.416717',352,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4495,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 20:19:26.364804',160,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4496,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 20:19:26.366134',167,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4497,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 20:19:26.353180',181,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4498,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 20:19:26.363030',294,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4499,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 20:28:44.245199',56,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4500,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 20:28:44.317907',129,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4501,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 20:28:44.323966',165,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4502,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 20:28:44.344075',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4503,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 23:13:14.313406',87,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4504,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 23:13:14.465469',253,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4505,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 23:13:14.445293',381,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4506,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 23:13:14.438064',397,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4507,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 23:25:34.396251',171,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4508,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 23:25:34.394026',192,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4509,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 23:25:34.399305',226,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4510,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 23:25:34.400362',299,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4511,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-02 23:53:22.659810',147,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4512,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-02 23:53:22.685337',190,122,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4513,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-02 23:53:22.687247',263,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4514,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-02 23:53:22.670565',388,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4515,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 00:30:11.410233',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4516,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 00:30:11.430988',218,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4517,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 00:30:11.434803',239,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4518,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 00:30:11.423328',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4519,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 00:30:24.081016',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4520,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 00:30:24.141281',162,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4521,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 00:30:24.144115',189,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4522,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 00:30:24.125403',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4523,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 00:31:17.889468',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4524,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 00:31:17.885812',179,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4525,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 00:31:17.909331',202,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4526,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 00:31:17.938375',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4527,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 00:53:31.617343',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4528,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 00:53:31.599422',227,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4529,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 00:53:31.610938',222,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4530,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 00:53:31.610028',374,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4531,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 01:21:41.774407',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4532,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 01:21:41.784668',189,126,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4533,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 01:21:41.787919',199,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4534,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 01:21:41.753442',330,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4535,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 01:35:52.126753',141,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4536,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 01:35:52.121720',215,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4537,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 01:35:52.120552',217,128,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4538,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 01:35:52.118378',360,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4539,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 02:14:30.261011',151,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4540,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 02:14:30.268242',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4541,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 02:14:30.262462',193,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4542,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 02:14:30.257939',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4543,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 02:28:36.323356',142,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4544,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 02:28:36.354095',170,130,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4545,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 02:28:36.360809',175,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4546,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 02:28:36.318295',351,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4547,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 02:46:08.397045',125,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4548,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 02:46:08.403874',170,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4549,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 02:46:08.411072',170,130,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4550,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 02:46:08.418713',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4551,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 02:46:17.571709',142,130,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4552,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 02:46:17.564212',133,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4553,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 02:46:17.577131',168,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4554,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 02:46:17.564212',301,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4555,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:05:59.938676',198,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4556,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:05:59.936482',239,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4557,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:05:59.934418',244,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4558,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:05:59.933824',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4559,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:14:10.784723',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4560,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:14:10.796985',171,131,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4561,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:14:10.799245',187,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4562,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:14:10.798772',311,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4563,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:34:28.498404',141,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4564,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:34:28.484114',179,131,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4565,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:34:28.492492',188,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4566,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:34:28.490928',314,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4567,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:37:44.712273',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4568,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:37:44.731453',186,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4569,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:37:44.728743',187,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4570,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:37:44.715622',372,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4571,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:37:47.778555',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4572,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:37:47.793115',185,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4573,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:37:47.774947',209,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4574,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:37:47.763242',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4575,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:59:39.237238',179,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4576,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:59:39.233193',217,132,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4577,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:59:39.228447',253,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4578,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:59:39.222595',311,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4579,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:59:46.133390',174,132,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4580,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:59:46.126693',202,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4581,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:59:46.148555',170,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4582,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:59:46.127536',377,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4583,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 03:59:51.657106',178,132,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4584,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 03:59:51.613680',166,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4585,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 03:59:51.668867',176,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4586,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 03:59:51.621043',390,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4587,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:01:05.677427',66,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4588,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:01:05.712667',157,132,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4589,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:01:05.720849',186,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4590,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:01:05.681202',324,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4591,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:02:26.755208',137,132,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4592,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:02:26.756119',179,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4593,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:02:26.755207',183,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4594,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:02:26.762124',332,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4595,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:13:47.844135',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4596,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:13:47.837039',204,133,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4597,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:13:47.840930',219,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4598,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:13:47.833378',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4599,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:14:04.618239',214,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4600,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:14:04.622227',208,133,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4601,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:14:04.622855',221,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4602,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:14:04.623259',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4603,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:14:06.877100',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4604,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:14:06.869777',125,133,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4605,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:14:06.853485',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4606,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:14:08.275804',136,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4607,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:14:08.289359',142,133,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4608,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:14:08.314726',142,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4609,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:14:08.281266',291,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4610,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:29:01.315064',123,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4611,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:29:01.324185',146,134,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4612,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:29:01.287429',215,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4613,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:29:01.324729',318,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4614,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:40:54.882520',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4615,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:40:54.860909',208,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4616,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:40:54.871236',186,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4617,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:40:54.855002',315,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:43:32.820347',115,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4619,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:43:32.844596',195,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4620,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:43:32.818796',210,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4621,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:43:32.828943',342,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4622,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 04:44:13.704504',182,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4623,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 04:44:13.706285',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4624,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 04:44:13.707277',194,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4625,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 04:44:13.708733',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4626,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:06:38.354777',205,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4627,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:06:38.385614',178,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4628,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:06:38.377412',212,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4629,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:06:38.367164',381,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4630,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:06:49.870313',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4631,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:06:49.880018',202,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4632,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:06:49.890512',329,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4633,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:06:49.866567',438,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4634,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:06:54.505734',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4635,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:06:54.520180',179,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4636,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:06:54.515466',197,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4637,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:06:54.514299',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4638,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:09:20.482476',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4639,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:09:20.490074',176,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4640,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:09:20.483553',192,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4641,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:09:20.485739',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4642,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:09:31.125850',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4643,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:09:31.170235',140,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4644,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:09:31.162412',178,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4645,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:09:31.171918',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4646,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:09:33.208028',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4647,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:09:33.226424',187,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4648,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:09:33.242398',234,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4649,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:09:33.214951',365,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4650,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:52:47.547084',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4651,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:52:47.526054',186,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4652,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:52:47.526349',228,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4653,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:52:47.531420',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4654,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:52:55.273404',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4655,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:52:55.269849',208,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4656,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:52:55.248013',246,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4657,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:52:55.241173',425,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4658,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:52:57.575577',175,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4659,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:52:57.581702',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4660,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:52:57.591565',209,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4661,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:52:57.580357',359,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4662,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:52:59.781287',113,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4663,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:52:59.766336',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4664,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:52:59.770921',188,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4665,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:52:59.778005',398,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4666,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:53:00.491411',124,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4667,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:53:00.491121',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4668,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:53:00.496937',216,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4669,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:53:00.498538',390,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4670,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:53:07.237470',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4671,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 05:53:07.237470',173,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4672,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 05:53:07.238335',239,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4673,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:53:07.239195',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4674,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 05:53:11.117259',60,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4675,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 05:53:11.116127',251,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4676,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 06:10:58.945644',154,139,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4677,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 06:10:58.962320',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4678,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 06:10:58.960285',175,79,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 06:10:58.949307',360,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4680,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 06:17:24.043812',164,141,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4681,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 06:17:24.035837',197,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4682,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 06:17:24.053419',204,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4683,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 06:17:24.048609',364,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4684,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 06:17:25.623128',110,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4685,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 06:17:25.633060',139,141,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4686,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 06:17:25.621235',189,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4687,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 06:17:25.611520',314,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4688,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 07:09:52.895301',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4689,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 07:09:52.902443',157,142,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4690,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 07:09:52.888116',209,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 07:09:52.888115',353,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4692,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 07:23:14.138196',164,142,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 07:23:14.126600',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4694,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 07:23:14.123887',212,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4695,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 07:23:14.127856',366,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4696,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 07:32:20.504399',129,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4697,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 07:32:20.532276',192,143,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4698,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 07:32:20.525855',223,79,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4699,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 07:32:20.510347',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4700,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 07:45:39.297900',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4701,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 07:45:39.298298',170,143,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4702,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 07:45:39.312402',176,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 07:45:39.296331',376,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4704,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 07:54:07.301089',210,79,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4705,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 07:54:07.301784',193,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4706,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 07:54:07.302469',201,143,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4707,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 07:54:07.300137',269,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4708,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 07:55:09.511169',174,143,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4709,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 07:55:09.501514',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4710,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 07:55:09.510111',197,79,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4711,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 07:55:09.508359',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4712,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 08:04:32.046080',157,6,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4713,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 08:04:32.040437',170,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4714,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 08:04:32.054328',204,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 08:04:32.050493',341,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4716,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 08:16:19.496820',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4717,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 08:16:19.484512',151,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4718,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 08:16:19.514514',157,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4719,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 08:16:19.496740',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4720,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 08:21:53.527848',144,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4721,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 08:21:53.543970',185,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4722,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 08:21:53.548488',194,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4723,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 08:21:53.538646',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4724,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 08:41:14.062126',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4725,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 08:41:14.077746',159,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4726,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 08:41:14.090689',176,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 08:41:14.066670',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4728,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 08:43:56.959563',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4729,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 08:43:56.976326',168,39,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4730,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 08:43:56.974180',172,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4731,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 08:43:56.963966',328,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4732,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 09:29:18.443220',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4733,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 09:29:18.436331',144,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4734,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 09:29:18.453914',185,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4735,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 09:29:18.442267',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4736,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 09:40:24.937373',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4737,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 09:40:24.919795',151,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4738,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 09:40:24.926011',171,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4739,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 09:40:24.922872',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4740,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 09:51:10.051457',193,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4741,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 09:51:10.047946',187,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4742,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 09:51:10.056167',196,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4743,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 09:51:10.056251',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4744,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 11:13:28.100555',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4745,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 11:13:28.088028',192,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4746,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 11:13:28.106036',192,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4747,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 11:13:28.105461',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4748,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 11:24:17.862380',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4749,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 11:24:17.860121',151,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4750,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 11:24:17.873882',160,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4751,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 11:24:17.871435',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4752,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 11:24:32.900918',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4753,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 11:24:32.912441',168,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4754,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 11:24:32.908880',157,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4755,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 11:24:32.914301',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4756,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 11:24:35.720957',40,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4757,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 11:24:35.759311',145,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4758,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 11:24:35.758301',194,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4759,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 11:24:35.757655',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4760,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 11:28:45.747263',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4761,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 11:28:45.755113',159,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4762,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 11:28:45.754004',181,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4763,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 11:28:45.741978',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4764,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 11:29:25.953560',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4765,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 11:29:25.972047',150,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4766,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 11:29:25.967038',154,70,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4767,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 11:29:25.956409',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4768,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 12:13:32.808475',136,76,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4769,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 12:13:32.819817',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4770,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 12:13:32.795501',191,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4771,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 12:13:32.829752',263,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4772,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 12:13:37.077133',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4773,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 12:13:37.090467',151,76,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4774,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 12:13:37.071538',198,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4775,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 12:13:37.070356',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4776,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 13:03:39.557053',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4777,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 13:03:39.566574',165,78,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4778,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 13:03:39.567832',176,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4779,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 13:03:39.569128',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4780,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 13:03:51.109679',219,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 13:03:51.108002',223,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4782,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 13:03:51.130518',212,78,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4783,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 13:03:51.111360',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4784,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 13:03:54.567261',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4785,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 13:03:54.603552',152,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4786,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 13:03:54.612378',141,78,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4787,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 13:03:54.615680',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4788,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 15:26:20.675965',50,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4789,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 15:26:20.693274',182,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4790,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 15:26:20.686199',181,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4791,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 15:26:20.687281',369,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4792,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 16:42:39.520887',116,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4793,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 16:42:39.519144',140,91,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4794,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 16:42:39.529592',185,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4795,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 16:42:39.514214',330,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4796,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 17:02:24.602307',129,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4797,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 17:02:24.604146',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4798,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 17:02:24.614840',176,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4799,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 17:02:24.608754',282,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4800,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 17:55:19.450073',179,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4801,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 17:55:19.464320',159,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4802,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 17:55:19.474050',169,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4803,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 17:55:19.452913',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4804,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 18:15:05.906215',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4805,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 18:15:05.923112',187,96,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4806,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 18:15:05.925552',219,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4807,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 18:15:05.901370',327,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4808,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 19:00:27.135068',91,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4809,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 19:00:27.174666',118,96,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4810,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 19:00:27.161923',210,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4811,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 19:00:27.144403',300,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4812,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 19:22:17.275232',155,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4813,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 19:22:17.268133',173,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4814,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 19:22:17.266841',181,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4815,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 19:22:17.265676',289,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4816,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 19:38:37.007497',172,99,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4817,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 19:38:37.005701',168,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4818,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 19:38:37.000857',215,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4819,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 19:38:37.009432',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4820,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 20:16:22.133473',172,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4821,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 20:16:22.143020',169,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4822,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 20:16:22.140316',185,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4823,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 20:16:22.128183',319,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4824,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 20:46:44.404321',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4825,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 20:46:44.406872',152,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4826,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 20:46:44.428640',167,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4827,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 20:46:44.420022',293,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4828,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 21:10:11.913493',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4829,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 21:10:11.908149',233,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4830,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 21:10:11.915832',248,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4831,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 21:10:11.897484',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4832,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 21:10:24.147677',148,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 21:10:24.155433',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 21:10:24.177375',128,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4835,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 21:10:24.183856',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4836,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 21:10:27.062036',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4837,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 21:10:27.077307',169,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4838,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 21:10:27.070295',183,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4839,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 21:10:27.068237',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4840,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 22:15:10.872760',168,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4841,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 22:15:10.862817',234,110,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4842,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 22:15:10.870410',238,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4843,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 22:15:10.868417',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4844,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 22:34:01.437609',129,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4845,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 22:34:01.443282',196,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4846,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 22:34:01.445729',180,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4847,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 22:34:01.430544',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4848,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 23:21:23.719990',181,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4849,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 23:21:23.690739',200,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4850,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 23:21:23.697773',219,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4851,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 23:21:23.681612',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4852,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 23:32:13.237011',147,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4853,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 23:32:13.227335',196,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4854,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 23:32:13.238292',206,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4855,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 23:32:13.236888',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4856,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 23:52:12.839787',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4857,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 23:52:12.828060',129,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4858,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 23:52:12.835476',180,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4859,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 23:52:12.836225',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4860,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 23:52:24.149559',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4861,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 23:52:24.144741',156,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4862,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 23:52:24.152666',191,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4863,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 23:52:24.165554',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4864,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-03 23:52:27.267501',191,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4865,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-03 23:52:27.266396',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4866,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-03 23:52:27.281737',224,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4867,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-03 23:52:27.269530',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4868,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 00:49:12.639501',154,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4869,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 00:49:12.631622',166,114,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4870,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 00:49:12.644116',163,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4871,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 00:49:12.637390',302,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4872,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 01:20:14.874005',192,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 01:20:14.873129',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4874,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 01:20:14.870474',216,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4875,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 01:20:14.877268',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4876,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 01:48:32.989068',123,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4877,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 01:48:33.005191',133,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4878,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 01:48:33.025131',180,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4879,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 01:48:33.015982',309,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4880,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 02:36:15.657081',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 02:36:15.690100',180,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4882,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 02:36:15.674948',218,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4883,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 02:36:15.688922',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4884,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 02:39:00.384795',146,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4885,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 02:39:00.367662',191,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 02:39:00.372440',179,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4887,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 02:39:00.361553',348,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4888,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 02:40:13.232513',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4889,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 02:40:13.252829',145,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4890,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 02:40:13.240548',244,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4891,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 02:40:13.250813',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4892,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 02:42:00.410875',199,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4893,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 02:42:00.407107',212,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4894,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 02:42:00.409410',214,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4895,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 02:42:00.407689',376,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4896,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:04:30.274421',130,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4897,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:04:30.262073',209,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4898,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:04:30.253890',233,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4899,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:04:30.270147',337,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4900,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:06:16.730018',66,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4901,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:06:16.765344',90,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4902,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:06:16.753279',167,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4903,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:06:16.740429',334,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4904,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:06:21.478866',170,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:06:21.472802',150,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4906,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:06:21.470138',187,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4907,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:06:21.473012',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4908,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:13:31.372539',190,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4909,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:13:31.371122',222,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4910,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:13:31.357003',246,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4911,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:13:31.359536',356,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4912,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:13:54.215321',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4913,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:13:54.224302',152,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4914,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:13:54.221666',184,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4915,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:13:54.207337',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4916,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:13:57.784518',99,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:13:57.796243',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4918,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:13:57.900417',120,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4919,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:13:57.779462',354,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4920,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:41:13.491603',195,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4921,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:41:13.503029',175,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:41:13.499713',181,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4923,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:41:13.506996',323,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4924,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:41:29.518416',167,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4925,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:41:29.528508',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4926,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:41:29.527019',203,0,_binary '','dashboard','减少结果行数的错误。null',13371339,29,2,NULL,2,NULL,NULL,NULL,NULL),(4927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:41:29.525148',212,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4928,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:41:30.699670',190,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4929,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:41:30.712140',187,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4930,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:41:30.714599',186,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4931,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:41:30.698497',376,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4932,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:44:18.098546',168,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4933,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:44:18.098266',175,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4934,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:44:18.117142',169,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4935,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:44:18.095361',337,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4936,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 03:47:16.952197',143,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4937,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 03:47:16.933901',176,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4938,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 03:47:16.942838',211,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4939,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 03:47:16.940515',313,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4940,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 04:04:44.453473',170,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 04:04:44.441932',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4942,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 04:04:44.451403',220,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4943,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 04:04:44.473299',339,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4944,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 04:50:05.167259',223,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4945,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 04:50:05.165160',231,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4946,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 04:50:05.178145',244,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4947,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 04:50:05.159978',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4948,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 04:54:37.091097',144,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4949,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 04:54:37.087896',192,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4950,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 04:54:37.100325',225,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4951,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 04:54:37.103338',327,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4952,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 04:54:40.808767',130,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4953,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 04:54:40.817949',166,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4954,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 04:54:40.808762',182,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4955,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 04:54:40.807126',306,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4956,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:01:07.228369',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4957,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:01:07.248897',168,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4958,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:01:07.252319',212,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4959,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:01:07.222001',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4960,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:25:47.437405',174,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:25:47.436440',197,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4962,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:25:47.439553',213,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4963,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:25:47.431916',393,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4964,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:27:54.188302',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4965,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:27:54.206327',160,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4966,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:27:54.203200',172,80,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4967,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:27:54.174469',334,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4968,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:28:23.044805',136,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4969,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:28:23.054308',143,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4970,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:28:23.043285',176,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4971,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:28:23.042896',325,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4972,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:30:12.668009',167,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4973,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:30:12.669970',177,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4974,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:30:12.692722',171,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4975,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:30:12.668959',294,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4976,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:31:54.957524',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4977,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:31:54.953361',178,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4978,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:31:54.937970',201,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4979,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:31:54.946521',323,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4980,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:37:54.440197',162,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4981,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:37:54.525089',213,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4982,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:37:54.502535',396,80,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4983,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:37:54.545338',553,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4984,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:57:56.533900',117,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4985,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:57:56.543824',195,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4986,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:57:56.538876',207,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4987,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:57:56.551772',312,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4988,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:58:01.406348',123,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4989,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:58:01.391524',166,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4990,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:58:01.409535',164,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4991,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:58:01.408252',362,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4992,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:58:07.943078',138,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4993,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:58:07.948852',159,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4994,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:58:07.960378',170,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4995,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:58:07.952021',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4996,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 05:58:11.717138',156,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4997,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 05:58:11.722416',161,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4998,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 05:58:11.705881',215,80,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(4999,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 05:58:11.714802',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5000,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 06:44:44.417160',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5001,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 06:44:44.423506',213,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5002,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 06:44:44.440347',315,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5003,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 06:44:44.448499',482,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5004,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 07:09:25.946155',192,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5005,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 07:09:25.949878',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5006,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 07:09:25.965166',236,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5007,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 07:09:25.956404',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5008,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 07:44:15.272631',166,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5009,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 07:44:15.264512',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5010,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 07:44:15.271248',208,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5011,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 07:44:15.271567',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5012,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 07:44:26.956428',158,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5013,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 07:44:26.965966',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5014,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 07:44:26.963281',181,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5015,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 07:44:26.952817',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5016,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 07:44:28.955185',239,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5017,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 07:44:28.952287',270,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5018,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 07:44:28.953624',253,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5019,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 07:44:28.958271',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5020,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 07:57:19.999806',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5021,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 07:57:20.009723',232,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5022,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 07:57:20.014021',305,80,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5023,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 07:57:19.966964',408,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5024,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:13:07.996345',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5025,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 08:13:07.994216',173,15,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5026,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:13:07.978154',214,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5027,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:13:07.982373',319,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5028,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:13:19.194178',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5029,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 08:13:19.212758',150,15,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5030,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:13:19.223137',143,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5031,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:13:19.186990',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5032,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:13:22.519913',160,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5033,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:13:22.521505',168,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5034,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:13:22.519682',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5035,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:26:01.453957',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5036,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 08:26:01.459165',166,20,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5037,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:26:01.440028',212,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5038,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:26:01.446529',363,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5039,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:44:00.171891',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5040,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:44:00.204757',162,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5041,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 08:44:00.193368',168,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5042,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:44:00.183685',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5043,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 08:53:13.303050',136,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5044,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:53:13.305832',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5045,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:53:13.321912',192,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5046,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:53:13.329181',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5047,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 08:58:28.040559',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5048,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 08:58:28.033181',161,35,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5049,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 08:58:28.047720',188,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5050,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 08:58:28.041430',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5051,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:11:06.399696',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5052,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:11:06.399174',169,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5053,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:11:06.400648',166,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5054,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:11:06.393758',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5055,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:11:17.404916',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5056,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:11:17.418086',176,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5057,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:11:17.394370',223,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5058,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:11:17.387636',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5059,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:11:21.498715',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5060,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:11:21.505574',150,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5061,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:11:21.479845',185,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5062,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:11:21.484284',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:28:19.473127',151,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5064,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:28:19.493860',194,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5065,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:28:19.502940',203,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5066,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:28:19.506046',391,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5067,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:34:16.617322',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5068,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:34:16.612401',176,52,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5069,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:34:16.601504',193,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5070,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:34:16.593773',336,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5071,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:34:21.401827',170,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5072,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:34:21.387679',180,52,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5073,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:34:21.389877',180,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5074,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:34:21.388077',264,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5075,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:41:59.980368',184,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5076,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:41:59.980348',185,52,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5077,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:42:00.002007',210,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5078,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:41:59.988806',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5079,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 09:59:24.262390',101,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5080,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 09:59:24.273661',125,58,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5081,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 09:59:24.308899',153,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5082,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 09:59:24.302753',261,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5083,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 10:18:54.600417',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5084,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 10:18:54.623093',176,62,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5085,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 10:18:54.605249',209,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5086,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 10:18:54.612861',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5087,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 10:26:01.803315',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5088,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 10:26:01.824421',193,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5089,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 10:26:01.815015',206,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5090,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 10:26:01.809392',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5091,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 11:33:08.073385',102,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5092,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 11:33:08.108292',147,72,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5093,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 11:33:08.104424',169,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5094,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 11:33:08.108628',258,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5095,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 11:35:42.372100',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5096,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 11:35:42.396871',146,72,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5097,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 11:35:42.373133',171,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5098,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 11:35:42.385110',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5099,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 11:35:45.336453',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5100,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 11:35:45.310269',189,72,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5101,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 11:35:45.320245',185,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5102,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 11:35:45.305845',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5103,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 12:02:31.241552',98,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5104,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 12:02:31.257455',134,74,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5105,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 12:02:31.268222',138,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5106,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 12:02:31.277639',262,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5107,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 12:08:47.385338',96,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5108,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 12:08:47.389332',144,74,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5109,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 12:08:47.394333',162,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5110,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 12:08:47.398829',268,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5111,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 12:11:06.785778',157,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5112,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 12:11:06.801535',159,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 12:11:06.798600',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5114,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 12:11:06.791229',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5115,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 12:13:46.528659',162,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5116,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 12:13:46.516935',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5117,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 12:13:46.519893',174,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5118,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 12:13:46.530634',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5119,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 12:13:49.040801',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5120,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 12:13:49.048189',172,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5121,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 12:13:49.025253',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5122,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 13:35:10.149203',147,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5123,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 13:35:10.143914',173,77,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5124,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 13:35:10.138097',193,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5125,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 13:35:10.147761',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5126,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 13:52:25.073167',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5127,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 13:52:25.086509',140,79,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5128,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 13:52:25.067817',180,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5129,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 13:52:25.071873',258,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5130,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 14:03:35.427094',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5131,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 14:03:35.427987',153,79,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5132,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 14:03:35.441549',174,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5133,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 14:03:35.430435',310,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5134,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 14:27:52.198617',145,79,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5135,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 14:27:52.204942',151,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5136,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 14:27:52.213471',168,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5137,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 14:27:52.203537',279,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5138,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 15:18:04.213297',157,82,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5139,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 15:18:04.215187',176,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5140,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 15:18:04.211415',167,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5141,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 15:18:04.227047',265,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5142,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 15:18:55.381482',103,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5143,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 15:18:55.416172',129,82,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5144,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 15:18:55.422076',154,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5145,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 15:18:55.412419',266,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5146,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 16:02:44.229190',190,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5147,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 16:02:44.247981',181,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5148,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 16:02:44.256796',177,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5149,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 16:02:44.239969',329,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5150,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 16:06:27.713908',154,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5151,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 16:06:27.705426',190,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5152,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 16:06:27.721829',177,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5153,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 16:06:27.718473',310,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5154,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 17:12:29.971261',190,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5155,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 17:12:29.977600',179,88,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5156,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 17:12:29.980490',193,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5157,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 17:12:29.975990',310,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5158,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 17:27:11.008193',111,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5159,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 17:27:11.018720',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5160,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 17:27:11.019408',178,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5161,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 17:27:11.015419',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5162,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 17:27:22.057359',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5163,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 17:27:22.072878',152,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5164,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 17:27:22.087505',152,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5165,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 17:27:22.086286',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5166,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 17:27:24.955186',109,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5167,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 17:27:24.952310',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5168,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 17:27:24.960336',163,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5169,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 17:27:24.978948',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5170,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 18:11:28.902648',163,89,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5171,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 18:11:28.903180',168,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5172,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 18:11:28.906825',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5173,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 18:11:28.905022',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5174,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 18:29:03.034424',148,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5175,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 18:29:03.036538',163,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5176,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 18:29:03.038245',192,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5177,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 18:29:03.033053',348,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5178,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 20:16:15.792797',214,96,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5179,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 20:16:15.814983',200,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5180,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 20:16:15.813005',337,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5181,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 20:16:15.810401',474,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5182,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 20:34:59.616502',171,99,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5183,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 20:34:59.613084',194,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5184,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 20:34:59.609966',213,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5185,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 20:34:59.617783',333,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5186,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 21:08:28.189918',158,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5187,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 21:08:28.177953',176,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5188,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 21:08:28.172702',236,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5189,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 21:08:28.186711',329,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5190,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 21:42:39.836552',198,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5191,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 21:42:39.846989',185,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5192,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 21:42:39.849731',189,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5193,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 21:42:39.830313',349,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5194,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 21:42:50.303751',251,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5195,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 21:42:50.314010',231,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5196,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 21:42:50.329303',341,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5197,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 21:42:50.315950',421,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5198,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 22:41:05.925297',194,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5199,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 22:41:05.937765',189,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5200,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 22:41:05.935976',223,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5201,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 22:41:05.925743',330,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5202,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 22:42:48.185605',142,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5203,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 22:42:48.163271',185,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5204,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 22:42:48.197025',181,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5205,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 22:42:48.176424',324,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5206,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 22:53:26.151409',168,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5207,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 22:53:26.130103',200,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5208,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 22:53:26.135373',207,104,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5209,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 22:53:26.137237',345,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5210,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 22:55:49.448118',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5211,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 22:55:49.445910',220,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5212,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 22:55:49.427146',245,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5213,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 22:55:49.415754',408,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5214,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:03:51.109168',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5215,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:03:51.097598',193,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5216,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:03:51.107544',204,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5217,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:03:51.096975',367,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5218,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:04:02.625455',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5219,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:04:02.636289',177,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5220,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:04:02.619907',191,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5221,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:04:02.626618',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:04:05.237959',162,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5223,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:04:05.253959',159,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5224,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:04:05.240543',183,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5225,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:04:05.241350',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5226,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:05:28.051179',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5227,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:05:28.054372',134,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5228,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:05:28.060696',226,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5229,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:05:28.070964',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5230,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:14:33.502630',172,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5231,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:14:33.498787',181,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5232,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:14:33.498654',197,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5233,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:14:33.499765',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5234,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:30:49.328133',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5235,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:30:49.338301',192,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5236,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:30:49.349963',189,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5237,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:30:49.305345',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5238,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:30:53.895119',169,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5239,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:30:53.891514',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5240,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:30:53.897607',181,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5241,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:30:53.889455',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5242,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:31:00.470873',181,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5243,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:31:00.468828',191,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5244,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:31:00.475704',187,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5245,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:31:00.459113',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5246,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:31:03.597326',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5247,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:31:03.610594',191,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5248,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:31:03.612387',204,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5249,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:31:03.612423',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5250,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-04 23:35:32.102239',107,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5251,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-04 23:35:32.095288',162,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5252,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-04 23:35:32.105154',158,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5253,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-04 23:35:32.114828',319,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5254,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:00:49.114544',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5255,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:00:49.127832',181,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5256,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:00:49.148079',165,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5257,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:00:49.120388',371,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5258,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:21:14.137650',179,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5259,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:21:14.139310',211,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5260,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:21:14.164551',205,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5261,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:21:14.140664',385,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:36:05.979844',207,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5263,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:36:05.974313',206,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5264,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:36:05.975138',215,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5265,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:36:05.967754',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5266,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:42:54.784818',193,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5267,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:42:54.784693',183,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5268,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:42:54.826403',170,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5269,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:42:54.781351',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5270,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:43:02.638335',96,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5271,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:43:02.651401',151,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5272,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:43:02.638972',171,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5273,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:43:02.640623',343,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5274,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:43:06.584353',183,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5275,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:43:06.595249',189,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5276,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:43:06.598105',202,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5277,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:43:06.591542',337,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5278,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:44:05.997659',110,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5279,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:44:06.015347',165,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5280,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:44:05.998794',210,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5281,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:44:06.012372',363,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5282,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 00:57:37.096281',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5283,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 00:57:37.110773',187,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5284,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 00:57:37.093643',220,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5285,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 00:57:37.105132',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5286,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:22:02.651550',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5287,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:22:02.661434',192,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5288,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:22:02.664101',172,109,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5289,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:22:02.654735',289,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5290,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:42:55.836268',183,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5291,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:42:55.883054',157,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5292,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:42:55.897450',166,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5293,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:42:55.823420',326,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5294,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:50:03.607175',185,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:50:03.642011',184,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5296,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:50:03.614330',235,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5297,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:50:03.616001',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5298,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:50:06.633523',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5299,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:50:06.625842',126,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5300,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:50:06.621048',190,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5301,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:50:06.636384',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5302,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:50:14.821712',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5303,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:50:14.816106',150,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5304,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:50:14.811819',166,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5305,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:50:14.805308',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:50:17.639077',171,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5307,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:50:17.622539',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5308,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:50:17.637245',190,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5309,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:50:17.630868',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 02:58:23.916125',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5311,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 02:58:23.931350',170,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5312,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 02:58:23.925282',204,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5313,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 02:58:23.927325',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5314,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 03:10:11.249764',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5315,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 03:10:11.247551',186,112,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5316,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 03:10:11.233529',209,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5317,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 03:10:11.236557',385,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5318,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 04:01:50.547540',286,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5319,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 04:01:50.549490',315,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5320,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 04:01:50.548796',412,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5321,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 04:01:50.526627',463,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5322,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 04:01:54.623152',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5323,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 04:01:54.615208',178,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5324,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 04:01:54.608799',209,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5325,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 04:01:54.626139',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5326,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 04:02:00.346844',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5327,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 04:02:00.351057',152,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5328,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 04:02:00.360557',153,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5329,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 04:02:00.326490',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5330,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 04:02:03.257418',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5331,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 04:02:03.266029',173,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5332,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 04:02:03.255693',195,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5333,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 04:02:03.269273',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5334,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 05:53:13.165098',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5335,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 05:53:13.167021',193,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5336,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 05:53:13.150509',220,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5337,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 05:53:13.153317',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5338,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 05:53:21.106915',147,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5339,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 05:53:21.098405',193,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5340,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 05:53:21.102628',199,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5341,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 05:53:21.100257',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5342,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 05:53:24.017714',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5343,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 05:53:23.997472',164,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5344,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 05:53:24.019399',182,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5345,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 05:53:24.008034',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:08:39.818299',162,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5347,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:08:39.844309',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5348,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:08:39.845514',188,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5349,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:08:39.822280',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5350,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:21:29.247846',193,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5351,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:21:29.267989',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5352,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:21:29.247861',214,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5353,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:21:29.258412',354,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5354,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:23:02.161011',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5355,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:23:02.171477',230,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5356,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:23:02.167205',255,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5357,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:23:02.174762',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5358,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:23:05.011754',167,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5359,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:23:05.011788',213,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5360,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:23:05.009769',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5361,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:23:04.997945',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5362,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:26:28.943848',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5363,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:26:28.956919',161,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5364,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:26:28.953975',174,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5365,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:26:28.946973',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:35:09.707550',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5367,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:35:09.783188',183,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5368,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:35:09.778363',196,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5369,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:35:09.744382',368,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5370,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:35:41.012220',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5371,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:35:40.988193',205,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5372,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:35:40.999043',203,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5373,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:35:41.006368',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5374,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:35:47.828230',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5375,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:35:47.846170',177,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5376,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:35:47.835259',226,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5377,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:35:47.853203',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5378,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 06:52:53.835764',160,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 06:52:53.834810',189,124,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5380,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 06:52:53.830451',288,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5381,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 06:52:53.837069',350,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5382,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:00:35.085375',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5383,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:00:35.103440',176,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5384,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:00:35.088871',221,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5385,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:00:35.101282',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5386,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:00:38.590271',185,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5387,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:00:38.602415',259,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5388,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:00:38.606375',306,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5389,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:00:38.602741',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5390,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:18:21.526948',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5391,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:18:21.526332',170,126,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5392,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:18:21.525363',206,81,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5393,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:18:21.525591',349,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5394,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:19:16.030459',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5395,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:19:16.029156',177,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5396,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:19:16.028687',182,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5397,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:19:16.049363',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5398,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:19:18.829876',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5399,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:19:18.838053',189,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5400,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:19:18.851798',166,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5401,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:19:18.835500',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5402,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:32:59.318895',52,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5403,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:32:59.400552',185,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5404,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:32:59.402207',202,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5405,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:32:59.393940',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5406,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:50:23.931754',201,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5407,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:50:23.927536',203,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5408,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:50:23.924274',240,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5409,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:50:23.930622',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5410,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:56:17.781220',210,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5411,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:56:17.775165',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5412,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:56:17.752329',292,81,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5413,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:56:17.769716',435,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5414,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:58:04.473810',133,126,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5415,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:58:04.483432',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5416,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:58:04.484172',171,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5417,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:58:04.485399',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5418,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:58:09.342475',187,126,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5419,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:58:09.324264',180,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5420,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:58:09.325448',226,81,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5421,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:58:09.333870',337,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5422,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 07:59:54.810925',145,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5423,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 07:59:54.812905',172,81,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5424,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 07:59:54.805125',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5425,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 07:59:54.799462',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5426,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:08:43.051738',131,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5427,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:08:43.047086',191,5,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5428,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:08:43.062200',201,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5429,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:08:43.053539',329,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:23:17.763244',237,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5431,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:23:17.782356',228,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5432,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:23:17.779069',315,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5433,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:23:17.752045',388,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5434,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:31:05.631398',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5435,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:31:05.633374',150,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5436,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:31:05.628440',215,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5437,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:31:05.619872',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5438,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:34:44.977944',146,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5439,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:34:44.990830',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5440,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:34:44.976487',187,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5441,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:34:44.988614',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5442,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:35:30.015683',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5443,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:35:29.999485',166,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5444,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:35:30.022236',169,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5445,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:35:30.004270',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5446,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:35:55.952740',114,28,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5447,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:35:55.941854',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5448,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:35:55.940577',216,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5449,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:35:55.932000',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5450,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 08:44:25.357228',178,34,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5451,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 08:44:25.354972',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5452,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 08:44:25.346203',214,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5453,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 08:44:25.360532',312,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5454,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 09:26:11.887683',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 09:26:11.874324',163,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5456,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 09:26:11.878052',174,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5457,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 09:26:11.879762',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5458,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 09:26:24.908183',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5459,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 09:26:24.906736',168,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5460,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 09:26:24.905302',161,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5461,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 09:26:24.897576',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5462,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 09:35:39.188237',171,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5463,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 09:35:39.186173',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5464,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 09:35:39.198236',187,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5465,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 09:35:39.176718',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5466,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 09:47:56.411463',99,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5467,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 09:47:56.486189',140,47,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5468,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 09:47:56.489331',146,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5469,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 09:47:56.493012',261,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5470,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 10:11:25.460840',103,52,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5471,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 10:11:25.464183',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5472,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 10:11:25.458128',181,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5473,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 10:11:25.457177',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5474,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 10:14:34.599018',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5475,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 10:14:34.600687',140,54,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5476,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 10:14:34.587837',166,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5477,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 10:14:34.597259',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5478,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 10:16:19.388825',165,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5479,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 10:16:19.380908',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5480,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 10:16:19.387090',176,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5481,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 10:16:19.385869',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5482,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 10:23:27.076559',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5483,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 10:23:27.065963',187,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5484,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 10:23:27.079093',198,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5485,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 10:23:27.077526',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5486,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 11:07:17.364008',165,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5487,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 11:07:17.370444',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5488,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 11:07:17.381672',163,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5489,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 11:07:17.372817',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5490,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 12:00:25.944824',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5491,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 12:00:25.950720',198,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5492,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 12:00:25.964371',207,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5493,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 12:00:25.963313',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5494,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 12:00:39.522746',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5495,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 12:00:39.536889',160,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5496,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 12:00:39.538943',162,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5497,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 12:00:39.536947',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5498,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 12:00:42.283130',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5499,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 12:00:42.326889',131,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5500,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 12:00:42.312746',169,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5501,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 12:00:42.299890',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5502,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 12:15:09.963226',106,67,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5503,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 12:15:09.986567',137,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5504,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 12:15:09.997551',143,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5505,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 12:15:09.973682',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5506,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 12:21:16.846654',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5507,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 12:21:16.846754',164,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5508,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 12:21:16.862099',192,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5509,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 12:21:16.844793',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5510,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 16:05:11.549122',170,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5511,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 16:05:11.558062',177,79,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5512,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 16:05:11.536230',210,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5513,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 16:05:11.552062',330,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5514,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 17:48:36.182973',133,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5515,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 17:48:36.169032',198,82,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5516,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 17:48:36.161507',237,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5517,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 17:48:36.187463',348,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5518,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 17:48:41.390351',192,82,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5519,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 17:48:41.384877',206,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5520,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 17:48:41.407343',209,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5521,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 17:48:41.388318',261,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5522,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 18:02:31.338050',125,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5523,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 18:02:31.322961',153,82,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5524,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 18:02:31.313984',189,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5525,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 18:02:31.317451',349,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5526,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 19:28:14.568369',221,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5527,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 19:28:14.578220',192,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5528,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 19:28:14.581692',224,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5529,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 19:28:14.571486',358,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5530,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 20:51:15.427092',107,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5531,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 20:51:15.424921',177,87,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5532,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 20:51:15.427236',180,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5533,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 20:51:15.424256',313,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5534,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 21:09:17.860294',194,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5535,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 21:09:17.863116',213,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5536,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 21:09:17.864117',228,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5537,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 21:09:17.868746',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5538,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 21:12:02.533470',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5539,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 21:12:02.543622',211,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5540,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 21:12:02.541793',226,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5541,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 21:12:02.552887',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5542,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 21:12:05.508368',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5543,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 21:12:05.515265',169,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5544,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 21:12:05.519017',219,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5545,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 21:12:05.506212',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5546,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 21:49:27.150796',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5547,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 21:49:27.170145',180,91,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5548,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 21:49:27.185160',200,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5549,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 21:49:27.172512',364,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5550,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:03:06.200575',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5551,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:03:06.242979',144,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5552,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:03:06.220336',173,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5553,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:03:06.208368',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5554,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:17:35.756157',173,91,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5555,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:17:35.769339',162,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5556,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:17:35.764489',178,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5557,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:17:35.765954',322,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5558,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:25:21.835034',154,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5559,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:25:21.832385',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5560,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:25:21.892931',285,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5561,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:25:21.913083',388,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5562,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:25:24.927223',142,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5563,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:25:24.924058',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5564,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:25:24.946202',169,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5565,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:25:24.934245',390,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5566,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:26:52.892028',239,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5567,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:26:52.899500',245,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5568,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:26:52.905278',323,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5569,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:26:52.867279',461,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5570,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:39:07.617671',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5571,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:39:07.611807',153,91,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5572,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:39:07.615891',178,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5573,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:39:07.626839',284,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5574,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:52:28.852960',56,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5575,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:52:28.964755',126,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5576,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:52:28.956742',142,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5577,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:52:28.851418',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5578,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:52:32.012538',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5579,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:52:31.983205',159,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5580,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:52:32.000627',194,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5581,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:52:32.003150',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5582,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:52:40.278523',173,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5583,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:52:40.286824',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5584,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:52:40.288366',188,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5585,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:52:40.293262',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5586,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:52:43.104310',68,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5587,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:52:43.189229',131,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5588,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:52:43.189739',149,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5589,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:52:43.200148',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5590,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 22:53:40.709680',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5591,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 22:53:40.716378',167,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5592,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 22:53:40.710806',202,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5593,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 22:53:40.707428',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5594,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 23:04:51.759198',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5595,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 23:04:51.770417',179,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5596,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 23:04:51.792141',210,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5597,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 23:04:51.731877',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5598,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 23:26:35.599435',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5599,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 23:26:35.616904',185,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5600,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 23:26:35.605984',206,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5601,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 23:26:35.599768',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5602,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 23:26:47.844301',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5603,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 23:26:47.851824',182,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5604,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 23:26:47.842833',222,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5605,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 23:26:47.852464',357,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5606,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 23:26:50.022718',274,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5607,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 23:26:50.007461',305,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5608,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 23:26:50.017360',368,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5609,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 23:26:50.020354',540,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5610,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 23:53:49.780081',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5611,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 23:53:49.851105',166,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5612,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 23:53:49.795378',260,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5613,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 23:53:49.853066',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5614,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-05 23:54:45.504463',164,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5615,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-05 23:54:45.525991',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5616,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-05 23:54:45.511989',214,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5617,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-05 23:54:45.506440',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:04:10.986432',170,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5619,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:04:10.974008',173,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5620,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:04:10.974882',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5621,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:04:10.989388',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5622,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:08:15.678003',155,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5623,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:08:15.671771',185,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5624,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:08:15.717459',185,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5625,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:08:15.664036',331,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5626,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:08:26.523965',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5627,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:08:26.515532',154,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5628,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:08:26.539773',155,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5629,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:08:26.532245',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5630,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:08:30.236992',155,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5631,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:08:30.261697',187,96,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5632,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:08:30.245930',310,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5633,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:08:30.277717',401,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5634,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:31:19.184017',172,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5635,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:31:19.195613',247,96,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5636,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:31:19.221537',225,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5637,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:31:19.219761',371,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5638,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:32:00.662432',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5639,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:32:00.668923',190,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5640,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:32:00.651508',221,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5641,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:32:00.687519',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5642,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:52:38.052756',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5643,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:52:38.051321',216,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5644,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:52:38.066115',205,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5645,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:52:38.054242',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5646,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:52:42.289499',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5647,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:52:42.285569',155,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5648,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:52:42.279431',168,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5649,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:52:42.289102',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5650,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:53:01.425396',173,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5651,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:53:01.422252',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5652,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:53:01.433249',189,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5653,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:53:01.437202',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5654,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:53:04.386554',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5655,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:53:04.383775',168,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5656,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:53:04.403028',176,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5657,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:53:04.356901',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5658,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 00:53:39.180940',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5659,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 00:53:39.180384',166,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5660,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 00:53:39.189245',179,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5661,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 00:53:39.182915',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5662,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 01:11:34.204246',114,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5663,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 01:11:34.202438',169,99,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5664,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 01:11:34.222515',167,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5665,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 01:11:34.209444',333,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5666,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 01:55:57.224313',170,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5667,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 01:55:57.239322',207,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5668,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 01:55:57.248061',196,104,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5669,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 01:55:57.227299',357,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5670,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 01:56:02.466411',163,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5671,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 01:56:02.470097',173,104,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5672,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 01:56:02.478543',192,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5673,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 01:56:02.468164',345,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5674,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 01:56:13.621705',176,104,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5675,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 01:56:13.653962',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5676,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 01:56:13.640223',189,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5677,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 01:56:13.605539',345,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5678,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 01:56:14.821677',77,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5679,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 01:56:14.817891',93,104,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5680,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 01:56:14.817891',140,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5681,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 02:05:05.183473',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5682,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 02:05:05.198068',181,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5683,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 02:05:05.212317',204,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5684,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 02:05:05.202959',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5685,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 02:05:11.167458',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5686,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 02:05:11.178783',147,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5687,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 02:05:11.293101',119,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5688,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 02:05:11.162848',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5689,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 02:32:59.914077',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5690,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 02:32:59.896007',232,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5691,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 02:32:59.911056',219,105,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5692,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 02:32:59.893184',387,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 02:33:03.119438',138,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5694,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 02:33:03.093881',173,105,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5695,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 02:33:03.090004',188,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5696,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 02:33:03.085497',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5697,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 02:33:04.854770',144,105,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5698,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 02:33:04.843957',185,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5699,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 02:33:04.860463',175,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5700,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 02:33:04.841647',323,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5701,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 02:56:34.166543',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5702,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 02:56:34.161423',186,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5703,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 02:56:34.154156',161,105,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5704,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 02:56:34.179872',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5705,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:05:25.086093',136,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5706,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:05:25.067190',213,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5707,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:05:25.087435',205,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5708,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:05:25.059339',315,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5709,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:12:15.402936',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5710,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:12:15.421346',191,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5711,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:12:15.402238',218,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5712,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:12:15.431397',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:31:38.861379',207,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5714,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:31:38.862179',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5715,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:31:38.859467',234,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5716,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:31:38.859467',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5717,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:38:56.823665',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5718,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:38:56.837167',176,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5719,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:38:56.840596',171,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5720,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:38:56.828172',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5721,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:47:48.476358',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5722,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:47:48.473292',165,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5723,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:47:48.468625',201,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5724,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:47:48.477855',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5725,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:49:43.145837',157,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5726,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:49:43.150084',180,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5727,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:49:43.156265',188,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5728,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:49:43.151667',314,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5729,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:51:02.618131',111,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5730,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:51:02.616262',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5731,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:51:02.608351',186,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5732,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:51:02.617063',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5733,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:54:31.371481',147,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5734,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:54:31.370224',157,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5735,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:54:31.359985',189,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5736,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:54:31.373370',275,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5737,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 03:59:12.135335',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5738,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 03:59:12.141351',159,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5739,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 03:59:12.140413',183,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5740,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 03:59:12.142332',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5741,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:04:38.744635',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5742,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:04:38.761193',148,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5743,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:04:38.728902',179,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5744,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:04:38.710414',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5745,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:11:15.185524',154,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5746,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:11:15.218463',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5747,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:11:15.207404',178,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5748,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:11:15.206266',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5749,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:13:03.461262',89,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5750,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:13:03.464120',170,82,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5751,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:13:03.453599',184,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5752,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:13:03.464056',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5753,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:14:14.083444',168,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5754,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:14:14.081491',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5755,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:14:14.068298',204,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5756,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:14:14.081658',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5757,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:27:55.511820',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5758,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:27:55.509801',167,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5759,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:27:55.494102',221,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5760,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:27:55.489978',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5761,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:27:58.486528',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5762,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:27:58.541545',162,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5763,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:27:58.563058',136,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5764,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:27:58.484626',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5765,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:28:06.574689',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5766,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:28:06.678767',123,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5767,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:28:06.675605',128,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5768,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:28:06.577319',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5769,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:28:09.576937',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5770,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:28:09.558989',185,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5771,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:28:09.556336',217,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5772,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:28:09.558621',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5773,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:33:59.294957',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5774,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:33:59.305681',196,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5775,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:33:59.312988',188,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5776,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:33:59.316744',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5777,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 04:45:28.531540',174,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5778,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 04:45:28.529218',195,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5779,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 04:45:28.524929',180,112,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5780,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 04:45:28.538821',352,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 05:03:09.729052',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5782,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 05:03:09.745596',148,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5783,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 05:03:09.741557',190,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5784,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 05:03:09.740067',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5785,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 05:06:28.424971',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5786,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 05:06:28.433161',219,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5787,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 05:06:28.434326',239,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5788,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 05:06:28.435722',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5789,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 05:09:36.020135',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5790,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 05:09:36.028496',184,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5791,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 05:09:36.026042',199,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5792,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 05:09:36.011765',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5793,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 05:21:41.021300',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5794,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 05:21:41.066365',177,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5795,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 05:21:41.045479',222,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5796,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 05:21:41.030520',354,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5797,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 05:26:10.967820',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5798,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 05:26:10.988863',182,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5799,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 05:26:10.962521',215,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5800,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 05:26:10.969230',263,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5801,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 05:47:25.876322',164,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5802,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 05:47:25.893614',177,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5803,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 05:47:25.883768',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5804,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 05:47:25.887081',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5805,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:07:57.190227',160,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5806,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:07:57.201358',180,82,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:07:57.208228',207,114,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5808,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:07:57.178849',316,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5809,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:10:17.639762',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5810,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:10:17.658045',187,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5811,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:10:17.675114',186,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5812,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:10:17.659787',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5813,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:26:42.388483',194,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5814,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:26:42.396291',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5815,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:26:42.372884',227,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5816,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:26:42.363167',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5817,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:26:47.488058',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5818,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:26:47.482513',178,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5819,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:26:47.490332',194,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5820,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:26:47.485313',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5821,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:26:53.373211',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5822,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:26:53.374045',179,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5823,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:26:53.366893',186,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5824,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:26:53.375118',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5825,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:32:00.645152',192,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5826,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:32:00.636144',169,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5827,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:32:00.625685',198,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5828,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:32:00.635167',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5829,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 06:35:04.014505',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5830,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 06:35:03.985972',185,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5831,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 06:35:03.983771',186,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5832,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 06:35:03.983793',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:08:33.202332',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:08:33.224939',164,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5835,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:08:33.239019',169,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5836,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:08:33.212343',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5837,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:08:44.903121',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5838,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:08:44.904185',164,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5839,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:08:44.897038',183,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5840,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:08:44.913932',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5841,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:08:47.880396',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5842,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:08:47.892231',187,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5843,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:08:47.880233',215,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5844,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:08:47.903247',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5845,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:12:25.070404',154,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5846,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:12:25.077612',173,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5847,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:12:25.055824',205,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL);
INSERT INTO `query_execution` VALUES (5848,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:12:25.039427',375,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5849,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:12:35.823244',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5850,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:12:35.830077',194,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5851,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:12:35.831997',168,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5852,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:12:35.828486',294,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5853,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:12:39.248659',189,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5854,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:12:39.248946',179,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5855,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:12:39.250691',198,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5856,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:12:39.260881',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5857,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:16:02.251097',113,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5858,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:16:02.233828',195,82,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5859,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:16:02.240296',161,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5860,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:16:02.209179',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5861,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:31:30.700157',145,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5862,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:31:30.705527',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5863,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:31:30.715462',179,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5864,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:31:30.705265',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5865,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:45:44.550407',176,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:45:44.538781',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5867,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:45:44.532728',229,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:45:44.540863',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5869,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 07:57:36.592524',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5870,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 07:57:36.595274',165,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5871,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 07:57:36.591533',165,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5872,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 07:57:36.592851',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 08:00:46.390414',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5874,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 08:00:46.380878',165,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5875,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 08:00:46.385026',171,82,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5876,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 08:00:46.397966',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5877,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 08:18:24.152398',154,17,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5878,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 08:18:24.150097',194,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5879,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 08:18:24.148247',187,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 08:18:24.147254',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 08:37:35.673434',141,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5882,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 08:37:35.666085',181,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5883,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 08:37:35.660319',186,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5884,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 08:37:35.675061',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5885,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 08:56:08.625149',161,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5886,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 08:56:08.610490',185,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5887,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 08:56:08.601823',212,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5888,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 08:56:08.608881',357,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5889,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 09:03:07.850098',191,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5890,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 09:03:07.845310',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5891,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 09:03:07.861786',173,42,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 09:03:07.850667',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5893,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 09:04:21.728035',166,42,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5894,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 09:04:21.717239',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5895,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 09:04:21.718621',187,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5896,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 09:04:21.713257',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5897,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 09:36:13.641021',100,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5898,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 09:36:13.774439',122,50,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5899,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 09:36:13.746789',159,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5900,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 09:36:13.639789',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5901,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 09:37:29.570354',165,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5902,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 09:37:29.571961',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5903,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 09:37:29.561868',197,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 09:37:29.573208',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 09:45:50.806929',72,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5906,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 09:45:50.902561',138,53,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5907,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 09:45:50.900386',147,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5908,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 09:45:50.895796',312,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5909,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:02:17.386296',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5910,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:02:17.371197',194,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5911,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:02:17.381981',203,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5912,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:02:17.370758',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5913,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:03:19.320539',143,58,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5914,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:03:19.321875',161,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5915,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:03:19.328274',162,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:03:19.330989',261,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:07:21.822784',153,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5918,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:07:21.831189',180,58,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5919,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:07:21.839698',179,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5920,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:07:21.828395',277,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5921,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:12:37.384548',131,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5922,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:12:37.402819',152,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5923,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:12:37.389303',171,61,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5924,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:12:37.391688',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5925,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:13:06.108676',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5926,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:13:06.104340',159,61,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:13:06.109994',167,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5928,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:13:06.110994',283,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5929,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:16:21.379773',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5930,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:16:21.396449',145,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5931,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:16:21.374268',174,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5932,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:16:21.384036',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5933,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:41:39.624259',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5934,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:41:39.646372',145,65,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5935,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:41:39.646470',165,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5936,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:41:39.635172',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5937,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 10:58:48.704363',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5938,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 10:58:48.698964',186,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5939,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 10:58:48.693234',185,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5940,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 10:58:48.690634',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 11:09:46.463277',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5942,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 11:09:46.461233',177,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5943,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 11:09:46.461452',189,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5944,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 11:09:46.463742',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5945,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 11:17:09.677227',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5946,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 11:17:09.706646',108,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5947,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 11:17:09.695356',208,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5948,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 11:17:09.687263',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5949,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 13:16:28.260480',83,73,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5950,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 13:16:28.250603',146,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5951,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 13:16:28.263259',152,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5952,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 13:16:28.266604',268,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5953,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 13:19:40.533321',163,73,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5954,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 13:19:40.546521',155,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5955,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 13:19:40.548749',161,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 13:19:40.524975',323,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5957,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 16:46:14.715024',114,83,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5958,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 16:46:14.748772',156,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5959,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 16:46:14.744817',172,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5960,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 16:46:14.702261',302,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 18:15:38.304348',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5962,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 18:15:38.313938',173,91,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5963,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 18:15:38.316247',188,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5964,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 18:15:38.317364',358,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5965,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 18:16:10.444906',135,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5966,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 18:16:10.460654',141,91,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5967,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 18:16:10.445677',199,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5968,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 18:16:10.445097',322,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5969,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 18:32:05.960519',213,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5970,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 18:32:05.948923',253,92,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5971,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 18:32:05.959332',288,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5972,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 18:32:05.955893',398,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5973,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 19:27:23.645121',155,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5974,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 19:27:23.640910',223,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5975,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 19:27:23.648278',195,96,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5976,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 19:27:23.611938',341,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5977,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 20:02:46.439425',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5978,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 20:02:46.477318',154,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5979,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 20:02:46.479108',175,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5980,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 20:02:46.468506',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5981,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 20:25:00.430472',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5982,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 20:25:00.437898',150,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5983,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 20:25:00.426898',188,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 20:25:00.428395',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5985,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 20:25:18.335263',144,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5986,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 20:25:18.331564',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5987,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 20:25:18.344473',197,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5988,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 20:25:18.324327',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5989,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 20:25:21.194767',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5990,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 20:25:21.225205',142,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5991,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 20:25:21.209481',180,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5992,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 20:25:21.207336',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5993,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 20:38:24.964055',192,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 20:38:24.984734',160,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5995,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 20:38:24.983506',184,98,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 20:38:24.957051',293,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5997,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 21:38:43.853351',170,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 21:38:43.848548',184,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(5999,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 21:38:43.846854',185,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6000,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 21:38:43.838024',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6001,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:06:55.837807',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6002,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:06:55.844753',157,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6003,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:06:55.840376',200,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6004,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:06:55.875532',290,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6005,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:07:08.060359',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6006,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:07:08.067004',181,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6007,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:07:08.054060',200,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6008,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:07:08.061420',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6009,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:07:12.092511',162,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6010,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:07:12.081834',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6011,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:07:12.073455',226,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6012,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:07:12.094182',350,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6013,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:20:17.062384',153,106,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6014,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:20:17.063401',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6015,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:20:17.075021',173,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6016,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:20:17.077967',328,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6017,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:31:51.671928',176,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6018,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:31:51.668443',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6019,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:31:51.673567',218,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:31:51.672910',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:33:04.936138',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6022,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:33:04.938922',193,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6023,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:33:04.933718',214,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6024,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:33:04.934869',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6025,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:40:37.800056',184,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6026,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:40:37.790092',196,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6027,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:40:37.791928',236,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6028,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:40:37.801535',348,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6029,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:44:26.212898',145,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6030,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:44:26.208878',152,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6031,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:44:26.202650',177,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:44:26.226020',250,0,_binary '','dashboard','减少结果行数的错误。null',13371341,29,2,NULL,2,NULL,NULL,NULL,NULL),(6033,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 22:44:38.303807',171,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6034,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 22:44:38.325677',151,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6035,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 22:44:38.317231',176,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6036,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 22:44:38.298775',364,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6037,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 23:08:03.004120',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6038,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 23:08:03.005705',233,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6039,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 23:08:03.008310',260,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6040,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 23:08:03.007565',363,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6041,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 23:17:18.853236',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6042,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 23:17:18.875905',163,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6043,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 23:17:18.862526',178,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6044,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 23:17:18.863326',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6045,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 23:24:28.531007',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 23:24:28.522449',202,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6047,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 23:24:28.544489',193,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6048,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 23:24:28.518854',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6049,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-06 23:26:14.853954',164,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6050,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-06 23:26:14.840472',187,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6051,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-06 23:26:14.843751',205,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6052,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-06 23:26:14.846719',354,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6053,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:02:31.554126',178,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6054,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:02:31.549614',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6055,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:02:31.550936',194,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6056,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:02:31.544109',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6057,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:04:24.167686',176,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6058,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:04:24.163387',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6059,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:04:24.180312',203,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6060,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:04:24.170302',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6061,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:04:28.067167',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6062,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:04:28.060888',188,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:04:28.068736',175,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6064,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:04:28.074731',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6065,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:12:16.802117',163,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6066,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:12:16.803259',187,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6067,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:12:16.799169',181,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6068,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:12:16.791840',309,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6069,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:12:27.928763',196,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6070,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:12:27.936468',205,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6071,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:12:27.944222',231,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6072,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:12:27.932381',331,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6073,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:12:32.040910',181,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6074,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:12:32.056470',206,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6075,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:12:32.048127',234,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6076,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:12:32.043519',358,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6077,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:30:25.242700',152,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6078,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:30:25.258192',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6079,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:30:25.260897',214,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6080,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:30:25.247545',364,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6081,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 00:30:28.205299',142,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6082,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 00:30:28.206271',156,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6083,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 00:30:28.203058',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6084,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 00:30:28.171319',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6085,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 01:25:55.164829',159,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6086,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 01:25:55.149051',215,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6087,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 01:25:55.163288',228,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6088,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 01:25:55.154191',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6089,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 01:48:08.339678',206,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6090,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 01:48:08.360507',172,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6091,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 01:48:08.334694',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6092,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 01:48:08.352102',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6093,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:06:44.847506',296,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6094,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:06:44.820048',358,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6095,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:06:44.848206',391,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6096,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:06:44.828270',666,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6097,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:06:45.426504',150,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6098,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:06:45.440540',206,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6099,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:06:45.412363',257,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6100,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:06:45.445576',369,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6101,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:23:41.665451',215,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6102,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:23:41.648434',241,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6103,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:23:41.650977',305,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:23:41.639798',393,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:28:13.107465',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6106,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:28:13.096543',217,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6107,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:28:13.126903',193,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6108,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:28:13.110655',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6109,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:37:00.913930',155,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6110,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:37:00.904482',177,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6111,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:37:00.906343',194,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6112,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:37:00.898136',306,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:52:53.427284',122,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6114,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:52:53.423311',181,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6115,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:52:53.431151',175,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6116,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:52:53.435265',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:53:04.773929',207,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:53:04.788483',204,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6119,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:53:04.774147',306,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6120,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:53:04.775863',353,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6121,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 02:53:09.432550',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6122,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 02:53:09.416821',182,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6123,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 02:53:09.417753',187,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6124,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 02:53:09.429470',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:06:27.412991',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6126,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:06:27.419428',180,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6127,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:06:27.432467',178,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6128,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:06:27.401551',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6129,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:07:38.846843',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6130,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:07:38.831854',177,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6131,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:07:38.830659',221,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6132,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:07:38.831101',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6133,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:19:13.503531',87,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6134,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:19:13.499542',129,120,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6135,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:19:13.498473',216,83,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6136,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:19:13.501389',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6137,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:25:53.955939',192,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6138,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:25:53.966097',202,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6139,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:25:53.959342',233,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6140,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:25:53.958743',365,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6141,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:28:12.880365',146,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6142,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:28:12.912019',174,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6143,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:28:12.884390',242,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6144,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:28:12.892157',320,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6145,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:48:45.046374',192,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6146,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:48:45.059912',219,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6147,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:48:45.061661',241,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6148,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:48:45.061656',376,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6149,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 03:48:46.871839',182,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6150,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 03:48:46.872985',189,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6151,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 03:48:46.899163',162,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6152,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 03:48:46.868502',337,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6153,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:00:14.585226',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6154,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:00:14.620022',153,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6155,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:00:14.589923',196,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6156,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:00:14.610674',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6157,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:08:04.672829',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6158,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:08:04.694993',151,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6159,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:08:04.708072',159,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6160,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:08:04.697268',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6161,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:11:10.132000',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6162,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:11:10.127965',180,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6163,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:11:10.147536',197,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:11:10.148340',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6165,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:19:22.693176',172,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6166,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:19:22.696099',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6167,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:19:22.708292',193,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6168,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:19:22.688633',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6169,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:41:42.537113',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6170,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:41:42.533728',199,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6171,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:41:42.538726',212,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6172,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:41:42.546013',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6173,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:41:53.521027',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6174,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:41:53.537164',161,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6175,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:41:53.505504',205,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:41:53.529783',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6177,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:41:56.389486',47,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6178,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:41:56.409394',169,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6179,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:41:56.405517',187,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6180,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:41:56.406971',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6181,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:42:52.407270',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6182,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:42:52.432849',173,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6183,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:42:52.425687',197,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6184,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:42:52.382840',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6185,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:42:55.659422',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6186,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:42:55.676303',163,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6187,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:42:55.669549',173,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6188,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:42:55.656288',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6189,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:49:44.268726',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6190,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:49:44.268761',137,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6191,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:49:44.284514',177,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6192,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:49:44.272012',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6193,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:49:49.010431',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6194,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:49:49.025676',207,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6195,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:49:49.015873',249,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6196,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:49:49.027565',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6197,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:49:55.081990',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6198,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:49:55.144318',154,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6199,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:49:55.145254',201,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6200,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:49:55.148329',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6201,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:49:57.935163',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6202,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:49:57.956371',175,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6203,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:49:57.949318',174,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6204,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:49:57.952952',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6205,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 04:55:06.718544',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6206,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 04:55:06.732905',179,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6207,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 04:55:06.728109',185,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6208,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 04:55:06.742394',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6209,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:13:49.029727',177,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6210,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:13:49.026776',214,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6211,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:13:49.031208',231,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6212,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:13:49.033418',365,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6213,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:24:15.535042',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6214,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:24:15.511278',227,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6215,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:24:15.522617',231,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6216,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:24:15.502375',385,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6217,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:27:35.559361',174,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6218,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:27:35.580246',157,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6219,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:27:35.567120',183,83,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6220,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:27:35.564569',353,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6221,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:36:41.201050',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:36:41.207298',151,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6223,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:36:41.201975',173,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6224,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:36:41.203563',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6225,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:36:52.363394',215,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6226,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:36:52.363799',229,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6227,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:36:52.365263',239,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6228,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:36:52.377445',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6229,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:36:55.339417',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6230,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:36:55.314365',193,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6231,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:36:55.331455',219,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6232,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:36:55.320113',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6233,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:49:17.182134',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6234,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:49:17.178698',199,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6235,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:49:17.185342',229,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6236,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:49:17.191758',357,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6237,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:49:28.443526',61,0,_binary '','dashboard','减少结果行数的错误。null',13371345,31,2,NULL,2,NULL,NULL,NULL,NULL),(6238,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:49:28.455025',61,0,_binary '','dashboard','减少结果行数的错误。null',13371345,29,2,NULL,2,NULL,NULL,NULL,NULL),(6239,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:49:28.465792',111,0,_binary '','dashboard','减少结果行数的错误。null',13371345,30,2,NULL,2,NULL,NULL,NULL,NULL),(6240,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:49:28.394506',201,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6241,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 05:49:41.014470',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6242,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 05:49:41.031383',178,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6243,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 05:49:41.029310',192,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6244,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 05:49:40.998160',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6245,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:02:31.330293',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6246,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:02:31.352206',190,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6247,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:02:31.328615',223,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6248,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:02:31.338573',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6249,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:07:39.233409',183,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6250,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:07:39.237323',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6251,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:07:39.222929',213,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6252,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:07:39.235694',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6253,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:07:42.136968',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6254,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:07:42.151407',185,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6255,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:07:42.140141',207,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6256,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:07:42.151917',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6257,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:09:31.308219',181,124,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6258,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:09:31.296255',205,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6259,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:09:31.309301',200,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6260,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:09:31.306076',368,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6261,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:12:41.451573',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:12:41.463085',171,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6263,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:12:41.449130',208,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6264,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:12:41.453822',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6265,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:13:09.226216',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6266,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:13:09.304257',172,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6267,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:13:09.303682',200,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6268,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:13:09.221978',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6269,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:19:44.008918',60,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6270,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:19:44.050957',152,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6271,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:19:44.049340',168,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6272,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:19:44.045348',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6273,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:33:27.842058',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6274,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:33:27.833898',189,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6275,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:33:27.843283',203,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6276,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:33:27.844806',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6277,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:33:30.728725',118,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6278,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:33:30.719362',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6279,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:33:30.760264',153,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6280,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:33:30.737425',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6281,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:46:09.831141',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6282,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:46:09.832086',176,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6283,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:46:09.840609',203,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6284,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:46:09.828286',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6285,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:46:46.182245',101,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6286,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:46:46.186962',149,124,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6287,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:46:46.186306',177,83,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6288,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:46:46.197156',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:48:31.747336',157,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6290,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:48:31.740854',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6291,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:48:31.745870',167,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6292,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:48:31.749029',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6293,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:55:38.916777',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6294,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:55:38.921995',180,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6295,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:55:38.933195',200,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6296,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:55:38.924069',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6297,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:57:55.997238',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6298,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:57:56.043908',184,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6299,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:57:56.072970',171,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6300,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:57:56.055481',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6301,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:58:05.037067',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6302,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 06:58:05.079876',156,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6303,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 06:58:05.112530',130,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6304,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 06:58:05.040556',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6305,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 06:58:06.163959',45,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 07:05:19.045250',121,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6307,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 07:05:19.039705',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6308,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 07:05:19.042072',205,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6309,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 07:05:19.047862',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 07:05:36.478895',189,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6311,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 07:05:36.479885',196,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6312,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 07:05:36.481111',228,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6313,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 07:05:36.481762',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 07:17:40.385565',162,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6315,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 07:17:40.388817',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6316,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 07:17:40.376124',215,83,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6317,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 07:17:40.381019',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6318,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:08:09.286406',135,1,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6319,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:08:09.294007',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6320,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:08:09.307024',186,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6321,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:08:09.286847',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6322,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:08:47.621034',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6323,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:08:47.598537',189,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6324,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:08:47.629194',142,1,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6325,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:08:47.610571',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6326,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:20:03.770344',183,8,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6327,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:20:03.775219',178,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6328,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:20:03.778789',173,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6329,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:20:03.761476',339,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6330,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:20:09.102800',139,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6331,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:20:09.115336',203,8,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6332,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:20:09.117674',199,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6333,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:20:09.106550',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6334,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:20:12.423528',145,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6335,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:20:12.420777',262,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6336,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:26:46.349410',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6337,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:26:46.356442',169,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6338,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:26:46.352212',181,19,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6339,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:26:46.361454',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6340,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:33:34.621025',165,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6341,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:33:34.640297',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6342,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:33:34.628024',200,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6343,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:33:34.629169',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6344,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:35:11.056529',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6345,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:35:11.066149',187,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:35:11.068594',194,23,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6347,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:35:11.063150',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6348,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:38:11.664772',113,23,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6349,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:38:11.667449',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6350,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:38:11.676495',220,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6351,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:38:11.656892',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6352,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:50:28.993284',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6353,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:50:29.004201',174,27,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6354,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:50:28.991197',221,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6355,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:50:29.005700',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6356,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:53:09.479773',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6357,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:53:09.488265',142,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6358,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:53:09.485167',177,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6359,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:53:09.496619',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6360,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 08:56:20.847023',94,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6361,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 08:56:20.883483',156,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6362,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 08:56:20.886710',188,31,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6363,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 08:56:20.873298',336,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6364,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:04:36.064233',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6365,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:04:36.092530',133,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6366,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:04:36.107034',162,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6367,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:04:36.081840',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6368,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:11:57.694974',169,33,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6369,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:11:57.693148',176,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6370,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:11:57.696959',174,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6371,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:11:57.691642',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6372,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:12:11.092296',83,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6373,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:12:11.211793',119,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6374,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:12:11.190892',136,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6375,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:12:11.119553',278,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6376,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:21:18.516081',102,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6377,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:21:18.511136',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6378,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:21:18.564965',169,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6379,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:21:18.542770',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6380,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:36:20.316140',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6381,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:36:20.317334',125,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6382,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:36:20.314554',194,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6383,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:36:20.312131',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6384,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:44:01.012564',155,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6385,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:44:01.023381',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6386,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:44:01.017297',187,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6387,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:44:01.020143',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6388,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:50:56.344434',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6389,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:50:56.355017',122,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6390,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:50:56.358948',149,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6391,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:50:56.347250',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6392,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 09:57:18.259324',148,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6393,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 09:57:18.276883',215,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6394,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 09:57:18.268988',238,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6395,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 09:57:18.262816',374,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6396,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 10:23:36.696380',207,48,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 10:23:36.701185',227,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6398,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 10:23:36.685627',264,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6399,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 10:23:36.696126',371,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6400,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 10:23:48.530392',60,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6401,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 10:23:48.607405',169,48,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6402,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 10:23:48.621397',164,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6403,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 10:23:48.619385',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6404,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 10:30:31.775949',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6405,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 10:30:31.772101',117,48,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6406,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 10:30:31.780501',169,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6407,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 10:30:31.810730',285,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6408,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:06:57.486896',184,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6409,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:06:57.480208',180,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6410,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:06:57.493283',200,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6411,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:06:57.481218',349,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6412,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:07:01.513396',125,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6413,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:07:01.542984',155,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6414,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:07:01.532715',182,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6415,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:07:01.533346',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6416,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:07:09.332312',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6417,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:07:09.352361',156,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6418,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:07:09.361733',157,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6419,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:07:09.359574',250,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6420,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:17:17.715963',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:17:17.711936',162,52,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6422,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:17:17.714211',189,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6423,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:17:17.712540',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6424,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:18:30.955913',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6425,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:18:30.958069',99,52,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6426,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:18:30.956789',171,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6427,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:18:30.952954',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6428,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:18:42.442480',195,52,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:18:42.440656',225,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6430,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:18:42.454131',299,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6431,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:18:42.427332',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6432,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:18:44.463126',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6433,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:18:44.467095',107,52,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6434,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:18:44.463134',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6435,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:25:09.166025',135,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6436,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:25:09.168015',169,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6437,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:25:09.173460',174,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6438,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:25:09.165938',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6439,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:29:21.146999',101,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6440,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:29:21.163066',126,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6441,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:29:21.151872',155,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6442,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:29:21.161394',256,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6443,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:33:34.505683',94,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6444,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:33:34.515218',157,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6445,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:33:34.521853',157,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6446,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:33:34.508211',323,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6447,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:33:47.264335',187,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6448,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:33:47.294174',230,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6449,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:33:47.277957',285,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6450,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:33:47.286045',438,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6451,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:33:52.441233',110,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6452,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:33:52.445900',156,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6453,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:33:52.463420',156,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6454,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:33:52.443492',265,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 11:34:04.810062',168,52,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6456,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 11:34:04.819146',175,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6457,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 11:34:04.819571',194,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6458,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 11:34:04.820262',260,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6459,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 12:37:07.459394',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6460,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 12:37:07.505085',149,54,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6461,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 12:37:07.477687',184,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6462,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 12:37:07.469677',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6463,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 12:55:30.903313',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6464,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 12:55:30.888959',188,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6465,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 12:55:30.895747',167,54,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6466,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 12:55:30.893597',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6467,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 15:23:26.870358',189,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6468,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 15:23:26.867054',175,64,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6469,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 15:23:26.859158',197,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6470,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 15:23:26.878820',296,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6471,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 15:23:29.883254',153,64,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6472,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 15:23:29.904892',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6473,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 15:23:29.887150',202,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6474,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 15:23:29.903618',258,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6475,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 17:08:58.772693',137,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6476,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 17:08:58.770946',164,70,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6477,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 17:08:58.758678',198,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6478,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 17:08:58.765256',346,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6479,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 18:27:13.829384',84,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6480,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 18:27:13.844031',141,74,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6481,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 18:27:13.841831',165,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6482,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 18:27:13.838671',264,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6483,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 19:18:06.858882',149,75,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6484,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 19:18:06.854198',156,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6485,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 19:18:06.850240',190,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6486,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 19:18:06.852114',318,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6487,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 20:53:10.349813',142,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6488,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 20:53:10.368396',203,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6489,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 20:53:10.375933',243,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6490,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 20:53:10.358683',328,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6491,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 21:11:25.823702',198,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6492,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 21:11:25.843987',193,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6493,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 21:11:25.849390',180,85,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6494,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 21:11:25.827165',380,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6495,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 21:17:03.514436',161,86,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6496,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 21:17:03.515348',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6497,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 21:17:03.521403',327,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6498,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 21:17:03.508237',381,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6499,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 21:18:30.467133',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6500,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 21:18:30.473652',145,86,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6501,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 21:18:30.473347',186,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6502,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 21:18:30.475325',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6503,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 21:18:33.304518',173,86,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6504,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 21:18:33.316060',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6505,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 21:18:33.310810',201,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6506,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 21:18:33.306292',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6507,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 21:21:53.522274',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6508,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 21:21:53.533805',176,86,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6509,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 21:21:53.535479',198,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6510,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 21:21:53.534075',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6511,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 21:25:20.543594',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6512,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 21:25:20.545766',204,87,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6513,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 21:25:20.541284',222,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6514,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 21:25:20.539109',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6515,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:27:28.540785',166,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6516,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:27:28.543202',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6517,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:27:28.550936',188,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6518,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:27:28.552753',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6519,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:27:41.003629',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6520,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:27:41.018907',154,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6521,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:27:40.999400',189,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6522,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:27:41.032571',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6523,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:27:43.042817',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6524,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:27:43.034234',195,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6525,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:27:43.121017',150,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6526,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:27:43.029693',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6527,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:32:58.330819',118,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6528,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:32:58.325757',162,98,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6529,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:32:58.323488',175,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6530,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:32:58.335748',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6531,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:45:13.056074',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6532,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:45:13.076731',198,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6533,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:45:13.063477',213,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6534,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:45:13.073295',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6535,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:52:50.700713',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6536,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:52:50.720775',206,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6537,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:52:50.740088',213,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6538,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:52:50.719540',371,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6539,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 22:53:20.230323',155,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6540,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 22:53:20.243702',163,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6541,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 22:53:20.262142',188,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6542,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 22:53:20.239172',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6543,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 23:19:03.008418',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6544,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 23:19:02.978937',198,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6545,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 23:19:02.995383',180,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6546,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 23:19:02.982421',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6547,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 23:38:06.527382',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6548,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 23:38:06.515196',145,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6549,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 23:38:06.508876',225,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6550,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 23:38:06.504176',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6551,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 23:54:13.475669',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6552,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 23:54:13.499269',142,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6553,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 23:54:13.484677',186,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6554,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 23:54:13.491443',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6555,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 23:56:33.332643',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6556,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 23:56:33.356197',150,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6557,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 23:56:33.355147',160,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6558,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 23:56:33.335825',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6559,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 23:56:44.542651',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6560,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 23:56:44.619508',145,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6561,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 23:56:44.608131',163,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6562,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 23:56:44.598243',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6563,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-07 23:56:47.431225',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6564,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-07 23:56:47.422182',201,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6565,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-07 23:56:47.432862',238,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6566,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-07 23:56:47.422810',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6567,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:15:53.088372',191,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6568,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:15:53.096640',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6569,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:15:53.100726',210,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6570,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:15:53.088273',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6571,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:34:04.204116',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6572,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:34:04.216386',150,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6573,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:34:04.206289',217,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6574,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:34:04.198263',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6575,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:49:42.129384',177,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6576,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:49:42.128383',206,106,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6577,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:49:42.138790',204,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6578,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:49:42.128437',361,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6579,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:50:17.133892',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6580,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:50:17.132255',155,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6581,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:50:17.119468',204,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6582,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:50:17.132379',359,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6583,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:50:28.367728',153,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6584,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:50:28.379213',160,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6585,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:50:28.380181',190,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6586,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:50:28.380816',293,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6587,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:50:33.338303',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6588,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:50:33.347858',187,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6589,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:50:33.335612',259,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6590,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:50:33.335915',278,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6591,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:55:37.596072',205,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6592,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:55:37.598020',192,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6593,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:55:37.591245',207,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6594,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:55:37.587114',348,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6595,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 00:57:22.454940',150,107,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6596,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 00:57:22.468829',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6597,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 00:57:22.517908',157,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6598,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 00:57:22.472138',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6599,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 01:20:37.133856',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6600,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 01:20:37.146143',180,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6601,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 01:20:37.149929',201,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6602,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 01:20:37.142171',393,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6603,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 01:20:48.525045',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6604,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 01:20:48.533927',170,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6605,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 01:20:48.546497',170,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6606,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 01:20:48.515944',372,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6607,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 01:55:20.721564',167,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6608,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 01:55:20.712153',190,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6609,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 01:55:20.726890',179,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6610,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 01:55:20.724510',349,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6611,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 01:55:26.584222',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6612,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 01:55:26.587142',173,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6613,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 01:55:26.593359',194,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6614,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 01:55:26.578895',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6615,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 01:55:30.409889',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6616,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 01:55:30.438565',165,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6617,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 01:55:30.447359',183,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6618,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 01:55:30.428171',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6619,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:00:46.828041',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6620,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:00:46.865576',172,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6621,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:00:46.866658',165,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6622,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:00:46.835312',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6623,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:11:15.510036',208,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6624,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:11:15.521019',204,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6625,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:11:15.503766',254,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6626,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:11:15.524087',354,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6627,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:12:59.561388',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6628,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:12:59.570874',179,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6629,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:12:59.564312',229,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6630,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:12:59.570275',350,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6631,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:22:00.106232',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6632,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:22:00.128495',184,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6633,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:22:00.111569',269,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6634,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:22:00.125487',369,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6635,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:28:11.244615',130,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6636,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:28:11.258030',168,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6637,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:28:11.255407',187,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6638,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:28:11.273072',290,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6639,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:29:11.293940',187,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6640,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:29:11.295163',194,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6641,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:29:11.290481',196,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6642,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:29:11.280042',290,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6643,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:57:42.312325',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6644,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:57:42.329508',199,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:57:42.319517',197,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6646,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:57:42.320804',366,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6647,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 02:57:58.151345',248,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6648,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 02:57:58.162027',268,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6649,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 02:57:58.174891',277,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6650,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 02:57:58.176238',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6651,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:13:36.052958',136,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6652,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:13:36.065531',207,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6653,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:13:36.053477',207,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6654,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:13:36.073279',306,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6655,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:26:51.666727',233,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6656,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:26:51.665458',249,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6657,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:26:51.676646',321,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6658,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:26:51.664004',371,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6659,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:26:59.673607',95,118,_binary '','question',NULL,13371345,30,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6660,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:30:31.344919',226,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6661,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:30:31.359368',220,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6662,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:30:31.355962',232,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6663,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:30:31.340108',363,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6664,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:36:26.124662',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6665,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:36:26.121841',205,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6666,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:36:26.115489',225,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6667,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:36:26.122716',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6668,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:41:56.682012',131,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6669,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:41:56.688558',151,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6670,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:41:56.685227',205,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6671,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:41:56.692300',321,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6672,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:55:20.016262',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6673,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:55:20.044237',198,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6674,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:55:20.048427',210,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6675,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:55:20.007123',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6676,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 03:55:31.716499',114,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6677,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 03:55:31.723972',140,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6678,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 03:55:31.726313',183,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 03:55:31.734637',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6680,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:10:12.037983',135,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:10:12.025651',167,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6682,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:10:12.027111',201,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6683,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:10:12.039265',315,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6684,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:17:32.268150',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6685,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:17:32.274489',173,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6686,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:17:32.290810',193,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6687,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:17:32.290959',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6688,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:44:04.615651',172,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6689,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:44:04.619859',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6690,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:44:04.604609',231,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:44:04.618153',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6692,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:44:16.778659',153,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:44:16.776885',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6694,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:44:16.789256',219,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6695,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:44:16.780178',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6696,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:44:19.676778',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6697,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:44:19.662600',165,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6698,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:44:19.666277',164,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6699,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:44:19.653939',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6700,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:51:02.825518',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6701,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:51:02.820525',191,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6702,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:51:02.828408',192,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:51:02.836828',319,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6704,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:57:40.550951',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6705,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:57:40.569538',202,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6706,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:57:40.560290',236,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6707,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:57:40.564889',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6708,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:57:43.470691',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6709,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:57:43.456418',161,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6710,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:57:43.474282',168,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6711,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:57:43.456511',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6712,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 04:59:37.369793',174,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 04:59:37.383541',154,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6714,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 04:59:37.375350',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 04:59:37.377973',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6716,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:13:40.575268',136,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6717,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:13:40.584431',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6718,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:13:40.567854',216,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6719,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:13:40.579690',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6720,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:23:56.196260',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6721,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:23:56.209082',186,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6722,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:23:56.220190',204,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6723,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:23:56.216648',382,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6724,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:24:15.840016',206,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6725,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:24:15.844837',200,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6726,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:24:15.844887',213,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:24:15.860476',376,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6728,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:26:25.936475',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6729,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:26:25.935994',170,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6730,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:26:25.937842',188,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6731,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:26:25.932438',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6732,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:27:27.494252',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6733,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:27:27.510230',154,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6734,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:27:27.508598',186,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6735,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:27:27.494274',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6736,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:30:32.783199',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6737,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:30:32.780181',228,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6738,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:30:32.784310',239,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6739,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:30:32.773786',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6740,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 05:42:42.528404',181,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6741,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 05:42:42.540316',159,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6742,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 05:42:42.538314',202,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6743,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 05:42:42.520715',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6744,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:22:59.587106',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6745,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:22:59.596020',173,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6746,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:22:59.587901',225,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6747,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:22:59.596517',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6748,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:50:25.994751',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6749,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:50:26.005169',162,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6750,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:50:26.006134',196,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6751,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:50:26.007198',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6752,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:50:46.204776',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6753,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:50:46.216045',153,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6754,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:50:46.223071',169,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6755,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:50:46.224510',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6756,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:50:56.421301',191,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6757,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:50:56.415964',211,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6758,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:50:56.419239',245,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6759,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:50:56.417442',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6760,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:50:59.945921',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6761,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:50:59.923493',214,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6762,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:50:59.929495',198,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6763,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:50:59.961354',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6764,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:52:28.224804',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6765,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:52:28.230639',191,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6766,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:52:28.227767',209,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6767,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:52:28.216122',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6768,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 06:55:27.793845',122,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6769,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 06:55:27.795164',183,128,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6770,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 06:55:27.799013',185,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6771,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 06:55:27.788143',354,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6772,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:14:34.475180',176,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6773,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:14:34.458756',220,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6774,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:14:34.462963',220,128,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6775,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:14:34.449444',373,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6776,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:17:42.186475',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6777,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:17:42.183823',169,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6778,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:17:42.192369',201,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6779,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:17:42.180155',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6780,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:20:16.532365',85,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6781,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:20:16.605503',79,0,_binary '','dashboard','减少结果行数的错误。null',13371340,31,2,NULL,2,NULL,NULL,NULL,NULL),(6782,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:20:16.570830',122,0,_binary '','dashboard','减少结果行数的错误。null',13371340,29,2,NULL,2,NULL,NULL,NULL,NULL),(6783,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:20:16.581637',160,128,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6784,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:20:24.055666',84,128,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6785,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:20:24.058431',119,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6786,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:20:28.511744',94,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6787,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:20:28.556490',181,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6788,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:20:28.569561',158,128,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6789,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:20:28.519039',353,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6790,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:21:03.842955',69,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6791,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:21:03.848048',172,128,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6792,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:21:03.883601',190,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6793,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:21:03.848841',370,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6794,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:21:26.972834',147,128,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6795,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:21:26.990012',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6796,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:21:26.963954',198,84,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6797,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:21:26.996935',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6798,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:29:10.856862',181,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6799,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:29:10.855352',188,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6800,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:29:10.860876',217,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6801,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:29:10.860798',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6802,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:30:51.310873',165,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6803,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:30:51.296446',191,128,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6804,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:30:51.303990',216,84,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6805,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:30:51.294295',314,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6806,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:31:05.822684',144,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:31:05.824330',186,128,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6808,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:31:05.826115',220,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6809,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:31:05.837070',319,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6810,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:34:18.560629',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6811,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:34:18.597874',139,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6812,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:34:18.589254',180,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6813,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:34:18.573689',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6814,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:34:38.640686',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6815,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:34:38.641479',176,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6816,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:34:38.669156',153,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6817,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:34:38.637415',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:36:12.641022',119,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6819,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:36:12.658459',167,128,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6820,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:36:12.647332',190,84,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6821,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:36:12.645119',330,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6822,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:40:11.793143',53,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6823,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:40:11.829712',142,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6824,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:40:11.825555',152,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6825,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:40:11.828053',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6826,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 07:58:14.200634',67,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6827,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 07:58:14.277361',144,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6828,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 07:58:14.277120',160,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6829,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 07:58:14.279392',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6830,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:01:19.437437',93,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6831,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:01:19.427369',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6832,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:01:19.449941',227,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6833,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:01:19.430763',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6834,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:01:32.902247',214,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6835,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:01:32.909757',228,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6836,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:01:32.920085',224,84,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6837,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:01:32.912465',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6838,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:02:03.065119',147,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6839,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:02:03.059806',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6840,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:02:03.066264',182,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6841,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:02:03.069086',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6842,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:09:30.738451',175,5,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6843,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:09:30.754691',168,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6844,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:09:30.743790',193,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6845,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:09:30.743198',298,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6846,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:52:57.743233',212,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6847,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:52:57.745314',233,38,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6848,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:52:57.723943',285,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6849,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:52:57.732142',404,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6850,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:55:05.932091',174,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6851,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:55:05.952404',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6852,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:55:05.937505',189,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6853,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:55:05.941709',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6854,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 08:55:19.063845',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6855,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 08:55:19.081046',140,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6856,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 08:55:19.069318',161,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6857,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 08:55:19.076802',260,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6858,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 09:04:44.932214',62,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6859,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 09:04:44.994920',116,42,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6860,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 09:04:45.143090',120,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6861,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 09:04:44.998913',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6862,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 09:04:48.191445',105,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6863,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 09:04:48.178655',114,42,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6864,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 09:04:48.175432',271,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6865,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 09:14:28.834197',133,44,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 09:14:28.838339',180,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6867,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 09:14:28.854288',201,85,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 09:14:28.823064',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6869,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 09:56:55.302217',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6870,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 09:56:55.308373',217,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6871,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 09:56:55.317017',213,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6872,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 09:56:55.301287',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 10:03:01.219440',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6874,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 10:03:01.227146',162,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6875,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 10:03:01.225929',193,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6876,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 10:03:01.211601',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6877,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 10:15:57.574748',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6878,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 10:15:57.571095',183,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6879,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 10:15:57.576544',197,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 10:15:57.572238',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 10:45:01.499075',224,55,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6882,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 10:45:01.489356',259,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6883,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 10:45:01.503833',251,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6884,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 10:45:01.513707',405,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6885,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 12:13:23.708923',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 12:13:23.732523',171,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6887,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 12:13:23.737857',177,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6888,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 12:13:23.714737',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6889,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 12:13:34.411314',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6890,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 12:13:34.410219',156,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6891,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 12:13:34.414207',184,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 12:13:34.403227',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6893,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 12:13:37.949991',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6894,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 12:13:37.951767',180,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6895,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 12:13:37.959836',186,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6896,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 12:13:37.941293',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6897,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 12:13:50.330913',193,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6898,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 12:13:50.315895',235,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6899,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 12:13:50.301543',377,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6900,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 12:13:50.380593',420,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6901,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 12:27:10.510221',124,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6902,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 12:27:10.514124',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6903,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 12:27:10.517487',192,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 12:27:10.505881',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 19:06:35.258837',78,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6906,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 19:06:35.339465',132,78,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6907,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 19:06:35.341464',152,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6908,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 19:06:35.334994',346,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6909,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 19:06:40.952558',159,78,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6910,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 19:06:40.962062',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6911,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 19:06:40.964458',190,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6912,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 19:06:40.962718',341,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6913,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 19:06:46.549494',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6914,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 19:06:46.546559',185,78,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6915,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 19:06:46.551264',187,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 19:06:46.547179',341,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 19:06:50.375350',145,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6918,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 19:06:50.445151',284,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6919,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 19:06:50.426792',412,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6920,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 19:07:03.477564',132,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6921,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 19:07:03.485605',214,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 19:07:03.475488',220,78,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6923,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 19:07:03.468226',394,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6924,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 19:38:21.725460',154,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6925,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 19:38:21.743925',210,78,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6926,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 19:38:21.717306',286,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6927,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 19:38:21.722605',348,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6928,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:10:57.059945',121,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6929,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:10:57.067771',171,79,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6930,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:10:57.115448',191,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6931,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:10:57.064986',332,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6932,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:17:51.401943',116,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6933,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:17:51.403523',192,80,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6934,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:17:51.406604',194,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6935,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:17:51.401264',302,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6936,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:53:36.837224',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6937,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:53:36.829058',180,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6938,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:53:36.840850',202,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6939,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:53:36.843079',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6940,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:53:40.131558',175,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:53:40.142713',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6942,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:53:40.130884',186,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6943,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:53:40.133328',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6944,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:53:56.621006',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6945,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:53:56.633438',152,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6946,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:53:56.641965',169,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6947,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:53:56.614916',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6948,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:53:59.489511',180,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6949,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:53:59.494611',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6950,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:53:59.504439',199,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6951,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:53:59.512550',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6952,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:56:41.684871',200,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6953,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:56:41.679053',196,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:56:41.682501',187,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6955,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:56:41.680675',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6956,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:57:32.010528',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6957,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:57:31.998031',170,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6958,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:57:32.009284',181,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6959,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:57:31.994026',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6960,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 20:57:43.011649',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6961,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 20:57:43.016577',166,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6962,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 20:57:43.002470',186,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6963,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 20:57:43.010784',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6964,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 21:16:35.539875',202,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6965,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 21:16:35.535230',191,81,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6966,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 21:16:35.555489',195,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6967,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 21:16:35.569577',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6968,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 21:34:08.157036',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6969,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 21:34:08.169934',170,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6970,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 21:34:08.166660',176,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6971,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 21:34:08.158348',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6972,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 21:37:53.080434',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6973,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 21:37:53.077649',167,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6974,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 21:37:53.093146',169,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6975,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 21:37:53.090791',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6976,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 21:52:41.059165',177,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6977,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 21:52:41.052914',196,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6978,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 21:52:41.050552',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6979,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 21:52:41.044863',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6980,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 21:52:53.291919',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6981,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 21:52:53.297522',162,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6982,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 21:52:53.296618',174,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6983,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 21:52:53.294415',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6984,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 21:52:56.142885',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6985,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 21:52:56.150323',149,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6986,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 21:52:56.146142',178,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6987,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 21:52:56.142208',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6988,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 22:28:19.348999',140,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6989,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 22:28:19.333349',175,85,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6990,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 22:28:19.337839',182,85,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6991,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 22:28:19.339751',278,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6992,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 23:17:44.399787',172,86,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6993,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 23:17:44.399905',183,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6994,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 23:17:44.411984',184,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6995,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 23:17:44.401132',294,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6996,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-08 23:20:09.193031',146,86,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-08 23:20:09.175608',171,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6998,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-08 23:20:09.191196',211,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(6999,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-08 23:20:09.181079',327,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7000,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 00:06:01.203031',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7001,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 00:06:01.221030',169,88,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7002,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 00:06:01.240984',144,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7003,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 00:06:01.209936',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7004,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 00:18:29.947608',166,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7005,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 00:18:29.953875',174,89,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7006,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 00:18:29.936318',216,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7007,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 00:18:29.936020',357,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7008,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 00:18:33.890775',125,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7009,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 00:18:33.888441',298,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7010,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 00:27:50.767866',164,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7011,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 00:27:50.785293',184,90,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7012,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 00:27:50.766054',252,85,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7013,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 00:27:50.763161',360,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7014,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 00:31:29.894644',143,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7015,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 00:31:29.910970',169,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7016,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 00:31:29.913003',208,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7017,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 00:31:29.900936',352,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 01:04:00.313747',186,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7019,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 01:04:00.308987',203,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7020,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 01:04:00.318739',229,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7021,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 01:04:00.323703',387,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7022,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 01:09:49.768503',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7023,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 01:09:49.758966',229,93,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7024,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 01:09:49.768111',237,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7025,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 01:09:49.771741',365,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7026,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 01:11:08.521091',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7027,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 01:11:08.501570',174,85,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7028,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 01:11:08.508016',162,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7029,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 01:11:08.512419',325,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7030,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 01:19:37.973165',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7031,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 01:19:37.964198',175,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7032,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 01:19:37.962566',195,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7033,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 01:19:37.974184',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7034,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 01:46:31.064907',174,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7035,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 01:46:31.054518',181,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7036,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 01:46:31.061109',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7037,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 01:46:31.061291',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7038,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 01:57:47.261915',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7039,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 01:57:47.308888',138,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7040,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 01:57:47.285236',207,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7041,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 01:57:47.305356',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7042,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 02:27:42.153032',157,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7043,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 02:27:42.160495',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7044,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 02:27:42.146082',214,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7045,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 02:27:42.150173',373,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 02:27:53.968203',159,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7047,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 02:27:53.970449',192,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7048,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 02:27:53.977939',189,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7049,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 02:27:53.964247',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7050,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 02:27:55.858179',140,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7051,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 02:27:55.897360',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7052,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 02:27:55.901205',188,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7053,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 02:27:55.877004',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7054,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 02:32:47.371682',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7055,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 02:32:47.410488',151,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7056,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 02:32:47.396411',190,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7057,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 02:32:47.409810',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7058,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 02:33:12.098656',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7059,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 02:33:12.111860',155,96,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7060,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 02:33:12.134082',194,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7061,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 02:33:12.103346',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7062,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 02:59:57.112357',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 02:59:57.128674',162,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7064,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 02:59:57.144009',161,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7065,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 02:59:57.127328',285,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7066,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 03:00:09.784471',187,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7067,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 03:00:09.788099',195,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7068,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 03:00:09.790555',191,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7069,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 03:00:09.789319',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7070,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 03:10:44.100976',184,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7071,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 03:10:44.092438',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7072,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 03:10:44.090429',204,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7073,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 03:10:44.106115',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7074,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 03:12:50.854091',205,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7075,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 03:12:50.851537',222,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7076,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 03:12:50.830484',263,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7077,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 03:12:50.856437',400,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7078,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 03:12:53.749098',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7079,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 03:12:53.827466',145,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7080,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 03:12:53.831571',195,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7081,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 03:12:53.802801',350,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7082,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 03:13:00.162819',186,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7083,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 03:13:00.186539',174,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7084,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 03:13:00.176842',217,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7085,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 03:13:00.172014',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7086,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 04:03:25.231620',192,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7087,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 04:03:25.249013',181,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7088,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 04:03:25.237693',212,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7089,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 04:03:25.224403',339,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7090,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 04:25:20.008451',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7091,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 04:25:20.014157',184,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7092,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 04:25:20.010374',199,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7093,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 04:25:20.009101',356,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7094,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 04:28:20.226430',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7095,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 04:28:20.207120',176,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7096,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 04:28:20.224338',161,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7097,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 04:28:20.212152',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7098,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 04:31:29.458577',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7099,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 04:31:29.457129',199,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7100,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 04:31:29.455119',308,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7101,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 04:31:29.458449',393,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7102,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 04:34:14.111904',176,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7103,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 04:34:14.127311',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7104,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 04:34:14.116064',181,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7105,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 04:34:14.124452',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7106,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 04:46:41.916996',166,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7107,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 04:46:41.915933',176,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7108,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 04:46:41.908104',198,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7109,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 04:46:41.912412',313,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7110,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 05:11:02.880550',108,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7111,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 05:11:02.890750',163,103,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7112,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 05:11:02.890154',174,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7113,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 05:11:02.890984',290,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7114,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 05:37:42.968251',154,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7115,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 05:37:42.964342',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7116,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 05:37:42.963044',196,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7117,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 05:37:42.958399',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7118,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 05:45:51.244451',182,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7119,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 05:45:51.251230',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7120,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 05:45:51.261950',185,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7121,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 05:45:51.244681',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7122,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 05:54:25.463884',191,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7123,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 05:54:25.453817',190,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7124,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 05:54:25.441426',222,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7125,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 05:54:25.449335',318,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7126,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 05:57:09.549101',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7127,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 05:57:09.542929',193,107,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7128,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 05:57:09.550507',218,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7129,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 05:57:09.533908',356,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7130,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:07:25.000498',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7131,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:07:25.004456',162,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7132,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:07:25.008310',201,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7133,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:07:25.009200',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7134,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:46:22.385024',140,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7135,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:46:22.382773',202,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7136,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:46:22.386728',210,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7137,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:46:22.374446',340,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7138,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:47:36.922259',190,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7139,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:47:36.926001',219,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7140,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:47:36.926525',222,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7141,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:47:36.926012',322,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7142,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:49:33.214377',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7143,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:49:33.197644',157,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7144,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:49:33.212604',173,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7145,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:49:33.201741',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7146,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:49:46.924606',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7147,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:49:46.907815',163,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7148,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:49:46.918369',188,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7149,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:49:46.910280',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7150,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:49:55.062087',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7151,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:49:55.059554',159,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7152,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:49:55.065054',182,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7153,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:49:55.061547',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7154,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 06:49:58.026504',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7155,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 06:49:58.034177',167,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7156,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 06:49:58.026512',190,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7157,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 06:49:58.032368',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7158,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:00:29.356993',161,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7159,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:00:29.352515',175,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7160,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:00:29.359693',167,85,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7161,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:00:29.353632',304,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7162,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:00:58.500152',180,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7163,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:00:58.510106',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7164,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:00:58.498244',251,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7165,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:00:58.504308',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7166,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:04:19.344357',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7167,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:04:19.354915',174,112,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7168,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:04:19.351147',170,85,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7169,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:04:19.341982',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7170,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:15:48.898198',173,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7171,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:15:48.914265',175,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7172,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:15:48.905745',204,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7173,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:15:48.895974',338,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7174,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:29:20.440567',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7175,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:29:20.439283',165,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7176,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:29:20.456227',189,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7177,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:29:20.424831',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7178,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:31:03.091082',170,114,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7179,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:31:03.079955',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7180,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:31:03.089359',195,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7181,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:31:03.084816',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7182,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:33:45.065894',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7183,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:33:45.079840',150,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7184,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:33:45.078362',187,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7185,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:33:45.074891',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7186,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:34:02.501253',157,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7187,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:34:02.487899',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7188,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:34:02.494428',192,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7189,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:34:02.491441',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7190,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:36:39.762274',171,115,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7191,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:36:39.755060',188,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7192,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:36:39.771263',211,85,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7193,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:36:39.753690',301,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7194,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:45:12.470355',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7195,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:45:12.489343',148,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7196,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:45:12.487948',186,85,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7197,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:45:12.475476',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7198,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 07:57:12.385298',136,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7199,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 07:57:12.373199',180,117,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7200,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 07:57:12.384139',220,85,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7201,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 07:57:12.369678',360,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7202,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:09:03.813011',219,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7203,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:09:03.825352',218,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7204,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:09:03.823140',265,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7205,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:09:03.812091',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7206,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:09:10.395252',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7207,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:09:10.436559',196,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7208,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:09:10.453165',296,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7209,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:09:10.413774',368,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7210,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:09:20.154004',149,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7211,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:09:20.150932',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7212,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:09:20.155153',192,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7213,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:09:20.168313',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7214,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:09:26.140313',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7215,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:09:26.153975',178,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7216,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:09:26.133535',194,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7217,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:09:26.148696',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7218,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:09:31.149279',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7219,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:09:31.149546',194,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7220,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:09:31.153825',197,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7221,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:09:31.140736',359,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:10:32.369209',146,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7223,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:10:32.383078',175,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7224,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:10:32.385560',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7225,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:10:32.366201',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7226,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:14:17.250755',133,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7227,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:14:17.255025',141,14,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7228,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:14:17.266705',154,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7229,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:14:17.256847',278,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7230,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:25:24.255611',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7231,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:25:24.239111',189,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7232,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:25:24.270214',155,20,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7233,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:25:24.254029',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7234,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:30:38.792546',167,20,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7235,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:30:38.794966',132,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7236,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:30:38.807706',166,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7237,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:30:38.787879',335,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7238,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:39:11.566771',163,30,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7239,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:39:11.572227',166,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7240,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:39:11.577159',193,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7241,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:39:11.574157',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7242,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:47:34.692973',89,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7243,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:47:34.705838',141,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7244,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:47:34.720437',160,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7245,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:47:34.720612',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7246,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:51:45.905138',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7247,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:51:45.903505',135,35,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7248,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:51:45.904229',209,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7249,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:51:45.913922',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7250,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:55:17.380175',168,37,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7251,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:55:17.393283',164,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7252,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:55:17.388797',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7253,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:55:17.386142',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7254,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:56:21.606335',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7255,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:56:21.608762',177,37,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7256,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:56:21.613717',211,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7257,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:56:21.619988',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7258,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 08:59:57.918722',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7259,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 08:59:57.916375',146,37,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7260,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 08:59:57.910929',175,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7261,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 08:59:57.916071',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:03:28.248291',139,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7263,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:03:28.239882',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7264,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:03:28.250428',150,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7265,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:03:28.254260',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7266,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:04:00.886785',136,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7267,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:04:00.875981',179,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7268,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:04:00.884962',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7269,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:04:00.891342',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7270,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:05:07.497734',168,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7271,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:05:07.504324',170,38,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7272,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:05:07.500074',175,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7273,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:05:07.495214',297,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7274,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:05:11.745861',126,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7275,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:05:11.775004',152,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7276,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:05:11.754727',184,38,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7277,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:05:11.737539',339,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7278,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:08:45.623138',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7279,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:08:45.641629',157,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7280,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:08:45.670808',146,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7281,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:08:45.634258',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7282,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:08:56.757703',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7283,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:08:56.770882',155,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7284,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:08:56.782288',175,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7285,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:08:56.779102',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7286,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:08:59.564303',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7287,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:08:59.565145',146,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7288,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:08:59.606250',156,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7289,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:08:59.561397',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7290,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:10:02.828278',157,38,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7291,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:10:02.816414',157,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7292,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:10:02.837336',163,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7293,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:10:02.818992',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7294,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:10:40.942269',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:10:40.950546',139,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7296,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:10:40.929399',168,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7297,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:10:40.937223',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7298,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:19:52.444304',169,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7299,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:19:52.440463',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7300,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:19:52.439603',168,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7301,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:19:52.439714',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7302,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:21:50.188681',240,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7303,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:21:50.238467',244,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7304,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:21:50.195430',408,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7305,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:21:50.198328',440,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:24:24.960421',146,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7307,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:24:24.956713',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7308,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:24:24.948537',192,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7309,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:24:24.957306',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:49:19.157389',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7311,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:49:19.153892',123,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7312,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:49:19.147230',185,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7313,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:49:19.144452',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7314,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:49:31.156386',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7315,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:49:31.156834',213,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7316,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:49:31.167860',172,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7317,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:49:31.178996',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7318,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:49:39.843334',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7319,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:49:39.836790',154,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7320,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:49:39.849118',189,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7321,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:49:39.844415',272,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7322,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:50:56.194025',72,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7323,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:50:56.192747',142,47,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7324,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:50:56.182561',154,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7325,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:50:56.184932',270,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7326,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:54:00.553401',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7327,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:54:00.566060',166,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7328,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:54:00.559564',171,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7329,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:54:00.559626',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7330,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 09:56:47.234051',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7331,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 09:56:47.235636',146,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7332,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 09:56:47.236969',154,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7333,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 09:56:47.243152',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7334,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 10:04:39.631003',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7335,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 10:04:39.633905',163,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7336,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 10:04:39.650961',184,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7337,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 10:04:39.628251',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7338,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 10:11:42.760372',77,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7339,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 10:11:42.794665',148,53,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7340,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 10:11:42.775477',175,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7341,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 10:11:42.783653',302,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7342,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 10:23:40.335609',84,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7343,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 10:23:40.345196',182,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7344,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 10:23:40.356275',185,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7345,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 10:23:40.338614',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7346,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 10:49:48.186100',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7347,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 10:49:48.188873',184,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7348,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 10:49:48.190722',179,58,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7349,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 10:49:48.186798',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7350,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 11:09:39.487136',121,61,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7351,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 11:09:39.485931',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7352,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 11:09:39.512824',174,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7353,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 11:09:39.496659',269,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7354,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 11:34:12.872947',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7355,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 11:34:12.857296',172,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7356,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 11:34:12.891803',204,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7357,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 11:34:12.889742',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7358,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:27:50.624055',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7359,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:27:50.703788',176,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7360,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 12:27:50.697505',195,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7361,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:27:50.656888',384,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7362,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:27:53.407499',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7363,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:27:53.424461',145,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7364,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 12:27:53.429557',175,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7365,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:27:53.410274',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:27:59.192244',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7367,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:27:59.240749',138,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7368,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 12:27:59.238559',169,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7369,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:27:59.226717',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7370,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:30:48.176366',164,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7371,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:30:48.163013',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7372,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 12:30:48.155892',194,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7373,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:30:48.158861',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7374,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:54:53.455324',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7375,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:54:53.425229',194,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7376,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 12:54:53.440651',194,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7377,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:54:53.432795',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7378,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:54:56.053078',85,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:54:56.057922',109,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7380,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:54:56.049154',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7381,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 12:55:05.197739',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7382,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 12:55:05.198818',211,67,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7383,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 12:55:05.216453',211,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7384,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 12:55:05.222473',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7385,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 17:16:10.190148',134,77,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7386,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 17:16:10.190784',172,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7387,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 17:16:10.181804',191,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7388,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 17:16:10.189462',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7389,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 17:27:08.452083',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7390,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 17:27:08.447053',152,77,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7391,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 17:27:08.465095',162,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7392,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 17:27:08.463983',284,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7393,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 17:27:29.260535',129,77,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7394,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 17:27:29.288476',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7395,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 17:27:29.283533',184,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7396,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 17:27:29.271635',277,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 18:42:53.293609',137,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7398,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 18:42:53.305520',171,84,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7399,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 18:42:53.304208',179,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7400,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 18:42:53.308225',327,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7401,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 18:56:21.686615',150,85,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7402,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 18:56:21.681674',147,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7403,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 18:56:21.703968',179,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7404,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 18:56:21.684001',315,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7405,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 20:00:11.076575',186,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7406,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 20:00:11.068955',195,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7407,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 20:00:11.068759',219,86,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7408,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 20:00:11.064327',328,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7409,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 20:26:34.637973',162,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7410,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 20:26:34.648759',176,89,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7411,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 20:26:34.644570',203,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7412,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 20:26:34.646099',290,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7413,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 20:35:40.713694',108,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7414,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 20:35:40.722130',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7415,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 20:35:40.741098',147,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7416,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 20:35:40.729789',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7417,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 20:35:51.793808',166,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7418,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 20:35:51.807814',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7419,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 20:35:51.800692',188,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7420,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 20:35:51.817039',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7421,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 20:35:54.617959',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7422,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 20:35:54.618449',183,89,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7423,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 20:35:54.640151',214,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7424,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 20:35:54.604848',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7425,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 21:24:59.226773',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7426,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 21:24:59.240807',183,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7427,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 21:24:59.249371',268,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7428,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 21:24:59.251025',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 21:57:16.869488',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 21:57:16.852551',185,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7431,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 21:57:16.859564',190,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7432,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 21:57:16.898505',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7433,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 21:57:28.707335',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7434,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 21:57:28.696644',177,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7435,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 21:57:28.708410',173,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7436,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 21:57:28.720523',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7437,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 21:57:32.352261',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7438,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 21:57:32.358510',196,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7439,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 21:57:32.358018',177,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7440,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 21:57:32.369727',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7441,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 22:19:38.911922',88,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7442,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 22:19:38.911917',162,91,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7443,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 22:19:38.918004',196,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7444,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 22:19:38.923995',345,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7445,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 22:36:52.356328',103,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7446,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 22:36:52.386248',168,92,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7447,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 22:36:52.406967',232,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7448,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 22:36:52.375026',354,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7449,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 22:52:15.738728',195,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7450,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 22:52:15.741341',209,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7451,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 22:52:15.760787',190,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7452,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 22:52:15.731101',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7453,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 23:24:14.334222',120,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7454,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 23:24:14.321737',195,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 23:24:14.323086',189,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7456,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 23:24:14.345767',290,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7457,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 23:24:26.418564',216,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7458,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 23:24:26.426192',211,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7459,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 23:24:26.410417',223,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7460,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 23:24:26.413142',299,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7461,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-09 23:24:30.103634',192,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7462,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-09 23:24:30.108827',177,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7463,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-09 23:24:30.141920',174,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7464,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-09 23:24:30.101604',308,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7465,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 00:08:31.355065',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7466,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 00:08:31.346345',150,94,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7467,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 00:08:31.356531',173,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7468,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 00:08:31.355098',280,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7469,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 00:19:13.134912',174,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7470,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 00:19:13.139088',189,95,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7471,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 00:19:13.151231',193,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7472,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 00:19:13.137331',304,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7473,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 00:27:32.411892',135,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7474,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 00:27:32.393619',160,96,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7475,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 00:27:32.407094',185,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7476,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 00:27:32.404454',296,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7477,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:02:11.602503',44,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7478,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:02:11.637106',146,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7479,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:02:11.625642',171,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7480,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:02:11.634800',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7481,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:02:22.642996',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7482,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:02:22.630972',225,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7483,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:02:22.633881',216,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7484,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:02:22.658547',379,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7485,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:02:25.522301',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7486,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:02:25.537836',189,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7487,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:02:25.515528',226,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7488,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:02:25.522756',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7489,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:05:28.920708',178,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7490,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:05:28.934063',157,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7491,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:05:28.926086',208,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7492,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:05:28.935005',346,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7493,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:20:02.875292',166,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7494,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:20:02.883382',169,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7495,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:20:02.871508',221,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7496,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:20:02.882743',334,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7497,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:20:14.577465',145,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7498,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:20:14.584316',159,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7499,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:20:14.578301',172,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7500,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:20:14.574175',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7501,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:20:18.022944',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7502,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:20:18.014116',156,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7503,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:20:18.021329',334,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7504,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:21:07.820254',122,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7505,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:21:07.832930',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7506,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:21:07.823411',225,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7507,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:21:07.835178',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7508,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:26:20.250015',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7509,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:26:20.260439',177,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7510,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:26:20.278147',179,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7511,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:26:20.263266',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7512,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:29:30.378937',176,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7513,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:29:30.397847',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7514,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:29:30.381285',204,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7515,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:29:30.395864',382,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7516,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:34:35.996419',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7517,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:34:36.013185',197,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7518,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:34:35.999371',225,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7519,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:34:36.025248',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7520,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 01:36:13.120688',162,98,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7521,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 01:36:13.097871',192,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7522,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 01:36:13.107252',193,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7523,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 01:36:13.104927',296,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7524,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:20:20.348616',120,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7525,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:20:20.341610',177,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7526,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:20:20.355674',185,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7527,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:20:20.339358',341,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7528,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:20:41.821006',146,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7529,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:20:41.818211',124,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7530,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:20:41.815073',174,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7531,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:20:41.819013',285,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7532,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:29:43.698851',152,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7533,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:29:43.698023',177,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7534,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:29:43.690174',173,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7535,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:29:43.694747',299,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7536,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:30:26.644756',168,100,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7537,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:30:26.642650',181,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7538,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:30:26.642566',207,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7539,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:30:26.645219',350,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7540,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:35:43.178935',118,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7541,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:35:43.170443',185,101,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7542,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:35:43.165195',198,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7543,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:35:43.180557',343,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7544,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:39:20.601227',164,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7545,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:39:20.608766',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7546,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:39:20.604886',156,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7547,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:39:20.595298',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7548,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 02:43:31.424296',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7549,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 02:43:31.433224',145,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7550,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 02:43:31.428475',211,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7551,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 02:43:31.425811',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7552,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:09:32.904965',214,101,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7553,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:09:32.907058',233,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7554,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:09:32.909130',243,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7555,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:09:32.910333',331,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7556,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:19:08.971934',141,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7557,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:19:08.986938',180,101,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7558,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:19:08.966441',210,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7559,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:19:08.985771',319,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7560,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:29:23.600310',201,101,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7561,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:29:23.612462',203,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7562,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:29:23.604750',283,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7563,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:29:23.623902',301,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7564,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:33:47.740392',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7565,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:33:47.733420',186,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7566,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:33:47.730098',199,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7567,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:33:47.722569',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7568,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:46:00.877168',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7569,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:46:00.929924',133,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7570,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:46:00.945765',164,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7571,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:46:00.924380',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7572,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:46:07.192305',113,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7573,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:46:07.190865',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7574,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:46:07.193544',172,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7575,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:46:07.190345',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7576,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:46:14.466373',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7577,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:46:14.464435',171,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7578,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:46:14.463485',178,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7579,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:46:14.463667',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7580,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:46:17.398137',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7581,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:46:17.412534',168,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7582,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:46:17.425319',165,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7583,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:46:17.400070',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7584,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 03:49:31.489813',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 03:49:31.507357',193,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7586,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 03:49:31.494007',224,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7587,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 03:49:31.492817',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7588,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 04:26:15.181216',159,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7589,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 04:26:15.180184',216,102,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7590,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 04:26:15.191795',223,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7591,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 04:26:15.189775',309,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7592,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 04:59:43.442081',182,106,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7593,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 04:59:43.445968',214,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7594,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 04:59:43.448025',219,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7595,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 04:59:43.458433',313,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7596,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 05:03:01.803927',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7597,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 05:03:01.794374',200,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7598,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 05:03:01.828542',173,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7599,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 05:03:01.801479',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7600,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 05:03:12.899599',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7601,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 05:03:12.927509',160,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7602,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 05:03:12.944389',151,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7603,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 05:03:12.901570',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7604,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 05:03:15.736508',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7605,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 05:03:15.744140',167,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7606,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 05:03:15.781766',183,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7607,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 05:03:15.742109',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7608,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 05:15:54.565380',183,106,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7609,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 05:15:54.589447',209,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7610,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 05:15:54.588006',225,86,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7611,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 05:15:54.560420',341,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7612,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:07:40.763709',186,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7613,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:07:40.781313',222,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7614,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:07:40.772347',240,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7615,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:07:40.763042',295,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7616,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:10:00.604504',178,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7617,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:10:00.596164',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7618,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:10:00.605694',223,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7619,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:10:00.607803',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7620,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:10:22.876307',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7621,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:10:22.871610',170,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7622,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:10:22.887451',167,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7623,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:10:22.898164',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7624,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:20:38.436211',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7625,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:20:38.449080',179,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7626,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:20:38.438460',193,86,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7627,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:20:38.437267',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7628,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:27:11.541081',168,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7629,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:27:11.538076',186,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7630,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:27:11.539397',201,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7631,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:27:11.542831',300,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7632,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:37:55.803393',47,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7633,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:37:55.825294',225,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7634,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:37:55.807385',273,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7635,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:37:55.817374',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7636,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:38:08.506724',197,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7637,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:38:08.518033',194,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7638,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:38:08.513551',235,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7639,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:38:08.491919',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7640,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:38:10.491313',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7641,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:38:10.494255',183,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7642,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:38:10.492508',219,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7643,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:38:10.482899',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7644,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 06:53:04.112065',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 06:53:04.080165',225,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7646,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 06:53:04.085361',315,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7647,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 06:53:04.097984',381,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7648,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:02:41.962086',151,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7649,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:02:41.968218',175,112,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7650,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:02:41.984900',193,86,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7651,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:02:41.958434',318,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7652,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:04:14.388801',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7653,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:04:14.390985',160,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7654,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:04:14.377967',175,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7655,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:04:14.349271',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7656,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:20:43.165401',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7657,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:20:43.185989',170,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7658,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:20:43.191169',193,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7659,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:20:43.155048',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7660,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:26:26.818727',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7661,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:26:26.812107',176,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7662,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:26:26.816487',179,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7663,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:26:26.804327',365,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7664,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:28:16.820455',131,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7665,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:28:16.838895',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7666,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:28:16.818248',198,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7667,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:28:16.808380',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7668,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:28:32.982624',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7669,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:28:32.946043',177,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7670,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:28:32.955714',208,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7671,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:28:32.977096',357,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7672,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:28:34.896606',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7673,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:28:34.914084',152,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7674,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:28:34.897713',183,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7675,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:28:34.890811',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7676,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 07:48:15.370721',178,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7677,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 07:48:15.368849',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7678,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 07:48:15.366749',190,86,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 07:48:15.356939',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7680,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:18:16.714617',200,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7681,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:18:16.731620',177,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7682,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:18:16.733486',189,12,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7683,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:18:16.713777',325,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7684,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:26:55.008621',182,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7685,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:26:55.001008',184,17,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7686,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:26:55.004841',212,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7687,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:26:55.007244',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7688,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:27:06.838518',185,17,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7689,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:27:06.845550',171,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7690,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:27:06.815760',233,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:27:06.841965',414,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7692,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:27:10.660301',133,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7693,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:27:10.660197',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7694,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:30:36.591828',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7695,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:30:36.608753',164,17,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7696,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:30:36.602052',187,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7697,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:30:36.612404',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7698,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:38:03.141443',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7699,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:38:03.130199',207,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7700,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:38:03.150003',200,21,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7701,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:38:03.143672',309,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7702,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:49:25.777773',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7703,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:49:25.771073',189,22,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7704,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:49:25.779069',219,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7705,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:49:25.767323',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7706,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:49:35.416732',82,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7707,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:49:35.452261',87,22,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7708,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:49:35.442527',151,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7709,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:49:35.454346',263,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7710,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:49:41.831382',124,22,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7711,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:49:41.858838',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7712,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:49:41.870872',173,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7713,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:49:41.872407',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7714,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:49:44.532486',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7715,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:49:44.538147',108,22,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7716,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:49:44.535458',183,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7717,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:49:44.527335',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7718,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:50:33.976522',137,22,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7719,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:50:33.972251',162,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7720,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:50:33.983850',189,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7721,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:50:33.979903',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7722,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:56:54.567924',184,26,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7723,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:56:54.566291',204,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7724,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:56:54.569976',227,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7725,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:56:54.555605',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7726,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:57:05.992441',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7727,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:57:06.007430',160,26,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7728,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:57:05.989764',202,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7729,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:57:06.017936',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7730,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 08:57:07.676055',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7731,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 08:57:07.685013',167,26,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7732,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 08:57:07.700896',160,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7733,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 08:57:07.683328',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7734,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 09:07:07.348498',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7735,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 09:07:07.344610',195,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7736,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 09:07:07.352360',193,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7737,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 09:07:07.350454',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7738,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 09:25:11.828218',179,39,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7739,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 09:25:11.822557',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7740,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 09:25:11.820602',196,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7741,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 09:25:11.820184',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7742,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 09:26:24.299570',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7743,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 09:26:24.311413',132,39,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7744,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 09:26:24.295689',170,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7745,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 09:26:24.308460',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7746,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 09:46:17.687632',144,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7747,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 09:46:17.676962',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7748,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 09:46:17.685055',160,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7749,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 09:46:17.690128',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7750,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 10:49:54.450493',151,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7751,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 10:49:54.463083',158,47,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7752,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 10:49:54.453300',176,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7753,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 10:49:54.451481',311,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7754,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 10:51:53.723956',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7755,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 10:51:53.731928',162,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7756,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 10:51:53.732775',168,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7757,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 10:51:53.739616',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7758,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 10:51:56.806421',155,47,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7759,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 10:51:56.805506',174,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7760,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 10:51:56.808513',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7761,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 10:51:56.797710',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7762,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 10:55:40.871309',113,48,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7763,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 10:55:40.874788',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7764,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 10:55:40.873294',163,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7765,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 10:55:40.879199',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7766,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 13:05:08.878176',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7767,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 13:05:08.885905',192,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7768,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 13:05:08.882835',207,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7769,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 13:05:08.876144',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7770,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 17:50:08.831715',69,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7771,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 17:50:08.903560',131,67,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7772,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 17:50:08.889382',154,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7773,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 17:50:08.897402',260,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7774,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 18:02:28.020393',64,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7775,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 18:02:28.023265',180,68,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7776,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 18:02:28.043359',175,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7777,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 18:02:28.042497',290,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7778,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 18:23:51.732889',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7779,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 18:23:51.738906',146,69,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7780,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 18:23:51.757676',193,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7781,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 18:23:51.748033',355,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7782,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 18:24:04.326377',124,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7783,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 18:24:04.332490',143,69,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7784,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 18:24:04.333687',157,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7785,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 18:24:04.326891',357,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7786,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:11:44.831357',153,75,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7787,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:11:44.830963',135,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7788,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:11:44.813903',220,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7789,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:11:44.801738',295,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7790,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:20:32.849616',133,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7791,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:20:32.861057',185,75,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7792,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:20:32.869784',198,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7793,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:20:32.854491',320,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7794,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:21:40.438685',166,75,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7795,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:21:40.444371',167,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7796,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:21:40.441102',188,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7797,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:21:40.438360',304,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7798,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:22:40.236467',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7799,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:22:40.234394',147,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7800,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:22:40.223735',172,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7801,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:22:40.221550',289,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7802,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:23:40.501454',112,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7803,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:23:40.525315',157,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7804,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:23:40.528487',196,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7805,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:23:40.518734',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7806,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:24:40.817259',187,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:24:40.810756',202,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7808,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:24:40.824228',195,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7809,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:24:40.821049',344,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7810,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:25:40.603507',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7811,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:25:40.605157',146,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7812,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:25:40.584274',207,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7813,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:25:40.587327',320,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7814,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:26:40.895482',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7815,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:26:40.877360',148,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7816,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:26:40.893919',164,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7817,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:26:40.889617',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:27:41.704968',163,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7819,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:27:41.708491',183,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7820,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:27:41.702179',204,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7821,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:27:41.705257',343,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7822,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 19:28:52.499605',160,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7823,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 19:28:52.501255',178,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7824,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 19:28:52.490077',196,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7825,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 19:28:52.473348',292,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7826,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 20:31:23.334477',162,78,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7827,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 20:31:23.330094',156,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7828,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 20:31:23.347278',223,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7829,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 20:31:23.355129',311,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7830,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 20:37:45.562541',152,78,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7831,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 20:37:45.587863',153,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7832,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 20:37:45.597543',175,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7833,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 20:37:45.555168',318,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 20:53:14.743861',119,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7835,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 20:53:14.765385',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7836,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 20:53:14.763981',211,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7837,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 20:53:14.742531',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7838,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 20:53:55.741472',118,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7839,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 20:53:55.727547',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7840,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 20:53:55.752213',186,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7841,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 20:53:55.745988',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7842,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 20:53:58.422102',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7843,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 20:53:58.448121',170,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7844,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 20:53:58.445482',181,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7845,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 20:53:58.426223',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7846,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 21:11:58.239311',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7847,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 21:11:58.226893',187,80,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7848,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 21:11:58.237518',218,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7849,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 21:11:58.239104',323,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7850,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 22:06:50.193436',248,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7851,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 22:06:50.226565',247,83,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7852,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 22:06:50.192253',356,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7853,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 22:06:50.205409',452,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7854,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 22:26:21.962708',155,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7855,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 22:26:21.967781',174,85,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7856,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 22:26:21.974593',175,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7857,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 22:26:21.976424',270,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7858,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 22:37:58.296432',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7859,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 22:37:58.302442',190,87,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7860,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 22:37:58.317653',186,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7861,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 22:37:58.311134',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7862,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 23:13:27.183307',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7863,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 23:13:27.166038',157,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7864,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 23:13:27.210342',203,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7865,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 23:13:27.159452',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 23:17:59.816489',90,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7867,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 23:17:59.797921',118,91,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7868,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 23:17:59.829905',154,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7869,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 23:17:59.808813',269,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7870,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 23:21:08.627570',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7871,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 23:21:08.644702',148,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7872,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 23:21:08.633113',172,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7873,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 23:21:08.646713',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7874,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 23:21:20.769148',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7875,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 23:21:20.778563',197,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7876,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 23:21:20.777502',171,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7877,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 23:21:20.780490',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7878,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-10 23:21:22.753592',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7879,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-10 23:21:22.781413',145,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7880,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-10 23:21:22.760918',174,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7881,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-10 23:21:22.774566',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7882,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 00:07:01.716426',193,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7883,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 00:07:01.727953',200,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7884,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 00:07:01.730282',223,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7885,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 00:07:01.714041',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 00:18:37.669394',166,95,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7887,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 00:18:37.665472',194,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7888,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 00:18:37.673104',211,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7889,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 00:18:37.664252',391,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7890,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 00:18:54.739423',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7891,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 00:18:54.741358',184,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7892,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 00:18:54.729443',223,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7893,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 00:18:54.742341',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7894,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 00:45:30.119949',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7895,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 00:45:30.109287',157,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7896,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 00:45:30.124641',192,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7897,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 00:45:30.118855',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7898,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 00:54:02.392685',180,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7899,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 00:54:02.401639',196,98,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7900,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 00:54:02.370836',252,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7901,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 00:54:02.373577',319,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7902,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 01:07:26.033456',76,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7903,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 01:07:26.050908',152,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7904,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 01:07:26.056926',188,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7905,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 01:07:26.024273',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7906,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 01:33:57.633090',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7907,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 01:33:57.663705',133,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7908,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 01:33:57.671304',188,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7909,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 01:33:57.648840',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7910,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 02:04:19.107898',195,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7911,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 02:04:19.090559',223,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7912,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 02:04:19.097668',258,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7913,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 02:04:19.095647',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7914,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 02:04:26.971830',67,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7915,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 02:04:27.009395',174,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7916,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 02:04:26.991437',198,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7917,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 02:04:27.001988',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7918,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 03:41:31.644130',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7919,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 03:41:31.655344',165,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7920,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 03:41:31.666975',185,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7921,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 03:41:31.657814',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7922,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 03:41:35.651436',149,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7923,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 03:41:35.644858',155,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7924,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 03:41:35.642351',173,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7925,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 03:41:35.662050',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7926,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 03:57:55.107175',193,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 03:57:55.108012',221,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7928,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 03:57:55.105946',225,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7929,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 03:57:55.097580',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7930,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:09:55.465084',190,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7931,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:09:55.470929',178,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7932,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:09:55.472717',196,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7933,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:09:55.471975',299,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7934,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:11:10.910318',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7935,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:11:10.933498',175,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7936,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:11:10.923055',193,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7937,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:11:10.936404',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7938,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:18:33.772341',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7939,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:18:33.777081',161,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7940,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:18:33.797079',182,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7941,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:18:33.781566',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7942,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:18:44.846442',195,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7943,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:18:44.880163',182,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7944,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:18:44.867047',217,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7945,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:18:44.855463',382,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7946,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:18:47.779817',86,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7947,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:18:47.795472',155,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7948,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:18:47.789737',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7949,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:20:04.945553',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7950,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:20:04.954455',224,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7951,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:20:04.957728',228,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7952,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:20:04.956129',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7953,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:36:21.348456',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:36:21.329036',180,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7955,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:36:21.340146',200,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:36:21.336990',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7957,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:36:23.275460',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7958,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:36:23.278412',163,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7959,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:36:23.278097',174,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7960,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:36:23.266509',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 04:44:39.343478',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7962,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 04:44:39.344403',168,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7963,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 04:44:39.338979',184,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7964,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 04:44:39.334618',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7965,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 05:19:47.516709',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7966,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 05:19:47.539144',227,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7967,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 05:19:47.536976',239,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7968,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 05:19:47.500484',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7969,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 05:29:31.351316',186,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7970,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 05:29:31.349298',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7971,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 05:29:31.339597',223,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7972,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 05:29:31.353145',300,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7973,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 05:52:07.525396',158,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7974,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 05:52:07.537474',172,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7975,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 05:52:07.518792',212,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7976,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 05:52:07.538750',303,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7977,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 05:52:18.770642',202,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7978,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 05:52:18.779142',175,115,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7979,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 05:52:18.770920',193,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7980,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 05:52:18.774241',342,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7981,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 05:52:22.465219',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7982,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 05:52:22.445336',205,115,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7983,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 05:52:22.455827',217,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 05:52:22.447991',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7985,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 06:07:39.318249',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7986,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 06:07:39.313604',203,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7987,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 06:07:39.320157',242,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7988,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 06:07:39.335109',356,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7989,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 06:11:44.416344',125,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7990,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 06:11:44.434891',117,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7991,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 06:11:44.448072',183,87,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7992,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 06:11:44.432310',303,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7993,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 06:28:23.747429',141,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7994,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 06:28:23.740530',184,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7995,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 06:28:23.746510',166,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 06:28:23.746458',285,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7997,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 06:48:49.407293',158,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7998,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 06:48:49.413446',159,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(7999,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 06:48:49.400136',178,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8000,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 06:48:49.408352',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8001,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 06:48:51.925943',151,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8002,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 06:48:51.928263',158,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8003,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 06:48:51.926956',178,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8004,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 06:48:51.913548',282,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8005,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:05:05.140239',149,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8006,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:05:05.127927',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8007,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:05:05.139682',189,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8008,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:05:05.125600',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8009,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:08:05.141260',151,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8010,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:08:05.128538',161,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8011,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:08:05.124394',170,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8012,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:08:05.134050',300,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8013,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:24:38.842569',127,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8014,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:24:38.846143',188,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8015,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:24:38.865097',217,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8016,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:24:38.858698',296,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8017,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:30:56.840238',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:30:56.851977',164,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8019,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:30:56.854870',211,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:30:56.835117',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:31:20.737127',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8022,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:31:20.739904',147,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8023,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:31:20.747204',171,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8024,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:31:20.753741',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8025,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:31:45.457787',151,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8026,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:31:45.450278',179,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8027,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:31:45.461056',188,87,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8028,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:31:45.456560',308,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8029,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:48:42.122301',207,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8030,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:48:42.128095',214,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8031,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:48:42.134085',225,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:48:42.139179',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8033,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:48:46.619476',169,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8034,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:48:46.630233',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8035,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:48:46.604424',203,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8036,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:48:46.624647',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8037,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:51:17.298837',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8038,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:51:17.301566',180,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8039,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:51:17.325249',171,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8040,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:51:17.309388',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8041,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:57:02.309076',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8042,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:57:02.296958',179,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8043,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:57:02.308071',189,87,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8044,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:57:02.305306',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8045,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 07:58:37.293898',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 07:58:37.286925',173,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8047,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 07:58:37.298736',222,87,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8048,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 07:58:37.285465',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8049,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:15:01.883874',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8050,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:15:01.885883',173,15,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8051,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:15:01.891695',183,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8052,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:15:01.893959',291,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8053,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:15:56.071968',145,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8054,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:15:56.078542',150,15,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8055,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:15:56.079915',170,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8056,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:15:56.079117',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8057,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:28:45.468396',155,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8058,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:28:45.466562',174,27,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8059,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:28:45.487205',155,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8060,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:28:45.469733',290,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8061,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:29:29.017661',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8062,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:29:29.039953',187,27,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8063,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:29:29.043109',203,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8064,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:29:29.036817',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8065,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:36:00.623769',122,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8066,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:36:00.606436',183,30,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8067,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:36:00.618327',206,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8068,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:36:00.610024',344,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8069,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:52:32.783485',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8070,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:52:32.781346',178,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8071,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:52:32.801196',171,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8072,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:52:32.790734',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8073,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:55:15.362164',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8074,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:55:15.360839',171,36,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8075,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:55:15.364033',187,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8076,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:55:15.371035',312,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8077,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 08:59:41.763382',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8078,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 08:59:41.774134',187,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8079,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 08:59:41.790628',198,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8080,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 08:59:41.779547',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8081,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 09:38:35.852110',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8082,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 09:38:35.834280',171,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8083,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 09:38:35.865702',219,43,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8084,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 09:38:35.865019',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8085,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 09:42:59.356098',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8086,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 09:42:59.356960',163,45,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8087,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 09:42:59.354000',193,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8088,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 09:42:59.346341',311,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8089,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 09:45:27.558851',176,45,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8090,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 09:45:27.557512',168,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8091,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 09:45:27.542344',204,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8092,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 09:45:27.531008',339,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8093,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 10:17:43.029434',108,52,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8094,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 10:17:43.033942',158,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8095,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 10:17:43.028444',202,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8096,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 10:17:43.019693',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8097,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 11:08:48.774021',100,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8098,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 11:08:48.781912',136,57,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8099,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 11:08:48.798303',166,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8100,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 11:08:48.783647',284,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8101,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 12:14:51.524424',148,59,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8102,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 12:14:51.527023',157,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8103,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 12:14:51.528806',175,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 12:14:51.522313',276,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8105,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 13:24:40.097408',109,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8106,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 13:24:40.108713',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8107,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 13:24:40.107525',212,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8108,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 13:24:40.106522',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8109,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 13:38:03.941572',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8110,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 13:38:03.939516',172,64,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8111,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 13:38:03.932018',198,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8112,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 13:38:03.926246',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 15:29:14.169016',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8114,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 15:29:14.152180',190,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8115,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 15:29:14.146557',199,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8116,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 15:29:14.147524',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 17:15:34.525159',132,72,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 17:15:34.526797',162,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8119,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 17:15:34.525693',169,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8120,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 17:15:34.527236',278,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8121,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 17:50:16.580234',141,72,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8122,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 17:50:16.596766',176,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8123,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 17:50:16.584860',256,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8124,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 17:50:16.603202',326,0,_binary '','dashboard','减少结果行数的错误。null',13371339,29,2,NULL,2,NULL,NULL,NULL,NULL),(8125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 17:50:18.321496',112,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8126,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 17:50:18.319010',159,72,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8127,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 17:50:18.316465',163,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8128,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 17:50:18.320875',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8129,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 17:58:18.238034',169,73,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8130,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 17:58:18.232699',167,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8131,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 17:58:18.244198',182,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8132,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 17:58:18.232348',298,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8133,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 17:58:26.816932',150,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8134,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 17:58:26.814152',163,73,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8135,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 17:58:26.794325',188,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8136,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 17:58:26.787219',313,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8137,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 18:37:26.543141',139,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8138,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 18:37:26.548316',166,78,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8139,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 18:37:26.558835',193,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8140,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 18:37:26.549422',348,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8141,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 20:08:45.127101',187,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8142,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 20:08:45.119774',215,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8143,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 20:08:45.133137',189,84,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8144,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 20:08:45.128750',288,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8145,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 20:33:14.577944',172,87,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8146,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 20:33:14.575615',165,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8147,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 20:33:14.573834',222,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8148,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 20:33:14.577715',301,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8149,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 21:07:38.735710',182,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8150,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 21:07:38.737045',193,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8151,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 21:07:38.725618',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8152,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 21:07:38.722675',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8153,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 21:07:41.469454',107,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8154,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 21:07:41.491524',128,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8155,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 21:07:41.502458',173,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8156,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 21:07:41.500147',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8157,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 21:24:53.640866',84,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8158,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 21:24:53.684669',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8159,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 21:24:53.645365',196,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8160,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 21:24:53.671776',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8161,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 22:09:49.465309',150,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8162,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 22:09:49.471835',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8163,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 22:09:49.469304',181,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 22:09:49.478371',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8165,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 22:14:43.283307',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8166,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 22:14:43.289701',194,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8167,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 22:14:43.287465',200,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8168,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 22:14:43.276603',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8169,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 23:22:15.799311',145,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8170,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 23:22:15.790467',170,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8171,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 23:22:15.802359',165,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8172,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 23:22:15.797800',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8173,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-11 23:47:42.126259',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8174,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-11 23:47:42.138973',169,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8175,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-11 23:47:42.140560',186,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-11 23:47:42.146919',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8177,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 00:24:56.542821',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8178,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 00:24:56.534327',190,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8179,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 00:24:56.536545',221,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8180,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 00:24:56.534151',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8181,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 00:44:24.787422',134,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8182,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 00:44:24.827063',164,101,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8183,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 00:44:24.807521',203,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8184,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 00:44:24.802790',324,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8185,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 00:44:43.469504',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8186,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 00:44:43.481418',135,101,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8187,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 00:44:43.501400',156,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8188,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 00:44:43.488753',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8189,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 00:44:47.137134',172,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8190,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 00:44:47.178546',167,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8191,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 00:44:47.149047',179,101,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8192,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 00:44:47.194280',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8193,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 01:14:12.081741',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8194,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 01:14:12.087459',183,101,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8195,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 01:14:12.092903',205,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8196,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 01:14:12.091176',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8197,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 01:36:47.845417',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8198,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 01:36:47.852387',177,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8199,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 01:36:47.855107',215,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8200,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 01:36:47.842077',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8201,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 02:09:12.832272',92,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8202,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 02:09:12.836249',132,104,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8203,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 02:09:12.829804',214,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8204,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 02:09:12.822437',380,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8205,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 02:34:35.727120',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8206,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 02:34:35.733754',136,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8207,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 02:34:35.745864',187,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8208,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 02:34:35.764116',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8209,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 02:35:44.414472',181,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8210,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 02:35:44.412539',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8211,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 02:35:44.414832',207,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8212,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 02:35:44.417240',354,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8213,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 02:49:45.563342',151,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8214,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 02:49:45.584132',203,105,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8215,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 02:49:45.594567',202,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8216,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 02:49:45.570162',367,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8217,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 02:59:28.709561',131,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8218,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 02:59:28.720619',152,105,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8219,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 02:59:28.713316',183,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8220,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 02:59:28.719150',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8221,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 03:38:25.278044',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8222,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 03:38:25.284854',198,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8223,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 03:38:25.274478',206,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8224,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 03:38:25.274335',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8225,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 03:39:24.051992',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8226,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 03:39:24.045116',180,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8227,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 03:39:24.043422',183,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8228,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 03:39:24.035447',342,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8229,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 03:55:39.444419',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8230,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 03:55:39.438932',199,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8231,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 03:55:39.434532',228,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8232,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 03:55:39.403459',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8233,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 03:57:58.218066',126,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8234,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 03:57:58.227816',148,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8235,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 03:57:58.235142',180,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8236,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 03:57:58.223525',273,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8237,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 03:58:02.427949',166,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8238,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 03:58:02.466207',153,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8239,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 03:58:02.474849',158,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8240,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 03:58:02.445830',291,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8241,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:04:28.990488',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8242,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:04:29.012875',148,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8243,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:04:29.002412',203,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8244,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:04:29.027858',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8245,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:07:03.225420',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8246,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:07:03.236530',175,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8247,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:07:03.256396',156,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8248,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:07:03.239383',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8249,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:18:04.377484',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8250,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:18:04.387880',222,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8251,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:18:04.383606',232,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8252,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:18:04.388496',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8253,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:37:17.288656',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8254,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:37:17.281451',223,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8255,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:37:17.305222',235,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8256,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:37:17.296162',367,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8257,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:38:31.540514',146,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8258,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:38:31.544819',157,108,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8259,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:38:31.550175',168,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8260,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:38:31.561184',309,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8261,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:40:24.538822',135,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8262,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:40:24.530328',164,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8263,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:40:24.548458',172,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8264,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:40:24.526372',326,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8265,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:57:34.155782',161,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8266,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:57:34.132654',228,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8267,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:57:34.149941',208,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8268,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:57:34.135382',348,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8269,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 04:57:47.626344',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8270,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 04:57:47.626013',164,108,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8271,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 04:57:47.637103',170,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8272,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 04:57:47.635491',285,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8273,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 05:17:43.777971',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8274,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 05:17:43.785032',149,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8275,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 05:17:43.815029',156,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8276,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 05:17:43.793464',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8277,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 05:27:22.298008',117,109,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8278,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 05:27:22.300345',105,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8279,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 05:27:22.293814',186,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8280,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 05:27:22.298538',325,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8281,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 05:49:20.042513',177,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8282,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 05:49:20.033002',219,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8283,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 05:49:20.027249',236,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8284,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 05:49:20.053697',381,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8285,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 05:51:12.467108',186,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8286,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 05:51:12.482715',196,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8287,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 05:51:12.490574',182,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8288,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 05:51:12.495332',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 05:51:35.336804',177,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8290,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 05:51:35.336712',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8291,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 05:51:35.347327',196,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8292,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 05:51:35.339111',329,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8293,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:04:01.284342',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8294,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:04:01.285488',190,115,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8295,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:04:01.281821',242,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8296,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:04:01.282510',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8297,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:16:55.168080',151,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8298,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:16:55.172790',165,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8299,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:16:55.195183',202,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8300,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:16:55.178234',323,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8301,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:16:59.233031',154,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8302,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:16:59.240509',178,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8303,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:16:59.248957',209,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8304,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:16:59.243251',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8305,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:41:14.173727',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:41:14.171534',185,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8307,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:41:14.167908',210,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8308,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:41:14.183040',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8309,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:52:43.946618',117,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8310,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:52:43.965458',151,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8311,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:52:43.966850',179,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8312,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:52:43.952783',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8313,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:52:54.367266',127,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8314,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:52:54.358929',177,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8315,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:52:54.366012',214,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8316,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:52:54.368088',351,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8317,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:53:00.078446',57,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8318,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:53:00.095014',220,116,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8319,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:53:00.118777',225,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8320,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:53:00.106758',340,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8321,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 06:56:13.110843',124,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8322,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 06:56:13.116034',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8323,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 06:56:13.127036',200,88,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8324,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 06:56:13.130227',326,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8325,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 07:26:33.724185',160,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8326,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 07:26:33.727263',159,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8327,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 07:26:33.739933',164,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8328,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 07:26:33.725953',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8329,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 07:33:27.595523',121,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8330,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 07:33:27.598250',142,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8331,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 07:33:27.614162',206,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8332,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 07:33:27.612524',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8333,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 07:44:21.004219',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8334,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 07:44:21.007050',223,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8335,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 07:44:21.011182',227,88,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8336,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 07:44:21.007757',342,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8337,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 07:50:29.237896',175,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8338,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 07:50:29.231015',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8339,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 07:50:29.217992',223,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8340,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 07:50:29.204150',370,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8341,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 07:53:57.336091',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8342,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 07:53:57.336791',204,88,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8343,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 07:53:57.349517',182,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8344,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 07:53:57.330126',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8345,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 07:56:52.413628',142,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 07:56:52.422313',141,119,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8347,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 07:56:52.424862',163,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8348,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 07:56:52.413190',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8349,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:01:54.083289',168,0,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8350,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:01:54.071710',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8351,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:01:54.106708',161,88,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8352,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:01:54.077860',290,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8353,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:02:07.791262',85,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8354,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:02:07.833923',193,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8355,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:02:07.849562',191,0,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8356,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:02:07.799443',325,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8357,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:19:14.417057',149,14,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8358,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:19:14.407870',193,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8359,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:19:14.407940',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8360,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:19:14.412521',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8361,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:39:46.146783',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8362,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:39:46.159110',144,26,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8363,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:39:46.144290',196,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8364,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:39:46.158373',295,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8365,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:44:35.098898',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8366,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:44:35.101803',143,29,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8367,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:44:35.109772',169,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8368,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:44:35.096113',337,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8369,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:44:46.835775',175,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8370,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:44:46.838479',193,29,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8371,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:44:46.840645',210,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8372,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:44:46.826225',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8373,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:44:50.504094',362,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8374,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:44:50.562839',377,29,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8375,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:44:50.584897',408,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8376,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:44:50.597078',583,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8377,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:45:34.025897',143,29,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8378,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:45:34.024320',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8379,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:45:34.017627',165,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8380,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:45:34.026758',265,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8381,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:45:45.840760',106,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8382,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:45:45.839211',115,29,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8383,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:45:45.838843',179,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8384,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:45:45.847856',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8385,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 08:45:47.791539',125,29,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8386,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 08:45:47.788575',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8387,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 08:45:47.812155',173,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8388,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 08:45:47.796957',350,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8389,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 09:07:44.086237',171,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8390,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 09:07:44.084069',184,37,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8391,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 09:07:44.107180',180,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8392,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 09:07:44.086368',300,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8393,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 09:45:44.830731',127,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8394,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 09:45:44.818753',146,52,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8395,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 09:45:44.835188',193,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8396,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 09:45:44.832545',314,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 10:01:30.541847',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8398,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 10:01:30.556354',201,54,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8399,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 10:01:30.544725',224,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8400,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 10:01:30.557737',369,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8401,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 10:20:52.353532',149,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8402,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 10:20:52.350577',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8403,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 10:20:52.340460',208,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8404,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 10:20:52.365889',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8405,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 11:41:16.114254',104,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8406,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 11:41:16.111418',176,63,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8407,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 11:41:16.116441',199,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8408,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 11:41:16.107495',297,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8409,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 14:42:46.369210',233,71,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8410,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 14:42:46.383235',232,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8411,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 14:42:46.442789',286,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8412,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 14:42:46.398102',469,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8413,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 18:15:32.165633',114,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8414,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 18:15:32.188555',162,80,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8415,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 18:15:32.187373',194,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8416,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 18:15:32.174047',322,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8417,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 18:16:05.076795',162,80,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8418,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 18:16:05.081443',165,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8419,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 18:16:05.084067',171,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8420,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 18:16:05.089723',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 18:43:24.832167',176,83,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8422,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 18:43:24.851570',172,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8423,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 18:43:24.846262',215,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8424,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 18:43:24.838311',356,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8425,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 19:42:15.715878',149,87,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8426,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 19:42:15.702224',133,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8427,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 19:42:15.712868',191,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8428,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 19:42:15.696822',305,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 20:42:05.883710',115,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 20:42:05.875292',185,87,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8431,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 20:42:05.899437',207,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8432,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 20:42:05.882037',343,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8433,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 21:45:01.607914',243,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8434,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 21:45:01.617202',220,88,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8435,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 21:45:01.635170',293,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8436,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 21:45:01.618576',413,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8437,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 21:50:37.849773',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8438,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 21:50:37.814235',248,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8439,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 21:50:37.831189',257,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8440,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 21:50:37.812121',387,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8441,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 21:50:49.211361',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8442,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 21:50:49.222649',133,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8443,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 21:50:49.225640',181,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8444,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 21:50:49.225142',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8445,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 21:50:51.237350',181,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8446,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 21:50:51.259333',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8447,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 21:50:51.257803',191,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8448,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 21:50:51.233213',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8449,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 22:09:19.609344',153,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8450,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 22:09:19.616577',165,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8451,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 22:09:19.601911',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8452,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 22:09:19.612135',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8453,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 22:36:32.206563',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8454,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 22:36:32.193126',214,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 22:36:32.210726',211,92,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8456,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 22:36:32.208506',366,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8457,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 22:36:44.609155',183,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8458,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 22:36:44.593539',219,92,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8459,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 22:36:44.594945',268,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8460,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 22:36:44.588079',332,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8461,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 22:36:49.484345',216,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8462,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 22:36:49.478447',205,92,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8463,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 22:36:49.477159',198,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8464,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 22:36:49.473264',356,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8465,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 22:38:04.759104',136,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8466,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 22:38:04.772516',179,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8467,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 22:38:04.781051',183,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8468,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 22:38:04.784520',340,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8469,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 23:02:31.873922',159,97,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8470,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 23:02:31.879086',146,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8471,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 23:02:31.871259',188,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8472,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 23:02:31.866489',310,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8473,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 23:11:12.775670',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8474,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 23:11:12.783296',163,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8475,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 23:11:12.786030',178,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8476,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 23:11:12.784443',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8477,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 23:38:13.954817',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8478,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 23:38:13.955128',153,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8479,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 23:38:13.944172',185,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8480,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 23:38:13.953851',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8481,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 23:59:51.533890',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8482,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 23:59:51.541627',164,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8483,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 23:59:51.535224',193,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8484,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 23:59:51.533718',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8485,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-12 23:59:54.474151',168,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8486,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-12 23:59:54.480641',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8487,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-12 23:59:54.470056',218,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8488,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-12 23:59:54.472565',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8489,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 00:00:38.383455',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8490,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 00:00:38.385999',174,102,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8491,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 00:00:38.393313',161,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8492,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 00:00:38.380686',312,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8493,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 00:11:37.829301',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8494,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 00:11:37.861194',164,103,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8495,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 00:11:37.881175',185,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8496,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 00:11:37.873142',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8497,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 00:53:47.896618',87,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8498,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 00:53:47.918161',151,104,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8499,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 00:53:47.944867',187,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8500,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 00:53:47.941357',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8501,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:12:28.161020',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8502,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:12:28.152165',174,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8503,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:12:28.145249',214,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8504,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 01:12:28.154626',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8505,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:38:22.053183',196,109,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8506,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:38:22.058135',190,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8507,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:38:22.050035',225,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8508,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 01:38:22.056204',327,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8509,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:38:57.274743',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8510,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:38:57.281337',149,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8511,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:38:57.280518',177,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8512,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 01:38:57.283008',282,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8513,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:54:47.357261',158,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8514,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:54:47.358157',196,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8515,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:54:47.366251',189,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8516,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 01:54:47.355545',351,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8517,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:54:52.965401',73,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8518,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:54:53.060070',149,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8519,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:54:53.104321',128,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8520,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 01:54:52.966029',372,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8521,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:54:59.317217',171,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8522,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:54:59.315361',160,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8523,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:54:59.311852',224,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8524,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 01:54:59.310905',335,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8525,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 01:55:00.892389',59,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8526,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 01:55:00.945668',97,110,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8527,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 01:55:00.920123',159,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8528,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:05:55.258793',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8529,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:05:55.258568',199,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8530,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:05:55.267193',207,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8531,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:05:55.259369',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8532,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:29:47.300392',275,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8533,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:29:47.305190',289,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8534,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:29:47.303495',324,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8535,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:29:47.298528',451,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8536,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:36:23.007558',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8537,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:36:23.057311',195,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8538,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:36:23.043223',223,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8539,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:36:23.023410',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8540,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:41:37.122217',219,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8541,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:41:37.129129',214,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8542,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:41:37.125000',312,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8543,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:41:37.123648',389,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8544,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:43:00.745551',149,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8545,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:43:00.754383',169,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8546,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:43:00.744608',211,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8547,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:43:00.756387',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8548,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:43:12.559286',81,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8549,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:43:12.625781',153,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8550,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:43:12.636476',157,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8551,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:43:12.632832',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8552,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 02:43:16.992858',176,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8553,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 02:43:17.012105',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8554,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 02:43:17.010421',180,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8555,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 02:43:16.997016',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8556,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 03:02:08.564073',306,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8557,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 03:02:08.588828',291,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8558,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 03:02:08.549551',400,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8559,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 03:02:08.572019',436,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8560,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 03:46:54.513017',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8561,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 03:46:54.530573',137,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8562,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 03:46:54.540011',180,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8563,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 03:46:54.498473',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8564,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:05:03.526338',141,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8565,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:05:03.514742',176,113,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8566,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:05:03.524835',187,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8567,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:05:03.523025',335,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8568,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:05:40.691128',80,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8569,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:05:40.741543',130,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8570,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:05:40.732665',187,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8571,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:05:40.737374',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8572,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:10:01.162330',142,113,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8573,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:10:01.160030',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8574,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:10:01.149444',172,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8575,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:10:01.145163',347,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8576,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:19:13.871779',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8577,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:19:13.874608',158,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8578,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:19:13.901273',212,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8579,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:19:13.880890',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8580,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:19:25.117294',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8581,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:19:25.116053',173,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8582,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:19:25.118613',203,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8583,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:19:25.119449',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8584,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:19:27.243507',66,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:19:27.250864',116,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8586,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:19:27.278386',157,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8587,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:19:27.261291',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8588,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:48:51.368690',59,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8589,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:48:51.447774',150,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8590,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:48:51.437022',154,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8591,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:48:51.450934',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8592,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 04:48:54.290517',160,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8593,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 04:48:54.289161',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8594,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 04:48:54.281898',212,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8595,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 04:48:54.292349',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8596,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:03:58.354594',148,117,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8597,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:03:58.345382',166,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8598,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:03:58.347631',195,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8599,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:03:58.339430',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8600,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:14:56.678328',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8601,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:14:56.689305',185,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8602,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:14:56.683021',228,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8603,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:14:56.686747',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8604,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:17:08.190962',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8605,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:17:08.172935',201,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8606,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:17:08.176061',187,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8607,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:17:08.185003',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8608,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:18:59.682369',151,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8609,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:18:59.698326',165,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8610,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:18:59.688224',191,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8611,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:18:59.691066',307,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8612,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:19:12.911144',143,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8613,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:19:12.929046',154,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8614,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:19:12.915181',176,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8615,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:19:12.912270',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8616,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:19:17.083740',87,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8617,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:19:17.116933',177,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:19:17.112344',185,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8619,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:19:17.131106',308,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8620,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 05:59:54.073426',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8621,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 05:59:54.086658',123,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8622,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 05:59:54.067740',233,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8623,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 05:59:54.082046',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8624,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 06:01:09.823822',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8625,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 06:01:09.814795',170,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8626,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 06:01:09.834859',189,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8627,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 06:01:09.812614',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8628,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 06:01:12.660735',53,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8629,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 06:01:12.698918',147,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8630,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 06:01:12.696922',170,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8631,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 06:01:12.673296',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8632,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 06:03:03.502384',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8633,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 06:03:03.518273',169,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8634,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 06:03:03.494996',222,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8635,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 06:03:03.501053',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8636,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 06:18:52.496226',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8637,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 06:18:52.509941',172,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8638,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 06:18:52.489270',213,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8639,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 06:18:52.500636',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8640,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 06:54:59.689622',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8641,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 06:54:59.690821',181,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8642,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 06:54:59.704473',180,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8643,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 06:54:59.689118',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8644,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 07:00:47.969673',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 07:00:47.976474',176,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8646,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 07:00:47.997408',195,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8647,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 07:00:47.978353',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8648,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 07:36:14.684598',156,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8649,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 07:36:14.699799',159,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8650,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 07:36:14.690340',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8651,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 07:36:14.691934',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8652,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 07:42:43.515106',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8653,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 07:42:43.508463',161,126,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8654,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 07:42:43.512020',186,89,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8655,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 07:42:43.512944',330,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8656,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 07:46:56.568006',164,126,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8657,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 07:46:56.600164',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8658,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 07:46:56.573441',176,89,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8659,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 07:46:56.565396',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8660,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 07:56:14.077978',181,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8661,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 07:56:14.084749',192,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8662,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 07:56:14.100041',229,89,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8663,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 07:56:14.087320',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8664,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 07:59:07.324768',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8665,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 07:59:07.311651',177,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8666,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 07:59:07.327047',183,89,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8667,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 07:59:07.319896',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8668,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 08:18:43.980177',121,16,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8669,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 08:18:44.016647',133,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8670,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 08:18:44.018599',209,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8671,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 08:18:44.014676',343,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8672,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 08:23:52.232680',135,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8673,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 08:23:52.229870',169,21,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8674,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 08:23:52.227188',178,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8675,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 08:23:52.234336',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8676,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 08:42:01.703386',133,24,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8677,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 08:42:01.719833',184,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8678,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 08:42:01.718182',237,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 08:42:01.727067',331,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8680,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 08:59:56.295949',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 08:59:56.291405',160,37,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8682,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 08:59:56.294679',173,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8683,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 08:59:56.293475',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8684,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 09:38:35.562991',169,48,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8685,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 09:38:35.575862',172,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8686,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 09:38:35.608011',169,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8687,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 09:38:35.574041',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8688,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 09:40:46.444620',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8689,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 09:40:46.442444',133,48,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8690,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 09:40:46.444085',168,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 09:40:46.437886',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8692,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 09:53:13.301480',142,0,_binary '','dashboard','减少结果行数的错误。null',13371339,29,2,NULL,2,NULL,NULL,NULL,NULL),(8693,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 09:53:13.287367',161,0,_binary '','dashboard','减少结果行数的错误。null',13371339,31,2,NULL,2,NULL,NULL,NULL,NULL),(8694,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 09:53:13.285941',190,49,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8695,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 09:53:13.279024',222,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8696,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 09:53:14.475660',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8697,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 09:53:14.482688',178,49,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8698,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 09:53:14.493784',176,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8699,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 09:53:14.479508',275,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8700,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 09:58:28.794884',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8701,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 09:58:28.781425',177,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8702,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 09:58:28.786394',179,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 09:58:28.789073',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8704,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:29:48.365816',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8705,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:29:48.373490',131,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8706,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:29:48.382474',191,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8707,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:29:48.389686',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8708,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:33:08.996065',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8709,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:33:09.014934',149,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8710,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:33:09.024374',175,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8711,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:33:09.013178',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8712,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:36:53.680210',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:36:53.686733',152,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8714,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:36:53.687687',177,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:36:53.704370',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8716,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:37:33.881605',185,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8717,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:37:33.872085',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8718,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:37:33.882365',183,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8719,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:37:33.879010',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8720,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:37:36.702880',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8721,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:37:36.694230',172,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8722,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:37:36.698349',190,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8723,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:37:36.713115',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8724,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:39:21.361549',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8725,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:39:21.361911',153,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8726,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:39:21.353505',176,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:39:21.364225',248,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8728,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 10:55:48.020296',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8729,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 10:55:48.038694',195,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8730,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 10:55:48.025517',226,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8731,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 10:55:48.017236',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8732,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 12:14:26.075595',130,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8733,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 12:14:26.099550',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8734,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 12:14:26.079997',180,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8735,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 12:14:26.078221',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8736,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:00:44.463001',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8737,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:00:44.457050',193,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8738,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:00:44.461905',241,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8739,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:00:44.465908',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8740,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:00:55.557291',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8741,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:00:55.572553',147,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8742,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:00:55.619482',164,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8743,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:00:55.573689',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8744,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:00:58.453269',126,73,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8745,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:00:58.459488',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8746,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:00:58.465927',184,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8747,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:00:58.461884',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8748,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:13:21.699744',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8749,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:13:21.721100',144,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8750,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:13:21.728132',155,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8751,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:13:21.723965',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8752,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:13:24.426244',109,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8753,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:13:24.434881',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8754,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:13:24.432261',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8755,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:13:33.315489',67,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8756,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:13:33.392122',117,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8757,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:13:33.366002',153,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8758,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:13:33.350959',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8759,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:14:06.326439',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8760,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:14:06.347027',150,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8761,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:14:06.355778',149,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8762,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:14:06.323280',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8763,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 14:20:37.473135',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8764,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 14:20:37.481989',183,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8765,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 14:20:37.484981',187,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8766,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 14:20:37.485260',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8767,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 15:05:56.065271',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8768,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 15:05:56.057691',176,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8769,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 15:05:56.060809',183,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8770,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 15:05:56.055074',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8771,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 18:56:08.699057',120,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8772,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 18:56:08.702401',157,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8773,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 18:56:08.700787',174,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8774,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 18:56:08.713200',283,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8775,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 19:56:15.253329',126,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8776,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 19:56:15.261831',185,96,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8777,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 19:56:15.249356',220,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8778,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 19:56:15.255487',322,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8779,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 20:02:23.809188',208,96,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8780,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 20:02:23.810634',215,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 20:02:23.820274',192,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8782,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 20:02:23.806704',309,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8783,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 20:51:16.858329',157,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8784,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 20:51:16.854843',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8785,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 20:51:16.854628',178,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8786,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 20:51:16.855363',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8787,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 21:12:31.396519',190,102,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8788,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 21:12:31.400226',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8789,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 21:12:31.380185',313,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8790,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 21:12:31.386314',507,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8791,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 21:28:56.945536',133,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8792,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 21:28:56.985650',143,102,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8793,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 21:28:56.973342',186,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8794,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 21:28:56.959275',312,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8795,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 21:44:13.094700',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8796,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 21:44:13.081775',192,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8797,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 21:44:13.084315',186,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8798,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 21:44:13.076141',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8799,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:40:35.594269',192,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8800,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:40:35.584732',194,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8801,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:40:35.590651',220,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8802,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:40:35.593426',359,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8803,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:47:14.820865',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8804,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:47:14.844392',197,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8805,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:47:14.841399',216,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8806,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:47:14.825670',376,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8807,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:52:41.001858',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8808,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:52:41.021498',237,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8809,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:52:41.009934',184,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8810,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:52:41.034513',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8811,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:52:51.108651',97,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8812,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:52:51.108635',171,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8813,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:52:51.141024',145,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8814,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:52:51.123985',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8815,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:52:53.006336',150,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8816,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:52:53.019629',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8817,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:52:53.005990',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8818,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:54:54.402791',255,288,_binary '','question',NULL,13371345,29,NULL,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8819,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:55:11.472245',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8820,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:55:11.463982',175,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8821,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:55:11.462310',185,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8822,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:55:11.463989',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8823,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:55:24.342827',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8824,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:55:24.347560',211,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8825,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:55:24.359973',204,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8826,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:55:24.347818',367,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8827,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-13 23:55:26.339983',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8828,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-13 23:55:26.329331',164,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8829,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-13 23:55:26.348136',153,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8830,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-13 23:55:26.341437',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8831,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 00:21:07.729058',159,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8832,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 00:21:07.724781',176,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8833,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 00:21:07.713132',177,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8834,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 00:21:07.724770',294,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8835,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:09:48.090413',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8836,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:09:48.101108',169,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8837,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:09:48.114521',185,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8838,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:09:48.097433',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8839,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:09:59.289982',165,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8840,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:09:59.294210',192,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8841,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:09:59.284305',199,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8842,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:09:59.287059',317,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8843,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:10:03.323008',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8844,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:10:03.293896',187,111,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8845,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:10:03.283658',222,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8846,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:10:03.303021',356,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8847,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:32:27.836970',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8848,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:32:27.887387',162,111,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8849,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:32:27.897230',193,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8850,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:32:27.879238',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8851,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:48:03.055141',94,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8852,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:48:03.023049',156,111,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8853,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:48:03.039229',194,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8854,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:48:03.060236',280,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8855,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:50:35.386689',85,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8856,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:50:35.350976',131,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8857,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:50:35.401327',149,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8858,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:50:35.391900',286,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8859,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 01:50:39.939738',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8860,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 01:50:39.941677',155,111,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8861,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 01:50:39.939775',194,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8862,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 01:50:39.952133',281,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8863,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 02:01:55.151864',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8864,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 02:01:55.160561',211,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8865,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 02:01:55.153040',239,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8866,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 02:01:55.163454',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8867,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 02:01:58.057290',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8868,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 02:01:58.060053',151,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8869,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 02:01:58.061143',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8870,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 02:05:36.059837',184,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8871,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 02:05:36.069426',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8872,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 02:05:36.070277',175,112,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8873,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 02:05:36.068013',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8874,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 03:23:01.701300',90,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8875,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 03:23:01.720054',196,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8876,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 03:23:01.734156',194,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8877,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 03:23:01.705802',337,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8878,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 03:23:08.739108',178,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8879,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 03:23:08.733515',197,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8880,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 03:23:08.744046',195,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8881,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 03:23:08.719567',359,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8882,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 03:37:24.878370',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8883,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 03:37:24.882434',218,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8884,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 03:37:24.880985',231,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8885,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 03:37:24.872560',379,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8886,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 03:41:56.741544',135,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8887,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 03:41:56.728082',179,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8888,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 03:41:56.736898',187,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8889,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 03:41:56.752004',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8890,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 03:42:00.733643',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8891,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 03:42:00.811984',161,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8892,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 03:42:00.798447',181,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8893,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 03:42:00.732746',303,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8894,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 03:42:08.306254',264,119,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8895,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 03:42:08.297526',285,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8896,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 03:42:08.309103',275,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8897,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 03:42:08.311238',433,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8898,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 04:12:03.148688',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8899,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 04:12:03.186791',185,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8900,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 04:12:03.200315',180,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8901,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 04:12:03.156306',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8902,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 04:27:05.675737',79,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8903,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 04:27:05.730319',179,121,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8904,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 04:27:05.744808',222,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8905,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 04:27:05.733621',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8906,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 05:02:55.158529',162,124,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8907,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 05:02:55.163156',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8908,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 05:02:55.145203',195,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8909,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 05:02:55.150940',300,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8910,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 05:09:24.899375',153,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8911,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 05:09:24.899375',170,124,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8912,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 05:09:24.907698',196,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8913,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 05:09:24.915928',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8914,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 05:19:04.322324',45,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8915,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 05:19:04.423639',143,124,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8916,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 05:19:04.430530',150,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8917,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 05:19:04.421463',288,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8918,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 05:19:08.188387',190,90,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8919,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 05:19:08.207758',175,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8920,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 05:19:08.222876',181,124,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8921,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 05:19:08.181392',372,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:08:33.539049',176,126,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8923,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:08:33.573811',179,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8924,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:08:33.548528',229,90,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8925,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:08:33.558860',303,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8926,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:15:34.510793',97,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8927,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:15:34.500132',177,127,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8928,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:15:34.492923',207,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8929,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:15:34.510210',313,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8930,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:16:51.090743',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8931,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:16:51.093670',167,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8932,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:16:51.096439',173,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8933,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:16:51.095025',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8934,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:17:03.631258',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8935,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:17:03.670868',162,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8936,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:17:03.635952',184,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8937,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:17:03.658897',271,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8938,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:17:05.575516',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8939,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:17:05.581838',195,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8940,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:17:05.580486',230,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8941,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:17:05.594307',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8942,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:25:39.702358',201,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8943,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:25:39.719918',194,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8944,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:25:39.729656',256,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8945,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:25:39.709908',487,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8946,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 06:52:44.942657',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8947,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 06:52:44.925390',191,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8948,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 06:52:44.931281',215,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8949,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 06:52:44.930191',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8950,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:11:01.051459',185,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8951,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:11:01.081905',268,127,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8952,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:11:01.384511',217,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8953,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:11:01.388751',231,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8954,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:11:01.074911',563,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8955,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:11:01.390036',305,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:11:01.068076',741,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8957,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:11:01.349029',497,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8958,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:18:15.750974',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8959,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:18:15.754326',175,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8960,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:18:15.759898',179,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8961,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:18:15.754326',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8962,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:22:39.095487',96,127,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8963,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:22:39.081227',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8964,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:22:39.094028',166,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8965,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:22:39.078415',280,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8966,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:29:35.803325',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8967,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:29:35.810149',144,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8968,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:29:35.799018',193,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8969,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:29:35.823886',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8970,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:29:49.039469',132,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8971,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:29:49.040705',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8972,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:29:49.067946',140,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8973,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:29:49.042684',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8974,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:29:51.865606',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8975,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:29:51.867384',139,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8976,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:29:51.882146',163,90,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8977,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:29:51.875340',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8978,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 07:58:53.780534',105,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8979,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 07:58:53.776037',103,128,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8980,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 07:58:53.805090',160,90,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8981,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 07:58:53.793840',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8982,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:09:34.963520',131,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8983,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:09:34.973947',133,1,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8984,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:09:34.958442',163,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8985,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:09:34.960633',276,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8986,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:09:42.042265',127,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8987,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:09:42.055287',125,1,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8988,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:09:42.052327',163,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8989,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:09:42.049496',261,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8990,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:09:46.083559',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8991,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:09:46.091194',146,1,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8992,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:09:46.090307',177,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8993,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:09:46.092617',268,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:09:49.599504',135,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8995,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:09:49.656265',112,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:09:49.602596',229,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:11:12.630575',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:11:12.639239',213,1,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(8999,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:11:12.641330',273,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9000,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:11:12.644719',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9001,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:37:54.388227',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9002,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:37:54.394647',145,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9003,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:37:54.394673',172,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9004,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:37:54.383654',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9005,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:43:48.686475',140,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9006,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:43:48.690537',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9007,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:43:48.706443',151,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9008,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:43:48.707536',267,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9009,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:44:01.339444',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9010,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:44:01.354739',180,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9011,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:44:01.352498',225,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9012,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:44:01.335426',351,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9013,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:44:04.262994',155,33,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9014,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:44:04.262192',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9015,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:44:04.278147',147,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9016,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:44:04.272181',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9017,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 08:50:17.889503',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 08:50:17.914244',113,33,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9019,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 08:50:17.912657',178,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 08:50:17.899261',255,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 09:06:21.784895',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9022,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 09:06:21.792460',178,38,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9023,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 09:06:21.793823',198,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9024,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 09:06:21.796103',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9025,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 09:38:13.866947',154,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9026,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 09:38:13.878517',168,42,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9027,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 09:38:13.871318',190,91,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9028,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 09:38:13.862815',293,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9029,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 10:08:04.189681',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9030,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 10:08:04.189723',181,52,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9031,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 10:08:04.196314',176,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 10:08:04.189989',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9033,_binary '???\?\\?!.-\?y?x \?-Ye@]\????','2024-07-14 10:08:20.416405',146,91,_binary '','csv-download',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9034,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 10:23:54.224109',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9035,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 10:23:54.242387',179,55,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9036,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 10:23:54.238381',203,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9037,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 10:23:54.228890',277,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9038,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 10:27:53.979371',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9039,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 10:27:54.020976',155,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9040,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 10:27:54.015044',168,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9041,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 10:27:54.016251',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9042,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 10:41:30.882230',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9043,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 10:41:30.891217',187,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9044,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 10:41:30.893788',178,56,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9045,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 10:41:30.872940',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9046,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 10:59:36.153490',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9047,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 10:59:36.163406',193,57,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9048,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 10:59:36.176758',181,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9049,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 10:59:36.151279',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9050,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 13:01:27.137283',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9051,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 13:01:27.137744',197,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9052,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 13:01:27.148633',264,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9053,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 13:01:27.146729',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9054,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 17:03:24.594637',192,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9055,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 17:03:24.614463',138,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9056,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 17:03:24.617258',159,80,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9057,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 17:03:24.601083',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9058,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 17:48:52.940302',170,82,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9059,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 17:48:52.928512',173,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9060,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 17:48:52.926484',202,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9061,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 17:48:52.927643',328,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9062,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 18:09:12.585472',102,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 18:09:12.568260',170,85,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9064,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 18:09:12.571353',202,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9065,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 18:09:12.595272',326,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9066,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 20:46:52.561285',107,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9067,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 20:46:52.569091',104,97,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9068,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 20:46:52.589941',165,91,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9069,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 20:46:52.580185',283,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9070,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 21:19:35.660469',175,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9071,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 21:19:35.658351',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9072,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 21:19:35.651477',219,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9073,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 21:19:35.661810',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9074,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 21:23:46.286769',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9075,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 21:23:46.293172',201,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9076,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 21:23:46.293160',203,98,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9077,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 21:23:46.289544',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9078,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 22:04:21.527238',150,99,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9079,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 22:04:21.509377',238,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9080,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 22:04:21.496207',266,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9081,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 22:04:21.524898',403,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9082,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 22:16:09.845509',197,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9083,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 22:16:09.829902',209,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9084,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 22:16:09.835892',224,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9085,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 22:16:09.836994',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9086,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 22:28:31.758982',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9087,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 22:28:31.765274',199,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9088,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 22:28:31.768045',215,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9089,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 22:28:31.746702',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9090,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 22:28:43.553347',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9091,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 22:28:43.555625',162,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9092,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 22:28:43.546001',202,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9093,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 22:28:43.575709',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9094,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 22:28:45.534991',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9095,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 22:28:45.537398',162,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9096,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 22:28:45.535263',209,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9097,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 22:28:45.531067',378,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9098,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 23:42:44.633427',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9099,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 23:42:44.697246',182,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9100,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 23:42:44.712155',179,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9101,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 23:42:44.645560',394,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9102,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 23:42:47.440146',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9103,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 23:42:47.445316',201,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 23:42:47.435542',396,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9105,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 23:44:16.644712',188,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9106,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 23:44:16.663377',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9107,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 23:44:16.667842',203,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9108,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 23:44:16.646287',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9109,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 23:45:29.653366',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9110,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 23:45:29.641774',180,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9111,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 23:45:29.657584',192,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9112,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 23:45:29.642638',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 23:45:31.630246',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9114,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 23:45:31.649954',112,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9115,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 23:45:31.644715',261,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9116,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-14 23:54:01.779967',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-14 23:54:01.794169',193,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9118,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-14 23:54:01.789345',244,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9119,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-14 23:54:01.792502',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9120,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:00:25.337806',193,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9121,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:00:25.331526',228,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9122,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:00:25.335174',268,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9123,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:00:25.346976',409,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9124,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:00:39.339673',192,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:00:39.340448',172,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9126,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:00:39.345370',208,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9127,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:00:39.338235',304,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9128,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:00:40.665096',82,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9129,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:00:40.688095',115,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9130,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:00:40.673519',163,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9131,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:21:52.182348',151,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9132,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:21:52.190503',178,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9133,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:21:52.204205',189,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9134,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:21:52.184418',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9135,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:22:01.972259',135,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9136,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:22:01.978110',179,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9137,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:22:01.984206',179,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9138,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:22:01.975447',312,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9139,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:22:05.626847',155,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9140,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:22:05.611207',181,106,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9141,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:22:05.613836',207,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9142,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:22:05.624573',293,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9143,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:30:19.773691',186,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9144,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:30:19.787150',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9145,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:30:19.817575',204,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9146,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:30:19.789669',357,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9147,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:39:58.864634',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9148,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:39:58.874842',177,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9149,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:39:58.891409',214,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9150,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:39:58.877695',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9151,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:46:40.604504',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9152,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:46:40.645910',137,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9153,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:46:40.615046',192,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9154,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:46:40.623320',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9155,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:46:43.484443',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9156,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:46:43.565169',176,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9157,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:46:43.553988',189,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9158,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:46:43.511993',388,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9159,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:46:51.464322',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9160,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:46:51.499228',156,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9161,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:46:51.476086',240,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9162,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:46:51.509616',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9163,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:47:19.673806',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9164,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:47:19.712745',150,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9165,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:47:19.693544',197,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9166,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:47:19.686215',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9167,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:49:55.926203',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9168,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:49:55.916075',159,106,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9169,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:49:55.955379',184,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9170,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:49:55.936849',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9171,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:57:49.108713',196,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9172,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:57:49.132933',196,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9173,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:57:49.115339',228,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9174,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:57:49.131382',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9175,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 00:57:51.063403',143,108,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9176,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 00:57:51.063284',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9177,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 00:57:51.080143',207,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9178,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 00:57:51.072809',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9179,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 01:14:02.161348',137,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9180,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 01:14:02.160671',170,108,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9181,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 01:14:02.171955',192,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9182,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 01:14:02.162403',322,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9183,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 02:41:31.364133',147,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9184,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 02:41:31.372945',161,115,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9185,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 02:41:31.375495',214,91,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9186,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 02:41:31.363197',320,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9187,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 03:19:19.987778',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9188,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 03:19:20.003659',231,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9189,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 03:19:19.981189',247,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9190,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 03:19:20.017730',381,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9191,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 03:35:04.942798',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9192,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 03:35:04.957667',170,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9193,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 03:35:04.951969',230,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9194,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 03:35:04.954175',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9195,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 04:17:08.573066',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9196,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 04:17:08.598814',111,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9197,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 04:17:08.584679',225,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9198,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 04:17:08.618270',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9199,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 04:32:45.125283',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9200,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 04:32:45.119742',187,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9201,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 04:32:45.130070',192,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9202,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 04:32:45.127512',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9203,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 04:32:56.717455',156,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9204,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 04:32:56.716561',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9205,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 04:32:56.719957',169,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9206,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 04:32:56.710948',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9207,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 04:32:59.037291',172,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9208,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 04:32:59.022638',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9209,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 04:32:59.050405',185,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9210,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 04:32:59.027004',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9211,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 04:39:15.394479',217,121,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9212,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 04:39:15.405269',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9213,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 04:39:15.381356',264,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9214,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 04:39:15.383371',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9215,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:02:31.420892',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9216,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:02:31.427268',214,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9217,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:02:31.417626',233,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9218,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:02:31.423312',364,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9219,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:20:22.099178',158,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9220,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:20:22.112693',185,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9221,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:20:22.097857',213,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9222,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:20:22.101569',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9223,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:20:25.226120',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9224,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:20:25.215446',211,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9225,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:20:25.243821',183,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9226,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:20:25.237016',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9227,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:21:17.296216',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9228,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:21:17.296494',186,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9229,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:21:17.323920',213,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9230,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:21:17.304149',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9231,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:21:28.080669',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9232,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:21:28.082240',170,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9233,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:21:28.071908',188,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9234,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:21:28.089868',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9235,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:21:30.036108',129,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9236,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:21:29.989093',203,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9237,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:21:30.021318',161,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9238,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:21:30.013655',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9239,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:31:51.672667',177,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9240,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:31:51.645624',196,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9241,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:31:51.691169',175,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9242,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:31:51.660399',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9243,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:31:54.476423',112,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9244,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:31:54.492613',188,123,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9245,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:31:54.501723',188,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9246,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:31:54.480096',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9247,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:47:26.795859',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9248,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:47:26.799026',169,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9249,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:47:26.832522',178,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9250,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:47:26.818708',407,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9251,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 05:58:56.598343',140,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9252,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 05:58:56.592929',164,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9253,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 05:58:56.576332',160,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9254,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 05:58:56.584340',336,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9255,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:00:05.686085',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9256,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:00:05.695258',172,126,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9257,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:00:05.693431',224,91,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9258,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:00:05.696115',355,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9259,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:06:43.371941',168,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9260,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:06:43.372943',195,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9261,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:06:43.366758',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9262,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:06:43.370424',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9263,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:07:56.284438',164,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9264,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:07:56.298436',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9265,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:07:56.296377',179,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9266,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:07:56.285559',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9267,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:10:07.181599',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9268,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:10:07.180406',178,126,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9269,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:10:07.214654',202,91,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9270,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:10:07.172246',351,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9271,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:26:13.573611',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9272,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:26:13.592906',154,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9273,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:26:13.577558',203,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9274,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:26:13.596453',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9275,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:26:16.629682',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9276,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:26:16.631550',190,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9277,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:26:16.646949',185,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9278,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:26:16.635831',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9279,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:26:24.538022',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9280,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:26:24.551349',163,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9281,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:26:24.552905',188,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9282,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:26:24.513927',375,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9283,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:26:27.331090',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9284,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:26:27.350196',203,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9285,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:26:27.334642',266,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9286,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:26:27.335012',370,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9287,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 06:27:40.280321',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9288,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 06:27:40.288009',156,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9289,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 06:27:40.276506',240,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9290,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 06:27:40.272385',377,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9291,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:24:46.862912',71,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9292,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:24:46.883050',193,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9293,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:24:46.884316',206,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9294,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:24:46.869280',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:24:49.650425',119,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9296,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:24:49.648304',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9297,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:24:49.664856',247,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9298,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:24:57.990035',205,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9299,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:24:58.013196',229,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9300,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:24:57.993907',263,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9301,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:24:58.020825',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9302,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:35:05.590314',183,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9303,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:35:05.597117',198,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9304,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:35:05.596341',247,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9305,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:35:05.584749',358,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9306,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:44:42.630376',195,132,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9307,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:44:42.644312',191,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9308,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:44:42.642738',243,91,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9309,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:44:42.647189',367,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:49:16.762261',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9311,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:49:16.781441',177,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9312,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:49:16.785188',191,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9313,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:49:16.753386',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:52:39.293094',154,133,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9315,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:52:39.285753',172,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9316,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:52:39.285122',175,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9317,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:52:39.283899',289,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9318,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:52:48.645667',149,133,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9319,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:52:48.640266',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9320,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:52:48.646829',156,91,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9321,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:52:48.645695',277,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9322,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 07:59:45.779898',85,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9323,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 07:59:45.791319',154,133,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9324,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 07:59:45.792261',176,91,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9325,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 07:59:45.785948',307,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9326,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 08:01:42.257254',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9327,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 08:01:42.248860',203,91,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9328,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 08:01:42.262349',185,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9329,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 08:01:42.255192',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9330,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 08:13:59.426821',146,18,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9331,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 08:13:59.429202',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9332,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 08:13:59.399678',327,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9333,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 08:13:59.430522',364,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9334,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 08:15:06.016362',171,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9335,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 08:15:06.014293',184,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9336,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 08:15:06.015202',203,18,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9337,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 08:15:06.013852',309,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9338,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 08:18:17.821679',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9339,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 08:18:17.834220',164,18,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9340,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 08:18:17.829633',206,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9341,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 08:18:17.831968',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9342,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 08:30:23.566728',127,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9343,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 08:30:23.554026',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9344,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 08:30:23.556601',241,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9345,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 08:30:23.554857',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9346,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 08:46:54.677485',121,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9347,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 08:46:54.681383',181,35,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9348,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 08:46:54.686694',195,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9349,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 08:46:54.683775',316,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9350,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 09:31:32.796310',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9351,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 09:31:32.831204',195,44,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9352,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 09:31:32.813791',304,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9353,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 09:31:32.823133',375,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9354,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 09:37:44.045090',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9355,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 09:37:44.045105',199,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9356,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 09:37:44.062028',208,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9357,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 09:37:44.055502',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9358,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 10:08:09.810028',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9359,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 10:08:09.796274',187,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9360,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 10:08:09.814495',208,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9361,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 10:08:09.794519',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9362,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 10:08:12.644993',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9363,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 10:08:12.643982',194,50,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9364,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 10:08:12.642022',217,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9365,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 10:08:12.646507',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 10:21:07.990381',73,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9367,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 10:21:08.020753',188,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9368,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 10:21:08.022853',206,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9369,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 10:21:07.998504',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9370,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 10:21:19.351036',140,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9371,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 10:21:19.350721',161,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9372,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 10:21:19.349277',175,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9373,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 10:21:19.343826',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9374,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 10:21:22.770381',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9375,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 10:21:22.827945',160,52,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9376,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 10:21:22.833010',174,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9377,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 10:21:22.827945',246,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9378,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 10:31:24.588929',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 10:31:24.582951',186,59,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9380,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 10:31:24.592377',188,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9381,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 10:31:24.583374',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9382,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 11:25:29.613073',81,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9383,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 11:25:29.618894',152,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9384,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 11:25:29.632052',160,65,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9385,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 11:25:29.631879',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9386,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 11:26:06.607342',89,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9387,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 11:26:06.646594',163,65,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9388,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 11:26:06.655886',192,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9389,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 11:26:06.653263',276,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9390,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 11:56:38.163540',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9391,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 11:56:38.180741',169,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9392,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 11:56:38.198517',189,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9393,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 11:56:38.165499',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9394,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 11:56:39.189945',100,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9395,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 11:56:39.191733',109,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9396,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 11:56:39.189688',136,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 11:56:47.815680',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9398,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 11:56:47.851037',147,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9399,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 11:56:47.842381',165,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9400,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 11:56:47.855119',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9401,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 11:56:51.792296',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9402,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 11:56:51.861157',155,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9403,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 11:56:51.872180',151,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9404,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 11:56:51.822560',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9405,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 12:49:24.526498',183,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9406,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 12:49:24.532253',201,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9407,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 12:49:24.521926',257,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9408,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 12:49:24.530512',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9409,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 16:07:35.170851',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9410,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 16:07:35.193418',177,79,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9411,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 16:07:35.191428',215,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9412,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 16:07:35.177763',314,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9413,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 16:36:06.980858',128,82,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9414,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 16:36:06.993368',164,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9415,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 16:36:07.010490',199,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9416,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 16:36:07.008290',310,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9417,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 17:05:39.805159',200,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9418,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 17:05:39.803014',195,82,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9419,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 17:05:39.804909',242,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9420,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 17:05:39.795693',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 19:07:17.450473',173,91,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9422,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 19:07:17.468241',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9423,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 19:07:17.454721',180,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9424,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 19:07:17.447223',369,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9425,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 20:26:48.574178',160,93,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9426,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 20:26:48.584644',166,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9427,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 20:26:48.605458',186,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9428,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 20:26:48.579193',308,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 20:34:40.071311',192,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9430,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 20:34:40.070239',197,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9431,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 20:34:40.072258',203,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9432,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 20:34:40.073007',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9433,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 20:37:49.458843',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9434,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 20:37:49.458908',135,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9435,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 20:37:49.461267',179,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9436,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 20:37:49.459696',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9437,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 20:37:52.888418',110,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9438,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 20:37:52.979702',110,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9439,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 20:37:52.976158',156,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9440,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 20:37:52.881396',384,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9441,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 21:49:26.243002',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9442,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 21:49:26.266426',188,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9443,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 21:49:26.268985',178,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9444,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 21:49:26.218991',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9445,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 21:49:37.346452',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9446,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 21:49:37.343731',150,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9447,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 21:49:37.340458',175,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9448,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 21:49:37.345440',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9449,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 21:49:40.147539',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9450,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 21:49:40.133398',210,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9451,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 21:49:40.150095',223,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9452,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 21:49:40.117488',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9453,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 22:02:00.935532',145,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9454,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:02:00.932899',157,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9455,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 22:02:00.931373',196,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9456,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:02:00.937209',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9457,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 22:04:39.865544',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9458,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:04:39.879020',154,99,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9459,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 22:04:39.856212',216,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9460,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:04:39.893837',268,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9461,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 22:08:00.091986',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9462,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:08:00.085194',184,99,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9463,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 22:08:00.092766',221,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9464,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:08:00.088456',376,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9465,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 22:13:33.550035',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9466,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:13:33.547287',181,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9467,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 22:13:33.535805',205,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9468,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:13:33.533052',373,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9469,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:19:51.302749',175,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9470,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 22:19:51.307295',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9471,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 22:19:51.309406',176,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9472,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:19:51.290888',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9473,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:20:02.697953',182,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9474,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 22:20:02.701558',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9475,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 22:20:02.699335',210,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9476,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:20:02.685174',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9477,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 22:20:05.440334',90,100,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9478,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 22:20:05.438708',226,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9479,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 23:09:03.725348',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9480,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 23:09:03.725348',202,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9481,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 23:09:03.740018',242,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9482,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 23:09:03.738141',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9483,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 23:09:04.530371',73,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9484,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 23:09:04.533087',122,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9485,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 23:09:25.687264',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9486,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 23:09:25.696611',182,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9487,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 23:09:25.697996',200,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9488,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 23:09:25.698060',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9489,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 23:09:38.610793',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9490,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 23:09:38.611677',162,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9491,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 23:09:38.638735',177,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9492,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 23:09:38.632174',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9493,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-15 23:09:41.452758',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9494,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-15 23:09:41.442481',203,104,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9495,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-15 23:09:41.454825',249,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9496,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-15 23:09:41.441860',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9497,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:15:15.192841',154,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9498,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:15:15.199351',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9499,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:15:15.189884',202,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9500,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:15:15.190164',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9501,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:35:02.020902',181,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9502,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:35:02.024966',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9503,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:35:02.028256',216,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9504,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:35:02.030655',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9505,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:36:24.848909',151,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9506,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:36:24.853620',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9507,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:36:24.847181',214,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9508,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:36:24.856205',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9509,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:40:47.797406',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9510,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:40:47.800730',190,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9511,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:40:47.796718',187,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9512,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:40:47.801888',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9513,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:40:58.964958',48,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9514,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:40:58.976032',197,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9515,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:40:59.004224',152,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9516,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:40:58.985904',374,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9517,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:40:59.608112',123,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9518,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:40:59.607251',117,109,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9519,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:40:59.631474',167,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9520,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:40:59.616277',282,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9521,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:41:01.156326',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9522,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:41:01.196868',144,109,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9523,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:41:01.207980',168,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9524,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:41:01.204888',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9525,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:46:04.044063',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9526,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:46:04.076835',187,110,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9527,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:46:04.061176',214,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9528,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:46:04.051298',380,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9529,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:48:18.766422',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9530,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:48:18.765761',177,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9531,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:48:18.780320',181,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9532,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:48:18.763097',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9533,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 00:48:27.712730',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9534,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 00:48:27.729833',128,110,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9535,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 00:48:27.716501',182,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9536,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 00:48:27.722123',291,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9537,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 02:14:12.706830',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9538,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 02:14:12.719286',147,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9539,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 02:14:12.702631',203,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9540,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 02:14:12.705161',376,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9541,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 02:15:03.058668',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9542,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 02:15:03.041434',153,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9543,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 02:15:03.068790',172,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9544,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 02:15:03.048043',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9545,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 02:15:06.085987',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9546,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 02:15:06.114495',186,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9547,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 02:15:06.106413',214,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9548,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 02:15:06.089362',379,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9549,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 02:37:07.650349',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9550,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 02:37:07.652698',173,117,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9551,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 02:37:07.643923',220,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9552,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 02:37:07.659430',309,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9553,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 03:00:26.488287',137,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9554,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 03:00:26.481081',172,118,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9555,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 03:00:26.483932',176,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9556,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 03:00:26.500040',280,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9557,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 03:00:41.879269',98,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9558,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 03:00:41.938097',156,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9559,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 03:00:41.947704',163,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9560,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 03:00:41.941007',309,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9561,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 03:00:51.874913',176,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9562,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 03:00:51.873977',188,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9563,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 03:00:51.873105',208,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9564,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 03:00:51.870476',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9565,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 03:00:54.822411',142,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9566,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 03:00:54.833389',197,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9567,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 03:00:54.823308',233,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9568,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 03:00:54.804972',363,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9569,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 03:00:58.701390',168,118,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9570,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 03:00:58.703891',198,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9571,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 03:00:58.701246',221,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9572,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 03:00:58.703926',329,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9573,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:01:31.324573',157,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9574,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:01:31.317769',188,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9575,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:01:31.326194',211,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9576,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:01:31.330218',337,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9577,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:09:21.063802',107,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9578,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:09:21.074439',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9579,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:09:21.075371',172,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9580,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:09:21.076192',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9581,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:13:47.648443',150,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9582,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:13:47.642436',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9583,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:13:47.643696',228,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9584,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:13:47.654060',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:13:50.552293',275,120,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9586,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:13:50.587011',274,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9587,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:13:50.599596',275,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9588,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:13:50.599468',423,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9589,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:23:03.665282',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9590,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:23:03.676205',154,120,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9591,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:23:03.664784',219,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9592,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:23:03.677393',285,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9593,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:27:54.056516',228,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9594,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:27:54.061951',215,120,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9595,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:27:54.043112',252,92,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9596,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:27:54.045822',337,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9597,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:29:35.730394',172,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9598,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:29:35.759756',158,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9599,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:29:35.748168',181,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9600,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:29:35.727993',344,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9601,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:29:46.276449',143,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9602,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:29:46.306738',189,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9603,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:29:46.331374',205,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9604,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:29:46.316794',338,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9605,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:29:49.833893',145,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9606,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:29:49.842965',174,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9607,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:29:49.838177',181,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9608,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:29:49.845108',425,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9609,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:38:48.341093',168,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9610,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:38:48.364361',153,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9611,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:38:48.345458',179,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9612,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:38:48.344187',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9613,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:43:12.396281',172,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9614,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:43:12.416128',189,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9615,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:43:12.396572',229,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9616,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:43:12.396332',280,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9617,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:43:23.283209',197,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9618,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:43:23.286362',209,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9619,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:43:23.290849',183,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9620,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:43:23.300809',322,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9621,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 04:43:26.632457',132,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9622,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 04:43:26.631446',167,120,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9623,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 04:43:26.669191',165,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9624,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 04:43:26.625993',315,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9625,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 06:01:11.150338',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9626,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 06:01:11.178095',192,125,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9627,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 06:01:11.179590',249,92,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9628,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 06:01:11.187064',325,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9629,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 06:06:38.112422',163,126,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9630,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 06:06:38.104031',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9631,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 06:06:38.103773',243,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9632,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 06:06:38.105509',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9633,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:10:17.530723',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9634,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:10:17.520326',198,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9635,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:10:17.511220',247,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9636,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:10:17.532914',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9637,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:19:37.089921',189,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9638,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:19:37.079467',195,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9639,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:19:37.091418',193,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9640,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:19:37.083103',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9641,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:45:50.122882',243,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9642,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:45:50.118745',258,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9643,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:45:50.122091',374,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9644,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:45:50.162852',439,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9645,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:46:33.545468',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9646,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:46:33.544402',178,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9647,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:46:33.548488',194,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9648,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:46:33.547448',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9649,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:50:26.051626',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9650,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:50:26.040914',175,130,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9651,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:50:26.055386',201,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9652,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:50:26.033279',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9653,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:54:30.245534',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9654,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:54:30.237983',175,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9655,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:54:30.239148',197,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9656,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:54:30.231509',326,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9657,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:54:43.745230',161,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9658,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:54:43.758071',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9659,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:54:43.754357',179,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9660,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:54:43.756630',263,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9661,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:54:48.000314',168,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9662,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:54:48.000861',176,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9663,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:54:48.013348',183,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9664,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:54:47.986153',324,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9665,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:57:43.594526',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9666,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:57:43.599550',195,134,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9667,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:57:43.603979',226,92,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9668,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:57:43.612221',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9669,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:58:06.608286',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9670,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:58:06.627998',130,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9671,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:58:06.637163',151,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9672,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:58:06.615990',293,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9673,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:58:29.096567',159,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9674,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:58:29.090316',175,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9675,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:58:29.108783',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9676,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:58:29.092744',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9677,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:58:46.612455',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9678,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:58:46.587221',177,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9679,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:58:46.558128',192,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9680,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:58:46.594092',259,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 07:58:50.165373',259,134,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9682,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 07:58:50.233732',256,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9683,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 07:58:50.222434',371,92,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9684,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 07:58:50.237092',422,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9685,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:02:38.849375',164,6,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9686,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:02:38.875270',196,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9687,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:02:38.882801',237,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9688,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:02:38.891295',354,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9689,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:02:39.717269',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9690,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:02:39.779299',136,6,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9691,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:02:39.791979',168,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9692,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:02:39.721351',297,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:02:55.555095',73,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9694,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:02:55.526125',185,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9695,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:02:55.545966',154,6,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9696,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:02:55.517366',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9697,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:02:59.183463',102,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9698,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:02:59.172897',125,6,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9699,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:02:59.184483',263,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9700,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:03:37.773294',77,6,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9701,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:03:37.781053',134,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9702,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:03:37.770434',159,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:03:37.808672',254,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9704,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:06:30.390076',140,6,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9705,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:06:30.398755',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9706,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:06:30.395950',223,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9707,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:06:30.387046',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9708,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:40:13.446417',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9709,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:40:13.432428',194,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9710,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:40:13.444037',191,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9711,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:40:13.427545',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9712,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:49:42.578111',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:49:42.587832',195,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9714,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:49:42.582949',231,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:49:42.579879',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9716,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:49:51.400425',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9717,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:49:51.417067',182,36,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9718,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:49:51.420415',194,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9719,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:49:51.405640',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9720,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:53:57.252829',176,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9721,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:53:57.242150',196,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9722,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:53:57.235837',213,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9723,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:53:57.235826',303,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9724,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:54:01.758835',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9725,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:54:01.768127',172,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9726,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:54:01.753905',183,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:54:01.749456',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9728,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:54:08.191516',163,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9729,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 08:54:08.181557',174,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9730,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 08:54:08.177868',189,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9731,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:54:08.178812',297,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9732,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 08:54:11.649032',136,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9733,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 08:54:11.651350',228,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9734,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 09:00:56.231427',117,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9735,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 09:00:56.221029',162,41,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9736,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 09:00:56.228942',187,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9737,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 09:00:56.226375',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9738,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 09:21:09.118938',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9739,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 09:21:09.119487',141,49,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9740,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 09:21:09.127974',177,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9741,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 09:21:09.132565',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9742,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 09:37:10.946039',190,55,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9743,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 09:37:10.954350',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9744,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 09:37:10.961819',178,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9745,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 09:37:10.934218',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9746,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 09:49:17.954455',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9747,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 09:49:18.058639',144,55,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9748,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 09:49:18.044354',196,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9749,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 09:49:17.944769',359,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9750,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 09:52:32.582933',120,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9751,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 09:52:32.674227',144,59,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9752,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 09:52:32.683853',167,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9753,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 09:52:32.589189',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9754,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 09:59:43.678321',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9755,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 09:59:43.685225',191,59,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9756,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 09:59:43.667819',214,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9757,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 09:59:43.675381',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9758,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:03:37.379952',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9759,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:03:37.379333',170,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9760,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:03:37.396646',166,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9761,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:03:37.369665',278,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9762,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:28:08.275322',128,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9763,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:28:08.279728',177,68,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9764,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:28:08.277873',178,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9765,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:28:08.264957',317,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9766,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:28:11.157806',149,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9767,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:28:11.152800',160,68,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9768,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:28:11.152746',161,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9769,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:28:11.150663',291,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9770,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:33:34.815562',110,69,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9771,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:33:34.800768',151,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9772,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:33:34.806479',197,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9773,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:33:34.825865',285,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9774,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:42:22.417150',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9775,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:42:22.420110',141,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9776,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:42:22.418673',175,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9777,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:42:22.407188',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9778,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:51:49.571894',117,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9779,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:51:49.570946',172,69,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9780,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:51:49.585717',178,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9781,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:51:49.570946',287,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9782,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 10:54:26.637253',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9783,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 10:54:26.630614',141,69,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9784,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 10:54:26.639783',224,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9785,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 10:54:26.633379',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9786,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 11:53:58.112787',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9787,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 11:53:58.116475',184,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9788,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 11:53:58.120167',176,77,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9789,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 11:53:58.118061',276,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9790,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 12:48:00.188485',147,78,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9791,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 12:48:00.220997',170,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9792,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 12:48:00.196506',181,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9793,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 12:48:00.203884',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9794,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 13:45:30.248218',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9795,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 13:45:30.249782',174,82,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9796,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 13:45:30.258169',192,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9797,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 13:45:30.250924',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9798,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 13:51:35.921730',50,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9799,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 13:51:35.945936',169,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9800,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 13:51:35.941398',181,82,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9801,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 13:51:35.927575',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9802,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 13:51:38.627676',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9803,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 13:51:38.643004',149,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9804,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 13:51:38.633121',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9805,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 16:47:00.089286',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9806,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 16:47:00.081032',183,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 16:47:00.077558',185,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9808,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 16:47:00.097432',297,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9809,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 17:21:47.222204',184,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9810,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 17:21:47.204319',193,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9811,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 17:21:47.207309',210,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9812,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 17:21:47.212170',327,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9813,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 21:29:46.494020',150,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9814,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 21:29:46.506247',200,112,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9815,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 21:29:46.515695',194,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9816,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 21:29:46.491494',369,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9817,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 21:48:46.294981',97,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9818,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 21:48:46.282561',193,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9819,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 21:48:46.285565',198,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9820,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 21:48:46.296810',290,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9821,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:05:01.776235',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9822,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:05:01.784861',170,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9823,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:05:01.791542',189,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9824,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:05:01.767130',321,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9825,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:05:05.596060',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9826,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:05:05.602908',177,113,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9827,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:05:05.606197',214,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9828,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:05:05.618948',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9829,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:09:03.390469',136,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9830,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:09:03.386164',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9831,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:09:03.388651',173,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9832,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:09:03.391875',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:09:06.250698',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:09:06.249221',188,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9835,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:09:06.248358',201,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9836,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:09:06.249391',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9837,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:10:22.479537',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9838,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:10:22.460351',201,113,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9839,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:10:22.493507',227,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9840,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:10:22.490504',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9841,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:23:53.079835',112,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9842,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:23:53.077921',143,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9843,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:23:53.071701',192,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9844,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:23:53.076062',362,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9845,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:25:03.111741',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9846,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:25:03.114448',200,114,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9847,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:25:03.128326',203,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9848,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:25:03.092511',341,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9849,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:57:13.452131',124,116,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9850,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:57:13.448959',190,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9851,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:57:13.472230',166,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9852,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:57:13.467723',360,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9853,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 22:57:40.218541',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9854,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 22:57:40.221562',163,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9855,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 22:57:40.234714',188,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9856,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 22:57:40.236520',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9857,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 23:02:21.130430',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9858,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 23:02:21.156851',111,117,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9859,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 23:02:21.143312',186,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9860,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 23:02:21.131478',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9861,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 23:31:48.263296',134,117,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9862,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 23:31:48.283519',181,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9863,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 23:31:48.285251',205,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9864,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 23:31:48.268512',318,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9865,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 23:35:01.550612',169,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9866,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 23:35:01.556289',155,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9867,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 23:35:01.537691',222,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 23:35:01.568522',326,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9869,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 23:41:16.127870',161,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9870,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 23:41:16.027772',234,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9871,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 23:41:16.081420',215,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9872,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 23:41:16.040606',316,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-16 23:41:26.401101',168,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9874,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-16 23:41:26.408166',185,117,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9875,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-16 23:41:26.412049',245,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9876,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-16 23:41:26.403291',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9877,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 00:10:51.157326',163,118,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9878,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 00:10:51.172135',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9879,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 00:10:51.166842',211,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 00:10:51.151123',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 00:18:38.246423',128,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9882,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 00:18:38.234752',131,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9883,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 00:18:38.248364',199,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9884,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 00:18:38.236851',303,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9885,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 00:33:46.783847',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 00:33:46.782443',161,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9887,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 00:33:46.784912',231,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9888,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 00:33:46.801095',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9889,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 00:33:57.685367',175,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9890,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 00:33:57.688911',185,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9891,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 00:33:57.688988',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 00:33:57.686125',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9893,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 00:34:00.170862',194,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9894,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 00:34:00.163843',216,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9895,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 00:34:00.168441',212,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9896,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 00:34:00.169650',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9897,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 00:48:34.772222',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9898,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 00:48:34.772976',182,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9899,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 00:48:34.767210',199,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9900,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 00:48:34.783603',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9901,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 01:01:15.218079',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9902,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 01:01:15.225762',180,121,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9903,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 01:01:15.218097',257,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 01:01:15.237290',331,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 01:13:18.382004',104,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9906,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 01:13:18.446383',163,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9907,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 01:13:18.432336',177,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9908,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 01:13:18.367538',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9909,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 01:29:38.041536',71,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9910,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 01:29:38.082338',115,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9911,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 01:29:38.096739',175,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9912,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 01:29:38.085484',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9913,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 01:40:58.458553',146,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9914,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 01:40:58.457092',185,123,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9915,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 01:40:58.453397',230,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 01:40:58.483234',284,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 02:18:41.773273',59,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9918,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 02:18:41.887263',119,125,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9919,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 02:18:41.909387',134,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9920,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 02:18:41.771388',286,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9921,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 02:31:34.619743',201,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 02:31:34.632637',227,126,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9923,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 02:31:34.633763',246,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9924,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 02:31:34.620071',349,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9925,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 02:38:44.732358',177,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9926,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 02:38:44.734720',204,127,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 02:38:44.744365',245,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9928,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 02:38:44.727961',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9929,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 02:38:49.285353',128,127,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9930,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 02:38:49.306678',126,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9931,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 02:38:49.287686',195,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9932,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 02:38:49.288362',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9933,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:22:20.306093',137,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9934,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:22:20.319373',160,131,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9935,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:22:20.305521',196,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9936,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:22:20.307683',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9937,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:38:07.749466',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9938,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:38:07.768503',151,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9939,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:38:07.757331',197,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9940,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:38:07.761072',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9941,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:39:28.446063',177,132,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9942,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:39:28.463828',166,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9943,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:39:28.449181',200,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9944,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:39:28.442744',338,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9945,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:47:44.411798',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9946,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:47:44.402612',198,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9947,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:47:44.389368',236,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9948,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:47:44.398755',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9949,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:47:48.484906',181,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9950,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:47:48.476908',198,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9951,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:47:48.494287',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9952,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:47:48.479233',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9953,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:49:57.670207',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:49:57.694078',152,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9955,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:49:57.697008',178,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:49:57.676608',318,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9957,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 03:50:00.335279',150,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9958,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 03:50:00.330149',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9959,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 03:50:00.333322',218,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9960,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 03:50:00.345739',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 04:30:16.856632',182,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9962,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 04:30:16.863302',208,136,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9963,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 04:30:16.858357',278,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9964,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 04:30:16.855793',304,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9965,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 04:42:20.918631',150,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9966,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 04:42:20.916335',183,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9967,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 04:42:20.921166',222,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9968,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 04:42:20.930492',288,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9969,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 04:53:02.847798',83,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9970,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 04:53:02.907012',191,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9971,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 04:53:02.889803',200,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9972,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 04:53:02.858368',398,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9973,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 05:01:45.357071',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9974,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 05:01:45.368883',206,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9975,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 05:01:45.375442',371,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9976,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 05:01:45.375429',481,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9977,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 05:01:52.579432',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9978,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 05:01:52.595840',193,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9979,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 05:01:52.596340',200,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9980,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 05:01:52.584057',327,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9981,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 05:01:56.983598',149,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9982,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 05:01:56.977158',185,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9983,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 05:01:57.010823',171,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 05:01:56.973986',350,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9985,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:07:38.070202',127,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9986,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:07:38.060777',178,139,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9987,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:07:38.080365',183,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9988,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:07:38.055815',331,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9989,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:08:58.169273',137,139,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9990,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:08:58.156487',163,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9991,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:08:58.161377',185,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9992,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:08:58.169384',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9993,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:17:33.507421',113,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9994,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:17:33.529129',163,139,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9995,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:17:33.523606',177,93,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:17:33.515165',319,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:27:35.255499',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:27:35.258242',207,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(9999,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:27:35.266418',220,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10000,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:27:35.268915',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10001,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:27:38.048874',99,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10002,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:27:38.040956',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10003,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:27:38.043180',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10004,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:52:27.167168',94,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10005,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:52:27.267349',156,143,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10006,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:52:27.273218',160,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10007,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:52:27.170328',325,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10008,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:52:40.724613',195,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10009,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:52:40.743799',177,143,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10010,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:52:40.739407',246,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10011,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:52:40.716139',308,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10012,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 06:52:44.697953',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10013,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 06:52:44.712495',178,143,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10014,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 06:52:44.747461',185,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10015,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 06:52:44.714891',354,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10016,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 07:01:23.691757',118,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10017,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 07:01:23.723095',194,143,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10018,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 07:01:23.699138',230,93,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10019,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 07:01:23.700792',283,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10020,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 07:04:32.674272',121,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10021,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 07:04:32.693157',147,143,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10022,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 07:04:32.680635',180,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10023,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 07:04:32.690497',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10024,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 07:09:03.159034',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10025,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 07:09:03.187792',167,143,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10026,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 07:09:03.180905',186,93,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10027,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 07:09:03.190449',279,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10028,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 07:11:17.078196',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10029,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 07:11:17.067009',193,143,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10030,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 07:11:17.062738',245,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10031,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 07:11:17.076314',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10032,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 07:49:40.927293',188,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10033,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 07:49:40.948317',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10034,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 07:49:40.935096',223,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10035,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 07:49:40.925096',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10036,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:01:39.117861',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10037,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:01:39.105125',176,0,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10038,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:01:39.127868',235,93,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10039,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:01:39.119614',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10040,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:04:35.673739',132,4,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10041,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:04:35.686001',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10042,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:04:35.675485',171,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10043,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:04:35.689834',280,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10044,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:05:38.138261',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10045,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:05:38.132849',182,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:05:38.131977',183,4,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10047,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:05:38.142001',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10048,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:24:47.365198',178,28,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10049,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:24:47.363461',175,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10050,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:24:47.359926',211,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10051,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:24:47.357274',328,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10052,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:36:10.467219',141,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10053,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:36:10.464632',179,36,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10054,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:36:10.436157',216,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10055,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:36:10.425328',331,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10056,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:45:17.510215',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10057,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:45:17.518916',180,42,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10058,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:45:17.526462',182,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10059,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:45:17.505131',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10060,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 08:58:57.253648',119,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10061,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 08:58:57.260857',116,45,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10062,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 08:58:57.248001',184,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10063,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 08:58:57.258370',282,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10064,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:06:22.009355',161,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10065,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:06:22.001627',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10066,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:06:22.019982',187,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10067,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:06:22.004994',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10068,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:06:43.660485',124,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10069,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:06:43.677398',170,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10070,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:06:43.675506',216,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10071,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:06:43.667650',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10072,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:06:46.546575',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10073,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:06:46.556275',152,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10074,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:06:46.544296',175,51,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10075,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:06:46.543846',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10076,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:07:35.746182',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10077,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:07:35.743269',171,51,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10078,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:07:35.747277',172,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10079,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:07:35.750880',294,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10080,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:07:50.442192',186,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10081,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:07:50.421538',278,51,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10082,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:07:50.438954',293,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10083,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:07:50.440692',408,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10084,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:07:57.900256',155,51,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10085,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:07:57.897378',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10086,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:07:57.885144',185,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10087,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:07:57.889509',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10088,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:32:27.619759',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10089,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:32:27.642985',165,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10090,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:32:27.629896',217,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10091,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:32:27.614991',379,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10092,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:38:21.099981',202,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10093,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:38:21.103827',196,60,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10094,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:38:21.112245',189,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10095,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:38:21.096474',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10096,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:50:24.639442',189,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10097,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:50:24.661524',207,62,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10098,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:50:24.682331',212,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10099,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:50:24.654491',352,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10100,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:54:40.929573',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10101,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:54:40.921194',146,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10102,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:54:40.934324',192,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10103,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:54:40.921523',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10104,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 09:55:29.457889',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10105,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 09:55:29.460306',151,66,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10106,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 09:55:29.448654',222,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10107,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 09:55:29.462877',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10108,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 10:10:04.969215',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10109,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 10:10:04.965054',185,68,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10110,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 10:10:04.969540',191,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10111,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 10:10:04.953177',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10112,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 10:31:02.717620',124,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10113,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 10:31:02.713873',193,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10114,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 10:31:02.709436',215,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10115,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 10:31:02.717199',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10116,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 10:44:40.218546',138,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 10:44:40.208972',168,75,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10118,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 10:44:40.215894',179,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10119,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 10:44:40.218921',306,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10120,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 10:54:45.876211',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10121,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 10:54:45.882035',161,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10122,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 10:54:45.883403',177,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10123,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 10:54:45.875248',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10124,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 11:13:39.700711',178,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10125,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 11:13:39.707102',184,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10126,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 11:13:39.709031',191,77,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10127,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 11:13:39.715188',278,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10128,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 11:50:20.595650',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10129,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 11:50:20.593776',211,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10130,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 11:50:20.612511',209,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10131,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 11:50:20.588359',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10132,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 11:50:23.758139',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10133,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 11:50:23.760145',196,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10134,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 11:50:23.768112',162,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10135,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 11:50:23.772374',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10136,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 11:50:35.893630',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10137,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 11:50:35.889784',174,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10138,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 11:50:35.895345',203,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10139,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 11:50:35.901957',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10140,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 11:50:39.014114',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10141,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 11:50:39.019938',169,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10142,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 11:50:39.022218',207,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10143,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 11:50:39.023834',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10144,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 11:50:59.503460',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10145,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 11:50:59.531727',138,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10146,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 11:50:59.524341',168,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10147,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 11:50:59.527699',250,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10148,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 17:05:08.588951',186,104,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10149,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 17:05:08.589841',193,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10150,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 17:05:08.600343',216,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10151,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 17:05:08.583254',360,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10152,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 21:32:46.295283',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10153,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 21:32:46.310747',173,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10154,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 21:32:46.302493',205,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10155,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 21:32:46.300816',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10156,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 22:35:39.741863',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10157,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 22:35:39.745201',196,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10158,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 22:35:39.762353',177,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10159,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 22:35:39.756547',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10160,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 23:03:08.148361',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10161,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 23:03:08.158976',229,129,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10162,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 23:03:08.152496',366,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10163,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 23:03:08.143852',470,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10164,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 23:28:43.818909',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10165,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 23:28:43.831132',180,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10166,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 23:28:43.843120',207,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10167,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 23:28:43.848943',334,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10168,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-17 23:51:46.702167',121,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10169,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-17 23:51:46.703192',168,133,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10170,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-17 23:51:46.701546',208,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10171,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-17 23:51:46.704461',286,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10172,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:15:19.984949',161,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10173,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:15:19.987293',178,135,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10174,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:15:20.001570',254,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10175,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:15:20.003154',334,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10176,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:17:33.856566',135,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10177,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:17:33.872357',185,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10178,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:17:33.862967',225,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10179,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:17:33.873278',338,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10180,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:18:05.404967',175,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10181,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:18:05.413859',137,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10182,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:18:05.424604',205,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10183,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:18:05.427092',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10184,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:18:22.080494',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10185,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:18:22.074108',192,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10186,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:18:22.095187',224,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10187,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:18:22.076463',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10188,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:22:21.678949',137,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10189,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:22:21.713981',139,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10190,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:22:21.712034',156,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10191,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:22:21.688391',280,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10192,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:33:33.038634',117,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10193,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:33:33.052268',202,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10194,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:33:33.038385',220,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10195,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:33:33.048363',313,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10196,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 00:51:30.883331',133,135,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10197,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 00:51:30.885227',195,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10198,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 00:51:30.899315',187,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10199,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 00:51:30.882917',302,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10200,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 01:06:36.550416',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10201,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 01:06:36.566888',155,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10202,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 01:06:36.551307',201,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10203,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 01:06:36.553613',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10204,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 01:06:39.522563',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10205,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 01:06:39.554780',151,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10206,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 01:06:39.552382',155,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10207,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 01:06:39.527807',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10208,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 01:20:06.158759',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10209,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 01:20:06.161563',190,136,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10210,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 01:20:06.178519',187,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10211,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 01:20:06.159200',371,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10212,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 01:53:51.099964',162,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10213,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 01:53:51.094921',210,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10214,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 01:53:51.092921',217,136,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10215,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 01:53:51.087650',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10216,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 01:55:20.712688',94,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10217,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 01:55:20.726506',154,136,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10218,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 01:55:20.715278',176,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10219,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 01:55:20.732106',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10220,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 01:58:58.323117',237,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10221,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 01:58:58.342603',224,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 01:58:58.323847',239,136,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10223,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 01:58:58.326438',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10224,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 02:02:46.000308',115,136,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10225,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 02:02:45.983273',132,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10226,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 02:02:46.012047',173,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10227,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 02:02:45.990486',313,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10228,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 02:03:34.476129',155,136,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10229,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 02:03:34.486077',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10230,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 02:03:34.496421',177,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10231,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 02:03:34.477563',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10232,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 02:40:43.665193',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10233,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 02:40:43.658079',138,137,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10234,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 02:40:43.663843',221,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10235,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 02:40:43.672163',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10236,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 02:49:26.619706',165,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10237,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 02:49:26.617524',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10238,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 02:49:26.593714',230,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10239,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 02:49:26.611008',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10240,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 02:59:57.010813',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10241,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 02:59:57.003220',193,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10242,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 02:59:57.014218',234,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10243,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 02:59:57.037965',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10244,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:06:14.717215',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10245,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:06:14.778655',123,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10246,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:06:14.786909',177,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10247,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:06:14.785152',321,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10248,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:21:41.182838',146,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10249,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:21:41.178342',163,138,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10250,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:21:41.197149',180,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10251,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:21:41.189250',316,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10252,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:25:18.823947',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10253,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:25:18.822907',190,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10254,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:25:18.839479',187,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10255,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:25:18.827771',361,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10256,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:34:13.250086',171,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10257,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:34:13.248378',205,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10258,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:34:13.247956',202,138,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10259,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:34:13.259181',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10260,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:39:25.976191',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10261,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:39:25.961784',192,138,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10262,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:39:25.966495',244,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10263,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:39:25.961417',350,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10264,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:40:22.484564',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10265,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:40:22.482715',197,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10266,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:40:22.493062',243,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10267,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:40:22.476090',370,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10268,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:40:34.292783',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10269,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:40:34.298330',160,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10270,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:40:34.290940',197,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10271,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:40:34.291958',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10272,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:40:37.131060',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10273,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:40:37.128194',160,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10274,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:40:37.111478',184,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10275,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:40:37.144528',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10276,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 03:40:40.614203',99,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10277,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 03:40:40.639043',151,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10278,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 03:40:40.666148',131,138,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10279,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 03:40:40.650997',273,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10280,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 04:00:13.092189',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10281,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 04:00:13.084408',198,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10282,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 04:00:13.104663',226,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10283,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 04:00:13.101817',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10284,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 04:13:44.548258',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10285,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 04:13:44.567620',145,140,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10286,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 04:13:44.559545',203,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10287,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 04:13:44.566178',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10288,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 04:31:23.898716',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10289,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 04:31:23.913709',233,140,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10290,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 04:31:23.917653',245,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10291,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 04:31:23.905164',368,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10292,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 04:48:48.190336',198,141,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10293,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 04:48:48.195719',197,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10294,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 04:48:48.194314',199,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10295,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 04:48:48.186460',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10296,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 04:54:15.401914',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10297,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 04:54:15.399799',206,142,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10298,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 04:54:15.398260',247,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10299,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 04:54:15.394451',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10300,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 05:01:51.194559',171,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10301,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 05:01:51.191464',190,142,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10302,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 05:01:51.211812',224,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10303,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 05:01:51.213235',337,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10304,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 05:04:27.164297',67,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10305,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 05:04:27.160191',142,142,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10306,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 05:04:27.173766',180,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10307,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 05:04:27.201050',295,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10308,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 05:20:23.597655',192,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10309,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 05:20:23.608512',212,142,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10310,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 05:20:23.613733',240,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10311,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 05:20:23.598910',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10312,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 05:50:05.528945',182,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10313,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 05:50:05.523379',224,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 05:50:05.572003',192,142,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10315,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 05:50:05.544391',298,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10316,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 05:52:33.263695',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10317,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 05:52:33.256677',167,143,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10318,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 05:52:33.253266',178,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10319,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 05:52:33.239191',308,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10320,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:03:41.284558',99,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10321,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:03:41.288205',150,143,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10322,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:03:41.302406',163,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10323,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:03:41.296419',293,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10324,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:03:46.064719',186,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10325,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:03:46.067127',188,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10326,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:03:46.060392',197,143,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10327,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:03:46.052521',312,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10328,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:08:00.495603',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10329,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:08:00.498954',175,143,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10330,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:08:00.496905',213,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10331,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:08:00.483022',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10332,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:12:21.694340',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10333,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:12:21.719825',176,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10334,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:12:21.710778',186,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10335,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:12:21.708127',355,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10336,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:24:43.272466',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10337,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:24:43.263795',207,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10338,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:24:43.250793',252,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10339,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:24:43.248258',394,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10340,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:26:40.528752',115,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10341,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:26:40.514261',182,144,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10342,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:26:40.526739',200,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10343,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:26:40.510338',371,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10344,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:27:32.482993',186,144,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10345,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:27:32.474763',183,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10346,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:27:32.486025',227,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10347,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:27:32.489521',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10348,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:38:54.154430',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10349,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:38:54.138398',139,144,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10350,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:38:54.145358',170,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10351,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:38:54.135507',338,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10352,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:38:57.544855',141,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10353,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:38:57.549501',169,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10354,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:38:57.557810',255,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10355,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:43:10.083260',124,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10356,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:43:10.092709',179,147,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10357,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:43:10.085177',236,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10358,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:43:10.101764',368,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10359,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:48:50.299238',272,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10360,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:48:50.313312',475,147,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10361,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:48:50.194949',721,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10362,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:48:50.214264',751,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10363,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 06:54:03.357086',184,150,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10364,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 06:54:03.337362',215,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10365,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 06:54:03.322799',220,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10366,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 06:54:03.324073',378,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10367,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:16:11.555536',92,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10368,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:16:11.606318',163,94,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10369,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:16:11.617684',150,155,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10370,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:16:11.616025',311,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10371,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:22:50.900873',163,156,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10372,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:22:50.903301',172,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10373,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:22:50.905844',174,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10374,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:22:50.895081',358,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10375,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:27:17.449807',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10376,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:27:17.463805',163,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10377,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:27:17.501207',194,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10378,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:27:17.443289',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10379,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:33:45.215321',157,156,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10380,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:33:45.210527',181,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10381,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:33:45.231972',188,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10382,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:33:45.233050',334,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10383,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:37:32.596672',192,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10384,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:37:32.586345',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10385,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:37:32.586350',213,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10386,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:37:32.587437',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10387,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:38:15.823284',174,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10388,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:38:15.819999',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10389,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:38:15.832186',182,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10390,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:38:15.828530',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10391,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:41:13.311508',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10392,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:41:13.328707',219,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10393,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:41:13.330039',270,94,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10394,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:41:13.299826',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10395,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:46:41.677528',126,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10396,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:46:41.653175',188,157,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10397,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:46:41.659669',199,94,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10398,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:46:41.644961',318,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10399,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:56:38.700896',160,158,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10400,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:56:38.718473',146,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10401,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:56:38.701728',207,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10402,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:56:38.700736',307,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10403,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 07:59:11.987388',130,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10404,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 07:59:11.986375',166,158,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10405,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 07:59:11.985289',175,94,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10406,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 07:59:11.987001',300,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10407,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:14:02.168045',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10408,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:14:02.176726',189,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10409,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:14:02.193965',175,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10410,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:14:02.172666',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10411,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:14:49.743311',207,25,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10412,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:14:49.744344',218,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10413,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:14:49.766923',226,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10414,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:14:49.736569',356,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10415,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:15:01.709371',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10416,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:15:01.742310',184,25,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10417,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:15:01.737223',203,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10418,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:15:01.731979',299,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10419,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:15:05.324011',94,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10420,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:15:05.325399',214,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10421,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:15:05.340807',176,25,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10422,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:15:05.331332',346,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10423,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:15:17.258245',176,25,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10424,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:15:17.259882',181,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10425,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:15:17.254896',195,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10426,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:15:17.261630',246,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10427,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:18:01.565038',157,25,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10428,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:18:01.563794',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10429,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:18:01.557922',211,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10430,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:18:01.565920',322,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10431,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:21:47.093152',90,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10432,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:21:47.079820',114,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10433,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:21:47.061219',189,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10434,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:21:47.096361',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10435,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:21:59.038795',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10436,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:21:59.042002',166,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10437,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:21:59.044789',173,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10438,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:21:59.056510',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10439,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:22:00.972178',121,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10440,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:22:00.988465',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10441,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:22:00.980761',196,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10442,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:22:00.977905',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10443,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:24:28.501565',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10444,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:24:28.527981',132,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10445,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:24:28.545565',168,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10446,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:24:28.502165',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10447,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:24:40.877167',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10448,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:24:40.882444',163,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10449,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:24:40.877189',180,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10450,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:24:40.866216',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10451,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:24:42.847135',116,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10452,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:24:42.857954',164,41,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10453,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:24:42.867340',175,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10454,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:24:42.853518',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10455,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:26:48.653775',106,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10456,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:26:48.661559',163,41,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10457,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:26:48.670900',153,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10458,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:26:48.659917',266,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10459,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 08:48:27.923233',81,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10460,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 08:48:27.982134',160,52,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10461,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 08:48:27.979262',196,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10462,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 08:48:27.976770',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10463,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 09:17:06.981569',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10464,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 09:17:07.020689',190,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10465,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 09:17:06.988820',206,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10466,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 09:17:06.984401',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10467,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 09:45:41.922536',198,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10468,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 09:45:41.901269',211,69,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10469,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 09:45:41.901485',229,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10470,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 09:45:41.915393',323,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10471,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:00:20.198350',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10472,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:00:20.252178',175,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10473,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:00:20.209521',234,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10474,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:00:20.208278',363,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10475,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:00:24.052371',173,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10476,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:00:24.037180',155,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10477,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:00:24.047005',222,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10478,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:00:24.056457',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10479,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:15:42.647381',139,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10480,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:15:42.623698',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10481,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:15:42.645302',194,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10482,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:15:42.618652',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10483,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:18:33.619894',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10484,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:18:33.620601',145,74,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10485,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:18:33.607940',210,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10486,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:18:33.618853',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10487,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:30:38.440909',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10488,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:30:38.443450',178,76,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10489,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:30:38.444257',186,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10490,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:30:38.459292',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10491,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:30:43.544865',95,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10492,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:30:43.556972',172,76,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10493,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:30:43.543343',216,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10494,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:30:43.535931',347,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10495,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:34:06.754635',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10496,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:34:06.786426',154,77,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10497,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:34:06.778881',177,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10498,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:34:06.780281',274,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10499,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:34:16.423564',92,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10500,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:34:16.436240',137,77,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10501,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:34:16.441334',155,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10502,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:34:16.441210',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10503,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 10:37:50.409275',229,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10504,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 10:37:50.429953',234,77,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10505,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 10:37:50.431173',333,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10506,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 10:37:50.431777',435,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10507,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:07:42.966302',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10508,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:07:42.963310',182,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10509,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:07:42.955942',197,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10510,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:07:42.959250',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10511,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:22:47.649227',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10512,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:22:47.645960',163,81,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10513,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:22:47.647614',196,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10514,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:22:47.640291',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10515,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:22:58.504843',184,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10516,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:22:58.520367',179,81,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10517,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:22:58.515256',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10518,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:22:58.516238',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10519,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:35:12.796052',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10520,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:35:12.791296',148,82,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10521,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:35:12.788077',200,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10522,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:35:12.794171',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10523,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:36:18.098701',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10524,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:36:18.102755',176,82,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10525,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:36:18.133307',182,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10526,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:36:18.111330',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10527,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:56:05.305523',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10528,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:56:05.311927',201,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10529,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:56:05.306108',193,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10530,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:56:05.324253',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10531,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:56:37.799403',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10532,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:56:37.811074',163,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10533,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:56:37.808298',180,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10534,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:56:37.800954',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10535,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:56:48.837177',143,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10536,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 11:56:48.825951',196,83,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10537,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 11:56:48.809498',216,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10538,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:56:48.834183',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10539,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 11:56:52.093261',64,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10540,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 11:56:52.088194',244,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10541,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:16:38.221857',105,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10542,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 14:16:38.259288',161,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10543,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:16:38.242887',206,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10544,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:16:38.272416',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10545,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:16:42.933183',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10546,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:16:42.932801',190,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10547,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 14:16:42.941491',192,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10548,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:16:42.940007',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10549,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 14:16:49.302920',173,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10550,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:16:49.302228',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10551,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:16:49.320720',164,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10552,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:16:49.300481',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10553,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 14:16:52.219782',162,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10554,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:16:52.214820',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10555,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:16:52.240571',182,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10556,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:16:52.220831',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10557,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 14:17:46.236868',177,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10558,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:17:46.232741',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10559,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:17:46.287934',144,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10560,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:17:46.234132',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10561,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:17:55.355057',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10562,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 14:17:55.372852',149,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10563,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:17:55.391007',152,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10564,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:17:55.364190',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10565,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 14:17:58.069752',68,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10566,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 14:17:58.081670',147,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10567,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 14:17:58.068875',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10568,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 15:01:39.823013',97,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10569,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 15:01:39.839838',162,97,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10570,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 15:01:39.827272',207,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10571,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 15:01:39.843205',276,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10572,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 16:21:53.972459',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10573,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 16:21:53.976883',223,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10574,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 16:21:53.975590',248,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10575,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 16:21:53.970938',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10576,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 16:22:06.264104',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10577,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 16:22:06.293676',180,105,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10578,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 16:22:06.279909',193,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10579,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 16:22:06.269063',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10580,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 16:43:43.487445',177,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10581,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 16:43:43.498620',175,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10582,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 16:43:43.502323',180,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10583,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 16:43:43.499986',325,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10584,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 16:53:10.365320',52,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10585,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 16:53:10.386916',182,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10586,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 16:53:10.373381',202,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10587,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 16:53:10.385353',357,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10588,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 16:53:39.024267',156,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10589,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 16:53:39.019965',167,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10590,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 16:53:39.012345',156,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10591,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 16:53:39.017352',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10592,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 16:57:39.423421',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10593,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 16:57:39.414603',187,107,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10594,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 16:57:39.438322',215,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10595,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 16:57:39.423218',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10596,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 17:07:33.348446',96,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10597,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 17:07:33.355385',174,107,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10598,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 17:07:33.343919',196,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10599,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 17:07:33.358327',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10600,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 17:38:41.029983',149,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10601,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 17:38:41.048475',169,109,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10602,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 17:38:41.039763',185,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10603,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 17:38:41.038351',320,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10604,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 17:42:29.956315',88,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10605,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 17:42:30.010406',200,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10606,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 17:42:29.998018',219,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10607,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 17:42:29.959878',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10608,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 17:42:33.176111',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10609,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 17:42:33.218714',174,110,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10610,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 17:42:33.217979',178,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10611,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 17:42:33.191712',273,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10612,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 17:50:31.958525',191,110,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10613,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 17:50:31.960291',212,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10614,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 17:50:31.961828',205,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10615,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 17:50:31.958239',353,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10616,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 19:17:57.528530',176,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10617,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 19:17:57.540209',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 19:17:57.542051',190,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10619,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 19:17:57.522081',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10620,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 19:18:01.726770',184,116,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10621,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 19:18:01.712363',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10622,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 19:18:01.725475',203,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10623,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 19:18:01.693472',339,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10624,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 19:47:36.945691',87,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10625,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 19:47:37.014507',152,119,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10626,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 19:47:37.011056',163,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10627,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 19:47:37.016075',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10628,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 19:58:00.994202',218,119,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10629,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 19:58:00.997973',234,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10630,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 19:58:00.997195',251,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10631,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 19:58:00.989857',362,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10632,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:03:24.272932',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10633,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:03:24.274517',187,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10634,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:03:24.272512',231,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10635,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:03:24.269674',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10636,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:03:37.620214',108,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10637,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:03:37.614783',161,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10638,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:03:37.613701',182,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10639,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:03:37.604939',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10640,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:04:09.065729',181,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10641,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:04:09.052426',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10642,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:04:09.048294',221,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10643,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:04:09.051313',356,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10644,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:04:11.937219',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:04:11.948278',147,122,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10646,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:04:11.985088',157,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10647,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:04:11.945189',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10648,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:07:17.850214',180,122,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10649,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:07:17.851748',196,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10650,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:07:17.848080',212,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10651,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:07:17.860613',325,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10652,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:34:21.804768',199,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10653,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:34:21.818260',211,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10654,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:34:21.823383',233,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10655,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:34:21.811510',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10656,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:34:33.295841',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10657,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:34:33.285321',191,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10658,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:34:33.289413',191,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10659,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:34:33.299715',262,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10660,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 22:34:35.140468',156,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10661,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 22:34:35.135228',177,125,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10662,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 22:34:35.143369',171,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10663,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 22:34:35.136455',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10664,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 23:17:36.993978',172,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10665,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 23:17:36.967714',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10666,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 23:17:36.987596',187,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10667,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 23:17:36.979414',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10668,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 23:17:47.840284',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10669,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 23:17:47.851122',177,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10670,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 23:17:47.869444',155,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10671,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 23:17:47.858689',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10672,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 23:17:49.819565',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10673,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 23:17:49.812048',193,128,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10674,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 23:17:49.835780',179,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10675,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 23:17:49.823158',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10676,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 23:23:16.865973',188,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10677,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 23:23:16.860406',218,130,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10678,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 23:23:16.863385',240,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10679,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 23:23:16.870420',381,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10680,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 23:56:00.988447',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 23:56:00.988168',177,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10682,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 23:56:00.991330',199,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10683,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 23:56:00.992433',356,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10684,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-18 23:59:15.315100',137,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10685,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-18 23:59:15.342627',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10686,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-18 23:59:15.331173',173,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10687,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-18 23:59:15.328479',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10688,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 00:01:42.734880',194,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10689,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 00:01:42.749898',191,131,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10690,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 00:01:42.741233',223,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10691,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 00:01:42.740050',310,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10692,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 00:14:11.643200',146,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10693,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 00:14:11.661269',220,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10694,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 00:14:11.672998',201,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10695,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 00:14:11.647351',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10696,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 00:14:51.004418',211,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10697,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 00:14:51.007224',227,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10698,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 00:14:51.006129',286,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10699,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 00:14:50.927330',381,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10700,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 00:48:44.547714',181,132,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10701,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 00:48:44.548062',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10702,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 00:48:44.553883',197,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10703,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 00:48:44.540218',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10704,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 00:55:55.416771',187,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10705,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 00:55:55.414498',209,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10706,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 00:55:55.415199',200,134,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10707,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 00:55:55.425045',381,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10708,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:09:48.769570',96,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10709,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:09:48.780481',157,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10710,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:09:48.778773',199,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10711,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:09:48.781968',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10712,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:10:00.159897',178,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10713,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:10:00.165101',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10714,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:10:00.146140',231,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10715,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:10:00.144934',376,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10716,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:10:02.005469',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10717,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:10:02.015490',159,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10718,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:10:02.038146',203,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10719,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:10:02.034663',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10720,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:12:37.565976',61,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10721,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:12:37.622448',177,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10722,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:12:37.626320',201,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10723,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:12:37.658728',258,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10724,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:12:48.480938',202,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10725,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:12:48.478892',198,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10726,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:12:48.470460',239,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10727,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:12:48.462686',429,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10728,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:12:49.200648',159,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10729,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:12:49.184220',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10730,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:12:49.203202',195,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10731,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:12:49.215102',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10732,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:12:52.202775',144,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10733,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:12:52.207550',162,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10734,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:12:52.205672',184,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10735,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:12:52.195116',279,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10736,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:12:52.913749',139,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10737,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:12:52.918032',133,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10738,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:12:52.921533',176,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10739,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:12:52.916277',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10740,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:13:47.526002',150,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10741,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:13:47.565870',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10742,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:13:47.534764',207,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10743,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:13:47.563158',267,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10744,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:21:31.411010',129,135,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10745,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:21:31.405487',197,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10746,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:21:31.402987',232,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10747,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:21:31.397499',338,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10748,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:25:47.373832',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10749,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:25:47.387529',175,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10750,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:25:47.388524',226,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10751,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:25:47.376622',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10752,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:29:52.941625',174,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10753,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:29:52.958172',165,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10754,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:29:52.946909',207,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10755,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:29:52.950377',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10756,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:47:15.912547',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10757,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:47:15.925352',179,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10758,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:47:15.928885',185,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10759,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:47:15.922941',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10760,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:47:21.076111',148,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10761,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:47:21.119766',137,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10762,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:47:21.105957',148,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10763,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:47:21.098517',301,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10764,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:47:22.788297',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10765,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:47:22.774373',191,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10766,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:47:22.780870',221,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10767,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:47:22.786403',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10768,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:47:27.263831',75,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10769,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:47:27.334932',145,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10770,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:47:27.321907',221,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10771,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:47:27.317267',337,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10772,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:47:30.231387',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10773,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:47:30.270477',143,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10774,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:47:30.279436',163,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10775,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:47:30.238378',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10776,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:51:26.941365',143,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10777,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:51:26.946420',205,135,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10778,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:51:26.933005',254,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10779,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:51:26.937156',350,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10780,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 01:54:44.296021',153,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 01:54:44.296723',138,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10782,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 01:54:44.283214',207,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10783,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 01:54:44.294767',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10784,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:08:17.450665',162,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10785,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:08:17.466687',162,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10786,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:08:17.447351',212,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10787,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:08:17.470754',319,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10788,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:08:57.516948',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10789,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:08:57.576973',176,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10790,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:08:57.574251',186,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10791,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:08:57.586750',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10792,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:14:39.157487',196,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10793,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:14:39.166523',193,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10794,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:14:39.165291',191,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10795,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:14:39.161040',389,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10796,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:14:42.164694',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10797,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:14:42.169025',150,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10798,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:14:42.173340',163,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10799,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:14:42.171041',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10800,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:20:22.825053',173,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10801,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:20:22.823255',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10802,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:20:22.842051',188,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10803,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:20:22.829464',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10804,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:34:10.845480',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10805,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:34:10.870197',181,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10806,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:34:10.859532',212,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10807,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:34:10.851173',309,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10808,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:35:18.367189',159,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10809,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:35:18.366072',170,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10810,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:35:18.364891',163,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10811,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:35:18.368302',286,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10812,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:47:27.561007',192,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10813,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:47:27.540502',235,135,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10814,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:47:27.537654',270,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10815,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:47:27.547056',374,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10816,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 02:55:54.807351',152,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10817,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 02:55:54.818320',163,136,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10818,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 02:55:54.800376',217,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10819,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 02:55:54.808158',327,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10820,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:05:15.850162',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10821,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:05:15.833779',191,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10822,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:05:15.834292',213,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10823,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:05:15.837789',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10824,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:07:17.513867',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10825,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:07:17.496065',217,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10826,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:07:17.506515',229,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10827,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:07:17.502690',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10828,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:07:23.120092',191,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10829,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:07:23.104186',188,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10830,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:07:23.250208',140,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10831,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:07:23.118510',343,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10832,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:07:34.012434',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10833,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:07:34.012236',204,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10834,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:07:34.013442',213,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10835,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:07:34.014361',366,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10836,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:07:38.123769',194,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10837,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:07:38.133400',173,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10838,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:07:38.148017',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10839,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:07:38.131304',321,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10840,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:24:39.798136',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10841,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:24:39.790787',207,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10842,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:24:39.799938',243,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10843,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:24:39.797267',374,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10844,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:32:10.716956',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10845,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:32:10.736847',162,139,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10846,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:32:10.733827',196,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10847,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:32:10.720943',347,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10848,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 03:59:54.675012',166,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10849,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 03:59:54.681208',198,140,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10850,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 03:59:54.666032',230,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10851,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 03:59:54.671437',362,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10852,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:04:25.607835',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10853,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:04:25.602212',226,140,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10854,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:04:25.593722',274,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10855,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:04:25.599311',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10856,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:22:56.275111',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10857,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:22:56.275772',156,142,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10858,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:22:56.266175',207,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10859,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:22:56.268715',360,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10860,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:23:08.711328',119,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10861,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:23:08.709426',180,142,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10862,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:23:08.714679',189,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10863,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:23:08.702550',362,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10864,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:23:12.152710',125,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10865,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:23:12.151373',206,142,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10866,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:23:12.154195',197,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10867,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:23:12.149801',373,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10868,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:24:13.120966',129,142,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10869,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:24:13.087670',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10870,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:24:13.103243',182,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10871,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:24:13.087734',321,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10872,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:38:54.478489',145,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10873,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:38:54.464109',145,143,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10874,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:38:54.462316',220,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10875,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:38:54.464886',349,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10876,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:40:49.864662',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10877,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:40:49.901239',196,143,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10878,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:40:49.880268',304,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10879,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:40:49.883889',388,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10880,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:42:08.278358',213,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10881,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:42:08.259110',362,143,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10882,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:42:08.273706',382,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10883,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:42:08.277356',461,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10884,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:42:19.775481',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10885,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:42:19.775794',184,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:42:19.785206',174,145,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10887,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:42:19.777742',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10888,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:42:21.851323',176,145,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10889,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:42:21.850264',183,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10890,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:42:21.867537',172,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10891,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:42:21.839934',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10892,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:44:59.640874',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10893,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:44:59.656959',180,145,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10894,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:44:59.639324',256,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10895,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:44:59.635222',402,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10896,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 04:48:52.747726',138,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10897,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 04:48:52.760086',193,145,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10898,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 04:48:52.747745',237,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10899,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 04:48:52.764749',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10900,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 05:27:32.102450',163,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10901,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:27:32.107998',207,147,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10902,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 05:27:32.180729',221,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10903,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:27:32.099017',345,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10904,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 05:49:36.826394',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10905,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 05:49:36.841002',223,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10906,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:49:36.848167',187,148,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10907,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:49:36.823547',350,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10908,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 05:49:46.191565',58,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10909,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:49:46.271642',153,148,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10910,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 05:49:46.272274',184,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10911,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:49:46.268938',323,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10912,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:49:49.440269',176,148,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10913,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 05:49:49.443274',181,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10914,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 05:49:49.428247',228,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10915,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:49:49.425843',333,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10916,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:49:53.026022',99,148,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10917,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:49:53.014809',254,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10918,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:50:40.438977',192,148,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10919,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 05:50:40.459960',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10920,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 05:50:40.453371',215,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10921,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:50:40.442065',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10922,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 05:54:28.580444',176,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10923,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 05:54:28.576859',224,148,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10924,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 05:54:28.582448',254,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10925,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 05:54:28.580831',403,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10926,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:08:10.537260',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:08:10.550893',170,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10928,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:08:10.553554',178,149,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10929,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:08:10.540215',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10930,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:08:20.109318',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10931,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:08:20.113573',169,149,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10932,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:08:20.102968',211,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10933,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:08:20.100549',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10934,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:10:32.597556',163,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10935,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:10:32.601132',156,149,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10936,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:10:32.608319',188,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10937,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:10:32.613173',289,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10938,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:12:13.607288',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10939,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:12:13.611764',184,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10940,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:12:13.625050',203,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10941,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:12:13.616704',364,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10942,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:17:49.248825',176,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10943,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:17:49.253148',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10944,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:17:49.247428',198,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10945,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:17:49.255280',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10946,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:30:25.907301',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10947,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:30:25.908985',157,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10948,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:30:25.902466',202,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10949,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:30:25.895565',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10950,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:30:37.910427',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10951,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:30:37.925238',155,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10952,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:30:37.920155',213,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10953,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:30:37.916148',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:30:39.895700',173,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10955,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:30:39.887456',185,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10956,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:30:39.891630',221,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10957,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:30:39.906326',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10958,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:31:34.497390',198,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10959,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:31:34.500508',201,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10960,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:31:34.515471',222,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10961,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:31:34.516943',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10962,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:32:31.043785',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10963,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:32:31.063454',178,150,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10964,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:32:31.073917',188,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10965,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:32:31.053570',338,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10966,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:44:18.915769',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10967,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:44:18.913823',189,152,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10968,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:44:18.912603',203,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10969,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:44:18.910371',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10970,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:49:27.815123',208,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10971,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:49:27.827128',174,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10972,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:49:27.817255',186,152,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10973,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:49:27.819346',282,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10974,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 06:51:42.623973',156,152,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10975,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 06:51:42.657909',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10976,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 06:51:42.627022',200,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10977,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 06:51:42.611572',361,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10978,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:09:22.983812',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10979,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:09:22.985252',144,153,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10980,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:09:23.008290',189,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10981,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:09:22.982081',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10982,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:22:46.566425',190,153,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10983,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:22:46.563310',181,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10984,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:22:46.570481',209,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10985,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:22:46.568889',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10986,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:31:25.387000',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10987,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:31:25.413811',212,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10988,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:31:25.393388',239,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10989,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:31:25.398326',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10990,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:31:36.356908',158,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10991,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:31:36.366845',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10992,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:31:36.357816',167,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10993,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:31:36.359369',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:31:39.284300',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10995,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:31:39.322343',143,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10996,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:31:39.375851',163,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10997,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:31:39.289678',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10998,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:32:52.085707',158,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(10999,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:32:52.066417',234,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11000,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:32:52.064402',205,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11001,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:32:52.053654',357,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11002,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:35:34.867071',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11003,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:35:34.863184',184,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11004,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:35:34.880196',192,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11005,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:35:34.882489',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11006,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:51:02.368642',130,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11007,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:51:02.380199',155,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11008,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:51:02.375201',226,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11009,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:51:02.386162',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11010,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:51:05.336004',174,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11011,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:51:05.319441',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11012,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:51:05.346814',178,95,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11013,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:51:05.344399',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11014,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:53:43.712830',121,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11015,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:53:43.706757',173,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11016,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:53:43.705216',196,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11017,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:53:43.704287',368,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11018,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:53:56.392376',164,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11019,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:53:56.381432',183,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11020,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:53:56.376770',169,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11021,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:53:56.383364',303,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11022,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:54:14.852091',168,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11023,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:54:14.855188',201,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11024,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:54:14.848433',183,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11025,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:54:14.873471',297,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11026,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:55:45.209430',85,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11027,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:55:45.238921',150,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11028,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:55:45.241369',187,95,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11029,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:55:45.226174',340,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11030,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:56:48.456371',98,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11031,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:56:48.452700',163,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11032,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:56:48.454146',159,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11033,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:56:48.455278',318,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11034,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:58:47.478504',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11035,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:58:47.456461',196,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11036,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:58:47.482111',186,95,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11037,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:58:47.480324',348,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11038,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 07:58:54.367996',142,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11039,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 07:58:54.369917',171,95,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11040,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 07:58:54.396455',162,154,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11041,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 07:58:54.366816',312,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11042,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:02:24.947874',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11043,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:02:25.018854',152,9,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11044,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:02:25.010206',170,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11045,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:02:24.960202',364,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11046,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:05:05.588066',121,9,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11047,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:05:05.606922',143,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11048,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:05:05.594431',189,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11049,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:05:05.597567',351,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11050,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:12:40.845572',201,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11051,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:12:40.860286',220,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11052,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:12:40.868298',237,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11053,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:12:40.851627',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11054,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:18:56.986064',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11055,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:18:56.991147',182,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11056,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:18:57.003886',237,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11057,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:18:56.994291',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11058,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:19:09.622013',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11059,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:19:09.636911',164,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11060,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:19:09.627138',187,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11061,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:19:09.658086',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11062,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:19:12.544993',139,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11063,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:19:12.544910',180,25,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11064,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:19:12.551296',179,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11065,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:19:12.547202',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11066,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:23:28.238007',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11067,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:23:28.271547',140,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11068,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:23:28.254509',174,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11069,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:23:28.269578',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11070,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:32:06.481435',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11071,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:32:06.486538',175,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11072,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:32:06.487944',192,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11073,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:32:06.498712',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11074,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:45:02.822389',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11075,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:45:02.847575',192,46,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11076,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:45:02.831365',270,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11077,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:45:02.857356',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11078,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:47:03.383976',67,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11079,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:47:03.371817',146,46,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11080,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:47:03.381631',174,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11081,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:47:03.370262',289,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11082,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:48:11.533361',82,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11083,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:48:11.568095',138,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11084,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:48:11.570674',138,46,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11085,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:48:11.575824',259,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11086,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 08:54:36.057463',151,51,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11087,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 08:54:36.065716',158,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11088,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 08:54:36.059155',211,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11089,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 08:54:36.064087',300,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11090,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 09:06:45.482041',144,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11091,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 09:06:45.492462',197,59,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11092,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 09:06:45.477998',224,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11093,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 09:06:45.504099',365,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11094,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 09:20:18.528062',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11095,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 09:20:18.536419',161,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11096,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 09:20:18.528090',161,63,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11097,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 09:20:18.534956',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11098,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 09:29:00.286004',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11099,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 09:29:00.290865',176,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11100,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 09:29:00.303198',178,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11101,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 09:29:00.289149',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11102,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 09:29:03.947813',122,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11103,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 09:29:03.950503',127,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 09:29:03.957044',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 09:29:22.714141',122,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11106,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 09:29:22.724853',164,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11107,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 09:29:22.741999',206,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11108,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 09:29:22.723143',347,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11109,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 09:46:42.351751',90,73,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11110,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 09:46:42.365343',165,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11111,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 09:46:42.372871',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11112,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 09:46:42.384233',263,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11113,_binary '???\?\\?!.-\?y?x \?-Ye@]\????','2024-07-19 09:47:06.637128',74,96,_binary '','csv-download',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11114,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:00:43.399429',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11115,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:00:43.380272',202,78,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11116,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:00:43.384114',218,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11117,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:00:43.393662',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:02:55.704297',108,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11119,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:02:55.691038',197,80,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11120,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:02:55.704558',200,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11121,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:02:55.699947',270,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11122,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:13:58.790115',134,82,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11123,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:13:58.796958',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11124,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:13:58.793288',185,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11125,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:13:58.788411',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11126,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:20:21.215196',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11127,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:20:21.199072',178,82,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11128,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:20:21.213441',173,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11129,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:20:21.211418',288,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11130,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:24:42.374656',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11131,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:24:42.375910',140,84,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11132,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:24:42.412352',165,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11133,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:24:42.377200',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11134,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:30:59.170919',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11135,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:30:59.180304',192,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11136,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:30:59.182951',178,84,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11137,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:30:59.178798',301,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11138,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:54:48.135749',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11139,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:54:48.150357',163,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11140,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:54:48.129253',217,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11141,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:54:48.149810',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11142,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:54:51.075331',113,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11143,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:54:51.073337',155,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11144,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:54:51.070535',290,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11145,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:54:51.089308',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11146,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:54:59.482414',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11147,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 10:54:59.498966',205,88,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11148,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:54:59.486225',228,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11149,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:54:59.488213',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11150,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 10:55:02.300440',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11151,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 10:55:02.352275',154,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11152,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 10:55:02.305409',263,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11153,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 11:28:15.021548',183,90,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11154,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 11:28:15.023066',192,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11155,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 11:28:15.024260',201,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11156,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 11:28:15.021549',297,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11157,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 11:57:01.327732',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11158,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 11:57:01.316430',197,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11159,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 11:57:01.321406',186,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11160,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 11:57:01.321870',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11161,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 11:59:05.491011',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11162,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 11:59:05.494354',181,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11163,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 11:59:05.504775',180,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 11:59:05.493928',255,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11165,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:04:05.933870',99,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11166,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:04:05.943204',197,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11167,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:04:05.945607',187,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11168,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:04:05.958262',326,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11169,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:38:03.607156',188,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11170,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:38:03.613899',199,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11171,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:38:03.608070',193,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11172,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:38:03.600329',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11173,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:38:11.802750',133,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11174,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:38:11.821759',196,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11175,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:38:11.831936',158,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:38:11.789502',339,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11177,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:38:15.724672',154,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11178,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:38:15.739169',169,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11179,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:38:15.740782',163,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11180,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:38:15.727497',326,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11181,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:38:19.097751',206,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11182,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:42:37.271882',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11183,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:42:37.276415',156,97,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11184,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:42:37.289150',157,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11185,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:42:37.279186',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11186,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:44:13.207933',144,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11187,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:44:13.197419',159,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11188,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:44:13.200331',157,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11189,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:44:13.199045',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11190,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:44:17.137009',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11191,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:44:17.149994',193,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11192,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:44:17.146404',233,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11193,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:44:17.142152',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11194,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:45:19.537089',91,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11195,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:45:19.481067',157,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11196,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:45:19.499328',182,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11197,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:45:19.520152',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11198,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:45:22.367293',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11199,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:45:22.359396',181,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11200,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:45:22.375041',195,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11201,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:45:22.364307',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11202,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:49:21.762108',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11203,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:49:21.769827',162,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11204,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:49:21.759647',220,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11205,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:49:21.763510',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11206,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 12:51:55.222467',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11207,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 12:51:55.220497',196,97,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11208,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 12:51:55.226046',245,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11209,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 12:51:55.226503',290,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11210,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 16:07:06.273262',55,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11211,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 16:07:06.277310',181,108,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11212,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 16:07:06.300088',191,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11213,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 16:07:06.297423',266,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11214,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 16:17:06.477300',118,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11215,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 16:17:06.490094',160,110,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11216,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 16:17:06.478753',186,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11217,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 16:17:06.478983',301,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11218,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 16:33:21.022880',164,112,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11219,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 16:33:21.020125',173,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11220,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 16:33:21.033110',169,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11221,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 16:33:21.029348',327,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11222,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 17:03:51.087746',162,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11223,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 17:03:51.093018',196,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11224,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 17:03:51.103368',165,116,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11225,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 17:03:51.095753',280,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11226,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 17:38:17.124189',173,118,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11227,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 17:38:17.132438',159,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11228,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 17:38:17.131178',177,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11229,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 17:38:17.138056',314,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11230,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 18:58:19.001200',206,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11231,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 18:58:19.002849',247,126,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11232,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 18:58:18.995149',269,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11233,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 18:58:19.007125',360,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11234,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 19:43:37.583510',164,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11235,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 19:43:37.571422',209,131,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11236,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 19:43:37.587111',232,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11237,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 19:43:37.543979',302,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11238,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 20:20:08.828828',126,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11239,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 20:20:08.842544',183,136,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11240,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 20:20:08.828861',225,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11241,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 20:20:08.830105',322,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11242,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 20:29:16.276103',160,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11243,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 20:29:16.285746',174,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11244,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 20:29:16.290150',184,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11245,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 20:29:16.287763',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11246,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 20:38:11.240045',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11247,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 20:38:11.242914',171,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11248,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 20:38:11.240283',214,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11249,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 20:38:11.246519',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11250,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 20:38:22.820870',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11251,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 20:38:22.821089',220,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11252,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 20:38:22.835285',222,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11253,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 20:38:22.826332',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11254,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 20:38:24.930058',141,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11255,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 20:38:24.949406',175,138,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11256,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 20:38:24.962492',186,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11257,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 20:38:24.938235',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11258,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 21:47:40.957407',130,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11259,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 21:47:40.940057',189,144,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11260,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 21:47:40.938042',228,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11261,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 21:47:40.937680',324,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11262,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 22:10:07.596502',162,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11263,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 22:10:07.594855',166,145,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11264,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 22:10:07.593519',195,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11265,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 22:10:07.594359',343,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11266,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 22:44:48.015074',202,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11267,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 22:44:48.002685',190,148,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11268,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 22:44:48.013838',194,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11269,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 22:44:48.000186',333,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11270,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 22:51:08.064231',116,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11271,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 22:51:08.066903',204,148,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11272,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 22:51:08.067861',217,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11273,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 22:51:08.056514',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11274,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:03:30.702134',191,148,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11275,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:03:30.721817',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11276,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:03:30.708358',228,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11277,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:03:30.719021',366,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11278,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:07:28.750409',183,148,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11279,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:07:28.751068',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11280,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:07:28.749004',160,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11281,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:07:28.749267',275,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11282,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:16:08.407833',189,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11283,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:16:08.442316',202,150,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11284,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:16:08.427095',225,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11285,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:16:08.399051',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11286,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:23:30.640482',139,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11287,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:23:30.669679',156,150,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11288,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:23:30.654402',196,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11289,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:23:30.666732',276,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11290,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:36:40.144176',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11291,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:36:40.142927',176,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11292,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:36:40.142463',199,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11293,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:36:40.150612',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11294,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:42:50.894114',259,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11295,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:42:50.896375',255,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11296,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:42:50.898416',307,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11297,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:42:50.885503',421,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11298,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:44:18.002052',176,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11299,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:44:18.018671',170,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11300,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:44:18.022708',190,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11301,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:44:18.027115',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11302,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:45:57.876287',90,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11303,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:45:57.867769',170,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11304,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:45:57.941625',165,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11305,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:45:57.880753',310,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11306,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:46:00.635510',76,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11307,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:46:00.629221',125,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11308,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:46:00.640569',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11309,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-19 23:59:00.809483',177,151,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11310,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-19 23:59:00.809556',188,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11311,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-19 23:59:00.820566',253,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11312,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-19 23:59:00.822505',357,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11313,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 00:02:14.735047',132,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 00:02:14.727598',214,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11315,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 00:02:14.742720',220,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11316,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 00:02:14.733213',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11317,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 00:09:20.747737',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11318,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 00:09:20.750372',200,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11319,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 00:09:20.748655',209,151,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11320,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 00:09:20.761539',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11321,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 00:25:44.443750',150,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11322,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 00:25:44.442169',160,151,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11323,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 00:25:44.442916',184,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11324,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 00:25:44.442212',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11325,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 00:25:57.086314',184,151,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11326,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 00:25:57.090294',187,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11327,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 00:25:57.089141',227,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11328,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 00:25:57.070147',361,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11329,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 00:26:00.699676',160,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11330,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 00:26:00.712127',161,151,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11331,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 00:26:00.744011',144,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11332,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 00:26:00.702501',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11333,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 00:31:50.726147',217,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11334,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 00:31:50.744222',266,151,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11335,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 00:31:50.724222',303,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11336,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 00:31:50.762457',357,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11337,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:05:35.311720',135,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11338,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:05:35.322964',192,153,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11339,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:05:35.323895',222,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11340,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:05:35.320465',365,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11341,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:12:38.394048',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11342,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:12:38.413174',192,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11343,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:12:38.412241',214,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11344,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:12:38.410610',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11345,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:16:10.372871',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:16:10.403119',117,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11347,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:16:10.411724',182,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11348,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:16:10.399217',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11349,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:20:34.630756',136,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11350,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:20:34.643988',196,153,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11351,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:20:34.642161',204,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11352,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:20:34.630760',346,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11353,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:20:48.341701',83,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11354,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:20:48.343265',175,153,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11355,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:20:48.342869',204,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11356,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:20:48.310383',326,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11357,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:27:29.396358',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11358,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:27:29.381911',197,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11359,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:27:29.385382',242,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11360,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:27:29.383092',376,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11361,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:36:32.735052',175,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11362,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:36:32.738486',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11363,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:36:32.736123',212,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11364,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:36:32.736674',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11365,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:48:12.507339',214,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:48:12.504920',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11367,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:48:12.505018',209,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11368,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:48:12.495665',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11369,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:48:23.702381',37,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11370,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:48:23.718088',160,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11371,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:48:23.720907',170,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11372,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:48:23.710272',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11373,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:48:26.600242',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11374,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:48:26.602242',155,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11375,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:48:26.599387',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11376,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:53:52.887037',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11377,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:53:52.896937',211,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11378,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:53:52.882541',244,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11379,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:53:52.886254',361,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11380,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:53:57.908816',172,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11381,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:53:57.902969',208,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11382,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:53:57.900904',218,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11383,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:53:57.894965',328,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11384,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:54:04.774241',206,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11385,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:54:04.782181',190,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11386,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:54:04.795902',172,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11387,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:54:04.793397',322,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11388,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:54:08.530887',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11389,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:54:08.540739',206,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11390,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:54:08.542837',193,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11391,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:54:08.529640',342,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11392,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 01:58:52.220393',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11393,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 01:58:52.202317',199,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11394,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 01:58:52.222600',224,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11395,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 01:58:52.196061',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11396,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:03:52.126217',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11397,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:03:52.131038',153,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11398,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:03:52.141261',179,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11399,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:03:52.143859',282,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11400,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:04:04.945349',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11401,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:04:04.951687',159,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11402,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:04:04.935736',206,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11403,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:04:04.946525',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11404,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:04:06.943251',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11405,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:04:06.951567',183,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11406,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:04:06.953345',206,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11407,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:04:06.956381',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11408,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:31:13.819702',83,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11409,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:31:13.807680',131,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11410,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:31:13.813198',201,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11411,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:31:13.829150',287,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11412,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:43:01.751264',201,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11413,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:43:01.744073',207,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11414,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:43:01.760739',250,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11415,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:43:01.754607',332,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11416,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:48:17.232705',179,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11417,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:48:17.228535',200,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11418,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:48:17.242935',195,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11419,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:48:17.239031',317,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11420,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:50:20.398072',125,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11421,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:50:20.389992',180,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11422,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:50:20.393499',204,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11423,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:50:20.390277',366,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11424,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:50:25.199526',206,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11425,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:50:25.226075',201,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11426,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:50:25.203314',246,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11427,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:50:25.192470',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11428,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:50:28.920670',96,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11429,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:50:28.915500',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11430,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:51:15.799928',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11431,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:51:15.768042',207,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11432,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:51:15.756702',228,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11433,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:51:15.752420',295,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11434,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:52:45.920748',93,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11435,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:52:45.893798',153,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11436,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:52:45.922464',182,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11437,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:52:45.909176',276,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11438,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 02:59:49.485485',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11439,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 02:59:49.489695',191,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11440,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 02:59:49.488455',197,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11441,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 02:59:49.501154',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11442,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:10:51.595160',59,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11443,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:10:51.614322',174,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11444,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:10:51.644740',131,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11445,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:10:51.600380',295,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11446,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:21:47.326419',170,154,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11447,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:21:47.317255',178,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11448,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:21:47.319272',230,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11449,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:21:47.330376',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11450,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:24:39.908871',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11451,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:24:39.907273',170,155,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11452,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:24:39.910667',189,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11453,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:24:39.910802',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11454,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:28:13.575448',119,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11455,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:28:13.633711',156,155,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11456,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:28:13.619959',205,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11457,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:28:13.587288',293,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11458,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:58:37.567764',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11459,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:58:37.602845',182,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11460,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:58:37.599897',209,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11461,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:58:37.573293',346,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11462,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:59:45.761337',107,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11463,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:59:45.761337',181,156,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11464,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:59:45.771002',212,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11465,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:59:45.762362',336,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11466,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 03:59:52.659132',159,156,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11467,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 03:59:52.664230',148,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11468,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 03:59:52.672427',182,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11469,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 03:59:52.665993',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11470,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:00:42.362125',111,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11471,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:00:42.385189',142,156,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11472,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:00:42.423434',136,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11473,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:00:42.378097',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11474,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:00:45.272782',169,156,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11475,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:00:45.287642',152,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11476,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:00:45.271302',216,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11477,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:00:45.264486',343,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11478,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:08:56.885699',174,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11479,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:08:56.894132',176,156,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11480,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:08:56.882187',206,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11481,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:08:56.871555',360,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11482,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:09:02.039486',176,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11483,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:09:02.047491',177,156,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11484,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:09:02.074940',171,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11485,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:09:02.034733',297,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11486,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:09:13.228357',123,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11487,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:09:13.252977',157,156,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11488,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:09:13.231450',222,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11489,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:09:13.246365',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11490,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:09:16.701719',59,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11491,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:09:16.753687',115,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11492,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:09:16.757012',272,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11493,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:10:39.798258',102,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11494,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:10:39.793259',214,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11495,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:10:39.799846',217,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11496,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:10:39.809997',309,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11497,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:10:56.591433',120,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11498,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:10:56.614767',168,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11499,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:10:56.608967',181,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11500,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:10:56.597310',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11501,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:10:58.469265',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11502,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:10:58.485230',166,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11503,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:10:58.490827',170,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11504,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:10:58.488805',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11505,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:12:01.405332',159,156,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11506,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:12:01.416862',145,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11507,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:12:01.403337',199,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11508,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:12:01.414513',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11509,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:31:19.239630',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11510,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:31:19.237101',181,156,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11511,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:31:19.232522',204,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11512,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:31:19.229702',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11513,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:48:36.830245',212,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11514,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:48:36.851036',204,158,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11515,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:48:36.835767',271,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11516,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:48:36.839702',395,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11517,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 04:49:41.089072',123,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11518,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 04:49:41.111300',153,158,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11519,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 04:49:41.112973',181,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11520,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 04:49:41.113172',285,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11521,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:27:30.907063',187,158,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11522,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:27:30.913472',195,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11523,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:27:30.898379',188,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11524,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:27:30.899322',360,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11525,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:34:07.991350',181,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11526,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:34:07.999037',191,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11527,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:34:07.993852',231,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11528,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:34:07.994205',364,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11529,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:50:03.752061',180,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11530,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:50:03.745924',193,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11531,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:50:03.756427',215,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11532,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:50:03.779974',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11533,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:52:21.961025',114,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11534,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:52:22.080160',201,159,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11535,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:52:21.958303',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11536,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:52:22.038074',269,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11537,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:59:17.665945',185,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11538,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:59:17.665625',199,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11539,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:59:17.667273',222,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11540,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:59:17.668285',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11541,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:59:29.313969',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11542,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:59:29.316483',163,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11543,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:59:29.315318',193,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11544,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:59:29.311109',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11545,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 05:59:31.313708',170,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11546,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 05:59:31.321686',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11547,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 05:59:31.362294',151,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11548,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 05:59:31.337055',308,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11549,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:00:23.689657',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11550,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:00:23.683097',184,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11551,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:00:23.691996',201,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11552,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:00:23.715291',289,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11553,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:07:18.070370',144,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11554,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:07:18.084915',206,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11555,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:07:18.060688',245,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11556,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:07:18.083299',345,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11557,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:07:30.122942',165,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11558,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:07:30.116194',167,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11559,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:07:30.125366',187,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11560,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:07:30.126733',336,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11561,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:07:32.235146',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11562,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:07:32.255515',208,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11563,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:07:32.265333',248,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11564,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:07:32.246939',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11565,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:14:06.720994',148,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11566,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:14:06.723047',202,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11567,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:14:06.734306',216,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11568,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:14:06.721851',388,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11569,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:16:58.881165',124,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11570,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:16:58.908133',142,159,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11571,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:16:58.890907',193,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11572,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:16:58.884982',332,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11573,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:17:17.770629',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11574,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:17:17.782420',166,159,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11575,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:17:17.783751',201,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11576,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:17:17.781212',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11577,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:19:39.552777',180,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11578,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:19:39.559222',183,159,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11579,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:19:39.566085',252,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11580,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:19:39.550103',369,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11581,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:24:13.515115',169,162,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11582,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:24:13.518385',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11583,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:24:13.521211',198,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11584,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:24:13.512049',286,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11585,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:39:05.604540',168,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11586,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:39:05.597031',193,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11587,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:39:05.606246',198,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11588,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:39:05.587116',373,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11589,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:39:54.805515',164,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11590,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:39:54.797559',163,162,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11591,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:39:54.796032',202,96,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11592,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:39:54.796912',328,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11593,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:40:55.696624',126,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11594,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:40:55.695325',141,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11595,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:40:55.726457',165,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11596,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:40:55.711350',270,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11597,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:42:30.576445',154,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11598,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:42:30.632823',166,162,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11599,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:42:30.615190',208,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11600,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:42:30.569464',356,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11601,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:44:19.468825',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11602,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:44:19.492152',157,162,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11603,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:44:19.499612',178,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11604,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:44:19.500571',299,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11605,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:44:54.504027',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11606,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:44:54.501229',144,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11607,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:44:54.498953',177,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11608,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:44:54.520725',283,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11609,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:45:07.608791',99,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11610,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:45:07.635926',157,162,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11611,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:45:07.641944',170,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11612,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:45:07.644250',254,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11613,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:45:19.152520',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11614,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:45:19.228352',156,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11615,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:45:19.219721',174,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11616,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:45:19.213054',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11617,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:45:20.674559',93,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11618,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:45:20.676725',151,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11619,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:45:20.667469',227,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11620,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:45:20.686460',339,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11621,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:45:23.394120',164,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11622,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:45:23.370952',196,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11623,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:45:23.389804',205,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11624,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:45:23.392197',316,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11625,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:45:25.763981',141,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11626,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:45:25.768479',201,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11627,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:45:25.781315',200,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11628,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:45:25.776548',319,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11629,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:45:26.389271',138,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11630,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:45:26.394559',178,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11631,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:45:26.392057',186,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11632,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:45:26.382603',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11633,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:46:44.420497',131,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11634,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:46:44.412337',192,162,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11635,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:46:44.411537',223,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11636,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:46:44.411689',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11637,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:48:58.009664',175,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11638,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:48:58.021045',194,162,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11639,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:48:58.019497',239,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11640,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:48:58.023544',346,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11641,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:49:42.106339',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11642,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:49:42.111997',159,162,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11643,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:49:42.107425',208,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11644,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:49:42.101313',340,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11645,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 06:52:22.918316',177,162,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11646,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 06:52:22.919993',194,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11647,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 06:52:22.925171',267,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11648,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 06:52:22.909538',387,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11649,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:00:40.952125',204,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11650,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:00:40.956103',195,162,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11651,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:00:40.965169',231,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11652,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:00:40.963605',341,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11653,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:02:29.345906',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11654,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:02:29.343146',167,163,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11655,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:02:29.359033',194,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11656,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:02:29.348733',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11657,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:05:43.598201',160,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11658,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:05:43.593933',185,163,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11659,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:05:43.594811',222,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11660,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:05:43.599814',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11661,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:07:36.028626',185,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11662,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:07:36.007846',247,163,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11663,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:07:36.005325',291,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11664,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:07:36.000312',418,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11665,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:08:22.342398',117,163,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11666,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:08:22.323222',215,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11667,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:08:22.319950',200,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11668,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:08:22.333353',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11669,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:09:07.236903',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11670,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:09:07.233167',164,163,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11671,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:09:07.242840',195,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL);
INSERT INTO `query_execution` VALUES (11672,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:09:07.239487',335,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11673,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:12:46.741249',171,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11674,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:12:46.742289',165,165,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11675,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:12:46.738210',190,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11676,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:12:46.743613',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11677,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:21:06.155430',177,165,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11678,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:21:06.147919',174,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11679,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:21:06.154272',224,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11680,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:21:06.162087',299,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11681,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:22:47.978430',147,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11682,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:22:47.980108',159,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11683,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:22:47.978305',188,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11684,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:22:47.985358',305,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11685,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:22:55.514951',155,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11686,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:22:55.512376',170,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11687,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:22:55.522024',163,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11688,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:22:55.531460',275,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11689,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:22:58.994505',109,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11690,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:22:59.003504',163,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11691,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:22:58.998262',196,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11692,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:22:59.004114',291,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11693,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:23:04.475723',85,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11694,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:23:04.484246',146,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11695,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:23:04.470118',187,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11696,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:23:04.464934',308,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11697,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:23:22.615107',149,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11698,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:23:22.629801',145,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11699,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:23:22.608165',173,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11700,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:23:22.612494',300,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11701,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:23:25.724185',154,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11702,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:23:25.735158',169,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11703,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:23:25.720291',216,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11704,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:23:25.731110',296,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11705,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:24:04.331377',153,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11706,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:24:04.324250',188,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11707,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:24:04.318212',224,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11708,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:24:04.324725',323,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11709,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:24:29.299018',69,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11710,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:24:29.301909',196,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11711,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:24:29.303119',226,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11712,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:24:29.309110',334,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11713,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:24:33.482984',167,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11714,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:24:33.476113',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11715,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:24:33.466832',196,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11716,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:24:33.485906',281,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11717,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:25:12.958216',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11718,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:25:12.961797',202,166,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11719,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:25:12.960030',211,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11720,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:25:12.963023',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11721,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:25:36.131308',202,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11722,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:25:36.129517',223,166,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11723,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:25:36.132428',350,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11724,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:25:36.102568',544,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11725,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:26:02.167311',118,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11726,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:26:02.182200',198,166,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11727,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:26:02.184944',217,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11728,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:26:02.173451',319,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11729,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:27:42.188667',160,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11730,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:27:42.183876',185,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11731,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:27:42.179821',193,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11732,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:27:42.199410',297,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11733,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:28:49.680703',160,166,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11734,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:28:49.704461',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11735,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:28:49.674454',194,96,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11736,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:28:49.699233',280,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11737,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:29:12.126338',150,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11738,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:29:12.133447',161,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11739,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:29:12.137436',181,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11740,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:29:12.133352',294,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11741,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:29:44.242453',149,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11742,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:29:44.220751',169,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11743,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:29:44.237769',163,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11744,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:29:44.224127',316,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11745,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:33:41.091941',49,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11746,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:33:41.128408',155,166,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11747,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:33:41.111446',173,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11748,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:33:41.120282',299,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11749,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:47:49.219233',156,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11750,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:47:49.208794',220,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11751,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:47:49.229064',218,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11752,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:47:49.208794',372,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11753,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:48:44.490095',110,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11754,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:48:44.494724',138,166,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11755,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:48:44.483818',199,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11756,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:48:44.493990',314,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11757,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:50:11.824308',158,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11758,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:50:11.832439',181,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11759,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:50:11.833441',199,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11760,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:50:11.831236',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11761,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:50:16.609157',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11762,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:50:16.640735',141,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11763,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:50:16.625532',171,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11764,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:50:16.616200',274,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11765,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:50:25.997999',178,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11766,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:50:26.007802',187,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11767,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:50:26.004387',214,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11768,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:50:26.011405',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11769,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:50:56.887308',145,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11770,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:50:56.885410',171,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11771,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:50:56.897831',169,166,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11772,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:50:56.887236',301,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11773,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:52:32.062313',131,167,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11774,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:52:32.069529',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11775,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:52:32.054644',157,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11776,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:52:32.059876',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11777,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:55:17.194042',162,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11778,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:55:17.176963',235,167,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11779,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:55:17.188468',251,96,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11780,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:55:17.181413',363,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11781,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 07:59:03.984834',128,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11782,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 07:59:03.980939',141,167,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11783,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 07:59:03.995551',174,96,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11784,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 07:59:03.985894',298,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11785,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:02:36.871891',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11786,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:02:36.877042',163,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11787,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:02:36.875994',198,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11788,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:02:36.882430',331,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11789,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:02:52.621877',148,10,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11790,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:02:52.610429',157,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11791,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:02:52.629090',150,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11792,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:02:52.638402',308,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11793,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:03:50.656680',183,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11794,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:03:50.674448',197,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11795,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:03:50.664219',250,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11796,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:03:50.712210',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11797,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:04:20.782785',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11798,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:04:20.784962',136,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11799,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:04:20.773344',166,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11800,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:04:20.786931',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11801,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:05:05.689355',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11802,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:05:05.688495',126,10,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11803,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:05:05.692391',196,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11804,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:05:05.688548',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11805,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:05:16.791117',177,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11806,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:05:16.787850',189,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11807,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:05:16.790255',197,10,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11808,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:05:16.785329',302,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11809,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:13:18.335874',155,24,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11810,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:13:18.347869',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11811,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:13:18.346251',212,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11812,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:13:18.349153',354,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11813,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:14:30.375070',63,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11814,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:14:30.397763',199,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11815,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:14:30.403536',173,24,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11816,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:14:30.410984',319,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11817,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:16:09.175274',101,24,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11818,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:16:09.138926',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11819,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:16:09.158440',181,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11820,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:16:09.168271',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11821,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:17:25.464656',111,24,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11822,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:17:25.465927',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11823,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:17:25.471974',180,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11824,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:17:25.461462',313,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11825,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:23:36.627433',152,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11826,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:23:36.629443',170,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11827,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:23:36.632222',180,31,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11828,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:23:36.622920',350,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11829,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:27:17.829159',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11830,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:27:17.821173',153,31,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11831,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:27:17.827031',170,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11832,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:27:17.817423',311,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11833,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:28:55.794162',159,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11834,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:28:55.793519',168,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11835,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:28:55.782194',199,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11836,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:28:55.796131',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11837,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:29:31.102577',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11838,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:29:31.097140',163,31,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11839,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:29:31.100405',201,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11840,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:29:31.096010',294,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11841,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:29:35.602982',126,31,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11842,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:29:35.626071',130,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11843,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:29:35.628554',167,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11844,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:29:35.610822',292,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11845,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:30:01.751464',143,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11846,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:30:01.735968',190,31,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11847,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:30:01.728451',201,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11848,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:30:01.758147',324,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11849,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:31:56.130890',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11850,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:31:56.128481',148,31,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11851,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:31:56.121181',201,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11852,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:31:56.132917',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11853,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:37:54.630773',178,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11854,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:37:54.640217',200,34,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11855,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:37:54.643275',211,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11856,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:37:54.636362',348,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11857,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:40:07.960514',178,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11858,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:40:07.962391',181,34,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11859,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:40:07.980098',187,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11860,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:40:07.964012',313,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11861,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:54:15.147421',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11862,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:54:15.167044',143,44,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11863,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:54:15.165024',198,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11864,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:54:15.161918',364,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11865,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:54:38.510751',111,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11866,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:54:38.517152',151,44,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11867,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:54:38.543926',175,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11868,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:54:38.533908',268,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11869,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 08:55:22.721249',103,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11870,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 08:55:22.761242',188,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11871,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 08:55:22.768669',175,44,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11872,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 08:55:22.707812',409,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11873,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:02:05.988661',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11874,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:02:06.001768',154,44,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11875,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:02:05.994276',178,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11876,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:02:06.000379',284,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11877,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:02:17.665077',158,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11878,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:02:17.662494',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11879,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:02:17.686124',157,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11880,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:02:17.649230',307,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11881,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:02:20.581880',188,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11882,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:02:20.585214',190,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11883,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:02:20.595637',181,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11884,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:02:20.579231',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11885,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:10:38.463842',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11886,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:10:38.457200',224,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11887,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:10:38.463854',239,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11888,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:10:38.466456',317,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11889,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:10:49.534788',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11890,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:10:49.572978',105,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11891,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:10:49.553917',178,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11892,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:10:49.560636',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11893,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:10:52.519539',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11894,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:10:52.522423',160,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11895,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:10:52.564151',181,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11896,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:10:52.508027',297,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11897,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:11:02.100021',156,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11898,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:11:02.086404',151,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11899,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:11:02.084912',209,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11900,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:11:02.078849',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11901,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:11:13.819398',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11902,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:11:13.855005',159,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11903,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:11:13.853018',168,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11904,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:11:13.833774',316,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11905,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:11:16.769521',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11906,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:11:16.772076',174,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11907,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:11:16.764337',197,53,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11908,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:11:16.763335',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11909,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:15:53.143987',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11910,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:15:53.159786',154,61,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11911,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:15:53.152454',168,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11912,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:15:53.150419',295,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11913,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:17:38.055961',170,61,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11914,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:17:38.053809',177,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11915,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:17:38.060922',196,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11916,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:17:38.048325',308,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11917,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:24:04.187110',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11918,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:24:04.195933',178,65,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11919,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:24:04.178343',209,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11920,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:24:04.207910',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11921,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:28:02.753467',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11922,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:28:02.800052',158,65,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11923,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:28:02.766030',208,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11924,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:28:02.782095',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11925,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:35:21.823043',117,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11926,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:35:21.831501',129,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11927,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:35:21.839860',195,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11928,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:35:21.826896',333,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11929,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:35:25.200376',126,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11930,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:35:25.213425',168,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11931,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:35:25.210370',169,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11932,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:35:25.196161',346,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11933,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:36:25.688168',176,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11934,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:36:25.707650',173,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11935,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:36:25.703354',201,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11936,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:36:25.697282',270,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11937,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:36:35.074412',127,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11938,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:36:35.082075',159,68,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11939,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:36:35.097374',179,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11940,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:36:35.080519',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11941,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:36:39.113837',132,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11942,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:36:39.102006',146,68,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11943,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:36:39.143439',164,97,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11944,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:36:39.128499',261,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11945,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:37:51.423941',127,68,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11946,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:37:51.426260',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11947,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:37:51.428857',176,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11948,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:37:51.430570',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11949,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:43:17.045705',165,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11950,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:43:17.040838',172,71,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11951,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:43:17.051336',186,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11952,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:43:17.049547',330,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11953,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:43:20.831897',160,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11954,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:43:20.828534',191,71,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11955,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:43:20.836666',199,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11956,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:43:20.835482',261,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11957,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:43:50.616499',131,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11958,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:43:50.665687',231,71,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11959,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:43:50.618376',286,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11960,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:43:50.665609',352,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11961,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 09:45:22.492122',146,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11962,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 09:45:22.496783',135,71,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11963,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 09:45:22.511602',170,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11964,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 09:45:22.506571',318,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11965,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:05:37.549502',166,75,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11966,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:05:37.549500',111,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11967,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:05:37.562043',166,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11968,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:05:37.551207',296,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11969,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:11:59.298080',208,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11970,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:11:59.282329',248,75,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11971,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:11:59.293390',242,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11972,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:11:59.283276',266,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11973,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:12:12.006708',145,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11974,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:12:12.013855',175,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11975,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:12:12.012060',233,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11976,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:12:12.024340',325,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11977,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:12:14.836367',101,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11978,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:12:14.819739',155,79,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11979,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:12:14.839403',175,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11980,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:12:14.825257',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11981,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:36:24.534169',119,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11982,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:36:24.563629',175,81,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11983,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:36:24.568227',180,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11984,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:36:24.556531',309,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11985,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:38:15.440247',151,81,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11986,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:38:15.461016',158,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11987,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:38:15.462733',176,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11988,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:38:15.444365',288,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11989,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:38:20.893347',115,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11990,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:38:20.895467',141,81,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11991,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:38:20.918721',175,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11992,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:38:20.908084',277,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11993,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:38:27.584225',125,81,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11994,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:38:27.571014',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11995,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:38:27.593331',157,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11996,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:38:27.587069',271,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11997,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:38:33.932954',134,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11998,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:38:33.975842',188,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(11999,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:38:33.977408',130,81,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12000,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:38:33.965336',293,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12001,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:58:27.873427',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12002,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:58:27.916364',172,84,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12003,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:58:27.913576',205,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12004,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:58:27.915198',283,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12005,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 10:58:47.295659',43,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12006,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 10:58:47.461436',62,84,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12007,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 10:58:47.356439',221,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12008,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 10:58:47.736611',95,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12009,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:01:25.704566',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12010,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:01:25.695599',195,84,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12011,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:01:25.694305',231,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12012,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:01:25.706049',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12013,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:02:15.061356',95,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12014,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:02:15.072715',173,85,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12015,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:02:15.074285',195,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12016,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:02:15.062526',287,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12017,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:06:00.294563',108,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12018,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:06:00.331903',114,85,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12019,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:06:00.353857',155,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12020,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:06:00.324684',273,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12021,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:22:47.416469',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12022,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:22:47.407700',170,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12023,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:22:47.406221',206,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12024,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:22:47.413785',293,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12025,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:23:16.824350',155,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12026,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:23:16.809658',172,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12027,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:23:16.826024',175,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12028,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:23:16.813681',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12029,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:32:58.773825',179,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12030,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:32:58.771755',211,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12031,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:32:58.770213',220,90,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12032,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:32:58.767360',341,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12033,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:33:39.748003',166,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12034,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:33:39.764674',158,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12035,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:33:39.753196',170,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12036,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:33:39.763468',269,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12037,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:35:17.330805',184,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12038,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:35:17.346468',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12039,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:35:17.334020',178,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12040,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:35:17.335848',364,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12041,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:36:34.733785',186,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12042,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:36:34.713191',194,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12043,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:36:34.728280',204,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12044,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:36:34.715968',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12045,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:36:59.246730',157,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12046,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:36:59.233269',192,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12047,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:36:59.248488',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12048,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:36:59.226824',312,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12049,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:37:11.836268',110,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12050,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:37:11.856189',162,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12051,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:37:11.831266',215,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12052,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:37:11.849526',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12053,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:37:13.756606',163,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12054,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:37:13.775530',153,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12055,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:37:13.769111',238,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12056,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:37:13.738162',342,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12057,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:44:21.587450',128,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12058,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:44:21.599832',162,90,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12059,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:44:21.610680',181,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12060,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:44:21.612357',291,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12061,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:56:17.382980',168,91,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12062,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:56:17.372567',169,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12063,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:56:17.374326',193,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12064,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:56:17.374321',303,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12065,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:56:28.343107',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12066,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:56:28.365569',165,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12067,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:56:28.374113',165,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12068,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:56:28.351370',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12069,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:56:39.622868',199,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12070,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:56:39.632808',198,91,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12071,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:56:39.627106',214,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12072,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:56:39.630287',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12073,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:57:34.294170',120,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12074,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:57:34.341661',165,91,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12075,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:57:34.339087',168,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12076,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:57:34.340694',273,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12077,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 11:57:35.539204',168,91,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12078,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 11:57:35.545311',166,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12079,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 11:57:35.552879',207,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12080,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 11:57:35.562198',287,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12081,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:16:43.485209',48,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12082,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:16:43.513411',148,92,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12083,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:16:43.524747',166,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12084,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:16:43.516475',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12085,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:40:00.797973',132,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12086,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:40:00.795096',164,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12087,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:40:00.813892',189,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12088,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:40:00.804253',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12089,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:40:11.883535',103,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12090,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:40:11.899950',176,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12091,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:40:11.901749',195,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12092,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:40:11.887570',277,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12093,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:40:14.866297',109,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12094,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:40:14.864541',137,93,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12095,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:40:14.870214',187,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12096,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:40:14.859066',294,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12097,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:40:21.228620',144,93,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12098,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:40:21.250426',140,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12099,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:40:21.217685',209,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12100,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:40:21.249155',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12101,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:42:46.657969',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12102,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:42:46.667554',167,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12103,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:42:46.678784',191,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12104,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:42:46.661161',264,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12105,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:44:51.689012',140,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12106,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:44:51.699311',158,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12107,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:44:51.697136',168,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12108,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:44:51.695576',300,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12109,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:47:02.650863',82,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12110,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:47:02.649935',159,94,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12111,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:47:02.642350',196,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12112,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:47:02.650839',264,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12113,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 12:50:33.518102',181,94,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12114,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 12:50:33.533489',184,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12115,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 12:50:33.519653',217,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12116,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 12:50:33.512548',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12117,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:01:40.635502',171,94,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12118,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:01:40.631252',202,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12119,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:01:40.646293',212,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12120,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:01:40.638355',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12121,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:04:55.948535',128,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12122,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:04:55.937752',155,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12123,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:04:55.918510',189,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12124,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:04:55.909382',310,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12125,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:21:14.342609',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12126,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:21:14.350020',196,94,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12127,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:21:14.341307',214,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12128,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:21:14.340900',312,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12129,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:44:32.836629',153,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12130,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:44:32.836640',176,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12131,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:44:32.849351',185,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12132,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:44:32.838252',324,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12133,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:49:43.375084',168,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12134,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:49:43.386486',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12135,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:49:43.373348',230,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12136,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:49:43.366902',304,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12137,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:50:10.158982',161,95,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12138,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:50:10.161013',161,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12139,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:50:10.149223',153,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12140,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:50:10.148693',328,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12141,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:50:36.953775',147,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12142,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:50:36.952156',127,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12143,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:50:36.947954',189,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12144,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:50:36.958062',303,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12145,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 13:51:23.479650',170,95,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12146,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 13:51:23.482943',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12147,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 13:51:23.476950',214,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12148,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 13:51:23.473187',288,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12149,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 14:45:25.808737',87,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12150,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 14:45:25.816408',150,99,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12151,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 14:45:25.828777',178,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12152,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 14:45:25.806059',306,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12153,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 15:07:38.741172',148,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12154,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 15:07:38.758748',158,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12155,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 15:07:38.729813',196,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12156,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 15:07:38.750769',288,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12157,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 15:07:49.712637',160,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12158,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 15:07:49.703296',190,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12159,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 15:07:49.703524',204,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12160,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 15:07:49.717210',342,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12161,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 15:12:09.452033',142,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12162,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 15:12:09.462519',124,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12163,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 15:12:09.486709',197,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12164,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 15:12:09.466337',320,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12165,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 15:13:47.164032',149,100,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12166,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 15:13:47.148960',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12167,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 15:13:47.177505',146,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12168,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 15:13:47.156447',279,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12169,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 17:33:51.853150',162,115,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12170,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 17:33:51.862702',134,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12171,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 17:33:51.860875',198,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12172,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 17:33:51.870274',273,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12173,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 19:49:39.268230',152,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12174,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 19:49:39.283166',143,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12175,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 19:49:39.280042',204,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12176,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 19:49:39.266701',344,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12177,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 20:09:08.603235',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12178,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 20:09:08.621567',221,123,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12179,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 20:09:08.614892',235,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12180,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 20:09:08.617811',361,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12181,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 20:24:10.158229',169,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12182,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 20:24:10.191130',200,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12183,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 20:24:10.176005',212,124,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12184,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 20:24:10.197302',349,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12185,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 20:28:07.132546',203,124,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12186,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 20:28:07.141956',172,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12187,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 20:28:07.143499',212,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12188,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 20:28:07.150783',348,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12189,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 21:02:19.630398',168,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12190,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 21:02:19.634382',177,127,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12191,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 21:02:19.644227',187,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12192,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 21:02:19.641773',350,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12193,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 21:42:42.183494',60,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12194,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 21:42:42.196479',157,131,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12195,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 21:42:42.203917',215,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12196,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 21:42:42.199922',291,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12197,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 21:45:41.054337',216,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12198,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 21:45:41.070260',223,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12199,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 21:45:41.073077',233,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12200,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 21:45:41.068321',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12201,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 21:46:50.073078',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12202,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 21:46:50.171310',190,131,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12203,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 21:46:50.184105',351,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12204,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 21:46:50.187707',421,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12205,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:23:43.352788',174,133,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12206,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:23:43.355287',163,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12207,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:23:43.358784',177,97,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12208,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:23:43.380902',299,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12209,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:44:20.138289',136,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12210,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:44:20.139113',155,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12211,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:44:20.141232',206,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12212,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:44:20.133750',298,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12213,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:45:59.083725',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12214,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:45:59.099306',167,135,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12215,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:45:59.100806',183,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12216,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:45:59.098910',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12217,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:52:53.436746',196,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12218,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:52:53.452083',222,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12219,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:52:53.454370',247,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12220,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:52:53.436774',366,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12221,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:53:00.572513',170,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12222,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:53:00.570712',209,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12223,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:53:00.584274',222,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12224,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:53:00.570359',340,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12225,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:53:05.496700',167,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12226,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:53:05.508081',190,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12227,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:53:05.515995',195,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12228,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:53:05.504182',332,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12229,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 22:53:09.106795',92,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12230,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 22:53:09.115338',156,135,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12231,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 22:53:09.131861',173,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12232,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 22:53:09.130454',284,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12233,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 23:04:21.092543',127,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12234,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 23:04:21.111411',172,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12235,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 23:04:21.107438',217,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12236,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 23:04:21.113624',348,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12237,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 23:19:34.607945',176,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12238,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 23:19:34.607948',176,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12239,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 23:19:34.619544',178,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12240,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 23:19:34.619014',332,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12241,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 23:20:22.519225',180,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12242,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 23:20:22.508998',211,135,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12243,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 23:20:22.511528',236,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12244,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 23:20:22.507509',314,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12245,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 23:37:41.407405',173,137,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12246,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 23:37:41.395288',212,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12247,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 23:37:41.393018',225,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12248,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 23:37:41.389788',343,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12249,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 23:41:18.112417',152,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12250,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 23:41:18.122516',173,137,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12251,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 23:41:18.121352',180,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12252,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 23:41:18.118458',293,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12253,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-20 23:46:27.752789',174,137,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12254,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-20 23:46:27.743136',184,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12255,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-20 23:46:27.747640',210,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12256,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-20 23:46:27.754051',315,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12257,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:09:38.752877',172,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12258,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:09:38.744545',185,141,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12259,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:09:38.757567',201,97,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12260,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:09:38.773345',305,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12261,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:17:43.273339',197,142,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12262,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:17:43.275958',203,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12263,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:17:43.293615',211,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12264,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:17:43.270312',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12265,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:40:00.267014',133,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12266,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:40:00.264954',186,143,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12267,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:40:00.262092',219,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12268,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:40:00.259502',321,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12269,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:47:08.723180',133,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12270,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:47:08.732886',204,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12271,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:47:08.734517',197,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12272,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:47:08.724137',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12273,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:47:22.071997',98,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12274,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:47:22.038388',183,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12275,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:47:22.033299',185,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12276,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:47:22.058880',323,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12277,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:47:25.107396',181,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12278,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:47:25.112803',205,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12279,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:47:25.110544',226,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12280,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:47:25.098924',327,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12281,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:48:10.106269',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12282,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:48:10.109144',186,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12283,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:48:10.116822',212,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12284,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:48:10.111338',296,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12285,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:48:23.948610',171,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12286,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:48:23.993789',134,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12287,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:48:23.943816',220,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12288,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:48:24.007419',305,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12289,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 00:48:26.892274',149,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12290,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 00:48:26.893922',204,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12291,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 00:48:26.888472',225,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12292,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 00:48:26.889975',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12293,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:01:43.696405',177,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12294,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:01:43.707550',226,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12295,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:01:43.708702',260,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12296,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:01:43.691543',306,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12297,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:01:50.807336',155,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12298,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:01:50.846633',172,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12299,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:01:50.845033',161,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12300,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:01:50.793818',363,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12301,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:01:54.535889',173,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12302,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:01:54.564827',201,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12303,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:01:54.555045',239,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12304,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:01:54.540371',348,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12305,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:01:57.522606',164,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12306,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:01:57.502520',190,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12307,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:01:57.507699',226,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12308,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:01:57.509838',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12309,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:19:51.878831',168,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12310,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:19:51.877659',210,144,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12311,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:19:51.880643',225,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12312,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:19:51.873357',343,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12313,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:20:08.460058',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12314,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:20:08.443232',166,144,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12315,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:20:08.446159',188,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12316,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:20:08.455882',302,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12317,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 01:27:11.496612',158,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12318,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 01:27:11.496044',135,144,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12319,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 01:27:11.496051',201,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12320,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 01:27:11.493915',334,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12321,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:00:41.332743',135,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12322,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:00:41.336879',160,145,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12323,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:00:41.331033',202,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12324,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:00:41.324256',292,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12325,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:00:45.996991',122,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12326,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:00:46.005282',158,145,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12327,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:00:46.031186',157,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12328,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:00:46.036396',279,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12329,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:02:20.709301',148,145,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12330,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:02:20.707086',122,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12331,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:02:20.716445',179,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12332,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:02:20.706930',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12333,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:23:32.218056',170,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12334,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:23:32.225626',206,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12335,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:23:32.228773',193,145,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12336,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:23:32.238706',304,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12337,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:36:31.993499',142,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12338,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:36:32.031122',204,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12339,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:36:32.051314',211,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12340,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:36:32.006943',362,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12341,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:46:13.548360',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12342,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:46:13.573879',251,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12343,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:46:13.569512',249,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12344,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:46:13.571209',369,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12345,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:49:43.442069',170,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12346,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:49:43.455182',179,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12347,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:49:43.442952',224,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12348,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:49:43.444513',314,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12349,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:53:37.970026',171,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12350,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:53:37.951558',181,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12351,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:53:37.957338',236,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12352,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:53:37.980823',330,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12353,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:57:42.983394',161,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12354,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:57:43.000291',161,146,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12355,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:57:42.996227',207,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12356,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:57:43.003462',350,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12357,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:58:46.730562',111,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12358,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:58:46.759896',184,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12359,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:58:46.744317',208,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12360,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:58:46.746223',315,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12361,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 02:59:57.475014',150,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12362,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 02:59:57.471088',153,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12363,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 02:59:57.470995',226,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12364,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 02:59:57.486214',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12365,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:00:09.287457',153,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12366,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:00:09.302230',158,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12367,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:00:09.289242',207,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12368,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:00:09.305078',320,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12369,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:00:11.232502',147,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12370,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:00:11.226446',163,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12371,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:00:11.222798',203,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12372,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:00:11.222798',283,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12373,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:29:19.725684',174,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12374,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:29:19.721159',179,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12375,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:29:19.724744',208,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12376,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:29:19.716500',389,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12377,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:29:47.692792',115,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12378,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:29:47.690542',186,146,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12379,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:29:47.697162',201,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12380,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:29:47.695642',353,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12381,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:32:31.116134',136,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12382,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:32:31.117530',194,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12383,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:32:31.124655',164,146,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12384,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:32:31.122254',286,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12385,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:33:04.168109',176,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12386,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:33:04.164359',217,146,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12387,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:33:04.179023',223,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12388,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:33:04.160924',374,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12389,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:33:19.206719',175,146,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12390,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:33:19.214608',144,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12391,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:33:19.212506',205,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12392,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:33:19.223407',333,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12393,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:33:30.916305',164,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12394,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:33:30.926208',160,146,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12395,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:33:30.935001',159,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12396,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:33:30.917910',314,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12397,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:33:48.561457',122,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12398,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:33:48.543261',175,146,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12399,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:33:48.534247',218,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12400,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:33:48.553126',356,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12401,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:37:49.011442',143,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12402,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:37:49.008960',202,146,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12403,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:37:49.010041',242,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12404,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:37:49.006634',292,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12405,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 03:42:52.832713',150,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12406,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 03:42:52.841372',159,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12407,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 03:42:52.839963',182,148,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12408,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 03:42:52.831009',299,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12409,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:20:14.851373',166,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12410,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:20:14.845109',209,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12411,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:20:14.854631',182,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12412,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:20:14.856527',332,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12413,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:20:26.824183',175,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12414,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:20:26.818952',190,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12415,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:20:26.843368',212,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12416,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:20:26.817450',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12417,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:20:28.710495',117,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12418,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:20:28.723294',213,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12419,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:20:28.733860',243,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12420,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:20:28.731776',360,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12421,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:24:52.412467',88,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12422,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:24:52.405983',158,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12423,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:24:52.401944',171,149,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12424,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:24:52.392090',342,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12425,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:28:40.911726',125,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12426,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:28:40.929514',180,149,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12427,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:28:40.928263',196,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12428,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:28:40.917118',324,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12429,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:36:31.184672',121,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12430,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:36:31.199676',186,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12431,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:36:31.188514',204,150,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12432,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:36:31.194354',329,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12433,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:36:35.170752',168,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12434,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:36:35.177205',177,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12435,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:36:35.175378',190,150,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12436,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:36:35.173223',333,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12437,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:37:11.613915',148,1,_binary '','dashboard',NULL,13371341,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12438,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:37:11.615333',174,150,_binary '','dashboard',NULL,13371341,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12439,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:37:11.616759',213,97,_binary '','dashboard',NULL,13371341,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12440,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:37:11.625131',322,288,_binary '','dashboard',NULL,13371341,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12441,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 04:48:41.848296',139,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12442,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 04:48:41.858762',209,151,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12443,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 04:48:41.875802',221,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12444,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 04:48:41.855270',312,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12445,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 05:03:19.980375',165,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12446,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 05:03:19.987006',192,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12447,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 05:03:19.972759',214,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12448,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 05:03:19.984367',311,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12449,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 05:04:18.980339',127,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12450,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 05:04:18.997419',185,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12451,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 05:04:18.995646',182,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12452,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 05:04:18.990194',344,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12453,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 05:04:41.185310',119,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12454,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 05:04:41.177935',167,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12455,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 05:04:41.170259',209,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12456,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 05:04:41.199100',281,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12457,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 05:04:44.036577',182,153,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12458,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 05:04:44.038161',152,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12459,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 05:04:44.043670',233,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12460,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 05:04:44.036666',367,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12461,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 05:30:11.552500',141,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12462,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 05:30:11.540834',190,154,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12463,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 05:30:11.521431',200,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12464,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 05:30:11.555997',295,288,_binary '','dashboard',NULL,13371340,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12465,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 05:31:55.426307',113,1,_binary '','dashboard',NULL,13371339,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12466,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 05:31:55.422801',157,154,_binary '','dashboard',NULL,13371339,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12467,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 05:31:55.441152',176,97,_binary '','dashboard',NULL,13371339,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12468,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 05:31:55.442171',297,288,_binary '','dashboard',NULL,13371339,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12469,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 06:17:39.061551',157,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12470,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 06:17:39.056711',203,158,_binary '','dashboard',NULL,13371345,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12471,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 06:17:39.059475',250,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12472,_binary '?lm.iP?A9?\????K`\\\?C	????Z\?','2024-07-21 06:17:39.049934',328,288,_binary '','dashboard',NULL,13371345,29,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12473,_binary '?\??i??{?$%+??\r?\\i??@??\Z >?\?\?n','2024-07-21 06:25:59.594422',115,159,_binary '','dashboard',NULL,13371340,30,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12474,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 06:25:59.782051',584,1,_binary '','dashboard',NULL,13371340,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12475,_binary '㇧\'~???v;\'??\'\??u8?S\???Tl','2024-07-21 06:32:00.934135',315,1,_binary '','dashboard',NULL,13371345,27,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12476,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 06:32:01.548567',4274,97,_binary '','dashboard',NULL,13371345,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL),(12477,_binary '?\??\?0l?D??\???\?Q\'\??G?8?o\??T','2024-07-21 06:34:42.711951',4826,97,_binary '','dashboard',NULL,13371340,31,2,NULL,2,_binary '\0',NULL,_binary '\0',NULL);
/*!40000 ALTER TABLE `query_execution` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `query_field`
--

DROP TABLE IF EXISTS `query_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `query_field` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'PK',
  `card_id` int NOT NULL COMMENT 'referenced card',
  `field_id` int NOT NULL COMMENT 'referenced field',
  `direct_reference` bit(1) NOT NULL DEFAULT b'1' COMMENT 'Is the Field referenced directly or via a wildcard',
  PRIMARY KEY (`id`),
  KEY `idx_query_field_card_id` (`card_id`),
  KEY `idx_query_field_field_id` (`field_id`),
  CONSTRAINT `fk_query_field_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_query_field_field_id` FOREIGN KEY (`field_id`) REFERENCES `metabase_field` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=102 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Fields used by a card''s query';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `query_field`
--

LOCK TABLES `query_field` WRITE;
/*!40000 ALTER TABLE `query_field` DISABLE KEYS */;
INSERT INTO `query_field` VALUES (1,1,62,_binary ''),(2,1,39,_binary ''),(3,1,40,_binary ''),(4,1,41,_binary ''),(5,2,46,_binary ''),(6,2,43,_binary ''),(7,2,49,_binary ''),(8,5,62,_binary ''),(9,5,39,_binary ''),(10,5,40,_binary ''),(11,5,41,_binary ''),(12,6,58,_binary ''),(13,6,40,_binary ''),(14,7,58,_binary ''),(15,7,40,_binary ''),(16,7,41,_binary ''),(17,7,44,_binary ''),(18,8,62,_binary ''),(19,8,39,_binary ''),(20,8,40,_binary ''),(21,8,41,_binary ''),(22,9,48,_binary ''),(23,9,43,_binary ''),(24,9,42,_binary ''),(25,10,46,_binary ''),(26,10,45,_binary ''),(27,11,62,_binary ''),(28,11,58,_binary ''),(29,12,39,_binary ''),(30,12,41,_binary ''),(31,12,42,_binary ''),(32,13,41,_binary ''),(33,13,42,_binary ''),(34,14,58,_binary ''),(35,14,40,_binary ''),(36,14,41,_binary ''),(37,15,41,_binary ''),(38,15,42,_binary ''),(39,16,41,_binary ''),(40,16,43,_binary ''),(41,16,44,_binary ''),(42,16,45,_binary ''),(43,17,58,_binary ''),(44,17,46,_binary ''),(45,17,40,_binary ''),(46,17,43,_binary ''),(47,17,49,_binary ''),(48,18,36,_binary ''),(49,18,41,_binary ''),(50,19,65,_binary ''),(51,19,58,_binary ''),(52,19,40,_binary ''),(53,19,61,_binary ''),(54,20,39,_binary ''),(55,20,41,_binary ''),(56,21,46,_binary ''),(57,21,43,_binary ''),(58,21,45,_binary ''),(59,21,49,_binary ''),(60,22,61,_binary ''),(61,23,65,_binary ''),(62,23,58,_binary ''),(63,23,40,_binary ''),(64,24,56,_binary ''),(65,24,47,_binary ''),(66,25,46,_binary ''),(67,25,43,_binary ''),(68,25,42,_binary ''),(69,25,49,_binary ''),(70,26,49,_binary ''),(71,27,897,_binary ''),(72,28,898,_binary ''),(73,28,899,_binary ''),(74,29,898,_binary ''),(75,29,899,_binary ''),(76,30,875,_binary ''),(77,30,672,_binary ''),(78,30,673,_binary ''),(79,30,873,_binary ''),(80,30,674,_binary ''),(81,30,874,_binary ''),(82,31,893,_binary ''),(83,31,891,_binary ''),(84,31,882,_binary ''),(85,31,887,_binary ''),(86,31,894,_binary ''),(87,31,888,_binary ''),(88,31,884,_binary ''),(89,31,878,_binary ''),(90,31,890,_binary ''),(91,31,880,_binary ''),(92,31,889,_binary ''),(93,31,886,_binary ''),(94,31,883,_binary ''),(95,31,895,_binary ''),(96,31,876,_binary ''),(97,31,879,_binary ''),(98,31,881,_binary ''),(99,31,877,_binary ''),(100,31,885,_binary ''),(101,31,892,_binary '');
/*!40000 ALTER TABLE `query_field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recent_views`
--

DROP TABLE IF EXISTS `recent_views`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `recent_views` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'The user associated with this view',
  `model` varchar(16) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The name of the model that was viewed',
  `model_id` int NOT NULL COMMENT 'The ID of the model that was viewed',
  `timestamp` timestamp(6) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_recent_views_user_id` (`user_id`),
  CONSTRAINT `fk_recent_views_ref_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5433 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Used to store recently viewed objects for each user';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recent_views`
--

LOCK TABLES `recent_views` WRITE;
/*!40000 ALTER TABLE `recent_views` DISABLE KEYS */;
INSERT INTO `recent_views` VALUES (5,13371339,'collection',3,'2024-06-19 06:21:34.101784'),(7,13371339,'card',27,'2024-06-19 06:21:50.954487'),(219,13371339,'card',28,'2024-06-19 17:41:01.380749'),(227,13371339,'card',29,'2024-06-19 17:44:31.893468'),(243,13371339,'card',30,'2024-06-19 17:53:36.086464'),(469,13371341,'card',30,'2024-06-20 22:06:07.583026'),(1039,13371345,'card',27,'2024-06-24 04:23:57.265343'),(1940,13371339,'collection',2,'2024-06-30 06:31:36.363882'),(2196,13371341,'card',29,'2024-07-01 18:10:25.646278'),(3168,13371345,'card',30,'2024-07-08 03:26:59.736850'),(4000,13371345,'card',29,'2024-07-13 23:54:54.645405'),(4901,13371339,'card',31,'2024-07-19 09:47:06.699571'),(5406,13371341,'dashboard',2,'2024-07-21 04:37:11.465753'),(5424,13371345,'dashboard',2,'2024-07-21 06:32:00.307424'),(5427,13371340,'dashboard',2,'2024-07-21 06:34:42.429447'),(5432,13371339,'dashboard',2,'2024-07-21 06:45:12.675753');
/*!40000 ALTER TABLE `recent_views` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_card`
--

DROP TABLE IF EXISTS `report_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_card` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NULL DEFAULT NULL,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `display` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `dataset_query` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `visualization_settings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `creator_id` int NOT NULL,
  `database_id` int NOT NULL,
  `table_id` int DEFAULT NULL,
  `query_type` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `archived` bit(1) NOT NULL DEFAULT b'0',
  `collection_id` int DEFAULT NULL COMMENT 'Optional ID of Collection this Card belongs to.',
  `public_uuid` char(36) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Unique UUID used to in publically-accessible links to this Card.',
  `made_public_by_id` int DEFAULT NULL COMMENT 'The ID of the User who first publically shared this Card.',
  `enable_embedding` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Is this Card allowed to be embedded in different websites (using a signed JWT)?',
  `embedding_params` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `cache_ttl` int DEFAULT NULL COMMENT 'The maximum time, in seconds, to return cached results for this Card rather than running a new query.',
  `result_metadata` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `collection_position` smallint DEFAULT NULL COMMENT 'Optional pinned position for this item in its Collection. NULL means item is not pinned.',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  `parameters` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'List of parameter associated to a card',
  `parameter_mappings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci COMMENT 'List of parameter associated to a card',
  `collection_preview` bit(1) NOT NULL DEFAULT b'1',
  `metabase_version` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Metabase version used to create the card.',
  `type` varchar(16) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'question' COMMENT 'The type of card, could be ''question'', ''model'', ''metric''',
  `initially_published_at` timestamp(6) NULL DEFAULT NULL COMMENT 'The timestamp when the card was first published in a static embed',
  `cache_invalidated_at` timestamp(6) NULL DEFAULT NULL COMMENT 'An invalidation time that can supersede cache_config.invalidated_at',
  `last_used_at` timestamp(6) NULL DEFAULT NULL COMMENT 'The timestamp of when the card is last used',
  `view_count` int NOT NULL DEFAULT '0' COMMENT 'Keeps a running count of card views',
  PRIMARY KEY (`id`),
  UNIQUE KEY `public_uuid` (`public_uuid`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_card_creator_id` (`creator_id`),
  KEY `idx_card_collection_id` (`collection_id`),
  KEY `idx_card_public_uuid` (`public_uuid`),
  KEY `fk_card_made_public_by_id` (`made_public_by_id`),
  KEY `fk_report_card_ref_database_id` (`database_id`),
  KEY `fk_report_card_ref_table_id` (`table_id`),
  CONSTRAINT `fk_card_collection_id` FOREIGN KEY (`collection_id`) REFERENCES `collection` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_card_made_public_by_id` FOREIGN KEY (`made_public_by_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_card_ref_user_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_report_card_ref_database_id` FOREIGN KEY (`database_id`) REFERENCES `metabase_database` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_report_card_ref_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_card`
--

LOCK TABLES `report_card` WRITE;
/*!40000 ALTER TABLE `report_card` DISABLE KEYS */;
INSERT INTO `report_card` VALUES (1,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Aerodynamic Copper Knife trend','Compares the total number of orders placed for this product this month with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",39,{\"base-type\":\"type/Integer\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}]],\"source-table\":5,\"filter\":[\"and\",[\"between\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],\"2021-01-01\",\"2024-01-23\"],[\"=\",[\"field\",62,{\"base-type\":\"type/BigInteger\",\"source-field\":40}],165]]}}','{\"column_settings\":null}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Quantity\",\"semantic_type\":\"type/Quantity\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":7,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":3.25,\"q3\":6.0,\"max\":74.0,\"sd\":22.086949389477336,\"avg\":11.5}}}}]',NULL,'oShRjudlgUvJRezvGTQTD','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(2,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Orders with People',NULL,'table','{\"database\":1,\"type\":\"query\",\"query\":{\"expressions\":{\"Age\":[\"datetime-diff\",[\"field\",49,{\"base-type\":\"type/Date\",\"join-alias\":\"People - User\"}],[\"now\"],\"year\"]},\"joins\":[{\"alias\":\"People - User\",\"strategy\":\"left-join\",\"condition\":[\"=\",[\"field\",43,{\"base-type\":\"type/Integer\"}],[\"field\",46,{\"base-type\":\"type/BigInteger\",\"join-alias\":\"People - User\"}]],\"source-table\":3}],\"source-table\":5}}','{\"table.column_widths\":[null,null,null,null,null,null,null,null,null,164],\"graph.show_values\":true,\"table.cell_column\":\"SUBTOTAL\",\"graph.series_order_dimension\":null,\"graph.metrics\":[],\"graph.series_order\":null,\"table.pivot_column\":\"Age\",\"graph.dimensions\":[\"Age\"],\"stackable.stack_type\":\"stacked\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"This is a unique ID for the product. It is also called the “Invoice number” or “Confirmation number” in customer facing emails and screens.\",\"semantic_type\":\"type/PK\",\"coercion_strategy\":null,\"name\":\"ID\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",37,null],\"effective_type\":\"type/BigInteger\",\"id\":37,\"visibility_type\":\"normal\",\"display_name\":\"ID\",\"fingerprint\":null,\"base_type\":\"type/BigInteger\"},{\"description\":\"The id of the user who made this order. Note that in some cases where an order was created on behalf of a customer who phoned the order in, this might be the employee who handled the request.\",\"semantic_type\":\"type/FK\",\"coercion_strategy\":null,\"name\":\"USER_ID\",\"settings\":null,\"fk_target_field_id\":46,\"field_ref\":[\"field\",43,null],\"effective_type\":\"type/Integer\",\"id\":43,\"visibility_type\":\"normal\",\"display_name\":\"User ID\",\"fingerprint\":{\"global\":{\"distinct-count\":929,\"nil%\":0}},\"base_type\":\"type/Integer\"},{\"description\":\"The product ID. This is an internal identifier for the product, NOT the SKU.\",\"semantic_type\":\"type/FK\",\"coercion_strategy\":null,\"name\":\"PRODUCT_ID\",\"settings\":null,\"fk_target_field_id\":62,\"field_ref\":[\"field\",40,null],\"effective_type\":\"type/Integer\",\"id\":40,\"visibility_type\":\"normal\",\"display_name\":\"Product ID\",\"fingerprint\":{\"global\":{\"distinct-count\":200,\"nil%\":0}},\"base_type\":\"type/Integer\"},{\"description\":\"The raw, pre-tax cost of the order. Note that this might be different in the future from the product price due to promotions, credits, etc.\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"SUBTOTAL\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",44,null],\"effective_type\":\"type/Float\",\"id\":44,\"visibility_type\":\"normal\",\"display_name\":\"Subtotal\",\"fingerprint\":{\"global\":{\"distinct-count\":340,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":15.691943673970439,\"q1\":49.74894519060184,\"q3\":105.42965746993103,\"max\":148.22900526552291,\"sd\":32.53705013056317,\"avg\":77.01295465356547}}},\"base_type\":\"type/Float\"},{\"description\":\"This is the amount of local and federal taxes that are collected on the purchase. Note that other governmental fees on some products are not included here, but instead are accounted for in the subtotal.\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"TAX\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",38,null],\"effective_type\":\"type/Float\",\"id\":38,\"visibility_type\":\"normal\",\"display_name\":\"Tax\",\"fingerprint\":{\"global\":{\"distinct-count\":797,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":0,\"q1\":2.273340386603857,\"q3\":5.337275338216307,\"max\":11.12,\"sd\":2.3206651358900316,\"avg\":3.8722100000000004}}},\"base_type\":\"type/Float\"},{\"description\":\"The total billed amount.\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"TOTAL\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",42,null],\"effective_type\":\"type/Float\",\"id\":42,\"visibility_type\":\"normal\",\"display_name\":\"Total\",\"fingerprint\":{\"global\":{\"distinct-count\":4426,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":8.93914247937167,\"q1\":51.34535490743823,\"q3\":110.29428389265787,\"max\":159.34900526552292,\"sd\":34.26469575709948,\"avg\":80.35871658771228}}},\"base_type\":\"type/Float\"},{\"description\":\"Discount amount.\",\"semantic_type\":\"type/Discount\",\"coercion_strategy\":null,\"name\":\"DISCOUNT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",36,null],\"effective_type\":\"type/Float\",\"id\":36,\"visibility_type\":\"normal\",\"display_name\":\"Discount\",\"fingerprint\":{\"global\":{\"distinct-count\":701,\"nil%\":0.898},\"type\":{\"type/Number\":{\"min\":0.17088996672584322,\"q1\":2.9786226681458743,\"q3\":7.338187788658235,\"max\":61.69684269960571,\"sd\":3.053663125001991,\"avg\":5.161255547580326}}},\"base_type\":\"type/Float\"},{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"default\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"temporal-unit\":\"default\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"description\":\"Number of products bought.\",\"semantic_type\":\"type/Quantity\",\"coercion_strategy\":null,\"name\":\"QUANTITY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",39,null],\"effective_type\":\"type/Integer\",\"id\":39,\"visibility_type\":\"normal\",\"display_name\":\"Quantity\",\"fingerprint\":{\"global\":{\"distinct-count\":62,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":0,\"q1\":1.755882607764982,\"q3\":4.882654507928044,\"max\":100,\"sd\":4.214258386403798,\"avg\":3.7015}}},\"base_type\":\"type/Integer\"},{\"display_name\":\"Age\",\"field_ref\":[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"Age\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":42,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":24,\"q1\":33.36752836803635,\"q3\":55.20362176071121,\"max\":65,\"sd\":12.063315373018085,\"avg\":44.572}}},\"semantic_type\":null}]',1,'hjNoawcRfsDrC32g7LSOE','[]','[]',_binary '',NULL,'model',NULL,NULL,'2024-06-19 14:13:29.000000',0),(3,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Revenue per age group','Shows the revenue distributed by age group','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",\"TOTAL\",{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10}}]],\"source-table\":\"card__2\"}}','{\"column_settings\":null,\"graph.dimensions\":[\"Age\"],\"graph.metrics\":[\"sum\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"stackable.stack_type\":\"stacked\",\"table.cell_column\":\"SUBTOTAL\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"field_ref\":[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10,\"min-value\":20.0,\"max-value\":65.0,\"bin-width\":5.0}}],\"base_type\":\"type/BigInteger\",\"name\":\"Age\",\"effective_type\":\"type/BigInteger\",\"display_name\":\"Age\",\"fingerprint\":{\"global\":{\"distinct-count\":42,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":24,\"q1\":33.36752836803635,\"q3\":55.20362176071121,\"max\":65,\"sd\":12.063315373018085,\"avg\":44.572}}},\"binning_info\":{\"num_bins\":10,\"min_value\":20.0,\"max_value\":65.0,\"bin_width\":5.0,\"binning_strategy\":\"num-bins\"},\"source\":\"breakout\"},{\"base_type\":\"type/Float\",\"name\":\"sum\",\"display_name\":\"Sum of Total\",\"source\":\"aggregation\",\"field_ref\":[\"aggregation\",0],\"aggregation_index\":0}]',NULL,'rqxxsDv8zhSBXgJmVjyWa','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(4,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Buyers by age group','Shows a distribution of our customers in age groups','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10}}]],\"source-table\":\"card__26\"}}','{\"graph.dimensions\":[\"Age\"],\"series_settings\":{\"count\":{\"color\":\"#A989C5\"}},\"graph.series_order_dimension\":null,\"graph.series_order\":null,\"graph.metrics\":[\"count\"],\"graph.y_axis.title_text\":\"Buyers\"}',13371338,1,3,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"Age\",\"field_ref\":[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10,\"min-value\":20,\"max-value\":65,\"bin-width\":5}}],\"name\":\"Age\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"fingerprint\":{\"global\":{\"distinct-count\":42,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":24,\"q1\":33.340572873934306,\"q3\":55.17166516756599,\"max\":65,\"sd\":12.263883782175668,\"avg\":44.434}}},\"semantic_type\":null},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":9,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":61,\"q1\":270,\"q3\":304,\"max\":334,\"sd\":99.91663191547909,\"avg\":250}}}}]',NULL,'qj0jT7SXwEUezz1wSjtaZ','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(5,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Heavy-Duty Silk Chair trend','Compares the total number of orders placed for this product this month with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",39,{\"base-type\":\"type/Integer\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}]],\"source-table\":5,\"filter\":[\"and\",[\"between\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],\"2021-01-01\",\"2024-01-23\"],[\"=\",[\"field\",62,{\"base-type\":\"type/BigInteger\",\"source-field\":40}],86]]}}','{\"column_settings\":null}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Quantity\",\"semantic_type\":\"type/Quantity\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":7,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1.0,\"q1\":2.5,\"q3\":9.414213562373096,\"max\":10.0,\"sd\":3.693623849670827,\"avg\":5.75}}}}]',NULL,'nhFZBIIZA_KnK6RuLp36z','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(6,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Total orders by category','Breaks down the overall performance of each of the product categories','pie','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]],\"source-table\":5}}','{\"column_settings\":null,\"pie.colors\":{\"Doohickey\":\"#7172AD\",\"Gadget\":\"#A989C5\",\"Gizmo\":\"#C7EAEA\",\"Widget\":\"#227FD2\"}}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":58,\"visibility_type\":\"normal\",\"display_name\":\"Product → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":3976.0,\"q1\":4380.0,\"q3\":5000.0,\"max\":5061.0,\"sd\":489.3103990992493,\"avg\":4690.0}}}}]',NULL,'1aVGgD6-onGIPUeWCLiMA','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(7,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Value of orders over time (before taxes)',NULL,'bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",44,{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-24,\"month\"]}}','{\"column_settings\":null,\"graph.dimensions\":[\"CREATED_AT\",\"CATEGORY\"],\"graph.metrics\":[\"sum\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"stackable.stack_type\":\"stacked\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":58,\"visibility_type\":\"normal\",\"display_name\":\"Product → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Sum of Subtotal\",\"semantic_type\":null,\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":96,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":194.15721878715678,\"q1\":1682.037094502916,\"q3\":5250.149916853326,\"max\":10113.40941589646,\"sd\":2757.8851826916916,\"avg\":3956.9519658839577}}}}]',NULL,'f9RqS8HspKvcsGEH24_Af','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(8,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Enormous Wool Car trend','Compares the total number of orders placed for this product this month with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",39,{\"base-type\":\"type/Integer\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}]],\"source-table\":5,\"filter\":[\"and\",[\"between\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],\"2021-01-01\",\"2024-01-23\"],[\"=\",[\"field\",62,{\"base-type\":\"type/BigInteger\",\"source-field\":40}],17]]}}','{\"column_settings\":null}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Quantity\",\"semantic_type\":\"type/Quantity\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":11,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":3.0,\"q1\":4.76393202250021,\"q3\":17.0,\"max\":21.0,\"sd\":6.199964551476116,\"avg\":10.142857142857142}}}}]',NULL,'BP4o72CSvPOTLe5Nk6twf','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(9,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Revenue by state',NULL,'map','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",42,{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]],\"source-table\":5}}','{\"column_settings\":null,\"map.colors\":[\"#e5e5f1\",\"#c0c0da\",\"#9b9cc3\",\"#7677ab\",\"hsl(239, 29.5%, 39.3%)\"]}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The state or province of the account’s billing address\",\"semantic_type\":\"type/State\",\"coercion_strategy\":null,\"name\":\"STATE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}],\"effective_type\":\"type/Text\",\"id\":48,\"visibility_type\":\"normal\",\"display_name\":\"User → State\",\"fingerprint\":{\"global\":{\"distinct-count\":49,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":1.0,\"average-length\":2.0}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Sum of Total\",\"semantic_type\":null,\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":48,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1358.6880585850759,\"q1\":14606.102496036605,\"q3\":45423.71594332504,\"max\":108466.5974651383,\"sd\":21267.69039176716,\"avg\":31471.285063554824}}}}]',NULL,'hBnes5i3LGSYZeoGIYwvm','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(10,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Orders by source per age group','Shows a distribution of orders broken down by source across our customers\' age groups','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10}}],[\"field\",45,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}]],\"joins\":[{\"alias\":\"People - User\",\"fields\":\"all\",\"strategy\":\"left-join\",\"condition\":[\"=\",[\"field\",\"USER_ID\",{\"base-type\":\"type/Integer\"}],[\"field\",46,{\"base-type\":\"type/BigInteger\",\"join-alias\":\"People - User\"}]],\"source-table\":3}],\"source-table\":\"card__2\"}}','{\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"SOURCE\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"graph.x_axis.axis_enabled\":true,\"graph.x_axis.labels_enabled\":true,\"graph.x_axis.scale\":\"ordinal\",\"graph.y_axis.auto_range\":true,\"stackable.stack_type\":\"stacked\",\"table.cell_column\":\"SUBTOTAL\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"field_ref\":[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10,\"min-value\":20.0,\"max-value\":65.0,\"bin-width\":5.0}}],\"base_type\":\"type/BigInteger\",\"name\":\"Age\",\"effective_type\":\"type/BigInteger\",\"display_name\":\"Age\",\"fingerprint\":{\"global\":{\"distinct-count\":42,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":24,\"q1\":33.36752836803635,\"q3\":55.20362176071121,\"max\":65,\"sd\":12.063315373018085,\"avg\":44.572}}},\"binning_info\":{\"num_bins\":10,\"min_value\":20.0,\"max_value\":65.0,\"bin_width\":5.0,\"binning_strategy\":\"num-bins\"},\"source\":\"breakout\"},{\"description\":\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\",\"semantic_type\":\"type/Source\",\"table_id\":3,\"coercion_strategy\":null,\"name\":\"SOURCE\",\"settings\":null,\"source\":\"breakout\",\"fk_target_field_id\":null,\"field_ref\":[\"field\",45,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}],\"effective_type\":\"type/Text\",\"nfc_path\":null,\"parent_id\":null,\"id\":45,\"position\":8,\"visibility_type\":\"normal\",\"display_name\":\"People - User → Source\",\"fingerprint\":{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.4084}}},\"base_type\":\"type/Text\",\"source_alias\":\"People - User\"},{\"base_type\":\"type/Integer\",\"name\":\"count\",\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"source\":\"aggregation\",\"field_ref\":[\"aggregation\",0],\"aggregation_index\":0}]',NULL,'t1rQijQdCIZoQI6bhwBEG','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(11,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Product category orders per age group','Shows a distribution of orders broken down by product categories across our customers\' age groups','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10}}],[\"field\",58,{\"base-type\":\"type/Text\",\"join-alias\":\"Products\"}]],\"joins\":[{\"alias\":\"Products\",\"fields\":\"all\",\"strategy\":\"left-join\",\"condition\":[\"=\",[\"field\",\"PRODUCT_ID\",{\"base-type\":\"type/Integer\"}],[\"field\",62,{\"base-type\":\"type/BigInteger\",\"join-alias\":\"Products\"}]],\"source-table\":8}],\"source-table\":\"card__2\"}}','{\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"graph.x_axis.axis_enabled\":true,\"graph.x_axis.labels_enabled\":true,\"graph.x_axis.scale\":\"ordinal\",\"graph.y_axis.auto_range\":true,\"stackable.stack_type\":\"stacked\",\"table.cell_column\":\"SUBTOTAL\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"field_ref\":[\"field\",\"Age\",{\"base-type\":\"type/BigInteger\",\"binning\":{\"strategy\":\"num-bins\",\"num-bins\":10,\"min-value\":20.0,\"max-value\":65.0,\"bin-width\":5.0}}],\"base_type\":\"type/BigInteger\",\"name\":\"Age\",\"effective_type\":\"type/BigInteger\",\"display_name\":\"Age\",\"fingerprint\":{\"global\":{\"distinct-count\":42,\"nil%\":0},\"type\":{\"type/Number\":{\"min\":24,\"q1\":33.36752836803635,\"q3\":55.20362176071121,\"max\":65,\"sd\":12.063315373018085,\"avg\":44.572}}},\"binning_info\":{\"num_bins\":10,\"min_value\":20.0,\"max_value\":65.0,\"bin_width\":5.0,\"binning_strategy\":\"num-bins\"},\"source\":\"breakout\"},{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"table_id\":8,\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"source\":\"breakout\",\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"join-alias\":\"Products\"}],\"effective_type\":\"type/Text\",\"nfc_path\":null,\"parent_id\":null,\"id\":58,\"position\":3,\"visibility_type\":\"normal\",\"display_name\":\"Products → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\",\"source_alias\":\"Products\"},{\"base_type\":\"type/Integer\",\"name\":\"count\",\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"source\":\"aggregation\",\"field_ref\":[\"aggregation\",0],\"aggregation_index\":0}]',NULL,'avC199ZiYvp1aIWdejfFf','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(12,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Revenue and orders over time','Matches the cumulative revenue month over month with the number of orders placed each month','combo','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",42,{\"base-type\":\"type/Float\"}]],[\"sum\",[\"field\",39,{\"base-type\":\"type/Integer\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-24,\"month\"]}}','{\"column_settings\":null,\"graph.dimensions\":[\"CREATED_AT\"],\"graph.metrics\":[\"sum\",\"sum_2\"],\"graph.show_trendline\":false,\"graph.x_axis.title_text\":\"Orders date\",\"graph.y_axis.title_text\":\"Revenue\",\"series_settings\":{\"sum\":{\"display\":\"line\",\"line.interpolate\":\"linear\",\"line.marker_enabled\":false,\"show_series_values\":true,\"title\":\"Revenue\"},\"sum_2\":{\"color\":\"#51528D\",\"title\":\"Number of orders\"}}}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Total\",\"semantic_type\":null,\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":24,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":1265.7162964063327,\"q1\":7814.799491244121,\"q3\":21566.481581896165,\"max\":38569.69761756364,\"sd\":11384.837065416124,\"avg\":16481.762292966578}}}},{\"display_name\":\"Sum of Quantity\",\"semantic_type\":\"type/Quantity\",\"settings\":null,\"field_ref\":[\"aggregation\",1],\"name\":\"sum_2\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":24,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":75.0,\"q1\":369.0,\"q3\":1286.0,\"max\":2260.0,\"sd\":630.7594628699596,\"avg\":877.25}}}}]',NULL,'evd6f3MoDUtTNsoXHwu0T','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(13,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Revenue goal for this quarter','Compares the current total in revenue with the set goal for the quarter','progress','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"cum-sum\",[\"field\",42,{\"base-type\":\"type/Float\"}]]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],\"current\",\"quarter\"]}}','{\"column_settings\":null,\"progress.goal\":120000}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"Cumulative sum of Total\",\"semantic_type\":null,\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":123889.60365320997,\"q1\":123889.60365320997,\"q3\":123889.60365320997,\"max\":123889.60365320997,\"sd\":null,\"avg\":123889.60365320997}}}}]',NULL,'Bkb4GEr5dH2_LbDOKhObR','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(14,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Numbers of orders by category per quarter','Compares the orders of each category quarter over quarter','line','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-24,\"month\"]}}','{\"graph.dimensions\":[\"CREATED_AT\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"table.pivot_column\":\"CATEGORY\",\"table.cell_column\":\"count\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":58,\"visibility_type\":\"normal\",\"display_name\":\"Product → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\"},{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"quarter\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":34,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":13.0,\"q1\":81.0,\"q3\":259.5,\"max\":338.0,\"sd\":102.85448188797824,\"avg\":169.38888888888889}}}}]',NULL,'NdqehUq98ebQ4H_-1d9v3','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(15,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Revenue per quarter','Compares the total revenue this quarter with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",42,{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-2,\"quarter\"]}}','{\"column_settings\":null}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"quarter\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Total\",\"semantic_type\":null,\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":67863.39650548704,\"q1\":67863.39650548704,\"q3\":111121.25780141751,\"max\":111121.25780141751,\"sd\":30587.92706197953,\"avg\":89492.32715345226}}}}]',NULL,'d3KPtMfbe0IIK0MDrHTNn','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(16,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Orders according to sources per quarter','Orders placed per quarter broken down by source and formatted to highlight best and worst quarters','pivot','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",44,{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"field\",45,{\"base-type\":\"type/Text\",\"source-field\":43}],[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-24,\"month\"]}}','{\"graph.dimensions\":[\"CREATED_AT\",\"SOURCE\"],\"graph.series_labels\":[null],\"pivot_table.column_split\":{\"columns\":[[\"field\",45,{\"base-type\":\"type/Text\",\"source-field\":43}]],\"rows\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}]],\"values\":[[\"aggregation\",0]]},\"pivot_table.column_widths\":{\"leftHeaderWidths\":[141],\"totalLeftHeaderWidths\":141,\"valueHeaderWidths\":{}},\"stackable.stack_type\":\"stacked\",\"table.column_formatting\":[{\"color\":\"#A7D07C\",\"columns\":[\"sum\"],\"highlight_row\":false,\"operator\":\">\",\"type\":\"single\",\"value\":20000}],\"graph.metrics\":[\"sum\"]}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"pivot-grouping\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"expression\",\"pivot-grouping\"],\"effective_type\":\"type/Text\",\"id\":45,\"visibility_type\":\"normal\",\"display_name\":\"pivot-grouping\",\"fingerprint\":{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":3.0,\"q1\":3.0,\"q3\":3.0,\"max\":3.0,\"sd\":null,\"avg\":3.0}}},\"base_type\":\"type/Integer\"},{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"sum\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"aggregation\",0],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Sum of Subtotal\",\"fingerprint\":{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":379867.38872485986,\"q1\":379867.38872485986,\"q3\":379867.38872485986,\"max\":379867.38872485986,\"sd\":null,\"avg\":379867.38872485986}}},\"base_type\":\"type/Float\"}]',NULL,'-mfPjg0QOoIKbqJS0SYne','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(17,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Product category orders per individual age','Shows a distribution of orders broken down by product category across our customers\' individual age values','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"expression\",\"Age\",{\"base-type\":\"type/Integer\"}],[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]],\"expressions\":{\"Age\":[\"datetime-diff\",[\"field\",49,{\"base-type\":\"type/Date\",\"join-alias\":\"People - User\"}],[\"now\"],\"year\"]},\"joins\":[{\"alias\":\"People - User\",\"strategy\":\"left-join\",\"condition\":[\"=\",[\"field\",43,{\"base-type\":\"type/Integer\"}],[\"field\",46,{\"base-type\":\"type/BigInteger\",\"join-alias\":\"People - User\"}]],\"source-table\":3}],\"source-table\":5}}','{\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"stackable.stack_type\":\"stacked\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"Age\",\"field_ref\":[\"expression\",\"Age\"],\"name\":\"Age\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":24.0,\"q1\":34.25,\"q3\":55.75,\"max\":66.0,\"sd\":12.445906346880554,\"avg\":45.0}}}},{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":58,\"visibility_type\":\"normal\",\"display_name\":\"Product → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":84,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":11.0,\"q1\":95.5,\"q3\":124.48331477354789,\"max\":204.0,\"sd\":28.015985634286857,\"avg\":109.06976744186046}}}}]',NULL,'P-shWkp5lozD2nuo5xusW','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(18,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Discount given per quarter','Compares the total discount given this quarter with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",36,{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-2,\"quarter\"]}}','{\"column_settings\":null}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"quarter\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Discount\",\"semantic_type\":\"type/Discount\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":738.5575011690233,\"q1\":738.5575011690233,\"q3\":795.9833992557524,\"max\":795.9833992557524,\"sd\":40.606241952853686,\"avg\":767.2704502123879}}}}]',NULL,'wd1PEi_Z217Gr-ceeZSNj','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(19,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Customer satisfaction per category','Shows the distribution of the product categories along the scale of customer ratings','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",61,{\"base-type\":\"type/Float\",\"source-field\":40}],[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]],\"order-by\":[[\"desc\",[\"field\",61,{\"base-type\":\"type/Float\",\"source-field\":40}]]],\"source-table\":5,\"filter\":[\"!=\",[\"field\",65,{\"base-type\":\"type/Text\",\"source-field\":40}],\"Incredible Aluminum Knife\"]}}','{\"column_settings\":null,\"graph.dimensions\":[\"RATING\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.x_axis.title_text\":\"Products\",\"graph.y_axis.auto_range\":true,\"graph.y_axis.title_text\":\"total orders\",\"series_settings\":{\"count\":{\"color\":\"#999AC4\"}},\"stackable.stack_type\":\"stacked\",\"table.pivot\":false}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The average rating users have given the product. This ranges from 1 - 5\",\"semantic_type\":\"type/Score\",\"coercion_strategy\":null,\"name\":\"RATING\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",61,{\"base-type\":\"type/Float\",\"source-field\":40}],\"effective_type\":\"type/Float\",\"id\":61,\"visibility_type\":\"normal\",\"display_name\":\"Product → Rating\",\"fingerprint\":{\"global\":{\"distinct-count\":23,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":3.5120465053408525,\"q3\":4.216124969497314,\"max\":5.0,\"sd\":1.3605488657451452,\"avg\":3.4715}}},\"base_type\":\"type/Float\"},{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":58,\"visibility_type\":\"normal\",\"display_name\":\"Product → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":57,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":70.0,\"q1\":105.0,\"q3\":370.0,\"max\":1093.0,\"sd\":229.88812521865958,\"avg\":281.6060606060606}}}}]',NULL,'cO53DQ6k0DueW5Aglwp7Y','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(20,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Number of orders per month','Compares the total number of orders placed this month with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",39,{\"base-type\":\"type/Integer\"}]]],\"breakout\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}]],\"source-table\":5,\"filter\":[\"time-interval\",[\"field\",41,{\"base-type\":\"type/DateTime\"}],-2,\"month\"]}}','{\"column_settings\":null}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date and time an order was submitted.\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":41,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":10001,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-30T18:56:13.352Z\",\"latest\":\"2026-04-19T14:07:15.657Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Sum of Quantity\",\"semantic_type\":\"type/Quantity\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":487.0,\"q1\":487.0,\"q3\":1330.0,\"max\":1330.0,\"sd\":596.0910165402596,\"avg\":908.5}}}}]',NULL,'OouzOUPGIjf6zXJsSDe0f','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(21,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Orders by source per individual age','Shows a distribution of orders broken down by source across our customers\' individual age values','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"expression\",\"Age\",{\"base-type\":\"type/Integer\"}],[\"field\",45,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}]],\"expressions\":{\"Age\":[\"datetime-diff\",[\"field\",49,{\"base-type\":\"type/Date\",\"join-alias\":\"People - User\"}],[\"now\"],\"year\"]},\"joins\":[{\"alias\":\"People - User\",\"strategy\":\"left-join\",\"condition\":[\"=\",[\"field\",43,{\"base-type\":\"type/Integer\"}],[\"field\",46,{\"base-type\":\"type/BigInteger\",\"join-alias\":\"People - User\"}]],\"source-table\":3}],\"source-table\":5}}','{\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"SOURCE\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"stackable.stack_type\":\"stacked\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"Age\",\"field_ref\":[\"expression\",\"Age\"],\"name\":\"Age\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":24.0,\"q1\":34.15,\"q3\":55.45,\"max\":66.0,\"sd\":12.328008896346248,\"avg\":44.80281690140845}}}},{\"description\":\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\",\"semantic_type\":\"type/Source\",\"coercion_strategy\":null,\"name\":\"SOURCE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",45,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}],\"effective_type\":\"type/Text\",\"id\":45,\"visibility_type\":\"normal\",\"display_name\":\"People - User → Source\",\"fingerprint\":{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.4084}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":111,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":14.0,\"q1\":61.30452018978108,\"q3\":110.7900825561565,\"max\":214.0,\"sd\":36.95993697001328,\"avg\":88.07511737089202}}}}]',NULL,'DDT6zuq6O7bsnw1UEWtQQ','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(22,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Average product rating overall','Indicates the average customer review of our products','gauge','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"avg\",[\"field\",61,{\"base-type\":\"type/Float\"}]]],\"source-table\":8}}','{\"column_settings\":null,\"gauge.segments\":[{\"color\":\"#EF8C8C\",\"label\":\"awful\",\"max\":1,\"min\":0},{\"color\":\"#F2A86F\",\"label\":\"bad\",\"max\":2,\"min\":1},{\"color\":\"#F9D45C\",\"label\":\"alright\",\"max\":3,\"min\":2},{\"color\":\"#A7D07C\",\"label\":\"good\",\"max\":4,\"min\":3},{\"color\":\"#689636\",\"label\":\"great\",\"max\":5,\"min\":4}],\"table.cell_column\":\"avg\"}',13371338,1,8,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"Average of Rating\",\"semantic_type\":\"type/Score\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"avg\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":3.4715,\"q1\":3.4715,\"q3\":3.4715,\"max\":3.4715,\"sd\":null,\"avg\":3.4715}}}}]',NULL,'-BcEE22ptXyDOgUNRqyct','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(23,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Best selling products','An ordered list of our most successful products','row','{\"database\":1,\"type\":\"query\",\"query\":{\"filter\":[\">\",[\"field\",\"count\",{\"base-type\":\"type/Integer\"}],108],\"source-query\":{\"aggregation\":[[\"count\"]],\"breakout\":[[\"field\",65,{\"base-type\":\"type/Text\",\"source-field\":40}],[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]],\"order-by\":[[\"desc\",[\"aggregation\",0]]],\"source-table\":5,\"filter\":[\"!=\",[\"field\",65,{\"base-type\":\"type/Text\",\"source-field\":40}],\"Incredible Aluminum Knife\"]}}}','{\"column_settings\":null,\"graph.dimensions\":[\"TITLE\"],\"graph.metrics\":[\"count\"],\"graph.x_axis.title_text\":\"Products\",\"graph.y_axis.title_text\":\"total orders\",\"series_settings\":{\"count\":{\"color\":\"#999AC4\"}},\"table.pivot\":false}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The name of the product as it should be displayed to customers.\",\"semantic_type\":\"type/Title\",\"coercion_strategy\":null,\"name\":\"TITLE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",65,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":65,\"visibility_type\":\"normal\",\"display_name\":\"Product → Title\",\"fingerprint\":{\"global\":{\"distinct-count\":199,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":21.495}}},\"base_type\":\"type/Text\"},{\"description\":\"The type of product, valid values include: Doohicky, Gadget, Gizmo and Widget\",\"semantic_type\":\"type/Category\",\"coercion_strategy\":null,\"name\":\"CATEGORY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}],\"effective_type\":\"type/Text\",\"id\":58,\"visibility_type\":\"normal\",\"display_name\":\"Product → Category\",\"fingerprint\":{\"global\":{\"distinct-count\":4,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":6.375}}},\"base_type\":\"type/Text\"},{\"display_name\":\"Count\",\"semantic_type\":\"type/Quantity\",\"field_ref\":[\"field\",\"count\",{\"base-type\":\"type/Integer\"}],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":8,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":109.0,\"q1\":109.36150801752578,\"q3\":117.41886116991581,\"max\":120.0,\"sd\":4.254710813035841,\"avg\":113.53846153846153}}}}]',NULL,'dsZMohGmK4P7eQRBdLFmb','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(24,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Unique customers per month','Compares the number of unique customers placing orders this month with the previous period','smartscalar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"distinct\",[\"field\",47,{\"base-type\":\"type/Text\"}]]],\"breakout\":[[\"field\",56,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}]],\"source-table\":3,\"filter\":[\"time-interval\",[\"field\",56,{\"base-type\":\"type/DateTime\"}],-2,\"month\"]}}','{\"column_settings\":null}',13371338,1,3,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"The date the user record was created. Also referred to as the user’s \\\"join date\\\"\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"month\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",56,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"month\"}],\"effective_type\":\"type/DateTime\",\"id\":56,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-19T21:35:18.752Z\",\"latest\":\"2025-04-19T14:06:27.3Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Distinct values of Name\",\"semantic_type\":\"type/Quantity\",\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"count\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"fingerprint\":{\"global\":{\"distinct-count\":2,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":70.0,\"q1\":70.0,\"q3\":76.0,\"max\":76.0,\"sd\":4.242640687119285,\"avg\":73.0}}}}]',NULL,'fPYpb3KcV2TJZLRw-L841','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(25,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','Revenue per individual age','Shows a distribution of revenue per individual age values','bar','{\"database\":1,\"type\":\"query\",\"query\":{\"aggregation\":[[\"sum\",[\"field\",42,{\"base-type\":\"type/Float\"}]]],\"breakout\":[[\"expression\",\"Age\",{\"base-type\":\"type/Integer\"}]],\"expressions\":{\"Age\":[\"datetime-diff\",[\"field\",49,{\"base-type\":\"type/Date\",\"join-alias\":\"People - User\"}],[\"now\"],\"year\"]},\"joins\":[{\"alias\":\"People - User\",\"strategy\":\"left-join\",\"condition\":[\"=\",[\"field\",43,{\"base-type\":\"type/Integer\"}],[\"field\",46,{\"base-type\":\"type/BigInteger\",\"join-alias\":\"People - User\"}]],\"source-table\":3}],\"source-table\":5}}','{\"column_settings\":null,\"graph.dimensions\":[\"Age\"],\"graph.metrics\":[\"sum\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"stackable.stack_type\":\"stacked\"}',13371338,1,5,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"Age\",\"field_ref\":[\"expression\",\"Age\"],\"name\":\"Age\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":24.0,\"q1\":34.25,\"q3\":55.75,\"max\":66.0,\"sd\":12.556538801224908,\"avg\":45.0}}}},{\"display_name\":\"Sum of Total\",\"semantic_type\":null,\"settings\":null,\"field_ref\":[\"aggregation\",0],\"name\":\"sum\",\"base_type\":\"type/Float\",\"effective_type\":\"type/Float\",\"fingerprint\":{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":4158.786206744129,\"q1\":31397.769615345165,\"q3\":38764.15212640109,\"max\":58676.42899556268,\"sd\":8106.619825736762,\"avg\":35130.73681513096}}}}]',NULL,'KMq74J_Gh78vIimczx0LH','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(26,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','People with age',NULL,'table','{\"database\":1,\"type\":\"query\",\"query\":{\"source-table\":3,\"expressions\":{\"Age\":[\"datetime-diff\",[\"field\",49,{\"base-type\":\"type/Date\"}],[\"now\"],\"year\"]}}}','{\"graph.dimensions\":[\"age\"],\"graph.metrics\":[\"count\"],\"table.pivot_column\":\"SOURCE\",\"table.cell_column\":\"LONGITUDE\"}',13371338,1,3,'query',_binary '\0',1,NULL,NULL,_binary '\0',NULL,NULL,'[{\"description\":\"A unique identifier given to each user.\",\"semantic_type\":\"type/PK\",\"coercion_strategy\":null,\"name\":\"ID\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",46,null],\"effective_type\":\"type/BigInteger\",\"id\":46,\"visibility_type\":\"normal\",\"display_name\":\"ID\",\"fingerprint\":null,\"base_type\":\"type/BigInteger\"},{\"description\":\"The street address of the account’s billing address\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"ADDRESS\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",52,null],\"effective_type\":\"type/Text\",\"id\":52,\"visibility_type\":\"normal\",\"display_name\":\"Address\",\"fingerprint\":{\"global\":{\"distinct-count\":2490,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":20.85}}},\"base_type\":\"type/Text\"},{\"description\":\"The contact email for the account.\",\"semantic_type\":\"type/Email\",\"coercion_strategy\":null,\"name\":\"EMAIL\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",51,null],\"effective_type\":\"type/Text\",\"id\":51,\"visibility_type\":\"normal\",\"display_name\":\"Email\",\"fingerprint\":{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":1.0,\"percent-state\":0.0,\"average-length\":24.1824}}},\"base_type\":\"type/Text\"},{\"description\":\"This is the salted password of the user. It should not be visible\",\"semantic_type\":null,\"coercion_strategy\":null,\"name\":\"PASSWORD\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",53,null],\"effective_type\":\"type/Text\",\"id\":53,\"visibility_type\":\"normal\",\"display_name\":\"Password\",\"fingerprint\":{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":36.0}}},\"base_type\":\"type/Text\"},{\"description\":\"The name of the user who owns an account\",\"semantic_type\":\"type/Name\",\"coercion_strategy\":null,\"name\":\"NAME\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",47,null],\"effective_type\":\"type/Text\",\"id\":47,\"visibility_type\":\"normal\",\"display_name\":\"Name\",\"fingerprint\":{\"global\":{\"distinct-count\":2499,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":13.532}}},\"base_type\":\"type/Text\"},{\"description\":\"The city of the account’s billing address\",\"semantic_type\":\"type/City\",\"coercion_strategy\":null,\"name\":\"CITY\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",55,null],\"effective_type\":\"type/Text\",\"id\":55,\"visibility_type\":\"normal\",\"display_name\":\"City\",\"fingerprint\":{\"global\":{\"distinct-count\":1966,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.002,\"average-length\":8.284}}},\"base_type\":\"type/Text\"},{\"description\":\"This is the longitude of the user on sign-up. It might be updated in the future to the last seen location.\",\"semantic_type\":\"type/Longitude\",\"coercion_strategy\":null,\"name\":\"LONGITUDE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",50,null],\"effective_type\":\"type/Float\",\"id\":50,\"visibility_type\":\"normal\",\"display_name\":\"Longitude\",\"fingerprint\":{\"global\":{\"distinct-count\":2491,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-166.5425726,\"q1\":-101.58350792373135,\"q3\":-84.65289348288829,\"max\":-67.96735199999999,\"sd\":15.399698968175663,\"avg\":-95.18741780363999}}},\"base_type\":\"type/Float\"},{\"description\":\"The state or province of the account’s billing address\",\"semantic_type\":\"type/State\",\"coercion_strategy\":null,\"name\":\"STATE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",48,null],\"effective_type\":\"type/Text\",\"id\":48,\"visibility_type\":\"normal\",\"display_name\":\"State\",\"fingerprint\":{\"global\":{\"distinct-count\":49,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":1.0,\"average-length\":2.0}}},\"base_type\":\"type/Text\"},{\"description\":\"The channel through which we acquired this user. Valid values include: Affiliate, Facebook, Google, Organic and Twitter\",\"semantic_type\":\"type/Source\",\"coercion_strategy\":null,\"name\":\"SOURCE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",45,null],\"effective_type\":\"type/Text\",\"id\":45,\"visibility_type\":\"normal\",\"display_name\":\"Source\",\"fingerprint\":{\"global\":{\"distinct-count\":5,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":7.4084}}},\"base_type\":\"type/Text\"},{\"description\":\"The date of birth of the user\",\"semantic_type\":null,\"coercion_strategy\":null,\"unit\":\"default\",\"name\":\"BIRTH_DATE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",49,{\"temporal-unit\":\"default\"}],\"effective_type\":\"type/Date\",\"id\":49,\"visibility_type\":\"normal\",\"display_name\":\"Birth Date\",\"fingerprint\":{\"global\":{\"distinct-count\":2308,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"1958-04-26\",\"latest\":\"2000-04-03\"}}},\"base_type\":\"type/Date\"},{\"description\":\"The postal code of the account’s billing address\",\"semantic_type\":\"type/ZipCode\",\"coercion_strategy\":null,\"name\":\"ZIP\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",54,null],\"effective_type\":\"type/Text\",\"id\":54,\"visibility_type\":\"normal\",\"display_name\":\"Zip\",\"fingerprint\":{\"global\":{\"distinct-count\":2234,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.0}}},\"base_type\":\"type/Text\"},{\"description\":\"This is the latitude of the user on sign-up. It might be updated in the future to the last seen location.\",\"semantic_type\":\"type/Latitude\",\"coercion_strategy\":null,\"name\":\"LATITUDE\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",57,null],\"effective_type\":\"type/Float\",\"id\":57,\"visibility_type\":\"normal\",\"display_name\":\"Latitude\",\"fingerprint\":{\"global\":{\"distinct-count\":2491,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":25.775827,\"q1\":35.302705923023126,\"q3\":43.773802584662,\"max\":70.6355001,\"sd\":6.390832341883712,\"avg\":39.87934670484002}}},\"base_type\":\"type/Float\"},{\"description\":\"The date the user record was created. Also referred to as the user’s \\\"join date\\\"\",\"semantic_type\":\"type/CreationTimestamp\",\"coercion_strategy\":null,\"unit\":\"default\",\"name\":\"CREATED_AT\",\"settings\":null,\"fk_target_field_id\":null,\"field_ref\":[\"field\",56,{\"temporal-unit\":\"default\"}],\"effective_type\":\"type/DateTime\",\"id\":56,\"visibility_type\":\"normal\",\"display_name\":\"Created At\",\"fingerprint\":{\"global\":{\"distinct-count\":2500,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2022-04-19T21:35:18.752Z\",\"latest\":\"2025-04-19T14:06:27.3Z\"}}},\"base_type\":\"type/DateTime\"},{\"display_name\":\"Age\",\"field_ref\":[\"expression\",\"Age\"],\"name\":\"Age\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":42,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":24.0,\"q1\":33.340572873934306,\"q3\":55.17166516756599,\"max\":65.0,\"sd\":12.263883782175668,\"avg\":44.434}}}}]',NULL,'lY4hbjNofxepxQGRhJa0s','[]','[]',_binary '',NULL,'question',NULL,NULL,'2024-06-19 14:13:29.000000',0),(27,'2024-06-19 14:20:52.255156','2024-07-21 14:32:01.023565','当日流水',NULL,'scalar','{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\"}}','{\"column_settings\":{\"[\\\"name\\\",\\\"flow/100\\\"]\":{\"number_separators\":\".\"}}}',13371339,2,NULL,'native',_binary '\0',3,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"flow/100\",\"field_ref\":[\"field\",\"flow/100\",{\"base-type\":\"type/Decimal\"}],\"name\":\"flow/100\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":1,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":67421.62,\"q1\":67421.62,\"q3\":67421.62,\"max\":67421.62,\"sd\":null,\"avg\":67421.62}}}}]',NULL,'YaPijzoih3eXfFIsGcA2d','[]','[]',_binary '','v0.50.5 (48f6978)','question',NULL,NULL,'2024-07-21 14:32:01.000000',3478),(28,'2024-06-20 01:39:41.219099','2024-06-20 01:44:06.509945','三日流水时分同比',NULL,'line','{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}}','{\"graph.show_goal\":false,\"graph.show_trendline\":false,\"graph.show_values\":true,\"graph.x_axis.labels_enabled\":false,\"graph.series_order_dimension\":null,\"graph.x_axis.axis_enabled\":\"rotate-90\",\"graph.y_axis.scale\":\"linear\",\"graph.label_value_frequency\":\"fit\",\"graph.metrics\":[\"前天\",\"昨天\",\"今天\"],\"graph.y_axis.axis_enabled\":true,\"graph.label_value_formatting\":\"auto\",\"graph.series_order\":null,\"column_settings\":{\"[\\\"name\\\",\\\"t\\\"]\":{\"time_enabled\":\"seconds\",\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}},\"graph.x_axis.scale\":\"ordinal\",\"graph.dimensions\":[\"时间\"]}',13371339,2,NULL,'native',_binary '',3,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"时间\",\"field_ref\":[\"field\",\"时间\",{\"base-type\":\"type/Time\"}],\"name\":\"时间\",\"base_type\":\"type/Time\",\"effective_type\":\"type/Time\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":288,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"00:00:00+08:00\",\"latest\":\"23:55:00+08:00\"}}}},{\"display_name\":\"前天\",\"field_ref\":[\"field\",\"前天\",{\"base-type\":\"type/Decimal\"}],\"name\":\"前天\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":286,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":19621.866686248843,\"q3\":56075.32250000001,\"max\":70776.82,\"sd\":19799.369850403622,\"avg\":37145.63506944445}}}},{\"display_name\":\"昨天\",\"field_ref\":[\"field\",\"昨天\",{\"base-type\":\"type/Decimal\"}],\"name\":\"昨天\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":287,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":15323.414082724074,\"q3\":57720.24766030573,\"max\":72219.92,\"sd\":22498.958037008044,\"avg\":35904.26038194444}}}},{\"display_name\":\"今天\",\"field_ref\":[\"field\",\"今天\",{\"base-type\":\"type/Decimal\"}],\"name\":\"今天\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":107,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":0.0,\"q3\":11087.168333333333,\"max\":17222.2,\"sd\":6081.903195444214,\"avg\":4361.703784722222}}}}]',NULL,'83H8D9yh7bM54eQ89C03w','[]','[]',_binary '','v0.50.5 (48f6978)','question',NULL,NULL,'2024-06-20 01:43:37.000000',3),(29,'2024-06-20 01:42:14.547929','2024-07-21 14:17:39.361878','三日时分同比',NULL,'line','{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}}','{\"table.cell_column\":\"前天\",\"graph.x_axis.scale\":\"ordinal\",\"graph.x_axis.axis_enabled\":\"rotate-45\",\"graph.show_values\":true,\"graph.label_value_formatting\":\"auto\",\"graph.dimensions\":[\"时间\"],\"column_settings\":{\"[\\\"name\\\",\\\"时间\\\"]\":{\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}},\"graph.metrics\":[\"前天\",\"昨天\",\"今天\"]}',13371339,2,NULL,'native',_binary '\0',3,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"时间\",\"field_ref\":[\"field\",\"时间\",{\"base-type\":\"type/Time\"}],\"name\":\"时间\",\"base_type\":\"type/Time\",\"effective_type\":\"type/Time\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":288,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"00:00:00+08:00\",\"latest\":\"23:55:00+08:00\"}}}},{\"display_name\":\"前天\",\"field_ref\":[\"field\",\"前天\",{\"base-type\":\"type/Decimal\"}],\"name\":\"前天\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":287,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":19005.652714086627,\"q3\":57011.303285992406,\"max\":78468.44,\"sd\":21191.792380225583,\"avg\":37682.823472222226}}}},{\"display_name\":\"昨天\",\"field_ref\":[\"field\",\"昨天\",{\"base-type\":\"type/Decimal\"}],\"name\":\"昨天\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":286,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":30796.26099349458,\"q3\":60843.868749999994,\"max\":92651.23,\"sd\":21022.235076799632,\"avg\":46405.132673611115}}}},{\"display_name\":\"今天\",\"field_ref\":[\"field\",\"今天\",{\"base-type\":\"type/Decimal\"}],\"name\":\"今天\",\"base_type\":\"type/Decimal\",\"effective_type\":\"type/Decimal\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":265,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":24616.602166666664,\"q3\":53635.65,\"max\":66769.84,\"sd\":19014.776382851305,\"avg\":36113.086180555554}}}}]',NULL,'yvOSMNTUeqWKfubXw6Rj9','[]','[]',_binary '','v0.50.5 (48f6978)','question',NULL,NULL,'2024-07-21 14:17:39.000000',3359),(30,'2024-06-20 01:53:03.757564','2024-07-21 14:25:59.895373','主播当日收入榜',NULL,'table','{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'主播昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\nORDER BY t1.income DESC\\n;\"}}','{\"table.pivot_column\":\"昵称\",\"table.cell_column\":\"主播mid\",\"column_settings\":{\"[\\\"name\\\",\\\"主播mid\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"主播user_id\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"主播收入(钻石)\\\"]\":{\"number_separators\":\".\"}}}',13371339,2,NULL,'native',_binary '\0',3,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"主播mid\",\"field_ref\":[\"field\",\"主播mid\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"主播mid\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":159,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":8.0,\"q1\":2283.0615818571705,\"q3\":358897.2958799994,\"max\":432959.0,\"sd\":166430.9112948822,\"avg\":196646.95597484277}}}},{\"display_name\":\"主播user_id\",\"field_ref\":[\"field\",\"主播user_id\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"主播user_id\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":159,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":105786.0,\"q1\":334618.59375,\"q3\":740924.7589930617,\"max\":993443.0,\"sd\":247714.20970334625,\"avg\":535110.5849056604}}}},{\"display_name\":\"主播昵称\",\"field_ref\":[\"field\",\"主播昵称\",{\"base-type\":\"type/Text\"}],\"name\":\"主播昵称\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":159,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.3584905660377355}}}},{\"display_name\":\"主播收入(钻石)\",\"field_ref\":[\"field\",\"主播收入(钻石)\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"主播收入(钻石)\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":136,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-594.0,\"q1\":327.38451807241404,\"q3\":3035.1927152945445,\"max\":46434.0,\"sd\":5493.2163951965595,\"avg\":2814.2327044025155}}}}]',NULL,'WkUMW3ptA5dVGIw8dZiYT','[]','[]',_binary '','v0.50.5 (48f6978)','question',NULL,NULL,'2024-07-21 14:25:59.000000',3333),(31,'2024-06-30 14:31:19.535063','2024-07-21 14:34:44.124444','每日收入明细',NULL,'table','{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT\\n\\tptime   \'时间\',\\n\\tmembership_cnt   \'会员数\',\\n\\tmembership_flow   \'会员流水\',\\n\\tzone_admission_cnt   \'空间解锁数\',\\n\\tzone_admission_flow   \'空间解锁流水\',\\n\\tzone_superfan_cnt   \'空间超粉数\',\\n\\tzone_superfan_flow   \'空间超粉流水\',\\n\\tzone_moment_cnt   \'空间动态数\',\\n\\tzone_moment_flow   \'空间动态流水\',\\n\\tother_cnt   \'其他数(微信+金币)\',\\n\\tother_flow   \'其他流水(微信+金币)\',\\n\\ttotal_flow   \'总流水\',\\n\\tstreamer_flow   \'主播分成\',\\n\\tofficial_flow   \'净收入\',\\n\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\n\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\n\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\n\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\n\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\n\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\nFROM vas_day_detail\\nORDER BY ptime DESC\\n;\"}}','{\"column_settings\":{\"[\\\"name\\\",\\\"时间\\\"]\":{\"time_style\":\"HH:mm\",\"date_style\":\"YYYY/M/D\"}},\"table.cell_column\":\"会员数\"}',13371339,2,NULL,'native',_binary '\0',3,NULL,NULL,_binary '\0',NULL,NULL,'[{\"display_name\":\"时间\",\"field_ref\":[\"field\",\"时间\",{\"base-type\":\"type/DateTimeWithLocalTZ\"}],\"name\":\"时间\",\"base_type\":\"type/DateTimeWithLocalTZ\",\"effective_type\":\"type/DateTimeWithLocalTZ\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":97,\"nil%\":0.0},\"type\":{\"type/DateTime\":{\"earliest\":\"2024-04-15T00:00:00+08:00\",\"latest\":\"2024-07-20T00:00:00+08:00\"}}}},{\"display_name\":\"会员数\",\"field_ref\":[\"field\",\"会员数\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"会员数\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":41,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":4.0,\"q1\":9.630674792015038,\"q3\":24.73861278752583,\"max\":307.0,\"sd\":46.48574403648316,\"avg\":31.948453608247423}}}},{\"display_name\":\"会员流水\",\"field_ref\":[\"field\",\"会员流水\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"会员流水\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":41,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":196.0,\"q1\":471.9030648087368,\"q3\":1212.1920265887657,\"max\":15043.0,\"sd\":2277.8014577876747,\"avg\":1565.4742268041236}}}},{\"display_name\":\"空间解锁数\",\"field_ref\":[\"field\",\"空间解锁数\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"空间解锁数\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":85,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":147.1824573491027,\"q3\":920.25,\"max\":2711.0,\"sd\":581.6555719521454,\"avg\":632.041237113402}}}},{\"display_name\":\"空间解锁流水\",\"field_ref\":[\"field\",\"空间解锁流水\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"空间解锁流水\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":88,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":11447.369302156201,\"q3\":27391.75,\"max\":52917.0,\"sd\":12412.070007874941,\"avg\":19107.20618556701}}}},{\"display_name\":\"空间超粉数\",\"field_ref\":[\"field\",\"空间超粉数\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"空间超粉数\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":22,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":1.4637216638542114,\"q3\":12.427827300200523,\"max\":23.0,\"sd\":6.286747638985413,\"avg\":7.484536082474227}}}},{\"display_name\":\"空间超粉流水\",\"field_ref\":[\"field\",\"空间超粉流水\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"空间超粉流水\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":75,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":328.1225775800322,\"q3\":7408.552803811068,\"max\":14164.0,\"sd\":4052.3775363805657,\"avg\":4336.6082474226805}}}},{\"display_name\":\"空间动态数\",\"field_ref\":[\"field\",\"空间动态数\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"空间动态数\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":81,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":85.61512473537886,\"q3\":609.0625,\"max\":1802.0,\"sd\":310.62336485192986,\"avg\":370.2886597938144}}}},{\"display_name\":\"空间动态流水\",\"field_ref\":[\"field\",\"空间动态流水\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"空间动态流水\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":84,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":6528.668500729546,\"q3\":14930.596585052412,\"max\":26617.0,\"sd\":6255.012161995398,\"avg\":10122.288659793812}}}},{\"display_name\":\"其他数(微信+金币)\",\"field_ref\":[\"field\",\"其他数(微信+金币)\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"其他数(微信+金币)\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":43,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":10.77525512860841,\"q3\":30.082207001484488,\"max\":53.0,\"sd\":12.384838932953025,\"avg\":20.38144329896907}}}},{\"display_name\":\"其他流水(微信+金币)\",\"field_ref\":[\"field\",\"其他流水(微信+金币)\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"其他流水(微信+金币)\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":92,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":0.0,\"q1\":1140.3288287465668,\"q3\":4911.839056699421,\"max\":13801.0,\"sd\":2928.3327985902006,\"avg\":3480.144329896907}}}},{\"display_name\":\"总流水\",\"field_ref\":[\"field\",\"总流水\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"总流水\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":97,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":196.0,\"q1\":26050.174634230647,\"q3\":55715.5,\"max\":93951.0,\"sd\":23580.502657927653,\"avg\":38611.721649484534}}}},{\"display_name\":\"主播分成\",\"field_ref\":[\"field\",\"主播分成\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"主播分成\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":95,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":83.0,\"q1\":17953.696118329204,\"q3\":43457.010704340755,\"max\":73851.0,\"sd\":18687.36161413027,\"avg\":29248.80412371134}}}},{\"display_name\":\"净收入\",\"field_ref\":[\"field\",\"净收入\",{\"base-type\":\"type/BigInteger\"}],\"name\":\"净收入\",\"base_type\":\"type/BigInteger\",\"effective_type\":\"type/BigInteger\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":97,\"nil%\":0.0},\"type\":{\"type/Number\":{\"min\":-241.0,\"q1\":6494.458015487596,\"q3\":12905.0,\"max\":25701.0,\"sd\":5355.700881200428,\"avg\":9362.917525773197}}}},{\"display_name\":\"利润率\",\"field_ref\":[\"field\",\"利润率\",{\"base-type\":\"type/Text\"}],\"name\":\"利润率\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":92,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.938144329896907}}}},{\"display_name\":\"会员流水占比\",\"field_ref\":[\"field\",\"会员流水占比\",{\"base-type\":\"type/Text\"}],\"name\":\"会员流水占比\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":79,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.123711340206185}}}},{\"display_name\":\"空间解锁占比\",\"field_ref\":[\"field\",\"空间解锁占比\",{\"base-type\":\"type/Text\"}],\"name\":\"空间解锁占比\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":88,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.474226804123711}}}},{\"display_name\":\"空间超粉占比\",\"field_ref\":[\"field\",\"空间超粉占比\",{\"base-type\":\"type/Text\"}],\"name\":\"空间超粉占比\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":74,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":4.701030927835052}}}},{\"display_name\":\"空间动态占比\",\"field_ref\":[\"field\",\"空间动态占比\",{\"base-type\":\"type/Text\"}],\"name\":\"空间动态占比\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":83,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.350515463917525}}}},{\"display_name\":\"其他占比\",\"field_ref\":[\"field\",\"其他占比\",{\"base-type\":\"type/Text\"}],\"name\":\"其他占比\",\"base_type\":\"type/Text\",\"effective_type\":\"type/Text\",\"semantic_type\":null,\"fingerprint\":{\"global\":{\"distinct-count\":93,\"nil%\":0.0},\"type\":{\"type/Text\":{\"percent-json\":0.0,\"percent-url\":0.0,\"percent-email\":0.0,\"percent-state\":0.0,\"average-length\":5.175257731958763}}}}]',NULL,'-O1j6tHCB5JqcjTboahf-','[]','[]',_binary '','v0.50.5 (48f6978)','question',NULL,NULL,'2024-07-21 14:34:43.000000',2262);
/*!40000 ALTER TABLE `report_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_cardfavorite`
--

DROP TABLE IF EXISTS `report_cardfavorite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_cardfavorite` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `card_id` int NOT NULL,
  `owner_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_unique_cardfavorite_card_id_owner_id` (`card_id`,`owner_id`),
  KEY `idx_cardfavorite_card_id` (`card_id`),
  KEY `idx_cardfavorite_owner_id` (`owner_id`),
  CONSTRAINT `fk_cardfavorite_ref_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_cardfavorite_ref_user_id` FOREIGN KEY (`owner_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_cardfavorite`
--

LOCK TABLES `report_cardfavorite` WRITE;
/*!40000 ALTER TABLE `report_cardfavorite` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_cardfavorite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_dashboard`
--

DROP TABLE IF EXISTS `report_dashboard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_dashboard` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `creator_id` int NOT NULL,
  `parameters` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `points_of_interest` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `caveats` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `show_in_getting_started` bit(1) NOT NULL DEFAULT b'0',
  `public_uuid` char(36) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Unique UUID used to in publically-accessible links to this Dashboard.',
  `made_public_by_id` int DEFAULT NULL COMMENT 'The ID of the User who first publically shared this Dashboard.',
  `enable_embedding` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Is this Dashboard allowed to be embedded in different websites (using a signed JWT)?',
  `embedding_params` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `archived` bit(1) NOT NULL DEFAULT b'0' COMMENT 'Is this Dashboard archived (effectively treated as deleted?)',
  `position` int DEFAULT NULL COMMENT 'The position this Dashboard should appear in the Dashboards list, lower-numbered positions appearing before higher numbered ones.',
  `collection_id` int DEFAULT NULL COMMENT 'Optional ID of Collection this Dashboard belongs to.',
  `collection_position` smallint DEFAULT NULL COMMENT 'Optional pinned position for this item in its Collection. NULL means item is not pinned.',
  `cache_ttl` int DEFAULT NULL COMMENT 'Granular cache TTL for specific dashboard.',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  `auto_apply_filters` bit(1) NOT NULL DEFAULT b'1',
  `width` varchar(16) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'fixed',
  `initially_published_at` timestamp(6) NULL DEFAULT NULL COMMENT 'The timestamp when the dashboard was first published in a static embed',
  `view_count` int NOT NULL DEFAULT '0' COMMENT 'Keeps a running count of dashboard views',
  PRIMARY KEY (`id`),
  UNIQUE KEY `public_uuid` (`public_uuid`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_dashboard_creator_id` (`creator_id`),
  KEY `idx_report_dashboard_show_in_getting_started` (`show_in_getting_started`),
  KEY `idx_dashboard_public_uuid` (`public_uuid`),
  KEY `idx_dashboard_collection_id` (`collection_id`),
  KEY `fk_dashboard_made_public_by_id` (`made_public_by_id`),
  CONSTRAINT `fk_dashboard_collection_id` FOREIGN KEY (`collection_id`) REFERENCES `collection` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_dashboard_made_public_by_id` FOREIGN KEY (`made_public_by_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dashboard_ref_user_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_dashboard`
--

LOCK TABLES `report_dashboard` WRITE;
/*!40000 ALTER TABLE `report_dashboard` DISABLE KEYS */;
INSERT INTO `report_dashboard` VALUES (1,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000','E-commerce insights','Quickly take an overview of an e-commerce reseller business and dive into separate tabs that focus on top selling products and demographic insights. Each vendor can log in as a tenant and see their own data sandboxed from all the others.',13371338,'[{\"id\":\"fc2cd1be\",\"isMultiSelect\":false,\"name\":\"Vendor\",\"sectionId\":\"string\",\"slug\":\"vendor\",\"type\":\"string/=\"},{\"id\":\"afa56954\",\"name\":\"Date Range\",\"sectionId\":\"date\",\"slug\":\"date_range\",\"type\":\"date/range\"},{\"id\":\"5eeec658\",\"name\":\"Category\",\"sectionId\":\"string\",\"slug\":\"category\",\"type\":\"string/=\",\"values_query_type\":\"list\"},{\"id\":\"512c560a\",\"name\":\"Location\",\"sectionId\":\"location\",\"slug\":\"location\",\"type\":\"string/=\",\"values_query_type\":\"search\"}]',NULL,NULL,_binary '\0',NULL,NULL,_binary '\0',NULL,_binary '\0',NULL,1,2,NULL,'DlK2jXoIHPXyVkEuo6Uy6',_binary '','full',NULL,0),(2,'2024-06-19 14:21:04.657644','2024-06-30 14:31:36.361239','ironfan-增值',NULL,13371339,'[]',NULL,NULL,_binary '\0',NULL,NULL,_binary '\0',NULL,_binary '\0',NULL,3,NULL,NULL,'sMsdTxTSKoA1lP8ifp3iw',_binary '','full',NULL,5396);
/*!40000 ALTER TABLE `report_dashboard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_dashboardcard`
--

DROP TABLE IF EXISTS `report_dashboardcard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_dashboardcard` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `size_x` int,
  `size_y` int,
  `row` int NOT NULL,
  `col` int NOT NULL,
  `card_id` int DEFAULT NULL,
  `dashboard_id` int NOT NULL,
  `parameter_mappings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `visualization_settings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  `action_id` int DEFAULT NULL COMMENT 'The related action',
  `dashboard_tab_id` int DEFAULT NULL COMMENT 'The referenced tab id that dashcard is on, it''s nullable for dashboard with no tab',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_dashboardcard_card_id` (`card_id`),
  KEY `idx_dashboardcard_dashboard_id` (`dashboard_id`),
  KEY `fk_report_dashboardcard_ref_action_id` (`action_id`),
  KEY `fk_report_dashboardcard_ref_dashboard_tab_id` (`dashboard_tab_id`),
  CONSTRAINT `fk_dashboardcard_ref_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dashboardcard_ref_dashboard_id` FOREIGN KEY (`dashboard_id`) REFERENCES `report_dashboard` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_report_dashboardcard_ref_action_id` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_report_dashboardcard_ref_dashboard_tab_id` FOREIGN KEY (`dashboard_tab_id`) REFERENCES `dashboard_tab` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_dashboardcard`
--

LOCK TABLES `report_dashboardcard` WRITE;
/*!40000 ALTER TABLE `report_dashboardcard` DISABLE KEYS */;
INSERT INTO `report_dashboardcard` VALUES (1,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,7,15,0,7,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":7,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":7,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":7,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":7,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.title\":\"Value of orders over time (before taxes)\",\"column_settings\":null,\"graph.dimensions\":[\"CREATED_AT\",\"CATEGORY\"],\"graph.metrics\":[\"sum\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.x_axis.labels_enabled\":false,\"series_settings\":{\"Doohickey\":{\"color\":\"#7172AD\"},\"Gadget\":{\"color\":\"#A989C5\"},\"Gizmo\":{\"color\":\"#C7EAEA\"},\"Widget\":{\"color\":\"#227FD2\"}},\"stackable.stack_type\":\"stacked\"}','T3G6Is3XniVtrqzKbZ2vx',NULL,1),(2,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,6,9,0,16,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":16,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":16,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":16,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":16,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Orders placed per quarter broken down by source and formatted to highlight best and worst quarters\",\"column_settings\":null,\"graph.dimensions\":[\"CREATED_AT\",\"SOURCE\"],\"graph.metrics\":[\"sum\"],\"graph.series_labels\":[null],\"pivot.show_row_totals\":true,\"pivot_table.column_split\":{\"columns\":[[\"field\",45,{\"base-type\":\"type/Text\",\"source-field\":43}]],\"rows\":[[\"field\",41,{\"base-type\":\"type/DateTime\",\"temporal-unit\":\"quarter\"}]],\"values\":[[\"aggregation\",0]]},\"pivot_table.column_widths\":{\"leftHeaderWidths\":[141],\"totalLeftHeaderWidths\":141,\"valueHeaderWidths\":{\"0\":234,\"1\":263,\"2\":254,\"3\":236.3636474609375,\"4\":227,\"5\":170}},\"stackable.stack_type\":\"stacked\",\"table.column_formatting\":[{\"color\":\"#FBE499\",\"colors\":[\"#ED6E6E\",\"#FFFFFF\",\"#84BB4C\"],\"columns\":[\"sum\"],\"highlight_row\":false,\"max_type\":null,\"max_value\":100,\"min_type\":null,\"min_value\":0,\"operator\":\"<\",\"type\":\"range\",\"value\":1000}]}','gXkQgKfsYghl-XjDpSefW',NULL,1),(3,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,1,0,0,NULL,1,'[]','{\"column_settings\":null,\"dashcard.background\":false,\"text\":\"Overall business health\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"heading\",\"name\":null,\"visualization_settings\":{}}}','Cb92ioon7vWaER-4OcdDS',NULL,1),(4,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',15,6,1,9,4,1,'[{\"parameter_id\":\"512c560a\",\"card_id\":4,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\"}]]}]','{\"graph.y_axis.title_text\":\"Buyers\",\"graph.series_order_dimension\":null,\"graph.x_axis.title_text\":\"Age\",\"card.title\":\"Buyers by age group\",\"graph.metrics\":[\"count_2\"],\"graph.series_order\":null,\"card.description\":\"Shows a distribution of our customers in age groups\",\"series_settings\":{\"count\":{\"color\":\"#A989C5\"},\"count_2\":{\"color\":\"#999AC4\"}},\"graph.x_axis.scale\":\"ordinal\",\"graph.dimensions\":[\"count\"]}','vJZR2mN2xRrXiqqwAc0eb',NULL,3),(5,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,1,0,0,NULL,1,'[]','{\"column_settings\":null,\"dashcard.background\":false,\"text\":\"Top performing products\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"heading\",\"name\":null,\"visualization_settings\":{}}}','s2ZdKLKOql1B0gCbOh3XO',NULL,2),(6,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',7,5,13,17,6,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":6,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":6,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":6,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":6,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Breaks down the overall performance of each of the product categories \",\"card.title\":\"Total orders by category\",\"column_settings\":null,\"pie.colors\":{\"Doohickey\":\"#7172AD\",\"Gadget\":\"#A989C5\",\"Gizmo\":\"#C7EAEA\",\"Widget\":\"#227FD2\"}}','C3ByFOdgRYsNwwXVTGfY-',NULL,2),(7,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',17,5,13,0,14,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":14,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":14,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":14,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":14,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the orders of each category quarter over quarter\",\"card.title\":\"Numbers of orders by category per quarter\",\"column_settings\":null,\"graph.dimensions\":[\"CREATED_AT\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"graph.x_axis.labels_enabled\":false,\"graph.x_axis.title_text\":\"Created At\",\"graph.y_axis.title_text\":\"Number of orders\",\"series_settings\":{\"Doohickey\":{\"color\":\"#7172AD\"},\"Gadget\":{\"color\":\"#A989C5\"},\"Gizmo\":{\"color\":\"#C7EAEA\"},\"Widget\":{\"color\":\"#227FD2\"}}}','ndNZEBY96LMGGWefgnG3o',NULL,2),(8,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',7,3,3,17,1,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":1,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":1,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":1,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":1,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the total number of orders placed for this product this month with the previous period\",\"column_settings\":null}','g6Z9N7QjvtdQbEHaAgxhY',NULL,2),(9,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',7,3,6,17,5,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":5,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":5,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":5,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":5,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the total number of orders placed for this product this month with the previous period\",\"column_settings\":null}','Q4sD1F6XrD8dVPD2JHV1Z',NULL,2),(10,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',7,3,9,17,8,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":8,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":8,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":8,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":8,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the total number of orders placed for this product this month with the previous period\",\"column_settings\":null}','3d1iG7J48euO467UN-hCL',NULL,2),(11,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',7,2,1,17,NULL,1,'[]','{\"text\":\"### Top three all-time products \\nMoM performance\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"text\",\"name\":null,\"visualization_settings\":{}}}','Jtd-7AGoT0MNS4CxhVjei',NULL,2),(12,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,1,0,0,NULL,1,'[]','{\"column_settings\":null,\"dashcard.background\":false,\"text\":\"Who  and where are our customers\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"heading\",\"name\":null,\"visualization_settings\":{}}}','xmP43pM4LHbrbRP-rjT-j',NULL,3),(13,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',15,6,14,9,17,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":17,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":17,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":17,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":17,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}]]}]','{\"card.description\":\"Shows a distribution of orders broken down by product category across our customers\' age groups\",\"card.title\":\"Product category orders per individual age\",\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.x_axis.scale\":\"ordinal\",\"graph.y_axis.title_text\":\"Orders by category\",\"series_settings\":{\"Doohickey\":{\"color\":\"#7172AD\"},\"Gadget\":{\"color\":\"#A989C5\"},\"Gizmo\":{\"color\":\"#C7EAEA\"},\"Widget\":{\"color\":\"#227FD2\"}},\"stackable.stack_type\":\"normalized\"}','f-hh5qVJwpgrj3_JWDtpX',NULL,3),(14,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',15,6,8,9,25,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":25,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":25,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":25,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":25,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}]]}]','{\"card.description\":\"Shows a distribution of revenue in age groups\",\"card.title\":\"Revenue per individual age\",\"column_settings\":null,\"graph.dimensions\":[\"Age\"],\"graph.label_value_formatting\":\"compact\",\"graph.metrics\":[\"sum\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"graph.x_axis.scale\":\"ordinal\",\"graph.y_axis.title_text\":\"Total revenue\",\"stackable.stack_type\":\"stacked\"}','VjAahFlVkOA0hp1LVBrH5',NULL,3),(15,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',17,11,1,0,23,1,'[{\"parameter_id\":\"afa56954\",\"card_id\":23,\"target\":[\"dimension\",[\"field\",\"PRODUCTS__via__PRODUCT_ID__TITLE\",{\"base-type\":\"type/Text\"}]]}]','{\"card.description\":\"An ordered list of our most successful products\",\"card.title\":\"Best selling products\",\"column_settings\":null,\"graph.dimensions\":[\"TITLE\"],\"graph.metrics\":[\"count\"],\"graph.x_axis.labels_enabled\":false,\"graph.x_axis.title_text\":\"Products\",\"graph.y_axis.title_text\":\"number of orders\",\"series_settings\":{\"count\":{\"color\":\"#999AC4\"}},\"table.pivot\":false}','zfSwuSU-8e6O3eqyt9r16',NULL,2),(16,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,1,12,0,NULL,1,'[]','{\"column_settings\":null,\"dashcard.background\":false,\"text\":\"Product category insights\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"heading\",\"name\":null,\"visualization_settings\":{}}}','tNvUvy6ezg0rUhV9baI0O',NULL,2),(17,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',17,6,19,0,19,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":19,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":19,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":19,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":19,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Shows the distribution of the product categories along the scale of customer ratings\",\"card.title\":\"Customer Satisfaction per category\",\"column_settings\":null,\"graph.dimensions\":[\"RATING\",\"CATEGORY\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.x_axis.title_text\":\"Customer Ratings\",\"graph.y_axis.auto_range\":true,\"graph.y_axis.title_text\":\"Orders by category\",\"series_settings\":{\"Doohickey\":{\"color\":\"#7172AD\"},\"Gadget\":{\"color\":\"#A989C5\"},\"Gizmo\":{\"color\":\"#C7EAEA\"},\"Widget\":{\"color\":\"#227FD2\"},\"count\":{\"color\":\"#999AC4\"}},\"stackable.stack_type\":\"stacked\",\"table.pivot\":false}','OMCqqRP9CQTT3pSp6sfo5',NULL,2),(18,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',7,6,19,17,22,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":22,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":22,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\"}]]}]','{\"card.description\":\"Indicates the average customer review of our products\",\"card.title\":\"Average product rating overall\",\"column_settings\":null,\"gauge.segments\":[{\"color\":\"#EF8C8C\",\"label\":\"awful\",\"max\":1,\"min\":0},{\"color\":\"#F2A86F\",\"label\":\"bad\",\"max\":2,\"min\":1},{\"color\":\"#F9D45C\",\"label\":\"alright\",\"max\":3,\"min\":2},{\"color\":\"#A7D07C\",\"label\":\"good\",\"max\":4,\"min\":3},{\"color\":\"#689636\",\"label\":\"great\",\"max\":5,\"min\":4}],\"table.cell_column\":\"avg\"}','iSUCvbFniuVFlN5NDV3Y7',NULL,2),(19,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',15,6,20,9,21,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":21,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":21,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":21,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":21,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}]]}]','{\"card.description\":\"Shows a distribution of orders broken down by source across our customers\' age groups\",\"card.title\":\"Orders by source per individual age\",\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"SOURCE\"],\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.x_axis.axis_enabled\":true,\"graph.x_axis.scale\":\"ordinal\",\"graph.y_axis.title_text\":\"Orders by Sources\",\"stackable.stack_type\":\"normalized\"}','s_DDqee44Wp_gHh16bAuR',NULL,3),(20,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,1,7,0,NULL,1,'[]','{\"column_settings\":null,\"dashcard.background\":false,\"text\":\"Age insights breakdowns\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"heading\",\"name\":null,\"visualization_settings\":{}}}','P37ixkaPafIr47ep0oypD',NULL,3),(21,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',18,5,4,6,12,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":12,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":12,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":12,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":12,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Matches the cumulative revenue  month over month with the number of orders placed each month\",\"column_settings\":null,\"graph.dimensions\":[\"CREATED_AT\"],\"graph.metrics\":[\"sum\",\"sum_2\"],\"graph.show_trendline\":false,\"graph.x_axis.labels_enabled\":false,\"graph.x_axis.title_text\":\"Orders date\",\"graph.y_axis.labels_enabled\":false,\"graph.y_axis.title_text\":\"Revenue\",\"series_settings\":{\"sum\":{\"display\":\"line\",\"line.interpolate\":\"linear\",\"line.marker_enabled\":false,\"show_series_values\":true,\"title\":\"Revenue\"},\"sum_2\":{\"color\":\"#51528D\",\"title\":\"Number of orders\"}}}','Cc0jFy1OZZbmC1CEA4eu2',NULL,1),(22,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',24,1,18,0,NULL,1,'[]','{\"column_settings\":null,\"dashcard.background\":false,\"text\":\"Customer satisfaction insights\",\"virtual_card\":{\"archived\":false,\"dataset_query\":{},\"display\":\"heading\",\"name\":null,\"visualization_settings\":{}}}','wRqWXKjFJ_d3t34HXl7Vg',NULL,2),(23,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',6,3,1,12,20,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":20,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":20,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":20,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":20,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the total number of orders placed this month with the previous period\",\"column_settings\":null}','xZFChb3ro-2jzg7I767yY',NULL,1),(24,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',6,3,1,6,18,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":18,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":18,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":18,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":18,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the total discount given this quarter with the previous period\",\"card.title\":\"Discount given per quarter\",\"column_settings\":null}','NGar3mVnCROw5p7djSBa3',NULL,1),(25,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',6,3,1,0,15,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":15,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":15,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":15,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":15,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the total revenue this quarter with the previous period\",\"column_settings\":null}','dX_lc-n9uNhVcRmbhZfdQ',NULL,1),(26,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',6,3,1,18,24,1,'[{\"parameter_id\":\"512c560a\",\"card_id\":24,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\"}]]}]','{\"card.description\":\"Compares the number of unique customers placing orders this month with the previous period\",\"card.title\":\"Unique customers per month\",\"column_settings\":null}','1mSLJrWPvehXkcIzoK1Yq',NULL,1),(27,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',6,5,4,0,13,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":13,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":13,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":13,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":13,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"card.description\":\"Compares the current total in revenue with the set goal for the quarter\",\"progress.goal\":250000,\"column_settings\":{\"[\\\"name\\\",\\\"sum\\\"]\":{\"number_style\":\"currency\"}}}','e-8h-dZx-B9RYybRoZzci',NULL,1),(28,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',9,6,1,0,9,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":9,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":9,\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":9,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":9,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"column_settings\":null}','M89Lh2AQnAunejYWXNUeT',NULL,3),(29,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',9,6,14,0,11,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":11,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"join-alias\":\"Products\"}]]},{\"parameter_id\":\"afa56954\",\"card_id\":11,\"target\":[\"dimension\",[\"field\",\"CREATED_AT\",{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":11,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"join-alias\":\"Products\"}]]},{\"parameter_id\":\"512c560a\",\"card_id\":11,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]}]','{\"graph.show_values\":true,\"graph.x_axis.labels_enabled\":true,\"table.cell_column\":\"SUBTOTAL\",\"graph.series_order_dimension\":null,\"graph.x_axis.axis_enabled\":true,\"graph.y_axis.labels_enabled\":false,\"card.title\":\"Product category orders per age group\",\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"series_settings\":{\"Doohickey\":{\"color\":\"#7172AD\"},\"Gadget\":{\"color\":\"#A989C5\"},\"Gizmo\":{\"color\":\"#C7EAEA\"},\"Widget\":{\"color\":\"#227FD2\"}},\"graph.y_axis.auto_range\":true,\"graph.x_axis.scale\":\"ordinal\",\"graph.dimensions\":[\"Age\",\"CATEGORY\"],\"stackable.stack_type\":\"stacked\"}','3f4Uo5mlklic7PBxY32DZ',NULL,3),(30,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',9,6,8,0,3,1,'[{\"card_id\":3,\"parameter_id\":\"afa56954\",\"target\":[\"dimension\",[\"field\",41,{\"base-type\":\"type/DateTime\"}]]},{\"card_id\":3,\"parameter_id\":\"512c560a\",\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"source-field\":43}]]},{\"card_id\":3,\"parameter_id\":\"5eeec658\",\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"card_id\":3,\"parameter_id\":\"fc2cd1be\",\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]}]','{\"column_settings\":null,\"graph.dimensions\":[\"Age\"],\"graph.metrics\":[\"sum\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"graph.x_axis.scale\":\"ordinal\",\"stackable.stack_type\":\"stacked\",\"table.cell_column\":\"SUBTOTAL\"}','h_f6hPOFg0FN3m6VA5B03',NULL,3),(31,'2024-06-19 14:13:29.000000','2024-06-19 14:13:29.000000',9,6,20,0,10,1,'[{\"parameter_id\":\"fc2cd1be\",\"card_id\":10,\"target\":[\"dimension\",[\"field\",60,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"afa56954\",\"card_id\":10,\"target\":[\"dimension\",[\"field\",\"CREATED_AT\",{\"base-type\":\"type/DateTime\"}]]},{\"parameter_id\":\"5eeec658\",\"card_id\":10,\"target\":[\"dimension\",[\"field\",58,{\"base-type\":\"type/Text\",\"source-field\":40}]]},{\"parameter_id\":\"512c560a\",\"card_id\":10,\"target\":[\"dimension\",[\"field\",48,{\"base-type\":\"type/Text\",\"join-alias\":\"People - User\"}]]}]','{\"column_settings\":null,\"graph.dimensions\":[\"Age\",\"SOURCE\"],\"graph.label_value_formatting\":\"compact\",\"graph.metrics\":[\"count\"],\"graph.series_order\":null,\"graph.series_order_dimension\":null,\"graph.show_values\":true,\"graph.x_axis.axis_enabled\":true,\"graph.x_axis.labels_enabled\":true,\"graph.x_axis.scale\":\"ordinal\",\"graph.y_axis.auto_range\":true,\"graph.y_axis.labels_enabled\":false,\"graph.y_axis.title_text\":\"Orders\",\"stackable.stack_type\":\"stacked\",\"table.cell_column\":\"SUBTOTAL\"}','JDDgMLIDoRDC24ufF2yeI',NULL,3),(32,'2024-06-19 14:21:19.151649','2024-06-19 14:30:47.592703',24,2,0,0,27,2,'[]','{}','M0wMgB4luEU3tLw2ihcCr',NULL,NULL),(34,'2024-06-20 01:44:29.802136','2024-06-20 01:44:29.802136',24,8,2,0,29,2,'[]','{}','mAWb2jLm8VflkT7s1_lBf',NULL,NULL),(35,'2024-06-20 01:53:24.116127','2024-06-20 01:53:24.116127',24,5,10,0,30,2,'[]','{}','l8ojUGfQRhM62r3dfrUP9',NULL,NULL),(36,'2024-06-30 14:31:36.398124','2024-06-30 14:31:36.398124',24,8,15,0,31,2,'[]','{}','dMJWPl0xxJkfsUFnPmd3Q',NULL,NULL);
/*!40000 ALTER TABLE `report_dashboardcard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `revision`
--

DROP TABLE IF EXISTS `revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `revision` (
  `id` int NOT NULL AUTO_INCREMENT,
  `model` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `model_id` int NOT NULL,
  `user_id` int NOT NULL,
  `timestamp` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `object` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `is_reversion` bit(1) NOT NULL DEFAULT b'0',
  `is_creation` bit(1) NOT NULL DEFAULT b'0',
  `message` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `most_recent` bit(1) NOT NULL DEFAULT b'0',
  `metabase_version` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Metabase version used to create the revision.',
  PRIMARY KEY (`id`),
  KEY `idx_revision_model_model_id` (`model`,`model_id`),
  KEY `fk_revision_ref_user_id` (`user_id`),
  KEY `idx_revision_most_recent` (`most_recent`),
  CONSTRAINT `fk_revision_ref_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `revision`
--

LOCK TABLES `revision` WRITE;
/*!40000 ALTER TABLE `revision` DISABLE KEYS */;
INSERT INTO `revision` VALUES (1,'Card',27,13371339,'2024-06-19 14:20:52.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":null,\"query_type\":\"native\",\"name\":\"当日流水\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\"}},\"parameter_mappings\":[],\"display\":\"scalar\",\"collection_preview\":true,\"visualization_settings\":{\"column_settings\":{\"[\\\"name\\\",\\\"flow/100\\\"]\":{\"number_separators\":\".\"}}},\"parameters\":[]}',_binary '\0',_binary '',NULL,_binary '\0','v0.50.5 (48f6978)'),(2,'Dashboard',2,13371339,'2024-06-19 14:21:04.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":null,\"name\":\"ironfan-增值\",\"width\":\"fixed\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '',NULL,_binary '\0','v0.50.5 (48f6978)'),(3,'Dashboard',2,13371339,'2024-06-19 14:21:19.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":null,\"name\":\"ironfan-增值\",\"width\":\"fixed\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":3,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(4,'Card',27,13371339,'2024-06-19 14:21:45.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"当日流水\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT flow/100 FROM vas_day_flow ORDER BY pdate DESC LIMIT 1;\"}},\"parameter_mappings\":[],\"display\":\"scalar\",\"collection_preview\":true,\"visualization_settings\":{\"column_settings\":{\"[\\\"name\\\",\\\"flow/100\\\"]\":{\"number_separators\":\".\"}}},\"parameters\":[]}',_binary '\0',_binary '\0',NULL,_binary '','v0.50.5 (48f6978)'),(5,'Dashboard',2,13371339,'2024-06-19 14:22:12.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"fixed\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":3,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(6,'Dashboard',2,13371339,'2024-06-19 14:29:02.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":3,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(7,'Dashboard',2,13371339,'2024-06-19 14:30:47.000000','{\"description\":null,\"archived\":false,\"collection_position\":1,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(8,'Dashboard',2,13371339,'2024-06-19 14:33:02.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(9,'Dashboard',2,13371339,'2024-06-19 14:33:14.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":null,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(10,'Dashboard',2,13371339,'2024-06-19 14:34:07.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(11,'Card',28,13371339,'2024-06-20 01:39:41.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"三日流水时分同比\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}},\"parameter_mappings\":[],\"display\":\"line\",\"collection_preview\":true,\"visualization_settings\":{\"graph.show_goal\":false,\"graph.show_trendline\":false,\"graph.show_values\":true,\"graph.x_axis.labels_enabled\":false,\"graph.series_order_dimension\":null,\"graph.x_axis.axis_enabled\":\"rotate-90\",\"graph.y_axis.scale\":\"linear\",\"graph.label_value_frequency\":\"fit\",\"graph.metrics\":[\"前天\",\"昨天\",\"今天\"],\"graph.y_axis.axis_enabled\":true,\"graph.label_value_formatting\":\"auto\",\"graph.series_order\":null,\"column_settings\":{\"[\\\"name\\\",\\\"t\\\"]\":{\"time_enabled\":\"seconds\",\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}},\"graph.x_axis.scale\":\"ordinal\",\"graph.dimensions\":[\"时间\"]},\"parameters\":[]}',_binary '\0',_binary '',NULL,_binary '\0','v0.50.5 (48f6978)'),(12,'Dashboard',2,13371339,'2024-06-20 01:40:06.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":33,\"parameter_mappings\":[],\"card_id\":28,\"visualization_settings\":{},\"size_y\":7,\"dashboard_id\":2,\"row\":2}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(13,'Card',29,13371339,'2024-06-20 01:42:14.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"三日时分同比new\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}},\"parameter_mappings\":[],\"display\":\"table\",\"collection_preview\":true,\"visualization_settings\":{\"table.cell_column\":\"前天\",\"column_settings\":{\"[\\\"name\\\",\\\"时间\\\"]\":{\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}}},\"parameters\":[]}',_binary '\0',_binary '',NULL,_binary '\0','v0.50.5 (48f6978)'),(14,'Card',29,13371339,'2024-06-20 01:43:33.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"三日时分同比new\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}},\"parameter_mappings\":[],\"display\":\"line\",\"collection_preview\":true,\"visualization_settings\":{\"table.cell_column\":\"前天\",\"graph.x_axis.scale\":\"ordinal\",\"graph.x_axis.axis_enabled\":\"rotate-45\",\"graph.show_values\":true,\"graph.label_value_formatting\":\"auto\",\"graph.dimensions\":[\"时间\"],\"column_settings\":{\"[\\\"name\\\",\\\"时间\\\"]\":{\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}},\"graph.metrics\":[\"前天\",\"昨天\",\"今天\"]},\"parameters\":[]}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(15,'Card',28,13371339,'2024-06-20 01:44:06.000000','{\"description\":null,\"archived\":true,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"三日流水时分同比\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}},\"parameter_mappings\":[],\"display\":\"line\",\"collection_preview\":true,\"visualization_settings\":{\"graph.show_goal\":false,\"graph.show_trendline\":false,\"graph.show_values\":true,\"graph.x_axis.labels_enabled\":false,\"graph.series_order_dimension\":null,\"graph.x_axis.axis_enabled\":\"rotate-90\",\"graph.y_axis.scale\":\"linear\",\"graph.label_value_frequency\":\"fit\",\"graph.metrics\":[\"前天\",\"昨天\",\"今天\"],\"graph.y_axis.axis_enabled\":true,\"graph.label_value_formatting\":\"auto\",\"graph.series_order\":null,\"column_settings\":{\"[\\\"name\\\",\\\"t\\\"]\":{\"time_enabled\":\"seconds\",\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}},\"graph.x_axis.scale\":\"ordinal\",\"graph.dimensions\":[\"时间\"]},\"parameters\":[]}',_binary '\0',_binary '\0',NULL,_binary '','v0.50.5 (48f6978)'),(16,'Dashboard',2,13371339,'2024-06-20 01:44:29.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":34,\"parameter_mappings\":[],\"card_id\":29,\"visualization_settings\":{},\"size_y\":8,\"dashboard_id\":2,\"row\":2}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(17,'Card',29,13371339,'2024-06-20 01:44:42.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"三日时分同比\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t2.t AS \'时间\',\\n        IFNULL(t2.flow/100, 0) AS \'前天\',\\n        IFNULL(t1.flow/100, 0) AS \'昨天\',\\n        IFNULL(t0.flow/100, 0) As \'今天\'\\nFROM\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 2 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\')\\n) t2\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(CURDATE() - INTERVAL 1 DAY, \'%Y-%m-%d 00:00:00\') AND ptime<DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nON t1.t=t2.t\\nLEFT JOIN\\n(\\n        SELECT TIME(ptime) AS t, flow FROM vas_yoy_flow WHERE ptime>=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t0\\nON t0.t=t2.t\\n;\"}},\"parameter_mappings\":[],\"display\":\"line\",\"collection_preview\":true,\"visualization_settings\":{\"table.cell_column\":\"前天\",\"graph.x_axis.scale\":\"ordinal\",\"graph.x_axis.axis_enabled\":\"rotate-45\",\"graph.show_values\":true,\"graph.label_value_formatting\":\"auto\",\"graph.dimensions\":[\"时间\"],\"column_settings\":{\"[\\\"name\\\",\\\"时间\\\"]\":{\"time_style\":\"HH:mm\"},\"[\\\"name\\\",\\\"前天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"昨天\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"今天\\\"]\":{\"number_separators\":\".\"}},\"graph.metrics\":[\"前天\",\"昨天\",\"今天\"]},\"parameters\":[]}',_binary '\0',_binary '\0',NULL,_binary '','v0.50.5 (48f6978)'),(18,'Card',30,13371339,'2024-06-20 01:53:03.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"主播当日收入榜\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\nORDER BY t1.income DESC\\n;\"}},\"parameter_mappings\":[],\"display\":\"table\",\"collection_preview\":true,\"visualization_settings\":{\"table.pivot_column\":\"昵称\",\"table.cell_column\":\"主播mid\",\"column_settings\":{\"[\\\"name\\\",\\\"主播mid\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"主播user_id\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"主播收入(钻石)\\\"]\":{\"number_separators\":\".\"}}},\"parameters\":[]}',_binary '\0',_binary '',NULL,_binary '\0','v0.50.5 (48f6978)'),(19,'Dashboard',2,13371339,'2024-06-20 01:53:24.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":34,\"parameter_mappings\":[],\"card_id\":29,\"visualization_settings\":{},\"size_y\":8,\"dashboard_id\":2,\"row\":2},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":35,\"parameter_mappings\":[],\"card_id\":30,\"visualization_settings\":{},\"size_y\":5,\"dashboard_id\":2,\"row\":10}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '\0','v0.50.5 (48f6978)'),(20,'Card',30,13371339,'2024-06-20 01:53:50.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"主播当日收入榜\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT  t1.mid AS \'主播mid\',\\n        t2.user_id AS \'主播user_id\',\\n        t2.name AS \'主播昵称\',\\n        t1.income AS \'主播收入(钻石)\'\\nFROM\\n(\\n        SELECT mid,income,pdate FROM vas_cur_streamer_income WHERE pdate=DATE_FORMAT(NOW(), \'%Y-%m-%d 00:00:00\')\\n) t1\\nLEFT JOIN\\n(\\n        SELECT mid,user_id,name FROM streamer\\n) t2\\nON t1.mid=t2.mid\\nWHERE t2.name!=\'\'\\nORDER BY t1.income DESC\\n;\"}},\"parameter_mappings\":[],\"display\":\"table\",\"collection_preview\":true,\"visualization_settings\":{\"table.pivot_column\":\"昵称\",\"table.cell_column\":\"主播mid\",\"column_settings\":{\"[\\\"name\\\",\\\"主播mid\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"主播user_id\\\"]\":{\"number_separators\":\".\"},\"[\\\"name\\\",\\\"主播收入(钻石)\\\"]\":{\"number_separators\":\".\"}}},\"parameters\":[]}',_binary '\0',_binary '\0',NULL,_binary '','v0.50.5 (48f6978)'),(21,'Card',31,13371339,'2024-06-30 14:31:19.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"table_id\":null,\"database_id\":2,\"enable_embedding\":false,\"collection_id\":3,\"query_type\":\"native\",\"name\":\"每日收入明细\",\"type\":\"question\",\"embedding_params\":null,\"cache_ttl\":null,\"dataset_query\":{\"database\":2,\"type\":\"native\",\"native\":{\"template-tags\":{},\"query\":\"SELECT\\n\\tptime   \'时间\',\\n\\tmembership_cnt   \'会员数\',\\n\\tmembership_flow   \'会员流水\',\\n\\tzone_admission_cnt   \'空间解锁数\',\\n\\tzone_admission_flow   \'空间解锁流水\',\\n\\tzone_superfan_cnt   \'空间超粉数\',\\n\\tzone_superfan_flow   \'空间超粉流水\',\\n\\tzone_moment_cnt   \'空间动态数\',\\n\\tzone_moment_flow   \'空间动态流水\',\\n\\tother_cnt   \'其他数(微信+金币)\',\\n\\tother_flow   \'其他流水(微信+金币)\',\\n\\ttotal_flow   \'总流水\',\\n\\tstreamer_flow   \'主播分成\',\\n\\tofficial_flow   \'净收入\',\\n\\tCONCAT(ROUND(profit_rate*100.0,2), \'%\')   \'利润率\',\\n\\tCONCAT(ROUND(membership_rate*100.0,2), \'%\')   \'会员流水占比\',\\n\\tCONCAT(ROUND(zone_admission_rate*100.0,2), \'%\')   \'空间解锁占比\',\\n\\tCONCAT(ROUND(zone_superfan_rate*100.0,2), \'%\')   \'空间超粉占比\',\\n\\tCONCAT(ROUND(zone_moment_rate*100.0,2), \'%\')   \'空间动态占比\',\\n\\tCONCAT(ROUND(other_rate*100.0,2), \'%\')   \'其他占比\'\\nFROM vas_day_detail\\nORDER BY ptime DESC\\n;\"}},\"parameter_mappings\":[],\"display\":\"table\",\"collection_preview\":true,\"visualization_settings\":{\"table.cell_column\":\"会员数\",\"column_settings\":{\"[\\\"name\\\",\\\"时间\\\"]\":{\"time_style\":\"HH:mm\",\"date_style\":\"YYYY/M/D\"}}},\"parameters\":[]}',_binary '\0',_binary '',NULL,_binary '','v0.50.5 (48f6978)'),(22,'Dashboard',2,13371339,'2024-06-30 14:31:36.000000','{\"description\":null,\"archived\":false,\"collection_position\":null,\"tabs\":[],\"enable_embedding\":false,\"collection_id\":3,\"name\":\"ironfan-增值\",\"width\":\"full\",\"embedding_params\":null,\"cache_ttl\":null,\"cards\":[{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":32,\"parameter_mappings\":[],\"card_id\":27,\"visualization_settings\":{},\"size_y\":2,\"dashboard_id\":2,\"row\":0},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":34,\"parameter_mappings\":[],\"card_id\":29,\"visualization_settings\":{},\"size_y\":8,\"dashboard_id\":2,\"row\":2},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":35,\"parameter_mappings\":[],\"card_id\":30,\"visualization_settings\":{},\"size_y\":5,\"dashboard_id\":2,\"row\":10},{\"size_x\":24,\"dashboard_tab_id\":null,\"series\":[],\"action_id\":null,\"col\":0,\"id\":36,\"parameter_mappings\":[],\"card_id\":31,\"visualization_settings\":{},\"size_y\":8,\"dashboard_id\":2,\"row\":15}],\"parameters\":[],\"auto_apply_filters\":true}',_binary '\0',_binary '\0',NULL,_binary '','v0.50.5 (48f6978)');
/*!40000 ALTER TABLE `revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sandboxes`
--

DROP TABLE IF EXISTS `sandboxes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sandboxes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `group_id` int NOT NULL COMMENT 'ID of the Permissions Group this policy affects.',
  `table_id` int NOT NULL COMMENT 'ID of the Table that should get automatically replaced as query source for the Permissions Group.',
  `card_id` int DEFAULT NULL,
  `attribute_remappings` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `permission_id` int DEFAULT NULL COMMENT 'The ID of the corresponding permissions path for this sandbox',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_gtap_table_id_group_id` (`table_id`,`group_id`),
  KEY `fk_gtap_group_id` (`group_id`),
  KEY `idx_gtap_table_id_group_id` (`table_id`,`group_id`),
  KEY `fk_gtap_card_id` (`card_id`),
  KEY `fk_sandboxes_ref_permissions` (`permission_id`),
  CONSTRAINT `fk_gtap_card_id` FOREIGN KEY (`card_id`) REFERENCES `report_card` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_gtap_group_id` FOREIGN KEY (`group_id`) REFERENCES `permissions_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_gtap_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Records that a given Card (Question) should automatically replace a given Table as query source for a given a Perms Group.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sandboxes`
--

LOCK TABLES `sandboxes` WRITE;
/*!40000 ALTER TABLE `sandboxes` DISABLE KEYS */;
/*!40000 ALTER TABLE `sandboxes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `secret`
--

DROP TABLE IF EXISTS `secret`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `secret` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT 'Part of composite primary key for secret; this is the uniquely generted ID column',
  `version` int NOT NULL DEFAULT '1' COMMENT 'Part of composite primary key for secret; this is the version column',
  `creator_id` int DEFAULT NULL COMMENT 'User ID who created this secret instance',
  `created_at` timestamp(6) NOT NULL COMMENT 'Timestamp for when this secret instance was created',
  `updated_at` timestamp(6) NULL DEFAULT NULL COMMENT 'Timestamp for when this secret record was updated. Only relevant when non-value field changes since a value change will result in a new version being inserted.',
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The name of this secret record.',
  `kind` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The kind of secret this record represents; the value is interpreted as a Clojure keyword with a hierarchy. Ex: ''bytes'' means generic binary data, ''jks-keystore'' extends ''bytes'' but has a specific meaning.',
  `source` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'The source of secret record, which controls how Metabase interprets the value (ex: ''file-path'' means the ''simple_value'' is not the real value, but a pointer to a file that contains the value).',
  `value` longblob,
  PRIMARY KEY (`id`,`version`),
  KEY `fk_secret_ref_user_id` (`creator_id`),
  CONSTRAINT `fk_secret_ref_user_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Storage for managed secrets (passwords, binary data, etc.)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `secret`
--

LOCK TABLES `secret` WRITE;
/*!40000 ALTER TABLE `secret` DISABLE KEYS */;
/*!40000 ALTER TABLE `secret` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `segment`
--

DROP TABLE IF EXISTS `segment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `segment` (
  `id` int NOT NULL AUTO_INCREMENT,
  `table_id` int NOT NULL,
  `creator_id` int NOT NULL,
  `name` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `archived` bit(1) DEFAULT b'0',
  `definition` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `created_at` timestamp(6) NOT NULL,
  `updated_at` timestamp(6) NOT NULL,
  `points_of_interest` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `caveats` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `show_in_getting_started` bit(1) NOT NULL DEFAULT b'0',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `idx_segment_creator_id` (`creator_id`),
  KEY `idx_segment_table_id` (`table_id`),
  KEY `idx_segment_show_in_getting_started` (`show_in_getting_started`),
  CONSTRAINT `fk_segment_ref_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_segment_ref_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `segment`
--

LOCK TABLES `segment` WRITE;
/*!40000 ALTER TABLE `segment` DISABLE KEYS */;
/*!40000 ALTER TABLE `segment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `setting`
--

DROP TABLE IF EXISTS `setting`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `setting` (
  `key` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `value` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `setting`
--

LOCK TABLES `setting` WRITE;
/*!40000 ALTER TABLE `setting` DISABLE KEYS */;
INSERT INTO `setting` VALUES ('admin-email','lwl0608@foxmail.com'),('analytics-uuid','56a75705-c330-4527-a289-88989bf8d690'),('anon-tracking-enabled','true'),('custom-homepage','true'),('custom-homepage-dashboard','2'),('example-dashboard-id','1'),('instance-creation','2024-06-19T22:13:27Z'),('redirect-all-requests-to-https','false'),('settings-last-updated','2024-07-21 22:42:13'),('setup-license-active-at-setup','false'),('setup-token','5e2fb168-2bb8-4ede-b5ae-fd9996be93e0'),('site-locale','zh_CN'),('site-name','ironfan'),('site-url','http://bi.wishpal.cn'),('site-uuid','e75f40d5-f536-4499-8964-581cafb36270'),('site-uuid-for-version-info-fetching','38d420f9-8524-4136-af04-38a3a321b428'),('startup-time-millis','23871'),('version-info','{\"latest\":{\"version\":\"v0.50.13\",\"released\":\"2024-07-15\",\"patch\":true,\"highlights\":[\"Temporarily disable tracking field usage\",\"Fix table crash when going from normal to pivot mode\",\"Joined table column picker disables the only selected column\",\"Metadata % description shows up behind popup\",\"Weird behavior after saving questions in v1.50.11\",\"Pulse card render error - getSeriesVizSettingsKey - TypeError: Cannot read property \'name\' of undefined\",\"Sync `table.columns` and `graph.metrics` viz settings based on the desired column alias\",\"`type/FK` -> column and `type/FK` -> `type/Name` field values remapping doesn\'t work in QB filter widgets when `Search box` is used\",\"Using specific dates in Date field filter automatically adds unwanted time filter\",\"Unable to edit metadata of model\",\"When updating a filter value in chill mode, the order of the columns is messed up\",\"Model\'s column order not saved\",\"Ellipsis tooltip cut off/not visible in GUI editor\",\"Table filter multiselect input box does not work\",\"Question Corrupt - Columns not shown\",\"Can\'t edit metadata for models with several columns\",\"Models containing joins and repeated column names break the metadata editor\",\"Aggregating with Custom Column first doesn\'t show sub-totals in pivot table\",\"Can\'t edit metadata of a model column if it comes from a question join\",\"[BUG] Column order in saved question resets after a column(s) is removed from database table\",\"\\\"No matching name\\\" found when it clearly has been found\",\"Synced database with new table added, UI does not update to reflect\"]},\"older\":[{\"version\":\"v0.50.12\",\"released\":\"2024-07-12\",\"patch\":true,\"highlights\":[\"Add bounded transaction queue for SQL Analysis\",\"refactor: do not spread props to QueryModals\",\"[serdes] spec check requires up-to-date db\",\"Fix broken link to \\\"No self-service\\\" deprecation docs\",\"Update fast-loops\",\"docs - add note about parameters for datetime functions\",\"Fix flaky collections test\",\"Repro #45036 and #44910: Multiple popovers can be opened simultaneously\",\"Bump macaw to 0.1.65\",\"Repro #40622: Filter modal UI breaks when there are many tables in a question\",\"docs - warning for mysql\",\"Exclude internal content when populating :has_question_and_dashboard for current user.\",\"docs: add 49.20 and 50.11 releases\",\"Weird (split) Filter modal when joining two tables using their foreign keys\",\"Shutdown releasing migration locks has an error in the log statement\",\"Make import work on a fresh install\",\"Funnel column ordering freak out\",\"x-rays on the home screen are disappearing too quickly\",\"[CI] Add repro #31274 to the flaky test group\",\"Repro #45359 - Incorrect font in e2e tests in CI \",\"Async coll perm graph revision\",\"Funnel chart handles null values incorrectly\",\"[perf] Fix remaining thread leak in BigQuery query execution\",\"Serialize by entity_id\",\"perf: pass uuid to BE to enable metadata caching during fetching dashboard\",\"[serdes] use spec instead of a pipeline for Card\",\"Soft-delete defective duplicate fields\",\"Add explanations for permissions changes\",\"Dashboard level visualization settings not taken into account on dashboard subscriptions\",\"Dashboard parameter values doesn\'t work in the static embed modal preview when the dashboard isn\'t published\",\"You cannot do a full serialization export on stats via API\",\"Regression: y-axis minimum is ignored for stacked histograms\",\"non-admin unable to find sample db tables in search\",\"Custom Column Case Expression Doesn\'t Save\",\"v50: Foreign keys no longer work with MongoDB\",\"Animation happening when hovering between columns that prevents the column metadata from populating fast\",\"Object detail view is not scrollable at narrow screen widths\",\"Filter modal UI breaks when there are many tables in a question\",\"Wrong default parameter value passed to the parameter widget\",\"Editing description for models do not work and markdown support is inconsistent\",\"Editing model metadata disables table data sorting\",\"Error Applying All-Time Filter to a question\",\"In a dashboard, Dropdown list doesn\'t work through application sharing\",\"basic functionality to connect to a third-party Database \"]},{\"version\":\"v0.50.11\",\"released\":\"2024-07-09\",\"patch\":true,\"highlights\":[\"Shutdown releasing migration locks has an error in the log statement\",\"fix flaky unit test by removing un-needed waitForElementToBeRemoved\",\"Technical Debt: Logs page testing depends on hardcoded numbers\",\"fix: Allow submit buttons to override the variant prop\",\"docs - note on info schema\",\"/api/testing/set-time: ability to set JVM time during development\",\"`GET /api/activity/most_recently_viewed_dashboard` should not return archived dashboards\",\"add note about MySQL and MariaDB re: offset\",\"docs(sdk): Document how to reload Metabase embedding SDK components\",\"docs - add 50.10 to list of versions\",\"copy change in csv modal\",\"refactor: drop unused js file\",\"Cannot change the stacking setting on stats\",\"Add INFO log for each table before JSON unfolding during field sync\",\"Skip fingerprinting or scanning field values for fields with base-type=type/Collection\",\"Repro #39504: Pivot table disappears\",\"lint: add stylelint support for emotion components\",\"ci: pin replayio version\",\"Upgrade to v50 where Permissions are Mapped to \\\"No self-service (deprecated)\\\" Blocks View Access to Other Data in the Database\",\"Invalid visualization settings crash combined cartesian charts on dashboards\",\"Batch permission updates with many tables\",\"Add tables pre-fetching to dashboard load\",\"Adds plan-alias info to premium-embedding-token and exposes it in troubleshooting\",\"Hamburger menu is not functional in Admin app on moble\",\"Require Card ref permissions to use Card reference template tag in native query \",\"Remove field refs from DatasetEditor\",\"pass correct redux action name\",\"Dropdown slightly shifts after hover on items\",\"Users with \\\"No Query Access\\\" receive Incorrect error when trying to promote Questions to models\",\"[50.x] N+1 queries while loading dashboard `query_metadata`\",\"\\\"It\'s okay to play around with saved questions\\\" modal can\'t be dismissed with keyboard\",\"Submit button in \\\"Duplicate entity\\\" modal is not styled as primary\",\"Indexed Entities lack visual context in command palette\",\"The UI will keep calling /logs after you leave the troubleshooting->logs page\",\"Dashboard filter options lookup produces query that references non-existent column when linked question aggregates values\",\"No results and waiting for results overlap\",\"Editing Column description of Model is confusing if it contains aggregations\",\"Pivot table disappears\",\"error result when shared dashbord has boolean type filter\",\"Visualization doesn\'t pick up the all fields returned by the query\",\"Reverting a question to a revision prior to Metabase upgrade 0.46 does not work\",\"Zooming on object detail from a metadata-edited model column does not work or warn users\",\"Clicking on \\\"View details\\\" for a table row when editing model metadata throws 404\"]},{\"version\":\"v0.50.10\",\"released\":\"2024-07-04\",\"patch\":true,\"highlights\":[\"docs - add note about permissions update\",\"Repro #42385 - Cover additional draft join scenario\",\"User Parameter Values Are Unique Per Dashboard\",\"[perf] Add caching on `dashboard_load_id`; reusable MetadataProviders\",\"Upgrading to 50v causes some permission in No self-service (deprecated) to block access to the Browse Data\",\"Reproduce #27643: Field filter linked to Boolean column causes an error when used in Embedding\",\"docs - add 50.9 to list of releases\",\"Add reproduction for \\\"Entity picker surfaces recent questions that are not valid joins\\\"\",\"Repro parameter field matching issues for questions based on sql models\",\"docs: warnings about question marks\",\"Specifying a date in a custom expression breaks query (v50 regression)\",\"Support duplicate prefixes in long column names for CSV uploads\",\"Updating filter on one dashboard automatically updates filters on other dashboards with cards referencing the same data\",\"Performance: partial data-permissions graph refactor\",\"docs - oracle note\",\"Auto request review workflow\",\"Questions based on a custom SQL query aren\'t updated\",\"\\\"Duplicate Dashboard\\\" messes up last used filter values - one dashboard overrides another\",\"Invalid join clause does not disappear after changing query source to use a different database\",\"incomplete data on png image download \",\"we log \\\"WARN middleware.log :: OST /api/dataset 404 116.6 µs (0 DB calls)\\\" on 404\",\"SQL-converted question with field filter breaks filtered dashboard if reverted back to its editor version\",\"Permission error before finishing referencing a question in the native query\",\"Data model field renaming/remapping gets out of sync\"]},{\"version\":\"v0.50.9\",\"released\":\"2024-07-02\",\"patch\":true,\"highlights\":[\"Adds a property to a defsetting\",\"Consolidate admin E2E reproductions for the release-x.50.x\",\"Memoize driver.u/supports? only in prod\",\"docs - update API docs\",\"docs - ClickHouse\",\"docs: add 50.8\",\"Repro #27521 - Query fails when selecting two fields from nested query, when fields are identical except for their join-alias\",\"fix: one of transactions was removed and that causes problems on downgrade\",\" Be explicit about truncating characters versus bytes\",\"Better display names for CSV upload tables\",\"Return info about the proper billing status on the license page\",\"Metabase downgrade issue - v0.50.7 to v0.49.x\",\"Improve cartesian chart performance on large datasets\",\"Combine actions e2e specs\",\"Can\'t edit joined tables after saving the question\",\"Break out popover overflows the screen\",\"Filtering by exact date and time works incorrectly if midnight is chosen\",\"Hovering over column header in preview errors out\",\"Accurate Error Messaging for Cross DB Joins in Notebook Editor\",\"International characters do not display in Slack alerts\",\"Unable to configure steps order for funnel bar charts\",\"Filter values in dropdown are not getting populated in SQL question based dashboard\",\"Pin Map reads Metric Field value and it hides rows if it\'s null\",\"Unable to switch question to query table in another database\",\"Error displaying reviews model\",\"Broken navigation in question data source picker \",\"PNG Download of Map Visualization doesn\'t include Background Map Image\",\"Error adding any summary fields to an existing aggregate questions\",\"Metabase doesn\'t realize that Redshift aborts a query\",\"Scrolling up on schema list jumps to the top when creating a new question\",\"Can\'t update/change column settings \",\"Calendar icon in breakout picker is off-position\",\"GUI time period selector can cause blank screen under some circumstances\",\"Unecessary get values call\",\"`/field/values` endpoint contains `[object Object]` in the URL\",\"Metabase starts super slow if entropy is exhausted (10+min)\"]},{\"version\":\"v0.50.8\",\"released\":\"2024-06-28\",\"patch\":true,\"highlights\":[\"🤖 backported \\\"Rather support old files, than duplicate columns\\\"\",\"Revert: Fix appends for long column names\",\"Consolidate native E2E reproductions for the `release-x.50.x` branch\",\"Consolidate permissions E2E reproductions for the `release-x.50.x` branch\",\"Consolidate chart viz E2E reproductions for the `release-x.50.x` branch\",\"Consolidate tabular viz E2E reproductions for the `release-x.50.x branch`\",\"Consolidate search E2E reproductions for the `release-x.50.x` branch\",\"Consolidate embedding E2E reproductions for the `release-x.50.x` branch\",\"Consolidate native filter E2E reproductions for the `release-x.50.x` branch\",\"Consolidate dashboard E2E reproductions for the `release-x.50.x` branch\",\"Consolidate dashboard cards E2E reproductions for the `release-x.50.x` branch\",\"Consolidate joins E2E reproductions for the `release-x.50.x` branch\",\"Patch storybook to fix failed loki tests with runtime error\",\"Consolidate custom column E2E reproductions for the `release-x.50.x` branch\",\"Consolidate sharing E2E reproductions for the `release-x.50.x` branch\",\"Consolidate collections E2E reproductions for the `release-x.50.x` branch\",\"🤖 backported \\\"Ensure we close the canceled chan in query processor after query\\\"\",\"Ensure we close the canceled chan in query processor after query\",\"Add a repro for \'Page hangs when one of parameters contains {{x}} value\'\",\"docs: clarify migrate down for docker\",\"Error on import into an empty appdb\",\"Repro #34955: Custom column of type datetime with dashboard filter\",\"Unskip repro for #14957: Saving a question before query has been executed can be slow with UI \\\"hanging\\\"\",\"Repro #40635 - Metabase model does not display information correctly\",\"Consolidate models JS reproductions for the `release-x.50.x` branch\",\"add e2e test for public dashboard title\",\"🍒 Backport: Fix FE crash for line/area/bar charts with no data\",\"Consolidate question reproductions 3\",\"Consolidate question E2E reproductions (1 and 2) for the `release-x.50.x` branch specifically\",\"Page hangs when one of parameters contains `{{x}}` value\",\"[50.x] For a sandboxed user, thousands of appdb queries are sent during a dashboard read\",\"Make SLO optional and default the SLO behavior to disabled\",\"Users that upgraded to v50 receive an email with a link that goes to a 404\",\"Unskip the repro for #18770 (Post-aggregation filters)\",\"Consolidate filter E2E reproductions for the release-x.50.x branch specifically\",\"Remove description length check from copy question form\",\"Cannot append CSV with long column name\",\"Fix broken field normalization in metadata\",\"Memoize driver.u/supports?\",\"docs: add 50.7 to releases\",\"Repro #35043: Date range filter - from newer to older date\",\"Visualization error with a custom column\",\"Multiple values can be used as a default value for single-value dashboard filters\",\"Unable to sort by the breakout column\",\"Can\'t display line or bar chart for empty result set\",\"docs - fix link\",\"Fix testing week-of-year extraction in `general-timezone-support-test`\",\"Fix invalid API request fired on chart legend click\",\"Split SummarizeContent from SummarizeSidebar\",\"[v0.48.13 --> v0.49.17] Migration stuck with \\\"Running 8 migrations ...\\\"\",\"Issue processing Mongo BigDecimal when values are less than 0\",\"Bump dashboard description max length limit to 1.5K\",\"Some caching improvements\",\"E2E repro for \\\"Fix issue with root collection in QuestionPicker\\\"\",\"make enable-query-caching setting work\",\"Fix failures due to false positives on reserved SQL keywords\",\"We\'re maxing out fields at 255 characters in several places in the UI while our DB supports infinite text\",\"Exclude native query matches in search scoring when the search should exclude native queries\",\"Combine embedding e2e specs\",\"Consolidate chart viz e2e specs\",\"horizontal scroll disappeared on overflowing pivot table on saved questions.\",\"Invalid API request fired when clicking chart legend item\",\"Break out popover overflows the screen\",\"Questions always say \\\"Updated a few seconds ago\\\"\",\"Filtering on date columns by relative dates returning wrong results\",\"Using Column picker to remove columns on model breaks question with ERROR: column source.name_2 does not exist   Position\",\"Data picker shows \\\"Saved Questions\\\" on an empty *not yet activated* enterprise instance\",\"Model does not bring the options in filters although the api responds with a 200 and the values\",\"Remove all doesn\'t work when adding/removing columns\",\"Refresh button won\'t work after visualization is changed for users with no self-service access\",\"Cannot change question data source to raw data after selecting saved question\",\"[MLv2] - Visible Columns errors when source query is a table joined on itself\",\"\\\"Date range\\\" filter: I can set a range in which \\\"from\\\" is a later date than \\\"to\\\".\",\"Timeseries Filter Widget jumps when opening\",\"Custom column with errors is removed from the question without any error being shown\",\"`convertTimezone` usage on unsupported databases returns confusing error\",\"Question editor does not work if model joins the same table more than once\",\"Cumulative aggregate in Question breaks when you turn into a Model or simply add a Filter after the Aggregation\",\"Drilling into a filtered query from dashboard opens unfiltered query\",\"Metrics fields disapearing when joinning question\",\"Dashboard click through behavior to a question does not pass time filters correctly\",\"Adding filter of summarized field grouped by latitude and longitude on a map breaks breadcrumbs\",\"`POST /api/util/password_check` called way too often during setup\",\"\\\"Pick your starting data\\\" motion starts before the sidebar finished collapsing / misaligns\",\"Closing Drop-down in Join column selector causes non-drop-down columns to disapper\",\"Post-aggregation filters disrupt drilldown on table views\",\"When List style field is changed to show remapped foreign key, then cached values are not updated\",\"API allows `count(field)` which kills the metrics page\",\"Join UI picks the first schema even if a different one is selected\",\"Unbinned geo mapping defaults to Grid instead of Pins\"]},{\"version\":\"v0.50.7\",\"released\":\"2024-06-25\",\"patch\":true,\"highlights\":[\"Filters on static embedding are not respecting the filter dropdown type and defaulting to an input box when filters are connected to models\",\"🤖 backported \\\"bump echarts to v5.5.1-rc.1\\\"\",\"docs: add 49.18 to list of releases\",\"bump echarts to v5.5.1-rc.1\",\"Make scores work with zero items and zero max executuion count\",\"Repro #33330: Cumulative count breaks in certain situations\",\"🤖 backported \\\"Effective location on collection recent items\\\"\",\"🤖 backported \\\"perf: disable view log and card used updates during metadata fetches\\\"\",\"Repro #44550: Missing display name for the filter with an offset\",\"Field Filters in Embedded Dashboard Are No Longer Working\",\"Disable Pivot Export Post Processing Step\",\"Split content from `FilterModal` into `FilterContent` \",\"Chart dimensions are not updated when adding breakouts one-by-one\",\"Split `FilterModal` components into separate files and folders\",\"Make notebook props explicit\",\"convert browser.js to typescript\",\"Sanitize SVG before parsing with Batik to prevent render failures when invalid characters are in the SVG content\",\"Set `useLocalSessionState` and/or `alwaysSendSetIsolation` connection properties for MySQL/MariaDB\",\"Make the App DB transaction isolation level READ_COMMITTED for MySQL [MEGA PERFORMANCE BOOST]\",\"perf: disable view log and card used updates during metadata fetches\",\"Fix the order we attempt to set DW transaction isolation in [PERFORMANCE BOOST]\",\"convert embed.ts to ts and to use createSlice from rtk\",\"Add e2e tests of the Admin / Performance policy form\'s ability to save and display saved data\",\"Track metabase.nqa module dependencies\",\"Missing schema name in data picker\",\"Migrate down between 50 and 49 fails when you had sandboxing configured on 49\",\"[tiny PR:] fix(cache): Add missing question mark in the \'Clear cache\' confirmation modal\",\"User parameter value json fix\",\"Query changes are not accepted by the QB for some table questions if the query wasn\'t run before that\",\"Making a model that joins a table 2 times will generate wrong x-rays\",\"Don\'t analyse non-SQL cards with Macaw\",\"[MBQL lib] Put `:fields :all` on joins on deleting last aggregation\",\"Disable parameter mapping with native models\",\"Unable to connect dashboard number filter to number variable of SQL query card\",\"In Admin/Performance/Database caching, 12:00PM cannot be used as a time in the Schedule component\",\"In Admin/Performance/Database caching, when a minimum query duration is saved for an adaptive policy, the new value does not appear in the form\",\"Field values remapping with mixed PK and a FK targeting the same PK is broken in public dashboards\",\"Restoring a bookmarked entity (dashboard/question/metric) leads to application crash\",\"SQL \\\"Unknown column\\\" errors on 0.50.0 with breakouts on nested models\",\"special characters on the data will break subscriptions\",\"Table loses visualization settings when using a click action\",\"Effective location on collection recent items\",\"disable invalid move targets in the recents tab (needs recents API update: effective_location)\",\"Choosing the fields to Join On Resets Join Type in the GUI Editor\",\"Can\'t reset binning on join columns to \\\"Don\'t bin\\\"\",\"MB_JETTY_SKIP_SNI evaluating env variable as string instead of bool, always evaluating to truthy if set\",\"Add Upload CSVs button for customers with feature flag\",\"Database mapped field in model metadata shows None after mapping/saving\",\"Oracle timestamps fingerprinting error (No implementation of method: :->temporal of protocol: #\'metabase.sync.analyze.fingerprint.fingerprinters/ITemporalCoerceable)\",\"Filtering on text ids/foreign key not available in question editor\",\"Adding a string to UI question\'s custom column crashes Metabase\",\"Result inconsistencies with Preview in GUI editor\",\"Cannot edit a custom field named like the column it\'s referencing\",\"Date and number fields in Models based of a SQL question without variables can still be linked to filters in dashboards, but the filters will not work\",\"Join condition is not automatically selected\",\"The XLSX download for a pivot table should be pivoted\"]},{\"version\":\"v0.50.6\",\"released\":\"2024-06-19\",\"patch\":true,\"highlights\":[\"Disable SQL analysis by default + turn off all QueryField backfills\",\"If you don\'t have access to the root collection but inner collections, you get permission errors in QuestionPicker\",\"Rework measure search performance events\",\"Goal lines displayed incorrectly when axis scale is not linear\",\"Remove FE code that checks `enable-query-caching`\",\"Field values remapping with mixed PK and a FK targeting the same PK is broken in public dashboards\",\"StreamingResponse cannot be cast to class clojure.lang.Associative\",\"Error while exporting a pivot table without columns in v50.x\",\"Bar chart per week not showing proper information on Timeline\"]},{\"version\":\"v0.50.5\",\"released\":\"2024-06-17\",\"patch\":true,\"highlights\":[\"capitalize the ‘U’ in user interface\",\"Fix spaces in dashboard move toast\",\"Fix tool-tip values not being scaled in waterfall charts\",\"Waterfall tool-tips do not correctly apply column value scaling\",\"fix: Remove help email from error diagnostic modal\",\"Remove help@metabase.com from Error Diagnostic Modal\",\"v0.50.x - \\\"scale: Timeseries\\\" not working with Oracle database - \\\"invalid time zone in DateTimeFormat(): +00:00\\\"\",\"Don\'t sync JWT registered claims as login attributes\"]},{\"version\":\"v0.50.4\",\"released\":\"2024-06-14\",\"patch\":true,\"highlights\":[\"Remove animation from buttons\",\"Make each tab in Admin / Performance a distinct route\",\"Update Macaw to fix double blank lines\",\"Command Palette docs url is wrong\",\"Adding snippets back into getCollection\",\"Move `syncColumnSettings` to `metabase/visualization`\",\"\\\"Not able to modify the internal user\\\" for example dashboard creator user\",\"0.50.0 line graph with multiple series all jumbled up\",\"After updating to 0.50.0 the errors comes, some of fields turns to unkonw\",\"Post-aggregation filters mess up histograms where x-axis is a binned number\"]},{\"version\":\"v0.50.3\",\"released\":\"2024-06-13\",\"patch\":true,\"highlights\":[\"Users with No Access to the Collection Our Analytics are not able to use the Query Editor for Saved Questions/Models\",\"Comma in quoted string during CSV upload: CSV error (unexpected character: ,)\",\"Remove \'animate\' and \'highlightOnHover\' props\"]},{\"version\":\"v0.50.2\",\"released\":\"2024-06-12\",\"patch\":true,\"highlights\":[\"Model persistence tab in Performance should be available on OSS\",\"Error migrating to the 50.0 with the database connection encrypted\",\"\\\"Manage database\\\" perms incorrectly show up on the schema-level permissions page\"]},{\"version\":\"v0.50.1\",\"released\":\"2024-06-12\",\"patch\":true,\"highlights\":[\"After upgrading to 0.50, all non-admin users are facing error message : ERROR: syntax error at or near \\\")\\\" \",\"Switching from a `stack - 100%` chart to a line chart causes the line chart to break\",\"Cannot interact with the scrollbar in the suggestions list\"]},{\"version\":\"v0.49.15\",\"released\":\"2024-06-11\",\"patch\":true,\"highlights\":[\"bugfixes\"]},{\"version\":\"v0.49.14\",\"released\":\"2024-06-05\",\"patch\":true,\"highlights\":[\"Fingerprint of Large Binary Fields Crashes Metabase\",\"Catch exceptions from driver/database-supports? outside driver code\",\"Normalizer interprets \\\"expression\\\" as a MBQL :expression, but it is just a column name\",\"When Filtering with Dates Coerced from Numeric Fields in a Table Visualization - Filter Sometimes Disappears\",\"Fail during upgrade from 48.3 to 49.7\",\"Filtering Issue on UUID Column in Version 0.49.0\"]},{\"version\":\"v0.49.13\",\"released\":\"2024-05-29\",\"patch\":true,\"highlights\":[\"[serdes] unify snowplow analytics in a single event\",\"Trend charts should break down gracefully on missing data\",\"Azure AD SAML and SLO logout error\",\"Error when importing MongoDB database with collection having nested fields with more than 1 level of nesting\"]},{\"version\":\"v0.49.12\",\"released\":\"2024-05-24\",\"patch\":true,\"highlights\":[\"Fix `report_card.collection_preview` in v49\",\"Correct type for `report_card.collection_preview`\",\"🤖 backported \\\"fix: border appearing on night theme if bordered=false\\\"\",\"Use `db` argument in `driver/database-supports?` for uploads\",\"Pivot table becomes broken if a breakout clause is added without visualizing the question\",\"Clicking existing filter breaks question based on model\",\"fix: border appearing on night theme if bordered=false\",\"Cannot duplicate or save questions when moving from 42 to 49\"]},{\"version\":\"v0.49.11\",\"released\":\"2024-05-16\",\"patch\":true,\"highlights\":[\"Upgrade redshift dependency version\",\"Realize DB transient rows in after-select hook before calling `driver.u/features`\",\"[docs] Jessica\'s onboarding feedback\",\"Fix metadata loading issues after tabs\",\"Metabase can\'t decrypt the data when adding an encryption key after a failed migration \",\"Error in migration on upgrade between 48-49 due to encryption key\",\"docs - add 49.10 to list of releases\",\"More upload test changes for clickhouse\",\"After #39120 , Dashboard subscription\'s Japanese filename of attachment is broken\",\"Make json parsing more efficient on the JSON unfolding feature \"]},{\"version\":\"v0.49.10\",\"released\":\"2024-05-13\",\"patch\":true,\"highlights\":[\"[docs] add 48.13\",\"Columns are excluded from the unformatted option when downloading\",\"[docs] Clarify how optional SQL vars work\",\"[docs] see publicly shared content\",\"[docs] Fix format in CLI docs\",\"[docs] add 49.9 to list of releases\",\"Pie chart tooltip \\\"Other\\\" group produces NaN%\",\"[docs] Serialization docs update\",\"Pie chart sometimes disappears\",\"Disable cypress log to bypass out of memory issue\",\"Cannot import dashboards with circular click behavior\",\"Disable /api/health logging via an env var\"]},{\"version\":\"v0.49.9\",\"released\":\"2024-05-09\",\"patch\":true,\"highlights\":[\"Upgrade redshift driver in v49 to v26\",\"Fix flaky question management e2e test\",\"allow using urls from other columns in link templates\",\"[docs] Update environment-variables.md: fix typo re: MB_JETTY_SKIP_SNI\",\"docs - fix broken link\",\"Fix overflow problem in Filter Modal sidebar\",\"Fix failed to upgrade when instances have obsolete 3rd party drivers\",\"Allow drivers to not automatically add a PK column for CSV uploads\",\"attempt to type the return value of actions created by createThunkAction\",\"[docs] Updating table settings \",\"Snowflake: fix sync dynamic table\",\"Use database-supports? instead of hard-coded driver in `dataset-with-custom-pk-test`\",\"Added Key Authentication Option to SSH Tunneling Docs\",\"[docs] Add TOC to a few articles\",\"[docs] remove trailing slash from SSO docs\",\"docs - add 49.8 to list of releases\",\"docs - update filter docs\",\"[docs] A bit more details about API\",\"[docs] Add Pathway for Email Settings Configuration\",\"Unable to filter on MongoDB ObjectId type fields if configured as Entity Key\",\"BigQuery - Can\'t sync materialized views since 1.49.0\",\"docs -  generate environment variables\",\"Embedding Preview doesn\'t behave like Metabase Application when filter is locked and linked\",\"Azure AD SAML and SLO logout error\",\"Migration on MySQL/MariaDB leads to having multiple revisions with latest=true which leads to repeated items in the FE\",\"docs - field type metadata\",\"[49.1] impossible to filter on IDs identified as Identity key (PK)\",\"ERROR async.streaming-response when Jetty SSL enabled\"]},{\"version\":\"v0.49.8\",\"released\":\"2024-05-02\",\"patch\":true,\"highlights\":[\"🤖 backported \\\"Redshift and Oracle test sync: do not use hack\\\" and \\\"Faster driver/describe-database for redshift\\\"\",\"Snowflake temporal extract operators like `hour-of-day` do not respect report timezone\",\"Slack integration uses a deprecated API\",\"Snowflake always returns times truncated second precision, we should fix this for tests\",\"Snowflake UNIX timestamps interpreted as being in report timezone rather than UTC\",\"Issues connecting to Snowflake using RSA Keypair Authentication\",\"🤖 backported \\\"Fix queries being re-run because of broken parameters comparison\\\"\",\"Export input wrapper and remove label hack\",\"Date format \\\"January 31, 2018\\\" missing day in csv download\",\"Uploaded model not showing latest rows appended to the underlying table\",\"`SMTPConnectionForm`\",\"Serialization import should not die on seeing hidden .yaml files\",\"Default (formatted) CSV Export Returns \\\"Week #\\\" instead of Date\",\"Admin checklist indicates more progress than actual due to audit items\",\"Note the format_rows changes in the api changelog\",\"Upgrade react-draggable and react-dnd to 18 compatible versions\",\"Date Filtering Bug in v0.49.1 Docker Image with Japanese Locale Settings\",\"Switching between tabs reruns queries even if filters are not modified\",\"Google SSO with Interactive Embedding do not allow you to download CSV\",\"Filtering by a Specific Date in Snowflake will bring inaccurate results\",\"Use scientific notation on frontend multipliers\",\"Data mismatch between custom question and raw sql query with Redshift \",\"Support SAML and JWT logins at the same time\",\"Quarterly Date Filter different on Dashboard than on Question\",\"Snowflake JDBC driver incorrectly converts JDBC dates with a timezone\"]},{\"version\":\"v0.49.7\",\"released\":\"2024-04-23\",\"patch\":true,\"highlights\":[\"🤖 backported \\\"add validated migration checksums to v45 v46 v47 and v48\\\"\",\"🤖 backported \\\"add withUndos option to renderWithProviders to render Undos during …\\\"\",\"Date format \\\"January 31, 2018\\\" missing day in csv download\",\"Fix not sending necessary HTTP headers when downloading results\",\"Fix invisible user items in search filters\",\"docs - add redshift to list of dbs that support uploads\",\"Fix Embedded dashboard parameters parse runtime error\",\"Links to metabase URLs should open in the same window in link cards\",\"Default (formatted) CSV Export Returns \\\"Week #\\\" instead of Date\",\"Leading zero in filter value in embedded dashboard breaks it\",\"Don\'t say we\'ll cache archived models\",\"Archived models continue to be cached\",\"Migration doesn\'t like rows with null characters\",\"Primary Key missing filter options\",\"If a user is a member of multiple groups in the IdP, the user property is comma separated and we default to \\\"all users\\\"\",\"Date Filtering Bug in v0.49.1 Docker Image with Japanese Locale Settings\",\"Metabase renders the result but the query does not finish in the DB\",\"Illegal hex characters in escape (%) pattern - error at index 0 in: R6\",\"Cannot connect to new MongoDB source or sync existing databases\",\"Overall link situation\"]},{\"version\":\"v0.49.6\",\"released\":\"2024-04-16\",\"patch\":true,\"highlights\":[\"Tab query param not applied in embed\",\"Borders not respecting bordered=false parameter for static embedding\",\"Add INFO log for each table being fingerprinted\",\"Progress visualizations don\'t show, except on dashboards\",\"Wrong suggested join condition when joining 2 models\",\"Advanced option to turn off syncing field values doesn\'t work\",\"Progress visualisation not working, gives an error\",\"Text filters shown as input box in embed instead as dropdown\",\"SIGTERM during migration does not cleanly abort migration\",\"CSV upload support for Redshift \"]},{\"version\":\"v0.49.5\",\"released\":\"2024-04-11\",\"patch\":true,\"highlights\":[\"When exporting to CSV (or JSON or XLSX) from an embedded report, the file only contains \'Unknown parameter :format_rows.\'\",\"Downloading results of an embedded question (via iframe) fails because of \\\"Unknown parameter :format_rows\\\"\",\"Fix naming a filter offset or limit breaks dashboards\",\"Notebook query preview exists even before the data source is selected\",\"Incorrect results from SQL query referencing saved question with more than 1,048,575 rows\"]},{\"version\":\"v0.49.4\",\"released\":\"2024-04-10\",\"patch\":true,\"highlights\":[\"Signed Embedding without Title will remove all the tabs of a dashboard as well\",\"SQL generated for datetime \\\"is empty\\\" filter on MSSQL is not correct\",\"[MBQL lib] Don\'t enforce expression types when converting from legacy\",\"Casting integer to Datatime via Table Metadata makes column unusable \",\"asynchronously load libraries for png and pdf exports\",\"🤖 backported \\\"[QP] Correctly find joined fields in the previous stage\\\"\",\"\\\"No method in multimethod \'coerce-temporal\' for dispatch value: [nil java.time.LocalDateTime]\\\" when evaluating null datetimes\",\"Fix naming a filter offset or limit breaks dashboards\",\"Bigquery: Can\'t search field values for required partition tables\",\"Iframe embedding overflow widgets issue\",\"GUI model joining native ones break with column not found error\",\"Waiting for result tab title contains js code\",\"State of the FE gets lost on detail views when there are multiple joins to the same tables\",\"Manually choosing Axis in chart settings will break subscription\",\"Embedding height is not dynamic\",\"Fix \\\"instace analytics\\\" typo\",\"View Details: \\\"is connected to:\\\" uses wrong PK for query with join\"]},{\"version\":\"v0.49.3\",\"released\":\"2024-04-02\",\"patch\":true,\"highlights\":[\"Hovering a column header when joining two models crashes the visualisation\",\"Public dashboards no longer allow titled=false in url parameters (only allows true)\",\"Update Translations Strings for 49.3\",\"Throttle reset_password endpoint\",\"Setting `Hide this card if there are no results` at Dashboard level will remove it from the subscription even if there are results\",\"Handle invalid file drop\",\"Add `location` and `effective_location` to search\",\"model indexing: clear errors in success pathway\",\"Get rid of database connection help banner\",\"Should not use formatting for JSON results downloads\",\"Location on search endpoint\",\"Allow running native queries with required parameters and no defaults\",\"Filtering Issue on UUID Column in Version 0.49.0\",\"Switching between tabs reruns queries even if filters keep unmodified\",\"We\'re sending twice the necessary number of requests on x-ray first load\"],\"announcement_url\":\"https://www.metabase.com/releases/metabase-49?utm_source=product&utm_medium=banner&utm_campaign=49-announcement\"},{\"version\":\"v0.49.2\",\"released\":\"2024-03-28\",\"patch\":true,\"highlights\":[\"LDAP no longer works on OSS\",\"Dashcards from other tabs show up in the first one after entering and leaving editing mode\",\"Handle invalid file drop\",\"model indexes error when values are removed\",\"fix normalized chart crashes when trend lines enabled but there is no insights data\",\"Sort official collections first in API endpoints\",\"Common Metrics gone after Summarising by some other column\",\"Fix unable to migrate to 49 due to v49.00-059 migration\",\"Increase rate limit of actions from 1 to 10 per second \",\"Attaching CSV files to a subscription leads to a NullPointerException\",\"Often SLO won\'t be setup on the IdP but we should still delete the session.\",\"If there are new columns in the data source after the question was saved, they are hidden by default\",\"Cannot save a question based on another question after converting to SQL\",\"Redshfit: sync tables with partial select permission\",\"Restore logo margin\",\"Formatter Gives correct year for dates near start/end of Year\",\"Fix missing columns after query fields update\",\"Field filter breaks native question on dashboard\",\"Fix N+1 in checking write permission for collection\",\"postgresql tables that are visible through column grants aren\'t available for simple questions\",\"Specific date filter shifts dates by one day\",\"Group managers cannot view all people \",\"Exporting date values changes the year\",\"Copying and pasting values from a spreadsheet to a filter and insert a unique value\",\"Parameter filter widget jumps and doesn\'t allow to pick a value\",\"Order of collection should be the same as the collection sidebar\",\"Trend viz might not appear correctly on alerts\",\"Filtering by a Specific Date in Snowflake will bring inaccurate results\",\"funnel chart does not work in static viz\",\"Whitespace symbol breaks suggestions\",\"Model Caching stuck in \\\"pending\\\" state not cleared out by next scheduled refresh\",\"Duplicate column name error when exploring results of native query with join\",\"Show more billing info on license and billing settings page\",\"Getting errors in the truncate log task Caused by: java.lang.ClassNotFoundException: metabase.task.truncate_audit_log.TruncateAuditLog\",\"Include filters when exporting dashboard to PDF\",\"[MLv2] [BE] [Bug] `returnedColumns` does not handle columns with the same name\",\"Scrolling issue in sort dropdown with many values\",\"Export to PDF should have the filter values that were used on the dashboard\"]},{\"version\":\"v0.49.1\",\"released\":\"2024-03-21\",\"patch\":true,\"highlights\":[\"Cannot save a question based on another question after converting to SQL\",\"QB header jumps when switching between a simple and a notebook modes\",\"There is an additional border between the notebook and the query builder header\",\"Add Dimension field error handling\",\"Copying and pasting values from a spreadsheet to a filter and insert a unique value\",\"Allow running native queries with required parameters and no defaults\",\"Improve homepage experience for embedding users\",\"Wide logos cover the icon to collapse the sidebar\",\"PNG dashboard card download doesn\'t do anything in MacOS Safari\",\"Inconsistent spacing around table and schema divider\",\"Data source is not initially highlighted for nested questions and models once their source is moved to a different collection\",\"Can\'t enlarge preview section while creating a model\",\"[Epic] Highlight the selected data source in the notebook editor\",\"Getting fields in (Redshift) is slow\",\"Null values applied to filters with empty values in custom url from Click Behavior\",\"Zoom in from dashboard change visualization\",\"Updated native models may lose their result set metadata\",\"Can\'t use drag bar between editor and result pane while editing a model\",\"Snowflake alternative hostname implementation\"]},{\"version\":\"v0.49.0\",\"released\":\"2024-03-14\",\"patch\":false,\"highlights\":[\"Remove Models from Browse data\",\"Download Updated Translations for v49\",\"Apply Filters button cropped when a lot of values\",\"49 backport: Faster sync-fks for redshift (#38970)\",\"Elevate selected filter field values\",\"🤖 backported \\\"[QP] When querying a bare model with parameters, wrap an extra stage\\\"\",\"Remove browse data > models from the release\",\"🤖 backported \\\"[MLv2] Include implicit joins for breakout/order on models\\\"\",\"[QP] When querying a bare model with parameters, wrap an extra stage\",\"No view logging for oss\",\"Dashboard ID filter does not work on models\",\"Data source is not properly highlighted for simple saved questions based on a table in a multi-schema database\",\"Only return helpText for supported features\",\"LDAP logging is non existent\",\"Browse database page refreshes N seconds when a new db is added that makes the page unusable\",\"Cannot see Models as the data source in the data selector when opening a model\",\"Implicit joined fields are not available as breakouts in Models\",\"[chain filters] should not be using inactive fields for joins\",\"Join performance issues\",\"Introduce describeWithSnowplowEE\",\"Fixes after css modules migration\",\"[MLv2] `joinable-columns` on a Join sets source and alias\",\"🤖 backported \\\"[QP] Fix confusion of expressions with the same name as columns\\\"\",\"[QP] Use the alias for unfolded JSON columns from previous stages\",\"switch back to ring-jetty-adapter - addresses security issue\",\"Top nav + New and Settings buttons lock up when a dashboard is loading\",\"update deps with security issues\",\"Don\'t delete \\\"off\\\" persisted_info records\",\"[QP] Fix confusion of expressions with the same name as columns\",\"Fix wrong icon colors\",\"Remove unused global css\",\"Delete all pruned persisted info records\",\"Required filters: track when a filter is made required\",\"[FIX: #39152] Public links refer to `null` when question is new\",\"Add the timestamp to the filename in the subscription attachment\",\"[MLv2] Ensure `:name` is unique on returned columns in the FE\",\"Preview results of intermediate stages are wrong in query builder\",\"Grouping by and summarizing on a custom column fails\",\"Update required parameter reset icon\",\"Custom columns that have same name as existing columns cause failure\",\"[MLv2] Handle `Object.isFrozen()` legacy columns as input\",\"38811 no global css 1\",\"Interactive embedding dashboard with multiple tabs and parameter `header=false` will not load\",\"Uploads: 01/01/2012 is coerced to 1\",\"Unknown error in the revision history of a dashboard leads to a NullPointerException\",\"Filter picker search free input\",\"Wrap literals around expression refs\",\"Sidebar loading state regression fix\",\"Appends follow-up UI fixes\",\"Improve logging for Serialization Failures\",\"Add Creator Sentiment Email task\",\"Browse models: refactoring\",\"Toast/notification after custom dashboard has invisible text\",\"Browse models: expandable/collapsible collections\",\"Fix isNavigationAllowed\",\"Trend Chart font is incorrect in certain email clients\",\"seeing scrollbars in search and admin\",\"Browse models: Add filters\",\"Type routing in State\",\"\\\"Add tab\\\" button is covered with a right scroll button on dashboards with many tabs\",\"Models In Browse Data Follow Up\",\"Default enable-public-sharing to false for existing instances, and true for new ones\",\"add section icon and use in dashboard edit mode\",\"Instance Analytics titles drop after page load\",\"Add filters to Browse models\",\"Update auditv2 content for 49\",\"Improve look of models in Browse data\",\"Show more billing info on license and billing settings page\",\"[MLv2] Add description and fingerprint to `displayInfo` for columns\",\"Add a link to Metabase Analytics -> Question overview / Dashboard overview in the question/dashboard detail page\",\"Issue with click Behavior and passing filters to custom destinations that are tabs of the same dashboard\",\"[Epic] Add connection impersonation to Redshift\",\"FE: add UI for uploading from collections list\",\"Migrate the FieldInfo card to Mantine so it can be reused\",\"No option to hide/show tabs in Interactive embedding as a parameter. header=false will hide all tabs and go to tab 1 by default\",\"Export formatting for Longitude & Latitude\",\"[MLv2] Add caching for the common case of visible-columns w/o options\",\"[MLv2] Cache JS -> CLJS metadata conversion\",\"Send a Snowplow event to track Serialization\",\"Fix TableBrowser flex\",\"[MLv2] Add tests and fix a special case for fk-filter drills\",\"[MLv2] fk-details drill should preserve `:=` filters for other PKs\",\"[MLv2] Drill-thru coverage: Add a structured column and fix that case\",\"load analytics only when changed using a checksum\",\"Dashboard saves fails after adding the first tab then canceling the edit\",\"[MLv2] Fix some edge cases and add more unit tests for zoom in drills\",\"Unsaved dashcards with mapped params error when switching tabs\",\"[Epic] Meet embedders at the door - minimal edition\",\"Extreme slowness while editing parameters on a dashboard\",\"update graalvm\",\"[MLv2] New \\\"canned\\\" queries and clicks for drill-thru testing\",\"[Epic] Add Sections (pre-defined layout of empty dash cards) to Dashboard\",\"Let creators duplicate dashboards tabs and cards\",\"specify one more guava explicitly\",\"Add intermittent test solver\",\"Add BE for routing billing status\",\"More tidying prior to Models in Browse Data\",\"Port LastEditInfoLabel\",\"Initial tidying before Models in Browse Data\",\"Add stress testing workflow for frontend unit tests\",\" Optimise autocomplete query\",\"Sorting Dashboard Tabs has a weird animation on drop\",\"Canceling editing a dashboard does not reset current tab\",\"Cannot \\\"filter by this column\\\" \",\"\\\"Is\\\" filter in the header of the columns in a table context should be linked and allow free input\",\"[MLv2] Add `isTemporalExtraction` flag to `displayInfo`\",\"Add a banner to the top of `locales.clj`\",\"[MLv2] Add `aggregation-column` and `breakout-column`\",\"[MLv2] [BE] `findMatchingColumn` does not find matching column\",\"Add `align-temporal-unit-with-param-type-and-value` multimethod\",\"Changing groups or dbs on data permissions, after saving a value causes the client to falsely believe that someone else edited the perm graph\",\"update deps\",\"Refreshing after setting a table to be sandboxed causes an error\",\"[MLv2] Look up FK columns in `visible-columns`, not metadata\",\"[MLv2] Make `query=` treat missing `:base-type` as matching\",\"Required parameters: add to native queries\",\"Basic version of Models in Browse Data\",\"[MLv2] [FE] findColumnIndexForColumnSetting and findColumnSettingIndexForColumn\",\"[MLv2] Add `display-info` for queries\",\"[MLv2] [BE] [Bug] Make `query=` ignore absense of `base-type` and `effective-type` in field references\",\"Add anonymous usage tracking for relevant white-labeling\",\"[MLv2] Add `legacy-column->metadata` for converting `DatasetColumn`\",\"Pie chart legend percentages are vertically not aligned with their label\",\"[MLv2] [FE] Migrate data reference\",\"[MLv2] [FE] Migrate object detail\",\"[MLv2] Add `compatible-type?` wrapper that handles JS `DatasetColumn`s\",\"Delete API keys when their group is deleted\",\"[MLv2] [BE] [Bug] `returnedColumns` does not handle columns with the same name\",\"[MLv2] [FE] Remove aggregate, breakout, filter methods from Question\",\"[MLv2] [FE] Migrate supportsImplicitActions\",\"[MLv2] [BE] [Bug] Question filters are not being updated if there are breakout clauses for the same column\",\"[MLv2] [BE] [Bug] Support constants in expressions\",\"[MLv2] [FE] Migrate QuestionDataSource\",\"[MLv2] [FE] Migrate initializeQB\",\"[MLv2] [BE] Make displayInfo for column groups straightforward to use\",\"Dashboard filters are slow\",\"Avoid failing call to /api/model-index\",\"Error if DB downgrades are required\",\"Add last_name to ApiKey users\",\"CSV appends: append through model page\",\"[MLv2] [BE] [Bug] `filter-args-display-name` doesn\'t handle exclude date filters\",\"Update enterprise readme to 2024\",\"Flaky QueryBuilder.unit.spec.tsx\",\"[MLv2] [Testing plan] Custom columns\",\"[MLv2] [FE] Migrate `setDefaultDisplay` to MLv2\",\"[MLv2] [FE] Migrate `_syncStructuredQueryColumnsAndSettings` to MLv2\",\"[MLv2] [FE] Migrate `sourceTableId`, `sourceTable` to use `sourceTableOrCardId` from MLv2\",\"[MLv2] [FE] Migrate `databaseId`, `database` to use `databaseID` from MLv2\",\"Bug when using custom columns to do filters for the past 1 day/month/year\",\"`Admin > People` header \\\"jumps\\\" when switching from active and deselected users views\",\"RFC: kondo lint to enforce naming convention for thread not safe defn/defmacro in tests\",\"[MLv2] [BE] Add `breakoutColumn` and `aggregationColumn` APIs to simply columns retrieval from these clauses\",\"Oops - remove API bits from ApiKey model\",\"[MLv2] Resolve a string `:fk-field-id` to a numeric ID if possible\",\"Return `group` instead of just `group_name` for ApiKeys\",\"Add a DELETE endpoint for API Keys\",\"Test some modals more semantically\",\"Add SegmentedToggle component from mantine\",\"Write a `GET /api/api-key` endpoint to list API keys\",\"Write a `PUT /api/api-key/:id/regenerate` endpoint to regenerate an existing API key\",\"Write a `PUT /api/api-key/:id` endpoint to update API key names/groups\",\"Tighten visual design of charts\",\"[MLv2] [BE] Remove unused legacy MLv2 functions\",\"count `:model/User`, not `:core_user`\",\"[MLv2] Notebook steps\",\"[MLv2] [BE] Add a flag to `displayInfo(query, stageIndex, temporalBucket)` indicating it\'s for an extraction temporal unit\",\"[Epic] Help white-labeling admins remove links to metabase.com outside of admin settings\",\"[MLv2] Drop redundant :fields clauses from stages and joins\",\"Bigquery sync partitioned fields\",\"[MLv2] Fix an edge case where a join-alias is needed on a field ref\",\"When updating an alert, don\'t also update the question\",\"“contains” and “does-not-contain” returned for the wrong fields\",\"[Epic] Serialization API\",\"FE support partial permissions graph\",\"Fix dashcard-filter connection edge cases\",\"Add \\\"Replace question\\\" action to dashboard cards\",\"[MLv2] [FE] `View` - remove `BreakoutPopover` usage\",\"[MLv2] [FE] `View` - remove `AggregationPopover` usage\",\"FE: remove normalization from legacyFieldRef method once BE is ready\",\"FE - address the issue with segments in suggest.ts once products/QP provides a fix\",\"[MLv2] Reorder column filter and distribution drills\",\"BE: MLv2 Add support for segment and metric in legacyFieldRef\",\"[MLv2] [BE] removeClause throws \\\"Cannot remove the final join condition\\\" error\",\"Bigquery sync table require filter\",\"[MLv2] [BE] [Bug] `column-filter` should come before other column drills\",\"[MLv2] [BE] Add `sourceTableOrCardId(query)`\",\"[Epic] Bigquery: Sync required partition column\",\"[MLv2] `fk-filter` drills should not appear on native queries\",\"CSV appends Milestone 0, Merge 1 of 2: add endpoint to append to table\",\"FE: remove legacyQuery (clean-up)\",\"Add junit.xml to .gitignore\",\"Sync index info: mongo\",\"Cancelled Queries are retried with Bigquery Driver\",\"Fix permissions graph performance\",\"[MLv2] Track drill-thru unit test coverage\",\"Auth with API Key\",\"[MLv2] [BE] When modyfing the \\\"fields\\\" clause, remove the clause entirely if it becomes equivalent to not having the clause at all\",\"Consistent Date and Time Formatting for `metabase.formatter.datetime`\",\"Apply Consistent Formatting to Excel Artifacts\",\"Apply Consistent Formatting to JSON Artifacts\",\"adding perm-graph filtering on db or group id\",\"[MLv2] Unskip FE integration tests for automatic-insights drills\",\"[Epic] Let creators make dashboard and native query filters required\",\"[MLv2] [FE] `NotebookSteps`, `steps` - migrate modifying queries to MLv2\",\"[MLv2] Fix pivot drills integration with the FE\",\"Let creators swap out dashboard questions with a different question\",\"[Epic]Embedding settings cleanup and surface interactive embedding Quickstart \",\"Dashcard text gets cut off\",\"Sync index info\",\"[Epic]  Sync column index information\",\"[MLv2] Implement `automatic-insights` drill\",\"Make dashboard subscription attachment behavior match the user\'s choice in-product\",\"\\\"View details\\\" (PK) drill thru on non-PK value for a row with multiple PKs only adds a filter for one of the PKs, nondeterminiate\",\"FE: Add types to parseDimension\",\"Error calculating display info on filtering with a model\",\"[Epic] Let admins disable user provision on SSO\",\"Default dashboards to a fixed width to give creators a more predictable canvas\",\"Write a `POST /api/api-key` endpoint to create an API key\",\"Ensure consistent percentage formatting across FE and pulses\",\"Ensure results metadata is applied to standalone cards in pulse HTML output\",\"Ensure results metadata is applied to csv files in pulse exports\",\"png export of chart from a dashboard includes the menu ellipsis in the top right corner of the image\",\"FE- Migrate functions used in ExpressionEditorTextfield to MLv2 query\",\"Allow toggling of the dashboard subscription sidebar from the icon\",\"Create a test to prevent serialization bugs with new settings\",\"FE/BE?: second stage shows the wrong name (Total: binned)\",\"FE - Migrate `suggest.ts` to use MLv2 for computing columns\",\"[MLv2] [BE] Support changing expressions in the query w/o removing parts depending on the original\",\"[MLv2] [BE] [Bug] `zoom-in.timeseries` isn\'t returned in all known cases\",\"[Epic #35961] Milestone 2 - Create the Embed Modal\",\"CSV upload support for Redshift \",\"Merge viz settings correctly\",\"Merge metadata correctly\",\"[Epic #35961] Milestone 1 - Refactor Public Links and Static Embed Flow\",\"[Epic] Create a unified rendering pipeline for formatting\",\"FE - Convert ExpressionStep to MLv2\",\"[Epic] Setup flow for static/public embedding & embedding feature discoverability \",\"FE - Expressions in FilterPicker without legacy query\",\"FE - Expressions in AggregationPicker without legacy query\",\"MongoDB nested fields not showing in v0.47.x\",\"[Epic] White-labeling: Customizing or hiding “Help” link\",\"Refactor drills unit tests structure, split huge file by drill type\",\"Migration to remove the legacy pulses\",\"[MLv2] [BE] [Bug] `drill-thru/pk` drill should be returned for query that has multiple PKs on non-PK columns click\",\"[Epic] Allow appending more data to CSV uploads\",\"Support arbitrary date comparison\",\"Export to PDF should have the filter values that were used on the dashboard\",\"[MLv2] [BE] [Bug] `underlying-records` is not available for pivot table cell\",\"[MLv2] [BE] [Bug] `underlying-records` should be returned for chart legend clicks\",\"Action Button label cut off when editing click behavior\",\"Add percentage type to metadata\",\"Visual glitches when dragging a tab on another\",\"Date filtering on time-series viz is not available when the second grouping field is not a category type\",\"Date filtering on time-series viz only works if time is added as a first grouping category\",\"Redundant text card scrollbars shown in Firefox\",\"Execute an Action on embedded Dashboard fails with 404 not found API call\",\"Description for calculated columns in model metadata editing page is incorrectly populated with description from other columns\",\"Bookmark icon should be correct size; and should be filled when an item is bookmarked\",\"[Epic] Remove Pulses while warning customers about it\",\"Version info could have duplicated versions\",\"Unify type of timestamp columns\",\"Relative date filters don\'t work with custom date columns\",\"[Epic] Trend chart improvements\",\"SAML auth page is weird when set by env vars\",\"Role level security for Redshift\",\"Add new AWS global bundle certs for RDS\",\"Increase design control over Big Numbers (Trend Chart)\",\"Make Dashboard filters global or tab specific\",\"Autosuggestion in native queries peaks the CPU on instances with > 1M fields\",\"Dashboard Email Subscription seems to cache incorrect settings\",\"Wrong field highlighted when editing model metadata if custom column added to left of column\",\"Query metadata within comments leads to cache misses in AWS Athena\",\"[Epic] Metabase Lib v2\",\"[Epic] Honey SQL 2 Migration, Continued [47-49]\",\"Remove Honey SQL 1 as a dependency\",\"Migrate `:sqlserver` driver to Honey SQL 2\",\"Migrate `:presto` and `:presto-jdbc` drivers to Honey SQL 2\",\"Migrate `:bigquery-cloud-sdk` driver to Honey SQL 2\",\"Joining on aggregated dates via the editor generates \\\"No matching signature for function TIMESTAMP\\\"\",\"Pivot table with the filter on a date column breaks dashboard sending\",\"Aurora Serverless v2 fails to verify CA due to RDS Combined CA Bundle not importing all certificate chains\",\"Monger does not support Atlas Serverless\",\"Custom Column in Models doesn\'t respect filtering when binning is applied\",\"Adding a description to a model column duplicates the description to other columns if they are null\",\"Trend text not translated correctly depending on period\",\"Click Behavior not working for Pivot Table (and Table pivoted) for the non-value columns\",\"Sticky filters on Embedded/Public dashboards\",\"Date filter selection from the chart footer is glitchy and results in wrong selection\",\"Compute results of timestamp/current-date functions during query processing\",\"Make effective use of Snowflake\'s query result caching\",\"Option to rollback changes in failed serialization load\",\"On Date filter returns no results on a summarized question\",\"Renamed columns in CSV/JSON exports\",\"Allow to configure mandatory filters in Dashboards\",\"Exports should include formatting everywhere\",\"`Between` filter errors out with min > max \",\"[`result_metadata`] Implicit binning on longitude from SQL question results in error\",\"CSV exports of timestamps at midnight (00:00:00) is truncated to date\",\"Grid Map \\\"Zoom In\\\" broken for \\\"Custom Questions\\\"\",\"Smart Numbers: chose the unit of the lag displayed\",\"Fixed width dashboard option\",\"Smart numbers: configurable lag\",\"Proposal: Format SQL Query option in the Native Query Editor \",\"Smart Number visualization wording\",\"Datetime filter not working correctly (on mysql)\",\"Printed Dashboard is missing Color Indicators in the Legend\",\"Hitting enter doesn\'t save filter changes\",\"We should show progress charts\' current values on small dashboard cards\",\"Better UX for required missing parameters on dashboards\",\"[Epic] We should support an alternative API authentication mechanism\"]},{\"version\":\"v0.48.8\",\"released\":\"2024-03-04\",\"patch\":true,\"highlights\":[\"Forcefully reload table/card metadata when there are no fields (yet)\",\"Convert Dashboard header to functional component\",\"Enabling \\\"don\'t send if there aren\'t results\\\" in a subscription won\'t send the text cards\",\"Hide the default maps\",\"Add entity-id to Serdes v1 as an optional flag\",\"Allow official collections inside personal collections\",\"Include filters when exporting dashboard to PDF\",\"Currency Data Type Is Not Inferred in Summarized Visualizations\",\"Default values are not respected for pinned questions in collections in v48\",\"Export to PDF should have the filter values that were used on the dashboard\",\"Pie chart wedge hover incorrectly displays total for wedges smaller than 0.30%\",\"Minimum slice percentage effects actual values on Pie charts\",\"Subscriptions will fail when parameter doesn\'t exists\",\"Cannot connect to Snowflake via SSH\"]},{\"version\":\"v0.48.7\",\"released\":\"2024-02-22\",\"patch\":true,\"highlights\":[\"We should never run get-field-values on a dashboard load if the field does not have field values in the metabase_fieldvalues table\",\"Update `group-by-week-test` to use database timezone id\",\"Date filtering change between v0.48.3 and v0.48.4. looks timezone related\",\"Relative date filter with time works in Field Filters different for SQL variables than for GUI\",\"Change native SQL datetime range field filters to be inclusive of the end minute\",\"Date filters giving inconsistent results, depends on filter mode \"]},{\"version\":\"v0.48.6\",\"released\":\"2024-02-13\",\"patch\":true,\"highlights\":[\"Custom Destination to Public Dashboard URLs is broken on Static Embeds\",\"🤖 backported \\\"Analytics should load only when changed, via checksum\\\"\",\"X-Ray failure with message \\\"Cannot determine source table...\\\"\",\"🤖 backported \\\"load analytics only when changed using a checksum\\\"\",\"ClassCastException: class clojure.lang.Keyword cannot be cast to class java.lang.Throwable\",\"Newly added MySQL DB tables not showing up, but old ones do show up\",\"Don\'t instrument any namespaces for mu.fn/fn in production\",\"Remove impersonation feature from Redshift driver\",\"Some relative date filters don\'t work for custom expression columns\",\"Ability to customize table row limit in subscriptions\",\"Date filters giving inconsistent results, depends on filter mode \",\"Metabot 2.0 failing when context length exceeded\"]},{\"version\":\"v0.48.5\",\"released\":\"2024-02-06\",\"patch\":true,\"highlights\":[\"Not able to switch between databases after a question is created\",\"Dashboard subscription for auto generated dashboards is broken\",\"CSV uploads: Expand valid date formats to include one digit days\",\"Reverting a query that has parameters to a previous version does not use the parameters on the reloaded dataset\",\"Trend chart gives misleading output for some date combinations\",\"Add Hebrew Language Support\",\"Mongo sessions do not work with hidden member deployments\",\"🤖 backported \\\"[MLv2] Add caching for all the `foo-columns` functions\\\"\",\"MB_UNAGGREGATED_QUERY_ROW_LIMIT is limiting in-product download queries\",\"[MLv2] Add caching for all the `foo-columns` functions\",\"Summarizing timestamps by month handles time zones incorrectly in Snowflake\",\"\\\"Run selected text\\\" in Native editor does not include filter widget value and can return incorrect results\",\"Native query has 2000 limit even for aggregated data\",\"CSV/Excel attached file in Pulses is truncating to 2000 rows.\"]},{\"version\":\"v0.48.4\",\"released\":\"2024-01-29\",\"patch\":true,\"highlights\":[\"Exclude metabase.sync* and metabase.upload* from malli instrumentation\",\"NPE in `metabase.driver.sync/schema-patterns->filter-fn*`\",\"Settings with default of `false` now return null\",\"Metabase won\'t see schemas other than public or the default namespace of the user in snowflake\",\"switch to regenerator-runtime and update follow-redirects to silence Snyk warnings\",\"CVE updates: lambdaisland/uri, aws sdk (for ions), specify guava for googleanalytics\",\"🤖 backported \\\"Handle multiple date filters for the same template tag\\\"\",\"Field values cache needs to check permissions\",\"Upgrade `jsrsasign` to `v11.0.0`\",\"Handle multiple date filters for the same template tag\",\"Dashboard Time Filters Don\'t Work for Cards with SQL Date Variables\",\"Initializing MB from a config file is broken\",\"Don\'t try to compute `query-hash` for cards without queries\",\"Fix race-condition that could revert (un)subscriptions\",\"Text filters shown as input box in embed instead as dropdown\",\"We index the audit v2 views on instances that don\'t have the audit features\",\"site-uuid changes \",\"Handle an error of building UI parameters during dashboard fetching\",\"Unable to translate string \\\"{0} database {1} default timezone is {2}\\\" to fr\",\" 0.48.3 : SQL Server dynamic ports\",\"Database Permissions Display breadcrumbs don\'t handle schemaless DBs\",\"Some filters not working in v0.48.x\",\"Add personal-only to collection endpoint\",\"[MLv2] Add caching for all the `foo-columns` functions\",\"[MLv2] [BE] Cache xxxColumns functions\",\"Pass email and siteURL to metabase.com/help/connect\",\"Missing databasechangelog index for new instances\",\"[MLv2] Only allow implicit join on a column if its real ID is known\",\"Exclude snippet and card template tags from parameters returned from BE endpoints\",\"Malli.fn :: Invalid input in query-hash and select-keys-for-hashing\",\"Public native questions with snippets don\'t work\",\"Sync takes a massive amount of time to start\",\"Pivot visualization no longer displays after editing - \'invalid metadata returned\' error\",\"`displayInfo` returns unexpected result for a column group\",\"Can\'t Edit/Download question on a dashboard when Title is removed\",\"Search input in the filter modal gets focused on hover\",\"`qp.timezone/database-timezone-id` returns nil for `::db-from-store`\",\"Unable to update user first and last name when Google SSO used\",\"Split Axis not working for combo charts\",\"Update first_name and last_name when Google SSO used to login\",\"Greeting page briefly loads before redirecting to custom homepage\",\"Uncaught TypeError when setting custom click behavior for a question\",\"Typing on search bar before dashboard has finished rendering gets the search bar in non-functional state\",\"An alert set on a model reverts the models customized column names\",\"Can\'t re-order tabs with long names\",\"Visualization-specific question icons don\'t display on first load\",\"Default click behavior does not have selected state\",\"Ambiguous dashboard URL when filter is called \\\"tab\\\"\",\"Better debounce the SQL editor\",\"Custom homepage breaks search when used before redirect\",\"CSV upload icon will be gone after enabling CSV upload for the first time then go back to the collection.\",\"Env var to disable SNI check in Jetty\",\"Turn model caching on succeed but UI button doesn\'t update the text\",\"Discrepency in the unarchive UI between admins and non-admins\",\"Pinning a native question that references another question will fail to render\",\"Cursor didn\'t show pointer when passing the icon on mobile screen\",\"Possible to config or resend Email on EOF Error\",\"Pivot Table collapse/expand rows doesn\'t work for single question in Public/Embedding\",\"Login redirects to root, if already logged in and visiting URL like `/auth/login?redirect=..`\",\"Time column ignore formatting and always shows 12h-style AM/PM\"]},{\"version\":\"v0.48.3\",\"released\":\"2024-01-11\",\"patch\":true,\"highlights\":[\"Auditv2 prevented startup\",\"Restore GET /api/dashboard endpoint\",\"[Serialization] Skip Metabase Analytics and Custom reports collections when exporting content\",\"Validate json settings during init (#36182)\",\"Embeded dashboard takes longer and longer to display.\",\"Fixing case of invalid graph.dimension\",\"Slack integration failure on dashboard subscription\",\"Multi series questions won\'t get imported when using serialization\",\"CSV uploads: support more date formats\",\"Updating honeysql alias in dev ns\",\"Fix hsql import in dev.clj\",\"Invalid json for env variable settings breaks site\",\"Setting all reports to hide with no results breaks dashboard subscription\",\"Timestamp column be converted twice in 2-layer questions query  \",\"Number Visualisation show wrong field in dashboard subscription\",\"Snowflake driver won\'t use JDBC options\",\"Funnel charts with \\\"Month of Year\\\" type dimension and ordering can\'t render in Static Viz\"]},{\"version\":\"v0.48.2\",\"released\":\"2024-01-05\",\"patch\":true,\"highlights\":[\"Fix issue with model index search\",\"Subtracting two temporal values should yield an interval\",\"Caching not working for (all) mongo questions\",\"Fix card loading state in different tabs when parameters change\",\"Malli warning in metabase.models.recent-views/update-users-recent-views!\",\"show error and disable save button when create metric fails\",\"CSV upload support for Redshift \",\"Confusing copy in confirm modal when changing table data access to Sandboxed\",\"We\'re not signaling when a card is loading if you change the filters on a dashboard and switch tabs\",\"Number Visualisation show wrong field in dashboard subscription\",\"Ability to customize table row limit in subscriptions\",\"[Serdes v2] Error parsing JSON when exporting data model\",\"SparkSQL driver doesn\'t work well with capital database-types\"]},{\"version\":\"v0.47.10\",\"released\":\"2023-12-14\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.47.9\",\"released\":\"2023-12-01\",\"patch\":true,\"highlights\":[\"Upload configuration is not deserialized\",\"Bug fix: remove divider in QueryBuilder/ViewHeader when it\'s not needed\",\"Backport:  Handle CVE in commons-compress and org.json/json\",\"Handle CVE in commons-compress and org.json/json\",\"Syncs from Redshift failing since version 0.47.7\",\"Dashboards with pages sometimes appear blank when opened from bookmarks\",\"Export throws a Unexpected character (\'b\' (code 98))\",\"Use the official MySQL latest image for drivers tests\",\"serialization will fail if there\'s a snippet on destination with an already existent name but different entity id\",\"Blank strings in CSV uploads should be NULL in MySQL\",\"restore correct position when undoing dashcard tab movement or deletion\",\"Dashboard subscription attachment does not take into account the dashboardcard visualization settings\",\"Pivot viz fails on a nested question\",\"Static/Public embeds fail to load dashboard when one of the cards fails to load due to missing filter value.\",\"Exporting a child collection won\'t export the parent collection\",\"Queries not getting cancelled in MongoDB when leaving the page\",\"Serialization won\'t respect column sorting in pivot tables\",\"Pivot table with 2 group by\'s gets loaded incorrectly on serialization\",\"Dashboard parameter without field mapping have double borders\",\"Tables render slowly\",\"Serialization: Table columns with \\\"Display values\\\"=\\\"Use foreign key\\\" not always saved during `dump`\"]},{\"version\":\"v0.47.8\",\"released\":\"2023-11-17\",\"patch\":true,\"highlights\":[\"Backport:  fix exporting dashboard with configured click_behavior\",\"Fixing bad performance due to massive pprint statements\",\"Export throws a Unexpected character (\'b\' (code 98))\",\"Export throws a NullPointerException\",\"Fix serdes of click_behavior on dashcards\",\"returns 500 when visit an non-existing card\",\"A big warning that if you use CSV uploads in the sample database in the cloud, your data will disappear \",\"avoid calling fetchCardData in undoRemoveCardFromDashboard for virtual cards\",\"restore correct position when undoing dashcard tab movement or deletion\",\"Respect \\\"enable nested queries\\\" setting and database\'s \\\"nested queries\\\" feature\",\"Serialization `import` doesn\'t remove dashboardcards in the target instance \",\"Filters blink when there are many lines of filters in an embedded context with headers=false\",\"Users with read-only permissions to collections are shown \\\"edit question\\\" option in dashboard cards\",\"Text weirdly wrapped in column dropdown in Polish language\",\"Pivot viz fails on a nested question\",\"Add an option in the `/admin/settings/email` to opt-in to CC recipients\",\"\'-\' sign misplaced in shortened visualization of currency type\",\"Log why Serialization v2 fails when trying to export a dashboard that contains cards in outside collections\",\"Click behavior: dashboard and saved question links are not preserved during export / import\",\"Don\'t offer to create models or use nested questions on 3rd party drivers which don\'t support it\",\"e.some is not a function breaks the FE on the filter modal\",\"Linked fiters won\'t work if you use a question to populate filter values\",\"Disabled \\\"Nested Queries\\\" setting is not always respected\",\"Filter dropdown not showing remapped values on the dashboard\"]},{\"version\":\"v0.47.7\",\"released\":\"2023-11-07\",\"patch\":true,\"highlights\":[\"🍒 Manual backport of #34996\",\"Disable auto-commit (enable transactions) for read-only connections\",\"Graphing chart with date filter at 24 months is broken \",\"Serialization v2 export doesn\'t include parameter_card entity_ids which breaks the import\",\"Filters blink when there are many lines of filters in an embedded context with headers=false\",\"Dashboard reversion should skip cards that have been deleted or archived\",\"Serialization v2 duplicates entities loaded with serialization v1 on old versions\",\"Adding check for column before getting friendly name\",\"Dashboard filter Apply button does not follow column structure and shows up to right of other elements instead of below them\",\"MBQL v1 query breaks with boolean breakout\",\"Inconsistent display of numbers in Arabic locales\",\"Incorrect dialect is chosen for ClickHouse pretty SQL formatting\",\"Bar Chart visualization settings show an error and do not allow changes to be made\",\"Question in table view: Removing a field rearranges the entire table columns\",\" The title of the pdf exported by the dashboard is garbled in Chinese\",\"Custom expression that has a name consisting only of whitespace breaks the question\",\"New custom columns won\'t appear in a dashboard card with reordered columns (custom viz settings)\",\"Support subtracting intervals\",\"Scrolling doesnt update dragging on Visible Column configuration\"]},{\"version\":\"v0.47.6\",\"released\":\"2023-10-26\",\"patch\":true,\"highlights\":[\" Error: Field X is not present in the Query Processor Store.\",\"Selecting filter on date, then going back and selecting expression results in error\",\"Auto pivot is freezing query editor on high cardinality fields\",\"JavaScript TypeError when removing dashboard filter\",\"Can\'t go back with browser back button from \\\"Table metadata\\\"\",\"Large column names should wrap in the sidebar\"]},{\"version\":\"v0.47.5\",\"released\":\"2023-10-20\",\"patch\":true,\"highlights\":[\"Snowflake Database Setting allows you to input small caps role but breaks connection afterwards (used to work for both in 1.46.8)\",\"404 when downloading results on embedded questions on sub-paths\",\"Splitting multidimension questions that only have 1 metric\",\"The slack token is logged in plain text\",\"SQL autocomplete is hard to use because keywords are shown instead of tables and columns\",\"Event Icon for \\\"Balloons\\\" is a cake\",\"Replace `java-time` namespace with `java-time.api`\",\"Pivot Table Viz shows different output and calls different endpoints when saved VS being created \",\"d is not a function after latest update to v0.47.0 when enabling Show values on data points\",\"View-only native SQL question should hide SQL when browser back button used\",\"[Bug] Error occurs when performing \\\"Join data\\\" with fields containing \\\".\\\" character\",\"False \\\"Cannot read properties\\\" error appears sometimes when saving a question\",\"log() - logarithm function calculates wrong result in BigQuery because parameters backwards\",\"Nested questions get confused around custom columns that are just columns\",\"Click Behavior on ranges always parses single-date to destination question\'s filters\"]},{\"version\":\"v0.47.4\",\"released\":\"2023-10-11\",\"patch\":true,\"highlights\":[\"Update Apache POI\",\"`load-from-h2` fails on `master` with Command failed with exception: ERROR Clearing default entries created by Liquibase migrations...\",\"DashboardTab missing from `copy` command \",\"[Dashboard] Do not lose filters state on navigating back from Question\",\"Dashboard loses effective filter values when auto-apply is turned off\",\"Manual backport #33865 to 47\",\"We don\'t seem to be updating certificates when updating the connection\",\"Hardly visible expand icon on collection hover\",\"Postgres Custom Query Actions require explicit CAST() for date fields\",\"Spinners change color and fonts change on signed embedding while loading\",\"Corrupted dashboard filter makes it impossible to view the question (unless removed)\"]},{\"version\":\"v0.47.3\",\"released\":\"2023-10-03\",\"patch\":true,\"highlights\":[\"🤖 backported \\\"Use HTTPS when getting version-info\\\"\",\"Use HTTPS when getting version-info\",\"Can\'t apply category filters when a question has grouping and aggregation\",\"Summarizing or sorting in query editor after Exploring results in a SQL question and creating a Custom Column breaks query editor \",\"Other count displays incorrect value when Language set to Arabic or Arabic (Saudi Arabia)\",\"Backport #33898: Better deduplication for entities loader api queries\",\"Date filters - inconsistent filter values displayed when a question is opened from a filtered dashboard\",\"UI suggests it\'s possible to delete an archived collection\",\"Fix 33971: CSV uploads aren\'t possible when native query editing is disabled\",\"CSV uploads aren\'t possible when native query editing is disabled\",\"Search bar font size is too small on Safari\",\"bad gateway 502 for API via reverse proxy (POST request ignores \'location\' v0.47.2)\",\"Refactor useLeaveConfirmation hook to a component\",\"Summarizing by custom date column does not allow date grouping\",\"v.47-RC3 does not work custom range in conditional formatting\",\"[Epic] Provide a heads up when Metabase is upgraded with what’s new\",\"After hiding column in table settings on question based on another question, all joined columns unchecked in notebook editor when still selected\",\"Unable to add joined columns in table settings after removing through notebook editor on nested Question\",\"Inputting some values into Whitelabel \\\"Landing Page\\\" can cause the entire frontend to break\"]},{\"version\":\"v0.47.2\",\"released\":\"2023-09-18\",\"patch\":true,\"highlights\":[\"Performance regression in how we parse query_metadata response leads to notebook being unusable\",\"Clear cache when performing version upgrades\",\"Metabase will not let you update the cert if it was rotated\",\"Some table columns are unable to be rendered\",\"Download results (.csv, .json, .xlsx) request does not include subpath when deploying on subpath\",\"Table column is not visible in object detail view when its visibility is set to \\\"only in detail views\\\"\",\"Not possible to include time when filtering dates in dashboards\",\"Notebook Editor becomes very slow (or freezes browser), when there is a lot of fields/sections\"],\"announcement_url\":\"https://www.metabase.com/releases/Metabase-47?utm_source=product&utm_medium=banner&utm_campaign=47-announcement\"},{\"version\":\"v0.47.1\",\"released\":\"2023-09-07\",\"patch\":true,\"highlights\":[\"Remove unused \\\"No changes to permissions will be made.\\\" confirmation in `PermissionsEditBar`\",\"Don\'t delete a connection impersonation policy when non-data perms are updated\",\"Performance regression in how we parse query_metadata response leads to notebook being unusable\",\"Switch pulse email sending to use bcc instead of sending a seperate email\",\"Subscriptions should send a single email with all recipients in Bcc\",\"Wrong URL manipulation when configuring GTAPs when running on a sub path\",\"Change in Snowflake Driver adds a default role ACCOUNTADMIN instead of using user default\",\"Only log session cookie SameSite=None warning when connection is insecure\",\"Data Model Field Formatting settings should only show currency settings for currency fields\",\"Impersonated security: a user who does not have an attribute defined to access the database can see the data\",\"Role-based security at database level does not work if the role contains special characters such as the dot. (v0.47)\",\"Pie charts cut off in dashboard\",\"Link cards in dashboards shouldn\'t open in a new window unless you command+click them\",\"Question name not displayed when changing click behavior\",\"Show new syncing tables as greyed out in data reference page\",\"Invalid redirect URL when doing JWT SSO\",\"Redundant network requests triggered in object detail modal\",\"Some audit queries return empty results with an H2 application database\",\"Redundant separator displayed in table filter popup\",\"Empty column gets treated as series breakout in line chart\",\"Bottom corner radius on buttons looks weird on new dashboard grid\",\" Assert failed: No more than 1024 pending puts are allowed on a single channel\",\"[Epic] Update default and min size constraints for dashboard cards\",\"Inconsistent icon position in pinned dashboard item loading state\",\"Duplicating a model creates a new model that uses the original model\",\"Formatting for field in Data Modeling is no longer working\",\"Keyboard active when object detail modal is open\",\"Stale UI for the Official collections menu\",\"Do not prompt non-admin users to configure email or Slack\",\"Broken added series on dashcard prevents you from editing the card \"]},{\"version\":\"v0.47.0\",\"released\":\"2023-08-16\",\"patch\":false,\"highlights\":[\"Native parameters defaults change chart type after save or load\",\"X ray cards load bottom to top\",\"Deep copy dashboard with questions appends `-- Duplicate` with two dashes to duplicated questions\",\"Query actions won\'t work when the ID dashboard parameter linked with model ID and action parameter get values from the URL\",\"Columns with long names cause the visualization options sidebar to scroll horizontally\",\"Zero on axis not rounded, has many decimal places with single-row chart\",\"Nothing happens when clicking on search results in a link card\",\"Show new syncing tables as greyed out in data reference pane\",\"Flaky test - table popover should not be scrollable horizontally (metabase#31339)\",\"Action not found on dashboard on serdes v2\",\"side_nav=true does not work when going straight to a dashboard\",\"Bugs on People tab\",\"Basic model action names are not translated\",\"Can\'t clear dashboard description\",\"Metadata column formatting tab stopped working in v0.47.0-RC2\",\"Enable parameter substitution to Heading text cards\",\"Custom homepage search errors when previously set within the same session\",\"Update CSV permission check for \\\"Unrestricted\\\" access on the schema rather than any table\",\"Fade Link Cards in mapping mode\",\"Don\'t allow CSV uploads when sandboxing is enabled\",\"Cannot read properties of undefined (reading \'name\') when adding an incomplete card\",\"Don\'t offer to add new questions/ask new in a dashboard in a read-only collection\",\"Don\'t offer to create new items on read only collections\",\"Charts in admin Audit section load infinitely\",\"Change number card minimum size to 2x2\",\"Cards that are 1-2 grid units tall look broken in dashboard filter mapping mode\",\"Force migration is broken\",\"Adding filter of summarized field grouped by latitude and longitude on a map changes visualization type\",\"“Invalid :expression reference: no expression named …” on stats\",\"Provide admins with more context as to where they can change their homepage\"]},{\"version\":\"v0.46.7\",\"released\":\"2023-08-08\",\"patch\":true,\"highlights\":[\"v0.46.6.4 : Migration from H2 to Postgres fails with Command failed with exception: ERROR: insert or update on table \\\"metabase_table\\\" violates foreign key constraint \\\"fk_table_ref_database_id\\\"\",\"Prevent open redirects for JWT/SAML\",\"Very Inefficient query causing Metabase DB load to go to 100% [v0.46.6.4]\",\"LDAP Attribute sync no longer works\",\"\\\"Expected native source query to be a string, got: clojure.lang.PersistentArrayMap\\\" on nested queries\",\"Snowflake won\'t sync without password (user using only private key)\",\"Resizing columns in pivot tables in serialization breaks the card on load\",\":has_question_and_dashboard from `api/user/current` is always false\",\"Basic actions become unusable if clauses are added to the model later\",\"Cyclic load dependency when loading `src/metabase/integrations/ldap.clj`\",\"snowplow events for task details can be too large\",\"New interface Laggy and slow \",\"Certain invalid URL causes error response from Jetty\",\"Pulses with Conditional Formatting is displayed with black background, when value is above 999\"]},{\"version\":\"v0.46.6.4\",\"released\":\"2023-07-28\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.46.6.3\",\"released\":\"2023-07-28\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.46.6.2\",\"released\":\"2023-07-24\",\"patch\":true,\"highlights\":[\"Fix Google sign-in failing for some geolocations.\"]},{\"version\":\"v0.46.6.1\",\"released\":\"2023-07-21\",\"patch\":true,\"highlights\":[\"Upgrade your Metabase installation IMMEDIATELY. A recently discovered security vulnerability almost certainly affects you, and we recommend you upgrade your Metabase Installation right away.\"]},{\"version\":\"v0.46.6\",\"released\":\"2023-06-29\",\"patch\":true,\"highlights\":[\"Remove `task` snowplow event\",\"Incorrect query on nested questions in BigQuery\",\"Snowflake won\'t sync without password (user using only private key)\",\"Don\'t auto-run sql questions when there\'s an edit\",\"Error custom column \\\"only binary :- is supported\\\"\"]},{\"version\":\"v0.46.5\",\"released\":\"2023-06-13\",\"patch\":true,\"highlights\":[\"Add to Dashboard/Save Question Menu doesn\'t respect Collection Alphabetical order as in Main Menu\",\"Downloading data from cards in dashboards does not respect download limit\",\"Respect alphabetical order of collections in \\\"Move\\\" modal\",\"Attempting to upload RSA private key (PEM PK8) to connect to Snowflake fails with Private key provided is invalid or not supported\",\"Dump broken on 46.x on instances with more than 65K categorical fields\",\"MySQL default timeout needs to be increased\",\"Question with source query containing aggregation and sorting by that aggregation fails on mongodb\",\"Upgrade to 1.46 fails due to invalid state in permissions table\",\"Reverting to an earlier version of a dashboard creates an erroneous event in revision history\",\"Model caching not working anymore in 0.46.x with MySQL if query takes more than 29 seconds\",\"Question breaks after trying to create pivot table and edit on aggregated results that are not grouped\",\"Not able to Enable/Disable Actions when Choose when syncs and scans happen is Enabled\",\"Native editor buttons are incorrectly rendering on top of model metadata screen\",\"Unable to summarize models\",\"Sporadic \\\"we\'re a little lost...\\\" pop-up when scrolling up and down my query after expanding a row\",\"Basic actions (CUD) display order is non-deterministic\",\"Do not offer to save database changes if there were none\",\"There is no confirmation when running an action without parameters in dashboards\",\"Make the \\\"save\\\" modal context-aware\",\"SSO does not respect Metabase subpath\",\"MB_SESSION_TIMEOUT behavior does not match documentation\",\"Doing \\\"Zoom in\\\" from dashboard drops fields from joined tables\",\"Google Sign-in ignores \\\"Notify admins of new SSO users\\\" toggle\",\"Drill-through to questions with add columns (implicit join) causes no filtering to be defined\",\"Better error message/validation if SAML Keystore has no private key\",\"Cannot run native queries against MongoDB unless explicitly selecting the table\",\"When setting/resetting password, `sign in with your new password` shouldn\'t make you retype your password again\"]},{\"version\":\"v0.46.4\",\"released\":\"2023-05-24\",\"patch\":true,\"highlights\":[\"Link Cards that link to internal entities should open the object in the same iFrame in Full-App embedding\",\"Activity feed leaks metadata\",\"Mongodb won’t work if version does fall into the “semantic-version-gte” pattern (Percona)\",\"46 regression: `datetimeAdd` is apparently supposed to allow non-integer amounts\",\"If you bring the sample dataset back then go to \'Browse Data\' it does not appear unless you refresh the page\",\"Add series modal pulls all cards and viz settings and it\'s unusable on big instances\",\"/recent_views endpoint query uses non-indexed fields\"]},{\"version\":\"v0.46.3\",\"released\":\"2023-05-18\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.46.2\",\"released\":\"2023-04-28\",\"patch\":true,\"highlights\":[\"Users with No Access to the Collection Our Analytics are not able to define a dropdown list from models/questions\",\"MongoDB Custom Column SUM with arithmetic operation producing wrong MongoQL\",\"Race condition after deleting the Sample Database\",\"Include checklist task to migrate off h2\",\"[Snowflake] Syntax error: unexpected \\\"?\\\" when using filters inside window frames, or inside INTERVAL syntax\",\"Revision history erratically loads and removes historic changes\",\"\\\"People can pick\\\" ->multiple values in dashboards and custom dropdown filter don\'t go together\",\"Changing column order on model view then almost saving without preview breaks model with custom columns\",\"Metric tooltip description gets cut\",\"Metadata is required when trying join on an SQL based questions\",\"Adding more than one field filter blows up the frontend in Mongo and MySQL\",\"Filter values no longer work inside single quoted strings\",\"Serialization v1 errors when trying to load an instance with actions\",\"Cannot get into a card from a dashboard on \\\"no self-service\\\" permissions\",\"\\\"First day of the week\\\" not changing calendar widget on filters\"]},{\"version\":\"v0.46.1\",\"released\":\"2023-04-05\",\"patch\":true,\"highlights\":[\"drill-through not working correctly in legend for stacked charts\",\"SSO mapping: users are removed from groups that are not mapped\",\"Date Filter (Specific Dates) doesn\'t show first days of the month\",\"Fix implicit actions not created in a deterministic order\",\"Currency list: Add Mauritania ouguiya (MRU) as currency\",\"Big xslx file downloaded from BigQuery are corrupted in v0.45.3 and were not in v0.45.1\",\"Infinite loop, logging at warn level, filling disk for a GCP BigQuery connection\",\"Dashboard sticky filter incorrectly positioned, when moving between dashboards\",\"Unable to properly filter on an aggregation\"]},{\"version\":\"v0.46.0\",\"released\":\"2023-03-28\",\"patch\":false,\"highlights\":[\"Cannot save dashboard when using \\\"Add a saved question\\\" text\",\"Ensure we use the ssh tunnel on action execution\",\"Under specific circumstances, when editing an existing sandbox, the \\\"Parameter or variable\\\" dropdown for a filter is incorrectly grayed out\",\"Date Filter \\\"Exclude\\\" option fails on Dashboard if you are on a different language than English\",\"Exclude non required PKs from implicit create action\",\"Adding classname prop to ObjectDetail\",\"Object Detail View is no longer scrollable inside Query Builder\",\"Let users download questions as a PNG in-product\",\"Offer question downloads from dashboard cards\",\"\\\"Pulse card query error\\\" on user without native SQL permissions\",\"Don\'t include auto-incremented fields in the implicit create action form if it\'s an auto increment ID\",\"pulling out column title logic and sharing with settings\",\"Chartsettings use custom column names\",\"Updated Column names are not present in Chart Settings\",\"GUI Cached models that have joins will generate the query incorrectly and fail\",\"Remove personal collections from collection detail page\",\"Standardize chart settings icon buttons\",\"Updating Close Icon\",\"Centering tab labels\",\"Viz Charts don\'t support customisation of series with more than 20 groups\",\"Fix exclusion of CLJS devtools from release builds\",\"The order of series in a visualization should match the order in the sidebar\",\"Release script can stomp over root `./deps.edn` dependencies and break the build \",\"Personal collection shows up as a sub-collection of \\\"Our analytics\\\"\",\"[Epic] Improve Upgrade CTA Tracking\",\"Adding flex grow to card wrapper\",\"update the row chart style\",\"stack area chart with breakouts\",\"open chart settings when clicking active display type\",\"Keep filter and fields clauses in trivial nested queries\"]},{\"version\":\"v0.45.3\",\"released\":\"2023-02-21\",\"patch\":true,\"highlights\":[\"Fix ObjectDrill on queries with joined tables\",\"Send \\\"threads blocked\\\" via Prometheus exporter\",\"Make educational messaging in native questions less distracting\",\"Fix \\\"Powered by Metabase\\\" badge partially invisible with transparent theme\",\"Pre-existing category filters were not migrated to new ones\",\"Doing \\\"Zoom in\\\" from dashboard drops fields from joined tables\",\"Links for the IDs are showing wrong objects when table join is in place\",\"Column filters not working on Questions using custom columns\",\"Drill-through to questions with add columns (implicit join) causes no filtering to be defined\",\"Data selector not working in FullApp embedding if going directly from location that hasn\'t loaded `/api/database` yet\"]},{\"version\":\"v0.45.2.1\",\"released\":\"2023-01-27\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.45.2\",\"released\":\"2023-01-17\",\"patch\":true,\"highlights\":[\"Log4j2.xml file not read on 0.45\",\"Cannot select fields for double aggregated metrics, and existing sections gets removed on change\",\"Background color on hover for items in data picker looks off\",\"Static viz fails when there\'s an unused column returned\",\"\\\"Something\'s gone wrong\\\" error when moving between dashboards that has/hasn\'t filters\",\"Changing sorting does not apply for X-axis anymore\",\"Number filter with `0` (zero) as default value shows as empty in the widget\",\"Relieve db pressure on api/health check\",\"Static viz fails when date formatting contains day\",\"\\\"Replace missing values with\\\" set to `Zero` or `Nothing` causes the line to become zeroed/hidden\",\"Update token check URL\",\"Static viz fails when date formatting is abbreviated\",\"Disable Athena driver IAM role-based auth in Cloud\",\"Improve collection breadcrumbs with embedding parameters\",\"Snowflake sync is consuming more resources than necessary\",\"Click Behavior cannot handle absolute URLs outside of Metabase\",\"Avoid updating dashboard cards unless filter changes\",\"Using filter Contains on dashboard is case-insensitive, but on drill-through to question becomes case-sensitive\",\"BigQuery data type `BIGDECIMAL` is recognized as mixed string/numeric\",\"Text filter over a custom column in simple embedding expects a number\",\"Comma separated filter value would not hand over from dashboard to question\",\"Embedding Dashboard with Locked parameters does not allow numeric values\",\"Column name auto-classification not working for _latitude\",\"Corrupted question shows \\\"Something\'s gone wrong\\\" with no more info, and breaks \\\"Add series\\\" modal on the dashboard, and breaks Archive page\",\"unset MB_API_KEY for notify endpoint could use some feedback\"]},{\"version\":\"v0.45.1\",\"released\":\"2022-12-07\",\"patch\":true,\"highlights\":[\"SQL Server driver not loaded in 0.45.0\"]},{\"version\":\"v0.45.0\",\"released\":\"2022-12-05\",\"patch\":false,\"highlights\":[\"Editing a model\'s metadata bricks the question when mapping to an underlying DB column that has an enum mapping\",\"Remove `is_write` card property on the FE\",\"Audit dashboards click behavior does not work\",\"Fixes remapped columns support for the row chart type\",\"`has-user-setup` Setting does not actually cache truthy results like it says\",\"Visualization settings can crash Query Builder\",\"Build datetime filters as datetime before question is saved\",\"Analysis of Sample DB on initial startup takes ~2 minutes\",\"[Epic] Let users know why there’s no drill-through on their SQL/native questions\",\"Record application database version in Snowplow metrics\",\"In Mongo, the filter does not work for uuid fields\",\"Sync of new tables stops working if an existing table has a description set to empty (not null)\",\"BigQuery Arrays are not exported correctly to CSV\",\"Dashboard sticky filter incorrectly positioned, when moving between dashboards\",\"Sidebar covers dashboard sticky filters, when scrolling on dashboard\",\"Changing permissions can fail with `Data too long for column \'before\' at row 1` when using MySQL/MariaDB application database\",\"Serdes v2: it should be possible to load content to an instance without the serialized data model (if the target instance already contains the data model)\",\"Serdes v2 is not transferring `report_card.result_metadata` on models\",\"Model list appears empty when creating new question, even though models exist\",\"Click Behavior not working for Funnel\",\"Modal filtering doesn\'t work on joined table when Question has a filter after aggregation \",\"Reordering columns in pivot tables breaks the UI\",\"Dashboard Slack Subscription hits slack API max characters allowed per block\",\"Notify endpoint will always return 200 even if the tables don\'t exist\",\"[Epic] metabase-lib consolidation\",\"Add journey to create fresh Model using New button\",\"Add page to create Model without a Question using Native Query Editor\",\"Add page to create Model without a Question using Notebook Editor\",\"Data Model keeps resetting input fields while editing\",\"Persistent caching for Models fails to enable for MySQL\"]},{\"version\":\"v0.44.6\",\"released\":\"2022-11-01\",\"patch\":true,\"highlights\":[\"Google Sign-in fails because of unannounced change by Google\",\"Load in serialization with --mode update fails on upserts\",\"Between() in custom filter expression switches min and max upon adding new filter\",\"Collection list fails to display if there\'s an invalid parameter in a question\",\"Inconsistent behavior when sending certain payloads to /permissions/graph\",\"Loss of old translations in v0.44.1\"]},{\"version\":\"v0.44.5\",\"released\":\"2022-10-18\",\"patch\":true,\"highlights\":[\"Slack request error leads to sensitive authorization token being logged\",\"Synchronized tables that were initially marked as `cruft` has their `initial_sync_status` as `incomplete`\",\"Cannot drill-through \\\"View these ...\\\" when aggregated results are filtered\"]},{\"version\":\"v0.44.4\",\"released\":\"2022-09-29\",\"patch\":true,\"highlights\":[\"When LDAP is enabled but password login is disabled, login doesn\'t work\",\"Bump Postgres driver to 42.5.0\",\"404 on loading models when instance is configured in another language\",\"Loading spinners in filters don\'t appear anymore\",\"Inform admins if their account is in bad standing\",\"Bump MinaSSHD to 2.9.1\",\"MYSQL disable JSON unfolding doesn\'t work\",\"MySQL unfolding of JSON fails for `boolean` and `bigint` attributes\",\"Aggregation in Models causes the column name to incorrectly be parsed down to questions based on that Model\",\"Envar to disable custom maps / GeoJSON\",\"Changing filters on Simple question drops anything after first aggregation\",\"Metabase Prometheus Exporter\",\"Changing filters on Simple question drops aggregated filters\",\"Drill through / underlying records action doesn\'t respect filters in metric definitions\"]},{\"version\":\"v0.44.3\",\"released\":\"2022-09-15\",\"patch\":true,\"highlights\":[\"SessionStorage can become filled causing the frontend to throw errors until browser restart\",\"Filters incorrectly showing as linked to all fields on combined charts\",\"First created question not in Saved Questions inside Data Selector until page reload\",\"Cannot change email From-name and Reply-to-address when environment variables are used for other settings\",\"Column filters not working on multi-aggregation\",\"Tooltip periods are not displayed nicely on SQL questions\",\"Can\'t change filters via \'Show filters\'\",\"Bubble size not consistent across multiple series\",\"A hidden Database Sync doesn\'t allow descriptions for tables or fields to be edited\",\"Newly created Model not an option when creating a new question\",\"Dashboard filter does not show Search widget when trying to workaround other filter issues\",\"Chinese weekdays in calendar widget are incorrect\",\"Field filter linked to Boolean column causes an error when refreshing a public question\",\"Slack files channel can be confusing after initial setup\"]},{\"version\":\"v0.44.0\",\"released\":\"2022-08-04\",\"patch\":false,\"highlights\":[\"Blank screen if user without permissions to view dashboard card tries to edit the dashboard filter\",\"Bump jetty-server to 9.4.48.v20220622\",\"Click behavior to another dashboard/question makes the browser open the destination on a new window\",\"False warning that `No self-service` means higher access than `Block` permissions\",\"Bookmark icon not updated when question is converted to model and vice-versa\",\"Scalars show short number before showing the full number\",\"Default /api/collection/tree call does not include \\\"exclude-archived=true\\\"\",\"Archive page does not render all items\",\"Revert buttons shown on dashboard revision history for users without edit permissions\",\"Search returns irrelevant matches for non-native questions\",\"Can\'t embed cards with filters after v0.44.0-RC1 - Invalid Parameters: \\\"missing id\\\"\",\"CASE statements don\'t evaluate to False if using `, False` and nested CASE statements\",\"\\\"Custom...\\\" model refresh setting does not work on first request\",\"\\\"Our analytics\\\" appears on \\\"Save question\\\" collection search header even when user doesn\'t have access to it\",\"Exports fail on specific date styles\",\"Bubble size is scaling according to y-axis on scatter charts\",\"Error sending emails when reply-to setting contains empty string\",\"Email settings needs to use real password, not obfuscated password\",\"Wrong username/password on Office365 for email settings has misleading error\",\"Bulk Filter Modal v3\",\"Add snowplow tracking for new records on TaskHistory\",\"Missing full-screen button on public dashboards\",\"Primary color is not being used on background colors, so branding is not kept consistent\",\"Full Screen Night Mode Dashboard Has light background when scrolled down\",\"Dark primary color in data visualization makes icons almost disappear.\",\"Primary color in text with dark backgrounds makes text hard to read\",\"Relative Date filters on dashboard does not include the filter on drill-through\",\"Dashboard causes scrollbars to constantly go on/off depending on viewport size\",\"Items in the saved question picker are sorted case-sensitive\",\"Sandboxed group managers can\'t see other users in the People tab\"]},{\"version\":\"v0.43.4.2\",\"released\":\"2022-07-29\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.43.4.1\",\"released\":\"2022-07-28\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.43.4\",\"released\":\"2022-06-28\",\"patch\":true,\"highlights\":[\"Blank screen on questions with certain orphaned visualization settings\",\"Metabase returns \\\"No results!\\\" when the SSH tunnel is down on a query\",\"Changing account password to a non-complex password misleads the user with a success message even though the process fails\",\"Relative \\\"quarter\\\" filter doesn\'t work in SQL queries\",\"New Slack setup not working, because App isn\'t joining the files channel\",\"Tooltips goes outside of iframe in some cases\",\"\\\"Can\'t pop empty vector\\\" when binning JSON fields\",\"Collection name under dashboard title wraps weirdly when viewport is narrow\",\"Incorrect use of types during Postgres JSON unfolding\",\"Cannot filter `time` columns unless using the QB Sidebar\",\"Frontend incorrectly shows empty boolean values as `false`\"]},{\"version\":\"v0.43.3\",\"released\":\"2022-06-13\",\"patch\":true,\"highlights\":[\"Slack setup doesn\'t work if channels cache was recently cleared\",\"Custom Expression field is not respecting the modal size\",\"Bump google oauth version\",\"Relative filter with a lower \\\"Starting from\\\" period is confusing\",\"Cannot print large dashboards (multi page)\",\"Sync of JSON columns fails in schemas where schema names contains system characters\",\"Sync of fields fails, when table name contains uppercase characters\",\"Preview function in Notebook does not respect the columns selected on base source\",\"Viewing Metadata for a Model and cancelling can result in error, and further in blank screen\",\"Do not offer \\\"Explore results\\\" unless the database supports it\",\"Cannot view Object Detail of non-numeric IDs\",\"Incorrect use of types during Postgres JSON unfolding\",\"Click Behavior not redirecting in some cases\",\"Uploading certificates causes failure in TrustManager/KeyManager because of bad MIME-type\",\"New Slack App does not allow selecting private channels for pulses\",\"Query executions hitting the cache are not recorded\",\"Pulse fails when there is a column type `time`\"]},{\"version\":\"v0.43.2\",\"released\":\"2022-05-31\",\"patch\":true,\"highlights\":[\"Bump transitive com.google.code.gson/gson\",\"Login page: Whitelabeled logo clips top of page if vertical\",\"Sign in input fields are outside of screen on mobile\",\"Filters are taking 100% viewport width on mobile/tablet in v.43.1\",\"Updating data permissions counts questions as tables\",\"Fix deadlock in pivot table connection management\",\"Size of bubbles not respected on scatter chart\",\"Strings in the time series chrome UI aren\'t tagged for translation\",\"dont read settings at require time\",\"Unable to edit field name and description in Field page\",\"Custom Expression aggregation in Metrics does not work\",\"CPU spiking every hour since v0.43.0 upgrade\",\"Negative Y axis points not rendered on scatter plot\",\"X-ray charts don\'t seem to respect whitelabel colors\",\"Users with `block` permissions see ambiguous error message when they open a dashboard\",\"It is possible to change filter column when filter date columns from the table header\",\"We should cut the \\\"Navigation bar color\\\" option from /admin/settings/whitelabel\",\"Site URL setting reverting to default randomly\",\"Cannot use Click Behavior for filters with multiple options selected\",\"Click Behavior with filter pass-thru causes permission error (even for admins)\"]},{\"version\":\"v0.43.1\",\"released\":\"2022-05-16\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.43.0\",\"released\":\"2022-05-02\",\"patch\":false,\"highlights\":[\"Inconsistent colors in relative datetime filtering in sidebar\",\"Non-admin database manager can delete database using the API\",\"Query Builder data picker can \\\"forget\\\" about multiple schemas\",\"Data Model > Visibility buttons should \\\"signal\\\" they are clickable\",\"Date filter in the chart footer shows \\\"Previous\\\" filter type when \\\"All Time\\\" is selected\",\"\\\"Next\\\" relative filter tokens should read \\\"from now\\\" instead of \\\"ago\\\"\",\"Can\'t change a relative month filter\'s values when using the \\\"starting from\\\" feature\",\"Date preview is wrong when using the \\\"Starting from…\\\" action when it pushes back before the current year\",\"`Include this quarter` action is missing the words \\\"this quarter\\\"\",\"Purple borders in date filter popover should be blue\",\"In the relative date picker, changing the granularity of the Past/Next range picker should change the granularity of the Starting From picker\",\"Let\'s add the \\\"Metabase tips\\\" link for installers, too\",\"Errors when hiding/unhiding specific columns in table\",\"moving timelines and default interact poorly\",\"Sidebar stays open after entering a dashboard\'s fullscreen mode\",\"Exports fail when certain columns are hidden and a field is remapped\",\"Random comma in \\\"Display values\\\" section of data model settings for a field\",\"Selecting language Indonesian causes error\",\"Can not get the minimum or maximum of some SQL fields\",\"MAX/MIN aggregation on categories incorrectly inferred as numbers\",\"[Data Permissions] Saved questions showing in the list of databases\",\"Textbox on dashboards are difficult move and missing options\",\"Permission graph does not support schemas with slashes\",\"Backend should deserialize dashboard `Starting From`/`Exclude` datetime filters\",\"Datetime shortcut \\\"Relative dates...\\\" should default to \\\"Past\\\" filters\",\"Embedding/Public sharing of questions does not show download button in the footer\",\"Dashboard shows scrollbar in fullscreen\",\"Subscriptions button shown on dashboard in fullscreen\",\"Global search input is shorter than the field\",\"Popover menu position floating too far initiator\"]},{\"version\":\"v0.42.4\",\"released\":\"2022-04-07\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.42.3\",\"released\":\"2022-03-23\",\"patch\":true,\"highlights\":[\"Exclude /_internals from production build (#21162)\",\"Upgrade MySQL/MariaDB JDBC driver to version 2.7.5\",\"Comma Separate Numbers filter not working as it previously did\",\"Markdown parsing on backend doesn\'t support autolinks\",\"Subscription fails, when there\'s specific characters that causes Markdown failure\",\"Custom Column allows aggregation functions together with algebra, which fails on query\",\"Cannot connect Google Analytics because of deprecated OAuth OOB\",\"Postgres certificate SSL key reference incorrect\",\"Embedding with Locked parameters does not allow numeric values\",\"Models should not be shareable (embedding/public)\",\"BigQuery: Aggregating by a datetime in a saved question fails because of bad aliasing\",\"\\\"Saved\\\" overlay in data model UI in weird location on smaller screen\",\"\\\"Compare to the rest\\\" action in drill-through menu looks busted\",\"Autocomplete suggestions are not working for most of the database tables\",\"Permissions paths validation is `GET` API endpoints is too strict; causes numerous endpoints to 500 if unknown entry is present\",\"Main page loading spinner spins forever on API error\",\"Cannot use Data Selector when going directly to a question in new tab (or browser refresh)\",\"\\\"Show error details\\\" in Query Builder should be toggleable\",\"No visual feedback when setting column properties in Admin > Data Model\",\"QP/MBQL: `[:relative-datetime :current]` doesn\'t work inside `[:between]` filter\",\"Icon on empty activity page is misaligned\",\"Google Analytics updated Credentials aren\'t used for Connection\",\"Google Analytics database connection stopped working.\",\"Binning not working in table with a single row\",\"Fix error in send-abandonment-emails task\",\"Can\'t change Google Analytics DB settings\",\"when adding google analytics as source, it\'s not clear that I have to enable the API\"]},{\"version\":\"v0.42.2\",\"released\":\"2022-02-28\",\"patch\":true,\"highlights\":[\"Dashboards breaks when there\'s filters to cards that a user don\'t have permissions to view\",\"Questions with Field Filter with widget type \\\"None\\\" will not show results\",\"Can\'t combine saved questions on a dashboard card \",\"Setting a filter to \\\"Locked\\\" in Embedding question is not possible\",\"Nested queries with long Data Model names causes failing query with incorrect aliasing\",\"Dropdown list filtering not working, when there\'s nulls\",\"BigQuery - nested query generating bad aliases, when columns are renamed in Data Model\",\"Summarizing with implicit join does not allow subsequent joins and nested query\",\"Databases shows sync-spinner and doesn\'t allow to remove it or do a forced sync\"]},{\"version\":\"v0.42.1\",\"released\":\"2022-02-17\",\"patch\":true,\"highlights\":[\"Filter dropdown only allows filtering on \\\"starts with\\\"\",\"Unable to filter dashboards for dashboard subscription emails\",\"Dashboard filter with defaults, doesn\'t work if values are removed, query fails\",\"Pulse Question Alert to Slack sending cropped images\",\"Cannot remove Google Sign-in setup\",\"Embed dashboard Field Filter cannot work when choosing single option\",\"Custom expression - Count needs parentheses, but deletes them afterwards\",\"Cannot open Model sidebar in some cases\",\"BigQuery incorrectly aliasing, which can make the query fail\",\"Filtering on nested questions causes error in Public and Embedding\",\"BigQuery nested query with ambiguous columns causes error\",\"Setting a filter to \\\"Locked\\\" in Embedding is not possible\",\"Remove unused dep on aleph (and thus unused transient dep on Netty)\",\"Oracle queries don\'t work when aliases (auto-generated or otherwise) contain double quotes or null characters\",\"When no-data user views a nested question, then all editing options are exposed\",\"When no-data user views a nested question, then \\\"Ask question\\\" and \\\"Browse data\\\" appears\",\"Oracle fails queries on joins with tables with long display names\",\"Pivot Table: Cannot change name of fields used for \\\"values\\\"\"]},{\"version\":\"v0.42.0\",\"released\":\"2022-02-08\",\"patch\":false,\"highlights\":[\"Waterfall static viz default settings\",\"\\\"By coordinates\\\" map in People X-ray shows a nonsensical pin map\",\"Pins do not appear on pin map\",\"\\\"Explore results\\\" shown for no-data users resulting in blank screen when clicked\",\"Blank screen when accessing Models with no-data user\",\"Secret connection property file path is not retained when revisiting database edit page\",\"Licensing page goes into reload-loop if token is expired\",\"Descriptions missing in search results\",\" the Time picker AM and PM color can not be distinguished obviously\",\"Horizontal scroll of pinned table doesn\'t work on Firefox\",\"Metadata tooltip popup on colum header casues data table to reset for number columns that are all NULLs \",\"Certain visualization_settings can cause empty/missing columns on export\",\"Postgres unnecessarily casts `timestamptz` and `date` columns to `timestamp` inside `date_trunc()` \",\"Alert Stopped email is Unhelpful\",\"Exports ignore column ordering regression in v0.41.6\",\"Premature calls to `to-sql` inside `sql.qp/->honeysql` methods\",\"Visualization \\\"auto-viz\\\" doesn\'t keep existing settings, when changing fields returned\",\"Can\'t add a filter if the value isn\'t in the field filters dropdown\",\"Clean up database guide usability during configuration\",\"defsetting `:tag` metadata should be on the arglists themselves, not the var\",\"Clean up how we show deprecated database drivers\",\"SQLite/Redshift/SQL Server/MySQL queries don\'t work correctly with multiple column aliases with same name but different case\",\"Archived sub-collections are still showing in Permissions\",\"Clean up how we show deprecated database drivers\",\"XLSX exports are leaving temporary files, which can block instance from working\",\"Add a way to return to previous page from sign in cases\",\"Consolidate first db sync modal and X-ray selection\",\"[Epic] Migrate Slack implementation from Bot to App\",\"Improve Filters for 42\",\"Clean Up Settings Navigation\"]},{\"version\":\"v0.41.6\",\"released\":\"2022-01-14\",\"patch\":true,\"highlights\":[\"Specific visualization_settings can cause empty export\",\"Cannot change Field Filter reference to another schema/table if viewing the question directly\",\"Upgrade Log4j to 2.17.1\",\"Names of schemas or namespaces in the Data Model should wrap\",\"Broken layout on Data Model page on locales with longer text\"]},{\"version\":\"v0.41.5\",\"released\":\"2021-12-16\",\"patch\":true,\"highlights\":[\"Upgrade Log4j to 2.16.0\",\"X-rays fails if there\'s a filter in the question\",\"XLSX export does not respect \\\"Separator style\\\"\",\"One cannot change any of the LDAP Settings once it\'s been initially setup\",\"Custom Expression `coalesce` is using wrong field reference when nested query\",\"Custom Expression `case` is using wrong field reference when nested query\",\"Dashboard causes permission error, when \\\"Click Behavior\\\" linking to dashboard/question without access\",\"Site URL validation too strict, doesn\'t accept underscore\",\"Reverse proxy reset email should use site URL in email body and not localhost\"]},{\"version\":\"v0.41.4\",\"released\":\"2021-12-10\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.41.3.1\",\"released\":\"2021-12-02\",\"patch\":true,\"highlights\":[\"BigQuery and Google Analytics drivers broken on x.41.3\",\"BigQuery connection error on 0.41.1\"]},{\"version\":\"v0.41.3\",\"released\":\"2021-12-01\",\"patch\":true,\"highlights\":[\"Static viz creates Picaso painting, when data is unordered Timeseries\",\"Harmonize Google dependency versions, which could cause conflict between GA and new BigQuery driver\",\"Saving/updating questions can take a very long time (seconds or minutes) on large instances\",\"Funnel chart showing retained NaN% when all rows from aggregate column are zero\",\"Changing a (old) pivoted table to less than 3 columns results in blank screen\",\"Exports fails, when there\'s invalid visualization `column_settings` references\",\"Cannot send test emails before creating subscription, when using non-default filter values\",\"Native editor autocomplete suggestions makes object lookup without `limit`\",\"Strip whitespace from Google sign-in client IDs\",\"Validate Google sign-in client IDs\",\"Dashboard causes permission error, when \\\"Click Behavior\\\" linking to dashboard/question without access\",\"Clicking on legend in native question breaks the UI\",\"Trend tile on dashboard differs from tile on full screen\"]},{\"version\":\"v0.41.2\",\"released\":\"2021-11-09\",\"patch\":true,\"highlights\":[\"Frontend crashes when opening admin database permissions page\",\"Cannot access Notebook for questions that uses a Custom Column as joining column\",\"Requests to `GET /api/card/123` is making slow queries on larger instances\",\"BigQuery can cause conflict with some column names like `source`\",\"\\\"Verify this question\\\" button is shown even when content moderation feature is not enabled\",\"New BigQuery driver with \\\"Project ID (override)\\\" defined causes different Field Filter references\",\"Dashboard subscription send by Email fails with xlsx attachements\",\"Textbox markdown links on images difficult to click\",\"Some questions with old field dimensions or changed columns cannot be viewed, because of Javascript loop\",\"Multi-column join interface defaults binning for numeric fields causing incorrect results\",\"Sandboxing queries fails with caching is enabled\",\"Changing redshift db details leads to closed or broken resource pool\",\"Audit visualizations does not show correct information, when there\'s more than 1000 aggregated dates\",\"\\\"Set up your own alert\\\" text needs padding \",\"Dashboard Subscriptions are not deactivated, when dashboard is archived\",\"Update Uberjar builds on CircleCI to new build script\",\"ED25519 keys not working for built-in SSH tunnels\",\"Pin Maps with more than 1000 results (LeafletTilePinMap) not working with native queries\"]},{\"version\":\"v0.41.1\",\"released\":\"2021-10-21\",\"patch\":true,\"highlights\":[\"Not all endpoints are called, when doing FullApp embedding\",\"XLSX export of large columns fails because of formatting limitations\",\"Caching on 0.41.0 caches results for very long time (does not respect settings defined)\",\"Exporting large amount of data can result in OutOfMemory\",\"Chart descriptions (except table) is not shown in dashboards\",\"Better approach for column ordering in exports\",\"Remapped (display value) columns are dropped in downloads\",\"Tools for fixing errors problems with postgres semantics of limits (blank display of error table)\",\"Filtering null-column via the drill-through action menu causes blank screen\",\"Data Model shows blank page if there are any hidden tables in the database\",\"Columns missing from exports, when viz settings are using older field dimensions\",\"Pulses with rounded floats render a hanging decimal point in 0.41.0\",\"Raise MB_DB_CONNECTION_TIMEOUT_MS to 10000 as default\",\"Pulse/Subscription table cards with two columns (string, integer) fail to render\",\"[Add Database > Presto] Multiple JDBC field options\",\"Impossible to choose fields from different schema on Field Filters\",\"In email subscription, the original question title is shown instead of the curated title (v41)\",\"Audit > Questions > Total runtime displays link instead of an actual time\",\"KeyExchange signature verification failed for key type=ssh-rsa\",\"Export to XLSX can fail, when there\'s a very high integer value\",\"Questions -> all questions in Audit feature sorts by null values\",\"Allow caching of fonts and images\",\"Dashboard Subscription test email button does not show error messages\",\"EE Audit App frontend does not display error messages if queries fail\",\"Dashboard Textbox does not render links unless using Markdown\",\"Pin map only containing null location results causes the frontend to constantly reload or blank page\",\"X-Rays: Table field is shown as \\\"null\\\" in the title\",\"Custom Column with the same name as a table column returns incorrect results when grouped\",\"Adding data series to dashboard widget lags then sometimes hangs the UI\"]},{\"version\":\"v0.41.0\",\"released\":\"2021-10-06\",\"patch\":false,\"highlights\":[\"Went setting up multiple Dashboard Subscriptions, \\\"Send email now\\\" always sends the first one you set up until you refresh the page\",\"Pull in translations for 0.41\",\"Export in 0.41.0-rc1 does not include aggregated columns\",\"Whitelabel color options are not translatable\",\"Error inserting to view_log in 41-RC1\",\"Fix filter alignment in emails with many or long values\",\"Whitelabel includes `Metabase` in the subject for Alerts\",\"XLSX download fails, when settings still has the old `k:mm` hour-format instead of `HH:mm`\",\"History of last edited questions\",\"Search fields in `Tools > Errors` should be disabled when there are no questions\",\"\\\"Rerun Selected\\\" button is always enabled (even when there are no broken questions)\",\"Dragging dashboards filters makes them hidden while dragging\",\"Fix x-ray dashboards crash on first open\",\"Fix Audit logging not showing ad-hoc native queries\",\"X-ray dashboards crash on first opening\",\"Send to Slack/Send email now buttons on dashboard subscriptions send the wrong dashboard\",\"master - the upper-corner Run/Reload button has become very big\",\"Schemas with only hidden tables are shown in the data selector\",\"Saved Question: changing the breakout field (summarize) removes order-by (sort)\",\"Notebook Join UI display wrong table name with multiple join (master)\",\"Active filter widget are not using whitelabel color on border\",\"Data point value can be slightly cut-off for the top Y-axis values\",\"Dashboard sticky filter section is visible even when there aren\'t any filters\",\"Click Behavior does not work with old Pivot\",\"BigQuery Custom Column difficult to use because of name restrictions\",\"Revision history does not update until page reload\",\"Visualizations are not always using whitelabel colors by default\",\"BigQuery Custom Expression function `Percentile` and `Median` not using correct backtick quoting\",\"BigQuery `BIGNUMERIC` is recognized as `type/*` and displayed as string\",\"Joining behavior on datetime columns needs to be clearer\"]},{\"version\":\"v0.40.5\",\"released\":\"2021-09-21\",\"patch\":true,\"highlights\":[\"🤖 backported \\\"GeoJSON URL validation fix\\\"\",\"Grid map causes frontend reload or blank screen, when hovering the grids if there is no metric\",\"Cannot create more than 2 metrics, when UI language is Turkish - screen goes blank or displays \\\"Something went wrong\\\"\",\"Visualizations with more than 100 series just shows a blank chart\",\"Data point values uses formatting Style of first serie on all series\"]},{\"version\":\"v0.40.4\",\"released\":\"2021-09-09\",\"patch\":true,\"highlights\":[\"Dashboard filter autocomplete not working with mixed Search/Dropdown when dropdown has a `null` value\",\"Not possible to delete Dashboard Subscription unless dashboard is in root collection\",\"Possible to not input recipient of Subscription, which will then cause blank screen\",\"Valid Email settings disappear on save, but re-appear after refresh\",\"Unable to click \\\"Learn more\\\" on custom expression\",\"Editing an alert causes it to be deleted in some circumstances\",\"New databases with \\\"This is a large database ...\\\" still uses the default sync+scan settings\",\"Adding cards to dashboard via search can cause the card to show spinner until browser refresh\",\"Cannot login with OpenAM SAML since 1.38.3\",\"Native question \\\"Filter widget type\\\"=\\\"None\\\" hides the filter widget even after changing it to something else\"]},{\"version\":\"v0.40.3.1\",\"released\":\"2021-08-26\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.40.3\",\"released\":\"2021-08-25\",\"patch\":true,\"highlights\":[\"🤖 backported \\\"Keep `collection_id` of dashboard subscriptions in sync with same field on dashboard\\\"\",\"Run-overlay not going away on GUI question\",\"Dashboard causes scrollbars to constantly go on/off depending on viewport size \",\"Serialization `--mode skip` incorrectly updates some objects\",\"Serialization crashes on dump if there\'s no collections\",\"Serialization: Cannot load into empty/blank target\",\"Clicking the column formatting button when the sidebar is already open should correctly open that column\'s formatting sidebar\",\"Dashboard Subscription doesn\'t follow the order of the cards on the dashboard\",\"Clicking away from Sandbox modal breaks perms page\"]},{\"version\":\"v0.40.2\",\"released\":\"2021-08-03\",\"patch\":true,\"highlights\":[\"Update strings for 0.40.2\",\"Docs for 40.2\",\"Snippet folder permissions are always applied to root\",\"Cannot start development in VS Code because of missing Node.js\",\"Search widget on question builder hangs tab, API field search limit not respected\",\"Only 50 groups are displayed\",\"People search dropdown goes outside of the screen\",\"Only 50 users shown in email autocomplete and \\\"Other user\'s personal collection\\\"\",\"Dashboard - Adding ‘Click Behavior’ to an image field converts image to URL\",\"Cannot upgrade to v0.40.x on AWS Elastic Beanstalk due to AWS Inspector not being available in certain regions\",\"Add Metabase Cloud link to admin settings for hosted instances\",\"Fix dashboard card hovering buttons drag behaviour\",\"Elastic Beanstalk nginx config is not updated on latest EB docker images\",\"Cannot deactivate users after the first 50 users\",\"Tabs in the Audit section look broken\",\"Duplication of the displayed table\",\"Allow selecting text in Textbox cards, while dashboard is in edit-mode\",\"Metabase on old AWS Elastic Beanstalk (Amazon Linux w/ old Docker) upgrade to 0.40 failed\",\"Popover footer is displaced when using filter with a search input\",\"Public Sharing footer is double-size because action buttons are stacked\",\"Error when setting column type to Number in data model settings\",\"Site URL can sometimes be incorrectly defined during startup\",\"Padding needed for button on map settings page\",\"LDAP/Email settings gets cleared if validation fails\",\"Serialization: Visualization column settings lost\",\"Waterfall visualization does not work with ordinal X-axis\",\"Clicking \\\"Cancel\\\" on collection archive modal should let you stay in that same collection\",\"Snowflake Connector Requires Deprecated Region Id\",\"Modify instead of replace default EB nginx config\"]},{\"version\":\"v0.40.1\",\"released\":\"2021-07-14\",\"patch\":true,\"highlights\":[\"An error occurs when opening a public question with filters having default parameters\",\"Remove Multi-Release from manifest\",\"Questions filters does not work in Embedded/Public\",\"Long titles in collections push out the last-edited-by and last-edited-at columns\",\"Only first 50 databases are displayed\",\"After hiding the column and then setting a required default value for SQL field filter (connected to that column) shows all fields as hidden and breaks SQL filters completely\",\"Global search suggestions dropdown appears behind the dataset search widget when starting a simple question\",\"Clean up the user-facing strings for coercion options\",\"Clicking Visualize in Notebook makes the question \\\"dirty\\\" even if no changes was made\"]},{\"version\":\"v0.40.0\",\"released\":\"2021-07-08\",\"patch\":false,\"highlights\":[\"Avoid error when user searches with no data perms\",\"Updated saved question data picker - styling improvements\",\"The pinned items from the main collection are not showed on the front page anymore\",\"[0.40 blocker] Handle personal collections better in the new saved question data picker\",\"Remove \\\"Something went wrong\\\"\",\"Filter flag causes overlay for required \\\"Number\\\" filter with the default value set\",\"Do not show Cloud CTA for Enterprise Edition\",\"The list of collections available on homepage \\\"Our analytics\\\" depends on the name of the first 50 objects\",\"Filter feature flag causes Run-overlay of results in Native editor unless editor is expanded\",\"Error message missing when logging in to a disabled account with Google sign-in\",\"unix-timestamp->honeysql implementation for h2 is incorrect for microseconds\",\"Fix funnel appearance\",\"Confusing UI when adding GeoJSON with no identifiers\",\"Better error handling when adding malformed GeoJSON\",\"Can\'t archive a question from the Question page\",\"Can\'t move item to \\\"Our analytics\\\" using drag-n-drop\",\"Can\'t \\\"Select All\\\" collection items if all items are pinned\",\"Bulk archive doesn\'t work\",\"Selecting bin count on intermediate data question fails\",\"Collections Metadata FE Implementation\",\"Group by on a `:Coercion/YYYYMMDDHHMMSSBytes->Temporal` postgres column fails\",\"Double binning menu for date fields when using Saved Question (Native)\",\"Cannot filter only on longitude/latitude range - UX is forcing user to fill out values for both fields\",\"Bug in values on data points for waterfall charts\",\"Table view on Permissions shows error on browser refresh\",\"Password login on SSO instance drops the redirect URL\",\"No error is reported when adding SQLite database that doesn\'t exist\",\"Specific combination of filters can cause frontend reload or blank screen\",\"Dashboard Contains filter doesn\'t remain when clicking on Question title\",\"Normal login errors are not surfaced if SSO is also active\"]},{\"version\":\"v0.39.4\",\"released\":\"2021-06-16\",\"patch\":true,\"highlights\":[\"Javascript error when enabling JWT authentication\",\"Switch to column settings when sidebar is already open\",\"Questions on MongoDB return \'No results!\' after upgrade from 0.38.5 to 0.39.0 when filtering against array \",\"Login blocked till timeout if Metabase can\'t reach GeoJS API\",\"Missing tooltip for sharing individual question\",\"Histograms should filter out null x values\",\"Shifted chart values on line with ordinal x axis\",\"Don\'t show Custom Expression helper, when input is not in focus\",\"Dashboard filters dropdown only list the first 100 values\",\"Cannot use arithmetic between two `case()` function in Custom Expression\",\"LDAP login fails with Group Sync when user is assigned to 1 group\",\"LDAP auth errors with \\\"did not match stored password\\\" if `givenName` or `sn` is missing\",\"Cannot join Saved Questions that themselves contains joins\",\"Human-reable numering not working properly\",\"Time series filter and granularity widgets at bottom of screen are missing\",\"LDAP group sync - LDAPException after removing user from a mapped group\",\"Dashboard text cards aren\'t scrolling\"]},{\"version\":\"v0.39.3\",\"released\":\"2021-05-27\",\"patch\":true,\"highlights\":[\"Feature flag causes problems with Number filters in Native query\",\"Revoking access to users in multiple groups does not correctly cleanup GTAP\",\"LDAP settings form hitting wrong API endpoint on save\",\"ExpressionEditor loses value when user resizes browser window\",\"ExpressionEditor loses value when user clicks away from associated name input\",\"Filter dropdown not working for non-data users, when field has 300+ distinct values.\",\"Tooltip only shows first Y-axis value when X-axis is numeric and style is Ordinal/Histogram\",\"Gauge visualization on small screens can cause frontend refresh on hover\",\"Serialization: `field-literal` converted to `field` since 1.39.0\",\"Serialization dumps with static references instead of paths in 1.39.0\",\"Fix Serialization P1s\",\"Incorrect result + loss of user input when summarizing with Saved Question\",\"Some places shows `{0}` placeholder instead of expected value\",\"Serialization load-process does not update `source-table` in joins, leading to broken questions\",\"Unchecking \\\"Remember me\\\" box has no effect -- close the browser and reopen, then go back to your MB instance and you\'re still logged in\",\"Serialization `dump` includes Personal Collections\",\"Serialization: Nested question references questions in other collection are moved and becomes corrupted\",\"Serialization: Snippet folders and Collections collide on `dump` because of missing namespace separation\",\"Serialization: Snippets are not transferred correctly, leading to incorrect references and broken queries\",\"Serialization: Click Behavior not translating entitiy ID on dump, potentially referencing wrong entities on load\",\"Wrong LDAP port input (non-numeric) can cause complete lockout\",\"Nested queries using metric got wrong SQL\",\"Cannot aggregate question with unix timestamp column that is converted/cast in Metabase\",\"Test LDAP settings before saving\",\"Nested queries using metrics need to include all columns used in metric filters\"]},{\"version\":\"v0.39.2\",\"released\":\"2021-05-17\",\"patch\":true,\"highlights\":[\"Regression combining Druid date filters with dimension filters\",\"Regression in filtering Druid table where greater than date\",\"Variable Field Type after upgrade \\\"Input to parse-value-to-field-type does not match schema\\\"\",\"Whitelabel favicon does not work correctly in all browsers\",\"Show right versions on enterprise custom builds\",\"Not possible to select pinned collection item using checkbox\",\"The new \\\"contains\\\" behavior for field value lookup doesn\'t work outside of dashboards\",\"Cannot restore table visibility in Data Model, when database is down\",\"LDAP user authorization failed with `$` in password\",\"Difficult to use some filters, when user has no data permissions [FE - Filter widget stops working if API endpoint returns 403]\",\"Serialization: Dashboard cards are corrupted, when questions are outside of dashboard collection\",\"Collection tree loader causes UI jump\",\"Filters with dropdown lists uses query on the database\",\"Login Failing for LDAP if user email isn\'t lowercase\",\"Startup warning about unsupported class will impact performance\",\"Auth Returns 400 Bad Request instead of 401 Unauthorized upon wrong credentials submission\",\"Need better instructions for setting up Google Auth\"]},{\"version\":\"v0.39.1\",\"released\":\"2021-04-27\",\"patch\":true,\"highlights\":[\"Tooltip shows incorrect values on unaggregated data with breakout\",\"Can\'t use parentheses as expected in filter expressions\",\"UI prevents adding 2 parameters to `Percentile()` function\",\"Login logo is left-aligned on EE, when whitelabel features are enabled\",\"No loading spinner when clicking a Collection on the home page\",\"Tooltip on unaggregated data does not show summed value like the visualization\",\"Table with multiple Entity Key columns incorrectly filtering on \\\"Connected To\\\" drill-through\"]},{\"version\":\"v0.39.0.1\",\"released\":\"2021-04-20\",\"patch\":false,\"highlights\":[\"Cannot select category Field Filter in Native query on 0.39.0\",\"map category/location to string so we can treat them like string/= in UI\"]},{\"version\":\"v0.39.0\",\"released\":\"2021-04-19\",\"patch\":false,\"highlights\":[\"Strings with placeholders like {0} aren\'t translating correctly\",\"Wrong tooltip labels and values for multiple series charts in dashboard\",\"Add feature flag for the new 0.39.0 dashboard filter types\",\"Pulse fails when visualization_settings is referring to a field-literal column\",\"Login History not recording correct IP address\",\"Add an ENV var setting for typeahead search\",\"BigQuery with filter after aggregation of join table fails query with wrong alias reference on 38.x\",\"Dashboard Textbox images are 100% width\",\"Questions based on Saved Questions is not using the same query for date filters leading to wrong results\",\"0.39 string translations\",\"0.39 Docs\",\"Add missing \\\"is\\\" assertions to various tests\",\"Custom Expression autocomplete operator selection is appended to what was typed\",\"Custom Expression formula starts with high cursor placement on Firefox\",\"Custom Expression filter not setting the \\\"Done\\\" button to current state of the formula until onblur\",\"Custom Expression editor is removing spaces too aggressive\",\"Hitting return when modifying a custom expression incorrectly discards changes\",\"metabase/metabase-enterprise-head Docker image doesn\'t have enterprise extensions\",\"Custom expressions: UI is too wide when shown in the sidebar\",\"Search: some results are as being in a folder which doesn\'t exist in the data reference\",\"Error saving metric in data reference\",\"Dashboard Subscription Filters: Set Parameter Values\",\"Normalize queries in URL fragments on FE\",\"Support string and number filter operators in dashboard parameter filters \",\"defsetting macro throw an Exception if you try to define a setting that\'s already defined in a different namespace\",\"Fix render error when removing a dashboard parameter\",\"Upgrade HoneySQL version to latest\",\"Dashboard Filter Improvements (to support large-scale rollout)\",\"SSH Connectivity Improvements\",\"MBQL Refactor: Combine various Field clauses into one new clause\"]},{\"version\":\"v0.38.4\",\"released\":\"2021-04-12\",\"patch\":true,\"highlights\":[\"Not possible to position Y-axis if there\'s only one series\",\"Tooltip on unaggregated data does not show summed value like the visualization\",\"For a new Custom column, I can set Style to \\\"Currency\\\", but cannot choose the Unit of Currency\",\"Add Kyrgyz Som to currency list\"]},{\"version\":\"v0.38.3\",\"released\":\"2021-04-01\",\"patch\":true,\"highlights\":[\"Overflow text on Ask a question page \",\"Filtering on coerced column doesn\'t always know its coerced\",\"Wrong series label in multiple series scatterplot\",\"Dashboard Subscription fails for all SQL questions with a Field Filter on date column connected on dashboard\",\"Dashboard Subscription Emails do not work with filtered Native Queries\",\"Dashboard Subscription sidebar broken for Sandboxed users\",\"Provide more logging information on permission errors when creating Cards\",\" In Settings > Email, Save Changes is enabled even when there are no changes\",\"Exports always uses UTC as timezone instead of the selected Report Timezone\",\"Invalid Redirect Location After SAML Sign-in via Full App Embed\",\"Cannot download XLSX if there\'s more than 1 million results\",\"Frontend load issue: SMTP Email\",\"Pie chart sometimes does not show total\",\"Users with collections \\\"edit\\\" permissions and no data access permissions can\'t edit question metadata\",\"Add Bitcoin as a unit of currency\",\"Column \\\"Custom title\\\" not working in tooltips\",\"Schema sync does not update changes in column type case\",\"Error on visualization change of a question with SQL queries view only permission\",\"Line chart dots don\'t have `cursor: pointer` when hovering\"]},{\"version\":\"v0.38.2\",\"released\":\"2021-03-17\",\"patch\":true,\"highlights\":[\"Data model not showing PostgreSQL tables when they are partitioned\",\"Migrate old pre-1.37 \\\"Custom Drill-through\\\" settings to x.37+ \\\"Click Behavior\\\"\",\"Regression with URL links\"]},{\"version\":\"v0.38.1\",\"released\":\"2021-03-03\",\"patch\":true,\"highlights\":[\"Serialization `dump` of aggregated questions are not copied over on `load`\",\"Serialization doesn\'t update Sub-Query variable reference\",\"Oracle, BigQuery filtering by column with day-of-week bucketing not working\",\"Pivot Table export not working on unsaved questions\",\"Pivot Table does not work for users without data permissions\",\"Pivot Table not working with Sandboxed user\",\"BigQuery: Joins in the query builder generate invalid table aliases\",\"BigQuery: Question Stays running until timeout when query is error in Native Query\",\"Serialization: Archived items are included in `dump`\",\"Breadcrumbs can be confusing (the current one \\\"seems\\\" clickable when it\'s not)\",\"regexextract breaks query on sandboxed table\",\"Multi-level aggregations fails when filter is the last section\",\"Pivot queries aren\'t recorded to query execution log\",\"Start of Week not applied to Field Filter in Native question, which can lead to incorrect results\",\"In Safari 14, add-grouping button disappears randomly but consistently\",\"Serialization does not initialize 3rd party drivers when loading a dump\",\"Wrong day names are displayed when using not-Sunday as start of the week and grouping by \\\"Day of week\\\"\",\"Difficult to see which cells has \\\"Click behavior\\\" vs normal behavior\",\"Object Detail previous/next buttons not working correctly\",\"Global number formatting does not apply to percentages\",\"Native question filter widget reordering doesn\'t work\"]},{\"version\":\"v0.38.0.1\",\"released\":\"2021-02-19\",\"patch\":false,\"highlights\":[]},{\"version\":\"v0.38.0\",\"released\":\"2021-02-16\",\"patch\":false,\"highlights\":[\"Sandboxed question with `case` Custom Field doesn\'t substitute the \\\"else\\\" argument\'s table\",\"Custom Expression using `case()` function fails when referencing the same column names\",\"Filtering a Custom Column does not give correct results when using \\\"Not equal to\\\"\",\"Cannot remove columns via QB sidebar, then query fails, but works if being removed via Notebook\",\"fix(rotate-encryption-key) settings-last-updated is not encrypted\",\"For Pivot Tables, download popup doesn\'t show\",\"Dashboard Subscriptions: Have to click the close button multiple times after viewing a Subscription\",\"Advanced Sandboxing ignores Data Model features like Object Detail of FK\",\"Publish \\\"latest\\\" OSS JAR\",\"Custom GeoJSON files are not sorted in the dropdown\",\"user@password JDBC connection strings for application DB no longer work\",\"Shrunken bubbles shown in question for null values\",\"Drilling down by a Region Map assigns the wrong value to the filter\",\"Using \\\"Reset to defaults\\\" on textbox causes it to become a corrupted card on dashboard\",\"Add a lightweight notify api endpoint\",\"Sandboxing on tables with remapped FK (Display Values) causes query to fail\",\"Allow usage of PKCS-12 certificates with Postgres connections\",\"dump-to-h2 does not return a non-zero exit code on failure\",\"Advanced Sandboxing using questions that return more/other columns than the sandboxed table is not possible anymore, but the errors are not helpful\",\"Bar chart x-axis positions can cause different spacing depending on the dates returned\",\"Custom Columns breaks Pivot Table\",\"Pivot tables broken on dashboard after resize\",\"dump-to-h2 with --dump-plaintext should check for presence of MB_ENCRYPTION_SECRET_KEY\",\"Right alignment of pivot table value cells looks broken\",\"Don\'t inform admins about MB cloud on EE instances\",\"add cmd rotate-encryption-key\",\"Token check retry is too aggressive\",\"Login page should automatically focus on the email input field\",\"Dashboard subscriptions including cards no longer in dashboard\",\"UI should update when a collection changes parent\"]},{\"version\":\"v0.37.9\",\"released\":\"2021-02-11\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.37.8\",\"released\":\"2021-01-29\",\"patch\":true,\"highlights\":[\"Cannot add (date) filter if calendar is collapsed\"]},{\"version\":\"v0.37.7\",\"released\":\"2021-01-20\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.37.6\",\"released\":\"2021-01-13\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.37.5\",\"released\":\"2021-01-05\",\"patch\":true,\"highlights\":[\"Linked filters breaking SQL questions on v0.37.2\",\"Embedding loading slow\",\"Cannot toggle off \'Automatically run queries when doing simple filtering and summarizing\' \"]},{\"version\":\"v0.37.4\",\"released\":\"2020-12-17\",\"patch\":true,\"highlights\":[\"Error in Query: Input to aggregation-name does not match schema\",\"Revert #13895\",\"Exports always uses UTC as timezone instead of the selected Report Timezone\",\"Between Dates filter behaves inconsistently based on whether the column is from a joined table or not\"]},{\"version\":\"v0.37.3\",\"released\":\"2020-12-03\",\"patch\":true,\"highlights\":[\"Fix chain filtering with temporal string params like \'last32weeks\'\",\"Linked filters breaking SQL questions on v0.37.2\",\"Running with timezone `Europe/Moscow` shows Pulse timezone as `MT` instead of `MSK` and sends pulses on incorrect time\",\"Order fields to dump by ID\",\"Remove object count from log output\"]},{\"version\":\"v0.37.2\",\"released\":\"2020-11-16\",\"patch\":true,\"highlights\":[\"When visualization returns `null` (No results), then UI becomes broken\"]},{\"version\":\"v0.37.1\",\"released\":\"2020-11-12\",\"patch\":true,\"highlights\":[\"Table schema sync performance impact\",\"v0.37.0.2 doesn\'t sync Vertica schema\",\"Pie chart shows spinner, when returned measure/value is `null` or `0`\",\"Wrong day names are displayed when using not-Sunday as start of the week and grouping by \\\"Day of week\\\"\",\"When result row is `null`, then frontend incorrectly shows as \\\"No results!\\\"\",\"Snowflake tables with a GEOGRAPHY column cannot be explored\",\"Cannot edit BigQuery settings without providing service account JSON again\",\"Sync crashes with OOM on very large columns/row samples [proposal]\",\"500 stack overflow error on collection/graph API call\",\"Custom Column after aggregation creates wrong query and fails\",\"The expression editor shouldn\'t start in error mode without any user input\",\"Pulse attachment file sent without file extension\",\"Metric with unnamed Custom Expression breaks Data Model for table\",\"Nested queries with duplicate column names fail\",\"pulse attachment file(question name) Korean support problem\",\"Pulse Bar Chart Negative Values Formatting\"]},{\"version\":\"v0.37.0.2\",\"released\":\"2020-10-26\",\"patch\":false,\"highlights\":[]},{\"version\":\"v0.36.8.2\",\"released\":\"2020-10-26\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.37.0.1\",\"released\":\"2020-10-23\",\"patch\":false,\"highlights\":[]},{\"version\":\"v0.36.8.1\",\"released\":\"2020-10-23\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.37.0\",\"released\":\"2020-10-22\",\"patch\":false,\"highlights\":[\"Fix null handling in filters regression\",\"Add translation for Bulgarian\",\"0.37.0-rc3: Click behavior to Dashboard shown on Public/Embedded\",\"NO_COLOR/MB_COLORIZE_LOGS does not remove all ansi codes\",\"0.37.0-rc3: Filtering a joined table column by \\\"Is not\\\" or \\\"Does not contain\\\" fails\",\"Update translations for final 0.37 release\",\"0.37.0-rc2: Monday week start displays incorrectly on bar chart\",\"0.37.0-rc2: Linked filter showing all values (not filtering)\",\"Only get substrings in fingerprinting when supported [ci drivers]\",\"0.37.0-rc2: log4j should not output to file by default\",\"0.37-RC2: we should suppress drag behavior when custom click behavior is set\",\"0.37-RC2: disable Done button in cases where click behavior target isn\'t specified\",\"0.37-RC2: weird edit state when saving a dashboard with incomplete click behavior\",\"0.37-RC2: Interactivity summary tokens squashed on small dashboard cards\",\"0.37.0-rc2: Hovering on custom map no longer displays region name, displays region identifier instead\",\"0.37.0-rc1: \\\"Click behavior\\\" to URL for non-table card, doesn\'t show reference fields to use as variables\",\"0.37.0-rc1: Variables from Saved Question are referencing the same question\",\"0.37.0-rc2: Cannot create custom drill-through to dashboard\",\"0.37-rc1: after clicking a custom link that passes a value to a param, clicking Back shouldn\'t bring that value to the original dashboard\",\"0.37-rc1: When mapping dashboard filters to columns, SQL questions should display the name of the column mapped to the field filter\",\"0.37-rc1: customizing a dashboard card\'s click behavior without specifying a destination causes strange behavior\",\"0.37-rc1: canceling the dashboard archive action takes you to the collection\",\"Embedded versions of new chain filters endpoints \",\"\\\"Does not contain\\\" and \\\"Is not\\\" filter also removes nulls\",\"Docs - 37 release - new dashboard functionality\",\"forward slash on table name causes ORA-01424 and blocks the sync step\",\"Update login layout and illustration.\",\"MySQL grouping on a TIME field is not working\",\"Field Filter variables in SQL question don’t show table name when connecting filters in dashboard\",\"Upgrade to log4j 2.x\"]},{\"version\":\"v0.36.8\",\"released\":\"2020-10-22\",\"patch\":true,\"highlights\":[]},{\"version\":\"v0.36.7\",\"released\":\"2020-10-09\",\"patch\":true,\"highlights\":[\"Presto not respecting SSL and always uses http instead of https\",\"Footer (with export/fullscreen/refresh buttons) on Public/Embedded questions disappears when using Premium Embedding\",\"Postgres sync not respecting SSH tunneling\"]},{\"version\":\"v0.36.6\",\"released\":\"2020-09-15T22:58:04.727Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.36.5.1\",\"released\":\"2020-09-11T23:16:26.199Z\",\"patch\":true,\"highlights\":[\"Remappings should work on broken out fields\"]},{\"version\":\"v0.36.4\",\"released\":\"2020-08-17T22:41:20.449Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.36.3\",\"released\":\"2020-08-04T23:57:45.595Z\",\"patch\":true,\"highlights\":[\"Support for externally linked tables\"]},{\"version\":\"v0.36.2\",\"released\":\"2020-07-31T17:46:34.479Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.36.1\",\"released\":\"2020-07-30T18:10:44.459Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.36.0\",\"released\":\"2020-07-21T19:56:40.066Z\",\"patch\":false,\"highlights\":[\"SQL/native query snippets\",\"Language selection\"]},{\"version\":\"v0.35.4\",\"released\":\"2020-05-29T17:31:58.191Z\",\"patch\":true,\"highlights\":[\"Security fix for BigQuery and SparkSQL\",\"Turkish translation available again\",\"More than 20 additional bug fixes and enhancements\"]},{\"version\":\"v0.35.3\",\"released\":\"2020-04-21T21:18:24.959Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.35.2\",\"released\":\"2020-04-10T23:03:53.756Z\",\"patch\":true,\"highlights\":[\"Fix email and premium embedding settings\",\"Fix table permissions for database without a schema\",\"Fix \\\"Error reducing result rows\\\" error\"]},{\"version\":\"v0.35.1\",\"released\":\"2020-04-02T21:52:06.867Z\",\"patch\":true,\"highlights\":[\"Issue with date field filters after v0.35.0 upgrade\",\"Unable to filter on manually JOINed table\"]},{\"version\":\"v0.35.0\",\"released\":\"2020-03-25T18:29:17.286Z\",\"patch\":false,\"highlights\":[\"Filter expressions, string extracts, and more\",\"Reference saved questions in your SQL queries\",\"Performance improvements\"]},{\"version\":\"v0.34.3\",\"released\":\"2020-02-25T20:47:03.897Z\",\"patch\":true,\"highlights\":[\"Line, area, bar, combo, and scatter charts now allow a maximum of 100 series instead of 20.\",\"Chart labels now have more options to show significant decimal values.\",\"Various bug fixes\"]},{\"version\":\"v0.34.2\",\"released\":\"2020-02-05T22:02:15.277Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.34.1\",\"released\":\"2020-01-14T00:02:42.489Z\",\"patch\":true,\"highlights\":[\"Various bug fixes\"]},{\"version\":\"v0.34.0\",\"released\":\"2019-12-20T01:21:39.568Z\",\"patch\":false,\"highlights\":[\"Added support for variables and field filters in native Mongo queries\",\"Added option to display data values on Line, Bar, and Area charts\",\"Many Timezone fixes\"]},{\"version\":\"v0.33.7.3\",\"released\":\"2019-12-17T01:45:45.720Z\",\"patch\":true,\"highlights\":[\"Important security fix for Google Auth login\"]},{\"version\":\"v0.33.7\",\"released\":\"2019-12-13T20:35:14.667Z\",\"patch\":true,\"highlights\":[\"Important security fix for Google Auth login\"]},{\"version\":\"v0.33.6\",\"released\":\"2019-11-19T20:35:14.667Z\",\"patch\":true,\"highlights\":[\"Fixed regression that could cause saved questions to fail to render (#11297)\",\"Fixed regression where No Results icon didn\'t show (#11282)\",\"Pie chart visual improvements (#10837)\"]},{\"version\":\"v0.33.5\",\"released\":\"2019-11-08T20:35:14.667Z\",\"patch\":true,\"highlights\":[\"Added Slovak translation\",\"Fixed support for MySQL 8 with the default authentication method\",\"Fixed issues with X-axis label formatting in timeseries charts\"]},{\"version\":\"v0.33.4\",\"released\":\"2019-10-08T20:35:14.667Z\",\"patch\":true,\"highlights\":[\"Custom expression support for joined columns\",\"Fixed issue with filtering by month-of-year in MongoDB\",\"Misc Bug Fixes\"]},{\"version\":\"v0.33.3\",\"released\":\"2019-09-20T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Chinese and Persian translations now available again\",\"Misc Bug Fixes \"]},{\"version\":\"v0.33.2\",\"released\":\"2019-09-04T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixed Cards not saving\",\"Fixed searrch not working \"]},{\"version\":\"v0.33.1\",\"released\":\"2019-09-04T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixed conditional formatting not working\",\"Fixed an issue where some previously saved column settings were not applied \",\"Fixed an issue where pulses were not loading \"]},{\"version\":\"v0.33.0\",\"released\":\"2019-08-19T08:09:36.358Z\",\"patch\":false,\"highlights\":[\"Notebook mode + Simple Query Mode\",\"Joins\",\"Post Aggregation filters\"]},{\"version\":\"v0.32.10\",\"released\":\"2019-07-28T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix User can\'t logout / gets automatically logged in.\",\"Fix No data displayed when pivoting data\",\"Fixed Dashboard Filters on Linked Entities Broke\"]},{\"version\":\"v0.32.9\",\"released\":\"2019-06-14T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix issues connecting to MongoDB Atlas Cluster\",\"Fix database addition on setup\",\"Fixed numeric category error with Postgres\"]},{\"version\":\"v0.32.8\",\"released\":\"2019-05-13T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix i18n\"]},{\"version\":\"v0.32.7\",\"released\":\"2019-05-09T08:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix published SHA Hash\"]},{\"version\":\"v0.32.6\",\"released\":\"2019-05-08T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixed regression where Dashboards would fail to fully populate\",\"Performance improvements when running queries\",\"Security improvements\"]},{\"version\":\"v0.32.5\",\"released\":\"2019-04-20T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Improve long-running query handling\",\"Fix H2 to MySQL/Postgres migration issue\",\"Fix issue with embedded maps with custom GeoJSON\"]},{\"version\":\"v0.32.4\",\"released\":\"2019-04-09T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix issue where Google Auth login did not work\",\"FFix issue where Google Auth login did not work\"]},{\"version\":\"v0.32.3\",\"released\":\"2019-04-08T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixed Snowflake connection issues\",\"Fixed Dashboard copy\",\"Fixed non-root context logins\"]},{\"version\":\"v0.32.2\",\"released\":\"2019-04-03T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixed dashboard date filters \",\"Fixed SSL error using Quartz w/ MySQL\",\"Fix colors in dashboards\"]},{\"version\":\"v0.32.1\",\"released\":\"2019-03-29T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixed MySQL connections with SSL\",\"Fixed table sync issue\"]},{\"version\":\"v0.32.0\",\"released\":\"2019-03-28T12:09:36.358Z\",\"patch\":false,\"highlights\":[\"Modular Drivers (reducing memory consumption)\",\"Async queries (improving responsiveness)\",\"Reduced memory consumption.\"]},{\"version\":\"v0.31.2\",\"released\":\"2018-12-07T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Added German translation\",\"Fixed Heroku out-of-memory errors\",\"Fixed issue with Slack-based Pulses due to rate limiting.\"]},{\"version\":\"v0.31.1\",\"released\":\"2018-11-21T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Ability to clone dashboards\",\"Faster startup time and lower memory consumption\",\"Migration issue fixes.\"]},{\"version\":\"v0.31.0\",\"released\":\"2018-11-08T12:09:36.358Z\",\"patch\":false,\"highlights\":[\"New visualizations and combo charts\",\"Granular formatting controls\",\"Snowflake Support\"]},{\"version\":\"v0.30.4\",\"released\":\"2018-09-27T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Metabase fails to launch in Chinese\",\"Fix token status checking\",\"Fix BigQuery SQL parameters with encrypted DB details\"]},{\"version\":\"v0.30.3\",\"released\":\"2018-09-13T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Localization for Chinese, Japanese, Turkish, Persian\",\"Self referencing FK leads to exception\",\"Security improvements\"]},{\"version\":\"v0.30.2\",\"released\":\"2018-09-06T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Localization for French + Norwegian\",\"Stability fixes for HTTP/2\"]},{\"version\":\"v0.30.1\",\"released\":\"2018-08-08T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Localization for Portuguese\",\"Timezone fix\",\"SQL Template tag re-ordering fix\"]},{\"version\":\"v0.30.0\",\"released\":\"2018-08-08T12:09:36.358Z\",\"patch\":false,\"highlights\":[\"App wide search\",\"Enhanced Collection permissions\",\"Comparison X-Rays\"]},{\"version\":\"v0.29.3\",\"released\":\"2018-05-12T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix X-ray rules loading on Oracle JVM 8\"]},{\"version\":\"v0.29.2\",\"released\":\"2018-05-10T12:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix Spark Driver\"]},{\"version\":\"v0.29.1\",\"released\":\"2018-05-10T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Better heroku memory consumption\",\"Fixed X-Ray Bugs\",\"Drill through from line chart selects wrong date\"]},{\"version\":\"v0.29.0\",\"released\":\"2018-05-01T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"New and Improved X-Rays\",\"Search field values\",\"Spark SQL Support\"]},{\"version\":\"v0.28.6\",\"released\":\"2018-04-12T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix chart rendering in pulses\"]},{\"version\":\"v0.28.5\",\"released\":\"2018-04-04T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix memory consumption for SQL templates\",\"Fix public dashboards parameter validation\",\"Fix Unable to add cards to dashboards or search for cards, StackOverflowError on backend\"]},{\"version\":\"v0.28.4\",\"released\":\"2018-03-29T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix broken embedded dashboards\",\"Fix migration regression\",\"Fix input typing bug\"]},{\"version\":\"v0.28.3\",\"released\":\"2018-03-23T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Security improvements\"]},{\"version\":\"v0.28.2\",\"released\":\"2018-03-20T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Security improvements\",\"Sort on custom and saved metrics\",\"Performance improvements for large numbers of questions and dashboards\"]},{\"version\":\"v0.28.1\",\"released\":\"2018-02-09T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix admin panel update string\",\"Fix pulse rendering bug\",\"Fix CSV & XLS download bug\"]},{\"version\":\"v0.28.0\",\"released\":\"2018-02-07T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Text Cards in Dashboards\",\"Pulse + Alert attachments\",\"Performance Improvements\"]},{\"version\":\"v0.27.2\",\"released\":\"2017-12-12T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Migration bug fix\"]},{\"version\":\"v0.27.1\",\"released\":\"2017-12-01T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Migration bug fix\",\"Apply filters to embedded downloads\"]},{\"version\":\"v0.27.0\",\"released\":\"2017-11-27T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Alerts\",\"X-Ray insights\",\"Charting improvements\"]},{\"version\":\"v0.26.2\",\"released\":\"2017-09-27T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Update Redshift Driver\",\"Support Java 9\",\"Fix performance issue with fields listing\"]},{\"version\":\"v0.26.1\",\"released\":\"2017-09-27T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix migration issue on MySQL\"]},{\"version\":\"v0.26.0\",\"released\":\"2017-09-26T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Segment + Metric X-Rays and Comparisons\",\"Better control over metadata introspection process\",\"Improved Timezone support and bug fixes\"]},{\"version\":\"v0.25.2\",\"released\":\"2017-08-09T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Bug and performance fixes\"]},{\"version\":\"v0.25.1\",\"released\":\"2017-07-27T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"After upgrading to 0.25, unknown protocol error.\",\"Don\'t show saved questions in the permissions database lists\",\"Elastic beanstalk upgrades broken in 0.25 \"]},{\"version\":\"v0.25.0\",\"released\":\"2017-07-25T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Nested questions\",\"Enum and custom remapping support\",\"LDAP authentication support\"]},{\"version\":\"v0.24.2\",\"released\":\"2017-06-01T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Misc Bug fixes\"]},{\"version\":\"v0.24.1\",\"released\":\"2017-05-10T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix upgrades with MySQL/Mariadb\"]},{\"version\":\"v0.24.0\",\"released\":\"2017-05-10T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Drill-through + Actions\",\"Result Caching\",\"Presto Driver\"]},{\"version\":\"v0.23.1\",\"released\":\"2017-03-30T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Filter widgets for SQL Template Variables\",\"Fix spurious startup error\",\"Java 7 startup bug fixed\"]},{\"version\":\"v0.23.0\",\"released\":\"2017-03-21T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Public links for cards + dashboards\",\"Embedding cards + dashboards in other applications\",\"Encryption of database credentials\"]},{\"version\":\"v0.22.2\",\"released\":\"2017-01-10T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix startup on OpenJDK 7\"]},{\"version\":\"v0.22.1\",\"released\":\"2017-01-10T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"IMPORTANT: Closed a Collections Permissions security hole\",\"Improved startup performance\",\"Bug fixes\"]},{\"version\":\"v0.22.0\",\"released\":\"2017-01-10T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Collections + Collections Permissions\",\"Multiple Aggregations\",\"Custom Expressions\"]},{\"version\":\"v0.21.1\",\"released\":\"2016-12-08T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"BigQuery bug fixes\",\"Charting bug fixes\"]},{\"version\":\"v0.21.0\",\"released\":\"2016-12-08T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Google Analytics Driver\",\"Vertica Driver\",\"Better Time + Date Filters\"]},{\"version\":\"v0.20.3\",\"released\":\"2016-10-26T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix H2->MySQL/PostgreSQL migrations, part 2\"]},{\"version\":\"v0.20.2\",\"released\":\"2016-10-25T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Support Oracle 10+11\",\"Fix H2->MySQL/PostgreSQL migrations\",\"Revision timestamp fix\"]},{\"version\":\"v0.20.1\",\"released\":\"2016-10-18T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"Lots of bug fixes\"]},{\"version\":\"v0.20.0\",\"released\":\"2016-10-11T11:09:36.358Z\",\"patch\":false,\"highlights\":[\"Data access permissions\",\"Oracle Driver\",\"Charting improvements\"]},{\"version\":\"v0.19.3\",\"released\":\"2016-08-12T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"fix Dashboard editing header\"]},{\"version\":\"v0.19.2\",\"released\":\"2016-08-10T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"fix Dashboard chart titles\",\"fix pin map saving\"]},{\"version\":\"v0.19.1\",\"released\":\"2016-08-04T11:09:36.358Z\",\"patch\":true,\"highlights\":[\"fix Dashboard Filter Editing\",\"fix CSV Download of SQL Templates\",\"fix Metabot enabled toggle\"]},{\"version\":\"v0.19.0\",\"released\":\"2016-08-01T21:09:36.358Z\",\"patch\":false,\"highlights\":[\"SSO via Google Accounts\",\"SQL Templates\",\"Better charting controls\"]},{\"version\":\"v0.18.1\",\"released\":\"2016-06-29T21:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix for Hour of day sorting bug\",\"Fix for Column ordering bug in BigQuery\",\"Fix for Mongo charting bug\"]},{\"version\":\"v0.18.0\",\"released\":\"2016-06-022T21:09:36.358Z\",\"patch\":false,\"highlights\":[\"Dashboard Filters\",\"Crate.IO Support\",\"Checklist for Metabase Admins\",\"Converting Metabase Questions -> SQL\"]},{\"version\":\"v0.17.1\",\"released\":\"2016-05-04T21:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fix for Line chart ordering bug\",\"Fix for Time granularity bugs\"]},{\"version\":\"v0.17.0\",\"released\":\"2016-05-04T21:09:36.358Z\",\"patch\":false,\"highlights\":[\"Tags + Search for Saved Questions\",\"Calculated columns\",\"Faster Syncing of Metadata\",\"Lots of database driver improvements and bug fixes\"]},{\"version\":\"v0.16.1\",\"released\":\"2016-05-04T21:09:36.358Z\",\"patch\":true,\"highlights\":[\"Fixes for several time alignment issues (timezones)\",\"Resolved problem with SQL Server db connections\"]},{\"version\":\"v0.16.0\",\"released\":\"2016-05-04T21:09:36.358Z\",\"patch\":false,\"highlights\":[\"Fullscreen (and fabulous) Dashboards\",\"Say hello to Metabot in Slack\"]}]}'),('version-info-last-checked','2024-07-21T06:15:00.016305Z');
/*!40000 ALTER TABLE `setting` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `streamer`
--

DROP TABLE IF EXISTS `streamer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `streamer` (
  `mid` bigint NOT NULL,
  `user_id` bigint NOT NULL,
  `name` varchar(1024) COLLATE utf8mb4_general_ci NOT NULL,
  UNIQUE KEY `mid` (`mid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `streamer`
--

LOCK TABLES `streamer` WRITE;
/*!40000 ALTER TABLE `streamer` DISABLE KEYS */;
INSERT INTO `streamer` VALUES (3,968453,'猪猪女侠'),(4,351936,'宋昱欣Hitomi'),(5,300895,'账号已注销'),(6,993953,'静静大人'),(7,673951,'Sia不吃鱼'),(8,617336,'咩咩男装穿搭'),(9,534766,'易阳'),(10,840053,'梓琳'),(11,596500,'咩咩阿银'),(12,200557,'银蛇大人'),(14,963187,'恩馨很甜'),(15,392375,'TATTOO-纹身师桃子'),(16,817403,'是胖虎啊'),(17,819074,'一妍爱运动'),(19,615705,'Uu酱'),(20,928612,'小师妹'),(21,801086,'这里是小树苗苗儿'),(22,565089,'大佬甜Giova'),(23,330079,'杨姓奇女子'),(24,602375,'李李好甜'),(25,140913,'MIYA'),(26,350389,'任智桃'),(27,660516,'馨子baby'),(28,800436,'贝蒂蔓蔓'),(29,958821,'夏蓝'),(30,287546,'美酱Nami'),(31,781018,'凌大小姐'),(34,442668,'章鱼小童谣'),(35,724471,'宝宝子'),(36,898644,'性感羊秘'),(37,674687,'沈真理'),(38,253020,'晴子兔'),(41,587943,'安琪啦baby'),(44,462261,'兔心心心'),(48,802354,'陈佩奇'),(50,451014,'呆呆娜'),(58,401732,'文茜'),(59,906134,'账号已注销'),(61,333666,'鱼神'),(62,450855,'媛媛酱SAYUKI'),(63,145557,'相扑猫'),(64,767871,'左公子666'),(65,748245,'王兔兔啊'),(66,312090,'果儿Victoria'),(67,730047,'Dull-迷人'),(68,486245,'杉杉超辣'),(69,902778,'筱洁y'),(71,750695,'卡戴星'),(72,233583,'瘦宝'),(73,754587,'乙醇子'),(74,800110,'保守的妻子'),(75,771817,'俏妞qiaoniutT'),(76,773576,'李嘉欣97'),(77,728667,'不爱笑的赛琳'),(78,105786,'纪念小小V'),(79,630261,'kiko🏹温软净高184'),(81,155254,'女刺客'),(82,388045,'山雀Queen'),(83,158127,'王雨纯'),(84,323167,'凌凌七DL'),(85,332667,'炸蛋boom'),(87,228323,'金金金live'),(88,650778,'奶白鹿神'),(89,209558,'健身猫女'),(90,354499,'多肉大白兔Miko'),(91,636078,'董一涵_'),(92,618827,'大甜甜Bigba'),(93,621957,'君伊eliya'),(94,110493,'水蜜桃米米'),(95,446085,'聂傲娇'),(96,181837,'可馨'),(97,269587,'孟晓艺'),(98,792296,'姐姐LaLion'),(99,743139,'安妮_yo'),(100,625337,'奶瑶妹妹'),(101,219643,'PUPIHAN'),(102,444367,'夏天的小雪'),(103,881121,'麻辣奶兔'),(104,717354,'于芷晴MINI'),(105,616288,'王秋宝'),(106,897649,'铁锤姐姐'),(107,158790,'徐珺大哥'),(109,763926,'我才是岚岚'),(110,649412,'无情近视眼'),(111,148857,'馨馨酱'),(112,407598,'yu酱睡不醒'),(113,829549,'阿色'),(115,760752,'麻利亚辣'),(116,355252,'甜幼清'),(117,694867,'宝儿茹'),(118,384037,'雪怡'),(119,737657,'小艾根本吃不饱'),(120,659544,'小玉吃果冻'),(121,209894,'桃沢樱'),(122,902883,'美晓'),(123,776712,'Carol周妍希'),(124,324934,'圆溜溜啊圆'),(125,758780,'尤妮丝'),(127,893450,'悦悦babe'),(131,406354,'雯宝儿'),(132,275172,'沈汝凡'),(133,648836,'迷人的五姨太'),(134,675205,'赵伊彤'),(135,646340,'徐莉芝booty'),(136,418213,'冲田花老师'),(137,353184,'肉肉菲猪'),(138,351165,'可爱的肉巴'),(139,579626,'美邵女Baby'),(140,408888,'杨晨晨'),(141,556939,'玫玫'),(142,623144,'绮里嘉ula'),(144,761133,'羊羊崽'),(145,443606,'呆萌橘子酱'),(146,101850,'李美兮'),(147,768620,'仙儿'),(148,275362,'玫桃泡芙'),(149,863698,'大冰冰超甜'),(150,817341,'账号已注销'),(151,107004,'一只小胡狸'),(159,272856,'铁粉空间官方'),(245,117198,'陈妮妮'),(283,184127,'什锦金'),(493,546653,'刘有劲'),(501,458408,'西好运'),(507,267348,' 比安卡1995'),(530,815196,'午夜小野马'),(750,784124,'小喵咪ck'),(779,113360,'菠萝包'),(876,152349,'李音'),(897,293350,'陶77'),(898,391262,'林瑞贤在这儿'),(996,247733,'可可西'),(1071,243020,'周可儿yyy'),(1188,688860,'宫本湖泊'),(1258,581784,'撕后刑ss'),(1259,425756,'铠爷'),(1336,763552,'草莓酱yys'),(1471,300581,'姐姐阿竹'),(1624,325087,'欣杨'),(1649,968968,'八尺夫人'),(1740,781984,'阿尔卑香小狗子'),(1832,492987,' 小小西瓜妹～'),(1850,381955,'袍袍'),(1958,121348,'你的蜜桃姨'),(1982,199501,'UI'),(2391,499300,'小妖呀'),(2432,107917,'黎允熙baby'),(2508,404534,'哈哈哈哈哈'),(2608,892166,'白日做梦'),(2634,317448,'早睡羊崽'),(2686,338372,'团酱'),(2895,443213,'皮神'),(2953,909724,'高级白鹿'),(2997,280869,'聂傲娇'),(3169,184057,'娜依灵儿'),(3343,254089,'玲儿'),(3364,500691,'大鹅'),(3367,126513,'单打鱼丸'),(3489,720445,'猫七baby'),(3536,167525,'李妙子'),(3925,714087,'小逗逗蜜桃园'),(3940,835426,'芷仪G宝'),(4474,676774,'御母'),(4497,603792,'小悦悦阿'),(4865,527240,'想想会魔法'),(5051,701601,'丫丫'),(5161,506578,'心动女孩欣欣'),(5545,752956,'于丰霖'),(5620,987370,'崽崽'),(5681,580435,'bobby'),(6069,727220,'兔宝妮'),(6145,932543,'病娇咩咩酱'),(6520,257328,'艾拉·isla'),(6856,424856,'小蒋姐姐'),(7520,951830,'星怡'),(7875,171759,'账号已注销'),(8184,244133,'婷宝小姨'),(9017,636086,'大嫩粉'),(9429,543955,'柳老板_'),(10351,635501,'肥蛇饱饱'),(11146,278535,'甜甜央'),(11583,703267,'午夜小野马'),(12104,358212,'用户358212'),(12771,433999,'玩酱呀'),(12955,590846,'我是你可爱的小猫'),(13208,556936,'阿玉🍒'),(13324,151560,'午夜俱乐部'),(13820,472759,'大静静是个小朋友'),(13862,156665,'luna长腿仙女'),(15851,221455,'橙月儿'),(15949,371511,'文静儿'),(15966,390792,'粉色霸王龙'),(16311,326449,'黑杜宾'),(16477,400642,'小猪佩奇'),(18370,642077,'用户642077'),(18488,490060,'小蕉'),(19230,390191,'Grace'),(19316,354674,'大R老师'),(20475,928000,'胭脂粉粉'),(21951,931544,'爆炒肉肉啦'),(22358,566149,'大晴暴脾气'),(23132,948665,'用户948665'),(23152,401588,'溪月艺潼'),(24457,724793,'可心呀'),(24582,668819,'琪琪甜圈'),(25058,104731,'王心心'),(25114,762345,'雅茹'),(25315,198633,'庆欣有点胖'),(25329,620457,'用户620457'),(26283,324138,'思景MM'),(29980,410302,'婉蓉'),(31476,352039,'清柠呀呀呀'),(31520,345738,'账号已注销'),(31551,205316,'yuki'),(31552,847901,'晴晴'),(33306,754608,'用户754608'),(33487,847944,'姿色'),(34365,172005,'小小奶瓶儿'),(35042,246577,'小辣椒sweet'),(35373,178975,'玉帛Sama'),(36032,626036,'钟垚垚'),(36540,367000,'胖头娃娃鱼'),(37567,632804,'甜心宝贝'),(37634,793009,'小雪家'),(37939,588258,'小厨娘美食记'),(38263,397256,'薄荷大人'),(38971,222677,'贝小七'),(39190,945839,'大萱Amy'),(40441,398180,'绝佳佳'),(42720,860871,'爆炸小熊kuku'),(46055,959236,'沁羽'),(46302,308448,'沁羽'),(48900,469267,'琳琳'),(49436,656916,'Lynn 小静宛'),(51444,253564,'娜娜zzz'),(51609,973218,'不安分的人妻'),(51697,851231,'肉肉'),(52499,172653,'波雅大大'),(52772,765913,'奶糖'),(54525,383335,'soda野'),(55108,591186,'用户591186'),(57245,163876,'小小兔🐰'),(57272,189826,'微密秀直播'),(60553,278478,'账号已注销'),(60978,142816,'库库揍你呀'),(61060,180549,'王婉悠'),(66771,348715,'关于原的诗'),(66930,190912,'大宝贝'),(66961,588727,'王璐瑶的猫'),(67378,270176,'拉露恩'),(67379,286126,'一只辣宝'),(67383,339518,'凌凌七DL'),(67420,844688,'xxuan很困'),(68283,537718,'爱吃蚝仔烙的酱酱'),(68441,973788,'账号已注销'),(68559,173698,'香香de香香'),(69379,306344,'徐樱菡'),(70822,261190,'陈迪娅'),(71287,726144,'白嫚lsa'),(76278,232882,'脸红mm'),(76723,190254,'鱼紫酱'),(77377,730921,'杨桃长大了'),(79390,473434,'Ai二桃'),(79843,904656,'纯欲伊'),(80077,601309,'羊老师-'),(82003,831504,'用户831504'),(82391,334959,'暴虐兔_'),(82414,755511,'56岁后妈'),(84663,127346,'用户127346'),(85910,250082,'林沐瑶'),(87404,549166,'桃子嘟嘟'),(87907,728206,'瑶大美呀'),(89818,128503,'小阮'),(90281,321084,'巴菲音'),(90356,919263,'梦瑶雪儿'),(91236,727286,'你的 00'),(91856,365443,'萌妮妮'),(92413,271650,'話話超棒'),(93963,523813,'李漂亮'),(97359,310196,'兔兔很Sss'),(97857,473995,'芳姨'),(99796,302467,'薄荷大人'),(100601,310077,'千日酱'),(103920,822523,'阿拉蕾'),(105604,331338,'用户331338'),(106148,983565,'满好互娱'),(143961,138798,'辣肉肉Gina'),(144384,520094,'王雨纯'),(145309,849493,'MiKu'),(145740,400262,'美羊羊'),(145806,143257,'程程'),(146007,329143,'账号已注销'),(146166,779846,'欣老板'),(146340,877216,'汐娜'),(146460,993443,'妤丸'),(146545,562768,'小甜酒子'),(147322,252850,'爱吃辣'),(148509,644864,'凡妮莎'),(152001,243640,'小羊怕疼'),(153632,607576,'七七仙女'),(158395,492175,'妮好甜🐰'),(159566,710566,'小莹喜欢狗'),(161609,947097,'小王同学'),(162710,532352,'兰花仙子'),(162816,850230,'小斧牙'),(163374,344527,'小小苏妲己'),(163608,353794,'么凹猫'),(163660,574059,'叶子姐姐'),(164533,631165,'米晨'),(164630,926263,'姑苏酥酥'),(166037,347192,'美一人虞'),(167340,465820,'抓小乖'),(169095,336623,'草莓不可爱'),(172477,219189,'快手琳琳小公主'),(172731,333372,'款嫂'),(173051,918811,'茜怡'),(173304,550071,'账号已注销'),(174440,798116,'是姨也是姐'),(175834,366486,'小逗逗'),(176342,875112,'不好玩'),(177637,334117,'美少女13'),(178210,721139,'桥本环梦'),(179782,861732,'F姐姐呀'),(180889,518964,'秋不吃鱼'),(182308,397673,'柯宝碎碎念'),(184293,677337,'冰冰'),(185893,468226,'苏老师超棒s'),(187760,344209,'大G宝'),(190618,515701,'小希🍮'),(191324,965418,'用户965418'),(192434,433160,'阿爽'),(192549,744706,'账号已注销'),(193781,309344,'林汐韵-yyo'),(194448,938978,'小墨迹'),(195763,811053,'彤の'),(197811,463700,'奶雾喵'),(199188,890131,'酷奇儿'),(202826,556326,'女王的后花园'),(204372,495532,'用户495532'),(205940,923715,'壹奈多香'),(206164,704992,'账号已注销'),(206580,867784,'蛋炒饭好吃'),(208778,694226,'是田不是甜'),(209473,110875,'甜粥'),(210852,936467,'艾曦_lcey'),(212561,554518,'猪儿虫'),(213014,746277,'野生小鹿'),(213554,458901,'一念星辰'),(214911,360350,'水梨夫人🍐'),(215008,612442,'丰满秘书日常'),(215135,309225,'慵懒小新'),(215240,581343,'无情后妈不减脂'),(217606,346812,'柚柚琪宝'),(217860,948961,'桃桃🍑'),(218851,688704,'男王'),(220411,106516,'秀人XIUREN'),(226924,203069,'小熊五花肉'),(227196,622587,'黑森林中的粉红鲍'),(228265,414839,'爱疯13妹'),(228359,315751,'金喜妹妹'),(229743,376678,'用户376678'),(230965,594639,'健身的桃桃'),(239368,690991,'一颗小金桔'),(240225,484398,'一位很正的阿姨'),(242263,513210,'陈露露'),(243225,461378,'用户461378'),(243875,318127,'胖宁'),(249042,829329,'蒙蒙子'),(252780,543571,'账号已注销'),(254325,206323,'绝美可砸'),(254587,830707,'用户830707'),(258846,746079,'禾子'),(259111,313416,'芥妹帅'),(259476,955728,'侯阳靖雯'),(263758,336894,'伽罗'),(263921,610397,'肖甜'),(264877,862194,'账号已注销'),(267713,439858,'小依'),(267884,869711,'王蕊儿'),(268493,517785,'甜七七'),(268954,242331,'小文同学'),(269339,800547,'矫矫'),(269583,127781,'迷妹啊'),(269632,567851,'ss小点点'),(270017,680442,'梨涡狼姐'),(270232,803677,'菀菀'),(270602,319272,'冰.—'),(270888,832269,'李漂亮🦊'),(273575,956095,'小馋猫'),(274697,746123,'情酱'),(275013,841976,'朵茜'),(275732,588239,'小茹茹'),(276039,834923,'菜小葵'),(276071,861283,'雅丘小圆'),(276120,562693,'炸弹椅'),(276466,377132,'小虎'),(279590,850633,'奈奥米Naomi'),(280318,325431,'猫小妖🐱'),(280544,112932,'123'),(293390,169057,'温舒蕾'),(293753,647561,'苦茶子'),(296457,125292,'安娜金'),(296564,414387,'老婆饼'),(300771,145137,'济南摄影遥远'),(301759,476219,'小羊u'),(302200,155550,'欠揍'),(308732,695244,'人间水蜜桃'),(308873,774789,'尾巴酱'),(310356,114410,'Linda琳儿'),(311294,219844,'小姨'),(312807,270601,'玉子烧'),(317098,826968,'许雯Amy'),(317333,320658,'账号已注销'),(320610,954933,'我是ou'),(322645,659588,'moon酱'),(323517,781789,'困鼠'),(326483,842498,'兰兰小可爱'),(327391,538214,'舔舔'),(328717,571068,'小鹿奶啤'),(329947,688576,'吉宝宝宝'),(330130,678391,'黑闰润'),(330205,232585,'羽儿'),(330649,894664,'XY'),(335318,934640,'奶涵大白兔'),(335373,652745,'周姨姨'),(335577,924346,'壮壮姐姐'),(335736,856151,'泡芙'),(337587,391826,'是秀秀呀'),(337626,363364,'秦梦姐姐'),(337829,191935,'乖乖琦'),(338334,873354,'张有财（必发财版'),(338605,527300,'洋洋不是洋妞'),(341103,428611,'毅宝宝'),(341351,870802,'娜娜会脸红'),(341834,107874,'雪墩墩'),(342076,945338,'大宝ootd'),(342468,130527,'六六小阿姨'),(342969,420216,'学中医的土狗'),(344012,736360,'夹心饼干包'),(344664,214416,'小贝不吃鱼啊'),(344844,222935,'搞笑女'),(345300,110208,'En1x1'),(345521,262712,'苏古拉'),(345859,725246,'尽情释放'),(346732,274902,'恩雅'),(347900,470004,'我会炸'),(348187,651851,'樱桃小狗'),(348500,270152,'嘎嘎乱杀'),(348616,687518,'傲娇公主👠'),(348991,689989,'恩沈一点'),(349805,678107,'一口奶酱'),(351513,167171,'徐子蜜'),(352007,502570,'肉丝很烦恼'),(352353,128143,'Layla小拉蕾'),(352787,442209,'虞美人'),(352921,940934,'蔡文姬'),(352924,540639,'嘟媛'),(353051,224846,'林汐'),(353654,680541,'婷妹儿'),(353681,262466,'Yogurt'),(353921,243721,'一口两支冰淇淋'),(354058,408505,'于熙妍wink'),(354125,257859,'奶糖'),(354236,461943,'鹅鹅🦢'),(355229,999286,'王戴珊'),(356071,763546,'菲兮'),(356408,404190,'🍓草莓小狗🍓'),(356641,658274,'闪现一只高高'),(356737,641394,'一只发财的兔头'),(357096,120854,'畅畅'),(357146,660452,'琳崽'),(357181,420043,'小奈奈yuna'),(357669,141985,'枳侑十二'),(358886,953814,'智惠姐姐'),(359048,538101,'董大侠'),(359406,253093,'混血Makiyo'),(360080,964464,'妹妹'),(360323,634232,'你的玥宝啊'),(360412,830399,'小野'),(361340,470746,'失眠小薯'),(365051,982640,'Y7w'),(366194,533652,'娜娜小姨'),(367375,410743,'发疯小猫brat'),(367849,473024,'酥酥'),(370070,746521,'九亿星河'),(370793,508215,'落难小兔'),(371145,670679,'账号已注销'),(371600,101530,'邪龙大人'),(373789,509251,'童颜小巨巨1'),(374749,393548,'甜心小琪'),(376093,431698,'小奶芙'),(376243,688966,'酷野'),(377767,136999,'雯雯要亲亲'),(378027,217064,'陈晓晴'),(378518,458819,'臀模'),(378891,925736,'网红戴渃欣'),(379005,765626,'童颜小巨巨'),(379253,497289,'我是霏霏'),(380316,235069,'皮神'),(380647,172129,'angel'),(380765,857979,'雅丘小圆'),(381577,593513,'琳什么琳'),(382101,595705,'陈幼恩'),(382874,508511,'KIDP'),(383225,161227,'懒66'),(386910,830043,'Bangni邦尼'),(387243,145872,'朴羽琦'),(388957,947631,'小诗'),(389643,692525,'美味蛋堡'),(389928,479095,'蓓蕾秋语'),(390102,716817,'喵喵女王'),(391886,575052,'如如u'),(392278,256712,'灵灵大人'),(392896,477158,'小仙女凤儿'),(393152,518878,'利世'),(393298,269580,'小水星'),(393529,877093,'秋月辰时'),(396777,149127,'没有sense'),(397554,493755,'草莓小狗'),(399206,150057,'一只虐'),(399212,217367,'讨厌吃香菜'),(399876,139813,'乐安小姨'),(401922,679501,'周若嫣-Quen'),(402096,212674,'野合结衣'),(404583,616367,'丢丢不乖'),(404820,571603,'Ni的猫'),(406241,547035,'哥屋恩'),(406445,479500,'怎么快乐怎么来'),(408607,416495,'爱猪猪ya'),(408708,638202,'王兮悦'),(408893,400110,'用户400110'),(409130,809338,'张茄茄'),(409145,554851,'STBZYU'),(409201,390947,'小南宝'),(410700,331904,'喝不了滚'),(412300,418206,'小桃咩VOV'),(412533,477306,'呆猫猫m_'),(412764,169122,'最优解'),(412769,781248,'小查要变瘦'),(414419,617134,'Tina很妖孽呀'),(414568,222660,'小盐蛋喵'),(414570,860832,'不要说我很漂亮'),(414996,764154,'小小喻宝'),(416251,754014,'lelepigbaby_'),(418307,401755,'高蒂 Godet'),(420413,499852,'宅初初'),(421224,375431,'想听花海'),(421229,821528,'娜娜ovo'),(421408,151453,'我不是金莲'),(421498,909982,'柳柳'),(421672,344943,'用户344943'),(421876,906606,'你的小榕'),(421951,455105,'摇一摇'),(422423,913767,'爆辣爆米花儿'),(424452,735437,'怼怼超凶'),(425002,831638,'郑合伽子'),(425180,266297,'燕燕无敌'),(425534,181140,'夏小小'),(425674,956569,'Maymay'),(426274,126372,'金金洋'),(426738,185441,'火楽'),(427317,660964,'香秀'),(429542,300597,'薇薇'),(429897,207845,'卡妮莎'),(430335,301222,'海·'),(430734,289214,'麻辣溜溜梅'),(431977,722420,'UU酱'),(432362,229721,'樱桃～'),(432447,184058,'用户184058'),(432893,645696,'INJOKEMI'),(432959,238921,'百变少女'),(435296,323128,'娜宝宝'),(436883,590090,'小美爱吃肉'),(437347,210783,'小云同学'),(437450,932004,'房老板'),(437526,494132,'酷奇儿');
/*!40000 ALTER TABLE `streamer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `table_privileges`
--

DROP TABLE IF EXISTS `table_privileges`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `table_privileges` (
  `table_id` int NOT NULL COMMENT 'Table ID',
  `role` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Role name. NULL indicates the privileges are the current user''s',
  `select` bit(1) NOT NULL DEFAULT b'0',
  `update` bit(1) NOT NULL DEFAULT b'0',
  `insert` bit(1) NOT NULL DEFAULT b'0',
  `delete` bit(1) NOT NULL DEFAULT b'0',
  KEY `fk_table_privileges_table_id` (`table_id`),
  KEY `idx_table_privileges_role` (`role`),
  CONSTRAINT `fk_table_privileges_table_id` FOREIGN KEY (`table_id`) REFERENCES `metabase_table` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table for user and role privileges by table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `table_privileges`
--

LOCK TABLES `table_privileges` WRITE;
/*!40000 ALTER TABLE `table_privileges` DISABLE KEYS */;
/*!40000 ALTER TABLE `table_privileges` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_history`
--

DROP TABLE IF EXISTS `task_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `task_history` (
  `id` int NOT NULL AUTO_INCREMENT,
  `task` varchar(254) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Name of the task',
  `db_id` int DEFAULT NULL,
  `started_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6),
  `ended_at` timestamp(6) NULL DEFAULT NULL,
  `duration` int DEFAULT NULL,
  `task_details` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `status` varchar(21) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'started' COMMENT 'the status of task history, could be started, failed, success, unknown',
  PRIMARY KEY (`id`),
  KEY `idx_task_history_end_time` (`ended_at`),
  KEY `idx_task_history_db_id` (`db_id`),
  KEY `idx_task_history_started_at` (`started_at`)
) ENGINE=InnoDB AUTO_INCREMENT=10209 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Timing and metadata info about background/quartz processes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_history`
--

LOCK TABLES `task_history` WRITE;
/*!40000 ALTER TABLE `task_history` DISABLE KEYS */;
INSERT INTO `task_history` VALUES (1,'sync',1,'2024-06-19 06:13:30.792604','2024-06-19 06:13:33.718378',2925,NULL,'success'),(2,'sync-dbms-version',1,'2024-06-19 06:13:30.832099','2024-06-19 06:13:30.852284',20,'{\"flavor\":\"H2\",\"version\":\"2.1.214 (2022-06-13)\",\"semantic-version\":[2,1]}','success'),(3,'sync-timezone',1,'2024-06-19 06:13:30.879872','2024-06-19 06:13:30.959302',79,'{\"timezone-id\":\"GMT\"}','success'),(4,'sync-tables',1,'2024-06-19 06:13:30.985321','2024-06-19 06:13:31.049298',63,'{\"updated-tables\":0,\"total-tables\":8}','success'),(5,'sync-fields',1,'2024-06-19 06:13:31.070236','2024-06-19 06:13:31.418461',348,'{\"total-fields\":71,\"updated-fields\":0}','success'),(6,'sync-fks',1,'2024-06-19 06:13:31.455928','2024-06-19 06:13:31.553862',97,'{\"total-fks\":6,\"updated-fks\":0,\"total-failed\":0}','success'),(7,'sync-indexes',1,'2024-06-19 06:13:31.585973','2024-06-19 06:13:32.126133',540,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8,'sync-metabase-metadata',1,'2024-06-19 06:13:32.148691','2024-06-19 06:13:33.670715',1522,'{}','success'),(9,'sync-table-privileges',1,'2024-06-19 06:13:33.685970','2024-06-19 06:13:33.698852',12,NULL,'success'),(10,'analyze',1,'2024-06-19 06:13:33.753859','2024-06-19 06:13:33.943000',189,NULL,'success'),(11,'fingerprint-fields',1,'2024-06-19 06:13:33.764148','2024-06-19 06:13:33.834447',70,'{\"no-data-fingerprints\":0,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":0}','success'),(12,'classify-fields',1,'2024-06-19 06:13:33.847077','2024-06-19 06:13:33.888614',41,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(13,'classify-tables',1,'2024-06-19 06:13:33.900440','2024-06-19 06:13:33.926500',26,'{\"total-tables\":8,\"tables-classified\":0}','success'),(14,'field values scanning',1,'2024-06-19 06:13:33.973899','2024-06-19 06:13:36.691094',2717,NULL,'success'),(15,'delete-expired-advanced-field-values',1,'2024-06-19 06:13:34.001831','2024-06-19 06:13:34.569876',568,'{\"deleted\":0}','success'),(16,'update-field-values',1,'2024-06-19 06:13:34.586054','2024-06-19 06:13:36.674823',2088,'{\"errors\":0,\"created\":24,\"updated\":0,\"deleted\":0}','success'),(17,'sync',2,'2024-06-19 06:18:15.511690','2024-06-19 06:18:30.350768',14839,NULL,'success'),(18,'sync-dbms-version',2,'2024-06-19 06:18:15.522798','2024-06-19 06:18:15.582762',59,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(19,'sync-timezone',2,'2024-06-19 06:18:15.613663','2024-06-19 06:18:15.684280',70,'{\"timezone-id\":\"+08:00\"}','success'),(20,'sync-tables',2,'2024-06-19 06:18:15.695859','2024-06-19 06:18:19.138713',3442,'{\"updated-tables\":99,\"total-tables\":0}','success'),(21,'sync-fields',2,'2024-06-19 06:18:19.150792','2024-06-19 06:18:25.301943',6151,'{\"total-fields\":836,\"updated-fields\":836}','success'),(22,'sync-fks',2,'2024-06-19 06:18:25.312686','2024-06-19 06:18:26.865577',1552,'{\"total-fks\":113,\"updated-fks\":113,\"total-failed\":0}','success'),(23,'sync-indexes',2,'2024-06-19 06:18:26.875863','2024-06-19 06:18:30.289247',3413,'{\"total-indexes\":226,\"added-indexes\":226,\"removed-indexes\":0}','success'),(24,'sync-metabase-metadata',2,'2024-06-19 06:18:30.299416','2024-06-19 06:18:30.310372',10,'{}','success'),(25,'sync-table-privileges',2,'2024-06-19 06:18:30.328231','2024-06-19 06:18:30.340861',12,NULL,'success'),(26,'analyze',2,'2024-06-19 06:18:30.415383','2024-06-19 06:18:48.710913',18295,NULL,'success'),(27,'fingerprint-fields',2,'2024-06-19 06:18:30.430338','2024-06-19 06:18:43.917839',13487,'{\"no-data-fingerprints\":386,\"failed-fingerprints\":0,\"updated-fingerprints\":367,\"fingerprints-attempted\":753}','success'),(28,'classify-fields',2,'2024-06-19 06:18:43.926821','2024-06-19 06:18:47.707009',3780,'{\"fields-classified\":367,\"fields-failed\":0}','success'),(29,'classify-tables',2,'2024-06-19 06:18:47.716060','2024-06-19 06:18:48.701642',985,'{\"total-tables\":92,\"tables-classified\":92}','success'),(30,'field values scanning',2,'2024-06-19 06:18:48.910950','2024-06-19 06:19:06.250067',17339,NULL,'success'),(31,'delete-expired-advanced-field-values',2,'2024-06-19 06:18:48.923705','2024-06-19 06:18:52.788505',3864,'{\"deleted\":0}','success'),(32,'update-field-values',2,'2024-06-19 06:18:52.800979','2024-06-19 06:19:06.240434',13439,'{\"errors\":0,\"created\":272,\"updated\":0,\"deleted\":1}','success'),(33,'sync',2,'2024-06-19 06:45:00.121570','2024-06-19 06:45:05.024665',4903,NULL,'success'),(34,'sync-dbms-version',2,'2024-06-19 06:45:00.131497','2024-06-19 06:45:00.143188',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(35,'sync-timezone',2,'2024-06-19 06:45:00.153375','2024-06-19 06:45:00.165616',12,'{\"timezone-id\":\"+08:00\"}','success'),(36,'sync-tables',2,'2024-06-19 06:45:00.175499','2024-06-19 06:45:00.210265',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(37,'sync-fields',2,'2024-06-19 06:45:00.221270','2024-06-19 06:45:03.500054',3278,'{\"total-fields\":836,\"updated-fields\":0}','success'),(38,'sync-fks',2,'2024-06-19 06:45:03.509113','2024-06-19 06:45:04.307144',798,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(39,'sync-indexes',2,'2024-06-19 06:45:04.317840','2024-06-19 06:45:04.978050',660,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(40,'sync-metabase-metadata',2,'2024-06-19 06:45:04.986078','2024-06-19 06:45:04.995075',9,'{}','success'),(41,'sync-table-privileges',2,'2024-06-19 06:45:05.004722','2024-06-19 06:45:05.015074',10,NULL,'success'),(42,'analyze',2,'2024-06-19 06:45:05.055960','2024-06-19 06:45:09.212417',4156,NULL,'success'),(43,'fingerprint-fields',2,'2024-06-19 06:45:05.065333','2024-06-19 06:45:08.419365',3354,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":66,\"fingerprints-attempted\":386}','success'),(44,'classify-fields',2,'2024-06-19 06:45:08.431677','2024-06-19 06:45:09.178740',747,'{\"fields-classified\":66,\"fields-failed\":0}','success'),(45,'classify-tables',2,'2024-06-19 06:45:09.186859','2024-06-19 06:45:09.203531',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(46,'sync',2,'2024-06-19 07:45:00.147792','2024-06-19 07:45:04.782656',4634,NULL,'success'),(47,'sync-dbms-version',2,'2024-06-19 07:45:00.159240','2024-06-19 07:45:00.170767',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(48,'sync-timezone',2,'2024-06-19 07:45:00.179842','2024-06-19 07:45:00.192712',12,'{\"timezone-id\":\"+08:00\"}','success'),(49,'sync-tables',2,'2024-06-19 07:45:00.203443','2024-06-19 07:45:00.235268',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(50,'sync-fields',2,'2024-06-19 07:45:00.249283','2024-06-19 07:45:03.514687',3265,'{\"total-fields\":836,\"updated-fields\":0}','success'),(51,'sync-fks',2,'2024-06-19 07:45:03.530318','2024-06-19 07:45:04.164300',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(52,'sync-indexes',2,'2024-06-19 07:45:04.173603','2024-06-19 07:45:04.740157',566,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(53,'sync-metabase-metadata',2,'2024-06-19 07:45:04.747883','2024-06-19 07:45:04.756225',8,'{}','success'),(54,'sync-table-privileges',2,'2024-06-19 07:45:04.765092','2024-06-19 07:45:04.774064',8,NULL,'success'),(55,'analyze',2,'2024-06-19 07:45:04.810551','2024-06-19 07:45:07.303811',2493,NULL,'success'),(56,'fingerprint-fields',2,'2024-06-19 07:45:04.821396','2024-06-19 07:45:07.123668',2302,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(57,'classify-fields',2,'2024-06-19 07:45:07.132968','2024-06-19 07:45:07.268445',135,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(58,'classify-tables',2,'2024-06-19 07:45:07.277203','2024-06-19 07:45:07.293332',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(59,'sync',2,'2024-06-19 08:45:00.122800','2024-06-19 08:45:04.669408',4546,NULL,'success'),(60,'sync-dbms-version',2,'2024-06-19 08:45:00.133026','2024-06-19 08:45:00.143374',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(61,'sync-timezone',2,'2024-06-19 08:45:00.153015','2024-06-19 08:45:00.166103',13,'{\"timezone-id\":\"+08:00\"}','success'),(62,'sync-tables',2,'2024-06-19 08:45:00.175659','2024-06-19 08:45:00.204809',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(63,'sync-fields',2,'2024-06-19 08:45:00.215708','2024-06-19 08:45:03.425059',3209,'{\"total-fields\":836,\"updated-fields\":0}','success'),(64,'sync-fks',2,'2024-06-19 08:45:03.433093','2024-06-19 08:45:04.043709',610,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(65,'sync-indexes',2,'2024-06-19 08:45:04.052607','2024-06-19 08:45:04.624499',571,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(66,'sync-metabase-metadata',2,'2024-06-19 08:45:04.632738','2024-06-19 08:45:04.640911',8,'{}','success'),(67,'sync-table-privileges',2,'2024-06-19 08:45:04.649541','2024-06-19 08:45:04.658967',9,NULL,'success'),(68,'analyze',2,'2024-06-19 08:45:04.699659','2024-06-19 08:45:07.223656',2524,NULL,'success'),(69,'fingerprint-fields',2,'2024-06-19 08:45:04.708774','2024-06-19 08:45:07.046912',2338,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(70,'classify-fields',2,'2024-06-19 08:45:07.070790','2024-06-19 08:45:07.185163',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(71,'classify-tables',2,'2024-06-19 08:45:07.192791','2024-06-19 08:45:07.207439',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(72,'sync',2,'2024-06-19 09:45:00.120116','2024-06-19 09:45:04.462573',4342,NULL,'success'),(73,'sync-dbms-version',2,'2024-06-19 09:45:00.130675','2024-06-19 09:45:00.139930',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(74,'sync-timezone',2,'2024-06-19 09:45:00.149051','2024-06-19 09:45:00.159026',9,'{\"timezone-id\":\"+08:00\"}','success'),(75,'sync-tables',2,'2024-06-19 09:45:00.168002','2024-06-19 09:45:00.196534',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(76,'sync-fields',2,'2024-06-19 09:45:00.206124','2024-06-19 09:45:03.127886',2921,'{\"total-fields\":836,\"updated-fields\":0}','success'),(77,'sync-fks',2,'2024-06-19 09:45:03.135842','2024-06-19 09:45:03.762771',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(78,'sync-indexes',2,'2024-06-19 09:45:03.772210','2024-06-19 09:45:04.415770',643,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(79,'sync-metabase-metadata',2,'2024-06-19 09:45:04.427335','2024-06-19 09:45:04.435597',8,'{}','success'),(80,'sync-table-privileges',2,'2024-06-19 09:45:04.445072','2024-06-19 09:45:04.453108',8,NULL,'success'),(81,'analyze',2,'2024-06-19 09:45:04.492590','2024-06-19 09:45:06.820608',2328,NULL,'success'),(82,'fingerprint-fields',2,'2024-06-19 09:45:04.502176','2024-06-19 09:45:06.646841',2144,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(83,'classify-fields',2,'2024-06-19 09:45:06.660264','2024-06-19 09:45:06.783022',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(84,'classify-tables',2,'2024-06-19 09:45:06.794605','2024-06-19 09:45:06.811500',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(85,'sync',2,'2024-06-19 10:45:00.119445','2024-06-19 10:45:04.795362',4675,NULL,'success'),(86,'sync-dbms-version',2,'2024-06-19 10:45:00.128312','2024-06-19 10:45:00.139362',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(87,'sync-timezone',2,'2024-06-19 10:45:00.148759','2024-06-19 10:45:00.159656',10,'{\"timezone-id\":\"+08:00\"}','success'),(88,'sync-tables',2,'2024-06-19 10:45:00.169014','2024-06-19 10:45:00.200401',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(89,'sync-fields',2,'2024-06-19 10:45:00.222483','2024-06-19 10:45:03.457747',3235,'{\"total-fields\":836,\"updated-fields\":0}','success'),(90,'sync-fks',2,'2024-06-19 10:45:03.466302','2024-06-19 10:45:04.126019',659,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(91,'sync-indexes',2,'2024-06-19 10:45:04.138152','2024-06-19 10:45:04.752808',614,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(92,'sync-metabase-metadata',2,'2024-06-19 10:45:04.760602','2024-06-19 10:45:04.769691',9,'{}','success'),(93,'sync-table-privileges',2,'2024-06-19 10:45:04.778755','2024-06-19 10:45:04.787212',8,NULL,'success'),(94,'analyze',2,'2024-06-19 10:45:04.822949','2024-06-19 10:45:07.056520',2233,NULL,'success'),(95,'fingerprint-fields',2,'2024-06-19 10:45:04.831528','2024-06-19 10:45:06.881320',2049,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(96,'classify-fields',2,'2024-06-19 10:45:06.890747','2024-06-19 10:45:07.022068',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(97,'classify-tables',2,'2024-06-19 10:45:07.031199','2024-06-19 10:45:07.047479',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(98,'sync',2,'2024-06-19 11:45:00.126523','2024-06-19 11:45:04.558028',4431,NULL,'success'),(99,'sync-dbms-version',2,'2024-06-19 11:45:00.134897','2024-06-19 11:45:00.144221',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(100,'sync-timezone',2,'2024-06-19 11:45:00.153909','2024-06-19 11:45:00.168438',14,'{\"timezone-id\":\"+08:00\"}','success'),(101,'sync-tables',2,'2024-06-19 11:45:00.177967','2024-06-19 11:45:00.207972',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(102,'sync-fields',2,'2024-06-19 11:45:00.217670','2024-06-19 11:45:03.248879',3031,'{\"total-fields\":836,\"updated-fields\":0}','success'),(103,'sync-fks',2,'2024-06-19 11:45:03.258609','2024-06-19 11:45:03.936449',677,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(104,'sync-indexes',2,'2024-06-19 11:45:03.945555','2024-06-19 11:45:04.512612',567,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(105,'sync-metabase-metadata',2,'2024-06-19 11:45:04.520949','2024-06-19 11:45:04.530746',9,'{}','success'),(106,'sync-table-privileges',2,'2024-06-19 11:45:04.540830','2024-06-19 11:45:04.549800',8,NULL,'success'),(107,'analyze',2,'2024-06-19 11:45:04.582933','2024-06-19 11:45:06.569954',1987,NULL,'success'),(108,'fingerprint-fields',2,'2024-06-19 11:45:04.592870','2024-06-19 11:45:06.415635',1822,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(109,'classify-fields',2,'2024-06-19 11:45:06.424631','2024-06-19 11:45:06.538602',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(110,'classify-tables',2,'2024-06-19 11:45:06.546949','2024-06-19 11:45:06.561395',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(111,'sync',2,'2024-06-19 12:45:00.111873','2024-06-19 12:45:04.401725',4289,NULL,'success'),(112,'sync-dbms-version',2,'2024-06-19 12:45:00.122314','2024-06-19 12:45:00.133791',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(113,'sync-timezone',2,'2024-06-19 12:45:00.143862','2024-06-19 12:45:00.154743',10,'{\"timezone-id\":\"+08:00\"}','success'),(114,'sync-tables',2,'2024-06-19 12:45:00.165446','2024-06-19 12:45:00.194331',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(115,'sync-fields',2,'2024-06-19 12:45:00.205374','2024-06-19 12:45:03.268263',3062,'{\"total-fields\":836,\"updated-fields\":0}','success'),(116,'sync-fks',2,'2024-06-19 12:45:03.278400','2024-06-19 12:45:03.839812',561,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(117,'sync-indexes',2,'2024-06-19 12:45:03.848054','2024-06-19 12:45:04.357102',509,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(118,'sync-metabase-metadata',2,'2024-06-19 12:45:04.365108','2024-06-19 12:45:04.374699',9,'{}','success'),(119,'sync-table-privileges',2,'2024-06-19 12:45:04.384494','2024-06-19 12:45:04.394110',9,NULL,'success'),(120,'analyze',2,'2024-06-19 12:45:04.429312','2024-06-19 12:45:06.586042',2156,NULL,'success'),(121,'fingerprint-fields',2,'2024-06-19 12:45:04.437355','2024-06-19 12:45:06.417257',1979,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(122,'classify-fields',2,'2024-06-19 12:45:06.429279','2024-06-19 12:45:06.552374',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(123,'classify-tables',2,'2024-06-19 12:45:06.559929','2024-06-19 12:45:06.575193',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(124,'field values scanning',2,'2024-06-19 13:00:00.048798','2024-06-19 13:00:13.440769',13391,NULL,'success'),(125,'delete-expired-advanced-field-values',2,'2024-06-19 13:00:00.068907','2024-06-19 13:00:03.185266',3116,'{\"deleted\":0}','success'),(126,'update-field-values',2,'2024-06-19 13:00:03.192479','2024-06-19 13:00:13.431878',10239,'{\"errors\":0,\"created\":56,\"updated\":74,\"deleted\":1}','success'),(127,'sync',2,'2024-06-19 13:45:00.105601','2024-06-19 13:45:04.491472',4385,NULL,'success'),(128,'sync-dbms-version',2,'2024-06-19 13:45:00.114783','2024-06-19 13:45:00.125381',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(129,'sync-timezone',2,'2024-06-19 13:45:00.136281','2024-06-19 13:45:00.149645',13,'{\"timezone-id\":\"+08:00\"}','success'),(130,'sync-tables',2,'2024-06-19 13:45:00.159698','2024-06-19 13:45:00.187387',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(131,'sync-fields',2,'2024-06-19 13:45:00.195629','2024-06-19 13:45:03.191727',2996,'{\"total-fields\":836,\"updated-fields\":0}','success'),(132,'sync-fks',2,'2024-06-19 13:45:03.201856','2024-06-19 13:45:03.836312',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(133,'sync-indexes',2,'2024-06-19 13:45:03.845392','2024-06-19 13:45:04.444262',598,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(134,'sync-metabase-metadata',2,'2024-06-19 13:45:04.454824','2024-06-19 13:45:04.464242',9,'{}','success'),(135,'sync-table-privileges',2,'2024-06-19 13:45:04.473033','2024-06-19 13:45:04.482672',9,NULL,'success'),(136,'analyze',2,'2024-06-19 13:45:04.518513','2024-06-19 13:45:06.637127',2118,NULL,'success'),(137,'fingerprint-fields',2,'2024-06-19 13:45:04.527414','2024-06-19 13:45:06.481139',1953,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(138,'classify-fields',2,'2024-06-19 13:45:06.489281','2024-06-19 13:45:06.605442',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(139,'classify-tables',2,'2024-06-19 13:45:06.613345','2024-06-19 13:45:06.629288',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(140,'sync',2,'2024-06-19 14:45:00.118522','2024-06-19 14:45:04.622047',4503,NULL,'success'),(141,'sync-dbms-version',2,'2024-06-19 14:45:00.126734','2024-06-19 14:45:00.136223',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(142,'sync-timezone',2,'2024-06-19 14:45:00.148618','2024-06-19 14:45:00.167914',19,'{\"timezone-id\":\"+08:00\"}','success'),(143,'sync-tables',2,'2024-06-19 14:45:00.176253','2024-06-19 14:45:00.204310',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(144,'sync-fields',2,'2024-06-19 14:45:00.213672','2024-06-19 14:45:03.411356',3197,'{\"total-fields\":836,\"updated-fields\":0}','success'),(145,'sync-fks',2,'2024-06-19 14:45:03.419791','2024-06-19 14:45:04.072681',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(146,'sync-indexes',2,'2024-06-19 14:45:04.082226','2024-06-19 14:45:04.575553',493,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(147,'sync-metabase-metadata',2,'2024-06-19 14:45:04.583232','2024-06-19 14:45:04.593812',10,'{}','success'),(148,'sync-table-privileges',2,'2024-06-19 14:45:04.602568','2024-06-19 14:45:04.612349',9,NULL,'success'),(149,'analyze',2,'2024-06-19 14:45:04.648871','2024-06-19 14:45:06.695164',2046,NULL,'success'),(150,'fingerprint-fields',2,'2024-06-19 14:45:04.657147','2024-06-19 14:45:06.543766',1886,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(151,'classify-fields',2,'2024-06-19 14:45:06.552138','2024-06-19 14:45:06.662110',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(152,'classify-tables',2,'2024-06-19 14:45:06.670031','2024-06-19 14:45:06.684962',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(153,'sync',2,'2024-06-19 15:45:00.131753','2024-06-19 15:45:04.676182',4544,NULL,'success'),(154,'sync-dbms-version',2,'2024-06-19 15:45:00.140935','2024-06-19 15:45:00.151652',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(155,'sync-timezone',2,'2024-06-19 15:45:00.161760','2024-06-19 15:45:00.174038',12,'{\"timezone-id\":\"+08:00\"}','success'),(156,'sync-tables',2,'2024-06-19 15:45:00.183007','2024-06-19 15:45:00.215207',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(157,'sync-fields',2,'2024-06-19 15:45:00.224976','2024-06-19 15:45:03.463671',3238,'{\"total-fields\":836,\"updated-fields\":0}','success'),(158,'sync-fks',2,'2024-06-19 15:45:03.473124','2024-06-19 15:45:04.078395',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(159,'sync-indexes',2,'2024-06-19 15:45:04.087223','2024-06-19 15:45:04.636161',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(160,'sync-metabase-metadata',2,'2024-06-19 15:45:04.643675','2024-06-19 15:45:04.651635',7,'{}','success'),(161,'sync-table-privileges',2,'2024-06-19 15:45:04.659525','2024-06-19 15:45:04.667701',8,NULL,'success'),(162,'analyze',2,'2024-06-19 15:45:04.705064','2024-06-19 15:45:06.831518',2126,NULL,'success'),(163,'fingerprint-fields',2,'2024-06-19 15:45:04.713575','2024-06-19 15:45:06.675018',1961,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(164,'classify-fields',2,'2024-06-19 15:45:06.684251','2024-06-19 15:45:06.799985',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(165,'classify-tables',2,'2024-06-19 15:45:06.807994','2024-06-19 15:45:06.822990',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(166,'task-history-cleanup',NULL,'2024-06-19 16:00:00.018353','2024-06-19 16:00:00.061507',43,NULL,'success'),(167,'task-history-cleanup',NULL,'2024-06-19 16:00:00.135621','2024-06-19 16:00:00.208534',72,NULL,'success'),(168,'sync',2,'2024-06-19 16:45:00.124445','2024-06-19 16:45:04.520751',4396,NULL,'success'),(169,'sync-dbms-version',2,'2024-06-19 16:45:00.132765','2024-06-19 16:45:00.142245',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(170,'sync-timezone',2,'2024-06-19 16:45:00.150873','2024-06-19 16:45:00.164936',14,'{\"timezone-id\":\"+08:00\"}','success'),(171,'sync-tables',2,'2024-06-19 16:45:00.173027','2024-06-19 16:45:00.200071',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(172,'sync-fields',2,'2024-06-19 16:45:00.220468','2024-06-19 16:45:03.214933',2994,'{\"total-fields\":836,\"updated-fields\":0}','success'),(173,'sync-fks',2,'2024-06-19 16:45:03.224480','2024-06-19 16:45:03.842502',618,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(174,'sync-indexes',2,'2024-06-19 16:45:03.851196','2024-06-19 16:45:04.471873',620,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(175,'sync-metabase-metadata',2,'2024-06-19 16:45:04.481058','2024-06-19 16:45:04.488863',7,'{}','success'),(176,'sync-table-privileges',2,'2024-06-19 16:45:04.500715','2024-06-19 16:45:04.510692',9,NULL,'success'),(177,'analyze',2,'2024-06-19 16:45:04.555349','2024-06-19 16:45:06.632810',2077,NULL,'success'),(178,'fingerprint-fields',2,'2024-06-19 16:45:04.564651','2024-06-19 16:45:06.492342',1927,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(179,'classify-fields',2,'2024-06-19 16:45:06.499970','2024-06-19 16:45:06.601033',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(180,'classify-tables',2,'2024-06-19 16:45:06.608782','2024-06-19 16:45:06.624544',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(181,'sync',2,'2024-06-19 17:45:00.118329','2024-06-19 17:45:04.647544',4529,NULL,'success'),(182,'sync-dbms-version',2,'2024-06-19 17:45:00.127765','2024-06-19 17:45:00.136899',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(183,'sync-timezone',2,'2024-06-19 17:45:00.146818','2024-06-19 17:45:00.158081',11,'{\"timezone-id\":\"+08:00\"}','success'),(184,'sync-tables',2,'2024-06-19 17:45:00.167120','2024-06-19 17:45:00.197631',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(185,'sync-fields',2,'2024-06-19 17:45:00.206854','2024-06-19 17:45:03.338898',3132,'{\"total-fields\":836,\"updated-fields\":0}','success'),(186,'sync-fks',2,'2024-06-19 17:45:03.347389','2024-06-19 17:45:03.997473',650,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(187,'sync-indexes',2,'2024-06-19 17:45:04.006899','2024-06-19 17:45:04.604613',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(188,'sync-metabase-metadata',2,'2024-06-19 17:45:04.612352','2024-06-19 17:45:04.620809',8,'{}','success'),(189,'sync-table-privileges',2,'2024-06-19 17:45:04.629271','2024-06-19 17:45:04.639105',9,NULL,'success'),(190,'analyze',2,'2024-06-19 17:45:04.679085','2024-06-19 17:45:07.016056',2336,NULL,'success'),(191,'fingerprint-fields',2,'2024-06-19 17:45:04.688922','2024-06-19 17:45:06.765828',2076,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(192,'classify-fields',2,'2024-06-19 17:45:06.797183','2024-06-19 17:45:06.979517',182,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(193,'classify-tables',2,'2024-06-19 17:45:06.990077','2024-06-19 17:45:07.007592',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(194,'sync',2,'2024-06-19 18:45:00.126294','2024-06-19 18:45:04.641848',4515,NULL,'success'),(195,'sync-dbms-version',2,'2024-06-19 18:45:00.139109','2024-06-19 18:45:00.150360',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(196,'sync-timezone',2,'2024-06-19 18:45:00.160823','2024-06-19 18:45:00.172005',11,'{\"timezone-id\":\"+08:00\"}','success'),(197,'sync-tables',2,'2024-06-19 18:45:00.181461','2024-06-19 18:45:00.211103',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(198,'sync-fields',2,'2024-06-19 18:45:00.221334','2024-06-19 18:45:03.386638',3165,'{\"total-fields\":836,\"updated-fields\":0}','success'),(199,'sync-fks',2,'2024-06-19 18:45:03.397052','2024-06-19 18:45:04.038885',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(200,'sync-indexes',2,'2024-06-19 18:45:04.049874','2024-06-19 18:45:04.597264',547,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(201,'sync-metabase-metadata',2,'2024-06-19 18:45:04.605459','2024-06-19 18:45:04.614122',8,'{}','success'),(202,'sync-table-privileges',2,'2024-06-19 18:45:04.625016','2024-06-19 18:45:04.633464',8,NULL,'success'),(203,'analyze',2,'2024-06-19 18:45:04.665968','2024-06-19 18:45:06.925467',2259,NULL,'success'),(204,'fingerprint-fields',2,'2024-06-19 18:45:04.674347','2024-06-19 18:45:06.758088',2083,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(205,'classify-fields',2,'2024-06-19 18:45:06.776558','2024-06-19 18:45:06.895780',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(206,'classify-tables',2,'2024-06-19 18:45:06.903292','2024-06-19 18:45:06.916395',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(207,'sync',2,'2024-06-19 19:45:00.112922','2024-06-19 19:45:04.789789',4676,NULL,'success'),(208,'sync-dbms-version',2,'2024-06-19 19:45:00.121974','2024-06-19 19:45:00.132906',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(209,'sync-timezone',2,'2024-06-19 19:45:00.143085','2024-06-19 19:45:00.156156',13,'{\"timezone-id\":\"+08:00\"}','success'),(210,'sync-tables',2,'2024-06-19 19:45:00.165717','2024-06-19 19:45:00.194901',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(211,'sync-fields',2,'2024-06-19 19:45:00.204083','2024-06-19 19:45:03.409687',3205,'{\"total-fields\":836,\"updated-fields\":0}','success'),(212,'sync-fks',2,'2024-06-19 19:45:03.418060','2024-06-19 19:45:04.114330',696,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(213,'sync-indexes',2,'2024-06-19 19:45:04.123595','2024-06-19 19:45:04.744680',621,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(214,'sync-metabase-metadata',2,'2024-06-19 19:45:04.753677','2024-06-19 19:45:04.762445',8,'{}','success'),(215,'sync-table-privileges',2,'2024-06-19 19:45:04.771054','2024-06-19 19:45:04.780169',9,NULL,'success'),(216,'analyze',2,'2024-06-19 19:45:04.815728','2024-06-19 19:45:07.050136',2234,NULL,'success'),(217,'fingerprint-fields',2,'2024-06-19 19:45:04.826994','2024-06-19 19:45:06.894711',2067,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(218,'classify-fields',2,'2024-06-19 19:45:06.902971','2024-06-19 19:45:07.018029',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(219,'classify-tables',2,'2024-06-19 19:45:07.026136','2024-06-19 19:45:07.041517',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(220,'sync',2,'2024-06-19 20:45:00.103446','2024-06-19 20:45:04.607641',4504,NULL,'success'),(221,'sync-dbms-version',2,'2024-06-19 20:45:00.111730','2024-06-19 20:45:00.120404',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(222,'sync-timezone',2,'2024-06-19 20:45:00.129287','2024-06-19 20:45:00.139839',10,'{\"timezone-id\":\"+08:00\"}','success'),(223,'sync-tables',2,'2024-06-19 20:45:00.147890','2024-06-19 20:45:00.174766',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(224,'sync-fields',2,'2024-06-19 20:45:00.183084','2024-06-19 20:45:03.340745',3157,'{\"total-fields\":836,\"updated-fields\":0}','success'),(225,'sync-fks',2,'2024-06-19 20:45:03.349451','2024-06-19 20:45:03.972057',622,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(226,'sync-indexes',2,'2024-06-19 20:45:03.981046','2024-06-19 20:45:04.564194',583,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(227,'sync-metabase-metadata',2,'2024-06-19 20:45:04.572349','2024-06-19 20:45:04.581204',8,'{}','success'),(228,'sync-table-privileges',2,'2024-06-19 20:45:04.590223','2024-06-19 20:45:04.598314',8,NULL,'success'),(229,'analyze',2,'2024-06-19 20:45:04.636650','2024-06-19 20:45:06.757734',2121,NULL,'success'),(230,'fingerprint-fields',2,'2024-06-19 20:45:04.644989','2024-06-19 20:45:06.606923',1961,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(231,'classify-fields',2,'2024-06-19 20:45:06.614925','2024-06-19 20:45:06.726615',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(232,'classify-tables',2,'2024-06-19 20:45:06.734175','2024-06-19 20:45:06.747389',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(233,'sync',2,'2024-06-19 21:45:00.112350','2024-06-19 21:45:04.858399',4746,NULL,'success'),(234,'sync-dbms-version',2,'2024-06-19 21:45:00.122224','2024-06-19 21:45:00.132982',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(235,'sync-timezone',2,'2024-06-19 21:45:00.145081','2024-06-19 21:45:00.156649',11,'{\"timezone-id\":\"+08:00\"}','success'),(236,'sync-tables',2,'2024-06-19 21:45:00.165319','2024-06-19 21:45:00.197419',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(237,'sync-fields',2,'2024-06-19 21:45:00.206692','2024-06-19 21:45:03.493379',3286,'{\"total-fields\":836,\"updated-fields\":0}','success'),(238,'sync-fks',2,'2024-06-19 21:45:03.501755','2024-06-19 21:45:04.212288',710,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(239,'sync-indexes',2,'2024-06-19 21:45:04.221942','2024-06-19 21:45:04.812244',590,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(240,'sync-metabase-metadata',2,'2024-06-19 21:45:04.820777','2024-06-19 21:45:04.831906',11,'{}','success'),(241,'sync-table-privileges',2,'2024-06-19 21:45:04.841439','2024-06-19 21:45:04.849929',8,NULL,'success'),(242,'analyze',2,'2024-06-19 21:45:04.883648','2024-06-19 21:45:07.077163',2193,NULL,'success'),(243,'fingerprint-fields',2,'2024-06-19 21:45:04.892432','2024-06-19 21:45:06.928180',2035,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(244,'classify-fields',2,'2024-06-19 21:45:06.936339','2024-06-19 21:45:07.048307',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(245,'classify-tables',2,'2024-06-19 21:45:07.056918','2024-06-19 21:45:07.069809',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(246,'sync',2,'2024-06-19 22:45:00.127084','2024-06-19 22:45:04.719925',4592,NULL,'success'),(247,'sync-dbms-version',2,'2024-06-19 22:45:00.137091','2024-06-19 22:45:00.148761',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(248,'sync-timezone',2,'2024-06-19 22:45:00.158625','2024-06-19 22:45:00.170809',12,'{\"timezone-id\":\"+08:00\"}','success'),(249,'sync-tables',2,'2024-06-19 22:45:00.181780','2024-06-19 22:45:00.211752',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(250,'sync-fields',2,'2024-06-19 22:45:00.222502','2024-06-19 22:45:03.512053',3289,'{\"total-fields\":836,\"updated-fields\":0}','success'),(251,'sync-fks',2,'2024-06-19 22:45:03.520240','2024-06-19 22:45:04.120770',600,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(252,'sync-indexes',2,'2024-06-19 22:45:04.128775','2024-06-19 22:45:04.673724',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(253,'sync-metabase-metadata',2,'2024-06-19 22:45:04.682674','2024-06-19 22:45:04.692349',9,'{}','success'),(254,'sync-table-privileges',2,'2024-06-19 22:45:04.700830','2024-06-19 22:45:04.710147',9,NULL,'success'),(255,'analyze',2,'2024-06-19 22:45:04.751560','2024-06-19 22:45:06.913053',2161,NULL,'success'),(256,'fingerprint-fields',2,'2024-06-19 22:45:04.761250','2024-06-19 22:45:06.745907',1984,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(257,'classify-fields',2,'2024-06-19 22:45:06.755572','2024-06-19 22:45:06.876798',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(258,'classify-tables',2,'2024-06-19 22:45:06.884996','2024-06-19 22:45:06.901937',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(259,'sync',2,'2024-06-19 23:45:00.117707','2024-06-19 23:45:04.810441',4692,NULL,'success'),(260,'sync-dbms-version',2,'2024-06-19 23:45:00.128464','2024-06-19 23:45:00.137882',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(261,'sync-timezone',2,'2024-06-19 23:45:00.146312','2024-06-19 23:45:00.156344',10,'{\"timezone-id\":\"+08:00\"}','success'),(262,'sync-tables',2,'2024-06-19 23:45:00.164787','2024-06-19 23:45:00.193724',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(263,'sync-fields',2,'2024-06-19 23:45:00.202906','2024-06-19 23:45:03.553302',3350,'{\"total-fields\":836,\"updated-fields\":0}','success'),(264,'sync-fks',2,'2024-06-19 23:45:03.562822','2024-06-19 23:45:04.194057',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(265,'sync-indexes',2,'2024-06-19 23:45:04.203429','2024-06-19 23:45:04.768622',565,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(266,'sync-metabase-metadata',2,'2024-06-19 23:45:04.776802','2024-06-19 23:45:04.784899',8,'{}','success'),(267,'sync-table-privileges',2,'2024-06-19 23:45:04.793788','2024-06-19 23:45:04.801922',8,NULL,'success'),(268,'analyze',2,'2024-06-19 23:45:04.836846','2024-06-19 23:45:07.004058',2167,NULL,'success'),(269,'fingerprint-fields',2,'2024-06-19 23:45:04.845824','2024-06-19 23:45:06.838505',1992,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(270,'classify-fields',2,'2024-06-19 23:45:06.847172','2024-06-19 23:45:06.974332',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(271,'classify-tables',2,'2024-06-19 23:45:06.982071','2024-06-19 23:45:06.995395',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(272,'sync',2,'2024-06-20 00:45:00.122606','2024-06-20 00:45:04.965342',4842,NULL,'success'),(273,'sync-dbms-version',2,'2024-06-20 00:45:00.132181','2024-06-20 00:45:00.147194',15,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(274,'sync-timezone',2,'2024-06-20 00:45:00.157684','2024-06-20 00:45:00.171677',13,'{\"timezone-id\":\"+08:00\"}','success'),(275,'sync-tables',2,'2024-06-20 00:45:00.181529','2024-06-20 00:45:00.217655',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(276,'sync-fields',2,'2024-06-20 00:45:00.229934','2024-06-20 00:45:03.664017',3434,'{\"total-fields\":836,\"updated-fields\":0}','success'),(277,'sync-fks',2,'2024-06-20 00:45:03.673899','2024-06-20 00:45:04.323323',649,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(278,'sync-indexes',2,'2024-06-20 00:45:04.332340','2024-06-20 00:45:04.921150',588,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(279,'sync-metabase-metadata',2,'2024-06-20 00:45:04.929534','2024-06-20 00:45:04.938656',9,'{}','success'),(280,'sync-table-privileges',2,'2024-06-20 00:45:04.947020','2024-06-20 00:45:04.956642',9,NULL,'success'),(281,'analyze',2,'2024-06-20 00:45:04.991456','2024-06-20 00:45:07.185003',2193,NULL,'success'),(282,'fingerprint-fields',2,'2024-06-20 00:45:05.000947','2024-06-20 00:45:06.989622',1988,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(283,'classify-fields',2,'2024-06-20 00:45:06.998975','2024-06-20 00:45:07.133686',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(284,'classify-tables',2,'2024-06-20 00:45:07.157612','2024-06-20 00:45:07.174766',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(285,'sync',2,'2024-06-20 01:45:00.127627','2024-06-20 01:45:04.637935',4510,NULL,'success'),(286,'sync-dbms-version',2,'2024-06-20 01:45:00.137155','2024-06-20 01:45:00.147397',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(287,'sync-timezone',2,'2024-06-20 01:45:00.157207','2024-06-20 01:45:00.168178',10,'{\"timezone-id\":\"+08:00\"}','success'),(288,'sync-tables',2,'2024-06-20 01:45:00.178130','2024-06-20 01:45:00.207161',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(289,'sync-fields',2,'2024-06-20 01:45:00.222911','2024-06-20 01:45:03.396814',3173,'{\"total-fields\":836,\"updated-fields\":0}','success'),(290,'sync-fks',2,'2024-06-20 01:45:03.405530','2024-06-20 01:45:04.036056',630,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(291,'sync-indexes',2,'2024-06-20 01:45:04.047205','2024-06-20 01:45:04.593534',546,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(292,'sync-metabase-metadata',2,'2024-06-20 01:45:04.602268','2024-06-20 01:45:04.611802',9,'{}','success'),(293,'sync-table-privileges',2,'2024-06-20 01:45:04.619998','2024-06-20 01:45:04.629011',9,NULL,'success'),(294,'analyze',2,'2024-06-20 01:45:04.664151','2024-06-20 01:45:06.827213',2163,NULL,'success'),(295,'fingerprint-fields',2,'2024-06-20 01:45:04.673203','2024-06-20 01:45:06.666064',1992,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(296,'classify-fields',2,'2024-06-20 01:45:06.675610','2024-06-20 01:45:06.792756',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(297,'classify-tables',2,'2024-06-20 01:45:06.801022','2024-06-20 01:45:06.818095',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(298,'sync',2,'2024-06-20 02:45:00.114274','2024-06-20 02:45:04.812892',4698,NULL,'success'),(299,'sync-dbms-version',2,'2024-06-20 02:45:00.125471','2024-06-20 02:45:00.136458',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(300,'sync-timezone',2,'2024-06-20 02:45:00.146082','2024-06-20 02:45:00.158012',11,'{\"timezone-id\":\"+08:00\"}','success'),(301,'sync-tables',2,'2024-06-20 02:45:00.167615','2024-06-20 02:45:00.196263',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(302,'sync-fields',2,'2024-06-20 02:45:00.205155','2024-06-20 02:45:03.388645',3183,'{\"total-fields\":836,\"updated-fields\":0}','success'),(303,'sync-fks',2,'2024-06-20 02:45:03.397661','2024-06-20 02:45:04.131334',733,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(304,'sync-indexes',2,'2024-06-20 02:45:04.140405','2024-06-20 02:45:04.770731',630,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(305,'sync-metabase-metadata',2,'2024-06-20 02:45:04.778482','2024-06-20 02:45:04.786836',8,'{}','success'),(306,'sync-table-privileges',2,'2024-06-20 02:45:04.795063','2024-06-20 02:45:04.804619',9,NULL,'success'),(307,'analyze',2,'2024-06-20 02:45:04.839332','2024-06-20 02:45:07.127086',2287,NULL,'success'),(308,'fingerprint-fields',2,'2024-06-20 02:45:04.849942','2024-06-20 02:45:06.952262',2102,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(309,'classify-fields',2,'2024-06-20 02:45:06.961321','2024-06-20 02:45:07.090739',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(310,'classify-tables',2,'2024-06-20 02:45:07.099533','2024-06-20 02:45:07.117676',18,'{\"total-tables\":92,\"tables-classified\":0}','success'),(311,'sync',2,'2024-06-20 03:45:00.124419','2024-06-20 03:45:04.570111',4445,NULL,'success'),(312,'sync-dbms-version',2,'2024-06-20 03:45:00.133151','2024-06-20 03:45:00.143312',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(313,'sync-timezone',2,'2024-06-20 03:45:00.153141','2024-06-20 03:45:00.163831',10,'{\"timezone-id\":\"+08:00\"}','success'),(314,'sync-tables',2,'2024-06-20 03:45:00.173111','2024-06-20 03:45:00.203566',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(315,'sync-fields',2,'2024-06-20 03:45:00.212596','2024-06-20 03:45:03.313125',3100,'{\"total-fields\":836,\"updated-fields\":0}','success'),(316,'sync-fks',2,'2024-06-20 03:45:03.323058','2024-06-20 03:45:03.971100',648,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(317,'sync-indexes',2,'2024-06-20 03:45:03.980567','2024-06-20 03:45:04.526891',546,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(318,'sync-metabase-metadata',2,'2024-06-20 03:45:04.536284','2024-06-20 03:45:04.545318',9,'{}','success'),(319,'sync-table-privileges',2,'2024-06-20 03:45:04.554130','2024-06-20 03:45:04.562098',7,NULL,'success'),(320,'analyze',2,'2024-06-20 03:45:04.597635','2024-06-20 03:45:06.644365',2046,NULL,'success'),(321,'fingerprint-fields',2,'2024-06-20 03:45:04.607503','2024-06-20 03:45:06.492937',1885,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(322,'classify-fields',2,'2024-06-20 03:45:06.501768','2024-06-20 03:45:06.612688',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(323,'classify-tables',2,'2024-06-20 03:45:06.620206','2024-06-20 03:45:06.634289',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(324,'task-history-cleanup',NULL,'2024-06-20 04:00:00.099202','2024-06-20 04:00:00.113131',13,NULL,'success'),(325,'sync',2,'2024-06-20 04:45:00.126480','2024-06-20 04:45:04.609955',4483,NULL,'success'),(326,'sync-dbms-version',2,'2024-06-20 04:45:00.135659','2024-06-20 04:45:00.146223',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(327,'sync-timezone',2,'2024-06-20 04:45:00.155797','2024-06-20 04:45:00.168417',12,'{\"timezone-id\":\"+08:00\"}','success'),(328,'sync-tables',2,'2024-06-20 04:45:00.179125','2024-06-20 04:45:00.215742',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(329,'sync-fields',2,'2024-06-20 04:45:00.226404','2024-06-20 04:45:03.226371',2999,'{\"total-fields\":836,\"updated-fields\":0}','success'),(330,'sync-fks',2,'2024-06-20 04:45:03.236609','2024-06-20 04:45:03.935360',698,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(331,'sync-indexes',2,'2024-06-20 04:45:03.943657','2024-06-20 04:45:04.556334',612,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(332,'sync-metabase-metadata',2,'2024-06-20 04:45:04.566126','2024-06-20 04:45:04.577260',11,'{}','success'),(333,'sync-table-privileges',2,'2024-06-20 04:45:04.587625','2024-06-20 04:45:04.599231',11,NULL,'success'),(334,'analyze',2,'2024-06-20 04:45:04.638400','2024-06-20 04:45:06.817061',2178,NULL,'success'),(335,'fingerprint-fields',2,'2024-06-20 04:45:04.647703','2024-06-20 04:45:06.670381',2022,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(336,'classify-fields',2,'2024-06-20 04:45:06.685038','2024-06-20 04:45:06.786016',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(337,'classify-tables',2,'2024-06-20 04:45:06.793863','2024-06-20 04:45:06.807138',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(338,'sync',2,'2024-06-20 05:45:00.107670','2024-06-20 05:45:04.381800',4274,NULL,'success'),(339,'sync-dbms-version',2,'2024-06-20 05:45:00.116496','2024-06-20 05:45:00.128446',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(340,'sync-timezone',2,'2024-06-20 05:45:00.137165','2024-06-20 05:45:00.148804',11,'{\"timezone-id\":\"+08:00\"}','success'),(341,'sync-tables',2,'2024-06-20 05:45:00.158654','2024-06-20 05:45:00.188124',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(342,'sync-fields',2,'2024-06-20 05:45:00.196451','2024-06-20 05:45:03.099056',2902,'{\"total-fields\":836,\"updated-fields\":0}','success'),(343,'sync-fks',2,'2024-06-20 05:45:03.109273','2024-06-20 05:45:03.768949',659,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(344,'sync-indexes',2,'2024-06-20 05:45:03.777781','2024-06-20 05:45:04.338962',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(345,'sync-metabase-metadata',2,'2024-06-20 05:45:04.346263','2024-06-20 05:45:04.355770',9,'{}','success'),(346,'sync-table-privileges',2,'2024-06-20 05:45:04.364900','2024-06-20 05:45:04.373323',8,NULL,'success'),(347,'analyze',2,'2024-06-20 05:45:04.406298','2024-06-20 05:45:06.511958',2105,NULL,'success'),(348,'fingerprint-fields',2,'2024-06-20 05:45:04.414609','2024-06-20 05:45:06.373952',1959,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(349,'classify-fields',2,'2024-06-20 05:45:06.382199','2024-06-20 05:45:06.483435',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(350,'classify-tables',2,'2024-06-20 05:45:06.490643','2024-06-20 05:45:06.503758',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(351,'sync',2,'2024-06-20 06:45:00.109786','2024-06-20 06:45:05.231970',5122,NULL,'success'),(352,'sync-dbms-version',2,'2024-06-20 06:45:00.118264','2024-06-20 06:45:00.129724',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(353,'sync-timezone',2,'2024-06-20 06:45:00.138343','2024-06-20 06:45:00.149714',11,'{\"timezone-id\":\"+08:00\"}','success'),(354,'sync-tables',2,'2024-06-20 06:45:00.158566','2024-06-20 06:45:00.187164',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(355,'sync-fields',2,'2024-06-20 06:45:00.195970','2024-06-20 06:45:03.101807',2905,'{\"total-fields\":836,\"updated-fields\":0}','success'),(356,'sync-fks',2,'2024-06-20 06:45:03.112962','2024-06-20 06:45:03.705023',592,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(357,'sync-indexes',2,'2024-06-20 06:45:03.712996','2024-06-20 06:45:05.186637',1473,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(358,'sync-metabase-metadata',2,'2024-06-20 06:45:05.194636','2024-06-20 06:45:05.204199',9,'{}','success'),(359,'sync-table-privileges',2,'2024-06-20 06:45:05.213567','2024-06-20 06:45:05.222193',8,NULL,'success'),(360,'analyze',2,'2024-06-20 06:45:05.258423','2024-06-20 06:45:07.317979',2059,NULL,'success'),(361,'fingerprint-fields',2,'2024-06-20 06:45:05.266199','2024-06-20 06:45:07.147683',1881,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(362,'classify-fields',2,'2024-06-20 06:45:07.164089','2024-06-20 06:45:07.285297',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(363,'classify-tables',2,'2024-06-20 06:45:07.294573','2024-06-20 06:45:07.309709',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(364,'sync',2,'2024-06-20 07:45:00.106327','2024-06-20 07:45:04.956889',4850,NULL,'success'),(365,'sync-dbms-version',2,'2024-06-20 07:45:00.116060','2024-06-20 07:45:00.126533',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(366,'sync-timezone',2,'2024-06-20 07:45:00.135931','2024-06-20 07:45:00.147849',11,'{\"timezone-id\":\"+08:00\"}','success'),(367,'sync-tables',2,'2024-06-20 07:45:00.157768','2024-06-20 07:45:00.189988',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(368,'sync-fields',2,'2024-06-20 07:45:00.199706','2024-06-20 07:45:03.529408',3329,'{\"total-fields\":836,\"updated-fields\":0}','success'),(369,'sync-fks',2,'2024-06-20 07:45:03.537771','2024-06-20 07:45:04.259203',721,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(370,'sync-indexes',2,'2024-06-20 07:45:04.269056','2024-06-20 07:45:04.902859',633,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(371,'sync-metabase-metadata',2,'2024-06-20 07:45:04.918784','2024-06-20 07:45:04.927820',9,'{}','success'),(372,'sync-table-privileges',2,'2024-06-20 07:45:04.937263','2024-06-20 07:45:04.946896',9,NULL,'success'),(373,'analyze',2,'2024-06-20 07:45:04.982913','2024-06-20 07:45:07.238646',2255,NULL,'success'),(374,'fingerprint-fields',2,'2024-06-20 07:45:04.991276','2024-06-20 07:45:07.078990',2087,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(375,'classify-fields',2,'2024-06-20 07:45:07.087757','2024-06-20 07:45:07.203750',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(376,'classify-tables',2,'2024-06-20 07:45:07.214381','2024-06-20 07:45:07.228803',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(377,'sync',2,'2024-06-20 08:45:00.106036','2024-06-20 08:45:04.401728',4295,NULL,'success'),(378,'sync-dbms-version',2,'2024-06-20 08:45:00.114792','2024-06-20 08:45:00.124192',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(379,'sync-timezone',2,'2024-06-20 08:45:00.132729','2024-06-20 08:45:00.142716',9,'{\"timezone-id\":\"+08:00\"}','success'),(380,'sync-tables',2,'2024-06-20 08:45:00.151609','2024-06-20 08:45:00.180288',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(381,'sync-fields',2,'2024-06-20 08:45:00.189248','2024-06-20 08:45:03.232819',3043,'{\"total-fields\":836,\"updated-fields\":0}','success'),(382,'sync-fks',2,'2024-06-20 08:45:03.239828','2024-06-20 08:45:03.848004',608,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(383,'sync-indexes',2,'2024-06-20 08:45:03.855927','2024-06-20 08:45:04.362016',506,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(384,'sync-metabase-metadata',2,'2024-06-20 08:45:04.369687','2024-06-20 08:45:04.377791',8,'{}','success'),(385,'sync-table-privileges',2,'2024-06-20 08:45:04.385633','2024-06-20 08:45:04.393742',8,NULL,'success'),(386,'analyze',2,'2024-06-20 08:45:04.425449','2024-06-20 08:45:06.615838',2190,NULL,'success'),(387,'fingerprint-fields',2,'2024-06-20 08:45:04.433810','2024-06-20 08:45:06.453130',2019,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(388,'classify-fields',2,'2024-06-20 08:45:06.462250','2024-06-20 08:45:06.584240',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(389,'classify-tables',2,'2024-06-20 08:45:06.591906','2024-06-20 08:45:06.607271',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(390,'sync',2,'2024-06-20 09:45:00.118710','2024-06-20 09:45:04.153093',4034,NULL,'success'),(391,'sync-dbms-version',2,'2024-06-20 09:45:00.128696','2024-06-20 09:45:00.138452',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(392,'sync-timezone',2,'2024-06-20 09:45:00.147300','2024-06-20 09:45:00.157999',10,'{\"timezone-id\":\"+08:00\"}','success'),(393,'sync-tables',2,'2024-06-20 09:45:00.165962','2024-06-20 09:45:00.191696',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(394,'sync-fields',2,'2024-06-20 09:45:00.200453','2024-06-20 09:45:03.044962',2844,'{\"total-fields\":836,\"updated-fields\":0}','success'),(395,'sync-fks',2,'2024-06-20 09:45:03.053085','2024-06-20 09:45:03.605057',551,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(396,'sync-indexes',2,'2024-06-20 09:45:03.613162','2024-06-20 09:45:04.113461',500,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(397,'sync-metabase-metadata',2,'2024-06-20 09:45:04.121215','2024-06-20 09:45:04.129564',8,'{}','success'),(398,'sync-table-privileges',2,'2024-06-20 09:45:04.137576','2024-06-20 09:45:04.144697',7,NULL,'success'),(399,'analyze',2,'2024-06-20 09:45:04.182215','2024-06-20 09:45:06.310563',2128,NULL,'success'),(400,'fingerprint-fields',2,'2024-06-20 09:45:04.190685','2024-06-20 09:45:06.151724',1961,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(401,'classify-fields',2,'2024-06-20 09:45:06.160318','2024-06-20 09:45:06.276742',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(402,'classify-tables',2,'2024-06-20 09:45:06.285101','2024-06-20 09:45:06.301343',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(403,'sync',2,'2024-06-20 10:45:00.093500','2024-06-20 10:45:04.550034',4456,NULL,'success'),(404,'sync-dbms-version',2,'2024-06-20 10:45:00.103003','2024-06-20 10:45:00.112761',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(405,'sync-timezone',2,'2024-06-20 10:45:00.121985','2024-06-20 10:45:00.133448',11,'{\"timezone-id\":\"+08:00\"}','success'),(406,'sync-tables',2,'2024-06-20 10:45:00.142560','2024-06-20 10:45:00.171906',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(407,'sync-fields',2,'2024-06-20 10:45:00.182755','2024-06-20 10:45:03.253301',3070,'{\"total-fields\":836,\"updated-fields\":0}','success'),(408,'sync-fks',2,'2024-06-20 10:45:03.261972','2024-06-20 10:45:03.942717',680,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(409,'sync-indexes',2,'2024-06-20 10:45:03.952113','2024-06-20 10:45:04.507337',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(410,'sync-metabase-metadata',2,'2024-06-20 10:45:04.515103','2024-06-20 10:45:04.523121',8,'{}','success'),(411,'sync-table-privileges',2,'2024-06-20 10:45:04.531485','2024-06-20 10:45:04.541647',10,NULL,'success'),(412,'analyze',2,'2024-06-20 10:45:04.577672','2024-06-20 10:45:06.736542',2158,NULL,'success'),(413,'fingerprint-fields',2,'2024-06-20 10:45:04.586894','2024-06-20 10:45:06.592301',2005,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(414,'classify-fields',2,'2024-06-20 10:45:06.602231','2024-06-20 10:45:06.705436',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(415,'classify-tables',2,'2024-06-20 10:45:06.713238','2024-06-20 10:45:06.727864',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(416,'sync',2,'2024-06-20 11:45:00.111851','2024-06-20 11:45:04.452009',4340,NULL,'success'),(417,'sync-dbms-version',2,'2024-06-20 11:45:00.121323','2024-06-20 11:45:00.133807',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(418,'sync-timezone',2,'2024-06-20 11:45:00.142524','2024-06-20 11:45:00.153282',10,'{\"timezone-id\":\"+08:00\"}','success'),(419,'sync-tables',2,'2024-06-20 11:45:00.161876','2024-06-20 11:45:00.189968',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(420,'sync-fields',2,'2024-06-20 11:45:00.198603','2024-06-20 11:45:03.249083',3050,'{\"total-fields\":836,\"updated-fields\":0}','success'),(421,'sync-fks',2,'2024-06-20 11:45:03.257405','2024-06-20 11:45:03.885049',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(422,'sync-indexes',2,'2024-06-20 11:45:03.893297','2024-06-20 11:45:04.408296',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(423,'sync-metabase-metadata',2,'2024-06-20 11:45:04.418514','2024-06-20 11:45:04.427669',9,'{}','success'),(424,'sync-table-privileges',2,'2024-06-20 11:45:04.435912','2024-06-20 11:45:04.443752',7,NULL,'success'),(425,'analyze',2,'2024-06-20 11:45:04.477168','2024-06-20 11:45:06.551686',2074,NULL,'success'),(426,'fingerprint-fields',2,'2024-06-20 11:45:04.485341','2024-06-20 11:45:06.393906',1908,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(427,'classify-fields',2,'2024-06-20 11:45:06.401648','2024-06-20 11:45:06.519865',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(428,'classify-tables',2,'2024-06-20 11:45:06.528298','2024-06-20 11:45:06.542745',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(429,'sync',2,'2024-06-20 12:45:00.123146','2024-06-20 12:45:04.258807',4135,NULL,'success'),(430,'sync-dbms-version',2,'2024-06-20 12:45:00.132141','2024-06-20 12:45:00.141037',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(431,'sync-timezone',2,'2024-06-20 12:45:00.149707','2024-06-20 12:45:00.160221',10,'{\"timezone-id\":\"+08:00\"}','success'),(432,'sync-tables',2,'2024-06-20 12:45:00.169918','2024-06-20 12:45:00.198171',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(433,'sync-fields',2,'2024-06-20 12:45:00.220921','2024-06-20 12:45:03.107009',2886,'{\"total-fields\":836,\"updated-fields\":0}','success'),(434,'sync-fks',2,'2024-06-20 12:45:03.114516','2024-06-20 12:45:03.721605',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(435,'sync-indexes',2,'2024-06-20 12:45:03.729533','2024-06-20 12:45:04.216480',486,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(436,'sync-metabase-metadata',2,'2024-06-20 12:45:04.224065','2024-06-20 12:45:04.235093',11,'{}','success'),(437,'sync-table-privileges',2,'2024-06-20 12:45:04.242841','2024-06-20 12:45:04.250571',7,NULL,'success'),(438,'analyze',2,'2024-06-20 12:45:04.285805','2024-06-20 12:45:06.303874',2018,NULL,'success'),(439,'fingerprint-fields',2,'2024-06-20 12:45:04.293774','2024-06-20 12:45:06.138091',1844,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(440,'classify-fields',2,'2024-06-20 12:45:06.145692','2024-06-20 12:45:06.259944',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(441,'classify-tables',2,'2024-06-20 12:45:06.269657','2024-06-20 12:45:06.294915',25,'{\"total-tables\":92,\"tables-classified\":0}','success'),(442,'field values scanning',2,'2024-06-20 13:00:00.056916','2024-06-20 13:00:12.787554',12730,NULL,'success'),(443,'delete-expired-advanced-field-values',2,'2024-06-20 13:00:00.065721','2024-06-20 13:00:02.951636',2885,'{\"deleted\":0}','success'),(444,'update-field-values',2,'2024-06-20 13:00:02.959354','2024-06-20 13:00:12.780103',9820,'{\"errors\":0,\"created\":0,\"updated\":72,\"deleted\":0}','success'),(445,'sync',2,'2024-06-20 13:45:00.096479','2024-06-20 13:45:04.303032',4206,NULL,'success'),(446,'sync-dbms-version',2,'2024-06-20 13:45:00.105203','2024-06-20 13:45:00.114607',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(447,'sync-timezone',2,'2024-06-20 13:45:00.122525','2024-06-20 13:45:00.131552',9,'{\"timezone-id\":\"+08:00\"}','success'),(448,'sync-tables',2,'2024-06-20 13:45:00.140129','2024-06-20 13:45:00.168112',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(449,'sync-fields',2,'2024-06-20 13:45:00.176851','2024-06-20 13:45:03.172691',2995,'{\"total-fields\":836,\"updated-fields\":0}','success'),(450,'sync-fks',2,'2024-06-20 13:45:03.179708','2024-06-20 13:45:03.747513',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(451,'sync-indexes',2,'2024-06-20 13:45:03.756054','2024-06-20 13:45:04.261048',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(452,'sync-metabase-metadata',2,'2024-06-20 13:45:04.268455','2024-06-20 13:45:04.276434',7,'{}','success'),(453,'sync-table-privileges',2,'2024-06-20 13:45:04.285364','2024-06-20 13:45:04.294572',9,NULL,'success'),(454,'analyze',2,'2024-06-20 13:45:04.328562','2024-06-20 13:45:06.389092',2060,NULL,'success'),(455,'fingerprint-fields',2,'2024-06-20 13:45:04.338082','2024-06-20 13:45:06.228176',1890,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(456,'classify-fields',2,'2024-06-20 13:45:06.237126','2024-06-20 13:45:06.357637',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(457,'classify-tables',2,'2024-06-20 13:45:06.365748','2024-06-20 13:45:06.380180',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(458,'sync',2,'2024-06-20 14:45:00.112507','2024-06-20 14:45:04.344303',4231,NULL,'success'),(459,'sync-dbms-version',2,'2024-06-20 14:45:00.121451','2024-06-20 14:45:00.134834',13,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(460,'sync-timezone',2,'2024-06-20 14:45:00.145712','2024-06-20 14:45:00.157132',11,'{\"timezone-id\":\"+08:00\"}','success'),(461,'sync-tables',2,'2024-06-20 14:45:00.165712','2024-06-20 14:45:00.193784',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(462,'sync-fields',2,'2024-06-20 14:45:00.202826','2024-06-20 14:45:03.116838',2914,'{\"total-fields\":836,\"updated-fields\":0}','success'),(463,'sync-fks',2,'2024-06-20 14:45:03.125178','2024-06-20 14:45:03.737505',612,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(464,'sync-indexes',2,'2024-06-20 14:45:03.745551','2024-06-20 14:45:04.298822',553,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(465,'sync-metabase-metadata',2,'2024-06-20 14:45:04.307129','2024-06-20 14:45:04.316497',9,'{}','success'),(466,'sync-table-privileges',2,'2024-06-20 14:45:04.325234','2024-06-20 14:45:04.334616',9,NULL,'success'),(467,'analyze',2,'2024-06-20 14:45:04.373534','2024-06-20 14:45:06.344901',1971,NULL,'success'),(468,'fingerprint-fields',2,'2024-06-20 14:45:04.382757','2024-06-20 14:45:06.200432',1817,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(469,'classify-fields',2,'2024-06-20 14:45:06.208793','2024-06-20 14:45:06.314628',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(470,'classify-tables',2,'2024-06-20 14:45:06.322172','2024-06-20 14:45:06.336857',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(471,'sync',2,'2024-06-20 15:45:00.101321','2024-06-20 15:45:04.207210',4105,NULL,'success'),(472,'sync-dbms-version',2,'2024-06-20 15:45:00.109953','2024-06-20 15:45:00.118482',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(473,'sync-timezone',2,'2024-06-20 15:45:00.126546','2024-06-20 15:45:00.137202',10,'{\"timezone-id\":\"+08:00\"}','success'),(474,'sync-tables',2,'2024-06-20 15:45:00.146727','2024-06-20 15:45:00.175036',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(475,'sync-fields',2,'2024-06-20 15:45:00.184039','2024-06-20 15:45:03.043630',2859,'{\"total-fields\":836,\"updated-fields\":0}','success'),(476,'sync-fks',2,'2024-06-20 15:45:03.051599','2024-06-20 15:45:03.638633',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(477,'sync-indexes',2,'2024-06-20 15:45:03.646800','2024-06-20 15:45:04.163243',516,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(478,'sync-metabase-metadata',2,'2024-06-20 15:45:04.170911','2024-06-20 15:45:04.180305',9,'{}','success'),(479,'sync-table-privileges',2,'2024-06-20 15:45:04.189129','2024-06-20 15:45:04.198754',9,NULL,'success'),(480,'analyze',2,'2024-06-20 15:45:04.234203','2024-06-20 15:45:06.360743',2126,NULL,'success'),(481,'fingerprint-fields',2,'2024-06-20 15:45:04.242755','2024-06-20 15:45:06.205181',1962,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(482,'classify-fields',2,'2024-06-20 15:45:06.215008','2024-06-20 15:45:06.327215',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(483,'classify-tables',2,'2024-06-20 15:45:06.335195','2024-06-20 15:45:06.350609',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(484,'task-history-cleanup',NULL,'2024-06-20 16:00:00.019794','2024-06-20 16:00:00.045735',25,NULL,'success'),(485,'task-history-cleanup',NULL,'2024-06-20 16:00:00.072134','2024-06-20 16:00:00.085597',13,NULL,'success'),(486,'sync',2,'2024-06-20 16:45:00.106569','2024-06-20 16:45:04.344326',4237,NULL,'success'),(487,'sync-dbms-version',2,'2024-06-20 16:45:00.115165','2024-06-20 16:45:00.125152',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(488,'sync-timezone',2,'2024-06-20 16:45:00.133279','2024-06-20 16:45:00.143752',10,'{\"timezone-id\":\"+08:00\"}','success'),(489,'sync-tables',2,'2024-06-20 16:45:00.153709','2024-06-20 16:45:00.186355',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(490,'sync-fields',2,'2024-06-20 16:45:00.195300','2024-06-20 16:45:03.062512',2867,'{\"total-fields\":836,\"updated-fields\":0}','success'),(491,'sync-fks',2,'2024-06-20 16:45:03.072570','2024-06-20 16:45:03.723702',651,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(492,'sync-indexes',2,'2024-06-20 16:45:03.732486','2024-06-20 16:45:04.303118',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(493,'sync-metabase-metadata',2,'2024-06-20 16:45:04.310951','2024-06-20 16:45:04.320089',9,'{}','success'),(494,'sync-table-privileges',2,'2024-06-20 16:45:04.328669','2024-06-20 16:45:04.336545',7,NULL,'success'),(495,'analyze',2,'2024-06-20 16:45:04.372977','2024-06-20 16:45:06.389147',2016,NULL,'success'),(496,'fingerprint-fields',2,'2024-06-20 16:45:04.382367','2024-06-20 16:45:06.247406',1865,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(497,'classify-fields',2,'2024-06-20 16:45:06.255551','2024-06-20 16:45:06.359792',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(498,'classify-tables',2,'2024-06-20 16:45:06.367381','2024-06-20 16:45:06.380382',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(499,'sync',2,'2024-06-20 17:45:00.110097','2024-06-20 17:45:04.562714',4452,NULL,'success'),(500,'sync-dbms-version',2,'2024-06-20 17:45:00.119381','2024-06-20 17:45:00.130973',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(501,'sync-timezone',2,'2024-06-20 17:45:00.140490','2024-06-20 17:45:00.152022',11,'{\"timezone-id\":\"+08:00\"}','success'),(502,'sync-tables',2,'2024-06-20 17:45:00.161173','2024-06-20 17:45:00.188504',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(503,'sync-fields',2,'2024-06-20 17:45:00.196937','2024-06-20 17:45:03.299504',3102,'{\"total-fields\":836,\"updated-fields\":0}','success'),(504,'sync-fks',2,'2024-06-20 17:45:03.307759','2024-06-20 17:45:03.935279',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(505,'sync-indexes',2,'2024-06-20 17:45:03.943338','2024-06-20 17:45:04.513597',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(506,'sync-metabase-metadata',2,'2024-06-20 17:45:04.524101','2024-06-20 17:45:04.533233',9,'{}','success'),(507,'sync-table-privileges',2,'2024-06-20 17:45:04.542884','2024-06-20 17:45:04.553429',10,NULL,'success'),(508,'analyze',2,'2024-06-20 17:45:04.589850','2024-06-20 17:45:06.849752',2259,NULL,'success'),(509,'fingerprint-fields',2,'2024-06-20 17:45:04.599379','2024-06-20 17:45:06.684808',2085,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(510,'classify-fields',2,'2024-06-20 17:45:06.693441','2024-06-20 17:45:06.814197',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(511,'classify-tables',2,'2024-06-20 17:45:06.823858','2024-06-20 17:45:06.840033',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(512,'sync',2,'2024-06-20 18:45:00.135500','2024-06-20 18:45:04.752520',4617,NULL,'success'),(513,'sync-dbms-version',2,'2024-06-20 18:45:00.146771','2024-06-20 18:45:00.158271',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(514,'sync-timezone',2,'2024-06-20 18:45:00.169548','2024-06-20 18:45:00.181229',11,'{\"timezone-id\":\"+08:00\"}','success'),(515,'sync-tables',2,'2024-06-20 18:45:00.191102','2024-06-20 18:45:00.223296',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(516,'sync-fields',2,'2024-06-20 18:45:00.232795','2024-06-20 18:45:03.416512',3183,'{\"total-fields\":836,\"updated-fields\":0}','success'),(517,'sync-fks',2,'2024-06-20 18:45:03.425306','2024-06-20 18:45:04.135818',710,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(518,'sync-indexes',2,'2024-06-20 18:45:04.145276','2024-06-20 18:45:04.714508',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(519,'sync-metabase-metadata',2,'2024-06-20 18:45:04.721730','2024-06-20 18:45:04.729336',7,'{}','success'),(520,'sync-table-privileges',2,'2024-06-20 18:45:04.737108','2024-06-20 18:45:04.744929',7,NULL,'success'),(521,'analyze',2,'2024-06-20 18:45:04.776697','2024-06-20 18:45:07.086429',2309,NULL,'success'),(522,'fingerprint-fields',2,'2024-06-20 18:45:04.784256','2024-06-20 18:45:06.926230',2141,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(523,'classify-fields',2,'2024-06-20 18:45:06.934877','2024-06-20 18:45:07.049894',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(524,'classify-tables',2,'2024-06-20 18:45:07.058073','2024-06-20 18:45:07.074750',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(525,'sync',2,'2024-06-20 19:45:00.120598','2024-06-20 19:45:04.455072',4334,NULL,'success'),(526,'sync-dbms-version',2,'2024-06-20 19:45:00.130444','2024-06-20 19:45:00.143801',13,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(527,'sync-timezone',2,'2024-06-20 19:45:00.154198','2024-06-20 19:45:00.166192',11,'{\"timezone-id\":\"+08:00\"}','success'),(528,'sync-tables',2,'2024-06-20 19:45:00.175513','2024-06-20 19:45:00.206752',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(529,'sync-fields',2,'2024-06-20 19:45:00.216241','2024-06-20 19:45:03.258135',3041,'{\"total-fields\":836,\"updated-fields\":0}','success'),(530,'sync-fks',2,'2024-06-20 19:45:03.266066','2024-06-20 19:45:03.896848',630,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(531,'sync-indexes',2,'2024-06-20 19:45:03.905882','2024-06-20 19:45:04.410274',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(532,'sync-metabase-metadata',2,'2024-06-20 19:45:04.418095','2024-06-20 19:45:04.427491',9,'{}','success'),(533,'sync-table-privileges',2,'2024-06-20 19:45:04.437887','2024-06-20 19:45:04.446688',8,NULL,'success'),(534,'analyze',2,'2024-06-20 19:45:04.481476','2024-06-20 19:45:06.493176',2011,NULL,'success'),(535,'fingerprint-fields',2,'2024-06-20 19:45:04.489676','2024-06-20 19:45:06.349780',1860,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(536,'classify-fields',2,'2024-06-20 19:45:06.360117','2024-06-20 19:45:06.465011',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(537,'classify-tables',2,'2024-06-20 19:45:06.472287','2024-06-20 19:45:06.485533',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(538,'sync',2,'2024-06-20 20:45:00.119092','2024-06-20 20:45:04.401633',4282,NULL,'success'),(539,'sync-dbms-version',2,'2024-06-20 20:45:00.135770','2024-06-20 20:45:00.147448',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(540,'sync-timezone',2,'2024-06-20 20:45:00.157873','2024-06-20 20:45:00.169658',11,'{\"timezone-id\":\"+08:00\"}','success'),(541,'sync-tables',2,'2024-06-20 20:45:00.178760','2024-06-20 20:45:00.213557',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(542,'sync-fields',2,'2024-06-20 20:45:00.223497','2024-06-20 20:45:03.264825',3041,'{\"total-fields\":836,\"updated-fields\":0}','success'),(543,'sync-fks',2,'2024-06-20 20:45:03.273872','2024-06-20 20:45:03.842398',568,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(544,'sync-indexes',2,'2024-06-20 20:45:03.851100','2024-06-20 20:45:04.360953',509,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(545,'sync-metabase-metadata',2,'2024-06-20 20:45:04.369426','2024-06-20 20:45:04.376934',7,'{}','success'),(546,'sync-table-privileges',2,'2024-06-20 20:45:04.385093','2024-06-20 20:45:04.393840',8,NULL,'success'),(547,'analyze',2,'2024-06-20 20:45:04.425663','2024-06-20 20:45:06.455733',2030,NULL,'success'),(548,'fingerprint-fields',2,'2024-06-20 20:45:04.435064','2024-06-20 20:45:06.292872',1857,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(549,'classify-fields',2,'2024-06-20 20:45:06.301453','2024-06-20 20:45:06.423773',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(550,'classify-tables',2,'2024-06-20 20:45:06.431230','2024-06-20 20:45:06.446241',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(551,'sync',2,'2024-06-20 21:45:00.135438','2024-06-20 21:45:04.247372',4111,NULL,'success'),(552,'sync-dbms-version',2,'2024-06-20 21:45:00.145382','2024-06-20 21:45:00.156529',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(553,'sync-timezone',2,'2024-06-20 21:45:00.165678','2024-06-20 21:45:00.177048',11,'{\"timezone-id\":\"+08:00\"}','success'),(554,'sync-tables',2,'2024-06-20 21:45:00.187167','2024-06-20 21:45:00.216383',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(555,'sync-fields',2,'2024-06-20 21:45:00.225274','2024-06-20 21:45:03.043335',2818,'{\"total-fields\":836,\"updated-fields\":0}','success'),(556,'sync-fks',2,'2024-06-20 21:45:03.050881','2024-06-20 21:45:03.667085',616,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(557,'sync-indexes',2,'2024-06-20 21:45:03.675878','2024-06-20 21:45:04.203434',527,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(558,'sync-metabase-metadata',2,'2024-06-20 21:45:04.213110','2024-06-20 21:45:04.221474',8,'{}','success'),(559,'sync-table-privileges',2,'2024-06-20 21:45:04.230330','2024-06-20 21:45:04.238415',8,NULL,'success'),(560,'analyze',2,'2024-06-20 21:45:04.281736','2024-06-20 21:45:06.279337',1997,NULL,'success'),(561,'fingerprint-fields',2,'2024-06-20 21:45:04.291496','2024-06-20 21:45:06.114799',1823,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(562,'classify-fields',2,'2024-06-20 21:45:06.123178','2024-06-20 21:45:06.245847',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(563,'classify-tables',2,'2024-06-20 21:45:06.253909','2024-06-20 21:45:06.269239',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(564,'sync',2,'2024-06-20 22:45:00.132395','2024-06-20 22:45:04.920195',4787,NULL,'success'),(565,'sync-dbms-version',2,'2024-06-20 22:45:00.142540','2024-06-20 22:45:00.154869',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(566,'sync-timezone',2,'2024-06-20 22:45:00.164795','2024-06-20 22:45:00.177336',12,'{\"timezone-id\":\"+08:00\"}','success'),(567,'sync-tables',2,'2024-06-20 22:45:00.188403','2024-06-20 22:45:00.220402',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(568,'sync-fields',2,'2024-06-20 22:45:00.231412','2024-06-20 22:45:03.536196',3304,'{\"total-fields\":836,\"updated-fields\":0}','success'),(569,'sync-fks',2,'2024-06-20 22:45:03.544045','2024-06-20 22:45:04.213220',669,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(570,'sync-indexes',2,'2024-06-20 22:45:04.222166','2024-06-20 22:45:04.871712',649,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(571,'sync-metabase-metadata',2,'2024-06-20 22:45:04.881050','2024-06-20 22:45:04.890790',9,'{}','success'),(572,'sync-table-privileges',2,'2024-06-20 22:45:04.900085','2024-06-20 22:45:04.910494',10,NULL,'success'),(573,'analyze',2,'2024-06-20 22:45:04.946626','2024-06-20 22:45:07.161193',2214,NULL,'success'),(574,'fingerprint-fields',2,'2024-06-20 22:45:04.956784','2024-06-20 22:45:06.991677',2034,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(575,'classify-fields',2,'2024-06-20 22:45:07.000289','2024-06-20 22:45:07.127563',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(576,'classify-tables',2,'2024-06-20 22:45:07.136870','2024-06-20 22:45:07.152099',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(577,'sync',2,'2024-06-20 23:45:00.117959','2024-06-20 23:45:04.566049',4448,NULL,'success'),(578,'sync-dbms-version',2,'2024-06-20 23:45:00.128036','2024-06-20 23:45:00.139945',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(579,'sync-timezone',2,'2024-06-20 23:45:00.149797','2024-06-20 23:45:00.168678',18,'{\"timezone-id\":\"+08:00\"}','success'),(580,'sync-tables',2,'2024-06-20 23:45:00.178134','2024-06-20 23:45:00.205085',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(581,'sync-fields',2,'2024-06-20 23:45:00.216269','2024-06-20 23:45:03.393879',3177,'{\"total-fields\":836,\"updated-fields\":0}','success'),(582,'sync-fks',2,'2024-06-20 23:45:03.401783','2024-06-20 23:45:03.990805',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(583,'sync-indexes',2,'2024-06-20 23:45:04.000076','2024-06-20 23:45:04.525760',525,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(584,'sync-metabase-metadata',2,'2024-06-20 23:45:04.533360','2024-06-20 23:45:04.541215',7,'{}','success'),(585,'sync-table-privileges',2,'2024-06-20 23:45:04.549663','2024-06-20 23:45:04.557937',8,NULL,'success'),(586,'analyze',2,'2024-06-20 23:45:04.593108','2024-06-20 23:45:06.602325',2009,NULL,'success'),(587,'fingerprint-fields',2,'2024-06-20 23:45:04.603819','2024-06-20 23:45:06.468329',1864,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(588,'classify-fields',2,'2024-06-20 23:45:06.476249','2024-06-20 23:45:06.574256',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(589,'classify-tables',2,'2024-06-20 23:45:06.581342','2024-06-20 23:45:06.594538',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(590,'sync',2,'2024-06-21 00:45:00.130210','2024-06-21 00:45:04.625503',4495,NULL,'success'),(591,'sync-dbms-version',2,'2024-06-21 00:45:00.139625','2024-06-21 00:45:00.150271',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(592,'sync-timezone',2,'2024-06-21 00:45:00.159715','2024-06-21 00:45:00.170623',10,'{\"timezone-id\":\"+08:00\"}','success'),(593,'sync-tables',2,'2024-06-21 00:45:00.180215','2024-06-21 00:45:00.208438',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(594,'sync-fields',2,'2024-06-21 00:45:00.218110','2024-06-21 00:45:03.384380',3166,'{\"total-fields\":836,\"updated-fields\":0}','success'),(595,'sync-fks',2,'2024-06-21 00:45:03.393282','2024-06-21 00:45:04.058421',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(596,'sync-indexes',2,'2024-06-21 00:45:04.067352','2024-06-21 00:45:04.584023',516,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(597,'sync-metabase-metadata',2,'2024-06-21 00:45:04.591554','2024-06-21 00:45:04.601074',9,'{}','success'),(598,'sync-table-privileges',2,'2024-06-21 00:45:04.609261','2024-06-21 00:45:04.617681',8,NULL,'success'),(599,'analyze',2,'2024-06-21 00:45:04.649742','2024-06-21 00:45:06.749146',2099,NULL,'success'),(600,'fingerprint-fields',2,'2024-06-21 00:45:04.658267','2024-06-21 00:45:06.598840',1940,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(601,'classify-fields',2,'2024-06-21 00:45:06.606902','2024-06-21 00:45:06.718962',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(602,'classify-tables',2,'2024-06-21 00:45:06.726527','2024-06-21 00:45:06.741027',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(603,'sync',2,'2024-06-21 01:45:00.116834','2024-06-21 01:45:04.564938',4448,NULL,'success'),(604,'sync-dbms-version',2,'2024-06-21 01:45:00.126008','2024-06-21 01:45:00.137256',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(605,'sync-timezone',2,'2024-06-21 01:45:00.146517','2024-06-21 01:45:00.158677',12,'{\"timezone-id\":\"+08:00\"}','success'),(606,'sync-tables',2,'2024-06-21 01:45:00.168240','2024-06-21 01:45:00.197537',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(607,'sync-fields',2,'2024-06-21 01:45:00.207016','2024-06-21 01:45:03.345464',3138,'{\"total-fields\":836,\"updated-fields\":0}','success'),(608,'sync-fks',2,'2024-06-21 01:45:03.353536','2024-06-21 01:45:03.974083',620,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(609,'sync-indexes',2,'2024-06-21 01:45:03.982135','2024-06-21 01:45:04.518055',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(610,'sync-metabase-metadata',2,'2024-06-21 01:45:04.526354','2024-06-21 01:45:04.541301',14,'{}','success'),(611,'sync-table-privileges',2,'2024-06-21 01:45:04.549411','2024-06-21 01:45:04.557080',7,NULL,'success'),(612,'analyze',2,'2024-06-21 01:45:04.590318','2024-06-21 01:45:06.627398',2037,NULL,'success'),(613,'fingerprint-fields',2,'2024-06-21 01:45:04.600051','2024-06-21 01:45:06.480752',1880,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(614,'classify-fields',2,'2024-06-21 01:45:06.488709','2024-06-21 01:45:06.596368',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(615,'classify-tables',2,'2024-06-21 01:45:06.604508','2024-06-21 01:45:06.619475',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(616,'sync',2,'2024-06-21 02:45:00.095264','2024-06-21 02:45:04.858894',4763,NULL,'success'),(617,'sync-dbms-version',2,'2024-06-21 02:45:00.103165','2024-06-21 02:45:00.111989',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(618,'sync-timezone',2,'2024-06-21 02:45:00.120825','2024-06-21 02:45:00.131255',10,'{\"timezone-id\":\"+08:00\"}','success'),(619,'sync-tables',2,'2024-06-21 02:45:00.140263','2024-06-21 02:45:00.171780',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(620,'sync-fields',2,'2024-06-21 02:45:00.181113','2024-06-21 02:45:03.497460',3316,'{\"total-fields\":836,\"updated-fields\":0}','success'),(621,'sync-fks',2,'2024-06-21 02:45:03.505470','2024-06-21 02:45:04.217233',711,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(622,'sync-indexes',2,'2024-06-21 02:45:04.226482','2024-06-21 02:45:04.813056',586,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(623,'sync-metabase-metadata',2,'2024-06-21 02:45:04.822371','2024-06-21 02:45:04.831934',9,'{}','success'),(624,'sync-table-privileges',2,'2024-06-21 02:45:04.841088','2024-06-21 02:45:04.850382',9,NULL,'success'),(625,'analyze',2,'2024-06-21 02:45:04.886362','2024-06-21 02:45:07.031595',2145,NULL,'success'),(626,'fingerprint-fields',2,'2024-06-21 02:45:04.894467','2024-06-21 02:45:06.861843',1967,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(627,'classify-fields',2,'2024-06-21 02:45:06.871048','2024-06-21 02:45:06.996150',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(628,'classify-tables',2,'2024-06-21 02:45:07.004619','2024-06-21 02:45:07.023322',18,'{\"total-tables\":92,\"tables-classified\":0}','success'),(629,'sync',2,'2024-06-21 03:45:00.110899','2024-06-21 03:45:04.877382',4766,NULL,'success'),(630,'sync-dbms-version',2,'2024-06-21 03:45:00.122193','2024-06-21 03:45:00.132343',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(631,'sync-timezone',2,'2024-06-21 03:45:00.140956','2024-06-21 03:45:00.151772',10,'{\"timezone-id\":\"+08:00\"}','success'),(632,'sync-tables',2,'2024-06-21 03:45:00.160753','2024-06-21 03:45:00.187038',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(633,'sync-fields',2,'2024-06-21 03:45:00.196003','2024-06-21 03:45:03.524462',3328,'{\"total-fields\":836,\"updated-fields\":0}','success'),(634,'sync-fks',2,'2024-06-21 03:45:03.533063','2024-06-21 03:45:04.187524',654,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(635,'sync-indexes',2,'2024-06-21 03:45:04.195816','2024-06-21 03:45:04.826142',630,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(636,'sync-metabase-metadata',2,'2024-06-21 03:45:04.835709','2024-06-21 03:45:04.846669',10,'{}','success'),(637,'sync-table-privileges',2,'2024-06-21 03:45:04.856323','2024-06-21 03:45:04.866412',10,NULL,'success'),(638,'analyze',2,'2024-06-21 03:45:04.905458','2024-06-21 03:45:07.034660',2129,NULL,'success'),(639,'fingerprint-fields',2,'2024-06-21 03:45:04.914979','2024-06-21 03:45:06.900832',1985,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(640,'classify-fields',2,'2024-06-21 03:45:06.908513','2024-06-21 03:45:07.004944',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(641,'classify-tables',2,'2024-06-21 03:45:07.012938','2024-06-21 03:45:07.026774',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(642,'task-history-cleanup',NULL,'2024-06-21 04:00:00.063071','2024-06-21 04:00:00.081910',18,NULL,'success'),(643,'sync',2,'2024-06-21 04:45:00.111139','2024-06-21 04:45:04.691391',4580,NULL,'success'),(644,'sync-dbms-version',2,'2024-06-21 04:45:00.120185','2024-06-21 04:45:00.130225',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(645,'sync-timezone',2,'2024-06-21 04:45:00.141750','2024-06-21 04:45:00.153611',11,'{\"timezone-id\":\"+08:00\"}','success'),(646,'sync-tables',2,'2024-06-21 04:45:00.162876','2024-06-21 04:45:00.189822',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(647,'sync-fields',2,'2024-06-21 04:45:00.199358','2024-06-21 04:45:03.350591',3151,'{\"total-fields\":836,\"updated-fields\":0}','success'),(648,'sync-fks',2,'2024-06-21 04:45:03.359040','2024-06-21 04:45:04.049626',690,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(649,'sync-indexes',2,'2024-06-21 04:45:04.058863','2024-06-21 04:45:04.648191',589,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(650,'sync-metabase-metadata',2,'2024-06-21 04:45:04.656123','2024-06-21 04:45:04.664671',8,'{}','success'),(651,'sync-table-privileges',2,'2024-06-21 04:45:04.673211','2024-06-21 04:45:04.682823',9,NULL,'success'),(652,'analyze',2,'2024-06-21 04:45:04.717464','2024-06-21 04:45:06.826768',2109,NULL,'success'),(653,'fingerprint-fields',2,'2024-06-21 04:45:04.725815','2024-06-21 04:45:06.675428',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(654,'classify-fields',2,'2024-06-21 04:45:06.683479','2024-06-21 04:45:06.795710',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(655,'classify-tables',2,'2024-06-21 04:45:06.803410','2024-06-21 04:45:06.818406',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(656,'sync',2,'2024-06-21 05:45:00.113459','2024-06-21 05:45:04.393815',4280,NULL,'success'),(657,'sync-dbms-version',2,'2024-06-21 05:45:00.122050','2024-06-21 05:45:00.132664',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(658,'sync-timezone',2,'2024-06-21 05:45:00.141761','2024-06-21 05:45:00.152078',10,'{\"timezone-id\":\"+08:00\"}','success'),(659,'sync-tables',2,'2024-06-21 05:45:00.160924','2024-06-21 05:45:00.190180',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(660,'sync-fields',2,'2024-06-21 05:45:00.199565','2024-06-21 05:45:03.195102',2995,'{\"total-fields\":836,\"updated-fields\":0}','success'),(661,'sync-fks',2,'2024-06-21 05:45:03.204354','2024-06-21 05:45:03.807343',602,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(662,'sync-indexes',2,'2024-06-21 05:45:03.816146','2024-06-21 05:45:04.352367',536,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(663,'sync-metabase-metadata',2,'2024-06-21 05:45:04.360731','2024-06-21 05:45:04.369888',9,'{}','success'),(664,'sync-table-privileges',2,'2024-06-21 05:45:04.377718','2024-06-21 05:45:04.386006',8,NULL,'success'),(665,'analyze',2,'2024-06-21 05:45:04.417549','2024-06-21 05:45:06.394376',1976,NULL,'success'),(666,'fingerprint-fields',2,'2024-06-21 05:45:04.425534','2024-06-21 05:45:06.243519',1817,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(667,'classify-fields',2,'2024-06-21 05:45:06.251971','2024-06-21 05:45:06.358876',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(668,'classify-tables',2,'2024-06-21 05:45:06.366179','2024-06-21 05:45:06.385441',19,'{\"total-tables\":92,\"tables-classified\":0}','success'),(669,'sync',2,'2024-06-21 06:45:00.104910','2024-06-21 06:45:04.539785',4434,NULL,'success'),(670,'sync-dbms-version',2,'2024-06-21 06:45:00.113469','2024-06-21 06:45:00.122867',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(671,'sync-timezone',2,'2024-06-21 06:45:00.132094','2024-06-21 06:45:00.143659',11,'{\"timezone-id\":\"+08:00\"}','success'),(672,'sync-tables',2,'2024-06-21 06:45:00.153031','2024-06-21 06:45:00.180640',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(673,'sync-fields',2,'2024-06-21 06:45:00.189364','2024-06-21 06:45:03.269303',3079,'{\"total-fields\":836,\"updated-fields\":0}','success'),(674,'sync-fks',2,'2024-06-21 06:45:03.277093','2024-06-21 06:45:03.895848',618,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(675,'sync-indexes',2,'2024-06-21 06:45:03.904332','2024-06-21 06:45:04.501517',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(676,'sync-metabase-metadata',2,'2024-06-21 06:45:04.508634','2024-06-21 06:45:04.516874',8,'{}','success'),(677,'sync-table-privileges',2,'2024-06-21 06:45:04.524524','2024-06-21 06:45:04.532015',7,NULL,'success'),(678,'analyze',2,'2024-06-21 06:45:04.563104','2024-06-21 06:45:06.600990',2037,NULL,'success'),(679,'fingerprint-fields',2,'2024-06-21 06:45:04.571152','2024-06-21 06:45:06.439821',1868,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(680,'classify-fields',2,'2024-06-21 06:45:06.448017','2024-06-21 06:45:06.569860',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(681,'classify-tables',2,'2024-06-21 06:45:06.578952','2024-06-21 06:45:06.592694',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(682,'sync',2,'2024-06-21 07:45:00.106461','2024-06-21 07:45:05.499887',5393,NULL,'success'),(683,'sync-dbms-version',2,'2024-06-21 07:45:00.114899','2024-06-21 07:45:00.125306',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(684,'sync-timezone',2,'2024-06-21 07:45:00.135127','2024-06-21 07:45:00.147389',12,'{\"timezone-id\":\"+08:00\"}','success'),(685,'sync-tables',2,'2024-06-21 07:45:00.156938','2024-06-21 07:45:00.187342',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(686,'sync-fields',2,'2024-06-21 07:45:00.196016','2024-06-21 07:45:03.369626',3173,'{\"total-fields\":836,\"updated-fields\":0}','success'),(687,'sync-fks',2,'2024-06-21 07:45:03.380198','2024-06-21 07:45:03.997838',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(688,'sync-indexes',2,'2024-06-21 07:45:04.006449','2024-06-21 07:45:05.457100',1450,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(689,'sync-metabase-metadata',2,'2024-06-21 07:45:05.465080','2024-06-21 07:45:05.473706',8,'{}','success'),(690,'sync-table-privileges',2,'2024-06-21 07:45:05.481876','2024-06-21 07:45:05.490565',8,NULL,'success'),(691,'analyze',2,'2024-06-21 07:45:05.525948','2024-06-21 07:45:07.651888',2125,NULL,'success'),(692,'fingerprint-fields',2,'2024-06-21 07:45:05.534027','2024-06-21 07:45:07.504098',1970,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(693,'classify-fields',2,'2024-06-21 07:45:07.512251','2024-06-21 07:45:07.622307',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(694,'classify-tables',2,'2024-06-21 07:45:07.629978','2024-06-21 07:45:07.643457',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(695,'sync',2,'2024-06-21 08:45:00.109573','2024-06-21 08:45:04.564747',4455,NULL,'success'),(696,'sync-dbms-version',2,'2024-06-21 08:45:00.118049','2024-06-21 08:45:00.127881',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(697,'sync-timezone',2,'2024-06-21 08:45:00.136885','2024-06-21 08:45:00.146828',9,'{\"timezone-id\":\"+08:00\"}','success'),(698,'sync-tables',2,'2024-06-21 08:45:00.155879','2024-06-21 08:45:00.183848',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(699,'sync-fields',2,'2024-06-21 08:45:00.192676','2024-06-21 08:45:03.291146',3098,'{\"total-fields\":836,\"updated-fields\":0}','success'),(700,'sync-fks',2,'2024-06-21 08:45:03.299831','2024-06-21 08:45:03.952064',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(701,'sync-indexes',2,'2024-06-21 08:45:03.961108','2024-06-21 08:45:04.521953',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(702,'sync-metabase-metadata',2,'2024-06-21 08:45:04.529677','2024-06-21 08:45:04.538235',8,'{}','success'),(703,'sync-table-privileges',2,'2024-06-21 08:45:04.547469','2024-06-21 08:45:04.556167',8,NULL,'success'),(704,'analyze',2,'2024-06-21 08:45:04.591712','2024-06-21 08:45:06.682945',2091,NULL,'success'),(705,'fingerprint-fields',2,'2024-06-21 08:45:04.602634','2024-06-21 08:45:06.535874',1933,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(706,'classify-fields',2,'2024-06-21 08:45:06.544195','2024-06-21 08:45:06.653577',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(707,'classify-tables',2,'2024-06-21 08:45:06.660863','2024-06-21 08:45:06.674522',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(708,'sync',2,'2024-06-21 09:45:00.089833','2024-06-21 09:45:04.015826',3925,NULL,'success'),(709,'sync-dbms-version',2,'2024-06-21 09:45:00.100284','2024-06-21 09:45:00.108746',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(710,'sync-timezone',2,'2024-06-21 09:45:00.117673','2024-06-21 09:45:00.127606',9,'{\"timezone-id\":\"+08:00\"}','success'),(711,'sync-tables',2,'2024-06-21 09:45:00.136333','2024-06-21 09:45:00.168604',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(712,'sync-fields',2,'2024-06-21 09:45:00.177292','2024-06-21 09:45:02.939155',2761,'{\"total-fields\":836,\"updated-fields\":0}','success'),(713,'sync-fks',2,'2024-06-21 09:45:02.946853','2024-06-21 09:45:03.525260',578,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(714,'sync-indexes',2,'2024-06-21 09:45:03.534970','2024-06-21 09:45:03.977257',442,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(715,'sync-metabase-metadata',2,'2024-06-21 09:45:03.984421','2024-06-21 09:45:03.992261',7,'{}','success'),(716,'sync-table-privileges',2,'2024-06-21 09:45:03.999622','2024-06-21 09:45:04.007122',7,NULL,'success'),(717,'analyze',2,'2024-06-21 09:45:04.042060','2024-06-21 09:45:05.950510',1908,NULL,'success'),(718,'fingerprint-fields',2,'2024-06-21 09:45:04.049945','2024-06-21 09:45:05.808915',1758,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(719,'classify-fields',2,'2024-06-21 09:45:05.816769','2024-06-21 09:45:05.922476',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(720,'classify-tables',2,'2024-06-21 09:45:05.929939','2024-06-21 09:45:05.942792',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(721,'sync',2,'2024-06-21 10:45:00.103023','2024-06-21 10:45:03.972200',3869,NULL,'success'),(722,'sync-dbms-version',2,'2024-06-21 10:45:00.113063','2024-06-21 10:45:00.121428',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(723,'sync-timezone',2,'2024-06-21 10:45:00.129639','2024-06-21 10:45:00.140540',10,'{\"timezone-id\":\"+08:00\"}','success'),(724,'sync-tables',2,'2024-06-21 10:45:00.148526','2024-06-21 10:45:00.174126',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(725,'sync-fields',2,'2024-06-21 10:45:00.183830','2024-06-21 10:45:02.884743',2700,'{\"total-fields\":836,\"updated-fields\":0}','success'),(726,'sync-fks',2,'2024-06-21 10:45:02.892094','2024-06-21 10:45:03.441232',549,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(727,'sync-indexes',2,'2024-06-21 10:45:03.449069','2024-06-21 10:45:03.931628',482,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(728,'sync-metabase-metadata',2,'2024-06-21 10:45:03.938784','2024-06-21 10:45:03.946853',8,'{}','success'),(729,'sync-table-privileges',2,'2024-06-21 10:45:03.955215','2024-06-21 10:45:03.964314',9,NULL,'success'),(730,'analyze',2,'2024-06-21 10:45:03.995367','2024-06-21 10:45:06.061266',2065,NULL,'success'),(731,'fingerprint-fields',2,'2024-06-21 10:45:04.004849','2024-06-21 10:45:05.917681',1912,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(732,'classify-fields',2,'2024-06-21 10:45:05.925702','2024-06-21 10:45:06.031221',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(733,'classify-tables',2,'2024-06-21 10:45:06.039000','2024-06-21 10:45:06.052444',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(734,'sync',2,'2024-06-21 11:45:00.098209','2024-06-21 11:45:04.042469',3944,NULL,'success'),(735,'sync-dbms-version',2,'2024-06-21 11:45:00.106268','2024-06-21 11:45:00.116493',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(736,'sync-timezone',2,'2024-06-21 11:45:00.124937','2024-06-21 11:45:00.135655',10,'{\"timezone-id\":\"+08:00\"}','success'),(737,'sync-tables',2,'2024-06-21 11:45:00.144301','2024-06-21 11:45:00.179258',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(738,'sync-fields',2,'2024-06-21 11:45:00.187996','2024-06-21 11:45:02.950125',2762,'{\"total-fields\":836,\"updated-fields\":0}','success'),(739,'sync-fks',2,'2024-06-21 11:45:02.958094','2024-06-21 11:45:03.510222',552,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(740,'sync-indexes',2,'2024-06-21 11:45:03.519635','2024-06-21 11:45:04.000175',480,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(741,'sync-metabase-metadata',2,'2024-06-21 11:45:04.007334','2024-06-21 11:45:04.015896',8,'{}','success'),(742,'sync-table-privileges',2,'2024-06-21 11:45:04.026179','2024-06-21 11:45:04.034471',8,NULL,'success'),(743,'analyze',2,'2024-06-21 11:45:04.067805','2024-06-21 11:45:05.962491',1894,NULL,'success'),(744,'fingerprint-fields',2,'2024-06-21 11:45:04.075753','2024-06-21 11:45:05.825843',1750,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(745,'classify-fields',2,'2024-06-21 11:45:05.834107','2024-06-21 11:45:05.934593',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(746,'classify-tables',2,'2024-06-21 11:45:05.942040','2024-06-21 11:45:05.954896',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(747,'sync',2,'2024-06-21 12:45:00.100471','2024-06-21 12:45:04.110779',4010,NULL,'success'),(748,'sync-dbms-version',2,'2024-06-21 12:45:00.108462','2024-06-21 12:45:00.118209',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(749,'sync-timezone',2,'2024-06-21 12:45:00.126935','2024-06-21 12:45:00.138164',11,'{\"timezone-id\":\"+08:00\"}','success'),(750,'sync-tables',2,'2024-06-21 12:45:00.146855','2024-06-21 12:45:00.176891',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(751,'sync-fields',2,'2024-06-21 12:45:00.185925','2024-06-21 12:45:02.962134',2776,'{\"total-fields\":836,\"updated-fields\":0}','success'),(752,'sync-fks',2,'2024-06-21 12:45:02.969922','2024-06-21 12:45:03.559300',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(753,'sync-indexes',2,'2024-06-21 12:45:03.567600','2024-06-21 12:45:04.070656',503,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(754,'sync-metabase-metadata',2,'2024-06-21 12:45:04.078215','2024-06-21 12:45:04.085429',7,'{}','success'),(755,'sync-table-privileges',2,'2024-06-21 12:45:04.093791','2024-06-21 12:45:04.102820',9,NULL,'success'),(756,'analyze',2,'2024-06-21 12:45:04.142403','2024-06-21 12:45:06.166950',2024,NULL,'success'),(757,'fingerprint-fields',2,'2024-06-21 12:45:04.151031','2024-06-21 12:45:06.008200',1857,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(758,'classify-fields',2,'2024-06-21 12:45:06.016716','2024-06-21 12:45:06.133304',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(759,'classify-tables',2,'2024-06-21 12:45:06.141313','2024-06-21 12:45:06.155991',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(760,'field values scanning',2,'2024-06-21 13:00:00.052441','2024-06-21 13:00:11.298626',11246,NULL,'success'),(761,'delete-expired-advanced-field-values',2,'2024-06-21 13:00:00.065989','2024-06-21 13:00:02.841105',2775,'{\"deleted\":0}','success'),(762,'update-field-values',2,'2024-06-21 13:00:02.849290','2024-06-21 13:00:11.291961',8442,'{\"errors\":0,\"created\":0,\"updated\":34,\"deleted\":0}','success'),(763,'sync',2,'2024-06-21 13:45:00.104507','2024-06-21 13:45:04.040511',3936,NULL,'success'),(764,'sync-dbms-version',2,'2024-06-21 13:45:00.112224','2024-06-21 13:45:00.120835',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(765,'sync-timezone',2,'2024-06-21 13:45:00.128675','2024-06-21 13:45:00.139510',10,'{\"timezone-id\":\"+08:00\"}','success'),(766,'sync-tables',2,'2024-06-21 13:45:00.148068','2024-06-21 13:45:00.176414',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(767,'sync-fields',2,'2024-06-21 13:45:00.184743','2024-06-21 13:45:02.924952',2740,'{\"total-fields\":836,\"updated-fields\":0}','success'),(768,'sync-fks',2,'2024-06-21 13:45:02.932838','2024-06-21 13:45:03.537794',604,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(769,'sync-indexes',2,'2024-06-21 13:45:03.546830','2024-06-21 13:45:03.998160',451,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(770,'sync-metabase-metadata',2,'2024-06-21 13:45:04.005815','2024-06-21 13:45:04.013790',7,'{}','success'),(771,'sync-table-privileges',2,'2024-06-21 13:45:04.021886','2024-06-21 13:45:04.031468',9,NULL,'success'),(772,'analyze',2,'2024-06-21 13:45:04.066665','2024-06-21 13:45:05.952088',1885,NULL,'success'),(773,'fingerprint-fields',2,'2024-06-21 13:45:04.074705','2024-06-21 13:45:05.819397',1744,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(774,'classify-fields',2,'2024-06-21 13:45:05.826908','2024-06-21 13:45:05.925024',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(775,'classify-tables',2,'2024-06-21 13:45:05.932038','2024-06-21 13:45:05.944725',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(776,'sync',2,'2024-06-21 14:45:00.112954','2024-06-21 14:45:04.332658',4219,NULL,'success'),(777,'sync-dbms-version',2,'2024-06-21 14:45:00.121701','2024-06-21 14:45:00.131845',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(778,'sync-timezone',2,'2024-06-21 14:45:00.140813','2024-06-21 14:45:00.151856',11,'{\"timezone-id\":\"+08:00\"}','success'),(779,'sync-tables',2,'2024-06-21 14:45:00.160240','2024-06-21 14:45:00.188632',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(780,'sync-fields',2,'2024-06-21 14:45:00.197184','2024-06-21 14:45:03.130110',2932,'{\"total-fields\":836,\"updated-fields\":0}','success'),(781,'sync-fks',2,'2024-06-21 14:45:03.137807','2024-06-21 14:45:03.776485',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(782,'sync-indexes',2,'2024-06-21 14:45:03.786506','2024-06-21 14:45:04.293553',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(783,'sync-metabase-metadata',2,'2024-06-21 14:45:04.301000','2024-06-21 14:45:04.308991',7,'{}','success'),(784,'sync-table-privileges',2,'2024-06-21 14:45:04.316967','2024-06-21 14:45:04.324940',7,NULL,'success'),(785,'analyze',2,'2024-06-21 14:45:04.359306','2024-06-21 14:45:06.365165',2005,NULL,'success'),(786,'fingerprint-fields',2,'2024-06-21 14:45:04.366978','2024-06-21 14:45:06.217895',1850,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(787,'classify-fields',2,'2024-06-21 14:45:06.226265','2024-06-21 14:45:06.335704',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(788,'classify-tables',2,'2024-06-21 14:45:06.343171','2024-06-21 14:45:06.357524',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(789,'sync',2,'2024-06-21 15:45:00.104752','2024-06-21 15:45:04.475464',4370,NULL,'success'),(790,'sync-dbms-version',2,'2024-06-21 15:45:00.113424','2024-06-21 15:45:00.123699',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(791,'sync-timezone',2,'2024-06-21 15:45:00.132414','2024-06-21 15:45:00.143310',10,'{\"timezone-id\":\"+08:00\"}','success'),(792,'sync-tables',2,'2024-06-21 15:45:00.152923','2024-06-21 15:45:00.179243',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(793,'sync-fields',2,'2024-06-21 15:45:00.188195','2024-06-21 15:45:03.206949',3018,'{\"total-fields\":836,\"updated-fields\":0}','success'),(794,'sync-fks',2,'2024-06-21 15:45:03.223644','2024-06-21 15:45:03.850264',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(795,'sync-indexes',2,'2024-06-21 15:45:03.859246','2024-06-21 15:45:04.434946',575,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(796,'sync-metabase-metadata',2,'2024-06-21 15:45:04.441984','2024-06-21 15:45:04.450825',8,'{}','success'),(797,'sync-table-privileges',2,'2024-06-21 15:45:04.458362','2024-06-21 15:45:04.466011',7,NULL,'success'),(798,'analyze',2,'2024-06-21 15:45:04.503161','2024-06-21 15:45:06.531354',2028,NULL,'success'),(799,'fingerprint-fields',2,'2024-06-21 15:45:04.511824','2024-06-21 15:45:06.375109',1863,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(800,'classify-fields',2,'2024-06-21 15:45:06.383035','2024-06-21 15:45:06.500924',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(801,'classify-tables',2,'2024-06-21 15:45:06.508533','2024-06-21 15:45:06.522666',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(802,'task-history-cleanup',NULL,'2024-06-21 16:00:00.035217','2024-06-21 16:00:00.058519',23,NULL,'success'),(803,'task-history-cleanup',NULL,'2024-06-21 16:00:00.074638','2024-06-21 16:00:00.093057',18,NULL,'success'),(804,'sync',2,'2024-06-21 16:45:00.103405','2024-06-21 16:45:04.324645',4221,NULL,'success'),(805,'sync-dbms-version',2,'2024-06-21 16:45:00.111696','2024-06-21 16:45:00.120619',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(806,'sync-timezone',2,'2024-06-21 16:45:00.128710','2024-06-21 16:45:00.138099',9,'{\"timezone-id\":\"+08:00\"}','success'),(807,'sync-tables',2,'2024-06-21 16:45:00.146123','2024-06-21 16:45:00.171852',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(808,'sync-fields',2,'2024-06-21 16:45:00.180740','2024-06-21 16:45:03.068593',2887,'{\"total-fields\":836,\"updated-fields\":0}','success'),(809,'sync-fks',2,'2024-06-21 16:45:03.076994','2024-06-21 16:45:03.685611',608,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(810,'sync-indexes',2,'2024-06-21 16:45:03.694020','2024-06-21 16:45:04.272672',578,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(811,'sync-metabase-metadata',2,'2024-06-21 16:45:04.286985','2024-06-21 16:45:04.298020',11,'{}','success'),(812,'sync-table-privileges',2,'2024-06-21 16:45:04.306979','2024-06-21 16:45:04.316746',9,NULL,'success'),(813,'analyze',2,'2024-06-21 16:45:04.349122','2024-06-21 16:45:06.453081',2103,NULL,'success'),(814,'fingerprint-fields',2,'2024-06-21 16:45:04.356817','2024-06-21 16:45:06.285320',1928,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(815,'classify-fields',2,'2024-06-21 16:45:06.293708','2024-06-21 16:45:06.421556',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(816,'classify-tables',2,'2024-06-21 16:45:06.429119','2024-06-21 16:45:06.444324',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(817,'sync',2,'2024-06-21 17:45:00.108266','2024-06-21 17:45:04.503822',4395,NULL,'success'),(818,'sync-dbms-version',2,'2024-06-21 17:45:00.118719','2024-06-21 17:45:00.127671',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(819,'sync-timezone',2,'2024-06-21 17:45:00.139632','2024-06-21 17:45:00.149208',9,'{\"timezone-id\":\"+08:00\"}','success'),(820,'sync-tables',2,'2024-06-21 17:45:00.157924','2024-06-21 17:45:00.186982',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(821,'sync-fields',2,'2024-06-21 17:45:00.195887','2024-06-21 17:45:03.309477',3113,'{\"total-fields\":836,\"updated-fields\":0}','success'),(822,'sync-fks',2,'2024-06-21 17:45:03.318182','2024-06-21 17:45:03.953725',635,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(823,'sync-indexes',2,'2024-06-21 17:45:03.961905','2024-06-21 17:45:04.462613',500,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(824,'sync-metabase-metadata',2,'2024-06-21 17:45:04.470071','2024-06-21 17:45:04.478113',8,'{}','success'),(825,'sync-table-privileges',2,'2024-06-21 17:45:04.486110','2024-06-21 17:45:04.495859',9,NULL,'success'),(826,'analyze',2,'2024-06-21 17:45:04.529284','2024-06-21 17:45:06.484189',1954,NULL,'success'),(827,'fingerprint-fields',2,'2024-06-21 17:45:04.538178','2024-06-21 17:45:06.335932',1797,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(828,'classify-fields',2,'2024-06-21 17:45:06.344231','2024-06-21 17:45:06.452816',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(829,'classify-tables',2,'2024-06-21 17:45:06.460348','2024-06-21 17:45:06.475782',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(830,'sync',2,'2024-06-21 18:45:00.116606','2024-06-21 18:45:04.412357',4295,NULL,'success'),(831,'sync-dbms-version',2,'2024-06-21 18:45:00.124860','2024-06-21 18:45:00.134881',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(832,'sync-timezone',2,'2024-06-21 18:45:00.143298','2024-06-21 18:45:00.153483',10,'{\"timezone-id\":\"+08:00\"}','success'),(833,'sync-tables',2,'2024-06-21 18:45:00.162782','2024-06-21 18:45:00.195021',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(834,'sync-fields',2,'2024-06-21 18:45:00.204398','2024-06-21 18:45:03.132779',2928,'{\"total-fields\":836,\"updated-fields\":0}','success'),(835,'sync-fks',2,'2024-06-21 18:45:03.140134','2024-06-21 18:45:03.784457',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(836,'sync-indexes',2,'2024-06-21 18:45:03.793285','2024-06-21 18:45:04.367245',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(837,'sync-metabase-metadata',2,'2024-06-21 18:45:04.376415','2024-06-21 18:45:04.386123',9,'{}','success'),(838,'sync-table-privileges',2,'2024-06-21 18:45:04.395770','2024-06-21 18:45:04.404095',8,NULL,'success'),(839,'analyze',2,'2024-06-21 18:45:04.438408','2024-06-21 18:45:06.617429',2179,NULL,'success'),(840,'fingerprint-fields',2,'2024-06-21 18:45:04.446254','2024-06-21 18:45:06.457076',2010,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(841,'classify-fields',2,'2024-06-21 18:45:06.465871','2024-06-21 18:45:06.585803',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(842,'classify-tables',2,'2024-06-21 18:45:06.593253','2024-06-21 18:45:06.608754',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(843,'sync',2,'2024-06-21 19:45:00.107836','2024-06-21 19:45:04.285173',4177,NULL,'success'),(844,'sync-dbms-version',2,'2024-06-21 19:45:00.117422','2024-06-21 19:45:00.127339',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(845,'sync-timezone',2,'2024-06-21 19:45:00.135666','2024-06-21 19:45:00.147938',12,'{\"timezone-id\":\"+08:00\"}','success'),(846,'sync-tables',2,'2024-06-21 19:45:00.157031','2024-06-21 19:45:00.184704',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(847,'sync-fields',2,'2024-06-21 19:45:00.192906','2024-06-21 19:45:03.013093',2820,'{\"total-fields\":836,\"updated-fields\":0}','success'),(848,'sync-fks',2,'2024-06-21 19:45:03.021690','2024-06-21 19:45:03.662797',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(849,'sync-indexes',2,'2024-06-21 19:45:03.671538','2024-06-21 19:45:04.244063',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(850,'sync-metabase-metadata',2,'2024-06-21 19:45:04.252892','2024-06-21 19:45:04.261139',8,'{}','success'),(851,'sync-table-privileges',2,'2024-06-21 19:45:04.269373','2024-06-21 19:45:04.277438',8,NULL,'success'),(852,'analyze',2,'2024-06-21 19:45:04.309658','2024-06-21 19:45:06.406066',2096,NULL,'success'),(853,'fingerprint-fields',2,'2024-06-21 19:45:04.317863','2024-06-21 19:45:06.256241',1938,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(854,'classify-fields',2,'2024-06-21 19:45:06.265010','2024-06-21 19:45:06.375721',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(855,'classify-tables',2,'2024-06-21 19:45:06.384332','2024-06-21 19:45:06.397783',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(856,'sync',2,'2024-06-21 20:45:00.109405','2024-06-21 20:45:04.193445',4084,NULL,'success'),(857,'sync-dbms-version',2,'2024-06-21 20:45:00.117360','2024-06-21 20:45:00.126370',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(858,'sync-timezone',2,'2024-06-21 20:45:00.136514','2024-06-21 20:45:00.147792',11,'{\"timezone-id\":\"+08:00\"}','success'),(859,'sync-tables',2,'2024-06-21 20:45:00.157443','2024-06-21 20:45:00.186139',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(860,'sync-fields',2,'2024-06-21 20:45:00.196345','2024-06-21 20:45:03.002265',2805,'{\"total-fields\":836,\"updated-fields\":0}','success'),(861,'sync-fks',2,'2024-06-21 20:45:03.010540','2024-06-21 20:45:03.602234',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(862,'sync-indexes',2,'2024-06-21 20:45:03.610303','2024-06-21 20:45:04.151545',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(863,'sync-metabase-metadata',2,'2024-06-21 20:45:04.159287','2024-06-21 20:45:04.168442',9,'{}','success'),(864,'sync-table-privileges',2,'2024-06-21 20:45:04.177290','2024-06-21 20:45:04.184658',7,NULL,'success'),(865,'analyze',2,'2024-06-21 20:45:04.218174','2024-06-21 20:45:06.258897',2040,NULL,'success'),(866,'fingerprint-fields',2,'2024-06-21 20:45:04.226047','2024-06-21 20:45:06.109979',1883,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(867,'classify-fields',2,'2024-06-21 20:45:06.118113','2024-06-21 20:45:06.228292',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(868,'classify-tables',2,'2024-06-21 20:45:06.237211','2024-06-21 20:45:06.250436',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(869,'sync',2,'2024-06-21 21:45:00.097716','2024-06-21 21:45:04.603142',4505,NULL,'success'),(870,'sync-dbms-version',2,'2024-06-21 21:45:00.114932','2024-06-21 21:45:00.127997',13,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(871,'sync-timezone',2,'2024-06-21 21:45:00.142408','2024-06-21 21:45:00.153340',10,'{\"timezone-id\":\"+08:00\"}','success'),(872,'sync-tables',2,'2024-06-21 21:45:00.162915','2024-06-21 21:45:00.190478',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(873,'sync-fields',2,'2024-06-21 21:45:00.198499','2024-06-21 21:45:03.246033',3047,'{\"total-fields\":836,\"updated-fields\":0}','success'),(874,'sync-fks',2,'2024-06-21 21:45:03.254206','2024-06-21 21:45:03.938836',684,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(875,'sync-indexes',2,'2024-06-21 21:45:03.948093','2024-06-21 21:45:04.558960',610,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(876,'sync-metabase-metadata',2,'2024-06-21 21:45:04.566811','2024-06-21 21:45:04.574988',8,'{}','success'),(877,'sync-table-privileges',2,'2024-06-21 21:45:04.584214','2024-06-21 21:45:04.593725',9,NULL,'success'),(878,'analyze',2,'2024-06-21 21:45:04.628202','2024-06-21 21:45:06.757946',2129,NULL,'success'),(879,'fingerprint-fields',2,'2024-06-21 21:45:04.636202','2024-06-21 21:45:06.613381',1977,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(880,'classify-fields',2,'2024-06-21 21:45:06.622168','2024-06-21 21:45:06.727527',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(881,'classify-tables',2,'2024-06-21 21:45:06.734872','2024-06-21 21:45:06.749875',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(882,'sync',2,'2024-06-21 22:45:00.096336','2024-06-21 22:45:04.363395',4267,NULL,'success'),(883,'sync-dbms-version',2,'2024-06-21 22:45:00.106029','2024-06-21 22:45:00.117350',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(884,'sync-timezone',2,'2024-06-21 22:45:00.132973','2024-06-21 22:45:00.143417',10,'{\"timezone-id\":\"+08:00\"}','success'),(885,'sync-tables',2,'2024-06-21 22:45:00.153894','2024-06-21 22:45:00.192355',38,'{\"updated-tables\":0,\"total-tables\":99}','success'),(886,'sync-fields',2,'2024-06-21 22:45:00.201638','2024-06-21 22:45:03.202991',3001,'{\"total-fields\":836,\"updated-fields\":0}','success'),(887,'sync-fks',2,'2024-06-21 22:45:03.210898','2024-06-21 22:45:03.789556',578,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(888,'sync-indexes',2,'2024-06-21 22:45:03.798301','2024-06-21 22:45:04.320571',522,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(889,'sync-metabase-metadata',2,'2024-06-21 22:45:04.328578','2024-06-21 22:45:04.338620',10,'{}','success'),(890,'sync-table-privileges',2,'2024-06-21 22:45:04.347115','2024-06-21 22:45:04.355517',8,NULL,'success'),(891,'analyze',2,'2024-06-21 22:45:04.388259','2024-06-21 22:45:06.548700',2160,NULL,'success'),(892,'fingerprint-fields',2,'2024-06-21 22:45:04.396454','2024-06-21 22:45:06.378261',1981,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(893,'classify-fields',2,'2024-06-21 22:45:06.388110','2024-06-21 22:45:06.510171',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(894,'classify-tables',2,'2024-06-21 22:45:06.518169','2024-06-21 22:45:06.533536',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(895,'sync',2,'2024-06-21 23:45:00.103331','2024-06-21 23:45:04.199801',4096,NULL,'success'),(896,'sync-dbms-version',2,'2024-06-21 23:45:00.112038','2024-06-21 23:45:00.121978',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(897,'sync-timezone',2,'2024-06-21 23:45:00.131178','2024-06-21 23:45:00.140832',9,'{\"timezone-id\":\"+08:00\"}','success'),(898,'sync-tables',2,'2024-06-21 23:45:00.149949','2024-06-21 23:45:00.180334',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(899,'sync-fields',2,'2024-06-21 23:45:00.189974','2024-06-21 23:45:03.049829',2859,'{\"total-fields\":836,\"updated-fields\":0}','success'),(900,'sync-fks',2,'2024-06-21 23:45:03.058230','2024-06-21 23:45:03.645772',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(901,'sync-indexes',2,'2024-06-21 23:45:03.654154','2024-06-21 23:45:04.153819',499,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(902,'sync-metabase-metadata',2,'2024-06-21 23:45:04.164144','2024-06-21 23:45:04.172626',8,'{}','success'),(903,'sync-table-privileges',2,'2024-06-21 23:45:04.180674','2024-06-21 23:45:04.189151',8,NULL,'success'),(904,'analyze',2,'2024-06-21 23:45:04.233747','2024-06-21 23:45:06.274674',2040,NULL,'success'),(905,'fingerprint-fields',2,'2024-06-21 23:45:04.242559','2024-06-21 23:45:06.120529',1877,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(906,'classify-fields',2,'2024-06-21 23:45:06.129038','2024-06-21 23:45:06.242939',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(907,'classify-tables',2,'2024-06-21 23:45:06.250469','2024-06-21 23:45:06.266034',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(908,'sync',2,'2024-06-22 00:45:00.097459','2024-06-22 00:45:04.692129',4594,NULL,'success'),(909,'sync-dbms-version',2,'2024-06-22 00:45:00.105332','2024-06-22 00:45:00.115363',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(910,'sync-timezone',2,'2024-06-22 00:45:00.124326','2024-06-22 00:45:00.136296',11,'{\"timezone-id\":\"+08:00\"}','success'),(911,'sync-tables',2,'2024-06-22 00:45:00.145159','2024-06-22 00:45:00.221672',76,'{\"updated-tables\":0,\"total-tables\":99}','success'),(912,'sync-fields',2,'2024-06-22 00:45:00.230306','2024-06-22 00:45:03.351275',3120,'{\"total-fields\":836,\"updated-fields\":0}','success'),(913,'sync-fks',2,'2024-06-22 00:45:03.360255','2024-06-22 00:45:04.095306',735,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(914,'sync-indexes',2,'2024-06-22 00:45:04.104744','2024-06-22 00:45:04.647821',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(915,'sync-metabase-metadata',2,'2024-06-22 00:45:04.655921','2024-06-22 00:45:04.665012',9,'{}','success'),(916,'sync-table-privileges',2,'2024-06-22 00:45:04.674084','2024-06-22 00:45:04.683987',9,NULL,'success'),(917,'analyze',2,'2024-06-22 00:45:04.717238','2024-06-22 00:45:06.671066',1953,NULL,'success'),(918,'fingerprint-fields',2,'2024-06-22 00:45:04.726215','2024-06-22 00:45:06.524231',1798,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(919,'classify-fields',2,'2024-06-22 00:45:06.532344','2024-06-22 00:45:06.641733',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(920,'classify-tables',2,'2024-06-22 00:45:06.649341','2024-06-22 00:45:06.662803',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(921,'sync',2,'2024-06-22 01:45:00.113808','2024-06-22 01:45:04.523012',4409,NULL,'success'),(922,'sync-dbms-version',2,'2024-06-22 01:45:00.125173','2024-06-22 01:45:00.138017',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(923,'sync-timezone',2,'2024-06-22 01:45:00.148151','2024-06-22 01:45:00.160724',12,'{\"timezone-id\":\"+08:00\"}','success'),(924,'sync-tables',2,'2024-06-22 01:45:00.170238','2024-06-22 01:45:00.206176',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(925,'sync-fields',2,'2024-06-22 01:45:00.216033','2024-06-22 01:45:03.266431',3050,'{\"total-fields\":836,\"updated-fields\":0}','success'),(926,'sync-fks',2,'2024-06-22 01:45:03.274764','2024-06-22 01:45:03.898496',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(927,'sync-indexes',2,'2024-06-22 01:45:03.906437','2024-06-22 01:45:04.475249',568,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(928,'sync-metabase-metadata',2,'2024-06-22 01:45:04.484384','2024-06-22 01:45:04.494331',9,'{}','success'),(929,'sync-table-privileges',2,'2024-06-22 01:45:04.505596','2024-06-22 01:45:04.513948',8,NULL,'success'),(930,'analyze',2,'2024-06-22 01:45:04.550720','2024-06-22 01:45:06.589863',2039,NULL,'success'),(931,'fingerprint-fields',2,'2024-06-22 01:45:04.558791','2024-06-22 01:45:06.438185',1879,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(932,'classify-fields',2,'2024-06-22 01:45:06.452301','2024-06-22 01:45:06.561514',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(933,'classify-tables',2,'2024-06-22 01:45:06.568900','2024-06-22 01:45:06.581815',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(934,'sync',2,'2024-06-22 02:45:00.118627','2024-06-22 02:45:04.503538',4384,NULL,'success'),(935,'sync-dbms-version',2,'2024-06-22 02:45:00.127709','2024-06-22 02:45:00.139036',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(936,'sync-timezone',2,'2024-06-22 02:45:00.160279','2024-06-22 02:45:00.173246',12,'{\"timezone-id\":\"+08:00\"}','success'),(937,'sync-tables',2,'2024-06-22 02:45:00.184922','2024-06-22 02:45:00.226684',41,'{\"updated-tables\":0,\"total-tables\":99}','success'),(938,'sync-fields',2,'2024-06-22 02:45:00.237207','2024-06-22 02:45:03.299424',3062,'{\"total-fields\":836,\"updated-fields\":0}','success'),(939,'sync-fks',2,'2024-06-22 02:45:03.308437','2024-06-22 02:45:03.930173',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(940,'sync-indexes',2,'2024-06-22 02:45:03.938230','2024-06-22 02:45:04.465110',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(941,'sync-metabase-metadata',2,'2024-06-22 02:45:04.472365','2024-06-22 02:45:04.479746',7,'{}','success'),(942,'sync-table-privileges',2,'2024-06-22 02:45:04.487565','2024-06-22 02:45:04.495445',7,NULL,'success'),(943,'analyze',2,'2024-06-22 02:45:04.527871','2024-06-22 02:45:06.655324',2127,NULL,'success'),(944,'fingerprint-fields',2,'2024-06-22 02:45:04.537032','2024-06-22 02:45:06.497424',1960,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(945,'classify-fields',2,'2024-06-22 02:45:06.506122','2024-06-22 02:45:06.625180',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(946,'classify-tables',2,'2024-06-22 02:45:06.633303','2024-06-22 02:45:06.647215',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(947,'sync',2,'2024-06-22 03:45:00.112207','2024-06-22 03:45:04.495764',4383,NULL,'success'),(948,'sync-dbms-version',2,'2024-06-22 03:45:00.120821','2024-06-22 03:45:00.131205',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(949,'sync-timezone',2,'2024-06-22 03:45:00.140141','2024-06-22 03:45:00.150865',10,'{\"timezone-id\":\"+08:00\"}','success'),(950,'sync-tables',2,'2024-06-22 03:45:00.161690','2024-06-22 03:45:00.192531',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(951,'sync-fields',2,'2024-06-22 03:45:00.213095','2024-06-22 03:45:03.285425',3072,'{\"total-fields\":836,\"updated-fields\":0}','success'),(952,'sync-fks',2,'2024-06-22 03:45:03.294244','2024-06-22 03:45:03.899753',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(953,'sync-indexes',2,'2024-06-22 03:45:03.908343','2024-06-22 03:45:04.455050',546,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(954,'sync-metabase-metadata',2,'2024-06-22 03:45:04.463201','2024-06-22 03:45:04.470935',7,'{}','success'),(955,'sync-table-privileges',2,'2024-06-22 03:45:04.479668','2024-06-22 03:45:04.487868',8,NULL,'success'),(956,'analyze',2,'2024-06-22 03:45:04.519297','2024-06-22 03:45:06.588522',2069,NULL,'success'),(957,'fingerprint-fields',2,'2024-06-22 03:45:04.528094','2024-06-22 03:45:06.429400',1901,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(958,'classify-fields',2,'2024-06-22 03:45:06.438061','2024-06-22 03:45:06.557069',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(959,'classify-tables',2,'2024-06-22 03:45:06.564678','2024-06-22 03:45:06.579345',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(960,'task-history-cleanup',NULL,'2024-06-22 04:00:00.078145','2024-06-22 04:00:00.103550',25,NULL,'success'),(961,'sync',2,'2024-06-22 04:45:00.112353','2024-06-22 04:45:04.581713',4469,NULL,'success'),(962,'sync-dbms-version',2,'2024-06-22 04:45:00.121326','2024-06-22 04:45:00.131498',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(963,'sync-timezone',2,'2024-06-22 04:45:00.140570','2024-06-22 04:45:00.150946',10,'{\"timezone-id\":\"+08:00\"}','success'),(964,'sync-tables',2,'2024-06-22 04:45:00.159538','2024-06-22 04:45:00.187531',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(965,'sync-fields',2,'2024-06-22 04:45:00.196743','2024-06-22 04:45:03.308201',3111,'{\"total-fields\":836,\"updated-fields\":0}','success'),(966,'sync-fks',2,'2024-06-22 04:45:03.317213','2024-06-22 04:45:03.980793',663,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(967,'sync-indexes',2,'2024-06-22 04:45:03.993142','2024-06-22 04:45:04.540100',546,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(968,'sync-metabase-metadata',2,'2024-06-22 04:45:04.547237','2024-06-22 04:45:04.555337',8,'{}','success'),(969,'sync-table-privileges',2,'2024-06-22 04:45:04.563336','2024-06-22 04:45:04.571815',8,NULL,'success'),(970,'analyze',2,'2024-06-22 04:45:04.608690','2024-06-22 04:45:06.629019',2020,NULL,'success'),(971,'fingerprint-fields',2,'2024-06-22 04:45:04.617286','2024-06-22 04:45:06.470066',1852,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(972,'classify-fields',2,'2024-06-22 04:45:06.478673','2024-06-22 04:45:06.596693',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(973,'classify-tables',2,'2024-06-22 04:45:06.604599','2024-06-22 04:45:06.620139',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(974,'sync',2,'2024-06-22 05:45:00.110701','2024-06-22 05:45:04.778525',4667,NULL,'success'),(975,'sync-dbms-version',2,'2024-06-22 05:45:00.119706','2024-06-22 05:45:00.130778',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(976,'sync-timezone',2,'2024-06-22 05:45:00.140546','2024-06-22 05:45:00.152232',11,'{\"timezone-id\":\"+08:00\"}','success'),(977,'sync-tables',2,'2024-06-22 05:45:00.160983','2024-06-22 05:45:00.193607',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(978,'sync-fields',2,'2024-06-22 05:45:00.204566','2024-06-22 05:45:03.403128',3198,'{\"total-fields\":836,\"updated-fields\":0}','success'),(979,'sync-fks',2,'2024-06-22 05:45:03.412814','2024-06-22 05:45:04.105989',693,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(980,'sync-indexes',2,'2024-06-22 05:45:04.114725','2024-06-22 05:45:04.732704',617,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(981,'sync-metabase-metadata',2,'2024-06-22 05:45:04.741147','2024-06-22 05:45:04.751220',10,'{}','success'),(982,'sync-table-privileges',2,'2024-06-22 05:45:04.759986','2024-06-22 05:45:04.769897',9,NULL,'success'),(983,'analyze',2,'2024-06-22 05:45:04.803610','2024-06-22 05:45:06.819528',2015,NULL,'success'),(984,'fingerprint-fields',2,'2024-06-22 05:45:04.812548','2024-06-22 05:45:06.681888',1869,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(985,'classify-fields',2,'2024-06-22 05:45:06.689653','2024-06-22 05:45:06.791492',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(986,'classify-tables',2,'2024-06-22 05:45:06.798716','2024-06-22 05:45:06.811413',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(987,'sync',2,'2024-06-22 06:45:00.101271','2024-06-22 06:45:04.509577',4408,NULL,'success'),(988,'sync-dbms-version',2,'2024-06-22 06:45:00.109857','2024-06-22 06:45:00.120354',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(989,'sync-timezone',2,'2024-06-22 06:45:00.129093','2024-06-22 06:45:00.139088',9,'{\"timezone-id\":\"+08:00\"}','success'),(990,'sync-tables',2,'2024-06-22 06:45:00.147553','2024-06-22 06:45:00.189897',42,'{\"updated-tables\":0,\"total-tables\":99}','success'),(991,'sync-fields',2,'2024-06-22 06:45:00.200542','2024-06-22 06:45:03.271686',3071,'{\"total-fields\":836,\"updated-fields\":0}','success'),(992,'sync-fks',2,'2024-06-22 06:45:03.281814','2024-06-22 06:45:03.916000',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(993,'sync-indexes',2,'2024-06-22 06:45:03.923800','2024-06-22 06:45:04.467639',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(994,'sync-metabase-metadata',2,'2024-06-22 06:45:04.477113','2024-06-22 06:45:04.485429',8,'{}','success'),(995,'sync-table-privileges',2,'2024-06-22 06:45:04.493507','2024-06-22 06:45:04.501614',8,NULL,'success'),(996,'analyze',2,'2024-06-22 06:45:04.534424','2024-06-22 06:45:06.495946',1961,NULL,'success'),(997,'fingerprint-fields',2,'2024-06-22 06:45:04.545565','2024-06-22 06:45:06.348541',1802,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(998,'classify-fields',2,'2024-06-22 06:45:06.356125','2024-06-22 06:45:06.468018',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(999,'classify-tables',2,'2024-06-22 06:45:06.475069','2024-06-22 06:45:06.487998',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1000,'sync',2,'2024-06-22 07:45:00.110447','2024-06-22 07:45:04.688723',4578,NULL,'success'),(1001,'sync-dbms-version',2,'2024-06-22 07:45:00.119956','2024-06-22 07:45:00.129554',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1002,'sync-timezone',2,'2024-06-22 07:45:00.138172','2024-06-22 07:45:00.150406',12,'{\"timezone-id\":\"+08:00\"}','success'),(1003,'sync-tables',2,'2024-06-22 07:45:00.160918','2024-06-22 07:45:00.186508',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1004,'sync-fields',2,'2024-06-22 07:45:00.195742','2024-06-22 07:45:03.275273',3079,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1005,'sync-fks',2,'2024-06-22 07:45:03.283619','2024-06-22 07:45:03.974817',691,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1006,'sync-indexes',2,'2024-06-22 07:45:03.983904','2024-06-22 07:45:04.647487',663,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1007,'sync-metabase-metadata',2,'2024-06-22 07:45:04.655057','2024-06-22 07:45:04.663273',8,'{}','success'),(1008,'sync-table-privileges',2,'2024-06-22 07:45:04.672319','2024-06-22 07:45:04.680750',8,NULL,'success'),(1009,'analyze',2,'2024-06-22 07:45:04.714504','2024-06-22 07:45:06.821330',2106,NULL,'success'),(1010,'fingerprint-fields',2,'2024-06-22 07:45:04.723569','2024-06-22 07:45:06.652595',1929,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1011,'classify-fields',2,'2024-06-22 07:45:06.663158','2024-06-22 07:45:06.785498',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1012,'classify-tables',2,'2024-06-22 07:45:06.793966','2024-06-22 07:45:06.811748',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1013,'sync',2,'2024-06-22 08:45:00.100067','2024-06-22 08:45:05.160724',5060,NULL,'success'),(1014,'sync-dbms-version',2,'2024-06-22 08:45:00.111282','2024-06-22 08:45:00.122000',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1015,'sync-timezone',2,'2024-06-22 08:45:00.130767','2024-06-22 08:45:00.142708',11,'{\"timezone-id\":\"+08:00\"}','success'),(1016,'sync-tables',2,'2024-06-22 08:45:00.152544','2024-06-22 08:45:00.182529',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1017,'sync-fields',2,'2024-06-22 08:45:00.195329','2024-06-22 08:45:03.169315',2973,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1018,'sync-fks',2,'2024-06-22 08:45:03.177390','2024-06-22 08:45:03.746474',569,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1019,'sync-indexes',2,'2024-06-22 08:45:03.754470','2024-06-22 08:45:05.118818',1364,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1020,'sync-metabase-metadata',2,'2024-06-22 08:45:05.126622','2024-06-22 08:45:05.135622',9,'{}','success'),(1021,'sync-table-privileges',2,'2024-06-22 08:45:05.144164','2024-06-22 08:45:05.153001',8,NULL,'success'),(1022,'analyze',2,'2024-06-22 08:45:05.183917','2024-06-22 08:45:07.276525',2092,NULL,'success'),(1023,'fingerprint-fields',2,'2024-06-22 08:45:05.194119','2024-06-22 08:45:07.116723',1922,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1024,'classify-fields',2,'2024-06-22 08:45:07.124761','2024-06-22 08:45:07.243949',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1025,'classify-tables',2,'2024-06-22 08:45:07.252673','2024-06-22 08:45:07.266425',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1026,'sync',2,'2024-06-22 09:45:00.108435','2024-06-22 09:45:04.327957',4219,NULL,'success'),(1027,'sync-dbms-version',2,'2024-06-22 09:45:00.117255','2024-06-22 09:45:00.128431',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1028,'sync-timezone',2,'2024-06-22 09:45:00.138028','2024-06-22 09:45:00.148565',10,'{\"timezone-id\":\"+08:00\"}','success'),(1029,'sync-tables',2,'2024-06-22 09:45:00.156795','2024-06-22 09:45:00.185099',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1030,'sync-fields',2,'2024-06-22 09:45:00.193816','2024-06-22 09:45:03.098205',2904,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1031,'sync-fks',2,'2024-06-22 09:45:03.110692','2024-06-22 09:45:03.738370',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1032,'sync-indexes',2,'2024-06-22 09:45:03.748407','2024-06-22 09:45:04.287852',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1033,'sync-metabase-metadata',2,'2024-06-22 09:45:04.295251','2024-06-22 09:45:04.303610',8,'{}','success'),(1034,'sync-table-privileges',2,'2024-06-22 09:45:04.311342','2024-06-22 09:45:04.319931',8,NULL,'success'),(1035,'analyze',2,'2024-06-22 09:45:04.354164','2024-06-22 09:45:06.379790',2025,NULL,'success'),(1036,'fingerprint-fields',2,'2024-06-22 09:45:04.362330','2024-06-22 09:45:06.233323',1870,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1037,'classify-fields',2,'2024-06-22 09:45:06.241411','2024-06-22 09:45:06.347475',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1038,'classify-tables',2,'2024-06-22 09:45:06.354796','2024-06-22 09:45:06.369816',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1039,'sync',2,'2024-06-22 10:45:00.104858','2024-06-22 10:45:04.320021',4215,NULL,'success'),(1040,'sync-dbms-version',2,'2024-06-22 10:45:00.114282','2024-06-22 10:45:00.124595',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1041,'sync-timezone',2,'2024-06-22 10:45:00.133461','2024-06-22 10:45:00.144600',11,'{\"timezone-id\":\"+08:00\"}','success'),(1042,'sync-tables',2,'2024-06-22 10:45:00.153539','2024-06-22 10:45:00.180347',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1043,'sync-fields',2,'2024-06-22 10:45:00.189976','2024-06-22 10:45:03.111078',2921,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1044,'sync-fks',2,'2024-06-22 10:45:03.118741','2024-06-22 10:45:03.734155',615,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1045,'sync-indexes',2,'2024-06-22 10:45:03.742656','2024-06-22 10:45:04.280846',538,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1046,'sync-metabase-metadata',2,'2024-06-22 10:45:04.288005','2024-06-22 10:45:04.295607',7,'{}','success'),(1047,'sync-table-privileges',2,'2024-06-22 10:45:04.303630','2024-06-22 10:45:04.312102',8,NULL,'success'),(1048,'analyze',2,'2024-06-22 10:45:04.343763','2024-06-22 10:45:06.476198',2132,NULL,'success'),(1049,'fingerprint-fields',2,'2024-06-22 10:45:04.351570','2024-06-22 10:45:06.312472',1960,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1050,'classify-fields',2,'2024-06-22 10:45:06.322265','2024-06-22 10:45:06.444909',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1051,'classify-tables',2,'2024-06-22 10:45:06.452868','2024-06-22 10:45:06.467965',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1052,'sync',2,'2024-06-22 11:45:00.096125','2024-06-22 11:45:04.134447',4038,NULL,'success'),(1053,'sync-dbms-version',2,'2024-06-22 11:45:00.103991','2024-06-22 11:45:00.113742',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1054,'sync-timezone',2,'2024-06-22 11:45:00.122344','2024-06-22 11:45:00.131985',9,'{\"timezone-id\":\"+08:00\"}','success'),(1055,'sync-tables',2,'2024-06-22 11:45:00.139706','2024-06-22 11:45:00.164717',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1056,'sync-fields',2,'2024-06-22 11:45:00.172505','2024-06-22 11:45:02.963938',2791,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1057,'sync-fks',2,'2024-06-22 11:45:02.971038','2024-06-22 11:45:03.581477',610,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1058,'sync-indexes',2,'2024-06-22 11:45:03.590298','2024-06-22 11:45:04.093695',503,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1059,'sync-metabase-metadata',2,'2024-06-22 11:45:04.101644','2024-06-22 11:45:04.109654',8,'{}','success'),(1060,'sync-table-privileges',2,'2024-06-22 11:45:04.118345','2024-06-22 11:45:04.126668',8,NULL,'success'),(1061,'analyze',2,'2024-06-22 11:45:04.159955','2024-06-22 11:45:06.285930',2125,NULL,'success'),(1062,'fingerprint-fields',2,'2024-06-22 11:45:04.169028','2024-06-22 11:45:06.130606',1961,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1063,'classify-fields',2,'2024-06-22 11:45:06.138569','2024-06-22 11:45:06.252750',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1064,'classify-tables',2,'2024-06-22 11:45:06.261194','2024-06-22 11:45:06.276125',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1065,'sync',2,'2024-06-22 12:45:00.102895','2024-06-22 12:45:04.200998',4098,NULL,'success'),(1066,'sync-dbms-version',2,'2024-06-22 12:45:00.110844','2024-06-22 12:45:00.119820',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1067,'sync-timezone',2,'2024-06-22 12:45:00.128226','2024-06-22 12:45:00.138381',10,'{\"timezone-id\":\"+08:00\"}','success'),(1068,'sync-tables',2,'2024-06-22 12:45:00.147206','2024-06-22 12:45:00.175818',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1069,'sync-fields',2,'2024-06-22 12:45:00.184839','2024-06-22 12:45:03.087858',2903,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1070,'sync-fks',2,'2024-06-22 12:45:03.095681','2024-06-22 12:45:03.640506',544,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1071,'sync-indexes',2,'2024-06-22 12:45:03.648977','2024-06-22 12:45:04.156338',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1072,'sync-metabase-metadata',2,'2024-06-22 12:45:04.164204','2024-06-22 12:45:04.173361',9,'{}','success'),(1073,'sync-table-privileges',2,'2024-06-22 12:45:04.182839','2024-06-22 12:45:04.193233',10,NULL,'success'),(1074,'analyze',2,'2024-06-22 12:45:04.226646','2024-06-22 12:45:06.184600',1957,NULL,'success'),(1075,'fingerprint-fields',2,'2024-06-22 12:45:04.236391','2024-06-22 12:45:06.024441',1788,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1076,'classify-fields',2,'2024-06-22 12:45:06.032411','2024-06-22 12:45:06.154155',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1077,'classify-tables',2,'2024-06-22 12:45:06.161794','2024-06-22 12:45:06.176173',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1078,'field values scanning',2,'2024-06-22 13:00:00.060985','2024-06-22 13:00:11.349141',11288,NULL,'success'),(1079,'delete-expired-advanced-field-values',2,'2024-06-22 13:00:00.073499','2024-06-22 13:00:02.936760',2863,'{\"deleted\":0}','success'),(1080,'update-field-values',2,'2024-06-22 13:00:02.944239','2024-06-22 13:00:11.340070',8395,'{\"errors\":0,\"created\":0,\"updated\":30,\"deleted\":1}','success'),(1081,'sync',2,'2024-06-22 13:45:00.091508','2024-06-22 13:45:03.950117',3858,NULL,'success'),(1082,'sync-dbms-version',2,'2024-06-22 13:45:00.098991','2024-06-22 13:45:00.106939',7,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1083,'sync-timezone',2,'2024-06-22 13:45:00.115200','2024-06-22 13:45:00.124470',9,'{\"timezone-id\":\"+08:00\"}','success'),(1084,'sync-tables',2,'2024-06-22 13:45:00.131994','2024-06-22 13:45:00.170078',38,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1085,'sync-fields',2,'2024-06-22 13:45:00.178230','2024-06-22 13:45:02.811603',2633,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1086,'sync-fks',2,'2024-06-22 13:45:02.819621','2024-06-22 13:45:03.435724',616,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1087,'sync-indexes',2,'2024-06-22 13:45:03.443593','2024-06-22 13:45:03.910055',466,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1088,'sync-metabase-metadata',2,'2024-06-22 13:45:03.917181','2024-06-22 13:45:03.924691',7,'{}','success'),(1089,'sync-table-privileges',2,'2024-06-22 13:45:03.932902','2024-06-22 13:45:03.940630',7,NULL,'success'),(1090,'analyze',2,'2024-06-22 13:45:03.974852','2024-06-22 13:45:05.929975',1955,NULL,'success'),(1091,'fingerprint-fields',2,'2024-06-22 13:45:03.982781','2024-06-22 13:45:05.784087',1801,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1092,'classify-fields',2,'2024-06-22 13:45:05.791914','2024-06-22 13:45:05.900962',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1093,'classify-tables',2,'2024-06-22 13:45:05.908468','2024-06-22 13:45:05.921865',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1094,'sync',2,'2024-06-22 14:45:00.110014','2024-06-22 14:45:03.888606',3778,NULL,'success'),(1095,'sync-dbms-version',2,'2024-06-22 14:45:00.118743','2024-06-22 14:45:00.128355',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1096,'sync-timezone',2,'2024-06-22 14:45:00.136453','2024-06-22 14:45:00.147568',11,'{\"timezone-id\":\"+08:00\"}','success'),(1097,'sync-tables',2,'2024-06-22 14:45:00.155782','2024-06-22 14:45:00.183915',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1098,'sync-fields',2,'2024-06-22 14:45:00.192955','2024-06-22 14:45:02.848700',2655,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1099,'sync-fks',2,'2024-06-22 14:45:02.855841','2024-06-22 14:45:03.387124',531,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1100,'sync-indexes',2,'2024-06-22 14:45:03.395629','2024-06-22 14:45:03.848913',453,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1101,'sync-metabase-metadata',2,'2024-06-22 14:45:03.855955','2024-06-22 14:45:03.863545',7,'{}','success'),(1102,'sync-table-privileges',2,'2024-06-22 14:45:03.871345','2024-06-22 14:45:03.880472',9,NULL,'success'),(1103,'analyze',2,'2024-06-22 14:45:03.911780','2024-06-22 14:45:05.750573',1838,NULL,'success'),(1104,'fingerprint-fields',2,'2024-06-22 14:45:03.919561','2024-06-22 14:45:05.615488',1695,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1105,'classify-fields',2,'2024-06-22 14:45:05.623208','2024-06-22 14:45:05.722640',99,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1106,'classify-tables',2,'2024-06-22 14:45:05.729809','2024-06-22 14:45:05.743064',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1107,'sync',2,'2024-06-22 15:45:00.107431','2024-06-22 15:45:04.586214',4478,NULL,'success'),(1108,'sync-dbms-version',2,'2024-06-22 15:45:00.115726','2024-06-22 15:45:00.125179',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1109,'sync-timezone',2,'2024-06-22 15:45:00.133458','2024-06-22 15:45:00.143621',10,'{\"timezone-id\":\"+08:00\"}','success'),(1110,'sync-tables',2,'2024-06-22 15:45:00.151485','2024-06-22 15:45:00.178125',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1111,'sync-fields',2,'2024-06-22 15:45:00.186817','2024-06-22 15:45:03.277435',3090,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1112,'sync-fks',2,'2024-06-22 15:45:03.286891','2024-06-22 15:45:03.894204',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1113,'sync-indexes',2,'2024-06-22 15:45:03.902232','2024-06-22 15:45:04.541741',639,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1114,'sync-metabase-metadata',2,'2024-06-22 15:45:04.550691','2024-06-22 15:45:04.560142',9,'{}','success'),(1115,'sync-table-privileges',2,'2024-06-22 15:45:04.568806','2024-06-22 15:45:04.578267',9,NULL,'success'),(1116,'analyze',2,'2024-06-22 15:45:04.614654','2024-06-22 15:45:06.653827',2039,NULL,'success'),(1117,'fingerprint-fields',2,'2024-06-22 15:45:04.623154','2024-06-22 15:45:06.503340',1880,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1118,'classify-fields',2,'2024-06-22 15:45:06.511226','2024-06-22 15:45:06.622762',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1119,'classify-tables',2,'2024-06-22 15:45:06.630304','2024-06-22 15:45:06.644727',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1120,'task-history-cleanup',NULL,'2024-06-22 16:00:00.010890','2024-06-22 16:00:00.038768',27,NULL,'success'),(1121,'task-history-cleanup',NULL,'2024-06-22 16:00:00.061003','2024-06-22 16:00:00.075752',14,NULL,'success'),(1122,'sync',2,'2024-06-22 16:45:00.094356','2024-06-22 16:45:04.181232',4086,NULL,'success'),(1123,'sync-dbms-version',2,'2024-06-22 16:45:00.102645','2024-06-22 16:45:00.111855',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1124,'sync-timezone',2,'2024-06-22 16:45:00.120476','2024-06-22 16:45:00.132720',12,'{\"timezone-id\":\"+08:00\"}','success'),(1125,'sync-tables',2,'2024-06-22 16:45:00.142028','2024-06-22 16:45:00.171033',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1126,'sync-fields',2,'2024-06-22 16:45:00.179327','2024-06-22 16:45:03.063196',2883,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1127,'sync-fks',2,'2024-06-22 16:45:03.071010','2024-06-22 16:45:03.651884',580,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1128,'sync-indexes',2,'2024-06-22 16:45:03.660085','2024-06-22 16:45:04.141244',481,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1129,'sync-metabase-metadata',2,'2024-06-22 16:45:04.150217','2024-06-22 16:45:04.158262',8,'{}','success'),(1130,'sync-table-privileges',2,'2024-06-22 16:45:04.165903','2024-06-22 16:45:04.173215',7,NULL,'success'),(1131,'analyze',2,'2024-06-22 16:45:04.204456','2024-06-22 16:45:06.262672',2058,NULL,'success'),(1132,'fingerprint-fields',2,'2024-06-22 16:45:04.212540','2024-06-22 16:45:06.094873',1882,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1133,'classify-fields',2,'2024-06-22 16:45:06.103652','2024-06-22 16:45:06.232209',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1134,'classify-tables',2,'2024-06-22 16:45:06.240548','2024-06-22 16:45:06.253954',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1135,'sync',2,'2024-06-22 17:45:00.096799','2024-06-22 17:45:04.451646',4354,NULL,'success'),(1136,'sync-dbms-version',2,'2024-06-22 17:45:00.106352','2024-06-22 17:45:00.116168',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1137,'sync-timezone',2,'2024-06-22 17:45:00.125223','2024-06-22 17:45:00.136210',10,'{\"timezone-id\":\"+08:00\"}','success'),(1138,'sync-tables',2,'2024-06-22 17:45:00.145027','2024-06-22 17:45:00.176145',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1139,'sync-fields',2,'2024-06-22 17:45:00.185654','2024-06-22 17:45:03.173473',2987,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1140,'sync-fks',2,'2024-06-22 17:45:03.181234','2024-06-22 17:45:03.838546',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1141,'sync-indexes',2,'2024-06-22 17:45:03.848164','2024-06-22 17:45:04.407168',559,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1142,'sync-metabase-metadata',2,'2024-06-22 17:45:04.415707','2024-06-22 17:45:04.424683',8,'{}','success'),(1143,'sync-table-privileges',2,'2024-06-22 17:45:04.434066','2024-06-22 17:45:04.443024',8,NULL,'success'),(1144,'analyze',2,'2024-06-22 17:45:04.478553','2024-06-22 17:45:06.647896',2169,NULL,'success'),(1145,'fingerprint-fields',2,'2024-06-22 17:45:04.487441','2024-06-22 17:45:06.487832',2000,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1146,'classify-fields',2,'2024-06-22 17:45:06.496151','2024-06-22 17:45:06.614866',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1147,'classify-tables',2,'2024-06-22 17:45:06.624180','2024-06-22 17:45:06.639303',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1148,'sync',2,'2024-06-22 18:45:00.108147','2024-06-22 18:45:04.236600',4128,NULL,'success'),(1149,'sync-dbms-version',2,'2024-06-22 18:45:00.115817','2024-06-22 18:45:00.124136',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1150,'sync-timezone',2,'2024-06-22 18:45:00.132021','2024-06-22 18:45:00.142493',10,'{\"timezone-id\":\"+08:00\"}','success'),(1151,'sync-tables',2,'2024-06-22 18:45:00.150772','2024-06-22 18:45:00.177252',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1152,'sync-fields',2,'2024-06-22 18:45:00.185669','2024-06-22 18:45:03.073765',2888,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1153,'sync-fks',2,'2024-06-22 18:45:03.081654','2024-06-22 18:45:03.687193',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1154,'sync-indexes',2,'2024-06-22 18:45:03.696438','2024-06-22 18:45:04.195624',499,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1155,'sync-metabase-metadata',2,'2024-06-22 18:45:04.203973','2024-06-22 18:45:04.212140',8,'{}','success'),(1156,'sync-table-privileges',2,'2024-06-22 18:45:04.220496','2024-06-22 18:45:04.228462',7,NULL,'success'),(1157,'analyze',2,'2024-06-22 18:45:04.262599','2024-06-22 18:45:06.241255',1978,NULL,'success'),(1158,'fingerprint-fields',2,'2024-06-22 18:45:04.270945','2024-06-22 18:45:06.083406',1812,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1159,'classify-fields',2,'2024-06-22 18:45:06.092157','2024-06-22 18:45:06.210044',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1160,'classify-tables',2,'2024-06-22 18:45:06.217778','2024-06-22 18:45:06.233065',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1161,'sync',2,'2024-06-22 19:45:00.099283','2024-06-22 19:45:04.476868',4377,NULL,'success'),(1162,'sync-dbms-version',2,'2024-06-22 19:45:00.107791','2024-06-22 19:45:00.117174',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1163,'sync-timezone',2,'2024-06-22 19:45:00.125994','2024-06-22 19:45:00.135898',9,'{\"timezone-id\":\"+08:00\"}','success'),(1164,'sync-tables',2,'2024-06-22 19:45:00.143946','2024-06-22 19:45:00.170396',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1165,'sync-fields',2,'2024-06-22 19:45:00.179625','2024-06-22 19:45:03.222333',3042,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1166,'sync-fks',2,'2024-06-22 19:45:03.231141','2024-06-22 19:45:03.868674',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1167,'sync-indexes',2,'2024-06-22 19:45:03.878368','2024-06-22 19:45:04.434539',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1168,'sync-metabase-metadata',2,'2024-06-22 19:45:04.442083','2024-06-22 19:45:04.451230',9,'{}','success'),(1169,'sync-table-privileges',2,'2024-06-22 19:45:04.460404','2024-06-22 19:45:04.468746',8,NULL,'success'),(1170,'analyze',2,'2024-06-22 19:45:04.501757','2024-06-22 19:45:06.671928',2170,NULL,'success'),(1171,'fingerprint-fields',2,'2024-06-22 19:45:04.511926','2024-06-22 19:45:06.513998',2002,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1172,'classify-fields',2,'2024-06-22 19:45:06.523333','2024-06-22 19:45:06.642095',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1173,'classify-tables',2,'2024-06-22 19:45:06.650068','2024-06-22 19:45:06.663456',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1174,'sync',2,'2024-06-22 20:45:00.103810','2024-06-22 20:45:04.231985',4128,NULL,'success'),(1175,'sync-dbms-version',2,'2024-06-22 20:45:00.112353','2024-06-22 20:45:00.122073',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1176,'sync-timezone',2,'2024-06-22 20:45:00.131126','2024-06-22 20:45:00.140984',9,'{\"timezone-id\":\"+08:00\"}','success'),(1177,'sync-tables',2,'2024-06-22 20:45:00.150026','2024-06-22 20:45:00.178145',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1178,'sync-fields',2,'2024-06-22 20:45:00.187004','2024-06-22 20:45:03.124931',2937,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1179,'sync-fks',2,'2024-06-22 20:45:03.137333','2024-06-22 20:45:03.681037',543,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1180,'sync-indexes',2,'2024-06-22 20:45:03.689887','2024-06-22 20:45:04.189647',499,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1181,'sync-metabase-metadata',2,'2024-06-22 20:45:04.197785','2024-06-22 20:45:04.205301',7,'{}','success'),(1182,'sync-table-privileges',2,'2024-06-22 20:45:04.213957','2024-06-22 20:45:04.222471',8,NULL,'success'),(1183,'analyze',2,'2024-06-22 20:45:04.260351','2024-06-22 20:45:06.319325',2058,NULL,'success'),(1184,'fingerprint-fields',2,'2024-06-22 20:45:04.270228','2024-06-22 20:45:06.158543',1888,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1185,'classify-fields',2,'2024-06-22 20:45:06.167229','2024-06-22 20:45:06.289072',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1186,'classify-tables',2,'2024-06-22 20:45:06.297332','2024-06-22 20:45:06.310986',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1187,'sync',2,'2024-06-22 21:45:00.099289','2024-06-22 21:45:04.337602',4238,NULL,'success'),(1188,'sync-dbms-version',2,'2024-06-22 21:45:00.108029','2024-06-22 21:45:00.117127',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1189,'sync-timezone',2,'2024-06-22 21:45:00.125639','2024-06-22 21:45:00.135975',10,'{\"timezone-id\":\"+08:00\"}','success'),(1190,'sync-tables',2,'2024-06-22 21:45:00.144335','2024-06-22 21:45:00.170901',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1191,'sync-fields',2,'2024-06-22 21:45:00.179345','2024-06-22 21:45:03.135308',2955,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1192,'sync-fks',2,'2024-06-22 21:45:03.145667','2024-06-22 21:45:03.721383',575,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1193,'sync-indexes',2,'2024-06-22 21:45:03.730606','2024-06-22 21:45:04.289039',558,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1194,'sync-metabase-metadata',2,'2024-06-22 21:45:04.302314','2024-06-22 21:45:04.311181',8,'{}','success'),(1195,'sync-table-privileges',2,'2024-06-22 21:45:04.319770','2024-06-22 21:45:04.328093',8,NULL,'success'),(1196,'analyze',2,'2024-06-22 21:45:04.362537','2024-06-22 21:45:06.401764',2039,NULL,'success'),(1197,'fingerprint-fields',2,'2024-06-22 21:45:04.370959','2024-06-22 21:45:06.268577',1897,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1198,'classify-fields',2,'2024-06-22 21:45:06.276039','2024-06-22 21:45:06.373233',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1199,'classify-tables',2,'2024-06-22 21:45:06.380279','2024-06-22 21:45:06.393391',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1200,'sync',2,'2024-06-22 22:45:00.112019','2024-06-22 22:45:04.533879',4421,NULL,'success'),(1201,'sync-dbms-version',2,'2024-06-22 22:45:00.120810','2024-06-22 22:45:00.129899',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1202,'sync-timezone',2,'2024-06-22 22:45:00.141946','2024-06-22 22:45:00.153529',11,'{\"timezone-id\":\"+08:00\"}','success'),(1203,'sync-tables',2,'2024-06-22 22:45:00.162672','2024-06-22 22:45:00.191849',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1204,'sync-fields',2,'2024-06-22 22:45:00.200264','2024-06-22 22:45:03.226896',3026,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1205,'sync-fks',2,'2024-06-22 22:45:03.235380','2024-06-22 22:45:03.897775',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1206,'sync-indexes',2,'2024-06-22 22:45:03.906656','2024-06-22 22:45:04.488380',581,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1207,'sync-metabase-metadata',2,'2024-06-22 22:45:04.497378','2024-06-22 22:45:04.507525',10,'{}','success'),(1208,'sync-table-privileges',2,'2024-06-22 22:45:04.516726','2024-06-22 22:45:04.525261',8,NULL,'success'),(1209,'analyze',2,'2024-06-22 22:45:04.567617','2024-06-22 22:45:06.732120',2164,NULL,'success'),(1210,'fingerprint-fields',2,'2024-06-22 22:45:04.577649','2024-06-22 22:45:06.567194',1989,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1211,'classify-fields',2,'2024-06-22 22:45:06.575380','2024-06-22 22:45:06.701859',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1212,'classify-tables',2,'2024-06-22 22:45:06.710062','2024-06-22 22:45:06.723869',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1213,'sync',2,'2024-06-22 23:45:00.113012','2024-06-22 23:45:04.678152',4565,NULL,'success'),(1214,'sync-dbms-version',2,'2024-06-22 23:45:00.121249','2024-06-22 23:45:00.131381',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1215,'sync-timezone',2,'2024-06-22 23:45:00.140062','2024-06-22 23:45:00.152155',12,'{\"timezone-id\":\"+08:00\"}','success'),(1216,'sync-tables',2,'2024-06-22 23:45:00.161738','2024-06-22 23:45:00.189784',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1217,'sync-fields',2,'2024-06-22 23:45:00.198782','2024-06-22 23:45:03.384815',3186,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1218,'sync-fks',2,'2024-06-22 23:45:03.395302','2024-06-22 23:45:04.029219',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1219,'sync-indexes',2,'2024-06-22 23:45:04.039977','2024-06-22 23:45:04.629143',589,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1220,'sync-metabase-metadata',2,'2024-06-22 23:45:04.638312','2024-06-22 23:45:04.648241',9,'{}','success'),(1221,'sync-table-privileges',2,'2024-06-22 23:45:04.658354','2024-06-22 23:45:04.668193',9,NULL,'success'),(1222,'analyze',2,'2024-06-22 23:45:04.709847','2024-06-22 23:45:06.907235',2197,NULL,'success'),(1223,'fingerprint-fields',2,'2024-06-22 23:45:04.720448','2024-06-22 23:45:06.746659',2026,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1224,'classify-fields',2,'2024-06-22 23:45:06.755332','2024-06-22 23:45:06.873983',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1225,'classify-tables',2,'2024-06-22 23:45:06.881917','2024-06-22 23:45:06.895961',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1226,'sync',2,'2024-06-23 00:45:00.098477','2024-06-23 00:45:04.651776',4553,NULL,'success'),(1227,'sync-dbms-version',2,'2024-06-23 00:45:00.107356','2024-06-23 00:45:00.116261',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1228,'sync-timezone',2,'2024-06-23 00:45:00.125918','2024-06-23 00:45:00.136736',10,'{\"timezone-id\":\"+08:00\"}','success'),(1229,'sync-tables',2,'2024-06-23 00:45:00.145883','2024-06-23 00:45:00.174683',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1230,'sync-fields',2,'2024-06-23 00:45:00.183102','2024-06-23 00:45:03.316115',3133,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1231,'sync-fks',2,'2024-06-23 00:45:03.324869','2024-06-23 00:45:04.004819',679,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1232,'sync-indexes',2,'2024-06-23 00:45:04.013821','2024-06-23 00:45:04.602690',588,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1233,'sync-metabase-metadata',2,'2024-06-23 00:45:04.613095','2024-06-23 00:45:04.624291',11,'{}','success'),(1234,'sync-table-privileges',2,'2024-06-23 00:45:04.633647','2024-06-23 00:45:04.642374',8,NULL,'success'),(1235,'analyze',2,'2024-06-23 00:45:04.677862','2024-06-23 00:45:06.873230',2195,NULL,'success'),(1236,'fingerprint-fields',2,'2024-06-23 00:45:04.688164','2024-06-23 00:45:06.722456',2034,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1237,'classify-fields',2,'2024-06-23 00:45:06.730426','2024-06-23 00:45:06.836820',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1238,'classify-tables',2,'2024-06-23 00:45:06.847549','2024-06-23 00:45:06.864561',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1239,'sync',2,'2024-06-23 01:45:00.110689','2024-06-23 01:45:04.804076',4693,NULL,'success'),(1240,'sync-dbms-version',2,'2024-06-23 01:45:00.118774','2024-06-23 01:45:00.129839',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1241,'sync-timezone',2,'2024-06-23 01:45:00.139169','2024-06-23 01:45:00.151629',12,'{\"timezone-id\":\"+08:00\"}','success'),(1242,'sync-tables',2,'2024-06-23 01:45:00.161085','2024-06-23 01:45:00.194760',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1243,'sync-fields',2,'2024-06-23 01:45:00.205817','2024-06-23 01:45:03.496943',3291,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1244,'sync-fks',2,'2024-06-23 01:45:03.505469','2024-06-23 01:45:04.224746',719,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1245,'sync-indexes',2,'2024-06-23 01:45:04.234894','2024-06-23 01:45:04.760249',525,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1246,'sync-metabase-metadata',2,'2024-06-23 01:45:04.768495','2024-06-23 01:45:04.776554',8,'{}','success'),(1247,'sync-table-privileges',2,'2024-06-23 01:45:04.785443','2024-06-23 01:45:04.794793',9,NULL,'success'),(1248,'analyze',2,'2024-06-23 01:45:04.830495','2024-06-23 01:45:07.113149',2282,NULL,'success'),(1249,'fingerprint-fields',2,'2024-06-23 01:45:04.840310','2024-06-23 01:45:06.949227',2108,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1250,'classify-fields',2,'2024-06-23 01:45:06.957803','2024-06-23 01:45:07.078013',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1251,'classify-tables',2,'2024-06-23 01:45:07.085884','2024-06-23 01:45:07.103778',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1252,'sync',2,'2024-06-23 02:45:00.108526','2024-06-23 02:45:04.834434',4725,NULL,'success'),(1253,'sync-dbms-version',2,'2024-06-23 02:45:00.118424','2024-06-23 02:45:00.129628',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1254,'sync-timezone',2,'2024-06-23 02:45:00.139789','2024-06-23 02:45:00.152106',12,'{\"timezone-id\":\"+08:00\"}','success'),(1255,'sync-tables',2,'2024-06-23 02:45:00.161416','2024-06-23 02:45:00.189290',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1256,'sync-fields',2,'2024-06-23 02:45:00.198413','2024-06-23 02:45:03.562480',3364,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1257,'sync-fks',2,'2024-06-23 02:45:03.571397','2024-06-23 02:45:04.284624',713,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1258,'sync-indexes',2,'2024-06-23 02:45:04.292602','2024-06-23 02:45:04.792737',500,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1259,'sync-metabase-metadata',2,'2024-06-23 02:45:04.800522','2024-06-23 02:45:04.809928',9,'{}','success'),(1260,'sync-table-privileges',2,'2024-06-23 02:45:04.818541','2024-06-23 02:45:04.826535',7,NULL,'success'),(1261,'analyze',2,'2024-06-23 02:45:04.862855','2024-06-23 02:45:06.897482',2034,NULL,'success'),(1262,'fingerprint-fields',2,'2024-06-23 02:45:04.871005','2024-06-23 02:45:06.737031',1866,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1263,'classify-fields',2,'2024-06-23 02:45:06.745973','2024-06-23 02:45:06.865806',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1264,'classify-tables',2,'2024-06-23 02:45:06.874004','2024-06-23 02:45:06.889084',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1265,'sync',2,'2024-06-23 03:45:00.094715','2024-06-23 03:45:04.221427',4126,NULL,'success'),(1266,'sync-dbms-version',2,'2024-06-23 03:45:00.102653','2024-06-23 03:45:00.113462',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1267,'sync-timezone',2,'2024-06-23 03:45:00.122110','2024-06-23 03:45:00.131815',9,'{\"timezone-id\":\"+08:00\"}','success'),(1268,'sync-tables',2,'2024-06-23 03:45:00.140139','2024-06-23 03:45:00.173316',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1269,'sync-fields',2,'2024-06-23 03:45:00.182341','2024-06-23 03:45:03.060993',2878,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1270,'sync-fks',2,'2024-06-23 03:45:03.068706','2024-06-23 03:45:03.675991',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1271,'sync-indexes',2,'2024-06-23 03:45:03.684962','2024-06-23 03:45:04.181475',496,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1272,'sync-metabase-metadata',2,'2024-06-23 03:45:04.188759','2024-06-23 03:45:04.197395',8,'{}','success'),(1273,'sync-table-privileges',2,'2024-06-23 03:45:04.205294','2024-06-23 03:45:04.213132',7,NULL,'success'),(1274,'analyze',2,'2024-06-23 03:45:04.245394','2024-06-23 03:45:06.246813',2001,NULL,'success'),(1275,'fingerprint-fields',2,'2024-06-23 03:45:04.253735','2024-06-23 03:45:06.093619',1839,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1276,'classify-fields',2,'2024-06-23 03:45:06.101962','2024-06-23 03:45:06.215971',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1277,'classify-tables',2,'2024-06-23 03:45:06.223697','2024-06-23 03:45:06.236975',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1278,'task-history-cleanup',NULL,'2024-06-23 04:00:00.082255','2024-06-23 04:00:00.097647',15,NULL,'success'),(1279,'sync',2,'2024-06-23 04:45:00.103026','2024-06-23 04:45:04.377671',4274,NULL,'success'),(1280,'sync-dbms-version',2,'2024-06-23 04:45:00.111018','2024-06-23 04:45:00.120291',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1281,'sync-timezone',2,'2024-06-23 04:45:00.128470','2024-06-23 04:45:00.139953',11,'{\"timezone-id\":\"+08:00\"}','success'),(1282,'sync-tables',2,'2024-06-23 04:45:00.148315','2024-06-23 04:45:00.179625',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1283,'sync-fields',2,'2024-06-23 04:45:00.188707','2024-06-23 04:45:03.123244',2934,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1284,'sync-fks',2,'2024-06-23 04:45:03.131104','2024-06-23 04:45:03.772472',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1285,'sync-indexes',2,'2024-06-23 04:45:03.786837','2024-06-23 04:45:04.335777',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1286,'sync-metabase-metadata',2,'2024-06-23 04:45:04.343638','2024-06-23 04:45:04.351730',8,'{}','success'),(1287,'sync-table-privileges',2,'2024-06-23 04:45:04.361035','2024-06-23 04:45:04.369199',8,NULL,'success'),(1288,'analyze',2,'2024-06-23 04:45:04.402355','2024-06-23 04:45:06.617055',2214,NULL,'success'),(1289,'fingerprint-fields',2,'2024-06-23 04:45:04.411447','2024-06-23 04:45:06.459012',2047,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1290,'classify-fields',2,'2024-06-23 04:45:06.468218','2024-06-23 04:45:06.586455',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1291,'classify-tables',2,'2024-06-23 04:45:06.594282','2024-06-23 04:45:06.608641',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1292,'sync',2,'2024-06-23 05:45:00.106940','2024-06-23 05:45:04.576622',4469,NULL,'success'),(1293,'sync-dbms-version',2,'2024-06-23 05:45:00.115958','2024-06-23 05:45:00.125038',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1294,'sync-timezone',2,'2024-06-23 05:45:00.133729','2024-06-23 05:45:00.143953',10,'{\"timezone-id\":\"+08:00\"}','success'),(1295,'sync-tables',2,'2024-06-23 05:45:00.152962','2024-06-23 05:45:00.182472',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1296,'sync-fields',2,'2024-06-23 05:45:00.199155','2024-06-23 05:45:03.277494',3078,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1297,'sync-fks',2,'2024-06-23 05:45:03.285535','2024-06-23 05:45:03.955730',670,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1298,'sync-indexes',2,'2024-06-23 05:45:03.964517','2024-06-23 05:45:04.533655',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1299,'sync-metabase-metadata',2,'2024-06-23 05:45:04.541227','2024-06-23 05:45:04.549311',8,'{}','success'),(1300,'sync-table-privileges',2,'2024-06-23 05:45:04.557255','2024-06-23 05:45:04.567197',9,NULL,'success'),(1301,'analyze',2,'2024-06-23 05:45:04.604924','2024-06-23 05:45:06.833259',2228,NULL,'success'),(1302,'fingerprint-fields',2,'2024-06-23 05:45:04.613438','2024-06-23 05:45:06.685303',2071,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1303,'classify-fields',2,'2024-06-23 05:45:06.694849','2024-06-23 05:45:06.801911',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1304,'classify-tables',2,'2024-06-23 05:45:06.809267','2024-06-23 05:45:06.823071',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1305,'sync',2,'2024-06-23 06:45:00.101526','2024-06-23 06:45:04.329685',4228,NULL,'success'),(1306,'sync-dbms-version',2,'2024-06-23 06:45:00.111140','2024-06-23 06:45:00.120296',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1307,'sync-timezone',2,'2024-06-23 06:45:00.128831','2024-06-23 06:45:00.139296',10,'{\"timezone-id\":\"+08:00\"}','success'),(1308,'sync-tables',2,'2024-06-23 06:45:00.147872','2024-06-23 06:45:00.174675',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1309,'sync-fields',2,'2024-06-23 06:45:00.183041','2024-06-23 06:45:03.189135',3006,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1310,'sync-fks',2,'2024-06-23 06:45:03.196426','2024-06-23 06:45:03.786061',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1311,'sync-indexes',2,'2024-06-23 06:45:03.794063','2024-06-23 06:45:04.288460',494,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1312,'sync-metabase-metadata',2,'2024-06-23 06:45:04.296184','2024-06-23 06:45:04.304366',8,'{}','success'),(1313,'sync-table-privileges',2,'2024-06-23 06:45:04.312906','2024-06-23 06:45:04.321662',8,NULL,'success'),(1314,'analyze',2,'2024-06-23 06:45:04.354268','2024-06-23 06:45:06.359558',2005,NULL,'success'),(1315,'fingerprint-fields',2,'2024-06-23 06:45:04.362437','2024-06-23 06:45:06.190104',1827,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1316,'classify-fields',2,'2024-06-23 06:45:06.199172','2024-06-23 06:45:06.328965',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1317,'classify-tables',2,'2024-06-23 06:45:06.337514','2024-06-23 06:45:06.351628',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1318,'sync',2,'2024-06-23 07:45:00.102989','2024-06-23 07:45:04.034045',3931,NULL,'success'),(1319,'sync-dbms-version',2,'2024-06-23 07:45:00.111442','2024-06-23 07:45:00.120697',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1320,'sync-timezone',2,'2024-06-23 07:45:00.129963','2024-06-23 07:45:00.140667',10,'{\"timezone-id\":\"+08:00\"}','success'),(1321,'sync-tables',2,'2024-06-23 07:45:00.149501','2024-06-23 07:45:00.178728',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1322,'sync-fields',2,'2024-06-23 07:45:00.187303','2024-06-23 07:45:02.903183',2715,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1323,'sync-fks',2,'2024-06-23 07:45:02.910849','2024-06-23 07:45:03.472664',561,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1324,'sync-indexes',2,'2024-06-23 07:45:03.480778','2024-06-23 07:45:03.990629',509,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1325,'sync-metabase-metadata',2,'2024-06-23 07:45:03.998641','2024-06-23 07:45:04.007796',9,'{}','success'),(1326,'sync-table-privileges',2,'2024-06-23 07:45:04.016455','2024-06-23 07:45:04.025354',8,NULL,'success'),(1327,'analyze',2,'2024-06-23 07:45:04.058919','2024-06-23 07:45:06.031633',1972,NULL,'success'),(1328,'fingerprint-fields',2,'2024-06-23 07:45:04.066561','2024-06-23 07:45:05.884797',1818,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1329,'classify-fields',2,'2024-06-23 07:45:05.892781','2024-06-23 07:45:05.999842',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1330,'classify-tables',2,'2024-06-23 07:45:06.007246','2024-06-23 07:45:06.022786',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1331,'sync',2,'2024-06-23 08:45:00.111102','2024-06-23 08:45:04.294988',4183,NULL,'success'),(1332,'sync-dbms-version',2,'2024-06-23 08:45:00.119935','2024-06-23 08:45:00.133444',13,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1333,'sync-timezone',2,'2024-06-23 08:45:00.142177','2024-06-23 08:45:00.154414',12,'{\"timezone-id\":\"+08:00\"}','success'),(1334,'sync-tables',2,'2024-06-23 08:45:00.162748','2024-06-23 08:45:00.188915',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1335,'sync-fields',2,'2024-06-23 08:45:00.198608','2024-06-23 08:45:03.143149',2944,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1336,'sync-fks',2,'2024-06-23 08:45:03.150819','2024-06-23 08:45:03.674423',523,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1337,'sync-indexes',2,'2024-06-23 08:45:03.682887','2024-06-23 08:45:04.255616',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1338,'sync-metabase-metadata',2,'2024-06-23 08:45:04.263388','2024-06-23 08:45:04.270936',7,'{}','success'),(1339,'sync-table-privileges',2,'2024-06-23 08:45:04.278840','2024-06-23 08:45:04.286897',8,NULL,'success'),(1340,'analyze',2,'2024-06-23 08:45:04.320989','2024-06-23 08:45:06.245194',1924,NULL,'success'),(1341,'fingerprint-fields',2,'2024-06-23 08:45:04.330068','2024-06-23 08:45:06.089793',1759,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1342,'classify-fields',2,'2024-06-23 08:45:06.098721','2024-06-23 08:45:06.213532',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1343,'classify-tables',2,'2024-06-23 08:45:06.222099','2024-06-23 08:45:06.236846',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1344,'sync',2,'2024-06-23 09:45:00.094152','2024-06-23 09:45:04.993210',4899,NULL,'success'),(1345,'sync-dbms-version',2,'2024-06-23 09:45:00.101795','2024-06-23 09:45:00.110466',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1346,'sync-timezone',2,'2024-06-23 09:45:00.119239','2024-06-23 09:45:00.128941',9,'{\"timezone-id\":\"+08:00\"}','success'),(1347,'sync-tables',2,'2024-06-23 09:45:00.136894','2024-06-23 09:45:00.163941',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1348,'sync-fields',2,'2024-06-23 09:45:00.173011','2024-06-23 09:45:02.952986',2779,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1349,'sync-fks',2,'2024-06-23 09:45:02.960621','2024-06-23 09:45:03.561897',601,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1350,'sync-indexes',2,'2024-06-23 09:45:03.570077','2024-06-23 09:45:04.934611',1364,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1351,'sync-metabase-metadata',2,'2024-06-23 09:45:04.942458','2024-06-23 09:45:04.954172',11,'{}','success'),(1352,'sync-table-privileges',2,'2024-06-23 09:45:04.962450','2024-06-23 09:45:04.981723',19,NULL,'success'),(1353,'analyze',2,'2024-06-23 09:45:05.022560','2024-06-23 09:45:07.071658',2049,NULL,'success'),(1354,'fingerprint-fields',2,'2024-06-23 09:45:05.030351','2024-06-23 09:45:06.922076',1891,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1355,'classify-fields',2,'2024-06-23 09:45:06.930408','2024-06-23 09:45:07.042434',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1356,'classify-tables',2,'2024-06-23 09:45:07.050033','2024-06-23 09:45:07.063623',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1357,'sync',2,'2024-06-23 10:45:00.113377','2024-06-23 10:45:04.034545',3921,NULL,'success'),(1358,'sync-dbms-version',2,'2024-06-23 10:45:00.122509','2024-06-23 10:45:00.133561',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1359,'sync-timezone',2,'2024-06-23 10:45:00.143171','2024-06-23 10:45:00.163552',20,'{\"timezone-id\":\"+08:00\"}','success'),(1360,'sync-tables',2,'2024-06-23 10:45:00.172693','2024-06-23 10:45:00.204387',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1361,'sync-fields',2,'2024-06-23 10:45:00.213969','2024-06-23 10:45:02.967855',2753,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1362,'sync-fks',2,'2024-06-23 10:45:02.979254','2024-06-23 10:45:03.541403',562,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1363,'sync-indexes',2,'2024-06-23 10:45:03.549065','2024-06-23 10:45:03.995128',446,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1364,'sync-metabase-metadata',2,'2024-06-23 10:45:04.003014','2024-06-23 10:45:04.010060',7,'{}','success'),(1365,'sync-table-privileges',2,'2024-06-23 10:45:04.018442','2024-06-23 10:45:04.027014',8,NULL,'success'),(1366,'analyze',2,'2024-06-23 10:45:04.062519','2024-06-23 10:45:06.053042',1990,NULL,'success'),(1367,'fingerprint-fields',2,'2024-06-23 10:45:04.071207','2024-06-23 10:45:05.902467',1831,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1368,'classify-fields',2,'2024-06-23 10:45:05.911235','2024-06-23 10:45:06.023988',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1369,'classify-tables',2,'2024-06-23 10:45:06.031712','2024-06-23 10:45:06.044805',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1370,'sync',2,'2024-06-23 11:45:00.093304','2024-06-23 11:45:03.828383',3735,NULL,'success'),(1371,'sync-dbms-version',2,'2024-06-23 11:45:00.100600','2024-06-23 11:45:00.109051',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1372,'sync-timezone',2,'2024-06-23 11:45:00.116983','2024-06-23 11:45:00.126601',9,'{\"timezone-id\":\"+08:00\"}','success'),(1373,'sync-tables',2,'2024-06-23 11:45:00.134820','2024-06-23 11:45:00.160602',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1374,'sync-fields',2,'2024-06-23 11:45:00.169840','2024-06-23 11:45:02.772139',2602,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1375,'sync-fks',2,'2024-06-23 11:45:02.779521','2024-06-23 11:45:03.320927',541,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1376,'sync-indexes',2,'2024-06-23 11:45:03.333836','2024-06-23 11:45:03.789801',455,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1377,'sync-metabase-metadata',2,'2024-06-23 11:45:03.797001','2024-06-23 11:45:03.804798',7,'{}','success'),(1378,'sync-table-privileges',2,'2024-06-23 11:45:03.812548','2024-06-23 11:45:03.820464',7,NULL,'success'),(1379,'analyze',2,'2024-06-23 11:45:03.852189','2024-06-23 11:45:05.655141',1802,NULL,'success'),(1380,'fingerprint-fields',2,'2024-06-23 11:45:03.861067','2024-06-23 11:45:05.519707',1658,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1381,'classify-fields',2,'2024-06-23 11:45:05.527733','2024-06-23 11:45:05.627184',99,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1382,'classify-tables',2,'2024-06-23 11:45:05.634382','2024-06-23 11:45:05.646467',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1383,'sync',2,'2024-06-23 12:45:00.102038','2024-06-23 12:45:04.484100',4382,NULL,'success'),(1384,'sync-dbms-version',2,'2024-06-23 12:45:00.110627','2024-06-23 12:45:00.119891',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1385,'sync-timezone',2,'2024-06-23 12:45:00.129538','2024-06-23 12:45:00.140518',10,'{\"timezone-id\":\"+08:00\"}','success'),(1386,'sync-tables',2,'2024-06-23 12:45:00.149093','2024-06-23 12:45:00.180299',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1387,'sync-fields',2,'2024-06-23 12:45:00.189722','2024-06-23 12:45:03.356040',3166,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1388,'sync-fks',2,'2024-06-23 12:45:03.364118','2024-06-23 12:45:03.923471',559,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1389,'sync-indexes',2,'2024-06-23 12:45:03.931454','2024-06-23 12:45:04.438143',506,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1390,'sync-metabase-metadata',2,'2024-06-23 12:45:04.446813','2024-06-23 12:45:04.455064',8,'{}','success'),(1391,'sync-table-privileges',2,'2024-06-23 12:45:04.464910','2024-06-23 12:45:04.474634',9,NULL,'success'),(1392,'analyze',2,'2024-06-23 12:45:04.509322','2024-06-23 12:45:06.463189',1953,NULL,'success'),(1393,'fingerprint-fields',2,'2024-06-23 12:45:04.517445','2024-06-23 12:45:06.310039',1792,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1394,'classify-fields',2,'2024-06-23 12:45:06.318522','2024-06-23 12:45:06.431994',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1395,'classify-tables',2,'2024-06-23 12:45:06.440017','2024-06-23 12:45:06.455091',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1396,'field values scanning',2,'2024-06-23 13:00:00.058731','2024-06-23 13:00:11.504430',11445,NULL,'success'),(1397,'delete-expired-advanced-field-values',2,'2024-06-23 13:00:00.099890','2024-06-23 13:00:03.173334',3073,'{\"deleted\":0}','success'),(1398,'update-field-values',2,'2024-06-23 13:00:03.181395','2024-06-23 13:00:11.497424',8316,'{\"errors\":0,\"created\":0,\"updated\":31,\"deleted\":0}','success'),(1399,'sync',2,'2024-06-23 13:45:00.113772','2024-06-23 13:45:04.402829',4289,NULL,'success'),(1400,'sync-dbms-version',2,'2024-06-23 13:45:00.122425','2024-06-23 13:45:00.133476',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1401,'sync-timezone',2,'2024-06-23 13:45:00.142850','2024-06-23 13:45:00.153728',10,'{\"timezone-id\":\"+08:00\"}','success'),(1402,'sync-tables',2,'2024-06-23 13:45:00.163573','2024-06-23 13:45:00.193842',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1403,'sync-fields',2,'2024-06-23 13:45:00.203151','2024-06-23 13:45:03.218540',3015,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1404,'sync-fks',2,'2024-06-23 13:45:03.226194','2024-06-23 13:45:03.813345',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1405,'sync-indexes',2,'2024-06-23 13:45:03.821501','2024-06-23 13:45:04.360526',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1406,'sync-metabase-metadata',2,'2024-06-23 13:45:04.368607','2024-06-23 13:45:04.378318',9,'{}','success'),(1407,'sync-table-privileges',2,'2024-06-23 13:45:04.386756','2024-06-23 13:45:04.394790',8,NULL,'success'),(1408,'analyze',2,'2024-06-23 13:45:04.428631','2024-06-23 13:45:06.437497',2008,NULL,'success'),(1409,'fingerprint-fields',2,'2024-06-23 13:45:04.436825','2024-06-23 13:45:06.293434',1856,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1410,'classify-fields',2,'2024-06-23 13:45:06.301950','2024-06-23 13:45:06.407813',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1411,'classify-tables',2,'2024-06-23 13:45:06.415387','2024-06-23 13:45:06.429263',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1412,'sync',2,'2024-06-23 14:45:00.091063','2024-06-23 14:45:04.015067',3924,NULL,'success'),(1413,'sync-dbms-version',2,'2024-06-23 14:45:00.098719','2024-06-23 14:45:00.107510',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1414,'sync-timezone',2,'2024-06-23 14:45:00.115323','2024-06-23 14:45:00.124678',9,'{\"timezone-id\":\"+08:00\"}','success'),(1415,'sync-tables',2,'2024-06-23 14:45:00.132429','2024-06-23 14:45:00.157490',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1416,'sync-fields',2,'2024-06-23 14:45:00.165325','2024-06-23 14:45:02.835467',2670,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1417,'sync-fks',2,'2024-06-23 14:45:02.843198','2024-06-23 14:45:03.463735',620,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1418,'sync-indexes',2,'2024-06-23 14:45:03.472885','2024-06-23 14:45:03.975159',502,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1419,'sync-metabase-metadata',2,'2024-06-23 14:45:03.982778','2024-06-23 14:45:03.990774',7,'{}','success'),(1420,'sync-table-privileges',2,'2024-06-23 14:45:03.999042','2024-06-23 14:45:04.007017',7,NULL,'success'),(1421,'analyze',2,'2024-06-23 14:45:04.050466','2024-06-23 14:45:05.978445',1927,NULL,'success'),(1422,'fingerprint-fields',2,'2024-06-23 14:45:04.060425','2024-06-23 14:45:05.847748',1787,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1423,'classify-fields',2,'2024-06-23 14:45:05.855546','2024-06-23 14:45:05.951416',95,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1424,'classify-tables',2,'2024-06-23 14:45:05.958382','2024-06-23 14:45:05.971006',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1425,'sync',2,'2024-06-23 15:45:00.101131','2024-06-23 15:45:04.318092',4216,NULL,'success'),(1426,'sync-dbms-version',2,'2024-06-23 15:45:00.110199','2024-06-23 15:45:00.119847',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1427,'sync-timezone',2,'2024-06-23 15:45:00.129487','2024-06-23 15:45:00.139970',10,'{\"timezone-id\":\"+08:00\"}','success'),(1428,'sync-tables',2,'2024-06-23 15:45:00.149652','2024-06-23 15:45:00.178910',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1429,'sync-fields',2,'2024-06-23 15:45:00.189481','2024-06-23 15:45:03.148516',2959,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1430,'sync-fks',2,'2024-06-23 15:45:03.157725','2024-06-23 15:45:03.737606',579,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1431,'sync-indexes',2,'2024-06-23 15:45:03.745323','2024-06-23 15:45:04.277291',531,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1432,'sync-metabase-metadata',2,'2024-06-23 15:45:04.285121','2024-06-23 15:45:04.293323',8,'{}','success'),(1433,'sync-table-privileges',2,'2024-06-23 15:45:04.301042','2024-06-23 15:45:04.309769',8,NULL,'success'),(1434,'analyze',2,'2024-06-23 15:45:04.343500','2024-06-23 15:45:06.318471',1974,NULL,'success'),(1435,'fingerprint-fields',2,'2024-06-23 15:45:04.351260','2024-06-23 15:45:06.171651',1820,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1436,'classify-fields',2,'2024-06-23 15:45:06.179750','2024-06-23 15:45:06.288526',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1437,'classify-tables',2,'2024-06-23 15:45:06.295995','2024-06-23 15:45:06.310145',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1438,'task-history-cleanup',NULL,'2024-06-23 16:00:00.035251','2024-06-23 16:00:00.058675',23,NULL,'success'),(1439,'task-history-cleanup',NULL,'2024-06-23 16:00:00.078298','2024-06-23 16:00:00.103368',25,NULL,'success'),(1440,'sync',2,'2024-06-23 16:45:00.111152','2024-06-23 16:45:04.717207',4606,NULL,'success'),(1441,'sync-dbms-version',2,'2024-06-23 16:45:00.120060','2024-06-23 16:45:00.129714',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1442,'sync-timezone',2,'2024-06-23 16:45:00.139059','2024-06-23 16:45:00.149953',10,'{\"timezone-id\":\"+08:00\"}','success'),(1443,'sync-tables',2,'2024-06-23 16:45:00.158231','2024-06-23 16:45:00.188744',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1444,'sync-fields',2,'2024-06-23 16:45:00.197665','2024-06-23 16:45:03.359140',3161,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1445,'sync-fks',2,'2024-06-23 16:45:03.367157','2024-06-23 16:45:04.041002',673,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1446,'sync-indexes',2,'2024-06-23 16:45:04.049794','2024-06-23 16:45:04.671225',621,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1447,'sync-metabase-metadata',2,'2024-06-23 16:45:04.679805','2024-06-23 16:45:04.689798',9,'{}','success'),(1448,'sync-table-privileges',2,'2024-06-23 16:45:04.698773','2024-06-23 16:45:04.708342',9,NULL,'success'),(1449,'analyze',2,'2024-06-23 16:45:04.746508','2024-06-23 16:45:07.050997',2304,NULL,'success'),(1450,'fingerprint-fields',2,'2024-06-23 16:45:04.754710','2024-06-23 16:45:06.897637',2142,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1451,'classify-fields',2,'2024-06-23 16:45:06.906392','2024-06-23 16:45:07.020028',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1452,'classify-tables',2,'2024-06-23 16:45:07.028428','2024-06-23 16:45:07.042502',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1453,'sync',2,'2024-06-23 17:45:00.107323','2024-06-23 17:45:04.605402',4498,NULL,'success'),(1454,'sync-dbms-version',2,'2024-06-23 17:45:00.116165','2024-06-23 17:45:00.126733',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1455,'sync-timezone',2,'2024-06-23 17:45:00.135416','2024-06-23 17:45:00.146001',10,'{\"timezone-id\":\"+08:00\"}','success'),(1456,'sync-tables',2,'2024-06-23 17:45:00.154751','2024-06-23 17:45:00.182460',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1457,'sync-fields',2,'2024-06-23 17:45:00.191469','2024-06-23 17:45:03.413114',3221,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1458,'sync-fks',2,'2024-06-23 17:45:03.420700','2024-06-23 17:45:04.006242',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1459,'sync-indexes',2,'2024-06-23 17:45:04.014774','2024-06-23 17:45:04.559861',545,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1460,'sync-metabase-metadata',2,'2024-06-23 17:45:04.568605','2024-06-23 17:45:04.579158',10,'{}','success'),(1461,'sync-table-privileges',2,'2024-06-23 17:45:04.587897','2024-06-23 17:45:04.596825',8,NULL,'success'),(1462,'analyze',2,'2024-06-23 17:45:04.634621','2024-06-23 17:45:06.739487',2104,NULL,'success'),(1463,'fingerprint-fields',2,'2024-06-23 17:45:04.644136','2024-06-23 17:45:06.587821',1943,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1464,'classify-fields',2,'2024-06-23 17:45:06.596452','2024-06-23 17:45:06.709333',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1465,'classify-tables',2,'2024-06-23 17:45:06.717668','2024-06-23 17:45:06.731515',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1466,'sync',2,'2024-06-23 18:45:00.116301','2024-06-23 18:45:04.914165',4797,NULL,'success'),(1467,'sync-dbms-version',2,'2024-06-23 18:45:00.125881','2024-06-23 18:45:00.136293',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1468,'sync-timezone',2,'2024-06-23 18:45:00.145861','2024-06-23 18:45:00.165792',19,'{\"timezone-id\":\"+08:00\"}','success'),(1469,'sync-tables',2,'2024-06-23 18:45:00.175091','2024-06-23 18:45:00.210439',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1470,'sync-fields',2,'2024-06-23 18:45:00.221123','2024-06-23 18:45:03.557171',3336,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1471,'sync-fks',2,'2024-06-23 18:45:03.565178','2024-06-23 18:45:04.291672',726,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1472,'sync-indexes',2,'2024-06-23 18:45:04.300292','2024-06-23 18:45:04.870157',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1473,'sync-metabase-metadata',2,'2024-06-23 18:45:04.877556','2024-06-23 18:45:04.886020',8,'{}','success'),(1474,'sync-table-privileges',2,'2024-06-23 18:45:04.895565','2024-06-23 18:45:04.904443',8,NULL,'success'),(1475,'analyze',2,'2024-06-23 18:45:04.941674','2024-06-23 18:45:07.194280',2252,NULL,'success'),(1476,'fingerprint-fields',2,'2024-06-23 18:45:04.949998','2024-06-23 18:45:07.009162',2059,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1477,'classify-fields',2,'2024-06-23 18:45:07.019652','2024-06-23 18:45:07.159104',139,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1478,'classify-tables',2,'2024-06-23 18:45:07.168098','2024-06-23 18:45:07.184826',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1479,'sync',2,'2024-06-23 19:45:00.122401','2024-06-23 19:45:04.607246',4484,NULL,'success'),(1480,'sync-dbms-version',2,'2024-06-23 19:45:00.130989','2024-06-23 19:45:00.141053',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1481,'sync-timezone',2,'2024-06-23 19:45:00.150598','2024-06-23 19:45:00.162438',11,'{\"timezone-id\":\"+08:00\"}','success'),(1482,'sync-tables',2,'2024-06-23 19:45:00.171089','2024-06-23 19:45:00.203268',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1483,'sync-fields',2,'2024-06-23 19:45:00.212829','2024-06-23 19:45:03.284545',3071,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1484,'sync-fks',2,'2024-06-23 19:45:03.294237','2024-06-23 19:45:04.002446',708,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1485,'sync-indexes',2,'2024-06-23 19:45:04.012369','2024-06-23 19:45:04.565802',553,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1486,'sync-metabase-metadata',2,'2024-06-23 19:45:04.573470','2024-06-23 19:45:04.581948',8,'{}','success'),(1487,'sync-table-privileges',2,'2024-06-23 19:45:04.590131','2024-06-23 19:45:04.598603',8,NULL,'success'),(1488,'analyze',2,'2024-06-23 19:45:04.635722','2024-06-23 19:45:06.797852',2162,NULL,'success'),(1489,'fingerprint-fields',2,'2024-06-23 19:45:04.644412','2024-06-23 19:45:06.641176',1996,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1490,'classify-fields',2,'2024-06-23 19:45:06.649645','2024-06-23 19:45:06.765919',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1491,'classify-tables',2,'2024-06-23 19:45:06.774136','2024-06-23 19:45:06.789219',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1492,'sync',2,'2024-06-23 20:45:00.109884','2024-06-23 20:45:04.605766',4495,NULL,'success'),(1493,'sync-dbms-version',2,'2024-06-23 20:45:00.121711','2024-06-23 20:45:00.133430',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1494,'sync-timezone',2,'2024-06-23 20:45:00.142158','2024-06-23 20:45:00.154190',12,'{\"timezone-id\":\"+08:00\"}','success'),(1495,'sync-tables',2,'2024-06-23 20:45:00.163218','2024-06-23 20:45:00.190071',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1496,'sync-fields',2,'2024-06-23 20:45:00.198763','2024-06-23 20:45:03.316221',3117,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1497,'sync-fks',2,'2024-06-23 20:45:03.324432','2024-06-23 20:45:03.982319',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1498,'sync-indexes',2,'2024-06-23 20:45:03.990877','2024-06-23 20:45:04.560032',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1499,'sync-metabase-metadata',2,'2024-06-23 20:45:04.568661','2024-06-23 20:45:04.578128',9,'{}','success'),(1500,'sync-table-privileges',2,'2024-06-23 20:45:04.586851','2024-06-23 20:45:04.596656',9,NULL,'success'),(1501,'analyze',2,'2024-06-23 20:45:04.630239','2024-06-23 20:45:06.735848',2105,NULL,'success'),(1502,'fingerprint-fields',2,'2024-06-23 20:45:04.638691','2024-06-23 20:45:06.573866',1935,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1503,'classify-fields',2,'2024-06-23 20:45:06.582714','2024-06-23 20:45:06.703392',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1504,'classify-tables',2,'2024-06-23 20:45:06.711821','2024-06-23 20:45:06.727052',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1505,'sync',2,'2024-06-23 21:45:00.115252','2024-06-23 21:45:04.569258',4454,NULL,'success'),(1506,'sync-dbms-version',2,'2024-06-23 21:45:00.124442','2024-06-23 21:45:00.133862',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1507,'sync-timezone',2,'2024-06-23 21:45:00.143765','2024-06-23 21:45:00.155564',11,'{\"timezone-id\":\"+08:00\"}','success'),(1508,'sync-tables',2,'2024-06-23 21:45:00.164783','2024-06-23 21:45:00.193954',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1509,'sync-fields',2,'2024-06-23 21:45:00.202853','2024-06-23 21:45:03.248164',3045,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1510,'sync-fks',2,'2024-06-23 21:45:03.257120','2024-06-23 21:45:03.919264',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1511,'sync-indexes',2,'2024-06-23 21:45:03.928284','2024-06-23 21:45:04.522298',594,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1512,'sync-metabase-metadata',2,'2024-06-23 21:45:04.530795','2024-06-23 21:45:04.540874',10,'{}','success'),(1513,'sync-table-privileges',2,'2024-06-23 21:45:04.549396','2024-06-23 21:45:04.560140',10,NULL,'success'),(1514,'analyze',2,'2024-06-23 21:45:04.594337','2024-06-23 21:45:06.854827',2260,NULL,'success'),(1515,'fingerprint-fields',2,'2024-06-23 21:45:04.603070','2024-06-23 21:45:06.688287',2085,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1516,'classify-fields',2,'2024-06-23 21:45:06.696919','2024-06-23 21:45:06.819626',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1517,'classify-tables',2,'2024-06-23 21:45:06.827941','2024-06-23 21:45:06.844999',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1518,'sync',2,'2024-06-23 22:45:00.102880','2024-06-23 22:45:04.616677',4513,NULL,'success'),(1519,'sync-dbms-version',2,'2024-06-23 22:45:00.112103','2024-06-23 22:45:00.121664',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1520,'sync-timezone',2,'2024-06-23 22:45:00.130975','2024-06-23 22:45:00.141264',10,'{\"timezone-id\":\"+08:00\"}','success'),(1521,'sync-tables',2,'2024-06-23 22:45:00.150467','2024-06-23 22:45:00.179913',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1522,'sync-fields',2,'2024-06-23 22:45:00.190170','2024-06-23 22:45:03.331025',3140,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1523,'sync-fks',2,'2024-06-23 22:45:03.339236','2024-06-23 22:45:04.014477',675,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1524,'sync-indexes',2,'2024-06-23 22:45:04.023614','2024-06-23 22:45:04.571827',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1525,'sync-metabase-metadata',2,'2024-06-23 22:45:04.579104','2024-06-23 22:45:04.588798',9,'{}','success'),(1526,'sync-table-privileges',2,'2024-06-23 22:45:04.599005','2024-06-23 22:45:04.607316',8,NULL,'success'),(1527,'analyze',2,'2024-06-23 22:45:04.641675','2024-06-23 22:45:06.838628',2196,NULL,'success'),(1528,'fingerprint-fields',2,'2024-06-23 22:45:04.650292','2024-06-23 22:45:06.665839',2015,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1529,'classify-fields',2,'2024-06-23 22:45:06.674638','2024-06-23 22:45:06.807025',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1530,'classify-tables',2,'2024-06-23 22:45:06.814923','2024-06-23 22:45:06.829871',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1531,'sync',2,'2024-06-23 23:45:00.113281','2024-06-23 23:45:04.736041',4622,NULL,'success'),(1532,'sync-dbms-version',2,'2024-06-23 23:45:00.123153','2024-06-23 23:45:00.133695',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1533,'sync-timezone',2,'2024-06-23 23:45:00.142856','2024-06-23 23:45:00.153706',10,'{\"timezone-id\":\"+08:00\"}','success'),(1534,'sync-tables',2,'2024-06-23 23:45:00.163418','2024-06-23 23:45:00.194425',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1535,'sync-fields',2,'2024-06-23 23:45:00.203699','2024-06-23 23:45:03.359544',3155,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1536,'sync-fks',2,'2024-06-23 23:45:03.367553','2024-06-23 23:45:04.064727',697,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1537,'sync-indexes',2,'2024-06-23 23:45:04.072975','2024-06-23 23:45:04.688253',615,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1538,'sync-metabase-metadata',2,'2024-06-23 23:45:04.697319','2024-06-23 23:45:04.707101',9,'{}','success'),(1539,'sync-table-privileges',2,'2024-06-23 23:45:04.715905','2024-06-23 23:45:04.726387',10,NULL,'success'),(1540,'analyze',2,'2024-06-23 23:45:04.769563','2024-06-23 23:45:07.047087',2277,NULL,'success'),(1541,'fingerprint-fields',2,'2024-06-23 23:45:04.780608','2024-06-23 23:45:06.865948',2085,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1542,'classify-fields',2,'2024-06-23 23:45:06.875797','2024-06-23 23:45:07.011907',136,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1543,'classify-tables',2,'2024-06-23 23:45:07.020324','2024-06-23 23:45:07.037919',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1544,'sync',2,'2024-06-24 00:45:00.104359','2024-06-24 00:45:04.546617',4442,NULL,'success'),(1545,'sync-dbms-version',2,'2024-06-24 00:45:00.112285','2024-06-24 00:45:00.122401',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1546,'sync-timezone',2,'2024-06-24 00:45:00.130824','2024-06-24 00:45:00.141471',10,'{\"timezone-id\":\"+08:00\"}','success'),(1547,'sync-tables',2,'2024-06-24 00:45:00.150721','2024-06-24 00:45:00.178195',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1548,'sync-fields',2,'2024-06-24 00:45:00.186576','2024-06-24 00:45:03.290597',3104,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1549,'sync-fks',2,'2024-06-24 00:45:03.298076','2024-06-24 00:45:03.944669',646,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1550,'sync-indexes',2,'2024-06-24 00:45:03.952867','2024-06-24 00:45:04.502627',549,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1551,'sync-metabase-metadata',2,'2024-06-24 00:45:04.510612','2024-06-24 00:45:04.519022',8,'{}','success'),(1552,'sync-table-privileges',2,'2024-06-24 00:45:04.527367','2024-06-24 00:45:04.536127',8,NULL,'success'),(1553,'analyze',2,'2024-06-24 00:45:04.572954','2024-06-24 00:45:06.761516',2188,NULL,'success'),(1554,'fingerprint-fields',2,'2024-06-24 00:45:04.582606','2024-06-24 00:45:06.609231',2026,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1555,'classify-fields',2,'2024-06-24 00:45:06.617614','2024-06-24 00:45:06.731783',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1556,'classify-tables',2,'2024-06-24 00:45:06.739526','2024-06-24 00:45:06.753659',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1557,'sync',2,'2024-06-24 01:45:00.124287','2024-06-24 01:45:04.873609',4749,NULL,'success'),(1558,'sync-dbms-version',2,'2024-06-24 01:45:00.134047','2024-06-24 01:45:00.144564',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1559,'sync-timezone',2,'2024-06-24 01:45:00.154178','2024-06-24 01:45:00.166417',12,'{\"timezone-id\":\"+08:00\"}','success'),(1560,'sync-tables',2,'2024-06-24 01:45:00.175696','2024-06-24 01:45:00.204365',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1561,'sync-fields',2,'2024-06-24 01:45:00.213264','2024-06-24 01:45:03.504641',3291,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1562,'sync-fks',2,'2024-06-24 01:45:03.512840','2024-06-24 01:45:04.207064',694,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1563,'sync-indexes',2,'2024-06-24 01:45:04.216695','2024-06-24 01:45:04.819162',602,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1564,'sync-metabase-metadata',2,'2024-06-24 01:45:04.828276','2024-06-24 01:45:04.841741',13,'{}','success'),(1565,'sync-table-privileges',2,'2024-06-24 01:45:04.853672','2024-06-24 01:45:04.863631',9,NULL,'success'),(1566,'analyze',2,'2024-06-24 01:45:04.900473','2024-06-24 01:45:07.194572',2294,NULL,'success'),(1567,'fingerprint-fields',2,'2024-06-24 01:45:04.911392','2024-06-24 01:45:07.035881',2124,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1568,'classify-fields',2,'2024-06-24 01:45:07.044837','2024-06-24 01:45:07.162315',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1569,'classify-tables',2,'2024-06-24 01:45:07.170369','2024-06-24 01:45:07.185204',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1570,'sync',2,'2024-06-24 02:45:00.104288','2024-06-24 02:45:04.683159',4578,NULL,'success'),(1571,'sync-dbms-version',2,'2024-06-24 02:45:00.115863','2024-06-24 02:45:00.126172',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1572,'sync-timezone',2,'2024-06-24 02:45:00.136187','2024-06-24 02:45:00.146801',10,'{\"timezone-id\":\"+08:00\"}','success'),(1573,'sync-tables',2,'2024-06-24 02:45:00.156267','2024-06-24 02:45:00.187330',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1574,'sync-fields',2,'2024-06-24 02:45:00.196254','2024-06-24 02:45:03.316711',3120,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1575,'sync-fks',2,'2024-06-24 02:45:03.325163','2024-06-24 02:45:04.006031',680,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1576,'sync-indexes',2,'2024-06-24 02:45:04.015378','2024-06-24 02:45:04.634616',619,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1577,'sync-metabase-metadata',2,'2024-06-24 02:45:04.643495','2024-06-24 02:45:04.653571',10,'{}','success'),(1578,'sync-table-privileges',2,'2024-06-24 02:45:04.663030','2024-06-24 02:45:04.674209',11,NULL,'success'),(1579,'analyze',2,'2024-06-24 02:45:04.713465','2024-06-24 02:45:06.891124',2177,NULL,'success'),(1580,'fingerprint-fields',2,'2024-06-24 02:45:04.723887','2024-06-24 02:45:06.729418',2005,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1581,'classify-fields',2,'2024-06-24 02:45:06.739849','2024-06-24 02:45:06.857301',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1582,'classify-tables',2,'2024-06-24 02:45:06.865678','2024-06-24 02:45:06.882271',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1583,'sync',2,'2024-06-24 03:45:00.096116','2024-06-24 03:45:04.535945',4439,NULL,'success'),(1584,'sync-dbms-version',2,'2024-06-24 03:45:00.104739','2024-06-24 03:45:00.113476',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1585,'sync-timezone',2,'2024-06-24 03:45:00.121796','2024-06-24 03:45:00.131547',9,'{\"timezone-id\":\"+08:00\"}','success'),(1586,'sync-tables',2,'2024-06-24 03:45:00.140153','2024-06-24 03:45:00.166569',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1587,'sync-fields',2,'2024-06-24 03:45:00.174413','2024-06-24 03:45:03.332425',3158,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1588,'sync-fks',2,'2024-06-24 03:45:03.339984','2024-06-24 03:45:03.931493',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1589,'sync-indexes',2,'2024-06-24 03:45:03.939702','2024-06-24 03:45:04.494380',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1590,'sync-metabase-metadata',2,'2024-06-24 03:45:04.502381','2024-06-24 03:45:04.510783',8,'{}','success'),(1591,'sync-table-privileges',2,'2024-06-24 03:45:04.519052','2024-06-24 03:45:04.527198',8,NULL,'success'),(1592,'analyze',2,'2024-06-24 03:45:04.561625','2024-06-24 03:45:06.659270',2097,NULL,'success'),(1593,'fingerprint-fields',2,'2024-06-24 03:45:04.570114','2024-06-24 03:45:06.501454',1931,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1594,'classify-fields',2,'2024-06-24 03:45:06.509800','2024-06-24 03:45:06.628528',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1595,'classify-tables',2,'2024-06-24 03:45:06.635992','2024-06-24 03:45:06.650687',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1596,'task-history-cleanup',NULL,'2024-06-24 04:00:00.078174','2024-06-24 04:00:00.104934',26,NULL,'success'),(1597,'sync',2,'2024-06-24 04:45:00.124572','2024-06-24 04:45:04.847781',4723,NULL,'success'),(1598,'sync-dbms-version',2,'2024-06-24 04:45:00.133385','2024-06-24 04:45:00.143390',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1599,'sync-timezone',2,'2024-06-24 04:45:00.152192','2024-06-24 04:45:00.164171',11,'{\"timezone-id\":\"+08:00\"}','success'),(1600,'sync-tables',2,'2024-06-24 04:45:00.173252','2024-06-24 04:45:00.203288',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1601,'sync-fields',2,'2024-06-24 04:45:00.211995','2024-06-24 04:45:03.476962',3264,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1602,'sync-fks',2,'2024-06-24 04:45:03.485725','2024-06-24 04:45:04.196228',710,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1603,'sync-indexes',2,'2024-06-24 04:45:04.205158','2024-06-24 04:45:04.798536',593,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1604,'sync-metabase-metadata',2,'2024-06-24 04:45:04.807034','2024-06-24 04:45:04.816808',9,'{}','success'),(1605,'sync-table-privileges',2,'2024-06-24 04:45:04.827466','2024-06-24 04:45:04.837192',9,NULL,'success'),(1606,'analyze',2,'2024-06-24 04:45:04.878529','2024-06-24 04:45:07.159359',2280,NULL,'success'),(1607,'fingerprint-fields',2,'2024-06-24 04:45:04.887647','2024-06-24 04:45:07.002366',2114,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1608,'classify-fields',2,'2024-06-24 04:45:07.011009','2024-06-24 04:45:07.128003',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1609,'classify-tables',2,'2024-06-24 04:45:07.135822','2024-06-24 04:45:07.150983',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1610,'sync',2,'2024-06-24 05:45:00.106128','2024-06-24 05:45:04.451277',4345,NULL,'success'),(1611,'sync-dbms-version',2,'2024-06-24 05:45:00.114749','2024-06-24 05:45:00.124431',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1612,'sync-timezone',2,'2024-06-24 05:45:00.139162','2024-06-24 05:45:00.150318',11,'{\"timezone-id\":\"+08:00\"}','success'),(1613,'sync-tables',2,'2024-06-24 05:45:00.159693','2024-06-24 05:45:00.191563',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1614,'sync-fields',2,'2024-06-24 05:45:00.200712','2024-06-24 05:45:03.199877',2999,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1615,'sync-fks',2,'2024-06-24 05:45:03.207996','2024-06-24 05:45:03.854110',646,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1616,'sync-indexes',2,'2024-06-24 05:45:03.862468','2024-06-24 05:45:04.408670',546,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1617,'sync-metabase-metadata',2,'2024-06-24 05:45:04.416284','2024-06-24 05:45:04.424459',8,'{}','success'),(1618,'sync-table-privileges',2,'2024-06-24 05:45:04.433414','2024-06-24 05:45:04.442519',9,NULL,'success'),(1619,'analyze',2,'2024-06-24 05:45:04.480448','2024-06-24 05:45:06.574954',2094,NULL,'success'),(1620,'fingerprint-fields',2,'2024-06-24 05:45:04.488828','2024-06-24 05:45:06.426901',1938,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1621,'classify-fields',2,'2024-06-24 05:45:06.435223','2024-06-24 05:45:06.545499',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1622,'classify-tables',2,'2024-06-24 05:45:06.553253','2024-06-24 05:45:06.566810',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1623,'sync',2,'2024-06-24 06:45:00.104841','2024-06-24 06:45:04.310711',4205,NULL,'success'),(1624,'sync-dbms-version',2,'2024-06-24 06:45:00.113285','2024-06-24 06:45:00.123800',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1625,'sync-timezone',2,'2024-06-24 06:45:00.132730','2024-06-24 06:45:00.143831',11,'{\"timezone-id\":\"+08:00\"}','success'),(1626,'sync-tables',2,'2024-06-24 06:45:00.153164','2024-06-24 06:45:00.181469',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1627,'sync-fields',2,'2024-06-24 06:45:00.190291','2024-06-24 06:45:03.163974',2973,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1628,'sync-fks',2,'2024-06-24 06:45:03.172127','2024-06-24 06:45:03.735989',563,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1629,'sync-indexes',2,'2024-06-24 06:45:03.752770','2024-06-24 06:45:04.268700',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1630,'sync-metabase-metadata',2,'2024-06-24 06:45:04.278050','2024-06-24 06:45:04.286790',8,'{}','success'),(1631,'sync-table-privileges',2,'2024-06-24 06:45:04.294356','2024-06-24 06:45:04.302527',8,NULL,'success'),(1632,'analyze',2,'2024-06-24 06:45:04.342014','2024-06-24 06:45:06.271682',1929,NULL,'success'),(1633,'fingerprint-fields',2,'2024-06-24 06:45:04.352742','2024-06-24 06:45:06.121862',1769,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1634,'classify-fields',2,'2024-06-24 06:45:06.130140','2024-06-24 06:45:06.244075',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1635,'classify-tables',2,'2024-06-24 06:45:06.251137','2024-06-24 06:45:06.263854',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1636,'sync',2,'2024-06-24 07:45:00.099325','2024-06-24 07:45:04.494928',4395,NULL,'success'),(1637,'sync-dbms-version',2,'2024-06-24 07:45:00.109893','2024-06-24 07:45:00.120252',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1638,'sync-timezone',2,'2024-06-24 07:45:00.128962','2024-06-24 07:45:00.139613',10,'{\"timezone-id\":\"+08:00\"}','success'),(1639,'sync-tables',2,'2024-06-24 07:45:00.147736','2024-06-24 07:45:00.181560',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1640,'sync-fields',2,'2024-06-24 07:45:00.191783','2024-06-24 07:45:03.205468',3013,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1641,'sync-fks',2,'2024-06-24 07:45:03.213291','2024-06-24 07:45:03.859096',645,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1642,'sync-indexes',2,'2024-06-24 07:45:03.868958','2024-06-24 07:45:04.454149',585,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1643,'sync-metabase-metadata',2,'2024-06-24 07:45:04.461454','2024-06-24 07:45:04.469329',7,'{}','success'),(1644,'sync-table-privileges',2,'2024-06-24 07:45:04.477271','2024-06-24 07:45:04.486057',8,NULL,'success'),(1645,'analyze',2,'2024-06-24 07:45:04.521146','2024-06-24 07:45:06.710868',2189,NULL,'success'),(1646,'fingerprint-fields',2,'2024-06-24 07:45:04.529089','2024-06-24 07:45:06.553496',2024,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1647,'classify-fields',2,'2024-06-24 07:45:06.561875','2024-06-24 07:45:06.680105',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1648,'classify-tables',2,'2024-06-24 07:45:06.687723','2024-06-24 07:45:06.701824',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1649,'sync',2,'2024-06-24 08:45:00.112843','2024-06-24 08:45:04.703875',4591,NULL,'success'),(1650,'sync-dbms-version',2,'2024-06-24 08:45:00.122501','2024-06-24 08:45:00.132670',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1651,'sync-timezone',2,'2024-06-24 08:45:00.141186','2024-06-24 08:45:00.151304',10,'{\"timezone-id\":\"+08:00\"}','success'),(1652,'sync-tables',2,'2024-06-24 08:45:00.161270','2024-06-24 08:45:00.191334',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1653,'sync-fields',2,'2024-06-24 08:45:00.200539','2024-06-24 08:45:03.303880',3103,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1654,'sync-fks',2,'2024-06-24 08:45:03.312925','2024-06-24 08:45:03.972837',659,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1655,'sync-indexes',2,'2024-06-24 08:45:03.982509','2024-06-24 08:45:04.658754',676,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1656,'sync-metabase-metadata',2,'2024-06-24 08:45:04.666850','2024-06-24 08:45:04.676322',9,'{}','success'),(1657,'sync-table-privileges',2,'2024-06-24 08:45:04.684798','2024-06-24 08:45:04.694134',9,NULL,'success'),(1658,'analyze',2,'2024-06-24 08:45:04.735572','2024-06-24 08:45:06.874303',2138,NULL,'success'),(1659,'fingerprint-fields',2,'2024-06-24 08:45:04.744725','2024-06-24 08:45:06.710284',1965,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1660,'classify-fields',2,'2024-06-24 08:45:06.718831','2024-06-24 08:45:06.841192',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1661,'classify-tables',2,'2024-06-24 08:45:06.849106','2024-06-24 08:45:06.865492',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1662,'sync',2,'2024-06-24 09:45:00.105683','2024-06-24 09:45:04.765774',4660,NULL,'success'),(1663,'sync-dbms-version',2,'2024-06-24 09:45:00.114001','2024-06-24 09:45:00.124344',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1664,'sync-timezone',2,'2024-06-24 09:45:00.133263','2024-06-24 09:45:00.144203',10,'{\"timezone-id\":\"+08:00\"}','success'),(1665,'sync-tables',2,'2024-06-24 09:45:00.153062','2024-06-24 09:45:00.179718',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1666,'sync-fields',2,'2024-06-24 09:45:00.188269','2024-06-24 09:45:03.254557',3066,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1667,'sync-fks',2,'2024-06-24 09:45:03.263015','2024-06-24 09:45:03.951337',688,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1668,'sync-indexes',2,'2024-06-24 09:45:03.959727','2024-06-24 09:45:04.724268',764,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1669,'sync-metabase-metadata',2,'2024-06-24 09:45:04.732126','2024-06-24 09:45:04.740098',7,'{}','success'),(1670,'sync-table-privileges',2,'2024-06-24 09:45:04.748501','2024-06-24 09:45:04.757013',8,NULL,'success'),(1671,'analyze',2,'2024-06-24 09:45:04.790251','2024-06-24 09:45:06.810302',2020,NULL,'success'),(1672,'fingerprint-fields',2,'2024-06-24 09:45:04.798281','2024-06-24 09:45:06.656268',1857,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1673,'classify-fields',2,'2024-06-24 09:45:06.664195','2024-06-24 09:45:06.779560',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1674,'classify-tables',2,'2024-06-24 09:45:06.788283','2024-06-24 09:45:06.801740',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1675,'sync',2,'2024-06-24 10:45:00.099805','2024-06-24 10:45:04.828785',4728,NULL,'success'),(1676,'sync-dbms-version',2,'2024-06-24 10:45:00.107726','2024-06-24 10:45:00.116399',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1677,'sync-timezone',2,'2024-06-24 10:45:00.124875','2024-06-24 10:45:00.134818',9,'{\"timezone-id\":\"+08:00\"}','success'),(1678,'sync-tables',2,'2024-06-24 10:45:00.143114','2024-06-24 10:45:00.169409',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1679,'sync-fields',2,'2024-06-24 10:45:00.177777','2024-06-24 10:45:03.003565',2825,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1680,'sync-fks',2,'2024-06-24 10:45:03.011486','2024-06-24 10:45:03.621535',610,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1681,'sync-indexes',2,'2024-06-24 10:45:03.629602','2024-06-24 10:45:04.784211',1154,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1682,'sync-metabase-metadata',2,'2024-06-24 10:45:04.792118','2024-06-24 10:45:04.800512',8,'{}','success'),(1683,'sync-table-privileges',2,'2024-06-24 10:45:04.810023','2024-06-24 10:45:04.820299',10,NULL,'success'),(1684,'analyze',2,'2024-06-24 10:45:04.853566','2024-06-24 10:45:06.858005',2004,NULL,'success'),(1685,'fingerprint-fields',2,'2024-06-24 10:45:04.861205','2024-06-24 10:45:06.718262',1857,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1686,'classify-fields',2,'2024-06-24 10:45:06.726435','2024-06-24 10:45:06.830210',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1687,'classify-tables',2,'2024-06-24 10:45:06.837211','2024-06-24 10:45:06.850536',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1688,'sync',2,'2024-06-24 11:45:00.104355','2024-06-24 11:45:04.293716',4189,NULL,'success'),(1689,'sync-dbms-version',2,'2024-06-24 11:45:00.111834','2024-06-24 11:45:00.120898',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1690,'sync-timezone',2,'2024-06-24 11:45:00.128733','2024-06-24 11:45:00.139164',10,'{\"timezone-id\":\"+08:00\"}','success'),(1691,'sync-tables',2,'2024-06-24 11:45:00.149164','2024-06-24 11:45:00.177731',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1692,'sync-fields',2,'2024-06-24 11:45:00.186616','2024-06-24 11:45:03.091552',2904,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1693,'sync-fks',2,'2024-06-24 11:45:03.100410','2024-06-24 11:45:03.724054',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1694,'sync-indexes',2,'2024-06-24 11:45:03.733067','2024-06-24 11:45:04.254074',521,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1695,'sync-metabase-metadata',2,'2024-06-24 11:45:04.261927','2024-06-24 11:45:04.270088',8,'{}','success'),(1696,'sync-table-privileges',2,'2024-06-24 11:45:04.278440','2024-06-24 11:45:04.286397',7,NULL,'success'),(1697,'analyze',2,'2024-06-24 11:45:04.320369','2024-06-24 11:45:06.332219',2011,NULL,'success'),(1698,'fingerprint-fields',2,'2024-06-24 11:45:04.328107','2024-06-24 11:45:06.183119',1855,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1699,'classify-fields',2,'2024-06-24 11:45:06.193615','2024-06-24 11:45:06.305906',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1700,'classify-tables',2,'2024-06-24 11:45:06.313188','2024-06-24 11:45:06.324969',11,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1701,'sync',2,'2024-06-24 12:45:00.102917','2024-06-24 12:45:04.263733',4160,NULL,'success'),(1702,'sync-dbms-version',2,'2024-06-24 12:45:00.111641','2024-06-24 12:45:00.120791',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1703,'sync-timezone',2,'2024-06-24 12:45:00.128945','2024-06-24 12:45:00.139001',10,'{\"timezone-id\":\"+08:00\"}','success'),(1704,'sync-tables',2,'2024-06-24 12:45:00.148024','2024-06-24 12:45:00.176214',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1705,'sync-fields',2,'2024-06-24 12:45:00.185077','2024-06-24 12:45:03.150250',2965,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1706,'sync-fks',2,'2024-06-24 12:45:03.158470','2024-06-24 12:45:03.766172',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1707,'sync-indexes',2,'2024-06-24 12:45:03.774786','2024-06-24 12:45:04.226097',451,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1708,'sync-metabase-metadata',2,'2024-06-24 12:45:04.232920','2024-06-24 12:45:04.240487',7,'{}','success'),(1709,'sync-table-privileges',2,'2024-06-24 12:45:04.247860','2024-06-24 12:45:04.256227',8,NULL,'success'),(1710,'analyze',2,'2024-06-24 12:45:04.286457','2024-06-24 12:45:06.237763',1951,NULL,'success'),(1711,'fingerprint-fields',2,'2024-06-24 12:45:04.293979','2024-06-24 12:45:06.078095',1784,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1712,'classify-fields',2,'2024-06-24 12:45:06.086701','2024-06-24 12:45:06.203715',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1713,'classify-tables',2,'2024-06-24 12:45:06.212081','2024-06-24 12:45:06.228713',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1714,'field values scanning',2,'2024-06-24 13:00:00.062632','2024-06-24 13:00:11.578890',11516,NULL,'success'),(1715,'delete-expired-advanced-field-values',2,'2024-06-24 13:00:00.072378','2024-06-24 13:00:03.167741',3095,'{\"deleted\":0}','success'),(1716,'update-field-values',2,'2024-06-24 13:00:03.175390','2024-06-24 13:00:11.568596',8393,'{\"errors\":0,\"created\":0,\"updated\":33,\"deleted\":0}','success'),(1717,'sync',2,'2024-06-24 13:45:00.092889','2024-06-24 13:45:04.250938',4158,NULL,'success'),(1718,'sync-dbms-version',2,'2024-06-24 13:45:00.101116','2024-06-24 13:45:00.109695',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1719,'sync-timezone',2,'2024-06-24 13:45:00.117962','2024-06-24 13:45:00.127732',9,'{\"timezone-id\":\"+08:00\"}','success'),(1720,'sync-tables',2,'2024-06-24 13:45:00.135952','2024-06-24 13:45:00.160681',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1721,'sync-fields',2,'2024-06-24 13:45:00.168768','2024-06-24 13:45:03.028772',2860,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1722,'sync-fks',2,'2024-06-24 13:45:03.037256','2024-06-24 13:45:03.661115',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1723,'sync-indexes',2,'2024-06-24 13:45:03.668843','2024-06-24 13:45:04.210760',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1724,'sync-metabase-metadata',2,'2024-06-24 13:45:04.218856','2024-06-24 13:45:04.227257',8,'{}','success'),(1725,'sync-table-privileges',2,'2024-06-24 13:45:04.235395','2024-06-24 13:45:04.243151',7,NULL,'success'),(1726,'analyze',2,'2024-06-24 13:45:04.275159','2024-06-24 13:45:06.203238',1928,NULL,'success'),(1727,'fingerprint-fields',2,'2024-06-24 13:45:04.282970','2024-06-24 13:45:06.063659',1780,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1728,'classify-fields',2,'2024-06-24 13:45:06.071189','2024-06-24 13:45:06.174763',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1729,'classify-tables',2,'2024-06-24 13:45:06.182141','2024-06-24 13:45:06.195255',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1730,'sync',2,'2024-06-24 14:45:00.110643','2024-06-24 14:45:04.337189',4226,NULL,'success'),(1731,'sync-dbms-version',2,'2024-06-24 14:45:00.120408','2024-06-24 14:45:00.130245',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1732,'sync-timezone',2,'2024-06-24 14:45:00.138817','2024-06-24 14:45:00.148778',9,'{\"timezone-id\":\"+08:00\"}','success'),(1733,'sync-tables',2,'2024-06-24 14:45:00.157278','2024-06-24 14:45:00.184364',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1734,'sync-fields',2,'2024-06-24 14:45:00.191994','2024-06-24 14:45:03.196656',3004,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1735,'sync-fks',2,'2024-06-24 14:45:03.205038','2024-06-24 14:45:03.786243',581,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1736,'sync-indexes',2,'2024-06-24 14:45:03.794027','2024-06-24 14:45:04.298121',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1737,'sync-metabase-metadata',2,'2024-06-24 14:45:04.305120','2024-06-24 14:45:04.313225',8,'{}','success'),(1738,'sync-table-privileges',2,'2024-06-24 14:45:04.321278','2024-06-24 14:45:04.329617',8,NULL,'success'),(1739,'analyze',2,'2024-06-24 14:45:04.361361','2024-06-24 14:45:06.349612',1988,NULL,'success'),(1740,'fingerprint-fields',2,'2024-06-24 14:45:04.369214','2024-06-24 14:45:06.210498',1841,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1741,'classify-fields',2,'2024-06-24 14:45:06.217934','2024-06-24 14:45:06.320610',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1742,'classify-tables',2,'2024-06-24 14:45:06.327679','2024-06-24 14:45:06.341984',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1743,'sync',2,'2024-06-24 15:45:00.100240','2024-06-24 15:45:04.261614',4161,NULL,'success'),(1744,'sync-dbms-version',2,'2024-06-24 15:45:00.108713','2024-06-24 15:45:00.118440',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1745,'sync-timezone',2,'2024-06-24 15:45:00.127130','2024-06-24 15:45:00.138405',11,'{\"timezone-id\":\"+08:00\"}','success'),(1746,'sync-tables',2,'2024-06-24 15:45:00.146922','2024-06-24 15:45:00.174374',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1747,'sync-fields',2,'2024-06-24 15:45:00.182756','2024-06-24 15:45:03.051475',2868,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1748,'sync-fks',2,'2024-06-24 15:45:03.059078','2024-06-24 15:45:03.671495',612,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1749,'sync-indexes',2,'2024-06-24 15:45:03.680275','2024-06-24 15:45:04.221645',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1750,'sync-metabase-metadata',2,'2024-06-24 15:45:04.229099','2024-06-24 15:45:04.236980',7,'{}','success'),(1751,'sync-table-privileges',2,'2024-06-24 15:45:04.244404','2024-06-24 15:45:04.252512',8,NULL,'success'),(1752,'analyze',2,'2024-06-24 15:45:04.289126','2024-06-24 15:45:06.277030',1987,NULL,'success'),(1753,'fingerprint-fields',2,'2024-06-24 15:45:04.298095','2024-06-24 15:45:06.118036',1819,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1754,'classify-fields',2,'2024-06-24 15:45:06.126519','2024-06-24 15:45:06.246566',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1755,'classify-tables',2,'2024-06-24 15:45:06.255557','2024-06-24 15:45:06.269037',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1756,'task-history-cleanup',NULL,'2024-06-24 16:00:00.018167','2024-06-24 16:00:00.052686',34,NULL,'success'),(1757,'task-history-cleanup',NULL,'2024-06-24 16:00:00.080790','2024-06-24 16:00:00.098353',17,NULL,'success'),(1758,'sync',2,'2024-06-24 16:45:00.100156','2024-06-24 16:45:04.603292',4503,NULL,'success'),(1759,'sync-dbms-version',2,'2024-06-24 16:45:00.110212','2024-06-24 16:45:00.121117',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1760,'sync-timezone',2,'2024-06-24 16:45:00.130939','2024-06-24 16:45:00.141975',11,'{\"timezone-id\":\"+08:00\"}','success'),(1761,'sync-tables',2,'2024-06-24 16:45:00.150664','2024-06-24 16:45:00.181022',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1762,'sync-fields',2,'2024-06-24 16:45:00.191232','2024-06-24 16:45:03.318913',3127,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1763,'sync-fks',2,'2024-06-24 16:45:03.327510','2024-06-24 16:45:03.993614',666,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1764,'sync-indexes',2,'2024-06-24 16:45:04.005058','2024-06-24 16:45:04.558672',553,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1765,'sync-metabase-metadata',2,'2024-06-24 16:45:04.566278','2024-06-24 16:45:04.574958',8,'{}','success'),(1766,'sync-table-privileges',2,'2024-06-24 16:45:04.585948','2024-06-24 16:45:04.594940',8,NULL,'success'),(1767,'analyze',2,'2024-06-24 16:45:04.632822','2024-06-24 16:45:06.758309',2125,NULL,'success'),(1768,'fingerprint-fields',2,'2024-06-24 16:45:04.642576','2024-06-24 16:45:06.597861',1955,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1769,'classify-fields',2,'2024-06-24 16:45:06.605967','2024-06-24 16:45:06.723692',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1770,'classify-tables',2,'2024-06-24 16:45:06.732279','2024-06-24 16:45:06.747068',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1771,'sync',2,'2024-06-24 17:45:00.106652','2024-06-24 17:45:04.519920',4413,NULL,'success'),(1772,'sync-dbms-version',2,'2024-06-24 17:45:00.114854','2024-06-24 17:45:00.124612',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1773,'sync-timezone',2,'2024-06-24 17:45:00.133688','2024-06-24 17:45:00.144464',10,'{\"timezone-id\":\"+08:00\"}','success'),(1774,'sync-tables',2,'2024-06-24 17:45:00.153105','2024-06-24 17:45:00.184050',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1775,'sync-fields',2,'2024-06-24 17:45:00.193036','2024-06-24 17:45:03.318847',3125,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1776,'sync-fks',2,'2024-06-24 17:45:03.327212','2024-06-24 17:45:03.985969',658,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1777,'sync-indexes',2,'2024-06-24 17:45:03.994281','2024-06-24 17:45:04.481296',487,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1778,'sync-metabase-metadata',2,'2024-06-24 17:45:04.488420','2024-06-24 17:45:04.496039',7,'{}','success'),(1779,'sync-table-privileges',2,'2024-06-24 17:45:04.503809','2024-06-24 17:45:04.511866',8,NULL,'success'),(1780,'analyze',2,'2024-06-24 17:45:04.543385','2024-06-24 17:45:06.644866',2101,NULL,'success'),(1781,'fingerprint-fields',2,'2024-06-24 17:45:04.552453','2024-06-24 17:45:06.487105',1934,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1782,'classify-fields',2,'2024-06-24 17:45:06.495513','2024-06-24 17:45:06.612723',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1783,'classify-tables',2,'2024-06-24 17:45:06.620833','2024-06-24 17:45:06.636134',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1784,'sync',2,'2024-06-24 18:45:00.109255','2024-06-24 18:45:04.466169',4356,NULL,'success'),(1785,'sync-dbms-version',2,'2024-06-24 18:45:00.118774','2024-06-24 18:45:00.127253',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1786,'sync-timezone',2,'2024-06-24 18:45:00.135786','2024-06-24 18:45:00.147145',11,'{\"timezone-id\":\"+08:00\"}','success'),(1787,'sync-tables',2,'2024-06-24 18:45:00.155384','2024-06-24 18:45:00.181693',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1788,'sync-fields',2,'2024-06-24 18:45:00.189724','2024-06-24 18:45:03.178298',2988,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1789,'sync-fks',2,'2024-06-24 18:45:03.185839','2024-06-24 18:45:03.859834',673,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1790,'sync-indexes',2,'2024-06-24 18:45:03.868970','2024-06-24 18:45:04.424701',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1791,'sync-metabase-metadata',2,'2024-06-24 18:45:04.432362','2024-06-24 18:45:04.440705',8,'{}','success'),(1792,'sync-table-privileges',2,'2024-06-24 18:45:04.448877','2024-06-24 18:45:04.457328',8,NULL,'success'),(1793,'analyze',2,'2024-06-24 18:45:04.492746','2024-06-24 18:45:06.585614',2092,NULL,'success'),(1794,'fingerprint-fields',2,'2024-06-24 18:45:04.501331','2024-06-24 18:45:06.426521',1925,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1795,'classify-fields',2,'2024-06-24 18:45:06.435055','2024-06-24 18:45:06.556307',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1796,'classify-tables',2,'2024-06-24 18:45:06.563872','2024-06-24 18:45:06.577739',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1797,'sync',2,'2024-06-24 19:45:00.100055','2024-06-24 19:45:04.460481',4360,NULL,'success'),(1798,'sync-dbms-version',2,'2024-06-24 19:45:00.109018','2024-06-24 19:45:00.120274',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1799,'sync-timezone',2,'2024-06-24 19:45:00.131183','2024-06-24 19:45:00.141384',10,'{\"timezone-id\":\"+08:00\"}','success'),(1800,'sync-tables',2,'2024-06-24 19:45:00.150647','2024-06-24 19:45:00.181576',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1801,'sync-fields',2,'2024-06-24 19:45:00.191064','2024-06-24 19:45:03.244674',3053,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1802,'sync-fks',2,'2024-06-24 19:45:03.253459','2024-06-24 19:45:03.873112',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1803,'sync-indexes',2,'2024-06-24 19:45:03.882742','2024-06-24 19:45:04.412939',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1804,'sync-metabase-metadata',2,'2024-06-24 19:45:04.421365','2024-06-24 19:45:04.430624',9,'{}','success'),(1805,'sync-table-privileges',2,'2024-06-24 19:45:04.441358','2024-06-24 19:45:04.451229',9,NULL,'success'),(1806,'analyze',2,'2024-06-24 19:45:04.489390','2024-06-24 19:45:06.538331',2048,NULL,'success'),(1807,'fingerprint-fields',2,'2024-06-24 19:45:04.497648','2024-06-24 19:45:06.386444',1888,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1808,'classify-fields',2,'2024-06-24 19:45:06.395606','2024-06-24 19:45:06.505358',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1809,'classify-tables',2,'2024-06-24 19:45:06.516561','2024-06-24 19:45:06.530439',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1810,'sync',2,'2024-06-24 20:45:00.099520','2024-06-24 20:45:04.505149',4405,NULL,'success'),(1811,'sync-dbms-version',2,'2024-06-24 20:45:00.107703','2024-06-24 20:45:00.117565',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1812,'sync-timezone',2,'2024-06-24 20:45:00.125815','2024-06-24 20:45:00.137481',11,'{\"timezone-id\":\"+08:00\"}','success'),(1813,'sync-tables',2,'2024-06-24 20:45:00.145618','2024-06-24 20:45:00.175123',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1814,'sync-fields',2,'2024-06-24 20:45:00.183101','2024-06-24 20:45:03.235655',3052,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1815,'sync-fks',2,'2024-06-24 20:45:03.243748','2024-06-24 20:45:03.908886',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1816,'sync-indexes',2,'2024-06-24 20:45:03.917400','2024-06-24 20:45:04.457663',540,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1817,'sync-metabase-metadata',2,'2024-06-24 20:45:04.465842','2024-06-24 20:45:04.475546',9,'{}','success'),(1818,'sync-table-privileges',2,'2024-06-24 20:45:04.486457','2024-06-24 20:45:04.495848',9,NULL,'success'),(1819,'analyze',2,'2024-06-24 20:45:04.534771','2024-06-24 20:45:06.724368',2189,NULL,'success'),(1820,'fingerprint-fields',2,'2024-06-24 20:45:04.544373','2024-06-24 20:45:06.565957',2021,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1821,'classify-fields',2,'2024-06-24 20:45:06.574488','2024-06-24 20:45:06.692718',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1822,'classify-tables',2,'2024-06-24 20:45:06.700030','2024-06-24 20:45:06.713837',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1823,'sync',2,'2024-06-24 21:45:00.091377','2024-06-24 21:45:04.602185',4510,NULL,'success'),(1824,'sync-dbms-version',2,'2024-06-24 21:45:00.099406','2024-06-24 21:45:00.109340',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1825,'sync-timezone',2,'2024-06-24 21:45:00.120721','2024-06-24 21:45:00.130551',9,'{\"timezone-id\":\"+08:00\"}','success'),(1826,'sync-tables',2,'2024-06-24 21:45:00.139147','2024-06-24 21:45:00.168013',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1827,'sync-fields',2,'2024-06-24 21:45:00.177052','2024-06-24 21:45:03.387304',3210,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1828,'sync-fks',2,'2024-06-24 21:45:03.396051','2024-06-24 21:45:04.055638',659,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1829,'sync-indexes',2,'2024-06-24 21:45:04.064994','2024-06-24 21:45:04.564036',499,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1830,'sync-metabase-metadata',2,'2024-06-24 21:45:04.571035','2024-06-24 21:45:04.578991',7,'{}','success'),(1831,'sync-table-privileges',2,'2024-06-24 21:45:04.586760','2024-06-24 21:45:04.594746',7,NULL,'success'),(1832,'analyze',2,'2024-06-24 21:45:04.625790','2024-06-24 21:45:06.816446',2190,NULL,'success'),(1833,'fingerprint-fields',2,'2024-06-24 21:45:04.633435','2024-06-24 21:45:06.644279',2010,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1834,'classify-fields',2,'2024-06-24 21:45:06.652760','2024-06-24 21:45:06.785552',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1835,'classify-tables',2,'2024-06-24 21:45:06.793669','2024-06-24 21:45:06.807889',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1836,'sync',2,'2024-06-24 22:45:00.109456','2024-06-24 22:45:04.600927',4491,NULL,'success'),(1837,'sync-dbms-version',2,'2024-06-24 22:45:00.118205','2024-06-24 22:45:00.129194',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1838,'sync-timezone',2,'2024-06-24 22:45:00.138162','2024-06-24 22:45:00.147685',9,'{\"timezone-id\":\"+08:00\"}','success'),(1839,'sync-tables',2,'2024-06-24 22:45:00.157838','2024-06-24 22:45:00.189045',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1840,'sync-fields',2,'2024-06-24 22:45:00.200175','2024-06-24 22:45:03.348553',3148,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1841,'sync-fks',2,'2024-06-24 22:45:03.356601','2024-06-24 22:45:03.990133',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1842,'sync-indexes',2,'2024-06-24 22:45:03.999465','2024-06-24 22:45:04.558878',559,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1843,'sync-metabase-metadata',2,'2024-06-24 22:45:04.566457','2024-06-24 22:45:04.574642',8,'{}','success'),(1844,'sync-table-privileges',2,'2024-06-24 22:45:04.582949','2024-06-24 22:45:04.592542',9,NULL,'success'),(1845,'analyze',2,'2024-06-24 22:45:04.628199','2024-06-24 22:45:06.729441',2101,NULL,'success'),(1846,'fingerprint-fields',2,'2024-06-24 22:45:04.637310','2024-06-24 22:45:06.561516',1924,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1847,'classify-fields',2,'2024-06-24 22:45:06.570053','2024-06-24 22:45:06.696825',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1848,'classify-tables',2,'2024-06-24 22:45:06.706020','2024-06-24 22:45:06.720835',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1849,'sync',2,'2024-06-24 23:45:00.096974','2024-06-24 23:45:04.310148',4213,NULL,'success'),(1850,'sync-dbms-version',2,'2024-06-24 23:45:00.104808','2024-06-24 23:45:00.113521',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1851,'sync-timezone',2,'2024-06-24 23:45:00.121064','2024-06-24 23:45:00.130902',9,'{\"timezone-id\":\"+08:00\"}','success'),(1852,'sync-tables',2,'2024-06-24 23:45:00.139458','2024-06-24 23:45:00.166758',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1853,'sync-fields',2,'2024-06-24 23:45:00.175232','2024-06-24 23:45:03.107895',2932,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1854,'sync-fks',2,'2024-06-24 23:45:03.116647','2024-06-24 23:45:03.737924',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1855,'sync-indexes',2,'2024-06-24 23:45:03.746928','2024-06-24 23:45:04.269290',522,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1856,'sync-metabase-metadata',2,'2024-06-24 23:45:04.276882','2024-06-24 23:45:04.285093',8,'{}','success'),(1857,'sync-table-privileges',2,'2024-06-24 23:45:04.293110','2024-06-24 23:45:04.301317',8,NULL,'success'),(1858,'analyze',2,'2024-06-24 23:45:04.334679','2024-06-24 23:45:06.412414',2077,NULL,'success'),(1859,'fingerprint-fields',2,'2024-06-24 23:45:04.342548','2024-06-24 23:45:06.262601',1920,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1860,'classify-fields',2,'2024-06-24 23:45:06.271053','2024-06-24 23:45:06.381937',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1861,'classify-tables',2,'2024-06-24 23:45:06.389557','2024-06-24 23:45:06.404236',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1862,'sync',2,'2024-06-25 00:45:00.113636','2024-06-25 00:45:04.695322',4581,NULL,'success'),(1863,'sync-dbms-version',2,'2024-06-25 00:45:00.123050','2024-06-25 00:45:00.133069',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1864,'sync-timezone',2,'2024-06-25 00:45:00.142172','2024-06-25 00:45:00.153336',11,'{\"timezone-id\":\"+08:00\"}','success'),(1865,'sync-tables',2,'2024-06-25 00:45:00.163704','2024-06-25 00:45:00.198372',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1866,'sync-fields',2,'2024-06-25 00:45:00.208458','2024-06-25 00:45:03.354818',3146,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1867,'sync-fks',2,'2024-06-25 00:45:03.362754','2024-06-25 00:45:04.034503',671,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1868,'sync-indexes',2,'2024-06-25 00:45:04.043836','2024-06-25 00:45:04.647957',604,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1869,'sync-metabase-metadata',2,'2024-06-25 00:45:04.656305','2024-06-25 00:45:04.665988',9,'{}','success'),(1870,'sync-table-privileges',2,'2024-06-25 00:45:04.675765','2024-06-25 00:45:04.685938',10,NULL,'success'),(1871,'analyze',2,'2024-06-25 00:45:04.724630','2024-06-25 00:45:06.950499',2225,NULL,'success'),(1872,'fingerprint-fields',2,'2024-06-25 00:45:04.735284','2024-06-25 00:45:06.794144',2058,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1873,'classify-fields',2,'2024-06-25 00:45:06.803112','2024-06-25 00:45:06.917603',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1874,'classify-tables',2,'2024-06-25 00:45:06.925789','2024-06-25 00:45:06.940167',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1875,'sync',2,'2024-06-25 01:45:00.100313','2024-06-25 01:45:04.652134',4551,NULL,'success'),(1876,'sync-dbms-version',2,'2024-06-25 01:45:00.108712','2024-06-25 01:45:00.118336',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1877,'sync-timezone',2,'2024-06-25 01:45:00.130181','2024-06-25 01:45:00.142404',12,'{\"timezone-id\":\"+08:00\"}','success'),(1878,'sync-tables',2,'2024-06-25 01:45:00.151924','2024-06-25 01:45:00.187825',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1879,'sync-fields',2,'2024-06-25 01:45:00.197464','2024-06-25 01:45:03.446066',3248,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1880,'sync-fks',2,'2024-06-25 01:45:03.453594','2024-06-25 01:45:04.090954',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1881,'sync-indexes',2,'2024-06-25 01:45:04.100074','2024-06-25 01:45:04.612001',511,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1882,'sync-metabase-metadata',2,'2024-06-25 01:45:04.619529','2024-06-25 01:45:04.627569',8,'{}','success'),(1883,'sync-table-privileges',2,'2024-06-25 01:45:04.635644','2024-06-25 01:45:04.644184',8,NULL,'success'),(1884,'analyze',2,'2024-06-25 01:45:04.678456','2024-06-25 01:45:06.701360',2022,NULL,'success'),(1885,'fingerprint-fields',2,'2024-06-25 01:45:04.692516','2024-06-25 01:45:06.554053',1861,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1886,'classify-fields',2,'2024-06-25 01:45:06.562320','2024-06-25 01:45:06.671487',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1887,'classify-tables',2,'2024-06-25 01:45:06.678882','2024-06-25 01:45:06.692736',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1888,'sync',2,'2024-06-25 02:45:00.092331','2024-06-25 02:45:04.536453',4444,NULL,'success'),(1889,'sync-dbms-version',2,'2024-06-25 02:45:00.101451','2024-06-25 02:45:00.112175',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1890,'sync-timezone',2,'2024-06-25 02:45:00.121189','2024-06-25 02:45:00.131470',10,'{\"timezone-id\":\"+08:00\"}','success'),(1891,'sync-tables',2,'2024-06-25 02:45:00.139819','2024-06-25 02:45:00.165774',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1892,'sync-fields',2,'2024-06-25 02:45:00.174220','2024-06-25 02:45:03.275611',3101,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1893,'sync-fks',2,'2024-06-25 02:45:03.284436','2024-06-25 02:45:03.925554',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1894,'sync-indexes',2,'2024-06-25 02:45:03.934084','2024-06-25 02:45:04.488046',553,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1895,'sync-metabase-metadata',2,'2024-06-25 02:45:04.497809','2024-06-25 02:45:04.507562',9,'{}','success'),(1896,'sync-table-privileges',2,'2024-06-25 02:45:04.517325','2024-06-25 02:45:04.527427',10,NULL,'success'),(1897,'analyze',2,'2024-06-25 02:45:04.562473','2024-06-25 02:45:06.590732',2028,NULL,'success'),(1898,'fingerprint-fields',2,'2024-06-25 02:45:04.571943','2024-06-25 02:45:06.437347',1865,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1899,'classify-fields',2,'2024-06-25 02:45:06.445983','2024-06-25 02:45:06.561729',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1900,'classify-tables',2,'2024-06-25 02:45:06.569273','2024-06-25 02:45:06.582468',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1901,'sync',2,'2024-06-25 03:45:00.098054','2024-06-25 03:45:04.454461',4356,NULL,'success'),(1902,'sync-dbms-version',2,'2024-06-25 03:45:00.106205','2024-06-25 03:45:00.116794',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1903,'sync-timezone',2,'2024-06-25 03:45:00.126697','2024-06-25 03:45:00.137849',11,'{\"timezone-id\":\"+08:00\"}','success'),(1904,'sync-tables',2,'2024-06-25 03:45:00.146742','2024-06-25 03:45:00.173642',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1905,'sync-fields',2,'2024-06-25 03:45:00.183145','2024-06-25 03:45:03.264476',3081,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1906,'sync-fks',2,'2024-06-25 03:45:03.273816','2024-06-25 03:45:03.896413',622,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1907,'sync-indexes',2,'2024-06-25 03:45:03.905293','2024-06-25 03:45:04.415405',510,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1908,'sync-metabase-metadata',2,'2024-06-25 03:45:04.422600','2024-06-25 03:45:04.430397',7,'{}','success'),(1909,'sync-table-privileges',2,'2024-06-25 03:45:04.438253','2024-06-25 03:45:04.446489',8,NULL,'success'),(1910,'analyze',2,'2024-06-25 03:45:04.481360','2024-06-25 03:45:06.568154',2086,NULL,'success'),(1911,'fingerprint-fields',2,'2024-06-25 03:45:04.489299','2024-06-25 03:45:06.397309',1908,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1912,'classify-fields',2,'2024-06-25 03:45:06.406758','2024-06-25 03:45:06.534005',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1913,'classify-tables',2,'2024-06-25 03:45:06.542923','2024-06-25 03:45:06.558779',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1914,'task-history-cleanup',NULL,'2024-06-25 04:00:00.047987','2024-06-25 04:00:00.060082',12,NULL,'success'),(1915,'sync',2,'2024-06-25 04:45:00.096983','2024-06-25 04:45:04.634844',4537,NULL,'success'),(1916,'sync-dbms-version',2,'2024-06-25 04:45:00.105570','2024-06-25 04:45:00.117363',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1917,'sync-timezone',2,'2024-06-25 04:45:00.127263','2024-06-25 04:45:00.138072',10,'{\"timezone-id\":\"+08:00\"}','success'),(1918,'sync-tables',2,'2024-06-25 04:45:00.147821','2024-06-25 04:45:00.181148',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1919,'sync-fields',2,'2024-06-25 04:45:00.190294','2024-06-25 04:45:03.338313',3148,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1920,'sync-fks',2,'2024-06-25 04:45:03.347099','2024-06-25 04:45:04.052930',705,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1921,'sync-indexes',2,'2024-06-25 04:45:04.061316','2024-06-25 04:45:04.591110',529,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1922,'sync-metabase-metadata',2,'2024-06-25 04:45:04.600860','2024-06-25 04:45:04.608823',7,'{}','success'),(1923,'sync-table-privileges',2,'2024-06-25 04:45:04.617384','2024-06-25 04:45:04.626491',9,NULL,'success'),(1924,'analyze',2,'2024-06-25 04:45:04.659036','2024-06-25 04:45:06.717714',2058,NULL,'success'),(1925,'fingerprint-fields',2,'2024-06-25 04:45:04.667376','2024-06-25 04:45:06.566261',1898,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1926,'classify-fields',2,'2024-06-25 04:45:06.574500','2024-06-25 04:45:06.688304',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1927,'classify-tables',2,'2024-06-25 04:45:06.695762','2024-06-25 04:45:06.709375',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1928,'sync',2,'2024-06-25 05:45:00.104856','2024-06-25 05:45:04.502264',4397,NULL,'success'),(1929,'sync-dbms-version',2,'2024-06-25 05:45:00.113743','2024-06-25 05:45:00.125106',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1930,'sync-timezone',2,'2024-06-25 05:45:00.135964','2024-06-25 05:45:00.147188',11,'{\"timezone-id\":\"+08:00\"}','success'),(1931,'sync-tables',2,'2024-06-25 05:45:00.156490','2024-06-25 05:45:00.184340',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1932,'sync-fields',2,'2024-06-25 05:45:00.193345','2024-06-25 05:45:03.240463',3047,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1933,'sync-fks',2,'2024-06-25 05:45:03.249021','2024-06-25 05:45:03.888724',639,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1934,'sync-indexes',2,'2024-06-25 05:45:03.897455','2024-06-25 05:45:04.459394',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1935,'sync-metabase-metadata',2,'2024-06-25 05:45:04.467693','2024-06-25 05:45:04.476155',8,'{}','success'),(1936,'sync-table-privileges',2,'2024-06-25 05:45:04.484647','2024-06-25 05:45:04.493823',9,NULL,'success'),(1937,'analyze',2,'2024-06-25 05:45:04.528495','2024-06-25 05:45:06.602073',2073,NULL,'success'),(1938,'fingerprint-fields',2,'2024-06-25 05:45:04.538195','2024-06-25 05:45:06.438353',1900,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1939,'classify-fields',2,'2024-06-25 05:45:06.446822','2024-06-25 05:45:06.568181',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1940,'classify-tables',2,'2024-06-25 05:45:06.577877','2024-06-25 05:45:06.593333',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1941,'sync',2,'2024-06-25 06:45:00.109810','2024-06-25 06:45:04.749326',4639,NULL,'success'),(1942,'sync-dbms-version',2,'2024-06-25 06:45:00.118075','2024-06-25 06:45:00.126706',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1943,'sync-timezone',2,'2024-06-25 06:45:00.136031','2024-06-25 06:45:00.146709',10,'{\"timezone-id\":\"+08:00\"}','success'),(1944,'sync-tables',2,'2024-06-25 06:45:00.157026','2024-06-25 06:45:00.186033',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1945,'sync-fields',2,'2024-06-25 06:45:00.194699','2024-06-25 06:45:03.412558',3217,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1946,'sync-fks',2,'2024-06-25 06:45:03.420699','2024-06-25 06:45:04.095380',674,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1947,'sync-indexes',2,'2024-06-25 06:45:04.104689','2024-06-25 06:45:04.700604',595,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1948,'sync-metabase-metadata',2,'2024-06-25 06:45:04.709698','2024-06-25 06:45:04.719630',9,'{}','success'),(1949,'sync-table-privileges',2,'2024-06-25 06:45:04.730096','2024-06-25 06:45:04.739538',9,NULL,'success'),(1950,'analyze',2,'2024-06-25 06:45:04.776661','2024-06-25 06:45:06.970755',2194,NULL,'success'),(1951,'fingerprint-fields',2,'2024-06-25 06:45:04.786703','2024-06-25 06:45:06.815523',2028,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1952,'classify-fields',2,'2024-06-25 06:45:06.824138','2024-06-25 06:45:06.938877',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1953,'classify-tables',2,'2024-06-25 06:45:06.946658','2024-06-25 06:45:06.961492',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1954,'sync',2,'2024-06-25 07:45:00.112688','2024-06-25 07:45:04.470567',4357,NULL,'success'),(1955,'sync-dbms-version',2,'2024-06-25 07:45:00.121539','2024-06-25 07:45:00.134714',13,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1956,'sync-timezone',2,'2024-06-25 07:45:00.145100','2024-06-25 07:45:00.156233',11,'{\"timezone-id\":\"+08:00\"}','success'),(1957,'sync-tables',2,'2024-06-25 07:45:00.165110','2024-06-25 07:45:00.201397',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1958,'sync-fields',2,'2024-06-25 07:45:00.212473','2024-06-25 07:45:03.252770',3040,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1959,'sync-fks',2,'2024-06-25 07:45:03.260834','2024-06-25 07:45:03.851854',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1960,'sync-indexes',2,'2024-06-25 07:45:03.860668','2024-06-25 07:45:04.430012',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1961,'sync-metabase-metadata',2,'2024-06-25 07:45:04.437859','2024-06-25 07:45:04.446080',8,'{}','success'),(1962,'sync-table-privileges',2,'2024-06-25 07:45:04.454424','2024-06-25 07:45:04.462418',7,NULL,'success'),(1963,'analyze',2,'2024-06-25 07:45:04.495507','2024-06-25 07:45:06.512313',2016,NULL,'success'),(1964,'fingerprint-fields',2,'2024-06-25 07:45:04.504086','2024-06-25 07:45:06.362886',1858,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1965,'classify-fields',2,'2024-06-25 07:45:06.371734','2024-06-25 07:45:06.483225',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1966,'classify-tables',2,'2024-06-25 07:45:06.490429','2024-06-25 07:45:06.503126',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1967,'sync',2,'2024-06-25 08:45:00.108502','2024-06-25 08:45:04.386312',4277,NULL,'success'),(1968,'sync-dbms-version',2,'2024-06-25 08:45:00.118050','2024-06-25 08:45:00.128940',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1969,'sync-timezone',2,'2024-06-25 08:45:00.138560','2024-06-25 08:45:00.149367',10,'{\"timezone-id\":\"+08:00\"}','success'),(1970,'sync-tables',2,'2024-06-25 08:45:00.158834','2024-06-25 08:45:00.192558',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1971,'sync-fields',2,'2024-06-25 08:45:00.201820','2024-06-25 08:45:03.202720',3000,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1972,'sync-fks',2,'2024-06-25 08:45:03.210338','2024-06-25 08:45:03.780503',570,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1973,'sync-indexes',2,'2024-06-25 08:45:03.790321','2024-06-25 08:45:04.341516',551,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1974,'sync-metabase-metadata',2,'2024-06-25 08:45:04.349391','2024-06-25 08:45:04.361148',11,'{}','success'),(1975,'sync-table-privileges',2,'2024-06-25 08:45:04.369962','2024-06-25 08:45:04.378040',8,NULL,'success'),(1976,'analyze',2,'2024-06-25 08:45:04.411280','2024-06-25 08:45:06.595335',2184,NULL,'success'),(1977,'fingerprint-fields',2,'2024-06-25 08:45:04.419170','2024-06-25 08:45:06.425131',2005,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1978,'classify-fields',2,'2024-06-25 08:45:06.433795','2024-06-25 08:45:06.562269',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1979,'classify-tables',2,'2024-06-25 08:45:06.571736','2024-06-25 08:45:06.586186',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1980,'sync',2,'2024-06-25 09:45:00.103393','2024-06-25 09:45:04.273720',4170,NULL,'success'),(1981,'sync-dbms-version',2,'2024-06-25 09:45:00.111616','2024-06-25 09:45:00.121795',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1982,'sync-timezone',2,'2024-06-25 09:45:00.130452','2024-06-25 09:45:00.141797',11,'{\"timezone-id\":\"+08:00\"}','success'),(1983,'sync-tables',2,'2024-06-25 09:45:00.151228','2024-06-25 09:45:00.184294',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1984,'sync-fields',2,'2024-06-25 09:45:00.193699','2024-06-25 09:45:03.163993',2970,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1985,'sync-fks',2,'2024-06-25 09:45:03.171644','2024-06-25 09:45:03.698573',526,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1986,'sync-indexes',2,'2024-06-25 09:45:03.706106','2024-06-25 09:45:04.234906',528,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(1987,'sync-metabase-metadata',2,'2024-06-25 09:45:04.242118','2024-06-25 09:45:04.250089',7,'{}','success'),(1988,'sync-table-privileges',2,'2024-06-25 09:45:04.257767','2024-06-25 09:45:04.265873',8,NULL,'success'),(1989,'analyze',2,'2024-06-25 09:45:04.299565','2024-06-25 09:45:06.244555',1944,NULL,'success'),(1990,'fingerprint-fields',2,'2024-06-25 09:45:04.307561','2024-06-25 09:45:06.079398',1771,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(1991,'classify-fields',2,'2024-06-25 09:45:06.089562','2024-06-25 09:45:06.213923',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(1992,'classify-tables',2,'2024-06-25 09:45:06.221451','2024-06-25 09:45:06.235105',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(1993,'sync',2,'2024-06-25 10:45:00.099857','2024-06-25 10:45:04.630743',4530,NULL,'success'),(1994,'sync-dbms-version',2,'2024-06-25 10:45:00.107451','2024-06-25 10:45:00.115697',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(1995,'sync-timezone',2,'2024-06-25 10:45:00.124490','2024-06-25 10:45:00.134264',9,'{\"timezone-id\":\"+08:00\"}','success'),(1996,'sync-tables',2,'2024-06-25 10:45:00.142517','2024-06-25 10:45:00.168207',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(1997,'sync-fields',2,'2024-06-25 10:45:00.176521','2024-06-25 10:45:03.132934',2956,'{\"total-fields\":836,\"updated-fields\":0}','success'),(1998,'sync-fks',2,'2024-06-25 10:45:03.141188','2024-06-25 10:45:03.726909',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(1999,'sync-indexes',2,'2024-06-25 10:45:03.735406','2024-06-25 10:45:04.585343',849,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2000,'sync-metabase-metadata',2,'2024-06-25 10:45:04.593502','2024-06-25 10:45:04.602999',9,'{}','success'),(2001,'sync-table-privileges',2,'2024-06-25 10:45:04.613390','2024-06-25 10:45:04.622703',9,NULL,'success'),(2002,'analyze',2,'2024-06-25 10:45:04.655375','2024-06-25 10:45:06.671752',2016,NULL,'success'),(2003,'fingerprint-fields',2,'2024-06-25 10:45:04.664107','2024-06-25 10:45:06.517706',1853,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2004,'classify-fields',2,'2024-06-25 10:45:06.525743','2024-06-25 10:45:06.641872',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2005,'classify-tables',2,'2024-06-25 10:45:06.649731','2024-06-25 10:45:06.663615',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2006,'sync',2,'2024-06-25 11:45:00.104766','2024-06-25 11:45:04.840080',4735,NULL,'success'),(2007,'sync-dbms-version',2,'2024-06-25 11:45:00.112794','2024-06-25 11:45:00.121546',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2008,'sync-timezone',2,'2024-06-25 11:45:00.130194','2024-06-25 11:45:00.138899',8,'{\"timezone-id\":\"+08:00\"}','success'),(2009,'sync-tables',2,'2024-06-25 11:45:00.147087','2024-06-25 11:45:00.171522',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2010,'sync-fields',2,'2024-06-25 11:45:00.179869','2024-06-25 11:45:03.113444',2933,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2011,'sync-fks',2,'2024-06-25 11:45:03.120694','2024-06-25 11:45:03.722738',602,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2012,'sync-indexes',2,'2024-06-25 11:45:03.731782','2024-06-25 11:45:04.792200',1060,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2013,'sync-metabase-metadata',2,'2024-06-25 11:45:04.800975','2024-06-25 11:45:04.810674',9,'{}','success'),(2014,'sync-table-privileges',2,'2024-06-25 11:45:04.819884','2024-06-25 11:45:04.829840',9,NULL,'success'),(2015,'analyze',2,'2024-06-25 11:45:04.866074','2024-06-25 11:45:06.825688',1959,NULL,'success'),(2016,'fingerprint-fields',2,'2024-06-25 11:45:04.874454','2024-06-25 11:45:06.668597',1794,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2017,'classify-fields',2,'2024-06-25 11:45:06.677461','2024-06-25 11:45:06.794635',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2018,'classify-tables',2,'2024-06-25 11:45:06.802738','2024-06-25 11:45:06.816906',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2019,'sync',2,'2024-06-25 12:45:00.101330','2024-06-25 12:45:04.538805',4437,NULL,'success'),(2020,'sync-dbms-version',2,'2024-06-25 12:45:00.109395','2024-06-25 12:45:00.118301',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2021,'sync-timezone',2,'2024-06-25 12:45:00.126506','2024-06-25 12:45:00.136104',9,'{\"timezone-id\":\"+08:00\"}','success'),(2022,'sync-tables',2,'2024-06-25 12:45:00.144266','2024-06-25 12:45:00.175559',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2023,'sync-fields',2,'2024-06-25 12:45:00.184112','2024-06-25 12:45:03.177985',2993,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2024,'sync-fks',2,'2024-06-25 12:45:03.186371','2024-06-25 12:45:03.865251',678,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2025,'sync-indexes',2,'2024-06-25 12:45:03.874391','2024-06-25 12:45:04.494627',620,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2026,'sync-metabase-metadata',2,'2024-06-25 12:45:04.503714','2024-06-25 12:45:04.512454',8,'{}','success'),(2027,'sync-table-privileges',2,'2024-06-25 12:45:04.521812','2024-06-25 12:45:04.530376',8,NULL,'success'),(2028,'analyze',2,'2024-06-25 12:45:04.565920','2024-06-25 12:45:06.864255',2298,NULL,'success'),(2029,'fingerprint-fields',2,'2024-06-25 12:45:04.574197','2024-06-25 12:45:06.707703',2133,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2030,'classify-fields',2,'2024-06-25 12:45:06.716644','2024-06-25 12:45:06.833114',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2031,'classify-tables',2,'2024-06-25 12:45:06.840910','2024-06-25 12:45:06.855201',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2032,'field values scanning',2,'2024-06-25 13:00:00.054516','2024-06-25 13:00:11.682465',11627,NULL,'success'),(2033,'delete-expired-advanced-field-values',2,'2024-06-25 13:00:00.077883','2024-06-25 13:00:02.830481',2752,'{\"deleted\":0}','success'),(2034,'update-field-values',2,'2024-06-25 13:00:02.838573','2024-06-25 13:00:11.675246',8836,'{\"errors\":0,\"created\":0,\"updated\":32,\"deleted\":0}','success'),(2035,'sync',2,'2024-06-25 13:45:00.104882','2024-06-25 13:45:04.110949',4006,NULL,'success'),(2036,'sync-dbms-version',2,'2024-06-25 13:45:00.112772','2024-06-25 13:45:00.121490',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2037,'sync-timezone',2,'2024-06-25 13:45:00.130494','2024-06-25 13:45:00.140494',10,'{\"timezone-id\":\"+08:00\"}','success'),(2038,'sync-tables',2,'2024-06-25 13:45:00.149347','2024-06-25 13:45:00.174829',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2039,'sync-fields',2,'2024-06-25 13:45:00.183236','2024-06-25 13:45:03.020322',2837,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2040,'sync-fks',2,'2024-06-25 13:45:03.028707','2024-06-25 13:45:03.596347',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2041,'sync-indexes',2,'2024-06-25 13:45:03.604646','2024-06-25 13:45:04.070295',465,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2042,'sync-metabase-metadata',2,'2024-06-25 13:45:04.079571','2024-06-25 13:45:04.087645',8,'{}','success'),(2043,'sync-table-privileges',2,'2024-06-25 13:45:04.095507','2024-06-25 13:45:04.103601',8,NULL,'success'),(2044,'analyze',2,'2024-06-25 13:45:04.134946','2024-06-25 13:45:06.086572',1951,NULL,'success'),(2045,'fingerprint-fields',2,'2024-06-25 13:45:04.142618','2024-06-25 13:45:05.934751',1792,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2046,'classify-fields',2,'2024-06-25 13:45:05.943124','2024-06-25 13:45:06.057054',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2047,'classify-tables',2,'2024-06-25 13:45:06.064338','2024-06-25 13:45:06.077628',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2048,'sync',2,'2024-06-25 14:45:00.109430','2024-06-25 14:45:04.235880',4126,NULL,'success'),(2049,'sync-dbms-version',2,'2024-06-25 14:45:00.117185','2024-06-25 14:45:00.125963',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2050,'sync-timezone',2,'2024-06-25 14:45:00.134408','2024-06-25 14:45:00.143608',9,'{\"timezone-id\":\"+08:00\"}','success'),(2051,'sync-tables',2,'2024-06-25 14:45:00.152394','2024-06-25 14:45:00.178292',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2052,'sync-fields',2,'2024-06-25 14:45:00.186641','2024-06-25 14:45:03.021097',2834,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2053,'sync-fks',2,'2024-06-25 14:45:03.029312','2024-06-25 14:45:03.653702',624,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2054,'sync-indexes',2,'2024-06-25 14:45:03.662008','2024-06-25 14:45:04.192654',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2055,'sync-metabase-metadata',2,'2024-06-25 14:45:04.200602','2024-06-25 14:45:04.209184',8,'{}','success'),(2056,'sync-table-privileges',2,'2024-06-25 14:45:04.217881','2024-06-25 14:45:04.227037',9,NULL,'success'),(2057,'analyze',2,'2024-06-25 14:45:04.260406','2024-06-25 14:45:06.442649',2182,NULL,'success'),(2058,'fingerprint-fields',2,'2024-06-25 14:45:04.269904','2024-06-25 14:45:06.303692',2033,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2059,'classify-fields',2,'2024-06-25 14:45:06.311099','2024-06-25 14:45:06.413336',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2060,'classify-tables',2,'2024-06-25 14:45:06.420499','2024-06-25 14:45:06.434531',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2061,'sync',2,'2024-06-25 15:45:00.120150','2024-06-25 15:45:04.465049',4344,NULL,'success'),(2062,'sync-dbms-version',2,'2024-06-25 15:45:00.128763','2024-06-25 15:45:00.139482',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2063,'sync-timezone',2,'2024-06-25 15:45:00.149036','2024-06-25 15:45:00.160824',11,'{\"timezone-id\":\"+08:00\"}','success'),(2064,'sync-tables',2,'2024-06-25 15:45:00.171716','2024-06-25 15:45:00.209905',38,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2065,'sync-fields',2,'2024-06-25 15:45:00.221543','2024-06-25 15:45:03.179517',2957,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2066,'sync-fks',2,'2024-06-25 15:45:03.187294','2024-06-25 15:45:03.851932',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2067,'sync-indexes',2,'2024-06-25 15:45:03.862365','2024-06-25 15:45:04.422409',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2068,'sync-metabase-metadata',2,'2024-06-25 15:45:04.430150','2024-06-25 15:45:04.437779',7,'{}','success'),(2069,'sync-table-privileges',2,'2024-06-25 15:45:04.446508','2024-06-25 15:45:04.456787',10,NULL,'success'),(2070,'analyze',2,'2024-06-25 15:45:04.490900','2024-06-25 15:45:06.600096',2109,NULL,'success'),(2071,'fingerprint-fields',2,'2024-06-25 15:45:04.499929','2024-06-25 15:45:06.437590',1937,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2072,'classify-fields',2,'2024-06-25 15:45:06.447451','2024-06-25 15:45:06.568592',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2073,'classify-tables',2,'2024-06-25 15:45:06.576316','2024-06-25 15:45:06.591007',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2074,'task-history-cleanup',NULL,'2024-06-25 16:00:00.012747','2024-06-25 16:00:00.037448',24,NULL,'success'),(2075,'task-history-cleanup',NULL,'2024-06-25 16:00:00.063856','2024-06-25 16:00:00.081632',17,NULL,'success'),(2076,'sync',2,'2024-06-25 16:45:00.115135','2024-06-25 16:45:04.596819',4481,NULL,'success'),(2077,'sync-dbms-version',2,'2024-06-25 16:45:00.123854','2024-06-25 16:45:00.133480',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2078,'sync-timezone',2,'2024-06-25 16:45:00.142170','2024-06-25 16:45:00.153243',11,'{\"timezone-id\":\"+08:00\"}','success'),(2079,'sync-tables',2,'2024-06-25 16:45:00.161737','2024-06-25 16:45:00.193719',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2080,'sync-fields',2,'2024-06-25 16:45:00.203193','2024-06-25 16:45:03.315809',3112,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2081,'sync-fks',2,'2024-06-25 16:45:03.323825','2024-06-25 16:45:03.963966',640,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2082,'sync-indexes',2,'2024-06-25 16:45:03.972680','2024-06-25 16:45:04.556212',583,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2083,'sync-metabase-metadata',2,'2024-06-25 16:45:04.564557','2024-06-25 16:45:04.572678',8,'{}','success'),(2084,'sync-table-privileges',2,'2024-06-25 16:45:04.580775','2024-06-25 16:45:04.588617',7,NULL,'success'),(2085,'analyze',2,'2024-06-25 16:45:04.623422','2024-06-25 16:45:06.735023',2111,NULL,'success'),(2086,'fingerprint-fields',2,'2024-06-25 16:45:04.631556','2024-06-25 16:45:06.574484',1942,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2087,'classify-fields',2,'2024-06-25 16:45:06.582791','2024-06-25 16:45:06.702722',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2088,'classify-tables',2,'2024-06-25 16:45:06.709965','2024-06-25 16:45:06.726144',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2089,'sync',2,'2024-06-25 17:45:00.101819','2024-06-25 17:45:04.513328',4411,NULL,'success'),(2090,'sync-dbms-version',2,'2024-06-25 17:45:00.111428','2024-06-25 17:45:00.122729',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2091,'sync-timezone',2,'2024-06-25 17:45:00.132803','2024-06-25 17:45:00.144651',11,'{\"timezone-id\":\"+08:00\"}','success'),(2092,'sync-tables',2,'2024-06-25 17:45:00.153394','2024-06-25 17:45:00.184821',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2093,'sync-fields',2,'2024-06-25 17:45:00.193510','2024-06-25 17:45:03.203951',3010,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2094,'sync-fks',2,'2024-06-25 17:45:03.212533','2024-06-25 17:45:03.846490',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2095,'sync-indexes',2,'2024-06-25 17:45:03.858186','2024-06-25 17:45:04.466016',607,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2096,'sync-metabase-metadata',2,'2024-06-25 17:45:04.474238','2024-06-25 17:45:04.484107',9,'{}','success'),(2097,'sync-table-privileges',2,'2024-06-25 17:45:04.493402','2024-06-25 17:45:04.503720',10,NULL,'success'),(2098,'analyze',2,'2024-06-25 17:45:04.544575','2024-06-25 17:45:06.669853',2125,NULL,'success'),(2099,'fingerprint-fields',2,'2024-06-25 17:45:04.556333','2024-06-25 17:45:06.523888',1967,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2100,'classify-fields',2,'2024-06-25 17:45:06.532218','2024-06-25 17:45:06.638994',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2101,'classify-tables',2,'2024-06-25 17:45:06.646867','2024-06-25 17:45:06.661871',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2102,'sync',2,'2024-06-25 18:45:00.122125','2024-06-25 18:45:04.756322',4634,NULL,'success'),(2103,'sync-dbms-version',2,'2024-06-25 18:45:00.132911','2024-06-25 18:45:00.143520',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2104,'sync-timezone',2,'2024-06-25 18:45:00.152838','2024-06-25 18:45:00.164161',11,'{\"timezone-id\":\"+08:00\"}','success'),(2105,'sync-tables',2,'2024-06-25 18:45:00.174599','2024-06-25 18:45:00.205486',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2106,'sync-fields',2,'2024-06-25 18:45:00.215053','2024-06-25 18:45:03.297914',3082,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2107,'sync-fks',2,'2024-06-25 18:45:03.314386','2024-06-25 18:45:04.043191',728,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2108,'sync-indexes',2,'2024-06-25 18:45:04.054138','2024-06-25 18:45:04.710531',656,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2109,'sync-metabase-metadata',2,'2024-06-25 18:45:04.719251','2024-06-25 18:45:04.729463',10,'{}','success'),(2110,'sync-table-privileges',2,'2024-06-25 18:45:04.738213','2024-06-25 18:45:04.746854',8,NULL,'success'),(2111,'analyze',2,'2024-06-25 18:45:04.781812','2024-06-25 18:45:06.677243',1895,NULL,'success'),(2112,'fingerprint-fields',2,'2024-06-25 18:45:04.790498','2024-06-25 18:45:06.536649',1746,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2113,'classify-fields',2,'2024-06-25 18:45:06.544207','2024-06-25 18:45:06.643747',99,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2114,'classify-tables',2,'2024-06-25 18:45:06.651505','2024-06-25 18:45:06.666936',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2115,'sync',2,'2024-06-25 19:45:00.120093','2024-06-25 19:45:04.732704',4612,NULL,'success'),(2116,'sync-dbms-version',2,'2024-06-25 19:45:00.128315','2024-06-25 19:45:00.138908',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2117,'sync-timezone',2,'2024-06-25 19:45:00.148287','2024-06-25 19:45:00.159949',11,'{\"timezone-id\":\"+08:00\"}','success'),(2118,'sync-tables',2,'2024-06-25 19:45:00.169694','2024-06-25 19:45:00.196146',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2119,'sync-fields',2,'2024-06-25 19:45:00.205043','2024-06-25 19:45:03.444946',3239,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2120,'sync-fks',2,'2024-06-25 19:45:03.453679','2024-06-25 19:45:04.072854',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2121,'sync-indexes',2,'2024-06-25 19:45:04.081824','2024-06-25 19:45:04.687059',605,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2122,'sync-metabase-metadata',2,'2024-06-25 19:45:04.695929','2024-06-25 19:45:04.705740',9,'{}','success'),(2123,'sync-table-privileges',2,'2024-06-25 19:45:04.714728','2024-06-25 19:45:04.723725',9,NULL,'success'),(2124,'analyze',2,'2024-06-25 19:45:04.761431','2024-06-25 19:45:06.999281',2237,NULL,'success'),(2125,'fingerprint-fields',2,'2024-06-25 19:45:04.771825','2024-06-25 19:45:06.833996',2062,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2126,'classify-fields',2,'2024-06-25 19:45:06.843066','2024-06-25 19:45:06.967148',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2127,'classify-tables',2,'2024-06-25 19:45:06.975197','2024-06-25 19:45:06.989162',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2128,'sync',2,'2024-06-25 20:45:00.116366','2024-06-25 20:45:04.752451',4636,NULL,'success'),(2129,'sync-dbms-version',2,'2024-06-25 20:45:00.124218','2024-06-25 20:45:00.134068',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2130,'sync-timezone',2,'2024-06-25 20:45:00.142617','2024-06-25 20:45:00.152289',9,'{\"timezone-id\":\"+08:00\"}','success'),(2131,'sync-tables',2,'2024-06-25 20:45:00.160628','2024-06-25 20:45:00.188380',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2132,'sync-fields',2,'2024-06-25 20:45:00.196439','2024-06-25 20:45:03.396184',3199,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2133,'sync-fks',2,'2024-06-25 20:45:03.404501','2024-06-25 20:45:04.125244',720,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2134,'sync-indexes',2,'2024-06-25 20:45:04.133801','2024-06-25 20:45:04.705712',571,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2135,'sync-metabase-metadata',2,'2024-06-25 20:45:04.714437','2024-06-25 20:45:04.723289',8,'{}','success'),(2136,'sync-table-privileges',2,'2024-06-25 20:45:04.732859','2024-06-25 20:45:04.743373',10,NULL,'success'),(2137,'analyze',2,'2024-06-25 20:45:04.779245','2024-06-25 20:45:06.972984',2193,NULL,'success'),(2138,'fingerprint-fields',2,'2024-06-25 20:45:04.790350','2024-06-25 20:45:06.811657',2021,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2139,'classify-fields',2,'2024-06-25 20:45:06.820379','2024-06-25 20:45:06.940526',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2140,'classify-tables',2,'2024-06-25 20:45:06.948554','2024-06-25 20:45:06.963449',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2141,'sync',2,'2024-06-25 21:45:00.113323','2024-06-25 21:45:04.469721',4356,NULL,'success'),(2142,'sync-dbms-version',2,'2024-06-25 21:45:00.121489','2024-06-25 21:45:00.133110',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2143,'sync-timezone',2,'2024-06-25 21:45:00.142324','2024-06-25 21:45:00.152298',9,'{\"timezone-id\":\"+08:00\"}','success'),(2144,'sync-tables',2,'2024-06-25 21:45:00.161200','2024-06-25 21:45:00.195674',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2145,'sync-fields',2,'2024-06-25 21:45:00.205269','2024-06-25 21:45:03.329676',3124,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2146,'sync-fks',2,'2024-06-25 21:45:03.337816','2024-06-25 21:45:03.923748',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2147,'sync-indexes',2,'2024-06-25 21:45:03.932171','2024-06-25 21:45:04.428170',496,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2148,'sync-metabase-metadata',2,'2024-06-25 21:45:04.436509','2024-06-25 21:45:04.445453',8,'{}','success'),(2149,'sync-table-privileges',2,'2024-06-25 21:45:04.454158','2024-06-25 21:45:04.462062',7,NULL,'success'),(2150,'analyze',2,'2024-06-25 21:45:04.494916','2024-06-25 21:45:06.579981',2085,NULL,'success'),(2151,'fingerprint-fields',2,'2024-06-25 21:45:04.503039','2024-06-25 21:45:06.440843',1937,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2152,'classify-fields',2,'2024-06-25 21:45:06.450919','2024-06-25 21:45:06.551741',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2153,'classify-tables',2,'2024-06-25 21:45:06.558756','2024-06-25 21:45:06.571837',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2154,'sync',2,'2024-06-25 22:45:00.119199','2024-06-25 22:45:04.895193',4775,NULL,'success'),(2155,'sync-dbms-version',2,'2024-06-25 22:45:00.128097','2024-06-25 22:45:00.138977',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2156,'sync-timezone',2,'2024-06-25 22:45:00.148243','2024-06-25 22:45:00.160956',12,'{\"timezone-id\":\"+08:00\"}','success'),(2157,'sync-tables',2,'2024-06-25 22:45:00.170375','2024-06-25 22:45:00.198302',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2158,'sync-fields',2,'2024-06-25 22:45:00.207348','2024-06-25 22:45:03.559542',3352,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2159,'sync-fks',2,'2024-06-25 22:45:03.567694','2024-06-25 22:45:04.294797',727,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2160,'sync-indexes',2,'2024-06-25 22:45:04.304060','2024-06-25 22:45:04.853792',549,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2161,'sync-metabase-metadata',2,'2024-06-25 22:45:04.862301','2024-06-25 22:45:04.870568',8,'{}','success'),(2162,'sync-table-privileges',2,'2024-06-25 22:45:04.878653','2024-06-25 22:45:04.887217',8,NULL,'success'),(2163,'analyze',2,'2024-06-25 22:45:04.918697','2024-06-25 22:45:07.168090',2249,NULL,'success'),(2164,'fingerprint-fields',2,'2024-06-25 22:45:04.926771','2024-06-25 22:45:06.987731',2060,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2165,'classify-fields',2,'2024-06-25 22:45:06.996523','2024-06-25 22:45:07.134933',138,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2166,'classify-tables',2,'2024-06-25 22:45:07.143489','2024-06-25 22:45:07.158767',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2167,'sync',2,'2024-06-25 23:45:00.113833','2024-06-25 23:45:04.561460',4447,NULL,'success'),(2168,'sync-dbms-version',2,'2024-06-25 23:45:00.122946','2024-06-25 23:45:00.133157',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2169,'sync-timezone',2,'2024-06-25 23:45:00.142251','2024-06-25 23:45:00.154693',12,'{\"timezone-id\":\"+08:00\"}','success'),(2170,'sync-tables',2,'2024-06-25 23:45:00.163992','2024-06-25 23:45:00.194192',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2171,'sync-fields',2,'2024-06-25 23:45:00.203595','2024-06-25 23:45:03.371846',3168,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2172,'sync-fks',2,'2024-06-25 23:45:03.380292','2024-06-25 23:45:03.995900',615,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2173,'sync-indexes',2,'2024-06-25 23:45:04.004158','2024-06-25 23:45:04.520277',516,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2174,'sync-metabase-metadata',2,'2024-06-25 23:45:04.528134','2024-06-25 23:45:04.537442',9,'{}','success'),(2175,'sync-table-privileges',2,'2024-06-25 23:45:04.545168','2024-06-25 23:45:04.553547',8,NULL,'success'),(2176,'analyze',2,'2024-06-25 23:45:04.585998','2024-06-25 23:45:06.655221',2069,NULL,'success'),(2177,'fingerprint-fields',2,'2024-06-25 23:45:04.594006','2024-06-25 23:45:06.505553',1911,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2178,'classify-fields',2,'2024-06-25 23:45:06.514104','2024-06-25 23:45:06.624612',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2179,'classify-tables',2,'2024-06-25 23:45:06.632407','2024-06-25 23:45:06.646078',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2180,'sync',2,'2024-06-26 00:45:00.092526','2024-06-26 00:45:04.782604',4690,NULL,'success'),(2181,'sync-dbms-version',2,'2024-06-26 00:45:00.100644','2024-06-26 00:45:00.110168',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2182,'sync-timezone',2,'2024-06-26 00:45:00.119289','2024-06-26 00:45:00.130214',10,'{\"timezone-id\":\"+08:00\"}','success'),(2183,'sync-tables',2,'2024-06-26 00:45:00.139868','2024-06-26 00:45:00.173345',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2184,'sync-fields',2,'2024-06-26 00:45:00.182098','2024-06-26 00:45:03.511963',3329,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2185,'sync-fks',2,'2024-06-26 00:45:03.519666','2024-06-26 00:45:04.164492',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2186,'sync-indexes',2,'2024-06-26 00:45:04.174841','2024-06-26 00:45:04.742447',567,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2187,'sync-metabase-metadata',2,'2024-06-26 00:45:04.749722','2024-06-26 00:45:04.758192',8,'{}','success'),(2188,'sync-table-privileges',2,'2024-06-26 00:45:04.766852','2024-06-26 00:45:04.775128',8,NULL,'success'),(2189,'analyze',2,'2024-06-26 00:45:04.806262','2024-06-26 00:45:06.988884',2182,NULL,'success'),(2190,'fingerprint-fields',2,'2024-06-26 00:45:04.814710','2024-06-26 00:45:06.826203',2011,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2191,'classify-fields',2,'2024-06-26 00:45:06.835619','2024-06-26 00:45:06.957769',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2192,'classify-tables',2,'2024-06-26 00:45:06.966055','2024-06-26 00:45:06.980615',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2193,'sync',2,'2024-06-26 01:45:00.108204','2024-06-26 01:45:04.833330',4725,NULL,'success'),(2194,'sync-dbms-version',2,'2024-06-26 01:45:00.119964','2024-06-26 01:45:00.137150',17,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2195,'sync-timezone',2,'2024-06-26 01:45:00.146000','2024-06-26 01:45:00.156708',10,'{\"timezone-id\":\"+08:00\"}','success'),(2196,'sync-tables',2,'2024-06-26 01:45:00.165460','2024-06-26 01:45:00.192969',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2197,'sync-fields',2,'2024-06-26 01:45:00.201653','2024-06-26 01:45:03.451749',3250,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2198,'sync-fks',2,'2024-06-26 01:45:03.461555','2024-06-26 01:45:04.175905',714,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2199,'sync-indexes',2,'2024-06-26 01:45:04.184898','2024-06-26 01:45:04.787488',602,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2200,'sync-metabase-metadata',2,'2024-06-26 01:45:04.796645','2024-06-26 01:45:04.805962',9,'{}','success'),(2201,'sync-table-privileges',2,'2024-06-26 01:45:04.815663','2024-06-26 01:45:04.824799',9,NULL,'success'),(2202,'analyze',2,'2024-06-26 01:45:04.859132','2024-06-26 01:45:07.044829',2185,NULL,'success'),(2203,'fingerprint-fields',2,'2024-06-26 01:45:04.867992','2024-06-26 01:45:06.875059',2007,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2204,'classify-fields',2,'2024-06-26 01:45:06.883453','2024-06-26 01:45:07.009544',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2205,'classify-tables',2,'2024-06-26 01:45:07.018951','2024-06-26 01:45:07.035959',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2206,'sync',2,'2024-06-26 02:45:00.126456','2024-06-26 02:45:04.681679',4555,NULL,'success'),(2207,'sync-dbms-version',2,'2024-06-26 02:45:00.134719','2024-06-26 02:45:00.144393',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2208,'sync-timezone',2,'2024-06-26 02:45:00.152642','2024-06-26 02:45:00.162387',9,'{\"timezone-id\":\"+08:00\"}','success'),(2209,'sync-tables',2,'2024-06-26 02:45:00.171175','2024-06-26 02:45:00.204483',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2210,'sync-fields',2,'2024-06-26 02:45:00.214148','2024-06-26 02:45:03.262679',3048,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2211,'sync-fks',2,'2024-06-26 02:45:03.270827','2024-06-26 02:45:03.976423',705,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2212,'sync-indexes',2,'2024-06-26 02:45:03.986223','2024-06-26 02:45:04.635161',648,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2213,'sync-metabase-metadata',2,'2024-06-26 02:45:04.643599','2024-06-26 02:45:04.653554',9,'{}','success'),(2214,'sync-table-privileges',2,'2024-06-26 02:45:04.662769','2024-06-26 02:45:04.672334',9,NULL,'success'),(2215,'analyze',2,'2024-06-26 02:45:04.711553','2024-06-26 02:45:06.939048',2227,NULL,'success'),(2216,'fingerprint-fields',2,'2024-06-26 02:45:04.720787','2024-06-26 02:45:06.769157',2048,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2217,'classify-fields',2,'2024-06-26 02:45:06.778452','2024-06-26 02:45:06.905539',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2218,'classify-tables',2,'2024-06-26 02:45:06.914042','2024-06-26 02:45:06.930354',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2219,'sync',2,'2024-06-26 03:45:00.113160','2024-06-26 03:45:04.428324',4315,NULL,'success'),(2220,'sync-dbms-version',2,'2024-06-26 03:45:00.122886','2024-06-26 03:45:00.134734',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2221,'sync-timezone',2,'2024-06-26 03:45:00.145114','2024-06-26 03:45:00.155800',10,'{\"timezone-id\":\"+08:00\"}','success'),(2222,'sync-tables',2,'2024-06-26 03:45:00.164108','2024-06-26 03:45:00.194102',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2223,'sync-fields',2,'2024-06-26 03:45:00.203715','2024-06-26 03:45:03.100981',2897,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2224,'sync-fks',2,'2024-06-26 03:45:03.111417','2024-06-26 03:45:03.793408',681,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2225,'sync-indexes',2,'2024-06-26 03:45:03.803848','2024-06-26 03:45:04.387551',583,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2226,'sync-metabase-metadata',2,'2024-06-26 03:45:04.395245','2024-06-26 03:45:04.402395',7,'{}','success'),(2227,'sync-table-privileges',2,'2024-06-26 03:45:04.410936','2024-06-26 03:45:04.420106',9,NULL,'success'),(2228,'analyze',2,'2024-06-26 03:45:04.453648','2024-06-26 03:45:06.568777',2115,NULL,'success'),(2229,'fingerprint-fields',2,'2024-06-26 03:45:04.462948','2024-06-26 03:45:06.395844',1932,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2230,'classify-fields',2,'2024-06-26 03:45:06.406229','2024-06-26 03:45:06.533891',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2231,'classify-tables',2,'2024-06-26 03:45:06.542112','2024-06-26 03:45:06.556950',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2232,'task-history-cleanup',NULL,'2024-06-26 04:00:00.091791','2024-06-26 04:00:00.101795',10,NULL,'success'),(2233,'sync',2,'2024-06-26 04:45:00.119386','2024-06-26 04:45:04.763464',4644,NULL,'success'),(2234,'sync-dbms-version',2,'2024-06-26 04:45:00.129096','2024-06-26 04:45:00.139927',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2235,'sync-timezone',2,'2024-06-26 04:45:00.150176','2024-06-26 04:45:00.163170',12,'{\"timezone-id\":\"+08:00\"}','success'),(2236,'sync-tables',2,'2024-06-26 04:45:00.174881','2024-06-26 04:45:00.202351',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2237,'sync-fields',2,'2024-06-26 04:45:00.213058','2024-06-26 04:45:03.425274',3212,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2238,'sync-fks',2,'2024-06-26 04:45:03.433162','2024-06-26 04:45:04.068682',635,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2239,'sync-indexes',2,'2024-06-26 04:45:04.077685','2024-06-26 04:45:04.715717',638,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2240,'sync-metabase-metadata',2,'2024-06-26 04:45:04.724778','2024-06-26 04:45:04.735714',10,'{}','success'),(2241,'sync-table-privileges',2,'2024-06-26 04:45:04.745568','2024-06-26 04:45:04.754103',8,NULL,'success'),(2242,'analyze',2,'2024-06-26 04:45:04.794152','2024-06-26 04:45:06.967408',2173,NULL,'success'),(2243,'fingerprint-fields',2,'2024-06-26 04:45:04.804310','2024-06-26 04:45:06.814960',2010,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2244,'classify-fields',2,'2024-06-26 04:45:06.823334','2024-06-26 04:45:06.936122',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2245,'classify-tables',2,'2024-06-26 04:45:06.944055','2024-06-26 04:45:06.958605',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2246,'sync',2,'2024-06-26 05:45:00.123821','2024-06-26 05:45:05.071012',4947,NULL,'success'),(2247,'sync-dbms-version',2,'2024-06-26 05:45:00.132864','2024-06-26 05:45:00.144133',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2248,'sync-timezone',2,'2024-06-26 05:45:00.154247','2024-06-26 05:45:00.166052',11,'{\"timezone-id\":\"+08:00\"}','success'),(2249,'sync-tables',2,'2024-06-26 05:45:00.176040','2024-06-26 05:45:00.212250',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2250,'sync-fields',2,'2024-06-26 05:45:00.223050','2024-06-26 05:45:03.632878',3409,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2251,'sync-fks',2,'2024-06-26 05:45:03.643421','2024-06-26 05:45:04.384936',741,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2252,'sync-indexes',2,'2024-06-26 05:45:04.393913','2024-06-26 05:45:05.022409',628,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2253,'sync-metabase-metadata',2,'2024-06-26 05:45:05.030746','2024-06-26 05:45:05.041779',11,'{}','success'),(2254,'sync-table-privileges',2,'2024-06-26 05:45:05.051322','2024-06-26 05:45:05.061940',10,NULL,'success'),(2255,'analyze',2,'2024-06-26 05:45:05.101525','2024-06-26 05:45:07.374466',2272,NULL,'success'),(2256,'fingerprint-fields',2,'2024-06-26 05:45:05.110993','2024-06-26 05:45:07.222772',2111,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2257,'classify-fields',2,'2024-06-26 05:45:07.231301','2024-06-26 05:45:07.346699',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2258,'classify-tables',2,'2024-06-26 05:45:07.354099','2024-06-26 05:45:07.366984',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2259,'sync',2,'2024-06-26 06:45:00.118106','2024-06-26 06:45:04.588567',4470,NULL,'success'),(2260,'sync-dbms-version',2,'2024-06-26 06:45:00.126903','2024-06-26 06:45:00.138845',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2261,'sync-timezone',2,'2024-06-26 06:45:00.147870','2024-06-26 06:45:00.158674',10,'{\"timezone-id\":\"+08:00\"}','success'),(2262,'sync-tables',2,'2024-06-26 06:45:00.167407','2024-06-26 06:45:00.194471',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2263,'sync-fields',2,'2024-06-26 06:45:00.202994','2024-06-26 06:45:03.303968',3100,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2264,'sync-fks',2,'2024-06-26 06:45:03.316227','2024-06-26 06:45:03.969406',653,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2265,'sync-indexes',2,'2024-06-26 06:45:03.980152','2024-06-26 06:45:04.545406',565,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2266,'sync-metabase-metadata',2,'2024-06-26 06:45:04.553606','2024-06-26 06:45:04.561418',7,'{}','success'),(2267,'sync-table-privileges',2,'2024-06-26 06:45:04.570335','2024-06-26 06:45:04.579308',8,NULL,'success'),(2268,'analyze',2,'2024-06-26 06:45:04.617185','2024-06-26 06:45:06.737932',2120,NULL,'success'),(2269,'fingerprint-fields',2,'2024-06-26 06:45:04.625742','2024-06-26 06:45:06.576097',1950,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2270,'classify-fields',2,'2024-06-26 06:45:06.584305','2024-06-26 06:45:06.708222',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2271,'classify-tables',2,'2024-06-26 06:45:06.716067','2024-06-26 06:45:06.729258',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2272,'sync',2,'2024-06-26 07:45:00.110889','2024-06-26 07:45:04.591102',4480,NULL,'success'),(2273,'sync-dbms-version',2,'2024-06-26 07:45:00.119334','2024-06-26 07:45:00.129029',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2274,'sync-timezone',2,'2024-06-26 07:45:00.137779','2024-06-26 07:45:00.147767',9,'{\"timezone-id\":\"+08:00\"}','success'),(2275,'sync-tables',2,'2024-06-26 07:45:00.156174','2024-06-26 07:45:00.186465',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2276,'sync-fields',2,'2024-06-26 07:45:00.194844','2024-06-26 07:45:03.215374',3020,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2277,'sync-fks',2,'2024-06-26 07:45:03.223633','2024-06-26 07:45:03.936928',713,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2278,'sync-indexes',2,'2024-06-26 07:45:03.944614','2024-06-26 07:45:04.545854',601,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2279,'sync-metabase-metadata',2,'2024-06-26 07:45:04.553995','2024-06-26 07:45:04.564051',10,'{}','success'),(2280,'sync-table-privileges',2,'2024-06-26 07:45:04.573061','2024-06-26 07:45:04.582408',9,NULL,'success'),(2281,'analyze',2,'2024-06-26 07:45:04.617899','2024-06-26 07:45:06.826905',2209,NULL,'success'),(2282,'fingerprint-fields',2,'2024-06-26 07:45:04.627986','2024-06-26 07:45:06.645868',2017,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2283,'classify-fields',2,'2024-06-26 07:45:06.655367','2024-06-26 07:45:06.795175',139,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2284,'classify-tables',2,'2024-06-26 07:45:06.804259','2024-06-26 07:45:06.818705',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2285,'sync',2,'2024-06-26 08:45:00.106362','2024-06-26 08:45:04.234786',4128,NULL,'success'),(2286,'sync-dbms-version',2,'2024-06-26 08:45:00.114718','2024-06-26 08:45:00.124214',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2287,'sync-timezone',2,'2024-06-26 08:45:00.133430','2024-06-26 08:45:00.145000',11,'{\"timezone-id\":\"+08:00\"}','success'),(2288,'sync-tables',2,'2024-06-26 08:45:00.154440','2024-06-26 08:45:00.184946',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2289,'sync-fields',2,'2024-06-26 08:45:00.198173','2024-06-26 08:45:03.188191',2990,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2290,'sync-fks',2,'2024-06-26 08:45:03.195960','2024-06-26 08:45:03.746695',550,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2291,'sync-indexes',2,'2024-06-26 08:45:03.754251','2024-06-26 08:45:04.192830',438,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2292,'sync-metabase-metadata',2,'2024-06-26 08:45:04.201067','2024-06-26 08:45:04.209905',8,'{}','success'),(2293,'sync-table-privileges',2,'2024-06-26 08:45:04.218247','2024-06-26 08:45:04.226521',8,NULL,'success'),(2294,'analyze',2,'2024-06-26 08:45:04.259090','2024-06-26 08:45:06.331331',2072,NULL,'success'),(2295,'fingerprint-fields',2,'2024-06-26 08:45:04.273650','2024-06-26 08:45:06.171608',1897,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2296,'classify-fields',2,'2024-06-26 08:45:06.179742','2024-06-26 08:45:06.299540',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2297,'classify-tables',2,'2024-06-26 08:45:06.307432','2024-06-26 08:45:06.323274',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2298,'sync',2,'2024-06-26 09:45:00.095572','2024-06-26 09:45:04.823663',4728,NULL,'success'),(2299,'sync-dbms-version',2,'2024-06-26 09:45:00.104786','2024-06-26 09:45:00.115595',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2300,'sync-timezone',2,'2024-06-26 09:45:00.127483','2024-06-26 09:45:00.139096',11,'{\"timezone-id\":\"+08:00\"}','success'),(2301,'sync-tables',2,'2024-06-26 09:45:00.148547','2024-06-26 09:45:00.174038',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2302,'sync-fields',2,'2024-06-26 09:45:00.182422','2024-06-26 09:45:03.365573',3183,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2303,'sync-fks',2,'2024-06-26 09:45:03.373726','2024-06-26 09:45:04.058565',684,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2304,'sync-indexes',2,'2024-06-26 09:45:04.068977','2024-06-26 09:45:04.775915',706,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2305,'sync-metabase-metadata',2,'2024-06-26 09:45:04.784519','2024-06-26 09:45:04.794962',10,'{}','success'),(2306,'sync-table-privileges',2,'2024-06-26 09:45:04.803716','2024-06-26 09:45:04.814025',10,NULL,'success'),(2307,'analyze',2,'2024-06-26 09:45:04.855307','2024-06-26 09:45:06.864071',2008,NULL,'success'),(2308,'fingerprint-fields',2,'2024-06-26 09:45:04.863834','2024-06-26 09:45:06.724921',1861,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2309,'classify-fields',2,'2024-06-26 09:45:06.732743','2024-06-26 09:45:06.830488',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2310,'classify-tables',2,'2024-06-26 09:45:06.838199','2024-06-26 09:45:06.851196',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2311,'sync',2,'2024-06-26 10:45:00.096519','2024-06-26 10:45:04.346228',4249,NULL,'success'),(2312,'sync-dbms-version',2,'2024-06-26 10:45:00.104020','2024-06-26 10:45:00.114702',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2313,'sync-timezone',2,'2024-06-26 10:45:00.122620','2024-06-26 10:45:00.131214',8,'{\"timezone-id\":\"+08:00\"}','success'),(2314,'sync-tables',2,'2024-06-26 10:45:00.138719','2024-06-26 10:45:00.165316',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2315,'sync-fields',2,'2024-06-26 10:45:00.173333','2024-06-26 10:45:03.188019',3014,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2316,'sync-fks',2,'2024-06-26 10:45:03.197086','2024-06-26 10:45:03.825950',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2317,'sync-indexes',2,'2024-06-26 10:45:03.834704','2024-06-26 10:45:04.306832',472,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2318,'sync-metabase-metadata',2,'2024-06-26 10:45:04.314130','2024-06-26 10:45:04.322240',8,'{}','success'),(2319,'sync-table-privileges',2,'2024-06-26 10:45:04.330368','2024-06-26 10:45:04.338228',7,NULL,'success'),(2320,'analyze',2,'2024-06-26 10:45:04.371429','2024-06-26 10:45:06.396675',2025,NULL,'success'),(2321,'fingerprint-fields',2,'2024-06-26 10:45:04.379823','2024-06-26 10:45:06.229665',1849,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2322,'classify-fields',2,'2024-06-26 10:45:06.238677','2024-06-26 10:45:06.366573',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2323,'classify-tables',2,'2024-06-26 10:45:06.374101','2024-06-26 10:45:06.387968',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2324,'sync',2,'2024-06-26 11:45:00.117138','2024-06-26 11:45:04.762622',4645,NULL,'success'),(2325,'sync-dbms-version',2,'2024-06-26 11:45:00.125362','2024-06-26 11:45:00.135518',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2326,'sync-timezone',2,'2024-06-26 11:45:00.145025','2024-06-26 11:45:00.156533',11,'{\"timezone-id\":\"+08:00\"}','success'),(2327,'sync-tables',2,'2024-06-26 11:45:00.165327','2024-06-26 11:45:00.193441',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2328,'sync-fields',2,'2024-06-26 11:45:00.202484','2024-06-26 11:45:03.165689',2963,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2329,'sync-fks',2,'2024-06-26 11:45:03.173554','2024-06-26 11:45:03.835127',661,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2330,'sync-indexes',2,'2024-06-26 11:45:03.843933','2024-06-26 11:45:04.722211',878,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2331,'sync-metabase-metadata',2,'2024-06-26 11:45:04.730088','2024-06-26 11:45:04.738331',8,'{}','success'),(2332,'sync-table-privileges',2,'2024-06-26 11:45:04.746468','2024-06-26 11:45:04.754652',8,NULL,'success'),(2333,'analyze',2,'2024-06-26 11:45:04.794761','2024-06-26 11:45:06.769556',1974,NULL,'success'),(2334,'fingerprint-fields',2,'2024-06-26 11:45:04.804380','2024-06-26 11:45:06.611191',1806,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2335,'classify-fields',2,'2024-06-26 11:45:06.619688','2024-06-26 11:45:06.739332',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2336,'classify-tables',2,'2024-06-26 11:45:06.746769','2024-06-26 11:45:06.760692',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2337,'sync',2,'2024-06-26 12:45:00.111296','2024-06-26 12:45:04.552713',4441,NULL,'success'),(2338,'sync-dbms-version',2,'2024-06-26 12:45:00.119655','2024-06-26 12:45:00.129641',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2339,'sync-timezone',2,'2024-06-26 12:45:00.138453','2024-06-26 12:45:00.147954',9,'{\"timezone-id\":\"+08:00\"}','success'),(2340,'sync-tables',2,'2024-06-26 12:45:00.155667','2024-06-26 12:45:00.180531',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2341,'sync-fields',2,'2024-06-26 12:45:00.188335','2024-06-26 12:45:02.981931',2793,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2342,'sync-fks',2,'2024-06-26 12:45:02.989437','2024-06-26 12:45:03.514248',524,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2343,'sync-indexes',2,'2024-06-26 12:45:03.522050','2024-06-26 12:45:04.510124',988,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2344,'sync-metabase-metadata',2,'2024-06-26 12:45:04.517989','2024-06-26 12:45:04.527069',9,'{}','success'),(2345,'sync-table-privileges',2,'2024-06-26 12:45:04.535636','2024-06-26 12:45:04.544813',9,NULL,'success'),(2346,'analyze',2,'2024-06-26 12:45:04.577920','2024-06-26 12:45:06.483715',1905,NULL,'success'),(2347,'fingerprint-fields',2,'2024-06-26 12:45:04.585953','2024-06-26 12:45:06.338954',1753,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2348,'classify-fields',2,'2024-06-26 12:45:06.346506','2024-06-26 12:45:06.455470',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2349,'classify-tables',2,'2024-06-26 12:45:06.463243','2024-06-26 12:45:06.475965',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2350,'field values scanning',2,'2024-06-26 13:00:00.046871','2024-06-26 13:00:10.960375',10913,NULL,'success'),(2351,'delete-expired-advanced-field-values',2,'2024-06-26 13:00:00.056591','2024-06-26 13:00:02.788767',2732,'{\"deleted\":0}','success'),(2352,'update-field-values',2,'2024-06-26 13:00:02.795537','2024-06-26 13:00:10.953270',8157,'{\"errors\":0,\"created\":0,\"updated\":34,\"deleted\":0}','success'),(2353,'sync',2,'2024-06-26 13:45:00.101191','2024-06-26 13:45:04.152096',4050,NULL,'success'),(2354,'sync-dbms-version',2,'2024-06-26 13:45:00.109491','2024-06-26 13:45:00.122388',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2355,'sync-timezone',2,'2024-06-26 13:45:00.130465','2024-06-26 13:45:00.142058',11,'{\"timezone-id\":\"+08:00\"}','success'),(2356,'sync-tables',2,'2024-06-26 13:45:00.151196','2024-06-26 13:45:00.178290',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2357,'sync-fields',2,'2024-06-26 13:45:00.186706','2024-06-26 13:45:03.030542',2843,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2358,'sync-fks',2,'2024-06-26 13:45:03.038454','2024-06-26 13:45:03.599781',561,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2359,'sync-indexes',2,'2024-06-26 13:45:03.607812','2024-06-26 13:45:04.112374',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2360,'sync-metabase-metadata',2,'2024-06-26 13:45:04.119943','2024-06-26 13:45:04.128057',8,'{}','success'),(2361,'sync-table-privileges',2,'2024-06-26 13:45:04.136223','2024-06-26 13:45:04.143696',7,NULL,'success'),(2362,'analyze',2,'2024-06-26 13:45:04.175436','2024-06-26 13:45:06.054195',1878,NULL,'success'),(2363,'fingerprint-fields',2,'2024-06-26 13:45:04.183050','2024-06-26 13:45:05.911381',1728,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2364,'classify-fields',2,'2024-06-26 13:45:05.920005','2024-06-26 13:45:06.023894',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2365,'classify-tables',2,'2024-06-26 13:45:06.031532','2024-06-26 13:45:06.044526',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2366,'sync',2,'2024-06-26 14:45:00.094876','2024-06-26 14:45:04.475240',4380,NULL,'success'),(2367,'sync-dbms-version',2,'2024-06-26 14:45:00.103503','2024-06-26 14:45:00.114466',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2368,'sync-timezone',2,'2024-06-26 14:45:00.122399','2024-06-26 14:45:00.133437',11,'{\"timezone-id\":\"+08:00\"}','success'),(2369,'sync-tables',2,'2024-06-26 14:45:00.143155','2024-06-26 14:45:00.173266',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2370,'sync-fields',2,'2024-06-26 14:45:00.183135','2024-06-26 14:45:03.225573',3042,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2371,'sync-fks',2,'2024-06-26 14:45:03.234205','2024-06-26 14:45:03.922823',688,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2372,'sync-indexes',2,'2024-06-26 14:45:03.931788','2024-06-26 14:45:04.434754',502,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2373,'sync-metabase-metadata',2,'2024-06-26 14:45:04.442391','2024-06-26 14:45:04.450746',8,'{}','success'),(2374,'sync-table-privileges',2,'2024-06-26 14:45:04.459104','2024-06-26 14:45:04.467351',8,NULL,'success'),(2375,'analyze',2,'2024-06-26 14:45:04.500225','2024-06-26 14:45:06.442137',1941,NULL,'success'),(2376,'fingerprint-fields',2,'2024-06-26 14:45:04.508696','2024-06-26 14:45:06.296844',1788,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2377,'classify-fields',2,'2024-06-26 14:45:06.305109','2024-06-26 14:45:06.413296',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2378,'classify-tables',2,'2024-06-26 14:45:06.420576','2024-06-26 14:45:06.433963',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2379,'sync',2,'2024-06-26 15:45:00.100653','2024-06-26 15:45:04.244003',4143,NULL,'success'),(2380,'sync-dbms-version',2,'2024-06-26 15:45:00.109969','2024-06-26 15:45:00.119905',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2381,'sync-timezone',2,'2024-06-26 15:45:00.128372','2024-06-26 15:45:00.139565',11,'{\"timezone-id\":\"+08:00\"}','success'),(2382,'sync-tables',2,'2024-06-26 15:45:00.149163','2024-06-26 15:45:00.177058',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2383,'sync-fields',2,'2024-06-26 15:45:00.185958','2024-06-26 15:45:03.006368',2820,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2384,'sync-fks',2,'2024-06-26 15:45:03.015139','2024-06-26 15:45:03.652503',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2385,'sync-indexes',2,'2024-06-26 15:45:03.661412','2024-06-26 15:45:04.204223',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2386,'sync-metabase-metadata',2,'2024-06-26 15:45:04.212015','2024-06-26 15:45:04.220081',8,'{}','success'),(2387,'sync-table-privileges',2,'2024-06-26 15:45:04.227726','2024-06-26 15:45:04.236137',8,NULL,'success'),(2388,'analyze',2,'2024-06-26 15:45:04.267729','2024-06-26 15:45:06.165689',1897,NULL,'success'),(2389,'fingerprint-fields',2,'2024-06-26 15:45:04.275723','2024-06-26 15:45:06.006992',1731,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2390,'classify-fields',2,'2024-06-26 15:45:06.015617','2024-06-26 15:45:06.135103',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2391,'classify-tables',2,'2024-06-26 15:45:06.142561','2024-06-26 15:45:06.157163',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2392,'task-history-cleanup',NULL,'2024-06-26 16:00:00.024571','2024-06-26 16:00:00.051948',27,NULL,'success'),(2393,'task-history-cleanup',NULL,'2024-06-26 16:00:00.081374','2024-06-26 16:00:00.095769',14,NULL,'success'),(2394,'sync',2,'2024-06-26 16:45:00.107897','2024-06-26 16:45:04.299110',4191,NULL,'success'),(2395,'sync-dbms-version',2,'2024-06-26 16:45:00.115983','2024-06-26 16:45:00.125297',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2396,'sync-timezone',2,'2024-06-26 16:45:00.133116','2024-06-26 16:45:00.142652',9,'{\"timezone-id\":\"+08:00\"}','success'),(2397,'sync-tables',2,'2024-06-26 16:45:00.150105','2024-06-26 16:45:00.178106',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2398,'sync-fields',2,'2024-06-26 16:45:00.186261','2024-06-26 16:45:03.026613',2840,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2399,'sync-fks',2,'2024-06-26 16:45:03.034812','2024-06-26 16:45:03.678999',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2400,'sync-indexes',2,'2024-06-26 16:45:03.688569','2024-06-26 16:45:04.254932',566,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2401,'sync-metabase-metadata',2,'2024-06-26 16:45:04.262707','2024-06-26 16:45:04.271544',8,'{}','success'),(2402,'sync-table-privileges',2,'2024-06-26 16:45:04.280618','2024-06-26 16:45:04.290217',9,NULL,'success'),(2403,'analyze',2,'2024-06-26 16:45:04.327404','2024-06-26 16:45:06.244327',1916,NULL,'success'),(2404,'fingerprint-fields',2,'2024-06-26 16:45:04.336057','2024-06-26 16:45:06.096863',1760,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2405,'classify-fields',2,'2024-06-26 16:45:06.105091','2024-06-26 16:45:06.211734',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2406,'classify-tables',2,'2024-06-26 16:45:06.219445','2024-06-26 16:45:06.235781',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2407,'sync',2,'2024-06-26 17:45:00.118773','2024-06-26 17:45:04.702330',4583,NULL,'success'),(2408,'sync-dbms-version',2,'2024-06-26 17:45:00.128247','2024-06-26 17:45:00.138355',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2409,'sync-timezone',2,'2024-06-26 17:45:00.147680','2024-06-26 17:45:00.158292',10,'{\"timezone-id\":\"+08:00\"}','success'),(2410,'sync-tables',2,'2024-06-26 17:45:00.167065','2024-06-26 17:45:00.195478',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2411,'sync-fields',2,'2024-06-26 17:45:00.204176','2024-06-26 17:45:03.382759',3178,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2412,'sync-fks',2,'2024-06-26 17:45:03.391226','2024-06-26 17:45:04.073994',682,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2413,'sync-indexes',2,'2024-06-26 17:45:04.082762','2024-06-26 17:45:04.656292',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2414,'sync-metabase-metadata',2,'2024-06-26 17:45:04.666529','2024-06-26 17:45:04.676861',10,'{}','success'),(2415,'sync-table-privileges',2,'2024-06-26 17:45:04.685902','2024-06-26 17:45:04.694146',8,NULL,'success'),(2416,'analyze',2,'2024-06-26 17:45:04.727057','2024-06-26 17:45:06.806993',2079,NULL,'success'),(2417,'fingerprint-fields',2,'2024-06-26 17:45:04.736939','2024-06-26 17:45:06.648118',1911,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2418,'classify-fields',2,'2024-06-26 17:45:06.657499','2024-06-26 17:45:06.776189',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2419,'classify-tables',2,'2024-06-26 17:45:06.784998','2024-06-26 17:45:06.798246',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2420,'sync',2,'2024-06-26 18:45:00.118301','2024-06-26 18:45:04.709060',4590,NULL,'success'),(2421,'sync-dbms-version',2,'2024-06-26 18:45:00.127901','2024-06-26 18:45:00.137310',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2422,'sync-timezone',2,'2024-06-26 18:45:00.146481','2024-06-26 18:45:00.157323',10,'{\"timezone-id\":\"+08:00\"}','success'),(2423,'sync-tables',2,'2024-06-26 18:45:00.166354','2024-06-26 18:45:00.195981',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2424,'sync-fields',2,'2024-06-26 18:45:00.205418','2024-06-26 18:45:03.361375',3155,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2425,'sync-fks',2,'2024-06-26 18:45:03.369776','2024-06-26 18:45:04.040852',671,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2426,'sync-indexes',2,'2024-06-26 18:45:04.049517','2024-06-26 18:45:04.662127',612,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2427,'sync-metabase-metadata',2,'2024-06-26 18:45:04.671411','2024-06-26 18:45:04.681529',10,'{}','success'),(2428,'sync-table-privileges',2,'2024-06-26 18:45:04.690716','2024-06-26 18:45:04.700208',9,NULL,'success'),(2429,'analyze',2,'2024-06-26 18:45:04.737847','2024-06-26 18:45:06.857258',2119,NULL,'success'),(2430,'fingerprint-fields',2,'2024-06-26 18:45:04.748272','2024-06-26 18:45:06.706747',1958,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2431,'classify-fields',2,'2024-06-26 18:45:06.715069','2024-06-26 18:45:06.829257',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2432,'classify-tables',2,'2024-06-26 18:45:06.836621','2024-06-26 18:45:06.849483',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2433,'sync',2,'2024-06-26 19:45:00.117190','2024-06-26 19:45:04.857942',4740,NULL,'success'),(2434,'sync-dbms-version',2,'2024-06-26 19:45:00.126324','2024-06-26 19:45:00.135449',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2435,'sync-timezone',2,'2024-06-26 19:45:00.144870','2024-06-26 19:45:00.155714',10,'{\"timezone-id\":\"+08:00\"}','success'),(2436,'sync-tables',2,'2024-06-26 19:45:00.165149','2024-06-26 19:45:00.194299',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2437,'sync-fields',2,'2024-06-26 19:45:00.203340','2024-06-26 19:45:03.408606',3205,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2438,'sync-fks',2,'2024-06-26 19:45:03.417556','2024-06-26 19:45:04.164739',747,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2439,'sync-indexes',2,'2024-06-26 19:45:04.173245','2024-06-26 19:45:04.811054',637,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2440,'sync-metabase-metadata',2,'2024-06-26 19:45:04.819973','2024-06-26 19:45:04.829042',9,'{}','success'),(2441,'sync-table-privileges',2,'2024-06-26 19:45:04.838366','2024-06-26 19:45:04.848214',9,NULL,'success'),(2442,'analyze',2,'2024-06-26 19:45:04.885345','2024-06-26 19:45:07.116497',2231,NULL,'success'),(2443,'fingerprint-fields',2,'2024-06-26 19:45:04.895234','2024-06-26 19:45:06.942120',2046,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2444,'classify-fields',2,'2024-06-26 19:45:06.951126','2024-06-26 19:45:07.086520',135,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2445,'classify-tables',2,'2024-06-26 19:45:07.093963','2024-06-26 19:45:07.107986',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2446,'sync',2,'2024-06-26 20:45:00.122998','2024-06-26 20:45:05.001001',4878,NULL,'success'),(2447,'sync-dbms-version',2,'2024-06-26 20:45:00.133135','2024-06-26 20:45:00.143322',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2448,'sync-timezone',2,'2024-06-26 20:45:00.151850','2024-06-26 20:45:00.163111',11,'{\"timezone-id\":\"+08:00\"}','success'),(2449,'sync-tables',2,'2024-06-26 20:45:00.172266','2024-06-26 20:45:00.203431',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2450,'sync-fields',2,'2024-06-26 20:45:00.212926','2024-06-26 20:45:03.570691',3357,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2451,'sync-fks',2,'2024-06-26 20:45:03.580050','2024-06-26 20:45:04.312569',732,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2452,'sync-indexes',2,'2024-06-26 20:45:04.321789','2024-06-26 20:45:04.959186',637,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2453,'sync-metabase-metadata',2,'2024-06-26 20:45:04.966863','2024-06-26 20:45:04.974872',8,'{}','success'),(2454,'sync-table-privileges',2,'2024-06-26 20:45:04.983303','2024-06-26 20:45:04.992204',8,NULL,'success'),(2455,'analyze',2,'2024-06-26 20:45:05.028132','2024-06-26 20:45:07.180081',2151,NULL,'success'),(2456,'fingerprint-fields',2,'2024-06-26 20:45:05.037867','2024-06-26 20:45:07.003655',1965,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2457,'classify-fields',2,'2024-06-26 20:45:07.013118','2024-06-26 20:45:07.147879',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2458,'classify-tables',2,'2024-06-26 20:45:07.156165','2024-06-26 20:45:07.171381',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2459,'sync',2,'2024-06-26 21:45:00.096862','2024-06-26 21:45:04.839652',4742,NULL,'success'),(2460,'sync-dbms-version',2,'2024-06-26 21:45:00.105648','2024-06-26 21:45:00.115853',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2461,'sync-timezone',2,'2024-06-26 21:45:00.125828','2024-06-26 21:45:00.136052',10,'{\"timezone-id\":\"+08:00\"}','success'),(2462,'sync-tables',2,'2024-06-26 21:45:00.144459','2024-06-26 21:45:00.171506',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2463,'sync-fields',2,'2024-06-26 21:45:00.180324','2024-06-26 21:45:03.466781',3286,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2464,'sync-fks',2,'2024-06-26 21:45:03.476302','2024-06-26 21:45:04.156647',680,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2465,'sync-indexes',2,'2024-06-26 21:45:04.165468','2024-06-26 21:45:04.790648',625,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2466,'sync-metabase-metadata',2,'2024-06-26 21:45:04.799138','2024-06-26 21:45:04.809261',10,'{}','success'),(2467,'sync-table-privileges',2,'2024-06-26 21:45:04.818736','2024-06-26 21:45:04.830317',11,NULL,'success'),(2468,'analyze',2,'2024-06-26 21:45:04.872032','2024-06-26 21:45:07.135038',2263,NULL,'success'),(2469,'fingerprint-fields',2,'2024-06-26 21:45:04.882351','2024-06-26 21:45:06.967731',2085,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2470,'classify-fields',2,'2024-06-26 21:45:06.977749','2024-06-26 21:45:07.100989',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2471,'classify-tables',2,'2024-06-26 21:45:07.109327','2024-06-26 21:45:07.126549',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2472,'sync',2,'2024-06-26 22:45:00.112171','2024-06-26 22:45:04.462620',4350,NULL,'success'),(2473,'sync-dbms-version',2,'2024-06-26 22:45:00.121103','2024-06-26 22:45:00.130857',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2474,'sync-timezone',2,'2024-06-26 22:45:00.139831','2024-06-26 22:45:00.152046',12,'{\"timezone-id\":\"+08:00\"}','success'),(2475,'sync-tables',2,'2024-06-26 22:45:00.160766','2024-06-26 22:45:00.189054',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2476,'sync-fields',2,'2024-06-26 22:45:00.197889','2024-06-26 22:45:03.158404',2960,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2477,'sync-fks',2,'2024-06-26 22:45:03.167513','2024-06-26 22:45:03.777478',609,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2478,'sync-indexes',2,'2024-06-26 22:45:03.786203','2024-06-26 22:45:04.417597',631,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2479,'sync-metabase-metadata',2,'2024-06-26 22:45:04.426342','2024-06-26 22:45:04.435960',9,'{}','success'),(2480,'sync-table-privileges',2,'2024-06-26 22:45:04.444396','2024-06-26 22:45:04.454163',9,NULL,'success'),(2481,'analyze',2,'2024-06-26 22:45:04.488032','2024-06-26 22:45:06.756830',2268,NULL,'success'),(2482,'fingerprint-fields',2,'2024-06-26 22:45:04.496292','2024-06-26 22:45:06.591668',2095,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2483,'classify-fields',2,'2024-06-26 22:45:06.600614','2024-06-26 22:45:06.722000',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2484,'classify-tables',2,'2024-06-26 22:45:06.729915','2024-06-26 22:45:06.746840',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2485,'sync',2,'2024-06-26 23:45:00.108965','2024-06-26 23:45:04.689088',4580,NULL,'success'),(2486,'sync-dbms-version',2,'2024-06-26 23:45:00.118509','2024-06-26 23:45:00.128093',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2487,'sync-timezone',2,'2024-06-26 23:45:00.137416','2024-06-26 23:45:00.147737',10,'{\"timezone-id\":\"+08:00\"}','success'),(2488,'sync-tables',2,'2024-06-26 23:45:00.158746','2024-06-26 23:45:00.189101',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2489,'sync-fields',2,'2024-06-26 23:45:00.198094','2024-06-26 23:45:03.366093',3168,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2490,'sync-fks',2,'2024-06-26 23:45:03.375060','2024-06-26 23:45:04.008040',632,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2491,'sync-indexes',2,'2024-06-26 23:45:04.018430','2024-06-26 23:45:04.641938',623,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2492,'sync-metabase-metadata',2,'2024-06-26 23:45:04.650217','2024-06-26 23:45:04.659965',9,'{}','success'),(2493,'sync-table-privileges',2,'2024-06-26 23:45:04.669754','2024-06-26 23:45:04.679787',10,NULL,'success'),(2494,'analyze',2,'2024-06-26 23:45:04.714688','2024-06-26 23:45:06.951146',2236,NULL,'success'),(2495,'fingerprint-fields',2,'2024-06-26 23:45:04.722385','2024-06-26 23:45:06.772323',2049,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2496,'classify-fields',2,'2024-06-26 23:45:06.781547','2024-06-26 23:45:06.919183',137,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2497,'classify-tables',2,'2024-06-26 23:45:06.927853','2024-06-26 23:45:06.942158',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2498,'sync',2,'2024-06-27 00:45:00.108978','2024-06-27 00:45:04.379820',4270,NULL,'success'),(2499,'sync-dbms-version',2,'2024-06-27 00:45:00.117661','2024-06-27 00:45:00.126843',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2500,'sync-timezone',2,'2024-06-27 00:45:00.135715','2024-06-27 00:45:00.150251',14,'{\"timezone-id\":\"+08:00\"}','success'),(2501,'sync-tables',2,'2024-06-27 00:45:00.160033','2024-06-27 00:45:00.185238',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2502,'sync-fields',2,'2024-06-27 00:45:00.194486','2024-06-27 00:45:03.062948',2868,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2503,'sync-fks',2,'2024-06-27 00:45:03.070770','2024-06-27 00:45:03.778407',707,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2504,'sync-indexes',2,'2024-06-27 00:45:03.787109','2024-06-27 00:45:04.328669',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2505,'sync-metabase-metadata',2,'2024-06-27 00:45:04.336767','2024-06-27 00:45:04.345317',8,'{}','success'),(2506,'sync-table-privileges',2,'2024-06-27 00:45:04.355389','2024-06-27 00:45:04.370416',15,NULL,'success'),(2507,'analyze',2,'2024-06-27 00:45:04.407253','2024-06-27 00:45:06.573938',2166,NULL,'success'),(2508,'fingerprint-fields',2,'2024-06-27 00:45:04.416422','2024-06-27 00:45:06.411392',1994,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2509,'classify-fields',2,'2024-06-27 00:45:06.419837','2024-06-27 00:45:06.542754',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2510,'classify-tables',2,'2024-06-27 00:45:06.550882','2024-06-27 00:45:06.565364',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2511,'sync',2,'2024-06-27 01:45:00.116385','2024-06-27 01:45:04.684161',4567,NULL,'success'),(2512,'sync-dbms-version',2,'2024-06-27 01:45:00.125170','2024-06-27 01:45:00.135346',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2513,'sync-timezone',2,'2024-06-27 01:45:00.143989','2024-06-27 01:45:00.155237',11,'{\"timezone-id\":\"+08:00\"}','success'),(2514,'sync-tables',2,'2024-06-27 01:45:00.164552','2024-06-27 01:45:00.198200',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2515,'sync-fields',2,'2024-06-27 01:45:00.208358','2024-06-27 01:45:03.399173',3190,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2516,'sync-fks',2,'2024-06-27 01:45:03.406802','2024-06-27 01:45:04.060990',654,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2517,'sync-indexes',2,'2024-06-27 01:45:04.069287','2024-06-27 01:45:04.639823',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2518,'sync-metabase-metadata',2,'2024-06-27 01:45:04.647734','2024-06-27 01:45:04.657127',9,'{}','success'),(2519,'sync-table-privileges',2,'2024-06-27 01:45:04.665788','2024-06-27 01:45:04.675079',9,NULL,'success'),(2520,'analyze',2,'2024-06-27 01:45:04.709642','2024-06-27 01:45:07.118725',2409,NULL,'success'),(2521,'fingerprint-fields',2,'2024-06-27 01:45:04.717500','2024-06-27 01:45:06.938631',2221,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2522,'classify-fields',2,'2024-06-27 01:45:06.947910','2024-06-27 01:45:07.083042',135,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2523,'classify-tables',2,'2024-06-27 01:45:07.092230','2024-06-27 01:45:07.109316',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2524,'sync',2,'2024-06-27 02:45:00.108821','2024-06-27 02:45:04.726236',4617,NULL,'success'),(2525,'sync-dbms-version',2,'2024-06-27 02:45:00.117729','2024-06-27 02:45:00.128373',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2526,'sync-timezone',2,'2024-06-27 02:45:00.138321','2024-06-27 02:45:00.150139',11,'{\"timezone-id\":\"+08:00\"}','success'),(2527,'sync-tables',2,'2024-06-27 02:45:00.159246','2024-06-27 02:45:00.186363',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2528,'sync-fields',2,'2024-06-27 02:45:00.214074','2024-06-27 02:45:03.412230',3198,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2529,'sync-fks',2,'2024-06-27 02:45:03.421933','2024-06-27 02:45:04.073654',651,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2530,'sync-indexes',2,'2024-06-27 02:45:04.082014','2024-06-27 02:45:04.676298',594,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2531,'sync-metabase-metadata',2,'2024-06-27 02:45:04.685262','2024-06-27 02:45:04.695599',10,'{}','success'),(2532,'sync-table-privileges',2,'2024-06-27 02:45:04.706711','2024-06-27 02:45:04.716070',9,NULL,'success'),(2533,'analyze',2,'2024-06-27 02:45:04.759965','2024-06-27 02:45:07.127608',2367,NULL,'success'),(2534,'fingerprint-fields',2,'2024-06-27 02:45:04.770598','2024-06-27 02:45:06.979081',2208,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2535,'classify-fields',2,'2024-06-27 02:45:06.987669','2024-06-27 02:45:07.098653',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2536,'classify-tables',2,'2024-06-27 02:45:07.106253','2024-06-27 02:45:07.119484',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2537,'sync',2,'2024-06-27 03:45:00.112039','2024-06-27 03:45:04.706419',4594,NULL,'success'),(2538,'sync-dbms-version',2,'2024-06-27 03:45:00.121212','2024-06-27 03:45:00.132127',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2539,'sync-timezone',2,'2024-06-27 03:45:00.141599','2024-06-27 03:45:00.153840',12,'{\"timezone-id\":\"+08:00\"}','success'),(2540,'sync-tables',2,'2024-06-27 03:45:00.163458','2024-06-27 03:45:00.198095',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2541,'sync-fields',2,'2024-06-27 03:45:00.222027','2024-06-27 03:45:03.451206',3229,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2542,'sync-fks',2,'2024-06-27 03:45:03.460495','2024-06-27 03:45:04.129482',669,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2543,'sync-indexes',2,'2024-06-27 03:45:04.139018','2024-06-27 03:45:04.661801',522,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2544,'sync-metabase-metadata',2,'2024-06-27 03:45:04.669970','2024-06-27 03:45:04.679795',9,'{}','success'),(2545,'sync-table-privileges',2,'2024-06-27 03:45:04.688497','2024-06-27 03:45:04.697435',8,NULL,'success'),(2546,'analyze',2,'2024-06-27 03:45:04.733775','2024-06-27 03:45:06.923519',2189,NULL,'success'),(2547,'fingerprint-fields',2,'2024-06-27 03:45:04.741978','2024-06-27 03:45:06.773104',2031,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2548,'classify-fields',2,'2024-06-27 03:45:06.781872','2024-06-27 03:45:06.896707',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2549,'classify-tables',2,'2024-06-27 03:45:06.903816','2024-06-27 03:45:06.915821',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2550,'task-history-cleanup',NULL,'2024-06-27 04:00:00.074533','2024-06-27 04:00:00.085962',11,NULL,'success'),(2551,'sync',2,'2024-06-27 04:45:00.117071','2024-06-27 04:45:04.859424',4742,NULL,'success'),(2552,'sync-dbms-version',2,'2024-06-27 04:45:00.125387','2024-06-27 04:45:00.135007',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2553,'sync-timezone',2,'2024-06-27 04:45:00.144319','2024-06-27 04:45:00.154773',10,'{\"timezone-id\":\"+08:00\"}','success'),(2554,'sync-tables',2,'2024-06-27 04:45:00.165469','2024-06-27 04:45:00.194996',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2555,'sync-fields',2,'2024-06-27 04:45:00.203745','2024-06-27 04:45:03.594461',3390,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2556,'sync-fks',2,'2024-06-27 04:45:03.603863','2024-06-27 04:45:04.281820',677,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2557,'sync-indexes',2,'2024-06-27 04:45:04.290413','2024-06-27 04:45:04.814008',523,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2558,'sync-metabase-metadata',2,'2024-06-27 04:45:04.824091','2024-06-27 04:45:04.833626',9,'{}','success'),(2559,'sync-table-privileges',2,'2024-06-27 04:45:04.842696','2024-06-27 04:45:04.851379',8,NULL,'success'),(2560,'analyze',2,'2024-06-27 04:45:04.886147','2024-06-27 04:45:06.983963',2097,NULL,'success'),(2561,'fingerprint-fields',2,'2024-06-27 04:45:04.897555','2024-06-27 04:45:06.831195',1933,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2562,'classify-fields',2,'2024-06-27 04:45:06.839550','2024-06-27 04:45:06.953597',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2563,'classify-tables',2,'2024-06-27 04:45:06.961794','2024-06-27 04:45:06.975300',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2564,'sync',2,'2024-06-27 05:45:00.089155','2024-06-27 05:45:04.950278',4861,NULL,'success'),(2565,'sync-dbms-version',2,'2024-06-27 05:45:00.098894','2024-06-27 05:45:00.109252',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2566,'sync-timezone',2,'2024-06-27 05:45:00.120294','2024-06-27 05:45:00.132972',12,'{\"timezone-id\":\"+08:00\"}','success'),(2567,'sync-tables',2,'2024-06-27 05:45:00.141977','2024-06-27 05:45:00.171280',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2568,'sync-fields',2,'2024-06-27 05:45:00.180475','2024-06-27 05:45:03.500951',3320,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2569,'sync-fks',2,'2024-06-27 05:45:03.509687','2024-06-27 05:45:04.266617',756,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2570,'sync-indexes',2,'2024-06-27 05:45:04.276574','2024-06-27 05:45:04.903895',627,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2571,'sync-metabase-metadata',2,'2024-06-27 05:45:04.913170','2024-06-27 05:45:04.923194',10,'{}','success'),(2572,'sync-table-privileges',2,'2024-06-27 05:45:04.931989','2024-06-27 05:45:04.940888',8,NULL,'success'),(2573,'analyze',2,'2024-06-27 05:45:04.976407','2024-06-27 05:45:07.098578',2122,NULL,'success'),(2574,'fingerprint-fields',2,'2024-06-27 05:45:04.985610','2024-06-27 05:45:06.945973',1960,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2575,'classify-fields',2,'2024-06-27 05:45:06.956058','2024-06-27 05:45:07.069333',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2576,'classify-tables',2,'2024-06-27 05:45:07.076788','2024-06-27 05:45:07.089904',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2577,'sync',2,'2024-06-27 06:45:00.103907','2024-06-27 06:45:04.213599',4109,NULL,'success'),(2578,'sync-dbms-version',2,'2024-06-27 06:45:00.113555','2024-06-27 06:45:00.123177',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2579,'sync-timezone',2,'2024-06-27 06:45:00.131837','2024-06-27 06:45:00.142635',10,'{\"timezone-id\":\"+08:00\"}','success'),(2580,'sync-tables',2,'2024-06-27 06:45:00.150961','2024-06-27 06:45:00.176560',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2581,'sync-fields',2,'2024-06-27 06:45:00.185477','2024-06-27 06:45:03.026939',2841,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2582,'sync-fks',2,'2024-06-27 06:45:03.033880','2024-06-27 06:45:03.588018',554,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2583,'sync-indexes',2,'2024-06-27 06:45:03.597345','2024-06-27 06:45:04.171254',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2584,'sync-metabase-metadata',2,'2024-06-27 06:45:04.180578','2024-06-27 06:45:04.188485',7,'{}','success'),(2585,'sync-table-privileges',2,'2024-06-27 06:45:04.196922','2024-06-27 06:45:04.204854',7,NULL,'success'),(2586,'analyze',2,'2024-06-27 06:45:04.239756','2024-06-27 06:45:06.214562',1974,NULL,'success'),(2587,'fingerprint-fields',2,'2024-06-27 06:45:04.248484','2024-06-27 06:45:06.045481',1796,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2588,'classify-fields',2,'2024-06-27 06:45:06.054146','2024-06-27 06:45:06.180544',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2589,'classify-tables',2,'2024-06-27 06:45:06.188892','2024-06-27 06:45:06.204946',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2590,'sync',2,'2024-06-27 07:45:00.100556','2024-06-27 07:45:04.414763',4314,NULL,'success'),(2591,'sync-dbms-version',2,'2024-06-27 07:45:00.108368','2024-06-27 07:45:00.117034',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2592,'sync-timezone',2,'2024-06-27 07:45:00.126367','2024-06-27 07:45:00.137634',11,'{\"timezone-id\":\"+08:00\"}','success'),(2593,'sync-tables',2,'2024-06-27 07:45:00.146050','2024-06-27 07:45:00.178577',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2594,'sync-fields',2,'2024-06-27 07:45:00.187324','2024-06-27 07:45:03.221701',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2595,'sync-fks',2,'2024-06-27 07:45:03.231133','2024-06-27 07:45:03.856803',625,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2596,'sync-indexes',2,'2024-06-27 07:45:03.864733','2024-06-27 07:45:04.372317',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2597,'sync-metabase-metadata',2,'2024-06-27 07:45:04.380351','2024-06-27 07:45:04.389181',8,'{}','success'),(2598,'sync-table-privileges',2,'2024-06-27 07:45:04.398607','2024-06-27 07:45:04.406364',7,NULL,'success'),(2599,'analyze',2,'2024-06-27 07:45:04.441340','2024-06-27 07:45:06.405843',1964,NULL,'success'),(2600,'fingerprint-fields',2,'2024-06-27 07:45:04.450701','2024-06-27 07:45:06.254879',1804,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2601,'classify-fields',2,'2024-06-27 07:45:06.263358','2024-06-27 07:45:06.378358',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2602,'classify-tables',2,'2024-06-27 07:45:06.385507','2024-06-27 07:45:06.398146',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2603,'sync',2,'2024-06-27 08:45:00.107789','2024-06-27 08:45:04.462428',4354,NULL,'success'),(2604,'sync-dbms-version',2,'2024-06-27 08:45:00.116290','2024-06-27 08:45:00.126090',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2605,'sync-timezone',2,'2024-06-27 08:45:00.136127','2024-06-27 08:45:00.147709',11,'{\"timezone-id\":\"+08:00\"}','success'),(2606,'sync-tables',2,'2024-06-27 08:45:00.156676','2024-06-27 08:45:00.188091',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2607,'sync-fields',2,'2024-06-27 08:45:00.196764','2024-06-27 08:45:03.234822',3038,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2608,'sync-fks',2,'2024-06-27 08:45:03.242602','2024-06-27 08:45:03.905212',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2609,'sync-indexes',2,'2024-06-27 08:45:03.914333','2024-06-27 08:45:04.421643',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2610,'sync-metabase-metadata',2,'2024-06-27 08:45:04.429101','2024-06-27 08:45:04.437244',8,'{}','success'),(2611,'sync-table-privileges',2,'2024-06-27 08:45:04.444488','2024-06-27 08:45:04.452235',7,NULL,'success'),(2612,'analyze',2,'2024-06-27 08:45:04.487499','2024-06-27 08:45:06.649473',2161,NULL,'success'),(2613,'fingerprint-fields',2,'2024-06-27 08:45:04.496531','2024-06-27 08:45:06.411752',1915,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2614,'classify-fields',2,'2024-06-27 08:45:06.424200','2024-06-27 08:45:06.619913',195,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2615,'classify-tables',2,'2024-06-27 08:45:06.628363','2024-06-27 08:45:06.641734',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2616,'sync',2,'2024-06-27 09:45:00.102235','2024-06-27 09:45:04.436632',4334,NULL,'success'),(2617,'sync-dbms-version',2,'2024-06-27 09:45:00.110453','2024-06-27 09:45:00.118973',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2618,'sync-timezone',2,'2024-06-27 09:45:00.127612','2024-06-27 09:45:00.137216',9,'{\"timezone-id\":\"+08:00\"}','success'),(2619,'sync-tables',2,'2024-06-27 09:45:00.145783','2024-06-27 09:45:00.178985',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2620,'sync-fields',2,'2024-06-27 09:45:00.187916','2024-06-27 09:45:03.331563',3143,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2621,'sync-fks',2,'2024-06-27 09:45:03.339202','2024-06-27 09:45:03.906979',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2622,'sync-indexes',2,'2024-06-27 09:45:03.917605','2024-06-27 09:45:04.395554',477,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2623,'sync-metabase-metadata',2,'2024-06-27 09:45:04.402896','2024-06-27 09:45:04.410678',7,'{}','success'),(2624,'sync-table-privileges',2,'2024-06-27 09:45:04.419194','2024-06-27 09:45:04.428721',9,NULL,'success'),(2625,'analyze',2,'2024-06-27 09:45:04.461461','2024-06-27 09:45:06.401608',1940,NULL,'success'),(2626,'fingerprint-fields',2,'2024-06-27 09:45:04.469231','2024-06-27 09:45:06.268539',1799,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2627,'classify-fields',2,'2024-06-27 09:45:06.276255','2024-06-27 09:45:06.374030',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2628,'classify-tables',2,'2024-06-27 09:45:06.381234','2024-06-27 09:45:06.394299',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2629,'sync',2,'2024-06-27 10:45:00.118034','2024-06-27 10:45:04.326224',4208,NULL,'success'),(2630,'sync-dbms-version',2,'2024-06-27 10:45:00.126598','2024-06-27 10:45:00.137650',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2631,'sync-timezone',2,'2024-06-27 10:45:00.146575','2024-06-27 10:45:00.157427',10,'{\"timezone-id\":\"+08:00\"}','success'),(2632,'sync-tables',2,'2024-06-27 10:45:00.166914','2024-06-27 10:45:00.193032',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2633,'sync-fields',2,'2024-06-27 10:45:00.202025','2024-06-27 10:45:03.050007',2847,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2634,'sync-fks',2,'2024-06-27 10:45:03.057475','2024-06-27 10:45:03.647662',590,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2635,'sync-indexes',2,'2024-06-27 10:45:03.655698','2024-06-27 10:45:04.283674',627,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2636,'sync-metabase-metadata',2,'2024-06-27 10:45:04.291922','2024-06-27 10:45:04.300292',8,'{}','success'),(2637,'sync-table-privileges',2,'2024-06-27 10:45:04.309354','2024-06-27 10:45:04.318104',8,NULL,'success'),(2638,'analyze',2,'2024-06-27 10:45:04.351319','2024-06-27 10:45:06.400771',2049,NULL,'success'),(2639,'fingerprint-fields',2,'2024-06-27 10:45:04.359424','2024-06-27 10:45:06.255767',1896,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2640,'classify-fields',2,'2024-06-27 10:45:06.263963','2024-06-27 10:45:06.372538',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2641,'classify-tables',2,'2024-06-27 10:45:06.379902','2024-06-27 10:45:06.393130',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2642,'sync',2,'2024-06-27 11:45:00.097996','2024-06-27 11:45:04.268687',4170,NULL,'success'),(2643,'sync-dbms-version',2,'2024-06-27 11:45:00.106877','2024-06-27 11:45:00.116112',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2644,'sync-timezone',2,'2024-06-27 11:45:00.124917','2024-06-27 11:45:00.136322',11,'{\"timezone-id\":\"+08:00\"}','success'),(2645,'sync-tables',2,'2024-06-27 11:45:00.144565','2024-06-27 11:45:00.172549',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2646,'sync-fields',2,'2024-06-27 11:45:00.180945','2024-06-27 11:45:03.095575',2914,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2647,'sync-fks',2,'2024-06-27 11:45:03.108718','2024-06-27 11:45:03.689765',581,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2648,'sync-indexes',2,'2024-06-27 11:45:03.697635','2024-06-27 11:45:04.225225',527,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2649,'sync-metabase-metadata',2,'2024-06-27 11:45:04.233556','2024-06-27 11:45:04.242270',8,'{}','success'),(2650,'sync-table-privileges',2,'2024-06-27 11:45:04.251453','2024-06-27 11:45:04.260479',9,NULL,'success'),(2651,'analyze',2,'2024-06-27 11:45:04.293221','2024-06-27 11:45:06.444999',2151,NULL,'success'),(2652,'fingerprint-fields',2,'2024-06-27 11:45:04.301088','2024-06-27 11:45:06.299494',1998,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2653,'classify-fields',2,'2024-06-27 11:45:06.308964','2024-06-27 11:45:06.415786',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2654,'classify-tables',2,'2024-06-27 11:45:06.423315','2024-06-27 11:45:06.436978',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2655,'sync',2,'2024-06-27 12:45:00.098173','2024-06-27 12:45:04.883039',4784,NULL,'success'),(2656,'sync-dbms-version',2,'2024-06-27 12:45:00.106359','2024-06-27 12:45:00.114480',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2657,'sync-timezone',2,'2024-06-27 12:45:00.123102','2024-06-27 12:45:00.133571',10,'{\"timezone-id\":\"+08:00\"}','success'),(2658,'sync-tables',2,'2024-06-27 12:45:00.142034','2024-06-27 12:45:00.172796',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2659,'sync-fields',2,'2024-06-27 12:45:00.181465','2024-06-27 12:45:03.057708',2876,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2660,'sync-fks',2,'2024-06-27 12:45:03.065517','2024-06-27 12:45:03.695236',629,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2661,'sync-indexes',2,'2024-06-27 12:45:03.704500','2024-06-27 12:45:04.837956',1133,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2662,'sync-metabase-metadata',2,'2024-06-27 12:45:04.846137','2024-06-27 12:45:04.856039',9,'{}','success'),(2663,'sync-table-privileges',2,'2024-06-27 12:45:04.865759','2024-06-27 12:45:04.874401',8,NULL,'success'),(2664,'analyze',2,'2024-06-27 12:45:04.912965','2024-06-27 12:45:06.900634',1987,NULL,'success'),(2665,'fingerprint-fields',2,'2024-06-27 12:45:04.921748','2024-06-27 12:45:06.754300',1832,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2666,'classify-fields',2,'2024-06-27 12:45:06.762290','2024-06-27 12:45:06.871139',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2667,'classify-tables',2,'2024-06-27 12:45:06.878375','2024-06-27 12:45:06.891938',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2668,'field values scanning',2,'2024-06-27 13:00:00.058597','2024-06-27 13:00:11.841042',11782,NULL,'success'),(2669,'delete-expired-advanced-field-values',2,'2024-06-27 13:00:00.075167','2024-06-27 13:00:03.289511',3214,'{\"deleted\":0}','success'),(2670,'update-field-values',2,'2024-06-27 13:00:03.300052','2024-06-27 13:00:11.832966',8532,'{\"errors\":0,\"created\":0,\"updated\":32,\"deleted\":0}','success'),(2671,'sync',2,'2024-06-27 13:45:00.086368','2024-06-27 13:45:04.845559',4759,NULL,'success'),(2672,'sync-dbms-version',2,'2024-06-27 13:45:00.093630','2024-06-27 13:45:00.102568',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2673,'sync-timezone',2,'2024-06-27 13:45:00.110316','2024-06-27 13:45:00.119175',8,'{\"timezone-id\":\"+08:00\"}','success'),(2674,'sync-tables',2,'2024-06-27 13:45:00.127513','2024-06-27 13:45:00.152605',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2675,'sync-fields',2,'2024-06-27 13:45:00.160236','2024-06-27 13:45:03.208250',3048,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2676,'sync-fks',2,'2024-06-27 13:45:03.217903','2024-06-27 13:45:03.922607',704,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2677,'sync-indexes',2,'2024-06-27 13:45:03.931307','2024-06-27 13:45:04.804921',873,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2678,'sync-metabase-metadata',2,'2024-06-27 13:45:04.812308','2024-06-27 13:45:04.820507',8,'{}','success'),(2679,'sync-table-privileges',2,'2024-06-27 13:45:04.829389','2024-06-27 13:45:04.837513',8,NULL,'success'),(2680,'analyze',2,'2024-06-27 13:45:04.868948','2024-06-27 13:45:06.934114',2065,NULL,'success'),(2681,'fingerprint-fields',2,'2024-06-27 13:45:04.876620','2024-06-27 13:45:06.718343',1841,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2682,'classify-fields',2,'2024-06-27 13:45:06.726712','2024-06-27 13:45:06.903133',176,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2683,'classify-tables',2,'2024-06-27 13:45:06.910787','2024-06-27 13:45:06.924807',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2684,'sync',2,'2024-06-27 14:45:00.106243','2024-06-27 14:45:04.168730',4062,NULL,'success'),(2685,'sync-dbms-version',2,'2024-06-27 14:45:00.114289','2024-06-27 14:45:00.124398',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2686,'sync-timezone',2,'2024-06-27 14:45:00.136542','2024-06-27 14:45:00.147950',11,'{\"timezone-id\":\"+08:00\"}','success'),(2687,'sync-tables',2,'2024-06-27 14:45:00.158897','2024-06-27 14:45:00.191467',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2688,'sync-fields',2,'2024-06-27 14:45:00.201714','2024-06-27 14:45:02.955534',2753,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2689,'sync-fks',2,'2024-06-27 14:45:02.963164','2024-06-27 14:45:03.632933',669,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2690,'sync-indexes',2,'2024-06-27 14:45:03.641327','2024-06-27 14:45:04.128285',486,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2691,'sync-metabase-metadata',2,'2024-06-27 14:45:04.135915','2024-06-27 14:45:04.144007',8,'{}','success'),(2692,'sync-table-privileges',2,'2024-06-27 14:45:04.151769','2024-06-27 14:45:04.160067',8,NULL,'success'),(2693,'analyze',2,'2024-06-27 14:45:04.192918','2024-06-27 14:45:06.132468',1939,NULL,'success'),(2694,'fingerprint-fields',2,'2024-06-27 14:45:04.200522','2024-06-27 14:45:05.963786',1763,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2695,'classify-fields',2,'2024-06-27 14:45:05.981199','2024-06-27 14:45:06.103976',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2696,'classify-tables',2,'2024-06-27 14:45:06.111709','2024-06-27 14:45:06.124617',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2697,'sync',2,'2024-06-27 15:45:00.120196','2024-06-27 15:45:04.285001',4164,NULL,'success'),(2698,'sync-dbms-version',2,'2024-06-27 15:45:00.128200','2024-06-27 15:45:00.138937',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2699,'sync-timezone',2,'2024-06-27 15:45:00.147495','2024-06-27 15:45:00.158268',10,'{\"timezone-id\":\"+08:00\"}','success'),(2700,'sync-tables',2,'2024-06-27 15:45:00.166922','2024-06-27 15:45:00.196074',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2701,'sync-fields',2,'2024-06-27 15:45:00.205452','2024-06-27 15:45:03.167712',2962,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2702,'sync-fks',2,'2024-06-27 15:45:03.176004','2024-06-27 15:45:03.758658',582,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2703,'sync-indexes',2,'2024-06-27 15:45:03.767090','2024-06-27 15:45:04.242299',475,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2704,'sync-metabase-metadata',2,'2024-06-27 15:45:04.249906','2024-06-27 15:45:04.257672',7,'{}','success'),(2705,'sync-table-privileges',2,'2024-06-27 15:45:04.265639','2024-06-27 15:45:04.273206',7,NULL,'success'),(2706,'analyze',2,'2024-06-27 15:45:04.310017','2024-06-27 15:45:06.230973',1920,NULL,'success'),(2707,'fingerprint-fields',2,'2024-06-27 15:45:04.317912','2024-06-27 15:45:06.091733',1773,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2708,'classify-fields',2,'2024-06-27 15:45:06.099451','2024-06-27 15:45:06.202301',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2709,'classify-tables',2,'2024-06-27 15:45:06.209705','2024-06-27 15:45:06.222684',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2710,'task-history-cleanup',NULL,'2024-06-27 16:00:00.023379','2024-06-27 16:00:00.052368',28,NULL,'success'),(2711,'task-history-cleanup',NULL,'2024-06-27 16:00:00.071379','2024-06-27 16:00:00.083900',12,NULL,'success'),(2712,'sync',2,'2024-06-27 16:45:00.119202','2024-06-27 16:45:04.678872',4559,NULL,'success'),(2713,'sync-dbms-version',2,'2024-06-27 16:45:00.127347','2024-06-27 16:45:00.138643',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2714,'sync-timezone',2,'2024-06-27 16:45:00.148059','2024-06-27 16:45:00.157661',9,'{\"timezone-id\":\"+08:00\"}','success'),(2715,'sync-tables',2,'2024-06-27 16:45:00.166794','2024-06-27 16:45:00.192532',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2716,'sync-fields',2,'2024-06-27 16:45:00.201221','2024-06-27 16:45:03.441017',3239,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2717,'sync-fks',2,'2024-06-27 16:45:03.448934','2024-06-27 16:45:04.071824',622,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2718,'sync-indexes',2,'2024-06-27 16:45:04.079743','2024-06-27 16:45:04.639526',559,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2719,'sync-metabase-metadata',2,'2024-06-27 16:45:04.647262','2024-06-27 16:45:04.655116',7,'{}','success'),(2720,'sync-table-privileges',2,'2024-06-27 16:45:04.662987','2024-06-27 16:45:04.671164',8,NULL,'success'),(2721,'analyze',2,'2024-06-27 16:45:04.703951','2024-06-27 16:45:06.871407',2167,NULL,'success'),(2722,'fingerprint-fields',2,'2024-06-27 16:45:04.711762','2024-06-27 16:45:06.724334',2012,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2723,'classify-fields',2,'2024-06-27 16:45:06.733534','2024-06-27 16:45:06.842135',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2724,'classify-tables',2,'2024-06-27 16:45:06.850009','2024-06-27 16:45:06.863453',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2725,'sync',2,'2024-06-27 17:45:00.118001','2024-06-27 17:45:04.287894',4169,NULL,'success'),(2726,'sync-dbms-version',2,'2024-06-27 17:45:00.126670','2024-06-27 17:45:00.137247',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2727,'sync-timezone',2,'2024-06-27 17:45:00.146886','2024-06-27 17:45:00.158426',11,'{\"timezone-id\":\"+08:00\"}','success'),(2728,'sync-tables',2,'2024-06-27 17:45:00.167173','2024-06-27 17:45:00.202660',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2729,'sync-fields',2,'2024-06-27 17:45:00.211745','2024-06-27 17:45:03.209137',2997,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2730,'sync-fks',2,'2024-06-27 17:45:03.217292','2024-06-27 17:45:03.759243',541,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2731,'sync-indexes',2,'2024-06-27 17:45:03.768514','2024-06-27 17:45:04.248117',479,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2732,'sync-metabase-metadata',2,'2024-06-27 17:45:04.255695','2024-06-27 17:45:04.263855',8,'{}','success'),(2733,'sync-table-privileges',2,'2024-06-27 17:45:04.272109','2024-06-27 17:45:04.280131',8,NULL,'success'),(2734,'analyze',2,'2024-06-27 17:45:04.311966','2024-06-27 17:45:06.337075',2025,NULL,'success'),(2735,'fingerprint-fields',2,'2024-06-27 17:45:04.320204','2024-06-27 17:45:06.193404',1873,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2736,'classify-fields',2,'2024-06-27 17:45:06.201703','2024-06-27 17:45:06.308375',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2737,'classify-tables',2,'2024-06-27 17:45:06.315679','2024-06-27 17:45:06.328870',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2738,'sync',2,'2024-06-27 18:45:00.107206','2024-06-27 18:45:04.347086',4239,NULL,'success'),(2739,'sync-dbms-version',2,'2024-06-27 18:45:00.115856','2024-06-27 18:45:00.126202',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2740,'sync-timezone',2,'2024-06-27 18:45:00.134761','2024-06-27 18:45:00.144552',9,'{\"timezone-id\":\"+08:00\"}','success'),(2741,'sync-tables',2,'2024-06-27 18:45:00.153493','2024-06-27 18:45:00.179403',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2742,'sync-fields',2,'2024-06-27 18:45:00.187727','2024-06-27 18:45:03.058811',2871,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2743,'sync-fks',2,'2024-06-27 18:45:03.066275','2024-06-27 18:45:03.706356',640,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2744,'sync-indexes',2,'2024-06-27 18:45:03.715246','2024-06-27 18:45:04.306010',590,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2745,'sync-metabase-metadata',2,'2024-06-27 18:45:04.313471','2024-06-27 18:45:04.320713',7,'{}','success'),(2746,'sync-table-privileges',2,'2024-06-27 18:45:04.329422','2024-06-27 18:45:04.338666',9,NULL,'success'),(2747,'analyze',2,'2024-06-27 18:45:04.372425','2024-06-27 18:45:06.331846',1959,NULL,'success'),(2748,'fingerprint-fields',2,'2024-06-27 18:45:04.380553','2024-06-27 18:45:06.177038',1796,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2749,'classify-fields',2,'2024-06-27 18:45:06.185527','2024-06-27 18:45:06.302964',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2750,'classify-tables',2,'2024-06-27 18:45:06.310550','2024-06-27 18:45:06.323905',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2751,'sync',2,'2024-06-27 19:45:00.112640','2024-06-27 19:45:04.557056',4444,NULL,'success'),(2752,'sync-dbms-version',2,'2024-06-27 19:45:00.121413','2024-06-27 19:45:00.130762',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2753,'sync-timezone',2,'2024-06-27 19:45:00.139371','2024-06-27 19:45:00.151820',12,'{\"timezone-id\":\"+08:00\"}','success'),(2754,'sync-tables',2,'2024-06-27 19:45:00.160792','2024-06-27 19:45:00.188666',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2755,'sync-fields',2,'2024-06-27 19:45:00.198313','2024-06-27 19:45:03.273625',3075,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2756,'sync-fks',2,'2024-06-27 19:45:03.281913','2024-06-27 19:45:03.969412',687,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2757,'sync-indexes',2,'2024-06-27 19:45:03.981976','2024-06-27 19:45:04.516921',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2758,'sync-metabase-metadata',2,'2024-06-27 19:45:04.524823','2024-06-27 19:45:04.532872',8,'{}','success'),(2759,'sync-table-privileges',2,'2024-06-27 19:45:04.540822','2024-06-27 19:45:04.549325',8,NULL,'success'),(2760,'analyze',2,'2024-06-27 19:45:04.580949','2024-06-27 19:45:06.703311',2122,NULL,'success'),(2761,'fingerprint-fields',2,'2024-06-27 19:45:04.588536','2024-06-27 19:45:06.529973',1941,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2762,'classify-fields',2,'2024-06-27 19:45:06.539027','2024-06-27 19:45:06.670290',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2763,'classify-tables',2,'2024-06-27 19:45:06.678482','2024-06-27 19:45:06.694827',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2764,'sync',2,'2024-06-27 20:45:00.099274','2024-06-27 20:45:04.728341',4629,NULL,'success'),(2765,'sync-dbms-version',2,'2024-06-27 20:45:00.107811','2024-06-27 20:45:00.118988',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2766,'sync-timezone',2,'2024-06-27 20:45:00.128124','2024-06-27 20:45:00.137783',9,'{\"timezone-id\":\"+08:00\"}','success'),(2767,'sync-tables',2,'2024-06-27 20:45:00.146402','2024-06-27 20:45:00.184966',38,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2768,'sync-fields',2,'2024-06-27 20:45:00.195098','2024-06-27 20:45:03.413793',3218,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2769,'sync-fks',2,'2024-06-27 20:45:03.422537','2024-06-27 20:45:04.122127',699,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2770,'sync-indexes',2,'2024-06-27 20:45:04.131381','2024-06-27 20:45:04.685787',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2771,'sync-metabase-metadata',2,'2024-06-27 20:45:04.693988','2024-06-27 20:45:04.702059',8,'{}','success'),(2772,'sync-table-privileges',2,'2024-06-27 20:45:04.711025','2024-06-27 20:45:04.719710',8,NULL,'success'),(2773,'analyze',2,'2024-06-27 20:45:04.757246','2024-06-27 20:45:07.000939',2243,NULL,'success'),(2774,'fingerprint-fields',2,'2024-06-27 20:45:04.766470','2024-06-27 20:45:06.843685',2077,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2775,'classify-fields',2,'2024-06-27 20:45:06.852443','2024-06-27 20:45:06.971238',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2776,'classify-tables',2,'2024-06-27 20:45:06.978892','2024-06-27 20:45:06.992644',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2777,'sync',2,'2024-06-27 21:45:00.108113','2024-06-27 21:45:04.781055',4672,NULL,'success'),(2778,'sync-dbms-version',2,'2024-06-27 21:45:00.118276','2024-06-27 21:45:00.129741',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2779,'sync-timezone',2,'2024-06-27 21:45:00.139572','2024-06-27 21:45:00.151336',11,'{\"timezone-id\":\"+08:00\"}','success'),(2780,'sync-tables',2,'2024-06-27 21:45:00.161163','2024-06-27 21:45:00.189688',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2781,'sync-fields',2,'2024-06-27 21:45:00.198168','2024-06-27 21:45:03.397269',3199,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2782,'sync-fks',2,'2024-06-27 21:45:03.405156','2024-06-27 21:45:04.125743',720,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2783,'sync-indexes',2,'2024-06-27 21:45:04.135036','2024-06-27 21:45:04.734291',599,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2784,'sync-metabase-metadata',2,'2024-06-27 21:45:04.743320','2024-06-27 21:45:04.752108',8,'{}','success'),(2785,'sync-table-privileges',2,'2024-06-27 21:45:04.762139','2024-06-27 21:45:04.770456',8,NULL,'success'),(2786,'analyze',2,'2024-06-27 21:45:04.811483','2024-06-27 21:45:06.892667',2081,NULL,'success'),(2787,'fingerprint-fields',2,'2024-06-27 21:45:04.821432','2024-06-27 21:45:06.729196',1907,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2788,'classify-fields',2,'2024-06-27 21:45:06.737809','2024-06-27 21:45:06.861637',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2789,'classify-tables',2,'2024-06-27 21:45:06.869524','2024-06-27 21:45:06.884414',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2790,'sync',2,'2024-06-27 22:45:00.092504','2024-06-27 22:45:04.083438',3990,NULL,'success'),(2791,'sync-dbms-version',2,'2024-06-27 22:45:00.100145','2024-06-27 22:45:00.109119',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2792,'sync-timezone',2,'2024-06-27 22:45:00.117601','2024-06-27 22:45:00.127201',9,'{\"timezone-id\":\"+08:00\"}','success'),(2793,'sync-tables',2,'2024-06-27 22:45:00.135195','2024-06-27 22:45:00.160771',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2794,'sync-fields',2,'2024-06-27 22:45:00.168894','2024-06-27 22:45:02.971967',2803,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2795,'sync-fks',2,'2024-06-27 22:45:02.979674','2024-06-27 22:45:03.566223',586,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2796,'sync-indexes',2,'2024-06-27 22:45:03.574382','2024-06-27 22:45:04.043268',468,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2797,'sync-metabase-metadata',2,'2024-06-27 22:45:04.050397','2024-06-27 22:45:04.059031',8,'{}','success'),(2798,'sync-table-privileges',2,'2024-06-27 22:45:04.067639','2024-06-27 22:45:04.075879',8,NULL,'success'),(2799,'analyze',2,'2024-06-27 22:45:04.107996','2024-06-27 22:45:06.201624',2093,NULL,'success'),(2800,'fingerprint-fields',2,'2024-06-27 22:45:04.116018','2024-06-27 22:45:06.049421',1933,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2801,'classify-fields',2,'2024-06-27 22:45:06.058099','2024-06-27 22:45:06.170399',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2802,'classify-tables',2,'2024-06-27 22:45:06.177928','2024-06-27 22:45:06.192905',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2803,'sync',2,'2024-06-27 23:45:00.132535','2024-06-27 23:45:04.477985',4345,NULL,'success'),(2804,'sync-dbms-version',2,'2024-06-27 23:45:00.143672','2024-06-27 23:45:00.155110',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2805,'sync-timezone',2,'2024-06-27 23:45:00.165293','2024-06-27 23:45:00.178802',13,'{\"timezone-id\":\"+08:00\"}','success'),(2806,'sync-tables',2,'2024-06-27 23:45:00.189373','2024-06-27 23:45:00.219498',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2807,'sync-fields',2,'2024-06-27 23:45:00.228775','2024-06-27 23:45:03.288609',3059,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2808,'sync-fks',2,'2024-06-27 23:45:03.296607','2024-06-27 23:45:03.890663',594,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2809,'sync-indexes',2,'2024-06-27 23:45:03.899326','2024-06-27 23:45:04.437152',537,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2810,'sync-metabase-metadata',2,'2024-06-27 23:45:04.444393','2024-06-27 23:45:04.452778',8,'{}','success'),(2811,'sync-table-privileges',2,'2024-06-27 23:45:04.460785','2024-06-27 23:45:04.468493',7,NULL,'success'),(2812,'analyze',2,'2024-06-27 23:45:04.508911','2024-06-27 23:45:06.637141',2128,NULL,'success'),(2813,'fingerprint-fields',2,'2024-06-27 23:45:04.517394','2024-06-27 23:45:06.464867',1947,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2814,'classify-fields',2,'2024-06-27 23:45:06.474215','2024-06-27 23:45:06.604808',130,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2815,'classify-tables',2,'2024-06-27 23:45:06.613270','2024-06-27 23:45:06.628309',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2816,'sync',2,'2024-06-28 00:45:00.122878','2024-06-28 00:45:04.474256',4351,NULL,'success'),(2817,'sync-dbms-version',2,'2024-06-28 00:45:00.131751','2024-06-28 00:45:00.143490',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2818,'sync-timezone',2,'2024-06-28 00:45:00.152532','2024-06-28 00:45:00.161845',9,'{\"timezone-id\":\"+08:00\"}','success'),(2819,'sync-tables',2,'2024-06-28 00:45:00.169771','2024-06-28 00:45:00.200981',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2820,'sync-fields',2,'2024-06-28 00:45:00.213447','2024-06-28 00:45:03.301861',3088,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2821,'sync-fks',2,'2024-06-28 00:45:03.310236','2024-06-28 00:45:03.928927',618,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2822,'sync-indexes',2,'2024-06-28 00:45:03.936476','2024-06-28 00:45:04.423704',487,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2823,'sync-metabase-metadata',2,'2024-06-28 00:45:04.434832','2024-06-28 00:45:04.445148',10,'{}','success'),(2824,'sync-table-privileges',2,'2024-06-28 00:45:04.455406','2024-06-28 00:45:04.465187',9,NULL,'success'),(2825,'analyze',2,'2024-06-28 00:45:04.499168','2024-06-28 00:45:06.705366',2206,NULL,'success'),(2826,'fingerprint-fields',2,'2024-06-28 00:45:04.507266','2024-06-28 00:45:06.554853',2047,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2827,'classify-fields',2,'2024-06-28 00:45:06.563240','2024-06-28 00:45:06.675939',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2828,'classify-tables',2,'2024-06-28 00:45:06.683602','2024-06-28 00:45:06.697962',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2829,'sync',2,'2024-06-28 01:45:00.106698','2024-06-28 01:45:04.848097',4741,NULL,'success'),(2830,'sync-dbms-version',2,'2024-06-28 01:45:00.115329','2024-06-28 01:45:00.125827',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2831,'sync-timezone',2,'2024-06-28 01:45:00.135378','2024-06-28 01:45:00.146263',10,'{\"timezone-id\":\"+08:00\"}','success'),(2832,'sync-tables',2,'2024-06-28 01:45:00.155808','2024-06-28 01:45:00.187886',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2833,'sync-fields',2,'2024-06-28 01:45:00.196759','2024-06-28 01:45:03.596180',3399,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2834,'sync-fks',2,'2024-06-28 01:45:03.606241','2024-06-28 01:45:04.286130',679,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2835,'sync-indexes',2,'2024-06-28 01:45:04.295193','2024-06-28 01:45:04.804829',509,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2836,'sync-metabase-metadata',2,'2024-06-28 01:45:04.812940','2024-06-28 01:45:04.821368',8,'{}','success'),(2837,'sync-table-privileges',2,'2024-06-28 01:45:04.830813','2024-06-28 01:45:04.839477',8,NULL,'success'),(2838,'analyze',2,'2024-06-28 01:45:04.872528','2024-06-28 01:45:06.969911',2097,NULL,'success'),(2839,'fingerprint-fields',2,'2024-06-28 01:45:04.881176','2024-06-28 01:45:06.816698',1935,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2840,'classify-fields',2,'2024-06-28 01:45:06.824553','2024-06-28 01:45:06.938381',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2841,'classify-tables',2,'2024-06-28 01:45:06.947554','2024-06-28 01:45:06.961825',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2842,'sync',2,'2024-06-28 02:45:00.104006','2024-06-28 02:45:04.587805',4483,NULL,'success'),(2843,'sync-dbms-version',2,'2024-06-28 02:45:00.112156','2024-06-28 02:45:00.122133',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2844,'sync-timezone',2,'2024-06-28 02:45:00.130381','2024-06-28 02:45:00.140673',10,'{\"timezone-id\":\"+08:00\"}','success'),(2845,'sync-tables',2,'2024-06-28 02:45:00.149402','2024-06-28 02:45:00.179200',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2846,'sync-fields',2,'2024-06-28 02:45:00.188403','2024-06-28 02:45:03.379562',3191,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2847,'sync-fks',2,'2024-06-28 02:45:03.387207','2024-06-28 02:45:03.991083',603,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2848,'sync-indexes',2,'2024-06-28 02:45:03.999388','2024-06-28 02:45:04.542383',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2849,'sync-metabase-metadata',2,'2024-06-28 02:45:04.549568','2024-06-28 02:45:04.558083',8,'{}','success'),(2850,'sync-table-privileges',2,'2024-06-28 02:45:04.566181','2024-06-28 02:45:04.575474',9,NULL,'success'),(2851,'analyze',2,'2024-06-28 02:45:04.623060','2024-06-28 02:45:06.770537',2147,NULL,'success'),(2852,'fingerprint-fields',2,'2024-06-28 02:45:04.633256','2024-06-28 02:45:06.620127',1986,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2853,'classify-fields',2,'2024-06-28 02:45:06.628844','2024-06-28 02:45:06.741545',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2854,'classify-tables',2,'2024-06-28 02:45:06.749250','2024-06-28 02:45:06.762354',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2855,'sync',2,'2024-06-28 03:45:00.113729','2024-06-28 03:45:04.748254',4634,NULL,'success'),(2856,'sync-dbms-version',2,'2024-06-28 03:45:00.122542','2024-06-28 03:45:00.133045',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2857,'sync-timezone',2,'2024-06-28 03:45:00.142447','2024-06-28 03:45:00.153981',11,'{\"timezone-id\":\"+08:00\"}','success'),(2858,'sync-tables',2,'2024-06-28 03:45:00.163405','2024-06-28 03:45:00.191875',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2859,'sync-fields',2,'2024-06-28 03:45:00.201507','2024-06-28 03:45:03.418294',3216,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2860,'sync-fks',2,'2024-06-28 03:45:03.427826','2024-06-28 03:45:04.149941',722,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2861,'sync-indexes',2,'2024-06-28 03:45:04.159911','2024-06-28 03:45:04.704947',545,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2862,'sync-metabase-metadata',2,'2024-06-28 03:45:04.712982','2024-06-28 03:45:04.722297',9,'{}','success'),(2863,'sync-table-privileges',2,'2024-06-28 03:45:04.730774','2024-06-28 03:45:04.739541',8,NULL,'success'),(2864,'analyze',2,'2024-06-28 03:45:04.774340','2024-06-28 03:45:06.941300',2166,NULL,'success'),(2865,'fingerprint-fields',2,'2024-06-28 03:45:04.782676','2024-06-28 03:45:06.706358',1923,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2866,'classify-fields',2,'2024-06-28 03:45:06.716861','2024-06-28 03:45:06.828362',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2867,'classify-tables',2,'2024-06-28 03:45:06.835667','2024-06-28 03:45:06.848798',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2868,'task-history-cleanup',NULL,'2024-06-28 04:00:00.061309','2024-06-28 04:00:00.071398',10,NULL,'success'),(2869,'sync',2,'2024-06-28 04:45:00.118152','2024-06-28 04:45:04.995953',4877,NULL,'success'),(2870,'sync-dbms-version',2,'2024-06-28 04:45:00.127048','2024-06-28 04:45:00.137264',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2871,'sync-timezone',2,'2024-06-28 04:45:00.146471','2024-06-28 04:45:00.158671',12,'{\"timezone-id\":\"+08:00\"}','success'),(2872,'sync-tables',2,'2024-06-28 04:45:00.168313','2024-06-28 04:45:00.198496',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2873,'sync-fields',2,'2024-06-28 04:45:00.207571','2024-06-28 04:45:03.571946',3364,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2874,'sync-fks',2,'2024-06-28 04:45:03.580120','2024-06-28 04:45:04.310406',730,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2875,'sync-indexes',2,'2024-06-28 04:45:04.319913','2024-06-28 04:45:04.941918',622,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2876,'sync-metabase-metadata',2,'2024-06-28 04:45:04.952131','2024-06-28 04:45:04.961659',9,'{}','success'),(2877,'sync-table-privileges',2,'2024-06-28 04:45:04.972765','2024-06-28 04:45:04.982355',9,NULL,'success'),(2878,'analyze',2,'2024-06-28 04:45:05.027419','2024-06-28 04:45:07.221720',2194,NULL,'success'),(2879,'fingerprint-fields',2,'2024-06-28 04:45:05.037275','2024-06-28 04:45:07.059941',2022,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2880,'classify-fields',2,'2024-06-28 04:45:07.068967','2024-06-28 04:45:07.192079',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2881,'classify-tables',2,'2024-06-28 04:45:07.199491','2024-06-28 04:45:07.212368',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2882,'sync',2,'2024-06-28 05:45:00.113447','2024-06-28 05:45:04.982136',4868,NULL,'success'),(2883,'sync-dbms-version',2,'2024-06-28 05:45:00.121979','2024-06-28 05:45:00.130989',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2884,'sync-timezone',2,'2024-06-28 05:45:00.140209','2024-06-28 05:45:00.151313',11,'{\"timezone-id\":\"+08:00\"}','success'),(2885,'sync-tables',2,'2024-06-28 05:45:00.160402','2024-06-28 05:45:00.188559',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2886,'sync-fields',2,'2024-06-28 05:45:00.197478','2024-06-28 05:45:03.510377',3312,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2887,'sync-fks',2,'2024-06-28 05:45:03.520384','2024-06-28 05:45:04.259428',739,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2888,'sync-indexes',2,'2024-06-28 05:45:04.269160','2024-06-28 05:45:04.937979',668,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2889,'sync-metabase-metadata',2,'2024-06-28 05:45:04.946893','2024-06-28 05:45:04.955283',8,'{}','success'),(2890,'sync-table-privileges',2,'2024-06-28 05:45:04.964358','2024-06-28 05:45:04.973356',9,NULL,'success'),(2891,'analyze',2,'2024-06-28 05:45:05.011677','2024-06-28 05:45:07.348335',2336,NULL,'success'),(2892,'fingerprint-fields',2,'2024-06-28 05:45:05.020412','2024-06-28 05:45:07.178253',2157,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2893,'classify-fields',2,'2024-06-28 05:45:07.188220','2024-06-28 05:45:07.316897',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2894,'classify-tables',2,'2024-06-28 05:45:07.325339','2024-06-28 05:45:07.339786',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2895,'sync',2,'2024-06-28 06:45:00.105335','2024-06-28 06:45:04.936291',4830,NULL,'success'),(2896,'sync-dbms-version',2,'2024-06-28 06:45:00.113719','2024-06-28 06:45:00.123117',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2897,'sync-timezone',2,'2024-06-28 06:45:00.133200','2024-06-28 06:45:00.146632',13,'{\"timezone-id\":\"+08:00\"}','success'),(2898,'sync-tables',2,'2024-06-28 06:45:00.155607','2024-06-28 06:45:00.180989',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2899,'sync-fields',2,'2024-06-28 06:45:00.189809','2024-06-28 06:45:03.455056',3265,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2900,'sync-fks',2,'2024-06-28 06:45:03.464202','2024-06-28 06:45:04.185180',720,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2901,'sync-indexes',2,'2024-06-28 06:45:04.195140','2024-06-28 06:45:04.891539',696,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2902,'sync-metabase-metadata',2,'2024-06-28 06:45:04.900034','2024-06-28 06:45:04.909894',9,'{}','success'),(2903,'sync-table-privileges',2,'2024-06-28 06:45:04.918636','2024-06-28 06:45:04.927401',8,NULL,'success'),(2904,'analyze',2,'2024-06-28 06:45:04.966965','2024-06-28 06:45:07.337442',2370,NULL,'success'),(2905,'fingerprint-fields',2,'2024-06-28 06:45:04.979735','2024-06-28 06:45:07.141905',2162,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2906,'classify-fields',2,'2024-06-28 06:45:07.154832','2024-06-28 06:45:07.302200',147,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2907,'classify-tables',2,'2024-06-28 06:45:07.310563','2024-06-28 06:45:07.326896',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2908,'sync',2,'2024-06-28 07:45:00.090639','2024-06-28 07:45:04.122013',4031,NULL,'success'),(2909,'sync-dbms-version',2,'2024-06-28 07:45:00.098439','2024-06-28 07:45:00.107613',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2910,'sync-timezone',2,'2024-06-28 07:45:00.115962','2024-06-28 07:45:00.126676',10,'{\"timezone-id\":\"+08:00\"}','success'),(2911,'sync-tables',2,'2024-06-28 07:45:00.135050','2024-06-28 07:45:00.161412',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2912,'sync-fields',2,'2024-06-28 07:45:00.170009','2024-06-28 07:45:02.960125',2790,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2913,'sync-fks',2,'2024-06-28 07:45:02.967266','2024-06-28 07:45:03.532799',565,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2914,'sync-indexes',2,'2024-06-28 07:45:03.540842','2024-06-28 07:45:04.082939',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2915,'sync-metabase-metadata',2,'2024-06-28 07:45:04.090394','2024-06-28 07:45:04.098865',8,'{}','success'),(2916,'sync-table-privileges',2,'2024-06-28 07:45:04.106624','2024-06-28 07:45:04.114475',7,NULL,'success'),(2917,'analyze',2,'2024-06-28 07:45:04.145301','2024-06-28 07:45:06.223377',2078,NULL,'success'),(2918,'fingerprint-fields',2,'2024-06-28 07:45:04.152777','2024-06-28 07:45:05.961726',1808,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2919,'classify-fields',2,'2024-06-28 07:45:05.976872','2024-06-28 07:45:06.190110',213,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2920,'classify-tables',2,'2024-06-28 07:45:06.198881','2024-06-28 07:45:06.213369',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2921,'sync',2,'2024-06-28 08:45:00.094159','2024-06-28 08:45:04.553976',4459,NULL,'success'),(2922,'sync-dbms-version',2,'2024-06-28 08:45:00.101433','2024-06-28 08:45:00.110133',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2923,'sync-timezone',2,'2024-06-28 08:45:00.117962','2024-06-28 08:45:00.127222',9,'{\"timezone-id\":\"+08:00\"}','success'),(2924,'sync-tables',2,'2024-06-28 08:45:00.135462','2024-06-28 08:45:00.161452',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2925,'sync-fields',2,'2024-06-28 08:45:00.170591','2024-06-28 08:45:03.145535',2974,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2926,'sync-fks',2,'2024-06-28 08:45:03.153809','2024-06-28 08:45:03.926076',772,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2927,'sync-indexes',2,'2024-06-28 08:45:03.935933','2024-06-28 08:45:04.509779',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2928,'sync-metabase-metadata',2,'2024-06-28 08:45:04.518789','2024-06-28 08:45:04.528058',9,'{}','success'),(2929,'sync-table-privileges',2,'2024-06-28 08:45:04.537359','2024-06-28 08:45:04.545492',8,NULL,'success'),(2930,'analyze',2,'2024-06-28 08:45:04.580317','2024-06-28 08:45:06.948535',2368,NULL,'success'),(2931,'fingerprint-fields',2,'2024-06-28 08:45:04.589646','2024-06-28 08:45:06.713527',2123,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2932,'classify-fields',2,'2024-06-28 08:45:06.723643','2024-06-28 08:45:06.917030',193,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2933,'classify-tables',2,'2024-06-28 08:45:06.925929','2024-06-28 08:45:06.940479',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2934,'sync',2,'2024-06-28 09:45:00.112220','2024-06-28 09:45:04.414934',4302,NULL,'success'),(2935,'sync-dbms-version',2,'2024-06-28 09:45:00.120787','2024-06-28 09:45:00.131984',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2936,'sync-timezone',2,'2024-06-28 09:45:00.141442','2024-06-28 09:45:00.152384',10,'{\"timezone-id\":\"+08:00\"}','success'),(2937,'sync-tables',2,'2024-06-28 09:45:00.160987','2024-06-28 09:45:00.189898',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2938,'sync-fields',2,'2024-06-28 09:45:00.198418','2024-06-28 09:45:03.183411',2984,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2939,'sync-fks',2,'2024-06-28 09:45:03.192550','2024-06-28 09:45:03.813840',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2940,'sync-indexes',2,'2024-06-28 09:45:03.822901','2024-06-28 09:45:04.371807',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2941,'sync-metabase-metadata',2,'2024-06-28 09:45:04.379994','2024-06-28 09:45:04.388947',8,'{}','success'),(2942,'sync-table-privileges',2,'2024-06-28 09:45:04.397469','2024-06-28 09:45:04.405832',8,NULL,'success'),(2943,'analyze',2,'2024-06-28 09:45:04.440317','2024-06-28 09:45:06.422651',1982,NULL,'success'),(2944,'fingerprint-fields',2,'2024-06-28 09:45:04.450508','2024-06-28 09:45:06.221851',1771,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2945,'classify-fields',2,'2024-06-28 09:45:06.230535','2024-06-28 09:45:06.395003',164,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2946,'classify-tables',2,'2024-06-28 09:45:06.402240','2024-06-28 09:45:06.414299',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2947,'sync',2,'2024-06-28 10:45:00.094510','2024-06-28 10:45:04.040346',3945,NULL,'success'),(2948,'sync-dbms-version',2,'2024-06-28 10:45:00.102075','2024-06-28 10:45:00.111225',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2949,'sync-timezone',2,'2024-06-28 10:45:00.119186','2024-06-28 10:45:00.128551',9,'{\"timezone-id\":\"+08:00\"}','success'),(2950,'sync-tables',2,'2024-06-28 10:45:00.136559','2024-06-28 10:45:00.162497',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2951,'sync-fields',2,'2024-06-28 10:45:00.170407','2024-06-28 10:45:02.951498',2781,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2952,'sync-fks',2,'2024-06-28 10:45:02.959378','2024-06-28 10:45:03.521796',562,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2953,'sync-indexes',2,'2024-06-28 10:45:03.530274','2024-06-28 10:45:04.000391',470,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2954,'sync-metabase-metadata',2,'2024-06-28 10:45:04.007620','2024-06-28 10:45:04.016897',9,'{}','success'),(2955,'sync-table-privileges',2,'2024-06-28 10:45:04.024768','2024-06-28 10:45:04.032477',7,NULL,'success'),(2956,'analyze',2,'2024-06-28 10:45:04.064293','2024-06-28 10:45:05.960860',1896,NULL,'success'),(2957,'fingerprint-fields',2,'2024-06-28 10:45:04.072152','2024-06-28 10:45:05.827004',1754,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2958,'classify-fields',2,'2024-06-28 10:45:05.834565','2024-06-28 10:45:05.932764',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2959,'classify-tables',2,'2024-06-28 10:45:05.939864','2024-06-28 10:45:05.953076',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2960,'sync',2,'2024-06-28 11:45:00.103725','2024-06-28 11:45:04.333344',4229,NULL,'success'),(2961,'sync-dbms-version',2,'2024-06-28 11:45:00.111074','2024-06-28 11:45:00.121855',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2962,'sync-timezone',2,'2024-06-28 11:45:00.130827','2024-06-28 11:45:00.139985',9,'{\"timezone-id\":\"+08:00\"}','success'),(2963,'sync-tables',2,'2024-06-28 11:45:00.148012','2024-06-28 11:45:00.175724',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2964,'sync-fields',2,'2024-06-28 11:45:00.184069','2024-06-28 11:45:02.976527',2792,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2965,'sync-fks',2,'2024-06-28 11:45:02.984514','2024-06-28 11:45:03.644888',660,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2966,'sync-indexes',2,'2024-06-28 11:45:03.652952','2024-06-28 11:45:04.292141',639,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2967,'sync-metabase-metadata',2,'2024-06-28 11:45:04.299397','2024-06-28 11:45:04.307426',8,'{}','success'),(2968,'sync-table-privileges',2,'2024-06-28 11:45:04.315480','2024-06-28 11:45:04.324442',8,NULL,'success'),(2969,'analyze',2,'2024-06-28 11:45:04.363184','2024-06-28 11:45:06.424048',2060,NULL,'success'),(2970,'fingerprint-fields',2,'2024-06-28 11:45:04.371671','2024-06-28 11:45:06.285284',1913,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2971,'classify-fields',2,'2024-06-28 11:45:06.293379','2024-06-28 11:45:06.395066',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2972,'classify-tables',2,'2024-06-28 11:45:06.402285','2024-06-28 11:45:06.415654',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2973,'sync',2,'2024-06-28 12:45:00.095035','2024-06-28 12:45:03.869770',3774,NULL,'success'),(2974,'sync-dbms-version',2,'2024-06-28 12:45:00.102615','2024-06-28 12:45:00.111031',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2975,'sync-timezone',2,'2024-06-28 12:45:00.119096','2024-06-28 12:45:00.128379',9,'{\"timezone-id\":\"+08:00\"}','success'),(2976,'sync-tables',2,'2024-06-28 12:45:00.135966','2024-06-28 12:45:00.161014',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2977,'sync-fields',2,'2024-06-28 12:45:00.168750','2024-06-28 12:45:02.803453',2634,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2978,'sync-fks',2,'2024-06-28 12:45:02.810817','2024-06-28 12:45:03.356142',545,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2979,'sync-indexes',2,'2024-06-28 12:45:03.363999','2024-06-28 12:45:03.832312',468,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2980,'sync-metabase-metadata',2,'2024-06-28 12:45:03.839624','2024-06-28 12:45:03.847018',7,'{}','success'),(2981,'sync-table-privileges',2,'2024-06-28 12:45:03.854559','2024-06-28 12:45:03.862335',7,NULL,'success'),(2982,'analyze',2,'2024-06-28 12:45:03.893540','2024-06-28 12:45:05.725396',1831,NULL,'success'),(2983,'fingerprint-fields',2,'2024-06-28 12:45:03.900831','2024-06-28 12:45:05.589424',1688,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(2984,'classify-fields',2,'2024-06-28 12:45:05.597045','2024-06-28 12:45:05.697795',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(2985,'classify-tables',2,'2024-06-28 12:45:05.704647','2024-06-28 12:45:05.717267',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(2986,'field values scanning',2,'2024-06-28 13:00:00.057429','2024-06-28 13:00:11.138200',11080,NULL,'success'),(2987,'delete-expired-advanced-field-values',2,'2024-06-28 13:00:00.075019','2024-06-28 13:00:02.884624',2809,'{\"deleted\":0}','success'),(2988,'update-field-values',2,'2024-06-28 13:00:02.892261','2024-06-28 13:00:11.130896',8238,'{\"errors\":0,\"created\":0,\"updated\":27,\"deleted\":1}','success'),(2989,'sync',2,'2024-06-28 13:45:00.088698','2024-06-28 13:45:04.596289',4507,NULL,'success'),(2990,'sync-dbms-version',2,'2024-06-28 13:45:00.098879','2024-06-28 13:45:00.108498',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(2991,'sync-timezone',2,'2024-06-28 13:45:00.116886','2024-06-28 13:45:00.126167',9,'{\"timezone-id\":\"+08:00\"}','success'),(2992,'sync-tables',2,'2024-06-28 13:45:00.134141','2024-06-28 13:45:00.159473',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(2993,'sync-fields',2,'2024-06-28 13:45:00.167600','2024-06-28 13:45:03.010684',2843,'{\"total-fields\":836,\"updated-fields\":0}','success'),(2994,'sync-fks',2,'2024-06-28 13:45:03.017974','2024-06-28 13:45:03.558668',540,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(2995,'sync-indexes',2,'2024-06-28 13:45:03.567074','2024-06-28 13:45:04.552092',985,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(2996,'sync-metabase-metadata',2,'2024-06-28 13:45:04.559884','2024-06-28 13:45:04.569632',9,'{}','success'),(2997,'sync-table-privileges',2,'2024-06-28 13:45:04.578532','2024-06-28 13:45:04.586926',8,NULL,'success'),(2998,'analyze',2,'2024-06-28 13:45:04.625448','2024-06-28 13:45:06.778778',2153,NULL,'success'),(2999,'fingerprint-fields',2,'2024-06-28 13:45:04.634751','2024-06-28 13:45:06.611771',1977,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3000,'classify-fields',2,'2024-06-28 13:45:06.622774','2024-06-28 13:45:06.742920',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3001,'classify-tables',2,'2024-06-28 13:45:06.751015','2024-06-28 13:45:06.766142',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3002,'sync',2,'2024-06-28 14:45:00.105952','2024-06-28 14:45:04.729772',4623,NULL,'success'),(3003,'sync-dbms-version',2,'2024-06-28 14:45:00.113725','2024-06-28 14:45:00.122240',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3004,'sync-timezone',2,'2024-06-28 14:45:00.130538','2024-06-28 14:45:00.139450',8,'{\"timezone-id\":\"+08:00\"}','success'),(3005,'sync-tables',2,'2024-06-28 14:45:00.148723','2024-06-28 14:45:00.173343',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3006,'sync-fields',2,'2024-06-28 14:45:00.181373','2024-06-28 14:45:03.108404',2927,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3007,'sync-fks',2,'2024-06-28 14:45:03.116613','2024-06-28 14:45:03.806810',690,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3008,'sync-indexes',2,'2024-06-28 14:45:03.816140','2024-06-28 14:45:04.685272',869,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3009,'sync-metabase-metadata',2,'2024-06-28 14:45:04.695098','2024-06-28 14:45:04.703998',8,'{}','success'),(3010,'sync-table-privileges',2,'2024-06-28 14:45:04.712559','2024-06-28 14:45:04.720610',8,NULL,'success'),(3011,'analyze',2,'2024-06-28 14:45:04.759055','2024-06-28 14:45:06.864120',2105,NULL,'success'),(3012,'fingerprint-fields',2,'2024-06-28 14:45:04.767919','2024-06-28 14:45:06.719474',1951,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3013,'classify-fields',2,'2024-06-28 14:45:06.727947','2024-06-28 14:45:06.833220',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3014,'classify-tables',2,'2024-06-28 14:45:06.840886','2024-06-28 14:45:06.853423',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3015,'sync',2,'2024-06-28 15:45:00.101078','2024-06-28 15:45:04.191009',4089,NULL,'success'),(3016,'sync-dbms-version',2,'2024-06-28 15:45:00.108783','2024-06-28 15:45:00.118835',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3017,'sync-timezone',2,'2024-06-28 15:45:00.127431','2024-06-28 15:45:00.137978',10,'{\"timezone-id\":\"+08:00\"}','success'),(3018,'sync-tables',2,'2024-06-28 15:45:00.146170','2024-06-28 15:45:00.172217',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3019,'sync-fields',2,'2024-06-28 15:45:00.180034','2024-06-28 15:45:03.099450',2919,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3020,'sync-fks',2,'2024-06-28 15:45:03.107892','2024-06-28 15:45:03.666466',558,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3021,'sync-indexes',2,'2024-06-28 15:45:03.674895','2024-06-28 15:45:04.150991',476,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3022,'sync-metabase-metadata',2,'2024-06-28 15:45:04.158429','2024-06-28 15:45:04.166527',8,'{}','success'),(3023,'sync-table-privileges',2,'2024-06-28 15:45:04.174831','2024-06-28 15:45:04.183067',8,NULL,'success'),(3024,'analyze',2,'2024-06-28 15:45:04.220788','2024-06-28 15:45:06.227616',2006,NULL,'success'),(3025,'fingerprint-fields',2,'2024-06-28 15:45:04.229577','2024-06-28 15:45:06.083789',1854,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3026,'classify-fields',2,'2024-06-28 15:45:06.092056','2024-06-28 15:45:06.198227',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3027,'classify-tables',2,'2024-06-28 15:45:06.205658','2024-06-28 15:45:06.219272',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3028,'task-history-cleanup',NULL,'2024-06-28 16:00:00.044553','2024-06-28 16:00:00.063206',18,NULL,'success'),(3029,'task-history-cleanup',NULL,'2024-06-28 16:00:00.077791','2024-06-28 16:00:00.092853',15,NULL,'success'),(3030,'sync',2,'2024-06-28 16:45:00.104806','2024-06-28 16:45:04.490922',4386,NULL,'success'),(3031,'sync-dbms-version',2,'2024-06-28 16:45:00.112910','2024-06-28 16:45:00.122009',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3032,'sync-timezone',2,'2024-06-28 16:45:00.130351','2024-06-28 16:45:00.141535',11,'{\"timezone-id\":\"+08:00\"}','success'),(3033,'sync-tables',2,'2024-06-28 16:45:00.151188','2024-06-28 16:45:00.178732',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3034,'sync-fields',2,'2024-06-28 16:45:00.191996','2024-06-28 16:45:03.179810',2987,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3035,'sync-fks',2,'2024-06-28 16:45:03.187810','2024-06-28 16:45:03.852133',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3036,'sync-indexes',2,'2024-06-28 16:45:03.861555','2024-06-28 16:45:04.448293',586,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3037,'sync-metabase-metadata',2,'2024-06-28 16:45:04.457686','2024-06-28 16:45:04.466868',9,'{}','success'),(3038,'sync-table-privileges',2,'2024-06-28 16:45:04.474671','2024-06-28 16:45:04.482452',7,NULL,'success'),(3039,'analyze',2,'2024-06-28 16:45:04.516298','2024-06-28 16:45:06.494747',1978,NULL,'success'),(3040,'fingerprint-fields',2,'2024-06-28 16:45:04.524520','2024-06-28 16:45:06.363319',1838,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3041,'classify-fields',2,'2024-06-28 16:45:06.370843','2024-06-28 16:45:06.467266',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3042,'classify-tables',2,'2024-06-28 16:45:06.474440','2024-06-28 16:45:06.487137',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3043,'sync',2,'2024-06-28 17:45:00.114756','2024-06-28 17:45:04.516760',4402,NULL,'success'),(3044,'sync-dbms-version',2,'2024-06-28 17:45:00.123289','2024-06-28 17:45:00.133204',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3045,'sync-timezone',2,'2024-06-28 17:45:00.142478','2024-06-28 17:45:00.152493',10,'{\"timezone-id\":\"+08:00\"}','success'),(3046,'sync-tables',2,'2024-06-28 17:45:00.161015','2024-06-28 17:45:00.189603',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3047,'sync-fields',2,'2024-06-28 17:45:00.198867','2024-06-28 17:45:03.197256',2998,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3048,'sync-fks',2,'2024-06-28 17:45:03.207169','2024-06-28 17:45:03.858614',651,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3049,'sync-indexes',2,'2024-06-28 17:45:03.868083','2024-06-28 17:45:04.471680',603,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3050,'sync-metabase-metadata',2,'2024-06-28 17:45:04.480662','2024-06-28 17:45:04.490127',9,'{}','success'),(3051,'sync-table-privileges',2,'2024-06-28 17:45:04.498356','2024-06-28 17:45:04.508095',9,NULL,'success'),(3052,'analyze',2,'2024-06-28 17:45:04.542932','2024-06-28 17:45:06.660287',2117,NULL,'success'),(3053,'fingerprint-fields',2,'2024-06-28 17:45:04.552240','2024-06-28 17:45:06.517047',1964,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3054,'classify-fields',2,'2024-06-28 17:45:06.526157','2024-06-28 17:45:06.630346',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3055,'classify-tables',2,'2024-06-28 17:45:06.637685','2024-06-28 17:45:06.651701',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3056,'sync',2,'2024-06-28 18:45:00.108151','2024-06-28 18:45:04.464822',4356,NULL,'success'),(3057,'sync-dbms-version',2,'2024-06-28 18:45:00.118044','2024-06-28 18:45:00.128527',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3058,'sync-timezone',2,'2024-06-28 18:45:00.137548','2024-06-28 18:45:00.148270',10,'{\"timezone-id\":\"+08:00\"}','success'),(3059,'sync-tables',2,'2024-06-28 18:45:00.157501','2024-06-28 18:45:00.188144',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3060,'sync-fields',2,'2024-06-28 18:45:00.197803','2024-06-28 18:45:03.259464',3061,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3061,'sync-fks',2,'2024-06-28 18:45:03.267782','2024-06-28 18:45:03.879230',611,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3062,'sync-indexes',2,'2024-06-28 18:45:03.887436','2024-06-28 18:45:04.422361',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3063,'sync-metabase-metadata',2,'2024-06-28 18:45:04.430010','2024-06-28 18:45:04.438148',8,'{}','success'),(3064,'sync-table-privileges',2,'2024-06-28 18:45:04.447433','2024-06-28 18:45:04.456133',8,NULL,'success'),(3065,'analyze',2,'2024-06-28 18:45:04.489138','2024-06-28 18:45:06.627666',2138,NULL,'success'),(3066,'fingerprint-fields',2,'2024-06-28 18:45:04.496824','2024-06-28 18:45:06.471296',1974,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3067,'classify-fields',2,'2024-06-28 18:45:06.479906','2024-06-28 18:45:06.598646',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3068,'classify-tables',2,'2024-06-28 18:45:06.606244','2024-06-28 18:45:06.618783',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3069,'sync',2,'2024-06-28 19:45:00.101726','2024-06-28 19:45:04.453601',4351,NULL,'success'),(3070,'sync-dbms-version',2,'2024-06-28 19:45:00.111022','2024-06-28 19:45:00.121178',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3071,'sync-timezone',2,'2024-06-28 19:45:00.130473','2024-06-28 19:45:00.142721',12,'{\"timezone-id\":\"+08:00\"}','success'),(3072,'sync-tables',2,'2024-06-28 19:45:00.151953','2024-06-28 19:45:00.185423',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3073,'sync-fields',2,'2024-06-28 19:45:00.194965','2024-06-28 19:45:03.256316',3061,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3074,'sync-fks',2,'2024-06-28 19:45:03.264447','2024-06-28 19:45:03.831318',566,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3075,'sync-indexes',2,'2024-06-28 19:45:03.840121','2024-06-28 19:45:04.408175',568,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3076,'sync-metabase-metadata',2,'2024-06-28 19:45:04.416385','2024-06-28 19:45:04.426116',9,'{}','success'),(3077,'sync-table-privileges',2,'2024-06-28 19:45:04.435173','2024-06-28 19:45:04.445188',10,NULL,'success'),(3078,'analyze',2,'2024-06-28 19:45:04.478316','2024-06-28 19:45:06.554504',2076,NULL,'success'),(3079,'fingerprint-fields',2,'2024-06-28 19:45:04.486292','2024-06-28 19:45:06.398500',1912,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3080,'classify-fields',2,'2024-06-28 19:45:06.407242','2024-06-28 19:45:06.522998',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3081,'classify-tables',2,'2024-06-28 19:45:06.531262','2024-06-28 19:45:06.546195',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3082,'sync',2,'2024-06-28 20:45:00.097006','2024-06-28 20:45:04.581186',4484,NULL,'success'),(3083,'sync-dbms-version',2,'2024-06-28 20:45:00.104877','2024-06-28 20:45:00.114793',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3084,'sync-timezone',2,'2024-06-28 20:45:00.123647','2024-06-28 20:45:00.135624',11,'{\"timezone-id\":\"+08:00\"}','success'),(3085,'sync-tables',2,'2024-06-28 20:45:00.144836','2024-06-28 20:45:00.172873',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3086,'sync-fields',2,'2024-06-28 20:45:00.182145','2024-06-28 20:45:03.313921',3131,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3087,'sync-fks',2,'2024-06-28 20:45:03.324621','2024-06-28 20:45:03.994031',669,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3088,'sync-indexes',2,'2024-06-28 20:45:04.003084','2024-06-28 20:45:04.539972',536,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3089,'sync-metabase-metadata',2,'2024-06-28 20:45:04.547846','2024-06-28 20:45:04.556778',8,'{}','success'),(3090,'sync-table-privileges',2,'2024-06-28 20:45:04.564948','2024-06-28 20:45:04.573049',8,NULL,'success'),(3091,'analyze',2,'2024-06-28 20:45:04.604814','2024-06-28 20:45:06.642280',2037,NULL,'success'),(3092,'fingerprint-fields',2,'2024-06-28 20:45:04.612801','2024-06-28 20:45:06.481772',1868,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3093,'classify-fields',2,'2024-06-28 20:45:06.490135','2024-06-28 20:45:06.609557',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3094,'classify-tables',2,'2024-06-28 20:45:06.617977','2024-06-28 20:45:06.633141',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3095,'sync',2,'2024-06-28 21:45:00.120727','2024-06-28 21:45:04.214602',4093,NULL,'success'),(3096,'sync-dbms-version',2,'2024-06-28 21:45:00.129681','2024-06-28 21:45:00.139862',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3097,'sync-timezone',2,'2024-06-28 21:45:00.149091','2024-06-28 21:45:00.160218',11,'{\"timezone-id\":\"+08:00\"}','success'),(3098,'sync-tables',2,'2024-06-28 21:45:00.168999','2024-06-28 21:45:00.201474',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3099,'sync-fields',2,'2024-06-28 21:45:00.211569','2024-06-28 21:45:03.035325',2823,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3100,'sync-fks',2,'2024-06-28 21:45:03.043048','2024-06-28 21:45:03.632773',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3101,'sync-indexes',2,'2024-06-28 21:45:03.641524','2024-06-28 21:45:04.169883',528,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3102,'sync-metabase-metadata',2,'2024-06-28 21:45:04.177611','2024-06-28 21:45:04.186113',8,'{}','success'),(3103,'sync-table-privileges',2,'2024-06-28 21:45:04.195257','2024-06-28 21:45:04.204291',9,NULL,'success'),(3104,'analyze',2,'2024-06-28 21:45:04.239048','2024-06-28 21:45:06.353244',2114,NULL,'success'),(3105,'fingerprint-fields',2,'2024-06-28 21:45:04.246892','2024-06-28 21:45:06.161930',1915,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3106,'classify-fields',2,'2024-06-28 21:45:06.173349','2024-06-28 21:45:06.321123',147,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3107,'classify-tables',2,'2024-06-28 21:45:06.329594','2024-06-28 21:45:06.344314',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3108,'sync',2,'2024-06-28 22:45:00.106876','2024-06-28 22:45:04.633779',4526,NULL,'success'),(3109,'sync-dbms-version',2,'2024-06-28 22:45:00.117265','2024-06-28 22:45:00.127642',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3110,'sync-timezone',2,'2024-06-28 22:45:00.136961','2024-06-28 22:45:00.151377',14,'{\"timezone-id\":\"+08:00\"}','success'),(3111,'sync-tables',2,'2024-06-28 22:45:00.160510','2024-06-28 22:45:00.190111',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3112,'sync-fields',2,'2024-06-28 22:45:00.200023','2024-06-28 22:45:03.317874',3117,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3113,'sync-fks',2,'2024-06-28 22:45:03.326265','2024-06-28 22:45:04.022968',696,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3114,'sync-indexes',2,'2024-06-28 22:45:04.032667','2024-06-28 22:45:04.589866',557,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3115,'sync-metabase-metadata',2,'2024-06-28 22:45:04.598298','2024-06-28 22:45:04.607035',8,'{}','success'),(3116,'sync-table-privileges',2,'2024-06-28 22:45:04.615385','2024-06-28 22:45:04.624734',9,NULL,'success'),(3117,'analyze',2,'2024-06-28 22:45:04.663145','2024-06-28 22:45:06.801784',2138,NULL,'success'),(3118,'fingerprint-fields',2,'2024-06-28 22:45:04.671882','2024-06-28 22:45:06.644851',1972,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3119,'classify-fields',2,'2024-06-28 22:45:06.653523','2024-06-28 22:45:06.769181',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3120,'classify-tables',2,'2024-06-28 22:45:06.777658','2024-06-28 22:45:06.793402',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3121,'sync',2,'2024-06-28 23:45:00.114716','2024-06-28 23:45:04.347432',4232,NULL,'success'),(3122,'sync-dbms-version',2,'2024-06-28 23:45:00.123616','2024-06-28 23:45:00.133619',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3123,'sync-timezone',2,'2024-06-28 23:45:00.142690','2024-06-28 23:45:00.154462',11,'{\"timezone-id\":\"+08:00\"}','success'),(3124,'sync-tables',2,'2024-06-28 23:45:00.163913','2024-06-28 23:45:00.200769',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3125,'sync-fields',2,'2024-06-28 23:45:00.210243','2024-06-28 23:45:03.152030',2941,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3126,'sync-fks',2,'2024-06-28 23:45:03.159773','2024-06-28 23:45:03.769732',609,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3127,'sync-indexes',2,'2024-06-28 23:45:03.778151','2024-06-28 23:45:04.304795',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3128,'sync-metabase-metadata',2,'2024-06-28 23:45:04.312564','2024-06-28 23:45:04.321015',8,'{}','success'),(3129,'sync-table-privileges',2,'2024-06-28 23:45:04.329206','2024-06-28 23:45:04.338202',8,NULL,'success'),(3130,'analyze',2,'2024-06-28 23:45:04.373114','2024-06-28 23:45:06.514107',2140,NULL,'success'),(3131,'fingerprint-fields',2,'2024-06-28 23:45:04.381253','2024-06-28 23:45:06.364824',1983,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3132,'classify-fields',2,'2024-06-28 23:45:06.372363','2024-06-28 23:45:06.483308',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3133,'classify-tables',2,'2024-06-28 23:45:06.490692','2024-06-28 23:45:06.505504',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3134,'sync',2,'2024-06-29 00:45:00.090777','2024-06-29 00:45:04.451358',4360,NULL,'success'),(3135,'sync-dbms-version',2,'2024-06-29 00:45:00.100647','2024-06-29 00:45:00.110121',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3136,'sync-timezone',2,'2024-06-29 00:45:00.118207','2024-06-29 00:45:00.129224',11,'{\"timezone-id\":\"+08:00\"}','success'),(3137,'sync-tables',2,'2024-06-29 00:45:00.137021','2024-06-29 00:45:00.166885',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3138,'sync-fields',2,'2024-06-29 00:45:00.175419','2024-06-29 00:45:03.204141',3028,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3139,'sync-fks',2,'2024-06-29 00:45:03.213703','2024-06-29 00:45:03.842728',629,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3140,'sync-indexes',2,'2024-06-29 00:45:03.851514','2024-06-29 00:45:04.407170',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3141,'sync-metabase-metadata',2,'2024-06-29 00:45:04.415619','2024-06-29 00:45:04.423918',8,'{}','success'),(3142,'sync-table-privileges',2,'2024-06-29 00:45:04.433255','2024-06-29 00:45:04.441912',8,NULL,'success'),(3143,'analyze',2,'2024-06-29 00:45:04.478642','2024-06-29 00:45:06.677229',2198,NULL,'success'),(3144,'fingerprint-fields',2,'2024-06-29 00:45:04.487655','2024-06-29 00:45:06.526642',2038,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3145,'classify-fields',2,'2024-06-29 00:45:06.535001','2024-06-29 00:45:06.647473',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3146,'classify-tables',2,'2024-06-29 00:45:06.655333','2024-06-29 00:45:06.668553',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3147,'sync',2,'2024-06-29 01:45:00.119072','2024-06-29 01:45:04.595029',4475,NULL,'success'),(3148,'sync-dbms-version',2,'2024-06-29 01:45:00.128325','2024-06-29 01:45:00.138174',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3149,'sync-timezone',2,'2024-06-29 01:45:00.147395','2024-06-29 01:45:00.159396',12,'{\"timezone-id\":\"+08:00\"}','success'),(3150,'sync-tables',2,'2024-06-29 01:45:00.169126','2024-06-29 01:45:00.196992',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3151,'sync-fields',2,'2024-06-29 01:45:00.206027','2024-06-29 01:45:03.288815',3082,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3152,'sync-fks',2,'2024-06-29 01:45:03.296544','2024-06-29 01:45:03.986901',690,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3153,'sync-indexes',2,'2024-06-29 01:45:03.995914','2024-06-29 01:45:04.552973',557,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3154,'sync-metabase-metadata',2,'2024-06-29 01:45:04.562676','2024-06-29 01:45:04.571279',8,'{}','success'),(3155,'sync-table-privileges',2,'2024-06-29 01:45:04.578938','2024-06-29 01:45:04.587048',8,NULL,'success'),(3156,'analyze',2,'2024-06-29 01:45:04.619835','2024-06-29 01:45:06.617368',1997,NULL,'success'),(3157,'fingerprint-fields',2,'2024-06-29 01:45:04.628154','2024-06-29 01:45:06.455988',1827,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3158,'classify-fields',2,'2024-06-29 01:45:06.464302','2024-06-29 01:45:06.588520',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3159,'classify-tables',2,'2024-06-29 01:45:06.596164','2024-06-29 01:45:06.609569',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3160,'sync',2,'2024-06-29 02:45:00.106922','2024-06-29 02:45:04.533232',4426,NULL,'success'),(3161,'sync-dbms-version',2,'2024-06-29 02:45:00.115525','2024-06-29 02:45:00.126228',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3162,'sync-timezone',2,'2024-06-29 02:45:00.134760','2024-06-29 02:45:00.144393',9,'{\"timezone-id\":\"+08:00\"}','success'),(3163,'sync-tables',2,'2024-06-29 02:45:00.152359','2024-06-29 02:45:00.178425',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3164,'sync-fields',2,'2024-06-29 02:45:00.196639','2024-06-29 02:45:03.256890',3060,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3165,'sync-fks',2,'2024-06-29 02:45:03.266452','2024-06-29 02:45:03.934899',668,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3166,'sync-indexes',2,'2024-06-29 02:45:03.944958','2024-06-29 02:45:04.493689',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3167,'sync-metabase-metadata',2,'2024-06-29 02:45:04.501110','2024-06-29 02:45:04.508989',7,'{}','success'),(3168,'sync-table-privileges',2,'2024-06-29 02:45:04.517196','2024-06-29 02:45:04.525353',8,NULL,'success'),(3169,'analyze',2,'2024-06-29 02:45:04.558788','2024-06-29 02:45:06.621701',2062,NULL,'success'),(3170,'fingerprint-fields',2,'2024-06-29 02:45:04.566927','2024-06-29 02:45:06.464540',1897,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3171,'classify-fields',2,'2024-06-29 02:45:06.473188','2024-06-29 02:45:06.593294',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3172,'classify-tables',2,'2024-06-29 02:45:06.600865','2024-06-29 02:45:06.613946',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3173,'sync',2,'2024-06-29 03:45:00.107392','2024-06-29 03:45:04.653148',4545,NULL,'success'),(3174,'sync-dbms-version',2,'2024-06-29 03:45:00.116696','2024-06-29 03:45:00.126604',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3175,'sync-timezone',2,'2024-06-29 03:45:00.136035','2024-06-29 03:45:00.146369',10,'{\"timezone-id\":\"+08:00\"}','success'),(3176,'sync-tables',2,'2024-06-29 03:45:00.154663','2024-06-29 03:45:00.180531',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3177,'sync-fields',2,'2024-06-29 03:45:00.189022','2024-06-29 03:45:03.433989',3244,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3178,'sync-fks',2,'2024-06-29 03:45:03.441679','2024-06-29 03:45:04.054929',613,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3179,'sync-indexes',2,'2024-06-29 03:45:04.064524','2024-06-29 03:45:04.610366',545,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3180,'sync-metabase-metadata',2,'2024-06-29 03:45:04.618704','2024-06-29 03:45:04.626781',8,'{}','success'),(3181,'sync-table-privileges',2,'2024-06-29 03:45:04.635124','2024-06-29 03:45:04.644127',9,NULL,'success'),(3182,'analyze',2,'2024-06-29 03:45:04.683158','2024-06-29 03:45:06.684873',2001,NULL,'success'),(3183,'fingerprint-fields',2,'2024-06-29 03:45:04.692573','2024-06-29 03:45:06.526470',1833,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3184,'classify-fields',2,'2024-06-29 03:45:06.534739','2024-06-29 03:45:06.655413',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3185,'classify-tables',2,'2024-06-29 03:45:06.662851','2024-06-29 03:45:06.676517',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3186,'task-history-cleanup',NULL,'2024-06-29 04:00:00.067916','2024-06-29 04:00:00.094534',26,NULL,'success'),(3187,'sync',2,'2024-06-29 04:45:00.110797','2024-06-29 04:45:04.741633',4630,NULL,'success'),(3188,'sync-dbms-version',2,'2024-06-29 04:45:00.119174','2024-06-29 04:45:00.129444',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3189,'sync-timezone',2,'2024-06-29 04:45:00.138453','2024-06-29 04:45:00.152017',13,'{\"timezone-id\":\"+08:00\"}','success'),(3190,'sync-tables',2,'2024-06-29 04:45:00.161346','2024-06-29 04:45:00.192335',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3191,'sync-fields',2,'2024-06-29 04:45:00.201429','2024-06-29 04:45:03.353691',3152,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3192,'sync-fks',2,'2024-06-29 04:45:03.361981','2024-06-29 04:45:04.076803',714,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3193,'sync-indexes',2,'2024-06-29 04:45:04.087084','2024-06-29 04:45:04.695953',608,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3194,'sync-metabase-metadata',2,'2024-06-29 04:45:04.704407','2024-06-29 04:45:04.713919',9,'{}','success'),(3195,'sync-table-privileges',2,'2024-06-29 04:45:04.722689','2024-06-29 04:45:04.732031',9,NULL,'success'),(3196,'analyze',2,'2024-06-29 04:45:04.770933','2024-06-29 04:45:07.015183',2244,NULL,'success'),(3197,'fingerprint-fields',2,'2024-06-29 04:45:04.781883','2024-06-29 04:45:06.846297',2064,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3198,'classify-fields',2,'2024-06-29 04:45:06.854505','2024-06-29 04:45:06.982101',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3199,'classify-tables',2,'2024-06-29 04:45:06.989996','2024-06-29 04:45:07.005043',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3200,'sync',2,'2024-06-29 05:45:00.107467','2024-06-29 05:45:04.660266',4552,NULL,'success'),(3201,'sync-dbms-version',2,'2024-06-29 05:45:00.117199','2024-06-29 05:45:00.125936',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3202,'sync-timezone',2,'2024-06-29 05:45:00.134498','2024-06-29 05:45:00.145424',10,'{\"timezone-id\":\"+08:00\"}','success'),(3203,'sync-tables',2,'2024-06-29 05:45:00.154357','2024-06-29 05:45:00.182846',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3204,'sync-fields',2,'2024-06-29 05:45:00.192062','2024-06-29 05:45:03.351645',3159,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3205,'sync-fks',2,'2024-06-29 05:45:03.359177','2024-06-29 05:45:04.012406',653,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3206,'sync-indexes',2,'2024-06-29 05:45:04.021489','2024-06-29 05:45:04.618251',596,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3207,'sync-metabase-metadata',2,'2024-06-29 05:45:04.627034','2024-06-29 05:45:04.635484',8,'{}','success'),(3208,'sync-table-privileges',2,'2024-06-29 05:45:04.643872','2024-06-29 05:45:04.651801',7,NULL,'success'),(3209,'analyze',2,'2024-06-29 05:45:04.685551','2024-06-29 05:45:06.936073',2250,NULL,'success'),(3210,'fingerprint-fields',2,'2024-06-29 05:45:04.694420','2024-06-29 05:45:06.767569',2073,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3211,'classify-fields',2,'2024-06-29 05:45:06.776334','2024-06-29 05:45:06.904487',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3212,'classify-tables',2,'2024-06-29 05:45:06.912523','2024-06-29 05:45:06.927109',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3213,'sync',2,'2024-06-29 06:45:00.112973','2024-06-29 06:45:04.662781',4549,NULL,'success'),(3214,'sync-dbms-version',2,'2024-06-29 06:45:00.122237','2024-06-29 06:45:00.131485',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3215,'sync-timezone',2,'2024-06-29 06:45:00.139820','2024-06-29 06:45:00.149655',9,'{\"timezone-id\":\"+08:00\"}','success'),(3216,'sync-tables',2,'2024-06-29 06:45:00.158341','2024-06-29 06:45:00.204607',46,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3217,'sync-fields',2,'2024-06-29 06:45:00.214772','2024-06-29 06:45:03.443767',3228,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3218,'sync-fks',2,'2024-06-29 06:45:03.451880','2024-06-29 06:45:04.044526',592,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3219,'sync-indexes',2,'2024-06-29 06:45:04.053702','2024-06-29 06:45:04.617861',564,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3220,'sync-metabase-metadata',2,'2024-06-29 06:45:04.626098','2024-06-29 06:45:04.635626',9,'{}','success'),(3221,'sync-table-privileges',2,'2024-06-29 06:45:04.644223','2024-06-29 06:45:04.653199',8,NULL,'success'),(3222,'analyze',2,'2024-06-29 06:45:04.687453','2024-06-29 06:45:06.747135',2059,NULL,'success'),(3223,'fingerprint-fields',2,'2024-06-29 06:45:04.695646','2024-06-29 06:45:06.584285',1888,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3224,'classify-fields',2,'2024-06-29 06:45:06.592709','2024-06-29 06:45:06.714187',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3225,'classify-tables',2,'2024-06-29 06:45:06.721806','2024-06-29 06:45:06.737776',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3226,'sync',2,'2024-06-29 07:45:00.113699','2024-06-29 07:45:04.861883',4748,NULL,'success'),(3227,'sync-dbms-version',2,'2024-06-29 07:45:00.121394','2024-06-29 07:45:00.131145',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3228,'sync-timezone',2,'2024-06-29 07:45:00.140919','2024-06-29 07:45:00.152850',11,'{\"timezone-id\":\"+08:00\"}','success'),(3229,'sync-tables',2,'2024-06-29 07:45:00.162753','2024-06-29 07:45:00.197641',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3230,'sync-fields',2,'2024-06-29 07:45:00.206708','2024-06-29 07:45:03.502546',3295,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3231,'sync-fks',2,'2024-06-29 07:45:03.512569','2024-06-29 07:45:04.207946',695,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3232,'sync-indexes',2,'2024-06-29 07:45:04.216793','2024-06-29 07:45:04.814146',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3233,'sync-metabase-metadata',2,'2024-06-29 07:45:04.822848','2024-06-29 07:45:04.832760',9,'{}','success'),(3234,'sync-table-privileges',2,'2024-06-29 07:45:04.842785','2024-06-29 07:45:04.853232',10,NULL,'success'),(3235,'analyze',2,'2024-06-29 07:45:04.890363','2024-06-29 07:45:07.112150',2221,NULL,'success'),(3236,'fingerprint-fields',2,'2024-06-29 07:45:04.899005','2024-06-29 07:45:06.940017',2041,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3237,'classify-fields',2,'2024-06-29 07:45:06.948605','2024-06-29 07:45:07.076126',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3238,'classify-tables',2,'2024-06-29 07:45:07.084904','2024-06-29 07:45:07.102772',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3239,'sync',2,'2024-06-29 08:45:00.102086','2024-06-29 08:45:04.204250',4102,NULL,'success'),(3240,'sync-dbms-version',2,'2024-06-29 08:45:00.110126','2024-06-29 08:45:00.119259',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3241,'sync-timezone',2,'2024-06-29 08:45:00.129184','2024-06-29 08:45:00.139886',10,'{\"timezone-id\":\"+08:00\"}','success'),(3242,'sync-tables',2,'2024-06-29 08:45:00.149944','2024-06-29 08:45:00.178539',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3243,'sync-fields',2,'2024-06-29 08:45:00.186263','2024-06-29 08:45:03.087143',2900,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3244,'sync-fks',2,'2024-06-29 08:45:03.094979','2024-06-29 08:45:03.648843',553,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3245,'sync-indexes',2,'2024-06-29 08:45:03.656965','2024-06-29 08:45:04.162287',505,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3246,'sync-metabase-metadata',2,'2024-06-29 08:45:04.170658','2024-06-29 08:45:04.178643',7,'{}','success'),(3247,'sync-table-privileges',2,'2024-06-29 08:45:04.186853','2024-06-29 08:45:04.195924',9,NULL,'success'),(3248,'analyze',2,'2024-06-29 08:45:04.228465','2024-06-29 08:45:06.212881',1984,NULL,'success'),(3249,'fingerprint-fields',2,'2024-06-29 08:45:04.237406','2024-06-29 08:45:06.065371',1827,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3250,'classify-fields',2,'2024-06-29 08:45:06.073282','2024-06-29 08:45:06.182201',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3251,'classify-tables',2,'2024-06-29 08:45:06.190004','2024-06-29 08:45:06.204728',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3252,'sync',2,'2024-06-29 09:45:00.105323','2024-06-29 09:45:04.250393',4145,NULL,'success'),(3253,'sync-dbms-version',2,'2024-06-29 09:45:00.114248','2024-06-29 09:45:00.123542',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3254,'sync-timezone',2,'2024-06-29 09:45:00.133503','2024-06-29 09:45:00.143508',10,'{\"timezone-id\":\"+08:00\"}','success'),(3255,'sync-tables',2,'2024-06-29 09:45:00.152437','2024-06-29 09:45:00.179798',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3256,'sync-fields',2,'2024-06-29 09:45:00.188158','2024-06-29 09:45:03.067925',2879,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3257,'sync-fks',2,'2024-06-29 09:45:03.075914','2024-06-29 09:45:03.683763',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3258,'sync-indexes',2,'2024-06-29 09:45:03.692486','2024-06-29 09:45:04.207834',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3259,'sync-metabase-metadata',2,'2024-06-29 09:45:04.215574','2024-06-29 09:45:04.224798',9,'{}','success'),(3260,'sync-table-privileges',2,'2024-06-29 09:45:04.233594','2024-06-29 09:45:04.242068',8,NULL,'success'),(3261,'analyze',2,'2024-06-29 09:45:04.276443','2024-06-29 09:45:06.265079',1988,NULL,'success'),(3262,'fingerprint-fields',2,'2024-06-29 09:45:04.284354','2024-06-29 09:45:06.132627',1848,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3263,'classify-fields',2,'2024-06-29 09:45:06.140164','2024-06-29 09:45:06.237053',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3264,'classify-tables',2,'2024-06-29 09:45:06.243950','2024-06-29 09:45:06.257233',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3265,'sync',2,'2024-06-29 10:45:00.111802','2024-06-29 10:45:04.069293',3957,NULL,'success'),(3266,'sync-dbms-version',2,'2024-06-29 10:45:00.120403','2024-06-29 10:45:00.130554',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3267,'sync-timezone',2,'2024-06-29 10:45:00.139522','2024-06-29 10:45:00.152073',12,'{\"timezone-id\":\"+08:00\"}','success'),(3268,'sync-tables',2,'2024-06-29 10:45:00.161532','2024-06-29 10:45:00.196502',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3269,'sync-fields',2,'2024-06-29 10:45:00.206674','2024-06-29 10:45:02.982594',2775,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3270,'sync-fks',2,'2024-06-29 10:45:02.990093','2024-06-29 10:45:03.536483',546,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3271,'sync-indexes',2,'2024-06-29 10:45:03.545082','2024-06-29 10:45:04.030130',485,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3272,'sync-metabase-metadata',2,'2024-06-29 10:45:04.037308','2024-06-29 10:45:04.045133',7,'{}','success'),(3273,'sync-table-privileges',2,'2024-06-29 10:45:04.052961','2024-06-29 10:45:04.061519',8,NULL,'success'),(3274,'analyze',2,'2024-06-29 10:45:04.095464','2024-06-29 10:45:05.979876',1884,NULL,'success'),(3275,'fingerprint-fields',2,'2024-06-29 10:45:04.104934','2024-06-29 10:45:05.831969',1727,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3276,'classify-fields',2,'2024-06-29 10:45:05.839937','2024-06-29 10:45:05.948521',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3277,'classify-tables',2,'2024-06-29 10:45:05.957426','2024-06-29 10:45:05.971668',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3278,'sync',2,'2024-06-29 11:45:00.087142','2024-06-29 11:45:03.881620',3794,NULL,'success'),(3279,'sync-dbms-version',2,'2024-06-29 11:45:00.095677','2024-06-29 11:45:00.104045',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3280,'sync-timezone',2,'2024-06-29 11:45:00.112057','2024-06-29 11:45:00.121219',9,'{\"timezone-id\":\"+08:00\"}','success'),(3281,'sync-tables',2,'2024-06-29 11:45:00.128896','2024-06-29 11:45:00.154150',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3282,'sync-fields',2,'2024-06-29 11:45:00.161989','2024-06-29 11:45:02.823994',2662,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3283,'sync-fks',2,'2024-06-29 11:45:02.831932','2024-06-29 11:45:03.369332',537,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3284,'sync-indexes',2,'2024-06-29 11:45:03.377536','2024-06-29 11:45:03.841920',464,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3285,'sync-metabase-metadata',2,'2024-06-29 11:45:03.849103','2024-06-29 11:45:03.856532',7,'{}','success'),(3286,'sync-table-privileges',2,'2024-06-29 11:45:03.864709','2024-06-29 11:45:03.873540',8,NULL,'success'),(3287,'analyze',2,'2024-06-29 11:45:03.905359','2024-06-29 11:45:05.839380',1934,NULL,'success'),(3288,'fingerprint-fields',2,'2024-06-29 11:45:03.912965','2024-06-29 11:45:05.706447',1793,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3289,'classify-fields',2,'2024-06-29 11:45:05.714115','2024-06-29 11:45:05.810805',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3290,'classify-tables',2,'2024-06-29 11:45:05.817941','2024-06-29 11:45:05.830877',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3291,'sync',2,'2024-06-29 12:45:00.099321','2024-06-29 12:45:04.428880',4329,NULL,'success'),(3292,'sync-dbms-version',2,'2024-06-29 12:45:00.106891','2024-06-29 12:45:00.115896',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3293,'sync-timezone',2,'2024-06-29 12:45:00.124780','2024-06-29 12:45:00.134886',10,'{\"timezone-id\":\"+08:00\"}','success'),(3294,'sync-tables',2,'2024-06-29 12:45:00.142561','2024-06-29 12:45:00.166940',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3295,'sync-fields',2,'2024-06-29 12:45:00.174957','2024-06-29 12:45:03.107778',2932,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3296,'sync-fks',2,'2024-06-29 12:45:03.116267','2024-06-29 12:45:03.755696',639,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3297,'sync-indexes',2,'2024-06-29 12:45:03.765517','2024-06-29 12:45:04.387635',622,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3298,'sync-metabase-metadata',2,'2024-06-29 12:45:04.395159','2024-06-29 12:45:04.402510',7,'{}','success'),(3299,'sync-table-privileges',2,'2024-06-29 12:45:04.409831','2024-06-29 12:45:04.419401',9,NULL,'success'),(3300,'analyze',2,'2024-06-29 12:45:04.452511','2024-06-29 12:45:06.445440',1992,NULL,'success'),(3301,'fingerprint-fields',2,'2024-06-29 12:45:04.459841','2024-06-29 12:45:06.293872',1834,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3302,'classify-fields',2,'2024-06-29 12:45:06.302053','2024-06-29 12:45:06.414635',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3303,'classify-tables',2,'2024-06-29 12:45:06.422823','2024-06-29 12:45:06.437319',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3304,'field values scanning',2,'2024-06-29 13:00:00.092519','2024-06-29 13:00:11.884269',11791,NULL,'success'),(3305,'delete-expired-advanced-field-values',2,'2024-06-29 13:00:00.106108','2024-06-29 13:00:03.091665',2985,'{\"deleted\":0}','success'),(3306,'update-field-values',2,'2024-06-29 13:00:03.099169','2024-06-29 13:00:11.877385',8778,'{\"errors\":0,\"created\":0,\"updated\":32,\"deleted\":0}','success'),(3307,'sync',2,'2024-06-29 13:45:00.109278','2024-06-29 13:45:04.377441',4268,NULL,'success'),(3308,'sync-dbms-version',2,'2024-06-29 13:45:00.117343','2024-06-29 13:45:00.125931',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3309,'sync-timezone',2,'2024-06-29 13:45:00.134891','2024-06-29 13:45:00.145325',10,'{\"timezone-id\":\"+08:00\"}','success'),(3310,'sync-tables',2,'2024-06-29 13:45:00.154257','2024-06-29 13:45:00.183320',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3311,'sync-fields',2,'2024-06-29 13:45:00.191873','2024-06-29 13:45:03.136970',2945,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3312,'sync-fks',2,'2024-06-29 13:45:03.145678','2024-06-29 13:45:03.771858',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3313,'sync-indexes',2,'2024-06-29 13:45:03.780553','2024-06-29 13:45:04.336041',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3314,'sync-metabase-metadata',2,'2024-06-29 13:45:04.343747','2024-06-29 13:45:04.351897',8,'{}','success'),(3315,'sync-table-privileges',2,'2024-06-29 13:45:04.360083','2024-06-29 13:45:04.368034',7,NULL,'success'),(3316,'analyze',2,'2024-06-29 13:45:04.405602','2024-06-29 13:45:06.369963',1964,NULL,'success'),(3317,'fingerprint-fields',2,'2024-06-29 13:45:04.413886','2024-06-29 13:45:06.220619',1806,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3318,'classify-fields',2,'2024-06-29 13:45:06.229049','2024-06-29 13:45:06.341239',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3319,'classify-tables',2,'2024-06-29 13:45:06.348707','2024-06-29 13:45:06.362059',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3320,'sync',2,'2024-06-29 14:45:00.092421','2024-06-29 14:45:04.861428',4769,NULL,'success'),(3321,'sync-dbms-version',2,'2024-06-29 14:45:00.099964','2024-06-29 14:45:00.108994',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3322,'sync-timezone',2,'2024-06-29 14:45:00.117701','2024-06-29 14:45:00.128864',11,'{\"timezone-id\":\"+08:00\"}','success'),(3323,'sync-tables',2,'2024-06-29 14:45:00.139372','2024-06-29 14:45:00.167292',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3324,'sync-fields',2,'2024-06-29 14:45:00.175510','2024-06-29 14:45:03.108573',2933,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3325,'sync-fks',2,'2024-06-29 14:45:03.116762','2024-06-29 14:45:03.745024',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3326,'sync-indexes',2,'2024-06-29 14:45:03.753563','2024-06-29 14:45:04.820519',1066,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3327,'sync-metabase-metadata',2,'2024-06-29 14:45:04.828289','2024-06-29 14:45:04.836551',8,'{}','success'),(3328,'sync-table-privileges',2,'2024-06-29 14:45:04.844752','2024-06-29 14:45:04.852897',8,NULL,'success'),(3329,'analyze',2,'2024-06-29 14:45:04.888959','2024-06-29 14:45:06.924641',2035,NULL,'success'),(3330,'fingerprint-fields',2,'2024-06-29 14:45:04.897638','2024-06-29 14:45:06.773548',1875,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3331,'classify-fields',2,'2024-06-29 14:45:06.782174','2024-06-29 14:45:06.893926',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3332,'classify-tables',2,'2024-06-29 14:45:06.903143','2024-06-29 14:45:06.916749',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3333,'sync',2,'2024-06-29 15:45:00.112962','2024-06-29 15:45:04.769207',4656,NULL,'success'),(3334,'sync-dbms-version',2,'2024-06-29 15:45:00.121674','2024-06-29 15:45:00.131326',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3335,'sync-timezone',2,'2024-06-29 15:45:00.140836','2024-06-29 15:45:00.150715',9,'{\"timezone-id\":\"+08:00\"}','success'),(3336,'sync-tables',2,'2024-06-29 15:45:00.160225','2024-06-29 15:45:00.188501',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3337,'sync-fields',2,'2024-06-29 15:45:00.197392','2024-06-29 15:45:03.202242',3004,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3338,'sync-fks',2,'2024-06-29 15:45:03.213694','2024-06-29 15:45:03.871598',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3339,'sync-indexes',2,'2024-06-29 15:45:03.880813','2024-06-29 15:45:04.727941',847,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3340,'sync-metabase-metadata',2,'2024-06-29 15:45:04.735599','2024-06-29 15:45:04.744759',9,'{}','success'),(3341,'sync-table-privileges',2,'2024-06-29 15:45:04.752923','2024-06-29 15:45:04.760863',7,NULL,'success'),(3342,'analyze',2,'2024-06-29 15:45:04.797227','2024-06-29 15:45:06.894525',2097,NULL,'success'),(3343,'fingerprint-fields',2,'2024-06-29 15:45:04.805843','2024-06-29 15:45:06.722631',1916,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3344,'classify-fields',2,'2024-06-29 15:45:06.731808','2024-06-29 15:45:06.864614',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3345,'classify-tables',2,'2024-06-29 15:45:06.872195','2024-06-29 15:45:06.886269',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3346,'task-history-cleanup',NULL,'2024-06-29 16:00:00.026697','2024-06-29 16:00:00.077243',50,NULL,'success'),(3347,'task-history-cleanup',NULL,'2024-06-29 16:00:00.082152','2024-06-29 16:00:00.097471',15,NULL,'success'),(3348,'sync',2,'2024-06-29 16:45:00.108833','2024-06-29 16:45:04.541598',4432,NULL,'success'),(3349,'sync-dbms-version',2,'2024-06-29 16:45:00.116641','2024-06-29 16:45:00.125396',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3350,'sync-timezone',2,'2024-06-29 16:45:00.133370','2024-06-29 16:45:00.142621',9,'{\"timezone-id\":\"+08:00\"}','success'),(3351,'sync-tables',2,'2024-06-29 16:45:00.150707','2024-06-29 16:45:00.177952',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3352,'sync-fields',2,'2024-06-29 16:45:00.186260','2024-06-29 16:45:03.285416',3099,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3353,'sync-fks',2,'2024-06-29 16:45:03.292759','2024-06-29 16:45:03.922415',629,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3354,'sync-indexes',2,'2024-06-29 16:45:03.930508','2024-06-29 16:45:04.497014',566,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3355,'sync-metabase-metadata',2,'2024-06-29 16:45:04.505632','2024-06-29 16:45:04.514644',9,'{}','success'),(3356,'sync-table-privileges',2,'2024-06-29 16:45:04.523131','2024-06-29 16:45:04.532705',9,NULL,'success'),(3357,'analyze',2,'2024-06-29 16:45:04.572011','2024-06-29 16:45:06.659232',2087,NULL,'success'),(3358,'fingerprint-fields',2,'2024-06-29 16:45:04.581195','2024-06-29 16:45:06.527877',1946,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3359,'classify-fields',2,'2024-06-29 16:45:06.535459','2024-06-29 16:45:06.632319',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3360,'classify-tables',2,'2024-06-29 16:45:06.639405','2024-06-29 16:45:06.651492',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3361,'sync',2,'2024-06-29 17:45:00.097960','2024-06-29 17:45:04.509552',4411,NULL,'success'),(3362,'sync-dbms-version',2,'2024-06-29 17:45:00.106391','2024-06-29 17:45:00.115990',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3363,'sync-timezone',2,'2024-06-29 17:45:00.125445','2024-06-29 17:45:00.135631',10,'{\"timezone-id\":\"+08:00\"}','success'),(3364,'sync-tables',2,'2024-06-29 17:45:00.144722','2024-06-29 17:45:00.175708',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3365,'sync-fields',2,'2024-06-29 17:45:00.185171','2024-06-29 17:45:03.311969',3126,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3366,'sync-fks',2,'2024-06-29 17:45:03.319404','2024-06-29 17:45:03.930601',611,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3367,'sync-indexes',2,'2024-06-29 17:45:03.938661','2024-06-29 17:45:04.469102',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3368,'sync-metabase-metadata',2,'2024-06-29 17:45:04.476812','2024-06-29 17:45:04.484968',8,'{}','success'),(3369,'sync-table-privileges',2,'2024-06-29 17:45:04.493147','2024-06-29 17:45:04.501291',8,NULL,'success'),(3370,'analyze',2,'2024-06-29 17:45:04.532691','2024-06-29 17:45:06.533647',2000,NULL,'success'),(3371,'fingerprint-fields',2,'2024-06-29 17:45:04.541163','2024-06-29 17:45:06.385708',1844,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3372,'classify-fields',2,'2024-06-29 17:45:06.393732','2024-06-29 17:45:06.503018',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3373,'classify-tables',2,'2024-06-29 17:45:06.510760','2024-06-29 17:45:06.525047',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3374,'sync',2,'2024-06-29 18:45:00.096892','2024-06-29 18:45:04.611168',4514,NULL,'success'),(3375,'sync-dbms-version',2,'2024-06-29 18:45:00.104950','2024-06-29 18:45:00.113902',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3376,'sync-timezone',2,'2024-06-29 18:45:00.122038','2024-06-29 18:45:00.131308',9,'{\"timezone-id\":\"+08:00\"}','success'),(3377,'sync-tables',2,'2024-06-29 18:45:00.140223','2024-06-29 18:45:00.167105',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3378,'sync-fields',2,'2024-06-29 18:45:00.176248','2024-06-29 18:45:03.297659',3121,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3379,'sync-fks',2,'2024-06-29 18:45:03.304961','2024-06-29 18:45:03.988830',683,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3380,'sync-indexes',2,'2024-06-29 18:45:03.998096','2024-06-29 18:45:04.568923',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3381,'sync-metabase-metadata',2,'2024-06-29 18:45:04.576794','2024-06-29 18:45:04.586153',9,'{}','success'),(3382,'sync-table-privileges',2,'2024-06-29 18:45:04.594990','2024-06-29 18:45:04.603534',8,NULL,'success'),(3383,'analyze',2,'2024-06-29 18:45:04.646448','2024-06-29 18:45:06.865693',2219,NULL,'success'),(3384,'fingerprint-fields',2,'2024-06-29 18:45:04.657722','2024-06-29 18:45:06.706892',2049,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3385,'classify-fields',2,'2024-06-29 18:45:06.715786','2024-06-29 18:45:06.834736',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3386,'classify-tables',2,'2024-06-29 18:45:06.842738','2024-06-29 18:45:06.857631',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3387,'sync',2,'2024-06-29 19:45:00.107983','2024-06-29 19:45:04.626109',4518,NULL,'success'),(3388,'sync-dbms-version',2,'2024-06-29 19:45:00.116700','2024-06-29 19:45:00.127158',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3389,'sync-timezone',2,'2024-06-29 19:45:00.136119','2024-06-29 19:45:00.151988',15,'{\"timezone-id\":\"+08:00\"}','success'),(3390,'sync-tables',2,'2024-06-29 19:45:00.161246','2024-06-29 19:45:00.192833',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3391,'sync-fields',2,'2024-06-29 19:45:00.201907','2024-06-29 19:45:03.382773',3180,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3392,'sync-fks',2,'2024-06-29 19:45:03.391496','2024-06-29 19:45:04.047425',655,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3393,'sync-indexes',2,'2024-06-29 19:45:04.056039','2024-06-29 19:45:04.583919',527,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3394,'sync-metabase-metadata',2,'2024-06-29 19:45:04.591526','2024-06-29 19:45:04.599529',8,'{}','success'),(3395,'sync-table-privileges',2,'2024-06-29 19:45:04.608015','2024-06-29 19:45:04.617696',9,NULL,'success'),(3396,'analyze',2,'2024-06-29 19:45:04.651845','2024-06-29 19:45:06.948634',2296,NULL,'success'),(3397,'fingerprint-fields',2,'2024-06-29 19:45:04.660753','2024-06-29 19:45:06.778545',2117,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3398,'classify-fields',2,'2024-06-29 19:45:06.787298','2024-06-29 19:45:06.915756',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3399,'classify-tables',2,'2024-06-29 19:45:06.924003','2024-06-29 19:45:06.939653',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3400,'sync',2,'2024-06-29 20:45:00.109895','2024-06-29 20:45:04.646170',4536,NULL,'success'),(3401,'sync-dbms-version',2,'2024-06-29 20:45:00.118781','2024-06-29 20:45:00.128067',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3402,'sync-timezone',2,'2024-06-29 20:45:00.137372','2024-06-29 20:45:00.150038',12,'{\"timezone-id\":\"+08:00\"}','success'),(3403,'sync-tables',2,'2024-06-29 20:45:00.159163','2024-06-29 20:45:00.189470',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3404,'sync-fields',2,'2024-06-29 20:45:00.198369','2024-06-29 20:45:03.335199',3136,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3405,'sync-fks',2,'2024-06-29 20:45:03.343979','2024-06-29 20:45:04.018832',674,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3406,'sync-indexes',2,'2024-06-29 20:45:04.028338','2024-06-29 20:45:04.599391',571,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3407,'sync-metabase-metadata',2,'2024-06-29 20:45:04.607232','2024-06-29 20:45:04.616258',9,'{}','success'),(3408,'sync-table-privileges',2,'2024-06-29 20:45:04.625319','2024-06-29 20:45:04.637264',11,NULL,'success'),(3409,'analyze',2,'2024-06-29 20:45:04.670846','2024-06-29 20:45:06.788006',2117,NULL,'success'),(3410,'fingerprint-fields',2,'2024-06-29 20:45:04.679489','2024-06-29 20:45:06.628702',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3411,'classify-fields',2,'2024-06-29 20:45:06.637264','2024-06-29 20:45:06.756217',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3412,'classify-tables',2,'2024-06-29 20:45:06.764145','2024-06-29 20:45:06.779830',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3413,'sync',2,'2024-06-29 21:45:00.090406','2024-06-29 21:45:04.597133',4506,NULL,'success'),(3414,'sync-dbms-version',2,'2024-06-29 21:45:00.102565','2024-06-29 21:45:00.112784',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3415,'sync-timezone',2,'2024-06-29 21:45:00.121704','2024-06-29 21:45:00.131010',9,'{\"timezone-id\":\"+08:00\"}','success'),(3416,'sync-tables',2,'2024-06-29 21:45:00.138442','2024-06-29 21:45:00.163441',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3417,'sync-fields',2,'2024-06-29 21:45:00.171241','2024-06-29 21:45:03.344230',3172,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3418,'sync-fks',2,'2024-06-29 21:45:03.352376','2024-06-29 21:45:03.983650',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3419,'sync-indexes',2,'2024-06-29 21:45:03.992047','2024-06-29 21:45:04.554557',562,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3420,'sync-metabase-metadata',2,'2024-06-29 21:45:04.562054','2024-06-29 21:45:04.572113',10,'{}','success'),(3421,'sync-table-privileges',2,'2024-06-29 21:45:04.580173','2024-06-29 21:45:04.588261',8,NULL,'success'),(3422,'analyze',2,'2024-06-29 21:45:04.622234','2024-06-29 21:45:06.807552',2185,NULL,'success'),(3423,'fingerprint-fields',2,'2024-06-29 21:45:04.630525','2024-06-29 21:45:06.652494',2021,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3424,'classify-fields',2,'2024-06-29 21:45:06.661150','2024-06-29 21:45:06.773094',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3425,'classify-tables',2,'2024-06-29 21:45:06.784261','2024-06-29 21:45:06.799206',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3426,'sync',2,'2024-06-29 22:45:00.120206','2024-06-29 22:45:04.449745',4329,NULL,'success'),(3427,'sync-dbms-version',2,'2024-06-29 22:45:00.129107','2024-06-29 22:45:00.138665',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3428,'sync-timezone',2,'2024-06-29 22:45:00.147461','2024-06-29 22:45:00.157326',9,'{\"timezone-id\":\"+08:00\"}','success'),(3429,'sync-tables',2,'2024-06-29 22:45:00.165623','2024-06-29 22:45:00.198041',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3430,'sync-fields',2,'2024-06-29 22:45:00.207213','2024-06-29 22:45:03.234091',3026,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3431,'sync-fks',2,'2024-06-29 22:45:03.241785','2024-06-29 22:45:03.866977',625,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3432,'sync-indexes',2,'2024-06-29 22:45:03.874942','2024-06-29 22:45:04.409899',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3433,'sync-metabase-metadata',2,'2024-06-29 22:45:04.417341','2024-06-29 22:45:04.425652',8,'{}','success'),(3434,'sync-table-privileges',2,'2024-06-29 22:45:04.433931','2024-06-29 22:45:04.442125',8,NULL,'success'),(3435,'analyze',2,'2024-06-29 22:45:04.476713','2024-06-29 22:45:06.579859',2103,NULL,'success'),(3436,'fingerprint-fields',2,'2024-06-29 22:45:04.486133','2024-06-29 22:45:06.414097',1927,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3437,'classify-fields',2,'2024-06-29 22:45:06.423045','2024-06-29 22:45:06.546523',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3438,'classify-tables',2,'2024-06-29 22:45:06.554931','2024-06-29 22:45:06.571418',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3439,'sync',2,'2024-06-29 23:45:00.119112','2024-06-29 23:45:04.520398',4401,NULL,'success'),(3440,'sync-dbms-version',2,'2024-06-29 23:45:00.127353','2024-06-29 23:45:00.135935',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3441,'sync-timezone',2,'2024-06-29 23:45:00.143822','2024-06-29 23:45:00.153414',9,'{\"timezone-id\":\"+08:00\"}','success'),(3442,'sync-tables',2,'2024-06-29 23:45:00.163564','2024-06-29 23:45:00.193161',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3443,'sync-fields',2,'2024-06-29 23:45:00.201929','2024-06-29 23:45:03.256438',3054,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3444,'sync-fks',2,'2024-06-29 23:45:03.265616','2024-06-29 23:45:03.903132',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3445,'sync-indexes',2,'2024-06-29 23:45:03.911882','2024-06-29 23:45:04.477424',565,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3446,'sync-metabase-metadata',2,'2024-06-29 23:45:04.485084','2024-06-29 23:45:04.492827',7,'{}','success'),(3447,'sync-table-privileges',2,'2024-06-29 23:45:04.501656','2024-06-29 23:45:04.511040',9,NULL,'success'),(3448,'analyze',2,'2024-06-29 23:45:04.544942','2024-06-29 23:45:06.683172',2138,NULL,'success'),(3449,'fingerprint-fields',2,'2024-06-29 23:45:04.553315','2024-06-29 23:45:06.515310',1961,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3450,'classify-fields',2,'2024-06-29 23:45:06.523483','2024-06-29 23:45:06.651920',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3451,'classify-tables',2,'2024-06-29 23:45:06.659726','2024-06-29 23:45:06.674027',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3452,'sync',2,'2024-06-30 00:45:00.106662','2024-06-30 00:45:04.600537',4493,NULL,'success'),(3453,'sync-dbms-version',2,'2024-06-30 00:45:00.114599','2024-06-30 00:45:00.123422',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3454,'sync-timezone',2,'2024-06-30 00:45:00.132472','2024-06-30 00:45:00.143779',11,'{\"timezone-id\":\"+08:00\"}','success'),(3455,'sync-tables',2,'2024-06-30 00:45:00.152128','2024-06-30 00:45:00.179139',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3456,'sync-fields',2,'2024-06-30 00:45:00.189134','2024-06-30 00:45:03.337591',3148,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3457,'sync-fks',2,'2024-06-30 00:45:03.347173','2024-06-30 00:45:04.011018',663,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3458,'sync-indexes',2,'2024-06-30 00:45:04.019726','2024-06-30 00:45:04.556738',537,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3459,'sync-metabase-metadata',2,'2024-06-30 00:45:04.564642','2024-06-30 00:45:04.573847',9,'{}','success'),(3460,'sync-table-privileges',2,'2024-06-30 00:45:04.583075','2024-06-30 00:45:04.592105',9,NULL,'success'),(3461,'analyze',2,'2024-06-30 00:45:04.630395','2024-06-30 00:45:06.867743',2237,NULL,'success'),(3462,'fingerprint-fields',2,'2024-06-30 00:45:04.639434','2024-06-30 00:45:06.700175',2060,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3463,'classify-fields',2,'2024-06-30 00:45:06.708898','2024-06-30 00:45:06.837292',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3464,'classify-tables',2,'2024-06-30 00:45:06.845147','2024-06-30 00:45:06.859872',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3465,'sync',2,'2024-06-30 01:45:00.116875','2024-06-30 01:45:04.484926',4368,NULL,'success'),(3466,'sync-dbms-version',2,'2024-06-30 01:45:00.125784','2024-06-30 01:45:00.137849',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3467,'sync-timezone',2,'2024-06-30 01:45:00.146866','2024-06-30 01:45:00.159545',12,'{\"timezone-id\":\"+08:00\"}','success'),(3468,'sync-tables',2,'2024-06-30 01:45:00.168558','2024-06-30 01:45:00.196085',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3469,'sync-fields',2,'2024-06-30 01:45:00.205037','2024-06-30 01:45:03.239698',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3470,'sync-fks',2,'2024-06-30 01:45:03.248865','2024-06-30 01:45:03.897394',648,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3471,'sync-indexes',2,'2024-06-30 01:45:03.906363','2024-06-30 01:45:04.446415',540,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3472,'sync-metabase-metadata',2,'2024-06-30 01:45:04.453548','2024-06-30 01:45:04.461298',7,'{}','success'),(3473,'sync-table-privileges',2,'2024-06-30 01:45:04.469272','2024-06-30 01:45:04.477084',7,NULL,'success'),(3474,'analyze',2,'2024-06-30 01:45:04.508985','2024-06-30 01:45:06.670535',2161,NULL,'success'),(3475,'fingerprint-fields',2,'2024-06-30 01:45:04.517487','2024-06-30 01:45:06.500486',1983,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3476,'classify-fields',2,'2024-06-30 01:45:06.509233','2024-06-30 01:45:06.635414',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3477,'classify-tables',2,'2024-06-30 01:45:06.643807','2024-06-30 01:45:06.661087',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3478,'sync',2,'2024-06-30 02:45:00.104810','2024-06-30 02:45:04.946787',4841,NULL,'success'),(3479,'sync-dbms-version',2,'2024-06-30 02:45:00.112639','2024-06-30 02:45:00.120933',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3480,'sync-timezone',2,'2024-06-30 02:45:00.130800','2024-06-30 02:45:00.140950',10,'{\"timezone-id\":\"+08:00\"}','success'),(3481,'sync-tables',2,'2024-06-30 02:45:00.149788','2024-06-30 02:45:00.178875',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3482,'sync-fields',2,'2024-06-30 02:45:00.188420','2024-06-30 02:45:03.574208',3385,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3483,'sync-fks',2,'2024-06-30 02:45:03.582120','2024-06-30 02:45:04.284428',702,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3484,'sync-indexes',2,'2024-06-30 02:45:04.294027','2024-06-30 02:45:04.899352',605,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3485,'sync-metabase-metadata',2,'2024-06-30 02:45:04.907978','2024-06-30 02:45:04.917537',9,'{}','success'),(3486,'sync-table-privileges',2,'2024-06-30 02:45:04.927151','2024-06-30 02:45:04.937215',10,NULL,'success'),(3487,'analyze',2,'2024-06-30 02:45:04.975844','2024-06-30 02:45:07.107124',2131,NULL,'success'),(3488,'fingerprint-fields',2,'2024-06-30 02:45:04.985306','2024-06-30 02:45:06.939831',1954,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3489,'classify-fields',2,'2024-06-30 02:45:06.948517','2024-06-30 02:45:07.077598',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3490,'classify-tables',2,'2024-06-30 02:45:07.085037','2024-06-30 02:45:07.098639',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3491,'sync',2,'2024-06-30 03:45:00.113792','2024-06-30 03:45:04.784140',4670,NULL,'success'),(3492,'sync-dbms-version',2,'2024-06-30 03:45:00.121550','2024-06-30 03:45:00.130831',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3493,'sync-timezone',2,'2024-06-30 03:45:00.140132','2024-06-30 03:45:00.149831',9,'{\"timezone-id\":\"+08:00\"}','success'),(3494,'sync-tables',2,'2024-06-30 03:45:00.158079','2024-06-30 03:45:00.185164',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3495,'sync-fields',2,'2024-06-30 03:45:00.193735','2024-06-30 03:45:03.437967',3244,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3496,'sync-fks',2,'2024-06-30 03:45:03.448237','2024-06-30 03:45:04.156020',707,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3497,'sync-indexes',2,'2024-06-30 03:45:04.165802','2024-06-30 03:45:04.739512',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3498,'sync-metabase-metadata',2,'2024-06-30 03:45:04.747194','2024-06-30 03:45:04.755676',8,'{}','success'),(3499,'sync-table-privileges',2,'2024-06-30 03:45:04.764710','2024-06-30 03:45:04.774255',9,NULL,'success'),(3500,'analyze',2,'2024-06-30 03:45:04.813992','2024-06-30 03:45:07.015690',2201,NULL,'success'),(3501,'fingerprint-fields',2,'2024-06-30 03:45:04.823723','2024-06-30 03:45:06.856785',2033,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3502,'classify-fields',2,'2024-06-30 03:45:06.865631','2024-06-30 03:45:06.984131',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3503,'classify-tables',2,'2024-06-30 03:45:06.991741','2024-06-30 03:45:07.006954',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3504,'task-history-cleanup',NULL,'2024-06-30 04:00:00.061754','2024-06-30 04:00:00.101438',39,NULL,'success'),(3505,'sync',2,'2024-06-30 04:45:00.109163','2024-06-30 04:45:04.913264',4804,NULL,'success'),(3506,'sync-dbms-version',2,'2024-06-30 04:45:00.118083','2024-06-30 04:45:00.128693',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3507,'sync-timezone',2,'2024-06-30 04:45:00.137472','2024-06-30 04:45:00.148854',11,'{\"timezone-id\":\"+08:00\"}','success'),(3508,'sync-tables',2,'2024-06-30 04:45:00.157386','2024-06-30 04:45:00.186161',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3509,'sync-fields',2,'2024-06-30 04:45:00.195035','2024-06-30 04:45:03.431559',3236,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3510,'sync-fks',2,'2024-06-30 04:45:03.440387','2024-06-30 04:45:04.189489',749,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3511,'sync-indexes',2,'2024-06-30 04:45:04.199417','2024-06-30 04:45:04.866208',666,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3512,'sync-metabase-metadata',2,'2024-06-30 04:45:04.874828','2024-06-30 04:45:04.883464',8,'{}','success'),(3513,'sync-table-privileges',2,'2024-06-30 04:45:04.894233','2024-06-30 04:45:04.904373',10,NULL,'success'),(3514,'analyze',2,'2024-06-30 04:45:04.944500','2024-06-30 04:45:07.114759',2170,NULL,'success'),(3515,'fingerprint-fields',2,'2024-06-30 04:45:04.953368','2024-06-30 04:45:06.959193',2005,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3516,'classify-fields',2,'2024-06-30 04:45:06.968511','2024-06-30 04:45:07.082704',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3517,'classify-tables',2,'2024-06-30 04:45:07.090850','2024-06-30 04:45:07.106054',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3518,'sync',2,'2024-06-30 05:45:00.098276','2024-06-30 05:45:04.340538',4242,NULL,'success'),(3519,'sync-dbms-version',2,'2024-06-30 05:45:00.106622','2024-06-30 05:45:00.116864',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3520,'sync-timezone',2,'2024-06-30 05:45:00.125213','2024-06-30 05:45:00.135397',10,'{\"timezone-id\":\"+08:00\"}','success'),(3521,'sync-tables',2,'2024-06-30 05:45:00.144712','2024-06-30 05:45:00.174396',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3522,'sync-fields',2,'2024-06-30 05:45:00.184019','2024-06-30 05:45:03.154158',2970,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3523,'sync-fks',2,'2024-06-30 05:45:03.166255','2024-06-30 05:45:03.737598',571,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3524,'sync-indexes',2,'2024-06-30 05:45:03.746932','2024-06-30 05:45:04.289745',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3525,'sync-metabase-metadata',2,'2024-06-30 05:45:04.299941','2024-06-30 05:45:04.310549',10,'{}','success'),(3526,'sync-table-privileges',2,'2024-06-30 05:45:04.321788','2024-06-30 05:45:04.330092',8,NULL,'success'),(3527,'analyze',2,'2024-06-30 05:45:04.365088','2024-06-30 05:45:06.355763',1990,NULL,'success'),(3528,'fingerprint-fields',2,'2024-06-30 05:45:04.373177','2024-06-30 05:45:06.208721',1835,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3529,'classify-fields',2,'2024-06-30 05:45:06.217084','2024-06-30 05:45:06.326709',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3530,'classify-tables',2,'2024-06-30 05:45:06.334555','2024-06-30 05:45:06.347841',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3531,'sync',2,'2024-06-30 06:45:00.097678','2024-06-30 06:45:04.191130',4093,NULL,'success'),(3532,'sync-dbms-version',2,'2024-06-30 06:45:00.105545','2024-06-30 06:45:00.113919',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3533,'sync-timezone',2,'2024-06-30 06:45:00.121851','2024-06-30 06:45:00.132520',10,'{\"timezone-id\":\"+08:00\"}','success'),(3534,'sync-tables',2,'2024-06-30 06:45:00.141031','2024-06-30 06:45:00.167834',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3535,'sync-fields',2,'2024-06-30 06:45:00.176008','2024-06-30 06:45:03.057136',2881,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3536,'sync-fks',2,'2024-06-30 06:45:03.065130','2024-06-30 06:45:03.662861',597,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3537,'sync-indexes',2,'2024-06-30 06:45:03.671254','2024-06-30 06:45:04.148233',476,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3538,'sync-metabase-metadata',2,'2024-06-30 06:45:04.155989','2024-06-30 06:45:04.165397',9,'{}','success'),(3539,'sync-table-privileges',2,'2024-06-30 06:45:04.173840','2024-06-30 06:45:04.182605',8,NULL,'success'),(3540,'analyze',2,'2024-06-30 06:45:04.215517','2024-06-30 06:45:06.223597',2008,NULL,'success'),(3541,'fingerprint-fields',2,'2024-06-30 06:45:04.223223','2024-06-30 06:45:06.065274',1842,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3542,'classify-fields',2,'2024-06-30 06:45:06.073946','2024-06-30 06:45:06.191681',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3543,'classify-tables',2,'2024-06-30 06:45:06.199782','2024-06-30 06:45:06.214666',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3544,'sync',2,'2024-06-30 07:45:00.101560','2024-06-30 07:45:04.589446',4487,NULL,'success'),(3545,'sync-dbms-version',2,'2024-06-30 07:45:00.109420','2024-06-30 07:45:00.119164',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3546,'sync-timezone',2,'2024-06-30 07:45:00.127769','2024-06-30 07:45:00.139112',11,'{\"timezone-id\":\"+08:00\"}','success'),(3547,'sync-tables',2,'2024-06-30 07:45:00.148111','2024-06-30 07:45:00.174928',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3548,'sync-fields',2,'2024-06-30 07:45:00.184675','2024-06-30 07:45:03.287983',3103,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3549,'sync-fks',2,'2024-06-30 07:45:03.296448','2024-06-30 07:45:03.923636',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3550,'sync-indexes',2,'2024-06-30 07:45:03.933461','2024-06-30 07:45:04.547143',613,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3551,'sync-metabase-metadata',2,'2024-06-30 07:45:04.555718','2024-06-30 07:45:04.564372',8,'{}','success'),(3552,'sync-table-privileges',2,'2024-06-30 07:45:04.572945','2024-06-30 07:45:04.581475',8,NULL,'success'),(3553,'analyze',2,'2024-06-30 07:45:04.614396','2024-06-30 07:45:06.735240',2120,NULL,'success'),(3554,'fingerprint-fields',2,'2024-06-30 07:45:04.623159','2024-06-30 07:45:06.593011',1969,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3555,'classify-fields',2,'2024-06-30 07:45:06.600795','2024-06-30 07:45:06.705249',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3556,'classify-tables',2,'2024-06-30 07:45:06.712617','2024-06-30 07:45:06.725933',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3557,'sync',2,'2024-06-30 08:45:00.094934','2024-06-30 08:45:04.644609',4549,NULL,'success'),(3558,'sync-dbms-version',2,'2024-06-30 08:45:00.102754','2024-06-30 08:45:00.112696',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3559,'sync-timezone',2,'2024-06-30 08:45:00.121048','2024-06-30 08:45:00.130268',9,'{\"timezone-id\":\"+08:00\"}','success'),(3560,'sync-tables',2,'2024-06-30 08:45:00.138775','2024-06-30 08:45:00.164434',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3561,'sync-fields',2,'2024-06-30 08:45:00.173286','2024-06-30 08:45:03.354432',3181,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3562,'sync-fks',2,'2024-06-30 08:45:03.363027','2024-06-30 08:45:04.029457',666,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3563,'sync-indexes',2,'2024-06-30 08:45:04.038126','2024-06-30 08:45:04.601550',563,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3564,'sync-metabase-metadata',2,'2024-06-30 08:45:04.609334','2024-06-30 08:45:04.617742',8,'{}','success'),(3565,'sync-table-privileges',2,'2024-06-30 08:45:04.628084','2024-06-30 08:45:04.636303',8,NULL,'success'),(3566,'analyze',2,'2024-06-30 08:45:04.670395','2024-06-30 08:45:07.208718',2538,NULL,'success'),(3567,'fingerprint-fields',2,'2024-06-30 08:45:04.678770','2024-06-30 08:45:07.058296',2379,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3568,'classify-fields',2,'2024-06-30 08:45:07.066311','2024-06-30 08:45:07.179177',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3569,'classify-tables',2,'2024-06-30 08:45:07.186852','2024-06-30 08:45:07.200614',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3570,'sync',2,'2024-06-30 09:45:00.116996','2024-06-30 09:45:04.321023',4204,NULL,'success'),(3571,'sync-dbms-version',2,'2024-06-30 09:45:00.125230','2024-06-30 09:45:00.134123',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3572,'sync-timezone',2,'2024-06-30 09:45:00.142684','2024-06-30 09:45:00.153080',10,'{\"timezone-id\":\"+08:00\"}','success'),(3573,'sync-tables',2,'2024-06-30 09:45:00.163045','2024-06-30 09:45:00.192973',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3574,'sync-fields',2,'2024-06-30 09:45:00.203043','2024-06-30 09:45:03.153133',2950,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3575,'sync-fks',2,'2024-06-30 09:45:03.160881','2024-06-30 09:45:03.778414',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3576,'sync-indexes',2,'2024-06-30 09:45:03.786714','2024-06-30 09:45:04.281234',494,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3577,'sync-metabase-metadata',2,'2024-06-30 09:45:04.288929','2024-06-30 09:45:04.296556',7,'{}','success'),(3578,'sync-table-privileges',2,'2024-06-30 09:45:04.304774','2024-06-30 09:45:04.313143',8,NULL,'success'),(3579,'analyze',2,'2024-06-30 09:45:04.345717','2024-06-30 09:45:06.230750',1885,NULL,'success'),(3580,'fingerprint-fields',2,'2024-06-30 09:45:04.353275','2024-06-30 09:45:06.085021',1731,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3581,'classify-fields',2,'2024-06-30 09:45:06.093247','2024-06-30 09:45:06.198295',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3582,'classify-tables',2,'2024-06-30 09:45:06.205666','2024-06-30 09:45:06.222012',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3583,'sync',2,'2024-06-30 10:45:00.111795','2024-06-30 10:45:04.236226',4124,NULL,'success'),(3584,'sync-dbms-version',2,'2024-06-30 10:45:00.119909','2024-06-30 10:45:00.128975',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3585,'sync-timezone',2,'2024-06-30 10:45:00.137881','2024-06-30 10:45:00.148037',10,'{\"timezone-id\":\"+08:00\"}','success'),(3586,'sync-tables',2,'2024-06-30 10:45:00.157477','2024-06-30 10:45:00.189324',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3587,'sync-fields',2,'2024-06-30 10:45:00.198291','2024-06-30 10:45:03.231418',3033,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3588,'sync-fks',2,'2024-06-30 10:45:03.238963','2024-06-30 10:45:03.754661',515,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3589,'sync-indexes',2,'2024-06-30 10:45:03.762936','2024-06-30 10:45:04.198607',435,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3590,'sync-metabase-metadata',2,'2024-06-30 10:45:04.205461','2024-06-30 10:45:04.212729',7,'{}','success'),(3591,'sync-table-privileges',2,'2024-06-30 10:45:04.220841','2024-06-30 10:45:04.229043',8,NULL,'success'),(3592,'analyze',2,'2024-06-30 10:45:04.259540','2024-06-30 10:45:06.083773',1824,NULL,'success'),(3593,'fingerprint-fields',2,'2024-06-30 10:45:04.267072','2024-06-30 10:45:05.939406',1672,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3594,'classify-fields',2,'2024-06-30 10:45:05.946797','2024-06-30 10:45:06.053548',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3595,'classify-tables',2,'2024-06-30 10:45:06.061432','2024-06-30 10:45:06.075077',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3596,'sync',2,'2024-06-30 11:45:00.097981','2024-06-30 11:45:04.293770',4195,NULL,'success'),(3597,'sync-dbms-version',2,'2024-06-30 11:45:00.105847','2024-06-30 11:45:00.114832',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3598,'sync-timezone',2,'2024-06-30 11:45:00.123461','2024-06-30 11:45:00.133034',9,'{\"timezone-id\":\"+08:00\"}','success'),(3599,'sync-tables',2,'2024-06-30 11:45:00.141079','2024-06-30 11:45:00.166170',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3600,'sync-fields',2,'2024-06-30 11:45:00.175233','2024-06-30 11:45:03.098337',2923,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3601,'sync-fks',2,'2024-06-30 11:45:03.109756','2024-06-30 11:45:03.754927',645,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3602,'sync-indexes',2,'2024-06-30 11:45:03.766996','2024-06-30 11:45:04.253173',486,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3603,'sync-metabase-metadata',2,'2024-06-30 11:45:04.260861','2024-06-30 11:45:04.269021',8,'{}','success'),(3604,'sync-table-privileges',2,'2024-06-30 11:45:04.277175','2024-06-30 11:45:04.285530',8,NULL,'success'),(3605,'analyze',2,'2024-06-30 11:45:04.318156','2024-06-30 11:45:06.210564',1892,NULL,'success'),(3606,'fingerprint-fields',2,'2024-06-30 11:45:04.325873','2024-06-30 11:45:06.063113',1737,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3607,'classify-fields',2,'2024-06-30 11:45:06.071542','2024-06-30 11:45:06.180304',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3608,'classify-tables',2,'2024-06-30 11:45:06.187553','2024-06-30 11:45:06.202283',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3609,'sync',2,'2024-06-30 12:45:00.109340','2024-06-30 12:45:04.686115',4576,NULL,'success'),(3610,'sync-dbms-version',2,'2024-06-30 12:45:00.118177','2024-06-30 12:45:00.129103',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3611,'sync-timezone',2,'2024-06-30 12:45:00.137466','2024-06-30 12:45:00.147436',9,'{\"timezone-id\":\"+08:00\"}','success'),(3612,'sync-tables',2,'2024-06-30 12:45:00.156351','2024-06-30 12:45:00.185182',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3613,'sync-fields',2,'2024-06-30 12:45:00.194140','2024-06-30 12:45:03.271655',3077,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3614,'sync-fks',2,'2024-06-30 12:45:03.279620','2024-06-30 12:45:03.947660',668,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3615,'sync-indexes',2,'2024-06-30 12:45:03.956706','2024-06-30 12:45:04.643483',686,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3616,'sync-metabase-metadata',2,'2024-06-30 12:45:04.651400','2024-06-30 12:45:04.660184',8,'{}','success'),(3617,'sync-table-privileges',2,'2024-06-30 12:45:04.669014','2024-06-30 12:45:04.677688',8,NULL,'success'),(3618,'analyze',2,'2024-06-30 12:45:04.718715','2024-06-30 12:45:06.660954',1942,NULL,'success'),(3619,'fingerprint-fields',2,'2024-06-30 12:45:04.728099','2024-06-30 12:45:06.521189',1793,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3620,'classify-fields',2,'2024-06-30 12:45:06.528876','2024-06-30 12:45:06.631836',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3621,'classify-tables',2,'2024-06-30 12:45:06.639110','2024-06-30 12:45:06.652209',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3622,'field values scanning',2,'2024-06-30 13:00:00.072518','2024-06-30 13:00:11.406406',11333,NULL,'success'),(3623,'delete-expired-advanced-field-values',2,'2024-06-30 13:00:00.107334','2024-06-30 13:00:03.284173',3176,'{\"deleted\":0}','success'),(3624,'update-field-values',2,'2024-06-30 13:00:03.291777','2024-06-30 13:00:11.399015',8107,'{\"errors\":0,\"created\":0,\"updated\":46,\"deleted\":1}','success'),(3625,'sync',2,'2024-06-30 13:45:00.109254','2024-06-30 13:45:04.388081',4278,NULL,'success'),(3626,'sync-dbms-version',2,'2024-06-30 13:45:00.118381','2024-06-30 13:45:00.127520',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3627,'sync-timezone',2,'2024-06-30 13:45:00.136593','2024-06-30 13:45:00.148422',11,'{\"timezone-id\":\"+08:00\"}','success'),(3628,'sync-tables',2,'2024-06-30 13:45:00.158064','2024-06-30 13:45:00.189163',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3629,'sync-fields',2,'2024-06-30 13:45:00.204241','2024-06-30 13:45:03.249781',3045,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3630,'sync-fks',2,'2024-06-30 13:45:03.258306','2024-06-30 13:45:03.859711',601,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3631,'sync-indexes',2,'2024-06-30 13:45:03.868435','2024-06-30 13:45:04.347569',479,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3632,'sync-metabase-metadata',2,'2024-06-30 13:45:04.355037','2024-06-30 13:45:04.363194',8,'{}','success'),(3633,'sync-table-privileges',2,'2024-06-30 13:45:04.371598','2024-06-30 13:45:04.379613',8,NULL,'success'),(3634,'analyze',2,'2024-06-30 13:45:04.411626','2024-06-30 13:45:06.269443',1857,NULL,'success'),(3635,'fingerprint-fields',2,'2024-06-30 13:45:04.419534','2024-06-30 13:45:06.130175',1710,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3636,'classify-fields',2,'2024-06-30 13:45:06.137649','2024-06-30 13:45:06.240009',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3637,'classify-tables',2,'2024-06-30 13:45:06.247508','2024-06-30 13:45:06.260861',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3638,'sync',2,'2024-06-30 14:45:00.109937','2024-06-30 14:45:04.423794',4313,NULL,'success'),(3639,'sync-dbms-version',2,'2024-06-30 14:45:00.118594','2024-06-30 14:45:00.127530',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3640,'sync-timezone',2,'2024-06-30 14:45:00.136178','2024-06-30 14:45:00.145816',9,'{\"timezone-id\":\"+08:00\"}','success'),(3641,'sync-tables',2,'2024-06-30 14:45:00.154190','2024-06-30 14:45:00.181198',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3642,'sync-fields',2,'2024-06-30 14:45:00.189409','2024-06-30 14:45:03.192950',3003,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3643,'sync-fks',2,'2024-06-30 14:45:03.201415','2024-06-30 14:45:03.850394',648,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3644,'sync-indexes',2,'2024-06-30 14:45:03.858362','2024-06-30 14:45:04.384782',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3645,'sync-metabase-metadata',2,'2024-06-30 14:45:04.391918','2024-06-30 14:45:04.399215',7,'{}','success'),(3646,'sync-table-privileges',2,'2024-06-30 14:45:04.407671','2024-06-30 14:45:04.416292',8,NULL,'success'),(3647,'analyze',2,'2024-06-30 14:45:04.446949','2024-06-30 14:45:06.338164',1891,NULL,'success'),(3648,'fingerprint-fields',2,'2024-06-30 14:45:04.454857','2024-06-30 14:45:06.182533',1727,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3649,'classify-fields',2,'2024-06-30 14:45:06.191573','2024-06-30 14:45:06.307754',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3650,'classify-tables',2,'2024-06-30 14:45:06.316635','2024-06-30 14:45:06.329994',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3651,'sync',2,'2024-06-30 15:45:00.102676','2024-06-30 15:45:05.417273',5314,NULL,'success'),(3652,'sync-dbms-version',2,'2024-06-30 15:45:00.110900','2024-06-30 15:45:00.119964',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3653,'sync-timezone',2,'2024-06-30 15:45:00.128834','2024-06-30 15:45:00.142477',13,'{\"timezone-id\":\"+08:00\"}','success'),(3654,'sync-tables',2,'2024-06-30 15:45:00.151163','2024-06-30 15:45:00.178793',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3655,'sync-fields',2,'2024-06-30 15:45:00.187243','2024-06-30 15:45:03.248233',3060,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3656,'sync-fks',2,'2024-06-30 15:45:03.256552','2024-06-30 15:45:03.939533',682,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3657,'sync-indexes',2,'2024-06-30 15:45:03.949162','2024-06-30 15:45:05.371835',1422,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3658,'sync-metabase-metadata',2,'2024-06-30 15:45:05.380776','2024-06-30 15:45:05.389196',8,'{}','success'),(3659,'sync-table-privileges',2,'2024-06-30 15:45:05.398542','2024-06-30 15:45:05.407691',9,NULL,'success'),(3660,'analyze',2,'2024-06-30 15:45:05.446538','2024-06-30 15:45:07.557163',2110,NULL,'success'),(3661,'fingerprint-fields',2,'2024-06-30 15:45:05.455472','2024-06-30 15:45:07.376209',1920,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3662,'classify-fields',2,'2024-06-30 15:45:07.384793','2024-06-30 15:45:07.521443',136,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3663,'classify-tables',2,'2024-06-30 15:45:07.531387','2024-06-30 15:45:07.547651',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3664,'task-history-cleanup',NULL,'2024-06-30 16:00:00.012572','2024-06-30 16:00:00.095229',82,NULL,'success'),(3665,'task-history-cleanup',NULL,'2024-06-30 16:00:00.087056','2024-06-30 16:00:00.122700',35,NULL,'success'),(3666,'sync',2,'2024-06-30 16:45:00.109489','2024-06-30 16:45:04.434188',4324,NULL,'success'),(3667,'sync-dbms-version',2,'2024-06-30 16:45:00.118116','2024-06-30 16:45:00.128076',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3668,'sync-timezone',2,'2024-06-30 16:45:00.137071','2024-06-30 16:45:00.147982',10,'{\"timezone-id\":\"+08:00\"}','success'),(3669,'sync-tables',2,'2024-06-30 16:45:00.157372','2024-06-30 16:45:00.184781',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3670,'sync-fields',2,'2024-06-30 16:45:00.192998','2024-06-30 16:45:03.103834',2910,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3671,'sync-fks',2,'2024-06-30 16:45:03.114798','2024-06-30 16:45:03.720374',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3672,'sync-indexes',2,'2024-06-30 16:45:03.730348','2024-06-30 16:45:04.389524',659,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3673,'sync-metabase-metadata',2,'2024-06-30 16:45:04.397073','2024-06-30 16:45:04.404917',7,'{}','success'),(3674,'sync-table-privileges',2,'2024-06-30 16:45:04.414812','2024-06-30 16:45:04.424982',10,NULL,'success'),(3675,'analyze',2,'2024-06-30 16:45:04.458529','2024-06-30 16:45:06.591241',2132,NULL,'success'),(3676,'fingerprint-fields',2,'2024-06-30 16:45:04.466371','2024-06-30 16:45:06.427077',1960,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3677,'classify-fields',2,'2024-06-30 16:45:06.437509','2024-06-30 16:45:06.561078',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3678,'classify-tables',2,'2024-06-30 16:45:06.568670','2024-06-30 16:45:06.582689',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3679,'sync',2,'2024-06-30 17:45:00.102864','2024-06-30 17:45:04.875108',4772,NULL,'success'),(3680,'sync-dbms-version',2,'2024-06-30 17:45:00.113516','2024-06-30 17:45:00.123274',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3681,'sync-timezone',2,'2024-06-30 17:45:00.131896','2024-06-30 17:45:00.142168',10,'{\"timezone-id\":\"+08:00\"}','success'),(3682,'sync-tables',2,'2024-06-30 17:45:00.151238','2024-06-30 17:45:00.185401',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3683,'sync-fields',2,'2024-06-30 17:45:00.194511','2024-06-30 17:45:03.591454',3396,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3684,'sync-fks',2,'2024-06-30 17:45:03.599398','2024-06-30 17:45:04.272293',672,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3685,'sync-indexes',2,'2024-06-30 17:45:04.281644','2024-06-30 17:45:04.828384',546,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3686,'sync-metabase-metadata',2,'2024-06-30 17:45:04.837674','2024-06-30 17:45:04.847174',9,'{}','success'),(3687,'sync-table-privileges',2,'2024-06-30 17:45:04.855919','2024-06-30 17:45:04.865076',9,NULL,'success'),(3688,'analyze',2,'2024-06-30 17:45:04.900157','2024-06-30 17:45:07.077023',2176,NULL,'success'),(3689,'fingerprint-fields',2,'2024-06-30 17:45:04.907993','2024-06-30 17:45:06.894292',1986,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3690,'classify-fields',2,'2024-06-30 17:45:06.902643','2024-06-30 17:45:07.041279',138,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3691,'classify-tables',2,'2024-06-30 17:45:07.050947','2024-06-30 17:45:07.067953',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3692,'sync',2,'2024-06-30 18:45:00.119597','2024-06-30 18:45:04.777518',4657,NULL,'success'),(3693,'sync-dbms-version',2,'2024-06-30 18:45:00.128905','2024-06-30 18:45:00.139107',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3694,'sync-timezone',2,'2024-06-30 18:45:00.147902','2024-06-30 18:45:00.157760',9,'{\"timezone-id\":\"+08:00\"}','success'),(3695,'sync-tables',2,'2024-06-30 18:45:00.166023','2024-06-30 18:45:00.191940',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3696,'sync-fields',2,'2024-06-30 18:45:00.200247','2024-06-30 18:45:03.430884',3230,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3697,'sync-fks',2,'2024-06-30 18:45:03.440840','2024-06-30 18:45:04.122800',681,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3698,'sync-indexes',2,'2024-06-30 18:45:04.131930','2024-06-30 18:45:04.731479',599,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3699,'sync-metabase-metadata',2,'2024-06-30 18:45:04.740051','2024-06-30 18:45:04.749947',9,'{}','success'),(3700,'sync-table-privileges',2,'2024-06-30 18:45:04.758762','2024-06-30 18:45:04.767738',8,NULL,'success'),(3701,'analyze',2,'2024-06-30 18:45:04.808059','2024-06-30 18:45:07.023417',2215,NULL,'success'),(3702,'fingerprint-fields',2,'2024-06-30 18:45:04.817469','2024-06-30 18:45:06.855618',2038,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3703,'classify-fields',2,'2024-06-30 18:45:06.864868','2024-06-30 18:45:06.985346',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3704,'classify-tables',2,'2024-06-30 18:45:06.994294','2024-06-30 18:45:07.010358',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3705,'sync',2,'2024-06-30 19:45:00.100455','2024-06-30 19:45:04.722022',4621,NULL,'success'),(3706,'sync-dbms-version',2,'2024-06-30 19:45:00.110992','2024-06-30 19:45:00.120399',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3707,'sync-timezone',2,'2024-06-30 19:45:00.128635','2024-06-30 19:45:00.139662',11,'{\"timezone-id\":\"+08:00\"}','success'),(3708,'sync-tables',2,'2024-06-30 19:45:00.150041','2024-06-30 19:45:00.181975',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3709,'sync-fields',2,'2024-06-30 19:45:00.191113','2024-06-30 19:45:03.415281',3224,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3710,'sync-fks',2,'2024-06-30 19:45:03.424284','2024-06-30 19:45:04.086236',661,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3711,'sync-indexes',2,'2024-06-30 19:45:04.095710','2024-06-30 19:45:04.674968',579,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3712,'sync-metabase-metadata',2,'2024-06-30 19:45:04.683123','2024-06-30 19:45:04.693119',9,'{}','success'),(3713,'sync-table-privileges',2,'2024-06-30 19:45:04.701765','2024-06-30 19:45:04.710362',8,NULL,'success'),(3714,'analyze',2,'2024-06-30 19:45:04.747439','2024-06-30 19:45:06.959414',2211,NULL,'success'),(3715,'fingerprint-fields',2,'2024-06-30 19:45:04.755315','2024-06-30 19:45:06.785514',2030,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3716,'classify-fields',2,'2024-06-30 19:45:06.795648','2024-06-30 19:45:06.928514',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3717,'classify-tables',2,'2024-06-30 19:45:06.937220','2024-06-30 19:45:06.950926',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3718,'sync',2,'2024-06-30 20:45:00.107071','2024-06-30 20:45:04.539017',4431,NULL,'success'),(3719,'sync-dbms-version',2,'2024-06-30 20:45:00.117270','2024-06-30 20:45:00.126564',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3720,'sync-timezone',2,'2024-06-30 20:45:00.134619','2024-06-30 20:45:00.144390',9,'{\"timezone-id\":\"+08:00\"}','success'),(3721,'sync-tables',2,'2024-06-30 20:45:00.152667','2024-06-30 20:45:00.182517',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3722,'sync-fields',2,'2024-06-30 20:45:00.198269','2024-06-30 20:45:03.218451',3020,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3723,'sync-fks',2,'2024-06-30 20:45:03.227268','2024-06-30 20:45:03.890871',663,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3724,'sync-indexes',2,'2024-06-30 20:45:03.899742','2024-06-30 20:45:04.490632',590,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3725,'sync-metabase-metadata',2,'2024-06-30 20:45:04.499740','2024-06-30 20:45:04.509296',9,'{}','success'),(3726,'sync-table-privileges',2,'2024-06-30 20:45:04.518993','2024-06-30 20:45:04.529656',10,NULL,'success'),(3727,'analyze',2,'2024-06-30 20:45:04.565924','2024-06-30 20:45:06.713541',2147,NULL,'success'),(3728,'fingerprint-fields',2,'2024-06-30 20:45:04.574680','2024-06-30 20:45:06.555433',1980,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3729,'classify-fields',2,'2024-06-30 20:45:06.565327','2024-06-30 20:45:06.682467',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3730,'classify-tables',2,'2024-06-30 20:45:06.690096','2024-06-30 20:45:06.705022',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3731,'sync',2,'2024-06-30 21:45:00.107943','2024-06-30 21:45:04.725215',4617,NULL,'success'),(3732,'sync-dbms-version',2,'2024-06-30 21:45:00.117022','2024-06-30 21:45:00.126538',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3733,'sync-timezone',2,'2024-06-30 21:45:00.135206','2024-06-30 21:45:00.145142',9,'{\"timezone-id\":\"+08:00\"}','success'),(3734,'sync-tables',2,'2024-06-30 21:45:00.154247','2024-06-30 21:45:00.182038',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3735,'sync-fields',2,'2024-06-30 21:45:00.193148','2024-06-30 21:45:03.399840',3206,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3736,'sync-fks',2,'2024-06-30 21:45:03.407959','2024-06-30 21:45:04.085517',677,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3737,'sync-indexes',2,'2024-06-30 21:45:04.094259','2024-06-30 21:45:04.678444',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3738,'sync-metabase-metadata',2,'2024-06-30 21:45:04.686954','2024-06-30 21:45:04.697355',10,'{}','success'),(3739,'sync-table-privileges',2,'2024-06-30 21:45:04.706240','2024-06-30 21:45:04.716193',9,NULL,'success'),(3740,'analyze',2,'2024-06-30 21:45:04.751491','2024-06-30 21:45:07.139913',2388,NULL,'success'),(3741,'fingerprint-fields',2,'2024-06-30 21:45:04.761236','2024-06-30 21:45:06.968218',2206,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3742,'classify-fields',2,'2024-06-30 21:45:06.977009','2024-06-30 21:45:07.103942',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3743,'classify-tables',2,'2024-06-30 21:45:07.112623','2024-06-30 21:45:07.130129',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3744,'sync',2,'2024-06-30 22:45:00.103804','2024-06-30 22:45:04.296371',4192,NULL,'success'),(3745,'sync-dbms-version',2,'2024-06-30 22:45:00.112223','2024-06-30 22:45:00.121460',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3746,'sync-timezone',2,'2024-06-30 22:45:00.129756','2024-06-30 22:45:00.141395',11,'{\"timezone-id\":\"+08:00\"}','success'),(3747,'sync-tables',2,'2024-06-30 22:45:00.150796','2024-06-30 22:45:00.180003',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3748,'sync-fields',2,'2024-06-30 22:45:00.189261','2024-06-30 22:45:03.166078',2976,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3749,'sync-fks',2,'2024-06-30 22:45:03.173768','2024-06-30 22:45:03.730083',556,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3750,'sync-indexes',2,'2024-06-30 22:45:03.738485','2024-06-30 22:45:04.257722',519,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3751,'sync-metabase-metadata',2,'2024-06-30 22:45:04.264868','2024-06-30 22:45:04.273190',8,'{}','success'),(3752,'sync-table-privileges',2,'2024-06-30 22:45:04.281274','2024-06-30 22:45:04.288696',7,NULL,'success'),(3753,'analyze',2,'2024-06-30 22:45:04.321753','2024-06-30 22:45:06.422502',2100,NULL,'success'),(3754,'fingerprint-fields',2,'2024-06-30 22:45:04.330188','2024-06-30 22:45:06.261201',1931,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3755,'classify-fields',2,'2024-06-30 22:45:06.270131','2024-06-30 22:45:06.390995',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3756,'classify-tables',2,'2024-06-30 22:45:06.399039','2024-06-30 22:45:06.414029',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3757,'sync',2,'2024-06-30 23:45:00.111339','2024-06-30 23:45:04.399313',4287,NULL,'success'),(3758,'sync-dbms-version',2,'2024-06-30 23:45:00.119429','2024-06-30 23:45:00.128601',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3759,'sync-timezone',2,'2024-06-30 23:45:00.137816','2024-06-30 23:45:00.150204',12,'{\"timezone-id\":\"+08:00\"}','success'),(3760,'sync-tables',2,'2024-06-30 23:45:00.159406','2024-06-30 23:45:00.185384',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3761,'sync-fields',2,'2024-06-30 23:45:00.193904','2024-06-30 23:45:03.148478',2954,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3762,'sync-fks',2,'2024-06-30 23:45:03.156442','2024-06-30 23:45:03.763901',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3763,'sync-indexes',2,'2024-06-30 23:45:03.772068','2024-06-30 23:45:04.354457',582,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3764,'sync-metabase-metadata',2,'2024-06-30 23:45:04.362681','2024-06-30 23:45:04.371004',8,'{}','success'),(3765,'sync-table-privileges',2,'2024-06-30 23:45:04.379532','2024-06-30 23:45:04.390620',11,NULL,'success'),(3766,'analyze',2,'2024-06-30 23:45:04.428525','2024-06-30 23:45:06.549688',2121,NULL,'success'),(3767,'fingerprint-fields',2,'2024-06-30 23:45:04.438218','2024-06-30 23:45:06.387838',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3768,'classify-fields',2,'2024-06-30 23:45:06.396802','2024-06-30 23:45:06.514466',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3769,'classify-tables',2,'2024-06-30 23:45:06.523122','2024-06-30 23:45:06.540175',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3770,'sync',2,'2024-07-01 00:45:00.095876','2024-07-01 00:45:04.551639',4455,NULL,'success'),(3771,'sync-dbms-version',2,'2024-07-01 00:45:00.104529','2024-07-01 00:45:00.114830',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3772,'sync-timezone',2,'2024-07-01 00:45:00.124646','2024-07-01 00:45:00.136489',11,'{\"timezone-id\":\"+08:00\"}','success'),(3773,'sync-tables',2,'2024-07-01 00:45:00.145914','2024-07-01 00:45:00.172929',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3774,'sync-fields',2,'2024-07-01 00:45:00.181300','2024-07-01 00:45:03.283720',3102,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3775,'sync-fks',2,'2024-07-01 00:45:03.291736','2024-07-01 00:45:03.956415',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3776,'sync-indexes',2,'2024-07-01 00:45:03.965337','2024-07-01 00:45:04.508365',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3777,'sync-metabase-metadata',2,'2024-07-01 00:45:04.516887','2024-07-01 00:45:04.525631',8,'{}','success'),(3778,'sync-table-privileges',2,'2024-07-01 00:45:04.534147','2024-07-01 00:45:04.542770',8,NULL,'success'),(3779,'analyze',2,'2024-07-01 00:45:04.584441','2024-07-01 00:45:06.550152',1965,NULL,'success'),(3780,'fingerprint-fields',2,'2024-07-01 00:45:04.593908','2024-07-01 00:45:06.399662',1805,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3781,'classify-fields',2,'2024-07-01 00:45:06.407745','2024-07-01 00:45:06.520749',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3782,'classify-tables',2,'2024-07-01 00:45:06.528030','2024-07-01 00:45:06.540750',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3783,'sync',2,'2024-07-01 01:45:00.100922','2024-07-01 01:45:04.584050',4483,NULL,'success'),(3784,'sync-dbms-version',2,'2024-07-01 01:45:00.110650','2024-07-01 01:45:00.120967',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3785,'sync-timezone',2,'2024-07-01 01:45:00.129208','2024-07-01 01:45:00.138627',9,'{\"timezone-id\":\"+08:00\"}','success'),(3786,'sync-tables',2,'2024-07-01 01:45:00.147542','2024-07-01 01:45:00.176128',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3787,'sync-fields',2,'2024-07-01 01:45:00.184468','2024-07-01 01:45:03.307503',3123,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3788,'sync-fks',2,'2024-07-01 01:45:03.315794','2024-07-01 01:45:03.949105',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3789,'sync-indexes',2,'2024-07-01 01:45:03.958749','2024-07-01 01:45:04.537354',578,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3790,'sync-metabase-metadata',2,'2024-07-01 01:45:04.546025','2024-07-01 01:45:04.555670',9,'{}','success'),(3791,'sync-table-privileges',2,'2024-07-01 01:45:04.565923','2024-07-01 01:45:04.574220',8,NULL,'success'),(3792,'analyze',2,'2024-07-01 01:45:04.614260','2024-07-01 01:45:06.699975',2085,NULL,'success'),(3793,'fingerprint-fields',2,'2024-07-01 01:45:04.622444','2024-07-01 01:45:06.554399',1931,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3794,'classify-fields',2,'2024-07-01 01:45:06.562446','2024-07-01 01:45:06.671265',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3795,'classify-tables',2,'2024-07-01 01:45:06.678803','2024-07-01 01:45:06.692090',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3796,'sync',2,'2024-07-01 02:45:00.106943','2024-07-01 02:45:04.859433',4752,NULL,'success'),(3797,'sync-dbms-version',2,'2024-07-01 02:45:00.115789','2024-07-01 02:45:00.127344',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3798,'sync-timezone',2,'2024-07-01 02:45:00.137039','2024-07-01 02:45:00.148251',11,'{\"timezone-id\":\"+08:00\"}','success'),(3799,'sync-tables',2,'2024-07-01 02:45:00.158013','2024-07-01 02:45:00.192125',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3800,'sync-fields',2,'2024-07-01 02:45:00.202798','2024-07-01 02:45:03.554883',3352,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3801,'sync-fks',2,'2024-07-01 02:45:03.562909','2024-07-01 02:45:04.217208',654,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3802,'sync-indexes',2,'2024-07-01 02:45:04.227026','2024-07-01 02:45:04.811505',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3803,'sync-metabase-metadata',2,'2024-07-01 02:45:04.819274','2024-07-01 02:45:04.827755',8,'{}','success'),(3804,'sync-table-privileges',2,'2024-07-01 02:45:04.838101','2024-07-01 02:45:04.849659',11,NULL,'success'),(3805,'analyze',2,'2024-07-01 02:45:04.892895','2024-07-01 02:45:06.999226',2106,NULL,'success'),(3806,'fingerprint-fields',2,'2024-07-01 02:45:04.902156','2024-07-01 02:45:06.840707',1938,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3807,'classify-fields',2,'2024-07-01 02:45:06.849489','2024-07-01 02:45:06.966060',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3808,'classify-tables',2,'2024-07-01 02:45:06.973784','2024-07-01 02:45:06.991055',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3809,'sync',2,'2024-07-01 03:45:00.108348','2024-07-01 03:45:04.092235',3983,NULL,'success'),(3810,'sync-dbms-version',2,'2024-07-01 03:45:00.117730','2024-07-01 03:45:00.127006',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3811,'sync-timezone',2,'2024-07-01 03:45:00.135520','2024-07-01 03:45:00.145885',10,'{\"timezone-id\":\"+08:00\"}','success'),(3812,'sync-tables',2,'2024-07-01 03:45:00.153690','2024-07-01 03:45:00.180606',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3813,'sync-fields',2,'2024-07-01 03:45:00.188540','2024-07-01 03:45:02.939038',2750,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3814,'sync-fks',2,'2024-07-01 03:45:02.947371','2024-07-01 03:45:03.548495',601,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3815,'sync-indexes',2,'2024-07-01 03:45:03.557979','2024-07-01 03:45:04.053253',495,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3816,'sync-metabase-metadata',2,'2024-07-01 03:45:04.061350','2024-07-01 03:45:04.069094',7,'{}','success'),(3817,'sync-table-privileges',2,'2024-07-01 03:45:04.076752','2024-07-01 03:45:04.084542',7,NULL,'success'),(3818,'analyze',2,'2024-07-01 03:45:04.115461','2024-07-01 03:45:06.078776',1963,NULL,'success'),(3819,'fingerprint-fields',2,'2024-07-01 03:45:04.124950','2024-07-01 03:45:05.931201',1806,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3820,'classify-fields',2,'2024-07-01 03:45:05.939727','2024-07-01 03:45:06.048077',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3821,'classify-tables',2,'2024-07-01 03:45:06.056229','2024-07-01 03:45:06.070807',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3822,'task-history-cleanup',NULL,'2024-07-01 04:00:00.099232','2024-07-01 04:00:00.109966',10,NULL,'success'),(3823,'sync',2,'2024-07-01 04:45:00.116181','2024-07-01 04:45:04.459386',4343,NULL,'success'),(3824,'sync-dbms-version',2,'2024-07-01 04:45:00.124474','2024-07-01 04:45:00.136119',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3825,'sync-timezone',2,'2024-07-01 04:45:00.145150','2024-07-01 04:45:00.155142',9,'{\"timezone-id\":\"+08:00\"}','success'),(3826,'sync-tables',2,'2024-07-01 04:45:00.163185','2024-07-01 04:45:00.189670',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3827,'sync-fields',2,'2024-07-01 04:45:00.198548','2024-07-01 04:45:03.214172',3015,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3828,'sync-fks',2,'2024-07-01 04:45:03.223075','2024-07-01 04:45:03.846565',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3829,'sync-indexes',2,'2024-07-01 04:45:03.856326','2024-07-01 04:45:04.412633',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3830,'sync-metabase-metadata',2,'2024-07-01 04:45:04.421002','2024-07-01 04:45:04.430990',9,'{}','success'),(3831,'sync-table-privileges',2,'2024-07-01 04:45:04.440326','2024-07-01 04:45:04.448848',8,NULL,'success'),(3832,'analyze',2,'2024-07-01 04:45:04.485481','2024-07-01 04:45:06.631378',2145,NULL,'success'),(3833,'fingerprint-fields',2,'2024-07-01 04:45:04.494207','2024-07-01 04:45:06.458074',1963,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3834,'classify-fields',2,'2024-07-01 04:45:06.466158','2024-07-01 04:45:06.595560',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3835,'classify-tables',2,'2024-07-01 04:45:06.605717','2024-07-01 04:45:06.622010',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3836,'sync',2,'2024-07-01 05:45:00.104650','2024-07-01 05:45:04.731221',4626,NULL,'success'),(3837,'sync-dbms-version',2,'2024-07-01 05:45:00.113160','2024-07-01 05:45:00.124752',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3838,'sync-timezone',2,'2024-07-01 05:45:00.134789','2024-07-01 05:45:00.146225',11,'{\"timezone-id\":\"+08:00\"}','success'),(3839,'sync-tables',2,'2024-07-01 05:45:00.156272','2024-07-01 05:45:00.188824',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3840,'sync-fields',2,'2024-07-01 05:45:00.198504','2024-07-01 05:45:03.364566',3166,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3841,'sync-fks',2,'2024-07-01 05:45:03.373282','2024-07-01 05:45:04.062386',689,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3842,'sync-indexes',2,'2024-07-01 05:45:04.071698','2024-07-01 05:45:04.684304',612,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3843,'sync-metabase-metadata',2,'2024-07-01 05:45:04.693415','2024-07-01 05:45:04.703606',10,'{}','success'),(3844,'sync-table-privileges',2,'2024-07-01 05:45:04.713001','2024-07-01 05:45:04.721422',8,NULL,'success'),(3845,'analyze',2,'2024-07-01 05:45:04.757378','2024-07-01 05:45:06.849463',2092,NULL,'success'),(3846,'fingerprint-fields',2,'2024-07-01 05:45:04.767542','2024-07-01 05:45:06.695634',1928,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3847,'classify-fields',2,'2024-07-01 05:45:06.703859','2024-07-01 05:45:06.817908',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3848,'classify-tables',2,'2024-07-01 05:45:06.826111','2024-07-01 05:45:06.841450',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3849,'sync',2,'2024-07-01 06:45:00.113333','2024-07-01 06:45:04.562751',4449,NULL,'success'),(3850,'sync-dbms-version',2,'2024-07-01 06:45:00.122551','2024-07-01 06:45:00.134219',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3851,'sync-timezone',2,'2024-07-01 06:45:00.144147','2024-07-01 06:45:00.155035',10,'{\"timezone-id\":\"+08:00\"}','success'),(3852,'sync-tables',2,'2024-07-01 06:45:00.163519','2024-07-01 06:45:00.192236',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3853,'sync-fields',2,'2024-07-01 06:45:00.200879','2024-07-01 06:45:03.280421',3079,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3854,'sync-fks',2,'2024-07-01 06:45:03.288429','2024-07-01 06:45:03.953171',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3855,'sync-indexes',2,'2024-07-01 06:45:03.961773','2024-07-01 06:45:04.518317',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3856,'sync-metabase-metadata',2,'2024-07-01 06:45:04.526149','2024-07-01 06:45:04.535896',9,'{}','success'),(3857,'sync-table-privileges',2,'2024-07-01 06:45:04.544512','2024-07-01 06:45:04.554214',9,NULL,'success'),(3858,'analyze',2,'2024-07-01 06:45:04.593425','2024-07-01 06:45:06.735507',2142,NULL,'success'),(3859,'fingerprint-fields',2,'2024-07-01 06:45:04.603409','2024-07-01 06:45:06.583346',1979,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3860,'classify-fields',2,'2024-07-01 06:45:06.591564','2024-07-01 06:45:06.704836',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3861,'classify-tables',2,'2024-07-01 06:45:06.712801','2024-07-01 06:45:06.727630',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3862,'sync',2,'2024-07-01 07:45:00.099626','2024-07-01 07:45:04.903251',4803,NULL,'success'),(3863,'sync-dbms-version',2,'2024-07-01 07:45:00.107873','2024-07-01 07:45:00.118620',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3864,'sync-timezone',2,'2024-07-01 07:45:00.129436','2024-07-01 07:45:00.140350',10,'{\"timezone-id\":\"+08:00\"}','success'),(3865,'sync-tables',2,'2024-07-01 07:45:00.148894','2024-07-01 07:45:00.179238',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3866,'sync-fields',2,'2024-07-01 07:45:00.188754','2024-07-01 07:45:03.565775',3377,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3867,'sync-fks',2,'2024-07-01 07:45:03.574739','2024-07-01 07:45:04.259882',685,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3868,'sync-indexes',2,'2024-07-01 07:45:04.269480','2024-07-01 07:45:04.854535',585,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3869,'sync-metabase-metadata',2,'2024-07-01 07:45:04.863393','2024-07-01 07:45:04.872640',9,'{}','success'),(3870,'sync-table-privileges',2,'2024-07-01 07:45:04.883290','2024-07-01 07:45:04.894065',10,NULL,'success'),(3871,'analyze',2,'2024-07-01 07:45:04.929085','2024-07-01 07:45:07.116165',2187,NULL,'success'),(3872,'fingerprint-fields',2,'2024-07-01 07:45:04.939644','2024-07-01 07:45:06.939261',1999,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3873,'classify-fields',2,'2024-07-01 07:45:06.948191','2024-07-01 07:45:07.082652',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3874,'classify-tables',2,'2024-07-01 07:45:07.091236','2024-07-01 07:45:07.106270',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3875,'sync',2,'2024-07-01 08:45:00.100390','2024-07-01 08:45:04.159639',4059,NULL,'success'),(3876,'sync-dbms-version',2,'2024-07-01 08:45:00.108854','2024-07-01 08:45:00.119455',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3877,'sync-timezone',2,'2024-07-01 08:45:00.131556','2024-07-01 08:45:00.141683',10,'{\"timezone-id\":\"+08:00\"}','success'),(3878,'sync-tables',2,'2024-07-01 08:45:00.150104','2024-07-01 08:45:00.179098',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3879,'sync-fields',2,'2024-07-01 08:45:00.188104','2024-07-01 08:45:03.013119',2825,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3880,'sync-fks',2,'2024-07-01 08:45:03.020947','2024-07-01 08:45:03.610441',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3881,'sync-indexes',2,'2024-07-01 08:45:03.619156','2024-07-01 08:45:04.116034',496,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3882,'sync-metabase-metadata',2,'2024-07-01 08:45:04.124055','2024-07-01 08:45:04.134722',10,'{}','success'),(3883,'sync-table-privileges',2,'2024-07-01 08:45:04.142607','2024-07-01 08:45:04.151388',8,NULL,'success'),(3884,'analyze',2,'2024-07-01 08:45:04.183981','2024-07-01 08:45:06.099786',1915,NULL,'success'),(3885,'fingerprint-fields',2,'2024-07-01 08:45:04.192137','2024-07-01 08:45:05.955003',1762,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3886,'classify-fields',2,'2024-07-01 08:45:05.963793','2024-07-01 08:45:06.069553',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3887,'classify-tables',2,'2024-07-01 08:45:06.077440','2024-07-01 08:45:06.091152',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3888,'sync',2,'2024-07-01 09:45:00.096881','2024-07-01 09:45:04.020388',3923,NULL,'success'),(3889,'sync-dbms-version',2,'2024-07-01 09:45:00.104451','2024-07-01 09:45:00.114635',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3890,'sync-timezone',2,'2024-07-01 09:45:00.122661','2024-07-01 09:45:00.132310',9,'{\"timezone-id\":\"+08:00\"}','success'),(3891,'sync-tables',2,'2024-07-01 09:45:00.140744','2024-07-01 09:45:00.166108',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3892,'sync-fields',2,'2024-07-01 09:45:00.174254','2024-07-01 09:45:02.939369',2765,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3893,'sync-fks',2,'2024-07-01 09:45:02.947030','2024-07-01 09:45:03.494889',547,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3894,'sync-indexes',2,'2024-07-01 09:45:03.503816','2024-07-01 09:45:03.977170',473,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3895,'sync-metabase-metadata',2,'2024-07-01 09:45:03.984670','2024-07-01 09:45:03.993191',8,'{}','success'),(3896,'sync-table-privileges',2,'2024-07-01 09:45:04.001321','2024-07-01 09:45:04.011492',10,NULL,'success'),(3897,'analyze',2,'2024-07-01 09:45:04.047284','2024-07-01 09:45:05.934136',1886,NULL,'success'),(3898,'fingerprint-fields',2,'2024-07-01 09:45:04.056077','2024-07-01 09:45:05.793728',1737,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3899,'classify-fields',2,'2024-07-01 09:45:05.801599','2024-07-01 09:45:05.904462',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3900,'classify-tables',2,'2024-07-01 09:45:05.912457','2024-07-01 09:45:05.925953',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3901,'sync',2,'2024-07-01 10:45:00.107649','2024-07-01 10:45:04.184984',4077,NULL,'success'),(3902,'sync-dbms-version',2,'2024-07-01 10:45:00.115751','2024-07-01 10:45:00.124737',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3903,'sync-timezone',2,'2024-07-01 10:45:00.135283','2024-07-01 10:45:00.146366',11,'{\"timezone-id\":\"+08:00\"}','success'),(3904,'sync-tables',2,'2024-07-01 10:45:00.155251','2024-07-01 10:45:00.185616',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3905,'sync-fields',2,'2024-07-01 10:45:00.194082','2024-07-01 10:45:03.092248',2898,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3906,'sync-fks',2,'2024-07-01 10:45:03.100875','2024-07-01 10:45:03.674725',573,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3907,'sync-indexes',2,'2024-07-01 10:45:03.682631','2024-07-01 10:45:04.146426',463,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3908,'sync-metabase-metadata',2,'2024-07-01 10:45:04.153435','2024-07-01 10:45:04.160729',7,'{}','success'),(3909,'sync-table-privileges',2,'2024-07-01 10:45:04.169033','2024-07-01 10:45:04.177570',8,NULL,'success'),(3910,'analyze',2,'2024-07-01 10:45:04.208449','2024-07-01 10:45:06.236869',2028,NULL,'success'),(3911,'fingerprint-fields',2,'2024-07-01 10:45:04.216761','2024-07-01 10:45:06.083603',1866,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3912,'classify-fields',2,'2024-07-01 10:45:06.092426','2024-07-01 10:45:06.207622',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3913,'classify-tables',2,'2024-07-01 10:45:06.215836','2024-07-01 10:45:06.229003',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3914,'sync',2,'2024-07-01 11:45:00.110808','2024-07-01 11:45:04.181063',4070,NULL,'success'),(3915,'sync-dbms-version',2,'2024-07-01 11:45:00.119564','2024-07-01 11:45:00.128249',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3916,'sync-timezone',2,'2024-07-01 11:45:00.136635','2024-07-01 11:45:00.147992',11,'{\"timezone-id\":\"+08:00\"}','success'),(3917,'sync-tables',2,'2024-07-01 11:45:00.156352','2024-07-01 11:45:00.182938',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3918,'sync-fields',2,'2024-07-01 11:45:00.190621','2024-07-01 11:45:03.057991',2867,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3919,'sync-fks',2,'2024-07-01 11:45:03.065521','2024-07-01 11:45:03.634596',569,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3920,'sync-indexes',2,'2024-07-01 11:45:03.642171','2024-07-01 11:45:04.135669',493,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3921,'sync-metabase-metadata',2,'2024-07-01 11:45:04.143822','2024-07-01 11:45:04.153955',10,'{}','success'),(3922,'sync-table-privileges',2,'2024-07-01 11:45:04.163224','2024-07-01 11:45:04.171660',8,NULL,'success'),(3923,'analyze',2,'2024-07-01 11:45:04.209646','2024-07-01 11:45:06.221443',2011,NULL,'success'),(3924,'fingerprint-fields',2,'2024-07-01 11:45:04.218238','2024-07-01 11:45:06.080847',1862,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3925,'classify-fields',2,'2024-07-01 11:45:06.088971','2024-07-01 11:45:06.193307',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3926,'classify-tables',2,'2024-07-01 11:45:06.201155','2024-07-01 11:45:06.213914',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3927,'sync',2,'2024-07-01 12:45:00.096884','2024-07-01 12:45:03.884620',3787,NULL,'success'),(3928,'sync-dbms-version',2,'2024-07-01 12:45:00.105521','2024-07-01 12:45:00.114323',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3929,'sync-timezone',2,'2024-07-01 12:45:00.122882','2024-07-01 12:45:00.132022',9,'{\"timezone-id\":\"+08:00\"}','success'),(3930,'sync-tables',2,'2024-07-01 12:45:00.139746','2024-07-01 12:45:00.166898',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3931,'sync-fields',2,'2024-07-01 12:45:00.175602','2024-07-01 12:45:02.835439',2659,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3932,'sync-fks',2,'2024-07-01 12:45:02.842462','2024-07-01 12:45:03.373545',531,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3933,'sync-indexes',2,'2024-07-01 12:45:03.381360','2024-07-01 12:45:03.842933',461,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3934,'sync-metabase-metadata',2,'2024-07-01 12:45:03.849937','2024-07-01 12:45:03.860093',10,'{}','success'),(3935,'sync-table-privileges',2,'2024-07-01 12:45:03.868693','2024-07-01 12:45:03.876835',8,NULL,'success'),(3936,'analyze',2,'2024-07-01 12:45:03.908341','2024-07-01 12:45:05.865064',1956,NULL,'success'),(3937,'fingerprint-fields',2,'2024-07-01 12:45:03.916308','2024-07-01 12:45:05.719542',1803,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3938,'classify-fields',2,'2024-07-01 12:45:05.728071','2024-07-01 12:45:05.835656',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3939,'classify-tables',2,'2024-07-01 12:45:05.843722','2024-07-01 12:45:05.857509',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3940,'field values scanning',2,'2024-07-01 13:00:00.070568','2024-07-01 13:00:11.718371',11647,NULL,'success'),(3941,'delete-expired-advanced-field-values',2,'2024-07-01 13:00:00.086452','2024-07-01 13:00:02.961714',2875,'{\"deleted\":0}','success'),(3942,'update-field-values',2,'2024-07-01 13:00:02.969259','2024-07-01 13:00:11.709680',8740,'{\"errors\":0,\"created\":0,\"updated\":31,\"deleted\":0}','success'),(3943,'sync',2,'2024-07-01 13:45:00.098963','2024-07-01 13:45:04.273520',4174,NULL,'success'),(3944,'sync-dbms-version',2,'2024-07-01 13:45:00.106929','2024-07-01 13:45:00.115773',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3945,'sync-timezone',2,'2024-07-01 13:45:00.124085','2024-07-01 13:45:00.133960',9,'{\"timezone-id\":\"+08:00\"}','success'),(3946,'sync-tables',2,'2024-07-01 13:45:00.142571','2024-07-01 13:45:00.168290',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3947,'sync-fields',2,'2024-07-01 13:45:00.178855','2024-07-01 13:45:03.062770',2883,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3948,'sync-fks',2,'2024-07-01 13:45:03.070187','2024-07-01 13:45:03.658500',588,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3949,'sync-indexes',2,'2024-07-01 13:45:03.668601','2024-07-01 13:45:04.231720',563,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3950,'sync-metabase-metadata',2,'2024-07-01 13:45:04.240723','2024-07-01 13:45:04.249004',8,'{}','success'),(3951,'sync-table-privileges',2,'2024-07-01 13:45:04.257104','2024-07-01 13:45:04.265255',8,NULL,'success'),(3952,'analyze',2,'2024-07-01 13:45:04.297948','2024-07-01 13:45:06.329967',2032,NULL,'success'),(3953,'fingerprint-fields',2,'2024-07-01 13:45:04.305891','2024-07-01 13:45:06.186922',1881,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3954,'classify-fields',2,'2024-07-01 13:45:06.194740','2024-07-01 13:45:06.299071',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3955,'classify-tables',2,'2024-07-01 13:45:06.308760','2024-07-01 13:45:06.322205',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3956,'sync',2,'2024-07-01 14:45:00.108175','2024-07-01 14:45:04.292711',4184,NULL,'success'),(3957,'sync-dbms-version',2,'2024-07-01 14:45:00.115941','2024-07-01 14:45:00.125098',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3958,'sync-timezone',2,'2024-07-01 14:45:00.134197','2024-07-01 14:45:00.143763',9,'{\"timezone-id\":\"+08:00\"}','success'),(3959,'sync-tables',2,'2024-07-01 14:45:00.152317','2024-07-01 14:45:00.180279',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3960,'sync-fields',2,'2024-07-01 14:45:00.189259','2024-07-01 14:45:03.104318',2915,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3961,'sync-fks',2,'2024-07-01 14:45:03.113964','2024-07-01 14:45:03.737756',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3962,'sync-indexes',2,'2024-07-01 14:45:03.745466','2024-07-01 14:45:04.252611',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3963,'sync-metabase-metadata',2,'2024-07-01 14:45:04.260411','2024-07-01 14:45:04.268760',8,'{}','success'),(3964,'sync-table-privileges',2,'2024-07-01 14:45:04.276739','2024-07-01 14:45:04.284653',7,NULL,'success'),(3965,'analyze',2,'2024-07-01 14:45:04.316352','2024-07-01 14:45:06.342796',2026,NULL,'success'),(3966,'fingerprint-fields',2,'2024-07-01 14:45:04.324003','2024-07-01 14:45:06.195305',1871,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3967,'classify-fields',2,'2024-07-01 14:45:06.203649','2024-07-01 14:45:06.315123',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3968,'classify-tables',2,'2024-07-01 14:45:06.322758','2024-07-01 14:45:06.335353',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3969,'sync',2,'2024-07-01 15:45:00.107894','2024-07-01 15:45:04.487921',4380,NULL,'success'),(3970,'sync-dbms-version',2,'2024-07-01 15:45:00.116824','2024-07-01 15:45:00.127643',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3971,'sync-timezone',2,'2024-07-01 15:45:00.137402','2024-07-01 15:45:00.148012',10,'{\"timezone-id\":\"+08:00\"}','success'),(3972,'sync-tables',2,'2024-07-01 15:45:00.157019','2024-07-01 15:45:00.187534',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3973,'sync-fields',2,'2024-07-01 15:45:00.196040','2024-07-01 15:45:03.248125',3052,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3974,'sync-fks',2,'2024-07-01 15:45:03.256728','2024-07-01 15:45:03.888690',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3975,'sync-indexes',2,'2024-07-01 15:45:03.897470','2024-07-01 15:45:04.447181',549,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3976,'sync-metabase-metadata',2,'2024-07-01 15:45:04.454722','2024-07-01 15:45:04.462880',8,'{}','success'),(3977,'sync-table-privileges',2,'2024-07-01 15:45:04.471705','2024-07-01 15:45:04.479759',8,NULL,'success'),(3978,'analyze',2,'2024-07-01 15:45:04.511474','2024-07-01 15:45:06.585933',2074,NULL,'success'),(3979,'fingerprint-fields',2,'2024-07-01 15:45:04.519237','2024-07-01 15:45:06.436816',1917,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3980,'classify-fields',2,'2024-07-01 15:45:06.444696','2024-07-01 15:45:06.558189',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3981,'classify-tables',2,'2024-07-01 15:45:06.565482','2024-07-01 15:45:06.578477',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3982,'task-history-cleanup',NULL,'2024-07-01 16:00:00.012960','2024-07-01 16:00:00.064902',51,NULL,'success'),(3983,'task-history-cleanup',NULL,'2024-07-01 16:00:00.074962','2024-07-01 16:00:00.088053',13,NULL,'success'),(3984,'sync',2,'2024-07-01 16:45:00.123994','2024-07-01 16:45:05.716566',5592,NULL,'success'),(3985,'sync-dbms-version',2,'2024-07-01 16:45:00.132221','2024-07-01 16:45:00.142003',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3986,'sync-timezone',2,'2024-07-01 16:45:00.151145','2024-07-01 16:45:00.161955',10,'{\"timezone-id\":\"+08:00\"}','success'),(3987,'sync-tables',2,'2024-07-01 16:45:00.173413','2024-07-01 16:45:00.201620',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(3988,'sync-fields',2,'2024-07-01 16:45:00.211849','2024-07-01 16:45:03.513133',3301,'{\"total-fields\":836,\"updated-fields\":0}','success'),(3989,'sync-fks',2,'2024-07-01 16:45:03.521162','2024-07-01 16:45:04.179853',658,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(3990,'sync-indexes',2,'2024-07-01 16:45:04.188427','2024-07-01 16:45:05.672715',1484,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(3991,'sync-metabase-metadata',2,'2024-07-01 16:45:05.681715','2024-07-01 16:45:05.691077',9,'{}','success'),(3992,'sync-table-privileges',2,'2024-07-01 16:45:05.699482','2024-07-01 16:45:05.708113',8,NULL,'success'),(3993,'analyze',2,'2024-07-01 16:45:05.749210','2024-07-01 16:45:08.235551',2486,NULL,'success'),(3994,'fingerprint-fields',2,'2024-07-01 16:45:05.758219','2024-07-01 16:45:08.079143',2320,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(3995,'classify-fields',2,'2024-07-01 16:45:08.088213','2024-07-01 16:45:08.203387',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(3996,'classify-tables',2,'2024-07-01 16:45:08.211867','2024-07-01 16:45:08.226613',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(3997,'sync',2,'2024-07-01 17:45:00.093703','2024-07-01 17:45:04.245143',4151,NULL,'success'),(3998,'sync-dbms-version',2,'2024-07-01 17:45:00.101426','2024-07-01 17:45:00.110491',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(3999,'sync-timezone',2,'2024-07-01 17:45:00.119678','2024-07-01 17:45:00.129340',9,'{\"timezone-id\":\"+08:00\"}','success'),(4000,'sync-tables',2,'2024-07-01 17:45:00.136895','2024-07-01 17:45:00.169000',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4001,'sync-fields',2,'2024-07-01 17:45:00.178649','2024-07-01 17:45:03.139061',2960,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4002,'sync-fks',2,'2024-07-01 17:45:03.148245','2024-07-01 17:45:03.715639',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4003,'sync-indexes',2,'2024-07-01 17:45:03.723745','2024-07-01 17:45:04.205935',482,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4004,'sync-metabase-metadata',2,'2024-07-01 17:45:04.213057','2024-07-01 17:45:04.221302',8,'{}','success'),(4005,'sync-table-privileges',2,'2024-07-01 17:45:04.228826','2024-07-01 17:45:04.237056',8,NULL,'success'),(4006,'analyze',2,'2024-07-01 17:45:04.270033','2024-07-01 17:45:06.262229',1992,NULL,'success'),(4007,'fingerprint-fields',2,'2024-07-01 17:45:04.278972','2024-07-01 17:45:06.106984',1828,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4008,'classify-fields',2,'2024-07-01 17:45:06.115785','2024-07-01 17:45:06.224477',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4009,'classify-tables',2,'2024-07-01 17:45:06.232170','2024-07-01 17:45:06.247802',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4010,'sync',2,'2024-07-01 18:45:00.111698','2024-07-01 18:45:04.689985',4578,NULL,'success'),(4011,'sync-dbms-version',2,'2024-07-01 18:45:00.120285','2024-07-01 18:45:00.131435',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4012,'sync-timezone',2,'2024-07-01 18:45:00.142905','2024-07-01 18:45:00.153517',10,'{\"timezone-id\":\"+08:00\"}','success'),(4013,'sync-tables',2,'2024-07-01 18:45:00.163319','2024-07-01 18:45:00.197193',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4014,'sync-fields',2,'2024-07-01 18:45:00.207296','2024-07-01 18:45:03.362809',3155,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4015,'sync-fks',2,'2024-07-01 18:45:03.370992','2024-07-01 18:45:04.052339',681,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4016,'sync-indexes',2,'2024-07-01 18:45:04.062397','2024-07-01 18:45:04.644072',581,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4017,'sync-metabase-metadata',2,'2024-07-01 18:45:04.651976','2024-07-01 18:45:04.661301',9,'{}','success'),(4018,'sync-table-privileges',2,'2024-07-01 18:45:04.672660','2024-07-01 18:45:04.681224',8,NULL,'success'),(4019,'analyze',2,'2024-07-01 18:45:04.719395','2024-07-01 18:45:06.686415',1967,NULL,'success'),(4020,'fingerprint-fields',2,'2024-07-01 18:45:04.728320','2024-07-01 18:45:06.546407',1818,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4021,'classify-fields',2,'2024-07-01 18:45:06.555825','2024-07-01 18:45:06.657886',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4022,'classify-tables',2,'2024-07-01 18:45:06.664846','2024-07-01 18:45:06.678216',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4023,'sync',2,'2024-07-01 19:45:00.114706','2024-07-01 19:45:04.685780',4571,NULL,'success'),(4024,'sync-dbms-version',2,'2024-07-01 19:45:00.123131','2024-07-01 19:45:00.133490',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4025,'sync-timezone',2,'2024-07-01 19:45:00.142799','2024-07-01 19:45:00.154247',11,'{\"timezone-id\":\"+08:00\"}','success'),(4026,'sync-tables',2,'2024-07-01 19:45:00.163314','2024-07-01 19:45:00.194547',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4027,'sync-fields',2,'2024-07-01 19:45:00.204765','2024-07-01 19:45:03.292149',3087,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4028,'sync-fks',2,'2024-07-01 19:45:03.301410','2024-07-01 19:45:03.996359',694,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4029,'sync-indexes',2,'2024-07-01 19:45:04.005500','2024-07-01 19:45:04.642607',637,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4030,'sync-metabase-metadata',2,'2024-07-01 19:45:04.651121','2024-07-01 19:45:04.659602',8,'{}','success'),(4031,'sync-table-privileges',2,'2024-07-01 19:45:04.668806','2024-07-01 19:45:04.677515',8,NULL,'success'),(4032,'analyze',2,'2024-07-01 19:45:04.712333','2024-07-01 19:45:06.902775',2190,NULL,'success'),(4033,'fingerprint-fields',2,'2024-07-01 19:45:04.720569','2024-07-01 19:45:06.727167',2006,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4034,'classify-fields',2,'2024-07-01 19:45:06.737618','2024-07-01 19:45:06.868575',130,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4035,'classify-tables',2,'2024-07-01 19:45:06.877291','2024-07-01 19:45:06.893930',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4036,'sync',2,'2024-07-01 20:45:00.107491','2024-07-01 20:45:04.579785',4472,NULL,'success'),(4037,'sync-dbms-version',2,'2024-07-01 20:45:00.116284','2024-07-01 20:45:00.125623',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4038,'sync-timezone',2,'2024-07-01 20:45:00.134334','2024-07-01 20:45:00.144512',10,'{\"timezone-id\":\"+08:00\"}','success'),(4039,'sync-tables',2,'2024-07-01 20:45:00.153189','2024-07-01 20:45:00.181124',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4040,'sync-fields',2,'2024-07-01 20:45:00.189334','2024-07-01 20:45:03.260539',3071,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4041,'sync-fks',2,'2024-07-01 20:45:03.268382','2024-07-01 20:45:03.937119',668,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4042,'sync-indexes',2,'2024-07-01 20:45:03.946364','2024-07-01 20:45:04.536543',590,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4043,'sync-metabase-metadata',2,'2024-07-01 20:45:04.544657','2024-07-01 20:45:04.552847',8,'{}','success'),(4044,'sync-table-privileges',2,'2024-07-01 20:45:04.562196','2024-07-01 20:45:04.570435',8,NULL,'success'),(4045,'analyze',2,'2024-07-01 20:45:04.605743','2024-07-01 20:45:06.854492',2248,NULL,'success'),(4046,'fingerprint-fields',2,'2024-07-01 20:45:04.613846','2024-07-01 20:45:06.682178',2068,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4047,'classify-fields',2,'2024-07-01 20:45:06.693139','2024-07-01 20:45:06.821979',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4048,'classify-tables',2,'2024-07-01 20:45:06.830267','2024-07-01 20:45:06.845648',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4049,'sync',2,'2024-07-01 21:45:00.115253','2024-07-01 21:45:04.537831',4422,NULL,'success'),(4050,'sync-dbms-version',2,'2024-07-01 21:45:00.124453','2024-07-01 21:45:00.133669',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4051,'sync-timezone',2,'2024-07-01 21:45:00.142265','2024-07-01 21:45:00.154162',11,'{\"timezone-id\":\"+08:00\"}','success'),(4052,'sync-tables',2,'2024-07-01 21:45:00.162773','2024-07-01 21:45:00.189901',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4053,'sync-fields',2,'2024-07-01 21:45:00.198420','2024-07-01 21:45:03.380916',3182,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4054,'sync-fks',2,'2024-07-01 21:45:03.388973','2024-07-01 21:45:03.980150',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4055,'sync-indexes',2,'2024-07-01 21:45:03.988378','2024-07-01 21:45:04.496409',508,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4056,'sync-metabase-metadata',2,'2024-07-01 21:45:04.504046','2024-07-01 21:45:04.512155',8,'{}','success'),(4057,'sync-table-privileges',2,'2024-07-01 21:45:04.520735','2024-07-01 21:45:04.529725',8,NULL,'success'),(4058,'analyze',2,'2024-07-01 21:45:04.563530','2024-07-01 21:45:06.483109',1919,NULL,'success'),(4059,'fingerprint-fields',2,'2024-07-01 21:45:04.572892','2024-07-01 21:45:06.351247',1778,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4060,'classify-fields',2,'2024-07-01 21:45:06.359146','2024-07-01 21:45:06.454913',95,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4061,'classify-tables',2,'2024-07-01 21:45:06.462214','2024-07-01 21:45:06.475186',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4062,'sync',2,'2024-07-01 22:45:00.114106','2024-07-01 22:45:04.684490',4570,NULL,'success'),(4063,'sync-dbms-version',2,'2024-07-01 22:45:00.123330','2024-07-01 22:45:00.134565',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4064,'sync-timezone',2,'2024-07-01 22:45:00.143916','2024-07-01 22:45:00.155287',11,'{\"timezone-id\":\"+08:00\"}','success'),(4065,'sync-tables',2,'2024-07-01 22:45:00.164160','2024-07-01 22:45:00.192794',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4066,'sync-fields',2,'2024-07-01 22:45:00.202030','2024-07-01 22:45:03.411153',3209,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4067,'sync-fks',2,'2024-07-01 22:45:03.419132','2024-07-01 22:45:04.070072',650,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4068,'sync-indexes',2,'2024-07-01 22:45:04.079153','2024-07-01 22:45:04.639822',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4069,'sync-metabase-metadata',2,'2024-07-01 22:45:04.648005','2024-07-01 22:45:04.656674',8,'{}','success'),(4070,'sync-table-privileges',2,'2024-07-01 22:45:04.666348','2024-07-01 22:45:04.675552',9,NULL,'success'),(4071,'analyze',2,'2024-07-01 22:45:04.715208','2024-07-01 22:45:06.873384',2158,NULL,'success'),(4072,'fingerprint-fields',2,'2024-07-01 22:45:04.724457','2024-07-01 22:45:06.705057',1980,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4073,'classify-fields',2,'2024-07-01 22:45:06.713406','2024-07-01 22:45:06.838361',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4074,'classify-tables',2,'2024-07-01 22:45:06.847278','2024-07-01 22:45:06.863683',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4075,'sync',2,'2024-07-01 23:45:00.107232','2024-07-01 23:45:04.654890',4547,NULL,'success'),(4076,'sync-dbms-version',2,'2024-07-01 23:45:00.115532','2024-07-01 23:45:00.126519',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4077,'sync-timezone',2,'2024-07-01 23:45:00.135957','2024-07-01 23:45:00.147366',11,'{\"timezone-id\":\"+08:00\"}','success'),(4078,'sync-tables',2,'2024-07-01 23:45:00.156336','2024-07-01 23:45:00.183862',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4079,'sync-fields',2,'2024-07-01 23:45:00.193055','2024-07-01 23:45:03.430002',3236,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4080,'sync-fks',2,'2024-07-01 23:45:03.437642','2024-07-01 23:45:04.094940',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4081,'sync-indexes',2,'2024-07-01 23:45:04.103576','2024-07-01 23:45:04.615849',512,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4082,'sync-metabase-metadata',2,'2024-07-01 23:45:04.623045','2024-07-01 23:45:04.630954',7,'{}','success'),(4083,'sync-table-privileges',2,'2024-07-01 23:45:04.639034','2024-07-01 23:45:04.647044',8,NULL,'success'),(4084,'analyze',2,'2024-07-01 23:45:04.678421','2024-07-01 23:45:06.719122',2040,NULL,'success'),(4085,'fingerprint-fields',2,'2024-07-01 23:45:04.686128','2024-07-01 23:45:06.563208',1877,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4086,'classify-fields',2,'2024-07-01 23:45:06.572328','2024-07-01 23:45:06.690107',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4087,'classify-tables',2,'2024-07-01 23:45:06.697601','2024-07-01 23:45:06.710945',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4088,'sync',2,'2024-07-02 00:45:00.111001','2024-07-02 00:45:04.944151',4833,NULL,'success'),(4089,'sync-dbms-version',2,'2024-07-02 00:45:00.119962','2024-07-02 00:45:00.130544',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4090,'sync-timezone',2,'2024-07-02 00:45:00.142940','2024-07-02 00:45:00.155384',12,'{\"timezone-id\":\"+08:00\"}','success'),(4091,'sync-tables',2,'2024-07-02 00:45:00.165245','2024-07-02 00:45:00.198854',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4092,'sync-fields',2,'2024-07-02 00:45:00.208899','2024-07-02 00:45:03.549020',3340,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4093,'sync-fks',2,'2024-07-02 00:45:03.557209','2024-07-02 00:45:04.257572',700,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4094,'sync-indexes',2,'2024-07-02 00:45:04.266341','2024-07-02 00:45:04.893823',627,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4095,'sync-metabase-metadata',2,'2024-07-02 00:45:04.902075','2024-07-02 00:45:04.913744',11,'{}','success'),(4096,'sync-table-privileges',2,'2024-07-02 00:45:04.923611','2024-07-02 00:45:04.934206',10,NULL,'success'),(4097,'analyze',2,'2024-07-02 00:45:04.980169','2024-07-02 00:45:07.258206',2278,NULL,'success'),(4098,'fingerprint-fields',2,'2024-07-02 00:45:04.990652','2024-07-02 00:45:07.098833',2108,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4099,'classify-fields',2,'2024-07-02 00:45:07.107706','2024-07-02 00:45:07.226324',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4100,'classify-tables',2,'2024-07-02 00:45:07.234727','2024-07-02 00:45:07.249920',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4101,'sync',2,'2024-07-02 01:45:00.101336','2024-07-02 01:45:04.461171',4359,NULL,'success'),(4102,'sync-dbms-version',2,'2024-07-02 01:45:00.109728','2024-07-02 01:45:00.119392',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4103,'sync-timezone',2,'2024-07-02 01:45:00.127949','2024-07-02 01:45:00.138375',10,'{\"timezone-id\":\"+08:00\"}','success'),(4104,'sync-tables',2,'2024-07-02 01:45:00.147493','2024-07-02 01:45:00.174660',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4105,'sync-fields',2,'2024-07-02 01:45:00.183339','2024-07-02 01:45:03.201094',3017,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4106,'sync-fks',2,'2024-07-02 01:45:03.208574','2024-07-02 01:45:03.810754',602,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4107,'sync-indexes',2,'2024-07-02 01:45:03.819841','2024-07-02 01:45:04.418228',598,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4108,'sync-metabase-metadata',2,'2024-07-02 01:45:04.426431','2024-07-02 01:45:04.435049',8,'{}','success'),(4109,'sync-table-privileges',2,'2024-07-02 01:45:04.444080','2024-07-02 01:45:04.452642',8,NULL,'success'),(4110,'analyze',2,'2024-07-02 01:45:04.488443','2024-07-02 01:45:06.506000',2017,NULL,'success'),(4111,'fingerprint-fields',2,'2024-07-02 01:45:04.497175','2024-07-02 01:45:06.351893',1854,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4112,'classify-fields',2,'2024-07-02 01:45:06.360149','2024-07-02 01:45:06.475957',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4113,'classify-tables',2,'2024-07-02 01:45:06.483881','2024-07-02 01:45:06.497465',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4114,'sync',2,'2024-07-02 02:45:00.092936','2024-07-02 02:45:04.534256',4441,NULL,'success'),(4115,'sync-dbms-version',2,'2024-07-02 02:45:00.100795','2024-07-02 02:45:00.109785',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4116,'sync-timezone',2,'2024-07-02 02:45:00.118828','2024-07-02 02:45:00.128630',9,'{\"timezone-id\":\"+08:00\"}','success'),(4117,'sync-tables',2,'2024-07-02 02:45:00.137961','2024-07-02 02:45:00.164293',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4118,'sync-fields',2,'2024-07-02 02:45:00.172737','2024-07-02 02:45:03.362342',3189,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4119,'sync-fks',2,'2024-07-02 02:45:03.370126','2024-07-02 02:45:03.966933',596,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4120,'sync-indexes',2,'2024-07-02 02:45:03.974554','2024-07-02 02:45:04.490496',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4121,'sync-metabase-metadata',2,'2024-07-02 02:45:04.498806','2024-07-02 02:45:04.507549',8,'{}','success'),(4122,'sync-table-privileges',2,'2024-07-02 02:45:04.516557','2024-07-02 02:45:04.526253',9,NULL,'success'),(4123,'analyze',2,'2024-07-02 02:45:04.558290','2024-07-02 02:45:06.667054',2108,NULL,'success'),(4124,'fingerprint-fields',2,'2024-07-02 02:45:04.566388','2024-07-02 02:45:06.505202',1938,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4125,'classify-fields',2,'2024-07-02 02:45:06.513889','2024-07-02 02:45:06.633231',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4126,'classify-tables',2,'2024-07-02 02:45:06.642075','2024-07-02 02:45:06.657415',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4127,'sync',2,'2024-07-02 03:45:00.104432','2024-07-02 03:45:04.366845',4262,NULL,'success'),(4128,'sync-dbms-version',2,'2024-07-02 03:45:00.113023','2024-07-02 03:45:00.121842',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4129,'sync-timezone',2,'2024-07-02 03:45:00.130408','2024-07-02 03:45:00.141144',10,'{\"timezone-id\":\"+08:00\"}','success'),(4130,'sync-tables',2,'2024-07-02 03:45:00.149457','2024-07-02 03:45:00.174911',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4131,'sync-fields',2,'2024-07-02 03:45:00.183446','2024-07-02 03:45:03.075513',2892,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4132,'sync-fks',2,'2024-07-02 03:45:03.083807','2024-07-02 03:45:03.744207',660,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4133,'sync-indexes',2,'2024-07-02 03:45:03.753076','2024-07-02 03:45:04.323440',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4134,'sync-metabase-metadata',2,'2024-07-02 03:45:04.332054','2024-07-02 03:45:04.340701',8,'{}','success'),(4135,'sync-table-privileges',2,'2024-07-02 03:45:04.349492','2024-07-02 03:45:04.358455',8,NULL,'success'),(4136,'analyze',2,'2024-07-02 03:45:04.392118','2024-07-02 03:45:06.457931',2065,NULL,'success'),(4137,'fingerprint-fields',2,'2024-07-02 03:45:04.400645','2024-07-02 03:45:06.298107',1897,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4138,'classify-fields',2,'2024-07-02 03:45:06.306605','2024-07-02 03:45:06.428310',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4139,'classify-tables',2,'2024-07-02 03:45:06.436128','2024-07-02 03:45:06.449521',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4140,'task-history-cleanup',NULL,'2024-07-02 04:00:00.070971','2024-07-02 04:00:00.087594',16,NULL,'success'),(4141,'sync',2,'2024-07-02 04:45:00.099633','2024-07-02 04:45:04.559188',4459,NULL,'success'),(4142,'sync-dbms-version',2,'2024-07-02 04:45:00.108112','2024-07-02 04:45:00.118235',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4143,'sync-timezone',2,'2024-07-02 04:45:00.126713','2024-07-02 04:45:00.136554',9,'{\"timezone-id\":\"+08:00\"}','success'),(4144,'sync-tables',2,'2024-07-02 04:45:00.144909','2024-07-02 04:45:00.171557',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4145,'sync-fields',2,'2024-07-02 04:45:00.180160','2024-07-02 04:45:03.298374',3118,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4146,'sync-fks',2,'2024-07-02 04:45:03.306435','2024-07-02 04:45:03.945216',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4147,'sync-indexes',2,'2024-07-02 04:45:03.952768','2024-07-02 04:45:04.513522',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4148,'sync-metabase-metadata',2,'2024-07-02 04:45:04.521867','2024-07-02 04:45:04.531241',9,'{}','success'),(4149,'sync-table-privileges',2,'2024-07-02 04:45:04.540733','2024-07-02 04:45:04.549995',9,NULL,'success'),(4150,'analyze',2,'2024-07-02 04:45:04.586092','2024-07-02 04:45:06.786394',2200,NULL,'success'),(4151,'fingerprint-fields',2,'2024-07-02 04:45:04.595153','2024-07-02 04:45:06.628445',2033,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4152,'classify-fields',2,'2024-07-02 04:45:06.637452','2024-07-02 04:45:06.755715',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4153,'classify-tables',2,'2024-07-02 04:45:06.763074','2024-07-02 04:45:06.778243',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4154,'sync',2,'2024-07-02 05:45:00.122132','2024-07-02 05:45:05.171353',5049,NULL,'success'),(4155,'sync-dbms-version',2,'2024-07-02 05:45:00.131618','2024-07-02 05:45:00.142964',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4156,'sync-timezone',2,'2024-07-02 05:45:00.153200','2024-07-02 05:45:00.165233',12,'{\"timezone-id\":\"+08:00\"}','success'),(4157,'sync-tables',2,'2024-07-02 05:45:00.174600','2024-07-02 05:45:00.206457',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4158,'sync-fields',2,'2024-07-02 05:45:00.215701','2024-07-02 05:45:03.744840',3529,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4159,'sync-fks',2,'2024-07-02 05:45:03.753156','2024-07-02 05:45:04.478233',725,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4160,'sync-indexes',2,'2024-07-02 05:45:04.487220','2024-07-02 05:45:05.127655',640,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4161,'sync-metabase-metadata',2,'2024-07-02 05:45:05.136246','2024-07-02 05:45:05.144252',8,'{}','success'),(4162,'sync-table-privileges',2,'2024-07-02 05:45:05.152754','2024-07-02 05:45:05.162100',9,NULL,'success'),(4163,'analyze',2,'2024-07-02 05:45:05.199910','2024-07-02 05:45:07.449711',2249,NULL,'success'),(4164,'fingerprint-fields',2,'2024-07-02 05:45:05.208865','2024-07-02 05:45:07.271106',2062,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4165,'classify-fields',2,'2024-07-02 05:45:07.280320','2024-07-02 05:45:07.413674',133,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4166,'classify-tables',2,'2024-07-02 05:45:07.422084','2024-07-02 05:45:07.439953',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4167,'sync',2,'2024-07-02 06:45:00.110912','2024-07-02 06:45:04.379893',4268,NULL,'success'),(4168,'sync-dbms-version',2,'2024-07-02 06:45:00.119775','2024-07-02 06:45:00.131271',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4169,'sync-timezone',2,'2024-07-02 06:45:00.140233','2024-07-02 06:45:00.151596',11,'{\"timezone-id\":\"+08:00\"}','success'),(4170,'sync-tables',2,'2024-07-02 06:45:00.160116','2024-07-02 06:45:00.192878',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4171,'sync-fields',2,'2024-07-02 06:45:00.201926','2024-07-02 06:45:03.162332',2960,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4172,'sync-fks',2,'2024-07-02 06:45:03.170999','2024-07-02 06:45:03.780433',609,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4173,'sync-indexes',2,'2024-07-02 06:45:03.789871','2024-07-02 06:45:04.332361',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4174,'sync-metabase-metadata',2,'2024-07-02 06:45:04.339958','2024-07-02 06:45:04.348345',8,'{}','success'),(4175,'sync-table-privileges',2,'2024-07-02 06:45:04.360839','2024-07-02 06:45:04.371044',10,NULL,'success'),(4176,'analyze',2,'2024-07-02 06:45:04.405569','2024-07-02 06:45:06.495450',2089,NULL,'success'),(4177,'fingerprint-fields',2,'2024-07-02 06:45:04.413785','2024-07-02 06:45:06.338024',1924,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4178,'classify-fields',2,'2024-07-02 06:45:06.346008','2024-07-02 06:45:06.465281',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4179,'classify-tables',2,'2024-07-02 06:45:06.472657','2024-07-02 06:45:06.486811',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4180,'sync',2,'2024-07-02 07:45:00.121071','2024-07-02 07:45:04.833780',4712,NULL,'success'),(4181,'sync-dbms-version',2,'2024-07-02 07:45:00.129005','2024-07-02 07:45:00.139865',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4182,'sync-timezone',2,'2024-07-02 07:45:00.148401','2024-07-02 07:45:00.158443',10,'{\"timezone-id\":\"+08:00\"}','success'),(4183,'sync-tables',2,'2024-07-02 07:45:00.167023','2024-07-02 07:45:00.194874',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4184,'sync-fields',2,'2024-07-02 07:45:00.203456','2024-07-02 07:45:03.631847',3428,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4185,'sync-fks',2,'2024-07-02 07:45:03.641085','2024-07-02 07:45:04.213443',572,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4186,'sync-indexes',2,'2024-07-02 07:45:04.221725','2024-07-02 07:45:04.790195',568,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4187,'sync-metabase-metadata',2,'2024-07-02 07:45:04.798358','2024-07-02 07:45:04.807778',9,'{}','success'),(4188,'sync-table-privileges',2,'2024-07-02 07:45:04.816907','2024-07-02 07:45:04.825124',8,NULL,'success'),(4189,'analyze',2,'2024-07-02 07:45:04.858568','2024-07-02 07:45:06.972420',2113,NULL,'success'),(4190,'fingerprint-fields',2,'2024-07-02 07:45:04.866748','2024-07-02 07:45:06.829825',1963,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4191,'classify-fields',2,'2024-07-02 07:45:06.837930','2024-07-02 07:45:06.944042',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4192,'classify-tables',2,'2024-07-02 07:45:06.951339','2024-07-02 07:45:06.964433',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4193,'sync',2,'2024-07-02 08:45:00.108823','2024-07-02 08:45:04.473632',4364,NULL,'success'),(4194,'sync-dbms-version',2,'2024-07-02 08:45:00.117962','2024-07-02 08:45:00.127870',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4195,'sync-timezone',2,'2024-07-02 08:45:00.136828','2024-07-02 08:45:00.147698',10,'{\"timezone-id\":\"+08:00\"}','success'),(4196,'sync-tables',2,'2024-07-02 08:45:00.157178','2024-07-02 08:45:00.185432',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4197,'sync-fields',2,'2024-07-02 08:45:00.194633','2024-07-02 08:45:03.200556',3005,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4198,'sync-fks',2,'2024-07-02 08:45:03.209022','2024-07-02 08:45:03.861050',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4199,'sync-indexes',2,'2024-07-02 08:45:03.870141','2024-07-02 08:45:04.430772',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4200,'sync-metabase-metadata',2,'2024-07-02 08:45:04.438708','2024-07-02 08:45:04.447521',8,'{}','success'),(4201,'sync-table-privileges',2,'2024-07-02 08:45:04.456318','2024-07-02 08:45:04.465258',8,NULL,'success'),(4202,'analyze',2,'2024-07-02 08:45:04.497878','2024-07-02 08:45:06.551463',2053,NULL,'success'),(4203,'fingerprint-fields',2,'2024-07-02 08:45:04.505846','2024-07-02 08:45:06.345014',1839,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4204,'classify-fields',2,'2024-07-02 08:45:06.353800','2024-07-02 08:45:06.490027',136,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4205,'classify-tables',2,'2024-07-02 08:45:06.499022','2024-07-02 08:45:06.543080',44,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4206,'sync',2,'2024-07-02 09:45:00.095438','2024-07-02 09:45:04.077318',3981,NULL,'success'),(4207,'sync-dbms-version',2,'2024-07-02 09:45:00.105681','2024-07-02 09:45:00.114495',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4208,'sync-timezone',2,'2024-07-02 09:45:00.123022','2024-07-02 09:45:00.132790',9,'{\"timezone-id\":\"+08:00\"}','success'),(4209,'sync-tables',2,'2024-07-02 09:45:00.140917','2024-07-02 09:45:00.171902',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4210,'sync-fields',2,'2024-07-02 09:45:00.181046','2024-07-02 09:45:02.928003',2746,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4211,'sync-fks',2,'2024-07-02 09:45:02.935693','2024-07-02 09:45:03.497565',561,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4212,'sync-indexes',2,'2024-07-02 09:45:03.505575','2024-07-02 09:45:04.035419',529,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4213,'sync-metabase-metadata',2,'2024-07-02 09:45:04.042811','2024-07-02 09:45:04.051072',8,'{}','success'),(4214,'sync-table-privileges',2,'2024-07-02 09:45:04.059461','2024-07-02 09:45:04.068475',9,NULL,'success'),(4215,'analyze',2,'2024-07-02 09:45:04.107525','2024-07-02 09:45:05.932691',1825,NULL,'success'),(4216,'fingerprint-fields',2,'2024-07-02 09:45:04.115613','2024-07-02 09:45:05.798031',1682,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4217,'classify-fields',2,'2024-07-02 09:45:05.806672','2024-07-02 09:45:05.904290',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4218,'classify-tables',2,'2024-07-02 09:45:05.911217','2024-07-02 09:45:05.923617',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4219,'sync',2,'2024-07-02 10:45:00.109386','2024-07-02 10:45:04.327802',4218,NULL,'success'),(4220,'sync-dbms-version',2,'2024-07-02 10:45:00.118075','2024-07-02 10:45:00.127554',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4221,'sync-timezone',2,'2024-07-02 10:45:00.135732','2024-07-02 10:45:00.147184',11,'{\"timezone-id\":\"+08:00\"}','success'),(4222,'sync-tables',2,'2024-07-02 10:45:00.156164','2024-07-02 10:45:00.185487',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4223,'sync-fields',2,'2024-07-02 10:45:00.194155','2024-07-02 10:45:03.143258',2949,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4224,'sync-fks',2,'2024-07-02 10:45:03.150883','2024-07-02 10:45:03.746223',595,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4225,'sync-indexes',2,'2024-07-02 10:45:03.754408','2024-07-02 10:45:04.285573',531,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4226,'sync-metabase-metadata',2,'2024-07-02 10:45:04.293140','2024-07-02 10:45:04.301721',8,'{}','success'),(4227,'sync-table-privileges',2,'2024-07-02 10:45:04.309825','2024-07-02 10:45:04.319100',9,NULL,'success'),(4228,'analyze',2,'2024-07-02 10:45:04.354894','2024-07-02 10:45:06.449147',2094,NULL,'success'),(4229,'fingerprint-fields',2,'2024-07-02 10:45:04.363761','2024-07-02 10:45:06.306370',1942,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4230,'classify-fields',2,'2024-07-02 10:45:06.315893','2024-07-02 10:45:06.420363',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4231,'classify-tables',2,'2024-07-02 10:45:06.427940','2024-07-02 10:45:06.441257',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4232,'sync',2,'2024-07-02 11:45:00.088653','2024-07-02 11:45:04.410680',4322,NULL,'success'),(4233,'sync-dbms-version',2,'2024-07-02 11:45:00.096110','2024-07-02 11:45:00.105304',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4234,'sync-timezone',2,'2024-07-02 11:45:00.114535','2024-07-02 11:45:00.125421',10,'{\"timezone-id\":\"+08:00\"}','success'),(4235,'sync-tables',2,'2024-07-02 11:45:00.133743','2024-07-02 11:45:00.165209',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4236,'sync-fields',2,'2024-07-02 11:45:00.174505','2024-07-02 11:45:03.210412',3035,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4237,'sync-fks',2,'2024-07-02 11:45:03.218179','2024-07-02 11:45:03.792134',573,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4238,'sync-indexes',2,'2024-07-02 11:45:03.801956','2024-07-02 11:45:04.363195',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4239,'sync-metabase-metadata',2,'2024-07-02 11:45:04.373795','2024-07-02 11:45:04.383755',9,'{}','success'),(4240,'sync-table-privileges',2,'2024-07-02 11:45:04.392827','2024-07-02 11:45:04.402344',9,NULL,'success'),(4241,'analyze',2,'2024-07-02 11:45:04.435037','2024-07-02 11:45:06.464742',2029,NULL,'success'),(4242,'fingerprint-fields',2,'2024-07-02 11:45:04.443905','2024-07-02 11:45:06.302834',1858,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4243,'classify-fields',2,'2024-07-02 11:45:06.311542','2024-07-02 11:45:06.433369',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4244,'classify-tables',2,'2024-07-02 11:45:06.441257','2024-07-02 11:45:06.455887',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4245,'sync',2,'2024-07-02 12:45:00.100811','2024-07-02 12:45:04.070513',3969,NULL,'success'),(4246,'sync-dbms-version',2,'2024-07-02 12:45:00.108672','2024-07-02 12:45:00.118843',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4247,'sync-timezone',2,'2024-07-02 12:45:00.129790','2024-07-02 12:45:00.140011',10,'{\"timezone-id\":\"+08:00\"}','success'),(4248,'sync-tables',2,'2024-07-02 12:45:00.147822','2024-07-02 12:45:00.177363',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4249,'sync-fields',2,'2024-07-02 12:45:00.186282','2024-07-02 12:45:02.959637',2773,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4250,'sync-fks',2,'2024-07-02 12:45:02.967039','2024-07-02 12:45:03.544988',577,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4251,'sync-indexes',2,'2024-07-02 12:45:03.553021','2024-07-02 12:45:04.032253',479,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4252,'sync-metabase-metadata',2,'2024-07-02 12:45:04.039317','2024-07-02 12:45:04.046042',6,'{}','success'),(4253,'sync-table-privileges',2,'2024-07-02 12:45:04.054594','2024-07-02 12:45:04.062831',8,NULL,'success'),(4254,'analyze',2,'2024-07-02 12:45:04.094064','2024-07-02 12:45:06.000424',1906,NULL,'success'),(4255,'fingerprint-fields',2,'2024-07-02 12:45:04.102532','2024-07-02 12:45:05.855425',1752,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4256,'classify-fields',2,'2024-07-02 12:45:05.863366','2024-07-02 12:45:05.969702',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4257,'classify-tables',2,'2024-07-02 12:45:05.976851','2024-07-02 12:45:05.991422',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4258,'field values scanning',2,'2024-07-02 13:00:00.064476','2024-07-02 13:00:11.736986',11672,NULL,'success'),(4259,'delete-expired-advanced-field-values',2,'2024-07-02 13:00:00.074156','2024-07-02 13:00:03.051155',2977,'{\"deleted\":0}','success'),(4260,'update-field-values',2,'2024-07-02 13:00:03.058623','2024-07-02 13:00:11.730109',8671,'{\"errors\":0,\"created\":0,\"updated\":26,\"deleted\":0}','success'),(4261,'sync',2,'2024-07-02 13:45:00.095645','2024-07-02 13:45:04.116985',4021,NULL,'success'),(4262,'sync-dbms-version',2,'2024-07-02 13:45:00.104156','2024-07-02 13:45:00.115923',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4263,'sync-timezone',2,'2024-07-02 13:45:00.124362','2024-07-02 13:45:00.133974',9,'{\"timezone-id\":\"+08:00\"}','success'),(4264,'sync-tables',2,'2024-07-02 13:45:00.142295','2024-07-02 13:45:00.169272',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4265,'sync-fields',2,'2024-07-02 13:45:00.177545','2024-07-02 13:45:02.917718',2740,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4266,'sync-fks',2,'2024-07-02 13:45:02.925285','2024-07-02 13:45:03.529028',603,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4267,'sync-indexes',2,'2024-07-02 13:45:03.537497','2024-07-02 13:45:04.077758',540,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4268,'sync-metabase-metadata',2,'2024-07-02 13:45:04.085307','2024-07-02 13:45:04.092319',7,'{}','success'),(4269,'sync-table-privileges',2,'2024-07-02 13:45:04.100810','2024-07-02 13:45:04.109520',8,NULL,'success'),(4270,'analyze',2,'2024-07-02 13:45:04.142268','2024-07-02 13:45:06.188203',2045,NULL,'success'),(4271,'fingerprint-fields',2,'2024-07-02 13:45:04.149740','2024-07-02 13:45:06.028838',1879,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4272,'classify-fields',2,'2024-07-02 13:45:06.038653','2024-07-02 13:45:06.157312',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4273,'classify-tables',2,'2024-07-02 13:45:06.165092','2024-07-02 13:45:06.179677',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4274,'sync',2,'2024-07-02 14:45:00.097727','2024-07-02 14:45:04.239445',4141,NULL,'success'),(4275,'sync-dbms-version',2,'2024-07-02 14:45:00.106570','2024-07-02 14:45:00.116052',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4276,'sync-timezone',2,'2024-07-02 14:45:00.124212','2024-07-02 14:45:00.135111',10,'{\"timezone-id\":\"+08:00\"}','success'),(4277,'sync-tables',2,'2024-07-02 14:45:00.143308','2024-07-02 14:45:00.170300',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4278,'sync-fields',2,'2024-07-02 14:45:00.178672','2024-07-02 14:45:03.004718',2826,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4279,'sync-fks',2,'2024-07-02 14:45:03.013546','2024-07-02 14:45:03.598487',584,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4280,'sync-indexes',2,'2024-07-02 14:45:03.606667','2024-07-02 14:45:04.198297',591,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4281,'sync-metabase-metadata',2,'2024-07-02 14:45:04.205455','2024-07-02 14:45:04.214416',8,'{}','success'),(4282,'sync-table-privileges',2,'2024-07-02 14:45:04.223101','2024-07-02 14:45:04.231634',8,NULL,'success'),(4283,'analyze',2,'2024-07-02 14:45:04.266332','2024-07-02 14:45:06.139128',1872,NULL,'success'),(4284,'fingerprint-fields',2,'2024-07-02 14:45:04.275650','2024-07-02 14:45:06.000259',1724,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4285,'classify-fields',2,'2024-07-02 14:45:06.008105','2024-07-02 14:45:06.111196',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4286,'classify-tables',2,'2024-07-02 14:45:06.118781','2024-07-02 14:45:06.131596',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4287,'sync',2,'2024-07-02 15:45:00.094041','2024-07-02 15:45:04.472371',4378,NULL,'success'),(4288,'sync-dbms-version',2,'2024-07-02 15:45:00.101510','2024-07-02 15:45:00.109484',7,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4289,'sync-timezone',2,'2024-07-02 15:45:00.117110','2024-07-02 15:45:00.125814',8,'{\"timezone-id\":\"+08:00\"}','success'),(4290,'sync-tables',2,'2024-07-02 15:45:00.134462','2024-07-02 15:45:00.159224',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4291,'sync-fields',2,'2024-07-02 15:45:00.166902','2024-07-02 15:45:03.270150',3103,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4292,'sync-fks',2,'2024-07-02 15:45:03.278677','2024-07-02 15:45:03.895056',616,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4293,'sync-indexes',2,'2024-07-02 15:45:03.903274','2024-07-02 15:45:04.429960',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4294,'sync-metabase-metadata',2,'2024-07-02 15:45:04.438164','2024-07-02 15:45:04.445973',7,'{}','success'),(4295,'sync-table-privileges',2,'2024-07-02 15:45:04.454735','2024-07-02 15:45:04.463392',8,NULL,'success'),(4296,'analyze',2,'2024-07-02 15:45:04.497101','2024-07-02 15:45:06.496857',1999,NULL,'success'),(4297,'fingerprint-fields',2,'2024-07-02 15:45:04.505127','2024-07-02 15:45:06.349310',1844,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4298,'classify-fields',2,'2024-07-02 15:45:06.357213','2024-07-02 15:45:06.467283',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4299,'classify-tables',2,'2024-07-02 15:45:06.474187','2024-07-02 15:45:06.487775',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4300,'task-history-cleanup',NULL,'2024-07-02 16:00:00.012184','2024-07-02 16:00:00.067919',55,NULL,'success'),(4301,'task-history-cleanup',NULL,'2024-07-02 16:00:00.109225','2024-07-02 16:00:00.123380',14,NULL,'success'),(4302,'sync',2,'2024-07-02 16:45:00.108667','2024-07-02 16:45:04.759763',4651,NULL,'success'),(4303,'sync-dbms-version',2,'2024-07-02 16:45:00.116836','2024-07-02 16:45:00.125066',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4304,'sync-timezone',2,'2024-07-02 16:45:00.133697','2024-07-02 16:45:00.144622',10,'{\"timezone-id\":\"+08:00\"}','success'),(4305,'sync-tables',2,'2024-07-02 16:45:00.153174','2024-07-02 16:45:00.181494',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4306,'sync-fields',2,'2024-07-02 16:45:00.190754','2024-07-02 16:45:03.423238',3232,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4307,'sync-fks',2,'2024-07-02 16:45:03.432798','2024-07-02 16:45:04.132237',699,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4308,'sync-indexes',2,'2024-07-02 16:45:04.140809','2024-07-02 16:45:04.710302',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4309,'sync-metabase-metadata',2,'2024-07-02 16:45:04.721253','2024-07-02 16:45:04.731343',10,'{}','success'),(4310,'sync-table-privileges',2,'2024-07-02 16:45:04.740605','2024-07-02 16:45:04.750917',10,NULL,'success'),(4311,'analyze',2,'2024-07-02 16:45:04.785229','2024-07-02 16:45:06.884802',2099,NULL,'success'),(4312,'fingerprint-fields',2,'2024-07-02 16:45:04.795170','2024-07-02 16:45:06.731655',1936,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4313,'classify-fields',2,'2024-07-02 16:45:06.739724','2024-07-02 16:45:06.851821',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4314,'classify-tables',2,'2024-07-02 16:45:06.859468','2024-07-02 16:45:06.875012',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4315,'sync',2,'2024-07-02 17:45:00.110683','2024-07-02 17:45:05.198146',5087,NULL,'success'),(4316,'sync-dbms-version',2,'2024-07-02 17:45:00.119019','2024-07-02 17:45:00.128219',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4317,'sync-timezone',2,'2024-07-02 17:45:00.138422','2024-07-02 17:45:00.148931',10,'{\"timezone-id\":\"+08:00\"}','success'),(4318,'sync-tables',2,'2024-07-02 17:45:00.157545','2024-07-02 17:45:00.185977',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4319,'sync-fields',2,'2024-07-02 17:45:00.194441','2024-07-02 17:45:03.097801',2903,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4320,'sync-fks',2,'2024-07-02 17:45:03.107699','2024-07-02 17:45:03.696009',588,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4321,'sync-indexes',2,'2024-07-02 17:45:03.703969','2024-07-02 17:45:05.154408',1450,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4322,'sync-metabase-metadata',2,'2024-07-02 17:45:05.162973','2024-07-02 17:45:05.172091',9,'{}','success'),(4323,'sync-table-privileges',2,'2024-07-02 17:45:05.180515','2024-07-02 17:45:05.188878',8,NULL,'success'),(4324,'analyze',2,'2024-07-02 17:45:05.222604','2024-07-02 17:45:07.311225',2088,NULL,'success'),(4325,'fingerprint-fields',2,'2024-07-02 17:45:05.230824','2024-07-02 17:45:07.136039',1905,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4326,'classify-fields',2,'2024-07-02 17:45:07.144870','2024-07-02 17:45:07.277543',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4327,'classify-tables',2,'2024-07-02 17:45:07.286251','2024-07-02 17:45:07.301972',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4328,'sync',2,'2024-07-02 18:45:00.110004','2024-07-02 18:45:04.626063',4516,NULL,'success'),(4329,'sync-dbms-version',2,'2024-07-02 18:45:00.118745','2024-07-02 18:45:00.130688',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4330,'sync-timezone',2,'2024-07-02 18:45:00.139641','2024-07-02 18:45:00.151071',11,'{\"timezone-id\":\"+08:00\"}','success'),(4331,'sync-tables',2,'2024-07-02 18:45:00.160892','2024-07-02 18:45:00.191185',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4332,'sync-fields',2,'2024-07-02 18:45:00.200553','2024-07-02 18:45:03.386122',3185,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4333,'sync-fks',2,'2024-07-02 18:45:03.395101','2024-07-02 18:45:04.038527',643,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4334,'sync-indexes',2,'2024-07-02 18:45:04.047789','2024-07-02 18:45:04.583444',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4335,'sync-metabase-metadata',2,'2024-07-02 18:45:04.591335','2024-07-02 18:45:04.599460',8,'{}','success'),(4336,'sync-table-privileges',2,'2024-07-02 18:45:04.607910','2024-07-02 18:45:04.617457',9,NULL,'success'),(4337,'analyze',2,'2024-07-02 18:45:04.653261','2024-07-02 18:45:06.823008',2169,NULL,'success'),(4338,'fingerprint-fields',2,'2024-07-02 18:45:04.661949','2024-07-02 18:45:06.663691',2001,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4339,'classify-fields',2,'2024-07-02 18:45:06.672099','2024-07-02 18:45:06.787211',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4340,'classify-tables',2,'2024-07-02 18:45:06.798791','2024-07-02 18:45:06.814650',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4341,'sync',2,'2024-07-02 19:45:00.111419','2024-07-02 19:45:04.760516',4649,NULL,'success'),(4342,'sync-dbms-version',2,'2024-07-02 19:45:00.122053','2024-07-02 19:45:00.133704',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4343,'sync-timezone',2,'2024-07-02 19:45:00.142940','2024-07-02 19:45:00.154516',11,'{\"timezone-id\":\"+08:00\"}','success'),(4344,'sync-tables',2,'2024-07-02 19:45:00.163528','2024-07-02 19:45:00.193140',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4345,'sync-fields',2,'2024-07-02 19:45:00.214278','2024-07-02 19:45:03.334199',3119,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4346,'sync-fks',2,'2024-07-02 19:45:03.342309','2024-07-02 19:45:04.055229',712,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4347,'sync-indexes',2,'2024-07-02 19:45:04.065749','2024-07-02 19:45:04.713372',647,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4348,'sync-metabase-metadata',2,'2024-07-02 19:45:04.722105','2024-07-02 19:45:04.732756',10,'{}','success'),(4349,'sync-table-privileges',2,'2024-07-02 19:45:04.742076','2024-07-02 19:45:04.751239',9,NULL,'success'),(4350,'analyze',2,'2024-07-02 19:45:04.792539','2024-07-02 19:45:07.063195',2270,NULL,'success'),(4351,'fingerprint-fields',2,'2024-07-02 19:45:04.803401','2024-07-02 19:45:06.906547',2103,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4352,'classify-fields',2,'2024-07-02 19:45:06.914834','2024-07-02 19:45:07.029422',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4353,'classify-tables',2,'2024-07-02 19:45:07.037405','2024-07-02 19:45:07.054285',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4354,'sync',2,'2024-07-02 20:45:00.102064','2024-07-02 20:45:04.603557',4501,NULL,'success'),(4355,'sync-dbms-version',2,'2024-07-02 20:45:00.110311','2024-07-02 20:45:00.121411',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4356,'sync-timezone',2,'2024-07-02 20:45:00.129862','2024-07-02 20:45:00.140073',10,'{\"timezone-id\":\"+08:00\"}','success'),(4357,'sync-tables',2,'2024-07-02 20:45:00.149497','2024-07-02 20:45:00.180132',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4358,'sync-fields',2,'2024-07-02 20:45:00.189269','2024-07-02 20:45:03.393008',3203,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4359,'sync-fks',2,'2024-07-02 20:45:03.400982','2024-07-02 20:45:04.030388',629,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4360,'sync-indexes',2,'2024-07-02 20:45:04.038897','2024-07-02 20:45:04.561988',523,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4361,'sync-metabase-metadata',2,'2024-07-02 20:45:04.569723','2024-07-02 20:45:04.578186',8,'{}','success'),(4362,'sync-table-privileges',2,'2024-07-02 20:45:04.586412','2024-07-02 20:45:04.595087',8,NULL,'success'),(4363,'analyze',2,'2024-07-02 20:45:04.636654','2024-07-02 20:45:06.820337',2183,NULL,'success'),(4364,'fingerprint-fields',2,'2024-07-02 20:45:04.646812','2024-07-02 20:45:06.646312',1999,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4365,'classify-fields',2,'2024-07-02 20:45:06.654949','2024-07-02 20:45:06.786887',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4366,'classify-tables',2,'2024-07-02 20:45:06.794838','2024-07-02 20:45:06.811369',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4367,'sync',2,'2024-07-02 21:45:00.100453','2024-07-02 21:45:04.318708',4218,NULL,'success'),(4368,'sync-dbms-version',2,'2024-07-02 21:45:00.109497','2024-07-02 21:45:00.118924',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4369,'sync-timezone',2,'2024-07-02 21:45:00.127500','2024-07-02 21:45:00.137492',9,'{\"timezone-id\":\"+08:00\"}','success'),(4370,'sync-tables',2,'2024-07-02 21:45:00.146595','2024-07-02 21:45:00.174943',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4371,'sync-fields',2,'2024-07-02 21:45:00.182777','2024-07-02 21:45:03.070932',2888,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4372,'sync-fks',2,'2024-07-02 21:45:03.078848','2024-07-02 21:45:03.702890',624,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4373,'sync-indexes',2,'2024-07-02 21:45:03.711568','2024-07-02 21:45:04.273495',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4374,'sync-metabase-metadata',2,'2024-07-02 21:45:04.282742','2024-07-02 21:45:04.291512',8,'{}','success'),(4375,'sync-table-privileges',2,'2024-07-02 21:45:04.300544','2024-07-02 21:45:04.309926',9,NULL,'success'),(4376,'analyze',2,'2024-07-02 21:45:04.345485','2024-07-02 21:45:06.357199',2011,NULL,'success'),(4377,'fingerprint-fields',2,'2024-07-02 21:45:04.354679','2024-07-02 21:45:06.207802',1853,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4378,'classify-fields',2,'2024-07-02 21:45:06.216030','2024-07-02 21:45:06.324944',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4379,'classify-tables',2,'2024-07-02 21:45:06.333175','2024-07-02 21:45:06.348161',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4380,'sync',2,'2024-07-02 22:45:00.123270','2024-07-02 22:45:04.450173',4326,NULL,'success'),(4381,'sync-dbms-version',2,'2024-07-02 22:45:00.132382','2024-07-02 22:45:00.142651',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4382,'sync-timezone',2,'2024-07-02 22:45:00.151371','2024-07-02 22:45:00.161259',9,'{\"timezone-id\":\"+08:00\"}','success'),(4383,'sync-tables',2,'2024-07-02 22:45:00.170301','2024-07-02 22:45:00.203441',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4384,'sync-fields',2,'2024-07-02 22:45:00.212811','2024-07-02 22:45:03.213295',3000,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4385,'sync-fks',2,'2024-07-02 22:45:03.221449','2024-07-02 22:45:03.862068',640,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4386,'sync-indexes',2,'2024-07-02 22:45:03.874061','2024-07-02 22:45:04.410199',536,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4387,'sync-metabase-metadata',2,'2024-07-02 22:45:04.417950','2024-07-02 22:45:04.426029',8,'{}','success'),(4388,'sync-table-privileges',2,'2024-07-02 22:45:04.434136','2024-07-02 22:45:04.442197',8,NULL,'success'),(4389,'analyze',2,'2024-07-02 22:45:04.476808','2024-07-02 22:45:06.626634',2149,NULL,'success'),(4390,'fingerprint-fields',2,'2024-07-02 22:45:04.485402','2024-07-02 22:45:06.464656',1979,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4391,'classify-fields',2,'2024-07-02 22:45:06.473577','2024-07-02 22:45:06.596937',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4392,'classify-tables',2,'2024-07-02 22:45:06.604332','2024-07-02 22:45:06.617534',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4393,'sync',2,'2024-07-02 23:45:00.112522','2024-07-02 23:45:04.620758',4508,NULL,'success'),(4394,'sync-dbms-version',2,'2024-07-02 23:45:00.120735','2024-07-02 23:45:00.129615',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4395,'sync-timezone',2,'2024-07-02 23:45:00.138380','2024-07-02 23:45:00.149601',11,'{\"timezone-id\":\"+08:00\"}','success'),(4396,'sync-tables',2,'2024-07-02 23:45:00.158156','2024-07-02 23:45:00.191978',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4397,'sync-fields',2,'2024-07-02 23:45:00.202547','2024-07-02 23:45:03.359315',3156,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4398,'sync-fks',2,'2024-07-02 23:45:03.367290','2024-07-02 23:45:04.032729',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4399,'sync-indexes',2,'2024-07-02 23:45:04.041420','2024-07-02 23:45:04.579823',538,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4400,'sync-metabase-metadata',2,'2024-07-02 23:45:04.587217','2024-07-02 23:45:04.595071',7,'{}','success'),(4401,'sync-table-privileges',2,'2024-07-02 23:45:04.602850','2024-07-02 23:45:04.610761',7,NULL,'success'),(4402,'analyze',2,'2024-07-02 23:45:04.654447','2024-07-02 23:45:06.797521',2143,NULL,'success'),(4403,'fingerprint-fields',2,'2024-07-02 23:45:04.665924','2024-07-02 23:45:06.653753',1987,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4404,'classify-fields',2,'2024-07-02 23:45:06.665138','2024-07-02 23:45:06.768335',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4405,'classify-tables',2,'2024-07-02 23:45:06.776165','2024-07-02 23:45:06.789240',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4406,'sync',2,'2024-07-03 00:45:00.126541','2024-07-03 00:45:04.706221',4579,NULL,'success'),(4407,'sync-dbms-version',2,'2024-07-03 00:45:00.135004','2024-07-03 00:45:00.145878',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4408,'sync-timezone',2,'2024-07-03 00:45:00.155132','2024-07-03 00:45:00.167471',12,'{\"timezone-id\":\"+08:00\"}','success'),(4409,'sync-tables',2,'2024-07-03 00:45:00.176789','2024-07-03 00:45:00.208208',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4410,'sync-fields',2,'2024-07-03 00:45:00.217621','2024-07-03 00:45:03.389761',3172,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4411,'sync-fks',2,'2024-07-03 00:45:03.397619','2024-07-03 00:45:04.071349',673,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4412,'sync-indexes',2,'2024-07-03 00:45:04.081094','2024-07-03 00:45:04.663557',582,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4413,'sync-metabase-metadata',2,'2024-07-03 00:45:04.672243','2024-07-03 00:45:04.681270',9,'{}','success'),(4414,'sync-table-privileges',2,'2024-07-03 00:45:04.689269','2024-07-03 00:45:04.697693',8,NULL,'success'),(4415,'analyze',2,'2024-07-03 00:45:04.732733','2024-07-03 00:45:06.931146',2198,NULL,'success'),(4416,'fingerprint-fields',2,'2024-07-03 00:45:04.741184','2024-07-03 00:45:06.790071',2048,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4417,'classify-fields',2,'2024-07-03 00:45:06.798297','2024-07-03 00:45:06.902861',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4418,'classify-tables',2,'2024-07-03 00:45:06.910190','2024-07-03 00:45:06.923453',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4419,'sync',2,'2024-07-03 01:45:00.113521','2024-07-03 01:45:04.580731',4467,NULL,'success'),(4420,'sync-dbms-version',2,'2024-07-03 01:45:00.121785','2024-07-03 01:45:00.132171',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4421,'sync-timezone',2,'2024-07-03 01:45:00.141356','2024-07-03 01:45:00.152600',11,'{\"timezone-id\":\"+08:00\"}','success'),(4422,'sync-tables',2,'2024-07-03 01:45:00.161770','2024-07-03 01:45:00.190779',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4423,'sync-fields',2,'2024-07-03 01:45:00.199293','2024-07-03 01:45:03.269896',3070,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4424,'sync-fks',2,'2024-07-03 01:45:03.277843','2024-07-03 01:45:03.943276',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4425,'sync-indexes',2,'2024-07-03 01:45:03.951918','2024-07-03 01:45:04.539564',587,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4426,'sync-metabase-metadata',2,'2024-07-03 01:45:04.547156','2024-07-03 01:45:04.554809',7,'{}','success'),(4427,'sync-table-privileges',2,'2024-07-03 01:45:04.563366','2024-07-03 01:45:04.572997',9,NULL,'success'),(4428,'analyze',2,'2024-07-03 01:45:04.606003','2024-07-03 01:45:06.870714',2264,NULL,'success'),(4429,'fingerprint-fields',2,'2024-07-03 01:45:04.614648','2024-07-03 01:45:06.704010',2089,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4430,'classify-fields',2,'2024-07-03 01:45:06.712903','2024-07-03 01:45:06.839623',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4431,'classify-tables',2,'2024-07-03 01:45:06.847532','2024-07-03 01:45:06.862143',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4432,'sync',2,'2024-07-03 02:45:00.114610','2024-07-03 02:45:04.380100',4265,NULL,'success'),(4433,'sync-dbms-version',2,'2024-07-03 02:45:00.123187','2024-07-03 02:45:00.133437',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4434,'sync-timezone',2,'2024-07-03 02:45:00.142069','2024-07-03 02:45:00.152457',10,'{\"timezone-id\":\"+08:00\"}','success'),(4435,'sync-tables',2,'2024-07-03 02:45:00.162547','2024-07-03 02:45:00.193950',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4436,'sync-fields',2,'2024-07-03 02:45:00.203616','2024-07-03 02:45:03.156416',2952,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4437,'sync-fks',2,'2024-07-03 02:45:03.164259','2024-07-03 02:45:03.755336',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4438,'sync-indexes',2,'2024-07-03 02:45:03.764648','2024-07-03 02:45:04.335472',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4439,'sync-metabase-metadata',2,'2024-07-03 02:45:04.343865','2024-07-03 02:45:04.353697',9,'{}','success'),(4440,'sync-table-privileges',2,'2024-07-03 02:45:04.362194','2024-07-03 02:45:04.370886',8,NULL,'success'),(4441,'analyze',2,'2024-07-03 02:45:04.407792','2024-07-03 02:45:06.489323',2081,NULL,'success'),(4442,'fingerprint-fields',2,'2024-07-03 02:45:04.417823','2024-07-03 02:45:06.333950',1916,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4443,'classify-fields',2,'2024-07-03 02:45:06.342568','2024-07-03 02:45:06.457088',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4444,'classify-tables',2,'2024-07-03 02:45:06.464853','2024-07-03 02:45:06.479368',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4445,'sync',2,'2024-07-03 03:45:00.129053','2024-07-03 03:45:04.566165',4437,NULL,'success'),(4446,'sync-dbms-version',2,'2024-07-03 03:45:00.138844','2024-07-03 03:45:00.148982',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4447,'sync-timezone',2,'2024-07-03 03:45:00.160402','2024-07-03 03:45:00.172072',11,'{\"timezone-id\":\"+08:00\"}','success'),(4448,'sync-tables',2,'2024-07-03 03:45:00.181389','2024-07-03 03:45:00.209944',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4449,'sync-fields',2,'2024-07-03 03:45:00.218533','2024-07-03 03:45:03.282388',3063,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4450,'sync-fks',2,'2024-07-03 03:45:03.290949','2024-07-03 03:45:03.974370',683,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4451,'sync-indexes',2,'2024-07-03 03:45:03.982471','2024-07-03 03:45:04.525514',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4452,'sync-metabase-metadata',2,'2024-07-03 03:45:04.533338','2024-07-03 03:45:04.541426',8,'{}','success'),(4453,'sync-table-privileges',2,'2024-07-03 03:45:04.549471','2024-07-03 03:45:04.557450',7,NULL,'success'),(4454,'analyze',2,'2024-07-03 03:45:04.592359','2024-07-03 03:45:06.755950',2163,NULL,'success'),(4455,'fingerprint-fields',2,'2024-07-03 03:45:04.602656','2024-07-03 03:45:06.606626',2003,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4456,'classify-fields',2,'2024-07-03 03:45:06.614846','2024-07-03 03:45:06.726740',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4457,'classify-tables',2,'2024-07-03 03:45:06.734054','2024-07-03 03:45:06.747156',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4458,'task-history-cleanup',NULL,'2024-07-03 04:00:00.059938','2024-07-03 04:00:00.079844',19,NULL,'success'),(4459,'sync',2,'2024-07-03 04:45:00.123084','2024-07-03 04:45:04.826029',4702,NULL,'success'),(4460,'sync-dbms-version',2,'2024-07-03 04:45:00.131739','2024-07-03 04:45:00.141311',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4461,'sync-timezone',2,'2024-07-03 04:45:00.151239','2024-07-03 04:45:00.162852',11,'{\"timezone-id\":\"+08:00\"}','success'),(4462,'sync-tables',2,'2024-07-03 04:45:00.172316','2024-07-03 04:45:00.199418',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4463,'sync-fields',2,'2024-07-03 04:45:00.208132','2024-07-03 04:45:03.442760',3234,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4464,'sync-fks',2,'2024-07-03 04:45:03.451043','2024-07-03 04:45:04.154051',703,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4465,'sync-indexes',2,'2024-07-03 04:45:04.163921','2024-07-03 04:45:04.780216',616,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4466,'sync-metabase-metadata',2,'2024-07-03 04:45:04.788673','2024-07-03 04:45:04.798879',10,'{}','success'),(4467,'sync-table-privileges',2,'2024-07-03 04:45:04.808377','2024-07-03 04:45:04.817024',8,NULL,'success'),(4468,'analyze',2,'2024-07-03 04:45:04.854399','2024-07-03 04:45:07.097349',2242,NULL,'success'),(4469,'fingerprint-fields',2,'2024-07-03 04:45:04.863551','2024-07-03 04:45:06.922596',2059,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4470,'classify-fields',2,'2024-07-03 04:45:06.930703','2024-07-03 04:45:07.064646',133,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4471,'classify-tables',2,'2024-07-03 04:45:07.073042','2024-07-03 04:45:07.087766',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4472,'sync',2,'2024-07-03 05:45:00.115346','2024-07-03 05:45:04.580545',4465,NULL,'success'),(4473,'sync-dbms-version',2,'2024-07-03 05:45:00.123663','2024-07-03 05:45:00.134302',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4474,'sync-timezone',2,'2024-07-03 05:45:00.143031','2024-07-03 05:45:00.153364',10,'{\"timezone-id\":\"+08:00\"}','success'),(4475,'sync-tables',2,'2024-07-03 05:45:00.162199','2024-07-03 05:45:00.190668',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4476,'sync-fields',2,'2024-07-03 05:45:00.199450','2024-07-03 05:45:03.331886',3132,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4477,'sync-fks',2,'2024-07-03 05:45:03.339993','2024-07-03 05:45:03.935078',595,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4478,'sync-indexes',2,'2024-07-03 05:45:03.943134','2024-07-03 05:45:04.527502',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4479,'sync-metabase-metadata',2,'2024-07-03 05:45:04.535982','2024-07-03 05:45:04.545748',9,'{}','success'),(4480,'sync-table-privileges',2,'2024-07-03 05:45:04.556519','2024-07-03 05:45:04.571674',15,NULL,'success'),(4481,'analyze',2,'2024-07-03 05:45:04.614934','2024-07-03 05:45:06.683829',2068,NULL,'success'),(4482,'fingerprint-fields',2,'2024-07-03 05:45:04.624963','2024-07-03 05:45:06.531175',1906,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4483,'classify-fields',2,'2024-07-03 05:45:06.541632','2024-07-03 05:45:06.654086',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4484,'classify-tables',2,'2024-07-03 05:45:06.662209','2024-07-03 05:45:06.675368',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4485,'sync',2,'2024-07-03 06:45:00.092210','2024-07-03 06:45:04.403065',4310,NULL,'success'),(4486,'sync-dbms-version',2,'2024-07-03 06:45:00.100375','2024-07-03 06:45:00.110903',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4487,'sync-timezone',2,'2024-07-03 06:45:00.120097','2024-07-03 06:45:00.131523',11,'{\"timezone-id\":\"+08:00\"}','success'),(4488,'sync-tables',2,'2024-07-03 06:45:00.139844','2024-07-03 06:45:00.166812',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4489,'sync-fields',2,'2024-07-03 06:45:00.175818','2024-07-03 06:45:03.218851',3043,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4490,'sync-fks',2,'2024-07-03 06:45:03.226422','2024-07-03 06:45:03.804619',578,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4491,'sync-indexes',2,'2024-07-03 06:45:03.815482','2024-07-03 06:45:04.360083',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4492,'sync-metabase-metadata',2,'2024-07-03 06:45:04.368221','2024-07-03 06:45:04.376466',8,'{}','success'),(4493,'sync-table-privileges',2,'2024-07-03 06:45:04.385835','2024-07-03 06:45:04.394692',8,NULL,'success'),(4494,'analyze',2,'2024-07-03 06:45:04.432304','2024-07-03 06:45:06.506947',2074,NULL,'success'),(4495,'fingerprint-fields',2,'2024-07-03 06:45:04.441484','2024-07-03 06:45:06.347807',1906,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4496,'classify-fields',2,'2024-07-03 06:45:06.355938','2024-07-03 06:45:06.475229',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4497,'classify-tables',2,'2024-07-03 06:45:06.484242','2024-07-03 06:45:06.498226',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4498,'sync',2,'2024-07-03 07:45:00.106908','2024-07-03 07:45:04.691521',4584,NULL,'success'),(4499,'sync-dbms-version',2,'2024-07-03 07:45:00.115674','2024-07-03 07:45:00.124984',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4500,'sync-timezone',2,'2024-07-03 07:45:00.133283','2024-07-03 07:45:00.142733',9,'{\"timezone-id\":\"+08:00\"}','success'),(4501,'sync-tables',2,'2024-07-03 07:45:00.151520','2024-07-03 07:45:00.180079',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4502,'sync-fields',2,'2024-07-03 07:45:00.188892','2024-07-03 07:45:03.297364',3108,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4503,'sync-fks',2,'2024-07-03 07:45:03.305753','2024-07-03 07:45:04.026087',720,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4504,'sync-indexes',2,'2024-07-03 07:45:04.035510','2024-07-03 07:45:04.645191',609,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4505,'sync-metabase-metadata',2,'2024-07-03 07:45:04.653262','2024-07-03 07:45:04.662627',9,'{}','success'),(4506,'sync-table-privileges',2,'2024-07-03 07:45:04.671345','2024-07-03 07:45:04.681856',10,NULL,'success'),(4507,'analyze',2,'2024-07-03 07:45:04.723008','2024-07-03 07:45:07.047241',2324,NULL,'success'),(4508,'fingerprint-fields',2,'2024-07-03 07:45:04.733830','2024-07-03 07:45:06.870664',2136,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4509,'classify-fields',2,'2024-07-03 07:45:06.879595','2024-07-03 07:45:07.010227',130,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4510,'classify-tables',2,'2024-07-03 07:45:07.019088','2024-07-03 07:45:07.036109',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4511,'sync',2,'2024-07-03 08:45:00.101550','2024-07-03 08:45:04.489677',4388,NULL,'success'),(4512,'sync-dbms-version',2,'2024-07-03 08:45:00.109383','2024-07-03 08:45:00.118412',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4513,'sync-timezone',2,'2024-07-03 08:45:00.126830','2024-07-03 08:45:00.136654',9,'{\"timezone-id\":\"+08:00\"}','success'),(4514,'sync-tables',2,'2024-07-03 08:45:00.144832','2024-07-03 08:45:00.169983',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4515,'sync-fields',2,'2024-07-03 08:45:00.177814','2024-07-03 08:45:03.192725',3014,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4516,'sync-fks',2,'2024-07-03 08:45:03.201104','2024-07-03 08:45:03.863494',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4517,'sync-indexes',2,'2024-07-03 08:45:03.871766','2024-07-03 08:45:04.447340',575,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4518,'sync-metabase-metadata',2,'2024-07-03 08:45:04.454854','2024-07-03 08:45:04.464091',9,'{}','success'),(4519,'sync-table-privileges',2,'2024-07-03 08:45:04.472475','2024-07-03 08:45:04.480818',8,NULL,'success'),(4520,'analyze',2,'2024-07-03 08:45:04.514267','2024-07-03 08:45:06.605751',2091,NULL,'success'),(4521,'fingerprint-fields',2,'2024-07-03 08:45:04.523105','2024-07-03 08:45:06.451658',1928,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4522,'classify-fields',2,'2024-07-03 08:45:06.460781','2024-07-03 08:45:06.575696',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4523,'classify-tables',2,'2024-07-03 08:45:06.584054','2024-07-03 08:45:06.597466',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4524,'sync',2,'2024-07-03 09:45:00.091051','2024-07-03 09:45:04.218913',4127,NULL,'success'),(4525,'sync-dbms-version',2,'2024-07-03 09:45:00.098670','2024-07-03 09:45:00.107780',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4526,'sync-timezone',2,'2024-07-03 09:45:00.116305','2024-07-03 09:45:00.126104',9,'{\"timezone-id\":\"+08:00\"}','success'),(4527,'sync-tables',2,'2024-07-03 09:45:00.134763','2024-07-03 09:45:00.162625',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4528,'sync-fields',2,'2024-07-03 09:45:00.170944','2024-07-03 09:45:03.022709',2851,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4529,'sync-fks',2,'2024-07-03 09:45:03.029852','2024-07-03 09:45:03.616606',586,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4530,'sync-indexes',2,'2024-07-03 09:45:03.625136','2024-07-03 09:45:04.169899',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4531,'sync-metabase-metadata',2,'2024-07-03 09:45:04.182659','2024-07-03 09:45:04.191865',9,'{}','success'),(4532,'sync-table-privileges',2,'2024-07-03 09:45:04.200424','2024-07-03 09:45:04.209754',9,NULL,'success'),(4533,'analyze',2,'2024-07-03 09:45:04.245995','2024-07-03 09:45:06.327947',2081,NULL,'success'),(4534,'fingerprint-fields',2,'2024-07-03 09:45:04.254475','2024-07-03 09:45:06.191903',1937,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4535,'classify-fields',2,'2024-07-03 09:45:06.200131','2024-07-03 09:45:06.299003',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4536,'classify-tables',2,'2024-07-03 09:45:06.306347','2024-07-03 09:45:06.318758',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4537,'sync',2,'2024-07-03 10:45:00.093907','2024-07-03 10:45:04.325227',4231,NULL,'success'),(4538,'sync-dbms-version',2,'2024-07-03 10:45:00.101849','2024-07-03 10:45:00.113175',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4539,'sync-timezone',2,'2024-07-03 10:45:00.121828','2024-07-03 10:45:00.132061',10,'{\"timezone-id\":\"+08:00\"}','success'),(4540,'sync-tables',2,'2024-07-03 10:45:00.140734','2024-07-03 10:45:00.168684',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4541,'sync-fields',2,'2024-07-03 10:45:00.177729','2024-07-03 10:45:03.126990',2949,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4542,'sync-fks',2,'2024-07-03 10:45:03.134352','2024-07-03 10:45:03.720204',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4543,'sync-indexes',2,'2024-07-03 10:45:03.728369','2024-07-03 10:45:04.283293',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4544,'sync-metabase-metadata',2,'2024-07-03 10:45:04.290536','2024-07-03 10:45:04.298796',8,'{}','success'),(4545,'sync-table-privileges',2,'2024-07-03 10:45:04.306894','2024-07-03 10:45:04.315759',8,NULL,'success'),(4546,'analyze',2,'2024-07-03 10:45:04.355127','2024-07-03 10:45:06.438312',2083,NULL,'success'),(4547,'fingerprint-fields',2,'2024-07-03 10:45:04.364365','2024-07-03 10:45:06.288819',1924,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4548,'classify-fields',2,'2024-07-03 10:45:06.297185','2024-07-03 10:45:06.407458',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4549,'classify-tables',2,'2024-07-03 10:45:06.415612','2024-07-03 10:45:06.430220',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4550,'sync',2,'2024-07-03 11:45:00.101286','2024-07-03 11:45:04.419782',4318,NULL,'success'),(4551,'sync-dbms-version',2,'2024-07-03 11:45:00.111607','2024-07-03 11:45:00.121525',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4552,'sync-timezone',2,'2024-07-03 11:45:00.130864','2024-07-03 11:45:00.142645',11,'{\"timezone-id\":\"+08:00\"}','success'),(4553,'sync-tables',2,'2024-07-03 11:45:00.151016','2024-07-03 11:45:00.177732',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4554,'sync-fields',2,'2024-07-03 11:45:00.185681','2024-07-03 11:45:03.191092',3005,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4555,'sync-fks',2,'2024-07-03 11:45:03.199763','2024-07-03 11:45:03.831890',632,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4556,'sync-indexes',2,'2024-07-03 11:45:03.840852','2024-07-03 11:45:04.372716',531,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4557,'sync-metabase-metadata',2,'2024-07-03 11:45:04.380685','2024-07-03 11:45:04.389408',8,'{}','success'),(4558,'sync-table-privileges',2,'2024-07-03 11:45:04.400023','2024-07-03 11:45:04.410555',10,NULL,'success'),(4559,'analyze',2,'2024-07-03 11:45:04.444527','2024-07-03 11:45:06.510715',2066,NULL,'success'),(4560,'fingerprint-fields',2,'2024-07-03 11:45:04.452506','2024-07-03 11:45:06.366323',1913,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4561,'classify-fields',2,'2024-07-03 11:45:06.374501','2024-07-03 11:45:06.480945',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4562,'classify-tables',2,'2024-07-03 11:45:06.488915','2024-07-03 11:45:06.501962',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4563,'sync',2,'2024-07-03 12:45:00.111479','2024-07-03 12:45:04.293484',4182,NULL,'success'),(4564,'sync-dbms-version',2,'2024-07-03 12:45:00.119283','2024-07-03 12:45:00.129745',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4565,'sync-timezone',2,'2024-07-03 12:45:00.138223','2024-07-03 12:45:00.147488',9,'{\"timezone-id\":\"+08:00\"}','success'),(4566,'sync-tables',2,'2024-07-03 12:45:00.155787','2024-07-03 12:45:00.184076',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4567,'sync-fields',2,'2024-07-03 12:45:00.192317','2024-07-03 12:45:03.097451',2905,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4568,'sync-fks',2,'2024-07-03 12:45:03.108749','2024-07-03 12:45:03.717987',609,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4569,'sync-indexes',2,'2024-07-03 12:45:03.726143','2024-07-03 12:45:04.251880',525,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4570,'sync-metabase-metadata',2,'2024-07-03 12:45:04.259524','2024-07-03 12:45:04.267725',8,'{}','success'),(4571,'sync-table-privileges',2,'2024-07-03 12:45:04.275941','2024-07-03 12:45:04.283923',7,NULL,'success'),(4572,'analyze',2,'2024-07-03 12:45:04.320192','2024-07-03 12:45:06.187211',1867,NULL,'success'),(4573,'fingerprint-fields',2,'2024-07-03 12:45:04.328772','2024-07-03 12:45:06.047079',1718,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4574,'classify-fields',2,'2024-07-03 12:45:06.056035','2024-07-03 12:45:06.159648',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4575,'classify-tables',2,'2024-07-03 12:45:06.166969','2024-07-03 12:45:06.179530',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4576,'field values scanning',2,'2024-07-03 13:00:00.067681','2024-07-03 13:00:11.612062',11544,NULL,'success'),(4577,'delete-expired-advanced-field-values',2,'2024-07-03 13:00:00.077748','2024-07-03 13:00:03.169720',3091,'{\"deleted\":0}','success'),(4578,'update-field-values',2,'2024-07-03 13:00:03.177914','2024-07-03 13:00:11.604799',8426,'{\"errors\":0,\"created\":0,\"updated\":31,\"deleted\":0}','success'),(4579,'sync',2,'2024-07-03 13:45:00.107575','2024-07-03 13:45:04.142111',4034,NULL,'success'),(4580,'sync-dbms-version',2,'2024-07-03 13:45:00.117781','2024-07-03 13:45:00.127676',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4581,'sync-timezone',2,'2024-07-03 13:45:00.137813','2024-07-03 13:45:00.148034',10,'{\"timezone-id\":\"+08:00\"}','success'),(4582,'sync-tables',2,'2024-07-03 13:45:00.157449','2024-07-03 13:45:00.184737',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4583,'sync-fields',2,'2024-07-03 13:45:00.193878','2024-07-03 13:45:03.051325',2857,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4584,'sync-fks',2,'2024-07-03 13:45:03.060828','2024-07-03 13:45:03.598758',537,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4585,'sync-indexes',2,'2024-07-03 13:45:03.607426','2024-07-03 13:45:04.100196',492,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4586,'sync-metabase-metadata',2,'2024-07-03 13:45:04.107639','2024-07-03 13:45:04.115635',7,'{}','success'),(4587,'sync-table-privileges',2,'2024-07-03 13:45:04.124896','2024-07-03 13:45:04.134125',9,NULL,'success'),(4588,'analyze',2,'2024-07-03 13:45:04.165298','2024-07-03 13:45:06.200286',2034,NULL,'success'),(4589,'fingerprint-fields',2,'2024-07-03 13:45:04.173687','2024-07-03 13:45:06.049202',1875,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4590,'classify-fields',2,'2024-07-03 13:45:06.057992','2024-07-03 13:45:06.169457',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4591,'classify-tables',2,'2024-07-03 13:45:06.176996','2024-07-03 13:45:06.192196',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4592,'sync',2,'2024-07-03 14:45:00.108458','2024-07-03 14:45:04.253027',4144,NULL,'success'),(4593,'sync-dbms-version',2,'2024-07-03 14:45:00.116806','2024-07-03 14:45:00.126682',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4594,'sync-timezone',2,'2024-07-03 14:45:00.135869','2024-07-03 14:45:00.146363',10,'{\"timezone-id\":\"+08:00\"}','success'),(4595,'sync-tables',2,'2024-07-03 14:45:00.154930','2024-07-03 14:45:00.183105',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4596,'sync-fields',2,'2024-07-03 14:45:00.192051','2024-07-03 14:45:03.094279',2902,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4597,'sync-fks',2,'2024-07-03 14:45:03.103960','2024-07-03 14:45:03.708314',604,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4598,'sync-indexes',2,'2024-07-03 14:45:03.717485','2024-07-03 14:45:04.211608',494,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4599,'sync-metabase-metadata',2,'2024-07-03 14:45:04.219095','2024-07-03 14:45:04.227534',8,'{}','success'),(4600,'sync-table-privileges',2,'2024-07-03 14:45:04.236990','2024-07-03 14:45:04.244952',7,NULL,'success'),(4601,'analyze',2,'2024-07-03 14:45:04.281214','2024-07-03 14:45:06.375980',2094,NULL,'success'),(4602,'fingerprint-fields',2,'2024-07-03 14:45:04.289218','2024-07-03 14:45:06.225007',1935,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4603,'classify-fields',2,'2024-07-03 14:45:06.233278','2024-07-03 14:45:06.348091',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4604,'classify-tables',2,'2024-07-03 14:45:06.355908','2024-07-03 14:45:06.368314',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4605,'sync',2,'2024-07-03 15:45:00.126146','2024-07-03 15:45:04.592370',4466,NULL,'success'),(4606,'sync-dbms-version',2,'2024-07-03 15:45:00.136997','2024-07-03 15:45:00.146378',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4607,'sync-timezone',2,'2024-07-03 15:45:00.155651','2024-07-03 15:45:00.165736',10,'{\"timezone-id\":\"+08:00\"}','success'),(4608,'sync-tables',2,'2024-07-03 15:45:00.174206','2024-07-03 15:45:00.205748',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4609,'sync-fields',2,'2024-07-03 15:45:00.215120','2024-07-03 15:45:03.249180',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4610,'sync-fks',2,'2024-07-03 15:45:03.256923','2024-07-03 15:45:03.905385',648,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4611,'sync-indexes',2,'2024-07-03 15:45:03.914766','2024-07-03 15:45:04.544479',629,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4612,'sync-metabase-metadata',2,'2024-07-03 15:45:04.554487','2024-07-03 15:45:04.563149',8,'{}','success'),(4613,'sync-table-privileges',2,'2024-07-03 15:45:04.572354','2024-07-03 15:45:04.582024',9,NULL,'success'),(4614,'analyze',2,'2024-07-03 15:45:04.618808','2024-07-03 15:45:06.708041',2089,NULL,'success'),(4615,'fingerprint-fields',2,'2024-07-03 15:45:04.628181','2024-07-03 15:45:06.561985',1933,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4616,'classify-fields',2,'2024-07-03 15:45:06.570051','2024-07-03 15:45:06.678721',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4617,'classify-tables',2,'2024-07-03 15:45:06.686322','2024-07-03 15:45:06.700226',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4618,'task-history-cleanup',NULL,'2024-07-03 16:00:00.016160','2024-07-03 16:00:00.060904',44,NULL,'success'),(4619,'task-history-cleanup',NULL,'2024-07-03 16:00:00.068784','2024-07-03 16:00:00.081822',13,NULL,'success'),(4620,'sync',2,'2024-07-03 16:45:00.107692','2024-07-03 16:45:04.346557',4238,NULL,'success'),(4621,'sync-dbms-version',2,'2024-07-03 16:45:00.116141','2024-07-03 16:45:00.125459',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4622,'sync-timezone',2,'2024-07-03 16:45:00.134214','2024-07-03 16:45:00.147107',12,'{\"timezone-id\":\"+08:00\"}','success'),(4623,'sync-tables',2,'2024-07-03 16:45:00.156108','2024-07-03 16:45:00.183749',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4624,'sync-fields',2,'2024-07-03 16:45:00.200331','2024-07-03 16:45:03.234283',3033,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4625,'sync-fks',2,'2024-07-03 16:45:03.241731','2024-07-03 16:45:03.787845',546,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4626,'sync-indexes',2,'2024-07-03 16:45:03.796750','2024-07-03 16:45:04.303545',506,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4627,'sync-metabase-metadata',2,'2024-07-03 16:45:04.311652','2024-07-03 16:45:04.321050',9,'{}','success'),(4628,'sync-table-privileges',2,'2024-07-03 16:45:04.329028','2024-07-03 16:45:04.338271',9,NULL,'success'),(4629,'analyze',2,'2024-07-03 16:45:04.373794','2024-07-03 16:45:06.449961',2076,NULL,'success'),(4630,'fingerprint-fields',2,'2024-07-03 16:45:04.382201','2024-07-03 16:45:06.295089',1912,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4631,'classify-fields',2,'2024-07-03 16:45:06.303562','2024-07-03 16:45:06.418273',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4632,'classify-tables',2,'2024-07-03 16:45:06.425754','2024-07-03 16:45:06.441251',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4633,'sync',2,'2024-07-03 17:45:00.104286','2024-07-03 17:45:04.506596',4402,NULL,'success'),(4634,'sync-dbms-version',2,'2024-07-03 17:45:00.112158','2024-07-03 17:45:00.120923',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4635,'sync-timezone',2,'2024-07-03 17:45:00.129345','2024-07-03 17:45:00.140333',10,'{\"timezone-id\":\"+08:00\"}','success'),(4636,'sync-tables',2,'2024-07-03 17:45:00.149289','2024-07-03 17:45:00.177222',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4637,'sync-fields',2,'2024-07-03 17:45:00.186533','2024-07-03 17:45:03.281602',3095,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4638,'sync-fks',2,'2024-07-03 17:45:03.290271','2024-07-03 17:45:03.913349',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4639,'sync-indexes',2,'2024-07-03 17:45:03.921307','2024-07-03 17:45:04.469148',547,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4640,'sync-metabase-metadata',2,'2024-07-03 17:45:04.475883','2024-07-03 17:45:04.483305',7,'{}','success'),(4641,'sync-table-privileges',2,'2024-07-03 17:45:04.490800','2024-07-03 17:45:04.499246',8,NULL,'success'),(4642,'analyze',2,'2024-07-03 17:45:04.530694','2024-07-03 17:45:06.672365',2141,NULL,'success'),(4643,'fingerprint-fields',2,'2024-07-03 17:45:04.538347','2024-07-03 17:45:06.503032',1964,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4644,'classify-fields',2,'2024-07-03 17:45:06.511905','2024-07-03 17:45:06.639438',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4645,'classify-tables',2,'2024-07-03 17:45:06.647910','2024-07-03 17:45:06.663014',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4646,'sync',2,'2024-07-03 18:45:00.105058','2024-07-03 18:45:05.413037',5307,NULL,'success'),(4647,'sync-dbms-version',2,'2024-07-03 18:45:00.114710','2024-07-03 18:45:00.125663',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4648,'sync-timezone',2,'2024-07-03 18:45:00.134126','2024-07-03 18:45:00.144978',10,'{\"timezone-id\":\"+08:00\"}','success'),(4649,'sync-tables',2,'2024-07-03 18:45:00.153943','2024-07-03 18:45:00.179714',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4650,'sync-fields',2,'2024-07-03 18:45:00.187893','2024-07-03 18:45:03.284333',3096,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4651,'sync-fks',2,'2024-07-03 18:45:03.292472','2024-07-03 18:45:03.994863',702,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4652,'sync-indexes',2,'2024-07-03 18:45:04.003057','2024-07-03 18:45:05.368864',1365,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4653,'sync-metabase-metadata',2,'2024-07-03 18:45:05.377272','2024-07-03 18:45:05.386074',8,'{}','success'),(4654,'sync-table-privileges',2,'2024-07-03 18:45:05.394800','2024-07-03 18:45:05.404017',9,NULL,'success'),(4655,'analyze',2,'2024-07-03 18:45:05.448166','2024-07-03 18:45:07.698868',2250,NULL,'success'),(4656,'fingerprint-fields',2,'2024-07-03 18:45:05.457182','2024-07-03 18:45:07.551786',2094,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4657,'classify-fields',2,'2024-07-03 18:45:07.559941','2024-07-03 18:45:07.669610',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4658,'classify-tables',2,'2024-07-03 18:45:07.677142','2024-07-03 18:45:07.690354',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4659,'sync',2,'2024-07-03 19:45:00.107355','2024-07-03 19:45:04.312845',4205,NULL,'success'),(4660,'sync-dbms-version',2,'2024-07-03 19:45:00.115486','2024-07-03 19:45:00.125006',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4661,'sync-timezone',2,'2024-07-03 19:45:00.133774','2024-07-03 19:45:00.143390',9,'{\"timezone-id\":\"+08:00\"}','success'),(4662,'sync-tables',2,'2024-07-03 19:45:00.151627','2024-07-03 19:45:00.180215',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4663,'sync-fields',2,'2024-07-03 19:45:00.189202','2024-07-03 19:45:03.133449',2944,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4664,'sync-fks',2,'2024-07-03 19:45:03.143232','2024-07-03 19:45:03.765372',622,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4665,'sync-indexes',2,'2024-07-03 19:45:03.773713','2024-07-03 19:45:04.274370',500,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4666,'sync-metabase-metadata',2,'2024-07-03 19:45:04.281706','2024-07-03 19:45:04.289490',7,'{}','success'),(4667,'sync-table-privileges',2,'2024-07-03 19:45:04.297291','2024-07-03 19:45:04.305258',7,NULL,'success'),(4668,'analyze',2,'2024-07-03 19:45:04.337907','2024-07-03 19:45:06.290824',1952,NULL,'success'),(4669,'fingerprint-fields',2,'2024-07-03 19:45:04.345988','2024-07-03 19:45:06.126436',1780,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4670,'classify-fields',2,'2024-07-03 19:45:06.134826','2024-07-03 19:45:06.261292',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4671,'classify-tables',2,'2024-07-03 19:45:06.269366','2024-07-03 19:45:06.282379',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4672,'sync',2,'2024-07-03 20:45:00.100662','2024-07-03 20:45:04.536876',4436,NULL,'success'),(4673,'sync-dbms-version',2,'2024-07-03 20:45:00.109390','2024-07-03 20:45:00.119152',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4674,'sync-timezone',2,'2024-07-03 20:45:00.127528','2024-07-03 20:45:00.137030',9,'{\"timezone-id\":\"+08:00\"}','success'),(4675,'sync-tables',2,'2024-07-03 20:45:00.145042','2024-07-03 20:45:00.177174',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4676,'sync-fields',2,'2024-07-03 20:45:00.186405','2024-07-03 20:45:03.219776',3033,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4677,'sync-fks',2,'2024-07-03 20:45:03.228462','2024-07-03 20:45:03.909601',681,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4678,'sync-indexes',2,'2024-07-03 20:45:03.918189','2024-07-03 20:45:04.492423',574,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4679,'sync-metabase-metadata',2,'2024-07-03 20:45:04.500539','2024-07-03 20:45:04.511083',10,'{}','success'),(4680,'sync-table-privileges',2,'2024-07-03 20:45:04.520035','2024-07-03 20:45:04.528594',8,NULL,'success'),(4681,'analyze',2,'2024-07-03 20:45:04.567386','2024-07-03 20:45:06.651777',2084,NULL,'success'),(4682,'fingerprint-fields',2,'2024-07-03 20:45:04.576918','2024-07-03 20:45:06.507774',1930,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4683,'classify-fields',2,'2024-07-03 20:45:06.516520','2024-07-03 20:45:06.623248',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4684,'classify-tables',2,'2024-07-03 20:45:06.630480','2024-07-03 20:45:06.644056',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4685,'sync',2,'2024-07-03 21:45:00.126069','2024-07-03 21:45:04.590496',4464,NULL,'success'),(4686,'sync-dbms-version',2,'2024-07-03 21:45:00.134668','2024-07-03 21:45:00.144265',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4687,'sync-timezone',2,'2024-07-03 21:45:00.153807','2024-07-03 21:45:00.164593',10,'{\"timezone-id\":\"+08:00\"}','success'),(4688,'sync-tables',2,'2024-07-03 21:45:00.173101','2024-07-03 21:45:00.200568',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4689,'sync-fields',2,'2024-07-03 21:45:00.209702','2024-07-03 21:45:03.364113',3154,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4690,'sync-fks',2,'2024-07-03 21:45:03.375607','2024-07-03 21:45:04.010977',635,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4691,'sync-indexes',2,'2024-07-03 21:45:04.020461','2024-07-03 21:45:04.551113',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4692,'sync-metabase-metadata',2,'2024-07-03 21:45:04.558333','2024-07-03 21:45:04.566157',7,'{}','success'),(4693,'sync-table-privileges',2,'2024-07-03 21:45:04.574132','2024-07-03 21:45:04.582360',8,NULL,'success'),(4694,'analyze',2,'2024-07-03 21:45:04.614135','2024-07-03 21:45:06.697149',2083,NULL,'success'),(4695,'fingerprint-fields',2,'2024-07-03 21:45:04.623326','2024-07-03 21:45:06.530669',1907,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4696,'classify-fields',2,'2024-07-03 21:45:06.539183','2024-07-03 21:45:06.663443',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4697,'classify-tables',2,'2024-07-03 21:45:06.672098','2024-07-03 21:45:06.688120',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4698,'sync',2,'2024-07-03 22:45:00.102518','2024-07-03 22:45:04.591942',4489,NULL,'success'),(4699,'sync-dbms-version',2,'2024-07-03 22:45:00.113125','2024-07-03 22:45:00.124662',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4700,'sync-timezone',2,'2024-07-03 22:45:00.135299','2024-07-03 22:45:00.146615',11,'{\"timezone-id\":\"+08:00\"}','success'),(4701,'sync-tables',2,'2024-07-03 22:45:00.155749','2024-07-03 22:45:00.189159',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4702,'sync-fields',2,'2024-07-03 22:45:00.200307','2024-07-03 22:45:03.396078',3195,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4703,'sync-fks',2,'2024-07-03 22:45:03.404213','2024-07-03 22:45:04.026189',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4704,'sync-indexes',2,'2024-07-03 22:45:04.034732','2024-07-03 22:45:04.548556',513,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4705,'sync-metabase-metadata',2,'2024-07-03 22:45:04.556830','2024-07-03 22:45:04.565914',9,'{}','success'),(4706,'sync-table-privileges',2,'2024-07-03 22:45:04.574758','2024-07-03 22:45:04.583415',8,NULL,'success'),(4707,'analyze',2,'2024-07-03 22:45:04.616288','2024-07-03 22:45:06.688275',2071,NULL,'success'),(4708,'fingerprint-fields',2,'2024-07-03 22:45:04.624919','2024-07-03 22:45:06.535513',1910,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4709,'classify-fields',2,'2024-07-03 22:45:06.544423','2024-07-03 22:45:06.654611',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4710,'classify-tables',2,'2024-07-03 22:45:06.663405','2024-07-03 22:45:06.679175',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4711,'sync',2,'2024-07-03 23:45:00.119323','2024-07-03 23:45:04.585916',4466,NULL,'success'),(4712,'sync-dbms-version',2,'2024-07-03 23:45:00.127873','2024-07-03 23:45:00.139062',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4713,'sync-timezone',2,'2024-07-03 23:45:00.148766','2024-07-03 23:45:00.161000',12,'{\"timezone-id\":\"+08:00\"}','success'),(4714,'sync-tables',2,'2024-07-03 23:45:00.170282','2024-07-03 23:45:00.203593',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4715,'sync-fields',2,'2024-07-03 23:45:00.213412','2024-07-03 23:45:03.301762',3088,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4716,'sync-fks',2,'2024-07-03 23:45:03.312764','2024-07-03 23:45:03.959898',647,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4717,'sync-indexes',2,'2024-07-03 23:45:03.970497','2024-07-03 23:45:04.543712',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4718,'sync-metabase-metadata',2,'2024-07-03 23:45:04.551886','2024-07-03 23:45:04.559980',8,'{}','success'),(4719,'sync-table-privileges',2,'2024-07-03 23:45:04.567949','2024-07-03 23:45:04.576150',8,NULL,'success'),(4720,'analyze',2,'2024-07-03 23:45:04.610912','2024-07-03 23:45:06.758373',2147,NULL,'success'),(4721,'fingerprint-fields',2,'2024-07-03 23:45:04.618918','2024-07-03 23:45:06.588704',1969,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4722,'classify-fields',2,'2024-07-03 23:45:06.597092','2024-07-03 23:45:06.724344',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4723,'classify-tables',2,'2024-07-03 23:45:06.733082','2024-07-03 23:45:06.749031',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4724,'sync',2,'2024-07-04 00:45:00.099843','2024-07-04 00:45:05.113858',5014,NULL,'success'),(4725,'sync-dbms-version',2,'2024-07-04 00:45:00.108681','2024-07-04 00:45:00.118690',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4726,'sync-timezone',2,'2024-07-04 00:45:00.128571','2024-07-04 00:45:00.139314',10,'{\"timezone-id\":\"+08:00\"}','success'),(4727,'sync-tables',2,'2024-07-04 00:45:00.148066','2024-07-04 00:45:00.176054',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4728,'sync-fields',2,'2024-07-04 00:45:00.184911','2024-07-04 00:45:03.670212',3485,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4729,'sync-fks',2,'2024-07-04 00:45:03.679900','2024-07-04 00:45:04.410832',730,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4730,'sync-indexes',2,'2024-07-04 00:45:04.420316','2024-07-04 00:45:05.068106',647,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4731,'sync-metabase-metadata',2,'2024-07-04 00:45:05.076940','2024-07-04 00:45:05.087054',10,'{}','success'),(4732,'sync-table-privileges',2,'2024-07-04 00:45:05.095543','2024-07-04 00:45:05.104266',8,NULL,'success'),(4733,'analyze',2,'2024-07-04 00:45:05.146114','2024-07-04 00:45:07.514760',2368,NULL,'success'),(4734,'fingerprint-fields',2,'2024-07-04 00:45:05.154904','2024-07-04 00:45:07.362380',2207,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4735,'classify-fields',2,'2024-07-04 00:45:07.370668','2024-07-04 00:45:07.485601',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4736,'classify-tables',2,'2024-07-04 00:45:07.492953','2024-07-04 00:45:07.506656',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4737,'sync',2,'2024-07-04 01:45:00.116162','2024-07-04 01:45:05.122932',5006,NULL,'success'),(4738,'sync-dbms-version',2,'2024-07-04 01:45:00.125014','2024-07-04 01:45:00.135742',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4739,'sync-timezone',2,'2024-07-04 01:45:00.145101','2024-07-04 01:45:00.157070',11,'{\"timezone-id\":\"+08:00\"}','success'),(4740,'sync-tables',2,'2024-07-04 01:45:00.166472','2024-07-04 01:45:00.201991',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4741,'sync-fields',2,'2024-07-04 01:45:00.211509','2024-07-04 01:45:03.649661',3438,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4742,'sync-fks',2,'2024-07-04 01:45:03.658930','2024-07-04 01:45:04.435938',777,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4743,'sync-indexes',2,'2024-07-04 01:45:04.445107','2024-07-04 01:45:05.077368',632,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4744,'sync-metabase-metadata',2,'2024-07-04 01:45:05.087530','2024-07-04 01:45:05.097231',9,'{}','success'),(4745,'sync-table-privileges',2,'2024-07-04 01:45:05.106532','2024-07-04 01:45:05.114708',8,NULL,'success'),(4746,'analyze',2,'2024-07-04 01:45:05.151463','2024-07-04 01:45:07.336206',2184,NULL,'success'),(4747,'fingerprint-fields',2,'2024-07-04 01:45:05.160168','2024-07-04 01:45:07.170991',2010,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4748,'classify-fields',2,'2024-07-04 01:45:07.179475','2024-07-04 01:45:07.302649',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4749,'classify-tables',2,'2024-07-04 01:45:07.311473','2024-07-04 01:45:07.327150',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4750,'sync',2,'2024-07-04 02:45:00.107046','2024-07-04 02:45:04.783364',4676,NULL,'success'),(4751,'sync-dbms-version',2,'2024-07-04 02:45:00.114316','2024-07-04 02:45:00.122630',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4752,'sync-timezone',2,'2024-07-04 02:45:00.130695','2024-07-04 02:45:00.140006',9,'{\"timezone-id\":\"+08:00\"}','success'),(4753,'sync-tables',2,'2024-07-04 02:45:00.147836','2024-07-04 02:45:00.173087',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4754,'sync-fields',2,'2024-07-04 02:45:00.180725','2024-07-04 02:45:03.426844',3246,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4755,'sync-fks',2,'2024-07-04 02:45:03.435195','2024-07-04 02:45:04.152687',717,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4756,'sync-indexes',2,'2024-07-04 02:45:04.163072','2024-07-04 02:45:04.735753',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4757,'sync-metabase-metadata',2,'2024-07-04 02:45:04.744688','2024-07-04 02:45:04.754607',9,'{}','success'),(4758,'sync-table-privileges',2,'2024-07-04 02:45:04.765673','2024-07-04 02:45:04.774517',8,NULL,'success'),(4759,'analyze',2,'2024-07-04 02:45:04.811481','2024-07-04 02:45:06.911987',2100,NULL,'success'),(4760,'fingerprint-fields',2,'2024-07-04 02:45:04.822009','2024-07-04 02:45:06.753916',1931,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4761,'classify-fields',2,'2024-07-04 02:45:06.762337','2024-07-04 02:45:06.881160',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4762,'classify-tables',2,'2024-07-04 02:45:06.889823','2024-07-04 02:45:06.903287',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4763,'sync',2,'2024-07-04 03:45:00.114365','2024-07-04 03:45:04.496881',4382,NULL,'success'),(4764,'sync-dbms-version',2,'2024-07-04 03:45:00.125278','2024-07-04 03:45:00.137329',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4765,'sync-timezone',2,'2024-07-04 03:45:00.146926','2024-07-04 03:45:00.157108',10,'{\"timezone-id\":\"+08:00\"}','success'),(4766,'sync-tables',2,'2024-07-04 03:45:00.166109','2024-07-04 03:45:00.197551',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4767,'sync-fields',2,'2024-07-04 03:45:00.207859','2024-07-04 03:45:03.301071',3093,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4768,'sync-fks',2,'2024-07-04 03:45:03.309084','2024-07-04 03:45:03.898228',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4769,'sync-indexes',2,'2024-07-04 03:45:03.907031','2024-07-04 03:45:04.454070',547,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4770,'sync-metabase-metadata',2,'2024-07-04 03:45:04.461540','2024-07-04 03:45:04.469992',8,'{}','success'),(4771,'sync-table-privileges',2,'2024-07-04 03:45:04.478500','2024-07-04 03:45:04.487812',9,NULL,'success'),(4772,'analyze',2,'2024-07-04 03:45:04.524808','2024-07-04 03:45:06.482075',1957,NULL,'success'),(4773,'fingerprint-fields',2,'2024-07-04 03:45:04.532801','2024-07-04 03:45:06.333768',1800,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4774,'classify-fields',2,'2024-07-04 03:45:06.342391','2024-07-04 03:45:06.450653',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4775,'classify-tables',2,'2024-07-04 03:45:06.458678','2024-07-04 03:45:06.473759',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4776,'task-history-cleanup',NULL,'2024-07-04 04:00:00.089011','2024-07-04 04:00:00.101443',12,NULL,'success'),(4777,'sync',2,'2024-07-04 04:45:00.112732','2024-07-04 04:45:04.681934',4569,NULL,'success'),(4778,'sync-dbms-version',2,'2024-07-04 04:45:00.120963','2024-07-04 04:45:00.130253',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4779,'sync-timezone',2,'2024-07-04 04:45:00.138874','2024-07-04 04:45:00.148898',10,'{\"timezone-id\":\"+08:00\"}','success'),(4780,'sync-tables',2,'2024-07-04 04:45:00.157697','2024-07-04 04:45:00.185785',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4781,'sync-fields',2,'2024-07-04 04:45:00.194368','2024-07-04 04:45:03.327802',3133,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4782,'sync-fks',2,'2024-07-04 04:45:03.335905','2024-07-04 04:45:04.034716',698,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4783,'sync-indexes',2,'2024-07-04 04:45:04.044761','2024-07-04 04:45:04.635438',590,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4784,'sync-metabase-metadata',2,'2024-07-04 04:45:04.643954','2024-07-04 04:45:04.652171',8,'{}','success'),(4785,'sync-table-privileges',2,'2024-07-04 04:45:04.660917','2024-07-04 04:45:04.672365',11,NULL,'success'),(4786,'analyze',2,'2024-07-04 04:45:04.712523','2024-07-04 04:45:06.879187',2166,NULL,'success'),(4787,'fingerprint-fields',2,'2024-07-04 04:45:04.721571','2024-07-04 04:45:06.718366',1996,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4788,'classify-fields',2,'2024-07-04 04:45:06.726328','2024-07-04 04:45:06.850024',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4789,'classify-tables',2,'2024-07-04 04:45:06.857234','2024-07-04 04:45:06.871000',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4790,'sync',2,'2024-07-04 05:45:00.112644','2024-07-04 05:45:04.686927',4574,NULL,'success'),(4791,'sync-dbms-version',2,'2024-07-04 05:45:00.121133','2024-07-04 05:45:00.130975',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4792,'sync-timezone',2,'2024-07-04 05:45:00.139854','2024-07-04 05:45:00.150106',10,'{\"timezone-id\":\"+08:00\"}','success'),(4793,'sync-tables',2,'2024-07-04 05:45:00.158502','2024-07-04 05:45:00.184247',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4794,'sync-fields',2,'2024-07-04 05:45:00.192823','2024-07-04 05:45:03.455437',3262,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4795,'sync-fks',2,'2024-07-04 05:45:03.463937','2024-07-04 05:45:04.098065',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4796,'sync-indexes',2,'2024-07-04 05:45:04.107761','2024-07-04 05:45:04.646328',538,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4797,'sync-metabase-metadata',2,'2024-07-04 05:45:04.653921','2024-07-04 05:45:04.662479',8,'{}','success'),(4798,'sync-table-privileges',2,'2024-07-04 05:45:04.670722','2024-07-04 05:45:04.678903',8,NULL,'success'),(4799,'analyze',2,'2024-07-04 05:45:04.718002','2024-07-04 05:45:06.927089',2209,NULL,'success'),(4800,'fingerprint-fields',2,'2024-07-04 05:45:04.728914','2024-07-04 05:45:06.752119',2023,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4801,'classify-fields',2,'2024-07-04 05:45:06.760627','2024-07-04 05:45:06.895358',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4802,'classify-tables',2,'2024-07-04 05:45:06.903738','2024-07-04 05:45:06.919004',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4803,'sync',2,'2024-07-04 06:45:00.111278','2024-07-04 06:45:04.754453',4643,NULL,'success'),(4804,'sync-dbms-version',2,'2024-07-04 06:45:00.120370','2024-07-04 06:45:00.132544',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4805,'sync-timezone',2,'2024-07-04 06:45:00.145469','2024-07-04 06:45:00.156443',10,'{\"timezone-id\":\"+08:00\"}','success'),(4806,'sync-tables',2,'2024-07-04 06:45:00.167674','2024-07-04 06:45:00.198615',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4807,'sync-fields',2,'2024-07-04 06:45:00.207788','2024-07-04 06:45:03.402177',3194,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4808,'sync-fks',2,'2024-07-04 06:45:03.410145','2024-07-04 06:45:04.099292',689,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4809,'sync-indexes',2,'2024-07-04 06:45:04.108043','2024-07-04 06:45:04.708044',600,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4810,'sync-metabase-metadata',2,'2024-07-04 06:45:04.716690','2024-07-04 06:45:04.726654',9,'{}','success'),(4811,'sync-table-privileges',2,'2024-07-04 06:45:04.735932','2024-07-04 06:45:04.745164',9,NULL,'success'),(4812,'analyze',2,'2024-07-04 06:45:04.780313','2024-07-04 06:45:06.957631',2177,NULL,'success'),(4813,'fingerprint-fields',2,'2024-07-04 06:45:04.788999','2024-07-04 06:45:06.728930',1939,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4814,'classify-fields',2,'2024-07-04 06:45:06.741879','2024-07-04 06:45:06.869833',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4815,'classify-tables',2,'2024-07-04 06:45:06.878117','2024-07-04 06:45:06.948934',70,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4816,'sync',2,'2024-07-04 07:45:00.117623','2024-07-04 07:45:04.254807',4137,NULL,'success'),(4817,'sync-dbms-version',2,'2024-07-04 07:45:00.125865','2024-07-04 07:45:00.135916',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4818,'sync-timezone',2,'2024-07-04 07:45:00.144393','2024-07-04 07:45:00.153517',9,'{\"timezone-id\":\"+08:00\"}','success'),(4819,'sync-tables',2,'2024-07-04 07:45:00.161851','2024-07-04 07:45:00.188921',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4820,'sync-fields',2,'2024-07-04 07:45:00.197709','2024-07-04 07:45:03.069002',2871,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4821,'sync-fks',2,'2024-07-04 07:45:03.076803','2024-07-04 07:45:03.669571',592,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4822,'sync-indexes',2,'2024-07-04 07:45:03.677163','2024-07-04 07:45:04.212727',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4823,'sync-metabase-metadata',2,'2024-07-04 07:45:04.220565','2024-07-04 07:45:04.228958',8,'{}','success'),(4824,'sync-table-privileges',2,'2024-07-04 07:45:04.238038','2024-07-04 07:45:04.246667',8,NULL,'success'),(4825,'analyze',2,'2024-07-04 07:45:04.286113','2024-07-04 07:45:06.456990',2170,NULL,'success'),(4826,'fingerprint-fields',2,'2024-07-04 07:45:04.294704','2024-07-04 07:45:06.310315',2015,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4827,'classify-fields',2,'2024-07-04 07:45:06.318525','2024-07-04 07:45:06.427597',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4828,'classify-tables',2,'2024-07-04 07:45:06.434808','2024-07-04 07:45:06.448787',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4829,'sync',2,'2024-07-04 08:45:00.094660','2024-07-04 08:45:04.102985',4008,NULL,'success'),(4830,'sync-dbms-version',2,'2024-07-04 08:45:00.102997','2024-07-04 08:45:00.113598',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4831,'sync-timezone',2,'2024-07-04 08:45:00.121395','2024-07-04 08:45:00.130661',9,'{\"timezone-id\":\"+08:00\"}','success'),(4832,'sync-tables',2,'2024-07-04 08:45:00.137992','2024-07-04 08:45:00.162616',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4833,'sync-fields',2,'2024-07-04 08:45:00.171128','2024-07-04 08:45:02.919364',2748,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4834,'sync-fks',2,'2024-07-04 08:45:02.927294','2024-07-04 08:45:03.562414',635,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4835,'sync-indexes',2,'2024-07-04 08:45:03.570361','2024-07-04 08:45:04.060184',489,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4836,'sync-metabase-metadata',2,'2024-07-04 08:45:04.067767','2024-07-04 08:45:04.076744',8,'{}','success'),(4837,'sync-table-privileges',2,'2024-07-04 08:45:04.085252','2024-07-04 08:45:04.094042',8,NULL,'success'),(4838,'analyze',2,'2024-07-04 08:45:04.126622','2024-07-04 08:45:06.131618',2004,NULL,'success'),(4839,'fingerprint-fields',2,'2024-07-04 08:45:04.135286','2024-07-04 08:45:05.928490',1793,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4840,'classify-fields',2,'2024-07-04 08:45:05.938759','2024-07-04 08:45:06.102649',163,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4841,'classify-tables',2,'2024-07-04 08:45:06.109864','2024-07-04 08:45:06.122712',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4842,'sync',2,'2024-07-04 09:45:00.093947','2024-07-04 09:45:04.153363',4059,NULL,'success'),(4843,'sync-dbms-version',2,'2024-07-04 09:45:00.101906','2024-07-04 09:45:00.110419',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4844,'sync-timezone',2,'2024-07-04 09:45:00.118358','2024-07-04 09:45:00.127781',9,'{\"timezone-id\":\"+08:00\"}','success'),(4845,'sync-tables',2,'2024-07-04 09:45:00.135577','2024-07-04 09:45:00.160258',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4846,'sync-fields',2,'2024-07-04 09:45:00.168167','2024-07-04 09:45:02.901720',2733,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4847,'sync-fks',2,'2024-07-04 09:45:02.909353','2024-07-04 09:45:03.496599',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4848,'sync-indexes',2,'2024-07-04 09:45:03.504797','2024-07-04 09:45:04.110645',605,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4849,'sync-metabase-metadata',2,'2024-07-04 09:45:04.118563','2024-07-04 09:45:04.127081',8,'{}','success'),(4850,'sync-table-privileges',2,'2024-07-04 09:45:04.135257','2024-07-04 09:45:04.144759',9,NULL,'success'),(4851,'analyze',2,'2024-07-04 09:45:04.177476','2024-07-04 09:45:06.107484',1930,NULL,'success'),(4852,'fingerprint-fields',2,'2024-07-04 09:45:04.185342','2024-07-04 09:45:05.948952',1763,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4853,'classify-fields',2,'2024-07-04 09:45:05.957075','2024-07-04 09:45:06.075285',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4854,'classify-tables',2,'2024-07-04 09:45:06.084755','2024-07-04 09:45:06.097991',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4855,'sync',2,'2024-07-04 10:45:00.103153','2024-07-04 10:45:04.131471',4028,NULL,'success'),(4856,'sync-dbms-version',2,'2024-07-04 10:45:00.110771','2024-07-04 10:45:00.119768',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4857,'sync-timezone',2,'2024-07-04 10:45:00.128158','2024-07-04 10:45:00.137515',9,'{\"timezone-id\":\"+08:00\"}','success'),(4858,'sync-tables',2,'2024-07-04 10:45:00.145290','2024-07-04 10:45:00.171075',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4859,'sync-fields',2,'2024-07-04 10:45:00.179485','2024-07-04 10:45:02.949216',2769,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4860,'sync-fks',2,'2024-07-04 10:45:02.956397','2024-07-04 10:45:03.531067',574,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4861,'sync-indexes',2,'2024-07-04 10:45:03.538768','2024-07-04 10:45:04.031166',492,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4862,'sync-metabase-metadata',2,'2024-07-04 10:45:04.044379','2024-07-04 10:45:04.057995',13,'{}','success'),(4863,'sync-table-privileges',2,'2024-07-04 10:45:04.069726','2024-07-04 10:45:04.077661',7,NULL,'success'),(4864,'analyze',2,'2024-07-04 10:45:04.162699','2024-07-04 10:45:06.116987',1954,NULL,'success'),(4865,'fingerprint-fields',2,'2024-07-04 10:45:04.171464','2024-07-04 10:45:05.918538',1747,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4866,'classify-fields',2,'2024-07-04 10:45:05.973186','2024-07-04 10:45:06.081341',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4867,'classify-tables',2,'2024-07-04 10:45:06.088547','2024-07-04 10:45:06.108452',19,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4868,'sync',2,'2024-07-04 11:45:00.097195','2024-07-04 11:45:04.102615',4005,NULL,'success'),(4869,'sync-dbms-version',2,'2024-07-04 11:45:00.105892','2024-07-04 11:45:00.116288',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4870,'sync-timezone',2,'2024-07-04 11:45:00.125295','2024-07-04 11:45:00.135060',9,'{\"timezone-id\":\"+08:00\"}','success'),(4871,'sync-tables',2,'2024-07-04 11:45:00.143327','2024-07-04 11:45:00.170789',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4872,'sync-fields',2,'2024-07-04 11:45:00.179697','2024-07-04 11:45:02.950690',2770,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4873,'sync-fks',2,'2024-07-04 11:45:02.957731','2024-07-04 11:45:03.539486',581,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4874,'sync-indexes',2,'2024-07-04 11:45:03.550394','2024-07-04 11:45:04.063428',513,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4875,'sync-metabase-metadata',2,'2024-07-04 11:45:04.071237','2024-07-04 11:45:04.078793',7,'{}','success'),(4876,'sync-table-privileges',2,'2024-07-04 11:45:04.086734','2024-07-04 11:45:04.094423',7,NULL,'success'),(4877,'analyze',2,'2024-07-04 11:45:04.127645','2024-07-04 11:45:06.191614',2063,NULL,'success'),(4878,'fingerprint-fields',2,'2024-07-04 11:45:04.135807','2024-07-04 11:45:06.040830',1905,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4879,'classify-fields',2,'2024-07-04 11:45:06.049784','2024-07-04 11:45:06.161400',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4880,'classify-tables',2,'2024-07-04 11:45:06.169111','2024-07-04 11:45:06.182816',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4881,'sync',2,'2024-07-04 12:45:00.103241','2024-07-04 12:45:04.298730',4195,NULL,'success'),(4882,'sync-dbms-version',2,'2024-07-04 12:45:00.112415','2024-07-04 12:45:00.124754',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4883,'sync-timezone',2,'2024-07-04 12:45:00.132675','2024-07-04 12:45:00.142274',9,'{\"timezone-id\":\"+08:00\"}','success'),(4884,'sync-tables',2,'2024-07-04 12:45:00.151733','2024-07-04 12:45:00.179594',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4885,'sync-fields',2,'2024-07-04 12:45:00.187946','2024-07-04 12:45:03.040457',2852,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4886,'sync-fks',2,'2024-07-04 12:45:03.048413','2024-07-04 12:45:03.669284',620,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4887,'sync-indexes',2,'2024-07-04 12:45:03.677434','2024-07-04 12:45:04.255611',578,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4888,'sync-metabase-metadata',2,'2024-07-04 12:45:04.264039','2024-07-04 12:45:04.273621',9,'{}','success'),(4889,'sync-table-privileges',2,'2024-07-04 12:45:04.282545','2024-07-04 12:45:04.290633',8,NULL,'success'),(4890,'analyze',2,'2024-07-04 12:45:04.324123','2024-07-04 12:45:06.268906',1944,NULL,'success'),(4891,'fingerprint-fields',2,'2024-07-04 12:45:04.332666','2024-07-04 12:45:06.085302',1752,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4892,'classify-fields',2,'2024-07-04 12:45:06.094227','2024-07-04 12:45:06.215789',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4893,'classify-tables',2,'2024-07-04 12:45:06.227643','2024-07-04 12:45:06.245326',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4894,'field values scanning',2,'2024-07-04 13:00:00.050263','2024-07-04 13:00:04.361886',4311,NULL,'success'),(4895,'delete-expired-advanced-field-values',2,'2024-07-04 13:00:00.060688','2024-07-04 13:00:02.992519',2931,'{\"deleted\":0}','success'),(4896,'update-field-values',2,'2024-07-04 13:00:03.000196','2024-07-04 13:00:04.352537',1352,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(4897,'sync',2,'2024-07-04 13:45:00.106259','2024-07-04 13:45:04.298835',4192,NULL,'success'),(4898,'sync-dbms-version',2,'2024-07-04 13:45:00.114840','2024-07-04 13:45:00.122999',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4899,'sync-timezone',2,'2024-07-04 13:45:00.130625','2024-07-04 13:45:00.139848',9,'{\"timezone-id\":\"+08:00\"}','success'),(4900,'sync-tables',2,'2024-07-04 13:45:00.147278','2024-07-04 13:45:00.171388',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4901,'sync-fields',2,'2024-07-04 13:45:00.179563','2024-07-04 13:45:03.079040',2899,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4902,'sync-fks',2,'2024-07-04 13:45:03.087088','2024-07-04 13:45:03.704763',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4903,'sync-indexes',2,'2024-07-04 13:45:03.713290','2024-07-04 13:45:04.256506',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4904,'sync-metabase-metadata',2,'2024-07-04 13:45:04.263829','2024-07-04 13:45:04.273252',9,'{}','success'),(4905,'sync-table-privileges',2,'2024-07-04 13:45:04.281808','2024-07-04 13:45:04.289911',8,NULL,'success'),(4906,'analyze',2,'2024-07-04 13:45:04.328073','2024-07-04 13:45:06.343685',2015,NULL,'success'),(4907,'fingerprint-fields',2,'2024-07-04 13:45:04.338427','2024-07-04 13:45:06.187297',1848,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4908,'classify-fields',2,'2024-07-04 13:45:06.195607','2024-07-04 13:45:06.314249',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4909,'classify-tables',2,'2024-07-04 13:45:06.321631','2024-07-04 13:45:06.335048',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4910,'sync',2,'2024-07-04 14:45:00.093347','2024-07-04 14:45:04.454539',4361,NULL,'success'),(4911,'sync-dbms-version',2,'2024-07-04 14:45:00.101301','2024-07-04 14:45:00.111023',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4912,'sync-timezone',2,'2024-07-04 14:45:00.119888','2024-07-04 14:45:00.129726',9,'{\"timezone-id\":\"+08:00\"}','success'),(4913,'sync-tables',2,'2024-07-04 14:45:00.138630','2024-07-04 14:45:00.166165',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4914,'sync-fields',2,'2024-07-04 14:45:00.174812','2024-07-04 14:45:03.173004',2998,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4915,'sync-fks',2,'2024-07-04 14:45:03.181878','2024-07-04 14:45:03.832675',650,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4916,'sync-indexes',2,'2024-07-04 14:45:03.841709','2024-07-04 14:45:04.413720',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4917,'sync-metabase-metadata',2,'2024-07-04 14:45:04.421526','2024-07-04 14:45:04.430776',9,'{}','success'),(4918,'sync-table-privileges',2,'2024-07-04 14:45:04.438617','2024-07-04 14:45:04.446299',7,NULL,'success'),(4919,'analyze',2,'2024-07-04 14:45:04.479905','2024-07-04 14:45:06.696772',2216,NULL,'success'),(4920,'fingerprint-fields',2,'2024-07-04 14:45:04.487314','2024-07-04 14:45:06.427443',1940,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4921,'classify-fields',2,'2024-07-04 14:45:06.437934','2024-07-04 14:45:06.655800',217,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4922,'classify-tables',2,'2024-07-04 14:45:06.672783','2024-07-04 14:45:06.689104',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4923,'sync',2,'2024-07-04 15:45:00.108768','2024-07-04 15:45:04.514672',4405,NULL,'success'),(4924,'sync-dbms-version',2,'2024-07-04 15:45:00.117094','2024-07-04 15:45:00.127862',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4925,'sync-timezone',2,'2024-07-04 15:45:00.137540','2024-07-04 15:45:00.150222',12,'{\"timezone-id\":\"+08:00\"}','success'),(4926,'sync-tables',2,'2024-07-04 15:45:00.159768','2024-07-04 15:45:00.194222',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4927,'sync-fields',2,'2024-07-04 15:45:00.203450','2024-07-04 15:45:03.144598',2941,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4928,'sync-fks',2,'2024-07-04 15:45:03.153047','2024-07-04 15:45:03.910865',757,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4929,'sync-indexes',2,'2024-07-04 15:45:03.920173','2024-07-04 15:45:04.474027',553,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4930,'sync-metabase-metadata',2,'2024-07-04 15:45:04.481791','2024-07-04 15:45:04.490090',8,'{}','success'),(4931,'sync-table-privileges',2,'2024-07-04 15:45:04.498569','2024-07-04 15:45:04.506838',8,NULL,'success'),(4932,'analyze',2,'2024-07-04 15:45:04.543325','2024-07-04 15:45:06.668921',2125,NULL,'success'),(4933,'fingerprint-fields',2,'2024-07-04 15:45:04.551891','2024-07-04 15:45:06.501030',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4934,'classify-fields',2,'2024-07-04 15:45:06.509950','2024-07-04 15:45:06.636399',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4935,'classify-tables',2,'2024-07-04 15:45:06.645673','2024-07-04 15:45:06.659833',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4936,'task-history-cleanup',NULL,'2024-07-04 16:00:00.023416','2024-07-04 16:00:00.065982',42,NULL,'success'),(4937,'task-history-cleanup',NULL,'2024-07-04 16:00:00.099167','2024-07-04 16:00:00.126628',27,NULL,'success'),(4938,'sync',2,'2024-07-04 16:45:00.105802','2024-07-04 16:45:04.499595',4393,NULL,'success'),(4939,'sync-dbms-version',2,'2024-07-04 16:45:00.115079','2024-07-04 16:45:00.125858',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4940,'sync-timezone',2,'2024-07-04 16:45:00.135059','2024-07-04 16:45:00.145349',10,'{\"timezone-id\":\"+08:00\"}','success'),(4941,'sync-tables',2,'2024-07-04 16:45:00.154226','2024-07-04 16:45:00.187743',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4942,'sync-fields',2,'2024-07-04 16:45:00.196498','2024-07-04 16:45:03.266517',3070,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4943,'sync-fks',2,'2024-07-04 16:45:03.274800','2024-07-04 16:45:03.863711',588,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4944,'sync-indexes',2,'2024-07-04 16:45:03.872714','2024-07-04 16:45:04.460045',587,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4945,'sync-metabase-metadata',2,'2024-07-04 16:45:04.467917','2024-07-04 16:45:04.476173',8,'{}','success'),(4946,'sync-table-privileges',2,'2024-07-04 16:45:04.483828','2024-07-04 16:45:04.491963',8,NULL,'success'),(4947,'analyze',2,'2024-07-04 16:45:04.523562','2024-07-04 16:45:06.417268',1893,NULL,'success'),(4948,'fingerprint-fields',2,'2024-07-04 16:45:04.531079','2024-07-04 16:45:06.285874',1754,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4949,'classify-fields',2,'2024-07-04 16:45:06.293162','2024-07-04 16:45:06.390248',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4950,'classify-tables',2,'2024-07-04 16:45:06.397226','2024-07-04 16:45:06.409554',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4951,'sync',2,'2024-07-04 17:45:00.103570','2024-07-04 17:45:04.295422',4191,NULL,'success'),(4952,'sync-dbms-version',2,'2024-07-04 17:45:00.111956','2024-07-04 17:45:00.121415',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4953,'sync-timezone',2,'2024-07-04 17:45:00.129734','2024-07-04 17:45:00.140230',10,'{\"timezone-id\":\"+08:00\"}','success'),(4954,'sync-tables',2,'2024-07-04 17:45:00.149599','2024-07-04 17:45:00.177187',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4955,'sync-fields',2,'2024-07-04 17:45:00.186252','2024-07-04 17:45:03.066236',2879,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4956,'sync-fks',2,'2024-07-04 17:45:03.074547','2024-07-04 17:45:03.695899',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4957,'sync-indexes',2,'2024-07-04 17:45:03.710227','2024-07-04 17:45:04.255103',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4958,'sync-metabase-metadata',2,'2024-07-04 17:45:04.262557','2024-07-04 17:45:04.270969',8,'{}','success'),(4959,'sync-table-privileges',2,'2024-07-04 17:45:04.278716','2024-07-04 17:45:04.287251',8,NULL,'success'),(4960,'analyze',2,'2024-07-04 17:45:04.319874','2024-07-04 17:45:06.337326',2017,NULL,'success'),(4961,'fingerprint-fields',2,'2024-07-04 17:45:04.327909','2024-07-04 17:45:06.180765',1852,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4962,'classify-fields',2,'2024-07-04 17:45:06.188305','2024-07-04 17:45:06.304743',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4963,'classify-tables',2,'2024-07-04 17:45:06.312737','2024-07-04 17:45:06.328152',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4964,'sync',2,'2024-07-04 18:45:00.093391','2024-07-04 18:45:04.266114',4172,NULL,'success'),(4965,'sync-dbms-version',2,'2024-07-04 18:45:00.102023','2024-07-04 18:45:00.111236',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4966,'sync-timezone',2,'2024-07-04 18:45:00.119841','2024-07-04 18:45:00.129627',9,'{\"timezone-id\":\"+08:00\"}','success'),(4967,'sync-tables',2,'2024-07-04 18:45:00.137698','2024-07-04 18:45:00.164433',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4968,'sync-fields',2,'2024-07-04 18:45:00.172695','2024-07-04 18:45:03.026705',2854,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4969,'sync-fks',2,'2024-07-04 18:45:03.034303','2024-07-04 18:45:03.629380',595,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4970,'sync-indexes',2,'2024-07-04 18:45:03.636794','2024-07-04 18:45:04.225593',588,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4971,'sync-metabase-metadata',2,'2024-07-04 18:45:04.232872','2024-07-04 18:45:04.241317',8,'{}','success'),(4972,'sync-table-privileges',2,'2024-07-04 18:45:04.249833','2024-07-04 18:45:04.258059',8,NULL,'success'),(4973,'analyze',2,'2024-07-04 18:45:04.290771','2024-07-04 18:45:06.372759',2081,NULL,'success'),(4974,'fingerprint-fields',2,'2024-07-04 18:45:04.300322','2024-07-04 18:45:06.214319',1913,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4975,'classify-fields',2,'2024-07-04 18:45:06.222875','2024-07-04 18:45:06.342379',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4976,'classify-tables',2,'2024-07-04 18:45:06.350106','2024-07-04 18:45:06.364592',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4977,'sync',2,'2024-07-04 19:45:00.109067','2024-07-04 19:45:05.351516',5242,NULL,'success'),(4978,'sync-dbms-version',2,'2024-07-04 19:45:00.117330','2024-07-04 19:45:00.129288',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4979,'sync-timezone',2,'2024-07-04 19:45:00.138893','2024-07-04 19:45:00.152472',13,'{\"timezone-id\":\"+08:00\"}','success'),(4980,'sync-tables',2,'2024-07-04 19:45:00.161249','2024-07-04 19:45:00.189204',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4981,'sync-fields',2,'2024-07-04 19:45:00.198374','2024-07-04 19:45:03.303198',3104,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4982,'sync-fks',2,'2024-07-04 19:45:03.312254','2024-07-04 19:45:03.940644',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4983,'sync-indexes',2,'2024-07-04 19:45:03.948364','2024-07-04 19:45:05.304456',1356,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4984,'sync-metabase-metadata',2,'2024-07-04 19:45:05.313865','2024-07-04 19:45:05.323556',9,'{}','success'),(4985,'sync-table-privileges',2,'2024-07-04 19:45:05.332417','2024-07-04 19:45:05.341914',9,NULL,'success'),(4986,'analyze',2,'2024-07-04 19:45:05.380334','2024-07-04 19:45:07.527272',2146,NULL,'success'),(4987,'fingerprint-fields',2,'2024-07-04 19:45:05.388928','2024-07-04 19:45:07.349690',1960,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(4988,'classify-fields',2,'2024-07-04 19:45:07.359451','2024-07-04 19:45:07.492051',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(4989,'classify-tables',2,'2024-07-04 19:45:07.499976','2024-07-04 19:45:07.516775',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(4990,'sync',2,'2024-07-04 20:45:00.105653','2024-07-04 20:45:04.282245',4176,NULL,'success'),(4991,'sync-dbms-version',2,'2024-07-04 20:45:00.114349','2024-07-04 20:45:00.124340',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(4992,'sync-timezone',2,'2024-07-04 20:45:00.133350','2024-07-04 20:45:00.144707',11,'{\"timezone-id\":\"+08:00\"}','success'),(4993,'sync-tables',2,'2024-07-04 20:45:00.153197','2024-07-04 20:45:00.179057',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(4994,'sync-fields',2,'2024-07-04 20:45:00.187261','2024-07-04 20:45:03.093781',2906,'{\"total-fields\":836,\"updated-fields\":0}','success'),(4995,'sync-fks',2,'2024-07-04 20:45:03.101548','2024-07-04 20:45:03.687928',586,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(4996,'sync-indexes',2,'2024-07-04 20:45:03.697353','2024-07-04 20:45:04.238694',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(4997,'sync-metabase-metadata',2,'2024-07-04 20:45:04.248130','2024-07-04 20:45:04.256310',8,'{}','success'),(4998,'sync-table-privileges',2,'2024-07-04 20:45:04.264840','2024-07-04 20:45:04.273268',8,NULL,'success'),(4999,'analyze',2,'2024-07-04 20:45:04.307874','2024-07-04 20:45:06.461517',2153,NULL,'success'),(5000,'fingerprint-fields',2,'2024-07-04 20:45:04.315805','2024-07-04 20:45:06.319843',2004,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5001,'classify-fields',2,'2024-07-04 20:45:06.328263','2024-07-04 20:45:06.431510',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5002,'classify-tables',2,'2024-07-04 20:45:06.439035','2024-07-04 20:45:06.453029',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5003,'sync',2,'2024-07-04 21:45:00.094761','2024-07-04 21:45:04.520328',4425,NULL,'success'),(5004,'sync-dbms-version',2,'2024-07-04 21:45:00.103169','2024-07-04 21:45:00.112157',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5005,'sync-timezone',2,'2024-07-04 21:45:00.120375','2024-07-04 21:45:00.131333',10,'{\"timezone-id\":\"+08:00\"}','success'),(5006,'sync-tables',2,'2024-07-04 21:45:00.139863','2024-07-04 21:45:00.169254',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5007,'sync-fields',2,'2024-07-04 21:45:00.178532','2024-07-04 21:45:03.248535',3070,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5008,'sync-fks',2,'2024-07-04 21:45:03.256566','2024-07-04 21:45:03.878144',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5009,'sync-indexes',2,'2024-07-04 21:45:03.886568','2024-07-04 21:45:04.480774',594,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5010,'sync-metabase-metadata',2,'2024-07-04 21:45:04.488274','2024-07-04 21:45:04.495951',7,'{}','success'),(5011,'sync-table-privileges',2,'2024-07-04 21:45:04.503690','2024-07-04 21:45:04.511568',7,NULL,'success'),(5012,'analyze',2,'2024-07-04 21:45:04.550230','2024-07-04 21:45:06.642922',2092,NULL,'success'),(5013,'fingerprint-fields',2,'2024-07-04 21:45:04.559327','2024-07-04 21:45:06.495604',1936,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5014,'classify-fields',2,'2024-07-04 21:45:06.504214','2024-07-04 21:45:06.613593',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5015,'classify-tables',2,'2024-07-04 21:45:06.621316','2024-07-04 21:45:06.634510',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5016,'sync',2,'2024-07-04 22:45:00.091967','2024-07-04 22:45:04.453082',4361,NULL,'success'),(5017,'sync-dbms-version',2,'2024-07-04 22:45:00.099476','2024-07-04 22:45:00.108399',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5018,'sync-timezone',2,'2024-07-04 22:45:00.117281','2024-07-04 22:45:00.126416',9,'{\"timezone-id\":\"+08:00\"}','success'),(5019,'sync-tables',2,'2024-07-04 22:45:00.134207','2024-07-04 22:45:00.160269',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5020,'sync-fields',2,'2024-07-04 22:45:00.169041','2024-07-04 22:45:03.199475',3030,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5021,'sync-fks',2,'2024-07-04 22:45:03.207102','2024-07-04 22:45:03.844436',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5022,'sync-indexes',2,'2024-07-04 22:45:03.853153','2024-07-04 22:45:04.406368',553,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5023,'sync-metabase-metadata',2,'2024-07-04 22:45:04.415791','2024-07-04 22:45:04.425802',10,'{}','success'),(5024,'sync-table-privileges',2,'2024-07-04 22:45:04.434633','2024-07-04 22:45:04.444415',9,NULL,'success'),(5025,'analyze',2,'2024-07-04 22:45:04.477823','2024-07-04 22:45:06.614377',2136,NULL,'success'),(5026,'fingerprint-fields',2,'2024-07-04 22:45:04.485926','2024-07-04 22:45:06.455947',1970,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5027,'classify-fields',2,'2024-07-04 22:45:06.464901','2024-07-04 22:45:06.582016',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5028,'classify-tables',2,'2024-07-04 22:45:06.590273','2024-07-04 22:45:06.605854',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5029,'sync',2,'2024-07-04 23:45:00.119154','2024-07-04 23:45:04.626409',4507,NULL,'success'),(5030,'sync-dbms-version',2,'2024-07-04 23:45:00.128063','2024-07-04 23:45:00.137773',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5031,'sync-timezone',2,'2024-07-04 23:45:00.147070','2024-07-04 23:45:00.158384',11,'{\"timezone-id\":\"+08:00\"}','success'),(5032,'sync-tables',2,'2024-07-04 23:45:00.166696','2024-07-04 23:45:00.194517',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5033,'sync-fields',2,'2024-07-04 23:45:00.203830','2024-07-04 23:45:03.325480',3121,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5034,'sync-fks',2,'2024-07-04 23:45:03.334943','2024-07-04 23:45:04.011402',676,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5035,'sync-indexes',2,'2024-07-04 23:45:04.020454','2024-07-04 23:45:04.581731',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5036,'sync-metabase-metadata',2,'2024-07-04 23:45:04.590673','2024-07-04 23:45:04.600693',10,'{}','success'),(5037,'sync-table-privileges',2,'2024-07-04 23:45:04.608993','2024-07-04 23:45:04.617252',8,NULL,'success'),(5038,'analyze',2,'2024-07-04 23:45:04.651934','2024-07-04 23:45:06.842083',2190,NULL,'success'),(5039,'fingerprint-fields',2,'2024-07-04 23:45:04.661731','2024-07-04 23:45:06.657727',1995,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5040,'classify-fields',2,'2024-07-04 23:45:06.666940','2024-07-04 23:45:06.808161',141,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5041,'classify-tables',2,'2024-07-04 23:45:06.817221','2024-07-04 23:45:06.832399',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5042,'sync',2,'2024-07-05 00:45:00.108314','2024-07-05 00:45:04.978178',4869,NULL,'success'),(5043,'sync-dbms-version',2,'2024-07-05 00:45:00.116996','2024-07-05 00:45:00.129916',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5044,'sync-timezone',2,'2024-07-05 00:45:00.139500','2024-07-05 00:45:00.149884',10,'{\"timezone-id\":\"+08:00\"}','success'),(5045,'sync-tables',2,'2024-07-05 00:45:00.159302','2024-07-05 00:45:00.188316',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5046,'sync-fields',2,'2024-07-05 00:45:00.197270','2024-07-05 00:45:03.614733',3417,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5047,'sync-fks',2,'2024-07-05 00:45:03.623391','2024-07-05 00:45:04.345190',721,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5048,'sync-indexes',2,'2024-07-05 00:45:04.357174','2024-07-05 00:45:04.934957',577,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5049,'sync-metabase-metadata',2,'2024-07-05 00:45:04.942564','2024-07-05 00:45:04.951734',9,'{}','success'),(5050,'sync-table-privileges',2,'2024-07-05 00:45:04.960368','2024-07-05 00:45:04.969484',9,NULL,'success'),(5051,'analyze',2,'2024-07-05 00:45:05.002733','2024-07-05 00:45:07.268530',2265,NULL,'success'),(5052,'fingerprint-fields',2,'2024-07-05 00:45:05.010933','2024-07-05 00:45:07.095142',2084,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5053,'classify-fields',2,'2024-07-05 00:45:07.104398','2024-07-05 00:45:07.233829',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5054,'classify-tables',2,'2024-07-05 00:45:07.241976','2024-07-05 00:45:07.259500',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5055,'sync',2,'2024-07-05 01:45:00.108801','2024-07-05 01:45:04.406949',4298,NULL,'success'),(5056,'sync-dbms-version',2,'2024-07-05 01:45:00.116712','2024-07-05 01:45:00.125632',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5057,'sync-timezone',2,'2024-07-05 01:45:00.133250','2024-07-05 01:45:00.142368',9,'{\"timezone-id\":\"+08:00\"}','success'),(5058,'sync-tables',2,'2024-07-05 01:45:00.151127','2024-07-05 01:45:00.177496',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5059,'sync-fields',2,'2024-07-05 01:45:00.185787','2024-07-05 01:45:03.241618',3055,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5060,'sync-fks',2,'2024-07-05 01:45:03.249776','2024-07-05 01:45:03.869765',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5061,'sync-indexes',2,'2024-07-05 01:45:03.877520','2024-07-05 01:45:04.365256',487,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5062,'sync-metabase-metadata',2,'2024-07-05 01:45:04.372760','2024-07-05 01:45:04.381686',8,'{}','success'),(5063,'sync-table-privileges',2,'2024-07-05 01:45:04.389820','2024-07-05 01:45:04.398266',8,NULL,'success'),(5064,'analyze',2,'2024-07-05 01:45:04.434606','2024-07-05 01:45:06.387151',1952,NULL,'success'),(5065,'fingerprint-fields',2,'2024-07-05 01:45:04.442547','2024-07-05 01:45:06.245784',1803,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5066,'classify-fields',2,'2024-07-05 01:45:06.254042','2024-07-05 01:45:06.357375',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5067,'classify-tables',2,'2024-07-05 01:45:06.364868','2024-07-05 01:45:06.378688',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5068,'sync',2,'2024-07-05 02:45:00.100262','2024-07-05 02:45:04.604818',4504,NULL,'success'),(5069,'sync-dbms-version',2,'2024-07-05 02:45:00.109220','2024-07-05 02:45:00.120047',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5070,'sync-timezone',2,'2024-07-05 02:45:00.128897','2024-07-05 02:45:00.138550',9,'{\"timezone-id\":\"+08:00\"}','success'),(5071,'sync-tables',2,'2024-07-05 02:45:00.147095','2024-07-05 02:45:00.176633',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5072,'sync-fields',2,'2024-07-05 02:45:00.185861','2024-07-05 02:45:03.288461',3102,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5073,'sync-fks',2,'2024-07-05 02:45:03.296938','2024-07-05 02:45:03.961653',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5074,'sync-indexes',2,'2024-07-05 02:45:03.970042','2024-07-05 02:45:04.557131',587,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5075,'sync-metabase-metadata',2,'2024-07-05 02:45:04.567246','2024-07-05 02:45:04.575893',8,'{}','success'),(5076,'sync-table-privileges',2,'2024-07-05 02:45:04.585308','2024-07-05 02:45:04.595675',10,NULL,'success'),(5077,'analyze',2,'2024-07-05 02:45:04.634141','2024-07-05 02:45:06.862268',2228,NULL,'success'),(5078,'fingerprint-fields',2,'2024-07-05 02:45:04.643020','2024-07-05 02:45:06.710480',2067,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5079,'classify-fields',2,'2024-07-05 02:45:06.719165','2024-07-05 02:45:06.831056',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5080,'classify-tables',2,'2024-07-05 02:45:06.839181','2024-07-05 02:45:06.853219',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5081,'sync',2,'2024-07-05 03:45:00.114526','2024-07-05 03:45:04.362486',4247,NULL,'success'),(5082,'sync-dbms-version',2,'2024-07-05 03:45:00.123414','2024-07-05 03:45:00.135242',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5083,'sync-timezone',2,'2024-07-05 03:45:00.143176','2024-07-05 03:45:00.154318',11,'{\"timezone-id\":\"+08:00\"}','success'),(5084,'sync-tables',2,'2024-07-05 03:45:00.164444','2024-07-05 03:45:00.191245',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5085,'sync-fields',2,'2024-07-05 03:45:00.199362','2024-07-05 03:45:03.182632',2983,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5086,'sync-fks',2,'2024-07-05 03:45:03.190276','2024-07-05 03:45:03.765788',575,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5087,'sync-indexes',2,'2024-07-05 03:45:03.774831','2024-07-05 03:45:04.317044',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5088,'sync-metabase-metadata',2,'2024-07-05 03:45:04.324977','2024-07-05 03:45:04.334027',9,'{}','success'),(5089,'sync-table-privileges',2,'2024-07-05 03:45:04.346440','2024-07-05 03:45:04.354387',7,NULL,'success'),(5090,'analyze',2,'2024-07-05 03:45:04.387207','2024-07-05 03:45:06.453436',2066,NULL,'success'),(5091,'fingerprint-fields',2,'2024-07-05 03:45:04.396763','2024-07-05 03:45:06.298878',1902,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5092,'classify-fields',2,'2024-07-05 03:45:06.307846','2024-07-05 03:45:06.423727',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5093,'classify-tables',2,'2024-07-05 03:45:06.431221','2024-07-05 03:45:06.444987',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5094,'task-history-cleanup',NULL,'2024-07-05 04:00:00.073340','2024-07-05 04:00:00.084441',11,NULL,'success'),(5095,'sync',2,'2024-07-05 04:45:00.114251','2024-07-05 04:45:04.659596',4545,NULL,'success'),(5096,'sync-dbms-version',2,'2024-07-05 04:45:00.122294','2024-07-05 04:45:00.131815',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5097,'sync-timezone',2,'2024-07-05 04:45:00.141484','2024-07-05 04:45:00.153009',11,'{\"timezone-id\":\"+08:00\"}','success'),(5098,'sync-tables',2,'2024-07-05 04:45:00.163817','2024-07-05 04:45:00.191504',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5099,'sync-fields',2,'2024-07-05 04:45:00.201048','2024-07-05 04:45:03.364496',3163,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5100,'sync-fks',2,'2024-07-05 04:45:03.373500','2024-07-05 04:45:04.046076',672,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5101,'sync-indexes',2,'2024-07-05 04:45:04.054828','2024-07-05 04:45:04.615385',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5102,'sync-metabase-metadata',2,'2024-07-05 04:45:04.623157','2024-07-05 04:45:04.631829',8,'{}','success'),(5103,'sync-table-privileges',2,'2024-07-05 04:45:04.640133','2024-07-05 04:45:04.650218',10,NULL,'success'),(5104,'analyze',2,'2024-07-05 04:45:04.684022','2024-07-05 04:45:06.742498',2058,NULL,'success'),(5105,'fingerprint-fields',2,'2024-07-05 04:45:04.693395','2024-07-05 04:45:06.590308',1896,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5106,'classify-fields',2,'2024-07-05 04:45:06.598474','2024-07-05 04:45:06.711626',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5107,'classify-tables',2,'2024-07-05 04:45:06.719479','2024-07-05 04:45:06.733260',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5108,'sync',2,'2024-07-05 05:45:00.106014','2024-07-05 05:45:04.557026',4451,NULL,'success'),(5109,'sync-dbms-version',2,'2024-07-05 05:45:00.113987','2024-07-05 05:45:00.123351',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5110,'sync-timezone',2,'2024-07-05 05:45:00.133396','2024-07-05 05:45:00.144086',10,'{\"timezone-id\":\"+08:00\"}','success'),(5111,'sync-tables',2,'2024-07-05 05:45:00.154544','2024-07-05 05:45:00.184532',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5112,'sync-fields',2,'2024-07-05 05:45:00.193332','2024-07-05 05:45:03.313279',3119,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5113,'sync-fks',2,'2024-07-05 05:45:03.321610','2024-07-05 05:45:03.969963',648,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5114,'sync-indexes',2,'2024-07-05 05:45:03.979343','2024-07-05 05:45:04.514142',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5115,'sync-metabase-metadata',2,'2024-07-05 05:45:04.521621','2024-07-05 05:45:04.530101',8,'{}','success'),(5116,'sync-table-privileges',2,'2024-07-05 05:45:04.538917','2024-07-05 05:45:04.548666',9,NULL,'success'),(5117,'analyze',2,'2024-07-05 05:45:04.581502','2024-07-05 05:45:06.756568',2175,NULL,'success'),(5118,'fingerprint-fields',2,'2024-07-05 05:45:04.589716','2024-07-05 05:45:06.615481',2025,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5119,'classify-fields',2,'2024-07-05 05:45:06.623808','2024-07-05 05:45:06.727301',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5120,'classify-tables',2,'2024-07-05 05:45:06.734649','2024-07-05 05:45:06.748260',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5121,'sync',2,'2024-07-05 06:45:00.122758','2024-07-05 06:45:04.888567',4765,NULL,'success'),(5122,'sync-dbms-version',2,'2024-07-05 06:45:00.132989','2024-07-05 06:45:00.143838',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5123,'sync-timezone',2,'2024-07-05 06:45:00.154185','2024-07-05 06:45:00.166571',12,'{\"timezone-id\":\"+08:00\"}','success'),(5124,'sync-tables',2,'2024-07-05 06:45:00.176469','2024-07-05 06:45:00.207964',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5125,'sync-fields',2,'2024-07-05 06:45:00.217359','2024-07-05 06:45:03.567148',3349,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5126,'sync-fks',2,'2024-07-05 06:45:03.575489','2024-07-05 06:45:04.252249',676,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5127,'sync-indexes',2,'2024-07-05 06:45:04.260819','2024-07-05 06:45:04.845754',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5128,'sync-metabase-metadata',2,'2024-07-05 06:45:04.853093','2024-07-05 06:45:04.861321',8,'{}','success'),(5129,'sync-table-privileges',2,'2024-07-05 06:45:04.872289','2024-07-05 06:45:04.880830',8,NULL,'success'),(5130,'analyze',2,'2024-07-05 06:45:04.913916','2024-07-05 06:45:07.060897',2146,NULL,'success'),(5131,'fingerprint-fields',2,'2024-07-05 06:45:04.921920','2024-07-05 06:45:06.906108',1984,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5132,'classify-fields',2,'2024-07-05 06:45:06.913935','2024-07-05 06:45:07.028326',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5133,'classify-tables',2,'2024-07-05 06:45:07.035932','2024-07-05 06:45:07.051420',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5134,'sync',2,'2024-07-05 07:45:00.117692','2024-07-05 07:45:04.502266',4384,NULL,'success'),(5135,'sync-dbms-version',2,'2024-07-05 07:45:00.128431','2024-07-05 07:45:00.138934',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5136,'sync-timezone',2,'2024-07-05 07:45:00.148280','2024-07-05 07:45:00.166910',18,'{\"timezone-id\":\"+08:00\"}','success'),(5137,'sync-tables',2,'2024-07-05 07:45:00.176282','2024-07-05 07:45:00.210030',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5138,'sync-fields',2,'2024-07-05 07:45:00.220187','2024-07-05 07:45:03.253442',3033,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5139,'sync-fks',2,'2024-07-05 07:45:03.261192','2024-07-05 07:45:03.893143',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5140,'sync-indexes',2,'2024-07-05 07:45:03.902097','2024-07-05 07:45:04.461068',558,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5141,'sync-metabase-metadata',2,'2024-07-05 07:45:04.468975','2024-07-05 07:45:04.477307',8,'{}','success'),(5142,'sync-table-privileges',2,'2024-07-05 07:45:04.485766','2024-07-05 07:45:04.494065',8,NULL,'success'),(5143,'analyze',2,'2024-07-05 07:45:04.527724','2024-07-05 07:45:06.511684',1983,NULL,'success'),(5144,'fingerprint-fields',2,'2024-07-05 07:45:04.535724','2024-07-05 07:45:06.366416',1830,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5145,'classify-fields',2,'2024-07-05 07:45:06.374616','2024-07-05 07:45:06.481147',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5146,'classify-tables',2,'2024-07-05 07:45:06.488907','2024-07-05 07:45:06.503283',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5147,'sync',2,'2024-07-05 08:45:00.108114','2024-07-05 08:45:04.307352',4199,NULL,'success'),(5148,'sync-dbms-version',2,'2024-07-05 08:45:00.116831','2024-07-05 08:45:00.125901',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5149,'sync-timezone',2,'2024-07-05 08:45:00.134812','2024-07-05 08:45:00.145638',10,'{\"timezone-id\":\"+08:00\"}','success'),(5150,'sync-tables',2,'2024-07-05 08:45:00.153849','2024-07-05 08:45:00.178960',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5151,'sync-fields',2,'2024-07-05 08:45:00.187770','2024-07-05 08:45:03.184545',2996,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5152,'sync-fks',2,'2024-07-05 08:45:03.192651','2024-07-05 08:45:03.747471',554,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5153,'sync-indexes',2,'2024-07-05 08:45:03.756350','2024-07-05 08:45:04.266553',510,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5154,'sync-metabase-metadata',2,'2024-07-05 08:45:04.273879','2024-07-05 08:45:04.281964',8,'{}','success'),(5155,'sync-table-privileges',2,'2024-07-05 08:45:04.290243','2024-07-05 08:45:04.298401',8,NULL,'success'),(5156,'analyze',2,'2024-07-05 08:45:04.333004','2024-07-05 08:45:06.297770',1964,NULL,'success'),(5157,'fingerprint-fields',2,'2024-07-05 08:45:04.341536','2024-07-05 08:45:06.155165',1813,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5158,'classify-fields',2,'2024-07-05 08:45:06.162811','2024-07-05 08:45:06.267317',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5159,'classify-tables',2,'2024-07-05 08:45:06.275451','2024-07-05 08:45:06.289941',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5160,'sync',2,'2024-07-05 09:45:00.087943','2024-07-05 09:45:04.139148',4051,NULL,'success'),(5161,'sync-dbms-version',2,'2024-07-05 09:45:00.095781','2024-07-05 09:45:00.104846',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5162,'sync-timezone',2,'2024-07-05 09:45:00.113711','2024-07-05 09:45:00.125184',11,'{\"timezone-id\":\"+08:00\"}','success'),(5163,'sync-tables',2,'2024-07-05 09:45:00.133510','2024-07-05 09:45:00.160323',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5164,'sync-fields',2,'2024-07-05 09:45:00.168868','2024-07-05 09:45:02.936543',2767,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5165,'sync-fks',2,'2024-07-05 09:45:02.943778','2024-07-05 09:45:03.534182',590,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5166,'sync-indexes',2,'2024-07-05 09:45:03.544858','2024-07-05 09:45:04.099705',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5167,'sync-metabase-metadata',2,'2024-07-05 09:45:04.107513','2024-07-05 09:45:04.114494',6,'{}','success'),(5168,'sync-table-privileges',2,'2024-07-05 09:45:04.123192','2024-07-05 09:45:04.131333',8,NULL,'success'),(5169,'analyze',2,'2024-07-05 09:45:04.163526','2024-07-05 09:45:06.211299',2047,NULL,'success'),(5170,'fingerprint-fields',2,'2024-07-05 09:45:04.172632','2024-07-05 09:45:06.050499',1877,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5171,'classify-fields',2,'2024-07-05 09:45:06.059437','2024-07-05 09:45:06.181428',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5172,'classify-tables',2,'2024-07-05 09:45:06.189215','2024-07-05 09:45:06.203146',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5173,'sync',2,'2024-07-05 10:45:00.089259','2024-07-05 10:45:04.115882',4026,NULL,'success'),(5174,'sync-dbms-version',2,'2024-07-05 10:45:00.096963','2024-07-05 10:45:00.105437',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5175,'sync-timezone',2,'2024-07-05 10:45:00.113737','2024-07-05 10:45:00.122783',9,'{\"timezone-id\":\"+08:00\"}','success'),(5176,'sync-tables',2,'2024-07-05 10:45:00.130495','2024-07-05 10:45:00.155748',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5177,'sync-fields',2,'2024-07-05 10:45:00.163677','2024-07-05 10:45:02.955243',2791,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5178,'sync-fks',2,'2024-07-05 10:45:02.962735','2024-07-05 10:45:03.567749',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5179,'sync-indexes',2,'2024-07-05 10:45:03.575936','2024-07-05 10:45:04.075164',499,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5180,'sync-metabase-metadata',2,'2024-07-05 10:45:04.082508','2024-07-05 10:45:04.090368',7,'{}','success'),(5181,'sync-table-privileges',2,'2024-07-05 10:45:04.099640','2024-07-05 10:45:04.107869',8,NULL,'success'),(5182,'analyze',2,'2024-07-05 10:45:04.139888','2024-07-05 10:45:06.038141',1898,NULL,'success'),(5183,'fingerprint-fields',2,'2024-07-05 10:45:04.148364','2024-07-05 10:45:05.883408',1735,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5184,'classify-fields',2,'2024-07-05 10:45:05.891463','2024-07-05 10:45:06.007925',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5185,'classify-tables',2,'2024-07-05 10:45:06.015560','2024-07-05 10:45:06.029558',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5186,'sync',2,'2024-07-05 11:45:00.093775','2024-07-05 11:45:03.986387',3892,NULL,'success'),(5187,'sync-dbms-version',2,'2024-07-05 11:45:00.102500','2024-07-05 11:45:00.111631',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5188,'sync-timezone',2,'2024-07-05 11:45:00.119733','2024-07-05 11:45:00.131351',11,'{\"timezone-id\":\"+08:00\"}','success'),(5189,'sync-tables',2,'2024-07-05 11:45:00.139924','2024-07-05 11:45:00.164643',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5190,'sync-fields',2,'2024-07-05 11:45:00.172468','2024-07-05 11:45:02.850767',2678,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5191,'sync-fks',2,'2024-07-05 11:45:02.858444','2024-07-05 11:45:03.456318',597,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5192,'sync-indexes',2,'2024-07-05 11:45:03.464901','2024-07-05 11:45:03.948245',483,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5193,'sync-metabase-metadata',2,'2024-07-05 11:45:03.955269','2024-07-05 11:45:03.962975',7,'{}','success'),(5194,'sync-table-privileges',2,'2024-07-05 11:45:03.970646','2024-07-05 11:45:03.978572',7,NULL,'success'),(5195,'analyze',2,'2024-07-05 11:45:04.009964','2024-07-05 11:45:05.890376',1880,NULL,'success'),(5196,'fingerprint-fields',2,'2024-07-05 11:45:04.018802','2024-07-05 11:45:05.757932',1739,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5197,'classify-fields',2,'2024-07-05 11:45:05.765487','2024-07-05 11:45:05.862985',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5198,'classify-tables',2,'2024-07-05 11:45:05.870155','2024-07-05 11:45:05.882743',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5199,'sync',2,'2024-07-05 12:45:00.101719','2024-07-05 12:45:04.275474',4173,NULL,'success'),(5200,'sync-dbms-version',2,'2024-07-05 12:45:00.110075','2024-07-05 12:45:00.119120',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5201,'sync-timezone',2,'2024-07-05 12:45:00.127716','2024-07-05 12:45:00.137655',9,'{\"timezone-id\":\"+08:00\"}','success'),(5202,'sync-tables',2,'2024-07-05 12:45:00.147034','2024-07-05 12:45:00.174883',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5203,'sync-fields',2,'2024-07-05 12:45:00.183540','2024-07-05 12:45:03.139923',2956,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5204,'sync-fks',2,'2024-07-05 12:45:03.148083','2024-07-05 12:45:03.727814',579,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5205,'sync-indexes',2,'2024-07-05 12:45:03.736639','2024-07-05 12:45:04.233439',496,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5206,'sync-metabase-metadata',2,'2024-07-05 12:45:04.241003','2024-07-05 12:45:04.249137',8,'{}','success'),(5207,'sync-table-privileges',2,'2024-07-05 12:45:04.257507','2024-07-05 12:45:04.267318',9,NULL,'success'),(5208,'analyze',2,'2024-07-05 12:45:04.303120','2024-07-05 12:45:06.252230',1949,NULL,'success'),(5209,'fingerprint-fields',2,'2024-07-05 12:45:04.311269','2024-07-05 12:45:06.107592',1796,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5210,'classify-fields',2,'2024-07-05 12:45:06.115837','2024-07-05 12:45:06.220603',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5211,'classify-tables',2,'2024-07-05 12:45:06.228996','2024-07-05 12:45:06.243639',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5212,'field values scanning',2,'2024-07-05 13:00:00.060574','2024-07-05 13:00:04.211765',4151,NULL,'success'),(5213,'delete-expired-advanced-field-values',2,'2024-07-05 13:00:00.072104','2024-07-05 13:00:02.879424',2807,'{\"deleted\":0}','success'),(5214,'update-field-values',2,'2024-07-05 13:00:02.889005','2024-07-05 13:00:04.203699',1314,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(5215,'sync',2,'2024-07-05 13:45:00.103104','2024-07-05 13:45:04.019878',3916,NULL,'success'),(5216,'sync-dbms-version',2,'2024-07-05 13:45:00.111691','2024-07-05 13:45:00.121455',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5217,'sync-timezone',2,'2024-07-05 13:45:00.129873','2024-07-05 13:45:00.139465',9,'{\"timezone-id\":\"+08:00\"}','success'),(5218,'sync-tables',2,'2024-07-05 13:45:00.148162','2024-07-05 13:45:00.173523',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5219,'sync-fields',2,'2024-07-05 13:45:00.181846','2024-07-05 13:45:03.033164',2851,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5220,'sync-fks',2,'2024-07-05 13:45:03.040618','2024-07-05 13:45:03.535413',494,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5221,'sync-indexes',2,'2024-07-05 13:45:03.543236','2024-07-05 13:45:03.982934',439,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5222,'sync-metabase-metadata',2,'2024-07-05 13:45:03.989800','2024-07-05 13:45:03.997153',7,'{}','success'),(5223,'sync-table-privileges',2,'2024-07-05 13:45:04.004746','2024-07-05 13:45:04.012440',7,NULL,'success'),(5224,'analyze',2,'2024-07-05 13:45:04.042821','2024-07-05 13:45:05.875187',1832,NULL,'success'),(5225,'fingerprint-fields',2,'2024-07-05 13:45:04.050289','2024-07-05 13:45:05.718797',1668,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5226,'classify-fields',2,'2024-07-05 13:45:05.728004','2024-07-05 13:45:05.845613',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5227,'classify-tables',2,'2024-07-05 13:45:05.853157','2024-07-05 13:45:05.867096',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5228,'sync',2,'2024-07-05 14:45:00.094344','2024-07-05 14:45:04.358634',4264,NULL,'success'),(5229,'sync-dbms-version',2,'2024-07-05 14:45:00.102794','2024-07-05 14:45:00.113034',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5230,'sync-timezone',2,'2024-07-05 14:45:00.121553','2024-07-05 14:45:00.132972',11,'{\"timezone-id\":\"+08:00\"}','success'),(5231,'sync-tables',2,'2024-07-05 14:45:00.141620','2024-07-05 14:45:00.168253',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5232,'sync-fields',2,'2024-07-05 14:45:00.177925','2024-07-05 14:45:03.111075',2933,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5233,'sync-fks',2,'2024-07-05 14:45:03.118601','2024-07-05 14:45:03.735855',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5234,'sync-indexes',2,'2024-07-05 14:45:03.743822','2024-07-05 14:45:04.314150',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5235,'sync-metabase-metadata',2,'2024-07-05 14:45:04.322454','2024-07-05 14:45:04.331950',9,'{}','success'),(5236,'sync-table-privileges',2,'2024-07-05 14:45:04.340626','2024-07-05 14:45:04.349809',9,NULL,'success'),(5237,'analyze',2,'2024-07-05 14:45:04.385521','2024-07-05 14:45:06.359471',1973,NULL,'success'),(5238,'fingerprint-fields',2,'2024-07-05 14:45:04.394112','2024-07-05 14:45:06.220385',1826,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5239,'classify-fields',2,'2024-07-05 14:45:06.228176','2024-07-05 14:45:06.330180',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5240,'classify-tables',2,'2024-07-05 14:45:06.337799','2024-07-05 14:45:06.351831',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5241,'sync',2,'2024-07-05 15:45:00.099624','2024-07-05 15:45:04.438091',4338,NULL,'success'),(5242,'sync-dbms-version',2,'2024-07-05 15:45:00.109057','2024-07-05 15:45:00.118638',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5243,'sync-timezone',2,'2024-07-05 15:45:00.127120','2024-07-05 15:45:00.136755',9,'{\"timezone-id\":\"+08:00\"}','success'),(5244,'sync-tables',2,'2024-07-05 15:45:00.145954','2024-07-05 15:45:00.176064',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5245,'sync-fields',2,'2024-07-05 15:45:00.185312','2024-07-05 15:45:03.243002',3057,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5246,'sync-fks',2,'2024-07-05 15:45:03.250981','2024-07-05 15:45:03.916310',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5247,'sync-indexes',2,'2024-07-05 15:45:03.924416','2024-07-05 15:45:04.397482',473,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5248,'sync-metabase-metadata',2,'2024-07-05 15:45:04.404601','2024-07-05 15:45:04.412725',8,'{}','success'),(5249,'sync-table-privileges',2,'2024-07-05 15:45:04.420294','2024-07-05 15:45:04.430545',10,NULL,'success'),(5250,'analyze',2,'2024-07-05 15:45:04.462265','2024-07-05 15:45:06.430195',1967,NULL,'success'),(5251,'fingerprint-fields',2,'2024-07-05 15:45:04.469995','2024-07-05 15:45:06.299212',1829,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5252,'classify-fields',2,'2024-07-05 15:45:06.307097','2024-07-05 15:45:06.401391',94,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5253,'classify-tables',2,'2024-07-05 15:45:06.408681','2024-07-05 15:45:06.420840',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5254,'task-history-cleanup',NULL,'2024-07-05 16:00:00.019814','2024-07-05 16:00:00.081053',61,NULL,'success'),(5255,'task-history-cleanup',NULL,'2024-07-05 16:00:00.071218','2024-07-05 16:00:00.084905',13,NULL,'success'),(5256,'sync',2,'2024-07-05 16:45:00.120337','2024-07-05 16:45:04.432841',4312,NULL,'success'),(5257,'sync-dbms-version',2,'2024-07-05 16:45:00.128936','2024-07-05 16:45:00.138221',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5258,'sync-timezone',2,'2024-07-05 16:45:00.147568','2024-07-05 16:45:00.159422',11,'{\"timezone-id\":\"+08:00\"}','success'),(5259,'sync-tables',2,'2024-07-05 16:45:00.168519','2024-07-05 16:45:00.197430',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5260,'sync-fields',2,'2024-07-05 16:45:00.214493','2024-07-05 16:45:03.148613',2934,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5261,'sync-fks',2,'2024-07-05 16:45:03.156298','2024-07-05 16:45:03.822399',666,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5262,'sync-indexes',2,'2024-07-05 16:45:03.831051','2024-07-05 16:45:04.387744',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5263,'sync-metabase-metadata',2,'2024-07-05 16:45:04.395980','2024-07-05 16:45:04.404661',8,'{}','success'),(5264,'sync-table-privileges',2,'2024-07-05 16:45:04.413890','2024-07-05 16:45:04.424053',10,NULL,'success'),(5265,'analyze',2,'2024-07-05 16:45:04.458549','2024-07-05 16:45:06.601020',2142,NULL,'success'),(5266,'fingerprint-fields',2,'2024-07-05 16:45:04.466697','2024-07-05 16:45:06.444683',1977,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5267,'classify-fields',2,'2024-07-05 16:45:06.453263','2024-07-05 16:45:06.569862',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5268,'classify-tables',2,'2024-07-05 16:45:06.577708','2024-07-05 16:45:06.592459',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5269,'sync',2,'2024-07-05 17:45:00.111234','2024-07-05 17:45:04.987495',4876,NULL,'success'),(5270,'sync-dbms-version',2,'2024-07-05 17:45:00.120212','2024-07-05 17:45:00.131388',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5271,'sync-timezone',2,'2024-07-05 17:45:00.140277','2024-07-05 17:45:00.151651',11,'{\"timezone-id\":\"+08:00\"}','success'),(5272,'sync-tables',2,'2024-07-05 17:45:00.161120','2024-07-05 17:45:00.193555',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5273,'sync-fields',2,'2024-07-05 17:45:00.202940','2024-07-05 17:45:03.491377',3288,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5274,'sync-fks',2,'2024-07-05 17:45:03.499300','2024-07-05 17:45:04.218006',718,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5275,'sync-indexes',2,'2024-07-05 17:45:04.227256','2024-07-05 17:45:04.942213',714,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5276,'sync-metabase-metadata',2,'2024-07-05 17:45:04.950222','2024-07-05 17:45:04.960651',10,'{}','success'),(5277,'sync-table-privileges',2,'2024-07-05 17:45:04.970151','2024-07-05 17:45:04.978349',8,NULL,'success'),(5278,'analyze',2,'2024-07-05 17:45:05.018205','2024-07-05 17:45:07.264140',2245,NULL,'success'),(5279,'fingerprint-fields',2,'2024-07-05 17:45:05.027223','2024-07-05 17:45:07.086125',2058,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5280,'classify-fields',2,'2024-07-05 17:45:07.095253','2024-07-05 17:45:07.230389',135,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5281,'classify-tables',2,'2024-07-05 17:45:07.238815','2024-07-05 17:45:07.254757',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5282,'sync',2,'2024-07-05 18:45:00.116889','2024-07-05 18:45:04.543146',4426,NULL,'success'),(5283,'sync-dbms-version',2,'2024-07-05 18:45:00.125750','2024-07-05 18:45:00.135840',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5284,'sync-timezone',2,'2024-07-05 18:45:00.145009','2024-07-05 18:45:00.155381',10,'{\"timezone-id\":\"+08:00\"}','success'),(5285,'sync-tables',2,'2024-07-05 18:45:00.164138','2024-07-05 18:45:00.193434',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5286,'sync-fields',2,'2024-07-05 18:45:00.204814','2024-07-05 18:45:03.276187',3071,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5287,'sync-fks',2,'2024-07-05 18:45:03.283868','2024-07-05 18:45:03.869632',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5288,'sync-indexes',2,'2024-07-05 18:45:03.877483','2024-07-05 18:45:04.496868',619,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5289,'sync-metabase-metadata',2,'2024-07-05 18:45:04.504792','2024-07-05 18:45:04.514401',9,'{}','success'),(5290,'sync-table-privileges',2,'2024-07-05 18:45:04.523325','2024-07-05 18:45:04.533315',9,NULL,'success'),(5291,'analyze',2,'2024-07-05 18:45:04.575277','2024-07-05 18:45:06.508912',1933,NULL,'success'),(5292,'fingerprint-fields',2,'2024-07-05 18:45:04.584033','2024-07-05 18:45:06.359034',1775,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5293,'classify-fields',2,'2024-07-05 18:45:06.366838','2024-07-05 18:45:06.477109',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5294,'classify-tables',2,'2024-07-05 18:45:06.485381','2024-07-05 18:45:06.500074',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5295,'sync',2,'2024-07-05 19:45:00.098116','2024-07-05 19:45:04.629142',4531,NULL,'success'),(5296,'sync-dbms-version',2,'2024-07-05 19:45:00.106299','2024-07-05 19:45:00.116178',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5297,'sync-timezone',2,'2024-07-05 19:45:00.124857','2024-07-05 19:45:00.134972',10,'{\"timezone-id\":\"+08:00\"}','success'),(5298,'sync-tables',2,'2024-07-05 19:45:00.143919','2024-07-05 19:45:00.170601',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5299,'sync-fields',2,'2024-07-05 19:45:00.179606','2024-07-05 19:45:03.330604',3151,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5300,'sync-fks',2,'2024-07-05 19:45:03.338944','2024-07-05 19:45:04.004309',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5301,'sync-indexes',2,'2024-07-05 19:45:04.013595','2024-07-05 19:45:04.585439',571,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5302,'sync-metabase-metadata',2,'2024-07-05 19:45:04.597004','2024-07-05 19:45:04.604989',7,'{}','success'),(5303,'sync-table-privileges',2,'2024-07-05 19:45:04.613098','2024-07-05 19:45:04.621048',7,NULL,'success'),(5304,'analyze',2,'2024-07-05 19:45:04.656490','2024-07-05 19:45:06.597563',1941,NULL,'success'),(5305,'fingerprint-fields',2,'2024-07-05 19:45:04.664356','2024-07-05 19:45:06.459677',1795,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5306,'classify-fields',2,'2024-07-05 19:45:06.467501','2024-07-05 19:45:06.569531',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5307,'classify-tables',2,'2024-07-05 19:45:06.577027','2024-07-05 19:45:06.589903',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5308,'sync',2,'2024-07-05 20:45:00.114343','2024-07-05 20:45:05.567551',5453,NULL,'success'),(5309,'sync-dbms-version',2,'2024-07-05 20:45:00.124228','2024-07-05 20:45:00.134227',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5310,'sync-timezone',2,'2024-07-05 20:45:00.144437','2024-07-05 20:45:00.156015',11,'{\"timezone-id\":\"+08:00\"}','success'),(5311,'sync-tables',2,'2024-07-05 20:45:00.165520','2024-07-05 20:45:00.200800',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5312,'sync-fields',2,'2024-07-05 20:45:00.212943','2024-07-05 20:45:03.389355',3176,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5313,'sync-fks',2,'2024-07-05 20:45:03.397428','2024-07-05 20:45:04.114124',716,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5314,'sync-indexes',2,'2024-07-05 20:45:04.123175','2024-07-05 20:45:05.528051',1404,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5315,'sync-metabase-metadata',2,'2024-07-05 20:45:05.535693','2024-07-05 20:45:05.543850',8,'{}','success'),(5316,'sync-table-privileges',2,'2024-07-05 20:45:05.551550','2024-07-05 20:45:05.559874',8,NULL,'success'),(5317,'analyze',2,'2024-07-05 20:45:05.596627','2024-07-05 20:45:07.751181',2154,NULL,'success'),(5318,'fingerprint-fields',2,'2024-07-05 20:45:05.605735','2024-07-05 20:45:07.596848',1991,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5319,'classify-fields',2,'2024-07-05 20:45:07.605251','2024-07-05 20:45:07.720191',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5320,'classify-tables',2,'2024-07-05 20:45:07.727855','2024-07-05 20:45:07.741442',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5321,'sync',2,'2024-07-05 21:45:00.104746','2024-07-05 21:45:04.367736',4262,NULL,'success'),(5322,'sync-dbms-version',2,'2024-07-05 21:45:00.113200','2024-07-05 21:45:00.123428',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5323,'sync-timezone',2,'2024-07-05 21:45:00.132491','2024-07-05 21:45:00.142441',9,'{\"timezone-id\":\"+08:00\"}','success'),(5324,'sync-tables',2,'2024-07-05 21:45:00.150432','2024-07-05 21:45:00.177251',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5325,'sync-fields',2,'2024-07-05 21:45:00.185851','2024-07-05 21:45:03.155982',2970,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5326,'sync-fks',2,'2024-07-05 21:45:03.164675','2024-07-05 21:45:03.775266',610,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5327,'sync-indexes',2,'2024-07-05 21:45:03.784179','2024-07-05 21:45:04.326679',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5328,'sync-metabase-metadata',2,'2024-07-05 21:45:04.334056','2024-07-05 21:45:04.342340',8,'{}','success'),(5329,'sync-table-privileges',2,'2024-07-05 21:45:04.350353','2024-07-05 21:45:04.359077',8,NULL,'success'),(5330,'analyze',2,'2024-07-05 21:45:04.393542','2024-07-05 21:45:06.369776',1976,NULL,'success'),(5331,'fingerprint-fields',2,'2024-07-05 21:45:04.401569','2024-07-05 21:45:06.230970',1829,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5332,'classify-fields',2,'2024-07-05 21:45:06.239118','2024-07-05 21:45:06.340076',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5333,'classify-tables',2,'2024-07-05 21:45:06.347358','2024-07-05 21:45:06.361837',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5334,'sync',2,'2024-07-05 22:45:00.096619','2024-07-05 22:45:04.134074',4037,NULL,'success'),(5335,'sync-dbms-version',2,'2024-07-05 22:45:00.104707','2024-07-05 22:45:00.113825',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5336,'sync-timezone',2,'2024-07-05 22:45:00.122167','2024-07-05 22:45:00.132548',10,'{\"timezone-id\":\"+08:00\"}','success'),(5337,'sync-tables',2,'2024-07-05 22:45:00.140705','2024-07-05 22:45:00.167258',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5338,'sync-fields',2,'2024-07-05 22:45:00.181329','2024-07-05 22:45:02.985107',2803,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5339,'sync-fks',2,'2024-07-05 22:45:02.992853','2024-07-05 22:45:03.603116',610,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5340,'sync-indexes',2,'2024-07-05 22:45:03.610712','2024-07-05 22:45:04.093789',483,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5341,'sync-metabase-metadata',2,'2024-07-05 22:45:04.101739','2024-07-05 22:45:04.110107',8,'{}','success'),(5342,'sync-table-privileges',2,'2024-07-05 22:45:04.117966','2024-07-05 22:45:04.126093',8,NULL,'success'),(5343,'analyze',2,'2024-07-05 22:45:04.160900','2024-07-05 22:45:06.056146',1895,NULL,'success'),(5344,'fingerprint-fields',2,'2024-07-05 22:45:04.168690','2024-07-05 22:45:05.919515',1750,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5345,'classify-fields',2,'2024-07-05 22:45:05.927172','2024-07-05 22:45:06.028530',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5346,'classify-tables',2,'2024-07-05 22:45:06.035998','2024-07-05 22:45:06.048528',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5347,'sync',2,'2024-07-05 23:45:00.097012','2024-07-05 23:45:04.646101',4549,NULL,'success'),(5348,'sync-dbms-version',2,'2024-07-05 23:45:00.104868','2024-07-05 23:45:00.113845',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5349,'sync-timezone',2,'2024-07-05 23:45:00.122379','2024-07-05 23:45:00.133483',11,'{\"timezone-id\":\"+08:00\"}','success'),(5350,'sync-tables',2,'2024-07-05 23:45:00.142127','2024-07-05 23:45:00.174995',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5351,'sync-fields',2,'2024-07-05 23:45:00.183018','2024-07-05 23:45:03.310782',3127,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5352,'sync-fks',2,'2024-07-05 23:45:03.319295','2024-07-05 23:45:04.002560',683,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5353,'sync-indexes',2,'2024-07-05 23:45:04.010547','2024-07-05 23:45:04.603979',593,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5354,'sync-metabase-metadata',2,'2024-07-05 23:45:04.612057','2024-07-05 23:45:04.620174',8,'{}','success'),(5355,'sync-table-privileges',2,'2024-07-05 23:45:04.629184','2024-07-05 23:45:04.637520',8,NULL,'success'),(5356,'analyze',2,'2024-07-05 23:45:04.677634','2024-07-05 23:45:06.878104',2200,NULL,'success'),(5357,'fingerprint-fields',2,'2024-07-05 23:45:04.686473','2024-07-05 23:45:06.724168',2037,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5358,'classify-fields',2,'2024-07-05 23:45:06.733662','2024-07-05 23:45:06.849618',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5359,'classify-tables',2,'2024-07-05 23:45:06.857432','2024-07-05 23:45:06.870237',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5360,'sync',2,'2024-07-06 00:45:00.108809','2024-07-06 00:45:04.522000',4413,NULL,'success'),(5361,'sync-dbms-version',2,'2024-07-06 00:45:00.117263','2024-07-06 00:45:00.126074',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5362,'sync-timezone',2,'2024-07-06 00:45:00.134952','2024-07-06 00:45:00.146443',11,'{\"timezone-id\":\"+08:00\"}','success'),(5363,'sync-tables',2,'2024-07-06 00:45:00.154659','2024-07-06 00:45:00.185179',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5364,'sync-fields',2,'2024-07-06 00:45:00.194600','2024-07-06 00:45:03.297695',3103,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5365,'sync-fks',2,'2024-07-06 00:45:03.307710','2024-07-06 00:45:03.927687',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5366,'sync-indexes',2,'2024-07-06 00:45:03.936970','2024-07-06 00:45:04.479701',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5367,'sync-metabase-metadata',2,'2024-07-06 00:45:04.486970','2024-07-06 00:45:04.494939',7,'{}','success'),(5368,'sync-table-privileges',2,'2024-07-06 00:45:04.503169','2024-07-06 00:45:04.513470',10,NULL,'success'),(5369,'analyze',2,'2024-07-06 00:45:04.546464','2024-07-06 00:45:06.664634',2118,NULL,'success'),(5370,'fingerprint-fields',2,'2024-07-06 00:45:04.554276','2024-07-06 00:45:06.478856',1924,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5371,'classify-fields',2,'2024-07-06 00:45:06.487783','2024-07-06 00:45:06.632223',144,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5372,'classify-tables',2,'2024-07-06 00:45:06.641165','2024-07-06 00:45:06.656318',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5373,'sync',2,'2024-07-06 01:45:00.121642','2024-07-06 01:45:04.044859',3923,NULL,'success'),(5374,'sync-dbms-version',2,'2024-07-06 01:45:00.130844','2024-07-06 01:45:00.140945',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5375,'sync-timezone',2,'2024-07-06 01:45:00.149821','2024-07-06 01:45:00.159890',10,'{\"timezone-id\":\"+08:00\"}','success'),(5376,'sync-tables',2,'2024-07-06 01:45:00.168661','2024-07-06 01:45:00.202085',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5377,'sync-fields',2,'2024-07-06 01:45:00.211084','2024-07-06 01:45:03.006696',2795,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5378,'sync-fks',2,'2024-07-06 01:45:03.022655','2024-07-06 01:45:03.557913',535,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5379,'sync-indexes',2,'2024-07-06 01:45:03.565439','2024-07-06 01:45:04.004200',438,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5380,'sync-metabase-metadata',2,'2024-07-06 01:45:04.011143','2024-07-06 01:45:04.019188',8,'{}','success'),(5381,'sync-table-privileges',2,'2024-07-06 01:45:04.028812','2024-07-06 01:45:04.037190',8,NULL,'success'),(5382,'analyze',2,'2024-07-06 01:45:04.067492','2024-07-06 01:45:05.869825',1802,NULL,'success'),(5383,'fingerprint-fields',2,'2024-07-06 01:45:04.074780','2024-07-06 01:45:05.733391',1658,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5384,'classify-fields',2,'2024-07-06 01:45:05.741505','2024-07-06 01:45:05.842102',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5385,'classify-tables',2,'2024-07-06 01:45:05.849180','2024-07-06 01:45:05.861673',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5386,'sync',2,'2024-07-06 02:45:00.118290','2024-07-06 02:45:04.569077',4450,NULL,'success'),(5387,'sync-dbms-version',2,'2024-07-06 02:45:00.126309','2024-07-06 02:45:00.135907',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5388,'sync-timezone',2,'2024-07-06 02:45:00.145245','2024-07-06 02:45:00.156134',10,'{\"timezone-id\":\"+08:00\"}','success'),(5389,'sync-tables',2,'2024-07-06 02:45:00.165345','2024-07-06 02:45:00.192717',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5390,'sync-fields',2,'2024-07-06 02:45:00.201888','2024-07-06 02:45:03.302258',3100,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5391,'sync-fks',2,'2024-07-06 02:45:03.311707','2024-07-06 02:45:03.960400',648,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5392,'sync-indexes',2,'2024-07-06 02:45:03.968962','2024-07-06 02:45:04.525230',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5393,'sync-metabase-metadata',2,'2024-07-06 02:45:04.533222','2024-07-06 02:45:04.542984',9,'{}','success'),(5394,'sync-table-privileges',2,'2024-07-06 02:45:04.552599','2024-07-06 02:45:04.560823',8,NULL,'success'),(5395,'analyze',2,'2024-07-06 02:45:04.594941','2024-07-06 02:45:06.671678',2076,NULL,'success'),(5396,'fingerprint-fields',2,'2024-07-06 02:45:04.603569','2024-07-06 02:45:06.509039',1905,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5397,'classify-fields',2,'2024-07-06 02:45:06.517761','2024-07-06 02:45:06.640919',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5398,'classify-tables',2,'2024-07-06 02:45:06.648749','2024-07-06 02:45:06.662927',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5399,'sync',2,'2024-07-06 03:45:00.102044','2024-07-06 03:45:04.144262',4042,NULL,'success'),(5400,'sync-dbms-version',2,'2024-07-06 03:45:00.109895','2024-07-06 03:45:00.119424',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5401,'sync-timezone',2,'2024-07-06 03:45:00.128451','2024-07-06 03:45:00.138021',9,'{\"timezone-id\":\"+08:00\"}','success'),(5402,'sync-tables',2,'2024-07-06 03:45:00.146125','2024-07-06 03:45:00.171775',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5403,'sync-fields',2,'2024-07-06 03:45:00.179738','2024-07-06 03:45:03.016199',2836,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5404,'sync-fks',2,'2024-07-06 03:45:03.024570','2024-07-06 03:45:03.599352',574,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5405,'sync-indexes',2,'2024-07-06 03:45:03.609072','2024-07-06 03:45:04.104323',495,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5406,'sync-metabase-metadata',2,'2024-07-06 03:45:04.112394','2024-07-06 03:45:04.120915',8,'{}','success'),(5407,'sync-table-privileges',2,'2024-07-06 03:45:04.128933','2024-07-06 03:45:04.136481',7,NULL,'success'),(5408,'analyze',2,'2024-07-06 03:45:04.167640','2024-07-06 03:45:06.068661',1901,NULL,'success'),(5409,'fingerprint-fields',2,'2024-07-06 03:45:04.175193','2024-07-06 03:45:05.923750',1748,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5410,'classify-fields',2,'2024-07-06 03:45:05.932400','2024-07-06 03:45:06.039482',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5411,'classify-tables',2,'2024-07-06 03:45:06.047107','2024-07-06 03:45:06.060458',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5412,'task-history-cleanup',NULL,'2024-07-06 04:00:00.071593','2024-07-06 04:00:00.082308',10,NULL,'success'),(5413,'sync',2,'2024-07-06 04:45:00.100156','2024-07-06 04:45:04.478424',4378,NULL,'success'),(5414,'sync-dbms-version',2,'2024-07-06 04:45:00.107861','2024-07-06 04:45:00.116404',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5415,'sync-timezone',2,'2024-07-06 04:45:00.124528','2024-07-06 04:45:00.134125',9,'{\"timezone-id\":\"+08:00\"}','success'),(5416,'sync-tables',2,'2024-07-06 04:45:00.141895','2024-07-06 04:45:00.166823',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5417,'sync-fields',2,'2024-07-06 04:45:00.174735','2024-07-06 04:45:03.231829',3057,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5418,'sync-fks',2,'2024-07-06 04:45:03.240100','2024-07-06 04:45:03.880021',639,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5419,'sync-indexes',2,'2024-07-06 04:45:03.889815','2024-07-06 04:45:04.435008',545,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5420,'sync-metabase-metadata',2,'2024-07-06 04:45:04.442211','2024-07-06 04:45:04.450062',7,'{}','success'),(5421,'sync-table-privileges',2,'2024-07-06 04:45:04.460756','2024-07-06 04:45:04.469966',9,NULL,'success'),(5422,'analyze',2,'2024-07-06 04:45:04.502257','2024-07-06 04:45:06.468988',1966,NULL,'success'),(5423,'fingerprint-fields',2,'2024-07-06 04:45:04.510527','2024-07-06 04:45:06.320050',1809,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5424,'classify-fields',2,'2024-07-06 04:45:06.328206','2024-07-06 04:45:06.439046',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5425,'classify-tables',2,'2024-07-06 04:45:06.445879','2024-07-06 04:45:06.460278',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5426,'sync',2,'2024-07-06 05:45:00.097283','2024-07-06 05:45:04.452516',4355,NULL,'success'),(5427,'sync-dbms-version',2,'2024-07-06 05:45:00.105477','2024-07-06 05:45:00.115877',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5428,'sync-timezone',2,'2024-07-06 05:45:00.124255','2024-07-06 05:45:00.133963',9,'{\"timezone-id\":\"+08:00\"}','success'),(5429,'sync-tables',2,'2024-07-06 05:45:00.142755','2024-07-06 05:45:00.170451',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5430,'sync-fields',2,'2024-07-06 05:45:00.179375','2024-07-06 05:45:03.295493',3116,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5431,'sync-fks',2,'2024-07-06 05:45:03.303230','2024-07-06 05:45:03.899130',595,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5432,'sync-indexes',2,'2024-07-06 05:45:03.907006','2024-07-06 05:45:04.409038',502,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5433,'sync-metabase-metadata',2,'2024-07-06 05:45:04.418130','2024-07-06 05:45:04.426773',8,'{}','success'),(5434,'sync-table-privileges',2,'2024-07-06 05:45:04.434872','2024-07-06 05:45:04.444776',9,NULL,'success'),(5435,'analyze',2,'2024-07-06 05:45:04.476070','2024-07-06 05:45:06.447118',1971,NULL,'success'),(5436,'fingerprint-fields',2,'2024-07-06 05:45:04.483601','2024-07-06 05:45:06.281797',1798,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5437,'classify-fields',2,'2024-07-06 05:45:06.290466','2024-07-06 05:45:06.415311',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5438,'classify-tables',2,'2024-07-06 05:45:06.423201','2024-07-06 05:45:06.438650',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5439,'sync',2,'2024-07-06 06:45:00.110526','2024-07-06 06:45:04.625449',4514,NULL,'success'),(5440,'sync-dbms-version',2,'2024-07-06 06:45:00.119421','2024-07-06 06:45:00.128954',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5441,'sync-timezone',2,'2024-07-06 06:45:00.138414','2024-07-06 06:45:00.149082',10,'{\"timezone-id\":\"+08:00\"}','success'),(5442,'sync-tables',2,'2024-07-06 06:45:00.158438','2024-07-06 06:45:00.194982',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5443,'sync-fields',2,'2024-07-06 06:45:00.204173','2024-07-06 06:45:03.294730',3090,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5444,'sync-fks',2,'2024-07-06 06:45:03.303424','2024-07-06 06:45:03.998142',694,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5445,'sync-indexes',2,'2024-07-06 06:45:04.007103','2024-07-06 06:45:04.583491',576,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5446,'sync-metabase-metadata',2,'2024-07-06 06:45:04.591441','2024-07-06 06:45:04.599631',8,'{}','success'),(5447,'sync-table-privileges',2,'2024-07-06 06:45:04.607949','2024-07-06 06:45:04.616863',8,NULL,'success'),(5448,'analyze',2,'2024-07-06 06:45:04.654405','2024-07-06 06:45:06.611265',1956,NULL,'success'),(5449,'fingerprint-fields',2,'2024-07-06 06:45:04.663680','2024-07-06 06:45:06.459845',1796,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5450,'classify-fields',2,'2024-07-06 06:45:06.467684','2024-07-06 06:45:06.582590',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5451,'classify-tables',2,'2024-07-06 06:45:06.589859','2024-07-06 06:45:06.603231',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5452,'sync',2,'2024-07-06 07:45:00.119652','2024-07-06 07:45:04.488138',4368,NULL,'success'),(5453,'sync-dbms-version',2,'2024-07-06 07:45:00.128005','2024-07-06 07:45:00.137780',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5454,'sync-timezone',2,'2024-07-06 07:45:00.147001','2024-07-06 07:45:00.158366',11,'{\"timezone-id\":\"+08:00\"}','success'),(5455,'sync-tables',2,'2024-07-06 07:45:00.168025','2024-07-06 07:45:00.201096',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5456,'sync-fields',2,'2024-07-06 07:45:00.209688','2024-07-06 07:45:03.221792',3012,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5457,'sync-fks',2,'2024-07-06 07:45:03.231837','2024-07-06 07:45:03.889605',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5458,'sync-indexes',2,'2024-07-06 07:45:03.898183','2024-07-06 07:45:04.445263',547,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5459,'sync-metabase-metadata',2,'2024-07-06 07:45:04.453029','2024-07-06 07:45:04.461435',8,'{}','success'),(5460,'sync-table-privileges',2,'2024-07-06 07:45:04.470002','2024-07-06 07:45:04.480089',10,NULL,'success'),(5461,'analyze',2,'2024-07-06 07:45:04.513267','2024-07-06 07:45:06.584171',2070,NULL,'success'),(5462,'fingerprint-fields',2,'2024-07-06 07:45:04.521853','2024-07-06 07:45:06.429247',1907,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5463,'classify-fields',2,'2024-07-06 07:45:06.437404','2024-07-06 07:45:06.553623',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5464,'classify-tables',2,'2024-07-06 07:45:06.561172','2024-07-06 07:45:06.574451',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5465,'sync',2,'2024-07-06 08:45:00.103328','2024-07-06 08:45:04.126630',4023,NULL,'success'),(5466,'sync-dbms-version',2,'2024-07-06 08:45:00.112144','2024-07-06 08:45:00.121615',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5467,'sync-timezone',2,'2024-07-06 08:45:00.131749','2024-07-06 08:45:00.143988',12,'{\"timezone-id\":\"+08:00\"}','success'),(5468,'sync-tables',2,'2024-07-06 08:45:00.152489','2024-07-06 08:45:00.181515',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5469,'sync-fields',2,'2024-07-06 08:45:00.189945','2024-07-06 08:45:03.003934',2813,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5470,'sync-fks',2,'2024-07-06 08:45:03.011238','2024-07-06 08:45:03.592745',581,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5471,'sync-indexes',2,'2024-07-06 08:45:03.600924','2024-07-06 08:45:04.084518',483,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5472,'sync-metabase-metadata',2,'2024-07-06 08:45:04.091688','2024-07-06 08:45:04.099788',8,'{}','success'),(5473,'sync-table-privileges',2,'2024-07-06 08:45:04.107799','2024-07-06 08:45:04.115957',8,NULL,'success'),(5474,'analyze',2,'2024-07-06 08:45:04.151956','2024-07-06 08:45:05.977902',1825,NULL,'success'),(5475,'fingerprint-fields',2,'2024-07-06 08:45:04.160148','2024-07-06 08:45:05.846175',1686,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5476,'classify-fields',2,'2024-07-06 08:45:05.853765','2024-07-06 08:45:05.951534',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5477,'classify-tables',2,'2024-07-06 08:45:05.958350','2024-07-06 08:45:05.970612',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5478,'sync',2,'2024-07-06 09:45:00.094504','2024-07-06 09:45:04.199435',4104,NULL,'success'),(5479,'sync-dbms-version',2,'2024-07-06 09:45:00.102842','2024-07-06 09:45:00.112922',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5480,'sync-timezone',2,'2024-07-06 09:45:00.121289','2024-07-06 09:45:00.131106',9,'{\"timezone-id\":\"+08:00\"}','success'),(5481,'sync-tables',2,'2024-07-06 09:45:00.139758','2024-07-06 09:45:00.166987',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5482,'sync-fields',2,'2024-07-06 09:45:00.175467','2024-07-06 09:45:03.055293',2879,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5483,'sync-fks',2,'2024-07-06 09:45:03.063345','2024-07-06 09:45:03.653738',590,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5484,'sync-indexes',2,'2024-07-06 09:45:03.662068','2024-07-06 09:45:04.160319',498,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5485,'sync-metabase-metadata',2,'2024-07-06 09:45:04.167400','2024-07-06 09:45:04.175798',8,'{}','success'),(5486,'sync-table-privileges',2,'2024-07-06 09:45:04.183824','2024-07-06 09:45:04.191452',7,NULL,'success'),(5487,'analyze',2,'2024-07-06 09:45:04.223040','2024-07-06 09:45:06.043657',1820,NULL,'success'),(5488,'fingerprint-fields',2,'2024-07-06 09:45:04.230469','2024-07-06 09:45:05.913997',1683,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5489,'classify-fields',2,'2024-07-06 09:45:05.921290','2024-07-06 09:45:06.016000',94,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5490,'classify-tables',2,'2024-07-06 09:45:06.023082','2024-07-06 09:45:06.035915',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5491,'sync',2,'2024-07-06 10:45:00.082450','2024-07-06 10:45:03.925460',3843,NULL,'success'),(5492,'sync-dbms-version',2,'2024-07-06 10:45:00.089738','2024-07-06 10:45:00.098353',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5493,'sync-timezone',2,'2024-07-06 10:45:00.106417','2024-07-06 10:45:00.114518',8,'{\"timezone-id\":\"+08:00\"}','success'),(5494,'sync-tables',2,'2024-07-06 10:45:00.122126','2024-07-06 10:45:00.146070',23,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5495,'sync-fields',2,'2024-07-06 10:45:00.153874','2024-07-06 10:45:02.868643',2714,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5496,'sync-fks',2,'2024-07-06 10:45:02.875933','2024-07-06 10:45:03.419255',543,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5497,'sync-indexes',2,'2024-07-06 10:45:03.427564','2024-07-06 10:45:03.887018',459,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5498,'sync-metabase-metadata',2,'2024-07-06 10:45:03.894197','2024-07-06 10:45:03.901918',7,'{}','success'),(5499,'sync-table-privileges',2,'2024-07-06 10:45:03.909660','2024-07-06 10:45:03.917494',7,NULL,'success'),(5500,'analyze',2,'2024-07-06 10:45:03.948292','2024-07-06 10:45:05.817298',1869,NULL,'success'),(5501,'fingerprint-fields',2,'2024-07-06 10:45:03.956287','2024-07-06 10:45:05.681772',1725,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5502,'classify-fields',2,'2024-07-06 10:45:05.689392','2024-07-06 10:45:05.789991',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5503,'classify-tables',2,'2024-07-06 10:45:05.796881','2024-07-06 10:45:05.808396',11,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5504,'sync',2,'2024-07-06 11:45:00.094515','2024-07-06 11:45:04.184177',4089,NULL,'success'),(5505,'sync-dbms-version',2,'2024-07-06 11:45:00.102800','2024-07-06 11:45:00.111881',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5506,'sync-timezone',2,'2024-07-06 11:45:00.122198','2024-07-06 11:45:00.131976',9,'{\"timezone-id\":\"+08:00\"}','success'),(5507,'sync-tables',2,'2024-07-06 11:45:00.140073','2024-07-06 11:45:00.170282',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5508,'sync-fields',2,'2024-07-06 11:45:00.178197','2024-07-06 11:45:03.116535',2938,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5509,'sync-fks',2,'2024-07-06 11:45:03.124506','2024-07-06 11:45:03.656577',532,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5510,'sync-indexes',2,'2024-07-06 11:45:03.666068','2024-07-06 11:45:04.141862',475,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5511,'sync-metabase-metadata',2,'2024-07-06 11:45:04.149291','2024-07-06 11:45:04.157628',8,'{}','success'),(5512,'sync-table-privileges',2,'2024-07-06 11:45:04.166565','2024-07-06 11:45:04.175494',8,NULL,'success'),(5513,'analyze',2,'2024-07-06 11:45:04.218001','2024-07-06 11:45:06.177926',1959,NULL,'success'),(5514,'fingerprint-fields',2,'2024-07-06 11:45:04.227029','2024-07-06 11:45:06.023686',1796,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5515,'classify-fields',2,'2024-07-06 11:45:06.031598','2024-07-06 11:45:06.149994',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5516,'classify-tables',2,'2024-07-06 11:45:06.157780','2024-07-06 11:45:06.170577',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5517,'sync',2,'2024-07-06 12:45:00.090785','2024-07-06 12:45:04.332846',4242,NULL,'success'),(5518,'sync-dbms-version',2,'2024-07-06 12:45:00.098133','2024-07-06 12:45:00.106154',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5519,'sync-timezone',2,'2024-07-06 12:45:00.113724','2024-07-06 12:45:00.123082',9,'{\"timezone-id\":\"+08:00\"}','success'),(5520,'sync-tables',2,'2024-07-06 12:45:00.130740','2024-07-06 12:45:00.156067',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5521,'sync-fields',2,'2024-07-06 12:45:00.163793','2024-07-06 12:45:03.099073',2935,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5522,'sync-fks',2,'2024-07-06 12:45:03.111217','2024-07-06 12:45:03.757673',646,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5523,'sync-indexes',2,'2024-07-06 12:45:03.766442','2024-07-06 12:45:04.286478',520,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5524,'sync-metabase-metadata',2,'2024-07-06 12:45:04.293677','2024-07-06 12:45:04.302311',8,'{}','success'),(5525,'sync-table-privileges',2,'2024-07-06 12:45:04.311337','2024-07-06 12:45:04.324685',13,NULL,'success'),(5526,'analyze',2,'2024-07-06 12:45:04.357795','2024-07-06 12:45:06.202536',1844,NULL,'success'),(5527,'fingerprint-fields',2,'2024-07-06 12:45:04.365921','2024-07-06 12:45:06.072244',1706,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5528,'classify-fields',2,'2024-07-06 12:45:06.079999','2024-07-06 12:45:06.175620',95,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5529,'classify-tables',2,'2024-07-06 12:45:06.182602','2024-07-06 12:45:06.194864',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5530,'field values scanning',2,'2024-07-06 13:00:00.056299','2024-07-06 13:00:04.376742',4320,NULL,'success'),(5531,'delete-expired-advanced-field-values',2,'2024-07-06 13:00:00.067045','2024-07-06 13:00:03.075984',3008,'{\"deleted\":0}','success'),(5532,'update-field-values',2,'2024-07-06 13:00:03.083633','2024-07-06 13:00:04.368549',1284,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(5533,'sync',2,'2024-07-06 13:45:00.110256','2024-07-06 13:45:04.322109',4211,NULL,'success'),(5534,'sync-dbms-version',2,'2024-07-06 13:45:00.118019','2024-07-06 13:45:00.127424',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5535,'sync-timezone',2,'2024-07-06 13:45:00.135708','2024-07-06 13:45:00.145088',9,'{\"timezone-id\":\"+08:00\"}','success'),(5536,'sync-tables',2,'2024-07-06 13:45:00.154021','2024-07-06 13:45:00.180822',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5537,'sync-fields',2,'2024-07-06 13:45:00.188634','2024-07-06 13:45:03.134127',2945,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5538,'sync-fks',2,'2024-07-06 13:45:03.142520','2024-07-06 13:45:03.749860',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5539,'sync-indexes',2,'2024-07-06 13:45:03.757684','2024-07-06 13:45:04.282968',525,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5540,'sync-metabase-metadata',2,'2024-07-06 13:45:04.290024','2024-07-06 13:45:04.298679',8,'{}','success'),(5541,'sync-table-privileges',2,'2024-07-06 13:45:04.306874','2024-07-06 13:45:04.314511',7,NULL,'success'),(5542,'analyze',2,'2024-07-06 13:45:04.346032','2024-07-06 13:45:06.348656',2002,NULL,'success'),(5543,'fingerprint-fields',2,'2024-07-06 13:45:04.353514','2024-07-06 13:45:06.196006',1842,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5544,'classify-fields',2,'2024-07-06 13:45:06.204215','2024-07-06 13:45:06.320044',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5545,'classify-tables',2,'2024-07-06 13:45:06.327443','2024-07-06 13:45:06.340687',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5546,'sync',2,'2024-07-06 14:45:00.116189','2024-07-06 14:45:04.413166',4296,NULL,'success'),(5547,'sync-dbms-version',2,'2024-07-06 14:45:00.126751','2024-07-06 14:45:00.136998',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5548,'sync-timezone',2,'2024-07-06 14:45:00.146135','2024-07-06 14:45:00.156746',10,'{\"timezone-id\":\"+08:00\"}','success'),(5549,'sync-tables',2,'2024-07-06 14:45:00.165576','2024-07-06 14:45:00.196140',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5550,'sync-fields',2,'2024-07-06 14:45:00.205004','2024-07-06 14:45:03.192655',2987,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5551,'sync-fks',2,'2024-07-06 14:45:03.200845','2024-07-06 14:45:03.792883',592,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5552,'sync-indexes',2,'2024-07-06 14:45:03.803182','2024-07-06 14:45:04.365008',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5553,'sync-metabase-metadata',2,'2024-07-06 14:45:04.375486','2024-07-06 14:45:04.386922',11,'{}','success'),(5554,'sync-table-privileges',2,'2024-07-06 14:45:04.395618','2024-07-06 14:45:04.404862',9,NULL,'success'),(5555,'analyze',2,'2024-07-06 14:45:04.438256','2024-07-06 14:45:06.519404',2081,NULL,'success'),(5556,'fingerprint-fields',2,'2024-07-06 14:45:04.446105','2024-07-06 14:45:06.381197',1935,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5557,'classify-fields',2,'2024-07-06 14:45:06.389167','2024-07-06 14:45:06.491506',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5558,'classify-tables',2,'2024-07-06 14:45:06.498538','2024-07-06 14:45:06.511822',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5559,'sync',2,'2024-07-06 15:45:00.104320','2024-07-06 15:45:04.325879',4221,NULL,'success'),(5560,'sync-dbms-version',2,'2024-07-06 15:45:00.113216','2024-07-06 15:45:00.124677',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5561,'sync-timezone',2,'2024-07-06 15:45:00.133605','2024-07-06 15:45:00.144346',10,'{\"timezone-id\":\"+08:00\"}','success'),(5562,'sync-tables',2,'2024-07-06 15:45:00.153806','2024-07-06 15:45:00.182974',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5563,'sync-fields',2,'2024-07-06 15:45:00.192099','2024-07-06 15:45:03.125462',2933,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5564,'sync-fks',2,'2024-07-06 15:45:03.134220','2024-07-06 15:45:03.732804',598,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5565,'sync-indexes',2,'2024-07-06 15:45:03.740846','2024-07-06 15:45:04.284963',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5566,'sync-metabase-metadata',2,'2024-07-06 15:45:04.292505','2024-07-06 15:45:04.300529',8,'{}','success'),(5567,'sync-table-privileges',2,'2024-07-06 15:45:04.309322','2024-07-06 15:45:04.317998',8,NULL,'success'),(5568,'analyze',2,'2024-07-06 15:45:04.354664','2024-07-06 15:45:06.348727',1994,NULL,'success'),(5569,'fingerprint-fields',2,'2024-07-06 15:45:04.363357','2024-07-06 15:45:06.202306',1838,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5570,'classify-fields',2,'2024-07-06 15:45:06.210166','2024-07-06 15:45:06.318771',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5571,'classify-tables',2,'2024-07-06 15:45:06.326654','2024-07-06 15:45:06.340297',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5572,'task-history-cleanup',NULL,'2024-07-06 16:00:00.012357','2024-07-06 16:00:00.075812',63,NULL,'success'),(5573,'task-history-cleanup',NULL,'2024-07-06 16:00:00.098745','2024-07-06 16:00:00.127270',28,NULL,'success'),(5574,'sync',2,'2024-07-06 16:45:00.111047','2024-07-06 16:45:04.372843',4261,NULL,'success'),(5575,'sync-dbms-version',2,'2024-07-06 16:45:00.119879','2024-07-06 16:45:00.130356',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5576,'sync-timezone',2,'2024-07-06 16:45:00.139145','2024-07-06 16:45:00.149986',10,'{\"timezone-id\":\"+08:00\"}','success'),(5577,'sync-tables',2,'2024-07-06 16:45:00.158601','2024-07-06 16:45:00.184768',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5578,'sync-fields',2,'2024-07-06 16:45:00.193285','2024-07-06 16:45:03.084632',2891,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5579,'sync-fks',2,'2024-07-06 16:45:03.093913','2024-07-06 16:45:03.765269',671,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5580,'sync-indexes',2,'2024-07-06 16:45:03.773506','2024-07-06 16:45:04.334333',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5581,'sync-metabase-metadata',2,'2024-07-06 16:45:04.341992','2024-07-06 16:45:04.349875',7,'{}','success'),(5582,'sync-table-privileges',2,'2024-07-06 16:45:04.357628','2024-07-06 16:45:04.365269',7,NULL,'success'),(5583,'analyze',2,'2024-07-06 16:45:04.396938','2024-07-06 16:45:06.502243',2105,NULL,'success'),(5584,'fingerprint-fields',2,'2024-07-06 16:45:04.405236','2024-07-06 16:45:06.347029',1941,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5585,'classify-fields',2,'2024-07-06 16:45:06.355070','2024-07-06 16:45:06.471298',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5586,'classify-tables',2,'2024-07-06 16:45:06.479894','2024-07-06 16:45:06.493373',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5587,'sync',2,'2024-07-06 17:45:00.123437','2024-07-06 17:45:04.660212',4536,NULL,'success'),(5588,'sync-dbms-version',2,'2024-07-06 17:45:00.131994','2024-07-06 17:45:00.141081',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5589,'sync-timezone',2,'2024-07-06 17:45:00.149711','2024-07-06 17:45:00.161361',11,'{\"timezone-id\":\"+08:00\"}','success'),(5590,'sync-tables',2,'2024-07-06 17:45:00.170993','2024-07-06 17:45:00.198673',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5591,'sync-fields',2,'2024-07-06 17:45:00.207393','2024-07-06 17:45:03.287906',3080,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5592,'sync-fks',2,'2024-07-06 17:45:03.297157','2024-07-06 17:45:03.988949',691,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5593,'sync-indexes',2,'2024-07-06 17:45:03.997481','2024-07-06 17:45:04.616039',618,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5594,'sync-metabase-metadata',2,'2024-07-06 17:45:04.623532','2024-07-06 17:45:04.632333',8,'{}','success'),(5595,'sync-table-privileges',2,'2024-07-06 17:45:04.641715','2024-07-06 17:45:04.651318',9,NULL,'success'),(5596,'analyze',2,'2024-07-06 17:45:04.686115','2024-07-06 17:45:06.997454',2311,NULL,'success'),(5597,'fingerprint-fields',2,'2024-07-06 17:45:04.695970','2024-07-06 17:45:06.841345',2145,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5598,'classify-fields',2,'2024-07-06 17:45:06.849984','2024-07-06 17:45:06.964854',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5599,'classify-tables',2,'2024-07-06 17:45:06.972457','2024-07-06 17:45:06.988680',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5600,'sync',2,'2024-07-06 18:45:00.115089','2024-07-06 18:45:04.682327',4567,NULL,'success'),(5601,'sync-dbms-version',2,'2024-07-06 18:45:00.123351','2024-07-06 18:45:00.132515',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5602,'sync-timezone',2,'2024-07-06 18:45:00.141416','2024-07-06 18:45:00.154326',12,'{\"timezone-id\":\"+08:00\"}','success'),(5603,'sync-tables',2,'2024-07-06 18:45:00.163645','2024-07-06 18:45:00.190044',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5604,'sync-fields',2,'2024-07-06 18:45:00.198433','2024-07-06 18:45:03.286027',3087,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5605,'sync-fks',2,'2024-07-06 18:45:03.296122','2024-07-06 18:45:03.962941',666,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5606,'sync-indexes',2,'2024-07-06 18:45:03.972091','2024-07-06 18:45:04.642438',670,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5607,'sync-metabase-metadata',2,'2024-07-06 18:45:04.650358','2024-07-06 18:45:04.658327',7,'{}','success'),(5608,'sync-table-privileges',2,'2024-07-06 18:45:04.666358','2024-07-06 18:45:04.674698',8,NULL,'success'),(5609,'analyze',2,'2024-07-06 18:45:04.707699','2024-07-06 18:45:06.909903',2202,NULL,'success'),(5610,'fingerprint-fields',2,'2024-07-06 18:45:04.717209','2024-07-06 18:45:06.760701',2043,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5611,'classify-fields',2,'2024-07-06 18:45:06.768426','2024-07-06 18:45:06.880296',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5612,'classify-tables',2,'2024-07-06 18:45:06.887848','2024-07-06 18:45:06.901697',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5613,'sync',2,'2024-07-06 19:45:00.098384','2024-07-06 19:45:04.592909',4494,NULL,'success'),(5614,'sync-dbms-version',2,'2024-07-06 19:45:00.108548','2024-07-06 19:45:00.118991',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5615,'sync-timezone',2,'2024-07-06 19:45:00.129648','2024-07-06 19:45:00.140628',10,'{\"timezone-id\":\"+08:00\"}','success'),(5616,'sync-tables',2,'2024-07-06 19:45:00.150343','2024-07-06 19:45:00.190218',39,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5617,'sync-fields',2,'2024-07-06 19:45:00.200496','2024-07-06 19:45:03.274754',3074,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5618,'sync-fks',2,'2024-07-06 19:45:03.284036','2024-07-06 19:45:03.920466',636,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5619,'sync-indexes',2,'2024-07-06 19:45:03.930316','2024-07-06 19:45:04.547976',617,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5620,'sync-metabase-metadata',2,'2024-07-06 19:45:04.556003','2024-07-06 19:45:04.565422',9,'{}','success'),(5621,'sync-table-privileges',2,'2024-07-06 19:45:04.575743','2024-07-06 19:45:04.584834',9,NULL,'success'),(5622,'analyze',2,'2024-07-06 19:45:04.618670','2024-07-06 19:45:06.736012',2117,NULL,'success'),(5623,'fingerprint-fields',2,'2024-07-06 19:45:04.627108','2024-07-06 19:45:06.580502',1953,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5624,'classify-fields',2,'2024-07-06 19:45:06.589694','2024-07-06 19:45:06.705459',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5625,'classify-tables',2,'2024-07-06 19:45:06.712881','2024-07-06 19:45:06.726676',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5626,'sync',2,'2024-07-06 20:45:00.116957','2024-07-06 20:45:04.525061',4408,NULL,'success'),(5627,'sync-dbms-version',2,'2024-07-06 20:45:00.126383','2024-07-06 20:45:00.135422',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5628,'sync-timezone',2,'2024-07-06 20:45:00.144452','2024-07-06 20:45:00.155968',11,'{\"timezone-id\":\"+08:00\"}','success'),(5629,'sync-tables',2,'2024-07-06 20:45:00.164567','2024-07-06 20:45:00.191287',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5630,'sync-fields',2,'2024-07-06 20:45:00.199556','2024-07-06 20:45:03.238208',3038,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5631,'sync-fks',2,'2024-07-06 20:45:03.246518','2024-07-06 20:45:03.877521',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5632,'sync-indexes',2,'2024-07-06 20:45:03.886167','2024-07-06 20:45:04.479836',593,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5633,'sync-metabase-metadata',2,'2024-07-06 20:45:04.487846','2024-07-06 20:45:04.498081',10,'{}','success'),(5634,'sync-table-privileges',2,'2024-07-06 20:45:04.506718','2024-07-06 20:45:04.516204',9,NULL,'success'),(5635,'analyze',2,'2024-07-06 20:45:04.550444','2024-07-06 20:45:06.567114',2016,NULL,'success'),(5636,'fingerprint-fields',2,'2024-07-06 20:45:04.558595','2024-07-06 20:45:06.420961',1862,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5637,'classify-fields',2,'2024-07-06 20:45:06.428716','2024-07-06 20:45:06.538498',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5638,'classify-tables',2,'2024-07-06 20:45:06.546052','2024-07-06 20:45:06.559399',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5639,'sync',2,'2024-07-06 21:45:00.094531','2024-07-06 21:45:05.082248',4987,NULL,'success'),(5640,'sync-dbms-version',2,'2024-07-06 21:45:00.101974','2024-07-06 21:45:00.110680',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5641,'sync-timezone',2,'2024-07-06 21:45:00.118398','2024-07-06 21:45:00.127468',9,'{\"timezone-id\":\"+08:00\"}','success'),(5642,'sync-tables',2,'2024-07-06 21:45:00.136010','2024-07-06 21:45:00.165120',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5643,'sync-fields',2,'2024-07-06 21:45:00.174182','2024-07-06 21:45:03.074415',2900,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5644,'sync-fks',2,'2024-07-06 21:45:03.083308','2024-07-06 21:45:03.684135',600,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5645,'sync-indexes',2,'2024-07-06 21:45:03.691869','2024-07-06 21:45:05.037229',1345,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5646,'sync-metabase-metadata',2,'2024-07-06 21:45:05.045305','2024-07-06 21:45:05.054722',9,'{}','success'),(5647,'sync-table-privileges',2,'2024-07-06 21:45:05.064427','2024-07-06 21:45:05.073395',8,NULL,'success'),(5648,'analyze',2,'2024-07-06 21:45:05.107994','2024-07-06 21:45:07.206471',2098,NULL,'success'),(5649,'fingerprint-fields',2,'2024-07-06 21:45:05.116726','2024-07-06 21:45:07.055038',1938,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5650,'classify-fields',2,'2024-07-06 21:45:07.063388','2024-07-06 21:45:07.176073',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5651,'classify-tables',2,'2024-07-06 21:45:07.183809','2024-07-06 21:45:07.198255',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5652,'sync',2,'2024-07-06 22:45:00.114601','2024-07-06 22:45:04.604254',4489,NULL,'success'),(5653,'sync-dbms-version',2,'2024-07-06 22:45:00.124300','2024-07-06 22:45:00.133878',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5654,'sync-timezone',2,'2024-07-06 22:45:00.142290','2024-07-06 22:45:00.152660',10,'{\"timezone-id\":\"+08:00\"}','success'),(5655,'sync-tables',2,'2024-07-06 22:45:00.161342','2024-07-06 22:45:00.187768',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5656,'sync-fields',2,'2024-07-06 22:45:00.196246','2024-07-06 22:45:03.272027',3075,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5657,'sync-fks',2,'2024-07-06 22:45:03.279899','2024-07-06 22:45:03.934081',654,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5658,'sync-indexes',2,'2024-07-06 22:45:03.943171','2024-07-06 22:45:04.555858',612,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5659,'sync-metabase-metadata',2,'2024-07-06 22:45:04.565767','2024-07-06 22:45:04.575493',9,'{}','success'),(5660,'sync-table-privileges',2,'2024-07-06 22:45:04.584526','2024-07-06 22:45:04.595293',10,NULL,'success'),(5661,'analyze',2,'2024-07-06 22:45:04.629733','2024-07-06 22:45:06.705659',2075,NULL,'success'),(5662,'fingerprint-fields',2,'2024-07-06 22:45:04.638182','2024-07-06 22:45:06.555245',1917,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5663,'classify-fields',2,'2024-07-06 22:45:06.563800','2024-07-06 22:45:06.677531',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5664,'classify-tables',2,'2024-07-06 22:45:06.685167','2024-07-06 22:45:06.698002',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5665,'sync',2,'2024-07-06 23:45:00.129456','2024-07-06 23:45:04.815236',4685,NULL,'success'),(5666,'sync-dbms-version',2,'2024-07-06 23:45:00.138236','2024-07-06 23:45:00.148682',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5667,'sync-timezone',2,'2024-07-06 23:45:00.158058','2024-07-06 23:45:00.169545',11,'{\"timezone-id\":\"+08:00\"}','success'),(5668,'sync-tables',2,'2024-07-06 23:45:00.178012','2024-07-06 23:45:00.207464',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5669,'sync-fields',2,'2024-07-06 23:45:00.233101','2024-07-06 23:45:03.475560',3242,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5670,'sync-fks',2,'2024-07-06 23:45:03.484562','2024-07-06 23:45:04.179770',695,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5671,'sync-indexes',2,'2024-07-06 23:45:04.189485','2024-07-06 23:45:04.772477',582,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5672,'sync-metabase-metadata',2,'2024-07-06 23:45:04.780373','2024-07-06 23:45:04.788527',8,'{}','success'),(5673,'sync-table-privileges',2,'2024-07-06 23:45:04.796871','2024-07-06 23:45:04.806239',9,NULL,'success'),(5674,'analyze',2,'2024-07-06 23:45:04.840747','2024-07-06 23:45:06.970887',2130,NULL,'success'),(5675,'fingerprint-fields',2,'2024-07-06 23:45:04.848929','2024-07-06 23:45:06.818217',1969,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5676,'classify-fields',2,'2024-07-06 23:45:06.826430','2024-07-06 23:45:06.937954',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5677,'classify-tables',2,'2024-07-06 23:45:06.946643','2024-07-06 23:45:06.960746',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5678,'sync',2,'2024-07-07 00:45:00.096495','2024-07-07 00:45:04.165473',4068,NULL,'success'),(5679,'sync-dbms-version',2,'2024-07-07 00:45:00.104325','2024-07-07 00:45:00.113759',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5680,'sync-timezone',2,'2024-07-07 00:45:00.121792','2024-07-07 00:45:00.131498',9,'{\"timezone-id\":\"+08:00\"}','success'),(5681,'sync-tables',2,'2024-07-07 00:45:00.140077','2024-07-07 00:45:00.171464',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5682,'sync-fields',2,'2024-07-07 00:45:00.185479','2024-07-07 00:45:03.001739',2816,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5683,'sync-fks',2,'2024-07-07 00:45:03.009279','2024-07-07 00:45:03.585495',576,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5684,'sync-indexes',2,'2024-07-07 00:45:03.593834','2024-07-07 00:45:04.123467',529,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5685,'sync-metabase-metadata',2,'2024-07-07 00:45:04.131394','2024-07-07 00:45:04.141398',10,'{}','success'),(5686,'sync-table-privileges',2,'2024-07-07 00:45:04.149339','2024-07-07 00:45:04.157179',7,NULL,'success'),(5687,'analyze',2,'2024-07-07 00:45:04.193128','2024-07-07 00:45:06.161277',1968,NULL,'success'),(5688,'fingerprint-fields',2,'2024-07-07 00:45:04.201789','2024-07-07 00:45:06.012594',1810,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5689,'classify-fields',2,'2024-07-07 00:45:06.021008','2024-07-07 00:45:06.131902',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5690,'classify-tables',2,'2024-07-07 00:45:06.139416','2024-07-07 00:45:06.152918',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5691,'sync',2,'2024-07-07 01:45:00.090962','2024-07-07 01:45:04.040626',3949,NULL,'success'),(5692,'sync-dbms-version',2,'2024-07-07 01:45:00.099407','2024-07-07 01:45:00.107679',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5693,'sync-timezone',2,'2024-07-07 01:45:00.116141','2024-07-07 01:45:00.125979',9,'{\"timezone-id\":\"+08:00\"}','success'),(5694,'sync-tables',2,'2024-07-07 01:45:00.135111','2024-07-07 01:45:00.165862',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5695,'sync-fields',2,'2024-07-07 01:45:00.174508','2024-07-07 01:45:02.915116',2740,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5696,'sync-fks',2,'2024-07-07 01:45:02.922705','2024-07-07 01:45:03.481862',559,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5697,'sync-indexes',2,'2024-07-07 01:45:03.489444','2024-07-07 01:45:04.002110',512,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5698,'sync-metabase-metadata',2,'2024-07-07 01:45:04.009152','2024-07-07 01:45:04.017129',7,'{}','success'),(5699,'sync-table-privileges',2,'2024-07-07 01:45:04.025092','2024-07-07 01:45:04.033164',8,NULL,'success'),(5700,'analyze',2,'2024-07-07 01:45:04.063855','2024-07-07 01:45:05.973637',1909,NULL,'success'),(5701,'fingerprint-fields',2,'2024-07-07 01:45:04.072261','2024-07-07 01:45:05.820131',1747,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5702,'classify-fields',2,'2024-07-07 01:45:05.828048','2024-07-07 01:45:05.941741',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5703,'classify-tables',2,'2024-07-07 01:45:05.950141','2024-07-07 01:45:05.965138',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5704,'sync',2,'2024-07-07 02:45:00.109012','2024-07-07 02:45:04.456878',4347,NULL,'success'),(5705,'sync-dbms-version',2,'2024-07-07 02:45:00.116966','2024-07-07 02:45:00.125795',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5706,'sync-timezone',2,'2024-07-07 02:45:00.134605','2024-07-07 02:45:00.147381',12,'{\"timezone-id\":\"+08:00\"}','success'),(5707,'sync-tables',2,'2024-07-07 02:45:00.156403','2024-07-07 02:45:00.187097',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5708,'sync-fields',2,'2024-07-07 02:45:00.196021','2024-07-07 02:45:03.247352',3051,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5709,'sync-fks',2,'2024-07-07 02:45:03.255032','2024-07-07 02:45:03.914012',658,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5710,'sync-indexes',2,'2024-07-07 02:45:03.922174','2024-07-07 02:45:04.418111',495,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5711,'sync-metabase-metadata',2,'2024-07-07 02:45:04.425478','2024-07-07 02:45:04.433232',7,'{}','success'),(5712,'sync-table-privileges',2,'2024-07-07 02:45:04.440952','2024-07-07 02:45:04.449007',8,NULL,'success'),(5713,'analyze',2,'2024-07-07 02:45:04.487219','2024-07-07 02:45:06.628337',2141,NULL,'success'),(5714,'fingerprint-fields',2,'2024-07-07 02:45:04.495636','2024-07-07 02:45:06.473774',1978,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5715,'classify-fields',2,'2024-07-07 02:45:06.484136','2024-07-07 02:45:06.597419',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5716,'classify-tables',2,'2024-07-07 02:45:06.605356','2024-07-07 02:45:06.619308',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5717,'sync',2,'2024-07-07 03:45:00.117370','2024-07-07 03:45:04.810103',4692,NULL,'success'),(5718,'sync-dbms-version',2,'2024-07-07 03:45:00.125440','2024-07-07 03:45:00.137164',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5719,'sync-timezone',2,'2024-07-07 03:45:00.145652','2024-07-07 03:45:00.156194',10,'{\"timezone-id\":\"+08:00\"}','success'),(5720,'sync-tables',2,'2024-07-07 03:45:00.166811','2024-07-07 03:45:00.197382',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5721,'sync-fields',2,'2024-07-07 03:45:00.207117','2024-07-07 03:45:03.450840',3243,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5722,'sync-fks',2,'2024-07-07 03:45:03.459152','2024-07-07 03:45:04.153411',694,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5723,'sync-indexes',2,'2024-07-07 03:45:04.162638','2024-07-07 03:45:04.767404',604,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5724,'sync-metabase-metadata',2,'2024-07-07 03:45:04.775771','2024-07-07 03:45:04.784698',8,'{}','success'),(5725,'sync-table-privileges',2,'2024-07-07 03:45:04.792880','2024-07-07 03:45:04.801764',8,NULL,'success'),(5726,'analyze',2,'2024-07-07 03:45:04.834681','2024-07-07 03:45:06.834749',2000,NULL,'success'),(5727,'fingerprint-fields',2,'2024-07-07 03:45:04.843577','2024-07-07 03:45:06.690519',1846,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5728,'classify-fields',2,'2024-07-07 03:45:06.698055','2024-07-07 03:45:06.805419',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5729,'classify-tables',2,'2024-07-07 03:45:06.812759','2024-07-07 03:45:06.826150',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5730,'task-history-cleanup',NULL,'2024-07-07 04:00:00.085758','2024-07-07 04:00:00.105151',19,NULL,'success'),(5731,'sync',2,'2024-07-07 04:45:00.096618','2024-07-07 04:45:04.531152',4434,NULL,'success'),(5732,'sync-dbms-version',2,'2024-07-07 04:45:00.104220','2024-07-07 04:45:00.113174',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5733,'sync-timezone',2,'2024-07-07 04:45:00.121388','2024-07-07 04:45:00.132314',10,'{\"timezone-id\":\"+08:00\"}','success'),(5734,'sync-tables',2,'2024-07-07 04:45:00.140573','2024-07-07 04:45:00.172397',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5735,'sync-fields',2,'2024-07-07 04:45:00.182699','2024-07-07 04:45:03.166940',2984,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5736,'sync-fks',2,'2024-07-07 04:45:03.175436','2024-07-07 04:45:03.874013',698,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5737,'sync-indexes',2,'2024-07-07 04:45:03.883187','2024-07-07 04:45:04.483858',600,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5738,'sync-metabase-metadata',2,'2024-07-07 04:45:04.492216','2024-07-07 04:45:04.502275',10,'{}','success'),(5739,'sync-table-privileges',2,'2024-07-07 04:45:04.511938','2024-07-07 04:45:04.522124',10,NULL,'success'),(5740,'analyze',2,'2024-07-07 04:45:04.559689','2024-07-07 04:45:06.796734',2237,NULL,'success'),(5741,'fingerprint-fields',2,'2024-07-07 04:45:04.569807','2024-07-07 04:45:06.631479',2061,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5742,'classify-fields',2,'2024-07-07 04:45:06.640399','2024-07-07 04:45:06.764697',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5743,'classify-tables',2,'2024-07-07 04:45:06.772860','2024-07-07 04:45:06.788393',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5744,'sync',2,'2024-07-07 05:45:00.105913','2024-07-07 05:45:04.638255',4532,NULL,'success'),(5745,'sync-dbms-version',2,'2024-07-07 05:45:00.114034','2024-07-07 05:45:00.123923',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5746,'sync-timezone',2,'2024-07-07 05:45:00.132478','2024-07-07 05:45:00.144088',11,'{\"timezone-id\":\"+08:00\"}','success'),(5747,'sync-tables',2,'2024-07-07 05:45:00.152784','2024-07-07 05:45:00.183553',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5748,'sync-fields',2,'2024-07-07 05:45:00.192397','2024-07-07 05:45:03.401236',3208,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5749,'sync-fks',2,'2024-07-07 05:45:03.410083','2024-07-07 05:45:04.074758',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5750,'sync-indexes',2,'2024-07-07 05:45:04.083238','2024-07-07 05:45:04.596157',512,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5751,'sync-metabase-metadata',2,'2024-07-07 05:45:04.603425','2024-07-07 05:45:04.611870',8,'{}','success'),(5752,'sync-table-privileges',2,'2024-07-07 05:45:04.620656','2024-07-07 05:45:04.630096',9,NULL,'success'),(5753,'analyze',2,'2024-07-07 05:45:04.663017','2024-07-07 05:45:06.690722',2027,NULL,'success'),(5754,'fingerprint-fields',2,'2024-07-07 05:45:04.670989','2024-07-07 05:45:06.535291',1864,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5755,'classify-fields',2,'2024-07-07 05:45:06.543328','2024-07-07 05:45:06.660782',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5756,'classify-tables',2,'2024-07-07 05:45:06.668140','2024-07-07 05:45:06.681744',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5757,'sync',2,'2024-07-07 06:45:00.112958','2024-07-07 06:45:04.708530',4595,NULL,'success'),(5758,'sync-dbms-version',2,'2024-07-07 06:45:00.121199','2024-07-07 06:45:00.131200',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5759,'sync-timezone',2,'2024-07-07 06:45:00.140246','2024-07-07 06:45:00.152723',12,'{\"timezone-id\":\"+08:00\"}','success'),(5760,'sync-tables',2,'2024-07-07 06:45:00.161817','2024-07-07 06:45:00.192265',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5761,'sync-fields',2,'2024-07-07 06:45:00.201714','2024-07-07 06:45:03.397267',3195,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5762,'sync-fks',2,'2024-07-07 06:45:03.407597','2024-07-07 06:45:04.052085',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5763,'sync-indexes',2,'2024-07-07 06:45:04.061968','2024-07-07 06:45:04.663154',601,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5764,'sync-metabase-metadata',2,'2024-07-07 06:45:04.671322','2024-07-07 06:45:04.682111',10,'{}','success'),(5765,'sync-table-privileges',2,'2024-07-07 06:45:04.691334','2024-07-07 06:45:04.699959',8,NULL,'success'),(5766,'analyze',2,'2024-07-07 06:45:04.733537','2024-07-07 06:45:06.825475',2091,NULL,'success'),(5767,'fingerprint-fields',2,'2024-07-07 06:45:04.741624','2024-07-07 06:45:06.663975',1922,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5768,'classify-fields',2,'2024-07-07 06:45:06.673415','2024-07-07 06:45:06.795329',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5769,'classify-tables',2,'2024-07-07 06:45:06.803003','2024-07-07 06:45:06.817128',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5770,'sync',2,'2024-07-07 07:45:00.100547','2024-07-07 07:45:04.525758',4425,NULL,'success'),(5771,'sync-dbms-version',2,'2024-07-07 07:45:00.109861','2024-07-07 07:45:00.120295',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5772,'sync-timezone',2,'2024-07-07 07:45:00.129712','2024-07-07 07:45:00.140713',11,'{\"timezone-id\":\"+08:00\"}','success'),(5773,'sync-tables',2,'2024-07-07 07:45:00.151290','2024-07-07 07:45:00.181818',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5774,'sync-fields',2,'2024-07-07 07:45:00.191345','2024-07-07 07:45:03.153227',2961,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5775,'sync-fks',2,'2024-07-07 07:45:03.161260','2024-07-07 07:45:03.866282',705,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5776,'sync-indexes',2,'2024-07-07 07:45:03.875538','2024-07-07 07:45:04.479249',603,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5777,'sync-metabase-metadata',2,'2024-07-07 07:45:04.486944','2024-07-07 07:45:04.497077',10,'{}','success'),(5778,'sync-table-privileges',2,'2024-07-07 07:45:04.506622','2024-07-07 07:45:04.516758',10,NULL,'success'),(5779,'analyze',2,'2024-07-07 07:45:04.554447','2024-07-07 07:45:06.682865',2128,NULL,'success'),(5780,'fingerprint-fields',2,'2024-07-07 07:45:04.562828','2024-07-07 07:45:06.540142',1977,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5781,'classify-fields',2,'2024-07-07 07:45:06.548347','2024-07-07 07:45:06.655182',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5782,'classify-tables',2,'2024-07-07 07:45:06.662977','2024-07-07 07:45:06.675293',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5783,'sync',2,'2024-07-07 08:45:00.092599','2024-07-07 08:45:04.275350',4182,NULL,'success'),(5784,'sync-dbms-version',2,'2024-07-07 08:45:00.101144','2024-07-07 08:45:00.110633',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5785,'sync-timezone',2,'2024-07-07 08:45:00.118945','2024-07-07 08:45:00.129692',10,'{\"timezone-id\":\"+08:00\"}','success'),(5786,'sync-tables',2,'2024-07-07 08:45:00.137567','2024-07-07 08:45:00.162864',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5787,'sync-fields',2,'2024-07-07 08:45:00.170855','2024-07-07 08:45:03.119314',2948,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5788,'sync-fks',2,'2024-07-07 08:45:03.127188','2024-07-07 08:45:03.730327',603,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5789,'sync-indexes',2,'2024-07-07 08:45:03.739025','2024-07-07 08:45:04.236811',497,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5790,'sync-metabase-metadata',2,'2024-07-07 08:45:04.244139','2024-07-07 08:45:04.252482',8,'{}','success'),(5791,'sync-table-privileges',2,'2024-07-07 08:45:04.259840','2024-07-07 08:45:04.267513',7,NULL,'success'),(5792,'analyze',2,'2024-07-07 08:45:04.298529','2024-07-07 08:45:06.204061',1905,NULL,'success'),(5793,'fingerprint-fields',2,'2024-07-07 08:45:04.306099','2024-07-07 08:45:06.065839',1759,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5794,'classify-fields',2,'2024-07-07 08:45:06.073748','2024-07-07 08:45:06.175423',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5795,'classify-tables',2,'2024-07-07 08:45:06.183101','2024-07-07 08:45:06.195883',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5796,'sync',2,'2024-07-07 09:45:00.087575','2024-07-07 09:45:03.849980',3762,NULL,'success'),(5797,'sync-dbms-version',2,'2024-07-07 09:45:00.094845','2024-07-07 09:45:00.103511',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5798,'sync-timezone',2,'2024-07-07 09:45:00.111046','2024-07-07 09:45:00.120743',9,'{\"timezone-id\":\"+08:00\"}','success'),(5799,'sync-tables',2,'2024-07-07 09:45:00.129927','2024-07-07 09:45:00.160414',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5800,'sync-fields',2,'2024-07-07 09:45:00.168674','2024-07-07 09:45:02.773940',2605,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5801,'sync-fks',2,'2024-07-07 09:45:02.780909','2024-07-07 09:45:03.333823',552,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5802,'sync-indexes',2,'2024-07-07 09:45:03.341609','2024-07-07 09:45:03.810541',468,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5803,'sync-metabase-metadata',2,'2024-07-07 09:45:03.818504','2024-07-07 09:45:03.826989',8,'{}','success'),(5804,'sync-table-privileges',2,'2024-07-07 09:45:03.834533','2024-07-07 09:45:03.842716',8,NULL,'success'),(5805,'analyze',2,'2024-07-07 09:45:03.874838','2024-07-07 09:45:05.677719',1802,NULL,'success'),(5806,'fingerprint-fields',2,'2024-07-07 09:45:03.882274','2024-07-07 09:45:05.541985',1659,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5807,'classify-fields',2,'2024-07-07 09:45:05.549290','2024-07-07 09:45:05.651183',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5808,'classify-tables',2,'2024-07-07 09:45:05.658848','2024-07-07 09:45:05.670273',11,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5809,'sync',2,'2024-07-07 10:45:00.094673','2024-07-07 10:45:04.289673',4195,NULL,'success'),(5810,'sync-dbms-version',2,'2024-07-07 10:45:00.102762','2024-07-07 10:45:00.112021',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5811,'sync-timezone',2,'2024-07-07 10:45:00.120285','2024-07-07 10:45:00.130533',10,'{\"timezone-id\":\"+08:00\"}','success'),(5812,'sync-tables',2,'2024-07-07 10:45:00.138627','2024-07-07 10:45:00.164017',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5813,'sync-fields',2,'2024-07-07 10:45:00.172741','2024-07-07 10:45:03.121385',2948,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5814,'sync-fks',2,'2024-07-07 10:45:03.129711','2024-07-07 10:45:03.746346',616,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5815,'sync-indexes',2,'2024-07-07 10:45:03.754500','2024-07-07 10:45:04.250737',496,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5816,'sync-metabase-metadata',2,'2024-07-07 10:45:04.258175','2024-07-07 10:45:04.265772',7,'{}','success'),(5817,'sync-table-privileges',2,'2024-07-07 10:45:04.273864','2024-07-07 10:45:04.282222',8,NULL,'success'),(5818,'analyze',2,'2024-07-07 10:45:04.312359','2024-07-07 10:45:06.297394',1985,NULL,'success'),(5819,'fingerprint-fields',2,'2024-07-07 10:45:04.321336','2024-07-07 10:45:06.138917',1817,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5820,'classify-fields',2,'2024-07-07 10:45:06.147068','2024-07-07 10:45:06.263562',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5821,'classify-tables',2,'2024-07-07 10:45:06.271847','2024-07-07 10:45:06.288623',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5822,'sync',2,'2024-07-07 11:45:00.107513','2024-07-07 11:45:04.099563',3992,NULL,'success'),(5823,'sync-dbms-version',2,'2024-07-07 11:45:00.115637','2024-07-07 11:45:00.124491',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5824,'sync-timezone',2,'2024-07-07 11:45:00.134182','2024-07-07 11:45:00.143953',9,'{\"timezone-id\":\"+08:00\"}','success'),(5825,'sync-tables',2,'2024-07-07 11:45:00.152425','2024-07-07 11:45:00.180136',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5826,'sync-fields',2,'2024-07-07 11:45:00.190664','2024-07-07 11:45:03.030648',2839,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5827,'sync-fks',2,'2024-07-07 11:45:03.038162','2024-07-07 11:45:03.603483',565,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5828,'sync-indexes',2,'2024-07-07 11:45:03.611801','2024-07-07 11:45:04.057721',445,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5829,'sync-metabase-metadata',2,'2024-07-07 11:45:04.065535','2024-07-07 11:45:04.073633',8,'{}','success'),(5830,'sync-table-privileges',2,'2024-07-07 11:45:04.083749','2024-07-07 11:45:04.091893',8,NULL,'success'),(5831,'analyze',2,'2024-07-07 11:45:04.125182','2024-07-07 11:45:05.984749',1859,NULL,'success'),(5832,'fingerprint-fields',2,'2024-07-07 11:45:04.132780','2024-07-07 11:45:05.845485',1712,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5833,'classify-fields',2,'2024-07-07 11:45:05.853465','2024-07-07 11:45:05.955120',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5834,'classify-tables',2,'2024-07-07 11:45:05.963110','2024-07-07 11:45:05.976521',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5835,'sync',2,'2024-07-07 12:45:00.101885','2024-07-07 12:45:04.160030',4058,NULL,'success'),(5836,'sync-dbms-version',2,'2024-07-07 12:45:00.110002','2024-07-07 12:45:00.119983',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5837,'sync-timezone',2,'2024-07-07 12:45:00.127895','2024-07-07 12:45:00.137371',9,'{\"timezone-id\":\"+08:00\"}','success'),(5838,'sync-tables',2,'2024-07-07 12:45:00.145177','2024-07-07 12:45:00.171093',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5839,'sync-fields',2,'2024-07-07 12:45:00.178776','2024-07-07 12:45:02.994020',2815,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5840,'sync-fks',2,'2024-07-07 12:45:03.001817','2024-07-07 12:45:03.586828',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5841,'sync-indexes',2,'2024-07-07 12:45:03.595054','2024-07-07 12:45:04.113494',518,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5842,'sync-metabase-metadata',2,'2024-07-07 12:45:04.122484','2024-07-07 12:45:04.132523',10,'{}','success'),(5843,'sync-table-privileges',2,'2024-07-07 12:45:04.141687','2024-07-07 12:45:04.150286',8,NULL,'success'),(5844,'analyze',2,'2024-07-07 12:45:04.187594','2024-07-07 12:45:06.147793',1960,NULL,'success'),(5845,'fingerprint-fields',2,'2024-07-07 12:45:04.196869','2024-07-07 12:45:05.999846',1802,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5846,'classify-fields',2,'2024-07-07 12:45:06.008170','2024-07-07 12:45:06.117689',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5847,'classify-tables',2,'2024-07-07 12:45:06.125233','2024-07-07 12:45:06.139299',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5848,'field values scanning',2,'2024-07-07 13:00:00.046815','2024-07-07 13:00:04.031802',3984,NULL,'success'),(5849,'delete-expired-advanced-field-values',2,'2024-07-07 13:00:00.058016','2024-07-07 13:00:02.850853',2792,'{\"deleted\":0}','success'),(5850,'update-field-values',2,'2024-07-07 13:00:02.858173','2024-07-07 13:00:04.023916',1165,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(5851,'sync',2,'2024-07-07 13:45:00.094459','2024-07-07 13:45:03.945194',3850,NULL,'success'),(5852,'sync-dbms-version',2,'2024-07-07 13:45:00.101988','2024-07-07 13:45:00.112061',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5853,'sync-timezone',2,'2024-07-07 13:45:00.120114','2024-07-07 13:45:00.130670',10,'{\"timezone-id\":\"+08:00\"}','success'),(5854,'sync-tables',2,'2024-07-07 13:45:00.140462','2024-07-07 13:45:00.165436',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5855,'sync-fields',2,'2024-07-07 13:45:00.173675','2024-07-07 13:45:02.897064',2723,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5856,'sync-fks',2,'2024-07-07 13:45:02.904515','2024-07-07 13:45:03.440060',535,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5857,'sync-indexes',2,'2024-07-07 13:45:03.447658','2024-07-07 13:45:03.906966',459,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5858,'sync-metabase-metadata',2,'2024-07-07 13:45:03.914573','2024-07-07 13:45:03.922136',7,'{}','success'),(5859,'sync-table-privileges',2,'2024-07-07 13:45:03.929608','2024-07-07 13:45:03.937504',7,NULL,'success'),(5860,'analyze',2,'2024-07-07 13:45:03.968524','2024-07-07 13:45:05.821062',1852,NULL,'success'),(5861,'fingerprint-fields',2,'2024-07-07 13:45:03.975793','2024-07-07 13:45:05.671828',1696,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5862,'classify-fields',2,'2024-07-07 13:45:05.681117','2024-07-07 13:45:05.790474',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5863,'classify-tables',2,'2024-07-07 13:45:05.798096','2024-07-07 13:45:05.811692',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5864,'sync',2,'2024-07-07 14:45:00.104546','2024-07-07 14:45:04.223330',4118,NULL,'success'),(5865,'sync-dbms-version',2,'2024-07-07 14:45:00.112693','2024-07-07 14:45:00.123202',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5866,'sync-timezone',2,'2024-07-07 14:45:00.131741','2024-07-07 14:45:00.141444',9,'{\"timezone-id\":\"+08:00\"}','success'),(5867,'sync-tables',2,'2024-07-07 14:45:00.151168','2024-07-07 14:45:00.176356',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5868,'sync-fields',2,'2024-07-07 14:45:00.184414','2024-07-07 14:45:03.014618',2830,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5869,'sync-fks',2,'2024-07-07 14:45:03.022221','2024-07-07 14:45:03.663686',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5870,'sync-indexes',2,'2024-07-07 14:45:03.672387','2024-07-07 14:45:04.182084',509,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5871,'sync-metabase-metadata',2,'2024-07-07 14:45:04.189494','2024-07-07 14:45:04.197969',8,'{}','success'),(5872,'sync-table-privileges',2,'2024-07-07 14:45:04.207092','2024-07-07 14:45:04.215035',7,NULL,'success'),(5873,'analyze',2,'2024-07-07 14:45:04.247369','2024-07-07 14:45:06.293529',2046,NULL,'success'),(5874,'fingerprint-fields',2,'2024-07-07 14:45:04.256219','2024-07-07 14:45:06.138321',1882,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5875,'classify-fields',2,'2024-07-07 14:45:06.147043','2024-07-07 14:45:06.262381',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5876,'classify-tables',2,'2024-07-07 14:45:06.270036','2024-07-07 14:45:06.284457',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5877,'sync',2,'2024-07-07 15:45:00.103096','2024-07-07 15:45:04.351706',4248,NULL,'success'),(5878,'sync-dbms-version',2,'2024-07-07 15:45:00.111372','2024-07-07 15:45:00.121559',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5879,'sync-timezone',2,'2024-07-07 15:45:00.130598','2024-07-07 15:45:00.140097',9,'{\"timezone-id\":\"+08:00\"}','success'),(5880,'sync-tables',2,'2024-07-07 15:45:00.149027','2024-07-07 15:45:00.175633',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5881,'sync-fields',2,'2024-07-07 15:45:00.184457','2024-07-07 15:45:03.112402',2927,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5882,'sync-fks',2,'2024-07-07 15:45:03.121245','2024-07-07 15:45:03.766020',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5883,'sync-indexes',2,'2024-07-07 15:45:03.775270','2024-07-07 15:45:04.309377',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5884,'sync-metabase-metadata',2,'2024-07-07 15:45:04.316983','2024-07-07 15:45:04.325072',8,'{}','success'),(5885,'sync-table-privileges',2,'2024-07-07 15:45:04.334004','2024-07-07 15:45:04.343319',9,NULL,'success'),(5886,'analyze',2,'2024-07-07 15:45:04.376013','2024-07-07 15:45:06.445341',2069,NULL,'success'),(5887,'fingerprint-fields',2,'2024-07-07 15:45:04.385313','2024-07-07 15:45:06.292494',1907,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5888,'classify-fields',2,'2024-07-07 15:45:06.301385','2024-07-07 15:45:06.412967',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5889,'classify-tables',2,'2024-07-07 15:45:06.421399','2024-07-07 15:45:06.436007',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5890,'task-history-cleanup',NULL,'2024-07-07 16:00:00.023636','2024-07-07 16:00:00.089202',65,NULL,'success'),(5891,'task-history-cleanup',NULL,'2024-07-07 16:00:00.082341','2024-07-07 16:00:00.102274',19,NULL,'success'),(5892,'sync',2,'2024-07-07 16:45:00.096375','2024-07-07 16:45:04.142826',4046,NULL,'success'),(5893,'sync-dbms-version',2,'2024-07-07 16:45:00.105308','2024-07-07 16:45:00.116690',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5894,'sync-timezone',2,'2024-07-07 16:45:00.128775','2024-07-07 16:45:00.140536',11,'{\"timezone-id\":\"+08:00\"}','success'),(5895,'sync-tables',2,'2024-07-07 16:45:00.150028','2024-07-07 16:45:00.185563',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5896,'sync-fields',2,'2024-07-07 16:45:00.198855','2024-07-07 16:45:03.050611',2851,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5897,'sync-fks',2,'2024-07-07 16:45:03.058347','2024-07-07 16:45:03.645936',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5898,'sync-indexes',2,'2024-07-07 16:45:03.654098','2024-07-07 16:45:04.104176',450,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5899,'sync-metabase-metadata',2,'2024-07-07 16:45:04.111069','2024-07-07 16:45:04.119995',8,'{}','success'),(5900,'sync-table-privileges',2,'2024-07-07 16:45:04.128173','2024-07-07 16:45:04.135445',7,NULL,'success'),(5901,'analyze',2,'2024-07-07 16:45:04.165615','2024-07-07 16:45:05.994054',1828,NULL,'success'),(5902,'fingerprint-fields',2,'2024-07-07 16:45:04.173074','2024-07-07 16:45:05.856313',1683,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5903,'classify-fields',2,'2024-07-07 16:45:05.864315','2024-07-07 16:45:05.966280',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5904,'classify-tables',2,'2024-07-07 16:45:05.973413','2024-07-07 16:45:05.986146',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5905,'sync',2,'2024-07-07 17:45:00.101392','2024-07-07 17:45:04.621310',4519,NULL,'success'),(5906,'sync-dbms-version',2,'2024-07-07 17:45:00.110476','2024-07-07 17:45:00.121686',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5907,'sync-timezone',2,'2024-07-07 17:45:00.130857','2024-07-07 17:45:00.143755',12,'{\"timezone-id\":\"+08:00\"}','success'),(5908,'sync-tables',2,'2024-07-07 17:45:00.152262','2024-07-07 17:45:00.182557',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5909,'sync-fields',2,'2024-07-07 17:45:00.192241','2024-07-07 17:45:03.306676',3114,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5910,'sync-fks',2,'2024-07-07 17:45:03.314636','2024-07-07 17:45:03.994992',680,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5911,'sync-indexes',2,'2024-07-07 17:45:04.004717','2024-07-07 17:45:04.573939',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5912,'sync-metabase-metadata',2,'2024-07-07 17:45:04.582968','2024-07-07 17:45:04.593672',10,'{}','success'),(5913,'sync-table-privileges',2,'2024-07-07 17:45:04.602717','2024-07-07 17:45:04.612033',9,NULL,'success'),(5914,'analyze',2,'2024-07-07 17:45:04.648574','2024-07-07 17:45:06.799156',2150,NULL,'success'),(5915,'fingerprint-fields',2,'2024-07-07 17:45:04.657868','2024-07-07 17:45:06.642511',1984,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5916,'classify-fields',2,'2024-07-07 17:45:06.651300','2024-07-07 17:45:06.768143',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5917,'classify-tables',2,'2024-07-07 17:45:06.776071','2024-07-07 17:45:06.790776',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5918,'sync',2,'2024-07-07 18:45:00.105395','2024-07-07 18:45:04.542167',4436,NULL,'success'),(5919,'sync-dbms-version',2,'2024-07-07 18:45:00.113566','2024-07-07 18:45:00.122647',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5920,'sync-timezone',2,'2024-07-07 18:45:00.132414','2024-07-07 18:45:00.143199',10,'{\"timezone-id\":\"+08:00\"}','success'),(5921,'sync-tables',2,'2024-07-07 18:45:00.152492','2024-07-07 18:45:00.183989',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5922,'sync-fields',2,'2024-07-07 18:45:00.193641','2024-07-07 18:45:03.312548',3118,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5923,'sync-fks',2,'2024-07-07 18:45:03.320359','2024-07-07 18:45:03.932668',612,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5924,'sync-indexes',2,'2024-07-07 18:45:03.941612','2024-07-07 18:45:04.500181',558,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5925,'sync-metabase-metadata',2,'2024-07-07 18:45:04.507945','2024-07-07 18:45:04.516352',8,'{}','success'),(5926,'sync-table-privileges',2,'2024-07-07 18:45:04.524815','2024-07-07 18:45:04.534196',9,NULL,'success'),(5927,'analyze',2,'2024-07-07 18:45:04.565681','2024-07-07 18:45:06.758696',2193,NULL,'success'),(5928,'fingerprint-fields',2,'2024-07-07 18:45:04.573651','2024-07-07 18:45:06.585510',2011,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5929,'classify-fields',2,'2024-07-07 18:45:06.594287','2024-07-07 18:45:06.726186',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5930,'classify-tables',2,'2024-07-07 18:45:06.734092','2024-07-07 18:45:06.749951',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5931,'sync',2,'2024-07-07 19:45:00.106598','2024-07-07 19:45:04.744634',4638,NULL,'success'),(5932,'sync-dbms-version',2,'2024-07-07 19:45:00.116058','2024-07-07 19:45:00.127485',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5933,'sync-timezone',2,'2024-07-07 19:45:00.137175','2024-07-07 19:45:00.150310',13,'{\"timezone-id\":\"+08:00\"}','success'),(5934,'sync-tables',2,'2024-07-07 19:45:00.162109','2024-07-07 19:45:00.192259',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5935,'sync-fields',2,'2024-07-07 19:45:00.201474','2024-07-07 19:45:03.386968',3185,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5936,'sync-fks',2,'2024-07-07 19:45:03.395324','2024-07-07 19:45:04.015124',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5937,'sync-indexes',2,'2024-07-07 19:45:04.023201','2024-07-07 19:45:04.702161',678,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5938,'sync-metabase-metadata',2,'2024-07-07 19:45:04.709508','2024-07-07 19:45:04.718364',8,'{}','success'),(5939,'sync-table-privileges',2,'2024-07-07 19:45:04.726648','2024-07-07 19:45:04.736468',9,NULL,'success'),(5940,'analyze',2,'2024-07-07 19:45:04.768519','2024-07-07 19:45:06.959375',2190,NULL,'success'),(5941,'fingerprint-fields',2,'2024-07-07 19:45:04.776492','2024-07-07 19:45:06.797790',2021,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5942,'classify-fields',2,'2024-07-07 19:45:06.812788','2024-07-07 19:45:06.929168',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5943,'classify-tables',2,'2024-07-07 19:45:06.937190','2024-07-07 19:45:06.951205',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5944,'sync',2,'2024-07-07 20:45:00.110519','2024-07-07 20:45:04.381490',4270,NULL,'success'),(5945,'sync-dbms-version',2,'2024-07-07 20:45:00.119421','2024-07-07 20:45:00.131951',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5946,'sync-timezone',2,'2024-07-07 20:45:00.141164','2024-07-07 20:45:00.153068',11,'{\"timezone-id\":\"+08:00\"}','success'),(5947,'sync-tables',2,'2024-07-07 20:45:00.162443','2024-07-07 20:45:00.194945',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5948,'sync-fields',2,'2024-07-07 20:45:00.203005','2024-07-07 20:45:03.138040',2935,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5949,'sync-fks',2,'2024-07-07 20:45:03.145746','2024-07-07 20:45:03.714018',568,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5950,'sync-indexes',2,'2024-07-07 20:45:03.722126','2024-07-07 20:45:04.338602',616,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5951,'sync-metabase-metadata',2,'2024-07-07 20:45:04.346676','2024-07-07 20:45:04.355221',8,'{}','success'),(5952,'sync-table-privileges',2,'2024-07-07 20:45:04.363619','2024-07-07 20:45:04.371669',8,NULL,'success'),(5953,'analyze',2,'2024-07-07 20:45:04.407544','2024-07-07 20:45:06.547442',2139,NULL,'success'),(5954,'fingerprint-fields',2,'2024-07-07 20:45:04.416343','2024-07-07 20:45:06.389488',1973,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5955,'classify-fields',2,'2024-07-07 20:45:06.398087','2024-07-07 20:45:06.518056',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5956,'classify-tables',2,'2024-07-07 20:45:06.526010','2024-07-07 20:45:06.539069',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5957,'sync',2,'2024-07-07 21:45:00.103242','2024-07-07 21:45:04.315745',4212,NULL,'success'),(5958,'sync-dbms-version',2,'2024-07-07 21:45:00.111355','2024-07-07 21:45:00.120013',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5959,'sync-timezone',2,'2024-07-07 21:45:00.128112','2024-07-07 21:45:00.138247',10,'{\"timezone-id\":\"+08:00\"}','success'),(5960,'sync-tables',2,'2024-07-07 21:45:00.146384','2024-07-07 21:45:00.173765',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5961,'sync-fields',2,'2024-07-07 21:45:00.182217','2024-07-07 21:45:03.080155',2897,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5962,'sync-fks',2,'2024-07-07 21:45:03.088208','2024-07-07 21:45:03.708066',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5963,'sync-indexes',2,'2024-07-07 21:45:03.717069','2024-07-07 21:45:04.276696',559,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5964,'sync-metabase-metadata',2,'2024-07-07 21:45:04.283716','2024-07-07 21:45:04.291334',7,'{}','success'),(5965,'sync-table-privileges',2,'2024-07-07 21:45:04.299545','2024-07-07 21:45:04.307663',8,NULL,'success'),(5966,'analyze',2,'2024-07-07 21:45:04.339967','2024-07-07 21:45:06.318945',1978,NULL,'success'),(5967,'fingerprint-fields',2,'2024-07-07 21:45:04.348292','2024-07-07 21:45:06.172138',1823,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5968,'classify-fields',2,'2024-07-07 21:45:06.179725','2024-07-07 21:45:06.289478',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5969,'classify-tables',2,'2024-07-07 21:45:06.297390','2024-07-07 21:45:06.310810',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5970,'sync',2,'2024-07-07 22:45:00.102445','2024-07-07 22:45:05.541675',5439,NULL,'success'),(5971,'sync-dbms-version',2,'2024-07-07 22:45:00.112118','2024-07-07 22:45:00.121976',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5972,'sync-timezone',2,'2024-07-07 22:45:00.131044','2024-07-07 22:45:00.141757',10,'{\"timezone-id\":\"+08:00\"}','success'),(5973,'sync-tables',2,'2024-07-07 22:45:00.151170','2024-07-07 22:45:00.181368',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5974,'sync-fields',2,'2024-07-07 22:45:00.190719','2024-07-07 22:45:03.377002',3186,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5975,'sync-fks',2,'2024-07-07 22:45:03.385258','2024-07-07 22:45:04.071265',686,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5976,'sync-indexes',2,'2024-07-07 22:45:04.080288','2024-07-07 22:45:05.494687',1414,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5977,'sync-metabase-metadata',2,'2024-07-07 22:45:05.504095','2024-07-07 22:45:05.512759',8,'{}','success'),(5978,'sync-table-privileges',2,'2024-07-07 22:45:05.522716','2024-07-07 22:45:05.532087',9,NULL,'success'),(5979,'analyze',2,'2024-07-07 22:45:05.567955','2024-07-07 22:45:07.628344',2060,NULL,'success'),(5980,'fingerprint-fields',2,'2024-07-07 22:45:05.576818','2024-07-07 22:45:07.463089',1886,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5981,'classify-fields',2,'2024-07-07 22:45:07.473014','2024-07-07 22:45:07.598081',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5982,'classify-tables',2,'2024-07-07 22:45:07.605746','2024-07-07 22:45:07.620091',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5983,'sync',2,'2024-07-07 23:45:00.116394','2024-07-07 23:45:04.598130',4481,NULL,'success'),(5984,'sync-dbms-version',2,'2024-07-07 23:45:00.125109','2024-07-07 23:45:00.134565',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5985,'sync-timezone',2,'2024-07-07 23:45:00.144178','2024-07-07 23:45:00.156405',12,'{\"timezone-id\":\"+08:00\"}','success'),(5986,'sync-tables',2,'2024-07-07 23:45:00.167156','2024-07-07 23:45:00.196700',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(5987,'sync-fields',2,'2024-07-07 23:45:00.206386','2024-07-07 23:45:03.339417',3133,'{\"total-fields\":836,\"updated-fields\":0}','success'),(5988,'sync-fks',2,'2024-07-07 23:45:03.347383','2024-07-07 23:45:03.982092',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(5989,'sync-indexes',2,'2024-07-07 23:45:03.990413','2024-07-07 23:45:04.553400',562,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(5990,'sync-metabase-metadata',2,'2024-07-07 23:45:04.561320','2024-07-07 23:45:04.570436',9,'{}','success'),(5991,'sync-table-privileges',2,'2024-07-07 23:45:04.579687','2024-07-07 23:45:04.588761',9,NULL,'success'),(5992,'analyze',2,'2024-07-07 23:45:04.630189','2024-07-07 23:45:06.635126',2004,NULL,'success'),(5993,'fingerprint-fields',2,'2024-07-07 23:45:04.639041','2024-07-07 23:45:06.484278',1845,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(5994,'classify-fields',2,'2024-07-07 23:45:06.493228','2024-07-07 23:45:06.604933',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(5995,'classify-tables',2,'2024-07-07 23:45:06.613134','2024-07-07 23:45:06.626802',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(5996,'sync',2,'2024-07-08 00:45:00.104522','2024-07-08 00:45:04.423278',4318,NULL,'success'),(5997,'sync-dbms-version',2,'2024-07-08 00:45:00.115350','2024-07-08 00:45:00.124706',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(5998,'sync-timezone',2,'2024-07-08 00:45:00.134126','2024-07-08 00:45:00.146018',11,'{\"timezone-id\":\"+08:00\"}','success'),(5999,'sync-tables',2,'2024-07-08 00:45:00.155103','2024-07-08 00:45:00.182881',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6000,'sync-fields',2,'2024-07-08 00:45:00.191650','2024-07-08 00:45:03.243557',3051,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6001,'sync-fks',2,'2024-07-08 00:45:03.250840','2024-07-08 00:45:03.833667',582,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6002,'sync-indexes',2,'2024-07-08 00:45:03.841949','2024-07-08 00:45:04.381308',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6003,'sync-metabase-metadata',2,'2024-07-08 00:45:04.389138','2024-07-08 00:45:04.397561',8,'{}','success'),(6004,'sync-table-privileges',2,'2024-07-08 00:45:04.405746','2024-07-08 00:45:04.414307',8,NULL,'success'),(6005,'analyze',2,'2024-07-08 00:45:04.447642','2024-07-08 00:45:06.634732',2187,NULL,'success'),(6006,'fingerprint-fields',2,'2024-07-08 00:45:04.456417','2024-07-08 00:45:06.477480',2021,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6007,'classify-fields',2,'2024-07-08 00:45:06.485623','2024-07-08 00:45:06.602843',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6008,'classify-tables',2,'2024-07-08 00:45:06.611170','2024-07-08 00:45:06.626203',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6009,'sync',2,'2024-07-08 01:45:00.114016','2024-07-08 01:45:04.288674',4174,NULL,'success'),(6010,'sync-dbms-version',2,'2024-07-08 01:45:00.124179','2024-07-08 01:45:00.134315',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6011,'sync-timezone',2,'2024-07-08 01:45:00.143713','2024-07-08 01:45:00.157873',14,'{\"timezone-id\":\"+08:00\"}','success'),(6012,'sync-tables',2,'2024-07-08 01:45:00.168672','2024-07-08 01:45:00.203936',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6013,'sync-fields',2,'2024-07-08 01:45:00.213373','2024-07-08 01:45:03.172265',2958,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6014,'sync-fks',2,'2024-07-08 01:45:03.180212','2024-07-08 01:45:03.755596',575,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6015,'sync-indexes',2,'2024-07-08 01:45:03.763234','2024-07-08 01:45:04.247358',484,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6016,'sync-metabase-metadata',2,'2024-07-08 01:45:04.255029','2024-07-08 01:45:04.263487',8,'{}','success'),(6017,'sync-table-privileges',2,'2024-07-08 01:45:04.272439','2024-07-08 01:45:04.280973',8,NULL,'success'),(6018,'analyze',2,'2024-07-08 01:45:04.315040','2024-07-08 01:45:06.322641',2007,NULL,'success'),(6019,'fingerprint-fields',2,'2024-07-08 01:45:04.323024','2024-07-08 01:45:06.161093',1838,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6020,'classify-fields',2,'2024-07-08 01:45:06.170134','2024-07-08 01:45:06.291884',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6021,'classify-tables',2,'2024-07-08 01:45:06.300036','2024-07-08 01:45:06.313758',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6022,'sync',2,'2024-07-08 02:45:00.093136','2024-07-08 02:45:04.728352',4635,NULL,'success'),(6023,'sync-dbms-version',2,'2024-07-08 02:45:00.102226','2024-07-08 02:45:00.111776',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6024,'sync-timezone',2,'2024-07-08 02:45:00.121095','2024-07-08 02:45:00.131992',10,'{\"timezone-id\":\"+08:00\"}','success'),(6025,'sync-tables',2,'2024-07-08 02:45:00.140524','2024-07-08 02:45:00.167335',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6026,'sync-fields',2,'2024-07-08 02:45:00.175802','2024-07-08 02:45:03.327131',3151,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6027,'sync-fks',2,'2024-07-08 02:45:03.335664','2024-07-08 02:45:04.040631',704,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6028,'sync-indexes',2,'2024-07-08 02:45:04.049641','2024-07-08 02:45:04.683049',633,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6029,'sync-metabase-metadata',2,'2024-07-08 02:45:04.691558','2024-07-08 02:45:04.700939',9,'{}','success'),(6030,'sync-table-privileges',2,'2024-07-08 02:45:04.710263','2024-07-08 02:45:04.719651',9,NULL,'success'),(6031,'analyze',2,'2024-07-08 02:45:04.754629','2024-07-08 02:45:06.785210',2030,NULL,'success'),(6032,'fingerprint-fields',2,'2024-07-08 02:45:04.763824','2024-07-08 02:45:06.641335',1877,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6033,'classify-fields',2,'2024-07-08 02:45:06.649677','2024-07-08 02:45:06.756304',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6034,'classify-tables',2,'2024-07-08 02:45:06.763344','2024-07-08 02:45:06.776848',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6035,'sync',2,'2024-07-08 03:45:00.102230','2024-07-08 03:45:04.476983',4374,NULL,'success'),(6036,'sync-dbms-version',2,'2024-07-08 03:45:00.111154','2024-07-08 03:45:00.120966',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6037,'sync-timezone',2,'2024-07-08 03:45:00.129904','2024-07-08 03:45:00.139048',9,'{\"timezone-id\":\"+08:00\"}','success'),(6038,'sync-tables',2,'2024-07-08 03:45:00.147020','2024-07-08 03:45:00.173217',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6039,'sync-fields',2,'2024-07-08 03:45:00.181897','2024-07-08 03:45:03.176598',2994,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6040,'sync-fks',2,'2024-07-08 03:45:03.184468','2024-07-08 03:45:03.853124',668,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6041,'sync-indexes',2,'2024-07-08 03:45:03.861260','2024-07-08 03:45:04.432339',571,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6042,'sync-metabase-metadata',2,'2024-07-08 03:45:04.440849','2024-07-08 03:45:04.449334',8,'{}','success'),(6043,'sync-table-privileges',2,'2024-07-08 03:45:04.459366','2024-07-08 03:45:04.468244',8,NULL,'success'),(6044,'analyze',2,'2024-07-08 03:45:04.504529','2024-07-08 03:45:06.599053',2094,NULL,'success'),(6045,'fingerprint-fields',2,'2024-07-08 03:45:04.513403','2024-07-08 03:45:06.441062',1927,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6046,'classify-fields',2,'2024-07-08 03:45:06.450269','2024-07-08 03:45:06.566823',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6047,'classify-tables',2,'2024-07-08 03:45:06.574767','2024-07-08 03:45:06.590442',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6048,'task-history-cleanup',NULL,'2024-07-08 04:00:00.096006','2024-07-08 04:00:00.110323',14,NULL,'success'),(6049,'sync',2,'2024-07-08 04:45:00.106656','2024-07-08 04:45:04.591877',4485,NULL,'success'),(6050,'sync-dbms-version',2,'2024-07-08 04:45:00.115091','2024-07-08 04:45:00.126311',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6051,'sync-timezone',2,'2024-07-08 04:45:00.136002','2024-07-08 04:45:00.147278',11,'{\"timezone-id\":\"+08:00\"}','success'),(6052,'sync-tables',2,'2024-07-08 04:45:00.156333','2024-07-08 04:45:00.186421',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6053,'sync-fields',2,'2024-07-08 04:45:00.195882','2024-07-08 04:45:03.154257',2958,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6054,'sync-fks',2,'2024-07-08 04:45:03.164677','2024-07-08 04:45:03.904343',739,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6055,'sync-indexes',2,'2024-07-08 04:45:03.914072','2024-07-08 04:45:04.548401',634,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6056,'sync-metabase-metadata',2,'2024-07-08 04:45:04.556034','2024-07-08 04:45:04.564570',8,'{}','success'),(6057,'sync-table-privileges',2,'2024-07-08 04:45:04.573082','2024-07-08 04:45:04.582939',9,NULL,'success'),(6058,'analyze',2,'2024-07-08 04:45:04.621830','2024-07-08 04:45:06.800179',2178,NULL,'success'),(6059,'fingerprint-fields',2,'2024-07-08 04:45:04.630970','2024-07-08 04:45:06.644511',2013,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6060,'classify-fields',2,'2024-07-08 04:45:06.653177','2024-07-08 04:45:06.768392',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6061,'classify-tables',2,'2024-07-08 04:45:06.776045','2024-07-08 04:45:06.789523',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6062,'sync',2,'2024-07-08 05:45:00.107565','2024-07-08 05:45:04.852701',4745,NULL,'success'),(6063,'sync-dbms-version',2,'2024-07-08 05:45:00.116031','2024-07-08 05:45:00.126092',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6064,'sync-timezone',2,'2024-07-08 05:45:00.135555','2024-07-08 05:45:00.145942',10,'{\"timezone-id\":\"+08:00\"}','success'),(6065,'sync-tables',2,'2024-07-08 05:45:00.155751','2024-07-08 05:45:00.185822',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6066,'sync-fields',2,'2024-07-08 05:45:00.195994','2024-07-08 05:45:03.484999',3289,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6067,'sync-fks',2,'2024-07-08 05:45:03.493633','2024-07-08 05:45:04.187002',693,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6068,'sync-indexes',2,'2024-07-08 05:45:04.195883','2024-07-08 05:45:04.805392',609,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6069,'sync-metabase-metadata',2,'2024-07-08 05:45:04.813695','2024-07-08 05:45:04.824213',10,'{}','success'),(6070,'sync-table-privileges',2,'2024-07-08 05:45:04.834881','2024-07-08 05:45:04.843724',8,NULL,'success'),(6071,'analyze',2,'2024-07-08 05:45:04.885267','2024-07-08 05:45:07.013007',2127,NULL,'success'),(6072,'fingerprint-fields',2,'2024-07-08 05:45:04.894113','2024-07-08 05:45:06.846139',1952,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6073,'classify-fields',2,'2024-07-08 05:45:06.854980','2024-07-08 05:45:06.982116',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6074,'classify-tables',2,'2024-07-08 05:45:06.990104','2024-07-08 05:45:07.004253',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6075,'sync',2,'2024-07-08 06:45:00.115686','2024-07-08 06:45:04.153302',4037,NULL,'success'),(6076,'sync-dbms-version',2,'2024-07-08 06:45:00.124872','2024-07-08 06:45:00.134100',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6077,'sync-timezone',2,'2024-07-08 06:45:00.142113','2024-07-08 06:45:00.152152',10,'{\"timezone-id\":\"+08:00\"}','success'),(6078,'sync-tables',2,'2024-07-08 06:45:00.161164','2024-07-08 06:45:00.186839',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6079,'sync-fields',2,'2024-07-08 06:45:00.195064','2024-07-08 06:45:02.970404',2775,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6080,'sync-fks',2,'2024-07-08 06:45:02.977783','2024-07-08 06:45:03.569220',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6081,'sync-indexes',2,'2024-07-08 06:45:03.578097','2024-07-08 06:45:04.111085',532,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6082,'sync-metabase-metadata',2,'2024-07-08 06:45:04.119045','2024-07-08 06:45:04.127286',8,'{}','success'),(6083,'sync-table-privileges',2,'2024-07-08 06:45:04.136428','2024-07-08 06:45:04.145281',8,NULL,'success'),(6084,'analyze',2,'2024-07-08 06:45:04.180531','2024-07-08 06:45:06.292644',2112,NULL,'success'),(6085,'fingerprint-fields',2,'2024-07-08 06:45:04.188398','2024-07-08 06:45:06.132796',1944,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6086,'classify-fields',2,'2024-07-08 06:45:06.142069','2024-07-08 06:45:06.261775',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6087,'classify-tables',2,'2024-07-08 06:45:06.270284','2024-07-08 06:45:06.284415',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6088,'sync',2,'2024-07-08 07:45:00.102530','2024-07-08 07:45:04.037272',3934,NULL,'success'),(6089,'sync-dbms-version',2,'2024-07-08 07:45:00.111674','2024-07-08 07:45:00.121126',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6090,'sync-timezone',2,'2024-07-08 07:45:00.130042','2024-07-08 07:45:00.141466',11,'{\"timezone-id\":\"+08:00\"}','success'),(6091,'sync-tables',2,'2024-07-08 07:45:00.149775','2024-07-08 07:45:00.180151',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6092,'sync-fields',2,'2024-07-08 07:45:00.188667','2024-07-08 07:45:02.999624',2810,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6093,'sync-fks',2,'2024-07-08 07:45:03.006854','2024-07-08 07:45:03.547734',540,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6094,'sync-indexes',2,'2024-07-08 07:45:03.557527','2024-07-08 07:45:03.997961',440,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6095,'sync-metabase-metadata',2,'2024-07-08 07:45:04.005986','2024-07-08 07:45:04.014708',8,'{}','success'),(6096,'sync-table-privileges',2,'2024-07-08 07:45:04.022562','2024-07-08 07:45:04.029507',6,NULL,'success'),(6097,'analyze',2,'2024-07-08 07:45:04.060054','2024-07-08 07:45:05.890566',1830,NULL,'success'),(6098,'fingerprint-fields',2,'2024-07-08 07:45:04.067700','2024-07-08 07:45:05.760080',1692,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6099,'classify-fields',2,'2024-07-08 07:45:05.767294','2024-07-08 07:45:05.863419',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6100,'classify-tables',2,'2024-07-08 07:45:05.870450','2024-07-08 07:45:05.883206',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6101,'sync',2,'2024-07-08 08:45:00.095569','2024-07-08 08:45:04.153705',4058,NULL,'success'),(6102,'sync-dbms-version',2,'2024-07-08 08:45:00.103516','2024-07-08 08:45:00.112005',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6103,'sync-timezone',2,'2024-07-08 08:45:00.120600','2024-07-08 08:45:00.131690',11,'{\"timezone-id\":\"+08:00\"}','success'),(6104,'sync-tables',2,'2024-07-08 08:45:00.140161','2024-07-08 08:45:00.165535',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6105,'sync-fields',2,'2024-07-08 08:45:00.174293','2024-07-08 08:45:03.063527',2889,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6106,'sync-fks',2,'2024-07-08 08:45:03.071540','2024-07-08 08:45:03.629136',557,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6107,'sync-indexes',2,'2024-07-08 08:45:03.637104','2024-07-08 08:45:04.110774',473,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6108,'sync-metabase-metadata',2,'2024-07-08 08:45:04.119659','2024-07-08 08:45:04.127950',8,'{}','success'),(6109,'sync-table-privileges',2,'2024-07-08 08:45:04.136562','2024-07-08 08:45:04.145859',9,NULL,'success'),(6110,'analyze',2,'2024-07-08 08:45:04.177028','2024-07-08 08:45:06.060017',1882,NULL,'success'),(6111,'fingerprint-fields',2,'2024-07-08 08:45:04.184565','2024-07-08 08:45:05.920042',1735,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6112,'classify-fields',2,'2024-07-08 08:45:05.927891','2024-07-08 08:45:06.031545',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6113,'classify-tables',2,'2024-07-08 08:45:06.039122','2024-07-08 08:45:06.052629',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6114,'sync',2,'2024-07-08 09:45:00.097793','2024-07-08 09:45:04.046174',3948,NULL,'success'),(6115,'sync-dbms-version',2,'2024-07-08 09:45:00.105973','2024-07-08 09:45:00.115969',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6116,'sync-timezone',2,'2024-07-08 09:45:00.125350','2024-07-08 09:45:00.134929',9,'{\"timezone-id\":\"+08:00\"}','success'),(6117,'sync-tables',2,'2024-07-08 09:45:00.143072','2024-07-08 09:45:00.168336',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6118,'sync-fields',2,'2024-07-08 09:45:00.176433','2024-07-08 09:45:02.887764',2711,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6119,'sync-fks',2,'2024-07-08 09:45:02.894852','2024-07-08 09:45:03.483273',588,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6120,'sync-indexes',2,'2024-07-08 09:45:03.491076','2024-07-08 09:45:04.006211',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6121,'sync-metabase-metadata',2,'2024-07-08 09:45:04.013836','2024-07-08 09:45:04.022033',8,'{}','success'),(6122,'sync-table-privileges',2,'2024-07-08 09:45:04.029880','2024-07-08 09:45:04.038415',8,NULL,'success'),(6123,'analyze',2,'2024-07-08 09:45:04.074963','2024-07-08 09:45:05.980926',1905,NULL,'success'),(6124,'fingerprint-fields',2,'2024-07-08 09:45:04.083448','2024-07-08 09:45:05.837072',1753,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6125,'classify-fields',2,'2024-07-08 09:45:05.845078','2024-07-08 09:45:05.950827',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6126,'classify-tables',2,'2024-07-08 09:45:05.958385','2024-07-08 09:45:05.973202',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6127,'sync',2,'2024-07-08 10:45:00.105200','2024-07-08 10:45:04.701724',4596,NULL,'success'),(6128,'sync-dbms-version',2,'2024-07-08 10:45:00.113421','2024-07-08 10:45:00.122485',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6129,'sync-timezone',2,'2024-07-08 10:45:00.130879','2024-07-08 10:45:00.141233',10,'{\"timezone-id\":\"+08:00\"}','success'),(6130,'sync-tables',2,'2024-07-08 10:45:00.150007','2024-07-08 10:45:00.181848',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6131,'sync-fields',2,'2024-07-08 10:45:00.190358','2024-07-08 10:45:03.489730',3299,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6132,'sync-fks',2,'2024-07-08 10:45:03.499773','2024-07-08 10:45:04.126319',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6133,'sync-indexes',2,'2024-07-08 10:45:04.135410','2024-07-08 10:45:04.662928',527,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6134,'sync-metabase-metadata',2,'2024-07-08 10:45:04.670091','2024-07-08 10:45:04.678177',8,'{}','success'),(6135,'sync-table-privileges',2,'2024-07-08 10:45:04.685781','2024-07-08 10:45:04.693735',7,NULL,'success'),(6136,'analyze',2,'2024-07-08 10:45:04.727343','2024-07-08 10:45:06.640172',1912,NULL,'success'),(6137,'fingerprint-fields',2,'2024-07-08 10:45:04.735460','2024-07-08 10:45:06.491609',1756,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6138,'classify-fields',2,'2024-07-08 10:45:06.499704','2024-07-08 10:45:06.610967',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6139,'classify-tables',2,'2024-07-08 10:45:06.618534','2024-07-08 10:45:06.632410',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6140,'sync',2,'2024-07-08 11:45:00.103067','2024-07-08 11:45:04.365546',4262,NULL,'success'),(6141,'sync-dbms-version',2,'2024-07-08 11:45:00.111673','2024-07-08 11:45:00.121902',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6142,'sync-timezone',2,'2024-07-08 11:45:00.131289','2024-07-08 11:45:00.141809',10,'{\"timezone-id\":\"+08:00\"}','success'),(6143,'sync-tables',2,'2024-07-08 11:45:00.150798','2024-07-08 11:45:00.182096',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6144,'sync-fields',2,'2024-07-08 11:45:00.190785','2024-07-08 11:45:03.182117',2991,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6145,'sync-fks',2,'2024-07-08 11:45:03.190260','2024-07-08 11:45:03.777355',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6146,'sync-indexes',2,'2024-07-08 11:45:03.786087','2024-07-08 11:45:04.320639',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6147,'sync-metabase-metadata',2,'2024-07-08 11:45:04.330770','2024-07-08 11:45:04.339624',8,'{}','success'),(6148,'sync-table-privileges',2,'2024-07-08 11:45:04.349688','2024-07-08 11:45:04.357846',8,NULL,'success'),(6149,'analyze',2,'2024-07-08 11:45:04.389126','2024-07-08 11:45:06.466273',2077,NULL,'success'),(6150,'fingerprint-fields',2,'2024-07-08 11:45:04.397475','2024-07-08 11:45:06.326547',1929,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6151,'classify-fields',2,'2024-07-08 11:45:06.334409','2024-07-08 11:45:06.438703',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6152,'classify-tables',2,'2024-07-08 11:45:06.445687','2024-07-08 11:45:06.458367',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6153,'sync',2,'2024-07-08 12:45:00.103226','2024-07-08 12:45:04.340826',4237,NULL,'success'),(6154,'sync-dbms-version',2,'2024-07-08 12:45:00.112755','2024-07-08 12:45:00.124215',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6155,'sync-timezone',2,'2024-07-08 12:45:00.132497','2024-07-08 12:45:00.143396',10,'{\"timezone-id\":\"+08:00\"}','success'),(6156,'sync-tables',2,'2024-07-08 12:45:00.152903','2024-07-08 12:45:00.179936',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6157,'sync-fields',2,'2024-07-08 12:45:00.189359','2024-07-08 12:45:03.165433',2976,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6158,'sync-fks',2,'2024-07-08 12:45:03.173187','2024-07-08 12:45:03.758989',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6159,'sync-indexes',2,'2024-07-08 12:45:03.768223','2024-07-08 12:45:04.300732',532,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6160,'sync-metabase-metadata',2,'2024-07-08 12:45:04.308235','2024-07-08 12:45:04.316409',8,'{}','success'),(6161,'sync-table-privileges',2,'2024-07-08 12:45:04.324304','2024-07-08 12:45:04.332745',8,NULL,'success'),(6162,'analyze',2,'2024-07-08 12:45:04.365132','2024-07-08 12:45:06.301373',1936,NULL,'success'),(6163,'fingerprint-fields',2,'2024-07-08 12:45:04.372846','2024-07-08 12:45:06.152212',1779,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6164,'classify-fields',2,'2024-07-08 12:45:06.161776','2024-07-08 12:45:06.272733',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6165,'classify-tables',2,'2024-07-08 12:45:06.280444','2024-07-08 12:45:06.293376',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6166,'field values scanning',2,'2024-07-08 13:00:00.063121','2024-07-08 13:00:03.880705',3817,NULL,'success'),(6167,'delete-expired-advanced-field-values',2,'2024-07-08 13:00:00.098875','2024-07-08 13:00:02.727626',2628,'{\"deleted\":0}','success'),(6168,'update-field-values',2,'2024-07-08 13:00:02.735038','2024-07-08 13:00:03.872980',1137,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(6169,'sync',2,'2024-07-08 13:45:00.098863','2024-07-08 13:45:04.235647',4136,NULL,'success'),(6170,'sync-dbms-version',2,'2024-07-08 13:45:00.107154','2024-07-08 13:45:00.115981',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6171,'sync-timezone',2,'2024-07-08 13:45:00.124476','2024-07-08 13:45:00.133342',8,'{\"timezone-id\":\"+08:00\"}','success'),(6172,'sync-tables',2,'2024-07-08 13:45:00.141533','2024-07-08 13:45:00.167314',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6173,'sync-fields',2,'2024-07-08 13:45:00.175888','2024-07-08 13:45:03.114485',2938,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6174,'sync-fks',2,'2024-07-08 13:45:03.123918','2024-07-08 13:45:03.733445',609,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6175,'sync-indexes',2,'2024-07-08 13:45:03.741099','2024-07-08 13:45:04.195701',454,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6176,'sync-metabase-metadata',2,'2024-07-08 13:45:04.202994','2024-07-08 13:45:04.210225',7,'{}','success'),(6177,'sync-table-privileges',2,'2024-07-08 13:45:04.218006','2024-07-08 13:45:04.226103',8,NULL,'success'),(6178,'analyze',2,'2024-07-08 13:45:04.261024','2024-07-08 13:45:06.123120',1862,NULL,'success'),(6179,'fingerprint-fields',2,'2024-07-08 13:45:04.268591','2024-07-08 13:45:05.980859',1712,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6180,'classify-fields',2,'2024-07-08 13:45:05.988783','2024-07-08 13:45:06.094477',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6181,'classify-tables',2,'2024-07-08 13:45:06.101670','2024-07-08 13:45:06.115045',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6182,'sync',2,'2024-07-08 14:45:00.100571','2024-07-08 14:45:04.012637',3912,NULL,'success'),(6183,'sync-dbms-version',2,'2024-07-08 14:45:00.111166','2024-07-08 14:45:00.122029',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6184,'sync-timezone',2,'2024-07-08 14:45:00.130460','2024-07-08 14:45:00.144080',13,'{\"timezone-id\":\"+08:00\"}','success'),(6185,'sync-tables',2,'2024-07-08 14:45:00.152404','2024-07-08 14:45:00.177417',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6186,'sync-fields',2,'2024-07-08 14:45:00.185634','2024-07-08 14:45:02.880568',2694,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6187,'sync-fks',2,'2024-07-08 14:45:02.888181','2024-07-08 14:45:03.459813',571,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6188,'sync-indexes',2,'2024-07-08 14:45:03.468213','2024-07-08 14:45:03.973737',505,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6189,'sync-metabase-metadata',2,'2024-07-08 14:45:03.981085','2024-07-08 14:45:03.989014',7,'{}','success'),(6190,'sync-table-privileges',2,'2024-07-08 14:45:03.996736','2024-07-08 14:45:04.004537',7,NULL,'success'),(6191,'analyze',2,'2024-07-08 14:45:04.036162','2024-07-08 14:45:05.936065',1899,NULL,'success'),(6192,'fingerprint-fields',2,'2024-07-08 14:45:04.043625','2024-07-08 14:45:05.798019',1754,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6193,'classify-fields',2,'2024-07-08 14:45:05.805803','2024-07-08 14:45:05.908620',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6194,'classify-tables',2,'2024-07-08 14:45:05.915792','2024-07-08 14:45:05.928311',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6195,'sync',2,'2024-07-08 15:45:00.096768','2024-07-08 15:45:04.100089',4003,NULL,'success'),(6196,'sync-dbms-version',2,'2024-07-08 15:45:00.104468','2024-07-08 15:45:00.113093',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6197,'sync-timezone',2,'2024-07-08 15:45:00.121453','2024-07-08 15:45:00.132371',10,'{\"timezone-id\":\"+08:00\"}','success'),(6198,'sync-tables',2,'2024-07-08 15:45:00.140551','2024-07-08 15:45:00.167488',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6199,'sync-fields',2,'2024-07-08 15:45:00.175634','2024-07-08 15:45:02.971273',2795,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6200,'sync-fks',2,'2024-07-08 15:45:02.978398','2024-07-08 15:45:03.534757',556,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6201,'sync-indexes',2,'2024-07-08 15:45:03.542773','2024-07-08 15:45:04.056575',513,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6202,'sync-metabase-metadata',2,'2024-07-08 15:45:04.064155','2024-07-08 15:45:04.073765',9,'{}','success'),(6203,'sync-table-privileges',2,'2024-07-08 15:45:04.082161','2024-07-08 15:45:04.091332',9,NULL,'success'),(6204,'analyze',2,'2024-07-08 15:45:04.128644','2024-07-08 15:45:06.260891',2132,NULL,'success'),(6205,'fingerprint-fields',2,'2024-07-08 15:45:04.137025','2024-07-08 15:45:06.106525',1969,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6206,'classify-fields',2,'2024-07-08 15:45:06.115058','2024-07-08 15:45:06.230129',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6207,'classify-tables',2,'2024-07-08 15:45:06.237953','2024-07-08 15:45:06.252304',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6208,'task-history-cleanup',NULL,'2024-07-08 16:00:00.018311','2024-07-08 16:00:00.069930',51,NULL,'success'),(6209,'task-history-cleanup',NULL,'2024-07-08 16:00:00.074313','2024-07-08 16:00:00.104611',30,NULL,'success'),(6210,'sync',2,'2024-07-08 16:45:00.105782','2024-07-08 16:45:04.316831',4211,NULL,'success'),(6211,'sync-dbms-version',2,'2024-07-08 16:45:00.113321','2024-07-08 16:45:00.122104',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6212,'sync-timezone',2,'2024-07-08 16:45:00.130243','2024-07-08 16:45:00.139924',9,'{\"timezone-id\":\"+08:00\"}','success'),(6213,'sync-tables',2,'2024-07-08 16:45:00.147927','2024-07-08 16:45:00.175008',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6214,'sync-fields',2,'2024-07-08 16:45:00.183394','2024-07-08 16:45:03.153974',2970,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6215,'sync-fks',2,'2024-07-08 16:45:03.162208','2024-07-08 16:45:03.728857',566,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6216,'sync-indexes',2,'2024-07-08 16:45:03.736839','2024-07-08 16:45:04.268253',531,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6217,'sync-metabase-metadata',2,'2024-07-08 16:45:04.277771','2024-07-08 16:45:04.287954',10,'{}','success'),(6218,'sync-table-privileges',2,'2024-07-08 16:45:04.297283','2024-07-08 16:45:04.307682',10,NULL,'success'),(6219,'analyze',2,'2024-07-08 16:45:04.345379','2024-07-08 16:45:06.340929',1995,NULL,'success'),(6220,'fingerprint-fields',2,'2024-07-08 16:45:04.354003','2024-07-08 16:45:06.202191',1848,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6221,'classify-fields',2,'2024-07-08 16:45:06.210283','2024-07-08 16:45:06.313116',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6222,'classify-tables',2,'2024-07-08 16:45:06.320248','2024-07-08 16:45:06.332996',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6223,'sync',2,'2024-07-08 17:45:00.098652','2024-07-08 17:45:04.645768',4547,NULL,'success'),(6224,'sync-dbms-version',2,'2024-07-08 17:45:00.106858','2024-07-08 17:45:00.119632',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6225,'sync-timezone',2,'2024-07-08 17:45:00.128450','2024-07-08 17:45:00.139228',10,'{\"timezone-id\":\"+08:00\"}','success'),(6226,'sync-tables',2,'2024-07-08 17:45:00.148211','2024-07-08 17:45:00.174183',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6227,'sync-fields',2,'2024-07-08 17:45:00.183899','2024-07-08 17:45:03.361129',3177,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6228,'sync-fks',2,'2024-07-08 17:45:03.371300','2024-07-08 17:45:04.066065',694,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6229,'sync-indexes',2,'2024-07-08 17:45:04.075461','2024-07-08 17:45:04.599353',523,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6230,'sync-metabase-metadata',2,'2024-07-08 17:45:04.607878','2024-07-08 17:45:04.618275',10,'{}','success'),(6231,'sync-table-privileges',2,'2024-07-08 17:45:04.627395','2024-07-08 17:45:04.636502',9,NULL,'success'),(6232,'analyze',2,'2024-07-08 17:45:04.675704','2024-07-08 17:45:06.678259',2002,NULL,'success'),(6233,'fingerprint-fields',2,'2024-07-08 17:45:04.685911','2024-07-08 17:45:06.520733',1834,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6234,'classify-fields',2,'2024-07-08 17:45:06.529424','2024-07-08 17:45:06.647044',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6235,'classify-tables',2,'2024-07-08 17:45:06.654559','2024-07-08 17:45:06.668987',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6236,'sync',2,'2024-07-08 18:45:00.107796','2024-07-08 18:45:04.801955',4694,NULL,'success'),(6237,'sync-dbms-version',2,'2024-07-08 18:45:00.116096','2024-07-08 18:45:00.125328',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6238,'sync-timezone',2,'2024-07-08 18:45:00.135476','2024-07-08 18:45:00.145001',9,'{\"timezone-id\":\"+08:00\"}','success'),(6239,'sync-tables',2,'2024-07-08 18:45:00.154288','2024-07-08 18:45:00.183006',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6240,'sync-fields',2,'2024-07-08 18:45:00.192345','2024-07-08 18:45:03.374691',3182,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6241,'sync-fks',2,'2024-07-08 18:45:03.383626','2024-07-08 18:45:04.136089',752,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6242,'sync-indexes',2,'2024-07-08 18:45:04.144287','2024-07-08 18:45:04.757941',613,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6243,'sync-metabase-metadata',2,'2024-07-08 18:45:04.766405','2024-07-08 18:45:04.776955',10,'{}','success'),(6244,'sync-table-privileges',2,'2024-07-08 18:45:04.785829','2024-07-08 18:45:04.794175',8,NULL,'success'),(6245,'analyze',2,'2024-07-08 18:45:04.826653','2024-07-08 18:45:06.967722',2141,NULL,'success'),(6246,'fingerprint-fields',2,'2024-07-08 18:45:04.835089','2024-07-08 18:45:06.816044',1980,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6247,'classify-fields',2,'2024-07-08 18:45:06.825517','2024-07-08 18:45:06.937899',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6248,'classify-tables',2,'2024-07-08 18:45:06.945460','2024-07-08 18:45:06.959089',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6249,'sync',2,'2024-07-08 19:45:00.093775','2024-07-08 19:45:04.641931',4548,NULL,'success'),(6250,'sync-dbms-version',2,'2024-07-08 19:45:00.101881','2024-07-08 19:45:00.113145',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6251,'sync-timezone',2,'2024-07-08 19:45:00.121621','2024-07-08 19:45:00.131678',10,'{\"timezone-id\":\"+08:00\"}','success'),(6252,'sync-tables',2,'2024-07-08 19:45:00.142690','2024-07-08 19:45:00.168801',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6253,'sync-fields',2,'2024-07-08 19:45:00.177664','2024-07-08 19:45:03.258763',3081,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6254,'sync-fks',2,'2024-07-08 19:45:03.267197','2024-07-08 19:45:03.968031',700,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6255,'sync-indexes',2,'2024-07-08 19:45:03.976718','2024-07-08 19:45:04.597476',620,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6256,'sync-metabase-metadata',2,'2024-07-08 19:45:04.605430','2024-07-08 19:45:04.614740',9,'{}','success'),(6257,'sync-table-privileges',2,'2024-07-08 19:45:04.624381','2024-07-08 19:45:04.633565',9,NULL,'success'),(6258,'analyze',2,'2024-07-08 19:45:04.672817','2024-07-08 19:45:06.880901',2208,NULL,'success'),(6259,'fingerprint-fields',2,'2024-07-08 19:45:04.683185','2024-07-08 19:45:06.709829',2026,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6260,'classify-fields',2,'2024-07-08 19:45:06.718453','2024-07-08 19:45:06.847060',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6261,'classify-tables',2,'2024-07-08 19:45:06.855050','2024-07-08 19:45:06.870059',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6262,'sync',2,'2024-07-08 20:45:00.113680','2024-07-08 20:45:04.875825',4762,NULL,'success'),(6263,'sync-dbms-version',2,'2024-07-08 20:45:00.122318','2024-07-08 20:45:00.132847',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6264,'sync-timezone',2,'2024-07-08 20:45:00.143159','2024-07-08 20:45:00.155772',12,'{\"timezone-id\":\"+08:00\"}','success'),(6265,'sync-tables',2,'2024-07-08 20:45:00.164669','2024-07-08 20:45:00.196695',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6266,'sync-fields',2,'2024-07-08 20:45:00.206137','2024-07-08 20:45:03.445329',3239,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6267,'sync-fks',2,'2024-07-08 20:45:03.454455','2024-07-08 20:45:04.134836',680,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6268,'sync-indexes',2,'2024-07-08 20:45:04.143103','2024-07-08 20:45:04.828856',685,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6269,'sync-metabase-metadata',2,'2024-07-08 20:45:04.837134','2024-07-08 20:45:04.846999',9,'{}','success'),(6270,'sync-table-privileges',2,'2024-07-08 20:45:04.856010','2024-07-08 20:45:04.864952',8,NULL,'success'),(6271,'analyze',2,'2024-07-08 20:45:04.902174','2024-07-08 20:45:07.060027',2157,NULL,'success'),(6272,'fingerprint-fields',2,'2024-07-08 20:45:04.910189','2024-07-08 20:45:06.892916',1982,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6273,'classify-fields',2,'2024-07-08 20:45:06.901613','2024-07-08 20:45:07.027186',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6274,'classify-tables',2,'2024-07-08 20:45:07.035248','2024-07-08 20:45:07.051423',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6275,'sync',2,'2024-07-08 21:45:00.093662','2024-07-08 21:45:04.438076',4344,NULL,'success'),(6276,'sync-dbms-version',2,'2024-07-08 21:45:00.101384','2024-07-08 21:45:00.113711',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6277,'sync-timezone',2,'2024-07-08 21:45:00.122665','2024-07-08 21:45:00.132906',10,'{\"timezone-id\":\"+08:00\"}','success'),(6278,'sync-tables',2,'2024-07-08 21:45:00.141232','2024-07-08 21:45:00.173672',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6279,'sync-fields',2,'2024-07-08 21:45:00.183098','2024-07-08 21:45:03.176731',2993,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6280,'sync-fks',2,'2024-07-08 21:45:03.185251','2024-07-08 21:45:03.842380',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6281,'sync-indexes',2,'2024-07-08 21:45:03.850849','2024-07-08 21:45:04.394799',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6282,'sync-metabase-metadata',2,'2024-07-08 21:45:04.402719','2024-07-08 21:45:04.411248',8,'{}','success'),(6283,'sync-table-privileges',2,'2024-07-08 21:45:04.420274','2024-07-08 21:45:04.429707',9,NULL,'success'),(6284,'analyze',2,'2024-07-08 21:45:04.462371','2024-07-08 21:45:06.434186',1971,NULL,'success'),(6285,'fingerprint-fields',2,'2024-07-08 21:45:04.470365','2024-07-08 21:45:06.280952',1810,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6286,'classify-fields',2,'2024-07-08 21:45:06.289557','2024-07-08 21:45:06.404776',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6287,'classify-tables',2,'2024-07-08 21:45:06.412118','2024-07-08 21:45:06.425610',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6288,'sync',2,'2024-07-08 22:45:00.103017','2024-07-08 22:45:04.780303',4677,NULL,'success'),(6289,'sync-dbms-version',2,'2024-07-08 22:45:00.112833','2024-07-08 22:45:00.122472',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6290,'sync-timezone',2,'2024-07-08 22:45:00.131030','2024-07-08 22:45:00.142185',11,'{\"timezone-id\":\"+08:00\"}','success'),(6291,'sync-tables',2,'2024-07-08 22:45:00.150790','2024-07-08 22:45:00.178799',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6292,'sync-fields',2,'2024-07-08 22:45:00.187282','2024-07-08 22:45:03.428133',3240,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6293,'sync-fks',2,'2024-07-08 22:45:03.437243','2024-07-08 22:45:04.131196',693,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6294,'sync-indexes',2,'2024-07-08 22:45:04.140842','2024-07-08 22:45:04.739128',598,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6295,'sync-metabase-metadata',2,'2024-07-08 22:45:04.746427','2024-07-08 22:45:04.754357',7,'{}','success'),(6296,'sync-table-privileges',2,'2024-07-08 22:45:04.762385','2024-07-08 22:45:04.771833',9,NULL,'success'),(6297,'analyze',2,'2024-07-08 22:45:04.807540','2024-07-08 22:45:06.878265',2070,NULL,'success'),(6298,'fingerprint-fields',2,'2024-07-08 22:45:04.815498','2024-07-08 22:45:06.727661',1912,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6299,'classify-fields',2,'2024-07-08 22:45:06.736446','2024-07-08 22:45:06.848767',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6300,'classify-tables',2,'2024-07-08 22:45:06.856501','2024-07-08 22:45:06.869701',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6301,'sync',2,'2024-07-08 23:45:00.103036','2024-07-08 23:45:05.653712',5550,NULL,'success'),(6302,'sync-dbms-version',2,'2024-07-08 23:45:00.111795','2024-07-08 23:45:00.123065',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6303,'sync-timezone',2,'2024-07-08 23:45:00.132794','2024-07-08 23:45:00.144011',11,'{\"timezone-id\":\"+08:00\"}','success'),(6304,'sync-tables',2,'2024-07-08 23:45:00.153723','2024-07-08 23:45:00.184288',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6305,'sync-fields',2,'2024-07-08 23:45:00.193777','2024-07-08 23:45:03.465159',3271,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6306,'sync-fks',2,'2024-07-08 23:45:03.473606','2024-07-08 23:45:04.203227',729,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6307,'sync-indexes',2,'2024-07-08 23:45:04.213452','2024-07-08 23:45:05.611206',1397,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6308,'sync-metabase-metadata',2,'2024-07-08 23:45:05.619035','2024-07-08 23:45:05.629449',10,'{}','success'),(6309,'sync-table-privileges',2,'2024-07-08 23:45:05.637990','2024-07-08 23:45:05.646126',8,NULL,'success'),(6310,'analyze',2,'2024-07-08 23:45:05.686042','2024-07-08 23:45:07.870273',2184,NULL,'success'),(6311,'fingerprint-fields',2,'2024-07-08 23:45:05.694732','2024-07-08 23:45:07.709621',2014,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6312,'classify-fields',2,'2024-07-08 23:45:07.718362','2024-07-08 23:45:07.839709',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6313,'classify-tables',2,'2024-07-08 23:45:07.847577','2024-07-08 23:45:07.861862',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6314,'sync',2,'2024-07-09 00:45:00.102748','2024-07-09 00:45:04.284182',4181,NULL,'success'),(6315,'sync-dbms-version',2,'2024-07-09 00:45:00.111420','2024-07-09 00:45:00.122414',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6316,'sync-timezone',2,'2024-07-09 00:45:00.132574','2024-07-09 00:45:00.142902',10,'{\"timezone-id\":\"+08:00\"}','success'),(6317,'sync-tables',2,'2024-07-09 00:45:00.151268','2024-07-09 00:45:00.180745',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6318,'sync-fields',2,'2024-07-09 00:45:00.188861','2024-07-09 00:45:03.138652',2949,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6319,'sync-fks',2,'2024-07-09 00:45:03.146889','2024-07-09 00:45:03.729621',582,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6320,'sync-indexes',2,'2024-07-09 00:45:03.738087','2024-07-09 00:45:04.241344',503,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6321,'sync-metabase-metadata',2,'2024-07-09 00:45:04.249073','2024-07-09 00:45:04.257912',8,'{}','success'),(6322,'sync-table-privileges',2,'2024-07-09 00:45:04.266463','2024-07-09 00:45:04.276023',9,NULL,'success'),(6323,'analyze',2,'2024-07-09 00:45:04.309461','2024-07-09 00:45:06.379299',2069,NULL,'success'),(6324,'fingerprint-fields',2,'2024-07-09 00:45:04.317593','2024-07-09 00:45:06.206008',1888,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6325,'classify-fields',2,'2024-07-09 00:45:06.214473','2024-07-09 00:45:06.344362',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6326,'classify-tables',2,'2024-07-09 00:45:06.354100','2024-07-09 00:45:06.370425',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6327,'sync',2,'2024-07-09 01:45:00.090432','2024-07-09 01:45:04.408143',4317,NULL,'success'),(6328,'sync-dbms-version',2,'2024-07-09 01:45:00.098243','2024-07-09 01:45:00.107474',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6329,'sync-timezone',2,'2024-07-09 01:45:00.116305','2024-07-09 01:45:00.126254',9,'{\"timezone-id\":\"+08:00\"}','success'),(6330,'sync-tables',2,'2024-07-09 01:45:00.134639','2024-07-09 01:45:00.168784',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6331,'sync-fields',2,'2024-07-09 01:45:00.178704','2024-07-09 01:45:03.225252',3046,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6332,'sync-fks',2,'2024-07-09 01:45:03.232715','2024-07-09 01:45:03.825386',592,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6333,'sync-indexes',2,'2024-07-09 01:45:03.833115','2024-07-09 01:45:04.366482',533,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6334,'sync-metabase-metadata',2,'2024-07-09 01:45:04.373840','2024-07-09 01:45:04.383388',9,'{}','success'),(6335,'sync-table-privileges',2,'2024-07-09 01:45:04.391854','2024-07-09 01:45:04.399849',7,NULL,'success'),(6336,'analyze',2,'2024-07-09 01:45:04.436705','2024-07-09 01:45:06.477898',2041,NULL,'success'),(6337,'fingerprint-fields',2,'2024-07-09 01:45:04.445334','2024-07-09 01:45:06.333254',1887,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6338,'classify-fields',2,'2024-07-09 01:45:06.341345','2024-07-09 01:45:06.447333',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6339,'classify-tables',2,'2024-07-09 01:45:06.454862','2024-07-09 01:45:06.469447',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6340,'sync',2,'2024-07-09 02:45:00.122803','2024-07-09 02:45:04.878288',4755,NULL,'success'),(6341,'sync-dbms-version',2,'2024-07-09 02:45:00.132206','2024-07-09 02:45:00.141612',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6342,'sync-timezone',2,'2024-07-09 02:45:00.150872','2024-07-09 02:45:00.162256',11,'{\"timezone-id\":\"+08:00\"}','success'),(6343,'sync-tables',2,'2024-07-09 02:45:00.171082','2024-07-09 02:45:00.200499',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6344,'sync-fields',2,'2024-07-09 02:45:00.209175','2024-07-09 02:45:03.530821',3321,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6345,'sync-fks',2,'2024-07-09 02:45:03.540090','2024-07-09 02:45:04.238014',697,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6346,'sync-indexes',2,'2024-07-09 02:45:04.246406','2024-07-09 02:45:04.831365',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6347,'sync-metabase-metadata',2,'2024-07-09 02:45:04.840172','2024-07-09 02:45:04.849675',9,'{}','success'),(6348,'sync-table-privileges',2,'2024-07-09 02:45:04.859771','2024-07-09 02:45:04.869593',9,NULL,'success'),(6349,'analyze',2,'2024-07-09 02:45:04.906033','2024-07-09 02:45:06.966717',2060,NULL,'success'),(6350,'fingerprint-fields',2,'2024-07-09 02:45:04.915004','2024-07-09 02:45:06.825762',1910,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6351,'classify-fields',2,'2024-07-09 02:45:06.834144','2024-07-09 02:45:06.937961',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6352,'classify-tables',2,'2024-07-09 02:45:06.945471','2024-07-09 02:45:06.958407',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6353,'sync',2,'2024-07-09 03:45:00.126836','2024-07-09 03:45:04.615508',4488,NULL,'success'),(6354,'sync-dbms-version',2,'2024-07-09 03:45:00.136280','2024-07-09 03:45:00.145722',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6355,'sync-timezone',2,'2024-07-09 03:45:00.154678','2024-07-09 03:45:00.166021',11,'{\"timezone-id\":\"+08:00\"}','success'),(6356,'sync-tables',2,'2024-07-09 03:45:00.175299','2024-07-09 03:45:00.212274',36,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6357,'sync-fields',2,'2024-07-09 03:45:00.221650','2024-07-09 03:45:03.384126',3162,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6358,'sync-fks',2,'2024-07-09 03:45:03.394011','2024-07-09 03:45:03.999338',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6359,'sync-indexes',2,'2024-07-09 03:45:04.015343','2024-07-09 03:45:04.570099',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6360,'sync-metabase-metadata',2,'2024-07-09 03:45:04.578039','2024-07-09 03:45:04.587915',9,'{}','success'),(6361,'sync-table-privileges',2,'2024-07-09 03:45:04.596660','2024-07-09 03:45:04.606418',9,NULL,'success'),(6362,'analyze',2,'2024-07-09 03:45:04.642502','2024-07-09 03:45:06.723481',2080,NULL,'success'),(6363,'fingerprint-fields',2,'2024-07-09 03:45:04.651942','2024-07-09 03:45:06.567888',1915,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6364,'classify-fields',2,'2024-07-09 03:45:06.578139','2024-07-09 03:45:06.693875',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6365,'classify-tables',2,'2024-07-09 03:45:06.701654','2024-07-09 03:45:06.714678',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6366,'task-history-cleanup',NULL,'2024-07-09 04:00:00.051304','2024-07-09 04:00:00.074923',23,NULL,'success'),(6367,'sync',2,'2024-07-09 04:45:00.098667','2024-07-09 04:45:04.479890',4381,NULL,'success'),(6368,'sync-dbms-version',2,'2024-07-09 04:45:00.107251','2024-07-09 04:45:00.116773',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6369,'sync-timezone',2,'2024-07-09 04:45:00.125567','2024-07-09 04:45:00.135982',10,'{\"timezone-id\":\"+08:00\"}','success'),(6370,'sync-tables',2,'2024-07-09 04:45:00.144775','2024-07-09 04:45:00.175450',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6371,'sync-fields',2,'2024-07-09 04:45:00.184265','2024-07-09 04:45:03.219022',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6372,'sync-fks',2,'2024-07-09 04:45:03.228039','2024-07-09 04:45:03.875327',647,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6373,'sync-indexes',2,'2024-07-09 04:45:03.883209','2024-07-09 04:45:04.437342',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6374,'sync-metabase-metadata',2,'2024-07-09 04:45:04.445407','2024-07-09 04:45:04.453488',8,'{}','success'),(6375,'sync-table-privileges',2,'2024-07-09 04:45:04.462264','2024-07-09 04:45:04.471147',8,NULL,'success'),(6376,'analyze',2,'2024-07-09 04:45:04.504427','2024-07-09 04:45:06.556573',2052,NULL,'success'),(6377,'fingerprint-fields',2,'2024-07-09 04:45:04.512663','2024-07-09 04:45:06.407008',1894,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6378,'classify-fields',2,'2024-07-09 04:45:06.415384','2024-07-09 04:45:06.526478',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6379,'classify-tables',2,'2024-07-09 04:45:06.535142','2024-07-09 04:45:06.548122',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6380,'sync',2,'2024-07-09 05:45:00.096170','2024-07-09 05:45:04.614155',4517,NULL,'success'),(6381,'sync-dbms-version',2,'2024-07-09 05:45:00.104186','2024-07-09 05:45:00.113606',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6382,'sync-timezone',2,'2024-07-09 05:45:00.121868','2024-07-09 05:45:00.131386',9,'{\"timezone-id\":\"+08:00\"}','success'),(6383,'sync-tables',2,'2024-07-09 05:45:00.140892','2024-07-09 05:45:00.168982',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6384,'sync-fields',2,'2024-07-09 05:45:00.177451','2024-07-09 05:45:03.322014',3144,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6385,'sync-fks',2,'2024-07-09 05:45:03.330356','2024-07-09 05:45:03.992152',661,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6386,'sync-indexes',2,'2024-07-09 05:45:04.001969','2024-07-09 05:45:04.571114',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6387,'sync-metabase-metadata',2,'2024-07-09 05:45:04.578826','2024-07-09 05:45:04.587487',8,'{}','success'),(6388,'sync-table-privileges',2,'2024-07-09 05:45:04.596484','2024-07-09 05:45:04.605856',9,NULL,'success'),(6389,'analyze',2,'2024-07-09 05:45:04.637793','2024-07-09 05:45:06.865518',2227,NULL,'success'),(6390,'fingerprint-fields',2,'2024-07-09 05:45:04.646175','2024-07-09 05:45:06.697979',2051,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6391,'classify-fields',2,'2024-07-09 05:45:06.706494','2024-07-09 05:45:06.830416',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6392,'classify-tables',2,'2024-07-09 05:45:06.841292','2024-07-09 05:45:06.856298',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6393,'sync',2,'2024-07-09 06:45:00.106837','2024-07-09 06:45:04.498862',4392,NULL,'success'),(6394,'sync-dbms-version',2,'2024-07-09 06:45:00.116331','2024-07-09 06:45:00.126881',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6395,'sync-timezone',2,'2024-07-09 06:45:00.136210','2024-07-09 06:45:00.147648',11,'{\"timezone-id\":\"+08:00\"}','success'),(6396,'sync-tables',2,'2024-07-09 06:45:00.156465','2024-07-09 06:45:00.184107',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6397,'sync-fields',2,'2024-07-09 06:45:00.193341','2024-07-09 06:45:03.294960',3101,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6398,'sync-fks',2,'2024-07-09 06:45:03.302368','2024-07-09 06:45:03.911873',609,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6399,'sync-indexes',2,'2024-07-09 06:45:03.919684','2024-07-09 06:45:04.447823',528,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6400,'sync-metabase-metadata',2,'2024-07-09 06:45:04.456208','2024-07-09 06:45:04.466864',10,'{}','success'),(6401,'sync-table-privileges',2,'2024-07-09 06:45:04.478963','2024-07-09 06:45:04.486909',7,NULL,'success'),(6402,'analyze',2,'2024-07-09 06:45:04.525191','2024-07-09 06:45:06.550032',2024,NULL,'success'),(6403,'fingerprint-fields',2,'2024-07-09 06:45:04.533159','2024-07-09 06:45:06.313408',1780,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6404,'classify-fields',2,'2024-07-09 06:45:06.322739','2024-07-09 06:45:06.516256',193,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6405,'classify-tables',2,'2024-07-09 06:45:06.523779','2024-07-09 06:45:06.542366',18,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6406,'sync',2,'2024-07-09 07:45:00.103487','2024-07-09 07:45:04.395768',4292,NULL,'success'),(6407,'sync-dbms-version',2,'2024-07-09 07:45:00.111772','2024-07-09 07:45:00.120811',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6408,'sync-timezone',2,'2024-07-09 07:45:00.130313','2024-07-09 07:45:00.140304',9,'{\"timezone-id\":\"+08:00\"}','success'),(6409,'sync-tables',2,'2024-07-09 07:45:00.148828','2024-07-09 07:45:00.178441',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6410,'sync-fields',2,'2024-07-09 07:45:00.187279','2024-07-09 07:45:03.185655',2998,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6411,'sync-fks',2,'2024-07-09 07:45:03.194109','2024-07-09 07:45:03.804780',610,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6412,'sync-indexes',2,'2024-07-09 07:45:03.812949','2024-07-09 07:45:04.353850',540,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6413,'sync-metabase-metadata',2,'2024-07-09 07:45:04.361598','2024-07-09 07:45:04.369785',8,'{}','success'),(6414,'sync-table-privileges',2,'2024-07-09 07:45:04.378375','2024-07-09 07:45:04.386831',8,NULL,'success'),(6415,'analyze',2,'2024-07-09 07:45:04.420804','2024-07-09 07:45:06.538781',2117,NULL,'success'),(6416,'fingerprint-fields',2,'2024-07-09 07:45:04.430644','2024-07-09 07:45:06.370560',1939,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6417,'classify-fields',2,'2024-07-09 07:45:06.379236','2024-07-09 07:45:06.504301',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6418,'classify-tables',2,'2024-07-09 07:45:06.512855','2024-07-09 07:45:06.529430',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6419,'sync',2,'2024-07-09 08:45:00.099198','2024-07-09 08:45:04.256609',4157,NULL,'success'),(6420,'sync-dbms-version',2,'2024-07-09 08:45:00.108378','2024-07-09 08:45:00.117423',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6421,'sync-timezone',2,'2024-07-09 08:45:00.125540','2024-07-09 08:45:00.135179',9,'{\"timezone-id\":\"+08:00\"}','success'),(6422,'sync-tables',2,'2024-07-09 08:45:00.144275','2024-07-09 08:45:00.171137',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6423,'sync-fields',2,'2024-07-09 08:45:00.179173','2024-07-09 08:45:03.065024',2885,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6424,'sync-fks',2,'2024-07-09 08:45:03.073299','2024-07-09 08:45:03.686553',613,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6425,'sync-indexes',2,'2024-07-09 08:45:03.694511','2024-07-09 08:45:04.211393',516,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6426,'sync-metabase-metadata',2,'2024-07-09 08:45:04.219264','2024-07-09 08:45:04.228387',9,'{}','success'),(6427,'sync-table-privileges',2,'2024-07-09 08:45:04.236794','2024-07-09 08:45:04.247680',10,NULL,'success'),(6428,'analyze',2,'2024-07-09 08:45:04.283762','2024-07-09 08:45:06.225706',1941,NULL,'success'),(6429,'fingerprint-fields',2,'2024-07-09 08:45:04.292601','2024-07-09 08:45:06.082423',1789,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6430,'classify-fields',2,'2024-07-09 08:45:06.090614','2024-07-09 08:45:06.196606',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6431,'classify-tables',2,'2024-07-09 08:45:06.204024','2024-07-09 08:45:06.218001',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6432,'sync',2,'2024-07-09 09:45:00.110166','2024-07-09 09:45:04.398216',4288,NULL,'success'),(6433,'sync-dbms-version',2,'2024-07-09 09:45:00.118913','2024-07-09 09:45:00.129878',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6434,'sync-timezone',2,'2024-07-09 09:45:00.139373','2024-07-09 09:45:00.150326',10,'{\"timezone-id\":\"+08:00\"}','success'),(6435,'sync-tables',2,'2024-07-09 09:45:00.159138','2024-07-09 09:45:00.187196',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6436,'sync-fields',2,'2024-07-09 09:45:00.196469','2024-07-09 09:45:03.252218',3055,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6437,'sync-fks',2,'2024-07-09 09:45:03.260935','2024-07-09 09:45:03.850858',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6438,'sync-indexes',2,'2024-07-09 09:45:03.859963','2024-07-09 09:45:04.352686',492,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6439,'sync-metabase-metadata',2,'2024-07-09 09:45:04.360827','2024-07-09 09:45:04.370026',9,'{}','success'),(6440,'sync-table-privileges',2,'2024-07-09 09:45:04.380066','2024-07-09 09:45:04.389549',9,NULL,'success'),(6441,'analyze',2,'2024-07-09 09:45:04.423757','2024-07-09 09:45:06.348982',1925,NULL,'success'),(6442,'fingerprint-fields',2,'2024-07-09 09:45:04.432628','2024-07-09 09:45:06.211226',1778,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6443,'classify-fields',2,'2024-07-09 09:45:06.218745','2024-07-09 09:45:06.321335',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6444,'classify-tables',2,'2024-07-09 09:45:06.328563','2024-07-09 09:45:06.341350',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6445,'sync',2,'2024-07-09 10:45:00.104289','2024-07-09 10:45:04.118900',4014,NULL,'success'),(6446,'sync-dbms-version',2,'2024-07-09 10:45:00.112791','2024-07-09 10:45:00.121760',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6447,'sync-timezone',2,'2024-07-09 10:45:00.130847','2024-07-09 10:45:00.141443',10,'{\"timezone-id\":\"+08:00\"}','success'),(6448,'sync-tables',2,'2024-07-09 10:45:00.149750','2024-07-09 10:45:00.177697',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6449,'sync-fields',2,'2024-07-09 10:45:00.186078','2024-07-09 10:45:02.915321',2729,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6450,'sync-fks',2,'2024-07-09 10:45:02.923162','2024-07-09 10:45:03.561610',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6451,'sync-indexes',2,'2024-07-09 10:45:03.569273','2024-07-09 10:45:04.074822',505,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6452,'sync-metabase-metadata',2,'2024-07-09 10:45:04.083399','2024-07-09 10:45:04.091647',8,'{}','success'),(6453,'sync-table-privileges',2,'2024-07-09 10:45:04.101797','2024-07-09 10:45:04.110650',8,NULL,'success'),(6454,'analyze',2,'2024-07-09 10:45:04.143362','2024-07-09 10:45:06.123961',1980,NULL,'success'),(6455,'fingerprint-fields',2,'2024-07-09 10:45:04.151445','2024-07-09 10:45:05.963028',1811,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6456,'classify-fields',2,'2024-07-09 10:45:05.972022','2024-07-09 10:45:06.090361',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6457,'classify-tables',2,'2024-07-09 10:45:06.098393','2024-07-09 10:45:06.113494',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6458,'sync',2,'2024-07-09 11:45:00.096723','2024-07-09 11:45:04.214060',4117,NULL,'success'),(6459,'sync-dbms-version',2,'2024-07-09 11:45:00.104982','2024-07-09 11:45:00.114013',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6460,'sync-timezone',2,'2024-07-09 11:45:00.122697','2024-07-09 11:45:00.131962',9,'{\"timezone-id\":\"+08:00\"}','success'),(6461,'sync-tables',2,'2024-07-09 11:45:00.139995','2024-07-09 11:45:00.166914',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6462,'sync-fields',2,'2024-07-09 11:45:00.175522','2024-07-09 11:45:03.110966',2935,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6463,'sync-fks',2,'2024-07-09 11:45:03.118939','2024-07-09 11:45:03.708802',589,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6464,'sync-indexes',2,'2024-07-09 11:45:03.716672','2024-07-09 11:45:04.171975',455,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6465,'sync-metabase-metadata',2,'2024-07-09 11:45:04.178948','2024-07-09 11:45:04.187198',8,'{}','success'),(6466,'sync-table-privileges',2,'2024-07-09 11:45:04.195274','2024-07-09 11:45:04.205841',10,NULL,'success'),(6467,'analyze',2,'2024-07-09 11:45:04.237387','2024-07-09 11:45:06.235074',1997,NULL,'success'),(6468,'fingerprint-fields',2,'2024-07-09 11:45:04.245262','2024-07-09 11:45:06.077823',1832,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6469,'classify-fields',2,'2024-07-09 11:45:06.086218','2024-07-09 11:45:06.204752',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6470,'classify-tables',2,'2024-07-09 11:45:06.213027','2024-07-09 11:45:06.226326',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6471,'sync',2,'2024-07-09 12:45:00.110645','2024-07-09 12:45:04.103435',3992,NULL,'success'),(6472,'sync-dbms-version',2,'2024-07-09 12:45:00.119957','2024-07-09 12:45:00.129690',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6473,'sync-timezone',2,'2024-07-09 12:45:00.138712','2024-07-09 12:45:00.148618',9,'{\"timezone-id\":\"+08:00\"}','success'),(6474,'sync-tables',2,'2024-07-09 12:45:00.157234','2024-07-09 12:45:00.184056',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6475,'sync-fields',2,'2024-07-09 12:45:00.191902','2024-07-09 12:45:03.009091',2817,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6476,'sync-fks',2,'2024-07-09 12:45:03.017553','2024-07-09 12:45:03.592764',575,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6477,'sync-indexes',2,'2024-07-09 12:45:03.601397','2024-07-09 12:45:04.063751',462,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6478,'sync-metabase-metadata',2,'2024-07-09 12:45:04.071084','2024-07-09 12:45:04.079067',7,'{}','success'),(6479,'sync-table-privileges',2,'2024-07-09 12:45:04.087858','2024-07-09 12:45:04.095933',8,NULL,'success'),(6480,'analyze',2,'2024-07-09 12:45:04.126992','2024-07-09 12:45:06.102344',1975,NULL,'success'),(6481,'fingerprint-fields',2,'2024-07-09 12:45:04.134454','2024-07-09 12:45:05.944067',1809,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6482,'classify-fields',2,'2024-07-09 12:45:05.952358','2024-07-09 12:45:06.069459',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6483,'classify-tables',2,'2024-07-09 12:45:06.079127','2024-07-09 12:45:06.093778',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6484,'field values scanning',2,'2024-07-09 13:00:00.049921','2024-07-09 13:00:04.108434',4058,NULL,'success'),(6485,'delete-expired-advanced-field-values',2,'2024-07-09 13:00:00.072176','2024-07-09 13:00:02.944720',2872,'{\"deleted\":0}','success'),(6486,'update-field-values',2,'2024-07-09 13:00:02.952688','2024-07-09 13:00:04.101008',1148,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(6487,'sync',2,'2024-07-09 13:45:00.098194','2024-07-09 13:45:04.102457',4004,NULL,'success'),(6488,'sync-dbms-version',2,'2024-07-09 13:45:00.105906','2024-07-09 13:45:00.114274',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6489,'sync-timezone',2,'2024-07-09 13:45:00.122112','2024-07-09 13:45:00.131060',8,'{\"timezone-id\":\"+08:00\"}','success'),(6490,'sync-tables',2,'2024-07-09 13:45:00.139495','2024-07-09 13:45:00.165755',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6491,'sync-fields',2,'2024-07-09 13:45:00.173940','2024-07-09 13:45:03.011617',2837,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6492,'sync-fks',2,'2024-07-09 13:45:03.019543','2024-07-09 13:45:03.590265',570,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6493,'sync-indexes',2,'2024-07-09 13:45:03.598041','2024-07-09 13:45:04.059915',461,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6494,'sync-metabase-metadata',2,'2024-07-09 13:45:04.066947','2024-07-09 13:45:04.075012',8,'{}','success'),(6495,'sync-table-privileges',2,'2024-07-09 13:45:04.082886','2024-07-09 13:45:04.093269',10,NULL,'success'),(6496,'analyze',2,'2024-07-09 13:45:04.129673','2024-07-09 13:45:06.125872',1996,NULL,'success'),(6497,'fingerprint-fields',2,'2024-07-09 13:45:04.138532','2024-07-09 13:45:05.987354',1848,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6498,'classify-fields',2,'2024-07-09 13:45:05.995304','2024-07-09 13:45:06.097137',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6499,'classify-tables',2,'2024-07-09 13:45:06.104104','2024-07-09 13:45:06.117307',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6500,'sync',2,'2024-07-09 14:45:00.092848','2024-07-09 14:45:04.001898',3909,NULL,'success'),(6501,'sync-dbms-version',2,'2024-07-09 14:45:00.101183','2024-07-09 14:45:00.111433',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6502,'sync-timezone',2,'2024-07-09 14:45:00.119486','2024-07-09 14:45:00.127471',7,'{\"timezone-id\":\"+08:00\"}','success'),(6503,'sync-tables',2,'2024-07-09 14:45:00.137418','2024-07-09 14:45:00.174851',37,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6504,'sync-fields',2,'2024-07-09 14:45:00.185231','2024-07-09 14:45:02.887910',2702,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6505,'sync-fks',2,'2024-07-09 14:45:02.894938','2024-07-09 14:45:03.461949',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6506,'sync-indexes',2,'2024-07-09 14:45:03.470613','2024-07-09 14:45:03.962221',491,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6507,'sync-metabase-metadata',2,'2024-07-09 14:45:03.969380','2024-07-09 14:45:03.976973',7,'{}','success'),(6508,'sync-table-privileges',2,'2024-07-09 14:45:03.984552','2024-07-09 14:45:03.992832',8,NULL,'success'),(6509,'analyze',2,'2024-07-09 14:45:04.027921','2024-07-09 14:45:05.987576',1959,NULL,'success'),(6510,'fingerprint-fields',2,'2024-07-09 14:45:04.036150','2024-07-09 14:45:05.836051',1799,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6511,'classify-fields',2,'2024-07-09 14:45:05.843671','2024-07-09 14:45:05.954883',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6512,'classify-tables',2,'2024-07-09 14:45:05.962808','2024-07-09 14:45:05.978642',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6513,'sync',2,'2024-07-09 15:45:00.102835','2024-07-09 15:45:04.369497',4266,NULL,'success'),(6514,'sync-dbms-version',2,'2024-07-09 15:45:00.110829','2024-07-09 15:45:00.119820',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6515,'sync-timezone',2,'2024-07-09 15:45:00.128342','2024-07-09 15:45:00.138253',9,'{\"timezone-id\":\"+08:00\"}','success'),(6516,'sync-tables',2,'2024-07-09 15:45:00.146953','2024-07-09 15:45:00.174836',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6517,'sync-fields',2,'2024-07-09 15:45:00.185542','2024-07-09 15:45:03.217957',3032,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6518,'sync-fks',2,'2024-07-09 15:45:03.227552','2024-07-09 15:45:03.789263',561,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6519,'sync-indexes',2,'2024-07-09 15:45:03.798328','2024-07-09 15:45:04.324979',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6520,'sync-metabase-metadata',2,'2024-07-09 15:45:04.333507','2024-07-09 15:45:04.342306',8,'{}','success'),(6521,'sync-table-privileges',2,'2024-07-09 15:45:04.351098','2024-07-09 15:45:04.360684',9,NULL,'success'),(6522,'analyze',2,'2024-07-09 15:45:04.395790','2024-07-09 15:45:06.488672',2092,NULL,'success'),(6523,'fingerprint-fields',2,'2024-07-09 15:45:04.404514','2024-07-09 15:45:06.345690',1941,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6524,'classify-fields',2,'2024-07-09 15:45:06.353351','2024-07-09 15:45:06.460312',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6525,'classify-tables',2,'2024-07-09 15:45:06.468557','2024-07-09 15:45:06.480862',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6526,'task-history-cleanup',NULL,'2024-07-09 16:00:00.028928','2024-07-09 16:00:00.074689',45,NULL,'success'),(6527,'task-history-cleanup',NULL,'2024-07-09 16:00:00.095186','2024-07-09 16:00:00.112014',16,NULL,'success'),(6528,'sync',2,'2024-07-09 16:45:00.100052','2024-07-09 16:45:04.428961',4328,NULL,'success'),(6529,'sync-dbms-version',2,'2024-07-09 16:45:00.111105','2024-07-09 16:45:00.120837',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6530,'sync-timezone',2,'2024-07-09 16:45:00.129376','2024-07-09 16:45:00.139688',10,'{\"timezone-id\":\"+08:00\"}','success'),(6531,'sync-tables',2,'2024-07-09 16:45:00.148303','2024-07-09 16:45:00.173209',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6532,'sync-fields',2,'2024-07-09 16:45:00.182573','2024-07-09 16:45:03.192980',3010,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6533,'sync-fks',2,'2024-07-09 16:45:03.201792','2024-07-09 16:45:03.830338',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6534,'sync-indexes',2,'2024-07-09 16:45:03.838880','2024-07-09 16:45:04.387905',549,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6535,'sync-metabase-metadata',2,'2024-07-09 16:45:04.395302','2024-07-09 16:45:04.403418',8,'{}','success'),(6536,'sync-table-privileges',2,'2024-07-09 16:45:04.412250','2024-07-09 16:45:04.420237',7,NULL,'success'),(6537,'analyze',2,'2024-07-09 16:45:04.456761','2024-07-09 16:45:06.369002',1912,NULL,'success'),(6538,'fingerprint-fields',2,'2024-07-09 16:45:04.464952','2024-07-09 16:45:06.199773',1734,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6539,'classify-fields',2,'2024-07-09 16:45:06.207473','2024-07-09 16:45:06.339438',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6540,'classify-tables',2,'2024-07-09 16:45:06.347025','2024-07-09 16:45:06.359852',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6541,'sync',2,'2024-07-09 17:45:00.115028','2024-07-09 17:45:04.798217',4683,NULL,'success'),(6542,'sync-dbms-version',2,'2024-07-09 17:45:00.122552','2024-07-09 17:45:00.132049',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6543,'sync-timezone',2,'2024-07-09 17:45:00.140419','2024-07-09 17:45:00.151699',11,'{\"timezone-id\":\"+08:00\"}','success'),(6544,'sync-tables',2,'2024-07-09 17:45:00.161109','2024-07-09 17:45:00.189107',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6545,'sync-fields',2,'2024-07-09 17:45:00.197411','2024-07-09 17:45:03.446668',3249,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6546,'sync-fks',2,'2024-07-09 17:45:03.455112','2024-07-09 17:45:04.151014',695,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6547,'sync-indexes',2,'2024-07-09 17:45:04.159825','2024-07-09 17:45:04.756943',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6548,'sync-metabase-metadata',2,'2024-07-09 17:45:04.764453','2024-07-09 17:45:04.772550',8,'{}','success'),(6549,'sync-table-privileges',2,'2024-07-09 17:45:04.781709','2024-07-09 17:45:04.790060',8,NULL,'success'),(6550,'analyze',2,'2024-07-09 17:45:04.822748','2024-07-09 17:45:06.971317',2148,NULL,'success'),(6551,'fingerprint-fields',2,'2024-07-09 17:45:04.830908','2024-07-09 17:45:06.806017',1975,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6552,'classify-fields',2,'2024-07-09 17:45:06.814144','2024-07-09 17:45:06.940838',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6553,'classify-tables',2,'2024-07-09 17:45:06.949619','2024-07-09 17:45:06.962838',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6554,'sync',2,'2024-07-09 18:45:00.113907','2024-07-09 18:45:04.620864',4506,NULL,'success'),(6555,'sync-dbms-version',2,'2024-07-09 18:45:00.121954','2024-07-09 18:45:00.131075',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6556,'sync-timezone',2,'2024-07-09 18:45:00.140270','2024-07-09 18:45:00.151491',11,'{\"timezone-id\":\"+08:00\"}','success'),(6557,'sync-tables',2,'2024-07-09 18:45:00.159831','2024-07-09 18:45:00.187704',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6558,'sync-fields',2,'2024-07-09 18:45:00.196192','2024-07-09 18:45:03.295188',3098,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6559,'sync-fks',2,'2024-07-09 18:45:03.303384','2024-07-09 18:45:03.980469',677,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6560,'sync-indexes',2,'2024-07-09 18:45:03.990001','2024-07-09 18:45:04.576737',586,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6561,'sync-metabase-metadata',2,'2024-07-09 18:45:04.584741','2024-07-09 18:45:04.592940',8,'{}','success'),(6562,'sync-table-privileges',2,'2024-07-09 18:45:04.602477','2024-07-09 18:45:04.612398',9,NULL,'success'),(6563,'analyze',2,'2024-07-09 18:45:04.645025','2024-07-09 18:45:06.864450',2219,NULL,'success'),(6564,'fingerprint-fields',2,'2024-07-09 18:45:04.653768','2024-07-09 18:45:06.703809',2050,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6565,'classify-fields',2,'2024-07-09 18:45:06.713320','2024-07-09 18:45:06.833061',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6566,'classify-tables',2,'2024-07-09 18:45:06.841259','2024-07-09 18:45:06.855504',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6567,'sync',2,'2024-07-09 19:45:00.122291','2024-07-09 19:45:04.902168',4779,NULL,'success'),(6568,'sync-dbms-version',2,'2024-07-09 19:45:00.132022','2024-07-09 19:45:00.143199',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6569,'sync-timezone',2,'2024-07-09 19:45:00.152504','2024-07-09 19:45:00.163502',10,'{\"timezone-id\":\"+08:00\"}','success'),(6570,'sync-tables',2,'2024-07-09 19:45:00.173549','2024-07-09 19:45:00.207875',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6571,'sync-fields',2,'2024-07-09 19:45:00.218138','2024-07-09 19:45:03.472555',3254,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6572,'sync-fks',2,'2024-07-09 19:45:03.482559','2024-07-09 19:45:04.242858',760,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6573,'sync-indexes',2,'2024-07-09 19:45:04.251875','2024-07-09 19:45:04.859971',608,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6574,'sync-metabase-metadata',2,'2024-07-09 19:45:04.867560','2024-07-09 19:45:04.877127',9,'{}','success'),(6575,'sync-table-privileges',2,'2024-07-09 19:45:04.885663','2024-07-09 19:45:04.894389',8,NULL,'success'),(6576,'analyze',2,'2024-07-09 19:45:04.927329','2024-07-09 19:45:07.120544',2193,NULL,'success'),(6577,'fingerprint-fields',2,'2024-07-09 19:45:04.935142','2024-07-09 19:45:06.947937',2012,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6578,'classify-fields',2,'2024-07-09 19:45:06.957114','2024-07-09 19:45:07.087998',130,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6579,'classify-tables',2,'2024-07-09 19:45:07.096289','2024-07-09 19:45:07.111433',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6580,'sync',2,'2024-07-09 20:45:00.111954','2024-07-09 20:45:04.674827',4562,NULL,'success'),(6581,'sync-dbms-version',2,'2024-07-09 20:45:00.120521','2024-07-09 20:45:00.130201',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6582,'sync-timezone',2,'2024-07-09 20:45:00.139142','2024-07-09 20:45:00.152142',13,'{\"timezone-id\":\"+08:00\"}','success'),(6583,'sync-tables',2,'2024-07-09 20:45:00.161320','2024-07-09 20:45:00.188452',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6584,'sync-fields',2,'2024-07-09 20:45:00.196889','2024-07-09 20:45:03.274177',3077,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6585,'sync-fks',2,'2024-07-09 20:45:03.283255','2024-07-09 20:45:03.981143',697,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6586,'sync-indexes',2,'2024-07-09 20:45:03.990295','2024-07-09 20:45:04.631268',640,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6587,'sync-metabase-metadata',2,'2024-07-09 20:45:04.639187','2024-07-09 20:45:04.647780',8,'{}','success'),(6588,'sync-table-privileges',2,'2024-07-09 20:45:04.656132','2024-07-09 20:45:04.665987',9,NULL,'success'),(6589,'analyze',2,'2024-07-09 20:45:04.706413','2024-07-09 20:45:06.870209',2163,NULL,'success'),(6590,'fingerprint-fields',2,'2024-07-09 20:45:04.716086','2024-07-09 20:45:06.694063',1977,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6591,'classify-fields',2,'2024-07-09 20:45:06.702057','2024-07-09 20:45:06.837749',135,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6592,'classify-tables',2,'2024-07-09 20:45:06.846367','2024-07-09 20:45:06.861653',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6593,'sync',2,'2024-07-09 21:45:00.103780','2024-07-09 21:45:04.361657',4257,NULL,'success'),(6594,'sync-dbms-version',2,'2024-07-09 21:45:00.114559','2024-07-09 21:45:00.124662',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6595,'sync-timezone',2,'2024-07-09 21:45:00.133385','2024-07-09 21:45:00.143996',10,'{\"timezone-id\":\"+08:00\"}','success'),(6596,'sync-tables',2,'2024-07-09 21:45:00.152553','2024-07-09 21:45:00.180308',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6597,'sync-fields',2,'2024-07-09 21:45:00.190183','2024-07-09 21:45:03.045446',2855,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6598,'sync-fks',2,'2024-07-09 21:45:03.053822','2024-07-09 21:45:03.632928',579,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6599,'sync-indexes',2,'2024-07-09 21:45:03.640863','2024-07-09 21:45:04.321871',681,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6600,'sync-metabase-metadata',2,'2024-07-09 21:45:04.329011','2024-07-09 21:45:04.337228',8,'{}','success'),(6601,'sync-table-privileges',2,'2024-07-09 21:45:04.345157','2024-07-09 21:45:04.353696',8,NULL,'success'),(6602,'analyze',2,'2024-07-09 21:45:04.385125','2024-07-09 21:45:06.343682',1958,NULL,'success'),(6603,'fingerprint-fields',2,'2024-07-09 21:45:04.393139','2024-07-09 21:45:06.193574',1800,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6604,'classify-fields',2,'2024-07-09 21:45:06.201999','2024-07-09 21:45:06.313920',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6605,'classify-tables',2,'2024-07-09 21:45:06.321545','2024-07-09 21:45:06.335161',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6606,'sync',2,'2024-07-09 22:45:00.112234','2024-07-09 22:45:04.568431',4456,NULL,'success'),(6607,'sync-dbms-version',2,'2024-07-09 22:45:00.121176','2024-07-09 22:45:00.132482',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6608,'sync-timezone',2,'2024-07-09 22:45:00.142323','2024-07-09 22:45:00.153301',10,'{\"timezone-id\":\"+08:00\"}','success'),(6609,'sync-tables',2,'2024-07-09 22:45:00.162371','2024-07-09 22:45:00.193167',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6610,'sync-fields',2,'2024-07-09 22:45:00.202319','2024-07-09 22:45:03.385273',3182,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6611,'sync-fks',2,'2024-07-09 22:45:03.393212','2024-07-09 22:45:04.012812',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6612,'sync-indexes',2,'2024-07-09 22:45:04.021291','2024-07-09 22:45:04.528867',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6613,'sync-metabase-metadata',2,'2024-07-09 22:45:04.535980','2024-07-09 22:45:04.543467',7,'{}','success'),(6614,'sync-table-privileges',2,'2024-07-09 22:45:04.551628','2024-07-09 22:45:04.559849',8,NULL,'success'),(6615,'analyze',2,'2024-07-09 22:45:04.593763','2024-07-09 22:45:06.573740',1979,NULL,'success'),(6616,'fingerprint-fields',2,'2024-07-09 22:45:04.601750','2024-07-09 22:45:06.420710',1818,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6617,'classify-fields',2,'2024-07-09 22:45:06.429193','2024-07-09 22:45:06.539496',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6618,'classify-tables',2,'2024-07-09 22:45:06.547261','2024-07-09 22:45:06.564674',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6619,'sync',2,'2024-07-09 23:45:00.101438','2024-07-09 23:45:04.615190',4513,NULL,'success'),(6620,'sync-dbms-version',2,'2024-07-09 23:45:00.110347','2024-07-09 23:45:00.120659',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6621,'sync-timezone',2,'2024-07-09 23:45:00.129671','2024-07-09 23:45:00.140935',11,'{\"timezone-id\":\"+08:00\"}','success'),(6622,'sync-tables',2,'2024-07-09 23:45:00.150762','2024-07-09 23:45:00.182419',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6623,'sync-fields',2,'2024-07-09 23:45:00.191520','2024-07-09 23:45:03.345938',3154,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6624,'sync-fks',2,'2024-07-09 23:45:03.354173','2024-07-09 23:45:03.988269',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6625,'sync-indexes',2,'2024-07-09 23:45:03.996610','2024-07-09 23:45:04.573495',576,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6626,'sync-metabase-metadata',2,'2024-07-09 23:45:04.581121','2024-07-09 23:45:04.590327',9,'{}','success'),(6627,'sync-table-privileges',2,'2024-07-09 23:45:04.598727','2024-07-09 23:45:04.607042',8,NULL,'success'),(6628,'analyze',2,'2024-07-09 23:45:04.640605','2024-07-09 23:45:06.663950',2023,NULL,'success'),(6629,'fingerprint-fields',2,'2024-07-09 23:45:04.648897','2024-07-09 23:45:06.523320',1874,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6630,'classify-fields',2,'2024-07-09 23:45:06.531537','2024-07-09 23:45:06.633959',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6631,'classify-tables',2,'2024-07-09 23:45:06.641148','2024-07-09 23:45:06.654697',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6632,'sync',2,'2024-07-10 00:45:00.096499','2024-07-10 00:45:05.244532',5148,NULL,'success'),(6633,'sync-dbms-version',2,'2024-07-10 00:45:00.105200','2024-07-10 00:45:00.114901',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6634,'sync-timezone',2,'2024-07-10 00:45:00.124272','2024-07-10 00:45:00.135856',11,'{\"timezone-id\":\"+08:00\"}','success'),(6635,'sync-tables',2,'2024-07-10 00:45:00.144135','2024-07-10 00:45:00.170358',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6636,'sync-fields',2,'2024-07-10 00:45:00.178642','2024-07-10 00:45:03.212756',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6637,'sync-fks',2,'2024-07-10 00:45:03.220609','2024-07-10 00:45:03.873920',653,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6638,'sync-indexes',2,'2024-07-10 00:45:03.883014','2024-07-10 00:45:05.199753',1316,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6639,'sync-metabase-metadata',2,'2024-07-10 00:45:05.207891','2024-07-10 00:45:05.216287',8,'{}','success'),(6640,'sync-table-privileges',2,'2024-07-10 00:45:05.225913','2024-07-10 00:45:05.235722',9,NULL,'success'),(6641,'analyze',2,'2024-07-10 00:45:05.270140','2024-07-10 00:45:07.407466',2137,NULL,'success'),(6642,'fingerprint-fields',2,'2024-07-10 00:45:05.278655','2024-07-10 00:45:07.263203',1984,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6643,'classify-fields',2,'2024-07-10 00:45:07.271287','2024-07-10 00:45:07.377206',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6644,'classify-tables',2,'2024-07-10 00:45:07.384866','2024-07-10 00:45:07.399486',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6645,'sync',2,'2024-07-10 01:45:00.089776','2024-07-10 01:45:04.290578',4200,NULL,'success'),(6646,'sync-dbms-version',2,'2024-07-10 01:45:00.097561','2024-07-10 01:45:00.106654',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6647,'sync-timezone',2,'2024-07-10 01:45:00.114507','2024-07-10 01:45:00.123529',9,'{\"timezone-id\":\"+08:00\"}','success'),(6648,'sync-tables',2,'2024-07-10 01:45:00.134822','2024-07-10 01:45:00.161841',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6649,'sync-fields',2,'2024-07-10 01:45:00.169893','2024-07-10 01:45:03.050718',2880,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6650,'sync-fks',2,'2024-07-10 01:45:03.058144','2024-07-10 01:45:03.696733',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6651,'sync-indexes',2,'2024-07-10 01:45:03.705886','2024-07-10 01:45:04.243817',537,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6652,'sync-metabase-metadata',2,'2024-07-10 01:45:04.254106','2024-07-10 01:45:04.262971',8,'{}','success'),(6653,'sync-table-privileges',2,'2024-07-10 01:45:04.273334','2024-07-10 01:45:04.282595',9,NULL,'success'),(6654,'analyze',2,'2024-07-10 01:45:04.319970','2024-07-10 01:45:06.363039',2043,NULL,'success'),(6655,'fingerprint-fields',2,'2024-07-10 01:45:04.328863','2024-07-10 01:45:06.218043',1889,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6656,'classify-fields',2,'2024-07-10 01:45:06.226093','2024-07-10 01:45:06.334529',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6657,'classify-tables',2,'2024-07-10 01:45:06.341706','2024-07-10 01:45:06.354308',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6658,'sync',2,'2024-07-10 02:45:00.115655','2024-07-10 02:45:04.759856',4644,NULL,'success'),(6659,'sync-dbms-version',2,'2024-07-10 02:45:00.124427','2024-07-10 02:45:00.134474',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6660,'sync-timezone',2,'2024-07-10 02:45:00.142569','2024-07-10 02:45:00.153541',10,'{\"timezone-id\":\"+08:00\"}','success'),(6661,'sync-tables',2,'2024-07-10 02:45:00.162004','2024-07-10 02:45:00.191294',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6662,'sync-fields',2,'2024-07-10 02:45:00.200273','2024-07-10 02:45:03.411536',3211,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6663,'sync-fks',2,'2024-07-10 02:45:03.419924','2024-07-10 02:45:04.119238',699,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6664,'sync-indexes',2,'2024-07-10 02:45:04.128260','2024-07-10 02:45:04.714016',585,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6665,'sync-metabase-metadata',2,'2024-07-10 02:45:04.723884','2024-07-10 02:45:04.732744',8,'{}','success'),(6666,'sync-table-privileges',2,'2024-07-10 02:45:04.741293','2024-07-10 02:45:04.750120',8,NULL,'success'),(6667,'analyze',2,'2024-07-10 02:45:04.790254','2024-07-10 02:45:06.980197',2189,NULL,'success'),(6668,'fingerprint-fields',2,'2024-07-10 02:45:04.800354','2024-07-10 02:45:06.808202',2007,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6669,'classify-fields',2,'2024-07-10 02:45:06.816672','2024-07-10 02:45:06.938953',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6670,'classify-tables',2,'2024-07-10 02:45:06.953891','2024-07-10 02:45:06.971476',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6671,'sync',2,'2024-07-10 03:45:00.102913','2024-07-10 03:45:04.589337',4486,NULL,'success'),(6672,'sync-dbms-version',2,'2024-07-10 03:45:00.114135','2024-07-10 03:45:00.133006',18,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6673,'sync-timezone',2,'2024-07-10 03:45:00.146247','2024-07-10 03:45:00.158090',11,'{\"timezone-id\":\"+08:00\"}','success'),(6674,'sync-tables',2,'2024-07-10 03:45:00.166874','2024-07-10 03:45:00.193361',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6675,'sync-fields',2,'2024-07-10 03:45:00.202096','2024-07-10 03:45:03.338788',3136,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6676,'sync-fks',2,'2024-07-10 03:45:03.347375','2024-07-10 03:45:03.978238',630,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6677,'sync-indexes',2,'2024-07-10 03:45:03.988271','2024-07-10 03:45:04.545457',557,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6678,'sync-metabase-metadata',2,'2024-07-10 03:45:04.553281','2024-07-10 03:45:04.561743',8,'{}','success'),(6679,'sync-table-privileges',2,'2024-07-10 03:45:04.571336','2024-07-10 03:45:04.580041',8,NULL,'success'),(6680,'analyze',2,'2024-07-10 03:45:04.616176','2024-07-10 03:45:06.746991',2130,NULL,'success'),(6681,'fingerprint-fields',2,'2024-07-10 03:45:04.624818','2024-07-10 03:45:06.570176',1945,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6682,'classify-fields',2,'2024-07-10 03:45:06.578902','2024-07-10 03:45:06.707314',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6683,'classify-tables',2,'2024-07-10 03:45:06.715445','2024-07-10 03:45:06.737128',21,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6684,'task-history-cleanup',NULL,'2024-07-10 04:00:00.084538','2024-07-10 04:00:00.100261',15,NULL,'success'),(6685,'sync',2,'2024-07-10 04:45:00.117878','2024-07-10 04:45:04.752278',4634,NULL,'success'),(6686,'sync-dbms-version',2,'2024-07-10 04:45:00.126387','2024-07-10 04:45:00.135547',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6687,'sync-timezone',2,'2024-07-10 04:45:00.145540','2024-07-10 04:45:00.156971',11,'{\"timezone-id\":\"+08:00\"}','success'),(6688,'sync-tables',2,'2024-07-10 04:45:00.165802','2024-07-10 04:45:00.194281',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6689,'sync-fields',2,'2024-07-10 04:45:00.202791','2024-07-10 04:45:03.427886',3225,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6690,'sync-fks',2,'2024-07-10 04:45:03.435685','2024-07-10 04:45:04.143608',707,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6691,'sync-indexes',2,'2024-07-10 04:45:04.152926','2024-07-10 04:45:04.709882',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6692,'sync-metabase-metadata',2,'2024-07-10 04:45:04.717647','2024-07-10 04:45:04.726725',9,'{}','success'),(6693,'sync-table-privileges',2,'2024-07-10 04:45:04.735653','2024-07-10 04:45:04.744120',8,NULL,'success'),(6694,'analyze',2,'2024-07-10 04:45:04.778201','2024-07-10 04:45:06.920945',2142,NULL,'success'),(6695,'fingerprint-fields',2,'2024-07-10 04:45:04.786507','2024-07-10 04:45:06.769842',1983,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6696,'classify-fields',2,'2024-07-10 04:45:06.778914','2024-07-10 04:45:06.889801',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6697,'classify-tables',2,'2024-07-10 04:45:06.898543','2024-07-10 04:45:06.912970',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6698,'sync',2,'2024-07-10 05:45:00.098458','2024-07-10 05:45:04.553884',4455,NULL,'success'),(6699,'sync-dbms-version',2,'2024-07-10 05:45:00.108339','2024-07-10 05:45:00.118088',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6700,'sync-timezone',2,'2024-07-10 05:45:00.142121','2024-07-10 05:45:00.152217',10,'{\"timezone-id\":\"+08:00\"}','success'),(6701,'sync-tables',2,'2024-07-10 05:45:00.160671','2024-07-10 05:45:00.192217',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6702,'sync-fields',2,'2024-07-10 05:45:00.202202','2024-07-10 05:45:03.271660',3069,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6703,'sync-fks',2,'2024-07-10 05:45:03.280010','2024-07-10 05:45:03.929759',649,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6704,'sync-indexes',2,'2024-07-10 05:45:03.938682','2024-07-10 05:45:04.511286',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6705,'sync-metabase-metadata',2,'2024-07-10 05:45:04.518954','2024-07-10 05:45:04.527067',8,'{}','success'),(6706,'sync-table-privileges',2,'2024-07-10 05:45:04.535510','2024-07-10 05:45:04.545251',9,NULL,'success'),(6707,'analyze',2,'2024-07-10 05:45:04.577643','2024-07-10 05:45:06.750237',2172,NULL,'success'),(6708,'fingerprint-fields',2,'2024-07-10 05:45:04.585496','2024-07-10 05:45:06.586929',2001,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6709,'classify-fields',2,'2024-07-10 05:45:06.595463','2024-07-10 05:45:06.718795',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6710,'classify-tables',2,'2024-07-10 05:45:06.727231','2024-07-10 05:45:06.741727',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6711,'sync',2,'2024-07-10 06:45:00.107251','2024-07-10 06:45:04.557420',4450,NULL,'success'),(6712,'sync-dbms-version',2,'2024-07-10 06:45:00.115270','2024-07-10 06:45:00.126035',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6713,'sync-timezone',2,'2024-07-10 06:45:00.135667','2024-07-10 06:45:00.147794',12,'{\"timezone-id\":\"+08:00\"}','success'),(6714,'sync-tables',2,'2024-07-10 06:45:00.157310','2024-07-10 06:45:00.185126',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6715,'sync-fields',2,'2024-07-10 06:45:00.193504','2024-07-10 06:45:03.273539',3080,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6716,'sync-fks',2,'2024-07-10 06:45:03.283090','2024-07-10 06:45:03.935381',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6717,'sync-indexes',2,'2024-07-10 06:45:03.942957','2024-07-10 06:45:04.505200',562,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6718,'sync-metabase-metadata',2,'2024-07-10 06:45:04.513397','2024-07-10 06:45:04.527639',14,'{}','success'),(6719,'sync-table-privileges',2,'2024-07-10 06:45:04.538073','2024-07-10 06:45:04.548341',10,NULL,'success'),(6720,'analyze',2,'2024-07-10 06:45:04.586741','2024-07-10 06:45:06.768380',2181,NULL,'success'),(6721,'fingerprint-fields',2,'2024-07-10 06:45:04.595858','2024-07-10 06:45:06.615991',2020,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6722,'classify-fields',2,'2024-07-10 06:45:06.624516','2024-07-10 06:45:06.737556',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6723,'classify-tables',2,'2024-07-10 06:45:06.745692','2024-07-10 06:45:06.760152',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6724,'sync',2,'2024-07-10 07:45:00.108144','2024-07-10 07:45:04.267091',4158,NULL,'success'),(6725,'sync-dbms-version',2,'2024-07-10 07:45:00.117245','2024-07-10 07:45:00.127710',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6726,'sync-timezone',2,'2024-07-10 07:45:00.135981','2024-07-10 07:45:00.145745',9,'{\"timezone-id\":\"+08:00\"}','success'),(6727,'sync-tables',2,'2024-07-10 07:45:00.154215','2024-07-10 07:45:00.183288',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6728,'sync-fields',2,'2024-07-10 07:45:00.192454','2024-07-10 07:45:03.134890',2942,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6729,'sync-fks',2,'2024-07-10 07:45:03.142247','2024-07-10 07:45:03.705962',563,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6730,'sync-indexes',2,'2024-07-10 07:45:03.713665','2024-07-10 07:45:04.223840',510,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6731,'sync-metabase-metadata',2,'2024-07-10 07:45:04.232260','2024-07-10 07:45:04.242033',9,'{}','success'),(6732,'sync-table-privileges',2,'2024-07-10 07:45:04.250323','2024-07-10 07:45:04.258883',8,NULL,'success'),(6733,'analyze',2,'2024-07-10 07:45:04.291022','2024-07-10 07:45:06.432007',2140,NULL,'success'),(6734,'fingerprint-fields',2,'2024-07-10 07:45:04.298692','2024-07-10 07:45:06.291349',1992,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6735,'classify-fields',2,'2024-07-10 07:45:06.298940','2024-07-10 07:45:06.400921',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6736,'classify-tables',2,'2024-07-10 07:45:06.408065','2024-07-10 07:45:06.422800',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6737,'sync',2,'2024-07-10 08:45:00.091541','2024-07-10 08:45:04.439707',4348,NULL,'success'),(6738,'sync-dbms-version',2,'2024-07-10 08:45:00.099484','2024-07-10 08:45:00.109153',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6739,'sync-timezone',2,'2024-07-10 08:45:00.118092','2024-07-10 08:45:00.128096',10,'{\"timezone-id\":\"+08:00\"}','success'),(6740,'sync-tables',2,'2024-07-10 08:45:00.137089','2024-07-10 08:45:00.161624',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6741,'sync-fields',2,'2024-07-10 08:45:00.170126','2024-07-10 08:45:03.190499',3020,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6742,'sync-fks',2,'2024-07-10 08:45:03.198614','2024-07-10 08:45:03.822933',624,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6743,'sync-indexes',2,'2024-07-10 08:45:03.832269','2024-07-10 08:45:04.392814',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6744,'sync-metabase-metadata',2,'2024-07-10 08:45:04.401032','2024-07-10 08:45:04.411982',10,'{}','success'),(6745,'sync-table-privileges',2,'2024-07-10 08:45:04.420836','2024-07-10 08:45:04.431142',10,NULL,'success'),(6746,'analyze',2,'2024-07-10 08:45:04.466714','2024-07-10 08:45:06.590604',2123,NULL,'success'),(6747,'fingerprint-fields',2,'2024-07-10 08:45:04.476120','2024-07-10 08:45:06.432965',1956,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6748,'classify-fields',2,'2024-07-10 08:45:06.441720','2024-07-10 08:45:06.557152',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6749,'classify-tables',2,'2024-07-10 08:45:06.565099','2024-07-10 08:45:06.581881',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6750,'sync',2,'2024-07-10 09:45:00.096576','2024-07-10 09:45:04.486753',4390,NULL,'success'),(6751,'sync-dbms-version',2,'2024-07-10 09:45:00.104147','2024-07-10 09:45:00.114180',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6752,'sync-timezone',2,'2024-07-10 09:45:00.122420','2024-07-10 09:45:00.131899',9,'{\"timezone-id\":\"+08:00\"}','success'),(6753,'sync-tables',2,'2024-07-10 09:45:00.139961','2024-07-10 09:45:00.168055',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6754,'sync-fields',2,'2024-07-10 09:45:00.176095','2024-07-10 09:45:03.306149',3130,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6755,'sync-fks',2,'2024-07-10 09:45:03.315051','2024-07-10 09:45:03.910447',595,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6756,'sync-indexes',2,'2024-07-10 09:45:03.918837','2024-07-10 09:45:04.447568',528,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6757,'sync-metabase-metadata',2,'2024-07-10 09:45:04.454773','2024-07-10 09:45:04.462352',7,'{}','success'),(6758,'sync-table-privileges',2,'2024-07-10 09:45:04.470442','2024-07-10 09:45:04.478596',8,NULL,'success'),(6759,'analyze',2,'2024-07-10 09:45:04.513429','2024-07-10 09:45:06.514535',2001,NULL,'success'),(6760,'fingerprint-fields',2,'2024-07-10 09:45:04.522676','2024-07-10 09:45:06.377571',1854,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6761,'classify-fields',2,'2024-07-10 09:45:06.385151','2024-07-10 09:45:06.485374',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6762,'classify-tables',2,'2024-07-10 09:45:06.492529','2024-07-10 09:45:06.506438',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6763,'sync',2,'2024-07-10 10:45:00.095956','2024-07-10 10:45:04.382715',4286,NULL,'success'),(6764,'sync-dbms-version',2,'2024-07-10 10:45:00.105188','2024-07-10 10:45:00.113869',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6765,'sync-timezone',2,'2024-07-10 10:45:00.121761','2024-07-10 10:45:00.132864',11,'{\"timezone-id\":\"+08:00\"}','success'),(6766,'sync-tables',2,'2024-07-10 10:45:00.140999','2024-07-10 10:45:00.167187',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6767,'sync-fields',2,'2024-07-10 10:45:00.179758','2024-07-10 10:45:03.102828',2923,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6768,'sync-fks',2,'2024-07-10 10:45:03.110652','2024-07-10 10:45:03.755812',645,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6769,'sync-indexes',2,'2024-07-10 10:45:03.764914','2024-07-10 10:45:04.343062',578,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6770,'sync-metabase-metadata',2,'2024-07-10 10:45:04.350751','2024-07-10 10:45:04.358924',8,'{}','success'),(6771,'sync-table-privileges',2,'2024-07-10 10:45:04.366756','2024-07-10 10:45:04.375038',8,NULL,'success'),(6772,'analyze',2,'2024-07-10 10:45:04.406173','2024-07-10 10:45:06.388073',1981,NULL,'success'),(6773,'fingerprint-fields',2,'2024-07-10 10:45:04.413919','2024-07-10 10:45:06.240382',1826,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6774,'classify-fields',2,'2024-07-10 10:45:06.248379','2024-07-10 10:45:06.359234',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6775,'classify-tables',2,'2024-07-10 10:45:06.367262','2024-07-10 10:45:06.379623',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6776,'sync',2,'2024-07-10 11:45:00.099413','2024-07-10 11:45:04.541460',4442,NULL,'success'),(6777,'sync-dbms-version',2,'2024-07-10 11:45:00.107637','2024-07-10 11:45:00.118649',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6778,'sync-timezone',2,'2024-07-10 11:45:00.127659','2024-07-10 11:45:00.138042',10,'{\"timezone-id\":\"+08:00\"}','success'),(6779,'sync-tables',2,'2024-07-10 11:45:00.146636','2024-07-10 11:45:00.173970',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6780,'sync-fields',2,'2024-07-10 11:45:00.182538','2024-07-10 11:45:03.284330',3101,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6781,'sync-fks',2,'2024-07-10 11:45:03.291936','2024-07-10 11:45:03.956977',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6782,'sync-indexes',2,'2024-07-10 11:45:03.964980','2024-07-10 11:45:04.500406',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6783,'sync-metabase-metadata',2,'2024-07-10 11:45:04.507946','2024-07-10 11:45:04.515632',7,'{}','success'),(6784,'sync-table-privileges',2,'2024-07-10 11:45:04.524125','2024-07-10 11:45:04.533613',9,NULL,'success'),(6785,'analyze',2,'2024-07-10 11:45:04.565369','2024-07-10 11:45:06.484248',1918,NULL,'success'),(6786,'fingerprint-fields',2,'2024-07-10 11:45:04.573336','2024-07-10 11:45:06.340488',1767,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6787,'classify-fields',2,'2024-07-10 11:45:06.348213','2024-07-10 11:45:06.455899',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6788,'classify-tables',2,'2024-07-10 11:45:06.463466','2024-07-10 11:45:06.476395',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6789,'sync',2,'2024-07-10 12:45:00.095266','2024-07-10 12:45:04.295307',4200,NULL,'success'),(6790,'sync-dbms-version',2,'2024-07-10 12:45:00.104528','2024-07-10 12:45:00.114633',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6791,'sync-timezone',2,'2024-07-10 12:45:00.123215','2024-07-10 12:45:00.132688',9,'{\"timezone-id\":\"+08:00\"}','success'),(6792,'sync-tables',2,'2024-07-10 12:45:00.141397','2024-07-10 12:45:00.167058',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6793,'sync-fields',2,'2024-07-10 12:45:00.175321','2024-07-10 12:45:03.189277',3013,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6794,'sync-fks',2,'2024-07-10 12:45:03.196944','2024-07-10 12:45:03.747742',550,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6795,'sync-indexes',2,'2024-07-10 12:45:03.759963','2024-07-10 12:45:04.256532',496,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6796,'sync-metabase-metadata',2,'2024-07-10 12:45:04.263658','2024-07-10 12:45:04.271668',8,'{}','success'),(6797,'sync-table-privileges',2,'2024-07-10 12:45:04.279503','2024-07-10 12:45:04.287788',8,NULL,'success'),(6798,'analyze',2,'2024-07-10 12:45:04.318740','2024-07-10 12:45:06.173892',1855,NULL,'success'),(6799,'fingerprint-fields',2,'2024-07-10 12:45:04.326067','2024-07-10 12:45:06.005686',1679,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6800,'classify-fields',2,'2024-07-10 12:45:06.013237','2024-07-10 12:45:06.130723',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6801,'classify-tables',2,'2024-07-10 12:45:06.139092','2024-07-10 12:45:06.165051',25,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6802,'field values scanning',2,'2024-07-10 13:00:00.070828','2024-07-10 13:00:04.070564',3999,NULL,'success'),(6803,'delete-expired-advanced-field-values',2,'2024-07-10 13:00:00.090660','2024-07-10 13:00:02.890620',2799,'{\"deleted\":0}','success'),(6804,'update-field-values',2,'2024-07-10 13:00:02.898001','2024-07-10 13:00:04.062721',1164,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(6805,'sync',2,'2024-07-10 13:45:00.086961','2024-07-10 13:45:03.849573',3762,NULL,'success'),(6806,'sync-dbms-version',2,'2024-07-10 13:45:00.094877','2024-07-10 13:45:00.104742',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6807,'sync-timezone',2,'2024-07-10 13:45:00.112822','2024-07-10 13:45:00.121860',9,'{\"timezone-id\":\"+08:00\"}','success'),(6808,'sync-tables',2,'2024-07-10 13:45:00.129786','2024-07-10 13:45:00.155640',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6809,'sync-fields',2,'2024-07-10 13:45:00.163533','2024-07-10 13:45:02.756187',2592,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6810,'sync-fks',2,'2024-07-10 13:45:02.764553','2024-07-10 13:45:03.337468',572,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6811,'sync-indexes',2,'2024-07-10 13:45:03.345261','2024-07-10 13:45:03.811633',466,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6812,'sync-metabase-metadata',2,'2024-07-10 13:45:03.818620','2024-07-10 13:45:03.826440',7,'{}','success'),(6813,'sync-table-privileges',2,'2024-07-10 13:45:03.834042','2024-07-10 13:45:03.842029',7,NULL,'success'),(6814,'analyze',2,'2024-07-10 13:45:03.872785','2024-07-10 13:45:05.692468',1819,NULL,'success'),(6815,'fingerprint-fields',2,'2024-07-10 13:45:03.880001','2024-07-10 13:45:05.559002',1679,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6816,'classify-fields',2,'2024-07-10 13:45:05.566775','2024-07-10 13:45:05.663033',96,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6817,'classify-tables',2,'2024-07-10 13:45:05.672019','2024-07-10 13:45:05.684624',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6818,'sync',2,'2024-07-10 14:45:00.109987','2024-07-10 14:45:04.123315',4013,NULL,'success'),(6819,'sync-dbms-version',2,'2024-07-10 14:45:00.118296','2024-07-10 14:45:00.126657',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6820,'sync-timezone',2,'2024-07-10 14:45:00.134824','2024-07-10 14:45:00.144811',9,'{\"timezone-id\":\"+08:00\"}','success'),(6821,'sync-tables',2,'2024-07-10 14:45:00.152926','2024-07-10 14:45:00.179309',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6822,'sync-fields',2,'2024-07-10 14:45:00.187919','2024-07-10 14:45:03.028490',2840,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6823,'sync-fks',2,'2024-07-10 14:45:03.035998','2024-07-10 14:45:03.573770',537,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6824,'sync-indexes',2,'2024-07-10 14:45:03.581740','2024-07-10 14:45:04.082724',500,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6825,'sync-metabase-metadata',2,'2024-07-10 14:45:04.090804','2024-07-10 14:45:04.098616',7,'{}','success'),(6826,'sync-table-privileges',2,'2024-07-10 14:45:04.107281','2024-07-10 14:45:04.115025',7,NULL,'success'),(6827,'analyze',2,'2024-07-10 14:45:04.146418','2024-07-10 14:45:06.270245',2123,NULL,'success'),(6828,'fingerprint-fields',2,'2024-07-10 14:45:04.154313','2024-07-10 14:45:06.125799',1971,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6829,'classify-fields',2,'2024-07-10 14:45:06.133426','2024-07-10 14:45:06.240531',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6830,'classify-tables',2,'2024-07-10 14:45:06.248456','2024-07-10 14:45:06.262306',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6831,'sync',2,'2024-07-10 15:45:00.108617','2024-07-10 15:45:04.492571',4383,NULL,'success'),(6832,'sync-dbms-version',2,'2024-07-10 15:45:00.118688','2024-07-10 15:45:00.128179',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6833,'sync-timezone',2,'2024-07-10 15:45:00.136650','2024-07-10 15:45:00.146295',9,'{\"timezone-id\":\"+08:00\"}','success'),(6834,'sync-tables',2,'2024-07-10 15:45:00.154982','2024-07-10 15:45:00.185687',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6835,'sync-fields',2,'2024-07-10 15:45:00.194331','2024-07-10 15:45:03.254441',3060,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6836,'sync-fks',2,'2024-07-10 15:45:03.262348','2024-07-10 15:45:03.919916',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6837,'sync-indexes',2,'2024-07-10 15:45:03.929751','2024-07-10 15:45:04.451902',522,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6838,'sync-metabase-metadata',2,'2024-07-10 15:45:04.459420','2024-07-10 15:45:04.467519',8,'{}','success'),(6839,'sync-table-privileges',2,'2024-07-10 15:45:04.475999','2024-07-10 15:45:04.484784',8,NULL,'success'),(6840,'analyze',2,'2024-07-10 15:45:04.517794','2024-07-10 15:45:06.591815',2074,NULL,'success'),(6841,'fingerprint-fields',2,'2024-07-10 15:45:04.525474','2024-07-10 15:45:06.417878',1892,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6842,'classify-fields',2,'2024-07-10 15:45:06.427214','2024-07-10 15:45:06.559603',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6843,'classify-tables',2,'2024-07-10 15:45:06.567552','2024-07-10 15:45:06.582946',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6844,'task-history-cleanup',NULL,'2024-07-10 16:00:00.012687','2024-07-10 16:00:00.082067',69,NULL,'success'),(6845,'task-history-cleanup',NULL,'2024-07-10 16:00:00.077359','2024-07-10 16:00:00.096196',18,NULL,'success'),(6846,'sync',2,'2024-07-10 16:45:00.114361','2024-07-10 16:45:04.569935',4455,NULL,'success'),(6847,'sync-dbms-version',2,'2024-07-10 16:45:00.124166','2024-07-10 16:45:00.133923',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6848,'sync-timezone',2,'2024-07-10 16:45:00.143247','2024-07-10 16:45:00.153245',9,'{\"timezone-id\":\"+08:00\"}','success'),(6849,'sync-tables',2,'2024-07-10 16:45:00.161744','2024-07-10 16:45:00.190568',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6850,'sync-fields',2,'2024-07-10 16:45:00.199324','2024-07-10 16:45:03.313172',3113,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6851,'sync-fks',2,'2024-07-10 16:45:03.321521','2024-07-10 16:45:03.946903',625,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6852,'sync-indexes',2,'2024-07-10 16:45:03.955755','2024-07-10 16:45:04.528411',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6853,'sync-metabase-metadata',2,'2024-07-10 16:45:04.536217','2024-07-10 16:45:04.544251',8,'{}','success'),(6854,'sync-table-privileges',2,'2024-07-10 16:45:04.552501','2024-07-10 16:45:04.561025',8,NULL,'success'),(6855,'analyze',2,'2024-07-10 16:45:04.594477','2024-07-10 16:45:06.772689',2178,NULL,'success'),(6856,'fingerprint-fields',2,'2024-07-10 16:45:04.602699','2024-07-10 16:45:06.611141',2008,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6857,'classify-fields',2,'2024-07-10 16:45:06.620131','2024-07-10 16:45:06.742424',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6858,'classify-tables',2,'2024-07-10 16:45:06.750050','2024-07-10 16:45:06.763933',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6859,'sync',2,'2024-07-10 17:45:00.101457','2024-07-10 17:45:04.316632',4215,NULL,'success'),(6860,'sync-dbms-version',2,'2024-07-10 17:45:00.112360','2024-07-10 17:45:00.124768',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6861,'sync-timezone',2,'2024-07-10 17:45:00.133817','2024-07-10 17:45:00.145944',12,'{\"timezone-id\":\"+08:00\"}','success'),(6862,'sync-tables',2,'2024-07-10 17:45:00.155655','2024-07-10 17:45:00.184419',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6863,'sync-fields',2,'2024-07-10 17:45:00.194887','2024-07-10 17:45:03.125470',2930,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6864,'sync-fks',2,'2024-07-10 17:45:03.134169','2024-07-10 17:45:03.738047',603,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6865,'sync-indexes',2,'2024-07-10 17:45:03.746167','2024-07-10 17:45:04.276062',529,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6866,'sync-metabase-metadata',2,'2024-07-10 17:45:04.283943','2024-07-10 17:45:04.292872',8,'{}','success'),(6867,'sync-table-privileges',2,'2024-07-10 17:45:04.300391','2024-07-10 17:45:04.308679',8,NULL,'success'),(6868,'analyze',2,'2024-07-10 17:45:04.341084','2024-07-10 17:45:06.349392',2008,NULL,'success'),(6869,'fingerprint-fields',2,'2024-07-10 17:45:04.348540','2024-07-10 17:45:06.199738',1851,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6870,'classify-fields',2,'2024-07-10 17:45:06.207534','2024-07-10 17:45:06.319015',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6871,'classify-tables',2,'2024-07-10 17:45:06.326156','2024-07-10 17:45:06.341204',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6872,'sync',2,'2024-07-10 18:45:00.099517','2024-07-10 18:45:04.117315',4017,NULL,'success'),(6873,'sync-dbms-version',2,'2024-07-10 18:45:00.107489','2024-07-10 18:45:00.116626',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6874,'sync-timezone',2,'2024-07-10 18:45:00.125345','2024-07-10 18:45:00.135343',9,'{\"timezone-id\":\"+08:00\"}','success'),(6875,'sync-tables',2,'2024-07-10 18:45:00.143500','2024-07-10 18:45:00.171162',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6876,'sync-fields',2,'2024-07-10 18:45:00.184155','2024-07-10 18:45:02.984403',2800,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6877,'sync-fks',2,'2024-07-10 18:45:02.992169','2024-07-10 18:45:03.579774',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6878,'sync-indexes',2,'2024-07-10 18:45:03.588084','2024-07-10 18:45:04.072326',484,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6879,'sync-metabase-metadata',2,'2024-07-10 18:45:04.079944','2024-07-10 18:45:04.088197',8,'{}','success'),(6880,'sync-table-privileges',2,'2024-07-10 18:45:04.100888','2024-07-10 18:45:04.109191',8,NULL,'success'),(6881,'analyze',2,'2024-07-10 18:45:04.141520','2024-07-10 18:45:06.037321',1895,NULL,'success'),(6882,'fingerprint-fields',2,'2024-07-10 18:45:04.149943','2024-07-10 18:45:05.900734',1750,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6883,'classify-fields',2,'2024-07-10 18:45:05.908526','2024-07-10 18:45:06.008597',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6884,'classify-tables',2,'2024-07-10 18:45:06.015683','2024-07-10 18:45:06.029449',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6885,'sync',2,'2024-07-10 19:45:00.107436','2024-07-10 19:45:04.382266',4274,NULL,'success'),(6886,'sync-dbms-version',2,'2024-07-10 19:45:00.116182','2024-07-10 19:45:00.126469',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6887,'sync-timezone',2,'2024-07-10 19:45:00.136428','2024-07-10 19:45:00.147224',10,'{\"timezone-id\":\"+08:00\"}','success'),(6888,'sync-tables',2,'2024-07-10 19:45:00.156164','2024-07-10 19:45:00.184539',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6889,'sync-fields',2,'2024-07-10 19:45:00.195538','2024-07-10 19:45:03.143333',2947,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6890,'sync-fks',2,'2024-07-10 19:45:03.152309','2024-07-10 19:45:03.787558',635,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6891,'sync-indexes',2,'2024-07-10 19:45:03.796185','2024-07-10 19:45:04.338266',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6892,'sync-metabase-metadata',2,'2024-07-10 19:45:04.346229','2024-07-10 19:45:04.355113',8,'{}','success'),(6893,'sync-table-privileges',2,'2024-07-10 19:45:04.363836','2024-07-10 19:45:04.373977',10,NULL,'success'),(6894,'analyze',2,'2024-07-10 19:45:04.407533','2024-07-10 19:45:06.477903',2070,NULL,'success'),(6895,'fingerprint-fields',2,'2024-07-10 19:45:04.415790','2024-07-10 19:45:06.308752',1892,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6896,'classify-fields',2,'2024-07-10 19:45:06.317375','2024-07-10 19:45:06.437400',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6897,'classify-tables',2,'2024-07-10 19:45:06.445540','2024-07-10 19:45:06.461778',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6898,'sync',2,'2024-07-10 20:45:00.103112','2024-07-10 20:45:04.492942',4389,NULL,'success'),(6899,'sync-dbms-version',2,'2024-07-10 20:45:00.111704','2024-07-10 20:45:00.123123',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6900,'sync-timezone',2,'2024-07-10 20:45:00.132691','2024-07-10 20:45:00.143775',11,'{\"timezone-id\":\"+08:00\"}','success'),(6901,'sync-tables',2,'2024-07-10 20:45:00.153390','2024-07-10 20:45:00.183789',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6902,'sync-fields',2,'2024-07-10 20:45:00.192934','2024-07-10 20:45:03.244052',3051,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6903,'sync-fks',2,'2024-07-10 20:45:03.252657','2024-07-10 20:45:03.906503',653,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6904,'sync-indexes',2,'2024-07-10 20:45:03.915020','2024-07-10 20:45:04.450875',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6905,'sync-metabase-metadata',2,'2024-07-10 20:45:04.458626','2024-07-10 20:45:04.467627',9,'{}','success'),(6906,'sync-table-privileges',2,'2024-07-10 20:45:04.476594','2024-07-10 20:45:04.485066',8,NULL,'success'),(6907,'analyze',2,'2024-07-10 20:45:04.519220','2024-07-10 20:45:06.508564',1989,NULL,'success'),(6908,'fingerprint-fields',2,'2024-07-10 20:45:04.527494','2024-07-10 20:45:06.366536',1839,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6909,'classify-fields',2,'2024-07-10 20:45:06.374935','2024-07-10 20:45:06.478552',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6910,'classify-tables',2,'2024-07-10 20:45:06.486138','2024-07-10 20:45:06.499544',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6911,'sync',2,'2024-07-10 21:45:00.106378','2024-07-10 21:45:04.757882',4651,NULL,'success'),(6912,'sync-dbms-version',2,'2024-07-10 21:45:00.114439','2024-07-10 21:45:00.125273',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6913,'sync-timezone',2,'2024-07-10 21:45:00.134543','2024-07-10 21:45:00.145065',10,'{\"timezone-id\":\"+08:00\"}','success'),(6914,'sync-tables',2,'2024-07-10 21:45:00.153192','2024-07-10 21:45:00.178924',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6915,'sync-fields',2,'2024-07-10 21:45:00.187320','2024-07-10 21:45:03.351396',3164,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6916,'sync-fks',2,'2024-07-10 21:45:03.360046','2024-07-10 21:45:04.013888',653,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6917,'sync-indexes',2,'2024-07-10 21:45:04.021677','2024-07-10 21:45:04.711756',690,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6918,'sync-metabase-metadata',2,'2024-07-10 21:45:04.719765','2024-07-10 21:45:04.729458',9,'{}','success'),(6919,'sync-table-privileges',2,'2024-07-10 21:45:04.738658','2024-07-10 21:45:04.748710',10,NULL,'success'),(6920,'analyze',2,'2024-07-10 21:45:04.785180','2024-07-10 21:45:06.913208',2128,NULL,'success'),(6921,'fingerprint-fields',2,'2024-07-10 21:45:04.794506','2024-07-10 21:45:06.743632',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6922,'classify-fields',2,'2024-07-10 21:45:06.752284','2024-07-10 21:45:06.879834',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6923,'classify-tables',2,'2024-07-10 21:45:06.888406','2024-07-10 21:45:06.903933',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6924,'sync',2,'2024-07-10 22:45:00.105261','2024-07-10 22:45:04.481628',4376,NULL,'success'),(6925,'sync-dbms-version',2,'2024-07-10 22:45:00.113523','2024-07-10 22:45:00.123375',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6926,'sync-timezone',2,'2024-07-10 22:45:00.132248','2024-07-10 22:45:00.142229',9,'{\"timezone-id\":\"+08:00\"}','success'),(6927,'sync-tables',2,'2024-07-10 22:45:00.151179','2024-07-10 22:45:00.182267',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6928,'sync-fields',2,'2024-07-10 22:45:00.193228','2024-07-10 22:45:03.329054',3135,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6929,'sync-fks',2,'2024-07-10 22:45:03.336473','2024-07-10 22:45:03.917085',580,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6930,'sync-indexes',2,'2024-07-10 22:45:03.926216','2024-07-10 22:45:04.441671',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6931,'sync-metabase-metadata',2,'2024-07-10 22:45:04.448997','2024-07-10 22:45:04.457000',8,'{}','success'),(6932,'sync-table-privileges',2,'2024-07-10 22:45:04.465291','2024-07-10 22:45:04.473601',8,NULL,'success'),(6933,'analyze',2,'2024-07-10 22:45:04.505311','2024-07-10 22:45:06.379159',1873,NULL,'success'),(6934,'fingerprint-fields',2,'2024-07-10 22:45:04.513249','2024-07-10 22:45:06.240948',1727,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6935,'classify-fields',2,'2024-07-10 22:45:06.248598','2024-07-10 22:45:06.346536',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6936,'classify-tables',2,'2024-07-10 22:45:06.353676','2024-07-10 22:45:06.367780',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6937,'sync',2,'2024-07-10 23:45:00.110206','2024-07-10 23:45:04.359971',4249,NULL,'success'),(6938,'sync-dbms-version',2,'2024-07-10 23:45:00.118907','2024-07-10 23:45:00.127857',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6939,'sync-timezone',2,'2024-07-10 23:45:00.136670','2024-07-10 23:45:00.146853',10,'{\"timezone-id\":\"+08:00\"}','success'),(6940,'sync-tables',2,'2024-07-10 23:45:00.156006','2024-07-10 23:45:00.183332',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6941,'sync-fields',2,'2024-07-10 23:45:00.192565','2024-07-10 23:45:03.099433',2906,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6942,'sync-fks',2,'2024-07-10 23:45:03.111015','2024-07-10 23:45:03.744925',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6943,'sync-indexes',2,'2024-07-10 23:45:03.753874','2024-07-10 23:45:04.319670',565,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6944,'sync-metabase-metadata',2,'2024-07-10 23:45:04.327433','2024-07-10 23:45:04.335449',8,'{}','success'),(6945,'sync-table-privileges',2,'2024-07-10 23:45:04.343152','2024-07-10 23:45:04.351471',8,NULL,'success'),(6946,'analyze',2,'2024-07-10 23:45:04.390661','2024-07-10 23:45:06.323035',1932,NULL,'success'),(6947,'fingerprint-fields',2,'2024-07-10 23:45:04.399252','2024-07-10 23:45:06.184082',1784,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6948,'classify-fields',2,'2024-07-10 23:45:06.192001','2024-07-10 23:45:06.290203',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6949,'classify-tables',2,'2024-07-10 23:45:06.297166','2024-07-10 23:45:06.314428',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6950,'sync',2,'2024-07-11 00:45:00.105747','2024-07-11 00:45:04.493473',4387,NULL,'success'),(6951,'sync-dbms-version',2,'2024-07-11 00:45:00.114081','2024-07-11 00:45:00.122920',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6952,'sync-timezone',2,'2024-07-11 00:45:00.131041','2024-07-11 00:45:00.140445',9,'{\"timezone-id\":\"+08:00\"}','success'),(6953,'sync-tables',2,'2024-07-11 00:45:00.148773','2024-07-11 00:45:00.176027',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6954,'sync-fields',2,'2024-07-11 00:45:00.184021','2024-07-11 00:45:03.235127',3051,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6955,'sync-fks',2,'2024-07-11 00:45:03.244425','2024-07-11 00:45:03.896607',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6956,'sync-indexes',2,'2024-07-11 00:45:03.905617','2024-07-11 00:45:04.454248',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6957,'sync-metabase-metadata',2,'2024-07-11 00:45:04.462157','2024-07-11 00:45:04.470092',7,'{}','success'),(6958,'sync-table-privileges',2,'2024-07-11 00:45:04.477839','2024-07-11 00:45:04.485599',7,NULL,'success'),(6959,'analyze',2,'2024-07-11 00:45:04.517441','2024-07-11 00:45:06.559825',2042,NULL,'success'),(6960,'fingerprint-fields',2,'2024-07-11 00:45:04.525106','2024-07-11 00:45:06.415657',1890,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6961,'classify-fields',2,'2024-07-11 00:45:06.424137','2024-07-11 00:45:06.531700',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6962,'classify-tables',2,'2024-07-11 00:45:06.539358','2024-07-11 00:45:06.551298',11,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6963,'sync',2,'2024-07-11 01:45:00.092558','2024-07-11 01:45:05.070866',4978,NULL,'success'),(6964,'sync-dbms-version',2,'2024-07-11 01:45:00.100623','2024-07-11 01:45:00.109517',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6965,'sync-timezone',2,'2024-07-11 01:45:00.117373','2024-07-11 01:45:00.126712',9,'{\"timezone-id\":\"+08:00\"}','success'),(6966,'sync-tables',2,'2024-07-11 01:45:00.134571','2024-07-11 01:45:00.163820',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6967,'sync-fields',2,'2024-07-11 01:45:00.173028','2024-07-11 01:45:03.210652',3037,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6968,'sync-fks',2,'2024-07-11 01:45:03.218339','2024-07-11 01:45:03.803844',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6969,'sync-indexes',2,'2024-07-11 01:45:03.812171','2024-07-11 01:45:05.030320',1218,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6970,'sync-metabase-metadata',2,'2024-07-11 01:45:05.037771','2024-07-11 01:45:05.046459',8,'{}','success'),(6971,'sync-table-privileges',2,'2024-07-11 01:45:05.054407','2024-07-11 01:45:05.062765',8,NULL,'success'),(6972,'analyze',2,'2024-07-11 01:45:05.095245','2024-07-11 01:45:06.934122',1838,NULL,'success'),(6973,'fingerprint-fields',2,'2024-07-11 01:45:05.103459','2024-07-11 01:45:06.795109',1691,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6974,'classify-fields',2,'2024-07-11 01:45:06.802995','2024-07-11 01:45:06.904900',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6975,'classify-tables',2,'2024-07-11 01:45:06.912138','2024-07-11 01:45:06.925768',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6976,'sync',2,'2024-07-11 02:45:00.112071','2024-07-11 02:45:04.767843',4655,NULL,'success'),(6977,'sync-dbms-version',2,'2024-07-11 02:45:00.121326','2024-07-11 02:45:00.131308',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6978,'sync-timezone',2,'2024-07-11 02:45:00.140713','2024-07-11 02:45:00.151386',10,'{\"timezone-id\":\"+08:00\"}','success'),(6979,'sync-tables',2,'2024-07-11 02:45:00.160265','2024-07-11 02:45:00.189407',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6980,'sync-fields',2,'2024-07-11 02:45:00.198210','2024-07-11 02:45:03.448088',3249,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6981,'sync-fks',2,'2024-07-11 02:45:03.456239','2024-07-11 02:45:04.127005',670,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6982,'sync-indexes',2,'2024-07-11 02:45:04.136644','2024-07-11 02:45:04.726235',589,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6983,'sync-metabase-metadata',2,'2024-07-11 02:45:04.733740','2024-07-11 02:45:04.742042',8,'{}','success'),(6984,'sync-table-privileges',2,'2024-07-11 02:45:04.751386','2024-07-11 02:45:04.759865',8,NULL,'success'),(6985,'analyze',2,'2024-07-11 02:45:04.792638','2024-07-11 02:45:06.908128',2115,NULL,'success'),(6986,'fingerprint-fields',2,'2024-07-11 02:45:04.801139','2024-07-11 02:45:06.738713',1937,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(6987,'classify-fields',2,'2024-07-11 02:45:06.747778','2024-07-11 02:45:06.874540',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(6988,'classify-tables',2,'2024-07-11 02:45:06.882689','2024-07-11 02:45:06.899442',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(6989,'sync',2,'2024-07-11 03:45:00.105034','2024-07-11 03:45:04.504872',4399,NULL,'success'),(6990,'sync-dbms-version',2,'2024-07-11 03:45:00.115602','2024-07-11 03:45:00.124827',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(6991,'sync-timezone',2,'2024-07-11 03:45:00.133231','2024-07-11 03:45:00.143698',10,'{\"timezone-id\":\"+08:00\"}','success'),(6992,'sync-tables',2,'2024-07-11 03:45:00.152637','2024-07-11 03:45:00.179016',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(6993,'sync-fields',2,'2024-07-11 03:45:00.187551','2024-07-11 03:45:03.269456',3081,'{\"total-fields\":836,\"updated-fields\":0}','success'),(6994,'sync-fks',2,'2024-07-11 03:45:03.277921','2024-07-11 03:45:03.893152',615,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(6995,'sync-indexes',2,'2024-07-11 03:45:03.901216','2024-07-11 03:45:04.462024',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(6996,'sync-metabase-metadata',2,'2024-07-11 03:45:04.469427','2024-07-11 03:45:04.477643',8,'{}','success'),(6997,'sync-table-privileges',2,'2024-07-11 03:45:04.487042','2024-07-11 03:45:04.495506',8,NULL,'success'),(6998,'analyze',2,'2024-07-11 03:45:04.530283','2024-07-11 03:45:06.745798',2215,NULL,'success'),(6999,'fingerprint-fields',2,'2024-07-11 03:45:04.538427','2024-07-11 03:45:06.589102',2050,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7000,'classify-fields',2,'2024-07-11 03:45:06.597794','2024-07-11 03:45:06.716257',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7001,'classify-tables',2,'2024-07-11 03:45:06.723490','2024-07-11 03:45:06.736986',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7002,'task-history-cleanup',NULL,'2024-07-11 04:00:00.074399','2024-07-11 04:00:00.087838',13,NULL,'success'),(7003,'sync',2,'2024-07-11 04:45:00.121440','2024-07-11 04:45:04.564562',4443,NULL,'success'),(7004,'sync-dbms-version',2,'2024-07-11 04:45:00.130221','2024-07-11 04:45:00.139560',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7005,'sync-timezone',2,'2024-07-11 04:45:00.148475','2024-07-11 04:45:00.159966',11,'{\"timezone-id\":\"+08:00\"}','success'),(7006,'sync-tables',2,'2024-07-11 04:45:00.169682','2024-07-11 04:45:00.198004',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7007,'sync-fields',2,'2024-07-11 04:45:00.206984','2024-07-11 04:45:03.319927',3112,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7008,'sync-fks',2,'2024-07-11 04:45:03.327556','2024-07-11 04:45:03.932133',604,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7009,'sync-indexes',2,'2024-07-11 04:45:03.941370','2024-07-11 04:45:04.522866',581,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7010,'sync-metabase-metadata',2,'2024-07-11 04:45:04.530959','2024-07-11 04:45:04.539523',8,'{}','success'),(7011,'sync-table-privileges',2,'2024-07-11 04:45:04.547438','2024-07-11 04:45:04.555302',7,NULL,'success'),(7012,'analyze',2,'2024-07-11 04:45:04.588953','2024-07-11 04:45:06.719304',2130,NULL,'success'),(7013,'fingerprint-fields',2,'2024-07-11 04:45:04.596898','2024-07-11 04:45:06.550480',1953,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7014,'classify-fields',2,'2024-07-11 04:45:06.559442','2024-07-11 04:45:06.683189',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7015,'classify-tables',2,'2024-07-11 04:45:06.693512','2024-07-11 04:45:06.709627',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7016,'sync',2,'2024-07-11 05:45:00.100612','2024-07-11 05:45:04.596220',4495,NULL,'success'),(7017,'sync-dbms-version',2,'2024-07-11 05:45:00.109928','2024-07-11 05:45:00.120727',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7018,'sync-timezone',2,'2024-07-11 05:45:00.129392','2024-07-11 05:45:00.140393',11,'{\"timezone-id\":\"+08:00\"}','success'),(7019,'sync-tables',2,'2024-07-11 05:45:00.148948','2024-07-11 05:45:00.177003',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7020,'sync-fields',2,'2024-07-11 05:45:00.185718','2024-07-11 05:45:03.253697',3067,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7021,'sync-fks',2,'2024-07-11 05:45:03.262487','2024-07-11 05:45:03.934419',671,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7022,'sync-indexes',2,'2024-07-11 05:45:03.944044','2024-07-11 05:45:04.551073',607,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7023,'sync-metabase-metadata',2,'2024-07-11 05:45:04.559224','2024-07-11 05:45:04.568972',9,'{}','success'),(7024,'sync-table-privileges',2,'2024-07-11 05:45:04.577696','2024-07-11 05:45:04.587074',9,NULL,'success'),(7025,'analyze',2,'2024-07-11 05:45:04.622360','2024-07-11 05:45:06.709736',2087,NULL,'success'),(7026,'fingerprint-fields',2,'2024-07-11 05:45:04.631482','2024-07-11 05:45:06.560275',1928,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7027,'classify-fields',2,'2024-07-11 05:45:06.568489','2024-07-11 05:45:06.678153',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7028,'classify-tables',2,'2024-07-11 05:45:06.685485','2024-07-11 05:45:06.700143',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7029,'sync',2,'2024-07-11 06:45:00.113292','2024-07-11 06:45:04.562012',4448,NULL,'success'),(7030,'sync-dbms-version',2,'2024-07-11 06:45:00.121552','2024-07-11 06:45:00.132412',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7031,'sync-timezone',2,'2024-07-11 06:45:00.141735','2024-07-11 06:45:00.153595',11,'{\"timezone-id\":\"+08:00\"}','success'),(7032,'sync-tables',2,'2024-07-11 06:45:00.163147','2024-07-11 06:45:00.191932',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7033,'sync-fields',2,'2024-07-11 06:45:00.207048','2024-07-11 06:45:03.355788',3148,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7034,'sync-fks',2,'2024-07-11 06:45:03.364285','2024-07-11 06:45:03.996423',632,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7035,'sync-indexes',2,'2024-07-11 06:45:04.004606','2024-07-11 06:45:04.520810',516,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7036,'sync-metabase-metadata',2,'2024-07-11 06:45:04.528599','2024-07-11 06:45:04.536723',8,'{}','success'),(7037,'sync-table-privileges',2,'2024-07-11 06:45:04.544897','2024-07-11 06:45:04.553383',8,NULL,'success'),(7038,'analyze',2,'2024-07-11 06:45:04.588081','2024-07-11 06:45:06.785860',2197,NULL,'success'),(7039,'fingerprint-fields',2,'2024-07-11 06:45:04.596283','2024-07-11 06:45:06.634089',2037,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7040,'classify-fields',2,'2024-07-11 06:45:06.642899','2024-07-11 06:45:06.757204',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7041,'classify-tables',2,'2024-07-11 06:45:06.764320','2024-07-11 06:45:06.777456',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7042,'sync',2,'2024-07-11 07:45:00.091292','2024-07-11 07:45:04.458621',4367,NULL,'success'),(7043,'sync-dbms-version',2,'2024-07-11 07:45:00.099347','2024-07-11 07:45:00.109687',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7044,'sync-timezone',2,'2024-07-11 07:45:00.118231','2024-07-11 07:45:00.128339',10,'{\"timezone-id\":\"+08:00\"}','success'),(7045,'sync-tables',2,'2024-07-11 07:45:00.138124','2024-07-11 07:45:00.166966',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7046,'sync-fields',2,'2024-07-11 07:45:00.176466','2024-07-11 07:45:03.238560',3062,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7047,'sync-fks',2,'2024-07-11 07:45:03.246839','2024-07-11 07:45:03.870456',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7048,'sync-indexes',2,'2024-07-11 07:45:03.879262','2024-07-11 07:45:04.416346',537,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7049,'sync-metabase-metadata',2,'2024-07-11 07:45:04.423987','2024-07-11 07:45:04.432851',8,'{}','success'),(7050,'sync-table-privileges',2,'2024-07-11 07:45:04.441700','2024-07-11 07:45:04.450028',8,NULL,'success'),(7051,'analyze',2,'2024-07-11 07:45:04.484360','2024-07-11 07:45:06.520877',2036,NULL,'success'),(7052,'fingerprint-fields',2,'2024-07-11 07:45:04.492814','2024-07-11 07:45:06.366361',1873,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7053,'classify-fields',2,'2024-07-11 07:45:06.375078','2024-07-11 07:45:06.490448',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7054,'classify-tables',2,'2024-07-11 07:45:06.497850','2024-07-11 07:45:06.511966',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7055,'sync',2,'2024-07-11 08:45:00.116017','2024-07-11 08:45:04.719027',4603,NULL,'success'),(7056,'sync-dbms-version',2,'2024-07-11 08:45:00.125065','2024-07-11 08:45:00.134926',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7057,'sync-timezone',2,'2024-07-11 08:45:00.144486','2024-07-11 08:45:00.156273',11,'{\"timezone-id\":\"+08:00\"}','success'),(7058,'sync-tables',2,'2024-07-11 08:45:00.165278','2024-07-11 08:45:00.206184',40,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7059,'sync-fields',2,'2024-07-11 08:45:00.216743','2024-07-11 08:45:03.396027',3179,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7060,'sync-fks',2,'2024-07-11 08:45:03.404770','2024-07-11 08:45:04.056780',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7061,'sync-indexes',2,'2024-07-11 08:45:04.066344','2024-07-11 08:45:04.673312',606,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7062,'sync-metabase-metadata',2,'2024-07-11 08:45:04.682033','2024-07-11 08:45:04.691304',9,'{}','success'),(7063,'sync-table-privileges',2,'2024-07-11 08:45:04.700322','2024-07-11 08:45:04.710178',9,NULL,'success'),(7064,'analyze',2,'2024-07-11 08:45:04.743802','2024-07-11 08:45:06.960326',2216,NULL,'success'),(7065,'fingerprint-fields',2,'2024-07-11 08:45:04.751945','2024-07-11 08:45:06.809919',2057,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7066,'classify-fields',2,'2024-07-11 08:45:06.818189','2024-07-11 08:45:06.930508',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7067,'classify-tables',2,'2024-07-11 08:45:06.938257','2024-07-11 08:45:06.952115',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7068,'sync',2,'2024-07-11 09:45:00.105520','2024-07-11 09:45:04.294889',4189,NULL,'success'),(7069,'sync-dbms-version',2,'2024-07-11 09:45:00.113754','2024-07-11 09:45:00.122230',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7070,'sync-timezone',2,'2024-07-11 09:45:00.131141','2024-07-11 09:45:00.140565',9,'{\"timezone-id\":\"+08:00\"}','success'),(7071,'sync-tables',2,'2024-07-11 09:45:00.150801','2024-07-11 09:45:00.177610',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7072,'sync-fields',2,'2024-07-11 09:45:00.186879','2024-07-11 09:45:03.188077',3001,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7073,'sync-fks',2,'2024-07-11 09:45:03.196140','2024-07-11 09:45:03.756618',560,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7074,'sync-indexes',2,'2024-07-11 09:45:03.764460','2024-07-11 09:45:04.255815',491,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7075,'sync-metabase-metadata',2,'2024-07-11 09:45:04.263276','2024-07-11 09:45:04.270571',7,'{}','success'),(7076,'sync-table-privileges',2,'2024-07-11 09:45:04.278906','2024-07-11 09:45:04.287070',8,NULL,'success'),(7077,'analyze',2,'2024-07-11 09:45:04.320081','2024-07-11 09:45:06.336751',2016,NULL,'success'),(7078,'fingerprint-fields',2,'2024-07-11 09:45:04.327469','2024-07-11 09:45:06.174103',1846,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7079,'classify-fields',2,'2024-07-11 09:45:06.182694','2024-07-11 09:45:06.305657',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7080,'classify-tables',2,'2024-07-11 09:45:06.313496','2024-07-11 09:45:06.327415',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7081,'sync',2,'2024-07-11 10:45:00.109835','2024-07-11 10:45:04.463871',4354,NULL,'success'),(7082,'sync-dbms-version',2,'2024-07-11 10:45:00.118008','2024-07-11 10:45:00.128725',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7083,'sync-timezone',2,'2024-07-11 10:45:00.141652','2024-07-11 10:45:00.151807',10,'{\"timezone-id\":\"+08:00\"}','success'),(7084,'sync-tables',2,'2024-07-11 10:45:00.160396','2024-07-11 10:45:00.188321',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7085,'sync-fields',2,'2024-07-11 10:45:00.197906','2024-07-11 10:45:03.232153',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7086,'sync-fks',2,'2024-07-11 10:45:03.241448','2024-07-11 10:45:03.856655',615,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7087,'sync-indexes',2,'2024-07-11 10:45:03.865742','2024-07-11 10:45:04.422296',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7088,'sync-metabase-metadata',2,'2024-07-11 10:45:04.429950','2024-07-11 10:45:04.438347',8,'{}','success'),(7089,'sync-table-privileges',2,'2024-07-11 10:45:04.447478','2024-07-11 10:45:04.455462',7,NULL,'success'),(7090,'analyze',2,'2024-07-11 10:45:04.488335','2024-07-11 10:45:06.580528',2092,NULL,'success'),(7091,'fingerprint-fields',2,'2024-07-11 10:45:04.496043','2024-07-11 10:45:06.409832',1913,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7092,'classify-fields',2,'2024-07-11 10:45:06.418066','2024-07-11 10:45:06.550363',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7093,'classify-tables',2,'2024-07-11 10:45:06.557791','2024-07-11 10:45:06.571912',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7094,'sync',2,'2024-07-11 11:45:00.104410','2024-07-11 11:45:04.387571',4283,NULL,'success'),(7095,'sync-dbms-version',2,'2024-07-11 11:45:00.112926','2024-07-11 11:45:00.123816',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7096,'sync-timezone',2,'2024-07-11 11:45:00.132007','2024-07-11 11:45:00.143064',11,'{\"timezone-id\":\"+08:00\"}','success'),(7097,'sync-tables',2,'2024-07-11 11:45:00.150743','2024-07-11 11:45:00.176527',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7098,'sync-fields',2,'2024-07-11 11:45:00.184391','2024-07-11 11:45:03.172149',2987,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7099,'sync-fks',2,'2024-07-11 11:45:03.179944','2024-07-11 11:45:03.811913',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7100,'sync-indexes',2,'2024-07-11 11:45:03.819908','2024-07-11 11:45:04.346870',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7101,'sync-metabase-metadata',2,'2024-07-11 11:45:04.354225','2024-07-11 11:45:04.362452',8,'{}','success'),(7102,'sync-table-privileges',2,'2024-07-11 11:45:04.370203','2024-07-11 11:45:04.378828',8,NULL,'success'),(7103,'analyze',2,'2024-07-11 11:45:04.418364','2024-07-11 11:45:06.388976',1970,NULL,'success'),(7104,'fingerprint-fields',2,'2024-07-11 11:45:04.426426','2024-07-11 11:45:06.250509',1824,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7105,'classify-fields',2,'2024-07-11 11:45:06.258550','2024-07-11 11:45:06.359480',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7106,'classify-tables',2,'2024-07-11 11:45:06.366873','2024-07-11 11:45:06.380493',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7107,'sync',2,'2024-07-11 12:45:00.089387','2024-07-11 12:45:04.017137',3927,NULL,'success'),(7108,'sync-dbms-version',2,'2024-07-11 12:45:00.097508','2024-07-11 12:45:00.105916',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7109,'sync-timezone',2,'2024-07-11 12:45:00.115883','2024-07-11 12:45:00.126654',10,'{\"timezone-id\":\"+08:00\"}','success'),(7110,'sync-tables',2,'2024-07-11 12:45:00.135229','2024-07-11 12:45:00.163023',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7111,'sync-fields',2,'2024-07-11 12:45:00.171807','2024-07-11 12:45:02.957827',2786,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7112,'sync-fks',2,'2024-07-11 12:45:02.965298','2024-07-11 12:45:03.518239',552,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7113,'sync-indexes',2,'2024-07-11 12:45:03.526018','2024-07-11 12:45:03.975504',449,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7114,'sync-metabase-metadata',2,'2024-07-11 12:45:03.984713','2024-07-11 12:45:03.992779',8,'{}','success'),(7115,'sync-table-privileges',2,'2024-07-11 12:45:04.000020','2024-07-11 12:45:04.008297',8,NULL,'success'),(7116,'analyze',2,'2024-07-11 12:45:04.044188','2024-07-11 12:45:05.947798',1903,NULL,'success'),(7117,'fingerprint-fields',2,'2024-07-11 12:45:04.052168','2024-07-11 12:45:05.804903',1752,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7118,'classify-fields',2,'2024-07-11 12:45:05.814363','2024-07-11 12:45:05.918635',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7119,'classify-tables',2,'2024-07-11 12:45:05.925807','2024-07-11 12:45:05.939092',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7120,'field values scanning',2,'2024-07-11 13:00:00.071977','2024-07-11 13:00:04.253487',4181,NULL,'success'),(7121,'delete-expired-advanced-field-values',2,'2024-07-11 13:00:00.087071','2024-07-11 13:00:02.982256',2895,'{\"deleted\":0}','success'),(7122,'update-field-values',2,'2024-07-11 13:00:02.990141','2024-07-11 13:00:04.244552',1254,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(7123,'sync',2,'2024-07-11 13:45:00.093780','2024-07-11 13:45:04.090123',3996,NULL,'success'),(7124,'sync-dbms-version',2,'2024-07-11 13:45:00.101759','2024-07-11 13:45:00.110900',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7125,'sync-timezone',2,'2024-07-11 13:45:00.119861','2024-07-11 13:45:00.130170',10,'{\"timezone-id\":\"+08:00\"}','success'),(7126,'sync-tables',2,'2024-07-11 13:45:00.139095','2024-07-11 13:45:00.167171',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7127,'sync-fields',2,'2024-07-11 13:45:00.175435','2024-07-11 13:45:02.973911',2798,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7128,'sync-fks',2,'2024-07-11 13:45:02.981793','2024-07-11 13:45:03.559656',577,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7129,'sync-indexes',2,'2024-07-11 13:45:03.567386','2024-07-11 13:45:04.051754',484,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7130,'sync-metabase-metadata',2,'2024-07-11 13:45:04.059107','2024-07-11 13:45:04.067078',7,'{}','success'),(7131,'sync-table-privileges',2,'2024-07-11 13:45:04.074646','2024-07-11 13:45:04.082727',8,NULL,'success'),(7132,'analyze',2,'2024-07-11 13:45:04.114936','2024-07-11 13:45:06.050291',1935,NULL,'success'),(7133,'fingerprint-fields',2,'2024-07-11 13:45:04.122810','2024-07-11 13:45:05.910825',1788,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7134,'classify-fields',2,'2024-07-11 13:45:05.918044','2024-07-11 13:45:06.020264',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7135,'classify-tables',2,'2024-07-11 13:45:06.028001','2024-07-11 13:45:06.041887',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7136,'sync',2,'2024-07-11 14:45:00.112886','2024-07-11 14:45:03.893217',3780,NULL,'success'),(7137,'sync-dbms-version',2,'2024-07-11 14:45:00.121878','2024-07-11 14:45:00.130532',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7138,'sync-timezone',2,'2024-07-11 14:45:00.139118','2024-07-11 14:45:00.148611',9,'{\"timezone-id\":\"+08:00\"}','success'),(7139,'sync-tables',2,'2024-07-11 14:45:00.156674','2024-07-11 14:45:00.182093',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7140,'sync-fields',2,'2024-07-11 14:45:00.190378','2024-07-11 14:45:02.856812',2666,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7141,'sync-fks',2,'2024-07-11 14:45:02.864036','2024-07-11 14:45:03.387755',523,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7142,'sync-indexes',2,'2024-07-11 14:45:03.395219','2024-07-11 14:45:03.856259',461,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7143,'sync-metabase-metadata',2,'2024-07-11 14:45:03.863407','2024-07-11 14:45:03.870747',7,'{}','success'),(7144,'sync-table-privileges',2,'2024-07-11 14:45:03.878362','2024-07-11 14:45:03.886162',7,NULL,'success'),(7145,'analyze',2,'2024-07-11 14:45:03.919050','2024-07-11 14:45:05.874207',1955,NULL,'success'),(7146,'fingerprint-fields',2,'2024-07-11 14:45:03.926554','2024-07-11 14:45:05.728944',1802,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7147,'classify-fields',2,'2024-07-11 14:45:05.737893','2024-07-11 14:45:05.845031',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7148,'classify-tables',2,'2024-07-11 14:45:05.852562','2024-07-11 14:45:05.866165',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7149,'sync',2,'2024-07-11 15:45:00.098755','2024-07-11 15:45:04.585114',4486,NULL,'success'),(7150,'sync-dbms-version',2,'2024-07-11 15:45:00.106712','2024-07-11 15:45:00.115408',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7151,'sync-timezone',2,'2024-07-11 15:45:00.123247','2024-07-11 15:45:00.132840',9,'{\"timezone-id\":\"+08:00\"}','success'),(7152,'sync-tables',2,'2024-07-11 15:45:00.141310','2024-07-11 15:45:00.167371',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7153,'sync-fields',2,'2024-07-11 15:45:00.175477','2024-07-11 15:45:03.274979',3099,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7154,'sync-fks',2,'2024-07-11 15:45:03.284512','2024-07-11 15:45:03.954993',670,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7155,'sync-indexes',2,'2024-07-11 15:45:03.965630','2024-07-11 15:45:04.540865',575,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7156,'sync-metabase-metadata',2,'2024-07-11 15:45:04.549023','2024-07-11 15:45:04.557422',8,'{}','success'),(7157,'sync-table-privileges',2,'2024-07-11 15:45:04.568400','2024-07-11 15:45:04.577073',8,NULL,'success'),(7158,'analyze',2,'2024-07-11 15:45:04.610554','2024-07-11 15:45:06.781995',2171,NULL,'success'),(7159,'fingerprint-fields',2,'2024-07-11 15:45:04.619018','2024-07-11 15:45:06.615974',1996,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7160,'classify-fields',2,'2024-07-11 15:45:06.625927','2024-07-11 15:45:06.749366',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7161,'classify-tables',2,'2024-07-11 15:45:06.757243','2024-07-11 15:45:06.772571',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7162,'task-history-cleanup',NULL,'2024-07-11 16:00:00.035724','2024-07-11 16:00:00.123489',87,NULL,'success'),(7163,'task-history-cleanup',NULL,'2024-07-11 16:00:00.084349','2024-07-11 16:00:00.124366',40,NULL,'success'),(7164,'sync',2,'2024-07-11 16:45:00.084858','2024-07-11 16:45:04.205296',4120,NULL,'success'),(7165,'sync-dbms-version',2,'2024-07-11 16:45:00.092964','2024-07-11 16:45:00.101633',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7166,'sync-timezone',2,'2024-07-11 16:45:00.111963','2024-07-11 16:45:00.120957',8,'{\"timezone-id\":\"+08:00\"}','success'),(7167,'sync-tables',2,'2024-07-11 16:45:00.128769','2024-07-11 16:45:00.153927',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7168,'sync-fields',2,'2024-07-11 16:45:00.162167','2024-07-11 16:45:03.021679',2859,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7169,'sync-fks',2,'2024-07-11 16:45:03.028800','2024-07-11 16:45:03.612751',583,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7170,'sync-indexes',2,'2024-07-11 16:45:03.621768','2024-07-11 16:45:04.164279',542,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7171,'sync-metabase-metadata',2,'2024-07-11 16:45:04.171876','2024-07-11 16:45:04.179520',7,'{}','success'),(7172,'sync-table-privileges',2,'2024-07-11 16:45:04.188094','2024-07-11 16:45:04.197308',9,NULL,'success'),(7173,'analyze',2,'2024-07-11 16:45:04.229394','2024-07-11 16:45:06.267319',2037,NULL,'success'),(7174,'fingerprint-fields',2,'2024-07-11 16:45:04.237831','2024-07-11 16:45:06.098403',1860,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7175,'classify-fields',2,'2024-07-11 16:45:06.108744','2024-07-11 16:45:06.233453',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7176,'classify-tables',2,'2024-07-11 16:45:06.241731','2024-07-11 16:45:06.257920',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7177,'sync',2,'2024-07-11 17:45:00.113599','2024-07-11 17:45:04.604986',4491,NULL,'success'),(7178,'sync-dbms-version',2,'2024-07-11 17:45:00.122954','2024-07-11 17:45:00.133960',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7179,'sync-timezone',2,'2024-07-11 17:45:00.144054','2024-07-11 17:45:00.155359',11,'{\"timezone-id\":\"+08:00\"}','success'),(7180,'sync-tables',2,'2024-07-11 17:45:00.164248','2024-07-11 17:45:00.190501',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7181,'sync-fields',2,'2024-07-11 17:45:00.199303','2024-07-11 17:45:03.362830',3163,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7182,'sync-fks',2,'2024-07-11 17:45:03.370830','2024-07-11 17:45:04.003375',632,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7183,'sync-indexes',2,'2024-07-11 17:45:04.011764','2024-07-11 17:45:04.556400',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7184,'sync-metabase-metadata',2,'2024-07-11 17:45:04.564555','2024-07-11 17:45:04.573660',9,'{}','success'),(7185,'sync-table-privileges',2,'2024-07-11 17:45:04.587603','2024-07-11 17:45:04.596139',8,NULL,'success'),(7186,'analyze',2,'2024-07-11 17:45:04.631820','2024-07-11 17:45:06.614635',1982,NULL,'success'),(7187,'fingerprint-fields',2,'2024-07-11 17:45:04.641458','2024-07-11 17:45:06.464253',1822,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7188,'classify-fields',2,'2024-07-11 17:45:06.472700','2024-07-11 17:45:06.584623',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7189,'classify-tables',2,'2024-07-11 17:45:06.592388','2024-07-11 17:45:06.605984',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7190,'sync',2,'2024-07-11 18:45:00.122299','2024-07-11 18:45:04.931325',4809,NULL,'success'),(7191,'sync-dbms-version',2,'2024-07-11 18:45:00.131859','2024-07-11 18:45:00.142813',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7192,'sync-timezone',2,'2024-07-11 18:45:00.152196','2024-07-11 18:45:00.163308',11,'{\"timezone-id\":\"+08:00\"}','success'),(7193,'sync-tables',2,'2024-07-11 18:45:00.171451','2024-07-11 18:45:00.201049',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7194,'sync-fields',2,'2024-07-11 18:45:00.210686','2024-07-11 18:45:03.543937',3333,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7195,'sync-fks',2,'2024-07-11 18:45:03.552995','2024-07-11 18:45:04.287163',734,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7196,'sync-indexes',2,'2024-07-11 18:45:04.295706','2024-07-11 18:45:04.885323',589,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7197,'sync-metabase-metadata',2,'2024-07-11 18:45:04.894419','2024-07-11 18:45:04.904130',9,'{}','success'),(7198,'sync-table-privileges',2,'2024-07-11 18:45:04.913390','2024-07-11 18:45:04.921887',8,NULL,'success'),(7199,'analyze',2,'2024-07-11 18:45:04.955441','2024-07-11 18:45:07.201555',2246,NULL,'success'),(7200,'fingerprint-fields',2,'2024-07-11 18:45:04.965263','2024-07-11 18:45:07.042959',2077,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7201,'classify-fields',2,'2024-07-11 18:45:07.052390','2024-07-11 18:45:07.168162',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7202,'classify-tables',2,'2024-07-11 18:45:07.176303','2024-07-11 18:45:07.190986',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7203,'sync',2,'2024-07-11 19:45:00.122604','2024-07-11 19:45:05.044437',4921,NULL,'success'),(7204,'sync-dbms-version',2,'2024-07-11 19:45:00.131715','2024-07-11 19:45:00.143756',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7205,'sync-timezone',2,'2024-07-11 19:45:00.154075','2024-07-11 19:45:00.165215',11,'{\"timezone-id\":\"+08:00\"}','success'),(7206,'sync-tables',2,'2024-07-11 19:45:00.174270','2024-07-11 19:45:00.204390',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7207,'sync-fields',2,'2024-07-11 19:45:00.213797','2024-07-11 19:45:03.606910',3393,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7208,'sync-fks',2,'2024-07-11 19:45:03.616218','2024-07-11 19:45:04.370638',754,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7209,'sync-indexes',2,'2024-07-11 19:45:04.379946','2024-07-11 19:45:04.994919',614,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7210,'sync-metabase-metadata',2,'2024-07-11 19:45:05.005219','2024-07-11 19:45:05.016130',10,'{}','success'),(7211,'sync-table-privileges',2,'2024-07-11 19:45:05.026169','2024-07-11 19:45:05.035836',9,NULL,'success'),(7212,'analyze',2,'2024-07-11 19:45:05.074029','2024-07-11 19:45:07.234439',2160,NULL,'success'),(7213,'fingerprint-fields',2,'2024-07-11 19:45:05.083664','2024-07-11 19:45:07.082626',1998,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7214,'classify-fields',2,'2024-07-11 19:45:07.090572','2024-07-11 19:45:07.203447',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7215,'classify-tables',2,'2024-07-11 19:45:07.211438','2024-07-11 19:45:07.225937',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7216,'sync',2,'2024-07-11 20:45:00.097879','2024-07-11 20:45:04.203873',4105,NULL,'success'),(7217,'sync-dbms-version',2,'2024-07-11 20:45:00.112160','2024-07-11 20:45:00.121168',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7218,'sync-timezone',2,'2024-07-11 20:45:00.129903','2024-07-11 20:45:00.140955',11,'{\"timezone-id\":\"+08:00\"}','success'),(7219,'sync-tables',2,'2024-07-11 20:45:00.149151','2024-07-11 20:45:00.174729',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7220,'sync-fields',2,'2024-07-11 20:45:00.183418','2024-07-11 20:45:03.023374',2839,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7221,'sync-fks',2,'2024-07-11 20:45:03.031256','2024-07-11 20:45:03.644057',612,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7222,'sync-indexes',2,'2024-07-11 20:45:03.651927','2024-07-11 20:45:04.164215',512,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7223,'sync-metabase-metadata',2,'2024-07-11 20:45:04.171390','2024-07-11 20:45:04.179653',8,'{}','success'),(7224,'sync-table-privileges',2,'2024-07-11 20:45:04.187889','2024-07-11 20:45:04.196071',8,NULL,'success'),(7225,'analyze',2,'2024-07-11 20:45:04.228230','2024-07-11 20:45:06.141220',1912,NULL,'success'),(7226,'fingerprint-fields',2,'2024-07-11 20:45:04.236096','2024-07-11 20:45:05.988716',1752,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7227,'classify-fields',2,'2024-07-11 20:45:05.996650','2024-07-11 20:45:06.109198',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7228,'classify-tables',2,'2024-07-11 20:45:06.116918','2024-07-11 20:45:06.132401',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7229,'sync',2,'2024-07-11 21:45:00.106525','2024-07-11 21:45:04.437349',4330,NULL,'success'),(7230,'sync-dbms-version',2,'2024-07-11 21:45:00.116148','2024-07-11 21:45:00.129227',13,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7231,'sync-timezone',2,'2024-07-11 21:45:00.139436','2024-07-11 21:45:00.152099',12,'{\"timezone-id\":\"+08:00\"}','success'),(7232,'sync-tables',2,'2024-07-11 21:45:00.165340','2024-07-11 21:45:00.193717',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7233,'sync-fields',2,'2024-07-11 21:45:00.201951','2024-07-11 21:45:03.249613',3047,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7234,'sync-fks',2,'2024-07-11 21:45:03.257681','2024-07-11 21:45:03.836322',578,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7235,'sync-indexes',2,'2024-07-11 21:45:03.845872','2024-07-11 21:45:04.397648',551,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7236,'sync-metabase-metadata',2,'2024-07-11 21:45:04.405227','2024-07-11 21:45:04.413082',7,'{}','success'),(7237,'sync-table-privileges',2,'2024-07-11 21:45:04.421020','2024-07-11 21:45:04.429320',8,NULL,'success'),(7238,'analyze',2,'2024-07-11 21:45:04.461004','2024-07-11 21:45:06.665293',2204,NULL,'success'),(7239,'fingerprint-fields',2,'2024-07-11 21:45:04.469930','2024-07-11 21:45:06.495791',2025,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7240,'classify-fields',2,'2024-07-11 21:45:06.505030','2024-07-11 21:45:06.630912',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7241,'classify-tables',2,'2024-07-11 21:45:06.638774','2024-07-11 21:45:06.655480',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7242,'sync',2,'2024-07-11 22:45:00.108994','2024-07-11 22:45:04.150308',4041,NULL,'success'),(7243,'sync-dbms-version',2,'2024-07-11 22:45:00.116204','2024-07-11 22:45:00.125630',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7244,'sync-timezone',2,'2024-07-11 22:45:00.133022','2024-07-11 22:45:00.141842',8,'{\"timezone-id\":\"+08:00\"}','success'),(7245,'sync-tables',2,'2024-07-11 22:45:00.150075','2024-07-11 22:45:00.173951',23,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7246,'sync-fields',2,'2024-07-11 22:45:00.181846','2024-07-11 22:45:02.928247',2746,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7247,'sync-fks',2,'2024-07-11 22:45:02.935365','2024-07-11 22:45:03.513768',578,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7248,'sync-indexes',2,'2024-07-11 22:45:03.521829','2024-07-11 22:45:04.111364',589,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7249,'sync-metabase-metadata',2,'2024-07-11 22:45:04.118190','2024-07-11 22:45:04.125291',7,'{}','success'),(7250,'sync-table-privileges',2,'2024-07-11 22:45:04.133478','2024-07-11 22:45:04.142171',8,NULL,'success'),(7251,'analyze',2,'2024-07-11 22:45:04.173201','2024-07-11 22:45:05.963356',1790,NULL,'success'),(7252,'fingerprint-fields',2,'2024-07-11 22:45:04.180482','2024-07-11 22:45:05.822910',1642,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7253,'classify-fields',2,'2024-07-11 22:45:05.830846','2024-07-11 22:45:05.934986',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7254,'classify-tables',2,'2024-07-11 22:45:05.942624','2024-07-11 22:45:05.955624',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7255,'sync',2,'2024-07-11 23:45:00.122976','2024-07-11 23:45:04.618842',4495,NULL,'success'),(7256,'sync-dbms-version',2,'2024-07-11 23:45:00.133046','2024-07-11 23:45:00.142089',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7257,'sync-timezone',2,'2024-07-11 23:45:00.150980','2024-07-11 23:45:00.160884',9,'{\"timezone-id\":\"+08:00\"}','success'),(7258,'sync-tables',2,'2024-07-11 23:45:00.169975','2024-07-11 23:45:00.195810',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7259,'sync-fields',2,'2024-07-11 23:45:00.205326','2024-07-11 23:45:03.245572',3040,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7260,'sync-fks',2,'2024-07-11 23:45:03.254238','2024-07-11 23:45:03.943045',688,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7261,'sync-indexes',2,'2024-07-11 23:45:03.953622','2024-07-11 23:45:04.572848',619,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7262,'sync-metabase-metadata',2,'2024-07-11 23:45:04.581269','2024-07-11 23:45:04.590667',9,'{}','success'),(7263,'sync-table-privileges',2,'2024-07-11 23:45:04.599850','2024-07-11 23:45:04.609976',10,NULL,'success'),(7264,'analyze',2,'2024-07-11 23:45:04.648573','2024-07-11 23:45:06.730199',2081,NULL,'success'),(7265,'fingerprint-fields',2,'2024-07-11 23:45:04.658222','2024-07-11 23:45:06.568538',1910,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7266,'classify-fields',2,'2024-07-11 23:45:06.576341','2024-07-11 23:45:06.698386',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7267,'classify-tables',2,'2024-07-11 23:45:06.706831','2024-07-11 23:45:06.721859',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7268,'sync',2,'2024-07-12 00:45:00.105116','2024-07-12 00:45:04.924398',4819,NULL,'success'),(7269,'sync-dbms-version',2,'2024-07-12 00:45:00.114378','2024-07-12 00:45:00.124652',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7270,'sync-timezone',2,'2024-07-12 00:45:00.134233','2024-07-12 00:45:00.145710',11,'{\"timezone-id\":\"+08:00\"}','success'),(7271,'sync-tables',2,'2024-07-12 00:45:00.155578','2024-07-12 00:45:00.186238',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7272,'sync-fields',2,'2024-07-12 00:45:00.197355','2024-07-12 00:45:03.556057',3358,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7273,'sync-fks',2,'2024-07-12 00:45:03.564300','2024-07-12 00:45:04.288519',724,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7274,'sync-indexes',2,'2024-07-12 00:45:04.297326','2024-07-12 00:45:04.881838',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7275,'sync-metabase-metadata',2,'2024-07-12 00:45:04.889520','2024-07-12 00:45:04.898497',8,'{}','success'),(7276,'sync-table-privileges',2,'2024-07-12 00:45:04.907437','2024-07-12 00:45:04.915971',8,NULL,'success'),(7277,'analyze',2,'2024-07-12 00:45:04.949180','2024-07-12 00:45:07.035273',2086,NULL,'success'),(7278,'fingerprint-fields',2,'2024-07-12 00:45:04.957184','2024-07-12 00:45:06.862394',1905,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7279,'classify-fields',2,'2024-07-12 00:45:06.870556','2024-07-12 00:45:06.993572',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7280,'classify-tables',2,'2024-07-12 00:45:07.002249','2024-07-12 00:45:07.025339',23,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7281,'sync',2,'2024-07-12 01:45:00.120599','2024-07-12 01:45:04.598463',4477,NULL,'success'),(7282,'sync-dbms-version',2,'2024-07-12 01:45:00.129901','2024-07-12 01:45:00.140491',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7283,'sync-timezone',2,'2024-07-12 01:45:00.149313','2024-07-12 01:45:00.161118',11,'{\"timezone-id\":\"+08:00\"}','success'),(7284,'sync-tables',2,'2024-07-12 01:45:00.170226','2024-07-12 01:45:00.200157',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7285,'sync-fields',2,'2024-07-12 01:45:00.210604','2024-07-12 01:45:03.255200',3044,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7286,'sync-fks',2,'2024-07-12 01:45:03.262745','2024-07-12 01:45:03.897443',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7287,'sync-indexes',2,'2024-07-12 01:45:03.909867','2024-07-12 01:45:04.550144',640,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7288,'sync-metabase-metadata',2,'2024-07-12 01:45:04.561500','2024-07-12 01:45:04.571531',10,'{}','success'),(7289,'sync-table-privileges',2,'2024-07-12 01:45:04.580449','2024-07-12 01:45:04.589988',9,NULL,'success'),(7290,'analyze',2,'2024-07-12 01:45:04.625768','2024-07-12 01:45:06.891734',2265,NULL,'success'),(7291,'fingerprint-fields',2,'2024-07-12 01:45:04.635119','2024-07-12 01:45:06.732630',2097,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7292,'classify-fields',2,'2024-07-12 01:45:06.741679','2024-07-12 01:45:06.858988',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7293,'classify-tables',2,'2024-07-12 01:45:06.866365','2024-07-12 01:45:06.882445',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7294,'sync',2,'2024-07-12 02:45:00.117562','2024-07-12 02:45:05.415153',5297,NULL,'success'),(7295,'sync-dbms-version',2,'2024-07-12 02:45:00.126951','2024-07-12 02:45:00.137415',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7296,'sync-timezone',2,'2024-07-12 02:45:00.145724','2024-07-12 02:45:00.156987',11,'{\"timezone-id\":\"+08:00\"}','success'),(7297,'sync-tables',2,'2024-07-12 02:45:00.166640','2024-07-12 02:45:00.198288',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7298,'sync-fields',2,'2024-07-12 02:45:00.207619','2024-07-12 02:45:03.331956',3124,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7299,'sync-fks',2,'2024-07-12 02:45:03.342246','2024-07-12 02:45:03.997027',654,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7300,'sync-indexes',2,'2024-07-12 02:45:04.005461','2024-07-12 02:45:05.371210',1365,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7301,'sync-metabase-metadata',2,'2024-07-12 02:45:05.379670','2024-07-12 02:45:05.388105',8,'{}','success'),(7302,'sync-table-privileges',2,'2024-07-12 02:45:05.397116','2024-07-12 02:45:05.405944',8,NULL,'success'),(7303,'analyze',2,'2024-07-12 02:45:05.441845','2024-07-12 02:45:07.712118',2270,NULL,'success'),(7304,'fingerprint-fields',2,'2024-07-12 02:45:05.450185','2024-07-12 02:45:07.533216',2083,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7305,'classify-fields',2,'2024-07-12 02:45:07.549905','2024-07-12 02:45:07.679044',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7306,'classify-tables',2,'2024-07-12 02:45:07.688281','2024-07-12 02:45:07.702296',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7307,'sync',2,'2024-07-12 03:45:00.109218','2024-07-12 03:45:04.359770',4250,NULL,'success'),(7308,'sync-dbms-version',2,'2024-07-12 03:45:00.117295','2024-07-12 03:45:00.126152',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7309,'sync-timezone',2,'2024-07-12 03:45:00.135499','2024-07-12 03:45:00.146039',10,'{\"timezone-id\":\"+08:00\"}','success'),(7310,'sync-tables',2,'2024-07-12 03:45:00.154943','2024-07-12 03:45:00.180511',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7311,'sync-fields',2,'2024-07-12 03:45:00.188856','2024-07-12 03:45:03.171314',2982,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7312,'sync-fks',2,'2024-07-12 03:45:03.179519','2024-07-12 03:45:03.805568',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7313,'sync-indexes',2,'2024-07-12 03:45:03.813719','2024-07-12 03:45:04.321285',507,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7314,'sync-metabase-metadata',2,'2024-07-12 03:45:04.328751','2024-07-12 03:45:04.337013',8,'{}','success'),(7315,'sync-table-privileges',2,'2024-07-12 03:45:04.344837','2024-07-12 03:45:04.352306',7,NULL,'success'),(7316,'analyze',2,'2024-07-12 03:45:04.382996','2024-07-12 03:45:06.491154',2108,NULL,'success'),(7317,'fingerprint-fields',2,'2024-07-12 03:45:04.390480','2024-07-12 03:45:06.305317',1914,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7318,'classify-fields',2,'2024-07-12 03:45:06.313816','2024-07-12 03:45:06.458266',144,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7319,'classify-tables',2,'2024-07-12 03:45:06.466829','2024-07-12 03:45:06.480665',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7320,'task-history-cleanup',NULL,'2024-07-12 04:00:00.089229','2024-07-12 04:00:00.100919',11,NULL,'success'),(7321,'sync',2,'2024-07-12 04:45:00.117763','2024-07-12 04:45:04.924626',4806,NULL,'success'),(7322,'sync-dbms-version',2,'2024-07-12 04:45:00.126994','2024-07-12 04:45:00.136172',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7323,'sync-timezone',2,'2024-07-12 04:45:00.144615','2024-07-12 04:45:00.154442',9,'{\"timezone-id\":\"+08:00\"}','success'),(7324,'sync-tables',2,'2024-07-12 04:45:00.162939','2024-07-12 04:45:00.189922',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7325,'sync-fields',2,'2024-07-12 04:45:00.198566','2024-07-12 04:45:03.600025',3401,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7326,'sync-fks',2,'2024-07-12 04:45:03.608332','2024-07-12 04:45:04.298213',689,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7327,'sync-indexes',2,'2024-07-12 04:45:04.307849','2024-07-12 04:45:04.882468',574,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7328,'sync-metabase-metadata',2,'2024-07-12 04:45:04.890119','2024-07-12 04:45:04.899464',9,'{}','success'),(7329,'sync-table-privileges',2,'2024-07-12 04:45:04.907651','2024-07-12 04:45:04.916350',8,NULL,'success'),(7330,'analyze',2,'2024-07-12 04:45:04.949732','2024-07-12 04:45:07.101123',2151,NULL,'success'),(7331,'fingerprint-fields',2,'2024-07-12 04:45:04.958651','2024-07-12 04:45:06.934571',1975,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7332,'classify-fields',2,'2024-07-12 04:45:06.943442','2024-07-12 04:45:07.068771',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7333,'classify-tables',2,'2024-07-12 04:45:07.076354','2024-07-12 04:45:07.092338',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7334,'sync',2,'2024-07-12 05:45:00.095959','2024-07-12 05:45:04.165693',4069,NULL,'success'),(7335,'sync-dbms-version',2,'2024-07-12 05:45:00.103641','2024-07-12 05:45:00.112628',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7336,'sync-timezone',2,'2024-07-12 05:45:00.121315','2024-07-12 05:45:00.131699',10,'{\"timezone-id\":\"+08:00\"}','success'),(7337,'sync-tables',2,'2024-07-12 05:45:00.139846','2024-07-12 05:45:00.166997',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7338,'sync-fields',2,'2024-07-12 05:45:00.174931','2024-07-12 05:45:03.057561',2882,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7339,'sync-fks',2,'2024-07-12 05:45:03.065794','2024-07-12 05:45:03.645834',580,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7340,'sync-indexes',2,'2024-07-12 05:45:03.653624','2024-07-12 05:45:04.127554',473,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7341,'sync-metabase-metadata',2,'2024-07-12 05:45:04.134865','2024-07-12 05:45:04.142866',8,'{}','success'),(7342,'sync-table-privileges',2,'2024-07-12 05:45:04.150123','2024-07-12 05:45:04.157915',7,NULL,'success'),(7343,'analyze',2,'2024-07-12 05:45:04.197024','2024-07-12 05:45:06.215001',2017,NULL,'success'),(7344,'fingerprint-fields',2,'2024-07-12 05:45:04.204821','2024-07-12 05:45:06.053577',1848,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7345,'classify-fields',2,'2024-07-12 05:45:06.061316','2024-07-12 05:45:06.184267',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7346,'classify-tables',2,'2024-07-12 05:45:06.192947','2024-07-12 05:45:06.206660',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7347,'sync',2,'2024-07-12 06:45:00.100359','2024-07-12 06:45:04.570129',4469,NULL,'success'),(7348,'sync-dbms-version',2,'2024-07-12 06:45:00.108934','2024-07-12 06:45:00.117751',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7349,'sync-timezone',2,'2024-07-12 06:45:00.127882','2024-07-12 06:45:00.138383',10,'{\"timezone-id\":\"+08:00\"}','success'),(7350,'sync-tables',2,'2024-07-12 06:45:00.147072','2024-07-12 06:45:00.173616',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7351,'sync-fields',2,'2024-07-12 06:45:00.182333','2024-07-12 06:45:03.275484',3093,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7352,'sync-fks',2,'2024-07-12 06:45:03.284765','2024-07-12 06:45:03.976912',692,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7353,'sync-indexes',2,'2024-07-12 06:45:03.985984','2024-07-12 06:45:04.529797',543,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7354,'sync-metabase-metadata',2,'2024-07-12 06:45:04.537509','2024-07-12 06:45:04.545505',7,'{}','success'),(7355,'sync-table-privileges',2,'2024-07-12 06:45:04.554148','2024-07-12 06:45:04.562371',8,NULL,'success'),(7356,'analyze',2,'2024-07-12 06:45:04.595885','2024-07-12 06:45:06.738285',2142,NULL,'success'),(7357,'fingerprint-fields',2,'2024-07-12 06:45:04.604181','2024-07-12 06:45:06.589131',1984,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7358,'classify-fields',2,'2024-07-12 06:45:06.597173','2024-07-12 06:45:06.707133',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7359,'classify-tables',2,'2024-07-12 06:45:06.714574','2024-07-12 06:45:06.729624',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7360,'sync',2,'2024-07-12 07:45:00.097552','2024-07-12 07:45:04.293943',4196,NULL,'success'),(7361,'sync-dbms-version',2,'2024-07-12 07:45:00.105258','2024-07-12 07:45:00.113775',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7362,'sync-timezone',2,'2024-07-12 07:45:00.121836','2024-07-12 07:45:00.131364',9,'{\"timezone-id\":\"+08:00\"}','success'),(7363,'sync-tables',2,'2024-07-12 07:45:00.139641','2024-07-12 07:45:00.165226',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7364,'sync-fields',2,'2024-07-12 07:45:00.173715','2024-07-12 07:45:03.058791',2885,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7365,'sync-fks',2,'2024-07-12 07:45:03.066571','2024-07-12 07:45:03.680354',613,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7366,'sync-indexes',2,'2024-07-12 07:45:03.688370','2024-07-12 07:45:04.250025',561,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7367,'sync-metabase-metadata',2,'2024-07-12 07:45:04.257723','2024-07-12 07:45:04.267928',10,'{}','success'),(7368,'sync-table-privileges',2,'2024-07-12 07:45:04.277525','2024-07-12 07:45:04.285809',8,NULL,'success'),(7369,'analyze',2,'2024-07-12 07:45:04.321052','2024-07-12 07:45:06.225560',1904,NULL,'success'),(7370,'fingerprint-fields',2,'2024-07-12 07:45:04.329859','2024-07-12 07:45:06.081124',1751,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7371,'classify-fields',2,'2024-07-12 07:45:06.097897','2024-07-12 07:45:06.198704',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7372,'classify-tables',2,'2024-07-12 07:45:06.205731','2024-07-12 07:45:06.218014',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7373,'sync',2,'2024-07-12 08:45:00.107665','2024-07-12 08:45:04.297574',4189,NULL,'success'),(7374,'sync-dbms-version',2,'2024-07-12 08:45:00.116749','2024-07-12 08:45:00.126731',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7375,'sync-timezone',2,'2024-07-12 08:45:00.135604','2024-07-12 08:45:00.147202',11,'{\"timezone-id\":\"+08:00\"}','success'),(7376,'sync-tables',2,'2024-07-12 08:45:00.155725','2024-07-12 08:45:00.183018',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7377,'sync-fields',2,'2024-07-12 08:45:00.191302','2024-07-12 08:45:03.134446',2943,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7378,'sync-fks',2,'2024-07-12 08:45:03.142055','2024-07-12 08:45:03.714236',572,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7379,'sync-indexes',2,'2024-07-12 08:45:03.722243','2024-07-12 08:45:04.255785',533,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7380,'sync-metabase-metadata',2,'2024-07-12 08:45:04.263449','2024-07-12 08:45:04.271707',8,'{}','success'),(7381,'sync-table-privileges',2,'2024-07-12 08:45:04.280446','2024-07-12 08:45:04.289130',8,NULL,'success'),(7382,'analyze',2,'2024-07-12 08:45:04.322079','2024-07-12 08:45:06.319043',1996,NULL,'success'),(7383,'fingerprint-fields',2,'2024-07-12 08:45:04.330004','2024-07-12 08:45:06.135131',1805,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7384,'classify-fields',2,'2024-07-12 08:45:06.147054','2024-07-12 08:45:06.287311',140,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7385,'classify-tables',2,'2024-07-12 08:45:06.295370','2024-07-12 08:45:06.310543',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7386,'sync',2,'2024-07-12 09:45:00.106415','2024-07-12 09:45:04.358130',4251,NULL,'success'),(7387,'sync-dbms-version',2,'2024-07-12 09:45:00.114694','2024-07-12 09:45:00.124840',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7388,'sync-timezone',2,'2024-07-12 09:45:00.133510','2024-07-12 09:45:00.143437',9,'{\"timezone-id\":\"+08:00\"}','success'),(7389,'sync-tables',2,'2024-07-12 09:45:00.152262','2024-07-12 09:45:00.180344',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7390,'sync-fields',2,'2024-07-12 09:45:00.189393','2024-07-12 09:45:03.230264',3040,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7391,'sync-fks',2,'2024-07-12 09:45:03.238091','2024-07-12 09:45:03.805551',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7392,'sync-indexes',2,'2024-07-12 09:45:03.813754','2024-07-12 09:45:04.319573',505,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7393,'sync-metabase-metadata',2,'2024-07-12 09:45:04.326683','2024-07-12 09:45:04.334330',7,'{}','success'),(7394,'sync-table-privileges',2,'2024-07-12 09:45:04.342155','2024-07-12 09:45:04.350469',8,NULL,'success'),(7395,'analyze',2,'2024-07-12 09:45:04.381967','2024-07-12 09:45:06.222532',1840,NULL,'success'),(7396,'fingerprint-fields',2,'2024-07-12 09:45:04.389982','2024-07-12 09:45:06.085020',1695,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7397,'classify-fields',2,'2024-07-12 09:45:06.092592','2024-07-12 09:45:06.195503',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7398,'classify-tables',2,'2024-07-12 09:45:06.202569','2024-07-12 09:45:06.214803',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7399,'sync',2,'2024-07-12 10:45:00.108187','2024-07-12 10:45:04.238271',4130,NULL,'success'),(7400,'sync-dbms-version',2,'2024-07-12 10:45:00.117486','2024-07-12 10:45:00.128596',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7401,'sync-timezone',2,'2024-07-12 10:45:00.138181','2024-07-12 10:45:00.149083',10,'{\"timezone-id\":\"+08:00\"}','success'),(7402,'sync-tables',2,'2024-07-12 10:45:00.157728','2024-07-12 10:45:00.186076',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7403,'sync-fields',2,'2024-07-12 10:45:00.194882','2024-07-12 10:45:03.180424',2985,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7404,'sync-fks',2,'2024-07-12 10:45:03.187820','2024-07-12 10:45:03.723643',535,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7405,'sync-indexes',2,'2024-07-12 10:45:03.731488','2024-07-12 10:45:04.199256',467,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7406,'sync-metabase-metadata',2,'2024-07-12 10:45:04.206441','2024-07-12 10:45:04.214454',8,'{}','success'),(7407,'sync-table-privileges',2,'2024-07-12 10:45:04.222554','2024-07-12 10:45:04.230374',7,NULL,'success'),(7408,'analyze',2,'2024-07-12 10:45:04.263489','2024-07-12 10:45:06.290438',2026,NULL,'success'),(7409,'fingerprint-fields',2,'2024-07-12 10:45:04.271023','2024-07-12 10:45:06.139308',1868,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7410,'classify-fields',2,'2024-07-12 10:45:06.148015','2024-07-12 10:45:06.261410',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7411,'classify-tables',2,'2024-07-12 10:45:06.269100','2024-07-12 10:45:06.282898',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7412,'sync',2,'2024-07-12 11:45:00.107609','2024-07-12 11:45:04.422598',4314,NULL,'success'),(7413,'sync-dbms-version',2,'2024-07-12 11:45:00.115268','2024-07-12 11:45:00.123875',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7414,'sync-timezone',2,'2024-07-12 11:45:00.133256','2024-07-12 11:45:00.143273',10,'{\"timezone-id\":\"+08:00\"}','success'),(7415,'sync-tables',2,'2024-07-12 11:45:00.151386','2024-07-12 11:45:00.176987',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7416,'sync-fields',2,'2024-07-12 11:45:00.185228','2024-07-12 11:45:03.145171',2959,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7417,'sync-fks',2,'2024-07-12 11:45:03.154326','2024-07-12 11:45:03.871244',716,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7418,'sync-indexes',2,'2024-07-12 11:45:03.880046','2024-07-12 11:45:04.378677',498,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7419,'sync-metabase-metadata',2,'2024-07-12 11:45:04.386501','2024-07-12 11:45:04.395424',8,'{}','success'),(7420,'sync-table-privileges',2,'2024-07-12 11:45:04.403611','2024-07-12 11:45:04.411601',7,NULL,'success'),(7421,'analyze',2,'2024-07-12 11:45:04.446367','2024-07-12 11:45:06.317740',1871,NULL,'success'),(7422,'fingerprint-fields',2,'2024-07-12 11:45:04.454682','2024-07-12 11:45:06.160552',1705,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7423,'classify-fields',2,'2024-07-12 11:45:06.169208','2024-07-12 11:45:06.285606',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7424,'classify-tables',2,'2024-07-12 11:45:06.293953','2024-07-12 11:45:06.309168',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7425,'sync',2,'2024-07-12 12:45:00.098273','2024-07-12 12:45:03.995276',3897,NULL,'success'),(7426,'sync-dbms-version',2,'2024-07-12 12:45:00.107325','2024-07-12 12:45:00.116481',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7427,'sync-timezone',2,'2024-07-12 12:45:00.124470','2024-07-12 12:45:00.134427',9,'{\"timezone-id\":\"+08:00\"}','success'),(7428,'sync-tables',2,'2024-07-12 12:45:00.142654','2024-07-12 12:45:00.168492',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7429,'sync-fields',2,'2024-07-12 12:45:00.176335','2024-07-12 12:45:02.970742',2794,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7430,'sync-fks',2,'2024-07-12 12:45:02.977604','2024-07-12 12:45:03.498331',520,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7431,'sync-indexes',2,'2024-07-12 12:45:03.506190','2024-07-12 12:45:03.956378',450,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7432,'sync-metabase-metadata',2,'2024-07-12 12:45:03.963913','2024-07-12 12:45:03.971517',7,'{}','success'),(7433,'sync-table-privileges',2,'2024-07-12 12:45:03.978984','2024-07-12 12:45:03.987945',8,NULL,'success'),(7434,'analyze',2,'2024-07-12 12:45:04.019088','2024-07-12 12:45:06.033604',2014,NULL,'success'),(7435,'fingerprint-fields',2,'2024-07-12 12:45:04.026653','2024-07-12 12:45:05.888985',1862,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7436,'classify-fields',2,'2024-07-12 12:45:05.897209','2024-07-12 12:45:06.006390',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7437,'classify-tables',2,'2024-07-12 12:45:06.014071','2024-07-12 12:45:06.026283',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7438,'field values scanning',2,'2024-07-12 13:00:00.061440','2024-07-12 13:00:04.151523',4090,NULL,'success'),(7439,'delete-expired-advanced-field-values',2,'2024-07-12 13:00:00.090220','2024-07-12 13:00:02.914290',2824,'{\"deleted\":0}','success'),(7440,'update-field-values',2,'2024-07-12 13:00:02.922202','2024-07-12 13:00:04.143303',1221,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(7441,'sync',2,'2024-07-12 13:45:00.098250','2024-07-12 13:45:04.298057',4199,NULL,'success'),(7442,'sync-dbms-version',2,'2024-07-12 13:45:00.106393','2024-07-12 13:45:00.115537',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7443,'sync-timezone',2,'2024-07-12 13:45:00.123833','2024-07-12 13:45:00.133572',9,'{\"timezone-id\":\"+08:00\"}','success'),(7444,'sync-tables',2,'2024-07-12 13:45:00.142061','2024-07-12 13:45:00.168834',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7445,'sync-fields',2,'2024-07-12 13:45:00.177485','2024-07-12 13:45:03.039908',2862,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7446,'sync-fks',2,'2024-07-12 13:45:03.048726','2024-07-12 13:45:03.697815',649,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7447,'sync-indexes',2,'2024-07-12 13:45:03.705917','2024-07-12 13:45:04.260273',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7448,'sync-metabase-metadata',2,'2024-07-12 13:45:04.267459','2024-07-12 13:45:04.275218',7,'{}','success'),(7449,'sync-table-privileges',2,'2024-07-12 13:45:04.282557','2024-07-12 13:45:04.290708',8,NULL,'success'),(7450,'analyze',2,'2024-07-12 13:45:04.322722','2024-07-12 13:45:06.336257',2013,NULL,'success'),(7451,'fingerprint-fields',2,'2024-07-12 13:45:04.331659','2024-07-12 13:45:06.180743',1849,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7452,'classify-fields',2,'2024-07-12 13:45:06.189883','2024-07-12 13:45:06.308168',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7453,'classify-tables',2,'2024-07-12 13:45:06.315619','2024-07-12 13:45:06.328657',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7454,'sync',2,'2024-07-12 14:45:00.103093','2024-07-12 14:45:04.276954',4173,NULL,'success'),(7455,'sync-dbms-version',2,'2024-07-12 14:45:00.112050','2024-07-12 14:45:00.121577',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7456,'sync-timezone',2,'2024-07-12 14:45:00.130884','2024-07-12 14:45:00.142659',11,'{\"timezone-id\":\"+08:00\"}','success'),(7457,'sync-tables',2,'2024-07-12 14:45:00.152243','2024-07-12 14:45:00.180098',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7458,'sync-fields',2,'2024-07-12 14:45:00.188576','2024-07-12 14:45:03.044547',2855,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7459,'sync-fks',2,'2024-07-12 14:45:03.051648','2024-07-12 14:45:03.634687',583,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7460,'sync-indexes',2,'2024-07-12 14:45:03.644272','2024-07-12 14:45:04.237875',593,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7461,'sync-metabase-metadata',2,'2024-07-12 14:45:04.244918','2024-07-12 14:45:04.252830',7,'{}','success'),(7462,'sync-table-privileges',2,'2024-07-12 14:45:04.261059','2024-07-12 14:45:04.268692',7,NULL,'success'),(7463,'analyze',2,'2024-07-12 14:45:04.305325','2024-07-12 14:45:06.440888',2135,NULL,'success');
INSERT INTO `task_history` VALUES (7464,'fingerprint-fields',2,'2024-07-12 14:45:04.313176','2024-07-12 14:45:06.263142',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7465,'classify-fields',2,'2024-07-12 14:45:06.271577','2024-07-12 14:45:06.403849',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7466,'classify-tables',2,'2024-07-12 14:45:06.416601','2024-07-12 14:45:06.430386',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7467,'sync',2,'2024-07-12 15:45:00.089122','2024-07-12 15:45:04.455738',4366,NULL,'success'),(7468,'sync-dbms-version',2,'2024-07-12 15:45:00.096408','2024-07-12 15:45:00.103821',7,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7469,'sync-timezone',2,'2024-07-12 15:45:00.111723','2024-07-12 15:45:00.121416',9,'{\"timezone-id\":\"+08:00\"}','success'),(7470,'sync-tables',2,'2024-07-12 15:45:00.129089','2024-07-12 15:45:00.155345',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7471,'sync-fields',2,'2024-07-12 15:45:00.163603','2024-07-12 15:45:03.174987',3011,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7472,'sync-fks',2,'2024-07-12 15:45:03.183340','2024-07-12 15:45:03.837421',654,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7473,'sync-indexes',2,'2024-07-12 15:45:03.845198','2024-07-12 15:45:04.413460',568,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7474,'sync-metabase-metadata',2,'2024-07-12 15:45:04.420933','2024-07-12 15:45:04.429118',8,'{}','success'),(7475,'sync-table-privileges',2,'2024-07-12 15:45:04.437121','2024-07-12 15:45:04.447105',9,NULL,'success'),(7476,'analyze',2,'2024-07-12 15:45:04.481214','2024-07-12 15:45:06.531916',2050,NULL,'success'),(7477,'fingerprint-fields',2,'2024-07-12 15:45:04.489456','2024-07-12 15:45:06.368469',1879,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7478,'classify-fields',2,'2024-07-12 15:45:06.376226','2024-07-12 15:45:06.500039',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7479,'classify-tables',2,'2024-07-12 15:45:06.508722','2024-07-12 15:45:06.523961',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7480,'task-history-cleanup',NULL,'2024-07-12 16:00:00.027476','2024-07-12 16:00:00.083910',56,NULL,'success'),(7481,'task-history-cleanup',NULL,'2024-07-12 16:00:00.102068','2024-07-12 16:00:00.123796',21,NULL,'success'),(7482,'sync',2,'2024-07-12 16:45:00.104647','2024-07-12 16:45:04.809927',4705,NULL,'success'),(7483,'sync-dbms-version',2,'2024-07-12 16:45:00.114704','2024-07-12 16:45:00.125698',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7484,'sync-timezone',2,'2024-07-12 16:45:00.134799','2024-07-12 16:45:00.147005',12,'{\"timezone-id\":\"+08:00\"}','success'),(7485,'sync-tables',2,'2024-07-12 16:45:00.156443','2024-07-12 16:45:00.183139',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7486,'sync-fields',2,'2024-07-12 16:45:00.191571','2024-07-12 16:45:03.472611',3281,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7487,'sync-fks',2,'2024-07-12 16:45:03.480995','2024-07-12 16:45:04.199086',718,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7488,'sync-indexes',2,'2024-07-12 16:45:04.208263','2024-07-12 16:45:04.763265',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7489,'sync-metabase-metadata',2,'2024-07-12 16:45:04.771373','2024-07-12 16:45:04.781267',9,'{}','success'),(7490,'sync-table-privileges',2,'2024-07-12 16:45:04.791094','2024-07-12 16:45:04.800647',9,NULL,'success'),(7491,'analyze',2,'2024-07-12 16:45:04.838945','2024-07-12 16:45:07.004322',2165,NULL,'success'),(7492,'fingerprint-fields',2,'2024-07-12 16:45:04.847569','2024-07-12 16:45:06.858659',2011,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7493,'classify-fields',2,'2024-07-12 16:45:06.866766','2024-07-12 16:45:06.975288',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7494,'classify-tables',2,'2024-07-12 16:45:06.982908','2024-07-12 16:45:06.996001',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7495,'sync',2,'2024-07-12 17:45:00.108694','2024-07-12 17:45:04.692439',4583,NULL,'success'),(7496,'sync-dbms-version',2,'2024-07-12 17:45:00.117169','2024-07-12 17:45:00.125976',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7497,'sync-timezone',2,'2024-07-12 17:45:00.134691','2024-07-12 17:45:00.144221',9,'{\"timezone-id\":\"+08:00\"}','success'),(7498,'sync-tables',2,'2024-07-12 17:45:00.152244','2024-07-12 17:45:00.180745',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7499,'sync-fields',2,'2024-07-12 17:45:00.189647','2024-07-12 17:45:03.370347',3180,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7500,'sync-fks',2,'2024-07-12 17:45:03.378970','2024-07-12 17:45:04.008346',629,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7501,'sync-indexes',2,'2024-07-12 17:45:04.018124','2024-07-12 17:45:04.647541',629,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7502,'sync-metabase-metadata',2,'2024-07-12 17:45:04.656282','2024-07-12 17:45:04.666342',10,'{}','success'),(7503,'sync-table-privileges',2,'2024-07-12 17:45:04.675041','2024-07-12 17:45:04.683717',8,NULL,'success'),(7504,'analyze',2,'2024-07-12 17:45:04.723743','2024-07-12 17:45:06.976389',2252,NULL,'success'),(7505,'fingerprint-fields',2,'2024-07-12 17:45:04.732561','2024-07-12 17:45:06.812331',2079,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7506,'classify-fields',2,'2024-07-12 17:45:06.821366','2024-07-12 17:45:06.946108',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7507,'classify-tables',2,'2024-07-12 17:45:06.953977','2024-07-12 17:45:06.967806',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7508,'sync',2,'2024-07-12 18:45:00.097944','2024-07-12 18:45:04.567032',4469,NULL,'success'),(7509,'sync-dbms-version',2,'2024-07-12 18:45:00.106513','2024-07-12 18:45:00.116092',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7510,'sync-timezone',2,'2024-07-12 18:45:00.124798','2024-07-12 18:45:00.134527',9,'{\"timezone-id\":\"+08:00\"}','success'),(7511,'sync-tables',2,'2024-07-12 18:45:00.143274','2024-07-12 18:45:00.173398',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7512,'sync-fields',2,'2024-07-12 18:45:00.182259','2024-07-12 18:45:03.275771',3093,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7513,'sync-fks',2,'2024-07-12 18:45:03.284095','2024-07-12 18:45:03.915335',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7514,'sync-indexes',2,'2024-07-12 18:45:03.924879','2024-07-12 18:45:04.524859',599,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7515,'sync-metabase-metadata',2,'2024-07-12 18:45:04.533021','2024-07-12 18:45:04.541137',8,'{}','success'),(7516,'sync-table-privileges',2,'2024-07-12 18:45:04.549199','2024-07-12 18:45:04.557569',8,NULL,'success'),(7517,'analyze',2,'2024-07-12 18:45:04.599480','2024-07-12 18:45:06.680944',2081,NULL,'success'),(7518,'fingerprint-fields',2,'2024-07-12 18:45:04.608147','2024-07-12 18:45:06.540262',1932,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7519,'classify-fields',2,'2024-07-12 18:45:06.548726','2024-07-12 18:45:06.652269',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7520,'classify-tables',2,'2024-07-12 18:45:06.660073','2024-07-12 18:45:06.672941',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7521,'sync',2,'2024-07-12 19:45:00.105048','2024-07-12 19:45:04.788871',4683,NULL,'success'),(7522,'sync-dbms-version',2,'2024-07-12 19:45:00.113494','2024-07-12 19:45:00.122879',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7523,'sync-timezone',2,'2024-07-12 19:45:00.131965','2024-07-12 19:45:00.143779',11,'{\"timezone-id\":\"+08:00\"}','success'),(7524,'sync-tables',2,'2024-07-12 19:45:00.153044','2024-07-12 19:45:00.181596',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7525,'sync-fields',2,'2024-07-12 19:45:00.190728','2024-07-12 19:45:03.472200',3281,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7526,'sync-fks',2,'2024-07-12 19:45:03.481340','2024-07-12 19:45:04.160916',679,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7527,'sync-indexes',2,'2024-07-12 19:45:04.170454','2024-07-12 19:45:04.743078',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7528,'sync-metabase-metadata',2,'2024-07-12 19:45:04.752279','2024-07-12 19:45:04.761820',9,'{}','success'),(7529,'sync-table-privileges',2,'2024-07-12 19:45:04.771065','2024-07-12 19:45:04.779596',8,NULL,'success'),(7530,'analyze',2,'2024-07-12 19:45:04.822221','2024-07-12 19:45:07.107795',2285,NULL,'success'),(7531,'fingerprint-fields',2,'2024-07-12 19:45:04.831952','2024-07-12 19:45:06.922492',2090,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7532,'classify-fields',2,'2024-07-12 19:45:06.930931','2024-07-12 19:45:07.062069',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7533,'classify-tables',2,'2024-07-12 19:45:07.070400','2024-07-12 19:45:07.087101',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7534,'sync',2,'2024-07-12 20:45:00.095207','2024-07-12 20:45:04.375563',4280,NULL,'success'),(7535,'sync-dbms-version',2,'2024-07-12 20:45:00.103805','2024-07-12 20:45:00.112689',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7536,'sync-timezone',2,'2024-07-12 20:45:00.123488','2024-07-12 20:45:00.134035',10,'{\"timezone-id\":\"+08:00\"}','success'),(7537,'sync-tables',2,'2024-07-12 20:45:00.142320','2024-07-12 20:45:00.174000',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7538,'sync-fields',2,'2024-07-12 20:45:00.182767','2024-07-12 20:45:03.176213',2993,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7539,'sync-fks',2,'2024-07-12 20:45:03.184198','2024-07-12 20:45:03.766726',582,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7540,'sync-indexes',2,'2024-07-12 20:45:03.776668','2024-07-12 20:45:04.329132',552,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7541,'sync-metabase-metadata',2,'2024-07-12 20:45:04.337308','2024-07-12 20:45:04.345732',8,'{}','success'),(7542,'sync-table-privileges',2,'2024-07-12 20:45:04.359196','2024-07-12 20:45:04.367477',8,NULL,'success'),(7543,'analyze',2,'2024-07-12 20:45:04.399927','2024-07-12 20:45:06.516866',2116,NULL,'success'),(7544,'fingerprint-fields',2,'2024-07-12 20:45:04.408278','2024-07-12 20:45:06.361628',1953,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7545,'classify-fields',2,'2024-07-12 20:45:06.370231','2024-07-12 20:45:06.485927',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7546,'classify-tables',2,'2024-07-12 20:45:06.493520','2024-07-12 20:45:06.508141',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7547,'sync',2,'2024-07-12 21:45:00.322023','2024-07-12 21:45:05.042538',4720,NULL,'success'),(7548,'sync-dbms-version',2,'2024-07-12 21:45:00.330571','2024-07-12 21:45:00.340069',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7549,'sync-timezone',2,'2024-07-12 21:45:00.352106','2024-07-12 21:45:00.362268',10,'{\"timezone-id\":\"+08:00\"}','success'),(7550,'sync-tables',2,'2024-07-12 21:45:00.370746','2024-07-12 21:45:00.399176',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7551,'sync-fields',2,'2024-07-12 21:45:00.410156','2024-07-12 21:45:03.820099',3409,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7552,'sync-fks',2,'2024-07-12 21:45:03.828326','2024-07-12 21:45:04.469701',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7553,'sync-indexes',2,'2024-07-12 21:45:04.478004','2024-07-12 21:45:04.997381',519,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7554,'sync-metabase-metadata',2,'2024-07-12 21:45:05.004958','2024-07-12 21:45:05.016094',11,'{}','success'),(7555,'sync-table-privileges',2,'2024-07-12 21:45:05.024789','2024-07-12 21:45:05.034000',9,NULL,'success'),(7556,'analyze',2,'2024-07-12 21:45:05.066113','2024-07-12 21:45:07.358327',2292,NULL,'success'),(7557,'fingerprint-fields',2,'2024-07-12 21:45:05.073683','2024-07-12 21:45:07.187962',2114,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7558,'classify-fields',2,'2024-07-12 21:45:07.195893','2024-07-12 21:45:07.324844',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7559,'classify-tables',2,'2024-07-12 21:45:07.333189','2024-07-12 21:45:07.348783',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7560,'sync',2,'2024-07-12 22:45:00.107435','2024-07-12 22:45:05.348897',5241,NULL,'success'),(7561,'sync-dbms-version',2,'2024-07-12 22:45:00.116132','2024-07-12 22:45:00.125799',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7562,'sync-timezone',2,'2024-07-12 22:45:00.134541','2024-07-12 22:45:00.143676',9,'{\"timezone-id\":\"+08:00\"}','success'),(7563,'sync-tables',2,'2024-07-12 22:45:00.152432','2024-07-12 22:45:00.182055',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7564,'sync-fields',2,'2024-07-12 22:45:00.192071','2024-07-12 22:45:03.765946',3573,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7565,'sync-fks',2,'2024-07-12 22:45:03.774423','2024-07-12 22:45:04.521101',746,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7566,'sync-indexes',2,'2024-07-12 22:45:04.530462','2024-07-12 22:45:05.303136',772,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7567,'sync-metabase-metadata',2,'2024-07-12 22:45:05.311567','2024-07-12 22:45:05.321203',9,'{}','success'),(7568,'sync-table-privileges',2,'2024-07-12 22:45:05.330465','2024-07-12 22:45:05.340274',9,NULL,'success'),(7569,'analyze',2,'2024-07-12 22:45:05.381103','2024-07-12 22:45:07.614620',2233,NULL,'success'),(7570,'fingerprint-fields',2,'2024-07-12 22:45:05.390844','2024-07-12 22:45:07.455963',2065,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7571,'classify-fields',2,'2024-07-12 22:45:07.464355','2024-07-12 22:45:07.584210',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7572,'classify-tables',2,'2024-07-12 22:45:07.591804','2024-07-12 22:45:07.605931',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7573,'sync',2,'2024-07-12 23:45:00.100124','2024-07-12 23:45:04.770719',4670,NULL,'success'),(7574,'sync-dbms-version',2,'2024-07-12 23:45:00.109269','2024-07-12 23:45:00.119718',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7575,'sync-timezone',2,'2024-07-12 23:45:00.128648','2024-07-12 23:45:00.139775',11,'{\"timezone-id\":\"+08:00\"}','success'),(7576,'sync-tables',2,'2024-07-12 23:45:00.148395','2024-07-12 23:45:00.180039',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7577,'sync-fields',2,'2024-07-12 23:45:00.189267','2024-07-12 23:45:03.370977',3181,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7578,'sync-fks',2,'2024-07-12 23:45:03.380027','2024-07-12 23:45:04.106297',726,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7579,'sync-indexes',2,'2024-07-12 23:45:04.115453','2024-07-12 23:45:04.724249',608,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7580,'sync-metabase-metadata',2,'2024-07-12 23:45:04.733696','2024-07-12 23:45:04.742533',8,'{}','success'),(7581,'sync-table-privileges',2,'2024-07-12 23:45:04.752102','2024-07-12 23:45:04.761715',9,NULL,'success'),(7582,'analyze',2,'2024-07-12 23:45:04.796449','2024-07-12 23:45:07.099966',2303,NULL,'success'),(7583,'fingerprint-fields',2,'2024-07-12 23:45:04.804860','2024-07-12 23:45:06.928607',2123,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7584,'classify-fields',2,'2024-07-12 23:45:06.937503','2024-07-12 23:45:07.066793',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7585,'classify-tables',2,'2024-07-12 23:45:07.075169','2024-07-12 23:45:07.090688',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7586,'sync',2,'2024-07-13 00:45:00.102245','2024-07-13 00:45:04.799463',4697,NULL,'success'),(7587,'sync-dbms-version',2,'2024-07-13 00:45:00.111267','2024-07-13 00:45:00.120160',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7588,'sync-timezone',2,'2024-07-13 00:45:00.128748','2024-07-13 00:45:00.139288',10,'{\"timezone-id\":\"+08:00\"}','success'),(7589,'sync-tables',2,'2024-07-13 00:45:00.148029','2024-07-13 00:45:00.178068',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7590,'sync-fields',2,'2024-07-13 00:45:00.186779','2024-07-13 00:45:03.405663',3218,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7591,'sync-fks',2,'2024-07-13 00:45:03.414884','2024-07-13 00:45:04.115606',700,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7592,'sync-indexes',2,'2024-07-13 00:45:04.125311','2024-07-13 00:45:04.752935',627,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7593,'sync-metabase-metadata',2,'2024-07-13 00:45:04.762082','2024-07-13 00:45:04.771221',9,'{}','success'),(7594,'sync-table-privileges',2,'2024-07-13 00:45:04.780601','2024-07-13 00:45:04.790979',10,NULL,'success'),(7595,'analyze',2,'2024-07-13 00:45:04.825028','2024-07-13 00:45:07.024682',2199,NULL,'success'),(7596,'fingerprint-fields',2,'2024-07-13 00:45:04.834239','2024-07-13 00:45:06.861730',2027,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7597,'classify-fields',2,'2024-07-13 00:45:06.870423','2024-07-13 00:45:06.989653',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7598,'classify-tables',2,'2024-07-13 00:45:06.998311','2024-07-13 00:45:07.012733',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7599,'sync',2,'2024-07-13 01:45:00.117608','2024-07-13 01:45:05.029530',4911,NULL,'success'),(7600,'sync-dbms-version',2,'2024-07-13 01:45:00.126445','2024-07-13 01:45:00.136844',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7601,'sync-timezone',2,'2024-07-13 01:45:00.146545','2024-07-13 01:45:00.157571',11,'{\"timezone-id\":\"+08:00\"}','success'),(7602,'sync-tables',2,'2024-07-13 01:45:00.167195','2024-07-13 01:45:00.199201',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7603,'sync-fields',2,'2024-07-13 01:45:00.208800','2024-07-13 01:45:03.600647',3391,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7604,'sync-fks',2,'2024-07-13 01:45:03.609302','2024-07-13 01:45:04.348085',738,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7605,'sync-indexes',2,'2024-07-13 01:45:04.357465','2024-07-13 01:45:04.985605',628,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7606,'sync-metabase-metadata',2,'2024-07-13 01:45:04.993660','2024-07-13 01:45:05.002347',8,'{}','success'),(7607,'sync-table-privileges',2,'2024-07-13 01:45:05.011469','2024-07-13 01:45:05.020175',8,NULL,'success'),(7608,'analyze',2,'2024-07-13 01:45:05.067458','2024-07-13 01:45:07.574127',2506,NULL,'success'),(7609,'fingerprint-fields',2,'2024-07-13 01:45:05.080405','2024-07-13 01:45:07.304626',2224,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7610,'classify-fields',2,'2024-07-13 01:45:07.315061','2024-07-13 01:45:07.536413',221,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7611,'classify-tables',2,'2024-07-13 01:45:07.546355','2024-07-13 01:45:07.563483',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7612,'sync',2,'2024-07-13 02:45:00.109721','2024-07-13 02:45:04.492426',4382,NULL,'success'),(7613,'sync-dbms-version',2,'2024-07-13 02:45:00.118468','2024-07-13 02:45:00.128036',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7614,'sync-timezone',2,'2024-07-13 02:45:00.136167','2024-07-13 02:45:00.146127',9,'{\"timezone-id\":\"+08:00\"}','success'),(7615,'sync-tables',2,'2024-07-13 02:45:00.156497','2024-07-13 02:45:00.183340',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7616,'sync-fields',2,'2024-07-13 02:45:00.191831','2024-07-13 02:45:03.220441',3028,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7617,'sync-fks',2,'2024-07-13 02:45:03.228459','2024-07-13 02:45:03.864064',635,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7618,'sync-indexes',2,'2024-07-13 02:45:03.872618','2024-07-13 02:45:04.448203',575,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7619,'sync-metabase-metadata',2,'2024-07-13 02:45:04.456102','2024-07-13 02:45:04.465514',9,'{}','success'),(7620,'sync-table-privileges',2,'2024-07-13 02:45:04.474064','2024-07-13 02:45:04.483690',9,NULL,'success'),(7621,'analyze',2,'2024-07-13 02:45:04.521838','2024-07-13 02:45:06.689332',2167,NULL,'success'),(7622,'fingerprint-fields',2,'2024-07-13 02:45:04.530830','2024-07-13 02:45:06.532055',2001,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7623,'classify-fields',2,'2024-07-13 02:45:06.542372','2024-07-13 02:45:06.659429',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7624,'classify-tables',2,'2024-07-13 02:45:06.667465','2024-07-13 02:45:06.681474',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7625,'sync',2,'2024-07-13 03:45:00.111355','2024-07-13 03:45:05.230419',5119,NULL,'success'),(7626,'sync-dbms-version',2,'2024-07-13 03:45:00.119422','2024-07-13 03:45:00.128647',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7627,'sync-timezone',2,'2024-07-13 03:45:00.137283','2024-07-13 03:45:00.147320',10,'{\"timezone-id\":\"+08:00\"}','success'),(7628,'sync-tables',2,'2024-07-13 03:45:00.155918','2024-07-13 03:45:00.196554',40,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7629,'sync-fields',2,'2024-07-13 03:45:00.206564','2024-07-13 03:45:03.153245',2946,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7630,'sync-fks',2,'2024-07-13 03:45:03.162645','2024-07-13 03:45:03.905536',742,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7631,'sync-indexes',2,'2024-07-13 03:45:03.914871','2024-07-13 03:45:05.184501',1269,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7632,'sync-metabase-metadata',2,'2024-07-13 03:45:05.192552','2024-07-13 03:45:05.202666',10,'{}','success'),(7633,'sync-table-privileges',2,'2024-07-13 03:45:05.212164','2024-07-13 03:45:05.221426',9,NULL,'success'),(7634,'analyze',2,'2024-07-13 03:45:05.255124','2024-07-13 03:45:07.461816',2206,NULL,'success'),(7635,'fingerprint-fields',2,'2024-07-13 03:45:05.263500','2024-07-13 03:45:07.220801',1957,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7636,'classify-fields',2,'2024-07-13 03:45:07.229644','2024-07-13 03:45:07.428347',198,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7637,'classify-tables',2,'2024-07-13 03:45:07.436518','2024-07-13 03:45:07.451930',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7638,'task-history-cleanup',NULL,'2024-07-13 04:00:00.061387','2024-07-13 04:00:00.094283',32,NULL,'success'),(7639,'sync',2,'2024-07-13 04:45:00.104818','2024-07-13 04:45:04.284255',4179,NULL,'success'),(7640,'sync-dbms-version',2,'2024-07-13 04:45:00.113066','2024-07-13 04:45:00.123503',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7641,'sync-timezone',2,'2024-07-13 04:45:00.133015','2024-07-13 04:45:00.144731',11,'{\"timezone-id\":\"+08:00\"}','success'),(7642,'sync-tables',2,'2024-07-13 04:45:00.157508','2024-07-13 04:45:00.196946',39,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7643,'sync-fields',2,'2024-07-13 04:45:00.210732','2024-07-13 04:45:03.154734',2944,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7644,'sync-fks',2,'2024-07-13 04:45:03.162137','2024-07-13 04:45:03.746265',584,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7645,'sync-indexes',2,'2024-07-13 04:45:03.755174','2024-07-13 04:45:04.241081',485,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7646,'sync-metabase-metadata',2,'2024-07-13 04:45:04.250157','2024-07-13 04:45:04.258567',8,'{}','success'),(7647,'sync-table-privileges',2,'2024-07-13 04:45:04.266795','2024-07-13 04:45:04.275873',9,NULL,'success'),(7648,'analyze',2,'2024-07-13 04:45:04.308383','2024-07-13 04:45:06.207565',1899,NULL,'success'),(7649,'fingerprint-fields',2,'2024-07-13 04:45:04.316650','2024-07-13 04:45:06.062549',1745,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7650,'classify-fields',2,'2024-07-13 04:45:06.070655','2024-07-13 04:45:06.179618',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7651,'classify-tables',2,'2024-07-13 04:45:06.186806','2024-07-13 04:45:06.199557',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7652,'sync',2,'2024-07-13 05:45:00.115904','2024-07-13 05:45:04.645341',4529,NULL,'success'),(7653,'sync-dbms-version',2,'2024-07-13 05:45:00.124635','2024-07-13 05:45:00.134136',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7654,'sync-timezone',2,'2024-07-13 05:45:00.143755','2024-07-13 05:45:00.156193',12,'{\"timezone-id\":\"+08:00\"}','success'),(7655,'sync-tables',2,'2024-07-13 05:45:00.166143','2024-07-13 05:45:00.197546',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7656,'sync-fields',2,'2024-07-13 05:45:00.207269','2024-07-13 05:45:03.380349',3173,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7657,'sync-fks',2,'2024-07-13 05:45:03.387861','2024-07-13 05:45:04.005620',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7658,'sync-indexes',2,'2024-07-13 05:45:04.014905','2024-07-13 05:45:04.600718',585,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7659,'sync-metabase-metadata',2,'2024-07-13 05:45:04.608848','2024-07-13 05:45:04.618133',9,'{}','success'),(7660,'sync-table-privileges',2,'2024-07-13 05:45:04.626961','2024-07-13 05:45:04.636031',9,NULL,'success'),(7661,'analyze',2,'2024-07-13 05:45:04.673326','2024-07-13 05:45:06.828187',2154,NULL,'success'),(7662,'fingerprint-fields',2,'2024-07-13 05:45:04.682768','2024-07-13 05:45:06.653347',1970,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7663,'classify-fields',2,'2024-07-13 05:45:06.662449','2024-07-13 05:45:06.794678',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7664,'classify-tables',2,'2024-07-13 05:45:06.803837','2024-07-13 05:45:06.818884',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7665,'sync',2,'2024-07-13 06:45:00.110209','2024-07-13 06:45:04.390368',4280,NULL,'success'),(7666,'sync-dbms-version',2,'2024-07-13 06:45:00.118843','2024-07-13 06:45:00.129559',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7667,'sync-timezone',2,'2024-07-13 06:45:00.138427','2024-07-13 06:45:00.149099',10,'{\"timezone-id\":\"+08:00\"}','success'),(7668,'sync-tables',2,'2024-07-13 06:45:00.158196','2024-07-13 06:45:00.186570',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7669,'sync-fields',2,'2024-07-13 06:45:00.195310','2024-07-13 06:45:03.243898',3048,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7670,'sync-fks',2,'2024-07-13 06:45:03.251707','2024-07-13 06:45:03.843021',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7671,'sync-indexes',2,'2024-07-13 06:45:03.851547','2024-07-13 06:45:04.350070',498,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7672,'sync-metabase-metadata',2,'2024-07-13 06:45:04.357631','2024-07-13 06:45:04.365482',7,'{}','success'),(7673,'sync-table-privileges',2,'2024-07-13 06:45:04.373209','2024-07-13 06:45:04.381151',7,NULL,'success'),(7674,'analyze',2,'2024-07-13 06:45:04.414968','2024-07-13 06:45:06.411963',1996,NULL,'success'),(7675,'fingerprint-fields',2,'2024-07-13 06:45:04.424029','2024-07-13 06:45:06.270920',1846,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7676,'classify-fields',2,'2024-07-13 06:45:06.280354','2024-07-13 06:45:06.380308',99,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7677,'classify-tables',2,'2024-07-13 06:45:06.389290','2024-07-13 06:45:06.404028',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7678,'sync',2,'2024-07-13 07:45:00.107937','2024-07-13 07:45:04.846538',4738,NULL,'success'),(7679,'sync-dbms-version',2,'2024-07-13 07:45:00.116232','2024-07-13 07:45:00.125689',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7680,'sync-timezone',2,'2024-07-13 07:45:00.134184','2024-07-13 07:45:00.144541',10,'{\"timezone-id\":\"+08:00\"}','success'),(7681,'sync-tables',2,'2024-07-13 07:45:00.153338','2024-07-13 07:45:00.179537',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7682,'sync-fields',2,'2024-07-13 07:45:00.188327','2024-07-13 07:45:03.517647',3329,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7683,'sync-fks',2,'2024-07-13 07:45:03.526351','2024-07-13 07:45:04.250400',724,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7684,'sync-indexes',2,'2024-07-13 07:45:04.260134','2024-07-13 07:45:04.805224',545,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7685,'sync-metabase-metadata',2,'2024-07-13 07:45:04.812848','2024-07-13 07:45:04.821378',8,'{}','success'),(7686,'sync-table-privileges',2,'2024-07-13 07:45:04.829875','2024-07-13 07:45:04.838183',8,NULL,'success'),(7687,'analyze',2,'2024-07-13 07:45:04.870925','2024-07-13 07:45:06.920701',2049,NULL,'success'),(7688,'fingerprint-fields',2,'2024-07-13 07:45:04.880154','2024-07-13 07:45:06.760104',1879,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7689,'classify-fields',2,'2024-07-13 07:45:06.768821','2024-07-13 07:45:06.890795',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7690,'classify-tables',2,'2024-07-13 07:45:06.898212','2024-07-13 07:45:06.911864',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7691,'sync',2,'2024-07-13 08:45:00.096181','2024-07-13 08:45:04.055958',3959,NULL,'success'),(7692,'sync-dbms-version',2,'2024-07-13 08:45:00.103449','2024-07-13 08:45:00.111973',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7693,'sync-timezone',2,'2024-07-13 08:45:00.120760','2024-07-13 08:45:00.131992',11,'{\"timezone-id\":\"+08:00\"}','success'),(7694,'sync-tables',2,'2024-07-13 08:45:00.139909','2024-07-13 08:45:00.165281',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7695,'sync-fields',2,'2024-07-13 08:45:00.173305','2024-07-13 08:45:02.963410',2790,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7696,'sync-fks',2,'2024-07-13 08:45:02.971105','2024-07-13 08:45:03.531572',560,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7697,'sync-indexes',2,'2024-07-13 08:45:03.539875','2024-07-13 08:45:04.017268',477,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7698,'sync-metabase-metadata',2,'2024-07-13 08:45:04.024442','2024-07-13 08:45:04.032470',8,'{}','success'),(7699,'sync-table-privileges',2,'2024-07-13 08:45:04.040048','2024-07-13 08:45:04.047967',7,NULL,'success'),(7700,'analyze',2,'2024-07-13 08:45:04.079816','2024-07-13 08:45:06.103211',2023,NULL,'success'),(7701,'fingerprint-fields',2,'2024-07-13 08:45:04.088009','2024-07-13 08:45:05.947326',1859,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7702,'classify-fields',2,'2024-07-13 08:45:05.955694','2024-07-13 08:45:06.072525',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7703,'classify-tables',2,'2024-07-13 08:45:06.080171','2024-07-13 08:45:06.094639',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7704,'sync',2,'2024-07-13 09:45:00.095281','2024-07-13 09:45:04.177082',4081,NULL,'success'),(7705,'sync-dbms-version',2,'2024-07-13 09:45:00.102857','2024-07-13 09:45:00.111542',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7706,'sync-timezone',2,'2024-07-13 09:45:00.120837','2024-07-13 09:45:00.131664',10,'{\"timezone-id\":\"+08:00\"}','success'),(7707,'sync-tables',2,'2024-07-13 09:45:00.141881','2024-07-13 09:45:00.167049',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7708,'sync-fields',2,'2024-07-13 09:45:00.175082','2024-07-13 09:45:03.012169',2837,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7709,'sync-fks',2,'2024-07-13 09:45:03.019635','2024-07-13 09:45:03.616850',597,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7710,'sync-indexes',2,'2024-07-13 09:45:03.624954','2024-07-13 09:45:04.134930',509,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7711,'sync-metabase-metadata',2,'2024-07-13 09:45:04.142377','2024-07-13 09:45:04.150856',8,'{}','success'),(7712,'sync-table-privileges',2,'2024-07-13 09:45:04.160799','2024-07-13 09:45:04.168838',8,NULL,'success'),(7713,'analyze',2,'2024-07-13 09:45:04.201864','2024-07-13 09:45:06.271486',2069,NULL,'success'),(7714,'fingerprint-fields',2,'2024-07-13 09:45:04.209854','2024-07-13 09:45:06.117508',1907,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7715,'classify-fields',2,'2024-07-13 09:45:06.125290','2024-07-13 09:45:06.242057',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7716,'classify-tables',2,'2024-07-13 09:45:06.249860','2024-07-13 09:45:06.262888',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7717,'sync',2,'2024-07-13 10:45:00.098528','2024-07-13 10:45:04.167090',4068,NULL,'success'),(7718,'sync-dbms-version',2,'2024-07-13 10:45:00.106447','2024-07-13 10:45:00.114022',7,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7719,'sync-timezone',2,'2024-07-13 10:45:00.121656','2024-07-13 10:45:00.131280',9,'{\"timezone-id\":\"+08:00\"}','success'),(7720,'sync-tables',2,'2024-07-13 10:45:00.138852','2024-07-13 10:45:00.163256',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7721,'sync-fields',2,'2024-07-13 10:45:00.171411','2024-07-13 10:45:03.025679',2854,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7722,'sync-fks',2,'2024-07-13 10:45:03.034139','2024-07-13 10:45:03.616623',582,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7723,'sync-indexes',2,'2024-07-13 10:45:03.624952','2024-07-13 10:45:04.126789',501,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7724,'sync-metabase-metadata',2,'2024-07-13 10:45:04.134765','2024-07-13 10:45:04.143265',8,'{}','success'),(7725,'sync-table-privileges',2,'2024-07-13 10:45:04.151058','2024-07-13 10:45:04.158867',7,NULL,'success'),(7726,'analyze',2,'2024-07-13 10:45:04.194721','2024-07-13 10:45:06.246609',2051,NULL,'success'),(7727,'fingerprint-fields',2,'2024-07-13 10:45:04.203356','2024-07-13 10:45:06.095940',1892,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7728,'classify-fields',2,'2024-07-13 10:45:06.105053','2024-07-13 10:45:06.216871',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7729,'classify-tables',2,'2024-07-13 10:45:06.224494','2024-07-13 10:45:06.238185',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7730,'sync',2,'2024-07-13 11:45:00.092280','2024-07-13 11:45:04.150941',4058,NULL,'success'),(7731,'sync-dbms-version',2,'2024-07-13 11:45:00.100848','2024-07-13 11:45:00.110295',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7732,'sync-timezone',2,'2024-07-13 11:45:00.118603','2024-07-13 11:45:00.128265',9,'{\"timezone-id\":\"+08:00\"}','success'),(7733,'sync-tables',2,'2024-07-13 11:45:00.136814','2024-07-13 11:45:00.161837',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7734,'sync-fields',2,'2024-07-13 11:45:00.170369','2024-07-13 11:45:03.045339',2874,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7735,'sync-fks',2,'2024-07-13 11:45:03.053854','2024-07-13 11:45:03.624847',570,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7736,'sync-indexes',2,'2024-07-13 11:45:03.633356','2024-07-13 11:45:04.110728',477,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7737,'sync-metabase-metadata',2,'2024-07-13 11:45:04.118212','2024-07-13 11:45:04.125932',7,'{}','success'),(7738,'sync-table-privileges',2,'2024-07-13 11:45:04.134553','2024-07-13 11:45:04.143166',8,NULL,'success'),(7739,'analyze',2,'2024-07-13 11:45:04.174264','2024-07-13 11:45:06.028295',1854,NULL,'success'),(7740,'fingerprint-fields',2,'2024-07-13 11:45:04.181602','2024-07-13 11:45:05.886762',1705,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7741,'classify-fields',2,'2024-07-13 11:45:05.894782','2024-07-13 11:45:06.000174',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7742,'classify-tables',2,'2024-07-13 11:45:06.007546','2024-07-13 11:45:06.020259',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7743,'sync',2,'2024-07-13 12:45:00.114007','2024-07-13 12:45:04.424963',4310,NULL,'success'),(7744,'sync-dbms-version',2,'2024-07-13 12:45:00.122797','2024-07-13 12:45:00.132545',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7745,'sync-timezone',2,'2024-07-13 12:45:00.140862','2024-07-13 12:45:00.151632',10,'{\"timezone-id\":\"+08:00\"}','success'),(7746,'sync-tables',2,'2024-07-13 12:45:00.160238','2024-07-13 12:45:00.194815',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7747,'sync-fields',2,'2024-07-13 12:45:00.204808','2024-07-13 12:45:03.216186',3011,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7748,'sync-fks',2,'2024-07-13 12:45:03.223981','2024-07-13 12:45:03.851689',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7749,'sync-indexes',2,'2024-07-13 12:45:03.860985','2024-07-13 12:45:04.383118',522,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7750,'sync-metabase-metadata',2,'2024-07-13 12:45:04.390835','2024-07-13 12:45:04.398813',7,'{}','success'),(7751,'sync-table-privileges',2,'2024-07-13 12:45:04.406839','2024-07-13 12:45:04.416114',9,NULL,'success'),(7752,'analyze',2,'2024-07-13 12:45:04.449142','2024-07-13 12:45:06.292980',1843,NULL,'success'),(7753,'fingerprint-fields',2,'2024-07-13 12:45:04.456995','2024-07-13 12:45:06.155105',1698,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7754,'classify-fields',2,'2024-07-13 12:45:06.163136','2024-07-13 12:45:06.264118',100,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7755,'classify-tables',2,'2024-07-13 12:45:06.271304','2024-07-13 12:45:06.284279',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7756,'field values scanning',2,'2024-07-13 13:00:00.067891','2024-07-13 13:00:04.335345',4267,NULL,'success'),(7757,'delete-expired-advanced-field-values',2,'2024-07-13 13:00:00.083869','2024-07-13 13:00:03.031297',2947,'{\"deleted\":0}','success'),(7758,'update-field-values',2,'2024-07-13 13:00:03.039128','2024-07-13 13:00:04.326127',1287,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(7759,'sync',2,'2024-07-13 13:45:00.094158','2024-07-13 13:45:04.251827',4157,NULL,'success'),(7760,'sync-dbms-version',2,'2024-07-13 13:45:00.102116','2024-07-13 13:45:00.113197',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7761,'sync-timezone',2,'2024-07-13 13:45:00.121520','2024-07-13 13:45:00.130773',9,'{\"timezone-id\":\"+08:00\"}','success'),(7762,'sync-tables',2,'2024-07-13 13:45:00.138494','2024-07-13 13:45:00.163744',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7763,'sync-fields',2,'2024-07-13 13:45:00.172849','2024-07-13 13:45:03.066225',2893,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7764,'sync-fks',2,'2024-07-13 13:45:03.074083','2024-07-13 13:45:03.691908',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7765,'sync-indexes',2,'2024-07-13 13:45:03.700267','2024-07-13 13:45:04.210984',510,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7766,'sync-metabase-metadata',2,'2024-07-13 13:45:04.218622','2024-07-13 13:45:04.227360',8,'{}','success'),(7767,'sync-table-privileges',2,'2024-07-13 13:45:04.235344','2024-07-13 13:45:04.243438',8,NULL,'success'),(7768,'analyze',2,'2024-07-13 13:45:04.276755','2024-07-13 13:45:06.216764',1940,NULL,'success'),(7769,'fingerprint-fields',2,'2024-07-13 13:45:04.285867','2024-07-13 13:45:06.066818',1780,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7770,'classify-fields',2,'2024-07-13 13:45:06.074483','2024-07-13 13:45:06.187449',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7771,'classify-tables',2,'2024-07-13 13:45:06.195247','2024-07-13 13:45:06.208956',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7772,'sync',2,'2024-07-13 14:45:00.087986','2024-07-13 14:45:03.819612',3731,NULL,'success'),(7773,'sync-dbms-version',2,'2024-07-13 14:45:00.095500','2024-07-13 14:45:00.103553',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7774,'sync-timezone',2,'2024-07-13 14:45:00.111775','2024-07-13 14:45:00.121117',9,'{\"timezone-id\":\"+08:00\"}','success'),(7775,'sync-tables',2,'2024-07-13 14:45:00.128599','2024-07-13 14:45:00.152505',23,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7776,'sync-fields',2,'2024-07-13 14:45:00.160041','2024-07-13 14:45:02.771657',2611,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7777,'sync-fks',2,'2024-07-13 14:45:02.778704','2024-07-13 14:45:03.307534',528,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7778,'sync-indexes',2,'2024-07-13 14:45:03.315869','2024-07-13 14:45:03.777907',462,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7779,'sync-metabase-metadata',2,'2024-07-13 14:45:03.785130','2024-07-13 14:45:03.793256',8,'{}','success'),(7780,'sync-table-privileges',2,'2024-07-13 14:45:03.801907','2024-07-13 14:45:03.810183',8,NULL,'success'),(7781,'analyze',2,'2024-07-13 14:45:03.843853','2024-07-13 14:45:05.691540',1847,NULL,'success'),(7782,'fingerprint-fields',2,'2024-07-13 14:45:03.851549','2024-07-13 14:45:05.563722',1712,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7783,'classify-fields',2,'2024-07-13 14:45:05.571349','2024-07-13 14:45:05.664538',93,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7784,'classify-tables',2,'2024-07-13 14:45:05.671486','2024-07-13 14:45:05.684081',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7785,'sync',2,'2024-07-13 15:45:00.113213','2024-07-13 15:45:04.525431',4412,NULL,'success'),(7786,'sync-dbms-version',2,'2024-07-13 15:45:00.121943','2024-07-13 15:45:00.131252',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7787,'sync-timezone',2,'2024-07-13 15:45:00.140647','2024-07-13 15:45:00.152397',11,'{\"timezone-id\":\"+08:00\"}','success'),(7788,'sync-tables',2,'2024-07-13 15:45:00.160546','2024-07-13 15:45:00.192418',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7789,'sync-fields',2,'2024-07-13 15:45:00.201731','2024-07-13 15:45:03.304264',3102,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7790,'sync-fks',2,'2024-07-13 15:45:03.312395','2024-07-13 15:45:03.908994',596,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7791,'sync-indexes',2,'2024-07-13 15:45:03.917289','2024-07-13 15:45:04.482168',564,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7792,'sync-metabase-metadata',2,'2024-07-13 15:45:04.490137','2024-07-13 15:45:04.498490',8,'{}','success'),(7793,'sync-table-privileges',2,'2024-07-13 15:45:04.506775','2024-07-13 15:45:04.516063',9,NULL,'success'),(7794,'analyze',2,'2024-07-13 15:45:04.550136','2024-07-13 15:45:06.489949',1939,NULL,'success'),(7795,'fingerprint-fields',2,'2024-07-13 15:45:04.559680','2024-07-13 15:45:06.347441',1787,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7796,'classify-fields',2,'2024-07-13 15:45:06.354931','2024-07-13 15:45:06.459918',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7797,'classify-tables',2,'2024-07-13 15:45:06.467265','2024-07-13 15:45:06.481559',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7798,'task-history-cleanup',NULL,'2024-07-13 16:00:00.020251','2024-07-13 16:00:00.079499',59,NULL,'success'),(7799,'task-history-cleanup',NULL,'2024-07-13 16:00:00.098973','2024-07-13 16:00:00.120497',21,NULL,'success'),(7800,'sync',2,'2024-07-13 16:45:00.107968','2024-07-13 16:45:04.207842',4099,NULL,'success'),(7801,'sync-dbms-version',2,'2024-07-13 16:45:00.116224','2024-07-13 16:45:00.125226',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7802,'sync-timezone',2,'2024-07-13 16:45:00.134191','2024-07-13 16:45:00.144151',9,'{\"timezone-id\":\"+08:00\"}','success'),(7803,'sync-tables',2,'2024-07-13 16:45:00.152317','2024-07-13 16:45:00.178376',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7804,'sync-fields',2,'2024-07-13 16:45:00.187772','2024-07-13 16:45:03.093006',2905,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7805,'sync-fks',2,'2024-07-13 16:45:03.105292','2024-07-13 16:45:03.640062',534,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7806,'sync-indexes',2,'2024-07-13 16:45:03.647895','2024-07-13 16:45:04.165681',517,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7807,'sync-metabase-metadata',2,'2024-07-13 16:45:04.173027','2024-07-13 16:45:04.181195',8,'{}','success'),(7808,'sync-table-privileges',2,'2024-07-13 16:45:04.189999','2024-07-13 16:45:04.199218',9,NULL,'success'),(7809,'analyze',2,'2024-07-13 16:45:04.231753','2024-07-13 16:45:06.203164',1971,NULL,'success'),(7810,'fingerprint-fields',2,'2024-07-13 16:45:04.239962','2024-07-13 16:45:06.061170',1821,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7811,'classify-fields',2,'2024-07-13 16:45:06.069546','2024-07-13 16:45:06.172464',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7812,'classify-tables',2,'2024-07-13 16:45:06.180238','2024-07-13 16:45:06.195121',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7813,'sync',2,'2024-07-13 17:45:00.109924','2024-07-13 17:45:04.785504',4675,NULL,'success'),(7814,'sync-dbms-version',2,'2024-07-13 17:45:00.118467','2024-07-13 17:45:00.129304',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7815,'sync-timezone',2,'2024-07-13 17:45:00.138318','2024-07-13 17:45:00.149975',11,'{\"timezone-id\":\"+08:00\"}','success'),(7816,'sync-tables',2,'2024-07-13 17:45:00.159248','2024-07-13 17:45:00.188205',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7817,'sync-fields',2,'2024-07-13 17:45:00.197114','2024-07-13 17:45:03.435081',3237,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7818,'sync-fks',2,'2024-07-13 17:45:03.445022','2024-07-13 17:45:04.144252',699,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7819,'sync-indexes',2,'2024-07-13 17:45:04.153801','2024-07-13 17:45:04.736781',582,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7820,'sync-metabase-metadata',2,'2024-07-13 17:45:04.746148','2024-07-13 17:45:04.756320',10,'{}','success'),(7821,'sync-table-privileges',2,'2024-07-13 17:45:04.765814','2024-07-13 17:45:04.776381',10,NULL,'success'),(7822,'analyze',2,'2024-07-13 17:45:04.816422','2024-07-13 17:45:06.846431',2030,NULL,'success'),(7823,'fingerprint-fields',2,'2024-07-13 17:45:04.827179','2024-07-13 17:45:06.692876',1865,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7824,'classify-fields',2,'2024-07-13 17:45:06.701341','2024-07-13 17:45:06.818250',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7825,'classify-tables',2,'2024-07-13 17:45:06.825265','2024-07-13 17:45:06.838565',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7826,'sync',2,'2024-07-13 18:45:00.093091','2024-07-13 18:45:04.627870',4534,NULL,'success'),(7827,'sync-dbms-version',2,'2024-07-13 18:45:00.102628','2024-07-13 18:45:00.112747',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7828,'sync-timezone',2,'2024-07-13 18:45:00.120921','2024-07-13 18:45:00.130896',9,'{\"timezone-id\":\"+08:00\"}','success'),(7829,'sync-tables',2,'2024-07-13 18:45:00.139028','2024-07-13 18:45:00.165391',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7830,'sync-fields',2,'2024-07-13 18:45:00.174168','2024-07-13 18:45:03.358971',3184,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7831,'sync-fks',2,'2024-07-13 18:45:03.367443','2024-07-13 18:45:04.036385',668,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7832,'sync-indexes',2,'2024-07-13 18:45:04.044925','2024-07-13 18:45:04.584229',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7833,'sync-metabase-metadata',2,'2024-07-13 18:45:04.592108','2024-07-13 18:45:04.600518',8,'{}','success'),(7834,'sync-table-privileges',2,'2024-07-13 18:45:04.609230','2024-07-13 18:45:04.619257',10,NULL,'success'),(7835,'analyze',2,'2024-07-13 18:45:04.652644','2024-07-13 18:45:06.730913',2078,NULL,'success'),(7836,'fingerprint-fields',2,'2024-07-13 18:45:04.660441','2024-07-13 18:45:06.562692',1902,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7837,'classify-fields',2,'2024-07-13 18:45:06.571824','2024-07-13 18:45:06.698639',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7838,'classify-tables',2,'2024-07-13 18:45:06.706762','2024-07-13 18:45:06.722129',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7839,'sync',2,'2024-07-13 19:45:00.100782','2024-07-13 19:45:04.749219',4648,NULL,'success'),(7840,'sync-dbms-version',2,'2024-07-13 19:45:00.111318','2024-07-13 19:45:00.122506',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7841,'sync-timezone',2,'2024-07-13 19:45:00.132590','2024-07-13 19:45:00.147159',14,'{\"timezone-id\":\"+08:00\"}','success'),(7842,'sync-tables',2,'2024-07-13 19:45:00.159637','2024-07-13 19:45:00.186159',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7843,'sync-fields',2,'2024-07-13 19:45:00.194199','2024-07-13 19:45:03.390125',3195,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7844,'sync-fks',2,'2024-07-13 19:45:03.399153','2024-07-13 19:45:04.114856',715,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7845,'sync-indexes',2,'2024-07-13 19:45:04.123845','2024-07-13 19:45:04.707240',583,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7846,'sync-metabase-metadata',2,'2024-07-13 19:45:04.714869','2024-07-13 19:45:04.723339',8,'{}','success'),(7847,'sync-table-privileges',2,'2024-07-13 19:45:04.731424','2024-07-13 19:45:04.740459',9,NULL,'success'),(7848,'analyze',2,'2024-07-13 19:45:04.774939','2024-07-13 19:45:06.847969',2073,NULL,'success'),(7849,'fingerprint-fields',2,'2024-07-13 19:45:04.784199','2024-07-13 19:45:06.698324',1914,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7850,'classify-fields',2,'2024-07-13 19:45:06.707690','2024-07-13 19:45:06.815143',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7851,'classify-tables',2,'2024-07-13 19:45:06.822851','2024-07-13 19:45:06.838184',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7852,'sync',2,'2024-07-13 20:45:00.104550','2024-07-13 20:45:04.348028',4243,NULL,'success'),(7853,'sync-dbms-version',2,'2024-07-13 20:45:00.113897','2024-07-13 20:45:00.123062',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7854,'sync-timezone',2,'2024-07-13 20:45:00.130976','2024-07-13 20:45:00.140283',9,'{\"timezone-id\":\"+08:00\"}','success'),(7855,'sync-tables',2,'2024-07-13 20:45:00.148758','2024-07-13 20:45:00.177167',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7856,'sync-fields',2,'2024-07-13 20:45:00.185537','2024-07-13 20:45:03.129986',2944,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7857,'sync-fks',2,'2024-07-13 20:45:03.137955','2024-07-13 20:45:03.760895',622,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7858,'sync-indexes',2,'2024-07-13 20:45:03.769222','2024-07-13 20:45:04.304224',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7859,'sync-metabase-metadata',2,'2024-07-13 20:45:04.312151','2024-07-13 20:45:04.321144',8,'{}','success'),(7860,'sync-table-privileges',2,'2024-07-13 20:45:04.330010','2024-07-13 20:45:04.339131',9,NULL,'success'),(7861,'analyze',2,'2024-07-13 20:45:04.374267','2024-07-13 20:45:06.514234',2139,NULL,'success'),(7862,'fingerprint-fields',2,'2024-07-13 20:45:04.383395','2024-07-13 20:45:06.365453',1982,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7863,'classify-fields',2,'2024-07-13 20:45:06.374598','2024-07-13 20:45:06.482734',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7864,'classify-tables',2,'2024-07-13 20:45:06.490953','2024-07-13 20:45:06.506175',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7865,'sync',2,'2024-07-13 21:45:00.092652','2024-07-13 21:45:04.569009',4476,NULL,'success'),(7866,'sync-dbms-version',2,'2024-07-13 21:45:00.101389','2024-07-13 21:45:00.111278',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7867,'sync-timezone',2,'2024-07-13 21:45:00.121779','2024-07-13 21:45:00.132721',10,'{\"timezone-id\":\"+08:00\"}','success'),(7868,'sync-tables',2,'2024-07-13 21:45:00.140664','2024-07-13 21:45:00.172696',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7869,'sync-fields',2,'2024-07-13 21:45:00.182126','2024-07-13 21:45:03.270988',3088,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7870,'sync-fks',2,'2024-07-13 21:45:03.279570','2024-07-13 21:45:03.952181',672,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7871,'sync-indexes',2,'2024-07-13 21:45:03.961407','2024-07-13 21:45:04.526119',564,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7872,'sync-metabase-metadata',2,'2024-07-13 21:45:04.534224','2024-07-13 21:45:04.543708',9,'{}','success'),(7873,'sync-table-privileges',2,'2024-07-13 21:45:04.551731','2024-07-13 21:45:04.560330',8,NULL,'success'),(7874,'analyze',2,'2024-07-13 21:45:04.593704','2024-07-13 21:45:06.616815',2023,NULL,'success'),(7875,'fingerprint-fields',2,'2024-07-13 21:45:04.601477','2024-07-13 21:45:06.471363',1869,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7876,'classify-fields',2,'2024-07-13 21:45:06.479296','2024-07-13 21:45:06.588509',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7877,'classify-tables',2,'2024-07-13 21:45:06.595925','2024-07-13 21:45:06.608495',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7878,'sync',2,'2024-07-13 22:45:00.095039','2024-07-13 22:45:04.554690',4459,NULL,'success'),(7879,'sync-dbms-version',2,'2024-07-13 22:45:00.103577','2024-07-13 22:45:00.114811',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7880,'sync-timezone',2,'2024-07-13 22:45:00.124365','2024-07-13 22:45:00.134397',10,'{\"timezone-id\":\"+08:00\"}','success'),(7881,'sync-tables',2,'2024-07-13 22:45:00.142928','2024-07-13 22:45:00.174880',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7882,'sync-fields',2,'2024-07-13 22:45:00.184048','2024-07-13 22:45:03.321892',3137,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7883,'sync-fks',2,'2024-07-13 22:45:03.330721','2024-07-13 22:45:03.963734',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7884,'sync-indexes',2,'2024-07-13 22:45:03.977103','2024-07-13 22:45:04.515342',538,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7885,'sync-metabase-metadata',2,'2024-07-13 22:45:04.522886','2024-07-13 22:45:04.530797',7,'{}','success'),(7886,'sync-table-privileges',2,'2024-07-13 22:45:04.538784','2024-07-13 22:45:04.546948',8,NULL,'success'),(7887,'analyze',2,'2024-07-13 22:45:04.578957','2024-07-13 22:45:06.676918',2097,NULL,'success'),(7888,'fingerprint-fields',2,'2024-07-13 22:45:04.587475','2024-07-13 22:45:06.526793',1939,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7889,'classify-fields',2,'2024-07-13 22:45:06.535227','2024-07-13 22:45:06.645219',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7890,'classify-tables',2,'2024-07-13 22:45:06.652989','2024-07-13 22:45:06.666663',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7891,'sync',2,'2024-07-13 23:45:00.104950','2024-07-13 23:45:04.434418',4329,NULL,'success'),(7892,'sync-dbms-version',2,'2024-07-13 23:45:00.113849','2024-07-13 23:45:00.123462',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7893,'sync-timezone',2,'2024-07-13 23:45:00.132194','2024-07-13 23:45:00.142564',10,'{\"timezone-id\":\"+08:00\"}','success'),(7894,'sync-tables',2,'2024-07-13 23:45:00.151206','2024-07-13 23:45:00.178677',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7895,'sync-fields',2,'2024-07-13 23:45:00.187017','2024-07-13 23:45:03.061260',2874,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7896,'sync-fks',2,'2024-07-13 23:45:03.068762','2024-07-13 23:45:03.688960',620,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7897,'sync-indexes',2,'2024-07-13 23:45:03.698819','2024-07-13 23:45:04.388118',689,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7898,'sync-metabase-metadata',2,'2024-07-13 23:45:04.395783','2024-07-13 23:45:04.405187',9,'{}','success'),(7899,'sync-table-privileges',2,'2024-07-13 23:45:04.413910','2024-07-13 23:45:04.424602',10,NULL,'success'),(7900,'analyze',2,'2024-07-13 23:45:04.460212','2024-07-13 23:45:06.542286',2082,NULL,'success'),(7901,'fingerprint-fields',2,'2024-07-13 23:45:04.469169','2024-07-13 23:45:06.397514',1928,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7902,'classify-fields',2,'2024-07-13 23:45:06.406151','2024-07-13 23:45:06.514444',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7903,'classify-tables',2,'2024-07-13 23:45:06.522048','2024-07-13 23:45:06.534659',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7904,'sync',2,'2024-07-14 00:45:00.113772','2024-07-14 00:45:04.641497',4527,NULL,'success'),(7905,'sync-dbms-version',2,'2024-07-14 00:45:00.122211','2024-07-14 00:45:00.131314',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7906,'sync-timezone',2,'2024-07-14 00:45:00.141695','2024-07-14 00:45:00.152165',10,'{\"timezone-id\":\"+08:00\"}','success'),(7907,'sync-tables',2,'2024-07-14 00:45:00.160916','2024-07-14 00:45:00.188510',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7908,'sync-fields',2,'2024-07-14 00:45:00.198315','2024-07-14 00:45:03.374243',3175,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7909,'sync-fks',2,'2024-07-14 00:45:03.382122','2024-07-14 00:45:03.998380',616,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7910,'sync-indexes',2,'2024-07-14 00:45:04.006931','2024-07-14 00:45:04.595120',588,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7911,'sync-metabase-metadata',2,'2024-07-14 00:45:04.603404','2024-07-14 00:45:04.611667',8,'{}','success'),(7912,'sync-table-privileges',2,'2024-07-14 00:45:04.621419','2024-07-14 00:45:04.631800',10,NULL,'success'),(7913,'analyze',2,'2024-07-14 00:45:04.667771','2024-07-14 00:45:06.772706',2104,NULL,'success'),(7914,'fingerprint-fields',2,'2024-07-14 00:45:04.676229','2024-07-14 00:45:06.628495',1952,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7915,'classify-fields',2,'2024-07-14 00:45:06.636285','2024-07-14 00:45:06.742598',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7916,'classify-tables',2,'2024-07-14 00:45:06.750204','2024-07-14 00:45:06.764432',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7917,'sync',2,'2024-07-14 01:45:00.117390','2024-07-14 01:45:04.522200',4404,NULL,'success'),(7918,'sync-dbms-version',2,'2024-07-14 01:45:00.126304','2024-07-14 01:45:00.136653',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7919,'sync-timezone',2,'2024-07-14 01:45:00.145338','2024-07-14 01:45:00.156100',10,'{\"timezone-id\":\"+08:00\"}','success'),(7920,'sync-tables',2,'2024-07-14 01:45:00.165033','2024-07-14 01:45:00.204918',39,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7921,'sync-fields',2,'2024-07-14 01:45:00.215578','2024-07-14 01:45:03.291221',3075,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7922,'sync-fks',2,'2024-07-14 01:45:03.299042','2024-07-14 01:45:03.927263',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7923,'sync-indexes',2,'2024-07-14 01:45:03.935615','2024-07-14 01:45:04.480428',544,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7924,'sync-metabase-metadata',2,'2024-07-14 01:45:04.488400','2024-07-14 01:45:04.496821',8,'{}','success'),(7925,'sync-table-privileges',2,'2024-07-14 01:45:04.505036','2024-07-14 01:45:04.513147',8,NULL,'success'),(7926,'analyze',2,'2024-07-14 01:45:04.547921','2024-07-14 01:45:06.502952',1955,NULL,'success'),(7927,'fingerprint-fields',2,'2024-07-14 01:45:04.556280','2024-07-14 01:45:06.351783',1795,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7928,'classify-fields',2,'2024-07-14 01:45:06.359148','2024-07-14 01:45:06.472064',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7929,'classify-tables',2,'2024-07-14 01:45:06.480568','2024-07-14 01:45:06.494771',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7930,'sync',2,'2024-07-14 02:45:00.094058','2024-07-14 02:45:04.437970',4343,NULL,'success'),(7931,'sync-dbms-version',2,'2024-07-14 02:45:00.102363','2024-07-14 02:45:00.111455',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7932,'sync-timezone',2,'2024-07-14 02:45:00.120384','2024-07-14 02:45:00.131171',10,'{\"timezone-id\":\"+08:00\"}','success'),(7933,'sync-tables',2,'2024-07-14 02:45:00.139482','2024-07-14 02:45:00.168337',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7934,'sync-fields',2,'2024-07-14 02:45:00.176747','2024-07-14 02:45:03.287942',3111,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7935,'sync-fks',2,'2024-07-14 02:45:03.295561','2024-07-14 02:45:03.848373',552,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7936,'sync-indexes',2,'2024-07-14 02:45:03.856301','2024-07-14 02:45:04.395083',538,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7937,'sync-metabase-metadata',2,'2024-07-14 02:45:04.402977','2024-07-14 02:45:04.411120',8,'{}','success'),(7938,'sync-table-privileges',2,'2024-07-14 02:45:04.421141','2024-07-14 02:45:04.429726',8,NULL,'success'),(7939,'analyze',2,'2024-07-14 02:45:04.462295','2024-07-14 02:45:06.428105',1965,NULL,'success'),(7940,'fingerprint-fields',2,'2024-07-14 02:45:04.470623','2024-07-14 02:45:06.285039',1814,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7941,'classify-fields',2,'2024-07-14 02:45:06.293146','2024-07-14 02:45:06.399352',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7942,'classify-tables',2,'2024-07-14 02:45:06.406816','2024-07-14 02:45:06.419998',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7943,'sync',2,'2024-07-14 03:45:00.089569','2024-07-14 03:45:04.793048',4703,NULL,'success'),(7944,'sync-dbms-version',2,'2024-07-14 03:45:00.103987','2024-07-14 03:45:00.114806',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7945,'sync-timezone',2,'2024-07-14 03:45:00.124558','2024-07-14 03:45:00.136090',11,'{\"timezone-id\":\"+08:00\"}','success'),(7946,'sync-tables',2,'2024-07-14 03:45:00.145365','2024-07-14 03:45:00.175540',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7947,'sync-fields',2,'2024-07-14 03:45:00.183838','2024-07-14 03:45:03.401788',3217,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7948,'sync-fks',2,'2024-07-14 03:45:03.409316','2024-07-14 03:45:04.046852',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7949,'sync-indexes',2,'2024-07-14 03:45:04.056693','2024-07-14 03:45:04.747344',690,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7950,'sync-metabase-metadata',2,'2024-07-14 03:45:04.755886','2024-07-14 03:45:04.764481',8,'{}','success'),(7951,'sync-table-privileges',2,'2024-07-14 03:45:04.774500','2024-07-14 03:45:04.783814',9,NULL,'success'),(7952,'analyze',2,'2024-07-14 03:45:04.823193','2024-07-14 03:45:07.285313',2462,NULL,'success'),(7953,'fingerprint-fields',2,'2024-07-14 03:45:04.832001','2024-07-14 03:45:07.123879',2291,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7954,'classify-fields',2,'2024-07-14 03:45:07.133128','2024-07-14 03:45:07.252242',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7955,'classify-tables',2,'2024-07-14 03:45:07.260712','2024-07-14 03:45:07.276102',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7956,'task-history-cleanup',NULL,'2024-07-14 04:00:00.055955','2024-07-14 04:00:00.078537',22,NULL,'success'),(7957,'sync',2,'2024-07-14 04:45:00.105857','2024-07-14 04:45:06.075205',5969,NULL,'success'),(7958,'sync-dbms-version',2,'2024-07-14 04:45:00.114676','2024-07-14 04:45:00.125978',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7959,'sync-timezone',2,'2024-07-14 04:45:00.135635','2024-07-14 04:45:00.146979',11,'{\"timezone-id\":\"+08:00\"}','success'),(7960,'sync-tables',2,'2024-07-14 04:45:00.157375','2024-07-14 04:45:00.194433',37,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7961,'sync-fields',2,'2024-07-14 04:45:00.204154','2024-07-14 04:45:03.843849',3639,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7962,'sync-fks',2,'2024-07-14 04:45:03.853843','2024-07-14 04:45:04.639176',785,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7963,'sync-indexes',2,'2024-07-14 04:45:04.649865','2024-07-14 04:45:06.030795',1380,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7964,'sync-metabase-metadata',2,'2024-07-14 04:45:06.039470','2024-07-14 04:45:06.048938',9,'{}','success'),(7965,'sync-table-privileges',2,'2024-07-14 04:45:06.057738','2024-07-14 04:45:06.066951',9,NULL,'success'),(7966,'analyze',2,'2024-07-14 04:45:06.104085','2024-07-14 04:45:08.624665',2520,NULL,'success'),(7967,'fingerprint-fields',2,'2024-07-14 04:45:06.113166','2024-07-14 04:45:08.446175',2333,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7968,'classify-fields',2,'2024-07-14 04:45:08.454666','2024-07-14 04:45:08.592687',138,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7969,'classify-tables',2,'2024-07-14 04:45:08.600979','2024-07-14 04:45:08.615709',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7970,'sync',2,'2024-07-14 05:45:00.099940','2024-07-14 05:45:04.803228',4703,NULL,'success'),(7971,'sync-dbms-version',2,'2024-07-14 05:45:00.108200','2024-07-14 05:45:00.119698',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7972,'sync-timezone',2,'2024-07-14 05:45:00.128386','2024-07-14 05:45:00.140148',11,'{\"timezone-id\":\"+08:00\"}','success'),(7973,'sync-tables',2,'2024-07-14 05:45:00.148899','2024-07-14 05:45:00.175217',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7974,'sync-fields',2,'2024-07-14 05:45:00.183988','2024-07-14 05:45:03.450885',3266,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7975,'sync-fks',2,'2024-07-14 05:45:03.459654','2024-07-14 05:45:04.148381',688,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7976,'sync-indexes',2,'2024-07-14 05:45:04.157245','2024-07-14 05:45:04.756132',598,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7977,'sync-metabase-metadata',2,'2024-07-14 05:45:04.765201','2024-07-14 05:45:04.775042',9,'{}','success'),(7978,'sync-table-privileges',2,'2024-07-14 05:45:04.785246','2024-07-14 05:45:04.794192',8,NULL,'success'),(7979,'analyze',2,'2024-07-14 05:45:04.834269','2024-07-14 05:45:07.083640',2249,NULL,'success'),(7980,'fingerprint-fields',2,'2024-07-14 05:45:04.844551','2024-07-14 05:45:06.913782',2069,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7981,'classify-fields',2,'2024-07-14 05:45:06.922853','2024-07-14 05:45:07.051475',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7982,'classify-tables',2,'2024-07-14 05:45:07.059939','2024-07-14 05:45:07.075027',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7983,'sync',2,'2024-07-14 06:45:00.091387','2024-07-14 06:45:04.634891',4543,NULL,'success'),(7984,'sync-dbms-version',2,'2024-07-14 06:45:00.099665','2024-07-14 06:45:00.108724',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7985,'sync-timezone',2,'2024-07-14 06:45:00.116143','2024-07-14 06:45:00.125264',9,'{\"timezone-id\":\"+08:00\"}','success'),(7986,'sync-tables',2,'2024-07-14 06:45:00.133003','2024-07-14 06:45:00.163074',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(7987,'sync-fields',2,'2024-07-14 06:45:00.171394','2024-07-14 06:45:03.280651',3109,'{\"total-fields\":836,\"updated-fields\":0}','success'),(7988,'sync-fks',2,'2024-07-14 06:45:03.287959','2024-07-14 06:45:03.956099',668,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(7989,'sync-indexes',2,'2024-07-14 06:45:03.964744','2024-07-14 06:45:04.593559',628,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(7990,'sync-metabase-metadata',2,'2024-07-14 06:45:04.600712','2024-07-14 06:45:04.608371',7,'{}','success'),(7991,'sync-table-privileges',2,'2024-07-14 06:45:04.616854','2024-07-14 06:45:04.625652',8,NULL,'success'),(7992,'analyze',2,'2024-07-14 06:45:04.658716','2024-07-14 06:45:06.819428',2160,NULL,'success'),(7993,'fingerprint-fields',2,'2024-07-14 06:45:04.667861','2024-07-14 06:45:06.652212',1984,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(7994,'classify-fields',2,'2024-07-14 06:45:06.661681','2024-07-14 06:45:06.786816',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(7995,'classify-tables',2,'2024-07-14 06:45:06.795663','2024-07-14 06:45:06.809948',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(7996,'sync',2,'2024-07-14 07:45:00.098445','2024-07-14 07:45:04.104706',4006,NULL,'success'),(7997,'sync-dbms-version',2,'2024-07-14 07:45:00.105729','2024-07-14 07:45:00.114004',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(7998,'sync-timezone',2,'2024-07-14 07:45:00.121976','2024-07-14 07:45:00.131458',9,'{\"timezone-id\":\"+08:00\"}','success'),(7999,'sync-tables',2,'2024-07-14 07:45:00.139850','2024-07-14 07:45:00.168171',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8000,'sync-fields',2,'2024-07-14 07:45:00.176477','2024-07-14 07:45:02.977412',2800,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8001,'sync-fks',2,'2024-07-14 07:45:02.984786','2024-07-14 07:45:03.554364',569,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8002,'sync-indexes',2,'2024-07-14 07:45:03.562208','2024-07-14 07:45:04.065076',502,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8003,'sync-metabase-metadata',2,'2024-07-14 07:45:04.072338','2024-07-14 07:45:04.079676',7,'{}','success'),(8004,'sync-table-privileges',2,'2024-07-14 07:45:04.088185','2024-07-14 07:45:04.097037',8,NULL,'success'),(8005,'analyze',2,'2024-07-14 07:45:04.128804','2024-07-14 07:45:06.013137',1884,NULL,'success'),(8006,'fingerprint-fields',2,'2024-07-14 07:45:04.136650','2024-07-14 07:45:05.786731',1650,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8007,'classify-fields',2,'2024-07-14 07:45:05.796732','2024-07-14 07:45:05.904971',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8008,'classify-tables',2,'2024-07-14 07:45:05.911931','2024-07-14 07:45:06.000573',88,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8009,'sync',2,'2024-07-14 08:45:00.087771','2024-07-14 08:45:04.150430',4062,NULL,'success'),(8010,'sync-dbms-version',2,'2024-07-14 08:45:00.095321','2024-07-14 08:45:00.103843',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8011,'sync-timezone',2,'2024-07-14 08:45:00.111649','2024-07-14 08:45:00.120141',8,'{\"timezone-id\":\"+08:00\"}','success'),(8012,'sync-tables',2,'2024-07-14 08:45:00.128123','2024-07-14 08:45:00.154141',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8013,'sync-fields',2,'2024-07-14 08:45:00.162753','2024-07-14 08:45:03.062370',2899,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8014,'sync-fks',2,'2024-07-14 08:45:03.070191','2024-07-14 08:45:03.615391',545,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8015,'sync-indexes',2,'2024-07-14 08:45:03.624024','2024-07-14 08:45:04.109134',485,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8016,'sync-metabase-metadata',2,'2024-07-14 08:45:04.116279','2024-07-14 08:45:04.124756',8,'{}','success'),(8017,'sync-table-privileges',2,'2024-07-14 08:45:04.132901','2024-07-14 08:45:04.142625',9,NULL,'success'),(8018,'analyze',2,'2024-07-14 08:45:04.173950','2024-07-14 08:45:06.183768',2009,NULL,'success'),(8019,'fingerprint-fields',2,'2024-07-14 08:45:04.181631','2024-07-14 08:45:06.041649',1860,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8020,'classify-fields',2,'2024-07-14 08:45:06.051814','2024-07-14 08:45:06.156288',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8021,'classify-tables',2,'2024-07-14 08:45:06.163214','2024-07-14 08:45:06.176041',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8022,'sync',2,'2024-07-14 09:45:00.095400','2024-07-14 09:45:04.222816',4127,NULL,'success'),(8023,'sync-dbms-version',2,'2024-07-14 09:45:00.103197','2024-07-14 09:45:00.111675',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8024,'sync-timezone',2,'2024-07-14 09:45:00.120175','2024-07-14 09:45:00.130092',9,'{\"timezone-id\":\"+08:00\"}','success'),(8025,'sync-tables',2,'2024-07-14 09:45:00.138272','2024-07-14 09:45:00.164323',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8026,'sync-fields',2,'2024-07-14 09:45:00.173701','2024-07-14 09:45:03.036365',2862,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8027,'sync-fks',2,'2024-07-14 09:45:03.044198','2024-07-14 09:45:03.624166',579,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8028,'sync-indexes',2,'2024-07-14 09:45:03.632726','2024-07-14 09:45:04.180956',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8029,'sync-metabase-metadata',2,'2024-07-14 09:45:04.188772','2024-07-14 09:45:04.197367',8,'{}','success'),(8030,'sync-table-privileges',2,'2024-07-14 09:45:04.206265','2024-07-14 09:45:04.215231',8,NULL,'success'),(8031,'analyze',2,'2024-07-14 09:45:04.247603','2024-07-14 09:45:06.279355',2031,NULL,'success'),(8032,'fingerprint-fields',2,'2024-07-14 09:45:04.256493','2024-07-14 09:45:06.114465',1857,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8033,'classify-fields',2,'2024-07-14 09:45:06.125348','2024-07-14 09:45:06.249671',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8034,'classify-tables',2,'2024-07-14 09:45:06.257354','2024-07-14 09:45:06.271307',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8035,'sync',2,'2024-07-14 10:45:00.091473','2024-07-14 10:45:04.260076',4168,NULL,'success'),(8036,'sync-dbms-version',2,'2024-07-14 10:45:00.099592','2024-07-14 10:45:00.111057',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8037,'sync-timezone',2,'2024-07-14 10:45:00.121055','2024-07-14 10:45:00.131440',10,'{\"timezone-id\":\"+08:00\"}','success'),(8038,'sync-tables',2,'2024-07-14 10:45:00.140873','2024-07-14 10:45:00.168276',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8039,'sync-fields',2,'2024-07-14 10:45:00.176933','2024-07-14 10:45:03.074986',2898,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8040,'sync-fks',2,'2024-07-14 10:45:03.083542','2024-07-14 10:45:03.680478',596,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8041,'sync-indexes',2,'2024-07-14 10:45:03.688517','2024-07-14 10:45:04.221795',533,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8042,'sync-metabase-metadata',2,'2024-07-14 10:45:04.228702','2024-07-14 10:45:04.236071',7,'{}','success'),(8043,'sync-table-privileges',2,'2024-07-14 10:45:04.244442','2024-07-14 10:45:04.251986',7,NULL,'success'),(8044,'analyze',2,'2024-07-14 10:45:04.286464','2024-07-14 10:45:06.400537',2114,NULL,'success'),(8045,'fingerprint-fields',2,'2024-07-14 10:45:04.295004','2024-07-14 10:45:06.247372',1952,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8046,'classify-fields',2,'2024-07-14 10:45:06.256378','2024-07-14 10:45:06.369910',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8047,'classify-tables',2,'2024-07-14 10:45:06.377674','2024-07-14 10:45:06.391714',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8048,'sync',2,'2024-07-14 11:45:00.107315','2024-07-14 11:45:04.455657',4348,NULL,'success'),(8049,'sync-dbms-version',2,'2024-07-14 11:45:00.123154','2024-07-14 11:45:00.132096',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8050,'sync-timezone',2,'2024-07-14 11:45:00.140298','2024-07-14 11:45:00.149776',9,'{\"timezone-id\":\"+08:00\"}','success'),(8051,'sync-tables',2,'2024-07-14 11:45:00.157658','2024-07-14 11:45:00.188276',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8052,'sync-fields',2,'2024-07-14 11:45:00.197474','2024-07-14 11:45:03.261028',3063,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8053,'sync-fks',2,'2024-07-14 11:45:03.269206','2024-07-14 11:45:03.868680',599,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8054,'sync-indexes',2,'2024-07-14 11:45:03.876901','2024-07-14 11:45:04.407240',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8055,'sync-metabase-metadata',2,'2024-07-14 11:45:04.417606','2024-07-14 11:45:04.425483',7,'{}','success'),(8056,'sync-table-privileges',2,'2024-07-14 11:45:04.435844','2024-07-14 11:45:04.446724',10,NULL,'success'),(8057,'analyze',2,'2024-07-14 11:45:04.480644','2024-07-14 11:45:06.453644',1973,NULL,'success'),(8058,'fingerprint-fields',2,'2024-07-14 11:45:04.488887','2024-07-14 11:45:06.318327',1829,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8059,'classify-fields',2,'2024-07-14 11:45:06.327143','2024-07-14 11:45:06.425665',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8060,'classify-tables',2,'2024-07-14 11:45:06.433027','2024-07-14 11:45:06.445870',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8061,'sync',2,'2024-07-14 12:45:00.108512','2024-07-14 12:45:04.130565',4022,NULL,'success'),(8062,'sync-dbms-version',2,'2024-07-14 12:45:00.117151','2024-07-14 12:45:00.126813',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8063,'sync-timezone',2,'2024-07-14 12:45:00.135186','2024-07-14 12:45:00.145222',10,'{\"timezone-id\":\"+08:00\"}','success'),(8064,'sync-tables',2,'2024-07-14 12:45:00.155134','2024-07-14 12:45:00.181442',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8065,'sync-fields',2,'2024-07-14 12:45:00.190424','2024-07-14 12:45:02.957744',2767,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8066,'sync-fks',2,'2024-07-14 12:45:02.965146','2024-07-14 12:45:03.624194',659,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8067,'sync-indexes',2,'2024-07-14 12:45:03.632884','2024-07-14 12:45:04.092182',459,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8068,'sync-metabase-metadata',2,'2024-07-14 12:45:04.099360','2024-07-14 12:45:04.106780',7,'{}','success'),(8069,'sync-table-privileges',2,'2024-07-14 12:45:04.114525','2024-07-14 12:45:04.122525',8,NULL,'success'),(8070,'analyze',2,'2024-07-14 12:45:04.153728','2024-07-14 12:45:06.067883',1914,NULL,'success'),(8071,'fingerprint-fields',2,'2024-07-14 12:45:04.161837','2024-07-14 12:45:05.866620',1704,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8072,'classify-fields',2,'2024-07-14 12:45:05.880049','2024-07-14 12:45:06.039249',159,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8073,'classify-tables',2,'2024-07-14 12:45:06.046453','2024-07-14 12:45:06.058791',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8074,'field values scanning',2,'2024-07-14 13:00:00.053221','2024-07-14 13:00:04.440098',4386,NULL,'success'),(8075,'delete-expired-advanced-field-values',2,'2024-07-14 13:00:00.070243','2024-07-14 13:00:03.126745',3056,'{\"deleted\":0}','success'),(8076,'update-field-values',2,'2024-07-14 13:00:03.135297','2024-07-14 13:00:04.431950',1296,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(8077,'sync',2,'2024-07-14 13:45:00.105694','2024-07-14 13:45:04.581083',4475,NULL,'success'),(8078,'sync-dbms-version',2,'2024-07-14 13:45:00.114011','2024-07-14 13:45:00.123156',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8079,'sync-timezone',2,'2024-07-14 13:45:00.133221','2024-07-14 13:45:00.144175',10,'{\"timezone-id\":\"+08:00\"}','success'),(8080,'sync-tables',2,'2024-07-14 13:45:00.152903','2024-07-14 13:45:00.181240',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8081,'sync-fields',2,'2024-07-14 13:45:00.190092','2024-07-14 13:45:03.345542',3155,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8082,'sync-fks',2,'2024-07-14 13:45:03.354018','2024-07-14 13:45:04.017660',663,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8083,'sync-indexes',2,'2024-07-14 13:45:04.026223','2024-07-14 13:45:04.543483',517,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8084,'sync-metabase-metadata',2,'2024-07-14 13:45:04.550665','2024-07-14 13:45:04.558906',8,'{}','success'),(8085,'sync-table-privileges',2,'2024-07-14 13:45:04.566512','2024-07-14 13:45:04.573728',7,NULL,'success'),(8086,'analyze',2,'2024-07-14 13:45:04.606882','2024-07-14 13:45:06.677720',2070,NULL,'success'),(8087,'fingerprint-fields',2,'2024-07-14 13:45:04.614818','2024-07-14 13:45:06.507984',1893,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8088,'classify-fields',2,'2024-07-14 13:45:06.516577','2024-07-14 13:45:06.646528',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8089,'classify-tables',2,'2024-07-14 13:45:06.654819','2024-07-14 13:45:06.669004',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8090,'sync',2,'2024-07-14 14:45:00.093869','2024-07-14 14:45:04.300609',4206,NULL,'success'),(8091,'sync-dbms-version',2,'2024-07-14 14:45:00.101873','2024-07-14 14:45:00.111538',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8092,'sync-timezone',2,'2024-07-14 14:45:00.120750','2024-07-14 14:45:00.131405',10,'{\"timezone-id\":\"+08:00\"}','success'),(8093,'sync-tables',2,'2024-07-14 14:45:00.140687','2024-07-14 14:45:00.171269',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8094,'sync-fields',2,'2024-07-14 14:45:00.180567','2024-07-14 14:45:03.040791',2860,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8095,'sync-fks',2,'2024-07-14 14:45:03.048906','2024-07-14 14:45:03.677806',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8096,'sync-indexes',2,'2024-07-14 14:45:03.686121','2024-07-14 14:45:04.259351',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8097,'sync-metabase-metadata',2,'2024-07-14 14:45:04.267175','2024-07-14 14:45:04.274992',7,'{}','success'),(8098,'sync-table-privileges',2,'2024-07-14 14:45:04.283133','2024-07-14 14:45:04.292056',8,NULL,'success'),(8099,'analyze',2,'2024-07-14 14:45:04.325141','2024-07-14 14:45:06.343878',2018,NULL,'success'),(8100,'fingerprint-fields',2,'2024-07-14 14:45:04.333460','2024-07-14 14:45:06.203218',1869,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8101,'classify-fields',2,'2024-07-14 14:45:06.211232','2024-07-14 14:45:06.314062',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8102,'classify-tables',2,'2024-07-14 14:45:06.322915','2024-07-14 14:45:06.335667',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8103,'sync',2,'2024-07-14 15:45:00.096490','2024-07-14 15:45:04.627654',4531,NULL,'success'),(8104,'sync-dbms-version',2,'2024-07-14 15:45:00.105337','2024-07-14 15:45:00.116444',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8105,'sync-timezone',2,'2024-07-14 15:45:00.125519','2024-07-14 15:45:00.136401',10,'{\"timezone-id\":\"+08:00\"}','success'),(8106,'sync-tables',2,'2024-07-14 15:45:00.146215','2024-07-14 15:45:00.177814',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8107,'sync-fields',2,'2024-07-14 15:45:00.186481','2024-07-14 15:45:03.349518',3163,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8108,'sync-fks',2,'2024-07-14 15:45:03.357930','2024-07-14 15:45:04.007651',649,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8109,'sync-indexes',2,'2024-07-14 15:45:04.016384','2024-07-14 15:45:04.586791',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8110,'sync-metabase-metadata',2,'2024-07-14 15:45:04.593970','2024-07-14 15:45:04.601944',7,'{}','success'),(8111,'sync-table-privileges',2,'2024-07-14 15:45:04.609954','2024-07-14 15:45:04.619060',9,NULL,'success'),(8112,'analyze',2,'2024-07-14 15:45:04.653353','2024-07-14 15:45:06.853766',2200,NULL,'success'),(8113,'fingerprint-fields',2,'2024-07-14 15:45:04.661767','2024-07-14 15:45:06.718082',2056,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8114,'classify-fields',2,'2024-07-14 15:45:06.726041','2024-07-14 15:45:06.824794',98,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8115,'classify-tables',2,'2024-07-14 15:45:06.831936','2024-07-14 15:45:06.846132',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8116,'task-history-cleanup',NULL,'2024-07-14 16:00:00.017815','2024-07-14 16:00:00.071276',53,NULL,'success'),(8117,'task-history-cleanup',NULL,'2024-07-14 16:00:00.139355','2024-07-14 16:00:00.164478',25,NULL,'success'),(8118,'sync',2,'2024-07-14 16:45:00.097110','2024-07-14 16:45:04.331283',4234,NULL,'success'),(8119,'sync-dbms-version',2,'2024-07-14 16:45:00.104923','2024-07-14 16:45:00.113749',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8120,'sync-timezone',2,'2024-07-14 16:45:00.121815','2024-07-14 16:45:00.131559',9,'{\"timezone-id\":\"+08:00\"}','success'),(8121,'sync-tables',2,'2024-07-14 16:45:00.141328','2024-07-14 16:45:00.169121',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8122,'sync-fields',2,'2024-07-14 16:45:00.178267','2024-07-14 16:45:03.132891',2954,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8123,'sync-fks',2,'2024-07-14 16:45:03.141270','2024-07-14 16:45:03.740615',599,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8124,'sync-indexes',2,'2024-07-14 16:45:03.749181','2024-07-14 16:45:04.290399',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8125,'sync-metabase-metadata',2,'2024-07-14 16:45:04.297892','2024-07-14 16:45:04.305805',7,'{}','success'),(8126,'sync-table-privileges',2,'2024-07-14 16:45:04.314146','2024-07-14 16:45:04.323205',9,NULL,'success'),(8127,'analyze',2,'2024-07-14 16:45:04.355391','2024-07-14 16:45:06.463246',2107,NULL,'success'),(8128,'fingerprint-fields',2,'2024-07-14 16:45:04.363441','2024-07-14 16:45:06.313054',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8129,'classify-fields',2,'2024-07-14 16:45:06.321408','2024-07-14 16:45:06.433722',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8130,'classify-tables',2,'2024-07-14 16:45:06.441624','2024-07-14 16:45:06.455163',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8131,'sync',2,'2024-07-14 17:45:00.099363','2024-07-14 17:45:04.589039',4489,NULL,'success'),(8132,'sync-dbms-version',2,'2024-07-14 17:45:00.107947','2024-07-14 17:45:00.117662',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8133,'sync-timezone',2,'2024-07-14 17:45:00.126156','2024-07-14 17:45:00.136806',10,'{\"timezone-id\":\"+08:00\"}','success'),(8134,'sync-tables',2,'2024-07-14 17:45:00.145377','2024-07-14 17:45:00.172626',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8135,'sync-fields',2,'2024-07-14 17:45:00.181349','2024-07-14 17:45:03.319428',3138,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8136,'sync-fks',2,'2024-07-14 17:45:03.327244','2024-07-14 17:45:04.002027',674,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8137,'sync-indexes',2,'2024-07-14 17:45:04.010715','2024-07-14 17:45:04.543170',532,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8138,'sync-metabase-metadata',2,'2024-07-14 17:45:04.551986','2024-07-14 17:45:04.560679',8,'{}','success'),(8139,'sync-table-privileges',2,'2024-07-14 17:45:04.570042','2024-07-14 17:45:04.580143',10,NULL,'success'),(8140,'analyze',2,'2024-07-14 17:45:04.616878','2024-07-14 17:45:07.028123',2411,NULL,'success'),(8141,'fingerprint-fields',2,'2024-07-14 17:45:04.626744','2024-07-14 17:45:06.851621',2224,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8142,'classify-fields',2,'2024-07-14 17:45:06.860263','2024-07-14 17:45:06.987731',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8143,'classify-tables',2,'2024-07-14 17:45:06.996325','2024-07-14 17:45:07.017675',21,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8144,'sync',2,'2024-07-14 18:45:00.116332','2024-07-14 18:45:04.567324',4450,NULL,'success'),(8145,'sync-dbms-version',2,'2024-07-14 18:45:00.125665','2024-07-14 18:45:00.134899',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8146,'sync-timezone',2,'2024-07-14 18:45:00.143360','2024-07-14 18:45:00.154542',11,'{\"timezone-id\":\"+08:00\"}','success'),(8147,'sync-tables',2,'2024-07-14 18:45:00.164176','2024-07-14 18:45:00.192876',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8148,'sync-fields',2,'2024-07-14 18:45:00.202012','2024-07-14 18:45:03.398011',3196,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8149,'sync-fks',2,'2024-07-14 18:45:03.408845','2024-07-14 18:45:03.960290',551,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8150,'sync-indexes',2,'2024-07-14 18:45:03.968146','2024-07-14 18:45:04.525227',557,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8151,'sync-metabase-metadata',2,'2024-07-14 18:45:04.532859','2024-07-14 18:45:04.542879',10,'{}','success'),(8152,'sync-table-privileges',2,'2024-07-14 18:45:04.551064','2024-07-14 18:45:04.559515',8,NULL,'success'),(8153,'analyze',2,'2024-07-14 18:45:04.592774','2024-07-14 18:45:06.823537',2230,NULL,'success'),(8154,'fingerprint-fields',2,'2024-07-14 18:45:04.602318','2024-07-14 18:45:06.676651',2074,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8155,'classify-fields',2,'2024-07-14 18:45:06.685494','2024-07-14 18:45:06.796000',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8156,'classify-tables',2,'2024-07-14 18:45:06.803119','2024-07-14 18:45:06.814965',11,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8157,'sync',2,'2024-07-14 19:45:00.091212','2024-07-14 19:45:04.428683',4337,NULL,'success'),(8158,'sync-dbms-version',2,'2024-07-14 19:45:00.101452','2024-07-14 19:45:00.111371',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8159,'sync-timezone',2,'2024-07-14 19:45:00.119981','2024-07-14 19:45:00.129446',9,'{\"timezone-id\":\"+08:00\"}','success'),(8160,'sync-tables',2,'2024-07-14 19:45:00.137956','2024-07-14 19:45:00.168509',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8161,'sync-fields',2,'2024-07-14 19:45:00.176511','2024-07-14 19:45:03.036592',2860,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8162,'sync-fks',2,'2024-07-14 19:45:03.044297','2024-07-14 19:45:03.773274',728,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8163,'sync-indexes',2,'2024-07-14 19:45:03.782934','2024-07-14 19:45:04.386271',603,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8164,'sync-metabase-metadata',2,'2024-07-14 19:45:04.393609','2024-07-14 19:45:04.401391',7,'{}','success'),(8165,'sync-table-privileges',2,'2024-07-14 19:45:04.410446','2024-07-14 19:45:04.419970',9,NULL,'success'),(8166,'analyze',2,'2024-07-14 19:45:04.453950','2024-07-14 19:45:06.542500',2088,NULL,'success'),(8167,'fingerprint-fields',2,'2024-07-14 19:45:04.461876','2024-07-14 19:45:06.374237',1912,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8168,'classify-fields',2,'2024-07-14 19:45:06.382056','2024-07-14 19:45:06.498627',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8169,'classify-tables',2,'2024-07-14 19:45:06.506569','2024-07-14 19:45:06.522407',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8170,'sync',2,'2024-07-14 20:45:00.093839','2024-07-14 20:45:04.448044',4354,NULL,'success'),(8171,'sync-dbms-version',2,'2024-07-14 20:45:00.102812','2024-07-14 20:45:00.112812',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8172,'sync-timezone',2,'2024-07-14 20:45:00.121974','2024-07-14 20:45:00.133604',11,'{\"timezone-id\":\"+08:00\"}','success'),(8173,'sync-tables',2,'2024-07-14 20:45:00.142565','2024-07-14 20:45:00.168213',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8174,'sync-fields',2,'2024-07-14 20:45:00.177838','2024-07-14 20:45:03.215307',3037,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8175,'sync-fks',2,'2024-07-14 20:45:03.223443','2024-07-14 20:45:03.817631',594,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8176,'sync-indexes',2,'2024-07-14 20:45:03.826190','2024-07-14 20:45:04.401365',575,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8177,'sync-metabase-metadata',2,'2024-07-14 20:45:04.409536','2024-07-14 20:45:04.419237',9,'{}','success'),(8178,'sync-table-privileges',2,'2024-07-14 20:45:04.428817','2024-07-14 20:45:04.439078',10,NULL,'success'),(8179,'analyze',2,'2024-07-14 20:45:04.482193','2024-07-14 20:45:06.648462',2166,NULL,'success'),(8180,'fingerprint-fields',2,'2024-07-14 20:45:04.491895','2024-07-14 20:45:06.485495',1993,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8181,'classify-fields',2,'2024-07-14 20:45:06.494578','2024-07-14 20:45:06.616519',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8182,'classify-tables',2,'2024-07-14 20:45:06.625213','2024-07-14 20:45:06.640086',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8183,'sync',2,'2024-07-14 21:45:00.101134','2024-07-14 21:45:04.795845',4694,NULL,'success'),(8184,'sync-dbms-version',2,'2024-07-14 21:45:00.110401','2024-07-14 21:45:00.119325',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8185,'sync-timezone',2,'2024-07-14 21:45:00.128736','2024-07-14 21:45:00.138549',9,'{\"timezone-id\":\"+08:00\"}','success'),(8186,'sync-tables',2,'2024-07-14 21:45:00.147292','2024-07-14 21:45:00.177543',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8187,'sync-fields',2,'2024-07-14 21:45:00.186049','2024-07-14 21:45:03.469301',3283,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8188,'sync-fks',2,'2024-07-14 21:45:03.477144','2024-07-14 21:45:04.143844',666,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8189,'sync-indexes',2,'2024-07-14 21:45:04.152465','2024-07-14 21:45:04.754232',601,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8190,'sync-metabase-metadata',2,'2024-07-14 21:45:04.761923','2024-07-14 21:45:04.770254',8,'{}','success'),(8191,'sync-table-privileges',2,'2024-07-14 21:45:04.778161','2024-07-14 21:45:04.787365',9,NULL,'success'),(8192,'analyze',2,'2024-07-14 21:45:04.830491','2024-07-14 21:45:07.034299',2203,NULL,'success'),(8193,'fingerprint-fields',2,'2024-07-14 21:45:04.844182','2024-07-14 21:45:06.875190',2031,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8194,'classify-fields',2,'2024-07-14 21:45:06.884121','2024-07-14 21:45:07.002535',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8195,'classify-tables',2,'2024-07-14 21:45:07.010542','2024-07-14 21:45:07.025422',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8196,'sync',2,'2024-07-14 22:45:00.099742','2024-07-14 22:45:04.227599',4127,NULL,'success'),(8197,'sync-dbms-version',2,'2024-07-14 22:45:00.108960','2024-07-14 22:45:00.118248',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8198,'sync-timezone',2,'2024-07-14 22:45:00.126877','2024-07-14 22:45:00.137164',10,'{\"timezone-id\":\"+08:00\"}','success'),(8199,'sync-tables',2,'2024-07-14 22:45:00.145259','2024-07-14 22:45:00.175042',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8200,'sync-fields',2,'2024-07-14 22:45:00.183476','2024-07-14 22:45:03.109409',2925,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8201,'sync-fks',2,'2024-07-14 22:45:03.117241','2024-07-14 22:45:03.674656',557,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8202,'sync-indexes',2,'2024-07-14 22:45:03.683559','2024-07-14 22:45:04.186341',502,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8203,'sync-metabase-metadata',2,'2024-07-14 22:45:04.193822','2024-07-14 22:45:04.202370',8,'{}','success'),(8204,'sync-table-privileges',2,'2024-07-14 22:45:04.210336','2024-07-14 22:45:04.218233',7,NULL,'success'),(8205,'analyze',2,'2024-07-14 22:45:04.254688','2024-07-14 22:45:06.262760',2008,NULL,'success'),(8206,'fingerprint-fields',2,'2024-07-14 22:45:04.262716','2024-07-14 22:45:06.121868',1859,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8207,'classify-fields',2,'2024-07-14 22:45:06.129446','2024-07-14 22:45:06.233600',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8208,'classify-tables',2,'2024-07-14 22:45:06.241434','2024-07-14 22:45:06.254666',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8209,'sync',2,'2024-07-14 23:45:00.112629','2024-07-14 23:45:05.359876',5247,NULL,'success'),(8210,'sync-dbms-version',2,'2024-07-14 23:45:00.121941','2024-07-14 23:45:00.130936',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8211,'sync-timezone',2,'2024-07-14 23:45:00.140042','2024-07-14 23:45:00.150231',10,'{\"timezone-id\":\"+08:00\"}','success'),(8212,'sync-tables',2,'2024-07-14 23:45:00.159155','2024-07-14 23:45:00.190913',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8213,'sync-fields',2,'2024-07-14 23:45:00.200003','2024-07-14 23:45:03.705252',3505,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8214,'sync-fks',2,'2024-07-14 23:45:03.714722','2024-07-14 23:45:04.498279',783,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8215,'sync-indexes',2,'2024-07-14 23:45:04.507721','2024-07-14 23:45:05.311166',803,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8216,'sync-metabase-metadata',2,'2024-07-14 23:45:05.319956','2024-07-14 23:45:05.329490',9,'{}','success'),(8217,'sync-table-privileges',2,'2024-07-14 23:45:05.338785','2024-07-14 23:45:05.348652',9,NULL,'success'),(8218,'analyze',2,'2024-07-14 23:45:05.401073','2024-07-14 23:45:07.715866',2314,NULL,'success'),(8219,'fingerprint-fields',2,'2024-07-14 23:45:05.413109','2024-07-14 23:45:07.559882',2146,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8220,'classify-fields',2,'2024-07-14 23:45:07.570628','2024-07-14 23:45:07.685334',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8221,'classify-tables',2,'2024-07-14 23:45:07.693643','2024-07-14 23:45:07.707614',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8222,'sync',2,'2024-07-15 00:45:00.110027','2024-07-15 00:45:04.670914',4560,NULL,'success'),(8223,'sync-dbms-version',2,'2024-07-15 00:45:00.118404','2024-07-15 00:45:00.128355',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8224,'sync-timezone',2,'2024-07-15 00:45:00.136738','2024-07-15 00:45:00.147370',10,'{\"timezone-id\":\"+08:00\"}','success'),(8225,'sync-tables',2,'2024-07-15 00:45:00.157369','2024-07-15 00:45:00.190992',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8226,'sync-fields',2,'2024-07-15 00:45:00.199986','2024-07-15 00:45:03.377645',3177,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8227,'sync-fks',2,'2024-07-15 00:45:03.385744','2024-07-15 00:45:04.022182',636,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8228,'sync-indexes',2,'2024-07-15 00:45:04.031618','2024-07-15 00:45:04.624297',592,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8229,'sync-metabase-metadata',2,'2024-07-15 00:45:04.632734','2024-07-15 00:45:04.643234',10,'{}','success'),(8230,'sync-table-privileges',2,'2024-07-15 00:45:04.652349','2024-07-15 00:45:04.662321',9,NULL,'success'),(8231,'analyze',2,'2024-07-15 00:45:04.701347','2024-07-15 00:45:06.823940',2122,NULL,'success'),(8232,'fingerprint-fields',2,'2024-07-15 00:45:04.711710','2024-07-15 00:45:06.671917',1960,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8233,'classify-fields',2,'2024-07-15 00:45:06.679903','2024-07-15 00:45:06.793243',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8234,'classify-tables',2,'2024-07-15 00:45:06.801179','2024-07-15 00:45:06.815439',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8235,'sync',2,'2024-07-15 01:45:00.115359','2024-07-15 01:45:04.637996',4522,NULL,'success'),(8236,'sync-dbms-version',2,'2024-07-15 01:45:00.124076','2024-07-15 01:45:00.134327',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8237,'sync-timezone',2,'2024-07-15 01:45:00.143425','2024-07-15 01:45:00.154692',11,'{\"timezone-id\":\"+08:00\"}','success'),(8238,'sync-tables',2,'2024-07-15 01:45:00.164027','2024-07-15 01:45:00.193295',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8239,'sync-fields',2,'2024-07-15 01:45:00.202161','2024-07-15 01:45:03.394936',3192,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8240,'sync-fks',2,'2024-07-15 01:45:03.402832','2024-07-15 01:45:04.030605',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8241,'sync-indexes',2,'2024-07-15 01:45:04.040464','2024-07-15 01:45:04.594918',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8242,'sync-metabase-metadata',2,'2024-07-15 01:45:04.602549','2024-07-15 01:45:04.613461',10,'{}','success'),(8243,'sync-table-privileges',2,'2024-07-15 01:45:04.622167','2024-07-15 01:45:04.630056',7,NULL,'success'),(8244,'analyze',2,'2024-07-15 01:45:04.662240','2024-07-15 01:45:06.739547',2077,NULL,'success'),(8245,'fingerprint-fields',2,'2024-07-15 01:45:04.670545','2024-07-15 01:45:06.589053',1918,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8246,'classify-fields',2,'2024-07-15 01:45:06.596882','2024-07-15 01:45:06.709760',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8247,'classify-tables',2,'2024-07-15 01:45:06.717724','2024-07-15 01:45:06.731307',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8248,'sync',2,'2024-07-15 02:45:00.104796','2024-07-15 02:45:04.605939',4501,NULL,'success'),(8249,'sync-dbms-version',2,'2024-07-15 02:45:00.113440','2024-07-15 02:45:00.123196',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8250,'sync-timezone',2,'2024-07-15 02:45:00.131950','2024-07-15 02:45:00.142849',10,'{\"timezone-id\":\"+08:00\"}','success'),(8251,'sync-tables',2,'2024-07-15 02:45:00.151307','2024-07-15 02:45:00.179098',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8252,'sync-fields',2,'2024-07-15 02:45:00.188270','2024-07-15 02:45:03.263162',3074,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8253,'sync-fks',2,'2024-07-15 02:45:03.272356','2024-07-15 02:45:03.922482',650,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8254,'sync-indexes',2,'2024-07-15 02:45:03.931852','2024-07-15 02:45:04.558662',626,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8255,'sync-metabase-metadata',2,'2024-07-15 02:45:04.567795','2024-07-15 02:45:04.578538',10,'{}','success'),(8256,'sync-table-privileges',2,'2024-07-15 02:45:04.587092','2024-07-15 02:45:04.595920',8,NULL,'success'),(8257,'analyze',2,'2024-07-15 02:45:04.631977','2024-07-15 02:45:06.796519',2164,NULL,'success'),(8258,'fingerprint-fields',2,'2024-07-15 02:45:04.639832','2024-07-15 02:45:06.648264',2008,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8259,'classify-fields',2,'2024-07-15 02:45:06.657116','2024-07-15 02:45:06.766502',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8260,'classify-tables',2,'2024-07-15 02:45:06.774018','2024-07-15 02:45:06.788026',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8261,'sync',2,'2024-07-15 03:45:00.090806','2024-07-15 03:45:04.669926',4579,NULL,'success'),(8262,'sync-dbms-version',2,'2024-07-15 03:45:00.098528','2024-07-15 03:45:00.107206',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8263,'sync-timezone',2,'2024-07-15 03:45:00.115262','2024-07-15 03:45:00.124525',9,'{\"timezone-id\":\"+08:00\"}','success'),(8264,'sync-tables',2,'2024-07-15 03:45:00.132963','2024-07-15 03:45:00.159286',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8265,'sync-fields',2,'2024-07-15 03:45:00.167802','2024-07-15 03:45:03.292704',3124,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8266,'sync-fks',2,'2024-07-15 03:45:03.302763','2024-07-15 03:45:04.034190',731,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8267,'sync-indexes',2,'2024-07-15 03:45:04.044181','2024-07-15 03:45:04.630641',586,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8268,'sync-metabase-metadata',2,'2024-07-15 03:45:04.637780','2024-07-15 03:45:04.644712',6,'{}','success'),(8269,'sync-table-privileges',2,'2024-07-15 03:45:04.653246','2024-07-15 03:45:04.662272',9,NULL,'success'),(8270,'analyze',2,'2024-07-15 03:45:04.695193','2024-07-15 03:45:06.827118',2131,NULL,'success'),(8271,'fingerprint-fields',2,'2024-07-15 03:45:04.703667','2024-07-15 03:45:06.659667',1956,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8272,'classify-fields',2,'2024-07-15 03:45:06.668709','2024-07-15 03:45:06.795437',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8273,'classify-tables',2,'2024-07-15 03:45:06.804503','2024-07-15 03:45:06.818830',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8274,'task-history-cleanup',NULL,'2024-07-15 04:00:00.087467','2024-07-15 04:00:00.112737',25,NULL,'success'),(8275,'sync',2,'2024-07-15 04:45:00.100877','2024-07-15 04:45:04.390566',4289,NULL,'success'),(8276,'sync-dbms-version',2,'2024-07-15 04:45:00.109693','2024-07-15 04:45:00.120709',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8277,'sync-timezone',2,'2024-07-15 04:45:00.131340','2024-07-15 04:45:00.142490',11,'{\"timezone-id\":\"+08:00\"}','success'),(8278,'sync-tables',2,'2024-07-15 04:45:00.151047','2024-07-15 04:45:00.180616',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8279,'sync-fields',2,'2024-07-15 04:45:00.189354','2024-07-15 04:45:03.177266',2987,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8280,'sync-fks',2,'2024-07-15 04:45:03.185232','2024-07-15 04:45:03.764158',578,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8281,'sync-indexes',2,'2024-07-15 04:45:03.772638','2024-07-15 04:45:04.351397',578,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8282,'sync-metabase-metadata',2,'2024-07-15 04:45:04.358838','2024-07-15 04:45:04.366700',7,'{}','success'),(8283,'sync-table-privileges',2,'2024-07-15 04:45:04.374943','2024-07-15 04:45:04.382225',7,NULL,'success'),(8284,'analyze',2,'2024-07-15 04:45:04.415000','2024-07-15 04:45:06.344092',1929,NULL,'success'),(8285,'fingerprint-fields',2,'2024-07-15 04:45:04.423182','2024-07-15 04:45:06.202974',1779,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8286,'classify-fields',2,'2024-07-15 04:45:06.210737','2024-07-15 04:45:06.315142',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8287,'classify-tables',2,'2024-07-15 04:45:06.322997','2024-07-15 04:45:06.336185',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8288,'sync',2,'2024-07-15 05:45:00.111622','2024-07-15 05:45:05.396483',5284,NULL,'success'),(8289,'sync-dbms-version',2,'2024-07-15 05:45:00.120269','2024-07-15 05:45:00.130198',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8290,'sync-timezone',2,'2024-07-15 05:45:00.138895','2024-07-15 05:45:00.150685',11,'{\"timezone-id\":\"+08:00\"}','success'),(8291,'sync-tables',2,'2024-07-15 05:45:00.159972','2024-07-15 05:45:00.186698',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8292,'sync-fields',2,'2024-07-15 05:45:00.195246','2024-07-15 05:45:03.360108',3164,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8293,'sync-fks',2,'2024-07-15 05:45:03.368819','2024-07-15 05:45:04.031105',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8294,'sync-indexes',2,'2024-07-15 05:45:04.039328','2024-07-15 05:45:05.350157',1310,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8295,'sync-metabase-metadata',2,'2024-07-15 05:45:05.358216','2024-07-15 05:45:05.368140',9,'{}','success'),(8296,'sync-table-privileges',2,'2024-07-15 05:45:05.377297','2024-07-15 05:45:05.387032',9,NULL,'success'),(8297,'analyze',2,'2024-07-15 05:45:05.422830','2024-07-15 05:45:07.601816',2178,NULL,'success'),(8298,'fingerprint-fields',2,'2024-07-15 05:45:05.431486','2024-07-15 05:45:07.436536',2005,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8299,'classify-fields',2,'2024-07-15 05:45:07.445617','2024-07-15 05:45:07.568984',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8300,'classify-tables',2,'2024-07-15 05:45:07.577371','2024-07-15 05:45:07.592554',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8301,'sync',2,'2024-07-15 06:45:00.106963','2024-07-15 06:45:04.556548',4449,NULL,'success'),(8302,'sync-dbms-version',2,'2024-07-15 06:45:00.115817','2024-07-15 06:45:00.126544',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8303,'sync-timezone',2,'2024-07-15 06:45:00.136017','2024-07-15 06:45:00.148029',12,'{\"timezone-id\":\"+08:00\"}','success'),(8304,'sync-tables',2,'2024-07-15 06:45:00.157299','2024-07-15 06:45:00.185974',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8305,'sync-fields',2,'2024-07-15 06:45:00.194786','2024-07-15 06:45:03.389938',3195,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8306,'sync-fks',2,'2024-07-15 06:45:03.398185','2024-07-15 06:45:03.962572',564,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8307,'sync-indexes',2,'2024-07-15 06:45:03.970676','2024-07-15 06:45:04.511791',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8308,'sync-metabase-metadata',2,'2024-07-15 06:45:04.520886','2024-07-15 06:45:04.529934',9,'{}','success'),(8309,'sync-table-privileges',2,'2024-07-15 06:45:04.539048','2024-07-15 06:45:04.547507',8,NULL,'success'),(8310,'analyze',2,'2024-07-15 06:45:04.581025','2024-07-15 06:45:06.633698',2052,NULL,'success'),(8311,'fingerprint-fields',2,'2024-07-15 06:45:04.589105','2024-07-15 06:45:06.478167',1889,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8312,'classify-fields',2,'2024-07-15 06:45:06.486781','2024-07-15 06:45:06.600437',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8313,'classify-tables',2,'2024-07-15 06:45:06.608531','2024-07-15 06:45:06.624164',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8314,'sync',2,'2024-07-15 07:45:00.102700','2024-07-15 07:45:04.521298',4418,NULL,'success'),(8315,'sync-dbms-version',2,'2024-07-15 07:45:00.111218','2024-07-15 07:45:00.120848',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8316,'sync-timezone',2,'2024-07-15 07:45:00.129399','2024-07-15 07:45:00.142648',13,'{\"timezone-id\":\"+08:00\"}','success'),(8317,'sync-tables',2,'2024-07-15 07:45:00.155504','2024-07-15 07:45:00.184178',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8318,'sync-fields',2,'2024-07-15 07:45:00.192681','2024-07-15 07:45:03.264346',3071,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8319,'sync-fks',2,'2024-07-15 07:45:03.272794','2024-07-15 07:45:03.923551',650,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8320,'sync-indexes',2,'2024-07-15 07:45:03.932914','2024-07-15 07:45:04.481517',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8321,'sync-metabase-metadata',2,'2024-07-15 07:45:04.489446','2024-07-15 07:45:04.497548',8,'{}','success'),(8322,'sync-table-privileges',2,'2024-07-15 07:45:04.505402','2024-07-15 07:45:04.513269',7,NULL,'success'),(8323,'analyze',2,'2024-07-15 07:45:04.545093','2024-07-15 07:45:06.652126',2107,NULL,'success'),(8324,'fingerprint-fields',2,'2024-07-15 07:45:04.553038','2024-07-15 07:45:06.503211',1950,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8325,'classify-fields',2,'2024-07-15 07:45:06.511799','2024-07-15 07:45:06.621834',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8326,'classify-tables',2,'2024-07-15 07:45:06.629523','2024-07-15 07:45:06.643901',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8327,'sync',2,'2024-07-15 08:45:00.093851','2024-07-15 08:45:04.256977',4163,NULL,'success'),(8328,'sync-dbms-version',2,'2024-07-15 08:45:00.102160','2024-07-15 08:45:00.110211',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8329,'sync-timezone',2,'2024-07-15 08:45:00.118644','2024-07-15 08:45:00.128146',9,'{\"timezone-id\":\"+08:00\"}','success'),(8330,'sync-tables',2,'2024-07-15 08:45:00.136562','2024-07-15 08:45:00.163032',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8331,'sync-fields',2,'2024-07-15 08:45:00.171518','2024-07-15 08:45:03.091232',2919,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8332,'sync-fks',2,'2024-07-15 08:45:03.101119','2024-07-15 08:45:03.714402',613,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8333,'sync-indexes',2,'2024-07-15 08:45:03.722986','2024-07-15 08:45:04.217432',494,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8334,'sync-metabase-metadata',2,'2024-07-15 08:45:04.224945','2024-07-15 08:45:04.232703',7,'{}','success'),(8335,'sync-table-privileges',2,'2024-07-15 08:45:04.240550','2024-07-15 08:45:04.248484',7,NULL,'success'),(8336,'analyze',2,'2024-07-15 08:45:04.281840','2024-07-15 08:45:06.134377',1852,NULL,'success'),(8337,'fingerprint-fields',2,'2024-07-15 08:45:04.289531','2024-07-15 08:45:05.979221',1689,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8338,'classify-fields',2,'2024-07-15 08:45:05.988335','2024-07-15 08:45:06.105040',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8339,'classify-tables',2,'2024-07-15 08:45:06.112879','2024-07-15 08:45:06.126481',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8340,'sync',2,'2024-07-15 09:45:00.099508','2024-07-15 09:45:04.277248',4177,NULL,'success'),(8341,'sync-dbms-version',2,'2024-07-15 09:45:00.108361','2024-07-15 09:45:00.118345',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8342,'sync-timezone',2,'2024-07-15 09:45:00.127566','2024-07-15 09:45:00.138449',10,'{\"timezone-id\":\"+08:00\"}','success'),(8343,'sync-tables',2,'2024-07-15 09:45:00.146920','2024-07-15 09:45:00.175075',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8344,'sync-fields',2,'2024-07-15 09:45:00.183814','2024-07-15 09:45:03.144221',2960,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8345,'sync-fks',2,'2024-07-15 09:45:03.152143','2024-07-15 09:45:03.719615',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8346,'sync-indexes',2,'2024-07-15 09:45:03.728805','2024-07-15 09:45:04.232976',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8347,'sync-metabase-metadata',2,'2024-07-15 09:45:04.240992','2024-07-15 09:45:04.250386',9,'{}','success'),(8348,'sync-table-privileges',2,'2024-07-15 09:45:04.259391','2024-07-15 09:45:04.268772',9,NULL,'success'),(8349,'analyze',2,'2024-07-15 09:45:04.300953','2024-07-15 09:45:06.208235',1907,NULL,'success'),(8350,'fingerprint-fields',2,'2024-07-15 09:45:04.310722','2024-07-15 09:45:06.062780',1752,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8351,'classify-fields',2,'2024-07-15 09:45:06.071330','2024-07-15 09:45:06.174517',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8352,'classify-tables',2,'2024-07-15 09:45:06.182523','2024-07-15 09:45:06.197687',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8353,'sync',2,'2024-07-15 10:45:00.095180','2024-07-15 10:45:04.425683',4330,NULL,'success'),(8354,'sync-dbms-version',2,'2024-07-15 10:45:00.103898','2024-07-15 10:45:00.113403',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8355,'sync-timezone',2,'2024-07-15 10:45:00.122116','2024-07-15 10:45:00.131488',9,'{\"timezone-id\":\"+08:00\"}','success'),(8356,'sync-tables',2,'2024-07-15 10:45:00.140845','2024-07-15 10:45:00.168936',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8357,'sync-fields',2,'2024-07-15 10:45:00.176886','2024-07-15 10:45:03.194337',3017,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8358,'sync-fks',2,'2024-07-15 10:45:03.202007','2024-07-15 10:45:03.842277',640,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8359,'sync-indexes',2,'2024-07-15 10:45:03.850164','2024-07-15 10:45:04.380474',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8360,'sync-metabase-metadata',2,'2024-07-15 10:45:04.389217','2024-07-15 10:45:04.398288',9,'{}','success'),(8361,'sync-table-privileges',2,'2024-07-15 10:45:04.407470','2024-07-15 10:45:04.416648',9,NULL,'success'),(8362,'analyze',2,'2024-07-15 10:45:04.450931','2024-07-15 10:45:06.351860',1900,NULL,'success'),(8363,'fingerprint-fields',2,'2024-07-15 10:45:04.459566','2024-07-15 10:45:06.211452',1751,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8364,'classify-fields',2,'2024-07-15 10:45:06.219366','2024-07-15 10:45:06.323474',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8365,'classify-tables',2,'2024-07-15 10:45:06.330656','2024-07-15 10:45:06.343355',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8366,'sync',2,'2024-07-15 11:45:00.087946','2024-07-15 11:45:04.393998',4306,NULL,'success'),(8367,'sync-dbms-version',2,'2024-07-15 11:45:00.097442','2024-07-15 11:45:00.106276',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8368,'sync-timezone',2,'2024-07-15 11:45:00.114485','2024-07-15 11:45:00.125861',11,'{\"timezone-id\":\"+08:00\"}','success'),(8369,'sync-tables',2,'2024-07-15 11:45:00.133885','2024-07-15 11:45:00.160203',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8370,'sync-fields',2,'2024-07-15 11:45:00.168423','2024-07-15 11:45:03.144431',2976,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8371,'sync-fks',2,'2024-07-15 11:45:03.152019','2024-07-15 11:45:03.826960',674,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8372,'sync-indexes',2,'2024-07-15 11:45:03.838823','2024-07-15 11:45:04.355893',517,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8373,'sync-metabase-metadata',2,'2024-07-15 11:45:04.363204','2024-07-15 11:45:04.371355',8,'{}','success'),(8374,'sync-table-privileges',2,'2024-07-15 11:45:04.378782','2024-07-15 11:45:04.386322',7,NULL,'success'),(8375,'analyze',2,'2024-07-15 11:45:04.417843','2024-07-15 11:45:06.416658',1998,NULL,'success'),(8376,'fingerprint-fields',2,'2024-07-15 11:45:04.425693','2024-07-15 11:45:06.252419',1826,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8377,'classify-fields',2,'2024-07-15 11:45:06.261489','2024-07-15 11:45:06.383483',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8378,'classify-tables',2,'2024-07-15 11:45:06.391503','2024-07-15 11:45:06.408322',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8379,'sync',2,'2024-07-15 12:45:00.095576','2024-07-15 12:45:04.180258',4084,NULL,'success'),(8380,'sync-dbms-version',2,'2024-07-15 12:45:00.105864','2024-07-15 12:45:00.115557',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8381,'sync-timezone',2,'2024-07-15 12:45:00.123364','2024-07-15 12:45:00.132439',9,'{\"timezone-id\":\"+08:00\"}','success'),(8382,'sync-tables',2,'2024-07-15 12:45:00.140503','2024-07-15 12:45:00.167278',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8383,'sync-fields',2,'2024-07-15 12:45:00.175378','2024-07-15 12:45:02.987569',2812,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8384,'sync-fks',2,'2024-07-15 12:45:02.995235','2024-07-15 12:45:03.580751',585,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8385,'sync-indexes',2,'2024-07-15 12:45:03.589187','2024-07-15 12:45:04.138028',548,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8386,'sync-metabase-metadata',2,'2024-07-15 12:45:04.146102','2024-07-15 12:45:04.155140',9,'{}','success'),(8387,'sync-table-privileges',2,'2024-07-15 12:45:04.163782','2024-07-15 12:45:04.172191',8,NULL,'success'),(8388,'analyze',2,'2024-07-15 12:45:04.208429','2024-07-15 12:45:06.257014',2048,NULL,'success'),(8389,'fingerprint-fields',2,'2024-07-15 12:45:04.217402','2024-07-15 12:45:06.112092',1894,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8390,'classify-fields',2,'2024-07-15 12:45:06.120448','2024-07-15 12:45:06.225332',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8391,'classify-tables',2,'2024-07-15 12:45:06.232740','2024-07-15 12:45:06.248337',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8392,'field values scanning',2,'2024-07-15 13:00:00.050559','2024-07-15 13:00:04.521028',4470,NULL,'success'),(8393,'delete-expired-advanced-field-values',2,'2024-07-15 13:00:00.061926','2024-07-15 13:00:03.050657',2988,'{\"deleted\":0}','success'),(8394,'update-field-values',2,'2024-07-15 13:00:03.059181','2024-07-15 13:00:04.512630',1453,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(8395,'sync',2,'2024-07-15 13:45:00.104102','2024-07-15 13:45:04.235526',4131,NULL,'success'),(8396,'sync-dbms-version',2,'2024-07-15 13:45:00.116229','2024-07-15 13:45:00.125952',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8397,'sync-timezone',2,'2024-07-15 13:45:00.135312','2024-07-15 13:45:00.145229',9,'{\"timezone-id\":\"+08:00\"}','success'),(8398,'sync-tables',2,'2024-07-15 13:45:00.155026','2024-07-15 13:45:00.183766',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8399,'sync-fields',2,'2024-07-15 13:45:00.192124','2024-07-15 13:45:03.036270',2844,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8400,'sync-fks',2,'2024-07-15 13:45:03.044655','2024-07-15 13:45:03.663715',619,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8401,'sync-indexes',2,'2024-07-15 13:45:03.672238','2024-07-15 13:45:04.193859',521,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8402,'sync-metabase-metadata',2,'2024-07-15 13:45:04.202189','2024-07-15 13:45:04.209943',7,'{}','success'),(8403,'sync-table-privileges',2,'2024-07-15 13:45:04.218642','2024-07-15 13:45:04.227155',8,NULL,'success'),(8404,'analyze',2,'2024-07-15 13:45:04.262613','2024-07-15 13:45:06.344973',2082,NULL,'success'),(8405,'fingerprint-fields',2,'2024-07-15 13:45:04.270830','2024-07-15 13:45:06.211188',1940,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8406,'classify-fields',2,'2024-07-15 13:45:06.219442','2024-07-15 13:45:06.317093',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8407,'classify-tables',2,'2024-07-15 13:45:06.324256','2024-07-15 13:45:06.337310',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8408,'sync',2,'2024-07-15 14:45:00.105522','2024-07-15 14:45:04.390324',4284,NULL,'success'),(8409,'sync-dbms-version',2,'2024-07-15 14:45:00.116205','2024-07-15 14:45:00.126965',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8410,'sync-timezone',2,'2024-07-15 14:45:00.136612','2024-07-15 14:45:00.147266',10,'{\"timezone-id\":\"+08:00\"}','success'),(8411,'sync-tables',2,'2024-07-15 14:45:00.155954','2024-07-15 14:45:00.183750',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8412,'sync-fields',2,'2024-07-15 14:45:00.192563','2024-07-15 14:45:03.143599',2951,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8413,'sync-fks',2,'2024-07-15 14:45:03.151799','2024-07-15 14:45:03.785867',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8414,'sync-indexes',2,'2024-07-15 14:45:03.794599','2024-07-15 14:45:04.349904',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8415,'sync-metabase-metadata',2,'2024-07-15 14:45:04.357603','2024-07-15 14:45:04.365460',7,'{}','success'),(8416,'sync-table-privileges',2,'2024-07-15 14:45:04.373546','2024-07-15 14:45:04.382631',9,NULL,'success'),(8417,'analyze',2,'2024-07-15 14:45:04.415492','2024-07-15 14:45:06.381266',1965,NULL,'success'),(8418,'fingerprint-fields',2,'2024-07-15 14:45:04.423402','2024-07-15 14:45:06.224259',1800,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8419,'classify-fields',2,'2024-07-15 14:45:06.232617','2024-07-15 14:45:06.348024',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8420,'classify-tables',2,'2024-07-15 14:45:06.356738','2024-07-15 14:45:06.371091',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8421,'sync',2,'2024-07-15 15:45:00.107422','2024-07-15 15:45:04.350189',4242,NULL,'success'),(8422,'sync-dbms-version',2,'2024-07-15 15:45:00.115134','2024-07-15 15:45:00.124384',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8423,'sync-timezone',2,'2024-07-15 15:45:00.133644','2024-07-15 15:45:00.143152',9,'{\"timezone-id\":\"+08:00\"}','success'),(8424,'sync-tables',2,'2024-07-15 15:45:00.151304','2024-07-15 15:45:00.176569',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8425,'sync-fields',2,'2024-07-15 15:45:00.185694','2024-07-15 15:45:03.168046',2982,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8426,'sync-fks',2,'2024-07-15 15:45:03.175563','2024-07-15 15:45:03.794360',618,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8427,'sync-indexes',2,'2024-07-15 15:45:03.802735','2024-07-15 15:45:04.306935',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8428,'sync-metabase-metadata',2,'2024-07-15 15:45:04.314370','2024-07-15 15:45:04.323342',8,'{}','success'),(8429,'sync-table-privileges',2,'2024-07-15 15:45:04.332286','2024-07-15 15:45:04.341206',8,NULL,'success'),(8430,'analyze',2,'2024-07-15 15:45:04.375046','2024-07-15 15:45:06.465716',2090,NULL,'success'),(8431,'fingerprint-fields',2,'2024-07-15 15:45:04.382911','2024-07-15 15:45:06.291242',1908,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8432,'classify-fields',2,'2024-07-15 15:45:06.299931','2024-07-15 15:45:06.427998',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8433,'classify-tables',2,'2024-07-15 15:45:06.443379','2024-07-15 15:45:06.457383',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8434,'task-history-cleanup',NULL,'2024-07-15 16:00:00.020011','2024-07-15 16:00:00.071270',51,NULL,'success'),(8435,'task-history-cleanup',NULL,'2024-07-15 16:00:00.084166','2024-07-15 16:00:00.096518',12,NULL,'success'),(8436,'sync',2,'2024-07-15 16:45:00.098389','2024-07-15 16:45:04.455462',4357,NULL,'success'),(8437,'sync-dbms-version',2,'2024-07-15 16:45:00.111659','2024-07-15 16:45:00.121235',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8438,'sync-timezone',2,'2024-07-15 16:45:00.130263','2024-07-15 16:45:00.140567',10,'{\"timezone-id\":\"+08:00\"}','success'),(8439,'sync-tables',2,'2024-07-15 16:45:00.150942','2024-07-15 16:45:00.181041',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8440,'sync-fields',2,'2024-07-15 16:45:00.190092','2024-07-15 16:45:03.234364',3044,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8441,'sync-fks',2,'2024-07-15 16:45:03.243096','2024-07-15 16:45:03.877933',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8442,'sync-indexes',2,'2024-07-15 16:45:03.886100','2024-07-15 16:45:04.412718',526,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8443,'sync-metabase-metadata',2,'2024-07-15 16:45:04.420193','2024-07-15 16:45:04.428706',8,'{}','success'),(8444,'sync-table-privileges',2,'2024-07-15 16:45:04.437538','2024-07-15 16:45:04.446712',9,NULL,'success'),(8445,'analyze',2,'2024-07-15 16:45:04.481336','2024-07-15 16:45:06.623437',2142,NULL,'success'),(8446,'fingerprint-fields',2,'2024-07-15 16:45:04.490540','2024-07-15 16:45:06.471868',1981,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8447,'classify-fields',2,'2024-07-15 16:45:06.480610','2024-07-15 16:45:06.595082',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8448,'classify-tables',2,'2024-07-15 16:45:06.602796','2024-07-15 16:45:06.615451',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8449,'sync',2,'2024-07-15 17:45:00.090836','2024-07-15 17:45:04.475219',4384,NULL,'success'),(8450,'sync-dbms-version',2,'2024-07-15 17:45:00.100252','2024-07-15 17:45:00.109001',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8451,'sync-timezone',2,'2024-07-15 17:45:00.116593','2024-07-15 17:45:00.124527',7,'{\"timezone-id\":\"+08:00\"}','success'),(8452,'sync-tables',2,'2024-07-15 17:45:00.132376','2024-07-15 17:45:00.157002',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8453,'sync-fields',2,'2024-07-15 17:45:00.165131','2024-07-15 17:45:03.196825',3031,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8454,'sync-fks',2,'2024-07-15 17:45:03.204726','2024-07-15 17:45:03.855777',651,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8455,'sync-indexes',2,'2024-07-15 17:45:03.864699','2024-07-15 17:45:04.434339',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8456,'sync-metabase-metadata',2,'2024-07-15 17:45:04.441822','2024-07-15 17:45:04.449817',7,'{}','success'),(8457,'sync-table-privileges',2,'2024-07-15 17:45:04.458547','2024-07-15 17:45:04.466916',8,NULL,'success'),(8458,'analyze',2,'2024-07-15 17:45:04.499262','2024-07-15 17:45:06.483518',1984,NULL,'success'),(8459,'fingerprint-fields',2,'2024-07-15 17:45:04.507212','2024-07-15 17:45:06.309968',1802,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8460,'classify-fields',2,'2024-07-15 17:45:06.317398','2024-07-15 17:45:06.449364',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8461,'classify-tables',2,'2024-07-15 17:45:06.459687','2024-07-15 17:45:06.474308',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8462,'sync',2,'2024-07-15 18:45:00.102050','2024-07-15 18:45:04.678692',4576,NULL,'success'),(8463,'sync-dbms-version',2,'2024-07-15 18:45:00.110506','2024-07-15 18:45:00.119815',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8464,'sync-timezone',2,'2024-07-15 18:45:00.128140','2024-07-15 18:45:00.137256',9,'{\"timezone-id\":\"+08:00\"}','success'),(8465,'sync-tables',2,'2024-07-15 18:45:00.145753','2024-07-15 18:45:00.172888',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8466,'sync-fields',2,'2024-07-15 18:45:00.181606','2024-07-15 18:45:03.318243',3136,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8467,'sync-fks',2,'2024-07-15 18:45:03.326982','2024-07-15 18:45:04.041460',714,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8468,'sync-indexes',2,'2024-07-15 18:45:04.050335','2024-07-15 18:45:04.635404',585,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8469,'sync-metabase-metadata',2,'2024-07-15 18:45:04.642734','2024-07-15 18:45:04.652009',9,'{}','success'),(8470,'sync-table-privileges',2,'2024-07-15 18:45:04.660682','2024-07-15 18:45:04.670142',9,NULL,'success'),(8471,'analyze',2,'2024-07-15 18:45:04.706736','2024-07-15 18:45:07.121056',2414,NULL,'success'),(8472,'fingerprint-fields',2,'2024-07-15 18:45:04.715915','2024-07-15 18:45:06.946248',2230,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8473,'classify-fields',2,'2024-07-15 18:45:06.955779','2024-07-15 18:45:07.087217',131,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8474,'classify-tables',2,'2024-07-15 18:45:07.096743','2024-07-15 18:45:07.112206',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8475,'sync',2,'2024-07-15 19:45:00.098781','2024-07-15 19:45:04.797072',4698,NULL,'success'),(8476,'sync-dbms-version',2,'2024-07-15 19:45:00.107072','2024-07-15 19:45:00.115790',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8477,'sync-timezone',2,'2024-07-15 19:45:00.124294','2024-07-15 19:45:00.134730',10,'{\"timezone-id\":\"+08:00\"}','success'),(8478,'sync-tables',2,'2024-07-15 19:45:00.143365','2024-07-15 19:45:00.168034',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8479,'sync-fields',2,'2024-07-15 19:45:00.176536','2024-07-15 19:45:03.484483',3307,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8480,'sync-fks',2,'2024-07-15 19:45:03.493471','2024-07-15 19:45:04.202800',709,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8481,'sync-indexes',2,'2024-07-15 19:45:04.211880','2024-07-15 19:45:04.751432',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8482,'sync-metabase-metadata',2,'2024-07-15 19:45:04.760867','2024-07-15 19:45:04.769851',8,'{}','success'),(8483,'sync-table-privileges',2,'2024-07-15 19:45:04.778810','2024-07-15 19:45:04.788259',9,NULL,'success'),(8484,'analyze',2,'2024-07-15 19:45:04.821615','2024-07-15 19:45:07.025360',2203,NULL,'success'),(8485,'fingerprint-fields',2,'2024-07-15 19:45:04.830532','2024-07-15 19:45:06.852998',2022,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8486,'classify-fields',2,'2024-07-15 19:45:06.862517','2024-07-15 19:45:06.992872',130,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8487,'classify-tables',2,'2024-07-15 19:45:07.000509','2024-07-15 19:45:07.016122',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8488,'sync',2,'2024-07-15 20:45:00.102877','2024-07-15 20:45:04.598349',4495,NULL,'success'),(8489,'sync-dbms-version',2,'2024-07-15 20:45:00.111014','2024-07-15 20:45:00.120173',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8490,'sync-timezone',2,'2024-07-15 20:45:00.128654','2024-07-15 20:45:00.138948',10,'{\"timezone-id\":\"+08:00\"}','success'),(8491,'sync-tables',2,'2024-07-15 20:45:00.147658','2024-07-15 20:45:00.178600',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8492,'sync-fields',2,'2024-07-15 20:45:00.194854','2024-07-15 20:45:03.335157',3140,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8493,'sync-fks',2,'2024-07-15 20:45:03.344924','2024-07-15 20:45:03.979545',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8494,'sync-indexes',2,'2024-07-15 20:45:03.989060','2024-07-15 20:45:04.558041',568,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8495,'sync-metabase-metadata',2,'2024-07-15 20:45:04.565200','2024-07-15 20:45:04.573027',7,'{}','success'),(8496,'sync-table-privileges',2,'2024-07-15 20:45:04.581738','2024-07-15 20:45:04.589918',8,NULL,'success'),(8497,'analyze',2,'2024-07-15 20:45:04.622828','2024-07-15 20:45:06.684004',2061,NULL,'success'),(8498,'fingerprint-fields',2,'2024-07-15 20:45:04.632029','2024-07-15 20:45:06.535064',1903,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8499,'classify-fields',2,'2024-07-15 20:45:06.543761','2024-07-15 20:45:06.653564',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8500,'classify-tables',2,'2024-07-15 20:45:06.661263','2024-07-15 20:45:06.675507',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8501,'sync',2,'2024-07-15 21:45:00.095978','2024-07-15 21:45:04.510092',4414,NULL,'success'),(8502,'sync-dbms-version',2,'2024-07-15 21:45:00.106699','2024-07-15 21:45:00.116367',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8503,'sync-timezone',2,'2024-07-15 21:45:00.125137','2024-07-15 21:45:00.136400',11,'{\"timezone-id\":\"+08:00\"}','success'),(8504,'sync-tables',2,'2024-07-15 21:45:00.146935','2024-07-15 21:45:00.173743',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8505,'sync-fields',2,'2024-07-15 21:45:00.182867','2024-07-15 21:45:03.259459',3076,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8506,'sync-fks',2,'2024-07-15 21:45:03.268796','2024-07-15 21:45:03.903355',634,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8507,'sync-indexes',2,'2024-07-15 21:45:03.912009','2024-07-15 21:45:04.464149',552,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8508,'sync-metabase-metadata',2,'2024-07-15 21:45:04.472219','2024-07-15 21:45:04.482233',10,'{}','success'),(8509,'sync-table-privileges',2,'2024-07-15 21:45:04.490461','2024-07-15 21:45:04.498978',8,NULL,'success'),(8510,'analyze',2,'2024-07-15 21:45:04.534977','2024-07-15 21:45:06.568376',2033,NULL,'success'),(8511,'fingerprint-fields',2,'2024-07-15 21:45:04.542912','2024-07-15 21:45:06.427777',1884,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8512,'classify-fields',2,'2024-07-15 21:45:06.435678','2024-07-15 21:45:06.538964',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8513,'classify-tables',2,'2024-07-15 21:45:06.546628','2024-07-15 21:45:06.559936',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8514,'sync',2,'2024-07-15 22:45:00.104038','2024-07-15 22:45:04.626593',4522,NULL,'success'),(8515,'sync-dbms-version',2,'2024-07-15 22:45:00.126347','2024-07-15 22:45:00.136961',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8516,'sync-timezone',2,'2024-07-15 22:45:00.146357','2024-07-15 22:45:00.156738',10,'{\"timezone-id\":\"+08:00\"}','success'),(8517,'sync-tables',2,'2024-07-15 22:45:00.165276','2024-07-15 22:45:00.195276',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8518,'sync-fields',2,'2024-07-15 22:45:00.205464','2024-07-15 22:45:03.403805',3198,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8519,'sync-fks',2,'2024-07-15 22:45:03.412222','2024-07-15 22:45:04.024096',611,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8520,'sync-indexes',2,'2024-07-15 22:45:04.032216','2024-07-15 22:45:04.582710',550,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8521,'sync-metabase-metadata',2,'2024-07-15 22:45:04.592378','2024-07-15 22:45:04.600649',8,'{}','success'),(8522,'sync-table-privileges',2,'2024-07-15 22:45:04.608842','2024-07-15 22:45:04.617104',8,NULL,'success'),(8523,'analyze',2,'2024-07-15 22:45:04.652000','2024-07-15 22:45:06.690477',2038,NULL,'success'),(8524,'fingerprint-fields',2,'2024-07-15 22:45:04.660088','2024-07-15 22:45:06.537534',1877,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8525,'classify-fields',2,'2024-07-15 22:45:06.546362','2024-07-15 22:45:06.658803',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8526,'classify-tables',2,'2024-07-15 22:45:06.667390','2024-07-15 22:45:06.681874',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8527,'sync',2,'2024-07-15 23:45:00.109841','2024-07-15 23:45:04.192325',4082,NULL,'success'),(8528,'sync-dbms-version',2,'2024-07-15 23:45:00.118455','2024-07-15 23:45:00.127678',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8529,'sync-timezone',2,'2024-07-15 23:45:00.136518','2024-07-15 23:45:00.145931',9,'{\"timezone-id\":\"+08:00\"}','success'),(8530,'sync-tables',2,'2024-07-15 23:45:00.153988','2024-07-15 23:45:00.180105',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8531,'sync-fields',2,'2024-07-15 23:45:00.188089','2024-07-15 23:45:03.055807',2867,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8532,'sync-fks',2,'2024-07-15 23:45:03.063497','2024-07-15 23:45:03.671494',608,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8533,'sync-indexes',2,'2024-07-15 23:45:03.679947','2024-07-15 23:45:04.149431',469,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8534,'sync-metabase-metadata',2,'2024-07-15 23:45:04.156999','2024-07-15 23:45:04.165100',8,'{}','success'),(8535,'sync-table-privileges',2,'2024-07-15 23:45:04.175105','2024-07-15 23:45:04.184015',8,NULL,'success'),(8536,'analyze',2,'2024-07-15 23:45:04.224790','2024-07-15 23:45:06.065436',1840,NULL,'success'),(8537,'fingerprint-fields',2,'2024-07-15 23:45:04.233460','2024-07-15 23:45:05.923315',1689,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8538,'classify-fields',2,'2024-07-15 23:45:05.931313','2024-07-15 23:45:06.037151',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8539,'classify-tables',2,'2024-07-15 23:45:06.044404','2024-07-15 23:45:06.057303',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8540,'sync',2,'2024-07-16 00:45:00.103252','2024-07-16 00:45:04.695784',4592,NULL,'success'),(8541,'sync-dbms-version',2,'2024-07-16 00:45:00.112272','2024-07-16 00:45:00.122135',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8542,'sync-timezone',2,'2024-07-16 00:45:00.130566','2024-07-16 00:45:00.140781',10,'{\"timezone-id\":\"+08:00\"}','success'),(8543,'sync-tables',2,'2024-07-16 00:45:00.149514','2024-07-16 00:45:00.177477',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8544,'sync-fields',2,'2024-07-16 00:45:00.186177','2024-07-16 00:45:03.285032',3098,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8545,'sync-fks',2,'2024-07-16 00:45:03.292976','2024-07-16 00:45:03.954566',661,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8546,'sync-indexes',2,'2024-07-16 00:45:03.962829','2024-07-16 00:45:04.652407',689,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8547,'sync-metabase-metadata',2,'2024-07-16 00:45:04.662281','2024-07-16 00:45:04.671098',8,'{}','success'),(8548,'sync-table-privileges',2,'2024-07-16 00:45:04.679500','2024-07-16 00:45:04.687885',8,NULL,'success'),(8549,'analyze',2,'2024-07-16 00:45:04.719442','2024-07-16 00:45:06.843066',2123,NULL,'success'),(8550,'fingerprint-fields',2,'2024-07-16 00:45:04.727081','2024-07-16 00:45:06.682440',1955,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8551,'classify-fields',2,'2024-07-16 00:45:06.691072','2024-07-16 00:45:06.810513',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8552,'classify-tables',2,'2024-07-16 00:45:06.818074','2024-07-16 00:45:06.834283',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8553,'sync',2,'2024-07-16 01:45:00.113780','2024-07-16 01:45:04.844915',4731,NULL,'success'),(8554,'sync-dbms-version',2,'2024-07-16 01:45:00.123668','2024-07-16 01:45:00.135441',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8555,'sync-timezone',2,'2024-07-16 01:45:00.145572','2024-07-16 01:45:00.157497',11,'{\"timezone-id\":\"+08:00\"}','success'),(8556,'sync-tables',2,'2024-07-16 01:45:00.167773','2024-07-16 01:45:00.199150',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8557,'sync-fields',2,'2024-07-16 01:45:00.209871','2024-07-16 01:45:03.475496',3265,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8558,'sync-fks',2,'2024-07-16 01:45:03.483050','2024-07-16 01:45:04.157483',674,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8559,'sync-indexes',2,'2024-07-16 01:45:04.167083','2024-07-16 01:45:04.800293',633,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8560,'sync-metabase-metadata',2,'2024-07-16 01:45:04.809209','2024-07-16 01:45:04.818910',9,'{}','success'),(8561,'sync-table-privileges',2,'2024-07-16 01:45:04.828284','2024-07-16 01:45:04.836287',8,NULL,'success'),(8562,'analyze',2,'2024-07-16 01:45:04.869965','2024-07-16 01:45:07.066447',2196,NULL,'success'),(8563,'fingerprint-fields',2,'2024-07-16 01:45:04.879506','2024-07-16 01:45:06.916473',2036,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8564,'classify-fields',2,'2024-07-16 01:45:06.925286','2024-07-16 01:45:07.035275',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8565,'classify-tables',2,'2024-07-16 01:45:07.043781','2024-07-16 01:45:07.058211',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8566,'sync',2,'2024-07-16 02:45:00.092944','2024-07-16 02:45:04.435156',4342,NULL,'success'),(8567,'sync-dbms-version',2,'2024-07-16 02:45:00.101126','2024-07-16 02:45:00.109906',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8568,'sync-timezone',2,'2024-07-16 02:45:00.117868','2024-07-16 02:45:00.127313',9,'{\"timezone-id\":\"+08:00\"}','success'),(8569,'sync-tables',2,'2024-07-16 02:45:00.135307','2024-07-16 02:45:00.162207',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8570,'sync-fields',2,'2024-07-16 02:45:00.170919','2024-07-16 02:45:03.261023',3090,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8571,'sync-fks',2,'2024-07-16 02:45:03.269473','2024-07-16 02:45:03.883021',613,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8572,'sync-indexes',2,'2024-07-16 02:45:03.892213','2024-07-16 02:45:04.393943',501,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8573,'sync-metabase-metadata',2,'2024-07-16 02:45:04.400952','2024-07-16 02:45:04.408420',7,'{}','success'),(8574,'sync-table-privileges',2,'2024-07-16 02:45:04.417738','2024-07-16 02:45:04.426919',9,NULL,'success'),(8575,'analyze',2,'2024-07-16 02:45:04.462825','2024-07-16 02:45:06.450403',1987,NULL,'success'),(8576,'fingerprint-fields',2,'2024-07-16 02:45:04.471502','2024-07-16 02:45:06.296290',1824,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8577,'classify-fields',2,'2024-07-16 02:45:06.304363','2024-07-16 02:45:06.419236',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8578,'classify-tables',2,'2024-07-16 02:45:06.427077','2024-07-16 02:45:06.441616',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8579,'sync',2,'2024-07-16 03:45:00.115917','2024-07-16 03:45:04.677415',4561,NULL,'success'),(8580,'sync-dbms-version',2,'2024-07-16 03:45:00.125112','2024-07-16 03:45:00.135156',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8581,'sync-timezone',2,'2024-07-16 03:45:00.145078','2024-07-16 03:45:00.157038',11,'{\"timezone-id\":\"+08:00\"}','success'),(8582,'sync-tables',2,'2024-07-16 03:45:00.165884','2024-07-16 03:45:00.195164',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8583,'sync-fields',2,'2024-07-16 03:45:00.204887','2024-07-16 03:45:03.418294',3213,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8584,'sync-fks',2,'2024-07-16 03:45:03.428361','2024-07-16 03:45:04.050168',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8585,'sync-indexes',2,'2024-07-16 03:45:04.059440','2024-07-16 03:45:04.634129',574,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8586,'sync-metabase-metadata',2,'2024-07-16 03:45:04.641390','2024-07-16 03:45:04.650254',8,'{}','success'),(8587,'sync-table-privileges',2,'2024-07-16 03:45:04.658996','2024-07-16 03:45:04.669361',10,NULL,'success'),(8588,'analyze',2,'2024-07-16 03:45:04.703072','2024-07-16 03:45:06.855518',2152,NULL,'success'),(8589,'fingerprint-fields',2,'2024-07-16 03:45:04.710981','2024-07-16 03:45:06.691188',1980,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8590,'classify-fields',2,'2024-07-16 03:45:06.700024','2024-07-16 03:45:06.823127',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8591,'classify-tables',2,'2024-07-16 03:45:06.831512','2024-07-16 03:45:06.845974',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8592,'task-history-cleanup',NULL,'2024-07-16 04:00:00.068344','2024-07-16 04:00:00.102019',33,NULL,'success'),(8593,'sync',2,'2024-07-16 04:45:00.106181','2024-07-16 04:45:04.834052',4727,NULL,'success'),(8594,'sync-dbms-version',2,'2024-07-16 04:45:00.115945','2024-07-16 04:45:00.126191',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8595,'sync-timezone',2,'2024-07-16 04:45:00.135305','2024-07-16 04:45:00.147800',12,'{\"timezone-id\":\"+08:00\"}','success'),(8596,'sync-tables',2,'2024-07-16 04:45:00.156845','2024-07-16 04:45:00.189687',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8597,'sync-fields',2,'2024-07-16 04:45:00.199391','2024-07-16 04:45:03.431685',3232,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8598,'sync-fks',2,'2024-07-16 04:45:03.439828','2024-07-16 04:45:04.120930',681,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8599,'sync-indexes',2,'2024-07-16 04:45:04.130842','2024-07-16 04:45:04.788233',657,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8600,'sync-metabase-metadata',2,'2024-07-16 04:45:04.797409','2024-07-16 04:45:04.807272',9,'{}','success'),(8601,'sync-table-privileges',2,'2024-07-16 04:45:04.815921','2024-07-16 04:45:04.825204',9,NULL,'success'),(8602,'analyze',2,'2024-07-16 04:45:04.859545','2024-07-16 04:45:07.055068',2195,NULL,'success'),(8603,'fingerprint-fields',2,'2024-07-16 04:45:04.867932','2024-07-16 04:45:06.877886',2009,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8604,'classify-fields',2,'2024-07-16 04:45:06.886257','2024-07-16 04:45:07.018948',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8605,'classify-tables',2,'2024-07-16 04:45:07.028090','2024-07-16 04:45:07.044735',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8606,'sync',2,'2024-07-16 05:45:00.112711','2024-07-16 05:45:04.539558',4426,NULL,'success'),(8607,'sync-dbms-version',2,'2024-07-16 05:45:00.121947','2024-07-16 05:45:00.132037',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8608,'sync-timezone',2,'2024-07-16 05:45:00.141433','2024-07-16 05:45:00.152102',10,'{\"timezone-id\":\"+08:00\"}','success'),(8609,'sync-tables',2,'2024-07-16 05:45:00.161474','2024-07-16 05:45:00.193221',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8610,'sync-fields',2,'2024-07-16 05:45:00.204205','2024-07-16 05:45:03.292103',3087,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8611,'sync-fks',2,'2024-07-16 05:45:03.300132','2024-07-16 05:45:03.941128',640,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8612,'sync-indexes',2,'2024-07-16 05:45:03.950056','2024-07-16 05:45:04.491775',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8613,'sync-metabase-metadata',2,'2024-07-16 05:45:04.500238','2024-07-16 05:45:04.511215',10,'{}','success'),(8614,'sync-table-privileges',2,'2024-07-16 05:45:04.520231','2024-07-16 05:45:04.531247',11,NULL,'success'),(8615,'analyze',2,'2024-07-16 05:45:04.567288','2024-07-16 05:45:06.610515',2043,NULL,'success'),(8616,'fingerprint-fields',2,'2024-07-16 05:45:04.575474','2024-07-16 05:45:06.461415',1885,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8617,'classify-fields',2,'2024-07-16 05:45:06.469928','2024-07-16 05:45:06.580198',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8618,'classify-tables',2,'2024-07-16 05:45:06.587880','2024-07-16 05:45:06.602013',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8619,'sync',2,'2024-07-16 06:45:00.097812','2024-07-16 06:45:05.223468',5125,NULL,'success'),(8620,'sync-dbms-version',2,'2024-07-16 06:45:00.105866','2024-07-16 06:45:00.114206',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8621,'sync-timezone',2,'2024-07-16 06:45:00.122964','2024-07-16 06:45:00.134287',11,'{\"timezone-id\":\"+08:00\"}','success'),(8622,'sync-tables',2,'2024-07-16 06:45:00.142894','2024-07-16 06:45:00.172423',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8623,'sync-fields',2,'2024-07-16 06:45:00.181575','2024-07-16 06:45:03.239676',3058,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8624,'sync-fks',2,'2024-07-16 06:45:03.247885','2024-07-16 06:45:03.875100',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8625,'sync-indexes',2,'2024-07-16 06:45:03.883820','2024-07-16 06:45:05.177915',1294,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8626,'sync-metabase-metadata',2,'2024-07-16 06:45:05.186039','2024-07-16 06:45:05.197268',11,'{}','success'),(8627,'sync-table-privileges',2,'2024-07-16 06:45:05.206670','2024-07-16 06:45:05.215039',8,NULL,'success'),(8628,'analyze',2,'2024-07-16 06:45:05.247675','2024-07-16 06:45:07.255615',2007,NULL,'success'),(8629,'fingerprint-fields',2,'2024-07-16 06:45:05.255788','2024-07-16 06:45:07.114416',1858,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8630,'classify-fields',2,'2024-07-16 06:45:07.122499','2024-07-16 06:45:07.226970',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8631,'classify-tables',2,'2024-07-16 06:45:07.234067','2024-07-16 06:45:07.247308',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8632,'sync',2,'2024-07-16 07:45:00.099217','2024-07-16 07:45:04.350733',4251,NULL,'success'),(8633,'sync-dbms-version',2,'2024-07-16 07:45:00.108245','2024-07-16 07:45:00.119420',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8634,'sync-timezone',2,'2024-07-16 07:45:00.128702','2024-07-16 07:45:00.139600',10,'{\"timezone-id\":\"+08:00\"}','success'),(8635,'sync-tables',2,'2024-07-16 07:45:00.151916','2024-07-16 07:45:00.181088',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8636,'sync-fields',2,'2024-07-16 07:45:00.197773','2024-07-16 07:45:03.199343',3001,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8637,'sync-fks',2,'2024-07-16 07:45:03.208299','2024-07-16 07:45:03.836005',627,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8638,'sync-indexes',2,'2024-07-16 07:45:03.843617','2024-07-16 07:45:04.311318',467,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8639,'sync-metabase-metadata',2,'2024-07-16 07:45:04.319026','2024-07-16 07:45:04.327193',8,'{}','success'),(8640,'sync-table-privileges',2,'2024-07-16 07:45:04.335210','2024-07-16 07:45:04.342605',7,NULL,'success'),(8641,'analyze',2,'2024-07-16 07:45:04.373898','2024-07-16 07:45:06.458512',2084,NULL,'success'),(8642,'fingerprint-fields',2,'2024-07-16 07:45:04.382059','2024-07-16 07:45:06.307039',1924,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8643,'classify-fields',2,'2024-07-16 07:45:06.315203','2024-07-16 07:45:06.428697',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8644,'classify-tables',2,'2024-07-16 07:45:06.436220','2024-07-16 07:45:06.449762',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8645,'sync',2,'2024-07-16 08:45:00.094295','2024-07-16 08:45:04.498850',4404,NULL,'success'),(8646,'sync-dbms-version',2,'2024-07-16 08:45:00.102511','2024-07-16 08:45:00.111800',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8647,'sync-timezone',2,'2024-07-16 08:45:00.121387','2024-07-16 08:45:00.133091',11,'{\"timezone-id\":\"+08:00\"}','success'),(8648,'sync-tables',2,'2024-07-16 08:45:00.142314','2024-07-16 08:45:00.173434',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8649,'sync-fields',2,'2024-07-16 08:45:00.182614','2024-07-16 08:45:03.242144',3059,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8650,'sync-fks',2,'2024-07-16 08:45:03.250182','2024-07-16 08:45:03.907325',657,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8651,'sync-indexes',2,'2024-07-16 08:45:03.915550','2024-07-16 08:45:04.455148',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8652,'sync-metabase-metadata',2,'2024-07-16 08:45:04.466060','2024-07-16 08:45:04.474399',8,'{}','success'),(8653,'sync-table-privileges',2,'2024-07-16 08:45:04.482791','2024-07-16 08:45:04.490515',7,NULL,'success'),(8654,'analyze',2,'2024-07-16 08:45:04.524010','2024-07-16 08:45:06.526044',2002,NULL,'success'),(8655,'fingerprint-fields',2,'2024-07-16 08:45:04.531996','2024-07-16 08:45:06.374659',1842,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8656,'classify-fields',2,'2024-07-16 08:45:06.382726','2024-07-16 08:45:06.495044',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8657,'classify-tables',2,'2024-07-16 08:45:06.502717','2024-07-16 08:45:06.518030',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8658,'sync',2,'2024-07-16 09:45:00.092238','2024-07-16 09:45:04.152301',4060,NULL,'success'),(8659,'sync-dbms-version',2,'2024-07-16 09:45:00.101835','2024-07-16 09:45:00.110695',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8660,'sync-timezone',2,'2024-07-16 09:45:00.118526','2024-07-16 09:45:00.127991',9,'{\"timezone-id\":\"+08:00\"}','success'),(8661,'sync-tables',2,'2024-07-16 09:45:00.136071','2024-07-16 09:45:00.166121',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8662,'sync-fields',2,'2024-07-16 09:45:00.175668','2024-07-16 09:45:03.006543',2830,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8663,'sync-fks',2,'2024-07-16 09:45:03.014440','2024-07-16 09:45:03.609832',595,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8664,'sync-indexes',2,'2024-07-16 09:45:03.618246','2024-07-16 09:45:04.107798',489,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8665,'sync-metabase-metadata',2,'2024-07-16 09:45:04.115957','2024-07-16 09:45:04.125787',9,'{}','success'),(8666,'sync-table-privileges',2,'2024-07-16 09:45:04.135485','2024-07-16 09:45:04.144030',8,NULL,'success'),(8667,'analyze',2,'2024-07-16 09:45:04.175433','2024-07-16 09:45:06.246830',2071,NULL,'success'),(8668,'fingerprint-fields',2,'2024-07-16 09:45:04.183017','2024-07-16 09:45:06.091176',1908,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8669,'classify-fields',2,'2024-07-16 09:45:06.100037','2024-07-16 09:45:06.218124',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8670,'classify-tables',2,'2024-07-16 09:45:06.225523','2024-07-16 09:45:06.238552',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8671,'sync',2,'2024-07-16 10:45:00.086175','2024-07-16 10:45:04.237203',4151,NULL,'success'),(8672,'sync-dbms-version',2,'2024-07-16 10:45:00.094282','2024-07-16 10:45:00.102452',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8673,'sync-timezone',2,'2024-07-16 10:45:00.110171','2024-07-16 10:45:00.118834',8,'{\"timezone-id\":\"+08:00\"}','success'),(8674,'sync-tables',2,'2024-07-16 10:45:00.127439','2024-07-16 10:45:00.152120',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8675,'sync-fields',2,'2024-07-16 10:45:00.160040','2024-07-16 10:45:03.064934',2904,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8676,'sync-fks',2,'2024-07-16 10:45:03.076047','2024-07-16 10:45:03.699538',623,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8677,'sync-indexes',2,'2024-07-16 10:45:03.707075','2024-07-16 10:45:04.197002',489,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8678,'sync-metabase-metadata',2,'2024-07-16 10:45:04.204780','2024-07-16 10:45:04.213066',8,'{}','success'),(8679,'sync-table-privileges',2,'2024-07-16 10:45:04.221188','2024-07-16 10:45:04.229481',8,NULL,'success'),(8680,'analyze',2,'2024-07-16 10:45:04.262126','2024-07-16 10:45:06.253524',1991,NULL,'success'),(8681,'fingerprint-fields',2,'2024-07-16 10:45:04.269756','2024-07-16 10:45:06.109412',1839,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8682,'classify-fields',2,'2024-07-16 10:45:06.117083','2024-07-16 10:45:06.222794',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8683,'classify-tables',2,'2024-07-16 10:45:06.230535','2024-07-16 10:45:06.245006',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8684,'sync',2,'2024-07-16 11:45:00.090059','2024-07-16 11:45:04.225850',4135,NULL,'success'),(8685,'sync-dbms-version',2,'2024-07-16 11:45:00.098426','2024-07-16 11:45:00.108807',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8686,'sync-timezone',2,'2024-07-16 11:45:00.116740','2024-07-16 11:45:00.126191',9,'{\"timezone-id\":\"+08:00\"}','success'),(8687,'sync-tables',2,'2024-07-16 11:45:00.134100','2024-07-16 11:45:00.162132',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8688,'sync-fields',2,'2024-07-16 11:45:00.171163','2024-07-16 11:45:02.986606',2815,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8689,'sync-fks',2,'2024-07-16 11:45:02.994248','2024-07-16 11:45:03.601172',606,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8690,'sync-indexes',2,'2024-07-16 11:45:03.609613','2024-07-16 11:45:04.181647',572,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8691,'sync-metabase-metadata',2,'2024-07-16 11:45:04.190926','2024-07-16 11:45:04.201461',10,'{}','success'),(8692,'sync-table-privileges',2,'2024-07-16 11:45:04.210014','2024-07-16 11:45:04.218244',8,NULL,'success'),(8693,'analyze',2,'2024-07-16 11:45:04.252285','2024-07-16 11:45:06.235566',1983,NULL,'success'),(8694,'fingerprint-fields',2,'2024-07-16 11:45:04.260567','2024-07-16 11:45:06.070993',1810,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8695,'classify-fields',2,'2024-07-16 11:45:06.079518','2024-07-16 11:45:06.204043',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8696,'classify-tables',2,'2024-07-16 11:45:06.213128','2024-07-16 11:45:06.227356',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8697,'sync',2,'2024-07-16 12:45:00.088461','2024-07-16 12:45:04.130529',4042,NULL,'success'),(8698,'sync-dbms-version',2,'2024-07-16 12:45:00.096802','2024-07-16 12:45:00.105337',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8699,'sync-timezone',2,'2024-07-16 12:45:00.114746','2024-07-16 12:45:00.124335',9,'{\"timezone-id\":\"+08:00\"}','success'),(8700,'sync-tables',2,'2024-07-16 12:45:00.132408','2024-07-16 12:45:00.159748',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8701,'sync-fields',2,'2024-07-16 12:45:00.167348','2024-07-16 12:45:03.045933',2878,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8702,'sync-fks',2,'2024-07-16 12:45:03.054005','2024-07-16 12:45:03.629690',575,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8703,'sync-indexes',2,'2024-07-16 12:45:03.637556','2024-07-16 12:45:04.092356',454,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8704,'sync-metabase-metadata',2,'2024-07-16 12:45:04.099748','2024-07-16 12:45:04.107418',7,'{}','success'),(8705,'sync-table-privileges',2,'2024-07-16 12:45:04.115125','2024-07-16 12:45:04.122982',7,NULL,'success'),(8706,'analyze',2,'2024-07-16 12:45:04.154076','2024-07-16 12:45:06.155769',2001,NULL,'success'),(8707,'fingerprint-fields',2,'2024-07-16 12:45:04.161483','2024-07-16 12:45:06.000503',1839,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8708,'classify-fields',2,'2024-07-16 12:45:06.009043','2024-07-16 12:45:06.125811',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8709,'classify-tables',2,'2024-07-16 12:45:06.134086','2024-07-16 12:45:06.147357',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8710,'field values scanning',2,'2024-07-16 13:00:00.054878','2024-07-16 13:00:04.053439',3998,NULL,'success'),(8711,'delete-expired-advanced-field-values',2,'2024-07-16 13:00:00.065298','2024-07-16 13:00:02.752555',2687,'{\"deleted\":0}','success'),(8712,'update-field-values',2,'2024-07-16 13:00:02.759608','2024-07-16 13:00:04.045565',1285,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(8713,'sync',2,'2024-07-16 13:45:00.110229','2024-07-16 13:45:04.790124',4679,NULL,'success'),(8714,'sync-dbms-version',2,'2024-07-16 13:45:00.118546','2024-07-16 13:45:00.129044',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8715,'sync-timezone',2,'2024-07-16 13:45:00.137228','2024-07-16 13:45:00.148018',10,'{\"timezone-id\":\"+08:00\"}','success'),(8716,'sync-tables',2,'2024-07-16 13:45:00.156799','2024-07-16 13:45:00.188528',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8717,'sync-fields',2,'2024-07-16 13:45:00.197951','2024-07-16 13:45:03.549901',3351,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8718,'sync-fks',2,'2024-07-16 13:45:03.557705','2024-07-16 13:45:04.243840',686,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8719,'sync-indexes',2,'2024-07-16 13:45:04.252334','2024-07-16 13:45:04.748233',495,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8720,'sync-metabase-metadata',2,'2024-07-16 13:45:04.755777','2024-07-16 13:45:04.763942',8,'{}','success'),(8721,'sync-table-privileges',2,'2024-07-16 13:45:04.773261','2024-07-16 13:45:04.781930',8,NULL,'success'),(8722,'analyze',2,'2024-07-16 13:45:04.813702','2024-07-16 13:45:06.949314',2135,NULL,'success'),(8723,'fingerprint-fields',2,'2024-07-16 13:45:04.821654','2024-07-16 13:45:06.794432',1972,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8724,'classify-fields',2,'2024-07-16 13:45:06.802194','2024-07-16 13:45:06.919931',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8725,'classify-tables',2,'2024-07-16 13:45:06.927201','2024-07-16 13:45:06.940947',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8726,'sync',2,'2024-07-16 14:45:00.097466','2024-07-16 14:45:04.206286',4108,NULL,'success'),(8727,'sync-dbms-version',2,'2024-07-16 14:45:00.105702','2024-07-16 14:45:00.114442',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8728,'sync-timezone',2,'2024-07-16 14:45:00.123182','2024-07-16 14:45:00.132280',9,'{\"timezone-id\":\"+08:00\"}','success'),(8729,'sync-tables',2,'2024-07-16 14:45:00.141489','2024-07-16 14:45:00.167472',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8730,'sync-fields',2,'2024-07-16 14:45:00.175993','2024-07-16 14:45:03.097794',2921,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8731,'sync-fks',2,'2024-07-16 14:45:03.106896','2024-07-16 14:45:03.687921',581,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8732,'sync-indexes',2,'2024-07-16 14:45:03.698157','2024-07-16 14:45:04.168852',470,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8733,'sync-metabase-metadata',2,'2024-07-16 14:45:04.175866','2024-07-16 14:45:04.183107',7,'{}','success'),(8734,'sync-table-privileges',2,'2024-07-16 14:45:04.191526','2024-07-16 14:45:04.198838',7,NULL,'success'),(8735,'analyze',2,'2024-07-16 14:45:04.230362','2024-07-16 14:45:06.157335',1926,NULL,'success'),(8736,'fingerprint-fields',2,'2024-07-16 14:45:04.237888','2024-07-16 14:45:06.013208',1775,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8737,'classify-fields',2,'2024-07-16 14:45:06.020768','2024-07-16 14:45:06.127870',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8738,'classify-tables',2,'2024-07-16 14:45:06.135446','2024-07-16 14:45:06.149481',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8739,'sync',2,'2024-07-16 15:45:00.094706','2024-07-16 15:45:04.645597',4550,NULL,'success'),(8740,'sync-dbms-version',2,'2024-07-16 15:45:00.102900','2024-07-16 15:45:00.112223',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8741,'sync-timezone',2,'2024-07-16 15:45:00.120971','2024-07-16 15:45:00.132331',11,'{\"timezone-id\":\"+08:00\"}','success'),(8742,'sync-tables',2,'2024-07-16 15:45:00.142570','2024-07-16 15:45:00.174500',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8743,'sync-fields',2,'2024-07-16 15:45:00.190805','2024-07-16 15:45:03.338896',3148,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8744,'sync-fks',2,'2024-07-16 15:45:03.346684','2024-07-16 15:45:03.990779',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8745,'sync-indexes',2,'2024-07-16 15:45:04.001113','2024-07-16 15:45:04.602453',601,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8746,'sync-metabase-metadata',2,'2024-07-16 15:45:04.610289','2024-07-16 15:45:04.618960',8,'{}','success'),(8747,'sync-table-privileges',2,'2024-07-16 15:45:04.628786','2024-07-16 15:45:04.637415',8,NULL,'success'),(8748,'analyze',2,'2024-07-16 15:45:04.669072','2024-07-16 15:45:06.959128',2290,NULL,'success'),(8749,'fingerprint-fields',2,'2024-07-16 15:45:04.677556','2024-07-16 15:45:06.798882',2121,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8750,'classify-fields',2,'2024-07-16 15:45:06.808363','2024-07-16 15:45:06.926497',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8751,'classify-tables',2,'2024-07-16 15:45:06.934531','2024-07-16 15:45:06.950008',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8752,'task-history-cleanup',NULL,'2024-07-16 16:00:00.011245','2024-07-16 16:00:00.069286',58,NULL,'success'),(8753,'task-history-cleanup',NULL,'2024-07-16 16:00:00.084092','2024-07-16 16:00:00.099949',15,NULL,'success'),(8754,'sync',2,'2024-07-16 16:45:00.094417','2024-07-16 16:45:04.495029',4400,NULL,'success'),(8755,'sync-dbms-version',2,'2024-07-16 16:45:00.103821','2024-07-16 16:45:00.114036',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8756,'sync-timezone',2,'2024-07-16 16:45:00.122642','2024-07-16 16:45:00.132900',10,'{\"timezone-id\":\"+08:00\"}','success'),(8757,'sync-tables',2,'2024-07-16 16:45:00.142294','2024-07-16 16:45:00.174085',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8758,'sync-fields',2,'2024-07-16 16:45:00.182815','2024-07-16 16:45:03.215909',3033,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8759,'sync-fks',2,'2024-07-16 16:45:03.223738','2024-07-16 16:45:03.821269',597,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8760,'sync-indexes',2,'2024-07-16 16:45:03.830625','2024-07-16 16:45:04.451094',620,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8761,'sync-metabase-metadata',2,'2024-07-16 16:45:04.459476','2024-07-16 16:45:04.468020',8,'{}','success'),(8762,'sync-table-privileges',2,'2024-07-16 16:45:04.476894','2024-07-16 16:45:04.485647',8,NULL,'success'),(8763,'analyze',2,'2024-07-16 16:45:04.522792','2024-07-16 16:45:06.715382',2192,NULL,'success'),(8764,'fingerprint-fields',2,'2024-07-16 16:45:04.531640','2024-07-16 16:45:06.556725',2025,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8765,'classify-fields',2,'2024-07-16 16:45:06.564927','2024-07-16 16:45:06.683191',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8766,'classify-tables',2,'2024-07-16 16:45:06.691330','2024-07-16 16:45:06.706466',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8767,'sync',2,'2024-07-16 17:45:00.097108','2024-07-16 17:45:04.609931',4512,NULL,'success'),(8768,'sync-dbms-version',2,'2024-07-16 17:45:00.105123','2024-07-16 17:45:00.114402',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8769,'sync-timezone',2,'2024-07-16 17:45:00.123012','2024-07-16 17:45:00.134418',11,'{\"timezone-id\":\"+08:00\"}','success'),(8770,'sync-tables',2,'2024-07-16 17:45:00.143226','2024-07-16 17:45:00.172793',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8771,'sync-fields',2,'2024-07-16 17:45:00.181429','2024-07-16 17:45:03.337825',3156,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8772,'sync-fks',2,'2024-07-16 17:45:03.345193','2024-07-16 17:45:03.983345',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8773,'sync-indexes',2,'2024-07-16 17:45:03.991786','2024-07-16 17:45:04.570739',578,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8774,'sync-metabase-metadata',2,'2024-07-16 17:45:04.577744','2024-07-16 17:45:04.585294',7,'{}','success'),(8775,'sync-table-privileges',2,'2024-07-16 17:45:04.592724','2024-07-16 17:45:04.600420',7,NULL,'success'),(8776,'analyze',2,'2024-07-16 17:45:04.634131','2024-07-16 17:45:06.740089',2105,NULL,'success'),(8777,'fingerprint-fields',2,'2024-07-16 17:45:04.641809','2024-07-16 17:45:06.565391',1923,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8778,'classify-fields',2,'2024-07-16 17:45:06.573782','2024-07-16 17:45:06.701035',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8779,'classify-tables',2,'2024-07-16 17:45:06.715480','2024-07-16 17:45:06.731388',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8780,'sync',2,'2024-07-16 18:45:00.101577','2024-07-16 18:45:04.961107',4859,NULL,'success'),(8781,'sync-dbms-version',2,'2024-07-16 18:45:00.110777','2024-07-16 18:45:00.122061',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8782,'sync-timezone',2,'2024-07-16 18:45:00.132660','2024-07-16 18:45:00.143762',11,'{\"timezone-id\":\"+08:00\"}','success'),(8783,'sync-tables',2,'2024-07-16 18:45:00.153510','2024-07-16 18:45:00.182179',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8784,'sync-fields',2,'2024-07-16 18:45:00.191406','2024-07-16 18:45:03.595395',3403,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8785,'sync-fks',2,'2024-07-16 18:45:03.603963','2024-07-16 18:45:04.328357',724,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8786,'sync-indexes',2,'2024-07-16 18:45:04.339700','2024-07-16 18:45:04.920257',580,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8787,'sync-metabase-metadata',2,'2024-07-16 18:45:04.928232','2024-07-16 18:45:04.936387',8,'{}','success'),(8788,'sync-table-privileges',2,'2024-07-16 18:45:04.944374','2024-07-16 18:45:04.952535',8,NULL,'success'),(8789,'analyze',2,'2024-07-16 18:45:04.990838','2024-07-16 18:45:07.180651',2189,NULL,'success'),(8790,'fingerprint-fields',2,'2024-07-16 18:45:04.999235','2024-07-16 18:45:06.997830',1998,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8791,'classify-fields',2,'2024-07-16 18:45:07.006033','2024-07-16 18:45:07.145415',139,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8792,'classify-tables',2,'2024-07-16 18:45:07.154536','2024-07-16 18:45:07.171333',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8793,'sync',2,'2024-07-16 19:45:00.098067','2024-07-16 19:45:04.650199',4552,NULL,'success'),(8794,'sync-dbms-version',2,'2024-07-16 19:45:00.106188','2024-07-16 19:45:00.117404',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8795,'sync-timezone',2,'2024-07-16 19:45:00.129181','2024-07-16 19:45:00.140643',11,'{\"timezone-id\":\"+08:00\"}','success'),(8796,'sync-tables',2,'2024-07-16 19:45:00.151576','2024-07-16 19:45:00.178278',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8797,'sync-fields',2,'2024-07-16 19:45:00.189254','2024-07-16 19:45:03.385590',3196,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8798,'sync-fks',2,'2024-07-16 19:45:03.394040','2024-07-16 19:45:04.057742',663,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8799,'sync-indexes',2,'2024-07-16 19:45:04.066062','2024-07-16 19:45:04.607112',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8800,'sync-metabase-metadata',2,'2024-07-16 19:45:04.614649','2024-07-16 19:45:04.623561',8,'{}','success'),(8801,'sync-table-privileges',2,'2024-07-16 19:45:04.632000','2024-07-16 19:45:04.640064',8,NULL,'success'),(8802,'analyze',2,'2024-07-16 19:45:04.679185','2024-07-16 19:45:06.673677',1994,NULL,'success'),(8803,'fingerprint-fields',2,'2024-07-16 19:45:04.687565','2024-07-16 19:45:06.516285',1828,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8804,'classify-fields',2,'2024-07-16 19:45:06.524773','2024-07-16 19:45:06.641045',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8805,'classify-tables',2,'2024-07-16 19:45:06.649278','2024-07-16 19:45:06.664734',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8806,'sync',2,'2024-07-16 20:45:00.089415','2024-07-16 20:45:04.514293',4424,NULL,'success'),(8807,'sync-dbms-version',2,'2024-07-16 20:45:00.097356','2024-07-16 20:45:00.106981',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8808,'sync-timezone',2,'2024-07-16 20:45:00.115022','2024-07-16 20:45:00.124765',9,'{\"timezone-id\":\"+08:00\"}','success'),(8809,'sync-tables',2,'2024-07-16 20:45:00.132960','2024-07-16 20:45:00.160726',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8810,'sync-fields',2,'2024-07-16 20:45:00.169013','2024-07-16 20:45:03.208294',3039,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8811,'sync-fks',2,'2024-07-16 20:45:03.216918','2024-07-16 20:45:03.909395',692,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8812,'sync-indexes',2,'2024-07-16 20:45:03.918545','2024-07-16 20:45:04.470886',552,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8813,'sync-metabase-metadata',2,'2024-07-16 20:45:04.478740','2024-07-16 20:45:04.488162',9,'{}','success'),(8814,'sync-table-privileges',2,'2024-07-16 20:45:04.496319','2024-07-16 20:45:04.504361',8,NULL,'success'),(8815,'analyze',2,'2024-07-16 20:45:04.539862','2024-07-16 20:45:06.740147',2200,NULL,'success'),(8816,'fingerprint-fields',2,'2024-07-16 20:45:04.548265','2024-07-16 20:45:06.571798',2023,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8817,'classify-fields',2,'2024-07-16 20:45:06.580145','2024-07-16 20:45:06.707953',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8818,'classify-tables',2,'2024-07-16 20:45:06.716691','2024-07-16 20:45:06.731548',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8819,'sync',2,'2024-07-16 21:45:00.095781','2024-07-16 21:45:04.303351',4207,NULL,'success'),(8820,'sync-dbms-version',2,'2024-07-16 21:45:00.103849','2024-07-16 21:45:00.112935',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8821,'sync-timezone',2,'2024-07-16 21:45:00.122176','2024-07-16 21:45:00.131699',9,'{\"timezone-id\":\"+08:00\"}','success'),(8822,'sync-tables',2,'2024-07-16 21:45:00.140934','2024-07-16 21:45:00.167914',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8823,'sync-fields',2,'2024-07-16 21:45:00.176277','2024-07-16 21:45:03.128836',2952,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8824,'sync-fks',2,'2024-07-16 21:45:03.137207','2024-07-16 21:45:03.724174',586,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8825,'sync-indexes',2,'2024-07-16 21:45:03.732117','2024-07-16 21:45:04.264379',532,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8826,'sync-metabase-metadata',2,'2024-07-16 21:45:04.272234','2024-07-16 21:45:04.280391',8,'{}','success'),(8827,'sync-table-privileges',2,'2024-07-16 21:45:04.287797','2024-07-16 21:45:04.295540',7,NULL,'success'),(8828,'analyze',2,'2024-07-16 21:45:04.330342','2024-07-16 21:45:06.506009',2175,NULL,'success'),(8829,'fingerprint-fields',2,'2024-07-16 21:45:04.340100','2024-07-16 21:45:06.356042',2015,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8830,'classify-fields',2,'2024-07-16 21:45:06.363903','2024-07-16 21:45:06.474737',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8831,'classify-tables',2,'2024-07-16 21:45:06.482405','2024-07-16 21:45:06.495672',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8832,'sync',2,'2024-07-16 22:45:00.091724','2024-07-16 22:45:04.410512',4318,NULL,'success'),(8833,'sync-dbms-version',2,'2024-07-16 22:45:00.104293','2024-07-16 22:45:00.115691',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8834,'sync-timezone',2,'2024-07-16 22:45:00.123975','2024-07-16 22:45:00.133731',9,'{\"timezone-id\":\"+08:00\"}','success'),(8835,'sync-tables',2,'2024-07-16 22:45:00.142716','2024-07-16 22:45:00.170480',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8836,'sync-fields',2,'2024-07-16 22:45:00.179959','2024-07-16 22:45:03.296841',3116,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8837,'sync-fks',2,'2024-07-16 22:45:03.304105','2024-07-16 22:45:03.880330',576,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8838,'sync-indexes',2,'2024-07-16 22:45:03.888306','2024-07-16 22:45:04.365113',476,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8839,'sync-metabase-metadata',2,'2024-07-16 22:45:04.374295','2024-07-16 22:45:04.382862',8,'{}','success'),(8840,'sync-table-privileges',2,'2024-07-16 22:45:04.391166','2024-07-16 22:45:04.399710',8,NULL,'success'),(8841,'analyze',2,'2024-07-16 22:45:04.438805','2024-07-16 22:45:06.423792',1984,NULL,'success'),(8842,'fingerprint-fields',2,'2024-07-16 22:45:04.449688','2024-07-16 22:45:06.284463',1834,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8843,'classify-fields',2,'2024-07-16 22:45:06.292527','2024-07-16 22:45:06.395363',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8844,'classify-tables',2,'2024-07-16 22:45:06.402971','2024-07-16 22:45:06.415914',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8845,'sync',2,'2024-07-16 23:45:00.106417','2024-07-16 23:45:05.064006',4957,NULL,'success'),(8846,'sync-dbms-version',2,'2024-07-16 23:45:00.115522','2024-07-16 23:45:00.127102',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8847,'sync-timezone',2,'2024-07-16 23:45:00.137041','2024-07-16 23:45:00.147810',10,'{\"timezone-id\":\"+08:00\"}','success'),(8848,'sync-tables',2,'2024-07-16 23:45:00.157541','2024-07-16 23:45:00.189208',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8849,'sync-fields',2,'2024-07-16 23:45:00.198547','2024-07-16 23:45:03.530544',3331,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8850,'sync-fks',2,'2024-07-16 23:45:03.539032','2024-07-16 23:45:04.341926',802,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8851,'sync-indexes',2,'2024-07-16 23:45:04.351311','2024-07-16 23:45:05.018178',666,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8852,'sync-metabase-metadata',2,'2024-07-16 23:45:05.027162','2024-07-16 23:45:05.036684',9,'{}','success'),(8853,'sync-table-privileges',2,'2024-07-16 23:45:05.046123','2024-07-16 23:45:05.055077',8,NULL,'success'),(8854,'analyze',2,'2024-07-16 23:45:05.097108','2024-07-16 23:45:07.280896',2183,NULL,'success'),(8855,'fingerprint-fields',2,'2024-07-16 23:45:05.106044','2024-07-16 23:45:07.112366',2006,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8856,'classify-fields',2,'2024-07-16 23:45:07.122784','2024-07-16 23:45:07.245940',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8857,'classify-tables',2,'2024-07-16 23:45:07.254734','2024-07-16 23:45:07.270914',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8858,'sync',2,'2024-07-17 00:45:00.102204','2024-07-17 00:45:04.469954',4367,NULL,'success'),(8859,'sync-dbms-version',2,'2024-07-17 00:45:00.110572','2024-07-17 00:45:00.119368',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8860,'sync-timezone',2,'2024-07-17 00:45:00.127825','2024-07-17 00:45:00.137570',9,'{\"timezone-id\":\"+08:00\"}','success'),(8861,'sync-tables',2,'2024-07-17 00:45:00.147562','2024-07-17 00:45:00.172735',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8862,'sync-fields',2,'2024-07-17 00:45:00.181500','2024-07-17 00:45:03.230273',3048,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8863,'sync-fks',2,'2024-07-17 00:45:03.238887','2024-07-17 00:45:03.880497',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8864,'sync-indexes',2,'2024-07-17 00:45:03.889226','2024-07-17 00:45:04.425668',536,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8865,'sync-metabase-metadata',2,'2024-07-17 00:45:04.433908','2024-07-17 00:45:04.443359',9,'{}','success'),(8866,'sync-table-privileges',2,'2024-07-17 00:45:04.451571','2024-07-17 00:45:04.460911',9,NULL,'success'),(8867,'analyze',2,'2024-07-17 00:45:04.495755','2024-07-17 00:45:06.668649',2172,NULL,'success'),(8868,'fingerprint-fields',2,'2024-07-17 00:45:04.504775','2024-07-17 00:45:06.516356',2011,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8869,'classify-fields',2,'2024-07-17 00:45:06.525404','2024-07-17 00:45:06.637573',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8870,'classify-tables',2,'2024-07-17 00:45:06.645196','2024-07-17 00:45:06.659750',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8871,'sync',2,'2024-07-17 01:45:00.104350','2024-07-17 01:45:04.616772',4512,NULL,'success'),(8872,'sync-dbms-version',2,'2024-07-17 01:45:00.113260','2024-07-17 01:45:00.123138',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8873,'sync-timezone',2,'2024-07-17 01:45:00.131850','2024-07-17 01:45:00.143290',11,'{\"timezone-id\":\"+08:00\"}','success'),(8874,'sync-tables',2,'2024-07-17 01:45:00.152048','2024-07-17 01:45:00.178273',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8875,'sync-fields',2,'2024-07-17 01:45:00.186290','2024-07-17 01:45:03.222143',3035,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8876,'sync-fks',2,'2024-07-17 01:45:03.230733','2024-07-17 01:45:03.883216',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8877,'sync-indexes',2,'2024-07-17 01:45:03.891857','2024-07-17 01:45:04.569602',677,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8878,'sync-metabase-metadata',2,'2024-07-17 01:45:04.579135','2024-07-17 01:45:04.588943',9,'{}','success'),(8879,'sync-table-privileges',2,'2024-07-17 01:45:04.597450','2024-07-17 01:45:04.607773',10,NULL,'success'),(8880,'analyze',2,'2024-07-17 01:45:04.648854','2024-07-17 01:45:06.769056',2120,NULL,'success'),(8881,'fingerprint-fields',2,'2024-07-17 01:45:04.658368','2024-07-17 01:45:06.622316',1963,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8882,'classify-fields',2,'2024-07-17 01:45:06.632977','2024-07-17 01:45:06.740495',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8883,'classify-tables',2,'2024-07-17 01:45:06.747697','2024-07-17 01:45:06.760452',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8884,'sync',2,'2024-07-17 02:45:00.094172','2024-07-17 02:45:04.613187',4519,NULL,'success'),(8885,'sync-dbms-version',2,'2024-07-17 02:45:00.102355','2024-07-17 02:45:00.110904',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8886,'sync-timezone',2,'2024-07-17 02:45:00.119763','2024-07-17 02:45:00.130776',11,'{\"timezone-id\":\"+08:00\"}','success'),(8887,'sync-tables',2,'2024-07-17 02:45:00.139606','2024-07-17 02:45:00.172128',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8888,'sync-fields',2,'2024-07-17 02:45:00.181208','2024-07-17 02:45:03.369494',3188,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8889,'sync-fks',2,'2024-07-17 02:45:03.377902','2024-07-17 02:45:04.003899',625,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8890,'sync-indexes',2,'2024-07-17 02:45:04.013954','2024-07-17 02:45:04.569496',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8891,'sync-metabase-metadata',2,'2024-07-17 02:45:04.577482','2024-07-17 02:45:04.586400',8,'{}','success'),(8892,'sync-table-privileges',2,'2024-07-17 02:45:04.594916','2024-07-17 02:45:04.604376',9,NULL,'success'),(8893,'analyze',2,'2024-07-17 02:45:04.640221','2024-07-17 02:45:06.775538',2135,NULL,'success'),(8894,'fingerprint-fields',2,'2024-07-17 02:45:04.648893','2024-07-17 02:45:06.597468',1948,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8895,'classify-fields',2,'2024-07-17 02:45:06.606131','2024-07-17 02:45:06.738136',132,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8896,'classify-tables',2,'2024-07-17 02:45:06.746967','2024-07-17 02:45:06.767130',20,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8897,'sync',2,'2024-07-17 03:45:00.096779','2024-07-17 03:45:04.719009',4622,NULL,'success'),(8898,'sync-dbms-version',2,'2024-07-17 03:45:00.105770','2024-07-17 03:45:00.116605',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8899,'sync-timezone',2,'2024-07-17 03:45:00.126788','2024-07-17 03:45:00.138326',11,'{\"timezone-id\":\"+08:00\"}','success'),(8900,'sync-tables',2,'2024-07-17 03:45:00.147781','2024-07-17 03:45:00.178072',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8901,'sync-fields',2,'2024-07-17 03:45:00.186637','2024-07-17 03:45:03.466647',3280,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8902,'sync-fks',2,'2024-07-17 03:45:03.474827','2024-07-17 03:45:04.149821',674,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8903,'sync-indexes',2,'2024-07-17 03:45:04.157843','2024-07-17 03:45:04.675804',517,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8904,'sync-metabase-metadata',2,'2024-07-17 03:45:04.683647','2024-07-17 03:45:04.691912',8,'{}','success'),(8905,'sync-table-privileges',2,'2024-07-17 03:45:04.701325','2024-07-17 03:45:04.709958',8,NULL,'success'),(8906,'analyze',2,'2024-07-17 03:45:04.746215','2024-07-17 03:45:06.846769',2100,NULL,'success'),(8907,'fingerprint-fields',2,'2024-07-17 03:45:04.754928','2024-07-17 03:45:06.681914',1926,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8908,'classify-fields',2,'2024-07-17 03:45:06.690628','2024-07-17 03:45:06.813817',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8909,'classify-tables',2,'2024-07-17 03:45:06.821557','2024-07-17 03:45:06.838090',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8910,'task-history-cleanup',NULL,'2024-07-17 04:00:00.069198','2024-07-17 04:00:00.101608',32,NULL,'success'),(8911,'sync',2,'2024-07-17 04:45:00.105086','2024-07-17 04:45:04.691769',4586,NULL,'success'),(8912,'sync-dbms-version',2,'2024-07-17 04:45:00.127079','2024-07-17 04:45:00.136634',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8913,'sync-timezone',2,'2024-07-17 04:45:00.145869','2024-07-17 04:45:00.157620',11,'{\"timezone-id\":\"+08:00\"}','success'),(8914,'sync-tables',2,'2024-07-17 04:45:00.167031','2024-07-17 04:45:00.195781',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8915,'sync-fields',2,'2024-07-17 04:45:00.205054','2024-07-17 04:45:03.443110',3238,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8916,'sync-fks',2,'2024-07-17 04:45:03.451449','2024-07-17 04:45:04.055573',604,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8917,'sync-indexes',2,'2024-07-17 04:45:04.063480','2024-07-17 04:45:04.648551',585,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8918,'sync-metabase-metadata',2,'2024-07-17 04:45:04.657250','2024-07-17 04:45:04.665644',8,'{}','success'),(8919,'sync-table-privileges',2,'2024-07-17 04:45:04.674570','2024-07-17 04:45:04.683624',9,NULL,'success'),(8920,'analyze',2,'2024-07-17 04:45:04.719152','2024-07-17 04:45:06.939521',2220,NULL,'success'),(8921,'fingerprint-fields',2,'2024-07-17 04:45:04.727723','2024-07-17 04:45:06.787575',2059,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8922,'classify-fields',2,'2024-07-17 04:45:06.796945','2024-07-17 04:45:06.909147',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8923,'classify-tables',2,'2024-07-17 04:45:06.917228','2024-07-17 04:45:06.930806',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8924,'sync',2,'2024-07-17 05:45:00.105749','2024-07-17 05:45:04.458863',4353,NULL,'success'),(8925,'sync-dbms-version',2,'2024-07-17 05:45:00.121209','2024-07-17 05:45:00.130835',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8926,'sync-timezone',2,'2024-07-17 05:45:00.146306','2024-07-17 05:45:00.165272',18,'{\"timezone-id\":\"+08:00\"}','success'),(8927,'sync-tables',2,'2024-07-17 05:45:00.174295','2024-07-17 05:45:00.202923',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8928,'sync-fields',2,'2024-07-17 05:45:00.211688','2024-07-17 05:45:03.189574',2977,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8929,'sync-fks',2,'2024-07-17 05:45:03.196938','2024-07-17 05:45:03.788628',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8930,'sync-indexes',2,'2024-07-17 05:45:03.796687','2024-07-17 05:45:04.417702',621,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8931,'sync-metabase-metadata',2,'2024-07-17 05:45:04.425431','2024-07-17 05:45:04.433799',8,'{}','success'),(8932,'sync-table-privileges',2,'2024-07-17 05:45:04.442908','2024-07-17 05:45:04.450601',7,NULL,'success'),(8933,'analyze',2,'2024-07-17 05:45:04.483899','2024-07-17 05:45:06.784793',2300,NULL,'success'),(8934,'fingerprint-fields',2,'2024-07-17 05:45:04.491859','2024-07-17 05:45:06.619385',2127,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8935,'classify-fields',2,'2024-07-17 05:45:06.628709','2024-07-17 05:45:06.751084',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8936,'classify-tables',2,'2024-07-17 05:45:06.759073','2024-07-17 05:45:06.775546',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8937,'sync',2,'2024-07-17 06:45:00.104774','2024-07-17 06:45:04.591937',4487,NULL,'success'),(8938,'sync-dbms-version',2,'2024-07-17 06:45:00.115096','2024-07-17 06:45:00.125318',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8939,'sync-timezone',2,'2024-07-17 06:45:00.133503','2024-07-17 06:45:00.144403',10,'{\"timezone-id\":\"+08:00\"}','success'),(8940,'sync-tables',2,'2024-07-17 06:45:00.152757','2024-07-17 06:45:00.184287',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8941,'sync-fields',2,'2024-07-17 06:45:00.192980','2024-07-17 06:45:03.414573',3221,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8942,'sync-fks',2,'2024-07-17 06:45:03.422150','2024-07-17 06:45:04.004816',582,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8943,'sync-indexes',2,'2024-07-17 06:45:04.013743','2024-07-17 06:45:04.549457',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8944,'sync-metabase-metadata',2,'2024-07-17 06:45:04.557288','2024-07-17 06:45:04.565281',7,'{}','success'),(8945,'sync-table-privileges',2,'2024-07-17 06:45:04.573563','2024-07-17 06:45:04.582534',8,NULL,'success'),(8946,'analyze',2,'2024-07-17 06:45:04.616383','2024-07-17 06:45:06.812522',2196,NULL,'success'),(8947,'fingerprint-fields',2,'2024-07-17 06:45:04.624596','2024-07-17 06:45:06.635414',2010,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8948,'classify-fields',2,'2024-07-17 06:45:06.644133','2024-07-17 06:45:06.781523',137,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8949,'classify-tables',2,'2024-07-17 06:45:06.789177','2024-07-17 06:45:06.803783',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8950,'sync',2,'2024-07-17 07:45:00.099554','2024-07-17 07:45:05.161318',5061,NULL,'success'),(8951,'sync-dbms-version',2,'2024-07-17 07:45:00.108071','2024-07-17 07:45:00.117076',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8952,'sync-timezone',2,'2024-07-17 07:45:00.125414','2024-07-17 07:45:00.136598',11,'{\"timezone-id\":\"+08:00\"}','success'),(8953,'sync-tables',2,'2024-07-17 07:45:00.144708','2024-07-17 07:45:00.170113',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8954,'sync-fields',2,'2024-07-17 07:45:00.178242','2024-07-17 07:45:03.227271',3049,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8955,'sync-fks',2,'2024-07-17 07:45:03.234363','2024-07-17 07:45:03.798597',564,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8956,'sync-indexes',2,'2024-07-17 07:45:03.805998','2024-07-17 07:45:05.120900',1314,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8957,'sync-metabase-metadata',2,'2024-07-17 07:45:05.129300','2024-07-17 07:45:05.137496',8,'{}','success'),(8958,'sync-table-privileges',2,'2024-07-17 07:45:05.145208','2024-07-17 07:45:05.153205',7,NULL,'success'),(8959,'analyze',2,'2024-07-17 07:45:05.186198','2024-07-17 07:45:07.132130',1945,NULL,'success'),(8960,'fingerprint-fields',2,'2024-07-17 07:45:05.194597','2024-07-17 07:45:06.993819',1799,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8961,'classify-fields',2,'2024-07-17 07:45:07.001916','2024-07-17 07:45:07.101763',99,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8962,'classify-tables',2,'2024-07-17 07:45:07.109799','2024-07-17 07:45:07.123825',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8963,'sync',2,'2024-07-17 08:45:00.091597','2024-07-17 08:45:04.444188',4352,NULL,'success'),(8964,'sync-dbms-version',2,'2024-07-17 08:45:00.099602','2024-07-17 08:45:00.108868',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8965,'sync-timezone',2,'2024-07-17 08:45:00.119005','2024-07-17 08:45:00.129857',10,'{\"timezone-id\":\"+08:00\"}','success'),(8966,'sync-tables',2,'2024-07-17 08:45:00.141569','2024-07-17 08:45:00.170060',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8967,'sync-fields',2,'2024-07-17 08:45:00.184828','2024-07-17 08:45:03.177473',2992,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8968,'sync-fks',2,'2024-07-17 08:45:03.186050','2024-07-17 08:45:03.827218',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8969,'sync-indexes',2,'2024-07-17 08:45:03.835112','2024-07-17 08:45:04.402011',566,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8970,'sync-metabase-metadata',2,'2024-07-17 08:45:04.409947','2024-07-17 08:45:04.418923',8,'{}','success'),(8971,'sync-table-privileges',2,'2024-07-17 08:45:04.426850','2024-07-17 08:45:04.435193',8,NULL,'success'),(8972,'analyze',2,'2024-07-17 08:45:04.469193','2024-07-17 08:45:06.551373',2082,NULL,'success'),(8973,'fingerprint-fields',2,'2024-07-17 08:45:04.477243','2024-07-17 08:45:06.397637',1920,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8974,'classify-fields',2,'2024-07-17 08:45:06.406380','2024-07-17 08:45:06.520419',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8975,'classify-tables',2,'2024-07-17 08:45:06.530176','2024-07-17 08:45:06.543668',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8976,'sync',2,'2024-07-17 09:45:00.107471','2024-07-17 09:45:04.411946',4304,NULL,'success'),(8977,'sync-dbms-version',2,'2024-07-17 09:45:00.115927','2024-07-17 09:45:00.124743',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8978,'sync-timezone',2,'2024-07-17 09:45:00.133167','2024-07-17 09:45:00.142134',8,'{\"timezone-id\":\"+08:00\"}','success'),(8979,'sync-tables',2,'2024-07-17 09:45:00.150020','2024-07-17 09:45:00.179992',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8980,'sync-fields',2,'2024-07-17 09:45:00.191945','2024-07-17 09:45:03.186065',2994,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8981,'sync-fks',2,'2024-07-17 09:45:03.194136','2024-07-17 09:45:03.793810',599,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8982,'sync-indexes',2,'2024-07-17 09:45:03.802875','2024-07-17 09:45:04.372553',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8983,'sync-metabase-metadata',2,'2024-07-17 09:45:04.380083','2024-07-17 09:45:04.388263',8,'{}','success'),(8984,'sync-table-privileges',2,'2024-07-17 09:45:04.395787','2024-07-17 09:45:04.403742',7,NULL,'success'),(8985,'analyze',2,'2024-07-17 09:45:04.441343','2024-07-17 09:45:06.393851',1952,NULL,'success'),(8986,'fingerprint-fields',2,'2024-07-17 09:45:04.449943','2024-07-17 09:45:06.250170',1800,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(8987,'classify-fields',2,'2024-07-17 09:45:06.258060','2024-07-17 09:45:06.364996',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(8988,'classify-tables',2,'2024-07-17 09:45:06.372460','2024-07-17 09:45:06.385820',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(8989,'sync',2,'2024-07-17 10:45:00.095104','2024-07-17 10:45:04.065725',3970,NULL,'success'),(8990,'sync-dbms-version',2,'2024-07-17 10:45:00.102817','2024-07-17 10:45:00.111964',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(8991,'sync-timezone',2,'2024-07-17 10:45:00.120162','2024-07-17 10:45:00.129179',9,'{\"timezone-id\":\"+08:00\"}','success'),(8992,'sync-tables',2,'2024-07-17 10:45:00.137043','2024-07-17 10:45:00.165535',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(8993,'sync-fields',2,'2024-07-17 10:45:00.174467','2024-07-17 10:45:02.922237',2747,'{\"total-fields\":836,\"updated-fields\":0}','success'),(8994,'sync-fks',2,'2024-07-17 10:45:02.929834','2024-07-17 10:45:03.517095',587,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(8995,'sync-indexes',2,'2024-07-17 10:45:03.524732','2024-07-17 10:45:04.020169',495,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(8996,'sync-metabase-metadata',2,'2024-07-17 10:45:04.027218','2024-07-17 10:45:04.036906',9,'{}','success'),(8997,'sync-table-privileges',2,'2024-07-17 10:45:04.045787','2024-07-17 10:45:04.054896',9,NULL,'success'),(8998,'analyze',2,'2024-07-17 10:45:04.090662','2024-07-17 10:45:06.110357',2019,NULL,'success'),(8999,'fingerprint-fields',2,'2024-07-17 10:45:04.098767','2024-07-17 10:45:05.967786',1869,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9000,'classify-fields',2,'2024-07-17 10:45:05.975596','2024-07-17 10:45:06.081313',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9001,'classify-tables',2,'2024-07-17 10:45:06.088844','2024-07-17 10:45:06.101871',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9002,'sync',2,'2024-07-17 11:45:00.107821','2024-07-17 11:45:04.365173',4257,NULL,'success'),(9003,'sync-dbms-version',2,'2024-07-17 11:45:00.115862','2024-07-17 11:45:00.125092',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9004,'sync-timezone',2,'2024-07-17 11:45:00.133774','2024-07-17 11:45:00.143371',9,'{\"timezone-id\":\"+08:00\"}','success'),(9005,'sync-tables',2,'2024-07-17 11:45:00.151895','2024-07-17 11:45:00.178574',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9006,'sync-fields',2,'2024-07-17 11:45:00.187375','2024-07-17 11:45:03.085980',2898,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9007,'sync-fks',2,'2024-07-17 11:45:03.115330','2024-07-17 11:45:03.736782',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9008,'sync-indexes',2,'2024-07-17 11:45:03.747475','2024-07-17 11:45:04.321098',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9009,'sync-metabase-metadata',2,'2024-07-17 11:45:04.329355','2024-07-17 11:45:04.338396',9,'{}','success'),(9010,'sync-table-privileges',2,'2024-07-17 11:45:04.349289','2024-07-17 11:45:04.357561',8,NULL,'success'),(9011,'analyze',2,'2024-07-17 11:45:04.388994','2024-07-17 11:45:06.295966',1906,NULL,'success'),(9012,'fingerprint-fields',2,'2024-07-17 11:45:04.399857','2024-07-17 11:45:06.166912',1767,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9013,'classify-fields',2,'2024-07-17 11:45:06.174738','2024-07-17 11:45:06.269118',94,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9014,'classify-tables',2,'2024-07-17 11:45:06.276089','2024-07-17 11:45:06.288198',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9015,'sync',2,'2024-07-17 12:45:00.098292','2024-07-17 12:45:04.065229',3966,NULL,'success'),(9016,'sync-dbms-version',2,'2024-07-17 12:45:00.106946','2024-07-17 12:45:00.117593',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9017,'sync-timezone',2,'2024-07-17 12:45:00.125612','2024-07-17 12:45:00.134952',9,'{\"timezone-id\":\"+08:00\"}','success'),(9018,'sync-tables',2,'2024-07-17 12:45:00.142749','2024-07-17 12:45:00.170155',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9019,'sync-fields',2,'2024-07-17 12:45:00.178909','2024-07-17 12:45:02.967421',2788,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9020,'sync-fks',2,'2024-07-17 12:45:02.974962','2024-07-17 12:45:03.532850',557,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9021,'sync-indexes',2,'2024-07-17 12:45:03.541157','2024-07-17 12:45:04.017567',476,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9022,'sync-metabase-metadata',2,'2024-07-17 12:45:04.027666','2024-07-17 12:45:04.039242',11,'{}','success'),(9023,'sync-table-privileges',2,'2024-07-17 12:45:04.049149','2024-07-17 12:45:04.056835',7,NULL,'success'),(9024,'analyze',2,'2024-07-17 12:45:04.088691','2024-07-17 12:45:05.927462',1838,NULL,'success'),(9025,'fingerprint-fields',2,'2024-07-17 12:45:04.096431','2024-07-17 12:45:05.791553',1695,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9026,'classify-fields',2,'2024-07-17 12:45:05.799480','2024-07-17 12:45:05.899025',99,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9027,'classify-tables',2,'2024-07-17 12:45:05.907052','2024-07-17 12:45:05.920117',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9028,'field values scanning',2,'2024-07-17 13:00:00.066091','2024-07-17 13:00:04.388089',4321,NULL,'success'),(9029,'delete-expired-advanced-field-values',2,'2024-07-17 13:00:00.080526','2024-07-17 13:00:03.027362',2946,'{\"deleted\":0}','success'),(9030,'update-field-values',2,'2024-07-17 13:00:03.036397','2024-07-17 13:00:04.379651',1343,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(9031,'sync',2,'2024-07-17 13:45:00.093057','2024-07-17 13:45:04.199830',4106,NULL,'success'),(9032,'sync-dbms-version',2,'2024-07-17 13:45:00.102860','2024-07-17 13:45:00.113999',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9033,'sync-timezone',2,'2024-07-17 13:45:00.122446','2024-07-17 13:45:00.132846',10,'{\"timezone-id\":\"+08:00\"}','success'),(9034,'sync-tables',2,'2024-07-17 13:45:00.141490','2024-07-17 13:45:00.172862',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9035,'sync-fields',2,'2024-07-17 13:45:00.181922','2024-07-17 13:45:03.047213',2865,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9036,'sync-fks',2,'2024-07-17 13:45:03.054474','2024-07-17 13:45:03.656605',602,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9037,'sync-indexes',2,'2024-07-17 13:45:03.664952','2024-07-17 13:45:04.156811',491,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9038,'sync-metabase-metadata',2,'2024-07-17 13:45:04.165296','2024-07-17 13:45:04.173140',7,'{}','success'),(9039,'sync-table-privileges',2,'2024-07-17 13:45:04.181628','2024-07-17 13:45:04.191558',9,NULL,'success'),(9040,'analyze',2,'2024-07-17 13:45:04.223736','2024-07-17 13:45:06.297521',2073,NULL,'success'),(9041,'fingerprint-fields',2,'2024-07-17 13:45:04.231822','2024-07-17 13:45:06.124648',1892,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9042,'classify-fields',2,'2024-07-17 13:45:06.138475','2024-07-17 13:45:06.265421',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9043,'classify-tables',2,'2024-07-17 13:45:06.273367','2024-07-17 13:45:06.288552',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9044,'sync',2,'2024-07-17 14:45:00.094976','2024-07-17 14:45:04.423274',4328,NULL,'success'),(9045,'sync-dbms-version',2,'2024-07-17 14:45:00.102853','2024-07-17 14:45:00.111987',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9046,'sync-timezone',2,'2024-07-17 14:45:00.120004','2024-07-17 14:45:00.128734',8,'{\"timezone-id\":\"+08:00\"}','success'),(9047,'sync-tables',2,'2024-07-17 14:45:00.136358','2024-07-17 14:45:00.161885',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9048,'sync-fields',2,'2024-07-17 14:45:00.170802','2024-07-17 14:45:03.205342',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9049,'sync-fks',2,'2024-07-17 14:45:03.212710','2024-07-17 14:45:03.799367',586,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9050,'sync-indexes',2,'2024-07-17 14:45:03.807948','2024-07-17 14:45:04.379541',571,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9051,'sync-metabase-metadata',2,'2024-07-17 14:45:04.387499','2024-07-17 14:45:04.397071',9,'{}','success'),(9052,'sync-table-privileges',2,'2024-07-17 14:45:04.406170','2024-07-17 14:45:04.414777',8,NULL,'success'),(9053,'analyze',2,'2024-07-17 14:45:04.452236','2024-07-17 14:45:06.410194',1957,NULL,'success'),(9054,'fingerprint-fields',2,'2024-07-17 14:45:04.461003','2024-07-17 14:45:06.261299',1800,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9055,'classify-fields',2,'2024-07-17 14:45:06.270847','2024-07-17 14:45:06.381024',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9056,'classify-tables',2,'2024-07-17 14:45:06.388448','2024-07-17 14:45:06.402332',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9057,'sync',2,'2024-07-17 15:45:00.092803','2024-07-17 15:45:04.611723',4518,NULL,'success'),(9058,'sync-dbms-version',2,'2024-07-17 15:45:00.100975','2024-07-17 15:45:00.111779',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9059,'sync-timezone',2,'2024-07-17 15:45:00.120209','2024-07-17 15:45:00.130777',10,'{\"timezone-id\":\"+08:00\"}','success'),(9060,'sync-tables',2,'2024-07-17 15:45:00.140534','2024-07-17 15:45:00.170386',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9061,'sync-fields',2,'2024-07-17 15:45:00.180400','2024-07-17 15:45:03.359520',3179,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9062,'sync-fks',2,'2024-07-17 15:45:03.367349','2024-07-17 15:45:04.005217',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9063,'sync-indexes',2,'2024-07-17 15:45:04.014117','2024-07-17 15:45:04.568282',554,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9064,'sync-metabase-metadata',2,'2024-07-17 15:45:04.576161','2024-07-17 15:45:04.585658',9,'{}','success'),(9065,'sync-table-privileges',2,'2024-07-17 15:45:04.594506','2024-07-17 15:45:04.603067',8,NULL,'success'),(9066,'analyze',2,'2024-07-17 15:45:04.638697','2024-07-17 15:45:06.761458',2122,NULL,'success'),(9067,'fingerprint-fields',2,'2024-07-17 15:45:04.648243','2024-07-17 15:45:06.606691',1958,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9068,'classify-fields',2,'2024-07-17 15:45:06.615097','2024-07-17 15:45:06.726435',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9069,'classify-tables',2,'2024-07-17 15:45:06.733911','2024-07-17 15:45:06.748866',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9070,'task-history-cleanup',NULL,'2024-07-17 16:00:00.016536','2024-07-17 16:00:00.081199',64,NULL,'success'),(9071,'task-history-cleanup',NULL,'2024-07-17 16:00:00.096616','2024-07-17 16:00:00.143388',46,NULL,'success'),(9072,'sync',2,'2024-07-17 16:45:00.092180','2024-07-17 16:45:04.802456',4710,NULL,'success'),(9073,'sync-dbms-version',2,'2024-07-17 16:45:00.100869','2024-07-17 16:45:00.110021',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9074,'sync-timezone',2,'2024-07-17 16:45:00.118658','2024-07-17 16:45:00.129985',11,'{\"timezone-id\":\"+08:00\"}','success'),(9075,'sync-tables',2,'2024-07-17 16:45:00.139171','2024-07-17 16:45:00.168029',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9076,'sync-fields',2,'2024-07-17 16:45:00.176778','2024-07-17 16:45:03.388784',3212,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9077,'sync-fks',2,'2024-07-17 16:45:03.396898','2024-07-17 16:45:04.117817',720,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9078,'sync-indexes',2,'2024-07-17 16:45:04.127671','2024-07-17 16:45:04.755643',627,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9079,'sync-metabase-metadata',2,'2024-07-17 16:45:04.764371','2024-07-17 16:45:04.774108',9,'{}','success'),(9080,'sync-table-privileges',2,'2024-07-17 16:45:04.783063','2024-07-17 16:45:04.793563',10,NULL,'success'),(9081,'analyze',2,'2024-07-17 16:45:04.835000','2024-07-17 16:45:07.037799',2202,NULL,'success'),(9082,'fingerprint-fields',2,'2024-07-17 16:45:04.844487','2024-07-17 16:45:06.861508',2017,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9083,'classify-fields',2,'2024-07-17 16:45:06.870659','2024-07-17 16:45:07.005404',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9084,'classify-tables',2,'2024-07-17 16:45:07.013090','2024-07-17 16:45:07.027976',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9085,'sync',2,'2024-07-17 17:45:00.100673','2024-07-17 17:45:04.501223',4400,NULL,'success'),(9086,'sync-dbms-version',2,'2024-07-17 17:45:00.109705','2024-07-17 17:45:00.120523',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9087,'sync-timezone',2,'2024-07-17 17:45:00.130051','2024-07-17 17:45:00.142111',12,'{\"timezone-id\":\"+08:00\"}','success'),(9088,'sync-tables',2,'2024-07-17 17:45:00.151868','2024-07-17 17:45:00.183836',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9089,'sync-fields',2,'2024-07-17 17:45:00.195734','2024-07-17 17:45:03.300255',3104,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9090,'sync-fks',2,'2024-07-17 17:45:03.308006','2024-07-17 17:45:03.936131',628,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9091,'sync-indexes',2,'2024-07-17 17:45:03.944523','2024-07-17 17:45:04.459779',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9092,'sync-metabase-metadata',2,'2024-07-17 17:45:04.467697','2024-07-17 17:45:04.475825',8,'{}','success'),(9093,'sync-table-privileges',2,'2024-07-17 17:45:04.484574','2024-07-17 17:45:04.492650',8,NULL,'success'),(9094,'analyze',2,'2024-07-17 17:45:04.532337','2024-07-17 17:45:06.515786',1983,NULL,'success'),(9095,'fingerprint-fields',2,'2024-07-17 17:45:04.541278','2024-07-17 17:45:06.365106',1823,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9096,'classify-fields',2,'2024-07-17 17:45:06.373165','2024-07-17 17:45:06.484640',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9097,'classify-tables',2,'2024-07-17 17:45:06.493316','2024-07-17 17:45:06.507434',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9098,'sync',2,'2024-07-17 18:45:00.095630','2024-07-17 18:45:04.582319',4486,NULL,'success'),(9099,'sync-dbms-version',2,'2024-07-17 18:45:00.107412','2024-07-17 18:45:00.119294',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9100,'sync-timezone',2,'2024-07-17 18:45:00.128726','2024-07-17 18:45:00.140050',11,'{\"timezone-id\":\"+08:00\"}','success'),(9101,'sync-tables',2,'2024-07-17 18:45:00.149208','2024-07-17 18:45:00.179273',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9102,'sync-fields',2,'2024-07-17 18:45:00.188449','2024-07-17 18:45:03.345809',3157,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9103,'sync-fks',2,'2024-07-17 18:45:03.353879','2024-07-17 18:45:03.991195',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9104,'sync-indexes',2,'2024-07-17 18:45:03.998777','2024-07-17 18:45:04.535512',536,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9105,'sync-metabase-metadata',2,'2024-07-17 18:45:04.543559','2024-07-17 18:45:04.553199',9,'{}','success'),(9106,'sync-table-privileges',2,'2024-07-17 18:45:04.562872','2024-07-17 18:45:04.572686',9,NULL,'success'),(9107,'analyze',2,'2024-07-17 18:45:04.607983','2024-07-17 18:45:06.758239',2150,NULL,'success'),(9108,'fingerprint-fields',2,'2024-07-17 18:45:04.616870','2024-07-17 18:45:06.581275',1964,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9109,'classify-fields',2,'2024-07-17 18:45:06.590500','2024-07-17 18:45:06.724875',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9110,'classify-tables',2,'2024-07-17 18:45:06.733552','2024-07-17 18:45:06.748983',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9111,'sync',2,'2024-07-17 19:45:00.103973','2024-07-17 19:45:04.660668',4556,NULL,'success'),(9112,'sync-dbms-version',2,'2024-07-17 19:45:00.111995','2024-07-17 19:45:00.120686',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9113,'sync-timezone',2,'2024-07-17 19:45:00.129761','2024-07-17 19:45:00.140314',10,'{\"timezone-id\":\"+08:00\"}','success'),(9114,'sync-tables',2,'2024-07-17 19:45:00.148486','2024-07-17 19:45:00.174144',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9115,'sync-fields',2,'2024-07-17 19:45:00.183228','2024-07-17 19:45:03.334299',3151,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9116,'sync-fks',2,'2024-07-17 19:45:03.343728','2024-07-17 19:45:04.008606',664,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9117,'sync-indexes',2,'2024-07-17 19:45:04.018259','2024-07-17 19:45:04.617519',599,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9118,'sync-metabase-metadata',2,'2024-07-17 19:45:04.625392','2024-07-17 19:45:04.633739',8,'{}','success'),(9119,'sync-table-privileges',2,'2024-07-17 19:45:04.642273','2024-07-17 19:45:04.651767',9,NULL,'success'),(9120,'analyze',2,'2024-07-17 19:45:04.685410','2024-07-17 19:45:06.673413',1988,NULL,'success'),(9121,'fingerprint-fields',2,'2024-07-17 19:45:04.693343','2024-07-17 19:45:06.509110',1815,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9122,'classify-fields',2,'2024-07-17 19:45:06.518422','2024-07-17 19:45:06.640973',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9123,'classify-tables',2,'2024-07-17 19:45:06.649029','2024-07-17 19:45:06.664352',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9124,'sync',2,'2024-07-17 20:45:00.106363','2024-07-17 20:45:04.659856',4553,NULL,'success'),(9125,'sync-dbms-version',2,'2024-07-17 20:45:00.116222','2024-07-17 20:45:00.126168',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9126,'sync-timezone',2,'2024-07-17 20:45:00.134456','2024-07-17 20:45:00.144218',9,'{\"timezone-id\":\"+08:00\"}','success'),(9127,'sync-tables',2,'2024-07-17 20:45:00.152295','2024-07-17 20:45:00.181857',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9128,'sync-fields',2,'2024-07-17 20:45:00.191373','2024-07-17 20:45:03.365910',3174,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9129,'sync-fks',2,'2024-07-17 20:45:03.373831','2024-07-17 20:45:04.047196',673,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9130,'sync-indexes',2,'2024-07-17 20:45:04.056512','2024-07-17 20:45:04.613506',556,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9131,'sync-metabase-metadata',2,'2024-07-17 20:45:04.622597','2024-07-17 20:45:04.632042',9,'{}','success'),(9132,'sync-table-privileges',2,'2024-07-17 20:45:04.641361','2024-07-17 20:45:04.650172',8,NULL,'success'),(9133,'analyze',2,'2024-07-17 20:45:04.687929','2024-07-17 20:45:06.834458',2146,NULL,'success'),(9134,'fingerprint-fields',2,'2024-07-17 20:45:04.697068','2024-07-17 20:45:06.677529',1980,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9135,'classify-fields',2,'2024-07-17 20:45:06.686908','2024-07-17 20:45:06.805593',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9136,'classify-tables',2,'2024-07-17 20:45:06.813360','2024-07-17 20:45:06.826757',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9137,'sync',2,'2024-07-17 21:45:00.104793','2024-07-17 21:45:04.999784',4894,NULL,'success'),(9138,'sync-dbms-version',2,'2024-07-17 21:45:00.115735','2024-07-17 21:45:00.126180',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9139,'sync-timezone',2,'2024-07-17 21:45:00.135864','2024-07-17 21:45:00.146078',10,'{\"timezone-id\":\"+08:00\"}','success'),(9140,'sync-tables',2,'2024-07-17 21:45:00.155314','2024-07-17 21:45:00.182667',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9141,'sync-fields',2,'2024-07-17 21:45:00.193050','2024-07-17 21:45:03.650187',3457,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9142,'sync-fks',2,'2024-07-17 21:45:03.658709','2024-07-17 21:45:04.378172',719,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9143,'sync-indexes',2,'2024-07-17 21:45:04.386780','2024-07-17 21:45:04.951151',564,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9144,'sync-metabase-metadata',2,'2024-07-17 21:45:04.959879','2024-07-17 21:45:04.970255',10,'{}','success'),(9145,'sync-table-privileges',2,'2024-07-17 21:45:04.980270','2024-07-17 21:45:04.990564',10,NULL,'success'),(9146,'analyze',2,'2024-07-17 21:45:05.029966','2024-07-17 21:45:07.126687',2096,NULL,'success'),(9147,'fingerprint-fields',2,'2024-07-17 21:45:05.039962','2024-07-17 21:45:06.956449',1916,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9148,'classify-fields',2,'2024-07-17 21:45:06.964993','2024-07-17 21:45:07.092077',127,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9149,'classify-tables',2,'2024-07-17 21:45:07.100723','2024-07-17 21:45:07.117093',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9150,'sync',2,'2024-07-17 22:45:00.087010','2024-07-17 22:45:04.640795',4553,NULL,'success'),(9151,'sync-dbms-version',2,'2024-07-17 22:45:00.095727','2024-07-17 22:45:00.105893',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9152,'sync-timezone',2,'2024-07-17 22:45:00.114194','2024-07-17 22:45:00.123947',9,'{\"timezone-id\":\"+08:00\"}','success'),(9153,'sync-tables',2,'2024-07-17 22:45:00.132846','2024-07-17 22:45:00.157602',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9154,'sync-fields',2,'2024-07-17 22:45:00.165816','2024-07-17 22:45:03.332507',3166,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9155,'sync-fks',2,'2024-07-17 22:45:03.343276','2024-07-17 22:45:04.005320',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9156,'sync-indexes',2,'2024-07-17 22:45:04.013777','2024-07-17 22:45:04.596150',582,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9157,'sync-metabase-metadata',2,'2024-07-17 22:45:04.604184','2024-07-17 22:45:04.612482',8,'{}','success'),(9158,'sync-table-privileges',2,'2024-07-17 22:45:04.620886','2024-07-17 22:45:04.631561',10,NULL,'success'),(9159,'analyze',2,'2024-07-17 22:45:04.672867','2024-07-17 22:45:06.658387',1985,NULL,'success'),(9160,'fingerprint-fields',2,'2024-07-17 22:45:04.683196','2024-07-17 22:45:06.501761',1818,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9161,'classify-fields',2,'2024-07-17 22:45:06.510714','2024-07-17 22:45:06.629157',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9162,'classify-tables',2,'2024-07-17 22:45:06.636766','2024-07-17 22:45:06.650208',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9163,'sync',2,'2024-07-17 23:45:00.101890','2024-07-17 23:45:04.580748',4478,NULL,'success'),(9164,'sync-dbms-version',2,'2024-07-17 23:45:00.111715','2024-07-17 23:45:00.122407',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9165,'sync-timezone',2,'2024-07-17 23:45:00.130517','2024-07-17 23:45:00.141390',10,'{\"timezone-id\":\"+08:00\"}','success'),(9166,'sync-tables',2,'2024-07-17 23:45:00.150017','2024-07-17 23:45:00.180543',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9167,'sync-fields',2,'2024-07-17 23:45:00.188544','2024-07-17 23:45:03.407411',3218,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9168,'sync-fks',2,'2024-07-17 23:45:03.415889','2024-07-17 23:45:04.055307',639,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9169,'sync-indexes',2,'2024-07-17 23:45:04.063717','2024-07-17 23:45:04.538672',474,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9170,'sync-metabase-metadata',2,'2024-07-17 23:45:04.546515','2024-07-17 23:45:04.555524',9,'{}','success'),(9171,'sync-table-privileges',2,'2024-07-17 23:45:04.564552','2024-07-17 23:45:04.572464',7,NULL,'success'),(9172,'analyze',2,'2024-07-17 23:45:04.604724','2024-07-17 23:45:06.733208',2128,NULL,'success'),(9173,'fingerprint-fields',2,'2024-07-17 23:45:04.612980','2024-07-17 23:45:06.567988',1955,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9174,'classify-fields',2,'2024-07-17 23:45:06.577689','2024-07-17 23:45:06.701761',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9175,'classify-tables',2,'2024-07-17 23:45:06.709966','2024-07-17 23:45:06.724673',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9176,'sync',2,'2024-07-18 00:45:00.095993','2024-07-18 00:45:04.196390',4100,NULL,'success'),(9177,'sync-dbms-version',2,'2024-07-18 00:45:00.104256','2024-07-18 00:45:00.113279',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9178,'sync-timezone',2,'2024-07-18 00:45:00.122462','2024-07-18 00:45:00.134274',11,'{\"timezone-id\":\"+08:00\"}','success'),(9179,'sync-tables',2,'2024-07-18 00:45:00.142798','2024-07-18 00:45:00.168399',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9180,'sync-fields',2,'2024-07-18 00:45:00.176871','2024-07-18 00:45:03.099443',2922,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9181,'sync-fks',2,'2024-07-18 00:45:03.113184','2024-07-18 00:45:03.668255',555,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9182,'sync-indexes',2,'2024-07-18 00:45:03.676420','2024-07-18 00:45:04.155598',479,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9183,'sync-metabase-metadata',2,'2024-07-18 00:45:04.164067','2024-07-18 00:45:04.172115',8,'{}','success'),(9184,'sync-table-privileges',2,'2024-07-18 00:45:04.179951','2024-07-18 00:45:04.188228',8,NULL,'success'),(9185,'analyze',2,'2024-07-18 00:45:04.222054','2024-07-18 00:45:06.297684',2075,NULL,'success'),(9186,'fingerprint-fields',2,'2024-07-18 00:45:04.230291','2024-07-18 00:45:06.157437',1927,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9187,'classify-fields',2,'2024-07-18 00:45:06.165468','2024-07-18 00:45:06.269076',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9188,'classify-tables',2,'2024-07-18 00:45:06.276319','2024-07-18 00:45:06.289664',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9189,'sync',2,'2024-07-18 01:45:00.098017','2024-07-18 01:45:04.563001',4464,NULL,'success'),(9190,'sync-dbms-version',2,'2024-07-18 01:45:00.107090','2024-07-18 01:45:00.115980',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9191,'sync-timezone',2,'2024-07-18 01:45:00.125628','2024-07-18 01:45:00.136493',10,'{\"timezone-id\":\"+08:00\"}','success'),(9192,'sync-tables',2,'2024-07-18 01:45:00.145057','2024-07-18 01:45:00.171139',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9193,'sync-fields',2,'2024-07-18 01:45:00.179637','2024-07-18 01:45:03.338826',3159,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9194,'sync-fks',2,'2024-07-18 01:45:03.346972','2024-07-18 01:45:04.009157',662,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9195,'sync-indexes',2,'2024-07-18 01:45:04.017630','2024-07-18 01:45:04.521529',503,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9196,'sync-metabase-metadata',2,'2024-07-18 01:45:04.529199','2024-07-18 01:45:04.538552',9,'{}','success'),(9197,'sync-table-privileges',2,'2024-07-18 01:45:04.546806','2024-07-18 01:45:04.554659',7,NULL,'success'),(9198,'analyze',2,'2024-07-18 01:45:04.587482','2024-07-18 01:45:06.809967',2222,NULL,'success'),(9199,'fingerprint-fields',2,'2024-07-18 01:45:04.595665','2024-07-18 01:45:06.660244',2064,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9200,'classify-fields',2,'2024-07-18 01:45:06.668542','2024-07-18 01:45:06.780243',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9201,'classify-tables',2,'2024-07-18 01:45:06.788167','2024-07-18 01:45:06.801221',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9202,'sync',2,'2024-07-18 02:45:00.106323','2024-07-18 02:45:04.906541',4800,NULL,'success'),(9203,'sync-dbms-version',2,'2024-07-18 02:45:00.114966','2024-07-18 02:45:00.124108',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9204,'sync-timezone',2,'2024-07-18 02:45:00.133027','2024-07-18 02:45:00.143897',10,'{\"timezone-id\":\"+08:00\"}','success'),(9205,'sync-tables',2,'2024-07-18 02:45:00.152867','2024-07-18 02:45:00.181414',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9206,'sync-fields',2,'2024-07-18 02:45:00.190400','2024-07-18 02:45:03.457469',3267,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9207,'sync-fks',2,'2024-07-18 02:45:03.467147','2024-07-18 02:45:04.120643',653,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9208,'sync-indexes',2,'2024-07-18 02:45:04.129852','2024-07-18 02:45:04.862285',732,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9209,'sync-metabase-metadata',2,'2024-07-18 02:45:04.870727','2024-07-18 02:45:04.880982',10,'{}','success'),(9210,'sync-table-privileges',2,'2024-07-18 02:45:04.889712','2024-07-18 02:45:04.898446',8,NULL,'success'),(9211,'analyze',2,'2024-07-18 02:45:04.931851','2024-07-18 02:45:07.031154',2099,NULL,'success'),(9212,'fingerprint-fields',2,'2024-07-18 02:45:04.940160','2024-07-18 02:45:06.884242',1944,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9213,'classify-fields',2,'2024-07-18 02:45:06.892178','2024-07-18 02:45:07.002366',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9214,'classify-tables',2,'2024-07-18 02:45:07.009538','2024-07-18 02:45:07.022462',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9215,'sync',2,'2024-07-18 03:45:00.099044','2024-07-18 03:45:04.746085',4647,NULL,'success'),(9216,'sync-dbms-version',2,'2024-07-18 03:45:00.108734','2024-07-18 03:45:00.120098',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9217,'sync-timezone',2,'2024-07-18 03:45:00.129589','2024-07-18 03:45:00.138841',9,'{\"timezone-id\":\"+08:00\"}','success'),(9218,'sync-tables',2,'2024-07-18 03:45:00.147415','2024-07-18 03:45:00.178441',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9219,'sync-fields',2,'2024-07-18 03:45:00.187298','2024-07-18 03:45:03.407833',3220,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9220,'sync-fks',2,'2024-07-18 03:45:03.415803','2024-07-18 03:45:04.082856',667,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9221,'sync-indexes',2,'2024-07-18 03:45:04.091846','2024-07-18 03:45:04.703482',611,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9222,'sync-metabase-metadata',2,'2024-07-18 03:45:04.711922','2024-07-18 03:45:04.720515',8,'{}','success'),(9223,'sync-table-privileges',2,'2024-07-18 03:45:04.729216','2024-07-18 03:45:04.737138',7,NULL,'success'),(9224,'analyze',2,'2024-07-18 03:45:04.770243','2024-07-18 03:45:06.816243',2046,NULL,'success'),(9225,'fingerprint-fields',2,'2024-07-18 03:45:04.777910','2024-07-18 03:45:06.665703',1887,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9226,'classify-fields',2,'2024-07-18 03:45:06.674187','2024-07-18 03:45:06.785075',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9227,'classify-tables',2,'2024-07-18 03:45:06.792881','2024-07-18 03:45:06.808013',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9228,'task-history-cleanup',NULL,'2024-07-18 04:00:00.065856','2024-07-18 04:00:00.078107',12,NULL,'success'),(9229,'sync',2,'2024-07-18 04:45:00.103098','2024-07-18 04:45:04.528197',4425,NULL,'success'),(9230,'sync-dbms-version',2,'2024-07-18 04:45:00.113949','2024-07-18 04:45:00.124574',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9231,'sync-timezone',2,'2024-07-18 04:45:00.133985','2024-07-18 04:45:00.144658',10,'{\"timezone-id\":\"+08:00\"}','success'),(9232,'sync-tables',2,'2024-07-18 04:45:00.153820','2024-07-18 04:45:00.183137',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9233,'sync-fields',2,'2024-07-18 04:45:00.192786','2024-07-18 04:45:03.336817',3144,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9234,'sync-fks',2,'2024-07-18 04:45:03.344229','2024-07-18 04:45:03.938261',594,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9235,'sync-indexes',2,'2024-07-18 04:45:03.947482','2024-07-18 04:45:04.486962',539,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9236,'sync-metabase-metadata',2,'2024-07-18 04:45:04.494716','2024-07-18 04:45:04.503086',8,'{}','success'),(9237,'sync-table-privileges',2,'2024-07-18 04:45:04.511286','2024-07-18 04:45:04.520037',8,NULL,'success'),(9238,'analyze',2,'2024-07-18 04:45:04.552476','2024-07-18 04:45:06.549629',1997,NULL,'success'),(9239,'fingerprint-fields',2,'2024-07-18 04:45:04.560834','2024-07-18 04:45:06.397832',1837,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9240,'classify-fields',2,'2024-07-18 04:45:06.406060','2024-07-18 04:45:06.519329',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9241,'classify-tables',2,'2024-07-18 04:45:06.527246','2024-07-18 04:45:06.541760',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9242,'sync',2,'2024-07-18 05:45:00.087148','2024-07-18 05:45:04.439474',4352,NULL,'success'),(9243,'sync-dbms-version',2,'2024-07-18 05:45:00.101665','2024-07-18 05:45:00.110128',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9244,'sync-timezone',2,'2024-07-18 05:45:00.118448','2024-07-18 05:45:00.127795',9,'{\"timezone-id\":\"+08:00\"}','success'),(9245,'sync-tables',2,'2024-07-18 05:45:00.135971','2024-07-18 05:45:00.161921',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9246,'sync-fields',2,'2024-07-18 05:45:00.170706','2024-07-18 05:45:03.268201',3097,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9247,'sync-fks',2,'2024-07-18 05:45:03.276300','2024-07-18 05:45:03.884979',608,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9248,'sync-indexes',2,'2024-07-18 05:45:03.893288','2024-07-18 05:45:04.397331',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9249,'sync-metabase-metadata',2,'2024-07-18 05:45:04.404512','2024-07-18 05:45:04.414437',9,'{}','success'),(9250,'sync-table-privileges',2,'2024-07-18 05:45:04.422765','2024-07-18 05:45:04.431440',8,NULL,'success'),(9251,'analyze',2,'2024-07-18 05:45:04.463097','2024-07-18 05:45:06.609705',2146,NULL,'success'),(9252,'fingerprint-fields',2,'2024-07-18 05:45:04.471261','2024-07-18 05:45:06.430558',1959,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9253,'classify-fields',2,'2024-07-18 05:45:06.439628','2024-07-18 05:45:06.574412',134,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9254,'classify-tables',2,'2024-07-18 05:45:06.582326','2024-07-18 05:45:06.599890',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9255,'sync',2,'2024-07-18 06:45:00.102316','2024-07-18 06:45:04.413428',4311,NULL,'success'),(9256,'sync-dbms-version',2,'2024-07-18 06:45:00.111439','2024-07-18 06:45:00.123602',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9257,'sync-timezone',2,'2024-07-18 06:45:00.132377','2024-07-18 06:45:00.142611',10,'{\"timezone-id\":\"+08:00\"}','success'),(9258,'sync-tables',2,'2024-07-18 06:45:00.151166','2024-07-18 06:45:00.176156',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9259,'sync-fields',2,'2024-07-18 06:45:00.185420','2024-07-18 06:45:03.166544',2981,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9260,'sync-fks',2,'2024-07-18 06:45:03.174364','2024-07-18 06:45:03.773640',599,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9261,'sync-indexes',2,'2024-07-18 06:45:03.782008','2024-07-18 06:45:04.373297',591,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9262,'sync-metabase-metadata',2,'2024-07-18 06:45:04.380467','2024-07-18 06:45:04.387563',7,'{}','success'),(9263,'sync-table-privileges',2,'2024-07-18 06:45:04.396282','2024-07-18 06:45:04.404856',8,NULL,'success'),(9264,'analyze',2,'2024-07-18 06:45:04.438299','2024-07-18 06:45:06.386328',1948,NULL,'success'),(9265,'fingerprint-fields',2,'2024-07-18 06:45:04.446151','2024-07-18 06:45:06.241837',1795,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9266,'classify-fields',2,'2024-07-18 06:45:06.249791','2024-07-18 06:45:06.357400',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9267,'classify-tables',2,'2024-07-18 06:45:06.364635','2024-07-18 06:45:06.376884',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9268,'sync',2,'2024-07-18 07:45:00.097652','2024-07-18 07:45:04.370809',4273,NULL,'success'),(9269,'sync-dbms-version',2,'2024-07-18 07:45:00.105281','2024-07-18 07:45:00.113945',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9270,'sync-timezone',2,'2024-07-18 07:45:00.121686','2024-07-18 07:45:00.131189',9,'{\"timezone-id\":\"+08:00\"}','success'),(9271,'sync-tables',2,'2024-07-18 07:45:00.139347','2024-07-18 07:45:00.166743',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9272,'sync-fields',2,'2024-07-18 07:45:00.174632','2024-07-18 07:45:03.121342',2946,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9273,'sync-fks',2,'2024-07-18 07:45:03.129286','2024-07-18 07:45:03.730802',601,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9274,'sync-indexes',2,'2024-07-18 07:45:03.739238','2024-07-18 07:45:04.329836',590,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9275,'sync-metabase-metadata',2,'2024-07-18 07:45:04.337238','2024-07-18 07:45:04.345104',7,'{}','success'),(9276,'sync-table-privileges',2,'2024-07-18 07:45:04.353665','2024-07-18 07:45:04.361810',8,NULL,'success'),(9277,'analyze',2,'2024-07-18 07:45:04.398126','2024-07-18 07:45:06.325768',1927,NULL,'success'),(9278,'fingerprint-fields',2,'2024-07-18 07:45:04.406731','2024-07-18 07:45:06.177538',1770,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9279,'classify-fields',2,'2024-07-18 07:45:06.185468','2024-07-18 07:45:06.297161',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9280,'classify-tables',2,'2024-07-18 07:45:06.304744','2024-07-18 07:45:06.317929',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9281,'sync',2,'2024-07-18 08:45:00.095084','2024-07-18 08:45:04.792025',4696,NULL,'success'),(9282,'sync-dbms-version',2,'2024-07-18 08:45:00.106084','2024-07-18 08:45:00.116052',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9283,'sync-timezone',2,'2024-07-18 08:45:00.125000','2024-07-18 08:45:00.135605',10,'{\"timezone-id\":\"+08:00\"}','success'),(9284,'sync-tables',2,'2024-07-18 08:45:00.144689','2024-07-18 08:45:00.172625',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9285,'sync-fields',2,'2024-07-18 08:45:00.183889','2024-07-18 08:45:02.978196',2794,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9286,'sync-fks',2,'2024-07-18 08:45:02.985972','2024-07-18 08:45:03.582739',596,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9287,'sync-indexes',2,'2024-07-18 08:45:03.590634','2024-07-18 08:45:04.752247',1161,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9288,'sync-metabase-metadata',2,'2024-07-18 08:45:04.759895','2024-07-18 08:45:04.767644',7,'{}','success'),(9289,'sync-table-privileges',2,'2024-07-18 08:45:04.775959','2024-07-18 08:45:04.784118',8,NULL,'success'),(9290,'analyze',2,'2024-07-18 08:45:04.815884','2024-07-18 08:45:06.626566',1810,NULL,'success'),(9291,'fingerprint-fields',2,'2024-07-18 08:45:04.824620','2024-07-18 08:45:06.496102',1671,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9292,'classify-fields',2,'2024-07-18 08:45:06.504029','2024-07-18 08:45:06.598992',94,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9293,'classify-tables',2,'2024-07-18 08:45:06.605864','2024-07-18 08:45:06.619263',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9294,'sync',2,'2024-07-18 09:45:00.097331','2024-07-18 09:45:04.375596',4278,NULL,'success'),(9295,'sync-dbms-version',2,'2024-07-18 09:45:00.105759','2024-07-18 09:45:00.116607',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9296,'sync-timezone',2,'2024-07-18 09:45:00.124932','2024-07-18 09:45:00.135699',10,'{\"timezone-id\":\"+08:00\"}','success'),(9297,'sync-tables',2,'2024-07-18 09:45:00.144669','2024-07-18 09:45:00.173183',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9298,'sync-fields',2,'2024-07-18 09:45:00.182037','2024-07-18 09:45:03.189042',3007,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9299,'sync-fks',2,'2024-07-18 09:45:03.197128','2024-07-18 09:45:03.796486',599,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9300,'sync-indexes',2,'2024-07-18 09:45:03.806260','2024-07-18 09:45:04.336494',530,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9301,'sync-metabase-metadata',2,'2024-07-18 09:45:04.343966','2024-07-18 09:45:04.351669',7,'{}','success'),(9302,'sync-table-privileges',2,'2024-07-18 09:45:04.359685','2024-07-18 09:45:04.367192',7,NULL,'success'),(9303,'analyze',2,'2024-07-18 09:45:04.402645','2024-07-18 09:45:06.415159',2012,NULL,'success'),(9304,'fingerprint-fields',2,'2024-07-18 09:45:04.410906','2024-07-18 09:45:06.264390',1853,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9305,'classify-fields',2,'2024-07-18 09:45:06.273427','2024-07-18 09:45:06.385130',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9306,'classify-tables',2,'2024-07-18 09:45:06.392618','2024-07-18 09:45:06.406715',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9307,'sync',2,'2024-07-18 10:45:00.106863','2024-07-18 10:45:04.483227',4376,NULL,'success'),(9308,'sync-dbms-version',2,'2024-07-18 10:45:00.116940','2024-07-18 10:45:00.129902',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9309,'sync-timezone',2,'2024-07-18 10:45:00.139421','2024-07-18 10:45:00.149965',10,'{\"timezone-id\":\"+08:00\"}','success'),(9310,'sync-tables',2,'2024-07-18 10:45:00.159936','2024-07-18 10:45:00.195742',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9311,'sync-fields',2,'2024-07-18 10:45:00.204801','2024-07-18 10:45:03.269169',3064,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9312,'sync-fks',2,'2024-07-18 10:45:03.277618','2024-07-18 10:45:03.927343',649,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9313,'sync-indexes',2,'2024-07-18 10:45:03.935965','2024-07-18 10:45:04.440167',504,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9314,'sync-metabase-metadata',2,'2024-07-18 10:45:04.449686','2024-07-18 10:45:04.458179',8,'{}','success'),(9315,'sync-table-privileges',2,'2024-07-18 10:45:04.466358','2024-07-18 10:45:04.474814',8,NULL,'success'),(9316,'analyze',2,'2024-07-18 10:45:04.509704','2024-07-18 10:45:06.511091',2001,NULL,'success'),(9317,'fingerprint-fields',2,'2024-07-18 10:45:04.517977','2024-07-18 10:45:06.363824',1845,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9318,'classify-fields',2,'2024-07-18 10:45:06.372772','2024-07-18 10:45:06.482641',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9319,'classify-tables',2,'2024-07-18 10:45:06.489996','2024-07-18 10:45:06.503329',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9320,'sync',2,'2024-07-18 11:45:00.092798','2024-07-18 11:45:04.134782',4041,NULL,'success'),(9321,'sync-dbms-version',2,'2024-07-18 11:45:00.100566','2024-07-18 11:45:00.111260',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9322,'sync-timezone',2,'2024-07-18 11:45:00.120007','2024-07-18 11:45:00.130870',10,'{\"timezone-id\":\"+08:00\"}','success'),(9323,'sync-tables',2,'2024-07-18 11:45:00.139518','2024-07-18 11:45:00.165391',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9324,'sync-fields',2,'2024-07-18 11:45:00.174271','2024-07-18 11:45:02.973132',2798,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9325,'sync-fks',2,'2024-07-18 11:45:02.981514','2024-07-18 11:45:03.565031',583,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9326,'sync-indexes',2,'2024-07-18 11:45:03.581331','2024-07-18 11:45:04.093760',512,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9327,'sync-metabase-metadata',2,'2024-07-18 11:45:04.101375','2024-07-18 11:45:04.109834',8,'{}','success'),(9328,'sync-table-privileges',2,'2024-07-18 11:45:04.118734','2024-07-18 11:45:04.126991',8,NULL,'success'),(9329,'analyze',2,'2024-07-18 11:45:04.160974','2024-07-18 11:45:06.013775',1852,NULL,'success'),(9330,'fingerprint-fields',2,'2024-07-18 11:45:04.168962','2024-07-18 11:45:05.880343',1711,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9331,'classify-fields',2,'2024-07-18 11:45:05.888137','2024-07-18 11:45:05.985889',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9332,'classify-tables',2,'2024-07-18 11:45:05.992923','2024-07-18 11:45:06.006319',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9333,'sync',2,'2024-07-18 12:45:00.103657','2024-07-18 12:45:04.669133',4565,NULL,'success'),(9334,'sync-dbms-version',2,'2024-07-18 12:45:00.113357','2024-07-18 12:45:00.122772',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9335,'sync-timezone',2,'2024-07-18 12:45:00.131567','2024-07-18 12:45:00.141333',9,'{\"timezone-id\":\"+08:00\"}','success'),(9336,'sync-tables',2,'2024-07-18 12:45:00.149989','2024-07-18 12:45:00.183298',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9337,'sync-fields',2,'2024-07-18 12:45:00.192749','2024-07-18 12:45:03.443345',3250,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9338,'sync-fks',2,'2024-07-18 12:45:03.451452','2024-07-18 12:45:04.090395',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9339,'sync-indexes',2,'2024-07-18 12:45:04.099117','2024-07-18 12:45:04.624931',525,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9340,'sync-metabase-metadata',2,'2024-07-18 12:45:04.634716','2024-07-18 12:45:04.642824',8,'{}','success'),(9341,'sync-table-privileges',2,'2024-07-18 12:45:04.651009','2024-07-18 12:45:04.659535',8,NULL,'success'),(9342,'analyze',2,'2024-07-18 12:45:04.695660','2024-07-18 12:45:06.623242',1927,NULL,'success'),(9343,'fingerprint-fields',2,'2024-07-18 12:45:04.704474','2024-07-18 12:45:06.467710',1763,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9344,'classify-fields',2,'2024-07-18 12:45:06.476130','2024-07-18 12:45:06.591274',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9345,'classify-tables',2,'2024-07-18 12:45:06.599339','2024-07-18 12:45:06.614798',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9346,'field values scanning',2,'2024-07-18 13:00:00.053116','2024-07-18 13:00:04.262930',4209,NULL,'success'),(9347,'delete-expired-advanced-field-values',2,'2024-07-18 13:00:00.066895','2024-07-18 13:00:02.891595',2824,'{\"deleted\":0}','success'),(9348,'update-field-values',2,'2024-07-18 13:00:02.898867','2024-07-18 13:00:04.254549',1355,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(9349,'sync',2,'2024-07-18 13:45:00.088705','2024-07-18 13:45:04.372391',4283,NULL,'success'),(9350,'sync-dbms-version',2,'2024-07-18 13:45:00.095936','2024-07-18 13:45:00.105603',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9351,'sync-timezone',2,'2024-07-18 13:45:00.115294','2024-07-18 13:45:00.125573',10,'{\"timezone-id\":\"+08:00\"}','success'),(9352,'sync-tables',2,'2024-07-18 13:45:00.135648','2024-07-18 13:45:00.165116',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9353,'sync-fields',2,'2024-07-18 13:45:00.173631','2024-07-18 13:45:03.115899',2942,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9354,'sync-fks',2,'2024-07-18 13:45:03.124155','2024-07-18 13:45:03.742101',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9355,'sync-indexes',2,'2024-07-18 13:45:03.750152','2024-07-18 13:45:04.334827',584,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9356,'sync-metabase-metadata',2,'2024-07-18 13:45:04.342705','2024-07-18 13:45:04.350057',7,'{}','success'),(9357,'sync-table-privileges',2,'2024-07-18 13:45:04.357478','2024-07-18 13:45:04.365005',7,NULL,'success'),(9358,'analyze',2,'2024-07-18 13:45:04.395885','2024-07-18 13:45:06.310065',1914,NULL,'success'),(9359,'fingerprint-fields',2,'2024-07-18 13:45:04.403572','2024-07-18 13:45:06.171481',1767,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9360,'classify-fields',2,'2024-07-18 13:45:06.179343','2024-07-18 13:45:06.283279',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9361,'classify-tables',2,'2024-07-18 13:45:06.290346','2024-07-18 13:45:06.302611',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9362,'sync',2,'2024-07-18 14:45:00.094438','2024-07-18 14:45:04.038640',3944,NULL,'success'),(9363,'sync-dbms-version',2,'2024-07-18 14:45:00.102577','2024-07-18 14:45:00.112999',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9364,'sync-timezone',2,'2024-07-18 14:45:00.122144','2024-07-18 14:45:00.132401',10,'{\"timezone-id\":\"+08:00\"}','success'),(9365,'sync-tables',2,'2024-07-18 14:45:00.140794','2024-07-18 14:45:00.166952',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9366,'sync-fields',2,'2024-07-18 14:45:00.175708','2024-07-18 14:45:02.965630',2789,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9367,'sync-fks',2,'2024-07-18 14:45:02.972979','2024-07-18 14:45:03.540863',567,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9368,'sync-indexes',2,'2024-07-18 14:45:03.549014','2024-07-18 14:45:04.000574',451,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9369,'sync-metabase-metadata',2,'2024-07-18 14:45:04.007862','2024-07-18 14:45:04.015699',7,'{}','success'),(9370,'sync-table-privileges',2,'2024-07-18 14:45:04.023470','2024-07-18 14:45:04.030844',7,NULL,'success'),(9371,'analyze',2,'2024-07-18 14:45:04.063236','2024-07-18 14:45:05.954408',1891,NULL,'success'),(9372,'fingerprint-fields',2,'2024-07-18 14:45:04.072859','2024-07-18 14:45:05.814834',1741,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9373,'classify-fields',2,'2024-07-18 14:45:05.822976','2024-07-18 14:45:05.926493',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9374,'classify-tables',2,'2024-07-18 14:45:05.933825','2024-07-18 14:45:05.946913',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9375,'sync',2,'2024-07-18 15:45:00.089698','2024-07-18 15:45:04.064483',3974,NULL,'success'),(9376,'sync-dbms-version',2,'2024-07-18 15:45:00.097272','2024-07-18 15:45:00.106882',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9377,'sync-timezone',2,'2024-07-18 15:45:00.115632','2024-07-18 15:45:00.124983',9,'{\"timezone-id\":\"+08:00\"}','success'),(9378,'sync-tables',2,'2024-07-18 15:45:00.132903','2024-07-18 15:45:00.158488',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9379,'sync-fields',2,'2024-07-18 15:45:00.168286','2024-07-18 15:45:03.034817',2866,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9380,'sync-fks',2,'2024-07-18 15:45:03.041794','2024-07-18 15:45:03.557717',515,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9381,'sync-indexes',2,'2024-07-18 15:45:03.565201','2024-07-18 15:45:04.022506',457,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9382,'sync-metabase-metadata',2,'2024-07-18 15:45:04.029737','2024-07-18 15:45:04.037748',8,'{}','success'),(9383,'sync-table-privileges',2,'2024-07-18 15:45:04.045742','2024-07-18 15:45:04.054962',9,NULL,'success'),(9384,'analyze',2,'2024-07-18 15:45:04.090014','2024-07-18 15:45:06.156076',2066,NULL,'success'),(9385,'fingerprint-fields',2,'2024-07-18 15:45:04.099267','2024-07-18 15:45:06.012096',1912,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9386,'classify-fields',2,'2024-07-18 15:45:06.020149','2024-07-18 15:45:06.126030',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9387,'classify-tables',2,'2024-07-18 15:45:06.135224','2024-07-18 15:45:06.148468',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9388,'task-history-cleanup',NULL,'2024-07-18 16:00:00.011480','2024-07-18 16:00:00.099920',88,NULL,'success'),(9389,'task-history-cleanup',NULL,'2024-07-18 16:00:00.043285','2024-07-18 16:00:00.082363',39,NULL,'success'),(9390,'sync',2,'2024-07-18 16:45:00.103995','2024-07-18 16:45:04.564264',4460,NULL,'success'),(9391,'sync-dbms-version',2,'2024-07-18 16:45:00.112659','2024-07-18 16:45:00.122344',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9392,'sync-timezone',2,'2024-07-18 16:45:00.131859','2024-07-18 16:45:00.141923',10,'{\"timezone-id\":\"+08:00\"}','success'),(9393,'sync-tables',2,'2024-07-18 16:45:00.152459','2024-07-18 16:45:00.182540',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9394,'sync-fields',2,'2024-07-18 16:45:00.191706','2024-07-18 16:45:03.289968',3098,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9395,'sync-fks',2,'2024-07-18 16:45:03.297961','2024-07-18 16:45:03.931347',633,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9396,'sync-indexes',2,'2024-07-18 16:45:03.940204','2024-07-18 16:45:04.523069',582,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9397,'sync-metabase-metadata',2,'2024-07-18 16:45:04.531110','2024-07-18 16:45:04.539446',8,'{}','success'),(9398,'sync-table-privileges',2,'2024-07-18 16:45:04.547974','2024-07-18 16:45:04.556154',8,NULL,'success'),(9399,'analyze',2,'2024-07-18 16:45:04.590665','2024-07-18 16:45:06.640182',2049,NULL,'success'),(9400,'fingerprint-fields',2,'2024-07-18 16:45:04.599111','2024-07-18 16:45:06.494986',1895,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9401,'classify-fields',2,'2024-07-18 16:45:06.502921','2024-07-18 16:45:06.611247',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9402,'classify-tables',2,'2024-07-18 16:45:06.618526','2024-07-18 16:45:06.632292',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9403,'sync',2,'2024-07-18 17:45:00.094047','2024-07-18 17:45:04.333650',4239,NULL,'success'),(9404,'sync-dbms-version',2,'2024-07-18 17:45:00.102425','2024-07-18 17:45:00.112005',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9405,'sync-timezone',2,'2024-07-18 17:45:00.120184','2024-07-18 17:45:00.129733',9,'{\"timezone-id\":\"+08:00\"}','success'),(9406,'sync-tables',2,'2024-07-18 17:45:00.138982','2024-07-18 17:45:00.166290',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9407,'sync-fields',2,'2024-07-18 17:45:00.174794','2024-07-18 17:45:03.127563',2952,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9408,'sync-fks',2,'2024-07-18 17:45:03.137022','2024-07-18 17:45:03.748274',611,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9409,'sync-indexes',2,'2024-07-18 17:45:03.756705','2024-07-18 17:45:04.291861',535,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9410,'sync-metabase-metadata',2,'2024-07-18 17:45:04.300876','2024-07-18 17:45:04.309315',8,'{}','success'),(9411,'sync-table-privileges',2,'2024-07-18 17:45:04.317771','2024-07-18 17:45:04.325666',7,NULL,'success'),(9412,'analyze',2,'2024-07-18 17:45:04.363768','2024-07-18 17:45:06.372210',2008,NULL,'success'),(9413,'fingerprint-fields',2,'2024-07-18 17:45:04.373194','2024-07-18 17:45:06.225559',1852,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9414,'classify-fields',2,'2024-07-18 17:45:06.233867','2024-07-18 17:45:06.343621',109,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9415,'classify-tables',2,'2024-07-18 17:45:06.350880','2024-07-18 17:45:06.364372',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9416,'sync',2,'2024-07-18 18:45:00.118870','2024-07-18 18:45:04.553264',4434,NULL,'success'),(9417,'sync-dbms-version',2,'2024-07-18 18:45:00.138340','2024-07-18 18:45:00.149025',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9418,'sync-timezone',2,'2024-07-18 18:45:00.157969','2024-07-18 18:45:00.167536',9,'{\"timezone-id\":\"+08:00\"}','success'),(9419,'sync-tables',2,'2024-07-18 18:45:00.177741','2024-07-18 18:45:00.207534',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9420,'sync-fields',2,'2024-07-18 18:45:00.216955','2024-07-18 18:45:03.259868',3042,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9421,'sync-fks',2,'2024-07-18 18:45:03.267952','2024-07-18 18:45:03.898064',630,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9422,'sync-indexes',2,'2024-07-18 18:45:03.906371','2024-07-18 18:45:04.509937',603,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9423,'sync-metabase-metadata',2,'2024-07-18 18:45:04.518541','2024-07-18 18:45:04.527738',9,'{}','success'),(9424,'sync-table-privileges',2,'2024-07-18 18:45:04.536942','2024-07-18 18:45:04.545339',8,NULL,'success'),(9425,'analyze',2,'2024-07-18 18:45:04.582074','2024-07-18 18:45:06.778682',2196,NULL,'success'),(9426,'fingerprint-fields',2,'2024-07-18 18:45:04.590515','2024-07-18 18:45:06.623945',2033,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9427,'classify-fields',2,'2024-07-18 18:45:06.632835','2024-07-18 18:45:06.747865',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9428,'classify-tables',2,'2024-07-18 18:45:06.755552','2024-07-18 18:45:06.770491',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9429,'sync',2,'2024-07-18 19:45:00.098239','2024-07-18 19:45:04.495614',4397,NULL,'success'),(9430,'sync-dbms-version',2,'2024-07-18 19:45:00.108007','2024-07-18 19:45:00.117148',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9431,'sync-timezone',2,'2024-07-18 19:45:00.125971','2024-07-18 19:45:00.136384',10,'{\"timezone-id\":\"+08:00\"}','success'),(9432,'sync-tables',2,'2024-07-18 19:45:00.146207','2024-07-18 19:45:00.176028',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9433,'sync-fields',2,'2024-07-18 19:45:00.185498','2024-07-18 19:45:03.225591',3040,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9434,'sync-fks',2,'2024-07-18 19:45:03.234094','2024-07-18 19:45:03.879983',645,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9435,'sync-indexes',2,'2024-07-18 19:45:03.888735','2024-07-18 19:45:04.452608',563,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9436,'sync-metabase-metadata',2,'2024-07-18 19:45:04.460343','2024-07-18 19:45:04.468640',8,'{}','success'),(9437,'sync-table-privileges',2,'2024-07-18 19:45:04.477519','2024-07-18 19:45:04.486731',9,NULL,'success'),(9438,'analyze',2,'2024-07-18 19:45:04.522914','2024-07-18 19:45:06.551973',2029,NULL,'success'),(9439,'fingerprint-fields',2,'2024-07-18 19:45:04.532740','2024-07-18 19:45:06.391298',1858,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9440,'classify-fields',2,'2024-07-18 19:45:06.399511','2024-07-18 19:45:06.518727',119,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9441,'classify-tables',2,'2024-07-18 19:45:06.527341','2024-07-18 19:45:06.543250',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9442,'sync',2,'2024-07-18 20:45:00.116229','2024-07-18 20:45:04.768118',4651,NULL,'success'),(9443,'sync-dbms-version',2,'2024-07-18 20:45:00.125531','2024-07-18 20:45:00.135901',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9444,'sync-timezone',2,'2024-07-18 20:45:00.144363','2024-07-18 20:45:00.155017',10,'{\"timezone-id\":\"+08:00\"}','success'),(9445,'sync-tables',2,'2024-07-18 20:45:00.165982','2024-07-18 20:45:00.193316',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9446,'sync-fields',2,'2024-07-18 20:45:00.202762','2024-07-18 20:45:03.418540',3215,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9447,'sync-fks',2,'2024-07-18 20:45:03.427053','2024-07-18 20:45:04.121715',694,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9448,'sync-indexes',2,'2024-07-18 20:45:04.131653','2024-07-18 20:45:04.727511',595,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9449,'sync-metabase-metadata',2,'2024-07-18 20:45:04.735160','2024-07-18 20:45:04.743468',8,'{}','success'),(9450,'sync-table-privileges',2,'2024-07-18 20:45:04.751085','2024-07-18 20:45:04.759384',8,NULL,'success'),(9451,'analyze',2,'2024-07-18 20:45:04.794151','2024-07-18 20:45:06.930151',2136,NULL,'success'),(9452,'fingerprint-fields',2,'2024-07-18 20:45:04.802378','2024-07-18 20:45:06.751835',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9453,'classify-fields',2,'2024-07-18 20:45:06.760295','2024-07-18 20:45:06.897940',137,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9454,'classify-tables',2,'2024-07-18 20:45:06.906550','2024-07-18 20:45:06.920915',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9455,'sync',2,'2024-07-18 21:45:00.102191','2024-07-18 21:45:04.494427',4392,NULL,'success'),(9456,'sync-dbms-version',2,'2024-07-18 21:45:00.110331','2024-07-18 21:45:00.120333',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9457,'sync-timezone',2,'2024-07-18 21:45:00.130334','2024-07-18 21:45:00.141330',10,'{\"timezone-id\":\"+08:00\"}','success'),(9458,'sync-tables',2,'2024-07-18 21:45:00.149518','2024-07-18 21:45:00.176282',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9459,'sync-fields',2,'2024-07-18 21:45:00.184893','2024-07-18 21:45:03.249350',3064,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9460,'sync-fks',2,'2024-07-18 21:45:03.256896','2024-07-18 21:45:03.877872',620,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9461,'sync-indexes',2,'2024-07-18 21:45:03.886447','2024-07-18 21:45:04.451098',564,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9462,'sync-metabase-metadata',2,'2024-07-18 21:45:04.459244','2024-07-18 21:45:04.469151',9,'{}','success'),(9463,'sync-table-privileges',2,'2024-07-18 21:45:04.477625','2024-07-18 21:45:04.485953',8,NULL,'success'),(9464,'analyze',2,'2024-07-18 21:45:04.520147','2024-07-18 21:45:06.617796',2097,NULL,'success'),(9465,'fingerprint-fields',2,'2024-07-18 21:45:04.528794','2024-07-18 21:45:06.454909',1926,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9466,'classify-fields',2,'2024-07-18 21:45:06.463769','2024-07-18 21:45:06.583827',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9467,'classify-tables',2,'2024-07-18 21:45:06.591770','2024-07-18 21:45:06.608498',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9468,'sync',2,'2024-07-18 22:45:00.106194','2024-07-18 22:45:04.412573',4306,NULL,'success'),(9469,'sync-dbms-version',2,'2024-07-18 22:45:00.114392','2024-07-18 22:45:00.124267',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9470,'sync-timezone',2,'2024-07-18 22:45:00.133064','2024-07-18 22:45:00.144487',11,'{\"timezone-id\":\"+08:00\"}','success'),(9471,'sync-tables',2,'2024-07-18 22:45:00.152964','2024-07-18 22:45:00.183970',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9472,'sync-fields',2,'2024-07-18 22:45:00.193289','2024-07-18 22:45:03.225185',3031,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9473,'sync-fks',2,'2024-07-18 22:45:03.233568','2024-07-18 22:45:03.847825',614,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9474,'sync-indexes',2,'2024-07-18 22:45:03.856042','2024-07-18 22:45:04.371677',515,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9475,'sync-metabase-metadata',2,'2024-07-18 22:45:04.378896','2024-07-18 22:45:04.387217',8,'{}','success'),(9476,'sync-table-privileges',2,'2024-07-18 22:45:04.395299','2024-07-18 22:45:04.403553',8,NULL,'success'),(9477,'analyze',2,'2024-07-18 22:45:04.438012','2024-07-18 22:45:06.477239',2039,NULL,'success'),(9478,'fingerprint-fields',2,'2024-07-18 22:45:04.445844','2024-07-18 22:45:06.307347',1861,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9479,'classify-fields',2,'2024-07-18 22:45:06.316598','2024-07-18 22:45:06.445089',128,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9480,'classify-tables',2,'2024-07-18 22:45:06.452919','2024-07-18 22:45:06.468521',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9481,'sync',2,'2024-07-18 23:45:00.096029','2024-07-18 23:45:04.521733',4425,NULL,'success'),(9482,'sync-dbms-version',2,'2024-07-18 23:45:00.104968','2024-07-18 23:45:00.115035',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9483,'sync-timezone',2,'2024-07-18 23:45:00.124118','2024-07-18 23:45:00.133791',9,'{\"timezone-id\":\"+08:00\"}','success'),(9484,'sync-tables',2,'2024-07-18 23:45:00.142356','2024-07-18 23:45:00.166738',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9485,'sync-fields',2,'2024-07-18 23:45:00.175011','2024-07-18 23:45:03.286732',3111,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9486,'sync-fks',2,'2024-07-18 23:45:03.294041','2024-07-18 23:45:03.925863',631,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9487,'sync-indexes',2,'2024-07-18 23:45:03.934126','2024-07-18 23:45:04.479485',545,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9488,'sync-metabase-metadata',2,'2024-07-18 23:45:04.487430','2024-07-18 23:45:04.495883',8,'{}','success'),(9489,'sync-table-privileges',2,'2024-07-18 23:45:04.505120','2024-07-18 23:45:04.513106',7,NULL,'success'),(9490,'analyze',2,'2024-07-18 23:45:04.546486','2024-07-18 23:45:06.705055',2158,NULL,'success'),(9491,'fingerprint-fields',2,'2024-07-18 23:45:04.554474','2024-07-18 23:45:06.545602',1991,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9492,'classify-fields',2,'2024-07-18 23:45:06.554225','2024-07-18 23:45:06.675259',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9493,'classify-tables',2,'2024-07-18 23:45:06.683300','2024-07-18 23:45:06.697173',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9494,'sync',2,'2024-07-19 00:45:00.106766','2024-07-19 00:45:04.656952',4550,NULL,'success'),(9495,'sync-dbms-version',2,'2024-07-19 00:45:00.116133','2024-07-19 00:45:00.125908',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9496,'sync-timezone',2,'2024-07-19 00:45:00.134332','2024-07-19 00:45:00.144790',10,'{\"timezone-id\":\"+08:00\"}','success'),(9497,'sync-tables',2,'2024-07-19 00:45:00.153649','2024-07-19 00:45:00.180207',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9498,'sync-fields',2,'2024-07-19 00:45:00.200303','2024-07-19 00:45:03.361227',3160,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9499,'sync-fks',2,'2024-07-19 00:45:03.368958','2024-07-19 00:45:04.019079',650,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9500,'sync-indexes',2,'2024-07-19 00:45:04.027561','2024-07-19 00:45:04.614459',586,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9501,'sync-metabase-metadata',2,'2024-07-19 00:45:04.622714','2024-07-19 00:45:04.631572',8,'{}','success'),(9502,'sync-table-privileges',2,'2024-07-19 00:45:04.640285','2024-07-19 00:45:04.649295',9,NULL,'success'),(9503,'analyze',2,'2024-07-19 00:45:04.681685','2024-07-19 00:45:06.929454',2247,NULL,'success'),(9504,'fingerprint-fields',2,'2024-07-19 00:45:04.690974','2024-07-19 00:45:06.754816',2063,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9505,'classify-fields',2,'2024-07-19 00:45:06.763147','2024-07-19 00:45:06.889371',126,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9506,'classify-tables',2,'2024-07-19 00:45:06.897529','2024-07-19 00:45:06.912271',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9507,'sync',2,'2024-07-19 01:45:00.084296','2024-07-19 01:45:04.241700',4157,NULL,'success'),(9508,'sync-dbms-version',2,'2024-07-19 01:45:00.091808','2024-07-19 01:45:00.099878',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9509,'sync-timezone',2,'2024-07-19 01:45:00.107698','2024-07-19 01:45:00.116388',8,'{\"timezone-id\":\"+08:00\"}','success'),(9510,'sync-tables',2,'2024-07-19 01:45:00.124076','2024-07-19 01:45:00.148772',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9511,'sync-fields',2,'2024-07-19 01:45:00.156915','2024-07-19 01:45:02.976233',2819,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9512,'sync-fks',2,'2024-07-19 01:45:02.985767','2024-07-19 01:45:03.632122',646,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9513,'sync-indexes',2,'2024-07-19 01:45:03.641323','2024-07-19 01:45:04.201292',559,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9514,'sync-metabase-metadata',2,'2024-07-19 01:45:04.208501','2024-07-19 01:45:04.216528',8,'{}','success'),(9515,'sync-table-privileges',2,'2024-07-19 01:45:04.224319','2024-07-19 01:45:04.233343',9,NULL,'success'),(9516,'analyze',2,'2024-07-19 01:45:04.265453','2024-07-19 01:45:06.355892',2090,NULL,'success'),(9517,'fingerprint-fields',2,'2024-07-19 01:45:04.273231','2024-07-19 01:45:06.192467',1919,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9518,'classify-fields',2,'2024-07-19 01:45:06.201793','2024-07-19 01:45:06.325050',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9519,'classify-tables',2,'2024-07-19 01:45:06.333139','2024-07-19 01:45:06.346919',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9520,'sync',2,'2024-07-19 02:45:00.099891','2024-07-19 02:45:04.743753',4643,NULL,'success'),(9521,'sync-dbms-version',2,'2024-07-19 02:45:00.111451','2024-07-19 02:45:00.121204',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9522,'sync-timezone',2,'2024-07-19 02:45:00.130046','2024-07-19 02:45:00.143145',13,'{\"timezone-id\":\"+08:00\"}','success'),(9523,'sync-tables',2,'2024-07-19 02:45:00.153636','2024-07-19 02:45:00.188381',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9524,'sync-fields',2,'2024-07-19 02:45:00.197811','2024-07-19 02:45:03.456961',3259,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9525,'sync-fks',2,'2024-07-19 02:45:03.465210','2024-07-19 02:45:04.153679',688,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9526,'sync-indexes',2,'2024-07-19 02:45:04.163035','2024-07-19 02:45:04.696499',533,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9527,'sync-metabase-metadata',2,'2024-07-19 02:45:04.704312','2024-07-19 02:45:04.712552',8,'{}','success'),(9528,'sync-table-privileges',2,'2024-07-19 02:45:04.722342','2024-07-19 02:45:04.734290',11,NULL,'success'),(9529,'analyze',2,'2024-07-19 02:45:04.770241','2024-07-19 02:45:06.847477',2077,NULL,'success'),(9530,'fingerprint-fields',2,'2024-07-19 02:45:04.779949','2024-07-19 02:45:06.674789',1894,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9531,'classify-fields',2,'2024-07-19 02:45:06.692301','2024-07-19 02:45:06.815557',123,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9532,'classify-tables',2,'2024-07-19 02:45:06.823531','2024-07-19 02:45:06.838770',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9533,'sync',2,'2024-07-19 03:45:00.107799','2024-07-19 03:45:04.671988',4564,NULL,'success'),(9534,'sync-dbms-version',2,'2024-07-19 03:45:00.116632','2024-07-19 03:45:00.126148',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9535,'sync-timezone',2,'2024-07-19 03:45:00.135393','2024-07-19 03:45:00.146032',10,'{\"timezone-id\":\"+08:00\"}','success'),(9536,'sync-tables',2,'2024-07-19 03:45:00.153882','2024-07-19 03:45:00.181620',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9537,'sync-fields',2,'2024-07-19 03:45:00.190370','2024-07-19 03:45:03.287020',3096,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9538,'sync-fks',2,'2024-07-19 03:45:03.295250','2024-07-19 03:45:03.900523',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9539,'sync-indexes',2,'2024-07-19 03:45:03.909465','2024-07-19 03:45:04.629275',719,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9540,'sync-metabase-metadata',2,'2024-07-19 03:45:04.637444','2024-07-19 03:45:04.645780',8,'{}','success'),(9541,'sync-table-privileges',2,'2024-07-19 03:45:04.653948','2024-07-19 03:45:04.662358',8,NULL,'success'),(9542,'analyze',2,'2024-07-19 03:45:04.701901','2024-07-19 03:45:06.782414',2080,NULL,'success'),(9543,'fingerprint-fields',2,'2024-07-19 03:45:04.709803','2024-07-19 03:45:06.634825',1925,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9544,'classify-fields',2,'2024-07-19 03:45:06.643161','2024-07-19 03:45:06.751733',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9545,'classify-tables',2,'2024-07-19 03:45:06.759182','2024-07-19 03:45:06.773816',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9546,'task-history-cleanup',NULL,'2024-07-19 04:00:00.064409','2024-07-19 04:00:00.075002',10,NULL,'success'),(9547,'sync',2,'2024-07-19 04:45:00.111381','2024-07-19 04:45:05.181375',5069,NULL,'success'),(9548,'sync-dbms-version',2,'2024-07-19 04:45:00.124273','2024-07-19 04:45:00.136101',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9549,'sync-timezone',2,'2024-07-19 04:45:00.145270','2024-07-19 04:45:00.157992',12,'{\"timezone-id\":\"+08:00\"}','success'),(9550,'sync-tables',2,'2024-07-19 04:45:00.168962','2024-07-19 04:45:00.202015',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9551,'sync-fields',2,'2024-07-19 04:45:00.211362','2024-07-19 04:45:03.806652',3595,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9552,'sync-fks',2,'2024-07-19 04:45:03.816729','2024-07-19 04:45:04.532226',715,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9553,'sync-indexes',2,'2024-07-19 04:45:04.541391','2024-07-19 04:45:05.135886',594,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9554,'sync-metabase-metadata',2,'2024-07-19 04:45:05.143859','2024-07-19 04:45:05.152199',8,'{}','success'),(9555,'sync-table-privileges',2,'2024-07-19 04:45:05.160963','2024-07-19 04:45:05.172196',11,NULL,'success'),(9556,'analyze',2,'2024-07-19 04:45:05.209107','2024-07-19 04:45:07.406272',2197,NULL,'success'),(9557,'fingerprint-fields',2,'2024-07-19 04:45:05.217465','2024-07-19 04:45:07.251039',2033,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9558,'classify-fields',2,'2024-07-19 04:45:07.259226','2024-07-19 04:45:07.377914',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9559,'classify-tables',2,'2024-07-19 04:45:07.385227','2024-07-19 04:45:07.398604',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9560,'sync',2,'2024-07-19 05:45:00.106363','2024-07-19 05:45:04.655899',4549,NULL,'success'),(9561,'sync-dbms-version',2,'2024-07-19 05:45:00.114323','2024-07-19 05:45:00.125755',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9562,'sync-timezone',2,'2024-07-19 05:45:00.135683','2024-07-19 05:45:00.158007',22,'{\"timezone-id\":\"+08:00\"}','success'),(9563,'sync-tables',2,'2024-07-19 05:45:00.166839','2024-07-19 05:45:00.198837',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9564,'sync-fields',2,'2024-07-19 05:45:00.207888','2024-07-19 05:45:03.401662',3193,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9565,'sync-fks',2,'2024-07-19 05:45:03.409728','2024-07-19 05:45:04.036146',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9566,'sync-indexes',2,'2024-07-19 05:45:04.044746','2024-07-19 05:45:04.614373',569,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9567,'sync-metabase-metadata',2,'2024-07-19 05:45:04.622555','2024-07-19 05:45:04.631298',8,'{}','success'),(9568,'sync-table-privileges',2,'2024-07-19 05:45:04.639620','2024-07-19 05:45:04.647663',8,NULL,'success'),(9569,'analyze',2,'2024-07-19 05:45:04.685312','2024-07-19 05:45:06.833310',2148,NULL,'success'),(9570,'fingerprint-fields',2,'2024-07-19 05:45:04.695663','2024-07-19 05:45:06.665643',1969,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9571,'classify-fields',2,'2024-07-19 05:45:06.675592','2024-07-19 05:45:06.799694',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9572,'classify-tables',2,'2024-07-19 05:45:06.808308','2024-07-19 05:45:06.823772',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9573,'sync',2,'2024-07-19 06:45:00.101771','2024-07-19 06:45:04.966755',4864,NULL,'success'),(9574,'sync-dbms-version',2,'2024-07-19 06:45:00.110561','2024-07-19 06:45:00.120198',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9575,'sync-timezone',2,'2024-07-19 06:45:00.128952','2024-07-19 06:45:00.139789',10,'{\"timezone-id\":\"+08:00\"}','success'),(9576,'sync-tables',2,'2024-07-19 06:45:00.148479','2024-07-19 06:45:00.177012',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9577,'sync-fields',2,'2024-07-19 06:45:00.185553','2024-07-19 06:45:03.445520',3259,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9578,'sync-fks',2,'2024-07-19 06:45:03.454244','2024-07-19 06:45:04.155695',701,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9579,'sync-indexes',2,'2024-07-19 06:45:04.164956','2024-07-19 06:45:04.918955',754,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9580,'sync-metabase-metadata',2,'2024-07-19 06:45:04.928296','2024-07-19 06:45:04.936831',8,'{}','success'),(9581,'sync-table-privileges',2,'2024-07-19 06:45:04.948608','2024-07-19 06:45:04.957733',9,NULL,'success'),(9582,'analyze',2,'2024-07-19 06:45:04.997896','2024-07-19 06:45:07.279686',2281,NULL,'success'),(9583,'fingerprint-fields',2,'2024-07-19 06:45:05.008391','2024-07-19 06:45:07.107143',2098,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9584,'classify-fields',2,'2024-07-19 06:45:07.115910','2024-07-19 06:45:07.245378',129,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9585,'classify-tables',2,'2024-07-19 06:45:07.253612','2024-07-19 06:45:07.270828',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9586,'sync',2,'2024-07-19 07:45:00.099380','2024-07-19 07:45:04.536618',4437,NULL,'success'),(9587,'sync-dbms-version',2,'2024-07-19 07:45:00.107860','2024-07-19 07:45:00.118006',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9588,'sync-timezone',2,'2024-07-19 07:45:00.126432','2024-07-19 07:45:00.137758',11,'{\"timezone-id\":\"+08:00\"}','success'),(9589,'sync-tables',2,'2024-07-19 07:45:00.145979','2024-07-19 07:45:00.173041',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9590,'sync-fields',2,'2024-07-19 07:45:00.181454','2024-07-19 07:45:03.230319',3048,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9591,'sync-fks',2,'2024-07-19 07:45:03.238186','2024-07-19 07:45:03.876892',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9592,'sync-indexes',2,'2024-07-19 07:45:03.885896','2024-07-19 07:45:04.487565',601,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9593,'sync-metabase-metadata',2,'2024-07-19 07:45:04.496474','2024-07-19 07:45:04.507007',10,'{}','success'),(9594,'sync-table-privileges',2,'2024-07-19 07:45:04.517892','2024-07-19 07:45:04.527134',9,NULL,'success'),(9595,'analyze',2,'2024-07-19 07:45:04.562839','2024-07-19 07:45:06.673414',2110,NULL,'success'),(9596,'fingerprint-fields',2,'2024-07-19 07:45:04.571507','2024-07-19 07:45:06.520845',1949,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9597,'classify-fields',2,'2024-07-19 07:45:06.529074','2024-07-19 07:45:06.644246',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9598,'classify-tables',2,'2024-07-19 07:45:06.651768','2024-07-19 07:45:06.664911',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9599,'sync',2,'2024-07-19 08:45:00.101816','2024-07-19 08:45:04.845648',4743,NULL,'success'),(9600,'sync-dbms-version',2,'2024-07-19 08:45:00.110799','2024-07-19 08:45:00.119710',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9601,'sync-timezone',2,'2024-07-19 08:45:00.129230','2024-07-19 08:45:00.139747',10,'{\"timezone-id\":\"+08:00\"}','success'),(9602,'sync-tables',2,'2024-07-19 08:45:00.148974','2024-07-19 08:45:00.178326',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9603,'sync-fields',2,'2024-07-19 08:45:00.186937','2024-07-19 08:45:03.427141',3240,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9604,'sync-fks',2,'2024-07-19 08:45:03.435667','2024-07-19 08:45:04.041567',605,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9605,'sync-indexes',2,'2024-07-19 08:45:04.050122','2024-07-19 08:45:04.800525',750,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9606,'sync-metabase-metadata',2,'2024-07-19 08:45:04.809654','2024-07-19 08:45:04.818521',8,'{}','success'),(9607,'sync-table-privileges',2,'2024-07-19 08:45:04.826979','2024-07-19 08:45:04.835798',8,NULL,'success'),(9608,'analyze',2,'2024-07-19 08:45:04.870782','2024-07-19 08:45:06.846326',1975,NULL,'success'),(9609,'fingerprint-fields',2,'2024-07-19 08:45:04.880207','2024-07-19 08:45:06.704477',1824,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9610,'classify-fields',2,'2024-07-19 08:45:06.712255','2024-07-19 08:45:06.817039',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9611,'classify-tables',2,'2024-07-19 08:45:06.824272','2024-07-19 08:45:06.838418',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9612,'sync',2,'2024-07-19 09:45:00.092606','2024-07-19 09:45:05.033625',4941,NULL,'success'),(9613,'sync-dbms-version',2,'2024-07-19 09:45:00.100382','2024-07-19 09:45:00.109955',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9614,'sync-timezone',2,'2024-07-19 09:45:00.118492','2024-07-19 09:45:00.127626',9,'{\"timezone-id\":\"+08:00\"}','success'),(9615,'sync-tables',2,'2024-07-19 09:45:00.136003','2024-07-19 09:45:00.160996',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9616,'sync-fields',2,'2024-07-19 09:45:00.169184','2024-07-19 09:45:03.193740',3024,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9617,'sync-fks',2,'2024-07-19 09:45:03.201867','2024-07-19 09:45:03.857811',655,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9618,'sync-indexes',2,'2024-07-19 09:45:03.866672','2024-07-19 09:45:04.990596',1123,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9619,'sync-metabase-metadata',2,'2024-07-19 09:45:04.998392','2024-07-19 09:45:05.007210',8,'{}','success'),(9620,'sync-table-privileges',2,'2024-07-19 09:45:05.016814','2024-07-19 09:45:05.024855',8,NULL,'success'),(9621,'analyze',2,'2024-07-19 09:45:05.057731','2024-07-19 09:45:06.940910',1883,NULL,'success'),(9622,'fingerprint-fields',2,'2024-07-19 09:45:05.066130','2024-07-19 09:45:06.800436',1734,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9623,'classify-fields',2,'2024-07-19 09:45:06.809928','2024-07-19 09:45:06.912064',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9624,'classify-tables',2,'2024-07-19 09:45:06.919483','2024-07-19 09:45:06.933189',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9625,'sync',2,'2024-07-19 10:45:00.102280','2024-07-19 10:45:04.233169',4130,NULL,'success'),(9626,'sync-dbms-version',2,'2024-07-19 10:45:00.111608','2024-07-19 10:45:00.121432',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9627,'sync-timezone',2,'2024-07-19 10:45:00.130223','2024-07-19 10:45:00.140042',9,'{\"timezone-id\":\"+08:00\"}','success'),(9628,'sync-tables',2,'2024-07-19 10:45:00.148736','2024-07-19 10:45:00.181766',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9629,'sync-fields',2,'2024-07-19 10:45:00.190887','2024-07-19 10:45:03.075319',2884,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9630,'sync-fks',2,'2024-07-19 10:45:03.082813','2024-07-19 10:45:03.660672',577,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9631,'sync-indexes',2,'2024-07-19 10:45:03.669299','2024-07-19 10:45:04.188875',519,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9632,'sync-metabase-metadata',2,'2024-07-19 10:45:04.196922','2024-07-19 10:45:04.206736',9,'{}','success'),(9633,'sync-table-privileges',2,'2024-07-19 10:45:04.215864','2024-07-19 10:45:04.224876',9,NULL,'success'),(9634,'analyze',2,'2024-07-19 10:45:04.257093','2024-07-19 10:45:06.230966',1973,NULL,'success'),(9635,'fingerprint-fields',2,'2024-07-19 10:45:04.265516','2024-07-19 10:45:06.085169',1819,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9636,'classify-fields',2,'2024-07-19 10:45:06.092975','2024-07-19 10:45:06.199762',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9637,'classify-tables',2,'2024-07-19 10:45:06.207724','2024-07-19 10:45:06.223017',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9638,'sync',2,'2024-07-19 11:45:00.095792','2024-07-19 11:45:04.457200',4361,NULL,'success'),(9639,'sync-dbms-version',2,'2024-07-19 11:45:00.103196','2024-07-19 11:45:00.111826',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9640,'sync-timezone',2,'2024-07-19 11:45:00.120113','2024-07-19 11:45:00.129023',8,'{\"timezone-id\":\"+08:00\"}','success'),(9641,'sync-tables',2,'2024-07-19 11:45:00.138363','2024-07-19 11:45:00.172156',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9642,'sync-fields',2,'2024-07-19 11:45:00.181323','2024-07-19 11:45:03.238456',3057,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9643,'sync-fks',2,'2024-07-19 11:45:03.248630','2024-07-19 11:45:03.842902',594,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9644,'sync-indexes',2,'2024-07-19 11:45:03.851524','2024-07-19 11:45:04.414444',562,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9645,'sync-metabase-metadata',2,'2024-07-19 11:45:04.422332','2024-07-19 11:45:04.432681',10,'{}','success'),(9646,'sync-table-privileges',2,'2024-07-19 11:45:04.441287','2024-07-19 11:45:04.449371',8,NULL,'success'),(9647,'analyze',2,'2024-07-19 11:45:04.484625','2024-07-19 11:45:06.444954',1960,NULL,'success'),(9648,'fingerprint-fields',2,'2024-07-19 11:45:04.493723','2024-07-19 11:45:06.293747',1800,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9649,'classify-fields',2,'2024-07-19 11:45:06.302167','2024-07-19 11:45:06.416331',114,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9650,'classify-tables',2,'2024-07-19 11:45:06.423690','2024-07-19 11:45:06.436752',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9651,'sync',2,'2024-07-19 12:45:00.104670','2024-07-19 12:45:04.310155',4205,NULL,'success'),(9652,'sync-dbms-version',2,'2024-07-19 12:45:00.113161','2024-07-19 12:45:00.123796',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9653,'sync-timezone',2,'2024-07-19 12:45:00.132484','2024-07-19 12:45:00.143809',11,'{\"timezone-id\":\"+08:00\"}','success'),(9654,'sync-tables',2,'2024-07-19 12:45:00.152630','2024-07-19 12:45:00.182826',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9655,'sync-fields',2,'2024-07-19 12:45:00.192432','2024-07-19 12:45:03.022156',2829,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9656,'sync-fks',2,'2024-07-19 12:45:03.030597','2024-07-19 12:45:03.674437',643,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9657,'sync-indexes',2,'2024-07-19 12:45:03.682993','2024-07-19 12:45:04.262512',579,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9658,'sync-metabase-metadata',2,'2024-07-19 12:45:04.270766','2024-07-19 12:45:04.279903',9,'{}','success'),(9659,'sync-table-privileges',2,'2024-07-19 12:45:04.288708','2024-07-19 12:45:04.299636',10,NULL,'success'),(9660,'analyze',2,'2024-07-19 12:45:04.337083','2024-07-19 12:45:06.421265',2084,NULL,'success'),(9661,'fingerprint-fields',2,'2024-07-19 12:45:04.346182','2024-07-19 12:45:06.275044',1928,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9662,'classify-fields',2,'2024-07-19 12:45:06.283756','2024-07-19 12:45:06.391873',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9663,'classify-tables',2,'2024-07-19 12:45:06.399267','2024-07-19 12:45:06.412978',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9664,'field values scanning',2,'2024-07-19 13:00:00.059374','2024-07-19 13:00:04.103398',4044,NULL,'success'),(9665,'delete-expired-advanced-field-values',2,'2024-07-19 13:00:00.070303','2024-07-19 13:00:02.857656',2787,'{\"deleted\":0}','success'),(9666,'update-field-values',2,'2024-07-19 13:00:02.867766','2024-07-19 13:00:04.095634',1227,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(9667,'sync',2,'2024-07-19 13:45:00.099005','2024-07-19 13:45:04.073805',3974,NULL,'success'),(9668,'sync-dbms-version',2,'2024-07-19 13:45:00.106867','2024-07-19 13:45:00.115643',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9669,'sync-timezone',2,'2024-07-19 13:45:00.124106','2024-07-19 13:45:00.133514',9,'{\"timezone-id\":\"+08:00\"}','success'),(9670,'sync-tables',2,'2024-07-19 13:45:00.141377','2024-07-19 13:45:00.166150',24,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9671,'sync-fields',2,'2024-07-19 13:45:00.174123','2024-07-19 13:45:02.850225',2676,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9672,'sync-fks',2,'2024-07-19 13:45:02.858158','2024-07-19 13:45:03.502962',644,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9673,'sync-indexes',2,'2024-07-19 13:45:03.514242','2024-07-19 13:45:04.030916',516,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9674,'sync-metabase-metadata',2,'2024-07-19 13:45:04.038421','2024-07-19 13:45:04.046367',7,'{}','success'),(9675,'sync-table-privileges',2,'2024-07-19 13:45:04.054699','2024-07-19 13:45:04.064872',10,NULL,'success'),(9676,'analyze',2,'2024-07-19 13:45:04.101237','2024-07-19 13:45:06.139268',2038,NULL,'success'),(9677,'fingerprint-fields',2,'2024-07-19 13:45:04.110232','2024-07-19 13:45:05.993354',1883,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9678,'classify-fields',2,'2024-07-19 13:45:06.001228','2024-07-19 13:45:06.112344',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9679,'classify-tables',2,'2024-07-19 13:45:06.119305','2024-07-19 13:45:06.131449',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9680,'sync',2,'2024-07-19 14:45:00.103218','2024-07-19 14:45:04.512530',4409,NULL,'success'),(9681,'sync-dbms-version',2,'2024-07-19 14:45:00.112531','2024-07-19 14:45:00.123043',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9682,'sync-timezone',2,'2024-07-19 14:45:00.132782','2024-07-19 14:45:00.144623',11,'{\"timezone-id\":\"+08:00\"}','success'),(9683,'sync-tables',2,'2024-07-19 14:45:00.153790','2024-07-19 14:45:00.186282',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9684,'sync-fields',2,'2024-07-19 14:45:00.196817','2024-07-19 14:45:03.232400',3035,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9685,'sync-fks',2,'2024-07-19 14:45:03.241034','2024-07-19 14:45:03.906125',665,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9686,'sync-indexes',2,'2024-07-19 14:45:03.915128','2024-07-19 14:45:04.470536',555,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9687,'sync-metabase-metadata',2,'2024-07-19 14:45:04.479250','2024-07-19 14:45:04.487413',8,'{}','success'),(9688,'sync-table-privileges',2,'2024-07-19 14:45:04.495705','2024-07-19 14:45:04.503967',8,NULL,'success'),(9689,'analyze',2,'2024-07-19 14:45:04.537448','2024-07-19 14:45:06.494773',1957,NULL,'success'),(9690,'fingerprint-fields',2,'2024-07-19 14:45:04.545799','2024-07-19 14:45:06.340442',1794,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9691,'classify-fields',2,'2024-07-19 14:45:06.351797','2024-07-19 14:45:06.464295',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9692,'classify-tables',2,'2024-07-19 14:45:06.473427','2024-07-19 14:45:06.486807',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9693,'sync',2,'2024-07-19 15:45:00.098643','2024-07-19 15:45:04.331312',4232,NULL,'success'),(9694,'sync-dbms-version',2,'2024-07-19 15:45:00.110886','2024-07-19 15:45:00.122918',12,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9695,'sync-timezone',2,'2024-07-19 15:45:00.132242','2024-07-19 15:45:00.143255',11,'{\"timezone-id\":\"+08:00\"}','success'),(9696,'sync-tables',2,'2024-07-19 15:45:00.152389','2024-07-19 15:45:00.178340',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9697,'sync-fields',2,'2024-07-19 15:45:00.186694','2024-07-19 15:45:03.189842',3003,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9698,'sync-fks',2,'2024-07-19 15:45:03.197184','2024-07-19 15:45:03.757359',560,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9699,'sync-indexes',2,'2024-07-19 15:45:03.765389','2024-07-19 15:45:04.293565',528,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9700,'sync-metabase-metadata',2,'2024-07-19 15:45:04.300624','2024-07-19 15:45:04.308285',7,'{}','success'),(9701,'sync-table-privileges',2,'2024-07-19 15:45:04.315909','2024-07-19 15:45:04.323779',7,NULL,'success'),(9702,'analyze',2,'2024-07-19 15:45:04.355006','2024-07-19 15:45:06.419052',2064,NULL,'success'),(9703,'fingerprint-fields',2,'2024-07-19 15:45:04.362425','2024-07-19 15:45:06.263456',1901,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9704,'classify-fields',2,'2024-07-19 15:45:06.271641','2024-07-19 15:45:06.389054',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9705,'classify-tables',2,'2024-07-19 15:45:06.396821','2024-07-19 15:45:06.410755',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9706,'task-history-cleanup',NULL,'2024-07-19 16:00:00.027846','2024-07-19 16:00:00.074467',46,NULL,'success'),(9707,'task-history-cleanup',NULL,'2024-07-19 16:00:00.092111','2024-07-19 16:00:00.116068',23,NULL,'success'),(9708,'sync',2,'2024-07-19 16:45:00.100539','2024-07-19 16:45:04.356447',4255,NULL,'success'),(9709,'sync-dbms-version',2,'2024-07-19 16:45:00.108905','2024-07-19 16:45:00.118430',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9710,'sync-timezone',2,'2024-07-19 16:45:00.127054','2024-07-19 16:45:00.138462',11,'{\"timezone-id\":\"+08:00\"}','success'),(9711,'sync-tables',2,'2024-07-19 16:45:00.147039','2024-07-19 16:45:00.176300',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9712,'sync-fields',2,'2024-07-19 16:45:00.185066','2024-07-19 16:45:03.229892',3044,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9713,'sync-fks',2,'2024-07-19 16:45:03.237292','2024-07-19 16:45:03.786146',548,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9714,'sync-indexes',2,'2024-07-19 16:45:03.793946','2024-07-19 16:45:04.315384',521,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9715,'sync-metabase-metadata',2,'2024-07-19 16:45:04.322542','2024-07-19 16:45:04.329545',7,'{}','success'),(9716,'sync-table-privileges',2,'2024-07-19 16:45:04.337768','2024-07-19 16:45:04.346717',8,NULL,'success'),(9717,'analyze',2,'2024-07-19 16:45:04.380004','2024-07-19 16:45:06.293286',1913,NULL,'success'),(9718,'fingerprint-fields',2,'2024-07-19 16:45:04.387841','2024-07-19 16:45:06.145412',1757,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9719,'classify-fields',2,'2024-07-19 16:45:06.153476','2024-07-19 16:45:06.264026',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9720,'classify-tables',2,'2024-07-19 16:45:06.271324','2024-07-19 16:45:06.285649',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9721,'sync',2,'2024-07-19 17:45:00.108129','2024-07-19 17:45:04.627211',4519,NULL,'success'),(9722,'sync-dbms-version',2,'2024-07-19 17:45:00.116034','2024-07-19 17:45:00.125231',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9723,'sync-timezone',2,'2024-07-19 17:45:00.134304','2024-07-19 17:45:00.145203',10,'{\"timezone-id\":\"+08:00\"}','success'),(9724,'sync-tables',2,'2024-07-19 17:45:00.154144','2024-07-19 17:45:00.180019',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9725,'sync-fields',2,'2024-07-19 17:45:00.189064','2024-07-19 17:45:03.334760',3145,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9726,'sync-fks',2,'2024-07-19 17:45:03.343193','2024-07-19 17:45:03.996153',652,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9727,'sync-indexes',2,'2024-07-19 17:45:04.005025','2024-07-19 17:45:04.586726',581,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9728,'sync-metabase-metadata',2,'2024-07-19 17:45:04.594393','2024-07-19 17:45:04.602574',8,'{}','success'),(9729,'sync-table-privileges',2,'2024-07-19 17:45:04.610819','2024-07-19 17:45:04.619034',8,NULL,'success'),(9730,'analyze',2,'2024-07-19 17:45:04.651418','2024-07-19 17:45:06.669520',2018,NULL,'success'),(9731,'fingerprint-fields',2,'2024-07-19 17:45:04.659531','2024-07-19 17:45:06.520125',1860,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9732,'classify-fields',2,'2024-07-19 17:45:06.528329','2024-07-19 17:45:06.638862',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9733,'classify-tables',2,'2024-07-19 17:45:06.646524','2024-07-19 17:45:06.659974',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9734,'sync',2,'2024-07-19 18:45:00.102334','2024-07-19 18:45:04.438540',4336,NULL,'success'),(9735,'sync-dbms-version',2,'2024-07-19 18:45:00.111216','2024-07-19 18:45:00.120519',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9736,'sync-timezone',2,'2024-07-19 18:45:00.128782','2024-07-19 18:45:00.138444',9,'{\"timezone-id\":\"+08:00\"}','success'),(9737,'sync-tables',2,'2024-07-19 18:45:00.148022','2024-07-19 18:45:00.183693',35,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9738,'sync-fields',2,'2024-07-19 18:45:00.193805','2024-07-19 18:45:03.259645',3065,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9739,'sync-fks',2,'2024-07-19 18:45:03.267867','2024-07-19 18:45:03.881559',613,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9740,'sync-indexes',2,'2024-07-19 18:45:03.889333','2024-07-19 18:45:04.395877',506,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9741,'sync-metabase-metadata',2,'2024-07-19 18:45:04.403613','2024-07-19 18:45:04.412347',8,'{}','success'),(9742,'sync-table-privileges',2,'2024-07-19 18:45:04.421121','2024-07-19 18:45:04.430474',9,NULL,'success'),(9743,'analyze',2,'2024-07-19 18:45:04.462484','2024-07-19 18:45:06.446993',1984,NULL,'success'),(9744,'fingerprint-fields',2,'2024-07-19 18:45:04.470262','2024-07-19 18:45:06.307549',1837,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9745,'classify-fields',2,'2024-07-19 18:45:06.315319','2024-07-19 18:45:06.417001',101,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9746,'classify-tables',2,'2024-07-19 18:45:06.424628','2024-07-19 18:45:06.438329',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9747,'sync',2,'2024-07-19 19:45:00.096874','2024-07-19 19:45:04.692707',4595,NULL,'success'),(9748,'sync-dbms-version',2,'2024-07-19 19:45:00.104847','2024-07-19 19:45:00.114349',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9749,'sync-timezone',2,'2024-07-19 19:45:00.122991','2024-07-19 19:45:00.134289',11,'{\"timezone-id\":\"+08:00\"}','success'),(9750,'sync-tables',2,'2024-07-19 19:45:00.143112','2024-07-19 19:45:00.168857',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9751,'sync-fields',2,'2024-07-19 19:45:00.179599','2024-07-19 19:45:03.351538',3171,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9752,'sync-fks',2,'2024-07-19 19:45:03.360353','2024-07-19 19:45:04.040289',679,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9753,'sync-indexes',2,'2024-07-19 19:45:04.049395','2024-07-19 19:45:04.646830',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9754,'sync-metabase-metadata',2,'2024-07-19 19:45:04.655258','2024-07-19 19:45:04.664158',8,'{}','success'),(9755,'sync-table-privileges',2,'2024-07-19 19:45:04.673817','2024-07-19 19:45:04.683709',9,NULL,'success'),(9756,'analyze',2,'2024-07-19 19:45:04.720543','2024-07-19 19:45:06.784430',2063,NULL,'success'),(9757,'fingerprint-fields',2,'2024-07-19 19:45:04.730110','2024-07-19 19:45:06.638832',1908,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9758,'classify-fields',2,'2024-07-19 19:45:06.646622','2024-07-19 19:45:06.755476',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9759,'classify-tables',2,'2024-07-19 19:45:06.763364','2024-07-19 19:45:06.776535',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9760,'sync',2,'2024-07-19 20:45:00.093989','2024-07-19 20:45:04.717593',4623,NULL,'success'),(9761,'sync-dbms-version',2,'2024-07-19 20:45:00.101436','2024-07-19 20:45:00.109786',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9762,'sync-timezone',2,'2024-07-19 20:45:00.119083','2024-07-19 20:45:00.129415',10,'{\"timezone-id\":\"+08:00\"}','success'),(9763,'sync-tables',2,'2024-07-19 20:45:00.137874','2024-07-19 20:45:00.164709',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9764,'sync-fields',2,'2024-07-19 20:45:00.173563','2024-07-19 20:45:03.378577',3205,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9765,'sync-fks',2,'2024-07-19 20:45:03.386988','2024-07-19 20:45:04.079825',692,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9766,'sync-indexes',2,'2024-07-19 20:45:04.089448','2024-07-19 20:45:04.671137',581,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9767,'sync-metabase-metadata',2,'2024-07-19 20:45:04.679034','2024-07-19 20:45:04.689051',10,'{}','success'),(9768,'sync-table-privileges',2,'2024-07-19 20:45:04.698673','2024-07-19 20:45:04.707840',9,NULL,'success'),(9769,'analyze',2,'2024-07-19 20:45:04.744208','2024-07-19 20:45:06.915367',2171,NULL,'success'),(9770,'fingerprint-fields',2,'2024-07-19 20:45:04.753433','2024-07-19 20:45:06.766553',2013,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9771,'classify-fields',2,'2024-07-19 20:45:06.774477','2024-07-19 20:45:06.885041',110,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9772,'classify-tables',2,'2024-07-19 20:45:06.892695','2024-07-19 20:45:06.906908',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9773,'sync',2,'2024-07-19 21:45:00.105189','2024-07-19 21:45:04.190246',4085,NULL,'success'),(9774,'sync-dbms-version',2,'2024-07-19 21:45:00.114143','2024-07-19 21:45:00.124463',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9775,'sync-timezone',2,'2024-07-19 21:45:00.133261','2024-07-19 21:45:00.142866',9,'{\"timezone-id\":\"+08:00\"}','success'),(9776,'sync-tables',2,'2024-07-19 21:45:00.150874','2024-07-19 21:45:00.178609',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9777,'sync-fields',2,'2024-07-19 21:45:00.187598','2024-07-19 21:45:03.135826',2948,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9778,'sync-fks',2,'2024-07-19 21:45:03.143449','2024-07-19 21:45:03.687017',543,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9779,'sync-indexes',2,'2024-07-19 21:45:03.694905','2024-07-19 21:45:04.151561',456,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9780,'sync-metabase-metadata',2,'2024-07-19 21:45:04.158824','2024-07-19 21:45:04.166900',8,'{}','success'),(9781,'sync-table-privileges',2,'2024-07-19 21:45:04.174819','2024-07-19 21:45:04.182744',7,NULL,'success'),(9782,'analyze',2,'2024-07-19 21:45:04.214420','2024-07-19 21:45:06.192566',1978,NULL,'success'),(9783,'fingerprint-fields',2,'2024-07-19 21:45:04.222288','2024-07-19 21:45:06.034994',1812,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9784,'classify-fields',2,'2024-07-19 21:45:06.043324','2024-07-19 21:45:06.161998',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9785,'classify-tables',2,'2024-07-19 21:45:06.169390','2024-07-19 21:45:06.184127',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9786,'sync',2,'2024-07-19 22:45:00.108489','2024-07-19 22:45:04.578539',4470,NULL,'success'),(9787,'sync-dbms-version',2,'2024-07-19 22:45:00.122463','2024-07-19 22:45:00.132859',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9788,'sync-timezone',2,'2024-07-19 22:45:00.142603','2024-07-19 22:45:00.153522',10,'{\"timezone-id\":\"+08:00\"}','success'),(9789,'sync-tables',2,'2024-07-19 22:45:00.162780','2024-07-19 22:45:00.188861',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9790,'sync-fields',2,'2024-07-19 22:45:00.198824','2024-07-19 22:45:03.272075',3073,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9791,'sync-fks',2,'2024-07-19 22:45:03.279339','2024-07-19 22:45:03.987029',707,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9792,'sync-indexes',2,'2024-07-19 22:45:03.996500','2024-07-19 22:45:04.537468',540,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9793,'sync-metabase-metadata',2,'2024-07-19 22:45:04.544771','2024-07-19 22:45:04.552751',7,'{}','success'),(9794,'sync-table-privileges',2,'2024-07-19 22:45:04.560823','2024-07-19 22:45:04.569352',8,NULL,'success'),(9795,'analyze',2,'2024-07-19 22:45:04.602912','2024-07-19 22:45:06.687412',2084,NULL,'success'),(9796,'fingerprint-fields',2,'2024-07-19 22:45:04.611366','2024-07-19 22:45:06.523164',1911,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9797,'classify-fields',2,'2024-07-19 22:45:06.531047','2024-07-19 22:45:06.655900',124,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9798,'classify-tables',2,'2024-07-19 22:45:06.663794','2024-07-19 22:45:06.678475',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9799,'sync',2,'2024-07-19 23:45:00.094496','2024-07-19 23:45:04.486949',4392,NULL,'success'),(9800,'sync-dbms-version',2,'2024-07-19 23:45:00.104067','2024-07-19 23:45:00.113165',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9801,'sync-timezone',2,'2024-07-19 23:45:00.122533','2024-07-19 23:45:00.132893',10,'{\"timezone-id\":\"+08:00\"}','success'),(9802,'sync-tables',2,'2024-07-19 23:45:00.141288','2024-07-19 23:45:00.173055',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9803,'sync-fields',2,'2024-07-19 23:45:00.181804','2024-07-19 23:45:03.298606',3116,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9804,'sync-fks',2,'2024-07-19 23:45:03.308516','2024-07-19 23:45:03.945084',636,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9805,'sync-indexes',2,'2024-07-19 23:45:03.954074','2024-07-19 23:45:04.447380',493,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9806,'sync-metabase-metadata',2,'2024-07-19 23:45:04.454425','2024-07-19 23:45:04.462350',7,'{}','success'),(9807,'sync-table-privileges',2,'2024-07-19 23:45:04.470138','2024-07-19 23:45:04.478844',8,NULL,'success'),(9808,'analyze',2,'2024-07-19 23:45:04.509828','2024-07-19 23:45:06.371743',1861,NULL,'success'),(9809,'fingerprint-fields',2,'2024-07-19 23:45:04.517421','2024-07-19 23:45:06.228942',1711,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9810,'classify-fields',2,'2024-07-19 23:45:06.237652','2024-07-19 23:45:06.343276',105,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9811,'classify-tables',2,'2024-07-19 23:45:06.350759','2024-07-19 23:45:06.363530',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9812,'sync',2,'2024-07-20 00:45:00.095914','2024-07-20 00:45:04.464260',4368,NULL,'success'),(9813,'sync-dbms-version',2,'2024-07-20 00:45:00.105038','2024-07-20 00:45:00.115296',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9814,'sync-timezone',2,'2024-07-20 00:45:00.124061','2024-07-20 00:45:00.134833',10,'{\"timezone-id\":\"+08:00\"}','success'),(9815,'sync-tables',2,'2024-07-20 00:45:00.143967','2024-07-20 00:45:00.172754',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9816,'sync-fields',2,'2024-07-20 00:45:00.181303','2024-07-20 00:45:03.185217',3003,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9817,'sync-fks',2,'2024-07-20 00:45:03.193201','2024-07-20 00:45:03.851857',658,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9818,'sync-indexes',2,'2024-07-20 00:45:03.860469','2024-07-20 00:45:04.423050',562,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9819,'sync-metabase-metadata',2,'2024-07-20 00:45:04.430817','2024-07-20 00:45:04.438716',7,'{}','success'),(9820,'sync-table-privileges',2,'2024-07-20 00:45:04.447438','2024-07-20 00:45:04.456147',8,NULL,'success'),(9821,'analyze',2,'2024-07-20 00:45:04.491165','2024-07-20 00:45:06.578031',2086,NULL,'success'),(9822,'fingerprint-fields',2,'2024-07-20 00:45:04.499521','2024-07-20 00:45:06.408081',1908,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9823,'classify-fields',2,'2024-07-20 00:45:06.418766','2024-07-20 00:45:06.544532',125,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9824,'classify-tables',2,'2024-07-20 00:45:06.552286','2024-07-20 00:45:06.566549',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9825,'sync',2,'2024-07-20 01:45:00.105602','2024-07-20 01:45:04.549919',4444,NULL,'success'),(9826,'sync-dbms-version',2,'2024-07-20 01:45:00.113304','2024-07-20 01:45:00.123492',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9827,'sync-timezone',2,'2024-07-20 01:45:00.132571','2024-07-20 01:45:00.143108',10,'{\"timezone-id\":\"+08:00\"}','success'),(9828,'sync-tables',2,'2024-07-20 01:45:00.152086','2024-07-20 01:45:00.182378',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9829,'sync-fields',2,'2024-07-20 01:45:00.193231','2024-07-20 01:45:03.331163',3137,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9830,'sync-fks',2,'2024-07-20 01:45:03.338730','2024-07-20 01:45:03.960269',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9831,'sync-indexes',2,'2024-07-20 01:45:03.968336','2024-07-20 01:45:04.496558',528,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9832,'sync-metabase-metadata',2,'2024-07-20 01:45:04.504448','2024-07-20 01:45:04.513150',8,'{}','success'),(9833,'sync-table-privileges',2,'2024-07-20 01:45:04.522476','2024-07-20 01:45:04.540095',17,NULL,'success'),(9834,'analyze',2,'2024-07-20 01:45:04.575200','2024-07-20 01:45:06.680748',2105,NULL,'success'),(9835,'fingerprint-fields',2,'2024-07-20 01:45:04.583154','2024-07-20 01:45:06.521736',1938,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9836,'classify-fields',2,'2024-07-20 01:45:06.529793','2024-07-20 01:45:06.647767',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9837,'classify-tables',2,'2024-07-20 01:45:06.655735','2024-07-20 01:45:06.671806',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9838,'sync',2,'2024-07-20 02:45:00.095873','2024-07-20 02:45:04.790281',4694,NULL,'success'),(9839,'sync-dbms-version',2,'2024-07-20 02:45:00.107329','2024-07-20 02:45:00.116632',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9840,'sync-timezone',2,'2024-07-20 02:45:00.124955','2024-07-20 02:45:00.134494',9,'{\"timezone-id\":\"+08:00\"}','success'),(9841,'sync-tables',2,'2024-07-20 02:45:00.142927','2024-07-20 02:45:00.170005',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9842,'sync-fields',2,'2024-07-20 02:45:00.180247','2024-07-20 02:45:03.402765',3222,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9843,'sync-fks',2,'2024-07-20 02:45:03.412419','2024-07-20 02:45:04.125828',713,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9844,'sync-indexes',2,'2024-07-20 02:45:04.134822','2024-07-20 02:45:04.747099',612,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9845,'sync-metabase-metadata',2,'2024-07-20 02:45:04.755054','2024-07-20 02:45:04.763083',8,'{}','success'),(9846,'sync-table-privileges',2,'2024-07-20 02:45:04.772134','2024-07-20 02:45:04.780107',7,NULL,'success'),(9847,'analyze',2,'2024-07-20 02:45:04.818899','2024-07-20 02:45:06.903079',2084,NULL,'success'),(9848,'fingerprint-fields',2,'2024-07-20 02:45:04.827466','2024-07-20 02:45:06.764074',1936,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9849,'classify-fields',2,'2024-07-20 02:45:06.771951','2024-07-20 02:45:06.874659',102,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9850,'classify-tables',2,'2024-07-20 02:45:06.882020','2024-07-20 02:45:06.895275',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9851,'sync',2,'2024-07-20 03:45:00.110669','2024-07-20 03:45:04.545603',4434,NULL,'success'),(9852,'sync-dbms-version',2,'2024-07-20 03:45:00.119092','2024-07-20 03:45:00.128499',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9853,'sync-timezone',2,'2024-07-20 03:45:00.137880','2024-07-20 03:45:00.149129',11,'{\"timezone-id\":\"+08:00\"}','success'),(9854,'sync-tables',2,'2024-07-20 03:45:00.158521','2024-07-20 03:45:00.189843',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9855,'sync-fields',2,'2024-07-20 03:45:00.199557','2024-07-20 03:45:03.335636',3136,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9856,'sync-fks',2,'2024-07-20 03:45:03.344142','2024-07-20 03:45:03.985387',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9857,'sync-indexes',2,'2024-07-20 03:45:03.994434','2024-07-20 03:45:04.506182',511,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9858,'sync-metabase-metadata',2,'2024-07-20 03:45:04.513577','2024-07-20 03:45:04.521933',8,'{}','success'),(9859,'sync-table-privileges',2,'2024-07-20 03:45:04.529681','2024-07-20 03:45:04.537292',7,NULL,'success'),(9860,'analyze',2,'2024-07-20 03:45:04.568858','2024-07-20 03:45:06.580937',2012,NULL,'success'),(9861,'fingerprint-fields',2,'2024-07-20 03:45:04.577204','2024-07-20 03:45:06.421574',1844,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9862,'classify-fields',2,'2024-07-20 03:45:06.430405','2024-07-20 03:45:06.547731',117,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9863,'classify-tables',2,'2024-07-20 03:45:06.555982','2024-07-20 03:45:06.571670',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9864,'task-history-cleanup',NULL,'2024-07-20 04:00:00.052544','2024-07-20 04:00:00.067471',14,NULL,'success'),(9865,'sync',2,'2024-07-20 04:45:00.092570','2024-07-20 04:45:04.763083',4670,NULL,'success'),(9866,'sync-dbms-version',2,'2024-07-20 04:45:00.100342','2024-07-20 04:45:00.110320',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9867,'sync-timezone',2,'2024-07-20 04:45:00.119455','2024-07-20 04:45:00.130968',11,'{\"timezone-id\":\"+08:00\"}','success'),(9868,'sync-tables',2,'2024-07-20 04:45:00.139557','2024-07-20 04:45:00.166840',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9869,'sync-fields',2,'2024-07-20 04:45:00.175891','2024-07-20 04:45:03.345299',3169,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9870,'sync-fks',2,'2024-07-20 04:45:03.354422','2024-07-20 04:45:04.025735',671,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9871,'sync-indexes',2,'2024-07-20 04:45:04.034282','2024-07-20 04:45:04.718947',684,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9872,'sync-metabase-metadata',2,'2024-07-20 04:45:04.727202','2024-07-20 04:45:04.737109',9,'{}','success'),(9873,'sync-table-privileges',2,'2024-07-20 04:45:04.745772','2024-07-20 04:45:04.754209',8,NULL,'success'),(9874,'analyze',2,'2024-07-20 04:45:04.794844','2024-07-20 04:45:06.889306',2094,NULL,'success'),(9875,'fingerprint-fields',2,'2024-07-20 04:45:04.804026','2024-07-20 04:45:06.735324',1931,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9876,'classify-fields',2,'2024-07-20 04:45:06.744150','2024-07-20 04:45:06.857560',113,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9877,'classify-tables',2,'2024-07-20 04:45:06.865391','2024-07-20 04:45:06.879545',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9878,'sync',2,'2024-07-20 05:45:00.102087','2024-07-20 05:45:04.511254',4409,NULL,'success'),(9879,'sync-dbms-version',2,'2024-07-20 05:45:00.113572','2024-07-20 05:45:00.124149',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9880,'sync-timezone',2,'2024-07-20 05:45:00.133490','2024-07-20 05:45:00.145033',11,'{\"timezone-id\":\"+08:00\"}','success'),(9881,'sync-tables',2,'2024-07-20 05:45:00.154786','2024-07-20 05:45:00.183082',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9882,'sync-fields',2,'2024-07-20 05:45:00.191142','2024-07-20 05:45:03.347416',3156,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9883,'sync-fks',2,'2024-07-20 05:45:03.356162','2024-07-20 05:45:03.921661',565,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9884,'sync-indexes',2,'2024-07-20 05:45:03.931465','2024-07-20 05:45:04.466053',534,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9885,'sync-metabase-metadata',2,'2024-07-20 05:45:04.474032','2024-07-20 05:45:04.482022',7,'{}','success'),(9886,'sync-table-privileges',2,'2024-07-20 05:45:04.490201','2024-07-20 05:45:04.500028',9,NULL,'success'),(9887,'analyze',2,'2024-07-20 05:45:04.536401','2024-07-20 05:45:06.546782',2010,NULL,'success'),(9888,'fingerprint-fields',2,'2024-07-20 05:45:04.545541','2024-07-20 05:45:06.402566',1857,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9889,'classify-fields',2,'2024-07-20 05:45:06.410994','2024-07-20 05:45:06.517795',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9890,'classify-tables',2,'2024-07-20 05:45:06.524961','2024-07-20 05:45:06.538453',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9891,'sync',2,'2024-07-20 06:45:00.095603','2024-07-20 06:45:04.395087',4299,NULL,'success'),(9892,'sync-dbms-version',2,'2024-07-20 06:45:00.106299','2024-07-20 06:45:00.116170',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9893,'sync-timezone',2,'2024-07-20 06:45:00.125806','2024-07-20 06:45:00.136717',10,'{\"timezone-id\":\"+08:00\"}','success'),(9894,'sync-tables',2,'2024-07-20 06:45:00.146116','2024-07-20 06:45:00.180416',34,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9895,'sync-fields',2,'2024-07-20 06:45:00.189013','2024-07-20 06:45:03.224231',3035,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9896,'sync-fks',2,'2024-07-20 06:45:03.232808','2024-07-20 06:45:03.827373',594,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9897,'sync-indexes',2,'2024-07-20 06:45:03.835886','2024-07-20 06:45:04.355530',519,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9898,'sync-metabase-metadata',2,'2024-07-20 06:45:04.363144','2024-07-20 06:45:04.371221',8,'{}','success'),(9899,'sync-table-privileges',2,'2024-07-20 06:45:04.378917','2024-07-20 06:45:04.387015',8,NULL,'success'),(9900,'analyze',2,'2024-07-20 06:45:04.420402','2024-07-20 06:45:06.533343',2112,NULL,'success'),(9901,'fingerprint-fields',2,'2024-07-20 06:45:04.428692','2024-07-20 06:45:06.317300',1888,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9902,'classify-fields',2,'2024-07-20 06:45:06.351031','2024-07-20 06:45:06.501035',150,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9903,'classify-tables',2,'2024-07-20 06:45:06.509286','2024-07-20 06:45:06.522030',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9904,'sync',2,'2024-07-20 07:45:00.098835','2024-07-20 07:45:04.522251',4423,NULL,'success'),(9905,'sync-dbms-version',2,'2024-07-20 07:45:00.107649','2024-07-20 07:45:00.127657',20,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9906,'sync-timezone',2,'2024-07-20 07:45:00.137102','2024-07-20 07:45:00.146053',8,'{\"timezone-id\":\"+08:00\"}','success'),(9907,'sync-tables',2,'2024-07-20 07:45:00.155327','2024-07-20 07:45:00.186070',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9908,'sync-fields',2,'2024-07-20 07:45:00.194435','2024-07-20 07:45:03.168087',2973,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9909,'sync-fks',2,'2024-07-20 07:45:03.176368','2024-07-20 07:45:03.802806',626,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9910,'sync-indexes',2,'2024-07-20 07:45:03.810872','2024-07-20 07:45:04.479392',668,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9911,'sync-metabase-metadata',2,'2024-07-20 07:45:04.487031','2024-07-20 07:45:04.495497',8,'{}','success'),(9912,'sync-table-privileges',2,'2024-07-20 07:45:04.504458','2024-07-20 07:45:04.513896',9,NULL,'success'),(9913,'analyze',2,'2024-07-20 07:45:04.551416','2024-07-20 07:45:06.621812',2070,NULL,'success'),(9914,'fingerprint-fields',2,'2024-07-20 07:45:04.560232','2024-07-20 07:45:06.411841',1851,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9915,'classify-fields',2,'2024-07-20 07:45:06.420364','2024-07-20 07:45:06.592443',172,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9916,'classify-tables',2,'2024-07-20 07:45:06.599377','2024-07-20 07:45:06.612640',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9917,'sync',2,'2024-07-20 08:45:00.086422','2024-07-20 08:45:04.464722',4378,NULL,'success'),(9918,'sync-dbms-version',2,'2024-07-20 08:45:00.095669','2024-07-20 08:45:00.105902',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9919,'sync-timezone',2,'2024-07-20 08:45:00.114652','2024-07-20 08:45:00.125086',10,'{\"timezone-id\":\"+08:00\"}','success'),(9920,'sync-tables',2,'2024-07-20 08:45:00.134878','2024-07-20 08:45:00.161442',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9921,'sync-fields',2,'2024-07-20 08:45:00.169950','2024-07-20 08:45:03.149694',2979,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9922,'sync-fks',2,'2024-07-20 08:45:03.157947','2024-07-20 08:45:03.837093',679,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9923,'sync-indexes',2,'2024-07-20 08:45:03.845996','2024-07-20 08:45:04.416185',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9924,'sync-metabase-metadata',2,'2024-07-20 08:45:04.425413','2024-07-20 08:45:04.435482',10,'{}','success'),(9925,'sync-table-privileges',2,'2024-07-20 08:45:04.445380','2024-07-20 08:45:04.454323',8,NULL,'success'),(9926,'analyze',2,'2024-07-20 08:45:04.494693','2024-07-20 08:45:06.571779',2077,NULL,'success'),(9927,'fingerprint-fields',2,'2024-07-20 08:45:04.504804','2024-07-20 08:45:06.414424',1909,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9928,'classify-fields',2,'2024-07-20 08:45:06.422859','2024-07-20 08:45:06.539424',116,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9929,'classify-tables',2,'2024-07-20 08:45:06.547401','2024-07-20 08:45:06.563022',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9930,'sync',2,'2024-07-20 09:45:00.103124','2024-07-20 09:45:04.789176',4686,NULL,'success'),(9931,'sync-dbms-version',2,'2024-07-20 09:45:00.112471','2024-07-20 09:45:00.123289',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9932,'sync-timezone',2,'2024-07-20 09:45:00.133152','2024-07-20 09:45:00.143734',10,'{\"timezone-id\":\"+08:00\"}','success'),(9933,'sync-tables',2,'2024-07-20 09:45:00.154840','2024-07-20 09:45:00.182301',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9934,'sync-fields',2,'2024-07-20 09:45:00.192326','2024-07-20 09:45:03.282138',3089,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9935,'sync-fks',2,'2024-07-20 09:45:03.290789','2024-07-20 09:45:03.934702',643,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9936,'sync-indexes',2,'2024-07-20 09:45:03.943874','2024-07-20 09:45:04.745952',802,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9937,'sync-metabase-metadata',2,'2024-07-20 09:45:04.753777','2024-07-20 09:45:04.762545',8,'{}','success'),(9938,'sync-table-privileges',2,'2024-07-20 09:45:04.770726','2024-07-20 09:45:04.780515',9,NULL,'success'),(9939,'analyze',2,'2024-07-20 09:45:04.815119','2024-07-20 09:45:06.856277',2041,NULL,'success'),(9940,'fingerprint-fields',2,'2024-07-20 09:45:04.824744','2024-07-20 09:45:06.692715',1867,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9941,'classify-fields',2,'2024-07-20 09:45:06.700811','2024-07-20 09:45:06.823211',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9942,'classify-tables',2,'2024-07-20 09:45:06.831225','2024-07-20 09:45:06.846990',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9943,'sync',2,'2024-07-20 10:45:00.108173','2024-07-20 10:45:05.525402',5417,NULL,'success'),(9944,'sync-dbms-version',2,'2024-07-20 10:45:00.119250','2024-07-20 10:45:00.131064',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9945,'sync-timezone',2,'2024-07-20 10:45:00.140535','2024-07-20 10:45:00.151856',11,'{\"timezone-id\":\"+08:00\"}','success'),(9946,'sync-tables',2,'2024-07-20 10:45:00.160734','2024-07-20 10:45:00.192700',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9947,'sync-fields',2,'2024-07-20 10:45:00.202021','2024-07-20 10:45:03.610552',3408,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9948,'sync-fks',2,'2024-07-20 10:45:03.619126','2024-07-20 10:45:04.341953',722,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9949,'sync-indexes',2,'2024-07-20 10:45:04.350837','2024-07-20 10:45:05.481266',1130,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9950,'sync-metabase-metadata',2,'2024-07-20 10:45:05.489640','2024-07-20 10:45:05.498189',8,'{}','success'),(9951,'sync-table-privileges',2,'2024-07-20 10:45:05.507437','2024-07-20 10:45:05.516744',9,NULL,'success'),(9952,'analyze',2,'2024-07-20 10:45:05.556547','2024-07-20 10:45:07.780858',2224,NULL,'success'),(9953,'fingerprint-fields',2,'2024-07-20 10:45:05.566342','2024-07-20 10:45:07.623642',2057,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9954,'classify-fields',2,'2024-07-20 10:45:07.631885','2024-07-20 10:45:07.752312',120,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9955,'classify-tables',2,'2024-07-20 10:45:07.760435','2024-07-20 10:45:07.773106',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9956,'sync',2,'2024-07-20 11:45:00.099383','2024-07-20 11:45:04.331427',4232,NULL,'success'),(9957,'sync-dbms-version',2,'2024-07-20 11:45:00.107150','2024-07-20 11:45:00.115900',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9958,'sync-timezone',2,'2024-07-20 11:45:00.124682','2024-07-20 11:45:00.134524',9,'{\"timezone-id\":\"+08:00\"}','success'),(9959,'sync-tables',2,'2024-07-20 11:45:00.142517','2024-07-20 11:45:00.175892',33,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9960,'sync-fields',2,'2024-07-20 11:45:00.184730','2024-07-20 11:45:03.148593',2963,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9961,'sync-fks',2,'2024-07-20 11:45:03.156905','2024-07-20 11:45:03.748483',591,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9962,'sync-indexes',2,'2024-07-20 11:45:03.758361','2024-07-20 11:45:04.290849',532,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9963,'sync-metabase-metadata',2,'2024-07-20 11:45:04.298057','2024-07-20 11:45:04.306180',8,'{}','success'),(9964,'sync-table-privileges',2,'2024-07-20 11:45:04.314403','2024-07-20 11:45:04.323868',9,NULL,'success'),(9965,'analyze',2,'2024-07-20 11:45:04.354521','2024-07-20 11:45:06.223120',1868,NULL,'success'),(9966,'fingerprint-fields',2,'2024-07-20 11:45:04.362189','2024-07-20 11:45:06.079744',1717,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9967,'classify-fields',2,'2024-07-20 11:45:06.088680','2024-07-20 11:45:06.195821',107,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9968,'classify-tables',2,'2024-07-20 11:45:06.203086','2024-07-20 11:45:06.215752',12,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9969,'sync',2,'2024-07-20 12:45:00.087974','2024-07-20 12:45:04.333902',4245,NULL,'success'),(9970,'sync-dbms-version',2,'2024-07-20 12:45:00.100482','2024-07-20 12:45:00.109042',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9971,'sync-timezone',2,'2024-07-20 12:45:00.117096','2024-07-20 12:45:00.126468',9,'{\"timezone-id\":\"+08:00\"}','success'),(9972,'sync-tables',2,'2024-07-20 12:45:00.134319','2024-07-20 12:45:00.162258',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9973,'sync-fields',2,'2024-07-20 12:45:00.171394','2024-07-20 12:45:03.116348',2944,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9974,'sync-fks',2,'2024-07-20 12:45:03.125099','2024-07-20 12:45:03.732809',607,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9975,'sync-indexes',2,'2024-07-20 12:45:03.741444','2024-07-20 12:45:04.292050',550,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9976,'sync-metabase-metadata',2,'2024-07-20 12:45:04.299755','2024-07-20 12:45:04.309221',9,'{}','success'),(9977,'sync-table-privileges',2,'2024-07-20 12:45:04.317656','2024-07-20 12:45:04.326050',8,NULL,'success'),(9978,'analyze',2,'2024-07-20 12:45:04.360564','2024-07-20 12:45:06.406236',2045,NULL,'success'),(9979,'fingerprint-fields',2,'2024-07-20 12:45:04.369158','2024-07-20 12:45:06.261132',1891,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9980,'classify-fields',2,'2024-07-20 12:45:06.269559','2024-07-20 12:45:06.375607',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9981,'classify-tables',2,'2024-07-20 12:45:06.383197','2024-07-20 12:45:06.396284',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9982,'field values scanning',2,'2024-07-20 13:00:00.046686','2024-07-20 13:00:04.159829',4113,NULL,'success'),(9983,'delete-expired-advanced-field-values',2,'2024-07-20 13:00:00.060992','2024-07-20 13:00:02.803392',2742,'{\"deleted\":0}','success'),(9984,'update-field-values',2,'2024-07-20 13:00:02.811657','2024-07-20 13:00:04.150704',1339,'{\"errors\":0,\"created\":0,\"updated\":0,\"deleted\":0}','success'),(9985,'sync',2,'2024-07-20 13:45:00.099767','2024-07-20 13:45:04.338701',4238,NULL,'success'),(9986,'sync-dbms-version',2,'2024-07-20 13:45:00.108284','2024-07-20 13:45:00.117628',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(9987,'sync-timezone',2,'2024-07-20 13:45:00.126820','2024-07-20 13:45:00.136546',9,'{\"timezone-id\":\"+08:00\"}','success'),(9988,'sync-tables',2,'2024-07-20 13:45:00.145627','2024-07-20 13:45:00.171790',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(9989,'sync-fields',2,'2024-07-20 13:45:00.180221','2024-07-20 13:45:03.102061',2921,'{\"total-fields\":836,\"updated-fields\":0}','success'),(9990,'sync-fks',2,'2024-07-20 13:45:03.113767','2024-07-20 13:45:03.754303',640,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(9991,'sync-indexes',2,'2024-07-20 13:45:03.762862','2024-07-20 13:45:04.295966',533,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(9992,'sync-metabase-metadata',2,'2024-07-20 13:45:04.303936','2024-07-20 13:45:04.312808',8,'{}','success'),(9993,'sync-table-privileges',2,'2024-07-20 13:45:04.321297','2024-07-20 13:45:04.329742',8,NULL,'success'),(9994,'analyze',2,'2024-07-20 13:45:04.364232','2024-07-20 13:45:06.417782',2053,NULL,'success'),(9995,'fingerprint-fields',2,'2024-07-20 13:45:04.372597','2024-07-20 13:45:06.266162',1893,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(9996,'classify-fields',2,'2024-07-20 13:45:06.274801','2024-07-20 13:45:06.386714',111,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(9997,'classify-tables',2,'2024-07-20 13:45:06.393750','2024-07-20 13:45:06.407961',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(9998,'sync',2,'2024-07-20 14:45:00.101560','2024-07-20 14:45:04.378329',4276,NULL,'success'),(9999,'sync-dbms-version',2,'2024-07-20 14:45:00.110274','2024-07-20 14:45:00.124719',14,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10000,'sync-timezone',2,'2024-07-20 14:45:00.143932','2024-07-20 14:45:00.159824',15,'{\"timezone-id\":\"+08:00\"}','success'),(10001,'sync-tables',2,'2024-07-20 14:45:00.173661','2024-07-20 14:45:00.201847',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10002,'sync-fields',2,'2024-07-20 14:45:00.210984','2024-07-20 14:45:03.130690',2919,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10003,'sync-fks',2,'2024-07-20 14:45:03.139489','2024-07-20 14:45:03.777232',637,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10004,'sync-indexes',2,'2024-07-20 14:45:03.785760','2024-07-20 14:45:04.338291',552,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10005,'sync-metabase-metadata',2,'2024-07-20 14:45:04.346286','2024-07-20 14:45:04.354102',7,'{}','success'),(10006,'sync-table-privileges',2,'2024-07-20 14:45:04.361862','2024-07-20 14:45:04.370082',8,NULL,'success'),(10007,'analyze',2,'2024-07-20 14:45:04.405979','2024-07-20 14:45:06.465686',2059,NULL,'success'),(10008,'fingerprint-fields',2,'2024-07-20 14:45:04.415701','2024-07-20 14:45:06.315862',1900,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10009,'classify-fields',2,'2024-07-20 14:45:06.323690','2024-07-20 14:45:06.430505',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10010,'classify-tables',2,'2024-07-20 14:45:06.437791','2024-07-20 14:45:06.451680',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10011,'sync',2,'2024-07-20 15:45:00.097293','2024-07-20 15:45:04.628504',4531,NULL,'success'),(10012,'sync-dbms-version',2,'2024-07-20 15:45:00.105655','2024-07-20 15:45:00.115826',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10013,'sync-timezone',2,'2024-07-20 15:45:00.124798','2024-07-20 15:45:00.134971',10,'{\"timezone-id\":\"+08:00\"}','success'),(10014,'sync-tables',2,'2024-07-20 15:45:00.144741','2024-07-20 15:45:00.174794',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10015,'sync-fields',2,'2024-07-20 15:45:00.183061','2024-07-20 15:45:03.354485',3171,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10016,'sync-fks',2,'2024-07-20 15:45:03.362551','2024-07-20 15:45:04.008165',645,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10017,'sync-indexes',2,'2024-07-20 15:45:04.015913','2024-07-20 15:45:04.582150',566,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10018,'sync-metabase-metadata',2,'2024-07-20 15:45:04.591108','2024-07-20 15:45:04.599467',8,'{}','success'),(10019,'sync-table-privileges',2,'2024-07-20 15:45:04.609004','2024-07-20 15:45:04.618702',9,NULL,'success'),(10020,'analyze',2,'2024-07-20 15:45:04.657910','2024-07-20 15:45:06.689223',2031,NULL,'success'),(10021,'fingerprint-fields',2,'2024-07-20 15:45:04.667934','2024-07-20 15:45:06.546466',1878,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10022,'classify-fields',2,'2024-07-20 15:45:06.554870','2024-07-20 15:45:06.659688',104,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10023,'classify-tables',2,'2024-07-20 15:45:06.667720','2024-07-20 15:45:06.681574',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10024,'task-history-cleanup',NULL,'2024-07-20 16:00:00.023934','2024-07-20 16:00:00.098768',74,NULL,'success'),(10025,'task-history-cleanup',NULL,'2024-07-20 16:00:00.131475','2024-07-20 16:00:00.143635',12,NULL,'success'),(10026,'sync',2,'2024-07-20 16:45:00.089827','2024-07-20 16:45:04.477940',4388,NULL,'success'),(10027,'sync-dbms-version',2,'2024-07-20 16:45:00.098123','2024-07-20 16:45:00.106985',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10028,'sync-timezone',2,'2024-07-20 16:45:00.115423','2024-07-20 16:45:00.125602',10,'{\"timezone-id\":\"+08:00\"}','success'),(10029,'sync-tables',2,'2024-07-20 16:45:00.134409','2024-07-20 16:45:00.162173',27,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10030,'sync-fields',2,'2024-07-20 16:45:00.170623','2024-07-20 16:45:03.241223',3070,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10031,'sync-fks',2,'2024-07-20 16:45:03.248653','2024-07-20 16:45:03.886980',638,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10032,'sync-indexes',2,'2024-07-20 16:45:03.894686','2024-07-20 16:45:04.436123',541,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10033,'sync-metabase-metadata',2,'2024-07-20 16:45:04.444269','2024-07-20 16:45:04.452941',8,'{}','success'),(10034,'sync-table-privileges',2,'2024-07-20 16:45:04.460877','2024-07-20 16:45:04.469317',8,NULL,'success'),(10035,'analyze',2,'2024-07-20 16:45:04.511205','2024-07-20 16:45:06.599755',2088,NULL,'success'),(10036,'fingerprint-fields',2,'2024-07-20 16:45:04.520111','2024-07-20 16:45:06.440886',1920,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10037,'classify-fields',2,'2024-07-20 16:45:06.449600','2024-07-20 16:45:06.567973',118,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10038,'classify-tables',2,'2024-07-20 16:45:06.575088','2024-07-20 16:45:06.590602',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10039,'sync',2,'2024-07-20 17:45:00.094383','2024-07-20 17:45:04.447602',4353,NULL,'success'),(10040,'sync-dbms-version',2,'2024-07-20 17:45:00.102025','2024-07-20 17:45:00.110987',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10041,'sync-timezone',2,'2024-07-20 17:45:00.120627','2024-07-20 17:45:00.130134',9,'{\"timezone-id\":\"+08:00\"}','success'),(10042,'sync-tables',2,'2024-07-20 17:45:00.138725','2024-07-20 17:45:00.164620',25,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10043,'sync-fields',2,'2024-07-20 17:45:00.173180','2024-07-20 17:45:03.207626',3034,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10044,'sync-fks',2,'2024-07-20 17:45:03.215364','2024-07-20 17:45:03.833088',617,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10045,'sync-indexes',2,'2024-07-20 17:45:03.841667','2024-07-20 17:45:04.401710',560,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10046,'sync-metabase-metadata',2,'2024-07-20 17:45:04.410559','2024-07-20 17:45:04.419896',9,'{}','success'),(10047,'sync-table-privileges',2,'2024-07-20 17:45:04.429199','2024-07-20 17:45:04.438659',9,NULL,'success'),(10048,'analyze',2,'2024-07-20 17:45:04.471785','2024-07-20 17:45:06.417854',1946,NULL,'success'),(10049,'fingerprint-fields',2,'2024-07-20 17:45:04.479859','2024-07-20 17:45:06.268990',1789,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10050,'classify-fields',2,'2024-07-20 17:45:06.276969','2024-07-20 17:45:06.385937',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10051,'classify-tables',2,'2024-07-20 17:45:06.395976','2024-07-20 17:45:06.409120',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10052,'sync',2,'2024-07-20 18:45:00.099361','2024-07-20 18:45:04.739173',4639,NULL,'success'),(10053,'sync-dbms-version',2,'2024-07-20 18:45:00.108040','2024-07-20 18:45:00.117314',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10054,'sync-timezone',2,'2024-07-20 18:45:00.126152','2024-07-20 18:45:00.136938',10,'{\"timezone-id\":\"+08:00\"}','success'),(10055,'sync-tables',2,'2024-07-20 18:45:00.145736','2024-07-20 18:45:00.174568',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10056,'sync-fields',2,'2024-07-20 18:45:00.183687','2024-07-20 18:45:03.348013',3164,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10057,'sync-fks',2,'2024-07-20 18:45:03.356409','2024-07-20 18:45:04.067700',711,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10058,'sync-indexes',2,'2024-07-20 18:45:04.077141','2024-07-20 18:45:04.695653',618,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10059,'sync-metabase-metadata',2,'2024-07-20 18:45:04.703745','2024-07-20 18:45:04.713220',9,'{}','success'),(10060,'sync-table-privileges',2,'2024-07-20 18:45:04.722059','2024-07-20 18:45:04.730499',8,NULL,'success'),(10061,'analyze',2,'2024-07-20 18:45:04.763380','2024-07-20 18:45:06.945038',2181,NULL,'success'),(10062,'fingerprint-fields',2,'2024-07-20 18:45:04.771562','2024-07-20 18:45:06.783451',2011,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10063,'classify-fields',2,'2024-07-20 18:45:06.791840','2024-07-20 18:45:06.913687',121,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10064,'classify-tables',2,'2024-07-20 18:45:06.921416','2024-07-20 18:45:06.936471',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10065,'sync',2,'2024-07-20 19:45:00.094019','2024-07-20 19:45:04.523351',4429,NULL,'success'),(10066,'sync-dbms-version',2,'2024-07-20 19:45:00.103026','2024-07-20 19:45:00.111638',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10067,'sync-timezone',2,'2024-07-20 19:45:00.120061','2024-07-20 19:45:00.130945',10,'{\"timezone-id\":\"+08:00\"}','success'),(10068,'sync-tables',2,'2024-07-20 19:45:00.139787','2024-07-20 19:45:00.170135',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10069,'sync-fields',2,'2024-07-20 19:45:00.178826','2024-07-20 19:45:03.238065',3059,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10070,'sync-fks',2,'2024-07-20 19:45:03.245951','2024-07-20 19:45:03.867663',621,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10071,'sync-indexes',2,'2024-07-20 19:45:03.875708','2024-07-20 19:45:04.473571',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10072,'sync-metabase-metadata',2,'2024-07-20 19:45:04.486253','2024-07-20 19:45:04.495003',8,'{}','success'),(10073,'sync-table-privileges',2,'2024-07-20 19:45:04.504519','2024-07-20 19:45:04.513219',8,NULL,'success'),(10074,'analyze',2,'2024-07-20 19:45:04.555795','2024-07-20 19:45:06.738805',2183,NULL,'success'),(10075,'fingerprint-fields',2,'2024-07-20 19:45:04.564956','2024-07-20 19:45:06.576694',2011,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10076,'classify-fields',2,'2024-07-20 19:45:06.585550','2024-07-20 19:45:06.700640',115,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10077,'classify-tables',2,'2024-07-20 19:45:06.708642','2024-07-20 19:45:06.728930',20,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10078,'sync',2,'2024-07-20 20:45:00.104051','2024-07-20 20:45:04.320373',4216,NULL,'success'),(10079,'sync-dbms-version',2,'2024-07-20 20:45:00.111658','2024-07-20 20:45:00.121174',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10080,'sync-timezone',2,'2024-07-20 20:45:00.130067','2024-07-20 20:45:00.141386',11,'{\"timezone-id\":\"+08:00\"}','success'),(10081,'sync-tables',2,'2024-07-20 20:45:00.149669','2024-07-20 20:45:00.178432',28,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10082,'sync-fields',2,'2024-07-20 20:45:00.186888','2024-07-20 20:45:03.068977',2882,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10083,'sync-fks',2,'2024-07-20 20:45:03.076965','2024-07-20 20:45:03.724952',647,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10084,'sync-indexes',2,'2024-07-20 20:45:03.732973','2024-07-20 20:45:04.280968',547,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10085,'sync-metabase-metadata',2,'2024-07-20 20:45:04.288664','2024-07-20 20:45:04.296387',7,'{}','success'),(10086,'sync-table-privileges',2,'2024-07-20 20:45:04.304326','2024-07-20 20:45:04.312911',8,NULL,'success'),(10087,'analyze',2,'2024-07-20 20:45:04.344530','2024-07-20 20:45:06.359247',2014,NULL,'success'),(10088,'fingerprint-fields',2,'2024-07-20 20:45:04.352736','2024-07-20 20:45:06.216643',1863,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10089,'classify-fields',2,'2024-07-20 20:45:06.225256','2024-07-20 20:45:06.328443',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10090,'classify-tables',2,'2024-07-20 20:45:06.335946','2024-07-20 20:45:06.351189',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10091,'sync',2,'2024-07-20 21:45:00.118861','2024-07-20 21:45:05.025124',4906,NULL,'success'),(10092,'sync-dbms-version',2,'2024-07-20 21:45:00.127535','2024-07-20 21:45:00.137741',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10093,'sync-timezone',2,'2024-07-20 21:45:00.147332','2024-07-20 21:45:00.157553',10,'{\"timezone-id\":\"+08:00\"}','success'),(10094,'sync-tables',2,'2024-07-20 21:45:00.167262','2024-07-20 21:45:00.197972',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10095,'sync-fields',2,'2024-07-20 21:45:00.207643','2024-07-20 21:45:03.629486',3421,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10096,'sync-fks',2,'2024-07-20 21:45:03.637937','2024-07-20 21:45:04.322315',684,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10097,'sync-indexes',2,'2024-07-20 21:45:04.332799','2024-07-20 21:45:04.977977',645,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10098,'sync-metabase-metadata',2,'2024-07-20 21:45:04.986291','2024-07-20 21:45:04.995873',9,'{}','success'),(10099,'sync-table-privileges',2,'2024-07-20 21:45:05.005168','2024-07-20 21:45:05.015107',9,NULL,'success'),(10100,'analyze',2,'2024-07-20 21:45:05.057319','2024-07-20 21:45:07.415244',2357,NULL,'success'),(10101,'fingerprint-fields',2,'2024-07-20 21:45:05.066564','2024-07-20 21:45:07.243531',2176,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10102,'classify-fields',2,'2024-07-20 21:45:07.253297','2024-07-20 21:45:07.383388',130,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10103,'classify-tables',2,'2024-07-20 21:45:07.391522','2024-07-20 21:45:07.406195',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10104,'sync',2,'2024-07-20 22:45:00.104781','2024-07-20 22:45:04.594010',4489,NULL,'success'),(10105,'sync-dbms-version',2,'2024-07-20 22:45:00.113341','2024-07-20 22:45:00.122355',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10106,'sync-timezone',2,'2024-07-20 22:45:00.131321','2024-07-20 22:45:00.143439',12,'{\"timezone-id\":\"+08:00\"}','success'),(10107,'sync-tables',2,'2024-07-20 22:45:00.152729','2024-07-20 22:45:00.184482',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10108,'sync-fields',2,'2024-07-20 22:45:00.193998','2024-07-20 22:45:03.329265',3135,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10109,'sync-fks',2,'2024-07-20 22:45:03.336830','2024-07-20 22:45:03.966291',629,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10110,'sync-indexes',2,'2024-07-20 22:45:03.974347','2024-07-20 22:45:04.547840',573,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10111,'sync-metabase-metadata',2,'2024-07-20 22:45:04.557689','2024-07-20 22:45:04.566670',8,'{}','success'),(10112,'sync-table-privileges',2,'2024-07-20 22:45:04.575942','2024-07-20 22:45:04.585121',9,NULL,'success'),(10113,'analyze',2,'2024-07-20 22:45:04.630446','2024-07-20 22:45:06.697967',2067,NULL,'success'),(10114,'fingerprint-fields',2,'2024-07-20 22:45:04.640499','2024-07-20 22:45:06.554544',1914,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10115,'classify-fields',2,'2024-07-20 22:45:06.562511','2024-07-20 22:45:06.669150',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10116,'classify-tables',2,'2024-07-20 22:45:06.676177','2024-07-20 22:45:06.689632',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10117,'sync',2,'2024-07-20 23:45:00.100335','2024-07-20 23:45:04.438448',4338,NULL,'success'),(10118,'sync-dbms-version',2,'2024-07-20 23:45:00.108304','2024-07-20 23:45:00.116949',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10119,'sync-timezone',2,'2024-07-20 23:45:00.125039','2024-07-20 23:45:00.134616',9,'{\"timezone-id\":\"+08:00\"}','success'),(10120,'sync-tables',2,'2024-07-20 23:45:00.143116','2024-07-20 23:45:00.169595',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10121,'sync-fields',2,'2024-07-20 23:45:00.178063','2024-07-20 23:45:03.203090',3025,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10122,'sync-fks',2,'2024-07-20 23:45:03.212597','2024-07-20 23:45:03.853611',641,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10123,'sync-indexes',2,'2024-07-20 23:45:03.862625','2024-07-20 23:45:04.395329',532,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10124,'sync-metabase-metadata',2,'2024-07-20 23:45:04.403317','2024-07-20 23:45:04.411453',8,'{}','success'),(10125,'sync-table-privileges',2,'2024-07-20 23:45:04.420691','2024-07-20 23:45:04.430299',9,NULL,'success'),(10126,'analyze',2,'2024-07-20 23:45:04.464848','2024-07-20 23:45:06.490256',2025,NULL,'success'),(10127,'fingerprint-fields',2,'2024-07-20 23:45:04.472754','2024-07-20 23:45:06.338739',1865,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10128,'classify-fields',2,'2024-07-20 23:45:06.347020','2024-07-20 23:45:06.459651',112,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10129,'classify-tables',2,'2024-07-20 23:45:06.467140','2024-07-20 23:45:06.482372',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10130,'sync',2,'2024-07-21 00:45:00.105280','2024-07-21 00:45:04.692464',4587,NULL,'success'),(10131,'sync-dbms-version',2,'2024-07-21 00:45:00.114031','2024-07-21 00:45:00.123553',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10132,'sync-timezone',2,'2024-07-21 00:45:00.132295','2024-07-21 00:45:00.143944',11,'{\"timezone-id\":\"+08:00\"}','success'),(10133,'sync-tables',2,'2024-07-21 00:45:00.152628','2024-07-21 00:45:00.184718',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10134,'sync-fields',2,'2024-07-21 00:45:00.196249','2024-07-21 00:45:03.438248',3242,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10135,'sync-fks',2,'2024-07-21 00:45:03.447261','2024-07-21 00:45:04.111201',663,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10136,'sync-indexes',2,'2024-07-21 00:45:04.119413','2024-07-21 00:45:04.652755',533,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10137,'sync-metabase-metadata',2,'2024-07-21 00:45:04.660047','2024-07-21 00:45:04.667608',7,'{}','success'),(10138,'sync-table-privileges',2,'2024-07-21 00:45:04.677002','2024-07-21 00:45:04.684681',7,NULL,'success'),(10139,'analyze',2,'2024-07-21 00:45:04.715609','2024-07-21 00:45:06.668201',1952,NULL,'success'),(10140,'fingerprint-fields',2,'2024-07-21 00:45:04.723224','2024-07-21 00:45:06.527752',1804,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10141,'classify-fields',2,'2024-07-21 00:45:06.535230','2024-07-21 00:45:06.638923',103,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10142,'classify-tables',2,'2024-07-21 00:45:06.646538','2024-07-21 00:45:06.660061',13,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10143,'sync',2,'2024-07-21 01:45:00.106342','2024-07-21 01:45:04.818209',4711,NULL,'success'),(10144,'sync-dbms-version',2,'2024-07-21 01:45:00.115118','2024-07-21 01:45:00.126318',11,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10145,'sync-timezone',2,'2024-07-21 01:45:00.135758','2024-07-21 01:45:00.147636',11,'{\"timezone-id\":\"+08:00\"}','success'),(10146,'sync-tables',2,'2024-07-21 01:45:00.156889','2024-07-21 01:45:00.189404',32,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10147,'sync-fields',2,'2024-07-21 01:45:00.198868','2024-07-21 01:45:03.486796',3287,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10148,'sync-fks',2,'2024-07-21 01:45:03.496018','2024-07-21 01:45:04.177004',680,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10149,'sync-indexes',2,'2024-07-21 01:45:04.186113','2024-07-21 01:45:04.775799',589,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10150,'sync-metabase-metadata',2,'2024-07-21 01:45:04.783747','2024-07-21 01:45:04.791742',7,'{}','success'),(10151,'sync-table-privileges',2,'2024-07-21 01:45:04.799844','2024-07-21 01:45:04.809867',10,NULL,'success'),(10152,'analyze',2,'2024-07-21 01:45:04.846141','2024-07-21 01:45:06.852421',2006,NULL,'success'),(10153,'fingerprint-fields',2,'2024-07-21 01:45:04.855158','2024-07-21 01:45:06.715670',1860,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10154,'classify-fields',2,'2024-07-21 01:45:06.724072','2024-07-21 01:45:06.821387',97,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10155,'classify-tables',2,'2024-07-21 01:45:06.828460','2024-07-21 01:45:06.844553',16,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10156,'sync',2,'2024-07-21 02:45:00.098906','2024-07-21 02:45:04.818092',4719,NULL,'success'),(10157,'sync-dbms-version',2,'2024-07-21 02:45:00.107519','2024-07-21 02:45:00.117810',10,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10158,'sync-timezone',2,'2024-07-21 02:45:00.127130','2024-07-21 02:45:00.138171',11,'{\"timezone-id\":\"+08:00\"}','success'),(10159,'sync-tables',2,'2024-07-21 02:45:00.147455','2024-07-21 02:45:00.178560',31,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10160,'sync-fields',2,'2024-07-21 02:45:00.187251','2024-07-21 02:45:03.456877',3269,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10161,'sync-fks',2,'2024-07-21 02:45:03.465667','2024-07-21 02:45:04.145131',679,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10162,'sync-indexes',2,'2024-07-21 02:45:04.154384','2024-07-21 02:45:04.771770',617,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10163,'sync-metabase-metadata',2,'2024-07-21 02:45:04.780314','2024-07-21 02:45:04.790271',9,'{}','success'),(10164,'sync-table-privileges',2,'2024-07-21 02:45:04.799248','2024-07-21 02:45:04.808076',8,NULL,'success'),(10165,'analyze',2,'2024-07-21 02:45:04.851085','2024-07-21 02:45:06.890517',2039,NULL,'success'),(10166,'fingerprint-fields',2,'2024-07-21 02:45:04.860224','2024-07-21 02:45:06.740754',1880,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10167,'classify-fields',2,'2024-07-21 02:45:06.749465','2024-07-21 02:45:06.858277',108,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10168,'classify-tables',2,'2024-07-21 02:45:06.866646','2024-07-21 02:45:06.881532',14,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10169,'sync',2,'2024-07-21 03:45:00.102700','2024-07-21 03:45:04.754209',4651,NULL,'success'),(10170,'sync-dbms-version',2,'2024-07-21 03:45:00.110955','2024-07-21 03:45:00.120349',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10171,'sync-timezone',2,'2024-07-21 03:45:00.128989','2024-07-21 03:45:00.140712',11,'{\"timezone-id\":\"+08:00\"}','success'),(10172,'sync-tables',2,'2024-07-21 03:45:00.149082','2024-07-21 03:45:00.178853',29,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10173,'sync-fields',2,'2024-07-21 03:45:00.187633','2024-07-21 03:45:03.501694',3314,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10174,'sync-fks',2,'2024-07-21 03:45:03.510531','2024-07-21 03:45:04.103477',592,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10175,'sync-indexes',2,'2024-07-21 03:45:04.111857','2024-07-21 03:45:04.708895',597,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10176,'sync-metabase-metadata',2,'2024-07-21 03:45:04.717421','2024-07-21 03:45:04.726762',9,'{}','success'),(10177,'sync-table-privileges',2,'2024-07-21 03:45:04.736894','2024-07-21 03:45:04.745803',8,NULL,'success'),(10178,'analyze',2,'2024-07-21 03:45:04.779179','2024-07-21 03:45:06.915141',2135,NULL,'success'),(10179,'fingerprint-fields',2,'2024-07-21 03:45:04.787315','2024-07-21 03:45:06.741788',1954,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10180,'classify-fields',2,'2024-07-21 03:45:06.750298','2024-07-21 03:45:06.873239',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10181,'classify-tables',2,'2024-07-21 03:45:06.887956','2024-07-21 03:45:06.905411',17,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10182,'task-history-cleanup',NULL,'2024-07-21 04:00:00.073705','2024-07-21 04:00:00.109711',36,NULL,'success'),(10183,'sync',2,'2024-07-21 04:45:00.106206','2024-07-21 04:45:04.711818',4605,NULL,'success'),(10184,'sync-dbms-version',2,'2024-07-21 04:45:00.114353','2024-07-21 04:45:00.123398',9,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10185,'sync-timezone',2,'2024-07-21 04:45:00.132254','2024-07-21 04:45:00.143146',10,'{\"timezone-id\":\"+08:00\"}','success'),(10186,'sync-tables',2,'2024-07-21 04:45:00.152406','2024-07-21 04:45:00.182760',30,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10187,'sync-fields',2,'2024-07-21 04:45:00.192413','2024-07-21 04:45:03.358240',3165,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10188,'sync-fks',2,'2024-07-21 04:45:03.367868','2024-07-21 04:45:04.086459',718,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10189,'sync-indexes',2,'2024-07-21 04:45:04.094955','2024-07-21 04:45:04.665602',570,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10190,'sync-metabase-metadata',2,'2024-07-21 04:45:04.674285','2024-07-21 04:45:04.684004',9,'{}','success'),(10191,'sync-table-privileges',2,'2024-07-21 04:45:04.692888','2024-07-21 04:45:04.703026',10,NULL,'success'),(10192,'analyze',2,'2024-07-21 04:45:04.740167','2024-07-21 04:45:06.818361',2078,NULL,'success'),(10193,'fingerprint-fields',2,'2024-07-21 04:45:04.749199','2024-07-21 04:45:06.671203',1922,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10194,'classify-fields',2,'2024-07-21 04:45:06.679792','2024-07-21 04:45:06.786091',106,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10195,'classify-tables',2,'2024-07-21 04:45:06.794813','2024-07-21 04:45:06.809935',15,'{\"total-tables\":92,\"tables-classified\":0}','success'),(10196,'sync',2,'2024-07-21 05:45:00.099083','2024-07-21 05:45:04.805386',4706,NULL,'success'),(10197,'sync-dbms-version',2,'2024-07-21 05:45:00.107037','2024-07-21 05:45:00.115925',8,'{\"flavor\":\"MySQL\",\"version\":\"8.2.0\",\"semantic-version\":[8,2]}','success'),(10198,'sync-timezone',2,'2024-07-21 05:45:00.124026','2024-07-21 05:45:00.134203',10,'{\"timezone-id\":\"+08:00\"}','success'),(10199,'sync-tables',2,'2024-07-21 05:45:00.142738','2024-07-21 05:45:00.169229',26,'{\"updated-tables\":0,\"total-tables\":99}','success'),(10200,'sync-fields',2,'2024-07-21 05:45:00.178348','2024-07-21 05:45:03.364068',3185,'{\"total-fields\":836,\"updated-fields\":0}','success'),(10201,'sync-fks',2,'2024-07-21 05:45:03.372961','2024-07-21 05:45:04.024864',651,'{\"total-fks\":113,\"updated-fks\":0,\"total-failed\":0}','success'),(10202,'sync-indexes',2,'2024-07-21 05:45:04.034395','2024-07-21 05:45:04.761318',726,'{\"total-indexes\":0,\"added-indexes\":0,\"removed-indexes\":0}','success'),(10203,'sync-metabase-metadata',2,'2024-07-21 05:45:04.769677','2024-07-21 05:45:04.778611',8,'{}','success'),(10204,'sync-table-privileges',2,'2024-07-21 05:45:04.787951','2024-07-21 05:45:04.797049',9,NULL,'success'),(10205,'analyze',2,'2024-07-21 05:45:04.833476','2024-07-21 05:45:06.961084',2127,NULL,'success'),(10206,'fingerprint-fields',2,'2024-07-21 05:45:04.842690','2024-07-21 05:45:06.800891',1958,'{\"no-data-fingerprints\":320,\"failed-fingerprints\":0,\"updated-fingerprints\":0,\"fingerprints-attempted\":320}','success'),(10207,'classify-fields',2,'2024-07-21 05:45:06.810470','2024-07-21 05:45:06.932928',122,'{\"fields-classified\":0,\"fields-failed\":0}','success'),(10208,'classify-tables',2,'2024-07-21 05:45:06.939923','2024-07-21 05:45:06.952835',12,'{\"total-tables\":92,\"tables-classified\":0}','success');
/*!40000 ALTER TABLE `task_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timeline`
--

DROP TABLE IF EXISTS `timeline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `timeline` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Name of the timeline',
  `description` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Optional description of the timeline',
  `icon` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `collection_id` int DEFAULT NULL COMMENT 'ID of the collection containing the timeline',
  `archived` bit(1) NOT NULL DEFAULT b'0',
  `creator_id` int NOT NULL COMMENT 'ID of the user who created the timeline',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the timeline was created',
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the timeline was updated',
  `default` bit(1) NOT NULL DEFAULT b'0',
  `entity_id` char(21) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Random NanoID tag for unique identity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`),
  KEY `fk_timeline_creator_id` (`creator_id`),
  KEY `idx_timeline_collection_id` (`collection_id`),
  CONSTRAINT `fk_timeline_collection_id` FOREIGN KEY (`collection_id`) REFERENCES `collection` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_timeline_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Timeline table to organize events';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timeline`
--

LOCK TABLES `timeline` WRITE;
/*!40000 ALTER TABLE `timeline` DISABLE KEYS */;
/*!40000 ALTER TABLE `timeline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timeline_event`
--

DROP TABLE IF EXISTS `timeline_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `timeline_event` (
  `id` int NOT NULL AUTO_INCREMENT,
  `timeline_id` int NOT NULL COMMENT 'ID of the timeline containing the event',
  `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Name of the event',
  `description` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Optional markdown description of the event',
  `timestamp` timestamp(6) NOT NULL COMMENT 'When the event happened',
  `time_matters` bit(1) NOT NULL,
  `timezone` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Timezone to display the underlying UTC timestamp in for the client',
  `icon` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `archived` bit(1) NOT NULL DEFAULT b'0',
  `creator_id` int NOT NULL COMMENT 'ID of the user who created the event',
  `created_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the event was created',
  `updated_at` timestamp(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6) COMMENT 'The timestamp of when the event was modified',
  PRIMARY KEY (`id`),
  KEY `fk_event_creator_id` (`creator_id`),
  KEY `idx_timeline_event_timeline_id` (`timeline_id`),
  KEY `idx_timeline_event_timeline_id_timestamp` (`timeline_id`,`timestamp`),
  CONSTRAINT `fk_event_creator_id` FOREIGN KEY (`creator_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_events_timeline_id` FOREIGN KEY (`timeline_id`) REFERENCES `timeline` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Events table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timeline_event`
--

LOCK TABLES `timeline_event` WRITE;
/*!40000 ALTER TABLE `timeline_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `timeline_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_parameter_value`
--

DROP TABLE IF EXISTS `user_parameter_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `user_parameter_value` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL COMMENT 'ID of the User who has set the parameter value',
  `parameter_id` varchar(36) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The parameter ID',
  `value` longtext COLLATE utf8mb4_unicode_ci COMMENT 'Value of the parameter',
  PRIMARY KEY (`id`),
  KEY `idx_user_parameter_value_user_id` (`user_id`),
  CONSTRAINT `fk_user_parameter_value_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Table holding last set value of a parameter per user';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_parameter_value`
--

LOCK TABLES `user_parameter_value` WRITE;
/*!40000 ALTER TABLE `user_parameter_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `user_parameter_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Temporary view structure for view `v_alerts`
--

DROP TABLE IF EXISTS `v_alerts`;
/*!50001 DROP VIEW IF EXISTS `v_alerts`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_alerts` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `creator_id`,
 1 AS `card_id`,
 1 AS `card_qualified_id`,
 1 AS `alert_condition`,
 1 AS `schedule_type`,
 1 AS `schedule_day`,
 1 AS `schedule_hour`,
 1 AS `archived`,
 1 AS `recipient_type`,
 1 AS `recipients`,
 1 AS `recipient_external`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_audit_log`
--

DROP TABLE IF EXISTS `v_audit_log`;
/*!50001 DROP VIEW IF EXISTS `v_audit_log`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_audit_log` AS SELECT
 1 AS `id`,
 1 AS `topic`,
 1 AS `timestamp`,
 1 AS `end_timestamp`,
 1 AS `user_id`,
 1 AS `entity_type`,
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `details`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_content`
--

DROP TABLE IF EXISTS `v_content`;
/*!50001 DROP VIEW IF EXISTS `v_content`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_content` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `entity_type`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `creator_id`,
 1 AS `name`,
 1 AS `description`,
 1 AS `collection_id`,
 1 AS `made_public_by_user`,
 1 AS `is_embedding_enabled`,
 1 AS `archived`,
 1 AS `action_type`,
 1 AS `action_model_id`,
 1 AS `collection_is_official`,
 1 AS `collection_is_personal`,
 1 AS `question_viz_type`,
 1 AS `question_database_id`,
 1 AS `question_is_native`,
 1 AS `event_timestamp`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_dashboardcard`
--

DROP TABLE IF EXISTS `v_dashboardcard`;
/*!50001 DROP VIEW IF EXISTS `v_dashboardcard`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_dashboardcard` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `dashboard_qualified_id`,
 1 AS `dashboardtab_id`,
 1 AS `card_qualified_id`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `size_x`,
 1 AS `size_y`,
 1 AS `visualization_settings`,
 1 AS `parameter_mappings`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_databases`
--

DROP TABLE IF EXISTS `v_databases`;
/*!50001 DROP VIEW IF EXISTS `v_databases`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_databases` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `name`,
 1 AS `description`,
 1 AS `database_type`,
 1 AS `metadata_sync_schedule`,
 1 AS `cache_field_values_schedule`,
 1 AS `timezone`,
 1 AS `is_on_demand`,
 1 AS `auto_run_queries`,
 1 AS `cache_ttl`,
 1 AS `creator_id`,
 1 AS `db_version`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_fields`
--

DROP TABLE IF EXISTS `v_fields`;
/*!50001 DROP VIEW IF EXISTS `v_fields`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_fields` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `name`,
 1 AS `display_name`,
 1 AS `description`,
 1 AS `base_type`,
 1 AS `visibility_type`,
 1 AS `fk_target_field_id`,
 1 AS `has_field_values`,
 1 AS `active`,
 1 AS `table_id`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_group_members`
--

DROP TABLE IF EXISTS `v_group_members`;
/*!50001 DROP VIEW IF EXISTS `v_group_members`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_group_members` AS SELECT
 1 AS `user_id`,
 1 AS `group_id`,
 1 AS `group_name`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_query_log`
--

DROP TABLE IF EXISTS `v_query_log`;
/*!50001 DROP VIEW IF EXISTS `v_query_log`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_query_log` AS SELECT
 1 AS `entity_id`,
 1 AS `started_at`,
 1 AS `running_time_seconds`,
 1 AS `result_rows`,
 1 AS `is_native`,
 1 AS `query_source`,
 1 AS `error`,
 1 AS `user_id`,
 1 AS `card_id`,
 1 AS `card_qualified_id`,
 1 AS `dashboard_id`,
 1 AS `dashboard_qualified_id`,
 1 AS `pulse_id`,
 1 AS `database_id`,
 1 AS `database_qualified_id`,
 1 AS `cache_hit`,
 1 AS `action_id`,
 1 AS `action_qualified_id`,
 1 AS `query`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_subscriptions`
--

DROP TABLE IF EXISTS `v_subscriptions`;
/*!50001 DROP VIEW IF EXISTS `v_subscriptions`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_subscriptions` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `creator_id`,
 1 AS `archived`,
 1 AS `dashboard_qualified_id`,
 1 AS `schedule_type`,
 1 AS `schedule_day`,
 1 AS `schedule_hour`,
 1 AS `recipient_type`,
 1 AS `recipients`,
 1 AS `recipient_external`,
 1 AS `parameters`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_tables`
--

DROP TABLE IF EXISTS `v_tables`;
/*!50001 DROP VIEW IF EXISTS `v_tables`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_tables` AS SELECT
 1 AS `entity_id`,
 1 AS `entity_qualified_id`,
 1 AS `created_at`,
 1 AS `updated_at`,
 1 AS `name`,
 1 AS `display_name`,
 1 AS `description`,
 1 AS `active`,
 1 AS `database_id`,
 1 AS `schema`,
 1 AS `is_upload`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_tasks`
--

DROP TABLE IF EXISTS `v_tasks`;
/*!50001 DROP VIEW IF EXISTS `v_tasks`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_tasks` AS SELECT
 1 AS `id`,
 1 AS `task`,
 1 AS `database_qualified_id`,
 1 AS `started_at`,
 1 AS `ended_at`,
 1 AS `duration_seconds`,
 1 AS `details`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_users`
--

DROP TABLE IF EXISTS `v_users`;
/*!50001 DROP VIEW IF EXISTS `v_users`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_users` AS SELECT
 1 AS `user_id`,
 1 AS `entity_qualified_id`,
 1 AS `type`,
 1 AS `email`,
 1 AS `first_name`,
 1 AS `last_name`,
 1 AS `full_name`,
 1 AS `date_joined`,
 1 AS `last_login`,
 1 AS `updated_at`,
 1 AS `is_admin`,
 1 AS `is_active`,
 1 AS `sso_source`,
 1 AS `locale`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `v_view_log`
--

DROP TABLE IF EXISTS `v_view_log`;
/*!50001 DROP VIEW IF EXISTS `v_view_log`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `v_view_log` AS SELECT
 1 AS `id`,
 1 AS `timestamp`,
 1 AS `user_id`,
 1 AS `entity_type`,
 1 AS `entity_id`,
 1 AS `entity_qualified_id`*/;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `vas_cur_streamer_income`
--

DROP TABLE IF EXISTS `vas_cur_streamer_income`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vas_cur_streamer_income` (
  `mid` bigint NOT NULL,
  `income` bigint NOT NULL,
  `pdate` timestamp(6) NOT NULL,
  KEY `mid_pdate` (`mid`,`pdate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vas_cur_streamer_income`
--

LOCK TABLES `vas_cur_streamer_income` WRITE;
/*!40000 ALTER TABLE `vas_cur_streamer_income` DISABLE KEYS */;
INSERT INTO `vas_cur_streamer_income` VALUES (77377,6680,'2024-06-16 16:00:00.000000'),(182308,96240,'2024-06-16 16:00:00.000000'),(73857,33418,'2024-06-16 16:00:00.000000'),(269339,12821,'2024-06-16 16:00:00.000000'),(106148,6152,'2024-06-16 16:00:00.000000'),(269583,12081,'2024-06-16 16:00:00.000000'),(139,2778,'2024-06-16 16:00:00.000000'),(14573,11676,'2024-06-16 16:00:00.000000'),(66,958,'2024-06-16 16:00:00.000000'),(67019,31584,'2024-06-16 16:00:00.000000'),(270888,4014,'2024-06-16 16:00:00.000000'),(109,0,'2024-06-16 16:00:00.000000'),(2593,0,'2024-06-16 16:00:00.000000'),(268954,3335,'2024-06-16 16:00:00.000000'),(123,1416,'2024-06-16 16:00:00.000000'),(161609,50759,'2024-06-16 16:00:00.000000'),(283,1408,'2024-06-16 16:00:00.000000'),(25,462,'2024-06-16 16:00:00.000000'),(215008,856,'2024-06-16 16:00:00.000000'),(34,240,'2024-06-16 16:00:00.000000'),(144384,238,'2024-06-16 16:00:00.000000'),(69,4248,'2024-06-16 16:00:00.000000'),(195763,1341,'2024-06-16 16:00:00.000000'),(186083,719,'2024-06-16 16:00:00.000000'),(77,2352,'2024-06-16 16:00:00.000000'),(75,1368,'2024-06-16 16:00:00.000000'),(61,7276,'2024-06-16 16:00:00.000000'),(119,3564,'2024-06-16 16:00:00.000000'),(85,420,'2024-06-16 16:00:00.000000'),(240225,1170,'2024-06-16 16:00:00.000000'),(78740,1571,'2024-06-16 16:00:00.000000'),(258846,114,'2024-06-16 16:00:00.000000'),(141,1290,'2024-06-16 16:00:00.000000'),(163374,10253,'2024-06-16 16:00:00.000000'),(148509,560,'2024-06-16 16:00:00.000000'),(143961,6344,'2024-06-16 16:00:00.000000'),(159566,6040,'2024-06-16 16:00:00.000000'),(213554,960,'2024-06-16 16:00:00.000000'),(102,10176,'2024-06-16 16:00:00.000000'),(137,2040,'2024-06-16 16:00:00.000000'),(164,680,'2024-06-16 16:00:00.000000'),(190618,3885,'2024-06-16 16:00:00.000000'),(164630,544,'2024-06-16 16:00:00.000000'),(259111,240,'2024-06-16 16:00:00.000000'),(175834,1404,'2024-06-16 16:00:00.000000'),(142,1146,'2024-06-16 16:00:00.000000'),(6069,14095,'2024-06-16 16:00:00.000000'),(67383,9774,'2024-06-16 16:00:00.000000'),(270232,599,'2024-06-16 16:00:00.000000'),(74,40310,'2024-06-16 16:00:00.000000'),(217606,556,'2024-06-16 16:00:00.000000'),(97857,3900,'2024-06-16 16:00:00.000000'),(93579,227,'2024-06-16 16:00:00.000000'),(779,232,'2024-06-16 16:00:00.000000'),(146460,300,'2024-06-16 16:00:00.000000'),(13324,3405,'2024-06-16 16:00:00.000000'),(103920,4258,'2024-06-16 16:00:00.000000'),(8,894,'2024-06-16 16:00:00.000000'),(106,5848,'2024-06-16 16:00:00.000000'),(267713,1011,'2024-06-16 16:00:00.000000'),(146166,3528,'2024-06-16 16:00:00.000000'),(121,4164,'2024-06-16 16:00:00.000000'),(215135,60,'2024-06-16 16:00:00.000000'),(243393,20,'2024-06-16 16:00:00.000000'),(145740,976,'2024-06-16 16:00:00.000000'),(226924,636,'2024-06-16 16:00:00.000000'),(146545,347,'2024-06-16 16:00:00.000000'),(113,2058,'2024-06-16 16:00:00.000000'),(174440,1728,'2024-06-16 16:00:00.000000'),(270017,340,'2024-06-16 16:00:00.000000'),(9,823,'2024-06-16 16:00:00.000000'),(213014,488,'2024-06-16 16:00:00.000000'),(58,480,'2024-06-16 16:00:00.000000'),(145806,832,'2024-06-16 16:00:00.000000'),(179782,588,'2024-06-16 16:00:00.000000'),(69379,2447,'2024-06-16 16:00:00.000000'),(4,1188,'2024-06-16 16:00:00.000000'),(20,392,'2024-06-16 16:00:00.000000'),(13820,392,'2024-06-16 16:00:00.000000'),(169095,196,'2024-06-16 16:00:00.000000'),(63,18210,'2024-06-16 16:00:00.000000'),(87907,4480,'2024-06-16 16:00:00.000000'),(140,414,'2024-06-16 16:00:00.000000'),(145309,400,'2024-06-16 16:00:00.000000'),(249042,2224,'2024-06-16 16:00:00.000000'),(26,60,'2024-06-16 16:00:00.000000'),(11,480,'2024-06-16 16:00:00.000000'),(202826,1104,'2024-06-16 16:00:00.000000'),(91236,1152,'2024-06-16 16:00:00.000000'),(1958,3792,'2024-06-16 16:00:00.000000'),(64,2760,'2024-06-16 16:00:00.000000'),(79843,8828,'2024-06-16 16:00:00.000000'),(86090,1546,'2024-06-16 16:00:00.000000'),(167340,288,'2024-06-16 16:00:00.000000'),(37634,4336,'2024-06-16 16:00:00.000000'),(90281,3264,'2024-06-16 16:00:00.000000'),(48,594,'2024-06-16 16:00:00.000000'),(280544,528,'2024-06-16 16:00:00.000000'),(215240,173,'2024-06-16 16:00:00.000000'),(275013,948,'2024-06-16 16:00:00.000000'),(269632,3377,'2024-06-16 16:00:00.000000'),(7,234,'2024-06-16 16:00:00.000000'),(218851,4352,'2024-06-16 16:00:00.000000'),(26283,0,'2024-06-16 16:00:00.000000'),(276039,252,'2024-06-16 16:00:00.000000'),(242263,1200,'2024-06-16 16:00:00.000000'),(120,354,'2024-06-16 16:00:00.000000'),(1258,419,'2024-06-16 16:00:00.000000'),(270602,345,'2024-06-16 16:00:00.000000'),(92,354,'2024-06-16 16:00:00.000000'),(212561,234,'2024-06-16 16:00:00.000000'),(99,0,'2024-06-16 16:00:00.000000'),(898,232,'2024-06-16 16:00:00.000000'),(65,12640,'2024-06-16 16:00:00.000000'),(51609,1416,'2024-06-16 16:00:00.000000'),(1649,1264,'2024-06-16 16:00:00.000000'),(192434,118,'2024-06-16 16:00:00.000000'),(107,594,'2024-06-16 16:00:00.000000'),(79,294,'2024-06-16 16:00:00.000000'),(93,468,'2024-06-16 16:00:00.000000'),(101,294,'2024-06-16 16:00:00.000000'),(66771,792,'2024-06-16 16:00:00.000000'),(87404,1060,'2024-06-16 16:00:00.000000'),(40441,1317,'2024-06-16 16:00:00.000000'),(217860,312,'2024-06-16 16:00:00.000000'),(254325,16,'2024-06-16 16:00:00.000000'),(73,414,'2024-06-16 16:00:00.000000'),(16311,392,'2024-06-16 16:00:00.000000'),(182308,157380,'2024-06-17 16:00:00.000000'),(73857,53454,'2024-06-17 16:00:00.000000'),(164630,1632,'2024-06-17 16:00:00.000000'),(87404,13973,'2024-06-17 16:00:00.000000'),(14573,14259,'2024-06-17 16:00:00.000000'),(163374,8862,'2024-06-17 16:00:00.000000'),(190618,3617,'2024-06-17 16:00:00.000000'),(77377,6976,'2024-06-17 16:00:00.000000'),(75,720,'2024-06-17 16:00:00.000000'),(67019,12567,'2024-06-17 16:00:00.000000'),(269339,14015,'2024-06-17 16:00:00.000000'),(106148,8063,'2024-06-17 16:00:00.000000'),(269632,7560,'2024-06-17 16:00:00.000000'),(270602,899,'2024-06-17 16:00:00.000000'),(61,10882,'2024-06-17 16:00:00.000000'),(6069,23135,'2024-06-17 16:00:00.000000'),(143961,17621,'2024-06-17 16:00:00.000000'),(90281,2688,'2024-06-17 16:00:00.000000'),(37634,72,'2024-06-17 16:00:00.000000'),(69,1758,'2024-06-17 16:00:00.000000'),(161609,9491,'2024-06-17 16:00:00.000000'),(169095,1203,'2024-06-17 16:00:00.000000'),(13324,4884,'2024-06-17 16:00:00.000000'),(102,4764,'2024-06-17 16:00:00.000000'),(268954,4251,'2024-06-17 16:00:00.000000'),(106,18584,'2024-06-17 16:00:00.000000'),(16311,784,'2024-06-17 16:00:00.000000'),(97857,2505,'2024-06-17 16:00:00.000000'),(78740,1988,'2024-06-17 16:00:00.000000'),(93579,143,'2024-06-17 16:00:00.000000'),(148509,2728,'2024-06-17 16:00:00.000000'),(74,12392,'2024-06-17 16:00:00.000000'),(1958,3304,'2024-06-17 16:00:00.000000'),(77,882,'2024-06-17 16:00:00.000000'),(269583,16428,'2024-06-17 16:00:00.000000'),(79843,19654,'2024-06-17 16:00:00.000000'),(86090,3447,'2024-06-17 16:00:00.000000'),(67383,2688,'2024-06-17 16:00:00.000000'),(110,1188,'2024-06-17 16:00:00.000000'),(270888,2982,'2024-06-17 16:00:00.000000'),(121,2886,'2024-06-17 16:00:00.000000'),(109,2184,'2024-06-17 16:00:00.000000'),(2593,56,'2024-06-17 16:00:00.000000'),(215240,228,'2024-06-17 16:00:00.000000'),(273575,254,'2024-06-17 16:00:00.000000'),(267884,2005,'2024-06-17 16:00:00.000000'),(132,354,'2024-06-17 16:00:00.000000'),(195763,416,'2024-06-17 16:00:00.000000'),(186083,482,'2024-06-17 16:00:00.000000'),(63,594,'2024-06-17 16:00:00.000000'),(240225,1872,'2024-06-17 16:00:00.000000'),(259111,180,'2024-06-17 16:00:00.000000'),(146340,153,'2024-06-17 16:00:00.000000'),(34,120,'2024-06-17 16:00:00.000000'),(159566,3688,'2024-06-17 16:00:00.000000'),(8,648,'2024-06-17 16:00:00.000000'),(87907,2720,'2024-06-17 16:00:00.000000'),(179782,3276,'2024-06-17 16:00:00.000000'),(218851,1152,'2024-06-17 16:00:00.000000'),(85,180,'2024-06-17 16:00:00.000000'),(93,468,'2024-06-17 16:00:00.000000'),(213554,160,'2024-06-17 16:00:00.000000'),(249042,2137,'2024-06-17 16:00:00.000000'),(163608,232,'2024-06-17 16:00:00.000000'),(280318,175,'2024-06-17 16:00:00.000000'),(159,23,'2024-06-17 16:00:00.000000'),(1188,392,'2024-06-17 16:00:00.000000'),(296564,448,'2024-06-17 16:00:00.000000'),(227196,1848,'2024-06-17 16:00:00.000000'),(25,228,'2024-06-17 16:00:00.000000'),(11,1302,'2024-06-17 16:00:00.000000'),(283,944,'2024-06-17 16:00:00.000000'),(51609,2272,'2024-06-17 16:00:00.000000'),(66,360,'2024-06-17 16:00:00.000000'),(137,2856,'2024-06-17 16:00:00.000000'),(164,1068,'2024-06-17 16:00:00.000000'),(172731,472,'2024-06-17 16:00:00.000000'),(123,708,'2024-06-17 16:00:00.000000'),(779,232,'2024-06-17 16:00:00.000000'),(145740,3382,'2024-06-17 16:00:00.000000'),(139,2070,'2024-06-17 16:00:00.000000'),(119,3564,'2024-06-17 16:00:00.000000'),(145806,416,'2024-06-17 16:00:00.000000'),(217606,556,'2024-06-17 16:00:00.000000'),(146166,1890,'2024-06-17 16:00:00.000000'),(254325,16,'2024-06-17 16:00:00.000000'),(275013,1422,'2024-06-17 16:00:00.000000'),(58,120,'2024-06-17 16:00:00.000000'),(213014,4128,'2024-06-17 16:00:00.000000'),(113,708,'2024-06-17 16:00:00.000000'),(120,708,'2024-06-17 16:00:00.000000'),(270232,667,'2024-06-17 16:00:00.000000'),(26,240,'2024-06-17 16:00:00.000000'),(44,1217,'2024-06-17 16:00:00.000000'),(141,1284,'2024-06-17 16:00:00.000000'),(79,588,'2024-06-17 16:00:00.000000'),(175834,1128,'2024-06-17 16:00:00.000000'),(142,3192,'2024-06-17 16:00:00.000000'),(82,702,'2024-06-17 16:00:00.000000'),(185893,234,'2024-06-17 16:00:00.000000'),(9,653,'2024-06-17 16:00:00.000000'),(5545,400,'2024-06-17 16:00:00.000000'),(146545,1349,'2024-06-17 16:00:00.000000'),(274697,414,'2024-06-17 16:00:00.000000'),(146460,300,'2024-06-17 16:00:00.000000'),(24582,224,'2024-06-17 16:00:00.000000'),(7,234,'2024-06-17 16:00:00.000000'),(167340,144,'2024-06-17 16:00:00.000000'),(242263,360,'2024-06-17 16:00:00.000000'),(264877,120,'2024-06-17 16:00:00.000000'),(96,0,'2024-06-17 16:00:00.000000'),(103920,600,'2024-06-17 16:00:00.000000'),(212561,234,'2024-06-17 16:00:00.000000'),(73,174,'2024-06-17 16:00:00.000000'),(151,468,'2024-06-17 16:00:00.000000'),(64,1134,'2024-06-17 16:00:00.000000'),(308732,392,'2024-06-17 16:00:00.000000'),(267713,762,'2024-06-17 16:00:00.000000'),(217860,0,'2024-06-17 16:00:00.000000'),(1471,792,'2024-06-17 16:00:00.000000'),(263921,60,'2024-06-17 16:00:00.000000'),(92,354,'2024-06-17 16:00:00.000000'),(308873,271,'2024-06-17 16:00:00.000000'),(293390,408,'2024-06-17 16:00:00.000000'),(1258,26,'2024-06-17 16:00:00.000000'),(209473,138,'2024-06-17 16:00:00.000000'),(898,696,'2024-06-17 16:00:00.000000'),(174440,312,'2024-06-17 16:00:00.000000'),(91236,552,'2024-06-17 16:00:00.000000'),(144384,60,'2024-06-17 16:00:00.000000'),(138,348,'2024-06-17 16:00:00.000000'),(69379,791,'2024-06-17 16:00:00.000000'),(213014,2072,'2024-06-18 16:00:00.000000'),(161609,8142,'2024-06-18 16:00:00.000000'),(209473,901,'2024-06-18 16:00:00.000000'),(190618,2119,'2024-06-18 16:00:00.000000'),(269339,32295,'2024-06-18 16:00:00.000000'),(106148,11247,'2024-06-18 16:00:00.000000'),(163374,8286,'2024-06-18 16:00:00.000000'),(113,1944,'2024-06-18 16:00:00.000000'),(14573,13033,'2024-06-18 16:00:00.000000'),(143961,10117,'2024-06-18 16:00:00.000000'),(182308,180708,'2024-06-18 16:00:00.000000'),(73857,61514,'2024-06-18 16:00:00.000000'),(123,1416,'2024-06-18 16:00:00.000000'),(77377,6672,'2024-06-18 16:00:00.000000'),(270888,3834,'2024-06-18 16:00:00.000000'),(6069,42280,'2024-06-18 16:00:00.000000'),(139,4416,'2024-06-18 16:00:00.000000'),(121,2874,'2024-06-18 16:00:00.000000'),(103920,600,'2024-06-18 16:00:00.000000'),(13324,2835,'2024-06-18 16:00:00.000000'),(77,1764,'2024-06-18 16:00:00.000000'),(67019,10829,'2024-06-18 16:00:00.000000'),(242263,2056,'2024-06-18 16:00:00.000000'),(61,10699,'2024-06-18 16:00:00.000000'),(51609,7704,'2024-06-18 16:00:00.000000'),(37634,3328,'2024-06-18 16:00:00.000000'),(146545,1650,'2024-06-18 16:00:00.000000'),(34,60,'2024-06-18 16:00:00.000000'),(74,9990,'2024-06-18 16:00:00.000000'),(79843,10795,'2024-06-18 16:00:00.000000'),(86090,1895,'2024-06-18 16:00:00.000000'),(137,1632,'2024-06-18 16:00:00.000000'),(164,544,'2024-06-18 16:00:00.000000'),(269632,4052,'2024-06-18 16:00:00.000000'),(87907,1088,'2024-06-18 16:00:00.000000'),(102,11988,'2024-06-18 16:00:00.000000'),(240225,936,'2024-06-18 16:00:00.000000'),(78740,1216,'2024-06-18 16:00:00.000000'),(146166,450,'2024-06-18 16:00:00.000000'),(273575,1184,'2024-06-18 16:00:00.000000'),(283,944,'2024-06-18 16:00:00.000000'),(174440,856,'2024-06-18 16:00:00.000000'),(91236,1720,'2024-06-18 16:00:00.000000'),(85,180,'2024-06-18 16:00:00.000000'),(159566,5984,'2024-06-18 16:00:00.000000'),(293390,2396,'2024-06-18 16:00:00.000000'),(1258,159,'2024-06-18 16:00:00.000000'),(64,4788,'2024-06-18 16:00:00.000000'),(268954,983,'2024-06-18 16:00:00.000000'),(296564,151,'2024-06-18 16:00:00.000000'),(186083,253,'2024-06-18 16:00:00.000000'),(16311,392,'2024-06-18 16:00:00.000000'),(69,1144,'2024-06-18 16:00:00.000000'),(213554,488,'2024-06-18 16:00:00.000000'),(90281,2160,'2024-06-18 16:00:00.000000'),(26,240,'2024-06-18 16:00:00.000000'),(141,1062,'2024-06-18 16:00:00.000000'),(11,946,'2024-06-18 16:00:00.000000'),(212561,234,'2024-06-18 16:00:00.000000'),(106,4584,'2024-06-18 16:00:00.000000'),(66,720,'2024-06-18 16:00:00.000000'),(146340,1207,'2024-06-18 16:00:00.000000'),(97857,2528,'2024-06-18 16:00:00.000000'),(93579,147,'2024-06-18 16:00:00.000000'),(175834,1872,'2024-06-18 16:00:00.000000'),(142,474,'2024-06-18 16:00:00.000000'),(263921,180,'2024-06-18 16:00:00.000000'),(82,468,'2024-06-18 16:00:00.000000'),(148,294,'2024-06-18 16:00:00.000000'),(195763,208,'2024-06-18 16:00:00.000000'),(267713,485,'2024-06-18 16:00:00.000000'),(111,1062,'2024-06-18 16:00:00.000000'),(270602,2692,'2024-06-18 16:00:00.000000'),(109,1836,'2024-06-18 16:00:00.000000'),(2593,47,'2024-06-18 16:00:00.000000'),(243875,240,'2024-06-18 16:00:00.000000'),(210852,294,'2024-06-18 16:00:00.000000'),(44,612,'2024-06-18 16:00:00.000000'),(269583,12063,'2024-06-18 16:00:00.000000'),(227196,2960,'2024-06-18 16:00:00.000000'),(73,414,'2024-06-18 16:00:00.000000'),(148509,840,'2024-06-18 16:00:00.000000'),(169095,1605,'2024-06-18 16:00:00.000000'),(145806,416,'2024-06-18 16:00:00.000000'),(163608,464,'2024-06-18 16:00:00.000000'),(167340,144,'2024-06-18 16:00:00.000000'),(119,2376,'2024-06-18 16:00:00.000000'),(164630,352,'2024-06-18 16:00:00.000000'),(1649,1264,'2024-06-18 16:00:00.000000'),(259111,360,'2024-06-18 16:00:00.000000'),(117,312,'2024-06-18 16:00:00.000000'),(249042,1192,'2024-06-18 16:00:00.000000'),(120,708,'2024-06-18 16:00:00.000000'),(217860,1104,'2024-06-18 16:00:00.000000'),(9,1005,'2024-06-18 16:00:00.000000'),(252780,120,'2024-06-18 16:00:00.000000'),(179782,522,'2024-06-18 16:00:00.000000'),(1958,1584,'2024-06-18 16:00:00.000000'),(69379,1264,'2024-06-18 16:00:00.000000'),(270232,277,'2024-06-18 16:00:00.000000'),(267884,1849,'2024-06-18 16:00:00.000000'),(118,-392,'2024-06-18 16:00:00.000000'),(13820,392,'2024-06-18 16:00:00.000000'),(275013,474,'2024-06-18 16:00:00.000000'),(228359,180,'2024-06-18 16:00:00.000000'),(215240,196,'2024-06-18 16:00:00.000000'),(750,552,'2024-06-18 16:00:00.000000'),(132,1596,'2024-06-18 16:00:00.000000'),(173051,392,'2024-06-18 16:00:00.000000'),(75,120,'2024-06-18 16:00:00.000000'),(67383,0,'2024-06-18 16:00:00.000000'),(5681,960,'2024-06-18 16:00:00.000000'),(226924,114,'2024-06-18 16:00:00.000000'),(101,588,'2024-06-18 16:00:00.000000'),(302200,292,'2024-06-18 16:00:00.000000'),(302231,116,'2024-06-18 16:00:00.000000'),(898,0,'2024-06-18 16:00:00.000000'),(185893,234,'2024-06-18 16:00:00.000000'),(308732,1588,'2024-06-18 16:00:00.000000'),(214911,312,'2024-06-18 16:00:00.000000'),(144384,60,'2024-06-18 16:00:00.000000'),(140,414,'2024-06-18 16:00:00.000000'),(280318,105,'2024-06-18 16:00:00.000000'),(159,14,'2024-06-18 16:00:00.000000'),(51444,392,'2024-06-18 16:00:00.000000'),(178210,0,'2024-06-18 16:00:00.000000'),(170194,0,'2024-06-18 16:00:00.000000'),(182308,33540,'2024-06-19 16:00:00.000000'),(73857,12384,'2024-06-19 16:00:00.000000'),(74,11308,'2024-06-19 16:00:00.000000'),(67019,23949,'2024-06-19 16:00:00.000000'),(209473,207,'2024-06-19 16:00:00.000000'),(190618,1147,'2024-06-19 16:00:00.000000'),(16311,1176,'2024-06-19 16:00:00.000000'),(106,7024,'2024-06-19 16:00:00.000000'),(269339,16831,'2024-06-19 16:00:00.000000'),(106148,11595,'2024-06-19 16:00:00.000000'),(90281,3056,'2024-06-19 16:00:00.000000'),(61,6424,'2024-06-19 16:00:00.000000'),(267884,961,'2024-06-19 16:00:00.000000'),(4,594,'2024-06-19 16:00:00.000000'),(14573,9904,'2024-06-19 16:00:00.000000'),(213014,2048,'2024-06-19 16:00:00.000000'),(164630,896,'2024-06-19 16:00:00.000000'),(6069,42080,'2024-06-19 16:00:00.000000'),(270888,3612,'2024-06-19 16:00:00.000000'),(77,23999,'2024-06-19 16:00:00.000000'),(109,6696,'2024-06-19 16:00:00.000000'),(2593,173,'2024-06-19 16:00:00.000000'),(163374,11528,'2024-06-19 16:00:00.000000'),(268954,15625,'2024-06-19 16:00:00.000000'),(185893,702,'2024-06-19 16:00:00.000000'),(78740,1146,'2024-06-19 16:00:00.000000'),(240225,468,'2024-06-19 16:00:00.000000'),(48,594,'2024-06-19 16:00:00.000000'),(139,4140,'2024-06-19 16:00:00.000000'),(64,1776,'2024-06-19 16:00:00.000000'),(153632,36,'2024-06-19 16:00:00.000000'),(5349,15,'2024-06-19 16:00:00.000000'),(77377,4512,'2024-06-19 16:00:00.000000'),(146545,2400,'2024-06-19 16:00:00.000000'),(13324,6314,'2024-06-19 16:00:00.000000'),(132,1242,'2024-06-19 16:00:00.000000'),(269583,18594,'2024-06-19 16:00:00.000000'),(148509,560,'2024-06-19 16:00:00.000000'),(146340,785,'2024-06-19 16:00:00.000000'),(280318,525,'2024-06-19 16:00:00.000000'),(159,70,'2024-06-19 16:00:00.000000'),(228359,60,'2024-06-19 16:00:00.000000'),(215240,8,'2024-06-19 16:00:00.000000'),(159566,6072,'2024-06-19 16:00:00.000000'),(226924,342,'2024-06-19 16:00:00.000000'),(40441,384,'2024-06-19 16:00:00.000000'),(67383,1584,'2024-06-19 16:00:00.000000'),(213554,320,'2024-06-19 16:00:00.000000'),(97857,2193,'2024-06-19 16:00:00.000000'),(93579,126,'2024-06-19 16:00:00.000000'),(145740,2052,'2024-06-19 16:00:00.000000'),(95,594,'2024-06-19 16:00:00.000000'),(99,0,'2024-06-19 16:00:00.000000'),(1649,632,'2024-06-19 16:00:00.000000'),(121,2232,'2024-06-19 16:00:00.000000'),(269632,5459,'2024-06-19 16:00:00.000000'),(161609,5867,'2024-06-19 16:00:00.000000'),(63,1602,'2024-06-19 16:00:00.000000'),(123,708,'2024-06-19 16:00:00.000000'),(175834,1170,'2024-06-19 16:00:00.000000'),(142,429,'2024-06-19 16:00:00.000000'),(898,696,'2024-06-19 16:00:00.000000'),(227196,1668,'2024-06-19 16:00:00.000000'),(273575,850,'2024-06-19 16:00:00.000000'),(258846,1140,'2024-06-19 16:00:00.000000'),(143961,4100,'2024-06-19 16:00:00.000000'),(25,635,'2024-06-19 16:00:00.000000'),(92,354,'2024-06-19 16:00:00.000000'),(137,4080,'2024-06-19 16:00:00.000000'),(164,1360,'2024-06-19 16:00:00.000000'),(93,234,'2024-06-19 16:00:00.000000'),(169095,3804,'2024-06-19 16:00:00.000000'),(144384,952,'2024-06-19 16:00:00.000000'),(11,716,'2024-06-19 16:00:00.000000'),(102,948,'2024-06-19 16:00:00.000000'),(9,1079,'2024-06-19 16:00:00.000000'),(51609,3456,'2024-06-19 16:00:00.000000'),(79843,8374,'2024-06-19 16:00:00.000000'),(86090,1470,'2024-06-19 16:00:00.000000'),(145806,832,'2024-06-19 16:00:00.000000'),(293390,2416,'2024-06-19 16:00:00.000000'),(1258,162,'2024-06-19 16:00:00.000000'),(242263,2336,'2024-06-19 16:00:00.000000'),(91236,552,'2024-06-19 16:00:00.000000'),(259111,60,'2024-06-19 16:00:00.000000'),(66,240,'2024-06-19 16:00:00.000000'),(1958,3184,'2024-06-19 16:00:00.000000'),(141,708,'2024-06-19 16:00:00.000000'),(218851,992,'2024-06-19 16:00:00.000000'),(37634,3328,'2024-06-19 16:00:00.000000'),(7,468,'2024-06-19 16:00:00.000000'),(111,354,'2024-06-19 16:00:00.000000'),(73,342,'2024-06-19 16:00:00.000000'),(270232,277,'2024-06-19 16:00:00.000000'),(13820,392,'2024-06-19 16:00:00.000000'),(69,900,'2024-06-19 16:00:00.000000'),(267713,549,'2024-06-19 16:00:00.000000'),(174440,2920,'2024-06-19 16:00:00.000000'),(87907,1088,'2024-06-19 16:00:00.000000'),(270602,6498,'2024-06-19 16:00:00.000000'),(146460,1650,'2024-06-19 16:00:00.000000'),(249042,597,'2024-06-19 16:00:00.000000'),(69379,2127,'2024-06-19 16:00:00.000000'),(197811,1504,'2024-06-19 16:00:00.000000'),(75,18168,'2024-06-19 16:00:00.000000'),(308873,339,'2024-06-19 16:00:00.000000'),(101,1194,'2024-06-19 16:00:00.000000'),(119,594,'2024-06-19 16:00:00.000000'),(87404,4574,'2024-06-19 16:00:00.000000'),(173051,1176,'2024-06-19 16:00:00.000000'),(44,946,'2024-06-19 16:00:00.000000'),(81,120,'2024-06-19 16:00:00.000000'),(308732,1570,'2024-06-19 16:00:00.000000'),(195763,104,'2024-06-19 16:00:00.000000'),(186083,55,'2024-06-19 16:00:00.000000'),(270017,680,'2024-06-19 16:00:00.000000'),(146166,150,'2024-06-19 16:00:00.000000'),(85,60,'2024-06-19 16:00:00.000000'),(26283,792,'2024-06-19 16:00:00.000000'),(120,2748,'2024-06-19 16:00:00.000000'),(34,240,'2024-06-19 16:00:00.000000'),(26,60,'2024-06-19 16:00:00.000000'),(179782,1728,'2024-06-19 16:00:00.000000'),(113,354,'2024-06-19 16:00:00.000000'),(8,118,'2024-06-19 16:00:00.000000'),(163374,10108,'2024-06-20 16:00:00.000000'),(268954,6516,'2024-06-20 16:00:00.000000'),(106148,9687,'2024-06-20 16:00:00.000000'),(169095,1806,'2024-06-20 16:00:00.000000'),(13324,3718,'2024-06-20 16:00:00.000000'),(269339,12474,'2024-06-20 16:00:00.000000'),(190618,498,'2024-06-20 16:00:00.000000'),(182308,22920,'2024-06-20 16:00:00.000000'),(73857,8774,'2024-06-20 16:00:00.000000'),(270888,3402,'2024-06-20 16:00:00.000000'),(6069,53062,'2024-06-20 16:00:00.000000'),(77377,5392,'2024-06-20 16:00:00.000000'),(34,180,'2024-06-20 16:00:00.000000'),(67019,6780,'2024-06-20 16:00:00.000000'),(69379,160,'2024-06-20 16:00:00.000000'),(269583,29349,'2024-06-20 16:00:00.000000'),(163608,464,'2024-06-20 16:00:00.000000'),(144384,120,'2024-06-20 16:00:00.000000'),(106,11064,'2024-06-20 16:00:00.000000'),(74,2766,'2024-06-20 16:00:00.000000'),(898,864,'2024-06-20 16:00:00.000000'),(269632,4772,'2024-06-20 16:00:00.000000'),(308732,317,'2024-06-20 16:00:00.000000'),(159566,7214,'2024-06-20 16:00:00.000000'),(146340,628,'2024-06-20 16:00:00.000000'),(44,4869,'2024-06-20 16:00:00.000000'),(161609,13616,'2024-06-20 16:00:00.000000'),(139,-1566,'2024-06-20 16:00:00.000000'),(14573,10692,'2024-06-20 16:00:00.000000'),(267884,592,'2024-06-20 16:00:00.000000'),(143961,3141,'2024-06-20 16:00:00.000000'),(67383,882,'2024-06-20 16:00:00.000000'),(293390,8442,'2024-06-20 16:00:00.000000'),(1258,566,'2024-06-20 16:00:00.000000'),(78740,1352,'2024-06-20 16:00:00.000000'),(175834,936,'2024-06-20 16:00:00.000000'),(142,60,'2024-06-20 16:00:00.000000'),(137,2040,'2024-06-20 16:00:00.000000'),(164,680,'2024-06-20 16:00:00.000000'),(164630,776,'2024-06-20 16:00:00.000000'),(51609,2520,'2024-06-20 16:00:00.000000'),(123,1062,'2024-06-20 16:00:00.000000'),(103920,1118,'2024-06-20 16:00:00.000000'),(141,354,'2024-06-20 16:00:00.000000'),(227196,756,'2024-06-20 16:00:00.000000'),(63,2244,'2024-06-20 16:00:00.000000'),(101,1236,'2024-06-20 16:00:00.000000'),(61,3898,'2024-06-20 16:00:00.000000'),(209473,138,'2024-06-20 16:00:00.000000'),(146545,1902,'2024-06-20 16:00:00.000000'),(69,2500,'2024-06-20 16:00:00.000000'),(259111,240,'2024-06-20 16:00:00.000000'),(121,3228,'2024-06-20 16:00:00.000000'),(273575,1645,'2024-06-20 16:00:00.000000'),(195763,0,'2024-06-20 16:00:00.000000'),(186083,0,'2024-06-20 16:00:00.000000'),(280318,105,'2024-06-20 16:00:00.000000'),(159,24,'2024-06-20 16:00:00.000000'),(37634,1584,'2024-06-20 16:00:00.000000'),(79843,2406,'2024-06-20 16:00:00.000000'),(86090,420,'2024-06-20 16:00:00.000000'),(102,2190,'2024-06-20 16:00:00.000000'),(146166,300,'2024-06-20 16:00:00.000000'),(75,360,'2024-06-20 16:00:00.000000'),(212561,234,'2024-06-20 16:00:00.000000'),(270232,345,'2024-06-20 16:00:00.000000'),(267713,1151,'2024-06-20 16:00:00.000000'),(178210,396,'2024-06-20 16:00:00.000000'),(170194,41,'2024-06-20 16:00:00.000000'),(51444,392,'2024-06-20 16:00:00.000000'),(4,1188,'2024-06-20 16:00:00.000000'),(263921,60,'2024-06-20 16:00:00.000000'),(97857,2392,'2024-06-20 16:00:00.000000'),(93579,140,'2024-06-20 16:00:00.000000'),(274697,554,'2024-06-20 16:00:00.000000'),(132,708,'2024-06-20 16:00:00.000000'),(145806,1792,'2024-06-20 16:00:00.000000'),(2953,14888,'2024-06-20 16:00:00.000000'),(9,118,'2024-06-20 16:00:00.000000'),(167340,144,'2024-06-20 16:00:00.000000'),(148509,560,'2024-06-20 16:00:00.000000'),(174440,1728,'2024-06-20 16:00:00.000000'),(242263,1216,'2024-06-20 16:00:00.000000'),(213014,824,'2024-06-20 16:00:00.000000'),(320610,702,'2024-06-20 16:00:00.000000'),(77,3258,'2024-06-20 16:00:00.000000'),(1649,1264,'2024-06-20 16:00:00.000000'),(275013,474,'2024-06-20 16:00:00.000000'),(58,354,'2024-06-20 16:00:00.000000'),(66,0,'2024-06-20 16:00:00.000000'),(91236,8,'2024-06-20 16:00:00.000000'),(119,0,'2024-06-20 16:00:00.000000'),(240225,234,'2024-06-20 16:00:00.000000'),(109,2370,'2024-06-20 16:00:00.000000'),(2593,60,'2024-06-20 16:00:00.000000'),(107,10074,'2024-06-20 16:00:00.000000'),(1471,392,'2024-06-20 16:00:00.000000'),(249042,293,'2024-06-20 16:00:00.000000'),(64,534,'2024-06-20 16:00:00.000000'),(25,114,'2024-06-20 16:00:00.000000'),(11,360,'2024-06-20 16:00:00.000000'),(270602,622,'2024-06-20 16:00:00.000000'),(145740,1650,'2024-06-20 16:00:00.000000'),(179782,588,'2024-06-20 16:00:00.000000'),(310356,234,'2024-06-20 16:00:00.000000'),(16311,392,'2024-06-20 16:00:00.000000'),(113,708,'2024-06-20 16:00:00.000000'),(1958,5248,'2024-06-20 16:00:00.000000'),(258846,228,'2024-06-20 16:00:00.000000'),(94,474,'2024-06-20 16:00:00.000000'),(283,472,'2024-06-20 16:00:00.000000'),(308873,271,'2024-06-20 16:00:00.000000'),(1188,392,'2024-06-20 16:00:00.000000'),(40441,312,'2024-06-20 16:00:00.000000'),(90281,1104,'2024-06-20 16:00:00.000000'),(26,60,'2024-06-20 16:00:00.000000'),(87907,544,'2024-06-20 16:00:00.000000'),(120,354,'2024-06-20 16:00:00.000000'),(110,594,'2024-06-20 16:00:00.000000'),(148,6216,'2024-06-20 16:00:00.000000'),(213554,160,'2024-06-20 16:00:00.000000'),(99,354,'2024-06-20 16:00:00.000000'),(52499,792,'2024-06-20 16:00:00.000000'),(182308,49608,'2024-06-21 16:00:00.000000'),(73857,17264,'2024-06-21 16:00:00.000000'),(103920,3296,'2024-06-21 16:00:00.000000'),(13324,3168,'2024-06-21 16:00:00.000000'),(161609,5954,'2024-06-21 16:00:00.000000'),(270888,2184,'2024-06-21 16:00:00.000000'),(120,1374,'2024-06-21 16:00:00.000000'),(14573,6549,'2024-06-21 16:00:00.000000'),(213554,328,'2024-06-21 16:00:00.000000'),(227196,1110,'2024-06-21 16:00:00.000000'),(66,359,'2024-06-21 16:00:00.000000'),(67019,17693,'2024-06-21 16:00:00.000000'),(144384,180,'2024-06-21 16:00:00.000000'),(249042,1353,'2024-06-21 16:00:00.000000'),(78740,1191,'2024-06-21 16:00:00.000000'),(159566,3944,'2024-06-21 16:00:00.000000'),(82,21419,'2024-06-21 16:00:00.000000'),(63,1601,'2024-06-21 16:00:00.000000'),(269339,13670,'2024-06-21 16:00:00.000000'),(106148,11447,'2024-06-21 16:00:00.000000'),(273575,1227,'2024-06-21 16:00:00.000000'),(77377,6696,'2024-06-21 16:00:00.000000'),(74,4174,'2024-06-21 16:00:00.000000'),(121,2340,'2024-06-21 16:00:00.000000'),(259111,180,'2024-06-21 16:00:00.000000'),(169095,1101,'2024-06-21 16:00:00.000000'),(164630,5696,'2024-06-21 16:00:00.000000'),(269583,41573,'2024-06-21 16:00:00.000000'),(163374,14563,'2024-06-21 16:00:00.000000'),(8,650,'2024-06-21 16:00:00.000000'),(280318,2204,'2024-06-21 16:00:00.000000'),(159,297,'2024-06-21 16:00:00.000000'),(109,942,'2024-06-21 16:00:00.000000'),(2593,24,'2024-06-21 16:00:00.000000'),(61,23535,'2024-06-21 16:00:00.000000'),(268954,8392,'2024-06-21 16:00:00.000000'),(26,60,'2024-06-21 16:00:00.000000'),(137,3672,'2024-06-21 16:00:00.000000'),(164,1224,'2024-06-21 16:00:00.000000'),(106,20856,'2024-06-21 16:00:00.000000'),(2953,2376,'2024-06-21 16:00:00.000000'),(270232,0,'2024-06-21 16:00:00.000000'),(293390,906,'2024-06-21 16:00:00.000000'),(1258,59,'2024-06-21 16:00:00.000000'),(179782,1626,'2024-06-21 16:00:00.000000'),(26283,792,'2024-06-21 16:00:00.000000'),(69,588,'2024-06-21 16:00:00.000000'),(97857,3828,'2024-06-21 16:00:00.000000'),(93579,220,'2024-06-21 16:00:00.000000'),(146460,300,'2024-06-21 16:00:00.000000'),(143961,3071,'2024-06-21 16:00:00.000000'),(69379,2848,'2024-06-21 16:00:00.000000'),(146166,1950,'2024-06-21 16:00:00.000000'),(44,2035,'2024-06-21 16:00:00.000000'),(79843,3228,'2024-06-21 16:00:00.000000'),(86090,565,'2024-06-21 16:00:00.000000'),(6069,-6088,'2024-06-21 16:00:00.000000'),(11,414,'2024-06-21 16:00:00.000000'),(101,588,'2024-06-21 16:00:00.000000'),(37634,792,'2024-06-21 16:00:00.000000'),(269632,2146,'2024-06-21 16:00:00.000000'),(64,1236,'2024-06-21 16:00:00.000000'),(197811,1504,'2024-06-21 16:00:00.000000'),(73,588,'2024-06-21 16:00:00.000000'),(119,4350,'2024-06-21 16:00:00.000000'),(79,294,'2024-06-21 16:00:00.000000'),(48900,992,'2024-06-21 16:00:00.000000'),(141,348,'2024-06-21 16:00:00.000000'),(87404,1331,'2024-06-21 16:00:00.000000'),(77,882,'2024-06-21 16:00:00.000000'),(175834,702,'2024-06-21 16:00:00.000000'),(142,399,'2024-06-21 16:00:00.000000'),(213014,1616,'2024-06-21 16:00:00.000000'),(146545,300,'2024-06-21 16:00:00.000000'),(258846,228,'2024-06-21 16:00:00.000000'),(102,1542,'2024-06-21 16:00:00.000000'),(145740,1248,'2024-06-21 16:00:00.000000'),(113,936,'2024-06-21 16:00:00.000000'),(270602,622,'2024-06-21 16:00:00.000000'),(19316,792,'2024-06-21 16:00:00.000000'),(190618,480,'2024-06-21 16:00:00.000000'),(9,120,'2024-06-21 16:00:00.000000'),(174440,624,'2024-06-21 16:00:00.000000'),(81,238,'2024-06-21 16:00:00.000000'),(16311,392,'2024-06-21 16:00:00.000000'),(320610,292,'2024-06-21 16:00:00.000000'),(51609,1104,'2024-06-21 16:00:00.000000'),(67383,588,'2024-06-21 16:00:00.000000'),(90281,528,'2024-06-21 16:00:00.000000'),(283,472,'2024-06-21 16:00:00.000000'),(242263,1688,'2024-06-21 16:00:00.000000'),(48,594,'2024-06-21 16:00:00.000000'),(148509,1400,'2024-06-21 16:00:00.000000'),(139,828,'2024-06-21 16:00:00.000000'),(270017,1153,'2024-06-21 16:00:00.000000'),(146340,157,'2024-06-21 16:00:00.000000'),(96,234,'2024-06-21 16:00:00.000000'),(1958,1264,'2024-06-21 16:00:00.000000'),(226924,114,'2024-06-21 16:00:00.000000'),(218851,1568,'2024-06-21 16:00:00.000000'),(93,234,'2024-06-21 16:00:00.000000'),(308732,317,'2024-06-21 16:00:00.000000'),(1649,-632,'2024-06-21 16:00:00.000000'),(240225,234,'2024-06-21 16:00:00.000000'),(148,1116,'2024-06-21 16:00:00.000000'),(91236,464,'2024-06-21 16:00:00.000000'),(308873,271,'2024-06-21 16:00:00.000000'),(185893,0,'2024-06-21 16:00:00.000000'),(4,594,'2024-06-21 16:00:00.000000'),(58,120,'2024-06-21 16:00:00.000000'),(75,120,'2024-06-21 16:00:00.000000'),(267884,296,'2024-06-21 16:00:00.000000'),(3940,29032,'2024-06-21 16:00:00.000000'),(78,0,'2024-06-21 16:00:00.000000'),(87907,544,'2024-06-21 16:00:00.000000'),(123,354,'2024-06-21 16:00:00.000000'),(182308,20940,'2024-06-22 16:00:00.000000'),(73857,7990,'2024-06-22 16:00:00.000000'),(148,294,'2024-06-22 16:00:00.000000'),(14573,7593,'2024-06-22 16:00:00.000000'),(113,1062,'2024-06-22 16:00:00.000000'),(143961,5376,'2024-06-22 16:00:00.000000'),(146340,2251,'2024-06-22 16:00:00.000000'),(13324,2518,'2024-06-22 16:00:00.000000'),(148509,280,'2024-06-22 16:00:00.000000'),(78740,871,'2024-06-22 16:00:00.000000'),(270888,3030,'2024-06-22 16:00:00.000000'),(74,19506,'2024-06-22 16:00:00.000000'),(67019,16184,'2024-06-22 16:00:00.000000'),(227196,2910,'2024-06-22 16:00:00.000000'),(159566,10720,'2024-06-22 16:00:00.000000'),(87907,544,'2024-06-22 16:00:00.000000'),(190618,1902,'2024-06-22 16:00:00.000000'),(137,2040,'2024-06-22 16:00:00.000000'),(164,680,'2024-06-22 16:00:00.000000'),(144384,417,'2024-06-22 16:00:00.000000'),(40441,624,'2024-06-22 16:00:00.000000'),(308732,317,'2024-06-22 16:00:00.000000'),(106148,13003,'2024-06-22 16:00:00.000000'),(217860,624,'2024-06-22 16:00:00.000000'),(213014,1720,'2024-06-22 16:00:00.000000'),(218851,4416,'2024-06-22 16:00:00.000000'),(269339,16904,'2024-06-22 16:00:00.000000'),(77377,3920,'2024-06-22 16:00:00.000000'),(11,822,'2024-06-22 16:00:00.000000'),(269632,3895,'2024-06-22 16:00:00.000000'),(121,2700,'2024-06-22 16:00:00.000000'),(8,118,'2024-06-22 16:00:00.000000'),(69379,7511,'2024-06-22 16:00:00.000000'),(4,594,'2024-06-22 16:00:00.000000'),(82,1296,'2024-06-22 16:00:00.000000'),(175834,1356,'2024-06-22 16:00:00.000000'),(142,87,'2024-06-22 16:00:00.000000'),(898,464,'2024-06-22 16:00:00.000000'),(268954,3844,'2024-06-22 16:00:00.000000'),(163374,3771,'2024-06-22 16:00:00.000000'),(269583,13813,'2024-06-22 16:00:00.000000'),(270232,554,'2024-06-22 16:00:00.000000'),(78,234,'2024-06-22 16:00:00.000000'),(44,681,'2024-06-22 16:00:00.000000'),(91236,1888,'2024-06-22 16:00:00.000000'),(106,18088,'2024-06-22 16:00:00.000000'),(6069,20783,'2024-06-22 16:00:00.000000'),(79843,4303,'2024-06-22 16:00:00.000000'),(86090,754,'2024-06-22 16:00:00.000000'),(58,120,'2024-06-22 16:00:00.000000'),(37634,3328,'2024-06-22 16:00:00.000000'),(110,594,'2024-06-22 16:00:00.000000'),(270017,0,'2024-06-22 16:00:00.000000'),(61,2302,'2024-06-22 16:00:00.000000'),(48900,792,'2024-06-22 16:00:00.000000'),(197811,2208,'2024-06-22 16:00:00.000000'),(254325,576,'2024-06-22 16:00:00.000000'),(67383,1116,'2024-06-22 16:00:00.000000'),(109,1782,'2024-06-22 16:00:00.000000'),(2593,183,'2024-06-22 16:00:00.000000'),(185893,702,'2024-06-22 16:00:00.000000'),(97857,2967,'2024-06-22 16:00:00.000000'),(93579,171,'2024-06-22 16:00:00.000000'),(81,120,'2024-06-22 16:00:00.000000'),(93,234,'2024-06-22 16:00:00.000000'),(283,632,'2024-06-22 16:00:00.000000'),(77,588,'2024-06-22 16:00:00.000000'),(164630,2760,'2024-06-22 16:00:00.000000'),(169095,201,'2024-06-22 16:00:00.000000'),(146545,450,'2024-06-22 16:00:00.000000'),(2953,416,'2024-06-22 16:00:00.000000'),(166037,414,'2024-06-22 16:00:00.000000'),(273575,1262,'2024-06-22 16:00:00.000000'),(267713,277,'2024-06-22 16:00:00.000000'),(34,120,'2024-06-22 16:00:00.000000'),(66,588,'2024-06-22 16:00:00.000000'),(240225,234,'2024-06-22 16:00:00.000000'),(20,320,'2024-06-22 16:00:00.000000'),(145740,150,'2024-06-22 16:00:00.000000'),(270602,554,'2024-06-22 16:00:00.000000'),(146166,1152,'2024-06-22 16:00:00.000000'),(69,900,'2024-06-22 16:00:00.000000'),(228359,60,'2024-06-22 16:00:00.000000'),(215240,68,'2024-06-22 16:00:00.000000'),(1958,3472,'2024-06-22 16:00:00.000000'),(263921,0,'2024-06-22 16:00:00.000000'),(26,240,'2024-06-22 16:00:00.000000'),(139,828,'2024-06-22 16:00:00.000000'),(161609,3679,'2024-06-22 16:00:00.000000'),(146460,300,'2024-06-22 16:00:00.000000'),(101,3042,'2024-06-22 16:00:00.000000'),(75,17688,'2024-06-22 16:00:00.000000'),(9,120,'2024-06-22 16:00:00.000000'),(102,3342,'2024-06-22 16:00:00.000000'),(68,174,'2024-06-22 16:00:00.000000'),(249042,1465,'2024-06-22 16:00:00.000000'),(90281,528,'2024-06-22 16:00:00.000000'),(25,348,'2024-06-22 16:00:00.000000'),(242263,616,'2024-06-22 16:00:00.000000'),(280318,518,'2024-06-22 16:00:00.000000'),(159,70,'2024-06-22 16:00:00.000000'),(119,594,'2024-06-22 16:00:00.000000'),(172477,234,'2024-06-22 16:00:00.000000'),(3940,36499,'2024-06-22 16:00:00.000000'),(51609,1104,'2024-06-22 16:00:00.000000'),(87404,530,'2024-06-22 16:00:00.000000'),(259111,60,'2024-06-22 16:00:00.000000'),(195763,104,'2024-06-22 16:00:00.000000'),(186083,55,'2024-06-22 16:00:00.000000'),(95,0,'2024-06-22 16:00:00.000000'),(275013,474,'2024-06-22 16:00:00.000000'),(123,2748,'2024-06-22 16:00:00.000000'),(120,354,'2024-06-22 16:00:00.000000'),(132,690,'2024-06-22 16:00:00.000000'),(67379,616,'2024-06-22 16:00:00.000000'),(179782,522,'2024-06-22 16:00:00.000000'),(103920,300,'2024-06-22 16:00:00.000000'),(192434,118,'2024-06-22 16:00:00.000000'),(263758,120,'2024-06-22 16:00:00.000000'),(1958,11432,'2024-06-23 16:00:00.000000'),(3940,22479,'2024-06-23 16:00:00.000000'),(106148,13102,'2024-06-23 16:00:00.000000'),(213014,1784,'2024-06-23 16:00:00.000000'),(67383,1120,'2024-06-23 16:00:00.000000'),(67019,10551,'2024-06-23 16:00:00.000000'),(269339,16145,'2024-06-23 16:00:00.000000'),(109,5904,'2024-06-23 16:00:00.000000'),(2593,249,'2024-06-23 16:00:00.000000'),(14573,12297,'2024-06-23 16:00:00.000000'),(270888,4512,'2024-06-23 16:00:00.000000'),(73857,16024,'2024-06-23 16:00:00.000000'),(163374,7326,'2024-06-23 16:00:00.000000'),(269583,20292,'2024-06-23 16:00:00.000000'),(275013,4740,'2024-06-23 16:00:00.000000'),(78740,4162,'2024-06-23 16:00:00.000000'),(161609,3736,'2024-06-23 16:00:00.000000'),(77,10362,'2024-06-23 16:00:00.000000'),(64,4206,'2024-06-23 16:00:00.000000'),(227196,1184,'2024-06-23 16:00:00.000000'),(6069,20445,'2024-06-23 16:00:00.000000'),(182308,43560,'2024-06-23 16:00:00.000000'),(26,180,'2024-06-23 16:00:00.000000'),(77377,7080,'2024-06-23 16:00:00.000000'),(102,1068,'2024-06-23 16:00:00.000000'),(44,486,'2024-06-23 16:00:00.000000'),(267713,553,'2024-06-23 16:00:00.000000'),(137,408,'2024-06-23 16:00:00.000000'),(164,136,'2024-06-23 16:00:00.000000'),(164630,1392,'2024-06-23 16:00:00.000000'),(268954,4072,'2024-06-23 16:00:00.000000'),(95,594,'2024-06-23 16:00:00.000000'),(82,1061,'2024-06-23 16:00:00.000000'),(118,294,'2024-06-23 16:00:00.000000'),(190618,987,'2024-06-23 16:00:00.000000'),(61,2433,'2024-06-23 16:00:00.000000'),(159566,5856,'2024-06-23 16:00:00.000000'),(249042,1118,'2024-06-23 16:00:00.000000'),(121,1638,'2024-06-23 16:00:00.000000'),(148509,2160,'2024-06-23 16:00:00.000000'),(269632,1090,'2024-06-23 16:00:00.000000'),(327391,2681,'2024-06-23 16:00:00.000000'),(141,3102,'2024-06-23 16:00:00.000000'),(93,468,'2024-06-23 16:00:00.000000'),(308732,317,'2024-06-23 16:00:00.000000'),(103920,2018,'2024-06-23 16:00:00.000000'),(13324,4531,'2024-06-23 16:00:00.000000'),(20,240,'2024-06-23 16:00:00.000000'),(97857,2233,'2024-06-23 16:00:00.000000'),(93579,129,'2024-06-23 16:00:00.000000'),(144384,60,'2024-06-23 16:00:00.000000'),(106,20544,'2024-06-23 16:00:00.000000'),(37634,864,'2024-06-23 16:00:00.000000'),(85,60,'2024-06-23 16:00:00.000000'),(79843,2303,'2024-06-23 16:00:00.000000'),(86090,375,'2024-06-23 16:00:00.000000'),(69379,7524,'2024-06-23 16:00:00.000000'),(146545,450,'2024-06-23 16:00:00.000000'),(91236,2568,'2024-06-23 16:00:00.000000'),(169095,1701,'2024-06-23 16:00:00.000000'),(175834,4320,'2024-06-23 16:00:00.000000'),(142,637,'2024-06-23 16:00:00.000000'),(66,480,'2024-06-23 16:00:00.000000'),(11,358,'2024-06-23 16:00:00.000000'),(145740,300,'2024-06-23 16:00:00.000000'),(270017,1084,'2024-06-23 16:00:00.000000'),(215135,140,'2024-06-23 16:00:00.000000'),(243393,18,'2024-06-23 16:00:00.000000'),(67379,1064,'2024-06-23 16:00:00.000000'),(25,522,'2024-06-23 16:00:00.000000'),(16311,1568,'2024-06-23 16:00:00.000000'),(139,1884,'2024-06-23 16:00:00.000000'),(132,354,'2024-06-23 16:00:00.000000'),(58,0,'2024-06-23 16:00:00.000000'),(13820,392,'2024-06-23 16:00:00.000000'),(52499,14488,'2024-06-23 16:00:00.000000'),(218851,2848,'2024-06-23 16:00:00.000000'),(143961,2571,'2024-06-23 16:00:00.000000'),(280318,424,'2024-06-23 16:00:00.000000'),(159,1852,'2024-06-23 16:00:00.000000'),(101,474,'2024-06-23 16:00:00.000000'),(123,1710,'2024-06-23 16:00:00.000000'),(111,354,'2024-06-23 16:00:00.000000'),(2953,792,'2024-06-23 16:00:00.000000'),(267884,665,'2024-06-23 16:00:00.000000'),(213554,320,'2024-06-23 16:00:00.000000'),(145806,416,'2024-06-23 16:00:00.000000'),(146460,150,'2024-06-23 16:00:00.000000'),(270602,899,'2024-06-23 16:00:00.000000'),(240225,702,'2024-06-23 16:00:00.000000'),(146166,3102,'2024-06-23 16:00:00.000000'),(148,2688,'2024-06-23 16:00:00.000000'),(258846,114,'2024-06-23 16:00:00.000000'),(209473,138,'2024-06-23 16:00:00.000000'),(69,882,'2024-06-23 16:00:00.000000'),(140,414,'2024-06-23 16:00:00.000000'),(75,360,'2024-06-23 16:00:00.000000'),(179782,19644,'2024-06-23 16:00:00.000000'),(90281,4160,'2024-06-23 16:00:00.000000'),(273575,835,'2024-06-23 16:00:00.000000'),(242263,1312,'2024-06-23 16:00:00.000000'),(146340,1890,'2024-06-23 16:00:00.000000'),(320610,814,'2024-06-23 16:00:00.000000'),(74,4388,'2024-06-23 16:00:00.000000'),(51609,1416,'2024-06-23 16:00:00.000000'),(87907,1632,'2024-06-23 16:00:00.000000'),(228359,120,'2024-06-23 16:00:00.000000'),(215240,16,'2024-06-23 16:00:00.000000'),(73,414,'2024-06-23 16:00:00.000000'),(293390,351,'2024-06-23 16:00:00.000000'),(1258,23,'2024-06-23 16:00:00.000000'),(1649,632,'2024-06-23 16:00:00.000000'),(310356,234,'2024-06-23 16:00:00.000000'),(328717,2453,'2024-06-23 16:00:00.000000'),(79,294,'2024-06-23 16:00:00.000000'),(206580,70,'2024-06-23 16:00:00.000000'),(217860,312,'2024-06-23 16:00:00.000000'),(274697,1108,'2024-06-23 16:00:00.000000'),(326483,16324,'2024-06-23 16:00:00.000000'),(85910,156,'2024-06-23 16:00:00.000000'),(174440,0,'2024-06-23 16:00:00.000000'),(283,160,'2024-06-23 16:00:00.000000'),(8,120,'2024-06-23 16:00:00.000000'),(898,464,'2024-06-23 16:00:00.000000'),(7,234,'2024-06-23 16:00:00.000000'),(326483,14070,'2024-06-24 16:00:00.000000'),(159,1917,'2024-06-24 16:00:00.000000'),(146545,498,'2024-06-24 16:00:00.000000'),(13324,2865,'2024-06-24 16:00:00.000000'),(182308,26520,'2024-06-24 16:00:00.000000'),(73857,9976,'2024-06-24 16:00:00.000000'),(102,3376,'2024-06-24 16:00:00.000000'),(14573,18682,'2024-06-24 16:00:00.000000'),(269339,14911,'2024-06-24 16:00:00.000000'),(106148,16626,'2024-06-24 16:00:00.000000'),(1958,19368,'2024-06-24 16:00:00.000000'),(77377,5576,'2024-06-24 16:00:00.000000'),(106,40864,'2024-06-24 16:00:00.000000'),(215240,180,'2024-06-24 16:00:00.000000'),(78740,1607,'2024-06-24 16:00:00.000000'),(67019,13215,'2024-06-24 16:00:00.000000'),(163374,5932,'2024-06-24 16:00:00.000000'),(66,719,'2024-06-24 16:00:00.000000'),(6069,17464,'2024-06-24 16:00:00.000000'),(259111,120,'2024-06-24 16:00:00.000000'),(61,1218,'2024-06-24 16:00:00.000000'),(69,3174,'2024-06-24 16:00:00.000000'),(79843,3723,'2024-06-24 16:00:00.000000'),(86090,652,'2024-06-24 16:00:00.000000'),(161609,2595,'2024-06-24 16:00:00.000000'),(69379,3800,'2024-06-24 16:00:00.000000'),(269583,43563,'2024-06-24 16:00:00.000000'),(268954,8137,'2024-06-24 16:00:00.000000'),(274697,137,'2024-06-24 16:00:00.000000'),(113,1352,'2024-06-24 16:00:00.000000'),(159566,13920,'2024-06-24 16:00:00.000000'),(75,11264,'2024-06-24 16:00:00.000000'),(121,2574,'2024-06-24 16:00:00.000000'),(90281,3696,'2024-06-24 16:00:00.000000'),(175834,1170,'2024-06-24 16:00:00.000000'),(142,194,'2024-06-24 16:00:00.000000'),(218851,4800,'2024-06-24 16:00:00.000000'),(5681,960,'2024-06-24 16:00:00.000000'),(269632,1401,'2024-06-24 16:00:00.000000'),(1649,1264,'2024-06-24 16:00:00.000000'),(109,19110,'2024-06-24 16:00:00.000000'),(2593,507,'2024-06-24 16:00:00.000000'),(328717,838,'2024-06-24 16:00:00.000000'),(212561,234,'2024-06-24 16:00:00.000000'),(123,3456,'2024-06-24 16:00:00.000000'),(270888,3408,'2024-06-24 16:00:00.000000'),(190618,1387,'2024-06-24 16:00:00.000000'),(242263,1536,'2024-06-24 16:00:00.000000'),(270017,1153,'2024-06-24 16:00:00.000000'),(145740,1950,'2024-06-24 16:00:00.000000'),(146166,1950,'2024-06-24 16:00:00.000000'),(1258,603,'2024-06-24 16:00:00.000000'),(74,4628,'2024-06-24 16:00:00.000000'),(44,1636,'2024-06-24 16:00:00.000000'),(137,2448,'2024-06-24 16:00:00.000000'),(164,816,'2024-06-24 16:00:00.000000'),(226924,114,'2024-06-24 16:00:00.000000'),(227196,5887,'2024-06-24 16:00:00.000000'),(120,3220,'2024-06-24 16:00:00.000000'),(139,1182,'2024-06-24 16:00:00.000000'),(275013,7020,'2024-06-24 16:00:00.000000'),(148509,1952,'2024-06-24 16:00:00.000000'),(206580,70,'2024-06-24 16:00:00.000000'),(213014,1184,'2024-06-24 16:00:00.000000'),(79,2514,'2024-06-24 16:00:00.000000'),(91236,1368,'2024-06-24 16:00:00.000000'),(25,228,'2024-06-24 16:00:00.000000'),(249042,1812,'2024-06-24 16:00:00.000000'),(95,4182,'2024-06-24 16:00:00.000000'),(213554,160,'2024-06-24 16:00:00.000000'),(78,60,'2024-06-24 16:00:00.000000'),(110,10668,'2024-06-24 16:00:00.000000'),(3940,11447,'2024-06-24 16:00:00.000000'),(77,530,'2024-06-24 16:00:00.000000'),(141,1180,'2024-06-24 16:00:00.000000'),(254325,616,'2024-06-24 16:00:00.000000'),(68,348,'2024-06-24 16:00:00.000000'),(119,1184,'2024-06-24 16:00:00.000000'),(97359,440,'2024-06-24 16:00:00.000000'),(37634,3328,'2024-06-24 16:00:00.000000'),(11,944,'2024-06-24 16:00:00.000000'),(103920,1036,'2024-06-24 16:00:00.000000'),(283,1728,'2024-06-24 16:00:00.000000'),(270602,758,'2024-06-24 16:00:00.000000'),(209473,207,'2024-06-24 16:00:00.000000'),(64,4854,'2024-06-24 16:00:00.000000'),(34,120,'2024-06-24 16:00:00.000000'),(67383,882,'2024-06-24 16:00:00.000000'),(51609,5184,'2024-06-24 16:00:00.000000'),(52499,2392,'2024-06-24 16:00:00.000000'),(107,1188,'2024-06-24 16:00:00.000000'),(19316,6376,'2024-06-24 16:00:00.000000'),(85,120,'2024-06-24 16:00:00.000000'),(143961,3133,'2024-06-24 16:00:00.000000'),(327391,8896,'2024-06-24 16:00:00.000000'),(195763,1393,'2024-06-24 16:00:00.000000'),(186083,748,'2024-06-24 16:00:00.000000'),(87404,1060,'2024-06-24 16:00:00.000000'),(280318,305,'2024-06-24 16:00:00.000000'),(267884,80,'2024-06-24 16:00:00.000000'),(87907,6784,'2024-06-24 16:00:00.000000'),(94,354,'2024-06-24 16:00:00.000000'),(40441,2469,'2024-06-24 16:00:00.000000'),(146340,420,'2024-06-24 16:00:00.000000'),(111,119,'2024-06-24 16:00:00.000000'),(273575,870,'2024-06-24 16:00:00.000000'),(58,360,'2024-06-24 16:00:00.000000'),(89,357,'2024-06-24 16:00:00.000000'),(81,120,'2024-06-24 16:00:00.000000'),(26,120,'2024-06-24 16:00:00.000000'),(8,882,'2024-06-24 16:00:00.000000'),(1471,792,'2024-06-24 16:00:00.000000'),(163608,464,'2024-06-24 16:00:00.000000'),(92,118,'2024-06-24 16:00:00.000000'),(132,236,'2024-06-24 16:00:00.000000'),(144384,180,'2024-06-24 16:00:00.000000'),(140,118,'2024-06-24 16:00:00.000000'),(48900,792,'2024-06-24 16:00:00.000000'),(174440,2616,'2024-06-24 16:00:00.000000'),(293390,351,'2024-06-24 16:00:00.000000'),(16311,392,'2024-06-24 16:00:00.000000'),(99,236,'2024-06-24 16:00:00.000000'),(54525,118,'2024-06-24 16:00:00.000000'),(164630,304,'2024-06-24 16:00:00.000000'),(179782,294,'2024-06-24 16:00:00.000000'),(101,118,'2024-06-24 16:00:00.000000'),(9,120,'2024-06-24 16:00:00.000000'),(106,16040,'2024-06-25 16:00:00.000000'),(327391,4720,'2024-06-25 16:00:00.000000'),(106148,14711,'2024-06-25 16:00:00.000000'),(269339,21574,'2024-06-25 16:00:00.000000'),(269632,1129,'2024-06-25 16:00:00.000000'),(270888,4260,'2024-06-25 16:00:00.000000'),(73857,20600,'2024-06-25 16:00:00.000000'),(3940,28021,'2024-06-25 16:00:00.000000'),(163374,17383,'2024-06-25 16:00:00.000000'),(227196,4264,'2024-06-25 16:00:00.000000'),(159566,7119,'2024-06-25 16:00:00.000000'),(1958,8288,'2024-06-25 16:00:00.000000'),(6069,18648,'2024-06-25 16:00:00.000000'),(132,2034,'2024-06-25 16:00:00.000000'),(14573,6698,'2024-06-25 16:00:00.000000'),(182308,57540,'2024-06-25 16:00:00.000000'),(139,1180,'2024-06-25 16:00:00.000000'),(269583,14737,'2024-06-25 16:00:00.000000'),(279590,14080,'2024-06-25 16:00:00.000000'),(159,3386,'2024-06-25 16:00:00.000000'),(164630,8312,'2024-06-25 16:00:00.000000'),(102,3574,'2024-06-25 16:00:00.000000'),(40441,1135,'2024-06-25 16:00:00.000000'),(275013,5850,'2024-06-25 16:00:00.000000'),(78740,2284,'2024-06-25 16:00:00.000000'),(67019,14274,'2024-06-25 16:00:00.000000'),(898,232,'2024-06-25 16:00:00.000000'),(44,3524,'2024-06-25 16:00:00.000000'),(326483,10710,'2024-06-25 16:00:00.000000'),(218851,6208,'2024-06-25 16:00:00.000000'),(77377,7428,'2024-06-25 16:00:00.000000'),(109,3192,'2024-06-25 16:00:00.000000'),(2593,82,'2024-06-25 16:00:00.000000'),(161609,2780,'2024-06-25 16:00:00.000000'),(74,20158,'2024-06-25 16:00:00.000000'),(240225,702,'2024-06-25 16:00:00.000000'),(9,1240,'2024-06-25 16:00:00.000000'),(249042,1634,'2024-06-25 16:00:00.000000'),(97857,3900,'2024-06-25 16:00:00.000000'),(93579,227,'2024-06-25 16:00:00.000000'),(137,2448,'2024-06-25 16:00:00.000000'),(164,816,'2024-06-25 16:00:00.000000'),(77,412,'2024-06-25 16:00:00.000000'),(69,1776,'2024-06-25 16:00:00.000000'),(113,1352,'2024-06-25 16:00:00.000000'),(146166,947,'2024-06-25 16:00:00.000000'),(13324,1658,'2024-06-25 16:00:00.000000'),(2953,792,'2024-06-25 16:00:00.000000'),(268954,5162,'2024-06-25 16:00:00.000000'),(267884,2076,'2024-06-25 16:00:00.000000'),(141,590,'2024-06-25 16:00:00.000000'),(121,876,'2024-06-25 16:00:00.000000'),(213014,3008,'2024-06-25 16:00:00.000000'),(69379,1272,'2024-06-25 16:00:00.000000'),(115,118,'2024-06-25 16:00:00.000000'),(328717,516,'2024-06-25 16:00:00.000000'),(61,1533,'2024-06-25 16:00:00.000000'),(92,590,'2024-06-25 16:00:00.000000'),(242263,3072,'2024-06-25 16:00:00.000000'),(143961,2168,'2024-06-25 16:00:00.000000'),(25,468,'2024-06-25 16:00:00.000000'),(103920,4562,'2024-06-25 16:00:00.000000'),(140,610,'2024-06-25 16:00:00.000000'),(179782,2316,'2024-06-25 16:00:00.000000'),(7,234,'2024-06-25 16:00:00.000000'),(169095,900,'2024-06-25 16:00:00.000000'),(148509,1400,'2024-06-25 16:00:00.000000'),(243875,120,'2024-06-25 16:00:00.000000'),(293390,1053,'2024-06-25 16:00:00.000000'),(1258,411,'2024-06-25 16:00:00.000000'),(320610,929,'2024-06-25 16:00:00.000000'),(11,1013,'2024-06-25 16:00:00.000000'),(195763,312,'2024-06-25 16:00:00.000000'),(186083,165,'2024-06-25 16:00:00.000000'),(190618,978,'2024-06-25 16:00:00.000000'),(144384,120,'2024-06-25 16:00:00.000000'),(5620,0,'2024-06-25 16:00:00.000000'),(119,1298,'2024-06-25 16:00:00.000000'),(82,468,'2024-06-25 16:00:00.000000'),(94,118,'2024-06-25 16:00:00.000000'),(24582,712,'2024-06-25 16:00:00.000000'),(175834,468,'2024-06-25 16:00:00.000000'),(142,149,'2024-06-25 16:00:00.000000'),(174440,1568,'2024-06-25 16:00:00.000000'),(97359,1144,'2024-06-25 16:00:00.000000'),(78,174,'2024-06-25 16:00:00.000000'),(120,118,'2024-06-25 16:00:00.000000'),(75,958,'2024-06-25 16:00:00.000000'),(79843,1346,'2024-06-25 16:00:00.000000'),(86090,236,'2024-06-25 16:00:00.000000'),(87907,1088,'2024-06-25 16:00:00.000000'),(48900,200,'2024-06-25 16:00:00.000000'),(148,294,'2024-06-25 16:00:00.000000'),(273575,502,'2024-06-25 16:00:00.000000'),(37634,4304,'2024-06-25 16:00:00.000000'),(8,354,'2024-06-25 16:00:00.000000'),(90281,1056,'2024-06-25 16:00:00.000000'),(91236,928,'2024-06-25 16:00:00.000000'),(217860,1104,'2024-06-25 16:00:00.000000'),(99,118,'2024-06-25 16:00:00.000000'),(67383,2412,'2024-06-25 16:00:00.000000'),(123,708,'2024-06-25 16:00:00.000000'),(122,118,'2024-06-25 16:00:00.000000'),(66,358,'2024-06-25 16:00:00.000000'),(145740,300,'2024-06-25 16:00:00.000000'),(51609,5664,'2024-06-25 16:00:00.000000'),(215240,60,'2024-06-25 16:00:00.000000'),(146340,210,'2024-06-25 16:00:00.000000'),(280318,222,'2024-06-25 16:00:00.000000'),(58,120,'2024-06-25 16:00:00.000000'),(85,60,'2024-06-25 16:00:00.000000'),(101,236,'2024-06-25 16:00:00.000000'),(213554,1440,'2024-06-25 16:00:00.000000'),(270232,277,'2024-06-25 16:00:00.000000'),(64,3282,'2024-06-25 16:00:00.000000'),(259111,60,'2024-06-25 16:00:00.000000'),(329947,949,'2024-06-25 16:00:00.000000'),(93,118,'2024-06-25 16:00:00.000000'),(89,119,'2024-06-25 16:00:00.000000'),(206580,70,'2024-06-25 16:00:00.000000'),(308873,271,'2024-06-25 16:00:00.000000'),(63,594,'2024-06-25 16:00:00.000000'),(117,1416,'2024-06-25 16:00:00.000000'),(228359,0,'2024-06-25 16:00:00.000000'),(270602,413,'2024-06-25 16:00:00.000000'),(209473,69,'2024-06-25 16:00:00.000000'),(54525,236,'2024-06-25 16:00:00.000000'),(163608,0,'2024-06-25 16:00:00.000000'),(335318,114,'2024-06-25 16:00:00.000000'),(48,234,'2024-06-25 16:00:00.000000'),(267713,277,'2024-06-25 16:00:00.000000'),(269339,21306,'2024-06-26 16:00:00.000000'),(106148,10991,'2024-06-26 16:00:00.000000'),(67383,584,'2024-06-26 16:00:00.000000'),(67019,10976,'2024-06-26 16:00:00.000000'),(182308,51720,'2024-06-26 16:00:00.000000'),(73857,18500,'2024-06-26 16:00:00.000000'),(195763,312,'2024-06-26 16:00:00.000000'),(186083,165,'2024-06-26 16:00:00.000000'),(273575,999,'2024-06-26 16:00:00.000000'),(163374,21737,'2024-06-26 16:00:00.000000'),(37634,1256,'2024-06-26 16:00:00.000000'),(270602,2980,'2024-06-26 16:00:00.000000'),(77377,4424,'2024-06-26 16:00:00.000000'),(269583,9278,'2024-06-26 16:00:00.000000'),(161609,6850,'2024-06-26 16:00:00.000000'),(8,762,'2024-06-26 16:00:00.000000'),(190618,2632,'2024-06-26 16:00:00.000000'),(6069,31094,'2024-06-26 16:00:00.000000'),(275013,1756,'2024-06-26 16:00:00.000000'),(78740,1141,'2024-06-26 16:00:00.000000'),(146340,210,'2024-06-26 16:00:00.000000'),(13324,1384,'2024-06-26 16:00:00.000000'),(148,642,'2024-06-26 16:00:00.000000'),(14573,9532,'2024-06-26 16:00:00.000000'),(3940,12928,'2024-06-26 16:00:00.000000'),(148509,3080,'2024-06-26 16:00:00.000000'),(270888,3780,'2024-06-26 16:00:00.000000'),(51609,5096,'2024-06-26 16:00:00.000000'),(141,354,'2024-06-26 16:00:00.000000'),(44,1764,'2024-06-26 16:00:00.000000'),(121,1284,'2024-06-26 16:00:00.000000'),(94,118,'2024-06-26 16:00:00.000000'),(132,770,'2024-06-26 16:00:00.000000'),(179782,582,'2024-06-26 16:00:00.000000'),(106,8272,'2024-06-26 16:00:00.000000'),(69,4656,'2024-06-26 16:00:00.000000'),(95,0,'2024-06-26 16:00:00.000000'),(143961,12435,'2024-06-26 16:00:00.000000'),(163608,2886,'2024-06-26 16:00:00.000000'),(326483,1680,'2024-06-26 16:00:00.000000'),(159,-1553,'2024-06-26 16:00:00.000000'),(268954,10582,'2024-06-26 16:00:00.000000'),(227196,5656,'2024-06-26 16:00:00.000000'),(159566,12359,'2024-06-26 16:00:00.000000'),(158395,792,'2024-06-26 16:00:00.000000'),(249042,635,'2024-06-26 16:00:00.000000'),(1958,6984,'2024-06-26 16:00:00.000000'),(146545,300,'2024-06-26 16:00:00.000000'),(61,4118,'2024-06-26 16:00:00.000000'),(74,5588,'2024-06-26 16:00:00.000000'),(119,1652,'2024-06-26 16:00:00.000000'),(144384,60,'2024-06-26 16:00:00.000000'),(164630,9240,'2024-06-26 16:00:00.000000'),(102,948,'2024-06-26 16:00:00.000000'),(145740,900,'2024-06-26 16:00:00.000000'),(79843,4303,'2024-06-26 16:00:00.000000'),(86090,754,'2024-06-26 16:00:00.000000'),(242263,664,'2024-06-26 16:00:00.000000'),(1258,251,'2024-06-26 16:00:00.000000'),(4,118,'2024-06-26 16:00:00.000000'),(185893,594,'2024-06-26 16:00:00.000000'),(145309,800,'2024-06-26 16:00:00.000000'),(269632,686,'2024-06-26 16:00:00.000000'),(169095,402,'2024-06-26 16:00:00.000000'),(293390,351,'2024-06-26 16:00:00.000000'),(123,1416,'2024-06-26 16:00:00.000000'),(213554,640,'2024-06-26 16:00:00.000000'),(338334,60,'2024-06-26 16:00:00.000000'),(120,118,'2024-06-26 16:00:00.000000'),(26,60,'2024-06-26 16:00:00.000000'),(90281,3360,'2024-06-26 16:00:00.000000'),(218851,1664,'2024-06-26 16:00:00.000000'),(54525,236,'2024-06-26 16:00:00.000000'),(175834,3798,'2024-06-26 16:00:00.000000'),(142,249,'2024-06-26 16:00:00.000000'),(280318,927,'2024-06-26 16:00:00.000000'),(11,480,'2024-06-26 16:00:00.000000'),(213014,4112,'2024-06-26 16:00:00.000000'),(206580,348,'2024-06-26 16:00:00.000000'),(48900,992,'2024-06-26 16:00:00.000000'),(209473,207,'2024-06-26 16:00:00.000000'),(9,356,'2024-06-26 16:00:00.000000'),(109,9606,'2024-06-26 16:00:00.000000'),(2593,385,'2024-06-26 16:00:00.000000'),(215135,477,'2024-06-26 16:00:00.000000'),(243393,64,'2024-06-26 16:00:00.000000'),(270232,345,'2024-06-26 16:00:00.000000'),(99,468,'2024-06-26 16:00:00.000000'),(97857,1323,'2024-06-26 16:00:00.000000'),(93579,77,'2024-06-26 16:00:00.000000'),(79,294,'2024-06-26 16:00:00.000000'),(58,120,'2024-06-26 16:00:00.000000'),(20,160,'2024-06-26 16:00:00.000000'),(25,467,'2024-06-26 16:00:00.000000'),(327391,596,'2024-06-26 16:00:00.000000'),(97,119,'2024-06-26 16:00:00.000000'),(73,396,'2024-06-26 16:00:00.000000'),(91236,472,'2024-06-26 16:00:00.000000'),(75,9718,'2024-06-26 16:00:00.000000'),(87404,598,'2024-06-26 16:00:00.000000'),(69379,1896,'2024-06-26 16:00:00.000000'),(64,1296,'2024-06-26 16:00:00.000000'),(215240,60,'2024-06-26 16:00:00.000000'),(113,826,'2024-06-26 16:00:00.000000'),(320610,407,'2024-06-26 16:00:00.000000'),(338605,421,'2024-06-26 16:00:00.000000'),(259111,120,'2024-06-26 16:00:00.000000'),(140,118,'2024-06-26 16:00:00.000000'),(139,354,'2024-06-26 16:00:00.000000'),(337829,114,'2024-06-26 16:00:00.000000'),(336963,15,'2024-06-26 16:00:00.000000'),(103920,450,'2024-06-26 16:00:00.000000'),(34,294,'2024-06-26 16:00:00.000000'),(82,408,'2024-06-26 16:00:00.000000'),(341103,120,'2024-06-26 16:00:00.000000'),(340532,16,'2024-06-26 16:00:00.000000'),(101,236,'2024-06-26 16:00:00.000000'),(167340,288,'2024-06-26 16:00:00.000000'),(174440,696,'2024-06-26 16:00:00.000000'),(337626,478,'2024-06-26 16:00:00.000000'),(283,1336,'2024-06-26 16:00:00.000000'),(267713,277,'2024-06-26 16:00:00.000000'),(166037,414,'2024-06-26 16:00:00.000000'),(107,594,'2024-06-26 16:00:00.000000'),(137,408,'2024-06-26 16:00:00.000000'),(164,136,'2024-06-26 16:00:00.000000'),(342076,352,'2024-06-26 16:00:00.000000'),(87907,2848,'2024-06-26 16:00:00.000000'),(146166,498,'2024-06-26 16:00:00.000000'),(172477,234,'2024-06-26 16:00:00.000000'),(19316,792,'2024-06-26 16:00:00.000000'),(66,240,'2024-06-26 16:00:00.000000'),(92,236,'2024-06-26 16:00:00.000000'),(279590,-14080,'2024-06-26 16:00:00.000000'),(263921,60,'2024-06-26 16:00:00.000000'),(63,768,'2024-06-26 16:00:00.000000'),(78,60,'2024-06-26 16:00:00.000000'),(258846,114,'2024-06-26 16:00:00.000000'),(267884,222,'2024-06-26 16:00:00.000000'),(242263,2296,'2024-06-27 16:00:00.000000'),(182308,64068,'2024-06-27 16:00:00.000000'),(73857,22736,'2024-06-27 16:00:00.000000'),(159566,9816,'2024-06-27 16:00:00.000000'),(20,80,'2024-06-27 16:00:00.000000'),(213554,1456,'2024-06-27 16:00:00.000000'),(163374,3248,'2024-06-27 16:00:00.000000'),(174440,464,'2024-06-27 16:00:00.000000'),(6069,29128,'2024-06-27 16:00:00.000000'),(249042,1400,'2024-06-27 16:00:00.000000'),(78740,1709,'2024-06-27 16:00:00.000000'),(67019,8653,'2024-06-27 16:00:00.000000'),(64,1350,'2024-06-27 16:00:00.000000'),(148509,1608,'2024-06-27 16:00:00.000000'),(3940,41130,'2024-06-27 16:00:00.000000'),(106148,15968,'2024-06-27 16:00:00.000000'),(269339,22023,'2024-06-27 16:00:00.000000'),(227196,3552,'2024-06-27 16:00:00.000000'),(270888,4140,'2024-06-27 16:00:00.000000'),(44,68,'2024-06-27 16:00:00.000000'),(87404,530,'2024-06-27 16:00:00.000000'),(14573,6959,'2024-06-27 16:00:00.000000'),(74,11478,'2024-06-27 16:00:00.000000'),(267884,444,'2024-06-27 16:00:00.000000'),(269583,10505,'2024-06-27 16:00:00.000000'),(119,3456,'2024-06-27 16:00:00.000000'),(97857,4449,'2024-06-27 16:00:00.000000'),(93579,259,'2024-06-27 16:00:00.000000'),(143961,5216,'2024-06-27 16:00:00.000000'),(85,120,'2024-06-27 16:00:00.000000'),(145309,80,'2024-06-27 16:00:00.000000'),(66,600,'2024-06-27 16:00:00.000000'),(273575,1710,'2024-06-27 16:00:00.000000'),(75,1061,'2024-06-27 16:00:00.000000'),(102,590,'2024-06-27 16:00:00.000000'),(82,1404,'2024-06-27 16:00:00.000000'),(268954,9543,'2024-06-27 16:00:00.000000'),(161609,5053,'2024-06-27 16:00:00.000000'),(139,590,'2024-06-27 16:00:00.000000'),(175834,3564,'2024-06-27 16:00:00.000000'),(142,353,'2024-06-27 16:00:00.000000'),(218851,1248,'2024-06-27 16:00:00.000000'),(144384,60,'2024-06-27 16:00:00.000000'),(77,824,'2024-06-27 16:00:00.000000'),(61,3349,'2024-06-27 16:00:00.000000'),(308732,808,'2024-06-27 16:00:00.000000'),(209473,276,'2024-06-27 16:00:00.000000'),(190618,756,'2024-06-27 16:00:00.000000'),(275013,2110,'2024-06-27 16:00:00.000000'),(77377,4288,'2024-06-27 16:00:00.000000'),(92,708,'2024-06-27 16:00:00.000000'),(215240,120,'2024-06-27 16:00:00.000000'),(90281,5104,'2024-06-27 16:00:00.000000'),(327391,1074,'2024-06-27 16:00:00.000000'),(8,118,'2024-06-27 16:00:00.000000'),(326483,1680,'2024-06-27 16:00:00.000000'),(159,341,'2024-06-27 16:00:00.000000'),(9,120,'2024-06-27 16:00:00.000000'),(113,996,'2024-06-27 16:00:00.000000'),(267713,277,'2024-06-27 16:00:00.000000'),(123,708,'2024-06-27 16:00:00.000000'),(37634,1640,'2024-06-27 16:00:00.000000'),(217606,0,'2024-06-27 16:00:00.000000'),(120,708,'2024-06-27 16:00:00.000000'),(1958,4448,'2024-06-27 16:00:00.000000'),(141,354,'2024-06-27 16:00:00.000000'),(169095,2904,'2024-06-27 16:00:00.000000'),(13324,4229,'2024-06-27 16:00:00.000000'),(69,1476,'2024-06-27 16:00:00.000000'),(213014,800,'2024-06-27 16:00:00.000000'),(240225,234,'2024-06-27 16:00:00.000000'),(320610,748,'2024-06-27 16:00:00.000000'),(73,516,'2024-06-27 16:00:00.000000'),(338605,394,'2024-06-27 16:00:00.000000'),(341103,60,'2024-06-27 16:00:00.000000'),(336963,4,'2024-06-27 16:00:00.000000'),(340532,116,'2024-06-27 16:00:00.000000'),(121,3738,'2024-06-27 16:00:00.000000'),(109,816,'2024-06-27 16:00:00.000000'),(2593,20,'2024-06-27 16:00:00.000000'),(269632,951,'2024-06-27 16:00:00.000000'),(164630,544,'2024-06-27 16:00:00.000000'),(87907,1088,'2024-06-27 16:00:00.000000'),(132,0,'2024-06-27 16:00:00.000000'),(51609,1728,'2024-06-27 16:00:00.000000'),(137,2040,'2024-06-27 16:00:00.000000'),(164,680,'2024-06-27 16:00:00.000000'),(97,119,'2024-06-27 16:00:00.000000'),(342468,696,'2024-06-27 16:00:00.000000'),(7,522,'2024-06-27 16:00:00.000000'),(115,588,'2024-06-27 16:00:00.000000'),(103920,2374,'2024-06-27 16:00:00.000000'),(308873,271,'2024-06-27 16:00:00.000000'),(106,5560,'2024-06-27 16:00:00.000000'),(270602,618,'2024-06-27 16:00:00.000000'),(4,236,'2024-06-27 16:00:00.000000'),(67383,410,'2024-06-27 16:00:00.000000'),(215135,182,'2024-06-27 16:00:00.000000'),(243393,24,'2024-06-27 16:00:00.000000'),(79843,3236,'2024-06-27 16:00:00.000000'),(86090,568,'2024-06-27 16:00:00.000000'),(146166,300,'2024-06-27 16:00:00.000000'),(145740,648,'2024-06-27 16:00:00.000000'),(146340,1470,'2024-06-27 16:00:00.000000'),(1649,632,'2024-06-27 16:00:00.000000'),(67379,1008,'2024-06-27 16:00:00.000000'),(270017,2971,'2024-06-27 16:00:00.000000'),(179782,882,'2024-06-27 16:00:00.000000'),(293390,560,'2024-06-27 16:00:00.000000'),(1258,452,'2024-06-27 16:00:00.000000'),(91236,1104,'2024-06-27 16:00:00.000000'),(146545,1800,'2024-06-27 16:00:00.000000'),(54525,118,'2024-06-27 16:00:00.000000'),(69379,6536,'2024-06-27 16:00:00.000000'),(338334,60,'2024-06-27 16:00:00.000000'),(99,234,'2024-06-27 16:00:00.000000'),(258846,114,'2024-06-27 16:00:00.000000'),(101,236,'2024-06-27 16:00:00.000000'),(185893,360,'2024-06-27 16:00:00.000000'),(329947,239,'2024-06-27 16:00:00.000000'),(280318,408,'2024-06-27 16:00:00.000000'),(217860,1104,'2024-06-27 16:00:00.000000'),(140,0,'2024-06-27 16:00:00.000000'),(898,464,'2024-06-27 16:00:00.000000'),(89,119,'2024-06-27 16:00:00.000000'),(34,234,'2024-06-27 16:00:00.000000'),(330205,133,'2024-06-27 16:00:00.000000'),(320517,7,'2024-06-27 16:00:00.000000'),(40441,151,'2024-06-27 16:00:00.000000'),(1188,0,'2024-06-27 16:00:00.000000'),(341834,239,'2024-06-27 16:00:00.000000'),(283,160,'2024-06-27 16:00:00.000000'),(95,594,'2024-06-27 16:00:00.000000'),(342076,0,'2024-06-27 16:00:00.000000'),(52499,792,'2024-06-27 16:00:00.000000'),(106,20368,'2024-06-28 16:00:00.000000'),(182308,66468,'2024-06-28 16:00:00.000000'),(73857,24732,'2024-06-28 16:00:00.000000'),(61,7094,'2024-06-28 16:00:00.000000'),(67019,10954,'2024-06-28 16:00:00.000000'),(159566,9852,'2024-06-28 16:00:00.000000'),(75,2120,'2024-06-28 16:00:00.000000'),(320610,460,'2024-06-28 16:00:00.000000'),(78740,1185,'2024-06-28 16:00:00.000000'),(97857,774,'2024-06-28 16:00:00.000000'),(93579,45,'2024-06-28 16:00:00.000000'),(3940,20106,'2024-06-28 16:00:00.000000'),(106148,11425,'2024-06-28 16:00:00.000000'),(227196,1712,'2024-06-28 16:00:00.000000'),(174440,2672,'2024-06-28 16:00:00.000000'),(74,5202,'2024-06-28 16:00:00.000000'),(269339,23930,'2024-06-28 16:00:00.000000'),(69379,1272,'2024-06-28 16:00:00.000000'),(4,472,'2024-06-28 16:00:00.000000'),(14573,14287,'2024-06-28 16:00:00.000000'),(6069,38984,'2024-06-28 16:00:00.000000'),(270888,7728,'2024-06-28 16:00:00.000000'),(120,354,'2024-06-28 16:00:00.000000'),(113,590,'2024-06-28 16:00:00.000000'),(164630,928,'2024-06-28 16:00:00.000000'),(90281,7904,'2024-06-28 16:00:00.000000'),(209473,69,'2024-06-28 16:00:00.000000'),(190618,818,'2024-06-28 16:00:00.000000'),(69,1272,'2024-06-28 16:00:00.000000'),(77,1236,'2024-06-28 16:00:00.000000'),(77377,5048,'2024-06-28 16:00:00.000000'),(143961,5959,'2024-06-28 16:00:00.000000'),(115,18288,'2024-06-28 16:00:00.000000'),(163374,3640,'2024-06-28 16:00:00.000000'),(249042,1644,'2024-06-28 16:00:00.000000'),(44,20850,'2024-06-28 16:00:00.000000'),(898,864,'2024-06-28 16:00:00.000000'),(121,6966,'2024-06-28 16:00:00.000000'),(283,2672,'2024-06-28 16:00:00.000000'),(213554,648,'2024-06-28 16:00:00.000000'),(95,594,'2024-06-28 16:00:00.000000'),(141,1830,'2024-06-28 16:00:00.000000'),(161609,11050,'2024-06-28 16:00:00.000000'),(280318,1377,'2024-06-28 16:00:00.000000'),(159,785,'2024-06-28 16:00:00.000000'),(101,236,'2024-06-28 16:00:00.000000'),(327391,296,'2024-06-28 16:00:00.000000'),(48,522,'2024-06-28 16:00:00.000000'),(139,4036,'2024-06-28 16:00:00.000000'),(79843,10020,'2024-06-28 16:00:00.000000'),(86090,1762,'2024-06-28 16:00:00.000000'),(58,358,'2024-06-28 16:00:00.000000'),(338334,120,'2024-06-28 16:00:00.000000'),(1958,2528,'2024-06-28 16:00:00.000000'),(67383,1108,'2024-06-28 16:00:00.000000'),(326483,4410,'2024-06-28 16:00:00.000000'),(268954,4807,'2024-06-28 16:00:00.000000'),(275013,3510,'2024-06-28 16:00:00.000000'),(328717,322,'2024-06-28 16:00:00.000000'),(146340,630,'2024-06-28 16:00:00.000000'),(13324,2104,'2024-06-28 16:00:00.000000'),(273575,942,'2024-06-28 16:00:00.000000'),(9,299,'2024-06-28 16:00:00.000000'),(218851,416,'2024-06-28 16:00:00.000000'),(73,239,'2024-06-28 16:00:00.000000'),(166037,414,'2024-06-28 16:00:00.000000'),(2593,483,'2024-06-28 16:00:00.000000'),(52499,792,'2024-06-28 16:00:00.000000'),(137,1224,'2024-06-28 16:00:00.000000'),(164,524,'2024-06-28 16:00:00.000000'),(269632,277,'2024-06-28 16:00:00.000000'),(240225,234,'2024-06-28 16:00:00.000000'),(345300,1404,'2024-06-28 16:00:00.000000'),(336963,90,'2024-06-28 16:00:00.000000'),(340532,222,'2024-06-28 16:00:00.000000'),(111,119,'2024-06-28 16:00:00.000000'),(269583,2892,'2024-06-28 16:00:00.000000'),(206580,70,'2024-06-28 16:00:00.000000'),(274697,2526,'2024-06-28 16:00:00.000000'),(87907,1632,'2024-06-28 16:00:00.000000'),(82,642,'2024-06-28 16:00:00.000000'),(25114,1600,'2024-06-28 16:00:00.000000'),(145740,300,'2024-06-28 16:00:00.000000'),(132,236,'2024-06-28 16:00:00.000000'),(66,714,'2024-06-28 16:00:00.000000'),(308732,317,'2024-06-28 16:00:00.000000'),(87404,530,'2024-06-28 16:00:00.000000'),(103920,744,'2024-06-28 16:00:00.000000'),(175834,468,'2024-06-28 16:00:00.000000'),(142,387,'2024-06-28 16:00:00.000000'),(140,354,'2024-06-28 16:00:00.000000'),(119,2984,'2024-06-28 16:00:00.000000'),(37634,1024,'2024-06-28 16:00:00.000000'),(78,120,'2024-06-28 16:00:00.000000'),(63,594,'2024-06-28 16:00:00.000000'),(148509,208,'2024-06-28 16:00:00.000000'),(146545,1950,'2024-06-28 16:00:00.000000'),(296564,151,'2024-06-28 16:00:00.000000'),(186083,88,'2024-06-28 16:00:00.000000'),(270602,3189,'2024-06-28 16:00:00.000000'),(136,348,'2024-06-28 16:00:00.000000'),(85,60,'2024-06-28 16:00:00.000000'),(242263,2224,'2024-06-28 16:00:00.000000'),(91236,2400,'2024-06-28 16:00:00.000000'),(51609,6464,'2024-06-28 16:00:00.000000'),(263921,60,'2024-06-28 16:00:00.000000'),(213014,4464,'2024-06-28 16:00:00.000000'),(7,234,'2024-06-28 16:00:00.000000'),(160616,44,'2024-06-28 16:00:00.000000'),(92,464,'2024-06-28 16:00:00.000000'),(270017,2073,'2024-06-28 16:00:00.000000'),(293390,280,'2024-06-28 16:00:00.000000'),(1258,19,'2024-06-28 16:00:00.000000'),(169095,201,'2024-06-28 16:00:00.000000'),(342076,285,'2024-06-28 16:00:00.000000'),(267713,277,'2024-06-28 16:00:00.000000'),(341834,239,'2024-06-28 16:00:00.000000'),(267884,222,'2024-06-28 16:00:00.000000'),(123,1062,'2024-06-28 16:00:00.000000'),(146460,498,'2024-06-28 16:00:00.000000'),(96,0,'2024-06-28 16:00:00.000000'),(122,118,'2024-06-28 16:00:00.000000'),(109,594,'2024-06-28 16:00:00.000000'),(197811,1504,'2024-06-28 16:00:00.000000'),(48900,240,'2024-06-28 16:00:00.000000'),(335577,612,'2024-06-28 16:00:00.000000'),(310356,234,'2024-06-28 16:00:00.000000'),(342468,228,'2024-06-28 16:00:00.000000'),(215240,60,'2024-06-28 16:00:00.000000'),(345859,70,'2024-06-28 16:00:00.000000'),(258846,114,'2024-06-28 16:00:00.000000'),(270888,8070,'2024-06-29 16:00:00.000000'),(73857,12790,'2024-06-29 16:00:00.000000'),(275013,5728,'2024-06-29 16:00:00.000000'),(78740,2372,'2024-06-29 16:00:00.000000'),(67019,10068,'2024-06-29 16:00:00.000000'),(159566,10986,'2024-06-29 16:00:00.000000'),(160616,76,'2024-06-29 16:00:00.000000'),(269339,25346,'2024-06-29 16:00:00.000000'),(106148,8955,'2024-06-29 16:00:00.000000'),(182308,30300,'2024-06-29 16:00:00.000000'),(106,25136,'2024-06-29 16:00:00.000000'),(148,294,'2024-06-29 16:00:00.000000'),(14573,14252,'2024-06-29 16:00:00.000000'),(274697,246,'2024-06-29 16:00:00.000000'),(110,1830,'2024-06-29 16:00:00.000000'),(249042,3200,'2024-06-29 16:00:00.000000'),(120,236,'2024-06-29 16:00:00.000000'),(320610,228,'2024-06-29 16:00:00.000000'),(213014,2216,'2024-06-29 16:00:00.000000'),(94,354,'2024-06-29 16:00:00.000000'),(329947,239,'2024-06-29 16:00:00.000000'),(142,217,'2024-06-29 16:00:00.000000'),(345300,1872,'2024-06-29 16:00:00.000000'),(346331,120,'2024-06-29 16:00:00.000000'),(340532,309,'2024-06-29 16:00:00.000000'),(336963,158,'2024-06-29 16:00:00.000000'),(227196,1600,'2024-06-29 16:00:00.000000'),(123,1872,'2024-06-29 16:00:00.000000'),(163374,3607,'2024-06-29 16:00:00.000000'),(145740,996,'2024-06-29 16:00:00.000000'),(13324,3120,'2024-06-29 16:00:00.000000'),(3940,12936,'2024-06-29 16:00:00.000000'),(121,4278,'2024-06-29 16:00:00.000000'),(164630,1152,'2024-06-29 16:00:00.000000'),(172477,702,'2024-06-29 16:00:00.000000'),(82,2628,'2024-06-29 16:00:00.000000'),(61,4973,'2024-06-29 16:00:00.000000'),(326483,4354,'2024-06-29 16:00:00.000000'),(159,651,'2024-06-29 16:00:00.000000'),(6069,45472,'2024-06-29 16:00:00.000000'),(77,1806,'2024-06-29 16:00:00.000000'),(77377,1888,'2024-06-29 16:00:00.000000'),(16311,1960,'2024-06-29 16:00:00.000000'),(143961,6703,'2024-06-29 16:00:00.000000'),(146545,600,'2024-06-29 16:00:00.000000'),(146166,150,'2024-06-29 16:00:00.000000'),(215135,0,'2024-06-29 16:00:00.000000'),(243393,0,'2024-06-29 16:00:00.000000'),(74,3864,'2024-06-29 16:00:00.000000'),(175834,1512,'2024-06-29 16:00:00.000000'),(293390,3224,'2024-06-29 16:00:00.000000'),(1258,219,'2024-06-29 16:00:00.000000'),(102,2984,'2024-06-29 16:00:00.000000'),(146460,1092,'2024-06-29 16:00:00.000000'),(190618,1368,'2024-06-29 16:00:00.000000'),(296564,151,'2024-06-29 16:00:00.000000'),(186083,88,'2024-06-29 16:00:00.000000'),(269632,516,'2024-06-29 16:00:00.000000'),(317333,240,'2024-06-29 16:00:00.000000'),(174440,2264,'2024-06-29 16:00:00.000000'),(99,18264,'2024-06-29 16:00:00.000000'),(79843,7889,'2024-06-29 16:00:00.000000'),(86090,1382,'2024-06-29 16:00:00.000000'),(167340,144,'2024-06-29 16:00:00.000000'),(268954,1054,'2024-06-29 16:00:00.000000'),(1958,2056,'2024-06-29 16:00:00.000000'),(44,1964,'2024-06-29 16:00:00.000000'),(161609,8318,'2024-06-29 16:00:00.000000'),(148509,488,'2024-06-29 16:00:00.000000'),(341103,524,'2024-06-29 16:00:00.000000'),(119,1416,'2024-06-29 16:00:00.000000'),(90281,11488,'2024-06-29 16:00:00.000000'),(48,522,'2024-06-29 16:00:00.000000'),(139,708,'2024-06-29 16:00:00.000000'),(141,1350,'2024-06-29 16:00:00.000000'),(69379,2688,'2024-06-29 16:00:00.000000'),(269583,1039,'2024-06-29 16:00:00.000000'),(283,1024,'2024-06-29 16:00:00.000000'),(113,1000,'2024-06-29 16:00:00.000000'),(69,3222,'2024-06-29 16:00:00.000000'),(103920,600,'2024-06-29 16:00:00.000000'),(75,539,'2024-06-29 16:00:00.000000'),(20,80,'2024-06-29 16:00:00.000000'),(335318,114,'2024-06-29 16:00:00.000000'),(109,2538,'2024-06-29 16:00:00.000000'),(2593,1384,'2024-06-29 16:00:00.000000'),(151,118,'2024-06-29 16:00:00.000000'),(267713,899,'2024-06-29 16:00:00.000000'),(169095,402,'2024-06-29 16:00:00.000000'),(63,594,'2024-06-29 16:00:00.000000'),(10,468,'2024-06-29 16:00:00.000000'),(66,946,'2024-06-29 16:00:00.000000'),(87907,1632,'2024-06-29 16:00:00.000000'),(242263,1384,'2024-06-29 16:00:00.000000'),(330205,133,'2024-06-29 16:00:00.000000'),(320517,19,'2024-06-29 16:00:00.000000'),(323517,114,'2024-06-29 16:00:00.000000'),(144384,120,'2024-06-29 16:00:00.000000'),(1071,416,'2024-06-29 16:00:00.000000'),(7,288,'2024-06-29 16:00:00.000000'),(91236,1104,'2024-06-29 16:00:00.000000'),(342468,798,'2024-06-29 16:00:00.000000'),(11,1234,'2024-06-29 16:00:00.000000'),(146340,2201,'2024-06-29 16:00:00.000000'),(67,594,'2024-06-29 16:00:00.000000'),(73,346,'2024-06-29 16:00:00.000000'),(101,356,'2024-06-29 16:00:00.000000'),(85,120,'2024-06-29 16:00:00.000000'),(3364,792,'2024-06-29 16:00:00.000000'),(51609,2272,'2024-06-29 16:00:00.000000'),(348500,0,'2024-06-29 16:00:00.000000'),(336947,2,'2024-06-29 16:00:00.000000'),(335577,2448,'2024-06-29 16:00:00.000000'),(37634,1584,'2024-06-29 16:00:00.000000'),(97857,3429,'2024-06-29 16:00:00.000000'),(93579,199,'2024-06-29 16:00:00.000000'),(273575,1392,'2024-06-29 16:00:00.000000'),(92,0,'2024-06-29 16:00:00.000000'),(9,1243,'2024-06-29 16:00:00.000000'),(132,472,'2024-06-29 16:00:00.000000'),(87404,1005,'2024-06-29 16:00:00.000000'),(267884,222,'2024-06-29 16:00:00.000000'),(78,60,'2024-06-29 16:00:00.000000'),(26,60,'2024-06-29 16:00:00.000000'),(259111,60,'2024-06-29 16:00:00.000000'),(206580,70,'2024-06-29 16:00:00.000000'),(218851,416,'2024-06-29 16:00:00.000000'),(137,1632,'2024-06-29 16:00:00.000000'),(164,544,'2024-06-29 16:00:00.000000'),(270017,271,'2024-06-29 16:00:00.000000'),(270602,277,'2024-06-29 16:00:00.000000'),(52499,400,'2024-06-29 16:00:00.000000'),(25,348,'2024-06-29 16:00:00.000000'),(67383,573,'2024-06-29 16:00:00.000000'),(4,118,'2024-06-29 16:00:00.000000'),(345859,484,'2024-06-29 16:00:00.000000'),(328717,573,'2024-06-29 16:00:00.000000'),(344844,60,'2024-06-29 16:00:00.000000'),(270232,345,'2024-06-29 16:00:00.000000'),(163608,391,'2024-06-29 16:00:00.000000'),(40441,1884,'2024-06-29 16:00:00.000000'),(13820,320,'2024-06-29 16:00:00.000000'),(8,118,'2024-06-29 16:00:00.000000'),(6069,39544,'2024-06-30 16:00:00.000000'),(182308,22920,'2024-06-30 16:00:00.000000'),(73857,11552,'2024-06-30 16:00:00.000000'),(159566,8788,'2024-06-30 16:00:00.000000'),(160616,66,'2024-06-30 16:00:00.000000'),(270888,11736,'2024-06-30 16:00:00.000000'),(82,1997,'2024-06-30 16:00:00.000000'),(67019,8777,'2024-06-30 16:00:00.000000'),(344844,60,'2024-06-30 16:00:00.000000'),(336947,6,'2024-06-30 16:00:00.000000'),(346331,297,'2024-06-30 16:00:00.000000'),(340532,754,'2024-06-30 16:00:00.000000'),(336963,396,'2024-06-30 16:00:00.000000'),(78740,2913,'2024-06-30 16:00:00.000000'),(25,228,'2024-06-30 16:00:00.000000'),(69,2208,'2024-06-30 16:00:00.000000'),(342468,1044,'2024-06-30 16:00:00.000000'),(326483,4503,'2024-06-30 16:00:00.000000'),(159,1607,'2024-06-30 16:00:00.000000'),(77377,6584,'2024-06-30 16:00:00.000000'),(109,3480,'2024-06-30 16:00:00.000000'),(2593,1574,'2024-06-30 16:00:00.000000'),(14573,11507,'2024-06-30 16:00:00.000000'),(119,1298,'2024-06-30 16:00:00.000000'),(898,1160,'2024-06-30 16:00:00.000000'),(90281,16112,'2024-06-30 16:00:00.000000'),(92,118,'2024-06-30 16:00:00.000000'),(328717,774,'2024-06-30 16:00:00.000000'),(106148,7052,'2024-06-30 16:00:00.000000'),(106,13048,'2024-06-30 16:00:00.000000'),(141,10770,'2024-06-30 16:00:00.000000'),(132,1242,'2024-06-30 16:00:00.000000'),(242263,2376,'2024-06-30 16:00:00.000000'),(102,3732,'2024-06-30 16:00:00.000000'),(317333,-240,'2024-06-30 16:00:00.000000'),(79843,4172,'2024-06-30 16:00:00.000000'),(86090,730,'2024-06-30 16:00:00.000000'),(143961,7317,'2024-06-30 16:00:00.000000'),(335577,2754,'2024-06-30 16:00:00.000000'),(174440,1808,'2024-06-30 16:00:00.000000'),(142,437,'2024-06-30 16:00:00.000000'),(293390,631,'2024-06-30 16:00:00.000000'),(1258,42,'2024-06-30 16:00:00.000000'),(61,7535,'2024-06-30 16:00:00.000000'),(270602,1380,'2024-06-30 16:00:00.000000'),(273575,967,'2024-06-30 16:00:00.000000'),(115,611,'2024-06-30 16:00:00.000000'),(269339,4663,'2024-06-30 16:00:00.000000'),(91236,880,'2024-06-30 16:00:00.000000'),(190618,854,'2024-06-30 16:00:00.000000'),(51609,6120,'2024-06-30 16:00:00.000000'),(146545,150,'2024-06-30 16:00:00.000000'),(13324,1147,'2024-06-30 16:00:00.000000'),(16311,392,'2024-06-30 16:00:00.000000'),(267713,1106,'2024-06-30 16:00:00.000000'),(144384,414,'2024-06-30 16:00:00.000000'),(227196,3648,'2024-06-30 16:00:00.000000'),(113,826,'2024-06-30 16:00:00.000000'),(1958,4928,'2024-06-30 16:00:00.000000'),(269583,10244,'2024-06-30 16:00:00.000000'),(218851,1248,'2024-06-30 16:00:00.000000'),(351513,451,'2024-06-30 16:00:00.000000'),(1071,416,'2024-06-30 16:00:00.000000'),(97857,1771,'2024-06-30 16:00:00.000000'),(93579,101,'2024-06-30 16:00:00.000000'),(48,174,'2024-06-30 16:00:00.000000'),(249042,3037,'2024-06-30 16:00:00.000000'),(93,118,'2024-06-30 16:00:00.000000'),(139,2060,'2024-06-30 16:00:00.000000'),(169095,1203,'2024-06-30 16:00:00.000000'),(117,312,'2024-06-30 16:00:00.000000'),(123,354,'2024-06-30 16:00:00.000000'),(163374,3340,'2024-06-30 16:00:00.000000'),(74,2466,'2024-06-30 16:00:00.000000'),(345859,5041,'2024-06-30 16:00:00.000000'),(137,1632,'2024-06-30 16:00:00.000000'),(164,544,'2024-06-30 16:00:00.000000'),(121,1404,'2024-06-30 16:00:00.000000'),(11,1191,'2024-06-30 16:00:00.000000'),(161609,3823,'2024-06-30 16:00:00.000000'),(1471,0,'2024-06-30 16:00:00.000000'),(2953,0,'2024-06-30 16:00:00.000000'),(268954,2306,'2024-06-30 16:00:00.000000'),(3940,20908,'2024-06-30 16:00:00.000000'),(329947,239,'2024-06-30 16:00:00.000000'),(146166,150,'2024-06-30 16:00:00.000000'),(270232,345,'2024-06-30 16:00:00.000000'),(67383,588,'2024-06-30 16:00:00.000000'),(87907,3264,'2024-06-30 16:00:00.000000'),(8,236,'2024-06-30 16:00:00.000000'),(213014,424,'2024-06-30 16:00:00.000000'),(7,468,'2024-06-30 16:00:00.000000'),(66,1120,'2024-06-30 16:00:00.000000'),(175834,3090,'2024-06-30 16:00:00.000000'),(44,271,'2024-06-30 16:00:00.000000'),(151,228,'2024-06-30 16:00:00.000000'),(37634,464,'2024-06-30 16:00:00.000000'),(341103,119,'2024-06-30 16:00:00.000000'),(4,354,'2024-06-30 16:00:00.000000'),(206580,70,'2024-06-30 16:00:00.000000'),(75,647,'2024-06-30 16:00:00.000000'),(20,80,'2024-06-30 16:00:00.000000'),(209473,345,'2024-06-30 16:00:00.000000'),(95,1188,'2024-06-30 16:00:00.000000'),(347900,696,'2024-06-30 16:00:00.000000'),(140,0,'2024-06-30 16:00:00.000000'),(148509,1687,'2024-06-30 16:00:00.000000'),(274697,831,'2024-06-30 16:00:00.000000'),(145740,300,'2024-06-30 16:00:00.000000'),(40441,463,'2024-06-30 16:00:00.000000'),(300771,0,'2024-06-30 16:00:00.000000'),(186083,143,'2024-06-30 16:00:00.000000'),(213554,160,'2024-06-30 16:00:00.000000'),(120,236,'2024-06-30 16:00:00.000000'),(345300,5796,'2024-06-30 16:00:00.000000'),(320610,983,'2024-06-30 16:00:00.000000'),(296564,151,'2024-06-30 16:00:00.000000'),(73,858,'2024-06-30 16:00:00.000000'),(215135,70,'2024-06-30 16:00:00.000000'),(243393,9,'2024-06-30 16:00:00.000000'),(94,236,'2024-06-30 16:00:00.000000'),(48900,3168,'2024-06-30 16:00:00.000000'),(101,236,'2024-06-30 16:00:00.000000'),(275013,5616,'2024-06-30 16:00:00.000000'),(24582,1592,'2024-06-30 16:00:00.000000'),(110,948,'2024-06-30 16:00:00.000000'),(293753,344,'2024-06-30 16:00:00.000000'),(34,1638,'2024-06-30 16:00:00.000000'),(52499,2392,'2024-06-30 16:00:00.000000'),(270017,340,'2024-06-30 16:00:00.000000'),(197811,704,'2024-06-30 16:00:00.000000'),(13820,320,'2024-06-30 16:00:00.000000'),(750,552,'2024-06-30 16:00:00.000000'),(77,294,'2024-06-30 16:00:00.000000'),(338334,60,'2024-06-30 16:00:00.000000'),(338605,816,'2024-06-30 16:00:00.000000'),(146460,150,'2024-06-30 16:00:00.000000'),(54525,118,'2024-06-30 16:00:00.000000'),(240225,234,'2024-06-30 16:00:00.000000'),(217606,556,'2024-06-30 16:00:00.000000'),(195763,104,'2024-06-30 16:00:00.000000'),(81,414,'2024-06-30 16:00:00.000000'),(353051,133,'2024-06-30 16:00:00.000000'),(352007,231,'2024-06-30 16:00:00.000000'),(310356,0,'2024-06-30 16:00:00.000000'),(69379,0,'2024-06-30 16:00:00.000000'),(192434,118,'2024-06-30 16:00:00.000000'),(77377,3472,'2024-07-01 16:00:00.000000'),(269339,4873,'2024-07-01 16:00:00.000000'),(106148,8107,'2024-07-01 16:00:00.000000'),(268954,7163,'2024-07-01 16:00:00.000000'),(353051,546,'2024-07-01 16:00:00.000000'),(159,2521,'2024-07-01 16:00:00.000000'),(270888,28014,'2024-07-01 16:00:00.000000'),(73857,24718,'2024-07-01 16:00:00.000000'),(182308,46140,'2024-07-01 16:00:00.000000'),(48900,2376,'2024-07-01 16:00:00.000000'),(161609,8331,'2024-07-01 16:00:00.000000'),(91236,264,'2024-07-01 16:00:00.000000'),(352007,516,'2024-07-01 16:00:00.000000'),(342468,870,'2024-07-01 16:00:00.000000'),(346331,364,'2024-07-01 16:00:00.000000'),(340532,943,'2024-07-01 16:00:00.000000'),(78740,2271,'2024-07-01 16:00:00.000000'),(159566,12079,'2024-07-01 16:00:00.000000'),(160616,87,'2024-07-01 16:00:00.000000'),(242263,3152,'2024-07-01 16:00:00.000000'),(326483,8995,'2024-07-01 16:00:00.000000'),(13820,-160,'2024-07-01 16:00:00.000000'),(269583,17791,'2024-07-01 16:00:00.000000'),(172477,702,'2024-07-01 16:00:00.000000'),(13324,3391,'2024-07-01 16:00:00.000000'),(67019,11210,'2024-07-01 16:00:00.000000'),(148509,1680,'2024-07-01 16:00:00.000000'),(190618,498,'2024-07-01 16:00:00.000000'),(74,9280,'2024-07-01 16:00:00.000000'),(4,1062,'2024-07-01 16:00:00.000000'),(14573,13888,'2024-07-01 16:00:00.000000'),(227196,1880,'2024-07-01 16:00:00.000000'),(209473,138,'2024-07-01 16:00:00.000000'),(121,1638,'2024-07-01 16:00:00.000000'),(102,4290,'2024-07-01 16:00:00.000000'),(7,468,'2024-07-01 16:00:00.000000'),(113,6558,'2024-07-01 16:00:00.000000'),(106,15776,'2024-07-01 16:00:00.000000'),(144384,412,'2024-07-01 16:00:00.000000'),(335577,612,'2024-07-01 16:00:00.000000'),(2593,390,'2024-07-01 16:00:00.000000'),(6069,10432,'2024-07-01 16:00:00.000000'),(352924,2340,'2024-07-01 16:00:00.000000'),(336947,129,'2024-07-01 16:00:00.000000'),(336963,436,'2024-07-01 16:00:00.000000'),(345859,839,'2024-07-01 16:00:00.000000'),(119,1298,'2024-07-01 16:00:00.000000'),(249042,1429,'2024-07-01 16:00:00.000000'),(185893,0,'2024-07-01 16:00:00.000000'),(328717,3544,'2024-07-01 16:00:00.000000'),(97857,1459,'2024-07-01 16:00:00.000000'),(93579,84,'2024-07-01 16:00:00.000000'),(82,1170,'2024-07-01 16:00:00.000000'),(132,1280,'2024-07-01 16:00:00.000000'),(73,1493,'2024-07-01 16:00:00.000000'),(139,1472,'2024-07-01 16:00:00.000000'),(141,4856,'2024-07-01 16:00:00.000000'),(175834,7368,'2024-07-01 16:00:00.000000'),(142,603,'2024-07-01 16:00:00.000000'),(348187,6946,'2024-07-01 16:00:00.000000'),(164630,1088,'2024-07-01 16:00:00.000000'),(163374,796,'2024-07-01 16:00:00.000000'),(351513,211,'2024-07-01 16:00:00.000000'),(92,118,'2024-07-01 16:00:00.000000'),(61,5140,'2024-07-01 16:00:00.000000'),(63,1188,'2024-07-01 16:00:00.000000'),(3940,12846,'2024-07-01 16:00:00.000000'),(283,552,'2024-07-01 16:00:00.000000'),(273575,760,'2024-07-01 16:00:00.000000'),(137,1632,'2024-07-01 16:00:00.000000'),(164,544,'2024-07-01 16:00:00.000000'),(77,1698,'2024-07-01 16:00:00.000000'),(1958,2848,'2024-07-01 16:00:00.000000'),(123,708,'2024-07-01 16:00:00.000000'),(54525,118,'2024-07-01 16:00:00.000000'),(270232,967,'2024-07-01 16:00:00.000000'),(109,2376,'2024-07-01 16:00:00.000000'),(79,588,'2024-07-01 16:00:00.000000'),(24582,224,'2024-07-01 16:00:00.000000'),(352787,456,'2024-07-01 16:00:00.000000'),(320517,50,'2024-07-01 16:00:00.000000'),(44,1222,'2024-07-01 16:00:00.000000'),(354058,708,'2024-07-01 16:00:00.000000'),(320610,59,'2024-07-01 16:00:00.000000'),(69,4188,'2024-07-01 16:00:00.000000'),(217860,240,'2024-07-01 16:00:00.000000'),(104,0,'2024-07-01 16:00:00.000000'),(110,2610,'2024-07-01 16:00:00.000000'),(94,826,'2024-07-01 16:00:00.000000'),(111,238,'2024-07-01 16:00:00.000000'),(79843,7707,'2024-07-01 16:00:00.000000'),(86090,1353,'2024-07-01 16:00:00.000000'),(26,120,'2024-07-01 16:00:00.000000'),(58,2394,'2024-07-01 16:00:00.000000'),(120,354,'2024-07-01 16:00:00.000000'),(90281,5056,'2024-07-01 16:00:00.000000'),(143961,3252,'2024-07-01 16:00:00.000000'),(275013,1658,'2024-07-01 16:00:00.000000'),(347900,348,'2024-07-01 16:00:00.000000'),(103920,900,'2024-07-01 16:00:00.000000'),(66,1430,'2024-07-01 16:00:00.000000'),(115,344,'2024-07-01 16:00:00.000000'),(215240,60,'2024-07-01 16:00:00.000000'),(81,120,'2024-07-01 16:00:00.000000'),(345300,2352,'2024-07-01 16:00:00.000000'),(169095,1152,'2024-07-01 16:00:00.000000'),(146545,1302,'2024-07-01 16:00:00.000000'),(51609,2040,'2024-07-01 16:00:00.000000'),(174440,232,'2024-07-01 16:00:00.000000'),(197811,1504,'2024-07-01 16:00:00.000000'),(308732,0,'2024-07-01 16:00:00.000000'),(67383,586,'2024-07-01 16:00:00.000000'),(329947,478,'2024-07-01 16:00:00.000000'),(1649,26928,'2024-07-01 16:00:00.000000'),(179782,588,'2024-07-01 16:00:00.000000'),(213014,1216,'2024-07-01 16:00:00.000000'),(9,120,'2024-07-01 16:00:00.000000'),(87907,544,'2024-07-01 16:00:00.000000'),(354125,234,'2024-07-01 16:00:00.000000'),(11,120,'2024-07-01 16:00:00.000000'),(69379,1424,'2024-07-01 16:00:00.000000'),(330205,133,'2024-07-01 16:00:00.000000'),(87404,801,'2024-07-01 16:00:00.000000'),(93,118,'2024-07-01 16:00:00.000000'),(146166,2992,'2024-07-01 16:00:00.000000'),(352921,234,'2024-07-01 16:00:00.000000'),(75,120,'2024-07-01 16:00:00.000000'),(354236,1896,'2024-07-01 16:00:00.000000'),(267884,813,'2024-07-01 16:00:00.000000'),(101,118,'2024-07-01 16:00:00.000000'),(267713,13,'2024-07-01 16:00:00.000000'),(353921,114,'2024-07-01 16:00:00.000000'),(218851,2496,'2024-07-01 16:00:00.000000'),(270602,204,'2024-07-01 16:00:00.000000'),(48,348,'2024-07-01 16:00:00.000000'),(52499,792,'2024-07-01 16:00:00.000000'),(40441,302,'2024-07-01 16:00:00.000000'),(95,3582,'2024-07-01 16:00:00.000000'),(341103,59,'2024-07-01 16:00:00.000000'),(140,118,'2024-07-01 16:00:00.000000'),(274697,277,'2024-07-01 16:00:00.000000'),(293390,280,'2024-07-01 16:00:00.000000'),(1258,1213,'2024-07-01 16:00:00.000000'),(34,468,'2024-07-01 16:00:00.000000'),(26283,792,'2024-07-01 16:00:00.000000'),(280318,485,'2024-07-01 16:00:00.000000'),(898,584,'2024-07-01 16:00:00.000000'),(348991,114,'2024-07-01 16:00:00.000000'),(16311,-392,'2024-07-01 16:00:00.000000'),(67379,616,'2024-07-01 16:00:00.000000'),(145740,150,'2024-07-01 16:00:00.000000'),(10,0,'2024-07-01 16:00:00.000000'),(3940,38244,'2024-07-02 16:00:00.000000'),(106148,13227,'2024-07-02 16:00:00.000000'),(6069,23558,'2024-07-02 16:00:00.000000'),(182308,62328,'2024-07-02 16:00:00.000000'),(73857,25534,'2024-07-02 16:00:00.000000'),(270888,14274,'2024-07-02 16:00:00.000000'),(159566,8615,'2024-07-02 16:00:00.000000'),(160616,68,'2024-07-02 16:00:00.000000'),(77377,1664,'2024-07-02 16:00:00.000000'),(51609,3592,'2024-07-02 16:00:00.000000'),(328717,937,'2024-07-02 16:00:00.000000'),(268954,6350,'2024-07-02 16:00:00.000000'),(113,236,'2024-07-02 16:00:00.000000'),(14573,9648,'2024-07-02 16:00:00.000000'),(90281,8368,'2024-07-02 16:00:00.000000'),(345300,2058,'2024-07-02 16:00:00.000000'),(346331,241,'2024-07-02 16:00:00.000000'),(340532,626,'2024-07-02 16:00:00.000000'),(336963,256,'2024-07-02 16:00:00.000000'),(78740,2423,'2024-07-02 16:00:00.000000'),(109,7866,'2024-07-02 16:00:00.000000'),(2593,2131,'2024-07-02 16:00:00.000000'),(269583,24273,'2024-07-02 16:00:00.000000'),(74,7166,'2024-07-02 16:00:00.000000'),(67019,17832,'2024-07-02 16:00:00.000000'),(143961,6029,'2024-07-02 16:00:00.000000'),(342468,870,'2024-07-02 16:00:00.000000'),(348187,8729,'2024-07-02 16:00:00.000000'),(159,3722,'2024-07-02 16:00:00.000000'),(353051,408,'2024-07-02 16:00:00.000000'),(67379,224,'2024-07-02 16:00:00.000000'),(296564,151,'2024-07-02 16:00:00.000000'),(186083,143,'2024-07-02 16:00:00.000000'),(4,590,'2024-07-02 16:00:00.000000'),(352921,234,'2024-07-02 16:00:00.000000'),(320517,71,'2024-07-02 16:00:00.000000'),(148509,4480,'2024-07-02 16:00:00.000000'),(354236,948,'2024-07-02 16:00:00.000000'),(132,354,'2024-07-02 16:00:00.000000'),(242263,1072,'2024-07-02 16:00:00.000000'),(209473,69,'2024-07-02 16:00:00.000000'),(190618,1857,'2024-07-02 16:00:00.000000'),(352924,468,'2024-07-02 16:00:00.000000'),(336947,73,'2024-07-02 16:00:00.000000'),(227196,1592,'2024-07-02 16:00:00.000000'),(119,1534,'2024-07-02 16:00:00.000000'),(87907,2176,'2024-07-02 16:00:00.000000'),(106,17800,'2024-07-02 16:00:00.000000'),(269339,7147,'2024-07-02 16:00:00.000000'),(326483,15450,'2024-07-02 16:00:00.000000'),(73,2166,'2024-07-02 16:00:00.000000'),(37634,7320,'2024-07-02 16:00:00.000000'),(161609,4385,'2024-07-02 16:00:00.000000'),(67383,294,'2024-07-02 16:00:00.000000'),(330205,133,'2024-07-02 16:00:00.000000'),(352007,308,'2024-07-02 16:00:00.000000'),(348991,114,'2024-07-02 16:00:00.000000'),(163374,1822,'2024-07-02 16:00:00.000000'),(75,1955,'2024-07-02 16:00:00.000000'),(102,1474,'2024-07-02 16:00:00.000000'),(163608,232,'2024-07-02 16:00:00.000000'),(345859,1393,'2024-07-02 16:00:00.000000'),(11,702,'2024-07-02 16:00:00.000000'),(103920,900,'2024-07-02 16:00:00.000000'),(13324,1776,'2024-07-02 16:00:00.000000'),(142,507,'2024-07-02 16:00:00.000000'),(97,119,'2024-07-02 16:00:00.000000'),(141,708,'2024-07-02 16:00:00.000000'),(335577,3060,'2024-07-02 16:00:00.000000'),(218851,1248,'2024-07-02 16:00:00.000000'),(121,2574,'2024-07-02 16:00:00.000000'),(79843,2971,'2024-07-02 16:00:00.000000'),(86090,522,'2024-07-02 16:00:00.000000'),(139,2984,'2024-07-02 16:00:00.000000'),(66,240,'2024-07-02 16:00:00.000000'),(82,936,'2024-07-02 16:00:00.000000'),(85,414,'2024-07-02 16:00:00.000000'),(69,2458,'2024-07-02 16:00:00.000000'),(175834,2340,'2024-07-02 16:00:00.000000'),(174440,4384,'2024-07-02 16:00:00.000000'),(338334,60,'2024-07-02 16:00:00.000000'),(172477,234,'2024-07-02 16:00:00.000000'),(61,2358,'2024-07-02 16:00:00.000000'),(140,118,'2024-07-02 16:00:00.000000'),(101,472,'2024-07-02 16:00:00.000000'),(354058,354,'2024-07-02 16:00:00.000000'),(48,348,'2024-07-02 16:00:00.000000'),(273575,290,'2024-07-02 16:00:00.000000'),(69379,1415,'2024-07-02 16:00:00.000000'),(293390,280,'2024-07-02 16:00:00.000000'),(1258,2407,'2024-07-02 16:00:00.000000'),(95,594,'2024-07-02 16:00:00.000000'),(107,594,'2024-07-02 16:00:00.000000'),(213554,160,'2024-07-02 16:00:00.000000'),(120,236,'2024-07-02 16:00:00.000000'),(146545,798,'2024-07-02 16:00:00.000000'),(146166,300,'2024-07-02 16:00:00.000000'),(138,348,'2024-07-02 16:00:00.000000'),(164,524,'2024-07-02 16:00:00.000000'),(249042,1604,'2024-07-02 16:00:00.000000'),(123,1770,'2024-07-02 16:00:00.000000'),(9,657,'2024-07-02 16:00:00.000000'),(110,1542,'2024-07-02 16:00:00.000000'),(351513,211,'2024-07-02 16:00:00.000000'),(353921,114,'2024-07-02 16:00:00.000000'),(1982,16000,'2024-07-02 16:00:00.000000'),(77,294,'2024-07-02 16:00:00.000000'),(215135,70,'2024-07-02 16:00:00.000000'),(243393,9,'2024-07-02 16:00:00.000000'),(169095,1203,'2024-07-02 16:00:00.000000'),(87404,1399,'2024-07-02 16:00:00.000000'),(164630,0,'2024-07-02 16:00:00.000000'),(67,26274,'2024-07-02 16:00:00.000000'),(274697,691,'2024-07-02 16:00:00.000000'),(320610,635,'2024-07-02 16:00:00.000000'),(166037,828,'2024-07-02 16:00:00.000000'),(344844,360,'2024-07-02 16:00:00.000000'),(195763,104,'2024-07-02 16:00:00.000000'),(20,320,'2024-07-02 16:00:00.000000'),(34,468,'2024-07-02 16:00:00.000000'),(267713,704,'2024-07-02 16:00:00.000000'),(145740,600,'2024-07-02 16:00:00.000000'),(240225,468,'2024-07-02 16:00:00.000000'),(137,1224,'2024-07-02 16:00:00.000000'),(267884,2440,'2024-07-02 16:00:00.000000'),(1958,472,'2024-07-02 16:00:00.000000'),(213014,5680,'2024-07-02 16:00:00.000000'),(8,118,'2024-07-02 16:00:00.000000'),(352787,798,'2024-07-02 16:00:00.000000'),(97857,1794,'2024-07-02 16:00:00.000000'),(93579,105,'2024-07-02 16:00:00.000000'),(68,348,'2024-07-02 16:00:00.000000'),(293753,1784,'2024-07-02 16:00:00.000000'),(283,784,'2024-07-02 16:00:00.000000'),(1188,1176,'2024-07-02 16:00:00.000000'),(308732,317,'2024-07-02 16:00:00.000000'),(63,2790,'2024-07-02 16:00:00.000000'),(996,392,'2024-07-02 16:00:00.000000'),(270232,2700,'2024-07-02 16:00:00.000000'),(270602,277,'2024-07-02 16:00:00.000000'),(348500,234,'2024-07-02 16:00:00.000000'),(92,118,'2024-07-02 16:00:00.000000'),(94,118,'2024-07-02 16:00:00.000000'),(329947,299,'2024-07-02 16:00:00.000000'),(275013,1066,'2024-07-02 16:00:00.000000'),(13820,792,'2024-07-02 16:00:00.000000'),(206580,70,'2024-07-02 16:00:00.000000'),(78,60,'2024-07-02 16:00:00.000000'),(217860,1512,'2024-07-02 16:00:00.000000'),(44,271,'2024-07-02 16:00:00.000000'),(341834,239,'2024-07-02 16:00:00.000000'),(167340,288,'2024-07-02 16:00:00.000000'),(16311,392,'2024-07-02 16:00:00.000000'),(153632,521,'2024-07-02 16:00:00.000000'),(5349,223,'2024-07-02 16:00:00.000000'),(185893,234,'2024-07-02 16:00:00.000000'),(2953,792,'2024-07-02 16:00:00.000000'),(91236,552,'2024-07-02 16:00:00.000000'),(254325,576,'2024-07-02 16:00:00.000000'),(327391,60,'2024-07-02 16:00:00.000000'),(348187,11396,'2024-07-03 16:00:00.000000'),(159,6201,'2024-07-03 16:00:00.000000'),(77377,4048,'2024-07-03 16:00:00.000000'),(101,118,'2024-07-03 16:00:00.000000'),(14573,6440,'2024-07-03 16:00:00.000000'),(182308,54360,'2024-07-03 16:00:00.000000'),(73857,30506,'2024-07-03 16:00:00.000000'),(270888,37158,'2024-07-03 16:00:00.000000'),(269583,31587,'2024-07-03 16:00:00.000000'),(106148,13449,'2024-07-03 16:00:00.000000'),(352787,2610,'2024-07-03 16:00:00.000000'),(336947,155,'2024-07-03 16:00:00.000000'),(320517,165,'2024-07-03 16:00:00.000000'),(340532,1040,'2024-07-03 16:00:00.000000'),(346331,395,'2024-07-03 16:00:00.000000'),(78740,2141,'2024-07-03 16:00:00.000000'),(121,4446,'2024-07-03 16:00:00.000000'),(161609,2483,'2024-07-03 16:00:00.000000'),(22,28640,'2024-07-03 16:00:00.000000'),(146166,450,'2024-07-03 16:00:00.000000'),(13324,1739,'2024-07-03 16:00:00.000000'),(115,344,'2024-07-03 16:00:00.000000'),(96,236,'2024-07-03 16:00:00.000000'),(159566,11282,'2024-07-03 16:00:00.000000'),(160616,80,'2024-07-03 16:00:00.000000'),(3940,28484,'2024-07-03 16:00:00.000000'),(109,3660,'2024-07-03 16:00:00.000000'),(2593,588,'2024-07-03 16:00:00.000000'),(102,708,'2024-07-03 16:00:00.000000'),(6069,20783,'2024-07-03 16:00:00.000000'),(169095,2151,'2024-07-03 16:00:00.000000'),(44,1165,'2024-07-03 16:00:00.000000'),(67019,6999,'2024-07-03 16:00:00.000000'),(345859,3363,'2024-07-03 16:00:00.000000'),(213014,3304,'2024-07-03 16:00:00.000000'),(328717,1482,'2024-07-03 16:00:00.000000'),(345521,60,'2024-07-03 16:00:00.000000'),(258846,114,'2024-07-03 16:00:00.000000'),(143961,3801,'2024-07-03 16:00:00.000000'),(345300,2883,'2024-07-03 16:00:00.000000'),(336963,396,'2024-07-03 16:00:00.000000'),(75,360,'2024-07-03 16:00:00.000000'),(269339,8173,'2024-07-03 16:00:00.000000'),(34,702,'2024-07-03 16:00:00.000000'),(110,948,'2024-07-03 16:00:00.000000'),(163374,398,'2024-07-03 16:00:00.000000'),(249042,1733,'2024-07-03 16:00:00.000000'),(148509,2520,'2024-07-03 16:00:00.000000'),(213554,328,'2024-07-03 16:00:00.000000'),(106,9528,'2024-07-03 16:00:00.000000'),(73,1254,'2024-07-03 16:00:00.000000'),(326483,29881,'2024-07-03 16:00:00.000000'),(20,1680,'2024-07-03 16:00:00.000000'),(92,236,'2024-07-03 16:00:00.000000'),(82,468,'2024-07-03 16:00:00.000000'),(275013,1066,'2024-07-03 16:00:00.000000'),(190618,880,'2024-07-03 16:00:00.000000'),(1649,1104,'2024-07-03 16:00:00.000000'),(146340,210,'2024-07-03 16:00:00.000000'),(69379,1896,'2024-07-03 16:00:00.000000'),(335577,918,'2024-07-03 16:00:00.000000'),(293390,280,'2024-07-03 16:00:00.000000'),(1258,198,'2024-07-03 16:00:00.000000'),(274697,345,'2024-07-03 16:00:00.000000'),(123,354,'2024-07-03 16:00:00.000000'),(342468,1044,'2024-07-03 16:00:00.000000'),(90281,7904,'2024-07-03 16:00:00.000000'),(320610,401,'2024-07-03 16:00:00.000000'),(87907,6528,'2024-07-03 16:00:00.000000'),(254325,72,'2024-07-03 16:00:00.000000'),(172477,234,'2024-07-03 16:00:00.000000'),(329947,2145,'2024-07-03 16:00:00.000000'),(354236,2640,'2024-07-03 16:00:00.000000'),(139,1062,'2024-07-03 16:00:00.000000'),(164630,0,'2024-07-03 16:00:00.000000'),(11,120,'2024-07-03 16:00:00.000000'),(119,472,'2024-07-03 16:00:00.000000'),(358886,942,'2024-07-03 16:00:00.000000'),(215240,60,'2024-07-03 16:00:00.000000'),(61,2800,'2024-07-03 16:00:00.000000'),(308732,1015,'2024-07-03 16:00:00.000000'),(344844,360,'2024-07-03 16:00:00.000000'),(174440,4336,'2024-07-03 16:00:00.000000'),(132,0,'2024-07-03 16:00:00.000000'),(268954,8595,'2024-07-03 16:00:00.000000'),(242263,2072,'2024-07-03 16:00:00.000000'),(74,6636,'2024-07-03 16:00:00.000000'),(26283,1584,'2024-07-03 16:00:00.000000'),(1958,1584,'2024-07-03 16:00:00.000000'),(141,354,'2024-07-03 16:00:00.000000'),(206580,0,'2024-07-03 16:00:00.000000'),(54525,236,'2024-07-03 16:00:00.000000'),(63,2904,'2024-07-03 16:00:00.000000'),(51609,1976,'2024-07-03 16:00:00.000000'),(353051,956,'2024-07-03 16:00:00.000000'),(137,1632,'2024-07-03 16:00:00.000000'),(164,544,'2024-07-03 16:00:00.000000'),(175834,1404,'2024-07-03 16:00:00.000000'),(142,209,'2024-07-03 16:00:00.000000'),(267713,150,'2024-07-03 16:00:00.000000'),(8,238,'2024-07-03 16:00:00.000000'),(15,80,'2024-07-03 16:00:00.000000'),(342076,232,'2024-07-03 16:00:00.000000'),(4,472,'2024-07-03 16:00:00.000000'),(76278,594,'2024-07-03 16:00:00.000000'),(25,114,'2024-07-03 16:00:00.000000'),(66,600,'2024-07-03 16:00:00.000000'),(120,354,'2024-07-03 16:00:00.000000'),(95,594,'2024-07-03 16:00:00.000000'),(78,120,'2024-07-03 16:00:00.000000'),(24582,944,'2024-07-03 16:00:00.000000'),(91236,1656,'2024-07-03 16:00:00.000000'),(113,354,'2024-07-03 16:00:00.000000'),(280318,485,'2024-07-03 16:00:00.000000'),(69,240,'2024-07-03 16:00:00.000000'),(58,240,'2024-07-03 16:00:00.000000'),(87404,3180,'2024-07-03 16:00:00.000000'),(227196,1280,'2024-07-03 16:00:00.000000'),(85,234,'2024-07-03 16:00:00.000000'),(293753,688,'2024-07-03 16:00:00.000000'),(267884,222,'2024-07-03 16:00:00.000000'),(79843,938,'2024-07-03 16:00:00.000000'),(86090,164,'2024-07-03 16:00:00.000000'),(79,114,'2024-07-03 16:00:00.000000'),(77,588,'2024-07-03 16:00:00.000000'),(348991,0,'2024-07-03 16:00:00.000000'),(352924,234,'2024-07-03 16:00:00.000000'),(3536,392,'2024-07-03 16:00:00.000000'),(179782,294,'2024-07-03 16:00:00.000000'),(270017,0,'2024-07-03 16:00:00.000000'),(148,294,'2024-07-03 16:00:00.000000'),(341103,120,'2024-07-03 16:00:00.000000'),(218851,416,'2024-07-03 16:00:00.000000'),(9,118,'2024-07-03 16:00:00.000000'),(37634,872,'2024-07-03 16:00:00.000000'),(7,234,'2024-07-03 16:00:00.000000'),(64,354,'2024-07-03 16:00:00.000000'),(145740,150,'2024-07-03 16:00:00.000000'),(348187,10953,'2024-07-04 16:00:00.000000'),(159,3732,'2024-07-04 16:00:00.000000'),(182308,50820,'2024-07-04 16:00:00.000000'),(73857,23338,'2024-07-04 16:00:00.000000'),(270888,19194,'2024-07-04 16:00:00.000000'),(103920,300,'2024-07-04 16:00:00.000000'),(13324,459,'2024-07-04 16:00:00.000000'),(269583,17602,'2024-07-04 16:00:00.000000'),(106148,7986,'2024-07-04 16:00:00.000000'),(268954,1256,'2024-07-04 16:00:00.000000'),(119,1244,'2024-07-04 16:00:00.000000'),(14573,7770,'2024-07-04 16:00:00.000000'),(61,2807,'2024-07-04 16:00:00.000000'),(67019,6179,'2024-07-04 16:00:00.000000'),(87404,1060,'2024-07-04 16:00:00.000000'),(113,1652,'2024-07-04 16:00:00.000000'),(269339,8559,'2024-07-04 16:00:00.000000'),(353051,140,'2024-07-04 16:00:00.000000'),(141,354,'2024-07-04 16:00:00.000000'),(348500,234,'2024-07-04 16:00:00.000000'),(346331,467,'2024-07-04 16:00:00.000000'),(340532,1183,'2024-07-04 16:00:00.000000'),(336947,120,'2024-07-04 16:00:00.000000'),(78740,3731,'2024-07-04 16:00:00.000000'),(6069,26168,'2024-07-04 16:00:00.000000'),(87907,4896,'2024-07-04 16:00:00.000000'),(90281,8896,'2024-07-04 16:00:00.000000'),(106,9856,'2024-07-04 16:00:00.000000'),(132,708,'2024-07-04 16:00:00.000000'),(144384,648,'2024-07-04 16:00:00.000000'),(159566,5161,'2024-07-04 16:00:00.000000'),(160616,35,'2024-07-04 16:00:00.000000'),(3940,19910,'2024-07-04 16:00:00.000000'),(354236,2294,'2024-07-04 16:00:00.000000'),(336963,593,'2024-07-04 16:00:00.000000'),(109,3558,'2024-07-04 16:00:00.000000'),(2593,1080,'2024-07-04 16:00:00.000000'),(20,1040,'2024-07-04 16:00:00.000000'),(69,480,'2024-07-04 16:00:00.000000'),(213014,848,'2024-07-04 16:00:00.000000'),(190618,960,'2024-07-04 16:00:00.000000'),(148509,8680,'2024-07-04 16:00:00.000000'),(77377,1568,'2024-07-04 16:00:00.000000'),(143961,6842,'2024-07-04 16:00:00.000000'),(77,1470,'2024-07-04 16:00:00.000000'),(345300,5395,'2024-07-04 16:00:00.000000'),(169095,300,'2024-07-04 16:00:00.000000'),(217860,960,'2024-07-04 16:00:00.000000'),(82,642,'2024-07-04 16:00:00.000000'),(74,3318,'2024-07-04 16:00:00.000000'),(328717,0,'2024-07-04 16:00:00.000000'),(227196,4232,'2024-07-04 16:00:00.000000'),(8,354,'2024-07-04 16:00:00.000000'),(94,354,'2024-07-04 16:00:00.000000'),(352921,234,'2024-07-04 16:00:00.000000'),(320517,71,'2024-07-04 16:00:00.000000'),(85,60,'2024-07-04 16:00:00.000000'),(320610,342,'2024-07-04 16:00:00.000000'),(293390,280,'2024-07-04 16:00:00.000000'),(1258,198,'2024-07-04 16:00:00.000000'),(242263,4856,'2024-07-04 16:00:00.000000'),(342468,522,'2024-07-04 16:00:00.000000'),(110,0,'2024-07-04 16:00:00.000000'),(73,798,'2024-07-04 16:00:00.000000'),(175834,1638,'2024-07-04 16:00:00.000000'),(142,224,'2024-07-04 16:00:00.000000'),(280318,209,'2024-07-04 16:00:00.000000'),(326483,6180,'2024-07-04 16:00:00.000000'),(267884,222,'2024-07-04 16:00:00.000000'),(275013,948,'2024-07-04 16:00:00.000000'),(140,644,'2024-07-04 16:00:00.000000'),(79843,1611,'2024-07-04 16:00:00.000000'),(86090,282,'2024-07-04 16:00:00.000000'),(342076,343,'2024-07-04 16:00:00.000000'),(354058,234,'2024-07-04 16:00:00.000000'),(185893,234,'2024-07-04 16:00:00.000000'),(349805,234,'2024-07-04 16:00:00.000000'),(44,403,'2024-07-04 16:00:00.000000'),(91236,1248,'2024-07-04 16:00:00.000000'),(38971,594,'2024-07-04 16:00:00.000000'),(352787,696,'2024-07-04 16:00:00.000000'),(174440,8320,'2024-07-04 16:00:00.000000'),(335577,1836,'2024-07-04 16:00:00.000000'),(121,5970,'2024-07-04 16:00:00.000000'),(51609,152,'2024-07-04 16:00:00.000000'),(293753,5664,'2024-07-04 16:00:00.000000'),(66,360,'2024-07-04 16:00:00.000000'),(352007,3378,'2024-07-04 16:00:00.000000'),(249042,6700,'2024-07-04 16:00:00.000000'),(29980,696,'2024-07-04 16:00:00.000000'),(139,472,'2024-07-04 16:00:00.000000'),(338605,816,'2024-07-04 16:00:00.000000'),(163374,941,'2024-07-04 16:00:00.000000'),(79,0,'2024-07-04 16:00:00.000000'),(137,408,'2024-07-04 16:00:00.000000'),(164,252,'2024-07-04 16:00:00.000000'),(102,118,'2024-07-04 16:00:00.000000'),(120,118,'2024-07-04 16:00:00.000000'),(358886,1344,'2024-07-04 16:00:00.000000'),(75,840,'2024-07-04 16:00:00.000000'),(163660,232,'2024-07-04 16:00:00.000000'),(25,228,'2024-07-04 16:00:00.000000'),(161609,782,'2024-07-04 16:00:00.000000'),(352924,702,'2024-07-04 16:00:00.000000'),(1958,5240,'2024-07-04 16:00:00.000000'),(92,590,'2024-07-04 16:00:00.000000'),(329947,239,'2024-07-04 16:00:00.000000'),(26283,792,'2024-07-04 16:00:00.000000'),(138,348,'2024-07-04 16:00:00.000000'),(9,238,'2024-07-04 16:00:00.000000'),(365051,234,'2024-07-04 16:00:00.000000'),(1471,792,'2024-07-04 16:00:00.000000'),(145740,450,'2024-07-04 16:00:00.000000'),(7,413,'2024-07-04 16:00:00.000000'),(37634,1256,'2024-07-04 16:00:00.000000'),(996,392,'2024-07-04 16:00:00.000000'),(1649,552,'2024-07-04 16:00:00.000000'),(123,1062,'2024-07-04 16:00:00.000000'),(58,120,'2024-07-04 16:00:00.000000'),(51444,392,'2024-07-04 16:00:00.000000'),(63,594,'2024-07-04 16:00:00.000000'),(146166,0,'2024-07-04 16:00:00.000000'),(54525,236,'2024-07-04 16:00:00.000000'),(367375,120,'2024-07-04 16:00:00.000000'),(345859,644,'2024-07-04 16:00:00.000000'),(5545,400,'2024-07-04 16:00:00.000000'),(97,4001,'2024-07-04 16:00:00.000000'),(303906,2316,'2024-07-04 16:00:00.000000'),(101,118,'2024-07-04 16:00:00.000000'),(69379,632,'2024-07-04 16:00:00.000000'),(34,702,'2024-07-04 16:00:00.000000'),(267713,13,'2024-07-04 16:00:00.000000'),(283,472,'2024-07-04 16:00:00.000000'),(97857,598,'2024-07-04 16:00:00.000000'),(93579,35,'2024-07-04 16:00:00.000000'),(344844,60,'2024-07-04 16:00:00.000000'),(308732,317,'2024-07-04 16:00:00.000000'),(11,120,'2024-07-04 16:00:00.000000'),(93,784,'2024-07-04 16:00:00.000000'),(270602,554,'2024-07-04 16:00:00.000000'),(52499,792,'2024-07-04 16:00:00.000000'),(348187,11611,'2024-07-05 16:00:00.000000'),(159,3017,'2024-07-05 16:00:00.000000'),(352007,630,'2024-07-05 16:00:00.000000'),(270888,13926,'2024-07-05 16:00:00.000000'),(73857,12342,'2024-07-05 16:00:00.000000'),(182308,23100,'2024-07-05 16:00:00.000000'),(3940,21964,'2024-07-05 16:00:00.000000'),(106148,10679,'2024-07-05 16:00:00.000000'),(161609,5469,'2024-07-05 16:00:00.000000'),(77377,1888,'2024-07-05 16:00:00.000000'),(269339,13012,'2024-07-05 16:00:00.000000'),(123,1062,'2024-07-05 16:00:00.000000'),(14573,8947,'2024-07-05 16:00:00.000000'),(93,4312,'2024-07-05 16:00:00.000000'),(303906,6782,'2024-07-05 16:00:00.000000'),(335318,180,'2024-07-05 16:00:00.000000'),(78740,1637,'2024-07-05 16:00:00.000000'),(67019,15280,'2024-07-05 16:00:00.000000'),(77,1470,'2024-07-05 16:00:00.000000'),(227196,4768,'2024-07-05 16:00:00.000000'),(335577,2448,'2024-07-05 16:00:00.000000'),(2593,1350,'2024-07-05 16:00:00.000000'),(146460,297,'2024-07-05 16:00:00.000000'),(13324,3146,'2024-07-05 16:00:00.000000'),(26,99,'2024-07-05 16:00:00.000000'),(106,9528,'2024-07-05 16:00:00.000000'),(345859,1315,'2024-07-05 16:00:00.000000'),(6069,28240,'2024-07-05 16:00:00.000000'),(113,3158,'2024-07-05 16:00:00.000000'),(185893,588,'2024-07-05 16:00:00.000000'),(82,234,'2024-07-05 16:00:00.000000'),(159566,5904,'2024-07-05 16:00:00.000000'),(160616,46,'2024-07-05 16:00:00.000000'),(269583,18437,'2024-07-05 16:00:00.000000'),(169095,300,'2024-07-05 16:00:00.000000'),(97,7155,'2024-07-05 16:00:00.000000'),(87404,1861,'2024-07-05 16:00:00.000000'),(293753,626,'2024-07-05 16:00:00.000000'),(175834,1170,'2024-07-05 16:00:00.000000'),(142,432,'2024-07-05 16:00:00.000000'),(190618,818,'2024-07-05 16:00:00.000000'),(20,960,'2024-07-05 16:00:00.000000'),(179782,228,'2024-07-05 16:00:00.000000'),(74,16144,'2024-07-05 16:00:00.000000'),(119,590,'2024-07-05 16:00:00.000000'),(121,7224,'2024-07-05 16:00:00.000000'),(249042,598,'2024-07-05 16:00:00.000000'),(268954,8181,'2024-07-05 16:00:00.000000'),(97857,1196,'2024-07-05 16:00:00.000000'),(93579,70,'2024-07-05 16:00:00.000000'),(352787,348,'2024-07-05 16:00:00.000000'),(336947,62,'2024-07-05 16:00:00.000000'),(320517,44,'2024-07-05 16:00:00.000000'),(340532,592,'2024-07-05 16:00:00.000000'),(346331,235,'2024-07-05 16:00:00.000000'),(344844,60,'2024-07-05 16:00:00.000000'),(336963,300,'2024-07-05 16:00:00.000000'),(90281,13008,'2024-07-05 16:00:00.000000'),(102,1592,'2024-07-05 16:00:00.000000'),(345300,3922,'2024-07-05 16:00:00.000000'),(275013,474,'2024-07-05 16:00:00.000000'),(148509,1421,'2024-07-05 16:00:00.000000'),(367375,120,'2024-07-05 16:00:00.000000'),(213014,1368,'2024-07-05 16:00:00.000000'),(66,240,'2024-07-05 16:00:00.000000'),(143961,5216,'2024-07-05 16:00:00.000000'),(139,4044,'2024-07-05 16:00:00.000000'),(141,472,'2024-07-05 16:00:00.000000'),(61,2044,'2024-07-05 16:00:00.000000'),(242263,3464,'2024-07-05 16:00:00.000000'),(63,1122,'2024-07-05 16:00:00.000000'),(352924,702,'2024-07-05 16:00:00.000000'),(146545,1152,'2024-07-05 16:00:00.000000'),(73,1026,'2024-07-05 16:00:00.000000'),(95,594,'2024-07-05 16:00:00.000000'),(163374,1268,'2024-07-05 16:00:00.000000'),(146166,2304,'2024-07-05 16:00:00.000000'),(67383,1277,'2024-07-05 16:00:00.000000'),(326483,6180,'2024-07-05 16:00:00.000000'),(151,118,'2024-07-05 16:00:00.000000'),(100,792,'2024-07-05 16:00:00.000000'),(1958,472,'2024-07-05 16:00:00.000000'),(69379,1039,'2024-07-05 16:00:00.000000'),(91236,1672,'2024-07-05 16:00:00.000000'),(358886,528,'2024-07-05 16:00:00.000000'),(51609,2520,'2024-07-05 16:00:00.000000'),(328717,554,'2024-07-05 16:00:00.000000'),(270602,277,'2024-07-05 16:00:00.000000'),(89,455,'2024-07-05 16:00:00.000000'),(7,522,'2024-07-05 16:00:00.000000'),(11,294,'2024-07-05 16:00:00.000000'),(34,702,'2024-07-05 16:00:00.000000'),(87907,7872,'2024-07-05 16:00:00.000000'),(54525,118,'2024-07-05 16:00:00.000000'),(1649,552,'2024-07-05 16:00:00.000000'),(94,118,'2024-07-05 16:00:00.000000'),(342468,522,'2024-07-05 16:00:00.000000'),(110,474,'2024-07-05 16:00:00.000000'),(120,236,'2024-07-05 16:00:00.000000'),(137,816,'2024-07-05 16:00:00.000000'),(164,272,'2024-07-05 16:00:00.000000'),(338605,816,'2024-07-05 16:00:00.000000'),(79,17556,'2024-07-05 16:00:00.000000'),(92,464,'2024-07-05 16:00:00.000000'),(353051,105,'2024-07-05 16:00:00.000000'),(267713,832,'2024-07-05 16:00:00.000000'),(360412,696,'2024-07-05 16:00:00.000000'),(330205,202,'2024-07-05 16:00:00.000000'),(267884,222,'2024-07-05 16:00:00.000000'),(145740,1302,'2024-07-05 16:00:00.000000'),(280318,575,'2024-07-05 16:00:00.000000'),(1258,1845,'2024-07-05 16:00:00.000000'),(48,828,'2024-07-05 16:00:00.000000'),(101,0,'2024-07-05 16:00:00.000000'),(140,118,'2024-07-05 16:00:00.000000'),(68,174,'2024-07-05 16:00:00.000000'),(174440,312,'2024-07-05 16:00:00.000000'),(240225,234,'2024-07-05 16:00:00.000000'),(209473,138,'2024-07-05 16:00:00.000000'),(109,1188,'2024-07-05 16:00:00.000000'),(360323,0,'2024-07-05 16:00:00.000000'),(348968,0,'2024-07-05 16:00:00.000000'),(81,120,'2024-07-05 16:00:00.000000'),(96,118,'2024-07-05 16:00:00.000000'),(144384,60,'2024-07-05 16:00:00.000000'),(29980,696,'2024-07-05 16:00:00.000000'),(274697,831,'2024-07-05 16:00:00.000000'),(329947,239,'2024-07-05 16:00:00.000000'),(132,118,'2024-07-05 16:00:00.000000'),(44,679,'2024-07-05 16:00:00.000000'),(19316,792,'2024-07-05 16:00:00.000000'),(366194,274,'2024-07-05 16:00:00.000000'),(218851,416,'2024-07-05 16:00:00.000000'),(182308,34860,'2024-07-06 16:00:00.000000'),(73857,16522,'2024-07-06 16:00:00.000000'),(348187,14840,'2024-07-06 16:00:00.000000'),(159,7123,'2024-07-06 16:00:00.000000'),(106,21824,'2024-07-06 16:00:00.000000'),(93,5162,'2024-07-06 16:00:00.000000'),(303906,7844,'2024-07-06 16:00:00.000000'),(1958,6480,'2024-07-06 16:00:00.000000'),(3940,18457,'2024-07-06 16:00:00.000000'),(106148,5588,'2024-07-06 16:00:00.000000'),(44,1962,'2024-07-06 16:00:00.000000'),(67019,5324,'2024-07-06 16:00:00.000000'),(139,664,'2024-07-06 16:00:00.000000'),(14573,20702,'2024-07-06 16:00:00.000000'),(270888,14706,'2024-07-06 16:00:00.000000'),(269339,8016,'2024-07-06 16:00:00.000000'),(6069,22520,'2024-07-06 16:00:00.000000'),(90281,0,'2024-07-06 16:00:00.000000'),(87907,0,'2024-07-06 16:00:00.000000'),(159566,14096,'2024-07-06 16:00:00.000000'),(160616,110,'2024-07-06 16:00:00.000000'),(218851,832,'2024-07-06 16:00:00.000000'),(274697,831,'2024-07-06 16:00:00.000000'),(74,2952,'2024-07-06 16:00:00.000000'),(109,23712,'2024-07-06 16:00:00.000000'),(2593,1119,'2024-07-06 16:00:00.000000'),(143961,10432,'2024-07-06 16:00:00.000000'),(73,912,'2024-07-06 16:00:00.000000'),(66,120,'2024-07-06 16:00:00.000000'),(1649,2760,'2024-07-06 16:00:00.000000'),(352007,1932,'2024-07-06 16:00:00.000000'),(137,408,'2024-07-06 16:00:00.000000'),(164,136,'2024-07-06 16:00:00.000000'),(190618,1369,'2024-07-06 16:00:00.000000'),(227196,2704,'2024-07-06 16:00:00.000000'),(91236,1896,'2024-07-06 16:00:00.000000'),(119,1534,'2024-07-06 16:00:00.000000'),(345859,1595,'2024-07-06 16:00:00.000000'),(20,880,'2024-07-06 16:00:00.000000'),(85,174,'2024-07-06 16:00:00.000000'),(366194,822,'2024-07-06 16:00:00.000000'),(97,3112,'2024-07-06 16:00:00.000000'),(140,354,'2024-07-06 16:00:00.000000'),(34,1404,'2024-07-06 16:00:00.000000'),(175834,26490,'2024-07-06 16:00:00.000000'),(142,2172,'2024-07-06 16:00:00.000000'),(77377,2592,'2024-07-06 16:00:00.000000'),(161609,4463,'2024-07-06 16:00:00.000000'),(326483,7306,'2024-07-06 16:00:00.000000'),(354236,3918,'2024-07-06 16:00:00.000000'),(340532,666,'2024-07-06 16:00:00.000000'),(346331,265,'2024-07-06 16:00:00.000000'),(336963,372,'2024-07-06 16:00:00.000000'),(78740,1969,'2024-07-06 16:00:00.000000'),(209473,69,'2024-07-06 16:00:00.000000'),(353051,1101,'2024-07-06 16:00:00.000000'),(148509,4573,'2024-07-06 16:00:00.000000'),(269583,2841,'2024-07-06 16:00:00.000000'),(345300,1706,'2024-07-06 16:00:00.000000'),(163374,80,'2024-07-06 16:00:00.000000'),(51609,1336,'2024-07-06 16:00:00.000000'),(197811,1504,'2024-07-06 16:00:00.000000'),(145740,300,'2024-07-06 16:00:00.000000'),(13324,317,'2024-07-06 16:00:00.000000'),(92,236,'2024-07-06 16:00:00.000000'),(123,1290,'2024-07-06 16:00:00.000000'),(226924,712,'2024-07-06 16:00:00.000000'),(121,2688,'2024-07-06 16:00:00.000000'),(4,118,'2024-07-06 16:00:00.000000'),(120,1180,'2024-07-06 16:00:00.000000'),(69,240,'2024-07-06 16:00:00.000000'),(240225,702,'2024-07-06 16:00:00.000000'),(268954,1868,'2024-07-06 16:00:00.000000'),(48,828,'2024-07-06 16:00:00.000000'),(79843,2284,'2024-07-06 16:00:00.000000'),(86090,400,'2024-07-06 16:00:00.000000'),(344844,120,'2024-07-06 16:00:00.000000'),(336947,19,'2024-07-06 16:00:00.000000'),(75,240,'2024-07-06 16:00:00.000000'),(69379,5424,'2024-07-06 16:00:00.000000'),(61,2037,'2024-07-06 16:00:00.000000'),(132,868,'2024-07-06 16:00:00.000000'),(26,249,'2024-07-06 16:00:00.000000'),(7,468,'2024-07-06 16:00:00.000000'),(353921,59,'2024-07-06 16:00:00.000000'),(77,588,'2024-07-06 16:00:00.000000'),(11,1007,'2024-07-06 16:00:00.000000'),(146166,150,'2024-07-06 16:00:00.000000'),(87404,1590,'2024-07-06 16:00:00.000000'),(1188,392,'2024-07-06 16:00:00.000000'),(249042,1669,'2024-07-06 16:00:00.000000'),(335577,918,'2024-07-06 16:00:00.000000'),(174440,2832,'2024-07-06 16:00:00.000000'),(144384,588,'2024-07-06 16:00:00.000000'),(342468,696,'2024-07-06 16:00:00.000000'),(113,1234,'2024-07-06 16:00:00.000000'),(242263,3464,'2024-07-06 16:00:00.000000'),(213014,2536,'2024-07-06 16:00:00.000000'),(93963,1504,'2024-07-06 16:00:00.000000'),(338605,197,'2024-07-06 16:00:00.000000'),(115,344,'2024-07-06 16:00:00.000000'),(24582,1592,'2024-07-06 16:00:00.000000'),(54525,472,'2024-07-06 16:00:00.000000'),(172477,234,'2024-07-06 16:00:00.000000'),(352787,174,'2024-07-06 16:00:00.000000'),(320517,20,'2024-07-06 16:00:00.000000'),(19316,4000,'2024-07-06 16:00:00.000000'),(103920,600,'2024-07-06 16:00:00.000000'),(367375,60,'2024-07-06 16:00:00.000000'),(328717,554,'2024-07-06 16:00:00.000000'),(1258,476,'2024-07-06 16:00:00.000000'),(95,594,'2024-07-06 16:00:00.000000'),(141,590,'2024-07-06 16:00:00.000000'),(29980,21027,'2024-07-06 16:00:00.000000'),(31476,8604,'2024-07-06 16:00:00.000000'),(110,882,'2024-07-06 16:00:00.000000'),(270602,277,'2024-07-06 16:00:00.000000'),(68,348,'2024-07-06 16:00:00.000000'),(335318,60,'2024-07-06 16:00:00.000000'),(185893,0,'2024-07-06 16:00:00.000000'),(67383,294,'2024-07-06 16:00:00.000000'),(101,472,'2024-07-06 16:00:00.000000'),(898,232,'2024-07-06 16:00:00.000000'),(293753,4192,'2024-07-06 16:00:00.000000'),(358886,234,'2024-07-06 16:00:00.000000'),(169095,0,'2024-07-06 16:00:00.000000'),(352921,0,'2024-07-06 16:00:00.000000'),(9,120,'2024-07-06 16:00:00.000000'),(164630,1936,'2024-07-06 16:00:00.000000'),(280318,104,'2024-07-06 16:00:00.000000'),(320610,402,'2024-07-06 16:00:00.000000'),(3,60,'2024-07-06 16:00:00.000000'),(67,594,'2024-07-06 16:00:00.000000'),(13820,792,'2024-07-06 16:00:00.000000'),(102,118,'2024-07-06 16:00:00.000000'),(217860,480,'2024-07-06 16:00:00.000000'),(338334,60,'2024-07-06 16:00:00.000000'),(376093,232,'2024-07-06 16:00:00.000000'),(267713,277,'2024-07-06 16:00:00.000000'),(37634,1184,'2024-07-06 16:00:00.000000'),(8,118,'2024-07-06 16:00:00.000000'),(330205,69,'2024-07-06 16:00:00.000000'),(182308,30480,'2024-07-07 16:00:00.000000'),(73857,14272,'2024-07-07 16:00:00.000000'),(95,594,'2024-07-07 16:00:00.000000'),(14573,7296,'2024-07-07 16:00:00.000000'),(348187,15659,'2024-07-07 16:00:00.000000'),(159,4161,'2024-07-07 16:00:00.000000'),(190618,1920,'2024-07-07 16:00:00.000000'),(37634,232,'2024-07-07 16:00:00.000000'),(227196,3592,'2024-07-07 16:00:00.000000'),(270888,12336,'2024-07-07 16:00:00.000000'),(352007,322,'2024-07-07 16:00:00.000000'),(345859,2170,'2024-07-07 16:00:00.000000'),(269583,1680,'2024-07-07 16:00:00.000000'),(106148,6381,'2024-07-07 16:00:00.000000'),(93,2352,'2024-07-07 16:00:00.000000'),(303906,7885,'2024-07-07 16:00:00.000000'),(6069,21056,'2024-07-07 16:00:00.000000'),(31476,6333,'2024-07-07 16:00:00.000000'),(268954,4674,'2024-07-07 16:00:00.000000'),(161609,3882,'2024-07-07 16:00:00.000000'),(269339,11322,'2024-07-07 16:00:00.000000'),(159566,10987,'2024-07-07 16:00:00.000000'),(160616,84,'2024-07-07 16:00:00.000000'),(1958,10040,'2024-07-07 16:00:00.000000'),(217860,1592,'2024-07-07 16:00:00.000000'),(143961,4614,'2024-07-07 16:00:00.000000'),(121,1110,'2024-07-07 16:00:00.000000'),(274697,409,'2024-07-07 16:00:00.000000'),(366194,670,'2024-07-07 16:00:00.000000'),(3940,15424,'2024-07-07 16:00:00.000000'),(119,3004,'2024-07-07 16:00:00.000000'),(358886,762,'2024-07-07 16:00:00.000000'),(336947,74,'2024-07-07 16:00:00.000000'),(340532,520,'2024-07-07 16:00:00.000000'),(346331,195,'2024-07-07 16:00:00.000000'),(78740,2122,'2024-07-07 16:00:00.000000'),(74,964,'2024-07-07 16:00:00.000000'),(67019,5377,'2024-07-07 16:00:00.000000'),(96,179,'2024-07-07 16:00:00.000000'),(326483,10674,'2024-07-07 16:00:00.000000'),(145740,1152,'2024-07-07 16:00:00.000000'),(13324,1852,'2024-07-07 16:00:00.000000'),(8,236,'2024-07-07 16:00:00.000000'),(79843,4568,'2024-07-07 16:00:00.000000'),(86090,800,'2024-07-07 16:00:00.000000'),(106,15440,'2024-07-07 16:00:00.000000'),(97,7527,'2024-07-07 16:00:00.000000'),(379005,7170,'2024-07-07 16:00:00.000000'),(374757,2390,'2024-07-07 16:00:00.000000'),(169095,0,'2024-07-07 16:00:00.000000'),(69379,1655,'2024-07-07 16:00:00.000000'),(120,472,'2024-07-07 16:00:00.000000'),(345300,2477,'2024-07-07 16:00:00.000000'),(336963,205,'2024-07-07 16:00:00.000000'),(109,7728,'2024-07-07 16:00:00.000000'),(2593,693,'2024-07-07 16:00:00.000000'),(148509,1788,'2024-07-07 16:00:00.000000'),(97857,861,'2024-07-07 16:00:00.000000'),(93579,49,'2024-07-07 16:00:00.000000'),(11,-294,'2024-07-07 16:00:00.000000'),(61,2807,'2024-07-07 16:00:00.000000'),(1258,651,'2024-07-07 16:00:00.000000'),(77377,1272,'2024-07-07 16:00:00.000000'),(293753,619,'2024-07-07 16:00:00.000000'),(29980,961,'2024-07-07 16:00:00.000000'),(101,1009,'2024-07-07 16:00:00.000000'),(87907,3264,'2024-07-07 16:00:00.000000'),(367375,60,'2024-07-07 16:00:00.000000'),(320517,28,'2024-07-07 16:00:00.000000'),(20,400,'2024-07-07 16:00:00.000000'),(342468,696,'2024-07-07 16:00:00.000000'),(7,707,'2024-07-07 16:00:00.000000'),(352924,234,'2024-07-07 16:00:00.000000'),(249042,5852,'2024-07-07 16:00:00.000000'),(40441,543,'2024-07-07 16:00:00.000000'),(142,666,'2024-07-07 16:00:00.000000'),(338334,60,'2024-07-07 16:00:00.000000'),(65,0,'2024-07-07 16:00:00.000000'),(270232,277,'2024-07-07 16:00:00.000000'),(85,234,'2024-07-07 16:00:00.000000'),(19316,1320,'2024-07-07 16:00:00.000000'),(75,360,'2024-07-07 16:00:00.000000'),(1649,5640,'2024-07-07 16:00:00.000000'),(132,236,'2024-07-07 16:00:00.000000'),(1471,0,'2024-07-07 16:00:00.000000'),(16311,392,'2024-07-07 16:00:00.000000'),(123,1127,'2024-07-07 16:00:00.000000'),(213014,2384,'2024-07-07 16:00:00.000000'),(73,912,'2024-07-07 16:00:00.000000'),(90281,4688,'2024-07-07 16:00:00.000000'),(335577,918,'2024-07-07 16:00:00.000000'),(242263,768,'2024-07-07 16:00:00.000000'),(240225,234,'2024-07-07 16:00:00.000000'),(4,472,'2024-07-07 16:00:00.000000'),(44,1901,'2024-07-07 16:00:00.000000'),(175834,1055,'2024-07-07 16:00:00.000000'),(218851,2496,'2024-07-07 16:00:00.000000'),(338605,197,'2024-07-07 16:00:00.000000'),(94,118,'2024-07-07 16:00:00.000000'),(329947,478,'2024-07-07 16:00:00.000000'),(144384,120,'2024-07-07 16:00:00.000000'),(91236,552,'2024-07-07 16:00:00.000000'),(87404,1060,'2024-07-07 16:00:00.000000'),(310356,234,'2024-07-07 16:00:00.000000'),(337626,239,'2024-07-07 16:00:00.000000'),(267713,290,'2024-07-07 16:00:00.000000'),(226924,1348,'2024-07-07 16:00:00.000000'),(163374,232,'2024-07-07 16:00:00.000000'),(140,236,'2024-07-07 16:00:00.000000'),(79,114,'2024-07-07 16:00:00.000000'),(139,1113,'2024-07-07 16:00:00.000000'),(113,354,'2024-07-07 16:00:00.000000'),(69,1740,'2024-07-07 16:00:00.000000'),(92,408,'2024-07-07 16:00:00.000000'),(354236,120,'2024-07-07 16:00:00.000000'),(353051,273,'2024-07-07 16:00:00.000000'),(348500,234,'2024-07-07 16:00:00.000000'),(217606,0,'2024-07-07 16:00:00.000000'),(376093,232,'2024-07-07 16:00:00.000000'),(77,294,'2024-07-07 16:00:00.000000'),(103920,600,'2024-07-07 16:00:00.000000'),(352787,348,'2024-07-07 16:00:00.000000'),(267884,1842,'2024-07-07 16:00:00.000000'),(195763,104,'2024-07-07 16:00:00.000000'),(186083,55,'2024-07-07 16:00:00.000000'),(341103,174,'2024-07-07 16:00:00.000000'),(202826,0,'2024-07-07 16:00:00.000000'),(81,60,'2024-07-07 16:00:00.000000'),(63,1678,'2024-07-07 16:00:00.000000'),(348991,114,'2024-07-07 16:00:00.000000'),(174440,624,'2024-07-07 16:00:00.000000'),(344844,60,'2024-07-07 16:00:00.000000'),(51609,2272,'2024-07-07 16:00:00.000000'),(146545,1452,'2024-07-07 16:00:00.000000'),(185893,234,'2024-07-07 16:00:00.000000'),(146166,300,'2024-07-07 16:00:00.000000'),(26283,0,'2024-07-07 16:00:00.000000'),(141,0,'2024-07-07 16:00:00.000000'),(25,474,'2024-07-07 16:00:00.000000'),(102,359,'2024-07-07 16:00:00.000000'),(9,240,'2024-07-07 16:00:00.000000'),(146340,210,'2024-07-07 16:00:00.000000'),(66,240,'2024-07-07 16:00:00.000000'),(15,50,'2024-07-07 16:00:00.000000'),(137,408,'2024-07-07 16:00:00.000000'),(164,136,'2024-07-07 16:00:00.000000'),(182308,31620,'2024-07-08 16:00:00.000000'),(73857,14634,'2024-07-08 16:00:00.000000'),(376093,105,'2024-07-08 16:00:00.000000'),(159,4840,'2024-07-08 16:00:00.000000'),(249042,2435,'2024-07-08 16:00:00.000000'),(78740,2273,'2024-07-08 16:00:00.000000'),(67019,9038,'2024-07-08 16:00:00.000000'),(270888,12282,'2024-07-08 16:00:00.000000'),(97,8383,'2024-07-08 16:00:00.000000'),(303906,9148,'2024-07-08 16:00:00.000000'),(348187,9268,'2024-07-08 16:00:00.000000'),(159566,6379,'2024-07-08 16:00:00.000000'),(160616,45,'2024-07-08 16:00:00.000000'),(73,1026,'2024-07-08 16:00:00.000000'),(190618,400,'2024-07-08 16:00:00.000000'),(148509,2283,'2024-07-08 16:00:00.000000'),(6069,37656,'2024-07-08 16:00:00.000000'),(379005,2742,'2024-07-08 16:00:00.000000'),(374757,914,'2024-07-08 16:00:00.000000'),(269339,8760,'2024-07-08 16:00:00.000000'),(106148,9089,'2024-07-08 16:00:00.000000'),(274697,885,'2024-07-08 16:00:00.000000'),(268954,10546,'2024-07-08 16:00:00.000000'),(3940,23525,'2024-07-08 16:00:00.000000'),(143961,10149,'2024-07-08 16:00:00.000000'),(14573,7136,'2024-07-08 16:00:00.000000'),(269583,7238,'2024-07-08 16:00:00.000000'),(227196,7320,'2024-07-08 16:00:00.000000'),(31476,3106,'2024-07-08 16:00:00.000000'),(1958,3792,'2024-07-08 16:00:00.000000'),(44,243,'2024-07-08 16:00:00.000000'),(140,0,'2024-07-08 16:00:00.000000'),(213014,1288,'2024-07-08 16:00:00.000000'),(91236,1728,'2024-07-08 16:00:00.000000'),(123,1485,'2024-07-08 16:00:00.000000'),(29980,1377,'2024-07-08 16:00:00.000000'),(161609,3648,'2024-07-08 16:00:00.000000'),(179782,359,'2024-07-08 16:00:00.000000'),(77377,1264,'2024-07-08 16:00:00.000000'),(354236,1896,'2024-07-08 16:00:00.000000'),(340532,1034,'2024-07-08 16:00:00.000000'),(346331,407,'2024-07-08 16:00:00.000000'),(336963,223,'2024-07-08 16:00:00.000000'),(326483,10956,'2024-07-08 16:00:00.000000'),(106,19160,'2024-07-08 16:00:00.000000'),(164630,2560,'2024-07-08 16:00:00.000000'),(103920,1200,'2024-07-08 16:00:00.000000'),(13324,929,'2024-07-08 16:00:00.000000'),(69379,1495,'2024-07-08 16:00:00.000000'),(342468,1896,'2024-07-08 16:00:00.000000'),(367375,60,'2024-07-08 16:00:00.000000'),(320517,351,'2024-07-08 16:00:00.000000'),(81,300,'2024-07-08 16:00:00.000000'),(74,7954,'2024-07-08 16:00:00.000000'),(121,479,'2024-07-08 16:00:00.000000'),(132,0,'2024-07-08 16:00:00.000000'),(77,10950,'2024-07-08 16:00:00.000000'),(142,826,'2024-07-08 16:00:00.000000'),(353051,4161,'2024-07-08 16:00:00.000000'),(345300,1540,'2024-07-08 16:00:00.000000'),(93,5459,'2024-07-08 16:00:00.000000'),(352007,784,'2024-07-08 16:00:00.000000'),(210852,474,'2024-07-08 16:00:00.000000'),(48900,0,'2024-07-08 16:00:00.000000'),(20,240,'2024-07-08 16:00:00.000000'),(338605,816,'2024-07-08 16:00:00.000000'),(87907,1088,'2024-07-08 16:00:00.000000'),(242263,1536,'2024-07-08 16:00:00.000000'),(144384,298,'2024-07-08 16:00:00.000000'),(163374,477,'2024-07-08 16:00:00.000000'),(94,0,'2024-07-08 16:00:00.000000'),(341834,239,'2024-07-08 16:00:00.000000'),(273575,34,'2024-07-08 16:00:00.000000'),(280318,208,'2024-07-08 16:00:00.000000'),(175834,1666,'2024-07-08 16:00:00.000000'),(218851,416,'2024-07-08 16:00:00.000000'),(102,1077,'2024-07-08 16:00:00.000000'),(9,419,'2024-07-08 16:00:00.000000'),(90281,8480,'2024-07-08 16:00:00.000000'),(52499,792,'2024-07-08 16:00:00.000000'),(66,240,'2024-07-08 16:00:00.000000'),(345859,1147,'2024-07-08 16:00:00.000000'),(145740,1002,'2024-07-08 16:00:00.000000'),(352921,474,'2024-07-08 16:00:00.000000'),(1649,4848,'2024-07-08 16:00:00.000000'),(61,2676,'2024-07-08 16:00:00.000000'),(293753,4975,'2024-07-08 16:00:00.000000'),(75,653,'2024-07-08 16:00:00.000000'),(79843,673,'2024-07-08 16:00:00.000000'),(86090,118,'2024-07-08 16:00:00.000000'),(63,239,'2024-07-08 16:00:00.000000'),(328717,68,'2024-07-08 16:00:00.000000'),(342076,80,'2024-07-08 16:00:00.000000'),(195763,182,'2024-07-08 16:00:00.000000'),(186083,96,'2024-07-08 16:00:00.000000'),(120,1558,'2024-07-08 16:00:00.000000'),(153632,557,'2024-07-08 16:00:00.000000'),(5349,238,'2024-07-08 16:00:00.000000'),(40441,80,'2024-07-08 16:00:00.000000'),(109,942,'2024-07-08 16:00:00.000000'),(2593,354,'2024-07-08 16:00:00.000000'),(330205,0,'2024-07-08 16:00:00.000000'),(8,592,'2024-07-08 16:00:00.000000'),(87404,1060,'2024-07-08 16:00:00.000000'),(352787,4290,'2024-07-08 16:00:00.000000'),(336947,167,'2024-07-08 16:00:00.000000'),(329947,1967,'2024-07-08 16:00:00.000000'),(185893,90,'2024-07-08 16:00:00.000000'),(174440,1096,'2024-07-08 16:00:00.000000'),(37634,312,'2024-07-08 16:00:00.000000'),(335577,612,'2024-07-08 16:00:00.000000'),(898,336,'2024-07-08 16:00:00.000000'),(141,3520,'2024-07-08 16:00:00.000000'),(148,359,'2024-07-08 16:00:00.000000'),(97857,1771,'2024-07-08 16:00:00.000000'),(93579,101,'2024-07-08 16:00:00.000000'),(138,348,'2024-07-08 16:00:00.000000'),(164,388,'2024-07-08 16:00:00.000000'),(137,816,'2024-07-08 16:00:00.000000'),(146166,150,'2024-07-08 16:00:00.000000'),(169095,150,'2024-07-08 16:00:00.000000'),(48,414,'2024-07-08 16:00:00.000000'),(26283,1440,'2024-07-08 16:00:00.000000'),(146545,150,'2024-07-08 16:00:00.000000'),(357181,474,'2024-07-08 16:00:00.000000'),(51609,624,'2024-07-08 16:00:00.000000'),(95,3582,'2024-07-08 16:00:00.000000'),(139,359,'2024-07-08 16:00:00.000000'),(270602,277,'2024-07-08 16:00:00.000000'),(101,359,'2024-07-08 16:00:00.000000'),(366194,2447,'2024-07-08 16:00:00.000000'),(113,479,'2024-07-08 16:00:00.000000'),(275013,474,'2024-07-08 16:00:00.000000'),(342969,0,'2024-07-08 16:00:00.000000'),(19316,792,'2024-07-08 16:00:00.000000'),(269583,667,'2024-07-09 16:00:00.000000'),(106148,4023,'2024-07-09 16:00:00.000000'),(190618,1209,'2024-07-09 16:00:00.000000'),(106,23280,'2024-07-09 16:00:00.000000'),(77377,3088,'2024-07-09 16:00:00.000000'),(31476,5496,'2024-07-09 16:00:00.000000'),(303906,10013,'2024-07-09 16:00:00.000000'),(182308,20820,'2024-07-09 16:00:00.000000'),(73857,11038,'2024-07-09 16:00:00.000000'),(270888,12294,'2024-07-09 16:00:00.000000'),(293753,4787,'2024-07-09 16:00:00.000000'),(159,3643,'2024-07-09 16:00:00.000000'),(345859,245,'2024-07-09 16:00:00.000000'),(242263,1536,'2024-07-09 16:00:00.000000'),(159566,8248,'2024-07-09 16:00:00.000000'),(160616,57,'2024-07-09 16:00:00.000000'),(109,2718,'2024-07-09 16:00:00.000000'),(2593,227,'2024-07-09 16:00:00.000000'),(14573,12256,'2024-07-09 16:00:00.000000'),(3940,10682,'2024-07-09 16:00:00.000000'),(269339,8560,'2024-07-09 16:00:00.000000'),(164630,1392,'2024-07-09 16:00:00.000000'),(354236,4974,'2024-07-09 16:00:00.000000'),(340532,1215,'2024-07-09 16:00:00.000000'),(346331,495,'2024-07-09 16:00:00.000000'),(336963,584,'2024-07-09 16:00:00.000000'),(78740,3102,'2024-07-09 16:00:00.000000'),(348187,3087,'2024-07-09 16:00:00.000000'),(44,549,'2024-07-09 16:00:00.000000'),(67019,6806,'2024-07-09 16:00:00.000000'),(93,11161,'2024-07-09 16:00:00.000000'),(148509,2872,'2024-07-09 16:00:00.000000'),(143961,7625,'2024-07-09 16:00:00.000000'),(268954,846,'2024-07-09 16:00:00.000000'),(249042,3219,'2024-07-09 16:00:00.000000'),(102,4837,'2024-07-09 16:00:00.000000'),(335577,0,'2024-07-09 16:00:00.000000'),(139,1436,'2024-07-09 16:00:00.000000'),(121,5383,'2024-07-09 16:00:00.000000'),(29980,3557,'2024-07-09 16:00:00.000000'),(360412,210,'2024-07-09 16:00:00.000000'),(141,1126,'2024-07-09 16:00:00.000000'),(103920,2605,'2024-07-09 16:00:00.000000'),(13324,1191,'2024-07-09 16:00:00.000000'),(6069,16767,'2024-07-09 16:00:00.000000'),(119,1077,'2024-07-09 16:00:00.000000'),(120,3125,'2024-07-09 16:00:00.000000'),(227196,2752,'2024-07-09 16:00:00.000000'),(345300,3496,'2024-07-09 16:00:00.000000'),(1958,9696,'2024-07-09 16:00:00.000000'),(326483,10674,'2024-07-09 16:00:00.000000'),(51609,1416,'2024-07-09 16:00:00.000000'),(137,816,'2024-07-09 16:00:00.000000'),(164,272,'2024-07-09 16:00:00.000000'),(73,4428,'2024-07-09 16:00:00.000000'),(67383,412,'2024-07-09 16:00:00.000000'),(20,80,'2024-07-09 16:00:00.000000'),(79843,1346,'2024-07-09 16:00:00.000000'),(86090,236,'2024-07-09 16:00:00.000000'),(213014,800,'2024-07-09 16:00:00.000000'),(101,778,'2024-07-09 16:00:00.000000'),(185893,120,'2024-07-09 16:00:00.000000'),(90281,3216,'2024-07-09 16:00:00.000000'),(357181,1896,'2024-07-09 16:00:00.000000'),(320517,124,'2024-07-09 16:00:00.000000'),(74,592,'2024-07-09 16:00:00.000000'),(4,2813,'2024-07-09 16:00:00.000000'),(357669,594,'2024-07-09 16:00:00.000000'),(336947,57,'2024-07-09 16:00:00.000000'),(1649,2760,'2024-07-09 16:00:00.000000'),(87907,1632,'2024-07-09 16:00:00.000000'),(37634,2280,'2024-07-09 16:00:00.000000'),(293390,840,'2024-07-09 16:00:00.000000'),(1258,57,'2024-07-09 16:00:00.000000'),(163374,1108,'2024-07-09 16:00:00.000000'),(161609,1319,'2024-07-09 16:00:00.000000'),(61,4024,'2024-07-09 16:00:00.000000'),(97,2792,'2024-07-09 16:00:00.000000'),(240225,594,'2024-07-09 16:00:00.000000'),(69379,1094,'2024-07-09 16:00:00.000000'),(91236,2776,'2024-07-09 16:00:00.000000'),(132,1257,'2024-07-09 16:00:00.000000'),(40441,392,'2024-07-09 16:00:00.000000'),(87404,469,'2024-07-09 16:00:00.000000'),(218851,2080,'2024-07-09 16:00:00.000000'),(8,2242,'2024-07-09 16:00:00.000000'),(348991,474,'2024-07-09 16:00:00.000000'),(175834,4164,'2024-07-09 16:00:00.000000'),(142,301,'2024-07-09 16:00:00.000000'),(57245,2304,'2024-07-09 16:00:00.000000'),(135,414,'2024-07-09 16:00:00.000000'),(169095,501,'2024-07-09 16:00:00.000000'),(24582,856,'2024-07-09 16:00:00.000000'),(352007,1665,'2024-07-09 16:00:00.000000'),(113,2831,'2024-07-09 16:00:00.000000'),(79,114,'2024-07-09 16:00:00.000000'),(379005,1824,'2024-07-09 16:00:00.000000'),(374757,608,'2024-07-09 16:00:00.000000'),(192434,534,'2024-07-09 16:00:00.000000'),(118,474,'2024-07-09 16:00:00.000000'),(270602,1108,'2024-07-09 16:00:00.000000'),(77,712,'2024-07-09 16:00:00.000000'),(82,600,'2024-07-09 16:00:00.000000'),(92,359,'2024-07-09 16:00:00.000000'),(353051,2524,'2024-07-09 16:00:00.000000'),(63,1674,'2024-07-09 16:00:00.000000'),(267884,0,'2024-07-09 16:00:00.000000'),(69,954,'2024-07-09 16:00:00.000000'),(358886,474,'2024-07-09 16:00:00.000000'),(75,288,'2024-07-09 16:00:00.000000'),(254325,24,'2024-07-09 16:00:00.000000'),(123,1066,'2024-07-09 16:00:00.000000'),(275013,2386,'2024-07-09 16:00:00.000000'),(146545,300,'2024-07-09 16:00:00.000000'),(376093,232,'2024-07-09 16:00:00.000000'),(97857,734,'2024-07-09 16:00:00.000000'),(93579,42,'2024-07-09 16:00:00.000000'),(342468,594,'2024-07-09 16:00:00.000000'),(217860,480,'2024-07-09 16:00:00.000000'),(145740,798,'2024-07-09 16:00:00.000000'),(146166,150,'2024-07-09 16:00:00.000000'),(380316,696,'2024-07-09 16:00:00.000000'),(153632,1049,'2024-07-09 16:00:00.000000'),(5349,449,'2024-07-09 16:00:00.000000'),(11,179,'2024-07-09 16:00:00.000000'),(206580,68,'2024-07-09 16:00:00.000000'),(34,234,'2024-07-09 16:00:00.000000'),(267713,290,'2024-07-09 16:00:00.000000'),(66,414,'2024-07-09 16:00:00.000000'),(195763,104,'2024-07-09 16:00:00.000000'),(186083,55,'2024-07-09 16:00:00.000000'),(269632,69,'2024-07-09 16:00:00.000000'),(338605,197,'2024-07-09 16:00:00.000000'),(65,246,'2024-07-09 16:00:00.000000'),(99,359,'2024-07-09 16:00:00.000000'),(95,594,'2024-07-09 16:00:00.000000'),(182308,19260,'2024-07-10 16:00:00.000000'),(73857,11310,'2024-07-10 16:00:00.000000'),(95,4608,'2024-07-10 16:00:00.000000'),(14573,14286,'2024-07-10 16:00:00.000000'),(326483,15166,'2024-07-10 16:00:00.000000'),(159,4525,'2024-07-10 16:00:00.000000'),(270888,14670,'2024-07-10 16:00:00.000000'),(145740,3299,'2024-07-10 16:00:00.000000'),(13324,2329,'2024-07-10 16:00:00.000000'),(109,4212,'2024-07-10 16:00:00.000000'),(2593,1097,'2024-07-10 16:00:00.000000'),(102,767,'2024-07-10 16:00:00.000000'),(6069,5656,'2024-07-10 16:00:00.000000'),(159566,15201,'2024-07-10 16:00:00.000000'),(160616,124,'2024-07-10 16:00:00.000000'),(161609,1168,'2024-07-10 16:00:00.000000'),(63,1956,'2024-07-10 16:00:00.000000'),(67019,9100,'2024-07-10 16:00:00.000000'),(143961,9218,'2024-07-10 16:00:00.000000'),(103920,1200,'2024-07-10 16:00:00.000000'),(87404,1413,'2024-07-10 16:00:00.000000'),(93,2402,'2024-07-10 16:00:00.000000'),(303906,5758,'2024-07-10 16:00:00.000000'),(164630,928,'2024-07-10 16:00:00.000000'),(3940,21313,'2024-07-10 16:00:00.000000'),(106148,7893,'2024-07-10 16:00:00.000000'),(185893,4242,'2024-07-10 16:00:00.000000'),(78740,7354,'2024-07-10 16:00:00.000000'),(352007,1218,'2024-07-10 16:00:00.000000'),(77377,5152,'2024-07-10 16:00:00.000000'),(358886,1422,'2024-07-10 16:00:00.000000'),(336947,303,'2024-07-10 16:00:00.000000'),(340532,3124,'2024-07-10 16:00:00.000000'),(346331,1121,'2024-07-10 16:00:00.000000'),(269339,12656,'2024-07-10 16:00:00.000000'),(345859,742,'2024-07-10 16:00:00.000000'),(65,-246,'2024-07-10 16:00:00.000000'),(119,718,'2024-07-10 16:00:00.000000'),(120,838,'2024-07-10 16:00:00.000000'),(218851,2496,'2024-07-10 16:00:00.000000'),(69379,1432,'2024-07-10 16:00:00.000000'),(190618,596,'2024-07-10 16:00:00.000000'),(1958,17160,'2024-07-10 16:00:00.000000'),(106,20552,'2024-07-10 16:00:00.000000'),(269583,842,'2024-07-10 16:00:00.000000'),(354236,3960,'2024-07-10 16:00:00.000000'),(336963,412,'2024-07-10 16:00:00.000000'),(249042,12334,'2024-07-10 16:00:00.000000'),(97857,870,'2024-07-10 16:00:00.000000'),(93579,49,'2024-07-10 16:00:00.000000'),(348187,7434,'2024-07-10 16:00:00.000000'),(148509,2240,'2024-07-10 16:00:00.000000'),(139,1077,'2024-07-10 16:00:00.000000'),(34,468,'2024-07-10 16:00:00.000000'),(137,2448,'2024-07-10 16:00:00.000000'),(164,816,'2024-07-10 16:00:00.000000'),(91236,688,'2024-07-10 16:00:00.000000'),(37634,3472,'2024-07-10 16:00:00.000000'),(227196,3344,'2024-07-10 16:00:00.000000'),(141,13251,'2024-07-10 16:00:00.000000'),(121,479,'2024-07-10 16:00:00.000000'),(268954,5989,'2024-07-10 16:00:00.000000'),(97,6407,'2024-07-10 16:00:00.000000'),(73,2068,'2024-07-10 16:00:00.000000'),(66,414,'2024-07-10 16:00:00.000000'),(338605,2026,'2024-07-10 16:00:00.000000'),(240225,1188,'2024-07-10 16:00:00.000000'),(31476,1792,'2024-07-10 16:00:00.000000'),(61,3262,'2024-07-10 16:00:00.000000'),(379005,858,'2024-07-10 16:00:00.000000'),(374757,286,'2024-07-10 16:00:00.000000'),(123,838,'2024-07-10 16:00:00.000000'),(329947,357,'2024-07-10 16:00:00.000000'),(26283,3360,'2024-07-10 16:00:00.000000'),(113,958,'2024-07-10 16:00:00.000000'),(135,3222,'2024-07-10 16:00:00.000000'),(142,717,'2024-07-10 16:00:00.000000'),(226924,594,'2024-07-10 16:00:00.000000'),(111,359,'2024-07-10 16:00:00.000000'),(144384,474,'2024-07-10 16:00:00.000000'),(376093,232,'2024-07-10 16:00:00.000000'),(1649,1104,'2024-07-10 16:00:00.000000'),(101,1436,'2024-07-10 16:00:00.000000'),(195763,104,'2024-07-10 16:00:00.000000'),(186083,55,'2024-07-10 16:00:00.000000'),(1471,792,'2024-07-10 16:00:00.000000'),(82,1008,'2024-07-10 16:00:00.000000'),(175834,2220,'2024-07-10 16:00:00.000000'),(293753,2636,'2024-07-10 16:00:00.000000'),(213014,2432,'2024-07-10 16:00:00.000000'),(270602,2143,'2024-07-10 16:00:00.000000'),(320610,408,'2024-07-10 16:00:00.000000'),(90281,-1520,'2024-07-10 16:00:00.000000'),(94,359,'2024-07-10 16:00:00.000000'),(44,542,'2024-07-10 16:00:00.000000'),(370070,5328,'2024-07-10 16:00:00.000000'),(345300,1900,'2024-07-10 16:00:00.000000'),(75,659,'2024-07-10 16:00:00.000000'),(275013,592,'2024-07-10 16:00:00.000000'),(77,594,'2024-07-10 16:00:00.000000'),(273575,55,'2024-07-10 16:00:00.000000'),(380316,3208,'2024-07-10 16:00:00.000000'),(242263,3784,'2024-07-10 16:00:00.000000'),(151,359,'2024-07-10 16:00:00.000000'),(269632,1354,'2024-07-10 16:00:00.000000'),(69,474,'2024-07-10 16:00:00.000000'),(342468,12156,'2024-07-10 16:00:00.000000'),(74,3594,'2024-07-10 16:00:00.000000'),(148,359,'2024-07-10 16:00:00.000000'),(89,359,'2024-07-10 16:00:00.000000'),(79843,265,'2024-07-10 16:00:00.000000'),(86090,46,'2024-07-10 16:00:00.000000'),(352787,474,'2024-07-10 16:00:00.000000'),(320517,93,'2024-07-10 16:00:00.000000'),(1258,1668,'2024-07-10 16:00:00.000000'),(209473,207,'2024-07-10 16:00:00.000000'),(366194,3342,'2024-07-10 16:00:00.000000'),(335577,1836,'2024-07-10 16:00:00.000000'),(87907,1088,'2024-07-10 16:00:00.000000'),(898,464,'2024-07-10 16:00:00.000000'),(163374,159,'2024-07-10 16:00:00.000000'),(9,177,'2024-07-10 16:00:00.000000'),(357181,948,'2024-07-10 16:00:00.000000'),(206580,68,'2024-07-10 16:00:00.000000'),(280318,556,'2024-07-10 16:00:00.000000'),(48,474,'2024-07-10 16:00:00.000000'),(352924,474,'2024-07-10 16:00:00.000000'),(146166,150,'2024-07-10 16:00:00.000000'),(92,359,'2024-07-10 16:00:00.000000'),(328717,554,'2024-07-10 16:00:00.000000'),(378518,1424,'2024-07-10 16:00:00.000000'),(146340,210,'2024-07-10 16:00:00.000000'),(7,288,'2024-07-10 16:00:00.000000'),(353051,140,'2024-07-10 16:00:00.000000'),(274697,277,'2024-07-10 16:00:00.000000'),(40441,80,'2024-07-10 16:00:00.000000'),(4,2394,'2024-07-10 16:00:00.000000'),(283,0,'2024-07-10 16:00:00.000000'),(169095,201,'2024-07-10 16:00:00.000000'),(344844,0,'2024-07-10 16:00:00.000000'),(29980,209,'2024-07-10 16:00:00.000000'),(182308,51480,'2024-07-11 16:00:00.000000'),(73857,23262,'2024-07-11 16:00:00.000000'),(348187,10661,'2024-07-11 16:00:00.000000'),(159,2543,'2024-07-11 16:00:00.000000'),(148509,4868,'2024-07-11 16:00:00.000000'),(78740,2651,'2024-07-11 16:00:00.000000'),(87907,5440,'2024-07-11 16:00:00.000000'),(31476,1612,'2024-07-11 16:00:00.000000'),(303906,3695,'2024-07-11 16:00:00.000000'),(270888,18306,'2024-07-11 16:00:00.000000'),(6069,75116,'2024-07-11 16:00:00.000000'),(143961,4868,'2024-07-11 16:00:00.000000'),(14573,13714,'2024-07-11 16:00:00.000000'),(106,11704,'2024-07-11 16:00:00.000000'),(190618,1273,'2024-07-11 16:00:00.000000'),(74,18844,'2024-07-11 16:00:00.000000'),(67019,11656,'2024-07-11 16:00:00.000000'),(269583,1018,'2024-07-11 16:00:00.000000'),(106148,9501,'2024-07-11 16:00:00.000000'),(267713,136,'2024-07-11 16:00:00.000000'),(44,4705,'2024-07-11 16:00:00.000000'),(159566,12424,'2024-07-11 16:00:00.000000'),(160616,90,'2024-07-11 16:00:00.000000'),(338605,197,'2024-07-11 16:00:00.000000'),(123,2933,'2024-07-11 16:00:00.000000'),(269339,18026,'2024-07-11 16:00:00.000000'),(51609,-1416,'2024-07-11 16:00:00.000000'),(268954,7082,'2024-07-11 16:00:00.000000'),(137,816,'2024-07-11 16:00:00.000000'),(164,272,'2024-07-11 16:00:00.000000'),(379005,1482,'2024-07-11 16:00:00.000000'),(374757,498,'2024-07-11 16:00:00.000000'),(82,828,'2024-07-11 16:00:00.000000'),(293753,1877,'2024-07-11 16:00:00.000000'),(354236,6612,'2024-07-11 16:00:00.000000'),(340532,1011,'2024-07-11 16:00:00.000000'),(346331,348,'2024-07-11 16:00:00.000000'),(336963,495,'2024-07-11 16:00:00.000000'),(195763,104,'2024-07-11 16:00:00.000000'),(186083,55,'2024-07-11 16:00:00.000000'),(1649,5560,'2024-07-11 16:00:00.000000'),(275013,2860,'2024-07-11 16:00:00.000000'),(249042,598,'2024-07-11 16:00:00.000000'),(103920,900,'2024-07-11 16:00:00.000000'),(13324,2409,'2024-07-11 16:00:00.000000'),(269632,1631,'2024-07-11 16:00:00.000000'),(169095,1902,'2024-07-11 16:00:00.000000'),(342468,414,'2024-07-11 16:00:00.000000'),(26283,3120,'2024-07-11 16:00:00.000000'),(326483,5056,'2024-07-11 16:00:00.000000'),(3940,17279,'2024-07-11 16:00:00.000000'),(90281,2112,'2024-07-11 16:00:00.000000'),(148,359,'2024-07-11 16:00:00.000000'),(40441,213,'2024-07-11 16:00:00.000000'),(119,1795,'2024-07-11 16:00:00.000000'),(209473,346,'2024-07-11 16:00:00.000000'),(206580,205,'2024-07-11 16:00:00.000000'),(93,3634,'2024-07-11 16:00:00.000000'),(1958,11400,'2024-07-11 16:00:00.000000'),(335577,1224,'2024-07-11 16:00:00.000000'),(2593,684,'2024-07-11 16:00:00.000000'),(132,359,'2024-07-11 16:00:00.000000'),(61,4801,'2024-07-11 16:00:00.000000'),(96,359,'2024-07-11 16:00:00.000000'),(352007,14,'2024-07-11 16:00:00.000000'),(382101,716,'2024-07-11 16:00:00.000000'),(336947,152,'2024-07-11 16:00:00.000000'),(357669,0,'2024-07-11 16:00:00.000000'),(77377,3344,'2024-07-11 16:00:00.000000'),(91236,168,'2024-07-11 16:00:00.000000'),(213014,824,'2024-07-11 16:00:00.000000'),(64,354,'2024-07-11 16:00:00.000000'),(274697,0,'2024-07-11 16:00:00.000000'),(79843,1346,'2024-07-11 16:00:00.000000'),(86090,236,'2024-07-11 16:00:00.000000'),(393529,12,'2024-07-11 16:00:00.000000'),(227196,1440,'2024-07-11 16:00:00.000000'),(29980,617,'2024-07-11 16:00:00.000000'),(120,312,'2024-07-11 16:00:00.000000'),(358886,948,'2024-07-11 16:00:00.000000'),(280318,104,'2024-07-11 16:00:00.000000'),(24582,712,'2024-07-11 16:00:00.000000'),(135,414,'2024-07-11 16:00:00.000000'),(142,432,'2024-07-11 16:00:00.000000'),(161609,3520,'2024-07-11 16:00:00.000000'),(163374,232,'2024-07-11 16:00:00.000000'),(390102,236,'2024-07-11 16:00:00.000000'),(328717,554,'2024-07-11 16:00:00.000000'),(75,1589,'2024-07-11 16:00:00.000000'),(109,942,'2024-07-11 16:00:00.000000'),(341834,2567,'2024-07-11 16:00:00.000000'),(345300,594,'2024-07-11 16:00:00.000000'),(63,3144,'2024-07-11 16:00:00.000000'),(69,822,'2024-07-11 16:00:00.000000'),(345859,182,'2024-07-11 16:00:00.000000'),(308732,317,'2024-07-11 16:00:00.000000'),(270602,827,'2024-07-11 16:00:00.000000'),(320610,522,'2024-07-11 16:00:00.000000'),(28,50,'2024-07-11 16:00:00.000000'),(87404,1611,'2024-07-11 16:00:00.000000'),(69379,480,'2024-07-11 16:00:00.000000'),(79,114,'2024-07-11 16:00:00.000000'),(92,359,'2024-07-11 16:00:00.000000'),(175834,708,'2024-07-11 16:00:00.000000'),(393152,118,'2024-07-11 16:00:00.000000'),(320517,25,'2024-07-11 16:00:00.000000'),(270017,271,'2024-07-11 16:00:00.000000'),(338334,177,'2024-07-11 16:00:00.000000'),(4,23328,'2024-07-11 16:00:00.000000'),(101,1605,'2024-07-11 16:00:00.000000'),(95,2988,'2024-07-11 16:00:00.000000'),(141,838,'2024-07-11 16:00:00.000000'),(242263,304,'2024-07-11 16:00:00.000000'),(146166,1800,'2024-07-11 16:00:00.000000'),(389928,59,'2024-07-11 16:00:00.000000'),(279951,7,'2024-07-11 16:00:00.000000'),(353051,280,'2024-07-11 16:00:00.000000'),(366194,274,'2024-07-11 16:00:00.000000'),(145740,300,'2024-07-11 16:00:00.000000'),(97,1760,'2024-07-11 16:00:00.000000'),(34,234,'2024-07-11 16:00:00.000000'),(380316,696,'2024-07-11 16:00:00.000000'),(174440,312,'2024-07-11 16:00:00.000000'),(381577,478,'2024-07-11 16:00:00.000000'),(348968,30,'2024-07-11 16:00:00.000000'),(99,359,'2024-07-11 16:00:00.000000'),(26,0,'2024-07-11 16:00:00.000000'),(217606,765,'2024-07-11 16:00:00.000000'),(73,948,'2024-07-11 16:00:00.000000'),(397554,234,'2024-07-11 16:00:00.000000'),(396777,179,'2024-07-11 16:00:00.000000'),(37634,312,'2024-07-11 16:00:00.000000'),(392278,559,'2024-07-11 16:00:00.000000'),(110,474,'2024-07-11 16:00:00.000000'),(5620,528,'2024-07-11 16:00:00.000000'),(93579,105,'2024-07-11 16:00:00.000000'),(67379,224,'2024-07-11 16:00:00.000000'),(267884,222,'2024-07-11 16:00:00.000000'),(87404,938,'2024-07-12 16:00:00.000000'),(14573,6774,'2024-07-12 16:00:00.000000'),(270888,14850,'2024-07-12 16:00:00.000000'),(73857,15050,'2024-07-12 16:00:00.000000'),(190618,1120,'2024-07-12 16:00:00.000000'),(159566,8667,'2024-07-12 16:00:00.000000'),(160616,69,'2024-07-12 16:00:00.000000'),(31476,1792,'2024-07-12 16:00:00.000000'),(303906,5510,'2024-07-12 16:00:00.000000'),(348187,5353,'2024-07-12 16:00:00.000000'),(159,3472,'2024-07-12 16:00:00.000000'),(182308,30300,'2024-07-12 16:00:00.000000'),(185893,-474,'2024-07-12 16:00:00.000000'),(78740,4915,'2024-07-12 16:00:00.000000'),(67019,6742,'2024-07-12 16:00:00.000000'),(63,120,'2024-07-12 16:00:00.000000'),(8,1362,'2024-07-12 16:00:00.000000'),(3940,22962,'2024-07-12 16:00:00.000000'),(106148,15994,'2024-07-12 16:00:00.000000'),(269339,27203,'2024-07-12 16:00:00.000000'),(240225,1188,'2024-07-12 16:00:00.000000'),(1958,2528,'2024-07-12 16:00:00.000000'),(26283,1520,'2024-07-12 16:00:00.000000'),(6069,38415,'2024-07-12 16:00:00.000000'),(87907,3264,'2024-07-12 16:00:00.000000'),(91236,1288,'2024-07-12 16:00:00.000000'),(268954,3563,'2024-07-12 16:00:00.000000'),(227196,4376,'2024-07-12 16:00:00.000000'),(69,2310,'2024-07-12 16:00:00.000000'),(106,14032,'2024-07-12 16:00:00.000000'),(345300,13422,'2024-07-12 16:00:00.000000'),(346331,925,'2024-07-12 16:00:00.000000'),(340532,2480,'2024-07-12 16:00:00.000000'),(336963,1320,'2024-07-12 16:00:00.000000'),(329947,4652,'2024-07-12 16:00:00.000000'),(123,0,'2024-07-12 16:00:00.000000'),(101,718,'2024-07-12 16:00:00.000000'),(366194,822,'2024-07-12 16:00:00.000000'),(381577,828,'2024-07-12 16:00:00.000000'),(348968,54,'2024-07-12 16:00:00.000000'),(336947,301,'2024-07-12 16:00:00.000000'),(119,3112,'2024-07-12 16:00:00.000000'),(389928,946,'2024-07-12 16:00:00.000000'),(279951,119,'2024-07-12 16:00:00.000000'),(74,2186,'2024-07-12 16:00:00.000000'),(93,7123,'2024-07-12 16:00:00.000000'),(92,1664,'2024-07-12 16:00:00.000000'),(120,1427,'2024-07-12 16:00:00.000000'),(148509,3963,'2024-07-12 16:00:00.000000'),(145740,300,'2024-07-12 16:00:00.000000'),(13324,1155,'2024-07-12 16:00:00.000000'),(141,419,'2024-07-12 16:00:00.000000'),(249042,2557,'2024-07-12 16:00:00.000000'),(121,2444,'2024-07-12 16:00:00.000000'),(29980,418,'2024-07-12 16:00:00.000000'),(1649,552,'2024-07-12 16:00:00.000000'),(354236,5244,'2024-07-12 16:00:00.000000'),(44,5575,'2024-07-12 16:00:00.000000'),(97,1257,'2024-07-12 16:00:00.000000'),(320610,408,'2024-07-12 16:00:00.000000'),(217606,69,'2024-07-12 16:00:00.000000'),(75,1176,'2024-07-12 16:00:00.000000'),(396777,358,'2024-07-12 16:00:00.000000'),(320517,258,'2024-07-12 16:00:00.000000'),(393152,1121,'2024-07-12 16:00:00.000000'),(143961,9083,'2024-07-12 16:00:00.000000'),(345859,139,'2024-07-12 16:00:00.000000'),(77377,5416,'2024-07-12 16:00:00.000000'),(326483,18322,'2024-07-12 16:00:00.000000'),(267884,7,'2024-07-12 16:00:00.000000'),(174440,-312,'2024-07-12 16:00:00.000000'),(352921,0,'2024-07-12 16:00:00.000000'),(242263,760,'2024-07-12 16:00:00.000000'),(397554,12282,'2024-07-12 16:00:00.000000'),(335577,358,'2024-07-12 16:00:00.000000'),(2593,227,'2024-07-12 16:00:00.000000'),(270017,340,'2024-07-12 16:00:00.000000'),(90281,1056,'2024-07-12 16:00:00.000000'),(195763,104,'2024-07-12 16:00:00.000000'),(186083,55,'2024-07-12 16:00:00.000000'),(146545,1152,'2024-07-12 16:00:00.000000'),(391886,118,'2024-07-12 16:00:00.000000'),(7,414,'2024-07-12 16:00:00.000000'),(48,768,'2024-07-12 16:00:00.000000'),(79843,938,'2024-07-12 16:00:00.000000'),(86090,164,'2024-07-12 16:00:00.000000'),(140,354,'2024-07-12 16:00:00.000000'),(352787,474,'2024-07-12 16:00:00.000000'),(52499,800,'2024-07-12 16:00:00.000000'),(132,359,'2024-07-12 16:00:00.000000'),(352007,336,'2024-07-12 16:00:00.000000'),(357181,1422,'2024-07-12 16:00:00.000000'),(73,831,'2024-07-12 16:00:00.000000'),(293753,485,'2024-07-12 16:00:00.000000'),(269583,1049,'2024-07-12 16:00:00.000000'),(109,1350,'2024-07-12 16:00:00.000000'),(102,594,'2024-07-12 16:00:00.000000'),(61,4693,'2024-07-12 16:00:00.000000'),(382101,358,'2024-07-12 16:00:00.000000'),(269632,1562,'2024-07-12 16:00:00.000000'),(110,474,'2024-07-12 16:00:00.000000'),(95,594,'2024-07-12 16:00:00.000000'),(399212,413,'2024-07-12 16:00:00.000000'),(341103,0,'2024-07-12 16:00:00.000000'),(267713,68,'2024-07-12 16:00:00.000000'),(328717,277,'2024-07-12 16:00:00.000000'),(379005,120,'2024-07-12 16:00:00.000000'),(374757,40,'2024-07-12 16:00:00.000000'),(146166,450,'2024-07-12 16:00:00.000000'),(275013,2844,'2024-07-12 16:00:00.000000'),(380765,118,'2024-07-12 16:00:00.000000'),(142,436,'2024-07-12 16:00:00.000000'),(135,828,'2024-07-12 16:00:00.000000'),(103920,600,'2024-07-12 16:00:00.000000'),(344844,474,'2024-07-12 16:00:00.000000'),(163374,1744,'2024-07-12 16:00:00.000000'),(338334,118,'2024-07-12 16:00:00.000000'),(82,354,'2024-07-12 16:00:00.000000'),(358886,948,'2024-07-12 16:00:00.000000'),(213014,424,'2024-07-12 16:00:00.000000'),(898,232,'2024-07-12 16:00:00.000000'),(4,419,'2024-07-12 16:00:00.000000'),(34,468,'2024-07-12 16:00:00.000000'),(79,114,'2024-07-12 16:00:00.000000'),(353051,280,'2024-07-12 16:00:00.000000'),(342468,414,'2024-07-12 16:00:00.000000'),(99,359,'2024-07-12 16:00:00.000000'),(19316,792,'2024-07-12 16:00:00.000000'),(24582,712,'2024-07-12 16:00:00.000000'),(371145,162,'2024-07-12 16:00:00.000000'),(97857,734,'2024-07-12 16:00:00.000000'),(93579,42,'2024-07-12 16:00:00.000000'),(164630,384,'2024-07-12 16:00:00.000000'),(338605,197,'2024-07-12 16:00:00.000000'),(3,60,'2024-07-12 16:00:00.000000'),(218851,832,'2024-07-12 16:00:00.000000'),(117,0,'2024-07-12 16:00:00.000000'),(175834,354,'2024-07-12 16:00:00.000000'),(26,0,'2024-07-12 16:00:00.000000'),(356641,594,'2024-07-12 16:00:00.000000'),(139,359,'2024-07-12 16:00:00.000000'),(66,294,'2024-07-12 16:00:00.000000'),(376243,239,'2024-07-12 16:00:00.000000'),(69379,632,'2024-07-12 16:00:00.000000'),(182308,25380,'2024-07-13 16:00:00.000000'),(73857,17456,'2024-07-13 16:00:00.000000'),(66,1294,'2024-07-13 16:00:00.000000'),(67019,9714,'2024-07-13 16:00:00.000000'),(87404,2943,'2024-07-13 16:00:00.000000'),(14573,8831,'2024-07-13 16:00:00.000000'),(6069,47064,'2024-07-13 16:00:00.000000'),(348187,4835,'2024-07-13 16:00:00.000000'),(159,3364,'2024-07-13 16:00:00.000000'),(270888,26988,'2024-07-13 16:00:00.000000'),(146166,2604,'2024-07-13 16:00:00.000000'),(13324,2936,'2024-07-13 16:00:00.000000'),(338605,2223,'2024-07-13 16:00:00.000000'),(269339,19358,'2024-07-13 16:00:00.000000'),(106148,11309,'2024-07-13 16:00:00.000000'),(354236,7668,'2024-07-13 16:00:00.000000'),(340532,1977,'2024-07-13 16:00:00.000000'),(346331,596,'2024-07-13 16:00:00.000000'),(336963,907,'2024-07-13 16:00:00.000000'),(78740,6332,'2024-07-13 16:00:00.000000'),(190618,1689,'2024-07-13 16:00:00.000000'),(120,838,'2024-07-13 16:00:00.000000'),(159566,10229,'2024-07-13 16:00:00.000000'),(160616,80,'2024-07-13 16:00:00.000000'),(275013,17084,'2024-07-13 16:00:00.000000'),(103920,1500,'2024-07-13 16:00:00.000000'),(392278,1759,'2024-07-13 16:00:00.000000'),(106,21824,'2024-07-13 16:00:00.000000'),(93,6061,'2024-07-13 16:00:00.000000'),(303906,6888,'2024-07-13 16:00:00.000000'),(268954,12494,'2024-07-13 16:00:00.000000'),(77377,5512,'2024-07-13 16:00:00.000000'),(242263,3152,'2024-07-13 16:00:00.000000'),(87907,3808,'2024-07-13 16:00:00.000000'),(393152,944,'2024-07-13 16:00:00.000000'),(336947,471,'2024-07-13 16:00:00.000000'),(320517,248,'2024-07-13 16:00:00.000000'),(269583,1005,'2024-07-13 16:00:00.000000'),(227196,4000,'2024-07-13 16:00:00.000000'),(169095,603,'2024-07-13 16:00:00.000000'),(345300,1302,'2024-07-13 16:00:00.000000'),(73,1605,'2024-07-13 16:00:00.000000'),(143961,10218,'2024-07-13 16:00:00.000000'),(97857,4172,'2024-07-13 16:00:00.000000'),(93579,241,'2024-07-13 16:00:00.000000'),(63,1422,'2024-07-13 16:00:00.000000'),(119,5366,'2024-07-13 16:00:00.000000'),(326483,10394,'2024-07-13 16:00:00.000000'),(270602,831,'2024-07-13 16:00:00.000000'),(389928,1253,'2024-07-13 16:00:00.000000'),(279951,161,'2024-07-13 16:00:00.000000'),(97,2563,'2024-07-13 16:00:00.000000'),(163374,2915,'2024-07-13 16:00:00.000000'),(90281,7376,'2024-07-13 16:00:00.000000'),(164630,2640,'2024-07-13 16:00:00.000000'),(148509,560,'2024-07-13 16:00:00.000000'),(74,3344,'2024-07-13 16:00:00.000000'),(338334,118,'2024-07-13 16:00:00.000000'),(26283,1120,'2024-07-13 16:00:00.000000'),(366194,4428,'2024-07-13 16:00:00.000000'),(44,1020,'2024-07-13 16:00:00.000000'),(283,1256,'2024-07-13 16:00:00.000000'),(61,5132,'2024-07-13 16:00:00.000000'),(382101,716,'2024-07-13 16:00:00.000000'),(110,474,'2024-07-13 16:00:00.000000'),(145740,1145,'2024-07-13 16:00:00.000000'),(1958,6512,'2024-07-13 16:00:00.000000'),(357181,948,'2024-07-13 16:00:00.000000'),(399212,354,'2024-07-13 16:00:00.000000'),(320610,870,'2024-07-13 16:00:00.000000'),(3940,17974,'2024-07-13 16:00:00.000000'),(397554,5754,'2024-07-13 16:00:00.000000'),(139,359,'2024-07-13 16:00:00.000000'),(102,1077,'2024-07-13 16:00:00.000000'),(4,2394,'2024-07-13 16:00:00.000000'),(121,1437,'2024-07-13 16:00:00.000000'),(391886,2207,'2024-07-13 16:00:00.000000'),(31476,5501,'2024-07-13 16:00:00.000000'),(396777,358,'2024-07-13 16:00:00.000000'),(175834,642,'2024-07-13 16:00:00.000000'),(142,42,'2024-07-13 16:00:00.000000'),(335577,9648,'2024-07-13 16:00:00.000000'),(2593,5265,'2024-07-13 16:00:00.000000'),(328717,2777,'2024-07-13 16:00:00.000000'),(101,718,'2024-07-13 16:00:00.000000'),(379005,702,'2024-07-13 16:00:00.000000'),(374757,234,'2024-07-13 16:00:00.000000'),(390102,236,'2024-07-13 16:00:00.000000'),(399876,1025,'2024-07-13 16:00:00.000000'),(269632,69,'2024-07-13 16:00:00.000000'),(358886,528,'2024-07-13 16:00:00.000000'),(109,2784,'2024-07-13 16:00:00.000000'),(376243,1427,'2024-07-13 16:00:00.000000'),(95,2988,'2024-07-13 16:00:00.000000'),(353051,140,'2024-07-13 16:00:00.000000'),(179782,497,'2024-07-13 16:00:00.000000'),(161609,2151,'2024-07-13 16:00:00.000000'),(371145,108,'2024-07-13 16:00:00.000000'),(345859,182,'2024-07-13 16:00:00.000000'),(249042,3443,'2024-07-13 16:00:00.000000'),(91236,704,'2024-07-13 16:00:00.000000'),(213014,824,'2024-07-13 16:00:00.000000'),(206580,68,'2024-07-13 16:00:00.000000'),(380316,3847,'2024-07-13 16:00:00.000000'),(29980,204,'2024-07-13 16:00:00.000000'),(24582,2944,'2024-07-13 16:00:00.000000'),(141,419,'2024-07-13 16:00:00.000000'),(77,2512,'2024-07-13 16:00:00.000000'),(352007,1594,'2024-07-13 16:00:00.000000'),(146545,300,'2024-07-13 16:00:00.000000'),(174440,1424,'2024-07-13 16:00:00.000000'),(82,708,'2024-07-13 16:00:00.000000'),(389643,358,'2024-07-13 16:00:00.000000'),(356641,1188,'2024-07-13 16:00:00.000000'),(1649,1104,'2024-07-13 16:00:00.000000'),(67420,917,'2024-07-13 16:00:00.000000'),(52499,1584,'2024-07-13 16:00:00.000000'),(270017,69,'2024-07-13 16:00:00.000000'),(352787,348,'2024-07-13 16:00:00.000000'),(69379,711,'2024-07-13 16:00:00.000000'),(148,359,'2024-07-13 16:00:00.000000'),(381577,588,'2024-07-13 16:00:00.000000'),(348968,38,'2024-07-13 16:00:00.000000'),(79,228,'2024-07-13 16:00:00.000000'),(218851,416,'2024-07-13 16:00:00.000000'),(383225,468,'2024-07-13 16:00:00.000000'),(267713,635,'2024-07-13 16:00:00.000000'),(380665,23,'2024-07-13 16:00:00.000000'),(34,936,'2024-07-13 16:00:00.000000'),(240225,0,'2024-07-13 16:00:00.000000'),(123,288,'2024-07-13 16:00:00.000000'),(146340,210,'2024-07-13 16:00:00.000000'),(173051,392,'2024-07-13 16:00:00.000000'),(137,816,'2024-07-13 16:00:00.000000'),(164,272,'2024-07-13 16:00:00.000000'),(393529,0,'2024-07-13 16:00:00.000000'),(79843,536,'2024-07-13 16:00:00.000000'),(86090,93,'2024-07-13 16:00:00.000000'),(280318,104,'2024-07-13 16:00:00.000000'),(69,0,'2024-07-13 16:00:00.000000'),(344844,474,'2024-07-13 16:00:00.000000'),(192434,294,'2024-07-13 16:00:00.000000'),(153632,1378,'2024-07-13 16:00:00.000000'),(5349,588,'2024-07-13 16:00:00.000000'),(370070,474,'2024-07-13 16:00:00.000000'),(217860,240,'2024-07-13 16:00:00.000000'),(342468,234,'2024-07-13 16:00:00.000000'),(132,359,'2024-07-13 16:00:00.000000'),(270888,22308,'2024-07-14 16:00:00.000000'),(73857,13556,'2024-07-14 16:00:00.000000'),(153632,29,'2024-07-14 16:00:00.000000'),(5349,12,'2024-07-14 16:00:00.000000'),(367375,120,'2024-07-14 16:00:00.000000'),(340532,4369,'2024-07-14 16:00:00.000000'),(346331,1675,'2024-07-14 16:00:00.000000'),(320517,1666,'2024-07-14 16:00:00.000000'),(78740,7409,'2024-07-14 16:00:00.000000'),(69,2232,'2024-07-14 16:00:00.000000'),(67019,9910,'2024-07-14 16:00:00.000000'),(159566,9763,'2024-07-14 16:00:00.000000'),(160616,67,'2024-07-14 16:00:00.000000'),(397554,2988,'2024-07-14 16:00:00.000000'),(348187,4623,'2024-07-14 16:00:00.000000'),(106148,14962,'2024-07-14 16:00:00.000000'),(242263,608,'2024-07-14 16:00:00.000000'),(182308,18360,'2024-07-14 16:00:00.000000'),(141,419,'2024-07-14 16:00:00.000000'),(14573,7990,'2024-07-14 16:00:00.000000'),(353921,-114,'2024-07-14 16:00:00.000000'),(354236,14028,'2024-07-14 16:00:00.000000'),(336963,1110,'2024-07-14 16:00:00.000000'),(97,4675,'2024-07-14 16:00:00.000000'),(303906,4686,'2024-07-14 16:00:00.000000'),(3940,27947,'2024-07-14 16:00:00.000000'),(87404,2220,'2024-07-14 16:00:00.000000'),(44,1133,'2024-07-14 16:00:00.000000'),(90281,480,'2024-07-14 16:00:00.000000'),(91236,1240,'2024-07-14 16:00:00.000000'),(119,359,'2024-07-14 16:00:00.000000'),(898,232,'2024-07-14 16:00:00.000000'),(393152,295,'2024-07-14 16:00:00.000000'),(336947,379,'2024-07-14 16:00:00.000000'),(269339,25660,'2024-07-14 16:00:00.000000'),(6069,47928,'2024-07-14 16:00:00.000000'),(61,9497,'2024-07-14 16:00:00.000000'),(249042,2204,'2024-07-14 16:00:00.000000'),(344844,294,'2024-07-14 16:00:00.000000'),(382101,657,'2024-07-14 16:00:00.000000'),(352007,672,'2024-07-14 16:00:00.000000'),(159,1912,'2024-07-14 16:00:00.000000'),(106,33344,'2024-07-14 16:00:00.000000'),(77377,3640,'2024-07-14 16:00:00.000000'),(352787,1524,'2024-07-14 16:00:00.000000'),(143961,5768,'2024-07-14 16:00:00.000000'),(353051,280,'2024-07-14 16:00:00.000000'),(190618,649,'2024-07-14 16:00:00.000000'),(380316,139,'2024-07-14 16:00:00.000000'),(63,4584,'2024-07-14 16:00:00.000000'),(148,718,'2024-07-14 16:00:00.000000'),(137,2040,'2024-07-14 16:00:00.000000'),(164,680,'2024-07-14 16:00:00.000000'),(101,718,'2024-07-14 16:00:00.000000'),(366194,1157,'2024-07-14 16:00:00.000000'),(357181,21696,'2024-07-14 16:00:00.000000'),(192434,120,'2024-07-14 16:00:00.000000'),(66,1374,'2024-07-14 16:00:00.000000'),(326483,5902,'2024-07-14 16:00:00.000000'),(227196,800,'2024-07-14 16:00:00.000000'),(161609,2967,'2024-07-14 16:00:00.000000'),(109,10584,'2024-07-14 16:00:00.000000'),(2593,274,'2024-07-14 16:00:00.000000'),(345300,1533,'2024-07-14 16:00:00.000000'),(82,594,'2024-07-14 16:00:00.000000'),(69379,2528,'2024-07-14 16:00:00.000000'),(97857,303,'2024-07-14 16:00:00.000000'),(93579,17,'2024-07-14 16:00:00.000000'),(16311,0,'2024-07-14 16:00:00.000000'),(280318,312,'2024-07-14 16:00:00.000000'),(268954,3163,'2024-07-14 16:00:00.000000'),(4,419,'2024-07-14 16:00:00.000000'),(380765,531,'2024-07-14 16:00:00.000000'),(73,1836,'2024-07-14 16:00:00.000000'),(174440,1248,'2024-07-14 16:00:00.000000'),(320610,1625,'2024-07-14 16:00:00.000000'),(390102,114,'2024-07-14 16:00:00.000000'),(163374,1981,'2024-07-14 16:00:00.000000'),(102,1366,'2024-07-14 16:00:00.000000'),(99,718,'2024-07-14 16:00:00.000000'),(139,1061,'2024-07-14 16:00:00.000000'),(175834,1062,'2024-07-14 16:00:00.000000'),(142,455,'2024-07-14 16:00:00.000000'),(275013,948,'2024-07-14 16:00:00.000000'),(123,1485,'2024-07-14 16:00:00.000000'),(371145,162,'2024-07-14 16:00:00.000000'),(356641,1476,'2024-07-14 16:00:00.000000'),(75,474,'2024-07-14 16:00:00.000000'),(173051,392,'2024-07-14 16:00:00.000000'),(392278,1038,'2024-07-14 16:00:00.000000'),(269632,1395,'2024-07-14 16:00:00.000000'),(269583,20893,'2024-07-14 16:00:00.000000'),(379005,444,'2024-07-14 16:00:00.000000'),(374757,148,'2024-07-14 16:00:00.000000'),(146545,300,'2024-07-14 16:00:00.000000'),(13324,971,'2024-07-14 16:00:00.000000'),(93,1668,'2024-07-14 16:00:00.000000'),(274697,554,'2024-07-14 16:00:00.000000'),(87907,4480,'2024-07-14 16:00:00.000000'),(404820,468,'2024-07-14 16:00:00.000000'),(338605,591,'2024-07-14 16:00:00.000000'),(267713,68,'2024-07-14 16:00:00.000000'),(135,414,'2024-07-14 16:00:00.000000'),(148509,3224,'2024-07-14 16:00:00.000000'),(145740,150,'2024-07-14 16:00:00.000000'),(404583,59,'2024-07-14 16:00:00.000000'),(327391,0,'2024-07-14 16:00:00.000000'),(358886,1422,'2024-07-14 16:00:00.000000'),(270602,277,'2024-07-14 16:00:00.000000'),(179782,1144,'2024-07-14 16:00:00.000000'),(399876,209,'2024-07-14 16:00:00.000000'),(34,2039,'2024-07-14 16:00:00.000000'),(376093,442,'2024-07-14 16:00:00.000000'),(31476,2929,'2024-07-14 16:00:00.000000'),(8,650,'2024-07-14 16:00:00.000000'),(37634,0,'2024-07-14 16:00:00.000000'),(389928,418,'2024-07-14 16:00:00.000000'),(279951,54,'2024-07-14 16:00:00.000000'),(2953,792,'2024-07-14 16:00:00.000000'),(177637,464,'2024-07-14 16:00:00.000000'),(342468,1062,'2024-07-14 16:00:00.000000'),(132,359,'2024-07-14 16:00:00.000000'),(348500,114,'2024-07-14 16:00:00.000000'),(67379,448,'2024-07-14 16:00:00.000000'),(74,3704,'2024-07-14 16:00:00.000000'),(376243,2316,'2024-07-14 16:00:00.000000'),(353687,370,'2024-07-14 16:00:00.000000'),(29980,418,'2024-07-14 16:00:00.000000'),(213014,424,'2024-07-14 16:00:00.000000'),(136,0,'2024-07-14 16:00:00.000000'),(94,718,'2024-07-14 16:00:00.000000'),(389643,179,'2024-07-14 16:00:00.000000'),(380665,23,'2024-07-14 16:00:00.000000'),(26283,569,'2024-07-14 16:00:00.000000'),(270232,277,'2024-07-14 16:00:00.000000'),(1958,5248,'2024-07-14 16:00:00.000000'),(77,712,'2024-07-14 16:00:00.000000'),(79,228,'2024-07-14 16:00:00.000000'),(164630,544,'2024-07-14 16:00:00.000000'),(310356,114,'2024-07-14 16:00:00.000000'),(217860,240,'2024-07-14 16:00:00.000000'),(169095,1203,'2024-07-14 16:00:00.000000'),(352921,0,'2024-07-14 16:00:00.000000'),(1258,234,'2024-07-14 16:00:00.000000'),(7,414,'2024-07-14 16:00:00.000000'),(391886,59,'2024-07-14 16:00:00.000000'),(52499,792,'2024-07-14 16:00:00.000000'),(206580,68,'2024-07-14 16:00:00.000000'),(67420,280,'2024-07-14 16:00:00.000000'),(78,414,'2024-07-14 16:00:00.000000'),(240225,354,'2024-07-14 16:00:00.000000'),(329947,-118,'2024-07-14 16:00:00.000000'),(348187,7778,'2024-07-15 16:00:00.000000'),(159,2946,'2024-07-15 16:00:00.000000'),(97,3116,'2024-07-15 16:00:00.000000'),(303906,5596,'2024-07-15 16:00:00.000000'),(1958,8712,'2024-07-15 16:00:00.000000'),(182308,24360,'2024-07-15 16:00:00.000000'),(73857,18226,'2024-07-15 16:00:00.000000'),(270888,30318,'2024-07-15 16:00:00.000000'),(146545,300,'2024-07-15 16:00:00.000000'),(13324,1390,'2024-07-15 16:00:00.000000'),(106,7832,'2024-07-15 16:00:00.000000'),(110,474,'2024-07-15 16:00:00.000000'),(14573,6844,'2024-07-15 16:00:00.000000'),(393152,2596,'2024-07-15 16:00:00.000000'),(336947,660,'2024-07-15 16:00:00.000000'),(346331,1650,'2024-07-15 16:00:00.000000'),(340532,5145,'2024-07-15 16:00:00.000000'),(320517,2201,'2024-07-15 16:00:00.000000'),(78740,8343,'2024-07-15 16:00:00.000000'),(269339,16764,'2024-07-15 16:00:00.000000'),(106148,12048,'2024-07-15 16:00:00.000000'),(61,6758,'2024-07-15 16:00:00.000000'),(67019,19271,'2024-07-15 16:00:00.000000'),(77377,5648,'2024-07-15 16:00:00.000000'),(109,2526,'2024-07-15 16:00:00.000000'),(2593,450,'2024-07-15 16:00:00.000000'),(143961,5328,'2024-07-15 16:00:00.000000'),(354236,10158,'2024-07-15 16:00:00.000000'),(336963,1234,'2024-07-15 16:00:00.000000'),(74,5780,'2024-07-15 16:00:00.000000'),(93,5651,'2024-07-15 16:00:00.000000'),(90281,6320,'2024-07-15 16:00:00.000000'),(159566,12686,'2024-07-15 16:00:00.000000'),(160616,99,'2024-07-15 16:00:00.000000'),(3940,19960,'2024-07-15 16:00:00.000000'),(121,1437,'2024-07-15 16:00:00.000000'),(177637,464,'2024-07-15 16:00:00.000000'),(6069,62392,'2024-07-15 16:00:00.000000'),(102,718,'2024-07-15 16:00:00.000000'),(389928,537,'2024-07-15 16:00:00.000000'),(279951,69,'2024-07-15 16:00:00.000000'),(391886,118,'2024-07-15 16:00:00.000000'),(268954,8737,'2024-07-15 16:00:00.000000'),(66,3810,'2024-07-15 16:00:00.000000'),(69379,2744,'2024-07-15 16:00:00.000000'),(269632,1234,'2024-07-15 16:00:00.000000'),(140,708,'2024-07-15 16:00:00.000000'),(242263,3456,'2024-07-15 16:00:00.000000'),(31476,1374,'2024-07-15 16:00:00.000000'),(249042,1899,'2024-07-15 16:00:00.000000'),(381577,1110,'2024-07-15 16:00:00.000000'),(348968,72,'2024-07-15 16:00:00.000000'),(178210,359,'2024-07-15 16:00:00.000000'),(170194,38,'2024-07-15 16:00:00.000000'),(357181,25014,'2024-07-15 16:00:00.000000'),(352007,1427,'2024-07-15 16:00:00.000000'),(390102,2807,'2024-07-15 16:00:00.000000'),(195763,312,'2024-07-15 16:00:00.000000'),(186083,165,'2024-07-15 16:00:00.000000'),(1471,17576,'2024-07-15 16:00:00.000000'),(148509,2556,'2024-07-15 16:00:00.000000'),(123,1773,'2024-07-15 16:00:00.000000'),(69,5892,'2024-07-15 16:00:00.000000'),(353051,968,'2024-07-15 16:00:00.000000'),(29980,1239,'2024-07-15 16:00:00.000000'),(341834,239,'2024-07-15 16:00:00.000000'),(270232,481,'2024-07-15 16:00:00.000000'),(348991,474,'2024-07-15 16:00:00.000000'),(397554,2250,'2024-07-15 16:00:00.000000'),(161609,5925,'2024-07-15 16:00:00.000000'),(335577,716,'2024-07-15 16:00:00.000000'),(370070,930,'2024-07-15 16:00:00.000000'),(63,3342,'2024-07-15 16:00:00.000000'),(380765,118,'2024-07-15 16:00:00.000000'),(320610,348,'2024-07-15 16:00:00.000000'),(227196,3272,'2024-07-15 16:00:00.000000'),(345300,2189,'2024-07-15 16:00:00.000000'),(75,4006,'2024-07-15 16:00:00.000000'),(190618,818,'2024-07-15 16:00:00.000000'),(119,1077,'2024-07-15 16:00:00.000000'),(371145,54,'2024-07-15 16:00:00.000000'),(326483,9550,'2024-07-15 16:00:00.000000'),(79,582,'2024-07-15 16:00:00.000000'),(164630,4024,'2024-07-15 16:00:00.000000'),(348500,114,'2024-07-15 16:00:00.000000'),(396777,3015,'2024-07-15 16:00:00.000000'),(96,359,'2024-07-15 16:00:00.000000'),(269583,19447,'2024-07-15 16:00:00.000000'),(99,0,'2024-07-15 16:00:00.000000'),(342468,414,'2024-07-15 16:00:00.000000'),(382101,537,'2024-07-15 16:00:00.000000'),(73,2366,'2024-07-15 16:00:00.000000'),(379005,5250,'2024-07-15 16:00:00.000000'),(374757,1750,'2024-07-15 16:00:00.000000'),(79843,673,'2024-07-15 16:00:00.000000'),(86090,118,'2024-07-15 16:00:00.000000'),(380316,900,'2024-07-15 16:00:00.000000'),(175834,2124,'2024-07-15 16:00:00.000000'),(142,497,'2024-07-15 16:00:00.000000'),(120,419,'2024-07-15 16:00:00.000000'),(356641,1422,'2024-07-15 16:00:00.000000'),(91236,680,'2024-07-15 16:00:00.000000'),(87907,7744,'2024-07-15 16:00:00.000000'),(139,2204,'2024-07-15 16:00:00.000000'),(367375,60,'2024-07-15 16:00:00.000000'),(213014,800,'2024-07-15 16:00:00.000000'),(77,1188,'2024-07-15 16:00:00.000000'),(26283,2182,'2024-07-15 16:00:00.000000'),(404820,358,'2024-07-15 16:00:00.000000'),(146166,300,'2024-07-15 16:00:00.000000'),(145740,300,'2024-07-15 16:00:00.000000'),(11,533,'2024-07-15 16:00:00.000000'),(226924,118,'2024-07-15 16:00:00.000000'),(82,594,'2024-07-15 16:00:00.000000'),(366194,885,'2024-07-15 16:00:00.000000'),(1649,552,'2024-07-15 16:00:00.000000'),(40441,312,'2024-07-15 16:00:00.000000'),(296457,118,'2024-07-15 16:00:00.000000'),(97857,3591,'2024-07-15 16:00:00.000000'),(93579,205,'2024-07-15 16:00:00.000000'),(101,359,'2024-07-15 16:00:00.000000'),(399212,472,'2024-07-15 16:00:00.000000'),(392278,320,'2024-07-15 16:00:00.000000'),(163374,1253,'2024-07-15 16:00:00.000000'),(209473,138,'2024-07-15 16:00:00.000000'),(8,1360,'2024-07-15 16:00:00.000000'),(351513,126,'2024-07-15 16:00:00.000000'),(78,520,'2024-07-15 16:00:00.000000'),(217860,1032,'2024-07-15 16:00:00.000000'),(34,1108,'2024-07-15 16:00:00.000000'),(169095,1203,'2024-07-15 16:00:00.000000'),(328717,277,'2024-07-15 16:00:00.000000'),(137,408,'2024-07-15 16:00:00.000000'),(164,136,'2024-07-15 16:00:00.000000'),(274697,809,'2024-07-15 16:00:00.000000'),(379253,181,'2024-07-15 16:00:00.000000'),(389643,118,'2024-07-15 16:00:00.000000'),(380665,12,'2024-07-15 16:00:00.000000'),(24582,712,'2024-07-15 16:00:00.000000'),(996,392,'2024-07-15 16:00:00.000000'),(67383,20322,'2024-07-15 16:00:00.000000'),(4,2394,'2024-07-15 16:00:00.000000'),(348616,696,'2024-07-15 16:00:00.000000'),(146340,210,'2024-07-15 16:00:00.000000'),(217606,1252,'2024-07-15 16:00:00.000000'),(92,359,'2024-07-15 16:00:00.000000'),(275013,474,'2024-07-15 16:00:00.000000'),(103920,744,'2024-07-15 16:00:00.000000'),(270602,899,'2024-07-15 16:00:00.000000'),(132,539,'2024-07-15 16:00:00.000000'),(898,464,'2024-07-15 16:00:00.000000'),(179782,359,'2024-07-15 16:00:00.000000'),(378518,1592,'2024-07-15 16:00:00.000000'),(51444,784,'2024-07-15 16:00:00.000000'),(107,594,'2024-07-15 16:00:00.000000'),(74,4104,'2024-07-16 16:00:00.000000'),(67019,19592,'2024-07-16 16:00:00.000000'),(393152,4110,'2024-07-16 16:00:00.000000'),(336947,988,'2024-07-16 16:00:00.000000'),(346331,952,'2024-07-16 16:00:00.000000'),(340532,3898,'2024-07-16 16:00:00.000000'),(320517,2114,'2024-07-16 16:00:00.000000'),(78740,6059,'2024-07-16 16:00:00.000000'),(182308,30600,'2024-07-16 16:00:00.000000'),(73857,14160,'2024-07-16 16:00:00.000000'),(348187,8308,'2024-07-16 16:00:00.000000'),(159,3135,'2024-07-16 16:00:00.000000'),(898,2472,'2024-07-16 16:00:00.000000'),(8,414,'2024-07-16 16:00:00.000000'),(379005,4188,'2024-07-16 16:00:00.000000'),(374757,1396,'2024-07-16 16:00:00.000000'),(61,12837,'2024-07-16 16:00:00.000000'),(270888,11880,'2024-07-16 16:00:00.000000'),(78,816,'2024-07-16 16:00:00.000000'),(3940,17402,'2024-07-16 16:00:00.000000'),(106148,10858,'2024-07-16 16:00:00.000000'),(342468,2484,'2024-07-16 16:00:00.000000'),(77377,2296,'2024-07-16 16:00:00.000000'),(159566,6097,'2024-07-16 16:00:00.000000'),(160616,46,'2024-07-16 16:00:00.000000'),(352787,294,'2024-07-16 16:00:00.000000'),(240225,708,'2024-07-16 16:00:00.000000'),(269339,14906,'2024-07-16 16:00:00.000000'),(242263,3480,'2024-07-16 16:00:00.000000'),(249042,1415,'2024-07-16 16:00:00.000000'),(269632,1239,'2024-07-16 16:00:00.000000'),(326483,1686,'2024-07-16 16:00:00.000000'),(414419,472,'2024-07-16 16:00:00.000000'),(353051,140,'2024-07-16 16:00:00.000000'),(26283,4718,'2024-07-16 16:00:00.000000'),(63,1896,'2024-07-16 16:00:00.000000'),(75,5244,'2024-07-16 16:00:00.000000'),(79,582,'2024-07-16 16:00:00.000000'),(29980,1040,'2024-07-16 16:00:00.000000'),(69379,1734,'2024-07-16 16:00:00.000000'),(354236,8028,'2024-07-16 16:00:00.000000'),(336963,902,'2024-07-16 16:00:00.000000'),(390102,708,'2024-07-16 16:00:00.000000'),(275013,1654,'2024-07-16 16:00:00.000000'),(66,1650,'2024-07-16 16:00:00.000000'),(389643,354,'2024-07-16 16:00:00.000000'),(380665,36,'2024-07-16 16:00:00.000000'),(389928,179,'2024-07-16 16:00:00.000000'),(279951,23,'2024-07-16 16:00:00.000000'),(391886,531,'2024-07-16 16:00:00.000000'),(6069,9463,'2024-07-16 16:00:00.000000'),(345300,1590,'2024-07-16 16:00:00.000000'),(31476,1309,'2024-07-16 16:00:00.000000'),(303906,3562,'2024-07-16 16:00:00.000000'),(226924,118,'2024-07-16 16:00:00.000000'),(143961,7510,'2024-07-16 16:00:00.000000'),(14573,6696,'2024-07-16 16:00:00.000000'),(397554,4380,'2024-07-16 16:00:00.000000'),(381577,294,'2024-07-16 16:00:00.000000'),(348968,19,'2024-07-16 16:00:00.000000'),(161609,3927,'2024-07-16 16:00:00.000000'),(93,1472,'2024-07-16 16:00:00.000000'),(132,539,'2024-07-16 16:00:00.000000'),(163608,709,'2024-07-16 16:00:00.000000'),(174440,1728,'2024-07-16 16:00:00.000000'),(396777,1896,'2024-07-16 16:00:00.000000'),(99,1077,'2024-07-16 16:00:00.000000'),(73,2248,'2024-07-16 16:00:00.000000'),(270602,759,'2024-07-16 16:00:00.000000'),(190618,1334,'2024-07-16 16:00:00.000000'),(335577,0,'2024-07-16 16:00:00.000000'),(2593,89,'2024-07-16 16:00:00.000000'),(404583,1184,'2024-07-16 16:00:00.000000'),(351513,590,'2024-07-16 16:00:00.000000'),(87907,2720,'2024-07-16 16:00:00.000000'),(357181,6186,'2024-07-16 16:00:00.000000'),(139,2048,'2024-07-16 16:00:00.000000'),(30,50,'2024-07-16 16:00:00.000000'),(4,838,'2024-07-16 16:00:00.000000'),(69,11358,'2024-07-16 16:00:00.000000'),(97,3867,'2024-07-16 16:00:00.000000'),(137,2040,'2024-07-16 16:00:00.000000'),(164,680,'2024-07-16 16:00:00.000000'),(146545,150,'2024-07-16 16:00:00.000000'),(13324,1391,'2024-07-16 16:00:00.000000'),(119,0,'2024-07-16 16:00:00.000000'),(67420,10277,'2024-07-16 16:00:00.000000'),(148509,1873,'2024-07-16 16:00:00.000000'),(269583,17244,'2024-07-16 16:00:00.000000'),(267713,81,'2024-07-16 16:00:00.000000'),(51609,3144,'2024-07-16 16:00:00.000000'),(380765,118,'2024-07-16 16:00:00.000000'),(296457,118,'2024-07-16 16:00:00.000000'),(273575,158,'2024-07-16 16:00:00.000000'),(109,3474,'2024-07-16 16:00:00.000000'),(140,354,'2024-07-16 16:00:00.000000'),(213014,824,'2024-07-16 16:00:00.000000'),(227196,3192,'2024-07-16 16:00:00.000000'),(382101,2812,'2024-07-16 16:00:00.000000'),(175834,1416,'2024-07-16 16:00:00.000000'),(142,146,'2024-07-16 16:00:00.000000'),(320610,1103,'2024-07-16 16:00:00.000000'),(169095,201,'2024-07-16 16:00:00.000000'),(96,359,'2024-07-16 16:00:00.000000'),(135,828,'2024-07-16 16:00:00.000000'),(64,708,'2024-07-16 16:00:00.000000'),(259476,168,'2024-07-16 16:00:00.000000'),(338605,816,'2024-07-16 16:00:00.000000'),(34,822,'2024-07-16 16:00:00.000000'),(163374,849,'2024-07-16 16:00:00.000000'),(1958,1264,'2024-07-16 16:00:00.000000'),(106,8712,'2024-07-16 16:00:00.000000'),(90281,7792,'2024-07-16 16:00:00.000000'),(352007,336,'2024-07-16 16:00:00.000000'),(404820,537,'2024-07-16 16:00:00.000000'),(209473,414,'2024-07-16 16:00:00.000000'),(356641,155,'2024-07-16 16:00:00.000000'),(77,1175,'2024-07-16 16:00:00.000000'),(102,1312,'2024-07-16 16:00:00.000000'),(95,3582,'2024-07-16 16:00:00.000000'),(19316,1584,'2024-07-16 16:00:00.000000'),(392278,1280,'2024-07-16 16:00:00.000000'),(268954,5257,'2024-07-16 16:00:00.000000'),(146166,150,'2024-07-16 16:00:00.000000'),(412533,3792,'2024-07-16 16:00:00.000000'),(11,1870,'2024-07-16 16:00:00.000000'),(379253,826,'2024-07-16 16:00:00.000000'),(164630,1632,'2024-07-16 16:00:00.000000'),(145740,1650,'2024-07-16 16:00:00.000000'),(366194,274,'2024-07-16 16:00:00.000000'),(172731,472,'2024-07-16 16:00:00.000000'),(414568,0,'2024-07-16 16:00:00.000000'),(380316,1596,'2024-07-16 16:00:00.000000'),(1982,704,'2024-07-16 16:00:00.000000'),(44,960,'2024-07-16 16:00:00.000000'),(92,359,'2024-07-16 16:00:00.000000'),(147322,312,'2024-07-16 16:00:00.000000'),(103920,300,'2024-07-16 16:00:00.000000'),(371145,108,'2024-07-16 16:00:00.000000'),(144384,12690,'2024-07-16 16:00:00.000000'),(328717,68,'2024-07-16 16:00:00.000000'),(254325,552,'2024-07-16 16:00:00.000000'),(120,419,'2024-07-16 16:00:00.000000'),(67383,600,'2024-07-16 16:00:00.000000'),(399876,418,'2024-07-16 16:00:00.000000'),(348500,342,'2024-07-16 16:00:00.000000'),(1649,552,'2024-07-16 16:00:00.000000'),(399212,236,'2024-07-16 16:00:00.000000'),(146340,210,'2024-07-16 16:00:00.000000'),(402096,1495,'2024-07-16 16:00:00.000000'),(412769,320,'2024-07-16 16:00:00.000000'),(410700,118,'2024-07-16 16:00:00.000000'),(352924,234,'2024-07-16 16:00:00.000000'),(91236,8,'2024-07-16 16:00:00.000000'),(293753,0,'2024-07-16 16:00:00.000000'),(26,0,'2024-07-16 16:00:00.000000'),(329947,532,'2024-07-16 16:00:00.000000'),(412300,0,'2024-07-16 16:00:00.000000'),(412764,888,'2024-07-16 16:00:00.000000'),(276039,0,'2024-07-16 16:00:00.000000'),(87404,1067,'2024-07-16 16:00:00.000000'),(358886,474,'2024-07-16 16:00:00.000000'),(409201,114,'2024-07-16 16:00:00.000000'),(89,359,'2024-07-16 16:00:00.000000'),(214911,1104,'2024-07-16 16:00:00.000000'),(367375,60,'2024-07-16 16:00:00.000000'),(342969,234,'2024-07-16 16:00:00.000000'),(182308,54468,'2024-07-17 16:00:00.000000'),(73857,25520,'2024-07-17 16:00:00.000000'),(270888,22092,'2024-07-17 16:00:00.000000'),(412533,468,'2024-07-17 16:00:00.000000'),(320517,788,'2024-07-17 16:00:00.000000'),(61,8815,'2024-07-17 16:00:00.000000'),(67019,27698,'2024-07-17 16:00:00.000000'),(348187,12057,'2024-07-17 16:00:00.000000'),(159,2526,'2024-07-17 16:00:00.000000'),(414419,708,'2024-07-17 16:00:00.000000'),(268954,5751,'2024-07-17 16:00:00.000000'),(106148,13896,'2024-07-17 16:00:00.000000'),(380316,1392,'2024-07-17 16:00:00.000000'),(346331,643,'2024-07-17 16:00:00.000000'),(340532,3987,'2024-07-17 16:00:00.000000'),(78740,7515,'2024-07-17 16:00:00.000000'),(393152,2065,'2024-07-17 16:00:00.000000'),(336947,1261,'2024-07-17 16:00:00.000000'),(87404,740,'2024-07-17 16:00:00.000000'),(14573,11947,'2024-07-17 16:00:00.000000'),(69,20088,'2024-07-17 16:00:00.000000'),(44,2580,'2024-07-17 16:00:00.000000'),(227196,4384,'2024-07-17 16:00:00.000000'),(269339,5293,'2024-07-17 16:00:00.000000'),(379005,756,'2024-07-17 16:00:00.000000'),(374757,252,'2024-07-17 16:00:00.000000'),(399876,0,'2024-07-17 16:00:00.000000'),(391886,649,'2024-07-17 16:00:00.000000'),(336963,518,'2024-07-17 16:00:00.000000'),(75,9450,'2024-07-17 16:00:00.000000'),(51444,392,'2024-07-17 16:00:00.000000'),(93,1376,'2024-07-17 16:00:00.000000'),(303906,3795,'2024-07-17 16:00:00.000000'),(146545,300,'2024-07-17 16:00:00.000000'),(13324,1508,'2024-07-17 16:00:00.000000'),(164630,6136,'2024-07-17 16:00:00.000000'),(3940,35137,'2024-07-17 16:00:00.000000'),(91236,16,'2024-07-17 16:00:00.000000'),(269583,26057,'2024-07-17 16:00:00.000000'),(214911,1504,'2024-07-17 16:00:00.000000'),(143961,8958,'2024-07-17 16:00:00.000000'),(106,10296,'2024-07-17 16:00:00.000000'),(139,2513,'2024-07-17 16:00:00.000000'),(119,2563,'2024-07-17 16:00:00.000000'),(280318,1574,'2024-07-17 16:00:00.000000'),(242263,1216,'2024-07-17 16:00:00.000000'),(102,718,'2024-07-17 16:00:00.000000'),(342468,1656,'2024-07-17 16:00:00.000000'),(190618,987,'2024-07-17 16:00:00.000000'),(354236,4500,'2024-07-17 16:00:00.000000'),(123,2899,'2024-07-17 16:00:00.000000'),(159566,6085,'2024-07-17 16:00:00.000000'),(160616,41,'2024-07-17 16:00:00.000000'),(77377,3552,'2024-07-17 16:00:00.000000'),(73,3718,'2024-07-17 16:00:00.000000'),(109,1596,'2024-07-17 16:00:00.000000'),(2593,40,'2024-07-17 16:00:00.000000'),(379253,622,'2024-07-17 16:00:00.000000'),(1958,4768,'2024-07-17 16:00:00.000000'),(402096,3507,'2024-07-17 16:00:00.000000'),(356641,839,'2024-07-17 16:00:00.000000'),(90281,5216,'2024-07-17 16:00:00.000000'),(66,7754,'2024-07-17 16:00:00.000000'),(249042,2623,'2024-07-17 16:00:00.000000'),(213014,2416,'2024-07-17 16:00:00.000000'),(275013,3906,'2024-07-17 16:00:00.000000'),(397554,11202,'2024-07-17 16:00:00.000000'),(26283,11552,'2024-07-17 16:00:00.000000'),(412769,649,'2024-07-17 16:00:00.000000'),(270602,691,'2024-07-17 16:00:00.000000'),(161609,21031,'2024-07-17 16:00:00.000000'),(97,3467,'2024-07-17 16:00:00.000000'),(6069,29367,'2024-07-17 16:00:00.000000'),(269632,1906,'2024-07-17 16:00:00.000000'),(898,464,'2024-07-17 16:00:00.000000'),(34,234,'2024-07-17 16:00:00.000000'),(240225,1062,'2024-07-17 16:00:00.000000'),(389643,295,'2024-07-17 16:00:00.000000'),(380665,52,'2024-07-17 16:00:00.000000'),(137,2040,'2024-07-17 16:00:00.000000'),(164,680,'2024-07-17 16:00:00.000000'),(63,3342,'2024-07-17 16:00:00.000000'),(209473,138,'2024-07-17 16:00:00.000000'),(396777,716,'2024-07-17 16:00:00.000000'),(58,600,'2024-07-17 16:00:00.000000'),(95,1188,'2024-07-17 16:00:00.000000'),(148509,5240,'2024-07-17 16:00:00.000000'),(267884,222,'2024-07-17 16:00:00.000000'),(410700,236,'2024-07-17 16:00:00.000000'),(404583,708,'2024-07-17 16:00:00.000000'),(326483,5338,'2024-07-17 16:00:00.000000'),(11,472,'2024-07-17 16:00:00.000000'),(101,778,'2024-07-17 16:00:00.000000'),(352924,234,'2024-07-17 16:00:00.000000'),(399212,118,'2024-07-17 16:00:00.000000'),(67420,280,'2024-07-17 16:00:00.000000'),(99,1534,'2024-07-17 16:00:00.000000'),(74,5148,'2024-07-17 16:00:00.000000'),(357181,1896,'2024-07-17 16:00:00.000000'),(163374,709,'2024-07-17 16:00:00.000000'),(31476,2805,'2024-07-17 16:00:00.000000'),(276039,504,'2024-07-17 16:00:00.000000'),(87907,8288,'2024-07-17 16:00:00.000000'),(418307,472,'2024-07-17 16:00:00.000000'),(144384,474,'2024-07-17 16:00:00.000000'),(82,594,'2024-07-17 16:00:00.000000'),(39190,0,'2024-07-17 16:00:00.000000'),(370070,174,'2024-07-17 16:00:00.000000'),(380765,2630,'2024-07-17 16:00:00.000000'),(51609,3288,'2024-07-17 16:00:00.000000'),(348500,114,'2024-07-17 16:00:00.000000'),(48,474,'2024-07-17 16:00:00.000000'),(352787,936,'2024-07-17 16:00:00.000000'),(177637,232,'2024-07-17 16:00:00.000000'),(358886,1896,'2024-07-17 16:00:00.000000'),(4,838,'2024-07-17 16:00:00.000000'),(320610,2669,'2024-07-17 16:00:00.000000'),(97857,598,'2024-07-17 16:00:00.000000'),(93579,35,'2024-07-17 16:00:00.000000'),(52499,792,'2024-07-17 16:00:00.000000'),(389928,716,'2024-07-17 16:00:00.000000'),(279951,92,'2024-07-17 16:00:00.000000'),(64,648,'2024-07-17 16:00:00.000000'),(104,9480,'2024-07-17 16:00:00.000000'),(175834,708,'2024-07-17 16:00:00.000000'),(142,1250,'2024-07-17 16:00:00.000000'),(392278,3104,'2024-07-17 16:00:00.000000'),(338605,197,'2024-07-17 16:00:00.000000'),(146166,600,'2024-07-17 16:00:00.000000'),(366194,609,'2024-07-17 16:00:00.000000'),(414568,1013,'2024-07-17 16:00:00.000000'),(296457,118,'2024-07-17 16:00:00.000000'),(78,174,'2024-07-17 16:00:00.000000'),(79843,271,'2024-07-17 16:00:00.000000'),(86090,47,'2024-07-17 16:00:00.000000'),(9,2400,'2024-07-17 16:00:00.000000'),(217860,240,'2024-07-17 16:00:00.000000'),(69379,1264,'2024-07-17 16:00:00.000000'),(67383,13800,'2024-07-17 16:00:00.000000'),(120,419,'2024-07-17 16:00:00.000000'),(267713,0,'2024-07-17 16:00:00.000000'),(135,1938,'2024-07-17 16:00:00.000000'),(3364,792,'2024-07-17 16:00:00.000000'),(132,359,'2024-07-17 16:00:00.000000'),(390102,59,'2024-07-17 16:00:00.000000'),(409201,177,'2024-07-17 16:00:00.000000'),(381577,717,'2024-07-17 16:00:00.000000'),(348968,45,'2024-07-17 16:00:00.000000'),(141,838,'2024-07-17 16:00:00.000000'),(92,946,'2024-07-17 16:00:00.000000'),(357669,114,'2024-07-17 16:00:00.000000'),(140,876,'2024-07-17 16:00:00.000000'),(412764,504,'2024-07-17 16:00:00.000000'),(145740,1452,'2024-07-17 16:00:00.000000'),(328717,367,'2024-07-17 16:00:00.000000'),(3,60,'2024-07-17 16:00:00.000000'),(404820,179,'2024-07-17 16:00:00.000000'),(376243,597,'2024-07-17 16:00:00.000000'),(353687,94,'2024-07-17 16:00:00.000000'),(283,944,'2024-07-17 16:00:00.000000'),(103920,2014,'2024-07-17 16:00:00.000000'),(412300,236,'2024-07-17 16:00:00.000000'),(96,359,'2024-07-17 16:00:00.000000'),(376093,337,'2024-07-17 16:00:00.000000'),(280544,234,'2024-07-17 16:00:00.000000'),(153632,36,'2024-07-17 16:00:00.000000'),(5349,15,'2024-07-17 16:00:00.000000'),(308873,271,'2024-07-17 16:00:00.000000'),(206580,68,'2024-07-17 16:00:00.000000'),(421224,236,'2024-07-17 16:00:00.000000'),(107,594,'2024-07-17 16:00:00.000000'),(19316,792,'2024-07-17 16:00:00.000000'),(37634,792,'2024-07-17 16:00:00.000000'),(1649,552,'2024-07-17 16:00:00.000000'),(46302,366,'2024-07-17 16:00:00.000000'),(353051,140,'2024-07-17 16:00:00.000000'),(26,49,'2024-07-17 16:00:00.000000'),(48900,1584,'2024-07-17 16:00:00.000000'),(79,114,'2024-07-17 16:00:00.000000'),(397554,7728,'2024-07-18 16:00:00.000000'),(348187,7622,'2024-07-18 16:00:00.000000'),(106148,13742,'2024-07-18 16:00:00.000000'),(182308,21780,'2024-07-18 16:00:00.000000'),(73857,15480,'2024-07-18 16:00:00.000000'),(106,13240,'2024-07-18 16:00:00.000000'),(270888,24660,'2024-07-18 16:00:00.000000'),(159,2617,'2024-07-18 16:00:00.000000'),(69,8898,'2024-07-18 16:00:00.000000'),(67019,31017,'2024-07-18 16:00:00.000000'),(320610,3837,'2024-07-18 16:00:00.000000'),(78740,10032,'2024-07-18 16:00:00.000000'),(95,2988,'2024-07-18 16:00:00.000000'),(14573,8939,'2024-07-18 16:00:00.000000'),(190618,809,'2024-07-18 16:00:00.000000'),(74,11808,'2024-07-18 16:00:00.000000'),(393152,7103,'2024-07-18 16:00:00.000000'),(336947,1068,'2024-07-18 16:00:00.000000'),(346331,1608,'2024-07-18 16:00:00.000000'),(340532,5623,'2024-07-18 16:00:00.000000'),(320517,1699,'2024-07-18 16:00:00.000000'),(75,11433,'2024-07-18 16:00:00.000000'),(414419,354,'2024-07-18 16:00:00.000000'),(175834,4002,'2024-07-18 16:00:00.000000'),(142,263,'2024-07-18 16:00:00.000000'),(3940,33860,'2024-07-18 16:00:00.000000'),(380765,236,'2024-07-18 16:00:00.000000'),(11,1530,'2024-07-18 16:00:00.000000'),(402096,2610,'2024-07-18 16:00:00.000000'),(356641,1100,'2024-07-18 16:00:00.000000'),(269583,26523,'2024-07-18 16:00:00.000000'),(103920,1050,'2024-07-18 16:00:00.000000'),(13324,1473,'2024-07-18 16:00:00.000000'),(61,12762,'2024-07-18 16:00:00.000000'),(391886,1239,'2024-07-18 16:00:00.000000'),(336963,1329,'2024-07-18 16:00:00.000000'),(269339,6818,'2024-07-18 16:00:00.000000'),(242263,2144,'2024-07-18 16:00:00.000000'),(141,3868,'2024-07-18 16:00:00.000000'),(159566,16428,'2024-07-18 16:00:00.000000'),(160616,135,'2024-07-18 16:00:00.000000'),(268954,4824,'2024-07-18 16:00:00.000000'),(4,1257,'2024-07-18 16:00:00.000000'),(161609,11166,'2024-07-18 16:00:00.000000'),(69379,5055,'2024-07-18 16:00:00.000000'),(354236,8273,'2024-07-18 16:00:00.000000'),(137,3264,'2024-07-18 16:00:00.000000'),(164,1088,'2024-07-18 16:00:00.000000'),(97857,136,'2024-07-18 16:00:00.000000'),(93579,205,'2024-07-18 16:00:00.000000'),(110,474,'2024-07-18 16:00:00.000000'),(93,1764,'2024-07-18 16:00:00.000000'),(303906,2095,'2024-07-18 16:00:00.000000'),(77377,3032,'2024-07-18 16:00:00.000000'),(275013,9312,'2024-07-18 16:00:00.000000'),(123,2095,'2024-07-18 16:00:00.000000'),(87907,8160,'2024-07-18 16:00:00.000000'),(296457,118,'2024-07-18 16:00:00.000000'),(1471,792,'2024-07-18 16:00:00.000000'),(8,118,'2024-07-18 16:00:00.000000'),(67383,4410,'2024-07-18 16:00:00.000000'),(34,984,'2024-07-18 16:00:00.000000'),(66,2381,'2024-07-18 16:00:00.000000'),(352787,588,'2024-07-18 16:00:00.000000'),(412769,708,'2024-07-18 16:00:00.000000'),(371145,54,'2024-07-18 16:00:00.000000'),(389643,236,'2024-07-18 16:00:00.000000'),(380665,90,'2024-07-18 16:00:00.000000'),(174440,1496,'2024-07-18 16:00:00.000000'),(383225,948,'2024-07-18 16:00:00.000000'),(280544,0,'2024-07-18 16:00:00.000000'),(31476,1073,'2024-07-18 16:00:00.000000'),(227196,7824,'2024-07-18 16:00:00.000000'),(412533,708,'2024-07-18 16:00:00.000000'),(1649,1656,'2024-07-18 16:00:00.000000'),(404583,2011,'2024-07-18 16:00:00.000000'),(6069,28116,'2024-07-18 16:00:00.000000'),(410700,826,'2024-07-18 16:00:00.000000'),(404820,358,'2024-07-18 16:00:00.000000'),(185893,474,'2024-07-18 16:00:00.000000'),(345300,4284,'2024-07-18 16:00:00.000000'),(382101,358,'2024-07-18 16:00:00.000000'),(51609,2040,'2024-07-18 16:00:00.000000'),(414568,179,'2024-07-18 16:00:00.000000'),(335577,0,'2024-07-18 16:00:00.000000'),(2593,45,'2024-07-18 16:00:00.000000'),(213014,3640,'2024-07-18 16:00:00.000000'),(409201,708,'2024-07-18 16:00:00.000000'),(270017,1291,'2024-07-18 16:00:00.000000'),(73,4204,'2024-07-18 16:00:00.000000'),(249042,1892,'2024-07-18 16:00:00.000000'),(1958,7432,'2024-07-18 16:00:00.000000'),(342468,3312,'2024-07-18 16:00:00.000000'),(421224,708,'2024-07-18 16:00:00.000000'),(1071,1644,'2024-07-18 16:00:00.000000'),(396777,1244,'2024-07-18 16:00:00.000000'),(259111,0,'2024-07-18 16:00:00.000000'),(121,1481,'2024-07-18 16:00:00.000000'),(97,1206,'2024-07-18 16:00:00.000000'),(380316,696,'2024-07-18 16:00:00.000000'),(146166,798,'2024-07-18 16:00:00.000000'),(358886,1896,'2024-07-18 16:00:00.000000'),(48900,1512,'2024-07-18 16:00:00.000000'),(269632,4812,'2024-07-18 16:00:00.000000'),(90281,1584,'2024-07-18 16:00:00.000000'),(9,4556,'2024-07-18 16:00:00.000000'),(267713,344,'2024-07-18 16:00:00.000000'),(144384,474,'2024-07-18 16:00:00.000000'),(26283,2176,'2024-07-18 16:00:00.000000'),(898,296,'2024-07-18 16:00:00.000000'),(163374,2718,'2024-07-18 16:00:00.000000'),(206580,68,'2024-07-18 16:00:00.000000'),(132,0,'2024-07-18 16:00:00.000000'),(379005,1380,'2024-07-18 16:00:00.000000'),(374757,460,'2024-07-18 16:00:00.000000'),(389928,716,'2024-07-18 16:00:00.000000'),(279951,106,'2024-07-18 16:00:00.000000'),(357181,11376,'2024-07-18 16:00:00.000000'),(217860,792,'2024-07-18 16:00:00.000000'),(381577,956,'2024-07-18 16:00:00.000000'),(348968,60,'2024-07-18 16:00:00.000000'),(139,1485,'2024-07-18 16:00:00.000000'),(91236,1224,'2024-07-18 16:00:00.000000'),(79843,6099,'2024-07-18 16:00:00.000000'),(86090,1074,'2024-07-18 16:00:00.000000'),(392278,479,'2024-07-18 16:00:00.000000'),(270602,1108,'2024-07-18 16:00:00.000000'),(44,792,'2024-07-18 16:00:00.000000'),(326483,5618,'2024-07-18 16:00:00.000000'),(420413,1770,'2024-07-18 16:00:00.000000'),(1258,468,'2024-07-18 16:00:00.000000'),(143961,10367,'2024-07-18 16:00:00.000000'),(145740,1397,'2024-07-18 16:00:00.000000'),(274697,277,'2024-07-18 16:00:00.000000'),(48,474,'2024-07-18 16:00:00.000000'),(119,1845,'2024-07-18 16:00:00.000000'),(366194,344,'2024-07-18 16:00:00.000000'),(67,414,'2024-07-18 16:00:00.000000'),(148509,2268,'2024-07-18 16:00:00.000000'),(353051,3212,'2024-07-18 16:00:00.000000'),(357669,114,'2024-07-18 16:00:00.000000'),(29980,1234,'2024-07-18 16:00:00.000000'),(347900,0,'2024-07-18 16:00:00.000000'),(163608,159,'2024-07-18 16:00:00.000000'),(63,1422,'2024-07-18 16:00:00.000000'),(77,18516,'2024-07-18 16:00:00.000000'),(348500,456,'2024-07-18 16:00:00.000000'),(348991,1668,'2024-07-18 16:00:00.000000'),(82,1188,'2024-07-18 16:00:00.000000'),(173051,392,'2024-07-18 16:00:00.000000'),(102,718,'2024-07-18 16:00:00.000000'),(51444,392,'2024-07-18 16:00:00.000000'),(78,174,'2024-07-18 16:00:00.000000'),(240225,354,'2024-07-18 16:00:00.000000'),(109,1782,'2024-07-18 16:00:00.000000'),(338605,197,'2024-07-18 16:00:00.000000'),(195763,104,'2024-07-18 16:00:00.000000'),(186083,55,'2024-07-18 16:00:00.000000'),(328717,106,'2024-07-18 16:00:00.000000'),(164630,544,'2024-07-18 16:00:00.000000'),(379253,413,'2024-07-18 16:00:00.000000'),(24,50,'2024-07-18 16:00:00.000000'),(24457,708,'2024-07-18 16:00:00.000000'),(52499,640,'2024-07-18 16:00:00.000000'),(996,392,'2024-07-18 16:00:00.000000'),(64,354,'2024-07-18 16:00:00.000000'),(67420,2376,'2024-07-18 16:00:00.000000'),(111,359,'2024-07-18 16:00:00.000000'),(68,594,'2024-07-18 16:00:00.000000'),(399206,69,'2024-07-18 16:00:00.000000'),(169095,201,'2024-07-18 16:00:00.000000'),(87404,938,'2024-07-18 16:00:00.000000'),(101,359,'2024-07-18 16:00:00.000000'),(18780,23,'2024-07-18 16:00:00.000000'),(412300,118,'2024-07-18 16:00:00.000000'),(410700,1888,'2024-07-19 16:00:00.000000'),(340532,11968,'2024-07-19 16:00:00.000000'),(336947,1752,'2024-07-19 16:00:00.000000'),(336963,3515,'2024-07-19 16:00:00.000000'),(78740,18636,'2024-07-19 16:00:00.000000'),(397554,11202,'2024-07-19 16:00:00.000000'),(348187,6603,'2024-07-19 16:00:00.000000'),(106148,13531,'2024-07-19 16:00:00.000000'),(412769,1770,'2024-07-19 16:00:00.000000'),(3940,21103,'2024-07-19 16:00:00.000000'),(270888,44544,'2024-07-19 16:00:00.000000'),(73857,23288,'2024-07-19 16:00:00.000000'),(182308,25320,'2024-07-19 16:00:00.000000'),(190618,240,'2024-07-19 16:00:00.000000'),(75,3587,'2024-07-19 16:00:00.000000'),(67019,18727,'2024-07-19 16:00:00.000000'),(97,1036,'2024-07-19 16:00:00.000000'),(303906,2612,'2024-07-19 16:00:00.000000'),(6069,19487,'2024-07-19 16:00:00.000000'),(354236,39096,'2024-07-19 16:00:00.000000'),(346331,2370,'2024-07-19 16:00:00.000000'),(898,528,'2024-07-19 16:00:00.000000'),(67420,7457,'2024-07-19 16:00:00.000000'),(159,2970,'2024-07-19 16:00:00.000000'),(85,474,'2024-07-19 16:00:00.000000'),(9,1918,'2024-07-19 16:00:00.000000'),(87907,7072,'2024-07-19 16:00:00.000000'),(1958,9504,'2024-07-19 16:00:00.000000'),(352924,702,'2024-07-19 16:00:00.000000'),(148509,4577,'2024-07-19 16:00:00.000000'),(393152,8832,'2024-07-19 16:00:00.000000'),(320517,1615,'2024-07-19 16:00:00.000000'),(404820,1359,'2024-07-19 16:00:00.000000'),(353051,280,'2024-07-19 16:00:00.000000'),(227196,6240,'2024-07-19 16:00:00.000000'),(242263,4936,'2024-07-19 16:00:00.000000'),(269339,7640,'2024-07-19 16:00:00.000000'),(269583,26998,'2024-07-19 16:00:00.000000'),(326483,1968,'2024-07-19 16:00:00.000000'),(269632,2428,'2024-07-19 16:00:00.000000'),(370070,174,'2024-07-19 16:00:00.000000'),(143961,26359,'2024-07-19 16:00:00.000000'),(14573,15416,'2024-07-19 16:00:00.000000'),(412533,2118,'2024-07-19 16:00:00.000000'),(140,2916,'2024-07-19 16:00:00.000000'),(391886,649,'2024-07-19 16:00:00.000000'),(142,687,'2024-07-19 16:00:00.000000'),(146166,1248,'2024-07-19 16:00:00.000000'),(13324,1928,'2024-07-19 16:00:00.000000'),(268954,8376,'2024-07-19 16:00:00.000000'),(357181,3912,'2024-07-19 16:00:00.000000'),(161609,4709,'2024-07-19 16:00:00.000000'),(109,11058,'2024-07-19 16:00:00.000000'),(2593,5479,'2024-07-19 16:00:00.000000'),(73,2666,'2024-07-19 16:00:00.000000'),(74,3016,'2024-07-19 16:00:00.000000'),(159566,5501,'2024-07-19 16:00:00.000000'),(160616,43,'2024-07-19 16:00:00.000000'),(175834,1416,'2024-07-19 16:00:00.000000'),(389643,590,'2024-07-19 16:00:00.000000'),(380665,67,'2024-07-19 16:00:00.000000'),(123,2802,'2024-07-19 16:00:00.000000'),(26283,11564,'2024-07-19 16:00:00.000000'),(345300,3371,'2024-07-19 16:00:00.000000'),(106,23184,'2024-07-19 16:00:00.000000'),(121,1552,'2024-07-19 16:00:00.000000'),(409201,649,'2024-07-19 16:00:00.000000'),(275013,3432,'2024-07-19 16:00:00.000000'),(44,1911,'2024-07-19 16:00:00.000000'),(63,5604,'2024-07-19 16:00:00.000000'),(382101,895,'2024-07-19 16:00:00.000000'),(66,4217,'2024-07-19 16:00:00.000000'),(1071,548,'2024-07-19 16:00:00.000000'),(69379,7759,'2024-07-19 16:00:00.000000'),(381577,1195,'2024-07-19 16:00:00.000000'),(348968,75,'2024-07-19 16:00:00.000000'),(52499,1584,'2024-07-19 16:00:00.000000'),(370793,228,'2024-07-19 16:00:00.000000'),(77377,4384,'2024-07-19 16:00:00.000000'),(420413,708,'2024-07-19 16:00:00.000000'),(146460,0,'2024-07-19 16:00:00.000000'),(78,2740,'2024-07-19 16:00:00.000000'),(120,419,'2024-07-19 16:00:00.000000'),(338605,197,'2024-07-19 16:00:00.000000'),(352787,294,'2024-07-19 16:00:00.000000'),(91236,4976,'2024-07-19 16:00:00.000000'),(95,1188,'2024-07-19 16:00:00.000000'),(134,118,'2024-07-19 16:00:00.000000'),(61,19257,'2024-07-19 16:00:00.000000'),(119,1114,'2024-07-19 16:00:00.000000'),(69,6156,'2024-07-19 16:00:00.000000'),(296457,531,'2024-07-19 16:00:00.000000'),(213014,4144,'2024-07-19 16:00:00.000000'),(163374,3403,'2024-07-19 16:00:00.000000'),(54525,718,'2024-07-19 16:00:00.000000'),(169095,402,'2024-07-19 16:00:00.000000'),(97857,2066,'2024-07-19 16:00:00.000000'),(93579,119,'2024-07-19 16:00:00.000000'),(414570,114,'2024-07-19 16:00:00.000000'),(146545,947,'2024-07-19 16:00:00.000000'),(93,834,'2024-07-19 16:00:00.000000'),(90281,4320,'2024-07-19 16:00:00.000000'),(342468,1590,'2024-07-19 16:00:00.000000'),(34,707,'2024-07-19 16:00:00.000000'),(195763,208,'2024-07-19 16:00:00.000000'),(186083,110,'2024-07-19 16:00:00.000000'),(11,3201,'2024-07-19 16:00:00.000000'),(367375,240,'2024-07-19 16:00:00.000000'),(101,718,'2024-07-19 16:00:00.000000'),(366194,1845,'2024-07-19 16:00:00.000000'),(79,228,'2024-07-19 16:00:00.000000'),(320610,522,'2024-07-19 16:00:00.000000'),(390102,354,'2024-07-19 16:00:00.000000'),(380765,177,'2024-07-19 16:00:00.000000'),(414568,179,'2024-07-19 16:00:00.000000'),(135,3570,'2024-07-19 16:00:00.000000'),(48,474,'2024-07-19 16:00:00.000000'),(31476,4594,'2024-07-19 16:00:00.000000'),(1258,395,'2024-07-19 16:00:00.000000'),(402096,598,'2024-07-19 16:00:00.000000'),(356641,1718,'2024-07-19 16:00:00.000000'),(270232,68,'2024-07-19 16:00:00.000000'),(412300,236,'2024-07-19 16:00:00.000000'),(376243,3698,'2024-07-19 16:00:00.000000'),(353687,589,'2024-07-19 16:00:00.000000'),(267884,1620,'2024-07-19 16:00:00.000000'),(102,359,'2024-07-19 16:00:00.000000'),(136,348,'2024-07-19 16:00:00.000000'),(164,1184,'2024-07-19 16:00:00.000000'),(274697,471,'2024-07-19 16:00:00.000000'),(58,600,'2024-07-19 16:00:00.000000'),(396777,358,'2024-07-19 16:00:00.000000'),(141,1257,'2024-07-19 16:00:00.000000'),(317098,3512,'2024-07-19 16:00:00.000000'),(67383,600,'2024-07-19 16:00:00.000000'),(357669,228,'2024-07-19 16:00:00.000000'),(24582,712,'2024-07-19 16:00:00.000000'),(412764,504,'2024-07-19 16:00:00.000000'),(137,2856,'2024-07-19 16:00:00.000000'),(389928,3826,'2024-07-19 16:00:00.000000'),(279951,4681,'2024-07-19 16:00:00.000000'),(341834,239,'2024-07-19 16:00:00.000000'),(379005,348,'2024-07-19 16:00:00.000000'),(374757,116,'2024-07-19 16:00:00.000000'),(138,348,'2024-07-19 16:00:00.000000'),(399212,354,'2024-07-19 16:00:00.000000'),(408708,59,'2024-07-19 16:00:00.000000'),(348616,351,'2024-07-19 16:00:00.000000'),(293390,696,'2024-07-19 16:00:00.000000'),(249042,359,'2024-07-19 16:00:00.000000'),(308732,317,'2024-07-19 16:00:00.000000'),(1471,792,'2024-07-19 16:00:00.000000'),(87404,673,'2024-07-19 16:00:00.000000'),(379253,209,'2024-07-19 16:00:00.000000'),(15966,2392,'2024-07-19 16:00:00.000000'),(145740,600,'2024-07-19 16:00:00.000000'),(358886,1656,'2024-07-19 16:00:00.000000'),(352007,741,'2024-07-19 16:00:00.000000'),(226924,118,'2024-07-19 16:00:00.000000'),(341103,272,'2024-07-19 16:00:00.000000'),(104,528,'2024-07-19 16:00:00.000000'),(376093,337,'2024-07-19 16:00:00.000000'),(139,2933,'2024-07-19 16:00:00.000000'),(425674,37566,'2024-07-19 16:00:00.000000'),(425534,234,'2024-07-19 16:00:00.000000'),(371600,114,'2024-07-19 16:00:00.000000'),(92,359,'2024-07-19 16:00:00.000000'),(424452,177,'2024-07-19 16:00:00.000000'),(328717,45,'2024-07-19 16:00:00.000000'),(4,838,'2024-07-19 16:00:00.000000'),(174440,2840,'2024-07-19 16:00:00.000000'),(240225,2478,'2024-07-19 16:00:00.000000'),(113,1132,'2024-07-19 16:00:00.000000'),(421408,202,'2024-07-19 16:00:00.000000'),(164630,2480,'2024-07-19 16:00:00.000000'),(7,414,'2024-07-19 16:00:00.000000'),(103920,818,'2024-07-19 16:00:00.000000'),(335577,9648,'2024-07-19 16:00:00.000000'),(132,359,'2024-07-19 16:00:00.000000'),(348500,228,'2024-07-19 16:00:00.000000'),(163608,477,'2024-07-19 16:00:00.000000'),(351513,197,'2024-07-19 16:00:00.000000'),(344844,882,'2024-07-19 16:00:00.000000'),(99,359,'2024-07-19 16:00:00.000000'),(29980,204,'2024-07-19 16:00:00.000000'),(430734,236,'2024-07-19 16:00:00.000000'),(81,897,'2024-07-19 16:00:00.000000'),(390102,236,'2024-07-20 16:00:00.000000'),(340532,8451,'2024-07-20 16:00:00.000000'),(336947,1018,'2024-07-20 16:00:00.000000'),(336963,3681,'2024-07-20 16:00:00.000000'),(78740,12101,'2024-07-20 16:00:00.000000'),(348187,6276,'2024-07-20 16:00:00.000000'),(159,3015,'2024-07-20 16:00:00.000000'),(270888,16614,'2024-07-20 16:00:00.000000'),(73857,7838,'2024-07-20 16:00:00.000000'),(393152,9024,'2024-07-20 16:00:00.000000'),(320517,1141,'2024-07-20 16:00:00.000000'),(346331,2679,'2024-07-20 16:00:00.000000'),(182308,6900,'2024-07-20 16:00:00.000000'),(354236,46848,'2024-07-20 16:00:00.000000'),(397554,7950,'2024-07-20 16:00:00.000000'),(106148,9102,'2024-07-20 16:00:00.000000'),(404820,882,'2024-07-20 16:00:00.000000'),(376243,-594,'2024-07-20 16:00:00.000000'),(353687,-95,'2024-07-20 16:00:00.000000'),(242263,10984,'2024-07-20 16:00:00.000000'),(164630,1776,'2024-07-20 16:00:00.000000'),(410700,354,'2024-07-20 16:00:00.000000'),(161609,3616,'2024-07-20 16:00:00.000000'),(269583,3652,'2024-07-20 16:00:00.000000'),(6069,28840,'2024-07-20 16:00:00.000000'),(106,4752,'2024-07-20 16:00:00.000000'),(3940,20485,'2024-07-20 16:00:00.000000'),(77377,6056,'2024-07-20 16:00:00.000000'),(338605,857,'2024-07-20 16:00:00.000000'),(389928,537,'2024-07-20 16:00:00.000000'),(279951,1077,'2024-07-20 16:00:00.000000'),(1958,8376,'2024-07-20 16:00:00.000000'),(227196,5080,'2024-07-20 16:00:00.000000'),(26283,1746,'2024-07-20 16:00:00.000000'),(430734,472,'2024-07-20 16:00:00.000000'),(190618,1440,'2024-07-20 16:00:00.000000'),(275013,1412,'2024-07-20 16:00:00.000000'),(67019,22970,'2024-07-20 16:00:00.000000'),(159566,10149,'2024-07-20 16:00:00.000000'),(160616,80,'2024-07-20 16:00:00.000000'),(75,6202,'2024-07-20 16:00:00.000000'),(268954,3523,'2024-07-20 16:00:00.000000'),(358886,3012,'2024-07-20 16:00:00.000000'),(148509,2276,'2024-07-20 16:00:00.000000'),(69,7890,'2024-07-20 16:00:00.000000'),(344844,882,'2024-07-20 16:00:00.000000'),(425674,7584,'2024-07-20 16:00:00.000000'),(61,15449,'2024-07-20 16:00:00.000000'),(143961,6135,'2024-07-20 16:00:00.000000'),(14573,11187,'2024-07-20 16:00:00.000000'),(370070,582,'2024-07-20 16:00:00.000000'),(1258,234,'2024-07-20 16:00:00.000000'),(409201,767,'2024-07-20 16:00:00.000000'),(139,19107,'2024-07-20 16:00:00.000000'),(66,9025,'2024-07-20 16:00:00.000000'),(326483,7864,'2024-07-20 16:00:00.000000'),(93,3635,'2024-07-20 16:00:00.000000'),(303906,4060,'2024-07-20 16:00:00.000000'),(412769,354,'2024-07-20 16:00:00.000000'),(342468,1242,'2024-07-20 16:00:00.000000'),(73,12953,'2024-07-20 16:00:00.000000'),(91236,904,'2024-07-20 16:00:00.000000'),(269339,13146,'2024-07-20 16:00:00.000000'),(396777,179,'2024-07-20 16:00:00.000000'),(87907,4352,'2024-07-20 16:00:00.000000'),(996,784,'2024-07-20 16:00:00.000000'),(79843,1346,'2024-07-20 16:00:00.000000'),(86090,236,'2024-07-20 16:00:00.000000'),(135,828,'2024-07-20 16:00:00.000000'),(142,169,'2024-07-20 16:00:00.000000'),(357181,4974,'2024-07-20 16:00:00.000000'),(408708,826,'2024-07-20 16:00:00.000000'),(380665,148,'2024-07-20 16:00:00.000000'),(109,648,'2024-07-20 16:00:00.000000'),(2593,210,'2024-07-20 16:00:00.000000'),(380765,295,'2024-07-20 16:00:00.000000'),(123,1485,'2024-07-20 16:00:00.000000'),(352924,293,'2024-07-20 16:00:00.000000'),(404583,119,'2024-07-20 16:00:00.000000'),(74,8960,'2024-07-20 16:00:00.000000'),(249042,1256,'2024-07-20 16:00:00.000000'),(391886,531,'2024-07-20 16:00:00.000000'),(67420,4744,'2024-07-20 16:00:00.000000'),(382101,118,'2024-07-20 16:00:00.000000'),(399212,590,'2024-07-20 16:00:00.000000'),(146166,1602,'2024-07-20 16:00:00.000000'),(13324,4955,'2024-07-20 16:00:00.000000'),(97,1458,'2024-07-20 16:00:00.000000'),(402096,1903,'2024-07-20 16:00:00.000000'),(356641,1076,'2024-07-20 16:00:00.000000'),(26,951,'2024-07-20 16:00:00.000000'),(141,838,'2024-07-20 16:00:00.000000'),(352007,1008,'2024-07-20 16:00:00.000000'),(320610,587,'2024-07-20 16:00:00.000000'),(34,1887,'2024-07-20 16:00:00.000000'),(420413,0,'2024-07-20 16:00:00.000000'),(175834,1770,'2024-07-20 16:00:00.000000'),(357669,114,'2024-07-20 16:00:00.000000'),(8,946,'2024-07-20 16:00:00.000000'),(267884,278,'2024-07-20 16:00:00.000000'),(329947,1248,'2024-07-20 16:00:00.000000'),(169095,3945,'2024-07-20 16:00:00.000000'),(11,1056,'2024-07-20 16:00:00.000000'),(412300,59,'2024-07-20 16:00:00.000000'),(137,816,'2024-07-20 16:00:00.000000'),(164,388,'2024-07-20 16:00:00.000000'),(421224,472,'2024-07-20 16:00:00.000000'),(366194,688,'2024-07-20 16:00:00.000000'),(68,0,'2024-07-20 16:00:00.000000'),(381577,717,'2024-07-20 16:00:00.000000'),(348968,48,'2024-07-20 16:00:00.000000'),(82,1188,'2024-07-20 16:00:00.000000'),(69379,3232,'2024-07-20 16:00:00.000000'),(338334,118,'2024-07-20 16:00:00.000000'),(102,359,'2024-07-20 16:00:00.000000'),(213014,2208,'2024-07-20 16:00:00.000000'),(269632,208,'2024-07-20 16:00:00.000000'),(163374,1193,'2024-07-20 16:00:00.000000'),(103920,600,'2024-07-20 16:00:00.000000'),(240225,354,'2024-07-20 16:00:00.000000'),(9,600,'2024-07-20 16:00:00.000000'),(352787,294,'2024-07-20 16:00:00.000000'),(1071,274,'2024-07-20 16:00:00.000000'),(163608,232,'2024-07-20 16:00:00.000000'),(121,3512,'2024-07-20 16:00:00.000000'),(146340,840,'2024-07-20 16:00:00.000000'),(48900,240,'2024-07-20 16:00:00.000000'),(270017,680,'2024-07-20 16:00:00.000000'),(37634,4672,'2024-07-20 16:00:00.000000'),(409130,177,'2024-07-20 16:00:00.000000'),(174440,1480,'2024-07-20 16:00:00.000000'),(421408,126,'2024-07-20 16:00:00.000000'),(280318,140,'2024-07-20 16:00:00.000000'),(92,707,'2024-07-20 16:00:00.000000'),(136,348,'2024-07-20 16:00:00.000000'),(78,174,'2024-07-20 16:00:00.000000'),(44,480,'2024-07-20 16:00:00.000000'),(416251,474,'2024-07-20 16:00:00.000000'),(270602,277,'2024-07-20 16:00:00.000000'),(31476,1555,'2024-07-20 16:00:00.000000'),(341103,0,'2024-07-20 16:00:00.000000'),(63,1422,'2024-07-20 16:00:00.000000'),(389643,59,'2024-07-20 16:00:00.000000'),(146460,436,'2024-07-20 16:00:00.000000'),(13820,3744,'2024-07-20 16:00:00.000000'),(425534,522,'2024-07-20 16:00:00.000000'),(345300,2247,'2024-07-20 16:00:00.000000'),(29980,622,'2024-07-20 16:00:00.000000'),(140,354,'2024-07-20 16:00:00.000000'),(77,1782,'2024-07-20 16:00:00.000000'),(146545,150,'2024-07-20 16:00:00.000000'),(151,359,'2024-07-20 16:00:00.000000'),(335577,358,'2024-07-20 16:00:00.000000'),(120,419,'2024-07-20 16:00:00.000000'),(90281,2688,'2024-07-20 16:00:00.000000'),(414570,114,'2024-07-20 16:00:00.000000'),(426738,118,'2024-07-20 16:00:00.000000'),(328717,554,'2024-07-20 16:00:00.000000'),(81,118,'2024-07-20 16:00:00.000000'),(399876,622,'2024-07-20 16:00:00.000000'),(67383,408,'2024-07-20 16:00:00.000000'),(426274,234,'2024-07-20 16:00:00.000000'),(95,594,'2024-07-20 16:00:00.000000'),(1649,552,'2024-07-20 16:00:00.000000'),(412533,708,'2024-07-20 16:00:00.000000'),(46302,366,'2024-07-20 16:00:00.000000'),(145740,1499,'2024-07-20 16:00:00.000000'),(357146,59,'2024-07-20 16:00:00.000000'),(353051,140,'2024-07-20 16:00:00.000000'),(392278,320,'2024-07-20 16:00:00.000000'),(51609,312,'2024-07-20 16:00:00.000000'),(432959,84,'2024-07-20 16:00:00.000000'),(110,474,'2024-07-20 16:00:00.000000'),(379253,209,'2024-07-20 16:00:00.000000'),(348616,351,'2024-07-20 16:00:00.000000'),(226924,936,'2024-07-20 16:00:00.000000'),(10,294,'2024-07-20 16:00:00.000000');
/*!40000 ALTER TABLE `vas_cur_streamer_income` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vas_day_detail`
--

DROP TABLE IF EXISTS `vas_day_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vas_day_detail` (
  `ptime` timestamp(6) NOT NULL,
  `membership_cnt` bigint NOT NULL,
  `membership_flow` bigint NOT NULL,
  `zone_admission_cnt` bigint NOT NULL,
  `zone_admission_flow` bigint NOT NULL,
  `zone_superfan_cnt` bigint NOT NULL,
  `zone_superfan_flow` bigint NOT NULL,
  `zone_moment_cnt` bigint NOT NULL,
  `zone_moment_flow` bigint NOT NULL,
  `other_cnt` bigint NOT NULL,
  `other_flow` bigint NOT NULL,
  `total_flow` bigint NOT NULL,
  `streamer_flow` bigint NOT NULL,
  `official_flow` bigint NOT NULL,
  `profit_rate` float NOT NULL,
  `membership_rate` float NOT NULL,
  `zone_admission_rate` float NOT NULL,
  `zone_superfan_rate` float NOT NULL,
  `zone_moment_rate` float NOT NULL,
  `other_rate` float NOT NULL,
  UNIQUE KEY `ptime` (`ptime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vas_day_detail`
--

LOCK TABLES `vas_day_detail` WRITE;
/*!40000 ALTER TABLE `vas_day_detail` DISABLE KEYS */;
INSERT INTO `vas_day_detail` VALUES ('2024-04-14 16:00:00.000000',7,343,0,0,0,0,0,0,3,200,543,354,189,0.348066,0.631676,0,0,0,0.368324),('2024-04-15 16:00:00.000000',6,294,0,0,0,0,0,0,9,4348,4642,3513,1129,0.243214,0.0633348,0,0,0,0.936665),('2024-04-16 16:00:00.000000',8,392,0,0,0,0,0,0,1,50,442,156,286,0.647059,0.886878,0,0,0,0.113122),('2024-04-17 16:00:00.000000',7,343,0,0,0,0,0,0,4,499,842,475,367,0.435867,0.407363,0,0,0,0.592637),('2024-04-18 16:00:00.000000',6,294,0,0,0,0,0,0,1,100,394,157,237,0.601523,0.746193,0,0,0,0.253807),('2024-04-19 16:00:00.000000',6,294,1,99,0,0,0,0,1,110,503,157,346,0.687873,0.584493,0.196819,0,0,0.218688),('2024-04-20 16:00:00.000000',13,637,0,0,0,0,0,0,0,0,637,274,363,0.569859,1,0,0,0,0),('2024-04-21 16:00:00.000000',14,686,0,0,0,0,0,0,0,0,686,117,569,0.829446,1,0,0,0,0),('2024-04-22 16:00:00.000000',9,441,0,0,0,0,0,0,0,0,441,156,285,0.646259,1,0,0,0,0),('2024-04-23 16:00:00.000000',11,539,0,0,0,0,0,0,5,446,985,542,443,0.449746,0.547208,0,0,0,0.452792),('2024-04-24 16:00:00.000000',8,392,2,2,0,0,0,0,1,100,494,83,411,0.831984,0.793522,0.00404858,0,0,0.202429),('2024-04-25 16:00:00.000000',7,343,2,70,0,0,0,0,1,1,414,330,84,0.202899,0.828502,0.169082,0,0,0.00241546),('2024-04-26 16:00:00.000000',4,196,0,0,0,0,0,0,0,0,196,437,-241,-1.22959,1,0,0,0,0),('2024-04-27 16:00:00.000000',11,539,4,396,0,0,0,0,1,100,1035,584,451,0.435749,0.520773,0.382609,0,0,0.0966184),('2024-04-28 16:00:00.000000',10,490,13,1189,0,0,2,87,8,3978,5744,4473,1271,0.221274,0.0853064,0.206999,0,0.0151462,0.692549),('2024-04-29 16:00:00.000000',19,931,12,1188,0,0,1,399,5,269,2787,1200,1587,0.56943,0.334051,0.426265,0,0.143165,0.0965196),('2024-04-30 16:00:00.000000',43,2107,27,2533,0,0,4,524,9,949,6113,3116,2997,0.490267,0.344675,0.414363,0,0.085719,0.155243),('2024-05-01 16:00:00.000000',109,5341,63,4666,0,0,6,1468,8,1550,13025,6428,6597,0.506488,0.410058,0.358234,0,0.112706,0.119002),('2024-05-02 16:00:00.000000',141,6909,122,8967,2,2891,25,3307,12,4119,26193,14577,11616,0.443477,0.263773,0.342343,0.110373,0.126255,0.157256),('2024-05-03 16:00:00.000000',105,5145,121,8798,0,0,46,5653,11,633,20229,12413,7816,0.386376,0.254338,0.43492,0,0.27945,0.0312917),('2024-05-04 16:00:00.000000',171,8379,188,13539,0,0,72,8182,5,179,30279,17476,12803,0.422834,0.276726,0.447142,0,0.27022,0.00591169),('2024-05-05 16:00:00.000000',132,6468,155,11394,0,0,70,5151,16,2425,25438,15653,9785,0.384661,0.254265,0.447913,0,0.202492,0.0953298),('2024-05-06 16:00:00.000000',139,6811,199,14732,1,2888,83,7224,24,1348,33003,19861,13142,0.398206,0.206375,0.446384,0.0875072,0.218889,0.0408448),('2024-05-07 16:00:00.000000',307,15043,314,24908,2,5776,132,12080,31,4937,62744,37043,25701,0.409617,0.239752,0.396978,0.0920566,0.192528,0.0786848),('2024-05-08 16:00:00.000000',144,7056,249,19229,1,2888,137,8754,21,3948,41875,26395,15480,0.369672,0.168501,0.4592,0.0689672,0.209051,0.0942806),('2024-05-09 16:00:00.000000',59,2891,211,16212,0,0,105,6878,16,1378,27359,19505,7854,0.287072,0.105669,0.592566,0,0.251398,0.0503673),('2024-05-10 16:00:00.000000',130,6370,199,15746,3,297,96,6578,17,1682,30673,19782,10891,0.355068,0.207675,0.51335,0.00968278,0.214456,0.0548365),('2024-05-11 16:00:00.000000',102,4998,156,12689,2,3087,102,9560,7,1247,31581,21063,10518,0.333048,0.15826,0.401792,0.0977486,0.302714,0.0394858),('2024-05-12 16:00:00.000000',87,4263,149,12267,6,1494,87,8011,18,2764,28799,19397,9402,0.32647,0.148026,0.425952,0.0518768,0.278169,0.0959756),('2024-05-13 16:00:00.000000',73,3577,150,12402,4,917,88,6324,15,3411,26631,18216,8415,0.315985,0.134317,0.465698,0.0344336,0.237468,0.128084),('2024-05-14 16:00:00.000000',96,4704,144,11354,5,3584,97,7626,13,4684,31952,21692,10260,0.321107,0.147221,0.355346,0.112168,0.238671,0.146595),('2024-05-15 16:00:00.000000',78,3822,143,10808,2,298,104,9094,16,1059,25081,16961,8120,0.323751,0.152386,0.430924,0.0118815,0.362585,0.0422232),('2024-05-16 16:00:00.000000',36,1764,135,10467,7,1182,118,9169,12,2365,24947,18380,6567,0.263238,0.0707099,0.419569,0.0473804,0.367539,0.094801),('2024-05-17 16:00:00.000000',25,1225,108,8417,3,414,58,5644,14,1035,16735,12453,4282,0.255871,0.0731999,0.502958,0.0247386,0.337257,0.0618464),('2024-05-18 16:00:00.000000',33,1617,161,12652,6,3639,97,6833,22,3295,28036,20907,7129,0.25428,0.0576758,0.451277,0.129797,0.243722,0.117527),('2024-05-19 16:00:00.000000',28,1372,265,12992,3,1590,140,8665,9,1058,25677,19380,6297,0.245239,0.053433,0.505978,0.0619231,0.337462,0.0412042),('2024-05-20 16:00:00.000000',38,1862,521,11942,10,1602,345,6393,23,4713,26512,19461,7051,0.265955,0.0702323,0.450438,0.0604255,0.241136,0.177769),('2024-05-21 16:00:00.000000',26,1274,535,14520,5,995,464,10291,19,1154,28234,21277,6957,0.246405,0.0451229,0.514274,0.0352412,0.36449,0.0408727),('2024-05-22 16:00:00.000000',15,735,509,16538,4,914,365,6793,17,3989,28969,22280,6689,0.230902,0.025372,0.570886,0.031551,0.234492,0.137699),('2024-05-23 16:00:00.000000',9,441,752,20105,5,1873,488,10230,21,2974,35623,27648,7975,0.223872,0.0123796,0.564383,0.0525784,0.287174,0.0834854),('2024-05-24 16:00:00.000000',11,539,579,16519,6,1913,343,7252,18,1655,27878,21708,6170,0.221321,0.0193342,0.592546,0.0686204,0.260133,0.0593658),('2024-05-25 16:00:00.000000',6,294,386,15510,7,4160,273,8329,19,1192,29485,23222,6263,0.212413,0.00997117,0.52603,0.141089,0.282483,0.0404273),('2024-05-26 16:00:00.000000',4,196,452,17049,5,1312,317,8298,7,325,27180,21346,5834,0.214643,0.00721118,0.627263,0.0482708,0.305298,0.0119573),('2024-05-27 16:00:00.000000',11,539,411,15841,7,1849,267,7938,14,817,26984,20847,6137,0.227431,0.0199748,0.587052,0.0685221,0.294174,0.0302772),('2024-05-28 16:00:00.000000',14,686,481,18605,13,6117,298,8412,19,3262,37082,29003,8079,0.217869,0.0184995,0.501726,0.164959,0.226849,0.0879672),('2024-05-29 16:00:00.000000',10,490,452,14221,8,2684,359,9831,16,3241,30467,24094,6373,0.209177,0.016083,0.466767,0.0880953,0.322677,0.106377),('2024-05-30 16:00:00.000000',7,343,553,16794,4,674,429,9898,24,1456,29165,21658,7507,0.257398,0.0117607,0.575827,0.0231099,0.339379,0.0499229),('2024-05-31 16:00:00.000000',12,588,541,15976,6,4800,399,9378,20,3593,34335,25864,8471,0.246716,0.0171254,0.465298,0.139799,0.273132,0.104645),('2024-06-01 16:00:00.000000',9,441,566,18502,13,3214,403,8964,19,6161,37282,29412,7870,0.211094,0.0118288,0.496272,0.0862078,0.240438,0.165254),('2024-06-02 16:00:00.000000',7,343,489,16853,7,3862,412,10805,10,2133,33996,26873,7123,0.209525,0.0100894,0.495735,0.113602,0.317832,0.0627427),('2024-06-03 16:00:00.000000',9,441,623,18249,5,6251,523,11938,10,2477,39356,31011,8345,0.212039,0.0112054,0.46369,0.158832,0.303334,0.0629383),('2024-06-04 16:00:00.000000',25,1225,2640,39989,7,2365,1802,26617,18,5598,75794,59347,16447,0.216996,0.0161622,0.527601,0.031203,0.351176,0.0738581),('2024-06-05 16:00:00.000000',10,490,645,19742,2,337,226,9267,16,1095,30931,24256,6675,0.215803,0.0158417,0.638259,0.0108952,0.299602,0.0354014),('2024-06-06 16:00:00.000000',12,588,1271,24790,4,863,446,13118,14,3107,42466,33173,9293,0.218834,0.0138464,0.583761,0.0203221,0.308906,0.0731644),('2024-06-07 16:00:00.000000',12,588,1766,32619,8,6811,651,18377,28,3363,61758,48800,12958,0.209819,0.00952103,0.528174,0.110285,0.297565,0.0544545),('2024-06-08 16:00:00.000000',11,539,1153,30569,9,5691,496,15008,34,5469,57276,44297,12979,0.226605,0.00941057,0.533714,0.099361,0.262029,0.095485),('2024-06-09 16:00:00.000000',10,490,739,24890,9,10431,328,13433,22,3414,52658,41700,10958,0.208098,0.00930533,0.472673,0.19809,0.255099,0.0648335),('2024-06-10 16:00:00.000000',6,294,654,20801,6,3741,271,10820,31,2886,38542,30378,8164,0.211821,0.00762804,0.539697,0.0970629,0.280733,0.0748794),('2024-06-11 16:00:00.000000',10,490,757,26800,11,4679,366,16067,30,4049,52085,40679,11406,0.218988,0.0094077,0.514544,0.0898339,0.308477,0.0777383),('2024-06-12 16:00:00.000000',22,1078,965,28628,11,4987,496,15118,19,1653,51464,39842,11622,0.225828,0.0209467,0.556272,0.0969027,0.293759,0.0321195),('2024-06-13 16:00:00.000000',25,1225,1378,32659,8,7818,643,17689,53,6828,66219,51372,14847,0.224211,0.0184992,0.493197,0.118063,0.267129,0.103112),('2024-06-14 16:00:00.000000',31,1519,2711,50177,9,9297,702,16490,41,8371,85854,67028,18826,0.219279,0.0176928,0.584446,0.108288,0.19207,0.0975027),('2024-06-15 16:00:00.000000',21,1029,1547,37381,12,7479,649,19115,40,3486,68490,53293,15197,0.221886,0.0150241,0.545788,0.109198,0.279092,0.0508979),('2024-06-16 16:00:00.000000',22,1078,1538,33756,12,13260,655,15237,34,6332,69663,54445,15218,0.218452,0.0154745,0.484561,0.190345,0.218724,0.0908947),('2024-06-17 16:00:00.000000',22,1078,2324,41545,12,6177,723,18704,32,3695,71199,55851,15348,0.215565,0.0151407,0.583505,0.0867568,0.2627,0.0518968),('2024-06-18 16:00:00.000000',13,637,1943,37104,13,10214,970,21974,30,2330,72259,56982,15277,0.21142,0.00881551,0.513486,0.141353,0.304101,0.0322451),('2024-06-19 16:00:00.000000',10,490,718,23501,13,9792,495,13991,51,7144,54918,43120,11798,0.214829,0.00892239,0.427929,0.178302,0.254762,0.130085),('2024-06-20 16:00:00.000000',13,637,605,22031,9,3759,550,13526,31,4916,44869,34866,10003,0.222938,0.0141969,0.491007,0.0837772,0.301455,0.109563),('2024-06-21 16:00:00.000000',8,392,560,20697,7,8356,575,12584,36,12977,55006,39557,15449,0.28086,0.0071265,0.376268,0.151911,0.228775,0.23592),('2024-06-22 16:00:00.000000',12,588,545,21277,8,7389,480,12094,25,2961,44309,34775,9534,0.215171,0.0132704,0.480196,0.166761,0.272947,0.0668261),('2024-06-23 16:00:00.000000',19,931,892,27685,12,7692,606,14350,33,3922,54580,43428,11152,0.204324,0.0170575,0.507237,0.140931,0.262917,0.0718578),('2024-06-24 16:00:00.000000',14,686,804,27294,22,12643,531,13852,42,9494,63969,49794,14175,0.221592,0.0107239,0.426675,0.197643,0.216542,0.148416),('2024-06-25 16:00:00.000000',19,931,1120,28652,18,7473,659,14948,37,6292,58296,45449,12847,0.220375,0.0159702,0.491492,0.128191,0.256416,0.107932),('2024-06-26 16:00:00.000000',16,784,969,25595,14,5483,644,15834,38,5259,52955,39274,13681,0.258351,0.014805,0.483335,0.103541,0.299009,0.0993107),('2024-06-27 16:00:00.000000',10,490,735,21377,14,8442,542,13354,34,7457,51120,40093,11027,0.215708,0.00958529,0.418173,0.165141,0.261228,0.145872),('2024-06-28 16:00:00.000000',17,833,719,22861,19,12183,608,16153,26,6481,58511,46327,12184,0.208234,0.0142366,0.390713,0.208217,0.276068,0.110765),('2024-06-29 16:00:00.000000',13,637,780,23483,12,9363,492,12540,27,4813,50836,39567,11269,0.221674,0.0125305,0.461936,0.18418,0.246676,0.094677),('2024-06-30 16:00:00.000000',8,392,701,22570,13,5159,416,11279,33,7847,47247,36703,10544,0.223168,0.00829682,0.477702,0.109192,0.238724,0.166085),('2024-07-01 16:00:00.000000',7,343,1098,26651,8,5988,612,19017,28,4018,56017,44226,11791,0.21049,0.00612314,0.475766,0.106896,0.339486,0.0717282),('2024-07-02 16:00:00.000000',16,784,1172,30917,13,7355,661,15441,39,13801,68298,51255,17043,0.249539,0.0114791,0.452678,0.10769,0.226083,0.20207),('2024-07-03 16:00:00.000000',19,931,1507,33897,11,6717,944,14118,24,5852,61515,48276,13239,0.215216,0.0151345,0.551036,0.109193,0.229505,0.0951313),('2024-07-04 16:00:00.000000',17,833,1162,28658,12,4548,682,12847,24,3237,50123,38894,11229,0.224029,0.0166191,0.571754,0.0907368,0.256309,0.0645811),('2024-07-05 16:00:00.000000',14,686,766,24979,14,6528,698,14314,20,5140,51647,40658,10989,0.212771,0.0132825,0.483649,0.126396,0.277151,0.0995218),('2024-07-06 16:00:00.000000',24,1176,995,27950,13,10808,682,14892,30,3062,57888,45023,12865,0.222239,0.0203151,0.482829,0.186705,0.257255,0.0528952),('2024-07-07 16:00:00.000000',16,784,882,25967,13,2357,613,15550,32,2927,47585,35502,12083,0.253925,0.0164758,0.545697,0.0495324,0.326784,0.061511),('2024-07-08 16:00:00.000000',10,490,770,24983,9,4850,574,13300,36,7947,51570,40520,11050,0.214272,0.00950165,0.484448,0.0940469,0.257902,0.154101),('2024-07-09 16:00:00.000000',8,392,613,23455,6,2381,433,14516,28,3935,44679,34930,9749,0.218201,0.0087737,0.524967,0.0532913,0.324895,0.0880727),('2024-07-10 16:00:00.000000',11,539,751,25502,23,9592,481,14281,29,5134,55048,42197,12851,0.233451,0.00979145,0.463268,0.174248,0.259428,0.0932641),('2024-07-11 16:00:00.000000',24,1176,1032,29645,17,14164,683,15243,17,1047,61275,47523,13752,0.224431,0.0191922,0.483803,0.231155,0.248764,0.0170869),('2024-07-12 16:00:00.000000',17,833,801,26354,18,9501,561,13458,16,1705,51851,40330,11521,0.222194,0.0160653,0.508264,0.183237,0.259551,0.0328827),('2024-07-13 16:00:00.000000',19,931,914,30462,18,9538,617,17940,29,4667,63538,49693,13845,0.217901,0.0146526,0.47943,0.150115,0.282351,0.0734521),('2024-07-14 16:00:00.000000',9,441,738,29063,15,11211,557,16570,20,4079,61364,47758,13606,0.221726,0.00718662,0.473616,0.182697,0.270028,0.0664722),('2024-07-15 16:00:00.000000',23,1127,1105,35977,16,13681,763,16703,31,5067,72555,56995,15560,0.214458,0.015533,0.495858,0.18856,0.230212,0.0698367),('2024-07-16 16:00:00.000000',23,1127,939,31215,19,5750,731,14930,27,2593,55615,43586,12029,0.216291,0.0202643,0.561269,0.103389,0.268453,0.0466241),('2024-07-17 16:00:00.000000',21,1029,1160,39924,17,9791,749,15748,28,12489,78981,61426,17555,0.222269,0.0130285,0.505489,0.123967,0.19939,0.158127),('2024-07-18 16:00:00.000000',22,1078,1143,41470,19,10114,804,20067,35,6131,78860,60685,18175,0.230472,0.0136698,0.525869,0.128253,0.254464,0.0777454),('2024-07-19 16:00:00.000000',16,784,1438,52917,19,10728,696,19427,37,10095,93951,73851,20100,0.213941,0.00834478,0.56324,0.114187,0.206778,0.10745);
/*!40000 ALTER TABLE `vas_day_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vas_day_flow`
--

DROP TABLE IF EXISTS `vas_day_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vas_day_flow` (
  `pdate` timestamp(6) NOT NULL,
  `flow` bigint NOT NULL,
  KEY `pdate` (`pdate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vas_day_flow`
--

LOCK TABLES `vas_day_flow` WRITE;
/*!40000 ALTER TABLE `vas_day_flow` DISABLE KEYS */;
INSERT INTO `vas_day_flow` VALUES ('2024-05-07 16:00:00.000000',6274460),('2024-05-08 16:00:00.000000',4220970),('2024-05-09 16:00:00.000000',2740997),('2024-05-10 16:00:00.000000',3094824),('2024-05-11 16:00:00.000000',3162264),('2024-05-12 16:00:00.000000',2879932),('2024-05-13 16:00:00.000000',2663141),('2024-05-14 16:00:00.000000',3190436),('2024-05-15 16:00:00.000000',2508146),('2024-05-16 16:00:00.000000',2494700),('2024-05-17 16:00:00.000000',1673597),('2024-05-18 16:00:00.000000',2803631),('2024-05-19 16:00:00.000000',2566878),('2024-05-20 16:00:00.000000',2651298),('2024-05-21 16:00:00.000000',2821525),('2024-05-22 16:00:00.000000',2895955),('2024-05-23 16:00:00.000000',3552523),('2024-05-24 16:00:00.000000',2787937),('2024-05-25 16:00:00.000000',2948598),('2024-05-26 16:00:00.000000',2704313),('2024-05-27 16:00:00.000000',2698486),('2024-05-28 16:00:00.000000',3708328),('2024-05-29 16:00:00.000000',3046893),('2024-05-30 16:00:00.000000',2913659),('2024-05-31 16:00:00.000000',3430661),('2024-06-01 16:00:00.000000',3726421),('2024-06-02 16:00:00.000000',3397724),('2024-06-03 16:00:00.000000',3935755),('2024-06-04 16:00:00.000000',7576554),('2024-06-05 16:00:00.000000',3093182),('2024-06-06 16:00:00.000000',4246707),('2024-06-07 16:00:00.000000',6156024),('2024-06-08 16:00:00.000000',5725803),('2024-06-09 16:00:00.000000',5264904),('2024-06-10 16:00:00.000000',3873202),('2024-06-11 16:00:00.000000',5208633),('2024-06-12 16:00:00.000000',5146586),('2024-06-13 16:00:00.000000',6612137),('2024-06-14 16:00:00.000000',8581933),('2024-06-15 16:00:00.000000',6847091),('2024-06-16 16:00:00.000000',6965390),('2024-06-17 16:00:00.000000',7115176),('2024-06-18 16:00:00.000000',7224992),('2024-06-19 16:00:00.000000',5491963),('2024-06-20 16:00:00.000000',4486957),('2024-06-21 16:00:00.000000',5498751),('2024-06-22 16:00:00.000000',4430961),('2024-06-23 16:00:00.000000',5456171),('2024-06-24 16:00:00.000000',6387201),('2024-06-25 16:00:00.000000',5827787),('2024-06-26 16:00:00.000000',5291797),('2024-06-27 16:00:00.000000',5112025),('2024-06-28 16:00:00.000000',5851176),('2024-06-29 16:00:00.000000',5083618),('2024-06-30 16:00:00.000000',4708757),('2024-07-01 16:00:00.000000',5594909),('2024-07-02 16:00:00.000000',6829741),('2024-07-03 16:00:00.000000',6149501),('2024-07-04 16:00:00.000000',5012423),('2024-07-05 16:00:00.000000',5164821),('2024-07-06 16:00:00.000000',5786954),('2024-07-07 16:00:00.000000',4759668),('2024-07-08 16:00:00.000000',5154379),('2024-07-09 16:00:00.000000',4477914),('2024-07-10 16:00:00.000000',5505039),('2024-07-11 16:00:00.000000',6127637),('2024-07-12 16:00:00.000000',5176270),('2024-07-13 16:00:00.000000',6352817),('2024-07-14 16:00:00.000000',6135965),('2024-07-15 16:00:00.000000',7255624),('2024-07-16 16:00:00.000000',5567999),('2024-07-17 16:00:00.000000',7884439),('2024-07-18 16:00:00.000000',7893304),('2024-07-19 16:00:00.000000',9393493),('2024-07-20 16:00:00.000000',6785908);
/*!40000 ALTER TABLE `vas_day_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vas_yoy_flow`
--

DROP TABLE IF EXISTS `vas_yoy_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vas_yoy_flow` (
  `ptime` timestamp(6) NOT NULL,
  `flow` bigint(20) unsigned zerofill NOT NULL,
  KEY `ix_ptime` (`ptime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vas_yoy_flow`
--

LOCK TABLES `vas_yoy_flow` WRITE;
/*!40000 ALTER TABLE `vas_yoy_flow` DISABLE KEYS */;
INSERT INTO `vas_yoy_flow` VALUES ('2024-05-06 16:05:00.000000',00000000000000032500),('2024-05-06 16:10:00.000000',00000000000000058180),('2024-05-06 16:15:00.000000',00000000000000067070),('2024-05-06 16:20:00.000000',00000000000000067070),('2024-05-06 16:25:00.000000',00000000000000117370),('2024-05-06 16:30:00.000000',00000000000000131170),('2024-05-06 16:35:00.000000',00000000000000146870),('2024-05-06 16:40:00.000000',00000000000000146870),('2024-05-06 16:45:00.000000',00000000000000178249),('2024-05-06 16:50:00.000000',00000000000000218549),('2024-05-06 16:55:00.000000',00000000000000250149),('2024-05-06 17:00:00.000000',00000000000000274749),('2024-05-06 17:05:00.000000',00000000000000340249),('2024-05-06 17:10:00.000000',00000000000000374828),('2024-05-06 17:15:00.000000',00000000000000383607),('2024-05-06 17:20:00.000000',00000000000000402407),('2024-05-06 17:25:00.000000',00000000000000450697),('2024-05-06 17:30:00.000000',00000000000000478477),('2024-05-06 17:35:00.000000',00000000000000506877),('2024-05-06 17:40:00.000000',00000000000000534346),('2024-05-06 17:45:00.000000',00000000000000557046),('2024-05-06 17:50:00.000000',00000000000000571746),('2024-05-06 17:55:00.000000',00000000000000593516),('2024-05-06 18:00:00.000000',00000000000000598416),('2024-05-06 18:05:00.000000',00000000000000616116),('2024-05-06 18:10:00.000000',00000000000000616116),('2024-05-06 18:15:00.000000',00000000000000616116),('2024-05-06 18:20:00.000000',00000000000000616116),('2024-05-06 18:25:00.000000',00000000000000620916),('2024-05-06 18:30:00.000000',00000000000000620916),('2024-05-06 18:35:00.000000',00000000000000625816),('2024-05-06 18:40:00.000000',00000000000000633595),('2024-05-06 18:45:00.000000',00000000000000642495),('2024-05-06 18:50:00.000000',00000000000000642495),('2024-05-06 18:55:00.000000',00000000000000642495),('2024-05-06 19:00:00.000000',00000000000000648395),('2024-05-06 19:05:00.000000',00000000000000661195),('2024-05-06 19:10:00.000000',00000000000000666095),('2024-05-06 19:15:00.000000',00000000000000666095),('2024-05-06 19:20:00.000000',00000000000000669995),('2024-05-06 19:25:00.000000',00000000000000694695),('2024-05-06 19:30:00.000000',00000000000000729595),('2024-05-06 19:35:00.000000',00000000000000787995),('2024-05-06 19:40:00.000000',00000000000000796885),('2024-05-06 19:45:00.000000',00000000000000805685),('2024-05-06 19:50:00.000000',00000000000000822265),('2024-05-06 19:55:00.000000',00000000000000856044),('2024-05-06 20:00:00.000000',00000000000000856044),('2024-05-06 20:05:00.000000',00000000000000860944),('2024-05-06 20:10:00.000000',00000000000000860944),('2024-05-06 20:15:00.000000',00000000000000860944),('2024-05-06 20:20:00.000000',00000000000000860944),('2024-05-06 20:25:00.000000',00000000000000860944),('2024-05-06 20:30:00.000000',00000000000000868844),('2024-05-06 20:35:00.000000',00000000000000868844),('2024-05-06 20:40:00.000000',00000000000000868844),('2024-05-06 20:45:00.000000',00000000000000868844),('2024-05-06 20:50:00.000000',00000000000000868844),('2024-05-06 20:55:00.000000',00000000000000868844),('2024-05-06 21:00:00.000000',00000000000000868844),('2024-05-06 21:05:00.000000',00000000000000868844),('2024-05-06 21:10:00.000000',00000000000000868844),('2024-05-06 21:15:00.000000',00000000000000876744),('2024-05-06 21:20:00.000000',00000000000000884644),('2024-05-06 21:25:00.000000',00000000000000890544),('2024-05-06 21:30:00.000000',00000000000000890544),('2024-05-06 21:35:00.000000',00000000000000895444),('2024-05-06 21:40:00.000000',00000000000000912244),('2024-05-06 21:45:00.000000',00000000000000942044),('2024-05-06 21:50:00.000000',00000000000000951023),('2024-05-06 21:55:00.000000',00000000000000951023),('2024-05-06 22:00:00.000000',00000000000000951023),('2024-05-06 22:05:00.000000',00000000000000951023),('2024-05-06 22:10:00.000000',00000000000000951023),('2024-05-06 22:15:00.000000',00000000000000951023),('2024-05-06 22:20:00.000000',00000000000000966823),('2024-05-06 22:25:00.000000',00000000000000970723),('2024-05-06 22:30:00.000000',00000000000000970723),('2024-05-06 22:35:00.000000',00000000000000973623),('2024-05-06 22:40:00.000000',00000000000000973623),('2024-05-06 22:45:00.000000',00000000000000973623),('2024-05-06 22:50:00.000000',00000000000000973623),('2024-05-06 22:55:00.000000',00000000000000981523),('2024-05-06 23:00:00.000000',00000000000000981523),('2024-05-06 23:05:00.000000',00000000000000981523),('2024-05-06 23:10:00.000000',00000000000000995202),('2024-05-06 23:15:00.000000',00000000000000995202),('2024-05-06 23:20:00.000000',00000000000000995202),('2024-05-06 23:25:00.000000',00000000000001005002),('2024-05-06 23:30:00.000000',00000000000001005002),('2024-05-06 23:35:00.000000',00000000000001012902),('2024-05-06 23:40:00.000000',00000000000001031581),('2024-05-06 23:45:00.000000',00000000000001042381),('2024-05-06 23:50:00.000000',00000000000001047281),('2024-05-06 23:55:00.000000',00000000000001052181),('2024-05-07 00:00:00.000000',00000000000001052181),('2024-05-07 00:05:00.000000',00000000000001065960),('2024-05-07 00:10:00.000000',00000000000001065960),('2024-05-07 00:15:00.000000',00000000000001065960),('2024-05-07 00:20:00.000000',00000000000001065960),('2024-05-07 00:25:00.000000',00000000000001065960),('2024-05-07 00:30:00.000000',00000000000001080760),('2024-05-07 00:35:00.000000',00000000000001087660),('2024-05-07 00:40:00.000000',00000000000001095549),('2024-05-07 00:45:00.000000',00000000000001104449),('2024-05-07 00:50:00.000000',00000000000001109349),('2024-05-07 00:55:00.000000',00000000000001109349),('2024-05-07 01:00:00.000000',00000000000001118149),('2024-05-07 01:05:00.000000',00000000000001128949),('2024-05-07 01:10:00.000000',00000000000001154439),('2024-05-07 01:15:00.000000',00000000000001159339),('2024-05-07 01:20:00.000000',00000000000001173139),('2024-05-07 01:25:00.000000',00000000000001185839),('2024-05-07 01:30:00.000000',00000000000001185839),('2024-05-07 01:35:00.000000',00000000000001185839),('2024-05-07 01:40:00.000000',00000000000001190739),('2024-05-07 01:45:00.000000',00000000000001200539),('2024-05-07 01:50:00.000000',00000000000001200539),('2024-05-07 01:55:00.000000',00000000000001209439),('2024-05-07 02:00:00.000000',00000000000001222239),('2024-05-07 02:05:00.000000',00000000000001227139),('2024-05-07 02:10:00.000000',00000000000001227139),('2024-05-07 02:15:00.000000',00000000000001235039),('2024-05-07 02:20:00.000000',00000000000001239939),('2024-05-07 02:25:00.000000',00000000000001247839),('2024-05-07 02:30:00.000000',00000000000001247839),('2024-05-07 02:35:00.000000',00000000000001247839),('2024-05-07 02:40:00.000000',00000000000001247839),('2024-05-07 02:45:00.000000',00000000000001247839),('2024-05-07 02:50:00.000000',00000000000001261639),('2024-05-07 02:55:00.000000',00000000000001321139),('2024-05-07 03:00:00.000000',00000000000001326039),('2024-05-07 03:05:00.000000',00000000000001326039),('2024-05-07 03:10:00.000000',00000000000001340739),('2024-05-07 03:15:00.000000',00000000000001340739),('2024-05-07 03:20:00.000000',00000000000001340739),('2024-05-07 03:25:00.000000',00000000000001340739),('2024-05-07 03:30:00.000000',00000000000001340739),('2024-05-07 03:35:00.000000',00000000000001345639),('2024-05-07 03:40:00.000000',00000000000001345639),('2024-05-07 03:45:00.000000',00000000000001360339),('2024-05-07 03:50:00.000000',00000000000001360339),('2024-05-07 03:55:00.000000',00000000000001360339),('2024-05-07 04:00:00.000000',00000000000001360339),('2024-05-07 04:05:00.000000',00000000000001369118),('2024-05-07 04:10:00.000000',00000000000001374018),('2024-05-07 04:15:00.000000',00000000000001388718),('2024-05-07 04:20:00.000000',00000000000001392597),('2024-05-07 04:25:00.000000',00000000000001411397),('2024-05-07 04:30:00.000000',00000000000001430997),('2024-05-07 04:35:00.000000',00000000000001440897),('2024-05-07 04:40:00.000000',00000000000001454697),('2024-05-07 04:45:00.000000',00000000000001459597),('2024-05-07 04:50:00.000000',00000000000001479397),('2024-05-07 04:55:00.000000',00000000000001487297),('2024-05-07 05:00:00.000000',00000000000001500976),('2024-05-07 05:05:00.000000',00000000000001505876),('2024-05-07 05:10:00.000000',00000000000001510976),('2024-05-07 05:15:00.000000',00000000000001519776),('2024-05-07 05:20:00.000000',00000000000001554476),('2024-05-07 05:25:00.000000',00000000000001573176),('2024-05-07 05:30:00.000000',00000000000001578076),('2024-05-07 05:35:00.000000',00000000000001582976),('2024-05-07 05:40:00.000000',00000000000001595776),('2024-05-07 05:45:00.000000',00000000000001604666),('2024-05-07 05:50:00.000000',00000000000001628066),('2024-05-07 05:55:00.000000',00000000000001658745),('2024-05-07 06:00:00.000000',00000000000001663645),('2024-05-07 06:05:00.000000',00000000000001672545),('2024-05-07 06:10:00.000000',00000000000001672545),('2024-05-07 06:15:00.000000',00000000000001685345),('2024-05-07 06:20:00.000000',00000000000001697124),('2024-05-07 06:25:00.000000',00000000000001708903),('2024-05-07 06:30:00.000000',00000000000001713803),('2024-05-07 06:35:00.000000',00000000000001718703),('2024-05-07 06:40:00.000000',00000000000001729482),('2024-05-07 06:45:00.000000',00000000000001729482),('2024-05-07 06:50:00.000000',00000000000001741282),('2024-05-07 06:55:00.000000',00000000000001741282),('2024-05-07 07:00:00.000000',00000000000001746182),('2024-05-07 07:05:00.000000',00000000000001746182),('2024-05-07 07:10:00.000000',00000000000001746182),('2024-05-07 07:15:00.000000',00000000000001751082),('2024-05-07 07:20:00.000000',00000000000001761882),('2024-05-07 07:25:00.000000',00000000000001761882),('2024-05-07 07:30:00.000000',00000000000001761882),('2024-05-07 07:35:00.000000',00000000000001778482),('2024-05-07 07:40:00.000000',00000000000001778482),('2024-05-07 07:45:00.000000',00000000000001798082),('2024-05-07 07:50:00.000000',00000000000001798082),('2024-05-07 07:55:00.000000',00000000000001798082),('2024-05-07 08:00:00.000000',00000000000001798082),('2024-05-07 08:05:00.000000',00000000000001823782),('2024-05-07 08:10:00.000000',00000000000001833682),('2024-05-07 08:15:00.000000',00000000000001863582),('2024-05-07 08:20:00.000000',00000000000001891182),('2024-05-07 08:25:00.000000',00000000000001913882),('2024-05-07 08:30:00.000000',00000000000001918782),('2024-05-07 08:35:00.000000',00000000000001921772),('2024-05-07 08:40:00.000000',00000000000001933472),('2024-05-07 08:45:00.000000',00000000000001933472),('2024-05-07 08:50:00.000000',00000000000001933472),('2024-05-07 08:55:00.000000',00000000000001943372),('2024-05-07 09:00:00.000000',00000000000001943372),('2024-05-07 09:05:00.000000',00000000000001965072),('2024-05-07 09:10:00.000000',00000000000001965072),('2024-05-07 09:15:00.000000',00000000000001981872),('2024-05-07 09:20:00.000000',00000000000001985772),('2024-05-07 09:25:00.000000',00000000000001985772),('2024-05-07 09:30:00.000000',00000000000001985772),('2024-05-07 09:35:00.000000',00000000000001993672),('2024-05-07 09:40:00.000000',00000000000001997551),('2024-05-07 09:45:00.000000',00000000000002005451),('2024-05-07 09:50:00.000000',00000000000002010351),('2024-05-07 09:55:00.000000',00000000000002015251),('2024-05-07 10:00:00.000000',00000000000002023151),('2024-05-07 10:05:00.000000',00000000000002023151),('2024-05-07 10:10:00.000000',00000000000002029951),('2024-05-07 10:15:00.000000',00000000000002036851),('2024-05-07 10:20:00.000000',00000000000002041751),('2024-05-07 10:25:00.000000',00000000000002051651),('2024-05-07 10:30:00.000000',00000000000002051651),('2024-05-07 10:35:00.000000',00000000000002059551),('2024-05-07 10:40:00.000000',00000000000002072351),('2024-05-07 10:45:00.000000',00000000000002081130),('2024-05-07 10:50:00.000000',00000000000002081130),('2024-05-07 10:55:00.000000',00000000000002081130),('2024-05-07 11:00:00.000000',00000000000002111930),('2024-05-07 11:05:00.000000',00000000000002119830),('2024-05-07 11:10:00.000000',00000000000002119830),('2024-05-07 11:15:00.000000',00000000000002124730),('2024-05-07 11:20:00.000000',00000000000002128630),('2024-05-07 11:25:00.000000',00000000000002133530),('2024-05-07 11:30:00.000000',00000000000002141430),('2024-05-07 11:35:00.000000',00000000000002149330),('2024-05-07 11:40:00.000000',00000000000002158109),('2024-05-07 11:45:00.000000',00000000000002171788),('2024-05-07 11:50:00.000000',00000000000002202388),('2024-05-07 11:55:00.000000',00000000000002211367),('2024-05-07 12:00:00.000000',00000000000002220267),('2024-05-07 12:05:00.000000',00000000000002225167),('2024-05-07 12:10:00.000000',00000000000002232067),('2024-05-07 12:15:00.000000',00000000000002252767),('2024-05-07 12:20:00.000000',00000000000002260667),('2024-05-07 12:25:00.000000',00000000000002268567),('2024-05-07 12:30:00.000000',00000000000002331167),('2024-05-07 12:35:00.000000',00000000000002352867),('2024-05-07 12:40:00.000000',00000000000002659546),('2024-05-07 12:45:00.000000',00000000000002667446),('2024-05-07 12:50:00.000000',00000000000002686225),('2024-05-07 12:55:00.000000',00000000000002704025),('2024-05-07 13:00:00.000000',00000000000002716825),('2024-05-07 13:05:00.000000',00000000000002731505),('2024-05-07 13:10:00.000000',00000000000002761884),('2024-05-07 13:15:00.000000',00000000000002775684),('2024-05-07 13:20:00.000000',00000000000002780584),('2024-05-07 13:25:00.000000',00000000000002798284),('2024-05-07 13:30:00.000000',00000000000002826684),('2024-05-07 13:35:00.000000',00000000000002830674),('2024-05-07 13:40:00.000000',00000000000002861374),('2024-05-07 13:45:00.000000',00000000000002955574),('2024-05-07 13:50:00.000000',00000000000002960474),('2024-05-07 13:55:00.000000',00000000000002972253),('2024-05-07 14:00:00.000000',00000000000002996253),('2024-05-07 14:05:00.000000',00000000000003006053),('2024-05-07 14:10:00.000000',00000000000003013953),('2024-05-07 14:15:00.000000',00000000000003018853),('2024-05-07 14:20:00.000000',00000000000003031853),('2024-05-07 14:25:00.000000',00000000000003070453),('2024-05-07 14:30:00.000000',00000000000003082253),('2024-05-07 14:35:00.000000',00000000000003082253),('2024-05-07 14:40:00.000000',00000000000003099053),('2024-05-07 14:45:00.000000',00000000000003105953),('2024-05-07 14:50:00.000000',00000000000003113853),('2024-05-07 14:55:00.000000',00000000000003113853),('2024-05-07 15:00:00.000000',00000000000003121653),('2024-05-07 15:05:00.000000',00000000000003150142),('2024-05-07 15:10:00.000000',00000000000003175042),('2024-05-07 15:15:00.000000',00000000000003191842),('2024-05-07 15:20:00.000000',00000000000003243321),('2024-05-07 15:25:00.000000',00000000000003251221),('2024-05-07 15:30:00.000000',00000000000003251221),('2024-05-07 15:35:00.000000',00000000000003256121),('2024-05-07 15:40:00.000000',00000000000003265021),('2024-05-07 15:45:00.000000',00000000000003273821),('2024-05-07 15:50:00.000000',00000000000003273821),('2024-05-07 15:55:00.000000',00000000000003292421),('2024-05-07 16:00:00.000000',00000000000003300321),('2024-05-07 16:05:00.000000',00000000000000026700),('2024-05-07 16:10:00.000000',00000000000000044300),('2024-05-07 16:15:00.000000',00000000000000066879),('2024-05-07 16:20:00.000000',00000000000000073779),('2024-05-07 16:25:00.000000',00000000000000073779),('2024-05-07 16:30:00.000000',00000000000000099279),('2024-05-07 16:35:00.000000',00000000000000108179),('2024-05-07 16:40:00.000000',00000000000000118879),('2024-05-07 16:45:00.000000',00000000000000407679),('2024-05-07 16:50:00.000000',00000000000000415579),('2024-05-07 16:55:00.000000',00000000000000425379),('2024-05-07 17:00:00.000000',00000000000000430279),('2024-05-07 17:05:00.000000',00000000000000444079),('2024-05-07 17:10:00.000000',00000000000000448979),('2024-05-07 17:15:00.000000',00000000000000474679),('2024-05-07 17:20:00.000000',00000000000000474679),('2024-05-07 17:25:00.000000',00000000000000491358),('2024-05-07 17:30:00.000000',00000000000000508158),('2024-05-07 17:35:00.000000',00000000000000513058),('2024-05-07 17:40:00.000000',00000000000000529737),('2024-05-07 17:45:00.000000',00000000000000529737),('2024-05-07 17:50:00.000000',00000000000000543537),('2024-05-07 17:55:00.000000',00000000000000551437),('2024-05-07 18:00:00.000000',00000000000000556317),('2024-05-07 18:05:00.000000',00000000000000569117),('2024-05-07 18:10:00.000000',00000000000000577917),('2024-05-07 18:15:00.000000',00000000000000582817),('2024-05-07 18:20:00.000000',00000000000000582817),('2024-05-07 18:25:00.000000',00000000000000590717),('2024-05-07 18:30:00.000000',00000000000000595817),('2024-05-07 18:35:00.000000',00000000000000599696),('2024-05-07 18:40:00.000000',00000000000000620275),('2024-05-07 18:45:00.000000',00000000000000633975),('2024-05-07 18:50:00.000000',00000000000000638675),('2024-05-07 18:55:00.000000',00000000000000643575),('2024-05-07 19:00:00.000000',00000000000000660275),('2024-05-07 19:05:00.000000',00000000000000669075),('2024-05-07 19:10:00.000000',00000000000000669075),('2024-05-07 19:15:00.000000',00000000000000673975),('2024-05-07 19:20:00.000000',00000000000000673975),('2024-05-07 19:25:00.000000',00000000000000673975),('2024-05-07 19:30:00.000000',00000000000000718775),('2024-05-07 19:35:00.000000',00000000000000732475),('2024-05-07 19:40:00.000000',00000000000000745475),('2024-05-07 19:45:00.000000',00000000000000789254),('2024-05-07 19:50:00.000000',00000000000000796154),('2024-05-07 19:55:00.000000',00000000000000796154),('2024-05-07 20:00:00.000000',00000000000000809854),('2024-05-07 20:05:00.000000',00000000000000809854),('2024-05-07 20:10:00.000000',00000000000000819754),('2024-05-07 20:15:00.000000',00000000000000828554),('2024-05-07 20:20:00.000000',00000000000000833454),('2024-05-07 20:25:00.000000',00000000000000838354),('2024-05-07 20:30:00.000000',00000000000000843254),('2024-05-07 20:35:00.000000',00000000000000843254),('2024-05-07 20:40:00.000000',00000000000000843254),('2024-05-07 20:45:00.000000',00000000000000848154),('2024-05-07 20:50:00.000000',00000000000000848154),('2024-05-07 20:55:00.000000',00000000000000856954),('2024-05-07 21:00:00.000000',00000000000000869754),('2024-05-07 21:05:00.000000',00000000000000869754),('2024-05-07 21:10:00.000000',00000000000000887554),('2024-05-07 21:15:00.000000',00000000000000897354),('2024-05-07 21:20:00.000000',00000000000000897354),('2024-05-07 21:25:00.000000',00000000000000897354),('2024-05-07 21:30:00.000000',00000000000000897354),('2024-05-07 21:35:00.000000',00000000000000901254),('2024-05-07 21:40:00.000000',00000000000000901254),('2024-05-07 21:45:00.000000',00000000000000901254),('2024-05-07 21:50:00.000000',00000000000000901254),('2024-05-07 21:55:00.000000',00000000000000901254),('2024-05-07 22:00:00.000000',00000000000000901254),('2024-05-07 22:05:00.000000',00000000000000911154),('2024-05-07 22:10:00.000000',00000000000000911154),('2024-05-07 22:15:00.000000',00000000000000911154),('2024-05-07 22:20:00.000000',00000000000000916054),('2024-05-07 22:25:00.000000',00000000000000924954),('2024-05-07 22:30:00.000000',00000000000000929854),('2024-05-07 22:35:00.000000',00000000000000937754),('2024-05-07 22:40:00.000000',00000000000000942654),('2024-05-07 22:45:00.000000',00000000000000947554),('2024-05-07 22:50:00.000000',00000000000000957454),('2024-05-07 22:55:00.000000',00000000000000957454),('2024-05-07 23:00:00.000000',00000000000000962354),('2024-05-07 23:05:00.000000',00000000000000962354),('2024-05-07 23:10:00.000000',00000000000000962354),('2024-05-07 23:15:00.000000',00000000000000967454),('2024-05-07 23:20:00.000000',00000000000000972354),('2024-05-07 23:25:00.000000',00000000000000982254),('2024-05-07 23:30:00.000000',00000000000000982254),('2024-05-07 23:35:00.000000',00000000000000999054),('2024-05-07 23:40:00.000000',00000000000000999054),('2024-05-07 23:45:00.000000',00000000000000999054),('2024-05-07 23:50:00.000000',00000000000001015754),('2024-05-07 23:55:00.000000',00000000000001055654),('2024-05-08 00:00:00.000000',00000000000001072433),('2024-05-08 00:05:00.000000',00000000000001097133),('2024-05-08 00:10:00.000000',00000000000001097133),('2024-05-08 00:15:00.000000',00000000000001117833),('2024-05-08 00:20:00.000000',00000000000001129612),('2024-05-08 00:25:00.000000',00000000000001129612),('2024-05-08 00:30:00.000000',00000000000001134512),('2024-05-08 00:35:00.000000',00000000000001139412),('2024-05-08 00:40:00.000000',00000000000001174912),('2024-05-08 00:45:00.000000',00000000000001179812),('2024-05-08 00:50:00.000000',00000000000001179812),('2024-05-08 00:55:00.000000',00000000000001201612),('2024-05-08 01:00:00.000000',00000000000001215312),('2024-05-08 01:05:00.000000',00000000000001242812),('2024-05-08 01:10:00.000000',00000000000001282712),('2024-05-08 01:15:00.000000',00000000000001286591),('2024-05-08 01:20:00.000000',00000000000001286591),('2024-05-08 01:25:00.000000',00000000000001286591),('2024-05-08 01:30:00.000000',00000000000001295491),('2024-05-08 01:35:00.000000',00000000000001295491),('2024-05-08 01:40:00.000000',00000000000001303391),('2024-05-08 01:45:00.000000',00000000000001311291),('2024-05-08 01:50:00.000000',00000000000001320070),('2024-05-08 01:55:00.000000',00000000000001325170),('2024-05-08 02:00:00.000000',00000000000001330070),('2024-05-08 02:05:00.000000',00000000000001354770),('2024-05-08 02:10:00.000000',00000000000001358670),('2024-05-08 02:15:00.000000',00000000000001419470),('2024-05-08 02:20:00.000000',00000000000001433170),('2024-05-08 02:25:00.000000',00000000000001441070),('2024-05-08 02:30:00.000000',00000000000001445970),('2024-05-08 02:35:00.000000',00000000000001445970),('2024-05-08 02:40:00.000000',00000000000001453870),('2024-05-08 02:45:00.000000',00000000000001458770),('2024-05-08 02:50:00.000000',00000000000001458770),('2024-05-08 02:55:00.000000',00000000000001458870),('2024-05-08 03:00:00.000000',00000000000001479570),('2024-05-08 03:05:00.000000',00000000000001479570),('2024-05-08 03:10:00.000000',00000000000001479570),('2024-05-08 03:15:00.000000',00000000000001502570),('2024-05-08 03:20:00.000000',00000000000001556270),('2024-05-08 03:25:00.000000',00000000000001565730),('2024-05-08 03:30:00.000000',00000000000001565730),('2024-05-08 03:35:00.000000',00000000000001616409),('2024-05-08 03:40:00.000000',00000000000001616409),('2024-05-08 03:45:00.000000',00000000000001621509),('2024-05-08 03:50:00.000000',00000000000001643109),('2024-05-08 03:55:00.000000',00000000000001663109),('2024-05-08 04:00:00.000000',00000000000001681809),('2024-05-08 04:05:00.000000',00000000000001690788),('2024-05-08 04:10:00.000000',00000000000001695688),('2024-05-08 04:15:00.000000',00000000000001703588),('2024-05-08 04:20:00.000000',00000000000001713488),('2024-05-08 04:25:00.000000',00000000000001739888),('2024-05-08 04:30:00.000000',00000000000001747788),('2024-05-08 04:35:00.000000',00000000000001755688),('2024-05-08 04:40:00.000000',00000000000001765588),('2024-05-08 04:45:00.000000',00000000000001770488),('2024-05-08 04:50:00.000000',00000000000001770488),('2024-05-08 04:55:00.000000',00000000000001770488),('2024-05-08 05:00:00.000000',00000000000001788188),('2024-05-08 05:05:00.000000',00000000000001793088),('2024-05-08 05:10:00.000000',00000000000001815688),('2024-05-08 05:15:00.000000',00000000000001836388),('2024-05-08 05:20:00.000000',00000000000001844067),('2024-05-08 05:25:00.000000',00000000000001887767),('2024-05-08 05:30:00.000000',00000000000001901446),('2024-05-08 05:35:00.000000',00000000000001916146),('2024-05-08 05:40:00.000000',00000000000001935005),('2024-05-08 05:45:00.000000',00000000000001939905),('2024-05-08 05:50:00.000000',00000000000001959705),('2024-05-08 05:55:00.000000',00000000000001969505),('2024-05-08 06:00:00.000000',00000000000001992205),('2024-05-08 06:05:00.000000',00000000000002008884),('2024-05-08 06:10:00.000000',00000000000002040484),('2024-05-08 06:15:00.000000',00000000000002048384),('2024-05-08 06:20:00.000000',00000000000002088184),('2024-05-08 06:25:00.000000',00000000000002093084),('2024-05-08 06:30:00.000000',00000000000002115784),('2024-05-08 06:35:00.000000',00000000000002136463),('2024-05-08 06:40:00.000000',00000000000002381463),('2024-05-08 06:45:00.000000',00000000000002422863),('2024-05-08 06:50:00.000000',00000000000002442563),('2024-05-08 06:55:00.000000',00000000000002463263),('2024-05-08 07:00:00.000000',00000000000002479942),('2024-05-08 07:05:00.000000',00000000000002484842),('2024-05-08 07:10:00.000000',00000000000002499542),('2024-05-08 07:15:00.000000',00000000000002525142),('2024-05-08 07:20:00.000000',00000000000002544821),('2024-05-08 07:25:00.000000',00000000000002553600),('2024-05-08 07:30:00.000000',00000000000002568400),('2024-05-08 07:35:00.000000',00000000000002584200),('2024-05-08 07:40:00.000000',00000000000002602100),('2024-05-08 07:45:00.000000',00000000000002607000),('2024-05-08 07:50:00.000000',00000000000002611900),('2024-05-08 07:55:00.000000',00000000000002637500),('2024-05-08 08:00:00.000000',00000000000002668200),('2024-05-08 08:05:00.000000',00000000000002708479),('2024-05-08 08:10:00.000000',00000000000002734979),('2024-05-08 08:15:00.000000',00000000000002745079),('2024-05-08 08:20:00.000000',00000000000002777579),('2024-05-08 08:25:00.000000',00000000000002812858),('2024-05-08 08:30:00.000000',00000000000002837437),('2024-05-08 08:35:00.000000',00000000000002866937),('2024-05-08 08:40:00.000000',00000000000002909216),('2024-05-08 08:45:00.000000',00000000000002929774),('2024-05-08 08:50:00.000000',00000000000002953474),('2024-05-08 08:55:00.000000',00000000000003049953),('2024-05-08 09:00:00.000000',00000000000003058753),('2024-05-08 09:05:00.000000',00000000000003079453),('2024-05-08 09:10:00.000000',00000000000003145153),('2024-05-08 09:15:00.000000',00000000000003178953),('2024-05-08 09:20:00.000000',00000000000003178953),('2024-05-08 09:25:00.000000',00000000000003190732),('2024-05-08 09:30:00.000000',00000000000003190732),('2024-05-08 09:35:00.000000',00000000000003195632),('2024-05-08 09:40:00.000000',00000000000003203532),('2024-05-08 09:45:00.000000',00000000000003223932),('2024-05-08 09:50:00.000000',00000000000003252532),('2024-05-08 09:55:00.000000',00000000000003260432),('2024-05-08 10:00:00.000000',00000000000003270232),('2024-05-08 10:05:00.000000',00000000000003292632),('2024-05-08 10:10:00.000000',00000000000003320532),('2024-05-08 10:15:00.000000',00000000000003361232),('2024-05-08 10:20:00.000000',00000000000003391132),('2024-05-08 10:25:00.000000',00000000000003395122),('2024-05-08 10:30:00.000000',00000000000003417722),('2024-05-08 10:35:00.000000',00000000000003445222),('2024-05-08 10:40:00.000000',00000000000003461722),('2024-05-08 10:45:00.000000',00000000000003491222),('2024-05-08 10:50:00.000000',00000000000003552222),('2024-05-08 10:55:00.000000',00000000000003586522),('2024-05-08 11:00:00.000000',00000000000003613201),('2024-05-08 11:05:00.000000',00000000000003660901),('2024-05-08 11:10:00.000000',00000000000003697301),('2024-05-08 11:15:00.000000',00000000000003730780),('2024-05-08 11:20:00.000000',00000000000003755080),('2024-05-08 11:25:00.000000',00000000000003790459),('2024-05-08 11:30:00.000000',00000000000003835738),('2024-05-08 11:35:00.000000',00000000000003867117),('2024-05-08 11:40:00.000000',00000000000003904917),('2024-05-08 11:45:00.000000',00000000000003918717),('2024-05-08 11:50:00.000000',00000000000004257417),('2024-05-08 11:55:00.000000',00000000000004281917),('2024-05-08 12:00:00.000000',00000000000004302617),('2024-05-08 12:05:00.000000',00000000000004338096),('2024-05-08 12:10:00.000000',00000000000004393196),('2024-05-08 12:15:00.000000',00000000000004499133),('2024-05-08 12:20:00.000000',00000000000004577833),('2024-05-08 12:25:00.000000',00000000000004636512),('2024-05-08 12:30:00.000000',00000000000004671612),('2024-05-08 12:35:00.000000',00000000000004734712),('2024-05-08 12:40:00.000000',00000000000004790412),('2024-05-08 12:45:00.000000',00000000000004849870),('2024-05-08 12:50:00.000000',00000000000004905749),('2024-05-08 12:55:00.000000',00000000000004989128),('2024-05-08 13:00:00.000000',00000000000005043228),('2024-05-08 13:05:00.000000',00000000000005135728),('2024-05-08 13:10:00.000000',00000000000005202928),('2024-05-08 13:15:00.000000',00000000000005321428),('2024-05-08 13:20:00.000000',00000000000005431007),('2024-05-08 13:25:00.000000',00000000000005465507),('2024-05-08 13:30:00.000000',00000000000005530507),('2024-05-08 13:35:00.000000',00000000000005620707),('2024-05-08 13:40:00.000000',00000000000005648886),('2024-05-08 13:45:00.000000',00000000000005657786),('2024-05-08 13:50:00.000000',00000000000005665986),('2024-05-08 13:55:00.000000',00000000000005705065),('2024-05-08 14:00:00.000000',00000000000005723665),('2024-05-08 14:05:00.000000',00000000000005743265),('2024-05-08 14:10:00.000000',00000000000005748165),('2024-05-08 14:15:00.000000',00000000000005768865),('2024-05-08 14:20:00.000000',00000000000005797365),('2024-05-08 14:25:00.000000',00000000000005851465),('2024-05-08 14:30:00.000000',00000000000005855344),('2024-05-08 14:35:00.000000',00000000000005891244),('2024-05-08 14:40:00.000000',00000000000005923323),('2024-05-08 14:45:00.000000',00000000000005952823),('2024-05-08 14:50:00.000000',00000000000005992323),('2024-05-08 14:55:00.000000',00000000000006034202),('2024-05-08 15:00:00.000000',00000000000006103402),('2024-05-08 15:05:00.000000',00000000000006203681),('2024-05-08 15:10:00.000000',00000000000006249881),('2024-05-08 15:15:00.000000',00000000000006269560),('2024-05-08 15:20:00.000000',00000000000006274460),('2024-05-08 15:25:00.000000',00000000000006274460),('2024-05-08 15:30:00.000000',00000000000006274460),('2024-05-08 15:35:00.000000',00000000000006274460),('2024-05-08 15:40:00.000000',00000000000006274460),('2024-05-08 15:45:00.000000',00000000000006274460),('2024-05-08 15:50:00.000000',00000000000006274460),('2024-05-08 15:55:00.000000',00000000000006274460),('2024-05-08 16:00:00.000000',00000000000000000000),('2024-05-08 16:05:00.000000',00000000000000000000),('2024-05-08 16:10:00.000000',00000000000000000000),('2024-05-08 16:15:00.000000',00000000000000000000),('2024-05-08 16:20:00.000000',00000000000000000000),('2024-05-08 16:25:00.000000',00000000000000000000),('2024-05-08 16:30:00.000000',00000000000000000000),('2024-05-08 16:35:00.000000',00000000000000000000),('2024-05-08 16:40:00.000000',00000000000000017700),('2024-05-08 16:45:00.000000',00000000000000027500),('2024-05-08 16:50:00.000000',00000000000000093600),('2024-05-08 16:55:00.000000',00000000000000151869),('2024-05-08 17:00:00.000000',00000000000000200269),('2024-05-08 17:05:00.000000',00000000000000243248),('2024-05-08 17:10:00.000000',00000000000000264948),('2024-05-08 17:15:00.000000',00000000000000298438),('2024-05-08 17:20:00.000000',00000000000000307217),('2024-05-08 17:25:00.000000',00000000000000312117),('2024-05-08 17:30:00.000000',00000000000000369017),('2024-05-08 17:35:00.000000',00000000000000380796),('2024-05-08 17:40:00.000000',00000000000000385696),('2024-05-08 17:45:00.000000',00000000000000420286),('2024-05-08 17:50:00.000000',00000000000000436086),('2024-05-08 17:55:00.000000',00000000000000450876),('2024-05-08 18:00:00.000000',00000000000000462576),('2024-05-08 18:05:00.000000',00000000000000472476),('2024-05-08 18:10:00.000000',00000000000000481276),('2024-05-08 18:15:00.000000',00000000000000489176),('2024-05-08 18:20:00.000000',00000000000000513776),('2024-05-08 18:25:00.000000',00000000000000526455),('2024-05-08 18:30:00.000000',00000000000000541255),('2024-05-08 18:35:00.000000',00000000000000541255),('2024-05-08 18:40:00.000000',00000000000000541255),('2024-05-08 18:45:00.000000',00000000000000550155),('2024-05-08 18:50:00.000000',00000000000000575734),('2024-05-08 18:55:00.000000',00000000000000586534),('2024-05-08 19:00:00.000000',00000000000000612234),('2024-05-08 19:05:00.000000',00000000000000616113),('2024-05-08 19:10:00.000000',00000000000000612113),('2024-05-08 19:15:00.000000',00000000000000612113),('2024-05-08 19:20:00.000000',00000000000000625913),('2024-05-08 19:25:00.000000',00000000000000625913),('2024-05-08 19:30:00.000000',00000000000000636993),('2024-05-08 19:35:00.000000',00000000000000646893),('2024-05-08 19:40:00.000000',00000000000000658593),('2024-05-08 19:45:00.000000',00000000000000668393),('2024-05-08 19:50:00.000000',00000000000000668393),('2024-05-08 19:55:00.000000',00000000000000673293),('2024-05-08 20:00:00.000000',00000000000000695943),('2024-05-08 20:05:00.000000',00000000000000704843),('2024-05-08 20:10:00.000000',00000000000000714843),('2024-05-08 20:15:00.000000',00000000000000723743),('2024-05-08 20:20:00.000000',00000000000000723743),('2024-05-08 20:25:00.000000',00000000000000731643),('2024-05-08 20:30:00.000000',00000000000000731643),('2024-05-08 20:35:00.000000',00000000000000731643),('2024-05-08 20:40:00.000000',00000000000000731643),('2024-05-08 20:45:00.000000',00000000000000740543),('2024-05-08 20:50:00.000000',00000000000000740543),('2024-05-08 20:55:00.000000',00000000000000740543),('2024-05-08 21:00:00.000000',00000000000000740543),('2024-05-08 21:05:00.000000',00000000000000740543),('2024-05-08 21:10:00.000000',00000000000000740543),('2024-05-08 21:15:00.000000',00000000000000740543),('2024-05-08 21:20:00.000000',00000000000000750323),('2024-05-08 21:25:00.000000',00000000000000750323),('2024-05-08 21:30:00.000000',00000000000000750323),('2024-05-08 21:35:00.000000',00000000000000750323),('2024-05-08 21:40:00.000000',00000000000000763123),('2024-05-08 21:45:00.000000',00000000000000770023),('2024-05-08 21:50:00.000000',00000000000000770023),('2024-05-08 21:55:00.000000',00000000000000770023),('2024-05-08 22:00:00.000000',00000000000000786823),('2024-05-08 22:05:00.000000',00000000000000786823),('2024-05-08 22:10:00.000000',00000000000000790702),('2024-05-08 22:15:00.000000',00000000000000790702),('2024-05-08 22:20:00.000000',00000000000000790702),('2024-05-08 22:25:00.000000',00000000000000803502),('2024-05-08 22:30:00.000000',00000000000000808402),('2024-05-08 22:35:00.000000',00000000000000813302),('2024-05-08 22:40:00.000000',00000000000000830002),('2024-05-08 22:45:00.000000',00000000000000835102),('2024-05-08 22:50:00.000000',00000000000000840002),('2024-05-08 22:55:00.000000',00000000000000840002),('2024-05-08 23:00:00.000000',00000000000000847902),('2024-05-08 23:05:00.000000',00000000000000852802),('2024-05-08 23:10:00.000000',00000000000000852802),('2024-05-08 23:15:00.000000',00000000000000875702),('2024-05-08 23:20:00.000000',00000000000000886602),('2024-05-08 23:25:00.000000',00000000000000894502),('2024-05-08 23:30:00.000000',00000000000000902402),('2024-05-08 23:35:00.000000',00000000000000914102),('2024-05-08 23:40:00.000000',00000000000000928782),('2024-05-08 23:45:00.000000',00000000000000928782),('2024-05-08 23:50:00.000000',00000000000000976582),('2024-05-08 23:55:00.000000',00000000000000976582),('2024-05-09 00:00:00.000000',00000000000001000182),('2024-05-09 00:05:00.000000',00000000000001005082),('2024-05-09 00:10:00.000000',00000000000001023782),('2024-05-09 00:15:00.000000',00000000000001063682),('2024-05-09 00:20:00.000000',00000000000001082382),('2024-05-09 00:25:00.000000',00000000000001082382),('2024-05-09 00:30:00.000000',00000000000001122282),('2024-05-09 00:35:00.000000',00000000000001130182),('2024-05-09 00:40:00.000000',00000000000001139982),('2024-05-09 00:45:00.000000',00000000000001147882),('2024-05-09 00:50:00.000000',00000000000001147882),('2024-05-09 00:55:00.000000',00000000000001160782),('2024-05-09 01:00:00.000000',00000000000001160782),('2024-05-09 01:05:00.000000',00000000000001160782),('2024-05-09 01:10:00.000000',00000000000001160782),('2024-05-09 01:15:00.000000',00000000000001165682),('2024-05-09 01:20:00.000000',00000000000001178482),('2024-05-09 01:25:00.000000',00000000000001182361),('2024-05-09 01:30:00.000000',00000000000001182361),('2024-05-09 01:35:00.000000',00000000000001209061),('2024-05-09 01:40:00.000000',00000000000001265661),('2024-05-09 01:45:00.000000',00000000000001265661),('2024-05-09 01:50:00.000000',00000000000001272561),('2024-05-09 01:55:00.000000',00000000000001288161),('2024-05-09 02:00:00.000000',00000000000001301961),('2024-05-09 02:05:00.000000',00000000000001308761),('2024-05-09 02:10:00.000000',00000000000001326461),('2024-05-09 02:15:00.000000',00000000000001336361),('2024-05-09 02:20:00.000000',00000000000001338361),('2024-05-09 02:25:00.000000',00000000000001346261),('2024-05-09 02:30:00.000000',00000000000001362961),('2024-05-09 02:35:00.000000',00000000000001367861),('2024-05-09 02:40:00.000000',00000000000001384561),('2024-05-09 02:45:00.000000',00000000000001384561),('2024-05-09 02:50:00.000000',00000000000001391361),('2024-05-09 02:55:00.000000',00000000000001408161),('2024-05-09 03:00:00.000000',00000000000001416961),('2024-05-09 03:05:00.000000',00000000000001425661),('2024-05-09 03:10:00.000000',00000000000001417761),('2024-05-09 03:15:00.000000',00000000000001424661),('2024-05-09 03:20:00.000000',00000000000001482340),('2024-05-09 03:25:00.000000',00000000000001497040),('2024-05-09 03:30:00.000000',00000000000001504940),('2024-05-09 03:35:00.000000',00000000000001504940),('2024-05-09 03:40:00.000000',00000000000001509840),('2024-05-09 03:45:00.000000',00000000000001524640),('2024-05-09 03:50:00.000000',00000000000001524640),('2024-05-09 03:55:00.000000',00000000000001524640),('2024-05-09 04:00:00.000000',00000000000001529540),('2024-05-09 04:05:00.000000',00000000000001543240),('2024-05-09 04:10:00.000000',00000000000001543240),('2024-05-09 04:15:00.000000',00000000000001556540),('2024-05-09 04:20:00.000000',00000000000001567140),('2024-05-09 04:25:00.000000',00000000000001601740),('2024-05-09 04:30:00.000000',00000000000001622819),('2024-05-09 04:35:00.000000',00000000000001660119),('2024-05-09 04:40:00.000000',00000000000001676719),('2024-05-09 04:45:00.000000',00000000000001693819),('2024-05-09 04:50:00.000000',00000000000001710219),('2024-05-09 04:55:00.000000',00000000000001711019),('2024-05-09 05:00:00.000000',00000000000001737698),('2024-05-09 05:05:00.000000',00000000000001753698),('2024-05-09 05:10:00.000000',00000000000001768298),('2024-05-09 05:15:00.000000',00000000000001786077),('2024-05-09 05:20:00.000000',00000000000001799856),('2024-05-09 05:25:00.000000',00000000000001799856),('2024-05-09 05:30:00.000000',00000000000001811656),('2024-05-09 05:35:00.000000',00000000000001824856),('2024-05-09 05:40:00.000000',00000000000001838746),('2024-05-09 05:45:00.000000',00000000000001858446),('2024-05-09 05:50:00.000000',00000000000001868246),('2024-05-09 05:55:00.000000',00000000000001881046),('2024-05-09 06:00:00.000000',00000000000001910546),('2024-05-09 06:05:00.000000',00000000000001912646),('2024-05-09 06:10:00.000000',00000000000001925046),('2024-05-09 06:15:00.000000',00000000000001962246),('2024-05-09 06:20:00.000000',00000000000001974946),('2024-05-09 06:25:00.000000',00000000000002209346),('2024-05-09 06:30:00.000000',00000000000002227046),('2024-05-09 06:35:00.000000',00000000000002231946),('2024-05-09 06:40:00.000000',00000000000002231946),('2024-05-09 06:45:00.000000',00000000000002231946),('2024-05-09 06:50:00.000000',00000000000002256646),('2024-05-09 06:55:00.000000',00000000000002258246),('2024-05-09 07:00:00.000000',00000000000002276046),('2024-05-09 07:05:00.000000',00000000000002291846),('2024-05-09 07:10:00.000000',00000000000002305646),('2024-05-09 07:15:00.000000',00000000000002332246),('2024-05-09 07:20:00.000000',00000000000002427746),('2024-05-09 07:25:00.000000',00000000000002459025),('2024-05-09 07:30:00.000000',00000000000002445225),('2024-05-09 07:35:00.000000',00000000000002450125),('2024-05-09 07:40:00.000000',00000000000002460025),('2024-05-09 07:45:00.000000',00000000000002472725),('2024-05-09 07:50:00.000000',00000000000002480625),('2024-05-09 07:55:00.000000',00000000000002480625),('2024-05-09 08:00:00.000000',00000000000002532304),('2024-05-09 08:05:00.000000',00000000000002536183),('2024-05-09 08:10:00.000000',00000000000002541083),('2024-05-09 08:15:00.000000',00000000000002551083),('2024-05-09 08:20:00.000000',00000000000002567583),('2024-05-09 08:25:00.000000',00000000000002595183),('2024-05-09 08:30:00.000000',00000000000002621862),('2024-05-09 08:35:00.000000',00000000000002634662),('2024-05-09 08:40:00.000000',00000000000002647462),('2024-05-09 08:45:00.000000',00000000000002647462),('2024-05-09 08:50:00.000000',00000000000002647462),('2024-05-09 08:55:00.000000',00000000000002667062),('2024-05-09 09:00:00.000000',00000000000002671962),('2024-05-09 09:05:00.000000',00000000000002676862),('2024-05-09 09:10:00.000000',00000000000002693662),('2024-05-09 09:15:00.000000',00000000000002703562),('2024-05-09 09:20:00.000000',00000000000002703562),('2024-05-09 09:25:00.000000',00000000000002712362),('2024-05-09 09:30:00.000000',00000000000002712362),('2024-05-09 09:35:00.000000',00000000000002712362),('2024-05-09 09:40:00.000000',00000000000002712462),('2024-05-09 09:45:00.000000',00000000000003017962),('2024-05-09 09:50:00.000000',00000000000003035662),('2024-05-09 09:55:00.000000',00000000000003050462),('2024-05-09 10:00:00.000000',00000000000003085862),('2024-05-09 10:05:00.000000',00000000000003093762),('2024-05-09 10:10:00.000000',00000000000003093762),('2024-05-09 10:15:00.000000',00000000000003101662),('2024-05-09 10:20:00.000000',00000000000003109562),('2024-05-09 10:25:00.000000',00000000000003109562),('2024-05-09 10:30:00.000000',00000000000003114462),('2024-05-09 10:35:00.000000',00000000000003114462),('2024-05-09 10:40:00.000000',00000000000003119362),('2024-05-09 10:45:00.000000',00000000000003141062),('2024-05-09 10:50:00.000000',00000000000003164462),('2024-05-09 10:55:00.000000',00000000000003167462),('2024-05-09 11:00:00.000000',00000000000003188162),('2024-05-09 11:05:00.000000',00000000000003188262),('2024-05-09 11:10:00.000000',00000000000003188862),('2024-05-09 11:15:00.000000',00000000000003206462),('2024-05-09 11:20:00.000000',00000000000003228062),('2024-05-09 11:25:00.000000',00000000000003284662),('2024-05-09 11:30:00.000000',00000000000003284662),('2024-05-09 11:35:00.000000',00000000000003298862),('2024-05-09 11:40:00.000000',00000000000003304062),('2024-05-09 11:45:00.000000',00000000000003318862),('2024-05-09 11:50:00.000000',00000000000003333662),('2024-05-09 11:55:00.000000',00000000000003174362),('2024-05-09 12:00:00.000000',00000000000003189162),('2024-05-09 12:05:00.000000',00000000000003204962),('2024-05-09 12:10:00.000000',00000000000003204962),('2024-05-09 12:15:00.000000',00000000000003220662),('2024-05-09 12:20:00.000000',00000000000003236462),('2024-05-09 12:25:00.000000',00000000000003247262),('2024-05-09 12:30:00.000000',00000000000003347262),('2024-05-09 12:35:00.000000',00000000000003354162),('2024-05-09 12:40:00.000000',00000000000003354162),('2024-05-09 12:45:00.000000',00000000000003358152),('2024-05-09 12:50:00.000000',00000000000003405952),('2024-05-09 12:55:00.000000',00000000000003419652),('2024-05-09 13:00:00.000000',00000000000003419652),('2024-05-09 13:05:00.000000',00000000000003437452),('2024-05-09 13:10:00.000000',00000000000003469952),('2024-05-09 13:15:00.000000',00000000000003473942),('2024-05-09 13:20:00.000000',00000000000003484742),('2024-05-09 13:25:00.000000',00000000000003494542),('2024-05-09 13:30:00.000000',00000000000003506342),('2024-05-09 13:35:00.000000',00000000000003508042),('2024-05-09 13:40:00.000000',00000000000003519821),('2024-05-09 13:45:00.000000',00000000000003524721),('2024-05-09 13:50:00.000000',00000000000003524721),('2024-05-09 13:55:00.000000',00000000000003546421),('2024-05-09 14:00:00.000000',00000000000003551321),('2024-05-09 14:05:00.000000',00000000000003731321),('2024-05-09 14:10:00.000000',00000000000003758921),('2024-05-09 14:15:00.000000',00000000000003777721),('2024-05-09 14:20:00.000000',00000000000003777721),('2024-05-09 14:25:00.000000',00000000000003787621),('2024-05-09 14:30:00.000000',00000000000003795521),('2024-05-09 14:35:00.000000',00000000000003809200),('2024-05-09 14:40:00.000000',00000000000003822000),('2024-05-09 14:45:00.000000',00000000000003822000),('2024-05-09 14:50:00.000000',00000000000003862600),('2024-05-09 14:55:00.000000',00000000000003888300),('2024-05-09 15:00:00.000000',00000000000003908000),('2024-05-09 15:05:00.000000',00000000000003920800),('2024-05-09 15:10:00.000000',00000000000003952400),('2024-05-09 15:15:00.000000',00000000000003993680),('2024-05-09 15:20:00.000000',00000000000004018280),('2024-05-09 15:25:00.000000',00000000000004031080),('2024-05-09 15:30:00.000000',00000000000004045880),('2024-05-09 15:35:00.000000',00000000000004066580),('2024-05-09 15:40:00.000000',00000000000004111880),('2024-05-09 15:45:00.000000',00000000000004124680),('2024-05-09 15:50:00.000000',00000000000004145270),('2024-05-09 15:55:00.000000',00000000000004194370),('2024-05-09 16:00:00.000000',00000000000000000000),('2024-05-09 16:05:00.000000',00000000000000031000),('2024-05-09 16:10:00.000000',00000000000000043800),('2024-05-09 16:15:00.000000',00000000000000067500),('2024-05-09 16:20:00.000000',00000000000000100200),('2024-05-09 16:25:00.000000',00000000000000135500),('2024-05-09 16:30:00.000000',00000000000000167000),('2024-05-09 16:35:00.000000',00000000000000187700),('2024-05-09 16:40:00.000000',00000000000000219300),('2024-05-09 16:45:00.000000',00000000000000261690),('2024-05-09 16:50:00.000000',00000000000000261690),('2024-05-09 16:55:00.000000',00000000000000269490),('2024-05-09 17:00:00.000000',00000000000000300090),('2024-05-09 17:05:00.000000',00000000000000305090),('2024-05-09 17:10:00.000000',00000000000000305090),('2024-05-09 17:15:00.000000',00000000000000337690),('2024-05-09 17:20:00.000000',00000000000000359190),('2024-05-09 17:25:00.000000',00000000000000367090),('2024-05-09 17:30:00.000000',00000000000000367090),('2024-05-09 17:35:00.000000',00000000000000367090),('2024-05-09 17:40:00.000000',00000000000000389790),('2024-05-09 17:45:00.000000',00000000000000396690),('2024-05-09 17:50:00.000000',00000000000000403590),('2024-05-09 17:55:00.000000',00000000000000403590),('2024-05-09 18:00:00.000000',00000000000000443490),('2024-05-09 18:05:00.000000',00000000000000443490),('2024-05-09 18:10:00.000000',00000000000000443490),('2024-05-09 18:15:00.000000',00000000000000463290),('2024-05-09 18:20:00.000000',00000000000000468190),('2024-05-09 18:25:00.000000',00000000000000468190),('2024-05-09 18:30:00.000000',00000000000000468190),('2024-05-09 18:35:00.000000',00000000000000468190),('2024-05-09 18:40:00.000000',00000000000000468190),('2024-05-09 18:45:00.000000',00000000000000482990),('2024-05-09 18:50:00.000000',00000000000000482990),('2024-05-09 18:55:00.000000',00000000000000490890),('2024-05-09 19:00:00.000000',00000000000000497790),('2024-05-09 19:05:00.000000',00000000000000507690),('2024-05-09 19:10:00.000000',00000000000000507690),('2024-05-09 19:15:00.000000',00000000000000507690),('2024-05-09 19:20:00.000000',00000000000000521390),('2024-05-09 19:25:00.000000',00000000000000514490),('2024-05-09 19:30:00.000000',00000000000000534490),('2024-05-09 19:35:00.000000',00000000000000543290),('2024-05-09 19:40:00.000000',00000000000000548190),('2024-05-09 19:45:00.000000',00000000000000548190),('2024-05-09 19:50:00.000000',00000000000000548190),('2024-05-09 19:55:00.000000',00000000000000555990),('2024-05-09 20:00:00.000000',00000000000000563890),('2024-05-09 20:05:00.000000',00000000000000567790),('2024-05-09 20:10:00.000000',00000000000000567790),('2024-05-09 20:15:00.000000',00000000000000567790),('2024-05-09 20:20:00.000000',00000000000000567790),('2024-05-09 20:25:00.000000',00000000000000567790),('2024-05-09 20:30:00.000000',00000000000000572690),('2024-05-09 20:35:00.000000',00000000000000580590),('2024-05-09 20:40:00.000000',00000000000000585490),('2024-05-09 20:45:00.000000',00000000000000592390),('2024-05-09 20:50:00.000000',00000000000000592390),('2024-05-09 20:55:00.000000',00000000000000597290),('2024-05-09 21:00:00.000000',00000000000000597290),('2024-05-09 21:05:00.000000',00000000000000597290),('2024-05-09 21:10:00.000000',00000000000000597290),('2024-05-09 21:15:00.000000',00000000000000597290),('2024-05-09 21:20:00.000000',00000000000000597290),('2024-05-09 21:25:00.000000',00000000000000602190),('2024-05-09 21:30:00.000000',00000000000000612090),('2024-05-09 21:35:00.000000',00000000000000619990),('2024-05-09 21:40:00.000000',00000000000000632790),('2024-05-09 21:45:00.000000',00000000000000684690),('2024-05-09 21:50:00.000000',00000000000000684690),('2024-05-09 21:55:00.000000',00000000000000684690),('2024-05-09 22:00:00.000000',00000000000000684690),('2024-05-09 22:05:00.000000',00000000000000684690),('2024-05-09 22:10:00.000000',00000000000000689590),('2024-05-09 22:15:00.000000',00000000000000689590),('2024-05-09 22:20:00.000000',00000000000000696490),('2024-05-09 22:25:00.000000',00000000000000696490),('2024-05-09 22:30:00.000000',00000000000000696490),('2024-05-09 22:35:00.000000',00000000000000696490),('2024-05-09 22:40:00.000000',00000000000000706490),('2024-05-09 22:45:00.000000',00000000000000706490),('2024-05-09 22:50:00.000000',00000000000000706490),('2024-05-09 22:55:00.000000',00000000000000706490),('2024-05-09 23:00:00.000000',00000000000000719290),('2024-05-09 23:05:00.000000',00000000000000729290),('2024-05-09 23:10:00.000000',00000000000000734190),('2024-05-09 23:15:00.000000',00000000000000753890),('2024-05-09 23:20:00.000000',00000000000000764390),('2024-05-09 23:25:00.000000',00000000000000766090),('2024-05-09 23:30:00.000000',00000000000000766090),('2024-05-09 23:35:00.000000',00000000000000766090),('2024-05-09 23:40:00.000000',00000000000000766090),('2024-05-09 23:45:00.000000',00000000000000771090),('2024-05-09 23:50:00.000000',00000000000000771090),('2024-05-09 23:55:00.000000',00000000000000778990),('2024-05-10 00:00:00.000000',00000000000000786890),('2024-05-10 00:05:00.000000',00000000000000786890),('2024-05-10 00:10:00.000000',00000000000000786890),('2024-05-10 00:15:00.000000',00000000000000786890),('2024-05-10 00:20:00.000000',00000000000000793790),('2024-05-10 00:25:00.000000',00000000000000806590),('2024-05-10 00:30:00.000000',00000000000000816490),('2024-05-10 00:35:00.000000',00000000000000820390),('2024-05-10 00:40:00.000000',00000000000000828290),('2024-05-10 00:45:00.000000',00000000000000827290),('2024-05-10 00:50:00.000000',00000000000000828590),('2024-05-10 00:55:00.000000',00000000000000828590),('2024-05-10 01:00:00.000000',00000000000000828590),('2024-05-10 01:05:00.000000',00000000000000828590),('2024-05-10 01:10:00.000000',00000000000000841390),('2024-05-10 01:15:00.000000',00000000000000860669),('2024-05-10 01:20:00.000000',00000000000000860669),('2024-05-10 01:25:00.000000',00000000000000876469),('2024-05-10 01:30:00.000000',00000000000000876469),('2024-05-10 01:35:00.000000',00000000000000884369),('2024-05-10 01:40:00.000000',00000000000000884369),('2024-05-10 01:45:00.000000',00000000000000889469),('2024-05-10 01:50:00.000000',00000000000000889469),('2024-05-10 01:55:00.000000',00000000000000889469),('2024-05-10 02:00:00.000000',00000000000000894369),('2024-05-10 02:05:00.000000',00000000000000902269),('2024-05-10 02:10:00.000000',00000000000000902269),('2024-05-10 02:15:00.000000',00000000000000902269),('2024-05-10 02:20:00.000000',00000000000000907149),('2024-05-10 02:25:00.000000',00000000000000915049),('2024-05-10 02:30:00.000000',00000000000000933849),('2024-05-10 02:35:00.000000',00000000000000951649),('2024-05-10 02:40:00.000000',00000000000000970529),('2024-05-10 02:45:00.000000',00000000000000961729),('2024-05-10 02:50:00.000000',00000000000000968629),('2024-05-10 02:55:00.000000',00000000000000968629),('2024-05-10 03:00:00.000000',00000000000000981429),('2024-05-10 03:05:00.000000',00000000000000989329),('2024-05-10 03:10:00.000000',00000000000000989329),('2024-05-10 03:15:00.000000',00000000000000989329),('2024-05-10 03:20:00.000000',00000000000000994229),('2024-05-10 03:25:00.000000',00000000000001002129),('2024-05-10 03:30:00.000000',00000000000001013929),('2024-05-10 03:35:00.000000',00000000000001017808),('2024-05-10 03:40:00.000000',00000000000001017808),('2024-05-10 03:45:00.000000',00000000000001025708),('2024-05-10 03:50:00.000000',00000000000001031608),('2024-05-10 03:55:00.000000',00000000000001048308),('2024-05-10 04:00:00.000000',00000000000001053408),('2024-05-10 04:05:00.000000',00000000000001072108),('2024-05-10 04:10:00.000000',00000000000001079866),('2024-05-10 04:15:00.000000',00000000000001087766),('2024-05-10 04:20:00.000000',00000000000001089766),('2024-05-10 04:25:00.000000',00000000000001137566),('2024-05-10 04:30:00.000000',00000000000001142466),('2024-05-10 04:35:00.000000',00000000000001159966),('2024-05-10 04:40:00.000000',00000000000001159966),('2024-05-10 04:45:00.000000',00000000000001173825),('2024-05-10 04:50:00.000000',00000000000001189625),('2024-05-10 04:55:00.000000',00000000000001202325),('2024-05-10 05:00:00.000000',00000000000001228825),('2024-05-10 05:05:00.000000',00000000000001236604),('2024-05-10 05:10:00.000000',00000000000001266004),('2024-05-10 05:15:00.000000',00000000000001284804),('2024-05-10 05:20:00.000000',00000000000001297904),('2024-05-10 05:25:00.000000',00000000000001300804),('2024-05-10 05:30:00.000000',00000000000001300804),('2024-05-10 05:35:00.000000',00000000000001315604),('2024-05-10 05:40:00.000000',00000000000001315604),('2024-05-10 05:45:00.000000',00000000000001369304),('2024-05-10 05:50:00.000000',00000000000001399704),('2024-05-10 05:55:00.000000',00000000000001402704),('2024-05-10 06:00:00.000000',00000000000001424304),('2024-05-10 06:05:00.000000',00000000000001452904),('2024-05-10 06:10:00.000000',00000000000001452904),('2024-05-10 06:15:00.000000',00000000000001493204),('2024-05-10 06:20:00.000000',00000000000001505804),('2024-05-10 06:25:00.000000',00000000000001513704),('2024-05-10 06:30:00.000000',00000000000001528504),('2024-05-10 06:35:00.000000',00000000000001593804),('2024-05-10 06:40:00.000000',00000000000001593804),('2024-05-10 06:45:00.000000',00000000000001606604),('2024-05-10 06:50:00.000000',00000000000001606604),('2024-05-10 06:55:00.000000',00000000000001663304),('2024-05-10 07:00:00.000000',00000000000001671204),('2024-05-10 07:05:00.000000',00000000000001671204),('2024-05-10 07:10:00.000000',00000000000001679104),('2024-05-10 07:15:00.000000',00000000000001693804),('2024-05-10 07:20:00.000000',00000000000001696704),('2024-05-10 07:25:00.000000',00000000000001712404),('2024-05-10 07:30:00.000000',00000000000001720404),('2024-05-10 07:35:00.000000',00000000000001723304),('2024-05-10 07:40:00.000000',00000000000001723304),('2024-05-10 07:45:00.000000',00000000000001723304),('2024-05-10 07:50:00.000000',00000000000001723304),('2024-05-10 07:55:00.000000',00000000000001738004),('2024-05-10 08:00:00.000000',00000000000001738004),('2024-05-10 08:05:00.000000',00000000000001745904),('2024-05-10 08:10:00.000000',00000000000001745904),('2024-05-10 08:15:00.000000',00000000000001745904),('2024-05-10 08:20:00.000000',00000000000001753804),('2024-05-10 08:25:00.000000',00000000000001763804),('2024-05-10 08:30:00.000000',00000000000001791104),('2024-05-10 08:35:00.000000',00000000000001769783),('2024-05-10 08:40:00.000000',00000000000001784483),('2024-05-10 08:45:00.000000',00000000000001797183),('2024-05-10 08:50:00.000000',00000000000001796183),('2024-05-10 08:55:00.000000',00000000000001801083),('2024-05-10 09:00:00.000000',00000000000001805983),('2024-05-10 09:05:00.000000',00000000000001818783),('2024-05-10 09:10:00.000000',00000000000001837483),('2024-05-10 09:15:00.000000',00000000000001837483),('2024-05-10 09:20:00.000000',00000000000001837483),('2024-05-10 09:25:00.000000',00000000000001847383),('2024-05-10 09:30:00.000000',00000000000001844383),('2024-05-10 09:35:00.000000',00000000000001848283),('2024-05-10 09:40:00.000000',00000000000001848283),('2024-05-10 09:45:00.000000',00000000000001853163),('2024-05-10 09:50:00.000000',00000000000001853163),('2024-05-10 09:55:00.000000',00000000000001867863),('2024-05-10 10:00:00.000000',00000000000001867863),('2024-05-10 10:05:00.000000',00000000000001875763),('2024-05-10 10:10:00.000000',00000000000001883663),('2024-05-10 10:15:00.000000',00000000000001938063),('2024-05-10 10:20:00.000000',00000000000001941942),('2024-05-10 10:25:00.000000',00000000000001941942),('2024-05-10 10:30:00.000000',00000000000001941942),('2024-05-10 10:35:00.000000',00000000000001956742),('2024-05-10 10:40:00.000000',00000000000001971542),('2024-05-10 10:45:00.000000',00000000000001988242),('2024-05-10 10:50:00.000000',00000000000001993142),('2024-05-10 10:55:00.000000',00000000000001998042),('2024-05-10 11:00:00.000000',00000000000001998042),('2024-05-10 11:05:00.000000',00000000000001998042),('2024-05-10 11:10:00.000000',00000000000001998042),('2024-05-10 11:15:00.000000',00000000000001998042),('2024-05-10 11:20:00.000000',00000000000002015842),('2024-05-10 11:25:00.000000',00000000000002015842),('2024-05-10 11:30:00.000000',00000000000002015842),('2024-05-10 11:35:00.000000',00000000000002023742),('2024-05-10 11:40:00.000000',00000000000002031642),('2024-05-10 11:45:00.000000',00000000000002031642),('2024-05-10 11:50:00.000000',00000000000002036542),('2024-05-10 11:55:00.000000',00000000000002056242),('2024-05-10 12:00:00.000000',00000000000002056242),('2024-05-10 12:05:00.000000',00000000000002056242),('2024-05-10 12:10:00.000000',00000000000002066142),('2024-05-10 12:15:00.000000',00000000000002066142),('2024-05-10 12:20:00.000000',00000000000002071042),('2024-05-10 12:25:00.000000',00000000000002093742),('2024-05-10 12:30:00.000000',00000000000002101642),('2024-05-10 12:35:00.000000',00000000000002104542),('2024-05-10 12:40:00.000000',00000000000002114442),('2024-05-10 12:45:00.000000',00000000000002123242),('2024-05-10 12:50:00.000000',00000000000002123242),('2024-05-10 12:55:00.000000',00000000000002129142),('2024-05-10 13:00:00.000000',00000000000002167042),('2024-05-10 13:05:00.000000',00000000000002176021),('2024-05-10 13:10:00.000000',00000000000002188821),('2024-05-10 13:15:00.000000',00000000000002196721),('2024-05-10 13:20:00.000000',00000000000002196721),('2024-05-10 13:25:00.000000',00000000000002204621),('2024-05-10 13:30:00.000000',00000000000002226321),('2024-05-10 13:35:00.000000',00000000000002240521),('2024-05-10 13:40:00.000000',00000000000002297200),('2024-05-10 13:45:00.000000',00000000000002301979),('2024-05-10 13:50:00.000000',00000000000002315079),('2024-05-10 13:55:00.000000',00000000000002315079),('2024-05-10 14:00:00.000000',00000000000002315079),('2024-05-10 14:05:00.000000',00000000000002320979),('2024-05-10 14:10:00.000000',00000000000002320979),('2024-05-10 14:15:00.000000',00000000000002351479),('2024-05-10 14:20:00.000000',00000000000002368358),('2024-05-10 14:25:00.000000',00000000000002415858),('2024-05-10 14:30:00.000000',00000000000002415858),('2024-05-10 14:35:00.000000',00000000000002438358),('2024-05-10 14:40:00.000000',00000000000002460858),('2024-05-10 14:45:00.000000',00000000000002479637),('2024-05-10 14:50:00.000000',00000000000002484537),('2024-05-10 14:55:00.000000',00000000000002502337),('2024-05-10 15:00:00.000000',00000000000002507237),('2024-05-10 15:05:00.000000',00000000000002512137),('2024-05-10 15:10:00.000000',00000000000002506237),('2024-05-10 15:15:00.000000',00000000000002525737),('2024-05-10 15:20:00.000000',00000000000002545437),('2024-05-10 15:25:00.000000',00000000000002566137),('2024-05-10 15:30:00.000000',00000000000002584837),('2024-05-10 15:35:00.000000',00000000000002599537),('2024-05-10 15:40:00.000000',00000000000002665017),('2024-05-10 15:45:00.000000',00000000000002693617),('2024-05-10 15:50:00.000000',00000000000002724397),('2024-05-10 15:55:00.000000',00000000000002724397),('2024-05-10 16:00:00.000000',00000000000000000000),('2024-05-10 16:05:00.000000',00000000000000029600),('2024-05-10 16:10:00.000000',00000000000000038379),('2024-05-10 16:15:00.000000',00000000000000051179),('2024-05-10 16:20:00.000000',00000000000000055079),('2024-05-10 16:25:00.000000',00000000000000080779),('2024-05-10 16:30:00.000000',00000000000000085679),('2024-05-10 16:35:00.000000',00000000000000108379),('2024-05-10 16:40:00.000000',00000000000000116279),('2024-05-10 16:45:00.000000',00000000000000147479),('2024-05-10 16:50:00.000000',00000000000000169059),('2024-05-10 16:55:00.000000',00000000000000208059),('2024-05-10 17:00:00.000000',00000000000000212959),('2024-05-10 17:05:00.000000',00000000000000220859),('2024-05-10 17:10:00.000000',00000000000000238659),('2024-05-10 17:15:00.000000',00000000000000238659),('2024-05-10 17:20:00.000000',00000000000000228859),('2024-05-10 17:25:00.000000',00000000000000235759),('2024-05-10 17:30:00.000000',00000000000000244559),('2024-05-10 17:35:00.000000',00000000000000279059),('2024-05-10 17:40:00.000000',00000000000000297339),('2024-05-10 17:45:00.000000',00000000000000302239),('2024-05-10 17:50:00.000000',00000000000000302239),('2024-05-10 17:55:00.000000',00000000000000320039),('2024-05-10 18:00:00.000000',00000000000000322039),('2024-05-10 18:05:00.000000',00000000000000322039),('2024-05-10 18:10:00.000000',00000000000000322039),('2024-05-10 18:15:00.000000',00000000000000328639),('2024-05-10 18:20:00.000000',00000000000000328639),('2024-05-10 18:25:00.000000',00000000000000328639),('2024-05-10 18:30:00.000000',00000000000000329439),('2024-05-10 18:35:00.000000',00000000000000329439),('2024-05-10 18:40:00.000000',00000000000000334339),('2024-05-10 18:45:00.000000',00000000000000334339),('2024-05-10 18:50:00.000000',00000000000000334339),('2024-05-10 18:55:00.000000',00000000000000364939),('2024-05-10 19:00:00.000000',00000000000000364939),('2024-05-10 19:05:00.000000',00000000000000364939),('2024-05-10 19:10:00.000000',00000000000000364939),('2024-05-10 19:15:00.000000',00000000000000364939),('2024-05-10 19:20:00.000000',00000000000000382739),('2024-05-10 19:25:00.000000',00000000000000387639),('2024-05-10 19:30:00.000000',00000000000000420039),('2024-05-10 19:35:00.000000',00000000000000410139),('2024-05-10 19:40:00.000000',00000000000000410139),('2024-05-10 19:45:00.000000',00000000000000410139),('2024-05-10 19:50:00.000000',00000000000000410139),('2024-05-10 19:55:00.000000',00000000000000401339),('2024-05-10 20:00:00.000000',00000000000000401339),('2024-05-10 20:05:00.000000',00000000000000401339),('2024-05-10 20:10:00.000000',00000000000000401339),('2024-05-10 20:15:00.000000',00000000000000401339),('2024-05-10 20:20:00.000000',00000000000000401339),('2024-05-10 20:25:00.000000',00000000000000401339),('2024-05-10 20:30:00.000000',00000000000000401339),('2024-05-10 20:35:00.000000',00000000000000403239),('2024-05-10 20:40:00.000000',00000000000000403239),('2024-05-10 20:45:00.000000',00000000000000403239),('2024-05-10 20:50:00.000000',00000000000000403239),('2024-05-10 20:55:00.000000',00000000000000403239),('2024-05-10 21:00:00.000000',00000000000000410039),('2024-05-10 21:05:00.000000',00000000000000410039),('2024-05-10 21:10:00.000000',00000000000000410039),('2024-05-10 21:15:00.000000',00000000000000410039),('2024-05-10 21:20:00.000000',00000000000000410039),('2024-05-10 21:25:00.000000',00000000000000427839),('2024-05-10 21:30:00.000000',00000000000000427839),('2024-05-10 21:35:00.000000',00000000000000433739),('2024-05-10 21:40:00.000000',00000000000000433739),('2024-05-10 21:45:00.000000',00000000000000433739),('2024-05-10 21:50:00.000000',00000000000000433739),('2024-05-10 21:55:00.000000',00000000000000442639),('2024-05-10 22:00:00.000000',00000000000000458439),('2024-05-10 22:05:00.000000',00000000000000468339),('2024-05-10 22:10:00.000000',00000000000000468339),('2024-05-10 22:15:00.000000',00000000000000468339),('2024-05-10 22:20:00.000000',00000000000000468339),('2024-05-10 22:25:00.000000',00000000000000468339),('2024-05-10 22:30:00.000000',00000000000000468339),('2024-05-10 22:35:00.000000',00000000000000468339),('2024-05-10 22:40:00.000000',00000000000000468339),('2024-05-10 22:45:00.000000',00000000000000468339),('2024-05-10 22:50:00.000000',00000000000000468339),('2024-05-10 22:55:00.000000',00000000000000476239),('2024-05-10 23:00:00.000000',00000000000000476239),('2024-05-10 23:05:00.000000',00000000000000482139),('2024-05-10 23:10:00.000000',00000000000000482139),('2024-05-10 23:15:00.000000',00000000000000508039),('2024-05-10 23:20:00.000000',00000000000000508039),('2024-05-10 23:25:00.000000',00000000000000508039),('2024-05-10 23:30:00.000000',00000000000000531739),('2024-05-10 23:35:00.000000',00000000000000536619),('2024-05-10 23:40:00.000000',00000000000000536619),('2024-05-10 23:45:00.000000',00000000000000536619),('2024-05-10 23:50:00.000000',00000000000000536619),('2024-05-10 23:55:00.000000',00000000000000543419),('2024-05-11 00:00:00.000000',00000000000000548319),('2024-05-11 00:05:00.000000',00000000000000558219),('2024-05-11 00:10:00.000000',00000000000000558219),('2024-05-11 00:15:00.000000',00000000000000561119),('2024-05-11 00:20:00.000000',00000000000000562719),('2024-05-11 00:25:00.000000',00000000000000567619),('2024-05-11 00:30:00.000000',00000000000000567619),('2024-05-11 00:35:00.000000',00000000000000585319),('2024-05-11 00:40:00.000000',00000000000000647819),('2024-05-11 00:45:00.000000',00000000000000652719),('2024-05-11 00:50:00.000000',00000000000000660619),('2024-05-11 00:55:00.000000',00000000000000660619),('2024-05-11 01:00:00.000000',00000000000000670519),('2024-05-11 01:05:00.000000',00000000000000670519),('2024-05-11 01:10:00.000000',00000000000000692019),('2024-05-11 01:15:00.000000',00000000000000693119),('2024-05-11 01:20:00.000000',00000000000000693119),('2024-05-11 01:25:00.000000',00000000000000733019),('2024-05-11 01:30:00.000000',00000000000000756719),('2024-05-11 01:35:00.000000',00000000000000761619),('2024-05-11 01:40:00.000000',00000000000000761619),('2024-05-11 01:45:00.000000',00000000000000761619),('2024-05-11 01:50:00.000000',00000000000000775419),('2024-05-11 01:55:00.000000',00000000000000790219),('2024-05-11 02:00:00.000000',00000000000000798119),('2024-05-11 02:05:00.000000',00000000000000798119),('2024-05-11 02:10:00.000000',00000000000000798119),('2024-05-11 02:15:00.000000',00000000000000798119),('2024-05-11 02:20:00.000000',00000000000000806019),('2024-05-11 02:25:00.000000',00000000000000806019),('2024-05-11 02:30:00.000000',00000000000000813919),('2024-05-11 02:35:00.000000',00000000000000813919),('2024-05-11 02:40:00.000000',00000000000000853819),('2024-05-11 02:45:00.000000',00000000000000853819),('2024-05-11 02:50:00.000000',00000000000000853819),('2024-05-11 02:55:00.000000',00000000000000853819),('2024-05-11 03:00:00.000000',00000000000000853819),('2024-05-11 03:05:00.000000',00000000000000871499),('2024-05-11 03:10:00.000000',00000000000000883599),('2024-05-11 03:15:00.000000',00000000000000891499),('2024-05-11 03:20:00.000000',00000000000000891499),('2024-05-11 03:25:00.000000',00000000000000891499),('2024-05-11 03:30:00.000000',00000000000000895399),('2024-05-11 03:35:00.000000',00000000000000903299),('2024-05-11 03:40:00.000000',00000000000000907999),('2024-05-11 03:45:00.000000',00000000000000919778),('2024-05-11 03:50:00.000000',00000000000000919778),('2024-05-11 03:55:00.000000',00000000000000924678),('2024-05-11 04:00:00.000000',00000000000000924678),('2024-05-11 04:05:00.000000',00000000000000924678),('2024-05-11 04:10:00.000000',00000000000000947478),('2024-05-11 04:15:00.000000',00000000000000957378),('2024-05-11 04:20:00.000000',00000000000000957378),('2024-05-11 04:25:00.000000',00000000000000963278),('2024-05-11 04:30:00.000000',00000000000000966178),('2024-05-11 04:35:00.000000',00000000000000973078),('2024-05-11 04:40:00.000000',00000000000001005878),('2024-05-11 04:45:00.000000',00000000000001005878),('2024-05-11 04:50:00.000000',00000000000001005878),('2024-05-11 04:55:00.000000',00000000000001033778),('2024-05-11 05:00:00.000000',00000000000001063678),('2024-05-11 05:05:00.000000',00000000000001066678),('2024-05-11 05:10:00.000000',00000000000001074578),('2024-05-11 05:15:00.000000',00000000000001083378),('2024-05-11 05:20:00.000000',00000000000001075478),('2024-05-11 05:25:00.000000',00000000000001082378),('2024-05-11 05:30:00.000000',00000000000001082378),('2024-05-11 05:35:00.000000',00000000000001112878),('2024-05-11 05:40:00.000000',00000000000001115778),('2024-05-11 05:45:00.000000',00000000000001136478),('2024-05-11 05:50:00.000000',00000000000001156178),('2024-05-11 05:55:00.000000',00000000000001156178),('2024-05-11 06:00:00.000000',00000000000001171978),('2024-05-11 06:05:00.000000',00000000000001193668),('2024-05-11 06:10:00.000000',00000000000001193668),('2024-05-11 06:15:00.000000',00000000000001206568),('2024-05-11 06:20:00.000000',00000000000001206568),('2024-05-11 06:25:00.000000',00000000000001206568),('2024-05-11 06:30:00.000000',00000000000001206568),('2024-05-11 06:35:00.000000',00000000000001214468),('2024-05-11 06:40:00.000000',00000000000001220168),('2024-05-11 06:45:00.000000',00000000000001220168),('2024-05-11 06:50:00.000000',00000000000001220168),('2024-05-11 06:55:00.000000',00000000000001220168),('2024-05-11 07:00:00.000000',00000000000001220168),('2024-05-11 07:05:00.000000',00000000000001220168),('2024-05-11 07:10:00.000000',00000000000001224047),('2024-05-11 07:15:00.000000',00000000000001224047),('2024-05-11 07:20:00.000000',00000000000001224047),('2024-05-11 07:25:00.000000',00000000000001228947),('2024-05-11 07:30:00.000000',00000000000001228947),('2024-05-11 07:35:00.000000',00000000000001228947),('2024-05-11 07:40:00.000000',00000000000001228947),('2024-05-11 07:45:00.000000',00000000000001236147),('2024-05-11 07:50:00.000000',00000000000001239947),('2024-05-11 07:55:00.000000',00000000000001241947),('2024-05-11 08:00:00.000000',00000000000001241947),('2024-05-11 08:05:00.000000',00000000000001249847),('2024-05-11 08:10:00.000000',00000000000001249847),('2024-05-11 08:15:00.000000',00000000000001249847),('2024-05-11 08:20:00.000000',00000000000001249847),('2024-05-11 08:25:00.000000',00000000000001249847),('2024-05-11 08:30:00.000000',00000000000001249847),('2024-05-11 08:35:00.000000',00000000000001262647),('2024-05-11 08:40:00.000000',00000000000001286347),('2024-05-11 08:45:00.000000',00000000000001288347),('2024-05-11 08:50:00.000000',00000000000001288347),('2024-05-11 08:55:00.000000',00000000000001293247),('2024-05-11 09:00:00.000000',00000000000001298147),('2024-05-11 09:05:00.000000',00000000000001304047),('2024-05-11 09:10:00.000000',00000000000001308947),('2024-05-11 09:15:00.000000',00000000000001308947),('2024-05-11 09:20:00.000000',00000000000001330547),('2024-05-11 09:25:00.000000',00000000000001362847),('2024-05-11 09:30:00.000000',00000000000001380647),('2024-05-11 09:35:00.000000',00000000000001387547),('2024-05-11 09:40:00.000000',00000000000001449647),('2024-05-11 09:45:00.000000',00000000000001492526),('2024-05-11 09:50:00.000000',00000000000001518226),('2024-05-11 09:55:00.000000',00000000000001551784),('2024-05-11 10:00:00.000000',00000000000001601984),('2024-05-11 10:05:00.000000',00000000000001624763),('2024-05-11 10:10:00.000000',00000000000001656063),('2024-05-11 10:15:00.000000',00000000000001673763),('2024-05-11 10:20:00.000000',00000000000001683763),('2024-05-11 10:25:00.000000',00000000000001704463),('2024-05-11 10:30:00.000000',00000000000001761063),('2024-05-11 10:35:00.000000',00000000000001810542),('2024-05-11 10:40:00.000000',00000000000001849942),('2024-05-11 10:45:00.000000',00000000000001857842),('2024-05-11 10:50:00.000000',00000000000001872642),('2024-05-11 10:55:00.000000',00000000000001918042),('2024-05-11 11:00:00.000000',00000000000001946500),('2024-05-11 11:05:00.000000',00000000000001979680),('2024-05-11 11:10:00.000000',00000000000001991459),('2024-05-11 11:15:00.000000',00000000000002030659),('2024-05-11 11:20:00.000000',00000000000002080359),('2024-05-11 11:25:00.000000',00000000000002094159),('2024-05-11 11:30:00.000000',00000000000002108959),('2024-05-11 11:35:00.000000',00000000000002130438),('2024-05-11 11:40:00.000000',00000000000002168738),('2024-05-11 11:45:00.000000',00000000000002175638),('2024-05-11 11:50:00.000000',00000000000002193738),('2024-05-11 11:55:00.000000',00000000000002209418),('2024-05-11 12:00:00.000000',00000000000002222218),('2024-05-11 12:05:00.000000',00000000000002234018),('2024-05-11 12:10:00.000000',00000000000002239818),('2024-05-11 12:15:00.000000',00000000000002261618),('2024-05-11 12:20:00.000000',00000000000002272708),('2024-05-11 12:25:00.000000',00000000000002295408),('2024-05-11 12:30:00.000000',00000000000002325008),('2024-05-11 12:35:00.000000',00000000000002329908),('2024-05-11 12:40:00.000000',00000000000002334808),('2024-05-11 12:45:00.000000',00000000000002362408),('2024-05-11 12:50:00.000000',00000000000002379208),('2024-05-11 12:55:00.000000',00000000000002393008),('2024-05-11 13:00:00.000000',00000000000002397908),('2024-05-11 13:05:00.000000',00000000000002419608),('2024-05-11 13:10:00.000000',00000000000002437308),('2024-05-11 13:15:00.000000',00000000000002459808),('2024-05-11 13:20:00.000000',00000000000002477608),('2024-05-11 13:25:00.000000',00000000000002494308),('2024-05-11 13:30:00.000000',00000000000002527808),('2024-05-11 13:35:00.000000',00000000000002535708),('2024-05-11 13:40:00.000000',00000000000002563208),('2024-05-11 13:45:00.000000',00000000000002590808),('2024-05-11 13:50:00.000000',00000000000002644387),('2024-05-11 13:55:00.000000',00000000000002649387),('2024-05-11 14:00:00.000000',00000000000002639487),('2024-05-11 14:05:00.000000',00000000000002660087),('2024-05-11 14:10:00.000000',00000000000002684687),('2024-05-11 14:15:00.000000',00000000000002713266),('2024-05-11 14:20:00.000000',00000000000002726066),('2024-05-11 14:25:00.000000',00000000000002726066),('2024-05-11 14:30:00.000000',00000000000002735866),('2024-05-11 14:35:00.000000',00000000000002760566),('2024-05-11 14:40:00.000000',00000000000002785266),('2024-05-11 14:45:00.000000',00000000000002823766),('2024-05-11 14:50:00.000000',00000000000002836466),('2024-05-11 14:55:00.000000',00000000000002866066),('2024-05-11 15:00:00.000000',00000000000002872966),('2024-05-11 15:05:00.000000',00000000000002887766),('2024-05-11 15:10:00.000000',00000000000002922566),('2024-05-11 15:15:00.000000',00000000000002932466),('2024-05-11 15:20:00.000000',00000000000002955966),('2024-05-11 15:25:00.000000',00000000000003008266),('2024-05-11 15:30:00.000000',00000000000003025866),('2024-05-11 15:35:00.000000',00000000000003046245),('2024-05-11 15:40:00.000000',00000000000003057824),('2024-05-11 15:45:00.000000',00000000000003061624),('2024-05-11 15:50:00.000000',00000000000003061624),('2024-05-11 15:55:00.000000',00000000000003075324),('2024-05-11 16:00:00.000000',00000000000000000000),('2024-05-11 16:05:00.000000',00000000000000065700),('2024-05-11 16:10:00.000000',00000000000000070600),('2024-05-11 16:15:00.000000',00000000000000085400),('2024-05-11 16:20:00.000000',00000000000000093300),('2024-05-11 16:25:00.000000',00000000000000125600),('2024-05-11 16:30:00.000000',00000000000000165500),('2024-05-11 16:35:00.000000',00000000000000183200),('2024-05-11 16:40:00.000000',00000000000000204879),('2024-05-11 16:45:00.000000',00000000000000204879),('2024-05-11 16:50:00.000000',00000000000000260379),('2024-05-11 16:55:00.000000',00000000000000278079),('2024-05-11 17:00:00.000000',00000000000000287879),('2024-05-11 17:05:00.000000',00000000000000316458),('2024-05-11 17:10:00.000000',00000000000000331258),('2024-05-11 17:15:00.000000',00000000000000338158),('2024-05-11 17:20:00.000000',00000000000000430058),('2024-05-11 17:25:00.000000',00000000000000430058),('2024-05-11 17:30:00.000000',00000000000000515258),('2024-05-11 17:35:00.000000',00000000000000537758),('2024-05-11 17:40:00.000000',00000000000000555558),('2024-05-11 17:45:00.000000',00000000000000565358),('2024-05-11 17:50:00.000000',00000000000000570258),('2024-05-11 17:55:00.000000',00000000000000570258),('2024-05-11 18:00:00.000000',00000000000000576137),('2024-05-11 18:05:00.000000',00000000000000586937),('2024-05-11 18:10:00.000000',00000000000000586937),('2024-05-11 18:15:00.000000',00000000000000586937),('2024-05-11 18:20:00.000000',00000000000000598737),('2024-05-11 18:25:00.000000',00000000000000600737),('2024-05-11 18:30:00.000000',00000000000000653437),('2024-05-11 18:35:00.000000',00000000000000679137),('2024-05-11 18:40:00.000000',00000000000000684037),('2024-05-11 18:45:00.000000',00000000000000683037),('2024-05-11 18:50:00.000000',00000000000000707737),('2024-05-11 18:55:00.000000',00000000000000731337),('2024-05-11 19:00:00.000000',00000000000000737237),('2024-05-11 19:05:00.000000',00000000000000769237),('2024-05-11 19:10:00.000000',00000000000000776237),('2024-05-11 19:15:00.000000',00000000000000766337),('2024-05-11 19:20:00.000000',00000000000000771237),('2024-05-11 19:25:00.000000',00000000000000771237),('2024-05-11 19:30:00.000000',00000000000000771237),('2024-05-11 19:35:00.000000',00000000000000786037),('2024-05-11 19:40:00.000000',00000000000000786037),('2024-05-11 19:45:00.000000',00000000000000804737),('2024-05-11 19:50:00.000000',00000000000000808616),('2024-05-11 19:55:00.000000',00000000000000839116),('2024-05-11 20:00:00.000000',00000000000001133716),('2024-05-11 20:05:00.000000',00000000000001148516),('2024-05-11 20:10:00.000000',00000000000001162316),('2024-05-11 20:15:00.000000',00000000000001162316),('2024-05-11 20:20:00.000000',00000000000001162316),('2024-05-11 20:25:00.000000',00000000000001162316),('2024-05-11 20:30:00.000000',00000000000001162316),('2024-05-11 20:35:00.000000',00000000000001162316),('2024-05-11 20:40:00.000000',00000000000001172216),('2024-05-11 20:45:00.000000',00000000000001172216),('2024-05-11 20:50:00.000000',00000000000001172216),('2024-05-11 20:55:00.000000',00000000000001172216),('2024-05-11 21:00:00.000000',00000000000001186016),('2024-05-11 21:05:00.000000',00000000000001186016),('2024-05-11 21:10:00.000000',00000000000001186016),('2024-05-11 21:15:00.000000',00000000000001190916),('2024-05-11 21:20:00.000000',00000000000001199816),('2024-05-11 21:25:00.000000',00000000000001209716),('2024-05-11 21:30:00.000000',00000000000001214616),('2024-05-11 21:35:00.000000',00000000000001214616),('2024-05-11 21:40:00.000000',00000000000001214616),('2024-05-11 21:45:00.000000',00000000000001214616),('2024-05-11 21:50:00.000000',00000000000001214616),('2024-05-11 21:55:00.000000',00000000000001214616),('2024-05-11 22:00:00.000000',00000000000001214616),('2024-05-11 22:05:00.000000',00000000000001229216),('2024-05-11 22:10:00.000000',00000000000001234116),('2024-05-11 22:15:00.000000',00000000000001239016),('2024-05-11 22:20:00.000000',00000000000001248916),('2024-05-11 22:25:00.000000',00000000000001253816),('2024-05-11 22:30:00.000000',00000000000001254416),('2024-05-11 22:35:00.000000',00000000000001264816),('2024-05-11 22:40:00.000000',00000000000001272716),('2024-05-11 22:45:00.000000',00000000000001281516),('2024-05-11 22:50:00.000000',00000000000001281516),('2024-05-11 22:55:00.000000',00000000000001281516),('2024-05-11 23:00:00.000000',00000000000001286416),('2024-05-11 23:05:00.000000',00000000000001288416),('2024-05-11 23:10:00.000000',00000000000001303216),('2024-05-11 23:15:00.000000',00000000000001309016),('2024-05-11 23:20:00.000000',00000000000001309016),('2024-05-11 23:25:00.000000',00000000000001309016),('2024-05-11 23:30:00.000000',00000000000001309016),('2024-05-11 23:35:00.000000',00000000000001321816),('2024-05-11 23:40:00.000000',00000000000001334516),('2024-05-11 23:45:00.000000',00000000000001339416),('2024-05-11 23:50:00.000000',00000000000001348316),('2024-05-11 23:55:00.000000',00000000000001348316),('2024-05-12 00:00:00.000000',00000000000001348316),('2024-05-12 00:05:00.000000',00000000000001348316),('2024-05-12 00:10:00.000000',00000000000001352216),('2024-05-12 00:15:00.000000',00000000000001357116),('2024-05-12 00:20:00.000000',00000000000001362916),('2024-05-12 00:25:00.000000',00000000000001364916),('2024-05-12 00:30:00.000000',00000000000001378616),('2024-05-12 00:35:00.000000',00000000000001418516),('2024-05-12 00:40:00.000000',00000000000001423416),('2024-05-12 00:45:00.000000',00000000000001423416),('2024-05-12 00:50:00.000000',00000000000001423416),('2024-05-12 00:55:00.000000',00000000000001445116),('2024-05-12 01:00:00.000000',00000000000001461816),('2024-05-12 01:05:00.000000',00000000000001469516),('2024-05-12 01:10:00.000000',00000000000001487996),('2024-05-12 01:15:00.000000',00000000000001538596),('2024-05-12 01:20:00.000000',00000000000001538596),('2024-05-12 01:25:00.000000',00000000000001549296),('2024-05-12 01:30:00.000000',00000000000001561096),('2024-05-12 01:35:00.000000',00000000000001573896),('2024-05-12 01:40:00.000000',00000000000001583796),('2024-05-12 01:45:00.000000',00000000000001589596),('2024-05-12 01:50:00.000000',00000000000001596496),('2024-05-12 01:55:00.000000',00000000000001605396),('2024-05-12 02:00:00.000000',00000000000001605396),('2024-05-12 02:05:00.000000',00000000000001605396),('2024-05-12 02:10:00.000000',00000000000001605396),('2024-05-12 02:15:00.000000',00000000000001612296),('2024-05-12 02:20:00.000000',00000000000001632996),('2024-05-12 02:25:00.000000',00000000000001656696),('2024-05-12 02:30:00.000000',00000000000001660575),('2024-05-12 02:35:00.000000',00000000000001665475),('2024-05-12 02:40:00.000000',00000000000001680375),('2024-05-12 02:45:00.000000',00000000000001680375),('2024-05-12 02:50:00.000000',00000000000001688275),('2024-05-12 02:55:00.000000',00000000000001688275),('2024-05-12 03:00:00.000000',00000000000001688275),('2024-05-12 03:05:00.000000',00000000000001696175),('2024-05-12 03:10:00.000000',00000000000001696175),('2024-05-12 03:15:00.000000',00000000000001706075),('2024-05-12 03:20:00.000000',00000000000001713975),('2024-05-12 03:25:00.000000',00000000000001724075),('2024-05-12 03:30:00.000000',00000000000001724075),('2024-05-12 03:35:00.000000',00000000000001724075),('2024-05-12 03:40:00.000000',00000000000001737875),('2024-05-12 03:45:00.000000',00000000000001737875),('2024-05-12 03:50:00.000000',00000000000001754675),('2024-05-12 03:55:00.000000',00000000000001761475),('2024-05-12 04:00:00.000000',00000000000001761475),('2024-05-12 04:05:00.000000',00000000000001765275),('2024-05-12 04:10:00.000000',00000000000001778075),('2024-05-12 04:15:00.000000',00000000000001781075),('2024-05-12 04:20:00.000000',00000000000001781075),('2024-05-12 04:25:00.000000',00000000000001781075),('2024-05-12 04:30:00.000000',00000000000001790975),('2024-05-12 04:35:00.000000',00000000000001790975),('2024-05-12 04:40:00.000000',00000000000001798875),('2024-05-12 04:45:00.000000',00000000000001810475),('2024-05-12 04:50:00.000000',00000000000001819275),('2024-05-12 04:55:00.000000',00000000000001832054),('2024-05-12 05:00:00.000000',00000000000001832054),('2024-05-12 05:05:00.000000',00000000000001853454),('2024-05-12 05:10:00.000000',00000000000001878154),('2024-05-12 05:15:00.000000',00000000000001883054),('2024-05-12 05:20:00.000000',00000000000001895754),('2024-05-12 05:25:00.000000',00000000000001903554),('2024-05-12 05:30:00.000000',00000000000001918354),('2024-05-12 05:35:00.000000',00000000000001928254),('2024-05-12 05:40:00.000000',00000000000001985854),('2024-05-12 05:45:00.000000',00000000000002003654),('2024-05-12 05:50:00.000000',00000000000002003654),('2024-05-12 05:55:00.000000',00000000000002003654),('2024-05-12 06:00:00.000000',00000000000002011754),('2024-05-12 06:05:00.000000',00000000000002011754),('2024-05-12 06:10:00.000000',00000000000002011754),('2024-05-12 06:15:00.000000',00000000000002016654),('2024-05-12 06:20:00.000000',00000000000002034254),('2024-05-12 06:25:00.000000',00000000000002034254),('2024-05-12 06:30:00.000000',00000000000002049054),('2024-05-12 06:35:00.000000',00000000000002058733),('2024-05-12 06:40:00.000000',00000000000002065333),('2024-05-12 06:45:00.000000',00000000000002072233),('2024-05-12 06:50:00.000000',00000000000002080133),('2024-05-12 06:55:00.000000',00000000000002080133),('2024-05-12 07:00:00.000000',00000000000002088033),('2024-05-12 07:05:00.000000',00000000000002088033),('2024-05-12 07:10:00.000000',00000000000002097933),('2024-05-12 07:15:00.000000',00000000000002097933),('2024-05-12 07:20:00.000000',00000000000002097933),('2024-05-12 07:25:00.000000',00000000000002102833),('2024-05-12 07:30:00.000000',00000000000002121633),('2024-05-12 07:35:00.000000',00000000000002111733),('2024-05-12 07:40:00.000000',00000000000002129433),('2024-05-12 07:45:00.000000',00000000000002183223),('2024-05-12 07:50:00.000000',00000000000002205723),('2024-05-12 07:55:00.000000',00000000000002210623),('2024-05-12 08:00:00.000000',00000000000002210623),('2024-05-12 08:05:00.000000',00000000000002225413),('2024-05-12 08:10:00.000000',00000000000002258913),('2024-05-12 08:15:00.000000',00000000000002272613),('2024-05-12 08:20:00.000000',00000000000002278513),('2024-05-12 08:25:00.000000',00000000000002295213),('2024-05-12 08:30:00.000000',00000000000002297213),('2024-05-12 08:35:00.000000',00000000000002297213),('2024-05-12 08:40:00.000000',00000000000002316913),('2024-05-12 08:45:00.000000',00000000000002325813),('2024-05-12 08:50:00.000000',00000000000002405613),('2024-05-12 08:55:00.000000',00000000000002405613),('2024-05-12 09:00:00.000000',00000000000002424213),('2024-05-12 09:05:00.000000',00000000000002445813),('2024-05-12 09:10:00.000000',00000000000002457613),('2024-05-12 09:15:00.000000',00000000000002464513),('2024-05-12 09:20:00.000000',00000000000002504413),('2024-05-12 09:25:00.000000',00000000000002508857),('2024-05-12 09:30:00.000000',00000000000002508857),('2024-05-12 09:35:00.000000',00000000000002508857),('2024-05-12 09:40:00.000000',00000000000002513757),('2024-05-12 09:45:00.000000',00000000000002525557),('2024-05-12 09:50:00.000000',00000000000002525557),('2024-05-12 09:55:00.000000',00000000000002535457),('2024-05-12 10:00:00.000000',00000000000002535457),('2024-05-12 10:05:00.000000',00000000000002541257),('2024-05-12 10:10:00.000000',00000000000002549157),('2024-05-12 10:15:00.000000',00000000000002557057),('2024-05-12 10:20:00.000000',00000000000002561957),('2024-05-12 10:25:00.000000',00000000000002561957),('2024-05-12 10:30:00.000000',00000000000002581657),('2024-05-12 10:35:00.000000',00000000000002591036),('2024-05-12 10:40:00.000000',00000000000002595936),('2024-05-12 10:45:00.000000',00000000000002648636),('2024-05-12 10:50:00.000000',00000000000002648636),('2024-05-12 10:55:00.000000',00000000000002666336),('2024-05-12 11:00:00.000000',00000000000002691936),('2024-05-12 11:05:00.000000',00000000000002740036),('2024-05-12 11:10:00.000000',00000000000002751836),('2024-05-12 11:15:00.000000',00000000000002774536),('2024-05-12 11:20:00.000000',00000000000002794236),('2024-05-12 11:25:00.000000',00000000000002806936),('2024-05-12 11:30:00.000000',00000000000002825136),('2024-05-12 11:35:00.000000',00000000000002822336),('2024-05-12 11:40:00.000000',00000000000002830236),('2024-05-12 11:45:00.000000',00000000000002827236),('2024-05-12 11:50:00.000000',00000000000002833136),('2024-05-12 11:55:00.000000',00000000000002833136),('2024-05-12 12:00:00.000000',00000000000002842815),('2024-05-12 12:05:00.000000',00000000000002852715),('2024-05-12 12:10:00.000000',00000000000002861515),('2024-05-12 12:15:00.000000',00000000000002861515),('2024-05-12 12:20:00.000000',00000000000002865315),('2024-05-12 12:25:00.000000',00000000000002870215),('2024-05-12 12:30:00.000000',00000000000002890815),('2024-05-12 12:35:00.000000',00000000000002894715),('2024-05-12 12:40:00.000000',00000000000002894715),('2024-05-12 12:45:00.000000',00000000000002900515),('2024-05-12 12:50:00.000000',00000000000002905415),('2024-05-12 12:55:00.000000',00000000000002905415),('2024-05-12 13:00:00.000000',00000000000002905415),('2024-05-12 13:05:00.000000',00000000000002912395),('2024-05-12 13:10:00.000000',00000000000002912395),('2024-05-12 13:15:00.000000',00000000000002912395),('2024-05-12 13:20:00.000000',00000000000002912395),('2024-05-12 13:25:00.000000',00000000000002912395),('2024-05-12 13:30:00.000000',00000000000002933095),('2024-05-12 13:35:00.000000',00000000000002933095),('2024-05-12 13:40:00.000000',00000000000002941995),('2024-05-12 13:45:00.000000',00000000000002951895),('2024-05-12 13:50:00.000000',00000000000002951895),('2024-05-12 13:55:00.000000',00000000000002951895),('2024-05-12 14:00:00.000000',00000000000002960795),('2024-05-12 14:05:00.000000',00000000000002960795),('2024-05-12 14:10:00.000000',00000000000002975595),('2024-05-12 14:15:00.000000',00000000000003005395),('2024-05-12 14:20:00.000000',00000000000003005395),('2024-05-12 14:25:00.000000',00000000000003029095),('2024-05-12 14:30:00.000000',00000000000003037895),('2024-05-12 14:35:00.000000',00000000000003045795),('2024-05-12 14:40:00.000000',00000000000003053495),('2024-05-12 14:45:00.000000',00000000000003069195),('2024-05-12 14:50:00.000000',00000000000003069195),('2024-05-12 14:55:00.000000',00000000000003069195),('2024-05-12 15:00:00.000000',00000000000003069195),('2024-05-12 15:05:00.000000',00000000000003073095),('2024-05-12 15:10:00.000000',00000000000003073095),('2024-05-12 15:15:00.000000',00000000000003073095),('2024-05-12 15:20:00.000000',00000000000003081895),('2024-05-12 15:25:00.000000',00000000000003081895),('2024-05-12 15:30:00.000000',00000000000003091674),('2024-05-12 15:35:00.000000',00000000000003091674),('2024-05-12 15:40:00.000000',00000000000003104474),('2024-05-12 15:45:00.000000',00000000000003119274),('2024-05-12 15:50:00.000000',00000000000003127264),('2024-05-12 15:55:00.000000',00000000000003162264),('2024-05-12 16:00:00.000000',00000000000000000000),('2024-05-12 16:05:00.000000',00000000000000014800),('2024-05-12 16:10:00.000000',00000000000000035600),('2024-05-12 16:15:00.000000',00000000000000049400),('2024-05-12 16:20:00.000000',00000000000000056300),('2024-05-12 16:25:00.000000',00000000000000088900),('2024-05-12 16:30:00.000000',00000000000000114458),('2024-05-12 16:35:00.000000',00000000000000140058),('2024-05-12 16:40:00.000000',00000000000000140058),('2024-05-12 16:45:00.000000',00000000000000184858),('2024-05-12 16:50:00.000000',00000000000000190758),('2024-05-12 16:55:00.000000',00000000000000190758),('2024-05-12 17:00:00.000000',00000000000000212358),('2024-05-12 17:05:00.000000',00000000000000234058),('2024-05-12 17:10:00.000000',00000000000000257648),('2024-05-12 17:15:00.000000',00000000000000371848),('2024-05-12 17:20:00.000000',00000000000000391648),('2024-05-12 17:25:00.000000',00000000000000421938),('2024-05-12 17:30:00.000000',00000000000000439738),('2024-05-12 17:35:00.000000',00000000000000460538),('2024-05-12 17:40:00.000000',00000000000000460538),('2024-05-12 17:45:00.000000',00000000000000474238),('2024-05-12 17:50:00.000000',00000000000000524938),('2024-05-12 17:55:00.000000',00000000000000534838),('2024-05-12 18:00:00.000000',00000000000000534838),('2024-05-12 18:05:00.000000',00000000000000542738),('2024-05-12 18:10:00.000000',00000000000000542738),('2024-05-12 18:15:00.000000',00000000000000542738),('2024-05-12 18:20:00.000000',00000000000000547638),('2024-05-12 18:25:00.000000',00000000000000552538),('2024-05-12 18:30:00.000000',00000000000000579338),('2024-05-12 18:35:00.000000',00000000000000579338),('2024-05-12 18:40:00.000000',00000000000000579338),('2024-05-12 18:45:00.000000',00000000000000589238),('2024-05-12 18:50:00.000000',00000000000000589238),('2024-05-12 18:55:00.000000',00000000000000597038),('2024-05-12 19:00:00.000000',00000000000000599038),('2024-05-12 19:05:00.000000',00000000000000599038),('2024-05-12 19:10:00.000000',00000000000000599038),('2024-05-12 19:15:00.000000',00000000000000599038),('2024-05-12 19:20:00.000000',00000000000000608938),('2024-05-12 19:25:00.000000',00000000000000608938),('2024-05-12 19:30:00.000000',00000000000000608938),('2024-05-12 19:35:00.000000',00000000000000616838),('2024-05-12 19:40:00.000000',00000000000000616838),('2024-05-12 19:45:00.000000',00000000000000616838),('2024-05-12 19:50:00.000000',00000000000000616838),('2024-05-12 19:55:00.000000',00000000000000616838),('2024-05-12 20:00:00.000000',00000000000000626738),('2024-05-12 20:05:00.000000',00000000000000626738),('2024-05-12 20:10:00.000000',00000000000000631638),('2024-05-12 20:15:00.000000',00000000000000631638),('2024-05-12 20:20:00.000000',00000000000000631638),('2024-05-12 20:25:00.000000',00000000000000631638),('2024-05-12 20:30:00.000000',00000000000000636538),('2024-05-12 20:35:00.000000',00000000000000636538),('2024-05-12 20:40:00.000000',00000000000000636538),('2024-05-12 20:45:00.000000',00000000000000636538),('2024-05-12 20:50:00.000000',00000000000000636538),('2024-05-12 20:55:00.000000',00000000000000636538),('2024-05-12 21:00:00.000000',00000000000000636538),('2024-05-12 21:05:00.000000',00000000000000636538),('2024-05-12 21:10:00.000000',00000000000000646438),('2024-05-12 21:15:00.000000',00000000000000646438),('2024-05-12 21:20:00.000000',00000000000000656338),('2024-05-12 21:25:00.000000',00000000000000674938),('2024-05-12 21:30:00.000000',00000000000000674938),('2024-05-12 21:35:00.000000',00000000000000674938),('2024-05-12 21:40:00.000000',00000000000000674938),('2024-05-12 21:45:00.000000',00000000000000683838),('2024-05-12 21:50:00.000000',00000000000000683838),('2024-05-12 21:55:00.000000',00000000000000683838),('2024-05-12 22:00:00.000000',00000000000000688638),('2024-05-12 22:05:00.000000',00000000000000688638),('2024-05-12 22:10:00.000000',00000000000000688638),('2024-05-12 22:15:00.000000',00000000000000688638),('2024-05-12 22:20:00.000000',00000000000000688638),('2024-05-12 22:25:00.000000',00000000000000688638),('2024-05-12 22:30:00.000000',00000000000000688638),('2024-05-12 22:35:00.000000',00000000000000702338),('2024-05-12 22:40:00.000000',00000000000000702338),('2024-05-12 22:45:00.000000',00000000000000711238),('2024-05-12 22:50:00.000000',00000000000000711238),('2024-05-12 22:55:00.000000',00000000000000716138),('2024-05-12 23:00:00.000000',00000000000000716138),('2024-05-12 23:05:00.000000',00000000000000721038),('2024-05-12 23:10:00.000000',00000000000000721038),('2024-05-12 23:15:00.000000',00000000000000734738),('2024-05-12 23:20:00.000000',00000000000000734738),('2024-05-12 23:25:00.000000',00000000000000743538),('2024-05-12 23:30:00.000000',00000000000000753438),('2024-05-12 23:35:00.000000',00000000000000753438),('2024-05-12 23:40:00.000000',00000000000000753438),('2024-05-12 23:45:00.000000',00000000000000762238),('2024-05-12 23:50:00.000000',00000000000000762238),('2024-05-12 23:55:00.000000',00000000000000762238),('2024-05-13 00:00:00.000000',00000000000000769138),('2024-05-13 00:05:00.000000',00000000000000774038),('2024-05-13 00:10:00.000000',00000000000000774038),('2024-05-13 00:15:00.000000',00000000000000780938),('2024-05-13 00:20:00.000000',00000000000000780938),('2024-05-13 00:25:00.000000',00000000000000792738),('2024-05-13 00:30:00.000000',00000000000000818138),('2024-05-13 00:35:00.000000',00000000000000822017),('2024-05-13 00:40:00.000000',00000000000000837017),('2024-05-13 00:45:00.000000',00000000000000845917),('2024-05-13 00:50:00.000000',00000000000000845917),('2024-05-13 00:55:00.000000',00000000000000861617),('2024-05-13 01:00:00.000000',00000000000000861617),('2024-05-13 01:05:00.000000',00000000000000861617),('2024-05-13 01:10:00.000000',00000000000000901517),('2024-05-13 01:15:00.000000',00000000000000912317),('2024-05-13 01:20:00.000000',00000000000000923207),('2024-05-13 01:25:00.000000',00000000000000932007),('2024-05-13 01:30:00.000000',00000000000000943807),('2024-05-13 01:35:00.000000',00000000000000953807),('2024-05-13 01:40:00.000000',00000000000000968486),('2024-05-13 01:45:00.000000',00000000000000978386),('2024-05-13 01:50:00.000000',00000000000000983286),('2024-05-13 01:55:00.000000',00000000000000983286),('2024-05-13 02:00:00.000000',00000000000000991186),('2024-05-13 02:05:00.000000',00000000000000991186),('2024-05-13 02:10:00.000000',00000000000000991186),('2024-05-13 02:15:00.000000',00000000000000991186),('2024-05-13 02:20:00.000000',00000000000000995086),('2024-05-13 02:25:00.000000',00000000000000995086),('2024-05-13 02:30:00.000000',00000000000000998986),('2024-05-13 02:35:00.000000',00000000000001008986),('2024-05-13 02:40:00.000000',00000000000001009986),('2024-05-13 02:45:00.000000',00000000000001020486),('2024-05-13 02:50:00.000000',00000000000001020486),('2024-05-13 02:55:00.000000',00000000000001020486),('2024-05-13 03:00:00.000000',00000000000001039186),('2024-05-13 03:05:00.000000',00000000000001044086),('2024-05-13 03:10:00.000000',00000000000001050986),('2024-05-13 03:15:00.000000',00000000000001050986),('2024-05-13 03:20:00.000000',00000000000001050986),('2024-05-13 03:25:00.000000',00000000000001058886),('2024-05-13 03:30:00.000000',00000000000001058886),('2024-05-13 03:35:00.000000',00000000000001058886),('2024-05-13 03:40:00.000000',00000000000001062786),('2024-05-13 03:45:00.000000',00000000000001062786),('2024-05-13 03:50:00.000000',00000000000001142586),('2024-05-13 03:55:00.000000',00000000000001148486),('2024-05-13 04:00:00.000000',00000000000001153386),('2024-05-13 04:05:00.000000',00000000000001165186),('2024-05-13 04:10:00.000000',00000000000001165186),('2024-05-13 04:15:00.000000',00000000000001172086),('2024-05-13 04:20:00.000000',00000000000001191986),('2024-05-13 04:25:00.000000',00000000000001191986),('2024-05-13 04:30:00.000000',00000000000001191986),('2024-05-13 04:35:00.000000',00000000000001191986),('2024-05-13 04:40:00.000000',00000000000001200786),('2024-05-13 04:45:00.000000',00000000000001245586),('2024-05-13 04:50:00.000000',00000000000001257386),('2024-05-13 04:55:00.000000',00000000000001264286),('2024-05-13 05:00:00.000000',00000000000001280986),('2024-05-13 05:05:00.000000',00000000000001287886),('2024-05-13 05:10:00.000000',00000000000001292786),('2024-05-13 05:15:00.000000',00000000000001312686),('2024-05-13 05:20:00.000000',00000000000001321486),('2024-05-13 05:25:00.000000',00000000000001331386),('2024-05-13 05:30:00.000000',00000000000001505086),('2024-05-13 05:35:00.000000',00000000000001513886),('2024-05-13 05:40:00.000000',00000000000001513886),('2024-05-13 05:45:00.000000',00000000000001523786),('2024-05-13 05:50:00.000000',00000000000001523786),('2024-05-13 05:55:00.000000',00000000000001523786),('2024-05-13 06:00:00.000000',00000000000001531686),('2024-05-13 06:05:00.000000',00000000000001538586),('2024-05-13 06:10:00.000000',00000000000001543486),('2024-05-13 06:15:00.000000',00000000000001551386),('2024-05-13 06:20:00.000000',00000000000001559286),('2024-05-13 06:25:00.000000',00000000000001599186),('2024-05-13 06:30:00.000000',00000000000001604086),('2024-05-13 06:35:00.000000',00000000000001604086),('2024-05-13 06:40:00.000000',00000000000001627686),('2024-05-13 06:45:00.000000',00000000000001678286),('2024-05-13 06:50:00.000000',00000000000001684186),('2024-05-13 06:55:00.000000',00000000000001697986),('2024-05-13 07:00:00.000000',00000000000001697986),('2024-05-13 07:05:00.000000',00000000000001697986),('2024-05-13 07:10:00.000000',00000000000001702886),('2024-05-13 07:15:00.000000',00000000000001705786),('2024-05-13 07:20:00.000000',00000000000001705786),('2024-05-13 07:25:00.000000',00000000000001710686),('2024-05-13 07:30:00.000000',00000000000001735386),('2024-05-13 07:35:00.000000',00000000000001743286),('2024-05-13 07:40:00.000000',00000000000001743286),('2024-05-13 07:45:00.000000',00000000000001755086),('2024-05-13 07:50:00.000000',00000000000001764986),('2024-05-13 07:55:00.000000',00000000000001764986),('2024-05-13 08:00:00.000000',00000000000001778786),('2024-05-13 08:05:00.000000',00000000000001790686),('2024-05-13 08:10:00.000000',00000000000001793586),('2024-05-13 08:15:00.000000',00000000000001793586),('2024-05-13 08:20:00.000000',00000000000001799486),('2024-05-13 08:25:00.000000',00000000000001804386),('2024-05-13 08:30:00.000000',00000000000001810286),('2024-05-13 08:35:00.000000',00000000000001806386),('2024-05-13 08:40:00.000000',00000000000001821186),('2024-05-13 08:45:00.000000',00000000000001830086),('2024-05-13 08:50:00.000000',00000000000001838686),('2024-05-13 08:55:00.000000',00000000000001853486),('2024-05-13 09:00:00.000000',00000000000001844586),('2024-05-13 09:05:00.000000',00000000000001852486),('2024-05-13 09:10:00.000000',00000000000001859386),('2024-05-13 09:15:00.000000',00000000000001872186),('2024-05-13 09:20:00.000000',00000000000001872186),('2024-05-13 09:25:00.000000',00000000000001876986),('2024-05-13 09:30:00.000000',00000000000001887886),('2024-05-13 09:35:00.000000',00000000000001893786),('2024-05-13 09:40:00.000000',00000000000001898686),('2024-05-13 09:45:00.000000',00000000000001915486),('2024-05-13 09:50:00.000000',00000000000001919386),('2024-05-13 09:55:00.000000',00000000000001929286),('2024-05-13 10:00:00.000000',00000000000001922386),('2024-05-13 10:05:00.000000',00000000000001928286),('2024-05-13 10:10:00.000000',00000000000001932086),('2024-05-13 10:15:00.000000',00000000000001936986),('2024-05-13 10:20:00.000000',00000000000001941886),('2024-05-13 10:25:00.000000',00000000000001951686),('2024-05-13 10:30:00.000000',00000000000001964486),('2024-05-13 10:35:00.000000',00000000000001978986),('2024-05-13 10:40:00.000000',00000000000001992686),('2024-05-13 10:45:00.000000',00000000000002009386),('2024-05-13 10:50:00.000000',00000000000002019186),('2024-05-13 10:55:00.000000',00000000000002041786),('2024-05-13 11:00:00.000000',00000000000002061286),('2024-05-13 11:05:00.000000',00000000000002073086),('2024-05-13 11:10:00.000000',00000000000002090686),('2024-05-13 11:15:00.000000',00000000000002099586),('2024-05-13 11:20:00.000000',00000000000002104486),('2024-05-13 11:25:00.000000',00000000000002104486),('2024-05-13 11:30:00.000000',00000000000002128086),('2024-05-13 11:35:00.000000',00000000000002133986),('2024-05-13 11:40:00.000000',00000000000002146766),('2024-05-13 11:45:00.000000',00000000000002156466),('2024-05-13 11:50:00.000000',00000000000002191166),('2024-05-13 11:55:00.000000',00000000000002204966),('2024-05-13 12:00:00.000000',00000000000002227666),('2024-05-13 12:05:00.000000',00000000000002246166),('2024-05-13 12:10:00.000000',00000000000002248166),('2024-05-13 12:15:00.000000',00000000000002253066),('2024-05-13 12:20:00.000000',00000000000002253666),('2024-05-13 12:25:00.000000',00000000000002267366),('2024-05-13 12:30:00.000000',00000000000002274266),('2024-05-13 12:35:00.000000',00000000000002274266),('2024-05-13 12:40:00.000000',00000000000002274266),('2024-05-13 12:45:00.000000',00000000000002282166),('2024-05-13 12:50:00.000000',00000000000002287066),('2024-05-13 12:55:00.000000',00000000000002279166),('2024-05-13 13:00:00.000000',00000000000002279166),('2024-05-13 13:05:00.000000',00000000000002279166),('2024-05-13 13:10:00.000000',00000000000002294766),('2024-05-13 13:15:00.000000',00000000000002304666),('2024-05-13 13:20:00.000000',00000000000002321466),('2024-05-13 13:25:00.000000',00000000000002347066),('2024-05-13 13:30:00.000000',00000000000002374766),('2024-05-13 13:35:00.000000',00000000000002424566),('2024-05-13 13:40:00.000000',00000000000002427366),('2024-05-13 13:45:00.000000',00000000000002427366),('2024-05-13 13:50:00.000000',00000000000002427366),('2024-05-13 13:55:00.000000',00000000000002447966),('2024-05-13 14:00:00.000000',00000000000002457866),('2024-05-13 14:05:00.000000',00000000000002463366),('2024-05-13 14:10:00.000000',00000000000002476966),('2024-05-13 14:15:00.000000',00000000000002476966),('2024-05-13 14:20:00.000000',00000000000002477766),('2024-05-13 14:25:00.000000',00000000000002485266),('2024-05-13 14:30:00.000000',00000000000002485266),('2024-05-13 14:35:00.000000',00000000000002559866),('2024-05-13 14:40:00.000000',00000000000002659466),('2024-05-13 14:45:00.000000',00000000000002681366),('2024-05-13 14:50:00.000000',00000000000002709266),('2024-05-13 14:55:00.000000',00000000000002726066),('2024-05-13 15:00:00.000000',00000000000002738866),('2024-05-13 15:05:00.000000',00000000000002746766),('2024-05-13 15:10:00.000000',00000000000002751666),('2024-05-13 15:15:00.000000',00000000000002782166),('2024-05-13 15:20:00.000000',00000000000002806766),('2024-05-13 15:25:00.000000',00000000000002811666),('2024-05-13 15:30:00.000000',00000000000002815566),('2024-05-13 15:35:00.000000',00000000000002839166),('2024-05-13 15:40:00.000000',00000000000002849066),('2024-05-13 15:45:00.000000',00000000000002861866),('2024-05-13 15:50:00.000000',00000000000002869366),('2024-05-13 15:55:00.000000',00000000000002876032),('2024-05-13 16:00:00.000000',00000000000000000000),('2024-05-13 16:05:00.000000',00000000000000022700),('2024-05-13 16:10:00.000000',00000000000000022700),('2024-05-13 16:15:00.000000',00000000000000058000),('2024-05-13 16:20:00.000000',00000000000000080700),('2024-05-13 16:25:00.000000',00000000000000098100),('2024-05-13 16:30:00.000000',00000000000000104900),('2024-05-13 16:35:00.000000',00000000000000122500),('2024-05-13 16:40:00.000000',00000000000000136300),('2024-05-13 16:45:00.000000',00000000000000437700),('2024-05-13 16:50:00.000000',00000000000000453400),('2024-05-13 16:55:00.000000',00000000000000453400),('2024-05-13 17:00:00.000000',00000000000000493300),('2024-05-13 17:05:00.000000',00000000000000503200),('2024-05-13 17:10:00.000000',00000000000000553000),('2024-05-13 17:15:00.000000',00000000000000585400),('2024-05-13 17:20:00.000000',00000000000000603000),('2024-05-13 17:25:00.000000',00000000000000616700),('2024-05-13 17:30:00.000000',00000000000000648000),('2024-05-13 17:35:00.000000',00000000000000698866),('2024-05-13 17:40:00.000000',00000000000000697966),('2024-05-13 17:45:00.000000',00000000000000706766),('2024-05-13 17:50:00.000000',00000000000000720545),('2024-05-13 17:55:00.000000',00000000000000720545),('2024-05-13 18:00:00.000000',00000000000000734324),('2024-05-13 18:05:00.000000',00000000000000742224),('2024-05-13 18:10:00.000000',00000000000000781190),('2024-05-13 18:15:00.000000',00000000000000786090),('2024-05-13 18:20:00.000000',00000000000000795990),('2024-05-13 18:25:00.000000',00000000000000815790),('2024-05-13 18:30:00.000000',00000000000000825690),('2024-05-13 18:35:00.000000',00000000000000825690),('2024-05-13 18:40:00.000000',00000000000000835590),('2024-05-13 18:45:00.000000',00000000000000844490),('2024-05-13 18:50:00.000000',00000000000000853290),('2024-05-13 18:55:00.000000',00000000000000853290),('2024-05-13 19:00:00.000000',00000000000000853290),('2024-05-13 19:05:00.000000',00000000000000858190),('2024-05-13 19:10:00.000000',00000000000000858190),('2024-05-13 19:15:00.000000',00000000000000864090),('2024-05-13 19:20:00.000000',00000000000000875790),('2024-05-13 19:25:00.000000',00000000000000880690),('2024-05-13 19:30:00.000000',00000000000000880690),('2024-05-13 19:35:00.000000',00000000000000895490),('2024-05-13 19:40:00.000000',00000000000000895490),('2024-05-13 19:45:00.000000',00000000000000895490),('2024-05-13 19:50:00.000000',00000000000000895490),('2024-05-13 19:55:00.000000',00000000000000895490),('2024-05-13 20:00:00.000000',00000000000000895490),('2024-05-13 20:05:00.000000',00000000000000900690),('2024-05-13 20:10:00.000000',00000000000000908240),('2024-05-13 20:15:00.000000',00000000000000918346),('2024-05-13 20:20:00.000000',00000000000000920326),('2024-05-13 20:25:00.000000',00000000000000920326),('2024-05-13 20:30:00.000000',00000000000000932126),('2024-05-13 20:35:00.000000',00000000000000932126),('2024-05-13 20:40:00.000000',00000000000000932126),('2024-05-13 20:45:00.000000',00000000000000932126),('2024-05-13 20:50:00.000000',00000000000000932126),('2024-05-13 20:55:00.000000',00000000000000932126),('2024-05-13 21:00:00.000000',00000000000000932126),('2024-05-13 21:05:00.000000',00000000000000932126),('2024-05-13 21:10:00.000000',00000000000000932126),('2024-05-13 21:15:00.000000',00000000000000932126),('2024-05-13 21:20:00.000000',00000000000000940026),('2024-05-13 21:25:00.000000',00000000000000940026),('2024-05-13 21:30:00.000000',00000000000000940026),('2024-05-13 21:35:00.000000',00000000000000940026),('2024-05-13 21:40:00.000000',00000000000000940026),('2024-05-13 21:45:00.000000',00000000000000940026),('2024-05-13 21:50:00.000000',00000000000000949926),('2024-05-13 21:55:00.000000',00000000000000949926),('2024-05-13 22:00:00.000000',00000000000000949926),('2024-05-13 22:05:00.000000',00000000000000949926),('2024-05-13 22:10:00.000000',00000000000000949926),('2024-05-13 22:15:00.000000',00000000000000959826),('2024-05-13 22:20:00.000000',00000000000000959826),('2024-05-13 22:25:00.000000',00000000000000959826),('2024-05-13 22:30:00.000000',00000000000000959826),('2024-05-13 22:35:00.000000',00000000000000959826),('2024-05-13 22:40:00.000000',00000000000000964726),('2024-05-13 22:45:00.000000',00000000000000971626),('2024-05-13 22:50:00.000000',00000000000000971626),('2024-05-13 22:55:00.000000',00000000000000984426),('2024-05-13 23:00:00.000000',00000000000000984426),('2024-05-13 23:05:00.000000',00000000000000984426),('2024-05-13 23:10:00.000000',00000000000000984426),('2024-05-13 23:15:00.000000',00000000000000989326),('2024-05-13 23:20:00.000000',00000000000000998126),('2024-05-13 23:25:00.000000',00000000000000989326),('2024-05-13 23:30:00.000000',00000000000000994226),('2024-05-13 23:35:00.000000',00000000000000994226),('2024-05-13 23:40:00.000000',00000000000000994226),('2024-05-13 23:45:00.000000',00000000000000994226),('2024-05-13 23:50:00.000000',00000000000001003126),('2024-05-13 23:55:00.000000',00000000000001003126),('2024-05-14 00:00:00.000000',00000000000001003126),('2024-05-14 00:05:00.000000',00000000000001008926),('2024-05-14 00:10:00.000000',00000000000001053726),('2024-05-14 00:15:00.000000',00000000000001053726),('2024-05-14 00:20:00.000000',00000000000001053726),('2024-05-14 00:25:00.000000',00000000000001055726),('2024-05-14 00:30:00.000000',00000000000001060626),('2024-05-14 00:35:00.000000',00000000000001069526),('2024-05-14 00:40:00.000000',00000000000001069526),('2024-05-14 00:45:00.000000',00000000000001077426),('2024-05-14 00:50:00.000000',00000000000001077426),('2024-05-14 00:55:00.000000',00000000000001094226),('2024-05-14 01:00:00.000000',00000000000001094226),('2024-05-14 01:05:00.000000',00000000000001094226),('2024-05-14 01:10:00.000000',00000000000001103026),('2024-05-14 01:15:00.000000',00000000000001113925),('2024-05-14 01:20:00.000000',00000000000001113925),('2024-05-14 01:25:00.000000',00000000000001113925),('2024-05-14 01:30:00.000000',00000000000001117825),('2024-05-14 01:35:00.000000',00000000000001122625),('2024-05-14 01:40:00.000000',00000000000001122625),('2024-05-14 01:45:00.000000',00000000000001122625),('2024-05-14 01:50:00.000000',00000000000001122625),('2024-05-14 01:55:00.000000',00000000000001122625),('2024-05-14 02:00:00.000000',00000000000001122625),('2024-05-14 02:05:00.000000',00000000000001122625),('2024-05-14 02:10:00.000000',00000000000001122625),('2024-05-14 02:15:00.000000',00000000000001122625),('2024-05-14 02:20:00.000000',00000000000001144225),('2024-05-14 02:25:00.000000',00000000000001150891),('2024-05-14 02:30:00.000000',00000000000001150891),('2024-05-14 02:35:00.000000',00000000000001156791),('2024-05-14 02:40:00.000000',00000000000001156791),('2024-05-14 02:45:00.000000',00000000000001156791),('2024-05-14 02:50:00.000000',00000000000001169391),('2024-05-14 02:55:00.000000',00000000000001169391),('2024-05-14 03:00:00.000000',00000000000001169391),('2024-05-14 03:05:00.000000',00000000000001169391),('2024-05-14 03:10:00.000000',00000000000001169391),('2024-05-14 03:15:00.000000',00000000000001179291),('2024-05-14 03:20:00.000000',00000000000001169391),('2024-05-14 03:25:00.000000',00000000000001169391),('2024-05-14 03:30:00.000000',00000000000001182391),('2024-05-14 03:35:00.000000',00000000000001182391),('2024-05-14 03:40:00.000000',00000000000001192291),('2024-05-14 03:45:00.000000',00000000000001205091),('2024-05-14 03:50:00.000000',00000000000001205091),('2024-05-14 03:55:00.000000',00000000000001210991),('2024-05-14 04:00:00.000000',00000000000001211891),('2024-05-14 04:05:00.000000',00000000000001211891),('2024-05-14 04:10:00.000000',00000000000001217791),('2024-05-14 04:15:00.000000',00000000000001217791),('2024-05-14 04:20:00.000000',00000000000001232591),('2024-05-14 04:25:00.000000',00000000000001237491),('2024-05-14 04:30:00.000000',00000000000001237491),('2024-05-14 04:35:00.000000',00000000000001246391),('2024-05-14 04:40:00.000000',00000000000001251291),('2024-05-14 04:45:00.000000',00000000000001260191),('2024-05-14 04:50:00.000000',00000000000001269091),('2024-05-14 04:55:00.000000',00000000000001271991),('2024-05-14 05:00:00.000000',00000000000001281891),('2024-05-14 05:05:00.000000',00000000000001291791),('2024-05-14 05:10:00.000000',00000000000001300591),('2024-05-14 05:15:00.000000',00000000000001300591),('2024-05-14 05:20:00.000000',00000000000001300591),('2024-05-14 05:25:00.000000',00000000000001308491),('2024-05-14 05:30:00.000000',00000000000001313291),('2024-05-14 05:35:00.000000',00000000000001313291),('2024-05-14 05:40:00.000000',00000000000001323191),('2024-05-14 05:45:00.000000',00000000000001335891),('2024-05-14 05:50:00.000000',00000000000001352691),('2024-05-14 05:55:00.000000',00000000000001358491),('2024-05-14 06:00:00.000000',00000000000001370191),('2024-05-14 06:05:00.000000',00000000000001370191),('2024-05-14 06:10:00.000000',00000000000001375091),('2024-05-14 06:15:00.000000',00000000000001378991),('2024-05-14 06:20:00.000000',00000000000001397591),('2024-05-14 06:25:00.000000',00000000000001418191),('2024-05-14 06:30:00.000000',00000000000001421991),('2024-05-14 06:35:00.000000',00000000000001426891),('2024-05-14 06:40:00.000000',00000000000001444871),('2024-05-14 06:45:00.000000',00000000000001444871),('2024-05-14 06:50:00.000000',00000000000001454771),('2024-05-14 06:55:00.000000',00000000000001454771),('2024-05-14 07:00:00.000000',00000000000001464571),('2024-05-14 07:05:00.000000',00000000000001473350),('2024-05-14 07:10:00.000000',00000000000001502950),('2024-05-14 07:15:00.000000',00000000000001512850),('2024-05-14 07:20:00.000000',00000000000001522650),('2024-05-14 07:25:00.000000',00000000000001534350),('2024-05-14 07:30:00.000000',00000000000001534350),('2024-05-14 07:35:00.000000',00000000000001544150),('2024-05-14 07:40:00.000000',00000000000001604050),('2024-05-14 07:45:00.000000',00000000000001622629),('2024-05-14 07:50:00.000000',00000000000001651029),('2024-05-14 07:55:00.000000',00000000000001661109),('2024-05-14 08:00:00.000000',00000000000001666009),('2024-05-14 08:05:00.000000',00000000000001676809),('2024-05-14 08:10:00.000000',00000000000001681709),('2024-05-14 08:15:00.000000',00000000000001701109),('2024-05-14 08:20:00.000000',00000000000001701109),('2024-05-14 08:25:00.000000',00000000000001713909),('2024-05-14 08:30:00.000000',00000000000001713909),('2024-05-14 08:35:00.000000',00000000000001726608),('2024-05-14 08:40:00.000000',00000000000001733508),('2024-05-14 08:45:00.000000',00000000000001738408),('2024-05-14 08:50:00.000000',00000000000001738408),('2024-05-14 08:55:00.000000',00000000000001738408),('2024-05-14 09:00:00.000000',00000000000001738408),('2024-05-14 09:05:00.000000',00000000000001738408),('2024-05-14 09:10:00.000000',00000000000001738408),('2024-05-14 09:15:00.000000',00000000000001738408),('2024-05-14 09:20:00.000000',00000000000001741308),('2024-05-14 09:25:00.000000',00000000000001759108),('2024-05-14 09:30:00.000000',00000000000001759108),('2024-05-14 09:35:00.000000',00000000000001759108),('2024-05-14 09:40:00.000000',00000000000001759108),('2024-05-14 09:45:00.000000',00000000000001768908),('2024-05-14 09:50:00.000000',00000000000001778808),('2024-05-14 09:55:00.000000',00000000000001793608),('2024-05-14 10:00:00.000000',00000000000001798508),('2024-05-14 10:05:00.000000',00000000000001808408),('2024-05-14 10:10:00.000000',00000000000001808408),('2024-05-14 10:15:00.000000',00000000000001814208),('2024-05-14 10:20:00.000000',00000000000001814208),('2024-05-14 10:25:00.000000',00000000000001826008),('2024-05-14 10:30:00.000000',00000000000001837808),('2024-05-14 10:35:00.000000',00000000000001842808),('2024-05-14 10:40:00.000000',00000000000001847708),('2024-05-14 10:45:00.000000',00000000000001847708),('2024-05-14 10:50:00.000000',00000000000001847708),('2024-05-14 10:55:00.000000',00000000000001847708),('2024-05-14 11:00:00.000000',00000000000001852608),('2024-05-14 11:05:00.000000',00000000000001852608),('2024-05-14 11:10:00.000000',00000000000001859508),('2024-05-14 11:15:00.000000',00000000000001859508),('2024-05-14 11:20:00.000000',00000000000001867187),('2024-05-14 11:25:00.000000',00000000000001872087),('2024-05-14 11:30:00.000000',00000000000001883887),('2024-05-14 11:35:00.000000',00000000000001897687),('2024-05-14 11:40:00.000000',00000000000001897687),('2024-05-14 11:45:00.000000',00000000000001906487),('2024-05-14 11:50:00.000000',00000000000001911387),('2024-05-14 11:55:00.000000',00000000000001911387),('2024-05-14 12:00:00.000000',00000000000001931887),('2024-05-14 12:05:00.000000',00000000000001939787),('2024-05-14 12:10:00.000000',00000000000001939787),('2024-05-14 12:15:00.000000',00000000000001939787),('2024-05-14 12:20:00.000000',00000000000001960353),('2024-05-14 12:25:00.000000',00000000000001960353),('2024-05-14 12:30:00.000000',00000000000001990953),('2024-05-14 12:35:00.000000',00000000000001999753),('2024-05-14 12:40:00.000000',00000000000001999753),('2024-05-14 12:45:00.000000',00000000000002019453),('2024-05-14 12:50:00.000000',00000000000002042053),('2024-05-14 12:55:00.000000',00000000000002055753),('2024-05-14 13:00:00.000000',00000000000002064653),('2024-05-14 13:05:00.000000',00000000000002108453),('2024-05-14 13:10:00.000000',00000000000002123253),('2024-05-14 13:15:00.000000',00000000000002132053),('2024-05-14 13:20:00.000000',00000000000002132053),('2024-05-14 13:25:00.000000',00000000000002148753),('2024-05-14 13:30:00.000000',00000000000002209553),('2024-05-14 13:35:00.000000',00000000000002270053),('2024-05-14 13:40:00.000000',00000000000002284853),('2024-05-14 13:45:00.000000',00000000000002305453),('2024-05-14 13:50:00.000000',00000000000002315353),('2024-05-14 13:55:00.000000',00000000000002334153),('2024-05-14 14:00:00.000000',00000000000002341053),('2024-05-14 14:05:00.000000',00000000000002345853),('2024-05-14 14:10:00.000000',00000000000002370453),('2024-05-14 14:15:00.000000',00000000000002370453),('2024-05-14 14:20:00.000000',00000000000002370453),('2024-05-14 14:25:00.000000',00000000000002384253),('2024-05-14 14:30:00.000000',00000000000002389153),('2024-05-14 14:35:00.000000',00000000000002398053),('2024-05-14 14:40:00.000000',00000000000002399052),('2024-05-14 14:45:00.000000',00000000000002414851),('2024-05-14 14:50:00.000000',00000000000002420751),('2024-05-14 14:55:00.000000',00000000000002435551),('2024-05-14 15:00:00.000000',00000000000002485351),('2024-05-14 15:05:00.000000',00000000000002485351),('2024-05-14 15:10:00.000000',00000000000002500151),('2024-05-14 15:15:00.000000',00000000000002514851),('2024-05-14 15:20:00.000000',00000000000002518751),('2024-05-14 15:25:00.000000',00000000000002529641),('2024-05-14 15:30:00.000000',00000000000002538241),('2024-05-14 15:35:00.000000',00000000000002548141),('2024-05-14 15:40:00.000000',00000000000002576641),('2024-05-14 15:45:00.000000',00000000000002600241),('2024-05-14 15:50:00.000000',00000000000002625641),('2024-05-14 15:55:00.000000',00000000000002655241),('2024-05-14 16:00:00.000000',00000000000000000000),('2024-05-14 16:05:00.000000',00000000000000039900),('2024-05-14 16:10:00.000000',00000000000000039900),('2024-05-14 16:15:00.000000',00000000000000044800),('2024-05-14 16:20:00.000000',00000000000000077500),('2024-05-14 16:25:00.000000',00000000000000099300),('2024-05-14 16:30:00.000000',00000000000000109900),('2024-05-14 16:35:00.000000',00000000000000105420),('2024-05-14 16:40:00.000000',00000000000000111920),('2024-05-14 16:45:00.000000',00000000000000125820),('2024-05-14 16:50:00.000000',00000000000000130720),('2024-05-14 16:55:00.000000',00000000000000130720),('2024-05-14 17:00:00.000000',00000000000000154420),('2024-05-14 17:05:00.000000',00000000000000163320),('2024-05-14 17:10:00.000000',00000000000000191720),('2024-05-14 17:15:00.000000',00000000000000204320),('2024-05-14 17:20:00.000000',00000000000000217020),('2024-05-14 17:25:00.000000',00000000000000217020),('2024-05-14 17:30:00.000000',00000000000000228920),('2024-05-14 17:35:00.000000',00000000000000268820),('2024-05-14 17:40:00.000000',00000000000000289420),('2024-05-14 17:45:00.000000',00000000000000289420),('2024-05-14 17:50:00.000000',00000000000000295220),('2024-05-14 17:55:00.000000',00000000000000295220),('2024-05-14 18:00:00.000000',00000000000000310020),('2024-05-14 18:05:00.000000',00000000000000316486),('2024-05-14 18:10:00.000000',00000000000000317476),('2024-05-14 18:15:00.000000',00000000000000615176),('2024-05-14 18:20:00.000000',00000000000000640676),('2024-05-14 18:25:00.000000',00000000000000645276),('2024-05-14 18:30:00.000000',00000000000000651076),('2024-05-14 18:35:00.000000',00000000000000651076),('2024-05-14 18:40:00.000000',00000000000000651076),('2024-05-14 18:45:00.000000',00000000000000655776),('2024-05-14 18:50:00.000000',00000000000000660576),('2024-05-14 18:55:00.000000',00000000000000660576),('2024-05-14 19:00:00.000000',00000000000000660576),('2024-05-14 19:05:00.000000',00000000000000666476),('2024-05-14 19:10:00.000000',00000000000000675176),('2024-05-14 19:15:00.000000',00000000000000680076),('2024-05-14 19:20:00.000000',00000000000000680076),('2024-05-14 19:25:00.000000',00000000000000688876),('2024-05-14 19:30:00.000000',00000000000000689875),('2024-05-14 19:35:00.000000',00000000000000696775),('2024-05-14 19:40:00.000000',00000000000000701675),('2024-05-14 19:45:00.000000',00000000000000708275),('2024-05-14 19:50:00.000000',00000000000000708275),('2024-05-14 19:55:00.000000',00000000000000716202),('2024-05-14 20:00:00.000000',00000000000000716202),('2024-05-14 20:05:00.000000',00000000000000733002),('2024-05-14 20:10:00.000000',00000000000000733002),('2024-05-14 20:15:00.000000',00000000000000733002),('2024-05-14 20:20:00.000000',00000000000000733002),('2024-05-14 20:25:00.000000',00000000000000733002),('2024-05-14 20:30:00.000000',00000000000000733002),('2024-05-14 20:35:00.000000',00000000000000733002),('2024-05-14 20:40:00.000000',00000000000000733002),('2024-05-14 20:45:00.000000',00000000000000733002),('2024-05-14 20:50:00.000000',00000000000000733002),('2024-05-14 20:55:00.000000',00000000000000733002),('2024-05-14 21:00:00.000000',00000000000000738902),('2024-05-14 21:05:00.000000',00000000000000738902),('2024-05-14 21:10:00.000000',00000000000000738902),('2024-05-14 21:15:00.000000',00000000000000738902),('2024-05-14 21:20:00.000000',00000000000000738902),('2024-05-14 21:25:00.000000',00000000000000752022),('2024-05-14 21:30:00.000000',00000000000000758909),('2024-05-14 21:35:00.000000',00000000000000782075),('2024-05-14 21:40:00.000000',00000000000000782075),('2024-05-14 21:45:00.000000',00000000000000782075),('2024-05-14 21:50:00.000000',00000000000000782075),('2024-05-14 21:55:00.000000',00000000000000782075),('2024-05-14 22:00:00.000000',00000000000000782075),('2024-05-14 22:05:00.000000',00000000000000782075),('2024-05-14 22:10:00.000000',00000000000000782075),('2024-05-14 22:15:00.000000',00000000000000782075),('2024-05-14 22:20:00.000000',00000000000000782075),('2024-05-14 22:25:00.000000',00000000000000782075),('2024-05-14 22:30:00.000000',00000000000000782075),('2024-05-14 22:35:00.000000',00000000000000790875),('2024-05-14 22:40:00.000000',00000000000000790875),('2024-05-14 22:45:00.000000',00000000000000800775),('2024-05-14 22:50:00.000000',00000000000000800775),('2024-05-14 22:55:00.000000',00000000000000800775),('2024-05-14 23:00:00.000000',00000000000000805675),('2024-05-14 23:05:00.000000',00000000000000805675),('2024-05-14 23:10:00.000000',00000000000000805675),('2024-05-14 23:15:00.000000',00000000000000805675),('2024-05-14 23:20:00.000000',00000000000000805675),('2024-05-14 23:25:00.000000',00000000000000805675),('2024-05-14 23:30:00.000000',00000000000000805675),('2024-05-14 23:35:00.000000',00000000000000806195),('2024-05-14 23:40:00.000000',00000000000000806195),('2024-05-14 23:45:00.000000',00000000000000806195),('2024-05-14 23:50:00.000000',00000000000000806195),('2024-05-14 23:55:00.000000',00000000000000806195),('2024-05-15 00:00:00.000000',00000000000000806195),('2024-05-15 00:05:00.000000',00000000000000806195),('2024-05-15 00:10:00.000000',00000000000000806195),('2024-05-15 00:15:00.000000',00000000000000806195),('2024-05-15 00:20:00.000000',00000000000000806195),('2024-05-15 00:25:00.000000',00000000000000806195),('2024-05-15 00:30:00.000000',00000000000000806195),('2024-05-15 00:35:00.000000',00000000000000823995),('2024-05-15 00:40:00.000000',00000000000000823995),('2024-05-15 00:45:00.000000',00000000000000828895),('2024-05-15 00:50:00.000000',00000000000000828895),('2024-05-15 00:55:00.000000',00000000000000828895),('2024-05-15 01:00:00.000000',00000000000000828895),('2024-05-15 01:05:00.000000',00000000000000835795),('2024-05-15 01:10:00.000000',00000000000000840695),('2024-05-15 01:15:00.000000',00000000000000840695),('2024-05-15 01:20:00.000000',00000000000000840695),('2024-05-15 01:25:00.000000',00000000000000840695),('2024-05-15 01:30:00.000000',00000000000000840695),('2024-05-15 01:35:00.000000',00000000000000840695),('2024-05-15 01:40:00.000000',00000000000000840695),('2024-05-15 01:45:00.000000',00000000000000840695),('2024-05-15 01:50:00.000000',00000000000000840695),('2024-05-15 01:55:00.000000',00000000000000849595),('2024-05-15 02:00:00.000000',00000000000000861295),('2024-05-15 02:05:00.000000',00000000000000861295),('2024-05-15 02:10:00.000000',00000000000000861295),('2024-05-15 02:15:00.000000',00000000000000868195),('2024-05-15 02:20:00.000000',00000000000000868195),('2024-05-15 02:25:00.000000',00000000000000873095),('2024-05-15 02:30:00.000000',00000000000000873095),('2024-05-15 02:35:00.000000',00000000000000877995),('2024-05-15 02:40:00.000000',00000000000000877995),('2024-05-15 02:45:00.000000',00000000000000883895),('2024-05-15 02:50:00.000000',00000000000000883895),('2024-05-15 02:55:00.000000',00000000000000888795),('2024-05-15 03:00:00.000000',00000000000000897595),('2024-05-15 03:05:00.000000',00000000000000897595),('2024-05-15 03:10:00.000000',00000000000000917295),('2024-05-15 03:15:00.000000',00000000000000912395),('2024-05-15 03:20:00.000000',00000000000000913395),('2024-05-15 03:25:00.000000',00000000000000926195),('2024-05-15 03:30:00.000000',00000000000000944995),('2024-05-15 03:35:00.000000',00000000000000946995),('2024-05-15 03:40:00.000000',00000000000000948995),('2024-05-15 03:45:00.000000',00000000000000962695),('2024-05-15 03:50:00.000000',00000000000000962695),('2024-05-15 03:55:00.000000',00000000000000962695),('2024-05-15 04:00:00.000000',00000000000000962695),('2024-05-15 04:05:00.000000',00000000000000962695),('2024-05-15 04:10:00.000000',00000000000000962695),('2024-05-15 04:15:00.000000',00000000000000962695),('2024-05-15 04:20:00.000000',00000000000000976495),('2024-05-15 04:25:00.000000',00000000000000981395),('2024-05-15 04:30:00.000000',00000000000000987195),('2024-05-15 04:35:00.000000',00000000000000989184),('2024-05-15 04:40:00.000000',00000000000000989184),('2024-05-15 04:45:00.000000',00000000000000989184),('2024-05-15 04:50:00.000000',00000000000000989184),('2024-05-15 04:55:00.000000',00000000000000989184),('2024-05-15 05:00:00.000000',00000000000000993274),('2024-05-15 05:05:00.000000',00000000000001001174),('2024-05-15 05:10:00.000000',00000000000001001174),('2024-05-15 05:15:00.000000',00000000000001001694),('2024-05-15 05:20:00.000000',00000000000001025394),('2024-05-15 05:25:00.000000',00000000000001037194),('2024-05-15 05:30:00.000000',00000000000001042094),('2024-05-15 05:35:00.000000',00000000000001042094),('2024-05-15 05:40:00.000000',00000000000001076794),('2024-05-15 05:45:00.000000',00000000000001090594),('2024-05-15 05:50:00.000000',00000000000001120394),('2024-05-15 05:55:00.000000',00000000000001128294),('2024-05-15 06:00:00.000000',00000000000001132173),('2024-05-15 06:05:00.000000',00000000000001144973),('2024-05-15 06:10:00.000000',00000000000001180473),('2024-05-15 06:15:00.000000',00000000000001190793),('2024-05-15 06:20:00.000000',00000000000001190793),('2024-05-15 06:25:00.000000',00000000000001195693),('2024-05-15 06:30:00.000000',00000000000001195693),('2024-05-15 06:35:00.000000',00000000000001202593),('2024-05-15 06:40:00.000000',00000000000001297193),('2024-05-15 06:45:00.000000',00000000000001313893),('2024-05-15 06:50:00.000000',00000000000001313893),('2024-05-15 06:55:00.000000',00000000000001318893),('2024-05-15 07:00:00.000000',00000000000001331693),('2024-05-15 07:05:00.000000',00000000000001343773),('2024-05-15 07:10:00.000000',00000000000001348673),('2024-05-15 07:15:00.000000',00000000000001356573),('2024-05-15 07:20:00.000000',00000000000001394773),('2024-05-15 07:25:00.000000',00000000000001424893),('2024-05-15 07:30:00.000000',00000000000001450293),('2024-05-15 07:35:00.000000',00000000000001455193),('2024-05-15 07:40:00.000000',00000000000001455193),('2024-05-15 07:45:00.000000',00000000000001455193),('2024-05-15 07:50:00.000000',00000000000001467993),('2024-05-15 07:55:00.000000',00000000000001467993),('2024-05-15 08:00:00.000000',00000000000001472893),('2024-05-15 08:05:00.000000',00000000000001472893),('2024-05-15 08:10:00.000000',00000000000001472893),('2024-05-15 08:15:00.000000',00000000000001481793),('2024-05-15 08:20:00.000000',00000000000001481793),('2024-05-15 08:25:00.000000',00000000000001498493),('2024-05-15 08:30:00.000000',00000000000001489693),('2024-05-15 08:35:00.000000',00000000000001489693),('2024-05-15 08:40:00.000000',00000000000001491293),('2024-05-15 08:45:00.000000',00000000000001496193),('2024-05-15 08:50:00.000000',00000000000001496193),('2024-05-15 08:55:00.000000',00000000000001501093),('2024-05-15 09:00:00.000000',00000000000001526493),('2024-05-15 09:05:00.000000',00000000000001526493),('2024-05-15 09:10:00.000000',00000000000001711973),('2024-05-15 09:15:00.000000',00000000000001772473),('2024-05-15 09:20:00.000000',00000000000001789073),('2024-05-15 09:25:00.000000',00000000000001786073),('2024-05-15 09:30:00.000000',00000000000001803873),('2024-05-15 09:35:00.000000',00000000000001813773),('2024-05-15 09:40:00.000000',00000000000001823673),('2024-05-15 09:45:00.000000',00000000000001823573),('2024-05-15 09:50:00.000000',00000000000001827373),('2024-05-15 09:55:00.000000',00000000000001848163),('2024-05-15 10:00:00.000000',00000000000001848163),('2024-05-15 10:05:00.000000',00000000000001856063),('2024-05-15 10:10:00.000000',00000000000001873663),('2024-05-15 10:15:00.000000',00000000000001930563),('2024-05-15 10:20:00.000000',00000000000001949063),('2024-05-15 10:25:00.000000',00000000000001957863),('2024-05-15 10:30:00.000000',00000000000001957863),('2024-05-15 10:35:00.000000',00000000000001976663),('2024-05-15 10:40:00.000000',00000000000001976663),('2024-05-15 10:45:00.000000',00000000000001985642),('2024-05-15 10:50:00.000000',00000000000001985642),('2024-05-15 10:55:00.000000',00000000000001989542),('2024-05-15 11:00:00.000000',00000000000001989542),('2024-05-15 11:05:00.000000',00000000000001994442),('2024-05-15 11:10:00.000000',00000000000001994442),('2024-05-15 11:15:00.000000',00000000000001994442),('2024-05-15 11:20:00.000000',00000000000002008242),('2024-05-15 11:25:00.000000',00000000000002008242),('2024-05-15 11:30:00.000000',00000000000002009042),('2024-05-15 11:35:00.000000',00000000000002009042),('2024-05-15 11:40:00.000000',00000000000002028742),('2024-05-15 11:45:00.000000',00000000000002028742),('2024-05-15 11:50:00.000000',00000000000002040542),('2024-05-15 11:55:00.000000',00000000000002040542),('2024-05-15 12:00:00.000000',00000000000002040542),('2024-05-15 12:05:00.000000',00000000000002040542),('2024-05-15 12:10:00.000000',00000000000002040542),('2024-05-15 12:15:00.000000',00000000000002045442),('2024-05-15 12:20:00.000000',00000000000002055221),('2024-05-15 12:25:00.000000',00000000000002055221),('2024-05-15 12:30:00.000000',00000000000002055221),('2024-05-15 12:35:00.000000',00000000000002065121),('2024-05-15 12:40:00.000000',00000000000002070021),('2024-05-15 12:45:00.000000',00000000000002117821),('2024-05-15 12:50:00.000000',00000000000002122621),('2024-05-15 12:55:00.000000',00000000000002127521),('2024-05-15 13:00:00.000000',00000000000002127521),('2024-05-15 13:05:00.000000',00000000000002134421),('2024-05-15 13:10:00.000000',00000000000002141321),('2024-05-15 13:15:00.000000',00000000000002141321),('2024-05-15 13:20:00.000000',00000000000002141321),('2024-05-15 13:25:00.000000',00000000000002344221),('2024-05-15 13:30:00.000000',00000000000002344221),('2024-05-15 13:35:00.000000',00000000000002349121),('2024-05-15 13:40:00.000000',00000000000002349121),('2024-05-15 13:45:00.000000',00000000000002354021),('2024-05-15 13:50:00.000000',00000000000002354021),('2024-05-15 13:55:00.000000',00000000000002354021),('2024-05-15 14:00:00.000000',00000000000002387401),('2024-05-15 14:05:00.000000',00000000000002402301),('2024-05-15 14:10:00.000000',00000000000002434701),('2024-05-15 14:15:00.000000',00000000000002460401),('2024-05-15 14:20:00.000000',00000000000002486001),('2024-05-15 14:25:00.000000',00000000000002511801),('2024-05-15 14:30:00.000000',00000000000002564501),('2024-05-15 14:35:00.000000',00000000000002633801),('2024-05-15 14:40:00.000000',00000000000002651301),('2024-05-15 14:45:00.000000',00000000000002683601),('2024-05-15 14:50:00.000000',00000000000002721001),('2024-05-15 14:55:00.000000',00000000000002744269),('2024-05-15 15:00:00.000000',00000000000002771657),('2024-05-15 15:05:00.000000',00000000000002812857),('2024-05-15 15:10:00.000000',00000000000002846136),('2024-05-15 15:15:00.000000',00000000000002852036),('2024-05-15 15:20:00.000000',00000000000002859936),('2024-05-15 15:25:00.000000',00000000000002885336),('2024-05-15 15:30:00.000000',00000000000002906036),('2024-05-15 15:35:00.000000',00000000000002935236),('2024-05-15 15:40:00.000000',00000000000003003936),('2024-05-15 15:45:00.000000',00000000000003117316),('2024-05-15 15:50:00.000000',00000000000003115236),('2024-05-15 15:55:00.000000',00000000000003144636),('2024-05-15 16:00:00.000000',00000000000000000000),('2024-05-15 16:05:00.000000',00000000000000085300),('2024-05-15 16:10:00.000000',00000000000000105858),('2024-05-15 16:15:00.000000',00000000000000120558),('2024-05-15 16:20:00.000000',00000000000000174858),('2024-05-15 16:25:00.000000',00000000000000192758),('2024-05-15 16:30:00.000000',00000000000000192758),('2024-05-15 16:35:00.000000',00000000000000229558),('2024-05-15 16:40:00.000000',00000000000000290158),('2024-05-15 16:45:00.000000',00000000000000319558),('2024-05-15 16:50:00.000000',00000000000000403758),('2024-05-15 16:55:00.000000',00000000000000475337),('2024-05-15 17:00:00.000000',00000000000000536737),('2024-05-15 17:05:00.000000',00000000000000567337),('2024-05-15 17:10:00.000000',00000000000000592937),('2024-05-15 17:15:00.000000',00000000000000605737),('2024-05-15 17:20:00.000000',00000000000000627316),('2024-05-15 17:25:00.000000',00000000000000651916),('2024-05-15 17:30:00.000000',00000000000000659616),('2024-05-15 17:35:00.000000',00000000000000659616),('2024-05-15 17:40:00.000000',00000000000000664716),('2024-05-15 17:45:00.000000',00000000000000669616),('2024-05-15 17:50:00.000000',00000000000000684116),('2024-05-15 17:55:00.000000',00000000000000695916),('2024-05-15 18:00:00.000000',00000000000000695916),('2024-05-15 18:05:00.000000',00000000000000701016),('2024-05-15 18:10:00.000000',00000000000000701016),('2024-05-15 18:15:00.000000',00000000000000701016),('2024-05-15 18:20:00.000000',00000000000000708916),('2024-05-15 18:25:00.000000',00000000000000718616),('2024-05-15 18:30:00.000000',00000000000000734274),('2024-05-15 18:35:00.000000',00000000000000782874),('2024-05-15 18:40:00.000000',00000000000000832574),('2024-05-15 18:45:00.000000',00000000000000832574),('2024-05-15 18:50:00.000000',00000000000000848274),('2024-05-15 18:55:00.000000',00000000000000864074),('2024-05-15 19:00:00.000000',00000000000000864074),('2024-05-15 19:05:00.000000',00000000000000864074),('2024-05-15 19:10:00.000000',00000000000000871974),('2024-05-15 19:15:00.000000',00000000000000871974),('2024-05-15 19:20:00.000000',00000000000000871974),('2024-05-15 19:25:00.000000',00000000000000889474),('2024-05-15 19:30:00.000000',00000000000000889474),('2024-05-15 19:35:00.000000',00000000000000889474),('2024-05-15 19:40:00.000000',00000000000000905174),('2024-05-15 19:45:00.000000',00000000000000905174),('2024-05-15 19:50:00.000000',00000000000000905174),('2024-05-15 19:55:00.000000',00000000000000921874),('2024-05-15 20:00:00.000000',00000000000000921874),('2024-05-15 20:05:00.000000',00000000000000921874),('2024-05-15 20:10:00.000000',00000000000000921874),('2024-05-15 20:15:00.000000',00000000000000921874),('2024-05-15 20:20:00.000000',00000000000000921874),('2024-05-15 20:25:00.000000',00000000000000921874),('2024-05-15 20:30:00.000000',00000000000000921874),('2024-05-15 20:35:00.000000',00000000000000921874),('2024-05-15 20:40:00.000000',00000000000000921874),('2024-05-15 20:45:00.000000',00000000000000921874),('2024-05-15 20:50:00.000000',00000000000000921874),('2024-05-15 20:55:00.000000',00000000000000921874),('2024-05-15 21:00:00.000000',00000000000000926774),('2024-05-15 21:05:00.000000',00000000000000926774),('2024-05-15 21:10:00.000000',00000000000000931674),('2024-05-15 21:15:00.000000',00000000000000931674),('2024-05-15 21:20:00.000000',00000000000000945374),('2024-05-15 21:25:00.000000',00000000000000953274),('2024-05-15 21:30:00.000000',00000000000000953274),('2024-05-15 21:35:00.000000',00000000000000958174),('2024-05-15 21:40:00.000000',00000000000000976874),('2024-05-15 21:45:00.000000',00000000000000981774),('2024-05-15 21:50:00.000000',00000000000001024474),('2024-05-15 21:55:00.000000',00000000000001024474),('2024-05-15 22:00:00.000000',00000000000001032374),('2024-05-15 22:05:00.000000',00000000000001032374),('2024-05-15 22:10:00.000000',00000000000001043174),('2024-05-15 22:15:00.000000',00000000000001054434),('2024-05-15 22:20:00.000000',00000000000001054434),('2024-05-15 22:25:00.000000',00000000000001054434),('2024-05-15 22:30:00.000000',00000000000001065134),('2024-05-15 22:35:00.000000',00000000000001065134),('2024-05-15 22:40:00.000000',00000000000001065134),('2024-05-15 22:45:00.000000',00000000000001065134),('2024-05-15 22:50:00.000000',00000000000001074934),('2024-05-15 22:55:00.000000',00000000000001079834),('2024-05-15 23:00:00.000000',00000000000001079834),('2024-05-15 23:05:00.000000',00000000000001079834),('2024-05-15 23:10:00.000000',00000000000001137434),('2024-05-15 23:15:00.000000',00000000000001146134),('2024-05-15 23:20:00.000000',00000000000001160834),('2024-05-15 23:25:00.000000',00000000000001164734),('2024-05-15 23:30:00.000000',00000000000001164734),('2024-05-15 23:35:00.000000',00000000000001197534),('2024-05-15 23:40:00.000000',00000000000001200434),('2024-05-15 23:45:00.000000',00000000000001244134),('2024-05-15 23:50:00.000000',00000000000001251034),('2024-05-15 23:55:00.000000',00000000000001254834),('2024-05-16 00:00:00.000000',00000000000001254834),('2024-05-16 00:05:00.000000',00000000000001254834),('2024-05-16 00:10:00.000000',00000000000001254834),('2024-05-16 00:15:00.000000',00000000000001262734),('2024-05-16 00:20:00.000000',00000000000001262734),('2024-05-16 00:25:00.000000',00000000000001276434),('2024-05-16 00:30:00.000000',00000000000001276434),('2024-05-16 00:35:00.000000',00000000000001276434),('2024-05-16 00:40:00.000000',00000000000001276434),('2024-05-16 00:45:00.000000',00000000000001276434),('2024-05-16 00:50:00.000000',00000000000001276434),('2024-05-16 00:55:00.000000',00000000000001281334),('2024-05-16 01:00:00.000000',00000000000001293113),('2024-05-16 01:05:00.000000',00000000000001293113),('2024-05-16 01:10:00.000000',00000000000001293113),('2024-05-16 01:15:00.000000',00000000000001297013),('2024-05-16 01:20:00.000000',00000000000001297013),('2024-05-16 01:25:00.000000',00000000000001301913),('2024-05-16 01:30:00.000000',00000000000001301913),('2024-05-16 01:35:00.000000',00000000000001307013),('2024-05-16 01:40:00.000000',00000000000001307013),('2024-05-16 01:45:00.000000',00000000000001307013),('2024-05-16 01:50:00.000000',00000000000001307013),('2024-05-16 01:55:00.000000',00000000000001307013),('2024-05-16 02:00:00.000000',00000000000001307013),('2024-05-16 02:05:00.000000',00000000000001307013),('2024-05-16 02:10:00.000000',00000000000001311913),('2024-05-16 02:15:00.000000',00000000000001311913),('2024-05-16 02:20:00.000000',00000000000001311913),('2024-05-16 02:25:00.000000',00000000000001311913),('2024-05-16 02:30:00.000000',00000000000001311913),('2024-05-16 02:35:00.000000',00000000000001316813),('2024-05-16 02:40:00.000000',00000000000001319713),('2024-05-16 02:45:00.000000',00000000000001347613),('2024-05-16 02:50:00.000000',00000000000001347613),('2024-05-16 02:55:00.000000',00000000000001347613),('2024-05-16 03:00:00.000000',00000000000001347613),('2024-05-16 03:05:00.000000',00000000000001352513),('2024-05-16 03:10:00.000000',00000000000001352513),('2024-05-16 03:15:00.000000',00000000000001352513),('2024-05-16 03:20:00.000000',00000000000001352513),('2024-05-16 03:25:00.000000',00000000000001352513),('2024-05-16 03:30:00.000000',00000000000001356313),('2024-05-16 03:35:00.000000',00000000000001374113),('2024-05-16 03:40:00.000000',00000000000001374113),('2024-05-16 03:45:00.000000',00000000000001382913),('2024-05-16 03:50:00.000000',00000000000001382913),('2024-05-16 03:55:00.000000',00000000000001382913),('2024-05-16 04:00:00.000000',00000000000001379113),('2024-05-16 04:05:00.000000',00000000000001379113),('2024-05-16 04:10:00.000000',00000000000001379113),('2024-05-16 04:15:00.000000',00000000000001379113),('2024-05-16 04:20:00.000000',00000000000001379113),('2024-05-16 04:25:00.000000',00000000000001384013),('2024-05-16 04:30:00.000000',00000000000001384013),('2024-05-16 04:35:00.000000',00000000000001394613),('2024-05-16 04:40:00.000000',00000000000001405413),('2024-05-16 04:45:00.000000',00000000000001422013),('2024-05-16 04:50:00.000000',00000000000001413213),('2024-05-16 04:55:00.000000',00000000000001436692),('2024-05-16 05:00:00.000000',00000000000001436692),('2024-05-16 05:05:00.000000',00000000000001441592),('2024-05-16 05:10:00.000000',00000000000001445471),('2024-05-16 05:15:00.000000',00000000000001460071),('2024-05-16 05:20:00.000000',00000000000001474771),('2024-05-16 05:25:00.000000',00000000000001471771),('2024-05-16 05:30:00.000000',00000000000001471771),('2024-05-16 05:35:00.000000',00000000000001481671),('2024-05-16 05:40:00.000000',00000000000001495471),('2024-05-16 05:45:00.000000',00000000000001528471),('2024-05-16 05:50:00.000000',00000000000001562771),('2024-05-16 05:55:00.000000',00000000000001573471),('2024-05-16 06:00:00.000000',00000000000001582370),('2024-05-16 06:05:00.000000',00000000000001587470),('2024-05-16 06:10:00.000000',00000000000001587470),('2024-05-16 06:15:00.000000',00000000000001587470),('2024-05-16 06:20:00.000000',00000000000001587470),('2024-05-16 06:25:00.000000',00000000000001607260),('2024-05-16 06:30:00.000000',00000000000001607260),('2024-05-16 06:35:00.000000',00000000000001612160),('2024-05-16 06:40:00.000000',00000000000001626860),('2024-05-16 06:45:00.000000',00000000000001639660),('2024-05-16 06:50:00.000000',00000000000001649460),('2024-05-16 06:55:00.000000',00000000000001658360),('2024-05-16 07:00:00.000000',00000000000001674060),('2024-05-16 07:05:00.000000',00000000000001681860),('2024-05-16 07:10:00.000000',00000000000001690760),('2024-05-16 07:15:00.000000',00000000000001695660),('2024-05-16 07:20:00.000000',00000000000001695660),('2024-05-16 07:25:00.000000',00000000000001695660),('2024-05-16 07:30:00.000000',00000000000001695660),('2024-05-16 07:35:00.000000',00000000000001701160),('2024-05-16 07:40:00.000000',00000000000001753760),('2024-05-16 07:45:00.000000',00000000000001753760),('2024-05-16 07:50:00.000000',00000000000001753760),('2024-05-16 07:55:00.000000',00000000000001753760),('2024-05-16 08:00:00.000000',00000000000001776260),('2024-05-16 08:05:00.000000',00000000000001786160),('2024-05-16 08:10:00.000000',00000000000001796580),('2024-05-16 08:15:00.000000',00000000000001796580),('2024-05-16 08:20:00.000000',00000000000001796580),('2024-05-16 08:25:00.000000',00000000000001801480),('2024-05-16 08:30:00.000000',00000000000001801580),('2024-05-16 08:35:00.000000',00000000000001801580),('2024-05-16 08:40:00.000000',00000000000001801580),('2024-05-16 08:45:00.000000',00000000000001811380),('2024-05-16 08:50:00.000000',00000000000001821280),('2024-05-16 08:55:00.000000',00000000000001829180),('2024-05-16 09:00:00.000000',00000000000001829180),('2024-05-16 09:05:00.000000',00000000000001829180),('2024-05-16 09:10:00.000000',00000000000001829180),('2024-05-16 09:15:00.000000',00000000000001833179),('2024-05-16 09:20:00.000000',00000000000001833179),('2024-05-16 09:25:00.000000',00000000000001833179),('2024-05-16 09:30:00.000000',00000000000001842069),('2024-05-16 09:35:00.000000',00000000000001849969),('2024-05-16 09:40:00.000000',00000000000001849969),('2024-05-16 09:45:00.000000',00000000000001859769),('2024-05-16 09:50:00.000000',00000000000001877369),('2024-05-16 09:55:00.000000',00000000000001891169),('2024-05-16 10:00:00.000000',00000000000001903969),('2024-05-16 10:05:00.000000',00000000000001903969),('2024-05-16 10:10:00.000000',00000000000001903969),('2024-05-16 10:15:00.000000',00000000000001908869),('2024-05-16 10:20:00.000000',00000000000001913769),('2024-05-16 10:25:00.000000',00000000000001921669),('2024-05-16 10:30:00.000000',00000000000001931569),('2024-05-16 10:35:00.000000',00000000000001936469),('2024-05-16 10:40:00.000000',00000000000001936469),('2024-05-16 10:45:00.000000',00000000000001936469),('2024-05-16 10:50:00.000000',00000000000001941269),('2024-05-16 10:55:00.000000',00000000000001949069),('2024-05-16 11:00:00.000000',00000000000001965569),('2024-05-16 11:05:00.000000',00000000000001965569),('2024-05-16 11:10:00.000000',00000000000001965569),('2024-05-16 11:15:00.000000',00000000000001965569),('2024-05-16 11:20:00.000000',00000000000001971569),('2024-05-16 11:25:00.000000',00000000000001971569),('2024-05-16 11:30:00.000000',00000000000001971669),('2024-05-16 11:35:00.000000',00000000000001979569),('2024-05-16 11:40:00.000000',00000000000001998269),('2024-05-16 11:45:00.000000',00000000000002011069),('2024-05-16 11:50:00.000000',00000000000002028669),('2024-05-16 11:55:00.000000',00000000000002038569),('2024-05-16 12:00:00.000000',00000000000002060969),('2024-05-16 12:05:00.000000',00000000000002068869),('2024-05-16 12:10:00.000000',00000000000002072669),('2024-05-16 12:15:00.000000',00000000000002077469),('2024-05-16 12:20:00.000000',00000000000002096169),('2024-05-16 12:25:00.000000',00000000000002096169),('2024-05-16 12:30:00.000000',00000000000002096169),('2024-05-16 12:35:00.000000',00000000000002096169),('2024-05-16 12:40:00.000000',00000000000002096169),('2024-05-16 12:45:00.000000',00000000000002096169),('2024-05-16 12:50:00.000000',00000000000002096169),('2024-05-16 12:55:00.000000',00000000000002096169),('2024-05-16 13:00:00.000000',00000000000002105148),('2024-05-16 13:05:00.000000',00000000000002117548),('2024-05-16 13:10:00.000000',00000000000002117548),('2024-05-16 13:15:00.000000',00000000000002117548),('2024-05-16 13:20:00.000000',00000000000002135348),('2024-05-16 13:25:00.000000',00000000000002142148),('2024-05-16 13:30:00.000000',00000000000002159948),('2024-05-16 13:35:00.000000',00000000000002164848),('2024-05-16 13:40:00.000000',00000000000002179648),('2024-05-16 13:45:00.000000',00000000000002179648),('2024-05-16 13:50:00.000000',00000000000002179648),('2024-05-16 13:55:00.000000',00000000000002179648),('2024-05-16 14:00:00.000000',00000000000002186548),('2024-05-16 14:05:00.000000',00000000000002186548),('2024-05-16 14:10:00.000000',00000000000002191448),('2024-05-16 14:15:00.000000',00000000000002197348),('2024-05-16 14:20:00.000000',00000000000002197348),('2024-05-16 14:25:00.000000',00000000000002203148),('2024-05-16 14:30:00.000000',00000000000002211048),('2024-05-16 14:35:00.000000',00000000000002236548),('2024-05-16 14:40:00.000000',00000000000002246548),('2024-05-16 14:45:00.000000',00000000000002253148),('2024-05-16 14:50:00.000000',00000000000002255448),('2024-05-16 14:55:00.000000',00000000000002263348),('2024-05-16 15:00:00.000000',00000000000002282948),('2024-05-16 15:05:00.000000',00000000000002315548),('2024-05-16 15:10:00.000000',00000000000002326348),('2024-05-16 15:15:00.000000',00000000000002334648),('2024-05-16 15:20:00.000000',00000000000002343748),('2024-05-16 15:25:00.000000',00000000000002362448),('2024-05-16 15:30:00.000000',00000000000002372468),('2024-05-16 15:35:00.000000',00000000000002380147),('2024-05-16 15:40:00.000000',00000000000002374247),('2024-05-16 15:45:00.000000',00000000000002395947),('2024-05-16 15:50:00.000000',00000000000002426347),('2024-05-16 15:55:00.000000',00000000000002449946),('2024-05-16 16:00:00.000000',00000000000000000000),('2024-05-16 16:05:00.000000',00000000000000024800),('2024-05-16 16:10:00.000000',00000000000000069500),('2024-05-16 16:15:00.000000',00000000000000090380),('2024-05-16 16:20:00.000000',00000000000000124380),('2024-05-16 16:25:00.000000',00000000000000136159),('2024-05-16 16:30:00.000000',00000000000000144059),('2024-05-16 16:35:00.000000',00000000000000165859),('2024-05-16 16:40:00.000000',00000000000000166849),('2024-05-16 16:45:00.000000',00000000000000202248),('2024-05-16 16:50:00.000000',00000000000000218014),('2024-05-16 16:55:00.000000',00000000000000210114),('2024-05-16 17:00:00.000000',00000000000000213914),('2024-05-16 17:05:00.000000',00000000000000235514),('2024-05-16 17:10:00.000000',00000000000000240414),('2024-05-16 17:15:00.000000',00000000000000246314),('2024-05-16 17:20:00.000000',00000000000000246314),('2024-05-16 17:25:00.000000',00000000000000251734),('2024-05-16 17:30:00.000000',00000000000000266434),('2024-05-16 17:35:00.000000',00000000000000325134),('2024-05-16 17:40:00.000000',00000000000000316234),('2024-05-16 17:45:00.000000',00000000000000324134),('2024-05-16 17:50:00.000000',00000000000000344734),('2024-05-16 17:55:00.000000',00000000000000344734),('2024-05-16 18:00:00.000000',00000000000000344734),('2024-05-16 18:05:00.000000',00000000000000351634),('2024-05-16 18:10:00.000000',00000000000000370234),('2024-05-16 18:15:00.000000',00000000000000378134),('2024-05-16 18:20:00.000000',00000000000000388034),('2024-05-16 18:25:00.000000',00000000000000388034),('2024-05-16 18:30:00.000000',00000000000000388034),('2024-05-16 18:35:00.000000',00000000000000396934),('2024-05-16 18:40:00.000000',00000000000000403834),('2024-05-16 18:45:00.000000',00000000000000409254),('2024-05-16 18:50:00.000000',00000000000000416154),('2024-05-16 18:55:00.000000',00000000000000416154),('2024-05-16 19:00:00.000000',00000000000000421054),('2024-05-16 19:05:00.000000',00000000000000421054),('2024-05-16 19:10:00.000000',00000000000000429854),('2024-05-16 19:15:00.000000',00000000000000431373),('2024-05-16 19:20:00.000000',00000000000000454073),('2024-05-16 19:25:00.000000',00000000000000454073),('2024-05-16 19:30:00.000000',00000000000000454073),('2024-05-16 19:35:00.000000',00000000000000454073),('2024-05-16 19:40:00.000000',00000000000000454073),('2024-05-16 19:45:00.000000',00000000000000454073),('2024-05-16 19:50:00.000000',00000000000000454073),('2024-05-16 19:55:00.000000',00000000000000454073),('2024-05-16 20:00:00.000000',00000000000000454073),('2024-05-16 20:05:00.000000',00000000000000454073),('2024-05-16 20:10:00.000000',00000000000000454073),('2024-05-16 20:15:00.000000',00000000000000454073),('2024-05-16 20:20:00.000000',00000000000000462973),('2024-05-16 20:25:00.000000',00000000000000462973),('2024-05-16 20:30:00.000000',00000000000000462973),('2024-05-16 20:35:00.000000',00000000000000462973),('2024-05-16 20:40:00.000000',00000000000000462973),('2024-05-16 20:45:00.000000',00000000000000462973),('2024-05-16 20:50:00.000000',00000000000000462973),('2024-05-16 20:55:00.000000',00000000000000462973),('2024-05-16 21:00:00.000000',00000000000000462973),('2024-05-16 21:05:00.000000',00000000000000470873),('2024-05-16 21:10:00.000000',00000000000000470873),('2024-05-16 21:15:00.000000',00000000000000470873),('2024-05-16 21:20:00.000000',00000000000000470873),('2024-05-16 21:25:00.000000',00000000000000470873),('2024-05-16 21:30:00.000000',00000000000000470873),('2024-05-16 21:35:00.000000',00000000000000470873),('2024-05-16 21:40:00.000000',00000000000000477773),('2024-05-16 21:45:00.000000',00000000000000477773),('2024-05-16 21:50:00.000000',00000000000000477773),('2024-05-16 21:55:00.000000',00000000000000485673),('2024-05-16 22:00:00.000000',00000000000000485673),('2024-05-16 22:05:00.000000',00000000000000495573),('2024-05-16 22:10:00.000000',00000000000000525473),('2024-05-16 22:15:00.000000',00000000000000525473),('2024-05-16 22:20:00.000000',00000000000000525473),('2024-05-16 22:25:00.000000',00000000000000525473),('2024-05-16 22:30:00.000000',00000000000000525473),('2024-05-16 22:35:00.000000',00000000000000525473),('2024-05-16 22:40:00.000000',00000000000000525473),('2024-05-16 22:45:00.000000',00000000000000543073),('2024-05-16 22:50:00.000000',00000000000000547973),('2024-05-16 22:55:00.000000',00000000000000550853),('2024-05-16 23:00:00.000000',00000000000000558753),('2024-05-16 23:05:00.000000',00000000000000568653),('2024-05-16 23:10:00.000000',00000000000000576453),('2024-05-16 23:15:00.000000',00000000000000585253),('2024-05-16 23:20:00.000000',00000000000000585253),('2024-05-16 23:25:00.000000',00000000000000585253),('2024-05-16 23:30:00.000000',00000000000000585253),('2024-05-16 23:35:00.000000',00000000000000585253),('2024-05-16 23:40:00.000000',00000000000000602953),('2024-05-16 23:45:00.000000',00000000000000626553),('2024-05-16 23:50:00.000000',00000000000000626553),('2024-05-16 23:55:00.000000',00000000000000626553),('2024-05-17 00:00:00.000000',00000000000000635353),('2024-05-17 00:05:00.000000',00000000000000635353),('2024-05-17 00:10:00.000000',00000000000000647053),('2024-05-17 00:15:00.000000',00000000000000647053),('2024-05-17 00:20:00.000000',00000000000000647053),('2024-05-17 00:25:00.000000',00000000000000647053),('2024-05-17 00:30:00.000000',00000000000000647053),('2024-05-17 00:35:00.000000',00000000000000638153),('2024-05-17 00:40:00.000000',00000000000000638153),('2024-05-17 00:45:00.000000',00000000000000638153),('2024-05-17 00:50:00.000000',00000000000000638153),('2024-05-17 00:55:00.000000',00000000000000638153),('2024-05-17 01:00:00.000000',00000000000000653553),('2024-05-17 01:05:00.000000',00000000000000653553),('2024-05-17 01:10:00.000000',00000000000000653553),('2024-05-17 01:15:00.000000',00000000000000663453),('2024-05-17 01:20:00.000000',00000000000000663453),('2024-05-17 01:25:00.000000',00000000000000679233),('2024-05-17 01:30:00.000000',00000000000000679233),('2024-05-17 01:35:00.000000',00000000000000688133),('2024-05-17 01:40:00.000000',00000000000000688133),('2024-05-17 01:45:00.000000',00000000000000688133),('2024-05-17 01:50:00.000000',00000000000000713733),('2024-05-17 01:55:00.000000',00000000000000730433),('2024-05-17 02:00:00.000000',00000000000000739233),('2024-05-17 02:05:00.000000',00000000000000747933),('2024-05-17 02:10:00.000000',00000000000000751932),('2024-05-17 02:15:00.000000',00000000000000771432),('2024-05-17 02:20:00.000000',00000000000000771432),('2024-05-17 02:25:00.000000',00000000000000771432),('2024-05-17 02:30:00.000000',00000000000000779232),('2024-05-17 02:35:00.000000',00000000000000779232),('2024-05-17 02:40:00.000000',00000000000000785132),('2024-05-17 02:45:00.000000',00000000000000798932),('2024-05-17 02:50:00.000000',00000000000000809732),('2024-05-17 02:55:00.000000',00000000000000829732),('2024-05-17 03:00:00.000000',00000000000000834632),('2024-05-17 03:05:00.000000',00000000000000834632),('2024-05-17 03:10:00.000000',00000000000000834632),('2024-05-17 03:15:00.000000',00000000000000845432),('2024-05-17 03:20:00.000000',00000000000000858132),('2024-05-17 03:25:00.000000',00000000000000858132),('2024-05-17 03:30:00.000000',00000000000000858132),('2024-05-17 03:35:00.000000',00000000000000858132),('2024-05-17 03:40:00.000000',00000000000000858132),('2024-05-17 03:45:00.000000',00000000000000858132),('2024-05-17 03:50:00.000000',00000000000000858132),('2024-05-17 03:55:00.000000',00000000000000858132),('2024-05-17 04:00:00.000000',00000000000000858132),('2024-05-17 04:05:00.000000',00000000000000858132),('2024-05-17 04:10:00.000000',00000000000000858132),('2024-05-17 04:15:00.000000',00000000000000858132),('2024-05-17 04:20:00.000000',00000000000000858132),('2024-05-17 04:25:00.000000',00000000000000858132),('2024-05-17 04:30:00.000000',00000000000000858132),('2024-05-17 04:35:00.000000',00000000000000858132),('2024-05-17 04:40:00.000000',00000000000000858132),('2024-05-17 04:45:00.000000',00000000000000864032),('2024-05-17 04:50:00.000000',00000000000000873932),('2024-05-17 04:55:00.000000',00000000000000877732),('2024-05-17 05:00:00.000000',00000000000000881532),('2024-05-17 05:05:00.000000',00000000000000895232),('2024-05-17 05:10:00.000000',00000000000000900332),('2024-05-17 05:15:00.000000',00000000000000910232),('2024-05-17 05:20:00.000000',00000000000000919032),('2024-05-17 05:25:00.000000',00000000000000924920),('2024-05-17 05:30:00.000000',00000000000000931820),('2024-05-17 05:35:00.000000',00000000000000971620),('2024-05-17 05:40:00.000000',00000000000000976520),('2024-05-17 05:45:00.000000',00000000000000976520),('2024-05-17 05:50:00.000000',00000000000000990320),('2024-05-17 05:55:00.000000',00000000000000990320),('2024-05-17 06:00:00.000000',00000000000000990920),('2024-05-17 06:05:00.000000',00000000000001000820),('2024-05-17 06:10:00.000000',00000000000001010720),('2024-05-17 06:15:00.000000',00000000000001014520),('2024-05-17 06:20:00.000000',00000000000001014520),('2024-05-17 06:25:00.000000',00000000000001023420),('2024-05-17 06:30:00.000000',00000000000001023420),('2024-05-17 06:35:00.000000',00000000000001023420),('2024-05-17 06:40:00.000000',00000000000001023420),('2024-05-17 06:45:00.000000',00000000000001037220),('2024-05-17 06:50:00.000000',00000000000001042120),('2024-05-17 06:55:00.000000',00000000000001050020),('2024-05-17 07:00:00.000000',00000000000001050020),('2024-05-17 07:05:00.000000',00000000000001058820),('2024-05-17 07:10:00.000000',00000000000001069420),('2024-05-17 07:15:00.000000',00000000000001077320),('2024-05-17 07:20:00.000000',00000000000001077320),('2024-05-17 07:25:00.000000',00000000000001083920),('2024-05-17 07:30:00.000000',00000000000001107419),('2024-05-17 07:35:00.000000',00000000000001116219),('2024-05-17 07:40:00.000000',00000000000001116219),('2024-05-17 07:45:00.000000',00000000000001116219),('2024-05-17 07:50:00.000000',00000000000001122119),('2024-05-17 07:55:00.000000',00000000000001122119),('2024-05-17 08:00:00.000000',00000000000001129019),('2024-05-17 08:05:00.000000',00000000000001136919),('2024-05-17 08:10:00.000000',00000000000001136919),('2024-05-17 08:15:00.000000',00000000000001144819),('2024-05-17 08:20:00.000000',00000000000001152819),('2024-05-17 08:25:00.000000',00000000000001152819),('2024-05-17 08:30:00.000000',00000000000001160719),('2024-05-17 08:35:00.000000',00000000000001160619),('2024-05-17 08:40:00.000000',00000000000001160619),('2024-05-17 08:45:00.000000',00000000000001160619),('2024-05-17 08:50:00.000000',00000000000001160619),('2024-05-17 08:55:00.000000',00000000000001181409),('2024-05-17 09:00:00.000000',00000000000001201309),('2024-05-17 09:05:00.000000',00000000000001209209),('2024-05-17 09:10:00.000000',00000000000001214109),('2024-05-17 09:15:00.000000',00000000000001224009),('2024-05-17 09:20:00.000000',00000000000001224009),('2024-05-17 09:25:00.000000',00000000000001224009),('2024-05-17 09:30:00.000000',00000000000001224009),('2024-05-17 09:35:00.000000',00000000000001241909),('2024-05-17 09:40:00.000000',00000000000001245709),('2024-05-17 09:45:00.000000',00000000000001245709),('2024-05-17 09:50:00.000000',00000000000001249609),('2024-05-17 09:55:00.000000',00000000000001249609),('2024-05-17 10:00:00.000000',00000000000001249609),('2024-05-17 10:05:00.000000',00000000000001261309),('2024-05-17 10:10:00.000000',00000000000001261309),('2024-05-17 10:15:00.000000',00000000000001275009),('2024-05-17 10:20:00.000000',00000000000001275009),('2024-05-17 10:25:00.000000',00000000000001320009),('2024-05-17 10:30:00.000000',00000000000001327909),('2024-05-17 10:35:00.000000',00000000000001335809),('2024-05-17 10:40:00.000000',00000000000001383609),('2024-05-17 10:45:00.000000',00000000000001388809),('2024-05-17 10:50:00.000000',00000000000001388809),('2024-05-17 10:55:00.000000',00000000000001412409),('2024-05-17 11:00:00.000000',00000000000001412409),('2024-05-17 11:05:00.000000',00000000000001424975),('2024-05-17 11:10:00.000000',00000000000001432875),('2024-05-17 11:15:00.000000',00000000000001446675),('2024-05-17 11:20:00.000000',00000000000001496475),('2024-05-17 11:25:00.000000',00000000000001504375),('2024-05-17 11:30:00.000000',00000000000001517175),('2024-05-17 11:35:00.000000',00000000000001566075),('2024-05-17 11:40:00.000000',00000000000001566075),('2024-05-17 11:45:00.000000',00000000000001580875),('2024-05-17 11:50:00.000000',00000000000001596575),('2024-05-17 11:55:00.000000',00000000000001596575),('2024-05-17 12:00:00.000000',00000000000001596575),('2024-05-17 12:05:00.000000',00000000000001604475),('2024-05-17 12:10:00.000000',00000000000001604475),('2024-05-17 12:15:00.000000',00000000000001633075),('2024-05-17 12:20:00.000000',00000000000001684575),('2024-05-17 12:25:00.000000',00000000000001712075),('2024-05-17 12:30:00.000000',00000000000001758875),('2024-05-17 12:35:00.000000',00000000000001766775),('2024-05-17 12:40:00.000000',00000000000001902075),('2024-05-17 12:45:00.000000',00000000000001902741),('2024-05-17 12:50:00.000000',00000000000001903731),('2024-05-17 12:55:00.000000',00000000000001915231),('2024-05-17 13:00:00.000000',00000000000001939931),('2024-05-17 13:05:00.000000',00000000000001939931),('2024-05-17 13:10:00.000000',00000000000001939931),('2024-05-17 13:15:00.000000',00000000000001939931),('2024-05-17 13:20:00.000000',00000000000001939931),('2024-05-17 13:25:00.000000',00000000000001942111),('2024-05-17 13:30:00.000000',00000000000001951011),('2024-05-17 13:35:00.000000',00000000000001958911),('2024-05-17 13:40:00.000000',00000000000001965811),('2024-05-17 13:45:00.000000',00000000000001998211),('2024-05-17 13:50:00.000000',00000000000002060711),('2024-05-17 13:55:00.000000',00000000000002072511),('2024-05-17 14:00:00.000000',00000000000002120011),('2024-05-17 14:05:00.000000',00000000000002153890),('2024-05-17 14:10:00.000000',00000000000002162690),('2024-05-17 14:15:00.000000',00000000000002179390),('2024-05-17 14:20:00.000000',00000000000002189189),('2024-05-17 14:25:00.000000',00000000000002202355),('2024-05-17 14:30:00.000000',00000000000002202355),('2024-05-17 14:35:00.000000',00000000000002202355),('2024-05-17 14:40:00.000000',00000000000002202355),('2024-05-17 14:45:00.000000',00000000000002219055),('2024-05-17 14:50:00.000000',00000000000002219055),('2024-05-17 14:55:00.000000',00000000000002237755),('2024-05-17 15:00:00.000000',00000000000002301155),('2024-05-17 15:05:00.000000',00000000000002325355),('2024-05-17 15:10:00.000000',00000000000002363455),('2024-05-17 15:15:00.000000',00000000000002374155),('2024-05-17 15:20:00.000000',00000000000002374155),('2024-05-17 15:25:00.000000',00000000000002382055),('2024-05-17 15:30:00.000000',00000000000002407554),('2024-05-17 15:35:00.000000',00000000000002435934),('2024-05-17 15:40:00.000000',00000000000002436600),('2024-05-17 15:45:00.000000',00000000000002460300),('2024-05-17 15:50:00.000000',00000000000002461300),('2024-05-17 15:55:00.000000',00000000000002464200),('2024-05-17 16:00:00.000000',00000000000000000000),('2024-05-17 16:05:00.000000',00000000000000000000),('2024-05-17 16:10:00.000000',00000000000000000000),('2024-05-17 16:15:00.000000',00000000000000027600),('2024-05-17 16:20:00.000000',00000000000000033300),('2024-05-17 16:25:00.000000',00000000000000056000),('2024-05-17 16:30:00.000000',00000000000000067100),('2024-05-17 16:35:00.000000',00000000000000084800),('2024-05-17 16:40:00.000000',00000000000000117300),('2024-05-17 16:45:00.000000',00000000000000117300),('2024-05-17 16:50:00.000000',00000000000000169800),('2024-05-17 16:55:00.000000',00000000000000173600),('2024-05-17 17:00:00.000000',00000000000000173600),('2024-05-17 17:05:00.000000',00000000000000181500),('2024-05-17 17:10:00.000000',00000000000000205200),('2024-05-17 17:15:00.000000',00000000000000228800),('2024-05-17 17:20:00.000000',00000000000000240400),('2024-05-17 17:25:00.000000',00000000000000270300),('2024-05-17 17:30:00.000000',00000000000000280800),('2024-05-17 17:35:00.000000',00000000000000284700),('2024-05-17 17:40:00.000000',00000000000000301400),('2024-05-17 17:45:00.000000',00000000000000341300),('2024-05-17 17:50:00.000000',00000000000000357100),('2024-05-17 17:55:00.000000',00000000000000379600),('2024-05-17 18:00:00.000000',00000000000000385500),('2024-05-17 18:05:00.000000',00000000000000385500),('2024-05-17 18:10:00.000000',00000000000000391990),('2024-05-17 18:15:00.000000',00000000000000391990),('2024-05-17 18:20:00.000000',00000000000000401890),('2024-05-17 18:25:00.000000',00000000000000401890),('2024-05-17 18:30:00.000000',00000000000000401890),('2024-05-17 18:35:00.000000',00000000000000401890),('2024-05-17 18:40:00.000000',00000000000000401890),('2024-05-17 18:45:00.000000',00000000000000441490),('2024-05-17 18:50:00.000000',00000000000000441490),('2024-05-17 18:55:00.000000',00000000000000441490),('2024-05-17 19:00:00.000000',00000000000000441490),('2024-05-17 19:05:00.000000',00000000000000441490),('2024-05-17 19:10:00.000000',00000000000000441490),('2024-05-17 19:15:00.000000',00000000000000441490),('2024-05-17 19:20:00.000000',00000000000000441490),('2024-05-17 19:25:00.000000',00000000000000446390),('2024-05-17 19:30:00.000000',00000000000000446390),('2024-05-17 19:35:00.000000',00000000000000452290),('2024-05-17 19:40:00.000000',00000000000000452290),('2024-05-17 19:45:00.000000',00000000000000464090),('2024-05-17 19:50:00.000000',00000000000000471990),('2024-05-17 19:55:00.000000',00000000000000480890),('2024-05-17 20:00:00.000000',00000000000000480890),('2024-05-17 20:05:00.000000',00000000000000480890),('2024-05-17 20:10:00.000000',00000000000000480890),('2024-05-17 20:15:00.000000',00000000000000480890),('2024-05-17 20:20:00.000000',00000000000000480890),('2024-05-17 20:25:00.000000',00000000000000480890),('2024-05-17 20:30:00.000000',00000000000000480890),('2024-05-17 20:35:00.000000',00000000000000480890),('2024-05-17 20:40:00.000000',00000000000000480890),('2024-05-17 20:45:00.000000',00000000000000480890),('2024-05-17 20:50:00.000000',00000000000000480890),('2024-05-17 20:55:00.000000',00000000000000480890),('2024-05-17 21:00:00.000000',00000000000000480890),('2024-05-17 21:05:00.000000',00000000000000480890),('2024-05-17 21:10:00.000000',00000000000000486690),('2024-05-17 21:15:00.000000',00000000000000495590),('2024-05-17 21:20:00.000000',00000000000000495590),('2024-05-17 21:25:00.000000',00000000000000495590),('2024-05-17 21:30:00.000000',00000000000000501490),('2024-05-17 21:35:00.000000',00000000000000501490),('2024-05-17 21:40:00.000000',00000000000000505290),('2024-05-17 21:45:00.000000',00000000000000505290),('2024-05-17 21:50:00.000000',00000000000000512190),('2024-05-17 21:55:00.000000',00000000000000512190),('2024-05-17 22:00:00.000000',00000000000000512190),('2024-05-17 22:05:00.000000',00000000000000512190),('2024-05-17 22:10:00.000000',00000000000000512190),('2024-05-17 22:15:00.000000',00000000000000512190),('2024-05-17 22:20:00.000000',00000000000000512190),('2024-05-17 22:25:00.000000',00000000000000512190),('2024-05-17 22:30:00.000000',00000000000000529990),('2024-05-17 22:35:00.000000',00000000000000529990),('2024-05-17 22:40:00.000000',00000000000000537890),('2024-05-17 22:45:00.000000',00000000000000537890),('2024-05-17 22:50:00.000000',00000000000000537890),('2024-05-17 22:55:00.000000',00000000000000546690),('2024-05-17 23:00:00.000000',00000000000000546690),('2024-05-17 23:05:00.000000',00000000000000546690),('2024-05-17 23:10:00.000000',00000000000000559490),('2024-05-17 23:15:00.000000',00000000000000559490),('2024-05-17 23:20:00.000000',00000000000000559490),('2024-05-17 23:25:00.000000',00000000000000559490),('2024-05-17 23:30:00.000000',00000000000000559490),('2024-05-17 23:35:00.000000',00000000000000559490),('2024-05-17 23:40:00.000000',00000000000000559490),('2024-05-17 23:45:00.000000',00000000000000559490),('2024-05-17 23:50:00.000000',00000000000000563290),('2024-05-17 23:55:00.000000',00000000000000563290),('2024-05-18 00:00:00.000000',00000000000000563290),('2024-05-18 00:05:00.000000',00000000000000563290),('2024-05-18 00:10:00.000000',00000000000000563290),('2024-05-18 00:15:00.000000',00000000000000563290),('2024-05-18 00:20:00.000000',00000000000000563290),('2024-05-18 00:25:00.000000',00000000000000563290),('2024-05-18 00:30:00.000000',00000000000000563290),('2024-05-18 00:35:00.000000',00000000000000576090),('2024-05-18 00:40:00.000000',00000000000000576090),('2024-05-18 00:45:00.000000',00000000000000576090),('2024-05-18 00:50:00.000000',00000000000000590890),('2024-05-18 00:55:00.000000',00000000000000590890),('2024-05-18 01:00:00.000000',00000000000000590890),('2024-05-18 01:05:00.000000',00000000000000590890),('2024-05-18 01:10:00.000000',00000000000000590890),('2024-05-18 01:15:00.000000',00000000000000590890),('2024-05-18 01:20:00.000000',00000000000000594769),('2024-05-18 01:25:00.000000',00000000000000600669),('2024-05-18 01:30:00.000000',00000000000000612669),('2024-05-18 01:35:00.000000',00000000000000618569),('2024-05-18 01:40:00.000000',00000000000000627469),('2024-05-18 01:45:00.000000',00000000000000627469),('2024-05-18 01:50:00.000000',00000000000000632369),('2024-05-18 01:55:00.000000',00000000000000642269),('2024-05-18 02:00:00.000000',00000000000000647169),('2024-05-18 02:05:00.000000',00000000000000647169),('2024-05-18 02:10:00.000000',00000000000000647169),('2024-05-18 02:15:00.000000',00000000000000654069),('2024-05-18 02:20:00.000000',00000000000000666869),('2024-05-18 02:25:00.000000',00000000000000666869),('2024-05-18 02:30:00.000000',00000000000000688469),('2024-05-18 02:35:00.000000',00000000000000688469),('2024-05-18 02:40:00.000000',00000000000000688469),('2024-05-18 02:45:00.000000',00000000000000688469),('2024-05-18 02:50:00.000000',00000000000000688469),('2024-05-18 02:55:00.000000',00000000000000688469),('2024-05-18 03:00:00.000000',00000000000000695969),('2024-05-18 03:05:00.000000',00000000000000705869),('2024-05-18 03:10:00.000000',00000000000000715769),('2024-05-18 03:15:00.000000',00000000000000722669),('2024-05-18 03:20:00.000000',00000000000000715769),('2024-05-18 03:25:00.000000',00000000000000715769),('2024-05-18 03:30:00.000000',00000000000000715769),('2024-05-18 03:35:00.000000',00000000000000715769),('2024-05-18 03:40:00.000000',00000000000000715769),('2024-05-18 03:45:00.000000',00000000000000715769),('2024-05-18 03:50:00.000000',00000000000000715769),('2024-05-18 03:55:00.000000',00000000000000715769),('2024-05-18 04:00:00.000000',00000000000000715769),('2024-05-18 04:05:00.000000',00000000000000729469),('2024-05-18 04:10:00.000000',00000000000000734369),('2024-05-18 04:15:00.000000',00000000000000744269),('2024-05-18 04:20:00.000000',00000000000000754169),('2024-05-18 04:25:00.000000',00000000000000754169),('2024-05-18 04:30:00.000000',00000000000000754169),('2024-05-18 04:35:00.000000',00000000000000764169),('2024-05-18 04:40:00.000000',00000000000000774069),('2024-05-18 04:45:00.000000',00000000000000838569),('2024-05-18 04:50:00.000000',00000000000000842448),('2024-05-18 04:55:00.000000',00000000000000857248),('2024-05-18 05:00:00.000000',00000000000000857248),('2024-05-18 05:05:00.000000',00000000000000865048),('2024-05-18 05:10:00.000000',00000000000000865048),('2024-05-18 05:15:00.000000',00000000000000865048),('2024-05-18 05:20:00.000000',00000000000000865048),('2024-05-18 05:25:00.000000',00000000000000865048),('2024-05-18 05:30:00.000000',00000000000000865048),('2024-05-18 05:35:00.000000',00000000000000874948),('2024-05-18 05:40:00.000000',00000000000000874948),('2024-05-18 05:45:00.000000',00000000000000888748),('2024-05-18 05:50:00.000000',00000000000000917528),('2024-05-18 05:55:00.000000',00000000000000917528),('2024-05-18 06:00:00.000000',00000000000000907628),('2024-05-18 06:05:00.000000',00000000000000927428),('2024-05-18 06:10:00.000000',00000000000000966128),('2024-05-18 06:15:00.000000',00000000000001006028),('2024-05-18 06:20:00.000000',00000000000001019328),('2024-05-18 06:25:00.000000',00000000000001029228),('2024-05-18 06:30:00.000000',00000000000001029228),('2024-05-18 06:35:00.000000',00000000000001037128),('2024-05-18 06:40:00.000000',00000000000001037128),('2024-05-18 06:45:00.000000',00000000000001045028),('2024-05-18 06:50:00.000000',00000000000001045028),('2024-05-18 06:55:00.000000',00000000000001065728),('2024-05-18 07:00:00.000000',00000000000001065728),('2024-05-18 07:05:00.000000',00000000000001112528),('2024-05-18 07:10:00.000000',00000000000001117628),('2024-05-18 07:15:00.000000',00000000000001126428),('2024-05-18 07:20:00.000000',00000000000001126428),('2024-05-18 07:25:00.000000',00000000000001126428),('2024-05-18 07:30:00.000000',00000000000001126428),('2024-05-18 07:35:00.000000',00000000000001126428),('2024-05-18 07:40:00.000000',00000000000001126428),('2024-05-18 07:45:00.000000',00000000000001126428),('2024-05-18 07:50:00.000000',00000000000001126428),('2024-05-18 07:55:00.000000',00000000000001144128),('2024-05-18 08:00:00.000000',00000000000001144128),('2024-05-18 08:05:00.000000',00000000000001144128),('2024-05-18 08:10:00.000000',00000000000001174128),('2024-05-18 08:15:00.000000',00000000000001182028),('2024-05-18 08:20:00.000000',00000000000001196828),('2024-05-18 08:25:00.000000',00000000000001196828),('2024-05-18 08:30:00.000000',00000000000001236728),('2024-05-18 08:35:00.000000',00000000000001246528),('2024-05-18 08:40:00.000000',00000000000001246528),('2024-05-18 08:45:00.000000',00000000000001246528),('2024-05-18 08:50:00.000000',00000000000001246528),('2024-05-18 08:55:00.000000',00000000000001246528),('2024-05-18 09:00:00.000000',00000000000001246528),('2024-05-18 09:05:00.000000',00000000000001254428),('2024-05-18 09:10:00.000000',00000000000001254428),('2024-05-18 09:15:00.000000',00000000000001254428),('2024-05-18 09:20:00.000000',00000000000001260328),('2024-05-18 09:25:00.000000',00000000000001246628),('2024-05-18 09:30:00.000000',00000000000001254528),('2024-05-18 09:35:00.000000',00000000000001254528),('2024-05-18 09:40:00.000000',00000000000001264428),('2024-05-18 09:45:00.000000',00000000000001270228),('2024-05-18 09:50:00.000000',00000000000001270228),('2024-05-18 09:55:00.000000',00000000000001270228),('2024-05-18 10:00:00.000000',00000000000001270228),('2024-05-18 10:05:00.000000',00000000000001270228),('2024-05-18 10:10:00.000000',00000000000001281828),('2024-05-18 10:15:00.000000',00000000000001289628),('2024-05-18 10:20:00.000000',00000000000001309418),('2024-05-18 10:25:00.000000',00000000000001309418),('2024-05-18 10:30:00.000000',00000000000001309418),('2024-05-18 10:35:00.000000',00000000000001319318),('2024-05-18 10:40:00.000000',00000000000001314618),('2024-05-18 10:45:00.000000',00000000000001318418),('2024-05-18 10:50:00.000000',00000000000001330218),('2024-05-18 10:55:00.000000',00000000000001337018),('2024-05-18 11:00:00.000000',00000000000001343618),('2024-05-18 11:05:00.000000',00000000000001343618),('2024-05-18 11:10:00.000000',00000000000001343618),('2024-05-18 11:15:00.000000',00000000000001343618),('2024-05-18 11:20:00.000000',00000000000001343618),('2024-05-18 11:25:00.000000',00000000000001343618),('2024-05-18 11:30:00.000000',00000000000001343618),('2024-05-18 11:35:00.000000',00000000000001343618),('2024-05-18 11:40:00.000000',00000000000001352518),('2024-05-18 11:45:00.000000',00000000000001352518),('2024-05-18 11:50:00.000000',00000000000001352518),('2024-05-18 11:55:00.000000',00000000000001361318),('2024-05-18 12:00:00.000000',00000000000001361318),('2024-05-18 12:05:00.000000',00000000000001361318),('2024-05-18 12:10:00.000000',00000000000001361318),('2024-05-18 12:15:00.000000',00000000000001366218),('2024-05-18 12:20:00.000000',00000000000001375018),('2024-05-18 12:25:00.000000',00000000000001378818),('2024-05-18 12:30:00.000000',00000000000001381618),('2024-05-18 12:35:00.000000',00000000000001381618),('2024-05-18 12:40:00.000000',00000000000001381618),('2024-05-18 12:45:00.000000',00000000000001381618),('2024-05-18 12:50:00.000000',00000000000001386518),('2024-05-18 12:55:00.000000',00000000000001396418),('2024-05-18 13:00:00.000000',00000000000001411118),('2024-05-18 13:05:00.000000',00000000000001428918),('2024-05-18 13:10:00.000000',00000000000001443697),('2024-05-18 13:15:00.000000',00000000000001443697),('2024-05-18 13:20:00.000000',00000000000001443697),('2024-05-18 13:25:00.000000',00000000000001451597),('2024-05-18 13:30:00.000000',00000000000001464297),('2024-05-18 13:35:00.000000',00000000000001474197),('2024-05-18 13:40:00.000000',00000000000001478097),('2024-05-18 13:45:00.000000',00000000000001489597),('2024-05-18 13:50:00.000000',00000000000001482997),('2024-05-18 13:55:00.000000',00000000000001482997),('2024-05-18 14:00:00.000000',00000000000001498097),('2024-05-18 14:05:00.000000',00000000000001502997),('2024-05-18 14:10:00.000000',00000000000001510897),('2024-05-18 14:15:00.000000',00000000000001510897),('2024-05-18 14:20:00.000000',00000000000001518797),('2024-05-18 14:25:00.000000',00000000000001526697),('2024-05-18 14:30:00.000000',00000000000001526697),('2024-05-18 14:35:00.000000',00000000000001539297),('2024-05-18 14:40:00.000000',00000000000001554697),('2024-05-18 14:45:00.000000',00000000000001554697),('2024-05-18 14:50:00.000000',00000000000001558597),('2024-05-18 14:55:00.000000',00000000000001558597),('2024-05-18 15:00:00.000000',00000000000001566497),('2024-05-18 15:05:00.000000',00000000000001584297),('2024-05-18 15:10:00.000000',00000000000001576397),('2024-05-18 15:15:00.000000',00000000000001588097),('2024-05-18 15:20:00.000000',00000000000001592997),('2024-05-18 15:25:00.000000',00000000000001609797),('2024-05-18 15:30:00.000000',00000000000001609797),('2024-05-18 15:35:00.000000',00000000000001635197),('2024-05-18 15:40:00.000000',00000000000001635197),('2024-05-18 15:45:00.000000',00000000000001642097),('2024-05-18 15:50:00.000000',00000000000001645997),('2024-05-18 15:55:00.000000',00000000000001670697),('2024-05-18 16:00:00.000000',00000000000000000000),('2024-05-18 16:05:00.000000',00000000000000022690),('2024-05-18 16:10:00.000000',00000000000000033390),('2024-05-18 16:15:00.000000',00000000000000033390),('2024-05-18 16:20:00.000000',00000000000000045169),('2024-05-18 16:25:00.000000',00000000000000098469),('2024-05-18 16:30:00.000000',00000000000000098469),('2024-05-18 16:35:00.000000',00000000000000123969),('2024-05-18 16:40:00.000000',00000000000000127969),('2024-05-18 16:45:00.000000',00000000000000128589),('2024-05-18 16:50:00.000000',00000000000000136489),('2024-05-18 16:55:00.000000',00000000000000163889),('2024-05-18 17:00:00.000000',00000000000000178689),('2024-05-18 17:05:00.000000',00000000000000202389),('2024-05-18 17:10:00.000000',00000000000000195289),('2024-05-18 17:15:00.000000',00000000000000210168),('2024-05-18 17:20:00.000000',00000000000000224768),('2024-05-18 17:25:00.000000',00000000000000260768),('2024-05-18 17:30:00.000000',00000000000000284368),('2024-05-18 17:35:00.000000',00000000000000289368),('2024-05-18 17:40:00.000000',00000000000000304068),('2024-05-18 17:45:00.000000',00000000000000321948),('2024-05-18 17:50:00.000000',00000000000000343948),('2024-05-18 17:55:00.000000',00000000000000351848),('2024-05-18 18:00:00.000000',00000000000000354748),('2024-05-18 18:05:00.000000',00000000000000365548),('2024-05-18 18:10:00.000000',00000000000000371337),('2024-05-18 18:15:00.000000',00000000000000371337),('2024-05-18 18:20:00.000000',00000000000000400837),('2024-05-18 18:25:00.000000',00000000000000399837),('2024-05-18 18:30:00.000000',00000000000000399837),('2024-05-18 18:35:00.000000',00000000000000406737),('2024-05-18 18:40:00.000000',00000000000000406737),('2024-05-18 18:45:00.000000',00000000000000409737),('2024-05-18 18:50:00.000000',00000000000000417637),('2024-05-18 18:55:00.000000',00000000000000417637),('2024-05-18 19:00:00.000000',00000000000000419637),('2024-05-18 19:05:00.000000',00000000000000419637),('2024-05-18 19:10:00.000000',00000000000000419637),('2024-05-18 19:15:00.000000',00000000000000424537),('2024-05-18 19:20:00.000000',00000000000000433237),('2024-05-18 19:25:00.000000',00000000000000433237),('2024-05-18 19:30:00.000000',00000000000000441137),('2024-05-18 19:35:00.000000',00000000000000453237),('2024-05-18 19:40:00.000000',00000000000000509837),('2024-05-18 19:45:00.000000',00000000000000509837),('2024-05-18 19:50:00.000000',00000000000000509837),('2024-05-18 19:55:00.000000',00000000000000531437),('2024-05-18 20:00:00.000000',00000000000000545137),('2024-05-18 20:05:00.000000',00000000000000545137),('2024-05-18 20:10:00.000000',00000000000000564817),('2024-05-18 20:15:00.000000',00000000000000570717),('2024-05-18 20:20:00.000000',00000000000000570717),('2024-05-18 20:25:00.000000',00000000000000570717),('2024-05-18 20:30:00.000000',00000000000000570717),('2024-05-18 20:35:00.000000',00000000000000579517),('2024-05-18 20:40:00.000000',00000000000000584417),('2024-05-18 20:45:00.000000',00000000000000584417),('2024-05-18 20:50:00.000000',00000000000000584417),('2024-05-18 20:55:00.000000',00000000000000584417),('2024-05-18 21:00:00.000000',00000000000000584417),('2024-05-18 21:05:00.000000',00000000000000584417),('2024-05-18 21:10:00.000000',00000000000000584417),('2024-05-18 21:15:00.000000',00000000000000584417),('2024-05-18 21:20:00.000000',00000000000000584417),('2024-05-18 21:25:00.000000',00000000000000584417),('2024-05-18 21:30:00.000000',00000000000000584417),('2024-05-18 21:35:00.000000',00000000000000584417),('2024-05-18 21:40:00.000000',00000000000000588217),('2024-05-18 21:45:00.000000',00000000000000588217),('2024-05-18 21:50:00.000000',00000000000000588217),('2024-05-18 21:55:00.000000',00000000000000597117),('2024-05-18 22:00:00.000000',00000000000000613817),('2024-05-18 22:05:00.000000',00000000000000693617),('2024-05-18 22:10:00.000000',00000000000000693617),('2024-05-18 22:15:00.000000',00000000000000699317),('2024-05-18 22:20:00.000000',00000000000000712117),('2024-05-18 22:25:00.000000',00000000000000712117),('2024-05-18 22:30:00.000000',00000000000000712117),('2024-05-18 22:35:00.000000',00000000000000712117),('2024-05-18 22:40:00.000000',00000000000000712117),('2024-05-18 22:45:00.000000',00000000000000712117),('2024-05-18 22:50:00.000000',00000000000000720017),('2024-05-18 22:55:00.000000',00000000000000712117),('2024-05-18 23:00:00.000000',00000000000000712117),('2024-05-18 23:05:00.000000',00000000000000717017),('2024-05-18 23:10:00.000000',00000000000000717017),('2024-05-18 23:15:00.000000',00000000000000717017),('2024-05-18 23:20:00.000000',00000000000000717017),('2024-05-18 23:25:00.000000',00000000000000720007),('2024-05-18 23:30:00.000000',00000000000000720007),('2024-05-18 23:35:00.000000',00000000000000720673),('2024-05-18 23:40:00.000000',00000000000000724663),('2024-05-18 23:45:00.000000',00000000000000724663),('2024-05-18 23:50:00.000000',00000000000000725329),('2024-05-18 23:55:00.000000',00000000000000725329),('2024-05-19 00:00:00.000000',00000000000000735229),('2024-05-19 00:05:00.000000',00000000000000745129),('2024-05-19 00:10:00.000000',00000000000000745129),('2024-05-19 00:15:00.000000',00000000000000752029),('2024-05-19 00:20:00.000000',00000000000000757029),('2024-05-19 00:25:00.000000',00000000000000768729),('2024-05-19 00:30:00.000000',00000000000000777629),('2024-05-19 00:35:00.000000',00000000000000786195),('2024-05-19 00:40:00.000000',00000000000000804995),('2024-05-19 00:45:00.000000',00000000000000804995),('2024-05-19 00:50:00.000000',00000000000000804995),('2024-05-19 00:55:00.000000',00000000000000804995),('2024-05-19 01:00:00.000000',00000000000000804995),('2024-05-19 01:05:00.000000',00000000000000825695),('2024-05-19 01:10:00.000000',00000000000000825695),('2024-05-19 01:15:00.000000',00000000000000833595),('2024-05-19 01:20:00.000000',00000000000000833595),('2024-05-19 01:25:00.000000',00000000000000843495),('2024-05-19 01:30:00.000000',00000000000000843495),('2024-05-19 01:35:00.000000',00000000000000843495),('2024-05-19 01:40:00.000000',00000000000000851295),('2024-05-19 01:45:00.000000',00000000000000856195),('2024-05-19 01:50:00.000000',00000000000000861095),('2024-05-19 01:55:00.000000',00000000000000861761),('2024-05-19 02:00:00.000000',00000000000000861761),('2024-05-19 02:05:00.000000',00000000000000869661),('2024-05-19 02:10:00.000000',00000000000000878561),('2024-05-19 02:15:00.000000',00000000000000888061),('2024-05-19 02:20:00.000000',00000000000000927961),('2024-05-19 02:25:00.000000',00000000000000927961),('2024-05-19 02:30:00.000000',00000000000000927961),('2024-05-19 02:35:00.000000',00000000000000927961),('2024-05-19 02:40:00.000000',00000000000000942761),('2024-05-19 02:45:00.000000',00000000000000942761),('2024-05-19 02:50:00.000000',00000000000000942761),('2024-05-19 02:55:00.000000',00000000000000942761),('2024-05-19 03:00:00.000000',00000000000000947661),('2024-05-19 03:05:00.000000',00000000000000957561),('2024-05-19 03:10:00.000000',00000000000000972361),('2024-05-19 03:15:00.000000',00000000000000984261),('2024-05-19 03:20:00.000000',00000000000001006761),('2024-05-19 03:25:00.000000',00000000000001025361),('2024-05-19 03:30:00.000000',00000000000001044561),('2024-05-19 03:35:00.000000',00000000000001045551),('2024-05-19 03:40:00.000000',00000000000001068051),('2024-05-19 03:45:00.000000',00000000000001356851),('2024-05-19 03:50:00.000000',00000000000001416751),('2024-05-19 03:55:00.000000',00000000000001431451),('2024-05-19 04:00:00.000000',00000000000001431451),('2024-05-19 04:05:00.000000',00000000000001445751),('2024-05-19 04:10:00.000000',00000000000001445751),('2024-05-19 04:15:00.000000',00000000000001445751),('2024-05-19 04:20:00.000000',00000000000001455651),('2024-05-19 04:25:00.000000',00000000000001460451),('2024-05-19 04:30:00.000000',00000000000001468351),('2024-05-19 04:35:00.000000',00000000000001529930),('2024-05-19 04:40:00.000000',00000000000001529930),('2024-05-19 04:45:00.000000',00000000000001529930),('2024-05-19 04:50:00.000000',00000000000001529930),('2024-05-19 04:55:00.000000',00000000000001539430),('2024-05-19 05:00:00.000000',00000000000001539430),('2024-05-19 05:05:00.000000',00000000000001549230),('2024-05-19 05:10:00.000000',00000000000001553030),('2024-05-19 05:15:00.000000',00000000000001563830),('2024-05-19 05:20:00.000000',00000000000001611630),('2024-05-19 05:25:00.000000',00000000000001611630),('2024-05-19 05:30:00.000000',00000000000001611630),('2024-05-19 05:35:00.000000',00000000000001611630),('2024-05-19 05:40:00.000000',00000000000001611630),('2024-05-19 05:45:00.000000',00000000000001611630),('2024-05-19 05:50:00.000000',00000000000001632330),('2024-05-19 05:55:00.000000',00000000000001648930),('2024-05-19 06:00:00.000000',00000000000001656830),('2024-05-19 06:05:00.000000',00000000000001656830),('2024-05-19 06:10:00.000000',00000000000001653030),('2024-05-19 06:15:00.000000',00000000000001653030),('2024-05-19 06:20:00.000000',00000000000001679816),('2024-05-19 06:25:00.000000',00000000000001703506),('2024-05-19 06:30:00.000000',00000000000001753306),('2024-05-19 06:35:00.000000',00000000000001753306),('2024-05-19 06:40:00.000000',00000000000001753306),('2024-05-19 06:45:00.000000',00000000000001753306),('2024-05-19 06:50:00.000000',00000000000001753306),('2024-05-19 06:55:00.000000',00000000000001763306),('2024-05-19 07:00:00.000000',00000000000001763306),('2024-05-19 07:05:00.000000',00000000000001763306),('2024-05-19 07:10:00.000000',00000000000001758406),('2024-05-19 07:15:00.000000',00000000000001768306),('2024-05-19 07:20:00.000000',00000000000001784706),('2024-05-19 07:25:00.000000',00000000000001784706),('2024-05-19 07:30:00.000000',00000000000001798506),('2024-05-19 07:35:00.000000',00000000000001798506),('2024-05-19 07:40:00.000000',00000000000001798506),('2024-05-19 07:45:00.000000',00000000000001824106),('2024-05-19 07:50:00.000000',00000000000001829106),('2024-05-19 07:55:00.000000',00000000000001829106),('2024-05-19 08:00:00.000000',00000000000001829772),('2024-05-19 08:05:00.000000',00000000000001851472),('2024-05-19 08:10:00.000000',00000000000001851472),('2024-05-19 08:15:00.000000',00000000000001856672),('2024-05-19 08:20:00.000000',00000000000001867361),('2024-05-19 08:25:00.000000',00000000000001867361),('2024-05-19 08:30:00.000000',00000000000001875261),('2024-05-19 08:35:00.000000',00000000000001885161),('2024-05-19 08:40:00.000000',00000000000001893961),('2024-05-19 08:45:00.000000',00000000000001893961),('2024-05-19 08:50:00.000000',00000000000001893961),('2024-05-19 08:55:00.000000',00000000000001900861),('2024-05-19 09:00:00.000000',00000000000001908761),('2024-05-19 09:05:00.000000',00000000000001908761),('2024-05-19 09:10:00.000000',00000000000001912761),('2024-05-19 09:15:00.000000',00000000000001921661),('2024-05-19 09:20:00.000000',00000000000001935461),('2024-05-19 09:25:00.000000',00000000000001935461),('2024-05-19 09:30:00.000000',00000000000001935461),('2024-05-19 09:35:00.000000',00000000000001935461),('2024-05-19 09:40:00.000000',00000000000001940361),('2024-05-19 09:45:00.000000',00000000000001940361),('2024-05-19 09:50:00.000000',00000000000001940361),('2024-05-19 09:55:00.000000',00000000000001940361),('2024-05-19 10:00:00.000000',00000000000001948261),('2024-05-19 10:05:00.000000',00000000000001948261),('2024-05-19 10:10:00.000000',00000000000001954251),('2024-05-19 10:15:00.000000',00000000000001962151),('2024-05-19 10:20:00.000000',00000000000001962151),('2024-05-19 10:25:00.000000',00000000000001962151),('2024-05-19 10:30:00.000000',00000000000001972051),('2024-05-19 10:35:00.000000',00000000000001995751),('2024-05-19 10:40:00.000000',00000000000001995751),('2024-05-19 10:45:00.000000',00000000000001999651),('2024-05-19 10:50:00.000000',00000000000001999651),('2024-05-19 10:55:00.000000',00000000000001999651),('2024-05-19 11:00:00.000000',00000000000002016451),('2024-05-19 11:05:00.000000',00000000000002021351),('2024-05-19 11:10:00.000000',00000000000002021351),('2024-05-19 11:15:00.000000',00000000000002021351),('2024-05-19 11:20:00.000000',00000000000002030151),('2024-05-19 11:25:00.000000',00000000000002030151),('2024-05-19 11:30:00.000000',00000000000002048951),('2024-05-19 11:35:00.000000',00000000000002048951),('2024-05-19 11:40:00.000000',00000000000002052950),('2024-05-19 11:45:00.000000',00000000000002070750),('2024-05-19 11:50:00.000000',00000000000002070750),('2024-05-19 11:55:00.000000',00000000000002065950),('2024-05-19 12:00:00.000000',00000000000002093650),('2024-05-19 12:05:00.000000',00000000000002093650),('2024-05-19 12:10:00.000000',00000000000002093650),('2024-05-19 12:15:00.000000',00000000000002093650),('2024-05-19 12:20:00.000000',00000000000002093650),('2024-05-19 12:25:00.000000',00000000000002093650),('2024-05-19 12:30:00.000000',00000000000002122150),('2024-05-19 12:35:00.000000',00000000000002137750),('2024-05-19 12:40:00.000000',00000000000002137750),('2024-05-19 12:45:00.000000',00000000000002134750),('2024-05-19 12:50:00.000000',00000000000002151550),('2024-05-19 12:55:00.000000',00000000000002169350),('2024-05-19 13:00:00.000000',00000000000002169350),('2024-05-19 13:05:00.000000',00000000000002174250),('2024-05-19 13:10:00.000000',00000000000002186250),('2024-05-19 13:15:00.000000',00000000000002186250),('2024-05-19 13:20:00.000000',00000000000002198850),('2024-05-19 13:25:00.000000',00000000000002203840),('2024-05-19 13:30:00.000000',00000000000002213739),('2024-05-19 13:35:00.000000',00000000000002220628),('2024-05-19 13:40:00.000000',00000000000002288018),('2024-05-19 13:45:00.000000',00000000000002296918),('2024-05-19 13:50:00.000000',00000000000002315718),('2024-05-19 13:55:00.000000',00000000000002315718),('2024-05-19 14:00:00.000000',00000000000002330618),('2024-05-19 14:05:00.000000',00000000000002334418),('2024-05-19 14:10:00.000000',00000000000002343218),('2024-05-19 14:15:00.000000',00000000000002351118),('2024-05-19 14:20:00.000000',00000000000002373908),('2024-05-19 14:25:00.000000',00000000000002378808),('2024-05-19 14:30:00.000000',00000000000002399898),('2024-05-19 14:35:00.000000',00000000000002409687),('2024-05-19 14:40:00.000000',00000000000002428076),('2024-05-19 14:45:00.000000',00000000000002460966),('2024-05-19 14:50:00.000000',00000000000002469766),('2024-05-19 14:55:00.000000',00000000000002641232),('2024-05-19 15:00:00.000000',00000000000002659932),('2024-05-19 15:05:00.000000',00000000000002659932),('2024-05-19 15:10:00.000000',00000000000002675632),('2024-05-19 15:15:00.000000',00000000000002692332),('2024-05-19 15:20:00.000000',00000000000002700232),('2024-05-19 15:25:00.000000',00000000000002705132),('2024-05-19 15:30:00.000000',00000000000002730732),('2024-05-19 15:35:00.000000',00000000000002758431),('2024-05-19 15:40:00.000000',00000000000002749531),('2024-05-19 15:45:00.000000',00000000000002777031),('2024-05-19 15:50:00.000000',00000000000002777031),('2024-05-19 15:55:00.000000',00000000000002792831),('2024-05-19 16:00:00.000000',00000000000000000000),('2024-05-19 16:05:00.000000',00000000000000023600),('2024-05-19 16:10:00.000000',00000000000000053500),('2024-05-19 16:15:00.000000',00000000000000068300),('2024-05-19 16:20:00.000000',00000000000000076200),('2024-05-19 16:25:00.000000',00000000000000076200),('2024-05-19 16:30:00.000000',00000000000000086100),('2024-05-19 16:35:00.000000',00000000000000139600),('2024-05-19 16:40:00.000000',00000000000000139600),('2024-05-19 16:45:00.000000',00000000000000174100),('2024-05-19 16:50:00.000000',00000000000000174100),('2024-05-19 16:55:00.000000',00000000000000182000),('2024-05-19 17:00:00.000000',00000000000000202590),('2024-05-19 17:05:00.000000',00000000000000206568),('2024-05-19 17:10:00.000000',00000000000000231137),('2024-05-19 17:15:00.000000',00000000000000247837),('2024-05-19 17:20:00.000000',00000000000000268437),('2024-05-19 17:25:00.000000',00000000000000282137),('2024-05-19 17:30:00.000000',00000000000000297537),('2024-05-19 17:35:00.000000',00000000000000298527),('2024-05-19 17:40:00.000000',00000000000000310893),('2024-05-19 17:45:00.000000',00000000000000310893),('2024-05-19 17:50:00.000000',00000000000000330593),('2024-05-19 17:55:00.000000',00000000000000330593),('2024-05-19 18:00:00.000000',00000000000000391193),('2024-05-19 18:05:00.000000',00000000000000401093),('2024-05-19 18:10:00.000000',00000000000000401093),('2024-05-19 18:15:00.000000',00000000000000417793),('2024-05-19 18:20:00.000000',00000000000000417793),('2024-05-19 18:25:00.000000',00000000000000417793),('2024-05-19 18:30:00.000000',00000000000000437393),('2024-05-19 18:35:00.000000',00000000000000477293),('2024-05-19 18:40:00.000000',00000000000000482193),('2024-05-19 18:45:00.000000',00000000000000500893),('2024-05-19 18:50:00.000000',00000000000000508793),('2024-05-19 18:55:00.000000',00000000000000520493),('2024-05-19 19:00:00.000000',00000000000000545993),('2024-05-19 19:05:00.000000',00000000000000553893),('2024-05-19 19:10:00.000000',00000000000000554559),('2024-05-19 19:15:00.000000',00000000000000559459),('2024-05-19 19:20:00.000000',00000000000000567359),('2024-05-19 19:25:00.000000',00000000000000573259),('2024-05-19 19:30:00.000000',00000000000000581159),('2024-05-19 19:35:00.000000',00000000000000596959),('2024-05-19 19:40:00.000000',00000000000000596959),('2024-05-19 19:45:00.000000',00000000000000596959),('2024-05-19 19:50:00.000000',00000000000000596959),('2024-05-19 19:55:00.000000',00000000000000598959),('2024-05-19 20:00:00.000000',00000000000000601859),('2024-05-19 20:05:00.000000',00000000000000601859),('2024-05-19 20:10:00.000000',00000000000000601859),('2024-05-19 20:15:00.000000',00000000000000601859),('2024-05-19 20:20:00.000000',00000000000000601859),('2024-05-19 20:25:00.000000',00000000000000601859),('2024-05-19 20:30:00.000000',00000000000000601859),('2024-05-19 20:35:00.000000',00000000000000601859),('2024-05-19 20:40:00.000000',00000000000000611759),('2024-05-19 20:45:00.000000',00000000000000618559),('2024-05-19 20:50:00.000000',00000000000000628459),('2024-05-19 20:55:00.000000',00000000000000628459),('2024-05-19 21:00:00.000000',00000000000000628459),('2024-05-19 21:05:00.000000',00000000000000628459),('2024-05-19 21:10:00.000000',00000000000000628459),('2024-05-19 21:15:00.000000',00000000000000633359),('2024-05-19 21:20:00.000000',00000000000000633359),('2024-05-19 21:25:00.000000',00000000000000633359),('2024-05-19 21:30:00.000000',00000000000000638259),('2024-05-19 21:35:00.000000',00000000000000638259),('2024-05-19 21:40:00.000000',00000000000000648159),('2024-05-19 21:45:00.000000',00000000000000665959),('2024-05-19 21:50:00.000000',00000000000000665959),('2024-05-19 21:55:00.000000',00000000000000665959),('2024-05-19 22:00:00.000000',00000000000000665959),('2024-05-19 22:05:00.000000',00000000000000674759),('2024-05-19 22:10:00.000000',00000000000000675425),('2024-05-19 22:15:00.000000',00000000000000675425),('2024-05-19 22:20:00.000000',00000000000000675425),('2024-05-19 22:25:00.000000',00000000000000675425),('2024-05-19 22:30:00.000000',00000000000000675425),('2024-05-19 22:35:00.000000',00000000000000675425),('2024-05-19 22:40:00.000000',00000000000000675425),('2024-05-19 22:45:00.000000',00000000000000684225),('2024-05-19 22:50:00.000000',00000000000000684225),('2024-05-19 22:55:00.000000',00000000000000684225),('2024-05-19 23:00:00.000000',00000000000000684225),('2024-05-19 23:05:00.000000',00000000000000684225),('2024-05-19 23:10:00.000000',00000000000000684225),('2024-05-19 23:15:00.000000',00000000000000684225),('2024-05-19 23:20:00.000000',00000000000000692025),('2024-05-19 23:25:00.000000',00000000000000696024),('2024-05-19 23:30:00.000000',00000000000000702924),('2024-05-19 23:35:00.000000',00000000000000702924),('2024-05-19 23:40:00.000000',00000000000000711724),('2024-05-19 23:45:00.000000',00000000000000711724),('2024-05-19 23:50:00.000000',00000000000000717624),('2024-05-19 23:55:00.000000',00000000000000725524),('2024-05-20 00:00:00.000000',00000000000000742224),('2024-05-20 00:05:00.000000',00000000000000742224),('2024-05-20 00:10:00.000000',00000000000000747124),('2024-05-20 00:15:00.000000',00000000000000747124),('2024-05-20 00:20:00.000000',00000000000000747124),('2024-05-20 00:25:00.000000',00000000000000757024),('2024-05-20 00:30:00.000000',00000000000000757024),('2024-05-20 00:35:00.000000',00000000000000757024),('2024-05-20 00:40:00.000000',00000000000000758824),('2024-05-20 00:45:00.000000',00000000000000766724),('2024-05-20 00:50:00.000000',00000000000000774624),('2024-05-20 00:55:00.000000',00000000000000785424),('2024-05-20 01:00:00.000000',00000000000000808024),('2024-05-20 01:05:00.000000',00000000000000817724),('2024-05-20 01:10:00.000000',00000000000000817724),('2024-05-20 01:15:00.000000',00000000000000823624),('2024-05-20 01:20:00.000000',00000000000000828524),('2024-05-20 01:25:00.000000',00000000000000835324),('2024-05-20 01:30:00.000000',00000000000000842224),('2024-05-20 01:35:00.000000',00000000000000848124),('2024-05-20 01:40:00.000000',00000000000000848124),('2024-05-20 01:45:00.000000',00000000000000865924),('2024-05-20 01:50:00.000000',00000000000000873624),('2024-05-20 01:55:00.000000',00000000000000873624),('2024-05-20 02:00:00.000000',00000000000000873624),('2024-05-20 02:05:00.000000',00000000000000873624),('2024-05-20 02:10:00.000000',00000000000000888124),('2024-05-20 02:15:00.000000',00000000000000896024),('2024-05-20 02:20:00.000000',00000000000000896024),('2024-05-20 02:25:00.000000',00000000000000896024),('2024-05-20 02:30:00.000000',00000000000000905924),('2024-05-20 02:35:00.000000',00000000000000915824),('2024-05-20 02:40:00.000000',00000000000000915824),('2024-05-20 02:45:00.000000',00000000000000923724),('2024-05-20 02:50:00.000000',00000000000000923724),('2024-05-20 02:55:00.000000',00000000000000932624),('2024-05-20 03:00:00.000000',00000000000000947424),('2024-05-20 03:05:00.000000',00000000000000947424),('2024-05-20 03:10:00.000000',00000000000000947424),('2024-05-20 03:15:00.000000',00000000000000947424),('2024-05-20 03:20:00.000000',00000000000000954324),('2024-05-20 03:25:00.000000',00000000000000954324),('2024-05-20 03:30:00.000000',00000000000000972024),('2024-05-20 03:35:00.000000',00000000000000977014),('2024-05-20 03:40:00.000000',00000000000000977014),('2024-05-20 03:45:00.000000',00000000000000977014),('2024-05-20 03:50:00.000000',00000000000000982814),('2024-05-20 03:55:00.000000',00000000000000982814),('2024-05-20 04:00:00.000000',00000000000000982814),('2024-05-20 04:05:00.000000',00000000000000992714),('2024-05-20 04:10:00.000000',00000000000001000514),('2024-05-20 04:15:00.000000',00000000000001007314),('2024-05-20 04:20:00.000000',00000000000001011214),('2024-05-20 04:25:00.000000',00000000000001011214),('2024-05-20 04:30:00.000000',00000000000001018014),('2024-05-20 04:35:00.000000',00000000000001018014),('2024-05-20 04:40:00.000000',00000000000001025914),('2024-05-20 04:45:00.000000',00000000000001028094),('2024-05-20 04:50:00.000000',00000000000001037994),('2024-05-20 04:55:00.000000',00000000000001047894),('2024-05-20 05:00:00.000000',00000000000001065260),('2024-05-20 05:05:00.000000',00000000000001065260),('2024-05-20 05:10:00.000000',00000000000001065260),('2024-05-20 05:15:00.000000',00000000000001074060),('2024-05-20 05:20:00.000000',00000000000001078860),('2024-05-20 05:25:00.000000',00000000000001078860),('2024-05-20 05:30:00.000000',00000000000001088760),('2024-05-20 05:35:00.000000',00000000000001100460),('2024-05-20 05:40:00.000000',00000000000001122060),('2024-05-20 05:45:00.000000',00000000000001123246),('2024-05-20 05:50:00.000000',00000000000001123246),('2024-05-20 05:55:00.000000',00000000000001123246),('2024-05-20 06:00:00.000000',00000000000001123246),('2024-05-20 06:05:00.000000',00000000000001123246),('2024-05-20 06:10:00.000000',00000000000001131146),('2024-05-20 06:15:00.000000',00000000000001171046),('2024-05-20 06:20:00.000000',00000000000001171046),('2024-05-20 06:25:00.000000',00000000000001171046),('2024-05-20 06:30:00.000000',00000000000001171046),('2024-05-20 06:35:00.000000',00000000000001171046),('2024-05-20 06:40:00.000000',00000000000001178946),('2024-05-20 06:45:00.000000',00000000000001182746),('2024-05-20 06:50:00.000000',00000000000001182746),('2024-05-20 06:55:00.000000',00000000000001182746),('2024-05-20 07:00:00.000000',00000000000001188646),('2024-05-20 07:05:00.000000',00000000000001196546),('2024-05-20 07:10:00.000000',00000000000001205446),('2024-05-20 07:15:00.000000',00000000000001231146),('2024-05-20 07:20:00.000000',00000000000001248746),('2024-05-20 07:25:00.000000',00000000000001248746),('2024-05-20 07:30:00.000000',00000000000001248746),('2024-05-20 07:35:00.000000',00000000000001261346),('2024-05-20 07:40:00.000000',00000000000001261346),('2024-05-20 07:45:00.000000',00000000000001261346),('2024-05-20 07:50:00.000000',00000000000001299846),('2024-05-20 07:55:00.000000',00000000000001306625),('2024-05-20 08:00:00.000000',00000000000001321425),('2024-05-20 08:05:00.000000',00000000000001361325),('2024-05-20 08:10:00.000000',00000000000001361325),('2024-05-20 08:15:00.000000',00000000000001378125),('2024-05-20 08:20:00.000000',00000000000001381925),('2024-05-20 08:25:00.000000',00000000000001381925),('2024-05-20 08:30:00.000000',00000000000001381925),('2024-05-20 08:35:00.000000',00000000000001381925),('2024-05-20 08:40:00.000000',00000000000001395725),('2024-05-20 08:45:00.000000',00000000000001425625),('2024-05-20 08:50:00.000000',00000000000001425625),('2024-05-20 08:55:00.000000',00000000000001431525),('2024-05-20 09:00:00.000000',00000000000001435425),('2024-05-20 09:05:00.000000',00000000000001435425),('2024-05-20 09:10:00.000000',00000000000001443325),('2024-05-20 09:15:00.000000',00000000000001452125),('2024-05-20 09:20:00.000000',00000000000001452125),('2024-05-20 09:25:00.000000',00000000000001453125),('2024-05-20 09:30:00.000000',00000000000001472825),('2024-05-20 09:35:00.000000',00000000000001502725),('2024-05-20 09:40:00.000000',00000000000001518525),('2024-05-20 09:45:00.000000',00000000000001520525),('2024-05-20 09:50:00.000000',00000000000001521525),('2024-05-20 09:55:00.000000',00000000000001529525),('2024-05-20 10:00:00.000000',00000000000001534425),('2024-05-20 10:05:00.000000',00000000000001535425),('2024-05-20 10:10:00.000000',00000000000001536425),('2024-05-20 10:15:00.000000',00000000000001570325),('2024-05-20 10:20:00.000000',00000000000001570325),('2024-05-20 10:25:00.000000',00000000000001578225),('2024-05-20 10:30:00.000000',00000000000001588825),('2024-05-20 10:35:00.000000',00000000000001601725),('2024-05-20 10:40:00.000000',00000000000001605724),('2024-05-20 10:45:00.000000',00000000000001627424),('2024-05-20 10:50:00.000000',00000000000001654224),('2024-05-20 10:55:00.000000',00000000000001663124),('2024-05-20 11:00:00.000000',00000000000001673024),('2024-05-20 11:05:00.000000',00000000000001674024),('2024-05-20 11:10:00.000000',00000000000001675024),('2024-05-20 11:15:00.000000',00000000000001675024),('2024-05-20 11:20:00.000000',00000000000001675024),('2024-05-20 11:25:00.000000',00000000000001700724),('2024-05-20 11:30:00.000000',00000000000001736614),('2024-05-20 11:35:00.000000',00000000000001741514),('2024-05-20 11:40:00.000000',00000000000001752314),('2024-05-20 11:45:00.000000',00000000000001758314),('2024-05-20 11:50:00.000000',00000000000001788314),('2024-05-20 11:55:00.000000',00000000000001788314),('2024-05-20 12:00:00.000000',00000000000001790194),('2024-05-20 12:05:00.000000',00000000000001790194),('2024-05-20 12:10:00.000000',00000000000001835094),('2024-05-20 12:15:00.000000',00000000000001852974),('2024-05-20 12:20:00.000000',00000000000001862874),('2024-05-20 12:25:00.000000',00000000000001863874),('2024-05-20 12:30:00.000000',00000000000001868674),('2024-05-20 12:35:00.000000',00000000000001875574),('2024-05-20 12:40:00.000000',00000000000001883474),('2024-05-20 12:45:00.000000',00000000000001896364),('2024-05-20 12:50:00.000000',00000000000001903364),('2024-05-20 12:55:00.000000',00000000000001908014),('2024-05-20 13:00:00.000000',00000000000001919014),('2024-05-20 13:05:00.000000',00000000000001934804),('2024-05-20 13:10:00.000000',00000000000001935804),('2024-05-20 13:15:00.000000',00000000000001936804),('2024-05-20 13:20:00.000000',00000000000001946704),('2024-05-20 13:25:00.000000',00000000000002079104),('2024-05-20 13:30:00.000000',00000000000002079104),('2024-05-20 13:35:00.000000',00000000000002083104),('2024-05-20 13:40:00.000000',00000000000002120804),('2024-05-20 13:45:00.000000',00000000000002125704),('2024-05-20 13:50:00.000000',00000000000002127704),('2024-05-20 13:55:00.000000',00000000000002129704),('2024-05-20 14:00:00.000000',00000000000002137704),('2024-05-20 14:05:00.000000',00000000000002155504),('2024-05-20 14:10:00.000000',00000000000002163404),('2024-05-20 14:15:00.000000',00000000000002218362),('2024-05-20 14:20:00.000000',00000000000002261251),('2024-05-20 14:25:00.000000',00000000000002286297),('2024-05-20 14:30:00.000000',00000000000002301187),('2024-05-20 14:35:00.000000',00000000000002303187),('2024-05-20 14:40:00.000000',00000000000002305067),('2024-05-20 14:45:00.000000',00000000000002331767),('2024-05-20 14:50:00.000000',00000000000002342367),('2024-05-20 14:55:00.000000',00000000000002347247),('2024-05-20 15:00:00.000000',00000000000002363027),('2024-05-20 15:05:00.000000',00000000000002378827),('2024-05-20 15:10:00.000000',00000000000002390827),('2024-05-20 15:15:00.000000',00000000000002420127),('2024-05-20 15:20:00.000000',00000000000002429927),('2024-05-20 15:25:00.000000',00000000000002445127),('2024-05-20 15:30:00.000000',00000000000002458627),('2024-05-20 15:35:00.000000',00000000000002472407),('2024-05-20 15:40:00.000000',00000000000002518892),('2024-05-20 15:45:00.000000',00000000000002530978),('2024-05-20 15:50:00.000000',00000000000002548878),('2024-05-20 15:55:00.000000',00000000000002551978),('2024-05-20 16:00:00.000000',00000000000000000000),('2024-05-20 16:05:00.000000',00000000000000014900),('2024-05-20 16:10:00.000000',00000000000000027680),('2024-05-20 16:15:00.000000',00000000000000097080),('2024-05-20 16:20:00.000000',00000000000000120980),('2024-05-20 16:25:00.000000',00000000000000130980),('2024-05-20 16:30:00.000000',00000000000000148980),('2024-05-20 16:35:00.000000',00000000000000195328),('2024-05-20 16:40:00.000000',00000000000000205514),('2024-05-20 16:45:00.000000',00000000000000215514),('2024-05-20 16:50:00.000000',00000000000000233293),('2024-05-20 16:55:00.000000',00000000000000241293),('2024-05-20 17:00:00.000000',00000000000000276993),('2024-05-20 17:05:00.000000',00000000000000288793),('2024-05-20 17:10:00.000000',00000000000000302593),('2024-05-20 17:15:00.000000',00000000000000304593),('2024-05-20 17:20:00.000000',00000000000000479593),('2024-05-20 17:25:00.000000',00000000000000505393),('2024-05-20 17:30:00.000000',00000000000000517272),('2024-05-20 17:35:00.000000',00000000000000553672),('2024-05-20 17:40:00.000000',00000000000000560672),('2024-05-20 17:45:00.000000',00000000000000563672),('2024-05-20 17:50:00.000000',00000000000000569672),('2024-05-20 17:55:00.000000',00000000000000586572),('2024-05-20 18:00:00.000000',00000000000000618172),('2024-05-20 18:05:00.000000',00000000000000624972),('2024-05-20 18:10:00.000000',00000000000000625852),('2024-05-20 18:15:00.000000',00000000000000610052),('2024-05-20 18:20:00.000000',00000000000000611572),('2024-05-20 18:25:00.000000',00000000000000612572),('2024-05-20 18:30:00.000000',00000000000000618472),('2024-05-20 18:35:00.000000',00000000000000625472),('2024-05-20 18:40:00.000000',00000000000000633372),('2024-05-20 18:45:00.000000',00000000000000653072),('2024-05-20 18:50:00.000000',00000000000000654072),('2024-05-20 18:55:00.000000',00000000000000652272),('2024-05-20 19:00:00.000000',00000000000000653272),('2024-05-20 19:05:00.000000',00000000000000654272),('2024-05-20 19:10:00.000000',00000000000000697172),('2024-05-20 19:15:00.000000',00000000000000712972),('2024-05-20 19:20:00.000000',00000000000000714972),('2024-05-20 19:25:00.000000',00000000000000724872),('2024-05-20 19:30:00.000000',00000000000000724872),('2024-05-20 19:35:00.000000',00000000000000734772),('2024-05-20 19:40:00.000000',00000000000000739772),('2024-05-20 19:45:00.000000',00000000000000766372),('2024-05-20 19:50:00.000000',00000000000000758572),('2024-05-20 19:55:00.000000',00000000000000771372),('2024-05-20 20:00:00.000000',00000000000000772372),('2024-05-20 20:05:00.000000',00000000000000774372),('2024-05-20 20:10:00.000000',00000000000000774372),('2024-05-20 20:15:00.000000',00000000000000776372),('2024-05-20 20:20:00.000000',00000000000000779372),('2024-05-20 20:25:00.000000',00000000000000779372),('2024-05-20 20:30:00.000000',00000000000000782372),('2024-05-20 20:35:00.000000',00000000000000783372),('2024-05-20 20:40:00.000000',00000000000000803072),('2024-05-20 20:45:00.000000',00000000000000803072),('2024-05-20 20:50:00.000000',00000000000000812972),('2024-05-20 20:55:00.000000',00000000000000817772),('2024-05-20 21:00:00.000000',00000000000000822672),('2024-05-20 21:05:00.000000',00000000000000824672),('2024-05-20 21:10:00.000000',00000000000000824672),('2024-05-20 21:15:00.000000',00000000000000824672),('2024-05-20 21:20:00.000000',00000000000000824672),('2024-05-20 21:25:00.000000',00000000000000831672),('2024-05-20 21:30:00.000000',00000000000000832672),('2024-05-20 21:35:00.000000',00000000000000834672),('2024-05-20 21:40:00.000000',00000000000000835672),('2024-05-20 21:45:00.000000',00000000000000835672),('2024-05-20 21:50:00.000000',00000000000000835672),('2024-05-20 21:55:00.000000',00000000000000835672),('2024-05-20 22:00:00.000000',00000000000000837672),('2024-05-20 22:05:00.000000',00000000000000838672),('2024-05-20 22:10:00.000000',00000000000000840672),('2024-05-20 22:15:00.000000',00000000000000843672),('2024-05-20 22:20:00.000000',00000000000000843672),('2024-05-20 22:25:00.000000',00000000000000845672),('2024-05-20 22:30:00.000000',00000000000000847672),('2024-05-20 22:35:00.000000',00000000000000860572),('2024-05-20 22:40:00.000000',00000000000000869472),('2024-05-20 22:45:00.000000',00000000000000879372),('2024-05-20 22:50:00.000000',00000000000000896172),('2024-05-20 22:55:00.000000',00000000000000901162),('2024-05-20 23:00:00.000000',00000000000000907162),('2024-05-20 23:05:00.000000',00000000000000917862),('2024-05-20 23:10:00.000000',00000000000000917862),('2024-05-20 23:15:00.000000',00000000000000929282),('2024-05-20 23:20:00.000000',00000000000000930282),('2024-05-20 23:25:00.000000',00000000000000944182),('2024-05-20 23:30:00.000000',00000000000000945182),('2024-05-20 23:35:00.000000',00000000000000947702),('2024-05-20 23:40:00.000000',00000000000000947702),('2024-05-20 23:45:00.000000',00000000000000979302),('2024-05-20 23:50:00.000000',00000000000001020602),('2024-05-20 23:55:00.000000',00000000000001067402),('2024-05-21 00:00:00.000000',00000000000001078302),('2024-05-21 00:05:00.000000',00000000000001078302),('2024-05-21 00:10:00.000000',00000000000001078302),('2024-05-21 00:15:00.000000',00000000000001080302),('2024-05-21 00:20:00.000000',00000000000001081302),('2024-05-21 00:25:00.000000',00000000000001081302),('2024-05-21 00:30:00.000000',00000000000001082302),('2024-05-21 00:35:00.000000',00000000000001093202),('2024-05-21 00:40:00.000000',00000000000001099102),('2024-05-21 00:45:00.000000',00000000000001107002),('2024-05-21 00:50:00.000000',00000000000001107002),('2024-05-21 00:55:00.000000',00000000000001109002),('2024-05-21 01:00:00.000000',00000000000001138602),('2024-05-21 01:05:00.000000',00000000000001158302),('2024-05-21 01:10:00.000000',00000000000001161302),('2024-05-21 01:15:00.000000',00000000000001167202),('2024-05-21 01:20:00.000000',00000000000001172302),('2024-05-21 01:25:00.000000',00000000000001219202),('2024-05-21 01:30:00.000000',00000000000001224102),('2024-05-21 01:35:00.000000',00000000000001228102),('2024-05-21 01:40:00.000000',00000000000001233102),('2024-05-21 01:45:00.000000',00000000000001237102),('2024-05-21 01:50:00.000000',00000000000001258902),('2024-05-21 01:55:00.000000',00000000000001265902),('2024-05-21 02:00:00.000000',00000000000001284602),('2024-05-21 02:05:00.000000',00000000000001285602),('2024-05-21 02:10:00.000000',00000000000001299402),('2024-05-21 02:15:00.000000',00000000000001302402),('2024-05-21 02:20:00.000000',00000000000001317102),('2024-05-21 02:25:00.000000',00000000000001331902),('2024-05-21 02:30:00.000000',00000000000001335782),('2024-05-21 02:35:00.000000',00000000000001343582),('2024-05-21 02:40:00.000000',00000000000001349582),('2024-05-21 02:45:00.000000',00000000000001365282),('2024-05-21 02:50:00.000000',00000000000001370282),('2024-05-21 02:55:00.000000',00000000000001371282),('2024-05-21 03:00:00.000000',00000000000001390061),('2024-05-21 03:05:00.000000',00000000000001392061),('2024-05-21 03:10:00.000000',00000000000001405861),('2024-05-21 03:15:00.000000',00000000000001409761),('2024-05-21 03:20:00.000000',00000000000001412761),('2024-05-21 03:25:00.000000',00000000000001415761),('2024-05-21 03:30:00.000000',00000000000001418761),('2024-05-21 03:35:00.000000',00000000000001423750),('2024-05-21 03:40:00.000000',00000000000001424750),('2024-05-21 03:45:00.000000',00000000000001446450),('2024-05-21 03:50:00.000000',00000000000001451440),('2024-05-21 03:55:00.000000',00000000000001456440),('2024-05-21 04:00:00.000000',00000000000001456440),('2024-05-21 04:05:00.000000',00000000000001474040),('2024-05-21 04:10:00.000000',00000000000001477040),('2024-05-21 04:15:00.000000',00000000000001480040),('2024-05-21 04:20:00.000000',00000000000001485940),('2024-05-21 04:25:00.000000',00000000000001487940),('2024-05-21 04:30:00.000000',00000000000001495840),('2024-05-21 04:35:00.000000',00000000000001497506),('2024-05-21 04:40:00.000000',00000000000001510926),('2024-05-21 04:45:00.000000',00000000000001519826),('2024-05-21 04:50:00.000000',00000000000001521826),('2024-05-21 04:55:00.000000',00000000000001522826),('2024-05-21 05:00:00.000000',00000000000001524826),('2024-05-21 05:05:00.000000',00000000000001543626),('2024-05-21 05:10:00.000000',00000000000001547626),('2024-05-21 05:15:00.000000',00000000000001564426),('2024-05-21 05:20:00.000000',00000000000001564426),('2024-05-21 05:25:00.000000',00000000000001564426),('2024-05-21 05:30:00.000000',00000000000001568426),('2024-05-21 05:35:00.000000',00000000000001560526),('2024-05-21 05:40:00.000000',00000000000001561526),('2024-05-21 05:45:00.000000',00000000000001580406),('2024-05-21 05:50:00.000000',00000000000001581396),('2024-05-21 05:55:00.000000',00000000000001594285),('2024-05-21 06:00:00.000000',00000000000001596185),('2024-05-21 06:05:00.000000',00000000000001598185),('2024-05-21 06:10:00.000000',00000000000001599185),('2024-05-21 06:15:00.000000',00000000000001604085),('2024-05-21 06:20:00.000000',00000000000001607985),('2024-05-21 06:25:00.000000',00000000000001613885),('2024-05-21 06:30:00.000000',00000000000001614885),('2024-05-21 06:35:00.000000',00000000000001617885),('2024-05-21 06:40:00.000000',00000000000001618885),('2024-05-21 06:45:00.000000',00000000000001631685),('2024-05-21 06:50:00.000000',00000000000001634685),('2024-05-21 06:55:00.000000',00000000000001634685),('2024-05-21 07:00:00.000000',00000000000001669285),('2024-05-21 07:05:00.000000',00000000000001677185),('2024-05-21 07:10:00.000000',00000000000001678185),('2024-05-21 07:15:00.000000',00000000000001682185),('2024-05-21 07:20:00.000000',00000000000001699885),('2024-05-21 07:25:00.000000',00000000000001700885),('2024-05-21 07:30:00.000000',00000000000001702885),('2024-05-21 07:35:00.000000',00000000000001718585),('2024-05-21 07:40:00.000000',00000000000001740085),('2024-05-21 07:45:00.000000',00000000000001741085),('2024-05-21 07:50:00.000000',00000000000001742085),('2024-05-21 07:55:00.000000',00000000000001745085),('2024-05-21 08:00:00.000000',00000000000001747871),('2024-05-21 08:05:00.000000',00000000000001758947),('2024-05-21 08:10:00.000000',00000000000001763447),('2024-05-21 08:15:00.000000',00000000000001766847),('2024-05-21 08:20:00.000000',00000000000001773047),('2024-05-21 08:25:00.000000',00000000000001775347),('2024-05-21 08:30:00.000000',00000000000001777447),('2024-05-21 08:35:00.000000',00000000000001787447),('2024-05-21 08:40:00.000000',00000000000001808447),('2024-05-21 08:45:00.000000',00000000000001808447),('2024-05-21 08:50:00.000000',00000000000001808547),('2024-05-21 08:55:00.000000',00000000000001813547),('2024-05-21 09:00:00.000000',00000000000001813647),('2024-05-21 09:05:00.000000',00000000000001818647),('2024-05-21 09:10:00.000000',00000000000001818747),('2024-05-21 09:15:00.000000',00000000000001832547),('2024-05-21 09:20:00.000000',00000000000001836447),('2024-05-21 09:25:00.000000',00000000000001836547),('2024-05-21 09:30:00.000000',00000000000001851227),('2024-05-21 09:35:00.000000',00000000000001863227),('2024-05-21 09:40:00.000000',00000000000001878327),('2024-05-21 09:45:00.000000',00000000000001879427),('2024-05-21 09:50:00.000000',00000000000001890327),('2024-05-21 09:55:00.000000',00000000000001909227),('2024-05-21 10:00:00.000000',00000000000001911327),('2024-05-21 10:05:00.000000',00000000000001918727),('2024-05-21 10:10:00.000000',00000000000001920827),('2024-05-21 10:15:00.000000',00000000000001923027),('2024-05-21 10:20:00.000000',00000000000001936927),('2024-05-21 10:25:00.000000',00000000000001937927),('2024-05-21 10:30:00.000000',00000000000001948027),('2024-05-21 10:35:00.000000',00000000000001956827),('2024-05-21 10:40:00.000000',00000000000001964727),('2024-05-21 10:45:00.000000',00000000000001969717),('2024-05-21 10:50:00.000000',00000000000001973817),('2024-05-21 10:55:00.000000',00000000000002007717),('2024-05-21 11:00:00.000000',00000000000002008717),('2024-05-21 11:05:00.000000',00000000000002009717),('2024-05-21 11:10:00.000000',00000000000002013817),('2024-05-21 11:15:00.000000',00000000000002015017),('2024-05-21 11:20:00.000000',00000000000002017317),('2024-05-21 11:25:00.000000',00000000000002021317),('2024-05-21 11:30:00.000000',00000000000002023317),('2024-05-21 11:35:00.000000',00000000000002029317),('2024-05-21 11:40:00.000000',00000000000002042217),('2024-05-21 11:45:00.000000',00000000000002048217),('2024-05-21 11:50:00.000000',00000000000002094217),('2024-05-21 11:55:00.000000',00000000000002102117),('2024-05-21 12:00:00.000000',00000000000002103217),('2024-05-21 12:05:00.000000',00000000000002263317),('2024-05-21 12:10:00.000000',00000000000002265517),('2024-05-21 12:15:00.000000',00000000000002267917),('2024-05-21 12:20:00.000000',00000000000002268117),('2024-05-21 12:25:00.000000',00000000000002268317),('2024-05-21 12:30:00.000000',00000000000002273417),('2024-05-21 12:35:00.000000',00000000000002284517),('2024-05-21 12:40:00.000000',00000000000002288517),('2024-05-21 12:45:00.000000',00000000000002288517),('2024-05-21 12:50:00.000000',00000000000002304317),('2024-05-21 12:55:00.000000',00000000000002312217),('2024-05-21 13:00:00.000000',00000000000002326107),('2024-05-21 13:05:00.000000',00000000000002340997),('2024-05-21 13:10:00.000000',00000000000002341097),('2024-05-21 13:15:00.000000',00000000000002356897),('2024-05-21 13:20:00.000000',00000000000002356897),('2024-05-21 13:25:00.000000',00000000000002359897),('2024-05-21 13:30:00.000000',00000000000002359997),('2024-05-21 13:35:00.000000',00000000000002363997),('2024-05-21 13:40:00.000000',00000000000002379797),('2024-05-21 13:45:00.000000',00000000000002393597),('2024-05-21 13:50:00.000000',00000000000002393597),('2024-05-21 13:55:00.000000',00000000000002394117),('2024-05-21 14:00:00.000000',00000000000002410583),('2024-05-21 14:05:00.000000',00000000000002413583),('2024-05-21 14:10:00.000000',00000000000002418083),('2024-05-21 14:15:00.000000',00000000000002431883),('2024-05-21 14:20:00.000000',00000000000002444873),('2024-05-21 14:25:00.000000',00000000000002449873),('2024-05-21 14:30:00.000000',00000000000002455873),('2024-05-21 14:35:00.000000',00000000000002473762),('2024-05-21 14:40:00.000000',00000000000002482652),('2024-05-21 14:45:00.000000',00000000000002482752),('2024-05-21 14:50:00.000000',00000000000002493952),('2024-05-21 14:55:00.000000',00000000000002496712),('2024-05-21 15:00:00.000000',00000000000002501332),('2024-05-21 15:05:00.000000',00000000000002518198),('2024-05-21 15:10:00.000000',00000000000002525498),('2024-05-21 15:15:00.000000',00000000000002543598),('2024-05-21 15:20:00.000000',00000000000002570498),('2024-05-21 15:25:00.000000',00000000000002577598),('2024-05-21 15:30:00.000000',00000000000002581698),('2024-05-21 15:35:00.000000',00000000000002592698),('2024-05-21 15:40:00.000000',00000000000002613398),('2024-05-21 15:45:00.000000',00000000000002629398),('2024-05-21 15:50:00.000000',00000000000002635898),('2024-05-21 15:55:00.000000',00000000000002649098),('2024-05-21 16:00:00.000000',00000000000000000000),('2024-05-21 16:05:00.000000',00000000000000006000),('2024-05-21 16:10:00.000000',00000000000000031500),('2024-05-21 16:15:00.000000',00000000000000051066),('2024-05-21 16:20:00.000000',00000000000000117866),('2024-05-21 16:25:00.000000',00000000000000130266),('2024-05-21 16:30:00.000000',00000000000000161766),('2024-05-21 16:35:00.000000',00000000000000197766),('2024-05-21 16:40:00.000000',00000000000000225986),('2024-05-21 16:45:00.000000',00000000000000255776),('2024-05-21 16:50:00.000000',00000000000000268076),('2024-05-21 16:55:00.000000',00000000000000300176),('2024-05-21 17:00:00.000000',00000000000000316076),('2024-05-21 17:05:00.000000',00000000000000325976),('2024-05-21 17:10:00.000000',00000000000000338066),('2024-05-21 17:15:00.000000',00000000000000355066),('2024-05-21 17:20:00.000000',00000000000000418956),('2024-05-21 17:25:00.000000',00000000000000453956),('2024-05-21 17:30:00.000000',00000000000000477156),('2024-05-21 17:35:00.000000',00000000000000478156),('2024-05-21 17:40:00.000000',00000000000000482256),('2024-05-21 17:45:00.000000',00000000000000498446),('2024-05-21 17:50:00.000000',00000000000000515336),('2024-05-21 17:55:00.000000',00000000000000523436),('2024-05-21 18:00:00.000000',00000000000000545426),('2024-05-21 18:05:00.000000',00000000000000569526),('2024-05-21 18:10:00.000000',00000000000000596616),('2024-05-21 18:15:00.000000',00000000000000617716),('2024-05-21 18:20:00.000000',00000000000000685416),('2024-05-21 18:25:00.000000',00000000000000687716),('2024-05-21 18:30:00.000000',00000000000000703906),('2024-05-21 18:35:00.000000',00000000000000718685),('2024-05-21 18:40:00.000000',00000000000000726575),('2024-05-21 18:45:00.000000',00000000000000741465),('2024-05-21 18:50:00.000000',00000000000000743565),('2024-05-21 18:55:00.000000',00000000000000754465),('2024-05-21 19:00:00.000000',00000000000000759565),('2024-05-21 19:05:00.000000',00000000000000764565),('2024-05-21 19:10:00.000000',00000000000000767665),('2024-05-21 19:15:00.000000',00000000000000770765),('2024-05-21 19:20:00.000000',00000000000000780565),('2024-05-21 19:25:00.000000',00000000000000789755),('2024-05-21 19:30:00.000000',00000000000000791955),('2024-05-21 19:35:00.000000',00000000000000793055),('2024-05-21 19:40:00.000000',00000000000000806955),('2024-05-21 19:45:00.000000',00000000000000826945),('2024-05-21 19:50:00.000000',00000000000000843845),('2024-05-21 19:55:00.000000',00000000000000852845),('2024-05-21 20:00:00.000000',00000000000000856835),('2024-05-21 20:05:00.000000',00000000000000859135),('2024-05-21 20:10:00.000000',00000000000000865035),('2024-05-21 20:15:00.000000',00000000000000871035),('2024-05-21 20:20:00.000000',00000000000000872035),('2024-05-21 20:25:00.000000',00000000000000885735),('2024-05-21 20:30:00.000000',00000000000000886935),('2024-05-21 20:35:00.000000',00000000000000898935),('2024-05-21 20:40:00.000000',00000000000000908835),('2024-05-21 20:45:00.000000',00000000000000909835),('2024-05-21 20:50:00.000000',00000000000000911935),('2024-05-21 20:55:00.000000',00000000000000912935),('2024-05-21 21:00:00.000000',00000000000000912935),('2024-05-21 21:05:00.000000',00000000000000912935),('2024-05-21 21:10:00.000000',00000000000000912935),('2024-05-21 21:15:00.000000',00000000000000919735),('2024-05-21 21:20:00.000000',00000000000000924735),('2024-05-21 21:25:00.000000',00000000000000924735),('2024-05-21 21:30:00.000000',00000000000000924735),('2024-05-21 21:35:00.000000',00000000000000924835),('2024-05-21 21:40:00.000000',00000000000000926835),('2024-05-21 21:45:00.000000',00000000000000926835),('2024-05-21 21:50:00.000000',00000000000000928835),('2024-05-21 21:55:00.000000',00000000000000928935),('2024-05-21 22:00:00.000000',00000000000000929935),('2024-05-21 22:05:00.000000',00000000000000937835),('2024-05-21 22:10:00.000000',00000000000000937935),('2024-05-21 22:15:00.000000',00000000000000941935),('2024-05-21 22:20:00.000000',00000000000000942935),('2024-05-21 22:25:00.000000',00000000000000942935),('2024-05-21 22:30:00.000000',00000000000000943935),('2024-05-21 22:35:00.000000',00000000000000945035),('2024-05-21 22:40:00.000000',00000000000000959935),('2024-05-21 22:45:00.000000',00000000000000960935),('2024-05-21 22:50:00.000000',00000000000000961935),('2024-05-21 22:55:00.000000',00000000000000962935),('2024-05-21 23:00:00.000000',00000000000000962935),('2024-05-21 23:05:00.000000',00000000000000972935),('2024-05-21 23:10:00.000000',00000000000000981835),('2024-05-21 23:15:00.000000',00000000000000991915),('2024-05-21 23:20:00.000000',00000000000000997884),('2024-05-21 23:25:00.000000',00000000000001007774),('2024-05-21 23:30:00.000000',00000000000001014674),('2024-05-21 23:35:00.000000',00000000000001019674),('2024-05-21 23:40:00.000000',00000000000001022764),('2024-05-21 23:45:00.000000',00000000000001027664),('2024-05-21 23:50:00.000000',00000000000001057664),('2024-05-21 23:55:00.000000',00000000000001057664),('2024-05-22 00:00:00.000000',00000000000001068664),('2024-05-22 00:05:00.000000',00000000000001068664),('2024-05-22 00:10:00.000000',00000000000001076554),('2024-05-22 00:15:00.000000',00000000000001079554),('2024-05-22 00:20:00.000000',00000000000001086354),('2024-05-22 00:25:00.000000',00000000000001086354),('2024-05-22 00:30:00.000000',00000000000001104054),('2024-05-22 00:35:00.000000',00000000000001106054),('2024-05-22 00:40:00.000000',00000000000001111144),('2024-05-22 00:45:00.000000',00000000000001116044),('2024-05-22 00:50:00.000000',00000000000001116044),('2024-05-22 00:55:00.000000',00000000000001119044),('2024-05-22 01:00:00.000000',00000000000001120230),('2024-05-22 01:05:00.000000',00000000000001133398),('2024-05-22 01:10:00.000000',00000000000001138366),('2024-05-22 01:15:00.000000',00000000000001138366),('2024-05-22 01:20:00.000000',00000000000001138366),('2024-05-22 01:25:00.000000',00000000000001138366),('2024-05-22 01:30:00.000000',00000000000001138466),('2024-05-22 01:35:00.000000',00000000000001145456),('2024-05-22 01:40:00.000000',00000000000001146556),('2024-05-22 01:45:00.000000',00000000000001158356),('2024-05-22 01:50:00.000000',00000000000001159456),('2024-05-22 01:55:00.000000',00000000000001168256),('2024-05-22 02:00:00.000000',00000000000001168256),('2024-05-22 02:05:00.000000',00000000000001168256),('2024-05-22 02:10:00.000000',00000000000001168256),('2024-05-22 02:15:00.000000',00000000000001169456),('2024-05-22 02:20:00.000000',00000000000001172556),('2024-05-22 02:25:00.000000',00000000000001176556),('2024-05-22 02:30:00.000000',00000000000001177656),('2024-05-22 02:35:00.000000',00000000000001184556),('2024-05-22 02:40:00.000000',00000000000001185556),('2024-05-22 02:45:00.000000',00000000000001192356),('2024-05-22 02:50:00.000000',00000000000001200256),('2024-05-22 02:55:00.000000',00000000000001209156),('2024-05-22 03:00:00.000000',00000000000001212156),('2024-05-22 03:05:00.000000',00000000000001214256),('2024-05-22 03:10:00.000000',00000000000001217356),('2024-05-22 03:15:00.000000',00000000000001219456),('2024-05-22 03:20:00.000000',00000000000001220456),('2024-05-22 03:25:00.000000',00000000000001223356),('2024-05-22 03:30:00.000000',00000000000001262056),('2024-05-22 03:35:00.000000',00000000000001262056),('2024-05-22 03:40:00.000000',00000000000001273856),('2024-05-22 03:45:00.000000',00000000000001273856),('2024-05-22 03:50:00.000000',00000000000001273856),('2024-05-22 03:55:00.000000',00000000000001275956),('2024-05-22 04:00:00.000000',00000000000001290856),('2024-05-22 04:05:00.000000',00000000000001293756),('2024-05-22 04:10:00.000000',00000000000001293856),('2024-05-22 04:15:00.000000',00000000000001294956),('2024-05-22 04:20:00.000000',00000000000001297056),('2024-05-22 04:25:00.000000',00000000000001297056),('2024-05-22 04:30:00.000000',00000000000001301956),('2024-05-22 04:35:00.000000',00000000000001304956),('2024-05-22 04:40:00.000000',00000000000001305156),('2024-05-22 04:45:00.000000',00000000000001310056),('2024-05-22 04:50:00.000000',00000000000001319056),('2024-05-22 04:55:00.000000',00000000000001319056),('2024-05-22 05:00:00.000000',00000000000001330046),('2024-05-22 05:05:00.000000',00000000000001364036),('2024-05-22 05:10:00.000000',00000000000001376036),('2024-05-22 05:15:00.000000',00000000000001376036),('2024-05-22 05:20:00.000000',00000000000001381036),('2024-05-22 05:25:00.000000',00000000000001387026),('2024-05-22 05:30:00.000000',00000000000001393915),('2024-05-22 05:35:00.000000',00000000000001394015),('2024-05-22 05:40:00.000000',00000000000001406815),('2024-05-22 05:45:00.000000',00000000000001416794),('2024-05-22 05:50:00.000000',00000000000001425683),('2024-05-22 05:55:00.000000',00000000000001440563),('2024-05-22 06:00:00.000000',00000000000001443652),('2024-05-22 06:05:00.000000',00000000000001456651),('2024-05-22 06:10:00.000000',00000000000001460641),('2024-05-22 06:15:00.000000',00000000000001460741),('2024-05-22 06:20:00.000000',00000000000001479741),('2024-05-22 06:25:00.000000',00000000000001484641),('2024-05-22 06:30:00.000000',00000000000001506541),('2024-05-22 06:35:00.000000',00000000000001516641),('2024-05-22 06:40:00.000000',00000000000001516641),('2024-05-22 06:45:00.000000',00000000000001517641),('2024-05-22 06:50:00.000000',00000000000001524541),('2024-05-22 06:55:00.000000',00000000000001523621),('2024-05-22 07:00:00.000000',00000000000001524621),('2024-05-22 07:05:00.000000',00000000000001535521),('2024-05-22 07:10:00.000000',00000000000001535521),('2024-05-22 07:15:00.000000',00000000000001535521),('2024-05-22 07:20:00.000000',00000000000001558321),('2024-05-22 07:25:00.000000',00000000000001560321),('2024-05-22 07:30:00.000000',00000000000001560321),('2024-05-22 07:35:00.000000',00000000000001573411),('2024-05-22 07:40:00.000000',00000000000001598201),('2024-05-22 07:45:00.000000',00000000000001605301),('2024-05-22 07:50:00.000000',00000000000001607301),('2024-05-22 07:55:00.000000',00000000000001607501),('2024-05-22 08:00:00.000000',00000000000001612591),('2024-05-22 08:05:00.000000',00000000000001615581),('2024-05-22 08:10:00.000000',00000000000001615581),('2024-05-22 08:15:00.000000',00000000000001627360),('2024-05-22 08:20:00.000000',00000000000001642160),('2024-05-22 08:25:00.000000',00000000000001645960),('2024-05-22 08:30:00.000000',00000000000001658060),('2024-05-22 08:35:00.000000',00000000000001662160),('2024-05-22 08:40:00.000000',00000000000001662260),('2024-05-22 08:45:00.000000',00000000000001662260),('2024-05-22 08:50:00.000000',00000000000001663360),('2024-05-22 08:55:00.000000',00000000000001663360),('2024-05-22 09:00:00.000000',00000000000001663360),('2024-05-22 09:05:00.000000',00000000000001667260),('2024-05-22 09:10:00.000000',00000000000001669260),('2024-05-22 09:15:00.000000',00000000000001681160),('2024-05-22 09:20:00.000000',00000000000001681160),('2024-05-22 09:25:00.000000',00000000000001690825),('2024-05-22 09:30:00.000000',00000000000001690825),('2024-05-22 09:35:00.000000',00000000000001690825),('2024-05-22 09:40:00.000000',00000000000001697925),('2024-05-22 09:45:00.000000',00000000000001707825),('2024-05-22 09:50:00.000000',00000000000001710815),('2024-05-22 09:55:00.000000',00000000000001723615),('2024-05-22 10:00:00.000000',00000000000001731595),('2024-05-22 10:05:00.000000',00000000000001737595),('2024-05-22 10:10:00.000000',00000000000001749695),('2024-05-22 10:15:00.000000',00000000000001763595),('2024-05-22 10:20:00.000000',00000000000001766695),('2024-05-22 10:25:00.000000',00000000000001800395),('2024-05-22 10:30:00.000000',00000000000001800395),('2024-05-22 10:35:00.000000',00000000000001803295),('2024-05-22 10:40:00.000000',00000000000001811285),('2024-05-22 10:45:00.000000',00000000000001816275),('2024-05-22 10:50:00.000000',00000000000001851175),('2024-05-22 10:55:00.000000',00000000000001853275),('2024-05-22 11:00:00.000000',00000000000001869375),('2024-05-22 11:05:00.000000',00000000000001892165),('2024-05-22 11:10:00.000000',00000000000001903165),('2024-05-22 11:15:00.000000',00000000000001926065),('2024-05-22 11:20:00.000000',00000000000001929064),('2024-05-22 11:25:00.000000',00000000000001931054),('2024-05-22 11:30:00.000000',00000000000001954933),('2024-05-22 11:35:00.000000',00000000000001959833),('2024-05-22 11:40:00.000000',00000000000001969733),('2024-05-22 11:45:00.000000',00000000000001989533),('2024-05-22 11:50:00.000000',00000000000001990733),('2024-05-22 11:55:00.000000',00000000000001999823),('2024-05-22 12:00:00.000000',00000000000002022513),('2024-05-22 12:05:00.000000',00000000000002016379),('2024-05-22 12:10:00.000000',00000000000002019369),('2024-05-22 12:15:00.000000',00000000000002050059),('2024-05-22 12:20:00.000000',00000000000002058048),('2024-05-22 12:25:00.000000',00000000000002082848),('2024-05-22 12:30:00.000000',00000000000002092748),('2024-05-22 12:35:00.000000',00000000000002106848),('2024-05-22 12:40:00.000000',00000000000002120738),('2024-05-22 12:45:00.000000',00000000000002125737),('2024-05-22 12:50:00.000000',00000000000002130637),('2024-05-22 12:55:00.000000',00000000000002146437),('2024-05-22 13:00:00.000000',00000000000002170437),('2024-05-22 13:05:00.000000',00000000000002181637),('2024-05-22 13:10:00.000000',00000000000002193437),('2024-05-22 13:15:00.000000',00000000000002197537),('2024-05-22 13:20:00.000000',00000000000002212537),('2024-05-22 13:25:00.000000',00000000000002225327),('2024-05-22 13:30:00.000000',00000000000002228417),('2024-05-22 13:35:00.000000',00000000000002232507),('2024-05-22 13:40:00.000000',00000000000002234607),('2024-05-22 13:45:00.000000',00000000000002250607),('2024-05-22 13:50:00.000000',00000000000002260707),('2024-05-22 13:55:00.000000',00000000000002269877),('2024-05-22 14:00:00.000000',00000000000002319677),('2024-05-22 14:05:00.000000',00000000000002327577),('2024-05-22 14:10:00.000000',00000000000002327777),('2024-05-22 14:15:00.000000',00000000000002348677),('2024-05-22 14:20:00.000000',00000000000002370477),('2024-05-22 14:25:00.000000',00000000000002401177),('2024-05-22 14:30:00.000000',00000000000002419977),('2024-05-22 14:35:00.000000',00000000000002426877),('2024-05-22 14:40:00.000000',00000000000002465477),('2024-05-22 14:45:00.000000',00000000000002482267),('2024-05-22 14:50:00.000000',00000000000002534067),('2024-05-22 14:55:00.000000',00000000000002575557),('2024-05-22 15:00:00.000000',00000000000002591347),('2024-05-22 15:05:00.000000',00000000000002601347),('2024-05-22 15:10:00.000000',00000000000002616136),('2024-05-22 15:15:00.000000',00000000000002621026),('2024-05-22 15:20:00.000000',00000000000002641826),('2024-05-22 15:25:00.000000',00000000000002668726),('2024-05-22 15:30:00.000000',00000000000002681826),('2024-05-22 15:35:00.000000',00000000000002706826),('2024-05-22 15:40:00.000000',00000000000002762926),('2024-05-22 15:45:00.000000',00000000000002783926),('2024-05-22 15:50:00.000000',00000000000002800325),('2024-05-22 15:55:00.000000',00000000000002812325),('2024-05-22 16:00:00.000000',00000000000000000000),('2024-05-22 16:05:00.000000',00000000000000022880),('2024-05-22 16:10:00.000000',00000000000000040370),('2024-05-22 16:15:00.000000',00000000000000083570),('2024-05-22 16:20:00.000000',00000000000000102760),('2024-05-22 16:25:00.000000',00000000000000121840),('2024-05-22 16:30:00.000000',00000000000000135940),('2024-05-22 16:35:00.000000',00000000000000143040),('2024-05-22 16:40:00.000000',00000000000000169130),('2024-05-22 16:45:00.000000',00000000000000197130),('2024-05-22 16:50:00.000000',00000000000000225130),('2024-05-22 16:55:00.000000',00000000000000230520),('2024-05-22 17:00:00.000000',00000000000000238620),('2024-05-22 17:05:00.000000',00000000000000247620),('2024-05-22 17:10:00.000000',00000000000000257619),('2024-05-22 17:15:00.000000',00000000000000263619),('2024-05-22 17:20:00.000000',00000000000000272519),('2024-05-22 17:25:00.000000',00000000000000285239),('2024-05-22 17:30:00.000000',00000000000000304939),('2024-05-22 17:35:00.000000',00000000000000348928),('2024-05-22 17:40:00.000000',00000000000000353928),('2024-05-22 17:45:00.000000',00000000000000359128),('2024-05-22 17:50:00.000000',00000000000000364118),('2024-05-22 17:55:00.000000',00000000000000379018),('2024-05-22 18:00:00.000000',00000000000000390918),('2024-05-22 18:05:00.000000',00000000000000392117),('2024-05-22 18:10:00.000000',00000000000000395107),('2024-05-22 18:15:00.000000',00000000000000408006),('2024-05-22 18:20:00.000000',00000000000000423805),('2024-05-22 18:25:00.000000',00000000000000444905),('2024-05-22 18:30:00.000000',00000000000000463795),('2024-05-22 18:35:00.000000',00000000000000506595),('2024-05-22 18:40:00.000000',00000000000000511495),('2024-05-22 18:45:00.000000',00000000000000521395),('2024-05-22 18:50:00.000000',00000000000000515395),('2024-05-22 18:55:00.000000',00000000000000515395),('2024-05-22 19:00:00.000000',00000000000000527195),('2024-05-22 19:05:00.000000',00000000000000533095),('2024-05-22 19:10:00.000000',00000000000000534095),('2024-05-22 19:15:00.000000',00000000000000534095),('2024-05-22 19:20:00.000000',00000000000000545795),('2024-05-22 19:25:00.000000',00000000000000545795),('2024-05-22 19:30:00.000000',00000000000000545795),('2024-05-22 19:35:00.000000',00000000000000545795),('2024-05-22 19:40:00.000000',00000000000000550695),('2024-05-22 19:45:00.000000',00000000000000554685),('2024-05-22 19:50:00.000000',00000000000000570485),('2024-05-22 19:55:00.000000',00000000000000595085),('2024-05-22 20:00:00.000000',00000000000000599085),('2024-05-22 20:05:00.000000',00000000000000599085),('2024-05-22 20:10:00.000000',00000000000000599085),('2024-05-22 20:15:00.000000',00000000000000599885),('2024-05-22 20:20:00.000000',00000000000000604685),('2024-05-22 20:25:00.000000',00000000000000607675),('2024-05-22 20:30:00.000000',00000000000000607675),('2024-05-22 20:35:00.000000',00000000000000618475),('2024-05-22 20:40:00.000000',00000000000000620475),('2024-05-22 20:45:00.000000',00000000000000622475),('2024-05-22 20:50:00.000000',00000000000000641175),('2024-05-22 20:55:00.000000',00000000000000641175),('2024-05-22 21:00:00.000000',00000000000000641175),('2024-05-22 21:05:00.000000',00000000000000641175),('2024-05-22 21:10:00.000000',00000000000000641175),('2024-05-22 21:15:00.000000',00000000000000641175),('2024-05-22 21:20:00.000000',00000000000000644165),('2024-05-22 21:25:00.000000',00000000000000645155),('2024-05-22 21:30:00.000000',00000000000000649135),('2024-05-22 21:35:00.000000',00000000000000660935),('2024-05-22 21:40:00.000000',00000000000000660935),('2024-05-22 21:45:00.000000',00000000000000669735),('2024-05-22 21:50:00.000000',00000000000000679635),('2024-05-22 21:55:00.000000',00000000000000679635),('2024-05-22 22:00:00.000000',00000000000000679635),('2024-05-22 22:05:00.000000',00000000000000679635),('2024-05-22 22:10:00.000000',00000000000000679635),('2024-05-22 22:15:00.000000',00000000000000679635),('2024-05-22 22:20:00.000000',00000000000000679635),('2024-05-22 22:25:00.000000',00000000000000690535),('2024-05-22 22:30:00.000000',00000000000000690535),('2024-05-22 22:35:00.000000',00000000000000690535),('2024-05-22 22:40:00.000000',00000000000000691535),('2024-05-22 22:45:00.000000',00000000000000692635),('2024-05-22 22:50:00.000000',00000000000000692735),('2024-05-22 22:55:00.000000',00000000000000701535),('2024-05-22 23:00:00.000000',00000000000000701535),('2024-05-22 23:05:00.000000',00000000000000707435),('2024-05-22 23:10:00.000000',00000000000000721235),('2024-05-22 23:15:00.000000',00000000000000721235),('2024-05-22 23:20:00.000000',00000000000000721235),('2024-05-22 23:25:00.000000',00000000000000721235),('2024-05-22 23:30:00.000000',00000000000000727235),('2024-05-22 23:35:00.000000',00000000000000736035),('2024-05-22 23:40:00.000000',00000000000000736035),('2024-05-22 23:45:00.000000',00000000000000736035),('2024-05-22 23:50:00.000000',00000000000000750835),('2024-05-22 23:55:00.000000',00000000000000760735),('2024-05-23 00:00:00.000000',00000000000000761835),('2024-05-23 00:05:00.000000',00000000000000797635),('2024-05-23 00:10:00.000000',00000000000000797635),('2024-05-23 00:15:00.000000',00000000000000798735),('2024-05-23 00:20:00.000000',00000000000000798735),('2024-05-23 00:25:00.000000',00000000000000801734),('2024-05-23 00:30:00.000000',00000000000000822534),('2024-05-23 00:35:00.000000',00000000000000841124),('2024-05-23 00:40:00.000000',00000000000000853824),('2024-05-23 00:45:00.000000',00000000000000858824),('2024-05-23 00:50:00.000000',00000000000000858824),('2024-05-23 00:55:00.000000',00000000000000862824),('2024-05-23 01:00:00.000000',00000000000000867824),('2024-05-23 01:05:00.000000',00000000000000867824),('2024-05-23 01:10:00.000000',00000000000000870914),('2024-05-23 01:15:00.000000',00000000000000880914),('2024-05-23 01:20:00.000000',00000000000000881914),('2024-05-23 01:25:00.000000',00000000000000881914),('2024-05-23 01:30:00.000000',00000000000000887814),('2024-05-23 01:35:00.000000',00000000000000914513),('2024-05-23 01:40:00.000000',00000000000000916613),('2024-05-23 01:45:00.000000',00000000000000916613),('2024-05-23 01:50:00.000000',00000000000000934413),('2024-05-23 01:55:00.000000',00000000000000943313),('2024-05-23 02:00:00.000000',00000000000000949213),('2024-05-23 02:05:00.000000',00000000000000951213),('2024-05-23 02:10:00.000000',00000000000000962113),('2024-05-23 02:15:00.000000',00000000000000962213),('2024-05-23 02:20:00.000000',00000000000000967113),('2024-05-23 02:25:00.000000',00000000000000972013),('2024-05-23 02:30:00.000000',00000000000000974013),('2024-05-23 02:35:00.000000',00000000000000974013),('2024-05-23 02:40:00.000000',00000000000000979003),('2024-05-23 02:45:00.000000',00000000000001002803),('2024-05-23 02:50:00.000000',00000000000001002803),('2024-05-23 02:55:00.000000',00000000000001020603),('2024-05-23 03:00:00.000000',00000000000001020603),('2024-05-23 03:05:00.000000',00000000000001036502),('2024-05-23 03:10:00.000000',00000000000001043302),('2024-05-23 03:15:00.000000',00000000000001043302),('2024-05-23 03:20:00.000000',00000000000001048402),('2024-05-23 03:25:00.000000',00000000000001054402),('2024-05-23 03:30:00.000000',00000000000001073102),('2024-05-23 03:35:00.000000',00000000000001073202),('2024-05-23 03:40:00.000000',00000000000001136002),('2024-05-23 03:45:00.000000',00000000000001147792),('2024-05-23 03:50:00.000000',00000000000001158692),('2024-05-23 03:55:00.000000',00000000000001168792),('2024-05-23 04:00:00.000000',00000000000001170792),('2024-05-23 04:05:00.000000',00000000000001174692),('2024-05-23 04:10:00.000000',00000000000001178592),('2024-05-23 04:15:00.000000',00000000000001178592),('2024-05-23 04:20:00.000000',00000000000001188492),('2024-05-23 04:25:00.000000',00000000000001194392),('2024-05-23 04:30:00.000000',00000000000001201292),('2024-05-23 04:35:00.000000',00000000000001211292),('2024-05-23 04:40:00.000000',00000000000001222192),('2024-05-23 04:45:00.000000',00000000000001237992),('2024-05-23 04:50:00.000000',00000000000001247892),('2024-05-23 04:55:00.000000',00000000000001256692),('2024-05-23 05:00:00.000000',00000000000001266592),('2024-05-23 05:05:00.000000',00000000000001315372),('2024-05-23 05:10:00.000000',00000000000001315372),('2024-05-23 05:15:00.000000',00000000000001545272),('2024-05-23 05:20:00.000000',00000000000001575372),('2024-05-23 05:25:00.000000',00000000000001589672),('2024-05-23 05:30:00.000000',00000000000001598572),('2024-05-23 05:35:00.000000',00000000000001612562),('2024-05-23 05:40:00.000000',00000000000001618552),('2024-05-23 05:45:00.000000',00000000000001624552),('2024-05-23 05:50:00.000000',00000000000001626552),('2024-05-23 05:55:00.000000',00000000000001626552),('2024-05-23 06:00:00.000000',00000000000001637352),('2024-05-23 06:05:00.000000',00000000000001644352),('2024-05-23 06:10:00.000000',00000000000001644452),('2024-05-23 06:15:00.000000',00000000000001655442),('2024-05-23 06:20:00.000000',00000000000001673132),('2024-05-23 06:25:00.000000',00000000000001675132),('2024-05-23 06:30:00.000000',00000000000001675132),('2024-05-23 06:35:00.000000',00000000000001701922),('2024-05-23 06:40:00.000000',00000000000001722522),('2024-05-23 06:45:00.000000',00000000000001724522),('2024-05-23 06:50:00.000000',00000000000001728512),('2024-05-23 06:55:00.000000',00000000000001731511),('2024-05-23 07:00:00.000000',00000000000001740311),('2024-05-23 07:05:00.000000',00000000000001756111),('2024-05-23 07:10:00.000000',00000000000001766011),('2024-05-23 07:15:00.000000',00000000000001768011),('2024-05-23 07:20:00.000000',00000000000001773911),('2024-05-23 07:25:00.000000',00000000000001773911),('2024-05-23 07:30:00.000000',00000000000001773911),('2024-05-23 07:35:00.000000',00000000000001779890),('2024-05-23 07:40:00.000000',00000000000001792690),('2024-05-23 07:45:00.000000',00000000000001786890),('2024-05-23 07:50:00.000000',00000000000001794790),('2024-05-23 07:55:00.000000',00000000000001794890),('2024-05-23 08:00:00.000000',00000000000001801790),('2024-05-23 08:05:00.000000',00000000000001806780),('2024-05-23 08:10:00.000000',00000000000001806780),('2024-05-23 08:15:00.000000',00000000000001806880),('2024-05-23 08:20:00.000000',00000000000001806880),('2024-05-23 08:25:00.000000',00000000000001840360),('2024-05-23 08:30:00.000000',00000000000001846260),('2024-05-23 08:35:00.000000',00000000000001844260),('2024-05-23 08:40:00.000000',00000000000001848250),('2024-05-23 08:45:00.000000',00000000000001856150),('2024-05-23 08:50:00.000000',00000000000001856150),('2024-05-23 08:55:00.000000',00000000000001856150),('2024-05-23 09:00:00.000000',00000000000001856250),('2024-05-23 09:05:00.000000',00000000000001856250),('2024-05-23 09:10:00.000000',00000000000001860150),('2024-05-23 09:15:00.000000',00000000000001876249),('2024-05-23 09:20:00.000000',00000000000001880339),('2024-05-23 09:25:00.000000',00000000000001877449),('2024-05-23 09:30:00.000000',00000000000001884439),('2024-05-23 09:35:00.000000',00000000000001887639),('2024-05-23 09:40:00.000000',00000000000001904719),('2024-05-23 09:45:00.000000',00000000000001922498),('2024-05-23 09:50:00.000000',00000000000001928498),('2024-05-23 09:55:00.000000',00000000000001929498),('2024-05-23 10:00:00.000000',00000000000001936398),('2024-05-23 10:05:00.000000',00000000000001943397),('2024-05-23 10:10:00.000000',00000000000001943397),('2024-05-23 10:15:00.000000',00000000000001946497),('2024-05-23 10:20:00.000000',00000000000001950596),('2024-05-23 10:25:00.000000',00000000000001976396),('2024-05-23 10:30:00.000000',00000000000001986396),('2024-05-23 10:35:00.000000',00000000000002002086),('2024-05-23 10:40:00.000000',00000000000002022086),('2024-05-23 10:45:00.000000',00000000000002029176),('2024-05-23 10:50:00.000000',00000000000002032276),('2024-05-23 10:55:00.000000',00000000000002033376),('2024-05-23 11:00:00.000000',00000000000002033376),('2024-05-23 11:05:00.000000',00000000000002040266),('2024-05-23 11:10:00.000000',00000000000002043366),('2024-05-23 11:15:00.000000',00000000000002044466),('2024-05-23 11:20:00.000000',00000000000002054366),('2024-05-23 11:25:00.000000',00000000000002043466),('2024-05-23 11:30:00.000000',00000000000002064966),('2024-05-23 11:35:00.000000',00000000000002066066),('2024-05-23 11:40:00.000000',00000000000002067166),('2024-05-23 11:45:00.000000',00000000000002080166),('2024-05-23 11:50:00.000000',00000000000002086066),('2024-05-23 11:55:00.000000',00000000000002108856),('2024-05-23 12:00:00.000000',00000000000002109856),('2024-05-23 12:05:00.000000',00000000000002118436),('2024-05-23 12:10:00.000000',00000000000002119436),('2024-05-23 12:15:00.000000',00000000000002135236),('2024-05-23 12:20:00.000000',00000000000002149226),('2024-05-23 12:25:00.000000',00000000000002175726),('2024-05-23 12:30:00.000000',00000000000002195426),('2024-05-23 12:35:00.000000',00000000000002198426),('2024-05-23 12:40:00.000000',00000000000002200626),('2024-05-23 12:45:00.000000',00000000000002202626),('2024-05-23 12:50:00.000000',00000000000002217526),('2024-05-23 12:55:00.000000',00000000000002226326),('2024-05-23 13:00:00.000000',00000000000002251306),('2024-05-23 13:05:00.000000',00000000000002255206),('2024-05-23 13:10:00.000000',00000000000002275606),('2024-05-23 13:15:00.000000',00000000000002282806),('2024-05-23 13:20:00.000000',00000000000002299606),('2024-05-23 13:25:00.000000',00000000000002321206),('2024-05-23 13:30:00.000000',00000000000002334006),('2024-05-23 13:35:00.000000',00000000000002343906),('2024-05-23 13:40:00.000000',00000000000002356796),('2024-05-23 13:45:00.000000',00000000000002363496),('2024-05-23 13:50:00.000000',00000000000002381364),('2024-05-23 13:55:00.000000',00000000000002405964),('2024-05-23 14:00:00.000000',00000000000002411943),('2024-05-23 14:05:00.000000',00000000000002415943),('2024-05-23 14:10:00.000000',00000000000002426243),('2024-05-23 14:15:00.000000',00000000000002455443),('2024-05-23 14:20:00.000000',00000000000002545333),('2024-05-23 14:25:00.000000',00000000000002561222),('2024-05-23 14:30:00.000000',00000000000002568121),('2024-05-23 14:35:00.000000',00000000000002574021),('2024-05-23 14:40:00.000000',00000000000002581811),('2024-05-23 14:45:00.000000',00000000000002611411),('2024-05-23 14:50:00.000000',00000000000002633210),('2024-05-23 14:55:00.000000',00000000000002652210),('2024-05-23 15:00:00.000000',00000000000002674710),('2024-05-23 15:05:00.000000',00000000000002683599),('2024-05-23 15:10:00.000000',00000000000002712488),('2024-05-23 15:15:00.000000',00000000000002746467),('2024-05-23 15:20:00.000000',00000000000002760867),('2024-05-23 15:25:00.000000',00000000000002788766),('2024-05-23 15:30:00.000000',00000000000002819266),('2024-05-23 15:35:00.000000',00000000000002826366),('2024-05-23 15:40:00.000000',00000000000002842266),('2024-05-23 15:45:00.000000',00000000000002850566),('2024-05-23 15:50:00.000000',00000000000002881765),('2024-05-23 15:55:00.000000',00000000000002889765),('2024-05-23 16:00:00.000000',00000000000000000000),('2024-05-23 16:05:00.000000',00000000000000024869),('2024-05-23 16:10:00.000000',00000000000000027969),('2024-05-23 16:15:00.000000',00000000000000047869),('2024-05-23 16:20:00.000000',00000000000000056969),('2024-05-23 16:25:00.000000',00000000000000076659),('2024-05-23 16:30:00.000000',00000000000000077759),('2024-05-23 16:35:00.000000',00000000000000107159),('2024-05-23 16:40:00.000000',00000000000000114059),('2024-05-23 16:45:00.000000',00000000000000124859),('2024-05-23 16:50:00.000000',00000000000000129959),('2024-05-23 16:55:00.000000',00000000000000153958),('2024-05-23 17:00:00.000000',00000000000000186658),('2024-05-23 17:05:00.000000',00000000000000195648),('2024-05-23 17:10:00.000000',00000000000000208548),('2024-05-23 17:15:00.000000',00000000000000229348),('2024-05-23 17:20:00.000000',00000000000000253538),('2024-05-23 17:25:00.000000',00000000000000298527),('2024-05-23 17:30:00.000000',00000000000000310527),('2024-05-23 17:35:00.000000',00000000000000328127),('2024-05-23 17:40:00.000000',00000000000000346017),('2024-05-23 17:45:00.000000',00000000000000370817),('2024-05-23 17:50:00.000000',00000000000000401517),('2024-05-23 17:55:00.000000',00000000000000442517),('2024-05-23 18:00:00.000000',00000000000000455217),('2024-05-23 18:05:00.000000',00000000000000457217),('2024-05-23 18:10:00.000000',00000000000000460417),('2024-05-23 18:15:00.000000',00000000000000470417),('2024-05-23 18:20:00.000000',00000000000000475517),('2024-05-23 18:25:00.000000',00000000000000524517),('2024-05-23 18:30:00.000000',00000000000000526517),('2024-05-23 18:35:00.000000',00000000000000538417),('2024-05-23 18:40:00.000000',00000000000000547417),('2024-05-23 18:45:00.000000',00000000000000565397),('2024-05-23 18:50:00.000000',00000000000000576397),('2024-05-23 18:55:00.000000',00000000000000582797),('2024-05-23 19:00:00.000000',00000000000000584877),('2024-05-23 19:05:00.000000',00000000000000585877),('2024-05-23 19:10:00.000000',00000000000000590877),('2024-05-23 19:15:00.000000',00000000000000600877),('2024-05-23 19:20:00.000000',00000000000000606477),('2024-05-23 19:25:00.000000',00000000000000608677),('2024-05-23 19:30:00.000000',00000000000000609677),('2024-05-23 19:35:00.000000',00000000000000619577),('2024-05-23 19:40:00.000000',00000000000000619577),('2024-05-23 19:45:00.000000',00000000000000619577),('2024-05-23 19:50:00.000000',00000000000000625577),('2024-05-23 19:55:00.000000',00000000000000626677),('2024-05-23 20:00:00.000000',00000000000000629677),('2024-05-23 20:05:00.000000',00000000000000633867),('2024-05-23 20:10:00.000000',00000000000000633867),('2024-05-23 20:15:00.000000',00000000000000641767),('2024-05-23 20:20:00.000000',00000000000000657767),('2024-05-23 20:25:00.000000',00000000000000687667),('2024-05-23 20:30:00.000000',00000000000000688667),('2024-05-23 20:35:00.000000',00000000000000696557),('2024-05-23 20:40:00.000000',00000000000000697757),('2024-05-23 20:45:00.000000',00000000000000706735),('2024-05-23 20:50:00.000000',00000000000000707735),('2024-05-23 20:55:00.000000',00000000000000711491),('2024-05-23 21:00:00.000000',00000000000000714291),('2024-05-23 21:05:00.000000',00000000000000715291),('2024-05-23 21:10:00.000000',00000000000000724191),('2024-05-23 21:15:00.000000',00000000000000729290),('2024-05-23 21:20:00.000000',00000000000000732390),('2024-05-23 21:25:00.000000',00000000000000742290),('2024-05-23 21:30:00.000000',00000000000000744290),('2024-05-23 21:35:00.000000',00000000000000746290),('2024-05-23 21:40:00.000000',00000000000000756190),('2024-05-23 21:45:00.000000',00000000000000758190),('2024-05-23 21:50:00.000000',00000000000000759390),('2024-05-23 21:55:00.000000',00000000000000760390),('2024-05-23 22:00:00.000000',00000000000000760490),('2024-05-23 22:05:00.000000',00000000000000762490),('2024-05-23 22:10:00.000000',00000000000000762490),('2024-05-23 22:15:00.000000',00000000000000764590),('2024-05-23 22:20:00.000000',00000000000000769590),('2024-05-23 22:25:00.000000',00000000000000775690),('2024-05-23 22:30:00.000000',00000000000000776690),('2024-05-23 22:35:00.000000',00000000000000777790),('2024-05-23 22:40:00.000000',00000000000000784690),('2024-05-23 22:45:00.000000',00000000000000785690),('2024-05-23 22:50:00.000000',00000000000000786790),('2024-05-23 22:55:00.000000',00000000000000789790),('2024-05-23 23:00:00.000000',00000000000000812490),('2024-05-23 23:05:00.000000',00000000000000829290),('2024-05-23 23:10:00.000000',00000000000000838380),('2024-05-23 23:15:00.000000',00000000000000838380),('2024-05-23 23:20:00.000000',00000000000000839380),('2024-05-23 23:25:00.000000',00000000000000842480),('2024-05-23 23:30:00.000000',00000000000000846580),('2024-05-23 23:35:00.000000',00000000000000851780),('2024-05-23 23:40:00.000000',00000000000000858970),('2024-05-23 23:45:00.000000',00000000000000862070),('2024-05-23 23:50:00.000000',00000000000000877170),('2024-05-23 23:55:00.000000',00000000000000891269),('2024-05-24 00:00:00.000000',00000000000000903169),('2024-05-24 00:05:00.000000',00000000000000907369),('2024-05-24 00:10:00.000000',00000000000000909369),('2024-05-24 00:15:00.000000',00000000000000912369),('2024-05-24 00:20:00.000000',00000000000000915469),('2024-05-24 00:25:00.000000',00000000000000938369),('2024-05-24 00:30:00.000000',00000000000000945969),('2024-05-24 00:35:00.000000',00000000000000955059),('2024-05-24 00:40:00.000000',00000000000000956159),('2024-05-24 00:45:00.000000',00000000000000959159),('2024-05-24 00:50:00.000000',00000000000000964158),('2024-05-24 00:55:00.000000',00000000000000966158),('2024-05-24 01:00:00.000000',00000000000000973058),('2024-05-24 01:05:00.000000',00000000000000980258),('2024-05-24 01:10:00.000000',00000000000001017358),('2024-05-24 01:15:00.000000',00000000000001057057),('2024-05-24 01:20:00.000000',00000000000001066057),('2024-05-24 01:25:00.000000',00000000000001076457),('2024-05-24 01:30:00.000000',00000000000001087357),('2024-05-24 01:35:00.000000',00000000000001097457),('2024-05-24 01:40:00.000000',00000000000001109657),('2024-05-24 01:45:00.000000',00000000000001124757),('2024-05-24 01:50:00.000000',00000000000001136857),('2024-05-24 01:55:00.000000',00000000000001153757),('2024-05-24 02:00:00.000000',00000000000001167557),('2024-05-24 02:05:00.000000',00000000000001151957),('2024-05-24 02:10:00.000000',00000000000001159957),('2024-05-24 02:15:00.000000',00000000000001169157),('2024-05-24 02:20:00.000000',00000000000001178257),('2024-05-24 02:25:00.000000',00000000000001185357),('2024-05-24 02:30:00.000000',00000000000001189757),('2024-05-24 02:35:00.000000',00000000000001196756),('2024-05-24 02:40:00.000000',00000000000001204056),('2024-05-24 02:45:00.000000',00000000000001214856),('2024-05-24 02:50:00.000000',00000000000001259755),('2024-05-24 02:55:00.000000',00000000000001275655),('2024-05-24 03:00:00.000000',00000000000001361445),('2024-05-24 03:05:00.000000',00000000000001361445),('2024-05-24 03:10:00.000000',00000000000001366435),('2024-05-24 03:15:00.000000',00000000000001400925),('2024-05-24 03:20:00.000000',00000000000001410325),('2024-05-24 03:25:00.000000',00000000000001424615),('2024-05-24 03:30:00.000000',00000000000001445405),('2024-05-24 03:35:00.000000',00000000000001450595),('2024-05-24 03:40:00.000000',00000000000001460595),('2024-05-24 03:45:00.000000',00000000000001466595),('2024-05-24 03:50:00.000000',00000000000001492495),('2024-05-24 03:55:00.000000',00000000000001502385),('2024-05-24 04:00:00.000000',00000000000001504385),('2024-05-24 04:05:00.000000',00000000000001510485),('2024-05-24 04:10:00.000000',00000000000001523575),('2024-05-24 04:15:00.000000',00000000000001525775),('2024-05-24 04:20:00.000000',00000000000001546865),('2024-05-24 04:25:00.000000',00000000000001565345),('2024-05-24 04:30:00.000000',00000000000001575435),('2024-05-24 04:35:00.000000',00000000000001590625),('2024-05-24 04:40:00.000000',00000000000001605525),('2024-05-24 04:45:00.000000',00000000000001625415),('2024-05-24 04:50:00.000000',00000000000001646305),('2024-05-24 04:55:00.000000',00000000000001665095),('2024-05-24 05:00:00.000000',00000000000001699775),('2024-05-24 05:05:00.000000',00000000000001714975),('2024-05-24 05:10:00.000000',00000000000001727955),('2024-05-24 05:15:00.000000',00000000000001756045),('2024-05-24 05:20:00.000000',00000000000001779814),('2024-05-24 05:25:00.000000',00000000000001810814),('2024-05-24 05:30:00.000000',00000000000001844493),('2024-05-24 05:35:00.000000',00000000000001859373),('2024-05-24 05:40:00.000000',00000000000001870463),('2024-05-24 05:45:00.000000',00000000000001874653),('2024-05-24 05:50:00.000000',00000000000001892353),('2024-05-24 05:55:00.000000',00000000000001894453),('2024-05-24 06:00:00.000000',00000000000001894453),('2024-05-24 06:05:00.000000',00000000000001898553),('2024-05-24 06:10:00.000000',00000000000001898553),('2024-05-24 06:15:00.000000',00000000000001906453),('2024-05-24 06:20:00.000000',00000000000001911453),('2024-05-24 06:25:00.000000',00000000000001914443),('2024-05-24 06:30:00.000000',00000000000001930332),('2024-05-24 06:35:00.000000',00000000000001936977),('2024-05-24 06:40:00.000000',00000000000001939077),('2024-05-24 06:45:00.000000',00000000000001969176),('2024-05-24 06:50:00.000000',00000000000001978156),('2024-05-24 06:55:00.000000',00000000000001988135),('2024-05-24 07:00:00.000000',00000000000002003125),('2024-05-24 07:05:00.000000',00000000000002022905),('2024-05-24 07:10:00.000000',00000000000002034905),('2024-05-24 07:15:00.000000',00000000000002047805),('2024-05-24 07:20:00.000000',00000000000002091705),('2024-05-24 07:25:00.000000',00000000000002091705),('2024-05-24 07:30:00.000000',00000000000002094695),('2024-05-24 07:35:00.000000',00000000000002117395),('2024-05-24 07:40:00.000000',00000000000002120495),('2024-05-24 07:45:00.000000',00000000000002122595),('2024-05-24 07:50:00.000000',00000000000002132594),('2024-05-24 07:55:00.000000',00000000000002139594),('2024-05-24 08:00:00.000000',00000000000002159194),('2024-05-24 08:05:00.000000',00000000000002161095),('2024-05-24 08:10:00.000000',00000000000002176895),('2024-05-24 08:15:00.000000',00000000000002176895),('2024-05-24 08:20:00.000000',00000000000002181895),('2024-05-24 08:25:00.000000',00000000000002182995),('2024-05-24 08:30:00.000000',00000000000002190085),('2024-05-24 08:35:00.000000',00000000000002214775),('2024-05-24 08:40:00.000000',00000000000002219855),('2024-05-24 08:45:00.000000',00000000000002224855),('2024-05-24 08:50:00.000000',00000000000002225945),('2024-05-24 08:55:00.000000',00000000000002247635),('2024-05-24 09:00:00.000000',00000000000002263435),('2024-05-24 09:05:00.000000',00000000000002264525),('2024-05-24 09:10:00.000000',00000000000002289515),('2024-05-24 09:15:00.000000',00000000000002316205),('2024-05-24 09:20:00.000000',00000000000002328155),('2024-05-24 09:25:00.000000',00000000000002337344),('2024-05-24 09:30:00.000000',00000000000002353133),('2024-05-24 09:35:00.000000',00000000000002372011),('2024-05-24 09:40:00.000000',00000000000002389801),('2024-05-24 09:45:00.000000',00000000000002403691),('2024-05-24 09:50:00.000000',00000000000002390891),('2024-05-24 09:55:00.000000',00000000000002400880),('2024-05-24 10:00:00.000000',00000000000002415670),('2024-05-24 10:05:00.000000',00000000000002418660),('2024-05-24 10:10:00.000000',00000000000002433460),('2024-05-24 10:15:00.000000',00000000000002440349),('2024-05-24 10:20:00.000000',00000000000002446427),('2024-05-24 10:25:00.000000',00000000000002449427),('2024-05-24 10:30:00.000000',00000000000002451527),('2024-05-24 10:35:00.000000',00000000000002506216),('2024-05-24 10:40:00.000000',00000000000002508216),('2024-05-24 10:45:00.000000',00000000000002511206),('2024-05-24 10:50:00.000000',00000000000002523996),('2024-05-24 10:55:00.000000',00000000000002534086),('2024-05-24 11:00:00.000000',00000000000002551764),('2024-05-24 11:05:00.000000',00000000000002559764),('2024-05-24 11:10:00.000000',00000000000002559764),('2024-05-24 11:15:00.000000',00000000000002565653),('2024-05-24 11:20:00.000000',00000000000002576953),('2024-05-24 11:25:00.000000',00000000000002586732),('2024-05-24 11:30:00.000000',00000000000002598621),('2024-05-24 11:35:00.000000',00000000000002608521),('2024-05-24 11:40:00.000000',00000000000002623521),('2024-05-24 11:45:00.000000',00000000000002624621),('2024-05-24 11:50:00.000000',00000000000002643609),('2024-05-24 11:55:00.000000',00000000000002659688),('2024-05-24 12:00:00.000000',00000000000002665766),('2024-05-24 12:05:00.000000',00000000000002680665),('2024-05-24 12:10:00.000000',00000000000002692665),('2024-05-24 12:15:00.000000',00000000000002710465),('2024-05-24 12:20:00.000000',00000000000002735454),('2024-05-24 12:25:00.000000',00000000000002749331),('2024-05-24 12:30:00.000000',00000000000002791820),('2024-05-24 12:35:00.000000',00000000000002846519),('2024-05-24 12:40:00.000000',00000000000002854508),('2024-05-24 12:45:00.000000',00000000000002855508),('2024-05-24 12:50:00.000000',00000000000002856508),('2024-05-24 12:55:00.000000',00000000000002863476),('2024-05-24 13:00:00.000000',00000000000002870565),('2024-05-24 13:05:00.000000',00000000000002883565),('2024-05-24 13:10:00.000000',00000000000002898265),('2024-05-24 13:15:00.000000',00000000000002918065),('2024-05-24 13:20:00.000000',00000000000002936765),('2024-05-24 13:25:00.000000',00000000000003016565),('2024-05-24 13:30:00.000000',00000000000003046965),('2024-05-24 13:35:00.000000',00000000000003049955),('2024-05-24 13:40:00.000000',00000000000003068755),('2024-05-24 13:45:00.000000',00000000000003093444),('2024-05-24 13:50:00.000000',00000000000003127032),('2024-05-24 13:55:00.000000',00000000000003128032),('2024-05-24 14:00:00.000000',00000000000003132122),('2024-05-24 14:05:00.000000',00000000000003138102),('2024-05-24 14:10:00.000000',00000000000003147790),('2024-05-24 14:15:00.000000',00000000000003306790),('2024-05-24 14:20:00.000000',00000000000003307890),('2024-05-24 14:25:00.000000',00000000000003319890),('2024-05-24 14:30:00.000000',00000000000003319890),('2024-05-24 14:35:00.000000',00000000000003323980),('2024-05-24 14:40:00.000000',00000000000003327080),('2024-05-24 14:45:00.000000',00000000000003327080),('2024-05-24 14:50:00.000000',00000000000003351870),('2024-05-24 14:55:00.000000',00000000000003374458),('2024-05-24 15:00:00.000000',00000000000003389946),('2024-05-24 15:05:00.000000',00000000000003401846),('2024-05-24 15:10:00.000000',00000000000003408746),('2024-05-24 15:15:00.000000',00000000000003446446),('2024-05-24 15:20:00.000000',00000000000003453334),('2024-05-24 15:25:00.000000',00000000000003470234),('2024-05-24 15:30:00.000000',00000000000003484033),('2024-05-24 15:35:00.000000',00000000000003495933),('2024-05-24 15:40:00.000000',00000000000003507833),('2024-05-24 15:45:00.000000',00000000000003521823),('2024-05-24 15:50:00.000000',00000000000003532723),('2024-05-24 15:55:00.000000',00000000000003549523),('2024-05-24 16:00:00.000000',00000000000000000000),('2024-05-24 16:05:00.000000',00000000000000027578),('2024-05-24 16:10:00.000000',00000000000000047468),('2024-05-24 16:15:00.000000',00000000000000059468),('2024-05-24 16:20:00.000000',00000000000000095148),('2024-05-24 16:25:00.000000',00000000000000114850),('2024-05-24 16:30:00.000000',00000000000000132030),('2024-05-24 16:35:00.000000',00000000000000147786),('2024-05-24 16:40:00.000000',00000000000000162685),('2024-05-24 16:45:00.000000',00000000000000170664),('2024-05-24 16:50:00.000000',00000000000000193644),('2024-05-24 16:55:00.000000',00000000000000206834),('2024-05-24 17:00:00.000000',00000000000000221834),('2024-05-24 17:05:00.000000',00000000000000228024),('2024-05-24 17:10:00.000000',00000000000000236034),('2024-05-24 17:15:00.000000',00000000000000246124),('2024-05-24 17:20:00.000000',00000000000000252214),('2024-05-24 17:25:00.000000',00000000000000256194),('2024-05-24 17:30:00.000000',00000000000000261304),('2024-05-24 17:35:00.000000',00000000000000262404),('2024-05-24 17:40:00.000000',00000000000000278504),('2024-05-24 17:45:00.000000',00000000000000297694),('2024-05-24 17:50:00.000000',00000000000000309694),('2024-05-24 17:55:00.000000',00000000000000313784),('2024-05-24 18:00:00.000000',00000000000000314884),('2024-05-24 18:05:00.000000',00000000000000317884),('2024-05-24 18:10:00.000000',00000000000000322634),('2024-05-24 18:15:00.000000',00000000000000333834),('2024-05-24 18:20:00.000000',00000000000000356034),('2024-05-24 18:25:00.000000',00000000000000367024),('2024-05-24 18:30:00.000000',00000000000000383924),('2024-05-24 18:35:00.000000',00000000000000397923),('2024-05-24 18:40:00.000000',00000000000000406823),('2024-05-24 18:45:00.000000',00000000000000420423),('2024-05-24 18:50:00.000000',00000000000000422523),('2024-05-24 18:55:00.000000',00000000000000443223),('2024-05-24 19:00:00.000000',00000000000000459023),('2024-05-24 19:05:00.000000',00000000000000468013),('2024-05-24 19:10:00.000000',00000000000000473913),('2024-05-24 19:15:00.000000',00000000000000476113),('2024-05-24 19:20:00.000000',00000000000000480313),('2024-05-24 19:25:00.000000',00000000000000488313),('2024-05-24 19:30:00.000000',00000000000000503113),('2024-05-24 19:35:00.000000',00000000000000503113),('2024-05-24 19:40:00.000000',00000000000000504113),('2024-05-24 19:45:00.000000',00000000000000515213),('2024-05-24 19:50:00.000000',00000000000000515213),('2024-05-24 19:55:00.000000',00000000000000517213),('2024-05-24 20:00:00.000000',00000000000000527113),('2024-05-24 20:05:00.000000',00000000000000530992),('2024-05-24 20:10:00.000000',00000000000000537892),('2024-05-24 20:15:00.000000',00000000000000540992),('2024-05-24 20:20:00.000000',00000000000000540992),('2024-05-24 20:25:00.000000',00000000000000589792),('2024-05-24 20:30:00.000000',00000000000000589792),('2024-05-24 20:35:00.000000',00000000000000590792),('2024-05-24 20:40:00.000000',00000000000000590792),('2024-05-24 20:45:00.000000',00000000000000590792),('2024-05-24 20:50:00.000000',00000000000000592892),('2024-05-24 20:55:00.000000',00000000000000592892),('2024-05-24 21:00:00.000000',00000000000000603792),('2024-05-24 21:05:00.000000',00000000000000603792),('2024-05-24 21:10:00.000000',00000000000000608692),('2024-05-24 21:15:00.000000',00000000000000609692),('2024-05-24 21:20:00.000000',00000000000000613592),('2024-05-24 21:25:00.000000',00000000000000614592),('2024-05-24 21:30:00.000000',00000000000000622592),('2024-05-24 21:35:00.000000',00000000000000623592),('2024-05-24 21:40:00.000000',00000000000000629492),('2024-05-24 21:45:00.000000',00000000000000630592),('2024-05-24 21:50:00.000000',00000000000000631592),('2024-05-24 21:55:00.000000',00000000000000633692),('2024-05-24 22:00:00.000000',00000000000000636792),('2024-05-24 22:05:00.000000',00000000000000636792),('2024-05-24 22:10:00.000000',00000000000000639892),('2024-05-24 22:15:00.000000',00000000000000640992),('2024-05-24 22:20:00.000000',00000000000000649992),('2024-05-24 22:25:00.000000',00000000000000652982),('2024-05-24 22:30:00.000000',00000000000000655982),('2024-05-24 22:35:00.000000',00000000000000658970),('2024-05-24 22:40:00.000000',00000000000000671970),('2024-05-24 22:45:00.000000',00000000000000676170),('2024-05-24 22:50:00.000000',00000000000000719170),('2024-05-24 22:55:00.000000',00000000000000727170),('2024-05-24 23:00:00.000000',00000000000000729170),('2024-05-24 23:05:00.000000',00000000000000733260),('2024-05-24 23:10:00.000000',00000000000000739250),('2024-05-24 23:15:00.000000',00000000000000743350),('2024-05-24 23:20:00.000000',00000000000000748450),('2024-05-24 23:25:00.000000',00000000000000752450),('2024-05-24 23:30:00.000000',00000000000000759540),('2024-05-24 23:35:00.000000',00000000000000764440),('2024-05-24 23:40:00.000000',00000000000000789240),('2024-05-24 23:45:00.000000',00000000000000793440),('2024-05-24 23:50:00.000000',00000000000000784640),('2024-05-24 23:55:00.000000',00000000000000803640),('2024-05-25 00:00:00.000000',00000000000000829440),('2024-05-25 00:05:00.000000',00000000000000824640),('2024-05-25 00:10:00.000000',00000000000000837640),('2024-05-25 00:15:00.000000',00000000000000845540),('2024-05-25 00:20:00.000000',00000000000000925540),('2024-05-25 00:25:00.000000',00000000000000929540),('2024-05-25 00:30:00.000000',00000000000000931840),('2024-05-25 00:35:00.000000',00000000000000939640),('2024-05-25 00:40:00.000000',00000000000000940640),('2024-05-25 00:45:00.000000',00000000000000946540),('2024-05-25 00:50:00.000000',00000000000000947640),('2024-05-25 00:55:00.000000',00000000000000949640),('2024-05-25 01:00:00.000000',00000000000000961640),('2024-05-25 01:05:00.000000',00000000000000962640),('2024-05-25 01:10:00.000000',00000000000000962640),('2024-05-25 01:15:00.000000',00000000000000962640),('2024-05-25 01:20:00.000000',00000000000000973540),('2024-05-25 01:25:00.000000',00000000000000988240),('2024-05-25 01:30:00.000000',00000000000000991140),('2024-05-25 01:35:00.000000',00000000000000993140),('2024-05-25 01:40:00.000000',00000000000000997140),('2024-05-25 01:45:00.000000',00000000000001004239),('2024-05-25 01:50:00.000000',00000000000001015339),('2024-05-25 01:55:00.000000',00000000000001021439),('2024-05-25 02:00:00.000000',00000000000001037039),('2024-05-25 02:05:00.000000',00000000000001061039),('2024-05-25 02:10:00.000000',00000000000001075039),('2024-05-25 02:15:00.000000',00000000000001090929),('2024-05-25 02:20:00.000000',00000000000001090929),('2024-05-25 02:25:00.000000',00000000000001105829),('2024-05-25 02:30:00.000000',00000000000001099929),('2024-05-25 02:35:00.000000',00000000000001103928),('2024-05-25 02:40:00.000000',00000000000001104928),('2024-05-25 02:45:00.000000',00000000000001156707),('2024-05-25 02:50:00.000000',00000000000001162707),('2024-05-25 02:55:00.000000',00000000000001176606),('2024-05-25 03:00:00.000000',00000000000001178706),('2024-05-25 03:05:00.000000',00000000000001178706),('2024-05-25 03:10:00.000000',00000000000001178706),('2024-05-25 03:15:00.000000',00000000000001178806),('2024-05-25 03:20:00.000000',00000000000001180906),('2024-05-25 03:25:00.000000',00000000000001195796),('2024-05-25 03:30:00.000000',00000000000001196896),('2024-05-25 03:35:00.000000',00000000000001201896),('2024-05-25 03:40:00.000000',00000000000001204896),('2024-05-25 03:45:00.000000',00000000000001204896),('2024-05-25 03:50:00.000000',00000000000001208996),('2024-05-25 03:55:00.000000',00000000000001218886),('2024-05-25 04:00:00.000000',00000000000001241876),('2024-05-25 04:05:00.000000',00000000000001253776),('2024-05-25 04:10:00.000000',00000000000001255776),('2024-05-25 04:15:00.000000',00000000000001261976),('2024-05-25 04:20:00.000000',00000000000001267676),('2024-05-25 04:25:00.000000',00000000000001268676),('2024-05-25 04:30:00.000000',00000000000001275666),('2024-05-25 04:35:00.000000',00000000000001276666),('2024-05-25 04:40:00.000000',00000000000001297566),('2024-05-25 04:45:00.000000',00000000000001312866),('2024-05-25 04:50:00.000000',00000000000001334546),('2024-05-25 04:55:00.000000',00000000000001344646),('2024-05-25 05:00:00.000000',00000000000001346746),('2024-05-25 05:05:00.000000',00000000000001391646),('2024-05-25 05:10:00.000000',00000000000001407546),('2024-05-25 05:15:00.000000',00000000000001407546),('2024-05-25 05:20:00.000000',00000000000001418436),('2024-05-25 05:25:00.000000',00000000000001429336),('2024-05-25 05:30:00.000000',00000000000001438436),('2024-05-25 05:35:00.000000',00000000000001444414),('2024-05-25 05:40:00.000000',00000000000001446414),('2024-05-25 05:45:00.000000',00000000000001453403),('2024-05-25 05:50:00.000000',00000000000001462303),('2024-05-25 05:55:00.000000',00000000000001463303),('2024-05-25 06:00:00.000000',00000000000001467293),('2024-05-25 06:05:00.000000',00000000000001502183),('2024-05-25 06:10:00.000000',00000000000001526873),('2024-05-25 06:15:00.000000',00000000000001528873),('2024-05-25 06:20:00.000000',00000000000001535873),('2024-05-25 06:25:00.000000',00000000000001545773),('2024-05-25 06:30:00.000000',00000000000001551651),('2024-05-25 06:35:00.000000',00000000000001569451),('2024-05-25 06:40:00.000000',00000000000001575451),('2024-05-25 06:45:00.000000',00000000000001586351),('2024-05-25 06:50:00.000000',00000000000001611251),('2024-05-25 06:55:00.000000',00000000000001612251),('2024-05-25 07:00:00.000000',00000000000001615241),('2024-05-25 07:05:00.000000',00000000000001630010),('2024-05-25 07:10:00.000000',00000000000001653600),('2024-05-25 07:15:00.000000',00000000000001667490),('2024-05-25 07:20:00.000000',00000000000001683370),('2024-05-25 07:25:00.000000',00000000000001715350),('2024-05-25 07:30:00.000000',00000000000001734140),('2024-05-25 07:35:00.000000',00000000000001738706),('2024-05-25 07:40:00.000000',00000000000001748706),('2024-05-25 07:45:00.000000',00000000000001752606),('2024-05-25 07:50:00.000000',00000000000001753606),('2024-05-25 07:55:00.000000',00000000000001763606),('2024-05-25 08:00:00.000000',00000000000001769696),('2024-05-25 08:05:00.000000',00000000000001785385),('2024-05-25 08:10:00.000000',00000000000001793275),('2024-05-25 08:15:00.000000',00000000000001797275),('2024-05-25 08:20:00.000000',00000000000001798375),('2024-05-25 08:25:00.000000',00000000000001809275),('2024-05-25 08:30:00.000000',00000000000001814175),('2024-05-25 08:35:00.000000',00000000000001820975),('2024-05-25 08:40:00.000000',00000000000001839475),('2024-05-25 08:45:00.000000',00000000000001839475),('2024-05-25 08:50:00.000000',00000000000001846375),('2024-05-25 08:55:00.000000',00000000000001896475),('2024-05-25 09:00:00.000000',00000000000001906275),('2024-05-25 09:05:00.000000',00000000000001916675),('2024-05-25 09:10:00.000000',00000000000001922565),('2024-05-25 09:15:00.000000',00000000000001927465),('2024-05-25 09:20:00.000000',00000000000001945255),('2024-05-25 09:25:00.000000',00000000000001961543),('2024-05-25 09:30:00.000000',00000000000001961743),('2024-05-25 09:35:00.000000',00000000000001967733),('2024-05-25 09:40:00.000000',00000000000001969733),('2024-05-25 09:45:00.000000',00000000000001982733),('2024-05-25 09:50:00.000000',00000000000002006233),('2024-05-25 09:55:00.000000',00000000000002011233),('2024-05-25 10:00:00.000000',00000000000002014133),('2024-05-25 10:05:00.000000',00000000000002014133),('2024-05-25 10:10:00.000000',00000000000002014133),('2024-05-25 10:15:00.000000',00000000000002016133),('2024-05-25 10:20:00.000000',00000000000002016233),('2024-05-25 10:25:00.000000',00000000000002020223),('2024-05-25 10:30:00.000000',00000000000002026213),('2024-05-25 10:35:00.000000',00000000000002036113),('2024-05-25 10:40:00.000000',00000000000002044103),('2024-05-25 10:45:00.000000',00000000000002047103),('2024-05-25 10:50:00.000000',00000000000002053003),('2024-05-25 10:55:00.000000',00000000000002070703),('2024-05-25 11:00:00.000000',00000000000002074703),('2024-05-25 11:05:00.000000',00000000000002079803),('2024-05-25 11:10:00.000000',00000000000002107303),('2024-05-25 11:15:00.000000',00000000000002115203),('2024-05-25 11:20:00.000000',00000000000002120403),('2024-05-25 11:25:00.000000',00000000000002135192),('2024-05-25 11:30:00.000000',00000000000002150072),('2024-05-25 11:35:00.000000',00000000000002168061),('2024-05-25 11:40:00.000000',00000000000002195861),('2024-05-25 11:45:00.000000',00000000000002204661),('2024-05-25 11:50:00.000000',00000000000002207661),('2024-05-25 11:55:00.000000',00000000000002207661),('2024-05-25 12:00:00.000000',00000000000002209661),('2024-05-25 12:05:00.000000',00000000000002213751),('2024-05-25 12:10:00.000000',00000000000002244331),('2024-05-25 12:15:00.000000',00000000000002248131),('2024-05-25 12:20:00.000000',00000000000002269131),('2024-05-25 12:25:00.000000',00000000000002269231),('2024-05-25 12:30:00.000000',00000000000002269231),('2024-05-25 12:35:00.000000',00000000000002275321),('2024-05-25 12:40:00.000000',00000000000002276521),('2024-05-25 12:45:00.000000',00000000000002286421),('2024-05-25 12:50:00.000000',00000000000002292521),('2024-05-25 12:55:00.000000',00000000000002304621),('2024-05-25 13:00:00.000000',00000000000002308620),('2024-05-25 13:05:00.000000',00000000000002309286),('2024-05-25 13:10:00.000000',00000000000002314186),('2024-05-25 13:15:00.000000',00000000000002316186),('2024-05-25 13:20:00.000000',00000000000002336786),('2024-05-25 13:25:00.000000',00000000000002346675),('2024-05-25 13:30:00.000000',00000000000002354574),('2024-05-25 13:35:00.000000',00000000000002373273),('2024-05-25 13:40:00.000000',00000000000002390163),('2024-05-25 13:45:00.000000',00000000000002401863),('2024-05-25 13:50:00.000000',00000000000002413753),('2024-05-25 13:55:00.000000',00000000000002413753),('2024-05-25 14:00:00.000000',00000000000002417653),('2024-05-25 14:05:00.000000',00000000000002420653),('2024-05-25 14:10:00.000000',00000000000002421653),('2024-05-25 14:15:00.000000',00000000000002438443),('2024-05-25 14:20:00.000000',00000000000002442432),('2024-05-25 14:25:00.000000',00000000000002447310),('2024-05-25 14:30:00.000000',00000000000002469988),('2024-05-25 14:35:00.000000',00000000000002477888),('2024-05-25 14:40:00.000000',00000000000002478888),('2024-05-25 14:45:00.000000',00000000000002509388),('2024-05-25 14:50:00.000000',00000000000002529978),('2024-05-25 14:55:00.000000',00000000000002523078),('2024-05-25 15:00:00.000000',00000000000002535878),('2024-05-25 15:05:00.000000',00000000000002559668),('2024-05-25 15:10:00.000000',00000000000002564548),('2024-05-25 15:15:00.000000',00000000000002599148),('2024-05-25 15:20:00.000000',00000000000002621848),('2024-05-25 15:25:00.000000',00000000000002692248),('2024-05-25 15:30:00.000000',00000000000002711848),('2024-05-25 15:35:00.000000',00000000000002714848),('2024-05-25 15:40:00.000000',00000000000002740648),('2024-05-25 15:45:00.000000',00000000000002755348),('2024-05-25 15:50:00.000000',00000000000002781947),('2024-05-25 15:55:00.000000',00000000000002786937),('2024-05-25 16:00:00.000000',00000000000000000000),('2024-05-25 16:05:00.000000',00000000000000000000),('2024-05-25 16:10:00.000000',00000000000000020590),('2024-05-25 16:15:00.000000',00000000000000042090),('2024-05-25 16:20:00.000000',00000000000000060180),('2024-05-25 16:25:00.000000',00000000000000076080),('2024-05-25 16:30:00.000000',00000000000000088880),('2024-05-25 16:35:00.000000',00000000000000124680),('2024-05-25 16:40:00.000000',00000000000000137659),('2024-05-25 16:45:00.000000',00000000000000150939),('2024-05-25 16:50:00.000000',00000000000000158939),('2024-05-25 16:55:00.000000',00000000000000182518),('2024-05-25 17:00:00.000000',00000000000000191607),('2024-05-25 17:05:00.000000',00000000000000205497),('2024-05-25 17:10:00.000000',00000000000000217597),('2024-05-25 17:15:00.000000',00000000000000217597),('2024-05-25 17:20:00.000000',00000000000000228497),('2024-05-25 17:25:00.000000',00000000000000250197),('2024-05-25 17:30:00.000000',00000000000000280896),('2024-05-25 17:35:00.000000',00000000000000300465),('2024-05-25 17:40:00.000000',00000000000000319422),('2024-05-25 17:45:00.000000',00000000000000326310),('2024-05-25 17:50:00.000000',00000000000000330199),('2024-05-25 17:55:00.000000',00000000000000347289),('2024-05-25 18:00:00.000000',00000000000000356189),('2024-05-25 18:05:00.000000',00000000000000376089),('2024-05-25 18:10:00.000000',00000000000000379089),('2024-05-25 18:15:00.000000',00000000000000389978),('2024-05-25 18:20:00.000000',00000000000000389978),('2024-05-25 18:25:00.000000',00000000000000391978),('2024-05-25 18:30:00.000000',00000000000000404778),('2024-05-25 18:35:00.000000',00000000000000416667),('2024-05-25 18:40:00.000000',00000000000000417767),('2024-05-25 18:45:00.000000',00000000000000417767),('2024-05-25 18:50:00.000000',00000000000000427667),('2024-05-25 18:55:00.000000',00000000000000427667),('2024-05-25 19:00:00.000000',00000000000000427667),('2024-05-25 19:05:00.000000',00000000000000427667),('2024-05-25 19:10:00.000000',00000000000000436567),('2024-05-25 19:15:00.000000',00000000000000438567),('2024-05-25 19:20:00.000000',00000000000000452367),('2024-05-25 19:25:00.000000',00000000000000445567),('2024-05-25 19:30:00.000000',00000000000000456467),('2024-05-25 19:35:00.000000',00000000000000463556),('2024-05-25 19:40:00.000000',00000000000000460566),('2024-05-25 19:45:00.000000',00000000000000460566),('2024-05-25 19:50:00.000000',00000000000000464556),('2024-05-25 19:55:00.000000',00000000000000477414),('2024-05-25 20:00:00.000000',00000000000000477414),('2024-05-25 20:05:00.000000',00000000000000487304),('2024-05-25 20:10:00.000000',00000000000000487304),('2024-05-25 20:15:00.000000',00000000000000490204),('2024-05-25 20:20:00.000000',00000000000000490204),('2024-05-25 20:25:00.000000',00000000000000494194),('2024-05-25 20:30:00.000000',00000000000000494194),('2024-05-25 20:35:00.000000',00000000000000494194),('2024-05-25 20:40:00.000000',00000000000000497184),('2024-05-25 20:45:00.000000',00000000000000497184),('2024-05-25 20:50:00.000000',00000000000000494194),('2024-05-25 20:55:00.000000',00000000000000506094),('2024-05-25 21:00:00.000000',00000000000000525783),('2024-05-25 21:05:00.000000',00000000000000528783),('2024-05-25 21:10:00.000000',00000000000000528783),('2024-05-25 21:15:00.000000',00000000000000528883),('2024-05-25 21:20:00.000000',00000000000000528883),('2024-05-25 21:25:00.000000',00000000000000528883),('2024-05-25 21:30:00.000000',00000000000000528883),('2024-05-25 21:35:00.000000',00000000000000531873),('2024-05-25 21:40:00.000000',00000000000000533873),('2024-05-25 21:45:00.000000',00000000000000533873),('2024-05-25 21:50:00.000000',00000000000000533873),('2024-05-25 21:55:00.000000',00000000000000536873),('2024-05-25 22:00:00.000000',00000000000000538873),('2024-05-25 22:05:00.000000',00000000000000541873),('2024-05-25 22:10:00.000000',00000000000000549773),('2024-05-25 22:15:00.000000',00000000000000572140),('2024-05-25 22:20:00.000000',00000000000000572240),('2024-05-25 22:25:00.000000',00000000000000574240),('2024-05-25 22:30:00.000000',00000000000000574240),('2024-05-25 22:35:00.000000',00000000000000592840),('2024-05-25 22:40:00.000000',00000000000000592840),('2024-05-25 22:45:00.000000',00000000000000593840),('2024-05-25 22:50:00.000000',00000000000000593840),('2024-05-25 22:55:00.000000',00000000000000593840),('2024-05-25 23:00:00.000000',00000000000000602640),('2024-05-25 23:05:00.000000',00000000000000602640),('2024-05-25 23:10:00.000000',00000000000000613530),('2024-05-25 23:15:00.000000',00000000000000614520),('2024-05-25 23:20:00.000000',00000000000000618519),('2024-05-25 23:25:00.000000',00000000000000629319),('2024-05-25 23:30:00.000000',00000000000000632309),('2024-05-25 23:35:00.000000',00000000000000634298),('2024-05-25 23:40:00.000000',00000000000000632708),('2024-05-25 23:45:00.000000',00000000000000640608),('2024-05-25 23:50:00.000000',00000000000000642608),('2024-05-25 23:55:00.000000',00000000000000654296),('2024-05-26 00:00:00.000000',00000000000000655296),('2024-05-26 00:05:00.000000',00000000000000662176),('2024-05-26 00:10:00.000000',00000000000000662176),('2024-05-26 00:15:00.000000',00000000000000671076),('2024-05-26 00:20:00.000000',00000000000000671742),('2024-05-26 00:25:00.000000',00000000000000676842),('2024-05-26 00:30:00.000000',00000000000000712721),('2024-05-26 00:35:00.000000',00000000000000750721),('2024-05-26 00:40:00.000000',00000000000000758621),('2024-05-26 00:45:00.000000',00000000000000771421),('2024-05-26 00:50:00.000000',00000000000000773411),('2024-05-26 00:55:00.000000',00000000000000779211),('2024-05-26 01:00:00.000000',00000000000000794811),('2024-05-26 01:05:00.000000',00000000000000796699),('2024-05-26 01:10:00.000000',00000000000000806598),('2024-05-26 01:15:00.000000',00000000000000807598),('2024-05-26 01:20:00.000000',00000000000000820387),('2024-05-26 01:25:00.000000',00000000000000824386),('2024-05-26 01:30:00.000000',00000000000000827286),('2024-05-26 01:35:00.000000',00000000000000841085),('2024-05-26 01:40:00.000000',00000000000000842085),('2024-05-26 01:45:00.000000',00000000000000846885),('2024-05-26 01:50:00.000000',00000000000000846885),('2024-05-26 01:55:00.000000',00000000000000857774),('2024-05-26 02:00:00.000000',00000000000000860674),('2024-05-26 02:05:00.000000',00000000000000866474),('2024-05-26 02:10:00.000000',00000000000000870374),('2024-05-26 02:15:00.000000',00000000000000871374),('2024-05-26 02:20:00.000000',00000000000000874274),('2024-05-26 02:25:00.000000',00000000000000899864),('2024-05-26 02:30:00.000000',00000000000000910664),('2024-05-26 02:35:00.000000',00000000000000925364),('2024-05-26 02:40:00.000000',00000000000000926463),('2024-05-26 02:45:00.000000',00000000000000931363),('2024-05-26 02:50:00.000000',00000000000000958263),('2024-05-26 02:55:00.000000',00000000000000973062),('2024-05-26 03:00:00.000000',00000000000000977962),('2024-05-26 03:05:00.000000',00000000000000986862),('2024-05-26 03:10:00.000000',00000000000000986862),('2024-05-26 03:15:00.000000',00000000000000992942),('2024-05-26 03:20:00.000000',00000000000001001842),('2024-05-26 03:25:00.000000',00000000000001001842),('2024-05-26 03:30:00.000000',00000000000001025741),('2024-05-26 03:35:00.000000',00000000000001025741),('2024-05-26 03:40:00.000000',00000000000001040441),('2024-05-26 03:45:00.000000',00000000000001053341),('2024-05-26 03:50:00.000000',00000000000001053441),('2024-05-26 03:55:00.000000',00000000000001053441),('2024-05-26 04:00:00.000000',00000000000001060441),('2024-05-26 04:05:00.000000',00000000000001060541),('2024-05-26 04:10:00.000000',00000000000001064741),('2024-05-26 04:15:00.000000',00000000000001075641),('2024-05-26 04:20:00.000000',00000000000001082630),('2024-05-26 04:25:00.000000',00000000000001082730),('2024-05-26 04:30:00.000000',00000000000001085719),('2024-05-26 04:35:00.000000',00000000000001083798),('2024-05-26 04:40:00.000000',00000000000001084898),('2024-05-26 04:45:00.000000',00000000000001084998),('2024-05-26 04:50:00.000000',00000000000001091997),('2024-05-26 04:55:00.000000',00000000000001092997),('2024-05-26 05:00:00.000000',00000000000001095997),('2024-05-26 05:05:00.000000',00000000000001103897),('2024-05-26 05:10:00.000000',00000000000001131063),('2024-05-26 05:15:00.000000',00000000000001154763),('2024-05-26 05:20:00.000000',00000000000001193822),('2024-05-26 05:25:00.000000',00000000000001227622),('2024-05-26 05:30:00.000000',00000000000001241722),('2024-05-26 05:35:00.000000',00000000000001250522),('2024-05-26 05:40:00.000000',00000000000001309012),('2024-05-26 05:45:00.000000',00000000000001332512),('2024-05-26 05:50:00.000000',00000000000001343992),('2024-05-26 05:55:00.000000',00000000000001345992),('2024-05-26 06:00:00.000000',00000000000001372591),('2024-05-26 06:05:00.000000',00000000000001386491),('2024-05-26 06:10:00.000000',00000000000001398380),('2024-05-26 06:15:00.000000',00000000000001448180),('2024-05-26 06:20:00.000000',00000000000001466980),('2024-05-26 06:25:00.000000',00000000000001482479),('2024-05-26 06:30:00.000000',00000000000001489959),('2024-05-26 06:35:00.000000',00000000000001489959),('2024-05-26 06:40:00.000000',00000000000001515759),('2024-05-26 06:45:00.000000',00000000000001527649),('2024-05-26 06:50:00.000000',00000000000001540449),('2024-05-26 06:55:00.000000',00000000000001545449),('2024-05-26 07:00:00.000000',00000000000001548439),('2024-05-26 07:05:00.000000',00000000000001862939),('2024-05-26 07:10:00.000000',00000000000001864039),('2024-05-26 07:15:00.000000',00000000000001877939),('2024-05-26 07:20:00.000000',00000000000001894839),('2024-05-26 07:25:00.000000',00000000000001907439),('2024-05-26 07:30:00.000000',00000000000001917339),('2024-05-26 07:35:00.000000',00000000000001930239),('2024-05-26 07:40:00.000000',00000000000001944028),('2024-05-26 07:45:00.000000',00000000000001970827),('2024-05-26 07:50:00.000000',00000000000001985805),('2024-05-26 07:55:00.000000',00000000000001990905),('2024-05-26 08:00:00.000000',00000000000002014705),('2024-05-26 08:05:00.000000',00000000000002026604),('2024-05-26 08:10:00.000000',00000000000002038584),('2024-05-26 08:15:00.000000',00000000000002057284),('2024-05-26 08:20:00.000000',00000000000002073174),('2024-05-26 08:25:00.000000',00000000000002086064),('2024-05-26 08:30:00.000000',00000000000002089164),('2024-05-26 08:35:00.000000',00000000000002090164),('2024-05-26 08:40:00.000000',00000000000002091164),('2024-05-26 08:45:00.000000',00000000000002091164),('2024-05-26 08:50:00.000000',00000000000002102942),('2024-05-26 08:55:00.000000',00000000000002106042),('2024-05-26 09:00:00.000000',00000000000002117932),('2024-05-26 09:05:00.000000',00000000000002139631),('2024-05-26 09:10:00.000000',00000000000002194231),('2024-05-26 09:15:00.000000',00000000000002250930),('2024-05-26 09:20:00.000000',00000000000002252930),('2024-05-26 09:25:00.000000',00000000000002263730),('2024-05-26 09:30:00.000000',00000000000002266930),('2024-05-26 09:35:00.000000',00000000000002278720),('2024-05-26 09:40:00.000000',00000000000002284620),('2024-05-26 09:45:00.000000',00000000000002289420),('2024-05-26 09:50:00.000000',00000000000002289420),('2024-05-26 09:55:00.000000',00000000000002302220),('2024-05-26 10:00:00.000000',00000000000002310210),('2024-05-26 10:05:00.000000',00000000000002320010),('2024-05-26 10:10:00.000000',00000000000002322010),('2024-05-26 10:15:00.000000',00000000000002324910),('2024-05-26 10:20:00.000000',00000000000002327810),('2024-05-26 10:25:00.000000',00000000000002335610),('2024-05-26 10:30:00.000000',00000000000002335610),('2024-05-26 10:35:00.000000',00000000000002343510),('2024-05-26 10:40:00.000000',00000000000002351310),('2024-05-26 10:45:00.000000',00000000000002351310),('2024-05-26 10:50:00.000000',00000000000002382000),('2024-05-26 10:55:00.000000',00000000000002384000),('2024-05-26 11:00:00.000000',00000000000002393900),('2024-05-26 11:05:00.000000',00000000000002396890),('2024-05-26 11:10:00.000000',00000000000002396890),('2024-05-26 11:15:00.000000',00000000000002397890),('2024-05-26 11:20:00.000000',00000000000002400790),('2024-05-26 11:25:00.000000',00000000000002409690),('2024-05-26 11:30:00.000000',00000000000002419680),('2024-05-26 11:35:00.000000',00000000000002440470),('2024-05-26 11:40:00.000000',00000000000002445370),('2024-05-26 11:45:00.000000',00000000000002445370),('2024-05-26 11:50:00.000000',00000000000002457270),('2024-05-26 11:55:00.000000',00000000000002459270),('2024-05-26 12:00:00.000000',00000000000002468170),('2024-05-26 12:05:00.000000',00000000000002481970),('2024-05-26 12:10:00.000000',00000000000002484870),('2024-05-26 12:15:00.000000',00000000000002488869),('2024-05-26 12:20:00.000000',00000000000002489869),('2024-05-26 12:25:00.000000',00000000000002491869),('2024-05-26 12:30:00.000000',00000000000002500769),('2024-05-26 12:35:00.000000',00000000000002501769),('2024-05-26 12:40:00.000000',00000000000002506768),('2024-05-26 12:45:00.000000',00000000000002539668),('2024-05-26 12:50:00.000000',00000000000002541668),('2024-05-26 12:55:00.000000',00000000000002541668),('2024-05-26 13:00:00.000000',00000000000002544568),('2024-05-26 13:05:00.000000',00000000000002578768),('2024-05-26 13:10:00.000000',00000000000002573268),('2024-05-26 13:15:00.000000',00000000000002587228),('2024-05-26 13:20:00.000000',00000000000002587228),('2024-05-26 13:25:00.000000',00000000000002599028),('2024-05-26 13:30:00.000000',00000000000002605028),('2024-05-26 13:35:00.000000',00000000000002607928),('2024-05-26 13:40:00.000000',00000000000002615728),('2024-05-26 13:45:00.000000',00000000000002626528),('2024-05-26 13:50:00.000000',00000000000002630528),('2024-05-26 13:55:00.000000',00000000000002630528),('2024-05-26 14:00:00.000000',00000000000002636428),('2024-05-26 14:05:00.000000',00000000000002636428),('2024-05-26 14:10:00.000000',00000000000002651228),('2024-05-26 14:15:00.000000',00000000000002663028),('2024-05-26 14:20:00.000000',00000000000002663028),('2024-05-26 14:25:00.000000',00000000000002677008),('2024-05-26 14:30:00.000000',00000000000002704008),('2024-05-26 14:35:00.000000',00000000000002714863),('2024-05-26 14:40:00.000000',00000000000002717763),('2024-05-26 14:45:00.000000',00000000000002747162),('2024-05-26 14:50:00.000000',00000000000002754252),('2024-05-26 14:55:00.000000',00000000000002791142),('2024-05-26 15:00:00.000000',00000000000002800942),('2024-05-26 15:05:00.000000',00000000000002809642),('2024-05-26 15:10:00.000000',00000000000002825242),('2024-05-26 15:15:00.000000',00000000000002827342),('2024-05-26 15:20:00.000000',00000000000002863518),('2024-05-26 15:25:00.000000',00000000000002890117),('2024-05-26 15:30:00.000000',00000000000002887127),('2024-05-26 15:35:00.000000',00000000000002900928),('2024-05-26 15:40:00.000000',00000000000002909908),('2024-05-26 15:45:00.000000',00000000000002915908),('2024-05-26 15:50:00.000000',00000000000002922808),('2024-05-26 15:55:00.000000',00000000000002931708),('2024-05-26 16:00:00.000000',00000000000000000000),('2024-05-26 16:05:00.000000',00000000000000017990),('2024-05-26 16:10:00.000000',00000000000000021079),('2024-05-26 16:15:00.000000',00000000000000028058),('2024-05-26 16:20:00.000000',00000000000000029058),('2024-05-26 16:25:00.000000',00000000000000048127),('2024-05-26 16:30:00.000000',00000000000000064927),('2024-05-26 16:35:00.000000',00000000000000073727),('2024-05-26 16:40:00.000000',00000000000000097517),('2024-05-26 16:45:00.000000',00000000000000107007),('2024-05-26 16:50:00.000000',00000000000000128685),('2024-05-26 16:55:00.000000',00000000000000138785),('2024-05-26 17:00:00.000000',00000000000000155362),('2024-05-26 17:05:00.000000',00000000000000183262),('2024-05-26 17:10:00.000000',00000000000000188262),('2024-05-26 17:15:00.000000',00000000000000196162),('2024-05-26 17:20:00.000000',00000000000000207062),('2024-05-26 17:25:00.000000',00000000000000240852),('2024-05-26 17:30:00.000000',00000000000000247052),('2024-05-26 17:35:00.000000',00000000000000259852),('2024-05-26 17:40:00.000000',00000000000000278932),('2024-05-26 17:45:00.000000',00000000000000283532),('2024-05-26 17:50:00.000000',00000000000000289522),('2024-05-26 17:55:00.000000',00000000000000297522),('2024-05-26 18:00:00.000000',00000000000000310322),('2024-05-26 18:05:00.000000',00000000000000327222),('2024-05-26 18:10:00.000000',00000000000000333122),('2024-05-26 18:15:00.000000',00000000000000349122),('2024-05-26 18:20:00.000000',00000000000000351122),('2024-05-26 18:25:00.000000',00000000000000360102),('2024-05-26 18:30:00.000000',00000000000000361202),('2024-05-26 18:35:00.000000',00000000000000361202),('2024-05-26 18:40:00.000000',00000000000000370102),('2024-05-26 18:45:00.000000',00000000000000379902),('2024-05-26 18:50:00.000000',00000000000000383902),('2024-05-26 18:55:00.000000',00000000000000391902),('2024-05-26 19:00:00.000000',00000000000000395802),('2024-05-26 19:05:00.000000',00000000000000398702),('2024-05-26 19:10:00.000000',00000000000000402702),('2024-05-26 19:15:00.000000',00000000000000415802),('2024-05-26 19:20:00.000000',00000000000000449171),('2024-05-26 19:25:00.000000',00000000000000449171),('2024-05-26 19:30:00.000000',00000000000000452071),('2024-05-26 19:35:00.000000',00000000000000460961),('2024-05-26 19:40:00.000000',00000000000000468851),('2024-05-26 19:45:00.000000',00000000000000468851),('2024-05-26 19:50:00.000000',00000000000000471751),('2024-05-26 19:55:00.000000',00000000000000471751),('2024-05-26 20:00:00.000000',00000000000000482451),('2024-05-26 20:05:00.000000',00000000000000486451),('2024-05-26 20:10:00.000000',00000000000000491340),('2024-05-26 20:15:00.000000',00000000000000495329),('2024-05-26 20:20:00.000000',00000000000000497329),('2024-05-26 20:25:00.000000',00000000000000497329),('2024-05-26 20:30:00.000000',00000000000000497329),('2024-05-26 20:35:00.000000',00000000000000497329),('2024-05-26 20:40:00.000000',00000000000000497329),('2024-05-26 20:45:00.000000',00000000000000499329),('2024-05-26 20:50:00.000000',00000000000000500329),('2024-05-26 20:55:00.000000',00000000000000500329),('2024-05-26 21:00:00.000000',00000000000000503329),('2024-05-26 21:05:00.000000',00000000000000504329),('2024-05-26 21:10:00.000000',00000000000000511229),('2024-05-26 21:15:00.000000',00000000000000511229),('2024-05-26 21:20:00.000000',00000000000000511229),('2024-05-26 21:25:00.000000',00000000000000514129),('2024-05-26 21:30:00.000000',00000000000000516129),('2024-05-26 21:35:00.000000',00000000000000516129),('2024-05-26 21:40:00.000000',00000000000000516129),('2024-05-26 21:45:00.000000',00000000000000516129),('2024-05-26 21:50:00.000000',00000000000000516129),('2024-05-26 21:55:00.000000',00000000000000516129),('2024-05-26 22:00:00.000000',00000000000000522029),('2024-05-26 22:05:00.000000',00000000000000523029),('2024-05-26 22:10:00.000000',00000000000000530929),('2024-05-26 22:15:00.000000',00000000000000541729),('2024-05-26 22:20:00.000000',00000000000000544819),('2024-05-26 22:25:00.000000',00000000000000544819),('2024-05-26 22:30:00.000000',00000000000000557619),('2024-05-26 22:35:00.000000',00000000000000567519),('2024-05-26 22:40:00.000000',00000000000000567519),('2024-05-26 22:45:00.000000',00000000000000569519),('2024-05-26 22:50:00.000000',00000000000000569519),('2024-05-26 22:55:00.000000',00000000000000578319),('2024-05-26 23:00:00.000000',00000000000000591219),('2024-05-26 23:05:00.000000',00000000000000594219),('2024-05-26 23:10:00.000000',00000000000000603119),('2024-05-26 23:15:00.000000',00000000000000604119),('2024-05-26 23:20:00.000000',00000000000000604119),('2024-05-26 23:25:00.000000',00000000000000604119),('2024-05-26 23:30:00.000000',00000000000000606119),('2024-05-26 23:35:00.000000',00000000000000610019),('2024-05-26 23:40:00.000000',00000000000000621819),('2024-05-26 23:45:00.000000',00000000000000621819),('2024-05-26 23:50:00.000000',00000000000000621819),('2024-05-26 23:55:00.000000',00000000000000621819),('2024-05-27 00:00:00.000000',00000000000000621819),('2024-05-27 00:05:00.000000',00000000000000622819),('2024-05-27 00:10:00.000000',00000000000000628719),('2024-05-27 00:15:00.000000',00000000000000635319),('2024-05-27 00:20:00.000000',00000000000000637319),('2024-05-27 00:25:00.000000',00000000000000645219),('2024-05-27 00:30:00.000000',00000000000000648119),('2024-05-27 00:35:00.000000',00000000000000653219),('2024-05-27 00:40:00.000000',00000000000000658119),('2024-05-27 00:45:00.000000',00000000000000665919),('2024-05-27 00:50:00.000000',00000000000000665919),('2024-05-27 00:55:00.000000',00000000000000708719),('2024-05-27 01:00:00.000000',00000000000000708719),('2024-05-27 01:05:00.000000',00000000000000708719),('2024-05-27 01:10:00.000000',00000000000000728319),('2024-05-27 01:15:00.000000',00000000000000737119),('2024-05-27 01:20:00.000000',00000000000000743907),('2024-05-27 01:25:00.000000',00000000000000753907),('2024-05-27 01:30:00.000000',00000000000000767907),('2024-05-27 01:35:00.000000',00000000000000771906),('2024-05-27 01:40:00.000000',00000000000000780706),('2024-05-27 01:45:00.000000',00000000000000792605),('2024-05-27 01:50:00.000000',00000000000000801405),('2024-05-27 01:55:00.000000',00000000000000803405),('2024-05-27 02:00:00.000000',00000000000000806405),('2024-05-27 02:05:00.000000',00000000000000815405),('2024-05-27 02:10:00.000000',00000000000000820305),('2024-05-27 02:15:00.000000',00000000000000826195),('2024-05-27 02:20:00.000000',00000000000000826195),('2024-05-27 02:25:00.000000',00000000000000832595),('2024-05-27 02:30:00.000000',00000000000000835695),('2024-05-27 02:35:00.000000',00000000000000840865),('2024-05-27 02:40:00.000000',00000000000000848665),('2024-05-27 02:45:00.000000',00000000000000861365),('2024-05-27 02:50:00.000000',00000000000000873445),('2024-05-27 02:55:00.000000',00000000000000887045),('2024-05-27 03:00:00.000000',00000000000000892945),('2024-05-27 03:05:00.000000',00000000000000902845),('2024-05-27 03:10:00.000000',00000000000000906745),('2024-05-27 03:15:00.000000',00000000000000907745),('2024-05-27 03:20:00.000000',00000000000000912935),('2024-05-27 03:25:00.000000',00000000000000931735),('2024-05-27 03:30:00.000000',00000000000000935735),('2024-05-27 03:35:00.000000',00000000000000940535),('2024-05-27 03:40:00.000000',00000000000000943435),('2024-05-27 03:45:00.000000',00000000000000944435),('2024-05-27 03:50:00.000000',00000000000000955235),('2024-05-27 03:55:00.000000',00000000000000959114),('2024-05-27 04:00:00.000000',00000000000000970014),('2024-05-27 04:05:00.000000',00000000000000978814),('2024-05-27 04:10:00.000000',00000000000000991502),('2024-05-27 04:15:00.000000',00000000000001009202),('2024-05-27 04:20:00.000000',00000000000001019902),('2024-05-27 04:25:00.000000',00000000000001040592),('2024-05-27 04:30:00.000000',00000000000001063182),('2024-05-27 04:35:00.000000',00000000000001095682),('2024-05-27 04:40:00.000000',00000000000001095682),('2024-05-27 04:45:00.000000',00000000000001107382),('2024-05-27 04:50:00.000000',00000000000001132082),('2024-05-27 04:55:00.000000',00000000000001141772),('2024-05-27 05:00:00.000000',00000000000001141772),('2024-05-27 05:05:00.000000',00000000000001147572),('2024-05-27 05:10:00.000000',00000000000001152572),('2024-05-27 05:15:00.000000',00000000000001170172),('2024-05-27 05:20:00.000000',00000000000001176172),('2024-05-27 05:25:00.000000',00000000000001185972),('2024-05-27 05:30:00.000000',00000000000001201971),('2024-05-27 05:35:00.000000',00000000000001208871),('2024-05-27 05:40:00.000000',00000000000001214171),('2024-05-27 05:45:00.000000',00000000000001217071),('2024-05-27 05:50:00.000000',00000000000001222171),('2024-05-27 05:55:00.000000',00000000000001225071),('2024-05-27 06:00:00.000000',00000000000001225171),('2024-05-27 06:05:00.000000',00000000000001237971),('2024-05-27 06:10:00.000000',00000000000001244971),('2024-05-27 06:15:00.000000',00000000000001247971),('2024-05-27 06:20:00.000000',00000000000001268561),('2024-05-27 06:25:00.000000',00000000000001274361),('2024-05-27 06:30:00.000000',00000000000001281161),('2024-05-27 06:35:00.000000',00000000000001315741),('2024-05-27 06:40:00.000000',00000000000001372631),('2024-05-27 06:45:00.000000',00000000000001446131),('2024-05-27 06:50:00.000000',00000000000001453121),('2024-05-27 06:55:00.000000',00000000000001465921),('2024-05-27 07:00:00.000000',00000000000001469911),('2024-05-27 07:05:00.000000',00000000000001492511),('2024-05-27 07:10:00.000000',00000000000001503401),('2024-05-27 07:15:00.000000',00000000000001509191),('2024-05-27 07:20:00.000000',00000000000001510191),('2024-05-27 07:25:00.000000',00000000000001513181),('2024-05-27 07:30:00.000000',00000000000001524081),('2024-05-27 07:35:00.000000',00000000000001524081),('2024-05-27 07:40:00.000000',00000000000001554871),('2024-05-27 07:45:00.000000',00000000000001554871),('2024-05-27 07:50:00.000000',00000000000001581471),('2024-05-27 07:55:00.000000',00000000000001586371),('2024-05-27 08:00:00.000000',00000000000001588371),('2024-05-27 08:05:00.000000',00000000000001609161),('2024-05-27 08:10:00.000000',00000000000001621761),('2024-05-27 08:15:00.000000',00000000000001628761),('2024-05-27 08:20:00.000000',00000000000001638661),('2024-05-27 08:25:00.000000',00000000000001655350),('2024-05-27 08:30:00.000000',00000000000001660349),('2024-05-27 08:35:00.000000',00000000000001667349),('2024-05-27 08:40:00.000000',00000000000001678239),('2024-05-27 08:45:00.000000',00000000000001681139),('2024-05-27 08:50:00.000000',00000000000001687039),('2024-05-27 08:55:00.000000',00000000000001705739),('2024-05-27 09:00:00.000000',00000000000001708639),('2024-05-27 09:05:00.000000',00000000000001716529),('2024-05-27 09:10:00.000000',00000000000001716529),('2024-05-27 09:15:00.000000',00000000000001728319),('2024-05-27 09:20:00.000000',00000000000001751019),('2024-05-27 09:25:00.000000',00000000000001743119),('2024-05-27 09:30:00.000000',00000000000001751019),('2024-05-27 09:35:00.000000',00000000000001775619),('2024-05-27 09:40:00.000000',00000000000001786519),('2024-05-27 09:45:00.000000',00000000000001791419),('2024-05-27 09:50:00.000000',00000000000001800309),('2024-05-27 09:55:00.000000',00000000000001822209),('2024-05-27 10:00:00.000000',00000000000001835199),('2024-05-27 10:05:00.000000',00000000000001849899),('2024-05-27 10:10:00.000000',00000000000001855799),('2024-05-27 10:15:00.000000',00000000000001873599),('2024-05-27 10:20:00.000000',00000000000001885599),('2024-05-27 10:25:00.000000',00000000000001891599),('2024-05-27 10:30:00.000000',00000000000001934989),('2024-05-27 10:35:00.000000',00000000000001952577),('2024-05-27 10:40:00.000000',00000000000001958337),('2024-05-27 10:45:00.000000',00000000000001961327),('2024-05-27 10:50:00.000000',00000000000001976014),('2024-05-27 10:55:00.000000',00000000000001983104),('2024-05-27 11:00:00.000000',00000000000001990104),('2024-05-27 11:05:00.000000',00000000000002002004),('2024-05-27 11:10:00.000000',00000000000002020894),('2024-05-27 11:15:00.000000',00000000000002038494),('2024-05-27 11:20:00.000000',00000000000002046474),('2024-05-27 11:25:00.000000',00000000000002046474),('2024-05-27 11:30:00.000000',00000000000002046474),('2024-05-27 11:35:00.000000',00000000000002046474),('2024-05-27 11:40:00.000000',00000000000002046474),('2024-05-27 11:45:00.000000',00000000000002052473),('2024-05-27 11:50:00.000000',00000000000002061363),('2024-05-27 11:55:00.000000',00000000000002063363),('2024-05-27 12:00:00.000000',00000000000002080253),('2024-05-27 12:05:00.000000',00000000000002082243),('2024-05-27 12:10:00.000000',00000000000002082243),('2024-05-27 12:15:00.000000',00000000000002088143),('2024-05-27 12:20:00.000000',00000000000002105843),('2024-05-27 12:25:00.000000',00000000000002147732),('2024-05-27 12:30:00.000000',00000000000002178332),('2024-05-27 12:35:00.000000',00000000000002178332),('2024-05-27 12:40:00.000000',00000000000002192132),('2024-05-27 12:45:00.000000',00000000000002192132),('2024-05-27 12:50:00.000000',00000000000002192132),('2024-05-27 12:55:00.000000',00000000000002201132),('2024-05-27 13:00:00.000000',00000000000002208032),('2024-05-27 13:05:00.000000',00000000000002219832),('2024-05-27 13:10:00.000000',00000000000002227632),('2024-05-27 13:15:00.000000',00000000000002239532),('2024-05-27 13:20:00.000000',00000000000002256332),('2024-05-27 13:25:00.000000',00000000000002274132),('2024-05-27 13:30:00.000000',00000000000002292542),('2024-05-27 13:35:00.000000',00000000000002312432),('2024-05-27 13:40:00.000000',00000000000002341022),('2024-05-27 13:45:00.000000',00000000000002348021),('2024-05-27 13:50:00.000000',00000000000002374499),('2024-05-27 13:55:00.000000',00000000000002381499),('2024-05-27 14:00:00.000000',00000000000002383499),('2024-05-27 14:05:00.000000',00000000000002396388),('2024-05-27 14:10:00.000000',00000000000002409287),('2024-05-27 14:15:00.000000',00000000000002405288),('2024-05-27 14:20:00.000000',00000000000002430988),('2024-05-27 14:25:00.000000',00000000000002441888),('2024-05-27 14:30:00.000000',00000000000002468467),('2024-05-27 14:35:00.000000',00000000000002461767),('2024-05-27 14:40:00.000000',00000000000002467767),('2024-05-27 14:45:00.000000',00000000000002489467),('2024-05-27 14:50:00.000000',00000000000002505346),('2024-05-27 14:55:00.000000',00000000000002525036),('2024-05-27 15:00:00.000000',00000000000002540036),('2024-05-27 15:05:00.000000',00000000000002567936),('2024-05-27 15:10:00.000000',00000000000002576736),('2024-05-27 15:15:00.000000',00000000000002605436),('2024-05-27 15:20:00.000000',00000000000002623236),('2024-05-27 15:25:00.000000',00000000000002631136),('2024-05-27 15:30:00.000000',00000000000002632336),('2024-05-27 15:35:00.000000',00000000000002634336),('2024-05-27 15:40:00.000000',00000000000002643236),('2024-05-27 15:45:00.000000',00000000000002653236),('2024-05-27 15:50:00.000000',00000000000002661136),('2024-05-27 15:55:00.000000',00000000000002683825),('2024-05-27 16:00:00.000000',00000000000000000000),('2024-05-27 16:05:00.000000',00000000000000016800),('2024-05-27 16:10:00.000000',00000000000000039279),('2024-05-27 16:15:00.000000',00000000000000055979),('2024-05-27 16:20:00.000000',00000000000000058879),('2024-05-27 16:25:00.000000',00000000000000067779),('2024-05-27 16:30:00.000000',00000000000000079579),('2024-05-27 16:35:00.000000',00000000000000132279),('2024-05-27 16:40:00.000000',00000000000000138079),('2024-05-27 16:45:00.000000',00000000000000152679),('2024-05-27 16:50:00.000000',00000000000000143779),('2024-05-27 16:55:00.000000',00000000000000166479),('2024-05-27 17:00:00.000000',00000000000000194148),('2024-05-27 17:05:00.000000',00000000000000218848),('2024-05-27 17:10:00.000000',00000000000000236648),('2024-05-27 17:15:00.000000',00000000000000254548),('2024-05-27 17:20:00.000000',00000000000000296148),('2024-05-27 17:25:00.000000',00000000000000308826),('2024-05-27 17:30:00.000000',00000000000000336326),('2024-05-27 17:35:00.000000',00000000000000350826),('2024-05-27 17:40:00.000000',00000000000000356726),('2024-05-27 17:45:00.000000',00000000000000380926),('2024-05-27 17:50:00.000000',00000000000000389716),('2024-05-27 17:55:00.000000',00000000000000389716),('2024-05-27 18:00:00.000000',00000000000000439616),('2024-05-27 18:05:00.000000',00000000000000442606),('2024-05-27 18:10:00.000000',00000000000000451486),('2024-05-27 18:15:00.000000',00000000000000465186),('2024-05-27 18:20:00.000000',00000000000000467186),('2024-05-27 18:25:00.000000',00000000000000472086),('2024-05-27 18:30:00.000000',00000000000000483886),('2024-05-27 18:35:00.000000',00000000000000494586),('2024-05-27 18:40:00.000000',00000000000000508285),('2024-05-27 18:45:00.000000',00000000000000512284),('2024-05-27 18:50:00.000000',00000000000000512284),('2024-05-27 18:55:00.000000',00000000000000516184),('2024-05-27 19:00:00.000000',00000000000000519174),('2024-05-27 19:05:00.000000',00000000000000533874),('2024-05-27 19:10:00.000000',00000000000000533874),('2024-05-27 19:15:00.000000',00000000000000537774),('2024-05-27 19:20:00.000000',00000000000000548462),('2024-05-27 19:25:00.000000',00000000000000554107),('2024-05-27 19:30:00.000000',00000000000000554207),('2024-05-27 19:35:00.000000',00000000000000554207),('2024-05-27 19:40:00.000000',00000000000000558107),('2024-05-27 19:45:00.000000',00000000000000558107),('2024-05-27 19:50:00.000000',00000000000000561097),('2024-05-27 19:55:00.000000',00000000000000572643),('2024-05-27 20:00:00.000000',00000000000000574743),('2024-05-27 20:05:00.000000',00000000000000574743),('2024-05-27 20:10:00.000000',00000000000000580822),('2024-05-27 20:15:00.000000',00000000000000582822),('2024-05-27 20:20:00.000000',00000000000000585812),('2024-05-27 20:25:00.000000',00000000000000585812),('2024-05-27 20:30:00.000000',00000000000000594712),('2024-05-27 20:35:00.000000',00000000000000644512),('2024-05-27 20:40:00.000000',00000000000000644512),('2024-05-27 20:45:00.000000',00000000000000645612),('2024-05-27 20:50:00.000000',00000000000000650512),('2024-05-27 20:55:00.000000',00000000000000652400),('2024-05-27 21:00:00.000000',00000000000000652400),('2024-05-27 21:05:00.000000',00000000000000658300),('2024-05-27 21:10:00.000000',00000000000000666200),('2024-05-27 21:15:00.000000',00000000000000669100),('2024-05-27 21:20:00.000000',00000000000000669100),('2024-05-27 21:25:00.000000',00000000000000674089),('2024-05-27 21:30:00.000000',00000000000000676089),('2024-05-27 21:35:00.000000',00000000000000679189),('2024-05-27 21:40:00.000000',00000000000000679189),('2024-05-27 21:45:00.000000',00000000000000689978),('2024-05-27 21:50:00.000000',00000000000000694878),('2024-05-27 21:55:00.000000',00000000000000694878),('2024-05-27 22:00:00.000000',00000000000000708678),('2024-05-27 22:05:00.000000',00000000000000715478),('2024-05-27 22:10:00.000000',00000000000000715478),('2024-05-27 22:15:00.000000',00000000000000715478),('2024-05-27 22:20:00.000000',00000000000000716478),('2024-05-27 22:25:00.000000',00000000000000721348),('2024-05-27 22:30:00.000000',00000000000000730148),('2024-05-27 22:35:00.000000',00000000000000730148),('2024-05-27 22:40:00.000000',00000000000000735138),('2024-05-27 22:45:00.000000',00000000000000739138),('2024-05-27 22:50:00.000000',00000000000000739904),('2024-05-27 22:55:00.000000',00000000000000745884),('2024-05-27 23:00:00.000000',00000000000000745884),('2024-05-27 23:05:00.000000',00000000000000745884),('2024-05-27 23:10:00.000000',00000000000000762684),('2024-05-27 23:15:00.000000',00000000000000762784),('2024-05-27 23:20:00.000000',00000000000000762784),('2024-05-27 23:25:00.000000',00000000000000762784),('2024-05-27 23:30:00.000000',00000000000000768684),('2024-05-27 23:35:00.000000',00000000000000779384),('2024-05-27 23:40:00.000000',00000000000000785274),('2024-05-27 23:45:00.000000',00000000000000797164),('2024-05-27 23:50:00.000000',00000000000000814710),('2024-05-27 23:55:00.000000',00000000000000819710),('2024-05-28 00:00:00.000000',00000000000000831510),('2024-05-28 00:05:00.000000',00000000000000839609),('2024-05-28 00:10:00.000000',00000000000000846509),('2024-05-28 00:15:00.000000',00000000000000846509),('2024-05-28 00:20:00.000000',00000000000000846509),('2024-05-28 00:25:00.000000',00000000000000846509),('2024-05-28 00:30:00.000000',00000000000000846509),('2024-05-28 00:35:00.000000',00000000000000847509),('2024-05-28 00:40:00.000000',00000000000000850409),('2024-05-28 00:45:00.000000',00000000000000850509),('2024-05-28 00:50:00.000000',00000000000000850509),('2024-05-28 00:55:00.000000',00000000000000850509),('2024-05-28 01:00:00.000000',00000000000000857508),('2024-05-28 01:05:00.000000',00000000000000858308),('2024-05-28 01:10:00.000000',00000000000000861108),('2024-05-28 01:15:00.000000',00000000000000861108),('2024-05-28 01:20:00.000000',00000000000000864008),('2024-05-28 01:25:00.000000',00000000000000866008),('2024-05-28 01:30:00.000000',00000000000000878808),('2024-05-28 01:35:00.000000',00000000000000888708),('2024-05-28 01:40:00.000000',00000000000000890708),('2024-05-28 01:45:00.000000',00000000000000895508),('2024-05-28 01:50:00.000000',00000000000000911307),('2024-05-28 01:55:00.000000',00000000000000915998),('2024-05-28 02:00:00.000000',00000000000000930788),('2024-05-28 02:05:00.000000',00000000000000930788),('2024-05-28 02:10:00.000000',00000000000000933788),('2024-05-28 02:15:00.000000',00000000000000937988),('2024-05-28 02:20:00.000000',00000000000000949988),('2024-05-28 02:25:00.000000',00000000000000960978),('2024-05-28 02:30:00.000000',00000000000000962978),('2024-05-28 02:35:00.000000',00000000000000962978),('2024-05-28 02:40:00.000000',00000000000000962978),('2024-05-28 02:45:00.000000',00000000000000962978),('2024-05-28 02:50:00.000000',00000000000000965878),('2024-05-28 02:55:00.000000',00000000000000965878),('2024-05-28 03:00:00.000000',00000000000000965878),('2024-05-28 03:05:00.000000',00000000000000978677),('2024-05-28 03:10:00.000000',00000000000000983666),('2024-05-28 03:15:00.000000',00000000000000994189),('2024-05-28 03:20:00.000000',00000000000001006989),('2024-05-28 03:25:00.000000',00000000000001007989),('2024-05-28 03:30:00.000000',00000000000001013889),('2024-05-28 03:35:00.000000',00000000000001020868),('2024-05-28 03:40:00.000000',00000000000001022868),('2024-05-28 03:45:00.000000',00000000000001034768),('2024-05-28 03:50:00.000000',00000000000001054468),('2024-05-28 03:55:00.000000',00000000000001061368),('2024-05-28 04:00:00.000000',00000000000001061368),('2024-05-28 04:05:00.000000',00000000000001072268),('2024-05-28 04:10:00.000000',00000000000001072268),('2024-05-28 04:15:00.000000',00000000000001094868),('2024-05-28 04:20:00.000000',00000000000001096968),('2024-05-28 04:25:00.000000',00000000000001112767),('2024-05-28 04:30:00.000000',00000000000001117757),('2024-05-28 04:35:00.000000',00000000000001130657),('2024-05-28 04:40:00.000000',00000000000001145257),('2024-05-28 04:45:00.000000',00000000000001156577),('2024-05-28 04:50:00.000000',00000000000001181167),('2024-05-28 04:55:00.000000',00000000000001232767),('2024-05-28 05:00:00.000000',00000000000001235667),('2024-05-28 05:05:00.000000',00000000000001246467),('2024-05-28 05:10:00.000000',00000000000001251367),('2024-05-28 05:15:00.000000',00000000000001251367),('2024-05-28 05:20:00.000000',00000000000001251367),('2024-05-28 05:25:00.000000',00000000000001255267),('2024-05-28 05:30:00.000000',00000000000001281067),('2024-05-28 05:35:00.000000',00000000000001302667),('2024-05-28 05:40:00.000000',00000000000001315557),('2024-05-28 05:45:00.000000',00000000000001325557),('2024-05-28 05:50:00.000000',00000000000001341337),('2024-05-28 05:55:00.000000',00000000000001341337),('2024-05-28 06:00:00.000000',00000000000001341537),('2024-05-28 06:05:00.000000',00000000000001354427),('2024-05-28 06:10:00.000000',00000000000001359227),('2024-05-28 06:15:00.000000',00000000000001366017),('2024-05-28 06:20:00.000000',00000000000001366017),('2024-05-28 06:25:00.000000',00000000000001377817),('2024-05-28 06:30:00.000000',00000000000001379817),('2024-05-28 06:35:00.000000',00000000000001389697),('2024-05-28 06:40:00.000000',00000000000001405497),('2024-05-28 06:45:00.000000',00000000000001427097),('2024-05-28 06:50:00.000000',00000000000001422187),('2024-05-28 06:55:00.000000',00000000000001451887),('2024-05-28 07:00:00.000000',00000000000001456331),('2024-05-28 07:05:00.000000',00000000000001462231),('2024-05-28 07:10:00.000000',00000000000001471031),('2024-05-28 07:15:00.000000',00000000000001472031),('2024-05-28 07:20:00.000000',00000000000001483021),('2024-05-28 07:25:00.000000',00000000000001485021),('2024-05-28 07:30:00.000000',00000000000001500821),('2024-05-28 07:35:00.000000',00000000000001503821),('2024-05-28 07:40:00.000000',00000000000001515621),('2024-05-28 07:45:00.000000',00000000000001531321),('2024-05-28 07:50:00.000000',00000000000001528331),('2024-05-28 07:55:00.000000',00000000000001538230),('2024-05-28 08:00:00.000000',00000000000001543220),('2024-05-28 08:05:00.000000',00000000000001554120),('2024-05-28 08:10:00.000000',00000000000001554120),('2024-05-28 08:15:00.000000',00000000000001554120),('2024-05-28 08:20:00.000000',00000000000001583275),('2024-05-28 08:25:00.000000',00000000000001585930),('2024-05-28 08:30:00.000000',00000000000001592730),('2024-05-28 08:35:00.000000',00000000000001604630),('2024-05-28 08:40:00.000000',00000000000001603730),('2024-05-28 08:45:00.000000',00000000000001609630),('2024-05-28 08:50:00.000000',00000000000001609630),('2024-05-28 08:55:00.000000',00000000000001611630),('2024-05-28 09:00:00.000000',00000000000001619430),('2024-05-28 09:05:00.000000',00000000000001653000),('2024-05-28 09:10:00.000000',00000000000001657000),('2024-05-28 09:15:00.000000',00000000000001653100),('2024-05-28 09:20:00.000000',00000000000001653100),('2024-05-28 09:25:00.000000',00000000000001671800),('2024-05-28 09:30:00.000000',00000000000001675200),('2024-05-28 09:35:00.000000',00000000000001678100),('2024-05-28 09:40:00.000000',00000000000001702400),('2024-05-28 09:45:00.000000',00000000000001708300),('2024-05-28 09:50:00.000000',00000000000001727000),('2024-05-28 09:55:00.000000',00000000000001731900),('2024-05-28 10:00:00.000000',00000000000001738800),('2024-05-28 10:05:00.000000',00000000000001738800),('2024-05-28 10:10:00.000000',00000000000001754500),('2024-05-28 10:15:00.000000',00000000000001774290),('2024-05-28 10:20:00.000000',00000000000001775290),('2024-05-28 10:25:00.000000',00000000000001789070),('2024-05-28 10:30:00.000000',00000000000001808770),('2024-05-28 10:35:00.000000',00000000000001828470),('2024-05-28 10:40:00.000000',00000000000001830470),('2024-05-28 10:45:00.000000',00000000000001842270),('2024-05-28 10:50:00.000000',00000000000001852170),('2024-05-28 10:55:00.000000',00000000000001858070),('2024-05-28 11:00:00.000000',00000000000001871770),('2024-05-28 11:05:00.000000',00000000000001881570),('2024-05-28 11:10:00.000000',00000000000001882570),('2024-05-28 11:15:00.000000',00000000000001882570),('2024-05-28 11:20:00.000000',00000000000001902270),('2024-05-28 11:25:00.000000',00000000000001935670),('2024-05-28 11:30:00.000000',00000000000001944570),('2024-05-28 11:35:00.000000',00000000000001950770),('2024-05-28 11:40:00.000000',00000000000001961570),('2024-05-28 11:45:00.000000',00000000000001975370),('2024-05-28 11:50:00.000000',00000000000001980360),('2024-05-28 11:55:00.000000',00000000000001980360),('2024-05-28 12:00:00.000000',00000000000001989160),('2024-05-28 12:05:00.000000',00000000000001989160),('2024-05-28 12:10:00.000000',00000000000001992060),('2024-05-28 12:15:00.000000',00000000000002001960),('2024-05-28 12:20:00.000000',00000000000002012760),('2024-05-28 12:25:00.000000',00000000000002036360),('2024-05-28 12:30:00.000000',00000000000002036460),('2024-05-28 12:35:00.000000',00000000000002059060),('2024-05-28 12:40:00.000000',00000000000002053160),('2024-05-28 12:45:00.000000',00000000000002064059),('2024-05-28 12:50:00.000000',00000000000002078759),('2024-05-28 12:55:00.000000',00000000000002084647),('2024-05-28 13:00:00.000000',00000000000002097547),('2024-05-28 13:05:00.000000',00000000000002101536),('2024-05-28 13:10:00.000000',00000000000002153135),('2024-05-28 13:15:00.000000',00000000000002163035),('2024-05-28 13:20:00.000000',00000000000002171835),('2024-05-28 13:25:00.000000',00000000000002184635),('2024-05-28 13:30:00.000000',00000000000002184735),('2024-05-28 13:35:00.000000',00000000000002195535),('2024-05-28 13:40:00.000000',00000000000002207535),('2024-05-28 13:45:00.000000',00000000000002219435),('2024-05-28 13:50:00.000000',00000000000002220435),('2024-05-28 13:55:00.000000',00000000000002245575),('2024-05-28 14:00:00.000000',00000000000002258141),('2024-05-28 14:05:00.000000',00000000000002269841),('2024-05-28 14:10:00.000000',00000000000002278541),('2024-05-28 14:15:00.000000',00000000000002284541),('2024-05-28 14:20:00.000000',00000000000002296441),('2024-05-28 14:25:00.000000',00000000000002301341),('2024-05-28 14:30:00.000000',00000000000002308241),('2024-05-28 14:35:00.000000',00000000000002309341),('2024-05-28 14:40:00.000000',00000000000002327941),('2024-05-28 14:45:00.000000',00000000000002338741),('2024-05-28 14:50:00.000000',00000000000002361441),('2024-05-28 14:55:00.000000',00000000000002373441),('2024-05-28 15:00:00.000000',00000000000002380441),('2024-05-28 15:05:00.000000',00000000000002392441),('2024-05-28 15:10:00.000000',00000000000002406341),('2024-05-28 15:15:00.000000',00000000000002424141),('2024-05-28 15:20:00.000000',00000000000002421241),('2024-05-28 15:25:00.000000',00000000000002517930),('2024-05-28 15:30:00.000000',00000000000002538496),('2024-05-28 15:35:00.000000',00000000000002594896),('2024-05-28 15:40:00.000000',00000000000002635396),('2024-05-28 15:45:00.000000',00000000000002668896),('2024-05-28 15:50:00.000000',00000000000002668296),('2024-05-28 15:55:00.000000',00000000000002682196),('2024-05-28 16:00:00.000000',00000000000000000000),('2024-05-28 16:05:00.000000',00000000000000033400),('2024-05-28 16:10:00.000000',00000000000000049180),('2024-05-28 16:15:00.000000',00000000000000061080),('2024-05-28 16:20:00.000000',00000000000000097980),('2024-05-28 16:25:00.000000',00000000000000104880),('2024-05-28 16:30:00.000000',00000000000000126680),('2024-05-28 16:35:00.000000',00000000000000163958),('2024-05-28 16:40:00.000000',00000000000000195758),('2024-05-28 16:45:00.000000',00000000000000207958),('2024-05-28 16:50:00.000000',00000000000000242348),('2024-05-28 16:55:00.000000',00000000000000299637),('2024-05-28 17:00:00.000000',00000000000000335017),('2024-05-28 17:05:00.000000',00000000000000379607),('2024-05-28 17:10:00.000000',00000000000000382597),('2024-05-28 17:15:00.000000',00000000000000415987),('2024-05-28 17:20:00.000000',00000000000000420087),('2024-05-28 17:25:00.000000',00000000000000425987),('2024-05-28 17:30:00.000000',00000000000000465787),('2024-05-28 17:35:00.000000',00000000000000527287),('2024-05-28 17:40:00.000000',00000000000000553077),('2024-05-28 17:45:00.000000',00000000000000566465),('2024-05-28 17:50:00.000000',00000000000000640765),('2024-05-28 17:55:00.000000',00000000000000648565),('2024-05-28 18:00:00.000000',00000000000000649565),('2024-05-28 18:05:00.000000',00000000000000667355),('2024-05-28 18:10:00.000000',00000000000000679245),('2024-05-28 18:15:00.000000',00000000000000695045),('2024-05-28 18:20:00.000000',00000000000000707934),('2024-05-28 18:25:00.000000',00000000000000712934),('2024-05-28 18:30:00.000000',00000000000000707334),('2024-05-28 18:35:00.000000',00000000000000721034),('2024-05-28 18:40:00.000000',00000000000000727024),('2024-05-28 18:45:00.000000',00000000000000732014),('2024-05-28 18:50:00.000000',00000000000000737814),('2024-05-28 18:55:00.000000',00000000000000740814),('2024-05-28 19:00:00.000000',00000000000000749804),('2024-05-28 19:05:00.000000',00000000000000762604),('2024-05-28 19:10:00.000000',00000000000000769593),('2024-05-28 19:15:00.000000',00000000000000779493),('2024-05-28 19:20:00.000000',00000000000000788043),('2024-05-28 19:25:00.000000',00000000000000790043),('2024-05-28 19:30:00.000000',00000000000000794033),('2024-05-28 19:35:00.000000',00000000000000800033),('2024-05-28 19:40:00.000000',00000000000000800033),('2024-05-28 19:45:00.000000',00000000000000802022),('2024-05-28 19:50:00.000000',00000000000000802022),('2024-05-28 19:55:00.000000',00000000000000804022),('2024-05-28 20:00:00.000000',00000000000000807222),('2024-05-28 20:05:00.000000',00000000000000810122),('2024-05-28 20:10:00.000000',00000000000000812122),('2024-05-28 20:15:00.000000',00000000000000814122),('2024-05-28 20:20:00.000000',00000000000000816122),('2024-05-28 20:25:00.000000',00000000000000819122),('2024-05-28 20:30:00.000000',00000000000000819122),('2024-05-28 20:35:00.000000',00000000000000819122),('2024-05-28 20:40:00.000000',00000000000000821122),('2024-05-28 20:45:00.000000',00000000000000821122),('2024-05-28 20:50:00.000000',00000000000000827022),('2024-05-28 20:55:00.000000',00000000000000828012),('2024-05-28 21:00:00.000000',00000000000000828678),('2024-05-28 21:05:00.000000',00000000000000831578),('2024-05-28 21:10:00.000000',00000000000000831578),('2024-05-28 21:15:00.000000',00000000000000831578),('2024-05-28 21:20:00.000000',00000000000000831578),('2024-05-28 21:25:00.000000',00000000000000833578),('2024-05-28 21:30:00.000000',00000000000000833578),('2024-05-28 21:35:00.000000',00000000000000833578),('2024-05-28 21:40:00.000000',00000000000000833578),('2024-05-28 21:45:00.000000',00000000000000833578),('2024-05-28 21:50:00.000000',00000000000000840478),('2024-05-28 21:55:00.000000',00000000000000840478),('2024-05-28 22:00:00.000000',00000000000000842478),('2024-05-28 22:05:00.000000',00000000000000842478),('2024-05-28 22:10:00.000000',00000000000000844478),('2024-05-28 22:15:00.000000',00000000000000848568),('2024-05-28 22:20:00.000000',00000000000000848668),('2024-05-28 22:25:00.000000',00000000000000856568),('2024-05-28 22:30:00.000000',00000000000000860568),('2024-05-28 22:35:00.000000',00000000000000866468),('2024-05-28 22:40:00.000000',00000000000000867468),('2024-05-28 22:45:00.000000',00000000000000869468),('2024-05-28 22:50:00.000000',00000000000000885168),('2024-05-28 22:55:00.000000',00000000000000891068),('2024-05-28 23:00:00.000000',00000000000000891068),('2024-05-28 23:05:00.000000',00000000000000891068),('2024-05-28 23:10:00.000000',00000000000000905968),('2024-05-28 23:15:00.000000',00000000000000907968),('2024-05-28 23:20:00.000000',00000000000000907968),('2024-05-28 23:25:00.000000',00000000000000907968),('2024-05-28 23:30:00.000000',00000000000000914868),('2024-05-28 23:35:00.000000',00000000000000918868),('2024-05-28 23:40:00.000000',00000000000000924467),('2024-05-28 23:45:00.000000',00000000000000936467),('2024-05-28 23:50:00.000000',00000000000000939467),('2024-05-28 23:55:00.000000',00000000000000939467),('2024-05-29 00:00:00.000000',00000000000000944457),('2024-05-29 00:05:00.000000',00000000000000944457),('2024-05-29 00:10:00.000000',00000000000000952357),('2024-05-29 00:15:00.000000',00000000000000952357),('2024-05-29 00:20:00.000000',00000000000000953357),('2024-05-29 00:25:00.000000',00000000000000956257),('2024-05-29 00:30:00.000000',00000000000000956257),('2024-05-29 00:35:00.000000',00000000000000980757),('2024-05-29 00:40:00.000000',00000000000000972857),('2024-05-29 00:45:00.000000',00000000000000983647),('2024-05-29 00:50:00.000000',00000000000000989547),('2024-05-29 00:55:00.000000',00000000000000989547),('2024-05-29 01:00:00.000000',00000000000000991547),('2024-05-29 01:05:00.000000',00000000000000992547),('2024-05-29 01:10:00.000000',00000000000001001447),('2024-05-29 01:15:00.000000',00000000000001007347),('2024-05-29 01:20:00.000000',00000000000001025047),('2024-05-29 01:25:00.000000',00000000000001029947),('2024-05-29 01:30:00.000000',00000000000001037847),('2024-05-29 01:35:00.000000',00000000000001040747),('2024-05-29 01:40:00.000000',00000000000001051647),('2024-05-29 01:45:00.000000',00000000000001063536),('2024-05-29 01:50:00.000000',00000000000001147426),('2024-05-29 01:55:00.000000',00000000000001150326),('2024-05-29 02:00:00.000000',00000000000001155226),('2024-05-29 02:05:00.000000',00000000000001155226),('2024-05-29 02:10:00.000000',00000000000001167026),('2024-05-29 02:15:00.000000',00000000000001172514),('2024-05-29 02:20:00.000000',00000000000001184314),('2024-05-29 02:25:00.000000',00000000000001187304),('2024-05-29 02:30:00.000000',00000000000001196004),('2024-05-29 02:35:00.000000',00000000000001204904),('2024-05-29 02:40:00.000000',00000000000001221404),('2024-05-29 02:45:00.000000',00000000000001226304),('2024-05-29 02:50:00.000000',00000000000001246804),('2024-05-29 02:55:00.000000',00000000000001248804),('2024-05-29 03:00:00.000000',00000000000001260694),('2024-05-29 03:05:00.000000',00000000000001279194),('2024-05-29 03:10:00.000000',00000000000001279494),('2024-05-29 03:15:00.000000',00000000000001286794),('2024-05-29 03:20:00.000000',00000000000001301394),('2024-05-29 03:25:00.000000',00000000000001314084),('2024-05-29 03:30:00.000000',00000000000001340684),('2024-05-29 03:35:00.000000',00000000000001352474),('2024-05-29 03:40:00.000000',00000000000001363274),('2024-05-29 03:45:00.000000',00000000000001379774),('2024-05-29 03:50:00.000000',00000000000001382674),('2024-05-29 03:55:00.000000',00000000000001385574),('2024-05-29 04:00:00.000000',00000000000001404374),('2024-05-29 04:05:00.000000',00000000000001407374),('2024-05-29 04:10:00.000000',00000000000001415274),('2024-05-29 04:15:00.000000',00000000000001438874),('2024-05-29 04:20:00.000000',00000000000001449574),('2024-05-29 04:25:00.000000',00000000000001454474),('2024-05-29 04:30:00.000000',00000000000001487874),('2024-05-29 04:35:00.000000',00000000000001788564),('2024-05-29 04:40:00.000000',00000000000001787564),('2024-05-29 04:45:00.000000',00000000000001799464),('2024-05-29 04:50:00.000000',00000000000001820864),('2024-05-29 04:55:00.000000',00000000000001850764),('2024-05-29 05:00:00.000000',00000000000001860553),('2024-05-29 05:05:00.000000',00000000000001882220),('2024-05-29 05:10:00.000000',00000000000001901710),('2024-05-29 05:15:00.000000',00000000000001931110),('2024-05-29 05:20:00.000000',00000000000001927410),('2024-05-29 05:25:00.000000',00000000000001949110),('2024-05-29 05:30:00.000000',00000000000001962710),('2024-05-29 05:35:00.000000',00000000000001965610),('2024-05-29 05:40:00.000000',00000000000002007510),('2024-05-29 05:45:00.000000',00000000000002031110),('2024-05-29 05:50:00.000000',00000000000002031110),('2024-05-29 05:55:00.000000',00000000000002034110),('2024-05-29 06:00:00.000000',00000000000002046800),('2024-05-29 06:05:00.000000',00000000000002038900),('2024-05-29 06:10:00.000000',00000000000002045800),('2024-05-29 06:15:00.000000',00000000000002073490),('2024-05-29 06:20:00.000000',00000000000002077390),('2024-05-29 06:25:00.000000',00000000000002081390),('2024-05-29 06:30:00.000000',00000000000002090990),('2024-05-29 06:35:00.000000',00000000000002098890),('2024-05-29 06:40:00.000000',00000000000002101790),('2024-05-29 06:45:00.000000',00000000000002120490),('2024-05-29 06:50:00.000000',00000000000002120490),('2024-05-29 06:55:00.000000',00000000000002135479),('2024-05-29 07:00:00.000000',00000000000002141667),('2024-05-29 07:05:00.000000',00000000000002144667),('2024-05-29 07:10:00.000000',00000000000002145667),('2024-05-29 07:15:00.000000',00000000000002160367),('2024-05-29 07:20:00.000000',00000000000002175067),('2024-05-29 07:25:00.000000',00000000000002177667),('2024-05-29 07:30:00.000000',00000000000002172767),('2024-05-29 07:35:00.000000',00000000000002177167),('2024-05-29 07:40:00.000000',00000000000002224967),('2024-05-29 07:45:00.000000',00000000000002242667),('2024-05-29 07:50:00.000000',00000000000002253367),('2024-05-29 07:55:00.000000',00000000000002267167),('2024-05-29 08:00:00.000000',00000000000002279967),('2024-05-29 08:05:00.000000',00000000000002296767),('2024-05-29 08:10:00.000000',00000000000002316367),('2024-05-29 08:15:00.000000',00000000000002319367),('2024-05-29 08:20:00.000000',00000000000002343136),('2024-05-29 08:25:00.000000',00000000000002356883),('2024-05-29 08:30:00.000000',00000000000002387483),('2024-05-29 08:35:00.000000',00000000000002403273),('2024-05-29 08:40:00.000000',00000000000002397471),('2024-05-29 08:45:00.000000',00000000000002400771),('2024-05-29 08:50:00.000000',00000000000002424471),('2024-05-29 08:55:00.000000',00000000000002436471),('2024-05-29 09:00:00.000000',00000000000002437471),('2024-05-29 09:05:00.000000',00000000000002449171),('2024-05-29 09:10:00.000000',00000000000002451271),('2024-05-29 09:15:00.000000',00000000000002472171),('2024-05-29 09:20:00.000000',00000000000002474171),('2024-05-29 09:25:00.000000',00000000000002474271),('2024-05-29 09:30:00.000000',00000000000002487171),('2024-05-29 09:35:00.000000',00000000000002480271),('2024-05-29 09:40:00.000000',00000000000002484271),('2024-05-29 09:45:00.000000',00000000000002500871),('2024-05-29 09:50:00.000000',00000000000002517517),('2024-05-29 09:55:00.000000',00000000000002522417),('2024-05-29 10:00:00.000000',00000000000002547207),('2024-05-29 10:05:00.000000',00000000000002556107),('2024-05-29 10:10:00.000000',00000000000002559097),('2024-05-29 10:15:00.000000',00000000000002581697),('2024-05-29 10:20:00.000000',00000000000002599486),('2024-05-29 10:25:00.000000',00000000000002603386),('2024-05-29 10:30:00.000000',00000000000002607375),('2024-05-29 10:35:00.000000',00000000000002617275),('2024-05-29 10:40:00.000000',00000000000002621175),('2024-05-29 10:45:00.000000',00000000000002622175),('2024-05-29 10:50:00.000000',00000000000002628375),('2024-05-29 10:55:00.000000',00000000000002633275),('2024-05-29 11:00:00.000000',00000000000002637375),('2024-05-29 11:05:00.000000',00000000000002657075),('2024-05-29 11:10:00.000000',00000000000002665663),('2024-05-29 11:15:00.000000',00000000000002666663),('2024-05-29 11:20:00.000000',00000000000002685563),('2024-05-29 11:25:00.000000',00000000000002703363),('2024-05-29 11:30:00.000000',00000000000002688963),('2024-05-29 11:35:00.000000',00000000000002695862),('2024-05-29 11:40:00.000000',00000000000002708662),('2024-05-29 11:45:00.000000',00000000000002717661),('2024-05-29 11:50:00.000000',00000000000002727461),('2024-05-29 11:55:00.000000',00000000000002749161),('2024-05-29 12:00:00.000000',00000000000002783649),('2024-05-29 12:05:00.000000',00000000000002790549),('2024-05-29 12:10:00.000000',00000000000002798439),('2024-05-29 12:15:00.000000',00000000000002806439),('2024-05-29 12:20:00.000000',00000000000002814239),('2024-05-29 12:25:00.000000',00000000000002841018),('2024-05-29 12:30:00.000000',00000000000002843018),('2024-05-29 12:35:00.000000',00000000000002843018),('2024-05-29 12:40:00.000000',00000000000002843018),('2024-05-29 12:45:00.000000',00000000000002855808),('2024-05-29 12:50:00.000000',00000000000002863708),('2024-05-29 12:55:00.000000',00000000000002870808),('2024-05-29 13:00:00.000000',00000000000002888308),('2024-05-29 13:05:00.000000',00000000000002897963),('2024-05-29 13:10:00.000000',00000000000002898963),('2024-05-29 13:15:00.000000',00000000000002902863),('2024-05-29 13:20:00.000000',00000000000002916752),('2024-05-29 13:25:00.000000',00000000000002931452),('2024-05-29 13:30:00.000000',00000000000002938452),('2024-05-29 13:35:00.000000',00000000000002952352),('2024-05-29 13:40:00.000000',00000000000002974952),('2024-05-29 13:45:00.000000',00000000000002989540),('2024-05-29 13:50:00.000000',00000000000003000140),('2024-05-29 13:55:00.000000',00000000000003000140),('2024-05-29 14:00:00.000000',00000000000003011940),('2024-05-29 14:05:00.000000',00000000000003169940),('2024-05-29 14:10:00.000000',00000000000003180640),('2024-05-29 14:15:00.000000',00000000000003199240),('2024-05-29 14:20:00.000000',00000000000003215140),('2024-05-29 14:25:00.000000',00000000000003232920),('2024-05-29 14:30:00.000000',00000000000003235920),('2024-05-29 14:35:00.000000',00000000000003255620),('2024-05-29 14:40:00.000000',00000000000003262420),('2024-05-29 14:45:00.000000',00000000000003273220),('2024-05-29 14:50:00.000000',00000000000003302010),('2024-05-29 14:55:00.000000',00000000000003320810),('2024-05-29 15:00:00.000000',00000000000003346410),('2024-05-29 15:05:00.000000',00000000000003353299),('2024-05-29 15:10:00.000000',00000000000003363199),('2024-05-29 15:15:00.000000',00000000000003388999),('2024-05-29 15:20:00.000000',00000000000003414699),('2024-05-29 15:25:00.000000',00000000000003431499),('2024-05-29 15:30:00.000000',00000000000003449389),('2024-05-29 15:35:00.000000',00000000000003466168),('2024-05-29 15:40:00.000000',00000000000003487958),('2024-05-29 15:45:00.000000',00000000000003623258),('2024-05-29 15:50:00.000000',00000000000003635958),('2024-05-29 15:55:00.000000',00000000000003666548),('2024-05-29 16:00:00.000000',00000000000000000000),('2024-05-29 16:05:00.000000',00000000000000058300),('2024-05-29 16:10:00.000000',00000000000000066100),('2024-05-29 16:15:00.000000',00000000000000066100),('2024-05-29 16:20:00.000000',00000000000000080800),('2024-05-29 16:25:00.000000',00000000000000098900),('2024-05-29 16:30:00.000000',00000000000000113800),('2024-05-29 16:35:00.000000',00000000000000142900),('2024-05-29 16:40:00.000000',00000000000000151900),('2024-05-29 16:45:00.000000',00000000000000164000),('2024-05-29 16:50:00.000000',00000000000000229500),('2024-05-29 16:55:00.000000',00000000000000240200),('2024-05-29 17:00:00.000000',00000000000000250090),('2024-05-29 17:05:00.000000',00000000000000272779),('2024-05-29 17:10:00.000000',00000000000000291679),('2024-05-29 17:15:00.000000',00000000000000313669),('2024-05-29 17:20:00.000000',00000000000000340369),('2024-05-29 17:25:00.000000',00000000000000355169),('2024-05-29 17:30:00.000000',00000000000000371969),('2024-05-29 17:35:00.000000',00000000000000373069),('2024-05-29 17:40:00.000000',00000000000000377069),('2024-05-29 17:45:00.000000',00000000000000418269),('2024-05-29 17:50:00.000000',00000000000000422169),('2024-05-29 17:55:00.000000',00000000000000422169),('2024-05-29 18:00:00.000000',00000000000000451069),('2024-05-29 18:05:00.000000',00000000000000458169),('2024-05-29 18:10:00.000000',00000000000000464069),('2024-05-29 18:15:00.000000',00000000000000464269),('2024-05-29 18:20:00.000000',00000000000000477169),('2024-05-29 18:25:00.000000',00000000000000479169),('2024-05-29 18:30:00.000000',00000000000000489059),('2024-05-29 18:35:00.000000',00000000000000491159),('2024-05-29 18:40:00.000000',00000000000000491159),('2024-05-29 18:45:00.000000',00000000000000494059),('2024-05-29 18:50:00.000000',00000000000000498059),('2024-05-29 18:55:00.000000',00000000000000501959),('2024-05-29 19:00:00.000000',00000000000000513759),('2024-05-29 19:05:00.000000',00000000000000513759),('2024-05-29 19:10:00.000000',00000000000000517758),('2024-05-29 19:15:00.000000',00000000000000528658),('2024-05-29 19:20:00.000000',00000000000000528658),('2024-05-29 19:25:00.000000',00000000000000534558),('2024-05-29 19:30:00.000000',00000000000000534558),('2024-05-29 19:35:00.000000',00000000000000535558),('2024-05-29 19:40:00.000000',00000000000000536558),('2024-05-29 19:45:00.000000',00000000000000536558),('2024-05-29 19:50:00.000000',00000000000000548448),('2024-05-29 19:55:00.000000',00000000000000556348),('2024-05-29 20:00:00.000000',00000000000000556348),('2024-05-29 20:05:00.000000',00000000000000556348),('2024-05-29 20:10:00.000000',00000000000000556348),('2024-05-29 20:15:00.000000',00000000000000556348),('2024-05-29 20:20:00.000000',00000000000000556348),('2024-05-29 20:25:00.000000',00000000000000557348),('2024-05-29 20:30:00.000000',00000000000000558548),('2024-05-29 20:35:00.000000',00000000000000558548),('2024-05-29 20:40:00.000000',00000000000000566448),('2024-05-29 20:45:00.000000',00000000000000566448),('2024-05-29 20:50:00.000000',00000000000000569448),('2024-05-29 20:55:00.000000',00000000000000569448),('2024-05-29 21:00:00.000000',00000000000000569448),('2024-05-29 21:05:00.000000',00000000000000585248),('2024-05-29 21:10:00.000000',00000000000000586248),('2024-05-29 21:15:00.000000',00000000000000589148),('2024-05-29 21:20:00.000000',00000000000000589148),('2024-05-29 21:25:00.000000',00000000000000591148),('2024-05-29 21:30:00.000000',00000000000000595048),('2024-05-29 21:35:00.000000',00000000000000596048),('2024-05-29 21:40:00.000000',00000000000000602048),('2024-05-29 21:45:00.000000',00000000000000603148),('2024-05-29 21:50:00.000000',00000000000000613804),('2024-05-29 21:55:00.000000',00000000000000634604),('2024-05-29 22:00:00.000000',00000000000000649404),('2024-05-29 22:05:00.000000',00000000000000663294),('2024-05-29 22:10:00.000000',00000000000000729083),('2024-05-29 22:15:00.000000',00000000000000735061),('2024-05-29 22:20:00.000000',00000000000000736161),('2024-05-29 22:25:00.000000',00000000000000750061),('2024-05-29 22:30:00.000000',00000000000000759661),('2024-05-29 22:35:00.000000',00000000000000767461),('2024-05-29 22:40:00.000000',00000000000000768461),('2024-05-29 22:45:00.000000',00000000000000769461),('2024-05-29 22:50:00.000000',00000000000000769461),('2024-05-29 22:55:00.000000',00000000000000769461),('2024-05-29 23:00:00.000000',00000000000000770461),('2024-05-29 23:05:00.000000',00000000000000772461),('2024-05-29 23:10:00.000000',00000000000000772461),('2024-05-29 23:15:00.000000',00000000000000772461),('2024-05-29 23:20:00.000000',00000000000000786261),('2024-05-29 23:25:00.000000',00000000000000787261),('2024-05-29 23:30:00.000000',00000000000000795161),('2024-05-29 23:35:00.000000',00000000000000796261),('2024-05-29 23:40:00.000000',00000000000000801260),('2024-05-29 23:45:00.000000',00000000000000806570),('2024-05-29 23:50:00.000000',00000000000000844370),('2024-05-29 23:55:00.000000',00000000000000844370),('2024-05-30 00:00:00.000000',00000000000000852270),('2024-05-30 00:05:00.000000',00000000000000857170),('2024-05-30 00:10:00.000000',00000000000000858170),('2024-05-30 00:15:00.000000',00000000000000860170),('2024-05-30 00:20:00.000000',00000000000001014570),('2024-05-30 00:25:00.000000',00000000000001024470),('2024-05-30 00:30:00.000000',00000000000001035270),('2024-05-30 00:35:00.000000',00000000000001056360),('2024-05-30 00:40:00.000000',00000000000001073149),('2024-05-30 00:45:00.000000',00000000000001076249),('2024-05-30 00:50:00.000000',00000000000001085149),('2024-05-30 00:55:00.000000',00000000000001088149),('2024-05-30 01:00:00.000000',00000000000001092349),('2024-05-30 01:05:00.000000',00000000000001100949),('2024-05-30 01:10:00.000000',00000000000001131449),('2024-05-30 01:15:00.000000',00000000000001138239),('2024-05-30 01:20:00.000000',00000000000001141239),('2024-05-30 01:25:00.000000',00000000000001155139),('2024-05-30 01:30:00.000000',00000000000001156139),('2024-05-30 01:35:00.000000',00000000000001160039),('2024-05-30 01:40:00.000000',00000000000001167839),('2024-05-30 01:45:00.000000',00000000000001175739),('2024-05-30 01:50:00.000000',00000000000001179739),('2024-05-30 01:55:00.000000',00000000000001185739),('2024-05-30 02:00:00.000000',00000000000001195639),('2024-05-30 02:05:00.000000',00000000000001201739),('2024-05-30 02:10:00.000000',00000000000001213639),('2024-05-30 02:15:00.000000',00000000000001227318),('2024-05-30 02:20:00.000000',00000000000001227318),('2024-05-30 02:25:00.000000',00000000000001243118),('2024-05-30 02:30:00.000000',00000000000001245118),('2024-05-30 02:35:00.000000',00000000000001252018),('2024-05-30 02:40:00.000000',00000000000001254118),('2024-05-30 02:45:00.000000',00000000000001260018),('2024-05-30 02:50:00.000000',00000000000001266018),('2024-05-30 02:55:00.000000',00000000000001271117),('2024-05-30 03:00:00.000000',00000000000001275117),('2024-05-30 03:05:00.000000',00000000000001276117),('2024-05-30 03:10:00.000000',00000000000001279017),('2024-05-30 03:15:00.000000',00000000000001280017),('2024-05-30 03:20:00.000000',00000000000001281117),('2024-05-30 03:25:00.000000',00000000000001294017),('2024-05-30 03:30:00.000000',00000000000001302917),('2024-05-30 03:35:00.000000',00000000000001307917),('2024-05-30 03:40:00.000000',00000000000001314517),('2024-05-30 03:45:00.000000',00000000000001314517),('2024-05-30 03:50:00.000000',00000000000001313997),('2024-05-30 03:55:00.000000',00000000000001316097),('2024-05-30 04:00:00.000000',00000000000001321076),('2024-05-30 04:05:00.000000',00000000000001327976),('2024-05-30 04:10:00.000000',00000000000001328976),('2024-05-30 04:15:00.000000',00000000000001339976),('2024-05-30 04:20:00.000000',00000000000001343876),('2024-05-30 04:25:00.000000',00000000000001350876),('2024-05-30 04:30:00.000000',00000000000001357976),('2024-05-30 04:35:00.000000',00000000000001373976),('2024-05-30 04:40:00.000000',00000000000001379976),('2024-05-30 04:45:00.000000',00000000000001398066),('2024-05-30 04:50:00.000000',00000000000001406966),('2024-05-30 04:55:00.000000',00000000000001414965),('2024-05-30 05:00:00.000000',00000000000001455545),('2024-05-30 05:05:00.000000',00000000000001460545),('2024-05-30 05:10:00.000000',00000000000001468445),('2024-05-30 05:15:00.000000',00000000000001475445),('2024-05-30 05:20:00.000000',00000000000001480211),('2024-05-30 05:25:00.000000',00000000000001489070),('2024-05-30 05:30:00.000000',00000000000001504950),('2024-05-30 05:35:00.000000',00000000000001520750),('2024-05-30 05:40:00.000000',00000000000001534650),('2024-05-30 05:45:00.000000',00000000000001549550),('2024-05-30 05:50:00.000000',00000000000001553639),('2024-05-30 05:55:00.000000',00000000000001566539),('2024-05-30 06:00:00.000000',00000000000001583539),('2024-05-30 06:05:00.000000',00000000000001594439),('2024-05-30 06:10:00.000000',00000000000001600439),('2024-05-30 06:15:00.000000',00000000000001611339),('2024-05-30 06:20:00.000000',00000000000001628039),('2024-05-30 06:25:00.000000',00000000000001630039),('2024-05-30 06:30:00.000000',00000000000001658429),('2024-05-30 06:35:00.000000',00000000000001677219),('2024-05-30 06:40:00.000000',00000000000001682119),('2024-05-30 06:45:00.000000',00000000000001687909),('2024-05-30 06:50:00.000000',00000000000001691109),('2024-05-30 06:55:00.000000',00000000000001725709),('2024-05-30 07:00:00.000000',00000000000001729709),('2024-05-30 07:05:00.000000',00000000000001735809),('2024-05-30 07:10:00.000000',00000000000001758609),('2024-05-30 07:15:00.000000',00000000000002012609),('2024-05-30 07:20:00.000000',00000000000002017509),('2024-05-30 07:25:00.000000',00000000000002023309),('2024-05-30 07:30:00.000000',00000000000002027309),('2024-05-30 07:35:00.000000',00000000000002033399),('2024-05-30 07:40:00.000000',00000000000002045499),('2024-05-30 07:45:00.000000',00000000000002049499),('2024-05-30 07:50:00.000000',00000000000002050499),('2024-05-30 07:55:00.000000',00000000000002052499),('2024-05-30 08:00:00.000000',00000000000002052499),('2024-05-30 08:05:00.000000',00000000000002054499),('2024-05-30 08:10:00.000000',00000000000002058499),('2024-05-30 08:15:00.000000',00000000000002038599),('2024-05-30 08:20:00.000000',00000000000002062399),('2024-05-30 08:25:00.000000',00000000000002071299),('2024-05-30 08:30:00.000000',00000000000002072399),('2024-05-30 08:35:00.000000',00000000000002073399),('2024-05-30 08:40:00.000000',00000000000002070499),('2024-05-30 08:45:00.000000',00000000000002079299),('2024-05-30 08:50:00.000000',00000000000002079299),('2024-05-30 08:55:00.000000',00000000000002094168),('2024-05-30 09:00:00.000000',00000000000002095268),('2024-05-30 09:05:00.000000',00000000000002099258),('2024-05-30 09:10:00.000000',00000000000002104248),('2024-05-30 09:15:00.000000',00000000000002122938),('2024-05-30 09:20:00.000000',00000000000002173838),('2024-05-30 09:25:00.000000',00000000000002185638),('2024-05-30 09:30:00.000000',00000000000002211193),('2024-05-30 09:35:00.000000',00000000000002214193),('2024-05-30 09:40:00.000000',00000000000002216193),('2024-05-30 09:45:00.000000',00000000000002268893),('2024-05-30 09:50:00.000000',00000000000002268893),('2024-05-30 09:55:00.000000',00000000000002270883),('2024-05-30 10:00:00.000000',00000000000002276783),('2024-05-30 10:05:00.000000',00000000000002277783),('2024-05-30 10:10:00.000000',00000000000002288683),('2024-05-30 10:15:00.000000',00000000000002289783),('2024-05-30 10:20:00.000000',00000000000002298683),('2024-05-30 10:25:00.000000',00000000000002307483),('2024-05-30 10:30:00.000000',00000000000002312583),('2024-05-30 10:35:00.000000',00000000000002314583),('2024-05-30 10:40:00.000000',00000000000002315583),('2024-05-30 10:45:00.000000',00000000000002318583),('2024-05-30 10:50:00.000000',00000000000002326473),('2024-05-30 10:55:00.000000',00000000000002335473),('2024-05-30 11:00:00.000000',00000000000002340473),('2024-05-30 11:05:00.000000',00000000000002358173),('2024-05-30 11:10:00.000000',00000000000002368073),('2024-05-30 11:15:00.000000',00000000000002379773),('2024-05-30 11:20:00.000000',00000000000002388339),('2024-05-30 11:25:00.000000',00000000000002393329),('2024-05-30 11:30:00.000000',00000000000002407219),('2024-05-30 11:35:00.000000',00000000000002412198),('2024-05-30 11:40:00.000000',00000000000002429788),('2024-05-30 11:45:00.000000',00000000000002451466),('2024-05-30 11:50:00.000000',00000000000002455146),('2024-05-30 11:55:00.000000',00000000000002455146),('2024-05-30 12:00:00.000000',00000000000002459145),('2024-05-30 12:05:00.000000',00000000000002459145),('2024-05-30 12:10:00.000000',00000000000002472845),('2024-05-30 12:15:00.000000',00000000000002484845),('2024-05-30 12:20:00.000000',00000000000002487745),('2024-05-30 12:25:00.000000',00000000000002488745),('2024-05-30 12:30:00.000000',00000000000002497645),('2024-05-30 12:35:00.000000',00000000000002504445),('2024-05-30 12:40:00.000000',00000000000002508435),('2024-05-30 12:45:00.000000',00000000000002517435),('2024-05-30 12:50:00.000000',00000000000002518435),('2024-05-30 12:55:00.000000',00000000000002534235),('2024-05-30 13:00:00.000000',00000000000002541135),('2024-05-30 13:05:00.000000',00000000000002541801),('2024-05-30 13:10:00.000000',00000000000002548701),('2024-05-30 13:15:00.000000',00000000000002548801),('2024-05-30 13:20:00.000000',00000000000002556701),('2024-05-30 13:25:00.000000',00000000000002566257),('2024-05-30 13:30:00.000000',00000000000002570157),('2024-05-30 13:35:00.000000',00000000000002576157),('2024-05-30 13:40:00.000000',00000000000002576257),('2024-05-30 13:45:00.000000',00000000000002583057),('2024-05-30 13:50:00.000000',00000000000002585057),('2024-05-30 13:55:00.000000',00000000000002604657),('2024-05-30 14:00:00.000000',00000000000002609557),('2024-05-30 14:05:00.000000',00000000000002614357),('2024-05-30 14:10:00.000000',00000000000002633115),('2024-05-30 14:15:00.000000',00000000000002635115),('2024-05-30 14:20:00.000000',00000000000002651915),('2024-05-30 14:25:00.000000',00000000000002663615),('2024-05-30 14:30:00.000000',00000000000002674415),('2024-05-30 14:35:00.000000',00000000000002695815),('2024-05-30 14:40:00.000000',00000000000002717415),('2024-05-30 14:45:00.000000',00000000000002719415),('2024-05-30 14:50:00.000000',00000000000002751415),('2024-05-30 14:55:00.000000',00000000000002782215),('2024-05-30 15:00:00.000000',00000000000002794715),('2024-05-30 15:05:00.000000',00000000000002803614),('2024-05-30 15:10:00.000000',00000000000002830314),('2024-05-30 15:15:00.000000',00000000000002835414),('2024-05-30 15:20:00.000000',00000000000002866104),('2024-05-30 15:25:00.000000',00000000000002870104),('2024-05-30 15:30:00.000000',00000000000002878004),('2024-05-30 15:35:00.000000',00000000000002906504),('2024-05-30 15:40:00.000000',00000000000002921004),('2024-05-30 15:45:00.000000',00000000000002976904),('2024-05-30 15:50:00.000000',00000000000002984704),('2024-05-30 15:55:00.000000',00000000000003031704),('2024-05-30 16:00:00.000000',00000000000000000000),('2024-05-30 16:05:00.000000',00000000000000015900),('2024-05-30 16:10:00.000000',00000000000000055400),('2024-05-30 16:15:00.000000',00000000000000072289),('2024-05-30 16:20:00.000000',00000000000000092289),('2024-05-30 16:25:00.000000',00000000000000139279),('2024-05-30 16:30:00.000000',00000000000000146078),('2024-05-30 16:35:00.000000',00000000000000160978),('2024-05-30 16:40:00.000000',00000000000000181768),('2024-05-30 16:45:00.000000',00000000000000206968),('2024-05-30 16:50:00.000000',00000000000000220868),('2024-05-30 16:55:00.000000',00000000000000244468),('2024-05-30 17:00:00.000000',00000000000000260791),('2024-05-30 17:05:00.000000',00000000000000270791),('2024-05-30 17:10:00.000000',00000000000000270891),('2024-05-30 17:15:00.000000',00000000000000274891),('2024-05-30 17:20:00.000000',00000000000000288781),('2024-05-30 17:25:00.000000',00000000000000293781),('2024-05-30 17:30:00.000000',00000000000000297881),('2024-05-30 17:35:00.000000',00000000000000303881),('2024-05-30 17:40:00.000000',00000000000000307881),('2024-05-30 17:45:00.000000',00000000000000320881),('2024-05-30 17:50:00.000000',00000000000000331681),('2024-05-30 17:55:00.000000',00000000000000341581),('2024-05-30 18:00:00.000000',00000000000000358380),('2024-05-30 18:05:00.000000',00000000000000358380),('2024-05-30 18:10:00.000000',00000000000000369380),('2024-05-30 18:15:00.000000',00000000000000427180),('2024-05-30 18:20:00.000000',00000000000000432180),('2024-05-30 18:25:00.000000',00000000000000437170),('2024-05-30 18:30:00.000000',00000000000000452970),('2024-05-30 18:35:00.000000',00000000000000466770),('2024-05-30 18:40:00.000000',00000000000000467770),('2024-05-30 18:45:00.000000',00000000000000487270),('2024-05-30 18:50:00.000000',00000000000000502070),('2024-05-30 18:55:00.000000',00000000000000529670),('2024-05-30 19:00:00.000000',00000000000000529670),('2024-05-30 19:05:00.000000',00000000000000577370),('2024-05-30 19:10:00.000000',00000000000000587370),('2024-05-30 19:15:00.000000',00000000000000587370),('2024-05-30 19:20:00.000000',00000000000000587470),('2024-05-30 19:25:00.000000',00000000000000599470),('2024-05-30 19:30:00.000000',00000000000000606360),('2024-05-30 19:35:00.000000',00000000000000612359),('2024-05-30 19:40:00.000000',00000000000000613359),('2024-05-30 19:45:00.000000',00000000000000613359),('2024-05-30 19:50:00.000000',00000000000000613359),('2024-05-30 19:55:00.000000',00000000000000616459),('2024-05-30 20:00:00.000000',00000000000000619449),('2024-05-30 20:05:00.000000',00000000000000620215),('2024-05-30 20:10:00.000000',00000000000000626215),('2024-05-30 20:15:00.000000',00000000000000629215),('2024-05-30 20:20:00.000000',00000000000000629215),('2024-05-30 20:25:00.000000',00000000000000630215),('2024-05-30 20:30:00.000000',00000000000000630215),('2024-05-30 20:35:00.000000',00000000000000653915),('2024-05-30 20:40:00.000000',00000000000000656015),('2024-05-30 20:45:00.000000',00000000000000666815),('2024-05-30 20:50:00.000000',00000000000000670615),('2024-05-30 20:55:00.000000',00000000000000671615),('2024-05-30 21:00:00.000000',00000000000000674704),('2024-05-30 21:05:00.000000',00000000000000674804),('2024-05-30 21:10:00.000000',00000000000000681704),('2024-05-30 21:15:00.000000',00000000000000685704),('2024-05-30 21:20:00.000000',00000000000000687704),('2024-05-30 21:25:00.000000',00000000000000691704),('2024-05-30 21:30:00.000000',00000000000000691704),('2024-05-30 21:35:00.000000',00000000000000712403),('2024-05-30 21:40:00.000000',00000000000000716303),('2024-05-30 21:45:00.000000',00000000000000720293),('2024-05-30 21:50:00.000000',00000000000000720293),('2024-05-30 21:55:00.000000',00000000000000720293),('2024-05-30 22:00:00.000000',00000000000000720293),('2024-05-30 22:05:00.000000',00000000000000720293),('2024-05-30 22:10:00.000000',00000000000000724193),('2024-05-30 22:15:00.000000',00000000000000725193),('2024-05-30 22:20:00.000000',00000000000000743993),('2024-05-30 22:25:00.000000',00000000000000752993),('2024-05-30 22:30:00.000000',00000000000000769793),('2024-05-30 22:35:00.000000',00000000000000781693),('2024-05-30 22:40:00.000000',00000000000000793693),('2024-05-30 22:45:00.000000',00000000000000801693),('2024-05-30 22:50:00.000000',00000000000000803693),('2024-05-30 22:55:00.000000',00000000000000804693),('2024-05-30 23:00:00.000000',00000000000000806693),('2024-05-30 23:05:00.000000',00000000000000807693),('2024-05-30 23:10:00.000000',00000000000000820693),('2024-05-30 23:15:00.000000',00000000000000821793),('2024-05-30 23:20:00.000000',00000000000000822793),('2024-05-30 23:25:00.000000',00000000000000825893),('2024-05-30 23:30:00.000000',00000000000000829893),('2024-05-30 23:35:00.000000',00000000000000829893),('2024-05-30 23:40:00.000000',00000000000000829893),('2024-05-30 23:45:00.000000',00000000000000834793),('2024-05-30 23:50:00.000000',00000000000000838883),('2024-05-30 23:55:00.000000',00000000000000847783),('2024-05-31 00:00:00.000000',00000000000000862583),('2024-05-31 00:05:00.000000',00000000000000865683),('2024-05-31 00:10:00.000000',00000000000000883983),('2024-05-31 00:15:00.000000',00000000000000888083),('2024-05-31 00:20:00.000000',00000000000000893983),('2024-05-31 00:25:00.000000',00000000000000896983),('2024-05-31 00:30:00.000000',00000000000000899083),('2024-05-31 00:35:00.000000',00000000000000906883),('2024-05-31 00:40:00.000000',00000000000000924193),('2024-05-31 00:45:00.000000',00000000000000930093),('2024-05-31 00:50:00.000000',00000000000000944993),('2024-05-31 00:55:00.000000',00000000000000957593),('2024-05-31 01:00:00.000000',00000000000000962593),('2024-05-31 01:05:00.000000',00000000000000964693),('2024-05-31 01:10:00.000000',00000000000000979393),('2024-05-31 01:15:00.000000',00000000000000987392),('2024-05-31 01:20:00.000000',00000000000000989392),('2024-05-31 01:25:00.000000',00000000000001012192),('2024-05-31 01:30:00.000000',00000000000001019182),('2024-05-31 01:35:00.000000',00000000000001021082),('2024-05-31 01:40:00.000000',00000000000001023082),('2024-05-31 01:45:00.000000',00000000000001034731),('2024-05-31 01:50:00.000000',00000000000001034731),('2024-05-31 01:55:00.000000',00000000000001042631),('2024-05-31 02:00:00.000000',00000000000001045003),('2024-05-31 02:05:00.000000',00000000000001063469),('2024-05-31 02:10:00.000000',00000000000001066569),('2024-05-31 02:15:00.000000',00000000000001066769),('2024-05-31 02:20:00.000000',00000000000001076669),('2024-05-31 02:25:00.000000',00000000000001086469),('2024-05-31 02:30:00.000000',00000000000001087559),('2024-05-31 02:35:00.000000',00000000000001090559),('2024-05-31 02:40:00.000000',00000000000001100359),('2024-05-31 02:45:00.000000',00000000000001102359),('2024-05-31 02:50:00.000000',00000000000001111159),('2024-05-31 02:55:00.000000',00000000000001123959),('2024-05-31 03:00:00.000000',00000000000001136059),('2024-05-31 03:05:00.000000',00000000000001143059),('2024-05-31 03:10:00.000000',00000000000001143059),('2024-05-31 03:15:00.000000',00000000000001170659),('2024-05-31 03:20:00.000000',00000000000001183559),('2024-05-31 03:25:00.000000',00000000000001184559),('2024-05-31 03:30:00.000000',00000000000001188359),('2024-05-31 03:35:00.000000',00000000000001197359),('2024-05-31 03:40:00.000000',00000000000001197359),('2024-05-31 03:45:00.000000',00000000000001197359),('2024-05-31 03:50:00.000000',00000000000001217959),('2024-05-31 03:55:00.000000',00000000000001224959),('2024-05-31 04:00:00.000000',00000000000001224959),('2024-05-31 04:05:00.000000',00000000000001238759),('2024-05-31 04:10:00.000000',00000000000001267449),('2024-05-31 04:15:00.000000',00000000000001308349),('2024-05-31 04:20:00.000000',00000000000001316249),('2024-05-31 04:25:00.000000',00000000000001319238),('2024-05-31 04:30:00.000000',00000000000001380827),('2024-05-31 04:35:00.000000',00000000000001414963),('2024-05-31 04:40:00.000000',00000000000001434052),('2024-05-31 04:45:00.000000',00000000000001457911),('2024-05-31 04:50:00.000000',00000000000001470545),('2024-05-31 04:55:00.000000',00000000000001486936),('2024-05-31 05:00:00.000000',00000000000001497746),('2024-05-31 05:05:00.000000',00000000000001501836),('2024-05-31 05:10:00.000000',00000000000001518726),('2024-05-31 05:15:00.000000',00000000000001527536),('2024-05-31 05:20:00.000000',00000000000001541336),('2024-05-31 05:25:00.000000',00000000000001550236),('2024-05-31 05:30:00.000000',00000000000001596025),('2024-05-31 05:35:00.000000',00000000000001598125),('2024-05-31 05:40:00.000000',00000000000001616915),('2024-05-31 05:45:00.000000',00000000000001626561),('2024-05-31 05:50:00.000000',00000000000001666461),('2024-05-31 05:55:00.000000',00000000000001668461),('2024-05-31 06:00:00.000000',00000000000001676361),('2024-05-31 06:05:00.000000',00000000000001701161),('2024-05-31 06:10:00.000000',00000000000001701161),('2024-05-31 06:15:00.000000',00000000000001710041),('2024-05-31 06:20:00.000000',00000000000001710041),('2024-05-31 06:25:00.000000',00000000000001712041),('2024-05-31 06:30:00.000000',00000000000001718941),('2024-05-31 06:35:00.000000',00000000000001719941),('2024-05-31 06:40:00.000000',00000000000001728819),('2024-05-31 06:45:00.000000',00000000000001734385),('2024-05-31 06:50:00.000000',00000000000001737285),('2024-05-31 06:55:00.000000',00000000000001739285),('2024-05-31 07:00:00.000000',00000000000001741285),('2024-05-31 07:05:00.000000',00000000000001747485),('2024-05-31 07:10:00.000000',00000000000001747585),('2024-05-31 07:15:00.000000',00000000000001765475),('2024-05-31 07:20:00.000000',00000000000001765475),('2024-05-31 07:25:00.000000',00000000000001768375),('2024-05-31 07:30:00.000000',00000000000001783175),('2024-05-31 07:35:00.000000',00000000000001790075),('2024-05-31 07:40:00.000000',00000000000001797875),('2024-05-31 07:45:00.000000',00000000000001805775),('2024-05-31 07:50:00.000000',00000000000001806875),('2024-05-31 07:55:00.000000',00000000000001815775),('2024-05-31 08:00:00.000000',00000000000001818675),('2024-05-31 08:05:00.000000',00000000000001843475),('2024-05-31 08:10:00.000000',00000000000001848474),('2024-05-31 08:15:00.000000',00000000000001847475),('2024-05-31 08:20:00.000000',00000000000001851475),('2024-05-31 08:25:00.000000',00000000000001871175),('2024-05-31 08:30:00.000000',00000000000001875175),('2024-05-31 08:35:00.000000',00000000000001880175),('2024-05-31 08:40:00.000000',00000000000001881175),('2024-05-31 08:45:00.000000',00000000000001882275),('2024-05-31 08:50:00.000000',00000000000001882375),('2024-05-31 08:55:00.000000',00000000000001884475),('2024-05-31 09:00:00.000000',00000000000001904275),('2024-05-31 09:05:00.000000',00000000000001907175),('2024-05-31 09:10:00.000000',00000000000001907175),('2024-05-31 09:15:00.000000',00000000000001915975),('2024-05-31 09:20:00.000000',00000000000001915975),('2024-05-31 09:25:00.000000',00000000000001919875),('2024-05-31 09:30:00.000000',00000000000001925675),('2024-05-31 09:35:00.000000',00000000000001937574),('2024-05-31 09:40:00.000000',00000000000001937574),('2024-05-31 09:45:00.000000',00000000000001937574),('2024-05-31 09:50:00.000000',00000000000001954264),('2024-05-31 09:55:00.000000',00000000000001959254),('2024-05-31 10:00:00.000000',00000000000001980954),('2024-05-31 10:05:00.000000',00000000000001980954),('2024-05-31 10:10:00.000000',00000000000002005654),('2024-05-31 10:15:00.000000',00000000000002006654),('2024-05-31 10:20:00.000000',00000000000002007654),('2024-05-31 10:25:00.000000',00000000000002007654),('2024-05-31 10:30:00.000000',00000000000002007654),('2024-05-31 10:35:00.000000',00000000000002007654),('2024-05-31 10:40:00.000000',00000000000002017354),('2024-05-31 10:45:00.000000',00000000000002021254),('2024-05-31 10:50:00.000000',00000000000002024154),('2024-05-31 10:55:00.000000',00000000000002026143),('2024-05-31 11:00:00.000000',00000000000002034043),('2024-05-31 11:05:00.000000',00000000000002038943),('2024-05-31 11:10:00.000000',00000000000002043043),('2024-05-31 11:15:00.000000',00000000000002047843),('2024-05-31 11:20:00.000000',00000000000002052943),('2024-05-31 11:25:00.000000',00000000000002055943),('2024-05-31 11:30:00.000000',00000000000002066733),('2024-05-31 11:35:00.000000',00000000000002077533),('2024-05-31 11:40:00.000000',00000000000002081133),('2024-05-31 11:45:00.000000',00000000000002081133),('2024-05-31 11:50:00.000000',00000000000002101133),('2024-05-31 11:55:00.000000',00000000000002105133),('2024-05-31 12:00:00.000000',00000000000002127833),('2024-05-31 12:05:00.000000',00000000000002131833),('2024-05-31 12:10:00.000000',00000000000002146633),('2024-05-31 12:15:00.000000',00000000000002151623),('2024-05-31 12:20:00.000000',00000000000002154523),('2024-05-31 12:25:00.000000',00000000000002182223),('2024-05-31 12:30:00.000000',00000000000002186023),('2024-05-31 12:35:00.000000',00000000000002186023),('2024-05-31 12:40:00.000000',00000000000002186023),('2024-05-31 12:45:00.000000',00000000000002191923),('2024-05-31 12:50:00.000000',00000000000002216023),('2024-05-31 12:55:00.000000',00000000000002250723),('2024-05-31 13:00:00.000000',00000000000002255623),('2024-05-31 13:05:00.000000',00000000000002262523),('2024-05-31 13:10:00.000000',00000000000002264523),('2024-05-31 13:15:00.000000',00000000000002320123),('2024-05-31 13:20:00.000000',00000000000002372122),('2024-05-31 13:25:00.000000',00000000000002378413),('2024-05-31 13:30:00.000000',00000000000002387513),('2024-05-31 13:35:00.000000',00000000000002396513),('2024-05-31 13:40:00.000000',00000000000002413412),('2024-05-31 13:45:00.000000',00000000000002367512),('2024-05-31 13:50:00.000000',00000000000002382068),('2024-05-31 13:55:00.000000',00000000000002395126),('2024-05-31 14:00:00.000000',00000000000002425003),('2024-05-31 14:05:00.000000',00000000000002431203),('2024-05-31 14:10:00.000000',00000000000002468803),('2024-05-31 14:15:00.000000',00000000000002486003),('2024-05-31 14:20:00.000000',00000000000002503903),('2024-05-31 14:25:00.000000',00000000000002536592),('2024-05-31 14:30:00.000000',00000000000002549462),('2024-05-31 14:35:00.000000',00000000000002582512),('2024-05-31 14:40:00.000000',00000000000002596591),('2024-05-31 14:45:00.000000',00000000000002618381),('2024-05-31 14:50:00.000000',00000000000002631181),('2024-05-31 14:55:00.000000',00000000000002630181),('2024-05-31 15:00:00.000000',00000000000002644981),('2024-05-31 15:05:00.000000',00000000000002653981),('2024-05-31 15:10:00.000000',00000000000002676770),('2024-05-31 15:15:00.000000',00000000000002690660),('2024-05-31 15:20:00.000000',00000000000002726960),('2024-05-31 15:25:00.000000',00000000000002739860),('2024-05-31 15:30:00.000000',00000000000002755860),('2024-05-31 15:35:00.000000',00000000000002786649),('2024-05-31 15:40:00.000000',00000000000002793549),('2024-05-31 15:45:00.000000',00000000000002798749),('2024-05-31 15:50:00.000000',00000000000002811839),('2024-05-31 15:55:00.000000',00000000000002850739),('2024-05-31 16:00:00.000000',00000000000000000000),('2024-05-31 16:05:00.000000',00000000000000025700),('2024-05-31 16:10:00.000000',00000000000000062289),('2024-05-31 16:15:00.000000',00000000000000103889),('2024-05-31 16:20:00.000000',00000000000000118789),('2024-05-31 16:25:00.000000',00000000000000125789),('2024-05-31 16:30:00.000000',00000000000000125789),('2024-05-31 16:35:00.000000',00000000000000134789),('2024-05-31 16:40:00.000000',00000000000000165389),('2024-05-31 16:45:00.000000',00000000000000173489),('2024-05-31 16:50:00.000000',00000000000000190055),('2024-05-31 16:55:00.000000',00000000000000218845),('2024-05-31 17:00:00.000000',00000000000000228001),('2024-05-31 17:05:00.000000',00000000000000233101),('2024-05-31 17:10:00.000000',00000000000000238991),('2024-05-31 17:15:00.000000',00000000000000246891),('2024-05-31 17:20:00.000000',00000000000000249991),('2024-05-31 17:25:00.000000',00000000000000281881),('2024-05-31 17:30:00.000000',00000000000000300581),('2024-05-31 17:35:00.000000',00000000000000320381),('2024-05-31 17:40:00.000000',00000000000000320481),('2024-05-31 17:45:00.000000',00000000000000335481),('2024-05-31 17:50:00.000000',00000000000000346381),('2024-05-31 17:55:00.000000',00000000000000354471),('2024-05-31 18:00:00.000000',00000000000000359471),('2024-05-31 18:05:00.000000',00000000000000367471),('2024-05-31 18:10:00.000000',00000000000000377471),('2024-05-31 18:15:00.000000',00000000000000379471),('2024-05-31 18:20:00.000000',00000000000000385461),('2024-05-31 18:25:00.000000',00000000000000391661),('2024-05-31 18:30:00.000000',00000000000000403461),('2024-05-31 18:35:00.000000',00000000000000411361),('2024-05-31 18:40:00.000000',00000000000000427861),('2024-05-31 18:45:00.000000',00000000000000427861),('2024-05-31 18:50:00.000000',00000000000000428861),('2024-05-31 18:55:00.000000',00000000000000432861),('2024-05-31 19:00:00.000000',00000000000000435761),('2024-05-31 19:05:00.000000',00000000000000436761),('2024-05-31 19:10:00.000000',00000000000000444661),('2024-05-31 19:15:00.000000',00000000000000444661),('2024-05-31 19:20:00.000000',00000000000000441861),('2024-05-31 19:25:00.000000',00000000000000462661),('2024-05-31 19:30:00.000000',00000000000000478461),('2024-05-31 19:35:00.000000',00000000000000481461),('2024-05-31 19:40:00.000000',00000000000000873251),('2024-05-31 19:45:00.000000',00000000000000867751),('2024-05-31 19:50:00.000000',00000000000000872651),('2024-05-31 19:55:00.000000',00000000000000876651),('2024-05-31 20:00:00.000000',00000000000000884551),('2024-05-31 20:05:00.000000',00000000000000886551),('2024-05-31 20:10:00.000000',00000000000000889451),('2024-05-31 20:15:00.000000',00000000000000886461),('2024-05-31 20:20:00.000000',00000000000000887461),('2024-05-31 20:25:00.000000',00000000000000887461),('2024-05-31 20:30:00.000000',00000000000000887561),('2024-05-31 20:35:00.000000',00000000000000887561),('2024-05-31 20:40:00.000000',00000000000000969561),('2024-05-31 20:45:00.000000',00000000000000971661),('2024-05-31 20:50:00.000000',00000000000000973661),('2024-05-31 20:55:00.000000',00000000000000973661),('2024-05-31 21:00:00.000000',00000000000000974661),('2024-05-31 21:05:00.000000',00000000000000974661),('2024-05-31 21:10:00.000000',00000000000000980661),('2024-05-31 21:15:00.000000',00000000000000982661),('2024-05-31 21:20:00.000000',00000000000000984661),('2024-05-31 21:25:00.000000',00000000000000985661),('2024-05-31 21:30:00.000000',00000000000000987661),('2024-05-31 21:35:00.000000',00000000000000990561),('2024-05-31 21:40:00.000000',00000000000000990561),('2024-05-31 21:45:00.000000',00000000000000990561),('2024-05-31 21:50:00.000000',00000000000000990561),('2024-05-31 21:55:00.000000',00000000000000990561),('2024-05-31 22:00:00.000000',00000000000000990561),('2024-05-31 22:05:00.000000',00000000000000993661),('2024-05-31 22:10:00.000000',00000000000001001561),('2024-05-31 22:15:00.000000',00000000000001003561),('2024-05-31 22:20:00.000000',00000000000001003561),('2024-05-31 22:25:00.000000',00000000000001003561),('2024-05-31 22:30:00.000000',00000000000001003561),('2024-05-31 22:35:00.000000',00000000000001003561),('2024-05-31 22:40:00.000000',00000000000001003561),('2024-05-31 22:45:00.000000',00000000000001003561),('2024-05-31 22:50:00.000000',00000000000001005561),('2024-05-31 22:55:00.000000',00000000000001006661),('2024-05-31 23:00:00.000000',00000000000001010661),('2024-05-31 23:05:00.000000',00000000000001017661),('2024-05-31 23:10:00.000000',00000000000001025561),('2024-05-31 23:15:00.000000',00000000000001026561),('2024-05-31 23:20:00.000000',00000000000001037561),('2024-05-31 23:25:00.000000',00000000000001039561),('2024-05-31 23:30:00.000000',00000000000001042561),('2024-05-31 23:35:00.000000',00000000000001049461),('2024-05-31 23:40:00.000000',00000000000001054361),('2024-05-31 23:45:00.000000',00000000000001059361),('2024-05-31 23:50:00.000000',00000000000001065127),('2024-05-31 23:55:00.000000',00000000000001097827),('2024-06-01 00:00:00.000000',00000000000001105827),('2024-06-01 00:05:00.000000',00000000000001116583),('2024-06-01 00:10:00.000000',00000000000001136351),('2024-06-01 00:15:00.000000',00000000000001150251),('2024-06-01 00:20:00.000000',00000000000001166251),('2024-06-01 00:25:00.000000',00000000000001188151),('2024-06-01 00:30:00.000000',00000000000001195251),('2024-06-01 00:35:00.000000',00000000000001203451),('2024-06-01 00:40:00.000000',00000000000001205651),('2024-06-01 00:45:00.000000',00000000000001208651),('2024-06-01 00:50:00.000000',00000000000001215651),('2024-06-01 00:55:00.000000',00000000000001220651),('2024-06-01 01:00:00.000000',00000000000001232551),('2024-06-01 01:05:00.000000',00000000000001240451),('2024-06-01 01:10:00.000000',00000000000001252241),('2024-06-01 01:15:00.000000',00000000000001267041),('2024-06-01 01:20:00.000000',00000000000001270041),('2024-06-01 01:25:00.000000',00000000000001306640),('2024-06-01 01:30:00.000000',00000000000001318440),('2024-06-01 01:35:00.000000',00000000000001324440),('2024-06-01 01:40:00.000000',00000000000001336340),('2024-06-01 01:45:00.000000',00000000000001378340),('2024-06-01 01:50:00.000000',00000000000001380440),('2024-06-01 01:55:00.000000',00000000000001382440),('2024-06-01 02:00:00.000000',00000000000001391340),('2024-06-01 02:05:00.000000',00000000000001392340),('2024-06-01 02:10:00.000000',00000000000001400229),('2024-06-01 02:15:00.000000',00000000000001400229),('2024-06-01 02:20:00.000000',00000000000001411129),('2024-06-01 02:25:00.000000',00000000000001414129),('2024-06-01 02:30:00.000000',00000000000001416129),('2024-06-01 02:35:00.000000',00000000000001426129),('2024-06-01 02:40:00.000000',00000000000001449119),('2024-06-01 02:45:00.000000',00000000000001462097),('2024-06-01 02:50:00.000000',00000000000001468197),('2024-06-01 02:55:00.000000',00000000000001483197),('2024-06-01 03:00:00.000000',00000000000001506097),('2024-06-01 03:05:00.000000',00000000000001527597),('2024-06-01 03:10:00.000000',00000000000001528597),('2024-06-01 03:15:00.000000',00000000000001529597),('2024-06-01 03:20:00.000000',00000000000001534497),('2024-06-01 03:25:00.000000',00000000000001542297),('2024-06-01 03:30:00.000000',00000000000001550197),('2024-06-01 03:35:00.000000',00000000000001553197),('2024-06-01 03:40:00.000000',00000000000001557196),('2024-06-01 03:45:00.000000',00000000000001560196),('2024-06-01 03:50:00.000000',00000000000001571996),('2024-06-01 03:55:00.000000',00000000000001594876),('2024-06-01 04:00:00.000000',00000000000001617576),('2024-06-01 04:05:00.000000',00000000000001621576),('2024-06-01 04:10:00.000000',00000000000001626476),('2024-06-01 04:15:00.000000',00000000000001685976),('2024-06-01 04:20:00.000000',00000000000001691876),('2024-06-01 04:25:00.000000',00000000000001703856),('2024-06-01 04:30:00.000000',00000000000001719656),('2024-06-01 04:35:00.000000',00000000000001767556),('2024-06-01 04:40:00.000000',00000000000001778346),('2024-06-01 04:45:00.000000',00000000000001794781),('2024-06-01 04:50:00.000000',00000000000001812471),('2024-06-01 04:55:00.000000',00000000000001816471),('2024-06-01 05:00:00.000000',00000000000001824271),('2024-06-01 05:05:00.000000',00000000000001828251),('2024-06-01 05:10:00.000000',00000000000001851941),('2024-06-01 05:15:00.000000',00000000000001857741),('2024-06-01 05:20:00.000000',00000000000001861641),('2024-06-01 05:25:00.000000',00000000000001864641),('2024-06-01 05:30:00.000000',00000000000001867641),('2024-06-01 05:35:00.000000',00000000000001874641),('2024-06-01 05:40:00.000000',00000000000001886541),('2024-06-01 05:45:00.000000',00000000000001887541),('2024-06-01 05:50:00.000000',00000000000001890541),('2024-06-01 05:55:00.000000',00000000000001914318),('2024-06-01 06:00:00.000000',00000000000001922118),('2024-06-01 06:05:00.000000',00000000000001935518),('2024-06-01 06:10:00.000000',00000000000001945318),('2024-06-01 06:15:00.000000',00000000000001950318),('2024-06-01 06:20:00.000000',00000000000001959307),('2024-06-01 06:25:00.000000',00000000000001984239),('2024-06-01 06:30:00.000000',00000000000001991639),('2024-06-01 06:35:00.000000',00000000000002000738),('2024-06-01 06:40:00.000000',00000000000002007738),('2024-06-01 06:45:00.000000',00000000000002016538),('2024-06-01 06:50:00.000000',00000000000002022537),('2024-06-01 06:55:00.000000',00000000000002020338),('2024-06-01 07:00:00.000000',00000000000002030237),('2024-06-01 07:05:00.000000',00000000000002037037),('2024-06-01 07:10:00.000000',00000000000002067497),('2024-06-01 07:15:00.000000',00000000000002070397),('2024-06-01 07:20:00.000000',00000000000002079197),('2024-06-01 07:25:00.000000',00000000000002088087),('2024-06-01 07:30:00.000000',00000000000002092887),('2024-06-01 07:35:00.000000',00000000000002108687),('2024-06-01 07:40:00.000000',00000000000002110676),('2024-06-01 07:45:00.000000',00000000000002115675),('2024-06-01 07:50:00.000000',00000000000002127465),('2024-06-01 07:55:00.000000',00000000000002142364),('2024-06-01 08:00:00.000000',00000000000002158964),('2024-06-01 08:05:00.000000',00000000000002158964),('2024-06-01 08:10:00.000000',00000000000002198864),('2024-06-01 08:15:00.000000',00000000000002198864),('2024-06-01 08:20:00.000000',00000000000002205764),('2024-06-01 08:25:00.000000',00000000000002218564),('2024-06-01 08:30:00.000000',00000000000002224564),('2024-06-01 08:35:00.000000',00000000000002230564),('2024-06-01 08:40:00.000000',00000000000002249164),('2024-06-01 08:45:00.000000',00000000000002254764),('2024-06-01 08:50:00.000000',00000000000002260764),('2024-06-01 08:55:00.000000',00000000000002419764),('2024-06-01 09:00:00.000000',00000000000002429564),('2024-06-01 09:05:00.000000',00000000000002440464),('2024-06-01 09:10:00.000000',00000000000002467163),('2024-06-01 09:15:00.000000',00000000000002474163),('2024-06-01 09:20:00.000000',00000000000002480263),('2024-06-01 09:25:00.000000',00000000000002517153),('2024-06-01 09:30:00.000000',00000000000002521153),('2024-06-01 09:35:00.000000',00000000000002523253),('2024-06-01 09:40:00.000000',00000000000002526353),('2024-06-01 09:45:00.000000',00000000000002540252),('2024-06-01 09:50:00.000000',00000000000002548052),('2024-06-01 09:55:00.000000',00000000000002555952),('2024-06-01 10:00:00.000000',00000000000002561052),('2024-06-01 10:05:00.000000',00000000000002571052),('2024-06-01 10:10:00.000000',00000000000002576052),('2024-06-01 10:15:00.000000',00000000000002588052),('2024-06-01 10:20:00.000000',00000000000002604952),('2024-06-01 10:25:00.000000',00000000000002621952),('2024-06-01 10:30:00.000000',00000000000002649751),('2024-06-01 10:35:00.000000',00000000000002651751),('2024-06-01 10:40:00.000000',00000000000002654751),('2024-06-01 10:45:00.000000',00000000000002663551),('2024-06-01 10:50:00.000000',00000000000002673451),('2024-06-01 10:55:00.000000',00000000000002682351),('2024-06-01 11:00:00.000000',00000000000002682351),('2024-06-01 11:05:00.000000',00000000000002682351),('2024-06-01 11:10:00.000000',00000000000002692351),('2024-06-01 11:15:00.000000',00000000000002703151),('2024-06-01 11:20:00.000000',00000000000002705251),('2024-06-01 11:25:00.000000',00000000000002720051),('2024-06-01 11:30:00.000000',00000000000002733951),('2024-06-01 11:35:00.000000',00000000000002736051),('2024-06-01 11:40:00.000000',00000000000002737051),('2024-06-01 11:45:00.000000',00000000000002747451),('2024-06-01 11:50:00.000000',00000000000002753351),('2024-06-01 11:55:00.000000',00000000000002762350),('2024-06-01 12:00:00.000000',00000000000002772249),('2024-06-01 12:05:00.000000',00000000000002776915),('2024-06-01 12:10:00.000000',00000000000002779915),('2024-06-01 12:15:00.000000',00000000000002786815),('2024-06-01 12:20:00.000000',00000000000002798505),('2024-06-01 12:25:00.000000',00000000000002802505),('2024-06-01 12:30:00.000000',00000000000002802605),('2024-06-01 12:35:00.000000',00000000000002804605),('2024-06-01 12:40:00.000000',00000000000002808605),('2024-06-01 12:45:00.000000',00000000000002809605),('2024-06-01 12:50:00.000000',00000000000002824405),('2024-06-01 12:55:00.000000',00000000000002827405),('2024-06-01 13:00:00.000000',00000000000002832505),('2024-06-01 13:05:00.000000',00000000000002832605),('2024-06-01 13:10:00.000000',00000000000002847405),('2024-06-01 13:15:00.000000',00000000000002854395),('2024-06-01 13:20:00.000000',00000000000002854395),('2024-06-01 13:25:00.000000',00000000000002858895),('2024-06-01 13:30:00.000000',00000000000002863795),('2024-06-01 13:35:00.000000',00000000000002863795),('2024-06-01 13:40:00.000000',00000000000002876594),('2024-06-01 13:45:00.000000',00000000000002893294),('2024-06-01 13:50:00.000000',00000000000002934194),('2024-06-01 13:55:00.000000',00000000000002941184),('2024-06-01 14:00:00.000000',00000000000002983284),('2024-06-01 14:05:00.000000',00000000000002981294),('2024-06-01 14:10:00.000000',00000000000002981294),('2024-06-01 14:15:00.000000',00000000000003002094),('2024-06-01 14:20:00.000000',00000000000003010194),('2024-06-01 14:25:00.000000',00000000000003029894),('2024-06-01 14:30:00.000000',00000000000003030894),('2024-06-01 14:35:00.000000',00000000000003040794),('2024-06-01 14:40:00.000000',00000000000003067094),('2024-06-01 14:45:00.000000',00000000000003087394),('2024-06-01 14:50:00.000000',00000000000003096294),('2024-06-01 14:55:00.000000',00000000000003124094),('2024-06-01 15:00:00.000000',00000000000003143894),('2024-06-01 15:05:00.000000',00000000000003160584),('2024-06-01 15:10:00.000000',00000000000003168483),('2024-06-01 15:15:00.000000',00000000000003174383),('2024-06-01 15:20:00.000000',00000000000003186183),('2024-06-01 15:25:00.000000',00000000000003208982),('2024-06-01 15:30:00.000000',00000000000003219882),('2024-06-01 15:35:00.000000',00000000000003260662),('2024-06-01 15:40:00.000000',00000000000003274350),('2024-06-01 15:45:00.000000',00000000000003353071),('2024-06-01 15:50:00.000000',00000000000003383961),('2024-06-01 15:55:00.000000',00000000000003410861),('2024-06-01 16:00:00.000000',00000000000000000000),('2024-06-01 16:05:00.000000',00000000000000039390),('2024-06-01 16:10:00.000000',00000000000000063890),('2024-06-01 16:15:00.000000',00000000000000079590),('2024-06-01 16:20:00.000000',00000000000000102979),('2024-06-01 16:25:00.000000',00000000000000119679),('2024-06-01 16:30:00.000000',00000000000000135379),('2024-06-01 16:35:00.000000',00000000000000162779),('2024-06-01 16:40:00.000000',00000000000000178579),('2024-06-01 16:45:00.000000',00000000000000189379),('2024-06-01 16:50:00.000000',00000000000000209979),('2024-06-01 16:55:00.000000',00000000000000232769),('2024-06-01 17:00:00.000000',00000000000000259339),('2024-06-01 17:05:00.000000',00000000000000270228),('2024-06-01 17:10:00.000000',00000000000000283228),('2024-06-01 17:15:00.000000',00000000000000308683),('2024-06-01 17:20:00.000000',00000000000000349181),('2024-06-01 17:25:00.000000',00000000000000365281),('2024-06-01 17:30:00.000000',00000000000000408970),('2024-06-01 17:35:00.000000',00000000000000464770),('2024-06-01 17:40:00.000000',00000000000000489570),('2024-06-01 17:45:00.000000',00000000000000495970),('2024-06-01 17:50:00.000000',00000000000000507070),('2024-06-01 17:55:00.000000',00000000000000535669),('2024-06-01 18:00:00.000000',00000000000000549357),('2024-06-01 18:05:00.000000',00000000000000572957),('2024-06-01 18:10:00.000000',00000000000000582757),('2024-06-01 18:15:00.000000',00000000000000586157),('2024-06-01 18:20:00.000000',00000000000000588157),('2024-06-01 18:25:00.000000',00000000000000595147),('2024-06-01 18:30:00.000000',00000000000000602947),('2024-06-01 18:35:00.000000',00000000000000603947),('2024-06-01 18:40:00.000000',00000000000000607847),('2024-06-01 18:45:00.000000',00000000000000610847),('2024-06-01 18:50:00.000000',00000000000000615047),('2024-06-01 18:55:00.000000',00000000000000618047),('2024-06-01 19:00:00.000000',00000000000000622147),('2024-06-01 19:05:00.000000',00000000000000627247),('2024-06-01 19:10:00.000000',00000000000000651947),('2024-06-01 19:15:00.000000',00000000000000664737),('2024-06-01 19:20:00.000000',00000000000000664737),('2024-06-01 19:25:00.000000',00000000000000666737),('2024-06-01 19:30:00.000000',00000000000000672737),('2024-06-01 19:35:00.000000',00000000000000676637),('2024-06-01 19:40:00.000000',00000000000000690437),('2024-06-01 19:45:00.000000',00000000000000693427),('2024-06-01 19:50:00.000000',00000000000000693427),('2024-06-01 19:55:00.000000',00000000000000693427),('2024-06-01 20:00:00.000000',00000000000000693427),('2024-06-01 20:05:00.000000',00000000000000695427),('2024-06-01 20:10:00.000000',00000000000000700327),('2024-06-01 20:15:00.000000',00000000000000709127),('2024-06-01 20:20:00.000000',00000000000000714027),('2024-06-01 20:25:00.000000',00000000000000715027),('2024-06-01 20:30:00.000000',00000000000000716927),('2024-06-01 20:35:00.000000',00000000000000714027),('2024-06-01 20:40:00.000000',00000000000000714027),('2024-06-01 20:45:00.000000',00000000000000717017),('2024-06-01 20:50:00.000000',00000000000000719017),('2024-06-01 20:55:00.000000',00000000000000719017),('2024-06-01 21:00:00.000000',00000000000000719017),('2024-06-01 21:05:00.000000',00000000000000723017),('2024-06-01 21:10:00.000000',00000000000000726017),('2024-06-01 21:15:00.000000',00000000000000734817),('2024-06-01 21:20:00.000000',00000000000000743717),('2024-06-01 21:25:00.000000',00000000000000748717),('2024-06-01 21:30:00.000000',00000000000000750717),('2024-06-01 21:35:00.000000',00000000000000754717),('2024-06-01 21:40:00.000000',00000000000000754717),('2024-06-01 21:45:00.000000',00000000000000756717),('2024-06-01 21:50:00.000000',00000000000000756717),('2024-06-01 21:55:00.000000',00000000000000800517),('2024-06-01 22:00:00.000000',00000000000000802517),('2024-06-01 22:05:00.000000',00000000000000808417),('2024-06-01 22:10:00.000000',00000000000000818417),('2024-06-01 22:15:00.000000',00000000000000832317),('2024-06-01 22:20:00.000000',00000000000000822417),('2024-06-01 22:25:00.000000',00000000000000822417),('2024-06-01 22:30:00.000000',00000000000000824417),('2024-06-01 22:35:00.000000',00000000000000825417),('2024-06-01 22:40:00.000000',00000000000000833317),('2024-06-01 22:45:00.000000',00000000000000833317),('2024-06-01 22:50:00.000000',00000000000000835317),('2024-06-01 22:55:00.000000',00000000000000837317),('2024-06-01 23:00:00.000000',00000000000000872917),('2024-06-01 23:05:00.000000',00000000000000873917),('2024-06-01 23:10:00.000000',00000000000000875917),('2024-06-01 23:15:00.000000',00000000000000885717),('2024-06-01 23:20:00.000000',00000000000000889707),('2024-06-01 23:25:00.000000',00000000000000899707),('2024-06-01 23:30:00.000000',00000000000000902707),('2024-06-01 23:35:00.000000',00000000000000905707),('2024-06-01 23:40:00.000000',00000000000000912607),('2024-06-01 23:45:00.000000',00000000000000913607),('2024-06-01 23:50:00.000000',00000000000000916707),('2024-06-01 23:55:00.000000',00000000000000923607),('2024-06-02 00:00:00.000000',00000000000000927707),('2024-06-02 00:05:00.000000',00000000000000931807),('2024-06-02 00:10:00.000000',00000000000000933807),('2024-06-02 00:15:00.000000',00000000000000941807),('2024-06-02 00:20:00.000000',00000000000000950807),('2024-06-02 00:25:00.000000',00000000000000952807),('2024-06-02 00:30:00.000000',00000000000000953807),('2024-06-02 00:35:00.000000',00000000000000954807),('2024-06-02 00:40:00.000000',00000000000000959707),('2024-06-02 00:45:00.000000',00000000000000968507),('2024-06-02 00:50:00.000000',00000000000000970607),('2024-06-02 00:55:00.000000',00000000000000983607),('2024-06-02 01:00:00.000000',00000000000000992507),('2024-06-02 01:05:00.000000',00000000000000999707),('2024-06-02 01:10:00.000000',00000000000001009907),('2024-06-02 01:15:00.000000',00000000000001013007),('2024-06-02 01:20:00.000000',00000000000001022997),('2024-06-02 01:25:00.000000',00000000000001034697),('2024-06-02 01:30:00.000000',00000000000001042797),('2024-06-02 01:35:00.000000',00000000000001056697),('2024-06-02 01:40:00.000000',00000000000001058697),('2024-06-02 01:45:00.000000',00000000000001086297),('2024-06-02 01:50:00.000000',00000000000001093387),('2024-06-02 01:55:00.000000',00000000000001127177),('2024-06-02 02:00:00.000000',00000000000001139957),('2024-06-02 02:05:00.000000',00000000000001145857),('2024-06-02 02:10:00.000000',00000000000001148847),('2024-06-02 02:15:00.000000',00000000000001150947),('2024-06-02 02:20:00.000000',00000000000001187437),('2024-06-02 02:25:00.000000',00000000000001190437),('2024-06-02 02:30:00.000000',00000000000001197436),('2024-06-02 02:35:00.000000',00000000000001203224),('2024-06-02 02:40:00.000000',00000000000001210104),('2024-06-02 02:45:00.000000',00000000000001215094),('2024-06-02 02:50:00.000000',00000000000001223226),('2024-06-02 02:55:00.000000',00000000000001228216),('2024-06-02 03:00:00.000000',00000000000001231206),('2024-06-02 03:05:00.000000',00000000000001235206),('2024-06-02 03:10:00.000000',00000000000001244306),('2024-06-02 03:15:00.000000',00000000000001259196),('2024-06-02 03:20:00.000000',00000000000001274096),('2024-06-02 03:25:00.000000',00000000000001280096),('2024-06-02 03:30:00.000000',00000000000001286096),('2024-06-02 03:35:00.000000',00000000000001287096),('2024-06-02 03:40:00.000000',00000000000001450086),('2024-06-02 03:45:00.000000',00000000000001461986),('2024-06-02 03:50:00.000000',00000000000001465976),('2024-06-02 03:55:00.000000',00000000000001473876),('2024-06-02 04:00:00.000000',00000000000001489676),('2024-06-02 04:05:00.000000',00000000000001491766),('2024-06-02 04:10:00.000000',00000000000001502966),('2024-06-02 04:15:00.000000',00000000000001505956),('2024-06-02 04:20:00.000000',00000000000001518746),('2024-06-02 04:25:00.000000',00000000000001524646),('2024-06-02 04:30:00.000000',00000000000001537445),('2024-06-02 04:35:00.000000',00000000000001538545),('2024-06-02 04:40:00.000000',00000000000001562245),('2024-06-02 04:45:00.000000',00000000000001590735),('2024-06-02 04:50:00.000000',00000000000001628515),('2024-06-02 04:55:00.000000',00000000000001648915),('2024-06-02 05:00:00.000000',00000000000001650915),('2024-06-02 05:05:00.000000',00000000000001664471),('2024-06-02 05:10:00.000000',00000000000001698160),('2024-06-02 05:15:00.000000',00000000000001724629),('2024-06-02 05:20:00.000000',00000000000001750429),('2024-06-02 05:25:00.000000',00000000000001753529),('2024-06-02 05:30:00.000000',00000000000001764429),('2024-06-02 05:35:00.000000',00000000000001820219),('2024-06-02 05:40:00.000000',00000000000001812319),('2024-06-02 05:45:00.000000',00000000000001817219),('2024-06-02 05:50:00.000000',00000000000001828119),('2024-06-02 05:55:00.000000',00000000000001833019),('2024-06-02 06:00:00.000000',00000000000001836919),('2024-06-02 06:05:00.000000',00000000000001851819),('2024-06-02 06:10:00.000000',00000000000001872819),('2024-06-02 06:15:00.000000',00000000000001875719),('2024-06-02 06:20:00.000000',00000000000001883619),('2024-06-02 06:25:00.000000',00000000000001899419),('2024-06-02 06:30:00.000000',00000000000001907319),('2024-06-02 06:35:00.000000',00000000000001921209),('2024-06-02 06:40:00.000000',00000000000001929845),('2024-06-02 06:45:00.000000',00000000000001947311),('2024-06-02 06:50:00.000000',00000000000001967211),('2024-06-02 06:55:00.000000',00000000000001976310),('2024-06-02 07:00:00.000000',00000000000001983210),('2024-06-02 07:05:00.000000',00000000000001999000),('2024-06-02 07:10:00.000000',00000000000002010700),('2024-06-02 07:15:00.000000',00000000000002163800),('2024-06-02 07:20:00.000000',00000000000002172600),('2024-06-02 07:25:00.000000',00000000000002180500),('2024-06-02 07:30:00.000000',00000000000002193289),('2024-06-02 07:35:00.000000',00000000000002187277),('2024-06-02 07:40:00.000000',00000000000002195177),('2024-06-02 07:45:00.000000',00000000000002206977),('2024-06-02 07:50:00.000000',00000000000002219867),('2024-06-02 07:55:00.000000',00000000000002232657),('2024-06-02 08:00:00.000000',00000000000002232757),('2024-06-02 08:05:00.000000',00000000000002241657),('2024-06-02 08:10:00.000000',00000000000002257457),('2024-06-02 08:15:00.000000',00000000000002264546),('2024-06-02 08:20:00.000000',00000000000002276346),('2024-06-02 08:25:00.000000',00000000000002287246),('2024-06-02 08:30:00.000000',00000000000002291336),('2024-06-02 08:35:00.000000',00000000000002304812),('2024-06-02 08:40:00.000000',00000000000002329372),('2024-06-02 08:45:00.000000',00000000000002349071),('2024-06-02 08:50:00.000000',00000000000002393451),('2024-06-02 08:55:00.000000',00000000000002396451),('2024-06-02 09:00:00.000000',00000000000002399441),('2024-06-02 09:05:00.000000',00000000000002402441),('2024-06-02 09:10:00.000000',00000000000002404441),('2024-06-02 09:15:00.000000',00000000000002401641),('2024-06-02 09:20:00.000000',00000000000002385041),('2024-06-02 09:25:00.000000',00000000000002411641),('2024-06-02 09:30:00.000000',00000000000002427341),('2024-06-02 09:35:00.000000',00000000000002453041),('2024-06-02 09:40:00.000000',00000000000002461931),('2024-06-02 09:45:00.000000',00000000000002483721),('2024-06-02 09:50:00.000000',00000000000002484721),('2024-06-02 09:55:00.000000',00000000000002485721),('2024-06-02 10:00:00.000000',00000000000002494621),('2024-06-02 10:05:00.000000',00000000000002498500),('2024-06-02 10:10:00.000000',00000000000002511399),('2024-06-02 10:15:00.000000',00000000000002518399),('2024-06-02 10:20:00.000000',00000000000002537099),('2024-06-02 10:25:00.000000',00000000000002558799),('2024-06-02 10:30:00.000000',00000000000002570199),('2024-06-02 10:35:00.000000',00000000000002593699),('2024-06-02 10:40:00.000000',00000000000002613489),('2024-06-02 10:45:00.000000',00000000000002614589),('2024-06-02 10:50:00.000000',00000000000002631378),('2024-06-02 10:55:00.000000',00000000000002641277),('2024-06-02 11:00:00.000000',00000000000002645277),('2024-06-02 11:05:00.000000',00000000000002647367),('2024-06-02 11:10:00.000000',00000000000002672056),('2024-06-02 11:15:00.000000',00000000000002673056),('2024-06-02 11:20:00.000000',00000000000002675956),('2024-06-02 11:25:00.000000',00000000000002692876),('2024-06-02 11:30:00.000000',00000000000002695966),('2024-06-02 11:35:00.000000',00000000000002713366),('2024-06-02 11:40:00.000000',00000000000002770366),('2024-06-02 11:45:00.000000',00000000000002783066),('2024-06-02 11:50:00.000000',00000000000002799766),('2024-06-02 11:55:00.000000',00000000000002806765),('2024-06-02 12:00:00.000000',00000000000002806765),('2024-06-02 12:05:00.000000',00000000000002821565),('2024-06-02 12:10:00.000000',00000000000002830465),('2024-06-02 12:15:00.000000',00000000000002832465),('2024-06-02 12:20:00.000000',00000000000002847255),('2024-06-02 12:25:00.000000',00000000000002852145),('2024-06-02 12:30:00.000000',00000000000002863925),('2024-06-02 12:35:00.000000',00000000000002898325),('2024-06-02 12:40:00.000000',00000000000002910925),('2024-06-02 12:45:00.000000',00000000000002930825),('2024-06-02 12:50:00.000000',00000000000002930925),('2024-06-02 12:55:00.000000',00000000000002932915),('2024-06-02 13:00:00.000000',00000000000002941815),('2024-06-02 13:05:00.000000',00000000000002968305),('2024-06-02 13:10:00.000000',00000000000002972205),('2024-06-02 13:15:00.000000',00000000000002997805),('2024-06-02 13:20:00.000000',00000000000003161804),('2024-06-02 13:25:00.000000',00000000000003165794),('2024-06-02 13:30:00.000000',00000000000003179394),('2024-06-02 13:35:00.000000',00000000000003182594),('2024-06-02 13:40:00.000000',00000000000003202394),('2024-06-02 13:45:00.000000',00000000000003210294),('2024-06-02 13:50:00.000000',00000000000003219314),('2024-06-02 13:55:00.000000',00000000000003228303),('2024-06-02 14:00:00.000000',00000000000003234203),('2024-06-02 14:05:00.000000',00000000000003239193),('2024-06-02 14:10:00.000000',00000000000003251983),('2024-06-02 14:15:00.000000',00000000000003275883),('2024-06-02 14:20:00.000000',00000000000003275883),('2024-06-02 14:25:00.000000',00000000000003277683),('2024-06-02 14:30:00.000000',00000000000003289483),('2024-06-02 14:35:00.000000',00000000000003325083),('2024-06-02 14:40:00.000000',00000000000003340173),('2024-06-02 14:45:00.000000',00000000000003353073),('2024-06-02 14:50:00.000000',00000000000003357973),('2024-06-02 14:55:00.000000',00000000000003370863),('2024-06-02 15:00:00.000000',00000000000003396553),('2024-06-02 15:05:00.000000',00000000000003388743),('2024-06-02 15:10:00.000000',00000000000003556543),('2024-06-02 15:15:00.000000',00000000000003570443),('2024-06-02 15:20:00.000000',00000000000003581342),('2024-06-02 15:25:00.000000',00000000000003604242),('2024-06-02 15:30:00.000000',00000000000003619042),('2024-06-02 15:35:00.000000',00000000000003639832),('2024-06-02 15:40:00.000000',00000000000003668332),('2024-06-02 15:45:00.000000',00000000000003683222),('2024-06-02 15:50:00.000000',00000000000003694021),('2024-06-02 15:55:00.000000',00000000000003708721),('2024-06-02 16:00:00.000000',00000000000000000000),('2024-06-02 16:05:00.000000',00000000000000006000),('2024-06-02 16:10:00.000000',00000000000000028900),('2024-06-02 16:15:00.000000',00000000000000047700),('2024-06-02 16:20:00.000000',00000000000000097400),('2024-06-02 16:25:00.000000',00000000000000104300),('2024-06-02 16:30:00.000000',00000000000000248790),('2024-06-02 16:35:00.000000',00000000000000271590),('2024-06-02 16:40:00.000000',00000000000000318970),('2024-06-02 16:45:00.000000',00000000000000319170),('2024-06-02 16:50:00.000000',00000000000000369669),('2024-06-02 16:55:00.000000',00000000000000401368),('2024-06-02 17:00:00.000000',00000000000000418168),('2024-06-02 17:05:00.000000',00000000000000434068),('2024-06-02 17:10:00.000000',00000000000000468568),('2024-06-02 17:15:00.000000',00000000000000495538),('2024-06-02 17:20:00.000000',00000000000000508428),('2024-06-02 17:25:00.000000',00000000000000519427),('2024-06-02 17:30:00.000000',00000000000000568717),('2024-06-02 17:35:00.000000',00000000000000622617),('2024-06-02 17:40:00.000000',00000000000000625617),('2024-06-02 17:45:00.000000',00000000000000636617),('2024-06-02 17:50:00.000000',00000000000000650516),('2024-06-02 17:55:00.000000',00000000000000660516),('2024-06-02 18:00:00.000000',00000000000000661616),('2024-06-02 18:05:00.000000',00000000000000679406),('2024-06-02 18:10:00.000000',00000000000000701006),('2024-06-02 18:15:00.000000',00000000000000716206),('2024-06-02 18:20:00.000000',00000000000000737806),('2024-06-02 18:25:00.000000',00000000000000739706),('2024-06-02 18:30:00.000000',00000000000000747706),('2024-06-02 18:35:00.000000',00000000000000752606),('2024-06-02 18:40:00.000000',00000000000000748585),('2024-06-02 18:45:00.000000',00000000000000751575),('2024-06-02 18:50:00.000000',00000000000000756675),('2024-06-02 18:55:00.000000',00000000000000756675),('2024-06-02 19:00:00.000000',00000000000000758341),('2024-06-02 19:05:00.000000',00000000000000767075),('2024-06-02 19:10:00.000000',00000000000000780621),('2024-06-02 19:15:00.000000',00000000000000782621),('2024-06-02 19:20:00.000000',00000000000000782621),('2024-06-02 19:25:00.000000',00000000000000782621),('2024-06-02 19:30:00.000000',00000000000000784621),('2024-06-02 19:35:00.000000',00000000000000784621),('2024-06-02 19:40:00.000000',00000000000000787521),('2024-06-02 19:45:00.000000',00000000000000804301),('2024-06-02 19:50:00.000000',00000000000000810180),('2024-06-02 19:55:00.000000',00000000000000812180),('2024-06-02 20:00:00.000000',00000000000000821170),('2024-06-02 20:05:00.000000',00000000000000822160),('2024-06-02 20:10:00.000000',00000000000000824160),('2024-06-02 20:15:00.000000',00000000000000843849),('2024-06-02 20:20:00.000000',00000000000000855949),('2024-06-02 20:25:00.000000',00000000000000866749),('2024-06-02 20:30:00.000000',00000000000000872649),('2024-06-02 20:35:00.000000',00000000000000876638),('2024-06-02 20:40:00.000000',00000000000000876638),('2024-06-02 20:45:00.000000',00000000000000876638),('2024-06-02 20:50:00.000000',00000000000000877638),('2024-06-02 20:55:00.000000',00000000000000881538),('2024-06-02 21:00:00.000000',00000000000000883538),('2024-06-02 21:05:00.000000',00000000000000886638),('2024-06-02 21:10:00.000000',00000000000000886638),('2024-06-02 21:15:00.000000',00000000000000886638),('2024-06-02 21:20:00.000000',00000000000000894538),('2024-06-02 21:25:00.000000',00000000000000887638),('2024-06-02 21:30:00.000000',00000000000000888638),('2024-06-02 21:35:00.000000',00000000000000888638),('2024-06-02 21:40:00.000000',00000000000000898538),('2024-06-02 21:45:00.000000',00000000000000898538),('2024-06-02 21:50:00.000000',00000000000000938438),('2024-06-02 21:55:00.000000',00000000000000942437),('2024-06-02 22:00:00.000000',00000000000000942437),('2024-06-02 22:05:00.000000',00000000000000942437),('2024-06-02 22:10:00.000000',00000000000000943537),('2024-06-02 22:15:00.000000',00000000000000944537),('2024-06-02 22:20:00.000000',00000000000000945537),('2024-06-02 22:25:00.000000',00000000000000950437),('2024-06-02 22:30:00.000000',00000000000000961337),('2024-06-02 22:35:00.000000',00000000000000960337),('2024-06-02 22:40:00.000000',00000000000000965237),('2024-06-02 22:45:00.000000',00000000000000967237),('2024-06-02 22:50:00.000000',00000000000000969337),('2024-06-02 22:55:00.000000',00000000000000969337),('2024-06-02 23:00:00.000000',00000000000000973237),('2024-06-02 23:05:00.000000',00000000000000977227),('2024-06-02 23:10:00.000000',00000000000000999817),('2024-06-02 23:15:00.000000',00000000000000999817),('2024-06-02 23:20:00.000000',00000000000001009717),('2024-06-02 23:25:00.000000',00000000000001010717),('2024-06-02 23:30:00.000000',00000000000001012697),('2024-06-02 23:35:00.000000',00000000000001055597),('2024-06-02 23:40:00.000000',00000000000001059587),('2024-06-02 23:45:00.000000',00000000000001065487),('2024-06-02 23:50:00.000000',00000000000001065487),('2024-06-02 23:55:00.000000',00000000000001068487),('2024-06-03 00:00:00.000000',00000000000001077387),('2024-06-03 00:05:00.000000',00000000000001089287),('2024-06-03 00:10:00.000000',00000000000001098186),('2024-06-03 00:15:00.000000',00000000000001101186),('2024-06-03 00:20:00.000000',00000000000001113286),('2024-06-03 00:25:00.000000',00000000000001122386),('2024-06-03 00:30:00.000000',00000000000001122386),('2024-06-03 00:35:00.000000',00000000000001134286),('2024-06-03 00:40:00.000000',00000000000001135286),('2024-06-03 00:45:00.000000',00000000000001140186),('2024-06-03 00:50:00.000000',00000000000001140186),('2024-06-03 00:55:00.000000',00000000000001142186),('2024-06-03 01:00:00.000000',00000000000001157986),('2024-06-03 01:05:00.000000',00000000000001298876),('2024-06-03 01:10:00.000000',00000000000001321576),('2024-06-03 01:15:00.000000',00000000000001347176),('2024-06-03 01:20:00.000000',00000000000001400675),('2024-06-03 01:25:00.000000',00000000000001417375),('2024-06-03 01:30:00.000000',00000000000001419275),('2024-06-03 01:35:00.000000',00000000000001431054),('2024-06-03 01:40:00.000000',00000000000001434954),('2024-06-03 01:45:00.000000',00000000000001434954),('2024-06-03 01:50:00.000000',00000000000001441854),('2024-06-03 01:55:00.000000',00000000000001451454),('2024-06-03 02:00:00.000000',00000000000001451554),('2024-06-03 02:05:00.000000',00000000000001462454),('2024-06-03 02:10:00.000000',00000000000001462454),('2024-06-03 02:15:00.000000',00000000000001462454),('2024-06-03 02:20:00.000000',00000000000001462554),('2024-06-03 02:25:00.000000',00000000000001471444),('2024-06-03 02:30:00.000000',00000000000001472444),('2024-06-03 02:35:00.000000',00000000000001478344),('2024-06-03 02:40:00.000000',00000000000001478344),('2024-06-03 02:45:00.000000',00000000000001488234),('2024-06-03 02:50:00.000000',00000000000001491434),('2024-06-03 02:55:00.000000',00000000000001494534),('2024-06-03 03:00:00.000000',00000000000001512234),('2024-06-03 03:05:00.000000',00000000000001513234),('2024-06-03 03:10:00.000000',00000000000001513234),('2024-06-03 03:15:00.000000',00000000000001515234),('2024-06-03 03:20:00.000000',00000000000001521134),('2024-06-03 03:25:00.000000',00000000000001538034),('2024-06-03 03:30:00.000000',00000000000001553834),('2024-06-03 03:35:00.000000',00000000000001553834),('2024-06-03 03:40:00.000000',00000000000001556034),('2024-06-03 03:45:00.000000',00000000000001592734),('2024-06-03 03:50:00.000000',00000000000001600634),('2024-06-03 03:55:00.000000',00000000000001601634),('2024-06-03 04:00:00.000000',00000000000001606534),('2024-06-03 04:05:00.000000',00000000000001607524),('2024-06-03 04:10:00.000000',00000000000001614084),('2024-06-03 04:15:00.000000',00000000000001614084),('2024-06-03 04:20:00.000000',00000000000001614084),('2024-06-03 04:25:00.000000',00000000000001618984),('2024-06-03 04:30:00.000000',00000000000001643874),('2024-06-03 04:35:00.000000',00000000000001677274),('2024-06-03 04:40:00.000000',00000000000001691174),('2024-06-03 04:45:00.000000',00000000000001692164),('2024-06-03 04:50:00.000000',00000000000001709064),('2024-06-03 04:55:00.000000',00000000000001713164),('2024-06-03 05:00:00.000000',00000000000001713164),('2024-06-03 05:05:00.000000',00000000000001771864),('2024-06-03 05:10:00.000000',00000000000001782664),('2024-06-03 05:15:00.000000',00000000000001791654),('2024-06-03 05:20:00.000000',00000000000001797654),('2024-06-03 05:25:00.000000',00000000000001812554),('2024-06-03 05:30:00.000000',00000000000001822454),('2024-06-03 05:35:00.000000',00000000000001842154),('2024-06-03 05:40:00.000000',00000000000001842254),('2024-06-03 05:45:00.000000',00000000000001853154),('2024-06-03 05:50:00.000000',00000000000001871954),('2024-06-03 05:55:00.000000',00000000000001879844),('2024-06-03 06:00:00.000000',00000000000001887844),('2024-06-03 06:05:00.000000',00000000000001892834),('2024-06-03 06:10:00.000000',00000000000001906834),('2024-06-03 06:15:00.000000',00000000000001907834),('2024-06-03 06:20:00.000000',00000000000001909834),('2024-06-03 06:25:00.000000',00000000000001910834),('2024-06-03 06:30:00.000000',00000000000001915833),('2024-06-03 06:35:00.000000',00000000000001920733),('2024-06-03 06:40:00.000000',00000000000001941433),('2024-06-03 06:45:00.000000',00000000000001992122),('2024-06-03 06:50:00.000000',00000000000002000678),('2024-06-03 06:55:00.000000',00000000000002020278),('2024-06-03 07:00:00.000000',00000000000002023179),('2024-06-03 07:05:00.000000',00000000000002029079),('2024-06-03 07:10:00.000000',00000000000002032079),('2024-06-03 07:15:00.000000',00000000000002034979),('2024-06-03 07:20:00.000000',00000000000002042879),('2024-06-03 07:25:00.000000',00000000000002066379),('2024-06-03 07:30:00.000000',00000000000002068379),('2024-06-03 07:35:00.000000',00000000000002069479),('2024-06-03 07:40:00.000000',00000000000002068479),('2024-06-03 07:45:00.000000',00000000000002112258),('2024-06-03 07:50:00.000000',00000000000002121158),('2024-06-03 07:55:00.000000',00000000000002129058),('2024-06-03 08:00:00.000000',00000000000002155758),('2024-06-03 08:05:00.000000',00000000000002155858),('2024-06-03 08:10:00.000000',00000000000002162658),('2024-06-03 08:15:00.000000',00000000000002173558),('2024-06-03 08:20:00.000000',00000000000002176658),('2024-06-03 08:25:00.000000',00000000000002204258),('2024-06-03 08:30:00.000000',00000000000002220058),('2024-06-03 08:35:00.000000',00000000000002234958),('2024-06-03 08:40:00.000000',00000000000002243958),('2024-06-03 08:45:00.000000',00000000000002247948),('2024-06-03 08:50:00.000000',00000000000002386248),('2024-06-03 08:55:00.000000',00000000000002395148),('2024-06-03 09:00:00.000000',00000000000002414948),('2024-06-03 09:05:00.000000',00000000000002425848),('2024-06-03 09:10:00.000000',00000000000002429848),('2024-06-03 09:15:00.000000',00000000000002453737),('2024-06-03 09:20:00.000000',00000000000002464203),('2024-06-03 09:25:00.000000',00000000000002467203),('2024-06-03 09:30:00.000000',00000000000002484683),('2024-06-03 09:35:00.000000',00000000000002494583),('2024-06-03 09:40:00.000000',00000000000002494583),('2024-06-03 09:45:00.000000',00000000000002510383),('2024-06-03 09:50:00.000000',00000000000002519283),('2024-06-03 09:55:00.000000',00000000000002522273),('2024-06-03 10:00:00.000000',00000000000002537053),('2024-06-03 10:05:00.000000',00000000000002552633),('2024-06-03 10:10:00.000000',00000000000002563513),('2024-06-03 10:15:00.000000',00000000000002574513),('2024-06-03 10:20:00.000000',00000000000002577513),('2024-06-03 10:25:00.000000',00000000000002577613),('2024-06-03 10:30:00.000000',00000000000002611213),('2024-06-03 10:35:00.000000',00000000000002613213),('2024-06-03 10:40:00.000000',00000000000002622013),('2024-06-03 10:45:00.000000',00000000000002624013),('2024-06-03 10:50:00.000000',00000000000002626913),('2024-06-03 10:55:00.000000',00000000000002628902),('2024-06-03 11:00:00.000000',00000000000002629902),('2024-06-03 11:05:00.000000',00000000000002631902),('2024-06-03 11:10:00.000000',00000000000002633592),('2024-06-03 11:15:00.000000',00000000000002633592),('2024-06-03 11:20:00.000000',00000000000002636692),('2024-06-03 11:25:00.000000',00000000000002650382),('2024-06-03 11:30:00.000000',00000000000002653482),('2024-06-03 11:35:00.000000',00000000000002659382),('2024-06-03 11:40:00.000000',00000000000002659382),('2024-06-03 11:45:00.000000',00000000000002669282),('2024-06-03 11:50:00.000000',00000000000002677182),('2024-06-03 11:55:00.000000',00000000000002681282),('2024-06-03 12:00:00.000000',00000000000002691182),('2024-06-03 12:05:00.000000',00000000000002707082),('2024-06-03 12:10:00.000000',00000000000002708082),('2024-06-03 12:15:00.000000',00000000000002733972),('2024-06-03 12:20:00.000000',00000000000002748862),('2024-06-03 12:25:00.000000',00000000000002751952),('2024-06-03 12:30:00.000000',00000000000002759852),('2024-06-03 12:35:00.000000',00000000000002805722),('2024-06-03 12:40:00.000000',00000000000002818612),('2024-06-03 12:45:00.000000',00000000000002830511),('2024-06-03 12:50:00.000000',00000000000002835611),('2024-06-03 12:55:00.000000',00000000000002844401),('2024-06-03 13:00:00.000000',00000000000002855101),('2024-06-03 13:05:00.000000',00000000000002871801),('2024-06-03 13:10:00.000000',00000000000002875801),('2024-06-03 13:15:00.000000',00000000000002877801),('2024-06-03 13:20:00.000000',00000000000002900301),('2024-06-03 13:25:00.000000',00000000000002920901),('2024-06-03 13:30:00.000000',00000000000002934801),('2024-06-03 13:35:00.000000',00000000000002943701),('2024-06-03 13:40:00.000000',00000000000002976391),('2024-06-03 13:45:00.000000',00000000000002989381),('2024-06-03 13:50:00.000000',00000000000002994381),('2024-06-03 13:55:00.000000',00000000000003012181),('2024-06-03 14:00:00.000000',00000000000003044981),('2024-06-03 14:05:00.000000',00000000000003053081),('2024-06-03 14:10:00.000000',00000000000003055081),('2024-06-03 14:15:00.000000',00000000000003063071),('2024-06-03 14:20:00.000000',00000000000003064071),('2024-06-03 14:25:00.000000',00000000000003072020),('2024-06-03 14:30:00.000000',00000000000003109416),('2024-06-03 14:35:00.000000',00000000000003108416),('2024-06-03 14:40:00.000000',00000000000003112306),('2024-06-03 14:45:00.000000',00000000000003116306),('2024-06-03 14:50:00.000000',00000000000003134096),('2024-06-03 14:55:00.000000',00000000000003188596),('2024-06-03 15:00:00.000000',00000000000003191596),('2024-06-03 15:05:00.000000',00000000000003202486),('2024-06-03 15:10:00.000000',00000000000003212476),('2024-06-03 15:15:00.000000',00000000000003218576),('2024-06-03 15:20:00.000000',00000000000003233376),('2024-06-03 15:25:00.000000',00000000000003252366),('2024-06-03 15:30:00.000000',00000000000003269856),('2024-06-03 15:35:00.000000',00000000000003273844),('2024-06-03 15:40:00.000000',00000000000003346744),('2024-06-03 15:45:00.000000',00000000000003350844),('2024-06-03 15:50:00.000000',00000000000003369844),('2024-06-03 15:55:00.000000',00000000000003382944),('2024-06-03 16:00:00.000000',00000000000000000000),('2024-06-03 16:05:00.000000',00000000000000005980),('2024-06-03 16:10:00.000000',00000000000000018880),('2024-06-03 16:15:00.000000',00000000000000040870),('2024-06-03 16:20:00.000000',00000000000000051860),('2024-06-03 16:25:00.000000',00000000000000097260),('2024-06-03 16:30:00.000000',00000000000000106260),('2024-06-03 16:35:00.000000',00000000000000111560),('2024-06-03 16:40:00.000000',00000000000000125550),('2024-06-03 16:45:00.000000',00000000000000137450),('2024-06-03 16:50:00.000000',00000000000000163250),('2024-06-03 16:55:00.000000',00000000000000192406),('2024-06-03 17:00:00.000000',00000000000000207405),('2024-06-03 17:05:00.000000',00000000000000262105),('2024-06-03 17:10:00.000000',00000000000000269905),('2024-06-03 17:15:00.000000',00000000000000279885),('2024-06-03 17:20:00.000000',00000000000000316574),('2024-06-03 17:25:00.000000',00000000000000331274),('2024-06-03 17:30:00.000000',00000000000000351963),('2024-06-03 17:35:00.000000',00000000000000411162),('2024-06-03 17:40:00.000000',00000000000000708062),('2024-06-03 17:45:00.000000',00000000000000731852),('2024-06-03 17:50:00.000000',00000000000000740942),('2024-06-03 17:55:00.000000',00000000000000756942),('2024-06-03 18:00:00.000000',00000000000000765842),('2024-06-03 18:05:00.000000',00000000000000809042),('2024-06-03 18:10:00.000000',00000000000000816042),('2024-06-03 18:15:00.000000',00000000000000825031),('2024-06-03 18:20:00.000000',00000000000000848031),('2024-06-03 18:25:00.000000',00000000000000859031),('2024-06-03 18:30:00.000000',00000000000000874631),('2024-06-03 18:35:00.000000',00000000000000901531),('2024-06-03 18:40:00.000000',00000000000000909631),('2024-06-03 18:45:00.000000',00000000000000918631),('2024-06-03 18:50:00.000000',00000000000000923631),('2024-06-03 18:55:00.000000',00000000000000927731),('2024-06-03 19:00:00.000000',00000000000000940831),('2024-06-03 19:05:00.000000',00000000000000952931),('2024-06-03 19:10:00.000000',00000000000000962031),('2024-06-03 19:15:00.000000',00000000000000976031),('2024-06-03 19:20:00.000000',00000000000000988031),('2024-06-03 19:25:00.000000',00000000000000993131),('2024-06-03 19:30:00.000000',00000000000001005331),('2024-06-03 19:35:00.000000',00000000000001010331),('2024-06-03 19:40:00.000000',00000000000001025231),('2024-06-03 19:45:00.000000',00000000000001032131),('2024-06-03 19:50:00.000000',00000000000001033231),('2024-06-03 19:55:00.000000',00000000000001033231),('2024-06-03 20:00:00.000000',00000000000001034231),('2024-06-03 20:05:00.000000',00000000000001045131),('2024-06-03 20:10:00.000000',00000000000001045331),('2024-06-03 20:15:00.000000',00000000000001047331),('2024-06-03 20:20:00.000000',00000000000001047331),('2024-06-03 20:25:00.000000',00000000000001048331),('2024-06-03 20:30:00.000000',00000000000001050531),('2024-06-03 20:35:00.000000',00000000000001061431),('2024-06-03 20:40:00.000000',00000000000001103431),('2024-06-03 20:45:00.000000',00000000000001103431),('2024-06-03 20:50:00.000000',00000000000001103431),('2024-06-03 20:55:00.000000',00000000000001105431),('2024-06-03 21:00:00.000000',00000000000001117331),('2024-06-03 21:05:00.000000',00000000000001121231),('2024-06-03 21:10:00.000000',00000000000001129131),('2024-06-03 21:15:00.000000',00000000000001131131),('2024-06-03 21:20:00.000000',00000000000001132231),('2024-06-03 21:25:00.000000',00000000000001134231),('2024-06-03 21:30:00.000000',00000000000001134231),('2024-06-03 21:35:00.000000',00000000000001144131),('2024-06-03 21:40:00.000000',00000000000001150931),('2024-06-03 21:45:00.000000',00000000000001158931),('2024-06-03 21:50:00.000000',00000000000001158931),('2024-06-03 21:55:00.000000',00000000000001164930),('2024-06-03 22:00:00.000000',00000000000001204830),('2024-06-03 22:05:00.000000',00000000000001204830),('2024-06-03 22:10:00.000000',00000000000001211730),('2024-06-03 22:15:00.000000',00000000000001243530),('2024-06-03 22:20:00.000000',00000000000001253430),('2024-06-03 22:25:00.000000',00000000000001252520),('2024-06-03 22:30:00.000000',00000000000001258420),('2024-06-03 22:35:00.000000',00000000000001265220),('2024-06-03 22:40:00.000000',00000000000001274120),('2024-06-03 22:45:00.000000',00000000000001275120),('2024-06-03 22:50:00.000000',00000000000001279109),('2024-06-03 22:55:00.000000',00000000000001279109),('2024-06-03 23:00:00.000000',00000000000001279109),('2024-06-03 23:05:00.000000',00000000000001289809),('2024-06-03 23:10:00.000000',00000000000001292809),('2024-06-03 23:15:00.000000',00000000000001294809),('2024-06-03 23:20:00.000000',00000000000001301809),('2024-06-03 23:25:00.000000',00000000000001312709),('2024-06-03 23:30:00.000000',00000000000001314809),('2024-06-03 23:35:00.000000',00000000000001318809),('2024-06-03 23:40:00.000000',00000000000001326709),('2024-06-03 23:45:00.000000',00000000000001327709),('2024-06-03 23:50:00.000000',00000000000001328709),('2024-06-03 23:55:00.000000',00000000000001332709),('2024-06-04 00:00:00.000000',00000000000001333709),('2024-06-04 00:05:00.000000',00000000000001334709),('2024-06-04 00:10:00.000000',00000000000001349509),('2024-06-04 00:15:00.000000',00000000000001350509),('2024-06-04 00:20:00.000000',00000000000001353409),('2024-06-04 00:25:00.000000',00000000000001358399),('2024-06-04 00:30:00.000000',00000000000001365399),('2024-06-04 00:35:00.000000',00000000000001382999),('2024-06-04 00:40:00.000000',00000000000001397699),('2024-06-04 00:45:00.000000',00000000000001397699),('2024-06-04 00:50:00.000000',00000000000001427199),('2024-06-04 00:55:00.000000',00000000000001430199),('2024-06-04 01:00:00.000000',00000000000001454799),('2024-06-04 01:05:00.000000',00000000000001457789),('2024-06-04 01:10:00.000000',00000000000001469689),('2024-06-04 01:15:00.000000',00000000000001475589),('2024-06-04 01:20:00.000000',00000000000001485589),('2024-06-04 01:25:00.000000',00000000000001500679),('2024-06-04 01:30:00.000000',00000000000001509579),('2024-06-04 01:35:00.000000',00000000000001516679),('2024-06-04 01:40:00.000000',00000000000001529579),('2024-06-04 01:45:00.000000',00000000000001544579),('2024-06-04 01:50:00.000000',00000000000001561379),('2024-06-04 01:55:00.000000',00000000000001566379),('2024-06-04 02:00:00.000000',00000000000001577268),('2024-06-04 02:05:00.000000',00000000000001585168),('2024-06-04 02:10:00.000000',00000000000001601568),('2024-06-04 02:15:00.000000',00000000000001614256),('2024-06-04 02:20:00.000000',00000000000001617356),('2024-06-04 02:25:00.000000',00000000000001621556),('2024-06-04 02:30:00.000000',00000000000001622556),('2024-06-04 02:35:00.000000',00000000000001644956),('2024-06-04 02:40:00.000000',00000000000001649856),('2024-06-04 02:45:00.000000',00000000000001654856),('2024-06-04 02:50:00.000000',00000000000001658856),('2024-06-04 02:55:00.000000',00000000000001661156),('2024-06-04 03:00:00.000000',00000000000001663156),('2024-06-04 03:05:00.000000',00000000000001669056),('2024-06-04 03:10:00.000000',00000000000001671056),('2024-06-04 03:15:00.000000',00000000000001675155),('2024-06-04 03:20:00.000000',00000000000001687155),('2024-06-04 03:25:00.000000',00000000000001696055),('2024-06-04 03:30:00.000000',00000000000001697055),('2024-06-04 03:35:00.000000',00000000000001699055),('2024-06-04 03:40:00.000000',00000000000001699055),('2024-06-04 03:45:00.000000',00000000000001708955),('2024-06-04 03:50:00.000000',00000000000001715055),('2024-06-04 03:55:00.000000',00000000000001724955),('2024-06-04 04:00:00.000000',00000000000001725955),('2024-06-04 04:05:00.000000',00000000000001725955),('2024-06-04 04:10:00.000000',00000000000001732855),('2024-06-04 04:15:00.000000',00000000000001753655),('2024-06-04 04:20:00.000000',00000000000001761644),('2024-06-04 04:25:00.000000',00000000000001765744),('2024-06-04 04:30:00.000000',00000000000001771743),('2024-06-04 04:35:00.000000',00000000000001773943),('2024-06-04 04:40:00.000000',00000000000001784833),('2024-06-04 04:45:00.000000',00000000000001797033),('2024-06-04 04:50:00.000000',00000000000001807033),('2024-06-04 04:55:00.000000',00000000000001811033),('2024-06-04 05:00:00.000000',00000000000001823233),('2024-06-04 05:05:00.000000',00000000000001829332),('2024-06-04 05:10:00.000000',00000000000001849032),('2024-06-04 05:15:00.000000',00000000000001864032),('2024-06-04 05:20:00.000000',00000000000001873832),('2024-06-04 05:25:00.000000',00000000000001899332),('2024-06-04 05:30:00.000000',00000000000001901432),('2024-06-04 05:35:00.000000',00000000000001918132),('2024-06-04 05:40:00.000000',00000000000001924131),('2024-06-04 05:45:00.000000',00000000000001936031),('2024-06-04 05:50:00.000000',00000000000001941121),('2024-06-04 05:55:00.000000',00000000000001956121),('2024-06-04 06:00:00.000000',00000000000001958121),('2024-06-04 06:05:00.000000',00000000000001958121),('2024-06-04 06:10:00.000000',00000000000001972921),('2024-06-04 06:15:00.000000',00000000000001970921),('2024-06-04 06:20:00.000000',00000000000001985011),('2024-06-04 06:25:00.000000',00000000000001989921),('2024-06-04 06:30:00.000000',00000000000002000721),('2024-06-04 06:35:00.000000',00000000000002011421),('2024-06-04 06:40:00.000000',00000000000002016221),('2024-06-04 06:45:00.000000',00000000000002030121),('2024-06-04 06:50:00.000000',00000000000002039921),('2024-06-04 06:55:00.000000',00000000000002060521),('2024-06-04 07:00:00.000000',00000000000002080021),('2024-06-04 07:05:00.000000',00000000000002085221),('2024-06-04 07:10:00.000000',00000000000002088211),('2024-06-04 07:15:00.000000',00000000000002097111),('2024-06-04 07:20:00.000000',00000000000002126511),('2024-06-04 07:25:00.000000',00000000000002132611),('2024-06-04 07:30:00.000000',00000000000002147211),('2024-06-04 07:35:00.000000',00000000000002156111),('2024-06-04 07:40:00.000000',00000000000002161211),('2024-06-04 07:45:00.000000',00000000000002178911),('2024-06-04 07:50:00.000000',00000000000002184999),('2024-06-04 07:55:00.000000',00000000000002188010),('2024-06-04 08:00:00.000000',00000000000002198010),('2024-06-04 08:05:00.000000',00000000000002223510),('2024-06-04 08:10:00.000000',00000000000002234410),('2024-06-04 08:15:00.000000',00000000000002248110),('2024-06-04 08:20:00.000000',00000000000002277710),('2024-06-04 08:25:00.000000',00000000000002280710),('2024-06-04 08:30:00.000000',00000000000002293610),('2024-06-04 08:35:00.000000',00000000000002584410),('2024-06-04 08:40:00.000000',00000000000002598310),('2024-06-04 08:45:00.000000',00000000000002603309),('2024-06-04 08:50:00.000000',00000000000002621109),('2024-06-04 08:55:00.000000',00000000000002626909),('2024-06-04 09:00:00.000000',00000000000002640909),('2024-06-04 09:05:00.000000',00000000000002813576),('2024-06-04 09:10:00.000000',00000000000002818466),('2024-06-04 09:15:00.000000',00000000000002823466),('2024-06-04 09:20:00.000000',00000000000002833854),('2024-06-04 09:25:00.000000',00000000000002841744),('2024-06-04 09:30:00.000000',00000000000002846244),('2024-06-04 09:35:00.000000',00000000000002857344),('2024-06-04 09:40:00.000000',00000000000002865244),('2024-06-04 09:45:00.000000',00000000000002868244),('2024-06-04 09:50:00.000000',00000000000002871244),('2024-06-04 09:55:00.000000',00000000000002879244),('2024-06-04 10:00:00.000000',00000000000002895144),('2024-06-04 10:05:00.000000',00000000000002910944),('2024-06-04 10:10:00.000000',00000000000002913944),('2024-06-04 10:15:00.000000',00000000000002917044),('2024-06-04 10:20:00.000000',00000000000002930734),('2024-06-04 10:25:00.000000',00000000000002978634),('2024-06-04 10:30:00.000000',00000000000002987514),('2024-06-04 10:35:00.000000',00000000000002992504),('2024-06-04 10:40:00.000000',00000000000003009304),('2024-06-04 10:45:00.000000',00000000000003016294),('2024-06-04 10:50:00.000000',00000000000003028294),('2024-06-04 10:55:00.000000',00000000000003050994),('2024-06-04 11:00:00.000000',00000000000003064894),('2024-06-04 11:05:00.000000',00000000000003079794),('2024-06-04 11:10:00.000000',00000000000003090694),('2024-06-04 11:15:00.000000',00000000000003102394),('2024-06-04 11:20:00.000000',00000000000003112194),('2024-06-04 11:25:00.000000',00000000000003114194),('2024-06-04 11:30:00.000000',00000000000003121193),('2024-06-04 11:35:00.000000',00000000000003129093),('2024-06-04 11:40:00.000000',00000000000003140983),('2024-06-04 11:45:00.000000',00000000000003142983),('2024-06-04 11:50:00.000000',00000000000003150783),('2024-06-04 11:55:00.000000',00000000000003156783),('2024-06-04 12:00:00.000000',00000000000003165783),('2024-06-04 12:05:00.000000',00000000000003179183),('2024-06-04 12:10:00.000000',00000000000003181183),('2024-06-04 12:15:00.000000',00000000000003202050),('2024-06-04 12:20:00.000000',00000000000003212949),('2024-06-04 12:25:00.000000',00000000000003219939),('2024-06-04 12:30:00.000000',00000000000003245639),('2024-06-04 12:35:00.000000',00000000000003246639),('2024-06-04 12:40:00.000000',00000000000003320839),('2024-06-04 12:45:00.000000',00000000000003330439),('2024-06-04 12:50:00.000000',00000000000003333429),('2024-06-04 12:55:00.000000',00000000000003333429),('2024-06-04 13:00:00.000000',00000000000003338529),('2024-06-04 13:05:00.000000',00000000000003337529),('2024-06-04 13:10:00.000000',00000000000003342429),('2024-06-04 13:15:00.000000',00000000000003348419),('2024-06-04 13:20:00.000000',00000000000003371108),('2024-06-04 13:25:00.000000',00000000000003387098),('2024-06-04 13:30:00.000000',00000000000003390098),('2024-06-04 13:35:00.000000',00000000000003392098),('2024-06-04 13:40:00.000000',00000000000003401898),('2024-06-04 13:45:00.000000',00000000000003409798),('2024-06-04 13:50:00.000000',00000000000003420598),('2024-06-04 13:55:00.000000',00000000000003420598),('2024-06-04 14:00:00.000000',00000000000003426498),('2024-06-04 14:05:00.000000',00000000000003439198),('2024-06-04 14:10:00.000000',00000000000003442198),('2024-06-04 14:15:00.000000',00000000000003450088),('2024-06-04 14:20:00.000000',00000000000003461888),('2024-06-04 14:25:00.000000',00000000000003498387),('2024-06-04 14:30:00.000000',00000000000003506276),('2024-06-04 14:35:00.000000',00000000000003526876),('2024-06-04 14:40:00.000000',00000000000003546676),('2024-06-04 14:45:00.000000',00000000000003559576),('2024-06-04 14:50:00.000000',00000000000003568366),('2024-06-04 14:55:00.000000',00000000000003571366),('2024-06-04 15:00:00.000000',00000000000003584266),('2024-06-04 15:05:00.000000',00000000000003606966),('2024-06-04 15:10:00.000000',00000000000003633966),('2024-06-04 15:15:00.000000',00000000000003643966),('2024-06-04 15:20:00.000000',00000000000003664966),('2024-06-04 15:25:00.000000',00000000000003684166),('2024-06-04 15:30:00.000000',00000000000003710166),('2024-06-04 15:35:00.000000',00000000000003749365),('2024-06-04 15:40:00.000000',00000000000003774865),('2024-06-04 15:45:00.000000',00000000000003818965),('2024-06-04 15:50:00.000000',00000000000003858265),('2024-06-04 15:55:00.000000',00000000000003895965),('2024-06-04 16:00:00.000000',00000000000000000000),('2024-06-04 16:05:00.000000',00000000000000041899),('2024-06-04 16:10:00.000000',00000000000000125589),('2024-06-04 16:15:00.000000',00000000000000191989),('2024-06-04 16:20:00.000000',00000000000000261189),('2024-06-04 16:25:00.000000',00000000000000310489),('2024-06-04 16:30:00.000000',00000000000000416889),('2024-06-04 16:35:00.000000',00000000000000471589),('2024-06-04 16:40:00.000000',00000000000000531679),('2024-06-04 16:45:00.000000',00000000000000613858),('2024-06-04 16:50:00.000000',00000000000000637758),('2024-06-04 16:55:00.000000',00000000000000675048),('2024-06-04 17:00:00.000000',00000000000000706537),('2024-06-04 17:05:00.000000',00000000000000744527),('2024-06-04 17:10:00.000000',00000000000000784127),('2024-06-04 17:15:00.000000',00000000000000826527),('2024-06-04 17:20:00.000000',00000000000000877827),('2024-06-04 17:25:00.000000',00000000000000934727),('2024-06-04 17:30:00.000000',00000000000000977217),('2024-06-04 17:35:00.000000',00000000000001042817),('2024-06-04 17:40:00.000000',00000000000001138487),('2024-06-04 17:45:00.000000',00000000000001247087),('2024-06-04 17:50:00.000000',00000000000001295687),('2024-06-04 17:55:00.000000',00000000000001345077),('2024-06-04 18:00:00.000000',00000000000001422656),('2024-06-04 18:05:00.000000',00000000000001463946),('2024-06-04 18:10:00.000000',00000000000001515946),('2024-06-04 18:15:00.000000',00000000000001551436),('2024-06-04 18:20:00.000000',00000000000001577136),('2024-06-04 18:25:00.000000',00000000000001619526),('2024-06-04 18:30:00.000000',00000000000001644226),('2024-06-04 18:35:00.000000',00000000000001692916),('2024-06-04 18:40:00.000000',00000000000001739316),('2024-06-04 18:45:00.000000',00000000000001760716),('2024-06-04 18:50:00.000000',00000000000001783216),('2024-06-04 18:55:00.000000',00000000000001806316),('2024-06-04 19:00:00.000000',00000000000001819915),('2024-06-04 19:05:00.000000',00000000000001846015),('2024-06-04 19:10:00.000000',00000000000001872305),('2024-06-04 19:15:00.000000',00000000000001985305),('2024-06-04 19:20:00.000000',00000000000002012405),('2024-06-04 19:25:00.000000',00000000000002023405),('2024-06-04 19:30:00.000000',00000000000002037695),('2024-06-04 19:35:00.000000',00000000000002054995),('2024-06-04 19:40:00.000000',00000000000002082094),('2024-06-04 19:45:00.000000',00000000000002103294),('2024-06-04 19:50:00.000000',00000000000002121794),('2024-06-04 19:55:00.000000',00000000000002172694),('2024-06-04 20:00:00.000000',00000000000002193094),('2024-06-04 20:05:00.000000',00000000000002205494),('2024-06-04 20:10:00.000000',00000000000002221594),('2024-06-04 20:15:00.000000',00000000000002238594),('2024-06-04 20:20:00.000000',00000000000002247694),('2024-06-04 20:25:00.000000',00000000000002259794),('2024-06-04 20:30:00.000000',00000000000002269094),('2024-06-04 20:35:00.000000',00000000000002281294),('2024-06-04 20:40:00.000000',00000000000002292394),('2024-06-04 20:45:00.000000',00000000000002305594),('2024-06-04 20:50:00.000000',00000000000002316894),('2024-06-04 20:55:00.000000',00000000000002319994),('2024-06-04 21:00:00.000000',00000000000002329964),('2024-06-04 21:05:00.000000',00000000000002343164),('2024-06-04 21:10:00.000000',00000000000002353164),('2024-06-04 21:15:00.000000',00000000000002349365),('2024-06-04 21:20:00.000000',00000000000002360565),('2024-06-04 21:25:00.000000',00000000000002369565),('2024-06-04 21:30:00.000000',00000000000002378665),('2024-06-04 21:35:00.000000',00000000000002393855),('2024-06-04 21:40:00.000000',00000000000002402855),('2024-06-04 21:45:00.000000',00000000000002406955),('2024-06-04 21:50:00.000000',00000000000002412055),('2024-06-04 21:55:00.000000',00000000000002422255),('2024-06-04 22:00:00.000000',00000000000002432355),('2024-06-04 22:05:00.000000',00000000000002456145),('2024-06-04 22:10:00.000000',00000000000002473345),('2024-06-04 22:15:00.000000',00000000000002487633),('2024-06-04 22:20:00.000000',00000000000002501633),('2024-06-04 22:25:00.000000',00000000000002509033),('2024-06-04 22:30:00.000000',00000000000002521233),('2024-06-04 22:35:00.000000',00000000000002540533),('2024-06-04 22:40:00.000000',00000000000002561733),('2024-06-04 22:45:00.000000',00000000000002579033),('2024-06-04 22:50:00.000000',00000000000002618133),('2024-06-04 22:55:00.000000',00000000000002640433),('2024-06-04 23:00:00.000000',00000000000002710832),('2024-06-04 23:05:00.000000',00000000000002738932),('2024-06-04 23:10:00.000000',00000000000002757232),('2024-06-04 23:15:00.000000',00000000000002784822),('2024-06-04 23:20:00.000000',00000000000002812222),('2024-06-04 23:25:00.000000',00000000000002830622),('2024-06-04 23:30:00.000000',00000000000002846922),('2024-06-04 23:35:00.000000',00000000000002874122),('2024-06-04 23:40:00.000000',00000000000002895421),('2024-06-04 23:45:00.000000',00000000000002942321),('2024-06-04 23:50:00.000000',00000000000002971221),('2024-06-04 23:55:00.000000',00000000000003014511),('2024-06-05 00:00:00.000000',00000000000003069611),('2024-06-05 00:05:00.000000',00000000000003101411),('2024-06-05 00:10:00.000000',00000000000003156511),('2024-06-05 00:15:00.000000',00000000000003201511),('2024-06-05 00:20:00.000000',00000000000003223411),('2024-06-05 00:25:00.000000',00000000000003243511),('2024-06-05 00:30:00.000000',00000000000003279711),('2024-06-05 00:35:00.000000',00000000000003308111),('2024-06-05 00:40:00.000000',00000000000003340811),('2024-06-05 00:45:00.000000',00000000000003381711),('2024-06-05 00:50:00.000000',00000000000003429601),('2024-06-05 00:55:00.000000',00000000000003484101),('2024-06-05 01:00:00.000000',00000000000003562501),('2024-06-05 01:05:00.000000',00000000000003607091),('2024-06-05 01:10:00.000000',00000000000003648291),('2024-06-05 01:15:00.000000',00000000000003688091),('2024-06-05 01:20:00.000000',00000000000003710391),('2024-06-05 01:25:00.000000',00000000000003745781),('2024-06-05 01:30:00.000000',00000000000003773381),('2024-06-05 01:35:00.000000',00000000000003797481),('2024-06-05 01:40:00.000000',00000000000003849881),('2024-06-05 01:45:00.000000',00000000000003876581),('2024-06-05 01:50:00.000000',00000000000003905681),('2024-06-05 01:55:00.000000',00000000000003948140),('2024-06-05 02:00:00.000000',00000000000003976240),('2024-06-05 02:05:00.000000',00000000000004024440),('2024-06-05 02:10:00.000000',00000000000004055540),('2024-06-05 02:15:00.000000',00000000000004088740),('2024-06-05 02:20:00.000000',00000000000004127229),('2024-06-05 02:25:00.000000',00000000000004166709),('2024-06-05 02:30:00.000000',00000000000004206009),('2024-06-05 02:35:00.000000',00000000000004238509),('2024-06-05 02:40:00.000000',00000000000004269108),('2024-06-05 02:45:00.000000',00000000000004296408),('2024-06-05 02:50:00.000000',00000000000004333308),('2024-06-05 02:55:00.000000',00000000000004358608),('2024-06-05 03:00:00.000000',00000000000004378908),('2024-06-05 03:05:00.000000',00000000000004413508),('2024-06-05 03:10:00.000000',00000000000004459708),('2024-06-05 03:15:00.000000',00000000000004488908),('2024-06-05 03:20:00.000000',00000000000004525287),('2024-06-05 03:25:00.000000',00000000000004583287),('2024-06-05 03:30:00.000000',00000000000004604687),('2024-06-05 03:35:00.000000',00000000000004637577),('2024-06-05 03:40:00.000000',00000000000004663057),('2024-06-05 03:45:00.000000',00000000000004698157),('2024-06-05 03:50:00.000000',00000000000004707457),('2024-06-05 03:55:00.000000',00000000000004733457),('2024-06-05 04:00:00.000000',00000000000004753646),('2024-06-05 04:05:00.000000',00000000000004770636),('2024-06-05 04:10:00.000000',00000000000004785626),('2024-06-05 04:15:00.000000',00000000000004803726),('2024-06-05 04:20:00.000000',00000000000004819126),('2024-06-05 04:25:00.000000',00000000000004843326),('2024-06-05 04:30:00.000000',00000000000004859426),('2024-06-05 04:35:00.000000',00000000000004875426),('2024-06-05 04:40:00.000000',00000000000004902226),('2024-06-05 04:45:00.000000',00000000000005063726),('2024-06-05 04:50:00.000000',00000000000005085626),('2024-06-05 04:55:00.000000',00000000000005108716),('2024-06-05 05:00:00.000000',00000000000005126716),('2024-06-05 05:05:00.000000',00000000000005139016),('2024-06-05 05:10:00.000000',00000000000005151106),('2024-06-05 05:15:00.000000',00000000000005163106),('2024-06-05 05:20:00.000000',00000000000005179296),('2024-06-05 05:25:00.000000',00000000000005213196),('2024-06-05 05:30:00.000000',00000000000005237086),('2024-06-05 05:35:00.000000',00000000000005242386),('2024-06-05 05:40:00.000000',00000000000005255476),('2024-06-05 05:45:00.000000',00000000000005278566),('2024-06-05 05:50:00.000000',00000000000005329546),('2024-06-05 05:55:00.000000',00000000000005358436),('2024-06-05 06:00:00.000000',00000000000005373426),('2024-06-05 06:05:00.000000',00000000000005385594),('2024-06-05 06:10:00.000000',00000000000005391783),('2024-06-05 06:15:00.000000',00000000000005416483),('2024-06-05 06:20:00.000000',00000000000005436373),('2024-06-05 06:25:00.000000',00000000000005446473),('2024-06-05 06:30:00.000000',00000000000005457363),('2024-06-05 06:35:00.000000',00000000000005479663),('2024-06-05 06:40:00.000000',00000000000005489833),('2024-06-05 06:45:00.000000',00000000000005499824),('2024-06-05 06:50:00.000000',00000000000005503824),('2024-06-05 06:55:00.000000',00000000000005517814),('2024-06-05 07:00:00.000000',00000000000005526604),('2024-06-05 07:05:00.000000',00000000000005543604),('2024-06-05 07:10:00.000000',00000000000005558604),('2024-06-05 07:15:00.000000',00000000000005576704),('2024-06-05 07:20:00.000000',00000000000005593604),('2024-06-05 07:25:00.000000',00000000000005598704),('2024-06-05 07:30:00.000000',00000000000005618704),('2024-06-05 07:35:00.000000',00000000000005636604),('2024-06-05 07:40:00.000000',00000000000005666204),('2024-06-05 07:45:00.000000',00000000000005685804),('2024-06-05 07:50:00.000000',00000000000005707494),('2024-06-05 07:55:00.000000',00000000000005722394),('2024-06-05 08:00:00.000000',00000000000005726394),('2024-06-05 08:05:00.000000',00000000000005751173),('2024-06-05 08:10:00.000000',00000000000005857073),('2024-06-05 08:15:00.000000',00000000000005869963),('2024-06-05 08:20:00.000000',00000000000005871063),('2024-06-05 08:25:00.000000',00000000000005883163),('2024-06-05 08:30:00.000000',00000000000005908063),('2024-06-05 08:35:00.000000',00000000000006116963),('2024-06-05 08:40:00.000000',00000000000006129963),('2024-06-05 08:45:00.000000',00000000000006139863),('2024-06-05 08:50:00.000000',00000000000006145863),('2024-06-05 08:55:00.000000',00000000000006147963),('2024-06-05 09:00:00.000000',00000000000006149963),('2024-06-05 09:05:00.000000',00000000000006158763),('2024-06-05 09:10:00.000000',00000000000006178963),('2024-06-05 09:15:00.000000',00000000000006193763),('2024-06-05 09:20:00.000000',00000000000006217363),('2024-06-05 09:25:00.000000',00000000000006221453),('2024-06-05 09:30:00.000000',00000000000006216553),('2024-06-05 09:35:00.000000',00000000000006239553),('2024-06-05 09:40:00.000000',00000000000006243553),('2024-06-05 09:45:00.000000',00000000000006260553),('2024-06-05 09:50:00.000000',00000000000006284552),('2024-06-05 09:55:00.000000',00000000000006290542),('2024-06-05 10:00:00.000000',00000000000006297641),('2024-06-05 10:05:00.000000',00000000000006302151),('2024-06-05 10:10:00.000000',00000000000006319151),('2024-06-05 10:15:00.000000',00000000000006328041),('2024-06-05 10:20:00.000000',00000000000006332141),('2024-06-05 10:25:00.000000',00000000000006332241),('2024-06-05 10:30:00.000000',00000000000006337241),('2024-06-05 10:35:00.000000',00000000000006337341),('2024-06-05 10:40:00.000000',00000000000006355241),('2024-06-05 10:45:00.000000',00000000000006370141),('2024-06-05 10:50:00.000000',00000000000006384141),('2024-06-05 10:55:00.000000',00000000000006394241),('2024-06-05 11:00:00.000000',00000000000006418141),('2024-06-05 11:05:00.000000',00000000000006467041),('2024-06-05 11:10:00.000000',00000000000006501641),('2024-06-05 11:15:00.000000',00000000000006504741),('2024-06-05 11:20:00.000000',00000000000006525631),('2024-06-05 11:25:00.000000',00000000000006538721),('2024-06-05 11:30:00.000000',00000000000006542381),('2024-06-05 11:35:00.000000',00000000000006555371),('2024-06-05 11:40:00.000000',00000000000006570171),('2024-06-05 11:45:00.000000',00000000000006582071),('2024-06-05 11:50:00.000000',00000000000006600971),('2024-06-05 11:55:00.000000',00000000000006608871),('2024-06-05 12:00:00.000000',00000000000006613871),('2024-06-05 12:05:00.000000',00000000000006627771),('2024-06-05 12:10:00.000000',00000000000006640771),('2024-06-05 12:15:00.000000',00000000000006672371),('2024-06-05 12:20:00.000000',00000000000006684351),('2024-06-05 12:25:00.000000',00000000000006693330),('2024-06-05 12:30:00.000000',00000000000006726530),('2024-06-05 12:35:00.000000',00000000000006733730),('2024-06-05 12:40:00.000000',00000000000006744630),('2024-06-05 12:45:00.000000',00000000000006748620),('2024-06-05 12:50:00.000000',00000000000006754620),('2024-06-05 12:55:00.000000',00000000000006778320),('2024-06-05 13:00:00.000000',00000000000006789310),('2024-06-05 13:05:00.000000',00000000000006801310),('2024-06-05 13:10:00.000000',00000000000006878810),('2024-06-05 13:15:00.000000',00000000000006938410),('2024-06-05 13:20:00.000000',00000000000006949510),('2024-06-05 13:25:00.000000',00000000000006976879),('2024-06-05 13:30:00.000000',00000000000006981779),('2024-06-05 13:35:00.000000',00000000000006985779),('2024-06-05 13:40:00.000000',00000000000007015658),('2024-06-05 13:45:00.000000',00000000000007013768),('2024-06-05 13:50:00.000000',00000000000007039668),('2024-06-05 13:55:00.000000',00000000000007057368),('2024-06-05 14:00:00.000000',00000000000007072168),('2024-06-05 14:05:00.000000',00000000000007084489),('2024-06-05 14:10:00.000000',00000000000007099378),('2024-06-05 14:15:00.000000',00000000000007107277),('2024-06-05 14:20:00.000000',00000000000007115277),('2024-06-05 14:25:00.000000',00000000000007121377),('2024-06-05 14:30:00.000000',00000000000007138977),('2024-06-05 14:35:00.000000',00000000000007210010),('2024-06-05 14:40:00.000000',00000000000007251265),('2024-06-05 14:45:00.000000',00000000000007312065),('2024-06-05 14:50:00.000000',00000000000007341565),('2024-06-05 14:55:00.000000',00000000000007353565),('2024-06-05 15:00:00.000000',00000000000007358855),('2024-06-05 15:05:00.000000',00000000000007372845),('2024-06-05 15:10:00.000000',00000000000007400435),('2024-06-05 15:15:00.000000',00000000000007424135),('2024-06-05 15:20:00.000000',00000000000007451935),('2024-06-05 15:25:00.000000',00000000000007470147),('2024-06-05 15:30:00.000000',00000000000007489174),('2024-06-05 15:35:00.000000',00000000000007502054),('2024-06-05 15:40:00.000000',00000000000007525754),('2024-06-05 15:45:00.000000',00000000000007544254),('2024-06-05 15:50:00.000000',00000000000007550954),('2024-06-05 15:55:00.000000',00000000000007571654),('2024-06-05 16:00:00.000000',00000000000000000000),('2024-06-05 16:05:00.000000',00000000000000011900),('2024-06-05 16:10:00.000000',00000000000000091390),('2024-06-05 16:15:00.000000',00000000000000112680),('2024-06-05 16:20:00.000000',00000000000000127480),('2024-06-05 16:25:00.000000',00000000000000141479),('2024-06-05 16:30:00.000000',00000000000000151279),('2024-06-05 16:35:00.000000',00000000000000163069),('2024-06-05 16:40:00.000000',00000000000000189159),('2024-06-05 16:45:00.000000',00000000000000212859),('2024-06-05 16:50:00.000000',00000000000000218759),('2024-06-05 16:55:00.000000',00000000000000243559),('2024-06-05 17:00:00.000000',00000000000000266359),('2024-06-05 17:05:00.000000',00000000000000293048),('2024-06-05 17:10:00.000000',00000000000000311748),('2024-06-05 17:15:00.000000',00000000000000316747),('2024-06-05 17:20:00.000000',00000000000000322637),('2024-06-05 17:25:00.000000',00000000000000332437),('2024-06-05 17:30:00.000000',00000000000000357927),('2024-06-05 17:35:00.000000',00000000000000389427),('2024-06-05 17:40:00.000000',00000000000000405327),('2024-06-05 17:45:00.000000',00000000000000432917),('2024-06-05 17:50:00.000000',00000000000000451817),('2024-06-05 17:55:00.000000',00000000000000453817),('2024-06-05 18:00:00.000000',00000000000000470807),('2024-06-05 18:05:00.000000',00000000000000476195),('2024-06-05 18:10:00.000000',00000000000000477185),('2024-06-05 18:15:00.000000',00000000000000477185),('2024-06-05 18:20:00.000000',00000000000000477185),('2024-06-05 18:25:00.000000',00000000000000480175),('2024-06-05 18:30:00.000000',00000000000000483165),('2024-06-05 18:35:00.000000',00000000000000487065),('2024-06-05 18:40:00.000000',00000000000000490065),('2024-06-05 18:45:00.000000',00000000000000492965),('2024-06-05 18:50:00.000000',00000000000000494965),('2024-06-05 18:55:00.000000',00000000000000494965),('2024-06-05 19:00:00.000000',00000000000000494965),('2024-06-05 19:05:00.000000',00000000000000494965),('2024-06-05 19:10:00.000000',00000000000000500945),('2024-06-05 19:15:00.000000',00000000000000503845),('2024-06-05 19:20:00.000000',00000000000000516745),('2024-06-05 19:25:00.000000',00000000000000520745),('2024-06-05 19:30:00.000000',00000000000000520745),('2024-06-05 19:35:00.000000',00000000000000534545),('2024-06-05 19:40:00.000000',00000000000000535545),('2024-06-05 19:45:00.000000',00000000000000544845),('2024-06-05 19:50:00.000000',00000000000000548645),('2024-06-05 19:55:00.000000',00000000000000549645),('2024-06-05 20:00:00.000000',00000000000000550645),('2024-06-05 20:05:00.000000',00000000000000550645),('2024-06-05 20:10:00.000000',00000000000000551645),('2024-06-05 20:15:00.000000',00000000000000554645),('2024-06-05 20:20:00.000000',00000000000000554645),('2024-06-05 20:25:00.000000',00000000000000564545),('2024-06-05 20:30:00.000000',00000000000000568345),('2024-06-05 20:35:00.000000',00000000000000568345),('2024-06-05 20:40:00.000000',00000000000000578245),('2024-06-05 20:45:00.000000',00000000000000583145),('2024-06-05 20:50:00.000000',00000000000000583145),('2024-06-05 20:55:00.000000',00000000000000583145),('2024-06-05 21:00:00.000000',00000000000000583145),('2024-06-05 21:05:00.000000',00000000000000583145),('2024-06-05 21:10:00.000000',00000000000000588945),('2024-06-05 21:15:00.000000',00000000000000588945),('2024-06-05 21:20:00.000000',00000000000000597845),('2024-06-05 21:25:00.000000',00000000000000600835),('2024-06-05 21:30:00.000000',00000000000000601825),('2024-06-05 21:35:00.000000',00000000000000603814),('2024-06-05 21:40:00.000000',00000000000000609781),('2024-06-05 21:45:00.000000',00000000000000615781),('2024-06-05 21:50:00.000000',00000000000000616781),('2024-06-05 21:55:00.000000',00000000000000620681),('2024-06-05 22:00:00.000000',00000000000000621681),('2024-06-05 22:05:00.000000',00000000000000624581),('2024-06-05 22:10:00.000000',00000000000000624581),('2024-06-05 22:15:00.000000',00000000000000625581),('2024-06-05 22:20:00.000000',00000000000000627581),('2024-06-05 22:25:00.000000',00000000000000630481),('2024-06-05 22:30:00.000000',00000000000000640281),('2024-06-05 22:35:00.000000',00000000000000640281),('2024-06-05 22:40:00.000000',00000000000000656081),('2024-06-05 22:45:00.000000',00000000000000656081),('2024-06-05 22:50:00.000000',00000000000000658081),('2024-06-05 22:55:00.000000',00000000000000660081),('2024-06-05 23:00:00.000000',00000000000000660081),('2024-06-05 23:05:00.000000',00000000000000664070),('2024-06-05 23:10:00.000000',00000000000000668970),('2024-06-05 23:15:00.000000',00000000000000670970),('2024-06-05 23:20:00.000000',00000000000000684770),('2024-06-05 23:25:00.000000',00000000000000684770),('2024-06-05 23:30:00.000000',00000000000000685770),('2024-06-05 23:35:00.000000',00000000000000696570),('2024-06-05 23:40:00.000000',00000000000000698470),('2024-06-05 23:45:00.000000',00000000000000702370),('2024-06-05 23:50:00.000000',00000000000000703370),('2024-06-05 23:55:00.000000',00000000000000706370),('2024-06-06 00:00:00.000000',00000000000000708370),('2024-06-06 00:05:00.000000',00000000000000720170),('2024-06-06 00:10:00.000000',00000000000000720170),('2024-06-06 00:15:00.000000',00000000000000736970),('2024-06-06 00:20:00.000000',00000000000000754670),('2024-06-06 00:25:00.000000',00000000000000761570),('2024-06-06 00:30:00.000000',00000000000000762570),('2024-06-06 00:35:00.000000',00000000000000763570),('2024-06-06 00:40:00.000000',00000000000000769470),('2024-06-06 00:45:00.000000',00000000000000774370),('2024-06-06 00:50:00.000000',00000000000000778270),('2024-06-06 00:55:00.000000',00000000000000781270),('2024-06-06 01:00:00.000000',00000000000000783270),('2024-06-06 01:05:00.000000',00000000000000789170),('2024-06-06 01:10:00.000000',00000000000000794070),('2024-06-06 01:15:00.000000',00000000000000806870),('2024-06-06 01:20:00.000000',00000000000000814770),('2024-06-06 01:25:00.000000',00000000000000817760),('2024-06-06 01:30:00.000000',00000000000000818760),('2024-06-06 01:35:00.000000',00000000000000826660),('2024-06-06 01:40:00.000000',00000000000000831560),('2024-06-06 01:45:00.000000',00000000000000852560),('2024-06-06 01:50:00.000000',00000000000000867817),('2024-06-06 01:55:00.000000',00000000000000877917),('2024-06-06 02:00:00.000000',00000000000000935617),('2024-06-06 02:05:00.000000',00000000000000935617),('2024-06-06 02:10:00.000000',00000000000000940517),('2024-06-06 02:15:00.000000',00000000000000960417),('2024-06-06 02:20:00.000000',00000000000000969317),('2024-06-06 02:25:00.000000',00000000000001004006),('2024-06-06 02:30:00.000000',00000000000001019806),('2024-06-06 02:35:00.000000',00000000000001021806),('2024-06-06 02:40:00.000000',00000000000001019806),('2024-06-06 02:45:00.000000',00000000000001039406),('2024-06-06 02:50:00.000000',00000000000001046794),('2024-06-06 02:55:00.000000',00000000000001049794),('2024-06-06 03:00:00.000000',00000000000001060593),('2024-06-06 03:05:00.000000',00000000000001070493),('2024-06-06 03:10:00.000000',00000000000001073483),('2024-06-06 03:15:00.000000',00000000000001085383),('2024-06-06 03:20:00.000000',00000000000001096183),('2024-06-06 03:25:00.000000',00000000000001102983),('2024-06-06 03:30:00.000000',00000000000001102983),('2024-06-06 03:35:00.000000',00000000000001117773),('2024-06-06 03:40:00.000000',00000000000001125662),('2024-06-06 03:45:00.000000',00000000000001176262),('2024-06-06 03:50:00.000000',00000000000001188462),('2024-06-06 03:55:00.000000',00000000000001196361),('2024-06-06 04:00:00.000000',00000000000001203161),('2024-06-06 04:05:00.000000',00000000000001212061),('2024-06-06 04:10:00.000000',00000000000001215061),('2024-06-06 04:15:00.000000',00000000000001217061),('2024-06-06 04:20:00.000000',00000000000001234761),('2024-06-06 04:25:00.000000',00000000000001243661),('2024-06-06 04:30:00.000000',00000000000001245661),('2024-06-06 04:35:00.000000',00000000000001266461),('2024-06-06 04:40:00.000000',00000000000001326261),('2024-06-06 04:45:00.000000',00000000000001358941),('2024-06-06 04:50:00.000000',00000000000001413641),('2024-06-06 04:55:00.000000',00000000000001431289),('2024-06-06 05:00:00.000000',00000000000001442189),('2024-06-06 05:05:00.000000',00000000000001444089),('2024-06-06 05:10:00.000000',00000000000001464788),('2024-06-06 05:15:00.000000',00000000000001471688),('2024-06-06 05:20:00.000000',00000000000001484988),('2024-06-06 05:25:00.000000',00000000000001487988),('2024-06-06 05:30:00.000000',00000000000001492888),('2024-06-06 05:35:00.000000',00000000000001496888),('2024-06-06 05:40:00.000000',00000000000001509788),('2024-06-06 05:45:00.000000',00000000000001525674),('2024-06-06 05:50:00.000000',00000000000001545363),('2024-06-06 05:55:00.000000',00000000000001578829),('2024-06-06 06:00:00.000000',00000000000001590719),('2024-06-06 06:05:00.000000',00000000000001588619),('2024-06-06 06:10:00.000000',00000000000001606319),('2024-06-06 06:15:00.000000',00000000000001629288),('2024-06-06 06:20:00.000000',00000000000001676088),('2024-06-06 06:25:00.000000',00000000000001703388),('2024-06-06 06:30:00.000000',00000000000001714076),('2024-06-06 06:35:00.000000',00000000000001734776),('2024-06-06 06:40:00.000000',00000000000001780076),('2024-06-06 06:45:00.000000',00000000000001788976),('2024-06-06 06:50:00.000000',00000000000001788976),('2024-06-06 06:55:00.000000',00000000000001835676),('2024-06-06 07:00:00.000000',00000000000001844476),('2024-06-06 07:05:00.000000',00000000000001857276),('2024-06-06 07:10:00.000000',00000000000001933776),('2024-06-06 07:15:00.000000',00000000000001949576),('2024-06-06 07:20:00.000000',00000000000001951576),('2024-06-06 07:25:00.000000',00000000000001961376),('2024-06-06 07:30:00.000000',00000000000001967376),('2024-06-06 07:35:00.000000',00000000000001972176),('2024-06-06 07:40:00.000000',00000000000001984065),('2024-06-06 07:45:00.000000',00000000000001984065),('2024-06-06 07:50:00.000000',00000000000001987965),('2024-06-06 07:55:00.000000',00000000000001989965),('2024-06-06 08:00:00.000000',00000000000001994865),('2024-06-06 08:05:00.000000',00000000000002007665),('2024-06-06 08:10:00.000000',00000000000002012565),('2024-06-06 08:15:00.000000',00000000000002021465),('2024-06-06 08:20:00.000000',00000000000002071065),('2024-06-06 08:25:00.000000',00000000000002097365),('2024-06-06 08:30:00.000000',00000000000002109265),('2024-06-06 08:35:00.000000',00000000000002110265),('2024-06-06 08:40:00.000000',00000000000002111265),('2024-06-06 08:45:00.000000',00000000000002115265),('2024-06-06 08:50:00.000000',00000000000002124165),('2024-06-06 08:55:00.000000',00000000000002135065),('2024-06-06 09:00:00.000000',00000000000002146965),('2024-06-06 09:05:00.000000',00000000000002154644),('2024-06-06 09:10:00.000000',00000000000002162534),('2024-06-06 09:15:00.000000',00000000000002171424),('2024-06-06 09:20:00.000000',00000000000002172424),('2024-06-06 09:25:00.000000',00000000000002186124),('2024-06-06 09:30:00.000000',00000000000002194924),('2024-06-06 09:35:00.000000',00000000000002212624),('2024-06-06 09:40:00.000000',00000000000002218624),('2024-06-06 09:45:00.000000',00000000000002231414),('2024-06-06 09:50:00.000000',00000000000002238314),('2024-06-06 09:55:00.000000',00000000000002247214),('2024-06-06 10:00:00.000000',00000000000002262013),('2024-06-06 10:05:00.000000',00000000000002273692),('2024-06-06 10:10:00.000000',00000000000002281692),('2024-06-06 10:15:00.000000',00000000000002304382),('2024-06-06 10:20:00.000000',00000000000002328762),('2024-06-06 10:25:00.000000',00000000000002344562),('2024-06-06 10:30:00.000000',00000000000002362242),('2024-06-06 10:35:00.000000',00000000000002366142),('2024-06-06 10:40:00.000000',00000000000002378032),('2024-06-06 10:45:00.000000',00000000000002377032),('2024-06-06 10:50:00.000000',00000000000002386732),('2024-06-06 10:55:00.000000',00000000000002397632),('2024-06-06 11:00:00.000000',00000000000002400621),('2024-06-06 11:05:00.000000',00000000000002409421),('2024-06-06 11:10:00.000000',00000000000002437821),('2024-06-06 11:15:00.000000',00000000000002466321),('2024-06-06 11:20:00.000000',00000000000002467321),('2024-06-06 11:25:00.000000',00000000000002468421),('2024-06-06 11:30:00.000000',00000000000002490121),('2024-06-06 11:35:00.000000',00000000000002491221),('2024-06-06 11:40:00.000000',00000000000002505001),('2024-06-06 11:45:00.000000',00000000000002520801),('2024-06-06 11:50:00.000000',00000000000002521801),('2024-06-06 11:55:00.000000',00000000000002534600),('2024-06-06 12:00:00.000000',00000000000002546290),('2024-06-06 12:05:00.000000',00000000000002549280),('2024-06-06 12:10:00.000000',00000000000002568980),('2024-06-06 12:15:00.000000',00000000000002578780),('2024-06-06 12:20:00.000000',00000000000002578780),('2024-06-06 12:25:00.000000',00000000000002592770),('2024-06-06 12:30:00.000000',00000000000002599570),('2024-06-06 12:35:00.000000',00000000000002603570),('2024-06-06 12:40:00.000000',00000000000002610460),('2024-06-06 12:45:00.000000',00000000000002651360),('2024-06-06 12:50:00.000000',00000000000002672050),('2024-06-06 12:55:00.000000',00000000000002679838),('2024-06-06 13:00:00.000000',00000000000002689738),('2024-06-06 13:05:00.000000',00000000000002689738),('2024-06-06 13:10:00.000000',00000000000002699638),('2024-06-06 13:15:00.000000',00000000000002729427),('2024-06-06 13:20:00.000000',00000000000002743227),('2024-06-06 13:25:00.000000',00000000000002746027),('2024-06-06 13:30:00.000000',00000000000002749927),('2024-06-06 13:35:00.000000',00000000000002755827),('2024-06-06 13:40:00.000000',00000000000002757827),('2024-06-06 13:45:00.000000',00000000000002767827),('2024-06-06 13:50:00.000000',00000000000002772816),('2024-06-06 13:55:00.000000',00000000000002783705),('2024-06-06 14:00:00.000000',00000000000002791284),('2024-06-06 14:05:00.000000',00000000000002801984),('2024-06-06 14:10:00.000000',00000000000002814284),('2024-06-06 14:15:00.000000',00000000000002822474),('2024-06-06 14:20:00.000000',00000000000002847364),('2024-06-06 14:25:00.000000',00000000000002857164),('2024-06-06 14:30:00.000000',00000000000002860164),('2024-06-06 14:35:00.000000',00000000000002865064),('2024-06-06 14:40:00.000000',00000000000002864064),('2024-06-06 14:45:00.000000',00000000000002869954),('2024-06-06 14:50:00.000000',00000000000002888354),('2024-06-06 14:55:00.000000',00000000000002908744),('2024-06-06 15:00:00.000000',00000000000002926443),('2024-06-06 15:05:00.000000',00000000000002930443),('2024-06-06 15:10:00.000000',00000000000002942333),('2024-06-06 15:15:00.000000',00000000000002955323),('2024-06-06 15:20:00.000000',00000000000002964313),('2024-06-06 15:25:00.000000',00000000000002982113),('2024-06-06 15:30:00.000000',00000000000003007413),('2024-06-06 15:35:00.000000',00000000000003029203),('2024-06-06 15:40:00.000000',00000000000003044803),('2024-06-06 15:45:00.000000',00000000000003059902),('2024-06-06 15:50:00.000000',00000000000003073392),('2024-06-06 15:55:00.000000',00000000000003085292),('2024-06-06 16:00:00.000000',00000000000000000000),('2024-06-06 16:05:00.000000',00000000000000007889),('2024-06-06 16:10:00.000000',00000000000000010889),('2024-06-06 16:15:00.000000',00000000000000023668),('2024-06-06 16:20:00.000000',00000000000000033568),('2024-06-06 16:25:00.000000',00000000000000044468),('2024-06-06 16:30:00.000000',00000000000000062368),('2024-06-06 16:35:00.000000',00000000000000079967),('2024-06-06 16:40:00.000000',00000000000000090867),('2024-06-06 16:45:00.000000',00000000000000105757),('2024-06-06 16:50:00.000000',00000000000000127447),('2024-06-06 16:55:00.000000',00000000000000137435),('2024-06-06 17:00:00.000000',00000000000000157135),('2024-06-06 17:05:00.000000',00000000000000171125),('2024-06-06 17:10:00.000000',00000000000000205725),('2024-06-06 17:15:00.000000',00000000000000213725),('2024-06-06 17:20:00.000000',00000000000000377715),('2024-06-06 17:25:00.000000',00000000000000391705),('2024-06-06 17:30:00.000000',00000000000000405605),('2024-06-06 17:35:00.000000',00000000000000407605),('2024-06-06 17:40:00.000000',00000000000000422505),('2024-06-06 17:45:00.000000',00000000000000440394),('2024-06-06 17:50:00.000000',00000000000000445394),('2024-06-06 17:55:00.000000',00000000000000455393),('2024-06-06 18:00:00.000000',00000000000000469193),('2024-06-06 18:05:00.000000',00000000000000475193),('2024-06-06 18:10:00.000000',00000000000000500083),('2024-06-06 18:15:00.000000',00000000000000508083),('2024-06-06 18:20:00.000000',00000000000000529973),('2024-06-06 18:25:00.000000',00000000000000546973),('2024-06-06 18:30:00.000000',00000000000000565773),('2024-06-06 18:35:00.000000',00000000000000576773),('2024-06-06 18:40:00.000000',00000000000000589673),('2024-06-06 18:45:00.000000',00000000000000601573),('2024-06-06 18:50:00.000000',00000000000000641373),('2024-06-06 18:55:00.000000',00000000000000650273),('2024-06-06 19:00:00.000000',00000000000000671061),('2024-06-06 19:05:00.000000',00000000000000700661),('2024-06-06 19:10:00.000000',00000000000000713450),('2024-06-06 19:15:00.000000',00000000000000743240),('2024-06-06 19:20:00.000000',00000000000000749240),('2024-06-06 19:25:00.000000',00000000000000768940),('2024-06-06 19:30:00.000000',00000000000000772930),('2024-06-06 19:35:00.000000',00000000000000784830),('2024-06-06 19:40:00.000000',00000000000000795830),('2024-06-06 19:45:00.000000',00000000000000805730),('2024-06-06 19:50:00.000000',00000000000000810720),('2024-06-06 19:55:00.000000',00000000000000811720),('2024-06-06 20:00:00.000000',00000000000000814710),('2024-06-06 20:05:00.000000',00000000000000815710),('2024-06-06 20:10:00.000000',00000000000000817710),('2024-06-06 20:15:00.000000',00000000000000835510),('2024-06-06 20:20:00.000000',00000000000000884310),('2024-06-06 20:25:00.000000',00000000000000904710),('2024-06-06 20:30:00.000000',00000000000000926610),('2024-06-06 20:35:00.000000',00000000000000945400),('2024-06-06 20:40:00.000000',00000000000000958200),('2024-06-06 20:45:00.000000',00000000000000965200),('2024-06-06 20:50:00.000000',00000000000000971200),('2024-06-06 20:55:00.000000',00000000000000975200),('2024-06-06 21:00:00.000000',00000000000000982190),('2024-06-06 21:05:00.000000',00000000000000992180),('2024-06-06 21:10:00.000000',00000000000000997835),('2024-06-06 21:15:00.000000',00000000000001001835),('2024-06-06 21:20:00.000000',00000000000001008835),('2024-06-06 21:25:00.000000',00000000000001016725),('2024-06-06 21:30:00.000000',00000000000001021725),('2024-06-06 21:35:00.000000',00000000000001024725),('2024-06-06 21:40:00.000000',00000000000001041725),('2024-06-06 21:45:00.000000',00000000000001050725),('2024-06-06 21:50:00.000000',00000000000001056725),('2024-06-06 21:55:00.000000',00000000000001059715),('2024-06-06 22:00:00.000000',00000000000001068705),('2024-06-06 22:05:00.000000',00000000000001082505),('2024-06-06 22:10:00.000000',00000000000001096305),('2024-06-06 22:15:00.000000',00000000000001103295),('2024-06-06 22:20:00.000000',00000000000001111295),('2024-06-06 22:25:00.000000',00000000000001117295),('2024-06-06 22:30:00.000000',00000000000001126295),('2024-06-06 22:35:00.000000',00000000000001145095),('2024-06-06 22:40:00.000000',00000000000001160095),('2024-06-06 22:45:00.000000',00000000000001175995),('2024-06-06 22:50:00.000000',00000000000001199885),('2024-06-06 22:55:00.000000',00000000000001213885),('2024-06-06 23:00:00.000000',00000000000001232785),('2024-06-06 23:05:00.000000',00000000000001244685),('2024-06-06 23:10:00.000000',00000000000001259685),('2024-06-06 23:15:00.000000',00000000000001281584),('2024-06-06 23:20:00.000000',00000000000001294584),('2024-06-06 23:25:00.000000',00000000000001313584),('2024-06-06 23:30:00.000000',00000000000001324654),('2024-06-06 23:35:00.000000',00000000000001337644),('2024-06-06 23:40:00.000000',00000000000001361544),('2024-06-06 23:45:00.000000',00000000000001381544),('2024-06-06 23:50:00.000000',00000000000001416344),('2024-06-06 23:55:00.000000',00000000000001450644),('2024-06-07 00:00:00.000000',00000000000001485634),('2024-06-07 00:05:00.000000',00000000000001526424),('2024-06-07 00:10:00.000000',00000000000001552413),('2024-06-07 00:15:00.000000',00000000000001572013),('2024-06-07 00:20:00.000000',00000000000001591013),('2024-06-07 00:25:00.000000',00000000000001615913),('2024-06-07 00:30:00.000000',00000000000001640603),('2024-06-07 00:35:00.000000',00000000000001657592),('2024-06-07 00:40:00.000000',00000000000001673582),('2024-06-07 00:45:00.000000',00000000000001685482),('2024-06-07 00:50:00.000000',00000000000001699471),('2024-06-07 00:55:00.000000',00000000000001718371),('2024-06-07 01:00:00.000000',00000000000001742971),('2024-06-07 01:05:00.000000',00000000000001751971),('2024-06-07 01:10:00.000000',00000000000001776970),('2024-06-07 01:15:00.000000',00000000000001804960),('2024-06-07 01:20:00.000000',00000000000001824860),('2024-06-07 01:25:00.000000',00000000000001836760),('2024-06-07 01:30:00.000000',00000000000001844860),('2024-06-07 01:35:00.000000',00000000000001853660),('2024-06-07 01:40:00.000000',00000000000001873215),('2024-06-07 01:45:00.000000',00000000000001897915),('2024-06-07 01:50:00.000000',00000000000001918715),('2024-06-07 01:55:00.000000',00000000000001933615),('2024-06-07 02:00:00.000000',00000000000001947515),('2024-06-07 02:05:00.000000',00000000000001952515),('2024-06-07 02:10:00.000000',00000000000001958515),('2024-06-07 02:15:00.000000',00000000000001962515),('2024-06-07 02:20:00.000000',00000000000001977305),('2024-06-07 02:25:00.000000',00000000000001979305),('2024-06-07 02:30:00.000000',00000000000001999005),('2024-06-07 02:35:00.000000',00000000000002004005),('2024-06-07 02:40:00.000000',00000000000002019905),('2024-06-07 02:45:00.000000',00000000000002025805),('2024-06-07 02:50:00.000000',00000000000002032805),('2024-06-07 02:55:00.000000',00000000000002036805),('2024-06-07 03:00:00.000000',00000000000002044705),('2024-06-07 03:05:00.000000',00000000000002047705),('2024-06-07 03:10:00.000000',00000000000002053605),('2024-06-07 03:15:00.000000',00000000000002058605),('2024-06-07 03:20:00.000000',00000000000002072105),('2024-06-07 03:25:00.000000',00000000000002073105),('2024-06-07 03:30:00.000000',00000000000002084995),('2024-06-07 03:35:00.000000',00000000000002131795),('2024-06-07 03:40:00.000000',00000000000002145595),('2024-06-07 03:45:00.000000',00000000000002150585),('2024-06-07 03:50:00.000000',00000000000002166465),('2024-06-07 03:55:00.000000',00000000000002169465),('2024-06-07 04:00:00.000000',00000000000002172465),('2024-06-07 04:05:00.000000',00000000000002185165),('2024-06-07 04:10:00.000000',00000000000002229065),('2024-06-07 04:15:00.000000',00000000000002237964),('2024-06-07 04:20:00.000000',00000000000002246855),('2024-06-07 04:25:00.000000',00000000000002255855),('2024-06-07 04:30:00.000000',00000000000002270754),('2024-06-07 04:35:00.000000',00000000000002282454),('2024-06-07 04:40:00.000000',00000000000002294343),('2024-06-07 04:45:00.000000',00000000000002355043),('2024-06-07 04:50:00.000000',00000000000002367022),('2024-06-07 04:55:00.000000',00000000000002377912),('2024-06-07 05:00:00.000000',00000000000002408512),('2024-06-07 05:05:00.000000',00000000000002415412),('2024-06-07 05:10:00.000000',00000000000002426312),('2024-06-07 05:15:00.000000',00000000000002445112),('2024-06-07 05:20:00.000000',00000000000002445002),('2024-06-07 05:25:00.000000',00000000000002450992),('2024-06-07 05:30:00.000000',00000000000002460891),('2024-06-07 05:35:00.000000',00000000000002470681),('2024-06-07 05:40:00.000000',00000000000002477581),('2024-06-07 05:45:00.000000',00000000000002506171),('2024-06-07 05:50:00.000000',00000000000002532761),('2024-06-07 05:55:00.000000',00000000000002546091),('2024-06-07 06:00:00.000000',00000000000002565670),('2024-06-07 06:05:00.000000',00000000000002580560),('2024-06-07 06:10:00.000000',00000000000002590460),('2024-06-07 06:15:00.000000',00000000000002651060),('2024-06-07 06:20:00.000000',00000000000002657960),('2024-06-07 06:25:00.000000',00000000000002676660),('2024-06-07 06:30:00.000000',00000000000002729350),('2024-06-07 06:35:00.000000',00000000000002730350),('2024-06-07 06:40:00.000000',00000000000002734350),('2024-06-07 06:45:00.000000',00000000000002737350),('2024-06-07 06:50:00.000000',00000000000002760050),('2024-06-07 06:55:00.000000',00000000000002767950),('2024-06-07 07:00:00.000000',00000000000002768950),('2024-06-07 07:05:00.000000',00000000000002776850),('2024-06-07 07:10:00.000000',00000000000002787640),('2024-06-07 07:15:00.000000',00000000000002789640),('2024-06-07 07:20:00.000000',00000000000002797540),('2024-06-07 07:25:00.000000',00000000000002802440),('2024-06-07 07:30:00.000000',00000000000002806328),('2024-06-07 07:35:00.000000',00000000000002810328),('2024-06-07 07:40:00.000000',00000000000002820028),('2024-06-07 07:45:00.000000',00000000000002824638),('2024-06-07 07:50:00.000000',00000000000002815639),('2024-06-07 07:55:00.000000',00000000000002823539),('2024-06-07 08:00:00.000000',00000000000002828339),('2024-06-07 08:05:00.000000',00000000000002827339),('2024-06-07 08:10:00.000000',00000000000002852908),('2024-06-07 08:15:00.000000',00000000000002868408),('2024-06-07 08:20:00.000000',00000000000002871408),('2024-06-07 08:25:00.000000',00000000000002889108),('2024-06-07 08:30:00.000000',00000000000002890108),('2024-06-07 08:35:00.000000',00000000000002907008),('2024-06-07 08:40:00.000000',00000000000002909008),('2024-06-07 08:45:00.000000',00000000000002919908),('2024-06-07 08:50:00.000000',00000000000002932697),('2024-06-07 08:55:00.000000',00000000000002937497),('2024-06-07 09:00:00.000000',00000000000002945397),('2024-06-07 09:05:00.000000',00000000000002956297),('2024-06-07 09:10:00.000000',00000000000002967197),('2024-06-07 09:15:00.000000',00000000000002976086),('2024-06-07 09:20:00.000000',00000000000002977086),('2024-06-07 09:25:00.000000',00000000000002982986),('2024-06-07 09:30:00.000000',00000000000002986986),('2024-06-07 09:35:00.000000',00000000000002994786),('2024-06-07 09:40:00.000000',00000000000003001686),('2024-06-07 09:45:00.000000',00000000000003012386),('2024-06-07 09:50:00.000000',00000000000003009486),('2024-06-07 09:55:00.000000',00000000000003009486),('2024-06-07 10:00:00.000000',00000000000003013086),('2024-06-07 10:05:00.000000',00000000000003034486),('2024-06-07 10:10:00.000000',00000000000003052285),('2024-06-07 10:15:00.000000',00000000000003053285),('2024-06-07 10:20:00.000000',00000000000003063185),('2024-06-07 10:25:00.000000',00000000000003057275),('2024-06-07 10:30:00.000000',00000000000003059275),('2024-06-07 10:35:00.000000',00000000000003065075),('2024-06-07 10:40:00.000000',00000000000003072974),('2024-06-07 10:45:00.000000',00000000000003083873),('2024-06-07 10:50:00.000000',00000000000003079973),('2024-06-07 10:55:00.000000',00000000000003089773),('2024-06-07 11:00:00.000000',00000000000003091773),('2024-06-07 11:05:00.000000',00000000000003101773),('2024-06-07 11:10:00.000000',00000000000003114673),('2024-06-07 11:15:00.000000',00000000000003121662),('2024-06-07 11:20:00.000000',00000000000003178152),('2024-06-07 11:25:00.000000',00000000000003186052),('2024-06-07 11:30:00.000000',00000000000003186052),('2024-06-07 11:35:00.000000',00000000000003204852),('2024-06-07 11:40:00.000000',00000000000003227541),('2024-06-07 11:45:00.000000',00000000000003234431),('2024-06-07 11:50:00.000000',00000000000003257997),('2024-06-07 11:55:00.000000',00000000000003258997),('2024-06-07 12:00:00.000000',00000000000003258997),('2024-06-07 12:05:00.000000',00000000000003266897),('2024-06-07 12:10:00.000000',00000000000003306896),('2024-06-07 12:15:00.000000',00000000000003302686),('2024-06-07 12:20:00.000000',00000000000003308586),('2024-06-07 12:25:00.000000',00000000000003309586),('2024-06-07 12:30:00.000000',00000000000003326286),('2024-06-07 12:35:00.000000',00000000000003341886),('2024-06-07 12:40:00.000000',00000000000003355686),('2024-06-07 12:45:00.000000',00000000000003385386),('2024-06-07 12:50:00.000000',00000000000003403986),('2024-06-07 12:55:00.000000',00000000000003419786),('2024-06-07 13:00:00.000000',00000000000003419765),('2024-06-07 13:05:00.000000',00000000000003437565),('2024-06-07 13:10:00.000000',00000000000003453265),('2024-06-07 13:15:00.000000',00000000000003460265),('2024-06-07 13:20:00.000000',00000000000003465265),('2024-06-07 13:25:00.000000',00000000000003479165),('2024-06-07 13:30:00.000000',00000000000003494065),('2024-06-07 13:35:00.000000',00000000000003508664),('2024-06-07 13:40:00.000000',00000000000003531364),('2024-06-07 13:45:00.000000',00000000000003571864),('2024-06-07 13:50:00.000000',00000000000003582464),('2024-06-07 13:55:00.000000',00000000000003623964),('2024-06-07 14:00:00.000000',00000000000003628963),('2024-06-07 14:05:00.000000',00000000000003710803),('2024-06-07 14:10:00.000000',00000000000003729592),('2024-06-07 14:15:00.000000',00000000000003741392),('2024-06-07 14:20:00.000000',00000000000003777882),('2024-06-07 14:25:00.000000',00000000000003818561),('2024-06-07 14:30:00.000000',00000000000003824061),('2024-06-07 14:35:00.000000',00000000000003840761),('2024-06-07 14:40:00.000000',00000000000003849761),('2024-06-07 14:45:00.000000',00000000000003864561),('2024-06-07 14:50:00.000000',00000000000003877761),('2024-06-07 14:55:00.000000',00000000000003901561),('2024-06-07 15:00:00.000000',00000000000003907561),('2024-06-07 15:05:00.000000',00000000000003940161),('2024-06-07 15:10:00.000000',00000000000003951040),('2024-06-07 15:15:00.000000',00000000000003991638),('2024-06-07 15:20:00.000000',00000000000004015328),('2024-06-07 15:25:00.000000',00000000000004043018),('2024-06-07 15:30:00.000000',00000000000004064918),('2024-06-07 15:35:00.000000',00000000000004072918),('2024-06-07 15:40:00.000000',00000000000004096618),('2024-06-07 15:45:00.000000',00000000000004113608),('2024-06-07 15:50:00.000000',00000000000004146208),('2024-06-07 15:55:00.000000',00000000000004185107),('2024-06-07 16:00:00.000000',00000000000000000000),('2024-06-07 16:05:00.000000',00000000000000037500),('2024-06-07 16:10:00.000000',00000000000000122079),('2024-06-07 16:15:00.000000',00000000000000161879),('2024-06-07 16:20:00.000000',00000000000000200579),('2024-06-07 16:25:00.000000',00000000000000226279),('2024-06-07 16:30:00.000000',00000000000000254978),('2024-06-07 16:35:00.000000',00000000000000321378),('2024-06-07 16:40:00.000000',00000000000000362277),('2024-06-07 16:45:00.000000',00000000000000408667),('2024-06-07 16:50:00.000000',00000000000000434256),('2024-06-07 16:55:00.000000',00000000000000459756),('2024-06-07 17:00:00.000000',00000000000000471656),('2024-06-07 17:05:00.000000',00000000000000501356),('2024-06-07 17:10:00.000000',00000000000000536045),('2024-06-07 17:15:00.000000',00000000000000550445),('2024-06-07 17:20:00.000000',00000000000000574234),('2024-06-07 17:25:00.000000',00000000000000586034),('2024-06-07 17:30:00.000000',00000000000000650734),('2024-06-07 17:35:00.000000',00000000000000692334),('2024-06-07 17:40:00.000000',00000000000000711224),('2024-06-07 17:45:00.000000',00000000000000753124),('2024-06-07 17:50:00.000000',00000000000000765124),('2024-06-07 17:55:00.000000',00000000000000776824),('2024-06-07 18:00:00.000000',00000000000000783824),('2024-06-07 18:05:00.000000',00000000000000801524),('2024-06-07 18:10:00.000000',00000000000000973864),('2024-06-07 18:15:00.000000',00000000000000990754),('2024-06-07 18:20:00.000000',00000000000001007654),('2024-06-07 18:25:00.000000',00000000000001011554),('2024-06-07 18:30:00.000000',00000000000001057444),('2024-06-07 18:35:00.000000',00000000000001077144),('2024-06-07 18:40:00.000000',00000000000001118044),('2024-06-07 18:45:00.000000',00000000000001123944),('2024-06-07 18:50:00.000000',00000000000001125944),('2024-06-07 18:55:00.000000',00000000000001135844),('2024-06-07 19:00:00.000000',00000000000001137844),('2024-06-07 19:05:00.000000',00000000000001153644),('2024-06-07 19:10:00.000000',00000000000001160544),('2024-06-07 19:15:00.000000',00000000000001165444),('2024-06-07 19:20:00.000000',00000000000001175244),('2024-06-07 19:25:00.000000',00000000000001168344),('2024-06-07 19:30:00.000000',00000000000001170344),('2024-06-07 19:35:00.000000',00000000000001174344),('2024-06-07 19:40:00.000000',00000000000001186344),('2024-06-07 19:45:00.000000',00000000000001188324),('2024-06-07 19:50:00.000000',00000000000001188324),('2024-06-07 19:55:00.000000',00000000000001190314),('2024-06-07 20:00:00.000000',00000000000001198214),('2024-06-07 20:05:00.000000',00000000000001202214),('2024-06-07 20:10:00.000000',00000000000001221814),('2024-06-07 20:15:00.000000',00000000000001221814),('2024-06-07 20:20:00.000000',00000000000001225814),('2024-06-07 20:25:00.000000',00000000000001235714),('2024-06-07 20:30:00.000000',00000000000001239614),('2024-06-07 20:35:00.000000',00000000000001239614),('2024-06-07 20:40:00.000000',00000000000001240614),('2024-06-07 20:45:00.000000',00000000000001240614),('2024-06-07 20:50:00.000000',00000000000001240614),('2024-06-07 20:55:00.000000',00000000000001245514),('2024-06-07 21:00:00.000000',00000000000001251414),('2024-06-07 21:05:00.000000',00000000000001264314),('2024-06-07 21:10:00.000000',00000000000001272214),('2024-06-07 21:15:00.000000',00000000000001274214),('2024-06-07 21:20:00.000000',00000000000001276214),('2024-06-07 21:25:00.000000',00000000000001278214),('2024-06-07 21:30:00.000000',00000000000001278214),('2024-06-07 21:35:00.000000',00000000000001280214),('2024-06-07 21:40:00.000000',00000000000001281214),('2024-06-07 21:45:00.000000',00000000000001282214),('2024-06-07 21:50:00.000000',00000000000001284214),('2024-06-07 21:55:00.000000',00000000000001309914),('2024-06-07 22:00:00.000000',00000000000001320814),('2024-06-07 22:05:00.000000',00000000000001324814),('2024-06-07 22:10:00.000000',00000000000001328814),('2024-06-07 22:15:00.000000',00000000000001344813),('2024-06-07 22:20:00.000000',00000000000001345813),('2024-06-07 22:25:00.000000',00000000000001349812),('2024-06-07 22:30:00.000000',00000000000001350812),('2024-06-07 22:35:00.000000',00000000000001354812),('2024-06-07 22:40:00.000000',00000000000001356812),('2024-06-07 22:45:00.000000',00000000000001357802),('2024-06-07 22:50:00.000000',00000000000001372702),('2024-06-07 22:55:00.000000',00000000000001386602),('2024-06-07 23:00:00.000000',00000000000001394602),('2024-06-07 23:05:00.000000',00000000000001406602),('2024-06-07 23:10:00.000000',00000000000001409602),('2024-06-07 23:15:00.000000',00000000000001411602),('2024-06-07 23:20:00.000000',00000000000001435202),('2024-06-07 23:25:00.000000',00000000000001438202),('2024-06-07 23:30:00.000000',00000000000001445202),('2024-06-07 23:35:00.000000',00000000000001451202),('2024-06-07 23:40:00.000000',00000000000001466102),('2024-06-07 23:45:00.000000',00000000000001475102),('2024-06-07 23:50:00.000000',00000000000001482102),('2024-06-07 23:55:00.000000',00000000000001502002),('2024-06-08 00:00:00.000000',00000000000001521592),('2024-06-08 00:05:00.000000',00000000000001531392),('2024-06-08 00:10:00.000000',00000000000001548092),('2024-06-08 00:15:00.000000',00000000000001555092),('2024-06-08 00:20:00.000000',00000000000001560092),('2024-06-08 00:25:00.000000',00000000000001573971),('2024-06-08 00:30:00.000000',00000000000001583771),('2024-06-08 00:35:00.000000',00000000000001599561),('2024-06-08 00:40:00.000000',00000000000001610750),('2024-06-08 00:45:00.000000',00000000000001628340),('2024-06-08 00:50:00.000000',00000000000001647240),('2024-06-08 00:55:00.000000',00000000000001659140),('2024-06-08 01:00:00.000000',00000000000001668940),('2024-06-08 01:05:00.000000',00000000000001683506),('2024-06-08 01:10:00.000000',00000000000001698364),('2024-06-08 01:15:00.000000',00000000000001712596),('2024-06-08 01:20:00.000000',00000000000001724486),('2024-06-08 01:25:00.000000',00000000000001748086),('2024-06-08 01:30:00.000000',00000000000001757986),('2024-06-08 01:35:00.000000',00000000000001805786),('2024-06-08 01:40:00.000000',00000000000001835286),('2024-06-08 01:45:00.000000',00000000000001866986),('2024-06-08 01:50:00.000000',00000000000001890686),('2024-06-08 01:55:00.000000',00000000000001897586),('2024-06-08 02:00:00.000000',00000000000001900486),('2024-06-08 02:05:00.000000',00000000000001902486),('2024-06-08 02:10:00.000000',00000000000001908386),('2024-06-08 02:15:00.000000',00000000000001928886),('2024-06-08 02:20:00.000000',00000000000001936686),('2024-06-08 02:25:00.000000',00000000000001954486),('2024-06-08 02:30:00.000000',00000000000001956486),('2024-06-08 02:35:00.000000',00000000000001977086),('2024-06-08 02:40:00.000000',00000000000001986886),('2024-06-08 02:45:00.000000',00000000000001998686),('2024-06-08 02:50:00.000000',00000000000002005686),('2024-06-08 02:55:00.000000',00000000000002053586),('2024-06-08 03:00:00.000000',00000000000002061586),('2024-06-08 03:05:00.000000',00000000000002064586),('2024-06-08 03:10:00.000000',00000000000002085375),('2024-06-08 03:15:00.000000',00000000000002100275),('2024-06-08 03:20:00.000000',00000000000002108275),('2024-06-08 03:25:00.000000',00000000000002116275),('2024-06-08 03:30:00.000000',00000000000002124175),('2024-06-08 03:35:00.000000',00000000000002137075),('2024-06-08 03:40:00.000000',00000000000002147975),('2024-06-08 03:45:00.000000',00000000000002151975),('2024-06-08 03:50:00.000000',00000000000002157965),('2024-06-08 03:55:00.000000',00000000000002169765),('2024-06-08 04:00:00.000000',00000000000002176945),('2024-06-08 04:05:00.000000',00000000000002182934),('2024-06-08 04:10:00.000000',00000000000002208634),('2024-06-08 04:15:00.000000',00000000000002215634),('2024-06-08 04:20:00.000000',00000000000002226534),('2024-06-08 04:25:00.000000',00000000000002252334),('2024-06-08 04:30:00.000000',00000000000002265134),('2024-06-08 04:35:00.000000',00000000000002283924),('2024-06-08 04:40:00.000000',00000000000002308724),('2024-06-08 04:45:00.000000',00000000000002310823),('2024-06-08 04:50:00.000000',00000000000002361223),('2024-06-08 04:55:00.000000',00000000000002378023),('2024-06-08 05:00:00.000000',00000000000002403712),('2024-06-08 05:05:00.000000',00000000000002419512),('2024-06-08 05:10:00.000000',00000000000002439113),('2024-06-08 05:15:00.000000',00000000000002456013),('2024-06-08 05:20:00.000000',00000000000002486713),('2024-06-08 05:25:00.000000',00000000000002490713),('2024-06-08 05:30:00.000000',00000000000002495713),('2024-06-08 05:35:00.000000',00000000000002503613),('2024-06-08 05:40:00.000000',00000000000002517513),('2024-06-08 05:45:00.000000',00000000000002525413),('2024-06-08 05:50:00.000000',00000000000002590202),('2024-06-08 05:55:00.000000',00000000000002600202),('2024-06-08 06:00:00.000000',00000000000002607202),('2024-06-08 06:05:00.000000',00000000000002631702),('2024-06-08 06:10:00.000000',00000000000002635702),('2024-06-08 06:15:00.000000',00000000000002656391),('2024-06-08 06:20:00.000000',00000000000002666091),('2024-06-08 06:25:00.000000',00000000000002681169),('2024-06-08 06:30:00.000000',00000000000002698869),('2024-06-08 06:35:00.000000',00000000000002711648),('2024-06-08 06:40:00.000000',00000000000002731148),('2024-06-08 06:45:00.000000',00000000000002745038),('2024-06-08 06:50:00.000000',00000000000002749838),('2024-06-08 06:55:00.000000',00000000000002775538),('2024-06-08 07:00:00.000000',00000000000002808238),('2024-06-08 07:05:00.000000',00000000000002810238),('2024-06-08 07:10:00.000000',00000000000002811238),('2024-06-08 07:15:00.000000',00000000000002827138),('2024-06-08 07:20:00.000000',00000000000002836038),('2024-06-08 07:25:00.000000',00000000000002842027),('2024-06-08 07:30:00.000000',00000000000002861817),('2024-06-08 07:35:00.000000',00000000000002865817),('2024-06-08 07:40:00.000000',00000000000002887717),('2024-06-08 07:45:00.000000',00000000000002899617),('2024-06-08 07:50:00.000000',00000000000002926406),('2024-06-08 07:55:00.000000',00000000000002934195),('2024-06-08 08:00:00.000000',00000000000002937195),('2024-06-08 08:05:00.000000',00000000000002944995),('2024-06-08 08:10:00.000000',00000000000002947995),('2024-06-08 08:15:00.000000',00000000000002949995),('2024-06-08 08:20:00.000000',00000000000002950995),('2024-06-08 08:25:00.000000',00000000000002953995),('2024-06-08 08:30:00.000000',00000000000002957995),('2024-06-08 08:35:00.000000',00000000000002961995),('2024-06-08 08:40:00.000000',00000000000002964995),('2024-06-08 08:45:00.000000',00000000000002995684),('2024-06-08 08:50:00.000000',00000000000003019483),('2024-06-08 08:55:00.000000',00000000000003042983),('2024-06-08 09:00:00.000000',00000000000003045983),('2024-06-08 09:05:00.000000',00000000000003057783),('2024-06-08 09:10:00.000000',00000000000003193182),('2024-06-08 09:15:00.000000',00000000000003220681),('2024-06-08 09:20:00.000000',00000000000003367881),('2024-06-08 09:25:00.000000',00000000000003382681),('2024-06-08 09:30:00.000000',00000000000003392681),('2024-06-08 09:35:00.000000',00000000000003404281),('2024-06-08 09:40:00.000000',00000000000003408281),('2024-06-08 09:45:00.000000',00000000000003415181),('2024-06-08 09:50:00.000000',00000000000003422981),('2024-06-08 09:55:00.000000',00000000000003425981),('2024-06-08 10:00:00.000000',00000000000003437681),('2024-06-08 10:05:00.000000',00000000000003456470),('2024-06-08 10:10:00.000000',00000000000003472270),('2024-06-08 10:15:00.000000',00000000000003495870),('2024-06-08 10:20:00.000000',00000000000003500770),('2024-06-08 10:25:00.000000',00000000000003501750),('2024-06-08 10:30:00.000000',00000000000003552450),('2024-06-08 10:35:00.000000',00000000000003553450),('2024-06-08 10:40:00.000000',00000000000003566439),('2024-06-08 10:45:00.000000',00000000000003577039),('2024-06-08 10:50:00.000000',00000000000003592838),('2024-06-08 10:55:00.000000',00000000000003591928),('2024-06-08 11:00:00.000000',00000000000003601828),('2024-06-08 11:05:00.000000',00000000000003611718),('2024-06-08 11:10:00.000000',00000000000003624618),('2024-06-08 11:15:00.000000',00000000000003660318),('2024-06-08 11:20:00.000000',00000000000003662318),('2024-06-08 11:25:00.000000',00000000000003664307),('2024-06-08 11:30:00.000000',00000000000003667307),('2024-06-08 11:35:00.000000',00000000000003667307),('2024-06-08 11:40:00.000000',00000000000003668307),('2024-06-08 11:45:00.000000',00000000000003672307),('2024-06-08 11:50:00.000000',00000000000003685107),('2024-06-08 11:55:00.000000',00000000000003694007),('2024-06-08 12:00:00.000000',00000000000003696007),('2024-06-08 12:05:00.000000',00000000000004000507),('2024-06-08 12:10:00.000000',00000000000004018207),('2024-06-08 12:15:00.000000',00000000000004021207),('2024-06-08 12:20:00.000000',00000000000004043707),('2024-06-08 12:25:00.000000',00000000000004070007),('2024-06-08 12:30:00.000000',00000000000004089897),('2024-06-08 12:35:00.000000',00000000000004102797),('2024-06-08 12:40:00.000000',00000000000004122597),('2024-06-08 12:45:00.000000',00000000000004139397),('2024-06-08 12:50:00.000000',00000000000004152197),('2024-06-08 12:55:00.000000',00000000000004153197),('2024-06-08 13:00:00.000000',00000000000004171296),('2024-06-08 13:05:00.000000',00000000000004176296),('2024-06-08 13:10:00.000000',00000000000004191096),('2024-06-08 13:15:00.000000',00000000000004217696),('2024-06-08 13:20:00.000000',00000000000004225596),('2024-06-08 13:25:00.000000',00000000000004234586),('2024-06-08 13:30:00.000000',00000000000004254052),('2024-06-08 13:35:00.000000',00000000000004291900),('2024-06-08 13:40:00.000000',00000000000004323244),('2024-06-08 13:45:00.000000',00000000000004339044),('2024-06-08 13:50:00.000000',00000000000004355944),('2024-06-08 13:55:00.000000',00000000000004364944),('2024-06-08 14:00:00.000000',00000000000004381544),('2024-06-08 14:05:00.000000',00000000000004405433),('2024-06-08 14:10:00.000000',00000000000004415433),('2024-06-08 14:15:00.000000',00000000000004434423),('2024-06-08 14:20:00.000000',00000000000004473812),('2024-06-08 14:25:00.000000',00000000000004512782),('2024-06-08 14:30:00.000000',00000000000004553440),('2024-06-08 14:35:00.000000',00000000000004600840),('2024-06-08 14:40:00.000000',00000000000004629730),('2024-06-08 14:45:00.000000',00000000000004685529),('2024-06-08 14:50:00.000000',00000000000004720329),('2024-06-08 14:55:00.000000',00000000000004769695),('2024-06-08 15:00:00.000000',00000000000004800484),('2024-06-08 15:05:00.000000',00000000000004832484),('2024-06-08 15:10:00.000000',00000000000004943053),('2024-06-08 15:15:00.000000',00000000000005014653),('2024-06-08 15:20:00.000000',00000000000005095652),('2024-06-08 15:25:00.000000',00000000000005217941),('2024-06-08 15:30:00.000000',00000000000005345029),('2024-06-08 15:35:00.000000',00000000000005463929),('2024-06-08 15:40:00.000000',00000000000005599129),('2024-06-08 15:45:00.000000',00000000000005716929),('2024-06-08 15:50:00.000000',00000000000005877519),('2024-06-08 15:55:00.000000',00000000000006051365),('2024-06-08 16:00:00.000000',00000000000000000000),('2024-06-08 16:05:00.000000',00000000000000101580),('2024-06-08 16:10:00.000000',00000000000000174848),('2024-06-08 16:15:00.000000',00000000000000251338),('2024-06-08 16:20:00.000000',00000000000000298028),('2024-06-08 16:25:00.000000',00000000000000330818),('2024-06-08 16:30:00.000000',00000000000000363608),('2024-06-08 16:35:00.000000',00000000000000430287),('2024-06-08 16:40:00.000000',00000000000000485777),('2024-06-08 16:45:00.000000',00000000000000556467),('2024-06-08 16:50:00.000000',00000000000000592367),('2024-06-08 16:55:00.000000',00000000000000604357),('2024-06-08 17:00:00.000000',00000000000000645847),('2024-06-08 17:05:00.000000',00000000000000661547),('2024-06-08 17:10:00.000000',00000000000000702847),('2024-06-08 17:15:00.000000',00000000000000732547),('2024-06-08 17:20:00.000000',00000000000000813036),('2024-06-08 17:25:00.000000',00000000000000848816),('2024-06-08 17:30:00.000000',00000000000000881395),('2024-06-08 17:35:00.000000',00000000000000904095),('2024-06-08 17:40:00.000000',00000000000000933884),('2024-06-08 17:45:00.000000',00000000000000993584),('2024-06-08 17:50:00.000000',00000000000000992584),('2024-06-08 17:55:00.000000',00000000000001013384),('2024-06-08 18:00:00.000000',00000000000001044984),('2024-06-08 18:05:00.000000',00000000000001063772),('2024-06-08 18:10:00.000000',00000000000001075572),('2024-06-08 18:15:00.000000',00000000000001103361),('2024-06-08 18:20:00.000000',00000000000001125261),('2024-06-08 18:25:00.000000',00000000000001138151),('2024-06-08 18:30:00.000000',00000000000001205751),('2024-06-08 18:35:00.000000',00000000000001218851),('2024-06-08 18:40:00.000000',00000000000001221851),('2024-06-08 18:45:00.000000',00000000000001237651),('2024-06-08 18:50:00.000000',00000000000001439651),('2024-06-08 18:55:00.000000',00000000000001455451),('2024-06-08 19:00:00.000000',00000000000001459441),('2024-06-08 19:05:00.000000',00000000000001469331),('2024-06-08 19:10:00.000000',00000000000001486031),('2024-06-08 19:15:00.000000',00000000000001487031),('2024-06-08 19:20:00.000000',00000000000001494920),('2024-06-08 19:25:00.000000',00000000000001496920),('2024-06-08 19:30:00.000000',00000000000001505820),('2024-06-08 19:35:00.000000',00000000000001506820),('2024-06-08 19:40:00.000000',00000000000001508820),('2024-06-08 19:45:00.000000',00000000000001522720),('2024-06-08 19:50:00.000000',00000000000001539489),('2024-06-08 19:55:00.000000',00000000000001544489),('2024-06-08 20:00:00.000000',00000000000001568589),('2024-06-08 20:05:00.000000',00000000000001570589),('2024-06-08 20:10:00.000000',00000000000001581489),('2024-06-08 20:15:00.000000',00000000000001589279),('2024-06-08 20:20:00.000000',00000000000001589279),('2024-06-08 20:25:00.000000',00000000000001591279),('2024-06-08 20:30:00.000000',00000000000001611879),('2024-06-08 20:35:00.000000',00000000000001623779),('2024-06-08 20:40:00.000000',00000000000001629779),('2024-06-08 20:45:00.000000',00000000000001652469),('2024-06-08 20:50:00.000000',00000000000001660369),('2024-06-08 20:55:00.000000',00000000000001663369),('2024-06-08 21:00:00.000000',00000000000001669269),('2024-06-08 21:05:00.000000',00000000000001677069),('2024-06-08 21:10:00.000000',00000000000001682959),('2024-06-08 21:15:00.000000',00000000000001689848),('2024-06-08 21:20:00.000000',00000000000001703648),('2024-06-08 21:25:00.000000',00000000000001753448),('2024-06-08 21:30:00.000000',00000000000001755448),('2024-06-08 21:35:00.000000',00000000000001756448),('2024-06-08 21:40:00.000000',00000000000001755448),('2024-06-08 21:45:00.000000',00000000000001758448),('2024-06-08 21:50:00.000000',00000000000001758448),('2024-06-08 21:55:00.000000',00000000000001776248),('2024-06-08 22:00:00.000000',00000000000001783148),('2024-06-08 22:05:00.000000',00000000000001791948),('2024-06-08 22:10:00.000000',00000000000001797748),('2024-06-08 22:15:00.000000',00000000000001800748),('2024-06-08 22:20:00.000000',00000000000001804648),('2024-06-08 22:25:00.000000',00000000000001815548),('2024-06-08 22:30:00.000000',00000000000001835048),('2024-06-08 22:35:00.000000',00000000000001853348),('2024-06-08 22:40:00.000000',00000000000001853348),('2024-06-08 22:45:00.000000',00000000000001860148),('2024-06-08 22:50:00.000000',00000000000001863148),('2024-06-08 22:55:00.000000',00000000000001872048),('2024-06-08 23:00:00.000000',00000000000001873048),('2024-06-08 23:05:00.000000',00000000000001876048),('2024-06-08 23:10:00.000000',00000000000001884848),('2024-06-08 23:15:00.000000',00000000000001884848),('2024-06-08 23:20:00.000000',00000000000001897748),('2024-06-08 23:25:00.000000',00000000000001944548),('2024-06-08 23:30:00.000000',00000000000001942648),('2024-06-08 23:35:00.000000',00000000000001958448),('2024-06-08 23:40:00.000000',00000000000001965448),('2024-06-08 23:45:00.000000',00000000000001981348),('2024-06-08 23:50:00.000000',00000000000001991348),('2024-06-08 23:55:00.000000',00000000000002000248),('2024-06-09 00:00:00.000000',00000000000002010048),('2024-06-09 00:05:00.000000',00000000000002021948),('2024-06-09 00:10:00.000000',00000000000002034638),('2024-06-09 00:15:00.000000',00000000000002045626),('2024-06-09 00:20:00.000000',00000000000002057426),('2024-06-09 00:25:00.000000',00000000000002068326),('2024-06-09 00:30:00.000000',00000000000002085225),('2024-06-09 00:35:00.000000',00000000000002094025),('2024-06-09 00:40:00.000000',00000000000002097025),('2024-06-09 00:45:00.000000',00000000000002109825),('2024-06-09 00:50:00.000000',00000000000002118625),('2024-06-09 00:55:00.000000',00000000000002118913),('2024-06-09 01:00:00.000000',00000000000002128813),('2024-06-09 01:05:00.000000',00000000000002135703),('2024-06-09 01:10:00.000000',00000000000002161402),('2024-06-09 01:15:00.000000',00000000000002184902),('2024-06-09 01:20:00.000000',00000000000002259802),('2024-06-09 01:25:00.000000',00000000000002289392),('2024-06-09 01:30:00.000000',00000000000002309082),('2024-06-09 01:35:00.000000',00000000000002317072),('2024-06-09 01:40:00.000000',00000000000002344972),('2024-06-09 01:45:00.000000',00000000000002361872),('2024-06-09 01:50:00.000000',00000000000002363872),('2024-06-09 01:55:00.000000',00000000000002384672),('2024-06-09 02:00:00.000000',00000000000002392572),('2024-06-09 02:05:00.000000',00000000000002415872),('2024-06-09 02:10:00.000000',00000000000002430672),('2024-06-09 02:15:00.000000',00000000000002440372),('2024-06-09 02:20:00.000000',00000000000002461072),('2024-06-09 02:25:00.000000',00000000000002474972),('2024-06-09 02:30:00.000000',00000000000002493672),('2024-06-09 02:35:00.000000',00000000000002504472),('2024-06-09 02:40:00.000000',00000000000002511472),('2024-06-09 02:45:00.000000',00000000000002521372),('2024-06-09 02:50:00.000000',00000000000002521372),('2024-06-09 02:55:00.000000',00000000000002534172),('2024-06-09 03:00:00.000000',00000000000002549872),('2024-06-09 03:05:00.000000',00000000000002847572),('2024-06-09 03:10:00.000000',00000000000002866372),('2024-06-09 03:15:00.000000',00000000000002873272),('2024-06-09 03:20:00.000000',00000000000002878172),('2024-06-09 03:25:00.000000',00000000000002898962),('2024-06-09 03:30:00.000000',00000000000002907962),('2024-06-09 03:35:00.000000',00000000000002915662),('2024-06-09 03:40:00.000000',00000000000002934361),('2024-06-09 03:45:00.000000',00000000000002953961),('2024-06-09 03:50:00.000000',00000000000002966761),('2024-06-09 03:55:00.000000',00000000000002973760),('2024-06-09 04:00:00.000000',00000000000002984659),('2024-06-09 04:05:00.000000',00000000000002995359),('2024-06-09 04:10:00.000000',00000000000003023959),('2024-06-09 04:15:00.000000',00000000000003028959),('2024-06-09 04:20:00.000000',00000000000003036758),('2024-06-09 04:25:00.000000',00000000000003036758),('2024-06-09 04:30:00.000000',00000000000003059548),('2024-06-09 04:35:00.000000',00000000000003063548),('2024-06-09 04:40:00.000000',00000000000003082338),('2024-06-09 04:45:00.000000',00000000000003096237),('2024-06-09 04:50:00.000000',00000000000003140037),('2024-06-09 04:55:00.000000',00000000000003144037),('2024-06-09 05:00:00.000000',00000000000003158937),('2024-06-09 05:05:00.000000',00000000000003161037),('2024-06-09 05:10:00.000000',00000000000003185715),('2024-06-09 05:15:00.000000',00000000000003188705),('2024-06-09 05:20:00.000000',00000000000003200595),('2024-06-09 05:25:00.000000',00000000000003203595),('2024-06-09 05:30:00.000000',00000000000003210495),('2024-06-09 05:35:00.000000',00000000000003224285),('2024-06-09 05:40:00.000000',00000000000003260785),('2024-06-09 05:45:00.000000',00000000000003279285),('2024-06-09 05:50:00.000000',00000000000003299074),('2024-06-09 05:55:00.000000',00000000000003328673),('2024-06-09 06:00:00.000000',00000000000003332673),('2024-06-09 06:05:00.000000',00000000000003342573),('2024-06-09 06:10:00.000000',00000000000003345573),('2024-06-09 06:15:00.000000',00000000000003348363),('2024-06-09 06:20:00.000000',00000000000003354263),('2024-06-09 06:25:00.000000',00000000000003361063),('2024-06-09 06:30:00.000000',00000000000003375763),('2024-06-09 06:35:00.000000',00000000000003384652),('2024-06-09 06:40:00.000000',00000000000003388652),('2024-06-09 06:45:00.000000',00000000000003404551),('2024-06-09 06:50:00.000000',00000000000003413631),('2024-06-09 06:55:00.000000',00000000000003427331),('2024-06-09 07:00:00.000000',00000000000003437321),('2024-06-09 07:05:00.000000',00000000000003462021),('2024-06-09 07:10:00.000000',00000000000003477711),('2024-06-09 07:15:00.000000',00000000000003505411),('2024-06-09 07:20:00.000000',00000000000003515311),('2024-06-09 07:25:00.000000',00000000000003519211),('2024-06-09 07:30:00.000000',00000000000003515311),('2024-06-09 07:35:00.000000',00000000000003568011),('2024-06-09 07:40:00.000000',00000000000003588711),('2024-06-09 07:45:00.000000',00000000000003597611),('2024-06-09 07:50:00.000000',00000000000003617201),('2024-06-09 07:55:00.000000',00000000000003622101),('2024-06-09 08:00:00.000000',00000000000003641801),('2024-06-09 08:05:00.000000',00000000000003659501),('2024-06-09 08:10:00.000000',00000000000003667501),('2024-06-09 08:15:00.000000',00000000000003688201),('2024-06-09 08:20:00.000000',00000000000003701091),('2024-06-09 08:25:00.000000',00000000000003722790),('2024-06-09 08:30:00.000000',00000000000003730680),('2024-06-09 08:35:00.000000',00000000000003730680),('2024-06-09 08:40:00.000000',00000000000003731680),('2024-06-09 08:45:00.000000',00000000000003731680),('2024-06-09 08:50:00.000000',00000000000003740379),('2024-06-09 08:55:00.000000',00000000000003748279),('2024-06-09 09:00:00.000000',00000000000003756179),('2024-06-09 09:05:00.000000',00000000000003768069),('2024-06-09 09:10:00.000000',00000000000003776625),('2024-06-09 09:15:00.000000',00000000000003795325),('2024-06-09 09:20:00.000000',00000000000003795325),('2024-06-09 09:25:00.000000',00000000000003813171),('2024-06-09 09:30:00.000000',00000000000003816071),('2024-06-09 09:35:00.000000',00000000000003824771),('2024-06-09 09:40:00.000000',00000000000003830671),('2024-06-09 09:45:00.000000',00000000000003858371),('2024-06-09 09:50:00.000000',00000000000003878061),('2024-06-09 09:55:00.000000',00000000000003893461),('2024-06-09 10:00:00.000000',00000000000003945461),('2024-06-09 10:05:00.000000',00000000000003956361),('2024-06-09 10:10:00.000000',00000000000003967260),('2024-06-09 10:15:00.000000',00000000000004000460),('2024-06-09 10:20:00.000000',00000000000004015560),('2024-06-09 10:25:00.000000',00000000000004018560),('2024-06-09 10:30:00.000000',00000000000004026460),('2024-06-09 10:35:00.000000',00000000000004028460),('2024-06-09 10:40:00.000000',00000000000004046060),('2024-06-09 10:45:00.000000',00000000000004084860),('2024-06-09 10:50:00.000000',00000000000004098760),('2024-06-09 10:55:00.000000',00000000000004099760),('2024-06-09 11:00:00.000000',00000000000004099760),('2024-06-09 11:05:00.000000',00000000000004135160),('2024-06-09 11:10:00.000000',00000000000004151050),('2024-06-09 11:15:00.000000',00000000000004160850),('2024-06-09 11:20:00.000000',00000000000004186550),('2024-06-09 11:25:00.000000',00000000000004218530),('2024-06-09 11:30:00.000000',00000000000004238210),('2024-06-09 11:35:00.000000',00000000000004253010),('2024-06-09 11:40:00.000000',00000000000004279610),('2024-06-09 11:45:00.000000',00000000000004294210),('2024-06-09 11:50:00.000000',00000000000004307910),('2024-06-09 11:55:00.000000',00000000000004317810),('2024-06-09 12:00:00.000000',00000000000004322790),('2024-06-09 12:05:00.000000',00000000000004335490),('2024-06-09 12:10:00.000000',00000000000004346370),('2024-06-09 12:15:00.000000',00000000000004375839),('2024-06-09 12:20:00.000000',00000000000004391839),('2024-06-09 12:25:00.000000',00000000000004433139),('2024-06-09 12:30:00.000000',00000000000004434139),('2024-06-09 12:35:00.000000',00000000000004445839),('2024-06-09 12:40:00.000000',00000000000004450839),('2024-06-09 12:45:00.000000',00000000000004467719),('2024-06-09 12:50:00.000000',00000000000004485419),('2024-06-09 12:55:00.000000',00000000000004488419),('2024-06-09 13:00:00.000000',00000000000004507119),('2024-06-09 13:05:00.000000',00000000000004517519),('2024-06-09 13:10:00.000000',00000000000004583919),('2024-06-09 13:15:00.000000',00000000000004597009),('2024-06-09 13:20:00.000000',00000000000004606009),('2024-06-09 13:25:00.000000',00000000000004621909),('2024-06-09 13:30:00.000000',00000000000004631908),('2024-06-09 13:35:00.000000',00000000000004639797),('2024-06-09 13:40:00.000000',00000000000004683287),('2024-06-09 13:45:00.000000',00000000000004694187),('2024-06-09 13:50:00.000000',00000000000004853287),('2024-06-09 13:55:00.000000',00000000000004873187),('2024-06-09 14:00:00.000000',00000000000004913877),('2024-06-09 14:05:00.000000',00000000000005018966),('2024-06-09 14:10:00.000000',00000000000005084466),('2024-06-09 14:15:00.000000',00000000000005093466),('2024-06-09 14:20:00.000000',00000000000005131056),('2024-06-09 14:25:00.000000',00000000000005144046),('2024-06-09 14:30:00.000000',00000000000005158036),('2024-06-09 14:35:00.000000',00000000000005183936),('2024-06-09 14:40:00.000000',00000000000005216836),('2024-06-09 14:45:00.000000',00000000000005257716),('2024-06-09 14:50:00.000000',00000000000005291415),('2024-06-09 14:55:00.000000',00000000000005334116),('2024-06-09 15:00:00.000000',00000000000005358416),('2024-06-09 15:05:00.000000',00000000000005416996),('2024-06-09 15:10:00.000000',00000000000005444795),('2024-06-09 15:15:00.000000',00000000000005481394),('2024-06-09 15:20:00.000000',00000000000005553974),('2024-06-09 15:25:00.000000',00000000000005588374),('2024-06-09 15:30:00.000000',00000000000005630044),('2024-06-09 15:35:00.000000',00000000000005623144),('2024-06-09 15:40:00.000000',00000000000005653844),('2024-06-09 15:45:00.000000',00000000000005664744),('2024-06-09 15:50:00.000000',00000000000005676734),('2024-06-09 15:55:00.000000',00000000000005691234),('2024-06-09 16:00:00.000000',00000000000000000000),('2024-06-09 16:05:00.000000',00000000000000032379),('2024-06-09 16:10:00.000000',00000000000000055069),('2024-06-09 16:15:00.000000',00000000000000080868),('2024-06-09 16:20:00.000000',00000000000000089758),('2024-06-09 16:25:00.000000',00000000000000129238),('2024-06-09 16:30:00.000000',00000000000000167438),('2024-06-09 16:35:00.000000',00000000000000208027),('2024-06-09 16:40:00.000000',00000000000000216886),('2024-06-09 16:45:00.000000',00000000000000293476),('2024-06-09 16:50:00.000000',00000000000000306032),('2024-06-09 16:55:00.000000',00000000000000319922),('2024-06-09 17:00:00.000000',00000000000000329822),('2024-06-09 17:05:00.000000',00000000000000375222),('2024-06-09 17:10:00.000000',00000000000000389422),('2024-06-09 17:15:00.000000',00000000000000438212),('2024-06-09 17:20:00.000000',00000000000000456812),('2024-06-09 17:25:00.000000',00000000000000532200),('2024-06-09 17:30:00.000000',00000000000000561000),('2024-06-09 17:35:00.000000',00000000000000584500),('2024-06-09 17:40:00.000000',00000000000000596390),('2024-06-09 17:45:00.000000',00000000000000627879),('2024-06-09 17:50:00.000000',00000000000000639679),('2024-06-09 17:55:00.000000',00000000000000659179),('2024-06-09 18:00:00.000000',00000000000000667179),('2024-06-09 18:05:00.000000',00000000000000692878),('2024-06-09 18:10:00.000000',00000000000000707678),('2024-06-09 18:15:00.000000',00000000000000720278),('2024-06-09 18:20:00.000000',00000000000000765858),('2024-06-09 18:25:00.000000',00000000000000792746),('2024-06-09 18:30:00.000000',00000000000000811746),('2024-06-09 18:35:00.000000',00000000000000813746),('2024-06-09 18:40:00.000000',00000000000000824546),('2024-06-09 18:45:00.000000',00000000000000836446),('2024-06-09 18:50:00.000000',00000000000000881346),('2024-06-09 18:55:00.000000',00000000000000901246),('2024-06-09 19:00:00.000000',00000000000000918136),('2024-06-09 19:05:00.000000',00000000000000976736),('2024-06-09 19:10:00.000000',00000000000000995836),('2024-06-09 19:15:00.000000',00000000000001032524),('2024-06-09 19:20:00.000000',00000000000001037324),('2024-06-09 19:25:00.000000',00000000000001044124),('2024-06-09 19:30:00.000000',00000000000001047624),('2024-06-09 19:35:00.000000',00000000000001071324),('2024-06-09 19:40:00.000000',00000000000001083124),('2024-06-09 19:45:00.000000',00000000000001083124),('2024-06-09 19:50:00.000000',00000000000001102924),('2024-06-09 19:55:00.000000',00000000000001111824),('2024-06-09 20:00:00.000000',00000000000001115724),('2024-06-09 20:05:00.000000',00000000000001138024),('2024-06-09 20:10:00.000000',00000000000001131124),('2024-06-09 20:15:00.000000',00000000000001133924),('2024-06-09 20:20:00.000000',00000000000001143624),('2024-06-09 20:25:00.000000',00000000000001147624),('2024-06-09 20:30:00.000000',00000000000001150624),('2024-06-09 20:35:00.000000',00000000000001152524),('2024-06-09 20:40:00.000000',00000000000001164424),('2024-06-09 20:45:00.000000',00000000000001164424),('2024-06-09 20:50:00.000000',00000000000001154524),('2024-06-09 20:55:00.000000',00000000000001165424),('2024-06-09 21:00:00.000000',00000000000001166424),('2024-06-09 21:05:00.000000',00000000000001166424),('2024-06-09 21:10:00.000000',00000000000001169424),('2024-06-09 21:15:00.000000',00000000000001179324),('2024-06-09 21:20:00.000000',00000000000001179324),('2024-06-09 21:25:00.000000',00000000000001182324),('2024-06-09 21:30:00.000000',00000000000001187224),('2024-06-09 21:35:00.000000',00000000000001201024),('2024-06-09 21:40:00.000000',00000000000001204024),('2024-06-09 21:45:00.000000',00000000000001225724),('2024-06-09 21:50:00.000000',00000000000001229713),('2024-06-09 21:55:00.000000',00000000000001239613),('2024-06-09 22:00:00.000000',00000000000001253413),('2024-06-09 22:05:00.000000',00000000000001253413),('2024-06-09 22:10:00.000000',00000000000001262193),('2024-06-09 22:15:00.000000',00000000000001266183),('2024-06-09 22:20:00.000000',00000000000001267183),('2024-06-09 22:25:00.000000',00000000000001269183),('2024-06-09 22:30:00.000000',00000000000001270173),('2024-06-09 22:35:00.000000',00000000000001274163),('2024-06-09 22:40:00.000000',00000000000001279163),('2024-06-09 22:45:00.000000',00000000000001285363),('2024-06-09 22:50:00.000000',00000000000001290863),('2024-06-09 22:55:00.000000',00000000000001302763),('2024-06-09 23:00:00.000000',00000000000001320463),('2024-06-09 23:05:00.000000',00000000000001320463),('2024-06-09 23:10:00.000000',00000000000001336163),('2024-06-09 23:15:00.000000',00000000000001349163),('2024-06-09 23:20:00.000000',00000000000001350163),('2024-06-09 23:25:00.000000',00000000000001354163),('2024-06-09 23:30:00.000000',00000000000001361063),('2024-06-09 23:35:00.000000',00000000000001371863),('2024-06-09 23:40:00.000000',00000000000001377863),('2024-06-09 23:45:00.000000',00000000000001379852),('2024-06-09 23:50:00.000000',00000000000001382752),('2024-06-09 23:55:00.000000',00000000000001389542),('2024-06-10 00:00:00.000000',00000000000001406842),('2024-06-10 00:05:00.000000',00000000000001411742),('2024-06-10 00:10:00.000000',00000000000001414732),('2024-06-10 00:15:00.000000',00000000000001426532),('2024-06-10 00:20:00.000000',00000000000001467232),('2024-06-10 00:25:00.000000',00000000000001481031),('2024-06-10 00:30:00.000000',00000000000001484031),('2024-06-10 00:35:00.000000',00000000000001502831),('2024-06-10 00:40:00.000000',00000000000001515631),('2024-06-10 00:45:00.000000',00000000000001528531),('2024-06-10 00:50:00.000000',00000000000001527531),('2024-06-10 00:55:00.000000',00000000000001534231),('2024-06-10 01:00:00.000000',00000000000001542230),('2024-06-10 01:05:00.000000',00000000000001554120),('2024-06-10 01:10:00.000000',00000000000001559120),('2024-06-10 01:15:00.000000',00000000000001569020),('2024-06-10 01:20:00.000000',00000000000001730420),('2024-06-10 01:25:00.000000',00000000000001739120),('2024-06-10 01:30:00.000000',00000000000001742620),('2024-06-10 01:35:00.000000',00000000000001755020),('2024-06-10 01:40:00.000000',00000000000001756520),('2024-06-10 01:45:00.000000',00000000000001793720),('2024-06-10 01:50:00.000000',00000000000001795720),('2024-06-10 01:55:00.000000',00000000000001814420),('2024-06-10 02:00:00.000000',00000000000001826320),('2024-06-10 02:05:00.000000',00000000000001827310),('2024-06-10 02:10:00.000000',00000000000001827310),('2024-06-10 02:15:00.000000',00000000000001844010),('2024-06-10 02:20:00.000000',00000000000001850009),('2024-06-10 02:25:00.000000',00000000000001876708),('2024-06-10 02:30:00.000000',00000000000001880508),('2024-06-10 02:35:00.000000',00000000000001888298),('2024-06-10 02:40:00.000000',00000000000001906797),('2024-06-10 02:45:00.000000',00000000000001915497),('2024-06-10 02:50:00.000000',00000000000001917497),('2024-06-10 02:55:00.000000',00000000000001919497),('2024-06-10 03:00:00.000000',00000000000001929397),('2024-06-10 03:05:00.000000',00000000000002077897),('2024-06-10 03:10:00.000000',00000000000002122697),('2024-06-10 03:15:00.000000',00000000000002155297),('2024-06-10 03:20:00.000000',00000000000002167696),('2024-06-10 03:25:00.000000',00000000000002184596),('2024-06-10 03:30:00.000000',00000000000002185596),('2024-06-10 03:35:00.000000',00000000000002190496),('2024-06-10 03:40:00.000000',00000000000002205286),('2024-06-10 03:45:00.000000',00000000000002218886),('2024-06-10 03:50:00.000000',00000000000002222886),('2024-06-10 03:55:00.000000',00000000000002234886),('2024-06-10 04:00:00.000000',00000000000002253786),('2024-06-10 04:05:00.000000',00000000000002312486),('2024-06-10 04:10:00.000000',00000000000002317486),('2024-06-10 04:15:00.000000',00000000000002318486),('2024-06-10 04:20:00.000000',00000000000002322486),('2024-06-10 04:25:00.000000',00000000000002325486),('2024-06-10 04:30:00.000000',00000000000002326486),('2024-06-10 04:35:00.000000',00000000000002337386),('2024-06-10 04:40:00.000000',00000000000002351186),('2024-06-10 04:45:00.000000',00000000000002351186),('2024-06-10 04:50:00.000000',00000000000002353186),('2024-06-10 04:55:00.000000',00000000000002364086),('2024-06-10 05:00:00.000000',00000000000002370286),('2024-06-10 05:05:00.000000',00000000000002377186),('2024-06-10 05:10:00.000000',00000000000002389086),('2024-06-10 05:15:00.000000',00000000000002409786),('2024-06-10 05:20:00.000000',00000000000002430586),('2024-06-10 05:25:00.000000',00000000000002442786),('2024-06-10 05:30:00.000000',00000000000002458586),('2024-06-10 05:35:00.000000',00000000000002460586),('2024-06-10 05:40:00.000000',00000000000002458586),('2024-06-10 05:45:00.000000',00000000000002466586),('2024-06-10 05:50:00.000000',00000000000002477485),('2024-06-10 05:55:00.000000',00000000000002483585),('2024-06-10 06:00:00.000000',00000000000002484585),('2024-06-10 06:05:00.000000',00000000000002511275),('2024-06-10 06:10:00.000000',00000000000002529175),('2024-06-10 06:15:00.000000',00000000000002539174),('2024-06-10 06:20:00.000000',00000000000002550064),('2024-06-10 06:25:00.000000',00000000000002556954),('2024-06-10 06:30:00.000000',00000000000002569044),('2024-06-10 06:35:00.000000',00000000000002579944),('2024-06-10 06:40:00.000000',00000000000002639644),('2024-06-10 06:45:00.000000',00000000000002641644),('2024-06-10 06:50:00.000000',00000000000002673444),('2024-06-10 06:55:00.000000',00000000000002682244),('2024-06-10 07:00:00.000000',00000000000002712934),('2024-06-10 07:05:00.000000',00000000000002727634),('2024-06-10 07:10:00.000000',00000000000002743434),('2024-06-10 07:15:00.000000',00000000000002779634),('2024-06-10 07:20:00.000000',00000000000002790514),('2024-06-10 07:25:00.000000',00000000000002816202),('2024-06-10 07:30:00.000000',00000000000002845801),('2024-06-10 07:35:00.000000',00000000000002862601),('2024-06-10 07:40:00.000000',00000000000002881501),('2024-06-10 07:45:00.000000',00000000000002883501),('2024-06-10 07:50:00.000000',00000000000002913001),('2024-06-10 07:55:00.000000',00000000000002920901),('2024-06-10 08:00:00.000000',00000000000002937700),('2024-06-10 08:05:00.000000',00000000000002966200),('2024-06-10 08:10:00.000000',00000000000002971100),('2024-06-10 08:15:00.000000',00000000000003010144),('2024-06-10 08:20:00.000000',00000000000003018344),('2024-06-10 08:25:00.000000',00000000000003039244),('2024-06-10 08:30:00.000000',00000000000003051134),('2024-06-10 08:35:00.000000',00000000000003080834),('2024-06-10 08:40:00.000000',00000000000003094734),('2024-06-10 08:45:00.000000',00000000000003106534),('2024-06-10 08:50:00.000000',00000000000003114434),('2024-06-10 08:55:00.000000',00000000000003119334),('2024-06-10 09:00:00.000000',00000000000003130234),('2024-06-10 09:05:00.000000',00000000000003146934),('2024-06-10 09:10:00.000000',00000000000003196734),('2024-06-10 09:15:00.000000',00000000000003214932),('2024-06-10 09:20:00.000000',00000000000003357033),('2024-06-10 09:25:00.000000',00000000000003366933),('2024-06-10 09:30:00.000000',00000000000003382833),('2024-06-10 09:35:00.000000',00000000000003409433),('2024-06-10 09:40:00.000000',00000000000003449333),('2024-06-10 09:45:00.000000',00000000000003454233),('2024-06-10 09:50:00.000000',00000000000003500033),('2024-06-10 09:55:00.000000',00000000000003517833),('2024-06-10 10:00:00.000000',00000000000003526733),('2024-06-10 10:05:00.000000',00000000000003527733),('2024-06-10 10:10:00.000000',00000000000003530033),('2024-06-10 10:15:00.000000',00000000000003533678),('2024-06-10 10:20:00.000000',00000000000003572278),('2024-06-10 10:25:00.000000',00000000000003617078),('2024-06-10 10:30:00.000000',00000000000003636778),('2024-06-10 10:35:00.000000',00000000000003932457),('2024-06-10 10:40:00.000000',00000000000003937457),('2024-06-10 10:45:00.000000',00000000000003951057),('2024-06-10 10:50:00.000000',00000000000003956957),('2024-06-10 10:55:00.000000',00000000000003964657),('2024-06-10 11:00:00.000000',00000000000003986246),('2024-06-10 11:05:00.000000',00000000000003996036),('2024-06-10 11:10:00.000000',00000000000003993136),('2024-06-10 11:15:00.000000',00000000000004007936),('2024-06-10 11:20:00.000000',00000000000004017736),('2024-06-10 11:25:00.000000',00000000000004313324),('2024-06-10 11:30:00.000000',00000000000004320224),('2024-06-10 11:35:00.000000',00000000000004324224),('2024-06-10 11:40:00.000000',00000000000004324224),('2024-06-10 11:45:00.000000',00000000000004374524),('2024-06-10 11:50:00.000000',00000000000004392204),('2024-06-10 11:55:00.000000',00000000000004397104),('2024-06-10 12:00:00.000000',00000000000004388204),('2024-06-10 12:05:00.000000',00000000000004388204),('2024-06-10 12:10:00.000000',00000000000004392203),('2024-06-10 12:15:00.000000',00000000000004416903),('2024-06-10 12:20:00.000000',00000000000004427591),('2024-06-10 12:25:00.000000',00000000000004438491),('2024-06-10 12:30:00.000000',00000000000004444391),('2024-06-10 12:35:00.000000',00000000000004443791),('2024-06-10 12:40:00.000000',00000000000004460091),('2024-06-10 12:45:00.000000',00000000000004461091),('2024-06-10 12:50:00.000000',00000000000004469090),('2024-06-10 12:55:00.000000',00000000000004479980),('2024-06-10 13:00:00.000000',00000000000004506580),('2024-06-10 13:05:00.000000',00000000000004507880),('2024-06-10 13:10:00.000000',00000000000004525680),('2024-06-10 13:15:00.000000',00000000000004535480),('2024-06-10 13:20:00.000000',00000000000004565580),('2024-06-10 13:25:00.000000',00000000000004578480),('2024-06-10 13:30:00.000000',00000000000004583380),('2024-06-10 13:35:00.000000',00000000000004587280),('2024-06-10 13:40:00.000000',00000000000004614559),('2024-06-10 13:45:00.000000',00000000000004659448),('2024-06-10 13:50:00.000000',00000000000004661448),('2024-06-10 13:55:00.000000',00000000000004669348),('2024-06-10 14:00:00.000000',00000000000004680938),('2024-06-10 14:05:00.000000',00000000000004723438),('2024-06-10 14:10:00.000000',00000000000004740238),('2024-06-10 14:15:00.000000',00000000000004762938),('2024-06-10 14:20:00.000000',00000000000004777638),('2024-06-10 14:25:00.000000',00000000000004772738),('2024-06-10 14:30:00.000000',00000000000004792738),('2024-06-10 14:35:00.000000',00000000000004802638),('2024-06-10 14:40:00.000000',00000000000004825437),('2024-06-10 14:45:00.000000',00000000000004861837),('2024-06-10 14:50:00.000000',00000000000004879937),('2024-06-10 14:55:00.000000',00000000000004889936),('2024-06-10 15:00:00.000000',00000000000004928515),('2024-06-10 15:05:00.000000',00000000000004957305),('2024-06-10 15:10:00.000000',00000000000004968595),('2024-06-10 15:15:00.000000',00000000000004968595),('2024-06-10 15:20:00.000000',00000000000004979145),('2024-06-10 15:25:00.000000',00000000000004981245),('2024-06-10 15:30:00.000000',00000000000004982245),('2024-06-10 15:35:00.000000',00000000000005006935),('2024-06-10 15:40:00.000000',00000000000005167035),('2024-06-10 15:45:00.000000',00000000000005183724),('2024-06-10 15:50:00.000000',00000000000005211214),('2024-06-10 15:55:00.000000',00000000000005235314),('2024-06-10 16:00:00.000000',00000000000000000000),('2024-06-10 16:05:00.000000',00000000000000155490),('2024-06-10 16:10:00.000000',00000000000000190990),('2024-06-10 16:15:00.000000',00000000000000206880),('2024-06-10 16:20:00.000000',00000000000000230580),('2024-06-10 16:25:00.000000',00000000000000251380),('2024-06-10 16:30:00.000000',00000000000000278580),('2024-06-10 16:35:00.000000',00000000000000300379),('2024-06-10 16:40:00.000000',00000000000000308869),('2024-06-10 16:45:00.000000',00000000000000315858),('2024-06-10 16:50:00.000000',00000000000000322838),('2024-06-10 16:55:00.000000',00000000000000404238),('2024-06-10 17:00:00.000000',00000000000000412138),('2024-06-10 17:05:00.000000',00000000000000428838),('2024-06-10 17:10:00.000000',00000000000000444038),('2024-06-10 17:15:00.000000',00000000000000503838),('2024-06-10 17:20:00.000000',00000000000000503838),('2024-06-10 17:25:00.000000',00000000000000528438),('2024-06-10 17:30:00.000000',00000000000000540338),('2024-06-10 17:35:00.000000',00000000000000558138),('2024-06-10 17:40:00.000000',00000000000000586807),('2024-06-10 17:45:00.000000',00000000000000599796),('2024-06-10 17:50:00.000000',00000000000000625396),('2024-06-10 17:55:00.000000',00000000000000643196),('2024-06-10 18:00:00.000000',00000000000000657696),('2024-06-10 18:05:00.000000',00000000000000668596),('2024-06-10 18:10:00.000000',00000000000000675196),('2024-06-10 18:15:00.000000',00000000000000683396),('2024-06-10 18:20:00.000000',00000000000000693886),('2024-06-10 18:25:00.000000',00000000000000697186),('2024-06-10 18:30:00.000000',00000000000000706086),('2024-06-10 18:35:00.000000',00000000000000740086),('2024-06-10 18:40:00.000000',00000000000000747086),('2024-06-10 18:45:00.000000',00000000000000751086),('2024-06-10 18:50:00.000000',00000000000000762086),('2024-06-10 18:55:00.000000',00000000000000771986),('2024-06-10 19:00:00.000000',00000000000000774986),('2024-06-10 19:05:00.000000',00000000000000779976),('2024-06-10 19:10:00.000000',00000000000000786976),('2024-06-10 19:15:00.000000',00000000000000793975),('2024-06-10 19:20:00.000000',00000000000000809874),('2024-06-10 19:25:00.000000',00000000000000807974),('2024-06-10 19:30:00.000000',00000000000000815774),('2024-06-10 19:35:00.000000',00000000000000819774),('2024-06-10 19:40:00.000000',00000000000000832674),('2024-06-10 19:45:00.000000',00000000000000838474),('2024-06-10 19:50:00.000000',00000000000000862374),('2024-06-10 19:55:00.000000',00000000000000872264),('2024-06-10 20:00:00.000000',00000000000000882274),('2024-06-10 20:05:00.000000',00000000000000907874),('2024-06-10 20:10:00.000000',00000000000000913774),('2024-06-10 20:15:00.000000',00000000000000971574),('2024-06-10 20:20:00.000000',00000000000000977574),('2024-06-10 20:25:00.000000',00000000000000980574),('2024-06-10 20:30:00.000000',00000000000000981574),('2024-06-10 20:35:00.000000',00000000000000996374),('2024-06-10 20:40:00.000000',00000000000001001374),('2024-06-10 20:45:00.000000',00000000000001003274),('2024-06-10 20:50:00.000000',00000000000001015173),('2024-06-10 20:55:00.000000',00000000000001026873),('2024-06-10 21:00:00.000000',00000000000001026873),('2024-06-10 21:05:00.000000',00000000000001032673),('2024-06-10 21:10:00.000000',00000000000001032673),('2024-06-10 21:15:00.000000',00000000000001040573),('2024-06-10 21:20:00.000000',00000000000001040573),('2024-06-10 21:25:00.000000',00000000000001042573),('2024-06-10 21:30:00.000000',00000000000001045473),('2024-06-10 21:35:00.000000',00000000000001061073),('2024-06-10 21:40:00.000000',00000000000001064073),('2024-06-10 21:45:00.000000',00000000000001065073),('2024-06-10 21:50:00.000000',00000000000001066073),('2024-06-10 21:55:00.000000',00000000000001079873),('2024-06-10 22:00:00.000000',00000000000001085773),('2024-06-10 22:05:00.000000',00000000000001085773),('2024-06-10 22:10:00.000000',00000000000001090573),('2024-06-10 22:15:00.000000',00000000000001100473),('2024-06-10 22:20:00.000000',00000000000001102373),('2024-06-10 22:25:00.000000',00000000000001118173),('2024-06-10 22:30:00.000000',00000000000001121173),('2024-06-10 22:35:00.000000',00000000000001122173),('2024-06-10 22:40:00.000000',00000000000001130171),('2024-06-10 22:45:00.000000',00000000000001132171),('2024-06-10 22:50:00.000000',00000000000001133171),('2024-06-10 22:55:00.000000',00000000000001133171),('2024-06-10 23:00:00.000000',00000000000001135171),('2024-06-10 23:05:00.000000',00000000000001147071),('2024-06-10 23:10:00.000000',00000000000001147071),('2024-06-10 23:15:00.000000',00000000000001186971),('2024-06-10 23:20:00.000000',00000000000001200771),('2024-06-10 23:25:00.000000',00000000000001215670),('2024-06-10 23:30:00.000000',00000000000001216670),('2024-06-10 23:35:00.000000',00000000000001258670),('2024-06-10 23:40:00.000000',00000000000001258670),('2024-06-10 23:45:00.000000',00000000000001258670),('2024-06-10 23:50:00.000000',00000000000001268570),('2024-06-10 23:55:00.000000',00000000000001277370),('2024-06-11 00:00:00.000000',00000000000001277370),('2024-06-11 00:05:00.000000',00000000000001280370),('2024-06-11 00:10:00.000000',00000000000001296060),('2024-06-11 00:15:00.000000',00000000000001315760),('2024-06-11 00:20:00.000000',00000000000001315760),('2024-06-11 00:25:00.000000',00000000000001319660),('2024-06-11 00:30:00.000000',00000000000001322660),('2024-06-11 00:35:00.000000',00000000000001332360),('2024-06-11 00:40:00.000000',00000000000001335360),('2024-06-11 00:45:00.000000',00000000000001348260),('2024-06-11 00:50:00.000000',00000000000001353260),('2024-06-11 00:55:00.000000',00000000000001355760),('2024-06-11 01:00:00.000000',00000000000001358760),('2024-06-11 01:05:00.000000',00000000000001377560),('2024-06-11 01:10:00.000000',00000000000001387360),('2024-06-11 01:15:00.000000',00000000000001391250),('2024-06-11 01:20:00.000000',00000000000001407950),('2024-06-11 01:25:00.000000',00000000000001413850),('2024-06-11 01:30:00.000000',00000000000001421650),('2024-06-11 01:35:00.000000',00000000000001448440),('2024-06-11 01:40:00.000000',00000000000001461230),('2024-06-11 01:45:00.000000',00000000000001465330),('2024-06-11 01:50:00.000000',00000000000001465330),('2024-06-11 01:55:00.000000',00000000000001480530),('2024-06-11 02:00:00.000000',00000000000001490430),('2024-06-11 02:05:00.000000',00000000000001543130),('2024-06-11 02:10:00.000000',00000000000001546130),('2024-06-11 02:15:00.000000',00000000000001560830),('2024-06-11 02:20:00.000000',00000000000001577730),('2024-06-11 02:25:00.000000',00000000000001587430),('2024-06-11 02:30:00.000000',00000000000001597630),('2024-06-11 02:35:00.000000',00000000000001615230),('2024-06-11 02:40:00.000000',00000000000001617230),('2024-06-11 02:45:00.000000',00000000000001635030),('2024-06-11 02:50:00.000000',00000000000001637030),('2024-06-11 02:55:00.000000',00000000000001648830),('2024-06-11 03:00:00.000000',00000000000001658630),('2024-06-11 03:05:00.000000',00000000000001668530),('2024-06-11 03:10:00.000000',00000000000001677330),('2024-06-11 03:15:00.000000',00000000000001680330),('2024-06-11 03:20:00.000000',00000000000001698930),('2024-06-11 03:25:00.000000',00000000000001701230),('2024-06-11 03:30:00.000000',00000000000001715030),('2024-06-11 03:35:00.000000',00000000000001726818),('2024-06-11 03:40:00.000000',00000000000001743618),('2024-06-11 03:45:00.000000',00000000000001755518),('2024-06-11 03:50:00.000000',00000000000001759517),('2024-06-11 03:55:00.000000',00000000000001765517),('2024-06-11 04:00:00.000000',00000000000001779417),('2024-06-11 04:05:00.000000',00000000000001784317),('2024-06-11 04:10:00.000000',00000000000001801717),('2024-06-11 04:15:00.000000',00000000000001804717),('2024-06-11 04:20:00.000000',00000000000001822417),('2024-06-11 04:25:00.000000',00000000000001825417),('2024-06-11 04:30:00.000000',00000000000001828417),('2024-06-11 04:35:00.000000',00000000000001830317),('2024-06-11 04:40:00.000000',00000000000001846017),('2024-06-11 04:45:00.000000',00000000000001854917),('2024-06-11 04:50:00.000000',00000000000001865206),('2024-06-11 04:55:00.000000',00000000000001876906),('2024-06-11 05:00:00.000000',00000000000001913472),('2024-06-11 05:05:00.000000',00000000000001940072),('2024-06-11 05:10:00.000000',00000000000001966438),('2024-06-11 05:15:00.000000',00000000000001974238),('2024-06-11 05:20:00.000000',00000000000001999838),('2024-06-11 05:25:00.000000',00000000000002029338),('2024-06-11 05:30:00.000000',00000000000002077438),('2024-06-11 05:35:00.000000',00000000000002129928),('2024-06-11 05:40:00.000000',00000000000002183828),('2024-06-11 05:45:00.000000',00000000000002194928),('2024-06-11 05:50:00.000000',00000000000002195928),('2024-06-11 05:55:00.000000',00000000000002242728),('2024-06-11 06:00:00.000000',00000000000002243828),('2024-06-11 06:05:00.000000',00000000000002252728),('2024-06-11 06:10:00.000000',00000000000002261528),('2024-06-11 06:15:00.000000',00000000000002271418),('2024-06-11 06:20:00.000000',00000000000002276218),('2024-06-11 06:25:00.000000',00000000000002278218),('2024-06-11 06:30:00.000000',00000000000002289018),('2024-06-11 06:35:00.000000',00000000000002318618),('2024-06-11 06:40:00.000000',00000000000002326518),('2024-06-11 06:45:00.000000',00000000000002336398),('2024-06-11 06:50:00.000000',00000000000002352086),('2024-06-11 06:55:00.000000',00000000000002355976),('2024-06-11 07:00:00.000000',00000000000002355976),('2024-06-11 07:05:00.000000',00000000000002364876),('2024-06-11 07:10:00.000000',00000000000002359976),('2024-06-11 07:15:00.000000',00000000000002360976),('2024-06-11 07:20:00.000000',00000000000002369876),('2024-06-11 07:25:00.000000',00000000000002399776),('2024-06-11 07:30:00.000000',00000000000002406776),('2024-06-11 07:35:00.000000',00000000000002421575),('2024-06-11 07:40:00.000000',00000000000002427475),('2024-06-11 07:45:00.000000',00000000000002426575),('2024-06-11 07:50:00.000000',00000000000002439265),('2024-06-11 07:55:00.000000',00000000000002452165),('2024-06-11 08:00:00.000000',00000000000002461865),('2024-06-11 08:05:00.000000',00000000000002474665),('2024-06-11 08:10:00.000000',00000000000002476655),('2024-06-11 08:15:00.000000',00000000000002481555),('2024-06-11 08:20:00.000000',00000000000002491355),('2024-06-11 08:25:00.000000',00000000000002507435),('2024-06-11 08:30:00.000000',00000000000002517335),('2024-06-11 08:35:00.000000',00000000000002522335),('2024-06-11 08:40:00.000000',00000000000002530135),('2024-06-11 08:45:00.000000',00000000000002540035),('2024-06-11 08:50:00.000000',00000000000002559935),('2024-06-11 08:55:00.000000',00000000000002566835),('2024-06-11 09:00:00.000000',00000000000002582635),('2024-06-11 09:05:00.000000',00000000000002582635),('2024-06-11 09:10:00.000000',00000000000002584635),('2024-06-11 09:15:00.000000',00000000000002586635),('2024-06-11 09:20:00.000000',00000000000002595535),('2024-06-11 09:25:00.000000',00000000000002611214),('2024-06-11 09:30:00.000000',00000000000002616014),('2024-06-11 09:35:00.000000',00000000000002629814),('2024-06-11 09:40:00.000000',00000000000002645314),('2024-06-11 09:45:00.000000',00000000000002658214),('2024-06-11 09:50:00.000000',00000000000002671014),('2024-06-11 09:55:00.000000',00000000000002731713),('2024-06-11 10:00:00.000000',00000000000002737613),('2024-06-11 10:05:00.000000',00000000000002737613),('2024-06-11 10:10:00.000000',00000000000002751013),('2024-06-11 10:15:00.000000',00000000000002753013),('2024-06-11 10:20:00.000000',00000000000002891413),('2024-06-11 10:25:00.000000',00000000000002908013),('2024-06-11 10:30:00.000000',00000000000002949913),('2024-06-11 10:35:00.000000',00000000000002959813),('2024-06-11 10:40:00.000000',00000000000002968613),('2024-06-11 10:45:00.000000',00000000000002989313),('2024-06-11 10:50:00.000000',00000000000002996113),('2024-06-11 10:55:00.000000',00000000000003002913),('2024-06-11 11:00:00.000000',00000000000003018713),('2024-06-11 11:05:00.000000',00000000000003047503),('2024-06-11 11:10:00.000000',00000000000003055393),('2024-06-11 11:15:00.000000',00000000000003057382),('2024-06-11 11:20:00.000000',00000000000003065382),('2024-06-11 11:25:00.000000',00000000000003076282),('2024-06-11 11:30:00.000000',00000000000003131082),('2024-06-11 11:35:00.000000',00000000000003143882),('2024-06-11 11:40:00.000000',00000000000003143882),('2024-06-11 11:45:00.000000',00000000000003143882),('2024-06-11 11:50:00.000000',00000000000003148682),('2024-06-11 11:55:00.000000',00000000000003172362),('2024-06-11 12:00:00.000000',00000000000003188962),('2024-06-11 12:05:00.000000',00000000000003199762),('2024-06-11 12:10:00.000000',00000000000003209162),('2024-06-11 12:15:00.000000',00000000000003211162),('2024-06-11 12:20:00.000000',00000000000003214161),('2024-06-11 12:25:00.000000',00000000000003226162),('2024-06-11 12:30:00.000000',00000000000003220162),('2024-06-11 12:35:00.000000',00000000000003230162),('2024-06-11 12:40:00.000000',00000000000003244051),('2024-06-11 12:45:00.000000',00000000000003247051),('2024-06-11 12:50:00.000000',00000000000003253050),('2024-06-11 12:55:00.000000',00000000000003285549),('2024-06-11 13:00:00.000000',00000000000003302239),('2024-06-11 13:05:00.000000',00000000000003295439),('2024-06-11 13:10:00.000000',00000000000003298439),('2024-06-11 13:15:00.000000',00000000000003299439),('2024-06-11 13:20:00.000000',00000000000003305429),('2024-06-11 13:25:00.000000',00000000000003323219),('2024-06-11 13:30:00.000000',00000000000003387719),('2024-06-11 13:35:00.000000',00000000000003393709),('2024-06-11 13:40:00.000000',00000000000003401509),('2024-06-11 13:45:00.000000',00000000000003413309),('2024-06-11 13:50:00.000000',00000000000003421109),('2024-06-11 13:55:00.000000',00000000000003434509),('2024-06-11 14:00:00.000000',00000000000003444409),('2024-06-11 14:05:00.000000',00000000000003456309),('2024-06-11 14:10:00.000000',00000000000003458309),('2024-06-11 14:15:00.000000',00000000000003458309),('2024-06-11 14:20:00.000000',00000000000003490089),('2024-06-11 14:25:00.000000',00000000000003496889),('2024-06-11 14:30:00.000000',00000000000003554479),('2024-06-11 14:35:00.000000',00000000000003562479),('2024-06-11 14:40:00.000000',00000000000003568135),('2024-06-11 14:45:00.000000',00000000000003668275),('2024-06-11 14:50:00.000000',00000000000003681730),('2024-06-11 14:55:00.000000',00000000000003698030),('2024-06-11 15:00:00.000000',00000000000003727419),('2024-06-11 15:05:00.000000',00000000000003744219),('2024-06-11 15:10:00.000000',00000000000003772119),('2024-06-11 15:15:00.000000',00000000000003791819),('2024-06-11 15:20:00.000000',00000000000003763519),('2024-06-11 15:25:00.000000',00000000000003782387),('2024-06-11 15:30:00.000000',00000000000003792276),('2024-06-11 15:35:00.000000',00000000000003801243),('2024-06-11 15:40:00.000000',00000000000003814932),('2024-06-11 15:45:00.000000',00000000000003818932),('2024-06-11 15:50:00.000000',00000000000003833612),('2024-06-11 15:55:00.000000',00000000000003838512),('2024-06-11 16:00:00.000000',00000000000000000000),('2024-06-11 16:05:00.000000',00000000000000022990),('2024-06-11 16:10:00.000000',00000000000000057046),('2024-06-11 16:15:00.000000',00000000000000081825),('2024-06-11 16:20:00.000000',00000000000000093725),('2024-06-11 16:25:00.000000',00000000000000111624),('2024-06-11 16:30:00.000000',00000000000000120802),('2024-06-11 16:35:00.000000',00000000000000291492),('2024-06-11 16:40:00.000000',00000000000000317939),('2024-06-11 16:45:00.000000',00000000000000341482),('2024-06-11 16:50:00.000000',00000000000000383060),('2024-06-11 16:55:00.000000',00000000000000391060),('2024-06-11 17:00:00.000000',00000000000000391060),('2024-06-11 17:05:00.000000',00000000000000401050),('2024-06-11 17:10:00.000000',00000000000000421750),('2024-06-11 17:15:00.000000',00000000000000432439),('2024-06-11 17:20:00.000000',00000000000000448839),('2024-06-11 17:25:00.000000',00000000000000456039),('2024-06-11 17:30:00.000000',00000000000000475939),('2024-06-11 17:35:00.000000',00000000000000479917),('2024-06-11 17:40:00.000000',00000000000000496707),('2024-06-11 17:45:00.000000',00000000000000507497),('2024-06-11 17:50:00.000000',00000000000000518397),('2024-06-11 17:55:00.000000',00000000000000520387),('2024-06-11 18:00:00.000000',00000000000000515576),('2024-06-11 18:05:00.000000',00000000000000522466),('2024-06-11 18:10:00.000000',00000000000000538826),('2024-06-11 18:15:00.000000',00000000000000569316),('2024-06-11 18:20:00.000000',00000000000000638516),('2024-06-11 18:25:00.000000',00000000000000638516),('2024-06-11 18:30:00.000000',00000000000000639506),('2024-06-11 18:35:00.000000',00000000000000653296),('2024-06-11 18:40:00.000000',00000000000000660186),('2024-06-11 18:45:00.000000',00000000000000683076),('2024-06-11 18:50:00.000000',00000000000000694164),('2024-06-11 18:55:00.000000',00000000000000694164),('2024-06-11 19:00:00.000000',00000000000000696164),('2024-06-11 19:05:00.000000',00000000000000700043),('2024-06-11 19:10:00.000000',00000000000000702933),('2024-06-11 19:15:00.000000',00000000000000745922),('2024-06-11 19:20:00.000000',00000000000000752722),('2024-06-11 19:25:00.000000',00000000000000767522),('2024-06-11 19:30:00.000000',00000000000000782321),('2024-06-11 19:35:00.000000',00000000000000783321),('2024-06-11 19:40:00.000000',00000000000000793010),('2024-06-11 19:45:00.000000',00000000000000796910),('2024-06-11 19:50:00.000000',00000000000000831710),('2024-06-11 19:55:00.000000',00000000000000831710),('2024-06-11 20:00:00.000000',00000000000000835589),('2024-06-11 20:05:00.000000',00000000000000839588),('2024-06-11 20:10:00.000000',00000000000000840588),('2024-06-11 20:15:00.000000',00000000000000840588),('2024-06-11 20:20:00.000000',00000000000000841588),('2024-06-11 20:25:00.000000',00000000000000841588),('2024-06-11 20:30:00.000000',00000000000000841588),('2024-06-11 20:35:00.000000',00000000000000845587),('2024-06-11 20:40:00.000000',00000000000000851787),('2024-06-11 20:45:00.000000',00000000000000851787),('2024-06-11 20:50:00.000000',00000000000000861687),('2024-06-11 20:55:00.000000',00000000000000861687),('2024-06-11 21:00:00.000000',00000000000000865587),('2024-06-11 21:05:00.000000',00000000000000871587),('2024-06-11 21:10:00.000000',00000000000000872587),('2024-06-11 21:15:00.000000',00000000000000876587),('2024-06-11 21:20:00.000000',00000000000000880587),('2024-06-11 21:25:00.000000',00000000000000880587),('2024-06-11 21:30:00.000000',00000000000000881587),('2024-06-11 21:35:00.000000',00000000000000882587),('2024-06-11 21:40:00.000000',00000000000000886577),('2024-06-11 21:45:00.000000',00000000000000886577),('2024-06-11 21:50:00.000000',00000000000000886577),('2024-06-11 21:55:00.000000',00000000000000890567),('2024-06-11 22:00:00.000000',00000000000000891567),('2024-06-11 22:05:00.000000',00000000000000907656),('2024-06-11 22:10:00.000000',00000000000000915556),('2024-06-11 22:15:00.000000',00000000000000929445),('2024-06-11 22:20:00.000000',00000000000000935445),('2024-06-11 22:25:00.000000',00000000000000938445),('2024-06-11 22:30:00.000000',00000000000000942345),('2024-06-11 22:35:00.000000',00000000000000947845),('2024-06-11 22:40:00.000000',00000000000000950745),('2024-06-11 22:45:00.000000',00000000000000951745),('2024-06-11 22:50:00.000000',00000000000000955744),('2024-06-11 22:55:00.000000',00000000000000956734),('2024-06-11 23:00:00.000000',00000000000000970534),('2024-06-11 23:05:00.000000',00000000000001014334),('2024-06-11 23:10:00.000000',00000000000001018334),('2024-06-11 23:15:00.000000',00000000000001034224),('2024-06-11 23:20:00.000000',00000000000001036224),('2024-06-11 23:25:00.000000',00000000000001049924),('2024-06-11 23:30:00.000000',00000000000001052924),('2024-06-11 23:35:00.000000',00000000000001055903),('2024-06-11 23:40:00.000000',00000000000001065902),('2024-06-11 23:45:00.000000',00000000000001068102),('2024-06-11 23:50:00.000000',00000000000001069102),('2024-06-11 23:55:00.000000',00000000000001079902),('2024-06-12 00:00:00.000000',00000000000001097602),('2024-06-12 00:05:00.000000',00000000000001102402),('2024-06-12 00:10:00.000000',00000000000001110192),('2024-06-12 00:15:00.000000',00000000000001126982),('2024-06-12 00:20:00.000000',00000000000001138782),('2024-06-12 00:25:00.000000',00000000000001151462),('2024-06-12 00:30:00.000000',00000000000001154462),('2024-06-12 00:35:00.000000',00000000000001162451),('2024-06-12 00:40:00.000000',00000000000001172351),('2024-06-12 00:45:00.000000',00000000000001183151),('2024-06-12 00:50:00.000000',00000000000001222751),('2024-06-12 00:55:00.000000',00000000000001245450),('2024-06-12 01:00:00.000000',00000000000001247450),('2024-06-12 01:05:00.000000',00000000000001295250),('2024-06-12 01:10:00.000000',00000000000001296440),('2024-06-12 01:15:00.000000',00000000000001311140),('2024-06-12 01:20:00.000000',00000000000001317040),('2024-06-12 01:25:00.000000',00000000000001318040),('2024-06-12 01:30:00.000000',00000000000001326029),('2024-06-12 01:35:00.000000',00000000000001329929),('2024-06-12 01:40:00.000000',00000000000001349509),('2024-06-12 01:45:00.000000',00000000000001358599),('2024-06-12 01:50:00.000000',00000000000001366499),('2024-06-12 01:55:00.000000',00000000000001366499),('2024-06-12 02:00:00.000000',00000000000001371289),('2024-06-12 02:05:00.000000',00000000000001390089),('2024-06-12 02:10:00.000000',00000000000001395989),('2024-06-12 02:15:00.000000',00000000000001426589),('2024-06-12 02:20:00.000000',00000000000001430589),('2024-06-12 02:25:00.000000',00000000000001433579),('2024-06-12 02:30:00.000000',00000000000001447379),('2024-06-12 02:35:00.000000',00000000000001452279),('2024-06-12 02:40:00.000000',00000000000001464179),('2024-06-12 02:45:00.000000',00000000000001466179),('2024-06-12 02:50:00.000000',00000000000001475947),('2024-06-12 02:55:00.000000',00000000000001485847),('2024-06-12 03:00:00.000000',00000000000001507227),('2024-06-12 03:05:00.000000',00000000000001508217),('2024-06-12 03:10:00.000000',00000000000001509217),('2024-06-12 03:15:00.000000',00000000000001560017),('2024-06-12 03:20:00.000000',00000000000001577517),('2024-06-12 03:25:00.000000',00000000000001579317),('2024-06-12 03:30:00.000000',00000000000001579317),('2024-06-12 03:35:00.000000',00000000000001586307),('2024-06-12 03:40:00.000000',00000000000001610007),('2024-06-12 03:45:00.000000',00000000000001629607),('2024-06-12 03:50:00.000000',00000000000001643386),('2024-06-12 03:55:00.000000',00000000000001655174),('2024-06-12 04:00:00.000000',00000000000001664874),('2024-06-12 04:05:00.000000',00000000000001691553),('2024-06-12 04:10:00.000000',00000000000001706988),('2024-06-12 04:15:00.000000',00000000000001710988),('2024-06-12 04:20:00.000000',00000000000001705088),('2024-06-12 04:25:00.000000',00000000000001705088),('2024-06-12 04:30:00.000000',00000000000001726858),('2024-06-12 04:35:00.000000',00000000000001774358),('2024-06-12 04:40:00.000000',00000000000001783258),('2024-06-12 04:45:00.000000',00000000000001799036),('2024-06-12 04:50:00.000000',00000000000001834725),('2024-06-12 04:55:00.000000',00000000000001890515),('2024-06-12 05:00:00.000000',00000000000001911293),('2024-06-12 05:05:00.000000',00000000000001932993),('2024-06-12 05:10:00.000000',00000000000001951448),('2024-06-12 05:15:00.000000',00000000000001981017),('2024-06-12 05:20:00.000000',00000000000002014575),('2024-06-12 05:25:00.000000',00000000000002042333),('2024-06-12 05:30:00.000000',00000000000002080512),('2024-06-12 05:35:00.000000',00000000000002097112),('2024-06-12 05:40:00.000000',00000000000002112012),('2024-06-12 05:45:00.000000',00000000000002125801),('2024-06-12 05:50:00.000000',00000000000002154490),('2024-06-12 05:55:00.000000',00000000000002161590),('2024-06-12 06:00:00.000000',00000000000002162690),('2024-06-12 06:05:00.000000',00000000000002169590),('2024-06-12 06:10:00.000000',00000000000002190290),('2024-06-12 06:15:00.000000',00000000000002203690),('2024-06-12 06:20:00.000000',00000000000002256469),('2024-06-12 06:25:00.000000',00000000000002275149),('2024-06-12 06:30:00.000000',00000000000002302727),('2024-06-12 06:35:00.000000',00000000000002314527),('2024-06-12 06:40:00.000000',00000000000002340727),('2024-06-12 06:45:00.000000',00000000000002357505),('2024-06-12 06:50:00.000000',00000000000002368394),('2024-06-12 06:55:00.000000',00000000000002403884),('2024-06-12 07:00:00.000000',00000000000002424584),('2024-06-12 07:05:00.000000',00000000000002496154),('2024-06-12 07:10:00.000000',00000000000002517844),('2024-06-12 07:15:00.000000',00000000000002531724),('2024-06-12 07:20:00.000000',00000000000002568928),('2024-06-12 07:25:00.000000',00000000000002587796),('2024-06-12 07:30:00.000000',00000000000002891396),('2024-06-12 07:35:00.000000',00000000000002951585),('2024-06-12 07:40:00.000000',00000000000002954485),('2024-06-12 07:45:00.000000',00000000000002965364),('2024-06-12 07:50:00.000000',00000000000002985064),('2024-06-12 07:55:00.000000',00000000000003009822),('2024-06-12 08:00:00.000000',00000000000003027612),('2024-06-12 08:05:00.000000',00000000000003047512),('2024-06-12 08:10:00.000000',00000000000003051412),('2024-06-12 08:15:00.000000',00000000000003054412),('2024-06-12 08:20:00.000000',00000000000003073202),('2024-06-12 08:25:00.000000',00000000000003097902),('2024-06-12 08:30:00.000000',00000000000003106682),('2024-06-12 08:35:00.000000',00000000000003117482),('2024-06-12 08:40:00.000000',00000000000003152582),('2024-06-12 08:45:00.000000',00000000000003188737),('2024-06-12 08:50:00.000000',00000000000003207526),('2024-06-12 08:55:00.000000',00000000000003216427),('2024-06-12 09:00:00.000000',00000000000003235297),('2024-06-12 09:05:00.000000',00000000000003255486),('2024-06-12 09:10:00.000000',00000000000003317044),('2024-06-12 09:15:00.000000',00000000000003371902),('2024-06-12 09:20:00.000000',00000000000003375892),('2024-06-12 09:25:00.000000',00000000000003405572),('2024-06-12 09:30:00.000000',00000000000003427151),('2024-06-12 09:35:00.000000',00000000000003438941),('2024-06-12 09:40:00.000000',00000000000003448131),('2024-06-12 09:45:00.000000',00000000000003461301),('2024-06-12 09:50:00.000000',00000000000003470201),('2024-06-12 09:55:00.000000',00000000000003478101),('2024-06-12 10:00:00.000000',00000000000003478101),('2024-06-12 10:05:00.000000',00000000000003476191),('2024-06-12 10:10:00.000000',00000000000003479480),('2024-06-12 10:15:00.000000',00000000000003480146),('2024-06-12 10:20:00.000000',00000000000003488946),('2024-06-12 10:25:00.000000',00000000000003506746),('2024-06-12 10:30:00.000000',00000000000003520645),('2024-06-12 10:35:00.000000',00000000000003576345),('2024-06-12 10:40:00.000000',00000000000003589235),('2024-06-12 10:45:00.000000',00000000000003638115),('2024-06-12 10:50:00.000000',00000000000003659985),('2024-06-12 10:55:00.000000',00000000000003675864),('2024-06-12 11:00:00.000000',00000000000003695353),('2024-06-12 11:05:00.000000',00000000000003721133),('2024-06-12 11:10:00.000000',00000000000003736011),('2024-06-12 11:15:00.000000',00000000000003747301),('2024-06-12 11:20:00.000000',00000000000003770991),('2024-06-12 11:25:00.000000',00000000000003778971),('2024-06-12 11:30:00.000000',00000000000003783161),('2024-06-12 11:35:00.000000',00000000000003793041),('2024-06-12 11:40:00.000000',00000000000003799031),('2024-06-12 11:45:00.000000',00000000000003862701),('2024-06-12 11:50:00.000000',00000000000003875591),('2024-06-12 11:55:00.000000',00000000000003925381),('2024-06-12 12:00:00.000000',00000000000003939340),('2024-06-12 12:05:00.000000',00000000000003952420),('2024-06-12 12:10:00.000000',00000000000003967220),('2024-06-12 12:15:00.000000',00000000000003981119),('2024-06-12 12:20:00.000000',00000000000003985109),('2024-06-12 12:25:00.000000',00000000000003996909),('2024-06-12 12:30:00.000000',00000000000003999909),('2024-06-12 12:35:00.000000',00000000000004007798),('2024-06-12 12:40:00.000000',00000000000004025288),('2024-06-12 12:45:00.000000',00000000000004033488),('2024-06-12 12:50:00.000000',00000000000004039478),('2024-06-12 12:55:00.000000',00000000000004045477),('2024-06-12 13:00:00.000000',00000000000004061257),('2024-06-12 13:05:00.000000',00000000000004121927),('2024-06-12 13:10:00.000000',00000000000004177616),('2024-06-12 13:15:00.000000',00000000000004214096),('2024-06-12 13:20:00.000000',00000000000004274786),('2024-06-12 13:25:00.000000',00000000000004294776),('2024-06-12 13:30:00.000000',00000000000004325143),('2024-06-12 13:35:00.000000',00000000000004345023),('2024-06-12 13:40:00.000000',00000000000004368093),('2024-06-12 13:45:00.000000',00000000000004381872),('2024-06-12 13:50:00.000000',00000000000004407941),('2024-06-12 13:55:00.000000',00000000000004423641),('2024-06-12 14:00:00.000000',00000000000004444811),('2024-06-12 14:05:00.000000',00000000000004455311),('2024-06-12 14:10:00.000000',00000000000004471781),('2024-06-12 14:15:00.000000',00000000000004523649),('2024-06-12 14:20:00.000000',00000000000004528649),('2024-06-12 14:25:00.000000',00000000000004545996),('2024-06-12 14:30:00.000000',00000000000004559675),('2024-06-12 14:35:00.000000',00000000000004581764),('2024-06-12 14:40:00.000000',00000000000004645564),('2024-06-12 14:45:00.000000',00000000000004666243),('2024-06-12 14:50:00.000000',00000000000004727133),('2024-06-12 14:55:00.000000',00000000000004762801),('2024-06-12 15:00:00.000000',00000000000004835171),('2024-06-12 15:05:00.000000',00000000000004845960),('2024-06-12 15:10:00.000000',00000000000004870828),('2024-06-12 15:15:00.000000',00000000000004907717),('2024-06-12 15:20:00.000000',00000000000004925196),('2024-06-12 15:25:00.000000',00000000000004944976),('2024-06-12 15:30:00.000000',00000000000004975586),('2024-06-12 15:35:00.000000',00000000000004996376),('2024-06-12 15:40:00.000000',00000000000005027898),('2024-06-12 15:45:00.000000',00000000000005054598),('2024-06-12 15:50:00.000000',00000000000005091076),('2024-06-12 15:55:00.000000',00000000000005168356),('2024-06-12 16:00:00.000000',00000000000000000000),('2024-06-12 16:05:00.000000',00000000000000088748),('2024-06-12 16:10:00.000000',00000000000000207987),('2024-06-12 16:15:00.000000',00000000000000540324),('2024-06-12 16:20:00.000000',00000000000000559104),('2024-06-12 16:25:00.000000',00000000000000582894),('2024-06-12 16:30:00.000000',00000000000000622752),('2024-06-12 16:35:00.000000',00000000000000672198),('2024-06-12 16:40:00.000000',00000000000000686357),('2024-06-12 16:45:00.000000',00000000000000738735),('2024-06-12 16:50:00.000000',00000000000000761705),('2024-06-12 16:55:00.000000',00000000000000829783),('2024-06-12 17:00:00.000000',00000000000000860463),('2024-06-12 17:05:00.000000',00000000000000897843),('2024-06-12 17:10:00.000000',00000000000000939613),('2024-06-12 17:15:00.000000',00000000000000962663),('2024-06-12 17:20:00.000000',00000000000000970552),('2024-06-12 17:25:00.000000',00000000000000984444),('2024-06-12 17:30:00.000000',00000000000000992193),('2024-06-12 17:35:00.000000',00000000000001013893),('2024-06-12 17:40:00.000000',00000000000001007093),('2024-06-12 17:45:00.000000',00000000000001018082),('2024-06-12 17:50:00.000000',00000000000001032052),('2024-06-12 17:55:00.000000',00000000000001038042),('2024-06-12 18:00:00.000000',00000000000001064012),('2024-06-12 18:05:00.000000',00000000000001066012),('2024-06-12 18:10:00.000000',00000000000001071002),('2024-06-12 18:15:00.000000',00000000000001083881),('2024-06-12 18:20:00.000000',00000000000001095681),('2024-06-12 18:25:00.000000',00000000000001105471),('2024-06-12 18:30:00.000000',00000000000001115930),('2024-06-12 18:35:00.000000',00000000000001121920),('2024-06-12 18:40:00.000000',00000000000001125910),('2024-06-12 18:45:00.000000',00000000000001136810),('2024-06-12 18:50:00.000000',00000000000001146210),('2024-06-12 18:55:00.000000',00000000000001149210),('2024-06-12 19:00:00.000000',00000000000001153210),('2024-06-12 19:05:00.000000',00000000000001168010),('2024-06-12 19:10:00.000000',00000000000001175009),('2024-06-12 19:15:00.000000',00000000000001223999),('2024-06-12 19:20:00.000000',00000000000001225999),('2024-06-12 19:25:00.000000',00000000000001235899),('2024-06-12 19:30:00.000000',00000000000001242199),('2024-06-12 19:35:00.000000',00000000000001253099),('2024-06-12 19:40:00.000000',00000000000001263199),('2024-06-12 19:45:00.000000',00000000000001284999),('2024-06-12 19:50:00.000000',00000000000001284999),('2024-06-12 19:55:00.000000',00000000000001292799),('2024-06-12 20:00:00.000000',00000000000001303979),('2024-06-12 20:05:00.000000',00000000000001305979),('2024-06-12 20:10:00.000000',00000000000001307979),('2024-06-12 20:15:00.000000',00000000000001310979),('2024-06-12 20:20:00.000000',00000000000001321879),('2024-06-12 20:25:00.000000',00000000000001331759),('2024-06-12 20:30:00.000000',00000000000001355947),('2024-06-12 20:35:00.000000',00000000000001360947),('2024-06-12 20:40:00.000000',00000000000001365827),('2024-06-12 20:45:00.000000',00000000000001365827),('2024-06-12 20:50:00.000000',00000000000001373727),('2024-06-12 20:55:00.000000',00000000000001377627),('2024-06-12 21:00:00.000000',00000000000001381617),('2024-06-12 21:05:00.000000',00000000000001382617),('2024-06-12 21:10:00.000000',00000000000001392496),('2024-06-12 21:15:00.000000',00000000000001392496),('2024-06-12 21:20:00.000000',00000000000001395396),('2024-06-12 21:25:00.000000',00000000000001401396),('2024-06-12 21:30:00.000000',00000000000001403396),('2024-06-12 21:35:00.000000',00000000000001416095),('2024-06-12 21:40:00.000000',00000000000001424795),('2024-06-12 21:45:00.000000',00000000000001429985),('2024-06-12 21:50:00.000000',00000000000001431985),('2024-06-12 21:55:00.000000',00000000000001441874),('2024-06-12 22:00:00.000000',00000000000001445774),('2024-06-12 22:05:00.000000',00000000000001449674),('2024-06-12 22:10:00.000000',00000000000001449674),('2024-06-12 22:15:00.000000',00000000000001449674),('2024-06-12 22:20:00.000000',00000000000001456474),('2024-06-12 22:25:00.000000',00000000000001456474),('2024-06-12 22:30:00.000000',00000000000001458474),('2024-06-12 22:35:00.000000',00000000000001459474),('2024-06-12 22:40:00.000000',00000000000001465474),('2024-06-12 22:45:00.000000',00000000000001481174),('2024-06-12 22:50:00.000000',00000000000001487164),('2024-06-12 22:55:00.000000',00000000000001494964),('2024-06-12 23:00:00.000000',00000000000001507163),('2024-06-12 23:05:00.000000',00000000000001515063),('2024-06-12 23:10:00.000000',00000000000001518063),('2024-06-12 23:15:00.000000',00000000000001525043),('2024-06-12 23:20:00.000000',00000000000001533033),('2024-06-12 23:25:00.000000',00000000000001534033),('2024-06-12 23:30:00.000000',00000000000001534033),('2024-06-12 23:35:00.000000',00000000000001543933),('2024-06-12 23:40:00.000000',00000000000001555822),('2024-06-12 23:45:00.000000',00000000000001561322),('2024-06-12 23:50:00.000000',00000000000001575712),('2024-06-12 23:55:00.000000',00000000000001579612),('2024-06-13 00:00:00.000000',00000000000001589512),('2024-06-13 00:05:00.000000',00000000000001648202),('2024-06-13 00:10:00.000000',00000000000001659102),('2024-06-13 00:15:00.000000',00000000000001659302),('2024-06-13 00:20:00.000000',00000000000001663292),('2024-06-13 00:25:00.000000',00000000000001665292),('2024-06-13 00:30:00.000000',00000000000001677092),('2024-06-13 00:35:00.000000',00000000000001686492),('2024-06-13 00:40:00.000000',00000000000001702292),('2024-06-13 00:45:00.000000',00000000000001716882),('2024-06-13 00:50:00.000000',00000000000001717882),('2024-06-13 00:55:00.000000',00000000000001721882),('2024-06-13 01:00:00.000000',00000000000001723882),('2024-06-13 01:05:00.000000',00000000000001725882),('2024-06-13 01:10:00.000000',00000000000001737782),('2024-06-13 01:15:00.000000',00000000000001745682),('2024-06-13 01:20:00.000000',00000000000001759452),('2024-06-13 01:25:00.000000',00000000000001766242),('2024-06-13 01:30:00.000000',00000000000001777121),('2024-06-13 01:35:00.000000',00000000000001788800),('2024-06-13 01:40:00.000000',00000000000001798669),('2024-06-13 01:45:00.000000',00000000000001810638),('2024-06-13 01:50:00.000000',00000000000001840418),('2024-06-13 01:55:00.000000',00000000000001852118),('2024-06-13 02:00:00.000000',00000000000001868817),('2024-06-13 02:05:00.000000',00000000000001869817),('2024-06-13 02:10:00.000000',00000000000001881205),('2024-06-13 02:15:00.000000',00000000000001899684),('2024-06-13 02:20:00.000000',00000000000001904674),('2024-06-13 02:25:00.000000',00000000000001924142),('2024-06-13 02:30:00.000000',00000000000001939022),('2024-06-13 02:35:00.000000',00000000000001941022),('2024-06-13 02:40:00.000000',00000000000001943022),('2024-06-13 02:45:00.000000',00000000000001964722),('2024-06-13 02:50:00.000000',00000000000001968611),('2024-06-13 02:55:00.000000',00000000000001973600),('2024-06-13 03:00:00.000000',00000000000001979500),('2024-06-13 03:05:00.000000',00000000000001992389),('2024-06-13 03:10:00.000000',00000000000001998389),('2024-06-13 03:15:00.000000',00000000000002018169),('2024-06-13 03:20:00.000000',00000000000002038959),('2024-06-13 03:25:00.000000',00000000000002057038),('2024-06-13 03:30:00.000000',00000000000002066916),('2024-06-13 03:35:00.000000',00000000000002079816),('2024-06-13 03:40:00.000000',00000000000002087805),('2024-06-13 03:45:00.000000',00000000000002089366),('2024-06-13 03:50:00.000000',00000000000002103256),('2024-06-13 03:55:00.000000',00000000000002114245),('2024-06-13 04:00:00.000000',00000000000002143075),('2024-06-13 04:05:00.000000',00000000000002165753),('2024-06-13 04:10:00.000000',00000000000002190602),('2024-06-13 04:15:00.000000',00000000000002206391),('2024-06-13 04:20:00.000000',00000000000002218771),('2024-06-13 04:25:00.000000',00000000000002269120),('2024-06-13 04:30:00.000000',00000000000002312269),('2024-06-13 04:35:00.000000',00000000000002334059),('2024-06-13 04:40:00.000000',00000000000002348849),('2024-06-13 04:45:00.000000',00000000000002364549),('2024-06-13 04:50:00.000000',00000000000002378449),('2024-06-13 04:55:00.000000',00000000000002397338),('2024-06-13 05:00:00.000000',00000000000002431007),('2024-06-13 05:05:00.000000',00000000000002464864),('2024-06-13 05:10:00.000000',00000000000002478754),('2024-06-13 05:15:00.000000',00000000000002512243),('2024-06-13 05:20:00.000000',00000000000002548232),('2024-06-13 05:25:00.000000',00000000000002564992),('2024-06-13 05:30:00.000000',00000000000002593671),('2024-06-13 05:35:00.000000',00000000000002604461),('2024-06-13 05:40:00.000000',00000000000002615241),('2024-06-13 05:45:00.000000',00000000000002624630),('2024-06-13 05:50:00.000000',00000000000002649189),('2024-06-13 05:55:00.000000',00000000000002652070),('2024-06-13 06:00:00.000000',00000000000002666049),('2024-06-13 06:05:00.000000',00000000000002672928),('2024-06-13 06:10:00.000000',00000000000002694498),('2024-06-13 06:15:00.000000',00000000000002695498),('2024-06-13 06:20:00.000000',00000000000002709298),('2024-06-13 06:25:00.000000',00000000000002723188),('2024-06-13 06:30:00.000000',00000000000002728288),('2024-06-13 06:35:00.000000',00000000000002740178),('2024-06-13 06:40:00.000000',00000000000002779968),('2024-06-13 06:45:00.000000',00000000000002808568),('2024-06-13 06:50:00.000000',00000000000002816468),('2024-06-13 06:55:00.000000',00000000000002908038),('2024-06-13 07:00:00.000000',00000000000002932437),('2024-06-13 07:05:00.000000',00000000000002947817),('2024-06-13 07:10:00.000000',00000000000002964617),('2024-06-13 07:15:00.000000',00000000000002975506),('2024-06-13 07:20:00.000000',00000000000002979506),('2024-06-13 07:25:00.000000',00000000000002984495),('2024-06-13 07:30:00.000000',00000000000003009195),('2024-06-13 07:35:00.000000',00000000000003068675),('2024-06-13 07:40:00.000000',00000000000003083675),('2024-06-13 07:45:00.000000',00000000000003147044),('2024-06-13 07:50:00.000000',00000000000003165043),('2024-06-13 07:55:00.000000',00000000000003192743),('2024-06-13 08:00:00.000000',00000000000003212543),('2024-06-13 08:05:00.000000',00000000000003241422),('2024-06-13 08:10:00.000000',00000000000003274102),('2024-06-13 08:15:00.000000',00000000000003286892),('2024-06-13 08:20:00.000000',00000000000003309380),('2024-06-13 08:25:00.000000',00000000000003324279),('2024-06-13 08:30:00.000000',00000000000003342048),('2024-06-13 08:35:00.000000',00000000000003359905),('2024-06-13 08:40:00.000000',00000000000003378695),('2024-06-13 08:45:00.000000',00000000000003393485),('2024-06-13 08:50:00.000000',00000000000003431864),('2024-06-13 08:55:00.000000',00000000000003443764),('2024-06-13 09:00:00.000000',00000000000003501764),('2024-06-13 09:05:00.000000',00000000000003527011),('2024-06-13 09:10:00.000000',00000000000003534900),('2024-06-13 09:15:00.000000',00000000000003551379),('2024-06-13 09:20:00.000000',00000000000003618057),('2024-06-13 09:25:00.000000',00000000000003648647),('2024-06-13 09:30:00.000000',00000000000003667846),('2024-06-13 09:35:00.000000',00000000000003674896),('2024-06-13 09:40:00.000000',00000000000003692676),('2024-06-13 09:45:00.000000',00000000000003706655),('2024-06-13 09:50:00.000000',00000000000003717555),('2024-06-13 09:55:00.000000',00000000000003723445),('2024-06-13 10:00:00.000000',00000000000003746045),('2024-06-13 10:05:00.000000',00000000000003754945),('2024-06-13 10:10:00.000000',00000000000003763825),('2024-06-13 10:15:00.000000',00000000000003792425),('2024-06-13 10:20:00.000000',00000000000003799315),('2024-06-13 10:25:00.000000',00000000000003810195),('2024-06-13 10:30:00.000000',00000000000003824945),('2024-06-13 10:35:00.000000',00000000000003843714),('2024-06-13 10:40:00.000000',00000000000003867483),('2024-06-13 10:45:00.000000',00000000000003871172),('2024-06-13 10:50:00.000000',00000000000003881061),('2024-06-13 10:55:00.000000',00000000000003928950),('2024-06-13 11:00:00.000000',00000000000003952709),('2024-06-13 11:05:00.000000',00000000000003988993),('2024-06-13 11:10:00.000000',00000000000003994882),('2024-06-13 11:15:00.000000',00000000000004002372),('2024-06-13 11:20:00.000000',00000000000004059572),('2024-06-13 11:25:00.000000',00000000000004084362),('2024-06-13 11:30:00.000000',00000000000004110452),('2024-06-13 11:35:00.000000',00000000000004129232),('2024-06-13 11:40:00.000000',00000000000004143002),('2024-06-13 11:45:00.000000',00000000000004161692),('2024-06-13 11:50:00.000000',00000000000004189181),('2024-06-13 11:55:00.000000',00000000000004242180),('2024-06-13 12:00:00.000000',00000000000004247160),('2024-06-13 12:05:00.000000',00000000000004262159),('2024-06-13 12:10:00.000000',00000000000004279039),('2024-06-13 12:15:00.000000',00000000000004297919),('2024-06-13 12:20:00.000000',00000000000004298909),('2024-06-13 12:25:00.000000',00000000000004302789),('2024-06-13 12:30:00.000000',00000000000004304789),('2024-06-13 12:35:00.000000',00000000000004309779),('2024-06-13 12:40:00.000000',00000000000004305789),('2024-06-13 12:45:00.000000',00000000000004315679),('2024-06-13 12:50:00.000000',00000000000004332679),('2024-06-13 12:55:00.000000',00000000000004344579),('2024-06-13 13:00:00.000000',00000000000004363158),('2024-06-13 13:05:00.000000',00000000000004390928),('2024-06-13 13:10:00.000000',00000000000004428528),('2024-06-13 13:15:00.000000',00000000000004458596),('2024-06-13 13:20:00.000000',00000000000004479286),('2024-06-13 13:25:00.000000',00000000000004500985),('2024-06-13 13:30:00.000000',00000000000004516275),('2024-06-13 13:35:00.000000',00000000000004523764),('2024-06-13 13:40:00.000000',00000000000004567544),('2024-06-13 13:45:00.000000',00000000000004579434),('2024-06-13 13:50:00.000000',00000000000004582424),('2024-06-13 13:55:00.000000',00000000000004590405),('2024-06-13 14:00:00.000000',00000000000004610794),('2024-06-13 14:05:00.000000',00000000000004625772),('2024-06-13 14:10:00.000000',00000000000004643572),('2024-06-13 14:15:00.000000',00000000000004658372),('2024-06-13 14:20:00.000000',00000000000004668252),('2024-06-13 14:25:00.000000',00000000000004678242),('2024-06-13 14:30:00.000000',00000000000004687802),('2024-06-13 14:35:00.000000',00000000000004742272),('2024-06-13 14:40:00.000000',00000000000004748762),('2024-06-13 14:45:00.000000',00000000000004771850),('2024-06-13 14:50:00.000000',00000000000004778750),('2024-06-13 14:55:00.000000',00000000000004786740),('2024-06-13 15:00:00.000000',00000000000004804539),('2024-06-13 15:05:00.000000',00000000000004831438),('2024-06-13 15:10:00.000000',00000000000004871828),('2024-06-13 15:15:00.000000',00000000000004880728),('2024-06-13 15:20:00.000000',00000000000004898897),('2024-06-13 15:25:00.000000',00000000000004935657),('2024-06-13 15:30:00.000000',00000000000004980126),('2024-06-13 15:35:00.000000',00000000000005003916),('2024-06-13 15:40:00.000000',00000000000005018406),('2024-06-13 15:45:00.000000',00000000000005032227),('2024-06-13 15:50:00.000000',00000000000005069627),('2024-06-13 15:55:00.000000',00000000000005115427),('2024-06-13 16:00:00.000000',00000000000000000000),('2024-06-13 16:05:00.000000',00000000000000029490),('2024-06-13 16:10:00.000000',00000000000000095670),('2024-06-13 16:15:00.000000',00000000000000178549),('2024-06-13 16:20:00.000000',00000000000000257327),('2024-06-13 16:25:00.000000',00000000000000279996),('2024-06-13 16:30:00.000000',00000000000000353295),('2024-06-13 16:35:00.000000',00000000000000382374),('2024-06-13 16:40:00.000000',00000000000000421064),('2024-06-13 16:45:00.000000',00000000000000472864),('2024-06-13 16:50:00.000000',00000000000000494653),('2024-06-13 16:55:00.000000',00000000000000507553),('2024-06-13 17:00:00.000000',00000000000000517953),('2024-06-13 17:05:00.000000',00000000000000551543),('2024-06-13 17:10:00.000000',00000000000000572243),('2024-06-13 17:15:00.000000',00000000000000635223),('2024-06-13 17:20:00.000000',00000000000000646203),('2024-06-13 17:25:00.000000',00000000000000661103),('2024-06-13 17:30:00.000000',00000000000000683982),('2024-06-13 17:35:00.000000',00000000000000685393),('2024-06-13 17:40:00.000000',00000000000000775253),('2024-06-13 17:45:00.000000',00000000000000803043),('2024-06-13 17:50:00.000000',00000000000000830543),('2024-06-13 17:55:00.000000',00000000000000855243),('2024-06-13 18:00:00.000000',00000000000000873233),('2024-06-13 18:05:00.000000',00000000000000896933),('2024-06-13 18:10:00.000000',00000000000000914822),('2024-06-13 18:15:00.000000',00000000000000957512),('2024-06-13 18:20:00.000000',00000000000000962412),('2024-06-13 18:25:00.000000',00000000000000980312),('2024-06-13 18:30:00.000000',00000000000000986312),('2024-06-13 18:35:00.000000',00000000000001008012),('2024-06-13 18:40:00.000000',00000000000001065012),('2024-06-13 18:45:00.000000',00000000000001084012),('2024-06-13 18:50:00.000000',00000000000001099902),('2024-06-13 18:55:00.000000',00000000000001113771),('2024-06-13 19:00:00.000000',00000000000001133860),('2024-06-13 19:05:00.000000',00000000000001149749),('2024-06-13 19:10:00.000000',00000000000001193649),('2024-06-13 19:15:00.000000',00000000000001195649),('2024-06-13 19:20:00.000000',00000000000001198649),('2024-06-13 19:25:00.000000',00000000000001216449),('2024-06-13 19:30:00.000000',00000000000001234149),('2024-06-13 19:35:00.000000',00000000000001275937),('2024-06-13 19:40:00.000000',00000000000001276937),('2024-06-13 19:45:00.000000',00000000000001288837),('2024-06-13 19:50:00.000000',00000000000001292836),('2024-06-13 19:55:00.000000',00000000000001293836),('2024-06-13 20:00:00.000000',00000000000001295836),('2024-06-13 20:05:00.000000',00000000000001295836),('2024-06-13 20:10:00.000000',00000000000001300825),('2024-06-13 20:15:00.000000',00000000000001302825),('2024-06-13 20:20:00.000000',00000000000001310725),('2024-06-13 20:25:00.000000',00000000000001309725),('2024-06-13 20:30:00.000000',00000000000001325615),('2024-06-13 20:35:00.000000',00000000000001334615),('2024-06-13 20:40:00.000000',00000000000001351515),('2024-06-13 20:45:00.000000',00000000000001365515),('2024-06-13 20:50:00.000000',00000000000001367515),('2024-06-13 20:55:00.000000',00000000000001377515),('2024-06-13 21:00:00.000000',00000000000001389415),('2024-06-13 21:05:00.000000',00000000000001403415),('2024-06-13 21:10:00.000000',00000000000001429015),('2024-06-13 21:15:00.000000',00000000000001441015),('2024-06-13 21:20:00.000000',00000000000001447005),('2024-06-13 21:25:00.000000',00000000000001456994),('2024-06-13 21:30:00.000000',00000000000001755672),('2024-06-13 21:35:00.000000',00000000000001760530),('2024-06-13 21:40:00.000000',00000000000001767519),('2024-06-13 21:45:00.000000',00000000000001777508),('2024-06-13 21:50:00.000000',00000000000001782408),('2024-06-13 21:55:00.000000',00000000000001783408),('2024-06-13 22:00:00.000000',00000000000001788397),('2024-06-13 22:05:00.000000',00000000000001796386),('2024-06-13 22:10:00.000000',00000000000001802296),('2024-06-13 22:15:00.000000',00000000000001809274),('2024-06-13 22:20:00.000000',00000000000001811274),('2024-06-13 22:25:00.000000',00000000000001822774),('2024-06-13 22:30:00.000000',00000000000001828763),('2024-06-13 22:35:00.000000',00000000000001885563),('2024-06-13 22:40:00.000000',00000000000001899463),('2024-06-13 22:45:00.000000',00000000000001915263),('2024-06-13 22:50:00.000000',00000000000001922052),('2024-06-13 22:55:00.000000',00000000000001939852),('2024-06-13 23:00:00.000000',00000000000001962118),('2024-06-13 23:05:00.000000',00000000000001969997),('2024-06-13 23:10:00.000000',00000000000001974177),('2024-06-13 23:15:00.000000',00000000000001979077),('2024-06-13 23:20:00.000000',00000000000001987034),('2024-06-13 23:25:00.000000',00000000000001999434),('2024-06-13 23:30:00.000000',00000000000002010434),('2024-06-13 23:35:00.000000',00000000000002023324),('2024-06-13 23:40:00.000000',00000000000002030224),('2024-06-13 23:45:00.000000',00000000000002039124),('2024-06-13 23:50:00.000000',00000000000002053024),('2024-06-13 23:55:00.000000',00000000000002057924),('2024-06-14 00:00:00.000000',00000000000002065324),('2024-06-14 00:05:00.000000',00000000000002068424),('2024-06-14 00:10:00.000000',00000000000002081304),('2024-06-14 00:15:00.000000',00000000000002087271),('2024-06-14 00:20:00.000000',00000000000002103117),('2024-06-14 00:25:00.000000',00000000000002128864),('2024-06-14 00:30:00.000000',00000000000002138003),('2024-06-14 00:35:00.000000',00000000000002157863),('2024-06-14 00:40:00.000000',00000000000002166453),('2024-06-14 00:45:00.000000',00000000000002172443),('2024-06-14 00:50:00.000000',00000000000002204732),('2024-06-14 00:55:00.000000',00000000000002229421),('2024-06-14 01:00:00.000000',00000000000002234921),('2024-06-14 01:05:00.000000',00000000000002245921),('2024-06-14 01:10:00.000000',00000000000002248921),('2024-06-14 01:15:00.000000',00000000000002250921),('2024-06-14 01:20:00.000000',00000000000002267811),('2024-06-14 01:25:00.000000',00000000000002282000),('2024-06-14 01:30:00.000000',00000000000002290900),('2024-06-14 01:35:00.000000',00000000000002303400),('2024-06-14 01:40:00.000000',00000000000002315369),('2024-06-14 01:45:00.000000',00000000000002322649),('2024-06-14 01:50:00.000000',00000000000002340607),('2024-06-14 01:55:00.000000',00000000000002354307),('2024-06-14 02:00:00.000000',00000000000002372107),('2024-06-14 02:05:00.000000',00000000000002381087),('2024-06-14 02:10:00.000000',00000000000002393987),('2024-06-14 02:15:00.000000',00000000000002432487),('2024-06-14 02:20:00.000000',00000000000002492166),('2024-06-14 02:25:00.000000',00000000000002521845),('2024-06-14 02:30:00.000000',00000000000002539656),('2024-06-14 02:35:00.000000',00000000000002554456),('2024-06-14 02:40:00.000000',00000000000002560446),('2024-06-14 02:45:00.000000',00000000000002564446),('2024-06-14 02:50:00.000000',00000000000002580246),('2024-06-14 02:55:00.000000',00000000000002591714),('2024-06-14 03:00:00.000000',00000000000002597604),('2024-06-14 03:05:00.000000',00000000000002609404),('2024-06-14 03:10:00.000000',00000000000002612404),('2024-06-14 03:15:00.000000',00000000000002662183),('2024-06-14 03:20:00.000000',00000000000002667183),('2024-06-14 03:25:00.000000',00000000000002675183),('2024-06-14 03:30:00.000000',00000000000002696072),('2024-06-14 03:35:00.000000',00000000000002697983),('2024-06-14 03:40:00.000000',00000000000002698983),('2024-06-14 03:45:00.000000',00000000000002740323),('2024-06-14 03:50:00.000000',00000000000002815283),('2024-06-14 03:55:00.000000',00000000000002882853),('2024-06-14 04:00:00.000000',00000000000002893822),('2024-06-14 04:05:00.000000',00000000000002965281),('2024-06-14 04:10:00.000000',00000000000002964381),('2024-06-14 04:15:00.000000',00000000000003013361),('2024-06-14 04:20:00.000000',00000000000003038230),('2024-06-14 04:25:00.000000',00000000000003057130),('2024-06-14 04:30:00.000000',00000000000003075930),('2024-06-14 04:35:00.000000',00000000000003081920),('2024-06-14 04:40:00.000000',00000000000003098720),('2024-06-14 04:45:00.000000',00000000000003109610),('2024-06-14 04:50:00.000000',00000000000003119510),('2024-06-14 04:55:00.000000',00000000000003131299),('2024-06-14 05:00:00.000000',00000000000003150969),('2024-06-14 05:05:00.000000',00000000000003181509),('2024-06-14 05:10:00.000000',00000000000003232387),('2024-06-14 05:15:00.000000',00000000000003251417),('2024-06-14 05:20:00.000000',00000000000003272575),('2024-06-14 05:25:00.000000',00000000000003298055),('2024-06-14 05:30:00.000000',00000000000003302965),('2024-06-14 05:35:00.000000',00000000000003305965),('2024-06-14 05:40:00.000000',00000000000003313444),('2024-06-14 05:45:00.000000',00000000000003310454),('2024-06-14 05:50:00.000000',00000000000003321920),('2024-06-14 05:55:00.000000',00000000000003327920),('2024-06-14 06:00:00.000000',00000000000003337510),('2024-06-14 06:05:00.000000',00000000000003370889),('2024-06-14 06:10:00.000000',00000000000003384489),('2024-06-14 06:15:00.000000',00000000000003397479),('2024-06-14 06:20:00.000000',00000000000003415259),('2024-06-14 06:25:00.000000',00000000000003433318),('2024-06-14 06:30:00.000000',00000000000003439698),('2024-06-14 06:35:00.000000',00000000000003473618),('2024-06-14 06:40:00.000000',00000000000003506408),('2024-06-14 06:45:00.000000',00000000000003525278),('2024-06-14 06:50:00.000000',00000000000003544037),('2024-06-14 06:55:00.000000',00000000000003559815),('2024-06-14 07:00:00.000000',00000000000003609050),('2024-06-14 07:05:00.000000',00000000000003616650),('2024-06-14 07:10:00.000000',00000000000003641218),('2024-06-14 07:15:00.000000',00000000000003655957),('2024-06-14 07:20:00.000000',00000000000003670423),('2024-06-14 07:25:00.000000',00000000000003683223),('2024-06-14 07:30:00.000000',00000000000003693603),('2024-06-14 07:35:00.000000',00000000000003710079),('2024-06-14 07:40:00.000000',00000000000003730173),('2024-06-14 07:45:00.000000',00000000000003757139),('2024-06-14 07:50:00.000000',00000000000003786287),('2024-06-14 07:55:00.000000',00000000000003826807),('2024-06-14 08:00:00.000000',00000000000003866535),('2024-06-14 08:05:00.000000',00000000000003899305),('2024-06-14 08:10:00.000000',00000000000003917842),('2024-06-14 08:15:00.000000',00000000000003953998),('2024-06-14 08:20:00.000000',00000000000003982266),('2024-06-14 08:25:00.000000',00000000000004003168),('2024-06-14 08:30:00.000000',00000000000004024488),('2024-06-14 08:35:00.000000',00000000000004062488),('2024-06-14 08:40:00.000000',00000000000004071612),('2024-06-14 08:45:00.000000',00000000000004096864),('2024-06-14 08:50:00.000000',00000000000004111692),('2024-06-14 08:55:00.000000',00000000000004134241),('2024-06-14 09:00:00.000000',00000000000004151457),('2024-06-14 09:05:00.000000',00000000000004170911),('2024-06-14 09:10:00.000000',00000000000004186299),('2024-06-14 09:15:00.000000',00000000000004196963),('2024-06-14 09:20:00.000000',00000000000004216405),('2024-06-14 09:25:00.000000',00000000000004227961),('2024-06-14 09:30:00.000000',00000000000004241301),('2024-06-14 09:35:00.000000',00000000000004253865),('2024-06-14 09:40:00.000000',00000000000004253865),('2024-06-14 09:45:00.000000',00000000000004253865),('2024-06-14 09:50:00.000000',00000000000004277092),('2024-06-14 09:55:00.000000',00000000000004312322),('2024-06-14 10:00:00.000000',00000000000004350252),('2024-06-14 10:05:00.000000',00000000000004362830),('2024-06-14 10:10:00.000000',00000000000004387169),('2024-06-14 10:15:00.000000',00000000000004394557),('2024-06-14 10:20:00.000000',00000000000004596309),('2024-06-14 10:25:00.000000',00000000000004609775),('2024-06-14 10:30:00.000000',00000000000004637205),('2024-06-14 10:35:00.000000',00000000000004639482),('2024-06-14 10:40:00.000000',00000000000004652824),('2024-06-14 10:45:00.000000',00000000000004664676),('2024-06-14 10:50:00.000000',00000000000004677228),('2024-06-14 10:55:00.000000',00000000000004687891),('2024-06-14 11:00:00.000000',00000000000004697545),('2024-06-14 11:05:00.000000',00000000000004703923),('2024-06-14 11:10:00.000000',00000000000004723211),('2024-06-14 11:15:00.000000',00000000000004733575),('2024-06-14 11:20:00.000000',00000000000004732251),('2024-06-14 11:25:00.000000',00000000000004736039),('2024-06-14 11:30:00.000000',00000000000004758807),('2024-06-14 11:35:00.000000',00000000000004765473),('2024-06-14 11:40:00.000000',00000000000004781813),('2024-06-14 11:45:00.000000',00000000000004804053),('2024-06-14 11:50:00.000000',00000000000004819141),('2024-06-14 11:55:00.000000',00000000000004842005),('2024-06-14 12:00:00.000000',00000000000004855578),('2024-06-14 12:05:00.000000',00000000000004863354),('2024-06-14 12:10:00.000000',00000000000004874118),('2024-06-14 12:15:00.000000',00000000000004924774),('2024-06-14 12:20:00.000000',00000000000004940429),('2024-06-14 12:25:00.000000',00000000000004957183),('2024-06-14 12:30:00.000000',00000000000004967949),('2024-06-14 12:35:00.000000',00000000000004975349),('2024-06-14 12:40:00.000000',00000000000004997913),('2024-06-14 12:45:00.000000',00000000000005299889),('2024-06-14 12:50:00.000000',00000000000005319055),('2024-06-14 12:55:00.000000',00000000000005330831),('2024-06-14 13:00:00.000000',00000000000005347209),('2024-06-14 13:05:00.000000',00000000000005354873),('2024-06-14 13:10:00.000000',00000000000005359649),('2024-06-14 13:15:00.000000',00000000000005373225),('2024-06-14 13:20:00.000000',00000000000005387779),('2024-06-14 13:25:00.000000',00000000000005407233),('2024-06-14 13:30:00.000000',00000000000005428697),('2024-06-14 13:35:00.000000',00000000000005430572),('2024-06-14 13:40:00.000000',00000000000005587736),('2024-06-14 13:45:00.000000',00000000000005639913),('2024-06-14 13:50:00.000000',00000000000005672221),('2024-06-14 13:55:00.000000',00000000000005704721),('2024-06-14 14:00:00.000000',00000000000005715622),('2024-06-14 14:05:00.000000',00000000000005769780),('2024-06-14 14:10:00.000000',00000000000005787056),('2024-06-14 14:15:00.000000',00000000000005808724),('2024-06-14 14:20:00.000000',00000000000005844199),('2024-06-14 14:25:00.000000',00000000000005892943),('2024-06-14 14:30:00.000000',00000000000005929377),('2024-06-14 14:35:00.000000',00000000000005940353),('2024-06-14 14:40:00.000000',00000000000005950109),('2024-06-14 14:45:00.000000',00000000000005964963),('2024-06-14 14:50:00.000000',00000000000006025895),('2024-06-14 14:55:00.000000',00000000000006038672),('2024-06-14 15:00:00.000000',00000000000006065152),('2024-06-14 15:05:00.000000',00000000000006112383),('2024-06-14 15:10:00.000000',00000000000006153215),('2024-06-14 15:15:00.000000',00000000000006170901),('2024-06-14 15:20:00.000000',00000000000006197567),('2024-06-14 15:25:00.000000',00000000000006230755),('2024-06-14 15:30:00.000000',00000000000006257633),('2024-06-14 15:35:00.000000',00000000000006291375),('2024-06-14 15:40:00.000000',00000000000006323064),('2024-06-14 15:45:00.000000',00000000000006380352),('2024-06-14 15:50:00.000000',00000000000006439028),('2024-06-14 15:55:00.000000',00000000000006505374),('2024-06-14 16:00:00.000000',00000000000000000000),('2024-06-14 16:05:00.000000',00000000000000231589),('2024-06-14 16:10:00.000000',00000000000000321925),('2024-06-14 16:15:00.000000',00000000000000353366),('2024-06-14 16:20:00.000000',00000000000000396045),('2024-06-14 16:25:00.000000',00000000000000445599),('2024-06-14 16:30:00.000000',00000000000000505556),('2024-06-14 16:35:00.000000',00000000000000543214),('2024-06-14 16:40:00.000000',00000000000000586789),('2024-06-14 16:45:00.000000',00000000000000646077),('2024-06-14 16:50:00.000000',00000000000000691143),('2024-06-14 16:55:00.000000',00000000000000752719),('2024-06-14 17:00:00.000000',00000000000000811995),('2024-06-14 17:05:00.000000',00000000000000869260),('2024-06-14 17:10:00.000000',00000000000000916714),('2024-06-14 17:15:00.000000',00000000000000974170),('2024-06-14 17:20:00.000000',00000000000001009848),('2024-06-14 17:25:00.000000',00000000000001049338),('2024-06-14 17:30:00.000000',00000000000001092903),('2024-06-14 17:35:00.000000',00000000000001122603),('2024-06-14 17:40:00.000000',00000000000001160157),('2024-06-14 17:45:00.000000',00000000000001206612),('2024-06-14 17:50:00.000000',00000000000001240400),('2024-06-14 17:55:00.000000',00000000000001268300),('2024-06-14 18:00:00.000000',00000000000001285400),('2024-06-14 18:05:00.000000',00000000000001341876),('2024-06-14 18:10:00.000000',00000000000001374786),('2024-06-14 18:15:00.000000',00000000000001436276),('2024-06-14 18:20:00.000000',00000000000001483154),('2024-06-14 18:25:00.000000',00000000000001538154),('2024-06-14 18:30:00.000000',00000000000001592154),('2024-06-14 18:35:00.000000',00000000000001614032),('2024-06-14 18:40:00.000000',00000000000001642708),('2024-06-14 18:45:00.000000',00000000000001674496),('2024-06-14 18:50:00.000000',00000000000001790174),('2024-06-14 18:55:00.000000',00000000000001821550),('2024-06-14 19:00:00.000000',00000000000001848240),('2024-06-14 19:05:00.000000',00000000000001867640),('2024-06-14 19:10:00.000000',00000000000001887930),('2024-06-14 19:15:00.000000',00000000000001919100),('2024-06-14 19:20:00.000000',00000000000001997869),('2024-06-14 19:25:00.000000',00000000000002028747),('2024-06-14 19:30:00.000000',00000000000002061535),('2024-06-14 19:35:00.000000',00000000000002090335),('2024-06-14 19:40:00.000000',00000000000002111023),('2024-06-14 19:45:00.000000',00000000000002169611),('2024-06-14 19:50:00.000000',00000000000002180611),('2024-06-14 19:55:00.000000',00000000000002203999),('2024-06-14 20:00:00.000000',00000000000002208399),('2024-06-14 20:05:00.000000',00000000000002217399),('2024-06-14 20:10:00.000000',00000000000002225389),('2024-06-14 20:15:00.000000',00000000000002239277),('2024-06-14 20:20:00.000000',00000000000002257177),('2024-06-14 20:25:00.000000',00000000000002283077),('2024-06-14 20:30:00.000000',00000000000002298977),('2024-06-14 20:35:00.000000',00000000000002310765),('2024-06-14 20:40:00.000000',00000000000002322541),('2024-06-14 20:45:00.000000',00000000000002328541),('2024-06-14 20:50:00.000000',00000000000002340441),('2024-06-14 20:55:00.000000',00000000000002347441),('2024-06-14 21:00:00.000000',00000000000002377141),('2024-06-14 21:05:00.000000',00000000000002383141),('2024-06-14 21:10:00.000000',00000000000002390141),('2024-06-14 21:15:00.000000',00000000000002393029),('2024-06-14 21:20:00.000000',00000000000002402817),('2024-06-14 21:25:00.000000',00000000000002412717),('2024-06-14 21:30:00.000000',00000000000002422617),('2024-06-14 21:35:00.000000',00000000000002429117),('2024-06-14 21:40:00.000000',00000000000002438117),('2024-06-14 21:45:00.000000',00000000000002446917),('2024-06-14 21:50:00.000000',00000000000002455917),('2024-06-14 21:55:00.000000',00000000000002466906),('2024-06-14 22:00:00.000000',00000000000002474906),('2024-06-14 22:05:00.000000',00000000000002497706),('2024-06-14 22:10:00.000000',00000000000002505606),('2024-06-14 22:15:00.000000',00000000000002512494),('2024-06-14 22:20:00.000000',00000000000002522494),('2024-06-14 22:25:00.000000',00000000000002533070),('2024-06-14 22:30:00.000000',00000000000002543070),('2024-06-14 22:35:00.000000',00000000000002561070),('2024-06-14 22:40:00.000000',00000000000002567958),('2024-06-14 22:45:00.000000',00000000000002575836),('2024-06-14 22:50:00.000000',00000000000002596736),('2024-06-14 22:55:00.000000',00000000000002618426),('2024-06-14 23:00:00.000000',00000000000002637216),('2024-06-14 23:05:00.000000',00000000000002647195),('2024-06-14 23:10:00.000000',00000000000002661685),('2024-06-14 23:15:00.000000',00000000000002679573),('2024-06-14 23:20:00.000000',00000000000002689473),('2024-06-14 23:25:00.000000',00000000000002714362),('2024-06-14 23:30:00.000000',00000000000002736829),('2024-06-14 23:35:00.000000',00000000000002757484),('2024-06-14 23:40:00.000000',00000000000002791174),('2024-06-14 23:45:00.000000',00000000000002801938),('2024-06-14 23:50:00.000000',00000000000002838268),('2024-06-14 23:55:00.000000',00000000000002859825),('2024-06-15 00:00:00.000000',00000000000002883507),('2024-06-15 00:05:00.000000',00000000000002897407),('2024-06-15 00:10:00.000000',00000000000002915197),('2024-06-15 00:15:00.000000',00000000000002936761),('2024-06-15 00:20:00.000000',00000000000002959427),('2024-06-15 00:25:00.000000',00000000000002982879),('2024-06-15 00:30:00.000000',00000000000003009579),('2024-06-15 00:35:00.000000',00000000000003032835),('2024-06-15 00:40:00.000000',00000000000003052264),('2024-06-15 00:45:00.000000',00000000000003056152),('2024-06-15 00:50:00.000000',00000000000003063928),('2024-06-15 00:55:00.000000',00000000000003091256),('2024-06-15 01:00:00.000000',00000000000003113811),('2024-06-15 01:05:00.000000',00000000000003130588),('2024-06-15 01:10:00.000000',00000000000003153137),('2024-06-15 01:15:00.000000',00000000000003164024),('2024-06-15 01:20:00.000000',00000000000003182777),('2024-06-15 01:25:00.000000',00000000000003212231),('2024-06-15 01:30:00.000000',00000000000003246664),('2024-06-15 01:35:00.000000',00000000000003259452),('2024-06-15 01:40:00.000000',00000000000003284828),('2024-06-15 01:45:00.000000',00000000000003292828),('2024-06-15 01:50:00.000000',00000000000003306706),('2024-06-15 01:55:00.000000',00000000000003331606),('2024-06-15 02:00:00.000000',00000000000003350282),('2024-06-15 02:05:00.000000',00000000000003385747),('2024-06-15 02:10:00.000000',00000000000003424335),('2024-06-15 02:15:00.000000',00000000000003442835),('2024-06-15 02:20:00.000000',00000000000003450835),('2024-06-15 02:25:00.000000',00000000000003513111),('2024-06-15 02:30:00.000000',00000000000003534101),('2024-06-15 02:35:00.000000',00000000000003585948),('2024-06-15 02:40:00.000000',00000000000003595848),('2024-06-15 02:45:00.000000',00000000000003613648),('2024-06-15 02:50:00.000000',00000000000003638000),('2024-06-15 02:55:00.000000',00000000000003660333),('2024-06-15 03:00:00.000000',00000000000003682787),('2024-06-15 03:05:00.000000',00000000000003695266),('2024-06-15 03:10:00.000000',00000000000003711954),('2024-06-15 03:15:00.000000',00000000000003731542),('2024-06-15 03:20:00.000000',00000000000003758230),('2024-06-15 03:25:00.000000',00000000000003778874),('2024-06-15 03:30:00.000000',00000000000003842642),('2024-06-15 03:35:00.000000',00000000000003856732),('2024-06-15 03:40:00.000000',00000000000003890470),('2024-06-15 03:45:00.000000',00000000000003933349),('2024-06-15 03:50:00.000000',00000000000003951037),('2024-06-15 03:55:00.000000',00000000000003973693),('2024-06-15 04:00:00.000000',00000000000004012511),('2024-06-15 04:05:00.000000',00000000000004041620),('2024-06-15 04:10:00.000000',00000000000004063941),('2024-06-15 04:15:00.000000',00000000000004100755),('2024-06-15 04:20:00.000000',00000000000004134685),('2024-06-15 04:25:00.000000',00000000000004240049),('2024-06-15 04:30:00.000000',00000000000004263716),('2024-06-15 04:35:00.000000',00000000000004273492),('2024-06-15 04:40:00.000000',00000000000004303936),('2024-06-15 04:45:00.000000',00000000000004335564),('2024-06-15 04:50:00.000000',00000000000004454504),('2024-06-15 04:55:00.000000',00000000000004495748),('2024-06-15 05:00:00.000000',00000000000004514536),('2024-06-15 05:05:00.000000',00000000000004556804),('2024-06-15 05:10:00.000000',00000000000004590574),('2024-06-15 05:15:00.000000',00000000000004655704),('2024-06-15 05:20:00.000000',00000000000004667168),('2024-06-15 05:25:00.000000',00000000000004707210),('2024-06-15 05:30:00.000000',00000000000004748110),('2024-06-15 05:35:00.000000',00000000000004768619),('2024-06-15 05:40:00.000000',00000000000004806581),('2024-06-15 05:45:00.000000',00000000000004833901),('2024-06-15 05:50:00.000000',00000000000004871907),('2024-06-15 05:55:00.000000',00000000000004892247),('2024-06-15 06:00:00.000000',00000000000004921801),('2024-06-15 06:05:00.000000',00000000000004934865),('2024-06-15 06:10:00.000000',00000000000004982563),('2024-06-15 06:15:00.000000',00000000000004998231),('2024-06-15 06:20:00.000000',00000000000005020847),('2024-06-15 06:25:00.000000',00000000000005039152),('2024-06-15 06:30:00.000000',00000000000005218461),('2024-06-15 06:35:00.000000',00000000000005258659),('2024-06-15 06:40:00.000000',00000000000005300875),('2024-06-15 06:45:00.000000',00000000000005310540),('2024-06-15 06:50:00.000000',00000000000005364033),('2024-06-15 06:55:00.000000',00000000000005372002),('2024-06-15 07:00:00.000000',00000000000005377890),('2024-06-15 07:05:00.000000',00000000000005410618),('2024-06-15 07:10:00.000000',00000000000005442770),('2024-06-15 07:15:00.000000',00000000000005465060),('2024-06-15 07:20:00.000000',00000000000005478602),('2024-06-15 07:25:00.000000',00000000000005512331),('2024-06-15 07:30:00.000000',00000000000005548171),('2024-06-15 07:35:00.000000',00000000000005684537),('2024-06-15 07:40:00.000000',00000000000005692313),('2024-06-15 07:45:00.000000',00000000000005700303),('2024-06-15 07:50:00.000000',00000000000005715979),('2024-06-15 07:55:00.000000',00000000000005717855),('2024-06-15 08:00:00.000000',00000000000005737531),('2024-06-15 08:05:00.000000',00000000000005745431),('2024-06-15 08:10:00.000000',00000000000006043917),('2024-06-15 08:15:00.000000',00000000000006061683),('2024-06-15 08:20:00.000000',00000000000006076448),('2024-06-15 08:25:00.000000',00000000000006094077),('2024-06-15 08:30:00.000000',00000000000006037632),('2024-06-15 08:35:00.000000',00000000000006064960),('2024-06-15 08:40:00.000000',00000000000006108654),('2024-06-15 08:45:00.000000',00000000000006148276),('2024-06-15 08:50:00.000000',00000000000006162044),('2024-06-15 08:55:00.000000',00000000000006198353),('2024-06-15 09:00:00.000000',00000000000006208017),('2024-06-15 09:05:00.000000',00000000000006219817),('2024-06-15 09:10:00.000000',00000000000006230706),('2024-06-15 09:15:00.000000',00000000000006262936),('2024-06-15 09:20:00.000000',00000000000006299740),('2024-06-15 09:25:00.000000',00000000000006342579),('2024-06-15 09:30:00.000000',00000000000006366020),('2024-06-15 09:35:00.000000',00000000000006374920),('2024-06-15 09:40:00.000000',00000000000006384595),('2024-06-15 09:45:00.000000',00000000000006391371),('2024-06-15 09:50:00.000000',00000000000006394371),('2024-06-15 09:55:00.000000',00000000000006409935),('2024-06-15 10:00:00.000000',00000000000006418701),('2024-06-15 10:05:00.000000',00000000000006440479),('2024-06-15 10:10:00.000000',00000000000006464743),('2024-06-15 10:15:00.000000',00000000000006491921),('2024-06-15 10:20:00.000000',00000000000006504597),('2024-06-15 10:25:00.000000',00000000000006538075),('2024-06-15 10:30:00.000000',00000000000006579216),('2024-06-15 10:35:00.000000',00000000000006641406),('2024-06-15 10:40:00.000000',00000000000006668171),('2024-06-15 10:45:00.000000',00000000000006759971),('2024-06-15 10:50:00.000000',00000000000006777659),('2024-06-15 10:55:00.000000',00000000000006792447),('2024-06-15 11:00:00.000000',00000000000006815011),('2024-06-15 11:05:00.000000',00000000000006841575),('2024-06-15 11:10:00.000000',00000000000006857263),('2024-06-15 11:15:00.000000',00000000000006870151),('2024-06-15 11:20:00.000000',00000000000006886907),('2024-06-15 11:25:00.000000',00000000000006899785),('2024-06-15 11:30:00.000000',00000000000006917573),('2024-06-15 11:35:00.000000',00000000000006926473),('2024-06-15 11:40:00.000000',00000000000006945363),('2024-06-15 11:45:00.000000',00000000000006965140),('2024-06-15 11:50:00.000000',00000000000006988828),('2024-06-15 11:55:00.000000',00000000000006996616),('2024-06-15 12:00:00.000000',00000000000007005718),('2024-06-15 12:05:00.000000',00000000000007028518),('2024-06-15 12:10:00.000000',00000000000007040296),('2024-06-15 12:15:00.000000',00000000000007046184),('2024-06-15 12:20:00.000000',00000000000007053774),('2024-06-15 12:25:00.000000',00000000000007062651),('2024-06-15 12:30:00.000000',00000000000007082407),('2024-06-15 12:35:00.000000',00000000000007103107),('2024-06-15 12:40:00.000000',00000000000007118572),('2024-06-15 12:45:00.000000',00000000000007126472),('2024-06-15 12:50:00.000000',00000000000007140150),('2024-06-15 12:55:00.000000',00000000000007163694),('2024-06-15 13:00:00.000000',00000000000007181462),('2024-06-15 13:05:00.000000',00000000000007205038),('2024-06-15 13:10:00.000000',00000000000007232914),('2024-06-15 13:15:00.000000',00000000000007256604),('2024-06-15 13:20:00.000000',00000000000007276404),('2024-06-15 13:25:00.000000',00000000000007287060),('2024-06-15 13:30:00.000000',00000000000007316638),('2024-06-15 13:35:00.000000',00000000000007337726),('2024-06-15 13:40:00.000000',00000000000007357316),('2024-06-15 13:45:00.000000',00000000000007389474),('2024-06-15 13:50:00.000000',00000000000007404274),('2024-06-15 13:55:00.000000',00000000000007417364),('2024-06-15 14:00:00.000000',00000000000007425264),('2024-06-15 14:05:00.000000',00000000000007443252),('2024-06-15 14:10:00.000000',00000000000007475828),('2024-06-15 14:15:00.000000',00000000000007769516),('2024-06-15 14:20:00.000000',00000000000007775405),('2024-06-15 14:25:00.000000',00000000000007801072),('2024-06-15 14:30:00.000000',00000000000007834527),('2024-06-15 14:35:00.000000',00000000000007860416),('2024-06-15 14:40:00.000000',00000000000007930086),('2024-06-15 14:45:00.000000',00000000000007941564),('2024-06-15 14:50:00.000000',00000000000007996706),('2024-06-15 14:55:00.000000',00000000000008034163),('2024-06-15 15:00:00.000000',00000000000008068415),('2024-06-15 15:05:00.000000',00000000000008097323),('2024-06-15 15:10:00.000000',00000000000008124177),('2024-06-15 15:15:00.000000',00000000000008153934),('2024-06-15 15:20:00.000000',00000000000008185112),('2024-06-15 15:25:00.000000',00000000000008224688),('2024-06-15 15:30:00.000000',00000000000008356168),('2024-06-15 15:35:00.000000',00000000000008439645),('2024-06-15 15:40:00.000000',00000000000008459514),('2024-06-15 15:45:00.000000',00000000000008473414),('2024-06-15 15:50:00.000000',00000000000008495002),('2024-06-15 15:55:00.000000',00000000000008540866),('2024-06-15 16:00:00.000000',00000000000000000000),('2024-06-15 16:05:00.000000',00000000000000329900),('2024-06-15 16:10:00.000000',00000000000000373380),('2024-06-15 16:15:00.000000',00000000000000434203),('2024-06-15 16:20:00.000000',00000000000000457503),('2024-06-15 16:25:00.000000',00000000000000509892),('2024-06-15 16:30:00.000000',00000000000000556382),('2024-06-15 16:35:00.000000',00000000000000604962),('2024-06-15 16:40:00.000000',00000000000000663229),('2024-06-15 16:45:00.000000',00000000000000696908),('2024-06-15 16:50:00.000000',00000000000000783064),('2024-06-15 16:55:00.000000',00000000000000811343),('2024-06-15 17:00:00.000000',00000000000000833432),('2024-06-15 17:05:00.000000',00000000000000853922),('2024-06-15 17:10:00.000000',00000000000000899991),('2024-06-15 17:15:00.000000',00000000000000925781),('2024-06-15 17:20:00.000000',00000000000000996281),('2024-06-15 17:25:00.000000',00000000000001016960),('2024-06-15 17:30:00.000000',00000000000001060560),('2024-06-15 17:35:00.000000',00000000000001077439),('2024-06-15 17:40:00.000000',00000000000001120418),('2024-06-15 17:45:00.000000',00000000000001173996),('2024-06-15 17:50:00.000000',00000000000001209986),('2024-06-15 17:55:00.000000',00000000000001236774),('2024-06-15 18:00:00.000000',00000000000001271274),('2024-06-15 18:05:00.000000',00000000000001359474),('2024-06-15 18:10:00.000000',00000000000001382454),('2024-06-15 18:15:00.000000',00000000000001390254),('2024-06-15 18:20:00.000000',00000000000001424813),('2024-06-15 18:25:00.000000',00000000000001434803),('2024-06-15 18:30:00.000000',00000000000001472871),('2024-06-15 18:35:00.000000',00000000000001495471),('2024-06-15 18:40:00.000000',00000000000001516371),('2024-06-15 18:45:00.000000',00000000000001577139),('2024-06-15 18:50:00.000000',00000000000001586129),('2024-06-15 18:55:00.000000',00000000000001603029),('2024-06-15 19:00:00.000000',00000000000001614729),('2024-06-15 19:05:00.000000',00000000000001630429),('2024-06-15 19:10:00.000000',00000000000001646107),('2024-06-15 19:15:00.000000',00000000000001666907),('2024-06-15 19:20:00.000000',00000000000001673607),('2024-06-15 19:25:00.000000',00000000000001684107),('2024-06-15 19:30:00.000000',00000000000001693086),('2024-06-15 19:35:00.000000',00000000000001727755),('2024-06-15 19:40:00.000000',00000000000001748655),('2024-06-15 19:45:00.000000',00000000000001764555),('2024-06-15 19:50:00.000000',00000000000001790245),('2024-06-15 19:55:00.000000',00000000000001795245),('2024-06-15 20:00:00.000000',00000000000001812145),('2024-06-15 20:05:00.000000',00000000000001844645),('2024-06-15 20:10:00.000000',00000000000001863313),('2024-06-15 20:15:00.000000',00000000000001883313),('2024-06-15 20:20:00.000000',00000000000001904013),('2024-06-15 20:25:00.000000',00000000000001925602),('2024-06-15 20:30:00.000000',00000000000001941701),('2024-06-15 20:35:00.000000',00000000000001968377),('2024-06-15 20:40:00.000000',00000000000001974377),('2024-06-15 20:45:00.000000',00000000000001976377),('2024-06-15 20:50:00.000000',00000000000001994277),('2024-06-15 20:55:00.000000',00000000000001999277),('2024-06-15 21:00:00.000000',00000000000002006267),('2024-06-15 21:05:00.000000',00000000000002008267),('2024-06-15 21:10:00.000000',00000000000002021167),('2024-06-15 21:15:00.000000',00000000000002026067),('2024-06-15 21:20:00.000000',00000000000002032067),('2024-06-15 21:25:00.000000',00000000000002036067),('2024-06-15 21:30:00.000000',00000000000002043067),('2024-06-15 21:35:00.000000',00000000000002061957),('2024-06-15 21:40:00.000000',00000000000002083657),('2024-06-15 21:45:00.000000',00000000000002101457),('2024-06-15 21:50:00.000000',00000000000002115357),('2024-06-15 21:55:00.000000',00000000000002130145),('2024-06-15 22:00:00.000000',00000000000002133745),('2024-06-15 22:05:00.000000',00000000000002142725),('2024-06-15 22:10:00.000000',00000000000002160513),('2024-06-15 22:15:00.000000',00000000000002171113),('2024-06-15 22:20:00.000000',00000000000002178889),('2024-06-15 22:25:00.000000',00000000000002197001),('2024-06-15 22:30:00.000000',00000000000002204981),('2024-06-15 22:35:00.000000',00000000000002227671),('2024-06-15 22:40:00.000000',00000000000002248471),('2024-06-15 22:45:00.000000',00000000000002294371),('2024-06-15 22:50:00.000000',00000000000002356171),('2024-06-15 22:55:00.000000',00000000000002362171),('2024-06-15 23:00:00.000000',00000000000002377740),('2024-06-15 23:05:00.000000',00000000000002383740),('2024-06-15 23:10:00.000000',00000000000002409040),('2024-06-15 23:15:00.000000',00000000000002423930),('2024-06-15 23:20:00.000000',00000000000002449630),('2024-06-15 23:25:00.000000',00000000000002470030),('2024-06-15 23:30:00.000000',00000000000002483920),('2024-06-15 23:35:00.000000',00000000000002493520),('2024-06-15 23:40:00.000000',00000000000002557810),('2024-06-15 23:45:00.000000',00000000000002569698),('2024-06-15 23:50:00.000000',00000000000002580586),('2024-06-15 23:55:00.000000',00000000000002603374),('2024-06-16 00:00:00.000000',00000000000002632074),('2024-06-16 00:05:00.000000',00000000000002676354),('2024-06-16 00:10:00.000000',00000000000002708011),('2024-06-16 00:15:00.000000',00000000000002735899),('2024-06-16 00:20:00.000000',00000000000002800367),('2024-06-16 00:25:00.000000',00000000000002826255),('2024-06-16 00:30:00.000000',00000000000002845525),('2024-06-16 00:35:00.000000',00000000000002863315),('2024-06-16 00:40:00.000000',00000000000002877115),('2024-06-16 00:45:00.000000',00000000000002884115),('2024-06-16 00:50:00.000000',00000000000002907892),('2024-06-16 00:55:00.000000',00000000000002930747),('2024-06-16 01:00:00.000000',00000000000002950537),('2024-06-16 01:05:00.000000',00000000000002980404),('2024-06-16 01:10:00.000000',00000000000003005883),('2024-06-16 01:15:00.000000',00000000000003050452),('2024-06-16 01:20:00.000000',00000000000003120952),('2024-06-16 01:25:00.000000',00000000000003143751),('2024-06-16 01:30:00.000000',00000000000003157331),('2024-06-16 01:35:00.000000',00000000000003168331),('2024-06-16 01:40:00.000000',00000000000003200090),('2024-06-16 01:45:00.000000',00000000000003214078),('2024-06-16 01:50:00.000000',00000000000003237767),('2024-06-16 01:55:00.000000',00000000000003249567),('2024-06-16 02:00:00.000000',00000000000003260245),('2024-06-16 02:05:00.000000',00000000000003287645),('2024-06-16 02:10:00.000000',00000000000003295245),('2024-06-16 02:15:00.000000',00000000000003312945),('2024-06-16 02:20:00.000000',00000000000003324645),('2024-06-16 02:25:00.000000',00000000000003343424),('2024-06-16 02:30:00.000000',00000000000003379102),('2024-06-16 02:35:00.000000',00000000000003383902),('2024-06-16 02:40:00.000000',00000000000003410692),('2024-06-16 02:45:00.000000',00000000000003426692),('2024-06-16 02:50:00.000000',00000000000003454168),('2024-06-16 02:55:00.000000',00000000000003463157),('2024-06-16 03:00:00.000000',00000000000003484857),('2024-06-16 03:05:00.000000',00000000000003497747),('2024-06-16 03:10:00.000000',00000000000003522445),('2024-06-16 03:15:00.000000',00000000000003538823),('2024-06-16 03:20:00.000000',00000000000003558985),('2024-06-16 03:25:00.000000',00000000000003593552),('2024-06-16 03:30:00.000000',00000000000003601430),('2024-06-16 03:35:00.000000',00000000000003616918),('2024-06-16 03:40:00.000000',00000000000003633584),('2024-06-16 03:45:00.000000',00000000000003643484),('2024-06-16 03:50:00.000000',00000000000003659815),('2024-06-16 03:55:00.000000',00000000000003688070),('2024-06-16 04:00:00.000000',00000000000003698724),('2024-06-16 04:05:00.000000',00000000000003705512),('2024-06-16 04:10:00.000000',00000000000003727056),('2024-06-16 04:15:00.000000',00000000000003734844),('2024-06-16 04:20:00.000000',00000000000003746742),('2024-06-16 04:25:00.000000',00000000000003765210),('2024-06-16 04:30:00.000000',00000000000003783688),('2024-06-16 04:35:00.000000',00000000000003801444),('2024-06-16 04:40:00.000000',00000000000003819224),('2024-06-16 04:45:00.000000',00000000000003833512),('2024-06-16 04:50:00.000000',00000000000003836400),('2024-06-16 04:55:00.000000',00000000000003841288),('2024-06-16 05:00:00.000000',00000000000003860931),('2024-06-16 05:05:00.000000',00000000000003875608),('2024-06-16 05:10:00.000000',00000000000003890208),('2024-06-16 05:15:00.000000',00000000000003915896),('2024-06-16 05:20:00.000000',00000000000003928796),('2024-06-16 05:25:00.000000',00000000000003940562),('2024-06-16 05:30:00.000000',00000000000003955462),('2024-06-16 05:35:00.000000',00000000000003966362),('2024-06-16 05:40:00.000000',00000000000003975262),('2024-06-16 05:45:00.000000',00000000000004013662),('2024-06-16 05:50:00.000000',00000000000004066362),('2024-06-16 05:55:00.000000',00000000000004076239),('2024-06-16 06:00:00.000000',00000000000004134828),('2024-06-16 06:05:00.000000',00000000000004169295),('2024-06-16 06:10:00.000000',00000000000004209548),('2024-06-16 06:15:00.000000',00000000000004239023),('2024-06-16 06:20:00.000000',00000000000004246812),('2024-06-16 06:25:00.000000',00000000000004274500),('2024-06-16 06:30:00.000000',00000000000004282400),('2024-06-16 06:35:00.000000',00000000000004292278),('2024-06-16 06:40:00.000000',00000000000004296278),('2024-06-16 06:45:00.000000',00000000000004314066),('2024-06-16 06:50:00.000000',00000000000004317066),('2024-06-16 06:55:00.000000',00000000000004320066),('2024-06-16 07:00:00.000000',00000000000004338733),('2024-06-16 07:05:00.000000',00000000000004344732),('2024-06-16 07:10:00.000000',00000000000004418620),('2024-06-16 07:15:00.000000',00000000000004424520),('2024-06-16 07:20:00.000000',00000000000004440099),('2024-06-16 07:25:00.000000',00000000000004456489),('2024-06-16 07:30:00.000000',00000000000004484089),('2024-06-16 07:35:00.000000',00000000000004508676),('2024-06-16 07:40:00.000000',00000000000004563476),('2024-06-16 07:45:00.000000',00000000000004589964),('2024-06-16 07:50:00.000000',00000000000004601763),('2024-06-16 07:55:00.000000',00000000000004617452),('2024-06-16 08:00:00.000000',00000000000004642152),('2024-06-16 08:05:00.000000',00000000000004654052),('2024-06-16 08:10:00.000000',00000000000004669718),('2024-06-16 08:15:00.000000',00000000000004702418),('2024-06-16 08:20:00.000000',00000000000004720297),('2024-06-16 08:25:00.000000',00000000000004729097),('2024-06-16 08:30:00.000000',00000000000004733097),('2024-06-16 08:35:00.000000',00000000000004739097),('2024-06-16 08:40:00.000000',00000000000004753697),('2024-06-16 08:45:00.000000',00000000000004775487),('2024-06-16 08:50:00.000000',00000000000004813866),('2024-06-16 08:55:00.000000',00000000000004831426),('2024-06-16 09:00:00.000000',00000000000004858904),('2024-06-16 09:05:00.000000',00000000000004879680),('2024-06-16 09:10:00.000000',00000000000004901470),('2024-06-16 09:15:00.000000',00000000000004903460),('2024-06-16 09:20:00.000000',00000000000004912338),('2024-06-16 09:25:00.000000',00000000000004921318),('2024-06-16 09:30:00.000000',00000000000004929018),('2024-06-16 09:35:00.000000',00000000000004937918),('2024-06-16 09:40:00.000000',00000000000004950706),('2024-06-16 09:45:00.000000',00000000000005261161),('2024-06-16 09:50:00.000000',00000000000005283929),('2024-06-16 09:55:00.000000',00000000000005304698),('2024-06-16 10:00:00.000000',00000000000005316586),('2024-06-16 10:05:00.000000',00000000000005328476),('2024-06-16 10:10:00.000000',00000000000005337366),('2024-06-16 10:15:00.000000',00000000000005330446),('2024-06-16 10:20:00.000000',00000000000005326456),('2024-06-16 10:25:00.000000',00000000000005346256),('2024-06-16 10:30:00.000000',00000000000005362646),('2024-06-16 10:35:00.000000',00000000000005369446),('2024-06-16 10:40:00.000000',00000000000005373346),('2024-06-16 10:45:00.000000',00000000000005385246),('2024-06-16 10:50:00.000000',00000000000005383446),('2024-06-16 10:55:00.000000',00000000000005409125),('2024-06-16 11:00:00.000000',00000000000005438725),('2024-06-16 11:05:00.000000',00000000000005443604),('2024-06-16 11:10:00.000000',00000000000005455404),('2024-06-16 11:15:00.000000',00000000000005472083),('2024-06-16 11:20:00.000000',00000000000005472083),('2024-06-16 11:25:00.000000',00000000000005487883),('2024-06-16 11:30:00.000000',00000000000005501783),('2024-06-16 11:35:00.000000',00000000000005506771),('2024-06-16 11:40:00.000000',00000000000005526551),('2024-06-16 11:45:00.000000',00000000000005543330),('2024-06-16 11:50:00.000000',00000000000005554220),('2024-06-16 11:55:00.000000',00000000000005571310),('2024-06-16 12:00:00.000000',00000000000005586110),('2024-06-16 12:05:00.000000',00000000000005591010),('2024-06-16 12:10:00.000000',00000000000005599911),('2024-06-16 12:15:00.000000',00000000000005619710),('2024-06-16 12:20:00.000000',00000000000005626610),('2024-06-16 12:25:00.000000',00000000000005645310),('2024-06-16 12:30:00.000000',00000000000005677789),('2024-06-16 12:35:00.000000',00000000000005678789),('2024-06-16 12:40:00.000000',00000000000005689589),('2024-06-16 12:45:00.000000',00000000000005689589),('2024-06-16 12:50:00.000000',00000000000005705379),('2024-06-16 12:55:00.000000',00000000000005711079),('2024-06-16 13:00:00.000000',00000000000005759948),('2024-06-16 13:05:00.000000',00000000000005780748),('2024-06-16 13:10:00.000000',00000000000005809396),('2024-06-16 13:15:00.000000',00000000000005822164),('2024-06-16 13:20:00.000000',00000000000005834654),('2024-06-16 13:25:00.000000',00000000000005841644),('2024-06-16 13:30:00.000000',00000000000005853933),('2024-06-16 13:35:00.000000',00000000000005868712),('2024-06-16 13:40:00.000000',00000000000005905333),('2024-06-16 13:45:00.000000',00000000000005943633),('2024-06-16 13:50:00.000000',00000000000005975323),('2024-06-16 13:55:00.000000',00000000000005986212),('2024-06-16 14:00:00.000000',00000000000006031368),('2024-06-16 14:05:00.000000',00000000000006072935),('2024-06-16 14:10:00.000000',00000000000006089714),('2024-06-16 14:15:00.000000',00000000000006141027),('2024-06-16 14:20:00.000000',00000000000006172683),('2024-06-16 14:25:00.000000',00000000000006187562),('2024-06-16 14:30:00.000000',00000000000006234950),('2024-06-16 14:35:00.000000',00000000000006255849),('2024-06-16 14:40:00.000000',00000000000006352137),('2024-06-16 14:45:00.000000',00000000000006423174),('2024-06-16 14:50:00.000000',00000000000006454864),('2024-06-16 14:55:00.000000',00000000000006473754),('2024-06-16 15:00:00.000000',00000000000006495543),('2024-06-16 15:05:00.000000',00000000000006547589),('2024-06-16 15:10:00.000000',00000000000006553079),('2024-06-16 15:15:00.000000',00000000000006602144),('2024-06-16 15:20:00.000000',00000000000006622280),('2024-06-16 15:25:00.000000',00000000000006693679),('2024-06-16 15:30:00.000000',00000000000006723354),('2024-06-16 15:35:00.000000',00000000000006736254),('2024-06-16 15:40:00.000000',00000000000006769021),('2024-06-16 15:45:00.000000',00000000000006788921),('2024-06-16 15:50:00.000000',00000000000006805721),('2024-06-16 15:55:00.000000',00000000000006829311),('2024-06-16 16:00:00.000000',00000000000000000000),('2024-06-16 16:05:00.000000',00000000000000026788),('2024-06-16 16:10:00.000000',00000000000000056367),('2024-06-16 16:15:00.000000',00000000000000067136),('2024-06-16 16:20:00.000000',00000000000000084936),('2024-06-16 16:25:00.000000',00000000000000095625),('2024-06-16 16:30:00.000000',00000000000000123314),('2024-06-16 16:35:00.000000',00000000000000142914),('2024-06-16 16:40:00.000000',00000000000000179093),('2024-06-16 16:45:00.000000',00000000000000203692),('2024-06-16 16:50:00.000000',00000000000000254489),('2024-06-16 16:55:00.000000',00000000000000278658),('2024-06-16 17:00:00.000000',00000000000000296426),('2024-06-16 17:05:00.000000',00000000000000309337),('2024-06-16 17:10:00.000000',00000000000000321337),('2024-06-16 17:15:00.000000',00000000000000493236),('2024-06-16 17:20:00.000000',00000000000000515573),('2024-06-16 17:25:00.000000',00000000000000561729),('2024-06-16 17:30:00.000000',00000000000000872329),('2024-06-16 17:35:00.000000',00000000000000902986),('2024-06-16 17:40:00.000000',00000000000000919774),('2024-06-16 17:45:00.000000',00000000000000948539),('2024-06-16 17:50:00.000000',00000000000000963339),('2024-06-16 17:55:00.000000',00000000000000968739),('2024-06-16 18:00:00.000000',00000000000001002307),('2024-06-16 18:05:00.000000',00000000000001071057),('2024-06-16 18:10:00.000000',00000000000001090824),('2024-06-16 18:15:00.000000',00000000000001110602),('2024-06-16 18:20:00.000000',00000000000001118502),('2024-06-16 18:25:00.000000',00000000000001156102),('2024-06-16 18:30:00.000000',00000000000001172902),('2024-06-16 18:35:00.000000',00000000000001198692),('2024-06-16 18:40:00.000000',00000000000001231192),('2024-06-16 18:45:00.000000',00000000000001255992),('2024-06-16 18:50:00.000000',00000000000001267291),('2024-06-16 18:55:00.000000',00000000000001278791),('2024-06-16 19:00:00.000000',00000000000001287791),('2024-06-16 19:05:00.000000',00000000000001302590),('2024-06-16 19:10:00.000000',00000000000001328590),('2024-06-16 19:15:00.000000',00000000000001361390),('2024-06-16 19:20:00.000000',00000000000001381379),('2024-06-16 19:25:00.000000',00000000000001408369),('2024-06-16 19:30:00.000000',00000000000001421357),('2024-06-16 19:35:00.000000',00000000000001437357),('2024-06-16 19:40:00.000000',00000000000001496757),('2024-06-16 19:45:00.000000',00000000000001519847),('2024-06-16 19:50:00.000000',00000000000001548845),('2024-06-16 19:55:00.000000',00000000000001589845),('2024-06-16 20:00:00.000000',00000000000001650834),('2024-06-16 20:05:00.000000',00000000000001717623),('2024-06-16 20:10:00.000000',00000000000001809982),('2024-06-16 20:15:00.000000',00000000000001880181),('2024-06-16 20:20:00.000000',00000000000001909181),('2024-06-16 20:25:00.000000',00000000000001930149),('2024-06-16 20:30:00.000000',00000000000001945137),('2024-06-16 20:35:00.000000',00000000000001961217),('2024-06-16 20:40:00.000000',00000000000001979217),('2024-06-16 20:45:00.000000',00000000000001991851),('2024-06-16 20:50:00.000000',00000000000002012739),('2024-06-16 20:55:00.000000',00000000000002026739),('2024-06-16 21:00:00.000000',00000000000002049618),('2024-06-16 21:05:00.000000',00000000000002061618),('2024-06-16 21:10:00.000000',00000000000002069618),('2024-06-16 21:15:00.000000',00000000000002086618),('2024-06-16 21:20:00.000000',00000000000002103118),('2024-06-16 21:25:00.000000',00000000000002127118),('2024-06-16 21:30:00.000000',00000000000002146018),('2024-06-16 21:35:00.000000',00000000000002156918),('2024-06-16 21:40:00.000000',00000000000002165918),('2024-06-16 21:45:00.000000',00000000000002177818),('2024-06-16 21:50:00.000000',00000000000002185818),('2024-06-16 21:55:00.000000',00000000000002191697),('2024-06-16 22:00:00.000000',00000000000002199697),('2024-06-16 22:05:00.000000',00000000000002203297),('2024-06-16 22:10:00.000000',00000000000002208797),('2024-06-16 22:15:00.000000',00000000000002210797),('2024-06-16 22:20:00.000000',00000000000002213797),('2024-06-16 22:25:00.000000',00000000000002223576),('2024-06-16 22:30:00.000000',00000000000002225576),('2024-06-16 22:35:00.000000',00000000000002236465),('2024-06-16 22:40:00.000000',00000000000002250065),('2024-06-16 22:45:00.000000',00000000000002255944),('2024-06-16 22:50:00.000000',00000000000002258944),('2024-06-16 22:55:00.000000',00000000000002267844),('2024-06-16 23:00:00.000000',00000000000002274834),('2024-06-16 23:05:00.000000',00000000000002278832),('2024-06-16 23:10:00.000000',00000000000002289632),('2024-06-16 23:15:00.000000',00000000000002296622),('2024-06-16 23:20:00.000000',00000000000002299622),('2024-06-16 23:25:00.000000',00000000000002308612),('2024-06-16 23:30:00.000000',00000000000002314512),('2024-06-16 23:35:00.000000',00000000000002327411),('2024-06-16 23:40:00.000000',00000000000002347311),('2024-06-16 23:45:00.000000',00000000000002358210),('2024-06-16 23:50:00.000000',00000000000002371199),('2024-06-16 23:55:00.000000',00000000000002372198),('2024-06-17 00:00:00.000000',00000000000002413798),('2024-06-17 00:05:00.000000',00000000000002420277),('2024-06-17 00:10:00.000000',00000000000002456277),('2024-06-17 00:15:00.000000',00000000000002470877),('2024-06-17 00:20:00.000000',00000000000002489677),('2024-06-17 00:25:00.000000',00000000000002508446),('2024-06-17 00:30:00.000000',00000000000002511445),('2024-06-17 00:35:00.000000',00000000000002520324),('2024-06-17 00:40:00.000000',00000000000002539424),('2024-06-17 00:45:00.000000',00000000000002555302),('2024-06-17 00:50:00.000000',00000000000002567202),('2024-06-17 00:55:00.000000',00000000000002581080),('2024-06-17 01:00:00.000000',00000000000002592079),('2024-06-17 01:05:00.000000',00000000000002612558),('2024-06-17 01:10:00.000000',00000000000002638336),('2024-06-17 01:15:00.000000',00000000000002652236),('2024-06-17 01:20:00.000000',00000000000002670625),('2024-06-17 01:25:00.000000',00000000000002672625),('2024-06-17 01:30:00.000000',00000000000002672626),('2024-06-17 01:35:00.000000',00000000000002965426),('2024-06-17 01:40:00.000000',00000000000002972226),('2024-06-17 01:45:00.000000',00000000000002987026),('2024-06-17 01:50:00.000000',00000000000003027316),('2024-06-17 01:55:00.000000',00000000000003034316),('2024-06-17 02:00:00.000000',00000000000003075006),('2024-06-17 02:05:00.000000',00000000000003088406),('2024-06-17 02:10:00.000000',00000000000003111162),('2024-06-17 02:15:00.000000',00000000000003125041),('2024-06-17 02:20:00.000000',00000000000003134041),('2024-06-17 02:25:00.000000',00000000000003147841),('2024-06-17 02:30:00.000000',00000000000003167641),('2024-06-17 02:35:00.000000',00000000000003182420),('2024-06-17 02:40:00.000000',00000000000003188320),('2024-06-17 02:45:00.000000',00000000000003200200),('2024-06-17 02:50:00.000000',00000000000003219990),('2024-06-17 02:55:00.000000',00000000000003247790),('2024-06-17 03:00:00.000000',00000000000003265690),('2024-06-17 03:05:00.000000',00000000000003294660),('2024-06-17 03:10:00.000000',00000000000003328260),('2024-06-17 03:15:00.000000',00000000000003336260),('2024-06-17 03:20:00.000000',00000000000003347150),('2024-06-17 03:25:00.000000',00000000000003359050),('2024-06-17 03:30:00.000000',00000000000003366029),('2024-06-17 03:35:00.000000',00000000000003385029),('2024-06-17 03:40:00.000000',00000000000003421929),('2024-06-17 03:45:00.000000',00000000000003431929),('2024-06-17 03:50:00.000000',00000000000003449729),('2024-06-17 03:55:00.000000',00000000000003467497),('2024-06-17 04:00:00.000000',00000000000003477377),('2024-06-17 04:05:00.000000',00000000000003494024),('2024-06-17 04:10:00.000000',00000000000003498923),('2024-06-17 04:15:00.000000',00000000000003505823),('2024-06-17 04:20:00.000000',00000000000003517792),('2024-06-17 04:25:00.000000',00000000000003637460),('2024-06-17 04:30:00.000000',00000000000003652350),('2024-06-17 04:35:00.000000',00000000000003670239),('2024-06-17 04:40:00.000000',00000000000003686309),('2024-06-17 04:45:00.000000',00000000000003723605),('2024-06-17 04:50:00.000000',00000000000003752473),('2024-06-17 04:55:00.000000',00000000000003771532),('2024-06-17 05:00:00.000000',00000000000003792101),('2024-06-17 05:05:00.000000',00000000000003824859),('2024-06-17 05:10:00.000000',00000000000003904649),('2024-06-17 05:15:00.000000',00000000000003925548),('2024-06-17 05:20:00.000000',00000000000003946638),('2024-06-17 05:25:00.000000',00000000000003950315),('2024-06-17 05:30:00.000000',00000000000003976392),('2024-06-17 05:35:00.000000',00000000000004007482),('2024-06-17 05:40:00.000000',00000000000004034149),('2024-06-17 05:45:00.000000',00000000000004046028),('2024-06-17 05:50:00.000000',00000000000004060617),('2024-06-17 05:55:00.000000',00000000000004072396),('2024-06-17 06:00:00.000000',00000000000004091784),('2024-06-17 06:05:00.000000',00000000000004101573),('2024-06-17 06:10:00.000000',00000000000004110573),('2024-06-17 06:15:00.000000',00000000000004133762),('2024-06-17 06:20:00.000000',00000000000004139673),('2024-06-17 06:25:00.000000',00000000000004152573),('2024-06-17 06:30:00.000000',00000000000004166473),('2024-06-17 06:35:00.000000',00000000000004188231),('2024-06-17 06:40:00.000000',00000000000004191230),('2024-06-17 06:45:00.000000',00000000000004206729),('2024-06-17 06:50:00.000000',00000000000004282219),('2024-06-17 06:55:00.000000',00000000000004308399),('2024-06-17 07:00:00.000000',00000000000004329999),('2024-06-17 07:05:00.000000',00000000000004366378),('2024-06-17 07:10:00.000000',00000000000004379278),('2024-06-17 07:15:00.000000',00000000000004393057),('2024-06-17 07:20:00.000000',00000000000004404556),('2024-06-17 07:25:00.000000',00000000000004417414),('2024-06-17 07:30:00.000000',00000000000004426393),('2024-06-17 07:35:00.000000',00000000000004438071),('2024-06-17 07:40:00.000000',00000000000004446059),('2024-06-17 07:45:00.000000',00000000000004446037),('2024-06-17 07:50:00.000000',00000000000004461039),('2024-06-17 07:55:00.000000',00000000000004473019),('2024-06-17 08:00:00.000000',00000000000004480909),('2024-06-17 08:05:00.000000',00000000000004486908),('2024-06-17 08:10:00.000000',00000000000004508908),('2024-06-17 08:15:00.000000',00000000000004516787),('2024-06-17 08:20:00.000000',00000000000004528487),('2024-06-17 08:25:00.000000',00000000000004531487),('2024-06-17 08:30:00.000000',00000000000004541687),('2024-06-17 08:35:00.000000',00000000000004578287),('2024-06-17 08:40:00.000000',00000000000004587187),('2024-06-17 08:45:00.000000',00000000000004608486),('2024-06-17 08:50:00.000000',00000000000004618286),('2024-06-17 08:55:00.000000',00000000000004647875),('2024-06-17 09:00:00.000000',00000000000004829643),('2024-06-17 09:05:00.000000',00000000000004831732),('2024-06-17 09:10:00.000000',00000000000004863297),('2024-06-17 09:15:00.000000',00000000000004887286),('2024-06-17 09:20:00.000000',00000000000004895197),('2024-06-17 09:25:00.000000',00000000000004871176),('2024-06-17 09:30:00.000000',00000000000004888042),('2024-06-17 09:35:00.000000',00000000000004903932),('2024-06-17 09:40:00.000000',00000000000004910922),('2024-06-17 09:45:00.000000',00000000000004925778),('2024-06-17 09:50:00.000000',00000000000004929778),('2024-06-17 09:55:00.000000',00000000000004942667),('2024-06-17 10:00:00.000000',00000000000004988879),('2024-06-17 10:05:00.000000',00000000000005006659),('2024-06-17 10:10:00.000000',00000000000005020459),('2024-06-17 10:15:00.000000',00000000000005043138),('2024-06-17 10:20:00.000000',00000000000005050027),('2024-06-17 10:25:00.000000',00000000000005083627),('2024-06-17 10:30:00.000000',00000000000005119105),('2024-06-17 10:35:00.000000',00000000000005136804),('2024-06-17 10:40:00.000000',00000000000005154203),('2024-06-17 10:45:00.000000',00000000000005170172),('2024-06-17 10:50:00.000000',00000000000005176170),('2024-06-17 10:55:00.000000',00000000000005183170),('2024-06-17 11:00:00.000000',00000000000005190160),('2024-06-17 11:05:00.000000',00000000000005202060),('2024-06-17 11:10:00.000000',00000000000005210960),('2024-06-17 11:15:00.000000',00000000000005225660),('2024-06-17 11:20:00.000000',00000000000005237648),('2024-06-17 11:25:00.000000',00000000000005261415),('2024-06-17 11:30:00.000000',00000000000005273192),('2024-06-17 11:35:00.000000',00000000000005280351),('2024-06-17 11:40:00.000000',00000000000005284351),('2024-06-17 11:45:00.000000',00000000000005297841),('2024-06-17 11:50:00.000000',00000000000005308630),('2024-06-17 11:55:00.000000',00000000000005336420),('2024-06-17 12:00:00.000000',00000000000005628120),('2024-06-17 12:05:00.000000',00000000000005675919),('2024-06-17 12:10:00.000000',00000000000005681608),('2024-06-17 12:15:00.000000',00000000000005692488),('2024-06-17 12:20:00.000000',00000000000005724045),('2024-06-17 12:25:00.000000',00000000000005727045),('2024-06-17 12:30:00.000000',00000000000005742745),('2024-06-17 12:35:00.000000',00000000000005752077),('2024-06-17 12:40:00.000000',00000000000006061322),('2024-06-17 12:45:00.000000',00000000000006071311),('2024-06-17 12:50:00.000000',00000000000006089201),('2024-06-17 12:55:00.000000',00000000000006108901),('2024-06-17 13:00:00.000000',00000000000006117801),('2024-06-17 13:05:00.000000',00000000000006134601),('2024-06-17 13:10:00.000000',00000000000006150301),('2024-06-17 13:15:00.000000',00000000000006160401),('2024-06-17 13:20:00.000000',00000000000006163401),('2024-06-17 13:25:00.000000',00000000000006203426),('2024-06-17 13:30:00.000000',00000000000006249786),('2024-06-17 13:35:00.000000',00000000000006271675),('2024-06-17 13:40:00.000000',00000000000006276644),('2024-06-17 13:45:00.000000',00000000000006305703),('2024-06-17 13:50:00.000000',00000000000006332191),('2024-06-17 13:55:00.000000',00000000000006386971),('2024-06-17 14:00:00.000000',00000000000006413447),('2024-06-17 14:05:00.000000',00000000000006423846),('2024-06-17 14:10:00.000000',00000000000006460825),('2024-06-17 14:15:00.000000',00000000000006495002),('2024-06-17 14:20:00.000000',00000000000006518148),('2024-06-17 14:25:00.000000',00000000000006547317),('2024-06-17 14:30:00.000000',00000000000006576005),('2024-06-17 14:35:00.000000',00000000000006598594),('2024-06-17 14:40:00.000000',00000000000006614894),('2024-06-17 14:45:00.000000',00000000000006624894),('2024-06-17 14:50:00.000000',00000000000006633694),('2024-06-17 14:55:00.000000',00000000000006685293),('2024-06-17 15:00:00.000000',00000000000006710674),('2024-06-17 15:05:00.000000',00000000000006756151),('2024-06-17 15:10:00.000000',00000000000006793750),('2024-06-17 15:15:00.000000',00000000000006818518),('2024-06-17 15:20:00.000000',00000000000006835208),('2024-06-17 15:25:00.000000',00000000000006864476),('2024-06-17 15:30:00.000000',00000000000006869642),('2024-06-17 15:35:00.000000',00000000000006876932),('2024-06-17 15:40:00.000000',00000000000006905622),('2024-06-17 15:45:00.000000',00000000000006917611),('2024-06-17 15:50:00.000000',00000000000006932501),('2024-06-17 15:55:00.000000',00000000000006957390),('2024-06-17 16:00:00.000000',00000000000000000000),('2024-06-17 16:05:00.000000',00000000000000007800),('2024-06-17 16:10:00.000000',00000000000000056668),('2024-06-17 16:15:00.000000',00000000000000067657),('2024-06-17 16:20:00.000000',00000000000000081554),('2024-06-17 16:25:00.000000',00000000000000100444),('2024-06-17 16:30:00.000000',00000000000000106443),('2024-06-17 16:35:00.000000',00000000000000167743),('2024-06-17 16:40:00.000000',00000000000000219512),('2024-06-17 16:45:00.000000',00000000000000253188),('2024-06-17 16:50:00.000000',00000000000000292777),('2024-06-17 16:55:00.000000',00000000000000321565),('2024-06-17 17:00:00.000000',00000000000000394365),('2024-06-17 17:05:00.000000',00000000000000430133),('2024-06-17 17:10:00.000000',00000000000000526580),('2024-06-17 17:15:00.000000',00000000000000544480),('2024-06-17 17:20:00.000000',00000000000000587256),('2024-06-17 17:25:00.000000',00000000000000624056),('2024-06-17 17:30:00.000000',00000000000000630646),('2024-06-17 17:35:00.000000',00000000000000667536),('2024-06-17 17:40:00.000000',00000000000000720995),('2024-06-17 17:45:00.000000',00000000000000755854),('2024-06-17 17:50:00.000000',00000000000000780331),('2024-06-17 17:55:00.000000',00000000000000820101),('2024-06-17 18:00:00.000000',00000000000000860900),('2024-06-17 18:05:00.000000',00000000000000900588),('2024-06-17 18:10:00.000000',00000000000000939445),('2024-06-17 18:15:00.000000',00000000000001027445),('2024-06-17 18:20:00.000000',00000000000001094343),('2024-06-17 18:25:00.000000',00000000000001132842),('2024-06-17 18:30:00.000000',00000000000001216542),('2024-06-17 18:35:00.000000',00000000000001256041),('2024-06-17 18:40:00.000000',00000000000001281675),('2024-06-17 18:45:00.000000',00000000000001298575),('2024-06-17 18:50:00.000000',00000000000001305585),('2024-06-17 18:55:00.000000',00000000000001317585),('2024-06-17 19:00:00.000000',00000000000001323585),('2024-06-17 19:05:00.000000',00000000000001337484),('2024-06-17 19:10:00.000000',00000000000001362363),('2024-06-17 19:15:00.000000',00000000000001388163),('2024-06-17 19:20:00.000000',00000000000001406163),('2024-06-17 19:25:00.000000',00000000000001432063),('2024-06-17 19:30:00.000000',00000000000001479963),('2024-06-17 19:35:00.000000',00000000000001506143),('2024-06-17 19:40:00.000000',00000000000001520143),('2024-06-17 19:45:00.000000',00000000000001540922),('2024-06-17 19:50:00.000000',00000000000001556922),('2024-06-17 19:55:00.000000',00000000000001584822),('2024-06-17 20:00:00.000000',00000000000001597822),('2024-06-17 20:05:00.000000',00000000000001624522),('2024-06-17 20:10:00.000000',00000000000001639499),('2024-06-17 20:15:00.000000',00000000000001643499),('2024-06-17 20:20:00.000000',00000000000001653498),('2024-06-17 20:25:00.000000',00000000000001671497),('2024-06-17 20:30:00.000000',00000000000001694297),('2024-06-17 20:35:00.000000',00000000000001711187),('2024-06-17 20:40:00.000000',00000000000001725187),('2024-06-17 20:45:00.000000',00000000000001727197),('2024-06-17 20:50:00.000000',00000000000001740197),('2024-06-17 20:55:00.000000',00000000000001750197),('2024-06-17 21:00:00.000000',00000000000001758197),('2024-06-17 21:05:00.000000',00000000000001772177),('2024-06-17 21:10:00.000000',00000000000001797877),('2024-06-17 21:15:00.000000',00000000000001811466),('2024-06-17 21:20:00.000000',00000000000001816466),('2024-06-17 21:25:00.000000',00000000000001822465),('2024-06-17 21:30:00.000000',00000000000001834465),('2024-06-17 21:35:00.000000',00000000000001843465),('2024-06-17 21:40:00.000000',00000000000001849465),('2024-06-17 21:45:00.000000',00000000000001867365),('2024-06-17 21:50:00.000000',00000000000001877365),('2024-06-17 21:55:00.000000',00000000000001893365),('2024-06-17 22:00:00.000000',00000000000001912565),('2024-06-17 22:05:00.000000',00000000000002069865),('2024-06-17 22:10:00.000000',00000000000002083865),('2024-06-17 22:15:00.000000',00000000000002092864),('2024-06-17 22:20:00.000000',00000000000002099864),('2024-06-17 22:25:00.000000',00000000000002111864),('2024-06-17 22:30:00.000000',00000000000002119864),('2024-06-17 22:35:00.000000',00000000000002140564),('2024-06-17 22:40:00.000000',00000000000002154564),('2024-06-17 22:45:00.000000',00000000000002175453),('2024-06-17 22:50:00.000000',00000000000002203853),('2024-06-17 22:55:00.000000',00000000000002226753),('2024-06-17 23:00:00.000000',00000000000002243653),('2024-06-17 23:05:00.000000',00000000000002254653),('2024-06-17 23:10:00.000000',00000000000002281953),('2024-06-17 23:15:00.000000',00000000000002298653),('2024-06-17 23:20:00.000000',00000000000002322653),('2024-06-17 23:25:00.000000',00000000000002359253),('2024-06-17 23:30:00.000000',00000000000002368253),('2024-06-17 23:35:00.000000',00000000000002393053),('2024-06-17 23:40:00.000000',00000000000002413953),('2024-06-17 23:45:00.000000',00000000000002428953),('2024-06-17 23:50:00.000000',00000000000002443953),('2024-06-17 23:55:00.000000',00000000000002479753),('2024-06-18 00:00:00.000000',00000000000002512553),('2024-06-18 00:05:00.000000',00000000000002540541),('2024-06-18 00:10:00.000000',00000000000002571410),('2024-06-18 00:15:00.000000',00000000000002597398),('2024-06-18 00:20:00.000000',00000000000002614398),('2024-06-18 00:25:00.000000',00000000000002629398),('2024-06-18 00:30:00.000000',00000000000002652598),('2024-06-18 00:35:00.000000',00000000000002671467),('2024-06-18 00:40:00.000000',00000000000002702866),('2024-06-18 00:45:00.000000',00000000000002726855),('2024-06-18 00:50:00.000000',00000000000002768455),('2024-06-18 00:55:00.000000',00000000000002795155),('2024-06-18 01:00:00.000000',00000000000002822945),('2024-06-18 01:05:00.000000',00000000000002844724),('2024-06-18 01:10:00.000000',00000000000002888424),('2024-06-18 01:15:00.000000',00000000000002912624),('2024-06-18 01:20:00.000000',00000000000002934824),('2024-06-18 01:25:00.000000',00000000000002965123),('2024-06-18 01:30:00.000000',00000000000002980023),('2024-06-18 01:35:00.000000',00000000000003000903),('2024-06-18 01:40:00.000000',00000000000003037661),('2024-06-18 01:45:00.000000',00000000000003054661),('2024-06-18 01:50:00.000000',00000000000003062661),('2024-06-18 01:55:00.000000',00000000000003076661),('2024-06-18 02:00:00.000000',00000000000003090661),('2024-06-18 02:05:00.000000',00000000000003102161),('2024-06-18 02:10:00.000000',00000000000003113161),('2024-06-18 02:15:00.000000',00000000000003133051),('2024-06-18 02:20:00.000000',00000000000003146049),('2024-06-18 02:25:00.000000',00000000000003162939),('2024-06-18 02:30:00.000000',00000000000003177839),('2024-06-18 02:35:00.000000',00000000000003203639),('2024-06-18 02:40:00.000000',00000000000003212639),('2024-06-18 02:45:00.000000',00000000000003226639),('2024-06-18 02:50:00.000000',00000000000003250439),('2024-06-18 02:55:00.000000',00000000000003277228),('2024-06-18 03:00:00.000000',00000000000003311157),('2024-06-18 03:05:00.000000',00000000000003336935),('2024-06-18 03:10:00.000000',00000000000003337945),('2024-06-18 03:15:00.000000',00000000000003349845),('2024-06-18 03:20:00.000000',00000000000003370745),('2024-06-18 03:25:00.000000',00000000000003397645),('2024-06-18 03:30:00.000000',00000000000003436134),('2024-06-18 03:35:00.000000',00000000000003523513),('2024-06-18 03:40:00.000000',00000000000003541702),('2024-06-18 03:45:00.000000',00000000000003557681),('2024-06-18 03:50:00.000000',00000000000003577471),('2024-06-18 03:55:00.000000',00000000000003588461),('2024-06-18 04:00:00.000000',00000000000003729561),('2024-06-18 04:05:00.000000',00000000000003752349),('2024-06-18 04:10:00.000000',00000000000003786039),('2024-06-18 04:15:00.000000',00000000000003829879),('2024-06-18 04:20:00.000000',00000000000003868247),('2024-06-18 04:25:00.000000',00000000000003907166),('2024-06-18 04:30:00.000000',00000000000003948103),('2024-06-18 04:35:00.000000',00000000000003981763),('2024-06-18 04:40:00.000000',00000000000003997563),('2024-06-18 04:45:00.000000',00000000000004027443),('2024-06-18 04:50:00.000000',00000000000004045431),('2024-06-18 04:55:00.000000',00000000000004071031),('2024-06-18 05:00:00.000000',00000000000004099111),('2024-06-18 05:05:00.000000',00000000000004122080),('2024-06-18 05:10:00.000000',00000000000004163648),('2024-06-18 05:15:00.000000',00000000000004207127),('2024-06-18 05:20:00.000000',00000000000004292297),('2024-06-18 05:25:00.000000',00000000000004325057),('2024-06-18 05:30:00.000000',00000000000004397937),('2024-06-18 05:35:00.000000',00000000000004443196),('2024-06-18 05:40:00.000000',00000000000004473145),('2024-06-18 05:45:00.000000',00000000000004500601),('2024-06-18 05:50:00.000000',00000000000004525671),('2024-06-18 05:55:00.000000',00000000000004558410),('2024-06-18 06:00:00.000000',00000000000004574500),('2024-06-18 06:05:00.000000',00000000000004604168),('2024-06-18 06:10:00.000000',00000000000004641768),('2024-06-18 06:15:00.000000',00000000000004704948),('2024-06-18 06:20:00.000000',00000000000004707117),('2024-06-18 06:25:00.000000',00000000000004717115),('2024-06-18 06:30:00.000000',00000000000004739715),('2024-06-18 06:35:00.000000',00000000000004753515),('2024-06-18 06:40:00.000000',00000000000004788105),('2024-06-18 06:45:00.000000',00000000000004811905),('2024-06-18 06:50:00.000000',00000000000004819905),('2024-06-18 06:55:00.000000',00000000000004841685),('2024-06-18 07:00:00.000000',00000000000004857865),('2024-06-18 07:05:00.000000',00000000000004895645),('2024-06-18 07:10:00.000000',00000000000004914135),('2024-06-18 07:15:00.000000',00000000000004923014),('2024-06-18 07:20:00.000000',00000000000004944714),('2024-06-18 07:25:00.000000',00000000000004948713),('2024-06-18 07:30:00.000000',00000000000004951713),('2024-06-18 07:35:00.000000',00000000000004975403),('2024-06-18 07:40:00.000000',00000000000004996993),('2024-06-18 07:45:00.000000',00000000000005005893),('2024-06-18 07:50:00.000000',00000000000005028673),('2024-06-18 07:55:00.000000',00000000000005057171),('2024-06-18 08:00:00.000000',00000000000005075250),('2024-06-18 08:05:00.000000',00000000000005080250),('2024-06-18 08:10:00.000000',00000000000005101006),('2024-06-18 08:15:00.000000',00000000000005119796),('2024-06-18 08:20:00.000000',00000000000005122775),('2024-06-18 08:25:00.000000',00000000000005134675),('2024-06-18 08:30:00.000000',00000000000005138575),('2024-06-18 08:35:00.000000',00000000000005151264),('2024-06-18 08:40:00.000000',00000000000005165444),('2024-06-18 08:45:00.000000',00000000000005174434),('2024-06-18 08:50:00.000000',00000000000005202224),('2024-06-18 08:55:00.000000',00000000000005228023),('2024-06-18 09:00:00.000000',00000000000005246872),('2024-06-18 09:05:00.000000',00000000000005254461),('2024-06-18 09:10:00.000000',00000000000005454139),('2024-06-18 09:15:00.000000',00000000000005460139),('2024-06-18 09:20:00.000000',00000000000005464139),('2024-06-18 09:25:00.000000',00000000000005485929),('2024-06-18 09:30:00.000000',00000000000005488929),('2024-06-18 09:35:00.000000',00000000000005489929),('2024-06-18 09:40:00.000000',00000000000005529429),('2024-06-18 09:45:00.000000',00000000000005580029),('2024-06-18 09:50:00.000000',00000000000005587029),('2024-06-18 09:55:00.000000',00000000000005615529),('2024-06-18 10:00:00.000000',00000000000005626418),('2024-06-18 10:05:00.000000',00000000000005635308),('2024-06-18 10:10:00.000000',00000000000005638308),('2024-06-18 10:15:00.000000',00000000000005648208),('2024-06-18 10:20:00.000000',00000000000005734708),('2024-06-18 10:25:00.000000',00000000000005772075),('2024-06-18 10:30:00.000000',00000000000005772075),('2024-06-18 10:35:00.000000',00000000000005788774),('2024-06-18 10:40:00.000000',00000000000005790374),('2024-06-18 10:45:00.000000',00000000000005793374),('2024-06-18 10:50:00.000000',00000000000005794374),('2024-06-18 10:55:00.000000',00000000000005800564),('2024-06-18 11:00:00.000000',00000000000005802564),('2024-06-18 11:05:00.000000',00000000000005807263),('2024-06-18 11:10:00.000000',00000000000005823963),('2024-06-18 11:15:00.000000',00000000000005826963),('2024-06-18 11:20:00.000000',00000000000005848662),('2024-06-18 11:25:00.000000',00000000000005856642),('2024-06-18 11:30:00.000000',00000000000005845752),('2024-06-18 11:35:00.000000',00000000000005846752),('2024-06-18 11:40:00.000000',00000000000005853742),('2024-06-18 11:45:00.000000',00000000000005855742),('2024-06-18 11:50:00.000000',00000000000005868730),('2024-06-18 11:55:00.000000',00000000000005868730),('2024-06-18 12:00:00.000000',00000000000005883530),('2024-06-18 12:05:00.000000',00000000000005900330),('2024-06-18 12:10:00.000000',00000000000005902330),('2024-06-18 12:15:00.000000',00000000000005913809),('2024-06-18 12:20:00.000000',00000000000005923697),('2024-06-18 12:25:00.000000',00000000000005936586),('2024-06-18 12:30:00.000000',00000000000005965266),('2024-06-18 12:35:00.000000',00000000000005976544),('2024-06-18 12:40:00.000000',00000000000005996424),('2024-06-18 12:45:00.000000',00000000000006004223),('2024-06-18 12:50:00.000000',00000000000006013103),('2024-06-18 12:55:00.000000',00000000000006015103),('2024-06-18 13:00:00.000000',00000000000006039203),('2024-06-18 13:05:00.000000',00000000000006050093),('2024-06-18 13:10:00.000000',00000000000006056993),('2024-06-18 13:15:00.000000',00000000000006081750),('2024-06-18 13:20:00.000000',00000000000006115128),('2024-06-18 13:25:00.000000',00000000000006131896),('2024-06-18 13:30:00.000000',00000000000006164686),('2024-06-18 13:35:00.000000',00000000000006173576),('2024-06-18 13:40:00.000000',00000000000006176555),('2024-06-18 13:45:00.000000',00000000000006211014),('2024-06-18 13:50:00.000000',00000000000006224502),('2024-06-18 13:55:00.000000',00000000000006257972),('2024-06-18 14:00:00.000000',00000000000006285851),('2024-06-18 14:05:00.000000',00000000000006295741),('2024-06-18 14:10:00.000000',00000000000006317419),('2024-06-18 14:15:00.000000',00000000000006327308),('2024-06-18 14:20:00.000000',00000000000006344397),('2024-06-18 14:25:00.000000',00000000000006384935),('2024-06-18 14:30:00.000000',00000000000006485524),('2024-06-18 14:35:00.000000',00000000000006519914),('2024-06-18 14:40:00.000000',00000000000006574494),('2024-06-18 14:45:00.000000',00000000000006602672),('2024-06-18 14:50:00.000000',00000000000006655731),('2024-06-18 14:55:00.000000',00000000000006701457),('2024-06-18 15:00:00.000000',00000000000006766237),('2024-06-18 15:05:00.000000',00000000000006788327),('2024-06-18 15:10:00.000000',00000000000006803907),('2024-06-18 15:15:00.000000',00000000000006841097),('2024-06-18 15:20:00.000000',00000000000006856866),('2024-06-18 15:25:00.000000',00000000000006881206),('2024-06-18 15:30:00.000000',00000000000006894193),('2024-06-18 15:35:00.000000',00000000000006927152),('2024-06-18 15:40:00.000000',00000000000006940872),('2024-06-18 15:45:00.000000',00000000000007020742),('2024-06-18 15:50:00.000000',00000000000007057282),('2024-06-18 15:55:00.000000',00000000000007077682),('2024-06-18 16:00:00.000000',00000000000000000000),('2024-06-18 16:05:00.000000',00000000000000075906),('2024-06-18 16:10:00.000000',00000000000000083475),('2024-06-18 16:15:00.000000',00000000000000110265),('2024-06-18 16:20:00.000000',00000000000000130053),('2024-06-18 16:25:00.000000',00000000000000172241),('2024-06-18 16:30:00.000000',00000000000000231408),('2024-06-18 16:35:00.000000',00000000000000242567),('2024-06-18 16:40:00.000000',00000000000000260767),('2024-06-18 16:45:00.000000',00000000000000324447),('2024-06-18 16:50:00.000000',00000000000000363846),('2024-06-18 16:55:00.000000',00000000000000392726),('2024-06-18 17:00:00.000000',00000000000000418613),('2024-06-18 17:05:00.000000',00000000000000462801),('2024-06-18 17:10:00.000000',00000000000000509901),('2024-06-18 17:15:00.000000',00000000000000534301),('2024-06-18 17:20:00.000000',00000000000000558181),('2024-06-18 17:25:00.000000',00000000000000591061),('2024-06-18 17:30:00.000000',00000000000000592361),('2024-06-18 17:35:00.000000',00000000000000607159),('2024-06-18 17:40:00.000000',00000000000000638837),('2024-06-18 17:45:00.000000',00000000000000686995),('2024-06-18 17:50:00.000000',00000000000000713695),('2024-06-18 17:55:00.000000',00000000000000729895),('2024-06-18 18:00:00.000000',00000000000000794563),('2024-06-18 18:05:00.000000',00000000000000802563),('2024-06-18 18:10:00.000000',00000000000000819363),('2024-06-18 18:15:00.000000',00000000000000824363),('2024-06-18 18:20:00.000000',00000000000000840363),('2024-06-18 18:25:00.000000',00000000000000849363),('2024-06-18 18:30:00.000000',00000000000000858263),('2024-06-18 18:35:00.000000',00000000000000879733),('2024-06-18 18:40:00.000000',00000000000000897133),('2024-06-18 18:45:00.000000',00000000000000917833),('2024-06-18 18:50:00.000000',00000000000000921833),('2024-06-18 18:55:00.000000',00000000000000939723),('2024-06-18 19:00:00.000000',00000000000000963123),('2024-06-18 19:05:00.000000',00000000000001109713),('2024-06-18 19:10:00.000000',00000000000001113713),('2024-06-18 19:15:00.000000',00000000000001131703),('2024-06-18 19:20:00.000000',00000000000001146583),('2024-06-18 19:25:00.000000',00000000000001153572),('2024-06-18 19:30:00.000000',00000000000001165572),('2024-06-18 19:35:00.000000',00000000000001174172),('2024-06-18 19:40:00.000000',00000000000001193552),('2024-06-18 19:45:00.000000',00000000000001211452),('2024-06-18 19:50:00.000000',00000000000001216452),('2024-06-18 19:55:00.000000',00000000000001231352),('2024-06-18 20:00:00.000000',00000000000001255152),('2024-06-18 20:05:00.000000',00000000000001262152),('2024-06-18 20:10:00.000000',00000000000001282442),('2024-06-18 20:15:00.000000',00000000000001289842),('2024-06-18 20:20:00.000000',00000000000001295842),('2024-06-18 20:25:00.000000',00000000000001296842),('2024-06-18 20:30:00.000000',00000000000001301842),('2024-06-18 20:35:00.000000',00000000000001310842),('2024-06-18 20:40:00.000000',00000000000001313842),('2024-06-18 20:45:00.000000',00000000000001322842),('2024-06-18 20:50:00.000000',00000000000001330842),('2024-06-18 20:55:00.000000',00000000000001339742),('2024-06-18 21:00:00.000000',00000000000001343742),('2024-06-18 21:05:00.000000',00000000000001384542),('2024-06-18 21:10:00.000000',00000000000001418542),('2024-06-18 21:15:00.000000',00000000000001421542),('2024-06-18 21:20:00.000000',00000000000001427542),('2024-06-18 21:25:00.000000',00000000000001445332),('2024-06-18 21:30:00.000000',00000000000001496622),('2024-06-18 21:35:00.000000',00000000000001498622),('2024-06-18 21:40:00.000000',00000000000001519302),('2024-06-18 21:45:00.000000',00000000000001518312),('2024-06-18 21:50:00.000000',00000000000001518312),('2024-06-18 21:55:00.000000',00000000000001531112),('2024-06-18 22:00:00.000000',00000000000001541112),('2024-06-18 22:05:00.000000',00000000000001549102),('2024-06-18 22:10:00.000000',00000000000001552392),('2024-06-18 22:15:00.000000',00000000000001556392),('2024-06-18 22:20:00.000000',00000000000001562192),('2024-06-18 22:25:00.000000',00000000000001563192),('2024-06-18 22:30:00.000000',00000000000001573192),('2024-06-18 22:35:00.000000',00000000000001592092),('2024-06-18 22:40:00.000000',00000000000001610492),('2024-06-18 22:45:00.000000',00000000000001632269),('2024-06-18 22:50:00.000000',00000000000001648048),('2024-06-18 22:55:00.000000',00000000000001651048),('2024-06-18 23:00:00.000000',00000000000001659048),('2024-06-18 23:05:00.000000',00000000000001664048),('2024-06-18 23:10:00.000000',00000000000001679918),('2024-06-18 23:15:00.000000',00000000000001690818),('2024-06-18 23:20:00.000000',00000000000001692808),('2024-06-18 23:25:00.000000',00000000000001698708),('2024-06-18 23:30:00.000000',00000000000001701708),('2024-06-18 23:35:00.000000',00000000000001703708),('2024-06-18 23:40:00.000000',00000000000001717198),('2024-06-18 23:45:00.000000',00000000000001737098),('2024-06-18 23:50:00.000000',00000000000001757998),('2024-06-18 23:55:00.000000',00000000000001786698),('2024-06-19 00:00:00.000000',00000000000001789698),('2024-06-19 00:05:00.000000',00000000000001804598),('2024-06-19 00:10:00.000000',00000000000001813798),('2024-06-19 00:15:00.000000',00000000000001822598),('2024-06-19 00:20:00.000000',00000000000001831498),('2024-06-19 00:25:00.000000',00000000000001875398),('2024-06-19 00:30:00.000000',00000000000001897988),('2024-06-19 00:35:00.000000',00000000000001907888),('2024-06-19 00:40:00.000000',00000000000001923278),('2024-06-19 00:45:00.000000',00000000000001934278),('2024-06-19 00:50:00.000000',00000000000001957158),('2024-06-19 00:55:00.000000',00000000000001984058),('2024-06-19 01:00:00.000000',00000000000001999917),('2024-06-19 01:05:00.000000',00000000000002028617),('2024-06-19 01:10:00.000000',00000000000002047595),('2024-06-19 01:15:00.000000',00000000000002059673),('2024-06-19 01:20:00.000000',00000000000002073553),('2024-06-19 01:25:00.000000',00000000000002099213),('2024-06-19 01:30:00.000000',00000000000002110113),('2024-06-19 01:35:00.000000',00000000000002121013),('2024-06-19 01:40:00.000000',00000000000002143213),('2024-06-19 01:45:00.000000',00000000000002168792),('2024-06-19 01:50:00.000000',00000000000002180762),('2024-06-19 01:55:00.000000',00000000000002201332),('2024-06-19 02:00:00.000000',00000000000002210712),('2024-06-19 02:05:00.000000',00000000000002222312),('2024-06-19 02:10:00.000000',00000000000002242292),('2024-06-19 02:15:00.000000',00000000000002266152),('2024-06-19 02:20:00.000000',00000000000002329442),('2024-06-19 02:25:00.000000',00000000000002349332),('2024-06-19 02:30:00.000000',00000000000002368712),('2024-06-19 02:35:00.000000',00000000000002383512),('2024-06-19 02:40:00.000000',00000000000002398382),('2024-06-19 02:45:00.000000',00000000000002431682),('2024-06-19 02:50:00.000000',00000000000002461552),('2024-06-19 02:55:00.000000',00000000000002495442),('2024-06-19 03:00:00.000000',00000000000002519410),('2024-06-19 03:05:00.000000',00000000000002674370),('2024-06-19 03:10:00.000000',00000000000002721139),('2024-06-19 03:15:00.000000',00000000000002757799),('2024-06-19 03:20:00.000000',00000000000002792759),('2024-06-19 03:25:00.000000',00000000000002819288),('2024-06-19 03:30:00.000000',00000000000002859756),('2024-06-19 03:35:00.000000',00000000000002890975),('2024-06-19 03:40:00.000000',00000000000002963444),('2024-06-19 03:45:00.000000',00000000000003003344),('2024-06-19 03:50:00.000000',00000000000003051244),('2024-06-19 03:55:00.000000',00000000000003487044),('2024-06-19 04:00:00.000000',00000000000003545924),('2024-06-19 04:05:00.000000',00000000000003621504),('2024-06-19 04:10:00.000000',00000000000003702864),('2024-06-19 04:15:00.000000',00000000000003791490),('2024-06-19 04:20:00.000000',00000000000003834028),('2024-06-19 04:25:00.000000',00000000000003890807),('2024-06-19 04:30:00.000000',00000000000003937981),('2024-06-19 04:35:00.000000',00000000000004004770),('2024-06-19 04:40:00.000000',00000000000004068539),('2024-06-19 04:45:00.000000',00000000000004113539),('2024-06-19 04:50:00.000000',00000000000004185219),('2024-06-19 04:55:00.000000',00000000000004232019),('2024-06-19 05:00:00.000000',00000000000004267899),('2024-06-19 05:05:00.000000',00000000000004276899),('2024-06-19 05:10:00.000000',00000000000004319699),('2024-06-19 05:15:00.000000',00000000000004346699),('2024-06-19 05:20:00.000000',00000000000004371889),('2024-06-19 05:25:00.000000',00000000000004395789),('2024-06-19 05:30:00.000000',00000000000004425659),('2024-06-19 05:35:00.000000',00000000000004487558),('2024-06-19 05:40:00.000000',00000000000004528958),('2024-06-19 05:45:00.000000',00000000000004593048),('2024-06-19 05:50:00.000000',00000000000004661906),('2024-06-19 05:55:00.000000',00000000000004710095),('2024-06-19 06:00:00.000000',00000000000004739974),('2024-06-19 06:05:00.000000',00000000000004766863),('2024-06-19 06:10:00.000000',00000000000004781820),('2024-06-19 06:15:00.000000',00000000000004793710),('2024-06-19 06:20:00.000000',00000000000004810667),('2024-06-19 06:25:00.000000',00000000000004821867),('2024-06-19 06:30:00.000000',00000000000004842845),('2024-06-19 06:35:00.000000',00000000000004856823),('2024-06-19 06:40:00.000000',00000000000004877713),('2024-06-19 06:45:00.000000',00000000000004892603),('2024-06-19 06:50:00.000000',00000000000004904603),('2024-06-19 06:55:00.000000',00000000000004927503),('2024-06-19 07:00:00.000000',00000000000005002692),('2024-06-19 07:05:00.000000',00000000000005034860),('2024-06-19 07:10:00.000000',00000000000005065438),('2024-06-19 07:15:00.000000',00000000000005096108),('2024-06-19 07:20:00.000000',00000000000005114288),('2024-06-19 07:25:00.000000',00000000000005139978),('2024-06-19 07:30:00.000000',00000000000005167678),('2024-06-19 07:35:00.000000',00000000000005214757),('2024-06-19 07:40:00.000000',00000000000005239577),('2024-06-19 07:45:00.000000',00000000000005253547),('2024-06-19 07:50:00.000000',00000000000005259525),('2024-06-19 07:55:00.000000',00000000000005284283),('2024-06-19 08:00:00.000000',00000000000005292273),('2024-06-19 08:05:00.000000',00000000000005317111),('2024-06-19 08:10:00.000000',00000000000005333711),('2024-06-19 08:15:00.000000',00000000000005361181),('2024-06-19 08:20:00.000000',00000000000005365681),('2024-06-19 08:25:00.000000',00000000000005376581),('2024-06-19 08:30:00.000000',00000000000005384481),('2024-06-19 08:35:00.000000',00000000000005403171),('2024-06-19 08:40:00.000000',00000000000005435751),('2024-06-19 08:45:00.000000',00000000000005454451),('2024-06-19 08:50:00.000000',00000000000005457551),('2024-06-19 08:55:00.000000',00000000000005474351),('2024-06-19 09:00:00.000000',00000000000005522151),('2024-06-19 09:05:00.000000',00000000000005528051),('2024-06-19 09:10:00.000000',00000000000005548220),('2024-06-19 09:15:00.000000',00000000000005572299),('2024-06-19 09:20:00.000000',00000000000005623678),('2024-06-19 09:25:00.000000',00000000000005646478),('2024-06-19 09:30:00.000000',00000000000005661848),('2024-06-19 09:35:00.000000',00000000000005689037),('2024-06-19 09:40:00.000000',00000000000005699027),('2024-06-19 09:45:00.000000',00000000000005725727),('2024-06-19 09:50:00.000000',00000000000005730717),('2024-06-19 09:55:00.000000',00000000000005746517),('2024-06-19 10:00:00.000000',00000000000005763317),('2024-06-19 10:05:00.000000',00000000000005785616),('2024-06-19 10:10:00.000000',00000000000005929915),('2024-06-19 10:15:00.000000',00000000000005931915),('2024-06-19 10:20:00.000000',00000000000005957705),('2024-06-19 10:25:00.000000',00000000000005987552),('2024-06-19 10:30:00.000000',00000000000005997452),('2024-06-19 10:35:00.000000',00000000000006009352),('2024-06-19 10:40:00.000000',00000000000006033732),('2024-06-19 10:45:00.000000',00000000000006036732),('2024-06-19 10:50:00.000000',00000000000006049511),('2024-06-19 10:55:00.000000',00000000000006064411),('2024-06-19 11:00:00.000000',00000000000006072411),('2024-06-19 11:05:00.000000',00000000000006094289),('2024-06-19 11:10:00.000000',00000000000006099299),('2024-06-19 11:15:00.000000',00000000000006102399),('2024-06-19 11:20:00.000000',00000000000006116099),('2024-06-19 11:25:00.000000',00000000000006130079),('2024-06-19 11:30:00.000000',00000000000006139077),('2024-06-19 11:35:00.000000',00000000000006154777),('2024-06-19 11:40:00.000000',00000000000006162766),('2024-06-19 11:45:00.000000',00000000000006160776),('2024-06-19 11:50:00.000000',00000000000006173576),('2024-06-19 11:55:00.000000',00000000000006186556),('2024-06-19 12:00:00.000000',00000000000006191656),('2024-06-19 12:05:00.000000',00000000000006227314),('2024-06-19 12:10:00.000000',00000000000006254972),('2024-06-19 12:15:00.000000',00000000000006263872),('2024-06-19 12:20:00.000000',00000000000006282771),('2024-06-19 12:25:00.000000',00000000000006292761),('2024-06-19 12:30:00.000000',00000000000006299761),('2024-06-19 12:35:00.000000',00000000000006307750),('2024-06-19 12:40:00.000000',00000000000006325548),('2024-06-19 12:45:00.000000',00000000000006345377),('2024-06-19 12:50:00.000000',00000000000006353267),('2024-06-19 12:55:00.000000',00000000000006370647),('2024-06-19 13:00:00.000000',00000000000006387327),('2024-06-19 13:05:00.000000',00000000000006399227),('2024-06-19 13:10:00.000000',00000000000006429817),('2024-06-19 13:15:00.000000',00000000000006444817),('2024-06-19 13:20:00.000000',00000000000006454717),('2024-06-19 13:25:00.000000',00000000000006463617),('2024-06-19 13:30:00.000000',00000000000006475517),('2024-06-19 13:35:00.000000',00000000000006491387),('2024-06-19 13:40:00.000000',00000000000006514375),('2024-06-19 13:45:00.000000',00000000000006529264),('2024-06-19 13:50:00.000000',00000000000006575743),('2024-06-19 13:55:00.000000',00000000000006586543),('2024-06-19 14:00:00.000000',00000000000006587543),('2024-06-19 14:05:00.000000',00000000000006663488),('2024-06-19 14:10:00.000000',00000000000006696756),('2024-06-19 14:15:00.000000',00000000000006706054),('2024-06-19 14:20:00.000000',00000000000006741633),('2024-06-19 14:25:00.000000',00000000000006763333),('2024-06-19 14:30:00.000000',00000000000006789802),('2024-06-19 14:35:00.000000',00000000000006820071),('2024-06-19 14:40:00.000000',00000000000006859060),('2024-06-19 14:45:00.000000',00000000000006874920),('2024-06-19 14:50:00.000000',00000000000006899669),('2024-06-19 14:55:00.000000',00000000000006911077),('2024-06-19 15:00:00.000000',00000000000006933936),('2024-06-19 15:05:00.000000',00000000000006956294),('2024-06-19 15:10:00.000000',00000000000006981073),('2024-06-19 15:15:00.000000',00000000000007035531),('2024-06-19 15:20:00.000000',00000000000007062210),('2024-06-19 15:25:00.000000',00000000000007085460),('2024-06-19 15:30:00.000000',00000000000007105360),('2024-06-19 15:35:00.000000',00000000000007123260),('2024-06-19 15:40:00.000000',00000000000007162505),('2024-06-19 15:45:00.000000',00000000000007187843),('2024-06-19 15:50:00.000000',00000000000007201212),('2024-06-19 15:55:00.000000',00000000000007221992),('2024-06-19 16:00:00.000000',00000000000000000000),('2024-06-19 16:05:00.000000',00000000000000038280),('2024-06-19 16:10:00.000000',00000000000000058360),('2024-06-19 16:15:00.000000',00000000000000115740),('2024-06-19 16:20:00.000000',00000000000000166299),('2024-06-19 16:25:00.000000',00000000000000190888),('2024-06-19 16:30:00.000000',00000000000000246688),('2024-06-19 16:35:00.000000',00000000000000268143),('2024-06-19 16:40:00.000000',00000000000000293833),('2024-06-19 16:45:00.000000',00000000000000337423),('2024-06-19 16:50:00.000000',00000000000000363140),('2024-06-19 16:55:00.000000',00000000000000381720),('2024-06-19 17:00:00.000000',00000000000000397520),('2024-06-19 17:05:00.000000',00000000000000421120),('2024-06-19 17:10:00.000000',00000000000000435899),('2024-06-19 17:15:00.000000',00000000000000463799),('2024-06-19 17:20:00.000000',00000000000000479599),('2024-06-19 17:25:00.000000',00000000000000504388),('2024-06-19 17:30:00.000000',00000000000000516277),('2024-06-19 17:35:00.000000',00000000000000526167),('2024-06-19 17:40:00.000000',00000000000000549957),('2024-06-19 17:45:00.000000',00000000000000573834),('2024-06-19 17:50:00.000000',00000000000000602967),('2024-06-19 17:55:00.000000',00000000000000614244),('2024-06-19 18:00:00.000000',00000000000000616333),('2024-06-19 18:05:00.000000',00000000000000624712),('2024-06-19 18:10:00.000000',00000000000000637602),('2024-06-19 18:15:00.000000',00000000000000667272),('2024-06-19 18:20:00.000000',00000000000000676142),('2024-06-19 18:25:00.000000',00000000000000695121),('2024-06-19 18:30:00.000000',00000000000000705821),('2024-06-19 18:35:00.000000',00000000000000716590),('2024-06-19 18:40:00.000000',00000000000000744469),('2024-06-19 18:45:00.000000',00000000000000768459),('2024-06-19 18:50:00.000000',00000000000000811059),('2024-06-19 18:55:00.000000',00000000000000824848),('2024-06-19 19:00:00.000000',00000000000000826848),('2024-06-19 19:05:00.000000',00000000000000835348),('2024-06-19 19:10:00.000000',00000000000000851207),('2024-06-19 19:15:00.000000',00000000000000919697),('2024-06-19 19:20:00.000000',00000000000001092986),('2024-06-19 19:25:00.000000',00000000000001101156),('2024-06-19 19:30:00.000000',00000000000001101256),('2024-06-19 19:35:00.000000',00000000000001103156),('2024-06-19 19:40:00.000000',00000000000001113256),('2024-06-19 19:45:00.000000',00000000000001122146),('2024-06-19 19:50:00.000000',00000000000001128546),('2024-06-19 19:55:00.000000',00000000000001136446),('2024-06-19 20:00:00.000000',00000000000001142436),('2024-06-19 20:05:00.000000',00000000000001149324),('2024-06-19 20:10:00.000000',00000000000001162314),('2024-06-19 20:15:00.000000',00000000000001164514),('2024-06-19 20:20:00.000000',00000000000001164514),('2024-06-19 20:25:00.000000',00000000000001168514),('2024-06-19 20:30:00.000000',00000000000001164614),('2024-06-19 20:35:00.000000',00000000000001165214),('2024-06-19 20:40:00.000000',00000000000001167203),('2024-06-19 20:45:00.000000',00000000000001202693),('2024-06-19 20:50:00.000000',00000000000001203293),('2024-06-19 20:55:00.000000',00000000000001214893),('2024-06-19 21:00:00.000000',00000000000001247593),('2024-06-19 21:05:00.000000',00000000000001255483),('2024-06-19 21:10:00.000000',00000000000001265383),('2024-06-19 21:15:00.000000',00000000000001274183),('2024-06-19 21:20:00.000000',00000000000001274183),('2024-06-19 21:25:00.000000',00000000000001274183),('2024-06-19 21:30:00.000000',00000000000001274183),('2024-06-19 21:35:00.000000',00000000000001274183),('2024-06-19 21:40:00.000000',00000000000001274183),('2024-06-19 21:45:00.000000',00000000000001284083),('2024-06-19 21:50:00.000000',00000000000001323883),('2024-06-19 21:55:00.000000',00000000000001329783),('2024-06-19 22:00:00.000000',00000000000001331883),('2024-06-19 22:05:00.000000',00000000000001331883),('2024-06-19 22:10:00.000000',00000000000001344683),('2024-06-19 22:15:00.000000',00000000000001345683),('2024-06-19 22:20:00.000000',00000000000001387583),('2024-06-19 22:25:00.000000',00000000000001397573),('2024-06-19 22:30:00.000000',00000000000001397573),('2024-06-19 22:35:00.000000',00000000000001401473),('2024-06-19 22:40:00.000000',00000000000001415173),('2024-06-19 22:45:00.000000',00000000000001416173),('2024-06-19 22:50:00.000000',00000000000001423063),('2024-06-19 22:55:00.000000',00000000000001429963),('2024-06-19 23:00:00.000000',00000000000001434053),('2024-06-19 23:05:00.000000',00000000000001438752),('2024-06-19 23:10:00.000000',00000000000001451531),('2024-06-19 23:15:00.000000',00000000000001455431),('2024-06-19 23:20:00.000000',00000000000001459631),('2024-06-19 23:25:00.000000',00000000000001471031),('2024-06-19 23:30:00.000000',00000000000001473031),('2024-06-19 23:35:00.000000',00000000000001490899),('2024-06-19 23:40:00.000000',00000000000001497887),('2024-06-19 23:45:00.000000',00000000000001501787),('2024-06-19 23:50:00.000000',00000000000001511667),('2024-06-19 23:55:00.000000',00000000000001518556),('2024-06-20 00:00:00.000000',00000000000001529355),('2024-06-20 00:05:00.000000',00000000000001535834),('2024-06-20 00:10:00.000000',00000000000001547523),('2024-06-20 00:15:00.000000',00000000000001567311),('2024-06-20 00:20:00.000000',00000000000001573301),('2024-06-20 00:25:00.000000',00000000000001584201),('2024-06-20 00:30:00.000000',00000000000001587201),('2024-06-20 00:35:00.000000',00000000000001592401),('2024-06-20 00:40:00.000000',00000000000001599290),('2024-06-20 00:45:00.000000',00000000000001612169),('2024-06-20 00:50:00.000000',00000000000001628049),('2024-06-20 00:55:00.000000',00000000000001648049),('2024-06-20 01:00:00.000000',00000000000001648049),('2024-06-20 01:05:00.000000',00000000000001658839),('2024-06-20 01:10:00.000000',00000000000001665829),('2024-06-20 01:15:00.000000',00000000000001676718),('2024-06-20 01:20:00.000000',00000000000001700282),('2024-06-20 01:25:00.000000',00000000000001708462),('2024-06-20 01:30:00.000000',00000000000001717431),('2024-06-20 01:35:00.000000',00000000000001722220),('2024-06-20 01:40:00.000000',00000000000001732990),('2024-06-20 01:45:00.000000',00000000000001745946),('2024-06-20 01:50:00.000000',00000000000001746546),('2024-06-20 01:55:00.000000',00000000000001760326),('2024-06-20 02:00:00.000000',00000000000001767226),('2024-06-20 02:05:00.000000',00000000000001771225),('2024-06-20 02:10:00.000000',00000000000001796925),('2024-06-20 02:15:00.000000',00000000000001810825),('2024-06-20 02:20:00.000000',00000000000001813825),('2024-06-20 02:25:00.000000',00000000000001838425),('2024-06-20 02:30:00.000000',00000000000001844415),('2024-06-20 02:35:00.000000',00000000000001888415),('2024-06-20 02:40:00.000000',00000000000001889415),('2024-06-20 02:45:00.000000',00000000000001928095),('2024-06-20 02:50:00.000000',00000000000001939195),('2024-06-20 02:55:00.000000',00000000000001963885),('2024-06-20 03:00:00.000000',00000000000001964385),('2024-06-20 03:05:00.000000',00000000000001970274),('2024-06-20 03:10:00.000000',00000000000001989974),('2024-06-20 03:15:00.000000',00000000000001998943),('2024-06-20 03:20:00.000000',00000000000002009899),('2024-06-20 03:25:00.000000',00000000000002042699),('2024-06-20 03:30:00.000000',00000000000002063199),('2024-06-20 03:35:00.000000',00000000000002078088),('2024-06-20 03:40:00.000000',00000000000002084077),('2024-06-20 03:45:00.000000',00000000000002086077),('2024-06-20 03:50:00.000000',00000000000002089077),('2024-06-20 03:55:00.000000',00000000000002108777),('2024-06-20 04:00:00.000000',00000000000002110777),('2024-06-20 04:05:00.000000',00000000000002137554),('2024-06-20 04:10:00.000000',00000000000002200884),('2024-06-20 04:15:00.000000',00000000000002212754),('2024-06-20 04:20:00.000000',00000000000002230413),('2024-06-20 04:25:00.000000',00000000000002254321),('2024-06-20 04:30:00.000000',00000000000002266321),('2024-06-20 04:35:00.000000',00000000000002288921),('2024-06-20 04:40:00.000000',00000000000002294411),('2024-06-20 04:45:00.000000',00000000000002323880),('2024-06-20 04:50:00.000000',00000000000002336670),('2024-06-20 04:55:00.000000',00000000000002365070),('2024-06-20 05:00:00.000000',00000000000002371959),('2024-06-20 05:05:00.000000',00000000000002398648),('2024-06-20 05:10:00.000000',00000000000002402638),('2024-06-20 05:15:00.000000',00000000000002406627),('2024-06-20 05:20:00.000000',00000000000002421507),('2024-06-20 05:25:00.000000',00000000000002452387),('2024-06-20 05:30:00.000000',00000000000002512136),('2024-06-20 05:35:00.000000',00000000000002547786),('2024-06-20 05:40:00.000000',00000000000002659504),('2024-06-20 05:45:00.000000',00000000000002686553),('2024-06-20 05:50:00.000000',00000000000002714361),('2024-06-20 05:55:00.000000',00000000000002737540),('2024-06-20 06:00:00.000000',00000000000002756410),('2024-06-20 06:05:00.000000',00000000000002762620),('2024-06-20 06:10:00.000000',00000000000002784568),('2024-06-20 06:15:00.000000',00000000000002799457),('2024-06-20 06:20:00.000000',00000000000002808455),('2024-06-20 06:25:00.000000',00000000000002817335),('2024-06-20 06:30:00.000000',00000000000002818935),('2024-06-20 06:35:00.000000',00000000000002834815),('2024-06-20 06:40:00.000000',00000000000002854395),('2024-06-20 06:45:00.000000',00000000000002866285),('2024-06-20 06:50:00.000000',00000000000002875175),('2024-06-20 06:55:00.000000',00000000000002885875),('2024-06-20 07:00:00.000000',00000000000002892875),('2024-06-20 07:05:00.000000',00000000000002904765),('2024-06-20 07:10:00.000000',00000000000002911755),('2024-06-20 07:15:00.000000',00000000000002936415),('2024-06-20 07:20:00.000000',00000000000002952304),('2024-06-20 07:25:00.000000',00000000000002954304),('2024-06-20 07:30:00.000000',00000000000002955304),('2024-06-20 07:35:00.000000',00000000000002963104),('2024-06-20 07:40:00.000000',00000000000002966703),('2024-06-20 07:45:00.000000',00000000000002966703),('2024-06-20 07:50:00.000000',00000000000002977671),('2024-06-20 07:55:00.000000',00000000000002987541),('2024-06-20 08:00:00.000000',00000000000002993511),('2024-06-20 08:05:00.000000',00000000000002993531),('2024-06-20 08:10:00.000000',00000000000003007300),('2024-06-20 08:15:00.000000',00000000000003010288),('2024-06-20 08:20:00.000000',00000000000003032067),('2024-06-20 08:25:00.000000',00000000000003045037),('2024-06-20 08:30:00.000000',00000000000003061405),('2024-06-20 08:35:00.000000',00000000000003065694),('2024-06-20 08:40:00.000000',00000000000003070694),('2024-06-20 08:45:00.000000',00000000000003087354),('2024-06-20 08:50:00.000000',00000000000003091343),('2024-06-20 08:55:00.000000',00000000000003108733),('2024-06-20 09:00:00.000000',00000000000003260593),('2024-06-20 09:05:00.000000',00000000000003269363),('2024-06-20 09:10:00.000000',00000000000003282963),('2024-06-20 09:15:00.000000',00000000000003290963),('2024-06-20 09:20:00.000000',00000000000003295843),('2024-06-20 09:25:00.000000',00000000000003311613),('2024-06-20 09:30:00.000000',00000000000003380413),('2024-06-20 09:35:00.000000',00000000000003383413),('2024-06-20 09:40:00.000000',00000000000003383413),('2024-06-20 09:45:00.000000',00000000000003397203),('2024-06-20 09:50:00.000000',00000000000003397203),('2024-06-20 09:55:00.000000',00000000000003408003),('2024-06-20 10:00:00.000000',00000000000003408003),('2024-06-20 10:05:00.000000',00000000000003412093),('2024-06-20 10:10:00.000000',00000000000003415082),('2024-06-20 10:15:00.000000',00000000000003428962),('2024-06-20 10:20:00.000000',00000000000003436862),('2024-06-20 10:25:00.000000',00000000000003437862),('2024-06-20 10:30:00.000000',00000000000003438862),('2024-06-20 10:35:00.000000',00000000000003453742),('2024-06-20 10:40:00.000000',00000000000003459731),('2024-06-20 10:45:00.000000',00000000000003468520),('2024-06-20 10:50:00.000000',00000000000003484888),('2024-06-20 10:55:00.000000',00000000000003780578),('2024-06-20 11:00:00.000000',00000000000003799078),('2024-06-20 11:05:00.000000',00000000000004091878),('2024-06-20 11:10:00.000000',00000000000004106668),('2024-06-20 11:15:00.000000',00000000000004113568),('2024-06-20 11:20:00.000000',00000000000004136357),('2024-06-20 11:25:00.000000',00000000000004125557),('2024-06-20 11:30:00.000000',00000000000004154157),('2024-06-20 11:35:00.000000',00000000000004185157),('2024-06-20 11:40:00.000000',00000000000004194257),('2024-06-20 11:45:00.000000',00000000000004206257),('2024-06-20 11:50:00.000000',00000000000004210257),('2024-06-20 11:55:00.000000',00000000000004239937),('2024-06-20 12:00:00.000000',00000000000004301107),('2024-06-20 12:05:00.000000',00000000000004311096),('2024-06-20 12:10:00.000000',00000000000004347096),('2024-06-20 12:15:00.000000',00000000000004360296),('2024-06-20 12:20:00.000000',00000000000004362296),('2024-06-20 12:25:00.000000',00000000000004369285),('2024-06-20 12:30:00.000000',00000000000004379085),('2024-06-20 12:35:00.000000',00000000000004386985),('2024-06-20 12:40:00.000000',00000000000004395785),('2024-06-20 12:45:00.000000',00000000000004401763),('2024-06-20 12:50:00.000000',00000000000004426141),('2024-06-20 12:55:00.000000',00000000000004445010),('2024-06-20 13:00:00.000000',00000000000004502479),('2024-06-20 13:05:00.000000',00000000000004508380),('2024-06-20 13:10:00.000000',00000000000004526169),('2024-06-20 13:15:00.000000',00000000000004546158),('2024-06-20 13:20:00.000000',00000000000004583636),('2024-06-20 13:25:00.000000',00000000000004620505),('2024-06-20 13:30:00.000000',00000000000004637205),('2024-06-20 13:35:00.000000',00000000000004646205),('2024-06-20 13:40:00.000000',00000000000004656105),('2024-06-20 13:45:00.000000',00000000000004652115),('2024-06-20 13:50:00.000000',00000000000004718705),('2024-06-20 13:55:00.000000',00000000000004765495),('2024-06-20 14:00:00.000000',00000000000004775485),('2024-06-20 14:05:00.000000',00000000000004784354),('2024-06-20 14:10:00.000000',00000000000004844944),('2024-06-20 14:15:00.000000',00000000000004860334),('2024-06-20 14:20:00.000000',00000000000004890524),('2024-06-20 14:25:00.000000',00000000000004910824),('2024-06-20 14:30:00.000000',00000000000004925013),('2024-06-20 14:35:00.000000',00000000000004946292),('2024-06-20 14:40:00.000000',00000000000004970081),('2024-06-20 14:45:00.000000',00000000000005017981),('2024-06-20 14:50:00.000000',00000000000005054660),('2024-06-20 14:55:00.000000',00000000000005130940),('2024-06-20 15:00:00.000000',00000000000005158530),('2024-06-20 15:05:00.000000',00000000000005185720),('2024-06-20 15:10:00.000000',00000000000005200520),('2024-06-20 15:15:00.000000',00000000000005205489),('2024-06-20 15:20:00.000000',00000000000005227277),('2024-06-20 15:25:00.000000',00000000000005262056),('2024-06-20 15:30:00.000000',00000000000005269015),('2024-06-20 15:35:00.000000',00000000000005277814),('2024-06-20 15:40:00.000000',00000000000005328003),('2024-06-20 15:45:00.000000',00000000000005417593),('2024-06-20 15:50:00.000000',00000000000005436393),('2024-06-20 15:55:00.000000',00000000000005474683),('2024-06-20 16:00:00.000000',00000000000000000000),('2024-06-20 16:05:00.000000',00000000000000012534),('2024-06-20 16:10:00.000000',00000000000000035212),('2024-06-20 16:15:00.000000',00000000000000064401),('2024-06-20 16:20:00.000000',00000000000000132828),('2024-06-20 16:25:00.000000',00000000000000160927),('2024-06-20 16:30:00.000000',00000000000000186206),('2024-06-20 16:35:00.000000',00000000000000192796),('2024-06-20 16:40:00.000000',00000000000000216566),('2024-06-20 16:45:00.000000',00000000000000221965),('2024-06-20 16:50:00.000000',00000000000000241843),('2024-06-20 16:55:00.000000',00000000000000249743),('2024-06-20 17:00:00.000000',00000000000000257632),('2024-06-20 17:05:00.000000',00000000000000281099),('2024-06-20 17:10:00.000000',00000000000000439899),('2024-06-20 17:15:00.000000',00000000000000444999),('2024-06-20 17:20:00.000000',00000000000000458089),('2024-06-20 17:25:00.000000',00000000000000477789),('2024-06-20 17:30:00.000000',00000000000000502663),('2024-06-20 17:35:00.000000',00000000000000508653),('2024-06-20 17:40:00.000000',00000000000000518533),('2024-06-20 17:45:00.000000',00000000000000531422),('2024-06-20 17:50:00.000000',00000000000000544122),('2024-06-20 17:55:00.000000',00000000000000567980),('2024-06-20 18:00:00.000000',00000000000000579258),('2024-06-20 18:05:00.000000',00000000000000599115),('2024-06-20 18:10:00.000000',00000000000000611905),('2024-06-20 18:15:00.000000',00000000000000744405),('2024-06-20 18:20:00.000000',00000000000000755295),('2024-06-20 18:25:00.000000',00000000000000793985),('2024-06-20 18:30:00.000000',00000000000000799985),('2024-06-20 18:35:00.000000',00000000000000800985),('2024-06-20 18:40:00.000000',00000000000000817775),('2024-06-20 18:45:00.000000',00000000000000817775),('2024-06-20 18:50:00.000000',00000000000000830755),('2024-06-20 18:55:00.000000',00000000000000846745),('2024-06-20 19:00:00.000000',00000000000000847735),('2024-06-20 19:05:00.000000',00000000000000848035),('2024-06-20 19:10:00.000000',00000000000000850635),('2024-06-20 19:15:00.000000',00000000000000857425),('2024-06-20 19:20:00.000000',00000000000000866325),('2024-06-20 19:25:00.000000',00000000000000871213),('2024-06-20 19:30:00.000000',00000000000000886002),('2024-06-20 19:35:00.000000',00000000000000891970),('2024-06-20 19:40:00.000000',00000000000000901860),('2024-06-20 19:45:00.000000',00000000000000909340),('2024-06-20 19:50:00.000000',00000000000000915529),('2024-06-20 19:55:00.000000',00000000000000922219),('2024-06-20 20:00:00.000000',00000000000000946009),('2024-06-20 20:05:00.000000',00000000000000953809),('2024-06-20 20:10:00.000000',00000000000000963939),('2024-06-20 20:15:00.000000',00000000000000967839),('2024-06-20 20:20:00.000000',00000000000000971828),('2024-06-20 20:25:00.000000',00000000000000971828),('2024-06-20 20:30:00.000000',00000000000000971828),('2024-06-20 20:35:00.000000',00000000000000984718),('2024-06-20 20:40:00.000000',00000000000000988618),('2024-06-20 20:45:00.000000',00000000000000993907),('2024-06-20 20:50:00.000000',00000000000001004687),('2024-06-20 20:55:00.000000',00000000000001006687),('2024-06-20 21:00:00.000000',00000000000001012587),('2024-06-20 21:05:00.000000',00000000000001029387),('2024-06-20 21:10:00.000000',00000000000001065886),('2024-06-20 21:15:00.000000',00000000000001073776),('2024-06-20 21:20:00.000000',00000000000001078776),('2024-06-20 21:25:00.000000',00000000000001091676),('2024-06-20 21:30:00.000000',00000000000001095674),('2024-06-20 21:35:00.000000',00000000000001150064),('2024-06-20 21:40:00.000000',00000000000001167064),('2024-06-20 21:45:00.000000',00000000000001172954),('2024-06-20 21:50:00.000000',00000000000001174954),('2024-06-20 21:55:00.000000',00000000000001173954),('2024-06-20 22:00:00.000000',00000000000001179944),('2024-06-20 22:05:00.000000',00000000000001187913),('2024-06-20 22:10:00.000000',00000000000001192903),('2024-06-20 22:15:00.000000',00000000000001195903),('2024-06-20 22:20:00.000000',00000000000001200892),('2024-06-20 22:25:00.000000',00000000000001201892),('2024-06-20 22:30:00.000000',00000000000001209872),('2024-06-20 22:35:00.000000',00000000000001209872),('2024-06-20 22:40:00.000000',00000000000001209872),('2024-06-20 22:45:00.000000',00000000000001216872),('2024-06-20 22:50:00.000000',00000000000001216872),('2024-06-20 22:55:00.000000',00000000000001223672),('2024-06-20 23:00:00.000000',00000000000001229662),('2024-06-20 23:05:00.000000',00000000000001229662),('2024-06-20 23:10:00.000000',00000000000001238462),('2024-06-20 23:15:00.000000',00000000000001245362),('2024-06-20 23:20:00.000000',00000000000001256162),('2024-06-20 23:25:00.000000',00000000000001260062),('2024-06-20 23:30:00.000000',00000000000001262062),('2024-06-20 23:35:00.000000',00000000000001269962),('2024-06-20 23:40:00.000000',00000000000001290762),('2024-06-20 23:45:00.000000',00000000000001290762),('2024-06-20 23:50:00.000000',00000000000001302552),('2024-06-20 23:55:00.000000',00000000000001319342),('2024-06-21 00:00:00.000000',00000000000001324842),('2024-06-21 00:05:00.000000',00000000000001329842),('2024-06-21 00:10:00.000000',00000000000001335831),('2024-06-21 00:15:00.000000',00000000000001346800),('2024-06-21 00:20:00.000000',00000000000001356689),('2024-06-21 00:25:00.000000',00000000000001356689),('2024-06-21 00:30:00.000000',00000000000001358678),('2024-06-21 00:35:00.000000',00000000000001367646),('2024-06-21 00:40:00.000000',00000000000001385446),('2024-06-21 00:45:00.000000',00000000000001393346),('2024-06-21 00:50:00.000000',00000000000001403224),('2024-06-21 00:55:00.000000',00000000000001404224),('2024-06-21 01:00:00.000000',00000000000001415114),('2024-06-21 01:05:00.000000',00000000000001419104),('2024-06-21 01:10:00.000000',00000000000001429284),('2024-06-21 01:15:00.000000',00000000000001440984),('2024-06-21 01:20:00.000000',00000000000001445884),('2024-06-21 01:25:00.000000',00000000000001462764),('2024-06-21 01:30:00.000000',00000000000001463264),('2024-06-21 01:35:00.000000',00000000000001469130),('2024-06-21 01:40:00.000000',00000000000001470130),('2024-06-21 01:45:00.000000',00000000000001475030),('2024-06-21 01:50:00.000000',00000000000001487909),('2024-06-21 01:55:00.000000',00000000000001490964),('2024-06-21 02:00:00.000000',00000000000001486064),('2024-06-21 02:05:00.000000',00000000000001494032),('2024-06-21 02:10:00.000000',00000000000001502422),('2024-06-21 02:15:00.000000',00000000000001524122),('2024-06-21 02:20:00.000000',00000000000001535922),('2024-06-21 02:25:00.000000',00000000000001539922),('2024-06-21 02:30:00.000000',00000000000001543822),('2024-06-21 02:35:00.000000',00000000000001552702),('2024-06-21 02:40:00.000000',00000000000001556692),('2024-06-21 02:45:00.000000',00000000000001578552),('2024-06-21 02:50:00.000000',00000000000001611491),('2024-06-21 02:55:00.000000',00000000000001631411),('2024-06-21 03:00:00.000000',00000000000001652860),('2024-06-21 03:05:00.000000',00000000000001657860),('2024-06-21 03:10:00.000000',00000000000001688829),('2024-06-21 03:15:00.000000',00000000000001702798),('2024-06-21 03:20:00.000000',00000000000001716668),('2024-06-21 03:25:00.000000',00000000000001726948),('2024-06-21 03:30:00.000000',00000000000001735938),('2024-06-21 03:35:00.000000',00000000000001767767),('2024-06-21 03:40:00.000000',00000000000001792586),('2024-06-21 03:45:00.000000',00000000000001800146),('2024-06-21 03:50:00.000000',00000000000001821906),('2024-06-21 03:55:00.000000',00000000000001842556),('2024-06-21 04:00:00.000000',00000000000001859336),('2024-06-21 04:05:00.000000',00000000000001871296),('2024-06-21 04:10:00.000000',00000000000001938095),('2024-06-21 04:15:00.000000',00000000000001963933),('2024-06-21 04:20:00.000000',00000000000001982583),('2024-06-21 04:25:00.000000',00000000000002003411),('2024-06-21 04:30:00.000000',00000000000002004411),('2024-06-21 04:35:00.000000',00000000000002024291),('2024-06-21 04:40:00.000000',00000000000002040361),('2024-06-21 04:45:00.000000',00000000000002052821),('2024-06-21 04:50:00.000000',00000000000002066590),('2024-06-21 04:55:00.000000',00000000000002092160),('2024-06-21 05:00:00.000000',00000000000002295530),('2024-06-21 05:05:00.000000',00000000000002296920),('2024-06-21 05:10:00.000000',00000000000002299900),('2024-06-21 05:15:00.000000',00000000000002303890),('2024-06-21 05:20:00.000000',00000000000002323630),('2024-06-21 05:25:00.000000',00000000000002338400),('2024-06-21 05:30:00.000000',00000000000002350380),('2024-06-21 05:35:00.000000',00000000000002363860),('2024-06-21 05:40:00.000000',00000000000002383738),('2024-06-21 05:45:00.000000',00000000000002409038),('2024-06-21 05:50:00.000000',00000000000002422897),('2024-06-21 05:55:00.000000',00000000000002433155),('2024-06-21 06:00:00.000000',00000000000002450192),('2024-06-21 06:05:00.000000',00000000000002460092),('2024-06-21 06:10:00.000000',00000000000002469071),('2024-06-21 06:15:00.000000',00000000000002479061),('2024-06-21 06:20:00.000000',00000000000002507850),('2024-06-21 06:25:00.000000',00000000000002527630),('2024-06-21 06:30:00.000000',00000000000002545509),('2024-06-21 06:35:00.000000',00000000000002551589),('2024-06-21 06:40:00.000000',00000000000002567979),('2024-06-21 06:45:00.000000',00000000000002570879),('2024-06-21 06:50:00.000000',00000000000002574848),('2024-06-21 06:55:00.000000',00000000000002589628),('2024-06-21 07:00:00.000000',00000000000002603428),('2024-06-21 07:05:00.000000',00000000000002611908),('2024-06-21 07:10:00.000000',00000000000002613908),('2024-06-21 07:15:00.000000',00000000000002626887),('2024-06-21 07:20:00.000000',00000000000002639836),('2024-06-21 07:25:00.000000',00000000000002672456),('2024-06-21 07:30:00.000000',00000000000002710376),('2024-06-21 07:35:00.000000',00000000000002724896),('2024-06-21 07:40:00.000000',00000000000002739324),('2024-06-21 07:45:00.000000',00000000000002767462),('2024-06-21 07:50:00.000000',00000000000002792761),('2024-06-21 07:55:00.000000',00000000000002814340),('2024-06-21 08:00:00.000000',00000000000002814831),('2024-06-21 08:05:00.000000',00000000000002830531),('2024-06-21 08:10:00.000000',00000000000002835521),('2024-06-21 08:15:00.000000',00000000000002839621),('2024-06-21 08:20:00.000000',00000000000002852980),('2024-06-21 08:25:00.000000',00000000000002864870),('2024-06-21 08:30:00.000000',00000000000002874740),('2024-06-21 08:35:00.000000',00000000000002883618),('2024-06-21 08:40:00.000000',00000000000002896418),('2024-06-21 08:45:00.000000',00000000000002943218),('2024-06-21 08:50:00.000000',00000000000002969796),('2024-06-21 08:55:00.000000',00000000000002985696),('2024-06-21 09:00:00.000000',00000000000002985696),('2024-06-21 09:05:00.000000',00000000000003000496),('2024-06-21 09:10:00.000000',00000000000003004486),('2024-06-21 09:15:00.000000',00000000000003016476),('2024-06-21 09:20:00.000000',00000000000003026365),('2024-06-21 09:25:00.000000',00000000000003031334),('2024-06-21 09:30:00.000000',00000000000003055091),('2024-06-21 09:35:00.000000',00000000000003069381),('2024-06-21 09:40:00.000000',00000000000003072880),('2024-06-21 09:45:00.000000',00000000000003095480),('2024-06-21 09:50:00.000000',00000000000003109280),('2024-06-21 09:55:00.000000',00000000000003116635),('2024-06-21 10:00:00.000000',00000000000003134325),('2024-06-21 10:05:00.000000',00000000000003151771),('2024-06-21 10:10:00.000000',00000000000003170350),('2024-06-21 10:15:00.000000',00000000000003219122),('2024-06-21 10:20:00.000000',00000000000003240842),('2024-06-21 10:25:00.000000',00000000000003267512),('2024-06-21 10:30:00.000000',00000000000003282212),('2024-06-21 10:35:00.000000',00000000000003312592),('2024-06-21 10:40:00.000000',00000000000003326872),('2024-06-21 10:45:00.000000',00000000000003326872),('2024-06-21 10:50:00.000000',00000000000003331772),('2024-06-21 10:55:00.000000',00000000000003346972),('2024-06-21 11:00:00.000000',00000000000003351952),('2024-06-21 11:05:00.000000',00000000000003360741),('2024-06-21 11:10:00.000000',00000000000003368641),('2024-06-21 11:15:00.000000',00000000000003375541),('2024-06-21 11:20:00.000000',00000000000003375541),('2024-06-21 11:25:00.000000',00000000000003386441),('2024-06-21 11:30:00.000000',00000000000003395341),('2024-06-21 11:35:00.000000',00000000000003411141),('2024-06-21 11:40:00.000000',00000000000003424641),('2024-06-21 11:45:00.000000',00000000000003426741),('2024-06-21 11:50:00.000000',00000000000003439789),('2024-06-21 11:55:00.000000',00000000000003454689),('2024-06-21 12:00:00.000000',00000000000003460589),('2024-06-21 12:05:00.000000',00000000000003468468),('2024-06-21 12:10:00.000000',00000000000003475356),('2024-06-21 12:15:00.000000',00000000000003487257),('2024-06-21 12:20:00.000000',00000000000003486256),('2024-06-21 12:25:00.000000',00000000000003504215),('2024-06-21 12:30:00.000000',00000000000003515595),('2024-06-21 12:35:00.000000',00000000000003520574),('2024-06-21 12:40:00.000000',00000000000003534551),('2024-06-21 12:45:00.000000',00000000000003540540),('2024-06-21 12:50:00.000000',00000000000003544440),('2024-06-21 12:55:00.000000',00000000000003554340),('2024-06-21 13:00:00.000000',00000000000003564740),('2024-06-21 13:05:00.000000',00000000000003570730),('2024-06-21 13:10:00.000000',00000000000003574730),('2024-06-21 13:15:00.000000',00000000000003616820),('2024-06-21 13:20:00.000000',00000000000003637600),('2024-06-21 13:25:00.000000',00000000000003644290),('2024-06-21 13:30:00.000000',00000000000003686590),('2024-06-21 13:35:00.000000',00000000000003720945),('2024-06-21 13:40:00.000000',00000000000003723045),('2024-06-21 13:45:00.000000',00000000000003748445),('2024-06-21 13:50:00.000000',00000000000003896645),('2024-06-21 13:55:00.000000',00000000000003905445),('2024-06-21 14:00:00.000000',00000000000003926135),('2024-06-21 14:05:00.000000',00000000000003948491),('2024-06-21 14:10:00.000000',00000000000003981179),('2024-06-21 14:15:00.000000',00000000000003992268),('2024-06-21 14:20:00.000000',00000000000003992868),('2024-06-21 14:25:00.000000',00000000000004137057),('2024-06-21 14:30:00.000000',00000000000004152337),('2024-06-21 14:35:00.000000',00000000000004168137),('2024-06-21 14:40:00.000000',00000000000004187037),('2024-06-21 14:45:00.000000',00000000000004200717),('2024-06-21 14:50:00.000000',00000000000004200106),('2024-06-21 14:55:00.000000',00000000000004217894),('2024-06-21 15:00:00.000000',00000000000004275583),('2024-06-21 15:05:00.000000',00000000000004281483),('2024-06-21 15:10:00.000000',00000000000004301183),('2024-06-21 15:15:00.000000',00000000000004316962),('2024-06-21 15:20:00.000000',00000000000004340762),('2024-06-21 15:25:00.000000',00000000000004402762),('2024-06-21 15:30:00.000000',00000000000004430251),('2024-06-21 15:35:00.000000',00000000000004436151),('2024-06-21 15:40:00.000000',00000000000004492440),('2024-06-21 15:45:00.000000',00000000000004512640),('2024-06-21 15:50:00.000000',00000000000004499450),('2024-06-21 15:55:00.000000',00000000000004471138),('2024-06-21 16:00:00.000000',00000000000000000000),('2024-06-21 16:05:00.000000',00000000000000027780),('2024-06-21 16:10:00.000000',00000000000000042659),('2024-06-21 16:15:00.000000',00000000000000054179),('2024-06-21 16:20:00.000000',00000000000000071279),('2024-06-21 16:25:00.000000',00000000000000098038),('2024-06-21 16:30:00.000000',00000000000000106917),('2024-06-21 16:35:00.000000',00000000000000119717),('2024-06-21 16:40:00.000000',00000000000000133707),('2024-06-21 16:45:00.000000',00000000000000135707),('2024-06-21 16:50:00.000000',00000000000000213407),('2024-06-21 16:55:00.000000',00000000000000224015),('2024-06-21 17:00:00.000000',00000000000000245328),('2024-06-21 17:05:00.000000',00000000000000291028),('2024-06-21 17:10:00.000000',00000000000000305797),('2024-06-21 17:15:00.000000',00000000000000309875),('2024-06-21 17:20:00.000000',00000000000000314275),('2024-06-21 17:25:00.000000',00000000000000333044),('2024-06-21 17:30:00.000000',00000000000000352944),('2024-06-21 17:35:00.000000',00000000000000367712),('2024-06-21 17:40:00.000000',00000000000000379268),('2024-06-21 17:45:00.000000',00000000000000391258),('2024-06-21 17:50:00.000000',00000000000000405048),('2024-06-21 17:55:00.000000',00000000000000417994),('2024-06-21 18:00:00.000000',00000000000000418963),('2024-06-21 18:05:00.000000',00000000000000423953),('2024-06-21 18:10:00.000000',00000000000000427753),('2024-06-21 18:15:00.000000',00000000000000444542),('2024-06-21 18:20:00.000000',00000000000000449510),('2024-06-21 18:25:00.000000',00000000000000450500),('2024-06-21 18:30:00.000000',00000000000000452489),('2024-06-21 18:35:00.000000',00000000000000456488),('2024-06-21 18:40:00.000000',00000000000000456888),('2024-06-21 18:45:00.000000',00000000000000464778),('2024-06-21 18:50:00.000000',00000000000000477567),('2024-06-21 18:55:00.000000',00000000000000477567),('2024-06-21 19:00:00.000000',00000000000000482546),('2024-06-21 19:05:00.000000',00000000000000487446),('2024-06-21 19:10:00.000000',00000000000000487446),('2024-06-21 19:15:00.000000',00000000000000494413),('2024-06-21 19:20:00.000000',00000000000000501382),('2024-06-21 19:25:00.000000',00000000000000505871),('2024-06-21 19:30:00.000000',00000000000000505871),('2024-06-21 19:35:00.000000',00000000000000510751),('2024-06-21 19:40:00.000000',00000000000000525531),('2024-06-21 19:45:00.000000',00000000000000531431),('2024-06-21 19:50:00.000000',00000000000000543131),('2024-06-21 19:55:00.000000',00000000000000546121),('2024-06-21 20:00:00.000000',00000000000000550111),('2024-06-21 20:05:00.000000',00000000000000550111),('2024-06-21 20:10:00.000000',00000000000000563026),('2024-06-21 20:15:00.000000',00000000000000563026),('2024-06-21 20:20:00.000000',00000000000000568015),('2024-06-21 20:25:00.000000',00000000000000574273),('2024-06-21 20:30:00.000000',00000000000000578273),('2024-06-21 20:35:00.000000',00000000000000582273),('2024-06-21 20:40:00.000000',00000000000000584273),('2024-06-21 20:45:00.000000',00000000000000584273),('2024-06-21 20:50:00.000000',00000000000000591073),('2024-06-21 20:55:00.000000',00000000000000601963),('2024-06-21 21:00:00.000000',00000000000000601963),('2024-06-21 21:05:00.000000',00000000000000613852),('2024-06-21 21:10:00.000000',00000000000000617852),('2024-06-21 21:15:00.000000',00000000000000629352),('2024-06-21 21:20:00.000000',00000000000000640152),('2024-06-21 21:25:00.000000',00000000000000647752),('2024-06-21 21:30:00.000000',00000000000000647752),('2024-06-21 21:35:00.000000',00000000000000665342),('2024-06-21 21:40:00.000000',00000000000000667342),('2024-06-21 21:45:00.000000',00000000000000676952),('2024-06-21 21:50:00.000000',00000000000000676952),('2024-06-21 21:55:00.000000',00000000000000679952),('2024-06-21 22:00:00.000000',00000000000000683852),('2024-06-21 22:05:00.000000',00000000000000684852),('2024-06-21 22:10:00.000000',00000000000000685852),('2024-06-21 22:15:00.000000',00000000000000685852),('2024-06-21 22:20:00.000000',00000000000000687852),('2024-06-21 22:25:00.000000',00000000000000688852),('2024-06-21 22:30:00.000000',00000000000000690852),('2024-06-21 22:35:00.000000',00000000000000702752),('2024-06-21 22:40:00.000000',00000000000000706752),('2024-06-21 22:45:00.000000',00000000000000707742),('2024-06-21 22:50:00.000000',00000000000001097532),('2024-06-21 22:55:00.000000',00000000000001100511),('2024-06-21 23:00:00.000000',00000000000001104511),('2024-06-21 23:05:00.000000',00000000000001104511),('2024-06-21 23:10:00.000000',00000000000001106611),('2024-06-21 23:15:00.000000',00000000000001110611),('2024-06-21 23:20:00.000000',00000000000001112600),('2024-06-21 23:25:00.000000',00000000000001120489),('2024-06-21 23:30:00.000000',00000000000001120489),('2024-06-21 23:35:00.000000',00000000000001120489),('2024-06-21 23:40:00.000000',00000000000001124479),('2024-06-21 23:45:00.000000',00000000000001149379),('2024-06-21 23:50:00.000000',00000000000001161279),('2024-06-21 23:55:00.000000',00000000000001161279),('2024-06-22 00:00:00.000000',00000000000001164279),('2024-06-22 00:05:00.000000',00000000000001170679),('2024-06-22 00:10:00.000000',00000000000001180579),('2024-06-22 00:15:00.000000',00000000000001185468),('2024-06-22 00:20:00.000000',00000000000001185468),('2024-06-22 00:25:00.000000',00000000000001199336),('2024-06-22 00:30:00.000000',00000000000001210225),('2024-06-22 00:35:00.000000',00000000000001232514),('2024-06-22 00:40:00.000000',00000000000001235514),('2024-06-22 00:45:00.000000',00000000000001248814),('2024-06-22 00:50:00.000000',00000000000001293614),('2024-06-22 00:55:00.000000',00000000000001305514),('2024-06-22 01:00:00.000000',00000000000001311003),('2024-06-22 01:05:00.000000',00000000000001315992),('2024-06-22 01:10:00.000000',00000000000001319992),('2024-06-22 01:15:00.000000',00000000000001332782),('2024-06-22 01:20:00.000000',00000000000001349462),('2024-06-22 01:25:00.000000',00000000000001374241),('2024-06-22 01:30:00.000000',00000000000001378907),('2024-06-22 01:35:00.000000',00000000000001399676),('2024-06-22 01:40:00.000000',00000000000001408376),('2024-06-22 01:45:00.000000',00000000000001425076),('2024-06-22 01:50:00.000000',00000000000001557456),('2024-06-22 01:55:00.000000',00000000000001563445),('2024-06-22 02:00:00.000000',00000000000001587214),('2024-06-22 02:05:00.000000',00000000000001596304),('2024-06-22 02:10:00.000000',00000000000001606204),('2024-06-22 02:15:00.000000',00000000000001650074),('2024-06-22 02:20:00.000000',00000000000001922274),('2024-06-22 02:25:00.000000',00000000000001934143),('2024-06-22 02:30:00.000000',00000000000001942043),('2024-06-22 02:35:00.000000',00000000000001966023),('2024-06-22 02:40:00.000000',00000000000002008923),('2024-06-22 02:45:00.000000',00000000000002030913),('2024-06-22 02:50:00.000000',00000000000002048841),('2024-06-22 02:55:00.000000',00000000000002058821),('2024-06-22 03:00:00.000000',00000000000002083691),('2024-06-22 03:05:00.000000',00000000000002397478),('2024-06-22 03:10:00.000000',00000000000002401367),('2024-06-22 03:15:00.000000',00000000000002429136),('2024-06-22 03:20:00.000000',00000000000002443994),('2024-06-22 03:25:00.000000',00000000000002467944),('2024-06-22 03:30:00.000000',00000000000002486934),('2024-06-22 03:35:00.000000',00000000000002522684),('2024-06-22 03:40:00.000000',00000000000002607384),('2024-06-22 03:45:00.000000',00000000000002631753),('2024-06-22 03:50:00.000000',00000000000002653523),('2024-06-22 03:55:00.000000',00000000000002659513),('2024-06-22 04:00:00.000000',00000000000002681593),('2024-06-22 04:05:00.000000',00000000000002698073),('2024-06-22 04:10:00.000000',00000000000002704073),('2024-06-22 04:15:00.000000',00000000000002713963),('2024-06-22 04:20:00.000000',00000000000002718963),('2024-06-22 04:25:00.000000',00000000000002736663),('2024-06-22 04:30:00.000000',00000000000002740663),('2024-06-22 04:35:00.000000',00000000000002747643),('2024-06-22 04:40:00.000000',00000000000002747643),('2024-06-22 04:45:00.000000',00000000000002764433),('2024-06-22 04:50:00.000000',00000000000002768423),('2024-06-22 04:55:00.000000',00000000000002775392),('2024-06-22 05:00:00.000000',00000000000002780382),('2024-06-22 05:05:00.000000',00000000000002780382),('2024-06-22 05:10:00.000000',00000000000002799772),('2024-06-22 05:15:00.000000',00000000000002817462),('2024-06-22 05:20:00.000000',00000000000002840001),('2024-06-22 05:25:00.000000',00000000000002866530),('2024-06-22 05:30:00.000000',00000000000002888789),('2024-06-22 05:35:00.000000',00000000000002920526),('2024-06-22 05:40:00.000000',00000000000002933385),('2024-06-22 05:45:00.000000',00000000000002954423),('2024-06-22 05:50:00.000000',00000000000002996070),('2024-06-22 05:55:00.000000',00000000000003052818),('2024-06-22 06:00:00.000000',00000000000003078555),('2024-06-22 06:05:00.000000',00000000000003095293),('2024-06-22 06:10:00.000000',00000000000003134883),('2024-06-22 06:15:00.000000',00000000000003180143),('2024-06-22 06:20:00.000000',00000000000003239519),('2024-06-22 06:25:00.000000',00000000000003272693),('2024-06-22 06:30:00.000000',00000000000003309887),('2024-06-22 06:35:00.000000',00000000000003317865),('2024-06-22 06:40:00.000000',00000000000003327754),('2024-06-22 06:45:00.000000',00000000000003336633),('2024-06-22 06:50:00.000000',00000000000003346501),('2024-06-22 06:55:00.000000',00000000000003388315),('2024-06-22 07:00:00.000000',00000000000003399273),('2024-06-22 07:05:00.000000',00000000000003426852),('2024-06-22 07:10:00.000000',00000000000003436652),('2024-06-22 07:15:00.000000',00000000000003457620),('2024-06-22 07:20:00.000000',00000000000003463509),('2024-06-22 07:25:00.000000',00000000000003489766),('2024-06-22 07:30:00.000000',00000000000003504146),('2024-06-22 07:35:00.000000',00000000000003512925),('2024-06-22 07:40:00.000000',00000000000003539425),('2024-06-22 07:45:00.000000',00000000000003548215),('2024-06-22 07:50:00.000000',00000000000003586395),('2024-06-22 07:55:00.000000',00000000000003597195),('2024-06-22 08:00:00.000000',00000000000003606175),('2024-06-22 08:05:00.000000',00000000000003616075),('2024-06-22 08:10:00.000000',00000000000003619065),('2024-06-22 08:15:00.000000',00000000000003649220),('2024-06-22 08:20:00.000000',00000000000003657209),('2024-06-22 08:25:00.000000',00000000000003680799),('2024-06-22 08:30:00.000000',00000000000003708159),('2024-06-22 08:35:00.000000',00000000000003732817),('2024-06-22 08:40:00.000000',00000000000003750685),('2024-06-22 08:45:00.000000',00000000000003768155),('2024-06-22 08:50:00.000000',00000000000003780224),('2024-06-22 08:55:00.000000',00000000000003786714),('2024-06-22 09:00:00.000000',00000000000003811504),('2024-06-22 09:05:00.000000',00000000000003854004),('2024-06-22 09:10:00.000000',00000000000003865804),('2024-06-22 09:15:00.000000',00000000000003870794),('2024-06-22 09:20:00.000000',00000000000003876694),('2024-06-22 09:25:00.000000',00000000000003881694),('2024-06-22 09:30:00.000000',00000000000003884794),('2024-06-22 09:35:00.000000',00000000000003895282),('2024-06-22 09:40:00.000000',00000000000003896282),('2024-06-22 09:45:00.000000',00000000000003914081),('2024-06-22 09:50:00.000000',00000000000003926881),('2024-06-22 09:55:00.000000',00000000000003944581),('2024-06-22 10:00:00.000000',00000000000003952560),('2024-06-22 10:05:00.000000',00000000000003970760),('2024-06-22 10:10:00.000000',00000000000003989789),('2024-06-22 10:15:00.000000',00000000000004004658),('2024-06-22 10:20:00.000000',00000000000004019858),('2024-06-22 10:25:00.000000',00000000000004018958),('2024-06-22 10:30:00.000000',00000000000004023936),('2024-06-22 10:35:00.000000',00000000000004034736),('2024-06-22 10:40:00.000000',00000000000004039726),('2024-06-22 10:45:00.000000',00000000000004048714),('2024-06-22 10:50:00.000000',00000000000004054214),('2024-06-22 10:55:00.000000',00000000000004069893),('2024-06-22 11:00:00.000000',00000000000004069893),('2024-06-22 11:05:00.000000',00000000000004083873),('2024-06-22 11:10:00.000000',00000000000004086273),('2024-06-22 11:15:00.000000',00000000000004092073),('2024-06-22 11:20:00.000000',00000000000004095703),('2024-06-22 11:25:00.000000',00000000000004105593),('2024-06-22 11:30:00.000000',00000000000004106593),('2024-06-22 11:35:00.000000',00000000000004118382),('2024-06-22 11:40:00.000000',00000000000004131260),('2024-06-22 11:45:00.000000',00000000000004147649),('2024-06-22 11:50:00.000000',00000000000004151949),('2024-06-22 11:55:00.000000',00000000000004171239),('2024-06-22 12:00:00.000000',00000000000004180108),('2024-06-22 12:05:00.000000',00000000000004194497),('2024-06-22 12:10:00.000000',00000000000004203047),('2024-06-22 12:15:00.000000',00000000000004205047),('2024-06-22 12:20:00.000000',00000000000004208947),('2024-06-22 12:25:00.000000',00000000000004220827),('2024-06-22 12:30:00.000000',00000000000004235327),('2024-06-22 12:35:00.000000',00000000000004241906),('2024-06-22 12:40:00.000000',00000000000004263676),('2024-06-22 12:45:00.000000',00000000000004264676),('2024-06-22 12:50:00.000000',00000000000004264676),('2024-06-22 12:55:00.000000',00000000000004273456),('2024-06-22 13:00:00.000000',00000000000004277445),('2024-06-22 13:05:00.000000',00000000000004289325),('2024-06-22 13:10:00.000000',00000000000004334224),('2024-06-22 13:15:00.000000',00000000000004336224),('2024-06-22 13:20:00.000000',00000000000004356114),('2024-06-22 13:25:00.000000',00000000000005061942),('2024-06-22 13:30:00.000000',00000000000005072832),('2024-06-22 13:35:00.000000',00000000000005082632),('2024-06-22 13:40:00.000000',00000000000005085622),('2024-06-22 13:45:00.000000',00000000000005099589),('2024-06-22 13:50:00.000000',00000000000005110089),('2024-06-22 13:55:00.000000',00000000000005111089),('2024-06-22 14:00:00.000000',00000000000005117479),('2024-06-22 14:05:00.000000',00000000000005132497),('2024-06-22 14:10:00.000000',00000000000005148923),('2024-06-22 14:15:00.000000',00000000000005165682),('2024-06-22 14:20:00.000000',00000000000005185450),('2024-06-22 14:25:00.000000',00000000000005202830),('2024-06-22 14:30:00.000000',00000000000005210730),('2024-06-22 14:35:00.000000',00000000000005227519),('2024-06-22 14:40:00.000000',00000000000005248309),('2024-06-22 14:45:00.000000',00000000000005273276),('2024-06-22 14:50:00.000000',00000000000005286265),('2024-06-22 14:55:00.000000',00000000000005293255),('2024-06-22 15:00:00.000000',00000000000005303235),('2024-06-22 15:05:00.000000',00000000000005313935),('2024-06-22 15:10:00.000000',00000000000005343425),('2024-06-22 15:15:00.000000',00000000000005366125),('2024-06-22 15:20:00.000000',00000000000005374325),('2024-06-22 15:25:00.000000',00000000000005384225),('2024-06-22 15:30:00.000000',00000000000005402603),('2024-06-22 15:35:00.000000',00000000000005413503),('2024-06-22 15:40:00.000000',00000000000005425992),('2024-06-22 15:45:00.000000',00000000000005431192),('2024-06-22 15:50:00.000000',00000000000005450992),('2024-06-22 15:55:00.000000',00000000000005463692),('2024-06-22 16:00:00.000000',00000000000000000000),('2024-06-22 16:05:00.000000',00000000000000006000),('2024-06-22 16:10:00.000000',00000000000000010900),('2024-06-22 16:15:00.000000',00000000000000022700),('2024-06-22 16:20:00.000000',00000000000000040448),('2024-06-22 16:25:00.000000',00000000000000051247),('2024-06-22 16:30:00.000000',00000000000000062047),('2024-06-22 16:35:00.000000',00000000000000072046),('2024-06-22 16:40:00.000000',00000000000000094446),('2024-06-22 16:45:00.000000',00000000000000113814),('2024-06-22 16:50:00.000000',00000000000000121000),('2024-06-22 16:55:00.000000',00000000000000153477),('2024-06-22 17:00:00.000000',00000000000000162064),('2024-06-22 17:05:00.000000',00000000000000190633),('2024-06-22 17:10:00.000000',00000000000000201333),('2024-06-22 17:15:00.000000',00000000000000213032),('2024-06-22 17:20:00.000000',00000000000000213632),('2024-06-22 17:25:00.000000',00000000000000226112),('2024-06-22 17:30:00.000000',00000000000000227012),('2024-06-22 17:35:00.000000',00000000000000229012),('2024-06-22 17:40:00.000000',00000000000000235011),('2024-06-22 17:45:00.000000',00000000000000242911),('2024-06-22 17:50:00.000000',00000000000000242911),('2024-06-22 17:55:00.000000',00000000000000246011),('2024-06-22 18:00:00.000000',00000000000000251911),('2024-06-22 18:05:00.000000',00000000000000264611),('2024-06-22 18:10:00.000000',00000000000000270911),('2024-06-22 18:15:00.000000',00000000000000281910),('2024-06-22 18:20:00.000000',00000000000000311296),('2024-06-22 18:25:00.000000',00000000000000332696),('2024-06-22 18:30:00.000000',00000000000000364896),('2024-06-22 18:35:00.000000',00000000000000385074),('2024-06-22 18:40:00.000000',00000000000000404864),('2024-06-22 18:45:00.000000',00000000000000426664),('2024-06-22 18:50:00.000000',00000000000000433653),('2024-06-22 18:55:00.000000',00000000000000438753),('2024-06-22 19:00:00.000000',00000000000000460742),('2024-06-22 19:05:00.000000',00000000000000459497),('2024-06-22 19:10:00.000000',00000000000000460497),('2024-06-22 19:15:00.000000',00000000000000462497),('2024-06-22 19:20:00.000000',00000000000000465697),('2024-06-22 19:25:00.000000',00000000000000473597),('2024-06-22 19:30:00.000000',00000000000000489697),('2024-06-22 19:35:00.000000',00000000000000491697),('2024-06-22 19:40:00.000000',00000000000000493686),('2024-06-22 19:45:00.000000',00000000000000493686),('2024-06-22 19:50:00.000000',00000000000000493686),('2024-06-22 19:55:00.000000',00000000000000493686),('2024-06-22 20:00:00.000000',00000000000000495686),('2024-06-22 20:05:00.000000',00000000000000507575),('2024-06-22 20:10:00.000000',00000000000000509575),('2024-06-22 20:15:00.000000',00000000000000509575),('2024-06-22 20:20:00.000000',00000000000000509575),('2024-06-22 20:25:00.000000',00000000000000511564),('2024-06-22 20:30:00.000000',00000000000000530934),('2024-06-22 20:35:00.000000',00000000000000540900),('2024-06-22 20:40:00.000000',00000000000000551957),('2024-06-22 20:45:00.000000',00000000000000558857),('2024-06-22 20:50:00.000000',00000000000000558857),('2024-06-22 20:55:00.000000',00000000000000562356),('2024-06-22 21:00:00.000000',00000000000000575155),('2024-06-22 21:05:00.000000',00000000000000575155),('2024-06-22 21:10:00.000000',00000000000000579055),('2024-06-22 21:15:00.000000',00000000000000581955),('2024-06-22 21:20:00.000000',00000000000000587955),('2024-06-22 21:25:00.000000',00000000000000602354),('2024-06-22 21:30:00.000000',00000000000000602354),('2024-06-22 21:35:00.000000',00000000000000607554),('2024-06-22 21:40:00.000000',00000000000000607554),('2024-06-22 21:45:00.000000',00000000000000611454),('2024-06-22 21:50:00.000000',00000000000000631032),('2024-06-22 21:55:00.000000',00000000000000640921),('2024-06-22 22:00:00.000000',00000000000000640921),('2024-06-22 22:05:00.000000',00000000000000640921),('2024-06-22 22:10:00.000000',00000000000000640921),('2024-06-22 22:15:00.000000',00000000000000640921),('2024-06-22 22:20:00.000000',00000000000000648621),('2024-06-22 22:25:00.000000',00000000000000655521),('2024-06-22 22:30:00.000000',00000000000000657521),('2024-06-22 22:35:00.000000',00000000000000652621),('2024-06-22 22:40:00.000000',00000000000000663421),('2024-06-22 22:45:00.000000',00000000000000659409),('2024-06-22 22:50:00.000000',00000000000000674509),('2024-06-22 22:55:00.000000',00000000000000678409),('2024-06-22 23:00:00.000000',00000000000000680009),('2024-06-22 23:05:00.000000',00000000000000687909),('2024-06-22 23:10:00.000000',00000000000000687909),('2024-06-22 23:15:00.000000',00000000000000687909),('2024-06-22 23:20:00.000000',00000000000000687909),('2024-06-22 23:25:00.000000',00000000000000689409),('2024-06-22 23:30:00.000000',00000000000000689409),('2024-06-22 23:35:00.000000',00000000000000689509),('2024-06-22 23:40:00.000000',00000000000000689509),('2024-06-22 23:45:00.000000',00000000000000693509),('2024-06-22 23:50:00.000000',00000000000000697409),('2024-06-22 23:55:00.000000',00000000000000709309),('2024-06-23 00:00:00.000000',00000000000000709309),('2024-06-23 00:05:00.000000',00000000000000709309),('2024-06-23 00:10:00.000000',00000000000000709309),('2024-06-23 00:15:00.000000',00000000000000715299),('2024-06-23 00:20:00.000000',00000000000000720199),('2024-06-23 00:25:00.000000',00000000000000720199),('2024-06-23 00:30:00.000000',00000000000000724199),('2024-06-23 00:35:00.000000',00000000000000731389),('2024-06-23 00:40:00.000000',00000000000000737389),('2024-06-23 00:45:00.000000',00000000000000739689),('2024-06-23 00:50:00.000000',00000000000000741789),('2024-06-23 00:55:00.000000',00000000000000755889),('2024-06-23 01:00:00.000000',00000000000000761789),('2024-06-23 01:05:00.000000',00000000000000767269),('2024-06-23 01:10:00.000000',00000000000000767269),('2024-06-23 01:15:00.000000',00000000000000771259),('2024-06-23 01:20:00.000000',00000000000000784749),('2024-06-23 01:25:00.000000',00000000000000788849),('2024-06-23 01:30:00.000000',00000000000000794828),('2024-06-23 01:35:00.000000',00000000000000802808),('2024-06-23 01:40:00.000000',00000000000000846387),('2024-06-23 01:45:00.000000',00000000000000847387),('2024-06-23 01:50:00.000000',00000000000000851377),('2024-06-23 01:55:00.000000',00000000000000869077),('2024-06-23 02:00:00.000000',00000000000000869077),('2024-06-23 02:05:00.000000',00000000000000885067),('2024-06-23 02:10:00.000000',00000000000000876167),('2024-06-23 02:15:00.000000',00000000000000879167),('2024-06-23 02:20:00.000000',00000000000000881167),('2024-06-23 02:25:00.000000',00000000000000891967),('2024-06-23 02:30:00.000000',00000000000000911656),('2024-06-23 02:35:00.000000',00000000000000911656),('2024-06-23 02:40:00.000000',00000000000000953416),('2024-06-23 02:45:00.000000',00000000000000961316),('2024-06-23 02:50:00.000000',00000000000000973216),('2024-06-23 02:55:00.000000',00000000000000984216),('2024-06-23 03:00:00.000000',00000000000001032095),('2024-06-23 03:05:00.000000',00000000000001069164),('2024-06-23 03:10:00.000000',00000000000001085942),('2024-06-23 03:15:00.000000',00000000000001101892),('2024-06-23 03:20:00.000000',00000000000001111872),('2024-06-23 03:25:00.000000',00000000000001163741),('2024-06-23 03:30:00.000000',00000000000001177700),('2024-06-23 03:35:00.000000',00000000000001194470),('2024-06-23 03:40:00.000000',00000000000001203350),('2024-06-23 03:45:00.000000',00000000000001216230),('2024-06-23 03:50:00.000000',00000000000001219130),('2024-06-23 03:55:00.000000',00000000000001220130),('2024-06-23 04:00:00.000000',00000000000001227126),('2024-06-23 04:05:00.000000',00000000000001263514),('2024-06-23 04:10:00.000000',00000000000001272412),('2024-06-23 04:15:00.000000',00000000000001290352),('2024-06-23 04:20:00.000000',00000000000001305741),('2024-06-23 04:25:00.000000',00000000000001656402),('2024-06-23 04:30:00.000000',00000000000001671592),('2024-06-23 04:35:00.000000',00000000000001694508),('2024-06-23 04:40:00.000000',00000000000001718576),('2024-06-23 04:45:00.000000',00000000000001728524),('2024-06-23 04:50:00.000000',00000000000001779620),('2024-06-23 04:55:00.000000',00000000000001801410),('2024-06-23 05:00:00.000000',00000000000001809608),('2024-06-23 05:05:00.000000',00000000000001823206),('2024-06-23 05:10:00.000000',00000000000001825186),('2024-06-23 05:15:00.000000',00000000000001834456),('2024-06-23 05:20:00.000000',00000000000001842026),('2024-06-23 05:25:00.000000',00000000000001848924),('2024-06-23 05:30:00.000000',00000000000001852824),('2024-06-23 05:35:00.000000',00000000000001856811),('2024-06-23 05:40:00.000000',00000000000001859711),('2024-06-23 05:45:00.000000',00000000000001872677),('2024-06-23 05:50:00.000000',00000000000001881557),('2024-06-23 05:55:00.000000',00000000000001884547),('2024-06-23 06:00:00.000000',00000000000001910436),('2024-06-23 06:05:00.000000',00000000000001917424),('2024-06-23 06:10:00.000000',00000000000001930314),('2024-06-23 06:15:00.000000',00000000000001932314),('2024-06-23 06:20:00.000000',00000000000001939614),('2024-06-23 06:25:00.000000',00000000000001949512),('2024-06-23 06:30:00.000000',00000000000001985890),('2024-06-23 06:35:00.000000',00000000000001992890),('2024-06-23 06:40:00.000000',00000000000001995888),('2024-06-23 06:45:00.000000',00000000000001996588),('2024-06-23 06:50:00.000000',00000000000002003576),('2024-06-23 06:55:00.000000',00000000000002014054),('2024-06-23 07:00:00.000000',00000000000002091322),('2024-06-23 07:05:00.000000',00000000000002110301),('2024-06-23 07:10:00.000000',00000000000002110301),('2024-06-23 07:15:00.000000',00000000000002112891),('2024-06-23 07:20:00.000000',00000000000002126789),('2024-06-23 07:25:00.000000',00000000000002127789),('2024-06-23 07:30:00.000000',00000000000002136579),('2024-06-23 07:35:00.000000',00000000000002152377),('2024-06-23 07:40:00.000000',00000000000002171075),('2024-06-23 07:45:00.000000',00000000000002219363),('2024-06-23 07:50:00.000000',00000000000002228652),('2024-06-23 07:55:00.000000',00000000000002241141),('2024-06-23 08:00:00.000000',00000000000002309029),('2024-06-23 08:05:00.000000',00000000000002332628),('2024-06-23 08:10:00.000000',00000000000002342526),('2024-06-23 08:15:00.000000',00000000000002475426),('2024-06-23 08:20:00.000000',00000000000002630526),('2024-06-23 08:25:00.000000',00000000000002647384),('2024-06-23 08:30:00.000000',00000000000002647384),('2024-06-23 08:35:00.000000',00000000000002658164),('2024-06-23 08:40:00.000000',00000000000002665064),('2024-06-23 08:45:00.000000',00000000000002673062),('2024-06-23 08:50:00.000000',00000000000002676162),('2024-06-23 08:55:00.000000',00000000000002693940),('2024-06-23 09:00:00.000000',00000000000002715630),('2024-06-23 09:05:00.000000',00000000000002596530),('2024-06-23 09:10:00.000000',00000000000002598528),('2024-06-23 09:15:00.000000',00000000000002612418),('2024-06-23 09:20:00.000000',00000000000002631304),('2024-06-23 09:25:00.000000',00000000000002632906),('2024-06-23 09:30:00.000000',00000000000002654582),('2024-06-23 09:35:00.000000',00000000000002670059),('2024-06-23 09:40:00.000000',00000000000002675059),('2024-06-23 09:45:00.000000',00000000000002984345),('2024-06-23 09:50:00.000000',00000000000002998235),('2024-06-23 09:55:00.000000',00000000000003003225),('2024-06-23 10:00:00.000000',00000000000003009125),('2024-06-23 10:05:00.000000',00000000000003029925),('2024-06-23 10:10:00.000000',00000000000003031925),('2024-06-23 10:15:00.000000',00000000000003043814),('2024-06-23 10:20:00.000000',00000000000003053593),('2024-06-23 10:25:00.000000',00000000000003074293),('2024-06-23 10:30:00.000000',00000000000003091362),('2024-06-23 10:35:00.000000',00000000000003120212),('2024-06-23 10:40:00.000000',00000000000003127112),('2024-06-23 10:45:00.000000',00000000000003139882),('2024-06-23 10:50:00.000000',00000000000003148782),('2024-06-23 10:55:00.000000',00000000000003152271),('2024-06-23 11:00:00.000000',00000000000003152271),('2024-06-23 11:05:00.000000',00000000000003159261),('2024-06-23 11:10:00.000000',00000000000003159261),('2024-06-23 11:15:00.000000',00000000000003163248),('2024-06-23 11:20:00.000000',00000000000003211638),('2024-06-23 11:25:00.000000',00000000000003223615),('2024-06-23 11:30:00.000000',00000000000003228705),('2024-06-23 11:35:00.000000',00000000000003233995),('2024-06-23 11:40:00.000000',00000000000003236995),('2024-06-23 11:45:00.000000',00000000000003236995),('2024-06-23 11:50:00.000000',00000000000003196095),('2024-06-23 11:55:00.000000',00000000000003197095),('2024-06-23 12:00:00.000000',00000000000003217761),('2024-06-23 12:05:00.000000',00000000000003249111),('2024-06-23 12:10:00.000000',00000000000003263900),('2024-06-23 12:15:00.000000',00000000000003310178),('2024-06-23 12:20:00.000000',00000000000003320058),('2024-06-23 12:25:00.000000',00000000000003323558),('2024-06-23 12:30:00.000000',00000000000003339358),('2024-06-23 12:35:00.000000',00000000000003343658),('2024-06-23 12:40:00.000000',00000000000003343658),('2024-06-23 12:45:00.000000',00000000000003365408),('2024-06-23 12:50:00.000000',00000000000003390967),('2024-06-23 12:55:00.000000',00000000000003416667),('2024-06-23 13:00:00.000000',00000000000003476886),('2024-06-23 13:05:00.000000',00000000000003500294),('2024-06-23 13:10:00.000000',00000000000003528254),('2024-06-23 13:15:00.000000',00000000000003528254),('2024-06-23 13:20:00.000000',00000000000003538154),('2024-06-23 13:25:00.000000',00000000000003563932),('2024-06-23 13:30:00.000000',00000000000003619082),('2024-06-23 13:35:00.000000',00000000000003621582),('2024-06-23 13:40:00.000000',00000000000003649352),('2024-06-23 13:45:00.000000',00000000000003693102),('2024-06-23 13:50:00.000000',00000000000003709670),('2024-06-23 13:55:00.000000',00000000000003744430),('2024-06-23 14:00:00.000000',00000000000003758309),('2024-06-23 14:05:00.000000',00000000000003762206),('2024-06-23 14:10:00.000000',00000000000003779096),('2024-06-23 14:15:00.000000',00000000000003804875),('2024-06-23 14:20:00.000000',00000000000003807863),('2024-06-23 14:25:00.000000',00000000000003824653),('2024-06-23 14:30:00.000000',00000000000003842511),('2024-06-23 14:35:00.000000',00000000000003920947),('2024-06-23 14:40:00.000000',00000000000003954873),('2024-06-23 14:45:00.000000',00000000000003976098),('2024-06-23 14:50:00.000000',00000000000004004535),('2024-06-23 14:55:00.000000',00000000000004027603),('2024-06-23 15:00:00.000000',00000000000004072853),('2024-06-23 15:05:00.000000',00000000000004085821),('2024-06-23 15:10:00.000000',00000000000004129371),('2024-06-23 15:15:00.000000',00000000000004237879),('2024-06-23 15:20:00.000000',00000000000004242869),('2024-06-23 15:25:00.000000',00000000000004258326),('2024-06-23 15:30:00.000000',00000000000004282915),('2024-06-23 15:35:00.000000',00000000000004303515),('2024-06-23 15:40:00.000000',00000000000004322305),('2024-06-23 15:45:00.000000',00000000000004339884),('2024-06-23 15:50:00.000000',00000000000004393371),('2024-06-23 15:55:00.000000',00000000000004419061),('2024-06-23 16:00:00.000000',00000000000000000000),('2024-06-23 16:05:00.000000',00000000000000028769),('2024-06-23 16:10:00.000000',00000000000000214449),('2024-06-23 16:15:00.000000',00000000000000282805),('2024-06-23 16:20:00.000000',00000000000000309174),('2024-06-23 16:25:00.000000',00000000000000315823),('2024-06-23 16:30:00.000000',00000000000000339813),('2024-06-23 16:35:00.000000',00000000000000365050),('2024-06-23 16:40:00.000000',00000000000000407678),('2024-06-23 16:45:00.000000',00000000000000411657),('2024-06-23 16:50:00.000000',00000000000000423447),('2024-06-23 16:55:00.000000',00000000000000437336),('2024-06-23 17:00:00.000000',00000000000000460626),('2024-06-23 17:05:00.000000',00000000000000463115),('2024-06-23 17:10:00.000000',00000000000000475095),('2024-06-23 17:15:00.000000',00000000000000487972),('2024-06-23 17:20:00.000000',00000000000000501960),('2024-06-23 17:25:00.000000',00000000000000503960),('2024-06-23 17:30:00.000000',00000000000000518858),('2024-06-23 17:35:00.000000',00000000000000522854),('2024-06-23 17:40:00.000000',00000000000000551442),('2024-06-23 17:45:00.000000',00000000000000554440),('2024-06-23 17:50:00.000000',00000000000000565838),('2024-06-23 17:55:00.000000',00000000000000579736),('2024-06-23 18:00:00.000000',00000000000000642416),('2024-06-23 18:05:00.000000',00000000000000656303),('2024-06-23 18:10:00.000000',00000000000000687002),('2024-06-23 18:15:00.000000',00000000000000689991),('2024-06-23 18:20:00.000000',00000000000000690991),('2024-06-23 18:25:00.000000',00000000000000707877),('2024-06-23 18:30:00.000000',00000000000000743077),('2024-06-23 18:35:00.000000',00000000000000758866),('2024-06-23 18:40:00.000000',00000000000000768576),('2024-06-23 18:45:00.000000',00000000000000770576),('2024-06-23 18:50:00.000000',00000000000000774576),('2024-06-23 18:55:00.000000',00000000000000810176),('2024-06-23 19:00:00.000000',00000000000000817154),('2024-06-23 19:05:00.000000',00000000000000827154),('2024-06-23 19:10:00.000000',00000000000000827154),('2024-06-23 19:15:00.000000',00000000000000827154),('2024-06-23 19:20:00.000000',00000000000000833954),('2024-06-23 19:25:00.000000',00000000000000834954),('2024-06-23 19:30:00.000000',00000000000000835954),('2024-06-23 19:35:00.000000',00000000000000843854),('2024-06-23 19:40:00.000000',00000000000000843854),('2024-06-23 19:45:00.000000',00000000000000851754),('2024-06-23 19:50:00.000000',00000000000000851754),('2024-06-23 19:55:00.000000',00000000000000851754),('2024-06-23 20:00:00.000000',00000000000000852354),('2024-06-23 20:05:00.000000',00000000000000852354),('2024-06-23 20:10:00.000000',00000000000000866154),('2024-06-23 20:15:00.000000',00000000000000868152),('2024-06-23 20:20:00.000000',00000000000000873052),('2024-06-23 20:25:00.000000',00000000000000874052),('2024-06-23 20:30:00.000000',00000000000000881032),('2024-06-23 20:35:00.000000',00000000000000881032),('2024-06-23 20:40:00.000000',00000000000000882032),('2024-06-23 20:45:00.000000',00000000000000887032),('2024-06-23 20:50:00.000000',00000000000000887032),('2024-06-23 20:55:00.000000',00000000000000887032),('2024-06-23 21:00:00.000000',00000000000000890032),('2024-06-23 21:05:00.000000',00000000000000894032),('2024-06-23 21:10:00.000000',00000000000000898032),('2024-06-23 21:15:00.000000',00000000000000898032),('2024-06-23 21:20:00.000000',00000000000000902932),('2024-06-23 21:25:00.000000',00000000000000905932),('2024-06-23 21:30:00.000000',00000000000000906932),('2024-06-23 21:35:00.000000',00000000000000911932),('2024-06-23 21:40:00.000000',00000000000000923932),('2024-06-23 21:45:00.000000',00000000000000964432),('2024-06-23 21:50:00.000000',00000000000000969432),('2024-06-23 21:55:00.000000',00000000000000976232),('2024-06-23 22:00:00.000000',00000000000000980221),('2024-06-23 22:05:00.000000',00000000000000982741),('2024-06-23 22:10:00.000000',00000000000000990539),('2024-06-23 22:15:00.000000',00000000000000995138),('2024-06-23 22:20:00.000000',00000000000000995138),('2024-06-23 22:25:00.000000',00000000000001004128),('2024-06-23 22:30:00.000000',00000000000001009128),('2024-06-23 22:35:00.000000',00000000000001017128),('2024-06-23 22:40:00.000000',00000000000001021028),('2024-06-23 22:45:00.000000',00000000000001031928),('2024-06-23 22:50:00.000000',00000000000001041828),('2024-06-23 22:55:00.000000',00000000000001043528),('2024-06-23 23:00:00.000000',00000000000001055417),('2024-06-23 23:05:00.000000',00000000000001071307),('2024-06-23 23:10:00.000000',00000000000001080097),('2024-06-23 23:15:00.000000',00000000000001082097),('2024-06-23 23:20:00.000000',00000000000001089995),('2024-06-23 23:25:00.000000',00000000000001094885),('2024-06-23 23:30:00.000000',00000000000001106774),('2024-06-23 23:35:00.000000',00000000000001120574),('2024-06-23 23:40:00.000000',00000000000001124563),('2024-06-23 23:45:00.000000',00000000000001136463),('2024-06-23 23:50:00.000000',00000000000001146243),('2024-06-23 23:55:00.000000',00000000000001160542),('2024-06-24 00:00:00.000000',00000000000001163531),('2024-06-24 00:05:00.000000',00000000000001168031),('2024-06-24 00:10:00.000000',00000000000001179031),('2024-06-24 00:15:00.000000',00000000000001184619),('2024-06-24 00:20:00.000000',00000000000001186118),('2024-06-24 00:25:00.000000',00000000000001191018),('2024-06-24 00:30:00.000000',00000000000001196007),('2024-06-24 00:35:00.000000',00000000000001203905),('2024-06-24 00:40:00.000000',00000000000001207894),('2024-06-24 00:45:00.000000',00000000000001214794),('2024-06-24 00:50:00.000000',00000000000001227692),('2024-06-24 00:55:00.000000',00000000000001234682),('2024-06-24 01:00:00.000000',00000000000001236682),('2024-06-24 01:05:00.000000',00000000000001238671),('2024-06-24 01:10:00.000000',00000000000001258528),('2024-06-24 01:15:00.000000',00000000000001267518),('2024-06-24 01:20:00.000000',00000000000001271507),('2024-06-24 01:25:00.000000',00000000000001279497),('2024-06-24 01:30:00.000000',00000000000001280017),('2024-06-24 01:35:00.000000',00000000000001313845),('2024-06-24 01:40:00.000000',00000000000001321835),('2024-06-24 01:45:00.000000',00000000000001362315),('2024-06-24 01:50:00.000000',00000000000001378005),('2024-06-24 01:55:00.000000',00000000000001379995),('2024-06-24 02:00:00.000000',00000000000001391874),('2024-06-24 02:05:00.000000',00000000000001393863),('2024-06-24 02:10:00.000000',00000000000001410661),('2024-06-24 02:15:00.000000',00000000000001418150),('2024-06-24 02:20:00.000000',00000000000001425660),('2024-06-24 02:25:00.000000',00000000000001428460),('2024-06-24 02:30:00.000000',00000000000001429460),('2024-06-24 02:35:00.000000',00000000000001437350),('2024-06-24 02:40:00.000000',00000000000001489839),('2024-06-24 02:45:00.000000',00000000000001500328),('2024-06-24 02:50:00.000000',00000000000001509027),('2024-06-24 02:55:00.000000',00000000000001530627),('2024-06-24 03:00:00.000000',00000000000001534627),('2024-06-24 03:05:00.000000',00000000000001534627),('2024-06-24 03:10:00.000000',00000000000001537527),('2024-06-24 03:15:00.000000',00000000000001559316),('2024-06-24 03:20:00.000000',00000000000001567736),('2024-06-24 03:25:00.000000',00000000000001576605),('2024-06-24 03:30:00.000000',00000000000001576605),('2024-06-24 03:35:00.000000',00000000000001587905),('2024-06-24 03:40:00.000000',00000000000001618705),('2024-06-24 03:45:00.000000',00000000000001631175),('2024-06-24 03:50:00.000000',00000000000001641135),('2024-06-24 03:55:00.000000',00000000000001643215),('2024-06-24 04:00:00.000000',00000000000001650185),('2024-06-24 04:05:00.000000',00000000000001672045),('2024-06-24 04:10:00.000000',00000000000001680025),('2024-06-24 04:15:00.000000',00000000000001687894),('2024-06-24 04:20:00.000000',00000000000001720674),('2024-06-24 04:25:00.000000',00000000000001724664),('2024-06-24 04:30:00.000000',00000000000001743614),('2024-06-24 04:35:00.000000',00000000000001762412),('2024-06-24 04:40:00.000000',00000000000001768201),('2024-06-24 04:45:00.000000',00000000000001781871),('2024-06-24 04:50:00.000000',00000000000001813218),('2024-06-24 04:55:00.000000',00000000000001821007),('2024-06-24 05:00:00.000000',00000000000001836697),('2024-06-24 05:05:00.000000',00000000000001842597),('2024-06-24 05:10:00.000000',00000000000001856087),('2024-06-24 05:15:00.000000',00000000000001885626),('2024-06-24 05:20:00.000000',00000000000001909565),('2024-06-24 05:25:00.000000',00000000000001923542),('2024-06-24 05:30:00.000000',00000000000001942942),('2024-06-24 05:35:00.000000',00000000000001968300),('2024-06-24 05:40:00.000000',00000000000001958410),('2024-06-24 05:45:00.000000',00000000000001972890),('2024-06-24 05:50:00.000000',00000000000001990290),('2024-06-24 05:55:00.000000',00000000000001995379),('2024-06-24 06:00:00.000000',00000000000002027019),('2024-06-24 06:05:00.000000',00000000000002083889),('2024-06-24 06:10:00.000000',00000000000002102068),('2024-06-24 06:15:00.000000',00000000000002121548),('2024-06-24 06:20:00.000000',00000000000002139227),('2024-06-24 06:25:00.000000',00000000000002151806),('2024-06-24 06:30:00.000000',00000000000002161766),('2024-06-24 06:35:00.000000',00000000000002171766),('2024-06-24 06:40:00.000000',00000000000002179376),('2024-06-24 06:45:00.000000',00000000000002183366),('2024-06-24 06:50:00.000000',00000000000002198236),('2024-06-24 06:55:00.000000',00000000000002217036),('2024-06-24 07:00:00.000000',00000000000002236736),('2024-06-24 07:05:00.000000',00000000000002236726),('2024-06-24 07:10:00.000000',00000000000002282605),('2024-06-24 07:15:00.000000',00000000000002300373),('2024-06-24 07:20:00.000000',00000000000002306253),('2024-06-24 07:25:00.000000',00000000000002324032),('2024-06-24 07:30:00.000000',00000000000002331832),('2024-06-24 07:35:00.000000',00000000000002342622),('2024-06-24 07:40:00.000000',00000000000002348611),('2024-06-24 07:45:00.000000',00000000000002357288),('2024-06-24 07:50:00.000000',00000000000002377046),('2024-06-24 07:55:00.000000',00000000000002394846),('2024-06-24 08:00:00.000000',00000000000002404836),('2024-06-24 08:05:00.000000',00000000000002420135),('2024-06-24 08:10:00.000000',00000000000002422135),('2024-06-24 08:15:00.000000',00000000000002433104),('2024-06-24 08:20:00.000000',00000000000002444183),('2024-06-24 08:25:00.000000',00000000000002453072),('2024-06-24 08:30:00.000000',00000000000002474962),('2024-06-24 08:35:00.000000',00000000000002483652),('2024-06-24 08:40:00.000000',00000000000002497608),('2024-06-24 08:45:00.000000',00000000000002511487),('2024-06-24 08:50:00.000000',00000000000002676167),('2024-06-24 08:55:00.000000',00000000000002706547),('2024-06-24 09:00:00.000000',00000000000002714547),('2024-06-24 09:05:00.000000',00000000000002715447),('2024-06-24 09:10:00.000000',00000000000002732136),('2024-06-24 09:15:00.000000',00000000000002769626),('2024-06-24 09:20:00.000000',00000000000002770626),('2024-06-24 09:25:00.000000',00000000000002776135),('2024-06-24 09:30:00.000000',00000000000002793585),('2024-06-24 09:35:00.000000',00000000000002793585),('2024-06-24 09:40:00.000000',00000000000002809053),('2024-06-24 09:45:00.000000',00000000000002820041),('2024-06-24 09:50:00.000000',00000000000002832906),('2024-06-24 09:55:00.000000',00000000000002837806),('2024-06-24 10:00:00.000000',00000000000002839795),('2024-06-24 10:05:00.000000',00000000000003131695),('2024-06-24 10:10:00.000000',00000000000003135495),('2024-06-24 10:15:00.000000',00000000000003143394),('2024-06-24 10:20:00.000000',00000000000003151284),('2024-06-24 10:25:00.000000',00000000000003160174),('2024-06-24 10:30:00.000000',00000000000003164672),('2024-06-24 10:35:00.000000',00000000000003184362),('2024-06-24 10:40:00.000000',00000000000003191260),('2024-06-24 10:45:00.000000',00000000000003205150),('2024-06-24 10:50:00.000000',00000000000003211130),('2024-06-24 10:55:00.000000',00000000000003264020),('2024-06-24 11:00:00.000000',00000000000003278820),('2024-06-24 11:05:00.000000',00000000000003287798),('2024-06-24 11:10:00.000000',00000000000003307175),('2024-06-24 11:15:00.000000',00000000000003317054),('2024-06-24 11:20:00.000000',00000000000003332754),('2024-06-24 11:25:00.000000',00000000000003339654),('2024-06-24 11:30:00.000000',00000000000003342554),('2024-06-24 11:35:00.000000',00000000000003345554),('2024-06-24 11:40:00.000000',00000000000003356354),('2024-06-24 11:45:00.000000',00000000000003363255),('2024-06-24 11:50:00.000000',00000000000003375653),('2024-06-24 11:55:00.000000',00000000000003401741),('2024-06-24 12:00:00.000000',00000000000003412631),('2024-06-24 12:05:00.000000',00000000000003566841),('2024-06-24 12:10:00.000000',00000000000003586541),('2024-06-24 12:15:00.000000',00000000000003591540),('2024-06-24 12:20:00.000000',00000000000003598530),('2024-06-24 12:25:00.000000',00000000000003601530),('2024-06-24 12:30:00.000000',00000000000003624084),('2024-06-24 12:35:00.000000',00000000000003639778),('2024-06-24 12:40:00.000000',00000000000003648768),('2024-06-24 12:45:00.000000',00000000000003663978),('2024-06-24 12:50:00.000000',00000000000003686268),('2024-06-24 12:55:00.000000',00000000000003708247),('2024-06-24 13:00:00.000000',00000000000003721737),('2024-06-24 13:05:00.000000',00000000000003764046),('2024-06-24 13:10:00.000000',00000000000003780736),('2024-06-24 13:15:00.000000',00000000000003801316),('2024-06-24 13:20:00.000000',00000000000003794516),('2024-06-24 13:25:00.000000',00000000000003813304),('2024-06-24 13:30:00.000000',00000000000003839884),('2024-06-24 13:35:00.000000',00000000000003900184),('2024-06-24 13:40:00.000000',00000000000003969441),('2024-06-24 13:45:00.000000',00000000000003984898),('2024-06-24 13:50:00.000000',00000000000003993997),('2024-06-24 13:55:00.000000',00000000000004030077),('2024-06-24 14:00:00.000000',00000000000004052935),('2024-06-24 14:05:00.000000',00000000000004077714),('2024-06-24 14:10:00.000000',00000000000004143194),('2024-06-24 14:15:00.000000',00000000000004211452),('2024-06-24 14:20:00.000000',00000000000004289381),('2024-06-24 14:25:00.000000',00000000000004402757),('2024-06-24 14:30:00.000000',00000000000004540367),('2024-06-24 14:35:00.000000',00000000000004615037),('2024-06-24 14:40:00.000000',00000000000004695826),('2024-06-24 14:45:00.000000',00000000000004746592),('2024-06-24 14:50:00.000000',00000000000004829041),('2024-06-24 14:55:00.000000',00000000000004874000),('2024-06-24 15:00:00.000000',00000000000004930786),('2024-06-24 15:05:00.000000',00000000000005026824),('2024-06-24 15:10:00.000000',00000000000005071684),('2024-06-24 15:15:00.000000',00000000000005108922),('2024-06-24 15:20:00.000000',00000000000005145071),('2024-06-24 15:25:00.000000',00000000000005169330),('2024-06-24 15:30:00.000000',00000000000005233620),('2024-06-24 15:35:00.000000',00000000000005261169),('2024-06-24 15:40:00.000000',00000000000005323765),('2024-06-24 15:45:00.000000',00000000000005351013),('2024-06-24 15:50:00.000000',00000000000005376831),('2024-06-24 15:55:00.000000',00000000000005422481),('2024-06-24 16:00:00.000000',00000000000000000000),('2024-06-24 16:05:00.000000',00000000000000030680),('2024-06-24 16:10:00.000000',00000000000000069349),('2024-06-24 16:15:00.000000',00000000000000287988),('2024-06-24 16:20:00.000000',00000000000000320566),('2024-06-24 16:25:00.000000',00000000000000340024),('2024-06-24 16:30:00.000000',00000000000000361811),('2024-06-24 16:35:00.000000',00000000000000381498),('2024-06-24 16:40:00.000000',00000000000000438037),('2024-06-24 16:45:00.000000',00000000000000457505),('2024-06-24 16:50:00.000000',00000000000000493405),('2024-06-24 16:55:00.000000',00000000000000520995),('2024-06-24 17:00:00.000000',00000000000000540795),('2024-06-24 17:05:00.000000',00000000000000562273),('2024-06-24 17:10:00.000000',00000000000000586740),('2024-06-24 17:15:00.000000',00000000000000590730),('2024-06-24 17:20:00.000000',00000000000000643519),('2024-06-24 17:25:00.000000',00000000000000664208),('2024-06-24 17:30:00.000000',00000000000000675187),('2024-06-24 17:35:00.000000',00000000000000695041),('2024-06-24 17:40:00.000000',00000000000000712641),('2024-06-24 17:45:00.000000',00000000000000721229),('2024-06-24 17:50:00.000000',00000000000000741195),('2024-06-24 17:55:00.000000',00000000000000763782),('2024-06-24 18:00:00.000000',00000000000000801378),('2024-06-24 18:05:00.000000',00000000000000829165),('2024-06-24 18:10:00.000000',00000000000000853463),('2024-06-24 18:15:00.000000',00000000000000873363),('2024-06-24 18:20:00.000000',00000000000000879163),('2024-06-24 18:25:00.000000',00000000000000937740),('2024-06-24 18:30:00.000000',00000000000000940738),('2024-06-24 18:35:00.000000',00000000000000960138),('2024-06-24 18:40:00.000000',00000000000000990238),('2024-06-24 18:45:00.000000',00000000000000995228),('2024-06-24 18:50:00.000000',00000000000001002028),('2024-06-24 18:55:00.000000',00000000000001014003),('2024-06-24 19:00:00.000000',00000000000001045482),('2024-06-24 19:05:00.000000',00000000000001049480),('2024-06-24 19:10:00.000000',00000000000001051480),('2024-06-24 19:15:00.000000',00000000000001084380),('2024-06-24 19:20:00.000000',00000000000001114280),('2024-06-24 19:25:00.000000',00000000000001115280),('2024-06-24 19:30:00.000000',00000000000001119180),('2024-06-24 19:35:00.000000',00000000000001120180),('2024-06-24 19:40:00.000000',00000000000001122178),('2024-06-24 19:45:00.000000',00000000000001123678),('2024-06-24 19:50:00.000000',00000000000001136076),('2024-06-24 19:55:00.000000',00000000000001296076),('2024-06-24 20:00:00.000000',00000000000001299066),('2024-06-24 20:05:00.000000',00000000000001306855),('2024-06-24 20:10:00.000000',00000000000001313253),('2024-06-24 20:15:00.000000',00000000000001317253),('2024-06-24 20:20:00.000000',00000000000001317353),('2024-06-24 20:25:00.000000',00000000000001327253),('2024-06-24 20:30:00.000000',00000000000001330253),('2024-06-24 20:35:00.000000',00000000000001334253),('2024-06-24 20:40:00.000000',00000000000001339243),('2024-06-24 20:45:00.000000',00000000000001345231),('2024-06-24 20:50:00.000000',00000000000001345231),('2024-06-24 20:55:00.000000',00000000000001350220),('2024-06-24 21:00:00.000000',00000000000001354864),('2024-06-24 21:05:00.000000',00000000000001379650),('2024-06-24 21:10:00.000000',00000000000001405320),('2024-06-24 21:15:00.000000',00000000000001407318),('2024-06-24 21:20:00.000000',00000000000001410816),('2024-06-24 21:25:00.000000',00000000000001411816),('2024-06-24 21:30:00.000000',00000000000001413814),('2024-06-24 21:35:00.000000',00000000000001415814),('2024-06-24 21:40:00.000000',00000000000001420802),('2024-06-24 21:45:00.000000',00000000000001424780),('2024-06-24 21:50:00.000000',00000000000001424780),('2024-06-24 21:55:00.000000',00000000000001427770),('2024-06-24 22:00:00.000000',00000000000001431670),('2024-06-24 22:05:00.000000',00000000000001438660),('2024-06-24 22:10:00.000000',00000000000001440660),('2024-06-24 22:15:00.000000',00000000000001447560),('2024-06-24 22:20:00.000000',00000000000001447560),('2024-06-24 22:25:00.000000',00000000000001448550),('2024-06-24 22:30:00.000000',00000000000001455540),('2024-06-24 22:35:00.000000',00000000000001458538),('2024-06-24 22:40:00.000000',00000000000001471238),('2024-06-24 22:45:00.000000',00000000000001486027),('2024-06-24 22:50:00.000000',00000000000001514797),('2024-06-24 22:55:00.000000',00000000000001520697),('2024-06-24 23:00:00.000000',00000000000001525897),('2024-06-24 23:05:00.000000',00000000000001526897),('2024-06-24 23:10:00.000000',00000000000001535795),('2024-06-24 23:15:00.000000',00000000000001545775),('2024-06-24 23:20:00.000000',00000000000001574363),('2024-06-24 23:25:00.000000',00000000000001584163),('2024-06-24 23:30:00.000000',00000000000001585863),('2024-06-24 23:35:00.000000',00000000000001599763),('2024-06-24 23:40:00.000000',00000000000001601761),('2024-06-24 23:45:00.000000',00000000000001602361),('2024-06-24 23:50:00.000000',00000000000001653060),('2024-06-24 23:55:00.000000',00000000000001653060),('2024-06-25 00:00:00.000000',00000000000001655060),('2024-06-25 00:05:00.000000',00000000000001667860),('2024-06-25 00:10:00.000000',00000000000001676847),('2024-06-25 00:15:00.000000',00000000000001676847),('2024-06-25 00:20:00.000000',00000000000001696625),('2024-06-25 00:25:00.000000',00000000000001710605),('2024-06-25 00:30:00.000000',00000000000001715594),('2024-06-25 00:35:00.000000',00000000000001724494),('2024-06-25 00:40:00.000000',00000000000001742293),('2024-06-25 00:45:00.000000',00000000000001771059),('2024-06-25 00:50:00.000000',00000000000001783636),('2024-06-25 00:55:00.000000',00000000000001798315),('2024-06-25 01:00:00.000000',00000000000001799305),('2024-06-25 01:05:00.000000',00000000000001805773),('2024-06-25 01:10:00.000000',00000000000001821540),('2024-06-25 01:15:00.000000',00000000000001825440),('2024-06-25 01:20:00.000000',00000000000001835230),('2024-06-25 01:25:00.000000',00000000000001843220),('2024-06-25 01:30:00.000000',00000000000001839320),('2024-06-25 01:35:00.000000',00000000000001856110),('2024-06-25 01:40:00.000000',00000000000001897910),('2024-06-25 01:45:00.000000',00000000000001931310),('2024-06-25 01:50:00.000000',00000000000001933510),('2024-06-25 01:55:00.000000',00000000000001943909),('2024-06-25 02:00:00.000000',00000000000001952789),('2024-06-25 02:05:00.000000',00000000000001961689),('2024-06-25 02:10:00.000000',00000000000001979569),('2024-06-25 02:15:00.000000',00000000000001998369),('2024-06-25 02:20:00.000000',00000000000002002358),('2024-06-25 02:25:00.000000',00000000000002012438),('2024-06-25 02:30:00.000000',00000000000002013438),('2024-06-25 02:35:00.000000',00000000000002029217),('2024-06-25 02:40:00.000000',00000000000002042107),('2024-06-25 02:45:00.000000',00000000000002059994),('2024-06-25 02:50:00.000000',00000000000002094894),('2024-06-25 02:55:00.000000',00000000000002121684),('2024-06-25 03:00:00.000000',00000000000002121693),('2024-06-25 03:05:00.000000',00000000000002172383),('2024-06-25 03:10:00.000000',00000000000002183273),('2024-06-25 03:15:00.000000',00000000000002264553),('2024-06-25 03:20:00.000000',00000000000002329033),('2024-06-25 03:25:00.000000',00000000000002528723),('2024-06-25 03:30:00.000000',00000000000002558652),('2024-06-25 03:35:00.000000',00000000000002573722),('2024-06-25 03:40:00.000000',00000000000002591411),('2024-06-25 03:45:00.000000',00000000000002637300),('2024-06-25 03:50:00.000000',00000000000002639298),('2024-06-25 03:55:00.000000',00000000000002654098),('2024-06-25 04:00:00.000000',00000000000002665285),('2024-06-25 04:05:00.000000',00000000000002672695),('2024-06-25 04:10:00.000000',00000000000002695455),('2024-06-25 04:15:00.000000',00000000000002742185),('2024-06-25 04:20:00.000000',00000000000002804862),('2024-06-25 04:25:00.000000',00000000000002827531),('2024-06-25 04:30:00.000000',00000000000002852480),('2024-06-25 04:35:00.000000',00000000000002899360),('2024-06-25 04:40:00.000000',00000000000002932925),('2024-06-25 04:45:00.000000',00000000000002997191),('2024-06-25 04:50:00.000000',00000000000003018488),('2024-06-25 04:55:00.000000',00000000000003040768),('2024-06-25 05:00:00.000000',00000000000003064726),('2024-06-25 05:05:00.000000',00000000000003069723),('2024-06-25 05:10:00.000000',00000000000003140470),('2024-06-25 05:15:00.000000',00000000000003163428),('2024-06-25 05:20:00.000000',00000000000003180297),('2024-06-25 05:25:00.000000',00000000000003211326),('2024-06-25 05:30:00.000000',00000000000003222405),('2024-06-25 05:35:00.000000',00000000000003255344),('2024-06-25 05:40:00.000000',00000000000003341740),('2024-06-25 05:45:00.000000',00000000000003380855),('2024-06-25 05:50:00.000000',00000000000003423763),('2024-06-25 05:55:00.000000',00000000000003439620),('2024-06-25 06:00:00.000000',00000000000003449780),('2024-06-25 06:05:00.000000',00000000000003463538),('2024-06-25 06:10:00.000000',00000000000003492367),('2024-06-25 06:15:00.000000',00000000000003522697),('2024-06-25 06:20:00.000000',00000000000003603233),('2024-06-25 06:25:00.000000',00000000000003620001),('2024-06-25 06:30:00.000000',00000000000003640649),('2024-06-25 06:35:00.000000',00000000000003646638),('2024-06-25 06:40:00.000000',00000000000003699107),('2024-06-25 06:45:00.000000',00000000000003729684),('2024-06-25 06:50:00.000000',00000000000003735684),('2024-06-25 06:55:00.000000',00000000000003741573),('2024-06-25 07:00:00.000000',00000000000003748233),('2024-06-25 07:05:00.000000',00000000000003768761),('2024-06-25 07:10:00.000000',00000000000003772761),('2024-06-25 07:15:00.000000',00000000000003777751),('2024-06-25 07:20:00.000000',00000000000003785731),('2024-06-25 07:25:00.000000',00000000000003787631),('2024-06-25 07:30:00.000000',00000000000003802121),('2024-06-25 07:35:00.000000',00000000000003820990),('2024-06-25 07:40:00.000000',00000000000003832790),('2024-06-25 07:45:00.000000',00000000000003835790),('2024-06-25 07:50:00.000000',00000000000003878780),('2024-06-25 07:55:00.000000',00000000000003885869),('2024-06-25 08:00:00.000000',00000000000003890859),('2024-06-25 08:05:00.000000',00000000000003895849),('2024-06-25 08:10:00.000000',00000000000003924929),('2024-06-25 08:15:00.000000',00000000000003947705),('2024-06-25 08:20:00.000000',00000000000003954684),('2024-06-25 08:25:00.000000',00000000000004003662),('2024-06-25 08:30:00.000000',00000000000004033250),('2024-06-25 08:35:00.000000',00000000000004043308),('2024-06-25 08:40:00.000000',00000000000004065237),('2024-06-25 08:45:00.000000',00000000000004088085),('2024-06-25 08:50:00.000000',00000000000004101972),('2024-06-25 08:55:00.000000',00000000000004147872),('2024-06-25 09:00:00.000000',00000000000004159762),('2024-06-25 09:05:00.000000',00000000000004224339),('2024-06-25 09:10:00.000000',00000000000004228239),('2024-06-25 09:15:00.000000',00000000000004243739),('2024-06-25 09:20:00.000000',00000000000004256518),('2024-06-25 09:25:00.000000',00000000000004263917),('2024-06-25 09:30:00.000000',00000000000004287695),('2024-06-25 09:35:00.000000',00000000000004292695),('2024-06-25 09:40:00.000000',00000000000004281733),('2024-06-25 09:45:00.000000',00000000000004278844),('2024-06-25 09:50:00.000000',00000000000004281844),('2024-06-25 09:55:00.000000',00000000000004283833),('2024-06-25 10:00:00.000000',00000000000004284833),('2024-06-25 10:05:00.000000',00000000000004305582),('2024-06-25 10:10:00.000000',00000000000004303592),('2024-06-25 10:15:00.000000',00000000000004305581),('2024-06-25 10:20:00.000000',00000000000004309581),('2024-06-25 10:25:00.000000',00000000000004319549),('2024-06-25 10:30:00.000000',00000000000004324536),('2024-06-25 10:35:00.000000',00000000000004334426),('2024-06-25 10:40:00.000000',00000000000004366106),('2024-06-25 10:45:00.000000',00000000000004425745),('2024-06-25 10:50:00.000000',00000000000004467144),('2024-06-25 10:55:00.000000',00000000000004479924),('2024-06-25 11:00:00.000000',00000000000004535504),('2024-06-25 11:05:00.000000',00000000000004537493),('2024-06-25 11:10:00.000000',00000000000004543483),('2024-06-25 11:15:00.000000',00000000000004595382),('2024-06-25 11:20:00.000000',00000000000004600782),('2024-06-25 11:25:00.000000',00000000000004614082),('2024-06-25 11:30:00.000000',00000000000004619062),('2024-06-25 11:35:00.000000',00000000000004626050),('2024-06-25 11:40:00.000000',00000000000004665217),('2024-06-25 11:45:00.000000',00000000000004667097),('2024-06-25 11:50:00.000000',00000000000004687872),('2024-06-25 11:55:00.000000',00000000000004693772),('2024-06-25 12:00:00.000000',00000000000004706872),('2024-06-25 12:05:00.000000',00000000000004706872),('2024-06-25 12:10:00.000000',00000000000004716772),('2024-06-25 12:15:00.000000',00000000000004739372),('2024-06-25 12:20:00.000000',00000000000004754072),('2024-06-25 12:25:00.000000',00000000000004960570),('2024-06-25 12:30:00.000000',00000000000004974347),('2024-06-25 12:35:00.000000',00000000000005028725),('2024-06-25 12:40:00.000000',00000000000005049204),('2024-06-25 12:45:00.000000',00000000000005059093),('2024-06-25 12:50:00.000000',00000000000005120838),('2024-06-25 12:55:00.000000',00000000000005132727),('2024-06-25 13:00:00.000000',00000000000005138627),('2024-06-25 13:05:00.000000',00000000000005145427),('2024-06-25 13:10:00.000000',00000000000005165027),('2024-06-25 13:15:00.000000',00000000000005184814),('2024-06-25 13:20:00.000000',00000000000005190803),('2024-06-25 13:25:00.000000',00000000000005203191),('2024-06-25 13:30:00.000000',00000000000005231989),('2024-06-25 13:35:00.000000',00000000000005237979),('2024-06-25 13:40:00.000000',00000000000005243979),('2024-06-25 13:45:00.000000',00000000000005247979),('2024-06-25 13:50:00.000000',00000000000005254959),('2024-06-25 13:55:00.000000',00000000000005273836),('2024-06-25 14:00:00.000000',00000000000005288705),('2024-06-25 14:05:00.000000',00000000000005334454),('2024-06-25 14:10:00.000000',00000000000005289645),('2024-06-25 14:15:00.000000',00000000000005316614),('2024-06-25 14:20:00.000000',00000000000005344292),('2024-06-25 14:25:00.000000',00000000000005349271),('2024-06-25 14:30:00.000000',00000000000005367050),('2024-06-25 14:35:00.000000',00000000000005678816),('2024-06-25 14:40:00.000000',00000000000005702794),('2024-06-25 14:45:00.000000',00000000000005737872),('2024-06-25 14:50:00.000000',00000000000005789670),('2024-06-25 14:55:00.000000',00000000000005806159),('2024-06-25 15:00:00.000000',00000000000005824037),('2024-06-25 15:05:00.000000',00000000000005875637),('2024-06-25 15:10:00.000000',00000000000005892514),('2024-06-25 15:15:00.000000',00000000000005909382),('2024-06-25 15:20:00.000000',00000000000005980905),('2024-06-25 15:25:00.000000',00000000000006001693),('2024-06-25 15:30:00.000000',00000000000006028361),('2024-06-25 15:35:00.000000',00000000000006074041),('2024-06-25 15:40:00.000000',00000000000006218409),('2024-06-25 15:45:00.000000',00000000000006281779),('2024-06-25 15:50:00.000000',00000000000006312846),('2024-06-25 15:55:00.000000',00000000000006324631),('2024-06-25 16:00:00.000000',00000000000000000000),('2024-06-25 16:05:00.000000',00000000000000101066),('2024-06-25 16:10:00.000000',00000000000000111700),('2024-06-25 16:15:00.000000',00000000000000314689),('2024-06-25 16:20:00.000000',00000000000000336178),('2024-06-25 16:25:00.000000',00000000000000402726),('2024-06-25 16:30:00.000000',00000000000000444343),('2024-06-25 16:35:00.000000',00000000000000458624),('2024-06-25 16:40:00.000000',00000000000000502194),('2024-06-25 16:45:00.000000',00000000000000547752),('2024-06-25 16:50:00.000000',00000000000000560730),('2024-06-25 16:55:00.000000',00000000000000578809),('2024-06-25 17:00:00.000000',00000000000000611556),('2024-06-25 17:05:00.000000',00000000000000651214),('2024-06-25 17:10:00.000000',00000000000000712681),('2024-06-25 17:15:00.000000',00000000000000714681),('2024-06-25 17:20:00.000000',00000000000000726571),('2024-06-25 17:25:00.000000',00000000000000730551),('2024-06-25 17:30:00.000000',00000000000000744340),('2024-06-25 17:35:00.000000',00000000000000766410),('2024-06-25 17:40:00.000000',00000000000000814679),('2024-06-25 17:45:00.000000',00000000000000819668),('2024-06-25 17:50:00.000000',00000000000000834538),('2024-06-25 17:55:00.000000',00000000000000855318),('2024-06-25 18:00:00.000000',00000000000000873265),('2024-06-25 18:05:00.000000',00000000000000881865),('2024-06-25 18:10:00.000000',00000000000000887565),('2024-06-25 18:15:00.000000',00000000000000897552),('2024-06-25 18:20:00.000000',00000000000000912642),('2024-06-25 18:25:00.000000',00000000000000928442),('2024-06-25 18:30:00.000000',00000000000000938142),('2024-06-25 18:35:00.000000',00000000000000941142),('2024-06-25 18:40:00.000000',00000000000000942342),('2024-06-25 18:45:00.000000',00000000000000960220),('2024-06-25 18:50:00.000000',00000000000000989999),('2024-06-25 18:55:00.000000',00000000000000989999),('2024-06-25 19:00:00.000000',00000000000000996288),('2024-06-25 19:05:00.000000',00000000000001005088),('2024-06-25 19:10:00.000000',00000000000001008988),('2024-06-25 19:15:00.000000',00000000000001016868),('2024-06-25 19:20:00.000000',00000000000001032755),('2024-06-25 19:25:00.000000',00000000000001056435),('2024-06-25 19:30:00.000000',00000000000001080325),('2024-06-25 19:35:00.000000',00000000000001109614),('2024-06-25 19:40:00.000000',00000000000001117514),('2024-06-25 19:45:00.000000',00000000000001132314),('2024-06-25 19:50:00.000000',00000000000001162503),('2024-06-25 19:55:00.000000',00000000000001208493),('2024-06-25 20:00:00.000000',00000000000001221183),('2024-06-25 20:05:00.000000',00000000000001253663),('2024-06-25 20:10:00.000000',00000000000001255652),('2024-06-25 20:15:00.000000',00000000000001255652),('2024-06-25 20:20:00.000000',00000000000001263352),('2024-06-25 20:25:00.000000',00000000000001275240),('2024-06-25 20:30:00.000000',00000000000001282440),('2024-06-25 20:35:00.000000',00000000000001294439),('2024-06-25 20:40:00.000000',00000000000001304439),('2024-06-25 20:45:00.000000',00000000000001304439),('2024-06-25 20:50:00.000000',00000000000001310428),('2024-06-25 20:55:00.000000',00000000000001312417),('2024-06-25 21:00:00.000000',00000000000001315407),('2024-06-25 21:05:00.000000',00000000000001315407),('2024-06-25 21:10:00.000000',00000000000001324396),('2024-06-25 21:15:00.000000',00000000000001325396),('2024-06-25 21:20:00.000000',00000000000001327385),('2024-06-25 21:25:00.000000',00000000000001341175),('2024-06-25 21:30:00.000000',00000000000001342175),('2024-06-25 21:35:00.000000',00000000000001342175),('2024-06-25 21:40:00.000000',00000000000001348075),('2024-06-25 21:45:00.000000',00000000000001356042),('2024-06-25 21:50:00.000000',00000000000001358042),('2024-06-25 21:55:00.000000',00000000000001358042),('2024-06-25 22:00:00.000000',00000000000001358042),('2024-06-25 22:05:00.000000',00000000000001361042),('2024-06-25 22:10:00.000000',00000000000001365942),('2024-06-25 22:15:00.000000',00000000000001388732),('2024-06-25 22:20:00.000000',00000000000001393722),('2024-06-25 22:25:00.000000',00000000000001414602),('2024-06-25 22:30:00.000000',00000000000001415602),('2024-06-25 22:35:00.000000',00000000000001422402),('2024-06-25 22:40:00.000000',00000000000001430302),('2024-06-25 22:45:00.000000',00000000000001431302),('2024-06-25 22:50:00.000000',00000000000001442492),('2024-06-25 22:55:00.000000',00000000000001442692),('2024-06-25 23:00:00.000000',00000000000001444692),('2024-06-25 23:05:00.000000',00000000000001456392),('2024-06-25 23:10:00.000000',00000000000001456392),('2024-06-25 23:15:00.000000',00000000000001458390),('2024-06-25 23:20:00.000000',00000000000001461390),('2024-06-25 23:25:00.000000',00000000000001484390),('2024-06-25 23:30:00.000000',00000000000001504180),('2024-06-25 23:35:00.000000',00000000000001514980),('2024-06-25 23:40:00.000000',00000000000001516980),('2024-06-25 23:45:00.000000',00000000000001532460),('2024-06-25 23:50:00.000000',00000000000001548446),('2024-06-25 23:55:00.000000',00000000000001552446),('2024-06-26 00:00:00.000000',00000000000001554446),('2024-06-26 00:05:00.000000',00000000000001557346),('2024-06-26 00:10:00.000000',00000000000001590346),('2024-06-26 00:15:00.000000',00000000000001602235),('2024-06-26 00:20:00.000000',00000000000001610114),('2024-06-26 00:25:00.000000',00000000000001613114),('2024-06-26 00:30:00.000000',00000000000001624082),('2024-06-26 00:35:00.000000',00000000000001628081),('2024-06-26 00:40:00.000000',00000000000001665870),('2024-06-26 00:45:00.000000',00000000000001683660),('2024-06-26 00:50:00.000000',00000000000001686660),('2024-06-26 00:55:00.000000',00000000000001726560),('2024-06-26 01:00:00.000000',00000000000001726560),('2024-06-26 01:05:00.000000',00000000000001743350),('2024-06-26 01:10:00.000000',00000000000001744350),('2024-06-26 01:15:00.000000',00000000000001761250),('2024-06-26 01:20:00.000000',00000000000001776340),('2024-06-26 01:25:00.000000',00000000000001780840),('2024-06-26 01:30:00.000000',00000000000001782840),('2024-06-26 01:35:00.000000',00000000000001784840),('2024-06-26 01:40:00.000000',00000000000001795809),('2024-06-26 01:45:00.000000',00000000000001809688),('2024-06-26 01:50:00.000000',00000000000001820488),('2024-06-26 01:55:00.000000',00000000000001829378),('2024-06-26 02:00:00.000000',00000000000001828478),('2024-06-26 02:05:00.000000',00000000000001836378),('2024-06-26 02:10:00.000000',00000000000001838378),('2024-06-26 02:15:00.000000',00000000000001867947),('2024-06-26 02:20:00.000000',00000000000001874717),('2024-06-26 02:25:00.000000',00000000000001877197),('2024-06-26 02:30:00.000000',00000000000001881197),('2024-06-26 02:35:00.000000',00000000000001903985),('2024-06-26 02:40:00.000000',00000000000001904984),('2024-06-26 02:45:00.000000',00000000000001910974),('2024-06-26 02:50:00.000000',00000000000001930974),('2024-06-26 02:55:00.000000',00000000000001953063),('2024-06-26 03:00:00.000000',00000000000001972842),('2024-06-26 03:05:00.000000',00000000000001978821),('2024-06-26 03:10:00.000000',00000000000001983121),('2024-06-26 03:15:00.000000',00000000000002032891),('2024-06-26 03:20:00.000000',00000000000002062431),('2024-06-26 03:25:00.000000',00000000000002077930),('2024-06-26 03:30:00.000000',00000000000002083910),('2024-06-26 03:35:00.000000',00000000000002091889),('2024-06-26 03:40:00.000000',00000000000002129189),('2024-06-26 03:45:00.000000',00000000000002138068),('2024-06-26 03:50:00.000000',00000000000002125346),('2024-06-26 03:55:00.000000',00000000000002138125),('2024-06-26 04:00:00.000000',00000000000002152014),('2024-06-26 04:05:00.000000',00000000000002163504),('2024-06-26 04:10:00.000000',00000000000002174083),('2024-06-26 04:15:00.000000',00000000000002197871),('2024-06-26 04:20:00.000000',00000000000002205761),('2024-06-26 04:25:00.000000',00000000000002220551),('2024-06-26 04:30:00.000000',00000000000002241409),('2024-06-26 04:35:00.000000',00000000000002271818),('2024-06-26 04:40:00.000000',00000000000002290174),('2024-06-26 04:45:00.000000',00000000000002306943),('2024-06-26 04:50:00.000000',00000000000002344911),('2024-06-26 04:55:00.000000',00000000000002352981),('2024-06-26 05:00:00.000000',00000000000002386569),('2024-06-26 05:05:00.000000',00000000000002392158),('2024-06-26 05:10:00.000000',00000000000002409937),('2024-06-26 05:15:00.000000',00000000000002433706),('2024-06-26 05:20:00.000000',00000000000002433706),('2024-06-26 05:25:00.000000',00000000000002463675),('2024-06-26 05:30:00.000000',00000000000002507043),('2024-06-26 05:35:00.000000',00000000000002532833),('2024-06-26 05:40:00.000000',00000000000002533822),('2024-06-26 05:45:00.000000',00000000000002553492),('2024-06-26 05:50:00.000000',00000000000002558482),('2024-06-26 05:55:00.000000',00000000000002565472),('2024-06-26 06:00:00.000000',00000000000002579341),('2024-06-26 06:05:00.000000',00000000000002592209),('2024-06-26 06:10:00.000000',00000000000002602987),('2024-06-26 06:15:00.000000',00000000000002609987),('2024-06-26 06:20:00.000000',00000000000002621766),('2024-06-26 06:25:00.000000',00000000000002634345),('2024-06-26 06:30:00.000000',00000000000002648224),('2024-06-26 06:35:00.000000',00000000000002654193),('2024-06-26 06:40:00.000000',00000000000002666072),('2024-06-26 06:45:00.000000',00000000000002670972),('2024-06-26 06:50:00.000000',00000000000002677572),('2024-06-26 06:55:00.000000',00000000000002692460),('2024-06-26 07:00:00.000000',00000000000002694460),('2024-06-26 07:05:00.000000',00000000000002724116),('2024-06-26 07:10:00.000000',00000000000002736985),('2024-06-26 07:15:00.000000',00000000000002790763),('2024-06-26 07:20:00.000000',00000000000002829121),('2024-06-26 07:25:00.000000',00000000000002858759),('2024-06-26 07:30:00.000000',00000000000002894325),('2024-06-26 07:35:00.000000',00000000000002909199),('2024-06-26 07:40:00.000000',00000000000002916099),('2024-06-26 07:45:00.000000',00000000000002930056),('2024-06-26 07:50:00.000000',00000000000002946923),('2024-06-26 07:55:00.000000',00000000000002959502),('2024-06-26 08:00:00.000000',00000000000002967391),('2024-06-26 08:05:00.000000',00000000000002977270),('2024-06-26 08:10:00.000000',00000000000002987146),('2024-06-26 08:15:00.000000',00000000000002993746),('2024-06-26 08:20:00.000000',00000000000002993746),('2024-06-26 08:25:00.000000',00000000000003013436),('2024-06-26 08:30:00.000000',00000000000003025306),('2024-06-26 08:35:00.000000',00000000000003032284),('2024-06-26 08:40:00.000000',00000000000003039274),('2024-06-26 08:45:00.000000',00000000000003048231),('2024-06-26 08:50:00.000000',00000000000003050220),('2024-06-26 08:55:00.000000',00000000000003068989),('2024-06-26 09:00:00.000000',00000000000003364790),('2024-06-26 09:05:00.000000',00000000000003381658),('2024-06-26 09:10:00.000000',00000000000003383647),('2024-06-26 09:15:00.000000',00000000000003392437),('2024-06-26 09:20:00.000000',00000000000003398435),('2024-06-26 09:25:00.000000',00000000000003413124),('2024-06-26 09:30:00.000000',00000000000003418113),('2024-06-26 09:35:00.000000',00000000000003443902),('2024-06-26 09:40:00.000000',00000000000003456591),('2024-06-26 09:45:00.000000',00000000000003471477),('2024-06-26 09:50:00.000000',00000000000003487457),('2024-06-26 09:55:00.000000',00000000000003507306),('2024-06-26 10:00:00.000000',00000000000003545105),('2024-06-26 10:05:00.000000',00000000000003549083),('2024-06-26 10:10:00.000000',00000000000003563063),('2024-06-26 10:15:00.000000',00000000000003566052),('2024-06-26 10:20:00.000000',00000000000003583120),('2024-06-26 10:25:00.000000',00000000000003632988),('2024-06-26 10:30:00.000000',00000000000003647866),('2024-06-26 10:35:00.000000',00000000000003658754),('2024-06-26 10:40:00.000000',00000000000003681252),('2024-06-26 10:45:00.000000',00000000000003695130),('2024-06-26 10:50:00.000000',00000000000003710886),('2024-06-26 10:55:00.000000',00000000000003718786),('2024-06-26 11:00:00.000000',00000000000003731575),('2024-06-26 11:05:00.000000',00000000000003746254),('2024-06-26 11:10:00.000000',00000000000003768254),('2024-06-26 11:15:00.000000',00000000000003781132),('2024-06-26 11:20:00.000000',00000000000003807899),('2024-06-26 11:25:00.000000',00000000000003822887),('2024-06-26 11:30:00.000000',00000000000003867589),('2024-06-26 11:35:00.000000',00000000000003895379),('2024-06-26 11:40:00.000000',00000000000003896379),('2024-06-26 11:45:00.000000',00000000000003905247),('2024-06-26 11:50:00.000000',00000000000003906246),('2024-06-26 11:55:00.000000',00000000000003917202),('2024-06-26 12:00:00.000000',00000000000003931471),('2024-06-26 12:05:00.000000',00000000000003936370),('2024-06-26 12:10:00.000000',00000000000003947670),('2024-06-26 12:15:00.000000',00000000000003963059),('2024-06-26 12:20:00.000000',00000000000003972528),('2024-06-26 12:25:00.000000',00000000000003983007),('2024-06-26 12:30:00.000000',00000000000004013686),('2024-06-26 12:35:00.000000',00000000000004038345),('2024-06-26 12:40:00.000000',00000000000004071094),('2024-06-26 12:45:00.000000',00000000000004085925),('2024-06-26 12:50:00.000000',00000000000004099103),('2024-06-26 12:55:00.000000',00000000000004109970),('2024-06-26 13:00:00.000000',00000000000004119960),('2024-06-26 13:05:00.000000',00000000000004140071),('2024-06-26 13:10:00.000000',00000000000004148050),('2024-06-26 13:15:00.000000',00000000000004194329),('2024-06-26 13:20:00.000000',00000000000004222942),('2024-06-26 13:25:00.000000',00000000000004243121),('2024-06-26 13:30:00.000000',00000000000004303446),('2024-06-26 13:35:00.000000',00000000000004402616),('2024-06-26 13:40:00.000000',00000000000004489371),('2024-06-26 13:45:00.000000',00000000000004563159),('2024-06-26 13:50:00.000000',00000000000004633817),('2024-06-26 13:55:00.000000',00000000000004710623),('2024-06-26 14:00:00.000000',00000000000004759481),('2024-06-26 14:05:00.000000',00000000000004815203),('2024-06-26 14:10:00.000000',00000000000004855861),('2024-06-26 14:15:00.000000',00000000000004891759),('2024-06-26 14:20:00.000000',00000000000004918516),('2024-06-26 14:25:00.000000',00000000000004947161),('2024-06-26 14:30:00.000000',00000000000004956140),('2024-06-26 14:35:00.000000',00000000000005054919),('2024-06-26 14:40:00.000000',00000000000005131555),('2024-06-26 14:45:00.000000',00000000000005150511),('2024-06-26 14:50:00.000000',00000000000005244179),('2024-06-26 14:55:00.000000',00000000000005266079),('2024-06-26 15:00:00.000000',00000000000005331669),('2024-06-26 15:05:00.000000',00000000000005443810),('2024-06-26 15:10:00.000000',00000000000005483476),('2024-06-26 15:15:00.000000',00000000000005504274),('2024-06-26 15:20:00.000000',00000000000005556831),('2024-06-26 15:25:00.000000',00000000000005572898),('2024-06-26 15:30:00.000000',00000000000005606266),('2024-06-26 15:35:00.000000',00000000000005674764),('2024-06-26 15:40:00.000000',00000000000005700421),('2024-06-26 15:45:00.000000',00000000000005725258),('2024-06-26 15:50:00.000000',00000000000005747191),('2024-06-26 15:55:00.000000',00000000000005785749),('2024-06-26 16:00:00.000000',00000000000000000000),('2024-06-26 16:05:00.000000',00000000000000031704),('2024-06-26 16:10:00.000000',00000000000000049851),('2024-06-26 16:15:00.000000',00000000000000093317),('2024-06-26 16:20:00.000000',00000000000000126057),('2024-06-26 16:25:00.000000',00000000000000179335),('2024-06-26 16:30:00.000000',00000000000000220802),('2024-06-26 16:35:00.000000',00000000000000247502),('2024-06-26 16:40:00.000000',00000000000000246490),('2024-06-26 16:45:00.000000',00000000000000262269),('2024-06-26 16:50:00.000000',00000000000000310844),('2024-06-26 16:55:00.000000',00000000000000359222),('2024-06-26 17:00:00.000000',00000000000000426758),('2024-06-26 17:05:00.000000',00000000000000459482),('2024-06-26 17:10:00.000000',00000000000000506372),('2024-06-26 17:15:00.000000',00000000000000527135),('2024-06-26 17:20:00.000000',00000000000000565988),('2024-06-26 17:25:00.000000',00000000000000579877),('2024-06-26 17:30:00.000000',00000000000000601767),('2024-06-26 17:35:00.000000',00000000000000612667),('2024-06-26 17:40:00.000000',00000000000000635136),('2024-06-26 17:45:00.000000',00000000000000665702),('2024-06-26 17:50:00.000000',00000000000000674658),('2024-06-26 17:55:00.000000',00000000000000708013),('2024-06-26 18:00:00.000000',00000000000000716980),('2024-06-26 18:05:00.000000',00000000000000730522),('2024-06-26 18:10:00.000000',00000000000000732511),('2024-06-26 18:15:00.000000',00000000000000746411),('2024-06-26 18:20:00.000000',00000000000000762199),('2024-06-26 18:25:00.000000',00000000000000765178),('2024-06-26 18:30:00.000000',00000000000000773666),('2024-06-26 18:35:00.000000',00000000000000791064),('2024-06-26 18:40:00.000000',00000000000000797952),('2024-06-26 18:45:00.000000',00000000000000812342),('2024-06-26 18:50:00.000000',00000000000000818242),('2024-06-26 18:55:00.000000',00000000000000829132),('2024-06-26 19:00:00.000000',00000000000000836119),('2024-06-26 19:05:00.000000',00000000000000841009),('2024-06-26 19:10:00.000000',00000000000000842909),('2024-06-26 19:15:00.000000',00000000000000850697),('2024-06-26 19:20:00.000000',00000000000000852686),('2024-06-26 19:25:00.000000',00000000000000852686),('2024-06-26 19:30:00.000000',00000000000000864586),('2024-06-26 19:35:00.000000',00000000000000871219),('2024-06-26 19:40:00.000000',00000000000000886077),('2024-06-26 19:45:00.000000',00000000000000901944),('2024-06-26 19:50:00.000000',00000000000000907599),('2024-06-26 19:55:00.000000',00000000000000908598),('2024-06-26 20:00:00.000000',00000000000000919376),('2024-06-26 20:05:00.000000',00000000000000922375),('2024-06-26 20:10:00.000000',00000000000000924374),('2024-06-26 20:15:00.000000',00000000000000924374),('2024-06-26 20:20:00.000000',00000000000000927372),('2024-06-26 20:25:00.000000',00000000000000936262),('2024-06-26 20:30:00.000000',00000000000000941262),('2024-06-26 20:35:00.000000',00000000000000941262),('2024-06-26 20:40:00.000000',00000000000000951251),('2024-06-26 20:45:00.000000',00000000000000951251),('2024-06-26 20:50:00.000000',00000000000000954241),('2024-06-26 20:55:00.000000',00000000000000954241),('2024-06-26 21:00:00.000000',00000000000000954241),('2024-06-26 21:05:00.000000',00000000000000956230),('2024-06-26 21:10:00.000000',00000000000000963206),('2024-06-26 21:15:00.000000',00000000000000970173),('2024-06-26 21:20:00.000000',00000000000000976140),('2024-06-26 21:25:00.000000',00000000000000978140),('2024-06-26 21:30:00.000000',00000000000000983140),('2024-06-26 21:35:00.000000',00000000000000983140),('2024-06-26 21:40:00.000000',00000000000000984139),('2024-06-26 21:45:00.000000',00000000000000984139),('2024-06-26 21:50:00.000000',00000000000000992029),('2024-06-26 21:55:00.000000',00000000000001000629),('2024-06-26 22:00:00.000000',00000000000001001629),('2024-06-26 22:05:00.000000',00000000000001001629),('2024-06-26 22:10:00.000000',00000000000001002629),('2024-06-26 22:15:00.000000',00000000000001006629),('2024-06-26 22:20:00.000000',00000000000001006629),('2024-06-26 22:25:00.000000',00000000000001014829),('2024-06-26 22:30:00.000000',00000000000001017829),('2024-06-26 22:35:00.000000',00000000000001017829),('2024-06-26 22:40:00.000000',00000000000001019829),('2024-06-26 22:45:00.000000',00000000000001027026),('2024-06-26 22:50:00.000000',00000000000001032025),('2024-06-26 22:55:00.000000',00000000000001032025),('2024-06-26 23:00:00.000000',00000000000001032025),('2024-06-26 23:05:00.000000',00000000000001032025),('2024-06-26 23:10:00.000000',00000000000001039625),('2024-06-26 23:15:00.000000',00000000000001046425),('2024-06-26 23:20:00.000000',00000000000001052503),('2024-06-26 23:25:00.000000',00000000000001065193),('2024-06-26 23:30:00.000000',00000000000001137082),('2024-06-26 23:35:00.000000',00000000000001140082),('2024-06-26 23:40:00.000000',00000000000001190571),('2024-06-26 23:45:00.000000',00000000000001195471),('2024-06-26 23:50:00.000000',00000000000001209238),('2024-06-26 23:55:00.000000',00000000000001211238),('2024-06-27 00:00:00.000000',00000000000001217227),('2024-06-27 00:05:00.000000',00000000000001221216),('2024-06-27 00:10:00.000000',00000000000001225216),('2024-06-27 00:15:00.000000',00000000000001231205),('2024-06-27 00:20:00.000000',00000000000001271205),('2024-06-27 00:25:00.000000',00000000000001287205),('2024-06-27 00:30:00.000000',00000000000001299105),('2024-06-27 00:35:00.000000',00000000000001309105),('2024-06-27 00:40:00.000000',00000000000001323003),('2024-06-27 00:45:00.000000',00000000000001324003),('2024-06-27 00:50:00.000000',00000000000001330993),('2024-06-27 00:55:00.000000',00000000000001334893),('2024-06-27 01:00:00.000000',00000000000001349072),('2024-06-27 01:05:00.000000',00000000000001368371),('2024-06-27 01:10:00.000000',00000000000001392228),('2024-06-27 01:15:00.000000',00000000000001437495),('2024-06-27 01:20:00.000000',00000000000001458884),('2024-06-27 01:25:00.000000',00000000000001473273),('2024-06-27 01:30:00.000000',00000000000001483061),('2024-06-27 01:35:00.000000',00000000000001499910),('2024-06-27 01:40:00.000000',00000000000001527809),('2024-06-27 01:45:00.000000',00000000000001531099),('2024-06-27 01:50:00.000000',00000000000001542966),('2024-06-27 01:55:00.000000',00000000000001559856),('2024-06-27 02:00:00.000000',00000000000001565742),('2024-06-27 02:05:00.000000',00000000000001598204),('2024-06-27 02:10:00.000000',00000000000001598304),('2024-06-27 02:15:00.000000',00000000000001601304),('2024-06-27 02:20:00.000000',00000000000001622993),('2024-06-27 02:25:00.000000',00000000000001618993),('2024-06-27 02:30:00.000000',00000000000001637783),('2024-06-27 02:35:00.000000',00000000000001646683),('2024-06-27 02:40:00.000000',00000000000001656570),('2024-06-27 02:45:00.000000',00000000000001660370),('2024-06-27 02:50:00.000000',00000000000001674170),('2024-06-27 02:55:00.000000',00000000000001683159),('2024-06-27 03:00:00.000000',00000000000001690357),('2024-06-27 03:05:00.000000',00000000000001699246),('2024-06-27 03:10:00.000000',00000000000001707146),('2024-06-27 03:15:00.000000',00000000000001726835),('2024-06-27 03:20:00.000000',00000000000001798011),('2024-06-27 03:25:00.000000',00000000000001805007),('2024-06-27 03:30:00.000000',00000000000001815885),('2024-06-27 03:35:00.000000',00000000000001831555),('2024-06-27 03:40:00.000000',00000000000001837444),('2024-06-27 03:45:00.000000',00000000000001847922),('2024-06-27 03:50:00.000000',00000000000001870611),('2024-06-27 03:55:00.000000',00000000000002036490),('2024-06-27 04:00:00.000000',00000000000002060260),('2024-06-27 04:05:00.000000',00000000000002067250),('2024-06-27 04:10:00.000000',00000000000002085100),('2024-06-27 04:15:00.000000',00000000000002099998),('2024-06-27 04:20:00.000000',00000000000002123778),('2024-06-27 04:25:00.000000',00000000000002181868),('2024-06-27 04:30:00.000000',00000000000002191678),('2024-06-27 04:35:00.000000',00000000000002205541),('2024-06-27 04:40:00.000000',00000000000002213430),('2024-06-27 04:45:00.000000',00000000000002217428),('2024-06-27 04:50:00.000000',00000000000002235218),('2024-06-27 04:55:00.000000',00000000000002243296),('2024-06-27 05:00:00.000000',00000000000002258153),('2024-06-27 05:05:00.000000',00000000000002278851),('2024-06-27 05:10:00.000000',00000000000002282651),('2024-06-27 05:15:00.000000',00000000000002292530),('2024-06-27 05:20:00.000000',00000000000002299498),('2024-06-27 05:25:00.000000',00000000000002341478),('2024-06-27 05:30:00.000000',00000000000002375068),('2024-06-27 05:35:00.000000',00000000000002379256),('2024-06-27 05:40:00.000000',00000000000002389435),('2024-06-27 05:45:00.000000',00000000000002400121),('2024-06-27 05:50:00.000000',00000000000002409753),('2024-06-27 05:55:00.000000',00000000000002414751),('2024-06-27 06:00:00.000000',00000000000002420141),('2024-06-27 06:05:00.000000',00000000000002425219),('2024-06-27 06:10:00.000000',00000000000002437985),('2024-06-27 06:15:00.000000',00000000000002459243),('2024-06-27 06:20:00.000000',00000000000002470200),('2024-06-27 06:25:00.000000',00000000000002477179),('2024-06-27 06:30:00.000000',00000000000002491068),('2024-06-27 06:35:00.000000',00000000000002512578),('2024-06-27 06:40:00.000000',00000000000002525356),('2024-06-27 06:45:00.000000',00000000000002547124),('2024-06-27 06:50:00.000000',00000000000002561802),('2024-06-27 06:55:00.000000',00000000000002571759),('2024-06-27 07:00:00.000000',00000000000002585548),('2024-06-27 07:05:00.000000',00000000000002608226),('2024-06-27 07:10:00.000000',00000000000002622104),('2024-06-27 07:15:00.000000',00000000000002640861),('2024-06-27 07:20:00.000000',00000000000002676546),('2024-06-27 07:25:00.000000',00000000000002721224),('2024-06-27 07:30:00.000000',00000000000002735904),('2024-06-27 07:35:00.000000',00000000000002753593),('2024-06-27 07:40:00.000000',00000000000002812463),('2024-06-27 07:45:00.000000',00000000000002859540),('2024-06-27 07:50:00.000000',00000000000002877529),('2024-06-27 07:55:00.000000',00000000000002899997),('2024-06-27 08:00:00.000000',00000000000002912875),('2024-06-27 08:05:00.000000',00000000000002917863),('2024-06-27 08:10:00.000000',00000000000002930763),('2024-06-27 08:15:00.000000',00000000000002943631),('2024-06-27 08:20:00.000000',00000000000002960499),('2024-06-27 08:25:00.000000',00000000000002982168),('2024-06-27 08:30:00.000000',00000000000003010546),('2024-06-27 08:35:00.000000',00000000000003059094),('2024-06-27 08:40:00.000000',00000000000003082839),('2024-06-27 08:45:00.000000',00000000000003209228),('2024-06-27 08:50:00.000000',00000000000003217024),('2024-06-27 08:55:00.000000',00000000000003231883),('2024-06-27 09:00:00.000000',00000000000003241283),('2024-06-27 09:05:00.000000',00000000000003248551),('2024-06-27 09:10:00.000000',00000000000003262119),('2024-06-27 09:15:00.000000',00000000000003280808),('2024-06-27 09:20:00.000000',00000000000003296387),('2024-06-27 09:25:00.000000',00000000000003310277),('2024-06-27 09:30:00.000000',00000000000003360275),('2024-06-27 09:35:00.000000',00000000000003373262),('2024-06-27 09:40:00.000000',00000000000003374262),('2024-06-27 09:45:00.000000',00000000000003381151),('2024-06-27 09:50:00.000000',00000000000003395119),('2024-06-27 09:55:00.000000',00000000000003407994),('2024-06-27 10:00:00.000000',00000000000003427841),('2024-06-27 10:05:00.000000',00000000000003408809),('2024-06-27 10:10:00.000000',00000000000003417589),('2024-06-27 10:15:00.000000',00000000000003431089),('2024-06-27 10:20:00.000000',00000000000003441889),('2024-06-27 10:25:00.000000',00000000000003451867),('2024-06-27 10:30:00.000000',00000000000003454856),('2024-06-27 10:35:00.000000',00000000000003600054),('2024-06-27 10:40:00.000000',00000000000003623832),('2024-06-27 10:45:00.000000',00000000000003641611),('2024-06-27 10:50:00.000000',00000000000003660489),('2024-06-27 10:55:00.000000',00000000000003664477),('2024-06-27 11:00:00.000000',00000000000003675366),('2024-06-27 11:05:00.000000',00000000000003694956),('2024-06-27 11:10:00.000000',00000000000003717043),('2024-06-27 11:15:00.000000',00000000000003729743),('2024-06-27 11:20:00.000000',00000000000003739112),('2024-06-27 11:25:00.000000',00000000000003752901),('2024-06-27 11:30:00.000000',00000000000003765169),('2024-06-27 11:35:00.000000',00000000000003768158),('2024-06-27 11:40:00.000000',00000000000003774156),('2024-06-27 11:45:00.000000',00000000000003797846),('2024-06-27 11:50:00.000000',00000000000003798846),('2024-06-27 11:55:00.000000',00000000000003834846),('2024-06-27 12:00:00.000000',00000000000003866435),('2024-06-27 12:05:00.000000',00000000000003874536),('2024-06-27 12:10:00.000000',00000000000003894415),('2024-06-27 12:15:00.000000',00000000000003905295),('2024-06-27 12:20:00.000000',00000000000003905295),('2024-06-27 12:25:00.000000',00000000000003914215),('2024-06-27 12:30:00.000000',00000000000003902755),('2024-06-27 12:35:00.000000',00000000000003927455),('2024-06-27 12:40:00.000000',00000000000003980245),('2024-06-27 12:45:00.000000',00000000000004004843),('2024-06-27 12:50:00.000000',00000000000004030243),('2024-06-27 12:55:00.000000',00000000000004065702),('2024-06-27 13:00:00.000000',00000000000004089276),('2024-06-27 13:05:00.000000',00000000000004112665),('2024-06-27 13:10:00.000000',00000000000004133432),('2024-06-27 13:15:00.000000',00000000000004145085),('2024-06-27 13:20:00.000000',00000000000004163044),('2024-06-27 13:25:00.000000',00000000000004185890),('2024-06-27 13:30:00.000000',00000000000004216245),('2024-06-27 13:35:00.000000',00000000000004235801),('2024-06-27 13:40:00.000000',00000000000004276691),('2024-06-27 13:45:00.000000',00000000000004291389),('2024-06-27 13:50:00.000000',00000000000004306099),('2024-06-27 13:55:00.000000',00000000000004322789),('2024-06-27 14:00:00.000000',00000000000004336756),('2024-06-27 14:05:00.000000',00000000000004349724),('2024-06-27 14:10:00.000000',00000000000004370371),('2024-06-27 14:15:00.000000',00000000000004386169),('2024-06-27 14:20:00.000000',00000000000004400969),('2024-06-27 14:25:00.000000',00000000000004418739),('2024-06-27 14:30:00.000000',00000000000004446992),('2024-06-27 14:35:00.000000',00000000000004489205),('2024-06-27 14:40:00.000000',00000000000004520472),('2024-06-27 14:45:00.000000',00000000000004535107),('2024-06-27 14:50:00.000000',00000000000004591583),('2024-06-27 14:55:00.000000',00000000000004640982),('2024-06-27 15:00:00.000000',00000000000004757160),('2024-06-27 15:05:00.000000',00000000000004790639),('2024-06-27 15:10:00.000000',00000000000004813437),('2024-06-27 15:15:00.000000',00000000000004855437),('2024-06-27 15:20:00.000000',00000000000004898235),('2024-06-27 15:25:00.000000',00000000000004975923),('2024-06-27 15:30:00.000000',00000000000005014009),('2024-06-27 15:35:00.000000',00000000000005068798),('2024-06-27 15:40:00.000000',00000000000005131168),('2024-06-27 15:45:00.000000',00000000000005159148),('2024-06-27 15:50:00.000000',00000000000005201282),('2024-06-27 15:55:00.000000',00000000000005241768),('2024-06-27 16:00:00.000000',00000000000000000000),('2024-06-27 16:05:00.000000',00000000000000017798),('2024-06-27 16:10:00.000000',00000000000000060165),('2024-06-27 16:15:00.000000',00000000000000079819),('2024-06-27 16:20:00.000000',00000000000000097799),('2024-06-27 16:25:00.000000',00000000000000138224),('2024-06-27 16:30:00.000000',00000000000000154123),('2024-06-27 16:35:00.000000',00000000000000169983),('2024-06-27 16:40:00.000000',00000000000000184870),('2024-06-27 16:45:00.000000',00000000000000215547),('2024-06-27 16:50:00.000000',00000000000000244224),('2024-06-27 16:55:00.000000',00000000000000260524),('2024-06-27 17:00:00.000000',00000000000000283514),('2024-06-27 17:05:00.000000',00000000000000297294),('2024-06-27 17:10:00.000000',00000000000000315782),('2024-06-27 17:15:00.000000',00000000000000327562),('2024-06-27 17:20:00.000000',00000000000000337431),('2024-06-27 17:25:00.000000',00000000000000361719),('2024-06-27 17:30:00.000000',00000000000000366119),('2024-06-27 17:35:00.000000',00000000000000383087),('2024-06-27 17:40:00.000000',00000000000000400877),('2024-06-27 17:45:00.000000',00000000000000411766),('2024-06-27 17:50:00.000000',00000000000000442766),('2024-06-27 17:55:00.000000',00000000000000464365),('2024-06-27 18:00:00.000000',00000000000000472754),('2024-06-27 18:05:00.000000',00000000000000479744),('2024-06-27 18:10:00.000000',00000000000000497434),('2024-06-27 18:15:00.000000',00000000000000501334),('2024-06-27 18:20:00.000000',00000000000000510133),('2024-06-27 18:25:00.000000',00000000000000514033),('2024-06-27 18:30:00.000000',00000000000000518631),('2024-06-27 18:35:00.000000',00000000000000535477),('2024-06-27 18:40:00.000000',00000000000000556155),('2024-06-27 18:45:00.000000',00000000000000566055),('2024-06-27 18:50:00.000000',00000000000000566055),('2024-06-27 18:55:00.000000',00000000000000571955),('2024-06-27 19:00:00.000000',00000000000000576855),('2024-06-27 19:05:00.000000',00000000000000615444),('2024-06-27 19:10:00.000000',00000000000000616444),('2024-06-27 19:15:00.000000',00000000000000623240),('2024-06-27 19:20:00.000000',00000000000000640108),('2024-06-27 19:25:00.000000',00000000000000642097),('2024-06-27 19:30:00.000000',00000000000000642097),('2024-06-27 19:35:00.000000',00000000000000645097),('2024-06-27 19:40:00.000000',00000000000000650997),('2024-06-27 19:45:00.000000',00000000000000650997),('2024-06-27 19:50:00.000000',00000000000000652997),('2024-06-27 19:55:00.000000',00000000000000654997),('2024-06-27 20:00:00.000000',00000000000000654997),('2024-06-27 20:05:00.000000',00000000000000666797),('2024-06-27 20:10:00.000000',00000000000000658897),('2024-06-27 20:15:00.000000',00000000000000662875),('2024-06-27 20:20:00.000000',00000000000000674765),('2024-06-27 20:25:00.000000',00000000000000683565),('2024-06-27 20:30:00.000000',00000000000000685563),('2024-06-27 20:35:00.000000',00000000000000689552),('2024-06-27 20:40:00.000000',00000000000000689552),('2024-06-27 20:45:00.000000',00000000000000689552),('2024-06-27 20:50:00.000000',00000000000000689552),('2024-06-27 20:55:00.000000',00000000000000693452),('2024-06-27 21:00:00.000000',00000000000000694452),('2024-06-27 21:05:00.000000',00000000000000694452),('2024-06-27 21:10:00.000000',00000000000000694452),('2024-06-27 21:15:00.000000',00000000000000694452),('2024-06-27 21:20:00.000000',00000000000000736342),('2024-06-27 21:25:00.000000',00000000000000746342),('2024-06-27 21:30:00.000000',00000000000000752322),('2024-06-27 21:35:00.000000',00000000000000763220),('2024-06-27 21:40:00.000000',00000000000000763220),('2024-06-27 21:45:00.000000',00000000000000765209),('2024-06-27 21:50:00.000000',00000000000000767209),('2024-06-27 21:55:00.000000',00000000000000781098),('2024-06-27 22:00:00.000000',00000000000000784087),('2024-06-27 22:05:00.000000',00000000000000784087),('2024-06-27 22:10:00.000000',00000000000000786087),('2024-06-27 22:15:00.000000',00000000000000807987),('2024-06-27 22:20:00.000000',00000000000000807987),('2024-06-27 22:25:00.000000',00000000000000812976),('2024-06-27 22:30:00.000000',00000000000000819865),('2024-06-27 22:35:00.000000',00000000000000823854),('2024-06-27 22:40:00.000000',00000000000000826844),('2024-06-27 22:45:00.000000',00000000000000826844),('2024-06-27 22:50:00.000000',00000000000000828844),('2024-06-27 22:55:00.000000',00000000000000828844),('2024-06-27 23:00:00.000000',00000000000000830844),('2024-06-27 23:05:00.000000',00000000000000834844),('2024-06-27 23:10:00.000000',00000000000000845644),('2024-06-27 23:15:00.000000',00000000000000855624),('2024-06-27 23:20:00.000000',00000000000000857624),('2024-06-27 23:25:00.000000',00000000000000930324),('2024-06-27 23:30:00.000000',00000000000000935224),('2024-06-27 23:35:00.000000',00000000000000951124),('2024-06-27 23:40:00.000000',00000000000000946524),('2024-06-27 23:45:00.000000',00000000000000950524),('2024-06-27 23:50:00.000000',00000000000000996324),('2024-06-27 23:55:00.000000',00000000000000996324),('2024-06-28 00:00:00.000000',00000000000000998322),('2024-06-28 00:05:00.000000',00000000000001008812),('2024-06-28 00:10:00.000000',00000000000001013692),('2024-06-28 00:15:00.000000',00000000000001025580),('2024-06-28 00:20:00.000000',00000000000001032149),('2024-06-28 00:25:00.000000',00000000000001044147),('2024-06-28 00:30:00.000000',00000000000001047146),('2024-06-28 00:35:00.000000',00000000000001051035),('2024-06-28 00:40:00.000000',00000000000001051035),('2024-06-28 00:45:00.000000',00000000000001055035),('2024-06-28 00:50:00.000000',00000000000001055135),('2024-06-28 00:55:00.000000',00000000000001069935),('2024-06-28 01:00:00.000000',00000000000001071924),('2024-06-28 01:05:00.000000',00000000000001101424),('2024-06-28 01:10:00.000000',00000000000001106424),('2024-06-28 01:15:00.000000',00000000000001118024),('2024-06-28 01:20:00.000000',00000000000001122013),('2024-06-28 01:25:00.000000',00000000000001132601),('2024-06-28 01:30:00.000000',00000000000001132601),('2024-06-28 01:35:00.000000',00000000000001138580),('2024-06-28 01:40:00.000000',00000000000001147380),('2024-06-28 01:45:00.000000',00000000000001158976),('2024-06-28 01:50:00.000000',00000000000001165776),('2024-06-28 01:55:00.000000',00000000000001169766),('2024-06-28 02:00:00.000000',00000000000001181656),('2024-06-28 02:05:00.000000',00000000000001192636),('2024-06-28 02:10:00.000000',00000000000001210244),('2024-06-28 02:15:00.000000',00000000000001216222),('2024-06-28 02:20:00.000000',00000000000001231067),('2024-06-28 02:25:00.000000',00000000000001261653),('2024-06-28 02:30:00.000000',00000000000001282753),('2024-06-28 02:35:00.000000',00000000000001281424),('2024-06-28 02:40:00.000000',00000000000001284403),('2024-06-28 02:45:00.000000',00000000000001287303),('2024-06-28 02:50:00.000000',00000000000001296192),('2024-06-28 02:55:00.000000',00000000000001306992),('2024-06-28 03:00:00.000000',00000000000001351692),('2024-06-28 03:05:00.000000',00000000000001353681),('2024-06-28 03:10:00.000000',00000000000001366381),('2024-06-28 03:15:00.000000',00000000000001376381),('2024-06-28 03:20:00.000000',00000000000001383280),('2024-06-28 03:25:00.000000',00000000000001402200),('2024-06-28 03:30:00.000000',00000000000001409099),('2024-06-28 03:35:00.000000',00000000000001411099),('2024-06-28 03:40:00.000000',00000000000001416988),('2024-06-28 03:45:00.000000',00000000000001430778),('2024-06-28 03:50:00.000000',00000000000001437758),('2024-06-28 03:55:00.000000',00000000000001436758),('2024-06-28 04:00:00.000000',00000000000001443558),('2024-06-28 04:05:00.000000',00000000000001451458),('2024-06-28 04:10:00.000000',00000000000001455258),('2024-06-28 04:15:00.000000',00000000000001455258),('2024-06-28 04:20:00.000000',00000000000001456258),('2024-06-28 04:25:00.000000',00000000000001461256),('2024-06-28 04:30:00.000000',00000000000001486290),('2024-06-28 04:35:00.000000',00000000000001541180),('2024-06-28 04:40:00.000000',00000000000001556149),('2024-06-28 04:45:00.000000',00000000000001564329),('2024-06-28 04:50:00.000000',00000000000001586997),('2024-06-28 04:55:00.000000',00000000000001599955),('2024-06-28 05:00:00.000000',00000000000001662225),('2024-06-28 05:05:00.000000',00000000000001671025),('2024-06-28 05:10:00.000000',00000000000001690804),('2024-06-28 05:15:00.000000',00000000000001704694),('2024-06-28 05:20:00.000000',00000000000001725083),('2024-06-28 05:25:00.000000',00000000000001759673),('2024-06-28 05:30:00.000000',00000000000001829258),('2024-06-28 05:35:00.000000',00000000000001861158),('2024-06-28 05:40:00.000000',00000000000001905047),('2024-06-28 05:45:00.000000',00000000000001924777),('2024-06-28 05:50:00.000000',00000000000001975356),('2024-06-28 05:55:00.000000',00000000000001993026),('2024-06-28 06:00:00.000000',00000000000002043104),('2024-06-28 06:05:00.000000',00000000000002101884),('2024-06-28 06:10:00.000000',00000000000002119243),('2024-06-28 06:15:00.000000',00000000000002137320),('2024-06-28 06:20:00.000000',00000000000002201710),('2024-06-28 06:25:00.000000',00000000000002235498),('2024-06-28 06:30:00.000000',00000000000002245087),('2024-06-28 06:35:00.000000',00000000000002282866),('2024-06-28 06:40:00.000000',00000000000002290766),('2024-06-28 06:45:00.000000',00000000000002302642),('2024-06-28 06:50:00.000000',00000000000002375120),('2024-06-28 06:55:00.000000',00000000000002385094),('2024-06-28 07:00:00.000000',00000000000002400083),('2024-06-28 07:05:00.000000',00000000000002403983),('2024-06-28 07:10:00.000000',00000000000002426661),('2024-06-28 07:15:00.000000',00000000000002436529),('2024-06-28 07:20:00.000000',00000000000002456378),('2024-06-28 07:25:00.000000',00000000000002555568),('2024-06-28 07:30:00.000000',00000000000002572293),('2024-06-28 07:35:00.000000',00000000000002584170),('2024-06-28 07:40:00.000000',00000000000002603039),('2024-06-28 07:45:00.000000',00000000000002619026),('2024-06-28 07:50:00.000000',00000000000002639016),('2024-06-28 07:55:00.000000',00000000000002642816),('2024-06-28 08:00:00.000000',00000000000002658795),('2024-06-28 08:05:00.000000',00000000000002680553),('2024-06-28 08:10:00.000000',00000000000002682553),('2024-06-28 08:15:00.000000',00000000000002700337),('2024-06-28 08:20:00.000000',00000000000002704316),('2024-06-28 08:25:00.000000',00000000000002712204),('2024-06-28 08:30:00.000000',00000000000002731483),('2024-06-28 08:35:00.000000',00000000000002748272),('2024-06-28 08:40:00.000000',00000000000002774462),('2024-06-28 08:45:00.000000',00000000000002815251),('2024-06-28 08:50:00.000000',00000000000002827118),('2024-06-28 08:55:00.000000',00000000000002854955),('2024-06-28 09:00:00.000000',00000000000002870578),('2024-06-28 09:05:00.000000',00000000000002906736),('2024-06-28 09:10:00.000000',00000000000002909737),('2024-06-28 09:15:00.000000',00000000000002916716),('2024-06-28 09:20:00.000000',00000000000002932586),('2024-06-28 09:25:00.000000',00000000000002938224),('2024-06-28 09:30:00.000000',00000000000002946214),('2024-06-28 09:35:00.000000',00000000000002963101),('2024-06-28 09:40:00.000000',00000000000003094061),('2024-06-28 09:45:00.000000',00000000000003148539),('2024-06-28 09:50:00.000000',00000000000003158439),('2024-06-28 09:55:00.000000',00000000000003184128),('2024-06-28 10:00:00.000000',00000000000003197018),('2024-06-28 10:05:00.000000',00000000000003207816),('2024-06-28 10:10:00.000000',00000000000003211803),('2024-06-28 10:15:00.000000',00000000000003219783),('2024-06-28 10:20:00.000000',00000000000003212883),('2024-06-28 10:25:00.000000',00000000000003602683),('2024-06-28 10:30:00.000000',00000000000003602683),('2024-06-28 10:35:00.000000',00000000000003602683),('2024-06-28 10:40:00.000000',00000000000003615461),('2024-06-28 10:45:00.000000',00000000000003626359),('2024-06-28 10:50:00.000000',00000000000003638247),('2024-06-28 10:55:00.000000',00000000000003640236),('2024-06-28 11:00:00.000000',00000000000003646224),('2024-06-28 11:05:00.000000',00000000000003650124),('2024-06-28 11:10:00.000000',00000000000003654314),('2024-06-28 11:15:00.000000',00000000000003664212),('2024-06-28 11:20:00.000000',00000000000003664212),('2024-06-28 11:25:00.000000',00000000000003677902),('2024-06-28 11:30:00.000000',00000000000003706080),('2024-06-28 11:35:00.000000',00000000000003719967),('2024-06-28 11:40:00.000000',00000000000003730856),('2024-06-28 11:45:00.000000',00000000000003739501),('2024-06-28 11:50:00.000000',00000000000003751470),('2024-06-28 11:55:00.000000',00000000000003769346),('2024-06-28 12:00:00.000000',00000000000003772344),('2024-06-28 12:05:00.000000',00000000000003777243),('2024-06-28 12:10:00.000000',00000000000003785222),('2024-06-28 12:15:00.000000',00000000000003791102),('2024-06-28 12:20:00.000000',00000000000003809681),('2024-06-28 12:25:00.000000',00000000000003959871),('2024-06-28 12:30:00.000000',00000000000004002771),('2024-06-28 12:35:00.000000',00000000000004023258),('2024-06-28 12:40:00.000000',00000000000004028158),('2024-06-28 12:45:00.000000',00000000000004038137),('2024-06-28 12:50:00.000000',00000000000004038137),('2024-06-28 12:55:00.000000',00000000000004040137),('2024-06-28 13:00:00.000000',00000000000004061727),('2024-06-28 13:05:00.000000',00000000000004062627),('2024-06-28 13:10:00.000000',00000000000004071904),('2024-06-28 13:15:00.000000',00000000000004079893),('2024-06-28 13:20:00.000000',00000000000004083882),('2024-06-28 13:25:00.000000',00000000000004095552),('2024-06-28 13:30:00.000000',00000000000004104542),('2024-06-28 13:35:00.000000',00000000000004136109),('2024-06-28 13:40:00.000000',00000000000004146054),('2024-06-28 13:45:00.000000',00000000000004160522),('2024-06-28 13:50:00.000000',00000000000004177222),('2024-06-28 13:55:00.000000',00000000000004181212),('2024-06-28 14:00:00.000000',00000000000004193672),('2024-06-28 14:05:00.000000',00000000000004243062),('2024-06-28 14:10:00.000000',00000000000004255252),('2024-06-28 14:15:00.000000',00000000000004271941),('2024-06-28 14:20:00.000000',00000000000004291797),('2024-06-28 14:25:00.000000',00000000000004298764),('2024-06-28 14:30:00.000000',00000000000004299162),('2024-06-28 14:35:00.000000',00000000000004317119),('2024-06-28 14:40:00.000000',00000000000004362596),('2024-06-28 14:45:00.000000',00000000000004377574),('2024-06-28 14:50:00.000000',00000000000004411453),('2024-06-28 14:55:00.000000',00000000000004544543),('2024-06-28 15:00:00.000000',00000000000004585309),('2024-06-28 15:05:00.000000',00000000000004641987),('2024-06-28 15:10:00.000000',00000000000004686666),('2024-06-28 15:15:00.000000',00000000000004737744),('2024-06-28 15:20:00.000000',00000000000004776621),('2024-06-28 15:25:00.000000',00000000000004807489),('2024-06-28 15:30:00.000000',00000000000004835479),('2024-06-28 15:35:00.000000',00000000000004884637),('2024-06-28 15:40:00.000000',00000000000004911826),('2024-06-28 15:45:00.000000',00000000000004955372),('2024-06-28 15:50:00.000000',00000000000005065049),('2024-06-28 15:55:00.000000',00000000000005088647),('2024-06-28 16:00:00.000000',00000000000000000000),('2024-06-28 16:05:00.000000',00000000000000065788),('2024-06-28 16:10:00.000000',00000000000000113555),('2024-06-28 16:15:00.000000',00000000000000155544),('2024-06-28 16:20:00.000000',00000000000000220201),('2024-06-28 16:25:00.000000',00000000000000388665),('2024-06-28 16:30:00.000000',00000000000000431642),('2024-06-28 16:35:00.000000',00000000000000760442),('2024-06-28 16:40:00.000000',00000000000000807931),('2024-06-28 16:45:00.000000',00000000000000829331),('2024-06-28 16:50:00.000000',00000000000000880508),('2024-06-28 16:55:00.000000',00000000000001072208),('2024-06-28 17:00:00.000000',00000000000001097808),('2024-06-28 17:05:00.000000',00000000000001121577),('2024-06-28 17:10:00.000000',00000000000001165753),('2024-06-28 17:15:00.000000',00000000000001199318),('2024-06-28 17:20:00.000000',00000000000001222185),('2024-06-28 17:25:00.000000',00000000000001240351),('2024-06-28 17:30:00.000000',00000000000001262009),('2024-06-28 17:35:00.000000',00000000000001280298),('2024-06-28 17:40:00.000000',00000000000001298576),('2024-06-28 17:45:00.000000',00000000000001299665),('2024-06-28 17:50:00.000000',00000000000001332254),('2024-06-28 17:55:00.000000',00000000000001350132),('2024-06-28 18:00:00.000000',00000000000001371422),('2024-06-28 18:05:00.000000',00000000000001384102),('2024-06-28 18:10:00.000000',00000000000001409282),('2024-06-28 18:15:00.000000',00000000000001437739),('2024-06-28 18:20:00.000000',00000000000001473129),('2024-06-28 18:25:00.000000',00000000000001478829),('2024-06-28 18:30:00.000000',00000000000001510407),('2024-06-28 18:35:00.000000',00000000000001512407),('2024-06-28 18:40:00.000000',00000000000001549795),('2024-06-28 18:45:00.000000',00000000000001574395),('2024-06-28 18:50:00.000000',00000000000001586074),('2024-06-28 18:55:00.000000',00000000000001588074),('2024-06-28 19:00:00.000000',00000000000001606674),('2024-06-28 19:05:00.000000',00000000000001615274),('2024-06-28 19:10:00.000000',00000000000001620174),('2024-06-28 19:15:00.000000',00000000000001627043),('2024-06-28 19:20:00.000000',00000000000001625343),('2024-06-28 19:25:00.000000',00000000000001653043),('2024-06-28 19:30:00.000000',00000000000001662933),('2024-06-28 19:35:00.000000',00000000000001677722),('2024-06-28 19:40:00.000000',00000000000001693522),('2024-06-28 19:45:00.000000',00000000000001704421),('2024-06-28 19:50:00.000000',00000000000001704421),('2024-06-28 19:55:00.000000',00000000000001713321),('2024-06-28 20:00:00.000000',00000000000001718221),('2024-06-28 20:05:00.000000',00000000000001725211),('2024-06-28 20:10:00.000000',00000000000001741911),('2024-06-28 20:15:00.000000',00000000000001741911),('2024-06-28 20:20:00.000000',00000000000001742911),('2024-06-28 20:25:00.000000',00000000000001747901),('2024-06-28 20:30:00.000000',00000000000001752901),('2024-06-28 20:35:00.000000',00000000000001763391),('2024-06-28 20:40:00.000000',00000000000001763391),('2024-06-28 20:45:00.000000',00000000000001763391),('2024-06-28 20:50:00.000000',00000000000001763391),('2024-06-28 20:55:00.000000',00000000000001768389),('2024-06-28 21:00:00.000000',00000000000001768389),('2024-06-28 21:05:00.000000',00000000000001770389),('2024-06-28 21:10:00.000000',00000000000001772389),('2024-06-28 21:15:00.000000',00000000000001772389),('2024-06-28 21:20:00.000000',00000000000001781189),('2024-06-28 21:25:00.000000',00000000000001781189),('2024-06-28 21:30:00.000000',00000000000001790069),('2024-06-28 21:35:00.000000',00000000000001790069),('2024-06-28 21:40:00.000000',00000000000001791969),('2024-06-28 21:45:00.000000',00000000000001795959),('2024-06-28 21:50:00.000000',00000000000001808838),('2024-06-28 21:55:00.000000',00000000000001819638),('2024-06-28 22:00:00.000000',00000000000001825638),('2024-06-28 22:05:00.000000',00000000000001828636),('2024-06-28 22:10:00.000000',00000000000001828636),('2024-06-28 22:15:00.000000',00000000000001830636),('2024-06-28 22:20:00.000000',00000000000001840536),('2024-06-28 22:25:00.000000',00000000000001841536),('2024-06-28 22:30:00.000000',00000000000001849336),('2024-06-28 22:35:00.000000',00000000000001849336),('2024-06-28 22:40:00.000000',00000000000001849336),('2024-06-28 22:45:00.000000',00000000000001849336),('2024-06-28 22:50:00.000000',00000000000001860136),('2024-06-28 22:55:00.000000',00000000000001863136),('2024-06-28 23:00:00.000000',00000000000001865136),('2024-06-28 23:05:00.000000',00000000000001907036),('2024-06-28 23:10:00.000000',00000000000001912916),('2024-06-28 23:15:00.000000',00000000000001917815),('2024-06-28 23:20:00.000000',00000000000001922925),('2024-06-28 23:25:00.000000',00000000000001931825),('2024-06-28 23:30:00.000000',00000000000001941115),('2024-06-28 23:35:00.000000',00000000000001944605),('2024-06-28 23:40:00.000000',00000000000001954495),('2024-06-28 23:45:00.000000',00000000000001961483),('2024-06-28 23:50:00.000000',00000000000001961483),('2024-06-28 23:55:00.000000',00000000000001966582),('2024-06-29 00:00:00.000000',00000000000001966782),('2024-06-29 00:05:00.000000',00000000000001966782),('2024-06-29 00:10:00.000000',00000000000001978641),('2024-06-29 00:15:00.000000',00000000000001983641),('2024-06-29 00:20:00.000000',00000000000001985641),('2024-06-29 00:25:00.000000',00000000000001988641),('2024-06-29 00:30:00.000000',00000000000002007341),('2024-06-29 00:35:00.000000',00000000000002016231),('2024-06-29 00:40:00.000000',00000000000002027199),('2024-06-29 00:45:00.000000',00000000000002031198),('2024-06-29 00:50:00.000000',00000000000002037098),('2024-06-29 00:55:00.000000',00000000000002044898),('2024-06-29 01:00:00.000000',00000000000002051898),('2024-06-29 01:05:00.000000',00000000000002054198),('2024-06-29 01:10:00.000000',00000000000002070978),('2024-06-29 01:15:00.000000',00000000000002072268),('2024-06-29 01:20:00.000000',00000000000002084046),('2024-06-29 01:25:00.000000',00000000000002091336),('2024-06-29 01:30:00.000000',00000000000002112025),('2024-06-29 01:35:00.000000',00000000000002115025),('2024-06-29 01:40:00.000000',00000000000002120925),('2024-06-29 01:45:00.000000',00000000000002125915),('2024-06-29 01:50:00.000000',00000000000002176715),('2024-06-29 01:55:00.000000',00000000000002177715),('2024-06-29 02:00:00.000000',00000000000002187595),('2024-06-29 02:05:00.000000',00000000000002195575),('2024-06-29 02:10:00.000000',00000000000002215542),('2024-06-29 02:15:00.000000',00000000000002224430),('2024-06-29 02:20:00.000000',00000000000002230408),('2024-06-29 02:25:00.000000',00000000000002238887),('2024-06-29 02:30:00.000000',00000000000002240887),('2024-06-29 02:35:00.000000',00000000000002255787),('2024-06-29 02:40:00.000000',00000000000002255787),('2024-06-29 02:45:00.000000',00000000000002267987),('2024-06-29 02:50:00.000000',00000000000002285776),('2024-06-29 02:55:00.000000',00000000000002363576),('2024-06-29 03:00:00.000000',00000000000002366476),('2024-06-29 03:05:00.000000',00000000000002372466),('2024-06-29 03:10:00.000000',00000000000002391456),('2024-06-29 03:15:00.000000',00000000000002402246),('2024-06-29 03:20:00.000000',00000000000002405901),('2024-06-29 03:25:00.000000',00000000000002421846),('2024-06-29 03:30:00.000000',00000000000002431792),('2024-06-29 03:35:00.000000',00000000000002453724),('2024-06-29 03:40:00.000000',00000000000002460513),('2024-06-29 03:45:00.000000',00000000000002494150),('2024-06-29 03:50:00.000000',00000000000002512070),('2024-06-29 03:55:00.000000',00000000000002558750),('2024-06-29 04:00:00.000000',00000000000002562750),('2024-06-29 04:05:00.000000',00000000000002573450),('2024-06-29 04:10:00.000000',00000000000002577450),('2024-06-29 04:15:00.000000',00000000000002594439),('2024-06-29 04:20:00.000000',00000000000002643237),('2024-06-29 04:25:00.000000',00000000000002668017),('2024-06-29 04:30:00.000000',00000000000002679687),('2024-06-29 04:35:00.000000',00000000000002707257),('2024-06-29 04:40:00.000000',00000000000002721335),('2024-06-29 04:45:00.000000',00000000000002787913),('2024-06-29 04:50:00.000000',00000000000002884702),('2024-06-29 04:55:00.000000',00000000000002889692),('2024-06-29 05:00:00.000000',00000000000002894192),('2024-06-29 05:05:00.000000',00000000000002898170),('2024-06-29 05:10:00.000000',00000000000002912068),('2024-06-29 05:15:00.000000',00000000000002921946),('2024-06-29 05:20:00.000000',00000000000002928936),('2024-06-29 05:25:00.000000',00000000000002941685),('2024-06-29 05:30:00.000000',00000000000002943683),('2024-06-29 05:35:00.000000',00000000000002944683),('2024-06-29 05:40:00.000000',00000000000002953553),('2024-06-29 05:45:00.000000',00000000000002960551),('2024-06-29 05:50:00.000000',00000000000002967540),('2024-06-29 05:55:00.000000',00000000000003022108),('2024-06-29 06:00:00.000000',00000000000003032985),('2024-06-29 06:05:00.000000',00000000000003091955),('2024-06-29 06:10:00.000000',00000000000003095944),('2024-06-29 06:15:00.000000',00000000000003101834),('2024-06-29 06:20:00.000000',00000000000003147812),('2024-06-29 06:25:00.000000',00000000000003151722),('2024-06-29 06:30:00.000000',00000000000003163322),('2024-06-29 06:35:00.000000',00000000000003191622),('2024-06-29 06:40:00.000000',00000000000003197322),('2024-06-29 06:45:00.000000',00000000000003206182),('2024-06-29 06:50:00.000000',00000000000003216972),('2024-06-29 06:55:00.000000',00000000000003224872),('2024-06-29 07:00:00.000000',00000000000003230761),('2024-06-29 07:05:00.000000',00000000000003237261),('2024-06-29 07:10:00.000000',00000000000003254151),('2024-06-29 07:15:00.000000',00000000000003263031),('2024-06-29 07:20:00.000000',00000000000003278919),('2024-06-29 07:25:00.000000',00000000000003284119),('2024-06-29 07:30:00.000000',00000000000003290008),('2024-06-29 07:35:00.000000',00000000000003308693),('2024-06-29 07:40:00.000000',00000000000003310693),('2024-06-29 07:45:00.000000',00000000000003318672),('2024-06-29 07:50:00.000000',00000000000003334431),('2024-06-29 07:55:00.000000',00000000000003373077),('2024-06-29 08:00:00.000000',00000000000003392016),('2024-06-29 08:05:00.000000',00000000000003421286),('2024-06-29 08:10:00.000000',00000000000003439904),('2024-06-29 08:15:00.000000',00000000000003471674),('2024-06-29 08:20:00.000000',00000000000003491644),('2024-06-29 08:25:00.000000',00000000000003517123),('2024-06-29 08:30:00.000000',00000000000003531913),('2024-06-29 08:35:00.000000',00000000000003544770),('2024-06-29 08:40:00.000000',00000000000003565560),('2024-06-29 08:45:00.000000',00000000000004001240),('2024-06-29 08:50:00.000000',00000000000004015519),('2024-06-29 08:55:00.000000',00000000000004032216),('2024-06-29 09:00:00.000000',00000000000004049006),('2024-06-29 09:05:00.000000',00000000000004051006),('2024-06-29 09:10:00.000000',00000000000004059816),('2024-06-29 09:15:00.000000',00000000000004059816),('2024-06-29 09:20:00.000000',00000000000004108606),('2024-06-29 09:25:00.000000',00000000000004115565),('2024-06-29 09:30:00.000000',00000000000004139620),('2024-06-29 09:35:00.000000',00000000000004187199),('2024-06-29 09:40:00.000000',00000000000004243988),('2024-06-29 09:45:00.000000',00000000000004247978),('2024-06-29 09:50:00.000000',00000000000004269678),('2024-06-29 09:55:00.000000',00000000000004298167),('2024-06-29 10:00:00.000000',00000000000004303057),('2024-06-29 10:05:00.000000',00000000000004313057),('2024-06-29 10:10:00.000000',00000000000004314057),('2024-06-29 10:15:00.000000',00000000000004326757),('2024-06-29 10:20:00.000000',00000000000004326757),('2024-06-29 10:25:00.000000',00000000000004338557),('2024-06-29 10:30:00.000000',00000000000004361257),('2024-06-29 10:35:00.000000',00000000000004384044),('2024-06-29 10:40:00.000000',00000000000004384044),('2024-06-29 10:45:00.000000',00000000000004393844),('2024-06-29 10:50:00.000000',00000000000004407723),('2024-06-29 10:55:00.000000',00000000000004409523),('2024-06-29 11:00:00.000000',00000000000004440012),('2024-06-29 11:05:00.000000',00000000000004453812),('2024-06-29 11:10:00.000000',00000000000004466601),('2024-06-29 11:15:00.000000',00000000000004468601),('2024-06-29 11:20:00.000000',00000000000004485381),('2024-06-29 11:25:00.000000',00000000000004487481),('2024-06-29 11:30:00.000000',00000000000004491771),('2024-06-29 11:35:00.000000',00000000000004491771),('2024-06-29 11:40:00.000000',00000000000004500571),('2024-06-29 11:45:00.000000',00000000000004508540),('2024-06-29 11:50:00.000000',00000000000004516418),('2024-06-29 11:55:00.000000',00000000000004539998),('2024-06-29 12:00:00.000000',00000000000004550198),('2024-06-29 12:05:00.000000',00000000000004581088),('2024-06-29 12:10:00.000000',00000000000004589078),('2024-06-29 12:15:00.000000',00000000000004604964),('2024-06-29 12:20:00.000000',00000000000004659534),('2024-06-29 12:25:00.000000',00000000000004672312),('2024-06-29 12:30:00.000000',00000000000004678301),('2024-06-29 12:35:00.000000',00000000000004697779),('2024-06-29 12:40:00.000000',00000000000004708649),('2024-06-29 12:45:00.000000',00000000000004712449),('2024-06-29 12:50:00.000000',00000000000004727039),('2024-06-29 12:55:00.000000',00000000000004767427),('2024-06-29 13:00:00.000000',00000000000004830906),('2024-06-29 13:05:00.000000',00000000000004845514),('2024-06-29 13:10:00.000000',00000000000004858803),('2024-06-29 13:15:00.000000',00000000000004865872),('2024-06-29 13:20:00.000000',00000000000004883572),('2024-06-29 13:25:00.000000',00000000000005194162),('2024-06-29 13:30:00.000000',00000000000005248651),('2024-06-29 13:35:00.000000',00000000000005279498),('2024-06-29 13:40:00.000000',00000000000005296676),('2024-06-29 13:45:00.000000',00000000000005328335),('2024-06-29 13:50:00.000000',00000000000005331424),('2024-06-29 13:55:00.000000',00000000000005330424),('2024-06-29 14:00:00.000000',00000000000005367793),('2024-06-29 14:05:00.000000',00000000000005393950),('2024-06-29 14:10:00.000000',00000000000005397610),('2024-06-29 14:15:00.000000',00000000000005425200),('2024-06-29 14:20:00.000000',00000000000005435090),('2024-06-29 14:25:00.000000',00000000000005447667),('2024-06-29 14:30:00.000000',00000000000005478336),('2024-06-29 14:35:00.000000',00000000000005492125),('2024-06-29 14:40:00.000000',00000000000005524825),('2024-06-29 14:45:00.000000',00000000000005544684),('2024-06-29 14:50:00.000000',00000000000005548955),('2024-06-29 14:55:00.000000',00000000000005556845),('2024-06-29 15:00:00.000000',00000000000005581515),('2024-06-29 15:05:00.000000',00000000000005595295),('2024-06-29 15:10:00.000000',00000000000005636583),('2024-06-29 15:15:00.000000',00000000000005659141),('2024-06-29 15:20:00.000000',00000000000005687309),('2024-06-29 15:25:00.000000',00000000000005704859),('2024-06-29 15:30:00.000000',00000000000005725537),('2024-06-29 15:35:00.000000',00000000000005747326),('2024-06-29 15:40:00.000000',00000000000005776911),('2024-06-29 15:45:00.000000',00000000000005804960),('2024-06-29 15:50:00.000000',00000000000005823718),('2024-06-29 15:55:00.000000',00000000000005837297),('2024-06-29 16:00:00.000000',00000000000000000000),('2024-06-29 16:05:00.000000',00000000000000026587),('2024-06-29 16:10:00.000000',00000000000000058540),('2024-06-29 16:15:00.000000',00000000000000070340),('2024-06-29 16:20:00.000000',00000000000000123128),('2024-06-29 16:25:00.000000',00000000000000156503),('2024-06-29 16:30:00.000000',00000000000000179781),('2024-06-29 16:35:00.000000',00000000000000293017),('2024-06-29 16:40:00.000000',00000000000000308417),('2024-06-29 16:45:00.000000',00000000000000343094),('2024-06-29 16:50:00.000000',00000000000000366772),('2024-06-29 16:55:00.000000',00000000000000383851),('2024-06-29 17:00:00.000000',00000000000000397830),('2024-06-29 17:05:00.000000',00000000000000413810),('2024-06-29 17:10:00.000000',00000000000000453209),('2024-06-29 17:15:00.000000',00000000000000467499),('2024-06-29 17:20:00.000000',00000000000000487439),('2024-06-29 17:25:00.000000',00000000000000508439),('2024-06-29 17:30:00.000000',00000000000000527517),('2024-06-29 17:35:00.000000',00000000000000536417),('2024-06-29 17:40:00.000000',00000000000000549316),('2024-06-29 17:45:00.000000',00000000000000563206),('2024-06-29 17:50:00.000000',00000000000000589456),('2024-06-29 17:55:00.000000',00000000000000609134),('2024-06-29 18:00:00.000000',00000000000000763111),('2024-06-29 18:05:00.000000',00000000000000768001),('2024-06-29 18:10:00.000000',00000000000000781701),('2024-06-29 18:15:00.000000',00000000000000789590),('2024-06-29 18:20:00.000000',00000000000000798890),('2024-06-29 18:25:00.000000',00000000000000815180),('2024-06-29 18:30:00.000000',00000000000000820169),('2024-06-29 18:35:00.000000',00000000000000842948),('2024-06-29 18:40:00.000000',00000000000000848848),('2024-06-29 18:45:00.000000',00000000000000856448),('2024-06-29 18:50:00.000000',00000000000000857448),('2024-06-29 18:55:00.000000',00000000000000862346),('2024-06-29 19:00:00.000000',00000000000000865246),('2024-06-29 19:05:00.000000',00000000000000868235),('2024-06-29 19:10:00.000000',00000000000000868235),('2024-06-29 19:15:00.000000',00000000000000869735),('2024-06-29 19:20:00.000000',00000000000000875024),('2024-06-29 19:25:00.000000',00000000000000875624),('2024-06-29 19:30:00.000000',00000000000000888524),('2024-06-29 19:35:00.000000',00000000000000892813),('2024-06-29 19:40:00.000000',00000000000000900713),('2024-06-29 19:45:00.000000',00000000000000925103),('2024-06-29 19:50:00.000000',00000000000000957603),('2024-06-29 19:55:00.000000',00000000000000962593),('2024-06-29 20:00:00.000000',00000000000000970471),('2024-06-29 20:05:00.000000',00000000000000980261),('2024-06-29 20:10:00.000000',00000000000000984741),('2024-06-29 20:15:00.000000',00000000000000994640),('2024-06-29 20:20:00.000000',00000000000000998540),('2024-06-29 20:25:00.000000',00000000000000998540),('2024-06-29 20:30:00.000000',00000000000001002130),('2024-06-29 20:35:00.000000',00000000000001005120),('2024-06-29 20:40:00.000000',00000000000001005120),('2024-06-29 20:45:00.000000',00000000000001013020),('2024-06-29 20:50:00.000000',00000000000001026910),('2024-06-29 20:55:00.000000',00000000000001037780),('2024-06-29 21:00:00.000000',00000000000001037780),('2024-06-29 21:05:00.000000',00000000000001037780),('2024-06-29 21:10:00.000000',00000000000001037780),('2024-06-29 21:15:00.000000',00000000000001037780),('2024-06-29 21:20:00.000000',00000000000001048569),('2024-06-29 21:25:00.000000',00000000000001052469),('2024-06-29 21:30:00.000000',00000000000001052469),('2024-06-29 21:35:00.000000',00000000000001241269),('2024-06-29 21:40:00.000000',00000000000001245258),('2024-06-29 21:45:00.000000',00000000000001245258),('2024-06-29 21:50:00.000000',00000000000001245258),('2024-06-29 21:55:00.000000',00000000000001245258),('2024-06-29 22:00:00.000000',00000000000001247247),('2024-06-29 22:05:00.000000',00000000000001247247),('2024-06-29 22:10:00.000000',00000000000001268937),('2024-06-29 22:15:00.000000',00000000000001268937),('2024-06-29 22:20:00.000000',00000000000001270937),('2024-06-29 22:25:00.000000',00000000000001270937),('2024-06-29 22:30:00.000000',00000000000001287737),('2024-06-29 22:35:00.000000',00000000000001291727),('2024-06-29 22:40:00.000000',00000000000001292727),('2024-06-29 22:45:00.000000',00000000000001294027),('2024-06-29 22:50:00.000000',00000000000001298014),('2024-06-29 22:55:00.000000',00000000000001299014),('2024-06-29 23:00:00.000000',00000000000001300314),('2024-06-29 23:05:00.000000',00000000000001302314),('2024-06-29 23:10:00.000000',00000000000001303314),('2024-06-29 23:15:00.000000',00000000000001312294),('2024-06-29 23:20:00.000000',00000000000001314283),('2024-06-29 23:25:00.000000',00000000000001315283),('2024-06-29 23:30:00.000000',00000000000001319273),('2024-06-29 23:35:00.000000',00000000000001321273),('2024-06-29 23:40:00.000000',00000000000001321273),('2024-06-29 23:45:00.000000',00000000000001323273),('2024-06-29 23:50:00.000000',00000000000001337662),('2024-06-29 23:55:00.000000',00000000000001344560),('2024-06-30 00:00:00.000000',00000000000001346560),('2024-06-30 00:05:00.000000',00000000000001350460),('2024-06-30 00:10:00.000000',00000000000001365350),('2024-06-30 00:15:00.000000',00000000000001376340),('2024-06-30 00:20:00.000000',00000000000001380240),('2024-06-30 00:25:00.000000',00000000000001393040),('2024-06-30 00:30:00.000000',00000000000001401629),('2024-06-30 00:35:00.000000',00000000000001414409),('2024-06-30 00:40:00.000000',00000000000001428909),('2024-06-30 00:45:00.000000',00000000000001451607),('2024-06-30 00:50:00.000000',00000000000001458496),('2024-06-30 00:55:00.000000',00000000000001469274),('2024-06-30 01:00:00.000000',00000000000001485074),('2024-06-30 01:05:00.000000',00000000000001499932),('2024-06-30 01:10:00.000000',00000000000001503830),('2024-06-30 01:15:00.000000',00000000000001519598),('2024-06-30 01:20:00.000000',00000000000001525467),('2024-06-30 01:25:00.000000',00000000000001525467),('2024-06-30 01:30:00.000000',00000000000001532455),('2024-06-30 01:35:00.000000',00000000000001545332),('2024-06-30 01:40:00.000000',00000000000001560981),('2024-06-30 01:45:00.000000',00000000000001566471),('2024-06-30 01:50:00.000000',00000000000001572971),('2024-06-30 01:55:00.000000',00000000000001583959),('2024-06-30 02:00:00.000000',00000000000001597748),('2024-06-30 02:05:00.000000',00000000000001616538),('2024-06-30 02:10:00.000000',00000000000001628334),('2024-06-30 02:15:00.000000',00000000000001638224),('2024-06-30 02:20:00.000000',00000000000001658351),('2024-06-30 02:25:00.000000',00000000000001671229),('2024-06-30 02:30:00.000000',00000000000001681029),('2024-06-30 02:35:00.000000',00000000000001694529),('2024-06-30 02:40:00.000000',00000000000001751229),('2024-06-30 02:45:00.000000',00000000000001760029),('2024-06-30 02:50:00.000000',00000000000001762627),('2024-06-30 02:55:00.000000',00000000000001779116),('2024-06-30 03:00:00.000000',00000000000001803886),('2024-06-30 03:05:00.000000',00000000000001814676),('2024-06-30 03:10:00.000000',00000000000001834564),('2024-06-30 03:15:00.000000',00000000000001844164),('2024-06-30 03:20:00.000000',00000000000001862554),('2024-06-30 03:25:00.000000',00000000000001880199),('2024-06-30 03:30:00.000000',00000000000001927255),('2024-06-30 03:35:00.000000',00000000000001969955),('2024-06-30 03:40:00.000000',00000000000001991535),('2024-06-30 03:45:00.000000',00000000000001996035),('2024-06-30 03:50:00.000000',00000000000002011535),('2024-06-30 03:55:00.000000',00000000000002025505),('2024-06-30 04:00:00.000000',00000000000002026805),('2024-06-30 04:05:00.000000',00000000000002030894),('2024-06-30 04:10:00.000000',00000000000002033483),('2024-06-30 04:15:00.000000',00000000000002050273),('2024-06-30 04:20:00.000000',00000000000002052262),('2024-06-30 04:25:00.000000',00000000000002070137),('2024-06-30 04:30:00.000000',00000000000002070137),('2024-06-30 04:35:00.000000',00000000000002084937),('2024-06-30 04:40:00.000000',00000000000002099303),('2024-06-30 04:45:00.000000',00000000000002124692),('2024-06-30 04:50:00.000000',00000000000002152570),('2024-06-30 04:55:00.000000',00000000000002163368),('2024-06-30 05:00:00.000000',00000000000002177964),('2024-06-30 05:05:00.000000',00000000000002184932),('2024-06-30 05:10:00.000000',00000000000002231301),('2024-06-30 05:15:00.000000',00000000000002258109),('2024-06-30 05:20:00.000000',00000000000002266899),('2024-06-30 05:25:00.000000',00000000000002245889),('2024-06-30 05:30:00.000000',00000000000002249789),('2024-06-30 05:35:00.000000',00000000000002255778),('2024-06-30 05:40:00.000000',00000000000002276543),('2024-06-30 05:45:00.000000',00000000000002299232),('2024-06-30 05:50:00.000000',00000000000002301232),('2024-06-30 05:55:00.000000',00000000000002302232),('2024-06-30 06:00:00.000000',00000000000002332999),('2024-06-30 06:05:00.000000',00000000000002338978),('2024-06-30 06:10:00.000000',00000000000002352765),('2024-06-30 06:15:00.000000',00000000000002358665),('2024-06-30 06:20:00.000000',00000000000002375144),('2024-06-30 06:25:00.000000',00000000000002488023),('2024-06-30 06:30:00.000000',00000000000002506423),('2024-06-30 06:35:00.000000',00000000000002510423),('2024-06-30 06:40:00.000000',00000000000002514402),('2024-06-30 06:45:00.000000',00000000000002517392),('2024-06-30 06:50:00.000000',00000000000002517392),('2024-06-30 06:55:00.000000',00000000000002533171),('2024-06-30 07:00:00.000000',00000000000002548871),('2024-06-30 07:05:00.000000',00000000000002576761),('2024-06-30 07:10:00.000000',00000000000002587661),('2024-06-30 07:15:00.000000',00000000000002592640),('2024-06-30 07:20:00.000000',00000000000002599540),('2024-06-30 07:25:00.000000',00000000000002606536),('2024-06-30 07:30:00.000000',00000000000002623336),('2024-06-30 07:35:00.000000',00000000000002623336),('2024-06-30 07:40:00.000000',00000000000002626336),('2024-06-30 07:45:00.000000',00000000000002671236),('2024-06-30 07:50:00.000000',00000000000002683315),('2024-06-30 07:55:00.000000',00000000000002700015),('2024-06-30 08:00:00.000000',00000000000002705895),('2024-06-30 08:05:00.000000',00000000000002704494),('2024-06-30 08:10:00.000000',00000000000002756273),('2024-06-30 08:15:00.000000',00000000000002762161),('2024-06-30 08:20:00.000000',00000000000002783950),('2024-06-30 08:25:00.000000',00000000000003098506),('2024-06-30 08:30:00.000000',00000000000003116373),('2024-06-30 08:35:00.000000',00000000000003127352),('2024-06-30 08:40:00.000000',00000000000003152089),('2024-06-30 08:45:00.000000',00000000000003173489),('2024-06-30 08:50:00.000000',00000000000003182689),('2024-06-30 08:55:00.000000',00000000000003213257),('2024-06-30 09:00:00.000000',00000000000003240996),('2024-06-30 09:05:00.000000',00000000000003266796),('2024-06-30 09:10:00.000000',00000000000003297654),('2024-06-30 09:15:00.000000',00000000000003307044),('2024-06-30 09:20:00.000000',00000000000003340324),('2024-06-30 09:25:00.000000',00000000000003370683),('2024-06-30 09:30:00.000000',00000000000003387559),('2024-06-30 09:35:00.000000',00000000000003412457),('2024-06-30 09:40:00.000000',00000000000003435253),('2024-06-30 09:45:00.000000',00000000000003464931),('2024-06-30 09:50:00.000000',00000000000003529687),('2024-06-30 09:55:00.000000',00000000000003538566),('2024-06-30 10:00:00.000000',00000000000003561157),('2024-06-30 10:05:00.000000',00000000000003589106),('2024-06-30 10:10:00.000000',00000000000003632474),('2024-06-30 10:15:00.000000',00000000000003654454),('2024-06-30 10:20:00.000000',00000000000003682139),('2024-06-30 10:25:00.000000',00000000000003704489),('2024-06-30 10:30:00.000000',00000000000003742725),('2024-06-30 10:35:00.000000',00000000000003771325),('2024-06-30 10:40:00.000000',00000000000003790015),('2024-06-30 10:45:00.000000',00000000000003805605),('2024-06-30 10:50:00.000000',00000000000003809405),('2024-06-30 10:55:00.000000',00000000000003829173),('2024-06-30 11:00:00.000000',00000000000003835173),('2024-06-30 11:05:00.000000',00000000000003846071),('2024-06-30 11:10:00.000000',00000000000003851061),('2024-06-30 11:15:00.000000',00000000000003872261),('2024-06-30 11:20:00.000000',00000000000003886161),('2024-06-30 11:25:00.000000',00000000000003896061),('2024-06-30 11:30:00.000000',00000000000003913939),('2024-06-30 11:35:00.000000',00000000000003933817),('2024-06-30 11:40:00.000000',00000000000003958207),('2024-06-30 11:45:00.000000',00000000000003963194),('2024-06-30 11:50:00.000000',00000000000003964181),('2024-06-30 11:55:00.000000',00000000000003983671),('2024-06-30 12:00:00.000000',00000000000004001237),('2024-06-30 12:05:00.000000',00000000000004015134),('2024-06-30 12:10:00.000000',00000000000004159734),('2024-06-30 12:15:00.000000',00000000000004182334),('2024-06-30 12:20:00.000000',00000000000004185334),('2024-06-30 12:25:00.000000',00000000000004189332),('2024-06-30 12:30:00.000000',00000000000004198021),('2024-06-30 12:35:00.000000',00000000000004200021),('2024-06-30 12:40:00.000000',00000000000004200021),('2024-06-30 12:45:00.000000',00000000000004229300),('2024-06-30 12:50:00.000000',00000000000004277100),('2024-06-30 12:55:00.000000',00000000000004297878),('2024-06-30 13:00:00.000000',00000000000004309768),('2024-06-30 13:05:00.000000',00000000000004307778),('2024-06-30 13:10:00.000000',00000000000004314968),('2024-06-30 13:15:00.000000',00000000000004320966),('2024-06-30 13:20:00.000000',00000000000004320987),('2024-06-30 13:25:00.000000',00000000000004347687),('2024-06-30 13:30:00.000000',00000000000004430331),('2024-06-30 13:35:00.000000',00000000000004433331),('2024-06-30 13:40:00.000000',00000000000004575644),('2024-06-30 13:45:00.000000',00000000000004581631),('2024-06-30 13:50:00.000000',00000000000004586630),('2024-06-30 13:55:00.000000',00000000000004604420),('2024-06-30 14:00:00.000000',00000000000004608410),('2024-06-30 14:05:00.000000',00000000000004611279),('2024-06-30 14:10:00.000000',00000000000004624668),('2024-06-30 14:15:00.000000',00000000000004630657),('2024-06-30 14:20:00.000000',00000000000004648546),('2024-06-30 14:25:00.000000',00000000000004667431),('2024-06-30 14:30:00.000000',00000000000004676521),('2024-06-30 14:35:00.000000',00000000000004683411),('2024-06-30 14:40:00.000000',00000000000004701280),('2024-06-30 14:45:00.000000',00000000000004712270),('2024-06-30 14:50:00.000000',00000000000004722236),('2024-06-30 14:55:00.000000',00000000000004766036),('2024-06-30 15:00:00.000000',00000000000004795715),('2024-06-30 15:05:00.000000',00000000000004804515),('2024-06-30 15:10:00.000000',00000000000004809493),('2024-06-30 15:15:00.000000',00000000000004836862),('2024-06-30 15:20:00.000000',00000000000004882622),('2024-06-30 15:25:00.000000',00000000000004928259),('2024-06-30 15:30:00.000000',00000000000004945548),('2024-06-30 15:35:00.000000',00000000000004976094),('2024-06-30 15:40:00.000000',00000000000005007781),('2024-06-30 15:45:00.000000',00000000000005020960),('2024-06-30 15:50:00.000000',00000000000005049649),('2024-06-30 15:55:00.000000',00000000000005074629),('2024-06-30 16:00:00.000000',00000000000000000000),('2024-06-30 16:05:00.000000',00000000000000026798),('2024-06-30 16:10:00.000000',00000000000000068277),('2024-06-30 16:15:00.000000',00000000000000091766),('2024-06-30 16:20:00.000000',00000000000000121734),('2024-06-30 16:25:00.000000',00000000000000148823),('2024-06-30 16:30:00.000000',00000000000000164521),('2024-06-30 16:35:00.000000',00000000000000187309),('2024-06-30 16:40:00.000000',00000000000000203787),('2024-06-30 16:45:00.000000',00000000000000273187),('2024-06-30 16:50:00.000000',00000000000000291686),('2024-06-30 16:55:00.000000',00000000000000304463),('2024-06-30 17:00:00.000000',00000000000000328120),('2024-06-30 17:05:00.000000',00000000000000347810),('2024-06-30 17:10:00.000000',00000000000000363000),('2024-06-30 17:15:00.000000',00000000000000370654),('2024-06-30 17:20:00.000000',00000000000000377498),('2024-06-30 17:25:00.000000',00000000000000396287),('2024-06-30 17:30:00.000000',00000000000000469155),('2024-06-30 17:35:00.000000',00000000000000481345),('2024-06-30 17:40:00.000000',00000000000000504033),('2024-06-30 17:45:00.000000',00000000000000534111),('2024-06-30 17:50:00.000000',00000000000000530311),('2024-06-30 17:55:00.000000',00000000000000573801),('2024-06-30 18:00:00.000000',00000000000000593488),('2024-06-30 18:05:00.000000',00000000000000613266),('2024-06-30 18:10:00.000000',00000000000000628225),('2024-06-30 18:15:00.000000',00000000000000643025),('2024-06-30 18:20:00.000000',00000000000000649303),('2024-06-30 18:25:00.000000',00000000000000663192),('2024-06-30 18:30:00.000000',00000000000000684472),('2024-06-30 18:35:00.000000',00000000000000701752),('2024-06-30 18:40:00.000000',00000000000000709650),('2024-06-30 18:45:00.000000',00000000000000715750),('2024-06-30 18:50:00.000000',00000000000000722748),('2024-06-30 18:55:00.000000',00000000000000737148),('2024-06-30 19:00:00.000000',00000000000000772817),('2024-06-30 19:05:00.000000',00000000000000818517),('2024-06-30 19:10:00.000000',00000000000000833306),('2024-06-30 19:15:00.000000',00000000000000834306),('2024-06-30 19:20:00.000000',00000000000000834306),('2024-06-30 19:25:00.000000',00000000000000842196),('2024-06-30 19:30:00.000000',00000000000000864885),('2024-06-30 19:35:00.000000',00000000000000866885),('2024-06-30 19:40:00.000000',00000000000000866885),('2024-06-30 19:45:00.000000',00000000000000888574),('2024-06-30 19:50:00.000000',00000000000000909674),('2024-06-30 19:55:00.000000',00000000000000916653),('2024-06-30 20:00:00.000000',00000000000000916653),('2024-06-30 20:05:00.000000',00000000000000924542),('2024-06-30 20:10:00.000000',00000000000000924542),('2024-06-30 20:15:00.000000',00000000000000939342),('2024-06-30 20:20:00.000000',00000000000000941331),('2024-06-30 20:25:00.000000',00000000000000950331),('2024-06-30 20:30:00.000000',00000000000000955531),('2024-06-30 20:35:00.000000',00000000000000959531),('2024-06-30 20:40:00.000000',00000000000000959531),('2024-06-30 20:45:00.000000',00000000000000963531),('2024-06-30 20:50:00.000000',00000000000000971331),('2024-06-30 20:55:00.000000',00000000000000975231),('2024-06-30 21:00:00.000000',00000000000000979221),('2024-06-30 21:05:00.000000',00000000000000979420),('2024-06-30 21:10:00.000000',00000000000000982320),('2024-06-30 21:15:00.000000',00000000000000989098),('2024-06-30 21:20:00.000000',00000000000001002077),('2024-06-30 21:25:00.000000',00000000000001003077),('2024-06-30 21:30:00.000000',00000000000001003077),('2024-06-30 21:35:00.000000',00000000000001004077),('2024-06-30 21:40:00.000000',00000000000001004677),('2024-06-30 21:45:00.000000',00000000000001014577),('2024-06-30 21:50:00.000000',00000000000001023465),('2024-06-30 21:55:00.000000',00000000000001025465),('2024-06-30 22:00:00.000000',00000000000001026665),('2024-06-30 22:05:00.000000',00000000000001036665),('2024-06-30 22:10:00.000000',00000000000001046555),('2024-06-30 22:15:00.000000',00000000000001046855),('2024-06-30 22:20:00.000000',00000000000001049854),('2024-06-30 22:25:00.000000',00000000000001052844),('2024-06-30 22:30:00.000000',00000000000001052844),('2024-06-30 22:35:00.000000',00000000000001064734),('2024-06-30 22:40:00.000000',00000000000001071724),('2024-06-30 22:45:00.000000',00000000000001079624),('2024-06-30 22:50:00.000000',00000000000001088523),('2024-06-30 22:55:00.000000',00000000000001091523),('2024-06-30 23:00:00.000000',00000000000001095513),('2024-06-30 23:05:00.000000',00000000000001101402),('2024-06-30 23:10:00.000000',00000000000001143302),('2024-06-30 23:15:00.000000',00000000000001144302),('2024-06-30 23:20:00.000000',00000000000001145302),('2024-06-30 23:25:00.000000',00000000000001154202),('2024-06-30 23:30:00.000000',00000000000001309402),('2024-06-30 23:35:00.000000',00000000000001321402),('2024-06-30 23:40:00.000000',00000000000001321402),('2024-06-30 23:45:00.000000',00000000000001337181),('2024-06-30 23:50:00.000000',00000000000001340169),('2024-06-30 23:55:00.000000',00000000000001344158),('2024-07-01 00:00:00.000000',00000000000001350958),('2024-07-01 00:05:00.000000',00000000000001355947),('2024-07-01 00:10:00.000000',00000000000001362547),('2024-07-01 00:15:00.000000',00000000000001362547),('2024-07-01 00:20:00.000000',00000000000001377062),('2024-07-01 00:25:00.000000',00000000000001381528),('2024-07-01 00:30:00.000000',00000000000001384518),('2024-07-01 00:35:00.000000',00000000000001392328),('2024-07-01 00:40:00.000000',00000000000001397228),('2024-07-01 00:45:00.000000',00000000000001399228),('2024-07-01 00:50:00.000000',00000000000001408017),('2024-07-01 00:55:00.000000',00000000000001408028),('2024-07-01 01:00:00.000000',00000000000001429918),('2024-07-01 01:05:00.000000',00000000000001438707),('2024-07-01 01:10:00.000000',00000000000001428807),('2024-07-01 01:15:00.000000',00000000000001448396),('2024-07-01 01:20:00.000000',00000000000001455297),('2024-07-01 01:25:00.000000',00000000000001470175),('2024-07-01 01:30:00.000000',00000000000001613475),('2024-07-01 01:35:00.000000',00000000000001620365),('2024-07-01 01:40:00.000000',00000000000001631343),('2024-07-01 01:45:00.000000',00000000000001661190),('2024-07-01 01:50:00.000000',00000000000001668158),('2024-07-01 01:55:00.000000',00000000000001672147),('2024-07-01 02:00:00.000000',00000000000001676047),('2024-07-01 02:05:00.000000',00000000000001694915),('2024-07-01 02:10:00.000000',00000000000001700893),('2024-07-01 02:15:00.000000',00000000000001703904),('2024-07-01 02:20:00.000000',00000000000001704903),('2024-07-01 02:25:00.000000',00000000000001697002),('2024-07-01 02:30:00.000000',00000000000001707902),('2024-07-01 02:35:00.000000',00000000000001723790),('2024-07-01 02:40:00.000000',00000000000001736680),('2024-07-01 02:45:00.000000',00000000000001741580),('2024-07-01 02:50:00.000000',00000000000001748359),('2024-07-01 02:55:00.000000',00000000000001750348),('2024-07-01 03:00:00.000000',00000000000001759348),('2024-07-01 03:05:00.000000',00000000000001762248),('2024-07-01 03:10:00.000000',00000000000001766148),('2024-07-01 03:15:00.000000',00000000000001782016),('2024-07-01 03:20:00.000000',00000000000001785916),('2024-07-01 03:25:00.000000',00000000000001808506),('2024-07-01 03:30:00.000000',00000000000001803594),('2024-07-01 03:35:00.000000',00000000000001843291),('2024-07-01 03:40:00.000000',00000000000001894081),('2024-07-01 03:45:00.000000',00000000000001897081),('2024-07-01 03:50:00.000000',00000000000001898249),('2024-07-01 03:55:00.000000',00000000000001917095),('2024-07-01 04:00:00.000000',00000000000001924085),('2024-07-01 04:05:00.000000',00000000000001943924),('2024-07-01 04:10:00.000000',00000000000001993804),('2024-07-01 04:15:00.000000',00000000000001993804),('2024-07-01 04:20:00.000000',00000000000001989904),('2024-07-01 04:25:00.000000',00000000000002020184),('2024-07-01 04:30:00.000000',00000000000002041453),('2024-07-01 04:35:00.000000',00000000000002054042),('2024-07-01 04:40:00.000000',00000000000002072682),('2024-07-01 04:45:00.000000',00000000000002090458),('2024-07-01 04:50:00.000000',00000000000002107338),('2024-07-01 04:55:00.000000',00000000000002147075),('2024-07-01 05:00:00.000000',00000000000002160062),('2024-07-01 05:05:00.000000',00000000000002174852),('2024-07-01 05:10:00.000000',00000000000002186809),('2024-07-01 05:15:00.000000',00000000000002207488),('2024-07-01 05:20:00.000000',00000000000002227968),('2024-07-01 05:25:00.000000',00000000000002244848),('2024-07-01 05:30:00.000000',00000000000002258648),('2024-07-01 05:35:00.000000',00000000000002276426),('2024-07-01 05:40:00.000000',00000000000002294726),('2024-07-01 05:45:00.000000',00000000000002307626),('2024-07-01 05:50:00.000000',00000000000002341526),('2024-07-01 05:55:00.000000',00000000000002402316),('2024-07-01 06:00:00.000000',00000000000002422175),('2024-07-01 06:05:00.000000',00000000000002536965),('2024-07-01 06:10:00.000000',00000000000002538963),('2024-07-01 06:15:00.000000',00000000000002563720),('2024-07-01 06:20:00.000000',00000000000002573520),('2024-07-01 06:25:00.000000',00000000000002666320),('2024-07-01 06:30:00.000000',00000000000002676199),('2024-07-01 06:35:00.000000',00000000000002680986),('2024-07-01 06:40:00.000000',00000000000002685185),('2024-07-01 06:45:00.000000',00000000000002693761),('2024-07-01 06:50:00.000000',00000000000002717859),('2024-07-01 06:55:00.000000',00000000000002744125),('2024-07-01 07:00:00.000000',00000000000002762804),('2024-07-01 07:05:00.000000',00000000000002787584),('2024-07-01 07:10:00.000000',00000000000002794773),('2024-07-01 07:15:00.000000',00000000000002820473),('2024-07-01 07:20:00.000000',00000000000002838753),('2024-07-01 07:25:00.000000',00000000000002844741),('2024-07-01 07:30:00.000000',00000000000002851630),('2024-07-01 07:35:00.000000',00000000000002870319),('2024-07-01 07:40:00.000000',00000000000002880219),('2024-07-01 07:45:00.000000',00000000000002962799),('2024-07-01 07:50:00.000000',00000000000002963799),('2024-07-01 07:55:00.000000',00000000000002989188),('2024-07-01 08:00:00.000000',00000000000003002878),('2024-07-01 08:05:00.000000',00000000000003044467),('2024-07-01 08:10:00.000000',00000000000003081116),('2024-07-01 08:15:00.000000',00000000000003100797),('2024-07-01 08:20:00.000000',00000000000003144585),('2024-07-01 08:25:00.000000',00000000000003160375),('2024-07-01 08:30:00.000000',00000000000003182253),('2024-07-01 08:35:00.000000',00000000000003183243),('2024-07-01 08:40:00.000000',00000000000003195043),('2024-07-01 08:45:00.000000',00000000000003210523),('2024-07-01 08:50:00.000000',00000000000003219312),('2024-07-01 08:55:00.000000',00000000000003241012),('2024-07-01 09:00:00.000000',00000000000003245012),('2024-07-01 09:05:00.000000',00000000000003264010),('2024-07-01 09:10:00.000000',00000000000003269910),('2024-07-01 09:15:00.000000',00000000000003282710),('2024-07-01 09:20:00.000000',00000000000003300389),('2024-07-01 09:25:00.000000',00000000000003359358),('2024-07-01 09:30:00.000000',00000000000003369148),('2024-07-01 09:35:00.000000',00000000000003372748),('2024-07-01 09:40:00.000000',00000000000003402448),('2024-07-01 09:45:00.000000',00000000000003415628),('2024-07-01 09:50:00.000000',00000000000003418248),('2024-07-01 09:55:00.000000',00000000000003431448),('2024-07-01 10:00:00.000000',00000000000003451046),('2024-07-01 10:05:00.000000',00000000000003452946),('2024-07-01 10:10:00.000000',00000000000003459836),('2024-07-01 10:15:00.000000',00000000000003466436),('2024-07-01 10:20:00.000000',00000000000003473424),('2024-07-01 10:25:00.000000',00000000000003483224),('2024-07-01 10:30:00.000000',00000000000003487124),('2024-07-01 10:35:00.000000',00000000000003495024),('2024-07-01 10:40:00.000000',00000000000003498924),('2024-07-01 10:45:00.000000',00000000000003513713),('2024-07-01 10:50:00.000000',00000000000003527411),('2024-07-01 10:55:00.000000',00000000000003541311),('2024-07-01 11:00:00.000000',00000000000003547309),('2024-07-01 11:05:00.000000',00000000000003560198),('2024-07-01 11:10:00.000000',00000000000003674988),('2024-07-01 11:15:00.000000',00000000000003726778),('2024-07-01 11:20:00.000000',00000000000003729778),('2024-07-01 11:25:00.000000',00000000000003738678),('2024-07-01 11:30:00.000000',00000000000003741654),('2024-07-01 11:35:00.000000',00000000000003756344),('2024-07-01 11:40:00.000000',00000000000003768034),('2024-07-01 11:45:00.000000',00000000000003780413),('2024-07-01 11:50:00.000000',00000000000003791013),('2024-07-01 11:55:00.000000',00000000000003795902),('2024-07-01 12:00:00.000000',00000000000003811358),('2024-07-01 12:05:00.000000',00000000000003827058),('2024-07-01 12:10:00.000000',00000000000003828058),('2024-07-01 12:15:00.000000',00000000000003837858),('2024-07-01 12:20:00.000000',00000000000003850745),('2024-07-01 12:25:00.000000',00000000000004004834),('2024-07-01 12:30:00.000000',00000000000004008832),('2024-07-01 12:35:00.000000',00000000000004014721),('2024-07-01 12:40:00.000000',00000000000004022621),('2024-07-01 12:45:00.000000',00000000000004057821),('2024-07-01 12:50:00.000000',00000000000004063721),('2024-07-01 12:55:00.000000',00000000000004078721),('2024-07-01 13:00:00.000000',00000000000004079921),('2024-07-01 13:05:00.000000',00000000000004078120),('2024-07-01 13:10:00.000000',00000000000004081620),('2024-07-01 13:15:00.000000',00000000000004116189),('2024-07-01 13:20:00.000000',00000000000004125168),('2024-07-01 13:25:00.000000',00000000000004135154),('2024-07-01 13:30:00.000000',00000000000004136153),('2024-07-01 13:35:00.000000',00000000000004160853),('2024-07-01 13:40:00.000000',00000000000004184933),('2024-07-01 13:45:00.000000',00000000000004210923),('2024-07-01 13:50:00.000000',00000000000004227422),('2024-07-01 13:55:00.000000',00000000000004249422),('2024-07-01 14:00:00.000000',00000000000004265520),('2024-07-01 14:05:00.000000',00000000000004272120),('2024-07-01 14:10:00.000000',00000000000004300897),('2024-07-01 14:15:00.000000',00000000000004317597),('2024-07-01 14:20:00.000000',00000000000004326286),('2024-07-01 14:25:00.000000',00000000000004374875),('2024-07-01 14:30:00.000000',00000000000004382473),('2024-07-01 14:35:00.000000',00000000000004387460),('2024-07-01 14:40:00.000000',00000000000004394960),('2024-07-01 14:45:00.000000',00000000000004403960),('2024-07-01 14:50:00.000000',00000000000004413160),('2024-07-01 14:55:00.000000',00000000000004425949),('2024-07-01 15:00:00.000000',00000000000004435138),('2024-07-01 15:05:00.000000',00000000000004473914),('2024-07-01 15:10:00.000000',00000000000004475112),('2024-07-01 15:15:00.000000',00000000000004496801),('2024-07-01 15:20:00.000000',00000000000004545269),('2024-07-01 15:25:00.000000',00000000000004559669),('2024-07-01 15:30:00.000000',00000000000004573328),('2024-07-01 15:35:00.000000',00000000000004598026),('2024-07-01 15:40:00.000000',00000000000004598425),('2024-07-01 15:45:00.000000',00000000000004609123),('2024-07-01 15:50:00.000000',00000000000004674789),('2024-07-01 15:55:00.000000',00000000000004697367),('2024-07-01 16:00:00.000000',00000000000000000000),('2024-07-01 16:05:00.000000',00000000000000027600),('2024-07-01 16:10:00.000000',00000000000000047766),('2024-07-01 16:15:00.000000',00000000000000054352),('2024-07-01 16:20:00.000000',00000000000000106152),('2024-07-01 16:25:00.000000',00000000000000120640),('2024-07-01 16:30:00.000000',00000000000000126128),('2024-07-01 16:35:00.000000',00000000000000151594),('2024-07-01 16:40:00.000000',00000000000000181782),('2024-07-01 16:45:00.000000',00000000000000216457),('2024-07-01 16:50:00.000000',00000000000000266857),('2024-07-01 16:55:00.000000',00000000000000309255),('2024-07-01 17:00:00.000000',00000000000000340124),('2024-07-01 17:05:00.000000',00000000000000377014),('2024-07-01 17:10:00.000000',00000000000000415392),('2024-07-01 17:15:00.000000',00000000000000457182),('2024-07-01 17:20:00.000000',00000000000000499182),('2024-07-01 17:25:00.000000',00000000000000547960),('2024-07-01 17:30:00.000000',00000000000000592747),('2024-07-01 17:35:00.000000',00000000000000640945),('2024-07-01 17:40:00.000000',00000000000000688633),('2024-07-01 17:45:00.000000',00000000000000710522),('2024-07-01 17:50:00.000000',00000000000000726098),('2024-07-01 17:55:00.000000',00000000000000739185),('2024-07-01 18:00:00.000000',00000000000000774743),('2024-07-01 18:05:00.000000',00000000000000800532),('2024-07-01 18:10:00.000000',00000000000000824411),('2024-07-01 18:15:00.000000',00000000000000837399),('2024-07-01 18:20:00.000000',00000000000000848186),('2024-07-01 18:25:00.000000',00000000000000906675),('2024-07-01 18:30:00.000000',00000000000000911575),('2024-07-01 18:35:00.000000',00000000000000965975),('2024-07-01 18:40:00.000000',00000000000000987353),('2024-07-01 18:45:00.000000',00000000000001040043),('2024-07-01 18:50:00.000000',00000000000001051823),('2024-07-01 18:55:00.000000',00000000000001054223),('2024-07-01 19:00:00.000000',00000000000001072012),('2024-07-01 19:05:00.000000',00000000000001079910),('2024-07-01 19:10:00.000000',00000000000001077999),('2024-07-01 19:15:00.000000',00000000000001080999),('2024-07-01 19:20:00.000000',00000000000001091652),('2024-07-01 19:25:00.000000',00000000000001093652),('2024-07-01 19:30:00.000000',00000000000001096650),('2024-07-01 19:35:00.000000',00000000000001097650),('2024-07-01 19:40:00.000000',00000000000001109448),('2024-07-01 19:45:00.000000',00000000000001109448),('2024-07-01 19:50:00.000000',00000000000001116048),('2024-07-01 19:55:00.000000',00000000000001123948),('2024-07-01 20:00:00.000000',00000000000001124947),('2024-07-01 20:05:00.000000',00000000000001124947),('2024-07-01 20:10:00.000000',00000000000001124947),('2024-07-01 20:15:00.000000',00000000000001126936),('2024-07-01 20:20:00.000000',00000000000001141736),('2024-07-01 20:25:00.000000',00000000000001141736),('2024-07-01 20:30:00.000000',00000000000001144536),('2024-07-01 20:35:00.000000',00000000000001144536),('2024-07-01 20:40:00.000000',00000000000001151336),('2024-07-01 20:45:00.000000',00000000000001155236),('2024-07-01 20:50:00.000000',00000000000001155236),('2024-07-01 20:55:00.000000',00000000000001156236),('2024-07-01 21:00:00.000000',00000000000001182636),('2024-07-01 21:05:00.000000',00000000000001190126),('2024-07-01 21:10:00.000000',00000000000001190126),('2024-07-01 21:15:00.000000',00000000000001194116),('2024-07-01 21:20:00.000000',00000000000001198106),('2024-07-01 21:25:00.000000',00000000000001198106),('2024-07-01 21:30:00.000000',00000000000001205063),('2024-07-01 21:35:00.000000',00000000000001215931),('2024-07-01 21:40:00.000000',00000000000001220811),('2024-07-01 21:45:00.000000',00000000000001221811),('2024-07-01 21:50:00.000000',00000000000001224811),('2024-07-01 21:55:00.000000',00000000000001234609),('2024-07-01 22:00:00.000000',00000000000001240509),('2024-07-01 22:05:00.000000',00000000000001240509),('2024-07-01 22:10:00.000000',00000000000001254209),('2024-07-01 22:15:00.000000',00000000000001269107),('2024-07-01 22:20:00.000000',00000000000001270107),('2024-07-01 22:25:00.000000',00000000000001273107),('2024-07-01 22:30:00.000000',00000000000001281685),('2024-07-01 22:35:00.000000',00000000000001291661),('2024-07-01 22:40:00.000000',00000000000001292661),('2024-07-01 22:45:00.000000',00000000000001296661),('2024-07-01 22:50:00.000000',00000000000001300659),('2024-07-01 22:55:00.000000',00000000000001310459),('2024-07-01 23:00:00.000000',00000000000001311459),('2024-07-01 23:05:00.000000',00000000000001331738),('2024-07-01 23:10:00.000000',00000000000001337836),('2024-07-01 23:15:00.000000',00000000000001380236),('2024-07-01 23:20:00.000000',00000000000001382234),('2024-07-01 23:25:00.000000',00000000000001399623),('2024-07-01 23:30:00.000000',00000000000001399623),('2024-07-01 23:35:00.000000',00000000000001401621),('2024-07-01 23:40:00.000000',00000000000001403621),('2024-07-01 23:45:00.000000',00000000000001423407),('2024-07-01 23:50:00.000000',00000000000001430307),('2024-07-01 23:55:00.000000',00000000000001523898),('2024-07-02 00:00:00.000000',00000000000001531797),('2024-07-02 00:05:00.000000',00000000000001540697),('2024-07-02 00:10:00.000000',00000000000001545686),('2024-07-02 00:15:00.000000',00000000000001550685),('2024-07-02 00:20:00.000000',00000000000001564564),('2024-07-02 00:25:00.000000',00000000000001579451),('2024-07-02 00:30:00.000000',00000000000001586440),('2024-07-02 00:35:00.000000',00000000000001597340),('2024-07-02 00:40:00.000000',00000000000001600340),('2024-07-02 00:45:00.000000',00000000000001604318),('2024-07-02 00:50:00.000000',00000000000001606316),('2024-07-02 00:55:00.000000',00000000000001608315),('2024-07-02 01:00:00.000000',00000000000001614305),('2024-07-02 01:05:00.000000',00000000000001621205),('2024-07-02 01:10:00.000000',00000000000001624203),('2024-07-02 01:15:00.000000',00000000000001626203),('2024-07-02 01:20:00.000000',00000000000001632193),('2024-07-02 01:25:00.000000',00000000000001635793),('2024-07-02 01:30:00.000000',00000000000001662193),('2024-07-02 01:35:00.000000',00000000000001676473),('2024-07-02 01:40:00.000000',00000000000001720373),('2024-07-02 01:45:00.000000',00000000000001741162),('2024-07-02 01:50:00.000000',00000000000001749350),('2024-07-02 01:55:00.000000',00000000000001769250),('2024-07-02 02:00:00.000000',00000000000001769250),('2024-07-02 02:05:00.000000',00000000000001771450),('2024-07-02 02:10:00.000000',00000000000001782596),('2024-07-02 02:15:00.000000',00000000000001789685),('2024-07-02 02:20:00.000000',00000000000001841365),('2024-07-02 02:25:00.000000',00000000000001847352),('2024-07-02 02:30:00.000000',00000000000001880952),('2024-07-02 02:35:00.000000',00000000000001923422),('2024-07-02 02:40:00.000000',00000000000001937209),('2024-07-02 02:45:00.000000',00000000000001940086),('2024-07-02 02:50:00.000000',00000000000001943986),('2024-07-02 02:55:00.000000',00000000000001944986),('2024-07-02 03:00:00.000000',00000000000001973666),('2024-07-02 03:05:00.000000',00000000000001983565),('2024-07-02 03:10:00.000000',00000000000001992465),('2024-07-02 03:15:00.000000',00000000000001995865),('2024-07-02 03:20:00.000000',00000000000002000855),('2024-07-02 03:25:00.000000',00000000000002011655),('2024-07-02 03:30:00.000000',00000000000002118733),('2024-07-02 03:35:00.000000',00000000000002129623),('2024-07-02 03:40:00.000000',00000000000002145501),('2024-07-02 03:45:00.000000',00000000000002185401),('2024-07-02 03:50:00.000000',00000000000002195281),('2024-07-02 03:55:00.000000',00000000000002200281),('2024-07-02 04:00:00.000000',00000000000002201281),('2024-07-02 04:05:00.000000',00000000000002216081),('2024-07-02 04:10:00.000000',00000000000002221080),('2024-07-02 04:15:00.000000',00000000000002228980),('2024-07-02 04:20:00.000000',00000000000002230080),('2024-07-02 04:25:00.000000',00000000000002282069),('2024-07-02 04:30:00.000000',00000000000002294867),('2024-07-02 04:35:00.000000',00000000000002309636),('2024-07-02 04:40:00.000000',00000000000002328395),('2024-07-02 04:45:00.000000',00000000000002350762),('2024-07-02 04:50:00.000000',00000000000002378652),('2024-07-02 04:55:00.000000',00000000000002402572),('2024-07-02 05:00:00.000000',00000000000002419662),('2024-07-02 05:05:00.000000',00000000000002416472),('2024-07-02 05:10:00.000000',00000000000002436651),('2024-07-02 05:15:00.000000',00000000000002448619),('2024-07-02 05:20:00.000000',00000000000002464486),('2024-07-02 05:25:00.000000',00000000000002516601),('2024-07-02 05:30:00.000000',00000000000002554557),('2024-07-02 05:35:00.000000',00000000000002585406),('2024-07-02 05:40:00.000000',00000000000002585406),('2024-07-02 05:45:00.000000',00000000000002603085),('2024-07-02 05:50:00.000000',00000000000002632935),('2024-07-02 05:55:00.000000',00000000000002658705),('2024-07-02 06:00:00.000000',00000000000002731655),('2024-07-02 06:05:00.000000',00000000000002779623),('2024-07-02 06:10:00.000000',00000000000002798402),('2024-07-02 06:15:00.000000',00000000000002808302),('2024-07-02 06:20:00.000000',00000000000002804312),('2024-07-02 06:25:00.000000',00000000000002808302),('2024-07-02 06:30:00.000000',00000000000002821092),('2024-07-02 06:35:00.000000',00000000000002837772),('2024-07-02 06:40:00.000000',00000000000002837772),('2024-07-02 06:45:00.000000',00000000000002850770),('2024-07-02 06:50:00.000000',00000000000002857670),('2024-07-02 06:55:00.000000',00000000000002873548),('2024-07-02 07:00:00.000000',00000000000002888036),('2024-07-02 07:05:00.000000',00000000000002911826),('2024-07-02 07:10:00.000000',00000000000002929786),('2024-07-02 07:15:00.000000',00000000000002947674),('2024-07-02 07:20:00.000000',00000000000002985474),('2024-07-02 07:25:00.000000',00000000000003000873),('2024-07-02 07:30:00.000000',00000000000003020563),('2024-07-02 07:35:00.000000',00000000000003055629),('2024-07-02 07:40:00.000000',00000000000003069419),('2024-07-02 07:45:00.000000',00000000000003106098),('2024-07-02 07:50:00.000000',00000000000003109087),('2024-07-02 07:55:00.000000',00000000000003115185),('2024-07-02 08:00:00.000000',00000000000003117183),('2024-07-02 08:05:00.000000',00000000000003134152),('2024-07-02 08:10:00.000000',00000000000003139952),('2024-07-02 08:15:00.000000',00000000000003146841),('2024-07-02 08:20:00.000000',00000000000003164528),('2024-07-02 08:25:00.000000',00000000000003176416),('2024-07-02 08:30:00.000000',00000000000003176616),('2024-07-02 08:35:00.000000',00000000000003200516),('2024-07-02 08:40:00.000000',00000000000003211903),('2024-07-02 08:45:00.000000',00000000000003228693),('2024-07-02 08:50:00.000000',00000000000003237582),('2024-07-02 08:55:00.000000',00000000000003239582),('2024-07-02 09:00:00.000000',00000000000003246482),('2024-07-02 09:05:00.000000',00000000000003254372),('2024-07-02 09:10:00.000000',00000000000003254372),('2024-07-02 09:15:00.000000',00000000000003260272),('2024-07-02 09:20:00.000000',00000000000003267172),('2024-07-02 09:25:00.000000',00000000000003275061),('2024-07-02 09:30:00.000000',00000000000003319030),('2024-07-02 09:35:00.000000',00000000000003380220),('2024-07-02 09:40:00.000000',00000000000003389188),('2024-07-02 09:45:00.000000',00000000000003392088),('2024-07-02 09:50:00.000000',00000000000003398888),('2024-07-02 09:55:00.000000',00000000000003434588),('2024-07-02 10:00:00.000000',00000000000003439368),('2024-07-02 10:05:00.000000',00000000000003442368),('2024-07-02 10:10:00.000000',00000000000003443368),('2024-07-02 10:15:00.000000',00000000000003450168),('2024-07-02 10:20:00.000000',00000000000003455157),('2024-07-02 10:25:00.000000',00000000000003460405),('2024-07-02 10:30:00.000000',00000000000003460405),('2024-07-02 10:35:00.000000',00000000000003464305),('2024-07-02 10:40:00.000000',00000000000003481895),('2024-07-02 10:45:00.000000',00000000000003483895),('2024-07-02 10:50:00.000000',00000000000003488895),('2024-07-02 10:55:00.000000',00000000000003488895),('2024-07-02 11:00:00.000000',00000000000003506795),('2024-07-02 11:05:00.000000',00000000000003522695),('2024-07-02 11:10:00.000000',00000000000003541695),('2024-07-02 11:15:00.000000',00000000000003561393),('2024-07-02 11:20:00.000000',00000000000003564193),('2024-07-02 11:25:00.000000',00000000000003574072),('2024-07-02 11:30:00.000000',00000000000003628362),('2024-07-02 11:35:00.000000',00000000000003697491),('2024-07-02 11:40:00.000000',00000000000003710391),('2024-07-02 11:45:00.000000',00000000000003728171),('2024-07-02 11:50:00.000000',00000000000003741460),('2024-07-02 11:55:00.000000',00000000000003750570),('2024-07-02 12:00:00.000000',00000000000003765839),('2024-07-02 12:05:00.000000',00000000000003771817),('2024-07-02 12:10:00.000000',00000000000003786695),('2024-07-02 12:15:00.000000',00000000000003791693),('2024-07-02 12:20:00.000000',00000000000003799593),('2024-07-02 12:25:00.000000',00000000000003832272),('2024-07-02 12:30:00.000000',00000000000004141161),('2024-07-02 12:35:00.000000',00000000000004153940),('2024-07-02 12:40:00.000000',00000000000004169840),('2024-07-02 12:45:00.000000',00000000000004177830),('2024-07-02 12:50:00.000000',00000000000004196708),('2024-07-02 12:55:00.000000',00000000000004219387),('2024-07-02 13:00:00.000000',00000000000004231385),('2024-07-02 13:05:00.000000',00000000000004242773),('2024-07-02 13:10:00.000000',00000000000004248763),('2024-07-02 13:15:00.000000',00000000000004284661),('2024-07-02 13:20:00.000000',00000000000004294550),('2024-07-02 13:25:00.000000',00000000000004310139),('2024-07-02 13:30:00.000000',00000000000004338737),('2024-07-02 13:35:00.000000',00000000000004338737),('2024-07-02 13:40:00.000000',00000000000004354528),('2024-07-02 13:45:00.000000',00000000000004362117),('2024-07-02 13:50:00.000000',00000000000004381997),('2024-07-02 13:55:00.000000',00000000000004404766),('2024-07-02 14:00:00.000000',00000000000004419566),('2024-07-02 14:05:00.000000',00000000000004434066),('2024-07-02 14:10:00.000000',00000000000004462823),('2024-07-02 14:15:00.000000',00000000000004481011),('2024-07-02 14:20:00.000000',00000000000004493999),('2024-07-02 14:25:00.000000',00000000000004540355),('2024-07-02 14:30:00.000000',00000000000004578825),('2024-07-02 14:35:00.000000',00000000000004639204),('2024-07-02 14:40:00.000000',00000000000004673081),('2024-07-02 14:45:00.000000',00000000000004690737),('2024-07-02 14:50:00.000000',00000000000004709037),('2024-07-02 14:55:00.000000',00000000000004751826),('2024-07-02 15:00:00.000000',00000000000004780014),('2024-07-02 15:05:00.000000',00000000000004800910),('2024-07-02 15:10:00.000000',00000000000004823908),('2024-07-02 15:15:00.000000',00000000000004865987),('2024-07-02 15:20:00.000000',00000000000004966872),('2024-07-02 15:25:00.000000',00000000000004996670),('2024-07-02 15:30:00.000000',00000000000005262292),('2024-07-02 15:35:00.000000',00000000000005301571),('2024-07-02 15:40:00.000000',00000000000005363487),('2024-07-02 15:45:00.000000',00000000000005416654),('2024-07-02 15:50:00.000000',00000000000005493130),('2024-07-02 15:55:00.000000',00000000000005517330),('2024-07-02 16:00:00.000000',00000000000000000000),('2024-07-02 16:05:00.000000',00000000000000039289),('2024-07-02 16:10:00.000000',00000000000000076789),('2024-07-02 16:15:00.000000',00000000000000185267),('2024-07-02 16:20:00.000000',00000000000000226756),('2024-07-02 16:25:00.000000',00000000000000293524),('2024-07-02 16:30:00.000000',00000000000000741512),('2024-07-02 16:35:00.000000',00000000000000755799),('2024-07-02 16:40:00.000000',00000000000000799397),('2024-07-02 16:45:00.000000',00000000000000860374),('2024-07-02 16:50:00.000000',00000000000000889353),('2024-07-02 16:55:00.000000',00000000000000936602),('2024-07-02 17:00:00.000000',00000000000000954002),('2024-07-02 17:05:00.000000',00000000000001019391),('2024-07-02 17:10:00.000000',00000000000001045978),('2024-07-02 17:15:00.000000',00000000000001066602),('2024-07-02 17:20:00.000000',00000000000001072490),('2024-07-02 17:25:00.000000',00000000000001118668),('2024-07-02 17:30:00.000000',00000000000001135364),('2024-07-02 17:35:00.000000',00000000000001158064),('2024-07-02 17:40:00.000000',00000000000001211943),('2024-07-02 17:45:00.000000',00000000000001229731),('2024-07-02 17:50:00.000000',00000000000001269431),('2024-07-02 17:55:00.000000',00000000000001279421),('2024-07-02 18:00:00.000000',00000000000001283421),('2024-07-02 18:05:00.000000',00000000000001301221),('2024-07-02 18:10:00.000000',00000000000001322210),('2024-07-02 18:15:00.000000',00000000000001344910),('2024-07-02 18:20:00.000000',00000000000001343910),('2024-07-02 18:25:00.000000',00000000000001351799),('2024-07-02 18:30:00.000000',00000000000001362677),('2024-07-02 18:35:00.000000',00000000000001364277),('2024-07-02 18:40:00.000000',00000000000001370337),('2024-07-02 18:45:00.000000',00000000000001390026),('2024-07-02 18:50:00.000000',00000000000001403704),('2024-07-02 18:55:00.000000',00000000000001407004),('2024-07-02 19:00:00.000000',00000000000001418494),('2024-07-02 19:05:00.000000',00000000000001420493),('2024-07-02 19:10:00.000000',00000000000001425483),('2024-07-02 19:15:00.000000',00000000000001439563),('2024-07-02 19:20:00.000000',00000000000001453551),('2024-07-02 19:25:00.000000',00000000000001458431),('2024-07-02 19:30:00.000000',00000000000001464407),('2024-07-02 19:35:00.000000',00000000000001467396),('2024-07-02 19:40:00.000000',00000000000001472375),('2024-07-02 19:45:00.000000',00000000000001472375),('2024-07-02 19:50:00.000000',00000000000001473375),('2024-07-02 19:55:00.000000',00000000000001482365),('2024-07-02 20:00:00.000000',00000000000001490265),('2024-07-02 20:05:00.000000',00000000000001502154),('2024-07-02 20:10:00.000000',00000000000001525843),('2024-07-02 20:15:00.000000',00000000000001528843),('2024-07-02 20:20:00.000000',00000000000001533743),('2024-07-02 20:25:00.000000',00000000000001533743),('2024-07-02 20:30:00.000000',00000000000001540643),('2024-07-02 20:35:00.000000',00000000000001543643),('2024-07-02 20:40:00.000000',00000000000001548043),('2024-07-02 20:45:00.000000',00000000000001553043),('2024-07-02 20:50:00.000000',00000000000001553443),('2024-07-02 20:55:00.000000',00000000000001559332),('2024-07-02 21:00:00.000000',00000000000001560332),('2024-07-02 21:05:00.000000',00000000000001560332),('2024-07-02 21:10:00.000000',00000000000001560332),('2024-07-02 21:15:00.000000',00000000000001568322),('2024-07-02 21:20:00.000000',00000000000001572321),('2024-07-02 21:25:00.000000',00000000000001574721),('2024-07-02 21:30:00.000000',00000000000001576721),('2024-07-02 21:35:00.000000',00000000000001577381),('2024-07-02 21:40:00.000000',00000000000001580370),('2024-07-02 21:45:00.000000',00000000000001589170),('2024-07-02 21:50:00.000000',00000000000001589170),('2024-07-02 21:55:00.000000',00000000000001589170),('2024-07-02 22:00:00.000000',00000000000001598569),('2024-07-02 22:05:00.000000',00000000000001602569),('2024-07-02 22:10:00.000000',00000000000001616958),('2024-07-02 22:15:00.000000',00000000000001630948),('2024-07-02 22:20:00.000000',00000000000001641748),('2024-07-02 22:25:00.000000',00000000000001654548),('2024-07-02 22:30:00.000000',00000000000001659738),('2024-07-02 22:35:00.000000',00000000000001666638),('2024-07-02 22:40:00.000000',00000000000001670638),('2024-07-02 22:45:00.000000',00000000000001680628),('2024-07-02 22:50:00.000000',00000000000001689796),('2024-07-02 22:55:00.000000',00000000000001707484),('2024-07-02 23:00:00.000000',00000000000001707484),('2024-07-02 23:05:00.000000',00000000000001717474),('2024-07-02 23:10:00.000000',00000000000001717474),('2024-07-02 23:15:00.000000',00000000000001730174),('2024-07-02 23:20:00.000000',00000000000001730174),('2024-07-02 23:25:00.000000',00000000000001759272),('2024-07-02 23:30:00.000000',00000000000001769161),('2024-07-02 23:35:00.000000',00000000000001773150),('2024-07-02 23:40:00.000000',00000000000001785029),('2024-07-02 23:45:00.000000',00000000000001787418),('2024-07-02 23:50:00.000000',00000000000001787418),('2024-07-02 23:55:00.000000',00000000000001789418),('2024-07-03 00:00:00.000000',00000000000001791407),('2024-07-03 00:05:00.000000',00000000000001809987),('2024-07-03 00:10:00.000000',00000000000001824187),('2024-07-03 00:15:00.000000',00000000000001828826),('2024-07-03 00:20:00.000000',00000000000001837715),('2024-07-03 00:25:00.000000',00000000000001838715),('2024-07-03 00:30:00.000000',00000000000001846705),('2024-07-03 00:35:00.000000',00000000000001869390),('2024-07-03 00:40:00.000000',00000000000001884268),('2024-07-03 00:45:00.000000',00000000000001910358),('2024-07-03 00:50:00.000000',00000000000002119258),('2024-07-03 00:55:00.000000',00000000000002122258),('2024-07-03 01:00:00.000000',00000000000002136148),('2024-07-03 01:05:00.000000',00000000000002137148),('2024-07-03 01:10:00.000000',00000000000002155648),('2024-07-03 01:15:00.000000',00000000000002208446),('2024-07-03 01:20:00.000000',00000000000002215346),('2024-07-03 01:25:00.000000',00000000000002224336),('2024-07-03 01:30:00.000000',00000000000002230336),('2024-07-03 01:35:00.000000',00000000000002232336),('2024-07-03 01:40:00.000000',00000000000002266205),('2024-07-03 01:45:00.000000',00000000000002355005),('2024-07-03 01:50:00.000000',00000000000002358105),('2024-07-03 01:55:00.000000',00000000000002386603),('2024-07-03 02:00:00.000000',00000000000002391192),('2024-07-03 02:05:00.000000',00000000000002398892),('2024-07-03 02:10:00.000000',00000000000002404882),('2024-07-03 02:15:00.000000',00000000000002847182),('2024-07-03 02:20:00.000000',00000000000002849682),('2024-07-03 02:25:00.000000',00000000000002860880),('2024-07-03 02:30:00.000000',00000000000002878572),('2024-07-03 02:35:00.000000',00000000000002885472),('2024-07-03 02:40:00.000000',00000000000002896362),('2024-07-03 02:45:00.000000',00000000000003030352),('2024-07-03 02:50:00.000000',00000000000003055042),('2024-07-03 02:55:00.000000',00000000000003060942),('2024-07-03 03:00:00.000000',00000000000003084932),('2024-07-03 03:05:00.000000',00000000000003102732),('2024-07-03 03:10:00.000000',00000000000003118300),('2024-07-03 03:15:00.000000',00000000000003134100),('2024-07-03 03:20:00.000000',00000000000003134100),('2024-07-03 03:25:00.000000',00000000000003135600),('2024-07-03 03:30:00.000000',00000000000003149499),('2024-07-03 03:35:00.000000',00000000000003153098),('2024-07-03 03:40:00.000000',00000000000003162087),('2024-07-03 03:45:00.000000',00000000000003180877),('2024-07-03 03:50:00.000000',00000000000003194677),('2024-07-03 03:55:00.000000',00000000000003198675),('2024-07-03 04:00:00.000000',00000000000003215453),('2024-07-03 04:05:00.000000',00000000000003219942),('2024-07-03 04:10:00.000000',00000000000003221042),('2024-07-03 04:15:00.000000',00000000000003235022),('2024-07-03 04:20:00.000000',00000000000003243202),('2024-07-03 04:25:00.000000',00000000000003257092),('2024-07-03 04:30:00.000000',00000000000003287960),('2024-07-03 04:35:00.000000',00000000000003325510),('2024-07-03 04:40:00.000000',00000000000003356870),('2024-07-03 04:45:00.000000',00000000000003369050),('2024-07-03 04:50:00.000000',00000000000003409307),('2024-07-03 04:55:00.000000',00000000000003423354),('2024-07-03 05:00:00.000000',00000000000003434612),('2024-07-03 05:05:00.000000',00000000000003457390),('2024-07-03 05:10:00.000000',00000000000003474750),('2024-07-03 05:15:00.000000',00000000000003488540),('2024-07-03 05:20:00.000000',00000000000003504498),('2024-07-03 05:25:00.000000',00000000000003563157),('2024-07-03 05:30:00.000000',00000000000003586937),('2024-07-03 05:35:00.000000',00000000000003634926),('2024-07-03 05:40:00.000000',00000000000003641905),('2024-07-03 05:45:00.000000',00000000000003651803),('2024-07-03 05:50:00.000000',00000000000003882571),('2024-07-03 05:55:00.000000',00000000000003888558),('2024-07-03 06:00:00.000000',00000000000003910328),('2024-07-03 06:05:00.000000',00000000000003924098),('2024-07-03 06:10:00.000000',00000000000003948658),('2024-07-03 06:15:00.000000',00000000000003954548),('2024-07-03 06:20:00.000000',00000000000003958448),('2024-07-03 06:25:00.000000',00000000000003971408),('2024-07-03 06:30:00.000000',00000000000003975508),('2024-07-03 06:35:00.000000',00000000000003996068),('2024-07-03 06:40:00.000000',00000000000004009956),('2024-07-03 06:45:00.000000',00000000000004034590),('2024-07-03 06:50:00.000000',00000000000004051791),('2024-07-03 06:55:00.000000',00000000000004069491),('2024-07-03 07:00:00.000000',00000000000004089091),('2024-07-03 07:05:00.000000',00000000000004105480),('2024-07-03 07:10:00.000000',00000000000004114567),('2024-07-03 07:15:00.000000',00000000000004130047),('2024-07-03 07:20:00.000000',00000000000004161817),('2024-07-03 07:25:00.000000',00000000000004209447),('2024-07-03 07:30:00.000000',00000000000004239777),('2024-07-03 07:35:00.000000',00000000000004284826),('2024-07-03 07:40:00.000000',00000000000004318615),('2024-07-03 07:45:00.000000',00000000000004363185),('2024-07-03 07:50:00.000000',00000000000004414185),('2024-07-03 07:55:00.000000',00000000000004421985),('2024-07-03 08:00:00.000000',00000000000004469985),('2024-07-03 08:05:00.000000',00000000000004495075),('2024-07-03 08:10:00.000000',00000000000004526654),('2024-07-03 08:15:00.000000',00000000000004541254),('2024-07-03 08:20:00.000000',00000000000004538255),('2024-07-03 08:25:00.000000',00000000000004554134),('2024-07-03 08:30:00.000000',00000000000004586822),('2024-07-03 08:35:00.000000',00000000000004604702),('2024-07-03 08:40:00.000000',00000000000004611981),('2024-07-03 08:45:00.000000',00000000000004657159),('2024-07-03 08:50:00.000000',00000000000004665137),('2024-07-03 08:55:00.000000',00000000000004679727),('2024-07-03 09:00:00.000000',00000000000004696905),('2024-07-03 09:05:00.000000',00000000000004721754),('2024-07-03 09:10:00.000000',00000000000004742623),('2024-07-03 09:15:00.000000',00000000000004750513),('2024-07-03 09:20:00.000000',00000000000004764400),('2024-07-03 09:25:00.000000',00000000000004798170),('2024-07-03 09:30:00.000000',00000000000004803458),('2024-07-03 09:35:00.000000',00000000000004816448),('2024-07-03 09:40:00.000000',00000000000004833238),('2024-07-03 09:45:00.000000',00000000000004845218),('2024-07-03 09:50:00.000000',00000000000004858208),('2024-07-03 09:55:00.000000',00000000000004869176),('2024-07-03 10:00:00.000000',00000000000004870176),('2024-07-03 10:05:00.000000',00000000000004878955),('2024-07-03 10:10:00.000000',00000000000004894655),('2024-07-03 10:15:00.000000',00000000000004898645),('2024-07-03 10:20:00.000000',00000000000004912445),('2024-07-03 10:25:00.000000',00000000000004920521),('2024-07-03 10:30:00.000000',00000000000004924511),('2024-07-03 10:35:00.000000',00000000000004952301),('2024-07-03 10:40:00.000000',00000000000004956401),('2024-07-03 10:45:00.000000',00000000000005017777),('2024-07-03 10:50:00.000000',00000000000005019388),('2024-07-03 10:55:00.000000',00000000000005041776),('2024-07-03 11:00:00.000000',00000000000005061976),('2024-07-03 11:05:00.000000',00000000000005082835),('2024-07-03 11:10:00.000000',00000000000005112995),('2024-07-03 11:15:00.000000',00000000000005131785),('2024-07-03 11:20:00.000000',00000000000005142574),('2024-07-03 11:25:00.000000',00000000000005147574),('2024-07-03 11:30:00.000000',00000000000005164874),('2024-07-03 11:35:00.000000',00000000000005190842),('2024-07-03 11:40:00.000000',00000000000005194931),('2024-07-03 11:45:00.000000',00000000000005204201),('2024-07-03 11:50:00.000000',00000000000005212180),('2024-07-03 11:55:00.000000',00000000000005219080),('2024-07-03 12:00:00.000000',00000000000005232780),('2024-07-03 12:05:00.000000',00000000000005239780),('2024-07-03 12:10:00.000000',00000000000005290430),('2024-07-03 12:15:00.000000',00000000000005347410),('2024-07-03 12:20:00.000000',00000000000005389400),('2024-07-03 12:25:00.000000',00000000000005403298),('2024-07-03 12:30:00.000000',00000000000005432678),('2024-07-03 12:35:00.000000',00000000000005445767),('2024-07-03 12:40:00.000000',00000000000005479105),('2024-07-03 12:45:00.000000',00000000000005516873),('2024-07-03 12:50:00.000000',00000000000005570252),('2024-07-03 12:55:00.000000',00000000000005595542),('2024-07-03 13:00:00.000000',00000000000005624861),('2024-07-03 13:05:00.000000',00000000000005655161),('2024-07-03 13:10:00.000000',00000000000005670461),('2024-07-03 13:15:00.000000',00000000000005720361),('2024-07-03 13:20:00.000000',00000000000005745261),('2024-07-03 13:25:00.000000',00000000000005761847),('2024-07-03 13:30:00.000000',00000000000005769245),('2024-07-03 13:35:00.000000',00000000000005797335),('2024-07-03 13:40:00.000000',00000000000005805635),('2024-07-03 13:45:00.000000',00000000000005833904),('2024-07-03 13:50:00.000000',00000000000005903981),('2024-07-03 13:55:00.000000',00000000000005920970),('2024-07-03 14:00:00.000000',00000000000005938648),('2024-07-03 14:05:00.000000',00000000000005965746),('2024-07-03 14:10:00.000000',00000000000005981634),('2024-07-03 14:15:00.000000',00000000000006029814),('2024-07-03 14:20:00.000000',00000000000006043004),('2024-07-03 14:25:00.000000',00000000000006051404),('2024-07-03 14:30:00.000000',00000000000006091583),('2024-07-03 14:35:00.000000',00000000000006115573),('2024-07-03 14:40:00.000000',00000000000006136163),('2024-07-03 14:45:00.000000',00000000000006159533),('2024-07-03 14:50:00.000000',00000000000006172633),('2024-07-03 14:55:00.000000',00000000000006217612),('2024-07-03 15:00:00.000000',00000000000006244558),('2024-07-03 15:05:00.000000',00000000000006263958),('2024-07-03 15:10:00.000000',00000000000006275107),('2024-07-03 15:15:00.000000',00000000000006285307),('2024-07-03 15:20:00.000000',00000000000006314266),('2024-07-03 15:25:00.000000',00000000000006388166),('2024-07-03 15:30:00.000000',00000000000006415666),('2024-07-03 15:35:00.000000',00000000000006448486),('2024-07-03 15:40:00.000000',00000000000006517986),('2024-07-03 15:45:00.000000',00000000000006613654),('2024-07-03 15:50:00.000000',00000000000006744633),('2024-07-03 15:55:00.000000',00000000000006791682),('2024-07-03 16:00:00.000000',00000000000000000000),('2024-07-03 16:05:00.000000',00000000000000293479),('2024-07-03 16:10:00.000000',00000000000000357535),('2024-07-03 16:15:00.000000',00000000000000409281),('2024-07-03 16:20:00.000000',00000000000000463361),('2024-07-03 16:25:00.000000',00000000000000536130),('2024-07-03 16:30:00.000000',00000000000000581619),('2024-07-03 16:35:00.000000',00000000000000618598),('2024-07-03 16:40:00.000000',00000000000000681086),('2024-07-03 16:45:00.000000',00000000000000742676),('2024-07-03 16:50:00.000000',00000000000000830116),('2024-07-03 16:55:00.000000',00000000000000930093),('2024-07-03 17:00:00.000000',00000000000000981672),('2024-07-03 17:05:00.000000',00000000000001038251),('2024-07-03 17:10:00.000000',00000000000001092131),('2024-07-03 17:15:00.000000',00000000000001298319),('2024-07-03 17:20:00.000000',00000000000001349087),('2024-07-03 17:25:00.000000',00000000000001375885),('2024-07-03 17:30:00.000000',00000000000001403365),('2024-07-03 17:35:00.000000',00000000000001423265),('2024-07-03 17:40:00.000000',00000000000001454351),('2024-07-03 17:45:00.000000',00000000000001480651),('2024-07-03 17:50:00.000000',00000000000001509295),('2024-07-03 17:55:00.000000',00000000000001533138),('2024-07-03 18:00:00.000000',00000000000001555215),('2024-07-03 18:05:00.000000',00000000000001590741),('2024-07-03 18:10:00.000000',00000000000001602741),('2024-07-03 18:15:00.000000',00000000000001616030),('2024-07-03 18:20:00.000000',00000000000001628130),('2024-07-03 18:25:00.000000',00000000000001667429),('2024-07-03 18:30:00.000000',00000000000001695304),('2024-07-03 18:35:00.000000',00000000000001719793),('2024-07-03 18:40:00.000000',00000000000001722593),('2024-07-03 18:45:00.000000',00000000000002042081),('2024-07-03 18:50:00.000000',00000000000002051481),('2024-07-03 18:55:00.000000',00000000000002073271),('2024-07-03 19:00:00.000000',00000000000002089169),('2024-07-03 19:05:00.000000',00000000000002099669),('2024-07-03 19:10:00.000000',00000000000002107059),('2024-07-03 19:15:00.000000',00000000000002120148),('2024-07-03 19:20:00.000000',00000000000002133848),('2024-07-03 19:25:00.000000',00000000000002148326),('2024-07-03 19:30:00.000000',00000000000002162915),('2024-07-03 19:35:00.000000',00000000000002172215),('2024-07-03 19:40:00.000000',00000000000002188315),('2024-07-03 19:45:00.000000',00000000000002214515),('2024-07-03 19:50:00.000000',00000000000002228315),('2024-07-03 19:55:00.000000',00000000000002230315),('2024-07-03 20:00:00.000000',00000000000002233304),('2024-07-03 20:05:00.000000',00000000000002247304),('2024-07-03 20:10:00.000000',00000000000002265604),('2024-07-03 20:15:00.000000',00000000000002281504),('2024-07-03 20:20:00.000000',00000000000002290160),('2024-07-03 20:25:00.000000',00000000000002301060),('2024-07-03 20:30:00.000000',00000000000002311460),('2024-07-03 20:35:00.000000',00000000000002314160),('2024-07-03 20:40:00.000000',00000000000002317660),('2024-07-03 20:45:00.000000',00000000000002330860),('2024-07-03 20:50:00.000000',00000000000002337858),('2024-07-03 20:55:00.000000',00000000000002341258),('2024-07-03 21:00:00.000000',00000000000002345857),('2024-07-03 21:05:00.000000',00000000000002387757),('2024-07-03 21:10:00.000000',00000000000002388757),('2024-07-03 21:15:00.000000',00000000000002395647),('2024-07-03 21:20:00.000000',00000000000002398147),('2024-07-03 21:25:00.000000',00000000000002401747),('2024-07-03 21:30:00.000000',00000000000002405147),('2024-07-03 21:35:00.000000',00000000000002409036),('2024-07-03 21:40:00.000000',00000000000002414436),('2024-07-03 21:45:00.000000',00000000000002420736),('2024-07-03 21:50:00.000000',00000000000002425736),('2024-07-03 21:55:00.000000',00000000000002427636),('2024-07-03 22:00:00.000000',00000000000002427636),('2024-07-03 22:05:00.000000',00000000000002431436),('2024-07-03 22:10:00.000000',00000000000002436036),('2024-07-03 22:15:00.000000',00000000000002441056),('2024-07-03 22:20:00.000000',00000000000002446956),('2024-07-03 22:25:00.000000',00000000000002449725),('2024-07-03 22:30:00.000000',00000000000002457994),('2024-07-03 22:35:00.000000',00000000000002464594),('2024-07-03 22:40:00.000000',00000000000002471194),('2024-07-03 22:45:00.000000',00000000000002474194),('2024-07-03 22:50:00.000000',00000000000002487382),('2024-07-03 22:55:00.000000',00000000000002510272),('2024-07-03 23:00:00.000000',00000000000002526352),('2024-07-03 23:05:00.000000',00000000000002540641),('2024-07-03 23:10:00.000000',00000000000002548326),('2024-07-03 23:15:00.000000',00000000000002564726),('2024-07-03 23:20:00.000000',00000000000002571024),('2024-07-03 23:25:00.000000',00000000000002580014),('2024-07-03 23:30:00.000000',00000000000002593914),('2024-07-03 23:35:00.000000',00000000000002599114),('2024-07-03 23:40:00.000000',00000000000002613312),('2024-07-03 23:45:00.000000',00000000000002634712),('2024-07-03 23:50:00.000000',00000000000002646812),('2024-07-03 23:55:00.000000',00000000000002651212),('2024-07-04 00:00:00.000000',00000000000002661191),('2024-07-04 00:05:00.000000',00000000000002667291),('2024-07-04 00:10:00.000000',00000000000002685379),('2024-07-04 00:15:00.000000',00000000000002689379),('2024-07-04 00:20:00.000000',00000000000002702858),('2024-07-04 00:25:00.000000',00000000000002712258),('2024-07-04 00:30:00.000000',00000000000002724348),('2024-07-04 00:35:00.000000',00000000000002727548),('2024-07-04 00:40:00.000000',00000000000002735448),('2024-07-04 00:45:00.000000',00000000000002741337),('2024-07-04 00:50:00.000000',00000000000002753637),('2024-07-04 00:55:00.000000',00000000000002774413),('2024-07-04 01:00:00.000000',00000000000002782511),('2024-07-04 01:05:00.000000',00000000000002791478),('2024-07-04 01:10:00.000000',00000000000002815246),('2024-07-04 01:15:00.000000',00000000000002831435),('2024-07-04 01:20:00.000000',00000000000002858215),('2024-07-04 01:25:00.000000',00000000000002870315),('2024-07-04 01:30:00.000000',00000000000002877015),('2024-07-04 01:35:00.000000',00000000000002887902),('2024-07-04 01:40:00.000000',00000000000002912000),('2024-07-04 01:45:00.000000',00000000000002931879),('2024-07-04 01:50:00.000000',00000000000002951749),('2024-07-04 01:55:00.000000',00000000000002968438),('2024-07-04 02:00:00.000000',00000000000002972427),('2024-07-04 02:05:00.000000',00000000000002984327),('2024-07-04 02:10:00.000000',00000000000002989217),('2024-07-04 02:15:00.000000',00000000000002998417),('2024-07-04 02:20:00.000000',00000000000003019517),('2024-07-04 02:25:00.000000',00000000000003030496),('2024-07-04 02:30:00.000000',00000000000003035896),('2024-07-04 02:35:00.000000',00000000000003044075),('2024-07-04 02:40:00.000000',00000000000003055964),('2024-07-04 02:45:00.000000',00000000000003061864),('2024-07-04 02:50:00.000000',00000000000003068514),('2024-07-04 02:55:00.000000',00000000000003083304),('2024-07-04 03:00:00.000000',00000000000003095494),('2024-07-04 03:05:00.000000',00000000000003096994),('2024-07-04 03:10:00.000000',00000000000003128394),('2024-07-04 03:15:00.000000',00000000000003151694),('2024-07-04 03:20:00.000000',00000000000003191692),('2024-07-04 03:25:00.000000',00000000000003208342),('2024-07-04 03:30:00.000000',00000000000003225329),('2024-07-04 03:35:00.000000',00000000000003234618),('2024-07-04 03:40:00.000000',00000000000003238518),('2024-07-04 03:45:00.000000',00000000000003252618),('2024-07-04 03:50:00.000000',00000000000003252718),('2024-07-04 03:55:00.000000',00000000000003263608),('2024-07-04 04:00:00.000000',00000000000003279408),('2024-07-04 04:05:00.000000',00000000000003280408),('2024-07-04 04:10:00.000000',00000000000003283398),('2024-07-04 04:15:00.000000',00000000000003302192),('2024-07-04 04:20:00.000000',00000000000003313292),('2024-07-04 04:25:00.000000',00000000000003332472),('2024-07-04 04:30:00.000000',00000000000003338451),('2024-07-04 04:35:00.000000',00000000000003360130),('2024-07-04 04:40:00.000000',00000000000003377999),('2024-07-04 04:45:00.000000',00000000000003397285),('2024-07-04 04:50:00.000000',00000000000003421521),('2024-07-04 04:55:00.000000',00000000000003449371),('2024-07-04 05:00:00.000000',00000000000003475131),('2024-07-04 05:05:00.000000',00000000000003488920),('2024-07-04 05:10:00.000000',00000000000003503697),('2024-07-04 05:15:00.000000',00000000000003517397),('2024-07-04 05:20:00.000000',00000000000003552997),('2024-07-04 05:25:00.000000',00000000000003582066),('2024-07-04 05:30:00.000000',00000000000003596954),('2024-07-04 05:35:00.000000',00000000000003607923),('2024-07-04 05:40:00.000000',00000000000003635381),('2024-07-04 05:45:00.000000',00000000000003640379),('2024-07-04 05:50:00.000000',00000000000003648248),('2024-07-04 05:55:00.000000',00000000000003668028),('2024-07-04 06:00:00.000000',00000000000003712115),('2024-07-04 06:05:00.000000',00000000000003720894),('2024-07-04 06:10:00.000000',00000000000003732962),('2024-07-04 06:15:00.000000',00000000000003738449),('2024-07-04 06:20:00.000000',00000000000003740349),('2024-07-04 06:25:00.000000',00000000000003754329),('2024-07-04 06:30:00.000000',00000000000003874184),('2024-07-04 06:35:00.000000',00000000000003887954),('2024-07-04 06:40:00.000000',00000000000003912224),('2024-07-04 06:45:00.000000',00000000000003918214),('2024-07-04 06:50:00.000000',00000000000003923502),('2024-07-04 06:55:00.000000',00000000000003925395),('2024-07-04 07:00:00.000000',00000000000003936164),('2024-07-04 07:05:00.000000',00000000000003962733),('2024-07-04 07:10:00.000000',00000000000003970623),('2024-07-04 07:15:00.000000',00000000000003977611),('2024-07-04 07:20:00.000000',00000000000003994567),('2024-07-04 07:25:00.000000',00000000000004081524),('2024-07-04 07:30:00.000000',00000000000004089492),('2024-07-04 07:35:00.000000',00000000000004113862),('2024-07-04 07:40:00.000000',00000000000004131141),('2024-07-04 07:45:00.000000',00000000000004172931),('2024-07-04 07:50:00.000000',00000000000004183731),('2024-07-04 07:55:00.000000',00000000000004205418),('2024-07-04 08:00:00.000000',00000000000004210808),('2024-07-04 08:05:00.000000',00000000000004224597),('2024-07-04 08:10:00.000000',00000000000004236887),('2024-07-04 08:15:00.000000',00000000000004256415),('2024-07-04 08:20:00.000000',00000000000004271205),('2024-07-04 08:25:00.000000',00000000000004281283),('2024-07-04 08:30:00.000000',00000000000004293253),('2024-07-04 08:35:00.000000',00000000000004316868),('2024-07-04 08:40:00.000000',00000000000004328738),('2024-07-04 08:45:00.000000',00000000000004339418),('2024-07-04 08:50:00.000000',00000000000004413488),('2024-07-04 08:55:00.000000',00000000000004424366),('2024-07-04 09:00:00.000000',00000000000004438266),('2024-07-04 09:05:00.000000',00000000000004441866),('2024-07-04 09:10:00.000000',00000000000004484666),('2024-07-04 09:15:00.000000',00000000000004499966),('2024-07-04 09:20:00.000000',00000000000004517154),('2024-07-04 09:25:00.000000',00000000000004522652),('2024-07-04 09:30:00.000000',00000000000004587321),('2024-07-04 09:35:00.000000',00000000000004591221),('2024-07-04 09:40:00.000000',00000000000004610199),('2024-07-04 09:45:00.000000',00000000000004638279),('2024-07-04 09:50:00.000000',00000000000004645078),('2024-07-04 09:55:00.000000',00000000000004650168),('2024-07-04 10:00:00.000000',00000000000004658068),('2024-07-04 10:05:00.000000',00000000000004659068),('2024-07-04 10:10:00.000000',00000000000004663066),('2024-07-04 10:15:00.000000',00000000000004674966),('2024-07-04 10:20:00.000000',00000000000004675966),('2024-07-04 10:25:00.000000',00000000000004689834),('2024-07-04 10:30:00.000000',00000000000004699732),('2024-07-04 10:35:00.000000',00000000000004701732),('2024-07-04 10:40:00.000000',00000000000004702732),('2024-07-04 10:45:00.000000',00000000000004721601),('2024-07-04 10:50:00.000000',00000000000004737301),('2024-07-04 10:55:00.000000',00000000000004740101),('2024-07-04 11:00:00.000000',00000000000004741101),('2024-07-04 11:05:00.000000',00000000000004746999),('2024-07-04 11:10:00.000000',00000000000004762879),('2024-07-04 11:15:00.000000',00000000000004763379),('2024-07-04 11:20:00.000000',00000000000004782069),('2024-07-04 11:25:00.000000',00000000000004805849),('2024-07-04 11:30:00.000000',00000000000004815138),('2024-07-04 11:35:00.000000',00000000000004831796),('2024-07-04 11:40:00.000000',00000000000004882121),('2024-07-04 11:45:00.000000',00000000000004891321),('2024-07-04 11:50:00.000000',00000000000004912021),('2024-07-04 11:55:00.000000',00000000000004928898),('2024-07-04 12:00:00.000000',00000000000004945598),('2024-07-04 12:05:00.000000',00000000000004955288),('2024-07-04 12:10:00.000000',00000000000004983337),('2024-07-04 12:15:00.000000',00000000000005011117),('2024-07-04 12:20:00.000000',00000000000005028804),('2024-07-04 12:25:00.000000',00000000000005037604),('2024-07-04 12:30:00.000000',00000000000005059304),('2024-07-04 12:35:00.000000',00000000000005073202),('2024-07-04 12:40:00.000000',00000000000005079191),('2024-07-04 12:45:00.000000',00000000000005081991),('2024-07-04 12:50:00.000000',00000000000005091181),('2024-07-04 12:55:00.000000',00000000000005100078),('2024-07-04 13:00:00.000000',00000000000005124868),('2024-07-04 13:05:00.000000',00000000000005166168),('2024-07-04 13:10:00.000000',00000000000005188868),('2024-07-04 13:15:00.000000',00000000000005203758),('2024-07-04 13:20:00.000000',00000000000005217728),('2024-07-04 13:25:00.000000',00000000000005266607),('2024-07-04 13:30:00.000000',00000000000005269605),('2024-07-04 13:35:00.000000',00000000000005273595),('2024-07-04 13:40:00.000000',00000000000005289685),('2024-07-04 13:45:00.000000',00000000000005329375),('2024-07-04 13:50:00.000000',00000000000005333375),('2024-07-04 13:55:00.000000',00000000000005354124),('2024-07-04 14:00:00.000000',00000000000005365124),('2024-07-04 14:05:00.000000',00000000000005370864),('2024-07-04 14:10:00.000000',00000000000005415742),('2024-07-04 14:15:00.000000',00000000000005441120),('2024-07-04 14:20:00.000000',00000000000005457710),('2024-07-04 14:25:00.000000',00000000000005477587),('2024-07-04 14:30:00.000000',00000000000005490867),('2024-07-04 14:35:00.000000',00000000000005500565),('2024-07-04 14:40:00.000000',00000000000005511854),('2024-07-04 14:45:00.000000',00000000000005557444),('2024-07-04 14:50:00.000000',00000000000005582973),('2024-07-04 14:55:00.000000',00000000000005610150),('2024-07-04 15:00:00.000000',00000000000005631648),('2024-07-04 15:05:00.000000',00000000000005670028),('2024-07-04 15:10:00.000000',00000000000005702607),('2024-07-04 15:15:00.000000',00000000000005722695),('2024-07-04 15:20:00.000000',00000000000005814573),('2024-07-04 15:25:00.000000',00000000000005843553),('2024-07-04 15:30:00.000000',00000000000005878287),('2024-07-04 15:35:00.000000',00000000000005923925),('2024-07-04 15:40:00.000000',00000000000005982073),('2024-07-04 15:45:00.000000',00000000000006024341),('2024-07-04 15:50:00.000000',00000000000006064279),('2024-07-04 15:55:00.000000',00000000000006114422),('2024-07-04 16:00:00.000000',00000000000000000000),('2024-07-04 16:05:00.000000',00000000000000031388),('2024-07-04 16:10:00.000000',00000000000000074867),('2024-07-04 16:15:00.000000',00000000000000114096),('2024-07-04 16:20:00.000000',00000000000000163186),('2024-07-04 16:25:00.000000',00000000000000254553),('2024-07-04 16:30:00.000000',00000000000000326117),('2024-07-04 16:35:00.000000',00000000000000363284),('2024-07-04 16:40:00.000000',00000000000000423472),('2024-07-04 16:45:00.000000',00000000000000471862),('2024-07-04 16:50:00.000000',00000000000000501962),('2024-07-04 16:55:00.000000',00000000000000550062),('2024-07-04 17:00:00.000000',00000000000000597642),('2024-07-04 17:05:00.000000',00000000000000658727),('2024-07-04 17:10:00.000000',00000000000000721614),('2024-07-04 17:15:00.000000',00000000000000777702),('2024-07-04 17:20:00.000000',00000000000000807492),('2024-07-04 17:25:00.000000',00000000000000833878),('2024-07-04 17:30:00.000000',00000000000000852876),('2024-07-04 17:35:00.000000',00000000000000874074),('2024-07-04 17:40:00.000000',00000000000000896274),('2024-07-04 17:45:00.000000',00000000000000945551),('2024-07-04 17:50:00.000000',00000000000000955349),('2024-07-04 17:55:00.000000',00000000000000972726),('2024-07-04 18:00:00.000000',00000000000001000326),('2024-07-04 18:05:00.000000',00000000000001016124),('2024-07-04 18:10:00.000000',00000000000001023403),('2024-07-04 18:15:00.000000',00000000000001035991),('2024-07-04 18:20:00.000000',00000000000001043981),('2024-07-04 18:25:00.000000',00000000000001074721),('2024-07-04 18:30:00.000000',00000000000001103587),('2024-07-04 18:35:00.000000',00000000000001125565),('2024-07-04 18:40:00.000000',00000000000001156345),('2024-07-04 18:45:00.000000',00000000000001171745),('2024-07-04 18:50:00.000000',00000000000001184445),('2024-07-04 18:55:00.000000',00000000000001203225),('2024-07-04 19:00:00.000000',00000000000001211125),('2024-07-04 19:05:00.000000',00000000000001232315),('2024-07-04 19:10:00.000000',00000000000001244115),('2024-07-04 19:15:00.000000',00000000000001262114),('2024-07-04 19:20:00.000000',00000000000001274004),('2024-07-04 19:25:00.000000',00000000000001281004),('2024-07-04 19:30:00.000000',00000000000001285102),('2024-07-04 19:35:00.000000',00000000000001291091),('2024-07-04 19:40:00.000000',00000000000001300391),('2024-07-04 19:45:00.000000',00000000000001305377),('2024-07-04 19:50:00.000000',00000000000001311577),('2024-07-04 19:55:00.000000',00000000000001316067),('2024-07-04 20:00:00.000000',00000000000001316467),('2024-07-04 20:05:00.000000',00000000000001348967),('2024-07-04 20:10:00.000000',00000000000001351965),('2024-07-04 20:15:00.000000',00000000000001352965),('2024-07-04 20:20:00.000000',00000000000001356954),('2024-07-04 20:25:00.000000',00000000000001358854),('2024-07-04 20:30:00.000000',00000000000001363154),('2024-07-04 20:35:00.000000',00000000000001365354),('2024-07-04 20:40:00.000000',00000000000001373454),('2024-07-04 20:45:00.000000',00000000000001385641),('2024-07-04 20:50:00.000000',00000000000001391441),('2024-07-04 20:55:00.000000',00000000000001393540),('2024-07-04 21:00:00.000000',00000000000001397540),('2024-07-04 21:05:00.000000',00000000000001404530),('2024-07-04 21:10:00.000000',00000000000001405530),('2024-07-04 21:15:00.000000',00000000000001405530),('2024-07-04 21:20:00.000000',00000000000001405530),('2024-07-04 21:25:00.000000',00000000000001413430),('2024-07-04 21:30:00.000000',00000000000001419420),('2024-07-04 21:35:00.000000',00000000000001426320),('2024-07-04 21:40:00.000000',00000000000001445210),('2024-07-04 21:45:00.000000',00000000000001455198),('2024-07-04 21:50:00.000000',00000000000001500087),('2024-07-04 21:55:00.000000',00000000000001504077),('2024-07-04 22:00:00.000000',00000000000001512067),('2024-07-04 22:05:00.000000',00000000000001517965),('2024-07-04 22:10:00.000000',00000000000001515967),('2024-07-04 22:15:00.000000',00000000000001520067),('2024-07-04 22:20:00.000000',00000000000001550067),('2024-07-04 22:25:00.000000',00000000000001552067),('2024-07-04 22:30:00.000000',00000000000001558054),('2024-07-04 22:35:00.000000',00000000000001559054),('2024-07-04 22:40:00.000000',00000000000001569554),('2024-07-04 22:45:00.000000',00000000000001570554),('2024-07-04 22:50:00.000000',00000000000001570554),('2024-07-04 22:55:00.000000',00000000000001573554),('2024-07-04 23:00:00.000000',00000000000001581443),('2024-07-04 23:05:00.000000',00000000000001583432),('2024-07-04 23:10:00.000000',00000000000001597930),('2024-07-04 23:15:00.000000',00000000000001599930),('2024-07-04 23:20:00.000000',00000000000001603130),('2024-07-04 23:25:00.000000',00000000000001616120),('2024-07-04 23:30:00.000000',00000000000001623920),('2024-07-04 23:35:00.000000',00000000000001625920),('2024-07-04 23:40:00.000000',00000000000001628910),('2024-07-04 23:45:00.000000',00000000000001659899),('2024-07-04 23:50:00.000000',00000000000001677778),('2024-07-04 23:55:00.000000',00000000000001689276),('2024-07-05 00:00:00.000000',00000000000001682376),('2024-07-05 00:05:00.000000',00000000000001685365),('2024-07-05 00:10:00.000000',00000000000001685365),('2024-07-05 00:15:00.000000',00000000000001703163),('2024-07-05 00:20:00.000000',00000000000001710723),('2024-07-05 00:25:00.000000',00000000000001741421),('2024-07-05 00:30:00.000000',00000000000001752641),('2024-07-05 00:35:00.000000',00000000000001762141),('2024-07-05 00:40:00.000000',00000000000001779031),('2024-07-05 00:45:00.000000',00000000000001803795),('2024-07-05 00:50:00.000000',00000000000001813595),('2024-07-05 00:55:00.000000',00000000000001826085),('2024-07-05 01:00:00.000000',00000000000001838883),('2024-07-05 01:05:00.000000',00000000000001842081),('2024-07-05 01:10:00.000000',00000000000001842081),('2024-07-05 01:15:00.000000',00000000000001854071),('2024-07-05 01:20:00.000000',00000000000001864061),('2024-07-05 01:25:00.000000',00000000000001878938),('2024-07-05 01:30:00.000000',00000000000001896638),('2024-07-05 01:35:00.000000',00000000000001898636),('2024-07-05 01:40:00.000000',00000000000001912436),('2024-07-05 01:45:00.000000',00000000000001923546),('2024-07-05 01:50:00.000000',00000000000001932046),('2024-07-05 01:55:00.000000',00000000000001940945),('2024-07-05 02:00:00.000000',00000000000001949345),('2024-07-05 02:05:00.000000',00000000000001959625),('2024-07-05 02:10:00.000000',00000000000001970715),('2024-07-05 02:15:00.000000',00000000000001977204),('2024-07-05 02:20:00.000000',00000000000001982203),('2024-07-05 02:25:00.000000',00000000000001997893),('2024-07-05 02:30:00.000000',00000000000002014243),('2024-07-05 02:35:00.000000',00000000000002035532),('2024-07-05 02:40:00.000000',00000000000002052830),('2024-07-05 02:45:00.000000',00000000000002055230),('2024-07-05 02:50:00.000000',00000000000002060730),('2024-07-05 02:55:00.000000',00000000000002080390),('2024-07-05 03:00:00.000000',00000000000002093177),('2024-07-05 03:05:00.000000',00000000000002166162),('2024-07-05 03:10:00.000000',00000000000002172152),('2024-07-05 03:15:00.000000',00000000000002182632),('2024-07-05 03:20:00.000000',00000000000002199512),('2024-07-05 03:25:00.000000',00000000000002236402),('2024-07-05 03:30:00.000000',00000000000002265292),('2024-07-05 03:35:00.000000',00000000000002297451),('2024-07-05 03:40:00.000000',00000000000002358180),('2024-07-05 03:45:00.000000',00000000000002367659),('2024-07-05 03:50:00.000000',00000000000002373649),('2024-07-05 03:55:00.000000',00000000000002385439),('2024-07-05 04:00:00.000000',00000000000002386638),('2024-07-05 04:05:00.000000',00000000000002396026),('2024-07-05 04:10:00.000000',00000000000002400216),('2024-07-05 04:15:00.000000',00000000000002405214),('2024-07-05 04:20:00.000000',00000000000002450693),('2024-07-05 04:25:00.000000',00000000000002455661),('2024-07-05 04:30:00.000000',00000000000002472061),('2024-07-05 04:35:00.000000',00000000000002512951),('2024-07-05 04:40:00.000000',00000000000002517461),('2024-07-05 04:45:00.000000',00000000000002526161),('2024-07-05 04:50:00.000000',00000000000002566849),('2024-07-05 04:55:00.000000',00000000000002582729),('2024-07-05 05:00:00.000000',00000000000002594069),('2024-07-05 05:05:00.000000',00000000000002601848),('2024-07-05 05:10:00.000000',00000000000002613338),('2024-07-05 05:15:00.000000',00000000000002628507),('2024-07-05 05:20:00.000000',00000000000002635685),('2024-07-05 05:25:00.000000',00000000000002658345),('2024-07-05 05:30:00.000000',00000000000002662345),('2024-07-05 05:35:00.000000',00000000000002669224),('2024-07-05 05:40:00.000000',00000000000002704914),('2024-07-05 05:45:00.000000',00000000000002712803),('2024-07-05 05:50:00.000000',00000000000002717783),('2024-07-05 05:55:00.000000',00000000000002737473),('2024-07-05 06:00:00.000000',00000000000002756271),('2024-07-05 06:05:00.000000',00000000000002904338),('2024-07-05 06:10:00.000000',00000000000002908327),('2024-07-05 06:15:00.000000',00000000000002908327),('2024-07-05 06:20:00.000000',00000000000002924506),('2024-07-05 06:25:00.000000',00000000000002964206),('2024-07-05 06:30:00.000000',00000000000002959235),('2024-07-05 06:35:00.000000',00000000000002970035),('2024-07-05 06:40:00.000000',00000000000002975035),('2024-07-05 06:45:00.000000',00000000000002979935),('2024-07-05 06:50:00.000000',00000000000003011114),('2024-07-05 06:55:00.000000',00000000000003013103),('2024-07-05 07:00:00.000000',00000000000003033303),('2024-07-05 07:05:00.000000',00000000000003042793),('2024-07-05 07:10:00.000000',00000000000003052191),('2024-07-05 07:15:00.000000',00000000000003079029),('2024-07-05 07:20:00.000000',00000000000003100819),('2024-07-05 07:25:00.000000',00000000000003122188),('2024-07-05 07:30:00.000000',00000000000003129087),('2024-07-05 07:35:00.000000',00000000000003140053),('2024-07-05 07:40:00.000000',00000000000003172923),('2024-07-05 07:45:00.000000',00000000000003197701),('2024-07-05 07:50:00.000000',00000000000003231391),('2024-07-05 07:55:00.000000',00000000000003243390),('2024-07-05 08:00:00.000000',00000000000003237700),('2024-07-05 08:05:00.000000',00000000000003250200),('2024-07-05 08:10:00.000000',00000000000003260000),('2024-07-05 08:15:00.000000',00000000000003264900),('2024-07-05 08:20:00.000000',00000000000003275689),('2024-07-05 08:25:00.000000',00000000000003302189),('2024-07-05 08:30:00.000000',00000000000003306089),('2024-07-05 08:35:00.000000',00000000000003311989),('2024-07-05 08:40:00.000000',00000000000003332778),('2024-07-05 08:45:00.000000',00000000000003377468),('2024-07-05 08:50:00.000000',00000000000003389368),('2024-07-05 08:55:00.000000',00000000000003392568),('2024-07-05 09:00:00.000000',00000000000003409668),('2024-07-05 09:05:00.000000',00000000000003411668),('2024-07-05 09:10:00.000000',00000000000003427368),('2024-07-05 09:15:00.000000',00000000000003436158),('2024-07-05 09:20:00.000000',00000000000003483347),('2024-07-05 09:25:00.000000',00000000000003528836),('2024-07-05 09:30:00.000000',00000000000003554534),('2024-07-05 09:35:00.000000',00000000000003558434),('2024-07-05 09:40:00.000000',00000000000003572234),('2024-07-05 09:45:00.000000',00000000000003578734),('2024-07-05 09:50:00.000000',00000000000003586634),('2024-07-05 09:55:00.000000',00000000000003607332),('2024-07-05 10:00:00.000000',00000000000003607332),('2024-07-05 10:05:00.000000',00000000000003632022),('2024-07-05 10:10:00.000000',00000000000003642912),('2024-07-05 10:15:00.000000',00000000000003648812),('2024-07-05 10:20:00.000000',00000000000003654712),('2024-07-05 10:25:00.000000',00000000000003661612),('2024-07-05 10:30:00.000000',00000000000003676500),('2024-07-05 10:35:00.000000',00000000000003712400),('2024-07-05 10:40:00.000000',00000000000003722289),('2024-07-05 10:45:00.000000',00000000000003723289),('2024-07-05 10:50:00.000000',00000000000003727789),('2024-07-05 10:55:00.000000',00000000000003732689),('2024-07-05 11:00:00.000000',00000000000003736589),('2024-07-05 11:05:00.000000',00000000000003739578),('2024-07-05 11:10:00.000000',00000000000003758178),('2024-07-05 11:15:00.000000',00000000000003777958),('2024-07-05 11:20:00.000000',00000000000003795438),('2024-07-05 11:25:00.000000',00000000000003799438),('2024-07-05 11:30:00.000000',00000000000003801438),('2024-07-05 11:35:00.000000',00000000000003816138),('2024-07-05 11:40:00.000000',00000000000003821138),('2024-07-05 11:45:00.000000',00000000000003835128),('2024-07-05 11:50:00.000000',00000000000003880518),('2024-07-05 11:55:00.000000',00000000000003921408),('2024-07-05 12:00:00.000000',00000000000003952697),('2024-07-05 12:05:00.000000',00000000000003964797),('2024-07-05 12:10:00.000000',00000000000003975586),('2024-07-05 12:15:00.000000',00000000000003983576),('2024-07-05 12:20:00.000000',00000000000003986776),('2024-07-05 12:25:00.000000',00000000000003994966),('2024-07-05 12:30:00.000000',00000000000003992376),('2024-07-05 12:35:00.000000',00000000000004004954),('2024-07-05 12:40:00.000000',00000000000004063844),('2024-07-05 12:45:00.000000',00000000000004078642),('2024-07-05 12:50:00.000000',00000000000004093432),('2024-07-05 12:55:00.000000',00000000000004100032),('2024-07-05 13:00:00.000000',00000000000004122511),('2024-07-05 13:05:00.000000',00000000000004123701),('2024-07-05 13:10:00.000000',00000000000004133601),('2024-07-05 13:15:00.000000',00000000000004142491),('2024-07-05 13:20:00.000000',00000000000004157380),('2024-07-05 13:25:00.000000',00000000000004182970),('2024-07-05 13:30:00.000000',00000000000004192059),('2024-07-05 13:35:00.000000',00000000000004208829),('2024-07-05 13:40:00.000000',00000000000004215718),('2024-07-05 13:45:00.000000',00000000000004227986),('2024-07-05 13:50:00.000000',00000000000004246386),('2024-07-05 13:55:00.000000',00000000000004258975),('2024-07-05 14:00:00.000000',00000000000004278365),('2024-07-05 14:05:00.000000',00000000000004323354),('2024-07-05 14:10:00.000000',00000000000004333620),('2024-07-05 14:15:00.000000',00000000000004360520),('2024-07-05 14:20:00.000000',00000000000004369320),('2024-07-05 14:25:00.000000',00000000000004388109),('2024-07-05 14:30:00.000000',00000000000004402188),('2024-07-05 14:35:00.000000',00000000000004423857),('2024-07-05 14:40:00.000000',00000000000004438137),('2024-07-05 14:45:00.000000',00000000000004529807),('2024-07-05 14:50:00.000000',00000000000004554343),('2024-07-05 14:55:00.000000',00000000000004571243),('2024-07-05 15:00:00.000000',00000000000004620613),('2024-07-05 15:05:00.000000',00000000000004656413),('2024-07-05 15:10:00.000000',00000000000004681771),('2024-07-05 15:15:00.000000',00000000000004701561),('2024-07-05 15:20:00.000000',00000000000004718639),('2024-07-05 15:25:00.000000',00000000000004747908),('2024-07-05 15:30:00.000000',00000000000004784578),('2024-07-05 15:35:00.000000',00000000000004806937),('2024-07-05 15:40:00.000000',00000000000004827235),('2024-07-05 15:45:00.000000',00000000000004883120),('2024-07-05 15:50:00.000000',00000000000004912259),('2024-07-05 15:55:00.000000',00000000000004949746),('2024-07-05 16:00:00.000000',00000000000000000000),('2024-07-05 16:05:00.000000',00000000000000021689),('2024-07-05 16:10:00.000000',00000000000000056477),('2024-07-05 16:15:00.000000',00000000000000120155),('2024-07-05 16:20:00.000000',00000000000000140044),('2024-07-05 16:25:00.000000',00000000000000165042),('2024-07-05 16:30:00.000000',00000000000000192930),('2024-07-05 16:35:00.000000',00000000000000244236),('2024-07-05 16:40:00.000000',00000000000000273815),('2024-07-05 16:45:00.000000',00000000000000293703),('2024-07-05 16:50:00.000000',00000000000000307803),('2024-07-05 16:55:00.000000',00000000000000347192),('2024-07-05 17:00:00.000000',00000000000000370182),('2024-07-05 17:05:00.000000',00000000000000401282),('2024-07-05 17:10:00.000000',00000000000000461570),('2024-07-05 17:15:00.000000',00000000000000492207),('2024-07-05 17:20:00.000000',00000000000000519136),('2024-07-05 17:25:00.000000',00000000000000532325),('2024-07-05 17:30:00.000000',00000000000000586515),('2024-07-05 17:35:00.000000',00000000000000590204),('2024-07-05 17:40:00.000000',00000000000000600294),('2024-07-05 17:45:00.000000',00000000000000614181),('2024-07-05 17:50:00.000000',00000000000000627181),('2024-07-05 17:55:00.000000',00000000000000638571),('2024-07-05 18:00:00.000000',00000000000000661951),('2024-07-05 18:05:00.000000',00000000000000710550),('2024-07-05 18:10:00.000000',00000000000000715139),('2024-07-05 18:15:00.000000',00000000000000726437),('2024-07-05 18:20:00.000000',00000000000000747206),('2024-07-05 18:25:00.000000',00000000000000766494),('2024-07-05 18:30:00.000000',00000000000000792581),('2024-07-05 18:35:00.000000',00000000000000799481),('2024-07-05 18:40:00.000000',00000000000000810060),('2024-07-05 18:45:00.000000',00000000000000824640),('2024-07-05 18:50:00.000000',00000000000000862338),('2024-07-05 18:55:00.000000',00000000000000925118),('2024-07-05 19:00:00.000000',00000000000000946618),('2024-07-05 19:05:00.000000',00000000000000996318),('2024-07-05 19:10:00.000000',00000000000001024818),('2024-07-05 19:15:00.000000',00000000000001031598),('2024-07-05 19:20:00.000000',00000000000001060798),('2024-07-05 19:25:00.000000',00000000000001056564),('2024-07-05 19:30:00.000000',00000000000001063464),('2024-07-05 19:35:00.000000',00000000000001128154),('2024-07-05 19:40:00.000000',00000000000001147044),('2024-07-05 19:45:00.000000',00000000000001150044),('2024-07-05 19:50:00.000000',00000000000001159034),('2024-07-05 19:55:00.000000',00000000000001177723),('2024-07-05 20:00:00.000000',00000000000001179721),('2024-07-05 20:05:00.000000',00000000000001196521),('2024-07-05 20:10:00.000000',00000000000001212321),('2024-07-05 20:15:00.000000',00000000000001229091),('2024-07-05 20:20:00.000000',00000000000001234191),('2024-07-05 20:25:00.000000',00000000000001252991),('2024-07-05 20:30:00.000000',00000000000001265801),('2024-07-05 20:35:00.000000',00000000000001274700),('2024-07-05 20:40:00.000000',00000000000001286600),('2024-07-05 20:45:00.000000',00000000000001300600),('2024-07-05 20:50:00.000000',00000000000001302589),('2024-07-05 20:55:00.000000',00000000000001315489),('2024-07-05 21:00:00.000000',00000000000001321789),('2024-07-05 21:05:00.000000',00000000000001324389),('2024-07-05 21:10:00.000000',00000000000001324789),('2024-07-05 21:15:00.000000',00000000000001328689),('2024-07-05 21:20:00.000000',00000000000001336679),('2024-07-05 21:25:00.000000',00000000000001366769),('2024-07-05 21:30:00.000000',00000000000001378649),('2024-07-05 21:35:00.000000',00000000000001408917),('2024-07-05 21:40:00.000000',00000000000001410517),('2024-07-05 21:45:00.000000',00000000000001410607),('2024-07-05 21:50:00.000000',00000000000001413607),('2024-07-05 21:55:00.000000',00000000000001416605),('2024-07-05 22:00:00.000000',00000000000001426502),('2024-07-05 22:05:00.000000',00000000000001428702),('2024-07-05 22:10:00.000000',00000000000001456102),('2024-07-05 22:15:00.000000',00000000000001458302),('2024-07-05 22:20:00.000000',00000000000001458302),('2024-07-05 22:25:00.000000',00000000000001464202),('2024-07-05 22:30:00.000000',00000000000001464202),('2024-07-05 22:35:00.000000',00000000000001469102),('2024-07-05 22:40:00.000000',00000000000001476202),('2024-07-05 22:45:00.000000',00000000000001483691),('2024-07-05 22:50:00.000000',00000000000001485091),('2024-07-05 22:55:00.000000',00000000000001493679),('2024-07-05 23:00:00.000000',00000000000001497768),('2024-07-05 23:05:00.000000',00000000000001505058),('2024-07-05 23:10:00.000000',00000000000001509858),('2024-07-05 23:15:00.000000',00000000000001512658),('2024-07-05 23:20:00.000000',00000000000001520248),('2024-07-05 23:25:00.000000',00000000000001533238),('2024-07-05 23:30:00.000000',00000000000001583217),('2024-07-05 23:35:00.000000',00000000000001583417),('2024-07-05 23:40:00.000000',00000000000001589117),('2024-07-05 23:45:00.000000',00000000000001596706),('2024-07-05 23:50:00.000000',00000000000001606996),('2024-07-05 23:55:00.000000',00000000000001628696),('2024-07-06 00:00:00.000000',00000000000001642566),('2024-07-06 00:05:00.000000',00000000000001651966),('2024-07-06 00:10:00.000000',00000000000001659966),('2024-07-06 00:15:00.000000',00000000000001670766),('2024-07-06 00:20:00.000000',00000000000001678256),('2024-07-06 00:25:00.000000',00000000000001684245),('2024-07-06 00:30:00.000000',00000000000001691443),('2024-07-06 00:35:00.000000',00000000000001699443),('2024-07-06 00:40:00.000000',00000000000001716543),('2024-07-06 00:45:00.000000',00000000000001733132),('2024-07-06 00:50:00.000000',00000000000001736432),('2024-07-06 00:55:00.000000',00000000000001744232),('2024-07-06 01:00:00.000000',00000000000001745232),('2024-07-06 01:05:00.000000',00000000000001757522),('2024-07-06 01:10:00.000000',00000000000001774301),('2024-07-06 01:15:00.000000',00000000000001778401),('2024-07-06 01:20:00.000000',00000000000001778401),('2024-07-06 01:25:00.000000',00000000000001789601),('2024-07-06 01:30:00.000000',00000000000001792599),('2024-07-06 01:35:00.000000',00000000000001795488),('2024-07-06 01:40:00.000000',00000000000001806377),('2024-07-06 01:45:00.000000',00000000000001815177),('2024-07-06 01:50:00.000000',00000000000001817966),('2024-07-06 01:55:00.000000',00000000000001838014),('2024-07-06 02:00:00.000000',00000000000001838214),('2024-07-06 02:05:00.000000',00000000000001838214),('2024-07-06 02:10:00.000000',00000000000001849103),('2024-07-06 02:15:00.000000',00000000000001849903),('2024-07-06 02:20:00.000000',00000000000001857793),('2024-07-06 02:25:00.000000',00000000000001863693),('2024-07-06 02:30:00.000000',00000000000001865693),('2024-07-06 02:35:00.000000',00000000000001893272),('2024-07-06 02:40:00.000000',00000000000001895462),('2024-07-06 02:45:00.000000',00000000000001905462),('2024-07-06 02:50:00.000000',00000000000001919130),('2024-07-06 02:55:00.000000',00000000000001923030),('2024-07-06 03:00:00.000000',00000000000001923030),('2024-07-06 03:05:00.000000',00000000000001926930),('2024-07-06 03:10:00.000000',00000000000001932030),('2024-07-06 03:15:00.000000',00000000000001937320),('2024-07-06 03:20:00.000000',00000000000001951107),('2024-07-06 03:25:00.000000',00000000000001958107),('2024-07-06 03:30:00.000000',00000000000001961007),('2024-07-06 03:35:00.000000',00000000000001969807),('2024-07-06 03:40:00.000000',00000000000001977707),('2024-07-06 03:45:00.000000',00000000000001982507),('2024-07-06 03:50:00.000000',00000000000001988396),('2024-07-06 03:55:00.000000',00000000000002000196),('2024-07-06 04:00:00.000000',00000000000002012286),('2024-07-06 04:05:00.000000',00000000000002018186),('2024-07-06 04:10:00.000000',00000000000002029276),('2024-07-06 04:15:00.000000',00000000000002029276),('2024-07-06 04:20:00.000000',00000000000002036176),('2024-07-06 04:25:00.000000',00000000000002049246),('2024-07-06 04:30:00.000000',00000000000002061936),('2024-07-06 04:35:00.000000',00000000000002099936),('2024-07-06 04:40:00.000000',00000000000002147716),('2024-07-06 04:45:00.000000',00000000000002174276),('2024-07-06 04:50:00.000000',00000000000002181284),('2024-07-06 04:55:00.000000',00000000000002196164),('2024-07-06 05:00:00.000000',00000000000002210864),('2024-07-06 05:05:00.000000',00000000000002214864),('2024-07-06 05:10:00.000000',00000000000002220864),('2024-07-06 05:15:00.000000',00000000000002223964),('2024-07-06 05:20:00.000000',00000000000002225953),('2024-07-06 05:25:00.000000',00000000000002230653),('2024-07-06 05:30:00.000000',00000000000002237642),('2024-07-06 05:35:00.000000',00000000000002535432),('2024-07-06 05:40:00.000000',00000000000002547911),('2024-07-06 05:45:00.000000',00000000000002560880),('2024-07-06 05:50:00.000000',00000000000002575518),('2024-07-06 05:55:00.000000',00000000000002598788),('2024-07-06 06:00:00.000000',00000000000002638378),('2024-07-06 06:05:00.000000',00000000000002646869),('2024-07-06 06:10:00.000000',00000000000002657138),('2024-07-06 06:15:00.000000',00000000000002688856),('2024-07-06 06:20:00.000000',00000000000002706475),('2024-07-06 06:25:00.000000',00000000000002712375),('2024-07-06 06:30:00.000000',00000000000002740313),('2024-07-06 06:35:00.000000',00000000000002776492),('2024-07-06 06:40:00.000000',00000000000002799392),('2024-07-06 06:45:00.000000',00000000000002806492),('2024-07-06 06:50:00.000000',00000000000002813381),('2024-07-06 06:55:00.000000',00000000000002828861),('2024-07-06 07:00:00.000000',00000000000002830161),('2024-07-06 07:05:00.000000',00000000000002835061),('2024-07-06 07:10:00.000000',00000000000002845061),('2024-07-06 07:15:00.000000',00000000000002888151),('2024-07-06 07:20:00.000000',00000000000002907220),('2024-07-06 07:25:00.000000',00000000000002910199),('2024-07-06 07:30:00.000000',00000000000002920667),('2024-07-06 07:35:00.000000',00000000000002939406),('2024-07-06 07:40:00.000000',00000000000002946386),('2024-07-06 07:45:00.000000',00000000000002971313),('2024-07-06 07:50:00.000000',00000000000003007119),('2024-07-06 07:55:00.000000',00000000000003016737),('2024-07-06 08:00:00.000000',00000000000003023797),('2024-07-06 08:05:00.000000',00000000000003044767),('2024-07-06 08:10:00.000000',00000000000003069715),('2024-07-06 08:15:00.000000',00000000000003096384),('2024-07-06 08:20:00.000000',00000000000003093584),('2024-07-06 08:25:00.000000',00000000000003110426),('2024-07-06 08:30:00.000000',00000000000003137495),('2024-07-06 08:35:00.000000',00000000000003181491),('2024-07-06 08:40:00.000000',00000000000003188581),('2024-07-06 08:45:00.000000',00000000000003188581),('2024-07-06 08:50:00.000000',00000000000003199781),('2024-07-06 08:55:00.000000',00000000000003213871),('2024-07-06 09:00:00.000000',00000000000003239221),('2024-07-06 09:05:00.000000',00000000000003258101),('2024-07-06 09:10:00.000000',00000000000003270979),('2024-07-06 09:15:00.000000',00000000000003288737),('2024-07-06 09:20:00.000000',00000000000003296627),('2024-07-06 09:25:00.000000',00000000000003333487),('2024-07-06 09:30:00.000000',00000000000003347357),('2024-07-06 09:35:00.000000',00000000000003366526),('2024-07-06 09:40:00.000000',00000000000003381496),('2024-07-06 09:45:00.000000',00000000000003395475),('2024-07-06 09:50:00.000000',00000000000003404275),('2024-07-06 09:55:00.000000',00000000000003418244),('2024-07-06 10:00:00.000000',00000000000003427622),('2024-07-06 10:05:00.000000',00000000000003481321),('2024-07-06 10:10:00.000000',00000000000003497189),('2024-07-06 10:15:00.000000',00000000000003523125),('2024-07-06 10:20:00.000000',00000000000003536812),('2024-07-06 10:25:00.000000',00000000000003583501),('2024-07-06 10:30:00.000000',00000000000003658291),('2024-07-06 10:35:00.000000',00000000000003660201),('2024-07-06 10:40:00.000000',00000000000003674590),('2024-07-06 10:45:00.000000',00000000000003691870),('2024-07-06 10:50:00.000000',00000000000003705770),('2024-07-06 10:55:00.000000',00000000000003727449),('2024-07-06 11:00:00.000000',00000000000003743139),('2024-07-06 11:05:00.000000',00000000000003750628),('2024-07-06 11:10:00.000000',00000000000003772127),('2024-07-06 11:15:00.000000',00000000000003777116),('2024-07-06 11:20:00.000000',00000000000003791916),('2024-07-06 11:25:00.000000',00000000000003836816),('2024-07-06 11:30:00.000000',00000000000003863506),('2024-07-06 11:35:00.000000',00000000000003881296),('2024-07-06 11:40:00.000000',00000000000003895664),('2024-07-06 11:45:00.000000',00000000000003901653),('2024-07-06 11:50:00.000000',00000000000003926710),('2024-07-06 11:55:00.000000',00000000000003929310),('2024-07-06 12:00:00.000000',00000000000003963500),('2024-07-06 12:05:00.000000',00000000000003987899),('2024-07-06 12:10:00.000000',00000000000003996887),('2024-07-06 12:15:00.000000',00000000000003997387),('2024-07-06 12:20:00.000000',00000000000004006477),('2024-07-06 12:25:00.000000',00000000000004014277),('2024-07-06 12:30:00.000000',00000000000004030167),('2024-07-06 12:35:00.000000',00000000000004036067),('2024-07-06 12:40:00.000000',00000000000004047867),('2024-07-06 12:45:00.000000',00000000000004049865),('2024-07-06 12:50:00.000000',00000000000004053365),('2024-07-06 12:55:00.000000',00000000000004075944),('2024-07-06 13:00:00.000000',00000000000004104734),('2024-07-06 13:05:00.000000',00000000000004120234),('2024-07-06 13:10:00.000000',00000000000004132623),('2024-07-06 13:15:00.000000',00000000000004150513),('2024-07-06 13:20:00.000000',00000000000004166391),('2024-07-06 13:25:00.000000',00000000000004175991),('2024-07-06 13:30:00.000000',00000000000004180091),('2024-07-06 13:35:00.000000',00000000000004193881),('2024-07-06 13:40:00.000000',00000000000004219660),('2024-07-06 13:45:00.000000',00000000000004221558),('2024-07-06 13:50:00.000000',00000000000004229937),('2024-07-06 13:55:00.000000',00000000000004266827),('2024-07-06 14:00:00.000000',00000000000004309155),('2024-07-06 14:05:00.000000',00000000000004330824),('2024-07-06 14:10:00.000000',00000000000004367604),('2024-07-06 14:15:00.000000',00000000000004337714),('2024-07-06 14:20:00.000000',00000000000004333993),('2024-07-06 14:25:00.000000',00000000000004340672),('2024-07-06 14:30:00.000000',00000000000004348872),('2024-07-06 14:35:00.000000',00000000000004368262),('2024-07-06 14:40:00.000000',00000000000004370262),('2024-07-06 14:45:00.000000',00000000000004396792),('2024-07-06 14:50:00.000000',00000000000004423440),('2024-07-06 14:55:00.000000',00000000000004485309),('2024-07-06 15:00:00.000000',00000000000004499109),('2024-07-06 15:05:00.000000',00000000000004507088),('2024-07-06 15:10:00.000000',00000000000004533668),('2024-07-06 15:15:00.000000',00000000000004541979),('2024-07-06 15:20:00.000000',00000000000004755959),('2024-07-06 15:25:00.000000',00000000000004798307),('2024-07-06 15:30:00.000000',00000000000004859065),('2024-07-06 15:35:00.000000',00000000000004891813),('2024-07-06 15:40:00.000000',00000000000004944583),('2024-07-06 15:45:00.000000',00000000000004965641),('2024-07-06 15:50:00.000000',00000000000004969841),('2024-07-06 15:55:00.000000',00000000000004995631),('2024-07-06 16:00:00.000000',00000000000000000000),('2024-07-06 16:05:00.000000',00000000000000026600),('2024-07-06 16:10:00.000000',00000000000000086760),('2024-07-06 16:15:00.000000',00000000000000146239),('2024-07-06 16:20:00.000000',00000000000000159519),('2024-07-06 16:25:00.000000',00000000000000190519),('2024-07-06 16:30:00.000000',00000000000000241788),('2024-07-06 16:35:00.000000',00000000000000341363),('2024-07-06 16:40:00.000000',00000000000000412920),('2024-07-06 16:45:00.000000',00000000000000464318),('2024-07-06 16:50:00.000000',00000000000000564845),('2024-07-06 16:55:00.000000',00000000000000608094),('2024-07-06 17:00:00.000000',00000000000000655964),('2024-07-06 17:05:00.000000',00000000000000682663),('2024-07-06 17:10:00.000000',00000000000000705061),('2024-07-06 17:15:00.000000',00000000000000740960),('2024-07-06 17:20:00.000000',00000000000000759960),('2024-07-06 17:25:00.000000',00000000000000784860),('2024-07-06 17:30:00.000000',00000000000000803530),('2024-07-06 17:35:00.000000',00000000000000867420),('2024-07-06 17:40:00.000000',00000000000000895799),('2024-07-06 17:45:00.000000',00000000000000914788),('2024-07-06 17:50:00.000000',00000000000000921988),('2024-07-06 17:55:00.000000',00000000000000945988),('2024-07-06 18:00:00.000000',00000000000000970488),('2024-07-06 18:05:00.000000',00000000000001006066),('2024-07-06 18:10:00.000000',00000000000001032067),('2024-07-06 18:15:00.000000',00000000000001041656),('2024-07-06 18:20:00.000000',00000000000001064145),('2024-07-06 18:25:00.000000',00000000000001074745),('2024-07-06 18:30:00.000000',00000000000001081345),('2024-07-06 18:35:00.000000',00000000000001099135),('2024-07-06 18:40:00.000000',00000000000001116335),('2024-07-06 18:45:00.000000',00000000000001133525),('2024-07-06 18:50:00.000000',00000000000001154414),('2024-07-06 18:55:00.000000',00000000000001455014),('2024-07-06 19:00:00.000000',00000000000001464814),('2024-07-06 19:05:00.000000',00000000000001471814),('2024-07-06 19:10:00.000000',00000000000001482914),('2024-07-06 19:15:00.000000',00000000000001497614),('2024-07-06 19:20:00.000000',00000000000001498014),('2024-07-06 19:25:00.000000',00000000000001545814),('2024-07-06 19:30:00.000000',00000000000001547014),('2024-07-06 19:35:00.000000',00000000000001561904),('2024-07-06 19:40:00.000000',00000000000001562904),('2024-07-06 19:45:00.000000',00000000000001587692),('2024-07-06 19:50:00.000000',00000000000001589690),('2024-07-06 19:55:00.000000',00000000000001596579),('2024-07-06 20:00:00.000000',00000000000001606278),('2024-07-06 20:05:00.000000',00000000000001632136),('2024-07-06 20:10:00.000000',00000000000001645915),('2024-07-06 20:15:00.000000',00000000000001642904),('2024-07-06 20:20:00.000000',00000000000001650801),('2024-07-06 20:25:00.000000',00000000000001653991),('2024-07-06 20:30:00.000000',00000000000001654591),('2024-07-06 20:35:00.000000',00000000000001662791),('2024-07-06 20:40:00.000000',00000000000001667591),('2024-07-06 20:45:00.000000',00000000000001680491),('2024-07-06 20:50:00.000000',00000000000001693281),('2024-07-06 20:55:00.000000',00000000000001695681),('2024-07-06 21:00:00.000000',00000000000001706780),('2024-07-06 21:05:00.000000',00000000000001719880),('2024-07-06 21:10:00.000000',00000000000001722869),('2024-07-06 21:15:00.000000',00000000000001728858),('2024-07-06 21:20:00.000000',00000000000001729858),('2024-07-06 21:25:00.000000',00000000000001729858),('2024-07-06 21:30:00.000000',00000000000001729858),('2024-07-06 21:35:00.000000',00000000000001734758),('2024-07-06 21:40:00.000000',00000000000001734758),('2024-07-06 21:45:00.000000',00000000000001741647),('2024-07-06 21:50:00.000000',00000000000001741647),('2024-07-06 21:55:00.000000',00000000000001747547),('2024-07-06 22:00:00.000000',00000000000001750248),('2024-07-06 22:05:00.000000',00000000000001750248),('2024-07-06 22:10:00.000000',00000000000001750248),('2024-07-06 22:15:00.000000',00000000000001759248),('2024-07-06 22:20:00.000000',00000000000001763148),('2024-07-06 22:25:00.000000',00000000000001763148),('2024-07-06 22:30:00.000000',00000000000001771138),('2024-07-06 22:35:00.000000',00000000000001772238),('2024-07-06 22:40:00.000000',00000000000001772238),('2024-07-06 22:45:00.000000',00000000000001772838),('2024-07-06 22:50:00.000000',00000000000001777838),('2024-07-06 22:55:00.000000',00000000000001793215),('2024-07-06 23:00:00.000000',00000000000001793215),('2024-07-06 23:05:00.000000',00000000000001800015),('2024-07-06 23:10:00.000000',00000000000001807205),('2024-07-06 23:15:00.000000',00000000000001813295),('2024-07-06 23:20:00.000000',00000000000001833085),('2024-07-06 23:25:00.000000',00000000000001833385),('2024-07-06 23:30:00.000000',00000000000001844385),('2024-07-06 23:35:00.000000',00000000000001858275),('2024-07-06 23:40:00.000000',00000000000001863175),('2024-07-06 23:45:00.000000',00000000000001893075),('2024-07-06 23:50:00.000000',00000000000001901065),('2024-07-06 23:55:00.000000',00000000000001911863),('2024-07-07 00:00:00.000000',00000000000001922753),('2024-07-07 00:05:00.000000',00000000000001926753),('2024-07-07 00:10:00.000000',00000000000001934743),('2024-07-07 00:15:00.000000',00000000000001941643),('2024-07-07 00:20:00.000000',00000000000001949533),('2024-07-07 00:25:00.000000',00000000000001985123),('2024-07-07 00:30:00.000000',00000000000002009002),('2024-07-07 00:35:00.000000',00000000000002041770),('2024-07-07 00:40:00.000000',00000000000002049670),('2024-07-07 00:45:00.000000',00000000000002059381),('2024-07-07 00:50:00.000000',00000000000002084720),('2024-07-07 00:55:00.000000',00000000000002095120),('2024-07-07 01:00:00.000000',00000000000002104020),('2024-07-07 01:05:00.000000',00000000000002113220),('2024-07-07 01:10:00.000000',00000000000002133918),('2024-07-07 01:15:00.000000',00000000000002142807),('2024-07-07 01:20:00.000000',00000000000002147797),('2024-07-07 01:25:00.000000',00000000000002184897),('2024-07-07 01:30:00.000000',00000000000002215887),('2024-07-07 01:35:00.000000',00000000000002225776),('2024-07-07 01:40:00.000000',00000000000002230276),('2024-07-07 01:45:00.000000',00000000000002242074),('2024-07-07 01:50:00.000000',00000000000002283452),('2024-07-07 01:55:00.000000',00000000000002311018),('2024-07-07 02:00:00.000000',00000000000002324606),('2024-07-07 02:05:00.000000',00000000000002329606),('2024-07-07 02:10:00.000000',00000000000002342674),('2024-07-07 02:15:00.000000',00000000000002347774),('2024-07-07 02:20:00.000000',00000000000002363574),('2024-07-07 02:25:00.000000',00000000000002416574),('2024-07-07 02:30:00.000000',00000000000002437263),('2024-07-07 02:35:00.000000',00000000000002457441),('2024-07-07 02:40:00.000000',00000000000002467420),('2024-07-07 02:45:00.000000',00000000000002489309),('2024-07-07 02:50:00.000000',00000000000002499509),('2024-07-07 02:55:00.000000',00000000000002499509),('2024-07-07 03:00:00.000000',00000000000002509476),('2024-07-07 03:05:00.000000',00000000000002514944),('2024-07-07 03:10:00.000000',00000000000002531923),('2024-07-07 03:15:00.000000',00000000000002531923),('2024-07-07 03:20:00.000000',00000000000002537323),('2024-07-07 03:25:00.000000',00000000000002549412),('2024-07-07 03:30:00.000000',00000000000002593292),('2024-07-07 03:35:00.000000',00000000000002621582),('2024-07-07 03:40:00.000000',00000000000002630171),('2024-07-07 03:45:00.000000',00000000000002637248),('2024-07-07 03:50:00.000000',00000000000002663627),('2024-07-07 03:55:00.000000',00000000000002680171),('2024-07-07 04:00:00.000000',00000000000002694350),('2024-07-07 04:05:00.000000',00000000000002698339),('2024-07-07 04:10:00.000000',00000000000002706317),('2024-07-07 04:15:00.000000',00000000000002717217),('2024-07-07 04:20:00.000000',00000000000002723217),('2024-07-07 04:25:00.000000',00000000000002727217),('2024-07-07 04:30:00.000000',00000000000002745385),('2024-07-07 04:35:00.000000',00000000000002753385),('2024-07-07 04:40:00.000000',00000000000002770985),('2024-07-07 04:45:00.000000',00000000000002786774),('2024-07-07 04:50:00.000000',00000000000002849363),('2024-07-07 04:55:00.000000',00000000000002862363),('2024-07-07 05:00:00.000000',00000000000002875132),('2024-07-07 05:05:00.000000',00000000000002912521),('2024-07-07 05:10:00.000000',00000000000003230300),('2024-07-07 05:15:00.000000',00000000000003245580),('2024-07-07 05:20:00.000000',00000000000003268770),('2024-07-07 05:25:00.000000',00000000000003271668),('2024-07-07 05:30:00.000000',00000000000003324768),('2024-07-07 05:35:00.000000',00000000000003346618),('2024-07-07 05:40:00.000000',00000000000003359418),('2024-07-07 05:45:00.000000',00000000000003362607),('2024-07-07 05:50:00.000000',00000000000003369707),('2024-07-07 05:55:00.000000',00000000000003372007),('2024-07-07 06:00:00.000000',00000000000003385987),('2024-07-07 06:05:00.000000',00000000000003415835),('2024-07-07 06:10:00.000000',00000000000003429824),('2024-07-07 06:15:00.000000',00000000000003450690),('2024-07-07 06:20:00.000000',00000000000003522490),('2024-07-07 06:25:00.000000',00000000000003531780),('2024-07-07 06:30:00.000000',00000000000003548559),('2024-07-07 06:35:00.000000',00000000000003555209),('2024-07-07 06:40:00.000000',00000000000003563087),('2024-07-07 06:45:00.000000',00000000000003566977),('2024-07-07 06:50:00.000000',00000000000003591739),('2024-07-07 06:55:00.000000',00000000000003608597),('2024-07-07 07:00:00.000000',00000000000003642475),('2024-07-07 07:05:00.000000',00000000000003661065),('2024-07-07 07:10:00.000000',00000000000003680765),('2024-07-07 07:15:00.000000',00000000000003683154),('2024-07-07 07:20:00.000000',00000000000003698142),('2024-07-07 07:25:00.000000',00000000000003761420),('2024-07-07 07:30:00.000000',00000000000003777289),('2024-07-07 07:35:00.000000',00000000000003781968),('2024-07-07 07:40:00.000000',00000000000003791058),('2024-07-07 07:45:00.000000',00000000000003801858),('2024-07-07 07:50:00.000000',00000000000003908738),('2024-07-07 07:55:00.000000',00000000000003921636),('2024-07-07 08:00:00.000000',00000000000003935216),('2024-07-07 08:05:00.000000',00000000000003963275),('2024-07-07 08:10:00.000000',00000000000003965375),('2024-07-07 08:15:00.000000',00000000000003966375),('2024-07-07 08:20:00.000000',00000000000003977563),('2024-07-07 08:25:00.000000',00000000000003987542),('2024-07-07 08:30:00.000000',00000000000003996520),('2024-07-07 08:35:00.000000',00000000000004034548),('2024-07-07 08:40:00.000000',00000000000004040745),('2024-07-07 08:45:00.000000',00000000000004057512),('2024-07-07 08:50:00.000000',00000000000004082212),('2024-07-07 08:55:00.000000',00000000000004106182),('2024-07-07 09:00:00.000000',00000000000004111062),('2024-07-07 09:05:00.000000',00000000000004123832),('2024-07-07 09:10:00.000000',00000000000004149521),('2024-07-07 09:15:00.000000',00000000000004180821),('2024-07-07 09:20:00.000000',00000000000004203600),('2024-07-07 09:25:00.000000',00000000000004215400),('2024-07-07 09:30:00.000000',00000000000004250680),('2024-07-07 09:35:00.000000',00000000000004266647),('2024-07-07 09:40:00.000000',00000000000004275127),('2024-07-07 09:45:00.000000',00000000000004288476),('2024-07-07 09:50:00.000000',00000000000004306463),('2024-07-07 09:55:00.000000',00000000000004342061),('2024-07-07 10:00:00.000000',00000000000004363850),('2024-07-07 10:05:00.000000',00000000000004382439),('2024-07-07 10:10:00.000000',00000000000004395929),('2024-07-07 10:15:00.000000',00000000000004411519),('2024-07-07 10:20:00.000000',00000000000004434598),('2024-07-07 10:25:00.000000',00000000000004460598),('2024-07-07 10:30:00.000000',00000000000004501288),('2024-07-07 10:35:00.000000',00000000000004511088),('2024-07-07 10:40:00.000000',00000000000004518878),('2024-07-07 10:45:00.000000',00000000000004522838),('2024-07-07 10:50:00.000000',00000000000004546596),('2024-07-07 10:55:00.000000',00000000000004546596),('2024-07-07 11:00:00.000000',00000000000004551586),('2024-07-07 11:05:00.000000',00000000000004574366),('2024-07-07 11:10:00.000000',00000000000004578566),('2024-07-07 11:15:00.000000',00000000000004595354),('2024-07-07 11:20:00.000000',00000000000004598743),('2024-07-07 11:25:00.000000',00000000000004618643),('2024-07-07 11:30:00.000000',00000000000004622543),('2024-07-07 11:35:00.000000',00000000000004627241),('2024-07-07 11:40:00.000000',00000000000004628241),('2024-07-07 11:45:00.000000',00000000000004630239),('2024-07-07 11:50:00.000000',00000000000004641029),('2024-07-07 11:55:00.000000',00000000000004653129),('2024-07-07 12:00:00.000000',00000000000004689926),('2024-07-07 12:05:00.000000',00000000000004704214),('2024-07-07 12:10:00.000000',00000000000004720813),('2024-07-07 12:15:00.000000',00000000000004735471),('2024-07-07 12:20:00.000000',00000000000004745371),('2024-07-07 12:25:00.000000',00000000000004757351),('2024-07-07 12:30:00.000000',00000000000004778039),('2024-07-07 12:35:00.000000',00000000000004805508),('2024-07-07 12:40:00.000000',00000000000004821606),('2024-07-07 12:45:00.000000',00000000000005121496),('2024-07-07 12:50:00.000000',00000000000005133466),('2024-07-07 12:55:00.000000',00000000000005145442),('2024-07-07 13:00:00.000000',00000000000005153932),('2024-07-07 13:05:00.000000',00000000000005164389),('2024-07-07 13:10:00.000000',00000000000005175638),('2024-07-07 13:15:00.000000',00000000000005189636),('2024-07-07 13:20:00.000000',00000000000005149236),('2024-07-07 13:25:00.000000',00000000000005173316),('2024-07-07 13:30:00.000000',00000000000005174316),('2024-07-07 13:35:00.000000',00000000000005180205),('2024-07-07 13:40:00.000000',00000000000005187203),('2024-07-07 13:45:00.000000',00000000000005193182),('2024-07-07 13:50:00.000000',00000000000005220971),('2024-07-07 13:55:00.000000',00000000000005252339),('2024-07-07 14:00:00.000000',00000000000005268409),('2024-07-07 14:05:00.000000',00000000000005281705),('2024-07-07 14:10:00.000000',00000000000005295593),('2024-07-07 14:15:00.000000',00000000000005319379),('2024-07-07 14:20:00.000000',00000000000005344917),('2024-07-07 14:25:00.000000',00000000000005363191),('2024-07-07 14:30:00.000000',00000000000005402749),('2024-07-07 14:35:00.000000',00000000000005434798),('2024-07-07 14:40:00.000000',00000000000005444777),('2024-07-07 14:45:00.000000',00000000000005472947),('2024-07-07 14:50:00.000000',00000000000005529834),('2024-07-07 14:55:00.000000',00000000000005546813),('2024-07-07 15:00:00.000000',00000000000005573813),('2024-07-07 15:05:00.000000',00000000000005601013),('2024-07-07 15:10:00.000000',00000000000005608013),('2024-07-07 15:15:00.000000',00000000000005621813),('2024-07-07 15:20:00.000000',00000000000005634411),('2024-07-07 15:25:00.000000',00000000000005641309),('2024-07-07 15:30:00.000000',00000000000005662908),('2024-07-07 15:35:00.000000',00000000000005690998),('2024-07-07 15:40:00.000000',00000000000005718677),('2024-07-07 15:45:00.000000',00000000000005733067),('2024-07-07 15:50:00.000000',00000000000005743767),('2024-07-07 15:55:00.000000',00000000000005763206),('2024-07-07 16:00:00.000000',00000000000000000000),('2024-07-07 16:05:00.000000',00000000000000023095),('2024-07-07 16:10:00.000000',00000000000000033595),('2024-07-07 16:15:00.000000',00000000000000058955),('2024-07-07 16:20:00.000000',00000000000000077645),('2024-07-07 16:25:00.000000',00000000000000124020),('2024-07-07 16:30:00.000000',00000000000000151879),('2024-07-07 16:35:00.000000',00000000000000190049),('2024-07-07 16:40:00.000000',00000000000000230519),('2024-07-07 16:45:00.000000',00000000000000286209),('2024-07-07 16:50:00.000000',00000000000000327597),('2024-07-07 16:55:00.000000',00000000000000389351),('2024-07-07 17:00:00.000000',00000000000000445451),('2024-07-07 17:05:00.000000',00000000000000491541),('2024-07-07 17:10:00.000000',00000000000000514729),('2024-07-07 17:15:00.000000',00000000000000549019),('2024-07-07 17:20:00.000000',00000000000000599508),('2024-07-07 17:25:00.000000',00000000000000613697),('2024-07-07 17:30:00.000000',00000000000000633586),('2024-07-07 17:35:00.000000',00000000000000652182),('2024-07-07 17:40:00.000000',00000000000000682962),('2024-07-07 17:45:00.000000',00000000000000743262),('2024-07-07 17:50:00.000000',00000000000000746762),('2024-07-07 17:55:00.000000',00000000000000771952),('2024-07-07 18:00:00.000000',00000000000000782551),('2024-07-07 18:05:00.000000',00000000000000817840),('2024-07-07 18:10:00.000000',00000000000000849819),('2024-07-07 18:15:00.000000',00000000000000863108),('2024-07-07 18:20:00.000000',00000000000000879708),('2024-07-07 18:25:00.000000',00000000000000901098),('2024-07-07 18:30:00.000000',00000000000000907096),('2024-07-07 18:35:00.000000',00000000000000929886),('2024-07-07 18:40:00.000000',00000000000000933886),('2024-07-07 18:45:00.000000',00000000000000940286),('2024-07-07 18:50:00.000000',00000000000000944586),('2024-07-07 18:55:00.000000',00000000000000952955),('2024-07-07 19:00:00.000000',00000000000000958553),('2024-07-07 19:05:00.000000',00000000000000968453),('2024-07-07 19:10:00.000000',00000000000000982641),('2024-07-07 19:15:00.000000',00000000000000984641),('2024-07-07 19:20:00.000000',00000000000000994639),('2024-07-07 19:25:00.000000',00000000000001022229),('2024-07-07 19:30:00.000000',00000000000001023229),('2024-07-07 19:35:00.000000',00000000000001027909),('2024-07-07 19:40:00.000000',00000000000001050807),('2024-07-07 19:45:00.000000',00000000000001053407),('2024-07-07 19:50:00.000000',00000000000001053407),('2024-07-07 19:55:00.000000',00000000000001055407),('2024-07-07 20:00:00.000000',00000000000001055407),('2024-07-07 20:05:00.000000',00000000000001055407),('2024-07-07 20:10:00.000000',00000000000001055407),('2024-07-07 20:15:00.000000',00000000000001063403),('2024-07-07 20:20:00.000000',00000000000001063403),('2024-07-07 20:25:00.000000',00000000000001078281),('2024-07-07 20:30:00.000000',00000000000001088271),('2024-07-07 20:35:00.000000',00000000000001087171),('2024-07-07 20:40:00.000000',00000000000001097871),('2024-07-07 20:45:00.000000',00000000000001097871),('2024-07-07 20:50:00.000000',00000000000001100871),('2024-07-07 20:55:00.000000',00000000000001101871),('2024-07-07 21:00:00.000000',00000000000001104771),('2024-07-07 21:05:00.000000',00000000000001107671),('2024-07-07 21:10:00.000000',00000000000001118461),('2024-07-07 21:15:00.000000',00000000000001126039),('2024-07-07 21:20:00.000000',00000000000001138818),('2024-07-07 21:25:00.000000',00000000000001158618),('2024-07-07 21:30:00.000000',00000000000001159618),('2024-07-07 21:35:00.000000',00000000000001156816),('2024-07-07 21:40:00.000000',00000000000001160805),('2024-07-07 21:45:00.000000',00000000000001195295),('2024-07-07 21:50:00.000000',00000000000001195595),('2024-07-07 21:55:00.000000',00000000000001223162),('2024-07-07 22:00:00.000000',00000000000001228040),('2024-07-07 22:05:00.000000',00000000000001228240),('2024-07-07 22:10:00.000000',00000000000001230238),('2024-07-07 22:15:00.000000',00000000000001230238),('2024-07-07 22:20:00.000000',00000000000001233138),('2024-07-07 22:25:00.000000',00000000000001234137),('2024-07-07 22:30:00.000000',00000000000001234137),('2024-07-07 22:35:00.000000',00000000000001235137),('2024-07-07 22:40:00.000000',00000000000001235137),('2024-07-07 22:45:00.000000',00000000000001250027),('2024-07-07 22:50:00.000000',00000000000001250027),('2024-07-07 22:55:00.000000',00000000000001254927),('2024-07-07 23:00:00.000000',00000000000001262924),('2024-07-07 23:05:00.000000',00000000000001262924),('2024-07-07 23:10:00.000000',00000000000001266913),('2024-07-07 23:15:00.000000',00000000000001285583),('2024-07-07 23:20:00.000000',00000000000001285583),('2024-07-07 23:25:00.000000',00000000000001285583),('2024-07-07 23:30:00.000000',00000000000001292573),('2024-07-07 23:35:00.000000',00000000000001296563),('2024-07-07 23:40:00.000000',00000000000001299563),('2024-07-07 23:45:00.000000',00000000000001301563),('2024-07-07 23:50:00.000000',00000000000001321343),('2024-07-07 23:55:00.000000',00000000000001321343),('2024-07-08 00:00:00.000000',00000000000001328241),('2024-07-08 00:05:00.000000',00000000000001337441),('2024-07-08 00:10:00.000000',00000000000001338640),('2024-07-08 00:15:00.000000',00000000000001352539),('2024-07-08 00:20:00.000000',00000000000001360437),('2024-07-08 00:25:00.000000',00000000000001369425),('2024-07-08 00:30:00.000000',00000000000001374423),('2024-07-08 00:35:00.000000',00000000000001381123),('2024-07-08 00:40:00.000000',00000000000001412603),('2024-07-08 00:45:00.000000',00000000000001427103),('2024-07-08 00:50:00.000000',00000000000001435992),('2024-07-08 00:55:00.000000',00000000000001441982),('2024-07-08 01:00:00.000000',00000000000001502672),('2024-07-08 01:05:00.000000',00000000000001534372),('2024-07-08 01:10:00.000000',00000000000001545170),('2024-07-08 01:15:00.000000',00000000000001549560),('2024-07-08 01:20:00.000000',00000000000001558360),('2024-07-08 01:25:00.000000',00000000000001558360),('2024-07-08 01:30:00.000000',00000000000001574060),('2024-07-08 01:35:00.000000',00000000000001576060),('2024-07-08 01:40:00.000000',00000000000001580059),('2024-07-08 01:45:00.000000',00000000000001594859),('2024-07-08 01:50:00.000000',00000000000001608737),('2024-07-08 01:55:00.000000',00000000000001628536),('2024-07-08 02:00:00.000000',00000000000001631534),('2024-07-08 02:05:00.000000',00000000000001674823),('2024-07-08 02:10:00.000000',00000000000001678821),('2024-07-08 02:15:00.000000',00000000000001679821),('2024-07-08 02:20:00.000000',00000000000001694788),('2024-07-08 02:25:00.000000',00000000000001696777),('2024-07-08 02:30:00.000000',00000000000001752467),('2024-07-08 02:35:00.000000',00000000000001761016),('2024-07-08 02:40:00.000000',00000000000001776616),('2024-07-08 02:45:00.000000',00000000000001776616),('2024-07-08 02:50:00.000000',00000000000001786516),('2024-07-08 02:55:00.000000',00000000000001789614),('2024-07-08 03:00:00.000000',00000000000001817004),('2024-07-08 03:05:00.000000',00000000000001831094),('2024-07-08 03:10:00.000000',00000000000001837073),('2024-07-08 03:15:00.000000',00000000000001855041),('2024-07-08 03:20:00.000000',00000000000001881046),('2024-07-08 03:25:00.000000',00000000000001886946),('2024-07-08 03:30:00.000000',00000000000001888146),('2024-07-08 03:35:00.000000',00000000000001904034),('2024-07-08 03:40:00.000000',00000000000001924824),('2024-07-08 03:45:00.000000',00000000000001926813),('2024-07-08 03:50:00.000000',00000000000001927813),('2024-07-08 03:55:00.000000',00000000000001955891),('2024-07-08 04:00:00.000000',00000000000001972091),('2024-07-08 04:05:00.000000',00000000000001990737),('2024-07-08 04:10:00.000000',00000000000002011237),('2024-07-08 04:15:00.000000',00000000000002013237),('2024-07-08 04:20:00.000000',00000000000002021217),('2024-07-08 04:25:00.000000',00000000000002029417),('2024-07-08 04:30:00.000000',00000000000002050684),('2024-07-08 04:35:00.000000',00000000000002075574),('2024-07-08 04:40:00.000000',00000000000002106351),('2024-07-08 04:45:00.000000',00000000000002125641),('2024-07-08 04:50:00.000000',00000000000002193531),('2024-07-08 04:55:00.000000',00000000000002282120),('2024-07-08 05:00:00.000000',00000000000002296010),('2024-07-08 05:05:00.000000',00000000000002309009),('2024-07-08 05:10:00.000000',00000000000002314209),('2024-07-08 05:15:00.000000',00000000000002317109),('2024-07-08 05:20:00.000000',00000000000002333088),('2024-07-08 05:25:00.000000',00000000000002349786),('2024-07-08 05:30:00.000000',00000000000002359886),('2024-07-08 05:35:00.000000',00000000000002409276),('2024-07-08 05:40:00.000000',00000000000002473836),('2024-07-08 05:45:00.000000',00000000000002490126),('2024-07-08 05:50:00.000000',00000000000002502003),('2024-07-08 05:55:00.000000',00000000000002508603),('2024-07-08 06:00:00.000000',00000000000002524483),('2024-07-08 06:05:00.000000',00000000000002539973),('2024-07-08 06:10:00.000000',00000000000002550873),('2024-07-08 06:15:00.000000',00000000000002571162),('2024-07-08 06:20:00.000000',00000000000002582962),('2024-07-08 06:25:00.000000',00000000000002594752),('2024-07-08 06:30:00.000000',00000000000002610439),('2024-07-08 06:35:00.000000',00000000000002629107),('2024-07-08 06:40:00.000000',00000000000002644707),('2024-07-08 06:45:00.000000',00000000000002662495),('2024-07-08 06:50:00.000000',00000000000002670485),('2024-07-08 06:55:00.000000',00000000000002714474),('2024-07-08 07:00:00.000000',00000000000002743032),('2024-07-08 07:05:00.000000',00000000000002763708),('2024-07-08 07:10:00.000000',00000000000002772458),('2024-07-08 07:15:00.000000',00000000000002795248),('2024-07-08 07:20:00.000000',00000000000002799548),('2024-07-08 07:25:00.000000',00000000000002815438),('2024-07-08 07:30:00.000000',00000000000002818438),('2024-07-08 07:35:00.000000',00000000000002833534),('2024-07-08 07:40:00.000000',00000000000002833534),('2024-07-08 07:45:00.000000',00000000000002844610),('2024-07-08 07:50:00.000000',00000000000002853889),('2024-07-08 07:55:00.000000',00000000000002868738),('2024-07-08 08:00:00.000000',00000000000002877438),('2024-07-08 08:05:00.000000',00000000000002877438),('2024-07-08 08:10:00.000000',00000000000002885227),('2024-07-08 08:15:00.000000',00000000000002902227),('2024-07-08 08:20:00.000000',00000000000002924107),('2024-07-08 08:25:00.000000',00000000000002947755),('2024-07-08 08:30:00.000000',00000000000002964042),('2024-07-08 08:35:00.000000',00000000000002970042),('2024-07-08 08:40:00.000000',00000000000002981332),('2024-07-08 08:45:00.000000',00000000000002982988),('2024-07-08 08:50:00.000000',00000000000002993388),('2024-07-08 08:55:00.000000',00000000000003005878),('2024-07-08 09:00:00.000000',00000000000003025668),('2024-07-08 09:05:00.000000',00000000000003028668),('2024-07-08 09:10:00.000000',00000000000003041568),('2024-07-08 09:15:00.000000',00000000000003088248),('2024-07-08 09:20:00.000000',00000000000003099548),('2024-07-08 09:25:00.000000',00000000000003112948),('2024-07-08 09:30:00.000000',00000000000003126345),('2024-07-08 09:35:00.000000',00000000000003138245),('2024-07-08 09:40:00.000000',00000000000003141311),('2024-07-08 09:45:00.000000',00000000000003151701),('2024-07-08 09:50:00.000000',00000000000003162791),('2024-07-08 09:55:00.000000',00000000000003185579),('2024-07-08 10:00:00.000000',00000000000003216667),('2024-07-08 10:05:00.000000',00000000000003228345),('2024-07-08 10:10:00.000000',00000000000003244545),('2024-07-08 10:15:00.000000',00000000000003251145),('2024-07-08 10:20:00.000000',00000000000003273544),('2024-07-08 10:25:00.000000',00000000000003285334),('2024-07-08 10:30:00.000000',00000000000003293322),('2024-07-08 10:35:00.000000',00000000000003328712),('2024-07-08 10:40:00.000000',00000000000003389692),('2024-07-08 10:45:00.000000',00000000000003415242),('2024-07-08 10:50:00.000000',00000000000003446912),('2024-07-08 10:55:00.000000',00000000000003456702),('2024-07-08 11:00:00.000000',00000000000003474582),('2024-07-08 11:05:00.000000',00000000000003486382),('2024-07-08 11:10:00.000000',00000000000003496570),('2024-07-08 11:15:00.000000',00000000000003506786),('2024-07-08 11:20:00.000000',00000000000003549076),('2024-07-08 11:25:00.000000',00000000000003549476),('2024-07-08 11:30:00.000000',00000000000003555466),('2024-07-08 11:35:00.000000',00000000000003557466),('2024-07-08 11:40:00.000000',00000000000003568366),('2024-07-08 11:45:00.000000',00000000000003568766),('2024-07-08 11:50:00.000000',00000000000003590754),('2024-07-08 11:55:00.000000',00000000000003610854),('2024-07-08 12:00:00.000000',00000000000003626133),('2024-07-08 12:05:00.000000',00000000000003636133),('2024-07-08 12:10:00.000000',00000000000003644233),('2024-07-08 12:15:00.000000',00000000000003656131),('2024-07-08 12:20:00.000000',00000000000003675910),('2024-07-08 12:25:00.000000',00000000000003697498),('2024-07-08 12:30:00.000000',00000000000003698298),('2024-07-08 12:35:00.000000',00000000000003703198),('2024-07-08 12:40:00.000000',00000000000003713598),('2024-07-08 12:45:00.000000',00000000000003716596),('2024-07-08 12:50:00.000000',00000000000003717596),('2024-07-08 12:55:00.000000',00000000000003737386),('2024-07-08 13:00:00.000000',00000000000003834685),('2024-07-08 13:05:00.000000',00000000000003848965),('2024-07-08 13:10:00.000000',00000000000003871945),('2024-07-08 13:15:00.000000',00000000000003867855),('2024-07-08 13:20:00.000000',00000000000003884825),('2024-07-08 13:25:00.000000',00000000000003890523),('2024-07-08 13:30:00.000000',00000000000003897511),('2024-07-08 13:35:00.000000',00000000000003917069),('2024-07-08 13:40:00.000000',00000000000003940101),('2024-07-08 13:45:00.000000',00000000000003949001),('2024-07-08 13:50:00.000000',00000000000003986771),('2024-07-08 13:55:00.000000',00000000000004034671),('2024-07-08 14:00:00.000000',00000000000004057669),('2024-07-08 14:05:00.000000',00000000000004120328),('2024-07-08 14:10:00.000000',00000000000004135117),('2024-07-08 14:15:00.000000',00000000000004139613),('2024-07-08 14:20:00.000000',00000000000004176202),('2024-07-08 14:25:00.000000',00000000000004192902),('2024-07-08 14:30:00.000000',00000000000004258001),('2024-07-08 14:35:00.000000',00000000000004283900),('2024-07-08 14:40:00.000000',00000000000004291800),('2024-07-08 14:45:00.000000',00000000000004305969),('2024-07-08 14:50:00.000000',00000000000004323247),('2024-07-08 14:55:00.000000',00000000000004356207),('2024-07-08 15:00:00.000000',00000000000004401207),('2024-07-08 15:05:00.000000',00000000000004413396),('2024-07-08 15:10:00.000000',00000000000004419396),('2024-07-08 15:15:00.000000',00000000000004449166),('2024-07-08 15:20:00.000000',00000000000004476638),('2024-07-08 15:25:00.000000',00000000000004502727),('2024-07-08 15:30:00.000000',00000000000004520387),('2024-07-08 15:35:00.000000',00000000000004593165),('2024-07-08 15:40:00.000000',00000000000004618239),('2024-07-08 15:45:00.000000',00000000000004663918),('2024-07-08 15:50:00.000000',00000000000004693908),('2024-07-08 15:55:00.000000',00000000000004731388),('2024-07-08 16:00:00.000000',00000000000000000000),('2024-07-08 16:05:00.000000',00000000000000039877),('2024-07-08 16:10:00.000000',00000000000000077220),('2024-07-08 16:15:00.000000',00000000000000154299),('2024-07-08 16:20:00.000000',00000000000000313786),('2024-07-08 16:25:00.000000',00000000000000347646),('2024-07-08 16:30:00.000000',00000000000000373825),('2024-07-08 16:35:00.000000',00000000000000395305),('2024-07-08 16:40:00.000000',00000000000000451005),('2024-07-08 16:45:00.000000',00000000000000481005),('2024-07-08 16:50:00.000000',00000000000000505474),('2024-07-08 16:55:00.000000',00000000000000535162),('2024-07-08 17:00:00.000000',00000000000000546042),('2024-07-08 17:05:00.000000',00000000000000613022),('2024-07-08 17:10:00.000000',00000000000000626912),('2024-07-08 17:15:00.000000',00000000000000640912),('2024-07-08 17:20:00.000000',00000000000000658078),('2024-07-08 17:25:00.000000',00000000000000670717),('2024-07-08 17:30:00.000000',00000000000000691407),('2024-07-08 17:35:00.000000',00000000000000709306),('2024-07-08 17:40:00.000000',00000000000000715504),('2024-07-08 17:45:00.000000',00000000000000749104),('2024-07-08 17:50:00.000000',00000000000000753104),('2024-07-08 17:55:00.000000',00000000000000774962),('2024-07-08 18:00:00.000000',00000000000000789050),('2024-07-08 18:05:00.000000',00000000000000803860),('2024-07-08 18:10:00.000000',00000000000000813250),('2024-07-08 18:15:00.000000',00000000000000817810),('2024-07-08 18:20:00.000000',00000000000000843700),('2024-07-08 18:25:00.000000',00000000000000859679),('2024-07-08 18:30:00.000000',00000000000000868569),('2024-07-08 18:35:00.000000',00000000000000871759),('2024-07-08 18:40:00.000000',00000000000000874419),('2024-07-08 18:45:00.000000',00000000000000889209),('2024-07-08 18:50:00.000000',00000000000000908099),('2024-07-08 18:55:00.000000',00000000000000913999),('2024-07-08 19:00:00.000000',00000000000000920899),('2024-07-08 19:05:00.000000',00000000000000939687),('2024-07-08 19:10:00.000000',00000000000000946487),('2024-07-08 19:15:00.000000',00000000000000949787),('2024-07-08 19:20:00.000000',00000000000000960766),('2024-07-08 19:25:00.000000',00000000000000971756),('2024-07-08 19:30:00.000000',00000000000000982046),('2024-07-08 19:35:00.000000',00000000000000998036),('2024-07-08 19:40:00.000000',00000000000001019915),('2024-07-08 19:45:00.000000',00000000000001023915),('2024-07-08 19:50:00.000000',00000000000001025915),('2024-07-08 19:55:00.000000',00000000000001030904),('2024-07-08 20:00:00.000000',00000000000001034493),('2024-07-08 20:05:00.000000',00000000000001037142),('2024-07-08 20:10:00.000000',00000000000001047042),('2024-07-08 20:15:00.000000',00000000000001097832),('2024-07-08 20:20:00.000000',00000000000001099032),('2024-07-08 20:25:00.000000',00000000000001230732),('2024-07-08 20:30:00.000000',00000000000001232732),('2024-07-08 20:35:00.000000',00000000000001238632),('2024-07-08 20:40:00.000000',00000000000001244631),('2024-07-08 20:45:00.000000',00000000000001275419),('2024-07-08 20:50:00.000000',00000000000001276619),('2024-07-08 20:55:00.000000',00000000000001276919),('2024-07-08 21:00:00.000000',00000000000001290009),('2024-07-08 21:05:00.000000',00000000000001294009),('2024-07-08 21:10:00.000000',00000000000001305899),('2024-07-08 21:15:00.000000',00000000000001298199),('2024-07-08 21:20:00.000000',00000000000001309189),('2024-07-08 21:25:00.000000',00000000000001310189),('2024-07-08 21:30:00.000000',00000000000001310189),('2024-07-08 21:35:00.000000',00000000000001313089),('2024-07-08 21:40:00.000000',00000000000001313289),('2024-07-08 21:45:00.000000',00000000000001313289),('2024-07-08 21:50:00.000000',00000000000001319287),('2024-07-08 21:55:00.000000',00000000000001320287),('2024-07-08 22:00:00.000000',00000000000001320287),('2024-07-08 22:05:00.000000',00000000000001321287),('2024-07-08 22:10:00.000000',00000000000001323287),('2024-07-08 22:15:00.000000',00000000000001323487),('2024-07-08 22:20:00.000000',00000000000001324687),('2024-07-08 22:25:00.000000',00000000000001325687),('2024-07-08 22:30:00.000000',00000000000001333177),('2024-07-08 22:35:00.000000',00000000000001342676),('2024-07-08 22:40:00.000000',00000000000001345176),('2024-07-08 22:45:00.000000',00000000000001351574),('2024-07-08 22:50:00.000000',00000000000001357072),('2024-07-08 22:55:00.000000',00000000000001376262),('2024-07-08 23:00:00.000000',00000000000001377262),('2024-07-08 23:05:00.000000',00000000000001381252),('2024-07-08 23:10:00.000000',00000000000001393442),('2024-07-08 23:15:00.000000',00000000000001406321),('2024-07-08 23:20:00.000000',00000000000001406331),('2024-07-08 23:25:00.000000',00000000000001408331),('2024-07-08 23:30:00.000000',00000000000001409331),('2024-07-08 23:35:00.000000',00000000000001420321),('2024-07-08 23:40:00.000000',00000000000001437871),('2024-07-08 23:45:00.000000',00000000000001441771),('2024-07-08 23:50:00.000000',00000000000001453761),('2024-07-08 23:55:00.000000',00000000000001455761),('2024-07-09 00:00:00.000000',00000000000001465751),('2024-07-09 00:05:00.000000',00000000000001468751),('2024-07-09 00:10:00.000000',00000000000001477410),('2024-07-09 00:15:00.000000',00000000000001484479),('2024-07-09 00:20:00.000000',00000000000001489279),('2024-07-09 00:25:00.000000',00000000000001501179),('2024-07-09 00:30:00.000000',00000000000001507169),('2024-07-09 00:35:00.000000',00000000000001512169),('2024-07-09 00:40:00.000000',00000000000001522767),('2024-07-09 00:45:00.000000',00000000000001540267),('2024-07-09 00:50:00.000000',00000000000001554257),('2024-07-09 00:55:00.000000',00000000000001570055),('2024-07-09 01:00:00.000000',00000000000001573253),('2024-07-09 01:05:00.000000',00000000000001579153),('2024-07-09 01:10:00.000000',00000000000001592143),('2024-07-09 01:15:00.000000',00000000000001598139),('2024-07-09 01:20:00.000000',00000000000001633939),('2024-07-09 01:25:00.000000',00000000000001646939),('2024-07-09 01:30:00.000000',00000000000001653739),('2024-07-09 01:35:00.000000',00000000000001657739),('2024-07-09 01:40:00.000000',00000000000001663539),('2024-07-09 01:45:00.000000',00000000000001679029),('2024-07-09 01:50:00.000000',00000000000001689629),('2024-07-09 01:55:00.000000',00000000000001710418),('2024-07-09 02:00:00.000000',00000000000001725308),('2024-07-09 02:05:00.000000',00000000000001794398),('2024-07-09 02:10:00.000000',00000000000001802386),('2024-07-09 02:15:00.000000',00000000000001811486),('2024-07-09 02:20:00.000000',00000000000001814484),('2024-07-09 02:25:00.000000',00000000000001827380),('2024-07-09 02:30:00.000000',00000000000001840480),('2024-07-09 02:35:00.000000',00000000000001854360),('2024-07-09 02:40:00.000000',00000000000001863360),('2024-07-09 02:45:00.000000',00000000000001887460),('2024-07-09 02:50:00.000000',00000000000001896360),('2024-07-09 02:55:00.000000',00000000000001899260),('2024-07-09 03:00:00.000000',00000000000001918150),('2024-07-09 03:05:00.000000',00000000000001928050),('2024-07-09 03:10:00.000000',00000000000001998829),('2024-07-09 03:15:00.000000',00000000000002010729),('2024-07-09 03:20:00.000000',00000000000002020629),('2024-07-09 03:25:00.000000',00000000000002025929),('2024-07-09 03:30:00.000000',00000000000002147527),('2024-07-09 03:35:00.000000',00000000000002155427),('2024-07-09 03:40:00.000000',00000000000002150917),('2024-07-09 03:45:00.000000',00000000000002157817),('2024-07-09 03:50:00.000000',00000000000002168807),('2024-07-09 03:55:00.000000',00000000000002171507),('2024-07-09 04:00:00.000000',00000000000002177507),('2024-07-09 04:05:00.000000',00000000000002182397),('2024-07-09 04:10:00.000000',00000000000002191997),('2024-07-09 04:15:00.000000',00000000000002195187),('2024-07-09 04:20:00.000000',00000000000002203745),('2024-07-09 04:25:00.000000',00000000000002213645),('2024-07-09 04:30:00.000000',00000000000002236435),('2024-07-09 04:35:00.000000',00000000000002248425),('2024-07-09 04:40:00.000000',00000000000002302205),('2024-07-09 04:45:00.000000',00000000000002302205),('2024-07-09 04:50:00.000000',00000000000002308195),('2024-07-09 04:55:00.000000',00000000000002328875),('2024-07-09 05:00:00.000000',00000000000002342762),('2024-07-09 05:05:00.000000',00000000000002363742),('2024-07-09 05:10:00.000000',00000000000002366742),('2024-07-09 05:15:00.000000',00000000000002376740),('2024-07-09 05:20:00.000000',00000000000002381239),('2024-07-09 05:25:00.000000',00000000000002391229),('2024-07-09 05:30:00.000000',00000000000002443639),('2024-07-09 05:35:00.000000',00000000000002439749),('2024-07-09 05:40:00.000000',00000000000002445745),('2024-07-09 05:45:00.000000',00000000000002468435),('2024-07-09 05:50:00.000000',00000000000002490575),('2024-07-09 05:55:00.000000',00000000000002495775),('2024-07-09 06:00:00.000000',00000000000002503285),('2024-07-09 06:05:00.000000',00000000000002500885),('2024-07-09 06:10:00.000000',00000000000002519085),('2024-07-09 06:15:00.000000',00000000000002538375),('2024-07-09 06:20:00.000000',00000000000002551923),('2024-07-09 06:25:00.000000',00000000000002566212),('2024-07-09 06:30:00.000000',00000000000002578180),('2024-07-09 06:35:00.000000',00000000000002581960),('2024-07-09 06:40:00.000000',00000000000002584960),('2024-07-09 06:45:00.000000',00000000000002604850),('2024-07-09 06:50:00.000000',00000000000002596860),('2024-07-09 06:55:00.000000',00000000000002603850),('2024-07-09 07:00:00.000000',00000000000002635540),('2024-07-09 07:05:00.000000',00000000000002641530),('2024-07-09 07:10:00.000000',00000000000002644828),('2024-07-09 07:15:00.000000',00000000000002644828),('2024-07-09 07:20:00.000000',00000000000002660508),('2024-07-09 07:25:00.000000',00000000000002709908),('2024-07-09 07:30:00.000000',00000000000002715064),('2024-07-09 07:35:00.000000',00000000000002721054),('2024-07-09 07:40:00.000000',00000000000002728044),('2024-07-09 07:45:00.000000',00000000000002758734),('2024-07-09 07:50:00.000000',00000000000002752834),('2024-07-09 07:55:00.000000',00000000000002762724),('2024-07-09 08:00:00.000000',00000000000002775624),('2024-07-09 08:05:00.000000',00000000000002781274),('2024-07-09 08:10:00.000000',00000000000002797054),('2024-07-09 08:15:00.000000',00000000000002813610),('2024-07-09 08:20:00.000000',00000000000002820510),('2024-07-09 08:25:00.000000',00000000000002845988),('2024-07-09 08:30:00.000000',00000000000002900665),('2024-07-09 08:35:00.000000',00000000000002907664),('2024-07-09 08:40:00.000000',00000000000002909664),('2024-07-09 08:45:00.000000',00000000000002960638),('2024-07-09 08:50:00.000000',00000000000002986628),('2024-07-09 08:55:00.000000',00000000000003021108),('2024-07-09 09:00:00.000000',00000000000003030100),('2024-07-09 09:05:00.000000',00000000000003045598),('2024-07-09 09:10:00.000000',00000000000003053498),('2024-07-09 09:15:00.000000',00000000000003053498),('2024-07-09 09:20:00.000000',00000000000003059098),('2024-07-09 09:25:00.000000',00000000000003069088),('2024-07-09 09:30:00.000000',00000000000003083057),('2024-07-09 09:35:00.000000',00000000000003096657),('2024-07-09 09:40:00.000000',00000000000003109547),('2024-07-09 09:45:00.000000',00000000000003120445),('2024-07-09 09:50:00.000000',00000000000003133324),('2024-07-09 09:55:00.000000',00000000000003144412),('2024-07-09 10:00:00.000000',00000000000003162100),('2024-07-09 10:05:00.000000',00000000000003173879),('2024-07-09 10:10:00.000000',00000000000003176869),('2024-07-09 10:15:00.000000',00000000000003190759),('2024-07-09 10:20:00.000000',00000000000003224159),('2024-07-09 10:25:00.000000',00000000000003234759),('2024-07-09 10:30:00.000000',00000000000003243749),('2024-07-09 10:35:00.000000',00000000000003267029),('2024-07-09 10:40:00.000000',00000000000003273929),('2024-07-09 10:45:00.000000',00000000000003288629),('2024-07-09 10:50:00.000000',00000000000003318327),('2024-07-09 10:55:00.000000',00000000000003326227),('2024-07-09 11:00:00.000000',00000000000003338117),('2024-07-09 11:05:00.000000',00000000000003443007),('2024-07-09 11:10:00.000000',00000000000003642007),('2024-07-09 11:15:00.000000',00000000000003674005),('2024-07-09 11:20:00.000000',00000000000003743381),('2024-07-09 11:25:00.000000',00000000000003749281),('2024-07-09 11:30:00.000000',00000000000003778081),('2024-07-09 11:35:00.000000',00000000000003788971),('2024-07-09 11:40:00.000000',00000000000003818248),('2024-07-09 11:45:00.000000',00000000000003866848),('2024-07-09 11:50:00.000000',00000000000003883237),('2024-07-09 11:55:00.000000',00000000000003919337),('2024-07-09 12:00:00.000000',00000000000003924086),('2024-07-09 12:05:00.000000',00000000000003931886),('2024-07-09 12:10:00.000000',00000000000003929586),('2024-07-09 12:15:00.000000',00000000000003943786),('2024-07-09 12:20:00.000000',00000000000003943786),('2024-07-09 12:25:00.000000',00000000000003951686),('2024-07-09 12:30:00.000000',00000000000003960276),('2024-07-09 12:35:00.000000',00000000000003985226),('2024-07-09 12:40:00.000000',00000000000004001116),('2024-07-09 12:45:00.000000',00000000000004038496),('2024-07-09 12:50:00.000000',00000000000004041485),('2024-07-09 12:55:00.000000',00000000000004041485),('2024-07-09 13:00:00.000000',00000000000004045575),('2024-07-09 13:05:00.000000',00000000000004067265),('2024-07-09 13:10:00.000000',00000000000004090255),('2024-07-09 13:15:00.000000',00000000000004112753),('2024-07-09 13:20:00.000000',00000000000004141933),('2024-07-09 13:25:00.000000',00000000000004151423),('2024-07-09 13:30:00.000000',00000000000004165413),('2024-07-09 13:35:00.000000',00000000000004173801),('2024-07-09 13:40:00.000000',00000000000004196091),('2024-07-09 13:45:00.000000',00000000000004230559),('2024-07-09 13:50:00.000000',00000000000004263849),('2024-07-09 13:55:00.000000',00000000000004246359),('2024-07-09 14:00:00.000000',00000000000004265247),('2024-07-09 14:05:00.000000',00000000000004278245),('2024-07-09 14:10:00.000000',00000000000004291624),('2024-07-09 14:15:00.000000',00000000000004299711),('2024-07-09 14:20:00.000000',00000000000004319578),('2024-07-09 14:25:00.000000',00000000000004348278),('2024-07-09 14:30:00.000000',00000000000004376856),('2024-07-09 14:35:00.000000',00000000000004408634),('2024-07-09 14:40:00.000000',00000000000004458524),('2024-07-09 14:45:00.000000',00000000000004486212),('2024-07-09 14:50:00.000000',00000000000004514812),('2024-07-09 14:55:00.000000',00000000000004625902),('2024-07-09 15:00:00.000000',00000000000004635982),('2024-07-09 15:05:00.000000',00000000000004671672),('2024-07-09 15:10:00.000000',00000000000004797842),('2024-07-09 15:15:00.000000',00000000000004834022),('2024-07-09 15:20:00.000000',00000000000004873212),('2024-07-09 15:25:00.000000',00000000000004908482),('2024-07-09 15:30:00.000000',00000000000004970650),('2024-07-09 15:35:00.000000',00000000000004996428),('2024-07-09 15:40:00.000000',00000000000005027563),('2024-07-09 15:45:00.000000',00000000000005084212),('2024-07-09 15:50:00.000000',00000000000005099589),('2024-07-09 15:55:00.000000',00000000000005139179),('2024-07-09 16:00:00.000000',00000000000000000000),('2024-07-09 16:05:00.000000',00000000000000025790),('2024-07-09 16:10:00.000000',00000000000000036690),('2024-07-09 16:15:00.000000',00000000000000130677),('2024-07-09 16:20:00.000000',00000000000000167567),('2024-07-09 16:25:00.000000',00000000000000196246),('2024-07-09 16:30:00.000000',00000000000000239836),('2024-07-09 16:35:00.000000',00000000000000285316),('2024-07-09 16:40:00.000000',00000000000000304785),('2024-07-09 16:45:00.000000',00000000000000330575),('2024-07-09 16:50:00.000000',00000000000000442255),('2024-07-09 16:55:00.000000',00000000000000459053),('2024-07-09 17:00:00.000000',00000000000000497532),('2024-07-09 17:05:00.000000',00000000000000563028),('2024-07-09 17:10:00.000000',00000000000000597618),('2024-07-09 17:15:00.000000',00000000000000598118),('2024-07-09 17:20:00.000000',00000000000000614008),('2024-07-09 17:25:00.000000',00000000000000628808),('2024-07-09 17:30:00.000000',00000000000000655686),('2024-07-09 17:35:00.000000',00000000000000709564),('2024-07-09 17:40:00.000000',00000000000000733362),('2024-07-09 17:45:00.000000',00000000000000739062),('2024-07-09 17:50:00.000000',00000000000000765239),('2024-07-09 17:55:00.000000',00000000000000778439),('2024-07-09 18:00:00.000000',00000000000000794329),('2024-07-09 18:05:00.000000',00000000000000823119),('2024-07-09 18:10:00.000000',00000000000000856799),('2024-07-09 18:15:00.000000',00000000000000997299),('2024-07-09 18:20:00.000000',00000000000001013889),('2024-07-09 18:25:00.000000',00000000000001039479),('2024-07-09 18:30:00.000000',00000000000001040479),('2024-07-09 18:35:00.000000',00000000000001063375),('2024-07-09 18:40:00.000000',00000000000001071275),('2024-07-09 18:45:00.000000',00000000000001086075),('2024-07-09 18:50:00.000000',00000000000001089055),('2024-07-09 18:55:00.000000',00000000000001104744),('2024-07-09 19:00:00.000000',00000000000001107734),('2024-07-09 19:05:00.000000',00000000000001111723),('2024-07-09 19:10:00.000000',00000000000001115523),('2024-07-09 19:15:00.000000',00000000000001134213),('2024-07-09 19:20:00.000000',00000000000001138200),('2024-07-09 19:25:00.000000',00000000000001149100),('2024-07-09 19:30:00.000000',00000000000001154100),('2024-07-09 19:35:00.000000',00000000000001166089),('2024-07-09 19:40:00.000000',00000000000001172089),('2024-07-09 19:45:00.000000',00000000000001174089),('2024-07-09 19:50:00.000000',00000000000001176089),('2024-07-09 19:55:00.000000',00000000000001186979),('2024-07-09 20:00:00.000000',00000000000001187179),('2024-07-09 20:05:00.000000',00000000000001199079),('2024-07-09 20:10:00.000000',00000000000001238979),('2024-07-09 20:15:00.000000',00000000000001241967),('2024-07-09 20:20:00.000000',00000000000001242967),('2024-07-09 20:25:00.000000',00000000000001249957),('2024-07-09 20:30:00.000000',00000000000001259857),('2024-07-09 20:35:00.000000',00000000000001273727),('2024-07-09 20:40:00.000000',00000000000001292427),('2024-07-09 20:45:00.000000',00000000000001301327),('2024-07-09 20:50:00.000000',00000000000001304427),('2024-07-09 20:55:00.000000',00000000000001309327),('2024-07-09 21:00:00.000000',00000000000001313317),('2024-07-09 21:05:00.000000',00000000000001316306),('2024-07-09 21:10:00.000000',00000000000001325206),('2024-07-09 21:15:00.000000',00000000000001325206),('2024-07-09 21:20:00.000000',00000000000001333196),('2024-07-09 21:25:00.000000',00000000000001334196),('2024-07-09 21:30:00.000000',00000000000001338096),('2024-07-09 21:35:00.000000',00000000000001351986),('2024-07-09 21:40:00.000000',00000000000001358886),('2024-07-09 21:45:00.000000',00000000000001355696),('2024-07-09 21:50:00.000000',00000000000001356695),('2024-07-09 21:55:00.000000',00000000000001356695),('2024-07-09 22:00:00.000000',00000000000001356695),('2024-07-09 22:05:00.000000',00000000000001358695),('2024-07-09 22:10:00.000000',00000000000001359695),('2024-07-09 22:15:00.000000',00000000000001368495),('2024-07-09 22:20:00.000000',00000000000001369495),('2024-07-09 22:25:00.000000',00000000000001376395),('2024-07-09 22:30:00.000000',00000000000001377395),('2024-07-09 22:35:00.000000',00000000000001378395),('2024-07-09 22:40:00.000000',00000000000001381395),('2024-07-09 22:45:00.000000',00000000000001384395),('2024-07-09 22:50:00.000000',00000000000001388595),('2024-07-09 22:55:00.000000',00000000000001390585),('2024-07-09 23:00:00.000000',00000000000001391245),('2024-07-09 23:05:00.000000',00000000000001391245),('2024-07-09 23:10:00.000000',00000000000001399145),('2024-07-09 23:15:00.000000',00000000000001407943),('2024-07-09 23:20:00.000000',00000000000001410043),('2024-07-09 23:25:00.000000',00000000000001421743),('2024-07-09 23:30:00.000000',00000000000001422743),('2024-07-09 23:35:00.000000',00000000000001423743),('2024-07-09 23:40:00.000000',00000000000001426743),('2024-07-09 23:45:00.000000',00000000000001436632),('2024-07-09 23:50:00.000000',00000000000001455422),('2024-07-09 23:55:00.000000',00000000000001450421),('2024-07-10 00:00:00.000000',00000000000001471301),('2024-07-10 00:05:00.000000',00000000000001490281),('2024-07-10 00:10:00.000000',00000000000001516971),('2024-07-10 00:15:00.000000',00000000000001514469),('2024-07-10 00:20:00.000000',00000000000001529669),('2024-07-10 00:25:00.000000',00000000000001532669),('2024-07-10 00:30:00.000000',00000000000001548249),('2024-07-10 00:35:00.000000',00000000000001581247),('2024-07-10 00:40:00.000000',00000000000001592809),('2024-07-10 00:45:00.000000',00000000000001616011),('2024-07-10 00:50:00.000000',00000000000001639601),('2024-07-10 00:55:00.000000',00000000000001689401),('2024-07-10 01:00:00.000000',00000000000001701389),('2024-07-10 01:05:00.000000',00000000000001716089),('2024-07-10 01:10:00.000000',00000000000001727889),('2024-07-10 01:15:00.000000',00000000000001740689),('2024-07-10 01:20:00.000000',00000000000001745589),('2024-07-10 01:25:00.000000',00000000000001779589),('2024-07-10 01:30:00.000000',00000000000001789589),('2024-07-10 01:35:00.000000',00000000000001794579),('2024-07-10 01:40:00.000000',00000000000001795579),('2024-07-10 01:45:00.000000',00000000000001795579),('2024-07-10 01:50:00.000000',00000000000001805479),('2024-07-10 01:55:00.000000',00000000000001817369),('2024-07-10 02:00:00.000000',00000000000001862267),('2024-07-10 02:05:00.000000',00000000000001886967),('2024-07-10 02:10:00.000000',00000000000001895946),('2024-07-10 02:15:00.000000',00000000000001895946),('2024-07-10 02:20:00.000000',00000000000001915335),('2024-07-10 02:25:00.000000',00000000000001918235),('2024-07-10 02:30:00.000000',00000000000001928535),('2024-07-10 02:35:00.000000',00000000000001939435),('2024-07-10 02:40:00.000000',00000000000001973294),('2024-07-10 02:45:00.000000',00000000000001992194),('2024-07-10 02:50:00.000000',00000000000002009972),('2024-07-10 02:55:00.000000',00000000000002023662),('2024-07-10 03:00:00.000000',00000000000002035062),('2024-07-10 03:05:00.000000',00000000000002050557),('2024-07-10 03:10:00.000000',00000000000002059426),('2024-07-10 03:15:00.000000',00000000000002080126),('2024-07-10 03:20:00.000000',00000000000002103926),('2024-07-10 03:25:00.000000',00000000000002109926),('2024-07-10 03:30:00.000000',00000000000002120826),('2024-07-10 03:35:00.000000',00000000000002166716),('2024-07-10 03:40:00.000000',00000000000002166716),('2024-07-10 03:45:00.000000',00000000000002173616),('2024-07-10 03:50:00.000000',00000000000002189712),('2024-07-10 03:55:00.000000',00000000000002213492),('2024-07-10 04:00:00.000000',00000000000002216490),('2024-07-10 04:05:00.000000',00000000000002232990),('2024-07-10 04:10:00.000000',00000000000002234990),('2024-07-10 04:15:00.000000',00000000000002255879),('2024-07-10 04:20:00.000000',00000000000002251969),('2024-07-10 04:25:00.000000',00000000000002265667),('2024-07-10 04:30:00.000000',00000000000002288247),('2024-07-10 04:35:00.000000',00000000000002295237),('2024-07-10 04:40:00.000000',00000000000002304324),('2024-07-10 04:45:00.000000',00000000000002310734),('2024-07-10 04:50:00.000000',00000000000002319032),('2024-07-10 04:55:00.000000',00000000000002326932),('2024-07-10 05:00:00.000000',00000000000002373128),('2024-07-10 05:05:00.000000',00000000000002378228),('2024-07-10 05:10:00.000000',00000000000002381228),('2024-07-10 05:15:00.000000',00000000000002389128),('2024-07-10 05:20:00.000000',00000000000002413218),('2024-07-10 05:25:00.000000',00000000000002438208),('2024-07-10 05:30:00.000000',00000000000002474908),('2024-07-10 05:35:00.000000',00000000000002592861),('2024-07-10 05:40:00.000000',00000000000002617348),('2024-07-10 05:45:00.000000',00000000000002618347),('2024-07-10 05:50:00.000000',00000000000002619447),('2024-07-10 05:55:00.000000',00000000000002620747),('2024-07-10 06:00:00.000000',00000000000002636547),('2024-07-10 06:05:00.000000',00000000000002643447),('2024-07-10 06:10:00.000000',00000000000002643447),('2024-07-10 06:15:00.000000',00000000000002651527),('2024-07-10 06:20:00.000000',00000000000002658526),('2024-07-10 06:25:00.000000',00000000000002718826),('2024-07-10 06:30:00.000000',00000000000002723726),('2024-07-10 06:35:00.000000',00000000000002747116),('2024-07-10 06:40:00.000000',00000000000002753916),('2024-07-10 06:45:00.000000',00000000000002761816),('2024-07-10 06:50:00.000000',00000000000002785406),('2024-07-10 06:55:00.000000',00000000000002791396),('2024-07-10 07:00:00.000000',00000000000002797796),('2024-07-10 07:05:00.000000',00000000000002805996),('2024-07-10 07:10:00.000000',00000000000002802096),('2024-07-10 07:15:00.000000',00000000000002806093),('2024-07-10 07:20:00.000000',00000000000002815493),('2024-07-10 07:25:00.000000',00000000000002839883),('2024-07-10 07:30:00.000000',00000000000002845783),('2024-07-10 07:35:00.000000',00000000000002880473),('2024-07-10 07:40:00.000000',00000000000002870573),('2024-07-10 07:45:00.000000',00000000000002870573),('2024-07-10 07:50:00.000000',00000000000002888829),('2024-07-10 07:55:00.000000',00000000000002888829),('2024-07-10 08:00:00.000000',00000000000002907719),('2024-07-10 08:05:00.000000',00000000000002927609),('2024-07-10 08:10:00.000000',00000000000002944309),('2024-07-10 08:15:00.000000',00000000000002955209),('2024-07-10 08:20:00.000000',00000000000002954598),('2024-07-10 08:25:00.000000',00000000000002954598),('2024-07-10 08:30:00.000000',00000000000002979388),('2024-07-10 08:35:00.000000',00000000000002977398),('2024-07-10 08:40:00.000000',00000000000002994175),('2024-07-10 08:45:00.000000',00000000000002999171),('2024-07-10 08:50:00.000000',00000000000003003150),('2024-07-10 08:55:00.000000',00000000000003061840),('2024-07-10 09:00:00.000000',00000000000003072730),('2024-07-10 09:05:00.000000',00000000000003102330),('2024-07-10 09:10:00.000000',00000000000003121208),('2024-07-10 09:15:00.000000',00000000000003127298),('2024-07-10 09:20:00.000000',00000000000003127298),('2024-07-10 09:25:00.000000',00000000000003129287),('2024-07-10 09:30:00.000000',00000000000003130287),('2024-07-10 09:35:00.000000',00000000000003130287),('2024-07-10 09:40:00.000000',00000000000003130287),('2024-07-10 09:45:00.000000',00000000000003141177),('2024-07-10 09:50:00.000000',00000000000003142177),('2024-07-10 09:55:00.000000',00000000000003183077),('2024-07-10 10:00:00.000000',00000000000003191877),('2024-07-10 10:05:00.000000',00000000000003193877),('2024-07-10 10:10:00.000000',00000000000003200877),('2024-07-10 10:15:00.000000',00000000000003207777),('2024-07-10 10:20:00.000000',00000000000003213677),('2024-07-10 10:25:00.000000',00000000000003224467),('2024-07-10 10:30:00.000000',00000000000003244356),('2024-07-10 10:35:00.000000',00000000000003245356),('2024-07-10 10:40:00.000000',00000000000003260146),('2024-07-10 10:45:00.000000',00000000000003267136),('2024-07-10 10:50:00.000000',00000000000003312014),('2024-07-10 10:55:00.000000',00000000000003346914),('2024-07-10 11:00:00.000000',00000000000003367612),('2024-07-10 11:05:00.000000',00000000000003425012),('2024-07-10 11:10:00.000000',00000000000003425012),('2024-07-10 11:15:00.000000',00000000000003446802),('2024-07-10 11:20:00.000000',00000000000003457592),('2024-07-10 11:25:00.000000',00000000000003469590),('2024-07-10 11:30:00.000000',00000000000003462790),('2024-07-10 11:35:00.000000',00000000000003476668),('2024-07-10 11:40:00.000000',00000000000003483854),('2024-07-10 11:45:00.000000',00000000000003484902),('2024-07-10 11:50:00.000000',00000000000003484902),('2024-07-10 11:55:00.000000',00000000000003493190),('2024-07-10 12:00:00.000000',00000000000003504992),('2024-07-10 12:05:00.000000',00000000000003522882),('2024-07-10 12:10:00.000000',00000000000003594682),('2024-07-10 12:15:00.000000',00000000000003598331),('2024-07-10 12:20:00.000000',00000000000003602231),('2024-07-10 12:25:00.000000',00000000000003615121),('2024-07-10 12:30:00.000000',00000000000003625989),('2024-07-10 12:35:00.000000',00000000000003625989),('2024-07-10 12:40:00.000000',00000000000003642859),('2024-07-10 12:45:00.000000',00000000000003670249),('2024-07-10 12:50:00.000000',00000000000003706829),('2024-07-10 12:55:00.000000',00000000000003730917),('2024-07-10 13:00:00.000000',00000000000003739905),('2024-07-10 13:05:00.000000',00000000000003750805),('2024-07-10 13:10:00.000000',00000000000003744015),('2024-07-10 13:15:00.000000',00000000000003756005),('2024-07-10 13:20:00.000000',00000000000003762995),('2024-07-10 13:25:00.000000',00000000000003764995),('2024-07-10 13:30:00.000000',00000000000003769993),('2024-07-10 13:35:00.000000',00000000000003777493),('2024-07-10 13:40:00.000000',00000000000003796365),('2024-07-10 13:45:00.000000',00000000000003823653),('2024-07-10 13:50:00.000000',00000000000003827308),('2024-07-10 13:55:00.000000',00000000000003843898),('2024-07-10 14:00:00.000000',00000000000003849496),('2024-07-10 14:05:00.000000',00000000000003865276),('2024-07-10 14:10:00.000000',00000000000003901336),('2024-07-10 14:15:00.000000',00000000000003917214),('2024-07-10 14:20:00.000000',00000000000003946493),('2024-07-10 14:25:00.000000',00000000000003961781),('2024-07-10 14:30:00.000000',00000000000003974771),('2024-07-10 14:35:00.000000',00000000000003981069),('2024-07-10 14:40:00.000000',00000000000004021249),('2024-07-10 14:45:00.000000',00000000000004041528),('2024-07-10 14:50:00.000000',00000000000004053927),('2024-07-10 14:55:00.000000',00000000000004067327),('2024-07-10 15:00:00.000000',00000000000004129717),('2024-07-10 15:05:00.000000',00000000000004141606),('2024-07-10 15:10:00.000000',00000000000004160396),('2024-07-10 15:15:00.000000',00000000000004175506),('2024-07-10 15:20:00.000000',00000000000004248106),('2024-07-10 15:25:00.000000',00000000000004264896),('2024-07-10 15:30:00.000000',00000000000004284386),('2024-07-10 15:35:00.000000',00000000000004315556),('2024-07-10 15:40:00.000000',00000000000004361626),('2024-07-10 15:45:00.000000',00000000000004382504),('2024-07-10 15:50:00.000000',00000000000004412174),('2024-07-10 15:55:00.000000',00000000000004475914),('2024-07-10 16:00:00.000000',00000000000000000000),('2024-07-10 16:05:00.000000',00000000000000044200),('2024-07-10 16:10:00.000000',00000000000000082800),('2024-07-10 16:15:00.000000',00000000000000129690),('2024-07-10 16:20:00.000000',00000000000000172289),('2024-07-10 16:25:00.000000',00000000000000191979),('2024-07-10 16:30:00.000000',00000000000000211569),('2024-07-10 16:35:00.000000',00000000000000219259),('2024-07-10 16:40:00.000000',00000000000000221559),('2024-07-10 16:45:00.000000',00000000000000249659),('2024-07-10 16:50:00.000000',00000000000000260947),('2024-07-10 16:55:00.000000',00000000000000263947),('2024-07-10 17:00:00.000000',00000000000000292207),('2024-07-10 17:05:00.000000',00000000000000309195),('2024-07-10 17:10:00.000000',00000000000000360662),('2024-07-10 17:15:00.000000',00000000000000363362),('2024-07-10 17:20:00.000000',00000000000000366351),('2024-07-10 17:25:00.000000',00000000000000414731),('2024-07-10 17:30:00.000000',00000000000000433621),('2024-07-10 17:35:00.000000',00000000000000445299),('2024-07-10 17:40:00.000000',00000000000000455999),('2024-07-10 17:45:00.000000',00000000000000465499),('2024-07-10 17:50:00.000000',00000000000000472489),('2024-07-10 17:55:00.000000',00000000000000481889),('2024-07-10 18:00:00.000000',00000000000000498789),('2024-07-10 18:05:00.000000',00000000000000517689),('2024-07-10 18:10:00.000000',00000000000000517689),('2024-07-10 18:15:00.000000',00000000000000530589),('2024-07-10 18:20:00.000000',00000000000000546476),('2024-07-10 18:25:00.000000',00000000000000549474),('2024-07-10 18:30:00.000000',00000000000000561672),('2024-07-10 18:35:00.000000',00000000000000562872),('2024-07-10 18:40:00.000000',00000000000000575962),('2024-07-10 18:45:00.000000',00000000000000594452),('2024-07-10 18:50:00.000000',00000000000000596452),('2024-07-10 18:55:00.000000',00000000000000608252),('2024-07-10 19:00:00.000000',00000000000000618050),('2024-07-10 19:05:00.000000',00000000000000621039),('2024-07-10 19:10:00.000000',00000000000000621039),('2024-07-10 19:15:00.000000',00000000000000625139),('2024-07-10 19:20:00.000000',00000000000000629137),('2024-07-10 19:25:00.000000',00000000000000650027),('2024-07-10 19:30:00.000000',00000000000000658527),('2024-07-10 19:35:00.000000',00000000000000675395),('2024-07-10 19:40:00.000000',00000000000000691294),('2024-07-10 19:45:00.000000',00000000000000693294),('2024-07-10 19:50:00.000000',00000000000000700284),('2024-07-10 19:55:00.000000',00000000000000700284),('2024-07-10 20:00:00.000000',00000000000000702284),('2024-07-10 20:05:00.000000',00000000000000713974),('2024-07-10 20:10:00.000000',00000000000000715774),('2024-07-10 20:15:00.000000',00000000000000717574),('2024-07-10 20:20:00.000000',00000000000000720574),('2024-07-10 20:25:00.000000',00000000000000727474),('2024-07-10 20:30:00.000000',00000000000000730474),('2024-07-10 20:35:00.000000',00000000000000730474),('2024-07-10 20:40:00.000000',00000000000000740474),('2024-07-10 20:45:00.000000',00000000000000745573),('2024-07-10 20:50:00.000000',00000000000000758373),('2024-07-10 20:55:00.000000',00000000000000761273),('2024-07-10 21:00:00.000000',00000000000000765663),('2024-07-10 21:05:00.000000',00000000000000768653),('2024-07-10 21:10:00.000000',00000000000000768653),('2024-07-10 21:15:00.000000',00000000000000773243),('2024-07-10 21:20:00.000000',00000000000000774243),('2024-07-10 21:25:00.000000',00000000000000786143),('2024-07-10 21:30:00.000000',00000000000000788743),('2024-07-10 21:35:00.000000',00000000000000793943),('2024-07-10 21:40:00.000000',00000000000000797943),('2024-07-10 21:45:00.000000',00000000000000797943),('2024-07-10 21:50:00.000000',00000000000000803843),('2024-07-10 21:55:00.000000',00000000000000804843),('2024-07-10 22:00:00.000000',00000000000000804243),('2024-07-10 22:05:00.000000',00000000000000815143),('2024-07-10 22:10:00.000000',00000000000000873743),('2024-07-10 22:15:00.000000',00000000000000876343),('2024-07-10 22:20:00.000000',00000000000000887743),('2024-07-10 22:25:00.000000',00000000000000898443),('2024-07-10 22:30:00.000000',00000000000000908243),('2024-07-10 22:35:00.000000',00000000000000910243),('2024-07-10 22:40:00.000000',00000000000000902341),('2024-07-10 22:45:00.000000',00000000000000921117),('2024-07-10 22:50:00.000000',00000000000000923917),('2024-07-10 22:55:00.000000',00000000000000947707),('2024-07-10 23:00:00.000000',00000000000000948707),('2024-07-10 23:05:00.000000',00000000000000952705),('2024-07-10 23:10:00.000000',00000000000000953705),('2024-07-10 23:15:00.000000',00000000000000960695),('2024-07-10 23:20:00.000000',00000000000000961695),('2024-07-10 23:25:00.000000',00000000000000964695),('2024-07-10 23:30:00.000000',00000000000000966695),('2024-07-10 23:35:00.000000',00000000000000971685),('2024-07-10 23:40:00.000000',00000000000000978485),('2024-07-10 23:45:00.000000',00000000000000983483),('2024-07-10 23:50:00.000000',00000000000000990381),('2024-07-10 23:55:00.000000',00000000000000998371),('2024-07-11 00:00:00.000000',00000000000001004361),('2024-07-11 00:05:00.000000',00000000000001011261),('2024-07-11 00:10:00.000000',00000000000001052161),('2024-07-11 00:15:00.000000',00000000000001070051),('2024-07-11 00:20:00.000000',00000000000001070051),('2024-07-11 00:25:00.000000',00000000000001071051),('2024-07-11 00:30:00.000000',00000000000001071051),('2024-07-11 00:35:00.000000',00000000000001071051),('2024-07-11 00:40:00.000000',00000000000001074749),('2024-07-11 00:45:00.000000',00000000000001087628),('2024-07-11 00:50:00.000000',00000000000001094618),('2024-07-11 00:55:00.000000',00000000000001103518),('2024-07-11 01:00:00.000000',00000000000001120408),('2024-07-11 01:05:00.000000',00000000000001124398),('2024-07-11 01:10:00.000000',00000000000001131287),('2024-07-11 01:15:00.000000',00000000000001141185),('2024-07-11 01:20:00.000000',00000000000001149175),('2024-07-11 01:25:00.000000',00000000000001150275),('2024-07-11 01:30:00.000000',00000000000001151275),('2024-07-11 01:35:00.000000',00000000000001151975),('2024-07-11 01:40:00.000000',00000000000001159875),('2024-07-11 01:45:00.000000',00000000000001225075),('2024-07-11 01:50:00.000000',00000000000001243565),('2024-07-11 01:55:00.000000',00000000000001243665),('2024-07-11 02:00:00.000000',00000000000001244665),('2024-07-11 02:05:00.000000',00000000000001261553),('2024-07-11 02:10:00.000000',00000000000001280541),('2024-07-11 02:15:00.000000',00000000000001280541),('2024-07-11 02:20:00.000000',00000000000001284541),('2024-07-11 02:25:00.000000',00000000000001285541),('2024-07-11 02:30:00.000000',00000000000001292531),('2024-07-11 02:35:00.000000',00000000000001296331),('2024-07-11 02:40:00.000000',00000000000001315221),('2024-07-11 02:45:00.000000',00000000000001387821),('2024-07-11 02:50:00.000000',00000000000001398720),('2024-07-11 02:55:00.000000',00000000000001405620),('2024-07-11 03:00:00.000000',00000000000001419610),('2024-07-11 03:05:00.000000',00000000000001482390),('2024-07-11 03:10:00.000000',00000000000001494380),('2024-07-11 03:15:00.000000',00000000000001498280),('2024-07-11 03:20:00.000000',00000000000001505260),('2024-07-11 03:25:00.000000',00000000000001508349),('2024-07-11 03:30:00.000000',00000000000001511989),('2024-07-11 03:35:00.000000',00000000000001528767),('2024-07-11 03:40:00.000000',00000000000001547647),('2024-07-11 03:45:00.000000',00000000000001555637),('2024-07-11 03:50:00.000000',00000000000001557635),('2024-07-11 03:55:00.000000',00000000000001558635),('2024-07-11 04:00:00.000000',00000000000001564625),('2024-07-11 04:05:00.000000',00000000000001572225),('2024-07-11 04:10:00.000000',00000000000001584125),('2024-07-11 04:15:00.000000',00000000000001581125),('2024-07-11 04:20:00.000000',00000000000001600525),('2024-07-11 04:25:00.000000',00000000000001631315),('2024-07-11 04:30:00.000000',00000000000001632313),('2024-07-11 04:35:00.000000',00000000000001680203),('2024-07-11 04:40:00.000000',00000000000001682203),('2024-07-11 04:45:00.000000',00000000000001683103),('2024-07-11 04:50:00.000000',00000000000001701803),('2024-07-11 04:55:00.000000',00000000000001711592),('2024-07-11 05:00:00.000000',00000000000001726480),('2024-07-11 05:05:00.000000',00000000000001809580),('2024-07-11 05:10:00.000000',00000000000001848959),('2024-07-11 05:15:00.000000',00000000000001857747),('2024-07-11 05:20:00.000000',00000000000001886535),('2024-07-11 05:25:00.000000',00000000000001944215),('2024-07-11 05:30:00.000000',00000000000001950715),('2024-07-11 05:35:00.000000',00000000000001955715),('2024-07-11 05:40:00.000000',00000000000001959815),('2024-07-11 05:45:00.000000',00000000000002010715),('2024-07-11 05:50:00.000000',00000000000002018705),('2024-07-11 05:55:00.000000',00000000000002039495),('2024-07-11 06:00:00.000000',00000000000002043483),('2024-07-11 06:05:00.000000',00000000000002067349),('2024-07-11 06:10:00.000000',00000000000002089228),('2024-07-11 06:15:00.000000',00000000000002106118),('2024-07-11 06:20:00.000000',00000000000002123608),('2024-07-11 06:25:00.000000',00000000000002136198),('2024-07-11 06:30:00.000000',00000000000002174648),('2024-07-11 06:35:00.000000',00000000000002197525),('2024-07-11 06:40:00.000000',00000000000002211985),('2024-07-11 06:45:00.000000',00000000000002234763),('2024-07-11 06:50:00.000000',00000000000002257031),('2024-07-11 06:55:00.000000',00000000000002292221),('2024-07-11 07:00:00.000000',00000000000002300221),('2024-07-11 07:05:00.000000',00000000000002471511),('2024-07-11 07:10:00.000000',00000000000002483511),('2024-07-11 07:15:00.000000',00000000000002498711),('2024-07-11 07:20:00.000000',00000000000002498711),('2024-07-11 07:25:00.000000',00000000000002531571),('2024-07-11 07:30:00.000000',00000000000002576161),('2024-07-11 07:35:00.000000',00000000000002787747),('2024-07-11 07:40:00.000000',00000000000002800727),('2024-07-11 07:45:00.000000',00000000000002808307),('2024-07-11 07:50:00.000000',00000000000002811407),('2024-07-11 07:55:00.000000',00000000000002828753),('2024-07-11 08:00:00.000000',00000000000002835743),('2024-07-11 08:05:00.000000',00000000000002837741),('2024-07-11 08:10:00.000000',00000000000002851441),('2024-07-11 08:15:00.000000',00000000000002862229),('2024-07-11 08:20:00.000000',00000000000002865719),('2024-07-11 08:25:00.000000',00000000000002874717),('2024-07-11 08:30:00.000000',00000000000002911815),('2024-07-11 08:35:00.000000',00000000000002915815),('2024-07-11 08:40:00.000000',00000000000002945275),('2024-07-11 08:45:00.000000',00000000000002974265),('2024-07-11 08:50:00.000000',00000000000003005965),('2024-07-11 08:55:00.000000',00000000000003025252),('2024-07-11 09:00:00.000000',00000000000003027252),('2024-07-11 09:05:00.000000',00000000000003027252),('2024-07-11 09:10:00.000000',00000000000003030152),('2024-07-11 09:15:00.000000',00000000000003035052),('2024-07-11 09:20:00.000000',00000000000003069040),('2024-07-11 09:25:00.000000',00000000000003070630),('2024-07-11 09:30:00.000000',00000000000003083330),('2024-07-11 09:35:00.000000',00000000000003095020),('2024-07-11 09:40:00.000000',00000000000003110299),('2024-07-11 09:45:00.000000',00000000000003128068),('2024-07-11 09:50:00.000000',00000000000003145868),('2024-07-11 09:55:00.000000',00000000000003174856),('2024-07-11 10:00:00.000000',00000000000003192652),('2024-07-11 10:05:00.000000',00000000000003251941),('2024-07-11 10:10:00.000000',00000000000003260430),('2024-07-11 10:15:00.000000',00000000000003277310),('2024-07-11 10:20:00.000000',00000000000003284210),('2024-07-11 10:25:00.000000',00000000000003296490),('2024-07-11 10:30:00.000000',00000000000003313178),('2024-07-11 10:35:00.000000',00000000000003355368),('2024-07-11 10:40:00.000000',00000000000003379946),('2024-07-11 10:45:00.000000',00000000000003405526),('2024-07-11 10:50:00.000000',00000000000003417525),('2024-07-11 10:55:00.000000',00000000000003423515),('2024-07-11 11:00:00.000000',00000000000003441971),('2024-07-11 11:05:00.000000',00000000000003454440),('2024-07-11 11:10:00.000000',00000000000003467328),('2024-07-11 11:15:00.000000',00000000000003488118),('2024-07-11 11:20:00.000000',00000000000003503907),('2024-07-11 11:25:00.000000',00000000000003552907),('2024-07-11 11:30:00.000000',00000000000003560005),('2024-07-11 11:35:00.000000',00000000000003564005),('2024-07-11 11:40:00.000000',00000000000003611483),('2024-07-11 11:45:00.000000',00000000000003640273),('2024-07-11 11:50:00.000000',00000000000003649173),('2024-07-11 11:55:00.000000',00000000000003669763),('2024-07-11 12:00:00.000000',00000000000003676663),('2024-07-11 12:05:00.000000',00000000000003685643),('2024-07-11 12:10:00.000000',00000000000003681651),('2024-07-11 12:15:00.000000',00000000000003692541),('2024-07-11 12:20:00.000000',00000000000003749210),('2024-07-11 12:25:00.000000',00000000000003777808),('2024-07-11 12:30:00.000000',00000000000003778708),('2024-07-11 12:35:00.000000',00000000000003897298),('2024-07-11 12:40:00.000000',00000000000003948386),('2024-07-11 12:45:00.000000',00000000000004006574),('2024-07-11 12:50:00.000000',00000000000004017674),('2024-07-11 12:55:00.000000',00000000000004022174),('2024-07-11 13:00:00.000000',00000000000004037924),('2024-07-11 13:05:00.000000',00000000000004068769),('2024-07-11 13:10:00.000000',00000000000004073369),('2024-07-11 13:15:00.000000',00000000000004093427),('2024-07-11 13:20:00.000000',00000000000004092137),('2024-07-11 13:25:00.000000',00000000000004117016),('2024-07-11 13:30:00.000000',00000000000004127515),('2024-07-11 13:35:00.000000',00000000000004155505),('2024-07-11 13:40:00.000000',00000000000004233275),('2024-07-11 13:45:00.000000',00000000000004265245),('2024-07-11 13:50:00.000000',00000000000004306025),('2024-07-11 13:55:00.000000',00000000000004322414),('2024-07-11 14:00:00.000000',00000000000004398274),('2024-07-11 14:05:00.000000',00000000000004408074),('2024-07-11 14:10:00.000000',00000000000004412074),('2024-07-11 14:15:00.000000',00000000000004420574),('2024-07-11 14:20:00.000000',00000000000004442464),('2024-07-11 14:25:00.000000',00000000000004502642),('2024-07-11 14:30:00.000000',00000000000004521132),('2024-07-11 14:35:00.000000',00000000000004575832),('2024-07-11 14:40:00.000000',00000000000004819422),('2024-07-11 14:45:00.000000',00000000000004870090),('2024-07-11 14:50:00.000000',00000000000004897078),('2024-07-11 14:55:00.000000',00000000000004982458),('2024-07-11 15:00:00.000000',00000000000005022236),('2024-07-11 15:05:00.000000',00000000000005100406),('2024-07-11 15:10:00.000000',00000000000005115505),('2024-07-11 15:15:00.000000',00000000000005199045),('2024-07-11 15:20:00.000000',00000000000005227131),('2024-07-11 15:25:00.000000',00000000000005250208),('2024-07-11 15:30:00.000000',00000000000005285278),('2024-07-11 15:35:00.000000',00000000000005316456),('2024-07-11 15:40:00.000000',00000000000005356934),('2024-07-11 15:45:00.000000',00000000000005374133),('2024-07-11 15:50:00.000000',00000000000005413772),('2024-07-11 15:55:00.000000',00000000000005438160),('2024-07-11 16:00:00.000000',00000000000000000000),('2024-07-11 16:05:00.000000',00000000000000048490),('2024-07-11 16:10:00.000000',00000000000000385478),('2024-07-11 16:15:00.000000',00000000000000438757),('2024-07-11 16:20:00.000000',00000000000000503746),('2024-07-11 16:25:00.000000',00000000000000529646),('2024-07-11 16:30:00.000000',00000000000000578646),('2024-07-11 16:35:00.000000',00000000000000621734),('2024-07-11 16:40:00.000000',00000000000000663921),('2024-07-11 16:45:00.000000',00000000000000704821),('2024-07-11 16:50:00.000000',00000000000000746300),('2024-07-11 16:55:00.000000',00000000000000792279),('2024-07-11 17:00:00.000000',00000000000000847369),('2024-07-11 17:05:00.000000',00000000000000885857),('2024-07-11 17:10:00.000000',00000000000000941527),('2024-07-11 17:15:00.000000',00000000000000963853),('2024-07-11 17:20:00.000000',00000000000001003661),('2024-07-11 17:25:00.000000',00000000000001034539),('2024-07-11 17:30:00.000000',00000000000001060529),('2024-07-11 17:35:00.000000',00000000000001084329),('2024-07-11 17:40:00.000000',00000000000001110207),('2024-07-11 17:45:00.000000',00000000000001126686),('2024-07-11 17:50:00.000000',00000000000001186386),('2024-07-11 17:55:00.000000',00000000000001233170),('2024-07-11 18:00:00.000000',00000000000001265050),('2024-07-11 18:05:00.000000',00000000000001303539),('2024-07-11 18:10:00.000000',00000000000001384561),('2024-07-11 18:15:00.000000',00000000000001388761),('2024-07-11 18:20:00.000000',00000000000001407161),('2024-07-11 18:25:00.000000',00000000000001447741),('2024-07-11 18:30:00.000000',00000000000001462291),('2024-07-11 18:35:00.000000',00000000000001471491),('2024-07-11 18:40:00.000000',00000000000001486949),('2024-07-11 18:45:00.000000',00000000000001503926),('2024-07-11 18:50:00.000000',00000000000001538616),('2024-07-11 18:55:00.000000',00000000000001550604),('2024-07-11 19:00:00.000000',00000000000001599882),('2024-07-11 19:05:00.000000',00000000000001621636),('2024-07-11 19:10:00.000000',00000000000001625636),('2024-07-11 19:15:00.000000',00000000000001625836),('2024-07-11 19:20:00.000000',00000000000001636826),('2024-07-11 19:25:00.000000',00000000000001643726),('2024-07-11 19:30:00.000000',00000000000001653626),('2024-07-11 19:35:00.000000',00000000000001693526),('2024-07-11 19:40:00.000000',00000000000001695526),('2024-07-11 19:45:00.000000',00000000000001691536),('2024-07-11 19:50:00.000000',00000000000001824936),('2024-07-11 19:55:00.000000',00000000000001839815),('2024-07-11 20:00:00.000000',00000000000001846695),('2024-07-11 20:05:00.000000',00000000000001852195),('2024-07-11 20:10:00.000000',00000000000001867093),('2024-07-11 20:15:00.000000',00000000000001869893),('2024-07-11 20:20:00.000000',00000000000001870893),('2024-07-11 20:25:00.000000',00000000000001870893),('2024-07-11 20:30:00.000000',00000000000001880793),('2024-07-11 20:35:00.000000',00000000000001885759),('2024-07-11 20:40:00.000000',00000000000001886759),('2024-07-11 20:45:00.000000',00000000000001887759),('2024-07-11 20:50:00.000000',00000000000001897749),('2024-07-11 20:55:00.000000',00000000000001900549),('2024-07-11 21:00:00.000000',00000000000001904749),('2024-07-11 21:05:00.000000',00000000000001904949),('2024-07-11 21:10:00.000000',00000000000001917949),('2024-07-11 21:15:00.000000',00000000000001931037),('2024-07-11 21:20:00.000000',00000000000001931037),('2024-07-11 21:25:00.000000',00000000000001936637),('2024-07-11 21:30:00.000000',00000000000001947815),('2024-07-11 21:35:00.000000',00000000000001947815),('2024-07-11 21:40:00.000000',00000000000001951715),('2024-07-11 21:45:00.000000',00000000000001966515),('2024-07-11 21:50:00.000000',00000000000001973415),('2024-07-11 21:55:00.000000',00000000000001979913),('2024-07-11 22:00:00.000000',00000000000001986911),('2024-07-11 22:05:00.000000',00000000000002005301),('2024-07-11 22:10:00.000000',00000000000002015397),('2024-07-11 22:15:00.000000',00000000000002021997),('2024-07-11 22:20:00.000000',00000000000002024997),('2024-07-11 22:25:00.000000',00000000000002027997),('2024-07-11 22:30:00.000000',00000000000002036397),('2024-07-11 22:35:00.000000',00000000000002051297),('2024-07-11 22:40:00.000000',00000000000002051397),('2024-07-11 22:45:00.000000',00000000000002058887),('2024-07-11 22:50:00.000000',00000000000002071877),('2024-07-11 22:55:00.000000',00000000000002077877),('2024-07-11 23:00:00.000000',00000000000002086777),('2024-07-11 23:05:00.000000',00000000000002095736),('2024-07-11 23:10:00.000000',00000000000002095736),('2024-07-11 23:15:00.000000',00000000000002095736),('2024-07-11 23:20:00.000000',00000000000002105136),('2024-07-11 23:25:00.000000',00000000000002109936),('2024-07-11 23:30:00.000000',00000000000002111936),('2024-07-11 23:35:00.000000',00000000000002121124),('2024-07-11 23:40:00.000000',00000000000002139004),('2024-07-11 23:45:00.000000',00000000000002148004),('2024-07-11 23:50:00.000000',00000000000002157692),('2024-07-11 23:55:00.000000',00000000000002180382),('2024-07-12 00:00:00.000000',00000000000002197362),('2024-07-12 00:05:00.000000',00000000000002203022),('2024-07-12 00:10:00.000000',00000000000002264280),('2024-07-12 00:15:00.000000',00000000000002274180),('2024-07-12 00:20:00.000000',00000000000002278780),('2024-07-12 00:25:00.000000',00000000000002288780),('2024-07-12 00:30:00.000000',00000000000002352480),('2024-07-12 00:35:00.000000',00000000000002362580),('2024-07-12 00:40:00.000000',00000000000002367580),('2024-07-12 00:45:00.000000',00000000000002392280),('2024-07-12 00:50:00.000000',00000000000002406180),('2024-07-12 00:55:00.000000',00000000000002410180),('2024-07-12 01:00:00.000000',00000000000002450580),('2024-07-12 01:05:00.000000',00000000000002461558),('2024-07-12 01:10:00.000000',00000000000002482117),('2024-07-12 01:15:00.000000',00000000000002485106),('2024-07-12 01:20:00.000000',00000000000002521285),('2024-07-12 01:25:00.000000',00000000000002530940),('2024-07-12 01:30:00.000000',00000000000002530438),('2024-07-12 01:35:00.000000',00000000000002541736),('2024-07-12 01:40:00.000000',00000000000002544136),('2024-07-12 01:45:00.000000',00000000000002566022),('2024-07-12 01:50:00.000000',00000000000002580801),('2024-07-12 01:55:00.000000',00000000000002630460),('2024-07-12 02:00:00.000000',00000000000002689450),('2024-07-12 02:05:00.000000',00000000000002713940),('2024-07-12 02:10:00.000000',00000000000002739718),('2024-07-12 02:15:00.000000',00000000000002781518),('2024-07-12 02:20:00.000000',00000000000002789508),('2024-07-12 02:25:00.000000',00000000000002814296),('2024-07-12 02:30:00.000000',00000000000002823796),('2024-07-12 02:35:00.000000',00000000000002830794),('2024-07-12 02:40:00.000000',00000000000002834793),('2024-07-12 02:45:00.000000',00000000000002853581),('2024-07-12 02:50:00.000000',00000000000002879170),('2024-07-12 02:55:00.000000',00000000000002888059),('2024-07-12 03:00:00.000000',00000000000002892258),('2024-07-12 03:05:00.000000',00000000000002903047),('2024-07-12 03:10:00.000000',00000000000002928527),('2024-07-12 03:15:00.000000',00000000000002942425),('2024-07-12 03:20:00.000000',00000000000002960215),('2024-07-12 03:25:00.000000',00000000000002987193),('2024-07-12 03:30:00.000000',00000000000002992993),('2024-07-12 03:35:00.000000',00000000000003023080),('2024-07-12 03:40:00.000000',00000000000003033570),('2024-07-12 03:45:00.000000',00000000000003034570),('2024-07-12 03:50:00.000000',00000000000003043460),('2024-07-12 03:55:00.000000',00000000000003071230),('2024-07-12 04:00:00.000000',00000000000003090204),('2024-07-12 04:05:00.000000',00000000000003113190),('2024-07-12 04:10:00.000000',00000000000003146890),('2024-07-12 04:15:00.000000',00000000000003157090),('2024-07-12 04:20:00.000000',00000000000003177490),('2024-07-12 04:25:00.000000',00000000000003200389),('2024-07-12 04:30:00.000000',00000000000003237979),('2024-07-12 04:35:00.000000',00000000000003264945),('2024-07-12 04:40:00.000000',00000000000003278845),('2024-07-12 04:45:00.000000',00000000000003292733),('2024-07-12 04:50:00.000000',00000000000003304623),('2024-07-12 04:55:00.000000',00000000000003322513),('2024-07-12 05:00:00.000000',00000000000003336561),('2024-07-12 05:05:00.000000',00000000000003348340),('2024-07-12 05:10:00.000000',00000000000003366040),('2024-07-12 05:15:00.000000',00000000000003371039),('2024-07-12 05:20:00.000000',00000000000003385539),('2024-07-12 05:25:00.000000',00000000000003389539),('2024-07-12 05:30:00.000000',00000000000003785437),('2024-07-12 05:35:00.000000',00000000000003812137),('2024-07-12 05:40:00.000000',00000000000003814137),('2024-07-12 05:45:00.000000',00000000000003816137),('2024-07-12 05:50:00.000000',00000000000003822037),('2024-07-12 05:55:00.000000',00000000000003829935),('2024-07-12 06:00:00.000000',00000000000003846635),('2024-07-12 06:05:00.000000',00000000000003846235),('2024-07-12 06:10:00.000000',00000000000003876925),('2024-07-12 06:15:00.000000',00000000000003891815),('2024-07-12 06:20:00.000000',00000000000003897815),('2024-07-12 06:25:00.000000',00000000000003925295),('2024-07-12 06:30:00.000000',00000000000003936295),('2024-07-12 06:35:00.000000',00000000000003974385),('2024-07-12 06:40:00.000000',00000000000003980372),('2024-07-12 06:45:00.000000',00000000000004002251),('2024-07-12 06:50:00.000000',00000000000004005251),('2024-07-12 06:55:00.000000',00000000000004016651),('2024-07-12 07:00:00.000000',00000000000004029551),('2024-07-12 07:05:00.000000',00000000000004053451),('2024-07-12 07:10:00.000000',00000000000004062340),('2024-07-12 07:15:00.000000',00000000000004064340),('2024-07-12 07:20:00.000000',00000000000004091830),('2024-07-12 07:25:00.000000',00000000000004099720),('2024-07-12 07:30:00.000000',00000000000004110520),('2024-07-12 07:35:00.000000',00000000000004123820),('2024-07-12 07:40:00.000000',00000000000004143720),('2024-07-12 07:45:00.000000',00000000000004165520),('2024-07-12 07:50:00.000000',00000000000004174520),('2024-07-12 07:55:00.000000',00000000000004179520),('2024-07-12 08:00:00.000000',00000000000004195400),('2024-07-12 08:05:00.000000',00000000000004197400),('2024-07-12 08:10:00.000000',00000000000004198400),('2024-07-12 08:15:00.000000',00000000000004201399),('2024-07-12 08:20:00.000000',00000000000004216299),('2024-07-12 08:25:00.000000',00000000000004234299),('2024-07-12 08:30:00.000000',00000000000004250089),('2024-07-12 08:35:00.000000',00000000000004255077),('2024-07-12 08:40:00.000000',00000000000004275677),('2024-07-12 08:45:00.000000',00000000000004290571),('2024-07-12 08:50:00.000000',00000000000004300561),('2024-07-12 08:55:00.000000',00000000000004306159),('2024-07-12 09:00:00.000000',00000000000004322159),('2024-07-12 09:05:00.000000',00000000000004343949),('2024-07-12 09:10:00.000000',00000000000004351937),('2024-07-12 09:15:00.000000',00000000000004371127),('2024-07-12 09:20:00.000000',00000000000004391207),('2024-07-12 09:25:00.000000',00000000000004397917),('2024-07-12 09:30:00.000000',00000000000004422707),('2024-07-12 09:35:00.000000',00000000000004442396),('2024-07-12 09:40:00.000000',00000000000004443396),('2024-07-12 09:45:00.000000',00000000000004461186),('2024-07-12 09:50:00.000000',00000000000004474084),('2024-07-12 09:55:00.000000',00000000000004482894),('2024-07-12 10:00:00.000000',00000000000004486894),('2024-07-12 10:05:00.000000',00000000000004502694),('2024-07-12 10:10:00.000000',00000000000004515492),('2024-07-12 10:15:00.000000',00000000000004527392),('2024-07-12 10:20:00.000000',00000000000004531390),('2024-07-12 10:25:00.000000',00000000000004540286),('2024-07-12 10:30:00.000000',00000000000004549276),('2024-07-12 10:35:00.000000',00000000000004564556),('2024-07-12 10:40:00.000000',00000000000004581346),('2024-07-12 10:45:00.000000',00000000000004592345),('2024-07-12 10:50:00.000000',00000000000004599245),('2024-07-12 10:55:00.000000',00000000000004608145),('2024-07-12 11:00:00.000000',00000000000004620545),('2024-07-12 11:05:00.000000',00000000000004623645),('2024-07-12 11:10:00.000000',00000000000004626745),('2024-07-12 11:15:00.000000',00000000000004641633),('2024-07-12 11:20:00.000000',00000000000004647633),('2024-07-12 11:25:00.000000',00000000000004654031),('2024-07-12 11:30:00.000000',00000000000004670011),('2024-07-12 11:35:00.000000',00000000000004670011),('2024-07-12 11:40:00.000000',00000000000004670011),('2024-07-12 11:45:00.000000',00000000000004693801),('2024-07-12 11:50:00.000000',00000000000004697801),('2024-07-12 11:55:00.000000',00000000000004712181),('2024-07-12 12:00:00.000000',00000000000004714781),('2024-07-12 12:05:00.000000',00000000000004729260),('2024-07-12 12:10:00.000000',00000000000004748050),('2024-07-12 12:15:00.000000',00000000000004760248),('2024-07-12 12:20:00.000000',00000000000004775138),('2024-07-12 12:25:00.000000',00000000000004785628),('2024-07-12 12:30:00.000000',00000000000004856318),('2024-07-12 12:35:00.000000',00000000000004927898),('2024-07-12 12:40:00.000000',00000000000004948688),('2024-07-12 12:45:00.000000',00000000000004958588),('2024-07-12 12:50:00.000000',00000000000004965588),('2024-07-12 12:55:00.000000',00000000000004975578),('2024-07-12 13:00:00.000000',00000000000005006058),('2024-07-12 13:05:00.000000',00000000000005017168),('2024-07-12 13:10:00.000000',00000000000005026647),('2024-07-12 13:15:00.000000',00000000000005045447),('2024-07-12 13:20:00.000000',00000000000005057537),('2024-07-12 13:25:00.000000',00000000000005101435),('2024-07-12 13:30:00.000000',00000000000005103035),('2024-07-12 13:35:00.000000',00000000000005118535),('2024-07-12 13:40:00.000000',00000000000005125523),('2024-07-12 13:45:00.000000',00000000000005146323),('2024-07-12 13:50:00.000000',00000000000005206413),('2024-07-12 13:55:00.000000',00000000000005230363),('2024-07-12 14:00:00.000000',00000000000005253351),('2024-07-12 14:05:00.000000',00000000000005286131),('2024-07-12 14:10:00.000000',00000000000005469381),('2024-07-12 14:15:00.000000',00000000000005479960),('2024-07-12 14:20:00.000000',00000000000005499348),('2024-07-12 14:25:00.000000',00000000000005511548),('2024-07-12 14:30:00.000000',00000000000005530948),('2024-07-12 14:35:00.000000',00000000000005551048),('2024-07-12 14:40:00.000000',00000000000005574938),('2024-07-12 14:45:00.000000',00000000000005617826),('2024-07-12 14:50:00.000000',00000000000005645216),('2024-07-12 14:55:00.000000',00000000000005655206),('2024-07-12 15:00:00.000000',00000000000005819385),('2024-07-12 15:05:00.000000',00000000000005822383),('2024-07-12 15:10:00.000000',00000000000005877271),('2024-07-12 15:15:00.000000',00000000000005880171),('2024-07-12 15:20:00.000000',00000000000005896051),('2024-07-12 15:25:00.000000',00000000000005913851),('2024-07-12 15:30:00.000000',00000000000005935641),('2024-07-12 15:35:00.000000',00000000000005953421),('2024-07-12 15:40:00.000000',00000000000005961400),('2024-07-12 15:45:00.000000',00000000000006001580),('2024-07-12 15:50:00.000000',00000000000006073248),('2024-07-12 15:55:00.000000',00000000000006089638),('2024-07-12 16:00:00.000000',00000000000000000000),('2024-07-12 16:05:00.000000',00000000000000018087),('2024-07-12 16:10:00.000000',00000000000000054857),('2024-07-12 16:15:00.000000',00000000000000086223),('2024-07-12 16:20:00.000000',00000000000000103212),('2024-07-12 16:25:00.000000',00000000000000122302),('2024-07-12 16:30:00.000000',00000000000000178990),('2024-07-12 16:35:00.000000',00000000000000210068),('2024-07-12 16:40:00.000000',00000000000000243848),('2024-07-12 16:45:00.000000',00000000000000268946),('2024-07-12 16:50:00.000000',00000000000000346706),('2024-07-12 16:55:00.000000',00000000000000368406),('2024-07-12 17:00:00.000000',00000000000000385494),('2024-07-12 17:05:00.000000',00000000000000506924),('2024-07-12 17:10:00.000000',00000000000000536724),('2024-07-12 17:15:00.000000',00000000000000571824),('2024-07-12 17:20:00.000000',00000000000000604493),('2024-07-12 17:25:00.000000',00000000000000641373),('2024-07-12 17:30:00.000000',00000000000000672353),('2024-07-12 17:35:00.000000',00000000000000687633),('2024-07-12 17:40:00.000000',00000000000000700513),('2024-07-12 17:45:00.000000',00000000000000714381),('2024-07-12 17:50:00.000000',00000000000000738347),('2024-07-12 17:55:00.000000',00000000000000749627),('2024-07-12 18:00:00.000000',00000000000000964495),('2024-07-12 18:05:00.000000',00000000000000982475),('2024-07-12 18:10:00.000000',00000000000001042855),('2024-07-12 18:15:00.000000',00000000000001060355),('2024-07-12 18:20:00.000000',00000000000001086745),('2024-07-12 18:25:00.000000',00000000000001096784),('2024-07-12 18:30:00.000000',00000000000001112252),('2024-07-12 18:35:00.000000',00000000000001114052),('2024-07-12 18:40:00.000000',00000000000001120852),('2024-07-12 18:45:00.000000',00000000000001140402),('2024-07-12 18:50:00.000000',00000000000001161308),('2024-07-12 18:55:00.000000',00000000000001170474),('2024-07-12 19:00:00.000000',00000000000001190754),('2024-07-12 19:05:00.000000',00000000000001205043),('2024-07-12 19:10:00.000000',00000000000001222007),('2024-07-12 19:15:00.000000',00000000000001240852),('2024-07-12 19:20:00.000000',00000000000001247341),('2024-07-12 19:25:00.000000',00000000000001281931),('2024-07-12 19:30:00.000000',00000000000001329431),('2024-07-12 19:35:00.000000',00000000000001375931),('2024-07-12 19:40:00.000000',00000000000001380831),('2024-07-12 19:45:00.000000',00000000000001381531),('2024-07-12 19:50:00.000000',00000000000001387431),('2024-07-12 19:55:00.000000',00000000000001392331),('2024-07-12 20:00:00.000000',00000000000001394931),('2024-07-12 20:05:00.000000',00000000000001402830),('2024-07-12 20:10:00.000000',00000000000001407820),('2024-07-12 20:15:00.000000',00000000000001427899),('2024-07-12 20:20:00.000000',00000000000001440789),('2024-07-12 20:25:00.000000',00000000000001446689),('2024-07-12 20:30:00.000000',00000000000001475489),('2024-07-12 20:35:00.000000',00000000000001475489),('2024-07-12 20:40:00.000000',00000000000001483389),('2024-07-12 20:45:00.000000',00000000000001498049),('2024-07-12 20:50:00.000000',00000000000001538838),('2024-07-12 20:55:00.000000',00000000000001540438),('2024-07-12 21:00:00.000000',00000000000001540438),('2024-07-12 21:05:00.000000',00000000000001545328),('2024-07-12 21:10:00.000000',00000000000001547988),('2024-07-12 21:15:00.000000',00000000000001552978),('2024-07-12 21:20:00.000000',00000000000001553968),('2024-07-12 21:25:00.000000',00000000000001553968),('2024-07-12 21:30:00.000000',00000000000001555966),('2024-07-12 21:35:00.000000',00000000000001557966),('2024-07-12 21:40:00.000000',00000000000001557966),('2024-07-12 21:45:00.000000',00000000000001558966),('2024-07-12 21:50:00.000000',00000000000001558966),('2024-07-12 21:55:00.000000',00000000000001571946),('2024-07-12 22:00:00.000000',00000000000001572945),('2024-07-12 22:05:00.000000',00000000000001610925),('2024-07-12 22:10:00.000000',00000000000001610925),('2024-07-12 22:15:00.000000',00000000000001617913),('2024-07-12 22:20:00.000000',00000000000001635713),('2024-07-12 22:25:00.000000',00000000000001647292),('2024-07-12 22:30:00.000000',00000000000001661090),('2024-07-12 22:35:00.000000',00000000000001669590),('2024-07-12 22:40:00.000000',00000000000001673490),('2024-07-12 22:45:00.000000',00000000000001682470),('2024-07-12 22:50:00.000000',00000000000001686458),('2024-07-12 22:55:00.000000',00000000000001708358),('2024-07-12 23:00:00.000000',00000000000001720758),('2024-07-12 23:05:00.000000',00000000000001730738),('2024-07-12 23:10:00.000000',00000000000001741338),('2024-07-12 23:15:00.000000',00000000000001772138),('2024-07-12 23:20:00.000000',00000000000001776128),('2024-07-12 23:25:00.000000',00000000000001778127),('2024-07-12 23:30:00.000000',00000000000001786115),('2024-07-12 23:35:00.000000',00000000000001793705),('2024-07-12 23:40:00.000000',00000000000001795694),('2024-07-12 23:45:00.000000',00000000000001804594),('2024-07-12 23:50:00.000000',00000000000001810483),('2024-07-12 23:55:00.000000',00000000000001817373),('2024-07-13 00:00:00.000000',00000000000001823771),('2024-07-13 00:05:00.000000',00000000000001823771),('2024-07-13 00:10:00.000000',00000000000001830671),('2024-07-13 00:15:00.000000',00000000000001842661),('2024-07-13 00:20:00.000000',00000000000001845161),('2024-07-13 00:25:00.000000',00000000000001846461),('2024-07-13 00:30:00.000000',00000000000001856961),('2024-07-13 00:35:00.000000',00000000000001874661),('2024-07-13 00:40:00.000000',00000000000001901531),('2024-07-13 00:45:00.000000',00000000000001908529),('2024-07-13 00:50:00.000000',00000000000001905339),('2024-07-13 00:55:00.000000',00000000000001913539),('2024-07-13 01:00:00.000000',00000000000001926439),('2024-07-13 01:05:00.000000',00000000000001937939),('2024-07-13 01:10:00.000000',00000000000001946429),('2024-07-13 01:15:00.000000',00000000000001965228),('2024-07-13 01:20:00.000000',00000000000001980928),('2024-07-13 01:25:00.000000',00000000000001998418),('2024-07-13 01:30:00.000000',00000000000002037307),('2024-07-13 01:35:00.000000',00000000000002044507),('2024-07-13 01:40:00.000000',00000000000002051507),('2024-07-13 01:45:00.000000',00000000000002069473),('2024-07-13 01:50:00.000000',00000000000002071473),('2024-07-13 01:55:00.000000',00000000000002088363),('2024-07-13 02:00:00.000000',00000000000002104242),('2024-07-13 02:05:00.000000',00000000000002113232),('2024-07-13 02:10:00.000000',00000000000002117221),('2024-07-13 02:15:00.000000',00000000000002118221),('2024-07-13 02:20:00.000000',00000000000002161201),('2024-07-13 02:25:00.000000',00000000000002169190),('2024-07-13 02:30:00.000000',00000000000002217980),('2024-07-13 02:35:00.000000',00000000000002242080),('2024-07-13 02:40:00.000000',00000000000002248970),('2024-07-13 02:45:00.000000',00000000000002252970),('2024-07-13 02:50:00.000000',00000000000002282968),('2024-07-13 02:55:00.000000',00000000000002297766),('2024-07-13 03:00:00.000000',00000000000002303166),('2024-07-13 03:05:00.000000',00000000000002307156),('2024-07-13 03:10:00.000000',00000000000002316656),('2024-07-13 03:15:00.000000',00000000000002329656),('2024-07-13 03:20:00.000000',00000000000002339646),('2024-07-13 03:25:00.000000',00000000000002354346),('2024-07-13 03:30:00.000000',00000000000002384814),('2024-07-13 03:35:00.000000',00000000000002394904),('2024-07-13 03:40:00.000000',00000000000002406694),('2024-07-13 03:45:00.000000',00000000000002425994),('2024-07-13 03:50:00.000000',00000000000002435636),('2024-07-13 03:55:00.000000',00000000000002447534),('2024-07-13 04:00:00.000000',00000000000002467234),('2024-07-13 04:05:00.000000',00000000000002478134),('2024-07-13 04:10:00.000000',00000000000002491034),('2024-07-13 04:15:00.000000',00000000000002505334),('2024-07-13 04:20:00.000000',00000000000002512030),('2024-07-13 04:25:00.000000',00000000000002522117),('2024-07-13 04:30:00.000000',00000000000002526106),('2024-07-13 04:35:00.000000',00000000000002536006),('2024-07-13 04:40:00.000000',00000000000002548895),('2024-07-13 04:45:00.000000',00000000000002562684),('2024-07-13 04:50:00.000000',00000000000002603184),('2024-07-13 04:55:00.000000',00000000000002653982),('2024-07-13 05:00:00.000000',00000000000002653982),('2024-07-13 05:05:00.000000',00000000000002676772),('2024-07-13 05:10:00.000000',00000000000002691740),('2024-07-13 05:15:00.000000',00000000000002707720),('2024-07-13 05:20:00.000000',00000000000002711718),('2024-07-13 05:25:00.000000',00000000000002744708),('2024-07-13 05:30:00.000000',00000000000002755098),('2024-07-13 05:35:00.000000',00000000000002758598),('2024-07-13 05:40:00.000000',00000000000002762398),('2024-07-13 05:45:00.000000',00000000000002760090),('2024-07-13 05:50:00.000000',00000000000002764068),('2024-07-13 05:55:00.000000',00000000000002789408),('2024-07-13 06:00:00.000000',00000000000002799308),('2024-07-13 06:05:00.000000',00000000000002813188),('2024-07-13 06:10:00.000000',00000000000002821988),('2024-07-13 06:15:00.000000',00000000000002829878),('2024-07-13 06:20:00.000000',00000000000002895678),('2024-07-13 06:25:00.000000',00000000000002917666),('2024-07-13 06:30:00.000000',00000000000002931846),('2024-07-13 06:35:00.000000',00000000000002936556),('2024-07-13 06:40:00.000000',00000000000002970756),('2024-07-13 06:45:00.000000',00000000000002986935),('2024-07-13 06:50:00.000000',00000000000002997925),('2024-07-13 06:55:00.000000',00000000000003031815),('2024-07-13 07:00:00.000000',00000000000003050504),('2024-07-13 07:05:00.000000',00000000000003058789),('2024-07-13 07:10:00.000000',00000000000003067379),('2024-07-13 07:15:00.000000',00000000000003078577),('2024-07-13 07:20:00.000000',00000000000003105104),('2024-07-13 07:25:00.000000',00000000000003110559),('2024-07-13 07:30:00.000000',00000000000003120459),('2024-07-13 07:35:00.000000',00000000000003150249),('2024-07-13 07:40:00.000000',00000000000003156228),('2024-07-13 07:45:00.000000',00000000000003160308),('2024-07-13 07:50:00.000000',00000000000003167108),('2024-07-13 07:55:00.000000',00000000000003201778),('2024-07-13 08:00:00.000000',00000000000003231458),('2024-07-13 08:05:00.000000',00000000000003243548),('2024-07-13 08:10:00.000000',00000000000003250538),('2024-07-13 08:15:00.000000',00000000000003252738),('2024-07-13 08:20:00.000000',00000000000003403138),('2024-07-13 08:25:00.000000',00000000000003415928),('2024-07-13 08:30:00.000000',00000000000003427818),('2024-07-13 08:35:00.000000',00000000000003454618),('2024-07-13 08:40:00.000000',00000000000003469408),('2024-07-13 08:45:00.000000',00000000000003475308),('2024-07-13 08:50:00.000000',00000000000003498566),('2024-07-13 08:55:00.000000',00000000000003546366),('2024-07-13 09:00:00.000000',00000000000003553464),('2024-07-13 09:05:00.000000',00000000000003561364),('2024-07-13 09:10:00.000000',00000000000003572153),('2024-07-13 09:15:00.000000',00000000000003587951),('2024-07-13 09:20:00.000000',00000000000003593730),('2024-07-13 09:25:00.000000',00000000000003595730),('2024-07-13 09:30:00.000000',00000000000003597730),('2024-07-13 09:35:00.000000',00000000000003603918),('2024-07-13 09:40:00.000000',00000000000003626777),('2024-07-13 09:45:00.000000',00000000000003655867),('2024-07-13 09:50:00.000000',00000000000003669747),('2024-07-13 09:55:00.000000',00000000000003709227),('2024-07-13 10:00:00.000000',00000000000003723106),('2024-07-13 10:05:00.000000',00000000000003749975),('2024-07-13 10:10:00.000000',00000000000003753875),('2024-07-13 10:15:00.000000',00000000000003766675),('2024-07-13 10:20:00.000000',00000000000003774665),('2024-07-13 10:25:00.000000',00000000000003804265),('2024-07-13 10:30:00.000000',00000000000003805765),('2024-07-13 10:35:00.000000',00000000000003807755),('2024-07-13 10:40:00.000000',00000000000003818545),('2024-07-13 10:45:00.000000',00000000000003826124),('2024-07-13 10:50:00.000000',00000000000003837202),('2024-07-13 10:55:00.000000',00000000000003861892),('2024-07-13 11:00:00.000000',00000000000003866872),('2024-07-13 11:05:00.000000',00000000000003890241),('2024-07-13 11:10:00.000000',00000000000003893730),('2024-07-13 11:15:00.000000',00000000000003912419),('2024-07-13 11:20:00.000000',00000000000003912419),('2024-07-13 11:25:00.000000',00000000000004004209),('2024-07-13 11:30:00.000000',00000000000004004709),('2024-07-13 11:35:00.000000',00000000000004013699),('2024-07-13 11:40:00.000000',00000000000004030379),('2024-07-13 11:45:00.000000',00000000000004036279),('2024-07-13 11:50:00.000000',00000000000004047069),('2024-07-13 11:55:00.000000',00000000000004066569),('2024-07-13 12:00:00.000000',00000000000004070469),('2024-07-13 12:05:00.000000',00000000000004076769),('2024-07-13 12:10:00.000000',00000000000004087669),('2024-07-13 12:15:00.000000',00000000000004094469),('2024-07-13 12:20:00.000000',00000000000004108259),('2024-07-13 12:25:00.000000',00000000000004110259),('2024-07-13 12:30:00.000000',00000000000004118059),('2024-07-13 12:35:00.000000',00000000000004124849),('2024-07-13 12:40:00.000000',00000000000004148639),('2024-07-13 12:45:00.000000',00000000000004137649),('2024-07-13 12:50:00.000000',00000000000004151038),('2024-07-13 12:55:00.000000',00000000000004162517),('2024-07-13 13:00:00.000000',00000000000004165717),('2024-07-13 13:05:00.000000',00000000000004189602),('2024-07-13 13:10:00.000000',00000000000004201581),('2024-07-13 13:15:00.000000',00000000000004242071),('2024-07-13 13:20:00.000000',00000000000004252061),('2024-07-13 13:25:00.000000',00000000000004278451),('2024-07-13 13:30:00.000000',00000000000004291351),('2024-07-13 13:35:00.000000',00000000000004313241),('2024-07-13 13:40:00.000000',00000000000004339931),('2024-07-13 13:45:00.000000',00000000000004392101),('2024-07-13 13:50:00.000000',00000000000004409601),('2024-07-13 13:55:00.000000',00000000000004435889),('2024-07-13 14:00:00.000000',00000000000004477167),('2024-07-13 14:05:00.000000',00000000000004523066),('2024-07-13 14:10:00.000000',00000000000004691143),('2024-07-13 14:15:00.000000',00000000000004747935),('2024-07-13 14:20:00.000000',00000000000004764135),('2024-07-13 14:25:00.000000',00000000000004769135),('2024-07-13 14:30:00.000000',00000000000004792215),('2024-07-13 14:35:00.000000',00000000000004802314),('2024-07-13 14:40:00.000000',00000000000004806314),('2024-07-13 14:45:00.000000',00000000000004838092),('2024-07-13 14:50:00.000000',00000000000004849792),('2024-07-13 14:55:00.000000',00000000000004864382),('2024-07-13 15:00:00.000000',00000000000004888772),('2024-07-13 15:05:00.000000',00000000000004894672),('2024-07-13 15:10:00.000000',00000000000004914172),('2024-07-13 15:15:00.000000',00000000000004930440),('2024-07-13 15:20:00.000000',00000000000004952619),('2024-07-13 15:25:00.000000',00000000000004977089),('2024-07-13 15:30:00.000000',00000000000005017979),('2024-07-13 15:35:00.000000',00000000000005052848),('2024-07-13 15:40:00.000000',00000000000005079748),('2024-07-13 15:45:00.000000',00000000000005117036),('2024-07-13 15:50:00.000000',00000000000005127925),('2024-07-13 15:55:00.000000',00000000000005155391),('2024-07-13 16:00:00.000000',00000000000000000000),('2024-07-13 16:05:00.000000',00000000000000044169),('2024-07-13 16:10:00.000000',00000000000000065858),('2024-07-13 16:15:00.000000',00000000000000105445),('2024-07-13 16:20:00.000000',00000000000000118445),('2024-07-13 16:25:00.000000',00000000000000136844),('2024-07-13 16:30:00.000000',00000000000000150444),('2024-07-13 16:35:00.000000',00000000000000179334),('2024-07-13 16:40:00.000000',00000000000000207862),('2024-07-13 16:45:00.000000',00000000000000255639),('2024-07-13 16:50:00.000000',00000000000000378229),('2024-07-13 16:55:00.000000',00000000000000407584),('2024-07-13 17:00:00.000000',00000000000000469482),('2024-07-13 17:05:00.000000',00000000000000499060),('2024-07-13 17:10:00.000000',00000000000000537539),('2024-07-13 17:15:00.000000',00000000000000580718),('2024-07-13 17:20:00.000000',00000000000000603505),('2024-07-13 17:25:00.000000',00000000000000661901),('2024-07-13 17:30:00.000000',00000000000000701181),('2024-07-13 17:35:00.000000',00000000000000850871),('2024-07-13 17:40:00.000000',00000000000000853070),('2024-07-13 17:45:00.000000',00000000000000963066),('2024-07-13 17:50:00.000000',00000000000000966566),('2024-07-13 17:55:00.000000',00000000000000981266),('2024-07-13 18:00:00.000000',00000000000001014456),('2024-07-13 18:05:00.000000',00000000000001036144),('2024-07-13 18:10:00.000000',00000000000001050034),('2024-07-13 18:15:00.000000',00000000000001073784),('2024-07-13 18:20:00.000000',00000000000001080874),('2024-07-13 18:25:00.000000',00000000000001084261),('2024-07-13 18:30:00.000000',00000000000001106761),('2024-07-13 18:35:00.000000',00000000000001123651),('2024-07-13 18:40:00.000000',00000000000001126731),('2024-07-13 18:45:00.000000',00000000000001150097),('2024-07-13 18:50:00.000000',00000000000001169276),('2024-07-13 18:55:00.000000',00000000000001184666),('2024-07-13 19:00:00.000000',00000000000001193866),('2024-07-13 19:05:00.000000',00000000000001239566),('2024-07-13 19:10:00.000000',00000000000001250546),('2024-07-13 19:15:00.000000',00000000000001290124),('2024-07-13 19:20:00.000000',00000000000001291124),('2024-07-13 19:25:00.000000',00000000000001323814),('2024-07-13 19:30:00.000000',00000000000001337504),('2024-07-13 19:35:00.000000',00000000000001365594),('2024-07-13 19:40:00.000000',00000000000001376974),('2024-07-13 19:45:00.000000',00000000000001405554),('2024-07-13 19:50:00.000000',00000000000001407954),('2024-07-13 19:55:00.000000',00000000000001447454),('2024-07-13 20:00:00.000000',00000000000001468244),('2024-07-13 20:05:00.000000',00000000000001474233),('2024-07-13 20:10:00.000000',00000000000001645123),('2024-07-13 20:15:00.000000',00000000000001646113),('2024-07-13 20:20:00.000000',00000000000001691013),('2024-07-13 20:25:00.000000',00000000000001699813),('2024-07-13 20:30:00.000000',00000000000001712613),('2024-07-13 20:35:00.000000',00000000000001714613),('2024-07-13 20:40:00.000000',00000000000001722502),('2024-07-13 20:45:00.000000',00000000000001724492),('2024-07-13 20:50:00.000000',00000000000001726492),('2024-07-13 20:55:00.000000',00000000000001750189),('2024-07-13 21:00:00.000000',00000000000001750189),('2024-07-13 21:05:00.000000',00000000000001781089),('2024-07-13 21:10:00.000000',00000000000001786989),('2024-07-13 21:15:00.000000',00000000000001786989),('2024-07-13 21:20:00.000000',00000000000001792979),('2024-07-13 21:25:00.000000',00000000000001793969),('2024-07-13 21:30:00.000000',00000000000001801569),('2024-07-13 21:35:00.000000',00000000000001805158),('2024-07-13 21:40:00.000000',00000000000001805158),('2024-07-13 21:45:00.000000',00000000000001806158),('2024-07-13 21:50:00.000000',00000000000001807158),('2024-07-13 21:55:00.000000',00000000000001810058),('2024-07-13 22:00:00.000000',00000000000001811058),('2024-07-13 22:05:00.000000',00000000000001817956),('2024-07-13 22:10:00.000000',00000000000001821955),('2024-07-13 22:15:00.000000',00000000000001827835),('2024-07-13 22:20:00.000000',00000000000001843633),('2024-07-13 22:25:00.000000',00000000000001846623),('2024-07-13 22:30:00.000000',00000000000001847623),('2024-07-13 22:35:00.000000',00000000000001873011),('2024-07-13 22:40:00.000000',00000000000001874011),('2024-07-13 22:45:00.000000',00000000000001878000),('2024-07-13 22:50:00.000000',00000000000001880000),('2024-07-13 22:55:00.000000',00000000000001891148),('2024-07-13 23:00:00.000000',00000000000001893148),('2024-07-13 23:05:00.000000',00000000000001914938),('2024-07-13 23:10:00.000000',00000000000001918828),('2024-07-13 23:15:00.000000',00000000000001927628),('2024-07-13 23:20:00.000000',00000000000001927628),('2024-07-13 23:25:00.000000',00000000000001942408),('2024-07-13 23:30:00.000000',00000000000001947308),('2024-07-13 23:35:00.000000',00000000000001980798),('2024-07-13 23:40:00.000000',00000000000001980798),('2024-07-13 23:45:00.000000',00000000000001980798),('2024-07-13 23:50:00.000000',00000000000001995687),('2024-07-13 23:55:00.000000',00000000000002106387),('2024-07-14 00:00:00.000000',00000000000002169686),('2024-07-14 00:05:00.000000',00000000000002200574),('2024-07-14 00:10:00.000000',00000000000002208562),('2024-07-14 00:15:00.000000',00000000000002256450),('2024-07-14 00:20:00.000000',00000000000002269850),('2024-07-14 00:25:00.000000',00000000000002279838),('2024-07-14 00:30:00.000000',00000000000002293026),('2024-07-14 00:35:00.000000',00000000000002298326),('2024-07-14 00:40:00.000000',00000000000002308326),('2024-07-14 00:45:00.000000',00000000000002311326),('2024-07-14 00:50:00.000000',00000000000002319126),('2024-07-14 00:55:00.000000',00000000000002331024),('2024-07-14 01:00:00.000000',00000000000002339422),('2024-07-14 01:05:00.000000',00000000000002347322),('2024-07-14 01:10:00.000000',00000000000002350722),('2024-07-14 01:15:00.000000',00000000000002364501),('2024-07-14 01:20:00.000000',00000000000002379381),('2024-07-14 01:25:00.000000',00000000000002382381),('2024-07-14 01:30:00.000000',00000000000002393781),('2024-07-14 01:35:00.000000',00000000000002413568),('2024-07-14 01:40:00.000000',00000000000002419568),('2024-07-14 01:45:00.000000',00000000000002425166),('2024-07-14 01:50:00.000000',00000000000002440066),('2024-07-14 01:55:00.000000',00000000000002477056),('2024-07-14 02:00:00.000000',00000000000002479736),('2024-07-14 02:05:00.000000',00000000000002483726),('2024-07-14 02:10:00.000000',00000000000002503106),('2024-07-14 02:15:00.000000',00000000000002512104),('2024-07-14 02:20:00.000000',00000000000002524594),('2024-07-14 02:25:00.000000',00000000000002550458),('2024-07-14 02:30:00.000000',00000000000002569804),('2024-07-14 02:35:00.000000',00000000000002595182),('2024-07-14 02:40:00.000000',00000000000002695730),('2024-07-14 02:45:00.000000',00000000000002730409),('2024-07-14 02:50:00.000000',00000000000002757209),('2024-07-14 02:55:00.000000',00000000000002787980),('2024-07-14 03:00:00.000000',00000000000002839460),('2024-07-14 03:05:00.000000',00000000000002906339),('2024-07-14 03:10:00.000000',00000000000002922714),('2024-07-14 03:15:00.000000',00000000000002974603),('2024-07-14 03:20:00.000000',00000000000003028471),('2024-07-14 03:25:00.000000',00000000000003051238),('2024-07-14 03:30:00.000000',00000000000003047425),('2024-07-14 03:35:00.000000',00000000000003085414),('2024-07-14 03:40:00.000000',00000000000003088403),('2024-07-14 03:45:00.000000',00000000000003100373),('2024-07-14 03:50:00.000000',00000000000003111163),('2024-07-14 03:55:00.000000',00000000000003153052),('2024-07-14 04:00:00.000000',00000000000003164242),('2024-07-14 04:05:00.000000',00000000000003188942),('2024-07-14 04:10:00.000000',00000000000003193932),('2024-07-14 04:15:00.000000',00000000000003272412),('2024-07-14 04:20:00.000000',00000000000003288291),('2024-07-14 04:25:00.000000',00000000000003294481),('2024-07-14 04:30:00.000000',00000000000003318961),('2024-07-14 04:35:00.000000',00000000000003332459),('2024-07-14 04:40:00.000000',00000000000003336459),('2024-07-14 04:45:00.000000',00000000000003351259),('2024-07-14 04:50:00.000000',00000000000003358249),('2024-07-14 04:55:00.000000',00000000000003396828),('2024-07-14 05:00:00.000000',00000000000003412206),('2024-07-14 05:05:00.000000',00000000000003434086),('2024-07-14 05:10:00.000000',00000000000003466686),('2024-07-14 05:15:00.000000',00000000000003468686),('2024-07-14 05:20:00.000000',00000000000003472675),('2024-07-14 05:25:00.000000',00000000000003482654);
INSERT INTO `vas_yoy_flow` VALUES ('2024-07-14 05:30:00.000000',00000000000003495534),('2024-07-14 05:35:00.000000',00000000000003507424),('2024-07-14 05:40:00.000000',00000000000003528202),('2024-07-14 05:45:00.000000',00000000000003540182),('2024-07-14 05:50:00.000000',00000000000003567960),('2024-07-14 05:55:00.000000',00000000000003671460),('2024-07-14 06:00:00.000000',00000000000003681349),('2024-07-14 06:05:00.000000',00000000000003691228),('2024-07-14 06:10:00.000000',00000000000003711897),('2024-07-14 06:15:00.000000',00000000000003719677),('2024-07-14 06:20:00.000000',00000000000003752367),('2024-07-14 06:25:00.000000',00000000000003808686),('2024-07-14 06:30:00.000000',00000000000003824375),('2024-07-14 06:35:00.000000',00000000000003837965),('2024-07-14 06:40:00.000000',00000000000003844765),('2024-07-14 06:45:00.000000',00000000000003862453),('2024-07-14 06:50:00.000000',00000000000003888913),('2024-07-14 06:55:00.000000',00000000000003898901),('2024-07-14 07:00:00.000000',00000000000003914701),('2024-07-14 07:05:00.000000',00000000000003920191),('2024-07-14 07:10:00.000000',00000000000003930981),('2024-07-14 07:15:00.000000',00000000000003937881),('2024-07-14 07:20:00.000000',00000000000003948671),('2024-07-14 07:25:00.000000',00000000000004017471),('2024-07-14 07:30:00.000000',00000000000004036540),('2024-07-14 07:35:00.000000',00000000000004065318),('2024-07-14 07:40:00.000000',00000000000004088198),('2024-07-14 07:45:00.000000',00000000000004156798),('2024-07-14 07:50:00.000000',00000000000004184378),('2024-07-14 07:55:00.000000',00000000000004203338),('2024-07-14 08:00:00.000000',00000000000004203338),('2024-07-14 08:05:00.000000',00000000000004230676),('2024-07-14 08:10:00.000000',00000000000004245553),('2024-07-14 08:15:00.000000',00000000000004248553),('2024-07-14 08:20:00.000000',00000000000004275532),('2024-07-14 08:25:00.000000',00000000000004288322),('2024-07-14 08:30:00.000000',00000000000004302222),('2024-07-14 08:35:00.000000',00000000000004320022),('2024-07-14 08:40:00.000000',00000000000004340111),('2024-07-14 08:45:00.000000',00000000000004340111),('2024-07-14 08:50:00.000000',00000000000004348900),('2024-07-14 08:55:00.000000',00000000000004366790),('2024-07-14 09:00:00.000000',00000000000004412880),('2024-07-14 09:05:00.000000',00000000000004422850),('2024-07-14 09:10:00.000000',00000000000004422850),('2024-07-14 09:15:00.000000',00000000000004424850),('2024-07-14 09:20:00.000000',00000000000004431827),('2024-07-14 09:25:00.000000',00000000000004446317),('2024-07-14 09:30:00.000000',00000000000004461817),('2024-07-14 09:35:00.000000',00000000000004475127),('2024-07-14 09:40:00.000000',00000000000004488917),('2024-07-14 09:45:00.000000',00000000000004493817),('2024-07-14 09:50:00.000000',00000000000004497717),('2024-07-14 09:55:00.000000',00000000000004517007),('2024-07-14 10:00:00.000000',00000000000004524595),('2024-07-14 10:05:00.000000',00000000000004532495),('2024-07-14 10:10:00.000000',00000000000004560375),('2024-07-14 10:15:00.000000',00000000000004566474),('2024-07-14 10:20:00.000000',00000000000004616633),('2024-07-14 10:25:00.000000',00000000000004637462),('2024-07-14 10:30:00.000000',00000000000004683042),('2024-07-14 10:35:00.000000',00000000000004718738),('2024-07-14 10:40:00.000000',00000000000004742528),('2024-07-14 10:45:00.000000',00000000000004749028),('2024-07-14 10:50:00.000000',00000000000004762728),('2024-07-14 10:55:00.000000',00000000000004766628),('2024-07-14 11:00:00.000000',00000000000004786418),('2024-07-14 11:05:00.000000',00000000000004829317),('2024-07-14 11:10:00.000000',00000000000004834906),('2024-07-14 11:15:00.000000',00000000000004855306),('2024-07-14 11:20:00.000000',00000000000004943772),('2024-07-14 11:25:00.000000',00000000000004946272),('2024-07-14 11:30:00.000000',00000000000004950172),('2024-07-14 11:35:00.000000',00000000000004960071),('2024-07-14 11:40:00.000000',00000000000004962071),('2024-07-14 11:45:00.000000',00000000000004980861),('2024-07-14 11:50:00.000000',00000000000004985861),('2024-07-14 11:55:00.000000',00000000000005022351),('2024-07-14 12:00:00.000000',00000000000005034251),('2024-07-14 12:05:00.000000',00000000000005056940),('2024-07-14 12:10:00.000000',00000000000005060940),('2024-07-14 12:15:00.000000',00000000000005075840),('2024-07-14 12:20:00.000000',00000000000005096139),('2024-07-14 12:25:00.000000',00000000000005109029),('2024-07-14 12:30:00.000000',00000000000005183387),('2024-07-14 12:35:00.000000',00000000000005190941),('2024-07-14 12:40:00.000000',00000000000005297931),('2024-07-14 12:45:00.000000',00000000000005291231),('2024-07-14 12:50:00.000000',00000000000005304031),('2024-07-14 12:55:00.000000',00000000000005311831),('2024-07-14 13:00:00.000000',00000000000005322330),('2024-07-14 13:05:00.000000',00000000000005316303),('2024-07-14 13:10:00.000000',00000000000005321480),('2024-07-14 13:15:00.000000',00000000000005343180),('2024-07-14 13:20:00.000000',00000000000005376048),('2024-07-14 13:25:00.000000',00000000000005412338),('2024-07-14 13:30:00.000000',00000000000005433904),('2024-07-14 13:35:00.000000',00000000000005449689),('2024-07-14 13:40:00.000000',00000000000005454689),('2024-07-14 13:45:00.000000',00000000000005463579),('2024-07-14 13:50:00.000000',00000000000005472177),('2024-07-14 13:55:00.000000',00000000000005487754),('2024-07-14 14:00:00.000000',00000000000005498554),('2024-07-14 14:05:00.000000',00000000000005530254),('2024-07-14 14:10:00.000000',00000000000005556942),('2024-07-14 14:15:00.000000',00000000000005570832),('2024-07-14 14:20:00.000000',00000000000005603720),('2024-07-14 14:25:00.000000',00000000000005615178),('2024-07-14 14:30:00.000000',00000000000005657468),('2024-07-14 14:35:00.000000',00000000000005665468),('2024-07-14 14:40:00.000000',00000000000005709966),('2024-07-14 14:45:00.000000',00000000000005779734),('2024-07-14 14:50:00.000000',00000000000005812114),('2024-07-14 14:55:00.000000',00000000000005827604),('2024-07-14 15:00:00.000000',00000000000005844392),('2024-07-14 15:05:00.000000',00000000000005882492),('2024-07-14 15:10:00.000000',00000000000005933182),('2024-07-14 15:15:00.000000',00000000000005982772),('2024-07-14 15:20:00.000000',00000000000006021061),('2024-07-14 15:25:00.000000',00000000000006052151),('2024-07-14 15:30:00.000000',00000000000006080531),('2024-07-14 15:35:00.000000',00000000000006126690),('2024-07-14 15:40:00.000000',00000000000006144588),('2024-07-14 15:45:00.000000',00000000000006182078),('2024-07-14 15:50:00.000000',00000000000006254257),('2024-07-14 15:55:00.000000',00000000000006297827),('2024-07-14 16:00:00.000000',00000000000000000000),('2024-07-14 16:05:00.000000',00000000000000034918),('2024-07-14 16:10:00.000000',00000000000000083398),('2024-07-14 16:15:00.000000',00000000000000111698),('2024-07-14 16:20:00.000000',00000000000000142778),('2024-07-14 16:25:00.000000',00000000000000209668),('2024-07-14 16:30:00.000000',00000000000000261258),('2024-07-14 16:35:00.000000',00000000000000310838),('2024-07-14 16:40:00.000000',00000000000000369118),('2024-07-14 16:45:00.000000',00000000000000431306),('2024-07-14 16:50:00.000000',00000000000000447706),('2024-07-14 16:55:00.000000',00000000000000467585),('2024-07-14 17:00:00.000000',00000000000000470574),('2024-07-14 17:05:00.000000',00000000000000498653),('2024-07-14 17:10:00.000000',00000000000000509132),('2024-07-14 17:15:00.000000',00000000000000567810),('2024-07-14 17:20:00.000000',00000000000000581998),('2024-07-14 17:25:00.000000',00000000000000604688),('2024-07-14 17:30:00.000000',00000000000000619588),('2024-07-14 17:35:00.000000',00000000000000626886),('2024-07-14 17:40:00.000000',00000000000000680886),('2024-07-14 17:45:00.000000',00000000000000717466),('2024-07-14 17:50:00.000000',00000000000000732366),('2024-07-14 17:55:00.000000',00000000000000809942),('2024-07-14 18:00:00.000000',00000000000000849040),('2024-07-14 18:05:00.000000',00000000000000861838),('2024-07-14 18:10:00.000000',00000000000000880536),('2024-07-14 18:15:00.000000',00000000000000896034),('2024-07-14 18:20:00.000000',00000000000000902792),('2024-07-14 18:25:00.000000',00000000000000910790),('2024-07-14 18:30:00.000000',00000000000001021588),('2024-07-14 18:35:00.000000',00000000000001030978),('2024-07-14 18:40:00.000000',00000000000001043876),('2024-07-14 18:45:00.000000',00000000000001068964),('2024-07-14 18:50:00.000000',00000000000001112164),('2024-07-14 18:55:00.000000',00000000000001115164),('2024-07-14 19:00:00.000000',00000000000001125264),('2024-07-14 19:05:00.000000',00000000000001122864),('2024-07-14 19:10:00.000000',00000000000001129864),('2024-07-14 19:15:00.000000',00000000000001155464),('2024-07-14 19:20:00.000000',00000000000001175564),('2024-07-14 19:25:00.000000',00000000000001260654),('2024-07-14 19:30:00.000000',00000000000001265244),('2024-07-14 19:35:00.000000',00000000000001272442),('2024-07-14 19:40:00.000000',00000000000001282340),('2024-07-14 19:45:00.000000',00000000000001286006),('2024-07-14 19:50:00.000000',00000000000001298106),('2024-07-14 19:55:00.000000',00000000000001311706),('2024-07-14 20:00:00.000000',00000000000001336785),('2024-07-14 20:05:00.000000',00000000000001394587),('2024-07-14 20:10:00.000000',00000000000001399487),('2024-07-14 20:15:00.000000',00000000000001414287),('2024-07-14 20:20:00.000000',00000000000001410287),('2024-07-14 20:25:00.000000',00000000000001413287),('2024-07-14 20:30:00.000000',00000000000001417885),('2024-07-14 20:35:00.000000',00000000000001437364),('2024-07-14 20:40:00.000000',00000000000001438354),('2024-07-14 20:45:00.000000',00000000000001438354),('2024-07-14 20:50:00.000000',00000000000001439354),('2024-07-14 20:55:00.000000',00000000000001439354),('2024-07-14 21:00:00.000000',00000000000001445344),('2024-07-14 21:05:00.000000',00000000000001452443),('2024-07-14 21:10:00.000000',00000000000001464331),('2024-07-14 21:15:00.000000',00000000000001473131),('2024-07-14 21:20:00.000000',00000000000001486931),('2024-07-14 21:25:00.000000',00000000000001493929),('2024-07-14 21:30:00.000000',00000000000001502829),('2024-07-14 21:35:00.000000',00000000000001503829),('2024-07-14 21:40:00.000000',00000000000001511727),('2024-07-14 21:45:00.000000',00000000000001526507),('2024-07-14 21:50:00.000000',00000000000001526507),('2024-07-14 21:55:00.000000',00000000000001526507),('2024-07-14 22:00:00.000000',00000000000001526507),('2024-07-14 22:05:00.000000',00000000000001527507),('2024-07-14 22:10:00.000000',00000000000001534497),('2024-07-14 22:15:00.000000',00000000000001534497),('2024-07-14 22:20:00.000000',00000000000001536497),('2024-07-14 22:25:00.000000',00000000000001537497),('2024-07-14 22:30:00.000000',00000000000001539486),('2024-07-14 22:35:00.000000',00000000000001544376),('2024-07-14 22:40:00.000000',00000000000001555366),('2024-07-14 22:45:00.000000',00000000000001566956),('2024-07-14 22:50:00.000000',00000000000001578856),('2024-07-14 22:55:00.000000',00000000000001586846),('2024-07-14 23:00:00.000000',00000000000001590646),('2024-07-14 23:05:00.000000',00000000000001592546),('2024-07-14 23:10:00.000000',00000000000001601536),('2024-07-14 23:15:00.000000',00000000000001609436),('2024-07-14 23:20:00.000000',00000000000001628315),('2024-07-14 23:25:00.000000',00000000000001630304),('2024-07-14 23:30:00.000000',00000000000001650104),('2024-07-14 23:35:00.000000',00000000000001657102),('2024-07-14 23:40:00.000000',00000000000001673002),('2024-07-14 23:45:00.000000',00000000000001685992),('2024-07-14 23:50:00.000000',00000000000001703671),('2024-07-14 23:55:00.000000',00000000000001708571),('2024-07-15 00:00:00.000000',00000000000001718471),('2024-07-15 00:05:00.000000',00000000000001752381),('2024-07-15 00:10:00.000000',00000000000001769081),('2024-07-15 00:15:00.000000',00000000000001784971),('2024-07-15 00:20:00.000000',00000000000001788871),('2024-07-15 00:25:00.000000',00000000000002089869),('2024-07-15 00:30:00.000000',00000000000002091859),('2024-07-15 00:35:00.000000',00000000000002097759),('2024-07-15 00:40:00.000000',00000000000002096759),('2024-07-15 00:45:00.000000',00000000000002096761),('2024-07-15 00:50:00.000000',00000000000002102151),('2024-07-15 00:55:00.000000',00000000000002136730),('2024-07-15 01:00:00.000000',00000000000002146630),('2024-07-15 01:05:00.000000',00000000000002163880),('2024-07-15 01:10:00.000000',00000000000002173469),('2024-07-15 01:15:00.000000',00000000000002184459),('2024-07-15 01:20:00.000000',00000000000002198259),('2024-07-15 01:25:00.000000',00000000000002204159),('2024-07-15 01:30:00.000000',00000000000002209149),('2024-07-15 01:35:00.000000',00000000000002209149),('2024-07-15 01:40:00.000000',00000000000002224949),('2024-07-15 01:45:00.000000',00000000000002294849),('2024-07-15 01:50:00.000000',00000000000002313539),('2024-07-15 01:55:00.000000',00000000000002328535),('2024-07-15 02:00:00.000000',00000000000002339523),('2024-07-15 02:05:00.000000',00000000000002344511),('2024-07-15 02:10:00.000000',00000000000002477411),('2024-07-15 02:15:00.000000',00000000000002485311),('2024-07-15 02:20:00.000000',00000000000002506011),('2024-07-15 02:25:00.000000',00000000000002636911),('2024-07-15 02:30:00.000000',00000000000002649701),('2024-07-15 02:35:00.000000',00000000000002661601),('2024-07-15 02:40:00.000000',00000000000002672381),('2024-07-15 02:45:00.000000',00000000000002695781),('2024-07-15 02:50:00.000000',00000000000002716571),('2024-07-15 02:55:00.000000',00000000000002705681),('2024-07-15 03:00:00.000000',00000000000002727491),('2024-07-15 03:05:00.000000',00000000000002727491),('2024-07-15 03:10:00.000000',00000000000002728751),('2024-07-15 03:15:00.000000',00000000000002784930),('2024-07-15 03:20:00.000000',00000000000002798796),('2024-07-15 03:25:00.000000',00000000000002882008),('2024-07-15 03:30:00.000000',00000000000002889996),('2024-07-15 03:35:00.000000',00000000000002907756),('2024-07-15 03:40:00.000000',00000000000002934434),('2024-07-15 03:45:00.000000',00000000000002952302),('2024-07-15 03:50:00.000000',00000000000002967168),('2024-07-15 03:55:00.000000',00000000000003038131),('2024-07-15 04:00:00.000000',00000000000003050021),('2024-07-15 04:05:00.000000',00000000000003050021),('2024-07-15 04:10:00.000000',00000000000003061501),('2024-07-15 04:15:00.000000',00000000000003077951),('2024-07-15 04:20:00.000000',00000000000003091541),('2024-07-15 04:25:00.000000',00000000000003119800),('2024-07-15 04:30:00.000000',00000000000003132690),('2024-07-15 04:35:00.000000',00000000000003147068),('2024-07-15 04:40:00.000000',00000000000003162934),('2024-07-15 04:45:00.000000',00000000000003182822),('2024-07-15 04:50:00.000000',00000000000003195522),('2024-07-15 04:55:00.000000',00000000000003210912),('2024-07-15 05:00:00.000000',00000000000003265101),('2024-07-15 05:05:00.000000',00000000000003265109),('2024-07-15 05:10:00.000000',00000000000003276088),('2024-07-15 05:15:00.000000',00000000000003276088),('2024-07-15 05:20:00.000000',00000000000003300958),('2024-07-15 05:25:00.000000',00000000000003314918),('2024-07-15 05:30:00.000000',00000000000003336697),('2024-07-15 05:35:00.000000',00000000000003347277),('2024-07-15 05:40:00.000000',00000000000003371407),('2024-07-15 05:45:00.000000',00000000000003406555),('2024-07-15 05:50:00.000000',00000000000003433405),('2024-07-15 05:55:00.000000',00000000000003474175),('2024-07-15 06:00:00.000000',00000000000003480154),('2024-07-15 06:05:00.000000',00000000000003491044),('2024-07-15 06:10:00.000000',00000000000003527632),('2024-07-15 06:15:00.000000',00000000000003574412),('2024-07-15 06:20:00.000000',00000000000003593302),('2024-07-15 06:25:00.000000',00000000000003610881),('2024-07-15 06:30:00.000000',00000000000003613869),('2024-07-15 06:35:00.000000',00000000000003742559),('2024-07-15 06:40:00.000000',00000000000003746757),('2024-07-15 06:45:00.000000',00000000000003767039),('2024-07-15 06:50:00.000000',00000000000003810539),('2024-07-15 06:55:00.000000',00000000000003806549),('2024-07-15 07:00:00.000000',00000000000003862098),('2024-07-15 07:05:00.000000',00000000000003883798),('2024-07-15 07:10:00.000000',00000000000003895696),('2024-07-15 07:15:00.000000',00000000000003921296),('2024-07-15 07:20:00.000000',00000000000003933686),('2024-07-15 07:25:00.000000',00000000000003943576),('2024-07-15 07:30:00.000000',00000000000003954556),('2024-07-15 07:35:00.000000',00000000000003961546),('2024-07-15 07:40:00.000000',00000000000003965444),('2024-07-15 07:45:00.000000',00000000000003987044),('2024-07-15 07:50:00.000000',00000000000004182644),('2024-07-15 07:55:00.000000',00000000000004193544),('2024-07-15 08:00:00.000000',00000000000004206434),('2024-07-15 08:05:00.000000',00000000000004216224),('2024-07-15 08:10:00.000000',00000000000004236104),('2024-07-15 08:15:00.000000',00000000000004245004),('2024-07-15 08:20:00.000000',00000000000004279894),('2024-07-15 08:25:00.000000',00000000000004283872),('2024-07-15 08:30:00.000000',00000000000004308670),('2024-07-15 08:35:00.000000',00000000000004312070),('2024-07-15 08:40:00.000000',00000000000004315970),('2024-07-15 08:45:00.000000',00000000000004331739),('2024-07-15 08:50:00.000000',00000000000004361597),('2024-07-15 08:55:00.000000',00000000000004370577),('2024-07-15 09:00:00.000000',00000000000004366667),('2024-07-15 09:05:00.000000',00000000000004371645),('2024-07-15 09:10:00.000000',00000000000004378544),('2024-07-15 09:15:00.000000',00000000000004385523),('2024-07-15 09:20:00.000000',00000000000004398883),('2024-07-15 09:25:00.000000',00000000000004412861),('2024-07-15 09:30:00.000000',00000000000004434651),('2024-07-15 09:35:00.000000',00000000000004457321),('2024-07-15 09:40:00.000000',00000000000004465221),('2024-07-15 09:45:00.000000',00000000000004470211),('2024-07-15 09:50:00.000000',00000000000004490081),('2024-07-15 09:55:00.000000',00000000000004498881),('2024-07-15 10:00:00.000000',00000000000004506781),('2024-07-15 10:05:00.000000',00000000000004516581),('2024-07-15 10:10:00.000000',00000000000004514779),('2024-07-15 10:15:00.000000',00000000000004532477),('2024-07-15 10:20:00.000000',00000000000004549367),('2024-07-15 10:25:00.000000',00000000000004564465),('2024-07-15 10:30:00.000000',00000000000004604945),('2024-07-15 10:35:00.000000',00000000000004614835),('2024-07-15 10:40:00.000000',00000000000004628135),('2024-07-15 10:45:00.000000',00000000000004626135),('2024-07-15 10:50:00.000000',00000000000004655004),('2024-07-15 10:55:00.000000',00000000000004679793),('2024-07-15 11:00:00.000000',00000000000004749473),('2024-07-15 11:05:00.000000',00000000000004774173),('2024-07-15 11:10:00.000000',00000000000004788962),('2024-07-15 11:15:00.000000',00000000000004815651),('2024-07-15 11:20:00.000000',00000000000004822528),('2024-07-15 11:25:00.000000',00000000000004848946),('2024-07-15 11:30:00.000000',00000000000004892191),('2024-07-15 11:35:00.000000',00000000000004893691),('2024-07-15 11:40:00.000000',00000000000004913491),('2024-07-15 11:45:00.000000',00000000000004928281),('2024-07-15 11:50:00.000000',00000000000004928281),('2024-07-15 11:55:00.000000',00000000000004936181),('2024-07-15 12:00:00.000000',00000000000004936181),('2024-07-15 12:05:00.000000',00000000000004950281),('2024-07-15 12:10:00.000000',00000000000004972761),('2024-07-15 12:15:00.000000',00000000000004979751),('2024-07-15 12:20:00.000000',00000000000004996749),('2024-07-15 12:25:00.000000',00000000000005006449),('2024-07-15 12:30:00.000000',00000000000005042839),('2024-07-15 12:35:00.000000',00000000000005059309),('2024-07-15 12:40:00.000000',00000000000005091499),('2024-07-15 12:45:00.000000',00000000000005116979),('2024-07-15 12:50:00.000000',00000000000005134778),('2024-07-15 12:55:00.000000',00000000000005161392),('2024-07-15 13:00:00.000000',00000000000005169471),('2024-07-15 13:05:00.000000',00000000000005169471),('2024-07-15 13:10:00.000000',00000000000005220959),('2024-07-15 13:15:00.000000',00000000000005231859),('2024-07-15 13:20:00.000000',00000000000005259348),('2024-07-15 13:25:00.000000',00000000000005276236),('2024-07-15 13:30:00.000000',00000000000005294115),('2024-07-15 13:35:00.000000',00000000000005305815),('2024-07-15 13:40:00.000000',00000000000005321293),('2024-07-15 13:45:00.000000',00000000000005388473),('2024-07-15 13:50:00.000000',00000000000005401863),('2024-07-15 13:55:00.000000',00000000000005424452),('2024-07-15 14:00:00.000000',00000000000005448252),('2024-07-15 14:05:00.000000',00000000000005455219),('2024-07-15 14:10:00.000000',00000000000005469409),('2024-07-15 14:15:00.000000',00000000000005504165),('2024-07-15 14:20:00.000000',00000000000005527245),('2024-07-15 14:25:00.000000',00000000000005542045),('2024-07-15 14:30:00.000000',00000000000005545534),('2024-07-15 14:35:00.000000',00000000000005553444),('2024-07-15 14:40:00.000000',00000000000005591114),('2024-07-15 14:45:00.000000',00000000000005605993),('2024-07-15 14:50:00.000000',00000000000005650643),('2024-07-15 14:55:00.000000',00000000000005662622),('2024-07-15 15:00:00.000000',00000000000005691368),('2024-07-15 15:05:00.000000',00000000000005733357),('2024-07-15 15:10:00.000000',00000000000005748247),('2024-07-15 15:15:00.000000',00000000000005763147),('2024-07-15 15:20:00.000000',00000000000005783747),('2024-07-15 15:25:00.000000',00000000000005795327),('2024-07-15 15:30:00.000000',00000000000005819104),('2024-07-15 15:35:00.000000',00000000000005819194),('2024-07-15 15:40:00.000000',00000000000005855750),('2024-07-15 15:45:00.000000',00000000000005863919),('2024-07-15 15:50:00.000000',00000000000005949286),('2024-07-15 15:55:00.000000',00000000000005995886),('2024-07-15 16:00:00.000000',00000000000000000000),('2024-07-15 16:05:00.000000',00000000000000024789),('2024-07-15 16:10:00.000000',00000000000000056269),('2024-07-15 16:15:00.000000',00000000000000085959),('2024-07-15 16:20:00.000000',00000000000000169439),('2024-07-15 16:25:00.000000',00000000000000221127),('2024-07-15 16:30:00.000000',00000000000000257707),('2024-07-15 16:35:00.000000',00000000000000285481),('2024-07-15 16:40:00.000000',00000000000000368371),('2024-07-15 16:45:00.000000',00000000000000385957),('2024-07-15 16:50:00.000000',00000000000000408197),('2024-07-15 16:55:00.000000',00000000000000444897),('2024-07-15 17:00:00.000000',00000000000000489176),('2024-07-15 17:05:00.000000',00000000000000526956),('2024-07-15 17:10:00.000000',00000000000000549536),('2024-07-15 17:15:00.000000',00000000000000554936),('2024-07-15 17:20:00.000000',00000000000000575425),('2024-07-15 17:25:00.000000',00000000000000584825),('2024-07-15 17:30:00.000000',00000000000000597425),('2024-07-15 17:35:00.000000',00000000000000618475),('2024-07-15 17:40:00.000000',00000000000000633965),('2024-07-15 17:45:00.000000',00000000000000638365),('2024-07-15 17:50:00.000000',00000000000000655545),('2024-07-15 17:55:00.000000',00000000000000689335),('2024-07-15 18:00:00.000000',00000000000000712235),('2024-07-15 18:05:00.000000',00000000000000752225),('2024-07-15 18:10:00.000000',00000000000000777022),('2024-07-15 18:15:00.000000',00000000000000851089),('2024-07-15 18:20:00.000000',00000000000000876347),('2024-07-15 18:25:00.000000',00000000000000893147),('2024-07-15 18:30:00.000000',00000000000000922143),('2024-07-15 18:35:00.000000',00000000000000941943),('2024-07-15 18:40:00.000000',00000000000000944033),('2024-07-15 18:45:00.000000',00000000000000948033),('2024-07-15 18:50:00.000000',00000000000000964931),('2024-07-15 18:55:00.000000',00000000000000981421),('2024-07-15 19:00:00.000000',00000000000001003015),('2024-07-15 19:05:00.000000',00000000000001009514),('2024-07-15 19:10:00.000000',00000000000001036704),('2024-07-15 19:15:00.000000',00000000000001041604),('2024-07-15 19:20:00.000000',00000000000001043604),('2024-07-15 19:25:00.000000',00000000000001046602),('2024-07-15 19:30:00.000000',00000000000001090502),('2024-07-15 19:35:00.000000',00000000000001095102),('2024-07-15 19:40:00.000000',00000000000001115092),('2024-07-15 19:45:00.000000',00000000000001118092),('2024-07-15 19:50:00.000000',00000000000001127072),('2024-07-15 19:55:00.000000',00000000000001127372),('2024-07-15 20:00:00.000000',00000000000001130370),('2024-07-15 20:05:00.000000',00000000000001139270),('2024-07-15 20:10:00.000000',00000000000001144470),('2024-07-15 20:15:00.000000',00000000000001150970),('2024-07-15 20:20:00.000000',00000000000001166170),('2024-07-15 20:25:00.000000',00000000000001180960),('2024-07-15 20:30:00.000000',00000000000001185860),('2024-07-15 20:35:00.000000',00000000000001193250),('2024-07-15 20:40:00.000000',00000000000001232049),('2024-07-15 20:45:00.000000',00000000000001242939),('2024-07-15 20:50:00.000000',00000000000001252929),('2024-07-15 20:55:00.000000',00000000000001263908),('2024-07-15 21:00:00.000000',00000000000001264508),('2024-07-15 21:05:00.000000',00000000000001273476),('2024-07-15 21:10:00.000000',00000000000001288276),('2024-07-15 21:15:00.000000',00000000000001290265),('2024-07-15 21:20:00.000000',00000000000001291765),('2024-07-15 21:25:00.000000',00000000000001293765),('2024-07-15 21:30:00.000000',00000000000001292765),('2024-07-15 21:35:00.000000',00000000000001299665),('2024-07-15 21:40:00.000000',00000000000001302665),('2024-07-15 21:45:00.000000',00000000000001302665),('2024-07-15 21:50:00.000000',00000000000001302665),('2024-07-15 21:55:00.000000',00000000000001302665),('2024-07-15 22:00:00.000000',00000000000001313645),('2024-07-15 22:05:00.000000',00000000000001322545),('2024-07-15 22:10:00.000000',00000000000001315645),('2024-07-15 22:15:00.000000',00000000000001316645),('2024-07-15 22:20:00.000000',00000000000001330535),('2024-07-15 22:25:00.000000',00000000000001335525),('2024-07-15 22:30:00.000000',00000000000001338514),('2024-07-15 22:35:00.000000',00000000000001349494),('2024-07-15 22:40:00.000000',00000000000001351494),('2024-07-15 22:45:00.000000',00000000000001352494),('2024-07-15 22:50:00.000000',00000000000001359481),('2024-07-15 22:55:00.000000',00000000000001378271),('2024-07-15 23:00:00.000000',00000000000001403961),('2024-07-15 23:05:00.000000',00000000000001405961),('2024-07-15 23:10:00.000000',00000000000001410341),('2024-07-15 23:15:00.000000',00000000000001413641),('2024-07-15 23:20:00.000000',00000000000001426141),('2024-07-15 23:25:00.000000',00000000000001434339),('2024-07-15 23:30:00.000000',00000000000001441839),('2024-07-15 23:35:00.000000',00000000000001451339),('2024-07-15 23:40:00.000000',00000000000001458317),('2024-07-15 23:45:00.000000',00000000000001460517),('2024-07-15 23:50:00.000000',00000000000001461717),('2024-07-15 23:55:00.000000',00000000000001472217),('2024-07-16 00:00:00.000000',00000000000001482707),('2024-07-16 00:05:00.000000',00000000000001486707),('2024-07-16 00:10:00.000000',00000000000001498105),('2024-07-16 00:15:00.000000',00000000000001510495),('2024-07-16 00:20:00.000000',00000000000001511495),('2024-07-16 00:25:00.000000',00000000000001511695),('2024-07-16 00:30:00.000000',00000000000001521585),('2024-07-16 00:35:00.000000',00000000000001539875),('2024-07-16 00:40:00.000000',00000000000001584675),('2024-07-16 00:45:00.000000',00000000000001607473),('2024-07-16 00:50:00.000000',00000000000001621371),('2024-07-16 00:55:00.000000',00000000000001630361),('2024-07-16 01:00:00.000000',00000000000001631161),('2024-07-16 01:05:00.000000',00000000000001639250),('2024-07-16 01:10:00.000000',00000000000001961450),('2024-07-16 01:15:00.000000',00000000000001990230),('2024-07-16 01:20:00.000000',00000000000001993130),('2024-07-16 01:25:00.000000',00000000000002017808),('2024-07-16 01:30:00.000000',00000000000002036098),('2024-07-16 01:35:00.000000',00000000000002057967),('2024-07-16 01:40:00.000000',00000000000002059967),('2024-07-16 01:45:00.000000',00000000000002073826),('2024-07-16 01:50:00.000000',00000000000002103915),('2024-07-16 01:55:00.000000',00000000000002124415),('2024-07-16 02:00:00.000000',00000000000002145995),('2024-07-16 02:05:00.000000',00000000000002178283),('2024-07-16 02:10:00.000000',00000000000002188273),('2024-07-16 02:15:00.000000',00000000000002206073),('2024-07-16 02:20:00.000000',00000000000002225153),('2024-07-16 02:25:00.000000',00000000000002249051),('2024-07-16 02:30:00.000000',00000000000002256251),('2024-07-16 02:35:00.000000',00000000000002268051),('2024-07-16 02:40:00.000000',00000000000002287841),('2024-07-16 02:45:00.000000',00000000000002301541),('2024-07-16 02:50:00.000000',00000000000002322818),('2024-07-16 02:55:00.000000',00000000000002330718),('2024-07-16 03:00:00.000000',00000000000002341418),('2024-07-16 03:05:00.000000',00000000000002352374),('2024-07-16 03:10:00.000000',00000000000002364941),('2024-07-16 03:15:00.000000',00000000000002393388),('2024-07-16 03:20:00.000000',00000000000002405458),('2024-07-16 03:25:00.000000',00000000000002419158),('2024-07-16 03:30:00.000000',00000000000002432038),('2024-07-16 03:35:00.000000',00000000000002451326),('2024-07-16 03:40:00.000000',00000000000002461916),('2024-07-16 03:45:00.000000',00000000000002482266),('2024-07-16 03:50:00.000000',00000000000002490256),('2024-07-16 03:55:00.000000',00000000000002521026),('2024-07-16 04:00:00.000000',00000000000002521026),('2024-07-16 04:05:00.000000',00000000000002539295),('2024-07-16 04:10:00.000000',00000000000002590674),('2024-07-16 04:15:00.000000',00000000000002604153),('2024-07-16 04:20:00.000000',00000000000002662623),('2024-07-16 04:25:00.000000',00000000000002708403),('2024-07-16 04:30:00.000000',00000000000002735283),('2024-07-16 04:35:00.000000',00000000000002753873),('2024-07-16 04:40:00.000000',00000000000002763782),('2024-07-16 04:45:00.000000',00000000000002781662),('2024-07-16 04:50:00.000000',00000000000002785651),('2024-07-16 04:55:00.000000',00000000000002808131),('2024-07-16 05:00:00.000000',00000000000002907461),('2024-07-16 05:05:00.000000',00000000000002915841),('2024-07-16 05:10:00.000000',00000000000002934710),('2024-07-16 05:15:00.000000',00000000000002965220),('2024-07-16 05:20:00.000000',00000000000003125154),('2024-07-16 05:25:00.000000',00000000000003158844),('2024-07-16 05:30:00.000000',00000000000003171004),('2024-07-16 05:35:00.000000',00000000000003183384),('2024-07-16 05:40:00.000000',00000000000003206332),('2024-07-16 05:45:00.000000',00000000000003208332),('2024-07-16 05:50:00.000000',00000000000003217782),('2024-07-16 05:55:00.000000',00000000000003258262),('2024-07-16 06:00:00.000000',00000000000003286480),('2024-07-16 06:05:00.000000',00000000000003309169),('2024-07-16 06:10:00.000000',00000000000003338017),('2024-07-16 06:15:00.000000',00000000000003360697),('2024-07-16 06:20:00.000000',00000000000003371597),('2024-07-16 06:25:00.000000',00000000000003393966),('2024-07-16 06:30:00.000000',00000000000003422526),('2024-07-16 06:35:00.000000',00000000000003438316),('2024-07-16 06:40:00.000000',00000000000003442306),('2024-07-16 06:45:00.000000',00000000000003472943),('2024-07-16 06:50:00.000000',00000000000003476543),('2024-07-16 06:55:00.000000',00000000000003504923),('2024-07-16 07:00:00.000000',00000000000003515492),('2024-07-16 07:05:00.000000',00000000000003548048),('2024-07-16 07:10:00.000000',00000000000003562115),('2024-07-16 07:15:00.000000',00000000000003590808),('2024-07-16 07:20:00.000000',00000000000003604577),('2024-07-16 07:25:00.000000',00000000000003624244),('2024-07-16 07:30:00.000000',00000000000003645023),('2024-07-16 07:35:00.000000',00000000000003669823),('2024-07-16 07:40:00.000000',00000000000003729512),('2024-07-16 07:45:00.000000',00000000000003740302),('2024-07-16 07:50:00.000000',00000000000003761100),('2024-07-16 07:55:00.000000',00000000000003762100),('2024-07-16 08:00:00.000000',00000000000003772600),('2024-07-16 08:05:00.000000',00000000000003779700),('2024-07-16 08:10:00.000000',00000000000003805290),('2024-07-16 08:15:00.000000',00000000000003839058),('2024-07-16 08:20:00.000000',00000000000003871726),('2024-07-16 08:25:00.000000',00000000000003895926),('2024-07-16 08:30:00.000000',00000000000003902926),('2024-07-16 08:35:00.000000',00000000000003917726),('2024-07-16 08:40:00.000000',00000000000003924616),('2024-07-16 08:45:00.000000',00000000000003937906),('2024-07-16 08:50:00.000000',00000000000003947196),('2024-07-16 08:55:00.000000',00000000000004028394),('2024-07-16 09:00:00.000000',00000000000004059784),('2024-07-16 09:05:00.000000',00000000000004100874),('2024-07-16 09:10:00.000000',00000000000004106174),('2024-07-16 09:15:00.000000',00000000000004332864),('2024-07-16 09:20:00.000000',00000000000004352434),('2024-07-16 09:25:00.000000',00000000000004373432),('2024-07-16 09:30:00.000000',00000000000004391732),('2024-07-16 09:35:00.000000',00000000000004400830),('2024-07-16 09:40:00.000000',00000000000004421108),('2024-07-16 09:45:00.000000',00000000000004436598),('2024-07-16 09:50:00.000000',00000000000004473657),('2024-07-16 09:55:00.000000',00000000000004478406),('2024-07-16 10:00:00.000000',00000000000004486495),('2024-07-16 10:05:00.000000',00000000000004506485),('2024-07-16 10:10:00.000000',00000000000004519285),('2024-07-16 10:15:00.000000',00000000000004529365),('2024-07-16 10:20:00.000000',00000000000004542855),('2024-07-16 10:25:00.000000',00000000000004550845),('2024-07-16 10:30:00.000000',00000000000004564535),('2024-07-16 10:35:00.000000',00000000000004588725),('2024-07-16 10:40:00.000000',00000000000004604215),('2024-07-16 10:45:00.000000',00000000000004611305),('2024-07-16 10:50:00.000000',00000000000004632005),('2024-07-16 10:55:00.000000',00000000000004635403),('2024-07-16 11:00:00.000000',00000000000004654001),('2024-07-16 11:05:00.000000',00000000000004746591),('2024-07-16 11:10:00.000000',00000000000004766161),('2024-07-16 11:15:00.000000',00000000000004775039),('2024-07-16 11:20:00.000000',00000000000004795408),('2024-07-16 11:25:00.000000',00000000000004813298),('2024-07-16 11:30:00.000000',00000000000004836598),('2024-07-16 11:35:00.000000',00000000000004838588),('2024-07-16 11:40:00.000000',00000000000004848776),('2024-07-16 11:45:00.000000',00000000000004853766),('2024-07-16 11:50:00.000000',00000000000004890564),('2024-07-16 11:55:00.000000',00000000000005011734),('2024-07-16 12:00:00.000000',00000000000005039534),('2024-07-16 12:05:00.000000',00000000000005346534),('2024-07-16 12:10:00.000000',00000000000005360623),('2024-07-16 12:15:00.000000',00000000000005381421),('2024-07-16 12:20:00.000000',00000000000005387521),('2024-07-16 12:25:00.000000',00000000000005390121),('2024-07-16 12:30:00.000000',00000000000005392221),('2024-07-16 12:35:00.000000',00000000000005442699),('2024-07-16 12:40:00.000000',00000000000005471479),('2024-07-16 12:45:00.000000',00000000000005493259),('2024-07-16 12:50:00.000000',00000000000005518829),('2024-07-16 12:55:00.000000',00000000000005534099),('2024-07-16 13:00:00.000000',00000000000005635797),('2024-07-16 13:05:00.000000',00000000000005653467),('2024-07-16 13:10:00.000000',00000000000005696226),('2024-07-16 13:15:00.000000',00000000000005698215),('2024-07-16 13:20:00.000000',00000000000005732474),('2024-07-16 13:25:00.000000',00000000000005750674),('2024-07-16 13:30:00.000000',00000000000005795342),('2024-07-16 13:35:00.000000',00000000000005814982),('2024-07-16 13:40:00.000000',00000000000005829570),('2024-07-16 13:45:00.000000',00000000000005856418),('2024-07-16 13:50:00.000000',00000000000005902655),('2024-07-16 13:55:00.000000',00000000000005999355),('2024-07-16 14:00:00.000000',00000000000006016625),('2024-07-16 14:05:00.000000',00000000000006027515),('2024-07-16 14:10:00.000000',00000000000006050795),('2024-07-16 14:15:00.000000',00000000000006092464),('2024-07-16 14:20:00.000000',00000000000006115640),('2024-07-16 14:25:00.000000',00000000000006158059),('2024-07-16 14:30:00.000000',00000000000006222596),('2024-07-16 14:35:00.000000',00000000000006269476),('2024-07-16 14:40:00.000000',00000000000006286435),('2024-07-16 14:45:00.000000',00000000000006338694),('2024-07-16 14:50:00.000000',00000000000006374141),('2024-07-16 14:55:00.000000',00000000000006508901),('2024-07-16 15:00:00.000000',00000000000006537480),('2024-07-16 15:05:00.000000',00000000000006563330),('2024-07-16 15:10:00.000000',00000000000006580900),('2024-07-16 15:15:00.000000',00000000000006640248),('2024-07-16 15:20:00.000000',00000000000006709267),('2024-07-16 15:25:00.000000',00000000000006776016),('2024-07-16 15:30:00.000000',00000000000006805396),('2024-07-16 15:35:00.000000',00000000000006862186),('2024-07-16 15:40:00.000000',00000000000007018994),('2024-07-16 15:45:00.000000',00000000000007075274),('2024-07-16 15:50:00.000000',00000000000007190538),('2024-07-16 15:55:00.000000',00000000000007205134),('2024-07-16 16:00:00.000000',00000000000000000000),('2024-07-16 16:05:00.000000',00000000000000047490),('2024-07-16 16:10:00.000000',00000000000000079438),('2024-07-16 16:15:00.000000',00000000000000105304),('2024-07-16 16:20:00.000000',00000000000000110204),('2024-07-16 16:25:00.000000',00000000000000129490),('2024-07-16 16:30:00.000000',00000000000000178170),('2024-07-16 16:35:00.000000',00000000000000224040),('2024-07-16 16:40:00.000000',00000000000000279210),('2024-07-16 16:45:00.000000',00000000000000298200),('2024-07-16 16:50:00.000000',00000000000000337070),('2024-07-16 16:55:00.000000',00000000000000359849),('2024-07-16 17:00:00.000000',00000000000000374749),('2024-07-16 17:05:00.000000',00000000000000405039),('2024-07-16 17:10:00.000000',00000000000000426839),('2024-07-16 17:15:00.000000',00000000000000442826),('2024-07-16 17:20:00.000000',00000000000000473005),('2024-07-16 17:25:00.000000',00000000000000510303),('2024-07-16 17:30:00.000000',00000000000000532090),('2024-07-16 17:35:00.000000',00000000000000559959),('2024-07-16 17:40:00.000000',00000000000000585438),('2024-07-16 17:45:00.000000',00000000000000612828),('2024-07-16 17:50:00.000000',00000000000000628418),('2024-07-16 17:55:00.000000',00000000000000664868),('2024-07-16 18:00:00.000000',00000000000000715780),('2024-07-16 18:05:00.000000',00000000000000724729),('2024-07-16 18:10:00.000000',00000000000000815775),('2024-07-16 18:15:00.000000',00000000000000819765),('2024-07-16 18:20:00.000000',00000000000000830664),('2024-07-16 18:25:00.000000',00000000000000838654),('2024-07-16 18:30:00.000000',00000000000000859054),('2024-07-16 18:35:00.000000',00000000000000890823),('2024-07-16 18:40:00.000000',00000000000000900723),('2024-07-16 18:45:00.000000',00000000000000919902),('2024-07-16 18:50:00.000000',00000000000000934780),('2024-07-16 18:55:00.000000',00000000000000951860),('2024-07-16 19:00:00.000000',00000000000000955850),('2024-07-16 19:05:00.000000',00000000000000966238),('2024-07-16 19:10:00.000000',00000000000000988518),('2024-07-16 19:15:00.000000',00000000000000994498),('2024-07-16 19:20:00.000000',00000000000001003387),('2024-07-16 19:25:00.000000',00000000000001006387),('2024-07-16 19:30:00.000000',00000000000001017287),('2024-07-16 19:35:00.000000',00000000000001018487),('2024-07-16 19:40:00.000000',00000000000001032187),('2024-07-16 19:45:00.000000',00000000000001039187),('2024-07-16 19:50:00.000000',00000000000001062077),('2024-07-16 19:55:00.000000',00000000000001071366),('2024-07-16 20:00:00.000000',00000000000001079336),('2024-07-16 20:05:00.000000',00000000000001084326),('2024-07-16 20:10:00.000000',00000000000001104226),('2024-07-16 20:15:00.000000',00000000000001116105),('2024-07-16 20:20:00.000000',00000000000001127873),('2024-07-16 20:25:00.000000',00000000000001138373),('2024-07-16 20:30:00.000000',00000000000001143853),('2024-07-16 20:35:00.000000',00000000000001145853),('2024-07-16 20:40:00.000000',00000000000001145853),('2024-07-16 20:45:00.000000',00000000000001150352),('2024-07-16 20:50:00.000000',00000000000001159232),('2024-07-16 20:55:00.000000',00000000000001165132),('2024-07-16 21:00:00.000000',00000000000001165132),('2024-07-16 21:05:00.000000',00000000000001166122),('2024-07-16 21:10:00.000000',00000000000001173112),('2024-07-16 21:15:00.000000',00000000000001178102),('2024-07-16 21:20:00.000000',00000000000001180092),('2024-07-16 21:25:00.000000',00000000000001192479),('2024-07-16 21:30:00.000000',00000000000001192479),('2024-07-16 21:35:00.000000',00000000000001195469),('2024-07-16 21:40:00.000000',00000000000001196469),('2024-07-16 21:45:00.000000',00000000000001200459),('2024-07-16 21:50:00.000000',00000000000001201459),('2024-07-16 21:55:00.000000',00000000000001214327),('2024-07-16 22:00:00.000000',00000000000001220227),('2024-07-16 22:05:00.000000',00000000000001221227),('2024-07-16 22:10:00.000000',00000000000001230727),('2024-07-16 22:15:00.000000',00000000000001234727),('2024-07-16 22:20:00.000000',00000000000001234727),('2024-07-16 22:25:00.000000',00000000000001234727),('2024-07-16 22:30:00.000000',00000000000001235717),('2024-07-16 22:35:00.000000',00000000000001248517),('2024-07-16 22:40:00.000000',00000000000001249017),('2024-07-16 22:45:00.000000',00000000000001264917),('2024-07-16 22:50:00.000000',00000000000001273897),('2024-07-16 22:55:00.000000',00000000000001276807),('2024-07-16 23:00:00.000000',00000000000001276807),('2024-07-16 23:05:00.000000',00000000000001277307),('2024-07-16 23:10:00.000000',00000000000001280207),('2024-07-16 23:15:00.000000',00000000000001288595),('2024-07-16 23:20:00.000000',00000000000001295695),('2024-07-16 23:25:00.000000',00000000000001307585),('2024-07-16 23:30:00.000000',00000000000001316472),('2024-07-16 23:35:00.000000',00000000000001326770),('2024-07-16 23:40:00.000000',00000000000001333348),('2024-07-16 23:45:00.000000',00000000000001355626),('2024-07-16 23:50:00.000000',00000000000001365515),('2024-07-16 23:55:00.000000',00000000000001370414),('2024-07-17 00:00:00.000000',00000000000001375414),('2024-07-17 00:05:00.000000',00000000000001397014),('2024-07-17 00:10:00.000000',00000000000001398014),('2024-07-17 00:15:00.000000',00000000000001409904),('2024-07-17 00:20:00.000000',00000000000001416304),('2024-07-17 00:25:00.000000',00000000000001423104),('2024-07-17 00:30:00.000000',00000000000001444994),('2024-07-17 00:35:00.000000',00000000000001458783),('2024-07-17 00:40:00.000000',00000000000001483631),('2024-07-17 00:45:00.000000',00000000000001485911),('2024-07-17 00:50:00.000000',00000000000001518470),('2024-07-17 00:55:00.000000',00000000000001533126),('2024-07-17 01:00:00.000000',00000000000001536506),('2024-07-17 01:05:00.000000',00000000000001577195),('2024-07-17 01:10:00.000000',00000000000001602374),('2024-07-17 01:15:00.000000',00000000000001634274),('2024-07-17 01:20:00.000000',00000000000001646164),('2024-07-17 01:25:00.000000',00000000000001658043),('2024-07-17 01:30:00.000000',00000000000001677823),('2024-07-17 01:35:00.000000',00000000000001694703),('2024-07-17 01:40:00.000000',00000000000001723693),('2024-07-17 01:45:00.000000',00000000000001741383),('2024-07-17 01:50:00.000000',00000000000001755373),('2024-07-17 01:55:00.000000',00000000000001772443),('2024-07-17 02:00:00.000000',00000000000001776943),('2024-07-17 02:05:00.000000',00000000000001786920),('2024-07-17 02:10:00.000000',00000000000001793890),('2024-07-17 02:15:00.000000',00000000000001807446),('2024-07-17 02:20:00.000000',00000000000001828235),('2024-07-17 02:25:00.000000',00000000000001845625),('2024-07-17 02:30:00.000000',00000000000001863113),('2024-07-17 02:35:00.000000',00000000000001895203),('2024-07-17 02:40:00.000000',00000000000001905163),('2024-07-17 02:45:00.000000',00000000000001910053),('2024-07-17 02:50:00.000000',00000000000001916953),('2024-07-17 02:55:00.000000',00000000000001926543),('2024-07-17 03:00:00.000000',00000000000001927542),('2024-07-17 03:05:00.000000',00000000000001941421),('2024-07-17 03:10:00.000000',00000000000001948511),('2024-07-17 03:15:00.000000',00000000000002020111),('2024-07-17 03:20:00.000000',00000000000002034189),('2024-07-17 03:25:00.000000',00000000000002048969),('2024-07-17 03:30:00.000000',00000000000002060769),('2024-07-17 03:35:00.000000',00000000000002056259),('2024-07-17 03:40:00.000000',00000000000002077138),('2024-07-17 03:45:00.000000',00000000000002133608),('2024-07-17 03:50:00.000000',00000000000002139598),('2024-07-17 03:55:00.000000',00000000000002147888),('2024-07-17 04:00:00.000000',00000000000002168777),('2024-07-17 04:05:00.000000',00000000000002176677),('2024-07-17 04:10:00.000000',00000000000002201865),('2024-07-17 04:15:00.000000',00000000000002210865),('2024-07-17 04:20:00.000000',00000000000002230745),('2024-07-17 04:25:00.000000',00000000000002270325),('2024-07-17 04:30:00.000000',00000000000002292214),('2024-07-17 04:35:00.000000',00000000000002305404),('2024-07-17 04:40:00.000000',00000000000002321800),('2024-07-17 04:45:00.000000',00000000000002343668),('2024-07-17 04:50:00.000000',00000000000002362146),('2024-07-17 04:55:00.000000',00000000000002399615),('2024-07-17 05:00:00.000000',00000000000002417992),('2024-07-17 05:05:00.000000',00000000000002438650),('2024-07-17 05:10:00.000000',00000000000002483344),('2024-07-17 05:15:00.000000',00000000000002503322),('2024-07-17 05:20:00.000000',00000000000002536192),('2024-07-17 05:25:00.000000',00000000000002562480),('2024-07-17 05:30:00.000000',00000000000002590649),('2024-07-17 05:35:00.000000',00000000000002609529),('2024-07-17 05:40:00.000000',00000000000002629789),('2024-07-17 05:45:00.000000',00000000000002641579),('2024-07-17 05:50:00.000000',00000000000002645581),('2024-07-17 05:55:00.000000',00000000000002666971),('2024-07-17 06:00:00.000000',00000000000002684061),('2024-07-17 06:05:00.000000',00000000000002704750),('2024-07-17 06:10:00.000000',00000000000002745200),('2024-07-17 06:15:00.000000',00000000000002767470),('2024-07-17 06:20:00.000000',00000000000002778379),('2024-07-17 06:25:00.000000',00000000000002790669),('2024-07-17 06:30:00.000000',00000000000002794149),('2024-07-17 06:35:00.000000',00000000000002797639),('2024-07-17 06:40:00.000000',00000000000002811518),('2024-07-17 06:45:00.000000',00000000000002827408),('2024-07-17 06:50:00.000000',00000000000002851698),('2024-07-17 06:55:00.000000',00000000000002881354),('2024-07-17 07:00:00.000000',00000000000002954393),('2024-07-17 07:05:00.000000',00000000000002962891),('2024-07-17 07:10:00.000000',00000000000002992081),('2024-07-17 07:15:00.000000',00000000000003026661),('2024-07-17 07:20:00.000000',00000000000003044441),('2024-07-17 07:25:00.000000',00000000000003051341),('2024-07-17 07:30:00.000000',00000000000003064241),('2024-07-17 07:35:00.000000',00000000000003083031),('2024-07-17 07:40:00.000000',00000000000003100501),('2024-07-17 07:45:00.000000',00000000000003146180),('2024-07-17 07:50:00.000000',00000000000003213650),('2024-07-17 07:55:00.000000',00000000000003228640),('2024-07-17 08:00:00.000000',00000000000003340619),('2024-07-17 08:05:00.000000',00000000000003346689),('2024-07-17 08:10:00.000000',00000000000003358677),('2024-07-17 08:15:00.000000',00000000000003379554),('2024-07-17 08:20:00.000000',00000000000003387914),('2024-07-17 08:25:00.000000',00000000000003384003),('2024-07-17 08:30:00.000000',00000000000003412570),('2024-07-17 08:35:00.000000',00000000000003430270),('2024-07-17 08:40:00.000000',00000000000003451949),('2024-07-17 08:45:00.000000',00000000000003476839),('2024-07-17 08:50:00.000000',00000000000003527529),('2024-07-17 08:55:00.000000',00000000000003532528),('2024-07-17 09:00:00.000000',00000000000003548728),('2024-07-17 09:05:00.000000',00000000000003547728),('2024-07-17 09:10:00.000000',00000000000003559328),('2024-07-17 09:15:00.000000',00000000000003567404),('2024-07-17 09:20:00.000000',00000000000003571814),('2024-07-17 09:25:00.000000',00000000000003591503),('2024-07-17 09:30:00.000000',00000000000003597403),('2024-07-17 09:35:00.000000',00000000000003601303),('2024-07-17 09:40:00.000000',00000000000003804903),('2024-07-17 09:45:00.000000',00000000000003814783),('2024-07-17 09:50:00.000000',00000000000003832373),('2024-07-17 09:55:00.000000',00000000000003844173),('2024-07-17 10:00:00.000000',00000000000003857053),('2024-07-17 10:05:00.000000',00000000000003858153),('2024-07-17 10:10:00.000000',00000000000003886153),('2024-07-17 10:15:00.000000',00000000000003906953),('2024-07-17 10:20:00.000000',00000000000003928723),('2024-07-17 10:25:00.000000',00000000000003944113),('2024-07-17 10:30:00.000000',00000000000003988991),('2024-07-17 10:35:00.000000',00000000000004011681),('2024-07-17 10:40:00.000000',00000000000004014671),('2024-07-17 10:45:00.000000',00000000000004012671),('2024-07-17 10:50:00.000000',00000000000004023351),('2024-07-17 10:55:00.000000',00000000000004050931),('2024-07-17 11:00:00.000000',00000000000004078710),('2024-07-17 11:05:00.000000',00000000000004114290),('2024-07-17 11:10:00.000000',00000000000004114290),('2024-07-17 11:15:00.000000',00000000000004131290),('2024-07-17 11:20:00.000000',00000000000004131290),('2024-07-17 11:25:00.000000',00000000000004147280),('2024-07-17 11:30:00.000000',00000000000004147880),('2024-07-17 11:35:00.000000',00000000000004152880),('2024-07-17 11:40:00.000000',00000000000004154880),('2024-07-17 11:45:00.000000',00000000000004162780),('2024-07-17 11:50:00.000000',00000000000004176158),('2024-07-17 11:55:00.000000',00000000000004185038),('2024-07-17 12:00:00.000000',00000000000004186038),('2024-07-17 12:05:00.000000',00000000000004201826),('2024-07-17 12:10:00.000000',00000000000004212726),('2024-07-17 12:15:00.000000',00000000000004230116),('2024-07-17 12:20:00.000000',00000000000004240666),('2024-07-17 12:25:00.000000',00000000000004256066),('2024-07-17 12:30:00.000000',00000000000004267966),('2024-07-17 12:35:00.000000',00000000000004275946),('2024-07-17 12:40:00.000000',00000000000004295736),('2024-07-17 12:45:00.000000',00000000000004308236),('2024-07-17 12:50:00.000000',00000000000004313125),('2024-07-17 12:55:00.000000',00000000000004333913),('2024-07-17 13:00:00.000000',00000000000004346051),('2024-07-17 13:05:00.000000',00000000000004370797),('2024-07-17 13:10:00.000000',00000000000004374165),('2024-07-17 13:15:00.000000',00000000000004390834),('2024-07-17 13:20:00.000000',00000000000004423714),('2024-07-17 13:25:00.000000',00000000000004433304),('2024-07-17 13:30:00.000000',00000000000004448852),('2024-07-17 13:35:00.000000',00000000000004460221),('2024-07-17 13:40:00.000000',00000000000004481589),('2024-07-17 13:45:00.000000',00000000000004500359),('2024-07-17 13:50:00.000000',00000000000004562638),('2024-07-17 13:55:00.000000',00000000000004625806),('2024-07-17 14:00:00.000000',00000000000004649586),('2024-07-17 14:05:00.000000',00000000000004650986),('2024-07-17 14:10:00.000000',00000000000004678266),('2024-07-17 14:15:00.000000',00000000000004690537),('2024-07-17 14:20:00.000000',00000000000004712337),('2024-07-17 14:25:00.000000',00000000000004746104),('2024-07-17 14:30:00.000000',00000000000004779552),('2024-07-17 14:35:00.000000',00000000000004814142),('2024-07-17 14:40:00.000000',00000000000004841911),('2024-07-17 14:45:00.000000',00000000000004859922),('2024-07-17 14:50:00.000000',00000000000004908201),('2024-07-17 14:55:00.000000',00000000000004956559),('2024-07-17 15:00:00.000000',00000000000004992298),('2024-07-17 15:05:00.000000',00000000000005065045),('2024-07-17 15:10:00.000000',00000000000005089945),('2024-07-17 15:15:00.000000',00000000000005126725),('2024-07-17 15:20:00.000000',00000000000005150193),('2024-07-17 15:25:00.000000',00000000000005247762),('2024-07-17 15:30:00.000000',00000000000005312611),('2024-07-17 15:35:00.000000',00000000000005369480),('2024-07-17 15:40:00.000000',00000000000005380180),('2024-07-17 15:45:00.000000',00000000000005436780),('2024-07-17 15:50:00.000000',00000000000005500229),('2024-07-17 15:55:00.000000',00000000000005515029),('2024-07-17 16:00:00.000000',00000000000000000000),('2024-07-17 16:05:00.000000',00000000000000031900),('2024-07-17 16:10:00.000000',00000000000000099580),('2024-07-17 16:15:00.000000',00000000000000127760),('2024-07-17 16:20:00.000000',00000000000000188719),('2024-07-17 16:25:00.000000',00000000000000279498),('2024-07-17 16:30:00.000000',00000000000000338498),('2024-07-17 16:35:00.000000',00000000000000402257),('2024-07-17 16:40:00.000000',00000000000000455413),('2024-07-17 16:45:00.000000',00000000000000673422),('2024-07-17 16:50:00.000000',00000000000000699112),('2024-07-17 16:55:00.000000',00000000000000752640),('2024-07-17 17:00:00.000000',00000000000000776730),('2024-07-17 17:05:00.000000',00000000000000840500),('2024-07-17 17:10:00.000000',00000000000000879760),('2024-07-17 17:15:00.000000',00000000000000905328),('2024-07-17 17:20:00.000000',00000000000000919728),('2024-07-17 17:25:00.000000',00000000000000939618),('2024-07-17 17:30:00.000000',00000000000000952007),('2024-07-17 17:35:00.000000',00000000000000988696),('2024-07-17 17:40:00.000000',00000000000001047975),('2024-07-17 17:45:00.000000',00000000000001088453),('2024-07-17 17:50:00.000000',00000000000001116932),('2024-07-17 17:55:00.000000',00000000000001136732),('2024-07-17 18:00:00.000000',00000000000001165709),('2024-07-17 18:05:00.000000',00000000000001181497),('2024-07-17 18:10:00.000000',00000000000001213575),('2024-07-17 18:15:00.000000',00000000000001231865),('2024-07-17 18:20:00.000000',00000000000001317644),('2024-07-17 18:25:00.000000',00000000000001335244),('2024-07-17 18:30:00.000000',00000000000001354914),('2024-07-17 18:35:00.000000',00000000000001379704),('2024-07-17 18:40:00.000000',00000000000001401082),('2024-07-17 18:45:00.000000',00000000000001421858),('2024-07-17 18:50:00.000000',00000000000001445022),('2024-07-17 18:55:00.000000',00000000000001455689),('2024-07-17 19:00:00.000000',00000000000001519946),('2024-07-17 19:05:00.000000',00000000000001542335),('2024-07-17 19:10:00.000000',00000000000001557335),('2024-07-17 19:15:00.000000',00000000000001571235),('2024-07-17 19:20:00.000000',00000000000001577225),('2024-07-17 19:25:00.000000',00000000000001592801),('2024-07-17 19:30:00.000000',00000000000001614601),('2024-07-17 19:35:00.000000',00000000000001617899),('2024-07-17 19:40:00.000000',00000000000001622099),('2024-07-17 19:45:00.000000',00000000000001627078),('2024-07-17 19:50:00.000000',00000000000001633578),('2024-07-17 19:55:00.000000',00000000000001644858),('2024-07-17 20:00:00.000000',00000000000001646848),('2024-07-17 20:05:00.000000',00000000000001665738),('2024-07-17 20:10:00.000000',00000000000001676717),('2024-07-17 20:15:00.000000',00000000000001699297),('2024-07-17 20:20:00.000000',00000000000001704097),('2024-07-17 20:25:00.000000',00000000000001701097),('2024-07-17 20:30:00.000000',00000000000001711997),('2024-07-17 20:35:00.000000',00000000000001711997),('2024-07-17 20:40:00.000000',00000000000001723897),('2024-07-17 20:45:00.000000',00000000000001741397),('2024-07-17 20:50:00.000000',00000000000001754186),('2024-07-17 20:55:00.000000',00000000000001768986),('2024-07-17 21:00:00.000000',00000000000001811086),('2024-07-17 21:05:00.000000',00000000000001811086),('2024-07-17 21:10:00.000000',00000000000001817586),('2024-07-17 21:15:00.000000',00000000000001831286),('2024-07-17 21:20:00.000000',00000000000001864876),('2024-07-17 21:25:00.000000',00000000000001871856),('2024-07-17 21:30:00.000000',00000000000001872856),('2024-07-17 21:35:00.000000',00000000000001873856),('2024-07-17 21:40:00.000000',00000000000001877135),('2024-07-17 21:45:00.000000',00000000000001894935),('2024-07-17 21:50:00.000000',00000000000001901925),('2024-07-17 21:55:00.000000',00000000000001905823),('2024-07-17 22:00:00.000000',00000000000001908813),('2024-07-17 22:05:00.000000',00000000000001909813),('2024-07-17 22:10:00.000000',00000000000001919813),('2024-07-17 22:15:00.000000',00000000000001926692),('2024-07-17 22:20:00.000000',00000000000001927682),('2024-07-17 22:25:00.000000',00000000000001935382),('2024-07-17 22:30:00.000000',00000000000001946472),('2024-07-17 22:35:00.000000',00000000000001973162),('2024-07-17 22:40:00.000000',00000000000001977160),('2024-07-17 22:45:00.000000',00000000000001986350),('2024-07-17 22:50:00.000000',00000000000001989350),('2024-07-17 22:55:00.000000',00000000000001996550),('2024-07-17 23:00:00.000000',00000000000002005429),('2024-07-17 23:05:00.000000',00000000000002011318),('2024-07-17 23:10:00.000000',00000000000002020018),('2024-07-17 23:15:00.000000',00000000000002030908),('2024-07-17 23:20:00.000000',00000000000002040108),('2024-07-17 23:25:00.000000',00000000000002040108),('2024-07-17 23:30:00.000000',00000000000002061888),('2024-07-17 23:35:00.000000',00000000000002062878),('2024-07-17 23:40:00.000000',00000000000002072778),('2024-07-17 23:45:00.000000',00000000000002079668),('2024-07-17 23:50:00.000000',00000000000002082658),('2024-07-17 23:55:00.000000',00000000000002089558),('2024-07-18 00:00:00.000000',00000000000002093358),('2024-07-18 00:05:00.000000',00000000000002092268),('2024-07-18 00:10:00.000000',00000000000002097068),('2024-07-18 00:15:00.000000',00000000000002103068),('2024-07-18 00:20:00.000000',00000000000002120968),('2024-07-18 00:25:00.000000',00000000000002123168),('2024-07-18 00:30:00.000000',00000000000002123568),('2024-07-18 00:35:00.000000',00000000000002144268),('2024-07-18 00:40:00.000000',00000000000002160058),('2024-07-18 00:45:00.000000',00000000000002194228),('2024-07-18 00:50:00.000000',00000000000002205188),('2024-07-18 00:55:00.000000',00000000000002224858),('2024-07-18 01:00:00.000000',00000000000002250348),('2024-07-18 01:05:00.000000',00000000000002256938),('2024-07-18 01:10:00.000000',00000000000002281628),('2024-07-18 01:15:00.000000',00000000000002286428),('2024-07-18 01:20:00.000000',00000000000002328906),('2024-07-18 01:25:00.000000',00000000000002346864),('2024-07-18 01:30:00.000000',00000000000002367664),('2024-07-18 01:35:00.000000',00000000000002365841),('2024-07-18 01:40:00.000000',00000000000002367839),('2024-07-18 01:45:00.000000',00000000000002373239),('2024-07-18 01:50:00.000000',00000000000002401639),('2024-07-18 01:55:00.000000',00000000000002461209),('2024-07-18 02:00:00.000000',00000000000002468197),('2024-07-18 02:05:00.000000',00000000000002476175),('2024-07-18 02:10:00.000000',00000000000002483154),('2024-07-18 02:15:00.000000',00000000000002668152),('2024-07-18 02:20:00.000000',00000000000002670141),('2024-07-18 02:25:00.000000',00000000000002682020),('2024-07-18 02:30:00.000000',00000000000002689820),('2024-07-18 02:35:00.000000',00000000000002696710),('2024-07-18 02:40:00.000000',00000000000002714000),('2024-07-18 02:45:00.000000',00000000000002730970),('2024-07-18 02:50:00.000000',00000000000002743670),('2024-07-18 02:55:00.000000',00000000000002783937),('2024-07-18 03:00:00.000000',00000000000002807625),('2024-07-18 03:05:00.000000',00000000000002810915),('2024-07-18 03:10:00.000000',00000000000002814415),('2024-07-18 03:15:00.000000',00000000000002847382),('2024-07-18 03:20:00.000000',00000000000002865172),('2024-07-18 03:25:00.000000',00000000000002883859),('2024-07-18 03:30:00.000000',00000000000002886859),('2024-07-18 03:35:00.000000',00000000000002947359),('2024-07-18 03:40:00.000000',00000000000002949258),('2024-07-18 03:45:00.000000',00000000000002963138),('2024-07-18 03:50:00.000000',00000000000003012128),('2024-07-18 03:55:00.000000',00000000000003019118),('2024-07-18 04:00:00.000000',00000000000003040896),('2024-07-18 04:05:00.000000',00000000000003080065),('2024-07-18 04:10:00.000000',00000000000003096445),('2024-07-18 04:15:00.000000',00000000000003270733),('2024-07-18 04:20:00.000000',00000000000003311533),('2024-07-18 04:25:00.000000',00000000000003329433),('2024-07-18 04:30:00.000000',00000000000003351923),('2024-07-18 04:35:00.000000',00000000000003372181),('2024-07-18 04:40:00.000000',00000000000003380071),('2024-07-18 04:45:00.000000',00000000000003397261),('2024-07-18 04:50:00.000000',00000000000003434931),('2024-07-18 04:55:00.000000',00000000000003453811),('2024-07-18 05:00:00.000000',00000000000003521601),('2024-07-18 05:05:00.000000',00000000000003545761),('2024-07-18 05:10:00.000000',00000000000003579315),('2024-07-18 05:15:00.000000',00000000000003605553),('2024-07-18 05:20:00.000000',00000000000003638541),('2024-07-18 05:25:00.000000',00000000000003694031),('2024-07-18 05:30:00.000000',00000000000003719310),('2024-07-18 05:35:00.000000',00000000000003737690),('2024-07-18 05:40:00.000000',00000000000003776650),('2024-07-18 05:45:00.000000',00000000000003787728),('2024-07-18 05:50:00.000000',00000000000003811596),('2024-07-18 05:55:00.000000',00000000000003860141),('2024-07-18 06:00:00.000000',00000000000003869010),('2024-07-18 06:05:00.000000',00000000000003896300),('2024-07-18 06:10:00.000000',00000000000003911290),('2024-07-18 06:15:00.000000',00000000000003939738),('2024-07-18 06:20:00.000000',00000000000003949638),('2024-07-18 06:25:00.000000',00000000000003963517),('2024-07-18 06:30:00.000000',00000000000003976507),('2024-07-18 06:35:00.000000',00000000000004037076),('2024-07-18 06:40:00.000000',00000000000004048956),('2024-07-18 06:45:00.000000',00000000000004049934),('2024-07-18 06:50:00.000000',00000000000004067813),('2024-07-18 06:55:00.000000',00000000000004077702),('2024-07-18 07:00:00.000000',00000000000004100559),('2024-07-18 07:05:00.000000',00000000000004125509),('2024-07-18 07:10:00.000000',00000000000004165879),('2024-07-18 07:15:00.000000',00000000000004239536),('2024-07-18 07:20:00.000000',00000000000004322076),('2024-07-18 07:25:00.000000',00000000000004354345),('2024-07-18 07:30:00.000000',00000000000004366145),('2024-07-18 07:35:00.000000',00000000000004408225),('2024-07-18 07:40:00.000000',00000000000004422905),('2024-07-18 07:45:00.000000',00000000000004446805),('2024-07-18 07:50:00.000000',00000000000004458782),('2024-07-18 07:55:00.000000',00000000000004676241),('2024-07-18 08:00:00.000000',00000000000004700419),('2024-07-18 08:05:00.000000',00000000000004717209),('2024-07-18 08:10:00.000000',00000000000004751868),('2024-07-18 08:15:00.000000',00000000000004776248),('2024-07-18 08:20:00.000000',00000000000004779237),('2024-07-18 08:25:00.000000',00000000000004781235),('2024-07-18 08:30:00.000000',00000000000004819803),('2024-07-18 08:35:00.000000',00000000000004845583),('2024-07-18 08:40:00.000000',00000000000004959683),('2024-07-18 08:45:00.000000',00000000000004966663),('2024-07-18 08:50:00.000000',00000000000004978753),('2024-07-18 08:55:00.000000',00000000000004981353),('2024-07-18 09:00:00.000000',00000000000004992253),('2024-07-18 09:05:00.000000',00000000000005001753),('2024-07-18 09:10:00.000000',00000000000005010733),('2024-07-18 09:15:00.000000',00000000000005022523),('2024-07-18 09:20:00.000000',00000000000005034513),('2024-07-18 09:25:00.000000',00000000000005045292),('2024-07-18 09:30:00.000000',00000000000005054261),('2024-07-18 09:35:00.000000',00000000000005076119),('2024-07-18 09:40:00.000000',00000000000005079119),('2024-07-18 09:45:00.000000',00000000000005126599),('2024-07-18 09:50:00.000000',00000000000005135357),('2024-07-18 09:55:00.000000',00000000000005154507),('2024-07-18 10:00:00.000000',00000000000005247577),('2024-07-18 10:05:00.000000',00000000000005265366),('2024-07-18 10:10:00.000000',00000000000005292646),('2024-07-18 10:15:00.000000',00000000000005332635),('2024-07-18 10:20:00.000000',00000000000005336295),('2024-07-18 10:25:00.000000',00000000000005360485),('2024-07-18 10:30:00.000000',00000000000005368783),('2024-07-18 10:35:00.000000',00000000000005391272),('2024-07-18 10:40:00.000000',00000000000005405762),('2024-07-18 10:45:00.000000',00000000000005426640),('2024-07-18 10:50:00.000000',00000000000005438330),('2024-07-18 10:55:00.000000',00000000000005493310),('2024-07-18 11:00:00.000000',00000000000005499300),('2024-07-18 11:05:00.000000',00000000000005510400),('2024-07-18 11:10:00.000000',00000000000005519900),('2024-07-18 11:15:00.000000',00000000000005538478),('2024-07-18 11:20:00.000000',00000000000005570055),('2024-07-18 11:25:00.000000',00000000000005585033),('2024-07-18 11:30:00.000000',00000000000005609622),('2024-07-18 11:35:00.000000',00000000000005626412),('2024-07-18 11:40:00.000000',00000000000005642402),('2024-07-18 11:45:00.000000',00000000000005661189),('2024-07-18 11:50:00.000000',00000000000005880278),('2024-07-18 11:55:00.000000',00000000000005888378),('2024-07-18 12:00:00.000000',00000000000005908068),('2024-07-18 12:05:00.000000',00000000000005923958),('2024-07-18 12:10:00.000000',00000000000005940818),('2024-07-18 12:15:00.000000',00000000000005957806),('2024-07-18 12:20:00.000000',00000000000005966785),('2024-07-18 12:25:00.000000',00000000000005983485),('2024-07-18 12:30:00.000000',00000000000005990483),('2024-07-18 12:35:00.000000',00000000000006001162),('2024-07-18 12:40:00.000000',00000000000006022842),('2024-07-18 12:45:00.000000',00000000000006025632),('2024-07-18 12:50:00.000000',00000000000006044510),('2024-07-18 12:55:00.000000',00000000000006068479),('2024-07-18 13:00:00.000000',00000000000006076449),('2024-07-18 13:05:00.000000',00000000000006097139),('2024-07-18 13:10:00.000000',00000000000006117119),('2024-07-18 13:15:00.000000',00000000000006137908),('2024-07-18 13:20:00.000000',00000000000006145895),('2024-07-18 13:25:00.000000',00000000000006154485),('2024-07-18 13:30:00.000000',00000000000006163965),('2024-07-18 13:35:00.000000',00000000000006173865),('2024-07-18 13:40:00.000000',00000000000006202645),('2024-07-18 13:45:00.000000',00000000000006245805),('2024-07-18 13:50:00.000000',00000000000006285583),('2024-07-18 13:55:00.000000',00000000000006293303),('2024-07-18 14:00:00.000000',00000000000006278593),('2024-07-18 14:05:00.000000',00000000000006292793),('2024-07-18 14:10:00.000000',00000000000006317972),('2024-07-18 14:15:00.000000',00000000000006333852),('2024-07-18 14:20:00.000000',00000000000006382288),('2024-07-18 14:25:00.000000',00000000000006547478),('2024-07-18 14:30:00.000000',00000000000006672328),('2024-07-18 14:35:00.000000',00000000000006732916),('2024-07-18 14:40:00.000000',00000000000006773262),('2024-07-18 14:45:00.000000',00000000000006819621),('2024-07-18 14:50:00.000000',00000000000006853459),('2024-07-18 14:55:00.000000',00000000000006939199),('2024-07-18 15:00:00.000000',00000000000007011436),('2024-07-18 15:05:00.000000',00000000000007043724),('2024-07-18 15:10:00.000000',00000000000007093582),('2024-07-18 15:15:00.000000',00000000000007131538),('2024-07-18 15:20:00.000000',00000000000007164717),('2024-07-18 15:25:00.000000',00000000000007190115),('2024-07-18 15:30:00.000000',00000000000007222974),('2024-07-18 15:35:00.000000',00000000000007262053),('2024-07-18 15:40:00.000000',00000000000007280532),('2024-07-18 15:45:00.000000',00000000000007316411),('2024-07-18 15:50:00.000000',00000000000007783670),('2024-07-18 15:55:00.000000',00000000000007843249),('2024-07-18 16:00:00.000000',00000000000000000000),('2024-07-18 16:05:00.000000',00000000000000042579),('2024-07-18 16:10:00.000000',00000000000000136237),('2024-07-18 16:15:00.000000',00000000000000201195),('2024-07-18 16:20:00.000000',00000000000000278817),('2024-07-18 16:25:00.000000',00000000000000362356),('2024-07-18 16:30:00.000000',00000000000000442941),('2024-07-18 16:35:00.000000',00000000000000605621),('2024-07-18 16:40:00.000000',00000000000000665109),('2024-07-18 16:45:00.000000',00000000000000688099),('2024-07-18 16:50:00.000000',00000000000000743889),('2024-07-18 16:55:00.000000',00000000000000785527),('2024-07-18 17:00:00.000000',00000000000000806006),('2024-07-18 17:05:00.000000',00000000000000831304),('2024-07-18 17:10:00.000000',00000000000000858283),('2024-07-18 17:15:00.000000',00000000000000922247),('2024-07-18 17:20:00.000000',00000000000000927516),('2024-07-18 17:25:00.000000',00000000000000940016),('2024-07-18 17:30:00.000000',00000000000000956965),('2024-07-18 17:35:00.000000',00000000000001012433),('2024-07-18 17:40:00.000000',00000000000001028913),('2024-07-18 17:45:00.000000',00000000000001057582),('2024-07-18 17:50:00.000000',00000000000001082428),('2024-07-18 17:55:00.000000',00000000000001100897),('2024-07-18 18:00:00.000000',00000000000001133457),('2024-07-18 18:05:00.000000',00000000000001187201),('2024-07-18 18:10:00.000000',00000000000001210351),('2024-07-18 18:15:00.000000',00000000000001235128),('2024-07-18 18:20:00.000000',00000000000001261016),('2024-07-18 18:25:00.000000',00000000000001305586),('2024-07-18 18:30:00.000000',00000000000001331885),('2024-07-18 18:35:00.000000',00000000000001352883),('2024-07-18 18:40:00.000000',00000000000001381473),('2024-07-18 18:45:00.000000',00000000000001414661),('2024-07-18 18:50:00.000000',00000000000001414621),('2024-07-18 18:55:00.000000',00000000000001447221),('2024-07-18 19:00:00.000000',00000000000001471210),('2024-07-18 19:05:00.000000',00000000000001471810),('2024-07-18 19:10:00.000000',00000000000001475810),('2024-07-18 19:15:00.000000',00000000000001484108),('2024-07-18 19:20:00.000000',00000000000001501697),('2024-07-18 19:25:00.000000',00000000000001518985),('2024-07-18 19:30:00.000000',00000000000001545685),('2024-07-18 19:35:00.000000',00000000000001573773),('2024-07-18 19:40:00.000000',00000000000001595068),('2024-07-18 19:45:00.000000',00000000000001641268),('2024-07-18 19:50:00.000000',00000000000001660135),('2024-07-18 19:55:00.000000',00000000000001671713),('2024-07-18 20:00:00.000000',00000000000001673713),('2024-07-18 20:05:00.000000',00000000000001698502),('2024-07-18 20:10:00.000000',00000000000001707371),('2024-07-18 20:15:00.000000',00000000000001739151),('2024-07-18 20:20:00.000000',00000000000001741151),('2024-07-18 20:25:00.000000',00000000000001746341),('2024-07-18 20:30:00.000000',00000000000001761219),('2024-07-18 20:35:00.000000',00000000000001763209),('2024-07-18 20:40:00.000000',00000000000001777088),('2024-07-18 20:45:00.000000',00000000000001786288),('2024-07-18 20:50:00.000000',00000000000001793188),('2024-07-18 20:55:00.000000',00000000000001800088),('2024-07-18 21:00:00.000000',00000000000001814078),('2024-07-18 21:05:00.000000',00000000000001821168),('2024-07-18 21:10:00.000000',00000000000001822167),('2024-07-18 21:15:00.000000',00000000000001826167),('2024-07-18 21:20:00.000000',00000000000001839967),('2024-07-18 21:25:00.000000',00000000000001862565),('2024-07-18 21:30:00.000000',00000000000001867535),('2024-07-18 21:35:00.000000',00000000000001872525),('2024-07-18 21:40:00.000000',00000000000001879325),('2024-07-18 21:45:00.000000',00000000000001880982),('2024-07-18 21:50:00.000000',00000000000001882082),('2024-07-18 21:55:00.000000',00000000000001889072),('2024-07-18 22:00:00.000000',00000000000001891472),('2024-07-18 22:05:00.000000',00000000000001906261),('2024-07-18 22:10:00.000000',00000000000001907651),('2024-07-18 22:15:00.000000',00000000000001910039),('2024-07-18 22:20:00.000000',00000000000001951918),('2024-07-18 22:25:00.000000',00000000000001963798),('2024-07-18 22:30:00.000000',00000000000001965798),('2024-07-18 22:35:00.000000',00000000000001973787),('2024-07-18 22:40:00.000000',00000000000001979667),('2024-07-18 22:45:00.000000',00000000000001982567),('2024-07-18 22:50:00.000000',00000000000001990445),('2024-07-18 22:55:00.000000',00000000000001994001),('2024-07-18 23:00:00.000000',00000000000002005801),('2024-07-18 23:05:00.000000',00000000000002020791),('2024-07-18 23:10:00.000000',00000000000002029180),('2024-07-18 23:15:00.000000',00000000000002039470),('2024-07-18 23:20:00.000000',00000000000002064038),('2024-07-18 23:25:00.000000',00000000000002078927),('2024-07-18 23:30:00.000000',00000000000002087598),('2024-07-18 23:35:00.000000',00000000000002097567),('2024-07-18 23:40:00.000000',00000000000002134867),('2024-07-18 23:45:00.000000',00000000000002159757),('2024-07-18 23:50:00.000000',00000000000002188547),('2024-07-18 23:55:00.000000',00000000000002202835),('2024-07-19 00:00:00.000000',00000000000002218415),('2024-07-19 00:05:00.000000',00000000000002234603),('2024-07-19 00:10:00.000000',00000000000002238203),('2024-07-19 00:15:00.000000',00000000000002246172),('2024-07-19 00:20:00.000000',00000000000002272152),('2024-07-19 00:25:00.000000',00000000000002300738),('2024-07-19 00:30:00.000000',00000000000002308028),('2024-07-19 00:35:00.000000',00000000000002343517),('2024-07-19 00:40:00.000000',00000000000002362307),('2024-07-19 00:45:00.000000',00000000000002378684),('2024-07-19 00:50:00.000000',00000000000002411372),('2024-07-19 00:55:00.000000',00000000000002431440),('2024-07-19 01:00:00.000000',00000000000002455120),('2024-07-19 01:05:00.000000',00000000000002465419),('2024-07-19 01:10:00.000000',00000000000002483178),('2024-07-19 01:15:00.000000',00000000000002491078),('2024-07-19 01:20:00.000000',00000000000002505978),('2024-07-19 01:25:00.000000',00000000000002524768),('2024-07-19 01:30:00.000000',00000000000002555737),('2024-07-19 01:35:00.000000',00000000000002567627),('2024-07-19 01:40:00.000000',00000000000002586687),('2024-07-19 01:45:00.000000',00000000000002591987),('2024-07-19 01:50:00.000000',00000000000002595485),('2024-07-19 01:55:00.000000',00000000000002664875),('2024-07-19 02:00:00.000000',00000000000002667373),('2024-07-19 02:05:00.000000',00000000000002702563),('2024-07-19 02:10:00.000000',00000000000002720863),('2024-07-19 02:15:00.000000',00000000000002734931),('2024-07-19 02:20:00.000000',00000000000002767222),('2024-07-19 02:25:00.000000',00000000000002802101),('2024-07-19 02:30:00.000000',00000000000002822480),('2024-07-19 02:35:00.000000',00000000000002945147),('2024-07-19 02:40:00.000000',00000000000002995024),('2024-07-19 02:45:00.000000',00000000000003020004),('2024-07-19 02:50:00.000000',00000000000003040394),('2024-07-19 02:55:00.000000',00000000000003047184),('2024-07-19 03:00:00.000000',00000000000003059973),('2024-07-19 03:05:00.000000',00000000000003075652),('2024-07-19 03:10:00.000000',00000000000003079652),('2024-07-19 03:15:00.000000',00000000000003099642),('2024-07-19 03:20:00.000000',00000000000003118440),('2024-07-19 03:25:00.000000',00000000000003139219),('2024-07-19 03:30:00.000000',00000000000003146108),('2024-07-19 03:35:00.000000',00000000000003170288),('2024-07-19 03:40:00.000000',00000000000003197978),('2024-07-19 03:45:00.000000',00000000000003215768),('2024-07-19 03:50:00.000000',00000000000003242558),('2024-07-19 03:55:00.000000',00000000000003258748),('2024-07-19 04:00:00.000000',00000000000003272946),('2024-07-19 04:05:00.000000',00000000000003419234),('2024-07-19 04:10:00.000000',00000000000003504924),('2024-07-19 04:15:00.000000',00000000000003529954),('2024-07-19 04:20:00.000000',00000000000003547742),('2024-07-19 04:25:00.000000',00000000000003570522),('2024-07-19 04:30:00.000000',00000000000003601266),('2024-07-19 04:35:00.000000',00000000000003628514),('2024-07-19 04:40:00.000000',00000000000003650062),('2024-07-19 04:45:00.000000',00000000000003673762),('2024-07-19 04:50:00.000000',00000000000003722852),('2024-07-19 04:55:00.000000',00000000000003738140),('2024-07-19 05:00:00.000000',00000000000003763918),('2024-07-19 05:05:00.000000',00000000000003821674),('2024-07-19 05:10:00.000000',00000000000003848383),('2024-07-19 05:15:00.000000',00000000000003873083),('2024-07-19 05:20:00.000000',00000000000003902783),('2024-07-19 05:25:00.000000',00000000000003925981),('2024-07-19 05:30:00.000000',00000000000003996720),('2024-07-19 05:35:00.000000',00000000000004075040),('2024-07-19 05:40:00.000000',00000000000004196519),('2024-07-19 05:45:00.000000',00000000000004240339),('2024-07-19 05:50:00.000000',00000000000004260299),('2024-07-19 05:55:00.000000',00000000000004284567),('2024-07-19 06:00:00.000000',00000000000004330404),('2024-07-19 06:05:00.000000',00000000000004359781),('2024-07-19 06:10:00.000000',00000000000004367381),('2024-07-19 06:15:00.000000',00000000000004387351),('2024-07-19 06:20:00.000000',00000000000004388341),('2024-07-19 06:25:00.000000',00000000000004448966),('2024-07-19 06:30:00.000000',00000000000004463544),('2024-07-19 06:35:00.000000',00000000000004520703),('2024-07-19 06:40:00.000000',00000000000004550341),('2024-07-19 06:45:00.000000',00000000000004571131),('2024-07-19 06:50:00.000000',00000000000004603999),('2024-07-19 06:55:00.000000',00000000000004927279),('2024-07-19 07:00:00.000000',00000000000004942838),('2024-07-19 07:05:00.000000',00000000000004979618),('2024-07-19 07:10:00.000000',00000000000004986518),('2024-07-19 07:15:00.000000',00000000000004999218),('2024-07-19 07:20:00.000000',00000000000005044363),('2024-07-19 07:25:00.000000',00000000000005091822),('2024-07-19 07:30:00.000000',00000000000005107202),('2024-07-19 07:35:00.000000',00000000000005117102),('2024-07-19 07:40:00.000000',00000000000005125772),('2024-07-19 07:45:00.000000',00000000000005168152),('2024-07-19 07:50:00.000000',00000000000005285932),('2024-07-19 07:55:00.000000',00000000000005315478),('2024-07-19 08:00:00.000000',00000000000005336377),('2024-07-19 08:05:00.000000',00000000000005346067),('2024-07-19 08:10:00.000000',00000000000005354554),('2024-07-19 08:15:00.000000',00000000000005380124),('2024-07-19 08:20:00.000000',00000000000005389114),('2024-07-19 08:25:00.000000',00000000000005383204),('2024-07-19 08:30:00.000000',00000000000005400694),('2024-07-19 08:35:00.000000',00000000000005423494),('2024-07-19 08:40:00.000000',00000000000005432894),('2024-07-19 08:45:00.000000',00000000000005455084),('2024-07-19 08:50:00.000000',00000000000005501363),('2024-07-19 08:55:00.000000',00000000000005539553),('2024-07-19 09:00:00.000000',00000000000005541343),('2024-07-19 09:05:00.000000',00000000000005560343),('2024-07-19 09:10:00.000000',00000000000005568211),('2024-07-19 09:15:00.000000',00000000000005579111),('2024-07-19 09:20:00.000000',00000000000005597287),('2024-07-19 09:25:00.000000',00000000000005616634),('2024-07-19 09:30:00.000000',00000000000005625534),('2024-07-19 09:35:00.000000',00000000000005639434),('2024-07-19 09:40:00.000000',00000000000005654613),('2024-07-19 09:45:00.000000',00000000000005672303),('2024-07-19 09:50:00.000000',00000000000005675593),('2024-07-19 09:55:00.000000',00000000000005697483),('2024-07-19 10:00:00.000000',00000000000005714851),('2024-07-19 10:05:00.000000',00000000000005715841),('2024-07-19 10:10:00.000000',00000000000005741109),('2024-07-19 10:15:00.000000',00000000000005752988),('2024-07-19 10:20:00.000000',00000000000005777855),('2024-07-19 10:25:00.000000',00000000000005807755),('2024-07-19 10:30:00.000000',00000000000005811655),('2024-07-19 10:35:00.000000',00000000000005844132),('2024-07-19 10:40:00.000000',00000000000005861110),('2024-07-19 10:45:00.000000',00000000000005871400),('2024-07-19 10:50:00.000000',00000000000005943890),('2024-07-19 10:55:00.000000',00000000000005968626),('2024-07-19 11:00:00.000000',00000000000005971705),('2024-07-19 11:05:00.000000',00000000000005995195),('2024-07-19 11:10:00.000000',00000000000006026795),('2024-07-19 11:15:00.000000',00000000000006029325),('2024-07-19 11:20:00.000000',00000000000006029325),('2024-07-19 11:25:00.000000',00000000000006052975),('2024-07-19 11:30:00.000000',00000000000006053965),('2024-07-19 11:35:00.000000',00000000000006071745),('2024-07-19 11:40:00.000000',00000000000006082735),('2024-07-19 11:45:00.000000',00000000000006098633),('2024-07-19 11:50:00.000000',00000000000006116523),('2024-07-19 11:55:00.000000',00000000000006124123),('2024-07-19 12:00:00.000000',00000000000006153713),('2024-07-19 12:05:00.000000',00000000000006171603),('2024-07-19 12:10:00.000000',00000000000006185693),('2024-07-19 12:15:00.000000',00000000000006201391),('2024-07-19 12:20:00.000000',00000000000006244859),('2024-07-19 12:25:00.000000',00000000000006279629),('2024-07-19 12:30:00.000000',00000000000006270938),('2024-07-19 12:35:00.000000',00000000000006291638),('2024-07-19 12:40:00.000000',00000000000006305218),('2024-07-19 12:45:00.000000',00000000000006372598),('2024-07-19 12:50:00.000000',00000000000006383485),('2024-07-19 12:55:00.000000',00000000000006387785),('2024-07-19 13:00:00.000000',00000000000006410855),('2024-07-19 13:05:00.000000',00000000000006445495),('2024-07-19 13:10:00.000000',00000000000006473195),('2024-07-19 13:15:00.000000',00000000000006495975),('2024-07-19 13:20:00.000000',00000000000006565365),('2024-07-19 13:25:00.000000',00000000000006585743),('2024-07-19 13:30:00.000000',00000000000006640511),('2024-07-19 13:35:00.000000',00000000000006677981),('2024-07-19 13:40:00.000000',00000000000006743351),('2024-07-19 13:45:00.000000',00000000000006762051),('2024-07-19 13:50:00.000000',00000000000006784730),('2024-07-19 13:55:00.000000',00000000000006914820),('2024-07-19 14:00:00.000000',00000000000006935107),('2024-07-19 14:05:00.000000',00000000000006985542),('2024-07-19 14:10:00.000000',00000000000007174601),('2024-07-19 14:15:00.000000',00000000000007199991),('2024-07-19 14:20:00.000000',00000000000007209881),('2024-07-19 14:25:00.000000',00000000000007068561),('2024-07-19 14:30:00.000000',00000000000007079349),('2024-07-19 14:35:00.000000',00000000000007114118),('2024-07-19 14:40:00.000000',00000000000007136018),('2024-07-19 14:45:00.000000',00000000000007195353),('2024-07-19 14:50:00.000000',00000000000007225833),('2024-07-19 14:55:00.000000',00000000000007277503),('2024-07-19 15:00:00.000000',00000000000007333989),('2024-07-19 15:05:00.000000',00000000000007363827),('2024-07-19 15:10:00.000000',00000000000007388997),('2024-07-19 15:15:00.000000',00000000000007547477),('2024-07-19 15:20:00.000000',00000000000007568137),('2024-07-19 15:25:00.000000',00000000000007597915),('2024-07-19 15:30:00.000000',00000000000007613174),('2024-07-19 15:35:00.000000',00000000000007656891),('2024-07-19 15:40:00.000000',00000000000007688560),('2024-07-19 15:45:00.000000',00000000000007728976),('2024-07-19 15:50:00.000000',00000000000007774612),('2024-07-19 15:55:00.000000',00000000000007846844),('2024-07-19 16:00:00.000000',00000000000000000000),('2024-07-19 16:05:00.000000',00000000000000087249),('2024-07-19 16:10:00.000000',00000000000000164539),('2024-07-19 16:15:00.000000',00000000000000249295),('2024-07-19 16:20:00.000000',00000000000000278264),('2024-07-19 16:25:00.000000',00000000000000648091),('2024-07-19 16:30:00.000000',00000000000000695159),('2024-07-19 16:35:00.000000',00000000000000755149),('2024-07-19 16:40:00.000000',00000000000000831996),('2024-07-19 16:45:00.000000',00000000000000899823),('2024-07-19 16:50:00.000000',00000000000000949913),('2024-07-19 16:55:00.000000',00000000000001024993),('2024-07-19 17:00:00.000000',00000000000001099371),('2024-07-19 17:05:00.000000',00000000000001153450),('2024-07-19 17:10:00.000000',00000000000001186219),('2024-07-19 17:15:00.000000',00000000000001237794),('2024-07-19 17:20:00.000000',00000000000001276386),('2024-07-19 17:25:00.000000',00000000000001289056),('2024-07-19 17:30:00.000000',00000000000001302034),('2024-07-19 17:35:00.000000',00000000000001340014),('2024-07-19 17:40:00.000000',00000000000001428463),('2024-07-19 17:45:00.000000',00000000000001870407),('2024-07-19 17:50:00.000000',00000000000001902787),('2024-07-19 17:55:00.000000',00000000000001918577),('2024-07-19 18:00:00.000000',00000000000001981357),('2024-07-19 18:05:00.000000',00000000000002006037),('2024-07-19 18:10:00.000000',00000000000002055247),('2024-07-19 18:15:00.000000',00000000000002094827),('2024-07-19 18:20:00.000000',00000000000002161193),('2024-07-19 18:25:00.000000',00000000000002185784),('2024-07-19 18:30:00.000000',00000000000002201374),('2024-07-19 18:35:00.000000',00000000000002222034),('2024-07-19 18:40:00.000000',00000000000002233993),('2024-07-19 18:45:00.000000',00000000000002268263),('2024-07-19 18:50:00.000000',00000000000002296952),('2024-07-19 18:55:00.000000',00000000000002300952),('2024-07-19 19:00:00.000000',00000000000002325622),('2024-07-19 19:05:00.000000',00000000000002356399),('2024-07-19 19:10:00.000000',00000000000002388147),('2024-07-19 19:15:00.000000',00000000000002421034),('2024-07-19 19:20:00.000000',00000000000002503914),('2024-07-19 19:25:00.000000',00000000000002511414),('2024-07-19 19:30:00.000000',00000000000002521804),('2024-07-19 19:35:00.000000',00000000000002534694),('2024-07-19 19:40:00.000000',00000000000002538792),('2024-07-19 19:45:00.000000',00000000000002556582),('2024-07-19 19:50:00.000000',00000000000002562472),('2024-07-19 19:55:00.000000',00000000000002564962),('2024-07-19 20:00:00.000000',00000000000002574762),('2024-07-19 20:05:00.000000',00000000000002588541),('2024-07-19 20:10:00.000000',00000000000002598185),('2024-07-19 20:15:00.000000',00000000000002603175),('2024-07-19 20:20:00.000000',00000000000002618065),('2024-07-19 20:25:00.000000',00000000000002639776),('2024-07-19 20:30:00.000000',00000000000002646764),('2024-07-19 20:35:00.000000',00000000000002647753),('2024-07-19 20:40:00.000000',00000000000002651953),('2024-07-19 20:45:00.000000',00000000000002659833),('2024-07-19 20:50:00.000000',00000000000002663813),('2024-07-19 20:55:00.000000',00000000000002666793),('2024-07-19 21:00:00.000000',00000000000002659893),('2024-07-19 21:05:00.000000',00000000000002679673),('2024-07-19 21:10:00.000000',00000000000002697373),('2024-07-19 21:15:00.000000',00000000000002700343),('2024-07-19 21:20:00.000000',00000000000002704323),('2024-07-19 21:25:00.000000',00000000000002707323),('2024-07-19 21:30:00.000000',00000000000002723113),('2024-07-19 21:35:00.000000',00000000000002724113),('2024-07-19 21:40:00.000000',00000000000002724113),('2024-07-19 21:45:00.000000',00000000000002732013),('2024-07-19 21:50:00.000000',00000000000002746803),('2024-07-19 21:55:00.000000',00000000000003267793),('2024-07-19 22:00:00.000000',00000000000003279143),('2024-07-19 22:05:00.000000',00000000000003301083),('2024-07-19 22:10:00.000000',00000000000003315043),('2024-07-19 22:15:00.000000',00000000000003323923),('2024-07-19 22:20:00.000000',00000000000003324923),('2024-07-19 22:25:00.000000',00000000000003325923),('2024-07-19 22:30:00.000000',00000000000003329901),('2024-07-19 22:35:00.000000',00000000000003332891),('2024-07-19 22:40:00.000000',00000000000003340791),('2024-07-19 22:45:00.000000',00000000000003347681),('2024-07-19 22:50:00.000000',00000000000003355961),('2024-07-19 22:55:00.000000',00000000000003394651),('2024-07-19 23:00:00.000000',00000000000003405551),('2024-07-19 23:05:00.000000',00000000000003434321),('2024-07-19 23:10:00.000000',00000000000003433630),('2024-07-19 23:15:00.000000',00000000000003440720),('2024-07-19 23:20:00.000000',00000000000003458499),('2024-07-19 23:25:00.000000',00000000000003465399),('2024-07-19 23:30:00.000000',00000000000003475299),('2024-07-19 23:35:00.000000',00000000000003520699),('2024-07-19 23:40:00.000000',00000000000003532778),('2024-07-19 23:45:00.000000',00000000000003539268),('2024-07-19 23:50:00.000000',00000000000003544247),('2024-07-19 23:55:00.000000',00000000000003558227),('2024-07-20 00:00:00.000000',00000000000003558227),('2024-07-20 00:05:00.000000',00000000000003567117),('2024-07-20 00:10:00.000000',00000000000003585887),('2024-07-20 00:15:00.000000',00000000000003612177),('2024-07-20 00:20:00.000000',00000000000003626867),('2024-07-20 00:25:00.000000',00000000000003641544),('2024-07-20 00:30:00.000000',00000000000003663124),('2024-07-20 00:35:00.000000',00000000000003682994),('2024-07-20 00:40:00.000000',00000000000003710774),('2024-07-20 00:45:00.000000',00000000000003776154),('2024-07-20 00:50:00.000000',00000000000003787054),('2024-07-20 00:55:00.000000',00000000000003791014),('2024-07-20 01:00:00.000000',00000000000003810994),('2024-07-20 01:05:00.000000',00000000000003824474),('2024-07-20 01:10:00.000000',00000000000003849514),('2024-07-20 01:15:00.000000',00000000000003869294),('2024-07-20 01:20:00.000000',00000000000003893073),('2024-07-20 01:25:00.000000',00000000000003899033),('2024-07-20 01:30:00.000000',00000000000003914823),('2024-07-20 01:35:00.000000',00000000000003920923),('2024-07-20 01:40:00.000000',00000000000003944503),('2024-07-20 01:45:00.000000',00000000000003969093),('2024-07-20 01:50:00.000000',00000000000003981083),('2024-07-20 01:55:00.000000',00000000000003988873),('2024-07-20 02:00:00.000000',00000000000004005163),('2024-07-20 02:05:00.000000',00000000000004018763),('2024-07-20 02:10:00.000000',00000000000004041443),('2024-07-20 02:15:00.000000',00000000000004072423),('2024-07-20 02:20:00.000000',00000000000004092591),('2024-07-20 02:25:00.000000',00000000000004121181),('2024-07-20 02:30:00.000000',00000000000004136271),('2024-07-20 02:35:00.000000',00000000000004148461),('2024-07-20 02:40:00.000000',00000000000004157531),('2024-07-20 02:45:00.000000',00000000000004179750),('2024-07-20 02:50:00.000000',00000000000004194730),('2024-07-20 02:55:00.000000',00000000000004213028),('2024-07-20 03:00:00.000000',00000000000004228907),('2024-07-20 03:05:00.000000',00000000000004248656),('2024-07-20 03:10:00.000000',00000000000004265824),('2024-07-20 03:15:00.000000',00000000000004279104),('2024-07-20 03:20:00.000000',00000000000004311284),('2024-07-20 03:25:00.000000',00000000000004328163),('2024-07-20 03:30:00.000000',00000000000004347451),('2024-07-20 03:35:00.000000',00000000000004360341),('2024-07-20 03:40:00.000000',00000000000004429510),('2024-07-20 03:45:00.000000',00000000000004475400),('2024-07-20 03:50:00.000000',00000000000004507970),('2024-07-20 03:55:00.000000',00000000000004548798),('2024-07-20 04:00:00.000000',00000000000004595574),('2024-07-20 04:05:00.000000',00000000000004607454),('2024-07-20 04:10:00.000000',00000000000004610442),('2024-07-20 04:15:00.000000',00000000000004627840),('2024-07-20 04:20:00.000000',00000000000004640230),('2024-07-20 04:25:00.000000',00000000000004658509),('2024-07-20 04:30:00.000000',00000000000004687799),('2024-07-20 04:35:00.000000',00000000000004693789),('2024-07-20 04:40:00.000000',00000000000004698379),('2024-07-20 04:45:00.000000',00000000000004711058),('2024-07-20 04:50:00.000000',00000000000004715537),('2024-07-20 04:55:00.000000',00000000000004720113),('2024-07-20 05:00:00.000000',00000000000004764573),('2024-07-20 05:05:00.000000',00000000000004784443),('2024-07-20 05:10:00.000000',00000000000004819361),('2024-07-20 05:15:00.000000',00000000000004839141),('2024-07-20 05:20:00.000000',00000000000004864911),('2024-07-20 05:25:00.000000',00000000000004889101),('2024-07-20 05:30:00.000000',00000000000004973439),('2024-07-20 05:35:00.000000',00000000000005045757),('2024-07-20 05:40:00.000000',00000000000005102527),('2024-07-20 05:45:00.000000',00000000000005109325),('2024-07-20 05:50:00.000000',00000000000005161411),('2024-07-20 05:55:00.000000',00000000000005246491),('2024-07-20 06:00:00.000000',00000000000005262571),('2024-07-20 06:05:00.000000',00000000000005282531),('2024-07-20 06:10:00.000000',00000000000005309379),('2024-07-20 06:15:00.000000',00000000000005329307),('2024-07-20 06:20:00.000000',00000000000005352135),('2024-07-20 06:25:00.000000',00000000000005404584),('2024-07-20 06:30:00.000000',00000000000005469043),('2024-07-20 06:35:00.000000',00000000000005479012),('2024-07-20 06:40:00.000000',00000000000005500682),('2024-07-20 06:45:00.000000',00000000000005512911),('2024-07-20 06:50:00.000000',00000000000005524789),('2024-07-20 06:55:00.000000',00000000000005552259),('2024-07-20 07:00:00.000000',00000000000005607018),('2024-07-20 07:05:00.000000',00000000000005610586),('2024-07-20 07:10:00.000000',00000000000005648056),('2024-07-20 07:15:00.000000',00000000000005667834),('2024-07-20 07:20:00.000000',00000000000005662934),('2024-07-20 07:25:00.000000',00000000000005685700),('2024-07-20 07:30:00.000000',00000000000005699270),('2024-07-20 07:35:00.000000',00000000000005709149),('2024-07-20 07:40:00.000000',00000000000005740039),('2024-07-20 07:45:00.000000',00000000000005764188),('2024-07-20 07:50:00.000000',00000000000005773264),('2024-07-20 07:55:00.000000',00000000000005791843),('2024-07-20 08:00:00.000000',00000000000005816921),('2024-07-20 08:05:00.000000',00000000000005351760),('2024-07-20 08:10:00.000000',00000000000005412117),('2024-07-20 08:15:00.000000',00000000000005445504),('2024-07-20 08:20:00.000000',00000000000005505722),('2024-07-20 08:25:00.000000',00000000000005549381),('2024-07-20 08:30:00.000000',00000000000005579061),('2024-07-20 08:35:00.000000',00000000000005610620),('2024-07-20 08:40:00.000000',00000000000005614598),('2024-07-20 08:45:00.000000',00000000000005654888),('2024-07-20 08:50:00.000000',00000000000005683658),('2024-07-20 08:55:00.000000',00000000000005697448),('2024-07-20 09:00:00.000000',00000000000005709248),('2024-07-20 09:05:00.000000',00000000000005711238),('2024-07-20 09:10:00.000000',00000000000005764798),('2024-07-20 09:15:00.000000',00000000000005784448),('2024-07-20 09:20:00.000000',00000000000005839317),('2024-07-20 09:25:00.000000',00000000000005854186),('2024-07-20 09:30:00.000000',00000000000005872066),('2024-07-20 09:35:00.000000',00000000000005905854),('2024-07-20 09:40:00.000000',00000000000005964532),('2024-07-20 09:45:00.000000',00000000000005981402),('2024-07-20 09:50:00.000000',00000000000005998172),('2024-07-20 09:55:00.000000',00000000000006018752),('2024-07-20 10:00:00.000000',00000000000006131842),('2024-07-20 10:05:00.000000',00000000000006175322),('2024-07-20 10:10:00.000000',00000000000006192602),('2024-07-20 10:15:00.000000',00000000000006212471),('2024-07-20 10:20:00.000000',00000000000006241261),('2024-07-20 10:25:00.000000',00000000000006245450),('2024-07-20 10:30:00.000000',00000000000006267527),('2024-07-20 10:35:00.000000',00000000000006285927),('2024-07-20 10:40:00.000000',00000000000006302106),('2024-07-20 10:45:00.000000',00000000000006322986),('2024-07-20 10:50:00.000000',00000000000006331886),('2024-07-20 10:55:00.000000',00000000000006365386),('2024-07-20 11:00:00.000000',00000000000006381776),('2024-07-20 11:05:00.000000',00000000000006404966),('2024-07-20 11:10:00.000000',00000000000006412946),('2024-07-20 11:15:00.000000',00000000000006433526),('2024-07-20 11:20:00.000000',00000000000006478696),('2024-07-20 11:25:00.000000',00000000000006525986),('2024-07-20 11:30:00.000000',00000000000006537176),('2024-07-20 11:35:00.000000',00000000000006571916),('2024-07-20 11:40:00.000000',00000000000006584680),('2024-07-20 11:45:00.000000',00000000000006617370),('2024-07-20 11:50:00.000000',00000000000006636349),('2024-07-20 11:55:00.000000',00000000000006646238),('2024-07-20 12:00:00.000000',00000000000006698518),('2024-07-20 12:05:00.000000',00000000000006739814),('2024-07-20 12:10:00.000000',00000000000006787714),('2024-07-20 12:15:00.000000',00000000000006812414),('2024-07-20 12:20:00.000000',00000000000006823204),('2024-07-20 12:25:00.000000',00000000000006889963),('2024-07-20 12:30:00.000000',00000000000006918532),('2024-07-20 12:35:00.000000',00000000000007009022),('2024-07-20 12:40:00.000000',00000000000007053592),('2024-07-20 12:45:00.000000',00000000000007101562),('2024-07-20 12:50:00.000000',00000000000007125662),('2024-07-20 12:55:00.000000',00000000000007148842),('2024-07-20 13:00:00.000000',00000000000007174640),('2024-07-20 13:05:00.000000',00000000000007219128),('2024-07-20 13:10:00.000000',00000000000007230018),('2024-07-20 13:15:00.000000',00000000000007409677),('2024-07-20 13:20:00.000000',00000000000007422466),('2024-07-20 13:25:00.000000',00000000000007500646),('2024-07-20 13:30:00.000000',00000000000007526736),('2024-07-20 13:35:00.000000',00000000000007531296),('2024-07-20 13:40:00.000000',00000000000007573975),('2024-07-20 13:45:00.000000',00000000000007614275),('2024-07-20 13:50:00.000000',00000000000007660765),('2024-07-20 13:55:00.000000',00000000000007800005),('2024-07-20 14:00:00.000000',00000000000007852254),('2024-07-20 14:05:00.000000',00000000000007889220),('2024-07-20 14:10:00.000000',00000000000007946980),('2024-07-20 14:15:00.000000',00000000000007991660),('2024-07-20 14:20:00.000000',00000000000008044660),('2024-07-20 14:25:00.000000',00000000000008268260),('2024-07-20 14:30:00.000000',00000000000008309040),('2024-07-20 14:35:00.000000',00000000000008344530),('2024-07-20 14:40:00.000000',00000000000008378697),('2024-07-20 14:45:00.000000',00000000000008426653),('2024-07-20 14:50:00.000000',00000000000008462840),('2024-07-20 14:55:00.000000',00000000000008519618),('2024-07-20 15:00:00.000000',00000000000008593308),('2024-07-20 15:05:00.000000',00000000000008690888),('2024-07-20 15:10:00.000000',00000000000008760268),('2024-07-20 15:15:00.000000',00000000000008824827),('2024-07-20 15:20:00.000000',00000000000008849807),('2024-07-20 15:25:00.000000',00000000000008889776),('2024-07-20 15:30:00.000000',00000000000008968646),('2024-07-20 15:35:00.000000',00000000000009053694),('2024-07-20 15:40:00.000000',00000000000009111044),('2024-07-20 15:45:00.000000',00000000000009141484),('2024-07-20 15:50:00.000000',00000000000009202633),('2024-07-20 15:55:00.000000',00000000000009265123),('2024-07-20 16:00:00.000000',00000000000000000000),('2024-07-20 16:05:00.000000',00000000000000042469),('2024-07-20 16:10:00.000000',00000000000000106437),('2024-07-20 16:15:00.000000',00000000000000260104),('2024-07-20 16:20:00.000000',00000000000000320202),('2024-07-20 16:25:00.000000',00000000000000365102),('2024-07-20 16:30:00.000000',00000000000000427192),('2024-07-20 16:35:00.000000',00000000000000540167),('2024-07-20 16:40:00.000000',00000000000000783447),('2024-07-20 16:45:00.000000',00000000000000860216),('2024-07-20 16:50:00.000000',00000000000000892375),('2024-07-20 16:55:00.000000',00000000000000994653),('2024-07-20 17:00:00.000000',00000000000001037312),('2024-07-20 17:05:00.000000',00000000000001385402),('2024-07-20 17:10:00.000000',00000000000001441571),('2024-07-20 17:15:00.000000',00000000000001468988),('2024-07-20 17:20:00.000000',00000000000001488167),('2024-07-20 17:25:00.000000',00000000000001548222),('2024-07-20 17:30:00.000000',00000000000001604779),('2024-07-20 17:35:00.000000',00000000000001633656),('2024-07-20 17:40:00.000000',00000000000001726316),('2024-07-20 17:45:00.000000',00000000000001778443),('2024-07-20 17:50:00.000000',00000000000001816231),('2024-07-20 17:55:00.000000',00000000000001845991),('2024-07-20 18:00:00.000000',00000000000001876847),('2024-07-20 18:05:00.000000',00000000000001972083),('2024-07-20 18:10:00.000000',00000000000001997863),('2024-07-20 18:15:00.000000',00000000000002011763),('2024-07-20 18:20:00.000000',00000000000002020244),('2024-07-20 18:25:00.000000',00000000000002024443),('2024-07-20 18:30:00.000000',00000000000002053322),('2024-07-20 18:35:00.000000',00000000000002064022),('2024-07-20 18:40:00.000000',00000000000002089881),('2024-07-20 18:45:00.000000',00000000000002118871),('2024-07-20 18:50:00.000000',00000000000002119871),('2024-07-20 18:55:00.000000',00000000000002140661),('2024-07-20 19:00:00.000000',00000000000002153061),('2024-07-20 19:05:00.000000',00000000000002229704),('2024-07-20 19:10:00.000000',00000000000002243082),('2024-07-20 19:15:00.000000',00000000000002253472),('2024-07-20 19:20:00.000000',00000000000002274062),('2024-07-20 19:25:00.000000',00000000000002285551),('2024-07-20 19:30:00.000000',00000000000002292141),('2024-07-20 19:35:00.000000',00000000000002306930),('2024-07-20 19:40:00.000000',00000000000002314520),('2024-07-20 19:45:00.000000',00000000000002338488),('2024-07-20 19:50:00.000000',00000000000002359778),('2024-07-20 19:55:00.000000',00000000000002390558),('2024-07-20 20:00:00.000000',00000000000002404437),('2024-07-20 20:05:00.000000',00000000000002422927),('2024-07-20 20:10:00.000000',00000000000002450715),('2024-07-20 20:15:00.000000',00000000000002486405),('2024-07-20 20:20:00.000000',00000000000002501275),('2024-07-20 20:25:00.000000',00000000000002504075),('2024-07-20 20:30:00.000000',00000000000002505975),('2024-07-20 20:35:00.000000',00000000000002538965),('2024-07-20 20:40:00.000000',00000000000002535655),('2024-07-20 20:45:00.000000',00000000000002546555),('2024-07-20 20:50:00.000000',00000000000002563255),('2024-07-20 20:55:00.000000',00000000000002573545),('2024-07-20 21:00:00.000000',00000000000002590345),('2024-07-20 21:05:00.000000',00000000000002594245),('2024-07-20 21:10:00.000000',00000000000002598745),('2024-07-20 21:15:00.000000',00000000000002604133),('2024-07-20 21:20:00.000000',00000000000002609633),('2024-07-20 21:25:00.000000',00000000000002623523),('2024-07-20 21:30:00.000000',00000000000002630111),('2024-07-20 21:35:00.000000',00000000000002634091),('2024-07-20 21:40:00.000000',00000000000002658491),('2024-07-20 21:45:00.000000',00000000000002683170),('2024-07-20 21:50:00.000000',00000000000002697668),('2024-07-20 21:55:00.000000',00000000000002710568),('2024-07-20 22:00:00.000000',00000000000002713948),('2024-07-20 22:05:00.000000',00000000000002707048),('2024-07-20 22:10:00.000000',00000000000002722938),('2024-07-20 22:15:00.000000',00000000000002740738),('2024-07-20 22:20:00.000000',00000000000002755718),('2024-07-20 22:25:00.000000',00000000000002758718),('2024-07-20 22:30:00.000000',00000000000002760718),('2024-07-20 22:35:00.000000',00000000000002782008),('2024-07-20 22:40:00.000000',00000000000002788998),('2024-07-20 22:45:00.000000',00000000000002800387),('2024-07-20 22:50:00.000000',00000000000002808365),('2024-07-20 22:55:00.000000',00000000000002833054),('2024-07-20 23:00:00.000000',00000000000002846054),('2024-07-20 23:05:00.000000',00000000000002846054),('2024-07-20 23:10:00.000000',00000000000002854954),('2024-07-20 23:15:00.000000',00000000000002856954),('2024-07-20 23:20:00.000000',00000000000002871734),('2024-07-20 23:25:00.000000',00000000000002873334),('2024-07-20 23:30:00.000000',00000000000002873934),('2024-07-20 23:35:00.000000',00000000000002875934),('2024-07-20 23:40:00.000000',00000000000002895733),('2024-07-20 23:45:00.000000',00000000000002904633),('2024-07-20 23:50:00.000000',00000000000002900634),('2024-07-20 23:55:00.000000',00000000000002901624),('2024-07-21 00:00:00.000000',00000000000002905224),('2024-07-21 00:05:00.000000',00000000000002927103),('2024-07-21 00:10:00.000000',00000000000002934303),('2024-07-21 00:15:00.000000',00000000000002960103),('2024-07-21 00:20:00.000000',00000000000002996071),('2024-07-21 00:25:00.000000',00000000000002998060),('2024-07-21 00:30:00.000000',00000000000003012760),('2024-07-21 00:35:00.000000',00000000000003024549),('2024-07-21 00:40:00.000000',00000000000003049329),('2024-07-21 00:45:00.000000',00000000000003078179),('2024-07-21 00:50:00.000000',00000000000003093958),('2024-07-21 00:55:00.000000',00000000000003095947),('2024-07-21 01:00:00.000000',00000000000003126224),('2024-07-21 01:05:00.000000',00000000000003142024),('2024-07-21 01:10:00.000000',00000000000003153004),('2024-07-21 01:15:00.000000',00000000000003185193),('2024-07-21 01:20:00.000000',00000000000003213393),('2024-07-21 01:25:00.000000',00000000000003249171),('2024-07-21 01:30:00.000000',00000000000003246259),('2024-07-21 01:35:00.000000',00000000000003274617),('2024-07-21 01:40:00.000000',00000000000003311799),('2024-07-21 01:45:00.000000',00000000000003364579),('2024-07-21 01:50:00.000000',00000000000003397079),('2024-07-21 01:55:00.000000',00000000000003419869),('2024-07-21 02:00:00.000000',00000000000003433757),('2024-07-21 02:05:00.000000',00000000000003455557),('2024-07-21 02:10:00.000000',00000000000003468155),('2024-07-21 02:15:00.000000',00000000000003502224),('2024-07-21 02:20:00.000000',00000000000003512214),('2024-07-21 02:25:00.000000',00000000000003536084),('2024-07-21 02:30:00.000000',00000000000003561053),('2024-07-21 02:35:00.000000',00000000000003580242),('2024-07-21 02:40:00.000000',00000000000003601281),('2024-07-21 02:45:00.000000',00000000000003619060),('2024-07-21 02:50:00.000000',00000000000003639437),('2024-07-21 02:55:00.000000',00000000000003676787),('2024-07-21 03:00:00.000000',00000000000003706533),('2024-07-21 03:05:00.000000',00000000000003718223),('2024-07-21 03:10:00.000000',00000000000003723213),('2024-07-21 03:15:00.000000',00000000000003726202),('2024-07-21 03:20:00.000000',00000000000003747190),('2024-07-21 03:25:00.000000',00000000000003763890),('2024-07-21 03:30:00.000000',00000000000003794680),('2024-07-21 03:35:00.000000',00000000000003813382),('2024-07-21 03:40:00.000000',00000000000003826172),('2024-07-21 03:45:00.000000',00000000000003829761),('2024-07-21 03:50:00.000000',00000000000003861006),('2024-07-21 03:55:00.000000',00000000000003896253),('2024-07-21 04:00:00.000000',00000000000003919232),('2024-07-21 04:05:00.000000',00000000000003919632),('2024-07-21 04:10:00.000000',00000000000003947422),('2024-07-21 04:15:00.000000',00000000000003966222),('2024-07-21 04:20:00.000000',00000000000003977222),('2024-07-21 04:25:00.000000',00000000000004001391),('2024-07-21 04:30:00.000000',00000000000004041929),('2024-07-21 04:35:00.000000',00000000000004112608),('2024-07-21 04:40:00.000000',00000000000004182516),('2024-07-21 04:45:00.000000',00000000000004209095),('2024-07-21 04:50:00.000000',00000000000004229544),('2024-07-21 04:55:00.000000',00000000000004239433),('2024-07-21 05:00:00.000000',00000000000004271923),('2024-07-21 05:05:00.000000',00000000000004320313),('2024-07-21 05:10:00.000000',00000000000004371011),('2024-07-21 05:15:00.000000',00000000000004403791),('2024-07-21 05:20:00.000000',00000000000004431470),('2024-07-21 05:25:00.000000',00000000000004463039),('2024-07-21 05:30:00.000000',00000000000004486825),('2024-07-21 05:35:00.000000',00000000000004507903),('2024-07-21 05:40:00.000000',00000000000004555559),('2024-07-21 05:45:00.000000',00000000000004599129),('2024-07-21 05:50:00.000000',00000000000004620699),('2024-07-21 05:55:00.000000',00000000000004631269),('2024-07-21 06:00:00.000000',00000000000004689759),('2024-07-21 06:05:00.000000',00000000000004713518),('2024-07-21 06:10:00.000000',00000000000004712518),('2024-07-21 06:15:00.000000',00000000000004748108),('2024-07-21 06:20:00.000000',00000000000004760898),('2024-07-21 06:25:00.000000',00000000000004799668),('2024-07-21 06:30:00.000000',00000000000004870638),('2024-07-21 06:35:00.000000',00000000000004888598),('2024-07-21 06:40:00.000000',00000000000004902347),('2024-07-21 06:45:00.000000',00000000000004924997),('2024-07-21 06:50:00.000000',00000000000004947045),('2024-07-21 06:55:00.000000',00000000000004956815),('2024-07-21 07:00:00.000000',00000000000004965704),('2024-07-21 07:05:00.000000',00000000000004970684),('2024-07-21 07:10:00.000000',00000000000004993643),('2024-07-21 07:15:00.000000',00000000000005040410),('2024-07-21 07:20:00.000000',00000000000005062926),('2024-07-21 07:25:00.000000',00000000000005091887),('2024-07-21 07:30:00.000000',00000000000005111655),('2024-07-21 07:35:00.000000',00000000000005120524),('2024-07-21 07:40:00.000000',00000000000005130124),('2024-07-21 07:45:00.000000',00000000000005157873),('2024-07-21 07:50:00.000000',00000000000005191233),('2024-07-21 07:55:00.000000',00000000000005230152),('2024-07-21 08:00:00.000000',00000000000005276161),('2024-07-21 08:05:00.000000',00000000000005318610),('2024-07-21 08:10:00.000000',00000000000005347480),('2024-07-21 08:15:00.000000',00000000000005379650),('2024-07-21 08:20:00.000000',00000000000005425809),('2024-07-21 08:25:00.000000',00000000000005501778),('2024-07-21 08:30:00.000000',00000000000005502968),('2024-07-21 08:35:00.000000',00000000000005519947),('2024-07-21 08:40:00.000000',00000000000005530927),('2024-07-21 08:45:00.000000',00000000000005534907),('2024-07-21 08:50:00.000000',00000000000005545797),('2024-07-21 08:55:00.000000',00000000000005551577),('2024-07-21 09:00:00.000000',00000000000005592767),('2024-07-21 09:05:00.000000',00000000000005633147),('2024-07-21 09:10:00.000000',00000000000005637126),('2024-07-21 09:15:00.000000',00000000000005639226),('2024-07-21 09:20:00.000000',00000000000005669386),('2024-07-21 09:25:00.000000',00000000000005664675),('2024-07-21 09:30:00.000000',00000000000005676464),('2024-07-21 09:35:00.000000',00000000000005681754),('2024-07-21 09:40:00.000000',00000000000005691464),('2024-07-21 09:45:00.000000',00000000000005717402),('2024-07-21 09:50:00.000000',00000000000005747102),('2024-07-21 09:55:00.000000',00000000000005768482),('2024-07-21 10:00:00.000000',00000000000005776372),('2024-07-21 10:05:00.000000',00000000000005794641),('2024-07-21 10:10:00.000000',00000000000005799281),('2024-07-21 10:15:00.000000',00000000000005802381),('2024-07-21 10:20:00.000000',00000000000005804371),('2024-07-21 10:25:00.000000',00000000000005818241),('2024-07-21 10:30:00.000000',00000000000005831039),('2024-07-21 10:35:00.000000',00000000000005845219),('2024-07-21 10:40:00.000000',00000000000005853119),('2024-07-21 10:45:00.000000',00000000000005865209),('2024-07-21 10:50:00.000000',00000000000005880999),('2024-07-21 10:55:00.000000',00000000000005888899),('2024-07-21 11:00:00.000000',00000000000005907499),('2024-07-21 11:05:00.000000',00000000000005936175),('2024-07-21 11:10:00.000000',00000000000005945365),('2024-07-21 11:15:00.000000',00000000000005954254),('2024-07-21 11:20:00.000000',00000000000005974231),('2024-07-21 11:25:00.000000',00000000000005987920),('2024-07-21 11:30:00.000000',00000000000005987920),('2024-07-21 11:35:00.000000',00000000000006020507),('2024-07-21 11:40:00.000000',00000000000006086697),('2024-07-21 11:45:00.000000',00000000000006112586),('2024-07-21 11:50:00.000000',00000000000006127086),('2024-07-21 11:55:00.000000',00000000000006142965),('2024-07-21 12:00:00.000000',00000000000006171535),('2024-07-21 12:05:00.000000',00000000000006230813),('2024-07-21 12:10:00.000000',00000000000006247603),('2024-07-21 12:15:00.000000',00000000000006311173),('2024-07-21 12:20:00.000000',00000000000006338063),('2024-07-21 12:25:00.000000',00000000000006358943),('2024-07-21 12:30:00.000000',00000000000006356931),('2024-07-21 12:35:00.000000',00000000000006372920),('2024-07-21 12:40:00.000000',00000000000006403846),('2024-07-21 12:45:00.000000',00000000000006411600),('2024-07-21 12:50:00.000000',00000000000006414898),('2024-07-21 12:55:00.000000',00000000000006423768),('2024-07-21 13:00:00.000000',00000000000006434647),('2024-07-21 13:05:00.000000',00000000000006442547),('2024-07-21 13:10:00.000000',00000000000006458237),('2024-07-21 13:15:00.000000',00000000000006463205),('2024-07-21 13:20:00.000000',00000000000006476094),('2024-07-21 13:25:00.000000',00000000000006492194),('2024-07-21 13:30:00.000000',00000000000006496674),('2024-07-21 13:35:00.000000',00000000000006551932),('2024-07-21 13:40:00.000000',00000000000006567001),('2024-07-21 13:45:00.000000',00000000000006572897),('2024-07-21 13:50:00.000000',00000000000006573887),('2024-07-21 13:55:00.000000',00000000000006611465),('2024-07-21 14:00:00.000000',00000000000006653024),('2024-07-21 14:05:00.000000',00000000000006662984),('2024-07-21 14:10:00.000000',00000000000006676984),('2024-07-21 14:15:00.000000',00000000000006673173),('2024-07-21 14:20:00.000000',00000000000006689073),('2024-07-21 14:25:00.000000',00000000000006712362),('2024-07-21 14:30:00.000000',00000000000006724672),('2024-07-21 14:35:00.000000',00000000000006754051),('2024-07-21 14:40:00.000000',00000000000006756051);
/*!40000 ALTER TABLE `vas_yoy_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `view_log`
--

DROP TABLE IF EXISTS `view_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `view_log` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int DEFAULT NULL,
  `model` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `model_id` int NOT NULL,
  `timestamp` timestamp(6) NULL DEFAULT NULL,
  `metadata` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci,
  `has_access` bit(1) DEFAULT NULL,
  `context` varchar(32) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'The context of the view, can be collection, question, or dashboard. Only for cards.',
  PRIMARY KEY (`id`),
  KEY `idx_view_log_user_id` (`user_id`),
  KEY `idx_view_log_model_id` (`model_id`),
  KEY `idx_view_log_timestamp` (`timestamp`),
  KEY `idx_view_log_entity_qualified_id` ((concat(`model`,_utf8mb4'_',`model_id`))),
  CONSTRAINT `fk_view_log_ref_user_id` FOREIGN KEY (`user_id`) REFERENCES `core_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `view_log`
--

LOCK TABLES `view_log` WRITE;
/*!40000 ALTER TABLE `view_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `view_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Final view structure for view `v_alerts`
--

/*!50001 DROP VIEW IF EXISTS `v_alerts`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_alerts` AS with `agg_recipients` as (select `pulse_channel_recipient`.`pulse_channel_id` AS `pulse_channel_id`,group_concat(`core_user`.`email` separator ',') AS `recipients` from (`pulse_channel_recipient` left join `core_user` on((`pulse_channel_recipient`.`user_id` = `core_user`.`id`))) group by `pulse_channel_recipient`.`pulse_channel_id`) select `pulse`.`id` AS `entity_id`,concat('pulse_',`pulse`.`id`) AS `entity_qualified_id`,`pulse`.`created_at` AS `created_at`,`pulse`.`updated_at` AS `updated_at`,`pulse`.`creator_id` AS `creator_id`,`pulse_card`.`card_id` AS `card_id`,concat('card_',`pulse_card`.`card_id`) AS `card_qualified_id`,`pulse`.`alert_condition` AS `alert_condition`,`pulse_channel`.`schedule_type` AS `schedule_type`,`pulse_channel`.`schedule_day` AS `schedule_day`,`pulse_channel`.`schedule_hour` AS `schedule_hour`,`pulse`.`archived` AS `archived`,`pulse_channel`.`channel_type` AS `recipient_type`,`agg_recipients`.`recipients` AS `recipients`,`pulse_channel`.`details` AS `recipient_external` from (((`pulse` left join `pulse_card` on((`pulse`.`id` = `pulse_card`.`pulse_id`))) left join `pulse_channel` on((`pulse`.`id` = `pulse_channel`.`pulse_id`))) left join `agg_recipients` on((`pulse_channel`.`id` = `agg_recipients`.`pulse_channel_id`))) where (`pulse`.`alert_condition` is not null) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_audit_log`
--

/*!50001 DROP VIEW IF EXISTS `v_audit_log`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_audit_log` AS select `audit_log`.`id` AS `id`,(case when (`audit_log`.`topic` = 'card-create') then 'card-create' when (`audit_log`.`topic` = 'card-delete') then 'card-delete' when (`audit_log`.`topic` = 'card-update') then 'card-update' when (`audit_log`.`topic` = 'pulse-create') then 'subscription-create' when (`audit_log`.`topic` = 'pulse-delete') then 'subscription-delete' else `audit_log`.`topic` end) AS `topic`,`audit_log`.`timestamp` AS `timestamp`,NULL AS `end_timestamp`,coalesce(`audit_log`.`user_id`,0) AS `user_id`,lower(`audit_log`.`model`) AS `entity_type`,`audit_log`.`model_id` AS `entity_id`,(case when (`audit_log`.`model` = 'Dataset') then concat('card_',`audit_log`.`model_id`) when (`audit_log`.`model_id` is null) then NULL else concat(lower(`audit_log`.`model`),'_',`audit_log`.`model_id`) end) AS `entity_qualified_id`,`audit_log`.`details` AS `details` from `audit_log` where (`audit_log`.`topic` not in ('card-read','card-query','dashboard-read','dashboard-query')) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_content`
--

/*!50001 DROP VIEW IF EXISTS `v_content`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_content` AS select `action`.`id` AS `entity_id`,concat('action_',`action`.`id`) AS `entity_qualified_id`,'action' AS `entity_type`,`action`.`created_at` AS `created_at`,`action`.`updated_at` AS `updated_at`,`action`.`creator_id` AS `creator_id`,`action`.`name` AS `name`,`action`.`description` AS `description`,NULL AS `collection_id`,`action`.`made_public_by_id` AS `made_public_by_user`,NULL AS `is_embedding_enabled`,`action`.`archived` AS `archived`,`action`.`type` AS `action_type`,`action`.`model_id` AS `action_model_id`,NULL AS `collection_is_official`,NULL AS `collection_is_personal`,NULL AS `question_viz_type`,NULL AS `question_database_id`,NULL AS `question_is_native`,NULL AS `event_timestamp` from `action` union select `collection`.`id` AS `entity_id`,concat('collection_',`collection`.`id`) AS `entity_qualified_id`,'collection' AS `entity_type`,`collection`.`created_at` AS `created_at`,NULL AS `updated_at`,NULL AS `creator_id`,`collection`.`name` AS `name`,`collection`.`description` AS `description`,NULL AS `collection_id`,NULL AS `made_public_by_user`,NULL AS `is_embedding_enabled`,`collection`.`archived` AS `archived`,NULL AS `action_type`,NULL AS `action_model_id`,(case when (`collection`.`authority_level` = 'official') then true else false end) AS `collection_is_official`,(case when (`collection`.`personal_owner_id` is not null) then true else false end) AS `collection_is_personal`,NULL AS `question_viz_type`,NULL AS `question_database_id`,NULL AS `question_is_native`,NULL AS `event_timestamp` from `collection` union select `report_card`.`id` AS `entity_id`,concat('card_',`report_card`.`id`) AS `entity_qualified_id`,`report_card`.`type` AS `entity_type`,`report_card`.`created_at` AS `created_at`,`report_card`.`updated_at` AS `updated_at`,`report_card`.`creator_id` AS `creator_id`,`report_card`.`name` AS `name`,`report_card`.`description` AS `description`,`report_card`.`collection_id` AS `collection_id`,`report_card`.`made_public_by_id` AS `made_public_by_user`,`report_card`.`enable_embedding` AS `is_embedding_enabled`,`report_card`.`archived` AS `archived`,NULL AS `action_type`,NULL AS `action_model_id`,NULL AS `collection_is_official`,NULL AS `collection_is_personal`,`report_card`.`display` AS `question_viz_type`,concat('database_',`report_card`.`database_id`) AS `question_database_id`,(case when (`report_card`.`query_type` = 'native') then true else false end) AS `question_is_native`,NULL AS `event_timestamp` from `report_card` union select `report_dashboard`.`id` AS `entity_id`,concat('dashboard_',`report_dashboard`.`id`) AS `entity_qualified_id`,'dashboard' AS `entity_type`,`report_dashboard`.`created_at` AS `created_at`,`report_dashboard`.`updated_at` AS `updated_at`,`report_dashboard`.`creator_id` AS `creator_id`,`report_dashboard`.`name` AS `name`,`report_dashboard`.`description` AS `description`,`report_dashboard`.`collection_id` AS `collection_id`,`report_dashboard`.`made_public_by_id` AS `made_public_by_user`,`report_dashboard`.`enable_embedding` AS `is_embedding_enabled`,`report_dashboard`.`archived` AS `archived`,NULL AS `action_type`,NULL AS `action_model_id`,NULL AS `collection_is_official`,NULL AS `collection_is_personal`,NULL AS `question_viz_type`,NULL AS `question_database_id`,NULL AS `question_is_native`,NULL AS `event_timestamp` from `report_dashboard` union select `event`.`id` AS `entity_id`,concat('event_',`event`.`id`) AS `entity_qualified_id`,'event' AS `entity_type`,`event`.`created_at` AS `created_at`,`event`.`updated_at` AS `updated_at`,`event`.`creator_id` AS `creator_id`,`event`.`name` AS `name`,`event`.`description` AS `description`,`timeline`.`collection_id` AS `collection_id`,NULL AS `made_public_by_user`,NULL AS `is_embedding_enabled`,`event`.`archived` AS `archived`,NULL AS `action_type`,NULL AS `action_model_id`,NULL AS `collection_is_official`,NULL AS `collection_is_personal`,NULL AS `question_viz_type`,NULL AS `question_database_id`,NULL AS `question_is_native`,`event`.`timestamp` AS `event_timestamp` from (`timeline_event` `event` left join `timeline` on((`event`.`timeline_id` = `timeline`.`id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_dashboardcard`
--

/*!50001 DROP VIEW IF EXISTS `v_dashboardcard`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_dashboardcard` AS select `report_dashboardcard`.`id` AS `entity_id`,concat('dashboardcard_',`report_dashboardcard`.`id`) AS `entity_qualified_id`,concat('dashboard_',`report_dashboardcard`.`dashboard_id`) AS `dashboard_qualified_id`,concat('dashboardtab_',`report_dashboardcard`.`dashboard_tab_id`) AS `dashboardtab_id`,concat('card_',`report_dashboardcard`.`card_id`) AS `card_qualified_id`,`report_dashboardcard`.`created_at` AS `created_at`,`report_dashboardcard`.`updated_at` AS `updated_at`,`report_dashboardcard`.`size_x` AS `size_x`,`report_dashboardcard`.`size_y` AS `size_y`,`report_dashboardcard`.`visualization_settings` AS `visualization_settings`,`report_dashboardcard`.`parameter_mappings` AS `parameter_mappings` from `report_dashboardcard` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_databases`
--

/*!50001 DROP VIEW IF EXISTS `v_databases`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_databases` AS select `metabase_database`.`id` AS `entity_id`,concat('database_',`metabase_database`.`id`) AS `entity_qualified_id`,`metabase_database`.`created_at` AS `created_at`,`metabase_database`.`updated_at` AS `updated_at`,`metabase_database`.`name` AS `name`,`metabase_database`.`description` AS `description`,`metabase_database`.`engine` AS `database_type`,`metabase_database`.`metadata_sync_schedule` AS `metadata_sync_schedule`,`metabase_database`.`cache_field_values_schedule` AS `cache_field_values_schedule`,`metabase_database`.`timezone` AS `timezone`,`metabase_database`.`is_on_demand` AS `is_on_demand`,`metabase_database`.`auto_run_queries` AS `auto_run_queries`,`metabase_database`.`cache_ttl` AS `cache_ttl`,`metabase_database`.`creator_id` AS `creator_id`,`metabase_database`.`dbms_version` AS `db_version` from `metabase_database` where (`metabase_database`.`id` <> 13371337) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_fields`
--

/*!50001 DROP VIEW IF EXISTS `v_fields`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_fields` AS select `metabase_field`.`id` AS `entity_id`,concat('field_',`metabase_field`.`id`) AS `entity_qualified_id`,`metabase_field`.`created_at` AS `created_at`,`metabase_field`.`updated_at` AS `updated_at`,`metabase_field`.`name` AS `name`,`metabase_field`.`display_name` AS `display_name`,`metabase_field`.`description` AS `description`,`metabase_field`.`base_type` AS `base_type`,`metabase_field`.`visibility_type` AS `visibility_type`,`metabase_field`.`fk_target_field_id` AS `fk_target_field_id`,`metabase_field`.`has_field_values` AS `has_field_values`,`metabase_field`.`active` AS `active`,`metabase_field`.`table_id` AS `table_id` from `metabase_field` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_group_members`
--

/*!50001 DROP VIEW IF EXISTS `v_group_members`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_group_members` AS select `permissions_group_membership`.`user_id` AS `user_id`,`permissions_group`.`id` AS `group_id`,`permissions_group`.`name` AS `group_name` from (`permissions_group_membership` left join `permissions_group` on((`permissions_group_membership`.`group_id` = `permissions_group`.`id`))) union select 0 AS `user_id`,0 AS `group_id`,'Anonymous users' AS `group_name` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_query_log`
--

/*!50001 DROP VIEW IF EXISTS `v_query_log`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_query_log` AS select `query_execution`.`id` AS `entity_id`,`query_execution`.`started_at` AS `started_at`,(cast(`query_execution`.`running_time` as double) / 1000) AS `running_time_seconds`,`query_execution`.`result_rows` AS `result_rows`,`query_execution`.`native` AS `is_native`,`query_execution`.`context` AS `query_source`,`query_execution`.`error` AS `error`,coalesce(`query_execution`.`executor_id`,0) AS `user_id`,`query_execution`.`card_id` AS `card_id`,concat('card_',`query_execution`.`card_id`) AS `card_qualified_id`,`query_execution`.`dashboard_id` AS `dashboard_id`,concat('dashboard_',`query_execution`.`dashboard_id`) AS `dashboard_qualified_id`,`query_execution`.`pulse_id` AS `pulse_id`,`query_execution`.`database_id` AS `database_id`,concat('database_',`query_execution`.`database_id`) AS `database_qualified_id`,`query_execution`.`cache_hit` AS `cache_hit`,`query_execution`.`action_id` AS `action_id`,concat('action_',`query_execution`.`action_id`) AS `action_qualified_id`,`query`.`query` AS `query` from (`query_execution` left join `query` on((`query_execution`.`hash` = `query`.`query_hash`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_subscriptions`
--

/*!50001 DROP VIEW IF EXISTS `v_subscriptions`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_subscriptions` AS with `agg_recipients` as (select `pulse_channel_recipient`.`pulse_channel_id` AS `pulse_channel_id`,group_concat(`core_user`.`email` separator ',') AS `recipients` from (`pulse_channel_recipient` left join `core_user` on((`pulse_channel_recipient`.`user_id` = `core_user`.`id`))) group by `pulse_channel_recipient`.`pulse_channel_id`) select `pulse`.`id` AS `entity_id`,concat('pulse_',`pulse`.`id`) AS `entity_qualified_id`,`pulse`.`created_at` AS `created_at`,`pulse`.`updated_at` AS `updated_at`,`pulse`.`creator_id` AS `creator_id`,`pulse`.`archived` AS `archived`,concat('dashboard_',`pulse`.`dashboard_id`) AS `dashboard_qualified_id`,`pulse_channel`.`schedule_type` AS `schedule_type`,`pulse_channel`.`schedule_day` AS `schedule_day`,`pulse_channel`.`schedule_hour` AS `schedule_hour`,`pulse_channel`.`channel_type` AS `recipient_type`,`agg_recipients`.`recipients` AS `recipients`,`pulse_channel`.`details` AS `recipient_external`,`pulse`.`parameters` AS `parameters` from ((`pulse` left join `pulse_channel` on((`pulse`.`id` = `pulse_channel`.`pulse_id`))) left join `agg_recipients` on((`pulse_channel`.`id` = `agg_recipients`.`pulse_channel_id`))) where (`pulse`.`alert_condition` is null) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_tables`
--

/*!50001 DROP VIEW IF EXISTS `v_tables`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_tables` AS select `metabase_table`.`id` AS `entity_id`,concat('table_',`metabase_table`.`id`) AS `entity_qualified_id`,`metabase_table`.`created_at` AS `created_at`,`metabase_table`.`updated_at` AS `updated_at`,`metabase_table`.`name` AS `name`,`metabase_table`.`display_name` AS `display_name`,`metabase_table`.`description` AS `description`,`metabase_table`.`active` AS `active`,`metabase_table`.`db_id` AS `database_id`,'schema' AS `schema`,`metabase_table`.`is_upload` AS `is_upload` from `metabase_table` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_tasks`
--

/*!50001 DROP VIEW IF EXISTS `v_tasks`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_tasks` AS select `task_history`.`id` AS `id`,`task_history`.`task` AS `task`,concat('database_',`task_history`.`db_id`) AS `database_qualified_id`,`task_history`.`started_at` AS `started_at`,`task_history`.`ended_at` AS `ended_at`,(cast(`task_history`.`duration` as double) / 1000) AS `duration_seconds`,`task_history`.`task_details` AS `details` from `task_history` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_users`
--

/*!50001 DROP VIEW IF EXISTS `v_users`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_users` AS select `core_user`.`id` AS `user_id`,concat('user_',`core_user`.`id`) AS `entity_qualified_id`,`core_user`.`type` AS `type`,(case when (`core_user`.`type` = 'api-key') then NULL else `core_user`.`email` end) AS `email`,`core_user`.`first_name` AS `first_name`,`core_user`.`last_name` AS `last_name`,concat(`core_user`.`first_name`,' ',`core_user`.`last_name`) AS `full_name`,`core_user`.`date_joined` AS `date_joined`,`core_user`.`last_login` AS `last_login`,`core_user`.`updated_at` AS `updated_at`,`core_user`.`is_superuser` AS `is_admin`,`core_user`.`is_active` AS `is_active`,`core_user`.`sso_source` AS `sso_source`,`core_user`.`locale` AS `locale` from `core_user` union select 0 AS `user_id`,'user_0' AS `entity_qualified_id`,'anonymous' AS `type`,NULL AS `email`,'External' AS `first_name`,'User' AS `last_name`,'External User' AS `full_name`,NULL AS `date_joined`,NULL AS `last_login`,NULL AS `updated_at`,false AS `is_admin`,NULL AS `is_active`,NULL AS `sso_source`,NULL AS `locale` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_view_log`
--

/*!50001 DROP VIEW IF EXISTS `v_view_log`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`metabase_bi`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `v_view_log` AS select `view_log`.`id` AS `id`,`view_log`.`timestamp` AS `timestamp`,coalesce(`view_log`.`user_id`,0) AS `user_id`,`view_log`.`model` AS `entity_type`,`view_log`.`model_id` AS `entity_id`,concat(`view_log`.`model`,'_',`view_log`.`model_id`) AS `entity_qualified_id` from `view_log` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2024-07-21 22:45:45
